def aaa_accounting_commands_default_start_stop_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.aaa_config.aaa.accounting.commands.defaultacc.start_stop', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.aaa_config.aaa.accounting.commands.defaultacc.start_stop', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.aaa_config.aaa.accounting.commands.defaultacc.start_stop', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.aaa_config.aaa.accounting.commands.defaultacc.start_stop', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def aaa_accounting_commands_default_start_stop_server_type_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.aaa_config.aaa.accounting.commands.defaultacc.start_stop', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.aaa_config.aaa.accounting.commands.defaultacc.start_stop', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.aaa_config.aaa.accounting.commands.defaultacc.start_stop', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.aaa_config.aaa.accounting.commands.defaultacc.start_stop', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'server-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def aaa_accounting_exec_default_start_stop_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.aaa_config.aaa.accounting.exec_.defaultacc.start_stop', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.aaa_config.aaa.accounting.exec_.defaultacc.start_stop', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.aaa_config.aaa.accounting.exec_.defaultacc.start_stop', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.aaa_config.aaa.accounting.exec_.defaultacc.start_stop', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def aaa_accounting_exec_default_start_stop_server_type_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.aaa_config.aaa.accounting.exec_.defaultacc.start_stop', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.aaa_config.aaa.accounting.exec_.defaultacc.start_stop', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.aaa_config.aaa.accounting.exec_.defaultacc.start_stop', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.aaa_config.aaa.accounting.exec_.defaultacc.start_stop', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'server-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def aaa_authentication_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.aaa_config.aaa.authentication', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.aaa_config.aaa.authentication', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.aaa_config.aaa.authentication', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.aaa_config.aaa.authentication', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def aaa_authentication_login_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.aaa_config.aaa.authentication.login', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.aaa_config.aaa.authentication.login', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.aaa_config.aaa.authentication.login', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.aaa_config.aaa.authentication.login', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'first, second'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def aaa_authentication_login_first_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.aaa_config.aaa.authentication.login', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.aaa_config.aaa.authentication.login', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.aaa_config.aaa.authentication.login', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.aaa_config.aaa.authentication.login', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'first'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def aaa_authentication_login_second_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.aaa_config.aaa.authentication.login', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.aaa_config.aaa.authentication.login', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.aaa_config.aaa.authentication.login', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.aaa_config.aaa.authentication.login', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'second'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def aaa_config_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.aaa_config', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.aaa_config', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.aaa_config', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.aaa_config', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def acl_mirror_source_delete(self, source=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type source: src_interface_type, src_interface_name, destination, dst_interface_type, dst_interface_name
    :param source: Keyword argument tuple.

    :type src_interface_type: unicode
    :param src_interface_type: **source** tuple argument.

        * enumeration restriction: ::

            ['ethernet']

    :type src_interface_name: unicode
    :param src_interface_name: **source** tuple argument.

        * pattern restriction: ::

            '((([0-9]|1[0-6])/([1-9]|[1-9][0-9])(:[1-4])?)|(['
            '1-9]|[1-9][0-9]|[1-9][0-9]{2}|[1-5][0-9]{3}|6[0-'
            '1][0-4]{2}))'

    :type destination: unicode
    :param destination: **source** tuple argument.

        * enumeration restriction: ::

            ['destination']

    :type dst_interface_type: unicode
    :param dst_interface_type: **source** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 'port-channel']

    :type dst_interface_name: unicode
    :param dst_interface_name: **source** tuple argument.

        * pattern restriction: ::

            '((([0-9]|1[0-6])/([1-9]|[1-9][0-9])(:[1-4])?)|(['
            '1-9]|[1-9][0-9]|[1-9][0-9]{2}|[1-5][0-9]{3}|6[0-'
            '1][0-4]{2}))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.acl_mirror.source', 'pybind.slxos.v16r_1_00b.brocade_ip_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'source', 'keyval': 'src_interface_type, src_interface_name, destination, dst_interface_type, dst_interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, source=source)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, source=source)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def acl_policy_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.acl_policy', 'pybind.slxos.v16r_1_00b.brocade_acl_policy', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def acl_policy_allow_conflicting_rules_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.acl_policy.global_acl_policy_conf_cmds', 'pybind.slxos.v16r_1_00b.brocade_acl_policy', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'allow-conflicting-rules'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def acl_policy_allow_duplicate_rules_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.acl_policy.global_acl_policy_conf_cmds', 'pybind.slxos.v16r_1_00b.brocade_acl_policy', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'allow-duplicate-rules'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def acl_policy_global_acl_policy_conf_cmds_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.acl_policy.global_acl_policy_conf_cmds', 'pybind.slxos.v16r_1_00b.brocade_acl_policy', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def acl_state_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.acl_state', 'pybind.slxos.v16r_1_00b.brocade_ssm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def acl_state_vxlan_acl_delete(self, vxlan_acl=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type vxlan_acl: overlay_acl_tr_name
    :param vxlan_acl: Keyword argument tuple.

    :type overlay_acl_tr_name: unicode
    :param overlay_acl_tr_name: **vxlan_acl** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.acl_state.vxlan_acl', 'pybind.slxos.v16r_1_00b.brocade_ssm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'vxlan_acl', 'keyval': 'overlay_acl_tr_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vxlan_acl=vxlan_acl)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vxlan_acl=vxlan_acl)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def acl_state_vxlan_acl_extended_data_delete(self, vxlan_acl=None, extended_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vxlan_acl: overlay_acl_tr_name
    :param vxlan_acl: Keyword argument tuple.

    :type overlay_acl_tr_name: unicode
    :param overlay_acl_tr_name: **vxlan_acl** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type extended_data: acl_name, seq_num
    :param extended_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.acl_state.vxlan_acl', u'vxlan_acl')]
    bindings_list = [('pybind.slxos.v16r_1_00b.acl_state.vxlan_acl.extended_data', 'pybind.slxos.v16r_1_00b.brocade_ssm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'overlay_acl_tr_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'extended_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vxlan_acl=vxlan_acl, extended_data=extended_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vxlan_acl=vxlan_acl, extended_data=extended_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def acl_state_vxlan_acl_extended_data_byte_count_delete(self, vxlan_acl=None, extended_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vxlan_acl: overlay_acl_tr_name
    :param vxlan_acl: Keyword argument tuple.

    :type overlay_acl_tr_name: unicode
    :param overlay_acl_tr_name: **vxlan_acl** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type extended_data: acl_name, seq_num
    :param extended_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.acl_state.vxlan_acl', u'vxlan_acl')]
    bindings_list = [('pybind.slxos.v16r_1_00b.acl_state.vxlan_acl.extended_data', 'pybind.slxos.v16r_1_00b.brocade_ssm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'overlay_acl_tr_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'extended_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'byte-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vxlan_acl=vxlan_acl, extended_data=extended_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vxlan_acl=vxlan_acl, extended_data=extended_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def acl_state_vxlan_acl_extended_data_count_delete(self, vxlan_acl=None, extended_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vxlan_acl: overlay_acl_tr_name
    :param vxlan_acl: Keyword argument tuple.

    :type overlay_acl_tr_name: unicode
    :param overlay_acl_tr_name: **vxlan_acl** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type extended_data: acl_name, seq_num
    :param extended_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.acl_state.vxlan_acl', u'vxlan_acl')]
    bindings_list = [('pybind.slxos.v16r_1_00b.acl_state.vxlan_acl.extended_data', 'pybind.slxos.v16r_1_00b.brocade_ssm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'overlay_acl_tr_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'extended_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vxlan_acl=vxlan_acl, extended_data=extended_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vxlan_acl=vxlan_acl, extended_data=extended_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def acl_state_vxlan_acl_extended_data_dst_ip_delete(self, vxlan_acl=None, extended_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vxlan_acl: overlay_acl_tr_name
    :param vxlan_acl: Keyword argument tuple.

    :type overlay_acl_tr_name: unicode
    :param overlay_acl_tr_name: **vxlan_acl** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type extended_data: acl_name, seq_num
    :param extended_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.acl_state.vxlan_acl', u'vxlan_acl')]
    bindings_list = [('pybind.slxos.v16r_1_00b.acl_state.vxlan_acl.extended_data', 'pybind.slxos.v16r_1_00b.brocade_ssm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'overlay_acl_tr_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'extended_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dst-ip'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vxlan_acl=vxlan_acl, extended_data=extended_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vxlan_acl=vxlan_acl, extended_data=extended_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def acl_state_vxlan_acl_extended_data_dst_ip_mask_delete(self, vxlan_acl=None, extended_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vxlan_acl: overlay_acl_tr_name
    :param vxlan_acl: Keyword argument tuple.

    :type overlay_acl_tr_name: unicode
    :param overlay_acl_tr_name: **vxlan_acl** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type extended_data: acl_name, seq_num
    :param extended_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.acl_state.vxlan_acl', u'vxlan_acl')]
    bindings_list = [('pybind.slxos.v16r_1_00b.acl_state.vxlan_acl.extended_data', 'pybind.slxos.v16r_1_00b.brocade_ssm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'overlay_acl_tr_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'extended_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dst-ip-mask'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vxlan_acl=vxlan_acl, extended_data=extended_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vxlan_acl=vxlan_acl, extended_data=extended_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def acl_state_vxlan_acl_extended_data_dst_port_delete(self, vxlan_acl=None, extended_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vxlan_acl: overlay_acl_tr_name
    :param vxlan_acl: Keyword argument tuple.

    :type overlay_acl_tr_name: unicode
    :param overlay_acl_tr_name: **vxlan_acl** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type extended_data: acl_name, seq_num
    :param extended_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.acl_state.vxlan_acl', u'vxlan_acl')]
    bindings_list = [('pybind.slxos.v16r_1_00b.acl_state.vxlan_acl.extended_data', 'pybind.slxos.v16r_1_00b.brocade_ssm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'overlay_acl_tr_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'extended_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dst-port'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vxlan_acl=vxlan_acl, extended_data=extended_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vxlan_acl=vxlan_acl, extended_data=extended_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def acl_state_vxlan_acl_extended_data_dst_vtep_ip_delete(self, vxlan_acl=None, extended_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vxlan_acl: overlay_acl_tr_name
    :param vxlan_acl: Keyword argument tuple.

    :type overlay_acl_tr_name: unicode
    :param overlay_acl_tr_name: **vxlan_acl** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type extended_data: acl_name, seq_num
    :param extended_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.acl_state.vxlan_acl', u'vxlan_acl')]
    bindings_list = [('pybind.slxos.v16r_1_00b.acl_state.vxlan_acl.extended_data', 'pybind.slxos.v16r_1_00b.brocade_ssm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'overlay_acl_tr_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'extended_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dst-vtep-ip'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vxlan_acl=vxlan_acl, extended_data=extended_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vxlan_acl=vxlan_acl, extended_data=extended_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def acl_state_vxlan_acl_extended_data_mirror_interface_delete(self, vxlan_acl=None, extended_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vxlan_acl: overlay_acl_tr_name
    :param vxlan_acl: Keyword argument tuple.

    :type overlay_acl_tr_name: unicode
    :param overlay_acl_tr_name: **vxlan_acl** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type extended_data: acl_name, seq_num
    :param extended_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.acl_state.vxlan_acl', u'vxlan_acl')]
    bindings_list = [('pybind.slxos.v16r_1_00b.acl_state.vxlan_acl.extended_data', 'pybind.slxos.v16r_1_00b.brocade_ssm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'overlay_acl_tr_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'extended_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mirror-interface'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vxlan_acl=vxlan_acl, extended_data=extended_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vxlan_acl=vxlan_acl, extended_data=extended_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def acl_state_vxlan_acl_extended_data_native_tag_delete(self, vxlan_acl=None, extended_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vxlan_acl: overlay_acl_tr_name
    :param vxlan_acl: Keyword argument tuple.

    :type overlay_acl_tr_name: unicode
    :param overlay_acl_tr_name: **vxlan_acl** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type extended_data: acl_name, seq_num
    :param extended_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.acl_state.vxlan_acl', u'vxlan_acl')]
    bindings_list = [('pybind.slxos.v16r_1_00b.acl_state.vxlan_acl.extended_data', 'pybind.slxos.v16r_1_00b.brocade_ssm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'overlay_acl_tr_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'extended_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'native-tag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vxlan_acl=vxlan_acl, extended_data=extended_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vxlan_acl=vxlan_acl, extended_data=extended_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def acl_state_vxlan_acl_extended_data_permit_deny_delete(self, vxlan_acl=None, extended_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vxlan_acl: overlay_acl_tr_name
    :param vxlan_acl: Keyword argument tuple.

    :type overlay_acl_tr_name: unicode
    :param overlay_acl_tr_name: **vxlan_acl** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type extended_data: acl_name, seq_num
    :param extended_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.acl_state.vxlan_acl', u'vxlan_acl')]
    bindings_list = [('pybind.slxos.v16r_1_00b.acl_state.vxlan_acl.extended_data', 'pybind.slxos.v16r_1_00b.brocade_ssm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'overlay_acl_tr_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'extended_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'permit-deny'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vxlan_acl=vxlan_acl, extended_data=extended_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vxlan_acl=vxlan_acl, extended_data=extended_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def acl_state_vxlan_acl_extended_data_redir_interface_delete(self, vxlan_acl=None, extended_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vxlan_acl: overlay_acl_tr_name
    :param vxlan_acl: Keyword argument tuple.

    :type overlay_acl_tr_name: unicode
    :param overlay_acl_tr_name: **vxlan_acl** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type extended_data: acl_name, seq_num
    :param extended_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.acl_state.vxlan_acl', u'vxlan_acl')]
    bindings_list = [('pybind.slxos.v16r_1_00b.acl_state.vxlan_acl.extended_data', 'pybind.slxos.v16r_1_00b.brocade_ssm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'overlay_acl_tr_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'extended_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redir-interface'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vxlan_acl=vxlan_acl, extended_data=extended_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vxlan_acl=vxlan_acl, extended_data=extended_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def acl_state_vxlan_acl_extended_data_sflow_delete(self, vxlan_acl=None, extended_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vxlan_acl: overlay_acl_tr_name
    :param vxlan_acl: Keyword argument tuple.

    :type overlay_acl_tr_name: unicode
    :param overlay_acl_tr_name: **vxlan_acl** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type extended_data: acl_name, seq_num
    :param extended_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.acl_state.vxlan_acl', u'vxlan_acl')]
    bindings_list = [('pybind.slxos.v16r_1_00b.acl_state.vxlan_acl.extended_data', 'pybind.slxos.v16r_1_00b.brocade_ssm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'overlay_acl_tr_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'extended_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'sflow'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vxlan_acl=vxlan_acl, extended_data=extended_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vxlan_acl=vxlan_acl, extended_data=extended_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def acl_state_vxlan_acl_extended_data_src_ip_delete(self, vxlan_acl=None, extended_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vxlan_acl: overlay_acl_tr_name
    :param vxlan_acl: Keyword argument tuple.

    :type overlay_acl_tr_name: unicode
    :param overlay_acl_tr_name: **vxlan_acl** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type extended_data: acl_name, seq_num
    :param extended_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.acl_state.vxlan_acl', u'vxlan_acl')]
    bindings_list = [('pybind.slxos.v16r_1_00b.acl_state.vxlan_acl.extended_data', 'pybind.slxos.v16r_1_00b.brocade_ssm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'overlay_acl_tr_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'extended_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'src-ip'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vxlan_acl=vxlan_acl, extended_data=extended_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vxlan_acl=vxlan_acl, extended_data=extended_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def acl_state_vxlan_acl_extended_data_src_ip_mask_delete(self, vxlan_acl=None, extended_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vxlan_acl: overlay_acl_tr_name
    :param vxlan_acl: Keyword argument tuple.

    :type overlay_acl_tr_name: unicode
    :param overlay_acl_tr_name: **vxlan_acl** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type extended_data: acl_name, seq_num
    :param extended_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.acl_state.vxlan_acl', u'vxlan_acl')]
    bindings_list = [('pybind.slxos.v16r_1_00b.acl_state.vxlan_acl.extended_data', 'pybind.slxos.v16r_1_00b.brocade_ssm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'overlay_acl_tr_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'extended_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'src-ip-mask'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vxlan_acl=vxlan_acl, extended_data=extended_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vxlan_acl=vxlan_acl, extended_data=extended_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def acl_state_vxlan_acl_extended_data_src_port_delete(self, vxlan_acl=None, extended_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vxlan_acl: overlay_acl_tr_name
    :param vxlan_acl: Keyword argument tuple.

    :type overlay_acl_tr_name: unicode
    :param overlay_acl_tr_name: **vxlan_acl** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type extended_data: acl_name, seq_num
    :param extended_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.acl_state.vxlan_acl', u'vxlan_acl')]
    bindings_list = [('pybind.slxos.v16r_1_00b.acl_state.vxlan_acl.extended_data', 'pybind.slxos.v16r_1_00b.brocade_ssm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'overlay_acl_tr_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'extended_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'src-port'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vxlan_acl=vxlan_acl, extended_data=extended_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vxlan_acl=vxlan_acl, extended_data=extended_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def acl_state_vxlan_acl_extended_data_src_vtep_ip_delete(self, vxlan_acl=None, extended_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vxlan_acl: overlay_acl_tr_name
    :param vxlan_acl: Keyword argument tuple.

    :type overlay_acl_tr_name: unicode
    :param overlay_acl_tr_name: **vxlan_acl** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type extended_data: acl_name, seq_num
    :param extended_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.acl_state.vxlan_acl', u'vxlan_acl')]
    bindings_list = [('pybind.slxos.v16r_1_00b.acl_state.vxlan_acl.extended_data', 'pybind.slxos.v16r_1_00b.brocade_ssm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'overlay_acl_tr_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'extended_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'src-vtep-ip'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vxlan_acl=vxlan_acl, extended_data=extended_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vxlan_acl=vxlan_acl, extended_data=extended_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def acl_state_vxlan_acl_extended_data_transit_name_delete(self, vxlan_acl=None, extended_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vxlan_acl: overlay_acl_tr_name
    :param vxlan_acl: Keyword argument tuple.

    :type overlay_acl_tr_name: unicode
    :param overlay_acl_tr_name: **vxlan_acl** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type extended_data: acl_name, seq_num
    :param extended_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.acl_state.vxlan_acl', u'vxlan_acl')]
    bindings_list = [('pybind.slxos.v16r_1_00b.acl_state.vxlan_acl.extended_data', 'pybind.slxos.v16r_1_00b.brocade_ssm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'overlay_acl_tr_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'extended_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'transit-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vxlan_acl=vxlan_acl, extended_data=extended_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vxlan_acl=vxlan_acl, extended_data=extended_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def acl_state_vxlan_acl_extended_data_vni_delete(self, vxlan_acl=None, extended_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vxlan_acl: overlay_acl_tr_name
    :param vxlan_acl: Keyword argument tuple.

    :type overlay_acl_tr_name: unicode
    :param overlay_acl_tr_name: **vxlan_acl** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type extended_data: acl_name, seq_num
    :param extended_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.acl_state.vxlan_acl', u'vxlan_acl')]
    bindings_list = [('pybind.slxos.v16r_1_00b.acl_state.vxlan_acl.extended_data', 'pybind.slxos.v16r_1_00b.brocade_ssm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'overlay_acl_tr_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'extended_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vni'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vxlan_acl=vxlan_acl, extended_data=extended_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vxlan_acl=vxlan_acl, extended_data=extended_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def acl_state_vxlan_acl_extended_data_vni_mask_delete(self, vxlan_acl=None, extended_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vxlan_acl: overlay_acl_tr_name
    :param vxlan_acl: Keyword argument tuple.

    :type overlay_acl_tr_name: unicode
    :param overlay_acl_tr_name: **vxlan_acl** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type extended_data: acl_name, seq_num
    :param extended_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.acl_state.vxlan_acl', u'vxlan_acl')]
    bindings_list = [('pybind.slxos.v16r_1_00b.acl_state.vxlan_acl.extended_data', 'pybind.slxos.v16r_1_00b.brocade_ssm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'overlay_acl_tr_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'extended_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vni-mask'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vxlan_acl=vxlan_acl, extended_data=extended_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vxlan_acl=vxlan_acl, extended_data=extended_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def adj_neighbor_entries_state_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.adj_neighbor_entries_state', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def adj_neighbor_entries_state_adj_neighbor_delete(self, adj_neighbor=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type adj_neighbor: neighbor_id
    :param adj_neighbor: Keyword argument tuple.

    :type neighbor_id: unicode
    :param neighbor_id: **adj_neighbor** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.adj_neighbor_entries_state.adj_neighbor', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'adj_neighbor', 'keyval': 'neighbor_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, adj_neighbor=adj_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, adj_neighbor=adj_neighbor)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def adj_neighbor_entries_state_adj_neighbor_adj_3way_state_delete(self, adj_neighbor=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type adj_neighbor: neighbor_id
    :param adj_neighbor: Keyword argument tuple.

    :type neighbor_id: unicode
    :param neighbor_id: **adj_neighbor** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.adj_neighbor_entries_state.adj_neighbor', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'adj_neighbor', 'keyval': 'neighbor_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'adj-3way-state'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, adj_neighbor=adj_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, adj_neighbor=adj_neighbor)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def adj_neighbor_entries_state_adj_neighbor_adj_address_delete(self, adj_neighbor=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type adj_neighbor: neighbor_id
    :param adj_neighbor: Keyword argument tuple.

    :type neighbor_id: unicode
    :param neighbor_id: **adj_neighbor** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.adj_neighbor_entries_state.adj_neighbor', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'adj_neighbor', 'keyval': 'neighbor_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'adj-address'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, adj_neighbor=adj_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, adj_neighbor=adj_neighbor)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def adj_neighbor_entries_state_adj_neighbor_adj_area_delete(self, adj_neighbor=None, adj_area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type adj_neighbor: neighbor_id
    :param adj_neighbor: Keyword argument tuple.

    :type neighbor_id: unicode
    :param neighbor_id: **adj_neighbor** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type adj_area: adj_asi_area_name
    :param adj_area: Keyword argument tuple.

    :type adj_asi_area_name: unicode
    :param adj_asi_area_name: **adj_area** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.adj_neighbor_entries_state.adj_neighbor', u'adj_neighbor')]
    bindings_list = [('pybind.slxos.v16r_1_00b.adj_neighbor_entries_state.adj_neighbor.adj_area', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'neighbor_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'adj_area', 'keyval': 'adj_asi_area_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, adj_neighbor=adj_neighbor, adj_area=adj_area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, adj_neighbor=adj_neighbor, adj_area=adj_area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def adj_neighbor_entries_state_adj_neighbor_adj_bfd_holdover_time_delete(self, adj_neighbor=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type adj_neighbor: neighbor_id
    :param adj_neighbor: Keyword argument tuple.

    :type neighbor_id: unicode
    :param neighbor_id: **adj_neighbor** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.adj_neighbor_entries_state.adj_neighbor', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'adj_neighbor', 'keyval': 'neighbor_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'adj-bfd-holdover-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, adj_neighbor=adj_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, adj_neighbor=adj_neighbor)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def adj_neighbor_entries_state_adj_neighbor_adj_holding_time_delete(self, adj_neighbor=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type adj_neighbor: neighbor_id
    :param adj_neighbor: Keyword argument tuple.

    :type neighbor_id: unicode
    :param neighbor_id: **adj_neighbor** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.adj_neighbor_entries_state.adj_neighbor', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'adj_neighbor', 'keyval': 'neighbor_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'adj-holding-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, adj_neighbor=adj_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, adj_neighbor=adj_neighbor)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def adj_neighbor_entries_state_adj_neighbor_adj_ip6_address_delete(self, adj_neighbor=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type adj_neighbor: neighbor_id
    :param adj_neighbor: Keyword argument tuple.

    :type neighbor_id: unicode
    :param neighbor_id: **adj_neighbor** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.adj_neighbor_entries_state.adj_neighbor', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'adj_neighbor', 'keyval': 'neighbor_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'adj-ip6-address'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, adj_neighbor=adj_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, adj_neighbor=adj_neighbor)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def adj_neighbor_entries_state_adj_neighbor_adj_lan_id_delete(self, adj_neighbor=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type adj_neighbor: neighbor_id
    :param adj_neighbor: Keyword argument tuple.

    :type neighbor_id: unicode
    :param neighbor_id: **adj_neighbor** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.adj_neighbor_entries_state.adj_neighbor', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'adj_neighbor', 'keyval': 'neighbor_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'adj-lan-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, adj_neighbor=adj_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, adj_neighbor=adj_neighbor)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def adj_neighbor_entries_state_adj_neighbor_adj_lan_name_delete(self, adj_neighbor=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type adj_neighbor: neighbor_id
    :param adj_neighbor: Keyword argument tuple.

    :type neighbor_id: unicode
    :param neighbor_id: **adj_neighbor** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.adj_neighbor_entries_state.adj_neighbor', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'adj_neighbor', 'keyval': 'neighbor_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'adj-lan-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, adj_neighbor=adj_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, adj_neighbor=adj_neighbor)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def adj_neighbor_entries_state_adj_neighbor_adj_mtprot_delete(self, adj_neighbor=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type adj_neighbor: neighbor_id
    :param adj_neighbor: Keyword argument tuple.

    :type neighbor_id: unicode
    :param neighbor_id: **adj_neighbor** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.adj_neighbor_entries_state.adj_neighbor', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'adj_neighbor', 'keyval': 'neighbor_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'adj-mtprot'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, adj_neighbor=adj_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, adj_neighbor=adj_neighbor)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def adj_neighbor_entries_state_adj_neighbor_adj_num_adds_delete(self, adj_neighbor=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type adj_neighbor: neighbor_id
    :param adj_neighbor: Keyword argument tuple.

    :type neighbor_id: unicode
    :param neighbor_id: **adj_neighbor** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.adj_neighbor_entries_state.adj_neighbor', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'adj_neighbor', 'keyval': 'neighbor_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'adj-num-adds'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, adj_neighbor=adj_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, adj_neighbor=adj_neighbor)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def adj_neighbor_entries_state_adj_neighbor_adj_p2p_circ_id_delete(self, adj_neighbor=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type adj_neighbor: neighbor_id
    :param adj_neighbor: Keyword argument tuple.

    :type neighbor_id: unicode
    :param neighbor_id: **adj_neighbor** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.adj_neighbor_entries_state.adj_neighbor', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'adj_neighbor', 'keyval': 'neighbor_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'adj-p2p-circ-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, adj_neighbor=adj_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, adj_neighbor=adj_neighbor)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def adj_neighbor_entries_state_adj_neighbor_adj_priority_delete(self, adj_neighbor=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type adj_neighbor: neighbor_id
    :param adj_neighbor: Keyword argument tuple.

    :type neighbor_id: unicode
    :param neighbor_id: **adj_neighbor** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.adj_neighbor_entries_state.adj_neighbor', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'adj_neighbor', 'keyval': 'neighbor_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'adj-priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, adj_neighbor=adj_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, adj_neighbor=adj_neighbor)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def adj_neighbor_entries_state_adj_neighbor_adj_prot_delete(self, adj_neighbor=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type adj_neighbor: neighbor_id
    :param adj_neighbor: Keyword argument tuple.

    :type neighbor_id: unicode
    :param neighbor_id: **adj_neighbor** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.adj_neighbor_entries_state.adj_neighbor', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'adj_neighbor', 'keyval': 'neighbor_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'adj-prot'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, adj_neighbor=adj_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, adj_neighbor=adj_neighbor)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def adj_neighbor_entries_state_adj_neighbor_adj_state_delete(self, adj_neighbor=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type adj_neighbor: neighbor_id
    :param adj_neighbor: Keyword argument tuple.

    :type neighbor_id: unicode
    :param neighbor_id: **adj_neighbor** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.adj_neighbor_entries_state.adj_neighbor', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'adj_neighbor', 'keyval': 'neighbor_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'adj-state'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, adj_neighbor=adj_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, adj_neighbor=adj_neighbor)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def adj_neighbor_entries_state_adj_neighbor_adj_state_change_time_delete(self, adj_neighbor=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type adj_neighbor: neighbor_id
    :param adj_neighbor: Keyword argument tuple.

    :type neighbor_id: unicode
    :param neighbor_id: **adj_neighbor** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.adj_neighbor_entries_state.adj_neighbor', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'adj_neighbor', 'keyval': 'neighbor_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'adj-state-change-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, adj_neighbor=adj_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, adj_neighbor=adj_neighbor)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def adj_neighbor_entries_state_adj_neighbor_adj_type_delete(self, adj_neighbor=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type adj_neighbor: neighbor_id
    :param adj_neighbor: Keyword argument tuple.

    :type neighbor_id: unicode
    :param neighbor_id: **adj_neighbor** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.adj_neighbor_entries_state.adj_neighbor', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'adj_neighbor', 'keyval': 'neighbor_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'adj-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, adj_neighbor=adj_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, adj_neighbor=adj_neighbor)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def adj_neighbor_entries_state_adj_neighbor_adj_use_delete(self, adj_neighbor=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type adj_neighbor: neighbor_id
    :param adj_neighbor: Keyword argument tuple.

    :type neighbor_id: unicode
    :param neighbor_id: **adj_neighbor** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.adj_neighbor_entries_state.adj_neighbor', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'adj_neighbor', 'keyval': 'neighbor_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'adj-use'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, adj_neighbor=adj_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, adj_neighbor=adj_neighbor)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def adj_neighbor_entries_state_adj_neighbor_bfd_holdover_interval_delete(self, adj_neighbor=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type adj_neighbor: neighbor_id
    :param adj_neighbor: Keyword argument tuple.

    :type neighbor_id: unicode
    :param neighbor_id: **adj_neighbor** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.adj_neighbor_entries_state.adj_neighbor', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'adj_neighbor', 'keyval': 'neighbor_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bfd-holdover-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, adj_neighbor=adj_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, adj_neighbor=adj_neighbor)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def adj_neighbor_entries_state_adj_neighbor_bfd_state_delete(self, adj_neighbor=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type adj_neighbor: neighbor_id
    :param adj_neighbor: Keyword argument tuple.

    :type neighbor_id: unicode
    :param neighbor_id: **adj_neighbor** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.adj_neighbor_entries_state.adj_neighbor', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'adj_neighbor', 'keyval': 'neighbor_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bfd-state'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, adj_neighbor=adj_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, adj_neighbor=adj_neighbor)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def adj_neighbor_entries_state_adj_neighbor_circuit_intf_name_delete(self, adj_neighbor=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type adj_neighbor: neighbor_id
    :param adj_neighbor: Keyword argument tuple.

    :type neighbor_id: unicode
    :param neighbor_id: **adj_neighbor** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.adj_neighbor_entries_state.adj_neighbor', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'adj_neighbor', 'keyval': 'neighbor_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'circuit-intf-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, adj_neighbor=adj_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, adj_neighbor=adj_neighbor)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def adj_neighbor_entries_state_adj_neighbor_host_name_delete(self, adj_neighbor=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type adj_neighbor: neighbor_id
    :param adj_neighbor: Keyword argument tuple.

    :type neighbor_id: unicode
    :param neighbor_id: **adj_neighbor** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.adj_neighbor_entries_state.adj_neighbor', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'adj_neighbor', 'keyval': 'neighbor_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'host-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, adj_neighbor=adj_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, adj_neighbor=adj_neighbor)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def adj_neighbor_entries_state_adj_neighbor_ip6_circuit_id_delete(self, adj_neighbor=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type adj_neighbor: neighbor_id
    :param adj_neighbor: Keyword argument tuple.

    :type neighbor_id: unicode
    :param neighbor_id: **adj_neighbor** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.adj_neighbor_entries_state.adj_neighbor', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'adj_neighbor', 'keyval': 'neighbor_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ip6-circuit-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, adj_neighbor=adj_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, adj_neighbor=adj_neighbor)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def adj_neighbor_entries_state_adj_neighbor_ip_circuit_id_delete(self, adj_neighbor=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type adj_neighbor: neighbor_id
    :param adj_neighbor: Keyword argument tuple.

    :type neighbor_id: unicode
    :param neighbor_id: **adj_neighbor** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.adj_neighbor_entries_state.adj_neighbor', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'adj_neighbor', 'keyval': 'neighbor_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ip-circuit-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, adj_neighbor=adj_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, adj_neighbor=adj_neighbor)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def adj_neighbor_entries_state_adj_neighbor_remaining_time_delete(self, adj_neighbor=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type adj_neighbor: neighbor_id
    :param adj_neighbor: Keyword argument tuple.

    :type neighbor_id: unicode
    :param neighbor_id: **adj_neighbor** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.adj_neighbor_entries_state.adj_neighbor', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'adj_neighbor', 'keyval': 'neighbor_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'remaining-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, adj_neighbor=adj_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, adj_neighbor=adj_neighbor)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def adj_neighbor_entries_state_adj_neighbor_snpa_delete(self, adj_neighbor=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type adj_neighbor: neighbor_id
    :param adj_neighbor: Keyword argument tuple.

    :type neighbor_id: unicode
    :param neighbor_id: **adj_neighbor** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.adj_neighbor_entries_state.adj_neighbor', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'adj_neighbor', 'keyval': 'neighbor_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'snpa'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, adj_neighbor=adj_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, adj_neighbor=adj_neighbor)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def alias_config_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.alias_config', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.alias_config', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.alias_config', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.alias_config', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def alias_config_alias_delete(self, alias=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type alias: name
    :param alias: Keyword argument tuple.

    :type name: unicode
    :param name: **alias** tuple argument.

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.alias_config.alias', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.alias_config.alias', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.alias_config.alias', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.alias_config.alias', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'alias', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, alias=alias)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, alias=alias)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def alias_config_alias_expansion_delete(self, alias=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type alias: name
    :param alias: Keyword argument tuple.

    :type name: unicode
    :param name: **alias** tuple argument.

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.alias_config.alias', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.alias_config.alias', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.alias_config.alias', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.alias_config.alias', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'alias', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'expansion'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, alias=alias)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, alias=alias)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def alias_config_user_delete(self, user=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type user: name
    :param user: Keyword argument tuple.

    :type name: unicode
    :param name: **user** tuple argument.

        * length restriction: ::

            ['1..40']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.alias_config.user', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.alias_config.user', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.alias_config.user', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.alias_config.user', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'user', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, user=user)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, user=user)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def alias_config_user_alias_delete(self, user=None, alias=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type user: name
    :param user: Keyword argument tuple.

    :type name: unicode
    :param name: **user** tuple argument.

        * length restriction: ::

            ['1..40']

    **Instance Keyword Argument Tuple**:

    :type alias: name
    :param alias: Keyword argument tuple.

    :type name: unicode
    :param name: **alias** tuple argument.

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.alias_config.user', u'user'), ('pybind.nos.v7_1_0.alias_config.user', u'user'), ('pybind.nos.v7_0_1b.alias_config.user', u'user'), ('pybind.nos.v6_0_2c.alias_config.user', u'user')]
    bindings_list = [('pybind.nos.v6_0_2c.alias_config.user.alias', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.alias_config.user.alias', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.alias_config.user.alias', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.alias_config.user.alias', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'alias', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, user=user, alias=alias)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, user=user, alias=alias)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def alias_config_user_alias_expansion_delete(self, user=None, alias=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type user: name
    :param user: Keyword argument tuple.

    :type name: unicode
    :param name: **user** tuple argument.

        * length restriction: ::

            ['1..40']

    **Instance Keyword Argument Tuple**:

    :type alias: name
    :param alias: Keyword argument tuple.

    :type name: unicode
    :param name: **alias** tuple argument.

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.alias_config.user', u'user'), ('pybind.nos.v7_1_0.alias_config.user', u'user'), ('pybind.nos.v7_0_1b.alias_config.user', u'user'), ('pybind.nos.v6_0_2c.alias_config.user', u'user')]
    bindings_list = [('pybind.nos.v6_0_2c.alias_config.user.alias', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.alias_config.user.alias', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.alias_config.user.alias', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.alias_config.user.alias', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'alias', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'expansion'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, user=user, alias=alias)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, user=user, alias=alias)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def arp_delete(self, arp_entry=None, mac_address_value=None, interfacename=None, GigabitEthernet=None, TenGigabitEthernet=None, FortyGigabitEthernet=None, HundredGigabitEthernet=None, Ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type arp_entry: arp_ip_address, mac_address_value, interfacename, GigabitEthernet, TenGigabitEthernet, FortyGigabitEthernet, HundredGigabitEthernet, Ve
    :param arp_entry: Keyword argument tuple.

    :type arp_ip_address: unicode
    :param arp_ip_address: **arp_entry** tuple argument:  A.B.C.D;; IP address of the ARP entry

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type mac_address_value: unicode
    :param mac_address_value: **arp_entry** tuple argument.

    :type interfacename: unicode
    :param interfacename: **arp_entry** tuple argument.

        * enumeration restriction: ::

            ['interface']

    :type GigabitEthernet: unicode
    :param GigabitEthernet: **arp_entry** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type TenGigabitEthernet: unicode
    :param TenGigabitEthernet: **arp_entry** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type FortyGigabitEthernet: unicode
    :param FortyGigabitEthernet: **arp_entry** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type HundredGigabitEthernet: unicode
    :param HundredGigabitEthernet: **arp_entry** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type Ve: long
    :param Ve: **arp_entry** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Argument(s)**:

    :type mac_address_value: unicode
    :param mac_address_value: Keyword argument.

    :type interfacename: unicode
    :param interfacename: Keyword argument.

        * enumeration restriction: ::

            ['interface']

    :type GigabitEthernet: unicode
    :param GigabitEthernet: Choice keyword argument (Only one choice argument allowed per API invocation).

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type TenGigabitEthernet: unicode
    :param TenGigabitEthernet: Choice keyword argument (Only one choice argument allowed per API invocation).

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type FortyGigabitEthernet: unicode
    :param FortyGigabitEthernet: Choice keyword argument (Only one choice argument allowed per API invocation).

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type HundredGigabitEthernet: unicode
    :param HundredGigabitEthernet: Choice keyword argument (Only one choice argument allowed per API invocation).

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type Ve: long
    :param Ve: Choice keyword argument (Only one choice argument allowed per API invocation).

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.hide_arp_holder.arp_entry', 'pybind.nos.v6_0_2c.brocade_arp', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_arp_holder.arp_entry', 'pybind.nos.v7_0_1b.brocade_arp', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_arp_holder.arp_entry', 'pybind.nos.v7_1_0.brocade_arp', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.arp_entry', 'pybind.slxos.v16r_1_00b.brocade_arp', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'arp_entry', 'keyval': 'arp_ip_address', 'extra_keyval': 'arp_ip_address, mac_address_value, interfacename, Port_channel, GigabitEthernet, TenGigabitEthernet, FortyGigabitEthernet, HundredGigabitEthernet, Ve'}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v6_0_2c.hide_arp_holder.arp_entry": {"mac_address_value": "mac_address_value", "interfacename": "interfacename", "FortyGigabitEthernet": "FortyGigabitEthernet", "GigabitEthernet": "GigabitEthernet", "TenGigabitEthernet": "TenGigabitEthernet", "arp_ip_address": "arp_ip_address", "HundredGigabitEthernet": "HundredGigabitEthernet", "Ve": "Ve"}, "pybind.slxos.v16r_1_00b.arp_entry": {}, "pybind.nos.v7_1_0.hide_arp_holder.arp_entry": {}, "pybind.nos.v7_0_1b.hide_arp_holder.arp_entry": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v6_0_2c.hide_arp_holder.arp_entry': [u'FortyGigabitEthernet', u'GigabitEthernet', u'TenGigabitEthernet', u'HundredGigabitEthernet', u'Ve'], 'pybind.slxos.v16r_1_00b.arp_entry': [u'Ethernet', u'Ve'], 'pybind.nos.v7_1_0.hide_arp_holder.arp_entry': [u'Port_channel', u'Ve', u'FortyGigabitEthernet', u'GigabitEthernet', u'TenGigabitEthernet', u'HundredGigabitEthernet'], 'pybind.nos.v7_0_1b.hide_arp_holder.arp_entry': [u'Port_channel', u'Ve', u'FortyGigabitEthernet', u'GigabitEthernet', u'TenGigabitEthernet', u'HundredGigabitEthernet']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, arp_entry=arp_entry, mac_address_value=mac_address_value, interfacename=interfacename, GigabitEthernet=GigabitEthernet, TenGigabitEthernet=TenGigabitEthernet, FortyGigabitEthernet=FortyGigabitEthernet, HundredGigabitEthernet=HundredGigabitEthernet, Ve=Ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, arp_entry=arp_entry, mac_address_value=mac_address_value, interfacename=interfacename, GigabitEthernet=GigabitEthernet, TenGigabitEthernet=TenGigabitEthernet, FortyGigabitEthernet=FortyGigabitEthernet, HundredGigabitEthernet=HundredGigabitEthernet, Ve=Ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def arp_access_list_delete(self, access_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type access_list: acl_name
    :param access_list: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **access_list** tuple argument:  <WORD:1-62>;;Name of ARP access-list

        * length restriction: ::

            ['1..62']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,61})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.arp.access_list', 'pybind.nos.v6_0_2c.brocade_dai', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.arp.access_list', 'pybind.nos.v7_0_1b.brocade_dai', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.arp.access_list', 'pybind.nos.v7_1_0.brocade_dai', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.dai_config.arp.access_list', 'pybind.slxos.v16r_1_00b.brocade_dai', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'access_list', 'keyval': 'acl_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, access_list=access_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, access_list=access_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def arp_access_list_permit_delete(self, access_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type access_list: acl_name
    :param access_list: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **access_list** tuple argument:  <WORD:1-62>;;Name of ARP access-list

        * length restriction: ::

            ['1..62']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,61})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.arp.access_list', u'access_list'), ('pybind.slxos.v16r_1_00b.dai_config.arp.access_list', u'access_list'), ('pybind.nos.v7_0_1b.arp.access_list', u'access_list'), ('pybind.nos.v6_0_2c.arp.access_list', u'access_list')]
    bindings_list = [('pybind.nos.v6_0_2c.arp.access_list.permit', 'pybind.nos.v6_0_2c.brocade_dai', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.arp.access_list.permit', 'pybind.nos.v7_0_1b.brocade_dai', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.arp.access_list.permit', 'pybind.nos.v7_1_0.brocade_dai', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.dai_config.arp.access_list.permit', 'pybind.slxos.v16r_1_00b.brocade_dai', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'acl_name', 'extra_keyval': ''}, {'keyval': 'acl_name', 'extra_keyval': ''}, {'keyval': 'acl_name', 'extra_keyval': ''}, {'keyval': 'acl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, access_list=access_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, access_list=access_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def arp_access_list_permit_ip_delete(self, access_list=None, permit_list=None, log=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type access_list: acl_name
    :param access_list: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **access_list** tuple argument:  <WORD:1-62>;;Name of ARP access-list

        * length restriction: ::

            ['1..62']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,61})'

    **Instance Keyword Argument Tuple**:

    :type permit_list: ip_type, host_ip, mac_type, host_mac, log
    :param permit_list: Keyword argument tuple.

    :type ip_type: unicode
    :param ip_type: **permit_list** tuple argument.

        * enumeration restriction: ::

            ['host']

    :type host_ip: unicode
    :param host_ip: **permit_list** tuple argument:  IPv4Address;;Source IPv4 Address A.B.C.D

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type mac_type: unicode
    :param mac_type: **permit_list** tuple argument:  MAC address

        * enumeration restriction: ::

            ['host']

    :type host_mac: unicode
    :param host_mac: **permit_list** tuple argument:  MACADDRESS;;Mac address in HHHH.HHHH.HHHH format.

    :type log: YANGBool
    :param log: **permit_list** tuple argument:  Log packet

    **Instance Argument(s)**:

    :type log: YANGBool
    :param log: Log packet

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.arp.access_list', u'access_list'), ('pybind.nos.v7_0_1b.arp.access_list', u'access_list'), ('pybind.slxos.v16r_1_00b.dai_config.arp.access_list', u'access_list'), ('pybind.nos.v6_0_2c.arp.access_list', u'access_list')]
    bindings_list = [('pybind.nos.v6_0_2c.arp.access_list.permit.permit_list', 'pybind.nos.v6_0_2c.brocade_dai', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.arp.access_list.permit.permit_list', 'pybind.nos.v7_0_1b.brocade_dai', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.arp.access_list.permit.permit_list', 'pybind.nos.v7_1_0.brocade_dai', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.dai_config.arp.access_list.permit.permit_list', 'pybind.slxos.v16r_1_00b.brocade_dai', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'acl_name', 'extra_keyval': ''}, {'keyval': 'acl_name', 'extra_keyval': ''}, {'keyval': 'acl_name', 'extra_keyval': ''}, {'keyval': 'acl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'permit_list', 'keyval': 'ip_type, host_ip, mac_type, host_mac', 'extra_keyval': 'ip_type, host_ip, mac_type, host_mac, log'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, access_list=access_list, permit_list=permit_list, log=log)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, access_list=access_list, permit_list=permit_list, log=log)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def arp_access_list_permit_ip_log_delete(self, access_list=None, permit_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type access_list: acl_name
    :param access_list: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **access_list** tuple argument:  <WORD:1-62>;;Name of ARP access-list

        * length restriction: ::

            ['1..62']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,61})'

    **Instance Keyword Argument Tuple**:

    :type permit_list: ip_type, host_ip, mac_type, host_mac
    :param permit_list: Keyword argument tuple.

    :type ip_type: unicode
    :param ip_type: **permit_list** tuple argument.

        * enumeration restriction: ::

            ['host']

    :type host_ip: unicode
    :param host_ip: **permit_list** tuple argument:  IPv4Address;;Source IPv4 Address A.B.C.D

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type mac_type: unicode
    :param mac_type: **permit_list** tuple argument:  MAC address

        * enumeration restriction: ::

            ['host']

    :type host_mac: unicode
    :param host_mac: **permit_list** tuple argument:  MACADDRESS;;Mac address in HHHH.HHHH.HHHH format.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.arp.access_list', u'access_list'), ('pybind.nos.v7_0_1b.arp.access_list', u'access_list'), ('pybind.slxos.v16r_1_00b.dai_config.arp.access_list', u'access_list'), ('pybind.nos.v6_0_2c.arp.access_list', u'access_list')]
    bindings_list = [('pybind.nos.v6_0_2c.arp.access_list.permit.permit_list', 'pybind.nos.v6_0_2c.brocade_dai', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.arp.access_list.permit.permit_list', 'pybind.nos.v7_0_1b.brocade_dai', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.arp.access_list.permit.permit_list', 'pybind.nos.v7_1_0.brocade_dai', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.dai_config.arp.access_list.permit.permit_list', 'pybind.slxos.v16r_1_00b.brocade_dai', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'acl_name', 'extra_keyval': ''}, {'keyval': 'acl_name', 'extra_keyval': ''}, {'keyval': 'acl_name', 'extra_keyval': ''}, {'keyval': 'acl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'permit_list', 'keyval': 'ip_type, host_ip, mac_type, host_mac', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'log'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, access_list=access_list, permit_list=permit_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, access_list=access_list, permit_list=permit_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def arp_ethernet_delete(self, arp_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type arp_entry: arp_ip_address
    :param arp_entry: Keyword argument tuple.

    :type arp_ip_address: unicode
    :param arp_ip_address: **arp_entry** tuple argument:  A.B.C.D;; IP address of the ARP entry

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.arp_entry', 'pybind.slxos.v16r_1_00b.brocade_arp', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'arp_entry', 'keyval': 'arp_ip_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'Ethernet'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, arp_entry=arp_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, arp_entry=arp_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def arp_fortygigabitethernet_delete(self, arp_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Instance Keyword Argument Tuple**:

    :type arp_entry: arp_ip_address
    :param arp_entry: Keyword argument tuple.

    :type arp_ip_address: unicode
    :param arp_ip_address: **arp_entry** tuple argument:  A.B.C.D;; IP address of the ARP entry

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.hide_arp_holder.arp_entry', 'pybind.nos.v6_0_2c.brocade_arp', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_arp_holder.arp_entry', 'pybind.nos.v7_0_1b.brocade_arp', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_arp_holder.arp_entry', 'pybind.nos.v7_1_0.brocade_arp', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'arp_entry', 'keyval': 'arp_ip_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'FortyGigabitEthernet'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, arp_entry=arp_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, arp_entry=arp_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def arp_gigabitethernet_delete(self, arp_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Instance Keyword Argument Tuple**:

    :type arp_entry: arp_ip_address
    :param arp_entry: Keyword argument tuple.

    :type arp_ip_address: unicode
    :param arp_ip_address: **arp_entry** tuple argument:  A.B.C.D;; IP address of the ARP entry

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.hide_arp_holder.arp_entry', 'pybind.nos.v6_0_2c.brocade_arp', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_arp_holder.arp_entry', 'pybind.nos.v7_0_1b.brocade_arp', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_arp_holder.arp_entry', 'pybind.nos.v7_1_0.brocade_arp', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'arp_entry', 'keyval': 'arp_ip_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'GigabitEthernet'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, arp_entry=arp_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, arp_entry=arp_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def arp_hundredgigabitethernet_delete(self, arp_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Instance Keyword Argument Tuple**:

    :type arp_entry: arp_ip_address
    :param arp_entry: Keyword argument tuple.

    :type arp_ip_address: unicode
    :param arp_ip_address: **arp_entry** tuple argument:  A.B.C.D;; IP address of the ARP entry

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.hide_arp_holder.arp_entry', 'pybind.nos.v6_0_2c.brocade_arp', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_arp_holder.arp_entry', 'pybind.nos.v7_0_1b.brocade_arp', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_arp_holder.arp_entry', 'pybind.nos.v7_1_0.brocade_arp', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'arp_entry', 'keyval': 'arp_ip_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'HundredGigabitEthernet'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, arp_entry=arp_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, arp_entry=arp_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def arp_interfacename_delete(self, arp_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type arp_entry: arp_ip_address
    :param arp_entry: Keyword argument tuple.

    :type arp_ip_address: unicode
    :param arp_ip_address: **arp_entry** tuple argument:  A.B.C.D;; IP address of the ARP entry

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.hide_arp_holder.arp_entry', 'pybind.nos.v6_0_2c.brocade_arp', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_arp_holder.arp_entry', 'pybind.nos.v7_0_1b.brocade_arp', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_arp_holder.arp_entry', 'pybind.nos.v7_1_0.brocade_arp', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.arp_entry', 'pybind.slxos.v16r_1_00b.brocade_arp', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'arp_entry', 'keyval': 'arp_ip_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'interfacename'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, arp_entry=arp_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, arp_entry=arp_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def arp_mac_address_value_delete(self, arp_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type arp_entry: arp_ip_address
    :param arp_entry: Keyword argument tuple.

    :type arp_ip_address: unicode
    :param arp_ip_address: **arp_entry** tuple argument:  A.B.C.D;; IP address of the ARP entry

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.hide_arp_holder.arp_entry', 'pybind.nos.v6_0_2c.brocade_arp', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_arp_holder.arp_entry', 'pybind.nos.v7_0_1b.brocade_arp', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_arp_holder.arp_entry', 'pybind.nos.v7_1_0.brocade_arp', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.arp_entry', 'pybind.slxos.v16r_1_00b.brocade_arp', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'arp_entry', 'keyval': 'arp_ip_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mac-address-value'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, arp_entry=arp_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, arp_entry=arp_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def arp_port_channel_delete(self, arp_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Instance Keyword Argument Tuple**:

    :type arp_entry: arp_ip_address
    :param arp_entry: Keyword argument tuple.

    :type arp_ip_address: unicode
    :param arp_ip_address: **arp_entry** tuple argument:  A.B.C.D;; IP address of the ARP entry

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_0_1b.hide_arp_holder.arp_entry', 'pybind.nos.v7_0_1b.brocade_arp', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_arp_holder.arp_entry', 'pybind.nos.v7_1_0.brocade_arp', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'arp_entry', 'keyval': 'arp_ip_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'Port-channel'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, arp_entry=arp_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, arp_entry=arp_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def arp_tengigabitethernet_delete(self, arp_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Instance Keyword Argument Tuple**:

    :type arp_entry: arp_ip_address
    :param arp_entry: Keyword argument tuple.

    :type arp_ip_address: unicode
    :param arp_ip_address: **arp_entry** tuple argument:  A.B.C.D;; IP address of the ARP entry

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.hide_arp_holder.arp_entry', 'pybind.nos.v6_0_2c.brocade_arp', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_arp_holder.arp_entry', 'pybind.nos.v7_0_1b.brocade_arp', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_arp_holder.arp_entry', 'pybind.nos.v7_1_0.brocade_arp', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'arp_entry', 'keyval': 'arp_ip_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'TenGigabitEthernet'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, arp_entry=arp_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, arp_entry=arp_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def arp_ve_delete(self, arp_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type arp_entry: arp_ip_address
    :param arp_entry: Keyword argument tuple.

    :type arp_ip_address: unicode
    :param arp_ip_address: **arp_entry** tuple argument:  A.B.C.D;; IP address of the ARP entry

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.hide_arp_holder.arp_entry', 'pybind.nos.v6_0_2c.brocade_arp', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_arp_holder.arp_entry', 'pybind.nos.v7_0_1b.brocade_arp', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_arp_holder.arp_entry', 'pybind.nos.v7_1_0.brocade_arp', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.arp_entry', 'pybind.slxos.v16r_1_00b.brocade_arp', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'arp_entry', 'keyval': 'arp_ip_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'Ve'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, arp_entry=arp_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, arp_entry=arp_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def banner_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.banner', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def banner_incoming_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.banner', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.banner', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.banner', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.banner', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'incoming'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def banner_login_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.banner', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.banner', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.banner', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.banner', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'login'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def banner_motd_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.banner', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.banner', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.banner', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.banner', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'motd'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def bd_mac_br_state_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.bd_mac_br_state', 'pybind.slxos.v16r_1_00b.brocade_l2sys_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def bd_mac_br_state_dyn_mac_count_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.bd_mac_br_state', 'pybind.slxos.v16r_1_00b.brocade_l2sys_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dyn-mac-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def bd_mac_br_state_static_mac_count_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.bd_mac_br_state', 'pybind.slxos.v16r_1_00b.brocade_l2sys_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'static-mac-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def bd_mac_br_state_total_mac_count_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.bd_mac_br_state', 'pybind.slxos.v16r_1_00b.brocade_l2sys_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'total-mac-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def bd_vc_peer_state_delete(self, bd_vc_peer_state=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type bd_vc_peer_state: vc_id
    :param bd_vc_peer_state: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **bd_vc_peer_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.bd_vc_peer_state', 'pybind.slxos.v16r_1_00b.brocade_pwm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'bd_vc_peer_state', 'keyval': 'vc_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bd_vc_peer_state=bd_vc_peer_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bd_vc_peer_state=bd_vc_peer_state)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def bd_vc_peer_state_bd_vc_peer_counter_delete(self, bd_vc_peer_state=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bd_vc_peer_state: vc_id
    :param bd_vc_peer_state: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **bd_vc_peer_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.bd_vc_peer_state', 'bd_vc_peer_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.bd_vc_peer_state.bd_vc_peer_counter', 'pybind.slxos.v16r_1_00b.brocade_pwm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bd_vc_peer_state=bd_vc_peer_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bd_vc_peer_state=bd_vc_peer_state)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def bd_vc_peer_state_bd_vc_peer_counter_no_of_peer_configured_delete(self, bd_vc_peer_state=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bd_vc_peer_state: vc_id
    :param bd_vc_peer_state: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **bd_vc_peer_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.bd_vc_peer_state', 'bd_vc_peer_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.bd_vc_peer_state.bd_vc_peer_counter', 'pybind.slxos.v16r_1_00b.brocade_pwm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'no-of-peer-configured'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bd_vc_peer_state=bd_vc_peer_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bd_vc_peer_state=bd_vc_peer_state)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def bd_vc_peer_state_bd_vc_peer_counter_no_of_peer_operational_delete(self, bd_vc_peer_state=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bd_vc_peer_state: vc_id
    :param bd_vc_peer_state: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **bd_vc_peer_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.bd_vc_peer_state', 'bd_vc_peer_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.bd_vc_peer_state.bd_vc_peer_counter', 'pybind.slxos.v16r_1_00b.brocade_pwm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'no-of-peer-operational'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bd_vc_peer_state=bd_vc_peer_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bd_vc_peer_state=bd_vc_peer_state)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def bd_vc_peer_state_bd_vc_peer_data_delete(self, bd_vc_peer_state=None, bd_vc_peer_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bd_vc_peer_state: vc_id
    :param bd_vc_peer_state: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **bd_vc_peer_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type bd_vc_peer_data: vc_peer_address
    :param bd_vc_peer_data: Keyword argument tuple.

    :type vc_peer_address: unicode
    :param vc_peer_address: **bd_vc_peer_data** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.bd_vc_peer_state', 'bd_vc_peer_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.bd_vc_peer_state.bd_vc_peer_data', 'pybind.slxos.v16r_1_00b.brocade_pwm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'bd_vc_peer_data', 'keyval': 'vc_peer_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bd_vc_peer_state=bd_vc_peer_state, bd_vc_peer_data=bd_vc_peer_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bd_vc_peer_state=bd_vc_peer_state, bd_vc_peer_data=bd_vc_peer_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def bd_vc_peer_state_bd_vc_peer_data_vc_assigned_lsp_delete(self, bd_vc_peer_state=None, bd_vc_peer_data=None, vc_assigned_lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bd_vc_peer_state: vc_id
    :param bd_vc_peer_state: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **bd_vc_peer_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type bd_vc_peer_data: vc_peer_address
    :param bd_vc_peer_data: Keyword argument tuple.

    :type vc_peer_address: unicode
    :param vc_peer_address: **bd_vc_peer_data** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type vc_assigned_lsp: vc_lsp_name
    :param vc_assigned_lsp: Keyword argument tuple.

    :type vc_lsp_name: unicode
    :param vc_lsp_name: **vc_assigned_lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.bd_vc_peer_state', 'bd_vc_peer_state'), ('pybind.slxos.v16r_1_00b.bd_vc_peer_state.bd_vc_peer_data', u'bd_vc_peer_data')]
    bindings_list = [('pybind.slxos.v16r_1_00b.bd_vc_peer_state.bd_vc_peer_data.vc_assigned_lsp', 'pybind.slxos.v16r_1_00b.brocade_pwm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}, {'keyval': 'vc_peer_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vc_assigned_lsp', 'keyval': 'vc_lsp_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bd_vc_peer_state=bd_vc_peer_state, bd_vc_peer_data=bd_vc_peer_data, vc_assigned_lsp=vc_assigned_lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bd_vc_peer_state=bd_vc_peer_state, bd_vc_peer_data=bd_vc_peer_data, vc_assigned_lsp=vc_assigned_lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def bd_vc_peer_state_bd_vc_peer_data_vc_ldp_tnnl_in_use_delete(self, bd_vc_peer_state=None, bd_vc_peer_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bd_vc_peer_state: vc_id
    :param bd_vc_peer_state: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **bd_vc_peer_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type bd_vc_peer_data: vc_peer_address
    :param bd_vc_peer_data: Keyword argument tuple.

    :type vc_peer_address: unicode
    :param vc_peer_address: **bd_vc_peer_data** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.bd_vc_peer_state', 'bd_vc_peer_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.bd_vc_peer_state.bd_vc_peer_data', 'pybind.slxos.v16r_1_00b.brocade_pwm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'bd_vc_peer_data', 'keyval': 'vc_peer_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vc-ldp-tnnl-in-use'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bd_vc_peer_state=bd_vc_peer_state, bd_vc_peer_data=bd_vc_peer_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bd_vc_peer_state=bd_vc_peer_state, bd_vc_peer_data=bd_vc_peer_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def bd_vc_peer_state_bd_vc_peer_data_vc_local_label_delete(self, bd_vc_peer_state=None, bd_vc_peer_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bd_vc_peer_state: vc_id
    :param bd_vc_peer_state: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **bd_vc_peer_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type bd_vc_peer_data: vc_peer_address
    :param bd_vc_peer_data: Keyword argument tuple.

    :type vc_peer_address: unicode
    :param vc_peer_address: **bd_vc_peer_data** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.bd_vc_peer_state', 'bd_vc_peer_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.bd_vc_peer_state.bd_vc_peer_data', 'pybind.slxos.v16r_1_00b.brocade_pwm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'bd_vc_peer_data', 'keyval': 'vc_peer_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vc-local-label'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bd_vc_peer_state=bd_vc_peer_state, bd_vc_peer_data=bd_vc_peer_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bd_vc_peer_state=bd_vc_peer_state, bd_vc_peer_data=bd_vc_peer_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def bd_vc_peer_state_bd_vc_peer_data_vc_local_mtu_delete(self, bd_vc_peer_state=None, bd_vc_peer_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bd_vc_peer_state: vc_id
    :param bd_vc_peer_state: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **bd_vc_peer_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type bd_vc_peer_data: vc_peer_address
    :param bd_vc_peer_data: Keyword argument tuple.

    :type vc_peer_address: unicode
    :param vc_peer_address: **bd_vc_peer_data** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.bd_vc_peer_state', 'bd_vc_peer_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.bd_vc_peer_state.bd_vc_peer_data', 'pybind.slxos.v16r_1_00b.brocade_pwm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'bd_vc_peer_data', 'keyval': 'vc_peer_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vc-local-mtu'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bd_vc_peer_state=bd_vc_peer_state, bd_vc_peer_data=bd_vc_peer_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bd_vc_peer_state=bd_vc_peer_state, bd_vc_peer_data=bd_vc_peer_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def bd_vc_peer_state_bd_vc_peer_data_vc_local_type_delete(self, bd_vc_peer_state=None, bd_vc_peer_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bd_vc_peer_state: vc_id
    :param bd_vc_peer_state: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **bd_vc_peer_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type bd_vc_peer_data: vc_peer_address
    :param bd_vc_peer_data: Keyword argument tuple.

    :type vc_peer_address: unicode
    :param vc_peer_address: **bd_vc_peer_data** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.bd_vc_peer_state', 'bd_vc_peer_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.bd_vc_peer_state.bd_vc_peer_data', 'pybind.slxos.v16r_1_00b.brocade_pwm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'bd_vc_peer_data', 'keyval': 'vc_peer_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vc-local-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bd_vc_peer_state=bd_vc_peer_state, bd_vc_peer_data=bd_vc_peer_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bd_vc_peer_state=bd_vc_peer_state, bd_vc_peer_data=bd_vc_peer_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def bd_vc_peer_state_bd_vc_peer_data_vc_peer_cos_enabled_delete(self, bd_vc_peer_state=None, bd_vc_peer_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bd_vc_peer_state: vc_id
    :param bd_vc_peer_state: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **bd_vc_peer_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type bd_vc_peer_data: vc_peer_address
    :param bd_vc_peer_data: Keyword argument tuple.

    :type vc_peer_address: unicode
    :param vc_peer_address: **bd_vc_peer_data** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.bd_vc_peer_state', 'bd_vc_peer_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.bd_vc_peer_state.bd_vc_peer_data', 'pybind.slxos.v16r_1_00b.brocade_pwm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'bd_vc_peer_data', 'keyval': 'vc_peer_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vc-peer-cos-enabled'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bd_vc_peer_state=bd_vc_peer_state, bd_vc_peer_data=bd_vc_peer_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bd_vc_peer_state=bd_vc_peer_state, bd_vc_peer_data=bd_vc_peer_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def bd_vc_peer_state_bd_vc_peer_data_vc_peer_cos_value_delete(self, bd_vc_peer_state=None, bd_vc_peer_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bd_vc_peer_state: vc_id
    :param bd_vc_peer_state: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **bd_vc_peer_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type bd_vc_peer_data: vc_peer_address
    :param bd_vc_peer_data: Keyword argument tuple.

    :type vc_peer_address: unicode
    :param vc_peer_address: **bd_vc_peer_data** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.bd_vc_peer_state', 'bd_vc_peer_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.bd_vc_peer_state.bd_vc_peer_data', 'pybind.slxos.v16r_1_00b.brocade_pwm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'bd_vc_peer_data', 'keyval': 'vc_peer_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vc-peer-cos-value'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bd_vc_peer_state=bd_vc_peer_state, bd_vc_peer_data=bd_vc_peer_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bd_vc_peer_state=bd_vc_peer_state, bd_vc_peer_data=bd_vc_peer_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def bd_vc_peer_state_bd_vc_peer_data_vc_peer_load_balance_delete(self, bd_vc_peer_state=None, bd_vc_peer_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bd_vc_peer_state: vc_id
    :param bd_vc_peer_state: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **bd_vc_peer_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type bd_vc_peer_data: vc_peer_address
    :param bd_vc_peer_data: Keyword argument tuple.

    :type vc_peer_address: unicode
    :param vc_peer_address: **bd_vc_peer_data** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.bd_vc_peer_state', 'bd_vc_peer_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.bd_vc_peer_state.bd_vc_peer_data', 'pybind.slxos.v16r_1_00b.brocade_pwm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'bd_vc_peer_data', 'keyval': 'vc_peer_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vc-peer-load-balance'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bd_vc_peer_state=bd_vc_peer_state, bd_vc_peer_data=bd_vc_peer_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bd_vc_peer_state=bd_vc_peer_state, bd_vc_peer_data=bd_vc_peer_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def bd_vc_peer_state_bd_vc_peer_data_vc_peer_state_delete(self, bd_vc_peer_state=None, bd_vc_peer_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bd_vc_peer_state: vc_id
    :param bd_vc_peer_state: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **bd_vc_peer_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type bd_vc_peer_data: vc_peer_address
    :param bd_vc_peer_data: Keyword argument tuple.

    :type vc_peer_address: unicode
    :param vc_peer_address: **bd_vc_peer_data** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.bd_vc_peer_state', 'bd_vc_peer_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.bd_vc_peer_state.bd_vc_peer_data', 'pybind.slxos.v16r_1_00b.brocade_pwm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'bd_vc_peer_data', 'keyval': 'vc_peer_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vc-peer-state'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bd_vc_peer_state=bd_vc_peer_state, bd_vc_peer_data=bd_vc_peer_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bd_vc_peer_state=bd_vc_peer_state, bd_vc_peer_data=bd_vc_peer_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def bd_vc_peer_state_bd_vc_peer_data_vc_peer_uptime_delete(self, bd_vc_peer_state=None, bd_vc_peer_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bd_vc_peer_state: vc_id
    :param bd_vc_peer_state: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **bd_vc_peer_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type bd_vc_peer_data: vc_peer_address
    :param bd_vc_peer_data: Keyword argument tuple.

    :type vc_peer_address: unicode
    :param vc_peer_address: **bd_vc_peer_data** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.bd_vc_peer_state', 'bd_vc_peer_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.bd_vc_peer_state.bd_vc_peer_data', 'pybind.slxos.v16r_1_00b.brocade_pwm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'bd_vc_peer_data', 'keyval': 'vc_peer_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vc-peer-uptime'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bd_vc_peer_state=bd_vc_peer_state, bd_vc_peer_data=bd_vc_peer_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bd_vc_peer_state=bd_vc_peer_state, bd_vc_peer_data=bd_vc_peer_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def bd_vc_peer_state_bd_vc_peer_data_vc_proto_tnnl_delete(self, bd_vc_peer_state=None, bd_vc_peer_data=None, vc_proto_tnnl=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bd_vc_peer_state: vc_id
    :param bd_vc_peer_state: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **bd_vc_peer_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type bd_vc_peer_data: vc_peer_address
    :param bd_vc_peer_data: Keyword argument tuple.

    :type vc_peer_address: unicode
    :param vc_peer_address: **bd_vc_peer_data** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type vc_proto_tnnl: vc_proto_name
    :param vc_proto_tnnl: Keyword argument tuple.

    :type vc_proto_name: unicode
    :param vc_proto_name: **vc_proto_tnnl** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.bd_vc_peer_state', 'bd_vc_peer_state'), ('pybind.slxos.v16r_1_00b.bd_vc_peer_state.bd_vc_peer_data', u'bd_vc_peer_data')]
    bindings_list = [('pybind.slxos.v16r_1_00b.bd_vc_peer_state.bd_vc_peer_data.vc_proto_tnnl', 'pybind.slxos.v16r_1_00b.brocade_pwm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}, {'keyval': 'vc_peer_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vc_proto_tnnl', 'keyval': 'vc_proto_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bd_vc_peer_state=bd_vc_peer_state, bd_vc_peer_data=bd_vc_peer_data, vc_proto_tnnl=vc_proto_tnnl)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bd_vc_peer_state=bd_vc_peer_state, bd_vc_peer_data=bd_vc_peer_data, vc_proto_tnnl=vc_proto_tnnl)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def bd_vc_peer_state_bd_vc_peer_data_vc_proto_tnnl_vc_ldp_name_delete(self, bd_vc_peer_state=None, bd_vc_peer_data=None, vc_proto_tnnl=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bd_vc_peer_state: vc_id
    :param bd_vc_peer_state: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **bd_vc_peer_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type bd_vc_peer_data: vc_peer_address
    :param bd_vc_peer_data: Keyword argument tuple.

    :type vc_peer_address: unicode
    :param vc_peer_address: **bd_vc_peer_data** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type vc_proto_tnnl: vc_proto_name
    :param vc_proto_tnnl: Keyword argument tuple.

    :type vc_proto_name: unicode
    :param vc_proto_name: **vc_proto_tnnl** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.bd_vc_peer_state', 'bd_vc_peer_state'), ('pybind.slxos.v16r_1_00b.bd_vc_peer_state.bd_vc_peer_data', u'bd_vc_peer_data')]
    bindings_list = [('pybind.slxos.v16r_1_00b.bd_vc_peer_state.bd_vc_peer_data.vc_proto_tnnl', 'pybind.slxos.v16r_1_00b.brocade_pwm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}, {'keyval': 'vc_peer_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vc_proto_tnnl', 'keyval': 'vc_proto_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vc-ldp-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bd_vc_peer_state=bd_vc_peer_state, bd_vc_peer_data=bd_vc_peer_data, vc_proto_tnnl=vc_proto_tnnl)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bd_vc_peer_state=bd_vc_peer_state, bd_vc_peer_data=bd_vc_peer_data, vc_proto_tnnl=vc_proto_tnnl)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def bd_vc_peer_state_bd_vc_peer_data_vc_proto_tnnl_vc_ldp_tunnel_id_delete(self, bd_vc_peer_state=None, bd_vc_peer_data=None, vc_proto_tnnl=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bd_vc_peer_state: vc_id
    :param bd_vc_peer_state: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **bd_vc_peer_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type bd_vc_peer_data: vc_peer_address
    :param bd_vc_peer_data: Keyword argument tuple.

    :type vc_peer_address: unicode
    :param vc_peer_address: **bd_vc_peer_data** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type vc_proto_tnnl: vc_proto_name
    :param vc_proto_tnnl: Keyword argument tuple.

    :type vc_proto_name: unicode
    :param vc_proto_name: **vc_proto_tnnl** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.bd_vc_peer_state', 'bd_vc_peer_state'), ('pybind.slxos.v16r_1_00b.bd_vc_peer_state.bd_vc_peer_data', u'bd_vc_peer_data')]
    bindings_list = [('pybind.slxos.v16r_1_00b.bd_vc_peer_state.bd_vc_peer_data.vc_proto_tnnl', 'pybind.slxos.v16r_1_00b.brocade_pwm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}, {'keyval': 'vc_peer_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vc_proto_tnnl', 'keyval': 'vc_proto_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vc-ldp-tunnel-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bd_vc_peer_state=bd_vc_peer_state, bd_vc_peer_data=bd_vc_peer_data, vc_proto_tnnl=vc_proto_tnnl)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bd_vc_peer_state=bd_vc_peer_state, bd_vc_peer_data=bd_vc_peer_data, vc_proto_tnnl=vc_proto_tnnl)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def bd_vc_peer_state_bd_vc_peer_data_vc_proto_tnnl_vc_lsp_name_delete(self, bd_vc_peer_state=None, bd_vc_peer_data=None, vc_proto_tnnl=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bd_vc_peer_state: vc_id
    :param bd_vc_peer_state: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **bd_vc_peer_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type bd_vc_peer_data: vc_peer_address
    :param bd_vc_peer_data: Keyword argument tuple.

    :type vc_peer_address: unicode
    :param vc_peer_address: **bd_vc_peer_data** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type vc_proto_tnnl: vc_proto_name
    :param vc_proto_tnnl: Keyword argument tuple.

    :type vc_proto_name: unicode
    :param vc_proto_name: **vc_proto_tnnl** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.bd_vc_peer_state', 'bd_vc_peer_state'), ('pybind.slxos.v16r_1_00b.bd_vc_peer_state.bd_vc_peer_data', u'bd_vc_peer_data')]
    bindings_list = [('pybind.slxos.v16r_1_00b.bd_vc_peer_state.bd_vc_peer_data.vc_proto_tnnl', 'pybind.slxos.v16r_1_00b.brocade_pwm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}, {'keyval': 'vc_peer_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vc_proto_tnnl', 'keyval': 'vc_proto_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vc-lsp-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bd_vc_peer_state=bd_vc_peer_state, bd_vc_peer_data=bd_vc_peer_data, vc_proto_tnnl=vc_proto_tnnl)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bd_vc_peer_state=bd_vc_peer_state, bd_vc_peer_data=bd_vc_peer_data, vc_proto_tnnl=vc_proto_tnnl)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def bd_vc_peer_state_bd_vc_peer_data_vc_proto_tnnl_vc_peer_lsp_cos_enabled_delete(self, bd_vc_peer_state=None, bd_vc_peer_data=None, vc_proto_tnnl=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bd_vc_peer_state: vc_id
    :param bd_vc_peer_state: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **bd_vc_peer_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type bd_vc_peer_data: vc_peer_address
    :param bd_vc_peer_data: Keyword argument tuple.

    :type vc_peer_address: unicode
    :param vc_peer_address: **bd_vc_peer_data** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type vc_proto_tnnl: vc_proto_name
    :param vc_proto_tnnl: Keyword argument tuple.

    :type vc_proto_name: unicode
    :param vc_proto_name: **vc_proto_tnnl** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.bd_vc_peer_state', 'bd_vc_peer_state'), ('pybind.slxos.v16r_1_00b.bd_vc_peer_state.bd_vc_peer_data', u'bd_vc_peer_data')]
    bindings_list = [('pybind.slxos.v16r_1_00b.bd_vc_peer_state.bd_vc_peer_data.vc_proto_tnnl', 'pybind.slxos.v16r_1_00b.brocade_pwm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}, {'keyval': 'vc_peer_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vc_proto_tnnl', 'keyval': 'vc_proto_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vc-peer-lsp-cos-enabled'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bd_vc_peer_state=bd_vc_peer_state, bd_vc_peer_data=bd_vc_peer_data, vc_proto_tnnl=vc_proto_tnnl)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bd_vc_peer_state=bd_vc_peer_state, bd_vc_peer_data=bd_vc_peer_data, vc_proto_tnnl=vc_proto_tnnl)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def bd_vc_peer_state_bd_vc_peer_data_vc_proto_tnnl_vc_peer_lsp_cos_value_delete(self, bd_vc_peer_state=None, bd_vc_peer_data=None, vc_proto_tnnl=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bd_vc_peer_state: vc_id
    :param bd_vc_peer_state: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **bd_vc_peer_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type bd_vc_peer_data: vc_peer_address
    :param bd_vc_peer_data: Keyword argument tuple.

    :type vc_peer_address: unicode
    :param vc_peer_address: **bd_vc_peer_data** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type vc_proto_tnnl: vc_proto_name
    :param vc_proto_tnnl: Keyword argument tuple.

    :type vc_proto_name: unicode
    :param vc_proto_name: **vc_proto_tnnl** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.bd_vc_peer_state', 'bd_vc_peer_state'), ('pybind.slxos.v16r_1_00b.bd_vc_peer_state.bd_vc_peer_data', u'bd_vc_peer_data')]
    bindings_list = [('pybind.slxos.v16r_1_00b.bd_vc_peer_state.bd_vc_peer_data.vc_proto_tnnl', 'pybind.slxos.v16r_1_00b.brocade_pwm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}, {'keyval': 'vc_peer_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vc_proto_tnnl', 'keyval': 'vc_proto_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vc-peer-lsp-cos-value'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bd_vc_peer_state=bd_vc_peer_state, bd_vc_peer_data=bd_vc_peer_data, vc_proto_tnnl=vc_proto_tnnl)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bd_vc_peer_state=bd_vc_peer_state, bd_vc_peer_data=bd_vc_peer_data, vc_proto_tnnl=vc_proto_tnnl)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def bd_vc_peer_state_bd_vc_peer_data_vc_remote_label_delete(self, bd_vc_peer_state=None, bd_vc_peer_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bd_vc_peer_state: vc_id
    :param bd_vc_peer_state: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **bd_vc_peer_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type bd_vc_peer_data: vc_peer_address
    :param bd_vc_peer_data: Keyword argument tuple.

    :type vc_peer_address: unicode
    :param vc_peer_address: **bd_vc_peer_data** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.bd_vc_peer_state', 'bd_vc_peer_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.bd_vc_peer_state.bd_vc_peer_data', 'pybind.slxos.v16r_1_00b.brocade_pwm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'bd_vc_peer_data', 'keyval': 'vc_peer_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vc-remote-label'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bd_vc_peer_state=bd_vc_peer_state, bd_vc_peer_data=bd_vc_peer_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bd_vc_peer_state=bd_vc_peer_state, bd_vc_peer_data=bd_vc_peer_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def bd_vc_peer_state_bd_vc_peer_data_vc_remote_mtu_delete(self, bd_vc_peer_state=None, bd_vc_peer_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bd_vc_peer_state: vc_id
    :param bd_vc_peer_state: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **bd_vc_peer_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type bd_vc_peer_data: vc_peer_address
    :param bd_vc_peer_data: Keyword argument tuple.

    :type vc_peer_address: unicode
    :param vc_peer_address: **bd_vc_peer_data** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.bd_vc_peer_state', 'bd_vc_peer_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.bd_vc_peer_state.bd_vc_peer_data', 'pybind.slxos.v16r_1_00b.brocade_pwm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'bd_vc_peer_data', 'keyval': 'vc_peer_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vc-remote-mtu'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bd_vc_peer_state=bd_vc_peer_state, bd_vc_peer_data=bd_vc_peer_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bd_vc_peer_state=bd_vc_peer_state, bd_vc_peer_data=bd_vc_peer_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def bd_vc_peer_state_bd_vc_peer_data_vc_remote_type_delete(self, bd_vc_peer_state=None, bd_vc_peer_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bd_vc_peer_state: vc_id
    :param bd_vc_peer_state: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **bd_vc_peer_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type bd_vc_peer_data: vc_peer_address
    :param bd_vc_peer_data: Keyword argument tuple.

    :type vc_peer_address: unicode
    :param vc_peer_address: **bd_vc_peer_data** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.bd_vc_peer_state', 'bd_vc_peer_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.bd_vc_peer_state.bd_vc_peer_data', 'pybind.slxos.v16r_1_00b.brocade_pwm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'bd_vc_peer_data', 'keyval': 'vc_peer_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vc-remote-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bd_vc_peer_state=bd_vc_peer_state, bd_vc_peer_data=bd_vc_peer_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bd_vc_peer_state=bd_vc_peer_state, bd_vc_peer_data=bd_vc_peer_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def beacon_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.beacon', 'pybind.nos.v6_0_2c.brocade_beacon', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.beacon', 'pybind.nos.v7_0_1b.brocade_beacon', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.beacon', 'pybind.nos.v7_1_0.brocade_beacon', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.beacon', 'pybind.slxos.v16r_1_00b.brocade_beacon', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def bp_rate_limit_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.bp_rate_limit', 'pybind.slxos.v16r_1_00b.brocade_bprate_limit', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def bp_rate_limit_heavy_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.bp_rate_limit.heavy', 'pybind.slxos.v16r_1_00b.brocade_bprate_limit', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def bp_rate_limit_heavy_module_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.bp_rate_limit.heavy.module', 'pybind.slxos.v16r_1_00b.brocade_bprate_limit', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def bp_rate_limit_heavy_module_add_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.bp_rate_limit.heavy.module', 'pybind.slxos.v16r_1_00b.brocade_bprate_limit', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'add'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def bp_rate_limit_heavy_module_remove_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.bp_rate_limit.heavy.module', 'pybind.slxos.v16r_1_00b.brocade_bprate_limit', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'remove'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def bridge_domain_delete(self, bridge_domain=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type bridge_domain: bridge_domain_id, bridge_domain_type
    :param bridge_domain: Keyword argument tuple.

    :type bridge_domain_id: long
    :param bridge_domain_id: **bridge_domain** tuple argument:  Bridge-domain ID.

        * range restriction: ::

            ['0..4294967295']

    :type bridge_domain_type: unicode
    :param bridge_domain_type: **bridge_domain** tuple argument:  Set the Bridge Domain Type

        * enumeration restriction: ::

            ['p2mp', 'p2p']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.bridge_domain', 'pybind.slxos.v16r_1_00b.brocade_bridge_domain', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'bridge_domain', 'keyval': 'bridge_domain_id, bridge_domain_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain=bridge_domain)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain=bridge_domain)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def bridge_domain_bpdu_drop_enable_delete(self, bridge_domain=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type bridge_domain: bridge_domain_id, bridge_domain_type
    :param bridge_domain: Keyword argument tuple.

    :type bridge_domain_id: long
    :param bridge_domain_id: **bridge_domain** tuple argument:  Bridge-domain ID.

        * range restriction: ::

            ['0..4294967295']

    :type bridge_domain_type: unicode
    :param bridge_domain_type: **bridge_domain** tuple argument:  Set the Bridge Domain Type

        * enumeration restriction: ::

            ['p2mp', 'p2p']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.bridge_domain', 'pybind.slxos.v16r_1_00b.brocade_bridge_domain', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'bridge_domain', 'keyval': 'bridge_domain_id, bridge_domain_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bpdu-drop-enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain=bridge_domain)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain=bridge_domain)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def bridge_domain_local_switching_delete(self, bridge_domain=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type bridge_domain: bridge_domain_id, bridge_domain_type
    :param bridge_domain: Keyword argument tuple.

    :type bridge_domain_id: long
    :param bridge_domain_id: **bridge_domain** tuple argument:  Bridge-domain ID.

        * range restriction: ::

            ['0..4294967295']

    :type bridge_domain_type: unicode
    :param bridge_domain_type: **bridge_domain** tuple argument:  Set the Bridge Domain Type

        * enumeration restriction: ::

            ['p2mp', 'p2p']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.bridge_domain', 'pybind.slxos.v16r_1_00b.brocade_bridge_domain', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'bridge_domain', 'keyval': 'bridge_domain_id, bridge_domain_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'local-switching'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain=bridge_domain)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain=bridge_domain)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def bridge_domain_logical_interface_delete(self, bridge_domain=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bridge_domain: bridge_domain_id, bridge_domain_type
    :param bridge_domain: Keyword argument tuple.

    :type bridge_domain_id: long
    :param bridge_domain_id: **bridge_domain** tuple argument:  Bridge-domain ID.

        * range restriction: ::

            ['0..4294967295']

    :type bridge_domain_type: unicode
    :param bridge_domain_type: **bridge_domain** tuple argument:  Set the Bridge Domain Type

        * enumeration restriction: ::

            ['p2mp', 'p2p']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.bridge_domain', 'bridge_domain')]
    bindings_list = [('pybind.slxos.v16r_1_00b.bridge_domain.logical_interface', 'pybind.slxos.v16r_1_00b.brocade_bridge_domain', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bridge_domain_id, bridge_domain_type', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain=bridge_domain)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain=bridge_domain)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def bridge_domain_logical_interface_ethernet_delete(self, bridge_domain=None, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bridge_domain: bridge_domain_id, bridge_domain_type
    :param bridge_domain: Keyword argument tuple.

    :type bridge_domain_id: long
    :param bridge_domain_id: **bridge_domain** tuple argument:  Bridge-domain ID.

        * range restriction: ::

            ['0..4294967295']

    :type bridge_domain_type: unicode
    :param bridge_domain_type: **bridge_domain** tuple argument:  Set the Bridge Domain Type

        * enumeration restriction: ::

            ['p2mp', 'p2p']

    **Instance Keyword Argument Tuple**:

    :type ethernet: lif_bind_id
    :param ethernet: Keyword argument tuple.

    :type lif_bind_id: unicode
    :param lif_bind_id: **ethernet** tuple argument:  Instance ID of the LIF to bind

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9])(:[1-4])?)'
            '(\.([1-9]|[1-9][0-9]||[1-9][0-9][0-9]|[1-9][0-9]'
            '[0-9][0-9]|1[0-2][0-2][0-8][0-8]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.bridge_domain', 'bridge_domain')]
    bindings_list = [('pybind.slxos.v16r_1_00b.bridge_domain.logical_interface.ethernet', 'pybind.slxos.v16r_1_00b.brocade_bridge_domain', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bridge_domain_id, bridge_domain_type', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ethernet', 'keyval': 'lif_bind_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain=bridge_domain, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain=bridge_domain, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def bridge_domain_logical_interface_port_channel_delete(self, bridge_domain=None, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bridge_domain: bridge_domain_id, bridge_domain_type
    :param bridge_domain: Keyword argument tuple.

    :type bridge_domain_id: long
    :param bridge_domain_id: **bridge_domain** tuple argument:  Bridge-domain ID.

        * range restriction: ::

            ['0..4294967295']

    :type bridge_domain_type: unicode
    :param bridge_domain_type: **bridge_domain** tuple argument:  Set the Bridge Domain Type

        * enumeration restriction: ::

            ['p2mp', 'p2p']

    **Instance Keyword Argument Tuple**:

    :type port_channel: pc_lif_bind_id
    :param port_channel: Keyword argument tuple.

    :type pc_lif_bind_id: unicode
    :param pc_lif_bind_id: **port_channel** tuple argument:  Instance ID of the port-channel LIF to bind

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|[1-9][0-9][0-9]|[1-6][0-9][0-'
            '9][0-9])\.([1-9]|[1-9][0-9]||[1-9][0-9][0-9]|[1-'
            '9][0-9][0-9][0-9]|1[0-2][0-2][0-8][0-8]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.bridge_domain', 'bridge_domain')]
    bindings_list = [('pybind.slxos.v16r_1_00b.bridge_domain.logical_interface.port_channel', 'pybind.slxos.v16r_1_00b.brocade_bridge_domain', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bridge_domain_id, bridge_domain_type', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'port_channel', 'keyval': 'pc_lif_bind_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain=bridge_domain, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain=bridge_domain, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def bridge_domain_mac_state_delete(self, bridge_domain_mac_state=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type bridge_domain_mac_state: bd_id
    :param bridge_domain_mac_state: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bridge_domain_mac_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.bridge_domain_mac_state', 'pybind.slxos.v16r_1_00b.brocade_l2sys_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'bridge_domain_mac_state', 'keyval': 'bd_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain_mac_state=bridge_domain_mac_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain_mac_state=bridge_domain_mac_state)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def bridge_domain_mac_state_no_of_mac_delete(self, bridge_domain_mac_state=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type bridge_domain_mac_state: bd_id
    :param bridge_domain_mac_state: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bridge_domain_mac_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.bridge_domain_mac_state', 'pybind.slxos.v16r_1_00b.brocade_l2sys_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'bridge_domain_mac_state', 'keyval': 'bd_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'no-of-mac'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain_mac_state=bridge_domain_mac_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain_mac_state=bridge_domain_mac_state)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def bridge_domain_mac_state_no_of_static_mac_delete(self, bridge_domain_mac_state=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type bridge_domain_mac_state: bd_id
    :param bridge_domain_mac_state: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bridge_domain_mac_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.bridge_domain_mac_state', 'pybind.slxos.v16r_1_00b.brocade_l2sys_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'bridge_domain_mac_state', 'keyval': 'bd_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'no-of-static-mac'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain_mac_state=bridge_domain_mac_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain_mac_state=bridge_domain_mac_state)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def bridge_domain_peer_delete(self, bridge_domain=None, peer=None, load_balance=None, cos=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bridge_domain: bridge_domain_id, bridge_domain_type
    :param bridge_domain: Keyword argument tuple.

    :type bridge_domain_id: long
    :param bridge_domain_id: **bridge_domain** tuple argument:  Bridge-domain ID.

        * range restriction: ::

            ['0..4294967295']

    :type bridge_domain_type: unicode
    :param bridge_domain_type: **bridge_domain** tuple argument:  Set the Bridge Domain Type

        * enumeration restriction: ::

            ['p2mp', 'p2p']

    **Instance Keyword Argument Tuple**:

    :type peer: peer_ip, load_balance, cos
    :param peer: Keyword argument tuple.

    :type peer_ip: unicode
    :param peer_ip: **peer** tuple argument:  PW Peer Ip for remote peer

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type load_balance: YANGBool
    :param load_balance: **peer** tuple argument:  load balance

    :type cos: long
    :param cos: **peer** tuple argument:  cos value

        * range restriction: ::

            ['0..4294967295']

    **Instance Argument(s)**:

    :type load_balance: YANGBool
    :param load_balance: load balance

    :type cos: long
    :param cos: cos value

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.bridge_domain', 'bridge_domain')]
    bindings_list = [('pybind.slxos.v16r_1_00b.bridge_domain.peer', 'pybind.slxos.v16r_1_00b.brocade_bridge_domain', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bridge_domain_id, bridge_domain_type', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'peer', 'keyval': 'peer_ip', 'extra_keyval': 'peer_ip, load_balance, cos'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain=bridge_domain, peer=peer, load_balance=load_balance, cos=cos)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain=bridge_domain, peer=peer, load_balance=load_balance, cos=cos)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def bridge_domain_peer_cos_delete(self, bridge_domain=None, peer=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bridge_domain: bridge_domain_id, bridge_domain_type
    :param bridge_domain: Keyword argument tuple.

    :type bridge_domain_id: long
    :param bridge_domain_id: **bridge_domain** tuple argument:  Bridge-domain ID.

        * range restriction: ::

            ['0..4294967295']

    :type bridge_domain_type: unicode
    :param bridge_domain_type: **bridge_domain** tuple argument:  Set the Bridge Domain Type

        * enumeration restriction: ::

            ['p2mp', 'p2p']

    **Instance Keyword Argument Tuple**:

    :type peer: peer_ip
    :param peer: Keyword argument tuple.

    :type peer_ip: unicode
    :param peer_ip: **peer** tuple argument:  PW Peer Ip for remote peer

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.bridge_domain', 'bridge_domain')]
    bindings_list = [('pybind.slxos.v16r_1_00b.bridge_domain.peer', 'pybind.slxos.v16r_1_00b.brocade_bridge_domain', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bridge_domain_id, bridge_domain_type', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'peer', 'keyval': 'peer_ip', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cos'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain=bridge_domain, peer=peer)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain=bridge_domain, peer=peer)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def bridge_domain_peer_load_balance_delete(self, bridge_domain=None, peer=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bridge_domain: bridge_domain_id, bridge_domain_type
    :param bridge_domain: Keyword argument tuple.

    :type bridge_domain_id: long
    :param bridge_domain_id: **bridge_domain** tuple argument:  Bridge-domain ID.

        * range restriction: ::

            ['0..4294967295']

    :type bridge_domain_type: unicode
    :param bridge_domain_type: **bridge_domain** tuple argument:  Set the Bridge Domain Type

        * enumeration restriction: ::

            ['p2mp', 'p2p']

    **Instance Keyword Argument Tuple**:

    :type peer: peer_ip
    :param peer: Keyword argument tuple.

    :type peer_ip: unicode
    :param peer_ip: **peer** tuple argument:  PW Peer Ip for remote peer

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.bridge_domain', 'bridge_domain')]
    bindings_list = [('pybind.slxos.v16r_1_00b.bridge_domain.peer', 'pybind.slxos.v16r_1_00b.brocade_bridge_domain', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bridge_domain_id, bridge_domain_type', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'peer', 'keyval': 'peer_ip', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'load-balance'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain=bridge_domain, peer=peer)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain=bridge_domain, peer=peer)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def bridge_domain_pw_profile_delete(self, bridge_domain=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type bridge_domain: bridge_domain_id, bridge_domain_type
    :param bridge_domain: Keyword argument tuple.

    :type bridge_domain_id: long
    :param bridge_domain_id: **bridge_domain** tuple argument:  Bridge-domain ID.

        * range restriction: ::

            ['0..4294967295']

    :type bridge_domain_type: unicode
    :param bridge_domain_type: **bridge_domain** tuple argument:  Set the Bridge Domain Type

        * enumeration restriction: ::

            ['p2mp', 'p2p']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.bridge_domain', 'pybind.slxos.v16r_1_00b.brocade_bridge_domain', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'bridge_domain', 'keyval': 'bridge_domain_id, bridge_domain_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'pw-profile'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain=bridge_domain)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain=bridge_domain)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def bridge_domain_state_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.bridge_domain_state', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def bridge_domain_state_bridge_domain_counter_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.bridge_domain_state.bridge_domain_counter', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def bridge_domain_state_bridge_domain_counter_no_of_bd_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.bridge_domain_state.bridge_domain_counter', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'no-of-bd'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def bridge_domain_state_bridge_domain_counter_no_of_dynamic_mac_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.bridge_domain_state.bridge_domain_counter', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'no-of-dynamic-mac'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def bridge_domain_state_bridge_domain_counter_no_of_static_mac_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.bridge_domain_state.bridge_domain_counter', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'no-of-static-mac'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def bridge_domain_state_bridge_domain_counter_no_of_vpls_bd_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.bridge_domain_state.bridge_domain_counter', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'no-of-vpls-bd'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def bridge_domain_state_bridge_domain_list_delete(self, bridge_domain_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type bridge_domain_list: bd_id
    :param bridge_domain_list: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bridge_domain_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.bridge_domain_state.bridge_domain_list', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'bridge_domain_list', 'keyval': 'bd_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain_list=bridge_domain_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain_list=bridge_domain_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def bridge_domain_state_bridge_domain_list_active_ac_lif_count_delete(self, bridge_domain_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type bridge_domain_list: bd_id
    :param bridge_domain_list: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bridge_domain_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.bridge_domain_state.bridge_domain_list', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'bridge_domain_list', 'keyval': 'bd_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'active-ac-lif-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain_list=bridge_domain_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain_list=bridge_domain_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def bridge_domain_state_bridge_domain_list_active_vfi_lif_count_delete(self, bridge_domain_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type bridge_domain_list: bd_id
    :param bridge_domain_list: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bridge_domain_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.bridge_domain_state.bridge_domain_list', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'bridge_domain_list', 'keyval': 'bd_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'active-vfi-lif-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain_list=bridge_domain_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain_list=bridge_domain_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def bridge_domain_state_bridge_domain_list_bd_type_delete(self, bridge_domain_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type bridge_domain_list: bd_id
    :param bridge_domain_list: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bridge_domain_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.bridge_domain_state.bridge_domain_list', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'bridge_domain_list', 'keyval': 'bd_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bd-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain_list=bridge_domain_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain_list=bridge_domain_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def bridge_domain_state_bridge_domain_list_block_bpdu_delete(self, bridge_domain_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type bridge_domain_list: bd_id
    :param bridge_domain_list: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bridge_domain_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.bridge_domain_state.bridge_domain_list', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'bridge_domain_list', 'keyval': 'bd_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'block-bpdu'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain_list=bridge_domain_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain_list=bridge_domain_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def bridge_domain_state_bridge_domain_list_config_ac_lif_count_delete(self, bridge_domain_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type bridge_domain_list: bd_id
    :param bridge_domain_list: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bridge_domain_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.bridge_domain_state.bridge_domain_list', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'bridge_domain_list', 'keyval': 'bd_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-ac-lif-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain_list=bridge_domain_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain_list=bridge_domain_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def bridge_domain_state_bridge_domain_list_config_vfi_lif_count_delete(self, bridge_domain_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type bridge_domain_list: bd_id
    :param bridge_domain_list: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bridge_domain_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.bridge_domain_state.bridge_domain_list', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'bridge_domain_list', 'keyval': 'bd_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-vfi-lif-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain_list=bridge_domain_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain_list=bridge_domain_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def bridge_domain_state_bridge_domain_list_local_switching_delete(self, bridge_domain_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type bridge_domain_list: bd_id
    :param bridge_domain_list: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bridge_domain_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.bridge_domain_state.bridge_domain_list', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'bridge_domain_list', 'keyval': 'bd_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'local-switching'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain_list=bridge_domain_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain_list=bridge_domain_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def bridge_domain_state_bridge_domain_list_mac_limit_delete(self, bridge_domain_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type bridge_domain_list: bd_id
    :param bridge_domain_list: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bridge_domain_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.bridge_domain_state.bridge_domain_list', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'bridge_domain_list', 'keyval': 'bd_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mac-limit'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain_list=bridge_domain_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain_list=bridge_domain_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def bridge_domain_state_bridge_domain_list_outer_vlan_list_delete(self, bridge_domain_list=None, outer_vlan_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bridge_domain_list: bd_id
    :param bridge_domain_list: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bridge_domain_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type outer_vlan_list: outer_vlan
    :param outer_vlan_list: Keyword argument tuple.

    :type outer_vlan: long
    :param outer_vlan: **outer_vlan_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.bridge_domain_state.bridge_domain_list', u'bridge_domain_list')]
    bindings_list = [('pybind.slxos.v16r_1_00b.bridge_domain_state.bridge_domain_list.outer_vlan_list', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bd_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'outer_vlan_list', 'keyval': 'outer_vlan', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain_list=bridge_domain_list, outer_vlan_list=outer_vlan_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain_list=bridge_domain_list, outer_vlan_list=outer_vlan_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def bridge_domain_state_bridge_domain_list_outer_vlan_list_no_of_up_tagged_ports_delete(self, bridge_domain_list=None, outer_vlan_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bridge_domain_list: bd_id
    :param bridge_domain_list: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bridge_domain_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type outer_vlan_list: outer_vlan
    :param outer_vlan_list: Keyword argument tuple.

    :type outer_vlan: long
    :param outer_vlan: **outer_vlan_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.bridge_domain_state.bridge_domain_list', u'bridge_domain_list')]
    bindings_list = [('pybind.slxos.v16r_1_00b.bridge_domain_state.bridge_domain_list.outer_vlan_list', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bd_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'outer_vlan_list', 'keyval': 'outer_vlan', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'no-of-up-tagged-ports'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain_list=bridge_domain_list, outer_vlan_list=outer_vlan_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain_list=bridge_domain_list, outer_vlan_list=outer_vlan_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def bridge_domain_state_bridge_domain_list_outer_vlan_list_no_of_up_untagged_ports_delete(self, bridge_domain_list=None, outer_vlan_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bridge_domain_list: bd_id
    :param bridge_domain_list: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bridge_domain_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type outer_vlan_list: outer_vlan
    :param outer_vlan_list: Keyword argument tuple.

    :type outer_vlan: long
    :param outer_vlan: **outer_vlan_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.bridge_domain_state.bridge_domain_list', u'bridge_domain_list')]
    bindings_list = [('pybind.slxos.v16r_1_00b.bridge_domain_state.bridge_domain_list.outer_vlan_list', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bd_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'outer_vlan_list', 'keyval': 'outer_vlan', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'no-of-up-untagged-ports'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain_list=bridge_domain_list, outer_vlan_list=outer_vlan_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain_list=bridge_domain_list, outer_vlan_list=outer_vlan_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def bridge_domain_state_bridge_domain_list_outer_vlan_list_tagged_ports_list_delete(self, bridge_domain_list=None, outer_vlan_list=None, tagged_ports_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bridge_domain_list: bd_id
    :param bridge_domain_list: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bridge_domain_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type outer_vlan_list: outer_vlan
    :param outer_vlan_list: Keyword argument tuple.

    :type outer_vlan: long
    :param outer_vlan: **outer_vlan_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type tagged_ports_list: lif_name
    :param tagged_ports_list: Keyword argument tuple.

    :type lif_name: unicode
    :param lif_name: **tagged_ports_list** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.bridge_domain_state.bridge_domain_list', u'bridge_domain_list'), ('pybind.slxos.v16r_1_00b.bridge_domain_state.bridge_domain_list.outer_vlan_list', u'outer_vlan_list')]
    bindings_list = [('pybind.slxos.v16r_1_00b.bridge_domain_state.bridge_domain_list.outer_vlan_list.tagged_ports_list', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'outer_vlan', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'tagged_ports_list', 'keyval': 'lif_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain_list=bridge_domain_list, outer_vlan_list=outer_vlan_list, tagged_ports_list=tagged_ports_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain_list=bridge_domain_list, outer_vlan_list=outer_vlan_list, tagged_ports_list=tagged_ports_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def bridge_domain_state_bridge_domain_list_outer_vlan_list_tagged_ports_list_egress_stats_id_delete(self, bridge_domain_list=None, outer_vlan_list=None, tagged_ports_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bridge_domain_list: bd_id
    :param bridge_domain_list: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bridge_domain_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type outer_vlan_list: outer_vlan
    :param outer_vlan_list: Keyword argument tuple.

    :type outer_vlan: long
    :param outer_vlan: **outer_vlan_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type tagged_ports_list: lif_name
    :param tagged_ports_list: Keyword argument tuple.

    :type lif_name: unicode
    :param lif_name: **tagged_ports_list** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.bridge_domain_state.bridge_domain_list', u'bridge_domain_list'), ('pybind.slxos.v16r_1_00b.bridge_domain_state.bridge_domain_list.outer_vlan_list', u'outer_vlan_list')]
    bindings_list = [('pybind.slxos.v16r_1_00b.bridge_domain_state.bridge_domain_list.outer_vlan_list.tagged_ports_list', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'outer_vlan', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'tagged_ports_list', 'keyval': 'lif_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'egress-stats-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain_list=bridge_domain_list, outer_vlan_list=outer_vlan_list, tagged_ports_list=tagged_ports_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain_list=bridge_domain_list, outer_vlan_list=outer_vlan_list, tagged_ports_list=tagged_ports_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def bridge_domain_state_bridge_domain_list_outer_vlan_list_tagged_ports_list_encap_id_delete(self, bridge_domain_list=None, outer_vlan_list=None, tagged_ports_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bridge_domain_list: bd_id
    :param bridge_domain_list: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bridge_domain_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type outer_vlan_list: outer_vlan
    :param outer_vlan_list: Keyword argument tuple.

    :type outer_vlan: long
    :param outer_vlan: **outer_vlan_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type tagged_ports_list: lif_name
    :param tagged_ports_list: Keyword argument tuple.

    :type lif_name: unicode
    :param lif_name: **tagged_ports_list** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.bridge_domain_state.bridge_domain_list', u'bridge_domain_list'), ('pybind.slxos.v16r_1_00b.bridge_domain_state.bridge_domain_list.outer_vlan_list', u'outer_vlan_list')]
    bindings_list = [('pybind.slxos.v16r_1_00b.bridge_domain_state.bridge_domain_list.outer_vlan_list.tagged_ports_list', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'outer_vlan', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'tagged_ports_list', 'keyval': 'lif_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'encap-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain_list=bridge_domain_list, outer_vlan_list=outer_vlan_list, tagged_ports_list=tagged_ports_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain_list=bridge_domain_list, outer_vlan_list=outer_vlan_list, tagged_ports_list=tagged_ports_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def bridge_domain_state_bridge_domain_list_outer_vlan_list_tagged_ports_list_flags_delete(self, bridge_domain_list=None, outer_vlan_list=None, tagged_ports_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bridge_domain_list: bd_id
    :param bridge_domain_list: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bridge_domain_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type outer_vlan_list: outer_vlan
    :param outer_vlan_list: Keyword argument tuple.

    :type outer_vlan: long
    :param outer_vlan: **outer_vlan_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type tagged_ports_list: lif_name
    :param tagged_ports_list: Keyword argument tuple.

    :type lif_name: unicode
    :param lif_name: **tagged_ports_list** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.bridge_domain_state.bridge_domain_list', u'bridge_domain_list'), ('pybind.slxos.v16r_1_00b.bridge_domain_state.bridge_domain_list.outer_vlan_list', u'outer_vlan_list')]
    bindings_list = [('pybind.slxos.v16r_1_00b.bridge_domain_state.bridge_domain_list.outer_vlan_list.tagged_ports_list', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'outer_vlan', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'tagged_ports_list', 'keyval': 'lif_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'flags'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain_list=bridge_domain_list, outer_vlan_list=outer_vlan_list, tagged_ports_list=tagged_ports_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain_list=bridge_domain_list, outer_vlan_list=outer_vlan_list, tagged_ports_list=tagged_ports_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def bridge_domain_state_bridge_domain_list_outer_vlan_list_tagged_ports_list_ingress_stats_id_delete(self, bridge_domain_list=None, outer_vlan_list=None, tagged_ports_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bridge_domain_list: bd_id
    :param bridge_domain_list: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bridge_domain_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type outer_vlan_list: outer_vlan
    :param outer_vlan_list: Keyword argument tuple.

    :type outer_vlan: long
    :param outer_vlan: **outer_vlan_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type tagged_ports_list: lif_name
    :param tagged_ports_list: Keyword argument tuple.

    :type lif_name: unicode
    :param lif_name: **tagged_ports_list** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.bridge_domain_state.bridge_domain_list', u'bridge_domain_list'), ('pybind.slxos.v16r_1_00b.bridge_domain_state.bridge_domain_list.outer_vlan_list', u'outer_vlan_list')]
    bindings_list = [('pybind.slxos.v16r_1_00b.bridge_domain_state.bridge_domain_list.outer_vlan_list.tagged_ports_list', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'outer_vlan', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'tagged_ports_list', 'keyval': 'lif_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ingress-stats-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain_list=bridge_domain_list, outer_vlan_list=outer_vlan_list, tagged_ports_list=tagged_ports_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain_list=bridge_domain_list, outer_vlan_list=outer_vlan_list, tagged_ports_list=tagged_ports_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def bridge_domain_state_bridge_domain_list_outer_vlan_list_tagged_ports_list_inner_vlan_delete(self, bridge_domain_list=None, outer_vlan_list=None, tagged_ports_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bridge_domain_list: bd_id
    :param bridge_domain_list: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bridge_domain_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type outer_vlan_list: outer_vlan
    :param outer_vlan_list: Keyword argument tuple.

    :type outer_vlan: long
    :param outer_vlan: **outer_vlan_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type tagged_ports_list: lif_name
    :param tagged_ports_list: Keyword argument tuple.

    :type lif_name: unicode
    :param lif_name: **tagged_ports_list** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.bridge_domain_state.bridge_domain_list', u'bridge_domain_list'), ('pybind.slxos.v16r_1_00b.bridge_domain_state.bridge_domain_list.outer_vlan_list', u'outer_vlan_list')]
    bindings_list = [('pybind.slxos.v16r_1_00b.bridge_domain_state.bridge_domain_list.outer_vlan_list.tagged_ports_list', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'outer_vlan', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'tagged_ports_list', 'keyval': 'lif_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'inner-vlan'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain_list=bridge_domain_list, outer_vlan_list=outer_vlan_list, tagged_ports_list=tagged_ports_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain_list=bridge_domain_list, outer_vlan_list=outer_vlan_list, tagged_ports_list=tagged_ports_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def bridge_domain_state_bridge_domain_list_outer_vlan_list_tagged_ports_list_ivid_delete(self, bridge_domain_list=None, outer_vlan_list=None, tagged_ports_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bridge_domain_list: bd_id
    :param bridge_domain_list: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bridge_domain_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type outer_vlan_list: outer_vlan
    :param outer_vlan_list: Keyword argument tuple.

    :type outer_vlan: long
    :param outer_vlan: **outer_vlan_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type tagged_ports_list: lif_name
    :param tagged_ports_list: Keyword argument tuple.

    :type lif_name: unicode
    :param lif_name: **tagged_ports_list** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.bridge_domain_state.bridge_domain_list', u'bridge_domain_list'), ('pybind.slxos.v16r_1_00b.bridge_domain_state.bridge_domain_list.outer_vlan_list', u'outer_vlan_list')]
    bindings_list = [('pybind.slxos.v16r_1_00b.bridge_domain_state.bridge_domain_list.outer_vlan_list.tagged_ports_list', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'outer_vlan', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'tagged_ports_list', 'keyval': 'lif_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ivid'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain_list=bridge_domain_list, outer_vlan_list=outer_vlan_list, tagged_ports_list=tagged_ports_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain_list=bridge_domain_list, outer_vlan_list=outer_vlan_list, tagged_ports_list=tagged_ports_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def bridge_domain_state_bridge_domain_list_outer_vlan_list_tagged_ports_list_lif_ifindex_delete(self, bridge_domain_list=None, outer_vlan_list=None, tagged_ports_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bridge_domain_list: bd_id
    :param bridge_domain_list: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bridge_domain_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type outer_vlan_list: outer_vlan
    :param outer_vlan_list: Keyword argument tuple.

    :type outer_vlan: long
    :param outer_vlan: **outer_vlan_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type tagged_ports_list: lif_name
    :param tagged_ports_list: Keyword argument tuple.

    :type lif_name: unicode
    :param lif_name: **tagged_ports_list** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.bridge_domain_state.bridge_domain_list', u'bridge_domain_list'), ('pybind.slxos.v16r_1_00b.bridge_domain_state.bridge_domain_list.outer_vlan_list', u'outer_vlan_list')]
    bindings_list = [('pybind.slxos.v16r_1_00b.bridge_domain_state.bridge_domain_list.outer_vlan_list.tagged_ports_list', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'outer_vlan', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'tagged_ports_list', 'keyval': 'lif_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lif-ifindex'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain_list=bridge_domain_list, outer_vlan_list=outer_vlan_list, tagged_ports_list=tagged_ports_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain_list=bridge_domain_list, outer_vlan_list=outer_vlan_list, tagged_ports_list=tagged_ports_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def bridge_domain_state_bridge_domain_list_outer_vlan_list_tagged_ports_list_op_state_delete(self, bridge_domain_list=None, outer_vlan_list=None, tagged_ports_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bridge_domain_list: bd_id
    :param bridge_domain_list: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bridge_domain_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type outer_vlan_list: outer_vlan
    :param outer_vlan_list: Keyword argument tuple.

    :type outer_vlan: long
    :param outer_vlan: **outer_vlan_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type tagged_ports_list: lif_name
    :param tagged_ports_list: Keyword argument tuple.

    :type lif_name: unicode
    :param lif_name: **tagged_ports_list** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.bridge_domain_state.bridge_domain_list', u'bridge_domain_list'), ('pybind.slxos.v16r_1_00b.bridge_domain_state.bridge_domain_list.outer_vlan_list', u'outer_vlan_list')]
    bindings_list = [('pybind.slxos.v16r_1_00b.bridge_domain_state.bridge_domain_list.outer_vlan_list.tagged_ports_list', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'outer_vlan', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'tagged_ports_list', 'keyval': 'lif_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'op-state'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain_list=bridge_domain_list, outer_vlan_list=outer_vlan_list, tagged_ports_list=tagged_ports_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain_list=bridge_domain_list, outer_vlan_list=outer_vlan_list, tagged_ports_list=tagged_ports_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def bridge_domain_state_bridge_domain_list_outer_vlan_list_tagged_ports_list_outer_vlan_delete(self, bridge_domain_list=None, outer_vlan_list=None, tagged_ports_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bridge_domain_list: bd_id
    :param bridge_domain_list: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bridge_domain_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type outer_vlan_list: outer_vlan
    :param outer_vlan_list: Keyword argument tuple.

    :type outer_vlan: long
    :param outer_vlan: **outer_vlan_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type tagged_ports_list: lif_name
    :param tagged_ports_list: Keyword argument tuple.

    :type lif_name: unicode
    :param lif_name: **tagged_ports_list** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.bridge_domain_state.bridge_domain_list', u'bridge_domain_list'), ('pybind.slxos.v16r_1_00b.bridge_domain_state.bridge_domain_list.outer_vlan_list', u'outer_vlan_list')]
    bindings_list = [('pybind.slxos.v16r_1_00b.bridge_domain_state.bridge_domain_list.outer_vlan_list.tagged_ports_list', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'outer_vlan', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'tagged_ports_list', 'keyval': 'lif_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'outer-vlan'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain_list=bridge_domain_list, outer_vlan_list=outer_vlan_list, tagged_ports_list=tagged_ports_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain_list=bridge_domain_list, outer_vlan_list=outer_vlan_list, tagged_ports_list=tagged_ports_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def bridge_domain_state_bridge_domain_list_outer_vlan_list_tagged_ports_list_service_instance_delete(self, bridge_domain_list=None, outer_vlan_list=None, tagged_ports_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bridge_domain_list: bd_id
    :param bridge_domain_list: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bridge_domain_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type outer_vlan_list: outer_vlan
    :param outer_vlan_list: Keyword argument tuple.

    :type outer_vlan: long
    :param outer_vlan: **outer_vlan_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type tagged_ports_list: lif_name
    :param tagged_ports_list: Keyword argument tuple.

    :type lif_name: unicode
    :param lif_name: **tagged_ports_list** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.bridge_domain_state.bridge_domain_list', u'bridge_domain_list'), ('pybind.slxos.v16r_1_00b.bridge_domain_state.bridge_domain_list.outer_vlan_list', u'outer_vlan_list')]
    bindings_list = [('pybind.slxos.v16r_1_00b.bridge_domain_state.bridge_domain_list.outer_vlan_list.tagged_ports_list', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'outer_vlan', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'tagged_ports_list', 'keyval': 'lif_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'service-instance'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain_list=bridge_domain_list, outer_vlan_list=outer_vlan_list, tagged_ports_list=tagged_ports_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain_list=bridge_domain_list, outer_vlan_list=outer_vlan_list, tagged_ports_list=tagged_ports_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def bridge_domain_state_bridge_domain_list_outer_vlan_list_untagged_ports_list_delete(self, bridge_domain_list=None, outer_vlan_list=None, untagged_ports_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bridge_domain_list: bd_id
    :param bridge_domain_list: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bridge_domain_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type outer_vlan_list: outer_vlan
    :param outer_vlan_list: Keyword argument tuple.

    :type outer_vlan: long
    :param outer_vlan: **outer_vlan_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type untagged_ports_list: lif_name
    :param untagged_ports_list: Keyword argument tuple.

    :type lif_name: unicode
    :param lif_name: **untagged_ports_list** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.bridge_domain_state.bridge_domain_list', u'bridge_domain_list'), ('pybind.slxos.v16r_1_00b.bridge_domain_state.bridge_domain_list.outer_vlan_list', u'outer_vlan_list')]
    bindings_list = [('pybind.slxos.v16r_1_00b.bridge_domain_state.bridge_domain_list.outer_vlan_list.untagged_ports_list', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'outer_vlan', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'untagged_ports_list', 'keyval': 'lif_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain_list=bridge_domain_list, outer_vlan_list=outer_vlan_list, untagged_ports_list=untagged_ports_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain_list=bridge_domain_list, outer_vlan_list=outer_vlan_list, untagged_ports_list=untagged_ports_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def bridge_domain_state_bridge_domain_list_outer_vlan_list_untagged_ports_list_egress_stats_id_delete(self, bridge_domain_list=None, outer_vlan_list=None, untagged_ports_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bridge_domain_list: bd_id
    :param bridge_domain_list: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bridge_domain_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type outer_vlan_list: outer_vlan
    :param outer_vlan_list: Keyword argument tuple.

    :type outer_vlan: long
    :param outer_vlan: **outer_vlan_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type untagged_ports_list: lif_name
    :param untagged_ports_list: Keyword argument tuple.

    :type lif_name: unicode
    :param lif_name: **untagged_ports_list** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.bridge_domain_state.bridge_domain_list', u'bridge_domain_list'), ('pybind.slxos.v16r_1_00b.bridge_domain_state.bridge_domain_list.outer_vlan_list', u'outer_vlan_list')]
    bindings_list = [('pybind.slxos.v16r_1_00b.bridge_domain_state.bridge_domain_list.outer_vlan_list.untagged_ports_list', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'outer_vlan', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'untagged_ports_list', 'keyval': 'lif_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'egress-stats-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain_list=bridge_domain_list, outer_vlan_list=outer_vlan_list, untagged_ports_list=untagged_ports_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain_list=bridge_domain_list, outer_vlan_list=outer_vlan_list, untagged_ports_list=untagged_ports_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def bridge_domain_state_bridge_domain_list_outer_vlan_list_untagged_ports_list_encap_id_delete(self, bridge_domain_list=None, outer_vlan_list=None, untagged_ports_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bridge_domain_list: bd_id
    :param bridge_domain_list: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bridge_domain_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type outer_vlan_list: outer_vlan
    :param outer_vlan_list: Keyword argument tuple.

    :type outer_vlan: long
    :param outer_vlan: **outer_vlan_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type untagged_ports_list: lif_name
    :param untagged_ports_list: Keyword argument tuple.

    :type lif_name: unicode
    :param lif_name: **untagged_ports_list** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.bridge_domain_state.bridge_domain_list', u'bridge_domain_list'), ('pybind.slxos.v16r_1_00b.bridge_domain_state.bridge_domain_list.outer_vlan_list', u'outer_vlan_list')]
    bindings_list = [('pybind.slxos.v16r_1_00b.bridge_domain_state.bridge_domain_list.outer_vlan_list.untagged_ports_list', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'outer_vlan', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'untagged_ports_list', 'keyval': 'lif_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'encap-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain_list=bridge_domain_list, outer_vlan_list=outer_vlan_list, untagged_ports_list=untagged_ports_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain_list=bridge_domain_list, outer_vlan_list=outer_vlan_list, untagged_ports_list=untagged_ports_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def bridge_domain_state_bridge_domain_list_outer_vlan_list_untagged_ports_list_flags_delete(self, bridge_domain_list=None, outer_vlan_list=None, untagged_ports_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bridge_domain_list: bd_id
    :param bridge_domain_list: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bridge_domain_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type outer_vlan_list: outer_vlan
    :param outer_vlan_list: Keyword argument tuple.

    :type outer_vlan: long
    :param outer_vlan: **outer_vlan_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type untagged_ports_list: lif_name
    :param untagged_ports_list: Keyword argument tuple.

    :type lif_name: unicode
    :param lif_name: **untagged_ports_list** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.bridge_domain_state.bridge_domain_list', u'bridge_domain_list'), ('pybind.slxos.v16r_1_00b.bridge_domain_state.bridge_domain_list.outer_vlan_list', u'outer_vlan_list')]
    bindings_list = [('pybind.slxos.v16r_1_00b.bridge_domain_state.bridge_domain_list.outer_vlan_list.untagged_ports_list', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'outer_vlan', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'untagged_ports_list', 'keyval': 'lif_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'flags'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain_list=bridge_domain_list, outer_vlan_list=outer_vlan_list, untagged_ports_list=untagged_ports_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain_list=bridge_domain_list, outer_vlan_list=outer_vlan_list, untagged_ports_list=untagged_ports_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def bridge_domain_state_bridge_domain_list_outer_vlan_list_untagged_ports_list_ingress_stats_id_delete(self, bridge_domain_list=None, outer_vlan_list=None, untagged_ports_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bridge_domain_list: bd_id
    :param bridge_domain_list: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bridge_domain_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type outer_vlan_list: outer_vlan
    :param outer_vlan_list: Keyword argument tuple.

    :type outer_vlan: long
    :param outer_vlan: **outer_vlan_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type untagged_ports_list: lif_name
    :param untagged_ports_list: Keyword argument tuple.

    :type lif_name: unicode
    :param lif_name: **untagged_ports_list** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.bridge_domain_state.bridge_domain_list', u'bridge_domain_list'), ('pybind.slxos.v16r_1_00b.bridge_domain_state.bridge_domain_list.outer_vlan_list', u'outer_vlan_list')]
    bindings_list = [('pybind.slxos.v16r_1_00b.bridge_domain_state.bridge_domain_list.outer_vlan_list.untagged_ports_list', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'outer_vlan', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'untagged_ports_list', 'keyval': 'lif_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ingress-stats-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain_list=bridge_domain_list, outer_vlan_list=outer_vlan_list, untagged_ports_list=untagged_ports_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain_list=bridge_domain_list, outer_vlan_list=outer_vlan_list, untagged_ports_list=untagged_ports_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def bridge_domain_state_bridge_domain_list_outer_vlan_list_untagged_ports_list_ivid_delete(self, bridge_domain_list=None, outer_vlan_list=None, untagged_ports_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bridge_domain_list: bd_id
    :param bridge_domain_list: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bridge_domain_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type outer_vlan_list: outer_vlan
    :param outer_vlan_list: Keyword argument tuple.

    :type outer_vlan: long
    :param outer_vlan: **outer_vlan_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type untagged_ports_list: lif_name
    :param untagged_ports_list: Keyword argument tuple.

    :type lif_name: unicode
    :param lif_name: **untagged_ports_list** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.bridge_domain_state.bridge_domain_list', u'bridge_domain_list'), ('pybind.slxos.v16r_1_00b.bridge_domain_state.bridge_domain_list.outer_vlan_list', u'outer_vlan_list')]
    bindings_list = [('pybind.slxos.v16r_1_00b.bridge_domain_state.bridge_domain_list.outer_vlan_list.untagged_ports_list', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'outer_vlan', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'untagged_ports_list', 'keyval': 'lif_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ivid'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain_list=bridge_domain_list, outer_vlan_list=outer_vlan_list, untagged_ports_list=untagged_ports_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain_list=bridge_domain_list, outer_vlan_list=outer_vlan_list, untagged_ports_list=untagged_ports_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def bridge_domain_state_bridge_domain_list_outer_vlan_list_untagged_ports_list_lif_ifindex_delete(self, bridge_domain_list=None, outer_vlan_list=None, untagged_ports_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bridge_domain_list: bd_id
    :param bridge_domain_list: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bridge_domain_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type outer_vlan_list: outer_vlan
    :param outer_vlan_list: Keyword argument tuple.

    :type outer_vlan: long
    :param outer_vlan: **outer_vlan_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type untagged_ports_list: lif_name
    :param untagged_ports_list: Keyword argument tuple.

    :type lif_name: unicode
    :param lif_name: **untagged_ports_list** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.bridge_domain_state.bridge_domain_list', u'bridge_domain_list'), ('pybind.slxos.v16r_1_00b.bridge_domain_state.bridge_domain_list.outer_vlan_list', u'outer_vlan_list')]
    bindings_list = [('pybind.slxos.v16r_1_00b.bridge_domain_state.bridge_domain_list.outer_vlan_list.untagged_ports_list', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'outer_vlan', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'untagged_ports_list', 'keyval': 'lif_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lif-ifindex'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain_list=bridge_domain_list, outer_vlan_list=outer_vlan_list, untagged_ports_list=untagged_ports_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain_list=bridge_domain_list, outer_vlan_list=outer_vlan_list, untagged_ports_list=untagged_ports_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def bridge_domain_state_bridge_domain_list_outer_vlan_list_untagged_ports_list_op_state_delete(self, bridge_domain_list=None, outer_vlan_list=None, untagged_ports_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bridge_domain_list: bd_id
    :param bridge_domain_list: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bridge_domain_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type outer_vlan_list: outer_vlan
    :param outer_vlan_list: Keyword argument tuple.

    :type outer_vlan: long
    :param outer_vlan: **outer_vlan_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type untagged_ports_list: lif_name
    :param untagged_ports_list: Keyword argument tuple.

    :type lif_name: unicode
    :param lif_name: **untagged_ports_list** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.bridge_domain_state.bridge_domain_list', u'bridge_domain_list'), ('pybind.slxos.v16r_1_00b.bridge_domain_state.bridge_domain_list.outer_vlan_list', u'outer_vlan_list')]
    bindings_list = [('pybind.slxos.v16r_1_00b.bridge_domain_state.bridge_domain_list.outer_vlan_list.untagged_ports_list', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'outer_vlan', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'untagged_ports_list', 'keyval': 'lif_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'op-state'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain_list=bridge_domain_list, outer_vlan_list=outer_vlan_list, untagged_ports_list=untagged_ports_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain_list=bridge_domain_list, outer_vlan_list=outer_vlan_list, untagged_ports_list=untagged_ports_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def bridge_domain_state_bridge_domain_list_outer_vlan_list_untagged_ports_list_outer_vlan_delete(self, bridge_domain_list=None, outer_vlan_list=None, untagged_ports_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bridge_domain_list: bd_id
    :param bridge_domain_list: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bridge_domain_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type outer_vlan_list: outer_vlan
    :param outer_vlan_list: Keyword argument tuple.

    :type outer_vlan: long
    :param outer_vlan: **outer_vlan_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type untagged_ports_list: lif_name
    :param untagged_ports_list: Keyword argument tuple.

    :type lif_name: unicode
    :param lif_name: **untagged_ports_list** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.bridge_domain_state.bridge_domain_list', u'bridge_domain_list'), ('pybind.slxos.v16r_1_00b.bridge_domain_state.bridge_domain_list.outer_vlan_list', u'outer_vlan_list')]
    bindings_list = [('pybind.slxos.v16r_1_00b.bridge_domain_state.bridge_domain_list.outer_vlan_list.untagged_ports_list', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'outer_vlan', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'untagged_ports_list', 'keyval': 'lif_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'outer-vlan'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain_list=bridge_domain_list, outer_vlan_list=outer_vlan_list, untagged_ports_list=untagged_ports_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain_list=bridge_domain_list, outer_vlan_list=outer_vlan_list, untagged_ports_list=untagged_ports_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def bridge_domain_state_bridge_domain_list_outer_vlan_list_untagged_ports_list_service_instance_delete(self, bridge_domain_list=None, outer_vlan_list=None, untagged_ports_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bridge_domain_list: bd_id
    :param bridge_domain_list: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bridge_domain_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type outer_vlan_list: outer_vlan
    :param outer_vlan_list: Keyword argument tuple.

    :type outer_vlan: long
    :param outer_vlan: **outer_vlan_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type untagged_ports_list: lif_name
    :param untagged_ports_list: Keyword argument tuple.

    :type lif_name: unicode
    :param lif_name: **untagged_ports_list** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.bridge_domain_state.bridge_domain_list', u'bridge_domain_list'), ('pybind.slxos.v16r_1_00b.bridge_domain_state.bridge_domain_list.outer_vlan_list', u'outer_vlan_list')]
    bindings_list = [('pybind.slxos.v16r_1_00b.bridge_domain_state.bridge_domain_list.outer_vlan_list.untagged_ports_list', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'outer_vlan', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'untagged_ports_list', 'keyval': 'lif_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'service-instance'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain_list=bridge_domain_list, outer_vlan_list=outer_vlan_list, untagged_ports_list=untagged_ports_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain_list=bridge_domain_list, outer_vlan_list=outer_vlan_list, untagged_ports_list=untagged_ports_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def bridge_domain_state_bridge_domain_list_pw_profile_delete(self, bridge_domain_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type bridge_domain_list: bd_id
    :param bridge_domain_list: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bridge_domain_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.bridge_domain_state.bridge_domain_list', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'bridge_domain_list', 'keyval': 'bd_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'pw-profile'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain_list=bridge_domain_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain_list=bridge_domain_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def bridge_domain_state_bridge_domain_list_statistics_delete(self, bridge_domain_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type bridge_domain_list: bd_id
    :param bridge_domain_list: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bridge_domain_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.bridge_domain_state.bridge_domain_list', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'bridge_domain_list', 'keyval': 'bd_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'statistics'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain_list=bridge_domain_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain_list=bridge_domain_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def bridge_domain_state_bridge_domain_list_vc_id_delete(self, bridge_domain_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type bridge_domain_list: bd_id
    :param bridge_domain_list: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bridge_domain_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.bridge_domain_state.bridge_domain_list', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'bridge_domain_list', 'keyval': 'bd_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vc-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain_list=bridge_domain_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain_list=bridge_domain_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def bridge_domain_state_bridge_domain_list_ve_ifindex_delete(self, bridge_domain_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type bridge_domain_list: bd_id
    :param bridge_domain_list: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bridge_domain_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.bridge_domain_state.bridge_domain_list', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'bridge_domain_list', 'keyval': 'bd_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 've-ifindex'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain_list=bridge_domain_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain_list=bridge_domain_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def bridge_domain_statistics_delete(self, bridge_domain=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type bridge_domain: bridge_domain_id, bridge_domain_type
    :param bridge_domain: Keyword argument tuple.

    :type bridge_domain_id: long
    :param bridge_domain_id: **bridge_domain** tuple argument:  Bridge-domain ID.

        * range restriction: ::

            ['0..4294967295']

    :type bridge_domain_type: unicode
    :param bridge_domain_type: **bridge_domain** tuple argument:  Set the Bridge Domain Type

        * enumeration restriction: ::

            ['p2mp', 'p2p']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.bridge_domain', 'pybind.slxos.v16r_1_00b.brocade_bridge_domain', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'bridge_domain', 'keyval': 'bridge_domain_id, bridge_domain_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'statistics'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain=bridge_domain)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain=bridge_domain)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def bridge_domain_vc_id_delete(self, bridge_domain=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type bridge_domain: bridge_domain_id, bridge_domain_type
    :param bridge_domain: Keyword argument tuple.

    :type bridge_domain_id: long
    :param bridge_domain_id: **bridge_domain** tuple argument:  Bridge-domain ID.

        * range restriction: ::

            ['0..4294967295']

    :type bridge_domain_type: unicode
    :param bridge_domain_type: **bridge_domain** tuple argument:  Set the Bridge Domain Type

        * enumeration restriction: ::

            ['p2mp', 'p2p']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.bridge_domain', 'pybind.slxos.v16r_1_00b.brocade_bridge_domain', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'bridge_domain', 'keyval': 'bridge_domain_id, bridge_domain_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vc-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain=bridge_domain)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain=bridge_domain)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def capabilities_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.capabilities', 'pybind.slxos.v16r_1_00b.brocade_system_capabilities', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def capabilities_ipv6_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.capabilities.ipv6', 'pybind.slxos.v16r_1_00b.brocade_system_capabilities', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def capabilities_ipv6_ipv6raguard_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.capabilities.ipv6', 'pybind.slxos.v16r_1_00b.brocade_system_capabilities', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ipv6Raguard'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def capabilities_l2_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.capabilities.l2', 'pybind.slxos.v16r_1_00b.brocade_system_capabilities', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def capabilities_l2_consistency_check_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.capabilities.l2', 'pybind.slxos.v16r_1_00b.brocade_system_capabilities', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'consistency_check'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def capabilities_l2_internal_nsm_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.capabilities.l2', 'pybind.slxos.v16r_1_00b.brocade_system_capabilities', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'internal_nsm'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def capabilities_l2_learning_mode_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.capabilities.l2', 'pybind.slxos.v16r_1_00b.brocade_system_capabilities', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'learning_mode'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def capabilities_l2_mac_move_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.capabilities.l2', 'pybind.slxos.v16r_1_00b.brocade_system_capabilities', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mac_move'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def capabilities_l2_overlap_vlan_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.capabilities.l2', 'pybind.slxos.v16r_1_00b.brocade_system_capabilities', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'overlap_vlan'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def capabilities_l2_port_profile_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.capabilities.l2', 'pybind.slxos.v16r_1_00b.brocade_system_capabilities', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'port_profile'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def capabilities_l2_priority_tag_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.capabilities.l2', 'pybind.slxos.v16r_1_00b.brocade_system_capabilities', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority_tag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def capabilities_l2_rspan_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.capabilities.l2', 'pybind.slxos.v16r_1_00b.brocade_system_capabilities', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rspan'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def capabilities_lag_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.capabilities.lag', 'pybind.slxos.v16r_1_00b.brocade_system_capabilities', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def capabilities_lag_portchannelredundancy_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.capabilities.lag', 'pybind.slxos.v16r_1_00b.brocade_system_capabilities', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'PortchannelRedundancy'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def capabilities_mqc_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.capabilities.mqc', 'pybind.slxos.v16r_1_00b.brocade_system_capabilities', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def capabilities_mqc_span_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.capabilities.mqc', 'pybind.slxos.v16r_1_00b.brocade_system_capabilities', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'span'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def capabilities_ssm_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.capabilities.ssm', 'pybind.slxos.v16r_1_00b.brocade_system_capabilities', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def capabilities_ssm_acltraffictype_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.capabilities.ssm', 'pybind.slxos.v16r_1_00b.brocade_system_capabilities', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'aclTrafficType'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cee_map_delete(self, cee_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type cee_map: name
    :param cee_map: Keyword argument tuple.

    :type name: unicode
    :param name: **cee_map** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.cee_map', 'pybind.nos.v6_0_2c.brocade_cee_map', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.cee_map', 'pybind.nos.v7_0_1b.brocade_cee_map', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.cee_map', 'pybind.nos.v7_1_0.brocade_cee_map', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.cee_map', 'pybind.slxos.v16r_1_00b.brocade_qos_cee', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'cee_map', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cee_map=cee_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cee_map=cee_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cee_map_precedence_delete(self, cee_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type cee_map: name
    :param cee_map: Keyword argument tuple.

    :type name: unicode
    :param name: **cee_map** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.cee_map', 'pybind.nos.v6_0_2c.brocade_cee_map', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.cee_map', 'pybind.nos.v7_0_1b.brocade_cee_map', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.cee_map', 'pybind.nos.v7_1_0.brocade_cee_map', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.cee_map', 'pybind.slxos.v16r_1_00b.brocade_qos_cee', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'cee_map', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'precedence'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cee_map=cee_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cee_map=cee_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cee_map_priority_group_table_delete(self, cee_map=None, priority_group_table=None, weight=None, pfc=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cee_map: name
    :param cee_map: Keyword argument tuple.

    :type name: unicode
    :param name: **cee_map** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    **Instance Keyword Argument Tuple**:

    :type priority_group_table: PGID, weight, pfc
    :param priority_group_table: Keyword argument tuple.

    :type PGID: unicode
    :param PGID: **priority_group_table** tuple argument:  ;; Configure Priority Group (PGID 0-7,15.0-15.7)

        * pattern restriction: ::

            '[0-7]|15.[0-7]'

    :type weight: long
    :param weight: **priority_group_table** tuple argument:  Configure DWRR Priority Group (PGID 0-7) weight

        * range restriction: ::

            ['-2147483648..2147483647']

    :type pfc: unicode
    :param pfc: **priority_group_table** tuple argument:   Per-priority Flow Control

        * enumeration restriction: ::

            ['on', 'off']

    **Instance Argument(s)**:

    :type weight: long
    :param weight: Configure DWRR Priority Group (PGID 0-7) weight

        * range restriction: ::

            ['-2147483648..2147483647']

    :type pfc: unicode
    :param pfc:  Per-priority Flow Control

        * enumeration restriction: ::

            ['on', 'off']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.cee_map', 'cee_map'), ('pybind.nos.v7_0_1b.cee_map', 'cee_map'), ('pybind.slxos.v16r_1_00b.cee_map', 'cee_map'), ('pybind.nos.v6_0_2c.cee_map', 'cee_map')]
    bindings_list = [('pybind.nos.v6_0_2c.cee_map.priority_group_table', 'pybind.nos.v6_0_2c.brocade_cee_map', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.cee_map.priority_group_table', 'pybind.nos.v7_0_1b.brocade_cee_map', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.cee_map.priority_group_table', 'pybind.nos.v7_1_0.brocade_cee_map', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.cee_map.priority_group_table', 'pybind.slxos.v16r_1_00b.brocade_qos_cee', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'priority_group_table', 'keyval': 'PGID', 'extra_keyval': 'PGID, weight, pfc'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cee_map=cee_map, priority_group_table=priority_group_table, weight=weight, pfc=pfc)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cee_map=cee_map, priority_group_table=priority_group_table, weight=weight, pfc=pfc)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cee_map_priority_group_table_pfc_delete(self, cee_map=None, priority_group_table=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cee_map: name
    :param cee_map: Keyword argument tuple.

    :type name: unicode
    :param name: **cee_map** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    **Instance Keyword Argument Tuple**:

    :type priority_group_table: PGID
    :param priority_group_table: Keyword argument tuple.

    :type PGID: unicode
    :param PGID: **priority_group_table** tuple argument:  ;; Configure Priority Group (PGID 0-7,15.0-15.7)

        * pattern restriction: ::

            '[0-7]|15.[0-7]'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.cee_map', 'cee_map'), ('pybind.nos.v7_0_1b.cee_map', 'cee_map'), ('pybind.slxos.v16r_1_00b.cee_map', 'cee_map'), ('pybind.nos.v6_0_2c.cee_map', 'cee_map')]
    bindings_list = [('pybind.nos.v6_0_2c.cee_map.priority_group_table', 'pybind.nos.v6_0_2c.brocade_cee_map', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.cee_map.priority_group_table', 'pybind.nos.v7_0_1b.brocade_cee_map', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.cee_map.priority_group_table', 'pybind.nos.v7_1_0.brocade_cee_map', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.cee_map.priority_group_table', 'pybind.slxos.v16r_1_00b.brocade_qos_cee', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'priority_group_table', 'keyval': 'PGID', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'pfc'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cee_map=cee_map, priority_group_table=priority_group_table)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cee_map=cee_map, priority_group_table=priority_group_table)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cee_map_priority_group_table_weight_delete(self, cee_map=None, priority_group_table=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cee_map: name
    :param cee_map: Keyword argument tuple.

    :type name: unicode
    :param name: **cee_map** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    **Instance Keyword Argument Tuple**:

    :type priority_group_table: PGID
    :param priority_group_table: Keyword argument tuple.

    :type PGID: unicode
    :param PGID: **priority_group_table** tuple argument:  ;; Configure Priority Group (PGID 0-7,15.0-15.7)

        * pattern restriction: ::

            '[0-7]|15.[0-7]'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.cee_map', 'cee_map'), ('pybind.nos.v7_0_1b.cee_map', 'cee_map'), ('pybind.slxos.v16r_1_00b.cee_map', 'cee_map'), ('pybind.nos.v6_0_2c.cee_map', 'cee_map')]
    bindings_list = [('pybind.nos.v6_0_2c.cee_map.priority_group_table', 'pybind.nos.v6_0_2c.brocade_cee_map', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.cee_map.priority_group_table', 'pybind.nos.v7_0_1b.brocade_cee_map', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.cee_map.priority_group_table', 'pybind.nos.v7_1_0.brocade_cee_map', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.cee_map.priority_group_table', 'pybind.slxos.v16r_1_00b.brocade_qos_cee', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'priority_group_table', 'keyval': 'PGID', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'weight'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cee_map=cee_map, priority_group_table=priority_group_table)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cee_map=cee_map, priority_group_table=priority_group_table)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cee_map_priority_table_delete(self, cee_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cee_map: name
    :param cee_map: Keyword argument tuple.

    :type name: unicode
    :param name: **cee_map** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.cee_map', 'cee_map'), ('pybind.nos.v6_0_2c.cee_map', 'cee_map'), ('pybind.nos.v7_0_1b.cee_map', 'cee_map'), ('pybind.slxos.v16r_1_00b.cee_map', 'cee_map')]
    bindings_list = [('pybind.nos.v6_0_2c.cee_map.priority_table', 'pybind.nos.v6_0_2c.brocade_cee_map', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.cee_map.priority_table', 'pybind.nos.v7_0_1b.brocade_cee_map', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.cee_map.priority_table', 'pybind.nos.v7_1_0.brocade_cee_map', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.cee_map.priority_table', 'pybind.slxos.v16r_1_00b.brocade_qos_cee', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'map_cos0_pgid, map_cos1_pgid, map_cos2_pgid, map_cos3_pgid, map_cos4_pgid, map_cos5_pgid, map_cos6_pgid, map_cos7_pgid'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cee_map=cee_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cee_map=cee_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cee_map_priority_table_map_cos0_pgid_delete(self, cee_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cee_map: name
    :param cee_map: Keyword argument tuple.

    :type name: unicode
    :param name: **cee_map** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.cee_map', 'cee_map'), ('pybind.nos.v6_0_2c.cee_map', 'cee_map'), ('pybind.nos.v7_0_1b.cee_map', 'cee_map'), ('pybind.slxos.v16r_1_00b.cee_map', 'cee_map')]
    bindings_list = [('pybind.nos.v6_0_2c.cee_map.priority_table', 'pybind.nos.v6_0_2c.brocade_cee_map', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.cee_map.priority_table', 'pybind.nos.v7_0_1b.brocade_cee_map', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.cee_map.priority_table', 'pybind.nos.v7_1_0.brocade_cee_map', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.cee_map.priority_table', 'pybind.slxos.v16r_1_00b.brocade_qos_cee', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'map-cos0-pgid'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cee_map=cee_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cee_map=cee_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cee_map_priority_table_map_cos1_pgid_delete(self, cee_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cee_map: name
    :param cee_map: Keyword argument tuple.

    :type name: unicode
    :param name: **cee_map** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.cee_map', 'cee_map'), ('pybind.nos.v6_0_2c.cee_map', 'cee_map'), ('pybind.nos.v7_0_1b.cee_map', 'cee_map'), ('pybind.slxos.v16r_1_00b.cee_map', 'cee_map')]
    bindings_list = [('pybind.nos.v6_0_2c.cee_map.priority_table', 'pybind.nos.v6_0_2c.brocade_cee_map', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.cee_map.priority_table', 'pybind.nos.v7_0_1b.brocade_cee_map', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.cee_map.priority_table', 'pybind.nos.v7_1_0.brocade_cee_map', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.cee_map.priority_table', 'pybind.slxos.v16r_1_00b.brocade_qos_cee', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'map-cos1-pgid'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cee_map=cee_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cee_map=cee_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cee_map_priority_table_map_cos2_pgid_delete(self, cee_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cee_map: name
    :param cee_map: Keyword argument tuple.

    :type name: unicode
    :param name: **cee_map** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.cee_map', 'cee_map'), ('pybind.nos.v6_0_2c.cee_map', 'cee_map'), ('pybind.nos.v7_0_1b.cee_map', 'cee_map'), ('pybind.slxos.v16r_1_00b.cee_map', 'cee_map')]
    bindings_list = [('pybind.nos.v6_0_2c.cee_map.priority_table', 'pybind.nos.v6_0_2c.brocade_cee_map', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.cee_map.priority_table', 'pybind.nos.v7_0_1b.brocade_cee_map', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.cee_map.priority_table', 'pybind.nos.v7_1_0.brocade_cee_map', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.cee_map.priority_table', 'pybind.slxos.v16r_1_00b.brocade_qos_cee', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'map-cos2-pgid'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cee_map=cee_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cee_map=cee_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cee_map_priority_table_map_cos3_pgid_delete(self, cee_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cee_map: name
    :param cee_map: Keyword argument tuple.

    :type name: unicode
    :param name: **cee_map** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.cee_map', 'cee_map'), ('pybind.nos.v6_0_2c.cee_map', 'cee_map'), ('pybind.nos.v7_0_1b.cee_map', 'cee_map'), ('pybind.slxos.v16r_1_00b.cee_map', 'cee_map')]
    bindings_list = [('pybind.nos.v6_0_2c.cee_map.priority_table', 'pybind.nos.v6_0_2c.brocade_cee_map', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.cee_map.priority_table', 'pybind.nos.v7_0_1b.brocade_cee_map', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.cee_map.priority_table', 'pybind.nos.v7_1_0.brocade_cee_map', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.cee_map.priority_table', 'pybind.slxos.v16r_1_00b.brocade_qos_cee', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'map-cos3-pgid'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cee_map=cee_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cee_map=cee_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cee_map_priority_table_map_cos4_pgid_delete(self, cee_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cee_map: name
    :param cee_map: Keyword argument tuple.

    :type name: unicode
    :param name: **cee_map** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.cee_map', 'cee_map'), ('pybind.nos.v6_0_2c.cee_map', 'cee_map'), ('pybind.nos.v7_0_1b.cee_map', 'cee_map'), ('pybind.slxos.v16r_1_00b.cee_map', 'cee_map')]
    bindings_list = [('pybind.nos.v6_0_2c.cee_map.priority_table', 'pybind.nos.v6_0_2c.brocade_cee_map', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.cee_map.priority_table', 'pybind.nos.v7_0_1b.brocade_cee_map', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.cee_map.priority_table', 'pybind.nos.v7_1_0.brocade_cee_map', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.cee_map.priority_table', 'pybind.slxos.v16r_1_00b.brocade_qos_cee', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'map-cos4-pgid'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cee_map=cee_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cee_map=cee_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cee_map_priority_table_map_cos5_pgid_delete(self, cee_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cee_map: name
    :param cee_map: Keyword argument tuple.

    :type name: unicode
    :param name: **cee_map** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.cee_map', 'cee_map'), ('pybind.nos.v6_0_2c.cee_map', 'cee_map'), ('pybind.nos.v7_0_1b.cee_map', 'cee_map'), ('pybind.slxos.v16r_1_00b.cee_map', 'cee_map')]
    bindings_list = [('pybind.nos.v6_0_2c.cee_map.priority_table', 'pybind.nos.v6_0_2c.brocade_cee_map', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.cee_map.priority_table', 'pybind.nos.v7_0_1b.brocade_cee_map', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.cee_map.priority_table', 'pybind.nos.v7_1_0.brocade_cee_map', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.cee_map.priority_table', 'pybind.slxos.v16r_1_00b.brocade_qos_cee', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'map-cos5-pgid'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cee_map=cee_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cee_map=cee_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cee_map_priority_table_map_cos6_pgid_delete(self, cee_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cee_map: name
    :param cee_map: Keyword argument tuple.

    :type name: unicode
    :param name: **cee_map** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.cee_map', 'cee_map'), ('pybind.nos.v6_0_2c.cee_map', 'cee_map'), ('pybind.nos.v7_0_1b.cee_map', 'cee_map'), ('pybind.slxos.v16r_1_00b.cee_map', 'cee_map')]
    bindings_list = [('pybind.nos.v6_0_2c.cee_map.priority_table', 'pybind.nos.v6_0_2c.brocade_cee_map', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.cee_map.priority_table', 'pybind.nos.v7_0_1b.brocade_cee_map', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.cee_map.priority_table', 'pybind.nos.v7_1_0.brocade_cee_map', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.cee_map.priority_table', 'pybind.slxos.v16r_1_00b.brocade_qos_cee', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'map-cos6-pgid'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cee_map=cee_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cee_map=cee_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cee_map_priority_table_map_cos7_pgid_delete(self, cee_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cee_map: name
    :param cee_map: Keyword argument tuple.

    :type name: unicode
    :param name: **cee_map** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.cee_map', 'cee_map'), ('pybind.nos.v6_0_2c.cee_map', 'cee_map'), ('pybind.nos.v7_0_1b.cee_map', 'cee_map'), ('pybind.slxos.v16r_1_00b.cee_map', 'cee_map')]
    bindings_list = [('pybind.nos.v6_0_2c.cee_map.priority_table', 'pybind.nos.v6_0_2c.brocade_cee_map', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.cee_map.priority_table', 'pybind.nos.v7_0_1b.brocade_cee_map', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.cee_map.priority_table', 'pybind.nos.v7_1_0.brocade_cee_map', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.cee_map.priority_table', 'pybind.slxos.v16r_1_00b.brocade_qos_cee', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'map-cos7-pgid'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cee_map=cee_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cee_map=cee_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cee_map_remap_delete(self, cee_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cee_map: name
    :param cee_map: Keyword argument tuple.

    :type name: unicode
    :param name: **cee_map** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.cee_map', 'cee_map'), ('pybind.slxos.v16r_1_00b.cee_map', 'cee_map'), ('pybind.nos.v7_1_0.cee_map', 'cee_map'), ('pybind.nos.v7_0_1b.cee_map', 'cee_map')]
    bindings_list = [('pybind.nos.v6_0_2c.cee_map.remap', 'pybind.nos.v6_0_2c.brocade_cee_map', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.cee_map.remap', 'pybind.nos.v7_0_1b.brocade_cee_map', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.cee_map.remap', 'pybind.nos.v7_1_0.brocade_cee_map', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.cee_map.remap', 'pybind.slxos.v16r_1_00b.brocade_qos_cee', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cee_map=cee_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cee_map=cee_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cee_map_remap_fabric_priority_delete(self, cee_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cee_map: name
    :param cee_map: Keyword argument tuple.

    :type name: unicode
    :param name: **cee_map** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cee_map', 'cee_map'), ('pybind.nos.v7_0_1b.cee_map', 'cee_map'), ('pybind.nos.v6_0_2c.cee_map', 'cee_map'), ('pybind.nos.v7_1_0.cee_map', 'cee_map')]
    bindings_list = [('pybind.nos.v6_0_2c.cee_map.remap.fabric_priority', 'pybind.nos.v6_0_2c.brocade_cee_map', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.cee_map.remap.fabric_priority', 'pybind.nos.v7_0_1b.brocade_cee_map', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.cee_map.remap.fabric_priority', 'pybind.nos.v7_1_0.brocade_cee_map', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.cee_map.remap.fabric_priority', 'pybind.slxos.v16r_1_00b.brocade_qos_cee', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cee_map=cee_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cee_map=cee_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cee_map_remap_fabric_priority_priority_delete(self, cee_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cee_map: name
    :param cee_map: Keyword argument tuple.

    :type name: unicode
    :param name: **cee_map** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cee_map', 'cee_map'), ('pybind.nos.v7_0_1b.cee_map', 'cee_map'), ('pybind.nos.v6_0_2c.cee_map', 'cee_map'), ('pybind.nos.v7_1_0.cee_map', 'cee_map')]
    bindings_list = [('pybind.nos.v6_0_2c.cee_map.remap.fabric_priority', 'pybind.nos.v6_0_2c.brocade_cee_map', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.cee_map.remap.fabric_priority', 'pybind.nos.v7_0_1b.brocade_cee_map', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.cee_map.remap.fabric_priority', 'pybind.nos.v7_1_0.brocade_cee_map', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.cee_map.remap.fabric_priority', 'pybind.slxos.v16r_1_00b.brocade_qos_cee', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cee_map=cee_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cee_map=cee_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cee_map_remap_lossless_priority_delete(self, cee_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cee_map: name
    :param cee_map: Keyword argument tuple.

    :type name: unicode
    :param name: **cee_map** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.cee_map', 'cee_map'), ('pybind.slxos.v16r_1_00b.cee_map', 'cee_map'), ('pybind.nos.v7_1_0.cee_map', 'cee_map'), ('pybind.nos.v7_0_1b.cee_map', 'cee_map')]
    bindings_list = [('pybind.nos.v6_0_2c.cee_map.remap.lossless_priority', 'pybind.nos.v6_0_2c.brocade_cee_map', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.cee_map.remap.lossless_priority', 'pybind.nos.v7_0_1b.brocade_cee_map', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.cee_map.remap.lossless_priority', 'pybind.nos.v7_1_0.brocade_cee_map', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.cee_map.remap.lossless_priority', 'pybind.slxos.v16r_1_00b.brocade_qos_cee', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cee_map=cee_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cee_map=cee_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cee_map_remap_lossless_priority_priority_delete(self, cee_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cee_map: name
    :param cee_map: Keyword argument tuple.

    :type name: unicode
    :param name: **cee_map** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.cee_map', 'cee_map'), ('pybind.slxos.v16r_1_00b.cee_map', 'cee_map'), ('pybind.nos.v7_1_0.cee_map', 'cee_map'), ('pybind.nos.v7_0_1b.cee_map', 'cee_map')]
    bindings_list = [('pybind.nos.v6_0_2c.cee_map.remap.lossless_priority', 'pybind.nos.v6_0_2c.brocade_cee_map', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.cee_map.remap.lossless_priority', 'pybind.nos.v7_0_1b.brocade_cee_map', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.cee_map.remap.lossless_priority', 'pybind.nos.v7_1_0.brocade_cee_map', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.cee_map.remap.lossless_priority', 'pybind.slxos.v16r_1_00b.brocade_qos_cee', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cee_map=cee_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cee_map=cee_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def certutil_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.certutil', 'pybind.nos.v6_0_2c.brocade_certutil', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.certutil', 'pybind.nos.v7_0_1b.brocade_certutil', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.certutil', 'pybind.nos.v7_1_0.brocade_certutil', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.certutil', 'pybind.slxos.v16r_1_00b.brocade_certutil', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cfm_state_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.cfm_state', 'pybind.slxos.v16r_1_00b.brocade_dot1ag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cfm_state_cfm_connectivity_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.cfm_state.cfm_connectivity', 'pybind.slxos.v16r_1_00b.brocade_dot1ag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cfm_state_cfm_connectivity_domain_delete(self, domain=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type domain: md_name
    :param domain: Keyword argument tuple.

    :type md_name: unicode
    :param md_name: **domain** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.cfm_state.cfm_connectivity.domain', 'pybind.slxos.v16r_1_00b.brocade_dot1ag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'domain', 'keyval': 'md_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain=domain)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain=domain)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cfm_state_cfm_connectivity_domain_ma_delete(self, domain=None, ma=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain: md_name
    :param domain: Keyword argument tuple.

    :type md_name: unicode
    :param md_name: **domain** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type ma: ma_name
    :param ma: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cfm_state.cfm_connectivity.domain', u'domain')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cfm_state.cfm_connectivity.domain.ma', 'pybind.slxos.v16r_1_00b.brocade_dot1ag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'md_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ma', 'keyval': 'ma_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain=domain, ma=ma)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain=domain, ma=ma)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cfm_state_cfm_connectivity_domain_ma_ccm_interval_delete(self, domain=None, ma=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain: md_name
    :param domain: Keyword argument tuple.

    :type md_name: unicode
    :param md_name: **domain** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type ma: ma_name
    :param ma: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cfm_state.cfm_connectivity.domain', u'domain')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cfm_state.cfm_connectivity.domain.ma', 'pybind.slxos.v16r_1_00b.brocade_dot1ag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'md_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ma', 'keyval': 'ma_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ccm-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain=domain, ma=ma)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain=domain, ma=ma)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cfm_state_cfm_connectivity_domain_ma_ma_idx_delete(self, domain=None, ma=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain: md_name
    :param domain: Keyword argument tuple.

    :type md_name: unicode
    :param md_name: **domain** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type ma: ma_name
    :param ma: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cfm_state.cfm_connectivity.domain', u'domain')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cfm_state.cfm_connectivity.domain.ma', 'pybind.slxos.v16r_1_00b.brocade_dot1ag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'md_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ma', 'keyval': 'ma_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ma-idx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain=domain, ma=ma)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain=domain, ma=ma)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cfm_state_cfm_connectivity_domain_ma_ma_type_delete(self, domain=None, ma=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain: md_name
    :param domain: Keyword argument tuple.

    :type md_name: unicode
    :param md_name: **domain** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type ma: ma_name
    :param ma: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cfm_state.cfm_connectivity.domain', u'domain')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cfm_state.cfm_connectivity.domain.ma', 'pybind.slxos.v16r_1_00b.brocade_dot1ag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'md_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ma', 'keyval': 'ma_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ma-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain=domain, ma=ma)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain=domain, ma=ma)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cfm_state_cfm_connectivity_domain_ma_mep_delete(self, domain=None, ma=None, mep=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain: md_name
    :param domain: Keyword argument tuple.

    :type md_name: unicode
    :param md_name: **domain** tuple argument.

    :type ma: ma_name
    :param ma: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type mep: mep_id
    :param mep: Keyword argument tuple.

    :type mep_id: int
    :param mep_id: **mep** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cfm_state.cfm_connectivity.domain', u'domain'), ('pybind.slxos.v16r_1_00b.cfm_state.cfm_connectivity.domain.ma', u'ma')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cfm_state.cfm_connectivity.domain.ma.mep', 'pybind.slxos.v16r_1_00b.brocade_dot1ag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mep', 'keyval': 'mep_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain=domain, ma=ma, mep=mep)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain=domain, ma=ma, mep=mep)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cfm_state_cfm_connectivity_domain_ma_mep_mep_direction_delete(self, domain=None, ma=None, mep=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain: md_name
    :param domain: Keyword argument tuple.

    :type md_name: unicode
    :param md_name: **domain** tuple argument.

    :type ma: ma_name
    :param ma: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type mep: mep_id
    :param mep: Keyword argument tuple.

    :type mep_id: int
    :param mep_id: **mep** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cfm_state.cfm_connectivity.domain', u'domain'), ('pybind.slxos.v16r_1_00b.cfm_state.cfm_connectivity.domain.ma', u'ma')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cfm_state.cfm_connectivity.domain.ma.mep', 'pybind.slxos.v16r_1_00b.brocade_dot1ag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mep', 'keyval': 'mep_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mep-direction'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain=domain, ma=ma, mep=mep)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain=domain, ma=ma, mep=mep)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cfm_state_cfm_connectivity_domain_ma_mep_mep_mac_delete(self, domain=None, ma=None, mep=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain: md_name
    :param domain: Keyword argument tuple.

    :type md_name: unicode
    :param md_name: **domain** tuple argument.

    :type ma: ma_name
    :param ma: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type mep: mep_id
    :param mep: Keyword argument tuple.

    :type mep_id: int
    :param mep_id: **mep** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cfm_state.cfm_connectivity.domain', u'domain'), ('pybind.slxos.v16r_1_00b.cfm_state.cfm_connectivity.domain.ma', u'ma')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cfm_state.cfm_connectivity.domain.ma.mep', 'pybind.slxos.v16r_1_00b.brocade_dot1ag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mep', 'keyval': 'mep_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mep-mac'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain=domain, ma=ma, mep=mep)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain=domain, ma=ma, mep=mep)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cfm_state_cfm_connectivity_domain_ma_mep_mep_port_delete(self, domain=None, ma=None, mep=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain: md_name
    :param domain: Keyword argument tuple.

    :type md_name: unicode
    :param md_name: **domain** tuple argument.

    :type ma: ma_name
    :param ma: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type mep: mep_id
    :param mep: Keyword argument tuple.

    :type mep_id: int
    :param mep_id: **mep** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cfm_state.cfm_connectivity.domain', u'domain'), ('pybind.slxos.v16r_1_00b.cfm_state.cfm_connectivity.domain.ma', u'ma')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cfm_state.cfm_connectivity.domain.ma.mep', 'pybind.slxos.v16r_1_00b.brocade_dot1ag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mep', 'keyval': 'mep_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mep-port'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain=domain, ma=ma, mep=mep)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain=domain, ma=ma, mep=mep)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cfm_state_cfm_connectivity_domain_ma_mep_port_state_delete(self, domain=None, ma=None, mep=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain: md_name
    :param domain: Keyword argument tuple.

    :type md_name: unicode
    :param md_name: **domain** tuple argument.

    :type ma: ma_name
    :param ma: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type mep: mep_id
    :param mep: Keyword argument tuple.

    :type mep_id: int
    :param mep_id: **mep** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cfm_state.cfm_connectivity.domain', u'domain'), ('pybind.slxos.v16r_1_00b.cfm_state.cfm_connectivity.domain.ma', u'ma')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cfm_state.cfm_connectivity.domain.ma.mep', 'pybind.slxos.v16r_1_00b.brocade_dot1ag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mep', 'keyval': 'mep_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'port-state'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain=domain, ma=ma, mep=mep)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain=domain, ma=ma, mep=mep)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cfm_state_cfm_connectivity_domain_ma_mep_rmep_delete(self, domain=None, ma=None, mep=None, rmep=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain: md_name
    :param domain: Keyword argument tuple.

    :type md_name: unicode
    :param md_name: **domain** tuple argument.

    :type ma: ma_name
    :param ma: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma** tuple argument.

    :type mep: mep_id
    :param mep: Keyword argument tuple.

    :type mep_id: int
    :param mep_id: **mep** tuple argument.

        * range restriction: ::

            ['0..65535']

    **Instance Keyword Argument Tuple**:

    :type rmep: rmep_id
    :param rmep: Keyword argument tuple.

    :type rmep_id: int
    :param rmep_id: **rmep** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cfm_state.cfm_connectivity.domain', u'domain'), ('pybind.slxos.v16r_1_00b.cfm_state.cfm_connectivity.domain.ma', u'ma'), ('pybind.slxos.v16r_1_00b.cfm_state.cfm_connectivity.domain.ma.mep', u'mep')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cfm_state.cfm_connectivity.domain.ma.mep.rmep', 'pybind.slxos.v16r_1_00b.brocade_dot1ag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'mep_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'rmep', 'keyval': 'rmep_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain=domain, ma=ma, mep=mep, rmep=rmep)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain=domain, ma=ma, mep=mep, rmep=rmep)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cfm_state_cfm_connectivity_domain_ma_mep_rmep_fail_delete(self, domain=None, ma=None, mep=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain: md_name
    :param domain: Keyword argument tuple.

    :type md_name: unicode
    :param md_name: **domain** tuple argument.

    :type ma: ma_name
    :param ma: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type mep: mep_id
    :param mep: Keyword argument tuple.

    :type mep_id: int
    :param mep_id: **mep** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cfm_state.cfm_connectivity.domain', u'domain'), ('pybind.slxos.v16r_1_00b.cfm_state.cfm_connectivity.domain.ma', u'ma')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cfm_state.cfm_connectivity.domain.ma.mep', 'pybind.slxos.v16r_1_00b.brocade_dot1ag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mep', 'keyval': 'mep_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rmep-fail'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain=domain, ma=ma, mep=mep)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain=domain, ma=ma, mep=mep)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cfm_state_cfm_connectivity_domain_ma_mep_rmep_ok_delete(self, domain=None, ma=None, mep=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain: md_name
    :param domain: Keyword argument tuple.

    :type md_name: unicode
    :param md_name: **domain** tuple argument.

    :type ma: ma_name
    :param ma: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type mep: mep_id
    :param mep: Keyword argument tuple.

    :type mep_id: int
    :param mep_id: **mep** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cfm_state.cfm_connectivity.domain', u'domain'), ('pybind.slxos.v16r_1_00b.cfm_state.cfm_connectivity.domain.ma', u'ma')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cfm_state.cfm_connectivity.domain.ma.mep', 'pybind.slxos.v16r_1_00b.brocade_dot1ag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mep', 'keyval': 'mep_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rmep-ok'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain=domain, ma=ma, mep=mep)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain=domain, ma=ma, mep=mep)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cfm_state_cfm_connectivity_domain_ma_mep_rmep_rmep_mac_delete(self, domain=None, ma=None, mep=None, rmep=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain: md_name
    :param domain: Keyword argument tuple.

    :type md_name: unicode
    :param md_name: **domain** tuple argument.

    :type ma: ma_name
    :param ma: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma** tuple argument.

    :type mep: mep_id
    :param mep: Keyword argument tuple.

    :type mep_id: int
    :param mep_id: **mep** tuple argument.

        * range restriction: ::

            ['0..65535']

    **Instance Keyword Argument Tuple**:

    :type rmep: rmep_id
    :param rmep: Keyword argument tuple.

    :type rmep_id: int
    :param rmep_id: **rmep** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cfm_state.cfm_connectivity.domain', u'domain'), ('pybind.slxos.v16r_1_00b.cfm_state.cfm_connectivity.domain.ma', u'ma'), ('pybind.slxos.v16r_1_00b.cfm_state.cfm_connectivity.domain.ma.mep', u'mep')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cfm_state.cfm_connectivity.domain.ma.mep.rmep', 'pybind.slxos.v16r_1_00b.brocade_dot1ag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'mep_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'rmep', 'keyval': 'rmep_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rmep-mac'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain=domain, ma=ma, mep=mep, rmep=rmep)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain=domain, ma=ma, mep=mep, rmep=rmep)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cfm_state_cfm_connectivity_domain_ma_mep_rmep_rmep_port_delete(self, domain=None, ma=None, mep=None, rmep=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain: md_name
    :param domain: Keyword argument tuple.

    :type md_name: unicode
    :param md_name: **domain** tuple argument.

    :type ma: ma_name
    :param ma: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma** tuple argument.

    :type mep: mep_id
    :param mep: Keyword argument tuple.

    :type mep_id: int
    :param mep_id: **mep** tuple argument.

        * range restriction: ::

            ['0..65535']

    **Instance Keyword Argument Tuple**:

    :type rmep: rmep_id
    :param rmep: Keyword argument tuple.

    :type rmep_id: int
    :param rmep_id: **rmep** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cfm_state.cfm_connectivity.domain', u'domain'), ('pybind.slxos.v16r_1_00b.cfm_state.cfm_connectivity.domain.ma', u'ma'), ('pybind.slxos.v16r_1_00b.cfm_state.cfm_connectivity.domain.ma.mep', u'mep')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cfm_state.cfm_connectivity.domain.ma.mep.rmep', 'pybind.slxos.v16r_1_00b.brocade_dot1ag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'mep_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'rmep', 'keyval': 'rmep_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rmep-port'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain=domain, ma=ma, mep=mep, rmep=rmep)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain=domain, ma=ma, mep=mep, rmep=rmep)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cfm_state_cfm_connectivity_domain_ma_mep_rmep_rmep_state_delete(self, domain=None, ma=None, mep=None, rmep=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain: md_name
    :param domain: Keyword argument tuple.

    :type md_name: unicode
    :param md_name: **domain** tuple argument.

    :type ma: ma_name
    :param ma: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma** tuple argument.

    :type mep: mep_id
    :param mep: Keyword argument tuple.

    :type mep_id: int
    :param mep_id: **mep** tuple argument.

        * range restriction: ::

            ['0..65535']

    **Instance Keyword Argument Tuple**:

    :type rmep: rmep_id
    :param rmep: Keyword argument tuple.

    :type rmep_id: int
    :param rmep_id: **rmep** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cfm_state.cfm_connectivity.domain', u'domain'), ('pybind.slxos.v16r_1_00b.cfm_state.cfm_connectivity.domain.ma', u'ma'), ('pybind.slxos.v16r_1_00b.cfm_state.cfm_connectivity.domain.ma.mep', u'mep')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cfm_state.cfm_connectivity.domain.ma.mep.rmep', 'pybind.slxos.v16r_1_00b.brocade_dot1ag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'mep_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'rmep', 'keyval': 'rmep_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rmep-state'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain=domain, ma=ma, mep=mep, rmep=rmep)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain=domain, ma=ma, mep=mep, rmep=rmep)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cfm_state_cfm_connectivity_domain_ma_mep_rmep_vlan_id_delete(self, domain=None, ma=None, mep=None, rmep=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain: md_name
    :param domain: Keyword argument tuple.

    :type md_name: unicode
    :param md_name: **domain** tuple argument.

    :type ma: ma_name
    :param ma: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma** tuple argument.

    :type mep: mep_id
    :param mep: Keyword argument tuple.

    :type mep_id: int
    :param mep_id: **mep** tuple argument.

        * range restriction: ::

            ['0..65535']

    **Instance Keyword Argument Tuple**:

    :type rmep: rmep_id
    :param rmep: Keyword argument tuple.

    :type rmep_id: int
    :param rmep_id: **rmep** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cfm_state.cfm_connectivity.domain', u'domain'), ('pybind.slxos.v16r_1_00b.cfm_state.cfm_connectivity.domain.ma', u'ma'), ('pybind.slxos.v16r_1_00b.cfm_state.cfm_connectivity.domain.ma.mep', u'mep')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cfm_state.cfm_connectivity.domain.ma.mep.rmep', 'pybind.slxos.v16r_1_00b.brocade_dot1ag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'mep_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'rmep', 'keyval': 'rmep_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vlan-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain=domain, ma=ma, mep=mep, rmep=rmep)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain=domain, ma=ma, mep=mep, rmep=rmep)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cfm_state_cfm_connectivity_domain_ma_mip_delete(self, domain=None, ma=None, mip=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain: md_name
    :param domain: Keyword argument tuple.

    :type md_name: unicode
    :param md_name: **domain** tuple argument.

    :type ma: ma_name
    :param ma: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type mip: vlan_id, port
    :param mip: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **mip** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type port: unicode
    :param port: **mip** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cfm_state.cfm_connectivity.domain', u'domain'), ('pybind.slxos.v16r_1_00b.cfm_state.cfm_connectivity.domain.ma', u'ma')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cfm_state.cfm_connectivity.domain.ma.mip', 'pybind.slxos.v16r_1_00b.brocade_dot1ag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mip', 'keyval': 'vlan_id, port', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain=domain, ma=ma, mip=mip)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain=domain, ma=ma, mip=mip)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cfm_state_cfm_connectivity_domain_ma_mip_level_delete(self, domain=None, ma=None, mip=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain: md_name
    :param domain: Keyword argument tuple.

    :type md_name: unicode
    :param md_name: **domain** tuple argument.

    :type ma: ma_name
    :param ma: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type mip: vlan_id, port
    :param mip: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **mip** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type port: unicode
    :param port: **mip** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cfm_state.cfm_connectivity.domain', u'domain'), ('pybind.slxos.v16r_1_00b.cfm_state.cfm_connectivity.domain.ma', u'ma')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cfm_state.cfm_connectivity.domain.ma.mip', 'pybind.slxos.v16r_1_00b.brocade_dot1ag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mip', 'keyval': 'vlan_id, port', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'level'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain=domain, ma=ma, mip=mip)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain=domain, ma=ma, mip=mip)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cfm_state_cfm_connectivity_domain_ma_mip_mac_delete(self, domain=None, ma=None, mip=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain: md_name
    :param domain: Keyword argument tuple.

    :type md_name: unicode
    :param md_name: **domain** tuple argument.

    :type ma: ma_name
    :param ma: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type mip: vlan_id, port
    :param mip: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **mip** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type port: unicode
    :param port: **mip** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cfm_state.cfm_connectivity.domain', u'domain'), ('pybind.slxos.v16r_1_00b.cfm_state.cfm_connectivity.domain.ma', u'ma')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cfm_state.cfm_connectivity.domain.ma.mip', 'pybind.slxos.v16r_1_00b.brocade_dot1ag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mip', 'keyval': 'vlan_id, port', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mac'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain=domain, ma=ma, mip=mip)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain=domain, ma=ma, mip=mip)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cfm_state_cfm_connectivity_domain_ma_priority_delete(self, domain=None, ma=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain: md_name
    :param domain: Keyword argument tuple.

    :type md_name: unicode
    :param md_name: **domain** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type ma: ma_name
    :param ma: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cfm_state.cfm_connectivity.domain', u'domain')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cfm_state.cfm_connectivity.domain.ma', 'pybind.slxos.v16r_1_00b.brocade_dot1ag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'md_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ma', 'keyval': 'ma_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain=domain, ma=ma)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain=domain, ma=ma)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cfm_state_cfm_connectivity_domain_ma_vlan_id_delete(self, domain=None, ma=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain: md_name
    :param domain: Keyword argument tuple.

    :type md_name: unicode
    :param md_name: **domain** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type ma: ma_name
    :param ma: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cfm_state.cfm_connectivity.domain', u'domain')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cfm_state.cfm_connectivity.domain.ma', 'pybind.slxos.v16r_1_00b.brocade_dot1ag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'md_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ma', 'keyval': 'ma_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vlan-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain=domain, ma=ma)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain=domain, ma=ma)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cfm_state_cfm_connectivity_domain_md_level_delete(self, domain=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type domain: md_name
    :param domain: Keyword argument tuple.

    :type md_name: unicode
    :param md_name: **domain** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.cfm_state.cfm_connectivity.domain', 'pybind.slxos.v16r_1_00b.brocade_dot1ag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'domain', 'keyval': 'md_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'md-level'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain=domain)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain=domain)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cfm_state_cfm_detail_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.cfm_state.cfm_detail', 'pybind.slxos.v16r_1_00b.brocade_dot1ag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cfm_state_cfm_detail_domain_delete(self, domain=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type domain: md_name
    :param domain: Keyword argument tuple.

    :type md_name: unicode
    :param md_name: **domain** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.cfm_state.cfm_detail.domain', 'pybind.slxos.v16r_1_00b.brocade_dot1ag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'domain', 'keyval': 'md_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain=domain)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain=domain)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cfm_state_cfm_detail_domain_ma_delete(self, domain=None, ma=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain: md_name
    :param domain: Keyword argument tuple.

    :type md_name: unicode
    :param md_name: **domain** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type ma: ma_name
    :param ma: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cfm_state.cfm_detail.domain', u'domain')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cfm_state.cfm_detail.domain.ma', 'pybind.slxos.v16r_1_00b.brocade_dot1ag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'md_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ma', 'keyval': 'ma_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain=domain, ma=ma)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain=domain, ma=ma)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cfm_state_cfm_detail_domain_ma_ccm_interval_delete(self, domain=None, ma=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain: md_name
    :param domain: Keyword argument tuple.

    :type md_name: unicode
    :param md_name: **domain** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type ma: ma_name
    :param ma: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cfm_state.cfm_detail.domain', u'domain')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cfm_state.cfm_detail.domain.ma', 'pybind.slxos.v16r_1_00b.brocade_dot1ag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'md_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ma', 'keyval': 'ma_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ccm-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain=domain, ma=ma)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain=domain, ma=ma)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cfm_state_cfm_detail_domain_ma_ma_idx_delete(self, domain=None, ma=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain: md_name
    :param domain: Keyword argument tuple.

    :type md_name: unicode
    :param md_name: **domain** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type ma: ma_name
    :param ma: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cfm_state.cfm_detail.domain', u'domain')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cfm_state.cfm_detail.domain.ma', 'pybind.slxos.v16r_1_00b.brocade_dot1ag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'md_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ma', 'keyval': 'ma_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ma-idx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain=domain, ma=ma)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain=domain, ma=ma)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cfm_state_cfm_detail_domain_ma_ma_type_delete(self, domain=None, ma=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain: md_name
    :param domain: Keyword argument tuple.

    :type md_name: unicode
    :param md_name: **domain** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type ma: ma_name
    :param ma: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cfm_state.cfm_detail.domain', u'domain')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cfm_state.cfm_detail.domain.ma', 'pybind.slxos.v16r_1_00b.brocade_dot1ag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'md_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ma', 'keyval': 'ma_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ma-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain=domain, ma=ma)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain=domain, ma=ma)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cfm_state_cfm_detail_domain_ma_mep_delete(self, domain=None, ma=None, mep=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain: md_name
    :param domain: Keyword argument tuple.

    :type md_name: unicode
    :param md_name: **domain** tuple argument.

    :type ma: ma_name
    :param ma: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type mep: mep_id
    :param mep: Keyword argument tuple.

    :type mep_id: int
    :param mep_id: **mep** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cfm_state.cfm_detail.domain', u'domain'), ('pybind.slxos.v16r_1_00b.cfm_state.cfm_detail.domain.ma', u'ma')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cfm_state.cfm_detail.domain.ma.mep', 'pybind.slxos.v16r_1_00b.brocade_dot1ag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mep', 'keyval': 'mep_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain=domain, ma=ma, mep=mep)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain=domain, ma=ma, mep=mep)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cfm_state_cfm_detail_domain_ma_mep_mep_direction_delete(self, domain=None, ma=None, mep=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain: md_name
    :param domain: Keyword argument tuple.

    :type md_name: unicode
    :param md_name: **domain** tuple argument.

    :type ma: ma_name
    :param ma: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type mep: mep_id
    :param mep: Keyword argument tuple.

    :type mep_id: int
    :param mep_id: **mep** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cfm_state.cfm_detail.domain', u'domain'), ('pybind.slxos.v16r_1_00b.cfm_state.cfm_detail.domain.ma', u'ma')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cfm_state.cfm_detail.domain.ma.mep', 'pybind.slxos.v16r_1_00b.brocade_dot1ag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mep', 'keyval': 'mep_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mep-direction'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain=domain, ma=ma, mep=mep)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain=domain, ma=ma, mep=mep)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cfm_state_cfm_detail_domain_ma_mep_mep_mac_delete(self, domain=None, ma=None, mep=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain: md_name
    :param domain: Keyword argument tuple.

    :type md_name: unicode
    :param md_name: **domain** tuple argument.

    :type ma: ma_name
    :param ma: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type mep: mep_id
    :param mep: Keyword argument tuple.

    :type mep_id: int
    :param mep_id: **mep** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cfm_state.cfm_detail.domain', u'domain'), ('pybind.slxos.v16r_1_00b.cfm_state.cfm_detail.domain.ma', u'ma')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cfm_state.cfm_detail.domain.ma.mep', 'pybind.slxos.v16r_1_00b.brocade_dot1ag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mep', 'keyval': 'mep_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mep-mac'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain=domain, ma=ma, mep=mep)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain=domain, ma=ma, mep=mep)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cfm_state_cfm_detail_domain_ma_mep_mep_port_delete(self, domain=None, ma=None, mep=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain: md_name
    :param domain: Keyword argument tuple.

    :type md_name: unicode
    :param md_name: **domain** tuple argument.

    :type ma: ma_name
    :param ma: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type mep: mep_id
    :param mep: Keyword argument tuple.

    :type mep_id: int
    :param mep_id: **mep** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cfm_state.cfm_detail.domain', u'domain'), ('pybind.slxos.v16r_1_00b.cfm_state.cfm_detail.domain.ma', u'ma')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cfm_state.cfm_detail.domain.ma.mep', 'pybind.slxos.v16r_1_00b.brocade_dot1ag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mep', 'keyval': 'mep_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mep-port'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain=domain, ma=ma, mep=mep)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain=domain, ma=ma, mep=mep)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cfm_state_cfm_detail_domain_ma_mep_port_state_delete(self, domain=None, ma=None, mep=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain: md_name
    :param domain: Keyword argument tuple.

    :type md_name: unicode
    :param md_name: **domain** tuple argument.

    :type ma: ma_name
    :param ma: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type mep: mep_id
    :param mep: Keyword argument tuple.

    :type mep_id: int
    :param mep_id: **mep** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cfm_state.cfm_detail.domain', u'domain'), ('pybind.slxos.v16r_1_00b.cfm_state.cfm_detail.domain.ma', u'ma')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cfm_state.cfm_detail.domain.ma.mep', 'pybind.slxos.v16r_1_00b.brocade_dot1ag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mep', 'keyval': 'mep_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'port-state'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain=domain, ma=ma, mep=mep)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain=domain, ma=ma, mep=mep)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cfm_state_cfm_detail_domain_ma_mep_rmep_delete(self, domain=None, ma=None, mep=None, rmep=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain: md_name
    :param domain: Keyword argument tuple.

    :type md_name: unicode
    :param md_name: **domain** tuple argument.

    :type ma: ma_name
    :param ma: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma** tuple argument.

    :type mep: mep_id
    :param mep: Keyword argument tuple.

    :type mep_id: int
    :param mep_id: **mep** tuple argument.

        * range restriction: ::

            ['0..65535']

    **Instance Keyword Argument Tuple**:

    :type rmep: rmep_id
    :param rmep: Keyword argument tuple.

    :type rmep_id: int
    :param rmep_id: **rmep** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cfm_state.cfm_detail.domain', u'domain'), ('pybind.slxos.v16r_1_00b.cfm_state.cfm_detail.domain.ma', u'ma'), ('pybind.slxos.v16r_1_00b.cfm_state.cfm_detail.domain.ma.mep', u'mep')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cfm_state.cfm_detail.domain.ma.mep.rmep', 'pybind.slxos.v16r_1_00b.brocade_dot1ag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'mep_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'rmep', 'keyval': 'rmep_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain=domain, ma=ma, mep=mep, rmep=rmep)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain=domain, ma=ma, mep=mep, rmep=rmep)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cfm_state_cfm_detail_domain_ma_mep_rmep_fail_delete(self, domain=None, ma=None, mep=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain: md_name
    :param domain: Keyword argument tuple.

    :type md_name: unicode
    :param md_name: **domain** tuple argument.

    :type ma: ma_name
    :param ma: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type mep: mep_id
    :param mep: Keyword argument tuple.

    :type mep_id: int
    :param mep_id: **mep** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cfm_state.cfm_detail.domain', u'domain'), ('pybind.slxos.v16r_1_00b.cfm_state.cfm_detail.domain.ma', u'ma')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cfm_state.cfm_detail.domain.ma.mep', 'pybind.slxos.v16r_1_00b.brocade_dot1ag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mep', 'keyval': 'mep_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rmep-fail'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain=domain, ma=ma, mep=mep)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain=domain, ma=ma, mep=mep)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cfm_state_cfm_detail_domain_ma_mep_rmep_ok_delete(self, domain=None, ma=None, mep=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain: md_name
    :param domain: Keyword argument tuple.

    :type md_name: unicode
    :param md_name: **domain** tuple argument.

    :type ma: ma_name
    :param ma: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type mep: mep_id
    :param mep: Keyword argument tuple.

    :type mep_id: int
    :param mep_id: **mep** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cfm_state.cfm_detail.domain', u'domain'), ('pybind.slxos.v16r_1_00b.cfm_state.cfm_detail.domain.ma', u'ma')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cfm_state.cfm_detail.domain.ma.mep', 'pybind.slxos.v16r_1_00b.brocade_dot1ag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mep', 'keyval': 'mep_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rmep-ok'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain=domain, ma=ma, mep=mep)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain=domain, ma=ma, mep=mep)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cfm_state_cfm_detail_domain_ma_mep_rmep_rmep_mac_delete(self, domain=None, ma=None, mep=None, rmep=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain: md_name
    :param domain: Keyword argument tuple.

    :type md_name: unicode
    :param md_name: **domain** tuple argument.

    :type ma: ma_name
    :param ma: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma** tuple argument.

    :type mep: mep_id
    :param mep: Keyword argument tuple.

    :type mep_id: int
    :param mep_id: **mep** tuple argument.

        * range restriction: ::

            ['0..65535']

    **Instance Keyword Argument Tuple**:

    :type rmep: rmep_id
    :param rmep: Keyword argument tuple.

    :type rmep_id: int
    :param rmep_id: **rmep** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cfm_state.cfm_detail.domain', u'domain'), ('pybind.slxos.v16r_1_00b.cfm_state.cfm_detail.domain.ma', u'ma'), ('pybind.slxos.v16r_1_00b.cfm_state.cfm_detail.domain.ma.mep', u'mep')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cfm_state.cfm_detail.domain.ma.mep.rmep', 'pybind.slxos.v16r_1_00b.brocade_dot1ag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'mep_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'rmep', 'keyval': 'rmep_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rmep-mac'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain=domain, ma=ma, mep=mep, rmep=rmep)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain=domain, ma=ma, mep=mep, rmep=rmep)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cfm_state_cfm_detail_domain_ma_mep_rmep_rmep_port_delete(self, domain=None, ma=None, mep=None, rmep=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain: md_name
    :param domain: Keyword argument tuple.

    :type md_name: unicode
    :param md_name: **domain** tuple argument.

    :type ma: ma_name
    :param ma: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma** tuple argument.

    :type mep: mep_id
    :param mep: Keyword argument tuple.

    :type mep_id: int
    :param mep_id: **mep** tuple argument.

        * range restriction: ::

            ['0..65535']

    **Instance Keyword Argument Tuple**:

    :type rmep: rmep_id
    :param rmep: Keyword argument tuple.

    :type rmep_id: int
    :param rmep_id: **rmep** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cfm_state.cfm_detail.domain', u'domain'), ('pybind.slxos.v16r_1_00b.cfm_state.cfm_detail.domain.ma', u'ma'), ('pybind.slxos.v16r_1_00b.cfm_state.cfm_detail.domain.ma.mep', u'mep')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cfm_state.cfm_detail.domain.ma.mep.rmep', 'pybind.slxos.v16r_1_00b.brocade_dot1ag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'mep_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'rmep', 'keyval': 'rmep_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rmep-port'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain=domain, ma=ma, mep=mep, rmep=rmep)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain=domain, ma=ma, mep=mep, rmep=rmep)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cfm_state_cfm_detail_domain_ma_mep_rmep_rmep_state_delete(self, domain=None, ma=None, mep=None, rmep=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain: md_name
    :param domain: Keyword argument tuple.

    :type md_name: unicode
    :param md_name: **domain** tuple argument.

    :type ma: ma_name
    :param ma: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma** tuple argument.

    :type mep: mep_id
    :param mep: Keyword argument tuple.

    :type mep_id: int
    :param mep_id: **mep** tuple argument.

        * range restriction: ::

            ['0..65535']

    **Instance Keyword Argument Tuple**:

    :type rmep: rmep_id
    :param rmep: Keyword argument tuple.

    :type rmep_id: int
    :param rmep_id: **rmep** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cfm_state.cfm_detail.domain', u'domain'), ('pybind.slxos.v16r_1_00b.cfm_state.cfm_detail.domain.ma', u'ma'), ('pybind.slxos.v16r_1_00b.cfm_state.cfm_detail.domain.ma.mep', u'mep')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cfm_state.cfm_detail.domain.ma.mep.rmep', 'pybind.slxos.v16r_1_00b.brocade_dot1ag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'mep_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'rmep', 'keyval': 'rmep_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rmep-state'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain=domain, ma=ma, mep=mep, rmep=rmep)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain=domain, ma=ma, mep=mep, rmep=rmep)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cfm_state_cfm_detail_domain_ma_mep_rmep_vlan_id_delete(self, domain=None, ma=None, mep=None, rmep=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain: md_name
    :param domain: Keyword argument tuple.

    :type md_name: unicode
    :param md_name: **domain** tuple argument.

    :type ma: ma_name
    :param ma: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma** tuple argument.

    :type mep: mep_id
    :param mep: Keyword argument tuple.

    :type mep_id: int
    :param mep_id: **mep** tuple argument.

        * range restriction: ::

            ['0..65535']

    **Instance Keyword Argument Tuple**:

    :type rmep: rmep_id
    :param rmep: Keyword argument tuple.

    :type rmep_id: int
    :param rmep_id: **rmep** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cfm_state.cfm_detail.domain', u'domain'), ('pybind.slxos.v16r_1_00b.cfm_state.cfm_detail.domain.ma', u'ma'), ('pybind.slxos.v16r_1_00b.cfm_state.cfm_detail.domain.ma.mep', u'mep')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cfm_state.cfm_detail.domain.ma.mep.rmep', 'pybind.slxos.v16r_1_00b.brocade_dot1ag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'mep_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'rmep', 'keyval': 'rmep_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vlan-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain=domain, ma=ma, mep=mep, rmep=rmep)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain=domain, ma=ma, mep=mep, rmep=rmep)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cfm_state_cfm_detail_domain_ma_mip_delete(self, domain=None, ma=None, mip=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain: md_name
    :param domain: Keyword argument tuple.

    :type md_name: unicode
    :param md_name: **domain** tuple argument.

    :type ma: ma_name
    :param ma: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type mip: vlan_id, port
    :param mip: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **mip** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type port: unicode
    :param port: **mip** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cfm_state.cfm_detail.domain', u'domain'), ('pybind.slxos.v16r_1_00b.cfm_state.cfm_detail.domain.ma', u'ma')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cfm_state.cfm_detail.domain.ma.mip', 'pybind.slxos.v16r_1_00b.brocade_dot1ag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mip', 'keyval': 'vlan_id, port', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain=domain, ma=ma, mip=mip)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain=domain, ma=ma, mip=mip)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cfm_state_cfm_detail_domain_ma_mip_level_delete(self, domain=None, ma=None, mip=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain: md_name
    :param domain: Keyword argument tuple.

    :type md_name: unicode
    :param md_name: **domain** tuple argument.

    :type ma: ma_name
    :param ma: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type mip: vlan_id, port
    :param mip: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **mip** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type port: unicode
    :param port: **mip** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cfm_state.cfm_detail.domain', u'domain'), ('pybind.slxos.v16r_1_00b.cfm_state.cfm_detail.domain.ma', u'ma')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cfm_state.cfm_detail.domain.ma.mip', 'pybind.slxos.v16r_1_00b.brocade_dot1ag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mip', 'keyval': 'vlan_id, port', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'level'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain=domain, ma=ma, mip=mip)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain=domain, ma=ma, mip=mip)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cfm_state_cfm_detail_domain_ma_mip_mac_delete(self, domain=None, ma=None, mip=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain: md_name
    :param domain: Keyword argument tuple.

    :type md_name: unicode
    :param md_name: **domain** tuple argument.

    :type ma: ma_name
    :param ma: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type mip: vlan_id, port
    :param mip: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **mip** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type port: unicode
    :param port: **mip** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cfm_state.cfm_detail.domain', u'domain'), ('pybind.slxos.v16r_1_00b.cfm_state.cfm_detail.domain.ma', u'ma')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cfm_state.cfm_detail.domain.ma.mip', 'pybind.slxos.v16r_1_00b.brocade_dot1ag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mip', 'keyval': 'vlan_id, port', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mac'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain=domain, ma=ma, mip=mip)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain=domain, ma=ma, mip=mip)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cfm_state_cfm_detail_domain_ma_priority_delete(self, domain=None, ma=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain: md_name
    :param domain: Keyword argument tuple.

    :type md_name: unicode
    :param md_name: **domain** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type ma: ma_name
    :param ma: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cfm_state.cfm_detail.domain', u'domain')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cfm_state.cfm_detail.domain.ma', 'pybind.slxos.v16r_1_00b.brocade_dot1ag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'md_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ma', 'keyval': 'ma_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain=domain, ma=ma)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain=domain, ma=ma)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cfm_state_cfm_detail_domain_ma_vlan_id_delete(self, domain=None, ma=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain: md_name
    :param domain: Keyword argument tuple.

    :type md_name: unicode
    :param md_name: **domain** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type ma: ma_name
    :param ma: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cfm_state.cfm_detail.domain', u'domain')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cfm_state.cfm_detail.domain.ma', 'pybind.slxos.v16r_1_00b.brocade_dot1ag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'md_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ma', 'keyval': 'ma_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vlan-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain=domain, ma=ma)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain=domain, ma=ma)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cfm_state_cfm_detail_domain_md_level_delete(self, domain=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type domain: md_name
    :param domain: Keyword argument tuple.

    :type md_name: unicode
    :param md_name: **domain** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.cfm_state.cfm_detail.domain', 'pybind.slxos.v16r_1_00b.brocade_dot1ag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'domain', 'keyval': 'md_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'md-level'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain=domain)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain=domain)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def chassis_fan_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.chassis.fan', 'pybind.nos.v6_0_2c.brocade_chassis', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.chassis.fan', 'pybind.nos.v7_0_1b.brocade_chassis', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.chassis.fan', 'pybind.nos.v7_1_0.brocade_chassis', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.chassis.fan', 'pybind.slxos.v16r_1_00b.brocade_chassis', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def chassis_oper_address_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.hide_virtual_ip_holder.chassis.oper_address', 'pybind.nos.v6_0_2c.brocade_chassis', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_virtual_ip_holder.chassis.oper_address', 'pybind.nos.v7_0_1b.brocade_chassis', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_virtual_ip_holder.chassis.oper_address', 'pybind.nos.v7_1_0.brocade_chassis', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def chassis_virtual_ip_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.hide_virtual_ip_holder.chassis', 'pybind.nos.v6_0_2c.brocade_chassis', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_virtual_ip_holder.chassis', 'pybind.nos.v7_0_1b.brocade_chassis', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_virtual_ip_holder.chassis', 'pybind.nos.v7_1_0.brocade_chassis', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.hide_virtual_ip_holder.chassis', 'pybind.slxos.v16r_1_00b.brocade_chassis', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'virtual-ip'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def chassis_virtual_ip_oper_address_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.hide_virtual_ip_holder.chassis.oper_address', 'pybind.nos.v6_0_2c.brocade_chassis', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_virtual_ip_holder.chassis.oper_address', 'pybind.nos.v7_0_1b.brocade_chassis', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_virtual_ip_holder.chassis.oper_address', 'pybind.nos.v7_1_0.brocade_chassis', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'virtual-ip'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def chassis_virtual_ip_v4_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.hide_virtual_ip_holder.chassis.oper_address', 'pybind.slxos.v16r_1_00b.brocade_chassis', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'v4'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def chassis_virtual_ipv6_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.hide_virtual_ip_holder.chassis', 'pybind.nos.v6_0_2c.brocade_chassis', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_virtual_ip_holder.chassis', 'pybind.nos.v7_0_1b.brocade_chassis', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_virtual_ip_holder.chassis', 'pybind.nos.v7_1_0.brocade_chassis', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.hide_virtual_ip_holder.chassis', 'pybind.slxos.v16r_1_00b.brocade_chassis', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'virtual-ipv6'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def class_map_delete(self, class_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type class_map: name
    :param class_map: Keyword argument tuple.

    :type name: unicode
    :param name: **class_map** tuple argument:  Class Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.class_map', 'pybind.nos.v6_0_2c.brocade_policer', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.class_map', 'pybind.nos.v7_0_1b.brocade_policer', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.class_map', 'pybind.nos.v7_1_0.brocade_policer', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.class_map', 'pybind.slxos.v16r_1_00b.brocade_qos_mqc', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'class_map', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, class_map=class_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, class_map=class_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def class_map_match_access_group_access_group_name_delete(self, class_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type class_map: name
    :param class_map: Keyword argument tuple.

    :type name: unicode
    :param name: **class_map** tuple argument:  Class Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.class_map', 'class_map'), ('pybind.nos.v6_0_2c.class_map', 'class_map'), ('pybind.nos.v7_0_1b.class_map', 'class_map'), ('pybind.slxos.v16r_1_00b.class_map', 'class_map')]
    bindings_list = [('pybind.nos.v6_0_2c.class_map.match.access_group', 'pybind.nos.v6_0_2c.brocade_policer', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.class_map.match.access_group', 'pybind.nos.v7_0_1b.brocade_policer', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.class_map.match.access_group', 'pybind.nos.v7_1_0.brocade_policer', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.class_map.match.access_group', 'pybind.slxos.v16r_1_00b.brocade_qos_mqc', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'access-group-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, class_map=class_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, class_map=class_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def clear_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.clear', 'pybind.nos.v6_0_2c.brocade_common_def', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.clear', 'pybind.nos.v7_0_1b.brocade_common_def', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.clear', 'pybind.nos.v7_1_0.brocade_common_def', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.clear', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def clock_sa_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.clock_sa', 'pybind.nos.v6_0_2c.brocade_clock', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.clock_sa', 'pybind.nos.v7_0_1b.brocade_clock', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.clock_sa', 'pybind.nos.v7_1_0.brocade_clock', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.clock_sa', 'pybind.slxos.v16r_1_00b.brocade_clock', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def clock_timezone_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.clock_sa.clock', 'pybind.nos.v6_0_2c.brocade_clock', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.clock_sa.clock', 'pybind.nos.v7_0_1b.brocade_clock', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.clock_sa.clock', 'pybind.nos.v7_1_0.brocade_clock', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.clock_sa.clock', 'pybind.slxos.v16r_1_00b.brocade_clock', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'timezone'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cluster_delete(self, cluster=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type cluster: cluster_name, cluster_id
    :param cluster: Keyword argument tuple.

    :type cluster_name: unicode
    :param cluster_name: **cluster** tuple argument:  Name for the Cluster (MAX: 64 Characters)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,63})'

    :type cluster_id: long
    :param cluster_id: **cluster** tuple argument:  Id for the Cluster (Range: 1 - 65535

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.cluster', 'pybind.slxos.v16r_1_00b.brocade_mct', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'cluster', 'keyval': 'cluster_name, cluster_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cluster=cluster)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cluster=cluster)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cluster_client_delete(self, cluster=None, client=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cluster: cluster_name, cluster_id
    :param cluster: Keyword argument tuple.

    :type cluster_name: unicode
    :param cluster_name: **cluster** tuple argument:  Name for the Cluster (MAX: 64 Characters)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,63})'

    :type cluster_id: long
    :param cluster_id: **cluster** tuple argument:  Id for the Cluster (Range: 1 - 65535

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type client: client_name, client_id
    :param client: Keyword argument tuple.

    :type client_name: unicode
    :param client_name: **client** tuple argument:  Name for the Cluster Client (MAX: 64 Characters)

        * length restriction: ::

            ['1..64']

    :type client_id: long
    :param client_id: **client** tuple argument:  Id for the Cluster Client (Range: 1 - 512)

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cluster', 'cluster')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cluster.client', 'pybind.slxos.v16r_1_00b.brocade_mct', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_name, cluster_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'client', 'keyval': 'client_name, client_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cluster=cluster, client=client)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cluster=cluster, client=client)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cluster_client_client_interface_delete(self, cluster=None, client=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cluster: cluster_name, cluster_id
    :param cluster: Keyword argument tuple.

    :type cluster_name: unicode
    :param cluster_name: **cluster** tuple argument:  Name for the Cluster (MAX: 64 Characters)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,63})'

    :type cluster_id: long
    :param cluster_id: **cluster** tuple argument:  Id for the Cluster (Range: 1 - 65535

        * range restriction: ::

            ['0..4294967295']

    :type client: client_name, client_id
    :param client: Keyword argument tuple.

    :type client_name: unicode
    :param client_name: **client** tuple argument:  Name for the Cluster Client (MAX: 64 Characters)

        * length restriction: ::

            ['1..64']

    :type client_id: long
    :param client_id: **client** tuple argument:  Id for the Cluster Client (Range: 1 - 512)

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cluster', 'cluster'), ('pybind.slxos.v16r_1_00b.cluster.client', u'client')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cluster.client.client_interface', 'pybind.slxos.v16r_1_00b.brocade_mct', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_name, cluster_id', 'extra_keyval': ''}, {'keyval': 'client_name, client_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cluster=cluster, client=client)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cluster=cluster, client=client)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cluster_client_deploy_delete(self, cluster=None, client=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cluster: cluster_name, cluster_id
    :param cluster: Keyword argument tuple.

    :type cluster_name: unicode
    :param cluster_name: **cluster** tuple argument:  Name for the Cluster (MAX: 64 Characters)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,63})'

    :type cluster_id: long
    :param cluster_id: **cluster** tuple argument:  Id for the Cluster (Range: 1 - 65535

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type client: client_name, client_id
    :param client: Keyword argument tuple.

    :type client_name: unicode
    :param client_name: **client** tuple argument:  Name for the Cluster Client (MAX: 64 Characters)

        * length restriction: ::

            ['1..64']

    :type client_id: long
    :param client_id: **client** tuple argument:  Id for the Cluster Client (Range: 1 - 512)

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cluster', 'cluster')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cluster.client', 'pybind.slxos.v16r_1_00b.brocade_mct', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_name, cluster_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'client', 'keyval': 'client_name, client_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'deploy'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cluster=cluster, client=client)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cluster=cluster, client=client)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cluster_client_esi_delete(self, cluster=None, client=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cluster: cluster_name, cluster_id
    :param cluster: Keyword argument tuple.

    :type cluster_name: unicode
    :param cluster_name: **cluster** tuple argument:  Name for the Cluster (MAX: 64 Characters)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,63})'

    :type cluster_id: long
    :param cluster_id: **cluster** tuple argument:  Id for the Cluster (Range: 1 - 65535

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type client: client_name, client_id
    :param client: Keyword argument tuple.

    :type client_name: unicode
    :param client_name: **client** tuple argument:  Name for the Cluster Client (MAX: 64 Characters)

        * length restriction: ::

            ['1..64']

    :type client_id: long
    :param client_id: **client** tuple argument:  Id for the Cluster Client (Range: 1 - 512)

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cluster', 'cluster')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cluster.client', 'pybind.slxos.v16r_1_00b.brocade_mct', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_name, cluster_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'client', 'keyval': 'client_name, client_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'esi'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cluster=cluster, client=client)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cluster=cluster, client=client)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cluster_client_interfaces_shutdown_delete(self, cluster=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type cluster: cluster_name, cluster_id
    :param cluster: Keyword argument tuple.

    :type cluster_name: unicode
    :param cluster_name: **cluster** tuple argument:  Name for the Cluster (MAX: 64 Characters)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,63})'

    :type cluster_id: long
    :param cluster_id: **cluster** tuple argument:  Id for the Cluster (Range: 1 - 65535

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.cluster', 'pybind.slxos.v16r_1_00b.brocade_mct', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'cluster', 'keyval': 'cluster_name, cluster_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'client-interfaces-shutdown'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cluster=cluster)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cluster=cluster)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cluster_client_isolation_strict_delete(self, cluster=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type cluster: cluster_name, cluster_id
    :param cluster: Keyword argument tuple.

    :type cluster_name: unicode
    :param cluster_name: **cluster** tuple argument:  Name for the Cluster (MAX: 64 Characters)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,63})'

    :type cluster_id: long
    :param cluster_id: **cluster** tuple argument:  Id for the Cluster (Range: 1 - 65535

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.cluster', 'pybind.slxos.v16r_1_00b.brocade_mct', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'cluster', 'keyval': 'cluster_name, cluster_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'client-isolation-strict'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cluster=cluster)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cluster=cluster)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cluster_deploy_delete(self, cluster=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type cluster: cluster_name, cluster_id
    :param cluster: Keyword argument tuple.

    :type cluster_name: unicode
    :param cluster_name: **cluster** tuple argument:  Name for the Cluster (MAX: 64 Characters)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,63})'

    :type cluster_id: long
    :param cluster_id: **cluster** tuple argument:  Id for the Cluster (Range: 1 - 65535

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.cluster', 'pybind.slxos.v16r_1_00b.brocade_mct', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'cluster', 'keyval': 'cluster_name, cluster_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'deploy'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cluster=cluster)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cluster=cluster)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cluster_designated_forwarder_hold_time_delete(self, cluster=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type cluster: cluster_name, cluster_id
    :param cluster: Keyword argument tuple.

    :type cluster_name: unicode
    :param cluster_name: **cluster** tuple argument:  Name for the Cluster (MAX: 64 Characters)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,63})'

    :type cluster_id: long
    :param cluster_id: **cluster** tuple argument:  Id for the Cluster (Range: 1 - 65535

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.cluster', 'pybind.slxos.v16r_1_00b.brocade_mct', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'cluster', 'keyval': 'cluster_name, cluster_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'designated-forwarder-hold-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cluster=cluster)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cluster=cluster)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cluster_member_vlan_delete(self, cluster=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cluster: cluster_name, cluster_id
    :param cluster: Keyword argument tuple.

    :type cluster_name: unicode
    :param cluster_name: **cluster** tuple argument:  Name for the Cluster (MAX: 64 Characters)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,63})'

    :type cluster_id: long
    :param cluster_id: **cluster** tuple argument:  Id for the Cluster (Range: 1 - 65535

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cluster', 'cluster')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cluster.member_vlan', 'pybind.slxos.v16r_1_00b.brocade_mct', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_name, cluster_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cluster=cluster)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cluster=cluster)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cluster_member_vlan_add_delete(self, cluster=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cluster: cluster_name, cluster_id
    :param cluster: Keyword argument tuple.

    :type cluster_name: unicode
    :param cluster_name: **cluster** tuple argument:  Name for the Cluster (MAX: 64 Characters)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,63})'

    :type cluster_id: long
    :param cluster_id: **cluster** tuple argument:  Id for the Cluster (Range: 1 - 65535

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cluster', 'cluster')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cluster.member_vlan', 'pybind.slxos.v16r_1_00b.brocade_mct', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_name, cluster_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'add'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cluster=cluster)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cluster=cluster)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cluster_member_vlan_remove_delete(self, cluster=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cluster: cluster_name, cluster_id
    :param cluster: Keyword argument tuple.

    :type cluster_name: unicode
    :param cluster_name: **cluster** tuple argument:  Name for the Cluster (MAX: 64 Characters)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,63})'

    :type cluster_id: long
    :param cluster_id: **cluster** tuple argument:  Id for the Cluster (Range: 1 - 65535

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cluster', 'cluster')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cluster.member_vlan', 'pybind.slxos.v16r_1_00b.brocade_mct', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_name, cluster_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'remove'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cluster=cluster)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cluster=cluster)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cluster_peer_delete(self, cluster=None, peer=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cluster: cluster_name, cluster_id
    :param cluster: Keyword argument tuple.

    :type cluster_name: unicode
    :param cluster_name: **cluster** tuple argument:  Name for the Cluster (MAX: 64 Characters)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,63})'

    :type cluster_id: long
    :param cluster_id: **cluster** tuple argument:  Id for the Cluster (Range: 1 - 65535

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type peer: peer_ip
    :param peer: Keyword argument tuple.

    :type peer_ip: unicode
    :param peer_ip: **peer** tuple argument:  MCT Peer node IP Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cluster', 'cluster')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cluster.peer', 'pybind.slxos.v16r_1_00b.brocade_mct', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_name, cluster_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'peer', 'keyval': 'peer_ip', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cluster=cluster, peer=peer)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cluster=cluster, peer=peer)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def control_plane_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.control_plane', 'pybind.slxos.v16r_1_00b.brocade_control_plane', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def control_plane_ipv6_subnet_rate_limit_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.control_plane.ipv6.subnet_rate_limit', 'pybind.slxos.v16r_1_00b.brocade_control_plane', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def control_plane_ipv6_subnet_rate_limit_cbr_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.control_plane.ipv6.subnet_rate_limit', 'pybind.slxos.v16r_1_00b.brocade_control_plane', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cbr'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def control_plane_ipv6_subnet_rate_limit_cir_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.control_plane.ipv6.subnet_rate_limit', 'pybind.slxos.v16r_1_00b.brocade_control_plane', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cir'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def copy_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.copy', 'pybind.nos.v6_0_2c.brocade_ras', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.copy', 'pybind.nos.v7_0_1b.brocade_ras', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.copy', 'pybind.nos.v7_1_0.brocade_ras', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.copy', 'pybind.slxos.v16r_1_00b.brocade_ras', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def counts_state_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.counts_state', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def counts_state_areamis_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.counts_state', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'areamis'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def counts_state_bad_lsp_log_delete(self, bad_lsp_log=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type bad_lsp_log: type_index
    :param bad_lsp_log: Keyword argument tuple.

    :type type_index: int
    :param type_index: **bad_lsp_log** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.counts_state.bad_lsp_log', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'bad_lsp_log', 'keyval': 'type_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bad_lsp_log=bad_lsp_log)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bad_lsp_log=bad_lsp_log)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def counts_state_bad_lsp_log_l1_count_delete(self, bad_lsp_log=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type bad_lsp_log: type_index
    :param bad_lsp_log: Keyword argument tuple.

    :type type_index: int
    :param type_index: **bad_lsp_log** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.counts_state.bad_lsp_log', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'bad_lsp_log', 'keyval': 'type_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'l1-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bad_lsp_log=bad_lsp_log)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bad_lsp_log=bad_lsp_log)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def counts_state_bad_lsp_log_l2_count_delete(self, bad_lsp_log=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type bad_lsp_log: type_index
    :param bad_lsp_log: Keyword argument tuple.

    :type type_index: int
    :param type_index: **bad_lsp_log** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.counts_state.bad_lsp_log', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'bad_lsp_log', 'keyval': 'type_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'l2-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bad_lsp_log=bad_lsp_log)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bad_lsp_log=bad_lsp_log)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def counts_state_bad_lsp_log_time_stamp_delete(self, bad_lsp_log=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type bad_lsp_log: type_index
    :param bad_lsp_log: Keyword argument tuple.

    :type type_index: int
    :param type_index: **bad_lsp_log** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.counts_state.bad_lsp_log', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'bad_lsp_log', 'keyval': 'type_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'time-stamp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bad_lsp_log=bad_lsp_log)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bad_lsp_log=bad_lsp_log)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def counts_state_badidlen_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.counts_state', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'badidlen'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def counts_state_circ_l1authfail_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.counts_state', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'circ-l1authfail'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def counts_state_circ_l2authfail_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.counts_state', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'circ-l2authfail'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def counts_state_csnp_l1authfail_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.counts_state', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'csnp-l1authfail'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def counts_state_csnp_l2authfail_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.counts_state', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'csnp-l2authfail'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def counts_state_l1dbol_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.counts_state', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'l1dbol'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def counts_state_l2dbol_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.counts_state', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'l2dbol'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def counts_state_maxareamis_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.counts_state', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'maxareamis'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def counts_state_ownpurge_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.counts_state', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ownpurge'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def counts_state_psnp_l1authfail_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.counts_state', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'psnp-l1authfail'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def counts_state_psnp_l2authfail_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.counts_state', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'psnp-l2authfail'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def counts_state_seqerr_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.counts_state', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'seqerr'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def counts_state_seqskip_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.counts_state', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'seqskip'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cpu_cfg_state_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.cpu_cfg_state', 'pybind.slxos.v16r_1_00b.brocade_qos_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cpu_cfg_state_cpu_cfg_slot_delete(self, cpu_cfg_slot=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type cpu_cfg_slot: slot_id
    :param cpu_cfg_slot: Keyword argument tuple.

    :type slot_id: int
    :param slot_id: **cpu_cfg_slot** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.cpu_cfg_state.cpu_cfg_slot', 'pybind.slxos.v16r_1_00b.brocade_qos_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'cpu_cfg_slot', 'keyval': 'slot_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_cfg_slot=cpu_cfg_slot)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_cfg_slot=cpu_cfg_slot)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cpu_cfg_state_cpu_cfg_slot_cpu_cfg_data_delete(self, cpu_cfg_slot=None, cpu_cfg_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_cfg_slot: slot_id
    :param cpu_cfg_slot: Keyword argument tuple.

    :type slot_id: int
    :param slot_id: **cpu_cfg_slot** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type cpu_cfg_data: shaper_rate
    :param cpu_cfg_data: Keyword argument tuple.

    :type shaper_rate: long
    :param shaper_rate: **cpu_cfg_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cpu_cfg_state.cpu_cfg_slot', u'cpu_cfg_slot')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cpu_cfg_state.cpu_cfg_slot.cpu_cfg_data', 'pybind.slxos.v16r_1_00b.brocade_qos_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'slot_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'cpu_cfg_data', 'keyval': 'shaper_rate', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_cfg_slot=cpu_cfg_slot, cpu_cfg_data=cpu_cfg_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_cfg_slot=cpu_cfg_slot, cpu_cfg_data=cpu_cfg_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cpu_cfg_state_cpu_cfg_slot_cpu_cfg_data_burst_size_delete(self, cpu_cfg_slot=None, cpu_cfg_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_cfg_slot: slot_id
    :param cpu_cfg_slot: Keyword argument tuple.

    :type slot_id: int
    :param slot_id: **cpu_cfg_slot** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type cpu_cfg_data: shaper_rate
    :param cpu_cfg_data: Keyword argument tuple.

    :type shaper_rate: long
    :param shaper_rate: **cpu_cfg_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cpu_cfg_state.cpu_cfg_slot', u'cpu_cfg_slot')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cpu_cfg_state.cpu_cfg_slot.cpu_cfg_data', 'pybind.slxos.v16r_1_00b.brocade_qos_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'slot_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'cpu_cfg_data', 'keyval': 'shaper_rate', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'burst-size'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_cfg_slot=cpu_cfg_slot, cpu_cfg_data=cpu_cfg_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_cfg_slot=cpu_cfg_slot, cpu_cfg_data=cpu_cfg_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cpu_cfg_state_cpu_cfg_slot_cpu_cfg_data_wfq_value_delete(self, cpu_cfg_slot=None, cpu_cfg_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_cfg_slot: slot_id
    :param cpu_cfg_slot: Keyword argument tuple.

    :type slot_id: int
    :param slot_id: **cpu_cfg_slot** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type cpu_cfg_data: shaper_rate
    :param cpu_cfg_data: Keyword argument tuple.

    :type shaper_rate: long
    :param shaper_rate: **cpu_cfg_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cpu_cfg_state.cpu_cfg_slot', u'cpu_cfg_slot')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cpu_cfg_state.cpu_cfg_slot.cpu_cfg_data', 'pybind.slxos.v16r_1_00b.brocade_qos_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'slot_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'cpu_cfg_data', 'keyval': 'shaper_rate', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'wfq-value'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_cfg_slot=cpu_cfg_slot, cpu_cfg_data=cpu_cfg_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_cfg_slot=cpu_cfg_slot, cpu_cfg_data=cpu_cfg_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cpu_cfg_state_cpu_cfg_slot_cpu_cfg_group_delete(self, cpu_cfg_slot=None, cpu_cfg_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_cfg_slot: slot_id
    :param cpu_cfg_slot: Keyword argument tuple.

    :type slot_id: int
    :param slot_id: **cpu_cfg_slot** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type cpu_cfg_group: group_id
    :param cpu_cfg_group: Keyword argument tuple.

    :type group_id: int
    :param group_id: **cpu_cfg_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cpu_cfg_state.cpu_cfg_slot', u'cpu_cfg_slot')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cpu_cfg_state.cpu_cfg_slot.cpu_cfg_group', 'pybind.slxos.v16r_1_00b.brocade_qos_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'slot_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'cpu_cfg_group', 'keyval': 'group_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_cfg_slot=cpu_cfg_slot, cpu_cfg_group=cpu_cfg_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_cfg_slot=cpu_cfg_slot, cpu_cfg_group=cpu_cfg_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cpu_cfg_state_cpu_cfg_slot_cpu_cfg_group_cpu_cfg_data_delete(self, cpu_cfg_slot=None, cpu_cfg_group=None, cpu_cfg_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_cfg_slot: slot_id
    :param cpu_cfg_slot: Keyword argument tuple.

    :type slot_id: int
    :param slot_id: **cpu_cfg_slot** tuple argument.

        * range restriction: ::

            ['0..255']

    :type cpu_cfg_group: group_id
    :param cpu_cfg_group: Keyword argument tuple.

    :type group_id: int
    :param group_id: **cpu_cfg_group** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type cpu_cfg_data: shaper_rate
    :param cpu_cfg_data: Keyword argument tuple.

    :type shaper_rate: long
    :param shaper_rate: **cpu_cfg_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cpu_cfg_state.cpu_cfg_slot', u'cpu_cfg_slot'), ('pybind.slxos.v16r_1_00b.cpu_cfg_state.cpu_cfg_slot.cpu_cfg_group', u'cpu_cfg_group')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cpu_cfg_state.cpu_cfg_slot.cpu_cfg_group.cpu_cfg_data', 'pybind.slxos.v16r_1_00b.brocade_qos_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'slot_id', 'extra_keyval': ''}, {'keyval': 'group_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'cpu_cfg_data', 'keyval': 'shaper_rate', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_cfg_slot=cpu_cfg_slot, cpu_cfg_group=cpu_cfg_group, cpu_cfg_data=cpu_cfg_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_cfg_slot=cpu_cfg_slot, cpu_cfg_group=cpu_cfg_group, cpu_cfg_data=cpu_cfg_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cpu_cfg_state_cpu_cfg_slot_cpu_cfg_group_cpu_cfg_data_burst_size_delete(self, cpu_cfg_slot=None, cpu_cfg_group=None, cpu_cfg_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_cfg_slot: slot_id
    :param cpu_cfg_slot: Keyword argument tuple.

    :type slot_id: int
    :param slot_id: **cpu_cfg_slot** tuple argument.

        * range restriction: ::

            ['0..255']

    :type cpu_cfg_group: group_id
    :param cpu_cfg_group: Keyword argument tuple.

    :type group_id: int
    :param group_id: **cpu_cfg_group** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type cpu_cfg_data: shaper_rate
    :param cpu_cfg_data: Keyword argument tuple.

    :type shaper_rate: long
    :param shaper_rate: **cpu_cfg_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cpu_cfg_state.cpu_cfg_slot', u'cpu_cfg_slot'), ('pybind.slxos.v16r_1_00b.cpu_cfg_state.cpu_cfg_slot.cpu_cfg_group', u'cpu_cfg_group')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cpu_cfg_state.cpu_cfg_slot.cpu_cfg_group.cpu_cfg_data', 'pybind.slxos.v16r_1_00b.brocade_qos_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'slot_id', 'extra_keyval': ''}, {'keyval': 'group_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'cpu_cfg_data', 'keyval': 'shaper_rate', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'burst-size'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_cfg_slot=cpu_cfg_slot, cpu_cfg_group=cpu_cfg_group, cpu_cfg_data=cpu_cfg_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_cfg_slot=cpu_cfg_slot, cpu_cfg_group=cpu_cfg_group, cpu_cfg_data=cpu_cfg_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cpu_cfg_state_cpu_cfg_slot_cpu_cfg_group_cpu_cfg_data_wfq_value_delete(self, cpu_cfg_slot=None, cpu_cfg_group=None, cpu_cfg_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_cfg_slot: slot_id
    :param cpu_cfg_slot: Keyword argument tuple.

    :type slot_id: int
    :param slot_id: **cpu_cfg_slot** tuple argument.

        * range restriction: ::

            ['0..255']

    :type cpu_cfg_group: group_id
    :param cpu_cfg_group: Keyword argument tuple.

    :type group_id: int
    :param group_id: **cpu_cfg_group** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type cpu_cfg_data: shaper_rate
    :param cpu_cfg_data: Keyword argument tuple.

    :type shaper_rate: long
    :param shaper_rate: **cpu_cfg_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cpu_cfg_state.cpu_cfg_slot', u'cpu_cfg_slot'), ('pybind.slxos.v16r_1_00b.cpu_cfg_state.cpu_cfg_slot.cpu_cfg_group', u'cpu_cfg_group')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cpu_cfg_state.cpu_cfg_slot.cpu_cfg_group.cpu_cfg_data', 'pybind.slxos.v16r_1_00b.brocade_qos_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'slot_id', 'extra_keyval': ''}, {'keyval': 'group_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'cpu_cfg_data', 'keyval': 'shaper_rate', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'wfq-value'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_cfg_slot=cpu_cfg_slot, cpu_cfg_group=cpu_cfg_group, cpu_cfg_data=cpu_cfg_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_cfg_slot=cpu_cfg_slot, cpu_cfg_group=cpu_cfg_group, cpu_cfg_data=cpu_cfg_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cpu_cfg_state_cpu_cfg_slot_cpu_cfg_group_cpu_cfg_prio_delete(self, cpu_cfg_slot=None, cpu_cfg_group=None, cpu_cfg_prio=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_cfg_slot: slot_id
    :param cpu_cfg_slot: Keyword argument tuple.

    :type slot_id: int
    :param slot_id: **cpu_cfg_slot** tuple argument.

        * range restriction: ::

            ['0..255']

    :type cpu_cfg_group: group_id
    :param cpu_cfg_group: Keyword argument tuple.

    :type group_id: int
    :param group_id: **cpu_cfg_group** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type cpu_cfg_prio: prio_id
    :param cpu_cfg_prio: Keyword argument tuple.

    :type prio_id: int
    :param prio_id: **cpu_cfg_prio** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cpu_cfg_state.cpu_cfg_slot', u'cpu_cfg_slot'), ('pybind.slxos.v16r_1_00b.cpu_cfg_state.cpu_cfg_slot.cpu_cfg_group', u'cpu_cfg_group')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cpu_cfg_state.cpu_cfg_slot.cpu_cfg_group.cpu_cfg_prio', 'pybind.slxos.v16r_1_00b.brocade_qos_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'slot_id', 'extra_keyval': ''}, {'keyval': 'group_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'cpu_cfg_prio', 'keyval': 'prio_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_cfg_slot=cpu_cfg_slot, cpu_cfg_group=cpu_cfg_group, cpu_cfg_prio=cpu_cfg_prio)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_cfg_slot=cpu_cfg_slot, cpu_cfg_group=cpu_cfg_group, cpu_cfg_prio=cpu_cfg_prio)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cpu_cfg_state_cpu_cfg_slot_cpu_cfg_group_cpu_cfg_prio_cpu_cfg_data_delete(self, cpu_cfg_slot=None, cpu_cfg_group=None, cpu_cfg_prio=None, cpu_cfg_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_cfg_slot: slot_id
    :param cpu_cfg_slot: Keyword argument tuple.

    :type slot_id: int
    :param slot_id: **cpu_cfg_slot** tuple argument.

        * range restriction: ::

            ['0..255']

    :type cpu_cfg_group: group_id
    :param cpu_cfg_group: Keyword argument tuple.

    :type group_id: int
    :param group_id: **cpu_cfg_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type cpu_cfg_prio: prio_id
    :param cpu_cfg_prio: Keyword argument tuple.

    :type prio_id: int
    :param prio_id: **cpu_cfg_prio** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type cpu_cfg_data: shaper_rate
    :param cpu_cfg_data: Keyword argument tuple.

    :type shaper_rate: long
    :param shaper_rate: **cpu_cfg_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cpu_cfg_state.cpu_cfg_slot', u'cpu_cfg_slot'), ('pybind.slxos.v16r_1_00b.cpu_cfg_state.cpu_cfg_slot.cpu_cfg_group', u'cpu_cfg_group'), ('pybind.slxos.v16r_1_00b.cpu_cfg_state.cpu_cfg_slot.cpu_cfg_group.cpu_cfg_prio', u'cpu_cfg_prio')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cpu_cfg_state.cpu_cfg_slot.cpu_cfg_group.cpu_cfg_prio.cpu_cfg_data', 'pybind.slxos.v16r_1_00b.brocade_qos_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'slot_id', 'extra_keyval': ''}, {'keyval': 'group_id', 'extra_keyval': ''}, {'keyval': 'prio_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'cpu_cfg_data', 'keyval': 'shaper_rate', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_cfg_slot=cpu_cfg_slot, cpu_cfg_group=cpu_cfg_group, cpu_cfg_prio=cpu_cfg_prio, cpu_cfg_data=cpu_cfg_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_cfg_slot=cpu_cfg_slot, cpu_cfg_group=cpu_cfg_group, cpu_cfg_prio=cpu_cfg_prio, cpu_cfg_data=cpu_cfg_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cpu_cfg_state_cpu_cfg_slot_cpu_cfg_group_cpu_cfg_prio_cpu_cfg_data_burst_size_delete(self, cpu_cfg_slot=None, cpu_cfg_group=None, cpu_cfg_prio=None, cpu_cfg_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_cfg_slot: slot_id
    :param cpu_cfg_slot: Keyword argument tuple.

    :type slot_id: int
    :param slot_id: **cpu_cfg_slot** tuple argument.

        * range restriction: ::

            ['0..255']

    :type cpu_cfg_group: group_id
    :param cpu_cfg_group: Keyword argument tuple.

    :type group_id: int
    :param group_id: **cpu_cfg_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type cpu_cfg_prio: prio_id
    :param cpu_cfg_prio: Keyword argument tuple.

    :type prio_id: int
    :param prio_id: **cpu_cfg_prio** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type cpu_cfg_data: shaper_rate
    :param cpu_cfg_data: Keyword argument tuple.

    :type shaper_rate: long
    :param shaper_rate: **cpu_cfg_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cpu_cfg_state.cpu_cfg_slot', u'cpu_cfg_slot'), ('pybind.slxos.v16r_1_00b.cpu_cfg_state.cpu_cfg_slot.cpu_cfg_group', u'cpu_cfg_group'), ('pybind.slxos.v16r_1_00b.cpu_cfg_state.cpu_cfg_slot.cpu_cfg_group.cpu_cfg_prio', u'cpu_cfg_prio')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cpu_cfg_state.cpu_cfg_slot.cpu_cfg_group.cpu_cfg_prio.cpu_cfg_data', 'pybind.slxos.v16r_1_00b.brocade_qos_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'slot_id', 'extra_keyval': ''}, {'keyval': 'group_id', 'extra_keyval': ''}, {'keyval': 'prio_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'cpu_cfg_data', 'keyval': 'shaper_rate', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'burst-size'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_cfg_slot=cpu_cfg_slot, cpu_cfg_group=cpu_cfg_group, cpu_cfg_prio=cpu_cfg_prio, cpu_cfg_data=cpu_cfg_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_cfg_slot=cpu_cfg_slot, cpu_cfg_group=cpu_cfg_group, cpu_cfg_prio=cpu_cfg_prio, cpu_cfg_data=cpu_cfg_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cpu_cfg_state_cpu_cfg_slot_cpu_cfg_group_cpu_cfg_prio_cpu_cfg_data_wfq_value_delete(self, cpu_cfg_slot=None, cpu_cfg_group=None, cpu_cfg_prio=None, cpu_cfg_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_cfg_slot: slot_id
    :param cpu_cfg_slot: Keyword argument tuple.

    :type slot_id: int
    :param slot_id: **cpu_cfg_slot** tuple argument.

        * range restriction: ::

            ['0..255']

    :type cpu_cfg_group: group_id
    :param cpu_cfg_group: Keyword argument tuple.

    :type group_id: int
    :param group_id: **cpu_cfg_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type cpu_cfg_prio: prio_id
    :param cpu_cfg_prio: Keyword argument tuple.

    :type prio_id: int
    :param prio_id: **cpu_cfg_prio** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type cpu_cfg_data: shaper_rate
    :param cpu_cfg_data: Keyword argument tuple.

    :type shaper_rate: long
    :param shaper_rate: **cpu_cfg_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cpu_cfg_state.cpu_cfg_slot', u'cpu_cfg_slot'), ('pybind.slxos.v16r_1_00b.cpu_cfg_state.cpu_cfg_slot.cpu_cfg_group', u'cpu_cfg_group'), ('pybind.slxos.v16r_1_00b.cpu_cfg_state.cpu_cfg_slot.cpu_cfg_group.cpu_cfg_prio', u'cpu_cfg_prio')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cpu_cfg_state.cpu_cfg_slot.cpu_cfg_group.cpu_cfg_prio.cpu_cfg_data', 'pybind.slxos.v16r_1_00b.brocade_qos_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'slot_id', 'extra_keyval': ''}, {'keyval': 'group_id', 'extra_keyval': ''}, {'keyval': 'prio_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'cpu_cfg_data', 'keyval': 'shaper_rate', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'wfq-value'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_cfg_slot=cpu_cfg_slot, cpu_cfg_group=cpu_cfg_group, cpu_cfg_prio=cpu_cfg_prio, cpu_cfg_data=cpu_cfg_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_cfg_slot=cpu_cfg_slot, cpu_cfg_group=cpu_cfg_group, cpu_cfg_prio=cpu_cfg_prio, cpu_cfg_data=cpu_cfg_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cpu_info_state_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.cpu_info_state', 'pybind.slxos.v16r_1_00b.brocade_qos_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cpu_info_state_cpu_info_egid_delete(self, cpu_info_egid=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type cpu_info_egid: group_id
    :param cpu_info_egid: Keyword argument tuple.

    :type group_id: int
    :param group_id: **cpu_info_egid** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.cpu_info_state.cpu_info_egid', 'pybind.slxos.v16r_1_00b.brocade_qos_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'cpu_info_egid', 'keyval': 'group_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_info_egid=cpu_info_egid)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_info_egid=cpu_info_egid)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cpu_info_state_cpu_info_egid_description_delete(self, cpu_info_egid=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type cpu_info_egid: group_id
    :param cpu_info_egid: Keyword argument tuple.

    :type group_id: int
    :param group_id: **cpu_info_egid** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.cpu_info_state.cpu_info_egid', 'pybind.slxos.v16r_1_00b.brocade_qos_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'cpu_info_egid', 'keyval': 'group_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'description'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_info_egid=cpu_info_egid)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_info_egid=cpu_info_egid)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cpu_info_state_cpu_info_egid_egid_delete(self, cpu_info_egid=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type cpu_info_egid: group_id
    :param cpu_info_egid: Keyword argument tuple.

    :type group_id: int
    :param group_id: **cpu_info_egid** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.cpu_info_state.cpu_info_egid', 'pybind.slxos.v16r_1_00b.brocade_qos_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'cpu_info_egid', 'keyval': 'group_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'egid'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_info_egid=cpu_info_egid)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_info_egid=cpu_info_egid)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cpu_info_state_cpu_info_egid_name_delete(self, cpu_info_egid=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type cpu_info_egid: group_id
    :param cpu_info_egid: Keyword argument tuple.

    :type group_id: int
    :param group_id: **cpu_info_egid** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.cpu_info_state.cpu_info_egid', 'pybind.slxos.v16r_1_00b.brocade_qos_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'cpu_info_egid', 'keyval': 'group_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_info_egid=cpu_info_egid)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_info_egid=cpu_info_egid)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cpu_interface_state_delete(self, cpu_interface_state=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'cpu_interface_state', 'keyval': 'ifname', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cpu_interface_state_gos_stats_delete(self, cpu_interface_state=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state.gos_stats', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cpu_interface_state_gos_stats_link_status_delete(self, cpu_interface_state=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state.gos_stats', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'link-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cpu_interface_state_gos_stats_rx_bcast_pkts_cnt_delete(self, cpu_interface_state=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state.gos_stats', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rx-bcast-pkts-cnt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cpu_interface_state_gos_stats_rx_bytes_cnt_delete(self, cpu_interface_state=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state.gos_stats', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rx-bytes-cnt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cpu_interface_state_gos_stats_rx_crc_error_cnt_delete(self, cpu_interface_state=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state.gos_stats', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rx-crc-error-cnt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cpu_interface_state_gos_stats_rx_drop_cnt_delete(self, cpu_interface_state=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state.gos_stats', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rx-drop-cnt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cpu_interface_state_gos_stats_rx_errors_cnt_delete(self, cpu_interface_state=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state.gos_stats', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rx-errors-cnt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cpu_interface_state_gos_stats_rx_fifo_error_cnt_delete(self, cpu_interface_state=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state.gos_stats', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rx-fifo-error-cnt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cpu_interface_state_gos_stats_rx_flow_control_xoff_cnt_delete(self, cpu_interface_state=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state.gos_stats', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rx-flow-control-xoff-cnt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cpu_interface_state_gos_stats_rx_flow_control_xon_cnt_delete(self, cpu_interface_state=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state.gos_stats', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rx-flow-control-xon-cnt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cpu_interface_state_gos_stats_rx_frame_error_cnt_delete(self, cpu_interface_state=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state.gos_stats', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rx-frame-error-cnt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cpu_interface_state_gos_stats_rx_good_pkts_cnt_delete(self, cpu_interface_state=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state.gos_stats', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rx-good-pkts-cnt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cpu_interface_state_gos_stats_rx_mcast_pkts_cnt_delete(self, cpu_interface_state=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state.gos_stats', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rx-mcast-pkts-cnt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cpu_interface_state_gos_stats_rx_missed_errors_cnt_delete(self, cpu_interface_state=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state.gos_stats', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rx-missed-errors-cnt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cpu_interface_state_gos_stats_rx_no_dma_resource_cnt_delete(self, cpu_interface_state=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state.gos_stats', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rx-no-dma-resource-cnt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cpu_interface_state_gos_stats_rx_overrun_error_cnt_delete(self, cpu_interface_state=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state.gos_stats', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rx-overrun-error-cnt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cpu_interface_state_gos_stats_rx_pkts_1024bytes_max_cnt_delete(self, cpu_interface_state=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state.gos_stats', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rx-pkts-1024bytes-max-cnt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cpu_interface_state_gos_stats_rx_pkts_128_255bytes_cnt_delete(self, cpu_interface_state=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state.gos_stats', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rx-pkts-128-255bytes-cnt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cpu_interface_state_gos_stats_rx_pkts_256_511bytes_cnt_delete(self, cpu_interface_state=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state.gos_stats', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rx-pkts-256-511bytes-cnt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cpu_interface_state_gos_stats_rx_pkts_512_1023bytes_cnt_delete(self, cpu_interface_state=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state.gos_stats', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rx-pkts-512-1023bytes-cnt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cpu_interface_state_gos_stats_rx_pkts_64_127bytes_cnt_delete(self, cpu_interface_state=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state.gos_stats', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rx-pkts-64-127bytes-cnt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cpu_interface_state_gos_stats_rx_pkts_64bytes_cnt_delete(self, cpu_interface_state=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state.gos_stats', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rx-pkts-64bytes-cnt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cpu_interface_state_gos_stats_rx_pkts_cnt_delete(self, cpu_interface_state=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state.gos_stats', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rx-pkts-cnt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cpu_interface_state_gos_stats_tx_aborted_error_cnt_delete(self, cpu_interface_state=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state.gos_stats', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tx-aborted-error-cnt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cpu_interface_state_gos_stats_tx_bcast_pkts_cnt_delete(self, cpu_interface_state=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state.gos_stats', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tx-bcast-pkts-cnt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cpu_interface_state_gos_stats_tx_bytes_cnt_delete(self, cpu_interface_state=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state.gos_stats', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tx-bytes-cnt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cpu_interface_state_gos_stats_tx_carrier_error_cnt_delete(self, cpu_interface_state=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state.gos_stats', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tx-carrier-error-cnt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cpu_interface_state_gos_stats_tx_drop_cnt_delete(self, cpu_interface_state=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state.gos_stats', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tx-drop-cnt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cpu_interface_state_gos_stats_tx_errors_cnt_delete(self, cpu_interface_state=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state.gos_stats', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tx-errors-cnt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cpu_interface_state_gos_stats_tx_fifo_error_cnt_delete(self, cpu_interface_state=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state.gos_stats', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tx-fifo-error-cnt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cpu_interface_state_gos_stats_tx_flow_control_xoff_cnt_delete(self, cpu_interface_state=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state.gos_stats', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tx-flow-control-xoff-cnt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cpu_interface_state_gos_stats_tx_flow_control_xon_cnt_delete(self, cpu_interface_state=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state.gos_stats', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tx-flow-control-xon-cnt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cpu_interface_state_gos_stats_tx_mcast_pkts_cnt_delete(self, cpu_interface_state=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state.gos_stats', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tx-mcast-pkts-cnt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cpu_interface_state_gos_stats_tx_overrun_error_cnt_delete(self, cpu_interface_state=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state.gos_stats', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tx-overrun-error-cnt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cpu_interface_state_gos_stats_tx_pkts_1024bytes_max_cnt_delete(self, cpu_interface_state=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state.gos_stats', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tx-pkts-1024bytes-max-cnt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cpu_interface_state_gos_stats_tx_pkts_128_255bytes_cnt_delete(self, cpu_interface_state=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state.gos_stats', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tx-pkts-128-255bytes-cnt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cpu_interface_state_gos_stats_tx_pkts_256_511bytes_cnt_delete(self, cpu_interface_state=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state.gos_stats', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tx-pkts-256-511bytes-cnt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cpu_interface_state_gos_stats_tx_pkts_512_1023bytes_cnt_delete(self, cpu_interface_state=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state.gos_stats', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tx-pkts-512-1023bytes-cnt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cpu_interface_state_gos_stats_tx_pkts_64_127bytes_cnt_delete(self, cpu_interface_state=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state.gos_stats', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tx-pkts-64-127bytes-cnt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cpu_interface_state_gos_stats_tx_pkts_64bytes_cnt_delete(self, cpu_interface_state=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state.gos_stats', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tx-pkts-64bytes-cnt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cpu_interface_state_gos_stats_tx_pkts_cnt_delete(self, cpu_interface_state=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state.gos_stats', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tx-pkts-cnt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cpu_interface_state_gos_stats_tx_timeout_cnt_delete(self, cpu_interface_state=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state.gos_stats', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tx-timeout-cnt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cpu_interface_state_host_stats_delete(self, cpu_interface_state=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state.host_stats', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cpu_interface_state_host_stats_link_status_delete(self, cpu_interface_state=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state.host_stats', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'link-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cpu_interface_state_host_stats_rx_bcast_pkts_cnt_delete(self, cpu_interface_state=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state.host_stats', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rx-bcast-pkts-cnt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cpu_interface_state_host_stats_rx_bytes_cnt_delete(self, cpu_interface_state=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state.host_stats', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rx-bytes-cnt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cpu_interface_state_host_stats_rx_crc_error_cnt_delete(self, cpu_interface_state=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state.host_stats', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rx-crc-error-cnt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cpu_interface_state_host_stats_rx_drop_cnt_delete(self, cpu_interface_state=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state.host_stats', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rx-drop-cnt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cpu_interface_state_host_stats_rx_errors_cnt_delete(self, cpu_interface_state=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state.host_stats', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rx-errors-cnt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cpu_interface_state_host_stats_rx_fifo_error_cnt_delete(self, cpu_interface_state=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state.host_stats', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rx-fifo-error-cnt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cpu_interface_state_host_stats_rx_flow_control_xoff_cnt_delete(self, cpu_interface_state=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state.host_stats', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rx-flow-control-xoff-cnt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cpu_interface_state_host_stats_rx_flow_control_xon_cnt_delete(self, cpu_interface_state=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state.host_stats', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rx-flow-control-xon-cnt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cpu_interface_state_host_stats_rx_frame_error_cnt_delete(self, cpu_interface_state=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state.host_stats', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rx-frame-error-cnt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cpu_interface_state_host_stats_rx_good_pkts_cnt_delete(self, cpu_interface_state=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state.host_stats', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rx-good-pkts-cnt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cpu_interface_state_host_stats_rx_mcast_pkts_cnt_delete(self, cpu_interface_state=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state.host_stats', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rx-mcast-pkts-cnt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cpu_interface_state_host_stats_rx_missed_errors_cnt_delete(self, cpu_interface_state=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state.host_stats', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rx-missed-errors-cnt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cpu_interface_state_host_stats_rx_no_dma_resource_cnt_delete(self, cpu_interface_state=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state.host_stats', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rx-no-dma-resource-cnt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cpu_interface_state_host_stats_rx_overrun_error_cnt_delete(self, cpu_interface_state=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state.host_stats', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rx-overrun-error-cnt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cpu_interface_state_host_stats_rx_pkts_1024bytes_max_cnt_delete(self, cpu_interface_state=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state.host_stats', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rx-pkts-1024bytes-max-cnt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cpu_interface_state_host_stats_rx_pkts_128_255bytes_cnt_delete(self, cpu_interface_state=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state.host_stats', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rx-pkts-128-255bytes-cnt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cpu_interface_state_host_stats_rx_pkts_256_511bytes_cnt_delete(self, cpu_interface_state=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state.host_stats', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rx-pkts-256-511bytes-cnt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cpu_interface_state_host_stats_rx_pkts_512_1023bytes_cnt_delete(self, cpu_interface_state=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state.host_stats', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rx-pkts-512-1023bytes-cnt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cpu_interface_state_host_stats_rx_pkts_64_127bytes_cnt_delete(self, cpu_interface_state=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state.host_stats', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rx-pkts-64-127bytes-cnt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cpu_interface_state_host_stats_rx_pkts_64bytes_cnt_delete(self, cpu_interface_state=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state.host_stats', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rx-pkts-64bytes-cnt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cpu_interface_state_host_stats_rx_pkts_cnt_delete(self, cpu_interface_state=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state.host_stats', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rx-pkts-cnt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cpu_interface_state_host_stats_tx_aborted_error_cnt_delete(self, cpu_interface_state=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state.host_stats', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tx-aborted-error-cnt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cpu_interface_state_host_stats_tx_bcast_pkts_cnt_delete(self, cpu_interface_state=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state.host_stats', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tx-bcast-pkts-cnt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cpu_interface_state_host_stats_tx_bytes_cnt_delete(self, cpu_interface_state=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state.host_stats', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tx-bytes-cnt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cpu_interface_state_host_stats_tx_carrier_error_cnt_delete(self, cpu_interface_state=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state.host_stats', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tx-carrier-error-cnt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cpu_interface_state_host_stats_tx_drop_cnt_delete(self, cpu_interface_state=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state.host_stats', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tx-drop-cnt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cpu_interface_state_host_stats_tx_errors_cnt_delete(self, cpu_interface_state=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state.host_stats', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tx-errors-cnt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cpu_interface_state_host_stats_tx_fifo_error_cnt_delete(self, cpu_interface_state=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state.host_stats', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tx-fifo-error-cnt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cpu_interface_state_host_stats_tx_flow_control_xoff_cnt_delete(self, cpu_interface_state=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state.host_stats', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tx-flow-control-xoff-cnt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cpu_interface_state_host_stats_tx_flow_control_xon_cnt_delete(self, cpu_interface_state=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state.host_stats', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tx-flow-control-xon-cnt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cpu_interface_state_host_stats_tx_mcast_pkts_cnt_delete(self, cpu_interface_state=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state.host_stats', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tx-mcast-pkts-cnt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cpu_interface_state_host_stats_tx_overrun_error_cnt_delete(self, cpu_interface_state=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state.host_stats', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tx-overrun-error-cnt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cpu_interface_state_host_stats_tx_pkts_1024bytes_max_cnt_delete(self, cpu_interface_state=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state.host_stats', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tx-pkts-1024bytes-max-cnt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cpu_interface_state_host_stats_tx_pkts_128_255bytes_cnt_delete(self, cpu_interface_state=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state.host_stats', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tx-pkts-128-255bytes-cnt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cpu_interface_state_host_stats_tx_pkts_256_511bytes_cnt_delete(self, cpu_interface_state=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state.host_stats', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tx-pkts-256-511bytes-cnt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cpu_interface_state_host_stats_tx_pkts_512_1023bytes_cnt_delete(self, cpu_interface_state=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state.host_stats', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tx-pkts-512-1023bytes-cnt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cpu_interface_state_host_stats_tx_pkts_64_127bytes_cnt_delete(self, cpu_interface_state=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state.host_stats', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tx-pkts-64-127bytes-cnt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cpu_interface_state_host_stats_tx_pkts_64bytes_cnt_delete(self, cpu_interface_state=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state.host_stats', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tx-pkts-64bytes-cnt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cpu_interface_state_host_stats_tx_pkts_cnt_delete(self, cpu_interface_state=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state.host_stats', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tx-pkts-cnt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def cpu_interface_state_host_stats_tx_timeout_cnt_delete(self, cpu_interface_state=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.cpu_interface_state.host_stats', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tx-timeout-cnt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def crypto_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.crypto', 'pybind.nos.v6_0_2c.brocade_crypto_ext', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.crypto', 'pybind.nos.v7_0_1b.brocade_crypto_ext', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.crypto', 'pybind.nos.v7_1_0.brocade_crypto_ext', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.crypto', 'pybind.slxos.v16r_1_00b.brocade_crypto_ext', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def crypto_ca_delete(self, ca=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ca: trustpoint
    :param ca: Keyword argument tuple.

    :type trustpoint: unicode
    :param trustpoint: **ca** tuple argument:  Trustpoint name

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.crypto_sa.crypto.ca', 'pybind.slxos.v16r_1_00b.brocade_crypto', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ca', 'keyval': 'trustpoint', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ca=ca)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ca=ca)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def crypto_ca_keypair_delete(self, ca=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ca: trustpoint
    :param ca: Keyword argument tuple.

    :type trustpoint: unicode
    :param trustpoint: **ca** tuple argument:  Trustpoint name

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.crypto_sa.crypto.ca', 'pybind.slxos.v16r_1_00b.brocade_crypto', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ca', 'keyval': 'trustpoint', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'keypair'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ca=ca)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ca=ca)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def crypto_key_delete(self, key=None, type=None, modulus=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type key: label, type, modulus
    :param key: Keyword argument tuple.

    :type label: unicode
    :param label: **key** tuple argument:  Key Label

        * length restriction: ::

            ['1..64']

    :type type: unicode
    :param type: **key** tuple argument:  Key Type

        * enumeration restriction: ::

            ['dsa', 'rsa', 'ecdsa']

    :type modulus: long
    :param modulus: **key** tuple argument:  Key Size

        * range restriction: ::

            ['0..4294967295']

    **Instance Argument(s)**:

    :type type: unicode
    :param type: Key Type

        * enumeration restriction: ::

            ['dsa', 'rsa', 'ecdsa']

    :type modulus: long
    :param modulus: Key Size

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.crypto_sa.crypto.key', 'pybind.slxos.v16r_1_00b.brocade_crypto', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'key', 'keyval': 'label', 'extra_keyval': 'label, type, modulus'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, key=key, type=type, modulus=modulus)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, key=key, type=type, modulus=modulus)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def crypto_key_modulus_delete(self, key=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type key: label
    :param key: Keyword argument tuple.

    :type label: unicode
    :param label: **key** tuple argument:  Key Label

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.crypto_sa.crypto.key', 'pybind.slxos.v16r_1_00b.brocade_crypto', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'key', 'keyval': 'label', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'modulus'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, key=key)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, key=key)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def crypto_key_type_delete(self, key=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type key: label
    :param key: Keyword argument tuple.

    :type label: unicode
    :param label: **key** tuple argument:  Key Label

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.crypto_sa.crypto.key', 'pybind.slxos.v16r_1_00b.brocade_crypto', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'key', 'keyval': 'label', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, key=key)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, key=key)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def crypto_sa_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.crypto_sa', 'pybind.slxos.v16r_1_00b.brocade_crypto', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def dai_config_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.dai_config', 'pybind.slxos.v16r_1_00b.brocade_dai', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def destination_console_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.destination_console', 'pybind.nos.v6_0_2c.brocade_ras', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.destination_console', 'pybind.nos.v7_0_1b.brocade_ras', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.destination_console', 'pybind.nos.v7_1_0.brocade_ras', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.destination_console', 'pybind.slxos.v16r_1_00b.brocade_ras', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def dhcp_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.dhcp', 'pybind.nos.v6_0_2c.brocade_firmware', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.dhcp', 'pybind.nos.v7_0_1b.brocade_firmware', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.dhcp', 'pybind.nos.v7_1_0.brocade_firmware', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.dhcp', 'pybind.slxos.v16r_1_00b.brocade_firmware', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def diag_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.diag', 'pybind.nos.v6_0_2c.brocade_diagnostics', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.diag', 'pybind.nos.v7_0_1b.brocade_diagnostics', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.diag', 'pybind.nos.v7_1_0.brocade_diagnostics', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.diag', 'pybind.slxos.v16r_1_00b.brocade_diagnostics', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def diag_post_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.diag.post', 'pybind.nos.v6_0_2c.brocade_diagnostics', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.diag.post', 'pybind.nos.v7_0_1b.brocade_diagnostics', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.diag.post', 'pybind.nos.v7_1_0.brocade_diagnostics', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.diag.post', 'pybind.slxos.v16r_1_00b.brocade_diagnostics', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def diag_post_enable_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.diag.post', 'pybind.nos.v6_0_2c.brocade_diagnostics', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.diag.post', 'pybind.nos.v7_0_1b.brocade_diagnostics', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.diag.post', 'pybind.nos.v7_1_0.brocade_diagnostics', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.diag.post', 'pybind.slxos.v16r_1_00b.brocade_diagnostics', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def diag_post_rbridge_id_enable_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument:  Syntax: rbridgeId [rbridgeId]

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.diag.post.rbridge_id', 'pybind.nos.v6_0_2c.brocade_diagnostics', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.diag.post.rbridge_id', 'pybind.nos.v7_0_1b.brocade_diagnostics', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.diag.post.rbridge_id', 'pybind.nos.v7_1_0.brocade_diagnostics', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.diag.post.rbridge_id', 'pybind.slxos.v16r_1_00b.brocade_diagnostics', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'rbridge_id', 'keyval': 'rbridge_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def dot1x_enable_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.dot1x', 'pybind.nos.v6_0_2c.brocade_dot1x', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.dot1x', 'pybind.nos.v7_0_1b.brocade_dot1x', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.dot1x', 'pybind.nos.v7_1_0.brocade_dot1x', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.dot1x', 'pybind.slxos.v16r_1_00b.brocade_dot1x', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def dot1x_test_timeout_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.dot1x.test', 'pybind.nos.v6_0_2c.brocade_dot1x', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.dot1x.test', 'pybind.nos.v7_0_1b.brocade_dot1x', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.dot1x.test', 'pybind.nos.v7_1_0.brocade_dot1x', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.dot1x.test', 'pybind.slxos.v16r_1_00b.brocade_dot1x', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'timeout'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def dpod_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.dpod', 'pybind.nos.v6_0_2c.brocade_license', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.dpod', 'pybind.nos.v7_0_1b.brocade_license', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.dpod', 'pybind.nos.v7_1_0.brocade_license', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.dpod', 'pybind.slxos.v16r_1_00b.brocade_license', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def dpod_port_id_delete(self, port_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type port_id: port_id
    :param port_id: Keyword argument tuple.

    :type port_id: unicode
    :param port_id: **port_id** tuple argument:  Syntax: [rbridge-id/slot/port]

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.dpod.port_id', 'pybind.nos.v6_0_2c.brocade_license', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.dpod.port_id', 'pybind.nos.v7_0_1b.brocade_license', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.dpod.port_id', 'pybind.nos.v7_1_0.brocade_license', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.dpod.port_id', 'pybind.slxos.v16r_1_00b.brocade_license', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'port_id', 'keyval': 'port_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_id=port_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_id=port_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def dpod_port_id_operation_delete(self, port_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type port_id: port_id
    :param port_id: Keyword argument tuple.

    :type port_id: unicode
    :param port_id: **port_id** tuple argument:  Syntax: [rbridge-id/slot/port]

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.dpod.port_id', 'pybind.nos.v6_0_2c.brocade_license', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.dpod.port_id', 'pybind.nos.v7_0_1b.brocade_license', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.dpod.port_id', 'pybind.nos.v7_1_0.brocade_license', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.dpod.port_id', 'pybind.slxos.v16r_1_00b.brocade_license', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'port_id', 'keyval': 'port_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'operation'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_id=port_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_id=port_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def dscp_exp_state_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.dscp_exp_state', 'pybind.slxos.v16r_1_00b.brocade_qos_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def dscp_exp_state_qos_mpls_delete(self, qos_mpls=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type qos_mpls: map_name
    :param qos_mpls: Keyword argument tuple.

    :type map_name: unicode
    :param map_name: **qos_mpls** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.dscp_exp_state.qos_mpls', 'pybind.slxos.v16r_1_00b.brocade_qos_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'qos_mpls', 'keyval': 'map_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, qos_mpls=qos_mpls)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, qos_mpls=qos_mpls)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def dscp_exp_state_qos_mpls_enabled_slots_delete(self, qos_mpls=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type qos_mpls: map_name
    :param qos_mpls: Keyword argument tuple.

    :type map_name: unicode
    :param map_name: **qos_mpls** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.dscp_exp_state.qos_mpls', 'pybind.slxos.v16r_1_00b.brocade_qos_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'qos_mpls', 'keyval': 'map_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enabled-slots'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, qos_mpls=qos_mpls)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, qos_mpls=qos_mpls)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def dscp_exp_state_qos_mpls_map_type_delete(self, qos_mpls=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type qos_mpls: map_name
    :param qos_mpls: Keyword argument tuple.

    :type map_name: unicode
    :param map_name: **qos_mpls** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.dscp_exp_state.qos_mpls', 'pybind.slxos.v16r_1_00b.brocade_qos_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'qos_mpls', 'keyval': 'map_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'map-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, qos_mpls=qos_mpls)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, qos_mpls=qos_mpls)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def event_handler_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.event_handler', 'pybind.nos.v6_0_2c.brocade_event_handler', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.event_handler', 'pybind.nos.v7_0_1b.brocade_event_handler', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.event_handler', 'pybind.nos.v7_1_0.brocade_event_handler', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.event_handler', 'pybind.slxos.v16r_1_00b.brocade_event_handler', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def event_handler_activate_name_delete(self, name=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type name: name
    :param name: Keyword argument tuple.

    :type name: unicode
    :param name: **name** tuple argument:  Event handler name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.event_handler.activate.name', 'pybind.slxos.v16r_1_00b.brocade_event_handler', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'name', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, name=name)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, name=name)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def event_handler_activate_name_delay_delete(self, name=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type name: name
    :param name: Keyword argument tuple.

    :type name: unicode
    :param name: **name** tuple argument:  Event handler name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.event_handler.activate.name', 'pybind.slxos.v16r_1_00b.brocade_event_handler', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'name', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'delay'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, name=name)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, name=name)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def event_handler_activate_name_interval_delete(self, name=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type name: name
    :param name: Keyword argument tuple.

    :type name: unicode
    :param name: **name** tuple argument:  Event handler name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.event_handler.activate.name', 'pybind.slxos.v16r_1_00b.brocade_event_handler', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'name', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, name=name)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, name=name)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def event_handler_activate_name_iterations_delete(self, name=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type name: name
    :param name: Keyword argument tuple.

    :type name: unicode
    :param name: **name** tuple argument:  Event handler name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.event_handler.activate.name', 'pybind.slxos.v16r_1_00b.brocade_event_handler', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'name', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'iterations'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, name=name)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, name=name)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def event_handler_activate_name_run_mode_delete(self, name=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type name: name
    :param name: Keyword argument tuple.

    :type name: unicode
    :param name: **name** tuple argument:  Event handler name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.event_handler.activate.name', 'pybind.slxos.v16r_1_00b.brocade_event_handler', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'name', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'run-mode'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, name=name)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, name=name)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def event_handler_activate_name_time_window_delete(self, name=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type name: name
    :param name: Keyword argument tuple.

    :type name: unicode
    :param name: **name** tuple argument:  Event handler name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.event_handler.activate.name', u'name')]
    bindings_list = [('pybind.slxos.v16r_1_00b.event_handler.activate.name.trigger_function_container', 'pybind.slxos.v16r_1_00b.brocade_event_handler', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'time-window'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, name=name)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, name=name)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def event_handler_activate_name_trigger_function_delete(self, name=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type name: name
    :param name: Keyword argument tuple.

    :type name: unicode
    :param name: **name** tuple argument:  Event handler name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.event_handler.activate.name', u'name')]
    bindings_list = [('pybind.slxos.v16r_1_00b.event_handler.activate.name.trigger_function_container', 'pybind.slxos.v16r_1_00b.brocade_event_handler', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'trigger-function'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, name=name)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, name=name)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def event_handler_activate_name_trigger_mode_delete(self, name=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type name: name
    :param name: Keyword argument tuple.

    :type name: unicode
    :param name: **name** tuple argument:  Event handler name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.event_handler.activate.name', 'pybind.slxos.v16r_1_00b.brocade_event_handler', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'name', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'trigger-mode'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, name=name)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, name=name)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def event_handler_event_handler_list_delete(self, event_handler_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type event_handler_list: name
    :param event_handler_list: Keyword argument tuple.

    :type name: unicode
    :param name: **event_handler_list** tuple argument:  Event handler name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.event_handler.event_handler_list', 'pybind.nos.v6_0_2c.brocade_event_handler', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.event_handler.event_handler_list', 'pybind.nos.v7_0_1b.brocade_event_handler', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.event_handler.event_handler_list', 'pybind.nos.v7_1_0.brocade_event_handler', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.event_handler.event_handler_list', 'pybind.slxos.v16r_1_00b.brocade_event_handler', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'event_handler_list', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v7_1_0.event_handler.event_handler_list": {}, "pybind.nos.v7_0_1b.event_handler.event_handler_list": {}, "pybind.nos.v6_0_2c.event_handler.event_handler_list": {"name": "name"}, "pybind.slxos.v16r_1_00b.event_handler.event_handler_list": {"name": "name"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, event_handler_list=event_handler_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, event_handler_list=event_handler_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def event_handler_event_handler_list_action_delete(self, event_handler_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type event_handler_list: name
    :param event_handler_list: Keyword argument tuple.

    :type name: unicode
    :param name: **event_handler_list** tuple argument:  Event handler name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.event_handler.event_handler_list', u'event_handler_list'), ('pybind.nos.v7_1_0.event_handler.event_handler_list', u'event_handler_list'), ('pybind.nos.v7_0_1b.event_handler.event_handler_list', u'event_handler_list'), ('pybind.slxos.v16r_1_00b.event_handler.event_handler_list', u'event_handler_list')]
    bindings_list = [('pybind.nos.v6_0_2c.event_handler.event_handler_list.action', 'pybind.nos.v6_0_2c.brocade_event_handler', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.event_handler.event_handler_list.action', 'pybind.nos.v7_0_1b.brocade_event_handler', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.event_handler.event_handler_list.action', 'pybind.nos.v7_1_0.brocade_event_handler', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.event_handler.event_handler_list.action', 'pybind.slxos.v16r_1_00b.brocade_event_handler', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v6_0_2c.event_handler.event_handler_list.action': [u'python_script'], 'pybind.nos.v7_1_0.event_handler.event_handler_list.action': [u'python_script'], 'pybind.nos.v7_0_1b.event_handler.event_handler_list.action': [u'python_script'], 'pybind.slxos.v16r_1_00b.event_handler.event_handler_list.action': [u'python_script']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, event_handler_list=event_handler_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, event_handler_list=event_handler_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def event_handler_event_handler_list_action_python_script_delete(self, event_handler_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type event_handler_list: name
    :param event_handler_list: Keyword argument tuple.

    :type name: unicode
    :param name: **event_handler_list** tuple argument:  Event handler name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.event_handler.event_handler_list', u'event_handler_list'), ('pybind.nos.v7_1_0.event_handler.event_handler_list', u'event_handler_list'), ('pybind.nos.v7_0_1b.event_handler.event_handler_list', u'event_handler_list'), ('pybind.slxos.v16r_1_00b.event_handler.event_handler_list', u'event_handler_list')]
    bindings_list = [('pybind.nos.v6_0_2c.event_handler.event_handler_list.action', 'pybind.nos.v6_0_2c.brocade_event_handler', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.event_handler.event_handler_list.action', 'pybind.nos.v7_0_1b.brocade_event_handler', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.event_handler.event_handler_list.action', 'pybind.nos.v7_1_0.brocade_event_handler', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.event_handler.event_handler_list.action', 'pybind.slxos.v16r_1_00b.brocade_event_handler', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'python-script'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, event_handler_list=event_handler_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, event_handler_list=event_handler_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def event_handler_event_handler_list_description_delete(self, event_handler_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Instance Keyword Argument Tuple**:

    :type event_handler_list: name
    :param event_handler_list: Keyword argument tuple.

    :type name: unicode
    :param name: **event_handler_list** tuple argument:  Event handler name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_0_1b.event_handler.event_handler_list', 'pybind.nos.v7_0_1b.brocade_event_handler', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.event_handler.event_handler_list', 'pybind.nos.v7_1_0.brocade_event_handler', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'event_handler_list', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'description'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, event_handler_list=event_handler_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, event_handler_list=event_handler_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def event_handler_event_handler_list_trigger_delete(self, event_handler_list=None, trigger=None, vcs=None, raslog=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type event_handler_list: name
    :param event_handler_list: Keyword argument tuple.

    :type name: unicode
    :param name: **event_handler_list** tuple argument:  Event handler name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    **Instance Keyword Argument Tuple**:

    :type trigger: trigger_id, vcs, raslog
    :param trigger: Keyword argument tuple.

    :type trigger_id: long
    :param trigger_id: **trigger** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vcs: unicode
    :param vcs: **trigger** tuple argument:  VCS event type.

        * enumeration restriction: ::

            ['switch-bootup',
            'switch-ready-for-configuration']

    :type raslog: unicode
    :param raslog: **trigger** tuple argument:  RASlog Id.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    **Instance Argument(s)**:

    :type vcs: unicode
    :param vcs: VCS event type. Choice keyword argument (Only one choice argument allowed per API invocation).

        * enumeration restriction: ::

            ['switch-bootup',
            'switch-ready-for-configuration']

    :type raslog: unicode
    :param raslog: RASlog Id. Choice keyword argument (Only one choice argument allowed per API invocation).

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.event_handler.event_handler_list', u'event_handler_list'), ('pybind.nos.v6_0_2c.event_handler.event_handler_list', u'event_handler_list'), ('pybind.nos.v7_0_1b.event_handler.event_handler_list', u'event_handler_list'), ('pybind.slxos.v16r_1_00b.event_handler.event_handler_list', u'event_handler_list')]
    bindings_list = [('pybind.nos.v6_0_2c.event_handler.event_handler_list.trigger', 'pybind.nos.v6_0_2c.brocade_event_handler', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.event_handler.event_handler_list.trigger', 'pybind.nos.v7_0_1b.brocade_event_handler', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.event_handler.event_handler_list.trigger', 'pybind.nos.v7_1_0.brocade_event_handler', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.event_handler.event_handler_list.trigger', 'pybind.slxos.v16r_1_00b.brocade_event_handler', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'trigger', 'keyval': 'trigger_id', 'extra_keyval': 'trigger_id, vcs, raslog'}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v7_0_1b.event_handler.event_handler_list.trigger": {"vcs": "vcs", "raslog": "raslog", "trigger_id": "trigger_id"}, "pybind.slxos.v16r_1_00b.event_handler.event_handler_list.trigger": {"vcs": "vcs", "raslog": "raslog", "trigger_id": "trigger_id"}, "pybind.nos.v7_1_0.event_handler.event_handler_list.trigger": {}, "pybind.nos.v6_0_2c.event_handler.event_handler_list.trigger": {"vcs": "vcs", "raslog": "raslog", "trigger_id": "trigger_id"}}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_0_1b.event_handler.event_handler_list.trigger': [u'vcs', u'raslog'], 'pybind.slxos.v16r_1_00b.event_handler.event_handler_list.trigger': [u'vcs', u'raslog'], 'pybind.nos.v7_1_0.event_handler.event_handler_list.trigger': [u'vcs', u'raslog'], 'pybind.nos.v6_0_2c.event_handler.event_handler_list.trigger': [u'vcs', u'raslog']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, event_handler_list=event_handler_list, trigger=trigger, vcs=vcs, raslog=raslog)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, event_handler_list=event_handler_list, trigger=trigger, vcs=vcs, raslog=raslog)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def event_handler_event_handler_list_trigger_raslog_delete(self, event_handler_list=None, trigger=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type event_handler_list: name
    :param event_handler_list: Keyword argument tuple.

    :type name: unicode
    :param name: **event_handler_list** tuple argument:  Event handler name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    **Instance Keyword Argument Tuple**:

    :type trigger: trigger_id
    :param trigger: Keyword argument tuple.

    :type trigger_id: long
    :param trigger_id: **trigger** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.event_handler.event_handler_list', u'event_handler_list'), ('pybind.nos.v7_0_1b.event_handler.event_handler_list', u'event_handler_list'), ('pybind.slxos.v16r_1_00b.event_handler.event_handler_list', u'event_handler_list')]
    bindings_list = [('pybind.nos.v6_0_2c.event_handler.event_handler_list.trigger', 'pybind.nos.v6_0_2c.brocade_event_handler', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.event_handler.event_handler_list.trigger', 'pybind.nos.v7_0_1b.brocade_event_handler', 'pybind.nos.v7_0_1b'), ('pybind.slxos.v16r_1_00b.event_handler.event_handler_list.trigger', 'pybind.slxos.v16r_1_00b.brocade_event_handler', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'trigger', 'keyval': 'trigger_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'raslog'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, event_handler_list=event_handler_list, trigger=trigger)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, event_handler_list=event_handler_list, trigger=trigger)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def event_handler_event_handler_list_trigger_raslog_pattern_delete(self, event_handler_list=None, trigger=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type event_handler_list: name
    :param event_handler_list: Keyword argument tuple.

    :type name: unicode
    :param name: **event_handler_list** tuple argument:  Event handler name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type trigger: trigger_id, vcs
    :param trigger: Keyword argument tuple.

    :type trigger_id: long
    :param trigger_id: **trigger** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vcs: unicode
    :param vcs: **trigger** tuple argument:  VCS event type.

        * enumeration restriction: ::

            ['switch-bootup',
            'switch-ready-for-configuration']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.event_handler.event_handler_list', u'event_handler_list'), ('pybind.nos.v7_1_0.event_handler.event_handler_list.trigger', u'trigger')]
    bindings_list = [('pybind.nos.v7_1_0.event_handler.event_handler_list.trigger.raslog', 'pybind.nos.v7_1_0.brocade_event_handler', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'trigger_id', 'extra_keyval': 'trigger_id, vcs'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'pattern'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, event_handler_list=event_handler_list, trigger=trigger)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, event_handler_list=event_handler_list, trigger=trigger)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def event_handler_event_handler_list_trigger_raslog_raslog_delete(self, event_handler_list=None, trigger=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type event_handler_list: name
    :param event_handler_list: Keyword argument tuple.

    :type name: unicode
    :param name: **event_handler_list** tuple argument:  Event handler name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type trigger: trigger_id, vcs
    :param trigger: Keyword argument tuple.

    :type trigger_id: long
    :param trigger_id: **trigger** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vcs: unicode
    :param vcs: **trigger** tuple argument:  VCS event type.

        * enumeration restriction: ::

            ['switch-bootup',
            'switch-ready-for-configuration']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.event_handler.event_handler_list', u'event_handler_list'), ('pybind.nos.v7_1_0.event_handler.event_handler_list.trigger', u'trigger')]
    bindings_list = [('pybind.nos.v7_1_0.event_handler.event_handler_list.trigger.raslog', 'pybind.nos.v7_1_0.brocade_event_handler', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'trigger_id', 'extra_keyval': 'trigger_id, vcs'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'raslog'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, event_handler_list=event_handler_list, trigger=trigger)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, event_handler_list=event_handler_list, trigger=trigger)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def event_handler_event_handler_list_trigger_vcs_delete(self, event_handler_list=None, trigger=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type event_handler_list: name
    :param event_handler_list: Keyword argument tuple.

    :type name: unicode
    :param name: **event_handler_list** tuple argument:  Event handler name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    **Instance Keyword Argument Tuple**:

    :type trigger: trigger_id
    :param trigger: Keyword argument tuple.

    :type trigger_id: long
    :param trigger_id: **trigger** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.event_handler.event_handler_list', u'event_handler_list'), ('pybind.nos.v6_0_2c.event_handler.event_handler_list', u'event_handler_list'), ('pybind.nos.v7_0_1b.event_handler.event_handler_list', u'event_handler_list'), ('pybind.slxos.v16r_1_00b.event_handler.event_handler_list', u'event_handler_list')]
    bindings_list = [('pybind.nos.v6_0_2c.event_handler.event_handler_list.trigger', 'pybind.nos.v6_0_2c.brocade_event_handler', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.event_handler.event_handler_list.trigger', 'pybind.nos.v7_0_1b.brocade_event_handler', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.event_handler.event_handler_list.trigger', 'pybind.nos.v7_1_0.brocade_event_handler', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.event_handler.event_handler_list.trigger', 'pybind.slxos.v16r_1_00b.brocade_event_handler', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'trigger', 'keyval': 'trigger_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vcs'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, event_handler_list=event_handler_list, trigger=trigger)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, event_handler_list=event_handler_list, trigger=trigger)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def exp_dscp_state_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.exp_dscp_state', 'pybind.slxos.v16r_1_00b.brocade_qos_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def exp_dscp_state_qos_mpls_delete(self, qos_mpls=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type qos_mpls: map_name
    :param qos_mpls: Keyword argument tuple.

    :type map_name: unicode
    :param map_name: **qos_mpls** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.exp_dscp_state.qos_mpls', 'pybind.slxos.v16r_1_00b.brocade_qos_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'qos_mpls', 'keyval': 'map_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, qos_mpls=qos_mpls)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, qos_mpls=qos_mpls)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def exp_dscp_state_qos_mpls_enabled_slots_delete(self, qos_mpls=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type qos_mpls: map_name
    :param qos_mpls: Keyword argument tuple.

    :type map_name: unicode
    :param map_name: **qos_mpls** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.exp_dscp_state.qos_mpls', 'pybind.slxos.v16r_1_00b.brocade_qos_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'qos_mpls', 'keyval': 'map_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enabled-slots'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, qos_mpls=qos_mpls)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, qos_mpls=qos_mpls)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def exp_dscp_state_qos_mpls_map_type_delete(self, qos_mpls=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type qos_mpls: map_name
    :param qos_mpls: Keyword argument tuple.

    :type map_name: unicode
    :param map_name: **qos_mpls** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.exp_dscp_state.qos_mpls', 'pybind.slxos.v16r_1_00b.brocade_qos_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'qos_mpls', 'keyval': 'map_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'map-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, qos_mpls=qos_mpls)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, qos_mpls=qos_mpls)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def exp_traffic_class_state_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.exp_traffic_class_state', 'pybind.slxos.v16r_1_00b.brocade_qos_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def exp_traffic_class_state_qos_mpls_delete(self, qos_mpls=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type qos_mpls: map_name
    :param qos_mpls: Keyword argument tuple.

    :type map_name: unicode
    :param map_name: **qos_mpls** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.exp_traffic_class_state.qos_mpls', 'pybind.slxos.v16r_1_00b.brocade_qos_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'qos_mpls', 'keyval': 'map_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, qos_mpls=qos_mpls)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, qos_mpls=qos_mpls)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def exp_traffic_class_state_qos_mpls_enabled_slots_delete(self, qos_mpls=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type qos_mpls: map_name
    :param qos_mpls: Keyword argument tuple.

    :type map_name: unicode
    :param map_name: **qos_mpls** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.exp_traffic_class_state.qos_mpls', 'pybind.slxos.v16r_1_00b.brocade_qos_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'qos_mpls', 'keyval': 'map_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enabled-slots'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, qos_mpls=qos_mpls)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, qos_mpls=qos_mpls)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def exp_traffic_class_state_qos_mpls_map_type_delete(self, qos_mpls=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type qos_mpls: map_name
    :param qos_mpls: Keyword argument tuple.

    :type map_name: unicode
    :param map_name: **qos_mpls** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.exp_traffic_class_state.qos_mpls', 'pybind.slxos.v16r_1_00b.brocade_qos_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'qos_mpls', 'keyval': 'map_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'map-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, qos_mpls=qos_mpls)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, qos_mpls=qos_mpls)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def fabric_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.fabric', 'pybind.nos.v6_0_2c.brocade_fabric_service', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.fabric', 'pybind.nos.v7_0_1b.brocade_fabric_service', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.fabric', 'pybind.nos.v7_1_0.brocade_fabric_service', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.fabric', 'pybind.slxos.v16r_1_00b.brocade_fabric_service', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def fabric_route_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.fabric.route', 'pybind.nos.v6_0_2c.brocade_fabric_service', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.fabric.route', 'pybind.nos.v7_0_1b.brocade_fabric_service', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.fabric.route', 'pybind.nos.v7_1_0.brocade_fabric_service', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.fabric.route', 'pybind.slxos.v16r_1_00b.brocade_fabric_service', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def fabric_route_mcast_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.fabric.route.mcast', 'pybind.nos.v6_0_2c.brocade_fabric_service', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.fabric.route.mcast', 'pybind.nos.v7_0_1b.brocade_fabric_service', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.fabric.route.mcast', 'pybind.nos.v7_1_0.brocade_fabric_service', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.fabric.route.mcast', 'pybind.slxos.v16r_1_00b.brocade_fabric_service', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def fabric_route_mcast_rbridge_id_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument:  Syntax: rbridgeId [rbridgeId]

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.fabric.route.mcast.rbridge_id', 'pybind.nos.v6_0_2c.brocade_fabric_service', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.fabric.route.mcast.rbridge_id', 'pybind.nos.v7_0_1b.brocade_fabric_service', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.fabric.route.mcast.rbridge_id', 'pybind.nos.v7_1_0.brocade_fabric_service', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.fabric.route.mcast.rbridge_id', 'pybind.slxos.v16r_1_00b.brocade_fabric_service', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'rbridge_id', 'keyval': 'rbridge_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def fabric_route_mcast_rbridge_id_priority_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument:  Syntax: rbridgeId [rbridgeId]

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.fabric.route.mcast.rbridge_id', 'pybind.nos.v6_0_2c.brocade_fabric_service', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.fabric.route.mcast.rbridge_id', 'pybind.nos.v7_0_1b.brocade_fabric_service', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.fabric.route.mcast.rbridge_id', 'pybind.nos.v7_1_0.brocade_fabric_service', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.fabric.route.mcast.rbridge_id', 'pybind.slxos.v16r_1_00b.brocade_fabric_service', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'rbridge_id', 'keyval': 'rbridge_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def fcoe_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.fcoe', 'pybind.nos.v6_0_2c.brocade_fcoe', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.fcoe', 'pybind.nos.v7_0_1b.brocade_fcoe', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.fcoe', 'pybind.nos.v7_1_0.brocade_fcoe', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.fcoe', 'pybind.slxos.v16r_1_00b.brocade_fcoe', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def fcoe_fabric_map_delete(self, fcoe_fabric_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type fcoe_fabric_map: fcoe_fabric_map_name
    :param fcoe_fabric_map: Keyword argument tuple.

    :type fcoe_fabric_map_name: unicode
    :param fcoe_fabric_map_name: **fcoe_fabric_map** tuple argument:  FCoE Fabric-map name (Max Size - 31)

        * length restriction: ::

            ['1..31']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.fcoe.fcoe_fabric_map', 'pybind.nos.v6_0_2c.brocade_fcoe', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.fcoe.fcoe_fabric_map', 'pybind.nos.v7_0_1b.brocade_fcoe', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.fcoe.fcoe_fabric_map', 'pybind.nos.v7_1_0.brocade_fcoe', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.fcoe.fcoe_fabric_map', 'pybind.slxos.v16r_1_00b.brocade_fcoe', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'fcoe_fabric_map', 'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fcoe_fabric_map=fcoe_fabric_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fcoe_fabric_map=fcoe_fabric_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def fcoe_fabric_map_advertisement_interval_delete(self, fcoe_fabric_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fcoe_fabric_map: fcoe_fabric_map_name
    :param fcoe_fabric_map: Keyword argument tuple.

    :type fcoe_fabric_map_name: unicode
    :param fcoe_fabric_map_name: **fcoe_fabric_map** tuple argument:  FCoE Fabric-map name (Max Size - 31)

        * length restriction: ::

            ['1..31']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.fcoe.fcoe_fabric_map', u'fcoe_fabric_map'), ('pybind.slxos.v16r_1_00b.fcoe.fcoe_fabric_map', u'fcoe_fabric_map'), ('pybind.nos.v7_1_0.fcoe.fcoe_fabric_map', u'fcoe_fabric_map'), ('pybind.nos.v7_0_1b.fcoe.fcoe_fabric_map', u'fcoe_fabric_map')]
    bindings_list = [('pybind.nos.v6_0_2c.fcoe.fcoe_fabric_map.fcoe_fip_advertisement', 'pybind.nos.v6_0_2c.brocade_fcoe', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.fcoe.fcoe_fabric_map.fcoe_fip_advertisement', 'pybind.nos.v7_0_1b.brocade_fcoe', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.fcoe.fcoe_fabric_map.fcoe_fip_advertisement', 'pybind.nos.v7_1_0.brocade_fcoe', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.fcoe.fcoe_fabric_map.fcoe_fip_advertisement', 'pybind.slxos.v16r_1_00b.brocade_fcoe', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}, {'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}, {'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}, {'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fcoe_fabric_map=fcoe_fabric_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fcoe_fabric_map=fcoe_fabric_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def fcoe_fabric_map_fcf_group_delete(self, fcoe_fabric_map=None, fcoe_fcf_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fcoe_fabric_map: fcoe_fabric_map_name
    :param fcoe_fabric_map: Keyword argument tuple.

    :type fcoe_fabric_map_name: unicode
    :param fcoe_fabric_map_name: **fcoe_fabric_map** tuple argument:  FCoE Fabric-map name (Max Size - 31)

        * length restriction: ::

            ['1..31']

    **Instance Keyword Argument Tuple**:

    :type fcoe_fcf_map: fcf_map_name
    :param fcoe_fcf_map: Keyword argument tuple.

    :type fcf_map_name: unicode
    :param fcf_map_name: **fcoe_fcf_map** tuple argument.

        * length restriction: ::

            ['1..31']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.fcoe.fcoe_fabric_map', u'fcoe_fabric_map'), ('pybind.nos.v7_1_0.fcoe.fcoe_fabric_map', u'fcoe_fabric_map'), ('pybind.slxos.v16r_1_00b.fcoe.fcoe_fabric_map', u'fcoe_fabric_map'), ('pybind.nos.v6_0_2c.fcoe.fcoe_fabric_map', u'fcoe_fabric_map')]
    bindings_list = [('pybind.nos.v6_0_2c.fcoe.fcoe_fabric_map.fcoe_fcf_map', 'pybind.nos.v6_0_2c.brocade_fcoe', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.fcoe.fcoe_fabric_map.fcoe_fcf_map', 'pybind.nos.v7_0_1b.brocade_fcoe', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.fcoe.fcoe_fabric_map.fcoe_fcf_map', 'pybind.nos.v7_1_0.brocade_fcoe', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.fcoe.fcoe_fabric_map.fcoe_fcf_map', 'pybind.slxos.v16r_1_00b.brocade_fcoe', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}, {'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}, {'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}, {'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'fcoe_fcf_map', 'keyval': 'fcf_map_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fcoe_fabric_map=fcoe_fabric_map, fcoe_fcf_map=fcoe_fcf_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fcoe_fabric_map=fcoe_fabric_map, fcoe_fcf_map=fcoe_fcf_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def fcoe_fabric_map_fcf_group_fcf_rbid_delete(self, fcoe_fabric_map=None, fcoe_fcf_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fcoe_fabric_map: fcoe_fabric_map_name
    :param fcoe_fabric_map: Keyword argument tuple.

    :type fcoe_fabric_map_name: unicode
    :param fcoe_fabric_map_name: **fcoe_fabric_map** tuple argument:  FCoE Fabric-map name (Max Size - 31)

        * length restriction: ::

            ['1..31']

    **Instance Keyword Argument Tuple**:

    :type fcoe_fcf_map: fcf_map_name
    :param fcoe_fcf_map: Keyword argument tuple.

    :type fcf_map_name: unicode
    :param fcf_map_name: **fcoe_fcf_map** tuple argument.

        * length restriction: ::

            ['1..31']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.fcoe.fcoe_fabric_map', u'fcoe_fabric_map'), ('pybind.nos.v7_1_0.fcoe.fcoe_fabric_map', u'fcoe_fabric_map'), ('pybind.slxos.v16r_1_00b.fcoe.fcoe_fabric_map', u'fcoe_fabric_map'), ('pybind.nos.v6_0_2c.fcoe.fcoe_fabric_map', u'fcoe_fabric_map')]
    bindings_list = [('pybind.nos.v6_0_2c.fcoe.fcoe_fabric_map.fcoe_fcf_map', 'pybind.nos.v6_0_2c.brocade_fcoe', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.fcoe.fcoe_fabric_map.fcoe_fcf_map', 'pybind.nos.v7_0_1b.brocade_fcoe', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.fcoe.fcoe_fabric_map.fcoe_fcf_map', 'pybind.nos.v7_1_0.brocade_fcoe', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.fcoe.fcoe_fabric_map.fcoe_fcf_map', 'pybind.slxos.v16r_1_00b.brocade_fcoe', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}, {'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}, {'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}, {'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'fcoe_fcf_map', 'keyval': 'fcf_map_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'fcf-rbid'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fcoe_fabric_map=fcoe_fabric_map, fcoe_fcf_map=fcoe_fcf_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fcoe_fabric_map=fcoe_fabric_map, fcoe_fcf_map=fcoe_fcf_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def fcoe_fabric_map_fcf_group_fif_rbid_delete(self, fcoe_fabric_map=None, fcoe_fcf_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fcoe_fabric_map: fcoe_fabric_map_name
    :param fcoe_fabric_map: Keyword argument tuple.

    :type fcoe_fabric_map_name: unicode
    :param fcoe_fabric_map_name: **fcoe_fabric_map** tuple argument:  FCoE Fabric-map name (Max Size - 31)

        * length restriction: ::

            ['1..31']

    :type fcoe_fcf_map: fcf_map_name
    :param fcoe_fcf_map: Keyword argument tuple.

    :type fcf_map_name: unicode
    :param fcf_map_name: **fcoe_fcf_map** tuple argument.

        * length restriction: ::

            ['1..31']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.fcoe.fcoe_fabric_map', u'fcoe_fabric_map'), ('pybind.nos.v7_0_1b.fcoe.fcoe_fabric_map.fcoe_fcf_map', u'fcoe_fcf_map'), ('pybind.slxos.v16r_1_00b.fcoe.fcoe_fabric_map', u'fcoe_fabric_map'), ('pybind.slxos.v16r_1_00b.fcoe.fcoe_fabric_map.fcoe_fcf_map', u'fcoe_fcf_map'), ('pybind.nos.v7_1_0.fcoe.fcoe_fabric_map', u'fcoe_fabric_map'), ('pybind.nos.v7_1_0.fcoe.fcoe_fabric_map.fcoe_fcf_map', u'fcoe_fcf_map'), ('pybind.nos.v6_0_2c.fcoe.fcoe_fabric_map', u'fcoe_fabric_map'), ('pybind.nos.v6_0_2c.fcoe.fcoe_fabric_map.fcoe_fcf_map', u'fcoe_fcf_map')]
    bindings_list = [('pybind.nos.v6_0_2c.fcoe.fcoe_fabric_map.fcoe_fcf_map.fcf_map_fif_rbid', 'pybind.nos.v6_0_2c.brocade_fcoe', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.fcoe.fcoe_fabric_map.fcoe_fcf_map.fcf_map_fif_rbid', 'pybind.nos.v7_0_1b.brocade_fcoe', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.fcoe.fcoe_fabric_map.fcoe_fcf_map.fcf_map_fif_rbid', 'pybind.nos.v7_1_0.brocade_fcoe', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.fcoe.fcoe_fabric_map.fcoe_fcf_map.fcf_map_fif_rbid', 'pybind.slxos.v16r_1_00b.brocade_fcoe', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}, {'keyval': 'fcf_map_name', 'extra_keyval': ''}, {'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}, {'keyval': 'fcf_map_name', 'extra_keyval': ''}, {'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}, {'keyval': 'fcf_map_name', 'extra_keyval': ''}, {'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}, {'keyval': 'fcf_map_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fcoe_fabric_map=fcoe_fabric_map, fcoe_fcf_map=fcoe_fcf_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fcoe_fabric_map=fcoe_fabric_map, fcoe_fcf_map=fcoe_fcf_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def fcoe_fabric_map_fcf_group_fif_rbid_add_delete(self, fcoe_fabric_map=None, fcoe_fcf_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fcoe_fabric_map: fcoe_fabric_map_name
    :param fcoe_fabric_map: Keyword argument tuple.

    :type fcoe_fabric_map_name: unicode
    :param fcoe_fabric_map_name: **fcoe_fabric_map** tuple argument:  FCoE Fabric-map name (Max Size - 31)

        * length restriction: ::

            ['1..31']

    :type fcoe_fcf_map: fcf_map_name
    :param fcoe_fcf_map: Keyword argument tuple.

    :type fcf_map_name: unicode
    :param fcf_map_name: **fcoe_fcf_map** tuple argument.

        * length restriction: ::

            ['1..31']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.fcoe.fcoe_fabric_map', u'fcoe_fabric_map'), ('pybind.nos.v7_0_1b.fcoe.fcoe_fabric_map.fcoe_fcf_map', u'fcoe_fcf_map'), ('pybind.slxos.v16r_1_00b.fcoe.fcoe_fabric_map', u'fcoe_fabric_map'), ('pybind.slxos.v16r_1_00b.fcoe.fcoe_fabric_map.fcoe_fcf_map', u'fcoe_fcf_map'), ('pybind.nos.v7_1_0.fcoe.fcoe_fabric_map', u'fcoe_fabric_map'), ('pybind.nos.v7_1_0.fcoe.fcoe_fabric_map.fcoe_fcf_map', u'fcoe_fcf_map'), ('pybind.nos.v6_0_2c.fcoe.fcoe_fabric_map', u'fcoe_fabric_map'), ('pybind.nos.v6_0_2c.fcoe.fcoe_fabric_map.fcoe_fcf_map', u'fcoe_fcf_map')]
    bindings_list = [('pybind.nos.v6_0_2c.fcoe.fcoe_fabric_map.fcoe_fcf_map.fcf_map_fif_rbid', 'pybind.nos.v6_0_2c.brocade_fcoe', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.fcoe.fcoe_fabric_map.fcoe_fcf_map.fcf_map_fif_rbid', 'pybind.nos.v7_0_1b.brocade_fcoe', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.fcoe.fcoe_fabric_map.fcoe_fcf_map.fcf_map_fif_rbid', 'pybind.nos.v7_1_0.brocade_fcoe', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.fcoe.fcoe_fabric_map.fcoe_fcf_map.fcf_map_fif_rbid', 'pybind.slxos.v16r_1_00b.brocade_fcoe', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}, {'keyval': 'fcf_map_name', 'extra_keyval': ''}, {'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}, {'keyval': 'fcf_map_name', 'extra_keyval': ''}, {'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}, {'keyval': 'fcf_map_name', 'extra_keyval': ''}, {'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}, {'keyval': 'fcf_map_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'add'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fcoe_fabric_map=fcoe_fabric_map, fcoe_fcf_map=fcoe_fcf_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fcoe_fabric_map=fcoe_fabric_map, fcoe_fcf_map=fcoe_fcf_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def fcoe_fabric_map_fcf_group_fif_rbid_remove_delete(self, fcoe_fabric_map=None, fcoe_fcf_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fcoe_fabric_map: fcoe_fabric_map_name
    :param fcoe_fabric_map: Keyword argument tuple.

    :type fcoe_fabric_map_name: unicode
    :param fcoe_fabric_map_name: **fcoe_fabric_map** tuple argument:  FCoE Fabric-map name (Max Size - 31)

        * length restriction: ::

            ['1..31']

    :type fcoe_fcf_map: fcf_map_name
    :param fcoe_fcf_map: Keyword argument tuple.

    :type fcf_map_name: unicode
    :param fcf_map_name: **fcoe_fcf_map** tuple argument.

        * length restriction: ::

            ['1..31']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.fcoe.fcoe_fabric_map', u'fcoe_fabric_map'), ('pybind.nos.v7_0_1b.fcoe.fcoe_fabric_map.fcoe_fcf_map', u'fcoe_fcf_map'), ('pybind.slxos.v16r_1_00b.fcoe.fcoe_fabric_map', u'fcoe_fabric_map'), ('pybind.slxos.v16r_1_00b.fcoe.fcoe_fabric_map.fcoe_fcf_map', u'fcoe_fcf_map'), ('pybind.nos.v7_1_0.fcoe.fcoe_fabric_map', u'fcoe_fabric_map'), ('pybind.nos.v7_1_0.fcoe.fcoe_fabric_map.fcoe_fcf_map', u'fcoe_fcf_map'), ('pybind.nos.v6_0_2c.fcoe.fcoe_fabric_map', u'fcoe_fabric_map'), ('pybind.nos.v6_0_2c.fcoe.fcoe_fabric_map.fcoe_fcf_map', u'fcoe_fcf_map')]
    bindings_list = [('pybind.nos.v6_0_2c.fcoe.fcoe_fabric_map.fcoe_fcf_map.fcf_map_fif_rbid', 'pybind.nos.v6_0_2c.brocade_fcoe', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.fcoe.fcoe_fabric_map.fcoe_fcf_map.fcf_map_fif_rbid', 'pybind.nos.v7_0_1b.brocade_fcoe', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.fcoe.fcoe_fabric_map.fcoe_fcf_map.fcf_map_fif_rbid', 'pybind.nos.v7_1_0.brocade_fcoe', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.fcoe.fcoe_fabric_map.fcoe_fcf_map.fcf_map_fif_rbid', 'pybind.slxos.v16r_1_00b.brocade_fcoe', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}, {'keyval': 'fcf_map_name', 'extra_keyval': ''}, {'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}, {'keyval': 'fcf_map_name', 'extra_keyval': ''}, {'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}, {'keyval': 'fcf_map_name', 'extra_keyval': ''}, {'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}, {'keyval': 'fcf_map_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'remove'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fcoe_fabric_map=fcoe_fabric_map, fcoe_fcf_map=fcoe_fcf_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fcoe_fabric_map=fcoe_fabric_map, fcoe_fcf_map=fcoe_fcf_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def fcoe_fabric_map_fcmap_delete(self, fcoe_fabric_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type fcoe_fabric_map: fcoe_fabric_map_name
    :param fcoe_fabric_map: Keyword argument tuple.

    :type fcoe_fabric_map_name: unicode
    :param fcoe_fabric_map_name: **fcoe_fabric_map** tuple argument:  FCoE Fabric-map name (Max Size - 31)

        * length restriction: ::

            ['1..31']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.fcoe.fcoe_fabric_map', 'pybind.nos.v6_0_2c.brocade_fcoe', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.fcoe.fcoe_fabric_map', 'pybind.nos.v7_0_1b.brocade_fcoe', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.fcoe.fcoe_fabric_map', 'pybind.nos.v7_1_0.brocade_fcoe', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.fcoe.fcoe_fabric_map', 'pybind.slxos.v16r_1_00b.brocade_fcoe', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'fcoe_fabric_map', 'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'fcmap'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fcoe_fabric_map=fcoe_fabric_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fcoe_fabric_map=fcoe_fabric_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def fcoe_fabric_map_fcport_group_delete(self, fcoe_fabric_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fcoe_fabric_map: fcoe_fabric_map_name
    :param fcoe_fabric_map: Keyword argument tuple.

    :type fcoe_fabric_map_name: unicode
    :param fcoe_fabric_map_name: **fcoe_fabric_map** tuple argument:  FCoE Fabric-map name (Max Size - 31)

        * length restriction: ::

            ['1..31']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.fcoe.fcoe_fabric_map', u'fcoe_fabric_map'), ('pybind.nos.v7_0_1b.fcoe.fcoe_fabric_map', u'fcoe_fabric_map'), ('pybind.slxos.v16r_1_00b.fcoe.fcoe_fabric_map', u'fcoe_fabric_map'), ('pybind.nos.v7_1_0.fcoe.fcoe_fabric_map', u'fcoe_fabric_map')]
    bindings_list = [('pybind.nos.v6_0_2c.fcoe.fcoe_fabric_map.fcoe_fcport_group_config', 'pybind.nos.v6_0_2c.brocade_fcoe', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.fcoe.fcoe_fabric_map.fcoe_fcport_group_config', 'pybind.nos.v7_0_1b.brocade_fcoe', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.fcoe.fcoe_fabric_map.fcoe_fcport_group_config', 'pybind.nos.v7_1_0.brocade_fcoe', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.fcoe.fcoe_fabric_map.fcoe_fcport_group_config', 'pybind.slxos.v16r_1_00b.brocade_fcoe', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}, {'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}, {'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}, {'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fcoe_fabric_map=fcoe_fabric_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fcoe_fabric_map=fcoe_fabric_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def fcoe_fabric_map_fcport_group_fcport_group_rbid_delete(self, fcoe_fabric_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fcoe_fabric_map: fcoe_fabric_map_name
    :param fcoe_fabric_map: Keyword argument tuple.

    :type fcoe_fabric_map_name: unicode
    :param fcoe_fabric_map_name: **fcoe_fabric_map** tuple argument:  FCoE Fabric-map name (Max Size - 31)

        * length restriction: ::

            ['1..31']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.fcoe.fcoe_fabric_map', u'fcoe_fabric_map'), ('pybind.slxos.v16r_1_00b.fcoe.fcoe_fabric_map', u'fcoe_fabric_map'), ('pybind.nos.v6_0_2c.fcoe.fcoe_fabric_map', u'fcoe_fabric_map'), ('pybind.nos.v7_1_0.fcoe.fcoe_fabric_map', u'fcoe_fabric_map')]
    bindings_list = [('pybind.nos.v6_0_2c.fcoe.fcoe_fabric_map.fcoe_fcport_group_config.fcport_group_rbid', 'pybind.nos.v6_0_2c.brocade_fcoe', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.fcoe.fcoe_fabric_map.fcoe_fcport_group_config.fcport_group_rbid', 'pybind.nos.v7_0_1b.brocade_fcoe', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.fcoe.fcoe_fabric_map.fcoe_fcport_group_config.fcport_group_rbid', 'pybind.nos.v7_1_0.brocade_fcoe', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.fcoe.fcoe_fabric_map.fcoe_fcport_group_config.fcport_group_rbid', 'pybind.slxos.v16r_1_00b.brocade_fcoe', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}, {'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}, {'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}, {'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fcoe_fabric_map=fcoe_fabric_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fcoe_fabric_map=fcoe_fabric_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def fcoe_fabric_map_fcport_group_fcport_group_rbid_add_delete(self, fcoe_fabric_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fcoe_fabric_map: fcoe_fabric_map_name
    :param fcoe_fabric_map: Keyword argument tuple.

    :type fcoe_fabric_map_name: unicode
    :param fcoe_fabric_map_name: **fcoe_fabric_map** tuple argument:  FCoE Fabric-map name (Max Size - 31)

        * length restriction: ::

            ['1..31']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.fcoe.fcoe_fabric_map', u'fcoe_fabric_map'), ('pybind.slxos.v16r_1_00b.fcoe.fcoe_fabric_map', u'fcoe_fabric_map'), ('pybind.nos.v6_0_2c.fcoe.fcoe_fabric_map', u'fcoe_fabric_map'), ('pybind.nos.v7_1_0.fcoe.fcoe_fabric_map', u'fcoe_fabric_map')]
    bindings_list = [('pybind.nos.v6_0_2c.fcoe.fcoe_fabric_map.fcoe_fcport_group_config.fcport_group_rbid', 'pybind.nos.v6_0_2c.brocade_fcoe', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.fcoe.fcoe_fabric_map.fcoe_fcport_group_config.fcport_group_rbid', 'pybind.nos.v7_0_1b.brocade_fcoe', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.fcoe.fcoe_fabric_map.fcoe_fcport_group_config.fcport_group_rbid', 'pybind.nos.v7_1_0.brocade_fcoe', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.fcoe.fcoe_fabric_map.fcoe_fcport_group_config.fcport_group_rbid', 'pybind.slxos.v16r_1_00b.brocade_fcoe', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}, {'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}, {'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}, {'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'add'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fcoe_fabric_map=fcoe_fabric_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fcoe_fabric_map=fcoe_fabric_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def fcoe_fabric_map_fcport_group_fcport_group_rbid_remove_delete(self, fcoe_fabric_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fcoe_fabric_map: fcoe_fabric_map_name
    :param fcoe_fabric_map: Keyword argument tuple.

    :type fcoe_fabric_map_name: unicode
    :param fcoe_fabric_map_name: **fcoe_fabric_map** tuple argument:  FCoE Fabric-map name (Max Size - 31)

        * length restriction: ::

            ['1..31']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.fcoe.fcoe_fabric_map', u'fcoe_fabric_map'), ('pybind.slxos.v16r_1_00b.fcoe.fcoe_fabric_map', u'fcoe_fabric_map'), ('pybind.nos.v6_0_2c.fcoe.fcoe_fabric_map', u'fcoe_fabric_map'), ('pybind.nos.v7_1_0.fcoe.fcoe_fabric_map', u'fcoe_fabric_map')]
    bindings_list = [('pybind.nos.v6_0_2c.fcoe.fcoe_fabric_map.fcoe_fcport_group_config.fcport_group_rbid', 'pybind.nos.v6_0_2c.brocade_fcoe', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.fcoe.fcoe_fabric_map.fcoe_fcport_group_config.fcport_group_rbid', 'pybind.nos.v7_0_1b.brocade_fcoe', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.fcoe.fcoe_fabric_map.fcoe_fcport_group_config.fcport_group_rbid', 'pybind.nos.v7_1_0.brocade_fcoe', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.fcoe.fcoe_fabric_map.fcoe_fcport_group_config.fcport_group_rbid', 'pybind.slxos.v16r_1_00b.brocade_fcoe', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}, {'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}, {'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}, {'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'remove'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fcoe_fabric_map=fcoe_fabric_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fcoe_fabric_map=fcoe_fabric_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def fcoe_fabric_map_keep_alive_timeout_delete(self, fcoe_fabric_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fcoe_fabric_map: fcoe_fabric_map_name
    :param fcoe_fabric_map: Keyword argument tuple.

    :type fcoe_fabric_map_name: unicode
    :param fcoe_fabric_map_name: **fcoe_fabric_map** tuple argument:  FCoE Fabric-map name (Max Size - 31)

        * length restriction: ::

            ['1..31']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.fcoe.fcoe_fabric_map', u'fcoe_fabric_map'), ('pybind.nos.v6_0_2c.fcoe.fcoe_fabric_map', u'fcoe_fabric_map'), ('pybind.nos.v7_0_1b.fcoe.fcoe_fabric_map', u'fcoe_fabric_map'), ('pybind.slxos.v16r_1_00b.fcoe.fcoe_fabric_map', u'fcoe_fabric_map')]
    bindings_list = [('pybind.nos.v6_0_2c.fcoe.fcoe_fabric_map.fcoe_fip_keep_alive', 'pybind.nos.v6_0_2c.brocade_fcoe', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.fcoe.fcoe_fabric_map.fcoe_fip_keep_alive', 'pybind.nos.v7_0_1b.brocade_fcoe', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.fcoe.fcoe_fabric_map.fcoe_fip_keep_alive', 'pybind.nos.v7_1_0.brocade_fcoe', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.fcoe.fcoe_fabric_map.fcoe_fip_keep_alive', 'pybind.slxos.v16r_1_00b.brocade_fcoe', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}, {'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}, {'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}, {'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'timeout'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fcoe_fabric_map=fcoe_fabric_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fcoe_fabric_map=fcoe_fabric_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def fcoe_fabric_map_priority_delete(self, fcoe_fabric_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type fcoe_fabric_map: fcoe_fabric_map_name
    :param fcoe_fabric_map: Keyword argument tuple.

    :type fcoe_fabric_map_name: unicode
    :param fcoe_fabric_map_name: **fcoe_fabric_map** tuple argument:  FCoE Fabric-map name (Max Size - 31)

        * length restriction: ::

            ['1..31']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.fcoe.fcoe_fabric_map', 'pybind.nos.v6_0_2c.brocade_fcoe', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.fcoe.fcoe_fabric_map', 'pybind.nos.v7_0_1b.brocade_fcoe', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.fcoe.fcoe_fabric_map', 'pybind.nos.v7_1_0.brocade_fcoe', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.fcoe.fcoe_fabric_map', 'pybind.slxos.v16r_1_00b.brocade_fcoe', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'fcoe_fabric_map', 'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fcoe_fabric_map=fcoe_fabric_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fcoe_fabric_map=fcoe_fabric_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def fcoe_fabric_map_san_mode_delete(self, fcoe_fabric_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type fcoe_fabric_map: fcoe_fabric_map_name
    :param fcoe_fabric_map: Keyword argument tuple.

    :type fcoe_fabric_map_name: unicode
    :param fcoe_fabric_map_name: **fcoe_fabric_map** tuple argument:  FCoE Fabric-map name (Max Size - 31)

        * length restriction: ::

            ['1..31']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.fcoe.fcoe_fabric_map', 'pybind.nos.v6_0_2c.brocade_fcoe', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.fcoe.fcoe_fabric_map', 'pybind.nos.v7_0_1b.brocade_fcoe', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.fcoe.fcoe_fabric_map', 'pybind.nos.v7_1_0.brocade_fcoe', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.fcoe.fcoe_fabric_map', 'pybind.slxos.v16r_1_00b.brocade_fcoe', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'fcoe_fabric_map', 'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'san-mode'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fcoe_fabric_map=fcoe_fabric_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fcoe_fabric_map=fcoe_fabric_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def fcoe_fabric_map_virtual_fabric_delete(self, fcoe_fabric_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type fcoe_fabric_map: fcoe_fabric_map_name
    :param fcoe_fabric_map: Keyword argument tuple.

    :type fcoe_fabric_map_name: unicode
    :param fcoe_fabric_map_name: **fcoe_fabric_map** tuple argument:  FCoE Fabric-map name (Max Size - 31)

        * length restriction: ::

            ['1..31']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.fcoe.fcoe_fabric_map', 'pybind.nos.v6_0_2c.brocade_fcoe', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.fcoe.fcoe_fabric_map', 'pybind.nos.v7_0_1b.brocade_fcoe', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.fcoe.fcoe_fabric_map', 'pybind.nos.v7_1_0.brocade_fcoe', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.fcoe.fcoe_fabric_map', 'pybind.slxos.v16r_1_00b.brocade_fcoe', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'fcoe_fabric_map', 'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'virtual-fabric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fcoe_fabric_map=fcoe_fabric_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fcoe_fabric_map=fcoe_fabric_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def fcoe_fabric_map_vlan_delete(self, fcoe_fabric_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type fcoe_fabric_map: fcoe_fabric_map_name
    :param fcoe_fabric_map: Keyword argument tuple.

    :type fcoe_fabric_map_name: unicode
    :param fcoe_fabric_map_name: **fcoe_fabric_map** tuple argument:  FCoE Fabric-map name (Max Size - 31)

        * length restriction: ::

            ['1..31']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.fcoe.fcoe_fabric_map', 'pybind.nos.v6_0_2c.brocade_fcoe', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.fcoe.fcoe_fabric_map', 'pybind.nos.v7_0_1b.brocade_fcoe', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.fcoe.fcoe_fabric_map', 'pybind.nos.v7_1_0.brocade_fcoe', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.fcoe.fcoe_fabric_map', 'pybind.slxos.v16r_1_00b.brocade_fcoe', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'fcoe_fabric_map', 'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vlan'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fcoe_fabric_map=fcoe_fabric_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fcoe_fabric_map=fcoe_fabric_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def fcoe_fcoe_map_delete(self, fcoe_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type fcoe_map: fcoe_map_name
    :param fcoe_map: Keyword argument tuple.

    :type fcoe_map_name: unicode
    :param fcoe_map_name: **fcoe_map** tuple argument:  FCoE Map name (Max Size - 32)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.fcoe.fcoe_map', 'pybind.nos.v6_0_2c.brocade_fcoe', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.fcoe.fcoe_map', 'pybind.nos.v7_0_1b.brocade_fcoe', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.fcoe.fcoe_map', 'pybind.nos.v7_1_0.brocade_fcoe', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.fcoe.fcoe_map', 'pybind.slxos.v16r_1_00b.brocade_fcoe', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'fcoe_map', 'keyval': 'fcoe_map_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fcoe_map=fcoe_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fcoe_map=fcoe_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def fcoe_fcoe_map_cee_map_delete(self, fcoe_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fcoe_map: fcoe_map_name
    :param fcoe_map: Keyword argument tuple.

    :type fcoe_map_name: unicode
    :param fcoe_map_name: **fcoe_map** tuple argument:  FCoE Map name (Max Size - 32)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.fcoe.fcoe_map', u'fcoe_map'), ('pybind.nos.v6_0_2c.fcoe.fcoe_map', u'fcoe_map'), ('pybind.nos.v7_1_0.fcoe.fcoe_map', u'fcoe_map'), ('pybind.slxos.v16r_1_00b.fcoe.fcoe_map', u'fcoe_map')]
    bindings_list = [('pybind.nos.v6_0_2c.fcoe.fcoe_map.fcoe_map_cee_map', 'pybind.nos.v6_0_2c.brocade_fcoe', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.fcoe.fcoe_map.fcoe_map_cee_map', 'pybind.nos.v7_0_1b.brocade_fcoe', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.fcoe.fcoe_map.fcoe_map_cee_map', 'pybind.nos.v7_1_0.brocade_fcoe', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.fcoe.fcoe_map.fcoe_map_cee_map', 'pybind.slxos.v16r_1_00b.brocade_fcoe', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'fcoe_map_name', 'extra_keyval': ''}, {'keyval': 'fcoe_map_name', 'extra_keyval': ''}, {'keyval': 'fcoe_map_name', 'extra_keyval': ''}, {'keyval': 'fcoe_map_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fcoe_map=fcoe_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fcoe_map=fcoe_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def fcoe_fcoe_map_cee_map_fcoe_map_cee_map_leaf_delete(self, fcoe_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fcoe_map: fcoe_map_name
    :param fcoe_map: Keyword argument tuple.

    :type fcoe_map_name: unicode
    :param fcoe_map_name: **fcoe_map** tuple argument:  FCoE Map name (Max Size - 32)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.fcoe.fcoe_map', u'fcoe_map'), ('pybind.nos.v6_0_2c.fcoe.fcoe_map', u'fcoe_map'), ('pybind.nos.v7_1_0.fcoe.fcoe_map', u'fcoe_map'), ('pybind.slxos.v16r_1_00b.fcoe.fcoe_map', u'fcoe_map')]
    bindings_list = [('pybind.nos.v6_0_2c.fcoe.fcoe_map.fcoe_map_cee_map', 'pybind.nos.v6_0_2c.brocade_fcoe', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.fcoe.fcoe_map.fcoe_map_cee_map', 'pybind.nos.v7_0_1b.brocade_fcoe', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.fcoe.fcoe_map.fcoe_map_cee_map', 'pybind.nos.v7_1_0.brocade_fcoe', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.fcoe.fcoe_map.fcoe_map_cee_map', 'pybind.slxos.v16r_1_00b.brocade_fcoe', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'fcoe_map_name', 'extra_keyval': ''}, {'keyval': 'fcoe_map_name', 'extra_keyval': ''}, {'keyval': 'fcoe_map_name', 'extra_keyval': ''}, {'keyval': 'fcoe_map_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'fcoe-map-cee-map-leaf'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fcoe_map=fcoe_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fcoe_map=fcoe_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def fcoe_fcoe_map_fabric_map_delete(self, fcoe_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fcoe_map: fcoe_map_name
    :param fcoe_map: Keyword argument tuple.

    :type fcoe_map_name: unicode
    :param fcoe_map_name: **fcoe_map** tuple argument:  FCoE Map name (Max Size - 32)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.fcoe.fcoe_map', u'fcoe_map'), ('pybind.nos.v7_1_0.fcoe.fcoe_map', u'fcoe_map'), ('pybind.nos.v7_0_1b.fcoe.fcoe_map', u'fcoe_map'), ('pybind.slxos.v16r_1_00b.fcoe.fcoe_map', u'fcoe_map')]
    bindings_list = [('pybind.nos.v6_0_2c.fcoe.fcoe_map.fcoe_map_fabric_map', 'pybind.nos.v6_0_2c.brocade_fcoe', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.fcoe.fcoe_map.fcoe_map_fabric_map', 'pybind.nos.v7_0_1b.brocade_fcoe', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.fcoe.fcoe_map.fcoe_map_fabric_map', 'pybind.nos.v7_1_0.brocade_fcoe', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.fcoe.fcoe_map.fcoe_map_fabric_map', 'pybind.slxos.v16r_1_00b.brocade_fcoe', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'fcoe_map_name', 'extra_keyval': ''}, {'keyval': 'fcoe_map_name', 'extra_keyval': ''}, {'keyval': 'fcoe_map_name', 'extra_keyval': ''}, {'keyval': 'fcoe_map_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fcoe_map=fcoe_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fcoe_map=fcoe_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def fcsp_auth_auth_type_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.fcsp_sa.fcsp.auth.proto', 'pybind.nos.v6_0_2c.brocade_fc_auth', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.fcsp_sa.fcsp.auth.proto', 'pybind.nos.v7_0_1b.brocade_fc_auth', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.fcsp_sa.fcsp.auth.proto', 'pybind.nos.v7_1_0.brocade_fc_auth', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.fcsp_sa.fcsp.auth.proto', 'pybind.slxos.v16r_1_00b.brocade_fc_auth', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'auth-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def fcsp_auth_group_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.fcsp_sa.fcsp.auth.proto', 'pybind.nos.v6_0_2c.brocade_fc_auth', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.fcsp_sa.fcsp.auth.proto', 'pybind.nos.v7_0_1b.brocade_fc_auth', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.fcsp_sa.fcsp.auth.proto', 'pybind.nos.v7_1_0.brocade_fc_auth', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.fcsp_sa.fcsp.auth.proto', 'pybind.slxos.v16r_1_00b.brocade_fc_auth', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'group'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def fcsp_auth_hash_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.fcsp_sa.fcsp.auth.proto', 'pybind.nos.v6_0_2c.brocade_fc_auth', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.fcsp_sa.fcsp.auth.proto', 'pybind.nos.v7_0_1b.brocade_fc_auth', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.fcsp_sa.fcsp.auth.proto', 'pybind.nos.v7_1_0.brocade_fc_auth', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.fcsp_sa.fcsp.auth.proto', 'pybind.slxos.v16r_1_00b.brocade_fc_auth', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hash'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def fcsp_auth_policy_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.fcsp_sa.fcsp.auth.policy', 'pybind.nos.v6_0_2c.brocade_fc_auth', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.fcsp_sa.fcsp.auth.policy', 'pybind.nos.v7_0_1b.brocade_fc_auth', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.fcsp_sa.fcsp.auth.policy', 'pybind.nos.v7_1_0.brocade_fc_auth', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.fcsp_sa.fcsp.auth.policy', 'pybind.slxos.v16r_1_00b.brocade_fc_auth', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def fcsp_auth_policy_switch_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.fcsp_sa.fcsp.auth.policy', 'pybind.nos.v6_0_2c.brocade_fc_auth', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.fcsp_sa.fcsp.auth.policy', 'pybind.nos.v7_0_1b.brocade_fc_auth', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.fcsp_sa.fcsp.auth.policy', 'pybind.nos.v7_1_0.brocade_fc_auth', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.fcsp_sa.fcsp.auth.policy', 'pybind.slxos.v16r_1_00b.brocade_fc_auth', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'switch'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def fcsp_auth_proto_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.fcsp_sa.fcsp.auth.proto', 'pybind.nos.v6_0_2c.brocade_fc_auth', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.fcsp_sa.fcsp.auth.proto', 'pybind.nos.v7_0_1b.brocade_fc_auth', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.fcsp_sa.fcsp.auth.proto', 'pybind.nos.v7_1_0.brocade_fc_auth', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.fcsp_sa.fcsp.auth.proto', 'pybind.slxos.v16r_1_00b.brocade_fc_auth', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def fcsp_sa_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.fcsp_sa', 'pybind.nos.v6_0_2c.brocade_fc_auth', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.fcsp_sa', 'pybind.nos.v7_0_1b.brocade_fc_auth', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.fcsp_sa', 'pybind.nos.v7_1_0.brocade_fc_auth', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.fcsp_sa', 'pybind.slxos.v16r_1_00b.brocade_fc_auth', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def filter_change_update_delay_delete(self, filter_change_update_delay=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type filter_change_update_delay: filter_delay_value
    :param filter_change_update_delay: Keyword argument tuple.

    :type filter_delay_value: long
    :param filter_delay_value: **filter_change_update_delay** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.hide_filter_change_update_delay_holder.filter_change_update_delay', 'pybind.nos.v6_0_2c.brocade_ip_policy', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_filter_change_update_delay_holder.filter_change_update_delay', 'pybind.nos.v7_0_1b.brocade_ip_policy', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_filter_change_update_delay_holder.filter_change_update_delay', 'pybind.nos.v7_1_0.brocade_ip_policy', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.hide_filter_change_update_delay_holder.filter_change_update_delay', 'pybind.slxos.v16r_1_00b.brocade_ip_policy', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'filter_change_update_delay', 'keyval': 'filter_delay_value', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, filter_change_update_delay=filter_change_update_delay)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, filter_change_update_delay=filter_change_update_delay)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def firmware_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.firmware', 'pybind.nos.v6_0_2c.brocade_firmware', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.firmware', 'pybind.nos.v7_0_1b.brocade_firmware', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.firmware', 'pybind.nos.v7_1_0.brocade_firmware', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.firmware', 'pybind.slxos.v16r_1_00b.brocade_firmware', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def firmware_auto_upgrade_enable_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.firmware.autoupgrade', 'pybind.nos.v6_0_2c.brocade_firmware', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.firmware.autoupgrade', 'pybind.nos.v7_0_1b.brocade_firmware', 'pybind.nos.v7_0_1b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def firmware_auto_upgrade_params_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.firmware.autoupgrade_params', 'pybind.nos.v6_0_2c.brocade_firmware', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.firmware.autoupgrade_params', 'pybind.nos.v7_0_1b.brocade_firmware', 'pybind.nos.v7_0_1b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def firmware_auto_upgrade_params_host_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.firmware.autoupgrade_params', 'pybind.nos.v6_0_2c.brocade_firmware', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.firmware.autoupgrade_params', 'pybind.nos.v7_0_1b.brocade_firmware', 'pybind.nos.v7_0_1b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'host'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def firmware_auto_upgrade_params_password_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.firmware.autoupgrade_params', 'pybind.nos.v6_0_2c.brocade_firmware', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.firmware.autoupgrade_params', 'pybind.nos.v7_0_1b.brocade_firmware', 'pybind.nos.v7_0_1b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'password'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def firmware_auto_upgrade_params_path_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.firmware.autoupgrade_params', 'pybind.nos.v6_0_2c.brocade_firmware', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.firmware.autoupgrade_params', 'pybind.nos.v7_0_1b.brocade_firmware', 'pybind.nos.v7_0_1b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'path'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def firmware_auto_upgrade_params_protocol_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.firmware.autoupgrade_params', 'pybind.nos.v6_0_2c.brocade_firmware', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.firmware.autoupgrade_params', 'pybind.nos.v7_0_1b.brocade_firmware', 'pybind.nos.v7_0_1b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'protocol'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def firmware_auto_upgrade_params_username_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.firmware.autoupgrade_params', 'pybind.nos.v6_0_2c.brocade_firmware', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.firmware.autoupgrade_params', 'pybind.nos.v7_0_1b.brocade_firmware', 'pybind.nos.v7_0_1b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'username'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def firmware_download_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.firmware.download', 'pybind.nos.v6_0_2c.brocade_firmware', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.firmware.download', 'pybind.nos.v7_0_1b.brocade_firmware', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.firmware.download', 'pybind.nos.v7_1_0.brocade_firmware', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.firmware.download', 'pybind.slxos.v16r_1_00b.brocade_firmware', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v16r_1_00b.firmware.download": {}, "pybind.nos.v6_0_2c.brocade_firmware_rpc.firmware_download.input": {"coldboot": "coldboot", "rbridge_id": "rbridge_id", "auto_activate": "auto_activate"}, "pybind.nos.v6_0_2c.firmware.download": {}, "pybind.nos.v7_1_0.firmware.download": {}, "pybind.slxos.v16r_1_00b.brocade_firmware_rpc.firmware_download.input": {}, "pybind.nos.v7_1_0.brocade_firmware_rpc.firmware_download.input": {"coldboot": "coldboot", "rbridge_id": "rbridge_id", "auto_activate": "auto_activate"}, "pybind.nos.v7_0_1b.brocade_firmware_rpc.firmware_download.input": {"coldboot": "coldboot", "rbridge_id": "rbridge_id", "auto_activate": "auto_activate"}, "pybind.nos.v7_0_1b.firmware.download": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def firmware_download_logical_chassis_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.firmware.download.logical_chassis', 'pybind.nos.v6_0_2c.brocade_firmware', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.firmware.download.logical_chassis', 'pybind.nos.v7_0_1b.brocade_firmware', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.firmware.download.logical_chassis', 'pybind.nos.v7_1_0.brocade_firmware', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def firmware_peripheral_update_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_1_0.firmware.peripheral_update', 'pybind.nos.v7_1_0.brocade_firmware', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def firmware_peripheral_update_microcode_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_1_0.firmware.peripheral_update.microcode', 'pybind.nos.v7_1_0.brocade_firmware', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def fsb_enable_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.fcoe_fsb', 'pybind.nos.v6_0_2c.brocade_fcoe', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.fcoe_fsb', 'pybind.nos.v7_0_1b.brocade_fcoe', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.fcoe_fsb', 'pybind.nos.v7_1_0.brocade_fcoe', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.fcoe_fsb', 'pybind.slxos.v16r_1_00b.brocade_fcoe', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def global_lc_holder_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.global_lc_holder', 'pybind.slxos.v16r_1_00b.brocade_linecard_management', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def global_mtu_conf_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_0_1b.global_mtu_conf', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.global_mtu_conf', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ha_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.ha', 'pybind.nos.v6_0_2c.brocade_ha', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ha', 'pybind.nos.v7_0_1b.brocade_ha', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ha', 'pybind.nos.v7_1_0.brocade_ha', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ha', 'pybind.slxos.v16r_1_00b.brocade_ha', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ha_action_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.ha_action', 'pybind.slxos.v16r_1_00b.brocade_ha', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ha_ha_action_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.ha_action.ha', 'pybind.slxos.v16r_1_00b.brocade_ha', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ha_process_restart_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.ha.process_restart', 'pybind.slxos.v16r_1_00b.brocade_ha', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ha_process_restart_disable_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.ha.process_restart.disable_res', 'pybind.slxos.v16r_1_00b.brocade_ha', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'mpls'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ha_process_restart_disable_mpls_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.ha.process_restart.disable_res', 'pybind.slxos.v16r_1_00b.brocade_ha', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mpls'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def hardware_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.hardware', 'pybind.nos.v6_0_2c.brocade_hardware', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hardware', 'pybind.nos.v7_0_1b.brocade_hardware', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hardware', 'pybind.nos.v7_1_0.brocade_hardware', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.hardware', 'pybind.slxos.v16r_1_00b.brocade_hardware', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def hardware_connector_delete(self, connector=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type connector: name
    :param connector: Keyword argument tuple.

    :type name: unicode
    :param name: **connector** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.hardware.connector', 'pybind.nos.v6_0_2c.brocade_hardware', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hardware.connector', 'pybind.nos.v7_0_1b.brocade_hardware', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hardware.connector', 'pybind.nos.v7_1_0.brocade_hardware', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.hardware.connector', 'pybind.slxos.v16r_1_00b.brocade_hardware', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'connector', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, connector=connector)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, connector=connector)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def hardware_connector_breakout_delete(self, connector=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type connector: name
    :param connector: Keyword argument tuple.

    :type name: unicode
    :param name: **connector** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.hardware.connector', u'connector')]
    bindings_list = [('pybind.slxos.v16r_1_00b.hardware.connector.breakout', 'pybind.slxos.v16r_1_00b.brocade_hardware', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, connector=connector)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, connector=connector)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def hardware_connector_breakout_mode_delete(self, connector=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type connector: name
    :param connector: Keyword argument tuple.

    :type name: unicode
    :param name: **connector** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.hardware.connector', u'connector')]
    bindings_list = [('pybind.slxos.v16r_1_00b.hardware.connector.breakout', 'pybind.slxos.v16r_1_00b.brocade_hardware', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mode'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, connector=connector)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, connector=connector)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def hardware_connector_group_delete(self, connector_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Instance Keyword Argument Tuple**:

    :type connector_group: id
    :param connector_group: Keyword argument tuple.

    :type id: unicode
    :param id: **connector_group** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.hardware.connector_group', 'pybind.nos.v6_0_2c.brocade_hardware', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hardware.connector_group', 'pybind.nos.v7_0_1b.brocade_hardware', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hardware.connector_group', 'pybind.nos.v7_1_0.brocade_hardware', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'connector_group', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, connector_group=connector_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, connector_group=connector_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def hardware_connector_group_speed_delete(self, connector_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Instance Keyword Argument Tuple**:

    :type connector_group: id
    :param connector_group: Keyword argument tuple.

    :type id: unicode
    :param id: **connector_group** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.hardware.connector_group', 'pybind.nos.v6_0_2c.brocade_hardware', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hardware.connector_group', 'pybind.nos.v7_0_1b.brocade_hardware', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hardware.connector_group', 'pybind.nos.v7_1_0.brocade_hardware', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'connector_group', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'speed'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, connector_group=connector_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, connector_group=connector_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def hardware_connector_sfp_delete(self, connector=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type connector: name
    :param connector: Keyword argument tuple.

    :type name: unicode
    :param name: **connector** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.hardware.connector', u'connector'), ('pybind.nos.v7_0_1b.hardware.connector', u'connector'), ('pybind.nos.v7_1_0.hardware.connector', u'connector')]
    bindings_list = [('pybind.nos.v6_0_2c.hardware.connector.sfp', 'pybind.nos.v6_0_2c.brocade_hardware', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hardware.connector.sfp', 'pybind.nos.v7_0_1b.brocade_hardware', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hardware.connector.sfp', 'pybind.nos.v7_1_0.brocade_hardware', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, connector=connector)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, connector=connector)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def hardware_connector_sfp_breakout_delete(self, connector=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type connector: name
    :param connector: Keyword argument tuple.

    :type name: unicode
    :param name: **connector** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.hardware.connector', u'connector'), ('pybind.nos.v7_0_1b.hardware.connector', u'connector'), ('pybind.nos.v7_1_0.hardware.connector', u'connector')]
    bindings_list = [('pybind.nos.v6_0_2c.hardware.connector.sfp', 'pybind.nos.v6_0_2c.brocade_hardware', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hardware.connector.sfp', 'pybind.nos.v7_0_1b.brocade_hardware', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hardware.connector.sfp', 'pybind.nos.v7_1_0.brocade_hardware', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'breakout'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, connector=connector)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, connector=connector)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def hardware_custom_profile_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.hardware.custom_profile', 'pybind.nos.v6_0_2c.brocade_hardware', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hardware.custom_profile', 'pybind.nos.v7_0_1b.brocade_hardware', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hardware.custom_profile', 'pybind.nos.v7_1_0.brocade_hardware', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.hardware.custom_profile', 'pybind.slxos.v16r_1_00b.brocade_hardware', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def hardware_custom_profile_kap_delete(self, kap_custom_profile=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type kap_custom_profile: name
    :param kap_custom_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **kap_custom_profile** tuple argument.

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.hardware.custom_profile.kap_custom_profile', 'pybind.nos.v6_0_2c.brocade_hardware', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hardware.custom_profile.kap_custom_profile', 'pybind.nos.v7_0_1b.brocade_hardware', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hardware.custom_profile.kap_custom_profile', 'pybind.nos.v7_1_0.brocade_hardware', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.hardware.custom_profile.kap_custom_profile', 'pybind.slxos.v16r_1_00b.brocade_hardware', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'kap_custom_profile', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, kap_custom_profile=kap_custom_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, kap_custom_profile=kap_custom_profile)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def hardware_custom_profile_kap_bfd_l3_delete(self, kap_custom_profile=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type kap_custom_profile: name
    :param kap_custom_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **kap_custom_profile** tuple argument.

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.slxos.v16r_1_00b.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.nos.v7_1_0.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.nos.v7_0_1b.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile')]
    bindings_list = [('pybind.nos.v6_0_2c.hardware.custom_profile.kap_custom_profile.bfd_l3', 'pybind.nos.v6_0_2c.brocade_hardware', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hardware.custom_profile.kap_custom_profile.bfd_l3', 'pybind.nos.v7_0_1b.brocade_hardware', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hardware.custom_profile.kap_custom_profile.bfd_l3', 'pybind.nos.v7_1_0.brocade_hardware', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.hardware.custom_profile.kap_custom_profile.bfd_l3', 'pybind.slxos.v16r_1_00b.brocade_hardware', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'bfd_l3_hello_interval, bfd_l3_num_entry'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, kap_custom_profile=kap_custom_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, kap_custom_profile=kap_custom_profile)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def hardware_custom_profile_kap_bfd_l3_hello_interval_delete(self, kap_custom_profile=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type kap_custom_profile: name
    :param kap_custom_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **kap_custom_profile** tuple argument.

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.slxos.v16r_1_00b.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.nos.v7_1_0.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.nos.v7_0_1b.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile')]
    bindings_list = [('pybind.nos.v6_0_2c.hardware.custom_profile.kap_custom_profile.bfd_l3', 'pybind.nos.v6_0_2c.brocade_hardware', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hardware.custom_profile.kap_custom_profile.bfd_l3', 'pybind.nos.v7_0_1b.brocade_hardware', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hardware.custom_profile.kap_custom_profile.bfd_l3', 'pybind.nos.v7_1_0.brocade_hardware', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.hardware.custom_profile.kap_custom_profile.bfd_l3', 'pybind.slxos.v16r_1_00b.brocade_hardware', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hello-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, kap_custom_profile=kap_custom_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, kap_custom_profile=kap_custom_profile)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def hardware_custom_profile_kap_bfd_l3_num_entry_delete(self, kap_custom_profile=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type kap_custom_profile: name
    :param kap_custom_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **kap_custom_profile** tuple argument.

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.slxos.v16r_1_00b.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.nos.v7_1_0.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.nos.v7_0_1b.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile')]
    bindings_list = [('pybind.nos.v6_0_2c.hardware.custom_profile.kap_custom_profile.bfd_l3', 'pybind.nos.v6_0_2c.brocade_hardware', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hardware.custom_profile.kap_custom_profile.bfd_l3', 'pybind.nos.v7_0_1b.brocade_hardware', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hardware.custom_profile.kap_custom_profile.bfd_l3', 'pybind.nos.v7_1_0.brocade_hardware', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.hardware.custom_profile.kap_custom_profile.bfd_l3', 'pybind.slxos.v16r_1_00b.brocade_hardware', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'num-entry'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, kap_custom_profile=kap_custom_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, kap_custom_profile=kap_custom_profile)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def hardware_custom_profile_kap_bfd_vxlan_delete(self, kap_custom_profile=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type kap_custom_profile: name
    :param kap_custom_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **kap_custom_profile** tuple argument.

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.nos.v7_0_1b.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.nos.v6_0_2c.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.nos.v7_1_0.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile')]
    bindings_list = [('pybind.nos.v6_0_2c.hardware.custom_profile.kap_custom_profile.bfd_vxlan', 'pybind.nos.v6_0_2c.brocade_hardware', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hardware.custom_profile.kap_custom_profile.bfd_vxlan', 'pybind.nos.v7_0_1b.brocade_hardware', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hardware.custom_profile.kap_custom_profile.bfd_vxlan', 'pybind.nos.v7_1_0.brocade_hardware', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.hardware.custom_profile.kap_custom_profile.bfd_vxlan', 'pybind.slxos.v16r_1_00b.brocade_hardware', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'bfd_vxlan_hello_interval, bfd_vxlan_num_entry'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, kap_custom_profile=kap_custom_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, kap_custom_profile=kap_custom_profile)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def hardware_custom_profile_kap_bfd_vxlan_hello_interval_delete(self, kap_custom_profile=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type kap_custom_profile: name
    :param kap_custom_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **kap_custom_profile** tuple argument.

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.nos.v7_0_1b.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.nos.v6_0_2c.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.nos.v7_1_0.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile')]
    bindings_list = [('pybind.nos.v6_0_2c.hardware.custom_profile.kap_custom_profile.bfd_vxlan', 'pybind.nos.v6_0_2c.brocade_hardware', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hardware.custom_profile.kap_custom_profile.bfd_vxlan', 'pybind.nos.v7_0_1b.brocade_hardware', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hardware.custom_profile.kap_custom_profile.bfd_vxlan', 'pybind.nos.v7_1_0.brocade_hardware', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.hardware.custom_profile.kap_custom_profile.bfd_vxlan', 'pybind.slxos.v16r_1_00b.brocade_hardware', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hello-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, kap_custom_profile=kap_custom_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, kap_custom_profile=kap_custom_profile)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def hardware_custom_profile_kap_bfd_vxlan_num_entry_delete(self, kap_custom_profile=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type kap_custom_profile: name
    :param kap_custom_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **kap_custom_profile** tuple argument.

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.nos.v7_0_1b.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.nos.v6_0_2c.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.nos.v7_1_0.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile')]
    bindings_list = [('pybind.nos.v6_0_2c.hardware.custom_profile.kap_custom_profile.bfd_vxlan', 'pybind.nos.v6_0_2c.brocade_hardware', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hardware.custom_profile.kap_custom_profile.bfd_vxlan', 'pybind.nos.v7_0_1b.brocade_hardware', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hardware.custom_profile.kap_custom_profile.bfd_vxlan', 'pybind.nos.v7_1_0.brocade_hardware', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.hardware.custom_profile.kap_custom_profile.bfd_vxlan', 'pybind.slxos.v16r_1_00b.brocade_hardware', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'num-entry'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, kap_custom_profile=kap_custom_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, kap_custom_profile=kap_custom_profile)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def hardware_custom_profile_kap_fcoe_delete(self, kap_custom_profile=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type kap_custom_profile: name
    :param kap_custom_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **kap_custom_profile** tuple argument.

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.nos.v7_1_0.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.nos.v6_0_2c.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.slxos.v16r_1_00b.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile')]
    bindings_list = [('pybind.nos.v6_0_2c.hardware.custom_profile.kap_custom_profile.fcoe', 'pybind.nos.v6_0_2c.brocade_hardware', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hardware.custom_profile.kap_custom_profile.fcoe', 'pybind.nos.v7_0_1b.brocade_hardware', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hardware.custom_profile.kap_custom_profile.fcoe', 'pybind.nos.v7_1_0.brocade_hardware', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.hardware.custom_profile.kap_custom_profile.fcoe', 'pybind.slxos.v16r_1_00b.brocade_hardware', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'fcoe_hello_interval, fcoe_num_entry'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, kap_custom_profile=kap_custom_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, kap_custom_profile=kap_custom_profile)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def hardware_custom_profile_kap_fcoe_hello_interval_delete(self, kap_custom_profile=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type kap_custom_profile: name
    :param kap_custom_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **kap_custom_profile** tuple argument.

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.nos.v7_1_0.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.nos.v6_0_2c.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.slxos.v16r_1_00b.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile')]
    bindings_list = [('pybind.nos.v6_0_2c.hardware.custom_profile.kap_custom_profile.fcoe', 'pybind.nos.v6_0_2c.brocade_hardware', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hardware.custom_profile.kap_custom_profile.fcoe', 'pybind.nos.v7_0_1b.brocade_hardware', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hardware.custom_profile.kap_custom_profile.fcoe', 'pybind.nos.v7_1_0.brocade_hardware', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.hardware.custom_profile.kap_custom_profile.fcoe', 'pybind.slxos.v16r_1_00b.brocade_hardware', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hello-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, kap_custom_profile=kap_custom_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, kap_custom_profile=kap_custom_profile)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def hardware_custom_profile_kap_fcoe_num_entry_delete(self, kap_custom_profile=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type kap_custom_profile: name
    :param kap_custom_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **kap_custom_profile** tuple argument.

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.nos.v7_1_0.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.nos.v6_0_2c.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.slxos.v16r_1_00b.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile')]
    bindings_list = [('pybind.nos.v6_0_2c.hardware.custom_profile.kap_custom_profile.fcoe', 'pybind.nos.v6_0_2c.brocade_hardware', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hardware.custom_profile.kap_custom_profile.fcoe', 'pybind.nos.v7_0_1b.brocade_hardware', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hardware.custom_profile.kap_custom_profile.fcoe', 'pybind.nos.v7_1_0.brocade_hardware', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.hardware.custom_profile.kap_custom_profile.fcoe', 'pybind.slxos.v16r_1_00b.brocade_hardware', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'num-entry'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, kap_custom_profile=kap_custom_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, kap_custom_profile=kap_custom_profile)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def hardware_custom_profile_kap_lacp_delete(self, kap_custom_profile=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type kap_custom_profile: name
    :param kap_custom_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **kap_custom_profile** tuple argument.

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.nos.v6_0_2c.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.slxos.v16r_1_00b.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.nos.v7_1_0.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile')]
    bindings_list = [('pybind.nos.v6_0_2c.hardware.custom_profile.kap_custom_profile.lacp', 'pybind.nos.v6_0_2c.brocade_hardware', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hardware.custom_profile.kap_custom_profile.lacp', 'pybind.nos.v7_0_1b.brocade_hardware', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hardware.custom_profile.kap_custom_profile.lacp', 'pybind.nos.v7_1_0.brocade_hardware', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.hardware.custom_profile.kap_custom_profile.lacp', 'pybind.slxos.v16r_1_00b.brocade_hardware', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'lacp_hello_interval, lacp_num_entry'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, kap_custom_profile=kap_custom_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, kap_custom_profile=kap_custom_profile)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def hardware_custom_profile_kap_lacp_hello_interval_delete(self, kap_custom_profile=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type kap_custom_profile: name
    :param kap_custom_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **kap_custom_profile** tuple argument.

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.nos.v6_0_2c.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.slxos.v16r_1_00b.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.nos.v7_1_0.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile')]
    bindings_list = [('pybind.nos.v6_0_2c.hardware.custom_profile.kap_custom_profile.lacp', 'pybind.nos.v6_0_2c.brocade_hardware', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hardware.custom_profile.kap_custom_profile.lacp', 'pybind.nos.v7_0_1b.brocade_hardware', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hardware.custom_profile.kap_custom_profile.lacp', 'pybind.nos.v7_1_0.brocade_hardware', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.hardware.custom_profile.kap_custom_profile.lacp', 'pybind.slxos.v16r_1_00b.brocade_hardware', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hello-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, kap_custom_profile=kap_custom_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, kap_custom_profile=kap_custom_profile)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def hardware_custom_profile_kap_lacp_num_entry_delete(self, kap_custom_profile=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type kap_custom_profile: name
    :param kap_custom_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **kap_custom_profile** tuple argument.

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.nos.v6_0_2c.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.slxos.v16r_1_00b.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.nos.v7_1_0.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile')]
    bindings_list = [('pybind.nos.v6_0_2c.hardware.custom_profile.kap_custom_profile.lacp', 'pybind.nos.v6_0_2c.brocade_hardware', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hardware.custom_profile.kap_custom_profile.lacp', 'pybind.nos.v7_0_1b.brocade_hardware', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hardware.custom_profile.kap_custom_profile.lacp', 'pybind.nos.v7_1_0.brocade_hardware', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.hardware.custom_profile.kap_custom_profile.lacp', 'pybind.slxos.v16r_1_00b.brocade_hardware', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'num-entry'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, kap_custom_profile=kap_custom_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, kap_custom_profile=kap_custom_profile)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def hardware_custom_profile_kap_rpvst_delete(self, kap_custom_profile=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type kap_custom_profile: name
    :param kap_custom_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **kap_custom_profile** tuple argument.

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.nos.v7_1_0.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.nos.v6_0_2c.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.slxos.v16r_1_00b.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile')]
    bindings_list = [('pybind.nos.v6_0_2c.hardware.custom_profile.kap_custom_profile.rpvst', 'pybind.nos.v6_0_2c.brocade_hardware', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hardware.custom_profile.kap_custom_profile.rpvst', 'pybind.nos.v7_0_1b.brocade_hardware', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hardware.custom_profile.kap_custom_profile.rpvst', 'pybind.nos.v7_1_0.brocade_hardware', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.hardware.custom_profile.kap_custom_profile.rpvst', 'pybind.slxos.v16r_1_00b.brocade_hardware', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'rpvst_hello_interval, rpvst_num_entry'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, kap_custom_profile=kap_custom_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, kap_custom_profile=kap_custom_profile)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def hardware_custom_profile_kap_rpvst_hello_interval_delete(self, kap_custom_profile=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type kap_custom_profile: name
    :param kap_custom_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **kap_custom_profile** tuple argument.

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.nos.v7_1_0.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.nos.v6_0_2c.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.slxos.v16r_1_00b.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile')]
    bindings_list = [('pybind.nos.v6_0_2c.hardware.custom_profile.kap_custom_profile.rpvst', 'pybind.nos.v6_0_2c.brocade_hardware', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hardware.custom_profile.kap_custom_profile.rpvst', 'pybind.nos.v7_0_1b.brocade_hardware', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hardware.custom_profile.kap_custom_profile.rpvst', 'pybind.nos.v7_1_0.brocade_hardware', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.hardware.custom_profile.kap_custom_profile.rpvst', 'pybind.slxos.v16r_1_00b.brocade_hardware', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hello-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, kap_custom_profile=kap_custom_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, kap_custom_profile=kap_custom_profile)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def hardware_custom_profile_kap_rpvst_num_entry_delete(self, kap_custom_profile=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type kap_custom_profile: name
    :param kap_custom_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **kap_custom_profile** tuple argument.

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.nos.v7_1_0.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.nos.v6_0_2c.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.slxos.v16r_1_00b.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile')]
    bindings_list = [('pybind.nos.v6_0_2c.hardware.custom_profile.kap_custom_profile.rpvst', 'pybind.nos.v6_0_2c.brocade_hardware', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hardware.custom_profile.kap_custom_profile.rpvst', 'pybind.nos.v7_0_1b.brocade_hardware', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hardware.custom_profile.kap_custom_profile.rpvst', 'pybind.nos.v7_1_0.brocade_hardware', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.hardware.custom_profile.kap_custom_profile.rpvst', 'pybind.slxos.v16r_1_00b.brocade_hardware', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'num-entry'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, kap_custom_profile=kap_custom_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, kap_custom_profile=kap_custom_profile)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def hardware_custom_profile_kap_udld_delete(self, kap_custom_profile=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type kap_custom_profile: name
    :param kap_custom_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **kap_custom_profile** tuple argument.

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.nos.v6_0_2c.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.nos.v7_1_0.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.slxos.v16r_1_00b.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile')]
    bindings_list = [('pybind.nos.v6_0_2c.hardware.custom_profile.kap_custom_profile.udld', 'pybind.nos.v6_0_2c.brocade_hardware', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hardware.custom_profile.kap_custom_profile.udld', 'pybind.nos.v7_0_1b.brocade_hardware', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hardware.custom_profile.kap_custom_profile.udld', 'pybind.nos.v7_1_0.brocade_hardware', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.hardware.custom_profile.kap_custom_profile.udld', 'pybind.slxos.v16r_1_00b.brocade_hardware', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'udld_hello_interval, udld_num_entry'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, kap_custom_profile=kap_custom_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, kap_custom_profile=kap_custom_profile)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def hardware_custom_profile_kap_udld_hello_interval_delete(self, kap_custom_profile=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type kap_custom_profile: name
    :param kap_custom_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **kap_custom_profile** tuple argument.

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.nos.v6_0_2c.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.nos.v7_1_0.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.slxos.v16r_1_00b.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile')]
    bindings_list = [('pybind.nos.v6_0_2c.hardware.custom_profile.kap_custom_profile.udld', 'pybind.nos.v6_0_2c.brocade_hardware', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hardware.custom_profile.kap_custom_profile.udld', 'pybind.nos.v7_0_1b.brocade_hardware', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hardware.custom_profile.kap_custom_profile.udld', 'pybind.nos.v7_1_0.brocade_hardware', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.hardware.custom_profile.kap_custom_profile.udld', 'pybind.slxos.v16r_1_00b.brocade_hardware', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hello-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, kap_custom_profile=kap_custom_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, kap_custom_profile=kap_custom_profile)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def hardware_custom_profile_kap_udld_num_entry_delete(self, kap_custom_profile=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type kap_custom_profile: name
    :param kap_custom_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **kap_custom_profile** tuple argument.

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.nos.v6_0_2c.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.nos.v7_1_0.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.slxos.v16r_1_00b.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile')]
    bindings_list = [('pybind.nos.v6_0_2c.hardware.custom_profile.kap_custom_profile.udld', 'pybind.nos.v6_0_2c.brocade_hardware', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hardware.custom_profile.kap_custom_profile.udld', 'pybind.nos.v7_0_1b.brocade_hardware', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hardware.custom_profile.kap_custom_profile.udld', 'pybind.nos.v7_1_0.brocade_hardware', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.hardware.custom_profile.kap_custom_profile.udld', 'pybind.slxos.v16r_1_00b.brocade_hardware', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'num-entry'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, kap_custom_profile=kap_custom_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, kap_custom_profile=kap_custom_profile)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def hardware_custom_profile_kap_xstp_delete(self, kap_custom_profile=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type kap_custom_profile: name
    :param kap_custom_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **kap_custom_profile** tuple argument.

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.nos.v7_1_0.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.nos.v7_0_1b.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.slxos.v16r_1_00b.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile')]
    bindings_list = [('pybind.nos.v6_0_2c.hardware.custom_profile.kap_custom_profile.xstp', 'pybind.nos.v6_0_2c.brocade_hardware', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hardware.custom_profile.kap_custom_profile.xstp', 'pybind.nos.v7_0_1b.brocade_hardware', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hardware.custom_profile.kap_custom_profile.xstp', 'pybind.nos.v7_1_0.brocade_hardware', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.hardware.custom_profile.kap_custom_profile.xstp', 'pybind.slxos.v16r_1_00b.brocade_hardware', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'xstp_hello_interval, xstp_num_entry'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, kap_custom_profile=kap_custom_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, kap_custom_profile=kap_custom_profile)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def hardware_custom_profile_kap_xstp_hello_interval_delete(self, kap_custom_profile=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type kap_custom_profile: name
    :param kap_custom_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **kap_custom_profile** tuple argument.

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.nos.v7_1_0.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.nos.v7_0_1b.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.slxos.v16r_1_00b.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile')]
    bindings_list = [('pybind.nos.v6_0_2c.hardware.custom_profile.kap_custom_profile.xstp', 'pybind.nos.v6_0_2c.brocade_hardware', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hardware.custom_profile.kap_custom_profile.xstp', 'pybind.nos.v7_0_1b.brocade_hardware', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hardware.custom_profile.kap_custom_profile.xstp', 'pybind.nos.v7_1_0.brocade_hardware', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.hardware.custom_profile.kap_custom_profile.xstp', 'pybind.slxos.v16r_1_00b.brocade_hardware', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hello-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, kap_custom_profile=kap_custom_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, kap_custom_profile=kap_custom_profile)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def hardware_custom_profile_kap_xstp_num_entry_delete(self, kap_custom_profile=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type kap_custom_profile: name
    :param kap_custom_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **kap_custom_profile** tuple argument.

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.nos.v7_1_0.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.nos.v7_0_1b.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.slxos.v16r_1_00b.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile')]
    bindings_list = [('pybind.nos.v6_0_2c.hardware.custom_profile.kap_custom_profile.xstp', 'pybind.nos.v6_0_2c.brocade_hardware', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hardware.custom_profile.kap_custom_profile.xstp', 'pybind.nos.v7_0_1b.brocade_hardware', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hardware.custom_profile.kap_custom_profile.xstp', 'pybind.nos.v7_1_0.brocade_hardware', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.hardware.custom_profile.kap_custom_profile.xstp', 'pybind.slxos.v16r_1_00b.brocade_hardware', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'num-entry'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, kap_custom_profile=kap_custom_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, kap_custom_profile=kap_custom_profile)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def hardware_flexport_delete(self, flexport=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Instance Keyword Argument Tuple**:

    :type flexport: id
    :param flexport: Keyword argument tuple.

    :type id: unicode
    :param id: **flexport** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.hardware.flexport', 'pybind.nos.v6_0_2c.brocade_hardware', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hardware.flexport', 'pybind.nos.v7_0_1b.brocade_hardware', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hardware.flexport', 'pybind.nos.v7_1_0.brocade_hardware', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'flexport', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flexport=flexport)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flexport=flexport)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def hardware_flexport_instance_delete(self, flexport=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type flexport: id
    :param flexport: Keyword argument tuple.

    :type id: unicode
    :param id: **flexport** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.hardware.flexport', u'flexport'), ('pybind.nos.v7_0_1b.hardware.flexport', u'flexport'), ('pybind.nos.v6_0_2c.hardware.flexport', u'flexport')]
    bindings_list = [('pybind.nos.v6_0_2c.hardware.flexport.flexport_type', 'pybind.nos.v6_0_2c.brocade_hardware', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hardware.flexport.flexport_type', 'pybind.nos.v7_0_1b.brocade_hardware', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hardware.flexport.flexport_type', 'pybind.nos.v7_1_0.brocade_hardware', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'instance'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flexport=flexport)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flexport=flexport)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def hardware_flexport_skip_deconfig_delete(self, flexport=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type flexport: id
    :param flexport: Keyword argument tuple.

    :type id: unicode
    :param id: **flexport** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.hardware.flexport', u'flexport'), ('pybind.nos.v7_0_1b.hardware.flexport', u'flexport'), ('pybind.nos.v6_0_2c.hardware.flexport', u'flexport')]
    bindings_list = [('pybind.nos.v6_0_2c.hardware.flexport.flexport_type', 'pybind.nos.v6_0_2c.brocade_hardware', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hardware.flexport.flexport_type', 'pybind.nos.v7_0_1b.brocade_hardware', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hardware.flexport.flexport_type', 'pybind.nos.v7_1_0.brocade_hardware', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'skip_deconfig'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flexport=flexport)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flexport=flexport)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def hardware_flexport_type_delete(self, flexport=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type flexport: id
    :param flexport: Keyword argument tuple.

    :type id: unicode
    :param id: **flexport** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.hardware.flexport', u'flexport'), ('pybind.nos.v7_0_1b.hardware.flexport', u'flexport'), ('pybind.nos.v6_0_2c.hardware.flexport', u'flexport')]
    bindings_list = [('pybind.nos.v6_0_2c.hardware.flexport.flexport_type', 'pybind.nos.v6_0_2c.brocade_hardware', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hardware.flexport.flexport_type', 'pybind.nos.v7_0_1b.brocade_hardware', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hardware.flexport.flexport_type', 'pybind.nos.v7_1_0.brocade_hardware', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flexport=flexport)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flexport=flexport)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def hardware_port_group_delete(self, port_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type port_group: name
    :param port_group: Keyword argument tuple.

    :type name: unicode
    :param name: **port_group** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.hardware.port_group', 'pybind.nos.v6_0_2c.brocade_hardware', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hardware.port_group', 'pybind.nos.v7_0_1b.brocade_hardware', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hardware.port_group', 'pybind.nos.v7_1_0.brocade_hardware', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.hardware.port_group', 'pybind.slxos.v16r_1_00b.brocade_hardware', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'port_group', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v7_1_0.hardware.port_group": {"name": "name"}, "pybind.slxos.v16r_1_00b.hardware.port_group": {}, "pybind.nos.v6_0_2c.hardware.port_group": {"name": "name"}, "pybind.nos.v7_0_1b.hardware.port_group": {"name": "name"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_group=port_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_group=port_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def hardware_port_group_mode_delete(self, port_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type port_group: name
    :param port_group: Keyword argument tuple.

    :type name: unicode
    :param name: **port_group** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.hardware.port_group', 'pybind.slxos.v16r_1_00b.brocade_hardware', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'port_group', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mode'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_group=port_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_group=port_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def hardware_port_group_mode_performance_delete(self, port_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_group: name
    :param port_group: Keyword argument tuple.

    :type name: unicode
    :param name: **port_group** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.hardware.port_group', u'port_group'), ('pybind.nos.v7_0_1b.hardware.port_group', u'port_group'), ('pybind.nos.v7_1_0.hardware.port_group', u'port_group')]
    bindings_list = [('pybind.nos.v6_0_2c.hardware.port_group.mode', 'pybind.nos.v6_0_2c.brocade_hardware', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hardware.port_group.mode', 'pybind.nos.v7_0_1b.brocade_hardware', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hardware.port_group.mode', 'pybind.nos.v7_1_0.brocade_hardware', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'performance'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_group=port_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_group=port_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def hardware_port_group_mode_portgroup_speed_delete(self, port_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_group: name
    :param port_group: Keyword argument tuple.

    :type name: unicode
    :param name: **port_group** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.hardware.port_group', u'port_group'), ('pybind.nos.v7_1_0.hardware.port_group', u'port_group')]
    bindings_list = [('pybind.nos.v7_0_1b.hardware.port_group.mode', 'pybind.nos.v7_0_1b.brocade_hardware', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hardware.port_group.mode', 'pybind.nos.v7_1_0.brocade_hardware', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'portgroup-speed'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_group=port_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_group=port_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def hardware_port_group_mode_support_multispeed_delete(self, port_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_group: name
    :param port_group: Keyword argument tuple.

    :type name: unicode
    :param name: **port_group** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.hardware.port_group', u'port_group'), ('pybind.nos.v7_1_0.hardware.port_group', u'port_group')]
    bindings_list = [('pybind.nos.v7_0_1b.hardware.port_group.mode', 'pybind.nos.v7_0_1b.brocade_hardware', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hardware.port_group.mode', 'pybind.nos.v7_1_0.brocade_hardware', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'support_multispeed'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_group=port_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_group=port_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def hardware_port_group_mode_support_performance_delete(self, port_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_group: name
    :param port_group: Keyword argument tuple.

    :type name: unicode
    :param name: **port_group** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.hardware.port_group', u'port_group'), ('pybind.nos.v7_1_0.hardware.port_group', u'port_group')]
    bindings_list = [('pybind.nos.v7_0_1b.hardware.port_group.mode', 'pybind.nos.v7_0_1b.brocade_hardware', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hardware.port_group.mode', 'pybind.nos.v7_1_0.brocade_hardware', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'support_performance'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_group=port_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_group=port_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def hardware_profile_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.hardware.profile', 'pybind.slxos.v16r_1_00b.brocade_hardware', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def hardware_profile_counters_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.hardware.profile.counters', 'pybind.slxos.v16r_1_00b.brocade_hardware', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def hardware_profile_counters_counters_profiletype_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.hardware.profile.counters.predefined', 'pybind.slxos.v16r_1_00b.brocade_hardware', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'counters_profiletype'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def hardware_profile_counters_predefined_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.hardware.profile.counters.predefined', 'pybind.slxos.v16r_1_00b.brocade_hardware', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def hardware_profile_kap_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.hardware.profile.kap', 'pybind.slxos.v16r_1_00b.brocade_hardware', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def hardware_profile_kap_custom_profile_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.hardware.profile.kap.customized', 'pybind.slxos.v16r_1_00b.brocade_hardware', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def hardware_profile_kap_custom_profile_kap_profilename_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.hardware.profile.kap.customized', 'pybind.slxos.v16r_1_00b.brocade_hardware', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'kap_profilename'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def hardware_profile_kap_kap_profiletype_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.hardware.profile.kap.predefined', 'pybind.slxos.v16r_1_00b.brocade_hardware', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'kap_profiletype'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def hardware_profile_kap_predefined_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.hardware.profile.kap.predefined', 'pybind.slxos.v16r_1_00b.brocade_hardware', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def hardware_profile_lag_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.hardware.profile.lag', 'pybind.slxos.v16r_1_00b.brocade_hardware', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def hardware_profile_lag_lag_profiletype_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.hardware.profile.lag.predefined', 'pybind.slxos.v16r_1_00b.brocade_hardware', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lag_profiletype'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def hardware_profile_lag_predefined_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.hardware.profile.lag.predefined', 'pybind.slxos.v16r_1_00b.brocade_hardware', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def hardware_profile_route_table_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.hardware.profile.route_table', 'pybind.slxos.v16r_1_00b.brocade_hardware', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def hardware_profile_route_table_maximum_paths_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.hardware.profile.route_table.predefined.routing_parameter', 'pybind.slxos.v16r_1_00b.brocade_hardware', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'maximum_paths'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def hardware_profile_route_table_openflow_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.hardware.profile.route_table.predefined.routing_parameter', 'pybind.slxos.v16r_1_00b.brocade_hardware', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'openflow'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def hardware_profile_route_table_predefined_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.hardware.profile.route_table.predefined', 'pybind.slxos.v16r_1_00b.brocade_hardware', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'routing_profiletype'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def hardware_profile_route_table_routing_parameter_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.hardware.profile.route_table.predefined.routing_parameter', 'pybind.slxos.v16r_1_00b.brocade_hardware', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'maximum_paths, openflow_enable'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def hardware_profile_route_table_routing_profiletype_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.hardware.profile.route_table.predefined', 'pybind.slxos.v16r_1_00b.brocade_hardware', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'routing_profiletype'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def hardware_profile_tcam_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.hardware.profile.tcam', 'pybind.slxos.v16r_1_00b.brocade_hardware', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def hardware_profile_tcam_predefined_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.hardware.profile.tcam.predefined', 'pybind.slxos.v16r_1_00b.brocade_hardware', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def hardware_profile_tcam_tcam_profiletype_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.hardware.profile.tcam.predefined', 'pybind.slxos.v16r_1_00b.brocade_hardware', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tcam_profiletype'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def hardware_profile_vlan_classification_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.hardware.profile.vlan_classification', 'pybind.slxos.v16r_1_00b.brocade_hardware', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def hardware_profile_vlan_classification_predefined_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.hardware.profile.vlan_classification.predefined', 'pybind.slxos.v16r_1_00b.brocade_hardware', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def hardware_profile_vlan_classification_vlan_profiletype_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.hardware.profile.vlan_classification.predefined', 'pybind.slxos.v16r_1_00b.brocade_hardware', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vlan_profiletype'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def hide_arp_holder_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.hide_arp_holder', 'pybind.nos.v6_0_2c.brocade_arp', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_arp_holder', 'pybind.nos.v7_0_1b.brocade_arp', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_arp_holder', 'pybind.nos.v7_1_0.brocade_arp', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def hide_filter_change_update_delay_holder_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.hide_filter_change_update_delay_holder', 'pybind.nos.v6_0_2c.brocade_ip_policy', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_filter_change_update_delay_holder', 'pybind.nos.v7_0_1b.brocade_ip_policy', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_filter_change_update_delay_holder', 'pybind.nos.v7_1_0.brocade_ip_policy', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.hide_filter_change_update_delay_holder', 'pybind.slxos.v16r_1_00b.brocade_ip_policy', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def hide_intf_loopback_holder_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.hide_intf_loopback_holder', 'pybind.nos.v6_0_2c.brocade_intf_loopback', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_intf_loopback_holder', 'pybind.nos.v7_0_1b.brocade_intf_loopback', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_intf_loopback_holder', 'pybind.nos.v7_1_0.brocade_intf_loopback', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def hide_routemap_holder_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.hide_routemap_holder', 'pybind.nos.v6_0_2c.brocade_ip_policy', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_routemap_holder', 'pybind.nos.v7_0_1b.brocade_ip_policy', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_routemap_holder', 'pybind.nos.v7_1_0.brocade_ip_policy', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def http_sa_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.http_sa', 'pybind.nos.v6_0_2c.brocade_http_config', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.http_sa', 'pybind.nos.v7_0_1b.brocade_http_config', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.http_sa', 'pybind.nos.v7_1_0.brocade_http_config', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.http_sa', 'pybind.slxos.v16r_1_00b.brocade_http_config', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def http_server_http_vrf_cont_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_0_1b.http_sa.http.server.http_vrf_cont', 'pybind.nos.v7_0_1b.brocade_http_config', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.http_sa.http.server.http_vrf_cont', 'pybind.nos.v7_1_0.brocade_http_config', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.http_sa.http.server.http_vrf_cont', 'pybind.slxos.v16r_1_00b.brocade_http_config', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def http_server_shutdown_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.http_sa.http.server', 'pybind.nos.v6_0_2c.brocade_http_config', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.http_sa.http.server', 'pybind.nos.v7_0_1b.brocade_http_config', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.http_sa.http.server', 'pybind.nos.v7_1_0.brocade_http_config', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.http_sa.http.server', 'pybind.slxos.v16r_1_00b.brocade_http_config', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'shutdown'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def http_server_use_vrf_delete(self, use_vrf=None, http_vrf_shutdown=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type use_vrf: use_vrf_name, http_vrf_shutdown
    :param use_vrf: Keyword argument tuple.

    :type use_vrf_name: unicode
    :param use_vrf_name: **use_vrf** tuple argument.

        * length restriction: ::

            ['0..max']

    :type http_vrf_shutdown: YANGBool
    :param http_vrf_shutdown: **use_vrf** tuple argument:  Shutdown HTTP/HTTPS server on the given vrf

    **Instance Argument(s)**:

    :type http_vrf_shutdown: YANGBool
    :param http_vrf_shutdown: Shutdown HTTP/HTTPS server on the given vrf

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_0_1b.http_sa.http.server.http_vrf_cont.use_vrf', 'pybind.nos.v7_0_1b.brocade_http_config', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.http_sa.http.server.http_vrf_cont.use_vrf', 'pybind.nos.v7_1_0.brocade_http_config', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.http_sa.http.server.http_vrf_cont.use_vrf', 'pybind.slxos.v16r_1_00b.brocade_http_config', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'use_vrf', 'keyval': 'use_vrf_name', 'extra_keyval': 'use_vrf_name, http_vrf_shutdown'}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v7_0_1b.http_sa.http.server.http_vrf_cont.use_vrf": {"http_vrf_shutdown": "http_vrf_shutdown", "use_vrf_name": "use_vrf_name"}, "pybind.slxos.v16r_1_00b.http_sa.http.server.http_vrf_cont.use_vrf": {"http_vrf_shutdown": "http_vrf_shutdown", "use_vrf_name": "use_vrf_name"}, "pybind.nos.v7_1_0.http_sa.http.server.http_vrf_cont.use_vrf": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, use_vrf=use_vrf, http_vrf_shutdown=http_vrf_shutdown)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, use_vrf=use_vrf, http_vrf_shutdown=http_vrf_shutdown)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def http_server_use_vrf_secure_and_plain_delete(self, use_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    **Instance Keyword Argument Tuple**:

    :type use_vrf: use_vrf_name
    :param use_vrf: Keyword argument tuple.

    :type use_vrf_name: unicode
    :param use_vrf_name: **use_vrf** tuple argument.

        * length restriction: ::

            ['0..max']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_1_0.http_sa.http.server.http_vrf_cont.use_vrf', 'pybind.nos.v7_1_0.brocade_http_config', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'use_vrf', 'keyval': 'use_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'secure-and-plain'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, use_vrf=use_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, use_vrf=use_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def http_server_use_vrf_shutdown_delete(self, use_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type use_vrf: use_vrf_name
    :param use_vrf: Keyword argument tuple.

    :type use_vrf_name: unicode
    :param use_vrf_name: **use_vrf** tuple argument.

        * length restriction: ::

            ['0..max']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_0_1b.http_sa.http.server.http_vrf_cont.use_vrf', 'pybind.nos.v7_0_1b.brocade_http_config', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.http_sa.http.server.http_vrf_cont.use_vrf', 'pybind.nos.v7_1_0.brocade_http_config', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.http_sa.http.server.http_vrf_cont.use_vrf', 'pybind.slxos.v16r_1_00b.brocade_http_config', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'use_vrf', 'keyval': 'use_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'shutdown'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, use_vrf=use_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, use_vrf=use_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.igmp_snooping', 'pybind.nos.v6_0_2c.brocade_igmp_snooping', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.igmp_snooping', 'pybind.nos.v7_0_1b.brocade_igmp_snooping', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.igmp_snooping', 'pybind.nos.v7_1_0.brocade_igmp_snooping', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.igmp_snooping', 'pybind.slxos.v16r_1_00b.brocade_igmp_snooping', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_debug_igmp_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.debug_igmp', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_debug_igmp_direction_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.debug_igmp', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'direction'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_debug_igmp_enable_any_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.debug_igmp', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable-any'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_debug_igmp_error_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.debug_igmp', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'error'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_debug_igmp_events_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.debug_igmp', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'events'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_debug_igmp_group_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.debug_igmp', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'group'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_debug_igmp_grp_addr_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.debug_igmp', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'grp-addr'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_debug_igmp_io_port_name_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.debug_igmp', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'io-port-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_debug_igmp_packets_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.debug_igmp', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'packets'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_debug_igmp_phy_port_name_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.debug_igmp', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'phy-port-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_debug_igmp_protocol_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.debug_igmp', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'protocol'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_debug_igmp_query_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.debug_igmp', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'query'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_debug_igmp_v1_report_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.debug_igmp', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'v1-report'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_igmp_groups_delete(self, igmp_groups=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type igmp_groups: group_addr, interface_name
    :param igmp_groups: Keyword argument tuple.

    :type group_addr: unicode
    :param group_addr: **igmp_groups** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type interface_name: unicode
    :param interface_name: **igmp_groups** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_groups', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_groups', 'keyval': 'group_addr, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_groups=igmp_groups)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_groups=igmp_groups)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_igmp_groups_igmp_groups_delete(self, igmp_groups=None, igmp_groups_=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_groups: group_addr, interface_name
    :param igmp_groups: Keyword argument tuple.

    :type group_addr: unicode
    :param group_addr: **igmp_groups** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type interface_name: unicode
    :param interface_name: **igmp_groups** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type igmp_groups_: group_addr, interface_name
    :param igmp_groups_: Keyword argument tuple.

    :type group_addr: long
    :param group_addr: **igmp_groups_** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type interface_name: unicode
    :param interface_name: **igmp_groups_** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_groups', u'igmp_groups')]
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_groups.igmp_groups', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'group_addr, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'igmp_groups_', 'keyval': 'group_addr, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_groups=igmp_groups, igmp_groups_=igmp_groups_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_groups=igmp_groups, igmp_groups_=igmp_groups_)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_igmp_groups_igmp_groups_expiry_time_delete(self, igmp_groups=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_groups: group_addr, interface_name
    :param igmp_groups: Keyword argument tuple.

    :type group_addr: unicode
    :param group_addr: **igmp_groups** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type interface_name: unicode
    :param interface_name: **igmp_groups** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_groups', u'igmp_groups')]
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_groups.igmp_groups_', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'group_addr, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'expiry_time', 'keyval': 'group_addr, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'expiry-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_groups=igmp_groups)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_groups=igmp_groups)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_igmp_groups_igmp_groups_filter_mode_delete(self, igmp_groups=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_groups: group_addr, interface_name
    :param igmp_groups: Keyword argument tuple.

    :type group_addr: unicode
    :param group_addr: **igmp_groups** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type interface_name: unicode
    :param interface_name: **igmp_groups** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_groups', u'igmp_groups')]
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_groups.igmp_groups_', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'group_addr, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'expiry_time', 'keyval': 'group_addr, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'filter-mode'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_groups=igmp_groups)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_groups=igmp_groups)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_igmp_groups_igmp_groups_igmpv3_sources_delete(self, igmp_groups=None, igmpv3_sources=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_groups: group_addr, interface_name
    :param igmp_groups: Keyword argument tuple.

    :type group_addr: unicode
    :param group_addr: **igmp_groups** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type interface_name: unicode
    :param interface_name: **igmp_groups** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type igmpv3_sources: interface_name
    :param igmpv3_sources: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **igmpv3_sources** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_groups', u'igmp_groups')]
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_groups.igmp_groups_.igmpv3_sources', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'group_addr, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'igmpv3_sources', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_groups=igmp_groups, igmpv3_sources=igmpv3_sources)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_groups=igmp_groups, igmpv3_sources=igmpv3_sources)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_igmp_groups_igmp_groups_igmpv3_sources_excl_src_ip_delete(self, igmp_groups=None, igmpv3_sources=None, excl_src_ip=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_groups: group_addr, interface_name
    :param igmp_groups: Keyword argument tuple.

    :type group_addr: unicode
    :param group_addr: **igmp_groups** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type interface_name: unicode
    :param interface_name: **igmp_groups** tuple argument.

    :type igmpv3_sources: interface_name
    :param igmpv3_sources: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **igmpv3_sources** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type excl_src_ip: ipv4_addr
    :param excl_src_ip: Keyword argument tuple.

    :type ipv4_addr: long
    :param ipv4_addr: **excl_src_ip** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_groups', u'igmp_groups'), ('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_groups.igmp_groups_.igmpv3_sources', u'igmpv3_sources')]
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_groups.igmp_groups_.igmpv3_sources.excl_src_ip', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'group_addr, interface_name', 'extra_keyval': ''}, {'keyval': 'interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'excl_src_ip', 'keyval': 'ipv4_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_groups=igmp_groups, igmpv3_sources=igmpv3_sources, excl_src_ip=excl_src_ip)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_groups=igmp_groups, igmpv3_sources=igmpv3_sources, excl_src_ip=excl_src_ip)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_igmp_groups_igmp_groups_igmpv3_sources_incl_src_ip_delete(self, igmp_groups=None, igmpv3_sources=None, incl_src_ip=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_groups: group_addr, interface_name
    :param igmp_groups: Keyword argument tuple.

    :type group_addr: unicode
    :param group_addr: **igmp_groups** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type interface_name: unicode
    :param interface_name: **igmp_groups** tuple argument.

    :type igmpv3_sources: interface_name
    :param igmpv3_sources: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **igmpv3_sources** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type incl_src_ip: ipv4_addr
    :param incl_src_ip: Keyword argument tuple.

    :type ipv4_addr: long
    :param ipv4_addr: **incl_src_ip** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_groups', u'igmp_groups'), ('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_groups.igmp_groups_.igmpv3_sources', u'igmpv3_sources')]
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_groups.igmp_groups_.igmpv3_sources.incl_src_ip', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'group_addr, interface_name', 'extra_keyval': ''}, {'keyval': 'interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'incl_src_ip', 'keyval': 'ipv4_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_groups=igmp_groups, igmpv3_sources=igmpv3_sources, incl_src_ip=incl_src_ip)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_groups=igmp_groups, igmpv3_sources=igmpv3_sources, incl_src_ip=incl_src_ip)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_igmp_groups_igmp_groups_last_reporter_delete(self, igmp_groups=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_groups: group_addr, interface_name
    :param igmp_groups: Keyword argument tuple.

    :type group_addr: unicode
    :param group_addr: **igmp_groups** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type interface_name: unicode
    :param interface_name: **igmp_groups** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_groups', u'igmp_groups')]
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_groups.igmp_groups_', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'group_addr, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'expiry_time', 'keyval': 'group_addr, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'last-reporter'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_groups=igmp_groups)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_groups=igmp_groups)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_igmp_groups_igmp_groups_member_ship_delete(self, igmp_groups=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_groups: group_addr, interface_name
    :param igmp_groups: Keyword argument tuple.

    :type group_addr: unicode
    :param group_addr: **igmp_groups** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type interface_name: unicode
    :param interface_name: **igmp_groups** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_groups', u'igmp_groups')]
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_groups.igmp_groups_', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'group_addr, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'expiry_time', 'keyval': 'group_addr, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'member-ship'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_groups=igmp_groups)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_groups=igmp_groups)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_igmp_groups_igmp_groups_uptime_delete(self, igmp_groups=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_groups: group_addr, interface_name
    :param igmp_groups: Keyword argument tuple.

    :type group_addr: unicode
    :param group_addr: **igmp_groups** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type interface_name: unicode
    :param interface_name: **igmp_groups** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_groups', u'igmp_groups')]
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_groups.igmp_groups_', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'group_addr, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'expiry_time', 'keyval': 'group_addr, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'uptime'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_groups=igmp_groups)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_groups=igmp_groups)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_igmp_interface_statistics_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_interface_statistics', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_igmp_interface_statistics_error_bad_checksum_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_interface_statistics', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'error-bad-checksum'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_igmp_interface_statistics_error_bad_length_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_interface_statistics', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'error-bad-length'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_igmp_interface_statistics_error_unknown_types_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_interface_statistics', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'error-unknown-types'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_igmp_interface_statistics_grp_leave_edge_recvd_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_interface_statistics', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'grp-leave-edge-recvd'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_igmp_interface_statistics_grp_leave_edge_rx_errors_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_interface_statistics', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'grp-leave-edge-rx-errors'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_igmp_interface_statistics_grp_leave_edge_sent_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_interface_statistics', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'grp-leave-edge-sent'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_igmp_interface_statistics_interface_name_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_interface_statistics', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'interface-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_igmp_interface_statistics_pim_hello_edge_recvd_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_interface_statistics', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'pim-hello-edge-recvd'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_igmp_interface_statistics_pim_hello_edge_rx_errors_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_interface_statistics', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'pim-hello-edge-rx-errors'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_igmp_interface_statistics_pim_hello_edge_sent_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_interface_statistics', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'pim-hello-edge-sent'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_igmp_interface_statistics_query_edge_recvd_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_interface_statistics', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'query-edge-recvd'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_igmp_interface_statistics_query_edge_rx_errors_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_interface_statistics', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'query-edge-rx-errors'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_igmp_interface_statistics_query_edge_sent_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_interface_statistics', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'query-edge-sent'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_igmp_interface_statistics_v1_report_edge_recvd_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_interface_statistics', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'v1-report-edge-recvd'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_igmp_interface_statistics_v1_report_edge_rx_errors_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_interface_statistics', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'v1-report-edge-rx-errors'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_igmp_interface_statistics_v1_report_edge_sent_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_interface_statistics', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'v1-report-edge-sent'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_igmp_interface_statistics_v2_report_edge_recvd_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_interface_statistics', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'v2-report-edge-recvd'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_igmp_interface_statistics_v2_report_edge_rx_errors_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_interface_statistics', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'v2-report-edge-rx-errors'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_igmp_interface_statistics_v2_report_edge_sent_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_interface_statistics', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'v2-report-edge-sent'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_igmp_interface_statistics_v3_report_edge_recvd_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_interface_statistics', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'v3-report-edge-recvd'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_igmp_interface_statistics_v3_report_edge_rx_errors_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_interface_statistics', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'v3-report-edge-rx-errors'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_igmp_interface_statistics_v3_report_edge_sent_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_interface_statistics', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'v3-report-edge-sent'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_igmp_l3_interfaces_delete(self, igmp_l3_interfaces=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type igmp_l3_interfaces: interface_name
    :param igmp_l3_interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **igmp_l3_interfaces** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_l3_interfaces', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_l3_interfaces', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_l3_interfaces=igmp_l3_interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_l3_interfaces=igmp_l3_interfaces)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_igmp_l3_interfaces_igmp_l3_interfaces_delete(self, igmp_l3_interfaces=None, igmp_l3_interfaces_=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_l3_interfaces: interface_name
    :param igmp_l3_interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **igmp_l3_interfaces** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type igmp_l3_interfaces_: interface_name
    :param igmp_l3_interfaces_: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **igmp_l3_interfaces_** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_l3_interfaces', u'igmp_l3_interfaces')]
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_l3_interfaces.igmp_l3_interfaces', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'igmp_l3_interfaces_', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_l3_interfaces=igmp_l3_interfaces, igmp_l3_interfaces_=igmp_l3_interfaces_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_l3_interfaces=igmp_l3_interfaces, igmp_l3_interfaces_=igmp_l3_interfaces_)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_igmp_l3_interfaces_igmp_l3_interfaces_igmp_querier_delete(self, igmp_l3_interfaces=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_l3_interfaces: interface_name
    :param igmp_l3_interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **igmp_l3_interfaces** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_l3_interfaces', u'igmp_l3_interfaces')]
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_l3_interfaces.igmp_l3_interfaces_', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'igmp_querier', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'igmp-querier'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_l3_interfaces=igmp_l3_interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_l3_interfaces=igmp_l3_interfaces)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_igmp_l3_interfaces_igmp_l3_interfaces_immediate_leave_delete(self, igmp_l3_interfaces=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_l3_interfaces: interface_name
    :param igmp_l3_interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **igmp_l3_interfaces** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_l3_interfaces', u'igmp_l3_interfaces')]
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_l3_interfaces.igmp_l3_interfaces_', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'igmp_querier', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'immediate-leave'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_l3_interfaces=igmp_l3_interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_l3_interfaces=igmp_l3_interfaces)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_igmp_l3_interfaces_igmp_l3_interfaces_is_igmp_enabled_delete(self, igmp_l3_interfaces=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_l3_interfaces: interface_name
    :param igmp_l3_interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **igmp_l3_interfaces** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_l3_interfaces', u'igmp_l3_interfaces')]
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_l3_interfaces.igmp_l3_interfaces_', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'igmp_querier', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'is-igmp-enabled'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_l3_interfaces=igmp_l3_interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_l3_interfaces=igmp_l3_interfaces)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_igmp_l3_interfaces_igmp_l3_interfaces_is_igmp_querier_local_delete(self, igmp_l3_interfaces=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_l3_interfaces: interface_name
    :param igmp_l3_interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **igmp_l3_interfaces** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_l3_interfaces', u'igmp_l3_interfaces')]
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_l3_interfaces.igmp_l3_interfaces_', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'igmp_querier', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'is-igmp-querier-local'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_l3_interfaces=igmp_l3_interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_l3_interfaces=igmp_l3_interfaces)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_igmp_l3_interfaces_igmp_l3_interfaces_last_member_query_interval_delete(self, igmp_l3_interfaces=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_l3_interfaces: interface_name
    :param igmp_l3_interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **igmp_l3_interfaces** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_l3_interfaces', u'igmp_l3_interfaces')]
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_l3_interfaces.igmp_l3_interfaces_', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'igmp_querier', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'last-member-query-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_l3_interfaces=igmp_l3_interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_l3_interfaces=igmp_l3_interfaces)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_igmp_l3_interfaces_igmp_l3_interfaces_other_querier_interval_delete(self, igmp_l3_interfaces=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_l3_interfaces: interface_name
    :param igmp_l3_interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **igmp_l3_interfaces** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_l3_interfaces', u'igmp_l3_interfaces')]
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_l3_interfaces.igmp_l3_interfaces_', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'igmp_querier', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'other-querier-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_l3_interfaces=igmp_l3_interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_l3_interfaces=igmp_l3_interfaces)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_igmp_l3_interfaces_igmp_l3_interfaces_query_interval_delete(self, igmp_l3_interfaces=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_l3_interfaces: interface_name
    :param igmp_l3_interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **igmp_l3_interfaces** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_l3_interfaces', u'igmp_l3_interfaces')]
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_l3_interfaces.igmp_l3_interfaces_', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'igmp_querier', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'query-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_l3_interfaces=igmp_l3_interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_l3_interfaces=igmp_l3_interfaces)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_igmp_l3_interfaces_igmp_l3_interfaces_query_reponse_time_delete(self, igmp_l3_interfaces=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_l3_interfaces: interface_name
    :param igmp_l3_interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **igmp_l3_interfaces** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_l3_interfaces', u'igmp_l3_interfaces')]
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_l3_interfaces.igmp_l3_interfaces_', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'igmp_querier', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'query-reponse-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_l3_interfaces=igmp_l3_interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_l3_interfaces=igmp_l3_interfaces)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_igmp_multicast_snooping_vlans_delete(self, igmp_multicast_snooping_vlans=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type igmp_multicast_snooping_vlans: vlan_id
    :param igmp_multicast_snooping_vlans: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **igmp_multicast_snooping_vlans** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_multicast_snooping_vlans', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_multicast_snooping_vlans', 'keyval': 'vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_multicast_snooping_vlans=igmp_multicast_snooping_vlans)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_multicast_snooping_vlans=igmp_multicast_snooping_vlans)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_igmp_multicast_snooping_vlans_igmp_multicast_snooping_vlans_delete(self, igmp_multicast_snooping_vlans=None, igmp_multicast_snooping_vlans_=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_multicast_snooping_vlans: vlan_id
    :param igmp_multicast_snooping_vlans: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **igmp_multicast_snooping_vlans** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type igmp_multicast_snooping_vlans_: vlan_id
    :param igmp_multicast_snooping_vlans_: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **igmp_multicast_snooping_vlans_** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_multicast_snooping_vlans', u'igmp_multicast_snooping_vlans')]
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_multicast_snooping_vlans.igmp_multicast_snooping_vlans', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vlan_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'igmp_multicast_snooping_vlans_', 'keyval': 'vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_multicast_snooping_vlans=igmp_multicast_snooping_vlans, igmp_multicast_snooping_vlans_=igmp_multicast_snooping_vlans_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_multicast_snooping_vlans=igmp_multicast_snooping_vlans, igmp_multicast_snooping_vlans_=igmp_multicast_snooping_vlans_)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_igmp_multicast_snooping_vlans_igmp_multicast_snooping_vlans_igmp_sn_status_delete(self, igmp_multicast_snooping_vlans=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_multicast_snooping_vlans: vlan_id
    :param igmp_multicast_snooping_vlans: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **igmp_multicast_snooping_vlans** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_multicast_snooping_vlans', u'igmp_multicast_snooping_vlans')]
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_multicast_snooping_vlans.igmp_multicast_snooping_vlans_', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vlan_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'igmp_sn_status', 'keyval': 'vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'igmp-sn-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_multicast_snooping_vlans=igmp_multicast_snooping_vlans)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_multicast_snooping_vlans=igmp_multicast_snooping_vlans)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_igmp_multicast_snooping_vlans_igmp_multicast_snooping_vlans_igmp_version_delete(self, igmp_multicast_snooping_vlans=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_multicast_snooping_vlans: vlan_id
    :param igmp_multicast_snooping_vlans: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **igmp_multicast_snooping_vlans** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_multicast_snooping_vlans', u'igmp_multicast_snooping_vlans')]
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_multicast_snooping_vlans.igmp_multicast_snooping_vlans_', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vlan_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'igmp_sn_status', 'keyval': 'vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'igmp-version'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_multicast_snooping_vlans=igmp_multicast_snooping_vlans)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_multicast_snooping_vlans=igmp_multicast_snooping_vlans)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_igmp_multicast_snooping_vlans_igmp_multicast_snooping_vlans_pim_sn_status_delete(self, igmp_multicast_snooping_vlans=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_multicast_snooping_vlans: vlan_id
    :param igmp_multicast_snooping_vlans: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **igmp_multicast_snooping_vlans** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_multicast_snooping_vlans', u'igmp_multicast_snooping_vlans')]
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_multicast_snooping_vlans.igmp_multicast_snooping_vlans_', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vlan_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'igmp_sn_status', 'keyval': 'vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'pim-sn-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_multicast_snooping_vlans=igmp_multicast_snooping_vlans)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_multicast_snooping_vlans=igmp_multicast_snooping_vlans)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_igmp_snooping_mrouters_delete(self, igmp_snooping_mrouters=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type igmp_snooping_mrouters: vlan_id
    :param igmp_snooping_mrouters: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **igmp_snooping_mrouters** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_snooping_mrouters', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_snooping_mrouters', 'keyval': 'vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_snooping_mrouters=igmp_snooping_mrouters)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_snooping_mrouters=igmp_snooping_mrouters)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_igmp_snooping_mrouters_igmp_snooping_mrouters_delete(self, igmp_snooping_mrouters=None, igmp_snooping_mrouters_=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_snooping_mrouters: vlan_id
    :param igmp_snooping_mrouters: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **igmp_snooping_mrouters** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type igmp_snooping_mrouters_: vlan_id
    :param igmp_snooping_mrouters_: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **igmp_snooping_mrouters_** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_snooping_mrouters', u'igmp_snooping_mrouters')]
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_snooping_mrouters.igmp_snooping_mrouters', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vlan_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'igmp_snooping_mrouters_', 'keyval': 'vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_snooping_mrouters=igmp_snooping_mrouters, igmp_snooping_mrouters_=igmp_snooping_mrouters_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_snooping_mrouters=igmp_snooping_mrouters, igmp_snooping_mrouters_=igmp_snooping_mrouters_)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_igmp_snooping_mrouters_igmp_snooping_mrouters_expiry_time_delete(self, igmp_snooping_mrouters=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_snooping_mrouters: vlan_id
    :param igmp_snooping_mrouters: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **igmp_snooping_mrouters** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_snooping_mrouters', u'igmp_snooping_mrouters')]
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_snooping_mrouters.igmp_snooping_mrouters_', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vlan_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'expiry_time', 'keyval': 'vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'expiry-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_snooping_mrouters=igmp_snooping_mrouters)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_snooping_mrouters=igmp_snooping_mrouters)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_igmp_snooping_mrouters_igmp_snooping_mrouters_interface_name_delete(self, igmp_snooping_mrouters=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_snooping_mrouters: vlan_id
    :param igmp_snooping_mrouters: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **igmp_snooping_mrouters** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_snooping_mrouters', u'igmp_snooping_mrouters')]
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_snooping_mrouters.igmp_snooping_mrouters_', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vlan_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'expiry_time', 'keyval': 'vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'interface-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_snooping_mrouters=igmp_snooping_mrouters)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_snooping_mrouters=igmp_snooping_mrouters)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_igmp_snooping_vlans_delete(self, igmp_snooping_vlans=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type igmp_snooping_vlans: vlan_id
    :param igmp_snooping_vlans: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **igmp_snooping_vlans** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_snooping_vlans', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_snooping_vlans', 'keyval': 'vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_snooping_vlans=igmp_snooping_vlans)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_snooping_vlans=igmp_snooping_vlans)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_igmp_snooping_vlans_igmp_snooping_vlans_delete(self, igmp_snooping_vlans=None, igmp_snooping_vlans_=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_snooping_vlans: vlan_id
    :param igmp_snooping_vlans: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **igmp_snooping_vlans** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type igmp_snooping_vlans_: vlan_id
    :param igmp_snooping_vlans_: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **igmp_snooping_vlans_** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_snooping_vlans', u'igmp_snooping_vlans')]
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_snooping_vlans.igmp_snooping_vlans', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vlan_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'igmp_snooping_vlans_', 'keyval': 'vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_snooping_vlans=igmp_snooping_vlans, igmp_snooping_vlans_=igmp_snooping_vlans_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_snooping_vlans=igmp_snooping_vlans, igmp_snooping_vlans_=igmp_snooping_vlans_)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_igmp_snooping_vlans_igmp_snooping_vlans_fast_leave_delete(self, igmp_snooping_vlans=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_snooping_vlans: vlan_id
    :param igmp_snooping_vlans: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **igmp_snooping_vlans** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_snooping_vlans', u'igmp_snooping_vlans')]
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_snooping_vlans.igmp_snooping_vlans_', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vlan_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'fast_leave', 'keyval': 'vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'fast-leave'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_snooping_vlans=igmp_snooping_vlans)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_snooping_vlans=igmp_snooping_vlans)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_igmp_snooping_vlans_igmp_snooping_vlans_igmp_operation_mode_delete(self, igmp_snooping_vlans=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_snooping_vlans: vlan_id
    :param igmp_snooping_vlans: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **igmp_snooping_vlans** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_snooping_vlans', u'igmp_snooping_vlans')]
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_snooping_vlans.igmp_snooping_vlans_', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vlan_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'fast_leave', 'keyval': 'vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'igmp-operation-mode'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_snooping_vlans=igmp_snooping_vlans)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_snooping_vlans=igmp_snooping_vlans)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_igmp_snooping_vlans_igmp_snooping_vlans_is_querier_delete(self, igmp_snooping_vlans=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_snooping_vlans: vlan_id
    :param igmp_snooping_vlans: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **igmp_snooping_vlans** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_snooping_vlans', u'igmp_snooping_vlans')]
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_snooping_vlans.igmp_snooping_vlans_', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vlan_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'fast_leave', 'keyval': 'vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'is-querier'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_snooping_vlans=igmp_snooping_vlans)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_snooping_vlans=igmp_snooping_vlans)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_igmp_snooping_vlans_igmp_snooping_vlans_lmqi_delete(self, igmp_snooping_vlans=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_snooping_vlans: vlan_id
    :param igmp_snooping_vlans: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **igmp_snooping_vlans** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_snooping_vlans', u'igmp_snooping_vlans')]
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_snooping_vlans.igmp_snooping_vlans_', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vlan_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'fast_leave', 'keyval': 'vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lmqi'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_snooping_vlans=igmp_snooping_vlans)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_snooping_vlans=igmp_snooping_vlans)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_igmp_snooping_vlans_igmp_snooping_vlans_multicast_router_ports_delete(self, igmp_snooping_vlans=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_snooping_vlans: vlan_id
    :param igmp_snooping_vlans: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **igmp_snooping_vlans** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_snooping_vlans', u'igmp_snooping_vlans')]
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_snooping_vlans.igmp_snooping_vlans_', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vlan_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'fast_leave', 'keyval': 'vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'multicast-router-ports'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_snooping_vlans=igmp_snooping_vlans)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_snooping_vlans=igmp_snooping_vlans)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_igmp_snooping_vlans_igmp_snooping_vlans_num_of_mcast_grps_delete(self, igmp_snooping_vlans=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_snooping_vlans: vlan_id
    :param igmp_snooping_vlans: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **igmp_snooping_vlans** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_snooping_vlans', u'igmp_snooping_vlans')]
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_snooping_vlans.igmp_snooping_vlans_', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vlan_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'fast_leave', 'keyval': 'vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'num-of-mcast-grps'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_snooping_vlans=igmp_snooping_vlans)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_snooping_vlans=igmp_snooping_vlans)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_igmp_snooping_vlans_igmp_snooping_vlans_qi_delete(self, igmp_snooping_vlans=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_snooping_vlans: vlan_id
    :param igmp_snooping_vlans: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **igmp_snooping_vlans** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_snooping_vlans', u'igmp_snooping_vlans')]
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_snooping_vlans.igmp_snooping_vlans_', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vlan_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'fast_leave', 'keyval': 'vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'qi'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_snooping_vlans=igmp_snooping_vlans)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_snooping_vlans=igmp_snooping_vlans)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_igmp_snooping_vlans_igmp_snooping_vlans_qmrt_delete(self, igmp_snooping_vlans=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_snooping_vlans: vlan_id
    :param igmp_snooping_vlans: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **igmp_snooping_vlans** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_snooping_vlans', u'igmp_snooping_vlans')]
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_snooping_vlans.igmp_snooping_vlans_', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vlan_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'fast_leave', 'keyval': 'vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'qmrt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_snooping_vlans=igmp_snooping_vlans)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_snooping_vlans=igmp_snooping_vlans)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_igmp_snooping_vlans_igmp_snooping_vlans_version_delete(self, igmp_snooping_vlans=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_snooping_vlans: vlan_id
    :param igmp_snooping_vlans: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **igmp_snooping_vlans** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_snooping_vlans', u'igmp_snooping_vlans')]
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_snooping_vlans.igmp_snooping_vlans_', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vlan_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'fast_leave', 'keyval': 'vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'version'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_snooping_vlans=igmp_snooping_vlans)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_snooping_vlans=igmp_snooping_vlans)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_igmp_snooping_vlans_igmp_snooping_vlans_vlan_groups_delete(self, igmp_snooping_vlans=None, vlan_groups=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_snooping_vlans: vlan_id
    :param igmp_snooping_vlans: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **igmp_snooping_vlans** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vlan_groups: grp_ip_addr
    :param vlan_groups: Keyword argument tuple.

    :type grp_ip_addr: long
    :param grp_ip_addr: **vlan_groups** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_snooping_vlans', u'igmp_snooping_vlans')]
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_snooping_vlans.igmp_snooping_vlans_.vlan_groups', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vlan_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan_groups', 'keyval': 'grp_ip_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_snooping_vlans=igmp_snooping_vlans, vlan_groups=vlan_groups)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_snooping_vlans=igmp_snooping_vlans, vlan_groups=vlan_groups)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_igmp_snooping_vlans_igmp_snooping_vlans_vlan_groups_member_ports_delete(self, igmp_snooping_vlans=None, vlan_groups=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_snooping_vlans: vlan_id
    :param igmp_snooping_vlans: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **igmp_snooping_vlans** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vlan_groups: grp_ip_addr
    :param vlan_groups: Keyword argument tuple.

    :type grp_ip_addr: long
    :param grp_ip_addr: **vlan_groups** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_snooping_vlans', u'igmp_snooping_vlans')]
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_snooping_vlans.igmp_snooping_vlans_.vlan_groups', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vlan_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan_groups', 'keyval': 'grp_ip_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'member-ports'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_snooping_vlans=igmp_snooping_vlans, vlan_groups=vlan_groups)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_snooping_vlans=igmp_snooping_vlans, vlan_groups=vlan_groups)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_igmp_statistics_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_statistics', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_igmp_statistics_igmp_statistics_delete(self, igmp_statistics=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type igmp_statistics: interface_name
    :param igmp_statistics: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **igmp_statistics** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_statistics.igmp_statistics', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_statistics', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_statistics=igmp_statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_statistics=igmp_statistics)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_igmp_statistics_igmp_statistics_error_bad_checksum_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_statistics.igmp_statistics_', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'error_bad_checksum', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'error-bad-checksum'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_igmp_statistics_igmp_statistics_error_bad_length_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_statistics.igmp_statistics_', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'error_bad_checksum', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'error-bad-length'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_igmp_statistics_igmp_statistics_error_unknown_types_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_statistics.igmp_statistics_', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'error_bad_checksum', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'error-unknown-types'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_igmp_statistics_igmp_statistics_grp_leave_edge_recvd_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_statistics.igmp_statistics_', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'error_bad_checksum', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'grp-leave-edge-recvd'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_igmp_statistics_igmp_statistics_grp_leave_edge_rx_errors_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_statistics.igmp_statistics_', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'error_bad_checksum', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'grp-leave-edge-rx-errors'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_igmp_statistics_igmp_statistics_grp_leave_edge_sent_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_statistics.igmp_statistics_', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'error_bad_checksum', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'grp-leave-edge-sent'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_igmp_statistics_igmp_statistics_pim_hello_edge_recvd_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_statistics.igmp_statistics_', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'error_bad_checksum', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'pim-hello-edge-recvd'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_igmp_statistics_igmp_statistics_pim_hello_edge_rx_errors_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_statistics.igmp_statistics_', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'error_bad_checksum', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'pim-hello-edge-rx-errors'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_igmp_statistics_igmp_statistics_pim_hello_edge_sent_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_statistics.igmp_statistics_', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'error_bad_checksum', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'pim-hello-edge-sent'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_igmp_statistics_igmp_statistics_query_edge_recvd_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_statistics.igmp_statistics_', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'error_bad_checksum', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'query-edge-recvd'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_igmp_statistics_igmp_statistics_query_edge_rx_errors_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_statistics.igmp_statistics_', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'error_bad_checksum', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'query-edge-rx-errors'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_igmp_statistics_igmp_statistics_query_edge_sent_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_statistics.igmp_statistics_', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'error_bad_checksum', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'query-edge-sent'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_igmp_statistics_igmp_statistics_v1_report_edge_recvd_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_statistics.igmp_statistics_', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'error_bad_checksum', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'v1-report-edge-recvd'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_igmp_statistics_igmp_statistics_v1_report_edge_rx_errors_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_statistics.igmp_statistics_', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'error_bad_checksum', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'v1-report-edge-rx-errors'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_igmp_statistics_igmp_statistics_v1_report_edge_sent_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_statistics.igmp_statistics_', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'error_bad_checksum', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'v1-report-edge-sent'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_igmp_statistics_igmp_statistics_v2_report_edge_recvd_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_statistics.igmp_statistics_', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'error_bad_checksum', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'v2-report-edge-recvd'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_igmp_statistics_igmp_statistics_v2_report_edge_rx_errors_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_statistics.igmp_statistics_', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'error_bad_checksum', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'v2-report-edge-rx-errors'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_igmp_statistics_igmp_statistics_v2_report_edge_sent_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_statistics.igmp_statistics_', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'error_bad_checksum', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'v2-report-edge-sent'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_igmp_statistics_igmp_statistics_v3_report_edge_recvd_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_statistics.igmp_statistics_', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'error_bad_checksum', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'v3-report-edge-recvd'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_igmp_statistics_igmp_statistics_v3_report_edge_rx_errors_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_statistics.igmp_statistics_', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'error_bad_checksum', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'v3-report-edge-rx-errors'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_igmp_statistics_igmp_statistics_v3_report_edge_sent_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.igmp_statistics.igmp_statistics_', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'error_bad_checksum', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'v3-report-edge-sent'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_multicast_ssm_mapping_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.multicast_ssm_mapping', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_multicast_ssm_mapping_ssm_maps_delete(self, ssm_maps=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ssm_maps: prefix_list_name
    :param ssm_maps: Keyword argument tuple.

    :type prefix_list_name: unicode
    :param prefix_list_name: **ssm_maps** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.multicast_ssm_mapping.ssm_maps', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ssm_maps', 'keyval': 'prefix_list_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ssm_maps=ssm_maps)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ssm_maps=ssm_maps)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_multicast_ssm_mapping_ssm_maps_src_ip_addr_delete(self, ssm_maps=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ssm_maps: prefix_list_name
    :param ssm_maps: Keyword argument tuple.

    :type prefix_list_name: unicode
    :param prefix_list_name: **ssm_maps** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.multicast_ssm_mapping.ssm_maps', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ssm_maps', 'keyval': 'prefix_list_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'src-ip-addr'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ssm_maps=ssm_maps)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ssm_maps=ssm_maps)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_pim_snp_groups_delete(self, pim_snp_groups=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type pim_snp_groups: vlan_id
    :param pim_snp_groups: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **pim_snp_groups** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.pim_snp_groups', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'pim_snp_groups', 'keyval': 'vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim_snp_groups=pim_snp_groups)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim_snp_groups=pim_snp_groups)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_pim_snp_groups_pim_snp_groups_delete(self, pim_snp_groups=None, pim_snp_groups_=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type pim_snp_groups: vlan_id
    :param pim_snp_groups: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **pim_snp_groups** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type pim_snp_groups_: group_addr, vlan_id
    :param pim_snp_groups_: Keyword argument tuple.

    :type group_addr: long
    :param group_addr: **pim_snp_groups_** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vlan_id: long
    :param vlan_id: **pim_snp_groups_** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.pim_snp_groups', u'pim_snp_groups')]
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.pim_snp_groups.pim_snp_groups', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vlan_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'pim_snp_groups_', 'keyval': 'group_addr, vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim_snp_groups=pim_snp_groups, pim_snp_groups_=pim_snp_groups_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim_snp_groups=pim_snp_groups, pim_snp_groups_=pim_snp_groups_)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_pim_snp_groups_pim_snp_groups_expiry_time_delete(self, pim_snp_groups=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type pim_snp_groups: vlan_id
    :param pim_snp_groups: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **pim_snp_groups** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.pim_snp_groups', u'pim_snp_groups')]
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.pim_snp_groups.pim_snp_groups_', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vlan_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'expiry_time', 'keyval': 'group_addr, vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'expiry-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim_snp_groups=pim_snp_groups)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim_snp_groups=pim_snp_groups)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_pim_snp_groups_pim_snp_groups_last_reporter_delete(self, pim_snp_groups=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type pim_snp_groups: vlan_id
    :param pim_snp_groups: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **pim_snp_groups** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.pim_snp_groups', u'pim_snp_groups')]
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.pim_snp_groups.pim_snp_groups_', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vlan_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'expiry_time', 'keyval': 'group_addr, vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'last-reporter'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim_snp_groups=pim_snp_groups)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim_snp_groups=pim_snp_groups)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_pim_snp_groups_pim_snp_groups_pim_snp_sources_delete(self, pim_snp_groups=None, pim_snp_sources=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type pim_snp_groups: vlan_id
    :param pim_snp_groups: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **pim_snp_groups** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type pim_snp_sources: src_addr
    :param pim_snp_sources: Keyword argument tuple.

    :type src_addr: long
    :param src_addr: **pim_snp_sources** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.pim_snp_groups', u'pim_snp_groups')]
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.pim_snp_groups.pim_snp_groups_.pim_snp_sources', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vlan_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'pim_snp_sources', 'keyval': 'src_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim_snp_groups=pim_snp_groups, pim_snp_sources=pim_snp_sources)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim_snp_groups=pim_snp_groups, pim_snp_sources=pim_snp_sources)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_pim_snp_groups_pim_snp_groups_pim_snp_sources_pim_snp_sg_member_ports_delete(self, pim_snp_groups=None, pim_snp_sources=None, pim_snp_sg_member_ports=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type pim_snp_groups: vlan_id
    :param pim_snp_groups: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **pim_snp_groups** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type pim_snp_sources: src_addr
    :param pim_snp_sources: Keyword argument tuple.

    :type src_addr: long
    :param src_addr: **pim_snp_sources** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type pim_snp_sg_member_ports: interface_name
    :param pim_snp_sg_member_ports: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **pim_snp_sg_member_ports** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.pim_snp_groups', u'pim_snp_groups'), ('pybind.slxos.v16r_1_00b.igmp_snooping_state.pim_snp_groups.pim_snp_groups_.pim_snp_sources', u'pim_snp_sources')]
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.pim_snp_groups.pim_snp_groups_.pim_snp_sources.pim_snp_sg_member_ports', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vlan_id', 'extra_keyval': ''}, {'keyval': 'src_addr', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'pim_snp_sg_member_ports', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim_snp_groups=pim_snp_groups, pim_snp_sources=pim_snp_sources, pim_snp_sg_member_ports=pim_snp_sg_member_ports)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim_snp_groups=pim_snp_groups, pim_snp_sources=pim_snp_sources, pim_snp_sg_member_ports=pim_snp_sg_member_ports)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_pim_snp_groups_pim_snp_groups_pim_snp_sources_pim_snp_sg_member_ports_flag_string_delete(self, pim_snp_groups=None, pim_snp_sources=None, pim_snp_sg_member_ports=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type pim_snp_groups: vlan_id
    :param pim_snp_groups: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **pim_snp_groups** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type pim_snp_sources: src_addr
    :param pim_snp_sources: Keyword argument tuple.

    :type src_addr: long
    :param src_addr: **pim_snp_sources** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type pim_snp_sg_member_ports: interface_name
    :param pim_snp_sg_member_ports: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **pim_snp_sg_member_ports** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.pim_snp_groups', u'pim_snp_groups'), ('pybind.slxos.v16r_1_00b.igmp_snooping_state.pim_snp_groups.pim_snp_groups_.pim_snp_sources', u'pim_snp_sources')]
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.pim_snp_groups.pim_snp_groups_.pim_snp_sources.pim_snp_sg_member_ports', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vlan_id', 'extra_keyval': ''}, {'keyval': 'src_addr', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'pim_snp_sg_member_ports', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'flag-string'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim_snp_groups=pim_snp_groups, pim_snp_sources=pim_snp_sources, pim_snp_sg_member_ports=pim_snp_sg_member_ports)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim_snp_groups=pim_snp_groups, pim_snp_sources=pim_snp_sources, pim_snp_sg_member_ports=pim_snp_sg_member_ports)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_pim_snp_groups_pim_snp_groups_pim_snp_sources_pim_snp_sg_member_ports_mbr_flags_delete(self, pim_snp_groups=None, pim_snp_sources=None, pim_snp_sg_member_ports=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type pim_snp_groups: vlan_id
    :param pim_snp_groups: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **pim_snp_groups** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type pim_snp_sources: src_addr
    :param pim_snp_sources: Keyword argument tuple.

    :type src_addr: long
    :param src_addr: **pim_snp_sources** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type pim_snp_sg_member_ports: interface_name
    :param pim_snp_sg_member_ports: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **pim_snp_sg_member_ports** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.pim_snp_groups', u'pim_snp_groups'), ('pybind.slxos.v16r_1_00b.igmp_snooping_state.pim_snp_groups.pim_snp_groups_.pim_snp_sources', u'pim_snp_sources')]
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.pim_snp_groups.pim_snp_groups_.pim_snp_sources.pim_snp_sg_member_ports', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vlan_id', 'extra_keyval': ''}, {'keyval': 'src_addr', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'pim_snp_sg_member_ports', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mbr-flags'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim_snp_groups=pim_snp_groups, pim_snp_sources=pim_snp_sources, pim_snp_sg_member_ports=pim_snp_sg_member_ports)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim_snp_groups=pim_snp_groups, pim_snp_sources=pim_snp_sources, pim_snp_sg_member_ports=pim_snp_sg_member_ports)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_pim_snp_groups_pim_snp_groups_pim_snp_sources_pim_snp_sg_member_ports_mbr_uptime_delete(self, pim_snp_groups=None, pim_snp_sources=None, pim_snp_sg_member_ports=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type pim_snp_groups: vlan_id
    :param pim_snp_groups: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **pim_snp_groups** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type pim_snp_sources: src_addr
    :param pim_snp_sources: Keyword argument tuple.

    :type src_addr: long
    :param src_addr: **pim_snp_sources** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type pim_snp_sg_member_ports: interface_name
    :param pim_snp_sg_member_ports: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **pim_snp_sg_member_ports** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.pim_snp_groups', u'pim_snp_groups'), ('pybind.slxos.v16r_1_00b.igmp_snooping_state.pim_snp_groups.pim_snp_groups_.pim_snp_sources', u'pim_snp_sources')]
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.pim_snp_groups.pim_snp_groups_.pim_snp_sources.pim_snp_sg_member_ports', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vlan_id', 'extra_keyval': ''}, {'keyval': 'src_addr', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'pim_snp_sg_member_ports', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mbr-uptime'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim_snp_groups=pim_snp_groups, pim_snp_sources=pim_snp_sources, pim_snp_sg_member_ports=pim_snp_sg_member_ports)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim_snp_groups=pim_snp_groups, pim_snp_sources=pim_snp_sources, pim_snp_sg_member_ports=pim_snp_sg_member_ports)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_pim_snp_groups_pim_snp_groups_pim_snp_sources_src_flags_delete(self, pim_snp_groups=None, pim_snp_sources=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type pim_snp_groups: vlan_id
    :param pim_snp_groups: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **pim_snp_groups** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type pim_snp_sources: src_addr
    :param pim_snp_sources: Keyword argument tuple.

    :type src_addr: long
    :param src_addr: **pim_snp_sources** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.pim_snp_groups', u'pim_snp_groups')]
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.pim_snp_groups.pim_snp_groups_.pim_snp_sources', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vlan_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'pim_snp_sources', 'keyval': 'src_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'src-flags'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim_snp_groups=pim_snp_groups, pim_snp_sources=pim_snp_sources)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim_snp_groups=pim_snp_groups, pim_snp_sources=pim_snp_sources)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_pim_snp_groups_pim_snp_groups_pim_snp_sources_src_uptime_delete(self, pim_snp_groups=None, pim_snp_sources=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type pim_snp_groups: vlan_id
    :param pim_snp_groups: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **pim_snp_groups** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type pim_snp_sources: src_addr
    :param pim_snp_sources: Keyword argument tuple.

    :type src_addr: long
    :param src_addr: **pim_snp_sources** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.pim_snp_groups', u'pim_snp_groups')]
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.pim_snp_groups.pim_snp_groups_.pim_snp_sources', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vlan_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'pim_snp_sources', 'keyval': 'src_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'src-uptime'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim_snp_groups=pim_snp_groups, pim_snp_sources=pim_snp_sources)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim_snp_groups=pim_snp_groups, pim_snp_sources=pim_snp_sources)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_pim_snp_groups_pim_snp_groups_pim_snp_wg_member_ports_delete(self, pim_snp_groups=None, pim_snp_wg_member_ports=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type pim_snp_groups: vlan_id
    :param pim_snp_groups: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **pim_snp_groups** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type pim_snp_wg_member_ports: interface_name
    :param pim_snp_wg_member_ports: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **pim_snp_wg_member_ports** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.pim_snp_groups', u'pim_snp_groups')]
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.pim_snp_groups.pim_snp_groups_.pim_snp_wg_member_ports', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vlan_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'pim_snp_wg_member_ports', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim_snp_groups=pim_snp_groups, pim_snp_wg_member_ports=pim_snp_wg_member_ports)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim_snp_groups=pim_snp_groups, pim_snp_wg_member_ports=pim_snp_wg_member_ports)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_pim_snp_groups_pim_snp_groups_pim_snp_wg_member_ports_flag_string_delete(self, pim_snp_groups=None, pim_snp_wg_member_ports=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type pim_snp_groups: vlan_id
    :param pim_snp_groups: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **pim_snp_groups** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type pim_snp_wg_member_ports: interface_name
    :param pim_snp_wg_member_ports: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **pim_snp_wg_member_ports** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.pim_snp_groups', u'pim_snp_groups')]
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.pim_snp_groups.pim_snp_groups_.pim_snp_wg_member_ports', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vlan_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'pim_snp_wg_member_ports', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'flag-string'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim_snp_groups=pim_snp_groups, pim_snp_wg_member_ports=pim_snp_wg_member_ports)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim_snp_groups=pim_snp_groups, pim_snp_wg_member_ports=pim_snp_wg_member_ports)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_pim_snp_groups_pim_snp_groups_pim_snp_wg_member_ports_mbr_flags_delete(self, pim_snp_groups=None, pim_snp_wg_member_ports=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type pim_snp_groups: vlan_id
    :param pim_snp_groups: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **pim_snp_groups** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type pim_snp_wg_member_ports: interface_name
    :param pim_snp_wg_member_ports: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **pim_snp_wg_member_ports** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.pim_snp_groups', u'pim_snp_groups')]
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.pim_snp_groups.pim_snp_groups_.pim_snp_wg_member_ports', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vlan_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'pim_snp_wg_member_ports', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mbr-flags'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim_snp_groups=pim_snp_groups, pim_snp_wg_member_ports=pim_snp_wg_member_ports)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim_snp_groups=pim_snp_groups, pim_snp_wg_member_ports=pim_snp_wg_member_ports)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_pim_snp_groups_pim_snp_groups_pim_snp_wg_member_ports_mbr_uptime_delete(self, pim_snp_groups=None, pim_snp_wg_member_ports=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type pim_snp_groups: vlan_id
    :param pim_snp_groups: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **pim_snp_groups** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type pim_snp_wg_member_ports: interface_name
    :param pim_snp_wg_member_ports: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **pim_snp_wg_member_ports** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.pim_snp_groups', u'pim_snp_groups')]
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.pim_snp_groups.pim_snp_groups_.pim_snp_wg_member_ports', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vlan_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'pim_snp_wg_member_ports', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mbr-uptime'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim_snp_groups=pim_snp_groups, pim_snp_wg_member_ports=pim_snp_wg_member_ports)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim_snp_groups=pim_snp_groups, pim_snp_wg_member_ports=pim_snp_wg_member_ports)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def igmp_snooping_state_pim_snp_groups_pim_snp_groups_uptime_delete(self, pim_snp_groups=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type pim_snp_groups: vlan_id
    :param pim_snp_groups: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **pim_snp_groups** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.pim_snp_groups', u'pim_snp_groups')]
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping_state.pim_snp_groups.pim_snp_groups_', 'pybind.slxos.v16r_1_00b.brocade_mc_hms_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vlan_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'expiry_time', 'keyval': 'group_addr, vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'uptime'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim_snp_groups=pim_snp_groups)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim_snp_groups=pim_snp_groups)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_bfd_interval_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.bfd.interval', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_bfd_interval_min_rx_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.bfd.interval', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'min-rx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_bfd_interval_min_tx_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.bfd.interval', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'min-tx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_bfd_interval_multiplier_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.bfd.interval', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'multiplier'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_bfd_shutdown_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.bfd', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'shutdown'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_channel_group_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.channel_group', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'port_int, mode, type'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_channel_group_mode_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.channel_group', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mode'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_channel_group_port_int_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.channel_group', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'port-int'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_channel_group_type_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.channel_group', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_delay_link_event_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.delay_link_event', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_delay_link_event_delay_link_event_entry_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.delay_link_event.delay_link', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'delay-link-event-entry'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_delay_link_event_delay_link_event_type_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.delay_link_event.delay_link', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'delay-link-event-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_description_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ethernet', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'description'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_deviceconnectivity_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.connectivity', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'deviceconnectivity'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_dot1x_authentication_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.dot1x', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'authentication'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_dot1x_filter_strict_security_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.dot1x', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'filter-strict-security'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_dot1x_max_req_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.dot1x', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'max-req'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_dot1x_port_control_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.dot1x', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'port-control'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_dot1x_protocol_version_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.dot1x', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'protocol-version'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_dot1x_quiet_period_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.dot1x', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'quiet-period'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_dot1x_reauthentication_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.dot1x', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'reauthentication'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_dot1x_reauthmax_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.dot1x', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'reauthMax'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_dot1x_timeout_re_authperiod_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.dot1x.timeout', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 're-authperiod'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_dot1x_timeout_server_timeout_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.dot1x.timeout', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'server-timeout'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_dot1x_timeout_supp_timeout_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.dot1x.timeout', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'supp-timeout'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_dot1x_timeout_tx_period_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.dot1x.timeout', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tx-period'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_edge_loop_detection_port_priority_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.edge_loop_detection', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'port-priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_edge_loop_detection_vlan_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.edge_loop_detection', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vlan'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_fabric_dport_enable_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.fabric.fabric_dport', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_fabric_isl_enable_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.fabric.fabric_isl', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_fabric_neighbor_discovery_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.fabric.neighbor_discovery', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_fabric_neighbor_discovery_disable_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.fabric.neighbor_discovery', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'disable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_fabric_trunk_enable_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.fabric.fabric_trunk', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_fcoeport_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.fcoeport', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_fcoeport_map_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.fcoeport', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ifindex_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ethernet', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ifindex'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_interface_eth_isis_conf_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.interface_eth_isis_conf', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_intf_isis_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.interface_eth_isis_conf.intf_isis', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ip_access_group_delete(self, ethernet=None, access_group=None, traffic_type=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type access_group: ip_access_list, ip_direction, traffic_type
    :param access_group: Keyword argument tuple.

    :type ip_access_list: unicode
    :param ip_access_list: **access_group** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type ip_direction: unicode
    :param ip_direction: **access_group** tuple argument.

        * enumeration restriction: ::

            ['in', 'out']

    :type traffic_type: unicode
    :param traffic_type: **access_group** tuple argument.

        * enumeration restriction: ::

            ['switched', 'routed']

    **Instance Argument(s)**:

    :type traffic_type: unicode
    :param traffic_type: Keyword argument.

        * enumeration restriction: ::

            ['switched', 'routed']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ip_acl_interface.ip.access_group', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'access_group', 'keyval': 'ip_access_list, ip_direction', 'extra_keyval': 'ip_access_list, ip_direction, traffic_type'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, access_group=access_group, traffic_type=traffic_type)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, access_group=access_group, traffic_type=traffic_type)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ip_acl_interface_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ip_acl_interface', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ip_address_delete(self, ethernet=None, address=None, secondary=None, ospf_passive=None, ospf_ignore=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type address: address, secondary, ospf_passive, ospf_ignore
    :param address: Keyword argument tuple.

    :type address: unicode
    :param address: **address** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]'
            '|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0'
            '-4][0-9]|25[0-5])/(([1-9])|([1-2][0-9])|(3[0-1])'
            ')'

    :type secondary: YANGBool
    :param secondary: **address** tuple argument:  Secondary ip address on the specific interface

    :type ospf_passive: YANGBool
    :param ospf_passive: **address** tuple argument:  ospf pasive address on the specific interface

    :type ospf_ignore: YANGBool
    :param ospf_ignore: **address** tuple argument:  ospf active address on the specific interface

    **Instance Argument(s)**:

    :type secondary: YANGBool
    :param secondary: Secondary ip address on the specific interface

    :type ospf_passive: YANGBool
    :param ospf_passive: ospf pasive address on the specific interface

    :type ospf_ignore: YANGBool
    :param ospf_ignore: ospf active address on the specific interface

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ip.ip_config.address', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'address', 'keyval': 'address', 'extra_keyval': 'address, secondary, ospf_passive, ospf_ignore'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, address=address, secondary=secondary, ospf_passive=ospf_passive, ospf_ignore=ospf_ignore)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, address=address, secondary=secondary, ospf_passive=ospf_passive, ospf_ignore=ospf_ignore)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ip_address_ospf_ignore_delete(self, ethernet=None, address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type address: address
    :param address: Keyword argument tuple.

    :type address: unicode
    :param address: **address** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]'
            '|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0'
            '-4][0-9]|25[0-5])/(([1-9])|([1-2][0-9])|(3[0-1])'
            ')'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ip.ip_config.address', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'address', 'keyval': 'address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ospf-ignore'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, address=address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, address=address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ip_address_ospf_passive_delete(self, ethernet=None, address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type address: address
    :param address: Keyword argument tuple.

    :type address: unicode
    :param address: **address** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]'
            '|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0'
            '-4][0-9]|25[0-5])/(([1-9])|([1-2][0-9])|(3[0-1])'
            ')'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ip.ip_config.address', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'address', 'keyval': 'address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ospf-passive'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, address=address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, address=address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ip_address_secondary_delete(self, ethernet=None, address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type address: address
    :param address: Keyword argument tuple.

    :type address: unicode
    :param address: **address** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]'
            '|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0'
            '-4][0-9]|25[0-5])/(([1-9])|([1-2][0-9])|(3[0-1])'
            ')'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ip.ip_config.address', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'address', 'keyval': 'address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'secondary'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, address=address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, address=address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ip_arp_aging_timeout_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ip.ip_config', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'arp-aging-timeout'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ip_arp_inspection_trust_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ip.arp_node_config.arp.inspection', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'trust'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ip_arp_node_config_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ip.arp_node_config', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ip_dhcp_relay_gateway_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ip.interface_eth_dhcp_conf.dhcp.relay', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'gateway'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ip_dhcp_relay_servers_delete(self, ethernet=None, servers=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type servers: relay_ip_addr, server_vrf_name
    :param servers: Keyword argument tuple.

    :type relay_ip_addr: unicode
    :param relay_ip_addr: **servers** tuple argument:  A.B.C.D;; IP address of the DHCP server

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type server_vrf_name: unicode
    :param server_vrf_name: **servers** tuple argument:  VRF name of the DHCP server

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ip.interface_eth_dhcp_conf.dhcp.relay.servers', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'servers', 'keyval': 'relay_ip_addr, server_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, servers=servers)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, servers=servers)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ip_directed_broadcast_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ip.ip_config', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'directed-broadcast'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ip_icmp_rate_limiting_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ip.icmp', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rate-limiting'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ip_icmp_redirect_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ip.icmp', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redirect'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ip_igmp_immediate_leave_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'immediate-leave'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ip_igmp_last_member_query_interval_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'last-member-query-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ip_igmp_phy_intf_cfg_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ip.igmp_phy_intf_cfg', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ip_igmp_query_interval_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'query-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ip_igmp_query_max_response_time_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'query-max-response-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ip_igmp_static_group_delete(self, ethernet=None, igmpl3_static_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type igmpl3_static_group: igmpl3_sg_addr
    :param igmpl3_static_group: Keyword argument tuple.

    :type igmpl3_sg_addr: unicode
    :param igmpl3_sg_addr: **igmpl3_static_group** tuple argument:  Multicast Address to be Joined in the format A.B.C.D

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ip.igmp_phy_intf_cfg.igmp.igmpl3_static_group', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'igmpl3_static_group', 'keyval': 'igmpl3_sg_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, igmpl3_static_group=igmpl3_static_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, igmpl3_static_group=igmpl3_static_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ip_igmp_version_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'version'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ip_interface_eth_dhcp_conf_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ip.interface_eth_dhcp_conf', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ip_interface_eth_ospf_conf_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ip.interface_eth_ospf_conf', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ip_intf_router_isis_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ip.intf_router_isis', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ip_ip_config_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ip.ip_config', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ip_mtu_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ip.ip_config', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mtu'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ip_multicast_boundary_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ip.pim_intf_phy_cont.pim_int_cmd', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'multicast-boundary'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ip_ospf_active_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'active'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ip_ospf_area_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'area'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ip_ospf_auth_change_wait_time_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'auth-change-wait-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ip_ospf_authentication_key_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.authentication_key', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ip_ospf_authentication_key_auth_key_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.authentication_key.auth_key_table', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'auth-key'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ip_ospf_authentication_key_auth_key_table_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.authentication_key.auth_key_table', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'encrypttype, auth_key'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ip_ospf_authentication_key_encrypttype_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.authentication_key.auth_key_table', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'encrypttype'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ip_ospf_authentication_key_no_encrypt_auth_key_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.authentication_key.no_encrypt_auth_key_table', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'no-encrypt-auth-key'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ip_ospf_authentication_key_no_encrypt_auth_key_table_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.authentication_key.no_encrypt_auth_key_table', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ip_ospf_bfd_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.bfd', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ip_ospf_bfd_intf_bfd_enable_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.bfd', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'intf-bfd-enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ip_ospf_cost_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cost'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ip_ospf_database_filter_all_external_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.database_filter', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'all-external'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ip_ospf_database_filter_all_out_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.database_filter', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'all-out'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ip_ospf_database_filter_all_summary_external_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.database_filter', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'all-summary-external'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ip_ospf_dead_interval_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dead-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ip_ospf_hello_interval_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hello-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ip_ospf_ldp_sync_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ldp-sync'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ip_ospf_md5_authentication_key_activation_wait_time_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.md5_authentication', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'key-activation-wait-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ip_ospf_md5_authentication_key_id_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.md5_authentication.key_table', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'key_id, key, md5_authentication_key'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ip_ospf_md5_authentication_key_id_key_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.md5_authentication.key_table', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'key'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ip_ospf_md5_authentication_key_id_key_id_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.md5_authentication.key_table', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'key-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ip_ospf_md5_authentication_no_encrypt_key_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.md5_authentication.no_encrypt_key_table', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'no-encrypt-key'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ip_ospf_md5_authentication_no_encrypt_key_id_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.md5_authentication.no_encrypt_key_table', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'no-encrypt-key-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ip_ospf_mtu_ignore_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mtu-ignore'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ip_ospf_network_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'network'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ip_ospf_passive_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'passive'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ip_ospf_priority_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ip_ospf_retransmit_interval_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'retransmit-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ip_ospf_transmit_delay_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'transmit-delay'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ip_pbr_interface_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ip_pbr_interface', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ip_pim_dr_priority_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ip.pim_intf_phy_cont.pim_int_cmd.pim', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dr-priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ip_pim_int_cmd_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ip.pim_intf_phy_cont.pim_int_cmd', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ip_pim_intf_phy_cont_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ip.pim_intf_phy_cont', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ip_pim_neighbor_filter_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ip.pim_intf_phy_cont.pim_int_cmd.pim', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'neighbor-filter'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ip_pim_sparse_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ip.pim_intf_phy_cont.pim_int_cmd', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'pim-sparse'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ip_pim_ttl_threshold_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ip.pim_intf_phy_cont.pim_int_cmd.pim', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ttl-threshold'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ip_policy_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ip_pbr_interface.ip.policy', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ip_policy_route_map_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ip_pbr_interface.ip.policy.route_map', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ip_policy_route_map_route_map_name_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ip_pbr_interface.ip.policy.route_map', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ip_proxy_arp_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ip.ip_config', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'proxy-arp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ip_router_isis_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ip.intf_router_isis.int_router_isis', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'isis'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_access_group_delete(self, ethernet=None, access_group=None, traffic_type=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type access_group: ipv6_access_list, ip_direction, traffic_type
    :param access_group: Keyword argument tuple.

    :type ipv6_access_list: unicode
    :param ipv6_access_list: **access_group** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type ip_direction: unicode
    :param ip_direction: **access_group** tuple argument.

        * enumeration restriction: ::

            ['in', 'out']

    :type traffic_type: unicode
    :param traffic_type: **access_group** tuple argument.

        * enumeration restriction: ::

            ['switched', 'routed']

    **Instance Argument(s)**:

    :type traffic_type: unicode
    :param traffic_type: Keyword argument.

        * enumeration restriction: ::

            ['switched', 'routed']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.access_group', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'access_group', 'keyval': 'ipv6_access_list, ip_direction', 'extra_keyval': 'ipv6_access_list, ip_direction, traffic_type'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, access_group=access_group, traffic_type=traffic_type)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, access_group=access_group, traffic_type=traffic_type)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_access_group_traffic_type_delete(self, ethernet=None, access_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type access_group: ipv6_access_list, ip_direction
    :param access_group: Keyword argument tuple.

    :type ipv6_access_list: unicode
    :param ipv6_access_list: **access_group** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type ip_direction: unicode
    :param ip_direction: **access_group** tuple argument.

        * enumeration restriction: ::

            ['in', 'out']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.access_group', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'access_group', 'keyval': 'ipv6_access_list, ip_direction', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'traffic-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, access_group=access_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, access_group=access_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_address_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.ipv6_config.address', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_address_ipv6_address_delete(self, ethernet=None, ipv6_address=None, secondary=None, anycast=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ipv6_address: address, secondary, anycast
    :param ipv6_address: Keyword argument tuple.

    :type address: unicode
    :param address: **ipv6_address** tuple argument:  A:B::C:D/LEN;; IPv6 prefix format: xxxx:xxxx/ml, xxxx:xxxx::/ml, xxxx::xx/128

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type secondary: YANGBool
    :param secondary: **ipv6_address** tuple argument:  Configure Secondary ipv6 address on an interface

    :type anycast: YANGBool
    :param anycast: **ipv6_address** tuple argument:  Configure ipv6 address as anycast

    **Instance Argument(s)**:

    :type secondary: YANGBool
    :param secondary: Configure Secondary ipv6 address on an interface

    :type anycast: YANGBool
    :param anycast: Configure ipv6 address as anycast

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.ipv6_config.address.ipv6_address', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_address', 'keyval': 'address', 'extra_keyval': 'address, secondary, anycast'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, ipv6_address=ipv6_address, secondary=secondary, anycast=anycast)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, ipv6_address=ipv6_address, secondary=secondary, anycast=anycast)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_address_ipv6_address_anycast_delete(self, ethernet=None, ipv6_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ipv6_address: address
    :param ipv6_address: Keyword argument tuple.

    :type address: unicode
    :param address: **ipv6_address** tuple argument:  A:B::C:D/LEN;; IPv6 prefix format: xxxx:xxxx/ml, xxxx:xxxx::/ml, xxxx::xx/128

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.ipv6_config.address.ipv6_address', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_address', 'keyval': 'address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'anycast'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, ipv6_address=ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, ipv6_address=ipv6_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_address_ipv6_address_eui_64_delete(self, ethernet=None, ipv6_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type ipv6_address: address, secondary, anycast
    :param ipv6_address: Keyword argument tuple.

    :type address: unicode
    :param address: **ipv6_address** tuple argument:  A:B::C:D/LEN;; IPv6 prefix format: xxxx:xxxx/ml, xxxx:xxxx::/ml, xxxx::xx/128

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type secondary: YANGBool
    :param secondary: **ipv6_address** tuple argument:  Configure Secondary ipv6 address on an interface

    :type anycast: YANGBool
    :param anycast: **ipv6_address** tuple argument:  Configure ipv6 address as anycast

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet'), ('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.ipv6_config.address.ipv6_address', u'ipv6_address')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.ipv6_config.address.ipv6_address.eui_config', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'address', 'extra_keyval': 'address, secondary, anycast'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'eui-64'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, ipv6_address=ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, ipv6_address=ipv6_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_address_ipv6_address_secondary_delete(self, ethernet=None, ipv6_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ipv6_address: address
    :param ipv6_address: Keyword argument tuple.

    :type address: unicode
    :param address: **ipv6_address** tuple argument:  A:B::C:D/LEN;; IPv6 prefix format: xxxx:xxxx/ml, xxxx:xxxx::/ml, xxxx::xx/128

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.ipv6_config.address.ipv6_address', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_address', 'keyval': 'address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'secondary'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, ipv6_address=ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, ipv6_address=ipv6_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_address_ipv6_address_secondary_eui_config_delete(self, ethernet=None, ipv6_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type ipv6_address: address, secondary, anycast
    :param ipv6_address: Keyword argument tuple.

    :type address: unicode
    :param address: **ipv6_address** tuple argument:  A:B::C:D/LEN;; IPv6 prefix format: xxxx:xxxx/ml, xxxx:xxxx::/ml, xxxx::xx/128

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type secondary: YANGBool
    :param secondary: **ipv6_address** tuple argument:  Configure Secondary ipv6 address on an interface

    :type anycast: YANGBool
    :param anycast: **ipv6_address** tuple argument:  Configure ipv6 address as anycast

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet'), ('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.ipv6_config.address.ipv6_address', u'ipv6_address')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.ipv6_config.address.ipv6_address.eui_config', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'address', 'extra_keyval': 'address, secondary, anycast'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'secondary'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, ipv6_address=ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, ipv6_address=ipv6_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_address_link_local_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.ipv6_config.address.link_local_config', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'link-local'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_address_link_local_address_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.ipv6_config.address.link_local_config', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'link-local-address'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_address_link_local_config_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.ipv6_config.address.link_local_config', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'link_local_address, link_local'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_address_use_link_local_only_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.ipv6_config.address', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'use-link-local-only'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_dhcp_relay_servers_delete(self, ethernet=None, servers=None, server_vrf_name=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type servers: relay_ip_addr, server_vrf_name
    :param servers: Keyword argument tuple.

    :type relay_ip_addr: unicode
    :param relay_ip_addr: **servers** tuple argument:  IPv6 address of the DHCPv6 server

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type server_vrf_name: unicode
    :param server_vrf_name: **servers** tuple argument:  VRF name of the DHCPv6 server

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Argument(s)**:

    :type server_vrf_name: unicode
    :param server_vrf_name: VRF name of the DHCPv6 server

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'servers', 'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, servers=servers, server_vrf_name=server_vrf_name)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, servers=servers, server_vrf_name=server_vrf_name)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_dhcp_relay_servers_interface_delete(self, ethernet=None, servers=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type servers: relay_ip_addr, server_vrf_name
    :param servers: Keyword argument tuple.

    :type relay_ip_addr: unicode
    :param relay_ip_addr: **servers** tuple argument:  IPv6 address of the DHCPv6 server

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type server_vrf_name: unicode
    :param server_vrf_name: **servers** tuple argument:  VRF name of the DHCPv6 server

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet'), ('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', u'servers')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers.interface', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'interface_type, interface_name'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, servers=servers)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, servers=servers)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_dhcp_relay_servers_interface_interface_delete(self, ethernet=None, servers=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type servers: relay_ip_addr, server_vrf_name
    :param servers: Keyword argument tuple.

    :type relay_ip_addr: unicode
    :param relay_ip_addr: **servers** tuple argument:  IPv6 address of the DHCPv6 server

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type server_vrf_name: unicode
    :param server_vrf_name: **servers** tuple argument:  VRF name of the DHCPv6 server

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet'), ('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', u'servers')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers.interface', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'interface'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, servers=servers)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, servers=servers)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_dhcp_relay_servers_interface_interface_name_delete(self, ethernet=None, servers=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type servers: relay_ip_addr, server_vrf_name
    :param servers: Keyword argument tuple.

    :type relay_ip_addr: unicode
    :param relay_ip_addr: **servers** tuple argument:  IPv6 address of the DHCPv6 server

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type server_vrf_name: unicode
    :param server_vrf_name: **servers** tuple argument:  VRF name of the DHCPv6 server

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet'), ('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', u'servers')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers.interface', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'interface-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, servers=servers)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, servers=servers)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_dhcp_relay_servers_use_vrf_delete(self, ethernet=None, servers=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type servers: relay_ip_addr
    :param servers: Keyword argument tuple.

    :type relay_ip_addr: unicode
    :param relay_ip_addr: **servers** tuple argument:  IPv6 address of the DHCPv6 server

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'servers', 'keyval': 'relay_ip_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'use-vrf'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, servers=servers)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, servers=servers)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_hop_by_hop_trap_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.ipv6_phy_intf_cmds', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hop-by-hop-trap'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_icmpv6_rate_limiting_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.icmpv6', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rate-limiting'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_icmpv6_redirect_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.icmpv6', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redirect'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_interface_phy_dhcp_conf_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.interface_phy_dhcp_conf', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_intf_ipv6_router_isis_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.intf_ipv6_router_isis', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_ipv6_config_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.ipv6_config', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_ipv6_intf_cmds_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_ipv6_nd_ra_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.ipv6_nd_ra', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_ipv6_phy_intf_cmds_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.ipv6_phy_intf_cmds', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_mtu_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.ipv6_config', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mtu'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_nd_address_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.address', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_nd_address_suppress_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.address', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'suppress'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_nd_broadcast_mac_trap_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'broadcast-mac-trap'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_nd_cache_expire_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.cache', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'expire'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_nd_dad_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.dad', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_nd_dad_attempts_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.dad', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'attempts'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_nd_dad_time_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.dad', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_nd_hoplimit_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hoplimit'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_nd_managed_config_flag_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'managed-config-flag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_nd_mtu_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mtu'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_nd_ns_interval_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ns-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_nd_nud_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_nd_nud_retry_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'base, interval, max_attempts'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_nd_nud_retry_base_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'base'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_nd_nud_retry_interval_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_nd_nud_retry_max_attempts_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'max-attempts'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_nd_other_config_flag_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'other-config-flag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_nd_prefix_delete(self, ethernet=None, prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix', 'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, prefix=prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_nd_prefix_infinite_delete(self, ethernet=None, prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet'), ('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'infinite'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, prefix=prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_nd_prefix_infinite_preferred_delete(self, ethernet=None, prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet'), ('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'infinite'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, prefix=prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_nd_prefix_no_advertise_delete(self, ethernet=None, prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet'), ('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'no-advertise'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, prefix=prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_nd_prefix_no_autoconfig_delete(self, ethernet=None, prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet'), ('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'no-autoconfig'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, prefix=prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_nd_prefix_no_onlink_delete(self, ethernet=None, prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet'), ('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'no-onlink'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, prefix=prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_nd_prefix_off_link_delete(self, ethernet=None, prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet'), ('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'off-link'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, prefix=prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_nd_prefix_preferred_delete(self, ethernet=None, prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet'), ('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'preferred_lifetime, preferred_infinite'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred': [u'preferred_infinite', u'preferred_lifetime']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, prefix=prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_nd_prefix_preferred_lifetime_delete(self, ethernet=None, prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet'), ('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'preferred-lifetime'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, prefix=prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_nd_prefix_prefix_flags_delete(self, ethernet=None, prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet'), ('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'no_autoconfig, no_onlink, off_link'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, prefix=prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_nd_prefix_valid_lifetime_delete(self, ethernet=None, prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet'), ('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'valid-lifetime'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, prefix=prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_nd_proxy_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'proxy'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_nd_ra_dns_server_delete(self, ethernet=None, ra_dns_server=None, dns_server_lifetime_multiplier=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ra_dns_server: dns_server_prefix
    :param ra_dns_server: Keyword argument tuple.

    :type dns_server_prefix: unicode
    :param dns_server_prefix: **ra_dns_server** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    **Instance Argument(s)**:

    :type dns_server_lifetime_multiplier: long
    :param dns_server_lifetime_multiplier: Lifetime multiplier for the Recursive DNS Server option

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_dns_server', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ra_dns_server', 'keyval': 'dns_server_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, ra_dns_server=ra_dns_server, dns_server_lifetime_multiplier=dns_server_lifetime_multiplier)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, ra_dns_server=ra_dns_server, dns_server_lifetime_multiplier=dns_server_lifetime_multiplier)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_nd_ra_dns_server_lifetime_multiplier_delete(self, ethernet=None, ra_dns_server=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ra_dns_server: dns_server_prefix
    :param ra_dns_server: Keyword argument tuple.

    :type dns_server_prefix: unicode
    :param dns_server_prefix: **ra_dns_server** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_dns_server', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ra_dns_server', 'keyval': 'dns_server_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lifetime-multiplier'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, ra_dns_server=ra_dns_server)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, ra_dns_server=ra_dns_server)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_nd_ra_domain_name_delete(self, ethernet=None, ra_domain_name=None, domain_name_lifetime_multiplier=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ra_domain_name: domain_name_string
    :param ra_domain_name: Keyword argument tuple.

    :type domain_name_string: unicode
    :param domain_name_string: **ra_domain_name** tuple argument.

    **Instance Argument(s)**:

    :type domain_name_lifetime_multiplier: long
    :param domain_name_lifetime_multiplier: Lifetime multiplier for DNS Search List option

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_domain_name', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ra_domain_name', 'keyval': 'domain_name_string', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, ra_domain_name=ra_domain_name, domain_name_lifetime_multiplier=domain_name_lifetime_multiplier)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, ra_domain_name=ra_domain_name, domain_name_lifetime_multiplier=domain_name_lifetime_multiplier)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_nd_ra_domain_name_lifetime_multiplier_delete(self, ethernet=None, ra_domain_name=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ra_domain_name: domain_name_string
    :param ra_domain_name: Keyword argument tuple.

    :type domain_name_string: unicode
    :param domain_name_string: **ra_domain_name** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_domain_name', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ra_domain_name', 'keyval': 'domain_name_string', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lifetime-multiplier'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, ra_domain_name=ra_domain_name)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, ra_domain_name=ra_domain_name)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_nd_ra_interval_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_interval', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'max_interval, min_'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_nd_ra_interval_max_interval_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_interval', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'max-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_nd_ra_interval_min_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_interval', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'min'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_nd_ra_lifetime_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ra-lifetime'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_nd_reachable_time_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'reachable-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_nd_retrans_timer_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'retrans-timer'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_nd_router_preference_high_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.router_preference', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'high'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_nd_router_preference_low_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.router_preference', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'low'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_nd_router_preference_medium_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.router_preference', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'medium'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_nd_send_ra_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'send-ra'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_nd_suppress_ra_all_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'all'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_nd_suppress_ra_mtu_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mtu'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_nd_suppress_ra_suppress_ra_flag_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'suppress-ra-flag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_neighbor_delete(self, ethernet=None, neighbor=None, hardware_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type neighbor: ipv6_address
    :param neighbor: Keyword argument tuple.

    :type ipv6_address: unicode
    :param ipv6_address: **neighbor** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    **Instance Argument(s)**:

    :type hardware_address: unicode
    :param hardware_address: Keyword argument.

        * pattern restriction: ::

            '[0-9a-fA-F]{4}(.[0-9a-fA-F]{4}){2}'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.neighbor', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'neighbor', 'keyval': 'ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, neighbor=neighbor, hardware_address=hardware_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, neighbor=neighbor, hardware_address=hardware_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_neighbor_hardware_address_delete(self, ethernet=None, neighbor=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type neighbor: ipv6_address
    :param neighbor: Keyword argument tuple.

    :type ipv6_address: unicode
    :param ipv6_address: **neighbor** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.neighbor', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'neighbor', 'keyval': 'ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hardware-address'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, neighbor=neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, neighbor=neighbor)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_ospf_active_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.interface_ospfv3_conf', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'active'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_ospf_area_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.interface_ospfv3_conf', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'area'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_ospf_authentication_ah_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ah'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_ospf_authentication_esp_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'esp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_ospf_authentication_esp_auth_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'esp-auth'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_ospf_authentication_esp_key_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'esp-key'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_ospf_authentication_esp_no_encrypt_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'esp-no-encrypt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_ospf_authentication_ipsec_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_ospf_authentication_ipsec_disable_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'disable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_ospf_authentication_ipsec_key_add_remove_interval_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'key-add-remove-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_ospf_authentication_key_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'key'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_ospf_authentication_no_encrypt_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'no-encrypt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_ospf_authentication_spi_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'spi'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_ospf_bfd_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.interface_ospfv3_conf.bfd', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_ospf_bfd_bfd_enable_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.interface_ospfv3_conf.bfd', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bfd-enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_ospf_cost_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.interface_ospfv3_conf', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cost'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_ospf_dead_interval_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dead-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_ospf_hello_interval_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hello-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_ospf_hello_jitter_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hello-jitter'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_ospf_instance_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.interface_ospfv3_conf', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'instance'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_ospf_mtu_ignore_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.interface_ospfv3_conf', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mtu-ignore'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_ospf_network_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.interface_ospfv3_conf', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'network'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_ospf_passive_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.interface_ospfv3_conf', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'passive'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_ospf_priority_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.interface_ospfv3_conf', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_ospf_retransmit_interval_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'retransmit-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_ospf_suppress_linklsa_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.interface_ospfv3_conf', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'suppress-linklsa'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_ospf_transmit_delay_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'transmit-delay'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_policy_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.policy', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_policy_route_map_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.policy.route_map', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_policy_route_map_ipv6_route_map_name_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.policy.route_map', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ipv6-route-map-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_raguard_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'raguard'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_router_isis_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.intf_ipv6_router_isis.int_ipv6_router_isis', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'isis'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_vrrp_extended_group_delete(self, ethernet=None, vrrpv3e_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.vrrpv3e_group', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_vrrp_extended_group_advertise_backup_delete(self, ethernet=None, vrrpv3e_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.vrrpv3e_group', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'advertise-backup'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_vrrp_extended_group_advertisement_interval_delete(self, ethernet=None, vrrpv3e_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.vrrpv3e_group', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'advertisement-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_vrrp_extended_group_advertisement_interval_scale_delete(self, ethernet=None, vrrpv3e_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.vrrpv3e_group', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'advertisement-interval-scale'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_vrrp_extended_group_backup_advertisement_interval_delete(self, ethernet=None, vrrpv3e_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.vrrpv3e_group', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'backup-advertisement-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_vrrp_extended_group_description_delete(self, ethernet=None, vrrpv3e_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.vrrpv3e_group', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'description'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_vrrp_extended_group_enable_delete(self, ethernet=None, vrrpv3e_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.vrrpv3e_group', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_vrrp_extended_group_hold_time_delete(self, ethernet=None, vrrpv3e_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.vrrpv3e_group', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hold-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_vrrp_extended_group_nd_advertisement_timer_delete(self, ethernet=None, vrrpv3e_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.vrrpv3e_group', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'nd-advertisement-timer'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_vrrp_extended_group_preempt_mode_delete(self, ethernet=None, vrrpv3e_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.vrrpv3e_group', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'preempt-mode'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_vrrp_extended_group_priority_delete(self, ethernet=None, vrrpv3e_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.vrrpv3e_group', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_vrrp_extended_group_short_path_forwarding_delete(self, ethernet=None, vrrpv3e_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet'), ('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.vrrpv3e_group.short_path_forwarding', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'basic, revert_priority'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_vrrp_extended_group_short_path_forwarding_basic_delete(self, ethernet=None, vrrpv3e_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet'), ('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.vrrpv3e_group.short_path_forwarding', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'basic'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_vrrp_extended_group_short_path_forwarding_revert_priority_delete(self, ethernet=None, vrrpv3e_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet'), ('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.vrrpv3e_group.short_path_forwarding', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'revert-priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_vrrp_extended_group_track_interface_delete(self, ethernet=None, vrrpv3e_group=None, interface=None, track_priority=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Argument(s)**:

    :type track_priority: int
    :param track_priority: Track Priority

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet'), ('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.vrrpv3e_group.track.interface', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrpv3e_group=vrrpv3e_group, interface=interface, track_priority=track_priority)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrpv3e_group=vrrpv3e_group, interface=interface, track_priority=track_priority)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_vrrp_extended_group_track_interface_priority_delete(self, ethernet=None, vrrpv3e_group=None, interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet'), ('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.vrrpv3e_group.track.interface', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrpv3e_group=vrrpv3e_group, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrpv3e_group=vrrpv3e_group, interface=interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_vrrp_extended_group_virtual_ip_delete(self, ethernet=None, vrrpv3e_group=None, virtual_ip=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type virtual_ip: virtual_ipaddr
    :param virtual_ip: Keyword argument tuple.

    :type virtual_ipaddr: unicode
    :param virtual_ipaddr: **virtual_ip** tuple argument:  Virtual IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet'), ('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.vrrpv3e_group.virtual_ip', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'virtual_ip', 'keyval': 'virtual_ipaddr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrpv3e_group=vrrpv3e_group, virtual_ip=virtual_ip)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrpv3e_group=vrrpv3e_group, virtual_ip=virtual_ip)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_vrrp_group_delete(self, ethernet=None, vrrpv3_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.vrrpv3_group', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrpv3_group=vrrpv3_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrpv3_group=vrrpv3_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_vrrp_group_advertisement_interval_delete(self, ethernet=None, vrrpv3_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.vrrpv3_group', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'advertisement-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrpv3_group=vrrpv3_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrpv3_group=vrrpv3_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_vrrp_group_description_delete(self, ethernet=None, vrrpv3_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.vrrpv3_group', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'description'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrpv3_group=vrrpv3_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrpv3_group=vrrpv3_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_vrrp_group_enable_delete(self, ethernet=None, vrrpv3_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.vrrpv3_group', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrpv3_group=vrrpv3_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrpv3_group=vrrpv3_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_vrrp_group_hold_time_delete(self, ethernet=None, vrrpv3_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.vrrpv3_group', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hold-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrpv3_group=vrrpv3_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrpv3_group=vrrpv3_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_vrrp_group_preempt_mode_delete(self, ethernet=None, vrrpv3_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.vrrpv3_group', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'preempt-mode'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrpv3_group=vrrpv3_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrpv3_group=vrrpv3_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_vrrp_group_priority_delete(self, ethernet=None, vrrpv3_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.vrrpv3_group', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrpv3_group=vrrpv3_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrpv3_group=vrrpv3_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_vrrp_group_track_interface_delete(self, ethernet=None, vrrpv3_group=None, interface=None, track_priority=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Argument(s)**:

    :type track_priority: int
    :param track_priority: Track Priority

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet'), ('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.vrrpv3_group', u'vrrpv3_group')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.vrrpv3_group.track.interface', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrpv3_group=vrrpv3_group, interface=interface, track_priority=track_priority)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrpv3_group=vrrpv3_group, interface=interface, track_priority=track_priority)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_vrrp_group_track_interface_priority_delete(self, ethernet=None, vrrpv3_group=None, interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet'), ('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.vrrpv3_group', u'vrrpv3_group')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.vrrpv3_group.track.interface', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrpv3_group=vrrpv3_group, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrpv3_group=vrrpv3_group, interface=interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_vrrp_group_use_v2_checksum_delete(self, ethernet=None, vrrpv3_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.vrrpv3_group', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'use-v2-checksum'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrpv3_group=vrrpv3_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrpv3_group=vrrpv3_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_vrrp_group_virtual_ip_delete(self, ethernet=None, vrrpv3_group=None, virtual_ip=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type virtual_ip: virtual_ipaddr
    :param virtual_ip: Keyword argument tuple.

    :type virtual_ipaddr: unicode
    :param virtual_ipaddr: **virtual_ip** tuple argument:  Virtual IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet'), ('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.vrrpv3_group', u'vrrpv3_group')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.vrrpv3_group.virtual_ip', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'virtual_ip', 'keyval': 'virtual_ipaddr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrpv3_group=vrrpv3_group, virtual_ip=virtual_ip)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrpv3_group=vrrpv3_group, virtual_ip=virtual_ip)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_ipv6_vrrp_suppress_interface_ra_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vrrp-suppress-interface-ra'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_isis_auth_check_level_1_disable_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.auth_check.auth_check_level1', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'disable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_isis_auth_check_level_2_disable_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.auth_check.auth_check_level2', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'disable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_isis_auth_key_delete(self, ethernet=None, interface_auth_key=None, interface_auth_key_str=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type interface_auth_key: interface_auth_key_level, interface_auth_key_str
    :param interface_auth_key: Keyword argument tuple.

    :type interface_auth_key_level: unicode
    :param interface_auth_key_level: **interface_auth_key** tuple argument.

        * enumeration restriction: ::

            ['level-2', 'level-1']

    :type interface_auth_key_str: unicode
    :param interface_auth_key_str: **interface_auth_key** tuple argument.

        * length restriction: ::

            ['1..63']

    **Instance Argument(s)**:

    :type interface_auth_key_str: unicode
    :param interface_auth_key_str: Keyword argument.

        * length restriction: ::

            ['1..63']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_auth_key', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface_auth_key', 'keyval': 'interface_auth_key_level', 'extra_keyval': 'interface_auth_key_level, interface_auth_key_str'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, interface_auth_key=interface_auth_key, interface_auth_key_str=interface_auth_key_str)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, interface_auth_key=interface_auth_key, interface_auth_key_str=interface_auth_key_str)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_isis_auth_key_interface_auth_key_str_delete(self, ethernet=None, interface_auth_key=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type interface_auth_key: interface_auth_key_level
    :param interface_auth_key: Keyword argument tuple.

    :type interface_auth_key_level: unicode
    :param interface_auth_key_level: **interface_auth_key** tuple argument.

        * enumeration restriction: ::

            ['level-2', 'level-1']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_auth_key', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface_auth_key', 'keyval': 'interface_auth_key_level', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'interface-auth-key-str'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, interface_auth_key=interface_auth_key)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, interface_auth_key=interface_auth_key)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_isis_auth_mode_md5_level_1_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_auth_mode.interface_md5', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'level-1'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_isis_auth_mode_md5_level_2_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_auth_mode.interface_md5', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'level-2'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_isis_bfd_disable_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_bfd', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'disable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_isis_circuit_type_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'circuit-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_isis_hello_interval_delete(self, ethernet=None, interface_hello_interval=None, interface_hello_interval_val=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type interface_hello_interval: interface_hello_interval_level, interface_hello_interval_val
    :param interface_hello_interval: Keyword argument tuple.

    :type interface_hello_interval_level: unicode
    :param interface_hello_interval_level: **interface_hello_interval** tuple argument.

        * enumeration restriction: ::

            ['level-2', 'level-1']

    :type interface_hello_interval_val: long
    :param interface_hello_interval_val: **interface_hello_interval** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Argument(s)**:

    :type interface_hello_interval_val: long
    :param interface_hello_interval_val: Keyword argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_hello_interval', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface_hello_interval', 'keyval': 'interface_hello_interval_level', 'extra_keyval': 'interface_hello_interval_level, interface_hello_interval_val'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, interface_hello_interval=interface_hello_interval, interface_hello_interval_val=interface_hello_interval_val)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, interface_hello_interval=interface_hello_interval, interface_hello_interval_val=interface_hello_interval_val)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_isis_hello_interval_interface_hello_interval_val_delete(self, ethernet=None, interface_hello_interval=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type interface_hello_interval: interface_hello_interval_level
    :param interface_hello_interval: Keyword argument tuple.

    :type interface_hello_interval_level: unicode
    :param interface_hello_interval_level: **interface_hello_interval** tuple argument.

        * enumeration restriction: ::

            ['level-2', 'level-1']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_hello_interval', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface_hello_interval', 'keyval': 'interface_hello_interval_level', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'interface-hello-interval-val'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, interface_hello_interval=interface_hello_interval)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, interface_hello_interval=interface_hello_interval)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_isis_hello_multiplier_delete(self, ethernet=None, interface_hello_multiplier=None, interface_hello_multiplier_val=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type interface_hello_multiplier: interface_hello_multiplier_level, interface_hello_multiplier_val
    :param interface_hello_multiplier: Keyword argument tuple.

    :type interface_hello_multiplier_level: unicode
    :param interface_hello_multiplier_level: **interface_hello_multiplier** tuple argument.

        * enumeration restriction: ::

            ['level-2', 'level-1']

    :type interface_hello_multiplier_val: long
    :param interface_hello_multiplier_val: **interface_hello_multiplier** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Argument(s)**:

    :type interface_hello_multiplier_val: long
    :param interface_hello_multiplier_val: Keyword argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_hello_multiplier', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface_hello_multiplier', 'keyval': 'interface_hello_multiplier_level', 'extra_keyval': 'interface_hello_multiplier_level, interface_hello_multiplier_val'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, interface_hello_multiplier=interface_hello_multiplier, interface_hello_multiplier_val=interface_hello_multiplier_val)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, interface_hello_multiplier=interface_hello_multiplier, interface_hello_multiplier_val=interface_hello_multiplier_val)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_isis_hello_multiplier_interface_hello_multiplier_val_delete(self, ethernet=None, interface_hello_multiplier=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type interface_hello_multiplier: interface_hello_multiplier_level
    :param interface_hello_multiplier: Keyword argument tuple.

    :type interface_hello_multiplier_level: unicode
    :param interface_hello_multiplier_level: **interface_hello_multiplier** tuple argument.

        * enumeration restriction: ::

            ['level-2', 'level-1']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_hello_multiplier', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface_hello_multiplier', 'keyval': 'interface_hello_multiplier_level', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'interface-hello-multiplier-val'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, interface_hello_multiplier=interface_hello_multiplier)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, interface_hello_multiplier=interface_hello_multiplier)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_isis_hello_padding_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_hello.interface_hello_padding', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_isis_hello_padding_disable_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_hello.interface_hello_padding', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'disable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_isis_ipv6_metric_delete(self, ethernet=None, interface_ipv6_metric=None, interface_ipv6_metric_val=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type interface_ipv6_metric: interface_ipv6_metric_level, interface_ipv6_metric_val
    :param interface_ipv6_metric: Keyword argument tuple.

    :type interface_ipv6_metric_level: unicode
    :param interface_ipv6_metric_level: **interface_ipv6_metric** tuple argument.

        * enumeration restriction: ::

            ['level-2', 'level-1']

    :type interface_ipv6_metric_val: long
    :param interface_ipv6_metric_val: **interface_ipv6_metric** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Argument(s)**:

    :type interface_ipv6_metric_val: long
    :param interface_ipv6_metric_val: Keyword argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_ipv6.interface_ipv6_metric', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface_ipv6_metric', 'keyval': 'interface_ipv6_metric_level', 'extra_keyval': 'interface_ipv6_metric_level, interface_ipv6_metric_val'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, interface_ipv6_metric=interface_ipv6_metric, interface_ipv6_metric_val=interface_ipv6_metric_val)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, interface_ipv6_metric=interface_ipv6_metric, interface_ipv6_metric_val=interface_ipv6_metric_val)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_isis_ipv6_metric_interface_ipv6_metric_val_delete(self, ethernet=None, interface_ipv6_metric=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type interface_ipv6_metric: interface_ipv6_metric_level
    :param interface_ipv6_metric: Keyword argument tuple.

    :type interface_ipv6_metric_level: unicode
    :param interface_ipv6_metric_level: **interface_ipv6_metric** tuple argument.

        * enumeration restriction: ::

            ['level-2', 'level-1']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_ipv6.interface_ipv6_metric', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface_ipv6_metric', 'keyval': 'interface_ipv6_metric_level', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'interface-ipv6-metric-val'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, interface_ipv6_metric=interface_ipv6_metric)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, interface_ipv6_metric=interface_ipv6_metric)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_isis_ldp_sync_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ldp-sync'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_isis_metric_delete(self, ethernet=None, interface_metric=None, interface_metric_val=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type interface_metric: interface_metric_level, interface_metric_val
    :param interface_metric: Keyword argument tuple.

    :type interface_metric_level: unicode
    :param interface_metric_level: **interface_metric** tuple argument.

        * enumeration restriction: ::

            ['level-2', 'level-1']

    :type interface_metric_val: long
    :param interface_metric_val: **interface_metric** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Argument(s)**:

    :type interface_metric_val: long
    :param interface_metric_val: Keyword argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_metric', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface_metric', 'keyval': 'interface_metric_level', 'extra_keyval': 'interface_metric_level, interface_metric_val'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, interface_metric=interface_metric, interface_metric_val=interface_metric_val)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, interface_metric=interface_metric, interface_metric_val=interface_metric_val)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_isis_metric_interface_metric_val_delete(self, ethernet=None, interface_metric=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type interface_metric: interface_metric_level
    :param interface_metric: Keyword argument tuple.

    :type interface_metric_level: unicode
    :param interface_metric_level: **interface_metric** tuple argument.

        * enumeration restriction: ::

            ['level-2', 'level-1']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_metric', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface_metric', 'keyval': 'interface_metric_level', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'interface-metric-val'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, interface_metric=interface_metric)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, interface_metric=interface_metric)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_isis_passive_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'passive'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_isis_point_to_point_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'point-to-point'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_isis_priority_level_1_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_priority', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'level-1'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_isis_priority_level_2_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_priority', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'level-2'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_isis_reverse_metric_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_reverse_metric', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_isis_reverse_metric_rev_metric_common_attributes_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_reverse_metric.rev_metric_common_attributes', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_isis_reverse_metric_rev_metric_val_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_reverse_metric.rev_metric_common_attributes', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rev-metric-val'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_isis_reverse_metric_te_def_metric_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_reverse_metric.rev_metric_common_attributes', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'te-def-metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_isis_reverse_metric_whole_lan_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_reverse_metric.rev_metric_common_attributes', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'whole-lan'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_lacp_default_up_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.lacp', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'default-up'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_lacp_port_priority_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.lacp', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'port-priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_lacp_timeout_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.lacp', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'timeout'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_link_error_disable_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.link_error_disable', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'link_error_disable_entry, sampling_time_in_sec, wait_time_in_sec'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_link_error_disable_link_error_disable_entry_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.link_error_disable', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'link-error-disable-entry'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_link_error_disable_sampling_time_in_sec_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.link_error_disable', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'sampling-time-in-sec'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_link_error_disable_wait_time_in_sec_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.link_error_disable', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'wait-time-in-sec'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_link_fault_signaling_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.link_fault_signaling', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'rx, tx'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_link_fault_signaling_rx_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.link_fault_signaling', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_link_fault_signaling_tx_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.link_fault_signaling', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_lldp_cee_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.lldp.cee', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_lldp_cee_lldp_cee_on_off_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.lldp.cee', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lldp-cee-on-off'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_lldp_dcbx_version_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.lldp', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dcbx-version'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_lldp_disable_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.lldp', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'disable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_lldp_iscsi_priority_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.lldp', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'iscsi-priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_lldp_profile_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.lldp', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'profile'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_logical_interface_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.logical_interface', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_logical_interface_ethernet_delete(self, ethernet=None, ethernet_=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ethernet_: instance_id
    :param ethernet_: Keyword argument tuple.

    :type instance_id: unicode
    :param instance_id: **ethernet_** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9])(:[1-4])?)'
            '(\.([1-9]|[1-9][0-9]||[1-9][0-9][0-9]|[1-9][0-9]'
            '[0-9][0-9]|1[0-2][0-2][0-8][0-8]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.logical_interface.ethernet', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ethernet_', 'keyval': 'instance_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, ethernet_=ethernet_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, ethernet_=ethernet_)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_logical_interface_ethernet_get_untagged_vlan_dummy_delete(self, ethernet=None, ethernet_=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type ethernet_: instance_id
    :param ethernet_: Keyword argument tuple.

    :type instance_id: unicode
    :param instance_id: **ethernet_** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9])(:[1-4])?)'
            '(\.([1-9]|[1-9][0-9]||[1-9][0-9][0-9]|[1-9][0-9]'
            '[0-9][0-9]|1[0-2][0-2][0-8][0-8]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet'), ('pybind.slxos.v16r_1_00b.interface.ethernet.logical_interface.ethernet', u'ethernet_')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.logical_interface.ethernet.cmd_container_dummy.service_instance_vlan_cmds_dummy_container.get_untagged_vlan_dummy', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'instance_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, ethernet_=ethernet_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, ethernet_=ethernet_)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_logical_interface_ethernet_name_logical_interface_name_delete(self, ethernet=None, ethernet_=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type ethernet_: instance_id
    :param ethernet_: Keyword argument tuple.

    :type instance_id: unicode
    :param instance_id: **ethernet_** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9])(:[1-4])?)'
            '(\.([1-9]|[1-9][0-9]||[1-9][0-9][0-9]|[1-9][0-9]'
            '[0-9][0-9]|1[0-2][0-2][0-8][0-8]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet'), ('pybind.slxos.v16r_1_00b.interface.ethernet.logical_interface.ethernet', u'ethernet_')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.logical_interface.ethernet.cmd_container_dummy.service_instance_common_commands_dummy.name', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'instance_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'logical-interface-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, ethernet_=ethernet_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, ethernet_=ethernet_)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_logical_interface_ethernet_service_instance_common_commands_dummy_delete(self, ethernet=None, ethernet_=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type ethernet_: instance_id
    :param ethernet_: Keyword argument tuple.

    :type instance_id: unicode
    :param instance_id: **ethernet_** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9])(:[1-4])?)'
            '(\.([1-9]|[1-9][0-9]||[1-9][0-9][0-9]|[1-9][0-9]'
            '[0-9][0-9]|1[0-2][0-2][0-8][0-8]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet'), ('pybind.slxos.v16r_1_00b.interface.ethernet.logical_interface.ethernet', u'ethernet_')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.logical_interface.ethernet.cmd_container_dummy.service_instance_common_commands_dummy', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'instance_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, ethernet_=ethernet_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, ethernet_=ethernet_)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_logical_interface_ethernet_service_instance_vlan_cmds_dummy_container_delete(self, ethernet=None, ethernet_=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type ethernet_: instance_id
    :param ethernet_: Keyword argument tuple.

    :type instance_id: unicode
    :param instance_id: **ethernet_** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9])(:[1-4])?)'
            '(\.([1-9]|[1-9][0-9]||[1-9][0-9][0-9]|[1-9][0-9]'
            '[0-9][0-9]|1[0-2][0-2][0-8][0-8]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet'), ('pybind.slxos.v16r_1_00b.interface.ethernet.logical_interface.ethernet', u'ethernet_')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.logical_interface.ethernet.cmd_container_dummy.service_instance_vlan_cmds_dummy_container', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'instance_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, ethernet_=ethernet_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, ethernet_=ethernet_)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_logical_interface_ethernet_shutdown_shutdown_status_delete(self, ethernet=None, ethernet_=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type ethernet_: instance_id
    :param ethernet_: Keyword argument tuple.

    :type instance_id: unicode
    :param instance_id: **ethernet_** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9])(:[1-4])?)'
            '(\.([1-9]|[1-9][0-9]||[1-9][0-9][0-9]|[1-9][0-9]'
            '[0-9][0-9]|1[0-2][0-2][0-8][0-8]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet'), ('pybind.slxos.v16r_1_00b.interface.ethernet.logical_interface.ethernet', u'ethernet_')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.logical_interface.ethernet.cmd_container_dummy.service_instance_common_commands_dummy.shutdown', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'instance_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'shutdown-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, ethernet_=ethernet_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, ethernet_=ethernet_)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_logical_interface_ethernet_untagged_delete(self, ethernet=None, ethernet_=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type ethernet_: instance_id
    :param ethernet_: Keyword argument tuple.

    :type instance_id: unicode
    :param instance_id: **ethernet_** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9])(:[1-4])?)'
            '(\.([1-9]|[1-9][0-9]||[1-9][0-9][0-9]|[1-9][0-9]'
            '[0-9][0-9]|1[0-2][0-2][0-8][0-8]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet'), ('pybind.slxos.v16r_1_00b.interface.ethernet.logical_interface.ethernet', u'ethernet_')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.logical_interface.ethernet.cmd_container_dummy.service_instance_vlan_cmds_dummy_container.get_untagged_vlan_dummy.untagged', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'instance_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, ethernet_=ethernet_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, ethernet_=ethernet_)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_logical_interface_ethernet_untagged_vlan_delete(self, ethernet=None, ethernet_=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type ethernet_: instance_id
    :param ethernet_: Keyword argument tuple.

    :type instance_id: unicode
    :param instance_id: **ethernet_** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9])(:[1-4])?)'
            '(\.([1-9]|[1-9][0-9]||[1-9][0-9][0-9]|[1-9][0-9]'
            '[0-9][0-9]|1[0-2][0-2][0-8][0-8]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet'), ('pybind.slxos.v16r_1_00b.interface.ethernet.logical_interface.ethernet', u'ethernet_')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.logical_interface.ethernet.cmd_container_dummy.service_instance_vlan_cmds_dummy_container.get_untagged_vlan_dummy.untagged.untagged_vlan', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'instance_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, ethernet_=ethernet_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, ethernet_=ethernet_)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_logical_interface_ethernet_untagged_vlan_untagged_vlan_id_delete(self, ethernet=None, ethernet_=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type ethernet_: instance_id
    :param ethernet_: Keyword argument tuple.

    :type instance_id: unicode
    :param instance_id: **ethernet_** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9])(:[1-4])?)'
            '(\.([1-9]|[1-9][0-9]||[1-9][0-9][0-9]|[1-9][0-9]'
            '[0-9][0-9]|1[0-2][0-2][0-8][0-8]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet'), ('pybind.slxos.v16r_1_00b.interface.ethernet.logical_interface.ethernet', u'ethernet_')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.logical_interface.ethernet.cmd_container_dummy.service_instance_vlan_cmds_dummy_container.get_untagged_vlan_dummy.untagged.untagged_vlan', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'instance_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'untagged-vlan-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, ethernet_=ethernet_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, ethernet_=ethernet_)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_logical_interface_ethernet_vlan_delete(self, ethernet=None, ethernet_=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type ethernet_: instance_id
    :param ethernet_: Keyword argument tuple.

    :type instance_id: unicode
    :param instance_id: **ethernet_** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9])(:[1-4])?)'
            '(\.([1-9]|[1-9][0-9]||[1-9][0-9][0-9]|[1-9][0-9]'
            '[0-9][0-9]|1[0-2][0-2][0-8][0-8]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet'), ('pybind.slxos.v16r_1_00b.interface.ethernet.logical_interface.ethernet', u'ethernet_')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.logical_interface.ethernet.cmd_container_dummy.service_instance_vlan_cmds_dummy_container.tagged_outer_vlan', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'instance_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'outer_tagged_vlan_id, inner_vlan, inner_tagged_vlan_id'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, ethernet_=ethernet_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, ethernet_=ethernet_)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_logical_interface_ethernet_vlan_inner_tagged_vlan_id_delete(self, ethernet=None, ethernet_=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type ethernet_: instance_id
    :param ethernet_: Keyword argument tuple.

    :type instance_id: unicode
    :param instance_id: **ethernet_** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9])(:[1-4])?)'
            '(\.([1-9]|[1-9][0-9]||[1-9][0-9][0-9]|[1-9][0-9]'
            '[0-9][0-9]|1[0-2][0-2][0-8][0-8]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet'), ('pybind.slxos.v16r_1_00b.interface.ethernet.logical_interface.ethernet', u'ethernet_')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.logical_interface.ethernet.cmd_container_dummy.service_instance_vlan_cmds_dummy_container.tagged_outer_vlan', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'instance_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'inner-tagged-vlan-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, ethernet_=ethernet_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, ethernet_=ethernet_)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_logical_interface_ethernet_vlan_inner_vlan_delete(self, ethernet=None, ethernet_=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type ethernet_: instance_id
    :param ethernet_: Keyword argument tuple.

    :type instance_id: unicode
    :param instance_id: **ethernet_** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9])(:[1-4])?)'
            '(\.([1-9]|[1-9][0-9]||[1-9][0-9][0-9]|[1-9][0-9]'
            '[0-9][0-9]|1[0-2][0-2][0-8][0-8]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet'), ('pybind.slxos.v16r_1_00b.interface.ethernet.logical_interface.ethernet', u'ethernet_')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.logical_interface.ethernet.cmd_container_dummy.service_instance_vlan_cmds_dummy_container.tagged_outer_vlan', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'instance_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'inner-vlan'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, ethernet_=ethernet_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, ethernet_=ethernet_)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_logical_interface_ethernet_vlan_outer_tagged_vlan_id_delete(self, ethernet=None, ethernet_=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type ethernet_: instance_id
    :param ethernet_: Keyword argument tuple.

    :type instance_id: unicode
    :param instance_id: **ethernet_** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9])(:[1-4])?)'
            '(\.([1-9]|[1-9][0-9]||[1-9][0-9][0-9]|[1-9][0-9]'
            '[0-9][0-9]|1[0-2][0-2][0-8][0-8]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet'), ('pybind.slxos.v16r_1_00b.interface.ethernet.logical_interface.ethernet', u'ethernet_')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.logical_interface.ethernet.cmd_container_dummy.service_instance_vlan_cmds_dummy_container.tagged_outer_vlan', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'instance_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'outer-tagged-vlan-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, ethernet_=ethernet_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, ethernet_=ethernet_)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_long_distance_isl_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ethernet', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'long-distance-isl'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_mac_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.mac', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_mac_access_group_delete(self, ethernet=None, access_group=None, traffic_type=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type access_group: mac_access_list, mac_direction, traffic_type
    :param access_group: Keyword argument tuple.

    :type mac_access_list: unicode
    :param mac_access_list: **access_group** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type mac_direction: unicode
    :param mac_direction: **access_group** tuple argument.

        * enumeration restriction: ::

            ['in', 'out']

    :type traffic_type: unicode
    :param traffic_type: **access_group** tuple argument.

        * enumeration restriction: ::

            ['switched', 'routed']

    **Instance Argument(s)**:

    :type traffic_type: unicode
    :param traffic_type: Keyword argument.

        * enumeration restriction: ::

            ['switched', 'routed']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.mac.access_group', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'access_group', 'keyval': 'mac_access_list, mac_direction', 'extra_keyval': 'mac_access_list, mac_direction, traffic_type'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, access_group=access_group, traffic_type=traffic_type)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, access_group=access_group, traffic_type=traffic_type)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_mtu_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ethernet', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mtu'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_openflow_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.openflow', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_openflow_enable_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.openflow.enableInterfaceLevel', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'modeType, hybrid_mode'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_openflow_enable_hybrid_mode_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.openflow.enableInterfaceLevel', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hybrid-mode'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_openflow_enable_modetype_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.openflow.enableInterfaceLevel', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'modeType'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_openflow_protected_vlans_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.openflow.protected_vlans', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_openflow_protected_vlans_add_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.openflow.protected_vlans', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'add'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_openflow_protected_vlans_remove_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.openflow.protected_vlans', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'remove'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_port_profile_port_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ethernet', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'port-profile-port'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_port_profile_port_domain_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.port_profile_to_interface_associations.port_profile_port.port_to_port_profile_domain_association', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_port_profile_port_domain_profile_domain_name_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.port_profile_to_interface_associations.port_profile_port.port_to_port_profile_domain_association', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'profile-domain-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_port_profile_port_profile_delete(self, ethernet=None, port_to_port_profile_associations=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type port_to_port_profile_associations: port_to_port_profile_association
    :param port_to_port_profile_associations: Keyword argument tuple.

    :type port_to_port_profile_association: unicode
    :param port_to_port_profile_association: **port_to_port_profile_associations** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.port_profile_to_interface_associations.port_profile_port.port_to_port_profile_associations', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'port_to_port_profile_associations', 'keyval': 'port_to_port_profile_association', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, port_to_port_profile_associations=port_to_port_profile_associations)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, port_to_port_profile_associations=port_to_port_profile_associations)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_port_profile_to_interface_associations_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.port_profile_to_interface_associations', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_priority_tag_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ethernet', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority-tag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_qos_cos_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.qos', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cos'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_qos_cos_mutation_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.qos', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cos-mutation'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_qos_cos_traffic_class_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.qos', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cos-traffic-class'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_qos_drop_monitor_enable_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.qos.drop_monitor', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_qos_dscp_cos_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.qos', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dscp-cos'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_qos_dscp_mutation_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.qos', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dscp-mutation'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_qos_dscp_traffic_class_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.qos', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dscp-traffic-class'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_qos_flowcontrol_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.qos.flowcontrol', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_qos_flowcontrol_link_level_flowcontrol_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.qos.flowcontrol.link_level_flowcontrol', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_qos_flowcontrol_pfc_delete(self, ethernet=None, pfc=None, pfc_flowcontrol_tx=None, pfc_flowcontrol_rx=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type pfc: pfc_cos
    :param pfc: Keyword argument tuple.

    :type pfc_cos: int
    :param pfc_cos: **pfc** tuple argument:  0-7;;CoS value

        * range restriction: ::

            ['0..255']

    **Instance Argument(s)**:

    :type pfc_flowcontrol_tx: unicode
    :param pfc_flowcontrol_tx: Configure Pause generation

        * enumeration restriction: ::

            ['on', 'off']

    :type pfc_flowcontrol_rx: unicode
    :param pfc_flowcontrol_rx: Configure Pause reception

        * enumeration restriction: ::

            ['on', 'off']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.qos.flowcontrol.pfc', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'pfc', 'keyval': 'pfc_cos', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, pfc=pfc, pfc_flowcontrol_tx=pfc_flowcontrol_tx, pfc_flowcontrol_rx=pfc_flowcontrol_rx)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, pfc=pfc, pfc_flowcontrol_tx=pfc_flowcontrol_tx, pfc_flowcontrol_rx=pfc_flowcontrol_rx)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_qos_flowcontrol_pfc_rx_delete(self, ethernet=None, pfc=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type pfc: pfc_cos
    :param pfc: Keyword argument tuple.

    :type pfc_cos: int
    :param pfc_cos: **pfc** tuple argument:  0-7;;CoS value

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.qos.flowcontrol.pfc', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'pfc', 'keyval': 'pfc_cos', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, pfc=pfc)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, pfc=pfc)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_qos_flowcontrol_pfc_tx_delete(self, ethernet=None, pfc=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type pfc: pfc_cos
    :param pfc: Keyword argument tuple.

    :type pfc_cos: int
    :param pfc_cos: **pfc** tuple argument:  0-7;;CoS value

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.qos.flowcontrol.pfc', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'pfc', 'keyval': 'pfc_cos', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, pfc=pfc)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, pfc=pfc)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_qos_flowcontrol_rx_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.qos.flowcontrol.link_level_flowcontrol', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_qos_flowcontrol_tx_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.qos.flowcontrol.link_level_flowcontrol', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_qos_random_detect_traffic_class_delete(self, ethernet=None, traffic_class=None, red_profile_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type traffic_class: red_tc_value
    :param traffic_class: Keyword argument tuple.

    :type red_tc_value: int
    :param red_tc_value: **traffic_class** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Argument(s)**:

    :type red_profile_id: long
    :param red_profile_id: Keyword for all other VDX platforms

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.qos.random_detect.traffic_class', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'traffic_class', 'keyval': 'red_tc_value', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, traffic_class=traffic_class, red_profile_id=red_profile_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, traffic_class=traffic_class, red_profile_id=red_profile_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_qos_random_detect_traffic_class_red_profile_id_delete(self, ethernet=None, traffic_class=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type traffic_class: red_tc_value
    :param traffic_class: Keyword argument tuple.

    :type red_tc_value: int
    :param red_tc_value: **traffic_class** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.qos.random_detect.traffic_class', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'traffic_class', 'keyval': 'red_tc_value', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'red-profile-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, traffic_class=traffic_class)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, traffic_class=traffic_class)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_qos_rx_queue_cos_threshold_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.qos.rx_queue.cos_threshold', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_qos_rx_queue_cos_threshold_cos0_threshold_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.qos.rx_queue.cos_threshold', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cos0-threshold'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_qos_rx_queue_cos_threshold_cos1_threshold_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.qos.rx_queue.cos_threshold', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cos1-threshold'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_qos_rx_queue_cos_threshold_cos2_threshold_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.qos.rx_queue.cos_threshold', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cos2-threshold'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_qos_rx_queue_cos_threshold_cos3_threshold_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.qos.rx_queue.cos_threshold', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cos3-threshold'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_qos_rx_queue_cos_threshold_cos4_threshold_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.qos.rx_queue.cos_threshold', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cos4-threshold'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_qos_rx_queue_cos_threshold_cos5_threshold_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.qos.rx_queue.cos_threshold', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cos5-threshold'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_qos_rx_queue_cos_threshold_cos6_threshold_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.qos.rx_queue.cos_threshold', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cos6-threshold'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_qos_rx_queue_cos_threshold_cos7_threshold_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.qos.rx_queue.cos_threshold', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cos7-threshold'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_qos_rx_queue_multicast_best_effort_rate_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.qos.rx_queue.multicast', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'best-effort-rate'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_qos_rx_queue_multicast_guarantee_rate_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.qos.rx_queue.multicast', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'guarantee-rate'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_qos_rx_queue_multicast_queue_size_delete(self, ethernet=None, queue_size=None, min_queue_size=None, max_queue_size=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type queue_size: traffic_class, min_queue_size, max_queue_size
    :param queue_size: Keyword argument tuple.

    :type traffic_class: int
    :param traffic_class: **queue_size** tuple argument:  Traffic class to configure multicast queue size

        * range restriction: ::

            ['0..255']

    :type min_queue_size: long
    :param min_queue_size: **queue_size** tuple argument:  Configure minimum queue size

        * range restriction: ::

            ['0..4294967295']

    :type max_queue_size: long
    :param max_queue_size: **queue_size** tuple argument:  Configure maximum queue size

        * range restriction: ::

            ['0..4294967295']

    **Instance Argument(s)**:

    :type min_queue_size: long
    :param min_queue_size: Configure minimum queue size

        * range restriction: ::

            ['0..4294967295']

    :type max_queue_size: long
    :param max_queue_size: Configure maximum queue size

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.qos.rx_queue.multicast.queue_size', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'queue_size', 'keyval': 'traffic_class', 'extra_keyval': 'traffic_class, min_queue_size, max_queue_size'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, queue_size=queue_size, min_queue_size=min_queue_size, max_queue_size=max_queue_size)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, queue_size=queue_size, min_queue_size=min_queue_size, max_queue_size=max_queue_size)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_qos_rx_queue_multicast_queue_size_max_queue_size_delete(self, ethernet=None, queue_size=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type queue_size: traffic_class
    :param queue_size: Keyword argument tuple.

    :type traffic_class: int
    :param traffic_class: **queue_size** tuple argument:  Traffic class to configure multicast queue size

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.qos.rx_queue.multicast.queue_size', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'queue_size', 'keyval': 'traffic_class', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'max-queue-size'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, queue_size=queue_size)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, queue_size=queue_size)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_qos_rx_queue_multicast_queue_size_min_queue_size_delete(self, ethernet=None, queue_size=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type queue_size: traffic_class
    :param queue_size: Keyword argument tuple.

    :type traffic_class: int
    :param traffic_class: **queue_size** tuple argument:  Traffic class to configure multicast queue size

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.qos.rx_queue.multicast.queue_size', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'queue_size', 'keyval': 'traffic_class', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'min-queue-size'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, queue_size=queue_size)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, queue_size=queue_size)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_qos_rx_queue_unicast_queue_size_delete(self, ethernet=None, queue_size=None, min_queue_size=None, max_queue_size=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type queue_size: traffic_class, min_queue_size, max_queue_size
    :param queue_size: Keyword argument tuple.

    :type traffic_class: int
    :param traffic_class: **queue_size** tuple argument:  Traffic class to configure unicast queue size

        * range restriction: ::

            ['0..255']

    :type min_queue_size: long
    :param min_queue_size: **queue_size** tuple argument:  Configure minimum queue size

        * range restriction: ::

            ['0..4294967295']

    :type max_queue_size: long
    :param max_queue_size: **queue_size** tuple argument:  Configure maximum queue size

        * range restriction: ::

            ['0..4294967295']

    **Instance Argument(s)**:

    :type min_queue_size: long
    :param min_queue_size: Configure minimum queue size

        * range restriction: ::

            ['0..4294967295']

    :type max_queue_size: long
    :param max_queue_size: Configure maximum queue size

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.qos.rx_queue.unicast.queue_size', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'queue_size', 'keyval': 'traffic_class', 'extra_keyval': 'traffic_class, min_queue_size, max_queue_size'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, queue_size=queue_size, min_queue_size=min_queue_size, max_queue_size=max_queue_size)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, queue_size=queue_size, min_queue_size=min_queue_size, max_queue_size=max_queue_size)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_qos_rx_queue_unicast_queue_size_max_queue_size_delete(self, ethernet=None, queue_size=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type queue_size: traffic_class
    :param queue_size: Keyword argument tuple.

    :type traffic_class: int
    :param traffic_class: **queue_size** tuple argument:  Traffic class to configure unicast queue size

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.qos.rx_queue.unicast.queue_size', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'queue_size', 'keyval': 'traffic_class', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'max-queue-size'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, queue_size=queue_size)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, queue_size=queue_size)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_qos_rx_queue_unicast_queue_size_min_queue_size_delete(self, ethernet=None, queue_size=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type queue_size: traffic_class
    :param queue_size: Keyword argument tuple.

    :type traffic_class: int
    :param traffic_class: **queue_size** tuple argument:  Traffic class to configure unicast queue size

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.qos.rx_queue.unicast.queue_size', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'queue_size', 'keyval': 'traffic_class', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'min-queue-size'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, queue_size=queue_size)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, queue_size=queue_size)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_qos_traffic_class_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.qos', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'traffic-class'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_qos_traffic_class_cos_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.qos', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'traffic-class-cos'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_qos_trust_cos_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.qos.trust', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cos'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_qos_trust_dscp_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.qos.trust', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dscp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_rmon_collection_history_delete(self, ethernet=None, history_control_entry=None, history_control_buckets_requested=None, history_control_interval=None, history_control_owner=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type history_control_entry: history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner
    :param history_control_entry: Keyword argument tuple.

    :type history_control_index: long
    :param history_control_index: **history_control_entry** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type history_control_buckets_requested: long
    :param history_control_buckets_requested: **history_control_entry** tuple argument:  Buckets (default 50)

        * range restriction: ::

            ['-2147483648..2147483647']

    :type history_control_interval: long
    :param history_control_interval: **history_control_entry** tuple argument:  Polling Interval (default 1800)

        * range restriction: ::

            ['-2147483648..2147483647']

    :type history_control_owner: unicode
    :param history_control_owner: **history_control_entry** tuple argument:  Owner identity

        * length restriction: ::

            ['1 .. 15']

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,14})'

    **Instance Argument(s)**:

    :type history_control_buckets_requested: long
    :param history_control_buckets_requested: Buckets (default 50)

        * range restriction: ::

            ['-2147483648..2147483647']

    :type history_control_interval: long
    :param history_control_interval: Polling Interval (default 1800)

        * range restriction: ::

            ['-2147483648..2147483647']

    :type history_control_owner: unicode
    :param history_control_owner: Owner identity

        * length restriction: ::

            ['1 .. 15']

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,14})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.rmon.collection.history_control_entry', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'history_control_entry', 'keyval': 'history_control_index', 'extra_keyval': 'history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, history_control_entry=history_control_entry, history_control_buckets_requested=history_control_buckets_requested, history_control_interval=history_control_interval, history_control_owner=history_control_owner)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, history_control_entry=history_control_entry, history_control_buckets_requested=history_control_buckets_requested, history_control_interval=history_control_interval, history_control_owner=history_control_owner)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_rmon_collection_history_buckets_delete(self, ethernet=None, history_control_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type history_control_entry: history_control_index
    :param history_control_entry: Keyword argument tuple.

    :type history_control_index: long
    :param history_control_index: **history_control_entry** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.rmon.collection.history_control_entry', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'history_control_entry', 'keyval': 'history_control_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'buckets'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, history_control_entry=history_control_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, history_control_entry=history_control_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_rmon_collection_history_interval_delete(self, ethernet=None, history_control_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type history_control_entry: history_control_index
    :param history_control_entry: Keyword argument tuple.

    :type history_control_index: long
    :param history_control_index: **history_control_entry** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.rmon.collection.history_control_entry', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'history_control_entry', 'keyval': 'history_control_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, history_control_entry=history_control_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, history_control_entry=history_control_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_rmon_collection_history_owner_delete(self, ethernet=None, history_control_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type history_control_entry: history_control_index
    :param history_control_entry: Keyword argument tuple.

    :type history_control_index: long
    :param history_control_index: **history_control_entry** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.rmon.collection.history_control_entry', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'history_control_entry', 'keyval': 'history_control_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'owner'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, history_control_entry=history_control_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, history_control_entry=history_control_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_rmon_collection_stats_delete(self, ethernet=None, ether_stats_entry=None, ether_stats_owner=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ether_stats_entry: ether_stats_index, ether_stats_owner
    :param ether_stats_entry: Keyword argument tuple.

    :type ether_stats_index: long
    :param ether_stats_index: **ether_stats_entry** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type ether_stats_owner: unicode
    :param ether_stats_owner: **ether_stats_entry** tuple argument:  Owner identity

        * length restriction: ::

            ['1 .. 15']

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,14})'

    **Instance Argument(s)**:

    :type ether_stats_owner: unicode
    :param ether_stats_owner: Owner identity

        * length restriction: ::

            ['1 .. 15']

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,14})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.rmon.collection.ether_stats_entry', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ether_stats_entry', 'keyval': 'ether_stats_index', 'extra_keyval': 'ether_stats_index, ether_stats_owner'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, ether_stats_entry=ether_stats_entry, ether_stats_owner=ether_stats_owner)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, ether_stats_entry=ether_stats_entry, ether_stats_owner=ether_stats_owner)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_rmon_collection_stats_owner_delete(self, ethernet=None, ether_stats_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ether_stats_entry: ether_stats_index
    :param ether_stats_entry: Keyword argument tuple.

    :type ether_stats_index: long
    :param ether_stats_index: **ether_stats_entry** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.rmon.collection.ether_stats_entry', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ether_stats_entry', 'keyval': 'ether_stats_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'owner'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, ether_stats_entry=ether_stats_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, ether_stats_entry=ether_stats_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_rpf_log_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.rpf', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'log'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_rpf_mode_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.rpf_mode', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_rpf_mode_mode_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.rpf_mode', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mode'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_service_policy_in_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.service_policy', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'in'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_service_policy_out_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.service_policy', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'out'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_sflow_enable_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.sflow', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_sflow_polling_interval_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.sflow', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'polling-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_sflow_sample_rate_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.sflow', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'sample-rate'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_shutdown_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ethernet', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'shutdown'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_spanning_tree_autoedge_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.spanning_tree', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'autoedge'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_spanning_tree_bpdu_mac_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.spanning_tree', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bpdu-mac'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_spanning_tree_cost_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.spanning_tree', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cost'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_spanning_tree_edgeport_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.spanning_tree.edgeport', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_spanning_tree_edgeport_bpdu_filter_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.spanning_tree.edgeport', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bpdu-filter'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_spanning_tree_edgeport_bpdu_guard_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.spanning_tree.edgeport', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bpdu-guard'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_spanning_tree_edgeport_edgeportbasic_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.spanning_tree.edgeport', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'edgeportbasic'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_spanning_tree_guard_root_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.spanning_tree.guard', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'root'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_spanning_tree_instance_cost_delete(self, ethernet=None, instance=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type instance: id
    :param instance: Keyword argument tuple.

    :type id: int
    :param id: **instance** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.spanning_tree.instance', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instance', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cost'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, instance=instance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, instance=instance)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_spanning_tree_instance_priority_delete(self, ethernet=None, instance=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type instance: id
    :param instance: Keyword argument tuple.

    :type id: int
    :param id: **instance** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.spanning_tree.instance', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instance', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, instance=instance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, instance=instance)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_spanning_tree_instance_restricted_role_delete(self, ethernet=None, instance=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type instance: id
    :param instance: Keyword argument tuple.

    :type id: int
    :param id: **instance** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.spanning_tree.instance', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instance', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'restricted-role'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, instance=instance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, instance=instance)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_spanning_tree_instance_restricted_tcn_delete(self, ethernet=None, instance=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type instance: id
    :param instance: Keyword argument tuple.

    :type id: int
    :param id: **instance** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.spanning_tree.instance', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instance', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'restricted-tcn'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, instance=instance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, instance=instance)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_spanning_tree_link_type_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.spanning_tree', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'link-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_spanning_tree_portfast_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.spanning_tree.portfast', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_spanning_tree_portfast_bpdu_filter_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.spanning_tree.portfast', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bpdu-filter'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_spanning_tree_portfast_bpdu_guard_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.spanning_tree.portfast', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bpdu-guard'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_spanning_tree_portfast_portfastbasic_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.spanning_tree.portfast', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'portfastbasic'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_spanning_tree_priority_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.spanning_tree', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_spanning_tree_restricted_role_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.spanning_tree', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'restricted-role'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_spanning_tree_restricted_tcn_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.spanning_tree', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'restricted-tcn'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_spanning_tree_shutdown_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.spanning_tree', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'shutdown'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_spanning_tree_vlan_cost_delete(self, ethernet=None, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vlan: id
    :param vlan: Keyword argument tuple.

    :type id: long
    :param id: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.spanning_tree.vlan', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cost'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_spanning_tree_vlan_guard_root_delete(self, ethernet=None, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type vlan: id
    :param vlan: Keyword argument tuple.

    :type id: long
    :param id: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet'), ('pybind.slxos.v16r_1_00b.interface.ethernet.spanning_tree.vlan', u'vlan')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.spanning_tree.vlan.guard', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'root'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_spanning_tree_vlan_priority_delete(self, ethernet=None, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vlan: id
    :param vlan: Keyword argument tuple.

    :type id: long
    :param id: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.spanning_tree.vlan', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_speed_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ethernet', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'speed'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_storm_control_ingress_delete(self, ethernet=None, ingress=None, rate_format=None, rate_bps=None, rate_percent=None, bum_action=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ingress: protocol_type, rate_format, rate_bps, rate_percent, bum_action
    :param ingress: Keyword argument tuple.

    :type protocol_type: unicode
    :param protocol_type: **ingress** tuple argument.

        * enumeration restriction: ::

            ['broadcast', 'unknown-unicast', 'multicast']

    :type rate_format: unicode
    :param rate_format: **ingress** tuple argument.

        * enumeration restriction: ::

            ['limit-bps', 'limit-percent']

    :type rate_bps: long
    :param rate_bps: **ingress** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type rate_percent: long
    :param rate_percent: **ingress** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type bum_action: unicode
    :param bum_action: **ingress** tuple argument.

        * enumeration restriction: ::

            ['monitor', 'shutdown']

    **Instance Argument(s)**:

    :type rate_format: unicode
    :param rate_format: Keyword argument.

        * enumeration restriction: ::

            ['limit-bps', 'limit-percent']

    :type rate_bps: long
    :param rate_bps: Keyword argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type rate_percent: long
    :param rate_percent: Keyword argument.

        * range restriction: ::

            ['0..4294967295']

    :type bum_action: unicode
    :param bum_action: Keyword argument.

        * enumeration restriction: ::

            ['monitor', 'shutdown']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.storm_control.ingress', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ingress', 'keyval': 'protocol_type', 'extra_keyval': 'protocol_type, rate_format, rate_bps, rate_percent, bum_action'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, ingress=ingress, rate_format=rate_format, rate_bps=rate_bps, rate_percent=rate_percent, bum_action=bum_action)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, ingress=ingress, rate_format=rate_format, rate_bps=rate_bps, rate_percent=rate_percent, bum_action=bum_action)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_storm_control_ingress_bum_action_delete(self, ethernet=None, ingress=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ingress: protocol_type
    :param ingress: Keyword argument tuple.

    :type protocol_type: unicode
    :param protocol_type: **ingress** tuple argument.

        * enumeration restriction: ::

            ['broadcast', 'unknown-unicast', 'multicast']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.storm_control.ingress', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ingress', 'keyval': 'protocol_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bum-action'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, ingress=ingress)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, ingress=ingress)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_storm_control_ingress_rate_bps_delete(self, ethernet=None, ingress=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ingress: protocol_type
    :param ingress: Keyword argument tuple.

    :type protocol_type: unicode
    :param protocol_type: **ingress** tuple argument.

        * enumeration restriction: ::

            ['broadcast', 'unknown-unicast', 'multicast']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.storm_control.ingress', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ingress', 'keyval': 'protocol_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rate-bps'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, ingress=ingress)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, ingress=ingress)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_storm_control_ingress_rate_format_delete(self, ethernet=None, ingress=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ingress: protocol_type
    :param ingress: Keyword argument tuple.

    :type protocol_type: unicode
    :param protocol_type: **ingress** tuple argument.

        * enumeration restriction: ::

            ['broadcast', 'unknown-unicast', 'multicast']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.storm_control.ingress', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ingress', 'keyval': 'protocol_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rate-format'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, ingress=ingress)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, ingress=ingress)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_storm_control_ingress_rate_percent_delete(self, ethernet=None, ingress=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ingress: protocol_type
    :param ingress: Keyword argument tuple.

    :type protocol_type: unicode
    :param protocol_type: **ingress** tuple argument.

        * enumeration restriction: ::

            ['broadcast', 'unknown-unicast', 'multicast']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.storm_control.ingress', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ingress', 'keyval': 'protocol_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rate-percent'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, ingress=ingress)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, ingress=ingress)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_switchport_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.switchport_basic', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'switchport'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_switchport_access_mac_group_rspan_vlan_classification_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.switchport.access_mac_group_rspan_vlan_classification', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_switchport_access_mac_group_rspan_vlan_classification_access_rspan_vlan_delete(self, ethernet=None, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vlan: access_vlan_id, access_mac_group
    :param vlan: Keyword argument tuple.

    :type access_vlan_id: long
    :param access_vlan_id: **vlan** tuple argument:  Set the default VLAN for the interface

        * range restriction: ::

            ['0..4294967295']

    :type access_mac_group: long
    :param access_mac_group: **vlan** tuple argument:  Associate a Mac group with a vlan

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.switchport.access_mac_group_rspan_vlan_classification.access.vlan', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'access_vlan_id, access_mac_group', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_switchport_access_mac_group_vlan_classification_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.switchport.access_mac_group_vlan_classification', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_switchport_access_mac_group_vlan_classification_access_vlan_delete(self, ethernet=None, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vlan: access_vlan_id, access_mac_group
    :param vlan: Keyword argument tuple.

    :type access_vlan_id: long
    :param access_vlan_id: **vlan** tuple argument:  Set the default VLAN for the interface

        * range restriction: ::

            ['0..4294967295']

    :type access_mac_group: long
    :param access_mac_group: **vlan** tuple argument:  Associate a Mac group with a vlan

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.switchport.access_mac_group_vlan_classification.access.vlan', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'access_vlan_id, access_mac_group', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_switchport_access_mac_rspan_vlan_classification_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.switchport.access_mac_rspan_vlan_classification', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_switchport_access_mac_rspan_vlan_classification_access_rspan_vlan_delete(self, ethernet=None, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vlan: access_vlan_id, access_mac_address
    :param vlan: Keyword argument tuple.

    :type access_vlan_id: long
    :param access_vlan_id: **vlan** tuple argument:  Set the default VLAN for the interface

        * range restriction: ::

            ['0..4294967295']

    :type access_mac_address: unicode
    :param access_mac_address: **vlan** tuple argument:  Associate the Mac address with a vlan

        * pattern restriction: ::

            '[0-9a-fA-F]{4}(\.[0-9a-fA-F]{4}){2}'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.switchport.access_mac_rspan_vlan_classification.access.vlan', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'access_vlan_id, access_mac_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_switchport_access_mac_vlan_classification_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.switchport.access_mac_vlan_classification', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_switchport_access_mac_vlan_classification_access_vlan_delete(self, ethernet=None, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vlan: access_vlan_id, access_mac_address
    :param vlan: Keyword argument tuple.

    :type access_vlan_id: long
    :param access_vlan_id: **vlan** tuple argument:  Set the default VLAN for the interface

        * range restriction: ::

            ['0..4294967295']

    :type access_mac_address: unicode
    :param access_mac_address: **vlan** tuple argument:  Associate the Mac address with a vlan

        * pattern restriction: ::

            '[0-9a-fA-F]{4}(\.[0-9a-fA-F]{4}){2}'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.switchport.access_mac_vlan_classification.access.vlan', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'access_vlan_id, access_mac_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_switchport_access_rspan_vlan_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.switchport.access.rspan_access', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rspan-vlan'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_switchport_access_vlan_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.switchport.access', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vlan'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_switchport_basic_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.switchport_basic', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_switchport_mode_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.switchport.mode', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_switchport_mode_vlan_mode_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.switchport.mode', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vlan-mode'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_switchport_port_security_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.switchport.port_security', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_switchport_port_security_max_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.switchport.port_security', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'max'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_switchport_port_security_port_secutiry_mac_address_delete(self, ethernet=None, port_secutiry_mac_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type port_secutiry_mac_address: mac_address, port_sec_vlan
    :param port_secutiry_mac_address: Keyword argument tuple.

    :type mac_address: unicode
    :param mac_address: **port_secutiry_mac_address** tuple argument:  Mac Address

        * pattern restriction: ::

            '[0-9a-fA-F]{4}(\.[0-9a-fA-F]{4}){2}'

    :type port_sec_vlan: long
    :param port_sec_vlan: **port_secutiry_mac_address** tuple argument:  Forwarding vlan

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.switchport.port_security.port_secutiry_mac_address', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'port_secutiry_mac_address', 'keyval': 'mac_address, port_sec_vlan', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, port_secutiry_mac_address=port_secutiry_mac_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, port_secutiry_mac_address=port_secutiry_mac_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_switchport_port_security_shutdown_time_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.switchport.port_security', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'shutdown-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_switchport_port_security_sticky_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.switchport.port_security.sticky', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_switchport_port_security_sticky_port_secutiry_mac_address_delete(self, ethernet=None, port_secutiry_mac_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type port_secutiry_mac_address: mac_address, port_sec_vlan
    :param port_secutiry_mac_address: Keyword argument tuple.

    :type mac_address: unicode
    :param mac_address: **port_secutiry_mac_address** tuple argument:  Mac Address

        * pattern restriction: ::

            '[0-9a-fA-F]{4}(\.[0-9a-fA-F]{4}){2}'

    :type port_sec_vlan: long
    :param port_sec_vlan: **port_secutiry_mac_address** tuple argument:  Forwarding vlan

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.switchport.port_security.sticky.port_secutiry_mac_address', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'port_secutiry_mac_address', 'keyval': 'mac_address, port_sec_vlan', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, port_secutiry_mac_address=port_secutiry_mac_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, port_secutiry_mac_address=port_secutiry_mac_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_switchport_port_security_sticky_sticky_flag_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.switchport.port_security.sticky', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'sticky-flag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_switchport_port_security_violation_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.switchport.port_security', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'violation'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_switchport_trunk_allowed_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.switchport.trunk.allowed', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_switchport_trunk_allowed_rspan_vlan_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.switchport.trunk.allowed.rspan_vlan', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_switchport_trunk_allowed_rspan_vlan_add_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.switchport.trunk.allowed.rspan_vlan', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'add'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_switchport_trunk_allowed_rspan_vlan_remove_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.switchport.trunk.allowed.rspan_vlan', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'remove'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_switchport_trunk_allowed_trunk_rspan_vlan_classification_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_switchport_trunk_allowed_trunk_rspan_vlan_classification_rspan_vlan_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_switchport_trunk_allowed_trunk_rspan_vlan_classification_rspan_vlan_add_delete(self, ethernet=None, add=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type add: trunk_vlan_id, trunk_ctag_id
    :param add: Keyword argument tuple.

    :type trunk_vlan_id: long
    :param trunk_vlan_id: **add** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type trunk_ctag_id: long
    :param trunk_ctag_id: **add** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan.add_', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'add', 'keyval': 'trunk_vlan_id, trunk_ctag_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, add=add)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, add=add)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_switchport_trunk_allowed_trunk_rspan_vlan_classification_rspan_vlan_remove_delete(self, ethernet=None, remove=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type remove: trunk_vlan_id, trunk_ctag_id
    :param remove: Keyword argument tuple.

    :type trunk_vlan_id: long
    :param trunk_vlan_id: **remove** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type trunk_ctag_id: long
    :param trunk_ctag_id: **remove** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan.remove_', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'remove', 'keyval': 'trunk_vlan_id, trunk_ctag_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, remove=remove)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, remove=remove)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_switchport_trunk_allowed_vlan_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.switchport.trunk.allowed.vlan', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_switchport_trunk_allowed_vlan_add_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.switchport.trunk.allowed.vlan', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'add'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_switchport_trunk_allowed_vlan_all_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.switchport.trunk.allowed.vlan', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'all'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_switchport_trunk_allowed_vlan_except_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.switchport.trunk.allowed.vlan', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'except'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_switchport_trunk_allowed_vlan_none_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.switchport.trunk.allowed.vlan', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'none'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_switchport_trunk_allowed_vlan_remove_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.switchport.trunk.allowed.vlan', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'remove'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_switchport_trunk_allowed_vlanoper_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.switchport.trunk.allowed.vlanoper', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_switchport_trunk_allowed_vlanoper_vlan_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.switchport.trunk.allowed.vlanoper.vlan', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_switchport_trunk_allowed_vlanoper_vlan_add_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.switchport.trunk.allowed.vlanoper.vlan', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'add'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_switchport_trunk_allowed_vlanoper_vlan_remove_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.switchport.trunk.allowed.vlanoper.vlan', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'remove'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_switchport_trunk_ctag_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.switchport.trunk.native_vlan_classification', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ctag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_switchport_trunk_ctag_native_vlan_xtagged_config_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.switchport.trunk.native_vlan_xtagged_config', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ctag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_switchport_trunk_default_vlan_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.switchport.trunk.default_vlan_config', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'default-vlan'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_switchport_trunk_default_vlan_config_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.switchport.trunk.default_vlan_config', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'default_transparent_vlan'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_switchport_trunk_egress_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.switchport.trunk.native_vlan_xtagged_config', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'egress'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_switchport_trunk_native_vlan_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.switchport.trunk.native_vlan_classification', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'native-vlan'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_switchport_trunk_native_vlan_classification_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.switchport.trunk.native_vlan_classification', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'native_vlan_id, native_vlan_ctag_id'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_switchport_trunk_native_vlan_untagged_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.switchport.trunk.native_vlan_untagged_config', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'native-vlan-untagged'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_switchport_trunk_native_vlan_untagged_config_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.switchport.trunk.native_vlan_untagged_config', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'native_vlan_id_untagged'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_switchport_trunk_native_vlan_xtagged_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.switchport.trunk.native_vlan_xtagged_config', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'native-vlan-xtagged'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_switchport_trunk_native_vlan_xtagged_config_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.switchport.trunk.native_vlan_xtagged_config', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_switchport_trunk_tag_native_vlan_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.switchport.trunk.tag', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'native-vlan'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_switchport_trunk_trunk_vlan_classification_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.switchport.trunk.trunk_vlan_classification', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_switchport_trunk_trunk_vlan_classification_allowed_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.switchport.trunk.trunk_vlan_classification.allowed', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_switchport_trunk_trunk_vlan_classification_allowed_vlan_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_switchport_trunk_trunk_vlan_classification_allowed_vlan_add_delete(self, ethernet=None, add=None, trunk_ctag_range=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type add: trunk_vlan_id
    :param add: Keyword argument tuple.

    :type trunk_vlan_id: long
    :param trunk_vlan_id: **add** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Argument(s)**:

    :type trunk_ctag_range: unicode
    :param trunk_ctag_range: Keyword argument.

        * length restriction: ::

            ['1..1000']

        * pattern restriction: ::

            '(([1-9][0-9]{0,2})|([1-3][0-9]{3})|(40[0-8][0-9]'
            ')|(409[0-4]))(-((1[0-9]{1,2})|([2-9][0-9]{0,2})|'
            '([1-3][0-9]{3})|(40[0-8][0-9])|(409[0-4])))?((,('
            '(1[0-9]{1,2})|([2-9][0-9]{0,2})|([1-3][0-9]{3})|'
            '(40[0-8][0-9])|(409[0-4]))(-((1[0-9]{1,2})|([2-9'
            '][0-9]{0,2})|([1-3][0-9]{3})|(40[0-8][0-9])|(409'
            '[0-4])))?)?)*'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan.add_', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'add', 'keyval': 'trunk_vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, add=add, trunk_ctag_range=trunk_ctag_range)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, add=add, trunk_ctag_range=trunk_ctag_range)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_switchport_trunk_trunk_vlan_classification_allowed_vlan_add_ctag_delete(self, ethernet=None, add=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type add: trunk_vlan_id
    :param add: Keyword argument tuple.

    :type trunk_vlan_id: long
    :param trunk_vlan_id: **add** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan.add_', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'add', 'keyval': 'trunk_vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ctag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, add=add)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, add=add)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_switchport_trunk_trunk_vlan_classification_allowed_vlan_remove_delete(self, ethernet=None, remove=None, trunk_ctag_range=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type remove: trunk_vlan_id
    :param remove: Keyword argument tuple.

    :type trunk_vlan_id: long
    :param trunk_vlan_id: **remove** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Argument(s)**:

    :type trunk_ctag_range: unicode
    :param trunk_ctag_range: Keyword argument.

        * length restriction: ::

            ['1..1000']

        * pattern restriction: ::

            '(([1-9][0-9]{0,2})|([1-3][0-9]{3})|(40[0-8][0-9]'
            ')|(409[0-4]))(-((1[0-9]{1,2})|([2-9][0-9]{0,2})|'
            '([1-3][0-9]{3})|(40[0-8][0-9])|(409[0-4])))?((,('
            '(1[0-9]{1,2})|([2-9][0-9]{0,2})|([1-3][0-9]{3})|'
            '(40[0-8][0-9])|(409[0-4]))(-((1[0-9]{1,2})|([2-9'
            '][0-9]{0,2})|([1-3][0-9]{3})|(40[0-8][0-9])|(409'
            '[0-4])))?)?)*'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan.remove_', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'remove', 'keyval': 'trunk_vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, remove=remove, trunk_ctag_range=trunk_ctag_range)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, remove=remove, trunk_ctag_range=trunk_ctag_range)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_switchport_trunk_trunk_vlan_classification_allowed_vlan_remove_ctag_delete(self, ethernet=None, remove=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type remove: trunk_vlan_id
    :param remove: Keyword argument tuple.

    :type trunk_vlan_id: long
    :param trunk_vlan_id: **remove** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan.remove_', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'remove', 'keyval': 'trunk_vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ctag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, remove=remove)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, remove=remove)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_track_enable_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.track', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_track_interface_delete(self, ethernet=None, interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type interface: track_interface_type, track_interface_name
    :param interface: Keyword argument tuple.

    :type track_interface_type: unicode
    :param track_interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 'port-channel']

    :type track_interface_name: unicode
    :param track_interface_name: **interface** tuple argument:  Interface name

        * pattern restriction: ::

            '(((([1-9]|[1-9][0-9]|1[0-9]{2}|2[0-3][0-9])/)?(('
            '[0-9]|1[0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0-9]'
            ')(:[1-4])?)|([1-9]|[1-9][0-9]|[1-9][0-9]{2}|[1-5'
            '][0-9]{3}|6[0-1][0-4]{2}))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.track.interface', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'track_interface_type, track_interface_name', 'extra_keyval': 'track_interface_type, track_interface_name'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, interface=interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_track_min_link_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.track', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'min-link'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_track_remove_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.track.remove_', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_track_remove_all_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.track.remove_', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'all'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_udld_enable_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.udld', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_vepa_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.vepa', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_vepa_enable_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.vepa', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_vrf_forwarding_delete(self, ethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.vrf', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'forwarding'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_vrrp_group_delete(self, ethernet=None, vrrp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.vrrp', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrp=vrrp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_vrrp_group_advertisement_interval_delete(self, ethernet=None, vrrp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.vrrp', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'advertisement-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrp=vrrp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_vrrp_group_arp_unicast_request_receive_delete(self, ethernet=None, vrrp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet'), ('pybind.slxos.v16r_1_00b.interface.ethernet.vrrp', u'vrrp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.vrrp.arp.unicast_request', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'receive'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrp=vrrp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_vrrp_group_description_delete(self, ethernet=None, vrrp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.vrrp', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'description'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrp=vrrp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_vrrp_group_enable_delete(self, ethernet=None, vrrp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.vrrp', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrp=vrrp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_vrrp_group_hold_time_delete(self, ethernet=None, vrrp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.vrrp', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hold-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrp=vrrp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_vrrp_group_preempt_mode_delete(self, ethernet=None, vrrp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.vrrp', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'preempt-mode'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrp=vrrp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_vrrp_group_priority_delete(self, ethernet=None, vrrp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.vrrp', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrp=vrrp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_vrrp_group_track_interface_delete(self, ethernet=None, vrrp=None, interface=None, track_priority=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Argument(s)**:

    :type track_priority: int
    :param track_priority: Track Priority

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet'), ('pybind.slxos.v16r_1_00b.interface.ethernet.vrrp', u'vrrp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.vrrp.track.interface', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrp=vrrp, interface=interface, track_priority=track_priority)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrp=vrrp, interface=interface, track_priority=track_priority)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_vrrp_group_track_interface_priority_delete(self, ethernet=None, vrrp=None, interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet'), ('pybind.slxos.v16r_1_00b.interface.ethernet.vrrp', u'vrrp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.vrrp.track.interface', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrp=vrrp, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrp=vrrp, interface=interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_vrrp_group_use_v2_checksum_delete(self, ethernet=None, vrrp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.vrrp', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'use-v2-checksum'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrp=vrrp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ethernet_vrrp_group_virtual_ip_delete(self, ethernet=None, vrrp=None, virtual_ip=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type virtual_ip: virtual_ipaddr
    :param virtual_ip: Keyword argument tuple.

    :type virtual_ipaddr: unicode
    :param virtual_ipaddr: **virtual_ip** tuple argument:  Virtual IPv4 address in dotted decimal

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.ethernet', u'ethernet'), ('pybind.slxos.v16r_1_00b.interface.ethernet.vrrp', u'vrrp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.ethernet.vrrp.virtual_ip', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'virtual_ip', 'keyval': 'virtual_ipaddr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrp=vrrp, virtual_ip=virtual_ip)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrp=vrrp, virtual_ip=virtual_ip)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fcoe_delete(self, fcoe=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Instance Keyword Argument Tuple**:

    :type fcoe: fcoe_interface_name
    :param fcoe: Keyword argument tuple.

    :type fcoe_interface_name: unicode
    :param fcoe_interface_name: **fcoe** tuple argument.

        * length restriction: ::

            ['3..32']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.interface.fcoe', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fcoe', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fcoe', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'fcoe', 'keyval': 'fcoe_interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fcoe=fcoe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fcoe=fcoe)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fcoe_bind_delete(self, fcoe=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fcoe: fcoe_interface_name
    :param fcoe: Keyword argument tuple.

    :type fcoe_interface_name: unicode
    :param fcoe_interface_name: **fcoe** tuple argument.

        * length restriction: ::

            ['3..32']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fcoe', u'fcoe'), ('pybind.nos.v6_0_2c.interface.fcoe', u'fcoe'), ('pybind.nos.v7_0_1b.interface.fcoe', u'fcoe')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fcoe.fcoe_interface_bind', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fcoe.fcoe_interface_bind', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fcoe.fcoe_interface_bind', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'fcoe_interface_name', 'extra_keyval': ''}, {'keyval': 'fcoe_interface_name', 'extra_keyval': ''}, {'keyval': 'fcoe_interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'fcoe_interface_bind_te, fcoe_interface_bind_fo, fcoe_interface_bind_po, fcoe_interface_bind_mac, fcoe_interface_bind_hu, fcoe_interface_bind_name'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v6_0_2c.interface.fcoe.fcoe_interface_bind': [u'fcoe_interface_bind_mac', u'fcoe_interface_bind_te', u'fcoe_interface_bind_po', u'fcoe_interface_bind_fo', u'fcoe_interface_bind_hu'], 'pybind.nos.v7_1_0.interface.fcoe.fcoe_interface_bind': [u'fcoe_interface_bind_mac', u'fcoe_interface_bind_te', u'fcoe_interface_bind_po', u'fcoe_interface_bind_fo', u'fcoe_interface_bind_hu'], 'pybind.nos.v7_0_1b.interface.fcoe.fcoe_interface_bind': [u'fcoe_interface_bind_mac', u'fcoe_interface_bind_te', u'fcoe_interface_bind_po', u'fcoe_interface_bind_fo', u'fcoe_interface_bind_hu']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fcoe=fcoe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fcoe=fcoe)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fcoe_bind_fcoe_interface_bind_name_delete(self, fcoe=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fcoe: fcoe_interface_name
    :param fcoe: Keyword argument tuple.

    :type fcoe_interface_name: unicode
    :param fcoe_interface_name: **fcoe** tuple argument.

        * length restriction: ::

            ['3..32']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fcoe', u'fcoe'), ('pybind.nos.v6_0_2c.interface.fcoe', u'fcoe'), ('pybind.nos.v7_0_1b.interface.fcoe', u'fcoe')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fcoe.fcoe_interface_bind', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fcoe.fcoe_interface_bind', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fcoe.fcoe_interface_bind', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'fcoe_interface_name', 'extra_keyval': ''}, {'keyval': 'fcoe_interface_name', 'extra_keyval': ''}, {'keyval': 'fcoe_interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'fcoe-interface-bind-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fcoe=fcoe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fcoe=fcoe)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fcoe_bind_fortygigabitethernet_delete(self, fcoe=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fcoe: fcoe_interface_name
    :param fcoe: Keyword argument tuple.

    :type fcoe_interface_name: unicode
    :param fcoe_interface_name: **fcoe** tuple argument.

        * length restriction: ::

            ['3..32']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fcoe', u'fcoe'), ('pybind.nos.v6_0_2c.interface.fcoe', u'fcoe'), ('pybind.nos.v7_0_1b.interface.fcoe', u'fcoe')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fcoe.fcoe_interface_bind', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fcoe.fcoe_interface_bind', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fcoe.fcoe_interface_bind', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'fcoe_interface_name', 'extra_keyval': ''}, {'keyval': 'fcoe_interface_name', 'extra_keyval': ''}, {'keyval': 'fcoe_interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'FortyGigabitEthernet'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fcoe=fcoe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fcoe=fcoe)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fcoe_bind_hundredgigabitethernet_delete(self, fcoe=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fcoe: fcoe_interface_name
    :param fcoe: Keyword argument tuple.

    :type fcoe_interface_name: unicode
    :param fcoe_interface_name: **fcoe** tuple argument.

        * length restriction: ::

            ['3..32']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fcoe', u'fcoe'), ('pybind.nos.v6_0_2c.interface.fcoe', u'fcoe'), ('pybind.nos.v7_0_1b.interface.fcoe', u'fcoe')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fcoe.fcoe_interface_bind', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fcoe.fcoe_interface_bind', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fcoe.fcoe_interface_bind', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'fcoe_interface_name', 'extra_keyval': ''}, {'keyval': 'fcoe_interface_name', 'extra_keyval': ''}, {'keyval': 'fcoe_interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'HundredGigabitEthernet'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fcoe=fcoe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fcoe=fcoe)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fcoe_bind_mac_address_delete(self, fcoe=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fcoe: fcoe_interface_name
    :param fcoe: Keyword argument tuple.

    :type fcoe_interface_name: unicode
    :param fcoe_interface_name: **fcoe** tuple argument.

        * length restriction: ::

            ['3..32']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fcoe', u'fcoe'), ('pybind.nos.v6_0_2c.interface.fcoe', u'fcoe'), ('pybind.nos.v7_0_1b.interface.fcoe', u'fcoe')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fcoe.fcoe_interface_bind', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fcoe.fcoe_interface_bind', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fcoe.fcoe_interface_bind', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'fcoe_interface_name', 'extra_keyval': ''}, {'keyval': 'fcoe_interface_name', 'extra_keyval': ''}, {'keyval': 'fcoe_interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mac-address'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fcoe=fcoe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fcoe=fcoe)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fcoe_bind_port_channel_delete(self, fcoe=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fcoe: fcoe_interface_name
    :param fcoe: Keyword argument tuple.

    :type fcoe_interface_name: unicode
    :param fcoe_interface_name: **fcoe** tuple argument.

        * length restriction: ::

            ['3..32']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fcoe', u'fcoe'), ('pybind.nos.v6_0_2c.interface.fcoe', u'fcoe'), ('pybind.nos.v7_0_1b.interface.fcoe', u'fcoe')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fcoe.fcoe_interface_bind', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fcoe.fcoe_interface_bind', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fcoe.fcoe_interface_bind', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'fcoe_interface_name', 'extra_keyval': ''}, {'keyval': 'fcoe_interface_name', 'extra_keyval': ''}, {'keyval': 'fcoe_interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'Port-channel'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fcoe=fcoe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fcoe=fcoe)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fcoe_bind_tengigabitethernet_delete(self, fcoe=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fcoe: fcoe_interface_name
    :param fcoe: Keyword argument tuple.

    :type fcoe_interface_name: unicode
    :param fcoe_interface_name: **fcoe** tuple argument.

        * length restriction: ::

            ['3..32']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fcoe', u'fcoe'), ('pybind.nos.v6_0_2c.interface.fcoe', u'fcoe'), ('pybind.nos.v7_0_1b.interface.fcoe', u'fcoe')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fcoe.fcoe_interface_bind', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fcoe.fcoe_interface_bind', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fcoe.fcoe_interface_bind', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'fcoe_interface_name', 'extra_keyval': ''}, {'keyval': 'fcoe_interface_name', 'extra_keyval': ''}, {'keyval': 'fcoe_interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'TenGigabitEthernet'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fcoe=fcoe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fcoe=fcoe)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fcoe_shutdown_delete(self, fcoe=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Instance Keyword Argument Tuple**:

    :type fcoe: fcoe_interface_name
    :param fcoe: Keyword argument tuple.

    :type fcoe_interface_name: unicode
    :param fcoe_interface_name: **fcoe** tuple argument.

        * length restriction: ::

            ['3..32']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.interface.fcoe', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fcoe', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fcoe', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'fcoe', 'keyval': 'fcoe_interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'shutdown'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fcoe=fcoe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fcoe=fcoe)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_bfd_interval_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.bfd.interval', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.bfd.interval', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.bfd.interval', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_bfd_interval_min_rx_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.bfd.interval', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.bfd.interval', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.bfd.interval', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'min-rx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_bfd_interval_min_tx_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.bfd.interval', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.bfd.interval', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.bfd.interval', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'min-tx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_bfd_interval_multiplier_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.bfd.interval', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.bfd.interval', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.bfd.interval', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'multiplier'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_bfd_shutdown_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.bfd', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.bfd', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.bfd', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'shutdown'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_bpdu_drop_direction_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.bpdu_drop', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.bpdu_drop', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.bpdu_drop', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'direction'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_bpdu_drop_enable_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.bpdu_drop', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.bpdu_drop', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.bpdu_drop', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_cee_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Instance Keyword Argument Tuple**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'fortygigabitethernet', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cee'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_channel_group_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.channel_group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.channel_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.channel_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'port_int, mode, type'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_channel_group_mode_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.channel_group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.channel_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.channel_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mode'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_channel_group_port_int_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.channel_group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.channel_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.channel_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'port-int'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_channel_group_type_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.channel_group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.channel_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.channel_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_description_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Instance Keyword Argument Tuple**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'fortygigabitethernet', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'description'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_deviceconnectivity_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.connectivity', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.connectivity', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.connectivity', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'deviceconnectivity'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_dot1x_authentication_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.dot1x', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.dot1x', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.dot1x', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'authentication'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_dot1x_mac_auth_bypass_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet.dot1x', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mac-auth-bypass'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_dot1x_mac_auth_enable_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet.dot1x', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mac-auth-enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_dot1x_port_control_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.dot1x', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.dot1x', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.dot1x', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'port-control'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_dot1x_protocol_version_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.dot1x', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.dot1x', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.dot1x', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'protocol-version'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_dot1x_quiet_period_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.dot1x', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.dot1x', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.dot1x', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'quiet-period'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_dot1x_reauthentication_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.dot1x', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.dot1x', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.dot1x', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'reauthentication'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_dot1x_reauthmax_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.dot1x', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.dot1x', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.dot1x', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'reauthMax'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_dot1x_timeout_re_authperiod_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.dot1x.timeout', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.dot1x.timeout', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.dot1x.timeout', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 're-authperiod'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_dot1x_timeout_server_timeout_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.dot1x.timeout', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.dot1x.timeout', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.dot1x.timeout', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'server-timeout'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_dot1x_timeout_supp_timeout_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.dot1x.timeout', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.dot1x.timeout', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.dot1x.timeout', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'supp-timeout'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_dot1x_timeout_tx_period_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.dot1x.timeout', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.dot1x.timeout', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.dot1x.timeout', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tx-period'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_edge_loop_detection_port_priority_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.edge_loop_detection', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.edge_loop_detection', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.edge_loop_detection', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'port-priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_edge_loop_detection_vlan_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.edge_loop_detection', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.edge_loop_detection', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.edge_loop_detection', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vlan'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_fabric_dport_enable_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.fabric.fabric_dport', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_fabric_dport_mode_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet.fabric.fabric_dport', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.fabric.fabric_dport', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mode'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_fabric_isl_enable_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.fabric.fabric_isl', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.fabric.fabric_isl', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.fabric.fabric_isl', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_fabric_neighbor_discovery_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.fabric.neighbor_discovery', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.fabric.neighbor_discovery', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.fabric.neighbor_discovery', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_fabric_neighbor_discovery_disable_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.fabric.neighbor_discovery', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.fabric.neighbor_discovery', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.fabric.neighbor_discovery', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'disable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_fabric_trunk_enable_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.fabric.fabric_trunk', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.fabric.fabric_trunk', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.fabric.fabric_trunk', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_fcoeport_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.fcoeport', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.fcoeport', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.fcoeport', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'fcoeport_map, ns_ip_registration'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_fcoeport_map_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.fcoeport', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.fcoeport', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.fcoeport', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_fcoeport_ns_ip_registration_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.fcoeport', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.fcoeport', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.fcoeport', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ns-ip-registration'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ifindex_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Instance Keyword Argument Tuple**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'fortygigabitethernet', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ifindex'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ip_access_group_delete(self, fortygigabitethernet=None, access_group=None, traffic_type=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type access_group: ip_access_list, ip_direction, traffic_type
    :param access_group: Keyword argument tuple.

    :type ip_access_list: unicode
    :param ip_access_list: **access_group** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type ip_direction: unicode
    :param ip_direction: **access_group** tuple argument.

        * enumeration restriction: ::

            ['in', 'out']

    :type traffic_type: unicode
    :param traffic_type: **access_group** tuple argument.

        * enumeration restriction: ::

            ['switched', 'routed']

    **Instance Argument(s)**:

    :type traffic_type: unicode
    :param traffic_type: Keyword argument.

        * enumeration restriction: ::

            ['switched', 'routed']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ip_acl_interface.ip.access_group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ip_acl_interface.ip.access_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ip_acl_interface.ip.access_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'access_group', 'keyval': 'ip_access_list, ip_direction', 'extra_keyval': 'ip_access_list, ip_direction, traffic_type'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, access_group=access_group, traffic_type=traffic_type)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, access_group=access_group, traffic_type=traffic_type)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ip_acl_interface_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ip_acl_interface', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ip_acl_interface', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ip_acl_interface', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ip_address_delete(self, fortygigabitethernet=None, address=None, secondary=None, ospf_passive=None, ospf_ignore=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type address: address, secondary, ospf_passive, ospf_ignore
    :param address: Keyword argument tuple.

    :type address: unicode
    :param address: **address** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]'
            '|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0'
            '-4][0-9]|25[0-5])/(([1-9])|([1-2][0-9])|(3[0-1])'
            ')'

    :type secondary: YANGBool
    :param secondary: **address** tuple argument:  Secondary ip address on the specific interface

    :type ospf_passive: YANGBool
    :param ospf_passive: **address** tuple argument:  ospf pasive address on the specific interface

    :type ospf_ignore: YANGBool
    :param ospf_ignore: **address** tuple argument:  ospf active address on the specific interface

    **Instance Argument(s)**:

    :type secondary: YANGBool
    :param secondary: Secondary ip address on the specific interface

    :type ospf_passive: YANGBool
    :param ospf_passive: ospf pasive address on the specific interface

    :type ospf_ignore: YANGBool
    :param ospf_ignore: ospf active address on the specific interface

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ip.ip_config.address', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ip.ip_config.address', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ip.ip_config.address', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'address', 'keyval': 'address', 'extra_keyval': 'address, secondary, ospf_passive, ospf_ignore'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, address=address, secondary=secondary, ospf_passive=ospf_passive, ospf_ignore=ospf_ignore)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, address=address, secondary=secondary, ospf_passive=ospf_passive, ospf_ignore=ospf_ignore)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ip_address_ospf_ignore_delete(self, fortygigabitethernet=None, address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type address: address
    :param address: Keyword argument tuple.

    :type address: unicode
    :param address: **address** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]'
            '|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0'
            '-4][0-9]|25[0-5])/(([1-9])|([1-2][0-9])|(3[0-1])'
            ')'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ip.ip_config.address', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ip.ip_config.address', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ip.ip_config.address', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'address', 'keyval': 'address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ospf-ignore'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, address=address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, address=address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ip_address_ospf_passive_delete(self, fortygigabitethernet=None, address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type address: address
    :param address: Keyword argument tuple.

    :type address: unicode
    :param address: **address** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]'
            '|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0'
            '-4][0-9]|25[0-5])/(([1-9])|([1-2][0-9])|(3[0-1])'
            ')'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ip.ip_config.address', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ip.ip_config.address', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ip.ip_config.address', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'address', 'keyval': 'address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ospf-passive'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, address=address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, address=address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ip_address_secondary_delete(self, fortygigabitethernet=None, address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type address: address
    :param address: Keyword argument tuple.

    :type address: unicode
    :param address: **address** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]'
            '|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0'
            '-4][0-9]|25[0-5])/(([1-9])|([1-2][0-9])|(3[0-1])'
            ')'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ip.ip_config.address', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ip.ip_config.address', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ip.ip_config.address', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'address', 'keyval': 'address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'secondary'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, address=address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, address=address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ip_arp_aging_timeout_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ip.ip_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ip.ip_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ip.ip_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'arp-aging-timeout'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ip_arp_inspection_trust_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ip.arp_node_config.arp.inspection', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ip.arp_node_config.arp.inspection', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ip.arp_node_config.arp.inspection', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'trust'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ip_arp_ip_config_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ip.ip_config.arp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ip.ip_config.arp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ip_arp_learn_any_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ip.ip_config.arp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ip.ip_config.arp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'learn-any'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ip_arp_node_config_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ip.arp_node_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ip.arp_node_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ip.arp_node_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ip_dhcp_relay_gateway_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ip.interface_fo_dhcp_conf.dhcp.relay', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ip.interface_fo_dhcp_conf.dhcp.relay', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ip.interface_fo_dhcp_conf.dhcp.relay', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'gateway'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ip_dhcp_relay_servers_delete(self, fortygigabitethernet=None, servers=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type servers: relay_ip_addr, server_vrf_name
    :param servers: Keyword argument tuple.

    :type relay_ip_addr: unicode
    :param relay_ip_addr: **servers** tuple argument:  A.B.C.D;; IP address of the DHCP server

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type server_vrf_name: unicode
    :param server_vrf_name: **servers** tuple argument:  VRF name of the DHCP server

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ip.interface_fo_dhcp_conf.dhcp.relay.servers', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ip.interface_fo_dhcp_conf.dhcp.relay.servers', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ip.interface_fo_dhcp_conf.dhcp.relay.servers', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'servers', 'keyval': 'relay_ip_addr, server_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, servers=servers)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, servers=servers)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ip_directed_broadcast_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ip.ip_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ip.ip_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ip.ip_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'directed-broadcast'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ip_icmp_address_mask_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ip.icmp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ip.icmp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ip.icmp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'address-mask'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ip_icmp_echo_reply_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ip.icmp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ip.icmp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ip.icmp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'echo-reply'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ip_icmp_rate_limiting_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ip.icmp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ip.icmp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ip.icmp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rate-limiting'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ip_icmp_redirect_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ip.icmp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ip.icmp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ip.icmp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redirect'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ip_icmp_unreachable_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ip.icmp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ip.icmp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ip.icmp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'unreachable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ip_igmp_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v7_0_1b.interface.fortygigabitethernet.ip.igmp_phy_intf_cfg.igmp": {}, "pybind.nos.v6_0_2c.interface.fortygigabitethernet.ip.igmp_phy_intf_cfg.igmp": {"immediate_leave": "immediate_leave", "last_member_query_interval": "last_member_query_interval", "query_interval": "query_interval", "query_max_response_time": "query_max_response_time"}, "pybind.nos.v7_1_0.interface.fortygigabitethernet.ip.igmp_phy_intf_cfg.igmp": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ip_igmp_immediate_leave_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'immediate-leave'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ip_igmp_last_member_query_count_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'last-member-query-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ip_igmp_last_member_query_interval_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'last-member-query-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ip_igmp_phy_intf_cfg_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ip.igmp_phy_intf_cfg', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ip.igmp_phy_intf_cfg', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ip.igmp_phy_intf_cfg', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ip_igmp_query_interval_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'query-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ip_igmp_query_max_response_time_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'query-max-response-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ip_igmp_robustness_variable_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'robustness-variable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ip_igmp_startup_query_count_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'startup-query-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ip_igmp_startup_query_interval_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'startup-query-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ip_igmp_static_group_delete(self, fortygigabitethernet=None, static_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type static_group: sg_addr
    :param static_group: Keyword argument tuple.

    :type sg_addr: unicode
    :param sg_addr: **static_group** tuple argument:  Multicast Address to be Joined in the format A.B.C.D

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ip.igmp_phy_intf_cfg.igmp.static_group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ip.igmp_phy_intf_cfg.igmp.static_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ip.igmp_phy_intf_cfg.igmp.static_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'static_group', 'keyval': 'sg_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, static_group=static_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, static_group=static_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ip_interface_fo_dhcp_conf_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ip.interface_fo_dhcp_conf', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ip.interface_fo_dhcp_conf', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ip.interface_fo_dhcp_conf', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ip_interface_fo_ospf_conf_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ip.interface_fo_ospf_conf', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ip.interface_fo_ospf_conf', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ip_ip_config_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ip.ip_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ip.ip_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ip.ip_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ip_mtu_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ip.ip_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ip.ip_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ip.ip_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mtu'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ip_multicast_boundary_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'multicast-boundary'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ip_ospf_active_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'active'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ip_ospf_area_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'area'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ip_ospf_auth_change_wait_time_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'auth-change-wait-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ip_ospf_authentication_key_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ip_ospf_authentication_key_auth_key_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key.auth_key_table', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key.auth_key_table', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key.auth_key_table', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'auth-key'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ip_ospf_authentication_key_auth_key_table_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key.auth_key_table', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key.auth_key_table', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key.auth_key_table', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'encrypttype, auth_key'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ip_ospf_authentication_key_encrypttype_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key.auth_key_table', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key.auth_key_table', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key.auth_key_table', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'encrypttype'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ip_ospf_authentication_key_no_encrypt_auth_key_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key.no_encrypt_auth_key_table', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key.no_encrypt_auth_key_table', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key.no_encrypt_auth_key_table', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'no-encrypt-auth-key'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ip_ospf_authentication_key_no_encrypt_auth_key_table_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key.no_encrypt_auth_key_table', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key.no_encrypt_auth_key_table', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key.no_encrypt_auth_key_table', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ip_ospf_bfd_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.bfd', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.bfd', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.bfd', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ip_ospf_bfd_intf_bfd_enable_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.bfd', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.bfd', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.bfd', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'intf-bfd-enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ip_ospf_cost_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cost'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ip_ospf_database_filter_all_external_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'all-external'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ip_ospf_database_filter_all_out_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'all-out'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ip_ospf_database_filter_all_summary_external_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'all-summary-external'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ip_ospf_dead_interval_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dead-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ip_ospf_hello_interval_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hello-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ip_ospf_md5_authentication_key_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication.no_encrypt_key_table', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication.no_encrypt_key_table', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication.no_encrypt_key_table', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'key'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ip_ospf_md5_authentication_key_activation_wait_time_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'key-activation-wait-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ip_ospf_md5_authentication_key_id_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication.no_encrypt_key_table', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication.no_encrypt_key_table', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication.no_encrypt_key_table', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'key-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ip_ospf_md5_authentication_key_id_key_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication.key_table', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication.key_table', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication.key_table', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'key'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ip_ospf_md5_authentication_key_id_key_id_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication.key_table', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication.key_table', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication.key_table', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'key-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ip_ospf_md5_authentication_key_id_md5_authentication_key_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication.key_table', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication.key_table', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication.key_table', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'md5-authentication-key'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ip_ospf_mtu_ignore_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mtu-ignore'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ip_ospf_network_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'network'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ip_ospf_passive_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'passive'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ip_ospf_priority_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ip_ospf_retransmit_interval_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'retransmit-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ip_ospf_transmit_delay_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'transmit-delay'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ip_pbr_interface_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ip_pbr_interface', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ip_pbr_interface', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ip_pbr_interface', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ip_pim_dr_priority_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd.pim', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd.pim', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd.pim', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dr-priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ip_pim_int_cmd_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ip_pim_intf_phy_cont_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ip.pim_intf_phy_cont', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ip.pim_intf_phy_cont', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ip.pim_intf_phy_cont', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ip_pim_multinet_enable_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd.pim.multinet', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ip_pim_neighbor_filter_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd.pim', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd.pim', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd.pim', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'neighbor-filter'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ip_pim_sparse_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'pim-sparse'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ip_policy_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ip_pbr_interface.ip.policy', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ip_pbr_interface.ip.policy', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ip_pbr_interface.ip.policy', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ip_policy_route_map_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ip_pbr_interface.ip.policy.route_map', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ip_pbr_interface.ip.policy.route_map', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ip_pbr_interface.ip.policy.route_map', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ip_policy_route_map_route_map_name_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ip_pbr_interface.ip.policy.route_map', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ip_pbr_interface.ip.policy.route_map', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ip_pbr_interface.ip.policy.route_map', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ip_proxy_arp_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ip.ip_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ip.ip_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ip.ip_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'proxy-arp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ip_unnumbered_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ip.ip_config.unnumbered', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ip.ip_config.unnumbered', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'ip_donor_interface_type, ip_donor_interface_name'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ip_unnumbered_ip_donor_interface_name_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ip.ip_config.unnumbered', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ip.ip_config.unnumbered', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ip-donor-interface-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ip_unnumbered_ip_donor_interface_type_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ip.ip_config.unnumbered', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ip.ip_config.unnumbered', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ip-donor-interface-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_access_group_delete(self, fortygigabitethernet=None, access_group=None, traffic_type=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type access_group: ipv6_access_list, ip_direction, traffic_type
    :param access_group: Keyword argument tuple.

    :type ipv6_access_list: unicode
    :param ipv6_access_list: **access_group** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type ip_direction: unicode
    :param ip_direction: **access_group** tuple argument.

        * enumeration restriction: ::

            ['in', 'out']

    :type traffic_type: unicode
    :param traffic_type: **access_group** tuple argument.

        * enumeration restriction: ::

            ['switched', 'routed']

    **Instance Argument(s)**:

    :type traffic_type: unicode
    :param traffic_type: Keyword argument.

        * enumeration restriction: ::

            ['switched', 'routed']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.access_group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.access_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.access_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'access_group', 'keyval': 'ipv6_access_list, ip_direction', 'extra_keyval': 'ipv6_access_list, ip_direction, traffic_type'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, access_group=access_group, traffic_type=traffic_type)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, access_group=access_group, traffic_type=traffic_type)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_access_group_traffic_type_delete(self, fortygigabitethernet=None, access_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type access_group: ipv6_access_list, ip_direction
    :param access_group: Keyword argument tuple.

    :type ipv6_access_list: unicode
    :param ipv6_access_list: **access_group** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type ip_direction: unicode
    :param ip_direction: **access_group** tuple argument.

        * enumeration restriction: ::

            ['in', 'out']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.access_group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.access_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.access_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'access_group', 'keyval': 'ipv6_access_list, ip_direction', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'traffic-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, access_group=access_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, access_group=access_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_address_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.ipv6_config.address', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.ipv6_config.address', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.ipv6_config.address', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_address_ipv6_address_delete(self, fortygigabitethernet=None, ipv6_address=None, secondary=None, anycast=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ipv6_address: address, secondary, anycast
    :param ipv6_address: Keyword argument tuple.

    :type address: unicode
    :param address: **ipv6_address** tuple argument:  A:B::C:D/LEN;; IPv6 prefix format: xxxx:xxxx/ml, xxxx:xxxx::/ml, xxxx::xx/128

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type secondary: YANGBool
    :param secondary: **ipv6_address** tuple argument:  Configure Secondary ipv6 address on an interface

    :type anycast: YANGBool
    :param anycast: **ipv6_address** tuple argument:  Configure ipv6 address as anycast

    **Instance Argument(s)**:

    :type secondary: YANGBool
    :param secondary: Configure Secondary ipv6 address on an interface

    :type anycast: YANGBool
    :param anycast: Configure ipv6 address as anycast

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_address', 'keyval': 'address', 'extra_keyval': 'address, secondary, anycast'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, ipv6_address=ipv6_address, secondary=secondary, anycast=anycast)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, ipv6_address=ipv6_address, secondary=secondary, anycast=anycast)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_address_ipv6_address_anycast_delete(self, fortygigabitethernet=None, ipv6_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ipv6_address: address
    :param ipv6_address: Keyword argument tuple.

    :type address: unicode
    :param address: **ipv6_address** tuple argument:  A:B::C:D/LEN;; IPv6 prefix format: xxxx:xxxx/ml, xxxx:xxxx::/ml, xxxx::xx/128

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_address', 'keyval': 'address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'anycast'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, ipv6_address=ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, ipv6_address=ipv6_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_address_ipv6_address_eui_64_delete(self, fortygigabitethernet=None, ipv6_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type ipv6_address: address, secondary, anycast
    :param ipv6_address: Keyword argument tuple.

    :type address: unicode
    :param address: **ipv6_address** tuple argument:  A:B::C:D/LEN;; IPv6 prefix format: xxxx:xxxx/ml, xxxx:xxxx::/ml, xxxx::xx/128

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type secondary: YANGBool
    :param secondary: **ipv6_address** tuple argument:  Configure Secondary ipv6 address on an interface

    :type anycast: YANGBool
    :param anycast: **ipv6_address** tuple argument:  Configure ipv6 address as anycast

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.ipv6_config.address.ipv6_address', u'ipv6_address'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.ipv6_config.address.ipv6_address', u'ipv6_address'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.ipv6_config.address.ipv6_address', u'ipv6_address')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.ipv6_config.address.ipv6_address.eui_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.ipv6_config.address.ipv6_address.eui_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.ipv6_config.address.ipv6_address.eui_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'address', 'extra_keyval': 'address, secondary, anycast'}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'address', 'extra_keyval': 'address, secondary, anycast'}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'address', 'extra_keyval': 'address, secondary, anycast'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'eui-64'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, ipv6_address=ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, ipv6_address=ipv6_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_address_ipv6_address_secondary_delete(self, fortygigabitethernet=None, ipv6_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ipv6_address: address
    :param ipv6_address: Keyword argument tuple.

    :type address: unicode
    :param address: **ipv6_address** tuple argument:  A:B::C:D/LEN;; IPv6 prefix format: xxxx:xxxx/ml, xxxx:xxxx::/ml, xxxx::xx/128

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_address', 'keyval': 'address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'secondary'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, ipv6_address=ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, ipv6_address=ipv6_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_address_ipv6_address_secondary_eui_config_delete(self, fortygigabitethernet=None, ipv6_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type ipv6_address: address, secondary, anycast
    :param ipv6_address: Keyword argument tuple.

    :type address: unicode
    :param address: **ipv6_address** tuple argument:  A:B::C:D/LEN;; IPv6 prefix format: xxxx:xxxx/ml, xxxx:xxxx::/ml, xxxx::xx/128

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type secondary: YANGBool
    :param secondary: **ipv6_address** tuple argument:  Configure Secondary ipv6 address on an interface

    :type anycast: YANGBool
    :param anycast: **ipv6_address** tuple argument:  Configure ipv6 address as anycast

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.ipv6_config.address.ipv6_address', u'ipv6_address'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.ipv6_config.address.ipv6_address', u'ipv6_address'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.ipv6_config.address.ipv6_address', u'ipv6_address')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.ipv6_config.address.ipv6_address.eui_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.ipv6_config.address.ipv6_address.eui_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.ipv6_config.address.ipv6_address.eui_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'address', 'extra_keyval': 'address, secondary, anycast'}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'address', 'extra_keyval': 'address, secondary, anycast'}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'address', 'extra_keyval': 'address, secondary, anycast'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'secondary'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, ipv6_address=ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, ipv6_address=ipv6_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_address_link_local_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'link-local'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_address_link_local_address_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'link-local-address'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_address_link_local_config_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'link_local_address, link_local'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_address_use_link_local_only_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.ipv6_config.address', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.ipv6_config.address', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.ipv6_config.address', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'use-link-local-only'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_dhcp_relay_servers_delete(self, fortygigabitethernet=None, servers=None, server_vrf_name=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type servers: relay_ip_addr, server_vrf_name
    :param servers: Keyword argument tuple.

    :type relay_ip_addr: unicode
    :param relay_ip_addr: **servers** tuple argument:  IPv6 address of the DHCPv6 server

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type server_vrf_name: unicode
    :param server_vrf_name: **servers** tuple argument:  VRF name of the DHCPv6 server

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Argument(s)**:

    :type server_vrf_name: unicode
    :param server_vrf_name: VRF name of the DHCPv6 server

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'servers', 'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, servers=servers, server_vrf_name=server_vrf_name)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, servers=servers, server_vrf_name=server_vrf_name)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_dhcp_relay_servers_interface_delete(self, fortygigabitethernet=None, servers=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type servers: relay_ip_addr, server_vrf_name
    :param servers: Keyword argument tuple.

    :type relay_ip_addr: unicode
    :param relay_ip_addr: **servers** tuple argument:  IPv6 address of the DHCPv6 server

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type server_vrf_name: unicode
    :param server_vrf_name: **servers** tuple argument:  VRF name of the DHCPv6 server

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', u'servers'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', u'servers'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', u'servers')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers.interface', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers.interface', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers.interface', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'interface_type, interface_name'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, servers=servers)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, servers=servers)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_dhcp_relay_servers_interface_interface_delete(self, fortygigabitethernet=None, servers=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type servers: relay_ip_addr, server_vrf_name
    :param servers: Keyword argument tuple.

    :type relay_ip_addr: unicode
    :param relay_ip_addr: **servers** tuple argument:  IPv6 address of the DHCPv6 server

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type server_vrf_name: unicode
    :param server_vrf_name: **servers** tuple argument:  VRF name of the DHCPv6 server

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', u'servers'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', u'servers'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', u'servers')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers.interface', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers.interface', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers.interface', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'interface'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, servers=servers)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, servers=servers)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_dhcp_relay_servers_interface_interface_name_delete(self, fortygigabitethernet=None, servers=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type servers: relay_ip_addr, server_vrf_name
    :param servers: Keyword argument tuple.

    :type relay_ip_addr: unicode
    :param relay_ip_addr: **servers** tuple argument:  IPv6 address of the DHCPv6 server

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type server_vrf_name: unicode
    :param server_vrf_name: **servers** tuple argument:  VRF name of the DHCPv6 server

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', u'servers'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', u'servers'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', u'servers')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers.interface', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers.interface', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers.interface', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'interface-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, servers=servers)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, servers=servers)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_dhcp_relay_servers_use_vrf_delete(self, fortygigabitethernet=None, servers=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type servers: relay_ip_addr
    :param servers: Keyword argument tuple.

    :type relay_ip_addr: unicode
    :param relay_ip_addr: **servers** tuple argument:  IPv6 address of the DHCPv6 server

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'servers', 'keyval': 'relay_ip_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'use-vrf'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, servers=servers)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, servers=servers)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_hop_by_hop_trap_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.ipv6_phy_intf_cmds', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.ipv6_phy_intf_cmds', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.ipv6_phy_intf_cmds', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hop-by-hop-trap'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_icmpv6_echo_reply_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.icmpv6', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.icmpv6', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.icmpv6', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'echo-reply'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_icmpv6_rate_limiting_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.icmpv6', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.icmpv6', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.icmpv6', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rate-limiting'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_icmpv6_redirect_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.icmpv6', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.icmpv6', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.icmpv6', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redirect'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_icmpv6_unreachable_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.icmpv6', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.icmpv6', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.icmpv6', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'unreachable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_interface_phy_dhcp_conf_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.interface_phy_dhcp_conf', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.interface_phy_dhcp_conf', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.interface_phy_dhcp_conf', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_ipv6_config_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.ipv6_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.ipv6_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.ipv6_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_ipv6_intf_cmds_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_ipv6_nd_ra_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.ipv6_nd_ra', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.ipv6_nd_ra', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_ipv6_phy_intf_cmds_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.ipv6_phy_intf_cmds', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.ipv6_phy_intf_cmds', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.ipv6_phy_intf_cmds', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_mtu_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.ipv6_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.ipv6_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.ipv6_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mtu'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_nd_broadcast_mac_trap_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'broadcast-mac-trap'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_nd_cache_expire_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.cache', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.cache', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.cache', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'expire'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_nd_dad_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.dad', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.dad', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.dad', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_nd_dad_attempts_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.dad', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.dad', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.dad', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'attempts'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_nd_dad_time_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.dad', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.dad', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.dad', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_nd_hoplimit_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hoplimit'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_nd_managed_config_flag_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'managed-config-flag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_nd_mtu_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mtu'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_nd_ns_interval_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ns-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_nd_nud_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_nd_nud_retry_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'base, interval, max_attempts'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_nd_nud_retry_base_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'base'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_nd_nud_retry_interval_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_nd_nud_retry_max_attempts_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'max-attempts'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_nd_other_config_flag_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'other-config-flag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_nd_prefix_delete(self, fortygigabitethernet=None, prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix', 'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, prefix=prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_nd_prefix_infinite_delete(self, fortygigabitethernet=None, prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'infinite'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, prefix=prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_nd_prefix_infinite_preferred_delete(self, fortygigabitethernet=None, prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'infinite'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, prefix=prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_nd_prefix_no_advertise_delete(self, fortygigabitethernet=None, prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'no-advertise'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, prefix=prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_nd_prefix_no_autoconfig_delete(self, fortygigabitethernet=None, prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'no-autoconfig'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, prefix=prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_nd_prefix_no_onlink_delete(self, fortygigabitethernet=None, prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'no-onlink'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, prefix=prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_nd_prefix_off_link_delete(self, fortygigabitethernet=None, prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'off-link'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, prefix=prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_nd_prefix_preferred_delete(self, fortygigabitethernet=None, prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'preferred_lifetime, preferred_infinite'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred': [u'preferred_infinite', u'preferred_lifetime'], 'pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred': [u'preferred_infinite', u'preferred_lifetime'], 'pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred': [u'preferred_infinite', u'preferred_lifetime']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, prefix=prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_nd_prefix_preferred_lifetime_delete(self, fortygigabitethernet=None, prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'preferred-lifetime'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, prefix=prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_nd_prefix_prefix_flags_delete(self, fortygigabitethernet=None, prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'no_autoconfig, no_onlink, off_link'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, prefix=prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_nd_prefix_valid_lifetime_delete(self, fortygigabitethernet=None, prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'valid-lifetime'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, prefix=prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_nd_proxy_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'proxy'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_nd_ra_interval_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_interval', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_interval', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_interval', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'max_interval, min_'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_nd_ra_interval_max_interval_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_interval', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_interval', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_interval', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'max-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_nd_ra_interval_min_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_interval', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_interval', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_interval', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'min'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_nd_ra_lifetime_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ra-lifetime'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_nd_reachable_time_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'reachable-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_nd_retrans_timer_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'retrans-timer'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_nd_set_cache_expire_time_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'set-cache-expire-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_nd_set_hoplimit_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'set-hoplimit'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_nd_suppress_ra_all_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'all'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_nd_suppress_ra_mtu_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mtu'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_nd_suppress_ra_suppress_ra_flag_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'suppress-ra-flag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_neighbor_delete(self, fortygigabitethernet=None, neighbor=None, hardware_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type neighbor: ipv6_address
    :param neighbor: Keyword argument tuple.

    :type ipv6_address: unicode
    :param ipv6_address: **neighbor** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    **Instance Argument(s)**:

    :type hardware_address: unicode
    :param hardware_address: Keyword argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.neighbor', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.neighbor', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.neighbor', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'neighbor', 'keyval': 'ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, neighbor=neighbor, hardware_address=hardware_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, neighbor=neighbor, hardware_address=hardware_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_neighbor_hardware_address_delete(self, fortygigabitethernet=None, neighbor=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type neighbor: ipv6_address
    :param neighbor: Keyword argument tuple.

    :type ipv6_address: unicode
    :param ipv6_address: **neighbor** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.neighbor', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.neighbor', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.neighbor', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'neighbor', 'keyval': 'ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hardware-address'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, neighbor=neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, neighbor=neighbor)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_ospf_active_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'active'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_ospf_area_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'area'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_ospf_authentication_ah_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ah'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_ospf_authentication_esp_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'esp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_ospf_authentication_esp_auth_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'esp-auth'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_ospf_authentication_esp_key_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'esp-key'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_ospf_authentication_esp_no_encrypt_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'esp-no-encrypt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_ospf_authentication_ipsec_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_ospf_authentication_ipsec_disable_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'disable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_ospf_authentication_ipsec_key_add_remove_interval_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'key-add-remove-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_ospf_authentication_key_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'key'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_ospf_authentication_no_encrypt_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'no-encrypt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_ospf_authentication_spi_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'spi'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_ospf_bfd_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.bfd', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.bfd', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.bfd', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_ospf_bfd_bfd_enable_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.bfd', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.bfd', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.bfd', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bfd-enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_ospf_cost_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cost'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_ospf_dead_interval_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dead-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_ospf_hello_interval_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hello-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_ospf_hello_jitter_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hello-jitter'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_ospf_instance_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'instance'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_ospf_link_interval_properties_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_ospf_mtu_ignore_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mtu-ignore'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_ospf_network_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'network'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_ospf_passive_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'passive'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_ospf_priority_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_ospf_retransmit_interval_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'retransmit-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_ospf_suppress_linklsa_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'suppress-linklsa'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_ospf_transmit_delay_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'transmit-delay'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_policy_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.policy', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.policy', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.policy', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_policy_route_map_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.policy.route_map', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.policy.route_map', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.policy.route_map', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_policy_route_map_ipv6_route_map_name_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.policy.route_map', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.policy.route_map', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.policy.route_map', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ipv6-route-map-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_raguard_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'raguard'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_vrrp_extended_group_delete(self, fortygigabitethernet=None, vrrpv3e_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_vrrp_extended_group_advertise_backup_delete(self, fortygigabitethernet=None, vrrpv3e_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'advertise-backup'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_vrrp_extended_group_advertisement_interval_delete(self, fortygigabitethernet=None, vrrpv3e_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'advertisement-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_vrrp_extended_group_advertisement_interval_scale_delete(self, fortygigabitethernet=None, vrrpv3e_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'advertisement-interval-scale'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_vrrp_extended_group_backup_advertisement_interval_delete(self, fortygigabitethernet=None, vrrpv3e_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'backup-advertisement-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_vrrp_extended_group_description_delete(self, fortygigabitethernet=None, vrrpv3e_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'description'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_vrrp_extended_group_enable_delete(self, fortygigabitethernet=None, vrrpv3e_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_vrrp_extended_group_hold_time_delete(self, fortygigabitethernet=None, vrrpv3e_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hold-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_vrrp_extended_group_nd_advertisement_timer_delete(self, fortygigabitethernet=None, vrrpv3e_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'nd-advertisement-timer'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_vrrp_extended_group_preempt_mode_delete(self, fortygigabitethernet=None, vrrpv3e_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'preempt-mode'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_vrrp_extended_group_priority_delete(self, fortygigabitethernet=None, vrrpv3e_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_vrrp_extended_group_short_path_forwarding_delete(self, fortygigabitethernet=None, vrrpv3e_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.vrrpv3e_group.short_path_forwarding', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'basic, revert_priority'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_vrrp_extended_group_short_path_forwarding_basic_delete(self, fortygigabitethernet=None, vrrpv3e_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.vrrpv3e_group.short_path_forwarding', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.vrrpv3e_group.short_path_forwarding', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.vrrpv3e_group.short_path_forwarding', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'basic'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_vrrp_extended_group_short_path_forwarding_revert_priority_delete(self, fortygigabitethernet=None, vrrpv3e_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.vrrpv3e_group.short_path_forwarding', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.vrrpv3e_group.short_path_forwarding', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.vrrpv3e_group.short_path_forwarding', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'revert-priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_vrrp_extended_group_track_interface_delete(self, fortygigabitethernet=None, vrrpv3e_group=None, interface=None, track_priority=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Argument(s)**:

    :type track_priority: int
    :param track_priority: Track Priority

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.vrrpv3e_group.track.interface', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.vrrpv3e_group.track.interface', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.vrrpv3e_group.track.interface', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, vrrpv3e_group=vrrpv3e_group, interface=interface, track_priority=track_priority)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, vrrpv3e_group=vrrpv3e_group, interface=interface, track_priority=track_priority)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_vrrp_extended_group_track_interface_priority_delete(self, fortygigabitethernet=None, vrrpv3e_group=None, interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.vrrpv3e_group.track.interface', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.vrrpv3e_group.track.interface', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.vrrpv3e_group.track.interface', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, vrrpv3e_group=vrrpv3e_group, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, vrrpv3e_group=vrrpv3e_group, interface=interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_vrrp_extended_group_virtual_ip_delete(self, fortygigabitethernet=None, vrrpv3e_group=None, virtual_ip=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type virtual_ip: virtual_ipaddr
    :param virtual_ip: Keyword argument tuple.

    :type virtual_ipaddr: unicode
    :param virtual_ipaddr: **virtual_ip** tuple argument:  Virtual IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.vrrpv3e_group.virtual_ip', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.vrrpv3e_group.virtual_ip', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.vrrpv3e_group.virtual_ip', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'virtual_ip', 'keyval': 'virtual_ipaddr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, vrrpv3e_group=vrrpv3e_group, virtual_ip=virtual_ip)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, vrrpv3e_group=vrrpv3e_group, virtual_ip=virtual_ip)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_vrrp_group_delete(self, fortygigabitethernet=None, vrrpv3_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, vrrpv3_group=vrrpv3_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, vrrpv3_group=vrrpv3_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_vrrp_group_advertisement_interval_delete(self, fortygigabitethernet=None, vrrpv3_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'advertisement-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, vrrpv3_group=vrrpv3_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, vrrpv3_group=vrrpv3_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_vrrp_group_description_delete(self, fortygigabitethernet=None, vrrpv3_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'description'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, vrrpv3_group=vrrpv3_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, vrrpv3_group=vrrpv3_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_vrrp_group_enable_delete(self, fortygigabitethernet=None, vrrpv3_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, vrrpv3_group=vrrpv3_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, vrrpv3_group=vrrpv3_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_vrrp_group_hold_time_delete(self, fortygigabitethernet=None, vrrpv3_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hold-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, vrrpv3_group=vrrpv3_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, vrrpv3_group=vrrpv3_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_vrrp_group_preempt_mode_delete(self, fortygigabitethernet=None, vrrpv3_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'preempt-mode'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, vrrpv3_group=vrrpv3_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, vrrpv3_group=vrrpv3_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_vrrp_group_priority_delete(self, fortygigabitethernet=None, vrrpv3_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, vrrpv3_group=vrrpv3_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, vrrpv3_group=vrrpv3_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_vrrp_group_track_interface_delete(self, fortygigabitethernet=None, vrrpv3_group=None, interface=None, track_priority=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Argument(s)**:

    :type track_priority: int
    :param track_priority: Track Priority

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.vrrpv3_group', u'vrrpv3_group'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.vrrpv3_group', u'vrrpv3_group'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.vrrpv3_group', u'vrrpv3_group')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.vrrpv3_group.track.interface', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.vrrpv3_group.track.interface', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.vrrpv3_group.track.interface', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, vrrpv3_group=vrrpv3_group, interface=interface, track_priority=track_priority)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, vrrpv3_group=vrrpv3_group, interface=interface, track_priority=track_priority)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_vrrp_group_track_interface_priority_delete(self, fortygigabitethernet=None, vrrpv3_group=None, interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.vrrpv3_group', u'vrrpv3_group'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.vrrpv3_group', u'vrrpv3_group'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.vrrpv3_group', u'vrrpv3_group')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.vrrpv3_group.track.interface', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.vrrpv3_group.track.interface', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.vrrpv3_group.track.interface', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, vrrpv3_group=vrrpv3_group, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, vrrpv3_group=vrrpv3_group, interface=interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_vrrp_group_use_v2_checksum_delete(self, fortygigabitethernet=None, vrrpv3_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'use-v2-checksum'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, vrrpv3_group=vrrpv3_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, vrrpv3_group=vrrpv3_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_vrrp_group_virtual_ip_delete(self, fortygigabitethernet=None, vrrpv3_group=None, virtual_ip=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type virtual_ip: virtual_ipaddr
    :param virtual_ip: Keyword argument tuple.

    :type virtual_ipaddr: unicode
    :param virtual_ipaddr: **virtual_ip** tuple argument:  Virtual IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.vrrpv3_group', u'vrrpv3_group'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.vrrpv3_group', u'vrrpv3_group'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.vrrpv3_group', u'vrrpv3_group')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.vrrpv3_group.virtual_ip', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.vrrpv3_group.virtual_ip', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.vrrpv3_group.virtual_ip', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'virtual_ip', 'keyval': 'virtual_ipaddr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, vrrpv3_group=vrrpv3_group, virtual_ip=virtual_ip)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, vrrpv3_group=vrrpv3_group, virtual_ip=virtual_ip)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_vrrp_suppress_interface_ra_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vrrp-suppress-interface-ra'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_lacp_default_up_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.lacp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.lacp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.lacp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'default-up'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_lacp_port_priority_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.lacp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.lacp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.lacp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'port-priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_lacp_timeout_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.lacp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.lacp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.lacp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'timeout'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_lldp_cee_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.lldp.cee', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.lldp.cee', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.lldp.cee', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_lldp_cee_lldp_cee_on_off_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.lldp.cee', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.lldp.cee', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.lldp.cee', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lldp-cee-on-off'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_lldp_dcbx_version_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.lldp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.lldp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.lldp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dcbx-version'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_lldp_disable_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.lldp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.lldp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.lldp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'disable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_lldp_iscsi_priority_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.lldp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.lldp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.lldp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'iscsi-priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_lldp_profile_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.lldp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.lldp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.lldp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'profile'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_mac_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.mac', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.mac', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.mac', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_mac_access_group_delete(self, fortygigabitethernet=None, access_group=None, traffic_type=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type access_group: mac_access_list, mac_direction, traffic_type
    :param access_group: Keyword argument tuple.

    :type mac_access_list: unicode
    :param mac_access_list: **access_group** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type mac_direction: unicode
    :param mac_direction: **access_group** tuple argument.

        * enumeration restriction: ::

            ['in', 'out']

    :type traffic_type: unicode
    :param traffic_type: **access_group** tuple argument.

        * enumeration restriction: ::

            ['switched', 'routed']

    **Instance Argument(s)**:

    :type traffic_type: unicode
    :param traffic_type: Keyword argument.

        * enumeration restriction: ::

            ['switched', 'routed']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.mac.access_group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.mac.access_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.mac.access_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'access_group', 'keyval': 'mac_access_list, mac_direction', 'extra_keyval': 'mac_access_list, mac_direction, traffic_type'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, access_group=access_group, traffic_type=traffic_type)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, access_group=access_group, traffic_type=traffic_type)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_mac_learning_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.mac_learning', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.mac_learning', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.mac_learning', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_mac_learning_disable_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.mac_learning.mac_learn_disable', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.mac_learning.mac_learn_disable', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.mac_learning.mac_learn_disable', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_mac_learning_disable_vlan_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.mac_learning.mac_learn_disable.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.mac_learning.mac_learn_disable.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.mac_learning.mac_learn_disable.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_mac_learning_disable_vlan_add_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.mac_learning.mac_learn_disable.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.mac_learning.mac_learn_disable.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.mac_learning.mac_learn_disable.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'add'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_mac_learning_disable_vlan_remove_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.mac_learning.mac_learn_disable.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.mac_learning.mac_learn_disable.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.mac_learning.mac_learn_disable.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'remove'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_mtu_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Instance Keyword Argument Tuple**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'fortygigabitethernet', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mtu'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_openflow_enable_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.openflow_interface_cfg.openflow_enable', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.openflow_interface_cfg.openflow_enable', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.openflow_interface_cfg.openflow_enable', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_openflow_logical_instance_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.openflow_interface_cfg', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.openflow_interface_cfg', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.openflow_interface_cfg', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'logical-instance'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_openflow_match_profile_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.openflow_interface_cfg.openflow_enable', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.openflow_interface_cfg.openflow_enable', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.openflow_interface_cfg.openflow_enable', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'match-profile'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_openflow_openflow_enable_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.openflow_interface_cfg.openflow_enable', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.openflow_interface_cfg.openflow_enable', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.openflow_interface_cfg.openflow_enable', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'enable, match_profile'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_port_profile_port_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Instance Keyword Argument Tuple**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'fortygigabitethernet', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'port-profile-port'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_port_profile_port_domain_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.port_profile_to_interface_associations.port_profile_port.port_to_port_profile_domain_association', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.port_profile_to_interface_associations.port_profile_port.port_to_port_profile_domain_association', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.port_profile_to_interface_associations.port_profile_port.port_to_port_profile_domain_association', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_port_profile_port_domain_profile_domain_name_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.port_profile_to_interface_associations.port_profile_port.port_to_port_profile_domain_association', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.port_profile_to_interface_associations.port_profile_port.port_to_port_profile_domain_association', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.port_profile_to_interface_associations.port_profile_port.port_to_port_profile_domain_association', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'profile-domain-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_port_profile_port_profile_delete(self, fortygigabitethernet=None, port_to_port_profile_associations=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type port_to_port_profile_associations: port_to_port_profile_association
    :param port_to_port_profile_associations: Keyword argument tuple.

    :type port_to_port_profile_association: unicode
    :param port_to_port_profile_association: **port_to_port_profile_associations** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.port_profile_to_interface_associations.port_profile_port.port_to_port_profile_associations', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.port_profile_to_interface_associations.port_profile_port.port_to_port_profile_associations', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.port_profile_to_interface_associations.port_profile_port.port_to_port_profile_associations', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'port_to_port_profile_associations', 'keyval': 'port_to_port_profile_association', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, port_to_port_profile_associations=port_to_port_profile_associations)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, port_to_port_profile_associations=port_to_port_profile_associations)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_port_profile_to_interface_associations_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.port_profile_to_interface_associations', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.port_profile_to_interface_associations', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.port_profile_to_interface_associations', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_priority_tag_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Instance Keyword Argument Tuple**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'fortygigabitethernet', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority-tag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_qos_cos_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.qos', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.qos', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.qos', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cos'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_qos_cos_mutation_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.qos', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.qos', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.qos', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cos-mutation'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_qos_cos_traffic_class_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.qos', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.qos', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.qos', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cos-traffic-class'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_qos_drop_monitor_enable_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.qos.drop_monitor', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.qos.drop_monitor', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.qos.drop_monitor', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_qos_dscp_cos_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.qos', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.qos', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.qos', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dscp-cos'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_qos_dscp_mutation_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.qos', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.qos', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.qos', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dscp-mutation'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_qos_dscp_traffic_class_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.qos', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.qos', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.qos', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dscp-traffic-class'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_qos_flowcontrol_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.qos.flowcontrol', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.qos.flowcontrol', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.qos.flowcontrol', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_qos_flowcontrol_link_level_flowcontrol_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.qos.flowcontrol.link_level_flowcontrol', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.qos.flowcontrol.link_level_flowcontrol', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.qos.flowcontrol.link_level_flowcontrol', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_qos_flowcontrol_pfc_delete(self, fortygigabitethernet=None, pfc=None, pfc_flowcontrol_tx=None, pfc_flowcontrol_rx=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type pfc: pfc_cos
    :param pfc: Keyword argument tuple.

    :type pfc_cos: long
    :param pfc_cos: **pfc** tuple argument:  0-7;;CoS value

        * range restriction: ::

            ['-2147483648..2147483647']

    **Instance Argument(s)**:

    :type pfc_flowcontrol_tx: unicode
    :param pfc_flowcontrol_tx: Configure Pause generation

        * enumeration restriction: ::

            ['on', 'off']

    :type pfc_flowcontrol_rx: unicode
    :param pfc_flowcontrol_rx: Configure Pause reception

        * enumeration restriction: ::

            ['on', 'off']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.qos.flowcontrol.pfc', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.qos.flowcontrol.pfc', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.qos.flowcontrol.pfc', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'pfc', 'keyval': 'pfc_cos', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, pfc=pfc, pfc_flowcontrol_tx=pfc_flowcontrol_tx, pfc_flowcontrol_rx=pfc_flowcontrol_rx)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, pfc=pfc, pfc_flowcontrol_tx=pfc_flowcontrol_tx, pfc_flowcontrol_rx=pfc_flowcontrol_rx)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_qos_flowcontrol_pfc_rx_delete(self, fortygigabitethernet=None, pfc=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type pfc: pfc_cos
    :param pfc: Keyword argument tuple.

    :type pfc_cos: long
    :param pfc_cos: **pfc** tuple argument:  0-7;;CoS value

        * range restriction: ::

            ['-2147483648..2147483647']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.qos.flowcontrol.pfc', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.qos.flowcontrol.pfc', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.qos.flowcontrol.pfc', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'pfc', 'keyval': 'pfc_cos', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, pfc=pfc)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, pfc=pfc)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_qos_flowcontrol_pfc_tx_delete(self, fortygigabitethernet=None, pfc=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type pfc: pfc_cos
    :param pfc: Keyword argument tuple.

    :type pfc_cos: long
    :param pfc_cos: **pfc** tuple argument:  0-7;;CoS value

        * range restriction: ::

            ['-2147483648..2147483647']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.qos.flowcontrol.pfc', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.qos.flowcontrol.pfc', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.qos.flowcontrol.pfc', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'pfc', 'keyval': 'pfc_cos', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, pfc=pfc)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, pfc=pfc)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_qos_flowcontrol_rx_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.qos.flowcontrol.link_level_flowcontrol', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.qos.flowcontrol.link_level_flowcontrol', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.qos.flowcontrol.link_level_flowcontrol', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_qos_flowcontrol_tx_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.qos.flowcontrol.link_level_flowcontrol', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.qos.flowcontrol.link_level_flowcontrol', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.qos.flowcontrol.link_level_flowcontrol', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_qos_random_detect_traffic_class_delete(self, fortygigabitethernet=None, traffic_class=None, red_enable=None, red_profile_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type traffic_class: red_tc_value
    :param traffic_class: Keyword argument tuple.

    :type red_tc_value: long
    :param red_tc_value: **traffic_class** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Argument(s)**:

    :type red_enable: YANGBool
    :param red_enable: Keyword for VDX 6710,6720,6730,6746,2730

    :type red_profile_id: long
    :param red_profile_id: Keyword for all other VDX platforms

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.qos.random_detect.traffic_class', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.qos.random_detect.traffic_class', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.qos.random_detect.traffic_class', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'traffic_class', 'keyval': 'red_tc_value', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, traffic_class=traffic_class, red_enable=red_enable, red_profile_id=red_profile_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, traffic_class=traffic_class, red_enable=red_enable, red_profile_id=red_profile_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_qos_random_detect_traffic_class_apply_delete(self, fortygigabitethernet=None, traffic_class=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type traffic_class: red_tc_value
    :param traffic_class: Keyword argument tuple.

    :type red_tc_value: long
    :param red_tc_value: **traffic_class** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.qos.random_detect.traffic_class', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.qos.random_detect.traffic_class', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.qos.random_detect.traffic_class', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'traffic_class', 'keyval': 'red_tc_value', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'apply'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, traffic_class=traffic_class)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, traffic_class=traffic_class)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_qos_random_detect_traffic_class_red_profile_id_delete(self, fortygigabitethernet=None, traffic_class=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type traffic_class: red_tc_value
    :param traffic_class: Keyword argument tuple.

    :type red_tc_value: long
    :param red_tc_value: **traffic_class** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.qos.random_detect.traffic_class', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.qos.random_detect.traffic_class', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.qos.random_detect.traffic_class', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'traffic_class', 'keyval': 'red_tc_value', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'red-profile-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, traffic_class=traffic_class)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, traffic_class=traffic_class)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_qos_trust_cos_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.qos.trust', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.qos.trust', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.qos.trust', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cos'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_qos_trust_dscp_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.qos.trust', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.qos.trust', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.qos.trust', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dscp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_rmon_collection_history_delete(self, fortygigabitethernet=None, history_control_entry=None, history_control_buckets_requested=None, history_control_interval=None, history_control_owner=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type history_control_entry: history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner
    :param history_control_entry: Keyword argument tuple.

    :type history_control_index: long
    :param history_control_index: **history_control_entry** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type history_control_buckets_requested: long
    :param history_control_buckets_requested: **history_control_entry** tuple argument:  Buckets (default 50)

        * range restriction: ::

            ['-2147483648..2147483647']

    :type history_control_interval: long
    :param history_control_interval: **history_control_entry** tuple argument:  Polling Interval (default 1800)

        * range restriction: ::

            ['-2147483648..2147483647']

    :type history_control_owner: unicode
    :param history_control_owner: **history_control_entry** tuple argument:  Owner identity

        * length restriction: ::

            ['1 .. 15']

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,14})'

    **Instance Argument(s)**:

    :type history_control_buckets_requested: long
    :param history_control_buckets_requested: Buckets (default 50)

        * range restriction: ::

            ['-2147483648..2147483647']

    :type history_control_interval: long
    :param history_control_interval: Polling Interval (default 1800)

        * range restriction: ::

            ['-2147483648..2147483647']

    :type history_control_owner: unicode
    :param history_control_owner: Owner identity

        * length restriction: ::

            ['1 .. 15']

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,14})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.rmon.collection.history_control_entry', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.rmon.collection.history_control_entry', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.rmon.collection.history_control_entry', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'history_control_entry', 'keyval': 'history_control_index', 'extra_keyval': 'history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, history_control_entry=history_control_entry, history_control_buckets_requested=history_control_buckets_requested, history_control_interval=history_control_interval, history_control_owner=history_control_owner)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, history_control_entry=history_control_entry, history_control_buckets_requested=history_control_buckets_requested, history_control_interval=history_control_interval, history_control_owner=history_control_owner)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_rmon_collection_history_buckets_delete(self, fortygigabitethernet=None, history_control_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type history_control_entry: history_control_index
    :param history_control_entry: Keyword argument tuple.

    :type history_control_index: long
    :param history_control_index: **history_control_entry** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.rmon.collection.history_control_entry', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.rmon.collection.history_control_entry', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.rmon.collection.history_control_entry', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'history_control_entry', 'keyval': 'history_control_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'buckets'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, history_control_entry=history_control_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, history_control_entry=history_control_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_rmon_collection_history_interval_delete(self, fortygigabitethernet=None, history_control_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type history_control_entry: history_control_index
    :param history_control_entry: Keyword argument tuple.

    :type history_control_index: long
    :param history_control_index: **history_control_entry** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.rmon.collection.history_control_entry', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.rmon.collection.history_control_entry', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.rmon.collection.history_control_entry', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'history_control_entry', 'keyval': 'history_control_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, history_control_entry=history_control_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, history_control_entry=history_control_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_rmon_collection_history_owner_delete(self, fortygigabitethernet=None, history_control_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type history_control_entry: history_control_index
    :param history_control_entry: Keyword argument tuple.

    :type history_control_index: long
    :param history_control_index: **history_control_entry** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.rmon.collection.history_control_entry', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.rmon.collection.history_control_entry', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.rmon.collection.history_control_entry', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'history_control_entry', 'keyval': 'history_control_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'owner'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, history_control_entry=history_control_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, history_control_entry=history_control_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_rmon_collection_stats_delete(self, fortygigabitethernet=None, ether_stats_entry=None, ether_stats_owner=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ether_stats_entry: ether_stats_index, ether_stats_owner
    :param ether_stats_entry: Keyword argument tuple.

    :type ether_stats_index: long
    :param ether_stats_index: **ether_stats_entry** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type ether_stats_owner: unicode
    :param ether_stats_owner: **ether_stats_entry** tuple argument:  Owner identity

        * length restriction: ::

            ['1 .. 15']

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,14})'

    **Instance Argument(s)**:

    :type ether_stats_owner: unicode
    :param ether_stats_owner: Owner identity

        * length restriction: ::

            ['1 .. 15']

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,14})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.rmon.collection.ether_stats_entry', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.rmon.collection.ether_stats_entry', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.rmon.collection.ether_stats_entry', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ether_stats_entry', 'keyval': 'ether_stats_index', 'extra_keyval': 'ether_stats_index, ether_stats_owner'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, ether_stats_entry=ether_stats_entry, ether_stats_owner=ether_stats_owner)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, ether_stats_entry=ether_stats_entry, ether_stats_owner=ether_stats_owner)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_rmon_collection_stats_owner_delete(self, fortygigabitethernet=None, ether_stats_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ether_stats_entry: ether_stats_index
    :param ether_stats_entry: Keyword argument tuple.

    :type ether_stats_index: long
    :param ether_stats_index: **ether_stats_entry** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.rmon.collection.ether_stats_entry', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.rmon.collection.ether_stats_entry', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.rmon.collection.ether_stats_entry', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ether_stats_entry', 'keyval': 'ether_stats_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'owner'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, ether_stats_entry=ether_stats_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, ether_stats_entry=ether_stats_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_service_policy_in_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.service_policy', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.service_policy', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.service_policy', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'in'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_service_policy_out_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.service_policy', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.service_policy', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.service_policy', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'out'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_sflow_enable_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.sflow', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.sflow', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.sflow', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_sflow_polling_interval_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.sflow', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.sflow', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.sflow', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'polling-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_sflow_sample_rate_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.sflow', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.sflow', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.sflow', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'sample-rate'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_shutdown_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Instance Keyword Argument Tuple**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'fortygigabitethernet', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'shutdown'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_snmp_trap_link_status_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.snmp.trap', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.snmp.trap', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.snmp.trap', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'link-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_spanning_tree_autoedge_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.spanning_tree', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.spanning_tree', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.spanning_tree', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'autoedge'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_spanning_tree_bpdu_mac_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.spanning_tree', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.spanning_tree', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.spanning_tree', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bpdu-mac'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_spanning_tree_cost_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.spanning_tree', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.spanning_tree', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.spanning_tree', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cost'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_spanning_tree_edgeport_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.spanning_tree.edgeport', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.spanning_tree.edgeport', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.spanning_tree.edgeport', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_spanning_tree_edgeport_bpdu_filter_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.spanning_tree.edgeport', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.spanning_tree.edgeport', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.spanning_tree.edgeport', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bpdu-filter'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_spanning_tree_edgeport_bpdu_guard_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.spanning_tree.edgeport', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.spanning_tree.edgeport', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.spanning_tree.edgeport', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bpdu-guard'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_spanning_tree_edgeport_edgeportbasic_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.spanning_tree.edgeport', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.spanning_tree.edgeport', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.spanning_tree.edgeport', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'edgeportbasic'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_spanning_tree_guard_root_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.spanning_tree.guard', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.spanning_tree.guard', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.spanning_tree.guard', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'root'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_spanning_tree_hello_time_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.spanning_tree', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.spanning_tree', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.spanning_tree', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hello-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_spanning_tree_instance_cost_delete(self, fortygigabitethernet=None, instance=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type instance: id
    :param instance: Keyword argument tuple.

    :type id: int
    :param id: **instance** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.spanning_tree.instance', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.spanning_tree.instance', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.spanning_tree.instance', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instance', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cost'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, instance=instance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, instance=instance)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_spanning_tree_instance_priority_delete(self, fortygigabitethernet=None, instance=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type instance: id
    :param instance: Keyword argument tuple.

    :type id: int
    :param id: **instance** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.spanning_tree.instance', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.spanning_tree.instance', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.spanning_tree.instance', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instance', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, instance=instance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, instance=instance)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_spanning_tree_instance_restricted_role_delete(self, fortygigabitethernet=None, instance=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type instance: id
    :param instance: Keyword argument tuple.

    :type id: int
    :param id: **instance** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.spanning_tree.instance', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.spanning_tree.instance', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.spanning_tree.instance', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instance', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'restricted-role'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, instance=instance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, instance=instance)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_spanning_tree_instance_restricted_tcn_delete(self, fortygigabitethernet=None, instance=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type instance: id
    :param instance: Keyword argument tuple.

    :type id: int
    :param id: **instance** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.spanning_tree.instance', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.spanning_tree.instance', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.spanning_tree.instance', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instance', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'restricted-tcn'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, instance=instance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, instance=instance)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_spanning_tree_link_type_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.spanning_tree', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.spanning_tree', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.spanning_tree', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'link-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_spanning_tree_portfast_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.spanning_tree.portfast', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.spanning_tree.portfast', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.spanning_tree.portfast', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_spanning_tree_portfast_bpdu_filter_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.spanning_tree.portfast', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.spanning_tree.portfast', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.spanning_tree.portfast', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bpdu-filter'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_spanning_tree_portfast_bpdu_guard_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.spanning_tree.portfast', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.spanning_tree.portfast', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.spanning_tree.portfast', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bpdu-guard'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_spanning_tree_portfast_portfastbasic_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.spanning_tree.portfast', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.spanning_tree.portfast', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.spanning_tree.portfast', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'portfastbasic'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_spanning_tree_priority_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.spanning_tree', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.spanning_tree', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.spanning_tree', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_spanning_tree_restricted_role_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.spanning_tree', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.spanning_tree', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.spanning_tree', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'restricted-role'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_spanning_tree_restricted_tcn_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.spanning_tree', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.spanning_tree', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.spanning_tree', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'restricted-tcn'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_spanning_tree_shutdown_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.spanning_tree', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.spanning_tree', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.spanning_tree', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'shutdown'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_spanning_tree_vlan_cost_delete(self, fortygigabitethernet=None, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vlan: id
    :param vlan: Keyword argument tuple.

    :type id: long
    :param id: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.spanning_tree.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.spanning_tree.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.spanning_tree.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cost'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_spanning_tree_vlan_guard_root_delete(self, fortygigabitethernet=None, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vlan: id
    :param vlan: Keyword argument tuple.

    :type id: long
    :param id: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet.spanning_tree.vlan', u'vlan'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.spanning_tree.vlan', u'vlan'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.spanning_tree.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.spanning_tree.vlan.guard', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.spanning_tree.vlan.guard', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.spanning_tree.vlan.guard', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'root'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_spanning_tree_vlan_priority_delete(self, fortygigabitethernet=None, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vlan: id
    :param vlan: Keyword argument tuple.

    :type id: long
    :param id: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.spanning_tree.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.spanning_tree.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.spanning_tree.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_storm_control_ingress_delete(self, fortygigabitethernet=None, ingress=None, rate_format=None, rate_bps=None, rate_percent=None, bum_action=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ingress: protocol_type, rate_format, rate_bps, rate_percent, bum_action
    :param ingress: Keyword argument tuple.

    :type protocol_type: unicode
    :param protocol_type: **ingress** tuple argument.

        * enumeration restriction: ::

            ['broadcast', 'unknown-unicast', 'multicast']

    :type rate_format: unicode
    :param rate_format: **ingress** tuple argument.

        * enumeration restriction: ::

            ['limit-bps', 'limit-percent']

    :type rate_bps: long
    :param rate_bps: **ingress** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type rate_percent: long
    :param rate_percent: **ingress** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type bum_action: unicode
    :param bum_action: **ingress** tuple argument.

        * enumeration restriction: ::

            ['monitor', 'shutdown']

    **Instance Argument(s)**:

    :type rate_format: unicode
    :param rate_format: Keyword argument.

        * enumeration restriction: ::

            ['limit-bps', 'limit-percent']

    :type rate_bps: long
    :param rate_bps: Keyword argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type rate_percent: long
    :param rate_percent: Keyword argument.

        * range restriction: ::

            ['0..4294967295']

    :type bum_action: unicode
    :param bum_action: Keyword argument.

        * enumeration restriction: ::

            ['monitor', 'shutdown']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.storm_control.ingress', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.storm_control.ingress', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.storm_control.ingress', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ingress', 'keyval': 'protocol_type', 'extra_keyval': 'protocol_type, rate_format, rate_bps, rate_percent, bum_action'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, ingress=ingress, rate_format=rate_format, rate_bps=rate_bps, rate_percent=rate_percent, bum_action=bum_action)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, ingress=ingress, rate_format=rate_format, rate_bps=rate_bps, rate_percent=rate_percent, bum_action=bum_action)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_storm_control_ingress_bum_action_delete(self, fortygigabitethernet=None, ingress=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ingress: protocol_type
    :param ingress: Keyword argument tuple.

    :type protocol_type: unicode
    :param protocol_type: **ingress** tuple argument.

        * enumeration restriction: ::

            ['broadcast', 'unknown-unicast', 'multicast']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.storm_control.ingress', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.storm_control.ingress', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.storm_control.ingress', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ingress', 'keyval': 'protocol_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bum-action'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, ingress=ingress)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, ingress=ingress)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_storm_control_ingress_rate_bps_delete(self, fortygigabitethernet=None, ingress=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ingress: protocol_type
    :param ingress: Keyword argument tuple.

    :type protocol_type: unicode
    :param protocol_type: **ingress** tuple argument.

        * enumeration restriction: ::

            ['broadcast', 'unknown-unicast', 'multicast']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.storm_control.ingress', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.storm_control.ingress', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.storm_control.ingress', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ingress', 'keyval': 'protocol_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rate-bps'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, ingress=ingress)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, ingress=ingress)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_storm_control_ingress_rate_format_delete(self, fortygigabitethernet=None, ingress=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ingress: protocol_type
    :param ingress: Keyword argument tuple.

    :type protocol_type: unicode
    :param protocol_type: **ingress** tuple argument.

        * enumeration restriction: ::

            ['broadcast', 'unknown-unicast', 'multicast']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.storm_control.ingress', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.storm_control.ingress', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.storm_control.ingress', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ingress', 'keyval': 'protocol_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rate-format'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, ingress=ingress)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, ingress=ingress)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_storm_control_ingress_rate_percent_delete(self, fortygigabitethernet=None, ingress=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ingress: protocol_type
    :param ingress: Keyword argument tuple.

    :type protocol_type: unicode
    :param protocol_type: **ingress** tuple argument.

        * enumeration restriction: ::

            ['broadcast', 'unknown-unicast', 'multicast']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.storm_control.ingress', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.storm_control.ingress', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.storm_control.ingress', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ingress', 'keyval': 'protocol_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rate-percent'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, ingress=ingress)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, ingress=ingress)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.switchport_basic', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.switchport_basic', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.switchport_basic', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'switchport'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_access_mac_group_rspan_vlan_classification_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.switchport.access_mac_group_rspan_vlan_classification', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.switchport.access_mac_group_rspan_vlan_classification', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.switchport.access_mac_group_rspan_vlan_classification', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_access_mac_group_vlan_classification_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.switchport.access_mac_group_vlan_classification', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.switchport.access_mac_group_vlan_classification', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.switchport.access_mac_group_vlan_classification', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_access_mac_rspan_vlan_classification_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.switchport.access_mac_rspan_vlan_classification', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.switchport.access_mac_rspan_vlan_classification', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.switchport.access_mac_rspan_vlan_classification', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_access_mac_vlan_classification_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.switchport.access_mac_vlan_classification', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.switchport.access_mac_vlan_classification', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.switchport.access_mac_vlan_classification', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_access_rspan_vlan_delete(self, fortygigabitethernet=None, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vlan: access_vlan_id, access_mac_group
    :param vlan: Keyword argument tuple.

    :type access_vlan_id: long
    :param access_vlan_id: **vlan** tuple argument:  Set the default VLAN for the interface

        * range restriction: ::

            ['0..4294967295']

    :type access_mac_group: long
    :param access_mac_group: **vlan** tuple argument:  Associate a Mac group with a vlan

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.switchport.access_mac_group_rspan_vlan_classification.access.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.switchport.access_mac_group_rspan_vlan_classification.access.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.switchport.access_mac_group_rspan_vlan_classification.access.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'access_vlan_id, access_mac_group', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_access_rspan_vlan_access_mac_rspan_vlan_classification_delete(self, fortygigabitethernet=None, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vlan: access_vlan_id, access_mac_address
    :param vlan: Keyword argument tuple.

    :type access_vlan_id: long
    :param access_vlan_id: **vlan** tuple argument:  Set the default VLAN for the interface

        * range restriction: ::

            ['0..4294967295']

    :type access_mac_address: unicode
    :param access_mac_address: **vlan** tuple argument:  Associate the Mac address with a vlan

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.switchport.access_mac_rspan_vlan_classification.access.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.switchport.access_mac_rspan_vlan_classification.access.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.switchport.access_mac_rspan_vlan_classification.access.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'access_vlan_id, access_mac_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_access_vlan_delete(self, fortygigabitethernet=None, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vlan: access_vlan_id, access_mac_group
    :param vlan: Keyword argument tuple.

    :type access_vlan_id: long
    :param access_vlan_id: **vlan** tuple argument:  Set the default VLAN for the interface

        * range restriction: ::

            ['0..4294967295']

    :type access_mac_group: long
    :param access_mac_group: **vlan** tuple argument:  Associate a Mac group with a vlan

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.switchport.access_mac_group_vlan_classification.access.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.switchport.access_mac_group_vlan_classification.access.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.switchport.access_mac_group_vlan_classification.access.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'access_vlan_id, access_mac_group', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_access_vlan_access_mac_vlan_classification_delete(self, fortygigabitethernet=None, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vlan: access_vlan_id, access_mac_address
    :param vlan: Keyword argument tuple.

    :type access_vlan_id: long
    :param access_vlan_id: **vlan** tuple argument:  Set the default VLAN for the interface

        * range restriction: ::

            ['0..4294967295']

    :type access_mac_address: unicode
    :param access_mac_address: **vlan** tuple argument:  Associate the Mac address with a vlan

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.switchport.access_mac_vlan_classification.access.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.switchport.access_mac_vlan_classification.access.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.switchport.access_mac_vlan_classification.access.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'access_vlan_id, access_mac_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_basic_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.switchport_basic', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.switchport_basic', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.switchport_basic', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_mode_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.switchport.mode', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.switchport.mode', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.switchport.mode', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_mode_private_vlan_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.switchport.mode.private_vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.switchport.mode.private_vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.switchport.mode.private_vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_mode_private_vlan_host_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.switchport.mode.private_vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.switchport.mode.private_vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.switchport.mode.private_vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'host'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_mode_private_vlan_promiscuous_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.switchport.mode.private_vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.switchport.mode.private_vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.switchport.mode.private_vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'promiscuous'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_mode_private_vlan_trunk_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.switchport.mode.private_vlan.private_vlan_trunk', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.switchport.mode.private_vlan.private_vlan_trunk', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.switchport.mode.private_vlan.private_vlan_trunk', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_mode_private_vlan_trunk_host_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.switchport.mode.private_vlan.private_vlan_trunk', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.switchport.mode.private_vlan.private_vlan_trunk', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.switchport.mode.private_vlan.private_vlan_trunk', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'host'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_mode_private_vlan_trunk_promiscuous_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.switchport.mode.private_vlan.private_vlan_trunk', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.switchport.mode.private_vlan.private_vlan_trunk', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.switchport.mode.private_vlan.private_vlan_trunk', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'promiscuous'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_mode_private_vlan_trunk_trunk_basic_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.switchport.mode.private_vlan.private_vlan_trunk', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.switchport.mode.private_vlan.private_vlan_trunk', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.switchport.mode.private_vlan.private_vlan_trunk', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'trunk-basic'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_mode_vlan_mode_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.switchport.mode', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.switchport.mode', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.switchport.mode', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vlan-mode'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_port_security_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.switchport.port_security', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.switchport.port_security', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.switchport.port_security', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_port_security_allowed_ouis_delete(self, fortygigabitethernet=None, allowed_ouis=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type allowed_ouis: oui
    :param allowed_ouis: Keyword argument tuple.

    :type oui: unicode
    :param oui: **allowed_ouis** tuple argument:  <OUI> OUI in HHHH.HH00.0000 format

        * pattern restriction: ::

            '[0-9a-fA-F]{4}\.[0-9a-fA-F]{2}00\.0000'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.switchport.port_security.allowed_ouis', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.switchport.port_security.allowed_ouis', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.switchport.port_security.allowed_ouis', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'allowed_ouis', 'keyval': 'oui', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, allowed_ouis=allowed_ouis)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, allowed_ouis=allowed_ouis)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_port_security_max_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.switchport.port_security', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.switchport.port_security', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.switchport.port_security', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'max'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_port_security_port_secutiry_mac_address_delete(self, fortygigabitethernet=None, port_secutiry_mac_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type port_secutiry_mac_address: mac_address, port_sec_vlan
    :param port_secutiry_mac_address: Keyword argument tuple.

    :type mac_address: unicode
    :param mac_address: **port_secutiry_mac_address** tuple argument:  Mac Address

    :type port_sec_vlan: long
    :param port_sec_vlan: **port_secutiry_mac_address** tuple argument:  Forwarding vlan

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.switchport.port_security.port_secutiry_mac_address', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.switchport.port_security.port_secutiry_mac_address', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.switchport.port_security.port_secutiry_mac_address', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'port_secutiry_mac_address', 'keyval': 'mac_address, port_sec_vlan', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, port_secutiry_mac_address=port_secutiry_mac_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, port_secutiry_mac_address=port_secutiry_mac_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_port_security_shutdown_time_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.switchport.port_security', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.switchport.port_security', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.switchport.port_security', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'shutdown-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_port_security_sticky_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet.switchport.port_security.sticky', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.switchport.port_security.sticky', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_port_security_sticky_port_secutiry_mac_address_delete(self, fortygigabitethernet=None, port_secutiry_mac_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type port_secutiry_mac_address: mac_address, port_sec_vlan
    :param port_secutiry_mac_address: Keyword argument tuple.

    :type mac_address: unicode
    :param mac_address: **port_secutiry_mac_address** tuple argument:  Mac Address

    :type port_sec_vlan: long
    :param port_sec_vlan: **port_secutiry_mac_address** tuple argument:  Forwarding vlan

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.switchport.port_security.sticky.port_secutiry_mac_address', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.switchport.port_security.sticky.port_secutiry_mac_address', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.switchport.port_security.sticky.port_secutiry_mac_address', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'port_secutiry_mac_address', 'keyval': 'mac_address, port_sec_vlan', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, port_secutiry_mac_address=port_secutiry_mac_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, port_secutiry_mac_address=port_secutiry_mac_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_port_security_sticky_sticky_flag_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.switchport.port_security.sticky', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.switchport.port_security.sticky', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.switchport.port_security.sticky', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'sticky-flag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_port_security_violation_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.switchport.port_security', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.switchport.port_security', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.switchport.port_security', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'violation'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_private_vlan_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.switchport.private_vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.switchport.private_vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.switchport.private_vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_private_vlan_association_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.switchport.private_vlan.association', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.switchport.private_vlan.association', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.switchport.private_vlan.association', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_private_vlan_association_trunk_delete(self, fortygigabitethernet=None, trunk=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type trunk: trunk_pri_pvlan, trunk_sec_pvlan
    :param trunk: Keyword argument tuple.

    :type trunk_pri_pvlan: long
    :param trunk_pri_pvlan: **trunk** tuple argument:  Primary vlan id

        * range restriction: ::

            ['0..4294967295']

    :type trunk_sec_pvlan: long
    :param trunk_sec_pvlan: **trunk** tuple argument:  Secondary vlan id 

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.switchport.private_vlan.association.trunk', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.switchport.private_vlan.association.trunk', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.switchport.private_vlan.association.trunk', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'trunk', 'keyval': 'trunk_pri_pvlan, trunk_sec_pvlan', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, trunk=trunk)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, trunk=trunk)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_private_vlan_host_association_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.switchport.private_vlan.host_association', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.switchport.private_vlan.host_association', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.switchport.private_vlan.host_association', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'host_pri_pvlan, host_sec_pvlan'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_private_vlan_host_association_host_pri_pvlan_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.switchport.private_vlan.host_association', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.switchport.private_vlan.host_association', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.switchport.private_vlan.host_association', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'host-pri-pvlan'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_private_vlan_host_association_host_sec_pvlan_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.switchport.private_vlan.host_association', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.switchport.private_vlan.host_association', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.switchport.private_vlan.host_association', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'host-sec-pvlan'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_private_vlan_mapping_delete(self, fortygigabitethernet=None, mapping=None, oper=None, promis_sec_pvlan_range=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type mapping: promis_pri_pvlan, oper, promis_sec_pvlan_range
    :param mapping: Keyword argument tuple.

    :type promis_pri_pvlan: long
    :param promis_pri_pvlan: **mapping** tuple argument:  Primary vlan id

        * range restriction: ::

            ['0..4294967295']

    :type oper: unicode
    :param oper: **mapping** tuple argument.

        * enumeration restriction: ::

            ['add', 'delete']

    :type promis_sec_pvlan_range: unicode
    :param promis_sec_pvlan_range: **mapping** tuple argument:  Secondary vlan range

        * length restriction: ::

            ['1..253']

        * pattern restriction: ::

            '(([1-9][0-9]{0,2})|([1-7][0-9]{3})|(80[0-9]{2})|'
            '(81[0-8][0-9])|(819[01]))(-(([2-9])|([1-9][0-9]{'
            '1,2})|([1-7][0-9]{3})|(80[0-9]{2})|(81[0-8][0-9]'
            ')|(819[01])))?((,(([2-9])|([1-9][0-9]{1,2})|([1-'
            '7][0-9]{3})|(80[0-9]{2})|(81[0-8][0-9])|(819[01]'
            '))(-(([3-9])|([1-9][0-9]{1,2})|([1-7][0-9]{3})|('
            '80[0-9]{2})|(81[0-8][0-9])|(819[01])))?)?)*'

    **Instance Argument(s)**:

    :type oper: unicode
    :param oper: Keyword argument.

        * enumeration restriction: ::

            ['add', 'delete']

    :type promis_sec_pvlan_range: unicode
    :param promis_sec_pvlan_range: Secondary vlan range

        * length restriction: ::

            ['1..253']

        * pattern restriction: ::

            '(([1-9][0-9]{0,2})|([1-7][0-9]{3})|(80[0-9]{2})|'
            '(81[0-8][0-9])|(819[01]))(-(([2-9])|([1-9][0-9]{'
            '1,2})|([1-7][0-9]{3})|(80[0-9]{2})|(81[0-8][0-9]'
            ')|(819[01])))?((,(([2-9])|([1-9][0-9]{1,2})|([1-'
            '7][0-9]{3})|(80[0-9]{2})|(81[0-8][0-9])|(819[01]'
            '))(-(([3-9])|([1-9][0-9]{1,2})|([1-7][0-9]{3})|('
            '80[0-9]{2})|(81[0-8][0-9])|(819[01])))?)?)*'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.switchport.private_vlan.mapping', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.switchport.private_vlan.mapping', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.switchport.private_vlan.mapping', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mapping', 'keyval': 'promis_pri_pvlan', 'extra_keyval': 'promis_pri_pvlan, oper, promis_sec_pvlan_range'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, mapping=mapping, oper=oper, promis_sec_pvlan_range=promis_sec_pvlan_range)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, mapping=mapping, oper=oper, promis_sec_pvlan_range=promis_sec_pvlan_range)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_private_vlan_mapping_oper_delete(self, fortygigabitethernet=None, mapping=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type mapping: promis_pri_pvlan
    :param mapping: Keyword argument tuple.

    :type promis_pri_pvlan: long
    :param promis_pri_pvlan: **mapping** tuple argument:  Primary vlan id

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.switchport.private_vlan.mapping', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.switchport.private_vlan.mapping', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.switchport.private_vlan.mapping', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mapping', 'keyval': 'promis_pri_pvlan', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'oper'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, mapping=mapping)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, mapping=mapping)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_private_vlan_mapping_promis_sec_pvlan_range_delete(self, fortygigabitethernet=None, mapping=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type mapping: promis_pri_pvlan
    :param mapping: Keyword argument tuple.

    :type promis_pri_pvlan: long
    :param promis_pri_pvlan: **mapping** tuple argument:  Primary vlan id

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.switchport.private_vlan.mapping', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.switchport.private_vlan.mapping', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.switchport.private_vlan.mapping', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mapping', 'keyval': 'promis_pri_pvlan', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'promis-sec-pvlan-range'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, mapping=mapping)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, mapping=mapping)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_private_vlan_trunk_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.switchport.private_vlan.trunk', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.switchport.private_vlan.trunk', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.switchport.private_vlan.trunk', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_private_vlan_trunk_allowed_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.switchport.private_vlan.trunk.allowed', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.switchport.private_vlan.trunk.allowed', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.switchport.private_vlan.trunk.allowed', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_private_vlan_trunk_allowed_trunk_private_vlan_classification_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_private_vlan_trunk_allowed_vlan_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.switchport.private_vlan.trunk.allowed.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.switchport.private_vlan.trunk.allowed.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.switchport.private_vlan.trunk.allowed.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_private_vlan_trunk_allowed_vlan_add_delete(self, fortygigabitethernet=None, add=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type add: trunk_vlan_id, trunk_ctag_id
    :param add: Keyword argument tuple.

    :type trunk_vlan_id: long
    :param trunk_vlan_id: **add** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type trunk_ctag_id: long
    :param trunk_ctag_id: **add** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan.add_', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan.add_', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan.add_', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'add', 'keyval': 'trunk_vlan_id, trunk_ctag_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, add=add)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, add=add)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_private_vlan_trunk_allowed_vlan_all_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.switchport.private_vlan.trunk.allowed.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.switchport.private_vlan.trunk.allowed.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.switchport.private_vlan.trunk.allowed.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'all'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_private_vlan_trunk_allowed_vlan_except_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.switchport.private_vlan.trunk.allowed.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.switchport.private_vlan.trunk.allowed.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.switchport.private_vlan.trunk.allowed.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'except'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_private_vlan_trunk_allowed_vlan_none_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.switchport.private_vlan.trunk.allowed.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.switchport.private_vlan.trunk.allowed.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.switchport.private_vlan.trunk.allowed.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'none'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_private_vlan_trunk_allowed_vlan_remove_delete(self, fortygigabitethernet=None, remove=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type remove: trunk_vlan_id, trunk_ctag_id
    :param remove: Keyword argument tuple.

    :type trunk_vlan_id: long
    :param trunk_vlan_id: **remove** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type trunk_ctag_id: long
    :param trunk_ctag_id: **remove** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan.remove_', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan.remove_', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan.remove_', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'remove', 'keyval': 'trunk_vlan_id, trunk_ctag_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, remove=remove)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, remove=remove)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_private_vlan_trunk_allowed_vlan_trunk_private_vlan_classification_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_private_vlan_trunk_native_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.switchport.private_vlan.trunk.native', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.switchport.private_vlan.trunk.native', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.switchport.private_vlan.trunk.native', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'pvlanNativevlan, pvlan_native_vlan_ctag_id'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_private_vlan_trunk_native_ctag_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.switchport.private_vlan.trunk.native', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.switchport.private_vlan.trunk.native', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.switchport.private_vlan.trunk.native', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ctag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_private_vlan_trunk_native_vlan_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.switchport.private_vlan.trunk.native', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.switchport.private_vlan.trunk.native', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.switchport.private_vlan.trunk.native', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vlan'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_private_vlan_trunk_private_vlan_classification_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.switchport.trunk_private_vlan_classification.private_vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.switchport.trunk_private_vlan_classification.private_vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.switchport.trunk_private_vlan_classification.private_vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_private_vlan_trunk_tag_native_vlan_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.switchport.private_vlan.trunk.pvlan_tag', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.switchport.private_vlan.trunk.pvlan_tag', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.switchport.private_vlan.trunk.pvlan_tag', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'native-vlan'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_private_vlan_trunk_trunk_private_vlan_classification_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_trunk_allowed_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.switchport.trunk.allowed', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.switchport.trunk.allowed', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.switchport.trunk.allowed', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_trunk_allowed_rspan_vlan_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.switchport.trunk.allowed.rspan_vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.switchport.trunk.allowed.rspan_vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.switchport.trunk.allowed.rspan_vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_trunk_allowed_rspan_vlan_add_delete(self, fortygigabitethernet=None, add=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type add: trunk_vlan_id, trunk_ctag_id
    :param add: Keyword argument tuple.

    :type trunk_vlan_id: long
    :param trunk_vlan_id: **add** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type trunk_ctag_id: long
    :param trunk_ctag_id: **add** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan.add_', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan.add_', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan.add_', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'add', 'keyval': 'trunk_vlan_id, trunk_ctag_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, add=add)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, add=add)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_trunk_allowed_rspan_vlan_remove_delete(self, fortygigabitethernet=None, remove=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type remove: trunk_vlan_id, trunk_ctag_id
    :param remove: Keyword argument tuple.

    :type trunk_vlan_id: long
    :param trunk_vlan_id: **remove** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type trunk_ctag_id: long
    :param trunk_ctag_id: **remove** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan.remove_', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan.remove_', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan.remove_', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'remove', 'keyval': 'trunk_vlan_id, trunk_ctag_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, remove=remove)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, remove=remove)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_trunk_allowed_rspan_vlan_trunk_rspan_vlan_classification_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_trunk_allowed_trunk_rspan_vlan_classification_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_trunk_allowed_trunk_vlan_classification_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.switchport.trunk.trunk_vlan_classification.allowed', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.switchport.trunk.trunk_vlan_classification.allowed', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.switchport.trunk.trunk_vlan_classification.allowed', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_trunk_allowed_vlan_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.switchport.trunk.allowed.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.switchport.trunk.allowed.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.switchport.trunk.allowed.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_trunk_allowed_vlan_add_delete(self, fortygigabitethernet=None, add=None, trunk_ctag_range=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type add: trunk_vlan_id
    :param add: Keyword argument tuple.

    :type trunk_vlan_id: long
    :param trunk_vlan_id: **add** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Argument(s)**:

    :type trunk_ctag_range: unicode
    :param trunk_ctag_range: Keyword argument.

        * length restriction: ::

            ['1..1000']

        * pattern restriction: ::

            '(([1-9][0-9]{0,2})|([1-3][0-9]{3})|(40[0-8][0-9]'
            ')|(409[0-4]))(-((1[0-9]{1,2})|([2-9][0-9]{0,2})|'
            '([1-3][0-9]{3})|(40[0-8][0-9])|(409[0-4])))?((,('
            '(1[0-9]{1,2})|([2-9][0-9]{0,2})|([1-3][0-9]{3})|'
            '(40[0-8][0-9])|(409[0-4]))(-((1[0-9]{1,2})|([2-9'
            '][0-9]{0,2})|([1-3][0-9]{3})|(40[0-8][0-9])|(409'
            '[0-4])))?)?)*'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan.add_', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan.add_', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan.add_', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'add', 'keyval': 'trunk_vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, add=add, trunk_ctag_range=trunk_ctag_range)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, add=add, trunk_ctag_range=trunk_ctag_range)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_trunk_allowed_vlan_add_ctag_delete(self, fortygigabitethernet=None, add=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type add: trunk_vlan_id
    :param add: Keyword argument tuple.

    :type trunk_vlan_id: long
    :param trunk_vlan_id: **add** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan.add_', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan.add_', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan.add_', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'add', 'keyval': 'trunk_vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ctag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, add=add)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, add=add)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_trunk_allowed_vlan_all_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.switchport.trunk.allowed.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.switchport.trunk.allowed.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.switchport.trunk.allowed.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'all'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_trunk_allowed_vlan_except_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.switchport.trunk.allowed.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.switchport.trunk.allowed.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.switchport.trunk.allowed.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'except'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_trunk_allowed_vlan_none_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.switchport.trunk.allowed.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.switchport.trunk.allowed.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.switchport.trunk.allowed.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'none'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_trunk_allowed_vlan_remove_delete(self, fortygigabitethernet=None, remove=None, trunk_ctag_range=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type remove: trunk_vlan_id
    :param remove: Keyword argument tuple.

    :type trunk_vlan_id: long
    :param trunk_vlan_id: **remove** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Argument(s)**:

    :type trunk_ctag_range: unicode
    :param trunk_ctag_range: Keyword argument.

        * length restriction: ::

            ['1..1000']

        * pattern restriction: ::

            '(([1-9][0-9]{0,2})|([1-3][0-9]{3})|(40[0-8][0-9]'
            ')|(409[0-4]))(-((1[0-9]{1,2})|([2-9][0-9]{0,2})|'
            '([1-3][0-9]{3})|(40[0-8][0-9])|(409[0-4])))?((,('
            '(1[0-9]{1,2})|([2-9][0-9]{0,2})|([1-3][0-9]{3})|'
            '(40[0-8][0-9])|(409[0-4]))(-((1[0-9]{1,2})|([2-9'
            '][0-9]{0,2})|([1-3][0-9]{3})|(40[0-8][0-9])|(409'
            '[0-4])))?)?)*'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan.remove_', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan.remove_', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan.remove_', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'remove', 'keyval': 'trunk_vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, remove=remove, trunk_ctag_range=trunk_ctag_range)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, remove=remove, trunk_ctag_range=trunk_ctag_range)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_trunk_allowed_vlan_remove_ctag_delete(self, fortygigabitethernet=None, remove=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type remove: trunk_vlan_id
    :param remove: Keyword argument tuple.

    :type trunk_vlan_id: long
    :param trunk_vlan_id: **remove** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan.remove_', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan.remove_', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan.remove_', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'remove', 'keyval': 'trunk_vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ctag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, remove=remove)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, remove=remove)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_trunk_allowed_vlan_trunk_vlan_classification_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_trunk_allowed_vlanoper_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.switchport.trunk.allowed.vlanoper', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.switchport.trunk.allowed.vlanoper', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.switchport.trunk.allowed.vlanoper', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_trunk_allowed_vlanoper_vlan_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.switchport.trunk.allowed.vlanoper.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.switchport.trunk.allowed.vlanoper.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.switchport.trunk.allowed.vlanoper.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_trunk_allowed_vlanoper_vlan_add_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.switchport.trunk.allowed.vlanoper.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.switchport.trunk.allowed.vlanoper.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.switchport.trunk.allowed.vlanoper.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'add'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_trunk_allowed_vlanoper_vlan_remove_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.switchport.trunk.allowed.vlanoper.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.switchport.trunk.allowed.vlanoper.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.switchport.trunk.allowed.vlanoper.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'remove'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_trunk_ctag_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.switchport.trunk.native_vlan_classification', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.switchport.trunk.native_vlan_classification', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.switchport.trunk.native_vlan_classification', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ctag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_trunk_ctag_native_vlan_xtagged_config_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.switchport.trunk.native_vlan_xtagged_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.switchport.trunk.native_vlan_xtagged_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.switchport.trunk.native_vlan_xtagged_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ctag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_trunk_default_vlan_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.switchport.trunk.default_vlan_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.switchport.trunk.default_vlan_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.switchport.trunk.default_vlan_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'default-vlan'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_trunk_default_vlan_config_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.switchport.trunk.default_vlan_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.switchport.trunk.default_vlan_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.switchport.trunk.default_vlan_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'default_transparent_vlan'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_trunk_egress_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.switchport.trunk.native_vlan_xtagged_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.switchport.trunk.native_vlan_xtagged_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.switchport.trunk.native_vlan_xtagged_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'egress'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_trunk_native_vlan_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.switchport.trunk.native_vlan_classification', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.switchport.trunk.native_vlan_classification', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.switchport.trunk.native_vlan_classification', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'native-vlan'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_trunk_native_vlan_classification_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.switchport.trunk.native_vlan_classification', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.switchport.trunk.native_vlan_classification', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.switchport.trunk.native_vlan_classification', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'native_vlan_id, native_vlan_ctag_id'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_trunk_native_vlan_untagged_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.switchport.trunk.native_vlan_untagged_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.switchport.trunk.native_vlan_untagged_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.switchport.trunk.native_vlan_untagged_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'native-vlan-untagged'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_trunk_native_vlan_untagged_config_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.switchport.trunk.native_vlan_untagged_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.switchport.trunk.native_vlan_untagged_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.switchport.trunk.native_vlan_untagged_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'native_vlan_id_untagged'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_trunk_native_vlan_xtagged_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.switchport.trunk.native_vlan_xtagged_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.switchport.trunk.native_vlan_xtagged_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.switchport.trunk.native_vlan_xtagged_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'native-vlan-xtagged'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_trunk_native_vlan_xtagged_config_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.switchport.trunk.native_vlan_xtagged_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.switchport.trunk.native_vlan_xtagged_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.switchport.trunk.native_vlan_xtagged_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_trunk_private_vlan_classification_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.switchport.trunk_private_vlan_classification', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.switchport.trunk_private_vlan_classification', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.switchport.trunk_private_vlan_classification', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_trunk_tag_native_vlan_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.switchport.trunk.tag', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.switchport.trunk.tag', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.switchport.trunk.tag', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'native-vlan'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_trunk_trunk_vlan_classification_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.switchport.trunk.trunk_vlan_classification', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.switchport.trunk.trunk_vlan_classification', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.switchport.trunk.trunk_vlan_classification', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_track_enable_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.track', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.track', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.track', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_track_interface_delete(self, fortygigabitethernet=None, interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type interface: track_interface_type, track_interface_name
    :param interface: Keyword argument tuple.

    :type track_interface_type: unicode
    :param track_interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 'port-channel']

    :type track_interface_name: unicode
    :param track_interface_name: **interface** tuple argument:  Interface name

        * pattern restriction: ::

            '(((([1-9]|[1-9][0-9]|1[0-9]{2}|2[0-3][0-9])/)?(('
            '[0-9]|1[0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0-9]'
            ')(:[1-4])?)|([1-9]|[1-9][0-9]|[1-9][0-9]{2}|[1-5'
            '][0-9]{3}|6[0-1][0-4]{2}))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.track.interface', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.track.interface', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.track.interface', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'track_interface_type, track_interface_name', 'extra_keyval': 'track_interface_type, track_interface_name'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, interface=interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_track_min_link_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.track', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.track', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.track', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'min-link'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_track_remove_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.track.remove_', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.track.remove_', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.track.remove_', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_track_remove_all_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.track.remove_', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.track.remove_', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.track.remove_', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'all'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_tunable_optics_sfpp_channel_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet.tunable_optics.sfpp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.tunable_optics.sfpp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'channel'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_tunnel_tagged_ieee_bpdu_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.tunnel', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.tunnel', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.tunnel', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tagged-ieee-bpdu'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_udld_enable_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.udld', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.udld', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.udld', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_vlan_classifier_activate_group_delete(self, fortygigabitethernet=None, group=None, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type group: groupid, vlan
    :param group: Keyword argument tuple.

    :type groupid: long
    :param groupid: **group** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vlan: long
    :param vlan: **group** tuple argument:  1-8191;;Vlan

        * range restriction: ::

            ['0..4294967295']

    **Instance Argument(s)**:

    :type vlan: long
    :param vlan: 1-8191;;Vlan

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.vlan.classifier.activate.group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.vlan.classifier.activate.group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.vlan.classifier.activate.group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'group', 'keyval': 'groupid', 'extra_keyval': 'groupid, vlan'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, group=group, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, group=group, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_vlan_classifier_activate_group_vlan_delete(self, fortygigabitethernet=None, group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type group: groupid
    :param group: Keyword argument tuple.

    :type groupid: long
    :param groupid: **group** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.vlan.classifier.activate.group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.vlan.classifier.activate.group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.vlan.classifier.activate.group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'group', 'keyval': 'groupid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vlan'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, group=group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, group=group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_vrf_forwarding_delete(self, fortygigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.vrf', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.vrf', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.vrf', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'forwarding'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_vrrp_group_delete(self, fortygigabitethernet=None, vrrp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.vrrp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.vrrp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.vrrp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, vrrp=vrrp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_vrrp_group_advertisement_interval_delete(self, fortygigabitethernet=None, vrrp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.vrrp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.vrrp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.vrrp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'advertisement-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, vrrp=vrrp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_vrrp_group_arp_unicast_request_receive_delete(self, fortygigabitethernet=None, vrrp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.vrrp', u'vrrp'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.vrrp', u'vrrp'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet.vrrp', u'vrrp')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.vrrp.arp.unicast_request', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.vrrp.arp.unicast_request', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.vrrp.arp.unicast_request', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'receive'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, vrrp=vrrp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_vrrp_group_description_delete(self, fortygigabitethernet=None, vrrp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.vrrp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.vrrp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.vrrp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'description'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, vrrp=vrrp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_vrrp_group_enable_delete(self, fortygigabitethernet=None, vrrp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.vrrp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.vrrp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.vrrp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, vrrp=vrrp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_vrrp_group_hold_time_delete(self, fortygigabitethernet=None, vrrp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.vrrp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.vrrp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.vrrp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hold-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, vrrp=vrrp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_vrrp_group_preempt_mode_delete(self, fortygigabitethernet=None, vrrp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.vrrp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.vrrp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.vrrp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'preempt-mode'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, vrrp=vrrp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_vrrp_group_priority_delete(self, fortygigabitethernet=None, vrrp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.vrrp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.vrrp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.vrrp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, vrrp=vrrp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_vrrp_group_track_interface_delete(self, fortygigabitethernet=None, vrrp=None, interface=None, track_priority=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Argument(s)**:

    :type track_priority: int
    :param track_priority: Track Priority

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet.vrrp', u'vrrp'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.vrrp', u'vrrp'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.vrrp', u'vrrp')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.vrrp.track.interface', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.vrrp.track.interface', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.vrrp.track.interface', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, vrrp=vrrp, interface=interface, track_priority=track_priority)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, vrrp=vrrp, interface=interface, track_priority=track_priority)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_vrrp_group_track_interface_priority_delete(self, fortygigabitethernet=None, vrrp=None, interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet.vrrp', u'vrrp'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.vrrp', u'vrrp'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.vrrp', u'vrrp')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.vrrp.track.interface', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.vrrp.track.interface', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.vrrp.track.interface', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, vrrp=vrrp, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, vrrp=vrrp, interface=interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_vrrp_group_use_v2_checksum_delete(self, fortygigabitethernet=None, vrrp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.vrrp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.vrrp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.vrrp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'use-v2-checksum'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, vrrp=vrrp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_fortygigabitethernet_vrrp_group_virtual_ip_delete(self, fortygigabitethernet=None, vrrp=None, virtual_ip=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type virtual_ip: virtual_ipaddr
    :param virtual_ip: Keyword argument tuple.

    :type virtual_ipaddr: unicode
    :param virtual_ipaddr: **virtual_ip** tuple argument:  Virtual IPv4 address in dotted decimal

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.vrrp', u'vrrp'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.vrrp', u'vrrp'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2c.interface.fortygigabitethernet.vrrp', u'vrrp')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.fortygigabitethernet.vrrp.virtual_ip', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.fortygigabitethernet.vrrp.virtual_ip', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.fortygigabitethernet.vrrp.virtual_ip', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'virtual_ip', 'keyval': 'virtual_ipaddr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, vrrp=vrrp, virtual_ip=virtual_ip)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, vrrp=vrrp, virtual_ip=virtual_ip)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_bfd_interval_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.bfd.interval', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.bfd.interval', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.bfd.interval', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_bfd_interval_min_rx_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.bfd.interval', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.bfd.interval', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.bfd.interval', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'min-rx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_bfd_interval_min_tx_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.bfd.interval', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.bfd.interval', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.bfd.interval', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'min-tx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_bfd_interval_multiplier_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.bfd.interval', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.bfd.interval', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.bfd.interval', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'multiplier'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_bfd_shutdown_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.bfd', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.bfd', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.bfd', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'shutdown'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_bpdu_drop_direction_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.bpdu_drop', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.bpdu_drop', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.bpdu_drop', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'direction'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_bpdu_drop_enable_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.bpdu_drop', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.bpdu_drop', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.bpdu_drop', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_channel_group_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.channel_group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.channel_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.channel_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'port_int, mode, type'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_channel_group_mode_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.channel_group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.channel_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.channel_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mode'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_channel_group_port_int_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.channel_group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.channel_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.channel_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'port-int'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_channel_group_type_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.channel_group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.channel_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.channel_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_description_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Instance Keyword Argument Tuple**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'gigabitethernet', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'description'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_deviceconnectivity_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.connectivity', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.connectivity', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.connectivity', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'deviceconnectivity'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_dot1x_authentication_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.dot1x', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.dot1x', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.dot1x', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'authentication'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_dot1x_mac_auth_bypass_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v7_1_0.interface.gigabitethernet.dot1x', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mac-auth-bypass'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_dot1x_mac_auth_enable_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v7_1_0.interface.gigabitethernet.dot1x', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mac-auth-enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_dot1x_port_control_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.dot1x', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.dot1x', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.dot1x', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'port-control'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_dot1x_protocol_version_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.dot1x', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.dot1x', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.dot1x', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'protocol-version'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_dot1x_quiet_period_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.dot1x', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.dot1x', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.dot1x', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'quiet-period'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_dot1x_reauthentication_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.dot1x', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.dot1x', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.dot1x', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'reauthentication'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_dot1x_reauthmax_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.dot1x', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.dot1x', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.dot1x', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'reauthMax'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_dot1x_timeout_re_authperiod_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.dot1x.timeout', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.dot1x.timeout', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.dot1x.timeout', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 're-authperiod'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_dot1x_timeout_server_timeout_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.dot1x.timeout', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.dot1x.timeout', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.dot1x.timeout', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'server-timeout'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_dot1x_timeout_supp_timeout_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.dot1x.timeout', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.dot1x.timeout', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.dot1x.timeout', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'supp-timeout'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_dot1x_timeout_tx_period_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.dot1x.timeout', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.dot1x.timeout', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.dot1x.timeout', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tx-period'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_edge_loop_detection_port_priority_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.edge_loop_detection', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.edge_loop_detection', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.edge_loop_detection', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'port-priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_edge_loop_detection_vlan_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.edge_loop_detection', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.edge_loop_detection', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.edge_loop_detection', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vlan'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_fabric_neighbor_discovery_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.fabric.neighbor_discovery', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.fabric.neighbor_discovery', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.fabric.neighbor_discovery', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_fabric_neighbor_discovery_disable_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.fabric.neighbor_discovery', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.fabric.neighbor_discovery', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.fabric.neighbor_discovery', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'disable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ifindex_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Instance Keyword Argument Tuple**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'gigabitethernet', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ifindex'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ip_access_group_delete(self, gigabitethernet=None, access_group=None, traffic_type=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type access_group: ip_access_list, ip_direction, traffic_type
    :param access_group: Keyword argument tuple.

    :type ip_access_list: unicode
    :param ip_access_list: **access_group** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type ip_direction: unicode
    :param ip_direction: **access_group** tuple argument.

        * enumeration restriction: ::

            ['in', 'out']

    :type traffic_type: unicode
    :param traffic_type: **access_group** tuple argument.

        * enumeration restriction: ::

            ['switched', 'routed']

    **Instance Argument(s)**:

    :type traffic_type: unicode
    :param traffic_type: Keyword argument.

        * enumeration restriction: ::

            ['switched', 'routed']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ip_acl_interface.ip.access_group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ip_acl_interface.ip.access_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ip_acl_interface.ip.access_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'access_group', 'keyval': 'ip_access_list, ip_direction', 'extra_keyval': 'ip_access_list, ip_direction, traffic_type'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, access_group=access_group, traffic_type=traffic_type)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, access_group=access_group, traffic_type=traffic_type)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ip_acl_interface_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ip_acl_interface', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ip_acl_interface', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ip_acl_interface', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ip_address_delete(self, gigabitethernet=None, address=None, secondary=None, ospf_passive=None, ospf_ignore=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type address: address, secondary, ospf_passive, ospf_ignore
    :param address: Keyword argument tuple.

    :type address: unicode
    :param address: **address** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]'
            '|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0'
            '-4][0-9]|25[0-5])/(([1-9])|([1-2][0-9])|(3[0-1])'
            ')'

    :type secondary: YANGBool
    :param secondary: **address** tuple argument:  Secondary ip address on the specific interface

    :type ospf_passive: YANGBool
    :param ospf_passive: **address** tuple argument:  ospf pasive address on the specific interface

    :type ospf_ignore: YANGBool
    :param ospf_ignore: **address** tuple argument:  ospf active address on the specific interface

    **Instance Argument(s)**:

    :type secondary: YANGBool
    :param secondary: Secondary ip address on the specific interface

    :type ospf_passive: YANGBool
    :param ospf_passive: ospf pasive address on the specific interface

    :type ospf_ignore: YANGBool
    :param ospf_ignore: ospf active address on the specific interface

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ip.ip_config.address', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ip.ip_config.address', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ip.ip_config.address', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'address', 'keyval': 'address', 'extra_keyval': 'address, secondary, ospf_passive, ospf_ignore'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, address=address, secondary=secondary, ospf_passive=ospf_passive, ospf_ignore=ospf_ignore)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, address=address, secondary=secondary, ospf_passive=ospf_passive, ospf_ignore=ospf_ignore)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ip_address_ospf_ignore_delete(self, gigabitethernet=None, address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type address: address
    :param address: Keyword argument tuple.

    :type address: unicode
    :param address: **address** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]'
            '|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0'
            '-4][0-9]|25[0-5])/(([1-9])|([1-2][0-9])|(3[0-1])'
            ')'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ip.ip_config.address', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ip.ip_config.address', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ip.ip_config.address', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'address', 'keyval': 'address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ospf-ignore'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, address=address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, address=address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ip_address_ospf_passive_delete(self, gigabitethernet=None, address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type address: address
    :param address: Keyword argument tuple.

    :type address: unicode
    :param address: **address** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]'
            '|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0'
            '-4][0-9]|25[0-5])/(([1-9])|([1-2][0-9])|(3[0-1])'
            ')'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ip.ip_config.address', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ip.ip_config.address', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ip.ip_config.address', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'address', 'keyval': 'address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ospf-passive'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, address=address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, address=address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ip_address_secondary_delete(self, gigabitethernet=None, address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type address: address
    :param address: Keyword argument tuple.

    :type address: unicode
    :param address: **address** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]'
            '|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0'
            '-4][0-9]|25[0-5])/(([1-9])|([1-2][0-9])|(3[0-1])'
            ')'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ip.ip_config.address', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ip.ip_config.address', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ip.ip_config.address', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'address', 'keyval': 'address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'secondary'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, address=address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, address=address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ip_arp_aging_timeout_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ip.ip_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ip.ip_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ip.ip_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'arp-aging-timeout'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ip_arp_inspection_trust_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ip.arp_node_config.arp.inspection', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ip.arp_node_config.arp.inspection', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ip.arp_node_config.arp.inspection', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'trust'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ip_arp_ip_config_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet.ip.ip_config.arp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ip.ip_config.arp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ip_arp_learn_any_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet.ip.ip_config.arp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ip.ip_config.arp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'learn-any'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ip_arp_node_config_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ip.arp_node_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ip.arp_node_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ip.arp_node_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ip_dhcp_relay_gateway_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ip.interface_gi_dhcp_conf.dhcp.relay', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ip.interface_gi_dhcp_conf.dhcp.relay', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ip.interface_gi_dhcp_conf.dhcp.relay', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'gateway'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ip_dhcp_relay_servers_delete(self, gigabitethernet=None, servers=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type servers: relay_ip_addr, server_vrf_name
    :param servers: Keyword argument tuple.

    :type relay_ip_addr: unicode
    :param relay_ip_addr: **servers** tuple argument:  A.B.C.D;; IP address of the DHCP server

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type server_vrf_name: unicode
    :param server_vrf_name: **servers** tuple argument:  VRF name of the DHCP server

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ip.interface_gi_dhcp_conf.dhcp.relay.servers', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ip.interface_gi_dhcp_conf.dhcp.relay.servers', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ip.interface_gi_dhcp_conf.dhcp.relay.servers', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'servers', 'keyval': 'relay_ip_addr, server_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, servers=servers)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, servers=servers)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ip_directed_broadcast_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ip.ip_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ip.ip_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ip.ip_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'directed-broadcast'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ip_icmp_address_mask_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ip.icmp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ip.icmp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ip.icmp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'address-mask'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ip_icmp_echo_reply_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ip.icmp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ip.icmp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ip.icmp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'echo-reply'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ip_icmp_rate_limiting_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ip.icmp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ip.icmp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ip.icmp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rate-limiting'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ip_icmp_redirect_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ip.icmp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ip.icmp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ip.icmp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redirect'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ip_icmp_unreachable_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ip.icmp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ip.icmp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ip.icmp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'unreachable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ip_igmp_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v6_0_2c.interface.gigabitethernet.ip.igmp_phy_intf_cfg.igmp": {"immediate_leave": "immediate_leave", "last_member_query_interval": "last_member_query_interval", "query_interval": "query_interval", "query_max_response_time": "query_max_response_time"}, "pybind.nos.v7_0_1b.interface.gigabitethernet.ip.igmp_phy_intf_cfg.igmp": {}, "pybind.nos.v7_1_0.interface.gigabitethernet.ip.igmp_phy_intf_cfg.igmp": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ip_igmp_immediate_leave_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'immediate-leave'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ip_igmp_last_member_query_count_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'last-member-query-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ip_igmp_last_member_query_interval_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'last-member-query-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ip_igmp_phy_intf_cfg_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ip.igmp_phy_intf_cfg', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ip.igmp_phy_intf_cfg', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ip.igmp_phy_intf_cfg', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ip_igmp_query_interval_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'query-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ip_igmp_query_max_response_time_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'query-max-response-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ip_igmp_robustness_variable_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'robustness-variable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ip_igmp_startup_query_count_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'startup-query-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ip_igmp_startup_query_interval_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'startup-query-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ip_igmp_static_group_delete(self, gigabitethernet=None, static_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type static_group: sg_addr
    :param static_group: Keyword argument tuple.

    :type sg_addr: unicode
    :param sg_addr: **static_group** tuple argument:  Multicast Address to be Joined in the format A.B.C.D

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ip.igmp_phy_intf_cfg.igmp.static_group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ip.igmp_phy_intf_cfg.igmp.static_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ip.igmp_phy_intf_cfg.igmp.static_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'static_group', 'keyval': 'sg_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, static_group=static_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, static_group=static_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ip_interface_gi_dhcp_conf_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ip.interface_gi_dhcp_conf', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ip.interface_gi_dhcp_conf', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ip.interface_gi_dhcp_conf', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ip_interface_gi_ospf_conf_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ip.interface_gi_ospf_conf', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ip.interface_gi_ospf_conf', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ip.interface_gi_ospf_conf', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ip_ip_config_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ip.ip_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ip.ip_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ip.ip_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ip_mtu_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ip.ip_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ip.ip_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ip.ip_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mtu'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ip_multicast_boundary_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'multicast-boundary'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ip_ospf_active_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'active'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ip_ospf_area_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'area'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ip_ospf_auth_change_wait_time_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'auth-change-wait-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ip_ospf_authentication_key_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.authentication_key', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.authentication_key', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.authentication_key', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ip_ospf_authentication_key_auth_key_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.authentication_key.auth_key_table', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.authentication_key.auth_key_table', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.authentication_key.auth_key_table', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'auth-key'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ip_ospf_authentication_key_auth_key_table_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.authentication_key.auth_key_table', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.authentication_key.auth_key_table', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.authentication_key.auth_key_table', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'encrypttype, auth_key'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ip_ospf_authentication_key_encrypttype_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.authentication_key.auth_key_table', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.authentication_key.auth_key_table', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.authentication_key.auth_key_table', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'encrypttype'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ip_ospf_authentication_key_no_encrypt_auth_key_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.authentication_key.no_encrypt_auth_key_table', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.authentication_key.no_encrypt_auth_key_table', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.authentication_key.no_encrypt_auth_key_table', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'no-encrypt-auth-key'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ip_ospf_authentication_key_no_encrypt_auth_key_table_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.authentication_key.no_encrypt_auth_key_table', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.authentication_key.no_encrypt_auth_key_table', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.authentication_key.no_encrypt_auth_key_table', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ip_ospf_bfd_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.bfd', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.bfd', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.bfd', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ip_ospf_bfd_intf_bfd_enable_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.bfd', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.bfd', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.bfd', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'intf-bfd-enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ip_ospf_cost_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cost'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ip_ospf_database_filter_all_external_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'all-external'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ip_ospf_database_filter_all_out_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'all-out'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ip_ospf_database_filter_all_summary_external_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'all-summary-external'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ip_ospf_dead_interval_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dead-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ip_ospf_hello_interval_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hello-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ip_ospf_md5_authentication_key_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.md5_authentication.no_encrypt_key_table', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.md5_authentication.no_encrypt_key_table', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.md5_authentication.no_encrypt_key_table', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'key'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ip_ospf_md5_authentication_key_activation_wait_time_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.md5_authentication', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.md5_authentication', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.md5_authentication', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'key-activation-wait-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ip_ospf_md5_authentication_key_id_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.md5_authentication.no_encrypt_key_table', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.md5_authentication.no_encrypt_key_table', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.md5_authentication.no_encrypt_key_table', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'key-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ip_ospf_md5_authentication_key_id_key_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.md5_authentication.key_table', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.md5_authentication.key_table', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.md5_authentication.key_table', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'key'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ip_ospf_md5_authentication_key_id_key_id_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.md5_authentication.key_table', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.md5_authentication.key_table', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.md5_authentication.key_table', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'key-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ip_ospf_md5_authentication_key_id_md5_authentication_key_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.md5_authentication.key_table', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.md5_authentication.key_table', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.md5_authentication.key_table', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'md5-authentication-key'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ip_ospf_mtu_ignore_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mtu-ignore'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ip_ospf_network_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'network'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ip_ospf_passive_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'passive'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ip_ospf_priority_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ip_ospf_retransmit_interval_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'retransmit-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ip_ospf_transmit_delay_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'transmit-delay'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ip_pbr_interface_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ip_pbr_interface', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ip_pbr_interface', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ip_pbr_interface', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ip_pim_dr_priority_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd.pim', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd.pim', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd.pim', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dr-priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ip_pim_int_cmd_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ip_pim_intf_phy_cont_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ip.pim_intf_phy_cont', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ip.pim_intf_phy_cont', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ip.pim_intf_phy_cont', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ip_pim_multinet_enable_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v7_1_0.interface.gigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd.pim.multinet', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ip_pim_neighbor_filter_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd.pim', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd.pim', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd.pim', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'neighbor-filter'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ip_pim_sparse_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'pim-sparse'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ip_policy_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ip_pbr_interface.ip.policy', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ip_pbr_interface.ip.policy', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ip_pbr_interface.ip.policy', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ip_policy_route_map_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ip_pbr_interface.ip.policy.route_map', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ip_pbr_interface.ip.policy.route_map', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ip_pbr_interface.ip.policy.route_map', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ip_policy_route_map_route_map_name_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ip_pbr_interface.ip.policy.route_map', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ip_pbr_interface.ip.policy.route_map', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ip_pbr_interface.ip.policy.route_map', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ip_proxy_arp_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ip.ip_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ip.ip_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ip.ip_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'proxy-arp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ip_unnumbered_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet.ip.ip_config.unnumbered', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ip.ip_config.unnumbered', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'ip_donor_interface_type, ip_donor_interface_name'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ip_unnumbered_ip_donor_interface_name_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet.ip.ip_config.unnumbered', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ip.ip_config.unnumbered', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ip-donor-interface-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ip_unnumbered_ip_donor_interface_type_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet.ip.ip_config.unnumbered', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ip.ip_config.unnumbered', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ip-donor-interface-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_access_group_delete(self, gigabitethernet=None, access_group=None, traffic_type=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type access_group: ipv6_access_list, ip_direction, traffic_type
    :param access_group: Keyword argument tuple.

    :type ipv6_access_list: unicode
    :param ipv6_access_list: **access_group** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type ip_direction: unicode
    :param ip_direction: **access_group** tuple argument.

        * enumeration restriction: ::

            ['in', 'out']

    :type traffic_type: unicode
    :param traffic_type: **access_group** tuple argument.

        * enumeration restriction: ::

            ['switched', 'routed']

    **Instance Argument(s)**:

    :type traffic_type: unicode
    :param traffic_type: Keyword argument.

        * enumeration restriction: ::

            ['switched', 'routed']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.access_group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.access_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.access_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'access_group', 'keyval': 'ipv6_access_list, ip_direction', 'extra_keyval': 'ipv6_access_list, ip_direction, traffic_type'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, access_group=access_group, traffic_type=traffic_type)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, access_group=access_group, traffic_type=traffic_type)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_access_group_traffic_type_delete(self, gigabitethernet=None, access_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type access_group: ipv6_access_list, ip_direction
    :param access_group: Keyword argument tuple.

    :type ipv6_access_list: unicode
    :param ipv6_access_list: **access_group** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type ip_direction: unicode
    :param ip_direction: **access_group** tuple argument.

        * enumeration restriction: ::

            ['in', 'out']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.access_group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.access_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.access_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'access_group', 'keyval': 'ipv6_access_list, ip_direction', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'traffic-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, access_group=access_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, access_group=access_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_address_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.ipv6_config.address', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.ipv6_config.address', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.ipv6_config.address', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_address_ipv6_address_delete(self, gigabitethernet=None, ipv6_address=None, secondary=None, anycast=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ipv6_address: address, secondary, anycast
    :param ipv6_address: Keyword argument tuple.

    :type address: unicode
    :param address: **ipv6_address** tuple argument:  A:B::C:D/LEN;; IPv6 prefix format: xxxx:xxxx/ml, xxxx:xxxx::/ml, xxxx::xx/128

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type secondary: YANGBool
    :param secondary: **ipv6_address** tuple argument:  Configure Secondary ipv6 address on an interface

    :type anycast: YANGBool
    :param anycast: **ipv6_address** tuple argument:  Configure ipv6 address as anycast

    **Instance Argument(s)**:

    :type secondary: YANGBool
    :param secondary: Configure Secondary ipv6 address on an interface

    :type anycast: YANGBool
    :param anycast: Configure ipv6 address as anycast

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_address', 'keyval': 'address', 'extra_keyval': 'address, secondary, anycast'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, ipv6_address=ipv6_address, secondary=secondary, anycast=anycast)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, ipv6_address=ipv6_address, secondary=secondary, anycast=anycast)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_address_ipv6_address_anycast_delete(self, gigabitethernet=None, ipv6_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ipv6_address: address
    :param ipv6_address: Keyword argument tuple.

    :type address: unicode
    :param address: **ipv6_address** tuple argument:  A:B::C:D/LEN;; IPv6 prefix format: xxxx:xxxx/ml, xxxx:xxxx::/ml, xxxx::xx/128

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_address', 'keyval': 'address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'anycast'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, ipv6_address=ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, ipv6_address=ipv6_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_address_ipv6_address_eui_64_delete(self, gigabitethernet=None, ipv6_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type ipv6_address: address, secondary, anycast
    :param ipv6_address: Keyword argument tuple.

    :type address: unicode
    :param address: **ipv6_address** tuple argument:  A:B::C:D/LEN;; IPv6 prefix format: xxxx:xxxx/ml, xxxx:xxxx::/ml, xxxx::xx/128

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type secondary: YANGBool
    :param secondary: **ipv6_address** tuple argument:  Configure Secondary ipv6 address on an interface

    :type anycast: YANGBool
    :param anycast: **ipv6_address** tuple argument:  Configure ipv6 address as anycast

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.ipv6_config.address.ipv6_address', u'ipv6_address'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.ipv6_config.address.ipv6_address', u'ipv6_address'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.ipv6_config.address.ipv6_address', u'ipv6_address')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.ipv6_config.address.ipv6_address.eui_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.ipv6_config.address.ipv6_address.eui_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.ipv6_config.address.ipv6_address.eui_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'address', 'extra_keyval': 'address, secondary, anycast'}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'address', 'extra_keyval': 'address, secondary, anycast'}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'address', 'extra_keyval': 'address, secondary, anycast'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'eui-64'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, ipv6_address=ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, ipv6_address=ipv6_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_address_ipv6_address_secondary_delete(self, gigabitethernet=None, ipv6_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ipv6_address: address
    :param ipv6_address: Keyword argument tuple.

    :type address: unicode
    :param address: **ipv6_address** tuple argument:  A:B::C:D/LEN;; IPv6 prefix format: xxxx:xxxx/ml, xxxx:xxxx::/ml, xxxx::xx/128

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_address', 'keyval': 'address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'secondary'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, ipv6_address=ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, ipv6_address=ipv6_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_address_ipv6_address_secondary_eui_config_delete(self, gigabitethernet=None, ipv6_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type ipv6_address: address, secondary, anycast
    :param ipv6_address: Keyword argument tuple.

    :type address: unicode
    :param address: **ipv6_address** tuple argument:  A:B::C:D/LEN;; IPv6 prefix format: xxxx:xxxx/ml, xxxx:xxxx::/ml, xxxx::xx/128

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type secondary: YANGBool
    :param secondary: **ipv6_address** tuple argument:  Configure Secondary ipv6 address on an interface

    :type anycast: YANGBool
    :param anycast: **ipv6_address** tuple argument:  Configure ipv6 address as anycast

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.ipv6_config.address.ipv6_address', u'ipv6_address'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.ipv6_config.address.ipv6_address', u'ipv6_address'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.ipv6_config.address.ipv6_address', u'ipv6_address')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.ipv6_config.address.ipv6_address.eui_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.ipv6_config.address.ipv6_address.eui_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.ipv6_config.address.ipv6_address.eui_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'address', 'extra_keyval': 'address, secondary, anycast'}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'address', 'extra_keyval': 'address, secondary, anycast'}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'address', 'extra_keyval': 'address, secondary, anycast'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'secondary'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, ipv6_address=ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, ipv6_address=ipv6_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_address_link_local_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'link-local'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_address_link_local_address_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'link-local-address'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_address_link_local_config_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'link_local_address, link_local'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_address_use_link_local_only_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.ipv6_config.address', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.ipv6_config.address', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.ipv6_config.address', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'use-link-local-only'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_dhcp_relay_servers_delete(self, gigabitethernet=None, servers=None, server_vrf_name=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type servers: relay_ip_addr, server_vrf_name
    :param servers: Keyword argument tuple.

    :type relay_ip_addr: unicode
    :param relay_ip_addr: **servers** tuple argument:  IPv6 address of the DHCPv6 server

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type server_vrf_name: unicode
    :param server_vrf_name: **servers** tuple argument:  VRF name of the DHCPv6 server

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Argument(s)**:

    :type server_vrf_name: unicode
    :param server_vrf_name: VRF name of the DHCPv6 server

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'servers', 'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, servers=servers, server_vrf_name=server_vrf_name)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, servers=servers, server_vrf_name=server_vrf_name)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_dhcp_relay_servers_interface_delete(self, gigabitethernet=None, servers=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type servers: relay_ip_addr, server_vrf_name
    :param servers: Keyword argument tuple.

    :type relay_ip_addr: unicode
    :param relay_ip_addr: **servers** tuple argument:  IPv6 address of the DHCPv6 server

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type server_vrf_name: unicode
    :param server_vrf_name: **servers** tuple argument:  VRF name of the DHCPv6 server

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', u'servers'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', u'servers'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', u'servers')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers.interface', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers.interface', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers.interface', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'interface_type, interface_name'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, servers=servers)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, servers=servers)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_dhcp_relay_servers_interface_interface_delete(self, gigabitethernet=None, servers=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type servers: relay_ip_addr, server_vrf_name
    :param servers: Keyword argument tuple.

    :type relay_ip_addr: unicode
    :param relay_ip_addr: **servers** tuple argument:  IPv6 address of the DHCPv6 server

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type server_vrf_name: unicode
    :param server_vrf_name: **servers** tuple argument:  VRF name of the DHCPv6 server

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', u'servers'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', u'servers'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', u'servers')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers.interface', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers.interface', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers.interface', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'interface'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, servers=servers)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, servers=servers)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_dhcp_relay_servers_interface_interface_name_delete(self, gigabitethernet=None, servers=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type servers: relay_ip_addr, server_vrf_name
    :param servers: Keyword argument tuple.

    :type relay_ip_addr: unicode
    :param relay_ip_addr: **servers** tuple argument:  IPv6 address of the DHCPv6 server

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type server_vrf_name: unicode
    :param server_vrf_name: **servers** tuple argument:  VRF name of the DHCPv6 server

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', u'servers'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', u'servers'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', u'servers')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers.interface', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers.interface', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers.interface', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'interface-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, servers=servers)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, servers=servers)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_dhcp_relay_servers_use_vrf_delete(self, gigabitethernet=None, servers=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type servers: relay_ip_addr
    :param servers: Keyword argument tuple.

    :type relay_ip_addr: unicode
    :param relay_ip_addr: **servers** tuple argument:  IPv6 address of the DHCPv6 server

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'servers', 'keyval': 'relay_ip_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'use-vrf'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, servers=servers)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, servers=servers)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_hop_by_hop_trap_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.ipv6_phy_intf_cmds', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.ipv6_phy_intf_cmds', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.ipv6_phy_intf_cmds', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hop-by-hop-trap'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_icmpv6_echo_reply_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.icmpv6', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.icmpv6', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.icmpv6', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'echo-reply'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_icmpv6_rate_limiting_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.icmpv6', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.icmpv6', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.icmpv6', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rate-limiting'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_icmpv6_redirect_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.icmpv6', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.icmpv6', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.icmpv6', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redirect'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_icmpv6_unreachable_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.icmpv6', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.icmpv6', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.icmpv6', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'unreachable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_interface_phy_dhcp_conf_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.interface_phy_dhcp_conf', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.interface_phy_dhcp_conf', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.interface_phy_dhcp_conf', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_ipv6_config_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.ipv6_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.ipv6_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.ipv6_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_ipv6_intf_cmds_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_ipv6_nd_ra_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.ipv6_nd_ra', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.ipv6_nd_ra', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.ipv6_nd_ra', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_ipv6_phy_intf_cmds_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.ipv6_phy_intf_cmds', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.ipv6_phy_intf_cmds', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.ipv6_phy_intf_cmds', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_mtu_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.ipv6_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.ipv6_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.ipv6_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mtu'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_nd_broadcast_mac_trap_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'broadcast-mac-trap'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_nd_cache_expire_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.cache', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.cache', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.cache', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'expire'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_nd_dad_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.dad', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.dad', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.dad', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_nd_dad_attempts_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.dad', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.dad', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.dad', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'attempts'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_nd_dad_time_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.dad', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.dad', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.dad', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_nd_hoplimit_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hoplimit'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_nd_managed_config_flag_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'managed-config-flag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_nd_mtu_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mtu'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_nd_ns_interval_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ns-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_nd_nud_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_nd_nud_retry_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'base, interval, max_attempts'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_nd_nud_retry_base_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'base'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_nd_nud_retry_interval_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_nd_nud_retry_max_attempts_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'max-attempts'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_nd_other_config_flag_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'other-config-flag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_nd_prefix_delete(self, gigabitethernet=None, prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix', 'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, prefix=prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_nd_prefix_infinite_delete(self, gigabitethernet=None, prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'infinite'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, prefix=prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_nd_prefix_infinite_preferred_delete(self, gigabitethernet=None, prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'infinite'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, prefix=prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_nd_prefix_no_advertise_delete(self, gigabitethernet=None, prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'no-advertise'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, prefix=prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_nd_prefix_no_autoconfig_delete(self, gigabitethernet=None, prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'no-autoconfig'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, prefix=prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_nd_prefix_no_onlink_delete(self, gigabitethernet=None, prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'no-onlink'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, prefix=prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_nd_prefix_off_link_delete(self, gigabitethernet=None, prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'off-link'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, prefix=prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_nd_prefix_preferred_delete(self, gigabitethernet=None, prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'preferred_lifetime, preferred_infinite'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred': [u'preferred_infinite', u'preferred_lifetime'], 'pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred': [u'preferred_infinite', u'preferred_lifetime'], 'pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred': [u'preferred_infinite', u'preferred_lifetime']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, prefix=prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_nd_prefix_preferred_lifetime_delete(self, gigabitethernet=None, prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'preferred-lifetime'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, prefix=prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_nd_prefix_prefix_flags_delete(self, gigabitethernet=None, prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'no_autoconfig, no_onlink, off_link'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, prefix=prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_nd_prefix_valid_lifetime_delete(self, gigabitethernet=None, prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'valid-lifetime'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, prefix=prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_nd_proxy_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'proxy'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_nd_ra_interval_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_interval', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_interval', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_interval', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'max_interval, min_'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_nd_ra_interval_max_interval_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_interval', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_interval', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_interval', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'max-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_nd_ra_interval_min_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_interval', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_interval', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_interval', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'min'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_nd_ra_lifetime_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ra-lifetime'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_nd_reachable_time_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'reachable-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_nd_retrans_timer_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'retrans-timer'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_nd_set_cache_expire_time_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'set-cache-expire-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_nd_set_hoplimit_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'set-hoplimit'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_nd_suppress_ra_all_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'all'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_nd_suppress_ra_mtu_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mtu'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_nd_suppress_ra_suppress_ra_flag_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'suppress-ra-flag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_neighbor_delete(self, gigabitethernet=None, neighbor=None, hardware_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type neighbor: ipv6_address
    :param neighbor: Keyword argument tuple.

    :type ipv6_address: unicode
    :param ipv6_address: **neighbor** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    **Instance Argument(s)**:

    :type hardware_address: unicode
    :param hardware_address: Keyword argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.neighbor', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.neighbor', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.neighbor', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'neighbor', 'keyval': 'ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, neighbor=neighbor, hardware_address=hardware_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, neighbor=neighbor, hardware_address=hardware_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_neighbor_hardware_address_delete(self, gigabitethernet=None, neighbor=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type neighbor: ipv6_address
    :param neighbor: Keyword argument tuple.

    :type ipv6_address: unicode
    :param ipv6_address: **neighbor** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.neighbor', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.neighbor', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.neighbor', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'neighbor', 'keyval': 'ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hardware-address'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, neighbor=neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, neighbor=neighbor)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_ospf_active_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'active'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_ospf_area_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'area'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_ospf_authentication_ah_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ah'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_ospf_authentication_esp_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'esp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_ospf_authentication_esp_auth_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'esp-auth'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_ospf_authentication_esp_key_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'esp-key'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_ospf_authentication_esp_no_encrypt_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'esp-no-encrypt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_ospf_authentication_ipsec_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_ospf_authentication_ipsec_disable_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'disable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_ospf_authentication_ipsec_key_add_remove_interval_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'key-add-remove-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_ospf_authentication_key_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'key'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_ospf_authentication_no_encrypt_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'no-encrypt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_ospf_authentication_spi_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'spi'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_ospf_bfd_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.interface_ospfv3_conf.bfd', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.interface_ospfv3_conf.bfd', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.interface_ospfv3_conf.bfd', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_ospf_bfd_bfd_enable_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.interface_ospfv3_conf.bfd', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.interface_ospfv3_conf.bfd', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.interface_ospfv3_conf.bfd', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bfd-enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_ospf_cost_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cost'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_ospf_dead_interval_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dead-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_ospf_hello_interval_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hello-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_ospf_hello_jitter_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hello-jitter'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_ospf_instance_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'instance'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_ospf_link_interval_properties_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_ospf_mtu_ignore_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mtu-ignore'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_ospf_network_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'network'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_ospf_passive_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'passive'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_ospf_priority_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_ospf_retransmit_interval_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'retransmit-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_ospf_suppress_linklsa_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'suppress-linklsa'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_ospf_transmit_delay_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'transmit-delay'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_policy_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.policy', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.policy', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.policy', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_policy_route_map_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.policy.route_map', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.policy.route_map', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.policy.route_map', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_policy_route_map_ipv6_route_map_name_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.policy.route_map', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.policy.route_map', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.policy.route_map', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ipv6-route-map-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_raguard_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'raguard'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_vrrp_extended_group_delete(self, gigabitethernet=None, vrrpv3e_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_vrrp_extended_group_advertise_backup_delete(self, gigabitethernet=None, vrrpv3e_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'advertise-backup'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_vrrp_extended_group_advertisement_interval_delete(self, gigabitethernet=None, vrrpv3e_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'advertisement-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_vrrp_extended_group_advertisement_interval_scale_delete(self, gigabitethernet=None, vrrpv3e_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'advertisement-interval-scale'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_vrrp_extended_group_backup_advertisement_interval_delete(self, gigabitethernet=None, vrrpv3e_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'backup-advertisement-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_vrrp_extended_group_description_delete(self, gigabitethernet=None, vrrpv3e_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'description'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_vrrp_extended_group_enable_delete(self, gigabitethernet=None, vrrpv3e_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_vrrp_extended_group_hold_time_delete(self, gigabitethernet=None, vrrpv3e_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hold-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_vrrp_extended_group_nd_advertisement_timer_delete(self, gigabitethernet=None, vrrpv3e_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'nd-advertisement-timer'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_vrrp_extended_group_preempt_mode_delete(self, gigabitethernet=None, vrrpv3e_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'preempt-mode'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_vrrp_extended_group_priority_delete(self, gigabitethernet=None, vrrpv3e_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_vrrp_extended_group_short_path_forwarding_delete(self, gigabitethernet=None, vrrpv3e_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.vrrpv3e_group.short_path_forwarding', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'basic, revert_priority'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_vrrp_extended_group_short_path_forwarding_basic_delete(self, gigabitethernet=None, vrrpv3e_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.vrrpv3e_group.short_path_forwarding', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.vrrpv3e_group.short_path_forwarding', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.vrrpv3e_group.short_path_forwarding', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'basic'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_vrrp_extended_group_short_path_forwarding_revert_priority_delete(self, gigabitethernet=None, vrrpv3e_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.vrrpv3e_group.short_path_forwarding', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.vrrpv3e_group.short_path_forwarding', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.vrrpv3e_group.short_path_forwarding', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'revert-priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_vrrp_extended_group_track_interface_delete(self, gigabitethernet=None, vrrpv3e_group=None, interface=None, track_priority=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Argument(s)**:

    :type track_priority: int
    :param track_priority: Track Priority

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.vrrpv3e_group.track.interface', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.vrrpv3e_group.track.interface', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.vrrpv3e_group.track.interface', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, vrrpv3e_group=vrrpv3e_group, interface=interface, track_priority=track_priority)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, vrrpv3e_group=vrrpv3e_group, interface=interface, track_priority=track_priority)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_vrrp_extended_group_track_interface_priority_delete(self, gigabitethernet=None, vrrpv3e_group=None, interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.vrrpv3e_group.track.interface', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.vrrpv3e_group.track.interface', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.vrrpv3e_group.track.interface', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, vrrpv3e_group=vrrpv3e_group, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, vrrpv3e_group=vrrpv3e_group, interface=interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_vrrp_extended_group_virtual_ip_delete(self, gigabitethernet=None, vrrpv3e_group=None, virtual_ip=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type virtual_ip: virtual_ipaddr
    :param virtual_ip: Keyword argument tuple.

    :type virtual_ipaddr: unicode
    :param virtual_ipaddr: **virtual_ip** tuple argument:  Virtual IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.vrrpv3e_group.virtual_ip', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.vrrpv3e_group.virtual_ip', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.vrrpv3e_group.virtual_ip', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'virtual_ip', 'keyval': 'virtual_ipaddr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, vrrpv3e_group=vrrpv3e_group, virtual_ip=virtual_ip)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, vrrpv3e_group=vrrpv3e_group, virtual_ip=virtual_ip)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_vrrp_group_delete(self, gigabitethernet=None, vrrpv3_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, vrrpv3_group=vrrpv3_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, vrrpv3_group=vrrpv3_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_vrrp_group_advertisement_interval_delete(self, gigabitethernet=None, vrrpv3_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'advertisement-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, vrrpv3_group=vrrpv3_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, vrrpv3_group=vrrpv3_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_vrrp_group_description_delete(self, gigabitethernet=None, vrrpv3_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'description'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, vrrpv3_group=vrrpv3_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, vrrpv3_group=vrrpv3_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_vrrp_group_enable_delete(self, gigabitethernet=None, vrrpv3_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, vrrpv3_group=vrrpv3_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, vrrpv3_group=vrrpv3_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_vrrp_group_hold_time_delete(self, gigabitethernet=None, vrrpv3_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hold-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, vrrpv3_group=vrrpv3_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, vrrpv3_group=vrrpv3_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_vrrp_group_preempt_mode_delete(self, gigabitethernet=None, vrrpv3_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'preempt-mode'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, vrrpv3_group=vrrpv3_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, vrrpv3_group=vrrpv3_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_vrrp_group_priority_delete(self, gigabitethernet=None, vrrpv3_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, vrrpv3_group=vrrpv3_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, vrrpv3_group=vrrpv3_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_vrrp_group_track_interface_delete(self, gigabitethernet=None, vrrpv3_group=None, interface=None, track_priority=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Argument(s)**:

    :type track_priority: int
    :param track_priority: Track Priority

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.vrrpv3_group', u'vrrpv3_group'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.vrrpv3_group', u'vrrpv3_group'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.vrrpv3_group', u'vrrpv3_group')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.vrrpv3_group.track.interface', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.vrrpv3_group.track.interface', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.vrrpv3_group.track.interface', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, vrrpv3_group=vrrpv3_group, interface=interface, track_priority=track_priority)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, vrrpv3_group=vrrpv3_group, interface=interface, track_priority=track_priority)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_vrrp_group_track_interface_priority_delete(self, gigabitethernet=None, vrrpv3_group=None, interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.vrrpv3_group', u'vrrpv3_group'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.vrrpv3_group', u'vrrpv3_group'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.vrrpv3_group', u'vrrpv3_group')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.vrrpv3_group.track.interface', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.vrrpv3_group.track.interface', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.vrrpv3_group.track.interface', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, vrrpv3_group=vrrpv3_group, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, vrrpv3_group=vrrpv3_group, interface=interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_vrrp_group_use_v2_checksum_delete(self, gigabitethernet=None, vrrpv3_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'use-v2-checksum'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, vrrpv3_group=vrrpv3_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, vrrpv3_group=vrrpv3_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_vrrp_group_virtual_ip_delete(self, gigabitethernet=None, vrrpv3_group=None, virtual_ip=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type virtual_ip: virtual_ipaddr
    :param virtual_ip: Keyword argument tuple.

    :type virtual_ipaddr: unicode
    :param virtual_ipaddr: **virtual_ip** tuple argument:  Virtual IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.vrrpv3_group', u'vrrpv3_group'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.vrrpv3_group', u'vrrpv3_group'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.vrrpv3_group', u'vrrpv3_group')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.vrrpv3_group.virtual_ip', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.vrrpv3_group.virtual_ip', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.vrrpv3_group.virtual_ip', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'virtual_ip', 'keyval': 'virtual_ipaddr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, vrrpv3_group=vrrpv3_group, virtual_ip=virtual_ip)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, vrrpv3_group=vrrpv3_group, virtual_ip=virtual_ip)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_ipv6_vrrp_suppress_interface_ra_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vrrp-suppress-interface-ra'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_lacp_default_up_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.lacp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.lacp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.lacp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'default-up'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_lacp_port_priority_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.lacp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.lacp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.lacp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'port-priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_lacp_timeout_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.lacp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.lacp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.lacp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'timeout'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_lldp_cee_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.lldp.cee', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.lldp.cee', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.lldp.cee', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_lldp_cee_lldp_cee_on_off_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.lldp.cee', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.lldp.cee', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.lldp.cee', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lldp-cee-on-off'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_lldp_dcbx_version_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.lldp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.lldp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.lldp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dcbx-version'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_lldp_disable_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.lldp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.lldp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.lldp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'disable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_lldp_iscsi_priority_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.lldp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.lldp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.lldp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'iscsi-priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_lldp_profile_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.lldp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.lldp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.lldp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'profile'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_mac_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.mac', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.mac', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.mac', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_mac_access_group_delete(self, gigabitethernet=None, access_group=None, traffic_type=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type access_group: mac_access_list, mac_direction, traffic_type
    :param access_group: Keyword argument tuple.

    :type mac_access_list: unicode
    :param mac_access_list: **access_group** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type mac_direction: unicode
    :param mac_direction: **access_group** tuple argument.

        * enumeration restriction: ::

            ['in', 'out']

    :type traffic_type: unicode
    :param traffic_type: **access_group** tuple argument.

        * enumeration restriction: ::

            ['switched', 'routed']

    **Instance Argument(s)**:

    :type traffic_type: unicode
    :param traffic_type: Keyword argument.

        * enumeration restriction: ::

            ['switched', 'routed']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.mac.access_group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.mac.access_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.mac.access_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'access_group', 'keyval': 'mac_access_list, mac_direction', 'extra_keyval': 'mac_access_list, mac_direction, traffic_type'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, access_group=access_group, traffic_type=traffic_type)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, access_group=access_group, traffic_type=traffic_type)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_mac_learning_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.mac_learning', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.mac_learning', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.mac_learning', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_mac_learning_disable_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.mac_learning.mac_learn_disable', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.mac_learning.mac_learn_disable', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.mac_learning.mac_learn_disable', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_mac_learning_disable_vlan_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.mac_learning.mac_learn_disable.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.mac_learning.mac_learn_disable.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.mac_learning.mac_learn_disable.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_mac_learning_disable_vlan_add_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.mac_learning.mac_learn_disable.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.mac_learning.mac_learn_disable.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.mac_learning.mac_learn_disable.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'add'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_mac_learning_disable_vlan_remove_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.mac_learning.mac_learn_disable.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.mac_learning.mac_learn_disable.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.mac_learning.mac_learn_disable.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'remove'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_mtu_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Instance Keyword Argument Tuple**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'gigabitethernet', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mtu'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_openflow_enable_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.openflow_interface_cfg.openflow_enable', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.openflow_interface_cfg.openflow_enable', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.openflow_interface_cfg.openflow_enable', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_openflow_logical_instance_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.openflow_interface_cfg', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.openflow_interface_cfg', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.openflow_interface_cfg', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'logical-instance'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_openflow_match_profile_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.openflow_interface_cfg.openflow_enable', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.openflow_interface_cfg.openflow_enable', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.openflow_interface_cfg.openflow_enable', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'match-profile'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_openflow_openflow_enable_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.openflow_interface_cfg.openflow_enable', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.openflow_interface_cfg.openflow_enable', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.openflow_interface_cfg.openflow_enable', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'enable, match_profile'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_port_profile_port_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Instance Keyword Argument Tuple**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'gigabitethernet', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'port-profile-port'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_port_profile_port_domain_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.port_profile_to_interface_associations.port_profile_port.port_to_port_profile_domain_association', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.port_profile_to_interface_associations.port_profile_port.port_to_port_profile_domain_association', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.port_profile_to_interface_associations.port_profile_port.port_to_port_profile_domain_association', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_port_profile_port_domain_profile_domain_name_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.port_profile_to_interface_associations.port_profile_port.port_to_port_profile_domain_association', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.port_profile_to_interface_associations.port_profile_port.port_to_port_profile_domain_association', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.port_profile_to_interface_associations.port_profile_port.port_to_port_profile_domain_association', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'profile-domain-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_port_profile_port_profile_delete(self, gigabitethernet=None, port_to_port_profile_associations=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type port_to_port_profile_associations: port_to_port_profile_association
    :param port_to_port_profile_associations: Keyword argument tuple.

    :type port_to_port_profile_association: unicode
    :param port_to_port_profile_association: **port_to_port_profile_associations** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.port_profile_to_interface_associations.port_profile_port.port_to_port_profile_associations', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.port_profile_to_interface_associations.port_profile_port.port_to_port_profile_associations', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.port_profile_to_interface_associations.port_profile_port.port_to_port_profile_associations', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'port_to_port_profile_associations', 'keyval': 'port_to_port_profile_association', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, port_to_port_profile_associations=port_to_port_profile_associations)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, port_to_port_profile_associations=port_to_port_profile_associations)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_port_profile_to_interface_associations_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.port_profile_to_interface_associations', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.port_profile_to_interface_associations', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.port_profile_to_interface_associations', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_priority_tag_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Instance Keyword Argument Tuple**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'gigabitethernet', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority-tag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_qos_cos_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.qos', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.qos', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.qos', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cos'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_qos_cos_mutation_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.qos', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.qos', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.qos', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cos-mutation'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_qos_cos_traffic_class_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.qos', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.qos', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.qos', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cos-traffic-class'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_qos_drop_monitor_enable_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.qos.drop_monitor', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.qos.drop_monitor', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.qos.drop_monitor', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_qos_dscp_cos_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.qos', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.qos', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.qos', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dscp-cos'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_qos_dscp_mutation_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.qos', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.qos', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.qos', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dscp-mutation'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_qos_dscp_traffic_class_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.qos', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.qos', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.qos', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dscp-traffic-class'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_qos_flowcontrol_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.qos.flowcontrol', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.qos.flowcontrol', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.qos.flowcontrol', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_qos_flowcontrol_link_level_flowcontrol_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.qos.flowcontrol.link_level_flowcontrol', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.qos.flowcontrol.link_level_flowcontrol', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.qos.flowcontrol.link_level_flowcontrol', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_qos_flowcontrol_rx_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.qos.flowcontrol.link_level_flowcontrol', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.qos.flowcontrol.link_level_flowcontrol', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.qos.flowcontrol.link_level_flowcontrol', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_qos_flowcontrol_tx_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.qos.flowcontrol.link_level_flowcontrol', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.qos.flowcontrol.link_level_flowcontrol', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.qos.flowcontrol.link_level_flowcontrol', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_qos_random_detect_traffic_class_delete(self, gigabitethernet=None, traffic_class=None, red_enable=None, red_profile_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type traffic_class: red_tc_value
    :param traffic_class: Keyword argument tuple.

    :type red_tc_value: long
    :param red_tc_value: **traffic_class** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Argument(s)**:

    :type red_enable: YANGBool
    :param red_enable: Keyword for VDX 6710,6720,6730,6746,2730

    :type red_profile_id: long
    :param red_profile_id: Keyword for all other VDX platforms

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.qos.random_detect.traffic_class', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.qos.random_detect.traffic_class', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.qos.random_detect.traffic_class', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'traffic_class', 'keyval': 'red_tc_value', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, traffic_class=traffic_class, red_enable=red_enable, red_profile_id=red_profile_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, traffic_class=traffic_class, red_enable=red_enable, red_profile_id=red_profile_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_qos_random_detect_traffic_class_apply_delete(self, gigabitethernet=None, traffic_class=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type traffic_class: red_tc_value
    :param traffic_class: Keyword argument tuple.

    :type red_tc_value: long
    :param red_tc_value: **traffic_class** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.qos.random_detect.traffic_class', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.qos.random_detect.traffic_class', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.qos.random_detect.traffic_class', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'traffic_class', 'keyval': 'red_tc_value', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'apply'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, traffic_class=traffic_class)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, traffic_class=traffic_class)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_qos_random_detect_traffic_class_red_profile_id_delete(self, gigabitethernet=None, traffic_class=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type traffic_class: red_tc_value
    :param traffic_class: Keyword argument tuple.

    :type red_tc_value: long
    :param red_tc_value: **traffic_class** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.qos.random_detect.traffic_class', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.qos.random_detect.traffic_class', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.qos.random_detect.traffic_class', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'traffic_class', 'keyval': 'red_tc_value', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'red-profile-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, traffic_class=traffic_class)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, traffic_class=traffic_class)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_qos_rcv_queue_cos_threshold_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.qos.rcv_queue.cos_threshold', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.qos.rcv_queue.cos_threshold', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.qos.rcv_queue.cos_threshold', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_qos_rcv_queue_cos_threshold_cos0_threshold_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.qos.rcv_queue.cos_threshold', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.qos.rcv_queue.cos_threshold', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.qos.rcv_queue.cos_threshold', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cos0-threshold'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_qos_rcv_queue_cos_threshold_cos1_threshold_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.qos.rcv_queue.cos_threshold', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.qos.rcv_queue.cos_threshold', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.qos.rcv_queue.cos_threshold', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cos1-threshold'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_qos_rcv_queue_cos_threshold_cos2_threshold_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.qos.rcv_queue.cos_threshold', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.qos.rcv_queue.cos_threshold', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.qos.rcv_queue.cos_threshold', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cos2-threshold'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_qos_rcv_queue_cos_threshold_cos3_threshold_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.qos.rcv_queue.cos_threshold', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.qos.rcv_queue.cos_threshold', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.qos.rcv_queue.cos_threshold', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cos3-threshold'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_qos_rcv_queue_cos_threshold_cos4_threshold_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.qos.rcv_queue.cos_threshold', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.qos.rcv_queue.cos_threshold', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.qos.rcv_queue.cos_threshold', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cos4-threshold'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_qos_rcv_queue_cos_threshold_cos5_threshold_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.qos.rcv_queue.cos_threshold', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.qos.rcv_queue.cos_threshold', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.qos.rcv_queue.cos_threshold', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cos5-threshold'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_qos_rcv_queue_cos_threshold_cos6_threshold_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.qos.rcv_queue.cos_threshold', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.qos.rcv_queue.cos_threshold', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.qos.rcv_queue.cos_threshold', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cos6-threshold'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_qos_rcv_queue_cos_threshold_cos7_threshold_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.qos.rcv_queue.cos_threshold', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.qos.rcv_queue.cos_threshold', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.qos.rcv_queue.cos_threshold', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cos7-threshold'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_qos_trust_cos_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.qos.trust', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.qos.trust', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.qos.trust', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cos'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_qos_trust_dscp_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.qos.trust', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.qos.trust', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.qos.trust', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dscp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_rmon_collection_history_delete(self, gigabitethernet=None, history_control_entry=None, history_control_buckets_requested=None, history_control_interval=None, history_control_owner=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type history_control_entry: history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner
    :param history_control_entry: Keyword argument tuple.

    :type history_control_index: long
    :param history_control_index: **history_control_entry** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type history_control_buckets_requested: long
    :param history_control_buckets_requested: **history_control_entry** tuple argument:  Buckets (default 50)

        * range restriction: ::

            ['-2147483648..2147483647']

    :type history_control_interval: long
    :param history_control_interval: **history_control_entry** tuple argument:  Polling Interval (default 1800)

        * range restriction: ::

            ['-2147483648..2147483647']

    :type history_control_owner: unicode
    :param history_control_owner: **history_control_entry** tuple argument:  Owner identity

        * length restriction: ::

            ['1 .. 15']

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,14})'

    **Instance Argument(s)**:

    :type history_control_buckets_requested: long
    :param history_control_buckets_requested: Buckets (default 50)

        * range restriction: ::

            ['-2147483648..2147483647']

    :type history_control_interval: long
    :param history_control_interval: Polling Interval (default 1800)

        * range restriction: ::

            ['-2147483648..2147483647']

    :type history_control_owner: unicode
    :param history_control_owner: Owner identity

        * length restriction: ::

            ['1 .. 15']

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,14})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.rmon.collection.history_control_entry', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.rmon.collection.history_control_entry', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.rmon.collection.history_control_entry', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'history_control_entry', 'keyval': 'history_control_index', 'extra_keyval': 'history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, history_control_entry=history_control_entry, history_control_buckets_requested=history_control_buckets_requested, history_control_interval=history_control_interval, history_control_owner=history_control_owner)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, history_control_entry=history_control_entry, history_control_buckets_requested=history_control_buckets_requested, history_control_interval=history_control_interval, history_control_owner=history_control_owner)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_rmon_collection_history_buckets_delete(self, gigabitethernet=None, history_control_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type history_control_entry: history_control_index
    :param history_control_entry: Keyword argument tuple.

    :type history_control_index: long
    :param history_control_index: **history_control_entry** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.rmon.collection.history_control_entry', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.rmon.collection.history_control_entry', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.rmon.collection.history_control_entry', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'history_control_entry', 'keyval': 'history_control_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'buckets'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, history_control_entry=history_control_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, history_control_entry=history_control_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_rmon_collection_history_interval_delete(self, gigabitethernet=None, history_control_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type history_control_entry: history_control_index
    :param history_control_entry: Keyword argument tuple.

    :type history_control_index: long
    :param history_control_index: **history_control_entry** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.rmon.collection.history_control_entry', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.rmon.collection.history_control_entry', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.rmon.collection.history_control_entry', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'history_control_entry', 'keyval': 'history_control_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, history_control_entry=history_control_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, history_control_entry=history_control_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_rmon_collection_history_owner_delete(self, gigabitethernet=None, history_control_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type history_control_entry: history_control_index
    :param history_control_entry: Keyword argument tuple.

    :type history_control_index: long
    :param history_control_index: **history_control_entry** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.rmon.collection.history_control_entry', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.rmon.collection.history_control_entry', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.rmon.collection.history_control_entry', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'history_control_entry', 'keyval': 'history_control_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'owner'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, history_control_entry=history_control_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, history_control_entry=history_control_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_rmon_collection_stats_delete(self, gigabitethernet=None, ether_stats_entry=None, ether_stats_owner=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ether_stats_entry: ether_stats_index, ether_stats_owner
    :param ether_stats_entry: Keyword argument tuple.

    :type ether_stats_index: long
    :param ether_stats_index: **ether_stats_entry** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type ether_stats_owner: unicode
    :param ether_stats_owner: **ether_stats_entry** tuple argument:  Owner identity

        * length restriction: ::

            ['1 .. 15']

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,14})'

    **Instance Argument(s)**:

    :type ether_stats_owner: unicode
    :param ether_stats_owner: Owner identity

        * length restriction: ::

            ['1 .. 15']

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,14})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.rmon.collection.ether_stats_entry', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.rmon.collection.ether_stats_entry', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.rmon.collection.ether_stats_entry', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ether_stats_entry', 'keyval': 'ether_stats_index', 'extra_keyval': 'ether_stats_index, ether_stats_owner'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, ether_stats_entry=ether_stats_entry, ether_stats_owner=ether_stats_owner)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, ether_stats_entry=ether_stats_entry, ether_stats_owner=ether_stats_owner)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_rmon_collection_stats_owner_delete(self, gigabitethernet=None, ether_stats_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ether_stats_entry: ether_stats_index
    :param ether_stats_entry: Keyword argument tuple.

    :type ether_stats_index: long
    :param ether_stats_index: **ether_stats_entry** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.rmon.collection.ether_stats_entry', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.rmon.collection.ether_stats_entry', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.rmon.collection.ether_stats_entry', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ether_stats_entry', 'keyval': 'ether_stats_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'owner'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, ether_stats_entry=ether_stats_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, ether_stats_entry=ether_stats_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_service_policy_in_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.service_policy', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.service_policy', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.service_policy', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'in'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_service_policy_out_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.service_policy', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.service_policy', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.service_policy', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'out'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_sflow_enable_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.sflow', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.sflow', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.sflow', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_sflow_polling_interval_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.sflow', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.sflow', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.sflow', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'polling-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_sflow_sample_rate_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.sflow', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.sflow', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.sflow', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'sample-rate'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_shutdown_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Instance Keyword Argument Tuple**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'gigabitethernet', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'shutdown'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_snmp_trap_link_status_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.snmp.trap', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.snmp.trap', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.snmp.trap', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'link-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_spanning_tree_autoedge_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.spanning_tree', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.spanning_tree', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.spanning_tree', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'autoedge'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_spanning_tree_bpdu_mac_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.spanning_tree', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.spanning_tree', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.spanning_tree', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bpdu-mac'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_spanning_tree_cost_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.spanning_tree', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.spanning_tree', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.spanning_tree', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cost'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_spanning_tree_edgeport_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.spanning_tree.edgeport', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.spanning_tree.edgeport', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.spanning_tree.edgeport', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_spanning_tree_edgeport_bpdu_filter_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.spanning_tree.edgeport', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.spanning_tree.edgeport', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.spanning_tree.edgeport', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bpdu-filter'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_spanning_tree_edgeport_bpdu_guard_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.spanning_tree.edgeport', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.spanning_tree.edgeport', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.spanning_tree.edgeport', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bpdu-guard'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_spanning_tree_edgeport_edgeportbasic_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.spanning_tree.edgeport', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.spanning_tree.edgeport', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.spanning_tree.edgeport', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'edgeportbasic'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_spanning_tree_guard_root_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.spanning_tree.guard', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.spanning_tree.guard', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.spanning_tree.guard', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'root'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_spanning_tree_hello_time_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.spanning_tree', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.spanning_tree', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.spanning_tree', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hello-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_spanning_tree_instance_cost_delete(self, gigabitethernet=None, instance=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type instance: id
    :param instance: Keyword argument tuple.

    :type id: int
    :param id: **instance** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.spanning_tree.instance', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.spanning_tree.instance', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.spanning_tree.instance', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instance', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cost'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, instance=instance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, instance=instance)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_spanning_tree_instance_priority_delete(self, gigabitethernet=None, instance=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type instance: id
    :param instance: Keyword argument tuple.

    :type id: int
    :param id: **instance** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.spanning_tree.instance', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.spanning_tree.instance', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.spanning_tree.instance', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instance', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, instance=instance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, instance=instance)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_spanning_tree_instance_restricted_role_delete(self, gigabitethernet=None, instance=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type instance: id
    :param instance: Keyword argument tuple.

    :type id: int
    :param id: **instance** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.spanning_tree.instance', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.spanning_tree.instance', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.spanning_tree.instance', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instance', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'restricted-role'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, instance=instance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, instance=instance)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_spanning_tree_instance_restricted_tcn_delete(self, gigabitethernet=None, instance=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type instance: id
    :param instance: Keyword argument tuple.

    :type id: int
    :param id: **instance** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.spanning_tree.instance', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.spanning_tree.instance', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.spanning_tree.instance', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instance', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'restricted-tcn'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, instance=instance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, instance=instance)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_spanning_tree_link_type_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.spanning_tree', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.spanning_tree', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.spanning_tree', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'link-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_spanning_tree_portfast_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.spanning_tree.portfast', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.spanning_tree.portfast', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.spanning_tree.portfast', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_spanning_tree_portfast_bpdu_filter_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.spanning_tree.portfast', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.spanning_tree.portfast', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.spanning_tree.portfast', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bpdu-filter'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_spanning_tree_portfast_bpdu_guard_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.spanning_tree.portfast', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.spanning_tree.portfast', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.spanning_tree.portfast', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bpdu-guard'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_spanning_tree_portfast_portfastbasic_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.spanning_tree.portfast', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.spanning_tree.portfast', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.spanning_tree.portfast', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'portfastbasic'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_spanning_tree_priority_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.spanning_tree', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.spanning_tree', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.spanning_tree', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_spanning_tree_restricted_role_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.spanning_tree', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.spanning_tree', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.spanning_tree', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'restricted-role'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_spanning_tree_restricted_tcn_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.spanning_tree', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.spanning_tree', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.spanning_tree', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'restricted-tcn'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_spanning_tree_shutdown_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.spanning_tree', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.spanning_tree', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.spanning_tree', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'shutdown'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_spanning_tree_vlan_cost_delete(self, gigabitethernet=None, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vlan: id
    :param vlan: Keyword argument tuple.

    :type id: long
    :param id: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.spanning_tree.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.spanning_tree.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.spanning_tree.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cost'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_spanning_tree_vlan_guard_root_delete(self, gigabitethernet=None, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vlan: id
    :param vlan: Keyword argument tuple.

    :type id: long
    :param id: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.spanning_tree.vlan', u'vlan'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet.spanning_tree.vlan', u'vlan'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet.spanning_tree.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.spanning_tree.vlan.guard', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.spanning_tree.vlan.guard', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.spanning_tree.vlan.guard', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'root'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_spanning_tree_vlan_priority_delete(self, gigabitethernet=None, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vlan: id
    :param vlan: Keyword argument tuple.

    :type id: long
    :param id: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.spanning_tree.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.spanning_tree.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.spanning_tree.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_storm_control_ingress_delete(self, gigabitethernet=None, ingress=None, rate_format=None, rate_bps=None, rate_percent=None, bum_action=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ingress: protocol_type, rate_format, rate_bps, rate_percent, bum_action
    :param ingress: Keyword argument tuple.

    :type protocol_type: unicode
    :param protocol_type: **ingress** tuple argument.

        * enumeration restriction: ::

            ['broadcast', 'unknown-unicast', 'multicast']

    :type rate_format: unicode
    :param rate_format: **ingress** tuple argument.

        * enumeration restriction: ::

            ['limit-bps', 'limit-percent']

    :type rate_bps: long
    :param rate_bps: **ingress** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type rate_percent: long
    :param rate_percent: **ingress** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type bum_action: unicode
    :param bum_action: **ingress** tuple argument.

        * enumeration restriction: ::

            ['monitor', 'shutdown']

    **Instance Argument(s)**:

    :type rate_format: unicode
    :param rate_format: Keyword argument.

        * enumeration restriction: ::

            ['limit-bps', 'limit-percent']

    :type rate_bps: long
    :param rate_bps: Keyword argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type rate_percent: long
    :param rate_percent: Keyword argument.

        * range restriction: ::

            ['0..4294967295']

    :type bum_action: unicode
    :param bum_action: Keyword argument.

        * enumeration restriction: ::

            ['monitor', 'shutdown']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.storm_control.ingress', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.storm_control.ingress', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.storm_control.ingress', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ingress', 'keyval': 'protocol_type', 'extra_keyval': 'protocol_type, rate_format, rate_bps, rate_percent, bum_action'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, ingress=ingress, rate_format=rate_format, rate_bps=rate_bps, rate_percent=rate_percent, bum_action=bum_action)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, ingress=ingress, rate_format=rate_format, rate_bps=rate_bps, rate_percent=rate_percent, bum_action=bum_action)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_storm_control_ingress_bum_action_delete(self, gigabitethernet=None, ingress=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ingress: protocol_type
    :param ingress: Keyword argument tuple.

    :type protocol_type: unicode
    :param protocol_type: **ingress** tuple argument.

        * enumeration restriction: ::

            ['broadcast', 'unknown-unicast', 'multicast']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.storm_control.ingress', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.storm_control.ingress', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.storm_control.ingress', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ingress', 'keyval': 'protocol_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bum-action'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, ingress=ingress)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, ingress=ingress)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_storm_control_ingress_rate_bps_delete(self, gigabitethernet=None, ingress=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ingress: protocol_type
    :param ingress: Keyword argument tuple.

    :type protocol_type: unicode
    :param protocol_type: **ingress** tuple argument.

        * enumeration restriction: ::

            ['broadcast', 'unknown-unicast', 'multicast']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.storm_control.ingress', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.storm_control.ingress', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.storm_control.ingress', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ingress', 'keyval': 'protocol_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rate-bps'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, ingress=ingress)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, ingress=ingress)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_storm_control_ingress_rate_format_delete(self, gigabitethernet=None, ingress=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ingress: protocol_type
    :param ingress: Keyword argument tuple.

    :type protocol_type: unicode
    :param protocol_type: **ingress** tuple argument.

        * enumeration restriction: ::

            ['broadcast', 'unknown-unicast', 'multicast']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.storm_control.ingress', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.storm_control.ingress', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.storm_control.ingress', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ingress', 'keyval': 'protocol_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rate-format'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, ingress=ingress)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, ingress=ingress)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_storm_control_ingress_rate_percent_delete(self, gigabitethernet=None, ingress=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ingress: protocol_type
    :param ingress: Keyword argument tuple.

    :type protocol_type: unicode
    :param protocol_type: **ingress** tuple argument.

        * enumeration restriction: ::

            ['broadcast', 'unknown-unicast', 'multicast']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.storm_control.ingress', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.storm_control.ingress', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.storm_control.ingress', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ingress', 'keyval': 'protocol_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rate-percent'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, ingress=ingress)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, ingress=ingress)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_switchport_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.switchport_basic', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.switchport_basic', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.switchport_basic', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'switchport'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_switchport_access_mac_group_rspan_vlan_classification_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.switchport.access_mac_group_rspan_vlan_classification', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.switchport.access_mac_group_rspan_vlan_classification', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.switchport.access_mac_group_rspan_vlan_classification', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_switchport_access_mac_group_vlan_classification_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.switchport.access_mac_group_vlan_classification', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.switchport.access_mac_group_vlan_classification', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.switchport.access_mac_group_vlan_classification', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_switchport_access_mac_rspan_vlan_classification_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.switchport.access_mac_rspan_vlan_classification', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.switchport.access_mac_rspan_vlan_classification', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.switchport.access_mac_rspan_vlan_classification', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_switchport_access_mac_vlan_classification_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.switchport.access_mac_vlan_classification', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.switchport.access_mac_vlan_classification', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.switchport.access_mac_vlan_classification', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_switchport_access_rspan_vlan_delete(self, gigabitethernet=None, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vlan: access_vlan_id, access_mac_group
    :param vlan: Keyword argument tuple.

    :type access_vlan_id: long
    :param access_vlan_id: **vlan** tuple argument:  Set the default VLAN for the interface

        * range restriction: ::

            ['0..4294967295']

    :type access_mac_group: long
    :param access_mac_group: **vlan** tuple argument:  Associate a Mac group with a vlan

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.switchport.access_mac_group_rspan_vlan_classification.access.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.switchport.access_mac_group_rspan_vlan_classification.access.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.switchport.access_mac_group_rspan_vlan_classification.access.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'access_vlan_id, access_mac_group', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_switchport_access_rspan_vlan_access_mac_rspan_vlan_classification_delete(self, gigabitethernet=None, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vlan: access_vlan_id, access_mac_address
    :param vlan: Keyword argument tuple.

    :type access_vlan_id: long
    :param access_vlan_id: **vlan** tuple argument:  Set the default VLAN for the interface

        * range restriction: ::

            ['0..4294967295']

    :type access_mac_address: unicode
    :param access_mac_address: **vlan** tuple argument:  Associate the Mac address with a vlan

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.switchport.access_mac_rspan_vlan_classification.access.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.switchport.access_mac_rspan_vlan_classification.access.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.switchport.access_mac_rspan_vlan_classification.access.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'access_vlan_id, access_mac_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_switchport_access_vlan_delete(self, gigabitethernet=None, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vlan: access_vlan_id, access_mac_group
    :param vlan: Keyword argument tuple.

    :type access_vlan_id: long
    :param access_vlan_id: **vlan** tuple argument:  Set the default VLAN for the interface

        * range restriction: ::

            ['0..4294967295']

    :type access_mac_group: long
    :param access_mac_group: **vlan** tuple argument:  Associate a Mac group with a vlan

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.switchport.access_mac_group_vlan_classification.access.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.switchport.access_mac_group_vlan_classification.access.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.switchport.access_mac_group_vlan_classification.access.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'access_vlan_id, access_mac_group', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_switchport_access_vlan_access_mac_vlan_classification_delete(self, gigabitethernet=None, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vlan: access_vlan_id, access_mac_address
    :param vlan: Keyword argument tuple.

    :type access_vlan_id: long
    :param access_vlan_id: **vlan** tuple argument:  Set the default VLAN for the interface

        * range restriction: ::

            ['0..4294967295']

    :type access_mac_address: unicode
    :param access_mac_address: **vlan** tuple argument:  Associate the Mac address with a vlan

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.switchport.access_mac_vlan_classification.access.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.switchport.access_mac_vlan_classification.access.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.switchport.access_mac_vlan_classification.access.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'access_vlan_id, access_mac_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_switchport_basic_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.switchport_basic', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.switchport_basic', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.switchport_basic', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_switchport_mode_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.switchport.mode', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.switchport.mode', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.switchport.mode', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_switchport_mode_private_vlan_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.switchport.mode.private_vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.switchport.mode.private_vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.switchport.mode.private_vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_switchport_mode_private_vlan_host_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.switchport.mode.private_vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.switchport.mode.private_vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.switchport.mode.private_vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'host'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_switchport_mode_private_vlan_promiscuous_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.switchport.mode.private_vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.switchport.mode.private_vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.switchport.mode.private_vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'promiscuous'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_switchport_mode_private_vlan_trunk_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.switchport.mode.private_vlan.private_vlan_trunk', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.switchport.mode.private_vlan.private_vlan_trunk', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.switchport.mode.private_vlan.private_vlan_trunk', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_switchport_mode_private_vlan_trunk_host_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.switchport.mode.private_vlan.private_vlan_trunk', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.switchport.mode.private_vlan.private_vlan_trunk', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.switchport.mode.private_vlan.private_vlan_trunk', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'host'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_switchport_mode_private_vlan_trunk_promiscuous_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.switchport.mode.private_vlan.private_vlan_trunk', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.switchport.mode.private_vlan.private_vlan_trunk', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.switchport.mode.private_vlan.private_vlan_trunk', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'promiscuous'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_switchport_mode_private_vlan_trunk_trunk_basic_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.switchport.mode.private_vlan.private_vlan_trunk', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.switchport.mode.private_vlan.private_vlan_trunk', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.switchport.mode.private_vlan.private_vlan_trunk', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'trunk-basic'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_switchport_mode_vlan_mode_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.switchport.mode', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.switchport.mode', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.switchport.mode', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vlan-mode'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_switchport_port_security_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.switchport.port_security', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.switchport.port_security', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.switchport.port_security', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_switchport_port_security_allowed_ouis_delete(self, gigabitethernet=None, allowed_ouis=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type allowed_ouis: oui
    :param allowed_ouis: Keyword argument tuple.

    :type oui: unicode
    :param oui: **allowed_ouis** tuple argument:  <OUI> OUI in HHHH.HH00.0000 format

        * pattern restriction: ::

            '[0-9a-fA-F]{4}\.[0-9a-fA-F]{2}00\.0000'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.switchport.port_security.allowed_ouis', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.switchport.port_security.allowed_ouis', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.switchport.port_security.allowed_ouis', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'allowed_ouis', 'keyval': 'oui', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, allowed_ouis=allowed_ouis)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, allowed_ouis=allowed_ouis)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_switchport_port_security_max_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.switchport.port_security', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.switchport.port_security', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.switchport.port_security', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'max'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_switchport_port_security_port_secutiry_mac_address_delete(self, gigabitethernet=None, port_secutiry_mac_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type port_secutiry_mac_address: mac_address, port_sec_vlan
    :param port_secutiry_mac_address: Keyword argument tuple.

    :type mac_address: unicode
    :param mac_address: **port_secutiry_mac_address** tuple argument:  Mac Address

    :type port_sec_vlan: long
    :param port_sec_vlan: **port_secutiry_mac_address** tuple argument:  Forwarding vlan

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.switchport.port_security.port_secutiry_mac_address', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.switchport.port_security.port_secutiry_mac_address', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.switchport.port_security.port_secutiry_mac_address', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'port_secutiry_mac_address', 'keyval': 'mac_address, port_sec_vlan', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, port_secutiry_mac_address=port_secutiry_mac_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, port_secutiry_mac_address=port_secutiry_mac_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_switchport_port_security_shutdown_time_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.switchport.port_security', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.switchport.port_security', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.switchport.port_security', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'shutdown-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_switchport_port_security_sticky_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet.switchport.port_security.sticky', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.switchport.port_security.sticky', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_switchport_port_security_sticky_port_secutiry_mac_address_delete(self, gigabitethernet=None, port_secutiry_mac_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type port_secutiry_mac_address: mac_address, port_sec_vlan
    :param port_secutiry_mac_address: Keyword argument tuple.

    :type mac_address: unicode
    :param mac_address: **port_secutiry_mac_address** tuple argument:  Mac Address

    :type port_sec_vlan: long
    :param port_sec_vlan: **port_secutiry_mac_address** tuple argument:  Forwarding vlan

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.switchport.port_security.sticky.port_secutiry_mac_address', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.switchport.port_security.sticky.port_secutiry_mac_address', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.switchport.port_security.sticky.port_secutiry_mac_address', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'port_secutiry_mac_address', 'keyval': 'mac_address, port_sec_vlan', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, port_secutiry_mac_address=port_secutiry_mac_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, port_secutiry_mac_address=port_secutiry_mac_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_switchport_port_security_sticky_sticky_flag_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.switchport.port_security.sticky', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.switchport.port_security.sticky', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.switchport.port_security.sticky', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'sticky-flag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_switchport_port_security_violation_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.switchport.port_security', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.switchport.port_security', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.switchport.port_security', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'violation'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_switchport_private_vlan_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.switchport.private_vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.switchport.private_vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.switchport.private_vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_switchport_private_vlan_association_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.switchport.private_vlan.association', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.switchport.private_vlan.association', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.switchport.private_vlan.association', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_switchport_private_vlan_association_trunk_delete(self, gigabitethernet=None, trunk=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type trunk: trunk_pri_pvlan, trunk_sec_pvlan
    :param trunk: Keyword argument tuple.

    :type trunk_pri_pvlan: long
    :param trunk_pri_pvlan: **trunk** tuple argument:  Primary vlan id

        * range restriction: ::

            ['0..4294967295']

    :type trunk_sec_pvlan: long
    :param trunk_sec_pvlan: **trunk** tuple argument:  Secondary vlan id 

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.switchport.private_vlan.association.trunk', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.switchport.private_vlan.association.trunk', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.switchport.private_vlan.association.trunk', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'trunk', 'keyval': 'trunk_pri_pvlan, trunk_sec_pvlan', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, trunk=trunk)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, trunk=trunk)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_switchport_private_vlan_host_association_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.switchport.private_vlan.host_association', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.switchport.private_vlan.host_association', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.switchport.private_vlan.host_association', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'host_pri_pvlan, host_sec_pvlan'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_switchport_private_vlan_host_association_host_pri_pvlan_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.switchport.private_vlan.host_association', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.switchport.private_vlan.host_association', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.switchport.private_vlan.host_association', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'host-pri-pvlan'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_switchport_private_vlan_host_association_host_sec_pvlan_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.switchport.private_vlan.host_association', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.switchport.private_vlan.host_association', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.switchport.private_vlan.host_association', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'host-sec-pvlan'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_switchport_private_vlan_mapping_delete(self, gigabitethernet=None, mapping=None, oper=None, promis_sec_pvlan_range=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type mapping: promis_pri_pvlan, oper, promis_sec_pvlan_range
    :param mapping: Keyword argument tuple.

    :type promis_pri_pvlan: long
    :param promis_pri_pvlan: **mapping** tuple argument:  Primary vlan id

        * range restriction: ::

            ['0..4294967295']

    :type oper: unicode
    :param oper: **mapping** tuple argument.

        * enumeration restriction: ::

            ['add', 'delete']

    :type promis_sec_pvlan_range: unicode
    :param promis_sec_pvlan_range: **mapping** tuple argument:  Secondary vlan range

        * length restriction: ::

            ['1..253']

        * pattern restriction: ::

            '(([1-9][0-9]{0,2})|([1-7][0-9]{3})|(80[0-9]{2})|'
            '(81[0-8][0-9])|(819[01]))(-(([2-9])|([1-9][0-9]{'
            '1,2})|([1-7][0-9]{3})|(80[0-9]{2})|(81[0-8][0-9]'
            ')|(819[01])))?((,(([2-9])|([1-9][0-9]{1,2})|([1-'
            '7][0-9]{3})|(80[0-9]{2})|(81[0-8][0-9])|(819[01]'
            '))(-(([3-9])|([1-9][0-9]{1,2})|([1-7][0-9]{3})|('
            '80[0-9]{2})|(81[0-8][0-9])|(819[01])))?)?)*'

    **Instance Argument(s)**:

    :type oper: unicode
    :param oper: Keyword argument.

        * enumeration restriction: ::

            ['add', 'delete']

    :type promis_sec_pvlan_range: unicode
    :param promis_sec_pvlan_range: Secondary vlan range

        * length restriction: ::

            ['1..253']

        * pattern restriction: ::

            '(([1-9][0-9]{0,2})|([1-7][0-9]{3})|(80[0-9]{2})|'
            '(81[0-8][0-9])|(819[01]))(-(([2-9])|([1-9][0-9]{'
            '1,2})|([1-7][0-9]{3})|(80[0-9]{2})|(81[0-8][0-9]'
            ')|(819[01])))?((,(([2-9])|([1-9][0-9]{1,2})|([1-'
            '7][0-9]{3})|(80[0-9]{2})|(81[0-8][0-9])|(819[01]'
            '))(-(([3-9])|([1-9][0-9]{1,2})|([1-7][0-9]{3})|('
            '80[0-9]{2})|(81[0-8][0-9])|(819[01])))?)?)*'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.switchport.private_vlan.mapping', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.switchport.private_vlan.mapping', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.switchport.private_vlan.mapping', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mapping', 'keyval': 'promis_pri_pvlan', 'extra_keyval': 'promis_pri_pvlan, oper, promis_sec_pvlan_range'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, mapping=mapping, oper=oper, promis_sec_pvlan_range=promis_sec_pvlan_range)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, mapping=mapping, oper=oper, promis_sec_pvlan_range=promis_sec_pvlan_range)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_switchport_private_vlan_mapping_oper_delete(self, gigabitethernet=None, mapping=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type mapping: promis_pri_pvlan
    :param mapping: Keyword argument tuple.

    :type promis_pri_pvlan: long
    :param promis_pri_pvlan: **mapping** tuple argument:  Primary vlan id

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.switchport.private_vlan.mapping', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.switchport.private_vlan.mapping', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.switchport.private_vlan.mapping', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mapping', 'keyval': 'promis_pri_pvlan', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'oper'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, mapping=mapping)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, mapping=mapping)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_switchport_private_vlan_mapping_promis_sec_pvlan_range_delete(self, gigabitethernet=None, mapping=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type mapping: promis_pri_pvlan
    :param mapping: Keyword argument tuple.

    :type promis_pri_pvlan: long
    :param promis_pri_pvlan: **mapping** tuple argument:  Primary vlan id

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.switchport.private_vlan.mapping', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.switchport.private_vlan.mapping', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.switchport.private_vlan.mapping', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mapping', 'keyval': 'promis_pri_pvlan', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'promis-sec-pvlan-range'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, mapping=mapping)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, mapping=mapping)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_switchport_private_vlan_trunk_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.switchport.private_vlan.trunk', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.switchport.private_vlan.trunk', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.switchport.private_vlan.trunk', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_switchport_private_vlan_trunk_allowed_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.switchport.private_vlan.trunk.allowed', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.switchport.private_vlan.trunk.allowed', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.switchport.private_vlan.trunk.allowed', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_switchport_private_vlan_trunk_allowed_trunk_private_vlan_classification_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_switchport_private_vlan_trunk_allowed_vlan_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.switchport.private_vlan.trunk.allowed.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.switchport.private_vlan.trunk.allowed.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.switchport.private_vlan.trunk.allowed.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_switchport_private_vlan_trunk_allowed_vlan_add_delete(self, gigabitethernet=None, add=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type add: trunk_vlan_id, trunk_ctag_id
    :param add: Keyword argument tuple.

    :type trunk_vlan_id: long
    :param trunk_vlan_id: **add** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type trunk_ctag_id: long
    :param trunk_ctag_id: **add** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan.add_', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan.add_', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan.add_', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'add', 'keyval': 'trunk_vlan_id, trunk_ctag_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, add=add)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, add=add)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_switchport_private_vlan_trunk_allowed_vlan_all_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.switchport.private_vlan.trunk.allowed.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.switchport.private_vlan.trunk.allowed.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.switchport.private_vlan.trunk.allowed.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'all'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_switchport_private_vlan_trunk_allowed_vlan_except_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.switchport.private_vlan.trunk.allowed.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.switchport.private_vlan.trunk.allowed.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.switchport.private_vlan.trunk.allowed.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'except'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_switchport_private_vlan_trunk_allowed_vlan_none_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.switchport.private_vlan.trunk.allowed.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.switchport.private_vlan.trunk.allowed.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.switchport.private_vlan.trunk.allowed.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'none'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_switchport_private_vlan_trunk_allowed_vlan_remove_delete(self, gigabitethernet=None, remove=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type remove: trunk_vlan_id, trunk_ctag_id
    :param remove: Keyword argument tuple.

    :type trunk_vlan_id: long
    :param trunk_vlan_id: **remove** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type trunk_ctag_id: long
    :param trunk_ctag_id: **remove** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan.remove_', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan.remove_', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan.remove_', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'remove', 'keyval': 'trunk_vlan_id, trunk_ctag_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, remove=remove)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, remove=remove)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_switchport_private_vlan_trunk_allowed_vlan_trunk_private_vlan_classification_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_switchport_private_vlan_trunk_native_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.switchport.private_vlan.trunk.native', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.switchport.private_vlan.trunk.native', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.switchport.private_vlan.trunk.native', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'pvlanNativevlan, pvlan_native_vlan_ctag_id'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_switchport_private_vlan_trunk_native_ctag_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.switchport.private_vlan.trunk.native', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.switchport.private_vlan.trunk.native', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.switchport.private_vlan.trunk.native', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ctag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_switchport_private_vlan_trunk_native_vlan_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.switchport.private_vlan.trunk.native', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.switchport.private_vlan.trunk.native', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.switchport.private_vlan.trunk.native', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vlan'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_switchport_private_vlan_trunk_private_vlan_classification_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.switchport.trunk_private_vlan_classification.private_vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.switchport.trunk_private_vlan_classification.private_vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.switchport.trunk_private_vlan_classification.private_vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_switchport_private_vlan_trunk_tag_native_vlan_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.switchport.private_vlan.trunk.pvlan_tag', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.switchport.private_vlan.trunk.pvlan_tag', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.switchport.private_vlan.trunk.pvlan_tag', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'native-vlan'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_switchport_private_vlan_trunk_trunk_private_vlan_classification_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_switchport_trunk_allowed_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.switchport.trunk.allowed', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.switchport.trunk.allowed', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.switchport.trunk.allowed', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_switchport_trunk_allowed_rspan_vlan_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.switchport.trunk.allowed.rspan_vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.switchport.trunk.allowed.rspan_vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.switchport.trunk.allowed.rspan_vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_switchport_trunk_allowed_rspan_vlan_add_delete(self, gigabitethernet=None, add=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type add: trunk_vlan_id, trunk_ctag_id
    :param add: Keyword argument tuple.

    :type trunk_vlan_id: long
    :param trunk_vlan_id: **add** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type trunk_ctag_id: long
    :param trunk_ctag_id: **add** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan.add_', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan.add_', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan.add_', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'add', 'keyval': 'trunk_vlan_id, trunk_ctag_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, add=add)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, add=add)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_switchport_trunk_allowed_rspan_vlan_remove_delete(self, gigabitethernet=None, remove=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type remove: trunk_vlan_id, trunk_ctag_id
    :param remove: Keyword argument tuple.

    :type trunk_vlan_id: long
    :param trunk_vlan_id: **remove** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type trunk_ctag_id: long
    :param trunk_ctag_id: **remove** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan.remove_', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan.remove_', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan.remove_', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'remove', 'keyval': 'trunk_vlan_id, trunk_ctag_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, remove=remove)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, remove=remove)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_switchport_trunk_allowed_rspan_vlan_trunk_rspan_vlan_classification_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_switchport_trunk_allowed_trunk_rspan_vlan_classification_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_switchport_trunk_allowed_trunk_vlan_classification_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.switchport.trunk.trunk_vlan_classification.allowed', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.switchport.trunk.trunk_vlan_classification.allowed', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.switchport.trunk.trunk_vlan_classification.allowed', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_switchport_trunk_allowed_vlan_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.switchport.trunk.allowed.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.switchport.trunk.allowed.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.switchport.trunk.allowed.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_switchport_trunk_allowed_vlan_add_delete(self, gigabitethernet=None, add=None, trunk_ctag_range=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type add: trunk_vlan_id
    :param add: Keyword argument tuple.

    :type trunk_vlan_id: long
    :param trunk_vlan_id: **add** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Argument(s)**:

    :type trunk_ctag_range: unicode
    :param trunk_ctag_range: Keyword argument.

        * length restriction: ::

            ['1..1000']

        * pattern restriction: ::

            '(([1-9][0-9]{0,2})|([1-3][0-9]{3})|(40[0-8][0-9]'
            ')|(409[0-4]))(-((1[0-9]{1,2})|([2-9][0-9]{0,2})|'
            '([1-3][0-9]{3})|(40[0-8][0-9])|(409[0-4])))?((,('
            '(1[0-9]{1,2})|([2-9][0-9]{0,2})|([1-3][0-9]{3})|'
            '(40[0-8][0-9])|(409[0-4]))(-((1[0-9]{1,2})|([2-9'
            '][0-9]{0,2})|([1-3][0-9]{3})|(40[0-8][0-9])|(409'
            '[0-4])))?)?)*'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan.add_', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan.add_', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan.add_', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'add', 'keyval': 'trunk_vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, add=add, trunk_ctag_range=trunk_ctag_range)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, add=add, trunk_ctag_range=trunk_ctag_range)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_switchport_trunk_allowed_vlan_add_ctag_delete(self, gigabitethernet=None, add=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type add: trunk_vlan_id
    :param add: Keyword argument tuple.

    :type trunk_vlan_id: long
    :param trunk_vlan_id: **add** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan.add_', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan.add_', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan.add_', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'add', 'keyval': 'trunk_vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ctag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, add=add)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, add=add)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_switchport_trunk_allowed_vlan_all_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.switchport.trunk.allowed.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.switchport.trunk.allowed.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.switchport.trunk.allowed.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'all'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_switchport_trunk_allowed_vlan_except_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.switchport.trunk.allowed.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.switchport.trunk.allowed.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.switchport.trunk.allowed.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'except'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_switchport_trunk_allowed_vlan_none_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.switchport.trunk.allowed.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.switchport.trunk.allowed.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.switchport.trunk.allowed.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'none'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_switchport_trunk_allowed_vlan_remove_delete(self, gigabitethernet=None, remove=None, trunk_ctag_range=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type remove: trunk_vlan_id
    :param remove: Keyword argument tuple.

    :type trunk_vlan_id: long
    :param trunk_vlan_id: **remove** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Argument(s)**:

    :type trunk_ctag_range: unicode
    :param trunk_ctag_range: Keyword argument.

        * length restriction: ::

            ['1..1000']

        * pattern restriction: ::

            '(([1-9][0-9]{0,2})|([1-3][0-9]{3})|(40[0-8][0-9]'
            ')|(409[0-4]))(-((1[0-9]{1,2})|([2-9][0-9]{0,2})|'
            '([1-3][0-9]{3})|(40[0-8][0-9])|(409[0-4])))?((,('
            '(1[0-9]{1,2})|([2-9][0-9]{0,2})|([1-3][0-9]{3})|'
            '(40[0-8][0-9])|(409[0-4]))(-((1[0-9]{1,2})|([2-9'
            '][0-9]{0,2})|([1-3][0-9]{3})|(40[0-8][0-9])|(409'
            '[0-4])))?)?)*'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan.remove_', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan.remove_', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan.remove_', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'remove', 'keyval': 'trunk_vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, remove=remove, trunk_ctag_range=trunk_ctag_range)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, remove=remove, trunk_ctag_range=trunk_ctag_range)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_switchport_trunk_allowed_vlan_remove_ctag_delete(self, gigabitethernet=None, remove=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type remove: trunk_vlan_id
    :param remove: Keyword argument tuple.

    :type trunk_vlan_id: long
    :param trunk_vlan_id: **remove** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan.remove_', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan.remove_', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan.remove_', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'remove', 'keyval': 'trunk_vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ctag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, remove=remove)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, remove=remove)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_switchport_trunk_allowed_vlan_trunk_vlan_classification_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_switchport_trunk_allowed_vlanoper_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.switchport.trunk.allowed.vlanoper', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.switchport.trunk.allowed.vlanoper', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.switchport.trunk.allowed.vlanoper', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_switchport_trunk_allowed_vlanoper_vlan_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.switchport.trunk.allowed.vlanoper.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.switchport.trunk.allowed.vlanoper.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.switchport.trunk.allowed.vlanoper.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_switchport_trunk_allowed_vlanoper_vlan_add_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.switchport.trunk.allowed.vlanoper.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.switchport.trunk.allowed.vlanoper.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.switchport.trunk.allowed.vlanoper.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'add'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_switchport_trunk_allowed_vlanoper_vlan_remove_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.switchport.trunk.allowed.vlanoper.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.switchport.trunk.allowed.vlanoper.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.switchport.trunk.allowed.vlanoper.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'remove'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_switchport_trunk_ctag_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.switchport.trunk.native_vlan_classification', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.switchport.trunk.native_vlan_classification', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.switchport.trunk.native_vlan_classification', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ctag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_switchport_trunk_ctag_native_vlan_xtagged_config_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.switchport.trunk.native_vlan_xtagged_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.switchport.trunk.native_vlan_xtagged_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.switchport.trunk.native_vlan_xtagged_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ctag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_switchport_trunk_default_vlan_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.switchport.trunk.default_vlan_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.switchport.trunk.default_vlan_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.switchport.trunk.default_vlan_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'default-vlan'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_switchport_trunk_default_vlan_config_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.switchport.trunk.default_vlan_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.switchport.trunk.default_vlan_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.switchport.trunk.default_vlan_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'default_transparent_vlan'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_switchport_trunk_egress_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.switchport.trunk.native_vlan_xtagged_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.switchport.trunk.native_vlan_xtagged_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.switchport.trunk.native_vlan_xtagged_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'egress'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_switchport_trunk_native_vlan_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.switchport.trunk.native_vlan_classification', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.switchport.trunk.native_vlan_classification', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.switchport.trunk.native_vlan_classification', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'native-vlan'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_switchport_trunk_native_vlan_classification_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.switchport.trunk.native_vlan_classification', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.switchport.trunk.native_vlan_classification', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.switchport.trunk.native_vlan_classification', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'native_vlan_id, native_vlan_ctag_id'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_switchport_trunk_native_vlan_untagged_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.switchport.trunk.native_vlan_untagged_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.switchport.trunk.native_vlan_untagged_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.switchport.trunk.native_vlan_untagged_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'native-vlan-untagged'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_switchport_trunk_native_vlan_untagged_config_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.switchport.trunk.native_vlan_untagged_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.switchport.trunk.native_vlan_untagged_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.switchport.trunk.native_vlan_untagged_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'native_vlan_id_untagged'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_switchport_trunk_native_vlan_xtagged_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.switchport.trunk.native_vlan_xtagged_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.switchport.trunk.native_vlan_xtagged_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.switchport.trunk.native_vlan_xtagged_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'native-vlan-xtagged'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_switchport_trunk_native_vlan_xtagged_config_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.switchport.trunk.native_vlan_xtagged_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.switchport.trunk.native_vlan_xtagged_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.switchport.trunk.native_vlan_xtagged_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_switchport_trunk_private_vlan_classification_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.switchport.trunk_private_vlan_classification', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.switchport.trunk_private_vlan_classification', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.switchport.trunk_private_vlan_classification', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_switchport_trunk_tag_native_vlan_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.switchport.trunk.tag', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.switchport.trunk.tag', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.switchport.trunk.tag', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'native-vlan'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_switchport_trunk_trunk_vlan_classification_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.switchport.trunk.trunk_vlan_classification', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.switchport.trunk.trunk_vlan_classification', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.switchport.trunk.trunk_vlan_classification', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_track_enable_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.track', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.track', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.track', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_track_interface_delete(self, gigabitethernet=None, interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type interface: track_interface_type, track_interface_name
    :param interface: Keyword argument tuple.

    :type track_interface_type: unicode
    :param track_interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 'port-channel']

    :type track_interface_name: unicode
    :param track_interface_name: **interface** tuple argument:  Interface name

        * pattern restriction: ::

            '(((([1-9]|[1-9][0-9]|1[0-9]{2}|2[0-3][0-9])/)?(('
            '[0-9]|1[0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0-9]'
            ')(:[1-4])?)|([1-9]|[1-9][0-9]|[1-9][0-9]{2}|[1-5'
            '][0-9]{3}|6[0-1][0-4]{2}))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.track.interface', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.track.interface', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.track.interface', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'track_interface_type, track_interface_name', 'extra_keyval': 'track_interface_type, track_interface_name'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, interface=interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_track_min_link_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.track', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.track', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.track', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'min-link'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_track_remove_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.track.remove_', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.track.remove_', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.track.remove_', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_track_remove_all_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.track.remove_', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.track.remove_', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.track.remove_', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'all'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_tunable_optics_sfpp_channel_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.gigabitethernet.tunable_optics.sfpp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.tunable_optics.sfpp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'channel'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_tunnel_tagged_ieee_bpdu_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.tunnel', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.tunnel', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.tunnel', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tagged-ieee-bpdu'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_udld_enable_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.udld', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.udld', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.udld', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_vlan_classifier_activate_group_delete(self, gigabitethernet=None, group=None, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type group: groupid, vlan
    :param group: Keyword argument tuple.

    :type groupid: long
    :param groupid: **group** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vlan: long
    :param vlan: **group** tuple argument:  1-8191;;Vlan

        * range restriction: ::

            ['0..4294967295']

    **Instance Argument(s)**:

    :type vlan: long
    :param vlan: 1-8191;;Vlan

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.vlan.classifier.activate.group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.vlan.classifier.activate.group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.vlan.classifier.activate.group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'group', 'keyval': 'groupid', 'extra_keyval': 'groupid, vlan'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, group=group, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, group=group, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_vlan_classifier_activate_group_vlan_delete(self, gigabitethernet=None, group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type group: groupid
    :param group: Keyword argument tuple.

    :type groupid: long
    :param groupid: **group** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.vlan.classifier.activate.group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.vlan.classifier.activate.group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.vlan.classifier.activate.group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'group', 'keyval': 'groupid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vlan'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, group=group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, group=group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_vrf_forwarding_delete(self, gigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.vrf', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.vrf', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.vrf', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'forwarding'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_vrrp_group_delete(self, gigabitethernet=None, vrrp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.vrrp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.vrrp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.vrrp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, vrrp=vrrp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_vrrp_group_advertisement_interval_delete(self, gigabitethernet=None, vrrp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.vrrp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.vrrp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.vrrp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'advertisement-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, vrrp=vrrp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_vrrp_group_arp_unicast_request_receive_delete(self, gigabitethernet=None, vrrp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet.vrrp', u'vrrp'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet.vrrp', u'vrrp'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.vrrp', u'vrrp')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.vrrp.arp.unicast_request', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.vrrp.arp.unicast_request', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.vrrp.arp.unicast_request', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'receive'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, vrrp=vrrp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_vrrp_group_description_delete(self, gigabitethernet=None, vrrp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.vrrp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.vrrp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.vrrp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'description'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, vrrp=vrrp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_vrrp_group_enable_delete(self, gigabitethernet=None, vrrp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.vrrp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.vrrp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.vrrp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, vrrp=vrrp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_vrrp_group_hold_time_delete(self, gigabitethernet=None, vrrp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.vrrp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.vrrp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.vrrp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hold-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, vrrp=vrrp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_vrrp_group_preempt_mode_delete(self, gigabitethernet=None, vrrp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.vrrp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.vrrp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.vrrp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'preempt-mode'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, vrrp=vrrp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_vrrp_group_priority_delete(self, gigabitethernet=None, vrrp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.vrrp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.vrrp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.vrrp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, vrrp=vrrp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_vrrp_group_track_interface_delete(self, gigabitethernet=None, vrrp=None, interface=None, track_priority=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Argument(s)**:

    :type track_priority: int
    :param track_priority: Track Priority

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet.vrrp', u'vrrp'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.vrrp', u'vrrp'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet.vrrp', u'vrrp')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.vrrp.track.interface', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.vrrp.track.interface', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.vrrp.track.interface', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, vrrp=vrrp, interface=interface, track_priority=track_priority)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, vrrp=vrrp, interface=interface, track_priority=track_priority)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_vrrp_group_track_interface_priority_delete(self, gigabitethernet=None, vrrp=None, interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet.vrrp', u'vrrp'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.vrrp', u'vrrp'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet.vrrp', u'vrrp')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.vrrp.track.interface', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.vrrp.track.interface', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.vrrp.track.interface', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, vrrp=vrrp, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, vrrp=vrrp, interface=interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_vrrp_group_use_v2_checksum_delete(self, gigabitethernet=None, vrrp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.vrrp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.vrrp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.vrrp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'use-v2-checksum'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, vrrp=vrrp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_gigabitethernet_vrrp_group_virtual_ip_delete(self, gigabitethernet=None, vrrp=None, virtual_ip=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type virtual_ip: virtual_ipaddr
    :param virtual_ip: Keyword argument tuple.

    :type virtual_ipaddr: unicode
    :param virtual_ipaddr: **virtual_ip** tuple argument:  Virtual IPv4 address in dotted decimal

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_1_0.interface.gigabitethernet.vrrp', u'vrrp'), ('pybind.nos.v7_0_1b.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.vrrp', u'vrrp'), ('pybind.nos.v6_0_2c.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2c.interface.gigabitethernet.vrrp', u'vrrp')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.gigabitethernet.vrrp.virtual_ip', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.gigabitethernet.vrrp.virtual_ip', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.gigabitethernet.vrrp.virtual_ip', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'virtual_ip', 'keyval': 'virtual_ipaddr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, vrrp=vrrp, virtual_ip=virtual_ip)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, vrrp=vrrp, virtual_ip=virtual_ip)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_bfd_interval_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.bfd.interval', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.bfd.interval', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.bfd.interval', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_bfd_interval_min_rx_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.bfd.interval', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.bfd.interval', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.bfd.interval', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'min-rx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_bfd_interval_min_tx_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.bfd.interval', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.bfd.interval', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.bfd.interval', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'min-tx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_bfd_interval_multiplier_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.bfd.interval', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.bfd.interval', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.bfd.interval', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'multiplier'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_bfd_shutdown_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.bfd', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.bfd', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.bfd', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'shutdown'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_bpdu_drop_direction_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.bpdu_drop', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.bpdu_drop', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.bpdu_drop', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'direction'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_bpdu_drop_enable_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.bpdu_drop', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.bpdu_drop', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.bpdu_drop', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_cee_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Instance Keyword Argument Tuple**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'hundredgigabitethernet', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cee'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_channel_group_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.channel_group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.channel_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.channel_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'port_int, mode, type'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_channel_group_mode_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.channel_group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.channel_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.channel_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mode'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_channel_group_port_int_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.channel_group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.channel_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.channel_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'port-int'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_channel_group_type_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.channel_group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.channel_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.channel_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_description_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Instance Keyword Argument Tuple**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'hundredgigabitethernet', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'description'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_deviceconnectivity_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.connectivity', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.connectivity', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.connectivity', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'deviceconnectivity'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_dot1x_authentication_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.dot1x', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.dot1x', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.dot1x', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'authentication'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_dot1x_mac_auth_bypass_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet.dot1x', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mac-auth-bypass'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_dot1x_mac_auth_enable_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet.dot1x', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mac-auth-enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_dot1x_port_control_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.dot1x', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.dot1x', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.dot1x', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'port-control'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_dot1x_protocol_version_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.dot1x', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.dot1x', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.dot1x', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'protocol-version'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_dot1x_quiet_period_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.dot1x', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.dot1x', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.dot1x', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'quiet-period'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_dot1x_reauthentication_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.dot1x', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.dot1x', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.dot1x', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'reauthentication'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_dot1x_reauthmax_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.dot1x', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.dot1x', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.dot1x', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'reauthMax'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_dot1x_timeout_re_authperiod_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.dot1x.timeout', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.dot1x.timeout', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.dot1x.timeout', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 're-authperiod'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_dot1x_timeout_server_timeout_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.dot1x.timeout', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.dot1x.timeout', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.dot1x.timeout', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'server-timeout'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_dot1x_timeout_supp_timeout_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.dot1x.timeout', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.dot1x.timeout', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.dot1x.timeout', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'supp-timeout'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_dot1x_timeout_tx_period_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.dot1x.timeout', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.dot1x.timeout', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.dot1x.timeout', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tx-period'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_edge_loop_detection_port_priority_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.edge_loop_detection', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.edge_loop_detection', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.edge_loop_detection', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'port-priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_edge_loop_detection_vlan_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.edge_loop_detection', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.edge_loop_detection', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.edge_loop_detection', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vlan'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_fabric_dport_enable_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.fabric.fabric_dport', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_fabric_dport_mode_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.fabric.fabric_dport', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.fabric.fabric_dport', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mode'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_fabric_isl_enable_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.fabric.fabric_isl', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.fabric.fabric_isl', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.fabric.fabric_isl', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_fabric_neighbor_discovery_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.fabric.neighbor_discovery', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.fabric.neighbor_discovery', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.fabric.neighbor_discovery', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_fabric_neighbor_discovery_disable_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.fabric.neighbor_discovery', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.fabric.neighbor_discovery', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.fabric.neighbor_discovery', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'disable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_fabric_trunk_enable_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.fabric.fabric_trunk', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.fabric.fabric_trunk', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.fabric.fabric_trunk', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_fcoeport_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.fcoeport', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.fcoeport', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.fcoeport', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'fcoeport_map, ns_ip_registration'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_fcoeport_map_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.fcoeport', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.fcoeport', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.fcoeport', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_fcoeport_ns_ip_registration_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.fcoeport', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.fcoeport', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.fcoeport', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ns-ip-registration'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_fec_enable_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.fec', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.fec', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ifindex_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Instance Keyword Argument Tuple**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'hundredgigabitethernet', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ifindex'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_access_group_delete(self, hundredgigabitethernet=None, access_group=None, traffic_type=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type access_group: ip_access_list, ip_direction, traffic_type
    :param access_group: Keyword argument tuple.

    :type ip_access_list: unicode
    :param ip_access_list: **access_group** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type ip_direction: unicode
    :param ip_direction: **access_group** tuple argument.

        * enumeration restriction: ::

            ['in', 'out']

    :type traffic_type: unicode
    :param traffic_type: **access_group** tuple argument.

        * enumeration restriction: ::

            ['switched', 'routed']

    **Instance Argument(s)**:

    :type traffic_type: unicode
    :param traffic_type: Keyword argument.

        * enumeration restriction: ::

            ['switched', 'routed']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ip_acl_interface.ip.access_group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ip_acl_interface.ip.access_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ip_acl_interface.ip.access_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'access_group', 'keyval': 'ip_access_list, ip_direction', 'extra_keyval': 'ip_access_list, ip_direction, traffic_type'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, access_group=access_group, traffic_type=traffic_type)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, access_group=access_group, traffic_type=traffic_type)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_acl_interface_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ip_acl_interface', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ip_acl_interface', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ip_acl_interface', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_address_delete(self, hundredgigabitethernet=None, address=None, secondary=None, ospf_passive=None, ospf_ignore=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type address: address, secondary, ospf_passive, ospf_ignore
    :param address: Keyword argument tuple.

    :type address: unicode
    :param address: **address** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]'
            '|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0'
            '-4][0-9]|25[0-5])/(([1-9])|([1-2][0-9])|(3[0-1])'
            ')'

    :type secondary: YANGBool
    :param secondary: **address** tuple argument:  Secondary ip address on the specific interface

    :type ospf_passive: YANGBool
    :param ospf_passive: **address** tuple argument:  ospf pasive address on the specific interface

    :type ospf_ignore: YANGBool
    :param ospf_ignore: **address** tuple argument:  ospf active address on the specific interface

    **Instance Argument(s)**:

    :type secondary: YANGBool
    :param secondary: Secondary ip address on the specific interface

    :type ospf_passive: YANGBool
    :param ospf_passive: ospf pasive address on the specific interface

    :type ospf_ignore: YANGBool
    :param ospf_ignore: ospf active address on the specific interface

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ip.ip_config.address', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ip.ip_config.address', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ip.ip_config.address', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'address', 'keyval': 'address', 'extra_keyval': 'address, secondary, ospf_passive, ospf_ignore'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, address=address, secondary=secondary, ospf_passive=ospf_passive, ospf_ignore=ospf_ignore)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, address=address, secondary=secondary, ospf_passive=ospf_passive, ospf_ignore=ospf_ignore)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_address_ospf_ignore_delete(self, hundredgigabitethernet=None, address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type address: address
    :param address: Keyword argument tuple.

    :type address: unicode
    :param address: **address** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]'
            '|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0'
            '-4][0-9]|25[0-5])/(([1-9])|([1-2][0-9])|(3[0-1])'
            ')'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ip.ip_config.address', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ip.ip_config.address', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ip.ip_config.address', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'address', 'keyval': 'address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ospf-ignore'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, address=address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, address=address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_address_ospf_passive_delete(self, hundredgigabitethernet=None, address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type address: address
    :param address: Keyword argument tuple.

    :type address: unicode
    :param address: **address** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]'
            '|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0'
            '-4][0-9]|25[0-5])/(([1-9])|([1-2][0-9])|(3[0-1])'
            ')'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ip.ip_config.address', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ip.ip_config.address', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ip.ip_config.address', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'address', 'keyval': 'address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ospf-passive'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, address=address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, address=address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_address_secondary_delete(self, hundredgigabitethernet=None, address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type address: address
    :param address: Keyword argument tuple.

    :type address: unicode
    :param address: **address** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]'
            '|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0'
            '-4][0-9]|25[0-5])/(([1-9])|([1-2][0-9])|(3[0-1])'
            ')'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ip.ip_config.address', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ip.ip_config.address', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ip.ip_config.address', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'address', 'keyval': 'address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'secondary'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, address=address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, address=address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_arp_aging_timeout_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ip.ip_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ip.ip_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ip.ip_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'arp-aging-timeout'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_arp_inspection_trust_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ip.arp_node_config.arp.inspection', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ip.arp_node_config.arp.inspection', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ip.arp_node_config.arp.inspection', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'trust'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_arp_ip_config_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ip.ip_config.arp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ip.ip_config.arp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_arp_learn_any_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ip.ip_config.arp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ip.ip_config.arp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'learn-any'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_arp_node_config_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ip.arp_node_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ip.arp_node_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ip.arp_node_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_dhcp_relay_gateway_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ip.interface_hu_dhcp_conf.dhcp.relay', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ip.interface_hu_dhcp_conf.dhcp.relay', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ip.interface_hu_dhcp_conf.dhcp.relay', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'gateway'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_dhcp_relay_servers_delete(self, hundredgigabitethernet=None, servers=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type servers: relay_ip_addr, server_vrf_name
    :param servers: Keyword argument tuple.

    :type relay_ip_addr: unicode
    :param relay_ip_addr: **servers** tuple argument:  A.B.C.D;; IP address of the DHCP server

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type server_vrf_name: unicode
    :param server_vrf_name: **servers** tuple argument:  VRF name of the DHCP server

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ip.interface_hu_dhcp_conf.dhcp.relay.servers', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ip.interface_hu_dhcp_conf.dhcp.relay.servers', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ip.interface_hu_dhcp_conf.dhcp.relay.servers', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'servers', 'keyval': 'relay_ip_addr, server_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, servers=servers)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, servers=servers)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_directed_broadcast_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ip.ip_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ip.ip_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ip.ip_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'directed-broadcast'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_icmp_address_mask_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ip.icmp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ip.icmp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ip.icmp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'address-mask'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_icmp_echo_reply_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ip.icmp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ip.icmp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ip.icmp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'echo-reply'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_icmp_rate_limiting_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ip.icmp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ip.icmp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ip.icmp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rate-limiting'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_icmp_redirect_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ip.icmp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ip.icmp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ip.icmp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redirect'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_icmp_unreachable_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ip.icmp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ip.icmp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ip.icmp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'unreachable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_igmp_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ip.igmp_phy_intf_cfg.igmp": {}, "pybind.nos.v7_1_0.interface.hundredgigabitethernet.ip.igmp_phy_intf_cfg.igmp": {}, "pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ip.igmp_phy_intf_cfg.igmp": {"immediate_leave": "immediate_leave", "last_member_query_interval": "last_member_query_interval", "query_interval": "query_interval", "query_max_response_time": "query_max_response_time"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_igmp_immediate_leave_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'immediate-leave'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_igmp_last_member_query_count_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'last-member-query-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_igmp_last_member_query_interval_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'last-member-query-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_igmp_phy_intf_cfg_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ip.igmp_phy_intf_cfg', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ip.igmp_phy_intf_cfg', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ip.igmp_phy_intf_cfg', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_igmp_query_interval_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'query-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_igmp_query_max_response_time_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'query-max-response-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_igmp_robustness_variable_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'robustness-variable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_igmp_startup_query_count_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'startup-query-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_igmp_startup_query_interval_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'startup-query-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_igmp_static_group_delete(self, hundredgigabitethernet=None, static_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type static_group: sg_addr
    :param static_group: Keyword argument tuple.

    :type sg_addr: unicode
    :param sg_addr: **static_group** tuple argument:  Multicast Address to be Joined in the format A.B.C.D

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ip.igmp_phy_intf_cfg.igmp.static_group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ip.igmp_phy_intf_cfg.igmp.static_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ip.igmp_phy_intf_cfg.igmp.static_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'static_group', 'keyval': 'sg_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, static_group=static_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, static_group=static_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_interface_fo_ospf_conf_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_interface_hu_dhcp_conf_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ip.interface_hu_dhcp_conf', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ip.interface_hu_dhcp_conf', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ip.interface_hu_dhcp_conf', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_ip_config_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ip.ip_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ip.ip_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ip.ip_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_mtu_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ip.ip_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ip.ip_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ip.ip_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mtu'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_multicast_boundary_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'multicast-boundary'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_ospf_active_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'active'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_ospf_area_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'area'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_ospf_auth_change_wait_time_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'auth-change-wait-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_ospf_authentication_key_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_ospf_authentication_key_auth_key_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key.auth_key_table', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key.auth_key_table', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key.auth_key_table', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'auth-key'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_ospf_authentication_key_auth_key_table_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key.auth_key_table', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key.auth_key_table', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key.auth_key_table', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'encrypttype, auth_key'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_ospf_authentication_key_encrypttype_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key.auth_key_table', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key.auth_key_table', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key.auth_key_table', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'encrypttype'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_ospf_authentication_key_no_encrypt_auth_key_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key.no_encrypt_auth_key_table', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key.no_encrypt_auth_key_table', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key.no_encrypt_auth_key_table', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'no-encrypt-auth-key'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_ospf_authentication_key_no_encrypt_auth_key_table_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key.no_encrypt_auth_key_table', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key.no_encrypt_auth_key_table', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key.no_encrypt_auth_key_table', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_ospf_bfd_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.bfd', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.bfd', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.bfd', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_ospf_bfd_intf_bfd_enable_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.bfd', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.bfd', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.bfd', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'intf-bfd-enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_ospf_cost_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cost'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_ospf_database_filter_all_external_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'all-external'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_ospf_database_filter_all_out_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'all-out'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_ospf_database_filter_all_summary_external_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'all-summary-external'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_ospf_dead_interval_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dead-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_ospf_hello_interval_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hello-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_ospf_md5_authentication_key_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication.no_encrypt_key_table', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication.no_encrypt_key_table', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication.no_encrypt_key_table', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'key'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_ospf_md5_authentication_key_activation_wait_time_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'key-activation-wait-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_ospf_md5_authentication_key_id_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication.no_encrypt_key_table', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication.no_encrypt_key_table', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication.no_encrypt_key_table', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'key-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_ospf_md5_authentication_key_id_key_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication.key_table', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication.key_table', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication.key_table', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'key'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_ospf_md5_authentication_key_id_key_id_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication.key_table', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication.key_table', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication.key_table', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'key-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_ospf_md5_authentication_key_id_md5_authentication_key_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication.key_table', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication.key_table', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication.key_table', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'md5-authentication-key'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_ospf_mtu_ignore_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mtu-ignore'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_ospf_network_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'network'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_ospf_passive_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'passive'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_ospf_priority_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_ospf_retransmit_interval_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'retransmit-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_ospf_transmit_delay_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'transmit-delay'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_pbr_interface_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ip_pbr_interface', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ip_pbr_interface', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ip_pbr_interface', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_pim_dr_priority_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd.pim', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd.pim', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd.pim', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dr-priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_pim_int_cmd_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_pim_intf_phy_cont_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ip.pim_intf_phy_cont', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ip.pim_intf_phy_cont', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ip.pim_intf_phy_cont', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_pim_multinet_enable_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd.pim.multinet', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_pim_neighbor_filter_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd.pim', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd.pim', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd.pim', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'neighbor-filter'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_pim_sparse_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'pim-sparse'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_policy_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ip_pbr_interface.ip.policy', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ip_pbr_interface.ip.policy', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ip_pbr_interface.ip.policy', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_policy_route_map_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ip_pbr_interface.ip.policy.route_map', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ip_pbr_interface.ip.policy.route_map', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ip_pbr_interface.ip.policy.route_map', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_policy_route_map_route_map_name_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ip_pbr_interface.ip.policy.route_map', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ip_pbr_interface.ip.policy.route_map', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ip_pbr_interface.ip.policy.route_map', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_proxy_arp_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ip.ip_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ip.ip_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ip.ip_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'proxy-arp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_unnumbered_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ip.ip_config.unnumbered', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ip.ip_config.unnumbered', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'ip_donor_interface_type, ip_donor_interface_name'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_unnumbered_ip_donor_interface_name_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ip.ip_config.unnumbered', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ip.ip_config.unnumbered', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ip-donor-interface-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_unnumbered_ip_donor_interface_type_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ip.ip_config.unnumbered', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ip.ip_config.unnumbered', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ip-donor-interface-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_access_group_delete(self, hundredgigabitethernet=None, access_group=None, traffic_type=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type access_group: ipv6_access_list, ip_direction, traffic_type
    :param access_group: Keyword argument tuple.

    :type ipv6_access_list: unicode
    :param ipv6_access_list: **access_group** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type ip_direction: unicode
    :param ip_direction: **access_group** tuple argument.

        * enumeration restriction: ::

            ['in', 'out']

    :type traffic_type: unicode
    :param traffic_type: **access_group** tuple argument.

        * enumeration restriction: ::

            ['switched', 'routed']

    **Instance Argument(s)**:

    :type traffic_type: unicode
    :param traffic_type: Keyword argument.

        * enumeration restriction: ::

            ['switched', 'routed']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.access_group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.access_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.access_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'access_group', 'keyval': 'ipv6_access_list, ip_direction', 'extra_keyval': 'ipv6_access_list, ip_direction, traffic_type'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, access_group=access_group, traffic_type=traffic_type)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, access_group=access_group, traffic_type=traffic_type)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_access_group_traffic_type_delete(self, hundredgigabitethernet=None, access_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type access_group: ipv6_access_list, ip_direction
    :param access_group: Keyword argument tuple.

    :type ipv6_access_list: unicode
    :param ipv6_access_list: **access_group** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type ip_direction: unicode
    :param ip_direction: **access_group** tuple argument.

        * enumeration restriction: ::

            ['in', 'out']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.access_group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.access_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.access_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'access_group', 'keyval': 'ipv6_access_list, ip_direction', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'traffic-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, access_group=access_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, access_group=access_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_address_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.ipv6_config.address', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.ipv6_config.address', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.ipv6_config.address', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_address_ipv6_address_delete(self, hundredgigabitethernet=None, ipv6_address=None, secondary=None, anycast=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ipv6_address: address, secondary, anycast
    :param ipv6_address: Keyword argument tuple.

    :type address: unicode
    :param address: **ipv6_address** tuple argument:  A:B::C:D/LEN;; IPv6 prefix format: xxxx:xxxx/ml, xxxx:xxxx::/ml, xxxx::xx/128

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type secondary: YANGBool
    :param secondary: **ipv6_address** tuple argument:  Configure Secondary ipv6 address on an interface

    :type anycast: YANGBool
    :param anycast: **ipv6_address** tuple argument:  Configure ipv6 address as anycast

    **Instance Argument(s)**:

    :type secondary: YANGBool
    :param secondary: Configure Secondary ipv6 address on an interface

    :type anycast: YANGBool
    :param anycast: Configure ipv6 address as anycast

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_address', 'keyval': 'address', 'extra_keyval': 'address, secondary, anycast'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, ipv6_address=ipv6_address, secondary=secondary, anycast=anycast)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, ipv6_address=ipv6_address, secondary=secondary, anycast=anycast)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_address_ipv6_address_anycast_delete(self, hundredgigabitethernet=None, ipv6_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ipv6_address: address
    :param ipv6_address: Keyword argument tuple.

    :type address: unicode
    :param address: **ipv6_address** tuple argument:  A:B::C:D/LEN;; IPv6 prefix format: xxxx:xxxx/ml, xxxx:xxxx::/ml, xxxx::xx/128

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_address', 'keyval': 'address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'anycast'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, ipv6_address=ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, ipv6_address=ipv6_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_address_ipv6_address_eui_64_delete(self, hundredgigabitethernet=None, ipv6_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type ipv6_address: address, secondary, anycast
    :param ipv6_address: Keyword argument tuple.

    :type address: unicode
    :param address: **ipv6_address** tuple argument:  A:B::C:D/LEN;; IPv6 prefix format: xxxx:xxxx/ml, xxxx:xxxx::/ml, xxxx::xx/128

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type secondary: YANGBool
    :param secondary: **ipv6_address** tuple argument:  Configure Secondary ipv6 address on an interface

    :type anycast: YANGBool
    :param anycast: **ipv6_address** tuple argument:  Configure ipv6 address as anycast

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.ipv6_config.address.ipv6_address', u'ipv6_address'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.ipv6_config.address.ipv6_address', u'ipv6_address'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.ipv6_config.address.ipv6_address', u'ipv6_address')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.ipv6_config.address.ipv6_address.eui_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.ipv6_config.address.ipv6_address.eui_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.ipv6_config.address.ipv6_address.eui_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'address', 'extra_keyval': 'address, secondary, anycast'}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'address', 'extra_keyval': 'address, secondary, anycast'}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'address', 'extra_keyval': 'address, secondary, anycast'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'eui-64'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, ipv6_address=ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, ipv6_address=ipv6_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_address_ipv6_address_secondary_delete(self, hundredgigabitethernet=None, ipv6_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ipv6_address: address
    :param ipv6_address: Keyword argument tuple.

    :type address: unicode
    :param address: **ipv6_address** tuple argument:  A:B::C:D/LEN;; IPv6 prefix format: xxxx:xxxx/ml, xxxx:xxxx::/ml, xxxx::xx/128

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_address', 'keyval': 'address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'secondary'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, ipv6_address=ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, ipv6_address=ipv6_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_address_ipv6_address_secondary_eui_config_delete(self, hundredgigabitethernet=None, ipv6_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type ipv6_address: address, secondary, anycast
    :param ipv6_address: Keyword argument tuple.

    :type address: unicode
    :param address: **ipv6_address** tuple argument:  A:B::C:D/LEN;; IPv6 prefix format: xxxx:xxxx/ml, xxxx:xxxx::/ml, xxxx::xx/128

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type secondary: YANGBool
    :param secondary: **ipv6_address** tuple argument:  Configure Secondary ipv6 address on an interface

    :type anycast: YANGBool
    :param anycast: **ipv6_address** tuple argument:  Configure ipv6 address as anycast

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.ipv6_config.address.ipv6_address', u'ipv6_address'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.ipv6_config.address.ipv6_address', u'ipv6_address'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.ipv6_config.address.ipv6_address', u'ipv6_address')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.ipv6_config.address.ipv6_address.eui_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.ipv6_config.address.ipv6_address.eui_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.ipv6_config.address.ipv6_address.eui_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'address', 'extra_keyval': 'address, secondary, anycast'}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'address', 'extra_keyval': 'address, secondary, anycast'}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'address', 'extra_keyval': 'address, secondary, anycast'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'secondary'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, ipv6_address=ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, ipv6_address=ipv6_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_address_link_local_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'link-local'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_address_link_local_address_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'link-local-address'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_address_link_local_config_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'link_local_address, link_local'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_address_use_link_local_only_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.ipv6_config.address', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.ipv6_config.address', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.ipv6_config.address', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'use-link-local-only'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_dhcp_relay_servers_delete(self, hundredgigabitethernet=None, servers=None, server_vrf_name=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type servers: relay_ip_addr, server_vrf_name
    :param servers: Keyword argument tuple.

    :type relay_ip_addr: unicode
    :param relay_ip_addr: **servers** tuple argument:  IPv6 address of the DHCPv6 server

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type server_vrf_name: unicode
    :param server_vrf_name: **servers** tuple argument:  VRF name of the DHCPv6 server

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Argument(s)**:

    :type server_vrf_name: unicode
    :param server_vrf_name: VRF name of the DHCPv6 server

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'servers', 'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, servers=servers, server_vrf_name=server_vrf_name)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, servers=servers, server_vrf_name=server_vrf_name)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_dhcp_relay_servers_interface_delete(self, hundredgigabitethernet=None, servers=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type servers: relay_ip_addr, server_vrf_name
    :param servers: Keyword argument tuple.

    :type relay_ip_addr: unicode
    :param relay_ip_addr: **servers** tuple argument:  IPv6 address of the DHCPv6 server

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type server_vrf_name: unicode
    :param server_vrf_name: **servers** tuple argument:  VRF name of the DHCPv6 server

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', u'servers'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', u'servers'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', u'servers')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers.interface', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers.interface', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers.interface', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'interface_type, interface_name'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, servers=servers)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, servers=servers)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_dhcp_relay_servers_interface_interface_delete(self, hundredgigabitethernet=None, servers=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type servers: relay_ip_addr, server_vrf_name
    :param servers: Keyword argument tuple.

    :type relay_ip_addr: unicode
    :param relay_ip_addr: **servers** tuple argument:  IPv6 address of the DHCPv6 server

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type server_vrf_name: unicode
    :param server_vrf_name: **servers** tuple argument:  VRF name of the DHCPv6 server

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', u'servers'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', u'servers'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', u'servers')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers.interface', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers.interface', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers.interface', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'interface'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, servers=servers)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, servers=servers)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_dhcp_relay_servers_interface_interface_name_delete(self, hundredgigabitethernet=None, servers=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type servers: relay_ip_addr, server_vrf_name
    :param servers: Keyword argument tuple.

    :type relay_ip_addr: unicode
    :param relay_ip_addr: **servers** tuple argument:  IPv6 address of the DHCPv6 server

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type server_vrf_name: unicode
    :param server_vrf_name: **servers** tuple argument:  VRF name of the DHCPv6 server

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', u'servers'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', u'servers'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', u'servers')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers.interface', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers.interface', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers.interface', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'interface-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, servers=servers)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, servers=servers)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_dhcp_relay_servers_use_vrf_delete(self, hundredgigabitethernet=None, servers=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type servers: relay_ip_addr
    :param servers: Keyword argument tuple.

    :type relay_ip_addr: unicode
    :param relay_ip_addr: **servers** tuple argument:  IPv6 address of the DHCPv6 server

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'servers', 'keyval': 'relay_ip_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'use-vrf'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, servers=servers)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, servers=servers)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_hop_by_hop_trap_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.ipv6_phy_intf_cmds', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.ipv6_phy_intf_cmds', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.ipv6_phy_intf_cmds', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hop-by-hop-trap'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_icmpv6_echo_reply_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.icmpv6', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.icmpv6', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.icmpv6', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'echo-reply'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_icmpv6_rate_limiting_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.icmpv6', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.icmpv6', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.icmpv6', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rate-limiting'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_icmpv6_redirect_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.icmpv6', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.icmpv6', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.icmpv6', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redirect'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_icmpv6_unreachable_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.icmpv6', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.icmpv6', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.icmpv6', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'unreachable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_interface_phy_dhcp_conf_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.interface_phy_dhcp_conf', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.interface_phy_dhcp_conf', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.interface_phy_dhcp_conf', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_ipv6_config_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.ipv6_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.ipv6_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.ipv6_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_ipv6_intf_cmds_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_ipv6_nd_ra_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_ipv6_phy_intf_cmds_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.ipv6_phy_intf_cmds', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.ipv6_phy_intf_cmds', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.ipv6_phy_intf_cmds', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_mtu_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.ipv6_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.ipv6_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.ipv6_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mtu'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_nd_broadcast_mac_trap_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'broadcast-mac-trap'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_nd_cache_expire_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.cache', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.cache', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.cache', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'expire'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_nd_dad_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.dad', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.dad', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.dad', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_nd_dad_attempts_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.dad', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.dad', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.dad', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'attempts'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_nd_dad_time_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.dad', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.dad', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.dad', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_nd_hoplimit_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hoplimit'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_nd_managed_config_flag_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'managed-config-flag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_nd_mtu_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mtu'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_nd_ns_interval_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ns-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_nd_nud_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_nd_nud_retry_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'base, interval, max_attempts'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_nd_nud_retry_base_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'base'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_nd_nud_retry_interval_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_nd_nud_retry_max_attempts_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'max-attempts'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_nd_other_config_flag_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'other-config-flag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_nd_prefix_delete(self, hundredgigabitethernet=None, prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix', 'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, prefix=prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_nd_prefix_infinite_delete(self, hundredgigabitethernet=None, prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'infinite'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, prefix=prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_nd_prefix_infinite_preferred_delete(self, hundredgigabitethernet=None, prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'infinite'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, prefix=prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_nd_prefix_no_advertise_delete(self, hundredgigabitethernet=None, prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'no-advertise'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, prefix=prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_nd_prefix_no_autoconfig_delete(self, hundredgigabitethernet=None, prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'no-autoconfig'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, prefix=prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_nd_prefix_no_onlink_delete(self, hundredgigabitethernet=None, prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'no-onlink'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, prefix=prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_nd_prefix_off_link_delete(self, hundredgigabitethernet=None, prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'off-link'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, prefix=prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_nd_prefix_preferred_delete(self, hundredgigabitethernet=None, prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'preferred_lifetime, preferred_infinite'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred': [u'preferred_infinite', u'preferred_lifetime'], 'pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred': [u'preferred_infinite', u'preferred_lifetime'], 'pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred': [u'preferred_infinite', u'preferred_lifetime']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, prefix=prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_nd_prefix_preferred_lifetime_delete(self, hundredgigabitethernet=None, prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'preferred-lifetime'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, prefix=prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_nd_prefix_prefix_flags_delete(self, hundredgigabitethernet=None, prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'no_autoconfig, no_onlink, off_link'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, prefix=prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_nd_prefix_valid_lifetime_delete(self, hundredgigabitethernet=None, prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'valid-lifetime'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, prefix=prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_nd_proxy_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'proxy'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_nd_ra_interval_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_interval', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_interval', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_interval', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'max_interval, min_'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_nd_ra_interval_max_interval_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_interval', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_interval', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_interval', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'max-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_nd_ra_interval_min_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_interval', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_interval', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_interval', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'min'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_nd_ra_lifetime_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ra-lifetime'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_nd_reachable_time_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'reachable-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_nd_retrans_timer_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'retrans-timer'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_nd_set_cache_expire_time_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'set-cache-expire-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_nd_set_hoplimit_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'set-hoplimit'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_nd_suppress_ra_all_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'all'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_nd_suppress_ra_mtu_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mtu'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_nd_suppress_ra_suppress_ra_flag_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'suppress-ra-flag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_neighbor_delete(self, hundredgigabitethernet=None, neighbor=None, hardware_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type neighbor: ipv6_address
    :param neighbor: Keyword argument tuple.

    :type ipv6_address: unicode
    :param ipv6_address: **neighbor** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    **Instance Argument(s)**:

    :type hardware_address: unicode
    :param hardware_address: Keyword argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.neighbor', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.neighbor', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.neighbor', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'neighbor', 'keyval': 'ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, neighbor=neighbor, hardware_address=hardware_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, neighbor=neighbor, hardware_address=hardware_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_neighbor_hardware_address_delete(self, hundredgigabitethernet=None, neighbor=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type neighbor: ipv6_address
    :param neighbor: Keyword argument tuple.

    :type ipv6_address: unicode
    :param ipv6_address: **neighbor** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.neighbor', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.neighbor', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.neighbor', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'neighbor', 'keyval': 'ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hardware-address'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, neighbor=neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, neighbor=neighbor)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_ospf_active_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'active'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_ospf_area_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'area'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_ospf_authentication_ah_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ah'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_ospf_authentication_esp_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'esp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_ospf_authentication_esp_auth_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'esp-auth'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_ospf_authentication_esp_key_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'esp-key'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_ospf_authentication_esp_no_encrypt_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'esp-no-encrypt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_ospf_authentication_ipsec_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_ospf_authentication_ipsec_disable_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'disable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_ospf_authentication_ipsec_key_add_remove_interval_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'key-add-remove-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_ospf_authentication_key_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'key'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_ospf_authentication_no_encrypt_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'no-encrypt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_ospf_authentication_spi_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'spi'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_ospf_bfd_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.bfd', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.bfd', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.bfd', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_ospf_bfd_bfd_enable_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.bfd', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.bfd', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.bfd', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bfd-enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_ospf_cost_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cost'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_ospf_dead_interval_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dead-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_ospf_hello_interval_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hello-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_ospf_hello_jitter_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hello-jitter'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_ospf_instance_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'instance'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_ospf_link_interval_properties_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_ospf_mtu_ignore_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mtu-ignore'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_ospf_network_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'network'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_ospf_passive_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'passive'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_ospf_priority_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_ospf_retransmit_interval_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'retransmit-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_ospf_suppress_linklsa_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'suppress-linklsa'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_ospf_transmit_delay_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'transmit-delay'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_policy_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.policy', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.policy', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.policy', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_policy_route_map_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.policy.route_map', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.policy.route_map', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.policy.route_map', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_policy_route_map_ipv6_route_map_name_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.policy.route_map', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.policy.route_map', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.policy.route_map', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ipv6-route-map-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_raguard_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'raguard'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_vrrp_extended_group_delete(self, hundredgigabitethernet=None, vrrpv3e_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_vrrp_extended_group_advertise_backup_delete(self, hundredgigabitethernet=None, vrrpv3e_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'advertise-backup'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_vrrp_extended_group_advertisement_interval_delete(self, hundredgigabitethernet=None, vrrpv3e_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'advertisement-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_vrrp_extended_group_advertisement_interval_scale_delete(self, hundredgigabitethernet=None, vrrpv3e_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'advertisement-interval-scale'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_vrrp_extended_group_backup_advertisement_interval_delete(self, hundredgigabitethernet=None, vrrpv3e_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'backup-advertisement-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_vrrp_extended_group_description_delete(self, hundredgigabitethernet=None, vrrpv3e_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'description'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_vrrp_extended_group_enable_delete(self, hundredgigabitethernet=None, vrrpv3e_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_vrrp_extended_group_hold_time_delete(self, hundredgigabitethernet=None, vrrpv3e_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hold-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_vrrp_extended_group_nd_advertisement_timer_delete(self, hundredgigabitethernet=None, vrrpv3e_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'nd-advertisement-timer'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_vrrp_extended_group_preempt_mode_delete(self, hundredgigabitethernet=None, vrrpv3e_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'preempt-mode'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_vrrp_extended_group_priority_delete(self, hundredgigabitethernet=None, vrrpv3e_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_vrrp_extended_group_short_path_forwarding_basic_delete(self, hundredgigabitethernet=None, vrrpv3e_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.vrrpv3e_group.short_path_forwarding', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.vrrpv3e_group.short_path_forwarding', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'basic'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_vrrp_extended_group_short_path_forwarding_revert_priority_delete(self, hundredgigabitethernet=None, vrrpv3e_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.vrrpv3e_group.short_path_forwarding', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.vrrpv3e_group.short_path_forwarding', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'revert-priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_vrrp_extended_group_track_interface_delete(self, hundredgigabitethernet=None, vrrpv3e_group=None, interface=None, track_priority=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Argument(s)**:

    :type track_priority: int
    :param track_priority: Track Priority

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.vrrpv3e_group.track.interface', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.vrrpv3e_group.track.interface', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3e_group=vrrpv3e_group, interface=interface, track_priority=track_priority)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3e_group=vrrpv3e_group, interface=interface, track_priority=track_priority)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_vrrp_extended_group_track_interface_priority_delete(self, hundredgigabitethernet=None, vrrpv3e_group=None, interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.vrrpv3e_group.track.interface', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.vrrpv3e_group.track.interface', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3e_group=vrrpv3e_group, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3e_group=vrrpv3e_group, interface=interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_vrrp_extended_group_virtual_ip_delete(self, hundredgigabitethernet=None, vrrpv3e_group=None, virtual_ip=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type virtual_ip: virtual_ipaddr
    :param virtual_ip: Keyword argument tuple.

    :type virtual_ipaddr: unicode
    :param virtual_ipaddr: **virtual_ip** tuple argument:  Virtual IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.vrrpv3e_group.virtual_ip', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.vrrpv3e_group.virtual_ip', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'virtual_ip', 'keyval': 'virtual_ipaddr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3e_group=vrrpv3e_group, virtual_ip=virtual_ip)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3e_group=vrrpv3e_group, virtual_ip=virtual_ip)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_vrrp_group_delete(self, hundredgigabitethernet=None, vrrpv3_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3_group=vrrpv3_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3_group=vrrpv3_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_vrrp_group_advertisement_interval_delete(self, hundredgigabitethernet=None, vrrpv3_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'advertisement-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3_group=vrrpv3_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3_group=vrrpv3_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_vrrp_group_description_delete(self, hundredgigabitethernet=None, vrrpv3_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'description'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3_group=vrrpv3_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3_group=vrrpv3_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_vrrp_group_enable_delete(self, hundredgigabitethernet=None, vrrpv3_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3_group=vrrpv3_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3_group=vrrpv3_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_vrrp_group_hold_time_delete(self, hundredgigabitethernet=None, vrrpv3_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hold-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3_group=vrrpv3_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3_group=vrrpv3_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_vrrp_group_preempt_mode_delete(self, hundredgigabitethernet=None, vrrpv3_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'preempt-mode'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3_group=vrrpv3_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3_group=vrrpv3_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_vrrp_group_priority_delete(self, hundredgigabitethernet=None, vrrpv3_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3_group=vrrpv3_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3_group=vrrpv3_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_vrrp_group_track_interface_delete(self, hundredgigabitethernet=None, vrrpv3_group=None, interface=None, track_priority=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Argument(s)**:

    :type track_priority: int
    :param track_priority: Track Priority

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.vrrpv3_group', u'vrrpv3_group'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.vrrpv3_group', u'vrrpv3_group')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.vrrpv3_group.track.interface', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.vrrpv3_group.track.interface', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3_group=vrrpv3_group, interface=interface, track_priority=track_priority)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3_group=vrrpv3_group, interface=interface, track_priority=track_priority)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_vrrp_group_track_interface_priority_delete(self, hundredgigabitethernet=None, vrrpv3_group=None, interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.vrrpv3_group', u'vrrpv3_group'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.vrrpv3_group', u'vrrpv3_group')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.vrrpv3_group.track.interface', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.vrrpv3_group.track.interface', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3_group=vrrpv3_group, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3_group=vrrpv3_group, interface=interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_vrrp_group_use_v2_checksum_delete(self, hundredgigabitethernet=None, vrrpv3_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'use-v2-checksum'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3_group=vrrpv3_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3_group=vrrpv3_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_vrrp_group_virtual_ip_delete(self, hundredgigabitethernet=None, vrrpv3_group=None, virtual_ip=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type virtual_ip: virtual_ipaddr
    :param virtual_ip: Keyword argument tuple.

    :type virtual_ipaddr: unicode
    :param virtual_ipaddr: **virtual_ip** tuple argument:  Virtual IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.vrrpv3_group', u'vrrpv3_group'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.vrrpv3_group', u'vrrpv3_group')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.vrrpv3_group.virtual_ip', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.vrrpv3_group.virtual_ip', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'virtual_ip', 'keyval': 'virtual_ipaddr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3_group=vrrpv3_group, virtual_ip=virtual_ip)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3_group=vrrpv3_group, virtual_ip=virtual_ip)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_vrrp_suppress_interface_ra_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vrrp-suppress-interface-ra'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_lacp_default_up_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.lacp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.lacp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.lacp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'default-up'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_lacp_port_priority_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.lacp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.lacp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.lacp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'port-priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_lacp_timeout_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.lacp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.lacp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.lacp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'timeout'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_lldp_cee_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.lldp.cee', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.lldp.cee', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.lldp.cee', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_lldp_cee_lldp_cee_on_off_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.lldp.cee', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.lldp.cee', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.lldp.cee', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lldp-cee-on-off'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_lldp_dcbx_version_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.lldp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.lldp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.lldp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dcbx-version'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_lldp_disable_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.lldp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.lldp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.lldp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'disable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_lldp_iscsi_priority_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.lldp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.lldp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.lldp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'iscsi-priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_lldp_profile_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.lldp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.lldp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.lldp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'profile'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_mac_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.mac', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.mac', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.mac', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_mac_access_group_delete(self, hundredgigabitethernet=None, access_group=None, traffic_type=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type access_group: mac_access_list, mac_direction, traffic_type
    :param access_group: Keyword argument tuple.

    :type mac_access_list: unicode
    :param mac_access_list: **access_group** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type mac_direction: unicode
    :param mac_direction: **access_group** tuple argument.

        * enumeration restriction: ::

            ['in', 'out']

    :type traffic_type: unicode
    :param traffic_type: **access_group** tuple argument.

        * enumeration restriction: ::

            ['switched', 'routed']

    **Instance Argument(s)**:

    :type traffic_type: unicode
    :param traffic_type: Keyword argument.

        * enumeration restriction: ::

            ['switched', 'routed']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.mac.access_group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.mac.access_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.mac.access_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'access_group', 'keyval': 'mac_access_list, mac_direction', 'extra_keyval': 'mac_access_list, mac_direction, traffic_type'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, access_group=access_group, traffic_type=traffic_type)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, access_group=access_group, traffic_type=traffic_type)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_mac_learning_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.mac_learning', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.mac_learning', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.mac_learning', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_mac_learning_disable_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.mac_learning.mac_learn_disable', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.mac_learning.mac_learn_disable', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.mac_learning.mac_learn_disable', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_mac_learning_disable_vlan_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.mac_learning.mac_learn_disable.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.mac_learning.mac_learn_disable.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.mac_learning.mac_learn_disable.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_mac_learning_disable_vlan_add_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.mac_learning.mac_learn_disable.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.mac_learning.mac_learn_disable.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.mac_learning.mac_learn_disable.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'add'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_mac_learning_disable_vlan_remove_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.mac_learning.mac_learn_disable.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.mac_learning.mac_learn_disable.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.mac_learning.mac_learn_disable.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'remove'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_mtu_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Instance Keyword Argument Tuple**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'hundredgigabitethernet', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mtu'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_openflow_enable_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.openflow_interface_cfg.openflow_enable', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.openflow_interface_cfg.openflow_enable', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.openflow_interface_cfg.openflow_enable', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_openflow_logical_instance_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.openflow_interface_cfg', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.openflow_interface_cfg', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.openflow_interface_cfg', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'logical-instance'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_openflow_match_profile_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.openflow_interface_cfg.openflow_enable', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.openflow_interface_cfg.openflow_enable', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.openflow_interface_cfg.openflow_enable', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'match-profile'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_openflow_openflow_enable_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.openflow_interface_cfg.openflow_enable', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.openflow_interface_cfg.openflow_enable', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.openflow_interface_cfg.openflow_enable', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'enable, match_profile'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_port_profile_port_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Instance Keyword Argument Tuple**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'hundredgigabitethernet', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'port-profile-port'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_port_profile_port_domain_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.port_profile_to_interface_associations.port_profile_port.port_to_port_profile_domain_association', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.port_profile_to_interface_associations.port_profile_port.port_to_port_profile_domain_association', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.port_profile_to_interface_associations.port_profile_port.port_to_port_profile_domain_association', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_port_profile_port_domain_profile_domain_name_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.port_profile_to_interface_associations.port_profile_port.port_to_port_profile_domain_association', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.port_profile_to_interface_associations.port_profile_port.port_to_port_profile_domain_association', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.port_profile_to_interface_associations.port_profile_port.port_to_port_profile_domain_association', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'profile-domain-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_port_profile_port_profile_delete(self, hundredgigabitethernet=None, port_to_port_profile_associations=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type port_to_port_profile_associations: port_to_port_profile_association
    :param port_to_port_profile_associations: Keyword argument tuple.

    :type port_to_port_profile_association: unicode
    :param port_to_port_profile_association: **port_to_port_profile_associations** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.port_profile_to_interface_associations.port_profile_port.port_to_port_profile_associations', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.port_profile_to_interface_associations.port_profile_port.port_to_port_profile_associations', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.port_profile_to_interface_associations.port_profile_port.port_to_port_profile_associations', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'port_to_port_profile_associations', 'keyval': 'port_to_port_profile_association', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, port_to_port_profile_associations=port_to_port_profile_associations)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, port_to_port_profile_associations=port_to_port_profile_associations)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_port_profile_to_interface_associations_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.port_profile_to_interface_associations', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.port_profile_to_interface_associations', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.port_profile_to_interface_associations', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_priority_tag_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Instance Keyword Argument Tuple**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'hundredgigabitethernet', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority-tag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_qos_cos_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.qos', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.qos', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.qos', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cos'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_qos_cos_mutation_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.qos', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.qos', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.qos', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cos-mutation'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_qos_cos_traffic_class_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.qos', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.qos', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.qos', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cos-traffic-class'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_qos_drop_monitor_enable_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.qos.drop_monitor', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.qos.drop_monitor', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.qos.drop_monitor', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_qos_dscp_cos_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.qos', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.qos', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.qos', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dscp-cos'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_qos_dscp_mutation_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.qos', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.qos', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.qos', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dscp-mutation'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_qos_dscp_traffic_class_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.qos', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.qos', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.qos', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dscp-traffic-class'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_qos_flowcontrol_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.qos.flowcontrol', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.qos.flowcontrol', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.qos.flowcontrol', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_qos_flowcontrol_link_level_flowcontrol_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.qos.flowcontrol.link_level_flowcontrol', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.qos.flowcontrol.link_level_flowcontrol', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.qos.flowcontrol.link_level_flowcontrol', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_qos_flowcontrol_pfc_delete(self, hundredgigabitethernet=None, pfc=None, pfc_flowcontrol_tx=None, pfc_flowcontrol_rx=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type pfc: pfc_cos
    :param pfc: Keyword argument tuple.

    :type pfc_cos: long
    :param pfc_cos: **pfc** tuple argument:  0-7;;CoS value

        * range restriction: ::

            ['-2147483648..2147483647']

    **Instance Argument(s)**:

    :type pfc_flowcontrol_tx: unicode
    :param pfc_flowcontrol_tx: Configure Pause generation

        * enumeration restriction: ::

            ['on', 'off']

    :type pfc_flowcontrol_rx: unicode
    :param pfc_flowcontrol_rx: Configure Pause reception

        * enumeration restriction: ::

            ['on', 'off']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.qos.flowcontrol.pfc', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.qos.flowcontrol.pfc', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.qos.flowcontrol.pfc', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'pfc', 'keyval': 'pfc_cos', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, pfc=pfc, pfc_flowcontrol_tx=pfc_flowcontrol_tx, pfc_flowcontrol_rx=pfc_flowcontrol_rx)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, pfc=pfc, pfc_flowcontrol_tx=pfc_flowcontrol_tx, pfc_flowcontrol_rx=pfc_flowcontrol_rx)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_qos_flowcontrol_pfc_rx_delete(self, hundredgigabitethernet=None, pfc=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type pfc: pfc_cos
    :param pfc: Keyword argument tuple.

    :type pfc_cos: long
    :param pfc_cos: **pfc** tuple argument:  0-7;;CoS value

        * range restriction: ::

            ['-2147483648..2147483647']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.qos.flowcontrol.pfc', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.qos.flowcontrol.pfc', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.qos.flowcontrol.pfc', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'pfc', 'keyval': 'pfc_cos', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, pfc=pfc)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, pfc=pfc)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_qos_flowcontrol_pfc_tx_delete(self, hundredgigabitethernet=None, pfc=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type pfc: pfc_cos
    :param pfc: Keyword argument tuple.

    :type pfc_cos: long
    :param pfc_cos: **pfc** tuple argument:  0-7;;CoS value

        * range restriction: ::

            ['-2147483648..2147483647']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.qos.flowcontrol.pfc', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.qos.flowcontrol.pfc', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.qos.flowcontrol.pfc', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'pfc', 'keyval': 'pfc_cos', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, pfc=pfc)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, pfc=pfc)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_qos_flowcontrol_rx_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.qos.flowcontrol.link_level_flowcontrol', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.qos.flowcontrol.link_level_flowcontrol', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.qos.flowcontrol.link_level_flowcontrol', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_qos_flowcontrol_tx_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.qos.flowcontrol.link_level_flowcontrol', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.qos.flowcontrol.link_level_flowcontrol', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.qos.flowcontrol.link_level_flowcontrol', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_qos_random_detect_traffic_class_delete(self, hundredgigabitethernet=None, traffic_class=None, red_enable=None, red_profile_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type traffic_class: red_tc_value
    :param traffic_class: Keyword argument tuple.

    :type red_tc_value: long
    :param red_tc_value: **traffic_class** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Argument(s)**:

    :type red_enable: YANGBool
    :param red_enable: Keyword for VDX 6710,6720,6730,6746,2730

    :type red_profile_id: long
    :param red_profile_id: Keyword for all other VDX platforms

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.qos.random_detect.traffic_class', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.qos.random_detect.traffic_class', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.qos.random_detect.traffic_class', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'traffic_class', 'keyval': 'red_tc_value', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, traffic_class=traffic_class, red_enable=red_enable, red_profile_id=red_profile_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, traffic_class=traffic_class, red_enable=red_enable, red_profile_id=red_profile_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_qos_random_detect_traffic_class_apply_delete(self, hundredgigabitethernet=None, traffic_class=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type traffic_class: red_tc_value
    :param traffic_class: Keyword argument tuple.

    :type red_tc_value: long
    :param red_tc_value: **traffic_class** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.qos.random_detect.traffic_class', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.qos.random_detect.traffic_class', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.qos.random_detect.traffic_class', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'traffic_class', 'keyval': 'red_tc_value', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'apply'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, traffic_class=traffic_class)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, traffic_class=traffic_class)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_qos_random_detect_traffic_class_red_profile_id_delete(self, hundredgigabitethernet=None, traffic_class=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type traffic_class: red_tc_value
    :param traffic_class: Keyword argument tuple.

    :type red_tc_value: long
    :param red_tc_value: **traffic_class** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.qos.random_detect.traffic_class', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.qos.random_detect.traffic_class', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.qos.random_detect.traffic_class', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'traffic_class', 'keyval': 'red_tc_value', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'red-profile-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, traffic_class=traffic_class)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, traffic_class=traffic_class)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_qos_trust_cos_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.qos.trust', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.qos.trust', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.qos.trust', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cos'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_qos_trust_dscp_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.qos.trust', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.qos.trust', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.qos.trust', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dscp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_rmon_collection_history_delete(self, hundredgigabitethernet=None, history_control_entry=None, history_control_buckets_requested=None, history_control_interval=None, history_control_owner=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type history_control_entry: history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner
    :param history_control_entry: Keyword argument tuple.

    :type history_control_index: long
    :param history_control_index: **history_control_entry** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type history_control_buckets_requested: long
    :param history_control_buckets_requested: **history_control_entry** tuple argument:  Buckets (default 50)

        * range restriction: ::

            ['-2147483648..2147483647']

    :type history_control_interval: long
    :param history_control_interval: **history_control_entry** tuple argument:  Polling Interval (default 1800)

        * range restriction: ::

            ['-2147483648..2147483647']

    :type history_control_owner: unicode
    :param history_control_owner: **history_control_entry** tuple argument:  Owner identity

        * length restriction: ::

            ['1 .. 15']

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,14})'

    **Instance Argument(s)**:

    :type history_control_buckets_requested: long
    :param history_control_buckets_requested: Buckets (default 50)

        * range restriction: ::

            ['-2147483648..2147483647']

    :type history_control_interval: long
    :param history_control_interval: Polling Interval (default 1800)

        * range restriction: ::

            ['-2147483648..2147483647']

    :type history_control_owner: unicode
    :param history_control_owner: Owner identity

        * length restriction: ::

            ['1 .. 15']

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,14})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.rmon.collection.history_control_entry', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.rmon.collection.history_control_entry', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.rmon.collection.history_control_entry', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'history_control_entry', 'keyval': 'history_control_index', 'extra_keyval': 'history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, history_control_entry=history_control_entry, history_control_buckets_requested=history_control_buckets_requested, history_control_interval=history_control_interval, history_control_owner=history_control_owner)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, history_control_entry=history_control_entry, history_control_buckets_requested=history_control_buckets_requested, history_control_interval=history_control_interval, history_control_owner=history_control_owner)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_rmon_collection_history_buckets_delete(self, hundredgigabitethernet=None, history_control_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type history_control_entry: history_control_index
    :param history_control_entry: Keyword argument tuple.

    :type history_control_index: long
    :param history_control_index: **history_control_entry** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.rmon.collection.history_control_entry', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.rmon.collection.history_control_entry', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.rmon.collection.history_control_entry', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'history_control_entry', 'keyval': 'history_control_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'buckets'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, history_control_entry=history_control_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, history_control_entry=history_control_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_rmon_collection_history_interval_delete(self, hundredgigabitethernet=None, history_control_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type history_control_entry: history_control_index
    :param history_control_entry: Keyword argument tuple.

    :type history_control_index: long
    :param history_control_index: **history_control_entry** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.rmon.collection.history_control_entry', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.rmon.collection.history_control_entry', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.rmon.collection.history_control_entry', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'history_control_entry', 'keyval': 'history_control_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, history_control_entry=history_control_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, history_control_entry=history_control_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_rmon_collection_history_owner_delete(self, hundredgigabitethernet=None, history_control_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type history_control_entry: history_control_index
    :param history_control_entry: Keyword argument tuple.

    :type history_control_index: long
    :param history_control_index: **history_control_entry** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.rmon.collection.history_control_entry', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.rmon.collection.history_control_entry', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.rmon.collection.history_control_entry', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'history_control_entry', 'keyval': 'history_control_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'owner'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, history_control_entry=history_control_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, history_control_entry=history_control_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_rmon_collection_stats_delete(self, hundredgigabitethernet=None, ether_stats_entry=None, ether_stats_owner=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ether_stats_entry: ether_stats_index, ether_stats_owner
    :param ether_stats_entry: Keyword argument tuple.

    :type ether_stats_index: long
    :param ether_stats_index: **ether_stats_entry** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type ether_stats_owner: unicode
    :param ether_stats_owner: **ether_stats_entry** tuple argument:  Owner identity

        * length restriction: ::

            ['1 .. 15']

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,14})'

    **Instance Argument(s)**:

    :type ether_stats_owner: unicode
    :param ether_stats_owner: Owner identity

        * length restriction: ::

            ['1 .. 15']

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,14})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.rmon.collection.ether_stats_entry', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.rmon.collection.ether_stats_entry', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.rmon.collection.ether_stats_entry', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ether_stats_entry', 'keyval': 'ether_stats_index', 'extra_keyval': 'ether_stats_index, ether_stats_owner'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, ether_stats_entry=ether_stats_entry, ether_stats_owner=ether_stats_owner)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, ether_stats_entry=ether_stats_entry, ether_stats_owner=ether_stats_owner)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_rmon_collection_stats_owner_delete(self, hundredgigabitethernet=None, ether_stats_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ether_stats_entry: ether_stats_index
    :param ether_stats_entry: Keyword argument tuple.

    :type ether_stats_index: long
    :param ether_stats_index: **ether_stats_entry** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.rmon.collection.ether_stats_entry', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.rmon.collection.ether_stats_entry', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.rmon.collection.ether_stats_entry', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ether_stats_entry', 'keyval': 'ether_stats_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'owner'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, ether_stats_entry=ether_stats_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, ether_stats_entry=ether_stats_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_service_policy_in_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.service_policy', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.service_policy', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.service_policy', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'in'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_service_policy_out_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.service_policy', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.service_policy', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.service_policy', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'out'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_sflow_enable_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.sflow', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.sflow', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.sflow', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_sflow_polling_interval_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.sflow', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.sflow', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.sflow', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'polling-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_sflow_sample_rate_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.sflow', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.sflow', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.sflow', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'sample-rate'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_shutdown_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Instance Keyword Argument Tuple**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'hundredgigabitethernet', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'shutdown'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_snmp_trap_link_status_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.snmp.trap', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.snmp.trap', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.snmp.trap', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'link-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_spanning_tree_autoedge_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.spanning_tree', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.spanning_tree', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.spanning_tree', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'autoedge'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_spanning_tree_bpdu_mac_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.spanning_tree', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.spanning_tree', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.spanning_tree', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bpdu-mac'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_spanning_tree_cost_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.spanning_tree', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.spanning_tree', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.spanning_tree', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cost'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_spanning_tree_edgeport_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.spanning_tree.edgeport', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.spanning_tree.edgeport', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.spanning_tree.edgeport', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_spanning_tree_edgeport_bpdu_filter_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.spanning_tree.edgeport', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.spanning_tree.edgeport', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.spanning_tree.edgeport', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bpdu-filter'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_spanning_tree_edgeport_bpdu_guard_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.spanning_tree.edgeport', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.spanning_tree.edgeport', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.spanning_tree.edgeport', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bpdu-guard'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_spanning_tree_edgeport_edgeportbasic_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.spanning_tree.edgeport', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.spanning_tree.edgeport', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.spanning_tree.edgeport', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'edgeportbasic'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_spanning_tree_guard_root_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.spanning_tree.guard', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.spanning_tree.guard', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.spanning_tree.guard', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'root'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_spanning_tree_hello_time_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.spanning_tree', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.spanning_tree', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.spanning_tree', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hello-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_spanning_tree_instance_cost_delete(self, hundredgigabitethernet=None, instance=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type instance: id
    :param instance: Keyword argument tuple.

    :type id: int
    :param id: **instance** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.spanning_tree.instance', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.spanning_tree.instance', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.spanning_tree.instance', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instance', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cost'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, instance=instance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, instance=instance)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_spanning_tree_instance_priority_delete(self, hundredgigabitethernet=None, instance=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type instance: id
    :param instance: Keyword argument tuple.

    :type id: int
    :param id: **instance** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.spanning_tree.instance', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.spanning_tree.instance', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.spanning_tree.instance', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instance', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, instance=instance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, instance=instance)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_spanning_tree_instance_restricted_role_delete(self, hundredgigabitethernet=None, instance=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type instance: id
    :param instance: Keyword argument tuple.

    :type id: int
    :param id: **instance** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.spanning_tree.instance', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.spanning_tree.instance', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.spanning_tree.instance', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instance', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'restricted-role'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, instance=instance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, instance=instance)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_spanning_tree_instance_restricted_tcn_delete(self, hundredgigabitethernet=None, instance=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type instance: id
    :param instance: Keyword argument tuple.

    :type id: int
    :param id: **instance** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.spanning_tree.instance', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.spanning_tree.instance', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.spanning_tree.instance', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instance', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'restricted-tcn'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, instance=instance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, instance=instance)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_spanning_tree_link_type_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.spanning_tree', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.spanning_tree', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.spanning_tree', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'link-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_spanning_tree_portfast_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.spanning_tree.portfast', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.spanning_tree.portfast', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.spanning_tree.portfast', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_spanning_tree_portfast_bpdu_filter_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.spanning_tree.portfast', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.spanning_tree.portfast', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.spanning_tree.portfast', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bpdu-filter'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_spanning_tree_portfast_bpdu_guard_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.spanning_tree.portfast', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.spanning_tree.portfast', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.spanning_tree.portfast', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bpdu-guard'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_spanning_tree_portfast_portfastbasic_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.spanning_tree.portfast', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.spanning_tree.portfast', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.spanning_tree.portfast', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'portfastbasic'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_spanning_tree_priority_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.spanning_tree', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.spanning_tree', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.spanning_tree', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_spanning_tree_restricted_role_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.spanning_tree', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.spanning_tree', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.spanning_tree', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'restricted-role'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_spanning_tree_restricted_tcn_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.spanning_tree', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.spanning_tree', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.spanning_tree', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'restricted-tcn'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_spanning_tree_shutdown_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.spanning_tree', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.spanning_tree', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.spanning_tree', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'shutdown'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_spanning_tree_vlan_cost_delete(self, hundredgigabitethernet=None, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vlan: id
    :param vlan: Keyword argument tuple.

    :type id: long
    :param id: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.spanning_tree.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.spanning_tree.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.spanning_tree.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cost'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_spanning_tree_vlan_guard_root_delete(self, hundredgigabitethernet=None, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vlan: id
    :param vlan: Keyword argument tuple.

    :type id: long
    :param id: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.spanning_tree.vlan', u'vlan'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.spanning_tree.vlan', u'vlan'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.spanning_tree.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.spanning_tree.vlan.guard', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.spanning_tree.vlan.guard', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.spanning_tree.vlan.guard', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'root'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_spanning_tree_vlan_priority_delete(self, hundredgigabitethernet=None, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vlan: id
    :param vlan: Keyword argument tuple.

    :type id: long
    :param id: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.spanning_tree.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.spanning_tree.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.spanning_tree.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_storm_control_ingress_delete(self, hundredgigabitethernet=None, ingress=None, rate_format=None, rate_bps=None, rate_percent=None, bum_action=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ingress: protocol_type, rate_format, rate_bps, rate_percent, bum_action
    :param ingress: Keyword argument tuple.

    :type protocol_type: unicode
    :param protocol_type: **ingress** tuple argument.

        * enumeration restriction: ::

            ['broadcast', 'unknown-unicast', 'multicast']

    :type rate_format: unicode
    :param rate_format: **ingress** tuple argument.

        * enumeration restriction: ::

            ['limit-bps', 'limit-percent']

    :type rate_bps: long
    :param rate_bps: **ingress** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type rate_percent: long
    :param rate_percent: **ingress** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type bum_action: unicode
    :param bum_action: **ingress** tuple argument.

        * enumeration restriction: ::

            ['monitor', 'shutdown']

    **Instance Argument(s)**:

    :type rate_format: unicode
    :param rate_format: Keyword argument.

        * enumeration restriction: ::

            ['limit-bps', 'limit-percent']

    :type rate_bps: long
    :param rate_bps: Keyword argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type rate_percent: long
    :param rate_percent: Keyword argument.

        * range restriction: ::

            ['0..4294967295']

    :type bum_action: unicode
    :param bum_action: Keyword argument.

        * enumeration restriction: ::

            ['monitor', 'shutdown']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.storm_control.ingress', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.storm_control.ingress', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.storm_control.ingress', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ingress', 'keyval': 'protocol_type', 'extra_keyval': 'protocol_type, rate_format, rate_bps, rate_percent, bum_action'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, ingress=ingress, rate_format=rate_format, rate_bps=rate_bps, rate_percent=rate_percent, bum_action=bum_action)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, ingress=ingress, rate_format=rate_format, rate_bps=rate_bps, rate_percent=rate_percent, bum_action=bum_action)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_storm_control_ingress_bum_action_delete(self, hundredgigabitethernet=None, ingress=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ingress: protocol_type
    :param ingress: Keyword argument tuple.

    :type protocol_type: unicode
    :param protocol_type: **ingress** tuple argument.

        * enumeration restriction: ::

            ['broadcast', 'unknown-unicast', 'multicast']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.storm_control.ingress', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.storm_control.ingress', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.storm_control.ingress', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ingress', 'keyval': 'protocol_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bum-action'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, ingress=ingress)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, ingress=ingress)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_storm_control_ingress_rate_bps_delete(self, hundredgigabitethernet=None, ingress=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ingress: protocol_type
    :param ingress: Keyword argument tuple.

    :type protocol_type: unicode
    :param protocol_type: **ingress** tuple argument.

        * enumeration restriction: ::

            ['broadcast', 'unknown-unicast', 'multicast']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.storm_control.ingress', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.storm_control.ingress', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.storm_control.ingress', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ingress', 'keyval': 'protocol_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rate-bps'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, ingress=ingress)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, ingress=ingress)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_storm_control_ingress_rate_format_delete(self, hundredgigabitethernet=None, ingress=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ingress: protocol_type
    :param ingress: Keyword argument tuple.

    :type protocol_type: unicode
    :param protocol_type: **ingress** tuple argument.

        * enumeration restriction: ::

            ['broadcast', 'unknown-unicast', 'multicast']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.storm_control.ingress', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.storm_control.ingress', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.storm_control.ingress', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ingress', 'keyval': 'protocol_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rate-format'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, ingress=ingress)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, ingress=ingress)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_storm_control_ingress_rate_percent_delete(self, hundredgigabitethernet=None, ingress=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ingress: protocol_type
    :param ingress: Keyword argument tuple.

    :type protocol_type: unicode
    :param protocol_type: **ingress** tuple argument.

        * enumeration restriction: ::

            ['broadcast', 'unknown-unicast', 'multicast']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.storm_control.ingress', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.storm_control.ingress', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.storm_control.ingress', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ingress', 'keyval': 'protocol_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rate-percent'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, ingress=ingress)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, ingress=ingress)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.switchport_basic', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.switchport_basic', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.switchport_basic', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'switchport'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_access_mac_group_rspan_vlan_classification_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.switchport.access_mac_group_rspan_vlan_classification', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.switchport.access_mac_group_rspan_vlan_classification', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.switchport.access_mac_group_rspan_vlan_classification', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_access_mac_group_vlan_classification_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.switchport.access_mac_group_vlan_classification', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.switchport.access_mac_group_vlan_classification', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.switchport.access_mac_group_vlan_classification', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_access_mac_rspan_vlan_classification_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.switchport.access_mac_rspan_vlan_classification', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.switchport.access_mac_rspan_vlan_classification', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.switchport.access_mac_rspan_vlan_classification', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_access_mac_vlan_classification_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.switchport.access_mac_vlan_classification', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.switchport.access_mac_vlan_classification', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.switchport.access_mac_vlan_classification', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_access_rspan_vlan_delete(self, hundredgigabitethernet=None, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vlan: access_vlan_id, access_mac_group
    :param vlan: Keyword argument tuple.

    :type access_vlan_id: long
    :param access_vlan_id: **vlan** tuple argument:  Set the default VLAN for the interface

        * range restriction: ::

            ['0..4294967295']

    :type access_mac_group: long
    :param access_mac_group: **vlan** tuple argument:  Associate a Mac group with a vlan

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.switchport.access_mac_group_rspan_vlan_classification.access.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.switchport.access_mac_group_rspan_vlan_classification.access.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.switchport.access_mac_group_rspan_vlan_classification.access.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'access_vlan_id, access_mac_group', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_access_rspan_vlan_access_mac_rspan_vlan_classification_delete(self, hundredgigabitethernet=None, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vlan: access_vlan_id, access_mac_address
    :param vlan: Keyword argument tuple.

    :type access_vlan_id: long
    :param access_vlan_id: **vlan** tuple argument:  Set the default VLAN for the interface

        * range restriction: ::

            ['0..4294967295']

    :type access_mac_address: unicode
    :param access_mac_address: **vlan** tuple argument:  Associate the Mac address with a vlan

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.switchport.access_mac_rspan_vlan_classification.access.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.switchport.access_mac_rspan_vlan_classification.access.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.switchport.access_mac_rspan_vlan_classification.access.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'access_vlan_id, access_mac_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_access_vlan_delete(self, hundredgigabitethernet=None, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vlan: access_vlan_id, access_mac_group
    :param vlan: Keyword argument tuple.

    :type access_vlan_id: long
    :param access_vlan_id: **vlan** tuple argument:  Set the default VLAN for the interface

        * range restriction: ::

            ['0..4294967295']

    :type access_mac_group: long
    :param access_mac_group: **vlan** tuple argument:  Associate a Mac group with a vlan

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.switchport.access_mac_group_vlan_classification.access.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.switchport.access_mac_group_vlan_classification.access.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.switchport.access_mac_group_vlan_classification.access.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'access_vlan_id, access_mac_group', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_access_vlan_access_mac_vlan_classification_delete(self, hundredgigabitethernet=None, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vlan: access_vlan_id, access_mac_address
    :param vlan: Keyword argument tuple.

    :type access_vlan_id: long
    :param access_vlan_id: **vlan** tuple argument:  Set the default VLAN for the interface

        * range restriction: ::

            ['0..4294967295']

    :type access_mac_address: unicode
    :param access_mac_address: **vlan** tuple argument:  Associate the Mac address with a vlan

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.switchport.access_mac_vlan_classification.access.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.switchport.access_mac_vlan_classification.access.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.switchport.access_mac_vlan_classification.access.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'access_vlan_id, access_mac_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_basic_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.switchport_basic', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.switchport_basic', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.switchport_basic', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_mode_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.switchport.mode', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.switchport.mode', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.switchport.mode', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_mode_private_vlan_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.switchport.mode.private_vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.switchport.mode.private_vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.switchport.mode.private_vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_mode_private_vlan_host_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.switchport.mode.private_vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.switchport.mode.private_vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.switchport.mode.private_vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'host'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_mode_private_vlan_promiscuous_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.switchport.mode.private_vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.switchport.mode.private_vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.switchport.mode.private_vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'promiscuous'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_mode_private_vlan_trunk_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.switchport.mode.private_vlan.private_vlan_trunk', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.switchport.mode.private_vlan.private_vlan_trunk', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.switchport.mode.private_vlan.private_vlan_trunk', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_mode_private_vlan_trunk_host_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.switchport.mode.private_vlan.private_vlan_trunk', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.switchport.mode.private_vlan.private_vlan_trunk', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.switchport.mode.private_vlan.private_vlan_trunk', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'host'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_mode_private_vlan_trunk_promiscuous_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.switchport.mode.private_vlan.private_vlan_trunk', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.switchport.mode.private_vlan.private_vlan_trunk', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.switchport.mode.private_vlan.private_vlan_trunk', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'promiscuous'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_mode_private_vlan_trunk_trunk_basic_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.switchport.mode.private_vlan.private_vlan_trunk', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.switchport.mode.private_vlan.private_vlan_trunk', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.switchport.mode.private_vlan.private_vlan_trunk', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'trunk-basic'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_mode_vlan_mode_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.switchport.mode', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.switchport.mode', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.switchport.mode', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vlan-mode'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_port_security_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.switchport.port_security', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.switchport.port_security', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.switchport.port_security', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_port_security_allowed_ouis_delete(self, hundredgigabitethernet=None, allowed_ouis=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type allowed_ouis: oui
    :param allowed_ouis: Keyword argument tuple.

    :type oui: unicode
    :param oui: **allowed_ouis** tuple argument:  <OUI> OUI in HHHH.HH00.0000 format

        * pattern restriction: ::

            '[0-9a-fA-F]{4}\.[0-9a-fA-F]{2}00\.0000'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.switchport.port_security.allowed_ouis', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.switchport.port_security.allowed_ouis', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.switchport.port_security.allowed_ouis', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'allowed_ouis', 'keyval': 'oui', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, allowed_ouis=allowed_ouis)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, allowed_ouis=allowed_ouis)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_port_security_max_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.switchport.port_security', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.switchport.port_security', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.switchport.port_security', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'max'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_port_security_port_secutiry_mac_address_delete(self, hundredgigabitethernet=None, port_secutiry_mac_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type port_secutiry_mac_address: mac_address, port_sec_vlan
    :param port_secutiry_mac_address: Keyword argument tuple.

    :type mac_address: unicode
    :param mac_address: **port_secutiry_mac_address** tuple argument:  Mac Address

    :type port_sec_vlan: long
    :param port_sec_vlan: **port_secutiry_mac_address** tuple argument:  Forwarding vlan

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.switchport.port_security.port_secutiry_mac_address', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.switchport.port_security.port_secutiry_mac_address', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.switchport.port_security.port_secutiry_mac_address', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'port_secutiry_mac_address', 'keyval': 'mac_address, port_sec_vlan', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, port_secutiry_mac_address=port_secutiry_mac_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, port_secutiry_mac_address=port_secutiry_mac_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_port_security_shutdown_time_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.switchport.port_security', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.switchport.port_security', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.switchport.port_security', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'shutdown-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_port_security_sticky_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.switchport.port_security.sticky', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.switchport.port_security.sticky', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_port_security_sticky_port_secutiry_mac_address_delete(self, hundredgigabitethernet=None, port_secutiry_mac_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type port_secutiry_mac_address: mac_address, port_sec_vlan
    :param port_secutiry_mac_address: Keyword argument tuple.

    :type mac_address: unicode
    :param mac_address: **port_secutiry_mac_address** tuple argument:  Mac Address

    :type port_sec_vlan: long
    :param port_sec_vlan: **port_secutiry_mac_address** tuple argument:  Forwarding vlan

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.switchport.port_security.sticky.port_secutiry_mac_address', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.switchport.port_security.sticky.port_secutiry_mac_address', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.switchport.port_security.sticky.port_secutiry_mac_address', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'port_secutiry_mac_address', 'keyval': 'mac_address, port_sec_vlan', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, port_secutiry_mac_address=port_secutiry_mac_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, port_secutiry_mac_address=port_secutiry_mac_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_port_security_sticky_sticky_flag_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.switchport.port_security.sticky', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.switchport.port_security.sticky', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.switchport.port_security.sticky', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'sticky-flag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_port_security_violation_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.switchport.port_security', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.switchport.port_security', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.switchport.port_security', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'violation'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_private_vlan_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.switchport.private_vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.switchport.private_vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.switchport.private_vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_private_vlan_association_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.switchport.private_vlan.association', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.switchport.private_vlan.association', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.switchport.private_vlan.association', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_private_vlan_association_trunk_delete(self, hundredgigabitethernet=None, trunk=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type trunk: trunk_pri_pvlan, trunk_sec_pvlan
    :param trunk: Keyword argument tuple.

    :type trunk_pri_pvlan: long
    :param trunk_pri_pvlan: **trunk** tuple argument:  Primary vlan id

        * range restriction: ::

            ['0..4294967295']

    :type trunk_sec_pvlan: long
    :param trunk_sec_pvlan: **trunk** tuple argument:  Secondary vlan id 

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.switchport.private_vlan.association.trunk', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.switchport.private_vlan.association.trunk', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.switchport.private_vlan.association.trunk', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'trunk', 'keyval': 'trunk_pri_pvlan, trunk_sec_pvlan', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, trunk=trunk)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, trunk=trunk)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_private_vlan_host_association_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.switchport.private_vlan.host_association', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.switchport.private_vlan.host_association', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.switchport.private_vlan.host_association', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'host_pri_pvlan, host_sec_pvlan'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_private_vlan_host_association_host_pri_pvlan_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.switchport.private_vlan.host_association', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.switchport.private_vlan.host_association', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.switchport.private_vlan.host_association', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'host-pri-pvlan'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_private_vlan_host_association_host_sec_pvlan_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.switchport.private_vlan.host_association', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.switchport.private_vlan.host_association', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.switchport.private_vlan.host_association', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'host-sec-pvlan'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_private_vlan_mapping_delete(self, hundredgigabitethernet=None, mapping=None, oper=None, promis_sec_pvlan_range=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type mapping: promis_pri_pvlan, oper, promis_sec_pvlan_range
    :param mapping: Keyword argument tuple.

    :type promis_pri_pvlan: long
    :param promis_pri_pvlan: **mapping** tuple argument:  Primary vlan id

        * range restriction: ::

            ['0..4294967295']

    :type oper: unicode
    :param oper: **mapping** tuple argument.

        * enumeration restriction: ::

            ['add', 'delete']

    :type promis_sec_pvlan_range: unicode
    :param promis_sec_pvlan_range: **mapping** tuple argument:  Secondary vlan range

        * length restriction: ::

            ['1..253']

        * pattern restriction: ::

            '(([1-9][0-9]{0,2})|([1-7][0-9]{3})|(80[0-9]{2})|'
            '(81[0-8][0-9])|(819[01]))(-(([2-9])|([1-9][0-9]{'
            '1,2})|([1-7][0-9]{3})|(80[0-9]{2})|(81[0-8][0-9]'
            ')|(819[01])))?((,(([2-9])|([1-9][0-9]{1,2})|([1-'
            '7][0-9]{3})|(80[0-9]{2})|(81[0-8][0-9])|(819[01]'
            '))(-(([3-9])|([1-9][0-9]{1,2})|([1-7][0-9]{3})|('
            '80[0-9]{2})|(81[0-8][0-9])|(819[01])))?)?)*'

    **Instance Argument(s)**:

    :type oper: unicode
    :param oper: Keyword argument.

        * enumeration restriction: ::

            ['add', 'delete']

    :type promis_sec_pvlan_range: unicode
    :param promis_sec_pvlan_range: Secondary vlan range

        * length restriction: ::

            ['1..253']

        * pattern restriction: ::

            '(([1-9][0-9]{0,2})|([1-7][0-9]{3})|(80[0-9]{2})|'
            '(81[0-8][0-9])|(819[01]))(-(([2-9])|([1-9][0-9]{'
            '1,2})|([1-7][0-9]{3})|(80[0-9]{2})|(81[0-8][0-9]'
            ')|(819[01])))?((,(([2-9])|([1-9][0-9]{1,2})|([1-'
            '7][0-9]{3})|(80[0-9]{2})|(81[0-8][0-9])|(819[01]'
            '))(-(([3-9])|([1-9][0-9]{1,2})|([1-7][0-9]{3})|('
            '80[0-9]{2})|(81[0-8][0-9])|(819[01])))?)?)*'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.switchport.private_vlan.mapping', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.switchport.private_vlan.mapping', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.switchport.private_vlan.mapping', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mapping', 'keyval': 'promis_pri_pvlan', 'extra_keyval': 'promis_pri_pvlan, oper, promis_sec_pvlan_range'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, mapping=mapping, oper=oper, promis_sec_pvlan_range=promis_sec_pvlan_range)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, mapping=mapping, oper=oper, promis_sec_pvlan_range=promis_sec_pvlan_range)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_private_vlan_mapping_oper_delete(self, hundredgigabitethernet=None, mapping=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type mapping: promis_pri_pvlan
    :param mapping: Keyword argument tuple.

    :type promis_pri_pvlan: long
    :param promis_pri_pvlan: **mapping** tuple argument:  Primary vlan id

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.switchport.private_vlan.mapping', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.switchport.private_vlan.mapping', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.switchport.private_vlan.mapping', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mapping', 'keyval': 'promis_pri_pvlan', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'oper'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, mapping=mapping)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, mapping=mapping)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_private_vlan_mapping_promis_sec_pvlan_range_delete(self, hundredgigabitethernet=None, mapping=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type mapping: promis_pri_pvlan
    :param mapping: Keyword argument tuple.

    :type promis_pri_pvlan: long
    :param promis_pri_pvlan: **mapping** tuple argument:  Primary vlan id

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.switchport.private_vlan.mapping', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.switchport.private_vlan.mapping', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.switchport.private_vlan.mapping', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mapping', 'keyval': 'promis_pri_pvlan', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'promis-sec-pvlan-range'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, mapping=mapping)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, mapping=mapping)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_private_vlan_trunk_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.switchport.private_vlan.trunk', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.switchport.private_vlan.trunk', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.switchport.private_vlan.trunk', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_private_vlan_trunk_allowed_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.switchport.private_vlan.trunk.allowed', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.switchport.private_vlan.trunk.allowed', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.switchport.private_vlan.trunk.allowed', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_private_vlan_trunk_allowed_trunk_private_vlan_classification_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_private_vlan_trunk_allowed_vlan_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.switchport.private_vlan.trunk.allowed.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.switchport.private_vlan.trunk.allowed.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.switchport.private_vlan.trunk.allowed.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_private_vlan_trunk_allowed_vlan_add_delete(self, hundredgigabitethernet=None, add=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type add: trunk_vlan_id, trunk_ctag_id
    :param add: Keyword argument tuple.

    :type trunk_vlan_id: long
    :param trunk_vlan_id: **add** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type trunk_ctag_id: long
    :param trunk_ctag_id: **add** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan.add_', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan.add_', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan.add_', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'add', 'keyval': 'trunk_vlan_id, trunk_ctag_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, add=add)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, add=add)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_private_vlan_trunk_allowed_vlan_all_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.switchport.private_vlan.trunk.allowed.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.switchport.private_vlan.trunk.allowed.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.switchport.private_vlan.trunk.allowed.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'all'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_private_vlan_trunk_allowed_vlan_except_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.switchport.private_vlan.trunk.allowed.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.switchport.private_vlan.trunk.allowed.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.switchport.private_vlan.trunk.allowed.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'except'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_private_vlan_trunk_allowed_vlan_none_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.switchport.private_vlan.trunk.allowed.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.switchport.private_vlan.trunk.allowed.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.switchport.private_vlan.trunk.allowed.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'none'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_private_vlan_trunk_allowed_vlan_remove_delete(self, hundredgigabitethernet=None, remove=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type remove: trunk_vlan_id, trunk_ctag_id
    :param remove: Keyword argument tuple.

    :type trunk_vlan_id: long
    :param trunk_vlan_id: **remove** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type trunk_ctag_id: long
    :param trunk_ctag_id: **remove** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan.remove_', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan.remove_', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan.remove_', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'remove', 'keyval': 'trunk_vlan_id, trunk_ctag_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, remove=remove)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, remove=remove)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_private_vlan_trunk_allowed_vlan_trunk_private_vlan_classification_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_private_vlan_trunk_native_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.switchport.private_vlan.trunk.native', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.switchport.private_vlan.trunk.native', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.switchport.private_vlan.trunk.native', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'pvlanNativevlan, pvlan_native_vlan_ctag_id'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_private_vlan_trunk_native_ctag_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.switchport.private_vlan.trunk.native', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.switchport.private_vlan.trunk.native', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.switchport.private_vlan.trunk.native', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ctag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_private_vlan_trunk_native_vlan_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.switchport.private_vlan.trunk.native', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.switchport.private_vlan.trunk.native', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.switchport.private_vlan.trunk.native', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vlan'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_private_vlan_trunk_private_vlan_classification_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.switchport.trunk_private_vlan_classification.private_vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.switchport.trunk_private_vlan_classification.private_vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.switchport.trunk_private_vlan_classification.private_vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_private_vlan_trunk_tag_native_vlan_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.switchport.private_vlan.trunk.pvlan_tag', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.switchport.private_vlan.trunk.pvlan_tag', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.switchport.private_vlan.trunk.pvlan_tag', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'native-vlan'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_private_vlan_trunk_trunk_private_vlan_classification_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_trunk_allowed_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.switchport.trunk.allowed', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.switchport.trunk.allowed', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.switchport.trunk.allowed', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_trunk_allowed_rspan_vlan_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.switchport.trunk.allowed.rspan_vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.switchport.trunk.allowed.rspan_vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.switchport.trunk.allowed.rspan_vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_trunk_allowed_rspan_vlan_add_delete(self, hundredgigabitethernet=None, add=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type add: trunk_vlan_id, trunk_ctag_id
    :param add: Keyword argument tuple.

    :type trunk_vlan_id: long
    :param trunk_vlan_id: **add** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type trunk_ctag_id: long
    :param trunk_ctag_id: **add** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan.add_', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan.add_', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan.add_', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'add', 'keyval': 'trunk_vlan_id, trunk_ctag_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, add=add)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, add=add)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_trunk_allowed_rspan_vlan_remove_delete(self, hundredgigabitethernet=None, remove=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type remove: trunk_vlan_id, trunk_ctag_id
    :param remove: Keyword argument tuple.

    :type trunk_vlan_id: long
    :param trunk_vlan_id: **remove** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type trunk_ctag_id: long
    :param trunk_ctag_id: **remove** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan.remove_', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan.remove_', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan.remove_', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'remove', 'keyval': 'trunk_vlan_id, trunk_ctag_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, remove=remove)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, remove=remove)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_trunk_allowed_rspan_vlan_trunk_rspan_vlan_classification_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_trunk_allowed_trunk_rspan_vlan_classification_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_trunk_allowed_trunk_vlan_classification_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.switchport.trunk.trunk_vlan_classification.allowed', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.switchport.trunk.trunk_vlan_classification.allowed', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.switchport.trunk.trunk_vlan_classification.allowed', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_trunk_allowed_vlan_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.switchport.trunk.allowed.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.switchport.trunk.allowed.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.switchport.trunk.allowed.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_trunk_allowed_vlan_add_delete(self, hundredgigabitethernet=None, add=None, trunk_ctag_range=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type add: trunk_vlan_id
    :param add: Keyword argument tuple.

    :type trunk_vlan_id: long
    :param trunk_vlan_id: **add** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Argument(s)**:

    :type trunk_ctag_range: unicode
    :param trunk_ctag_range: Keyword argument.

        * length restriction: ::

            ['1..1000']

        * pattern restriction: ::

            '(([1-9][0-9]{0,2})|([1-3][0-9]{3})|(40[0-8][0-9]'
            ')|(409[0-4]))(-((1[0-9]{1,2})|([2-9][0-9]{0,2})|'
            '([1-3][0-9]{3})|(40[0-8][0-9])|(409[0-4])))?((,('
            '(1[0-9]{1,2})|([2-9][0-9]{0,2})|([1-3][0-9]{3})|'
            '(40[0-8][0-9])|(409[0-4]))(-((1[0-9]{1,2})|([2-9'
            '][0-9]{0,2})|([1-3][0-9]{3})|(40[0-8][0-9])|(409'
            '[0-4])))?)?)*'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan.add_', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan.add_', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan.add_', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'add', 'keyval': 'trunk_vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, add=add, trunk_ctag_range=trunk_ctag_range)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, add=add, trunk_ctag_range=trunk_ctag_range)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_trunk_allowed_vlan_add_ctag_delete(self, hundredgigabitethernet=None, add=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type add: trunk_vlan_id
    :param add: Keyword argument tuple.

    :type trunk_vlan_id: long
    :param trunk_vlan_id: **add** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan.add_', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan.add_', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan.add_', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'add', 'keyval': 'trunk_vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ctag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, add=add)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, add=add)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_trunk_allowed_vlan_all_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.switchport.trunk.allowed.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.switchport.trunk.allowed.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.switchport.trunk.allowed.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'all'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_trunk_allowed_vlan_except_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.switchport.trunk.allowed.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.switchport.trunk.allowed.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.switchport.trunk.allowed.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'except'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_trunk_allowed_vlan_none_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.switchport.trunk.allowed.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.switchport.trunk.allowed.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.switchport.trunk.allowed.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'none'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_trunk_allowed_vlan_remove_delete(self, hundredgigabitethernet=None, remove=None, trunk_ctag_range=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type remove: trunk_vlan_id
    :param remove: Keyword argument tuple.

    :type trunk_vlan_id: long
    :param trunk_vlan_id: **remove** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Argument(s)**:

    :type trunk_ctag_range: unicode
    :param trunk_ctag_range: Keyword argument.

        * length restriction: ::

            ['1..1000']

        * pattern restriction: ::

            '(([1-9][0-9]{0,2})|([1-3][0-9]{3})|(40[0-8][0-9]'
            ')|(409[0-4]))(-((1[0-9]{1,2})|([2-9][0-9]{0,2})|'
            '([1-3][0-9]{3})|(40[0-8][0-9])|(409[0-4])))?((,('
            '(1[0-9]{1,2})|([2-9][0-9]{0,2})|([1-3][0-9]{3})|'
            '(40[0-8][0-9])|(409[0-4]))(-((1[0-9]{1,2})|([2-9'
            '][0-9]{0,2})|([1-3][0-9]{3})|(40[0-8][0-9])|(409'
            '[0-4])))?)?)*'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan.remove_', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan.remove_', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan.remove_', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'remove', 'keyval': 'trunk_vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, remove=remove, trunk_ctag_range=trunk_ctag_range)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, remove=remove, trunk_ctag_range=trunk_ctag_range)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_trunk_allowed_vlan_remove_ctag_delete(self, hundredgigabitethernet=None, remove=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type remove: trunk_vlan_id
    :param remove: Keyword argument tuple.

    :type trunk_vlan_id: long
    :param trunk_vlan_id: **remove** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan.remove_', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan.remove_', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan.remove_', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'remove', 'keyval': 'trunk_vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ctag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, remove=remove)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, remove=remove)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_trunk_allowed_vlan_trunk_vlan_classification_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_trunk_allowed_vlanoper_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.switchport.trunk.allowed.vlanoper', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.switchport.trunk.allowed.vlanoper', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.switchport.trunk.allowed.vlanoper', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_trunk_allowed_vlanoper_vlan_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.switchport.trunk.allowed.vlanoper.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.switchport.trunk.allowed.vlanoper.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.switchport.trunk.allowed.vlanoper.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_trunk_allowed_vlanoper_vlan_add_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.switchport.trunk.allowed.vlanoper.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.switchport.trunk.allowed.vlanoper.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.switchport.trunk.allowed.vlanoper.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'add'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_trunk_allowed_vlanoper_vlan_remove_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.switchport.trunk.allowed.vlanoper.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.switchport.trunk.allowed.vlanoper.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.switchport.trunk.allowed.vlanoper.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'remove'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_trunk_ctag_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.switchport.trunk.native_vlan_classification', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.switchport.trunk.native_vlan_classification', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.switchport.trunk.native_vlan_classification', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ctag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_trunk_ctag_native_vlan_xtagged_config_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.switchport.trunk.native_vlan_xtagged_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.switchport.trunk.native_vlan_xtagged_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.switchport.trunk.native_vlan_xtagged_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ctag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_trunk_default_vlan_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.switchport.trunk.default_vlan_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.switchport.trunk.default_vlan_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.switchport.trunk.default_vlan_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'default-vlan'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_trunk_default_vlan_config_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.switchport.trunk.default_vlan_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.switchport.trunk.default_vlan_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.switchport.trunk.default_vlan_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'default_transparent_vlan'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_trunk_egress_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.switchport.trunk.native_vlan_xtagged_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.switchport.trunk.native_vlan_xtagged_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.switchport.trunk.native_vlan_xtagged_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'egress'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_trunk_native_vlan_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.switchport.trunk.native_vlan_classification', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.switchport.trunk.native_vlan_classification', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.switchport.trunk.native_vlan_classification', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'native-vlan'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_trunk_native_vlan_classification_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.switchport.trunk.native_vlan_classification', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.switchport.trunk.native_vlan_classification', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.switchport.trunk.native_vlan_classification', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'native_vlan_id, native_vlan_ctag_id'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_trunk_native_vlan_untagged_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.switchport.trunk.native_vlan_untagged_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.switchport.trunk.native_vlan_untagged_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.switchport.trunk.native_vlan_untagged_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'native-vlan-untagged'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_trunk_native_vlan_untagged_config_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.switchport.trunk.native_vlan_untagged_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.switchport.trunk.native_vlan_untagged_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.switchport.trunk.native_vlan_untagged_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'native_vlan_id_untagged'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_trunk_native_vlan_xtagged_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.switchport.trunk.native_vlan_xtagged_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.switchport.trunk.native_vlan_xtagged_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.switchport.trunk.native_vlan_xtagged_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'native-vlan-xtagged'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_trunk_native_vlan_xtagged_config_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.switchport.trunk.native_vlan_xtagged_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.switchport.trunk.native_vlan_xtagged_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.switchport.trunk.native_vlan_xtagged_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_trunk_private_vlan_classification_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.switchport.trunk_private_vlan_classification', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.switchport.trunk_private_vlan_classification', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.switchport.trunk_private_vlan_classification', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_trunk_tag_native_vlan_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.switchport.trunk.tag', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.switchport.trunk.tag', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.switchport.trunk.tag', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'native-vlan'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_trunk_trunk_vlan_classification_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.switchport.trunk.trunk_vlan_classification', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.switchport.trunk.trunk_vlan_classification', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.switchport.trunk.trunk_vlan_classification', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_track_enable_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.track', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.track', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.track', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_track_interface_delete(self, hundredgigabitethernet=None, interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type interface: track_interface_type, track_interface_name
    :param interface: Keyword argument tuple.

    :type track_interface_type: unicode
    :param track_interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 'port-channel']

    :type track_interface_name: unicode
    :param track_interface_name: **interface** tuple argument:  Interface name

        * pattern restriction: ::

            '(((([1-9]|[1-9][0-9]|1[0-9]{2}|2[0-3][0-9])/)?(('
            '[0-9]|1[0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0-9]'
            ')(:[1-4])?)|([1-9]|[1-9][0-9]|[1-9][0-9]{2}|[1-5'
            '][0-9]{3}|6[0-1][0-4]{2}))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.track.interface', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.track.interface', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.track.interface', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'track_interface_type, track_interface_name', 'extra_keyval': 'track_interface_type, track_interface_name'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, interface=interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_track_min_link_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.track', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.track', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.track', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'min-link'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_track_remove_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.track.remove_', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.track.remove_', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.track.remove_', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_track_remove_all_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.track.remove_', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.track.remove_', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.track.remove_', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'all'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_tunable_optics_sfpp_channel_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.tunable_optics.sfpp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.tunable_optics.sfpp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'channel'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_udld_enable_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.udld', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.udld', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.udld', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_vlan_classifier_activate_group_delete(self, hundredgigabitethernet=None, group=None, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type group: groupid, vlan
    :param group: Keyword argument tuple.

    :type groupid: long
    :param groupid: **group** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vlan: long
    :param vlan: **group** tuple argument:  1-8191;;Vlan

        * range restriction: ::

            ['0..4294967295']

    **Instance Argument(s)**:

    :type vlan: long
    :param vlan: 1-8191;;Vlan

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.vlan.classifier.activate.group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.vlan.classifier.activate.group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.vlan.classifier.activate.group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'group', 'keyval': 'groupid', 'extra_keyval': 'groupid, vlan'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, group=group, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, group=group, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_vlan_classifier_activate_group_vlan_delete(self, hundredgigabitethernet=None, group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type group: groupid
    :param group: Keyword argument tuple.

    :type groupid: long
    :param groupid: **group** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.vlan.classifier.activate.group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.vlan.classifier.activate.group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.vlan.classifier.activate.group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'group', 'keyval': 'groupid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vlan'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, group=group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, group=group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_vrf_forwarding_delete(self, hundredgigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.vrf', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.vrf', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.vrf', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'forwarding'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_vrrp_group_delete(self, hundredgigabitethernet=None, vrrp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.vrrp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.vrrp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.vrrp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, vrrp=vrrp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_vrrp_group_advertisement_interval_delete(self, hundredgigabitethernet=None, vrrp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.vrrp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.vrrp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.vrrp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'advertisement-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, vrrp=vrrp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_vrrp_group_arp_unicast_request_receive_delete(self, hundredgigabitethernet=None, vrrp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.vrrp', u'vrrp'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.vrrp', u'vrrp'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.vrrp', u'vrrp')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.vrrp.arp.unicast_request', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.vrrp.arp.unicast_request', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.vrrp.arp.unicast_request', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'receive'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, vrrp=vrrp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_vrrp_group_description_delete(self, hundredgigabitethernet=None, vrrp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.vrrp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.vrrp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.vrrp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'description'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, vrrp=vrrp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_vrrp_group_enable_delete(self, hundredgigabitethernet=None, vrrp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.vrrp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.vrrp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.vrrp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, vrrp=vrrp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_vrrp_group_hold_time_delete(self, hundredgigabitethernet=None, vrrp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.vrrp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.vrrp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.vrrp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hold-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, vrrp=vrrp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_vrrp_group_preempt_mode_delete(self, hundredgigabitethernet=None, vrrp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.vrrp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.vrrp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.vrrp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'preempt-mode'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, vrrp=vrrp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_vrrp_group_priority_delete(self, hundredgigabitethernet=None, vrrp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.vrrp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.vrrp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.vrrp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, vrrp=vrrp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_vrrp_group_track_interface_delete(self, hundredgigabitethernet=None, vrrp=None, interface=None, track_priority=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Argument(s)**:

    :type track_priority: int
    :param track_priority: Track Priority

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.vrrp', u'vrrp'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.vrrp', u'vrrp'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.vrrp', u'vrrp')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.vrrp.track.interface', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.vrrp.track.interface', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.vrrp.track.interface', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, vrrp=vrrp, interface=interface, track_priority=track_priority)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, vrrp=vrrp, interface=interface, track_priority=track_priority)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_vrrp_group_track_interface_priority_delete(self, hundredgigabitethernet=None, vrrp=None, interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.vrrp', u'vrrp'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.vrrp', u'vrrp'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.vrrp', u'vrrp')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.vrrp.track.interface', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.vrrp.track.interface', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.vrrp.track.interface', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, vrrp=vrrp, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, vrrp=vrrp, interface=interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_vrrp_group_use_v2_checksum_delete(self, hundredgigabitethernet=None, vrrp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.vrrp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.vrrp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.vrrp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'use-v2-checksum'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, vrrp=vrrp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_hundredgigabitethernet_vrrp_group_virtual_ip_delete(self, hundredgigabitethernet=None, vrrp=None, virtual_ip=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type virtual_ip: virtual_ipaddr
    :param virtual_ip: Keyword argument tuple.

    :type virtual_ipaddr: unicode
    :param virtual_ipaddr: **virtual_ip** tuple argument:  Virtual IPv4 address in dotted decimal

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.vrrp', u'vrrp'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.vrrp', u'vrrp'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.vrrp', u'vrrp')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.hundredgigabitethernet.vrrp.virtual_ip', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.hundredgigabitethernet.vrrp.virtual_ip', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.hundredgigabitethernet.vrrp.virtual_ip', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'virtual_ip', 'keyval': 'virtual_ipaddr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, vrrp=vrrp, virtual_ip=virtual_ip)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, vrrp=vrrp, virtual_ip=virtual_ip)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_delete(self, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.hide_intf_loopback_holder.interface.loopback', 'pybind.nos.v6_0_2c.brocade_intf_loopback', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_intf_loopback_holder.interface.loopback', 'pybind.nos.v7_0_1b.brocade_intf_loopback', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_intf_loopback_holder.interface.loopback', 'pybind.nos.v7_1_0.brocade_intf_loopback', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'loopback', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v7_0_1b.hide_intf_loopback_holder.interface.loopback": {"id": "id"}, "pybind.slxos.v16r_1_00b.routing_system.interface.loopback": {}, "pybind.nos.v6_0_2c.hide_intf_loopback_holder.interface.loopback": {"id": "id"}, "pybind.nos.v7_1_0.hide_intf_loopback_holder.interface.loopback": {"id": "id"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_ip_delete(self, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.hide_intf_loopback_holder.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2c.hide_intf_loopback_holder.interface.loopback', u'loopback'), ('pybind.nos.v7_1_0.hide_intf_loopback_holder.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2c.hide_intf_loopback_holder.interface.loopback.ip', 'pybind.nos.v6_0_2c.brocade_intf_loopback', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_intf_loopback_holder.interface.loopback.ip', 'pybind.nos.v7_0_1b.brocade_intf_loopback', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_intf_loopback_holder.interface.loopback.ip', 'pybind.nos.v7_1_0.brocade_intf_loopback', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_ip_address_delete(self, loopback=None, address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type address: address
    :param address: Keyword argument tuple.

    :type address: unicode
    :param address: **address** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]'
            '|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0'
            '-4][0-9]|25[0-5])/32'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', u'loopback'), ('pybind.nos.v7_0_1b.hide_intf_loopback_holder.interface.loopback', u'loopback'), ('pybind.nos.v7_1_0.hide_intf_loopback_holder.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2c.hide_intf_loopback_holder.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2c.hide_intf_loopback_holder.interface.loopback.ip.ip_config.address', 'pybind.nos.v6_0_2c.brocade_intf_loopback', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_intf_loopback_holder.interface.loopback.ip.ip_config.address', 'pybind.nos.v7_0_1b.brocade_intf_loopback', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_intf_loopback_holder.interface.loopback.ip.ip_config.address', 'pybind.nos.v7_1_0.brocade_intf_loopback', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.interface.loopback.ip.ip_config.address', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'address', 'keyval': 'address', 'extra_keyval': 'address'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback, address=address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback, address=address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_ip_interface_loopback_ospf_conf_delete(self, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback.ip.interface_loopback_ospf_conf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_ip_intf_router_isis_delete(self, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback.ip.intf_router_isis', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_ip_ip_config_delete(self, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.hide_intf_loopback_holder.interface.loopback', u'loopback'), ('pybind.nos.v7_0_1b.hide_intf_loopback_holder.interface.loopback', u'loopback'), ('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', u'loopback'), ('pybind.nos.v7_1_0.hide_intf_loopback_holder.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2c.hide_intf_loopback_holder.interface.loopback.ip.ip_config', 'pybind.nos.v6_0_2c.brocade_intf_loopback', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_intf_loopback_holder.interface.loopback.ip.ip_config', 'pybind.nos.v7_0_1b.brocade_intf_loopback', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_intf_loopback_holder.interface.loopback.ip.ip_config', 'pybind.nos.v7_1_0.brocade_intf_loopback', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.interface.loopback.ip.ip_config', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_ip_multicast_boundary_delete(self, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback.ip.pim_intf_loopback_cont.pim_int_cmd', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'multicast-boundary'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_ip_ospf_active_delete(self, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'active'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_ip_ospf_area_delete(self, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'area'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_ip_ospf_auth_change_wait_time_delete(self, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'auth-change-wait-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_ip_ospf_authentication_key_delete(self, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1.authentication_key', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_ip_ospf_authentication_key_auth_key_delete(self, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1.authentication_key.auth_key_table', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'auth-key'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_ip_ospf_authentication_key_auth_key_table_delete(self, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1.authentication_key.auth_key_table', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'encrypttype, auth_key'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_ip_ospf_authentication_key_encrypttype_delete(self, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1.authentication_key.auth_key_table', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'encrypttype'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_ip_ospf_authentication_key_no_encrypt_auth_key_delete(self, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1.authentication_key.no_encrypt_auth_key_table', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'no-encrypt-auth-key'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_ip_ospf_authentication_key_no_encrypt_auth_key_table_delete(self, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1.authentication_key.no_encrypt_auth_key_table', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_ip_ospf_bfd_delete(self, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1.bfd', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_ip_ospf_bfd_intf_bfd_enable_delete(self, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1.bfd', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'intf-bfd-enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_ip_ospf_cost_delete(self, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cost'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_ip_ospf_database_filter_all_external_delete(self, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1.database_filter', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'all-external'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_ip_ospf_database_filter_all_out_delete(self, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1.database_filter', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'all-out'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_ip_ospf_database_filter_all_summary_external_delete(self, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1.database_filter', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'all-summary-external'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_ip_ospf_dead_interval_delete(self, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dead-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_ip_ospf_hello_interval_delete(self, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hello-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_ip_ospf_ldp_sync_delete(self, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ldp-sync'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_ip_ospf_md5_authentication_key_activation_wait_time_delete(self, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1.md5_authentication', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'key-activation-wait-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_ip_ospf_md5_authentication_key_id_delete(self, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1.md5_authentication.key_table', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'key_id, key, md5_authentication_key'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_ip_ospf_md5_authentication_key_id_key_delete(self, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1.md5_authentication.key_table', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'key'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_ip_ospf_md5_authentication_key_id_key_id_delete(self, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1.md5_authentication.key_table', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'key-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_ip_ospf_md5_authentication_no_encrypt_key_delete(self, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1.md5_authentication.no_encrypt_key_table', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'no-encrypt-key'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_ip_ospf_md5_authentication_no_encrypt_key_id_delete(self, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1.md5_authentication.no_encrypt_key_table', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'no-encrypt-key-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_ip_ospf_mtu_ignore_delete(self, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mtu-ignore'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_ip_ospf_network_delete(self, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'network'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_ip_ospf_passive_delete(self, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'passive'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_ip_ospf_priority_delete(self, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_ip_ospf_retransmit_interval_delete(self, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'retransmit-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_ip_ospf_transmit_delay_delete(self, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'transmit-delay'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_ip_pim_dr_priority_delete(self, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback.ip.pim_intf_loopback_cont.pim_int_cmd.pim', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dr-priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_ip_pim_int_cmd_delete(self, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback.ip.pim_intf_loopback_cont.pim_int_cmd', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_ip_pim_intf_loopback_cont_delete(self, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback.ip.pim_intf_loopback_cont', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_ip_pim_neighbor_filter_delete(self, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback.ip.pim_intf_loopback_cont.pim_int_cmd.pim', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'neighbor-filter'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_ip_pim_sparse_delete(self, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback.ip.pim_intf_loopback_cont.pim_int_cmd', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'pim-sparse'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_ip_pim_ttl_threshold_delete(self, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback.ip.pim_intf_loopback_cont.pim_int_cmd.pim', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ttl-threshold'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_ip_router_isis_delete(self, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback.ip.intf_router_isis.int_router_isis', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'isis'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_ipv6_address_delete(self, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', u'loopback'), ('pybind.nos.v7_1_0.hide_intf_loopback_holder.interface.loopback', u'loopback'), ('pybind.nos.v7_0_1b.hide_intf_loopback_holder.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2c.hide_intf_loopback_holder.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2c.hide_intf_loopback_holder.interface.loopback.ipv6.ipv6_config.address', 'pybind.nos.v6_0_2c.brocade_intf_loopback', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_intf_loopback_holder.interface.loopback.ipv6.ipv6_config.address', 'pybind.nos.v7_0_1b.brocade_intf_loopback', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_intf_loopback_holder.interface.loopback.ipv6.ipv6_config.address', 'pybind.nos.v7_1_0.brocade_intf_loopback', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.interface.loopback.ipv6.ipv6_config.address', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_ipv6_address_ipv6_address_delete(self, loopback=None, ipv6_address=None, eui64=None, anycast=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ipv6_address: address, eui64, anycast
    :param ipv6_address: Keyword argument tuple.

    :type address: unicode
    :param address: **ipv6_address** tuple argument:  A:B::C:D/LEN;; IPv6 prefix format: xxxx:xxxx/ml, xxxx:xxxx::/ml, xxxx::xx/128

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type eui64: YANGBool
    :param eui64: **ipv6_address** tuple argument:  Configure ipv6 address with an automatically computed EUI-64 interface Id

    :type anycast: YANGBool
    :param anycast: **ipv6_address** tuple argument:  Configure ipv6 address as anycast

    **Instance Argument(s)**:

    :type eui64: YANGBool
    :param eui64: Configure ipv6 address with an automatically computed EUI-64 interface Id

    :type anycast: YANGBool
    :param anycast: Configure ipv6 address as anycast

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.hide_intf_loopback_holder.interface.loopback', u'loopback'), ('pybind.nos.v7_0_1b.hide_intf_loopback_holder.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2c.hide_intf_loopback_holder.interface.loopback', u'loopback'), ('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2c.hide_intf_loopback_holder.interface.loopback.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v6_0_2c.brocade_intf_loopback', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_intf_loopback_holder.interface.loopback.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v7_0_1b.brocade_intf_loopback', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_intf_loopback_holder.interface.loopback.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v7_1_0.brocade_intf_loopback', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.interface.loopback.ipv6.ipv6_config.address.ipv6_address', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_address', 'keyval': 'address', 'extra_keyval': 'address, eui64, anycast'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback, ipv6_address=ipv6_address, eui64=eui64, anycast=anycast)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback, ipv6_address=ipv6_address, eui64=eui64, anycast=anycast)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_ipv6_address_ipv6_address_anycast_delete(self, loopback=None, ipv6_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ipv6_address: address
    :param ipv6_address: Keyword argument tuple.

    :type address: unicode
    :param address: **ipv6_address** tuple argument:  A:B::C:D/LEN;; IPv6 prefix format: xxxx:xxxx/ml, xxxx:xxxx::/ml, xxxx::xx/128

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.hide_intf_loopback_holder.interface.loopback', u'loopback'), ('pybind.nos.v7_0_1b.hide_intf_loopback_holder.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2c.hide_intf_loopback_holder.interface.loopback', u'loopback'), ('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2c.hide_intf_loopback_holder.interface.loopback.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v6_0_2c.brocade_intf_loopback', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_intf_loopback_holder.interface.loopback.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v7_0_1b.brocade_intf_loopback', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_intf_loopback_holder.interface.loopback.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v7_1_0.brocade_intf_loopback', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.interface.loopback.ipv6.ipv6_config.address.ipv6_address', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_address', 'keyval': 'address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'anycast'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback, ipv6_address=ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback, ipv6_address=ipv6_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_ipv6_address_ipv6_address_eui_64_delete(self, loopback=None, ipv6_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ipv6_address: address
    :param ipv6_address: Keyword argument tuple.

    :type address: unicode
    :param address: **ipv6_address** tuple argument:  A:B::C:D/LEN;; IPv6 prefix format: xxxx:xxxx/ml, xxxx:xxxx::/ml, xxxx::xx/128

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.hide_intf_loopback_holder.interface.loopback', u'loopback'), ('pybind.nos.v7_0_1b.hide_intf_loopback_holder.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2c.hide_intf_loopback_holder.interface.loopback', u'loopback'), ('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2c.hide_intf_loopback_holder.interface.loopback.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v6_0_2c.brocade_intf_loopback', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_intf_loopback_holder.interface.loopback.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v7_0_1b.brocade_intf_loopback', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_intf_loopback_holder.interface.loopback.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v7_1_0.brocade_intf_loopback', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.interface.loopback.ipv6.ipv6_config.address.ipv6_address', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_address', 'keyval': 'address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'eui-64'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback, ipv6_address=ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback, ipv6_address=ipv6_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_ipv6_address_link_local_delete(self, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2c.hide_intf_loopback_holder.interface.loopback', u'loopback'), ('pybind.nos.v7_1_0.hide_intf_loopback_holder.interface.loopback', u'loopback'), ('pybind.nos.v7_0_1b.hide_intf_loopback_holder.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2c.hide_intf_loopback_holder.interface.loopback.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v6_0_2c.brocade_intf_loopback', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_intf_loopback_holder.interface.loopback.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v7_0_1b.brocade_intf_loopback', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_intf_loopback_holder.interface.loopback.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v7_1_0.brocade_intf_loopback', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.interface.loopback.ipv6.ipv6_config.address.link_local_config', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'link-local'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_ipv6_address_link_local_address_delete(self, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2c.hide_intf_loopback_holder.interface.loopback', u'loopback'), ('pybind.nos.v7_1_0.hide_intf_loopback_holder.interface.loopback', u'loopback'), ('pybind.nos.v7_0_1b.hide_intf_loopback_holder.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2c.hide_intf_loopback_holder.interface.loopback.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v6_0_2c.brocade_intf_loopback', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_intf_loopback_holder.interface.loopback.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v7_0_1b.brocade_intf_loopback', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_intf_loopback_holder.interface.loopback.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v7_1_0.brocade_intf_loopback', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.interface.loopback.ipv6.ipv6_config.address.link_local_config', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'link-local-address'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_ipv6_address_link_local_config_delete(self, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2c.hide_intf_loopback_holder.interface.loopback', u'loopback'), ('pybind.nos.v7_1_0.hide_intf_loopback_holder.interface.loopback', u'loopback'), ('pybind.nos.v7_0_1b.hide_intf_loopback_holder.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2c.hide_intf_loopback_holder.interface.loopback.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v6_0_2c.brocade_intf_loopback', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_intf_loopback_holder.interface.loopback.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v7_0_1b.brocade_intf_loopback', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_intf_loopback_holder.interface.loopback.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v7_1_0.brocade_intf_loopback', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.interface.loopback.ipv6.ipv6_config.address.link_local_config', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'link_local_address, link_local'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_ipv6_address_use_link_local_only_delete(self, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', u'loopback'), ('pybind.nos.v7_1_0.hide_intf_loopback_holder.interface.loopback', u'loopback'), ('pybind.nos.v7_0_1b.hide_intf_loopback_holder.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2c.hide_intf_loopback_holder.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2c.hide_intf_loopback_holder.interface.loopback.ipv6.ipv6_config.address', 'pybind.nos.v6_0_2c.brocade_intf_loopback', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_intf_loopback_holder.interface.loopback.ipv6.ipv6_config.address', 'pybind.nos.v7_0_1b.brocade_intf_loopback', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_intf_loopback_holder.interface.loopback.ipv6.ipv6_config.address', 'pybind.nos.v7_1_0.brocade_intf_loopback', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.interface.loopback.ipv6.ipv6_config.address', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'use-link-local-only'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_ipv6_intf_ipv6_router_isis_delete(self, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback.ipv6.intf_ipv6_router_isis', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_ipv6_ipv6_config_delete(self, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.hide_intf_loopback_holder.interface.loopback', u'loopback'), ('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2c.hide_intf_loopback_holder.interface.loopback', u'loopback'), ('pybind.nos.v7_1_0.hide_intf_loopback_holder.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2c.hide_intf_loopback_holder.interface.loopback.ipv6.ipv6_config', 'pybind.nos.v6_0_2c.brocade_intf_loopback', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_intf_loopback_holder.interface.loopback.ipv6.ipv6_config', 'pybind.nos.v7_0_1b.brocade_intf_loopback', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_intf_loopback_holder.interface.loopback.ipv6.ipv6_config', 'pybind.nos.v7_1_0.brocade_intf_loopback', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.interface.loopback.ipv6.ipv6_config', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_ipv6_ospf_active_delete(self, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback.ipv6.interface_ospfv3_conf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'active'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_ipv6_ospf_area_delete(self, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback.ipv6.interface_ospfv3_conf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'area'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_ipv6_ospf_authentication_ah_delete(self, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ah'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_ipv6_ospf_authentication_esp_delete(self, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'esp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_ipv6_ospf_authentication_esp_auth_delete(self, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'esp-auth'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_ipv6_ospf_authentication_esp_key_delete(self, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'esp-key'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_ipv6_ospf_authentication_esp_no_encrypt_delete(self, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'esp-no-encrypt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_ipv6_ospf_authentication_ipsec_delete(self, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_ipv6_ospf_authentication_ipsec_disable_delete(self, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'disable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_ipv6_ospf_authentication_ipsec_key_add_remove_interval_delete(self, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'key-add-remove-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_ipv6_ospf_authentication_key_delete(self, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'key'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_ipv6_ospf_authentication_no_encrypt_delete(self, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'no-encrypt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_ipv6_ospf_authentication_spi_delete(self, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'spi'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_ipv6_ospf_bfd_delete(self, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback.ipv6.interface_ospfv3_conf.bfd', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_ipv6_ospf_bfd_bfd_enable_delete(self, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback.ipv6.interface_ospfv3_conf.bfd', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bfd-enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_ipv6_ospf_cost_delete(self, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback.ipv6.interface_ospfv3_conf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cost'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_ipv6_ospf_dead_interval_delete(self, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dead-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_ipv6_ospf_hello_interval_delete(self, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hello-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_ipv6_ospf_hello_jitter_delete(self, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hello-jitter'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_ipv6_ospf_instance_delete(self, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback.ipv6.interface_ospfv3_conf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'instance'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_ipv6_ospf_mtu_ignore_delete(self, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback.ipv6.interface_ospfv3_conf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mtu-ignore'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_ipv6_ospf_network_delete(self, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback.ipv6.interface_ospfv3_conf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'network'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_ipv6_ospf_passive_delete(self, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback.ipv6.interface_ospfv3_conf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'passive'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_ipv6_ospf_priority_delete(self, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback.ipv6.interface_ospfv3_conf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_ipv6_ospf_retransmit_interval_delete(self, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'retransmit-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_ipv6_ospf_suppress_linklsa_delete(self, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback.ipv6.interface_ospfv3_conf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'suppress-linklsa'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_ipv6_ospf_transmit_delay_delete(self, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'transmit-delay'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_ipv6_router_isis_delete(self, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback.ipv6.intf_ipv6_router_isis.int_ipv6_router_isis', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'isis'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_isis_auth_check_level_1_disable_delete(self, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback.intf_isis.interface_isis.auth_check.auth_check_level1', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'disable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_isis_auth_check_level_2_disable_delete(self, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback.intf_isis.interface_isis.auth_check.auth_check_level2', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'disable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_isis_auth_key_delete(self, loopback=None, interface_auth_key=None, interface_auth_key_str=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type interface_auth_key: interface_auth_key_level, interface_auth_key_str
    :param interface_auth_key: Keyword argument tuple.

    :type interface_auth_key_level: unicode
    :param interface_auth_key_level: **interface_auth_key** tuple argument.

        * enumeration restriction: ::

            ['level-2', 'level-1']

    :type interface_auth_key_str: unicode
    :param interface_auth_key_str: **interface_auth_key** tuple argument.

        * length restriction: ::

            ['1..63']

    **Instance Argument(s)**:

    :type interface_auth_key_str: unicode
    :param interface_auth_key_str: Keyword argument.

        * length restriction: ::

            ['1..63']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback.intf_isis.interface_isis.interface_auth_key', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface_auth_key', 'keyval': 'interface_auth_key_level', 'extra_keyval': 'interface_auth_key_level, interface_auth_key_str'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback, interface_auth_key=interface_auth_key, interface_auth_key_str=interface_auth_key_str)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback, interface_auth_key=interface_auth_key, interface_auth_key_str=interface_auth_key_str)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_isis_auth_key_interface_auth_key_str_delete(self, loopback=None, interface_auth_key=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type interface_auth_key: interface_auth_key_level
    :param interface_auth_key: Keyword argument tuple.

    :type interface_auth_key_level: unicode
    :param interface_auth_key_level: **interface_auth_key** tuple argument.

        * enumeration restriction: ::

            ['level-2', 'level-1']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback.intf_isis.interface_isis.interface_auth_key', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface_auth_key', 'keyval': 'interface_auth_key_level', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'interface-auth-key-str'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback, interface_auth_key=interface_auth_key)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback, interface_auth_key=interface_auth_key)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_isis_auth_mode_md5_level_1_delete(self, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback.intf_isis.interface_isis.interface_auth_mode.interface_md5', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'level-1'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_isis_auth_mode_md5_level_2_delete(self, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback.intf_isis.interface_isis.interface_auth_mode.interface_md5', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'level-2'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_isis_bfd_disable_delete(self, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback.intf_isis.interface_isis.interface_bfd', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'disable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_isis_circuit_type_delete(self, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback.intf_isis.interface_isis', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'circuit-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_isis_hello_interval_delete(self, loopback=None, interface_hello_interval=None, interface_hello_interval_val=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type interface_hello_interval: interface_hello_interval_level, interface_hello_interval_val
    :param interface_hello_interval: Keyword argument tuple.

    :type interface_hello_interval_level: unicode
    :param interface_hello_interval_level: **interface_hello_interval** tuple argument.

        * enumeration restriction: ::

            ['level-2', 'level-1']

    :type interface_hello_interval_val: long
    :param interface_hello_interval_val: **interface_hello_interval** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Argument(s)**:

    :type interface_hello_interval_val: long
    :param interface_hello_interval_val: Keyword argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback.intf_isis.interface_isis.interface_hello_interval', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface_hello_interval', 'keyval': 'interface_hello_interval_level', 'extra_keyval': 'interface_hello_interval_level, interface_hello_interval_val'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback, interface_hello_interval=interface_hello_interval, interface_hello_interval_val=interface_hello_interval_val)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback, interface_hello_interval=interface_hello_interval, interface_hello_interval_val=interface_hello_interval_val)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_isis_hello_interval_interface_hello_interval_val_delete(self, loopback=None, interface_hello_interval=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type interface_hello_interval: interface_hello_interval_level
    :param interface_hello_interval: Keyword argument tuple.

    :type interface_hello_interval_level: unicode
    :param interface_hello_interval_level: **interface_hello_interval** tuple argument.

        * enumeration restriction: ::

            ['level-2', 'level-1']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback.intf_isis.interface_isis.interface_hello_interval', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface_hello_interval', 'keyval': 'interface_hello_interval_level', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'interface-hello-interval-val'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback, interface_hello_interval=interface_hello_interval)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback, interface_hello_interval=interface_hello_interval)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_isis_hello_multiplier_delete(self, loopback=None, interface_hello_multiplier=None, interface_hello_multiplier_val=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type interface_hello_multiplier: interface_hello_multiplier_level, interface_hello_multiplier_val
    :param interface_hello_multiplier: Keyword argument tuple.

    :type interface_hello_multiplier_level: unicode
    :param interface_hello_multiplier_level: **interface_hello_multiplier** tuple argument.

        * enumeration restriction: ::

            ['level-2', 'level-1']

    :type interface_hello_multiplier_val: long
    :param interface_hello_multiplier_val: **interface_hello_multiplier** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Argument(s)**:

    :type interface_hello_multiplier_val: long
    :param interface_hello_multiplier_val: Keyword argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback.intf_isis.interface_isis.interface_hello_multiplier', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface_hello_multiplier', 'keyval': 'interface_hello_multiplier_level', 'extra_keyval': 'interface_hello_multiplier_level, interface_hello_multiplier_val'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback, interface_hello_multiplier=interface_hello_multiplier, interface_hello_multiplier_val=interface_hello_multiplier_val)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback, interface_hello_multiplier=interface_hello_multiplier, interface_hello_multiplier_val=interface_hello_multiplier_val)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_isis_hello_multiplier_interface_hello_multiplier_val_delete(self, loopback=None, interface_hello_multiplier=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type interface_hello_multiplier: interface_hello_multiplier_level
    :param interface_hello_multiplier: Keyword argument tuple.

    :type interface_hello_multiplier_level: unicode
    :param interface_hello_multiplier_level: **interface_hello_multiplier** tuple argument.

        * enumeration restriction: ::

            ['level-2', 'level-1']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback.intf_isis.interface_isis.interface_hello_multiplier', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface_hello_multiplier', 'keyval': 'interface_hello_multiplier_level', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'interface-hello-multiplier-val'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback, interface_hello_multiplier=interface_hello_multiplier)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback, interface_hello_multiplier=interface_hello_multiplier)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_isis_hello_padding_delete(self, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback.intf_isis.interface_isis.interface_hello.interface_hello_padding', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_isis_hello_padding_disable_delete(self, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback.intf_isis.interface_isis.interface_hello.interface_hello_padding', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'disable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_isis_ipv6_metric_delete(self, loopback=None, interface_ipv6_metric=None, interface_ipv6_metric_val=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type interface_ipv6_metric: interface_ipv6_metric_level, interface_ipv6_metric_val
    :param interface_ipv6_metric: Keyword argument tuple.

    :type interface_ipv6_metric_level: unicode
    :param interface_ipv6_metric_level: **interface_ipv6_metric** tuple argument.

        * enumeration restriction: ::

            ['level-2', 'level-1']

    :type interface_ipv6_metric_val: long
    :param interface_ipv6_metric_val: **interface_ipv6_metric** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Argument(s)**:

    :type interface_ipv6_metric_val: long
    :param interface_ipv6_metric_val: Keyword argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback.intf_isis.interface_isis.interface_ipv6.interface_ipv6_metric', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface_ipv6_metric', 'keyval': 'interface_ipv6_metric_level', 'extra_keyval': 'interface_ipv6_metric_level, interface_ipv6_metric_val'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback, interface_ipv6_metric=interface_ipv6_metric, interface_ipv6_metric_val=interface_ipv6_metric_val)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback, interface_ipv6_metric=interface_ipv6_metric, interface_ipv6_metric_val=interface_ipv6_metric_val)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_isis_ipv6_metric_interface_ipv6_metric_val_delete(self, loopback=None, interface_ipv6_metric=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type interface_ipv6_metric: interface_ipv6_metric_level
    :param interface_ipv6_metric: Keyword argument tuple.

    :type interface_ipv6_metric_level: unicode
    :param interface_ipv6_metric_level: **interface_ipv6_metric** tuple argument.

        * enumeration restriction: ::

            ['level-2', 'level-1']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback.intf_isis.interface_isis.interface_ipv6.interface_ipv6_metric', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface_ipv6_metric', 'keyval': 'interface_ipv6_metric_level', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'interface-ipv6-metric-val'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback, interface_ipv6_metric=interface_ipv6_metric)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback, interface_ipv6_metric=interface_ipv6_metric)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_isis_ldp_sync_delete(self, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback.intf_isis.interface_isis', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ldp-sync'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_isis_metric_delete(self, loopback=None, interface_metric=None, interface_metric_val=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type interface_metric: interface_metric_level, interface_metric_val
    :param interface_metric: Keyword argument tuple.

    :type interface_metric_level: unicode
    :param interface_metric_level: **interface_metric** tuple argument.

        * enumeration restriction: ::

            ['level-2', 'level-1']

    :type interface_metric_val: long
    :param interface_metric_val: **interface_metric** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Argument(s)**:

    :type interface_metric_val: long
    :param interface_metric_val: Keyword argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback.intf_isis.interface_isis.interface_metric', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface_metric', 'keyval': 'interface_metric_level', 'extra_keyval': 'interface_metric_level, interface_metric_val'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback, interface_metric=interface_metric, interface_metric_val=interface_metric_val)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback, interface_metric=interface_metric, interface_metric_val=interface_metric_val)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_isis_metric_interface_metric_val_delete(self, loopback=None, interface_metric=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type interface_metric: interface_metric_level
    :param interface_metric: Keyword argument tuple.

    :type interface_metric_level: unicode
    :param interface_metric_level: **interface_metric** tuple argument.

        * enumeration restriction: ::

            ['level-2', 'level-1']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback.intf_isis.interface_isis.interface_metric', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface_metric', 'keyval': 'interface_metric_level', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'interface-metric-val'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback, interface_metric=interface_metric)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback, interface_metric=interface_metric)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_isis_passive_delete(self, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback.intf_isis.interface_isis', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'passive'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_isis_point_to_point_delete(self, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback.intf_isis.interface_isis', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'point-to-point'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_isis_priority_level_1_delete(self, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback.intf_isis.interface_isis.interface_priority', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'level-1'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_isis_priority_level_2_delete(self, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback.intf_isis.interface_isis.interface_priority', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'level-2'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_isis_reverse_metric_delete(self, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback.intf_isis.interface_isis.interface_reverse_metric', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_isis_reverse_metric_rev_metric_common_attributes_delete(self, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback.intf_isis.interface_isis.interface_reverse_metric.rev_metric_common_attributes', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_isis_reverse_metric_rev_metric_val_delete(self, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback.intf_isis.interface_isis.interface_reverse_metric.rev_metric_common_attributes', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rev-metric-val'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_isis_reverse_metric_te_def_metric_delete(self, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback.intf_isis.interface_isis.interface_reverse_metric.rev_metric_common_attributes', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'te-def-metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_isis_reverse_metric_whole_lan_delete(self, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.loopback.intf_isis.interface_isis.interface_reverse_metric.rev_metric_common_attributes', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'whole-lan'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_shutdown_delete(self, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.hide_intf_loopback_holder.interface.loopback', u'loopback'), ('pybind.nos.v7_0_1b.hide_intf_loopback_holder.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2c.hide_intf_loopback_holder.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2c.hide_intf_loopback_holder.interface.loopback.intf_loopback', 'pybind.nos.v6_0_2c.brocade_intf_loopback', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_intf_loopback_holder.interface.loopback.intf_loopback', 'pybind.nos.v7_0_1b.brocade_intf_loopback', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_intf_loopback_holder.interface.loopback.intf_loopback', 'pybind.nos.v7_1_0.brocade_intf_loopback', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v6_0_2c.hide_intf_loopback_holder.interface.loopback.intf_loopback": {"shutdown": "shutdown"}, "pybind.nos.v7_1_0.hide_intf_loopback_holder.interface.loopback.intf_loopback": {"shutdown": "shutdown"}, "pybind.slxos.v16r_1_00b.routing_system.interface.loopback": {}, "pybind.nos.v7_0_1b.hide_intf_loopback_holder.interface.loopback.intf_loopback": {"shutdown": "shutdown"}}
    rest_leaf_name = 'shutdown'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_loopback_vrf_forwarding_delete(self, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.hide_intf_loopback_holder.interface.loopback', u'loopback'), ('pybind.slxos.v16r_1_00b.routing_system.interface.loopback', u'loopback'), ('pybind.nos.v7_0_1b.hide_intf_loopback_holder.interface.loopback', u'loopback'), ('pybind.nos.v7_1_0.hide_intf_loopback_holder.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2c.hide_intf_loopback_holder.interface.loopback.vrf', 'pybind.nos.v6_0_2c.brocade_intf_loopback', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_intf_loopback_holder.interface.loopback.vrf', 'pybind.nos.v7_0_1b.brocade_intf_loopback', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_intf_loopback_holder.interface.loopback.vrf', 'pybind.nos.v7_1_0.brocade_intf_loopback', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.interface.loopback.vrf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'forwarding'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_management_delete(self, management=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type management: name
    :param management: Keyword argument tuple.

    :type name: unicode
    :param name: **management** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/([0-9'
            ']|[1-9][0-9])'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.interface.management', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.management', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.management', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.management', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'management', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, management=management)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, management=management)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_management_ip_access_group_mgmt_ip_access_list_delete(self, management=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type management: name
    :param management: Keyword argument tuple.

    :type name: unicode
    :param name: **management** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/([0-9'
            ']|[1-9][0-9])'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.management', u'management'), ('pybind.nos.v7_1_0.interface.management', u'management'), ('pybind.nos.v6_0_2c.interface.management', u'management'), ('pybind.nos.v7_0_1b.interface.management', u'management')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.management.ip.access_group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.management.ip.access_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.management.ip.access_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.management.ip.access_group', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mgmt-ip-access-list'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, management=management)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, management=management)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_management_ip_access_group_mgmt_ip_direction_delete(self, management=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type management: name
    :param management: Keyword argument tuple.

    :type name: unicode
    :param name: **management** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/([0-9'
            ']|[1-9][0-9])'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.management', u'management'), ('pybind.nos.v7_1_0.interface.management', u'management'), ('pybind.nos.v6_0_2c.interface.management', u'management'), ('pybind.nos.v7_0_1b.interface.management', u'management')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.management.ip.access_group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.management.ip.access_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.management.ip.access_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.management.ip.access_group', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mgmt-ip-direction'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, management=management)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, management=management)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_management_ip_address_delete(self, management=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type management: name
    :param management: Keyword argument tuple.

    :type name: unicode
    :param name: **management** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/([0-9'
            ']|[1-9][0-9])'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.management', u'management'), ('pybind.nos.v6_0_2c.interface.management', u'management'), ('pybind.nos.v7_1_0.interface.management', u'management'), ('pybind.nos.v7_0_1b.interface.management', u'management')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.management.ip.address', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.management.ip.address', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.management.ip.address', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.management.ip.address', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, management=management)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, management=management)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_management_ip_address_dhcp_delete(self, management=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type management: name
    :param management: Keyword argument tuple.

    :type name: unicode
    :param name: **management** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/([0-9'
            ']|[1-9][0-9])'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.management', u'management'), ('pybind.nos.v6_0_2c.interface.management', u'management'), ('pybind.nos.v7_1_0.interface.management', u'management'), ('pybind.nos.v7_0_1b.interface.management', u'management')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.management.ip.address', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.management.ip.address', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.management.ip.address', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.management.ip.address', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dhcp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, management=management)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, management=management)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_management_ip_address_ip_address_delete(self, management=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type management: name
    :param management: Keyword argument tuple.

    :type name: unicode
    :param name: **management** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/([0-9'
            ']|[1-9][0-9])'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.management', u'management'), ('pybind.nos.v6_0_2c.interface.management', u'management'), ('pybind.nos.v7_1_0.interface.management', u'management'), ('pybind.nos.v7_0_1b.interface.management', u'management')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.management.ip.address', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.management.ip.address', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.management.ip.address', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.management.ip.address', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ip-address'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, management=management)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, management=management)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_management_ip_address_ip_address_oper_address_delete(self, management=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type management: name
    :param management: Keyword argument tuple.

    :type name: unicode
    :param name: **management** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/([0-9'
            ']|[1-9][0-9])'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.management', u'management'), ('pybind.nos.v7_0_1b.interface.management', u'management'), ('pybind.nos.v7_1_0.interface.management', u'management'), ('pybind.nos.v6_0_2c.interface.management', u'management')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.management.ip.oper_address', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.management.ip.oper_address', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.management.ip.oper_address', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.management.ip.oper_address', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ip-address'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, management=management)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, management=management)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_management_ip_address_oper_address_delete(self, management=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type management: name
    :param management: Keyword argument tuple.

    :type name: unicode
    :param name: **management** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/([0-9'
            ']|[1-9][0-9])'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.management', u'management'), ('pybind.nos.v7_0_1b.interface.management', u'management'), ('pybind.nos.v7_1_0.interface.management', u'management'), ('pybind.nos.v6_0_2c.interface.management', u'management')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.management.ip.oper_address', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.management.ip.oper_address', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.management.ip.oper_address', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.management.ip.oper_address', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, management=management)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, management=management)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_management_ip_gateway_delete(self, management=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type management: name
    :param management: Keyword argument tuple.

    :type name: unicode
    :param name: **management** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/([0-9'
            ']|[1-9][0-9])'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.management', u'management'), ('pybind.nos.v7_1_0.interface.management', u'management'), ('pybind.nos.v7_0_1b.interface.management', u'management'), ('pybind.nos.v6_0_2c.interface.management', u'management')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.management.ip.gateway', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.management.ip.gateway', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.management.ip.gateway', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.management.ip.gateway', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, management=management)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, management=management)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_management_ip_gateway_address_delete(self, management=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type management: name
    :param management: Keyword argument tuple.

    :type name: unicode
    :param name: **management** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/([0-9'
            ']|[1-9][0-9])'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.management', u'management'), ('pybind.nos.v7_1_0.interface.management', u'management'), ('pybind.nos.v7_0_1b.interface.management', u'management'), ('pybind.nos.v6_0_2c.interface.management', u'management')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.management.ip.gateway', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.management.ip.gateway', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.management.ip.gateway', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.management.ip.gateway', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'gateway-address'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, management=management)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, management=management)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_management_ip_gateway_address_oper_gateway_con_delete(self, management=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type management: name
    :param management: Keyword argument tuple.

    :type name: unicode
    :param name: **management** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/([0-9'
            ']|[1-9][0-9])'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.management', u'management'), ('pybind.slxos.v16r_1_00b.interface.management', u'management'), ('pybind.nos.v7_1_0.interface.management', u'management'), ('pybind.nos.v6_0_2c.interface.management', u'management')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.management.ip.oper_gateway_con', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.management.ip.oper_gateway_con', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.management.ip.oper_gateway_con', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.management.ip.oper_gateway_con', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'gateway-address'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, management=management)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, management=management)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_management_ip_icmp_delete(self, management=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type management: name
    :param management: Keyword argument tuple.

    :type name: unicode
    :param name: **management** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/([0-9'
            ']|[1-9][0-9])'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.management', u'management'), ('pybind.nos.v7_0_1b.interface.management', u'management'), ('pybind.nos.v6_0_2c.interface.management', u'management'), ('pybind.slxos.v16r_1_00b.interface.management', u'management')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.management.ip.icmp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.management.ip.icmp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.management.ip.icmp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.management.ip.icmp', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, management=management)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, management=management)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_management_ip_icmp_echo_reply_delete(self, management=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type management: name
    :param management: Keyword argument tuple.

    :type name: unicode
    :param name: **management** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/([0-9'
            ']|[1-9][0-9])'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.management', u'management'), ('pybind.nos.v7_0_1b.interface.management', u'management'), ('pybind.nos.v6_0_2c.interface.management', u'management'), ('pybind.slxos.v16r_1_00b.interface.management', u'management')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.management.ip.icmp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.management.ip.icmp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.management.ip.icmp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.management.ip.icmp', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'echo-reply'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, management=management)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, management=management)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_management_ip_icmp_rate_limiting_delete(self, management=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type management: name
    :param management: Keyword argument tuple.

    :type name: unicode
    :param name: **management** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/([0-9'
            ']|[1-9][0-9])'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.management', u'management'), ('pybind.nos.v7_0_1b.interface.management', u'management'), ('pybind.nos.v6_0_2c.interface.management', u'management'), ('pybind.slxos.v16r_1_00b.interface.management', u'management')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.management.ip.icmp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.management.ip.icmp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.management.ip.icmp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.management.ip.icmp', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rate-limiting'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, management=management)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, management=management)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_management_ip_icmp_unreachable_delete(self, management=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type management: name
    :param management: Keyword argument tuple.

    :type name: unicode
    :param name: **management** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/([0-9'
            ']|[1-9][0-9])'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.management', u'management'), ('pybind.nos.v7_0_1b.interface.management', u'management'), ('pybind.nos.v6_0_2c.interface.management', u'management'), ('pybind.slxos.v16r_1_00b.interface.management', u'management')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.management.ip.icmp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.management.ip.icmp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.management.ip.icmp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.management.ip.icmp', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'unreachable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, management=management)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, management=management)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_management_ip_oper_gateway_con_delete(self, management=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type management: name
    :param management: Keyword argument tuple.

    :type name: unicode
    :param name: **management** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/([0-9'
            ']|[1-9][0-9])'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.management', u'management'), ('pybind.slxos.v16r_1_00b.interface.management', u'management'), ('pybind.nos.v7_1_0.interface.management', u'management'), ('pybind.nos.v6_0_2c.interface.management', u'management')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.management.ip.oper_gateway_con', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.management.ip.oper_gateway_con', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.management.ip.oper_gateway_con', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.management.ip.oper_gateway_con', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, management=management)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, management=management)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_management_ipv6_delete(self, management=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type management: name
    :param management: Keyword argument tuple.

    :type name: unicode
    :param name: **management** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/([0-9'
            ']|[1-9][0-9])'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.management', u'management'), ('pybind.nos.v7_0_1b.interface.management', u'management'), ('pybind.nos.v7_1_0.interface.management', u'management'), ('pybind.slxos.v16r_1_00b.interface.management', u'management')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.management.ipv6', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.management.ipv6', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.management.ipv6', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.management.ipv6', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, management=management)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, management=management)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_management_ipv6_access_group_mgmt_ip_direction_delete(self, management=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type management: name
    :param management: Keyword argument tuple.

    :type name: unicode
    :param name: **management** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/([0-9'
            ']|[1-9][0-9])'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.management', u'management'), ('pybind.nos.v7_0_1b.interface.management', u'management'), ('pybind.nos.v7_1_0.interface.management', u'management'), ('pybind.nos.v6_0_2c.interface.management', u'management')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.management.ipv6.access_group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.management.ipv6.access_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.management.ipv6.access_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.management.ipv6.access_group', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mgmt-ip-direction'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, management=management)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, management=management)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_management_ipv6_access_group_mgmt_ipv6_access_list_delete(self, management=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type management: name
    :param management: Keyword argument tuple.

    :type name: unicode
    :param name: **management** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/([0-9'
            ']|[1-9][0-9])'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.management', u'management'), ('pybind.nos.v7_0_1b.interface.management', u'management'), ('pybind.nos.v7_1_0.interface.management', u'management'), ('pybind.nos.v6_0_2c.interface.management', u'management')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.management.ipv6.access_group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.management.ipv6.access_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.management.ipv6.access_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.management.ipv6.access_group', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mgmt-ipv6-access-list'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, management=management)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, management=management)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_management_ipv6_address_delete(self, management=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type management: name
    :param management: Keyword argument tuple.

    :type name: unicode
    :param name: **management** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/([0-9'
            ']|[1-9][0-9])'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.management', u'management'), ('pybind.nos.v7_0_1b.interface.management', u'management'), ('pybind.nos.v7_1_0.interface.management', u'management'), ('pybind.slxos.v16r_1_00b.interface.management', u'management')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.management.ipv6.ipv6_address_cont', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.management.ipv6.ipv6_address_cont', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.management.ipv6.ipv6_address_cont', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.management.ipv6.ipv6_address_cont', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, management=management)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, management=management)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_management_ipv6_address_autoconfig_delete(self, management=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type management: name
    :param management: Keyword argument tuple.

    :type name: unicode
    :param name: **management** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/([0-9'
            ']|[1-9][0-9])'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.management', u'management'), ('pybind.nos.v7_0_1b.interface.management', u'management'), ('pybind.nos.v7_1_0.interface.management', u'management'), ('pybind.slxos.v16r_1_00b.interface.management', u'management')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.management.ipv6.ipv6_address_cont', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.management.ipv6.ipv6_address_cont', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.management.ipv6.ipv6_address_cont', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.management.ipv6.ipv6_address_cont', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'autoconfig'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, management=management)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, management=management)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_management_ipv6_address_dhcp_delete(self, management=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type management: name
    :param management: Keyword argument tuple.

    :type name: unicode
    :param name: **management** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/([0-9'
            ']|[1-9][0-9])'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.management', u'management'), ('pybind.nos.v7_0_1b.interface.management', u'management'), ('pybind.nos.v7_1_0.interface.management', u'management'), ('pybind.slxos.v16r_1_00b.interface.management', u'management')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.management.ipv6.ipv6_address_cont', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.management.ipv6.ipv6_address_cont', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.management.ipv6.ipv6_address_cont', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.management.ipv6.ipv6_address_cont', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dhcp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, management=management)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, management=management)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_management_ipv6_address_eui_64_delete(self, management=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type management: name
    :param management: Keyword argument tuple.

    :type name: unicode
    :param name: **management** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/([0-9'
            ']|[1-9][0-9])'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.management', u'management'), ('pybind.nos.v6_0_2c.interface.management', u'management'), ('pybind.slxos.v16r_1_00b.interface.management', u'management'), ('pybind.nos.v7_0_1b.interface.management', u'management')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.management.ipv6.ipv6_address_cont.ipv6_global_cont', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.management.ipv6.ipv6_address_cont.ipv6_global_cont', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.management.ipv6.ipv6_address_cont.ipv6_global_cont', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.management.ipv6.ipv6_address_cont.ipv6_global_cont', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'eui-64'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, management=management)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, management=management)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_management_ipv6_address_ipv6_global_address_delete(self, management=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type management: name
    :param management: Keyword argument tuple.

    :type name: unicode
    :param name: **management** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/([0-9'
            ']|[1-9][0-9])'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.management', u'management'), ('pybind.nos.v6_0_2c.interface.management', u'management'), ('pybind.slxos.v16r_1_00b.interface.management', u'management'), ('pybind.nos.v7_0_1b.interface.management', u'management')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.management.ipv6.ipv6_address_cont.ipv6_global_cont', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.management.ipv6.ipv6_address_cont.ipv6_global_cont', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.management.ipv6.ipv6_address_cont.ipv6_global_cont', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.management.ipv6.ipv6_address_cont.ipv6_global_cont', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ipv6-global-address'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, management=management)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, management=management)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_management_ipv6_address_ipv6_global_cont_delete(self, management=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type management: name
    :param management: Keyword argument tuple.

    :type name: unicode
    :param name: **management** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/([0-9'
            ']|[1-9][0-9])'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.management', u'management'), ('pybind.nos.v6_0_2c.interface.management', u'management'), ('pybind.slxos.v16r_1_00b.interface.management', u'management'), ('pybind.nos.v7_0_1b.interface.management', u'management')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.management.ipv6.ipv6_address_cont.ipv6_global_cont', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.management.ipv6.ipv6_address_cont.ipv6_global_cont', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.management.ipv6.ipv6_address_cont.ipv6_global_cont', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.management.ipv6.ipv6_address_cont.ipv6_global_cont', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'ipv6_global_address, ipv6_global_address_eui64'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, management=management)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, management=management)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_management_ipv6_icmpv6_delete(self, management=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type management: name
    :param management: Keyword argument tuple.

    :type name: unicode
    :param name: **management** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/([0-9'
            ']|[1-9][0-9])'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.management', u'management'), ('pybind.nos.v7_0_1b.interface.management', u'management'), ('pybind.slxos.v16r_1_00b.interface.management', u'management'), ('pybind.nos.v7_1_0.interface.management', u'management')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.management.ipv6.icmpv6', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.management.ipv6.icmpv6', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.management.ipv6.icmpv6', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.management.ipv6.icmpv6', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, management=management)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, management=management)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_management_ipv6_icmpv6_echo_reply_delete(self, management=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type management: name
    :param management: Keyword argument tuple.

    :type name: unicode
    :param name: **management** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/([0-9'
            ']|[1-9][0-9])'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.management', u'management'), ('pybind.nos.v7_0_1b.interface.management', u'management'), ('pybind.slxos.v16r_1_00b.interface.management', u'management'), ('pybind.nos.v7_1_0.interface.management', u'management')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.management.ipv6.icmpv6', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.management.ipv6.icmpv6', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.management.ipv6.icmpv6', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.management.ipv6.icmpv6', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'echo-reply'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, management=management)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, management=management)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_management_ipv6_icmpv6_rate_limiting_delete(self, management=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type management: name
    :param management: Keyword argument tuple.

    :type name: unicode
    :param name: **management** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/([0-9'
            ']|[1-9][0-9])'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.management', u'management'), ('pybind.nos.v7_0_1b.interface.management', u'management'), ('pybind.slxos.v16r_1_00b.interface.management', u'management'), ('pybind.nos.v7_1_0.interface.management', u'management')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.management.ipv6.icmpv6', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.management.ipv6.icmpv6', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.management.ipv6.icmpv6', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.management.ipv6.icmpv6', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rate-limiting'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, management=management)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, management=management)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_management_ipv6_icmpv6_unreachable_delete(self, management=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type management: name
    :param management: Keyword argument tuple.

    :type name: unicode
    :param name: **management** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/([0-9'
            ']|[1-9][0-9])'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.management', u'management'), ('pybind.nos.v7_0_1b.interface.management', u'management'), ('pybind.slxos.v16r_1_00b.interface.management', u'management'), ('pybind.nos.v7_1_0.interface.management', u'management')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.management.ipv6.icmpv6', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.management.ipv6.icmpv6', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.management.ipv6.icmpv6', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.management.ipv6.icmpv6', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'unreachable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, management=management)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, management=management)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_management_line_speed_delete(self, management=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type management: name
    :param management: Keyword argument tuple.

    :type name: unicode
    :param name: **management** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/([0-9'
            ']|[1-9][0-9])'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.management', u'management'), ('pybind.slxos.v16r_1_00b.interface.management', u'management'), ('pybind.nos.v7_1_0.interface.management', u'management'), ('pybind.nos.v7_0_1b.interface.management', u'management')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.management.line_speed', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.management.line_speed', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.management.line_speed', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.management.line_speed', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, management=management)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, management=management)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_management_line_speed_actual_delete(self, management=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type management: name
    :param management: Keyword argument tuple.

    :type name: unicode
    :param name: **management** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/([0-9'
            ']|[1-9][0-9])'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.management', u'management'), ('pybind.slxos.v16r_1_00b.interface.management', u'management'), ('pybind.nos.v7_1_0.interface.management', u'management'), ('pybind.nos.v7_0_1b.interface.management', u'management')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.management.line_speed', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.management.line_speed', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.management.line_speed', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.management.line_speed', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'actual'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, management=management)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, management=management)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_management_line_speed_configured_delete(self, management=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type management: name
    :param management: Keyword argument tuple.

    :type name: unicode
    :param name: **management** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/([0-9'
            ']|[1-9][0-9])'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.management', u'management'), ('pybind.slxos.v16r_1_00b.interface.management', u'management'), ('pybind.nos.v7_1_0.interface.management', u'management'), ('pybind.nos.v7_0_1b.interface.management', u'management')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.management.line_speed', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.management.line_speed', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.management.line_speed', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.management.line_speed', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'configured'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, management=management)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, management=management)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_management_oper_status_delete(self, management=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type management: name
    :param management: Keyword argument tuple.

    :type name: unicode
    :param name: **management** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/([0-9'
            ']|[1-9][0-9])'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.interface.management', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.management', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.management', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.management', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'management', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'oper-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, management=management)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, management=management)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_management_shutdown_delete(self, management=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type management: name
    :param management: Keyword argument tuple.

    :type name: unicode
    :param name: **management** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/([0-9'
            ']|[1-9][0-9])'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.interface.management', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.management', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.management', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.management', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'management', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'shutdown'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, management=management)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, management=management)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_management_speed_delete(self, management=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type management: name
    :param management: Keyword argument tuple.

    :type name: unicode
    :param name: **management** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/([0-9'
            ']|[1-9][0-9])'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.interface.management', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.management', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.management', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.management', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'management', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'speed'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, management=management)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, management=management)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_management_tcp_burstrate_delete(self, management=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type management: name
    :param management: Keyword argument tuple.

    :type name: unicode
    :param name: **management** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/([0-9'
            ']|[1-9][0-9])'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.management', u'management'), ('pybind.nos.v7_0_1b.interface.management', u'management'), ('pybind.slxos.v16r_1_00b.interface.management', u'management'), ('pybind.nos.v6_0_2c.interface.management', u'management')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.management.tcp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.management.tcp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.management.tcp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.management.tcp', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'burstrate'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, management=management)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, management=management)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_management_tcp_lockup_delete(self, management=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type management: name
    :param management: Keyword argument tuple.

    :type name: unicode
    :param name: **management** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/([0-9'
            ']|[1-9][0-9])'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.management', u'management'), ('pybind.nos.v7_0_1b.interface.management', u'management'), ('pybind.slxos.v16r_1_00b.interface.management', u'management'), ('pybind.nos.v6_0_2c.interface.management', u'management')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.management.tcp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.management.tcp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.management.tcp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.management.tcp', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lockup'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, management=management)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, management=management)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_management_vrf_forwarding_delete(self, management=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type management: name
    :param management: Keyword argument tuple.

    :type name: unicode
    :param name: **management** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/([0-9'
            ']|[1-9][0-9])'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.management', u'management'), ('pybind.nos.v7_1_0.interface.management', u'management'), ('pybind.nos.v7_0_1b.interface.management', u'management'), ('pybind.nos.v6_0_2c.interface.management', u'management')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.management.vrf', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.management.vrf', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.management.vrf', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.management.vrf', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'forwarding'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, management=management)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, management=management)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'port_channel', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v6_0_2c.interface.port_channel": {"cee": "cee", "minimum_links": "minimum_links", "name": "name", "priority_tag_enable": "priority_tag_enable", "mtu": "mtu", "shutdown": "shutdown", "ifindex": "ifindex", "load_balance": "load_balance", "po_speed": "po_speed", "port_profile_port": "port_profile_port", "description": "description"}, "pybind.slxos.v16r_1_00b.interface.port_channel": {"priority_tag_enable": "priority_tag_enable", "minimum_links": "minimum_links", "name": "name", "mtu": "mtu", "shutdown": "shutdown", "ifindex": "ifindex", "load_balance": "load_balance", "po_speed": "po_speed", "port_profile_port": "port_profile_port", "description": "description"}, "pybind.nos.v7_0_1b.interface.port_channel": {"cee": "cee", "minimum_links": "minimum_links", "name": "name", "priority_tag_enable": "priority_tag_enable", "mtu": "mtu", "shutdown": "shutdown", "ifindex": "ifindex", "load_balance": "load_balance", "po_speed": "po_speed", "port_profile_port": "port_profile_port", "description": "description"}, "pybind.nos.v7_1_0.interface.port_channel": {"cee": "cee", "minimum_links": "minimum_links", "name": "name", "priority_tag_enable": "priority_tag_enable", "mtu": "mtu", "shutdown": "shutdown", "ifindex": "ifindex", "load_balance": "load_balance", "po_speed": "po_speed", "port_profile_port": "port_profile_port", "description": "description"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_bfd_interval_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_1_0.interface.port_channel.bfd.interval', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_bfd_interval_min_rx_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_1_0.interface.port_channel.bfd.interval', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'min-rx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_bfd_interval_min_tx_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_1_0.interface.port_channel.bfd.interval', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'min-tx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_bfd_interval_multiplier_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_1_0.interface.port_channel.bfd.interval', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'multiplier'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_bfd_shutdown_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_1_0.interface.port_channel.bfd', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'shutdown'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_bpdu_drop_direction_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.bpdu_drop', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.bpdu_drop', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.bpdu_drop', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'direction'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_bpdu_drop_enable_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.bpdu_drop', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.bpdu_drop', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.bpdu_drop', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_cee_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Instance Keyword Argument Tuple**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'port_channel', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cee'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_description_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'port_channel', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'description'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_edge_loop_detection_port_priority_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.edge_loop_detection', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.edge_loop_detection', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.edge_loop_detection', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.edge_loop_detection', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'port-priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_edge_loop_detection_vlan_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.edge_loop_detection', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.edge_loop_detection', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.edge_loop_detection', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.edge_loop_detection', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vlan'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_esi_auto_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.esi', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.esi', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'auto'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_esi_value_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.esi', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.esi', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'value'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_fcoeport_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.fcoeport', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.fcoeport', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.fcoeport', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.fcoeport', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'fcoeport_map, ns_ip_registration'}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v7_0_1b.interface.port_channel.fcoeport": {"fcoeport_map": "fcoeport_map", "ns_ip_registration": "ns_ip_registration"}, "pybind.nos.v7_1_0.interface.port_channel.fcoeport": {"fcoeport_map": "fcoeport_map", "ns_ip_registration": "ns_ip_registration"}, "pybind.nos.v6_0_2c.interface.port_channel.fcoeport": {"fcoeport_map": "fcoeport_map", "ns_ip_registration": "ns_ip_registration"}, "pybind.slxos.v16r_1_00b.interface.port_channel.fcoeport": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_fcoeport_map_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.fcoeport', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.fcoeport', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.fcoeport', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.fcoeport', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_fcoeport_ns_ip_registration_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.fcoeport', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.fcoeport', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.fcoeport', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ns-ip-registration'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ifindex_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'port_channel', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ifindex'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ip_access_group_delete(self, port_channel=None, access_group=None, traffic_type=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type access_group: ip_access_list, ip_direction, traffic_type
    :param access_group: Keyword argument tuple.

    :type ip_access_list: unicode
    :param ip_access_list: **access_group** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type ip_direction: unicode
    :param ip_direction: **access_group** tuple argument.

        * enumeration restriction: ::

            ['in', 'out']

    :type traffic_type: unicode
    :param traffic_type: **access_group** tuple argument.

        * enumeration restriction: ::

            ['switched', 'routed']

    **Instance Argument(s)**:

    :type traffic_type: unicode
    :param traffic_type: Keyword argument.

        * enumeration restriction: ::

            ['switched', 'routed']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.ip_acl_interface.ip.access_group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.ip_acl_interface.ip.access_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ip_acl_interface.ip.access_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.ip_acl_interface.ip.access_group', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'access_group', 'keyval': 'ip_access_list, ip_direction', 'extra_keyval': 'ip_access_list, ip_direction, traffic_type'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, access_group=access_group, traffic_type=traffic_type)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, access_group=access_group, traffic_type=traffic_type)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ip_acl_interface_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.ip_acl_interface', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.slxos.v16r_1_00b.interface.port_channel.ip_acl_interface', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ip_address_delete(self, port_channel=None, address=None, secondary=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type address: address, secondary
    :param address: Keyword argument tuple.

    :type address: unicode
    :param address: **address** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]'
            '|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0'
            '-4][0-9]|25[0-5])/(([1-9])|([1-2][0-9])|(3[0-1])'
            ')'

    :type secondary: YANGBool
    :param secondary: **address** tuple argument:  Secondary ip address on the specific interface

    **Instance Argument(s)**:

    :type secondary: YANGBool
    :param secondary: Secondary ip address on the specific interface

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.ip.hide_ip_holder.ip_config.address', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.ip.ip_config.address', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ip.ip_config.address', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.ip.hide_ip_holder.ip_config.address', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'address', 'keyval': 'address', 'extra_keyval': 'address, secondary, ospf_passive, ospf_ignore'}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v16r_1_00b.interface.port_channel.ip.hide_ip_holder.ip_config.address": {"secondary": "secondary", "address": "address"}, "pybind.nos.v7_0_1b.interface.port_channel.ip.ip_config.address": {}, "pybind.nos.v6_0_2c.interface.port_channel.ip.hide_ip_holder.ip_config.address": {"secondary": "secondary", "address": "address"}, "pybind.nos.v7_1_0.interface.port_channel.ip.ip_config.address": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, address=address, secondary=secondary)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, address=address, secondary=secondary)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ip_address_ospf_ignore_delete(self, port_channel=None, address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type address: address
    :param address: Keyword argument tuple.

    :type address: unicode
    :param address: **address** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]'
            '|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0'
            '-4][0-9]|25[0-5])/(([1-9])|([1-2][0-9])|(3[0-1])'
            ')'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ip.ip_config.address', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ip.ip_config.address', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'address', 'keyval': 'address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ospf-ignore'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, address=address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, address=address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ip_address_ospf_passive_delete(self, port_channel=None, address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type address: address
    :param address: Keyword argument tuple.

    :type address: unicode
    :param address: **address** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]'
            '|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0'
            '-4][0-9]|25[0-5])/(([1-9])|([1-2][0-9])|(3[0-1])'
            ')'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ip.ip_config.address', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ip.ip_config.address', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'address', 'keyval': 'address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ospf-passive'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, address=address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, address=address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ip_address_secondary_delete(self, port_channel=None, address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type address: address
    :param address: Keyword argument tuple.

    :type address: unicode
    :param address: **address** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]'
            '|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0'
            '-4][0-9]|25[0-5])/(([1-9])|([1-2][0-9])|(3[0-1])'
            ')'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.ip.hide_ip_holder.ip_config.address', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.ip.ip_config.address', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ip.ip_config.address', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.ip.hide_ip_holder.ip_config.address', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'address', 'keyval': 'address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'secondary'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, address=address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, address=address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ip_arp_aging_timeout_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.ip.hide_ip_holder.ip_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.ip.ip_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ip.ip_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.ip.hide_ip_holder.ip_config', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'arp-aging-timeout'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ip_arp_inspection_trust_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.ip.arp.inspection', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.ip.arp.inspection', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ip.arp.inspection', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.ip.arp.inspection', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'trust'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ip_arp_ip_config_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ip.ip_config.arp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ip.ip_config.arp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ip_arp_learn_any_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ip.ip_config.arp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ip.ip_config.arp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'learn-any'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ip_dhcp_relay_gateway_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ip.interface_po_dhcp_conf.dhcp.relay', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ip.interface_po_dhcp_conf.dhcp.relay', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'gateway'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ip_dhcp_relay_servers_delete(self, port_channel=None, servers=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type servers: relay_ip_addr, server_vrf_name
    :param servers: Keyword argument tuple.

    :type relay_ip_addr: unicode
    :param relay_ip_addr: **servers** tuple argument:  A.B.C.D;; IP address of the DHCP server

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type server_vrf_name: unicode
    :param server_vrf_name: **servers** tuple argument:  VRF name of the DHCP server

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ip.interface_po_dhcp_conf.dhcp.relay.servers', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ip.interface_po_dhcp_conf.dhcp.relay.servers', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'servers', 'keyval': 'relay_ip_addr, server_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, servers=servers)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, servers=servers)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ip_directed_broadcast_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.ip.hide_ip_holder.ip_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.ip.ip_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ip.ip_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.ip.hide_ip_holder.ip_config', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'directed-broadcast'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ip_hide_ip_holder_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.ip.hide_ip_holder', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.slxos.v16r_1_00b.interface.port_channel.ip.hide_ip_holder', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ip_icmp_address_mask_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ip.icmp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ip.icmp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'address-mask'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ip_icmp_echo_reply_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ip.icmp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ip.icmp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'echo-reply'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ip_icmp_rate_limiting_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ip.icmp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ip.icmp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rate-limiting'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ip_icmp_redirect_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ip.icmp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ip.icmp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redirect'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ip_icmp_unreachable_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ip.icmp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ip.icmp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'unreachable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ip_igmp_immediate_leave_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ip.igmp_po_intf_cfg.igmp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ip.igmp_po_intf_cfg.igmp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'immediate-leave'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ip_igmp_last_member_query_count_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ip.igmp_po_intf_cfg.igmp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ip.igmp_po_intf_cfg.igmp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'last-member-query-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ip_igmp_last_member_query_interval_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ip.igmp_po_intf_cfg.igmp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ip.igmp_po_intf_cfg.igmp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'last-member-query-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ip_igmp_po_intf_cfg_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ip.igmp_po_intf_cfg', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ip.igmp_po_intf_cfg', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ip_igmp_query_interval_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ip.igmp_po_intf_cfg.igmp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ip.igmp_po_intf_cfg.igmp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'query-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ip_igmp_query_max_response_time_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ip.igmp_po_intf_cfg.igmp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ip.igmp_po_intf_cfg.igmp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'query-max-response-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ip_igmp_robustness_variable_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ip.igmp_po_intf_cfg.igmp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ip.igmp_po_intf_cfg.igmp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'robustness-variable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ip_igmp_startup_query_count_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ip.igmp_po_intf_cfg.igmp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ip.igmp_po_intf_cfg.igmp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'startup-query-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ip_igmp_startup_query_interval_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ip.igmp_po_intf_cfg.igmp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ip.igmp_po_intf_cfg.igmp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'startup-query-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ip_igmp_static_group_delete(self, port_channel=None, static_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type static_group: sg_addr
    :param static_group: Keyword argument tuple.

    :type sg_addr: unicode
    :param sg_addr: **static_group** tuple argument:  Multicast Address to be Joined in the format A.B.C.D

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ip.igmp_po_intf_cfg.igmp.static_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ip.igmp_po_intf_cfg.igmp.static_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'static_group', 'keyval': 'sg_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, static_group=static_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, static_group=static_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ip_interface_PO_ospf_conf_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ip.interface_PO_ospf_conf', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ip.interface_PO_ospf_conf', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ip_interface_po_dhcp_conf_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ip.interface_po_dhcp_conf', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ip.interface_po_dhcp_conf', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ip_ip_config_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.ip.hide_ip_holder.ip_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.ip.ip_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ip.ip_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.ip.hide_ip_holder.ip_config', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ip_mtu_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.ip.hide_ip_holder.ip_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.ip.ip_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ip.ip_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.ip.hide_ip_holder.ip_config', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mtu'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ip_multicast_boundary_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ip.pim_intf_po_cont.pim_int_cmd', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ip.pim_intf_po_cont.pim_int_cmd', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'multicast-boundary'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ip_ospf_active_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'active'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ip_ospf_area_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'area'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ip_ospf_auth_change_wait_time_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'auth-change-wait-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ip_ospf_authentication_key_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config.authentication_key', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config.authentication_key', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ip_ospf_authentication_key_auth_key_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config.authentication_key.auth_key_table', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config.authentication_key.auth_key_table', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'auth-key'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ip_ospf_authentication_key_auth_key_table_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config.authentication_key.auth_key_table', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config.authentication_key.auth_key_table', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'encrypttype, auth_key'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ip_ospf_authentication_key_encrypttype_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config.authentication_key.auth_key_table', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config.authentication_key.auth_key_table', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'encrypttype'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ip_ospf_authentication_key_no_encrypt_auth_key_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config.authentication_key.no_encrypt_auth_key_table', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config.authentication_key.no_encrypt_auth_key_table', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'no-encrypt-auth-key'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ip_ospf_authentication_key_no_encrypt_auth_key_table_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config.authentication_key.no_encrypt_auth_key_table', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config.authentication_key.no_encrypt_auth_key_table', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ip_ospf_bfd_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config.bfd', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config.bfd', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ip_ospf_bfd_intf_bfd_enable_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config.bfd', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config.bfd', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'intf-bfd-enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ip_ospf_cost_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cost'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ip_ospf_database_filter_all_external_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'all-external'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ip_ospf_database_filter_all_out_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'all-out'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ip_ospf_database_filter_all_summary_external_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'all-summary-external'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ip_ospf_dead_interval_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dead-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ip_ospf_hello_interval_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hello-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ip_ospf_md5_authentication_key_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config.md5_authentication.no_encrypt_key_table', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config.md5_authentication.no_encrypt_key_table', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'key'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ip_ospf_md5_authentication_key_activation_wait_time_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config.md5_authentication', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config.md5_authentication', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'key-activation-wait-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ip_ospf_md5_authentication_key_id_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config.md5_authentication.no_encrypt_key_table', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config.md5_authentication.no_encrypt_key_table', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'key-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ip_ospf_md5_authentication_key_id_key_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config.md5_authentication.key_table', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config.md5_authentication.key_table', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'key'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ip_ospf_md5_authentication_key_id_key_id_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config.md5_authentication.key_table', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config.md5_authentication.key_table', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'key-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ip_ospf_md5_authentication_key_id_md5_authentication_key_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config.md5_authentication.key_table', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config.md5_authentication.key_table', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'md5-authentication-key'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ip_ospf_mtu_ignore_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mtu-ignore'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ip_ospf_network_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'network'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ip_ospf_passive_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'passive'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ip_ospf_priority_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ip_ospf_retransmit_interval_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'retransmit-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ip_ospf_transmit_delay_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'transmit-delay'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ip_pbr_interface_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ip_pbr_interface', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ip_pbr_interface', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ip_pim_dr_priority_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ip.pim_intf_po_cont.pim_int_cmd.pim', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ip.pim_intf_po_cont.pim_int_cmd.pim', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dr-priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ip_pim_int_cmd_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ip.pim_intf_po_cont.pim_int_cmd', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ip.pim_intf_po_cont.pim_int_cmd', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ip_pim_intf_po_cont_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ip.pim_intf_po_cont', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ip.pim_intf_po_cont', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ip_pim_multinet_enable_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_1_0.interface.port_channel.ip.pim_intf_po_cont.pim_int_cmd.pim.multinet', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ip_pim_neighbor_filter_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ip.pim_intf_po_cont.pim_int_cmd.pim', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ip.pim_intf_po_cont.pim_int_cmd.pim', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'neighbor-filter'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ip_pim_sparse_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ip.pim_intf_po_cont.pim_int_cmd', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ip.pim_intf_po_cont.pim_int_cmd', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'pim-sparse'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ip_policy_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ip_pbr_interface.ip.policy', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ip_pbr_interface.ip.policy', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ip_policy_route_map_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ip_pbr_interface.ip.policy.route_map', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ip_pbr_interface.ip.policy.route_map', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ip_policy_route_map_route_map_name_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ip_pbr_interface.ip.policy.route_map', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ip_pbr_interface.ip.policy.route_map', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ip_proxy_arp_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.ip.hide_ip_holder.ip_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.ip.ip_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ip.ip_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.ip.hide_ip_holder.ip_config', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'proxy-arp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ip_unnumbered_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ip.ip_config.unnumbered', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ip.ip_config.unnumbered', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'ip_donor_interface_type, ip_donor_interface_name'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ip_unnumbered_ip_donor_interface_name_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ip.ip_config.unnumbered', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ip.ip_config.unnumbered', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ip-donor-interface-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ip_unnumbered_ip_donor_interface_type_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ip.ip_config.unnumbered', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ip.ip_config.unnumbered', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ip-donor-interface-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_access_group_delete(self, port_channel=None, access_group=None, traffic_type=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type access_group: ipv6_access_list, ip_direction, traffic_type
    :param access_group: Keyword argument tuple.

    :type ipv6_access_list: unicode
    :param ipv6_access_list: **access_group** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type ip_direction: unicode
    :param ip_direction: **access_group** tuple argument.

        * enumeration restriction: ::

            ['in', 'out']

    :type traffic_type: unicode
    :param traffic_type: **access_group** tuple argument.

        * enumeration restriction: ::

            ['switched', 'routed']

    **Instance Argument(s)**:

    :type traffic_type: unicode
    :param traffic_type: Keyword argument.

        * enumeration restriction: ::

            ['switched', 'routed']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.ipv6.access_group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.ipv6.access_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.access_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.ipv6.access_group', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'access_group', 'keyval': 'ipv6_access_list, ip_direction', 'extra_keyval': 'ipv6_access_list, ip_direction, traffic_type'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, access_group=access_group, traffic_type=traffic_type)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, access_group=access_group, traffic_type=traffic_type)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_access_group_traffic_type_delete(self, port_channel=None, access_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type access_group: ipv6_access_list, ip_direction
    :param access_group: Keyword argument tuple.

    :type ipv6_access_list: unicode
    :param ipv6_access_list: **access_group** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type ip_direction: unicode
    :param ip_direction: **access_group** tuple argument.

        * enumeration restriction: ::

            ['in', 'out']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.ipv6.access_group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.ipv6.access_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.access_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.ipv6.access_group', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'access_group', 'keyval': 'ipv6_access_list, ip_direction', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'traffic-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, access_group=access_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, access_group=access_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_address_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ipv6.ipv6_config.address', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.ipv6_config.address', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_address_ipv6_address_delete(self, port_channel=None, ipv6_address=None, secondary=None, anycast=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ipv6_address: address, secondary, anycast
    :param ipv6_address: Keyword argument tuple.

    :type address: unicode
    :param address: **ipv6_address** tuple argument:  A:B::C:D/LEN;; IPv6 prefix format: xxxx:xxxx/ml, xxxx:xxxx::/ml, xxxx::xx/128

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type secondary: YANGBool
    :param secondary: **ipv6_address** tuple argument:  Configure Secondary ipv6 address on an interface

    :type anycast: YANGBool
    :param anycast: **ipv6_address** tuple argument:  Configure ipv6 address as anycast

    **Instance Argument(s)**:

    :type secondary: YANGBool
    :param secondary: Configure Secondary ipv6 address on an interface

    :type anycast: YANGBool
    :param anycast: Configure ipv6 address as anycast

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_address', 'keyval': 'address', 'extra_keyval': 'address, secondary, anycast'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, ipv6_address=ipv6_address, secondary=secondary, anycast=anycast)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, ipv6_address=ipv6_address, secondary=secondary, anycast=anycast)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_address_ipv6_address_anycast_delete(self, port_channel=None, ipv6_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ipv6_address: address
    :param ipv6_address: Keyword argument tuple.

    :type address: unicode
    :param address: **ipv6_address** tuple argument:  A:B::C:D/LEN;; IPv6 prefix format: xxxx:xxxx/ml, xxxx:xxxx::/ml, xxxx::xx/128

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_address', 'keyval': 'address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'anycast'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, ipv6_address=ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, ipv6_address=ipv6_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_address_ipv6_address_eui_64_delete(self, port_channel=None, ipv6_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv6_address: address, secondary, anycast
    :param ipv6_address: Keyword argument tuple.

    :type address: unicode
    :param address: **ipv6_address** tuple argument:  A:B::C:D/LEN;; IPv6 prefix format: xxxx:xxxx/ml, xxxx:xxxx::/ml, xxxx::xx/128

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type secondary: YANGBool
    :param secondary: **ipv6_address** tuple argument:  Configure Secondary ipv6 address on an interface

    :type anycast: YANGBool
    :param anycast: **ipv6_address** tuple argument:  Configure ipv6 address as anycast

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel.ipv6.ipv6_config.address.ipv6_address', u'ipv6_address'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.ipv6_config.address.ipv6_address', u'ipv6_address')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ipv6.ipv6_config.address.ipv6_address.eui_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.ipv6_config.address.ipv6_address.eui_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'address', 'extra_keyval': 'address, secondary, anycast'}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'address', 'extra_keyval': 'address, secondary, anycast'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'eui-64'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, ipv6_address=ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, ipv6_address=ipv6_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_address_ipv6_address_secondary_delete(self, port_channel=None, ipv6_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ipv6_address: address
    :param ipv6_address: Keyword argument tuple.

    :type address: unicode
    :param address: **ipv6_address** tuple argument:  A:B::C:D/LEN;; IPv6 prefix format: xxxx:xxxx/ml, xxxx:xxxx::/ml, xxxx::xx/128

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_address', 'keyval': 'address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'secondary'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, ipv6_address=ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, ipv6_address=ipv6_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_address_ipv6_address_secondary_eui_config_delete(self, port_channel=None, ipv6_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv6_address: address, secondary, anycast
    :param ipv6_address: Keyword argument tuple.

    :type address: unicode
    :param address: **ipv6_address** tuple argument:  A:B::C:D/LEN;; IPv6 prefix format: xxxx:xxxx/ml, xxxx:xxxx::/ml, xxxx::xx/128

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type secondary: YANGBool
    :param secondary: **ipv6_address** tuple argument:  Configure Secondary ipv6 address on an interface

    :type anycast: YANGBool
    :param anycast: **ipv6_address** tuple argument:  Configure ipv6 address as anycast

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel.ipv6.ipv6_config.address.ipv6_address', u'ipv6_address'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.ipv6_config.address.ipv6_address', u'ipv6_address')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ipv6.ipv6_config.address.ipv6_address.eui_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.ipv6_config.address.ipv6_address.eui_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'address', 'extra_keyval': 'address, secondary, anycast'}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'address', 'extra_keyval': 'address, secondary, anycast'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'secondary'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, ipv6_address=ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, ipv6_address=ipv6_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_address_link_local_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'link-local'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_address_link_local_address_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'link-local-address'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_address_link_local_config_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'link_local_address, link_local'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_address_use_link_local_only_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ipv6.ipv6_config.address', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.ipv6_config.address', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'use-link-local-only'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_dhcp_relay_servers_delete(self, port_channel=None, servers=None, server_vrf_name=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type servers: relay_ip_addr, server_vrf_name
    :param servers: Keyword argument tuple.

    :type relay_ip_addr: unicode
    :param relay_ip_addr: **servers** tuple argument:  IPv6 address of the DHCPv6 server

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type server_vrf_name: unicode
    :param server_vrf_name: **servers** tuple argument:  VRF name of the DHCPv6 server

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Argument(s)**:

    :type server_vrf_name: unicode
    :param server_vrf_name: VRF name of the DHCPv6 server

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ipv6.interface_po_dhcp_conf.dhcp.relay.servers', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.interface_po_dhcp_conf.dhcp.relay.servers', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'servers', 'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, servers=servers, server_vrf_name=server_vrf_name)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, servers=servers, server_vrf_name=server_vrf_name)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_dhcp_relay_servers_interface_delete(self, port_channel=None, servers=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type servers: relay_ip_addr, server_vrf_name
    :param servers: Keyword argument tuple.

    :type relay_ip_addr: unicode
    :param relay_ip_addr: **servers** tuple argument:  IPv6 address of the DHCPv6 server

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type server_vrf_name: unicode
    :param server_vrf_name: **servers** tuple argument:  VRF name of the DHCPv6 server

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.interface_po_dhcp_conf.dhcp.relay.servers', u'servers'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel.ipv6.interface_po_dhcp_conf.dhcp.relay.servers', u'servers')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ipv6.interface_po_dhcp_conf.dhcp.relay.servers.interface', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.interface_po_dhcp_conf.dhcp.relay.servers.interface', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'interface_type, interface_name'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, servers=servers)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, servers=servers)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_dhcp_relay_servers_interface_interface_delete(self, port_channel=None, servers=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type servers: relay_ip_addr, server_vrf_name
    :param servers: Keyword argument tuple.

    :type relay_ip_addr: unicode
    :param relay_ip_addr: **servers** tuple argument:  IPv6 address of the DHCPv6 server

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type server_vrf_name: unicode
    :param server_vrf_name: **servers** tuple argument:  VRF name of the DHCPv6 server

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.interface_po_dhcp_conf.dhcp.relay.servers', u'servers'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel.ipv6.interface_po_dhcp_conf.dhcp.relay.servers', u'servers')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ipv6.interface_po_dhcp_conf.dhcp.relay.servers.interface', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.interface_po_dhcp_conf.dhcp.relay.servers.interface', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'interface'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, servers=servers)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, servers=servers)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_dhcp_relay_servers_interface_interface_name_delete(self, port_channel=None, servers=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type servers: relay_ip_addr, server_vrf_name
    :param servers: Keyword argument tuple.

    :type relay_ip_addr: unicode
    :param relay_ip_addr: **servers** tuple argument:  IPv6 address of the DHCPv6 server

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type server_vrf_name: unicode
    :param server_vrf_name: **servers** tuple argument:  VRF name of the DHCPv6 server

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.interface_po_dhcp_conf.dhcp.relay.servers', u'servers'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel.ipv6.interface_po_dhcp_conf.dhcp.relay.servers', u'servers')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ipv6.interface_po_dhcp_conf.dhcp.relay.servers.interface', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.interface_po_dhcp_conf.dhcp.relay.servers.interface', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'interface-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, servers=servers)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, servers=servers)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_dhcp_relay_servers_use_vrf_delete(self, port_channel=None, servers=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type servers: relay_ip_addr
    :param servers: Keyword argument tuple.

    :type relay_ip_addr: unicode
    :param relay_ip_addr: **servers** tuple argument:  IPv6 address of the DHCPv6 server

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ipv6.interface_po_dhcp_conf.dhcp.relay.servers', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.interface_po_dhcp_conf.dhcp.relay.servers', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'servers', 'keyval': 'relay_ip_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'use-vrf'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, servers=servers)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, servers=servers)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_hide_vrrpv3_holder_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.ipv6.hide_vrrpv3_holder', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.ipv6.hide_vrrpv3_holder', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.hide_vrrpv3_holder', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.ipv6.hide_vrrpv3_holder', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_icmpv6_echo_reply_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ipv6.icmpv6', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.icmpv6', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'echo-reply'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_icmpv6_rate_limiting_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ipv6.icmpv6', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.icmpv6', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rate-limiting'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_icmpv6_redirect_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ipv6.icmpv6', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.icmpv6', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redirect'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_icmpv6_unreachable_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ipv6.icmpv6', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.icmpv6', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'unreachable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_interface_po_dhcp_conf_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ipv6.interface_po_dhcp_conf', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.interface_po_dhcp_conf', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_ipv6_config_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ipv6.ipv6_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.ipv6_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_ipv6_intf_cmds_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_ipv6_nd_ra_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ipv6.ipv6_nd_ra', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.ipv6_nd_ra', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_mtu_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ipv6.ipv6_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.ipv6_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mtu'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_nd_broadcast_mac_trap_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'broadcast-mac-trap'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_nd_cache_expire_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.cache', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.cache', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'expire'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_nd_dad_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.dad', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.dad', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_nd_dad_attempts_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.dad', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.dad', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'attempts'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_nd_dad_time_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.dad', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.dad', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_nd_hoplimit_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hoplimit'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_nd_managed_config_flag_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'managed-config-flag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_nd_mtu_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mtu'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_nd_ns_interval_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ns-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_nd_nud_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_nd_nud_retry_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'base, interval, max_attempts'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_nd_nud_retry_base_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'base'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_nd_nud_retry_interval_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_nd_nud_retry_max_attempts_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'max-attempts'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_nd_other_config_flag_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'other-config-flag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_nd_prefix_delete(self, port_channel=None, prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix', 'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, prefix=prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_nd_prefix_infinite_delete(self, port_channel=None, prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'infinite'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, prefix=prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_nd_prefix_infinite_preferred_delete(self, port_channel=None, prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'infinite'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, prefix=prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_nd_prefix_no_advertise_delete(self, port_channel=None, prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'no-advertise'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, prefix=prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_nd_prefix_no_autoconfig_delete(self, port_channel=None, prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'no-autoconfig'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, prefix=prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_nd_prefix_no_onlink_delete(self, port_channel=None, prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'no-onlink'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, prefix=prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_nd_prefix_off_link_delete(self, port_channel=None, prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'off-link'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, prefix=prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_nd_prefix_preferred_delete(self, port_channel=None, prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'preferred_lifetime, preferred_infinite'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_1_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred': [u'preferred_infinite', u'preferred_lifetime'], 'pybind.nos.v7_0_1b.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred': [u'preferred_infinite', u'preferred_lifetime']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, prefix=prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_nd_prefix_preferred_lifetime_delete(self, port_channel=None, prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'preferred-lifetime'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, prefix=prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_nd_prefix_prefix_flags_delete(self, port_channel=None, prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'no_autoconfig, no_onlink, off_link'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, prefix=prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_nd_prefix_valid_lifetime_delete(self, port_channel=None, prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'valid-lifetime'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, prefix=prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_nd_proxy_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'proxy'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_nd_ra_interval_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_interval', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_interval', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'max_interval, min_'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_nd_ra_interval_max_interval_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_interval', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_interval', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'max-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_nd_ra_interval_min_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_interval', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_interval', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'min'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_nd_ra_lifetime_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ra-lifetime'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_nd_reachable_time_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'reachable-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_nd_retrans_timer_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'retrans-timer'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_nd_set_cache_expire_time_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_1_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'set-cache-expire-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_nd_set_hoplimit_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_1_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'set-hoplimit'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_nd_suppress_ra_all_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'all'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_nd_suppress_ra_mtu_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mtu'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_nd_suppress_ra_suppress_ra_flag_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'suppress-ra-flag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_neighbor_delete(self, port_channel=None, neighbor=None, hardware_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type neighbor: ipv6_address
    :param neighbor: Keyword argument tuple.

    :type ipv6_address: unicode
    :param ipv6_address: **neighbor** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    **Instance Argument(s)**:

    :type hardware_address: unicode
    :param hardware_address: Keyword argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.neighbor', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.neighbor', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'neighbor', 'keyval': 'ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, neighbor=neighbor, hardware_address=hardware_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, neighbor=neighbor, hardware_address=hardware_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_neighbor_hardware_address_delete(self, port_channel=None, neighbor=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type neighbor: ipv6_address
    :param neighbor: Keyword argument tuple.

    :type ipv6_address: unicode
    :param ipv6_address: **neighbor** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.neighbor', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.neighbor', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'neighbor', 'keyval': 'ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hardware-address'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, neighbor=neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, neighbor=neighbor)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_ospf_active_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'active'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_ospf_area_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'area'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_ospf_authentication_ah_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ah'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_ospf_authentication_esp_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'esp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_ospf_authentication_esp_auth_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'esp-auth'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_ospf_authentication_esp_key_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'esp-key'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_ospf_authentication_esp_no_encrypt_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'esp-no-encrypt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_ospf_authentication_ipsec_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_ospf_authentication_ipsec_disable_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'disable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_ospf_authentication_ipsec_key_add_remove_interval_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'key-add-remove-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_ospf_authentication_key_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'key'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_ospf_authentication_no_encrypt_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'no-encrypt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_ospf_authentication_spi_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'spi'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_ospf_bfd_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ipv6.interface_ospfv3_conf.bfd', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.interface_ospfv3_conf.bfd', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_ospf_bfd_bfd_enable_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ipv6.interface_ospfv3_conf.bfd', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.interface_ospfv3_conf.bfd', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bfd-enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_ospf_cost_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cost'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_ospf_dead_interval_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dead-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_ospf_hello_interval_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hello-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_ospf_hello_jitter_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hello-jitter'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_ospf_instance_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'instance'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_ospf_link_interval_properties_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_ospf_mtu_ignore_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mtu-ignore'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_ospf_network_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'network'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_ospf_passive_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'passive'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_ospf_priority_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_ospf_retransmit_interval_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'retransmit-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_ospf_suppress_linklsa_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'suppress-linklsa'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_ospf_transmit_delay_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'transmit-delay'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_policy_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ipv6.policy', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.policy', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_policy_route_map_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ipv6.policy.route_map', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.policy.route_map', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_policy_route_map_ipv6_route_map_name_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ipv6.policy.route_map', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.policy.route_map', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ipv6-route-map-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_raguard_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.ipv6', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.ipv6', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.ipv6', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'raguard'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_vrrp_extended_group_delete(self, port_channel=None, vrrpv3e=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.slxos.v16r_1_00b.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, vrrpv3e=vrrpv3e)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, vrrpv3e=vrrpv3e)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_vrrp_extended_group_advertise_backup_delete(self, port_channel=None, vrrpv3e=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.slxos.v16r_1_00b.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'advertise-backup'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, vrrpv3e=vrrpv3e)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, vrrpv3e=vrrpv3e)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_vrrp_extended_group_advertisement_interval_delete(self, port_channel=None, vrrpv3e=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.slxos.v16r_1_00b.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'advertisement-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, vrrpv3e=vrrpv3e)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, vrrpv3e=vrrpv3e)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_vrrp_extended_group_advertisement_interval_scale_delete(self, port_channel=None, vrrpv3e=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.slxos.v16r_1_00b.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'advertisement-interval-scale'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, vrrpv3e=vrrpv3e)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, vrrpv3e=vrrpv3e)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_vrrp_extended_group_backup_advertisement_interval_delete(self, port_channel=None, vrrpv3e=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.slxos.v16r_1_00b.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'backup-advertisement-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, vrrpv3e=vrrpv3e)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, vrrpv3e=vrrpv3e)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_vrrp_extended_group_description_delete(self, port_channel=None, vrrpv3e=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.slxos.v16r_1_00b.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'description'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, vrrpv3e=vrrpv3e)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, vrrpv3e=vrrpv3e)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_vrrp_extended_group_enable_delete(self, port_channel=None, vrrpv3e=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.slxos.v16r_1_00b.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, vrrpv3e=vrrpv3e)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, vrrpv3e=vrrpv3e)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_vrrp_extended_group_hold_time_delete(self, port_channel=None, vrrpv3e=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.slxos.v16r_1_00b.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hold-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, vrrpv3e=vrrpv3e)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, vrrpv3e=vrrpv3e)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_vrrp_extended_group_nd_advertisement_timer_delete(self, port_channel=None, vrrpv3e=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.slxos.v16r_1_00b.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'nd-advertisement-timer'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, vrrpv3e=vrrpv3e)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, vrrpv3e=vrrpv3e)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_vrrp_extended_group_preempt_mode_delete(self, port_channel=None, vrrpv3e=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.slxos.v16r_1_00b.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'preempt-mode'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, vrrpv3e=vrrpv3e)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, vrrpv3e=vrrpv3e)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_vrrp_extended_group_priority_delete(self, port_channel=None, vrrpv3e=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.slxos.v16r_1_00b.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, vrrpv3e=vrrpv3e)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, vrrpv3e=vrrpv3e)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_vrrp_extended_group_short_path_forwarding_delete(self, port_channel=None, vrrpv3e=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'vrrpv3e'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'vrrpv3e')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e.short_path_forwarding', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.slxos.v16r_1_00b.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e.short_path_forwarding', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'basic, revert_priority'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, vrrpv3e=vrrpv3e)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, vrrpv3e=vrrpv3e)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_vrrp_extended_group_short_path_forwarding_basic_delete(self, port_channel=None, vrrpv3e=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'vrrpv3e'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'vrrpv3e')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e.short_path_forwarding', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.slxos.v16r_1_00b.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e.short_path_forwarding', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'basic'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, vrrpv3e=vrrpv3e)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, vrrpv3e=vrrpv3e)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_vrrp_extended_group_short_path_forwarding_revert_priority_delete(self, port_channel=None, vrrpv3e=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'vrrpv3e'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'vrrpv3e')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e.short_path_forwarding', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.slxos.v16r_1_00b.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e.short_path_forwarding', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'revert-priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, vrrpv3e=vrrpv3e)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, vrrpv3e=vrrpv3e)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_vrrp_extended_group_track_interface_delete(self, port_channel=None, vrrpv3e=None, interface=None, track_priority=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Argument(s)**:

    :type track_priority: int
    :param track_priority: Track Priority

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'vrrpv3e'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'vrrpv3e')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e.track.interface', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.slxos.v16r_1_00b.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e.track.interface', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, vrrpv3e=vrrpv3e, interface=interface, track_priority=track_priority)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, vrrpv3e=vrrpv3e, interface=interface, track_priority=track_priority)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_vrrp_extended_group_track_interface_priority_delete(self, port_channel=None, vrrpv3e=None, interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'vrrpv3e'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'vrrpv3e')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e.track.interface', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.slxos.v16r_1_00b.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e.track.interface', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, vrrpv3e=vrrpv3e, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, vrrpv3e=vrrpv3e, interface=interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_vrrp_extended_group_virtual_ip_delete(self, port_channel=None, vrrpv3e=None, virtual_ip=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type virtual_ip: virtual_ipaddr
    :param virtual_ip: Keyword argument tuple.

    :type virtual_ipaddr: unicode
    :param virtual_ipaddr: **virtual_ip** tuple argument:  Virtual IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'vrrpv3e'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'vrrpv3e')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e.virtual_ip', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.slxos.v16r_1_00b.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e.virtual_ip', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'virtual_ip', 'keyval': 'virtual_ipaddr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, vrrpv3e=vrrpv3e, virtual_ip=virtual_ip)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, vrrpv3e=vrrpv3e, virtual_ip=virtual_ip)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_vrrp_group_delete(self, port_channel=None, vrrpv3=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3: vrid
    :param vrrpv3: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v7_0_1b.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3": {}, "pybind.nos.v6_0_2c.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3": {"enable": "enable", "description": "description", "vrid": "vrid", "priority": "priority", "advertisement_interval": "advertisement_interval", "hold_time": "hold_time", "preempt_mode": "preempt_mode"}, "pybind.nos.v7_1_0.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3": {}, "pybind.slxos.v16r_1_00b.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3": {"enable": "enable", "description": "description", "vrid": "vrid", "priority": "priority", "advertisement_interval": "advertisement_interval", "hold_time": "hold_time", "preempt_mode": "preempt_mode"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, vrrpv3=vrrpv3)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, vrrpv3=vrrpv3)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_vrrp_group_advertisement_interval_delete(self, port_channel=None, vrrpv3=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3: vrid
    :param vrrpv3: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'advertisement-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, vrrpv3=vrrpv3)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, vrrpv3=vrrpv3)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_vrrp_group_description_delete(self, port_channel=None, vrrpv3=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3: vrid
    :param vrrpv3: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'description'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, vrrpv3=vrrpv3)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, vrrpv3=vrrpv3)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_vrrp_group_enable_delete(self, port_channel=None, vrrpv3=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3: vrid
    :param vrrpv3: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, vrrpv3=vrrpv3)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, vrrpv3=vrrpv3)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_vrrp_group_hold_time_delete(self, port_channel=None, vrrpv3=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3: vrid
    :param vrrpv3: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hold-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, vrrpv3=vrrpv3)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, vrrpv3=vrrpv3)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_vrrp_group_preempt_mode_delete(self, port_channel=None, vrrpv3=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3: vrid
    :param vrrpv3: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'preempt-mode'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, vrrpv3=vrrpv3)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, vrrpv3=vrrpv3)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_vrrp_group_priority_delete(self, port_channel=None, vrrpv3=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3: vrid
    :param vrrpv3: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, vrrpv3=vrrpv3)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, vrrpv3=vrrpv3)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_vrrp_group_track_interface_delete(self, port_channel=None, vrrpv3=None, interface=None, track_priority=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpv3: vrid
    :param vrrpv3: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Argument(s)**:

    :type track_priority: int
    :param track_priority: Track Priority

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', u'vrrpv3'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', u'vrrpv3'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', u'vrrpv3'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', u'vrrpv3')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3.track.interface', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3.track.interface', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3.track.interface', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3.track.interface', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, vrrpv3=vrrpv3, interface=interface, track_priority=track_priority)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, vrrpv3=vrrpv3, interface=interface, track_priority=track_priority)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_vrrp_group_track_interface_priority_delete(self, port_channel=None, vrrpv3=None, interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpv3: vrid
    :param vrrpv3: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', u'vrrpv3'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', u'vrrpv3'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', u'vrrpv3'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', u'vrrpv3')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3.track.interface', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3.track.interface', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3.track.interface', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3.track.interface', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, vrrpv3=vrrpv3, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, vrrpv3=vrrpv3, interface=interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_vrrp_group_use_v2_checksum_delete(self, port_channel=None, vrrpv3=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3: vrid
    :param vrrpv3: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'use-v2-checksum'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, vrrpv3=vrrpv3)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, vrrpv3=vrrpv3)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_vrrp_group_virtual_ip_delete(self, port_channel=None, vrrpv3=None, virtual_ip=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpv3: vrid
    :param vrrpv3: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type virtual_ip: virtual_ipaddr
    :param virtual_ip: Keyword argument tuple.

    :type virtual_ipaddr: unicode
    :param virtual_ipaddr: **virtual_ip** tuple argument:  Virtual IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', u'vrrpv3'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', u'vrrpv3'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', u'vrrpv3'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', u'vrrpv3')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3.virtual_ip', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3.virtual_ip', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3.virtual_ip', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3.virtual_ip', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'virtual_ip', 'keyval': 'virtual_ipaddr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, vrrpv3=vrrpv3, virtual_ip=virtual_ip)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, vrrpv3=vrrpv3, virtual_ip=virtual_ip)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_ipv6_vrrp_suppress_interface_ra_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vrrp-suppress-interface-ra'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_load_balance_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'port_channel', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'load-balance'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_load_balance_type_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.port_channel', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'port_channel', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'load-balance-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_logical_interface_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.port_channel.logical_interface', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_logical_interface_port_channel_delete(self, port_channel=None, port_channel_=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type port_channel_: pc_instance_id
    :param port_channel_: Keyword argument tuple.

    :type pc_instance_id: unicode
    :param pc_instance_id: **port_channel_** tuple argument.

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|[1-9][0-9][0-9]|[1-6][0-9][0-'
            '9][0-9])\.([1-9]|[1-9][0-9]||[1-9][0-9][0-9]|[1-'
            '9][0-9][0-9][0-9]|1[0-2][0-2][0-8][0-8]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.port_channel.logical_interface.port_channel', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'port_channel_', 'keyval': 'pc_instance_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, port_channel_=port_channel_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, port_channel_=port_channel_)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_logical_interface_port_channel_get_untagged_vlan_dummy_delete(self, port_channel=None, port_channel_=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type port_channel_: pc_instance_id
    :param port_channel_: Keyword argument tuple.

    :type pc_instance_id: unicode
    :param pc_instance_id: **port_channel_** tuple argument.

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|[1-9][0-9][0-9]|[1-6][0-9][0-'
            '9][0-9])\.([1-9]|[1-9][0-9]||[1-9][0-9][0-9]|[1-'
            '9][0-9][0-9][0-9]|1[0-2][0-2][0-8][0-8]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel.logical_interface.port_channel', u'port_channel_')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.port_channel.logical_interface.port_channel.pc_cmd_container_dummy.service_instance_vlan_cmds_dummy_container.get_untagged_vlan_dummy', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'pc_instance_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, port_channel_=port_channel_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, port_channel_=port_channel_)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_logical_interface_port_channel_name_logical_interface_name_delete(self, port_channel=None, port_channel_=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type port_channel_: pc_instance_id
    :param port_channel_: Keyword argument tuple.

    :type pc_instance_id: unicode
    :param pc_instance_id: **port_channel_** tuple argument.

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|[1-9][0-9][0-9]|[1-6][0-9][0-'
            '9][0-9])\.([1-9]|[1-9][0-9]||[1-9][0-9][0-9]|[1-'
            '9][0-9][0-9][0-9]|1[0-2][0-2][0-8][0-8]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel.logical_interface.port_channel', u'port_channel_')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.port_channel.logical_interface.port_channel.pc_cmd_container_dummy.service_instance_common_commands_dummy.name', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'pc_instance_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'logical-interface-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, port_channel_=port_channel_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, port_channel_=port_channel_)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_logical_interface_port_channel_service_instance_common_commands_dummy_delete(self, port_channel=None, port_channel_=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type port_channel_: pc_instance_id
    :param port_channel_: Keyword argument tuple.

    :type pc_instance_id: unicode
    :param pc_instance_id: **port_channel_** tuple argument.

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|[1-9][0-9][0-9]|[1-6][0-9][0-'
            '9][0-9])\.([1-9]|[1-9][0-9]||[1-9][0-9][0-9]|[1-'
            '9][0-9][0-9][0-9]|1[0-2][0-2][0-8][0-8]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel.logical_interface.port_channel', u'port_channel_')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.port_channel.logical_interface.port_channel.pc_cmd_container_dummy.service_instance_common_commands_dummy', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'pc_instance_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, port_channel_=port_channel_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, port_channel_=port_channel_)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_logical_interface_port_channel_service_instance_vlan_cmds_dummy_container_delete(self, port_channel=None, port_channel_=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type port_channel_: pc_instance_id
    :param port_channel_: Keyword argument tuple.

    :type pc_instance_id: unicode
    :param pc_instance_id: **port_channel_** tuple argument.

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|[1-9][0-9][0-9]|[1-6][0-9][0-'
            '9][0-9])\.([1-9]|[1-9][0-9]||[1-9][0-9][0-9]|[1-'
            '9][0-9][0-9][0-9]|1[0-2][0-2][0-8][0-8]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel.logical_interface.port_channel', u'port_channel_')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.port_channel.logical_interface.port_channel.pc_cmd_container_dummy.service_instance_vlan_cmds_dummy_container', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'pc_instance_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, port_channel_=port_channel_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, port_channel_=port_channel_)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_logical_interface_port_channel_shutdown_shutdown_status_delete(self, port_channel=None, port_channel_=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type port_channel_: pc_instance_id
    :param port_channel_: Keyword argument tuple.

    :type pc_instance_id: unicode
    :param pc_instance_id: **port_channel_** tuple argument.

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|[1-9][0-9][0-9]|[1-6][0-9][0-'
            '9][0-9])\.([1-9]|[1-9][0-9]||[1-9][0-9][0-9]|[1-'
            '9][0-9][0-9][0-9]|1[0-2][0-2][0-8][0-8]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel.logical_interface.port_channel', u'port_channel_')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.port_channel.logical_interface.port_channel.pc_cmd_container_dummy.service_instance_common_commands_dummy.shutdown', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'pc_instance_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'shutdown-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, port_channel_=port_channel_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, port_channel_=port_channel_)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_logical_interface_port_channel_untagged_delete(self, port_channel=None, port_channel_=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type port_channel_: pc_instance_id
    :param port_channel_: Keyword argument tuple.

    :type pc_instance_id: unicode
    :param pc_instance_id: **port_channel_** tuple argument.

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|[1-9][0-9][0-9]|[1-6][0-9][0-'
            '9][0-9])\.([1-9]|[1-9][0-9]||[1-9][0-9][0-9]|[1-'
            '9][0-9][0-9][0-9]|1[0-2][0-2][0-8][0-8]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel.logical_interface.port_channel', u'port_channel_')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.port_channel.logical_interface.port_channel.pc_cmd_container_dummy.service_instance_vlan_cmds_dummy_container.get_untagged_vlan_dummy.untagged', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'pc_instance_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, port_channel_=port_channel_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, port_channel_=port_channel_)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_logical_interface_port_channel_untagged_vlan_delete(self, port_channel=None, port_channel_=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type port_channel_: pc_instance_id
    :param port_channel_: Keyword argument tuple.

    :type pc_instance_id: unicode
    :param pc_instance_id: **port_channel_** tuple argument.

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|[1-9][0-9][0-9]|[1-6][0-9][0-'
            '9][0-9])\.([1-9]|[1-9][0-9]||[1-9][0-9][0-9]|[1-'
            '9][0-9][0-9][0-9]|1[0-2][0-2][0-8][0-8]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel.logical_interface.port_channel', u'port_channel_')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.port_channel.logical_interface.port_channel.pc_cmd_container_dummy.service_instance_vlan_cmds_dummy_container.get_untagged_vlan_dummy.untagged.untagged_vlan', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'pc_instance_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, port_channel_=port_channel_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, port_channel_=port_channel_)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_logical_interface_port_channel_untagged_vlan_untagged_vlan_id_delete(self, port_channel=None, port_channel_=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type port_channel_: pc_instance_id
    :param port_channel_: Keyword argument tuple.

    :type pc_instance_id: unicode
    :param pc_instance_id: **port_channel_** tuple argument.

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|[1-9][0-9][0-9]|[1-6][0-9][0-'
            '9][0-9])\.([1-9]|[1-9][0-9]||[1-9][0-9][0-9]|[1-'
            '9][0-9][0-9][0-9]|1[0-2][0-2][0-8][0-8]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel.logical_interface.port_channel', u'port_channel_')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.port_channel.logical_interface.port_channel.pc_cmd_container_dummy.service_instance_vlan_cmds_dummy_container.get_untagged_vlan_dummy.untagged.untagged_vlan', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'pc_instance_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'untagged-vlan-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, port_channel_=port_channel_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, port_channel_=port_channel_)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_logical_interface_port_channel_vlan_delete(self, port_channel=None, port_channel_=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type port_channel_: pc_instance_id
    :param port_channel_: Keyword argument tuple.

    :type pc_instance_id: unicode
    :param pc_instance_id: **port_channel_** tuple argument.

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|[1-9][0-9][0-9]|[1-6][0-9][0-'
            '9][0-9])\.([1-9]|[1-9][0-9]||[1-9][0-9][0-9]|[1-'
            '9][0-9][0-9][0-9]|1[0-2][0-2][0-8][0-8]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel.logical_interface.port_channel', u'port_channel_')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.port_channel.logical_interface.port_channel.pc_cmd_container_dummy.service_instance_vlan_cmds_dummy_container.tagged_outer_vlan', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'pc_instance_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'outer_tagged_vlan_id, inner_vlan, inner_tagged_vlan_id'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, port_channel_=port_channel_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, port_channel_=port_channel_)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_logical_interface_port_channel_vlan_inner_tagged_vlan_id_delete(self, port_channel=None, port_channel_=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type port_channel_: pc_instance_id
    :param port_channel_: Keyword argument tuple.

    :type pc_instance_id: unicode
    :param pc_instance_id: **port_channel_** tuple argument.

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|[1-9][0-9][0-9]|[1-6][0-9][0-'
            '9][0-9])\.([1-9]|[1-9][0-9]||[1-9][0-9][0-9]|[1-'
            '9][0-9][0-9][0-9]|1[0-2][0-2][0-8][0-8]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel.logical_interface.port_channel', u'port_channel_')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.port_channel.logical_interface.port_channel.pc_cmd_container_dummy.service_instance_vlan_cmds_dummy_container.tagged_outer_vlan', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'pc_instance_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'inner-tagged-vlan-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, port_channel_=port_channel_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, port_channel_=port_channel_)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_logical_interface_port_channel_vlan_inner_vlan_delete(self, port_channel=None, port_channel_=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type port_channel_: pc_instance_id
    :param port_channel_: Keyword argument tuple.

    :type pc_instance_id: unicode
    :param pc_instance_id: **port_channel_** tuple argument.

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|[1-9][0-9][0-9]|[1-6][0-9][0-'
            '9][0-9])\.([1-9]|[1-9][0-9]||[1-9][0-9][0-9]|[1-'
            '9][0-9][0-9][0-9]|1[0-2][0-2][0-8][0-8]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel.logical_interface.port_channel', u'port_channel_')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.port_channel.logical_interface.port_channel.pc_cmd_container_dummy.service_instance_vlan_cmds_dummy_container.tagged_outer_vlan', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'pc_instance_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'inner-vlan'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, port_channel_=port_channel_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, port_channel_=port_channel_)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_logical_interface_port_channel_vlan_outer_tagged_vlan_id_delete(self, port_channel=None, port_channel_=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type port_channel_: pc_instance_id
    :param port_channel_: Keyword argument tuple.

    :type pc_instance_id: unicode
    :param pc_instance_id: **port_channel_** tuple argument.

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|[1-9][0-9][0-9]|[1-6][0-9][0-'
            '9][0-9])\.([1-9]|[1-9][0-9]||[1-9][0-9][0-9]|[1-'
            '9][0-9][0-9][0-9]|1[0-2][0-2][0-8][0-8]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel.logical_interface.port_channel', u'port_channel_')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.port_channel.logical_interface.port_channel.pc_cmd_container_dummy.service_instance_vlan_cmds_dummy_container.tagged_outer_vlan', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'pc_instance_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'outer-tagged-vlan-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, port_channel_=port_channel_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, port_channel_=port_channel_)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_mac_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.mac', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.mac', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.mac', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.mac', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_mac_access_group_delete(self, port_channel=None, access_group=None, traffic_type=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type access_group: mac_access_list, mac_direction, traffic_type
    :param access_group: Keyword argument tuple.

    :type mac_access_list: unicode
    :param mac_access_list: **access_group** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type mac_direction: unicode
    :param mac_direction: **access_group** tuple argument.

        * enumeration restriction: ::

            ['in', 'out']

    :type traffic_type: unicode
    :param traffic_type: **access_group** tuple argument.

        * enumeration restriction: ::

            ['switched', 'routed']

    **Instance Argument(s)**:

    :type traffic_type: unicode
    :param traffic_type: Keyword argument.

        * enumeration restriction: ::

            ['switched', 'routed']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.mac.access_group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.mac.access_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.mac.access_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.mac.access_group', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'access_group', 'keyval': 'mac_access_list, mac_direction', 'extra_keyval': 'mac_access_list, mac_direction, traffic_type'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, access_group=access_group, traffic_type=traffic_type)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, access_group=access_group, traffic_type=traffic_type)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_mac_learning_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.mac_learning', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.mac_learning', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.mac_learning', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_mac_learning_disable_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.mac_learning.mac_learn_disable', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.mac_learning.mac_learn_disable', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.mac_learning.mac_learn_disable', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_mac_learning_disable_vlan_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.mac_learning.mac_learn_disable.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.mac_learning.mac_learn_disable.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.mac_learning.mac_learn_disable.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_mac_learning_disable_vlan_add_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.mac_learning.mac_learn_disable.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.mac_learning.mac_learn_disable.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.mac_learning.mac_learn_disable.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'add'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_mac_learning_disable_vlan_remove_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.mac_learning.mac_learn_disable.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.mac_learning.mac_learn_disable.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.mac_learning.mac_learn_disable.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'remove'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_minimum_links_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'port_channel', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'minimum-links'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_mtu_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'port_channel', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mtu'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_port_profile_port_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'port_channel', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'port-profile-port'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_port_profile_port_domain_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.port_profile_to_interface_associations.port_profile_port.port_to_port_profile_domain_association', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.port_profile_to_interface_associations.port_profile_port.port_to_port_profile_domain_association', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.port_profile_to_interface_associations.port_profile_port.port_to_port_profile_domain_association', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.port_profile_to_interface_associations.port_profile_port.port_to_port_profile_domain_association', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_port_profile_port_domain_profile_domain_name_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.port_profile_to_interface_associations.port_profile_port.port_to_port_profile_domain_association', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.port_profile_to_interface_associations.port_profile_port.port_to_port_profile_domain_association', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.port_profile_to_interface_associations.port_profile_port.port_to_port_profile_domain_association', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.port_profile_to_interface_associations.port_profile_port.port_to_port_profile_domain_association', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'profile-domain-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_port_profile_port_profile_delete(self, port_channel=None, port_to_port_profile_associations=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type port_to_port_profile_associations: port_to_port_profile_association
    :param port_to_port_profile_associations: Keyword argument tuple.

    :type port_to_port_profile_association: unicode
    :param port_to_port_profile_association: **port_to_port_profile_associations** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.port_profile_to_interface_associations.port_profile_port.port_to_port_profile_associations', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.port_profile_to_interface_associations.port_profile_port.port_to_port_profile_associations', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.port_profile_to_interface_associations.port_profile_port.port_to_port_profile_associations', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.port_profile_to_interface_associations.port_profile_port.port_to_port_profile_associations', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'port_to_port_profile_associations', 'keyval': 'port_to_port_profile_association', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, port_to_port_profile_associations=port_to_port_profile_associations)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, port_to_port_profile_associations=port_to_port_profile_associations)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_port_profile_to_interface_associations_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.port_profile_to_interface_associations', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.port_profile_to_interface_associations', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.port_profile_to_interface_associations', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.port_profile_to_interface_associations', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_priority_tag_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'port_channel', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority-tag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_qos_cos_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.qos', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.qos', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.qos', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.qos', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cos'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_qos_cos_mutation_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.qos', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.qos', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.qos', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.qos', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cos-mutation'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_qos_cos_traffic_class_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.qos', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.qos', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.qos', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.qos', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cos-traffic-class'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_qos_drop_monitor_enable_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.qos.drop_monitor', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.qos.drop_monitor', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.qos.drop_monitor', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.qos.drop_monitor', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_qos_dscp_cos_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.qos', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.qos', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.qos', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.qos', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dscp-cos'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_qos_dscp_mutation_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.qos', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.qos', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.qos', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.qos', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dscp-mutation'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_qos_dscp_traffic_class_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.qos', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.qos', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.qos', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.qos', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dscp-traffic-class'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_qos_flowcontrol_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.qos.flowcontrol', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.qos.flowcontrol', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.qos.flowcontrol', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.qos.flowcontrol', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_qos_flowcontrol_link_level_flowcontrol_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.qos.flowcontrol.link_level_flowcontrol', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.qos.flowcontrol.link_level_flowcontrol', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.qos.flowcontrol.link_level_flowcontrol', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.qos.flowcontrol.link_level_flowcontrol', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_qos_flowcontrol_pfc_delete(self, port_channel=None, pfc=None, pfc_flowcontrol_tx=None, pfc_flowcontrol_rx=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type pfc: pfc_cos
    :param pfc: Keyword argument tuple.

    :type pfc_cos: long
    :param pfc_cos: **pfc** tuple argument:  0-7;;CoS value

        * range restriction: ::

            ['-2147483648..2147483647']

    **Instance Argument(s)**:

    :type pfc_flowcontrol_tx: unicode
    :param pfc_flowcontrol_tx: Configure Pause generation

        * enumeration restriction: ::

            ['on', 'off']

    :type pfc_flowcontrol_rx: unicode
    :param pfc_flowcontrol_rx: Configure Pause reception

        * enumeration restriction: ::

            ['on', 'off']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.qos.flowcontrol.pfc', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.qos.flowcontrol.pfc', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.qos.flowcontrol.pfc', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.qos.flowcontrol.pfc', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'pfc', 'keyval': 'pfc_cos', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, pfc=pfc, pfc_flowcontrol_tx=pfc_flowcontrol_tx, pfc_flowcontrol_rx=pfc_flowcontrol_rx)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, pfc=pfc, pfc_flowcontrol_tx=pfc_flowcontrol_tx, pfc_flowcontrol_rx=pfc_flowcontrol_rx)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_qos_flowcontrol_pfc_rx_delete(self, port_channel=None, pfc=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type pfc: pfc_cos
    :param pfc: Keyword argument tuple.

    :type pfc_cos: long
    :param pfc_cos: **pfc** tuple argument:  0-7;;CoS value

        * range restriction: ::

            ['-2147483648..2147483647']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.qos.flowcontrol.pfc', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.qos.flowcontrol.pfc', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.qos.flowcontrol.pfc', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.qos.flowcontrol.pfc', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'pfc', 'keyval': 'pfc_cos', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, pfc=pfc)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, pfc=pfc)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_qos_flowcontrol_pfc_tx_delete(self, port_channel=None, pfc=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type pfc: pfc_cos
    :param pfc: Keyword argument tuple.

    :type pfc_cos: long
    :param pfc_cos: **pfc** tuple argument:  0-7;;CoS value

        * range restriction: ::

            ['-2147483648..2147483647']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.qos.flowcontrol.pfc', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.qos.flowcontrol.pfc', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.qos.flowcontrol.pfc', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.qos.flowcontrol.pfc', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'pfc', 'keyval': 'pfc_cos', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, pfc=pfc)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, pfc=pfc)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_qos_flowcontrol_rx_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.qos.flowcontrol.link_level_flowcontrol', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.qos.flowcontrol.link_level_flowcontrol', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.qos.flowcontrol.link_level_flowcontrol', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.qos.flowcontrol.link_level_flowcontrol', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_qos_flowcontrol_tx_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.qos.flowcontrol.link_level_flowcontrol', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.qos.flowcontrol.link_level_flowcontrol', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.qos.flowcontrol.link_level_flowcontrol', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.qos.flowcontrol.link_level_flowcontrol', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_qos_random_detect_traffic_class_delete(self, port_channel=None, traffic_class=None, red_enable=None, red_profile_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type traffic_class: red_tc_value
    :param traffic_class: Keyword argument tuple.

    :type red_tc_value: long
    :param red_tc_value: **traffic_class** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Argument(s)**:

    :type red_enable: YANGBool
    :param red_enable: Keyword for VDX 6710,6720,6730,6746,2730

    :type red_profile_id: long
    :param red_profile_id: Keyword for all other VDX platforms

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.qos.random_detect.traffic_class', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.qos.random_detect.traffic_class', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.qos.random_detect.traffic_class', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.qos.random_detect.traffic_class', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'traffic_class', 'keyval': 'red_tc_value', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v7_1_0.interface.port_channel.qos.random_detect.traffic_class": {"red_tc_value": "red_tc_value", "red_profile_id": "red_profile_id", "red_enable": "red_enable"}, "pybind.nos.v6_0_2c.interface.port_channel.qos.random_detect.traffic_class": {"red_tc_value": "red_tc_value", "red_profile_id": "red_profile_id", "red_enable": "red_enable"}, "pybind.slxos.v16r_1_00b.interface.port_channel.qos.random_detect.traffic_class": {}, "pybind.nos.v7_0_1b.interface.port_channel.qos.random_detect.traffic_class": {"red_tc_value": "red_tc_value", "red_profile_id": "red_profile_id", "red_enable": "red_enable"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, traffic_class=traffic_class, red_enable=red_enable, red_profile_id=red_profile_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, traffic_class=traffic_class, red_enable=red_enable, red_profile_id=red_profile_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_qos_random_detect_traffic_class_apply_delete(self, port_channel=None, traffic_class=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type traffic_class: red_tc_value
    :param traffic_class: Keyword argument tuple.

    :type red_tc_value: long
    :param red_tc_value: **traffic_class** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.qos.random_detect.traffic_class', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.qos.random_detect.traffic_class', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.qos.random_detect.traffic_class', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'traffic_class', 'keyval': 'red_tc_value', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'apply'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, traffic_class=traffic_class)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, traffic_class=traffic_class)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_qos_random_detect_traffic_class_red_profile_id_delete(self, port_channel=None, traffic_class=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type traffic_class: red_tc_value
    :param traffic_class: Keyword argument tuple.

    :type red_tc_value: long
    :param red_tc_value: **traffic_class** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.qos.random_detect.traffic_class', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.qos.random_detect.traffic_class', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.qos.random_detect.traffic_class', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.qos.random_detect.traffic_class', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'traffic_class', 'keyval': 'red_tc_value', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'red-profile-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, traffic_class=traffic_class)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, traffic_class=traffic_class)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_qos_traffic_class_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.port_channel.qos', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'traffic-class'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_qos_traffic_class_cos_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.port_channel.qos', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'traffic-class-cos'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_qos_trust_cos_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.qos.trust', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.qos.trust', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.qos.trust', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.qos.trust', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cos'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_qos_trust_dscp_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.qos.trust', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.qos.trust', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.qos.trust', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.qos.trust', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dscp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_service_policy_in_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.service_policy', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.service_policy', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.service_policy', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.service_policy', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'in'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_service_policy_out_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.service_policy', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.service_policy', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.service_policy', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.service_policy', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'out'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_shutdown_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'port_channel', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'shutdown'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_snmp_trap_link_status_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.snmp.trap', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.snmp.trap', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.snmp.trap', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'link-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_spanning_tree_autoedge_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.spanning_tree', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.spanning_tree', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.spanning_tree', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.spanning_tree', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'autoedge'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_spanning_tree_bpdu_mac_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.spanning_tree', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.spanning_tree', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.spanning_tree', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.spanning_tree', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bpdu-mac'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_spanning_tree_cost_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.spanning_tree', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.spanning_tree', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.spanning_tree', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.spanning_tree', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cost'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_spanning_tree_edgeport_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.spanning_tree.edgeport', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.spanning_tree.edgeport', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.spanning_tree.edgeport', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.spanning_tree.edgeport', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_spanning_tree_edgeport_bpdu_filter_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.spanning_tree.edgeport', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.spanning_tree.edgeport', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.spanning_tree.edgeport', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.spanning_tree.edgeport', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bpdu-filter'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_spanning_tree_edgeport_bpdu_guard_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.spanning_tree.edgeport', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.spanning_tree.edgeport', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.spanning_tree.edgeport', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.spanning_tree.edgeport', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bpdu-guard'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_spanning_tree_edgeport_edgeportbasic_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.spanning_tree.edgeport', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.spanning_tree.edgeport', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.spanning_tree.edgeport', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.spanning_tree.edgeport', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'edgeportbasic'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_spanning_tree_guard_root_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.spanning_tree.guard', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.spanning_tree.guard', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.spanning_tree.guard', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.spanning_tree.guard', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'root'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_spanning_tree_hello_time_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.spanning_tree', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.spanning_tree', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.spanning_tree', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hello-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_spanning_tree_instance_cost_delete(self, port_channel=None, instance=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type instance: id
    :param instance: Keyword argument tuple.

    :type id: int
    :param id: **instance** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.spanning_tree.instance', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.spanning_tree.instance', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.spanning_tree.instance', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.spanning_tree.instance', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instance', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cost'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, instance=instance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, instance=instance)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_spanning_tree_instance_priority_delete(self, port_channel=None, instance=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type instance: id
    :param instance: Keyword argument tuple.

    :type id: int
    :param id: **instance** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.spanning_tree.instance', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.spanning_tree.instance', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.spanning_tree.instance', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.spanning_tree.instance', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instance', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, instance=instance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, instance=instance)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_spanning_tree_instance_restricted_role_delete(self, port_channel=None, instance=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type instance: id
    :param instance: Keyword argument tuple.

    :type id: int
    :param id: **instance** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.spanning_tree.instance', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.spanning_tree.instance', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.spanning_tree.instance', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.spanning_tree.instance', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instance', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'restricted-role'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, instance=instance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, instance=instance)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_spanning_tree_instance_restricted_tcn_delete(self, port_channel=None, instance=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type instance: id
    :param instance: Keyword argument tuple.

    :type id: int
    :param id: **instance** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.spanning_tree.instance', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.spanning_tree.instance', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.spanning_tree.instance', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.spanning_tree.instance', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instance', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'restricted-tcn'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, instance=instance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, instance=instance)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_spanning_tree_link_type_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.spanning_tree', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.spanning_tree', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.spanning_tree', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.spanning_tree', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'link-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_spanning_tree_peer_switch_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.spanning_tree', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.spanning_tree', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.spanning_tree', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.spanning_tree', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'peer-switch'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_spanning_tree_portfast_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.spanning_tree.portfast', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.spanning_tree.portfast', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.spanning_tree.portfast', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.spanning_tree.portfast', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_spanning_tree_portfast_bpdu_filter_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.spanning_tree.portfast', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.spanning_tree.portfast', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.spanning_tree.portfast', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.spanning_tree.portfast', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bpdu-filter'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_spanning_tree_portfast_bpdu_guard_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.spanning_tree.portfast', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.spanning_tree.portfast', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.spanning_tree.portfast', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.spanning_tree.portfast', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bpdu-guard'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_spanning_tree_portfast_portfastbasic_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.spanning_tree.portfast', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.spanning_tree.portfast', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.spanning_tree.portfast', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.spanning_tree.portfast', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'portfastbasic'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_spanning_tree_priority_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.spanning_tree', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.spanning_tree', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.spanning_tree', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.spanning_tree', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_spanning_tree_restricted_role_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.spanning_tree', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.spanning_tree', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.spanning_tree', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.spanning_tree', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'restricted-role'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_spanning_tree_restricted_tcn_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.spanning_tree', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.spanning_tree', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.spanning_tree', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.spanning_tree', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'restricted-tcn'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_spanning_tree_shutdown_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.spanning_tree', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.spanning_tree', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.spanning_tree', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.spanning_tree', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'shutdown'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_spanning_tree_vlan_cost_delete(self, port_channel=None, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vlan: id
    :param vlan: Keyword argument tuple.

    :type id: long
    :param id: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.spanning_tree.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.spanning_tree.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.spanning_tree.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.spanning_tree.vlan', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cost'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_spanning_tree_vlan_guard_root_delete(self, port_channel=None, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vlan: id
    :param vlan: Keyword argument tuple.

    :type id: long
    :param id: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel.spanning_tree.vlan', u'vlan'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel.spanning_tree.vlan', u'vlan'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel.spanning_tree.vlan', u'vlan'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel.spanning_tree.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.spanning_tree.vlan.guard', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.spanning_tree.vlan.guard', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.spanning_tree.vlan.guard', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.spanning_tree.vlan.guard', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'root'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_spanning_tree_vlan_priority_delete(self, port_channel=None, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vlan: id
    :param vlan: Keyword argument tuple.

    :type id: long
    :param id: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.spanning_tree.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.spanning_tree.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.spanning_tree.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.spanning_tree.vlan', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_speed_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'port_channel', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'speed'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_switchport_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.switchport_basic', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.switchport_basic', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.switchport_basic', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.switchport_basic', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'switchport'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_switchport_access_mac_group_vlan_classification_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.switchport.access_mac_group_vlan_classification', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.switchport.access_mac_group_vlan_classification', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.switchport.access_mac_group_vlan_classification', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.switchport.access_mac_group_vlan_classification', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_switchport_access_mac_group_vlan_classification_access_vlan_delete(self, port_channel=None, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vlan: access_vlan_id, access_mac_group
    :param vlan: Keyword argument tuple.

    :type access_vlan_id: long
    :param access_vlan_id: **vlan** tuple argument:  Set the default VLAN for the interface

        * range restriction: ::

            ['0..4294967295']

    :type access_mac_group: long
    :param access_mac_group: **vlan** tuple argument:  Associate a Mac group with a vlan

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.port_channel.switchport.access_mac_group_vlan_classification.access.vlan', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'access_vlan_id, access_mac_group', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_switchport_access_mac_vlan_classification_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.switchport.access_mac_vlan_classification', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.switchport.access_mac_vlan_classification', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.switchport.access_mac_vlan_classification', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.switchport.access_mac_vlan_classification', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_switchport_access_mac_vlan_classification_access_vlan_delete(self, port_channel=None, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vlan: access_vlan_id, access_mac_address
    :param vlan: Keyword argument tuple.

    :type access_vlan_id: long
    :param access_vlan_id: **vlan** tuple argument:  Set the default VLAN for the interface

        * range restriction: ::

            ['0..4294967295']

    :type access_mac_address: unicode
    :param access_mac_address: **vlan** tuple argument:  Associate the Mac address with a vlan

        * pattern restriction: ::

            '[0-9a-fA-F]{4}(\.[0-9a-fA-F]{4}){2}'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.port_channel.switchport.access_mac_vlan_classification.access.vlan', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'access_vlan_id, access_mac_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_switchport_access_vlan_delete(self, port_channel=None, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vlan: access_vlan_id, access_mac_group
    :param vlan: Keyword argument tuple.

    :type access_vlan_id: long
    :param access_vlan_id: **vlan** tuple argument:  Set the default VLAN for the interface

        * range restriction: ::

            ['0..4294967295']

    :type access_mac_group: long
    :param access_mac_group: **vlan** tuple argument:  Associate a Mac group with a vlan

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.switchport.access_mac_group_vlan_classification.access.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.switchport.access_mac_group_vlan_classification.access.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.switchport.access_mac_group_vlan_classification.access.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'access_vlan_id, access_mac_group', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_switchport_access_vlan_access_mac_vlan_classification_delete(self, port_channel=None, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vlan: access_vlan_id, access_mac_address
    :param vlan: Keyword argument tuple.

    :type access_vlan_id: long
    :param access_vlan_id: **vlan** tuple argument:  Set the default VLAN for the interface

        * range restriction: ::

            ['0..4294967295']

    :type access_mac_address: unicode
    :param access_mac_address: **vlan** tuple argument:  Associate the Mac address with a vlan

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.switchport.access_mac_vlan_classification.access.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.switchport.access_mac_vlan_classification.access.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.switchport.access_mac_vlan_classification.access.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'access_vlan_id, access_mac_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_switchport_basic_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.switchport_basic', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.switchport_basic', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.switchport_basic', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.switchport_basic', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_switchport_mode_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.switchport.mode', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.switchport.mode', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.switchport.mode', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.switchport.mode', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_switchport_mode_private_vlan_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.switchport.mode.private_vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.switchport.mode.private_vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.switchport.mode.private_vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_switchport_mode_private_vlan_host_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.switchport.mode.private_vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.switchport.mode.private_vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.switchport.mode.private_vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'host'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_switchport_mode_private_vlan_promiscuous_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.switchport.mode.private_vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.switchport.mode.private_vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.switchport.mode.private_vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'promiscuous'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_switchport_mode_private_vlan_trunk_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.switchport.mode.private_vlan.private_vlan_trunk', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.switchport.mode.private_vlan.private_vlan_trunk', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.switchport.mode.private_vlan.private_vlan_trunk', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_switchport_mode_private_vlan_trunk_host_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.switchport.mode.private_vlan.private_vlan_trunk', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.switchport.mode.private_vlan.private_vlan_trunk', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.switchport.mode.private_vlan.private_vlan_trunk', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'host'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_switchport_mode_private_vlan_trunk_promiscuous_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.switchport.mode.private_vlan.private_vlan_trunk', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.switchport.mode.private_vlan.private_vlan_trunk', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.switchport.mode.private_vlan.private_vlan_trunk', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'promiscuous'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_switchport_mode_private_vlan_trunk_trunk_basic_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.switchport.mode.private_vlan.private_vlan_trunk', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.switchport.mode.private_vlan.private_vlan_trunk', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.switchport.mode.private_vlan.private_vlan_trunk', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'trunk-basic'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_switchport_mode_vlan_mode_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.switchport.mode', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.switchport.mode', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.switchport.mode', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.switchport.mode', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vlan-mode'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_switchport_port_security_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.switchport.port_security', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.switchport.port_security', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.switchport.port_security', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.switchport.port_security', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_switchport_port_security_allowed_ouis_delete(self, port_channel=None, allowed_ouis=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type allowed_ouis: oui
    :param allowed_ouis: Keyword argument tuple.

    :type oui: unicode
    :param oui: **allowed_ouis** tuple argument:  <OUI> OUI in HHHH.HH00.0000 format

        * pattern restriction: ::

            '[0-9a-fA-F]{4}\.[0-9a-fA-F]{2}00\.0000'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.switchport.port_security.allowed_ouis', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.switchport.port_security.allowed_ouis', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.switchport.port_security.allowed_ouis', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'allowed_ouis', 'keyval': 'oui', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, allowed_ouis=allowed_ouis)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, allowed_ouis=allowed_ouis)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_switchport_port_security_max_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.switchport.port_security', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.switchport.port_security', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.switchport.port_security', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.switchport.port_security', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'max'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_switchport_port_security_port_secutiry_mac_address_delete(self, port_channel=None, port_secutiry_mac_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type port_secutiry_mac_address: mac_address, port_sec_vlan
    :param port_secutiry_mac_address: Keyword argument tuple.

    :type mac_address: unicode
    :param mac_address: **port_secutiry_mac_address** tuple argument:  Mac Address

    :type port_sec_vlan: long
    :param port_sec_vlan: **port_secutiry_mac_address** tuple argument:  Forwarding vlan

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.switchport.port_security.port_secutiry_mac_address', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.switchport.port_security.port_secutiry_mac_address', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.switchport.port_security.port_secutiry_mac_address', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.switchport.port_security.port_secutiry_mac_address', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'port_secutiry_mac_address', 'keyval': 'mac_address, port_sec_vlan', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, port_secutiry_mac_address=port_secutiry_mac_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, port_secutiry_mac_address=port_secutiry_mac_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_switchport_port_security_shutdown_time_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.switchport.port_security', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.switchport.port_security', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.switchport.port_security', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.switchport.port_security', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'shutdown-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_switchport_port_security_sticky_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.switchport.port_security.sticky', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.switchport.port_security.sticky', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.switchport.port_security.sticky', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_switchport_port_security_sticky_port_secutiry_mac_address_delete(self, port_channel=None, port_secutiry_mac_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type port_secutiry_mac_address: mac_address, port_sec_vlan
    :param port_secutiry_mac_address: Keyword argument tuple.

    :type mac_address: unicode
    :param mac_address: **port_secutiry_mac_address** tuple argument:  Mac Address

    :type port_sec_vlan: long
    :param port_sec_vlan: **port_secutiry_mac_address** tuple argument:  Forwarding vlan

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.switchport.port_security.sticky.port_secutiry_mac_address', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.switchport.port_security.sticky.port_secutiry_mac_address', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.switchport.port_security.sticky.port_secutiry_mac_address', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.switchport.port_security.sticky.port_secutiry_mac_address', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'port_secutiry_mac_address', 'keyval': 'mac_address, port_sec_vlan', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, port_secutiry_mac_address=port_secutiry_mac_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, port_secutiry_mac_address=port_secutiry_mac_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_switchport_port_security_sticky_sticky_flag_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.switchport.port_security.sticky', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.switchport.port_security.sticky', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.switchport.port_security.sticky', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.switchport.port_security.sticky', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'sticky-flag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_switchport_port_security_violation_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.switchport.port_security', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.switchport.port_security', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.switchport.port_security', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.switchport.port_security', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'violation'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_switchport_private_vlan_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.switchport.private_vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.switchport.private_vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.switchport.private_vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_switchport_private_vlan_association_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.switchport.private_vlan.association', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.switchport.private_vlan.association', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.switchport.private_vlan.association', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_switchport_private_vlan_association_trunk_delete(self, port_channel=None, trunk=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type trunk: trunk_pri_pvlan, trunk_sec_pvlan
    :param trunk: Keyword argument tuple.

    :type trunk_pri_pvlan: long
    :param trunk_pri_pvlan: **trunk** tuple argument:  Primary vlan id

        * range restriction: ::

            ['0..4294967295']

    :type trunk_sec_pvlan: long
    :param trunk_sec_pvlan: **trunk** tuple argument:  Secondary vlan id 

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.switchport.private_vlan.association.trunk', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.switchport.private_vlan.association.trunk', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.switchport.private_vlan.association.trunk', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'trunk', 'keyval': 'trunk_pri_pvlan, trunk_sec_pvlan', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, trunk=trunk)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, trunk=trunk)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_switchport_private_vlan_host_association_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.switchport.private_vlan.host_association', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.switchport.private_vlan.host_association', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.switchport.private_vlan.host_association', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'host_pri_pvlan, host_sec_pvlan'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_switchport_private_vlan_host_association_host_pri_pvlan_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.switchport.private_vlan.host_association', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.switchport.private_vlan.host_association', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.switchport.private_vlan.host_association', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'host-pri-pvlan'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_switchport_private_vlan_host_association_host_sec_pvlan_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.switchport.private_vlan.host_association', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.switchport.private_vlan.host_association', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.switchport.private_vlan.host_association', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'host-sec-pvlan'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_switchport_private_vlan_mapping_delete(self, port_channel=None, mapping=None, oper=None, promis_sec_pvlan_range=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type mapping: promis_pri_pvlan, oper, promis_sec_pvlan_range
    :param mapping: Keyword argument tuple.

    :type promis_pri_pvlan: long
    :param promis_pri_pvlan: **mapping** tuple argument:  Primary vlan id

        * range restriction: ::

            ['0..4294967295']

    :type oper: unicode
    :param oper: **mapping** tuple argument.

        * enumeration restriction: ::

            ['add', 'delete']

    :type promis_sec_pvlan_range: unicode
    :param promis_sec_pvlan_range: **mapping** tuple argument:  Secondary vlan range

        * length restriction: ::

            ['1..253']

        * pattern restriction: ::

            '(([1-9][0-9]{0,2})|([1-7][0-9]{3})|(80[0-9]{2})|'
            '(81[0-8][0-9])|(819[01]))(-(([2-9])|([1-9][0-9]{'
            '1,2})|([1-7][0-9]{3})|(80[0-9]{2})|(81[0-8][0-9]'
            ')|(819[01])))?((,(([2-9])|([1-9][0-9]{1,2})|([1-'
            '7][0-9]{3})|(80[0-9]{2})|(81[0-8][0-9])|(819[01]'
            '))(-(([3-9])|([1-9][0-9]{1,2})|([1-7][0-9]{3})|('
            '80[0-9]{2})|(81[0-8][0-9])|(819[01])))?)?)*'

    **Instance Argument(s)**:

    :type oper: unicode
    :param oper: Keyword argument.

        * enumeration restriction: ::

            ['add', 'delete']

    :type promis_sec_pvlan_range: unicode
    :param promis_sec_pvlan_range: Secondary vlan range

        * length restriction: ::

            ['1..253']

        * pattern restriction: ::

            '(([1-9][0-9]{0,2})|([1-7][0-9]{3})|(80[0-9]{2})|'
            '(81[0-8][0-9])|(819[01]))(-(([2-9])|([1-9][0-9]{'
            '1,2})|([1-7][0-9]{3})|(80[0-9]{2})|(81[0-8][0-9]'
            ')|(819[01])))?((,(([2-9])|([1-9][0-9]{1,2})|([1-'
            '7][0-9]{3})|(80[0-9]{2})|(81[0-8][0-9])|(819[01]'
            '))(-(([3-9])|([1-9][0-9]{1,2})|([1-7][0-9]{3})|('
            '80[0-9]{2})|(81[0-8][0-9])|(819[01])))?)?)*'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.switchport.private_vlan.mapping', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.switchport.private_vlan.mapping', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.switchport.private_vlan.mapping', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mapping', 'keyval': 'promis_pri_pvlan', 'extra_keyval': 'promis_pri_pvlan, oper, promis_sec_pvlan_range'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, mapping=mapping, oper=oper, promis_sec_pvlan_range=promis_sec_pvlan_range)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, mapping=mapping, oper=oper, promis_sec_pvlan_range=promis_sec_pvlan_range)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_switchport_private_vlan_mapping_oper_delete(self, port_channel=None, mapping=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type mapping: promis_pri_pvlan
    :param mapping: Keyword argument tuple.

    :type promis_pri_pvlan: long
    :param promis_pri_pvlan: **mapping** tuple argument:  Primary vlan id

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.switchport.private_vlan.mapping', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.switchport.private_vlan.mapping', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.switchport.private_vlan.mapping', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mapping', 'keyval': 'promis_pri_pvlan', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'oper'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, mapping=mapping)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, mapping=mapping)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_switchport_private_vlan_mapping_promis_sec_pvlan_range_delete(self, port_channel=None, mapping=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type mapping: promis_pri_pvlan
    :param mapping: Keyword argument tuple.

    :type promis_pri_pvlan: long
    :param promis_pri_pvlan: **mapping** tuple argument:  Primary vlan id

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.switchport.private_vlan.mapping', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.switchport.private_vlan.mapping', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.switchport.private_vlan.mapping', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mapping', 'keyval': 'promis_pri_pvlan', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'promis-sec-pvlan-range'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, mapping=mapping)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, mapping=mapping)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_switchport_private_vlan_trunk_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.switchport.private_vlan.trunk', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.switchport.private_vlan.trunk', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.switchport.private_vlan.trunk', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_switchport_private_vlan_trunk_allowed_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.switchport.private_vlan.trunk.allowed', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.switchport.private_vlan.trunk.allowed', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.switchport.private_vlan.trunk.allowed', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_switchport_private_vlan_trunk_allowed_trunk_private_vlan_classification_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_switchport_private_vlan_trunk_allowed_vlan_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.switchport.private_vlan.trunk.allowed.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.switchport.private_vlan.trunk.allowed.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.switchport.private_vlan.trunk.allowed.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_switchport_private_vlan_trunk_allowed_vlan_add_delete(self, port_channel=None, add=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type add: trunk_vlan_id, trunk_ctag_id
    :param add: Keyword argument tuple.

    :type trunk_vlan_id: long
    :param trunk_vlan_id: **add** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type trunk_ctag_id: long
    :param trunk_ctag_id: **add** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan.add_', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan.add_', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan.add_', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'add', 'keyval': 'trunk_vlan_id, trunk_ctag_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, add=add)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, add=add)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_switchport_private_vlan_trunk_allowed_vlan_all_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.switchport.private_vlan.trunk.allowed.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.switchport.private_vlan.trunk.allowed.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.switchport.private_vlan.trunk.allowed.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'all'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_switchport_private_vlan_trunk_allowed_vlan_except_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.switchport.private_vlan.trunk.allowed.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.switchport.private_vlan.trunk.allowed.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.switchport.private_vlan.trunk.allowed.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'except'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_switchport_private_vlan_trunk_allowed_vlan_none_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.switchport.private_vlan.trunk.allowed.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.switchport.private_vlan.trunk.allowed.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.switchport.private_vlan.trunk.allowed.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'none'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_switchport_private_vlan_trunk_allowed_vlan_remove_delete(self, port_channel=None, remove=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type remove: trunk_vlan_id, trunk_ctag_id
    :param remove: Keyword argument tuple.

    :type trunk_vlan_id: long
    :param trunk_vlan_id: **remove** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type trunk_ctag_id: long
    :param trunk_ctag_id: **remove** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan.remove_', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan.remove_', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan.remove_', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'remove', 'keyval': 'trunk_vlan_id, trunk_ctag_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, remove=remove)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, remove=remove)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_switchport_private_vlan_trunk_allowed_vlan_trunk_private_vlan_classification_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_switchport_private_vlan_trunk_native_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.switchport.private_vlan.trunk.native', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.switchport.private_vlan.trunk.native', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.switchport.private_vlan.trunk.native', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'pvlanNativevlan, pvlan_native_vlan_ctag_id'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_switchport_private_vlan_trunk_native_ctag_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.switchport.private_vlan.trunk.native', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.switchport.private_vlan.trunk.native', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.switchport.private_vlan.trunk.native', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ctag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_switchport_private_vlan_trunk_native_vlan_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.switchport.private_vlan.trunk.native', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.switchport.private_vlan.trunk.native', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.switchport.private_vlan.trunk.native', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vlan'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_switchport_private_vlan_trunk_private_vlan_classification_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.switchport.trunk_private_vlan_classification.private_vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.switchport.trunk_private_vlan_classification.private_vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.switchport.trunk_private_vlan_classification.private_vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_switchport_private_vlan_trunk_tag_native_vlan_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.switchport.private_vlan.trunk.pvlan_tag', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.switchport.private_vlan.trunk.pvlan_tag', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.switchport.private_vlan.trunk.pvlan_tag', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'native-vlan'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_switchport_private_vlan_trunk_trunk_private_vlan_classification_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.switchport.trunk_private_vlan_classification.private_vlan.trunk', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.switchport.trunk_private_vlan_classification.private_vlan.trunk', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.switchport.trunk_private_vlan_classification.private_vlan.trunk', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_switchport_trunk_allowed_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.switchport.trunk.allowed', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.switchport.trunk.allowed', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.switchport.trunk.allowed', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.switchport.trunk.allowed', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_switchport_trunk_allowed_trunk_vlan_classification_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_switchport_trunk_allowed_vlan_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.switchport.trunk.allowed.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.switchport.trunk.allowed.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.switchport.trunk.allowed.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.switchport.trunk.allowed.vlan', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_switchport_trunk_allowed_vlan_add_delete(self, port_channel=None, add=None, trunk_ctag_range=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type add: trunk_vlan_id
    :param add: Keyword argument tuple.

    :type trunk_vlan_id: long
    :param trunk_vlan_id: **add** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Argument(s)**:

    :type trunk_ctag_range: unicode
    :param trunk_ctag_range: Keyword argument.

        * length restriction: ::

            ['1..1000']

        * pattern restriction: ::

            '(([1-9][0-9]{0,2})|([1-3][0-9]{3})|(40[0-8][0-9]'
            ')|(409[0-4]))(-((1[0-9]{1,2})|([2-9][0-9]{0,2})|'
            '([1-3][0-9]{3})|(40[0-8][0-9])|(409[0-4])))?((,('
            '(1[0-9]{1,2})|([2-9][0-9]{0,2})|([1-3][0-9]{3})|'
            '(40[0-8][0-9])|(409[0-4]))(-((1[0-9]{1,2})|([2-9'
            '][0-9]{0,2})|([1-3][0-9]{3})|(40[0-8][0-9])|(409'
            '[0-4])))?)?)*'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan.add_', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan.add_', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan.add_', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'add', 'keyval': 'trunk_vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, add=add, trunk_ctag_range=trunk_ctag_range)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, add=add, trunk_ctag_range=trunk_ctag_range)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_switchport_trunk_allowed_vlan_add_ctag_delete(self, port_channel=None, add=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type add: trunk_vlan_id
    :param add: Keyword argument tuple.

    :type trunk_vlan_id: long
    :param trunk_vlan_id: **add** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan.add_', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan.add_', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan.add_', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'add', 'keyval': 'trunk_vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ctag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, add=add)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, add=add)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_switchport_trunk_allowed_vlan_all_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.switchport.trunk.allowed.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.switchport.trunk.allowed.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.switchport.trunk.allowed.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.switchport.trunk.allowed.vlan', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'all'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_switchport_trunk_allowed_vlan_except_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.switchport.trunk.allowed.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.switchport.trunk.allowed.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.switchport.trunk.allowed.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.switchport.trunk.allowed.vlan', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'except'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_switchport_trunk_allowed_vlan_none_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.switchport.trunk.allowed.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.switchport.trunk.allowed.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.switchport.trunk.allowed.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.switchport.trunk.allowed.vlan', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'none'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_switchport_trunk_allowed_vlan_remove_delete(self, port_channel=None, remove=None, trunk_ctag_range=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type remove: trunk_vlan_id
    :param remove: Keyword argument tuple.

    :type trunk_vlan_id: long
    :param trunk_vlan_id: **remove** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Argument(s)**:

    :type trunk_ctag_range: unicode
    :param trunk_ctag_range: Keyword argument.

        * length restriction: ::

            ['1..1000']

        * pattern restriction: ::

            '(([1-9][0-9]{0,2})|([1-3][0-9]{3})|(40[0-8][0-9]'
            ')|(409[0-4]))(-((1[0-9]{1,2})|([2-9][0-9]{0,2})|'
            '([1-3][0-9]{3})|(40[0-8][0-9])|(409[0-4])))?((,('
            '(1[0-9]{1,2})|([2-9][0-9]{0,2})|([1-3][0-9]{3})|'
            '(40[0-8][0-9])|(409[0-4]))(-((1[0-9]{1,2})|([2-9'
            '][0-9]{0,2})|([1-3][0-9]{3})|(40[0-8][0-9])|(409'
            '[0-4])))?)?)*'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan.remove_', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan.remove_', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan.remove_', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'remove', 'keyval': 'trunk_vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, remove=remove, trunk_ctag_range=trunk_ctag_range)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, remove=remove, trunk_ctag_range=trunk_ctag_range)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_switchport_trunk_allowed_vlan_remove_ctag_delete(self, port_channel=None, remove=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type remove: trunk_vlan_id
    :param remove: Keyword argument tuple.

    :type trunk_vlan_id: long
    :param trunk_vlan_id: **remove** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan.remove_', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan.remove_', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan.remove_', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'remove', 'keyval': 'trunk_vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ctag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, remove=remove)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, remove=remove)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_switchport_trunk_allowed_vlan_trunk_vlan_classification_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_switchport_trunk_allowed_vlanoper_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.switchport.trunk.allowed.vlanoper', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.switchport.trunk.allowed.vlanoper', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.switchport.trunk.allowed.vlanoper', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.switchport.trunk.allowed.vlanoper', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_switchport_trunk_allowed_vlanoper_vlan_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.switchport.trunk.allowed.vlanoper.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.switchport.trunk.allowed.vlanoper.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.switchport.trunk.allowed.vlanoper.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.switchport.trunk.allowed.vlanoper.vlan', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_switchport_trunk_allowed_vlanoper_vlan_add_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.switchport.trunk.allowed.vlanoper.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.switchport.trunk.allowed.vlanoper.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.switchport.trunk.allowed.vlanoper.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.switchport.trunk.allowed.vlanoper.vlan', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'add'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_switchport_trunk_allowed_vlanoper_vlan_remove_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.switchport.trunk.allowed.vlanoper.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.switchport.trunk.allowed.vlanoper.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.switchport.trunk.allowed.vlanoper.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.switchport.trunk.allowed.vlanoper.vlan', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'remove'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_switchport_trunk_ctag_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.switchport.trunk.native_vlan_classification', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.switchport.trunk.native_vlan_classification', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.switchport.trunk.native_vlan_classification', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.switchport.trunk.native_vlan_classification', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ctag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_switchport_trunk_ctag_native_vlan_xtagged_config_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.switchport.trunk.native_vlan_xtagged_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.switchport.trunk.native_vlan_xtagged_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.switchport.trunk.native_vlan_xtagged_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.switchport.trunk.native_vlan_xtagged_config', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ctag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_switchport_trunk_default_vlan_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.switchport.trunk.default_vlan_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.switchport.trunk.default_vlan_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.switchport.trunk.default_vlan_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.switchport.trunk.default_vlan_config', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'default-vlan'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_switchport_trunk_default_vlan_config_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.switchport.trunk.default_vlan_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.switchport.trunk.default_vlan_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.switchport.trunk.default_vlan_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.switchport.trunk.default_vlan_config', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'default_transparent_vlan'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_switchport_trunk_egress_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.switchport.trunk.native_vlan_xtagged_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.switchport.trunk.native_vlan_xtagged_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.switchport.trunk.native_vlan_xtagged_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.switchport.trunk.native_vlan_xtagged_config', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'egress'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_switchport_trunk_native_vlan_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.switchport.trunk.native_vlan_classification', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.switchport.trunk.native_vlan_classification', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.switchport.trunk.native_vlan_classification', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.switchport.trunk.native_vlan_classification', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'native-vlan'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_switchport_trunk_native_vlan_classification_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.switchport.trunk.native_vlan_classification', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.switchport.trunk.native_vlan_classification', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.switchport.trunk.native_vlan_classification', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.switchport.trunk.native_vlan_classification', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'native_vlan_id, native_vlan_ctag_id'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_switchport_trunk_native_vlan_untagged_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.switchport.trunk.native_vlan_untagged_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.switchport.trunk.native_vlan_untagged_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.switchport.trunk.native_vlan_untagged_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.switchport.trunk.native_vlan_untagged_config', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'native-vlan-untagged'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_switchport_trunk_native_vlan_untagged_config_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.switchport.trunk.native_vlan_untagged_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.switchport.trunk.native_vlan_untagged_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.switchport.trunk.native_vlan_untagged_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.switchport.trunk.native_vlan_untagged_config', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'native_vlan_id_untagged'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_switchport_trunk_native_vlan_xtagged_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.switchport.trunk.native_vlan_xtagged_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.switchport.trunk.native_vlan_xtagged_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.switchport.trunk.native_vlan_xtagged_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.switchport.trunk.native_vlan_xtagged_config', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'native-vlan-xtagged'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_switchport_trunk_native_vlan_xtagged_config_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.switchport.trunk.native_vlan_xtagged_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.switchport.trunk.native_vlan_xtagged_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.switchport.trunk.native_vlan_xtagged_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.switchport.trunk.native_vlan_xtagged_config', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_switchport_trunk_private_vlan_classification_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.switchport.trunk_private_vlan_classification', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.switchport.trunk_private_vlan_classification', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.switchport.trunk_private_vlan_classification', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_switchport_trunk_tag_native_vlan_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.switchport.trunk.tag', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.switchport.trunk.tag', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.switchport.trunk.tag', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.switchport.trunk.tag', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'native-vlan'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_switchport_trunk_trunk_vlan_classification_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.switchport.trunk.trunk_vlan_classification', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.switchport.trunk.trunk_vlan_classification', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.switchport.trunk.trunk_vlan_classification', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.switchport.trunk.trunk_vlan_classification', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_switchport_trunk_trunk_vlan_classification_allowed_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_switchport_trunk_trunk_vlan_classification_allowed_vlan_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_switchport_trunk_trunk_vlan_classification_allowed_vlan_add_delete(self, port_channel=None, add=None, trunk_ctag_range=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type add: trunk_vlan_id
    :param add: Keyword argument tuple.

    :type trunk_vlan_id: long
    :param trunk_vlan_id: **add** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Argument(s)**:

    :type trunk_ctag_range: unicode
    :param trunk_ctag_range: Keyword argument.

        * length restriction: ::

            ['1..1000']

        * pattern restriction: ::

            '(([1-9][0-9]{0,2})|([1-3][0-9]{3})|(40[0-8][0-9]'
            ')|(409[0-4]))(-((1[0-9]{1,2})|([2-9][0-9]{0,2})|'
            '([1-3][0-9]{3})|(40[0-8][0-9])|(409[0-4])))?((,('
            '(1[0-9]{1,2})|([2-9][0-9]{0,2})|([1-3][0-9]{3})|'
            '(40[0-8][0-9])|(409[0-4]))(-((1[0-9]{1,2})|([2-9'
            '][0-9]{0,2})|([1-3][0-9]{3})|(40[0-8][0-9])|(409'
            '[0-4])))?)?)*'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan.add_', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'add', 'keyval': 'trunk_vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, add=add, trunk_ctag_range=trunk_ctag_range)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, add=add, trunk_ctag_range=trunk_ctag_range)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_switchport_trunk_trunk_vlan_classification_allowed_vlan_add_ctag_delete(self, port_channel=None, add=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type add: trunk_vlan_id
    :param add: Keyword argument tuple.

    :type trunk_vlan_id: long
    :param trunk_vlan_id: **add** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan.add_', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'add', 'keyval': 'trunk_vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ctag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, add=add)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, add=add)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_switchport_trunk_trunk_vlan_classification_allowed_vlan_remove_delete(self, port_channel=None, remove=None, trunk_ctag_range=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type remove: trunk_vlan_id
    :param remove: Keyword argument tuple.

    :type trunk_vlan_id: long
    :param trunk_vlan_id: **remove** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Argument(s)**:

    :type trunk_ctag_range: unicode
    :param trunk_ctag_range: Keyword argument.

        * length restriction: ::

            ['1..1000']

        * pattern restriction: ::

            '(([1-9][0-9]{0,2})|([1-3][0-9]{3})|(40[0-8][0-9]'
            ')|(409[0-4]))(-((1[0-9]{1,2})|([2-9][0-9]{0,2})|'
            '([1-3][0-9]{3})|(40[0-8][0-9])|(409[0-4])))?((,('
            '(1[0-9]{1,2})|([2-9][0-9]{0,2})|([1-3][0-9]{3})|'
            '(40[0-8][0-9])|(409[0-4]))(-((1[0-9]{1,2})|([2-9'
            '][0-9]{0,2})|([1-3][0-9]{3})|(40[0-8][0-9])|(409'
            '[0-4])))?)?)*'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan.remove_', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'remove', 'keyval': 'trunk_vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, remove=remove, trunk_ctag_range=trunk_ctag_range)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, remove=remove, trunk_ctag_range=trunk_ctag_range)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_switchport_trunk_trunk_vlan_classification_allowed_vlan_remove_ctag_delete(self, port_channel=None, remove=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type remove: trunk_vlan_id
    :param remove: Keyword argument tuple.

    :type trunk_vlan_id: long
    :param trunk_vlan_id: **remove** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan.remove_', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'remove', 'keyval': 'trunk_vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ctag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, remove=remove)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, remove=remove)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_track_enable_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.track', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.track', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.track', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.track', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_track_interface_delete(self, port_channel=None, interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type interface: track_interface_type, track_interface_name
    :param interface: Keyword argument tuple.

    :type track_interface_type: unicode
    :param track_interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 'port-channel']

    :type track_interface_name: unicode
    :param track_interface_name: **interface** tuple argument:  Interface name

        * pattern restriction: ::

            '(((([1-9]|[1-9][0-9]|1[0-9]{2}|2[0-3][0-9])/)?(('
            '[0-9]|1[0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0-9]'
            ')(:[1-4])?)|([1-9]|[1-9][0-9]|[1-9][0-9]{2}|[1-5'
            '][0-9]{3}|6[0-1][0-4]{2}))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.track.interface', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.track.interface', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.track.interface', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.track.interface', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'track_interface_type, track_interface_name', 'extra_keyval': 'track_interface_type, track_interface_name'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, interface=interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_track_min_link_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.track', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.track', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.track', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.track', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'min-link'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_track_remove_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.track.remove_', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.track.remove_', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.track.remove_', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.track.remove_', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_track_remove_all_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.track.remove_', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.track.remove_', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.track.remove_', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.track.remove_', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'all'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_tunnel_tagged_ieee_bpdu_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.tunnel', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.tunnel', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.tunnel', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tagged-ieee-bpdu'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_vlag_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.vlag', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.vlag', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.vlag', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.vlag', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_vlag_ignore_split_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.vlag', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.vlag', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.vlag', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.vlag', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ignore-split'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_vlan_classifier_activate_group_delete(self, port_channel=None, group=None, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type group: groupid, vlan
    :param group: Keyword argument tuple.

    :type groupid: long
    :param groupid: **group** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vlan: long
    :param vlan: **group** tuple argument:  1-8191;;Vlan

        * range restriction: ::

            ['0..4294967295']

    **Instance Argument(s)**:

    :type vlan: long
    :param vlan: 1-8191;;Vlan

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.vlan.classifier.activate.group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.vlan.classifier.activate.group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.vlan.classifier.activate.group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'group', 'keyval': 'groupid', 'extra_keyval': 'groupid, vlan'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, group=group, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, group=group, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_vlan_classifier_activate_group_vlan_delete(self, port_channel=None, group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type group: groupid
    :param group: Keyword argument tuple.

    :type groupid: long
    :param groupid: **group** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.vlan.classifier.activate.group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.vlan.classifier.activate.group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.vlan.classifier.activate.group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'group', 'keyval': 'groupid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vlan'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, group=group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, group=group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_vrf_forwarding_delete(self, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.vrf', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.vrf', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'forwarding'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_vrrp_group_delete(self, port_channel=None, vrrp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.hide_vrrp_holer.vrrp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.vrrp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.vrrp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.hide_vrrp_holer.vrrp', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v16r_1_00b.interface.port_channel.hide_vrrp_holer.vrrp": {"enable": "enable", "version": "version", "vrid": "vrid", "priority": "priority", "advertisement_interval": "advertisement_interval", "hold_time": "hold_time", "preempt_mode": "preempt_mode", "description": "description"}, "pybind.nos.v7_0_1b.interface.port_channel.vrrp": {}, "pybind.nos.v7_1_0.interface.port_channel.vrrp": {}, "pybind.nos.v6_0_2c.interface.port_channel.hide_vrrp_holer.vrrp": {"enable": "enable", "version": "version", "vrid": "vrid", "priority": "priority", "advertisement_interval": "advertisement_interval", "hold_time": "hold_time", "preempt_mode": "preempt_mode", "description": "description"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, vrrp=vrrp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_vrrp_group_advertisement_interval_delete(self, port_channel=None, vrrp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.hide_vrrp_holer.vrrp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.vrrp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.vrrp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.hide_vrrp_holer.vrrp', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'advertisement-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, vrrp=vrrp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_vrrp_group_arp_unicast_request_receive_delete(self, port_channel=None, vrrp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel.hide_vrrp_holer.vrrp', u'vrrp'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel.hide_vrrp_holer.vrrp', u'vrrp'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel.vrrp', u'vrrp'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel.vrrp', u'vrrp')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.hide_vrrp_holer.vrrp.arp.unicast_request', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.vrrp.arp.unicast_request', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.vrrp.arp.unicast_request', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.hide_vrrp_holer.vrrp.arp.unicast_request', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'receive'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, vrrp=vrrp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_vrrp_group_description_delete(self, port_channel=None, vrrp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.hide_vrrp_holer.vrrp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.vrrp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.vrrp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.hide_vrrp_holer.vrrp', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'description'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, vrrp=vrrp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_vrrp_group_enable_delete(self, port_channel=None, vrrp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.hide_vrrp_holer.vrrp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.vrrp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.vrrp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.hide_vrrp_holer.vrrp', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, vrrp=vrrp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_vrrp_group_hold_time_delete(self, port_channel=None, vrrp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.hide_vrrp_holer.vrrp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.vrrp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.vrrp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.hide_vrrp_holer.vrrp', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hold-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, vrrp=vrrp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_vrrp_group_preempt_mode_delete(self, port_channel=None, vrrp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.hide_vrrp_holer.vrrp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.vrrp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.vrrp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.hide_vrrp_holer.vrrp', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'preempt-mode'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, vrrp=vrrp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_vrrp_group_priority_delete(self, port_channel=None, vrrp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.hide_vrrp_holer.vrrp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.vrrp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.vrrp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.hide_vrrp_holer.vrrp', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, vrrp=vrrp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_vrrp_group_track_interface_delete(self, port_channel=None, vrrp=None, interface=None, track_priority=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Argument(s)**:

    :type track_priority: int
    :param track_priority: Track Priority

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel.hide_vrrp_holer.vrrp', u'vrrp'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel.hide_vrrp_holer.vrrp', u'vrrp'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel.vrrp', u'vrrp'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel.vrrp', u'vrrp')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.hide_vrrp_holer.vrrp.track.interface', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.vrrp.track.interface', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.vrrp.track.interface', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.hide_vrrp_holer.vrrp.track.interface', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, vrrp=vrrp, interface=interface, track_priority=track_priority)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, vrrp=vrrp, interface=interface, track_priority=track_priority)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_vrrp_group_track_interface_priority_delete(self, port_channel=None, vrrp=None, interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel.hide_vrrp_holer.vrrp', u'vrrp'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel.hide_vrrp_holer.vrrp', u'vrrp'), ('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel.vrrp', u'vrrp'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel.vrrp', u'vrrp')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.hide_vrrp_holer.vrrp.track.interface', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.vrrp.track.interface', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.vrrp.track.interface', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.hide_vrrp_holer.vrrp.track.interface', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, vrrp=vrrp, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, vrrp=vrrp, interface=interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_vrrp_group_use_v2_checksum_delete(self, port_channel=None, vrrp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.port_channel.vrrp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.vrrp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'use-v2-checksum'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, vrrp=vrrp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_port_channel_vrrp_group_virtual_ip_delete(self, port_channel=None, vrrp=None, virtual_ip=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type virtual_ip: virtual_ipaddr
    :param virtual_ip: Keyword argument tuple.

    :type virtual_ipaddr: unicode
    :param virtual_ipaddr: **virtual_ip** tuple argument:  Virtual IPv4 address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.port_channel', u'port_channel'), ('pybind.nos.v7_0_1b.interface.port_channel.vrrp', u'vrrp'), ('pybind.slxos.v16r_1_00b.interface.port_channel', u'port_channel'), ('pybind.slxos.v16r_1_00b.interface.port_channel.hide_vrrp_holer.vrrp', u'vrrp'), ('pybind.nos.v6_0_2c.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2c.interface.port_channel.hide_vrrp_holer.vrrp', u'vrrp'), ('pybind.nos.v7_1_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_1_0.interface.port_channel.vrrp', u'vrrp')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.port_channel.hide_vrrp_holer.vrrp.virtual_ip', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.port_channel.vrrp.virtual_ip', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.port_channel.vrrp.virtual_ip', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface.port_channel.hide_vrrp_holer.vrrp.virtual_ip', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'virtual_ip', 'keyval': 'virtual_ipaddr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, vrrp=vrrp, virtual_ip=virtual_ip)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, vrrp=vrrp, virtual_ip=virtual_ip)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_bfd_interval_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.bfd.interval', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.bfd.interval', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.bfd.interval', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_bfd_interval_min_rx_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.bfd.interval', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.bfd.interval', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.bfd.interval', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'min-rx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_bfd_interval_min_tx_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.bfd.interval', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.bfd.interval', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.bfd.interval', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'min-tx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_bfd_interval_multiplier_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.bfd.interval', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.bfd.interval', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.bfd.interval', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'multiplier'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_bfd_shutdown_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.bfd', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.bfd', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.bfd', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'shutdown'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_bpdu_drop_direction_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.bpdu_drop', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.bpdu_drop', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.bpdu_drop', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'direction'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_bpdu_drop_enable_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.bpdu_drop', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.bpdu_drop', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.bpdu_drop', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_cee_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Instance Keyword Argument Tuple**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tengigabitethernet', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cee'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_channel_group_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.channel_group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.channel_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.channel_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'port_int, mode, type'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_channel_group_mode_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.channel_group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.channel_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.channel_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mode'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_channel_group_port_int_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.channel_group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.channel_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.channel_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'port-int'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_channel_group_type_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.channel_group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.channel_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.channel_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_description_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Instance Keyword Argument Tuple**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tengigabitethernet', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'description'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_deviceconnectivity_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.connectivity', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.connectivity', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.connectivity', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'deviceconnectivity'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_dot1x_authentication_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.dot1x', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.dot1x', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.dot1x', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'authentication'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_dot1x_mac_auth_bypass_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet.dot1x', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mac-auth-bypass'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_dot1x_mac_auth_enable_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet.dot1x', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mac-auth-enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_dot1x_port_control_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.dot1x', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.dot1x', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.dot1x', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'port-control'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_dot1x_protocol_version_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.dot1x', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.dot1x', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.dot1x', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'protocol-version'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_dot1x_quiet_period_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.dot1x', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.dot1x', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.dot1x', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'quiet-period'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_dot1x_reauthentication_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.dot1x', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.dot1x', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.dot1x', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'reauthentication'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_dot1x_reauthmax_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.dot1x', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.dot1x', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.dot1x', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'reauthMax'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_dot1x_timeout_re_authperiod_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.dot1x.timeout', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.dot1x.timeout', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.dot1x.timeout', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 're-authperiod'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_dot1x_timeout_server_timeout_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.dot1x.timeout', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.dot1x.timeout', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.dot1x.timeout', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'server-timeout'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_dot1x_timeout_supp_timeout_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.dot1x.timeout', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.dot1x.timeout', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.dot1x.timeout', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'supp-timeout'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_dot1x_timeout_tx_period_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.dot1x.timeout', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.dot1x.timeout', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.dot1x.timeout', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tx-period'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_edge_loop_detection_port_priority_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.edge_loop_detection', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.edge_loop_detection', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.edge_loop_detection', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'port-priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_edge_loop_detection_vlan_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.edge_loop_detection', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.edge_loop_detection', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.edge_loop_detection', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vlan'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_fabric_dport_enable_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.fabric.fabric_dport', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_fabric_dport_mode_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet.fabric.fabric_dport', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.fabric.fabric_dport', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mode'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_fabric_isl_enable_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.fabric.fabric_isl', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.fabric.fabric_isl', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.fabric.fabric_isl', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_fabric_neighbor_discovery_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.fabric.neighbor_discovery', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.fabric.neighbor_discovery', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.fabric.neighbor_discovery', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_fabric_neighbor_discovery_disable_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.fabric.neighbor_discovery', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.fabric.neighbor_discovery', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.fabric.neighbor_discovery', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'disable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_fabric_trunk_enable_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.fabric.fabric_trunk', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.fabric.fabric_trunk', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.fabric.fabric_trunk', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_fcoeport_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.fcoeport', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.fcoeport', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.fcoeport', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'fcoeport_map, ns_ip_registration'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_fcoeport_map_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.fcoeport', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.fcoeport', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.fcoeport', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_fcoeport_ns_ip_registration_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.fcoeport', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.fcoeport', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.fcoeport', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ns-ip-registration'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ifindex_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Instance Keyword Argument Tuple**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tengigabitethernet', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ifindex'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ip_access_group_delete(self, tengigabitethernet=None, access_group=None, traffic_type=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type access_group: ip_access_list, ip_direction, traffic_type
    :param access_group: Keyword argument tuple.

    :type ip_access_list: unicode
    :param ip_access_list: **access_group** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type ip_direction: unicode
    :param ip_direction: **access_group** tuple argument.

        * enumeration restriction: ::

            ['in', 'out']

    :type traffic_type: unicode
    :param traffic_type: **access_group** tuple argument.

        * enumeration restriction: ::

            ['switched', 'routed']

    **Instance Argument(s)**:

    :type traffic_type: unicode
    :param traffic_type: Keyword argument.

        * enumeration restriction: ::

            ['switched', 'routed']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ip_acl_interface.ip.access_group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ip_acl_interface.ip.access_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ip_acl_interface.ip.access_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'access_group', 'keyval': 'ip_access_list, ip_direction', 'extra_keyval': 'ip_access_list, ip_direction, traffic_type'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, access_group=access_group, traffic_type=traffic_type)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, access_group=access_group, traffic_type=traffic_type)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ip_acl_interface_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ip_acl_interface', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ip_acl_interface', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ip_acl_interface', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ip_address_delete(self, tengigabitethernet=None, address=None, secondary=None, ospf_passive=None, ospf_ignore=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type address: address, secondary, ospf_passive, ospf_ignore
    :param address: Keyword argument tuple.

    :type address: unicode
    :param address: **address** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]'
            '|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0'
            '-4][0-9]|25[0-5])/(([1-9])|([1-2][0-9])|(3[0-1])'
            ')'

    :type secondary: YANGBool
    :param secondary: **address** tuple argument:  Secondary ip address on the specific interface

    :type ospf_passive: YANGBool
    :param ospf_passive: **address** tuple argument:  ospf pasive address on the specific interface

    :type ospf_ignore: YANGBool
    :param ospf_ignore: **address** tuple argument:  ospf active address on the specific interface

    **Instance Argument(s)**:

    :type secondary: YANGBool
    :param secondary: Secondary ip address on the specific interface

    :type ospf_passive: YANGBool
    :param ospf_passive: ospf pasive address on the specific interface

    :type ospf_ignore: YANGBool
    :param ospf_ignore: ospf active address on the specific interface

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ip.ip_config.address', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ip.ip_config.address', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ip.ip_config.address', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'address', 'keyval': 'address', 'extra_keyval': 'address, secondary, ospf_passive, ospf_ignore'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, address=address, secondary=secondary, ospf_passive=ospf_passive, ospf_ignore=ospf_ignore)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, address=address, secondary=secondary, ospf_passive=ospf_passive, ospf_ignore=ospf_ignore)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ip_address_ospf_ignore_delete(self, tengigabitethernet=None, address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type address: address
    :param address: Keyword argument tuple.

    :type address: unicode
    :param address: **address** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]'
            '|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0'
            '-4][0-9]|25[0-5])/(([1-9])|([1-2][0-9])|(3[0-1])'
            ')'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ip.ip_config.address', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ip.ip_config.address', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ip.ip_config.address', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'address', 'keyval': 'address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ospf-ignore'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, address=address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, address=address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ip_address_ospf_passive_delete(self, tengigabitethernet=None, address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type address: address
    :param address: Keyword argument tuple.

    :type address: unicode
    :param address: **address** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]'
            '|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0'
            '-4][0-9]|25[0-5])/(([1-9])|([1-2][0-9])|(3[0-1])'
            ')'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ip.ip_config.address', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ip.ip_config.address', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ip.ip_config.address', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'address', 'keyval': 'address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ospf-passive'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, address=address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, address=address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ip_address_secondary_delete(self, tengigabitethernet=None, address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type address: address
    :param address: Keyword argument tuple.

    :type address: unicode
    :param address: **address** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]'
            '|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0'
            '-4][0-9]|25[0-5])/(([1-9])|([1-2][0-9])|(3[0-1])'
            ')'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ip.ip_config.address', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ip.ip_config.address', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ip.ip_config.address', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'address', 'keyval': 'address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'secondary'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, address=address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, address=address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ip_arp_aging_timeout_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ip.ip_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ip.ip_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ip.ip_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'arp-aging-timeout'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ip_arp_inspection_trust_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ip.arp_node_config.arp.inspection', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ip.arp_node_config.arp.inspection', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ip.arp_node_config.arp.inspection', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'trust'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ip_arp_ip_config_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet.ip.ip_config.arp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ip.ip_config.arp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ip_arp_learn_any_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet.ip.ip_config.arp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ip.ip_config.arp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'learn-any'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ip_arp_node_config_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ip.arp_node_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ip.arp_node_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ip.arp_node_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ip_dhcp_relay_gateway_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ip.interface_te_dhcp_conf.dhcp.relay', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ip.interface_te_dhcp_conf.dhcp.relay', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ip.interface_te_dhcp_conf.dhcp.relay', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'gateway'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ip_dhcp_relay_servers_delete(self, tengigabitethernet=None, servers=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type servers: relay_ip_addr, server_vrf_name
    :param servers: Keyword argument tuple.

    :type relay_ip_addr: unicode
    :param relay_ip_addr: **servers** tuple argument:  A.B.C.D;; IP address of the DHCP server

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type server_vrf_name: unicode
    :param server_vrf_name: **servers** tuple argument:  VRF name of the DHCP server

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ip.interface_te_dhcp_conf.dhcp.relay.servers', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ip.interface_te_dhcp_conf.dhcp.relay.servers', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ip.interface_te_dhcp_conf.dhcp.relay.servers', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'servers', 'keyval': 'relay_ip_addr, server_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, servers=servers)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, servers=servers)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ip_directed_broadcast_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ip.ip_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ip.ip_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ip.ip_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'directed-broadcast'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ip_icmp_address_mask_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ip.icmp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ip.icmp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ip.icmp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'address-mask'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ip_icmp_echo_reply_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ip.icmp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ip.icmp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ip.icmp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'echo-reply'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ip_icmp_rate_limiting_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ip.icmp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ip.icmp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ip.icmp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rate-limiting'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ip_icmp_redirect_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ip.icmp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ip.icmp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ip.icmp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redirect'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ip_icmp_unreachable_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ip.icmp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ip.icmp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ip.icmp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'unreachable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ip_igmp_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v6_0_2c.interface.tengigabitethernet.ip.igmp_phy_intf_cfg.igmp": {"immediate_leave": "immediate_leave", "last_member_query_interval": "last_member_query_interval", "query_interval": "query_interval", "query_max_response_time": "query_max_response_time"}, "pybind.nos.v7_0_1b.interface.tengigabitethernet.ip.igmp_phy_intf_cfg.igmp": {}, "pybind.nos.v7_1_0.interface.tengigabitethernet.ip.igmp_phy_intf_cfg.igmp": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ip_igmp_immediate_leave_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'immediate-leave'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ip_igmp_last_member_query_count_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'last-member-query-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ip_igmp_last_member_query_interval_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'last-member-query-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ip_igmp_phy_intf_cfg_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ip.igmp_phy_intf_cfg', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ip.igmp_phy_intf_cfg', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ip.igmp_phy_intf_cfg', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ip_igmp_query_interval_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'query-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ip_igmp_query_max_response_time_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'query-max-response-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ip_igmp_robustness_variable_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'robustness-variable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ip_igmp_startup_query_count_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'startup-query-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ip_igmp_startup_query_interval_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'startup-query-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ip_igmp_static_group_delete(self, tengigabitethernet=None, static_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type static_group: sg_addr
    :param static_group: Keyword argument tuple.

    :type sg_addr: unicode
    :param sg_addr: **static_group** tuple argument:  Multicast Address to be Joined in the format A.B.C.D

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ip.igmp_phy_intf_cfg.igmp.static_group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ip.igmp_phy_intf_cfg.igmp.static_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ip.igmp_phy_intf_cfg.igmp.static_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'static_group', 'keyval': 'sg_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, static_group=static_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, static_group=static_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ip_interface_te_dhcp_conf_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ip.interface_te_dhcp_conf', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ip.interface_te_dhcp_conf', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ip.interface_te_dhcp_conf', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ip_interface_te_ospf_conf_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ip.interface_te_ospf_conf', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ip.interface_te_ospf_conf', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ip.interface_te_ospf_conf', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ip_ip_config_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ip.ip_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ip.ip_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ip.ip_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ip_mtu_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ip.ip_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ip.ip_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ip.ip_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mtu'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ip_multicast_boundary_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'multicast-boundary'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ip_ospf_active_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'active'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ip_ospf_area_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'area'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ip_ospf_auth_change_wait_time_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'auth-change-wait-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ip_ospf_authentication_key_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.authentication_key', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.authentication_key', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.authentication_key', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ip_ospf_authentication_key_auth_key_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.authentication_key.auth_key_table', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.authentication_key.auth_key_table', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.authentication_key.auth_key_table', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'auth-key'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ip_ospf_authentication_key_auth_key_table_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.authentication_key.auth_key_table', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.authentication_key.auth_key_table', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.authentication_key.auth_key_table', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'encrypttype, auth_key'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ip_ospf_authentication_key_encrypttype_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.authentication_key.auth_key_table', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.authentication_key.auth_key_table', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.authentication_key.auth_key_table', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'encrypttype'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ip_ospf_authentication_key_no_encrypt_auth_key_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.authentication_key.no_encrypt_auth_key_table', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.authentication_key.no_encrypt_auth_key_table', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.authentication_key.no_encrypt_auth_key_table', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'no-encrypt-auth-key'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ip_ospf_authentication_key_no_encrypt_auth_key_table_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.authentication_key.no_encrypt_auth_key_table', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.authentication_key.no_encrypt_auth_key_table', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.authentication_key.no_encrypt_auth_key_table', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ip_ospf_bfd_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.bfd', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.bfd', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.bfd', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ip_ospf_bfd_intf_bfd_enable_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.bfd', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.bfd', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.bfd', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'intf-bfd-enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ip_ospf_cost_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cost'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ip_ospf_database_filter_all_external_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'all-external'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ip_ospf_database_filter_all_out_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'all-out'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ip_ospf_database_filter_all_summary_external_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'all-summary-external'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ip_ospf_dead_interval_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dead-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ip_ospf_hello_interval_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hello-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ip_ospf_md5_authentication_key_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.md5_authentication.no_encrypt_key_table', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.md5_authentication.no_encrypt_key_table', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.md5_authentication.no_encrypt_key_table', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'key'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ip_ospf_md5_authentication_key_activation_wait_time_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.md5_authentication', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.md5_authentication', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.md5_authentication', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'key-activation-wait-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ip_ospf_md5_authentication_key_id_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.md5_authentication.no_encrypt_key_table', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.md5_authentication.no_encrypt_key_table', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.md5_authentication.no_encrypt_key_table', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'key-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ip_ospf_md5_authentication_key_id_key_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.md5_authentication.key_table', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.md5_authentication.key_table', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.md5_authentication.key_table', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'key'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ip_ospf_md5_authentication_key_id_key_id_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.md5_authentication.key_table', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.md5_authentication.key_table', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.md5_authentication.key_table', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'key-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ip_ospf_md5_authentication_key_id_md5_authentication_key_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.md5_authentication.key_table', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.md5_authentication.key_table', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.md5_authentication.key_table', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'md5-authentication-key'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ip_ospf_mtu_ignore_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mtu-ignore'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ip_ospf_network_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'network'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ip_ospf_passive_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'passive'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ip_ospf_priority_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ip_ospf_retransmit_interval_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'retransmit-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ip_ospf_transmit_delay_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'transmit-delay'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ip_pbr_interface_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ip_pbr_interface', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ip_pbr_interface', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ip_pbr_interface', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ip_pim_dr_priority_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd.pim', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd.pim', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd.pim', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dr-priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ip_pim_int_cmd_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ip_pim_intf_phy_cont_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ip.pim_intf_phy_cont', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ip.pim_intf_phy_cont', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ip.pim_intf_phy_cont', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ip_pim_multinet_enable_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd.pim.multinet', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ip_pim_neighbor_filter_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd.pim', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd.pim', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd.pim', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'neighbor-filter'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ip_pim_sparse_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'pim-sparse'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ip_policy_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ip_pbr_interface.ip.policy', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ip_pbr_interface.ip.policy', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ip_pbr_interface.ip.policy', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ip_policy_route_map_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ip_pbr_interface.ip.policy.route_map', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ip_pbr_interface.ip.policy.route_map', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ip_pbr_interface.ip.policy.route_map', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ip_policy_route_map_route_map_name_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ip_pbr_interface.ip.policy.route_map', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ip_pbr_interface.ip.policy.route_map', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ip_pbr_interface.ip.policy.route_map', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ip_proxy_arp_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ip.ip_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ip.ip_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ip.ip_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'proxy-arp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ip_unnumbered_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet.ip.ip_config.unnumbered', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ip.ip_config.unnumbered', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'ip_donor_interface_type, ip_donor_interface_name'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ip_unnumbered_ip_donor_interface_name_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet.ip.ip_config.unnumbered', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ip.ip_config.unnumbered', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ip-donor-interface-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ip_unnumbered_ip_donor_interface_type_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet.ip.ip_config.unnumbered', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ip.ip_config.unnumbered', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ip-donor-interface-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_access_group_delete(self, tengigabitethernet=None, access_group=None, traffic_type=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type access_group: ipv6_access_list, ip_direction, traffic_type
    :param access_group: Keyword argument tuple.

    :type ipv6_access_list: unicode
    :param ipv6_access_list: **access_group** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type ip_direction: unicode
    :param ip_direction: **access_group** tuple argument.

        * enumeration restriction: ::

            ['in', 'out']

    :type traffic_type: unicode
    :param traffic_type: **access_group** tuple argument.

        * enumeration restriction: ::

            ['switched', 'routed']

    **Instance Argument(s)**:

    :type traffic_type: unicode
    :param traffic_type: Keyword argument.

        * enumeration restriction: ::

            ['switched', 'routed']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.access_group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.access_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.access_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'access_group', 'keyval': 'ipv6_access_list, ip_direction', 'extra_keyval': 'ipv6_access_list, ip_direction, traffic_type'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, access_group=access_group, traffic_type=traffic_type)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, access_group=access_group, traffic_type=traffic_type)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_access_group_traffic_type_delete(self, tengigabitethernet=None, access_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type access_group: ipv6_access_list, ip_direction
    :param access_group: Keyword argument tuple.

    :type ipv6_access_list: unicode
    :param ipv6_access_list: **access_group** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type ip_direction: unicode
    :param ip_direction: **access_group** tuple argument.

        * enumeration restriction: ::

            ['in', 'out']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.access_group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.access_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.access_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'access_group', 'keyval': 'ipv6_access_list, ip_direction', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'traffic-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, access_group=access_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, access_group=access_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_address_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.ipv6_config.address', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.ipv6_config.address', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.ipv6_config.address', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_address_ipv6_address_delete(self, tengigabitethernet=None, ipv6_address=None, secondary=None, anycast=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ipv6_address: address, secondary, anycast
    :param ipv6_address: Keyword argument tuple.

    :type address: unicode
    :param address: **ipv6_address** tuple argument:  A:B::C:D/LEN;; IPv6 prefix format: xxxx:xxxx/ml, xxxx:xxxx::/ml, xxxx::xx/128

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type secondary: YANGBool
    :param secondary: **ipv6_address** tuple argument:  Configure Secondary ipv6 address on an interface

    :type anycast: YANGBool
    :param anycast: **ipv6_address** tuple argument:  Configure ipv6 address as anycast

    **Instance Argument(s)**:

    :type secondary: YANGBool
    :param secondary: Configure Secondary ipv6 address on an interface

    :type anycast: YANGBool
    :param anycast: Configure ipv6 address as anycast

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_address', 'keyval': 'address', 'extra_keyval': 'address, secondary, anycast'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, ipv6_address=ipv6_address, secondary=secondary, anycast=anycast)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, ipv6_address=ipv6_address, secondary=secondary, anycast=anycast)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_address_ipv6_address_anycast_delete(self, tengigabitethernet=None, ipv6_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ipv6_address: address
    :param ipv6_address: Keyword argument tuple.

    :type address: unicode
    :param address: **ipv6_address** tuple argument:  A:B::C:D/LEN;; IPv6 prefix format: xxxx:xxxx/ml, xxxx:xxxx::/ml, xxxx::xx/128

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_address', 'keyval': 'address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'anycast'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, ipv6_address=ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, ipv6_address=ipv6_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_address_ipv6_address_eui_64_delete(self, tengigabitethernet=None, ipv6_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type ipv6_address: address, secondary, anycast
    :param ipv6_address: Keyword argument tuple.

    :type address: unicode
    :param address: **ipv6_address** tuple argument:  A:B::C:D/LEN;; IPv6 prefix format: xxxx:xxxx/ml, xxxx:xxxx::/ml, xxxx::xx/128

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type secondary: YANGBool
    :param secondary: **ipv6_address** tuple argument:  Configure Secondary ipv6 address on an interface

    :type anycast: YANGBool
    :param anycast: **ipv6_address** tuple argument:  Configure ipv6 address as anycast

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.ipv6_config.address.ipv6_address', u'ipv6_address'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.ipv6_config.address.ipv6_address', u'ipv6_address'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.ipv6_config.address.ipv6_address', u'ipv6_address')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.ipv6_config.address.ipv6_address.eui_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.ipv6_config.address.ipv6_address.eui_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.ipv6_config.address.ipv6_address.eui_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'address', 'extra_keyval': 'address, secondary, anycast'}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'address', 'extra_keyval': 'address, secondary, anycast'}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'address', 'extra_keyval': 'address, secondary, anycast'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'eui-64'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, ipv6_address=ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, ipv6_address=ipv6_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_address_ipv6_address_secondary_delete(self, tengigabitethernet=None, ipv6_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ipv6_address: address
    :param ipv6_address: Keyword argument tuple.

    :type address: unicode
    :param address: **ipv6_address** tuple argument:  A:B::C:D/LEN;; IPv6 prefix format: xxxx:xxxx/ml, xxxx:xxxx::/ml, xxxx::xx/128

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_address', 'keyval': 'address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'secondary'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, ipv6_address=ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, ipv6_address=ipv6_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_address_ipv6_address_secondary_eui_config_delete(self, tengigabitethernet=None, ipv6_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type ipv6_address: address, secondary, anycast
    :param ipv6_address: Keyword argument tuple.

    :type address: unicode
    :param address: **ipv6_address** tuple argument:  A:B::C:D/LEN;; IPv6 prefix format: xxxx:xxxx/ml, xxxx:xxxx::/ml, xxxx::xx/128

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type secondary: YANGBool
    :param secondary: **ipv6_address** tuple argument:  Configure Secondary ipv6 address on an interface

    :type anycast: YANGBool
    :param anycast: **ipv6_address** tuple argument:  Configure ipv6 address as anycast

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.ipv6_config.address.ipv6_address', u'ipv6_address'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.ipv6_config.address.ipv6_address', u'ipv6_address'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.ipv6_config.address.ipv6_address', u'ipv6_address')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.ipv6_config.address.ipv6_address.eui_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.ipv6_config.address.ipv6_address.eui_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.ipv6_config.address.ipv6_address.eui_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'address', 'extra_keyval': 'address, secondary, anycast'}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'address', 'extra_keyval': 'address, secondary, anycast'}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'address', 'extra_keyval': 'address, secondary, anycast'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'secondary'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, ipv6_address=ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, ipv6_address=ipv6_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_address_link_local_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'link-local'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_address_link_local_address_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'link-local-address'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_address_link_local_config_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'link_local_address, link_local'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_address_use_link_local_only_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.ipv6_config.address', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.ipv6_config.address', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.ipv6_config.address', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'use-link-local-only'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_dhcp_relay_servers_delete(self, tengigabitethernet=None, servers=None, server_vrf_name=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type servers: relay_ip_addr, server_vrf_name
    :param servers: Keyword argument tuple.

    :type relay_ip_addr: unicode
    :param relay_ip_addr: **servers** tuple argument:  IPv6 address of the DHCPv6 server

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type server_vrf_name: unicode
    :param server_vrf_name: **servers** tuple argument:  VRF name of the DHCPv6 server

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Argument(s)**:

    :type server_vrf_name: unicode
    :param server_vrf_name: VRF name of the DHCPv6 server

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'servers', 'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, servers=servers, server_vrf_name=server_vrf_name)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, servers=servers, server_vrf_name=server_vrf_name)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_dhcp_relay_servers_interface_delete(self, tengigabitethernet=None, servers=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type servers: relay_ip_addr, server_vrf_name
    :param servers: Keyword argument tuple.

    :type relay_ip_addr: unicode
    :param relay_ip_addr: **servers** tuple argument:  IPv6 address of the DHCPv6 server

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type server_vrf_name: unicode
    :param server_vrf_name: **servers** tuple argument:  VRF name of the DHCPv6 server

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', u'servers'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', u'servers'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', u'servers')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers.interface', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers.interface', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers.interface', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'interface_type, interface_name'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, servers=servers)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, servers=servers)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_dhcp_relay_servers_interface_interface_delete(self, tengigabitethernet=None, servers=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type servers: relay_ip_addr, server_vrf_name
    :param servers: Keyword argument tuple.

    :type relay_ip_addr: unicode
    :param relay_ip_addr: **servers** tuple argument:  IPv6 address of the DHCPv6 server

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type server_vrf_name: unicode
    :param server_vrf_name: **servers** tuple argument:  VRF name of the DHCPv6 server

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', u'servers'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', u'servers'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', u'servers')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers.interface', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers.interface', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers.interface', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'interface'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, servers=servers)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, servers=servers)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_dhcp_relay_servers_interface_interface_name_delete(self, tengigabitethernet=None, servers=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type servers: relay_ip_addr, server_vrf_name
    :param servers: Keyword argument tuple.

    :type relay_ip_addr: unicode
    :param relay_ip_addr: **servers** tuple argument:  IPv6 address of the DHCPv6 server

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type server_vrf_name: unicode
    :param server_vrf_name: **servers** tuple argument:  VRF name of the DHCPv6 server

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', u'servers'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', u'servers'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', u'servers')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers.interface', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers.interface', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers.interface', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'interface-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, servers=servers)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, servers=servers)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_dhcp_relay_servers_use_vrf_delete(self, tengigabitethernet=None, servers=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type servers: relay_ip_addr
    :param servers: Keyword argument tuple.

    :type relay_ip_addr: unicode
    :param relay_ip_addr: **servers** tuple argument:  IPv6 address of the DHCPv6 server

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'servers', 'keyval': 'relay_ip_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'use-vrf'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, servers=servers)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, servers=servers)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_hop_by_hop_trap_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.ipv6_phy_intf_cmds', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.ipv6_phy_intf_cmds', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.ipv6_phy_intf_cmds', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hop-by-hop-trap'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_icmpv6_echo_reply_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.icmpv6', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.icmpv6', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.icmpv6', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'echo-reply'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_icmpv6_rate_limiting_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.icmpv6', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.icmpv6', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.icmpv6', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rate-limiting'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_icmpv6_redirect_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.icmpv6', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.icmpv6', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.icmpv6', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redirect'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_icmpv6_unreachable_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.icmpv6', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.icmpv6', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.icmpv6', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'unreachable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_interface_phy_dhcp_conf_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.interface_phy_dhcp_conf', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.interface_phy_dhcp_conf', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.interface_phy_dhcp_conf', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_ipv6_config_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.ipv6_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.ipv6_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.ipv6_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_ipv6_intf_cmds_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_ipv6_nd_ra_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.ipv6_nd_ra', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.ipv6_nd_ra', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_ipv6_phy_intf_cmds_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.ipv6_phy_intf_cmds', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.ipv6_phy_intf_cmds', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.ipv6_phy_intf_cmds', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_mtu_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.ipv6_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.ipv6_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.ipv6_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mtu'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_nd_broadcast_mac_trap_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'broadcast-mac-trap'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_nd_cache_expire_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.cache', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.cache', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.cache', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'expire'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_nd_dad_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.dad', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.dad', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.dad', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_nd_dad_attempts_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.dad', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.dad', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.dad', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'attempts'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_nd_dad_time_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.dad', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.dad', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.dad', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_nd_hoplimit_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hoplimit'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_nd_managed_config_flag_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'managed-config-flag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_nd_mtu_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mtu'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_nd_ns_interval_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ns-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_nd_nud_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_nd_nud_retry_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'base, interval, max_attempts'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_nd_nud_retry_base_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'base'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_nd_nud_retry_interval_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_nd_nud_retry_max_attempts_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'max-attempts'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_nd_other_config_flag_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'other-config-flag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_nd_prefix_delete(self, tengigabitethernet=None, prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix', 'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, prefix=prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_nd_prefix_infinite_delete(self, tengigabitethernet=None, prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'infinite'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, prefix=prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_nd_prefix_infinite_preferred_delete(self, tengigabitethernet=None, prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'infinite'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, prefix=prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_nd_prefix_no_advertise_delete(self, tengigabitethernet=None, prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'no-advertise'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, prefix=prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_nd_prefix_no_autoconfig_delete(self, tengigabitethernet=None, prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'no-autoconfig'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, prefix=prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_nd_prefix_no_onlink_delete(self, tengigabitethernet=None, prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'no-onlink'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, prefix=prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_nd_prefix_off_link_delete(self, tengigabitethernet=None, prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'off-link'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, prefix=prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_nd_prefix_preferred_delete(self, tengigabitethernet=None, prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'preferred_lifetime, preferred_infinite'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred': [u'preferred_infinite', u'preferred_lifetime'], 'pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred': [u'preferred_infinite', u'preferred_lifetime'], 'pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred': [u'preferred_infinite', u'preferred_lifetime']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, prefix=prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_nd_prefix_preferred_lifetime_delete(self, tengigabitethernet=None, prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'preferred-lifetime'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, prefix=prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_nd_prefix_prefix_flags_delete(self, tengigabitethernet=None, prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'no_autoconfig, no_onlink, off_link'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, prefix=prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_nd_prefix_valid_lifetime_delete(self, tengigabitethernet=None, prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'valid-lifetime'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, prefix=prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_nd_proxy_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'proxy'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_nd_ra_interval_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_interval', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_interval', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_interval', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'max_interval, min_'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_nd_ra_interval_max_interval_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_interval', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_interval', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_interval', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'max-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_nd_ra_interval_min_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_interval', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_interval', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_interval', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'min'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_nd_ra_lifetime_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ra-lifetime'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_nd_reachable_time_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'reachable-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_nd_retrans_timer_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'retrans-timer'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_nd_set_cache_expire_time_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'set-cache-expire-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_nd_set_hoplimit_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'set-hoplimit'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_nd_suppress_ra_all_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'all'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_nd_suppress_ra_mtu_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mtu'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_nd_suppress_ra_suppress_ra_flag_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'suppress-ra-flag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_neighbor_delete(self, tengigabitethernet=None, neighbor=None, hardware_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type neighbor: ipv6_address
    :param neighbor: Keyword argument tuple.

    :type ipv6_address: unicode
    :param ipv6_address: **neighbor** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    **Instance Argument(s)**:

    :type hardware_address: unicode
    :param hardware_address: Keyword argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.neighbor', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.neighbor', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.neighbor', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'neighbor', 'keyval': 'ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, neighbor=neighbor, hardware_address=hardware_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, neighbor=neighbor, hardware_address=hardware_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_neighbor_hardware_address_delete(self, tengigabitethernet=None, neighbor=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type neighbor: ipv6_address
    :param neighbor: Keyword argument tuple.

    :type ipv6_address: unicode
    :param ipv6_address: **neighbor** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.neighbor', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.neighbor', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.neighbor', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'neighbor', 'keyval': 'ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hardware-address'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, neighbor=neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, neighbor=neighbor)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_ospf_active_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'active'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_ospf_area_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'area'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_ospf_authentication_ah_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ah'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_ospf_authentication_esp_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'esp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_ospf_authentication_esp_auth_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'esp-auth'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_ospf_authentication_esp_key_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'esp-key'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_ospf_authentication_esp_no_encrypt_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'esp-no-encrypt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_ospf_authentication_ipsec_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_ospf_authentication_ipsec_disable_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'disable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_ospf_authentication_ipsec_key_add_remove_interval_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'key-add-remove-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_ospf_authentication_key_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'key'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_ospf_authentication_no_encrypt_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'no-encrypt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_ospf_authentication_spi_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'spi'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_ospf_bfd_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.bfd', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.bfd', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.bfd', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_ospf_bfd_bfd_enable_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.bfd', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.bfd', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.bfd', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bfd-enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_ospf_cost_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cost'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_ospf_dead_interval_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dead-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_ospf_hello_interval_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hello-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_ospf_hello_jitter_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hello-jitter'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_ospf_instance_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'instance'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_ospf_link_interval_properties_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_ospf_mtu_ignore_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mtu-ignore'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_ospf_network_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'network'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_ospf_passive_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'passive'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_ospf_priority_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_ospf_retransmit_interval_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'retransmit-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_ospf_suppress_linklsa_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'suppress-linklsa'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_ospf_transmit_delay_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'transmit-delay'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_policy_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.policy', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.policy', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.policy', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_policy_route_map_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.policy.route_map', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.policy.route_map', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.policy.route_map', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_policy_route_map_ipv6_route_map_name_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.policy.route_map', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.policy.route_map', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.policy.route_map', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ipv6-route-map-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_raguard_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'raguard'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_vrrp_extended_group_delete(self, tengigabitethernet=None, vrrpv3e_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_vrrp_extended_group_advertise_backup_delete(self, tengigabitethernet=None, vrrpv3e_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'advertise-backup'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_vrrp_extended_group_advertisement_interval_delete(self, tengigabitethernet=None, vrrpv3e_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'advertisement-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_vrrp_extended_group_advertisement_interval_scale_delete(self, tengigabitethernet=None, vrrpv3e_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'advertisement-interval-scale'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_vrrp_extended_group_backup_advertisement_interval_delete(self, tengigabitethernet=None, vrrpv3e_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'backup-advertisement-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_vrrp_extended_group_description_delete(self, tengigabitethernet=None, vrrpv3e_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'description'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_vrrp_extended_group_enable_delete(self, tengigabitethernet=None, vrrpv3e_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_vrrp_extended_group_hold_time_delete(self, tengigabitethernet=None, vrrpv3e_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hold-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_vrrp_extended_group_nd_advertisement_timer_delete(self, tengigabitethernet=None, vrrpv3e_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'nd-advertisement-timer'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_vrrp_extended_group_preempt_mode_delete(self, tengigabitethernet=None, vrrpv3e_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'preempt-mode'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_vrrp_extended_group_priority_delete(self, tengigabitethernet=None, vrrpv3e_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_vrrp_extended_group_short_path_forwarding_delete(self, tengigabitethernet=None, vrrpv3e_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.vrrpv3e_group.short_path_forwarding', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'basic, revert_priority'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_vrrp_extended_group_short_path_forwarding_basic_delete(self, tengigabitethernet=None, vrrpv3e_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.vrrpv3e_group.short_path_forwarding', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.vrrpv3e_group.short_path_forwarding', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.vrrpv3e_group.short_path_forwarding', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'basic'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_vrrp_extended_group_short_path_forwarding_revert_priority_delete(self, tengigabitethernet=None, vrrpv3e_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.vrrpv3e_group.short_path_forwarding', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.vrrpv3e_group.short_path_forwarding', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.vrrpv3e_group.short_path_forwarding', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'revert-priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_vrrp_extended_group_track_interface_delete(self, tengigabitethernet=None, vrrpv3e_group=None, interface=None, track_priority=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Argument(s)**:

    :type track_priority: int
    :param track_priority: Track Priority

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.vrrpv3e_group.track.interface', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.vrrpv3e_group.track.interface', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.vrrpv3e_group.track.interface', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, vrrpv3e_group=vrrpv3e_group, interface=interface, track_priority=track_priority)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, vrrpv3e_group=vrrpv3e_group, interface=interface, track_priority=track_priority)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_vrrp_extended_group_track_interface_priority_delete(self, tengigabitethernet=None, vrrpv3e_group=None, interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.vrrpv3e_group.track.interface', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.vrrpv3e_group.track.interface', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.vrrpv3e_group.track.interface', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, vrrpv3e_group=vrrpv3e_group, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, vrrpv3e_group=vrrpv3e_group, interface=interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_vrrp_extended_group_virtual_ip_delete(self, tengigabitethernet=None, vrrpv3e_group=None, virtual_ip=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type virtual_ip: virtual_ipaddr
    :param virtual_ip: Keyword argument tuple.

    :type virtual_ipaddr: unicode
    :param virtual_ipaddr: **virtual_ip** tuple argument:  Virtual IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.vrrpv3e_group.virtual_ip', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.vrrpv3e_group.virtual_ip', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.vrrpv3e_group.virtual_ip', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'virtual_ip', 'keyval': 'virtual_ipaddr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, vrrpv3e_group=vrrpv3e_group, virtual_ip=virtual_ip)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, vrrpv3e_group=vrrpv3e_group, virtual_ip=virtual_ip)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_vrrp_group_delete(self, tengigabitethernet=None, vrrpv3_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, vrrpv3_group=vrrpv3_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, vrrpv3_group=vrrpv3_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_vrrp_group_advertisement_interval_delete(self, tengigabitethernet=None, vrrpv3_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'advertisement-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, vrrpv3_group=vrrpv3_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, vrrpv3_group=vrrpv3_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_vrrp_group_description_delete(self, tengigabitethernet=None, vrrpv3_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'description'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, vrrpv3_group=vrrpv3_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, vrrpv3_group=vrrpv3_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_vrrp_group_enable_delete(self, tengigabitethernet=None, vrrpv3_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, vrrpv3_group=vrrpv3_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, vrrpv3_group=vrrpv3_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_vrrp_group_hold_time_delete(self, tengigabitethernet=None, vrrpv3_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hold-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, vrrpv3_group=vrrpv3_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, vrrpv3_group=vrrpv3_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_vrrp_group_preempt_mode_delete(self, tengigabitethernet=None, vrrpv3_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'preempt-mode'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, vrrpv3_group=vrrpv3_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, vrrpv3_group=vrrpv3_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_vrrp_group_priority_delete(self, tengigabitethernet=None, vrrpv3_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, vrrpv3_group=vrrpv3_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, vrrpv3_group=vrrpv3_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_vrrp_group_track_interface_delete(self, tengigabitethernet=None, vrrpv3_group=None, interface=None, track_priority=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Argument(s)**:

    :type track_priority: int
    :param track_priority: Track Priority

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.vrrpv3_group', u'vrrpv3_group'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.vrrpv3_group', u'vrrpv3_group'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.vrrpv3_group', u'vrrpv3_group')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.vrrpv3_group.track.interface', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.vrrpv3_group.track.interface', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.vrrpv3_group.track.interface', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, vrrpv3_group=vrrpv3_group, interface=interface, track_priority=track_priority)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, vrrpv3_group=vrrpv3_group, interface=interface, track_priority=track_priority)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_vrrp_group_track_interface_priority_delete(self, tengigabitethernet=None, vrrpv3_group=None, interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.vrrpv3_group', u'vrrpv3_group'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.vrrpv3_group', u'vrrpv3_group'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.vrrpv3_group', u'vrrpv3_group')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.vrrpv3_group.track.interface', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.vrrpv3_group.track.interface', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.vrrpv3_group.track.interface', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, vrrpv3_group=vrrpv3_group, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, vrrpv3_group=vrrpv3_group, interface=interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_vrrp_group_use_v2_checksum_delete(self, tengigabitethernet=None, vrrpv3_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'use-v2-checksum'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, vrrpv3_group=vrrpv3_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, vrrpv3_group=vrrpv3_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_vrrp_group_virtual_ip_delete(self, tengigabitethernet=None, vrrpv3_group=None, virtual_ip=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type virtual_ip: virtual_ipaddr
    :param virtual_ip: Keyword argument tuple.

    :type virtual_ipaddr: unicode
    :param virtual_ipaddr: **virtual_ip** tuple argument:  Virtual IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.vrrpv3_group', u'vrrpv3_group'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.vrrpv3_group', u'vrrpv3_group'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.vrrpv3_group', u'vrrpv3_group')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.vrrpv3_group.virtual_ip', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.vrrpv3_group.virtual_ip', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.vrrpv3_group.virtual_ip', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'virtual_ip', 'keyval': 'virtual_ipaddr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, vrrpv3_group=vrrpv3_group, virtual_ip=virtual_ip)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, vrrpv3_group=vrrpv3_group, virtual_ip=virtual_ip)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_vrrp_suppress_interface_ra_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vrrp-suppress-interface-ra'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_lacp_default_up_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.lacp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.lacp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.lacp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'default-up'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_lacp_port_priority_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.lacp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.lacp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.lacp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'port-priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_lacp_timeout_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.lacp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.lacp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.lacp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'timeout'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_lldp_cee_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.lldp.cee', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.lldp.cee', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.lldp.cee', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_lldp_cee_lldp_cee_on_off_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.lldp.cee', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.lldp.cee', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.lldp.cee', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lldp-cee-on-off'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_lldp_dcbx_version_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.lldp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.lldp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.lldp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dcbx-version'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_lldp_disable_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.lldp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.lldp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.lldp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'disable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_lldp_iscsi_priority_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.lldp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.lldp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.lldp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'iscsi-priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_lldp_profile_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.lldp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.lldp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.lldp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'profile'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_long_distance_isl_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Instance Keyword Argument Tuple**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tengigabitethernet', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'long-distance-isl'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_mac_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.mac', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.mac', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.mac', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_mac_access_group_delete(self, tengigabitethernet=None, access_group=None, traffic_type=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type access_group: mac_access_list, mac_direction, traffic_type
    :param access_group: Keyword argument tuple.

    :type mac_access_list: unicode
    :param mac_access_list: **access_group** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type mac_direction: unicode
    :param mac_direction: **access_group** tuple argument.

        * enumeration restriction: ::

            ['in', 'out']

    :type traffic_type: unicode
    :param traffic_type: **access_group** tuple argument.

        * enumeration restriction: ::

            ['switched', 'routed']

    **Instance Argument(s)**:

    :type traffic_type: unicode
    :param traffic_type: Keyword argument.

        * enumeration restriction: ::

            ['switched', 'routed']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.mac.access_group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.mac.access_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.mac.access_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'access_group', 'keyval': 'mac_access_list, mac_direction', 'extra_keyval': 'mac_access_list, mac_direction, traffic_type'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, access_group=access_group, traffic_type=traffic_type)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, access_group=access_group, traffic_type=traffic_type)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_mac_learning_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.mac_learning', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.mac_learning', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.mac_learning', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_mac_learning_disable_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.mac_learning.mac_learn_disable', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.mac_learning.mac_learn_disable', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.mac_learning.mac_learn_disable', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_mac_learning_disable_vlan_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.mac_learning.mac_learn_disable.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.mac_learning.mac_learn_disable.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.mac_learning.mac_learn_disable.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_mac_learning_disable_vlan_add_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.mac_learning.mac_learn_disable.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.mac_learning.mac_learn_disable.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.mac_learning.mac_learn_disable.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'add'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_mac_learning_disable_vlan_remove_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.mac_learning.mac_learn_disable.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.mac_learning.mac_learn_disable.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.mac_learning.mac_learn_disable.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'remove'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_mtu_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Instance Keyword Argument Tuple**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tengigabitethernet', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mtu'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_openflow_enable_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.openflow_interface_cfg.openflow_enable', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.openflow_interface_cfg.openflow_enable', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.openflow_interface_cfg.openflow_enable', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_openflow_logical_instance_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.openflow_interface_cfg', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.openflow_interface_cfg', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.openflow_interface_cfg', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'logical-instance'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_openflow_match_profile_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.openflow_interface_cfg.openflow_enable', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.openflow_interface_cfg.openflow_enable', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.openflow_interface_cfg.openflow_enable', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'match-profile'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_openflow_openflow_enable_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.openflow_interface_cfg.openflow_enable', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.openflow_interface_cfg.openflow_enable', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.openflow_interface_cfg.openflow_enable', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'enable, match_profile'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_port_profile_port_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Instance Keyword Argument Tuple**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tengigabitethernet', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'port-profile-port'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_port_profile_port_domain_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.port_profile_to_interface_associations.port_profile_port.port_to_port_profile_domain_association', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.port_profile_to_interface_associations.port_profile_port.port_to_port_profile_domain_association', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.port_profile_to_interface_associations.port_profile_port.port_to_port_profile_domain_association', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_port_profile_port_domain_profile_domain_name_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.port_profile_to_interface_associations.port_profile_port.port_to_port_profile_domain_association', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.port_profile_to_interface_associations.port_profile_port.port_to_port_profile_domain_association', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.port_profile_to_interface_associations.port_profile_port.port_to_port_profile_domain_association', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'profile-domain-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_port_profile_port_profile_delete(self, tengigabitethernet=None, port_to_port_profile_associations=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type port_to_port_profile_associations: port_to_port_profile_association
    :param port_to_port_profile_associations: Keyword argument tuple.

    :type port_to_port_profile_association: unicode
    :param port_to_port_profile_association: **port_to_port_profile_associations** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.port_profile_to_interface_associations.port_profile_port.port_to_port_profile_associations', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.port_profile_to_interface_associations.port_profile_port.port_to_port_profile_associations', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.port_profile_to_interface_associations.port_profile_port.port_to_port_profile_associations', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'port_to_port_profile_associations', 'keyval': 'port_to_port_profile_association', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, port_to_port_profile_associations=port_to_port_profile_associations)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, port_to_port_profile_associations=port_to_port_profile_associations)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_port_profile_to_interface_associations_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.port_profile_to_interface_associations', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.port_profile_to_interface_associations', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.port_profile_to_interface_associations', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_priority_tag_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Instance Keyword Argument Tuple**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tengigabitethernet', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority-tag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_qos_cos_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.qos', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.qos', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.qos', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cos'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_qos_cos_mutation_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.qos', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.qos', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.qos', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cos-mutation'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_qos_cos_traffic_class_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.qos', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.qos', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.qos', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cos-traffic-class'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_qos_drop_monitor_enable_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.qos.drop_monitor', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.qos.drop_monitor', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.qos.drop_monitor', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_qos_dscp_cos_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.qos', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.qos', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.qos', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dscp-cos'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_qos_dscp_mutation_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.qos', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.qos', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.qos', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dscp-mutation'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_qos_dscp_traffic_class_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.qos', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.qos', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.qos', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dscp-traffic-class'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_qos_flowcontrol_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.qos.flowcontrol', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.qos.flowcontrol', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.qos.flowcontrol', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_qos_flowcontrol_link_level_flowcontrol_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.qos.flowcontrol.link_level_flowcontrol', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.qos.flowcontrol.link_level_flowcontrol', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.qos.flowcontrol.link_level_flowcontrol', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_qos_flowcontrol_pfc_delete(self, tengigabitethernet=None, pfc=None, pfc_flowcontrol_tx=None, pfc_flowcontrol_rx=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type pfc: pfc_cos
    :param pfc: Keyword argument tuple.

    :type pfc_cos: long
    :param pfc_cos: **pfc** tuple argument:  0-7;;CoS value

        * range restriction: ::

            ['-2147483648..2147483647']

    **Instance Argument(s)**:

    :type pfc_flowcontrol_tx: unicode
    :param pfc_flowcontrol_tx: Configure Pause generation

        * enumeration restriction: ::

            ['on', 'off']

    :type pfc_flowcontrol_rx: unicode
    :param pfc_flowcontrol_rx: Configure Pause reception

        * enumeration restriction: ::

            ['on', 'off']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.qos.flowcontrol.pfc', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.qos.flowcontrol.pfc', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.qos.flowcontrol.pfc', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'pfc', 'keyval': 'pfc_cos', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, pfc=pfc, pfc_flowcontrol_tx=pfc_flowcontrol_tx, pfc_flowcontrol_rx=pfc_flowcontrol_rx)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, pfc=pfc, pfc_flowcontrol_tx=pfc_flowcontrol_tx, pfc_flowcontrol_rx=pfc_flowcontrol_rx)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_qos_flowcontrol_pfc_rx_delete(self, tengigabitethernet=None, pfc=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type pfc: pfc_cos
    :param pfc: Keyword argument tuple.

    :type pfc_cos: long
    :param pfc_cos: **pfc** tuple argument:  0-7;;CoS value

        * range restriction: ::

            ['-2147483648..2147483647']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.qos.flowcontrol.pfc', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.qos.flowcontrol.pfc', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.qos.flowcontrol.pfc', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'pfc', 'keyval': 'pfc_cos', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, pfc=pfc)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, pfc=pfc)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_qos_flowcontrol_pfc_tx_delete(self, tengigabitethernet=None, pfc=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type pfc: pfc_cos
    :param pfc: Keyword argument tuple.

    :type pfc_cos: long
    :param pfc_cos: **pfc** tuple argument:  0-7;;CoS value

        * range restriction: ::

            ['-2147483648..2147483647']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.qos.flowcontrol.pfc', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.qos.flowcontrol.pfc', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.qos.flowcontrol.pfc', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'pfc', 'keyval': 'pfc_cos', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, pfc=pfc)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, pfc=pfc)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_qos_flowcontrol_rx_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.qos.flowcontrol.link_level_flowcontrol', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.qos.flowcontrol.link_level_flowcontrol', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.qos.flowcontrol.link_level_flowcontrol', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_qos_flowcontrol_tx_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.qos.flowcontrol.link_level_flowcontrol', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.qos.flowcontrol.link_level_flowcontrol', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.qos.flowcontrol.link_level_flowcontrol', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_qos_random_detect_traffic_class_delete(self, tengigabitethernet=None, traffic_class=None, red_enable=None, red_profile_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type traffic_class: red_tc_value
    :param traffic_class: Keyword argument tuple.

    :type red_tc_value: long
    :param red_tc_value: **traffic_class** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Argument(s)**:

    :type red_enable: YANGBool
    :param red_enable: Keyword for VDX 6710,6720,6730,6746,2730

    :type red_profile_id: long
    :param red_profile_id: Keyword for all other VDX platforms

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.qos.random_detect.traffic_class', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.qos.random_detect.traffic_class', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.qos.random_detect.traffic_class', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'traffic_class', 'keyval': 'red_tc_value', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, traffic_class=traffic_class, red_enable=red_enable, red_profile_id=red_profile_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, traffic_class=traffic_class, red_enable=red_enable, red_profile_id=red_profile_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_qos_random_detect_traffic_class_apply_delete(self, tengigabitethernet=None, traffic_class=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type traffic_class: red_tc_value
    :param traffic_class: Keyword argument tuple.

    :type red_tc_value: long
    :param red_tc_value: **traffic_class** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.qos.random_detect.traffic_class', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.qos.random_detect.traffic_class', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.qos.random_detect.traffic_class', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'traffic_class', 'keyval': 'red_tc_value', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'apply'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, traffic_class=traffic_class)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, traffic_class=traffic_class)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_qos_random_detect_traffic_class_red_profile_id_delete(self, tengigabitethernet=None, traffic_class=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type traffic_class: red_tc_value
    :param traffic_class: Keyword argument tuple.

    :type red_tc_value: long
    :param red_tc_value: **traffic_class** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.qos.random_detect.traffic_class', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.qos.random_detect.traffic_class', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.qos.random_detect.traffic_class', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'traffic_class', 'keyval': 'red_tc_value', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'red-profile-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, traffic_class=traffic_class)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, traffic_class=traffic_class)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_qos_rcv_queue_cos_threshold_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.qos.rcv_queue.cos_threshold', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.qos.rcv_queue.cos_threshold', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.qos.rcv_queue.cos_threshold', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_qos_rcv_queue_cos_threshold_cos0_threshold_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.qos.rcv_queue.cos_threshold', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.qos.rcv_queue.cos_threshold', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.qos.rcv_queue.cos_threshold', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cos0-threshold'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_qos_rcv_queue_cos_threshold_cos1_threshold_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.qos.rcv_queue.cos_threshold', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.qos.rcv_queue.cos_threshold', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.qos.rcv_queue.cos_threshold', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cos1-threshold'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_qos_rcv_queue_cos_threshold_cos2_threshold_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.qos.rcv_queue.cos_threshold', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.qos.rcv_queue.cos_threshold', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.qos.rcv_queue.cos_threshold', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cos2-threshold'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_qos_rcv_queue_cos_threshold_cos3_threshold_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.qos.rcv_queue.cos_threshold', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.qos.rcv_queue.cos_threshold', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.qos.rcv_queue.cos_threshold', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cos3-threshold'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_qos_rcv_queue_cos_threshold_cos4_threshold_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.qos.rcv_queue.cos_threshold', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.qos.rcv_queue.cos_threshold', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.qos.rcv_queue.cos_threshold', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cos4-threshold'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_qos_rcv_queue_cos_threshold_cos5_threshold_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.qos.rcv_queue.cos_threshold', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.qos.rcv_queue.cos_threshold', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.qos.rcv_queue.cos_threshold', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cos5-threshold'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_qos_rcv_queue_cos_threshold_cos6_threshold_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.qos.rcv_queue.cos_threshold', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.qos.rcv_queue.cos_threshold', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.qos.rcv_queue.cos_threshold', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cos6-threshold'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_qos_rcv_queue_cos_threshold_cos7_threshold_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.qos.rcv_queue.cos_threshold', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.qos.rcv_queue.cos_threshold', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.qos.rcv_queue.cos_threshold', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cos7-threshold'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_qos_trust_cos_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.qos.trust', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.qos.trust', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.qos.trust', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cos'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_qos_trust_dscp_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.qos.trust', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.qos.trust', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.qos.trust', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dscp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_rmon_collection_history_delete(self, tengigabitethernet=None, history_control_entry=None, history_control_buckets_requested=None, history_control_interval=None, history_control_owner=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type history_control_entry: history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner
    :param history_control_entry: Keyword argument tuple.

    :type history_control_index: long
    :param history_control_index: **history_control_entry** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type history_control_buckets_requested: long
    :param history_control_buckets_requested: **history_control_entry** tuple argument:  Buckets (default 50)

        * range restriction: ::

            ['-2147483648..2147483647']

    :type history_control_interval: long
    :param history_control_interval: **history_control_entry** tuple argument:  Polling Interval (default 1800)

        * range restriction: ::

            ['-2147483648..2147483647']

    :type history_control_owner: unicode
    :param history_control_owner: **history_control_entry** tuple argument:  Owner identity

        * length restriction: ::

            ['1 .. 15']

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,14})'

    **Instance Argument(s)**:

    :type history_control_buckets_requested: long
    :param history_control_buckets_requested: Buckets (default 50)

        * range restriction: ::

            ['-2147483648..2147483647']

    :type history_control_interval: long
    :param history_control_interval: Polling Interval (default 1800)

        * range restriction: ::

            ['-2147483648..2147483647']

    :type history_control_owner: unicode
    :param history_control_owner: Owner identity

        * length restriction: ::

            ['1 .. 15']

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,14})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.rmon.collection.history_control_entry', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.rmon.collection.history_control_entry', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.rmon.collection.history_control_entry', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'history_control_entry', 'keyval': 'history_control_index', 'extra_keyval': 'history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, history_control_entry=history_control_entry, history_control_buckets_requested=history_control_buckets_requested, history_control_interval=history_control_interval, history_control_owner=history_control_owner)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, history_control_entry=history_control_entry, history_control_buckets_requested=history_control_buckets_requested, history_control_interval=history_control_interval, history_control_owner=history_control_owner)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_rmon_collection_history_buckets_delete(self, tengigabitethernet=None, history_control_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type history_control_entry: history_control_index
    :param history_control_entry: Keyword argument tuple.

    :type history_control_index: long
    :param history_control_index: **history_control_entry** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.rmon.collection.history_control_entry', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.rmon.collection.history_control_entry', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.rmon.collection.history_control_entry', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'history_control_entry', 'keyval': 'history_control_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'buckets'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, history_control_entry=history_control_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, history_control_entry=history_control_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_rmon_collection_history_interval_delete(self, tengigabitethernet=None, history_control_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type history_control_entry: history_control_index
    :param history_control_entry: Keyword argument tuple.

    :type history_control_index: long
    :param history_control_index: **history_control_entry** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.rmon.collection.history_control_entry', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.rmon.collection.history_control_entry', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.rmon.collection.history_control_entry', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'history_control_entry', 'keyval': 'history_control_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, history_control_entry=history_control_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, history_control_entry=history_control_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_rmon_collection_history_owner_delete(self, tengigabitethernet=None, history_control_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type history_control_entry: history_control_index
    :param history_control_entry: Keyword argument tuple.

    :type history_control_index: long
    :param history_control_index: **history_control_entry** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.rmon.collection.history_control_entry', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.rmon.collection.history_control_entry', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.rmon.collection.history_control_entry', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'history_control_entry', 'keyval': 'history_control_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'owner'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, history_control_entry=history_control_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, history_control_entry=history_control_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_rmon_collection_stats_delete(self, tengigabitethernet=None, ether_stats_entry=None, ether_stats_owner=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ether_stats_entry: ether_stats_index, ether_stats_owner
    :param ether_stats_entry: Keyword argument tuple.

    :type ether_stats_index: long
    :param ether_stats_index: **ether_stats_entry** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type ether_stats_owner: unicode
    :param ether_stats_owner: **ether_stats_entry** tuple argument:  Owner identity

        * length restriction: ::

            ['1 .. 15']

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,14})'

    **Instance Argument(s)**:

    :type ether_stats_owner: unicode
    :param ether_stats_owner: Owner identity

        * length restriction: ::

            ['1 .. 15']

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,14})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.rmon.collection.ether_stats_entry', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.rmon.collection.ether_stats_entry', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.rmon.collection.ether_stats_entry', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ether_stats_entry', 'keyval': 'ether_stats_index', 'extra_keyval': 'ether_stats_index, ether_stats_owner'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, ether_stats_entry=ether_stats_entry, ether_stats_owner=ether_stats_owner)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, ether_stats_entry=ether_stats_entry, ether_stats_owner=ether_stats_owner)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_rmon_collection_stats_owner_delete(self, tengigabitethernet=None, ether_stats_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ether_stats_entry: ether_stats_index
    :param ether_stats_entry: Keyword argument tuple.

    :type ether_stats_index: long
    :param ether_stats_index: **ether_stats_entry** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.rmon.collection.ether_stats_entry', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.rmon.collection.ether_stats_entry', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.rmon.collection.ether_stats_entry', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ether_stats_entry', 'keyval': 'ether_stats_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'owner'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, ether_stats_entry=ether_stats_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, ether_stats_entry=ether_stats_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_service_policy_in_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.service_policy', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.service_policy', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.service_policy', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'in'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_service_policy_out_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.service_policy', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.service_policy', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.service_policy', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'out'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_sflow_enable_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.sflow', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.sflow', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.sflow', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_sflow_polling_interval_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.sflow', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.sflow', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.sflow', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'polling-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_sflow_sample_rate_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.sflow', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.sflow', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.sflow', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'sample-rate'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_shutdown_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Instance Keyword Argument Tuple**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tengigabitethernet', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'shutdown'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_snmp_trap_link_status_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.snmp.trap', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.snmp.trap', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.snmp.trap', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'link-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_spanning_tree_autoedge_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.spanning_tree', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.spanning_tree', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.spanning_tree', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'autoedge'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_spanning_tree_bpdu_mac_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.spanning_tree', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.spanning_tree', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.spanning_tree', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bpdu-mac'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_spanning_tree_cost_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.spanning_tree', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.spanning_tree', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.spanning_tree', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cost'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_spanning_tree_edgeport_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.spanning_tree.edgeport', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.spanning_tree.edgeport', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.spanning_tree.edgeport', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_spanning_tree_edgeport_bpdu_filter_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.spanning_tree.edgeport', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.spanning_tree.edgeport', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.spanning_tree.edgeport', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bpdu-filter'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_spanning_tree_edgeport_bpdu_guard_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.spanning_tree.edgeport', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.spanning_tree.edgeport', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.spanning_tree.edgeport', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bpdu-guard'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_spanning_tree_edgeport_edgeportbasic_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.spanning_tree.edgeport', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.spanning_tree.edgeport', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.spanning_tree.edgeport', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'edgeportbasic'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_spanning_tree_guard_root_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.spanning_tree.guard', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.spanning_tree.guard', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.spanning_tree.guard', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'root'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_spanning_tree_hello_time_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.spanning_tree', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.spanning_tree', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.spanning_tree', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hello-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_spanning_tree_instance_cost_delete(self, tengigabitethernet=None, instance=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type instance: id
    :param instance: Keyword argument tuple.

    :type id: int
    :param id: **instance** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.spanning_tree.instance', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.spanning_tree.instance', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.spanning_tree.instance', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instance', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cost'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, instance=instance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, instance=instance)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_spanning_tree_instance_priority_delete(self, tengigabitethernet=None, instance=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type instance: id
    :param instance: Keyword argument tuple.

    :type id: int
    :param id: **instance** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.spanning_tree.instance', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.spanning_tree.instance', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.spanning_tree.instance', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instance', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, instance=instance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, instance=instance)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_spanning_tree_instance_restricted_role_delete(self, tengigabitethernet=None, instance=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type instance: id
    :param instance: Keyword argument tuple.

    :type id: int
    :param id: **instance** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.spanning_tree.instance', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.spanning_tree.instance', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.spanning_tree.instance', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instance', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'restricted-role'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, instance=instance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, instance=instance)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_spanning_tree_instance_restricted_tcn_delete(self, tengigabitethernet=None, instance=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type instance: id
    :param instance: Keyword argument tuple.

    :type id: int
    :param id: **instance** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.spanning_tree.instance', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.spanning_tree.instance', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.spanning_tree.instance', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instance', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'restricted-tcn'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, instance=instance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, instance=instance)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_spanning_tree_link_type_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.spanning_tree', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.spanning_tree', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.spanning_tree', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'link-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_spanning_tree_portfast_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.spanning_tree.portfast', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.spanning_tree.portfast', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.spanning_tree.portfast', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_spanning_tree_portfast_bpdu_filter_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.spanning_tree.portfast', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.spanning_tree.portfast', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.spanning_tree.portfast', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bpdu-filter'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_spanning_tree_portfast_bpdu_guard_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.spanning_tree.portfast', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.spanning_tree.portfast', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.spanning_tree.portfast', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bpdu-guard'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_spanning_tree_portfast_portfastbasic_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.spanning_tree.portfast', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.spanning_tree.portfast', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.spanning_tree.portfast', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'portfastbasic'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_spanning_tree_priority_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.spanning_tree', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.spanning_tree', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.spanning_tree', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_spanning_tree_restricted_role_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.spanning_tree', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.spanning_tree', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.spanning_tree', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'restricted-role'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_spanning_tree_restricted_tcn_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.spanning_tree', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.spanning_tree', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.spanning_tree', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'restricted-tcn'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_spanning_tree_shutdown_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.spanning_tree', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.spanning_tree', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.spanning_tree', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'shutdown'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_spanning_tree_vlan_cost_delete(self, tengigabitethernet=None, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vlan: id
    :param vlan: Keyword argument tuple.

    :type id: long
    :param id: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.spanning_tree.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.spanning_tree.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.spanning_tree.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cost'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_spanning_tree_vlan_guard_root_delete(self, tengigabitethernet=None, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vlan: id
    :param vlan: Keyword argument tuple.

    :type id: long
    :param id: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.spanning_tree.vlan', u'vlan'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet.spanning_tree.vlan', u'vlan'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.spanning_tree.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.spanning_tree.vlan.guard', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.spanning_tree.vlan.guard', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.spanning_tree.vlan.guard', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'root'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_spanning_tree_vlan_priority_delete(self, tengigabitethernet=None, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vlan: id
    :param vlan: Keyword argument tuple.

    :type id: long
    :param id: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.spanning_tree.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.spanning_tree.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.spanning_tree.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_speed_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Instance Keyword Argument Tuple**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tengigabitethernet', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'speed'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_storm_control_ingress_delete(self, tengigabitethernet=None, ingress=None, rate_format=None, rate_bps=None, rate_percent=None, bum_action=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ingress: protocol_type, rate_format, rate_bps, rate_percent, bum_action
    :param ingress: Keyword argument tuple.

    :type protocol_type: unicode
    :param protocol_type: **ingress** tuple argument.

        * enumeration restriction: ::

            ['broadcast', 'unknown-unicast', 'multicast']

    :type rate_format: unicode
    :param rate_format: **ingress** tuple argument.

        * enumeration restriction: ::

            ['limit-bps', 'limit-percent']

    :type rate_bps: long
    :param rate_bps: **ingress** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type rate_percent: long
    :param rate_percent: **ingress** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type bum_action: unicode
    :param bum_action: **ingress** tuple argument.

        * enumeration restriction: ::

            ['monitor', 'shutdown']

    **Instance Argument(s)**:

    :type rate_format: unicode
    :param rate_format: Keyword argument.

        * enumeration restriction: ::

            ['limit-bps', 'limit-percent']

    :type rate_bps: long
    :param rate_bps: Keyword argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type rate_percent: long
    :param rate_percent: Keyword argument.

        * range restriction: ::

            ['0..4294967295']

    :type bum_action: unicode
    :param bum_action: Keyword argument.

        * enumeration restriction: ::

            ['monitor', 'shutdown']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.storm_control.ingress', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.storm_control.ingress', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.storm_control.ingress', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ingress', 'keyval': 'protocol_type', 'extra_keyval': 'protocol_type, rate_format, rate_bps, rate_percent, bum_action'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, ingress=ingress, rate_format=rate_format, rate_bps=rate_bps, rate_percent=rate_percent, bum_action=bum_action)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, ingress=ingress, rate_format=rate_format, rate_bps=rate_bps, rate_percent=rate_percent, bum_action=bum_action)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_storm_control_ingress_bum_action_delete(self, tengigabitethernet=None, ingress=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ingress: protocol_type
    :param ingress: Keyword argument tuple.

    :type protocol_type: unicode
    :param protocol_type: **ingress** tuple argument.

        * enumeration restriction: ::

            ['broadcast', 'unknown-unicast', 'multicast']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.storm_control.ingress', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.storm_control.ingress', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.storm_control.ingress', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ingress', 'keyval': 'protocol_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bum-action'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, ingress=ingress)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, ingress=ingress)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_storm_control_ingress_rate_bps_delete(self, tengigabitethernet=None, ingress=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ingress: protocol_type
    :param ingress: Keyword argument tuple.

    :type protocol_type: unicode
    :param protocol_type: **ingress** tuple argument.

        * enumeration restriction: ::

            ['broadcast', 'unknown-unicast', 'multicast']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.storm_control.ingress', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.storm_control.ingress', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.storm_control.ingress', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ingress', 'keyval': 'protocol_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rate-bps'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, ingress=ingress)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, ingress=ingress)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_storm_control_ingress_rate_format_delete(self, tengigabitethernet=None, ingress=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ingress: protocol_type
    :param ingress: Keyword argument tuple.

    :type protocol_type: unicode
    :param protocol_type: **ingress** tuple argument.

        * enumeration restriction: ::

            ['broadcast', 'unknown-unicast', 'multicast']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.storm_control.ingress', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.storm_control.ingress', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.storm_control.ingress', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ingress', 'keyval': 'protocol_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rate-format'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, ingress=ingress)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, ingress=ingress)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_storm_control_ingress_rate_percent_delete(self, tengigabitethernet=None, ingress=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ingress: protocol_type
    :param ingress: Keyword argument tuple.

    :type protocol_type: unicode
    :param protocol_type: **ingress** tuple argument.

        * enumeration restriction: ::

            ['broadcast', 'unknown-unicast', 'multicast']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.storm_control.ingress', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.storm_control.ingress', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.storm_control.ingress', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ingress', 'keyval': 'protocol_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rate-percent'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, ingress=ingress)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, ingress=ingress)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_switchport_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.switchport_basic', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.switchport_basic', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.switchport_basic', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'switchport'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_switchport_access_mac_group_rspan_vlan_classification_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.switchport.access_mac_group_rspan_vlan_classification', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.switchport.access_mac_group_rspan_vlan_classification', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.switchport.access_mac_group_rspan_vlan_classification', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_switchport_access_mac_group_vlan_classification_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.switchport.access_mac_group_vlan_classification', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.switchport.access_mac_group_vlan_classification', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.switchport.access_mac_group_vlan_classification', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_switchport_access_mac_rspan_vlan_classification_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.switchport.access_mac_rspan_vlan_classification', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.switchport.access_mac_rspan_vlan_classification', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.switchport.access_mac_rspan_vlan_classification', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_switchport_access_mac_vlan_classification_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.switchport.access_mac_vlan_classification', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.switchport.access_mac_vlan_classification', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.switchport.access_mac_vlan_classification', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_switchport_access_rspan_vlan_delete(self, tengigabitethernet=None, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vlan: access_vlan_id, access_mac_group
    :param vlan: Keyword argument tuple.

    :type access_vlan_id: long
    :param access_vlan_id: **vlan** tuple argument:  Set the default VLAN for the interface

        * range restriction: ::

            ['0..4294967295']

    :type access_mac_group: long
    :param access_mac_group: **vlan** tuple argument:  Associate a Mac group with a vlan

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.switchport.access_mac_group_rspan_vlan_classification.access.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.switchport.access_mac_group_rspan_vlan_classification.access.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.switchport.access_mac_group_rspan_vlan_classification.access.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'access_vlan_id, access_mac_group', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_switchport_access_rspan_vlan_access_mac_rspan_vlan_classification_delete(self, tengigabitethernet=None, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vlan: access_vlan_id, access_mac_address
    :param vlan: Keyword argument tuple.

    :type access_vlan_id: long
    :param access_vlan_id: **vlan** tuple argument:  Set the default VLAN for the interface

        * range restriction: ::

            ['0..4294967295']

    :type access_mac_address: unicode
    :param access_mac_address: **vlan** tuple argument:  Associate the Mac address with a vlan

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.switchport.access_mac_rspan_vlan_classification.access.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.switchport.access_mac_rspan_vlan_classification.access.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.switchport.access_mac_rspan_vlan_classification.access.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'access_vlan_id, access_mac_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_switchport_access_vlan_delete(self, tengigabitethernet=None, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vlan: access_vlan_id, access_mac_group
    :param vlan: Keyword argument tuple.

    :type access_vlan_id: long
    :param access_vlan_id: **vlan** tuple argument:  Set the default VLAN for the interface

        * range restriction: ::

            ['0..4294967295']

    :type access_mac_group: long
    :param access_mac_group: **vlan** tuple argument:  Associate a Mac group with a vlan

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.switchport.access_mac_group_vlan_classification.access.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.switchport.access_mac_group_vlan_classification.access.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.switchport.access_mac_group_vlan_classification.access.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'access_vlan_id, access_mac_group', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_switchport_access_vlan_access_mac_vlan_classification_delete(self, tengigabitethernet=None, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vlan: access_vlan_id, access_mac_address
    :param vlan: Keyword argument tuple.

    :type access_vlan_id: long
    :param access_vlan_id: **vlan** tuple argument:  Set the default VLAN for the interface

        * range restriction: ::

            ['0..4294967295']

    :type access_mac_address: unicode
    :param access_mac_address: **vlan** tuple argument:  Associate the Mac address with a vlan

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.switchport.access_mac_vlan_classification.access.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.switchport.access_mac_vlan_classification.access.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.switchport.access_mac_vlan_classification.access.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'access_vlan_id, access_mac_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_switchport_basic_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.switchport_basic', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.switchport_basic', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.switchport_basic', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_switchport_mode_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.switchport.mode', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.switchport.mode', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.switchport.mode', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_switchport_mode_private_vlan_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.switchport.mode.private_vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.switchport.mode.private_vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.switchport.mode.private_vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_switchport_mode_private_vlan_host_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.switchport.mode.private_vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.switchport.mode.private_vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.switchport.mode.private_vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'host'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_switchport_mode_private_vlan_promiscuous_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.switchport.mode.private_vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.switchport.mode.private_vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.switchport.mode.private_vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'promiscuous'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_switchport_mode_private_vlan_trunk_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.switchport.mode.private_vlan.private_vlan_trunk', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.switchport.mode.private_vlan.private_vlan_trunk', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.switchport.mode.private_vlan.private_vlan_trunk', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_switchport_mode_private_vlan_trunk_host_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.switchport.mode.private_vlan.private_vlan_trunk', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.switchport.mode.private_vlan.private_vlan_trunk', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.switchport.mode.private_vlan.private_vlan_trunk', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'host'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_switchport_mode_private_vlan_trunk_promiscuous_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.switchport.mode.private_vlan.private_vlan_trunk', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.switchport.mode.private_vlan.private_vlan_trunk', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.switchport.mode.private_vlan.private_vlan_trunk', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'promiscuous'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_switchport_mode_private_vlan_trunk_trunk_basic_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.switchport.mode.private_vlan.private_vlan_trunk', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.switchport.mode.private_vlan.private_vlan_trunk', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.switchport.mode.private_vlan.private_vlan_trunk', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'trunk-basic'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_switchport_mode_vlan_mode_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.switchport.mode', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.switchport.mode', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.switchport.mode', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vlan-mode'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_switchport_port_security_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.switchport.port_security', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.switchport.port_security', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.switchport.port_security', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_switchport_port_security_allowed_ouis_delete(self, tengigabitethernet=None, allowed_ouis=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type allowed_ouis: oui
    :param allowed_ouis: Keyword argument tuple.

    :type oui: unicode
    :param oui: **allowed_ouis** tuple argument:  <OUI> OUI in HHHH.HH00.0000 format

        * pattern restriction: ::

            '[0-9a-fA-F]{4}\.[0-9a-fA-F]{2}00\.0000'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.switchport.port_security.allowed_ouis', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.switchport.port_security.allowed_ouis', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.switchport.port_security.allowed_ouis', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'allowed_ouis', 'keyval': 'oui', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, allowed_ouis=allowed_ouis)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, allowed_ouis=allowed_ouis)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_switchport_port_security_max_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.switchport.port_security', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.switchport.port_security', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.switchport.port_security', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'max'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_switchport_port_security_port_secutiry_mac_address_delete(self, tengigabitethernet=None, port_secutiry_mac_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type port_secutiry_mac_address: mac_address, port_sec_vlan
    :param port_secutiry_mac_address: Keyword argument tuple.

    :type mac_address: unicode
    :param mac_address: **port_secutiry_mac_address** tuple argument:  Mac Address

    :type port_sec_vlan: long
    :param port_sec_vlan: **port_secutiry_mac_address** tuple argument:  Forwarding vlan

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.switchport.port_security.port_secutiry_mac_address', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.switchport.port_security.port_secutiry_mac_address', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.switchport.port_security.port_secutiry_mac_address', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'port_secutiry_mac_address', 'keyval': 'mac_address, port_sec_vlan', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, port_secutiry_mac_address=port_secutiry_mac_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, port_secutiry_mac_address=port_secutiry_mac_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_switchport_port_security_shutdown_time_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.switchport.port_security', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.switchport.port_security', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.switchport.port_security', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'shutdown-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_switchport_port_security_sticky_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet.switchport.port_security.sticky', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.switchport.port_security.sticky', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_switchport_port_security_sticky_port_secutiry_mac_address_delete(self, tengigabitethernet=None, port_secutiry_mac_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type port_secutiry_mac_address: mac_address, port_sec_vlan
    :param port_secutiry_mac_address: Keyword argument tuple.

    :type mac_address: unicode
    :param mac_address: **port_secutiry_mac_address** tuple argument:  Mac Address

    :type port_sec_vlan: long
    :param port_sec_vlan: **port_secutiry_mac_address** tuple argument:  Forwarding vlan

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.switchport.port_security.sticky.port_secutiry_mac_address', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.switchport.port_security.sticky.port_secutiry_mac_address', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.switchport.port_security.sticky.port_secutiry_mac_address', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'port_secutiry_mac_address', 'keyval': 'mac_address, port_sec_vlan', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, port_secutiry_mac_address=port_secutiry_mac_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, port_secutiry_mac_address=port_secutiry_mac_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_switchport_port_security_sticky_sticky_flag_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.switchport.port_security.sticky', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.switchport.port_security.sticky', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.switchport.port_security.sticky', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'sticky-flag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_switchport_port_security_violation_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.switchport.port_security', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.switchport.port_security', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.switchport.port_security', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'violation'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_switchport_private_vlan_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.switchport.private_vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.switchport.private_vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.switchport.private_vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_switchport_private_vlan_association_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.switchport.private_vlan.association', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.switchport.private_vlan.association', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.switchport.private_vlan.association', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_switchport_private_vlan_association_trunk_delete(self, tengigabitethernet=None, trunk=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type trunk: trunk_pri_pvlan, trunk_sec_pvlan
    :param trunk: Keyword argument tuple.

    :type trunk_pri_pvlan: long
    :param trunk_pri_pvlan: **trunk** tuple argument:  Primary vlan id

        * range restriction: ::

            ['0..4294967295']

    :type trunk_sec_pvlan: long
    :param trunk_sec_pvlan: **trunk** tuple argument:  Secondary vlan id 

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.switchport.private_vlan.association.trunk', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.switchport.private_vlan.association.trunk', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.switchport.private_vlan.association.trunk', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'trunk', 'keyval': 'trunk_pri_pvlan, trunk_sec_pvlan', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, trunk=trunk)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, trunk=trunk)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_switchport_private_vlan_host_association_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.switchport.private_vlan.host_association', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.switchport.private_vlan.host_association', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.switchport.private_vlan.host_association', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'host_pri_pvlan, host_sec_pvlan'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_switchport_private_vlan_host_association_host_pri_pvlan_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.switchport.private_vlan.host_association', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.switchport.private_vlan.host_association', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.switchport.private_vlan.host_association', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'host-pri-pvlan'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_switchport_private_vlan_host_association_host_sec_pvlan_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.switchport.private_vlan.host_association', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.switchport.private_vlan.host_association', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.switchport.private_vlan.host_association', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'host-sec-pvlan'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_switchport_private_vlan_mapping_delete(self, tengigabitethernet=None, mapping=None, oper=None, promis_sec_pvlan_range=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type mapping: promis_pri_pvlan, oper, promis_sec_pvlan_range
    :param mapping: Keyword argument tuple.

    :type promis_pri_pvlan: long
    :param promis_pri_pvlan: **mapping** tuple argument:  Primary vlan id

        * range restriction: ::

            ['0..4294967295']

    :type oper: unicode
    :param oper: **mapping** tuple argument.

        * enumeration restriction: ::

            ['add', 'delete']

    :type promis_sec_pvlan_range: unicode
    :param promis_sec_pvlan_range: **mapping** tuple argument:  Secondary vlan range

        * length restriction: ::

            ['1..253']

        * pattern restriction: ::

            '(([1-9][0-9]{0,2})|([1-7][0-9]{3})|(80[0-9]{2})|'
            '(81[0-8][0-9])|(819[01]))(-(([2-9])|([1-9][0-9]{'
            '1,2})|([1-7][0-9]{3})|(80[0-9]{2})|(81[0-8][0-9]'
            ')|(819[01])))?((,(([2-9])|([1-9][0-9]{1,2})|([1-'
            '7][0-9]{3})|(80[0-9]{2})|(81[0-8][0-9])|(819[01]'
            '))(-(([3-9])|([1-9][0-9]{1,2})|([1-7][0-9]{3})|('
            '80[0-9]{2})|(81[0-8][0-9])|(819[01])))?)?)*'

    **Instance Argument(s)**:

    :type oper: unicode
    :param oper: Keyword argument.

        * enumeration restriction: ::

            ['add', 'delete']

    :type promis_sec_pvlan_range: unicode
    :param promis_sec_pvlan_range: Secondary vlan range

        * length restriction: ::

            ['1..253']

        * pattern restriction: ::

            '(([1-9][0-9]{0,2})|([1-7][0-9]{3})|(80[0-9]{2})|'
            '(81[0-8][0-9])|(819[01]))(-(([2-9])|([1-9][0-9]{'
            '1,2})|([1-7][0-9]{3})|(80[0-9]{2})|(81[0-8][0-9]'
            ')|(819[01])))?((,(([2-9])|([1-9][0-9]{1,2})|([1-'
            '7][0-9]{3})|(80[0-9]{2})|(81[0-8][0-9])|(819[01]'
            '))(-(([3-9])|([1-9][0-9]{1,2})|([1-7][0-9]{3})|('
            '80[0-9]{2})|(81[0-8][0-9])|(819[01])))?)?)*'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.switchport.private_vlan.mapping', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.switchport.private_vlan.mapping', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.switchport.private_vlan.mapping', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mapping', 'keyval': 'promis_pri_pvlan', 'extra_keyval': 'promis_pri_pvlan, oper, promis_sec_pvlan_range'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, mapping=mapping, oper=oper, promis_sec_pvlan_range=promis_sec_pvlan_range)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, mapping=mapping, oper=oper, promis_sec_pvlan_range=promis_sec_pvlan_range)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_switchport_private_vlan_mapping_oper_delete(self, tengigabitethernet=None, mapping=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type mapping: promis_pri_pvlan
    :param mapping: Keyword argument tuple.

    :type promis_pri_pvlan: long
    :param promis_pri_pvlan: **mapping** tuple argument:  Primary vlan id

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.switchport.private_vlan.mapping', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.switchport.private_vlan.mapping', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.switchport.private_vlan.mapping', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mapping', 'keyval': 'promis_pri_pvlan', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'oper'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, mapping=mapping)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, mapping=mapping)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_switchport_private_vlan_mapping_promis_sec_pvlan_range_delete(self, tengigabitethernet=None, mapping=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type mapping: promis_pri_pvlan
    :param mapping: Keyword argument tuple.

    :type promis_pri_pvlan: long
    :param promis_pri_pvlan: **mapping** tuple argument:  Primary vlan id

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.switchport.private_vlan.mapping', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.switchport.private_vlan.mapping', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.switchport.private_vlan.mapping', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mapping', 'keyval': 'promis_pri_pvlan', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'promis-sec-pvlan-range'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, mapping=mapping)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, mapping=mapping)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_switchport_private_vlan_trunk_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.switchport.private_vlan.trunk', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.switchport.private_vlan.trunk', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.switchport.private_vlan.trunk', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_switchport_private_vlan_trunk_allowed_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.switchport.private_vlan.trunk.allowed', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.switchport.private_vlan.trunk.allowed', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.switchport.private_vlan.trunk.allowed', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_switchport_private_vlan_trunk_allowed_trunk_private_vlan_classification_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_switchport_private_vlan_trunk_allowed_vlan_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.switchport.private_vlan.trunk.allowed.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.switchport.private_vlan.trunk.allowed.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.switchport.private_vlan.trunk.allowed.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_switchport_private_vlan_trunk_allowed_vlan_add_delete(self, tengigabitethernet=None, add=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type add: trunk_vlan_id, trunk_ctag_id
    :param add: Keyword argument tuple.

    :type trunk_vlan_id: long
    :param trunk_vlan_id: **add** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type trunk_ctag_id: long
    :param trunk_ctag_id: **add** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan.add_', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan.add_', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan.add_', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'add', 'keyval': 'trunk_vlan_id, trunk_ctag_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, add=add)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, add=add)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_switchport_private_vlan_trunk_allowed_vlan_all_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.switchport.private_vlan.trunk.allowed.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.switchport.private_vlan.trunk.allowed.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.switchport.private_vlan.trunk.allowed.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'all'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_switchport_private_vlan_trunk_allowed_vlan_except_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.switchport.private_vlan.trunk.allowed.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.switchport.private_vlan.trunk.allowed.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.switchport.private_vlan.trunk.allowed.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'except'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_switchport_private_vlan_trunk_allowed_vlan_none_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.switchport.private_vlan.trunk.allowed.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.switchport.private_vlan.trunk.allowed.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.switchport.private_vlan.trunk.allowed.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'none'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_switchport_private_vlan_trunk_allowed_vlan_remove_delete(self, tengigabitethernet=None, remove=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type remove: trunk_vlan_id, trunk_ctag_id
    :param remove: Keyword argument tuple.

    :type trunk_vlan_id: long
    :param trunk_vlan_id: **remove** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type trunk_ctag_id: long
    :param trunk_ctag_id: **remove** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan.remove_', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan.remove_', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan.remove_', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'remove', 'keyval': 'trunk_vlan_id, trunk_ctag_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, remove=remove)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, remove=remove)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_switchport_private_vlan_trunk_allowed_vlan_trunk_private_vlan_classification_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_switchport_private_vlan_trunk_native_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.switchport.private_vlan.trunk.native', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.switchport.private_vlan.trunk.native', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.switchport.private_vlan.trunk.native', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'pvlanNativevlan, pvlan_native_vlan_ctag_id'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_switchport_private_vlan_trunk_native_ctag_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.switchport.private_vlan.trunk.native', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.switchport.private_vlan.trunk.native', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.switchport.private_vlan.trunk.native', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ctag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_switchport_private_vlan_trunk_native_vlan_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.switchport.private_vlan.trunk.native', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.switchport.private_vlan.trunk.native', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.switchport.private_vlan.trunk.native', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vlan'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_switchport_private_vlan_trunk_private_vlan_classification_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.switchport.trunk_private_vlan_classification.private_vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.switchport.trunk_private_vlan_classification.private_vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.switchport.trunk_private_vlan_classification.private_vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_switchport_private_vlan_trunk_tag_native_vlan_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.switchport.private_vlan.trunk.pvlan_tag', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.switchport.private_vlan.trunk.pvlan_tag', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.switchport.private_vlan.trunk.pvlan_tag', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'native-vlan'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_switchport_private_vlan_trunk_trunk_private_vlan_classification_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_switchport_trunk_allowed_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.switchport.trunk.allowed', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.switchport.trunk.allowed', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.switchport.trunk.allowed', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_switchport_trunk_allowed_rspan_vlan_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.switchport.trunk.allowed.rspan_vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.switchport.trunk.allowed.rspan_vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.switchport.trunk.allowed.rspan_vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_switchport_trunk_allowed_rspan_vlan_add_delete(self, tengigabitethernet=None, add=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type add: trunk_vlan_id, trunk_ctag_id
    :param add: Keyword argument tuple.

    :type trunk_vlan_id: long
    :param trunk_vlan_id: **add** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type trunk_ctag_id: long
    :param trunk_ctag_id: **add** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan.add_', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan.add_', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan.add_', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'add', 'keyval': 'trunk_vlan_id, trunk_ctag_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, add=add)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, add=add)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_switchport_trunk_allowed_rspan_vlan_remove_delete(self, tengigabitethernet=None, remove=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type remove: trunk_vlan_id, trunk_ctag_id
    :param remove: Keyword argument tuple.

    :type trunk_vlan_id: long
    :param trunk_vlan_id: **remove** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type trunk_ctag_id: long
    :param trunk_ctag_id: **remove** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan.remove_', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan.remove_', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan.remove_', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'remove', 'keyval': 'trunk_vlan_id, trunk_ctag_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, remove=remove)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, remove=remove)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_switchport_trunk_allowed_rspan_vlan_trunk_rspan_vlan_classification_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_switchport_trunk_allowed_trunk_rspan_vlan_classification_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_switchport_trunk_allowed_trunk_vlan_classification_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.switchport.trunk.trunk_vlan_classification.allowed', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.switchport.trunk.trunk_vlan_classification.allowed', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.switchport.trunk.trunk_vlan_classification.allowed', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_switchport_trunk_allowed_vlan_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.switchport.trunk.allowed.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.switchport.trunk.allowed.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.switchport.trunk.allowed.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_switchport_trunk_allowed_vlan_add_delete(self, tengigabitethernet=None, add=None, trunk_ctag_range=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type add: trunk_vlan_id
    :param add: Keyword argument tuple.

    :type trunk_vlan_id: long
    :param trunk_vlan_id: **add** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Argument(s)**:

    :type trunk_ctag_range: unicode
    :param trunk_ctag_range: Keyword argument.

        * length restriction: ::

            ['1..1000']

        * pattern restriction: ::

            '(([1-9][0-9]{0,2})|([1-3][0-9]{3})|(40[0-8][0-9]'
            ')|(409[0-4]))(-((1[0-9]{1,2})|([2-9][0-9]{0,2})|'
            '([1-3][0-9]{3})|(40[0-8][0-9])|(409[0-4])))?((,('
            '(1[0-9]{1,2})|([2-9][0-9]{0,2})|([1-3][0-9]{3})|'
            '(40[0-8][0-9])|(409[0-4]))(-((1[0-9]{1,2})|([2-9'
            '][0-9]{0,2})|([1-3][0-9]{3})|(40[0-8][0-9])|(409'
            '[0-4])))?)?)*'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan.add_', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan.add_', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan.add_', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'add', 'keyval': 'trunk_vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, add=add, trunk_ctag_range=trunk_ctag_range)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, add=add, trunk_ctag_range=trunk_ctag_range)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_switchport_trunk_allowed_vlan_add_ctag_delete(self, tengigabitethernet=None, add=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type add: trunk_vlan_id
    :param add: Keyword argument tuple.

    :type trunk_vlan_id: long
    :param trunk_vlan_id: **add** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan.add_', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan.add_', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan.add_', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'add', 'keyval': 'trunk_vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ctag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, add=add)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, add=add)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_switchport_trunk_allowed_vlan_all_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.switchport.trunk.allowed.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.switchport.trunk.allowed.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.switchport.trunk.allowed.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'all'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_switchport_trunk_allowed_vlan_except_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.switchport.trunk.allowed.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.switchport.trunk.allowed.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.switchport.trunk.allowed.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'except'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_switchport_trunk_allowed_vlan_none_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.switchport.trunk.allowed.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.switchport.trunk.allowed.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.switchport.trunk.allowed.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'none'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_switchport_trunk_allowed_vlan_remove_delete(self, tengigabitethernet=None, remove=None, trunk_ctag_range=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type remove: trunk_vlan_id
    :param remove: Keyword argument tuple.

    :type trunk_vlan_id: long
    :param trunk_vlan_id: **remove** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Argument(s)**:

    :type trunk_ctag_range: unicode
    :param trunk_ctag_range: Keyword argument.

        * length restriction: ::

            ['1..1000']

        * pattern restriction: ::

            '(([1-9][0-9]{0,2})|([1-3][0-9]{3})|(40[0-8][0-9]'
            ')|(409[0-4]))(-((1[0-9]{1,2})|([2-9][0-9]{0,2})|'
            '([1-3][0-9]{3})|(40[0-8][0-9])|(409[0-4])))?((,('
            '(1[0-9]{1,2})|([2-9][0-9]{0,2})|([1-3][0-9]{3})|'
            '(40[0-8][0-9])|(409[0-4]))(-((1[0-9]{1,2})|([2-9'
            '][0-9]{0,2})|([1-3][0-9]{3})|(40[0-8][0-9])|(409'
            '[0-4])))?)?)*'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan.remove_', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan.remove_', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan.remove_', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'remove', 'keyval': 'trunk_vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, remove=remove, trunk_ctag_range=trunk_ctag_range)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, remove=remove, trunk_ctag_range=trunk_ctag_range)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_switchport_trunk_allowed_vlan_remove_ctag_delete(self, tengigabitethernet=None, remove=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type remove: trunk_vlan_id
    :param remove: Keyword argument tuple.

    :type trunk_vlan_id: long
    :param trunk_vlan_id: **remove** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan.remove_', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan.remove_', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan.remove_', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'remove', 'keyval': 'trunk_vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ctag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, remove=remove)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, remove=remove)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_switchport_trunk_allowed_vlan_trunk_vlan_classification_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_switchport_trunk_allowed_vlanoper_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.switchport.trunk.allowed.vlanoper', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.switchport.trunk.allowed.vlanoper', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.switchport.trunk.allowed.vlanoper', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_switchport_trunk_allowed_vlanoper_vlan_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.switchport.trunk.allowed.vlanoper.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.switchport.trunk.allowed.vlanoper.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.switchport.trunk.allowed.vlanoper.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_switchport_trunk_allowed_vlanoper_vlan_add_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.switchport.trunk.allowed.vlanoper.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.switchport.trunk.allowed.vlanoper.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.switchport.trunk.allowed.vlanoper.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'add'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_switchport_trunk_allowed_vlanoper_vlan_remove_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.switchport.trunk.allowed.vlanoper.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.switchport.trunk.allowed.vlanoper.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.switchport.trunk.allowed.vlanoper.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'remove'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_switchport_trunk_ctag_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.switchport.trunk.native_vlan_classification', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.switchport.trunk.native_vlan_classification', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.switchport.trunk.native_vlan_classification', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ctag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_switchport_trunk_ctag_native_vlan_xtagged_config_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.switchport.trunk.native_vlan_xtagged_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.switchport.trunk.native_vlan_xtagged_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.switchport.trunk.native_vlan_xtagged_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ctag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_switchport_trunk_default_vlan_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.switchport.trunk.default_vlan_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.switchport.trunk.default_vlan_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.switchport.trunk.default_vlan_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'default-vlan'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_switchport_trunk_default_vlan_config_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.switchport.trunk.default_vlan_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.switchport.trunk.default_vlan_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.switchport.trunk.default_vlan_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'default_transparent_vlan'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_switchport_trunk_egress_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.switchport.trunk.native_vlan_xtagged_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.switchport.trunk.native_vlan_xtagged_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.switchport.trunk.native_vlan_xtagged_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'egress'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_switchport_trunk_native_vlan_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.switchport.trunk.native_vlan_classification', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.switchport.trunk.native_vlan_classification', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.switchport.trunk.native_vlan_classification', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'native-vlan'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_switchport_trunk_native_vlan_classification_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.switchport.trunk.native_vlan_classification', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.switchport.trunk.native_vlan_classification', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.switchport.trunk.native_vlan_classification', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'native_vlan_id, native_vlan_ctag_id'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_switchport_trunk_native_vlan_untagged_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.switchport.trunk.native_vlan_untagged_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.switchport.trunk.native_vlan_untagged_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.switchport.trunk.native_vlan_untagged_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'native-vlan-untagged'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_switchport_trunk_native_vlan_untagged_config_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.switchport.trunk.native_vlan_untagged_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.switchport.trunk.native_vlan_untagged_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.switchport.trunk.native_vlan_untagged_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'native_vlan_id_untagged'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_switchport_trunk_native_vlan_xtagged_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.switchport.trunk.native_vlan_xtagged_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.switchport.trunk.native_vlan_xtagged_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.switchport.trunk.native_vlan_xtagged_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'native-vlan-xtagged'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_switchport_trunk_native_vlan_xtagged_config_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.switchport.trunk.native_vlan_xtagged_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.switchport.trunk.native_vlan_xtagged_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.switchport.trunk.native_vlan_xtagged_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_switchport_trunk_private_vlan_classification_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.switchport.trunk_private_vlan_classification', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.switchport.trunk_private_vlan_classification', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.switchport.trunk_private_vlan_classification', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_switchport_trunk_tag_native_vlan_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.switchport.trunk.tag', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.switchport.trunk.tag', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.switchport.trunk.tag', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'native-vlan'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_switchport_trunk_trunk_vlan_classification_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.switchport.trunk.trunk_vlan_classification', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.switchport.trunk.trunk_vlan_classification', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.switchport.trunk.trunk_vlan_classification', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_track_enable_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.track', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.track', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.track', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_track_interface_delete(self, tengigabitethernet=None, interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type interface: track_interface_type, track_interface_name
    :param interface: Keyword argument tuple.

    :type track_interface_type: unicode
    :param track_interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 'port-channel']

    :type track_interface_name: unicode
    :param track_interface_name: **interface** tuple argument:  Interface name

        * pattern restriction: ::

            '(((([1-9]|[1-9][0-9]|1[0-9]{2}|2[0-3][0-9])/)?(('
            '[0-9]|1[0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0-9]'
            ')(:[1-4])?)|([1-9]|[1-9][0-9]|[1-9][0-9]{2}|[1-5'
            '][0-9]{3}|6[0-1][0-4]{2}))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.track.interface', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.track.interface', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.track.interface', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'track_interface_type, track_interface_name', 'extra_keyval': 'track_interface_type, track_interface_name'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, interface=interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_track_min_link_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.track', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.track', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.track', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'min-link'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_track_remove_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.track.remove_', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.track.remove_', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.track.remove_', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_track_remove_all_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.track.remove_', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.track.remove_', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.track.remove_', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'all'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_tunable_optics_sfpp_channel_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet.tunable_optics.sfpp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.tunable_optics.sfpp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'channel'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_tunnel_tagged_ieee_bpdu_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.tunnel', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.tunnel', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.tunnel', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tagged-ieee-bpdu'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_udld_enable_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.udld', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.udld', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.udld', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_vepa_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.vepa', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.vepa', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.vepa', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_vepa_enable_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.vepa', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.vepa', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.vepa', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_vlan_classifier_activate_group_delete(self, tengigabitethernet=None, group=None, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type group: groupid, vlan
    :param group: Keyword argument tuple.

    :type groupid: long
    :param groupid: **group** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vlan: long
    :param vlan: **group** tuple argument:  1-8191;;Vlan

        * range restriction: ::

            ['0..4294967295']

    **Instance Argument(s)**:

    :type vlan: long
    :param vlan: 1-8191;;Vlan

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.vlan.classifier.activate.group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.vlan.classifier.activate.group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.vlan.classifier.activate.group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'group', 'keyval': 'groupid', 'extra_keyval': 'groupid, vlan'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, group=group, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, group=group, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_vlan_classifier_activate_group_vlan_delete(self, tengigabitethernet=None, group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type group: groupid
    :param group: Keyword argument tuple.

    :type groupid: long
    :param groupid: **group** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.vlan.classifier.activate.group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.vlan.classifier.activate.group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.vlan.classifier.activate.group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'group', 'keyval': 'groupid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vlan'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, group=group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, group=group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_vrf_forwarding_delete(self, tengigabitethernet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.vrf', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.vrf', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.vrf', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'forwarding'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_vrrp_group_delete(self, tengigabitethernet=None, vrrp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.vrrp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.vrrp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.vrrp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, vrrp=vrrp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_vrrp_group_advertisement_interval_delete(self, tengigabitethernet=None, vrrp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.vrrp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.vrrp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.vrrp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'advertisement-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, vrrp=vrrp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_vrrp_group_arp_unicast_request_receive_delete(self, tengigabitethernet=None, vrrp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.vrrp', u'vrrp'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.vrrp', u'vrrp'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet.vrrp', u'vrrp')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.vrrp.arp.unicast_request', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.vrrp.arp.unicast_request', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.vrrp.arp.unicast_request', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'receive'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, vrrp=vrrp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_vrrp_group_description_delete(self, tengigabitethernet=None, vrrp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.vrrp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.vrrp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.vrrp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'description'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, vrrp=vrrp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_vrrp_group_enable_delete(self, tengigabitethernet=None, vrrp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.vrrp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.vrrp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.vrrp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, vrrp=vrrp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_vrrp_group_hold_time_delete(self, tengigabitethernet=None, vrrp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.vrrp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.vrrp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.vrrp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hold-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, vrrp=vrrp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_vrrp_group_preempt_mode_delete(self, tengigabitethernet=None, vrrp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.vrrp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.vrrp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.vrrp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'preempt-mode'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, vrrp=vrrp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_vrrp_group_priority_delete(self, tengigabitethernet=None, vrrp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.vrrp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.vrrp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.vrrp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, vrrp=vrrp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_vrrp_group_track_interface_delete(self, tengigabitethernet=None, vrrp=None, interface=None, track_priority=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Argument(s)**:

    :type track_priority: int
    :param track_priority: Track Priority

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.vrrp', u'vrrp'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.vrrp', u'vrrp'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet.vrrp', u'vrrp')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.vrrp.track.interface', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.vrrp.track.interface', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.vrrp.track.interface', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, vrrp=vrrp, interface=interface, track_priority=track_priority)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, vrrp=vrrp, interface=interface, track_priority=track_priority)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_vrrp_group_track_interface_priority_delete(self, tengigabitethernet=None, vrrp=None, interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.vrrp', u'vrrp'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.vrrp', u'vrrp'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet.vrrp', u'vrrp')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.vrrp.track.interface', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.vrrp.track.interface', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.vrrp.track.interface', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, vrrp=vrrp, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, vrrp=vrrp, interface=interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_vrrp_group_use_v2_checksum_delete(self, tengigabitethernet=None, vrrp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.vrrp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.vrrp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.vrrp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'use-v2-checksum'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, vrrp=vrrp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tengigabitethernet_vrrp_group_virtual_ip_delete(self, tengigabitethernet=None, vrrp=None, virtual_ip=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type virtual_ip: virtual_ipaddr
    :param virtual_ip: Keyword argument tuple.

    :type virtual_ipaddr: unicode
    :param virtual_ipaddr: **virtual_ip** tuple argument:  Virtual IPv4 address in dotted decimal

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2c.interface.tengigabitethernet.vrrp', u'vrrp'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.vrrp', u'vrrp'), ('pybind.nos.v7_1_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.vrrp', u'vrrp')]
    bindings_list = [('pybind.nos.v6_0_2c.interface.tengigabitethernet.vrrp.virtual_ip', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface.tengigabitethernet.vrrp.virtual_ip', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface.tengigabitethernet.vrrp.virtual_ip', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'virtual_ip', 'keyval': 'virtual_ipaddr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, vrrp=vrrp, virtual_ip=virtual_ip)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, vrrp=vrrp, virtual_ip=virtual_ip)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tunnel_delete(self, tunnel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type tunnel: identifier
    :param tunnel: Keyword argument tuple.

    :type identifier: long
    :param identifier: **tunnel** tuple argument:  Identifier value range 1 to 1024

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.tunnel', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tunnel', 'keyval': 'identifier', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tunnel=tunnel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tunnel=tunnel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tunnel_destination_delete(self, tunnel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type tunnel: identifier
    :param tunnel: Keyword argument tuple.

    :type identifier: long
    :param identifier: **tunnel** tuple argument:  Identifier value range 1 to 1024

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.tunnel', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tunnel', 'keyval': 'identifier', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'destination'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tunnel=tunnel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tunnel=tunnel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tunnel_dscp_delete(self, tunnel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type tunnel: identifier
    :param tunnel: Keyword argument tuple.

    :type identifier: long
    :param identifier: **tunnel** tuple argument:  Identifier value range 1 to 1024

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.tunnel', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tunnel', 'keyval': 'identifier', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dscp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tunnel=tunnel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tunnel=tunnel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tunnel_dscp_ttl_mode_delete(self, tunnel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type tunnel: identifier
    :param tunnel: Keyword argument tuple.

    :type identifier: long
    :param identifier: **tunnel** tuple argument:  Identifier value range 1 to 1024

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.tunnel', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tunnel', 'keyval': 'identifier', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dscp-ttl-mode'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tunnel=tunnel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tunnel=tunnel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tunnel_keepalive_delete(self, tunnel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tunnel: identifier
    :param tunnel: Keyword argument tuple.

    :type identifier: long
    :param identifier: **tunnel** tuple argument:  Identifier value range 1 to 1024

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.tunnel', u'tunnel')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.tunnel.keepalive', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'identifier', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tunnel=tunnel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tunnel=tunnel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tunnel_keepalive_retry_count_delete(self, tunnel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tunnel: identifier
    :param tunnel: Keyword argument tuple.

    :type identifier: long
    :param identifier: **tunnel** tuple argument:  Identifier value range 1 to 1024

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.tunnel', u'tunnel')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.tunnel.keepalive', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'identifier', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'retry-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tunnel=tunnel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tunnel=tunnel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tunnel_keepalive_time_interval_delete(self, tunnel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tunnel: identifier
    :param tunnel: Keyword argument tuple.

    :type identifier: long
    :param identifier: **tunnel** tuple argument:  Identifier value range 1 to 1024

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.tunnel', u'tunnel')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.tunnel.keepalive', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'identifier', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'time-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tunnel=tunnel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tunnel=tunnel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tunnel_map_delete(self, tunnel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tunnel: identifier
    :param tunnel: Keyword argument tuple.

    :type identifier: long
    :param identifier: **tunnel** tuple argument:  Identifier value range 1 to 1024

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.tunnel', u'tunnel')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.tunnel.tunnel_map', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'identifier', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v16r_1_00b.interface.tunnel.tunnel_map': [u'map_bd', u'map_vlan']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tunnel=tunnel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tunnel=tunnel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tunnel_map_bd_delete(self, tunnel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tunnel: identifier
    :param tunnel: Keyword argument tuple.

    :type identifier: long
    :param identifier: **tunnel** tuple argument:  Identifier value range 1 to 1024

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.tunnel', u'tunnel')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.tunnel.tunnel_map', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'identifier', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bd'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tunnel=tunnel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tunnel=tunnel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tunnel_map_vlan_delete(self, tunnel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tunnel: identifier
    :param tunnel: Keyword argument tuple.

    :type identifier: long
    :param identifier: **tunnel** tuple argument:  Identifier value range 1 to 1024

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.tunnel', u'tunnel')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.tunnel.tunnel_map', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'identifier', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vlan'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tunnel=tunnel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tunnel=tunnel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tunnel_map_vni_delete(self, tunnel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tunnel: identifier
    :param tunnel: Keyword argument tuple.

    :type identifier: long
    :param identifier: **tunnel** tuple argument:  Identifier value range 1 to 1024

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.tunnel', u'tunnel')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.tunnel.tunnel_map', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'identifier', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vni'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tunnel=tunnel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tunnel=tunnel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tunnel_mode_delete(self, tunnel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tunnel: identifier
    :param tunnel: Keyword argument tuple.

    :type identifier: long
    :param identifier: **tunnel** tuple argument:  Identifier value range 1 to 1024

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.tunnel', u'tunnel')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.tunnel.mode', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'identifier', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tunnel=tunnel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tunnel=tunnel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tunnel_mode_gre_delete(self, tunnel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tunnel: identifier
    :param tunnel: Keyword argument tuple.

    :type identifier: long
    :param identifier: **tunnel** tuple argument:  Identifier value range 1 to 1024

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.tunnel', u'tunnel')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.tunnel.mode.gre', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'identifier', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tunnel=tunnel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tunnel=tunnel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tunnel_mode_gre_ip_delete(self, tunnel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tunnel: identifier
    :param tunnel: Keyword argument tuple.

    :type identifier: long
    :param identifier: **tunnel** tuple argument:  Identifier value range 1 to 1024

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.tunnel', u'tunnel')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.tunnel.mode.gre', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'identifier', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ip'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tunnel=tunnel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tunnel=tunnel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tunnel_mode_vxlan_delete(self, tunnel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tunnel: identifier
    :param tunnel: Keyword argument tuple.

    :type identifier: long
    :param identifier: **tunnel** tuple argument:  Identifier value range 1 to 1024

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.tunnel', u'tunnel')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.tunnel.mode', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'identifier', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vxlan'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tunnel=tunnel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tunnel=tunnel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tunnel_name_delete(self, tunnel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type tunnel: identifier
    :param tunnel: Keyword argument tuple.

    :type identifier: long
    :param identifier: **tunnel** tuple argument:  Identifier value range 1 to 1024

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.tunnel', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tunnel', 'keyval': 'identifier', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tunnel=tunnel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tunnel=tunnel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tunnel_router_interface_delete(self, tunnel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tunnel: identifier
    :param tunnel: Keyword argument tuple.

    :type identifier: long
    :param identifier: **tunnel** tuple argument:  Identifier value range 1 to 1024

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.tunnel', u'tunnel')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.tunnel.tunnel_router_interface', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'identifier', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tunnel=tunnel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tunnel=tunnel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tunnel_router_interface_ve_delete(self, tunnel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tunnel: identifier
    :param tunnel: Keyword argument tuple.

    :type identifier: long
    :param identifier: **tunnel** tuple argument:  Identifier value range 1 to 1024

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.tunnel', u'tunnel')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.tunnel.tunnel_router_interface', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'identifier', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 've'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tunnel=tunnel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tunnel=tunnel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tunnel_shutdown_delete(self, tunnel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type tunnel: identifier
    :param tunnel: Keyword argument tuple.

    :type identifier: long
    :param identifier: **tunnel** tuple argument:  Identifier value range 1 to 1024

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.tunnel', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tunnel', 'keyval': 'identifier', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'shutdown'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tunnel=tunnel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tunnel=tunnel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tunnel_source_delete(self, tunnel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tunnel: identifier
    :param tunnel: Keyword argument tuple.

    :type identifier: long
    :param identifier: **tunnel** tuple argument:  Identifier value range 1 to 1024

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.tunnel', u'tunnel')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.tunnel.gre_source', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'identifier', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v16r_1_00b.interface.tunnel.gre_source': [u'source_address', u'interface_ethernet', u'interface_loopback', u'interface_ve']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tunnel=tunnel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tunnel=tunnel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tunnel_source_ethernet_delete(self, tunnel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tunnel: identifier
    :param tunnel: Keyword argument tuple.

    :type identifier: long
    :param identifier: **tunnel** tuple argument:  Identifier value range 1 to 1024

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.tunnel', u'tunnel')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.tunnel.gre_source', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'identifier', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ethernet'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tunnel=tunnel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tunnel=tunnel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tunnel_source_loopback_delete(self, tunnel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tunnel: identifier
    :param tunnel: Keyword argument tuple.

    :type identifier: long
    :param identifier: **tunnel** tuple argument:  Identifier value range 1 to 1024

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.tunnel', u'tunnel')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.tunnel.gre_source', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'identifier', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'loopback'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tunnel=tunnel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tunnel=tunnel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tunnel_source_source_address_delete(self, tunnel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tunnel: identifier
    :param tunnel: Keyword argument tuple.

    :type identifier: long
    :param identifier: **tunnel** tuple argument:  Identifier value range 1 to 1024

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.tunnel', u'tunnel')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.tunnel.gre_source', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'identifier', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'source-address'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tunnel=tunnel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tunnel=tunnel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tunnel_source_ve_delete(self, tunnel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tunnel: identifier
    :param tunnel: Keyword argument tuple.

    :type identifier: long
    :param identifier: **tunnel** tuple argument:  Identifier value range 1 to 1024

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface.tunnel', u'tunnel')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.tunnel.gre_source', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'identifier', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 've'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tunnel=tunnel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tunnel=tunnel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tunnel_statistics_delete(self, tunnel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type tunnel: identifier
    :param tunnel: Keyword argument tuple.

    :type identifier: long
    :param identifier: **tunnel** tuple argument:  Identifier value range 1 to 1024

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.tunnel', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tunnel', 'keyval': 'identifier', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'statistics'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tunnel=tunnel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tunnel=tunnel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_tunnel_ttl_delete(self, tunnel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type tunnel: identifier
    :param tunnel: Keyword argument tuple.

    :type identifier: long
    :param identifier: **tunnel** tuple argument:  Identifier value range 1 to 1024

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.interface.tunnel', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tunnel', 'keyval': 'identifier', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ttl'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tunnel=tunnel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tunnel=tunnel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ve: gve_name
    :param ve: Keyword argument tuple.

    :type gve_name: long
    :param gve_name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.interface_vlan.interface.ve', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface_vlan.interface.ve', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface_vlan.interface.ve', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.interface.ve', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u've', 'keyval': 'gve_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v6_0_2c.interface_vlan.interface.ve": {"global_ve_shutdown": "global_ve_shutdown", "gve_name": "gve_name"}, "pybind.slxos.v16r_1_00b.routing_system.interface.ve": {"global_ve_shutdown": "shutdown", "gve_name": "name"}, "pybind.nos.v7_1_0.interface_vlan.interface.ve": {"global_ve_shutdown": "global_ve_shutdown", "gve_name": "gve_name"}, "pybind.nos.v7_0_1b.interface_vlan.interface.ve": {"global_ve_shutdown": "global_ve_shutdown", "gve_name": "gve_name"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_attach_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: gve_name
    :param ve: Keyword argument tuple.

    :type gve_name: long
    :param gve_name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface_vlan.interface.ve', u've'), ('pybind.nos.v7_0_1b.interface_vlan.interface.ve', u've'), ('pybind.nos.v7_1_0.interface_vlan.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.interface_vlan.interface.ve.attach', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface_vlan.interface.ve.attach', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface_vlan.interface.ve.attach', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'gve_name', 'extra_keyval': ''}, {'keyval': 'gve_name', 'extra_keyval': ''}, {'keyval': 'gve_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_attach_rbridge_id_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: gve_name
    :param ve: Keyword argument tuple.

    :type gve_name: long
    :param gve_name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface_vlan.interface.ve', u've'), ('pybind.nos.v7_1_0.interface_vlan.interface.ve', u've'), ('pybind.nos.v6_0_2c.interface_vlan.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.interface_vlan.interface.ve.attach.rbridge_id', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface_vlan.interface.ve.attach.rbridge_id', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface_vlan.interface.ve.attach.rbridge_id', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'gve_name', 'extra_keyval': ''}, {'keyval': 'gve_name', 'extra_keyval': ''}, {'keyval': 'gve_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_attach_rbridge_id_add_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: gve_name
    :param ve: Keyword argument tuple.

    :type gve_name: long
    :param gve_name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface_vlan.interface.ve', u've'), ('pybind.nos.v7_1_0.interface_vlan.interface.ve', u've'), ('pybind.nos.v6_0_2c.interface_vlan.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.interface_vlan.interface.ve.attach.rbridge_id', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface_vlan.interface.ve.attach.rbridge_id', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface_vlan.interface.ve.attach.rbridge_id', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'gve_name', 'extra_keyval': ''}, {'keyval': 'gve_name', 'extra_keyval': ''}, {'keyval': 'gve_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'add'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_attach_rbridge_id_remove_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: gve_name
    :param ve: Keyword argument tuple.

    :type gve_name: long
    :param gve_name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface_vlan.interface.ve', u've'), ('pybind.nos.v7_1_0.interface_vlan.interface.ve', u've'), ('pybind.nos.v6_0_2c.interface_vlan.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.interface_vlan.interface.ve.attach.rbridge_id', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface_vlan.interface.ve.attach.rbridge_id', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface_vlan.interface.ve.attach.rbridge_id', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'gve_name', 'extra_keyval': ''}, {'keyval': 'gve_name', 'extra_keyval': ''}, {'keyval': 'gve_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'remove'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_bfd_interval_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.bfd.interval', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_bfd_interval_min_rx_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.bfd.interval', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'min-rx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_bfd_interval_min_tx_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.bfd.interval', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'min-tx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_bfd_interval_multiplier_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.bfd.interval', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'multiplier'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_bfd_shutdown_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.bfd', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'shutdown'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ip_access_group_delete(self, ve=None, access_group=None, traffic_type=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type access_group: ip_access_list, ip_direction, traffic_type
    :param access_group: Keyword argument tuple.

    :type ip_access_list: unicode
    :param ip_access_list: **access_group** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type ip_direction: unicode
    :param ip_direction: **access_group** tuple argument.

        * enumeration restriction: ::

            ['in', 'out']

    :type traffic_type: unicode
    :param traffic_type: **access_group** tuple argument.

        * enumeration restriction: ::

            ['switched', 'routed']

    **Instance Argument(s)**:

    :type traffic_type: unicode
    :param traffic_type: Keyword argument.

        * enumeration restriction: ::

            ['switched', 'routed']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ip_acl_interface.ip.access_group', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'access_group', 'keyval': 'ip_access_list, ip_direction', 'extra_keyval': 'ip_access_list, ip_direction, traffic_type'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, access_group=access_group, traffic_type=traffic_type)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, access_group=access_group, traffic_type=traffic_type)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ip_acl_interface_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ip_acl_interface', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ip_address_delete(self, ve=None, address=None, secondary=None, ospf_passive=None, ospf_ignore=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type address: address, secondary, ospf_passive, ospf_ignore
    :param address: Keyword argument tuple.

    :type address: unicode
    :param address: **address** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]'
            '|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0'
            '-4][0-9]|25[0-5])/(([1-9])|([1-2][0-9])|(3[0-1])'
            ')'

    :type secondary: YANGBool
    :param secondary: **address** tuple argument:  Secondary ip address on the specific interface

    :type ospf_passive: YANGBool
    :param ospf_passive: **address** tuple argument:  ospf pasive address on the specific interface

    :type ospf_ignore: YANGBool
    :param ospf_ignore: **address** tuple argument:  ospf active address on the specific interface

    **Instance Argument(s)**:

    :type secondary: YANGBool
    :param secondary: Secondary ip address on the specific interface

    :type ospf_passive: YANGBool
    :param ospf_passive: ospf pasive address on the specific interface

    :type ospf_ignore: YANGBool
    :param ospf_ignore: ospf active address on the specific interface

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ip.ip_config.address', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'address', 'keyval': 'address', 'extra_keyval': 'address, secondary, ospf_passive, ospf_ignore'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, address=address, secondary=secondary, ospf_passive=ospf_passive, ospf_ignore=ospf_ignore)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, address=address, secondary=secondary, ospf_passive=ospf_passive, ospf_ignore=ospf_ignore)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ip_address_ospf_ignore_delete(self, ve=None, address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type address: address
    :param address: Keyword argument tuple.

    :type address: unicode
    :param address: **address** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]'
            '|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0'
            '-4][0-9]|25[0-5])/(([1-9])|([1-2][0-9])|(3[0-1])'
            ')'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ip.ip_config.address', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'address', 'keyval': 'address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ospf-ignore'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, address=address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, address=address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ip_address_ospf_passive_delete(self, ve=None, address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type address: address
    :param address: Keyword argument tuple.

    :type address: unicode
    :param address: **address** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]'
            '|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0'
            '-4][0-9]|25[0-5])/(([1-9])|([1-2][0-9])|(3[0-1])'
            ')'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ip.ip_config.address', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'address', 'keyval': 'address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ospf-passive'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, address=address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, address=address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ip_address_secondary_delete(self, ve=None, address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type address: address
    :param address: Keyword argument tuple.

    :type address: unicode
    :param address: **address** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]'
            '|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0'
            '-4][0-9]|25[0-5])/(([1-9])|([1-2][0-9])|(3[0-1])'
            ')'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ip.ip_config.address', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'address', 'keyval': 'address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'secondary'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, address=address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, address=address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ip_arp_aging_timeout_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ip.ip_config', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'arp-aging-timeout'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ip_dhcp_relay_gateway_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ip.interface_ve_dhcp_conf.dhcp.relay', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'gateway'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ip_dhcp_relay_servers_delete(self, ve=None, servers=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type servers: relay_ip_addr, server_vrf_name
    :param servers: Keyword argument tuple.

    :type relay_ip_addr: unicode
    :param relay_ip_addr: **servers** tuple argument:  A.B.C.D;; IP address of the DHCP server

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type server_vrf_name: unicode
    :param server_vrf_name: **servers** tuple argument:  VRF name of the DHCP server

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ip.interface_ve_dhcp_conf.dhcp.relay.servers', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'servers', 'keyval': 'relay_ip_addr, server_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, servers=servers)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, servers=servers)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ip_directed_broadcast_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ip.ip_config', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'directed-broadcast'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ip_fabric_virtual_gateway_delete(self, ve=None, ip_anycast_gateway=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: gve_name
    :param ve: Keyword argument tuple.

    :type gve_name: long
    :param gve_name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ip_anycast_gateway: ip_gw_id
    :param ip_anycast_gateway: Keyword argument tuple.

    :type ip_gw_id: long
    :param ip_gw_id: **ip_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface_vlan.interface.ve', u've'), ('pybind.nos.v7_0_1b.interface_vlan.interface.ve', u've'), ('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've'), ('pybind.nos.v7_1_0.interface_vlan.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.interface_vlan.interface.ve.ip.ip_anycast_gateway', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface_vlan.interface.ve.ip.ip_anycast_gateway', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface_vlan.interface.ve.ip.ip_anycast_gateway', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ip.ip_local_anycast_gateway', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'gve_name', 'extra_keyval': ''}, {'keyval': 'gve_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'gve_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ip_anycast_gateway', 'keyval': 'ip_gw_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v7_0_1b.interface_vlan.interface.ve.ip.ip_anycast_gateway": {"enable": "enable", "description": "description", "ipv4_gateway_address": "ipv4_gateway_address", "ip_gw_id": "ip_gw_id", "load_balancing_disable": "load_balancing_disable", "hold_time": "hold_time"}, "pybind.slxos.v16r_1_00b.routing_system.interface.ve.ip.ip_local_anycast_gateway": {}, "pybind.nos.v6_0_2c.interface_vlan.interface.ve.ip.ip_anycast_gateway": {"enable": "enable", "description": "description", "ipv4_gateway_address": "ipv4_gateway_address", "ip_gw_id": "ip_gw_id", "load_balancing_disable": "load_balancing_disable", "hold_time": "hold_time"}, "pybind.nos.v7_1_0.interface_vlan.interface.ve.ip.ip_anycast_gateway": {"enable": "enable", "description": "description", "ipv4_gateway_address": "ipv4_gateway_address", "ip_gw_id": "ip_gw_id", "load_balancing_disable": "load_balancing_disable", "hold_time": "hold_time"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, ip_anycast_gateway=ip_anycast_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, ip_anycast_gateway=ip_anycast_gateway)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ip_fabric_virtual_gateway_description_delete(self, ve=None, ip_anycast_gateway=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: gve_name
    :param ve: Keyword argument tuple.

    :type gve_name: long
    :param gve_name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ip_anycast_gateway: ip_gw_id
    :param ip_anycast_gateway: Keyword argument tuple.

    :type ip_gw_id: long
    :param ip_gw_id: **ip_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface_vlan.interface.ve', u've'), ('pybind.nos.v6_0_2c.interface_vlan.interface.ve', u've'), ('pybind.nos.v7_1_0.interface_vlan.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.interface_vlan.interface.ve.ip.ip_anycast_gateway', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface_vlan.interface.ve.ip.ip_anycast_gateway', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface_vlan.interface.ve.ip.ip_anycast_gateway', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'gve_name', 'extra_keyval': ''}, {'keyval': 'gve_name', 'extra_keyval': ''}, {'keyval': 'gve_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ip_anycast_gateway', 'keyval': 'ip_gw_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'description'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, ip_anycast_gateway=ip_anycast_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, ip_anycast_gateway=ip_anycast_gateway)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ip_fabric_virtual_gateway_disable_delete(self, ve=None, ip_local_anycast_gateway=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ip_local_anycast_gateway: local_ip_gw_id
    :param ip_local_anycast_gateway: Keyword argument tuple.

    :type local_ip_gw_id: long
    :param local_ip_gw_id: **ip_local_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ip.ip_local_anycast_gateway', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ip_local_anycast_gateway', 'keyval': 'local_ip_gw_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'disable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, ip_local_anycast_gateway=ip_local_anycast_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, ip_local_anycast_gateway=ip_local_anycast_gateway)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ip_fabric_virtual_gateway_enable_delete(self, ve=None, ip_anycast_gateway=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: gve_name
    :param ve: Keyword argument tuple.

    :type gve_name: long
    :param gve_name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ip_anycast_gateway: ip_gw_id
    :param ip_anycast_gateway: Keyword argument tuple.

    :type ip_gw_id: long
    :param ip_gw_id: **ip_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface_vlan.interface.ve', u've'), ('pybind.nos.v7_0_1b.interface_vlan.interface.ve', u've'), ('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've'), ('pybind.nos.v7_1_0.interface_vlan.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.interface_vlan.interface.ve.ip.ip_anycast_gateway', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface_vlan.interface.ve.ip.ip_anycast_gateway', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface_vlan.interface.ve.ip.ip_anycast_gateway', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ip.ip_local_anycast_gateway', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'gve_name', 'extra_keyval': ''}, {'keyval': 'gve_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'gve_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ip_anycast_gateway', 'keyval': 'ip_gw_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v7_0_1b.interface_vlan.interface.ve.ip.ip_anycast_gateway": {"ip_gw_id": "ip_gw_id", "enable": "enable"}, "pybind.slxos.v16r_1_00b.routing_system.interface.ve.ip.ip_local_anycast_gateway": {"ip_gw_id": "local_ip_gw_id", "enable": "enable_local"}, "pybind.nos.v6_0_2c.interface_vlan.interface.ve.ip.ip_anycast_gateway": {"ip_gw_id": "ip_gw_id", "enable": "enable"}, "pybind.nos.v7_1_0.interface_vlan.interface.ve.ip.ip_anycast_gateway": {"ip_gw_id": "ip_gw_id", "enable": "enable"}}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, ip_anycast_gateway=ip_anycast_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, ip_anycast_gateway=ip_anycast_gateway)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ip_fabric_virtual_gateway_gateway_address_delete(self, ve=None, ip_anycast_gateway=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: gve_name
    :param ve: Keyword argument tuple.

    :type gve_name: long
    :param gve_name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ip_anycast_gateway: ip_gw_id
    :param ip_anycast_gateway: Keyword argument tuple.

    :type ip_gw_id: long
    :param ip_gw_id: **ip_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface_vlan.interface.ve', u've'), ('pybind.nos.v6_0_2c.interface_vlan.interface.ve', u've'), ('pybind.nos.v7_1_0.interface_vlan.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.interface_vlan.interface.ve.ip.ip_anycast_gateway', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface_vlan.interface.ve.ip.ip_anycast_gateway', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface_vlan.interface.ve.ip.ip_anycast_gateway', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'gve_name', 'extra_keyval': ''}, {'keyval': 'gve_name', 'extra_keyval': ''}, {'keyval': 'gve_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ip_anycast_gateway', 'keyval': 'ip_gw_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'gateway-address'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, ip_anycast_gateway=ip_anycast_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, ip_anycast_gateway=ip_anycast_gateway)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ip_fabric_virtual_gateway_gratuitous_arp_delete(self, ve=None, ip_anycast_gateway=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: gve_name
    :param ve: Keyword argument tuple.

    :type gve_name: long
    :param gve_name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ip_anycast_gateway: ip_gw_id
    :param ip_anycast_gateway: Keyword argument tuple.

    :type ip_gw_id: long
    :param ip_gw_id: **ip_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface_vlan.interface.ve', u've'), ('pybind.nos.v7_0_1b.interface_vlan.interface.ve.ip.ip_anycast_gateway', u'ip_anycast_gateway'), ('pybind.nos.v6_0_2c.interface_vlan.interface.ve', u've'), ('pybind.nos.v6_0_2c.interface_vlan.interface.ve.ip.ip_anycast_gateway', u'ip_anycast_gateway'), ('pybind.nos.v7_1_0.interface_vlan.interface.ve', u've'), ('pybind.nos.v7_1_0.interface_vlan.interface.ve.ip.ip_anycast_gateway', u'ip_anycast_gateway')]
    bindings_list = [('pybind.nos.v6_0_2c.interface_vlan.interface.ve.ip.ip_anycast_gateway.gratuitous_arp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface_vlan.interface.ve.ip.ip_anycast_gateway.gratuitous_arp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface_vlan.interface.ve.ip.ip_anycast_gateway.gratuitous_arp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'gve_name', 'extra_keyval': ''}, {'keyval': 'ip_gw_id', 'extra_keyval': ''}, {'keyval': 'gve_name', 'extra_keyval': ''}, {'keyval': 'ip_gw_id', 'extra_keyval': ''}, {'keyval': 'gve_name', 'extra_keyval': ''}, {'keyval': 'ip_gw_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, ip_anycast_gateway=ip_anycast_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, ip_anycast_gateway=ip_anycast_gateway)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ip_fabric_virtual_gateway_gratuitous_arp_timer_delete(self, ve=None, ip_anycast_gateway=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: gve_name
    :param ve: Keyword argument tuple.

    :type gve_name: long
    :param gve_name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ip_anycast_gateway: ip_gw_id
    :param ip_anycast_gateway: Keyword argument tuple.

    :type ip_gw_id: long
    :param ip_gw_id: **ip_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface_vlan.interface.ve', u've'), ('pybind.nos.v7_0_1b.interface_vlan.interface.ve.ip.ip_anycast_gateway', u'ip_anycast_gateway'), ('pybind.nos.v6_0_2c.interface_vlan.interface.ve', u've'), ('pybind.nos.v6_0_2c.interface_vlan.interface.ve.ip.ip_anycast_gateway', u'ip_anycast_gateway'), ('pybind.nos.v7_1_0.interface_vlan.interface.ve', u've'), ('pybind.nos.v7_1_0.interface_vlan.interface.ve.ip.ip_anycast_gateway', u'ip_anycast_gateway')]
    bindings_list = [('pybind.nos.v6_0_2c.interface_vlan.interface.ve.ip.ip_anycast_gateway.gratuitous_arp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface_vlan.interface.ve.ip.ip_anycast_gateway.gratuitous_arp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface_vlan.interface.ve.ip.ip_anycast_gateway.gratuitous_arp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'gve_name', 'extra_keyval': ''}, {'keyval': 'ip_gw_id', 'extra_keyval': ''}, {'keyval': 'gve_name', 'extra_keyval': ''}, {'keyval': 'ip_gw_id', 'extra_keyval': ''}, {'keyval': 'gve_name', 'extra_keyval': ''}, {'keyval': 'ip_gw_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'timer'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, ip_anycast_gateway=ip_anycast_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, ip_anycast_gateway=ip_anycast_gateway)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ip_fabric_virtual_gateway_hold_time_delete(self, ve=None, ip_anycast_gateway=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: gve_name
    :param ve: Keyword argument tuple.

    :type gve_name: long
    :param gve_name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ip_anycast_gateway: ip_gw_id
    :param ip_anycast_gateway: Keyword argument tuple.

    :type ip_gw_id: long
    :param ip_gw_id: **ip_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface_vlan.interface.ve', u've'), ('pybind.nos.v6_0_2c.interface_vlan.interface.ve', u've'), ('pybind.nos.v7_1_0.interface_vlan.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.interface_vlan.interface.ve.ip.ip_anycast_gateway', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface_vlan.interface.ve.ip.ip_anycast_gateway', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface_vlan.interface.ve.ip.ip_anycast_gateway', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'gve_name', 'extra_keyval': ''}, {'keyval': 'gve_name', 'extra_keyval': ''}, {'keyval': 'gve_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ip_anycast_gateway', 'keyval': 'ip_gw_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hold-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, ip_anycast_gateway=ip_anycast_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, ip_anycast_gateway=ip_anycast_gateway)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ip_fabric_virtual_gateway_load_balancing_delete(self, ve=None, ip_local_anycast_gateway=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ip_local_anycast_gateway: local_ip_gw_id
    :param ip_local_anycast_gateway: Keyword argument tuple.

    :type local_ip_gw_id: long
    :param local_ip_gw_id: **ip_local_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've'), ('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ip.ip_local_anycast_gateway', u'ip_local_anycast_gateway')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ip.ip_local_anycast_gateway.load_balancing', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ip_gw_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, ip_local_anycast_gateway=ip_local_anycast_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, ip_local_anycast_gateway=ip_local_anycast_gateway)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ip_fabric_virtual_gateway_load_balancing_basic_delete(self, ve=None, ip_local_anycast_gateway=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ip_local_anycast_gateway: local_ip_gw_id
    :param ip_local_anycast_gateway: Keyword argument tuple.

    :type local_ip_gw_id: long
    :param local_ip_gw_id: **ip_local_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've'), ('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ip.ip_local_anycast_gateway', u'ip_local_anycast_gateway')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ip.ip_local_anycast_gateway.load_balancing', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ip_gw_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'basic'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, ip_local_anycast_gateway=ip_local_anycast_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, ip_local_anycast_gateway=ip_local_anycast_gateway)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ip_fabric_virtual_gateway_load_balancing_disable_delete(self, ve=None, ip_anycast_gateway=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: gve_name
    :param ve: Keyword argument tuple.

    :type gve_name: long
    :param gve_name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ip_anycast_gateway: ip_gw_id
    :param ip_anycast_gateway: Keyword argument tuple.

    :type ip_gw_id: long
    :param ip_gw_id: **ip_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface_vlan.interface.ve', u've'), ('pybind.nos.v6_0_2c.interface_vlan.interface.ve', u've'), ('pybind.nos.v7_1_0.interface_vlan.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.interface_vlan.interface.ve.ip.ip_anycast_gateway', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface_vlan.interface.ve.ip.ip_anycast_gateway', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface_vlan.interface.ve.ip.ip_anycast_gateway', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'gve_name', 'extra_keyval': ''}, {'keyval': 'gve_name', 'extra_keyval': ''}, {'keyval': 'gve_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ip_anycast_gateway', 'keyval': 'ip_gw_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'load-balancing-disable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, ip_anycast_gateway=ip_anycast_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, ip_anycast_gateway=ip_anycast_gateway)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ip_fabric_virtual_gateway_load_balancing_threshold_priority_delete(self, ve=None, ip_local_anycast_gateway=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ip_local_anycast_gateway: local_ip_gw_id
    :param ip_local_anycast_gateway: Keyword argument tuple.

    :type local_ip_gw_id: long
    :param local_ip_gw_id: **ip_local_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've'), ('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ip.ip_local_anycast_gateway', u'ip_local_anycast_gateway')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ip.ip_local_anycast_gateway.load_balancing', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ip_gw_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'threshold-priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, ip_local_anycast_gateway=ip_local_anycast_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, ip_local_anycast_gateway=ip_local_anycast_gateway)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ip_fabric_virtual_gateway_track_delete(self, ve=None, ip_local_anycast_gateway=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ip_local_anycast_gateway: local_ip_gw_id
    :param ip_local_anycast_gateway: Keyword argument tuple.

    :type local_ip_gw_id: long
    :param local_ip_gw_id: **ip_local_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've'), ('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ip.ip_local_anycast_gateway', u'ip_local_anycast_gateway')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ip.ip_local_anycast_gateway.track', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ip_gw_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, ip_local_anycast_gateway=ip_local_anycast_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, ip_local_anycast_gateway=ip_local_anycast_gateway)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ip_fabric_virtual_gateway_track_interface_delete(self, ve=None, ip_local_anycast_gateway=None, interface=None, interface_priority=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ip_local_anycast_gateway: local_ip_gw_id
    :param ip_local_anycast_gateway: Keyword argument tuple.

    :type local_ip_gw_id: long
    :param local_ip_gw_id: **ip_local_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Argument(s)**:

    :type interface_priority: long
    :param interface_priority: Track Priority

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've'), ('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ip.ip_local_anycast_gateway', u'ip_local_anycast_gateway')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ip.ip_local_anycast_gateway.track.interface', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ip_gw_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, ip_local_anycast_gateway=ip_local_anycast_gateway, interface=interface, interface_priority=interface_priority)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, ip_local_anycast_gateway=ip_local_anycast_gateway, interface=interface, interface_priority=interface_priority)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ip_fabric_virtual_gateway_track_interface_priority_delete(self, ve=None, ip_local_anycast_gateway=None, interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ip_local_anycast_gateway: local_ip_gw_id
    :param ip_local_anycast_gateway: Keyword argument tuple.

    :type local_ip_gw_id: long
    :param local_ip_gw_id: **ip_local_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've'), ('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ip.ip_local_anycast_gateway', u'ip_local_anycast_gateway')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ip.ip_local_anycast_gateway.track.interface', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ip_gw_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, ip_local_anycast_gateway=ip_local_anycast_gateway, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, ip_local_anycast_gateway=ip_local_anycast_gateway, interface=interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ip_fabric_virtual_gateway_track_network_delete(self, ve=None, ip_local_anycast_gateway=None, network=None, network_priority=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ip_local_anycast_gateway: local_ip_gw_id
    :param ip_local_anycast_gateway: Keyword argument tuple.

    :type local_ip_gw_id: long
    :param local_ip_gw_id: **ip_local_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type network: network_address
    :param network: Keyword argument tuple.

    :type network_address: unicode
    :param network_address: **network** tuple argument.

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]'
            '|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0'
            '-4][0-9]|25[0-5])/(([1-9])|([1-2][0-9])|(3[0-1])'
            ')'

    **Instance Argument(s)**:

    :type network_priority: long
    :param network_priority: Track Priority

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've'), ('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ip.ip_local_anycast_gateway', u'ip_local_anycast_gateway')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ip.ip_local_anycast_gateway.track.network', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ip_gw_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'network', 'keyval': 'network_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, ip_local_anycast_gateway=ip_local_anycast_gateway, network=network, network_priority=network_priority)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, ip_local_anycast_gateway=ip_local_anycast_gateway, network=network, network_priority=network_priority)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ip_fabric_virtual_gateway_track_network_priority_delete(self, ve=None, ip_local_anycast_gateway=None, network=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ip_local_anycast_gateway: local_ip_gw_id
    :param ip_local_anycast_gateway: Keyword argument tuple.

    :type local_ip_gw_id: long
    :param local_ip_gw_id: **ip_local_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type network: network_address
    :param network: Keyword argument tuple.

    :type network_address: unicode
    :param network_address: **network** tuple argument.

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]'
            '|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0'
            '-4][0-9]|25[0-5])/(([1-9])|([1-2][0-9])|(3[0-1])'
            ')'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've'), ('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ip.ip_local_anycast_gateway', u'ip_local_anycast_gateway')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ip.ip_local_anycast_gateway.track.network', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ip_gw_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'network', 'keyval': 'network_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, ip_local_anycast_gateway=ip_local_anycast_gateway, network=network)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, ip_local_anycast_gateway=ip_local_anycast_gateway, network=network)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ip_fabric_virtual_gateway_track_next_hop_delete(self, ve=None, ip_local_anycast_gateway=None, next_hop=None, next_hop_priority=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ip_local_anycast_gateway: local_ip_gw_id
    :param ip_local_anycast_gateway: Keyword argument tuple.

    :type local_ip_gw_id: long
    :param local_ip_gw_id: **ip_local_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type next_hop: next_hop_address
    :param next_hop: Keyword argument tuple.

    :type next_hop_address: unicode
    :param next_hop_address: **next_hop** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Argument(s)**:

    :type next_hop_priority: long
    :param next_hop_priority: Track Priority

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've'), ('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ip.ip_local_anycast_gateway', u'ip_local_anycast_gateway')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ip.ip_local_anycast_gateway.track.next_hop', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ip_gw_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'next_hop', 'keyval': 'next_hop_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, ip_local_anycast_gateway=ip_local_anycast_gateway, next_hop=next_hop, next_hop_priority=next_hop_priority)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, ip_local_anycast_gateway=ip_local_anycast_gateway, next_hop=next_hop, next_hop_priority=next_hop_priority)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ip_fabric_virtual_gateway_track_next_hop_priority_delete(self, ve=None, ip_local_anycast_gateway=None, next_hop=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ip_local_anycast_gateway: local_ip_gw_id
    :param ip_local_anycast_gateway: Keyword argument tuple.

    :type local_ip_gw_id: long
    :param local_ip_gw_id: **ip_local_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type next_hop: next_hop_address
    :param next_hop: Keyword argument tuple.

    :type next_hop_address: unicode
    :param next_hop_address: **next_hop** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've'), ('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ip.ip_local_anycast_gateway', u'ip_local_anycast_gateway')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ip.ip_local_anycast_gateway.track.next_hop', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ip_gw_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'next_hop', 'keyval': 'next_hop_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, ip_local_anycast_gateway=ip_local_anycast_gateway, next_hop=next_hop)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, ip_local_anycast_gateway=ip_local_anycast_gateway, next_hop=next_hop)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ip_icmp_plus_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ip.icmp_plus', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ip_icmp_plus_address_mask_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ip.icmp_plus', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'address-mask'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ip_icmp_plus_echo_reply_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ip.icmp_plus', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'echo-reply'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ip_icmp_plus_unreachable_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ip.icmp_plus', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'unreachable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ip_icmp_rate_limiting_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ip.icmp', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rate-limiting'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ip_igmp_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ip.igmp', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ip_igmp_immediate_leave_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ip.igmp', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'immediate-leave'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ip_igmp_last_member_query_interval_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ip.igmp', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'last-member-query-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ip_igmp_query_interval_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ip.igmp', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'query-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ip_igmp_query_max_response_time_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ip.igmp', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'query-max-response-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ip_igmp_static_group_delete(self, ve=None, ve_igmpl3_static_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ve_igmpl3_static_group: igmpl3_sg_addr
    :param ve_igmpl3_static_group: Keyword argument tuple.

    :type igmpl3_sg_addr: unicode
    :param igmpl3_sg_addr: **ve_igmpl3_static_group** tuple argument:  Multicast Address to be Joined in the format A.B.C.D

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ip.igmp.ve_igmpl3_static_group', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u've_igmpl3_static_group', 'keyval': 'igmpl3_sg_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, ve_igmpl3_static_group=ve_igmpl3_static_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, ve_igmpl3_static_group=ve_igmpl3_static_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ip_igmp_version_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ip.igmp', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'version'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ip_interface_ve_dhcp_conf_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ip.interface_ve_dhcp_conf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ip_interface_vlan_ospf_conf_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ip.interface_vlan_ospf_conf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ip_intf_router_isis_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ip.intf_router_isis', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ip_ip_config_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ip.ip_config', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ip_mtu_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ip.ip_config', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mtu'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ip_multicast_boundary_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ip.pim_intf_vlan_cont.pim_int_cmd', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'multicast-boundary'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ip_ospf_active_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'active'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ip_ospf_area_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'area'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ip_ospf_auth_change_wait_time_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'auth-change-wait-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ip_ospf_authentication_key_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1.authentication_key', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ip_ospf_authentication_key_auth_key_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1.authentication_key.auth_key_table', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'auth-key'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ip_ospf_authentication_key_auth_key_table_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1.authentication_key.auth_key_table', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'encrypttype, auth_key'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ip_ospf_authentication_key_encrypttype_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1.authentication_key.auth_key_table', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'encrypttype'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ip_ospf_authentication_key_no_encrypt_auth_key_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1.authentication_key.no_encrypt_auth_key_table', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'no-encrypt-auth-key'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ip_ospf_authentication_key_no_encrypt_auth_key_table_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1.authentication_key.no_encrypt_auth_key_table', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ip_ospf_bfd_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1.bfd', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ip_ospf_bfd_intf_bfd_enable_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1.bfd', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'intf-bfd-enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ip_ospf_cost_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cost'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ip_ospf_database_filter_all_external_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1.database_filter', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'all-external'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ip_ospf_database_filter_all_out_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1.database_filter', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'all-out'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ip_ospf_database_filter_all_summary_external_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1.database_filter', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'all-summary-external'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ip_ospf_dead_interval_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dead-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ip_ospf_hello_interval_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hello-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ip_ospf_ldp_sync_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ldp-sync'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ip_ospf_md5_authentication_key_activation_wait_time_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1.md5_authentication', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'key-activation-wait-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ip_ospf_md5_authentication_key_id_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1.md5_authentication.key_table', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'key_id, key, md5_authentication_key'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ip_ospf_md5_authentication_key_id_key_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1.md5_authentication.key_table', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'key'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ip_ospf_md5_authentication_key_id_key_id_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1.md5_authentication.key_table', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'key-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ip_ospf_md5_authentication_no_encrypt_key_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1.md5_authentication.no_encrypt_key_table', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'no-encrypt-key'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ip_ospf_md5_authentication_no_encrypt_key_id_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1.md5_authentication.no_encrypt_key_table', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'no-encrypt-key-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ip_ospf_mtu_ignore_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mtu-ignore'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ip_ospf_network_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'network'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ip_ospf_passive_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'passive'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ip_ospf_priority_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ip_ospf_retransmit_interval_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'retransmit-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ip_ospf_transmit_delay_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'transmit-delay'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ip_pbr_interface_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ip_pbr_interface', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ip_pim_dr_priority_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ip.pim_intf_vlan_cont.pim_int_cmd.pim', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dr-priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ip_pim_int_cmd_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ip.pim_intf_vlan_cont.pim_int_cmd', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ip_pim_intf_vlan_cont_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ip.pim_intf_vlan_cont', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ip_pim_neighbor_filter_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ip.pim_intf_vlan_cont.pim_int_cmd.pim', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'neighbor-filter'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ip_pim_sparse_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ip.pim_intf_vlan_cont.pim_int_cmd', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'pim-sparse'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ip_pim_ttl_threshold_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ip.pim_intf_vlan_cont.pim_int_cmd.pim', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ttl-threshold'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ip_policy_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ip_pbr_interface.ip.policy', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ip_policy_route_map_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ip_pbr_interface.ip.policy.route_map', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ip_policy_route_map_route_map_name_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ip_pbr_interface.ip.policy.route_map', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ip_proxy_arp_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ip.ip_config', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'proxy-arp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ip_router_isis_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ip.intf_router_isis.int_router_isis', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'isis'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ip_vrrp_extended_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ip.ip_vrrp_extended', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ip_vrrp_extended_auth_type_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ip.ip_vrrp_extended.auth_type', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ip_vrrp_extended_auth_type_md5_auth_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ip.ip_vrrp_extended.auth_type.md5_auth', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ip_vrrp_extended_auth_type_md5_auth_auth_data_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ip.ip_vrrp_extended.auth_type.md5_auth', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'auth-data'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_access_group_delete(self, ve=None, access_group=None, traffic_type=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type access_group: ipv6_access_list, ip_direction, traffic_type
    :param access_group: Keyword argument tuple.

    :type ipv6_access_list: unicode
    :param ipv6_access_list: **access_group** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type ip_direction: unicode
    :param ip_direction: **access_group** tuple argument.

        * enumeration restriction: ::

            ['in', 'out']

    :type traffic_type: unicode
    :param traffic_type: **access_group** tuple argument.

        * enumeration restriction: ::

            ['switched', 'routed']

    **Instance Argument(s)**:

    :type traffic_type: unicode
    :param traffic_type: Keyword argument.

        * enumeration restriction: ::

            ['switched', 'routed']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.access_group', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'access_group', 'keyval': 'ipv6_access_list, ip_direction', 'extra_keyval': 'ipv6_access_list, ip_direction, traffic_type'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, access_group=access_group, traffic_type=traffic_type)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, access_group=access_group, traffic_type=traffic_type)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_access_group_traffic_type_delete(self, ve=None, access_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type access_group: ipv6_access_list, ip_direction
    :param access_group: Keyword argument tuple.

    :type ipv6_access_list: unicode
    :param ipv6_access_list: **access_group** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type ip_direction: unicode
    :param ip_direction: **access_group** tuple argument.

        * enumeration restriction: ::

            ['in', 'out']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.access_group', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'access_group', 'keyval': 'ipv6_access_list, ip_direction', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'traffic-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, access_group=access_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, access_group=access_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_address_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.ipv6_config.address', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_address_ipv6_address_delete(self, ve=None, ipv6_address=None, secondary=None, anycast=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ipv6_address: address, secondary, anycast
    :param ipv6_address: Keyword argument tuple.

    :type address: unicode
    :param address: **ipv6_address** tuple argument:  A:B::C:D/LEN;; IPv6 prefix format: xxxx:xxxx/ml, xxxx:xxxx::/ml, xxxx::xx/128

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type secondary: YANGBool
    :param secondary: **ipv6_address** tuple argument:  Configure Secondary ipv6 address on an interface

    :type anycast: YANGBool
    :param anycast: **ipv6_address** tuple argument:  Configure ipv6 address as anycast

    **Instance Argument(s)**:

    :type secondary: YANGBool
    :param secondary: Configure Secondary ipv6 address on an interface

    :type anycast: YANGBool
    :param anycast: Configure ipv6 address as anycast

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.ipv6_config.address.ipv6_address', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_address', 'keyval': 'address', 'extra_keyval': 'address, secondary, anycast'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, ipv6_address=ipv6_address, secondary=secondary, anycast=anycast)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, ipv6_address=ipv6_address, secondary=secondary, anycast=anycast)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_address_ipv6_address_anycast_delete(self, ve=None, ipv6_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ipv6_address: address
    :param ipv6_address: Keyword argument tuple.

    :type address: unicode
    :param address: **ipv6_address** tuple argument:  A:B::C:D/LEN;; IPv6 prefix format: xxxx:xxxx/ml, xxxx:xxxx::/ml, xxxx::xx/128

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.ipv6_config.address.ipv6_address', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_address', 'keyval': 'address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'anycast'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, ipv6_address=ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, ipv6_address=ipv6_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_address_ipv6_address_eui_64_delete(self, ve=None, ipv6_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv6_address: address, secondary, anycast
    :param ipv6_address: Keyword argument tuple.

    :type address: unicode
    :param address: **ipv6_address** tuple argument:  A:B::C:D/LEN;; IPv6 prefix format: xxxx:xxxx/ml, xxxx:xxxx::/ml, xxxx::xx/128

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type secondary: YANGBool
    :param secondary: **ipv6_address** tuple argument:  Configure Secondary ipv6 address on an interface

    :type anycast: YANGBool
    :param anycast: **ipv6_address** tuple argument:  Configure ipv6 address as anycast

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've'), ('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.ipv6_config.address.ipv6_address', u'ipv6_address')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.ipv6_config.address.ipv6_address.eui_config', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'address', 'extra_keyval': 'address, secondary, anycast'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'eui-64'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, ipv6_address=ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, ipv6_address=ipv6_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_address_ipv6_address_secondary_delete(self, ve=None, ipv6_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ipv6_address: address
    :param ipv6_address: Keyword argument tuple.

    :type address: unicode
    :param address: **ipv6_address** tuple argument:  A:B::C:D/LEN;; IPv6 prefix format: xxxx:xxxx/ml, xxxx:xxxx::/ml, xxxx::xx/128

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.ipv6_config.address.ipv6_address', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_address', 'keyval': 'address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'secondary'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, ipv6_address=ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, ipv6_address=ipv6_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_address_ipv6_address_secondary_eui_config_delete(self, ve=None, ipv6_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv6_address: address, secondary, anycast
    :param ipv6_address: Keyword argument tuple.

    :type address: unicode
    :param address: **ipv6_address** tuple argument:  A:B::C:D/LEN;; IPv6 prefix format: xxxx:xxxx/ml, xxxx:xxxx::/ml, xxxx::xx/128

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type secondary: YANGBool
    :param secondary: **ipv6_address** tuple argument:  Configure Secondary ipv6 address on an interface

    :type anycast: YANGBool
    :param anycast: **ipv6_address** tuple argument:  Configure ipv6 address as anycast

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've'), ('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.ipv6_config.address.ipv6_address', u'ipv6_address')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.ipv6_config.address.ipv6_address.eui_config', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'address', 'extra_keyval': 'address, secondary, anycast'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'secondary'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, ipv6_address=ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, ipv6_address=ipv6_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_address_link_local_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.ipv6_config.address.link_local_config', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'link-local'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_address_link_local_address_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.ipv6_config.address.link_local_config', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'link-local-address'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_address_link_local_config_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.ipv6_config.address.link_local_config', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'link_local_address, link_local'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_address_use_link_local_only_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.ipv6_config.address', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'use-link-local-only'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_dhcp_relay_servers_delete(self, ve=None, servers=None, server_vrf_name=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type servers: relay_ip_addr, server_vrf_name
    :param servers: Keyword argument tuple.

    :type relay_ip_addr: unicode
    :param relay_ip_addr: **servers** tuple argument:  IPv6 address of the DHCPv6 server

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type server_vrf_name: unicode
    :param server_vrf_name: **servers** tuple argument:  VRF name of the DHCPv6 server

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Argument(s)**:

    :type server_vrf_name: unicode
    :param server_vrf_name: VRF name of the DHCPv6 server

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.interface_ve_dhcp_conf.dhcp.relay.servers', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'servers', 'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, servers=servers, server_vrf_name=server_vrf_name)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, servers=servers, server_vrf_name=server_vrf_name)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_dhcp_relay_servers_interface_delete(self, ve=None, servers=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type servers: relay_ip_addr, server_vrf_name
    :param servers: Keyword argument tuple.

    :type relay_ip_addr: unicode
    :param relay_ip_addr: **servers** tuple argument:  IPv6 address of the DHCPv6 server

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type server_vrf_name: unicode
    :param server_vrf_name: **servers** tuple argument:  VRF name of the DHCPv6 server

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've'), ('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.interface_ve_dhcp_conf.dhcp.relay.servers', u'servers')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.interface_ve_dhcp_conf.dhcp.relay.servers.interface', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'interface_type, interface_name'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, servers=servers)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, servers=servers)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_dhcp_relay_servers_interface_interface_delete(self, ve=None, servers=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type servers: relay_ip_addr, server_vrf_name
    :param servers: Keyword argument tuple.

    :type relay_ip_addr: unicode
    :param relay_ip_addr: **servers** tuple argument:  IPv6 address of the DHCPv6 server

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type server_vrf_name: unicode
    :param server_vrf_name: **servers** tuple argument:  VRF name of the DHCPv6 server

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've'), ('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.interface_ve_dhcp_conf.dhcp.relay.servers', u'servers')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.interface_ve_dhcp_conf.dhcp.relay.servers.interface', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'interface'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, servers=servers)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, servers=servers)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_dhcp_relay_servers_interface_interface_name_delete(self, ve=None, servers=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type servers: relay_ip_addr, server_vrf_name
    :param servers: Keyword argument tuple.

    :type relay_ip_addr: unicode
    :param relay_ip_addr: **servers** tuple argument:  IPv6 address of the DHCPv6 server

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type server_vrf_name: unicode
    :param server_vrf_name: **servers** tuple argument:  VRF name of the DHCPv6 server

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've'), ('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.interface_ve_dhcp_conf.dhcp.relay.servers', u'servers')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.interface_ve_dhcp_conf.dhcp.relay.servers.interface', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'interface-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, servers=servers)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, servers=servers)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_dhcp_relay_servers_use_vrf_delete(self, ve=None, servers=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type servers: relay_ip_addr
    :param servers: Keyword argument tuple.

    :type relay_ip_addr: unicode
    :param relay_ip_addr: **servers** tuple argument:  IPv6 address of the DHCPv6 server

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.interface_ve_dhcp_conf.dhcp.relay.servers', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'servers', 'keyval': 'relay_ip_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'use-vrf'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, servers=servers)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, servers=servers)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_fabric_virtual_gateway_delete(self, ve=None, ipv6_anycast_gateway=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: gve_name
    :param ve: Keyword argument tuple.

    :type gve_name: long
    :param gve_name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ipv6_anycast_gateway: ipv6_gw_id
    :param ipv6_anycast_gateway: Keyword argument tuple.

    :type ipv6_gw_id: long
    :param ipv6_gw_id: **ipv6_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface_vlan.interface.ve', u've'), ('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've'), ('pybind.nos.v7_1_0.interface_vlan.interface.ve', u've'), ('pybind.nos.v7_0_1b.interface_vlan.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.interface_vlan.interface.ve.ipv6.ipv6_anycast_gateway', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface_vlan.interface.ve.ipv6.ipv6_anycast_gateway', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface_vlan.interface.ve.ipv6.ipv6_anycast_gateway', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'gve_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'gve_name', 'extra_keyval': ''}, {'keyval': 'gve_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_anycast_gateway', 'keyval': 'ipv6_gw_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v7_0_1b.interface_vlan.interface.ve.ipv6.ipv6_anycast_gateway": {"ipv6_gw_id": "ipv6_gw_id", "enable": "enable", "hold_time": "hold_time", "description": "description", "load_balancing_disable": "load_balancing_disable"}, "pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway": {}, "pybind.nos.v6_0_2c.interface_vlan.interface.ve.ipv6.ipv6_anycast_gateway": {"ipv6_gw_id": "ipv6_gw_id", "enable": "enable", "hold_time": "hold_time", "description": "description", "load_balancing_disable": "load_balancing_disable"}, "pybind.nos.v7_1_0.interface_vlan.interface.ve.ipv6.ipv6_anycast_gateway": {"ipv6_gw_id": "ipv6_gw_id", "enable": "enable", "hold_time": "hold_time", "description": "description", "load_balancing_disable": "load_balancing_disable"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, ipv6_anycast_gateway=ipv6_anycast_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, ipv6_anycast_gateway=ipv6_anycast_gateway)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_fabric_virtual_gateway_description_delete(self, ve=None, ipv6_anycast_gateway=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: gve_name
    :param ve: Keyword argument tuple.

    :type gve_name: long
    :param gve_name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ipv6_anycast_gateway: ipv6_gw_id
    :param ipv6_anycast_gateway: Keyword argument tuple.

    :type ipv6_gw_id: long
    :param ipv6_gw_id: **ipv6_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface_vlan.interface.ve', u've'), ('pybind.nos.v6_0_2c.interface_vlan.interface.ve', u've'), ('pybind.nos.v7_1_0.interface_vlan.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.interface_vlan.interface.ve.ipv6.ipv6_anycast_gateway', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface_vlan.interface.ve.ipv6.ipv6_anycast_gateway', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface_vlan.interface.ve.ipv6.ipv6_anycast_gateway', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'gve_name', 'extra_keyval': ''}, {'keyval': 'gve_name', 'extra_keyval': ''}, {'keyval': 'gve_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_anycast_gateway', 'keyval': 'ipv6_gw_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'description'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, ipv6_anycast_gateway=ipv6_anycast_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, ipv6_anycast_gateway=ipv6_anycast_gateway)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_fabric_virtual_gateway_disable_delete(self, ve=None, ipv6_local_anycast_gateway=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ipv6_local_anycast_gateway: local_ipv6_gw_id
    :param ipv6_local_anycast_gateway: Keyword argument tuple.

    :type local_ipv6_gw_id: long
    :param local_ipv6_gw_id: **ipv6_local_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_local_anycast_gateway', 'keyval': 'local_ipv6_gw_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'disable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, ipv6_local_anycast_gateway=ipv6_local_anycast_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, ipv6_local_anycast_gateway=ipv6_local_anycast_gateway)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_fabric_virtual_gateway_enable_delete(self, ve=None, ipv6_anycast_gateway=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: gve_name
    :param ve: Keyword argument tuple.

    :type gve_name: long
    :param gve_name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ipv6_anycast_gateway: ipv6_gw_id
    :param ipv6_anycast_gateway: Keyword argument tuple.

    :type ipv6_gw_id: long
    :param ipv6_gw_id: **ipv6_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface_vlan.interface.ve', u've'), ('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've'), ('pybind.nos.v7_1_0.interface_vlan.interface.ve', u've'), ('pybind.nos.v7_0_1b.interface_vlan.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.interface_vlan.interface.ve.ipv6.ipv6_anycast_gateway', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface_vlan.interface.ve.ipv6.ipv6_anycast_gateway', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface_vlan.interface.ve.ipv6.ipv6_anycast_gateway', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'gve_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'gve_name', 'extra_keyval': ''}, {'keyval': 'gve_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_anycast_gateway', 'keyval': 'ipv6_gw_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v7_0_1b.interface_vlan.interface.ve.ipv6.ipv6_anycast_gateway": {"ipv6_gw_id": "ipv6_gw_id", "enable": "enable"}, "pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway": {"ipv6_gw_id": "local_ipv6_gw_id", "enable": "enable_local"}, "pybind.nos.v6_0_2c.interface_vlan.interface.ve.ipv6.ipv6_anycast_gateway": {"ipv6_gw_id": "ipv6_gw_id", "enable": "enable"}, "pybind.nos.v7_1_0.interface_vlan.interface.ve.ipv6.ipv6_anycast_gateway": {"ipv6_gw_id": "ipv6_gw_id", "enable": "enable"}}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, ipv6_anycast_gateway=ipv6_anycast_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, ipv6_anycast_gateway=ipv6_anycast_gateway)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_fabric_virtual_gateway_gateway_address_delete(self, ve=None, ipv6_anycast_gateway=None, ipv6_gateway_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: gve_name
    :param ve: Keyword argument tuple.

    :type gve_name: long
    :param gve_name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv6_anycast_gateway: ipv6_gw_id
    :param ipv6_anycast_gateway: Keyword argument tuple.

    :type ipv6_gw_id: long
    :param ipv6_gw_id: **ipv6_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ipv6_gateway_address: ipv6_gw_addr
    :param ipv6_gateway_address: Keyword argument tuple.

    :type ipv6_gw_addr: unicode
    :param ipv6_gw_addr: **ipv6_gateway_address** tuple argument:  IPv6 Address/Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface_vlan.interface.ve', u've'), ('pybind.nos.v6_0_2c.interface_vlan.interface.ve.ipv6.ipv6_anycast_gateway', u'ipv6_anycast_gateway'), ('pybind.nos.v7_1_0.interface_vlan.interface.ve', u've'), ('pybind.nos.v7_1_0.interface_vlan.interface.ve.ipv6.ipv6_anycast_gateway', u'ipv6_anycast_gateway'), ('pybind.nos.v7_0_1b.interface_vlan.interface.ve', u've'), ('pybind.nos.v7_0_1b.interface_vlan.interface.ve.ipv6.ipv6_anycast_gateway', u'ipv6_anycast_gateway')]
    bindings_list = [('pybind.nos.v6_0_2c.interface_vlan.interface.ve.ipv6.ipv6_anycast_gateway.ipv6_gateway_address', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface_vlan.interface.ve.ipv6.ipv6_anycast_gateway.ipv6_gateway_address', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface_vlan.interface.ve.ipv6.ipv6_anycast_gateway.ipv6_gateway_address', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'gve_name', 'extra_keyval': ''}, {'keyval': 'ipv6_gw_id', 'extra_keyval': ''}, {'keyval': 'gve_name', 'extra_keyval': ''}, {'keyval': 'ipv6_gw_id', 'extra_keyval': ''}, {'keyval': 'gve_name', 'extra_keyval': ''}, {'keyval': 'ipv6_gw_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_gateway_address', 'keyval': 'ipv6_gw_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, ipv6_anycast_gateway=ipv6_anycast_gateway, ipv6_gateway_address=ipv6_gateway_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, ipv6_anycast_gateway=ipv6_anycast_gateway, ipv6_gateway_address=ipv6_gateway_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_fabric_virtual_gateway_gratuitous_arp_delete(self, ve=None, ipv6_anycast_gateway=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: gve_name
    :param ve: Keyword argument tuple.

    :type gve_name: long
    :param gve_name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv6_anycast_gateway: ipv6_gw_id
    :param ipv6_anycast_gateway: Keyword argument tuple.

    :type ipv6_gw_id: long
    :param ipv6_gw_id: **ipv6_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface_vlan.interface.ve', u've'), ('pybind.nos.v7_0_1b.interface_vlan.interface.ve.ipv6.ipv6_anycast_gateway', u'ipv6_anycast_gateway'), ('pybind.nos.v6_0_2c.interface_vlan.interface.ve', u've'), ('pybind.nos.v6_0_2c.interface_vlan.interface.ve.ipv6.ipv6_anycast_gateway', u'ipv6_anycast_gateway'), ('pybind.nos.v7_1_0.interface_vlan.interface.ve', u've'), ('pybind.nos.v7_1_0.interface_vlan.interface.ve.ipv6.ipv6_anycast_gateway', u'ipv6_anycast_gateway')]
    bindings_list = [('pybind.nos.v6_0_2c.interface_vlan.interface.ve.ipv6.ipv6_anycast_gateway.gratuitous_arp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface_vlan.interface.ve.ipv6.ipv6_anycast_gateway.gratuitous_arp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface_vlan.interface.ve.ipv6.ipv6_anycast_gateway.gratuitous_arp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'gve_name', 'extra_keyval': ''}, {'keyval': 'ipv6_gw_id', 'extra_keyval': ''}, {'keyval': 'gve_name', 'extra_keyval': ''}, {'keyval': 'ipv6_gw_id', 'extra_keyval': ''}, {'keyval': 'gve_name', 'extra_keyval': ''}, {'keyval': 'ipv6_gw_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, ipv6_anycast_gateway=ipv6_anycast_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, ipv6_anycast_gateway=ipv6_anycast_gateway)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_fabric_virtual_gateway_gratuitous_arp_timer_delete(self, ve=None, ipv6_anycast_gateway=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: gve_name
    :param ve: Keyword argument tuple.

    :type gve_name: long
    :param gve_name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv6_anycast_gateway: ipv6_gw_id
    :param ipv6_anycast_gateway: Keyword argument tuple.

    :type ipv6_gw_id: long
    :param ipv6_gw_id: **ipv6_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface_vlan.interface.ve', u've'), ('pybind.nos.v7_0_1b.interface_vlan.interface.ve.ipv6.ipv6_anycast_gateway', u'ipv6_anycast_gateway'), ('pybind.nos.v6_0_2c.interface_vlan.interface.ve', u've'), ('pybind.nos.v6_0_2c.interface_vlan.interface.ve.ipv6.ipv6_anycast_gateway', u'ipv6_anycast_gateway'), ('pybind.nos.v7_1_0.interface_vlan.interface.ve', u've'), ('pybind.nos.v7_1_0.interface_vlan.interface.ve.ipv6.ipv6_anycast_gateway', u'ipv6_anycast_gateway')]
    bindings_list = [('pybind.nos.v6_0_2c.interface_vlan.interface.ve.ipv6.ipv6_anycast_gateway.gratuitous_arp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface_vlan.interface.ve.ipv6.ipv6_anycast_gateway.gratuitous_arp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface_vlan.interface.ve.ipv6.ipv6_anycast_gateway.gratuitous_arp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'gve_name', 'extra_keyval': ''}, {'keyval': 'ipv6_gw_id', 'extra_keyval': ''}, {'keyval': 'gve_name', 'extra_keyval': ''}, {'keyval': 'ipv6_gw_id', 'extra_keyval': ''}, {'keyval': 'gve_name', 'extra_keyval': ''}, {'keyval': 'ipv6_gw_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'timer'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, ipv6_anycast_gateway=ipv6_anycast_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, ipv6_anycast_gateway=ipv6_anycast_gateway)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_fabric_virtual_gateway_hold_time_delete(self, ve=None, ipv6_anycast_gateway=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: gve_name
    :param ve: Keyword argument tuple.

    :type gve_name: long
    :param gve_name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ipv6_anycast_gateway: ipv6_gw_id
    :param ipv6_anycast_gateway: Keyword argument tuple.

    :type ipv6_gw_id: long
    :param ipv6_gw_id: **ipv6_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface_vlan.interface.ve', u've'), ('pybind.nos.v6_0_2c.interface_vlan.interface.ve', u've'), ('pybind.nos.v7_1_0.interface_vlan.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.interface_vlan.interface.ve.ipv6.ipv6_anycast_gateway', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface_vlan.interface.ve.ipv6.ipv6_anycast_gateway', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface_vlan.interface.ve.ipv6.ipv6_anycast_gateway', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'gve_name', 'extra_keyval': ''}, {'keyval': 'gve_name', 'extra_keyval': ''}, {'keyval': 'gve_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_anycast_gateway', 'keyval': 'ipv6_gw_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hold-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, ipv6_anycast_gateway=ipv6_anycast_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, ipv6_anycast_gateway=ipv6_anycast_gateway)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_fabric_virtual_gateway_load_balancing_delete(self, ve=None, ipv6_local_anycast_gateway=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv6_local_anycast_gateway: local_ipv6_gw_id
    :param ipv6_local_anycast_gateway: Keyword argument tuple.

    :type local_ipv6_gw_id: long
    :param local_ipv6_gw_id: **ipv6_local_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've'), ('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway', u'ipv6_local_anycast_gateway')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway.load_balancing', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ipv6_gw_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, ipv6_local_anycast_gateway=ipv6_local_anycast_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, ipv6_local_anycast_gateway=ipv6_local_anycast_gateway)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_fabric_virtual_gateway_load_balancing_basic_delete(self, ve=None, ipv6_local_anycast_gateway=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv6_local_anycast_gateway: local_ipv6_gw_id
    :param ipv6_local_anycast_gateway: Keyword argument tuple.

    :type local_ipv6_gw_id: long
    :param local_ipv6_gw_id: **ipv6_local_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've'), ('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway', u'ipv6_local_anycast_gateway')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway.load_balancing', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ipv6_gw_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'basic'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, ipv6_local_anycast_gateway=ipv6_local_anycast_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, ipv6_local_anycast_gateway=ipv6_local_anycast_gateway)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_fabric_virtual_gateway_load_balancing_disable_delete(self, ve=None, ipv6_anycast_gateway=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: gve_name
    :param ve: Keyword argument tuple.

    :type gve_name: long
    :param gve_name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ipv6_anycast_gateway: ipv6_gw_id
    :param ipv6_anycast_gateway: Keyword argument tuple.

    :type ipv6_gw_id: long
    :param ipv6_gw_id: **ipv6_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface_vlan.interface.ve', u've'), ('pybind.nos.v6_0_2c.interface_vlan.interface.ve', u've'), ('pybind.nos.v7_1_0.interface_vlan.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.interface_vlan.interface.ve.ipv6.ipv6_anycast_gateway', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface_vlan.interface.ve.ipv6.ipv6_anycast_gateway', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface_vlan.interface.ve.ipv6.ipv6_anycast_gateway', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'gve_name', 'extra_keyval': ''}, {'keyval': 'gve_name', 'extra_keyval': ''}, {'keyval': 'gve_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_anycast_gateway', 'keyval': 'ipv6_gw_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'load-balancing-disable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, ipv6_anycast_gateway=ipv6_anycast_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, ipv6_anycast_gateway=ipv6_anycast_gateway)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_fabric_virtual_gateway_load_balancing_threshold_priority_delete(self, ve=None, ipv6_local_anycast_gateway=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv6_local_anycast_gateway: local_ipv6_gw_id
    :param ipv6_local_anycast_gateway: Keyword argument tuple.

    :type local_ipv6_gw_id: long
    :param local_ipv6_gw_id: **ipv6_local_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've'), ('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway', u'ipv6_local_anycast_gateway')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway.load_balancing', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ipv6_gw_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'threshold-priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, ipv6_local_anycast_gateway=ipv6_local_anycast_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, ipv6_local_anycast_gateway=ipv6_local_anycast_gateway)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_fabric_virtual_gateway_track_delete(self, ve=None, ipv6_local_anycast_gateway=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv6_local_anycast_gateway: local_ipv6_gw_id
    :param ipv6_local_anycast_gateway: Keyword argument tuple.

    :type local_ipv6_gw_id: long
    :param local_ipv6_gw_id: **ipv6_local_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've'), ('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway', u'ipv6_local_anycast_gateway')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway.ipv6_track', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ipv6_gw_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, ipv6_local_anycast_gateway=ipv6_local_anycast_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, ipv6_local_anycast_gateway=ipv6_local_anycast_gateway)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_fabric_virtual_gateway_track_interface_delete(self, ve=None, ipv6_local_anycast_gateway=None, ipv6_interface=None, ipv6_interface_priority=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv6_local_anycast_gateway: local_ipv6_gw_id
    :param ipv6_local_anycast_gateway: Keyword argument tuple.

    :type local_ipv6_gw_id: long
    :param local_ipv6_gw_id: **ipv6_local_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ipv6_interface: ipv6_interface_type, ipv6_interface_name
    :param ipv6_interface: Keyword argument tuple.

    :type ipv6_interface_type: unicode
    :param ipv6_interface_type: **ipv6_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 'port-channel']

    :type ipv6_interface_name: unicode
    :param ipv6_interface_name: **ipv6_interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Argument(s)**:

    :type ipv6_interface_priority: long
    :param ipv6_interface_priority: Track Priority

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've'), ('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway', u'ipv6_local_anycast_gateway')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway.ipv6_track.ipv6_interface', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ipv6_gw_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_interface', 'keyval': 'ipv6_interface_type, ipv6_interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, ipv6_local_anycast_gateway=ipv6_local_anycast_gateway, ipv6_interface=ipv6_interface, ipv6_interface_priority=ipv6_interface_priority)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, ipv6_local_anycast_gateway=ipv6_local_anycast_gateway, ipv6_interface=ipv6_interface, ipv6_interface_priority=ipv6_interface_priority)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_fabric_virtual_gateway_track_interface_priority_delete(self, ve=None, ipv6_local_anycast_gateway=None, ipv6_interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv6_local_anycast_gateway: local_ipv6_gw_id
    :param ipv6_local_anycast_gateway: Keyword argument tuple.

    :type local_ipv6_gw_id: long
    :param local_ipv6_gw_id: **ipv6_local_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ipv6_interface: ipv6_interface_type, ipv6_interface_name
    :param ipv6_interface: Keyword argument tuple.

    :type ipv6_interface_type: unicode
    :param ipv6_interface_type: **ipv6_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 'port-channel']

    :type ipv6_interface_name: unicode
    :param ipv6_interface_name: **ipv6_interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've'), ('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway', u'ipv6_local_anycast_gateway')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway.ipv6_track.ipv6_interface', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ipv6_gw_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_interface', 'keyval': 'ipv6_interface_type, ipv6_interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, ipv6_local_anycast_gateway=ipv6_local_anycast_gateway, ipv6_interface=ipv6_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, ipv6_local_anycast_gateway=ipv6_local_anycast_gateway, ipv6_interface=ipv6_interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_fabric_virtual_gateway_track_network_delete(self, ve=None, ipv6_local_anycast_gateway=None, ipv6_network=None, ipv6_network_priority=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv6_local_anycast_gateway: local_ipv6_gw_id
    :param ipv6_local_anycast_gateway: Keyword argument tuple.

    :type local_ipv6_gw_id: long
    :param local_ipv6_gw_id: **ipv6_local_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ipv6_network: ipv6_network_address
    :param ipv6_network: Keyword argument tuple.

    :type ipv6_network_address: unicode
    :param ipv6_network_address: **ipv6_network** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    **Instance Argument(s)**:

    :type ipv6_network_priority: long
    :param ipv6_network_priority: Track Priority

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've'), ('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway', u'ipv6_local_anycast_gateway')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway.ipv6_track.ipv6_network', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ipv6_gw_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_network', 'keyval': 'ipv6_network_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, ipv6_local_anycast_gateway=ipv6_local_anycast_gateway, ipv6_network=ipv6_network, ipv6_network_priority=ipv6_network_priority)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, ipv6_local_anycast_gateway=ipv6_local_anycast_gateway, ipv6_network=ipv6_network, ipv6_network_priority=ipv6_network_priority)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_fabric_virtual_gateway_track_network_priority_delete(self, ve=None, ipv6_local_anycast_gateway=None, ipv6_network=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv6_local_anycast_gateway: local_ipv6_gw_id
    :param ipv6_local_anycast_gateway: Keyword argument tuple.

    :type local_ipv6_gw_id: long
    :param local_ipv6_gw_id: **ipv6_local_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ipv6_network: ipv6_network_address
    :param ipv6_network: Keyword argument tuple.

    :type ipv6_network_address: unicode
    :param ipv6_network_address: **ipv6_network** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've'), ('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway', u'ipv6_local_anycast_gateway')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway.ipv6_track.ipv6_network', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ipv6_gw_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_network', 'keyval': 'ipv6_network_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, ipv6_local_anycast_gateway=ipv6_local_anycast_gateway, ipv6_network=ipv6_network)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, ipv6_local_anycast_gateway=ipv6_local_anycast_gateway, ipv6_network=ipv6_network)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_fabric_virtual_gateway_track_next_hop_delete(self, ve=None, ipv6_local_anycast_gateway=None, ipv6_next_hop=None, ipv6_next_hop_priority=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv6_local_anycast_gateway: local_ipv6_gw_id
    :param ipv6_local_anycast_gateway: Keyword argument tuple.

    :type local_ipv6_gw_id: long
    :param local_ipv6_gw_id: **ipv6_local_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ipv6_next_hop: ipv6_next_hop_address
    :param ipv6_next_hop: Keyword argument tuple.

    :type ipv6_next_hop_address: unicode
    :param ipv6_next_hop_address: **ipv6_next_hop** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    **Instance Argument(s)**:

    :type ipv6_next_hop_priority: long
    :param ipv6_next_hop_priority: Track Priority

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've'), ('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway', u'ipv6_local_anycast_gateway')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway.ipv6_track.ipv6_next_hop', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ipv6_gw_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_next_hop', 'keyval': 'ipv6_next_hop_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, ipv6_local_anycast_gateway=ipv6_local_anycast_gateway, ipv6_next_hop=ipv6_next_hop, ipv6_next_hop_priority=ipv6_next_hop_priority)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, ipv6_local_anycast_gateway=ipv6_local_anycast_gateway, ipv6_next_hop=ipv6_next_hop, ipv6_next_hop_priority=ipv6_next_hop_priority)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_fabric_virtual_gateway_track_next_hop_priority_delete(self, ve=None, ipv6_local_anycast_gateway=None, ipv6_next_hop=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv6_local_anycast_gateway: local_ipv6_gw_id
    :param ipv6_local_anycast_gateway: Keyword argument tuple.

    :type local_ipv6_gw_id: long
    :param local_ipv6_gw_id: **ipv6_local_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ipv6_next_hop: ipv6_next_hop_address
    :param ipv6_next_hop: Keyword argument tuple.

    :type ipv6_next_hop_address: unicode
    :param ipv6_next_hop_address: **ipv6_next_hop** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've'), ('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway', u'ipv6_local_anycast_gateway')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway.ipv6_track.ipv6_next_hop', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ipv6_gw_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_next_hop', 'keyval': 'ipv6_next_hop_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, ipv6_local_anycast_gateway=ipv6_local_anycast_gateway, ipv6_next_hop=ipv6_next_hop)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, ipv6_local_anycast_gateway=ipv6_local_anycast_gateway, ipv6_next_hop=ipv6_next_hop)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_hop_by_hop_trap_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.ipv6_ve_intf_cmds', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hop-by-hop-trap'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_icmpv6_rate_limiting_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.icmpv6', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rate-limiting'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_interface_ve_dhcp_conf_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.interface_ve_dhcp_conf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_intf_ipv6_router_isis_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.intf_ipv6_router_isis', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_ipv6_config_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.ipv6_config', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_ipv6_intf_cmds_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_ipv6_nd_ra_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.ipv6_nd_ra', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_ipv6_ve_intf_cmds_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.ipv6_ve_intf_cmds', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_mtu_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.ipv6_config', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mtu'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_nd_address_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.address', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_nd_address_suppress_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.address', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'suppress'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_nd_broadcast_mac_trap_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'broadcast-mac-trap'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_nd_cache_expire_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.cache', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'expire'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_nd_dad_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.dad', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_nd_dad_attempts_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.dad', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'attempts'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_nd_dad_time_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.dad', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_nd_hoplimit_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hoplimit'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_nd_managed_config_flag_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'managed-config-flag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_nd_mtu_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mtu'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_nd_ns_interval_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ns-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_nd_nud_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_nd_nud_retry_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'base, interval, max_attempts'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_nd_nud_retry_base_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'base'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_nd_nud_retry_interval_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_nd_nud_retry_max_attempts_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'max-attempts'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_nd_other_config_flag_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'other-config-flag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_nd_prefix_delete(self, ve=None, prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix', 'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, prefix=prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_nd_prefix_infinite_delete(self, ve=None, prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've'), ('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'infinite'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, prefix=prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_nd_prefix_infinite_preferred_delete(self, ve=None, prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've'), ('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'infinite'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, prefix=prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_nd_prefix_no_advertise_delete(self, ve=None, prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've'), ('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'no-advertise'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, prefix=prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_nd_prefix_no_autoconfig_delete(self, ve=None, prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've'), ('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'no-autoconfig'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, prefix=prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_nd_prefix_no_onlink_delete(self, ve=None, prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've'), ('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'no-onlink'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, prefix=prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_nd_prefix_off_link_delete(self, ve=None, prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've'), ('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'off-link'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, prefix=prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_nd_prefix_preferred_delete(self, ve=None, prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've'), ('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'preferred_lifetime, preferred_infinite'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred': [u'preferred_infinite', u'preferred_lifetime']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, prefix=prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_nd_prefix_preferred_lifetime_delete(self, ve=None, prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've'), ('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'preferred-lifetime'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, prefix=prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_nd_prefix_prefix_flags_delete(self, ve=None, prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've'), ('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'no_autoconfig, no_onlink, off_link'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, prefix=prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_nd_prefix_valid_lifetime_delete(self, ve=None, prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've'), ('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'valid-lifetime'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, prefix=prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_nd_proxy_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'proxy'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_nd_ra_dns_server_delete(self, ve=None, ra_dns_server=None, dns_server_lifetime_multiplier=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ra_dns_server: dns_server_prefix
    :param ra_dns_server: Keyword argument tuple.

    :type dns_server_prefix: unicode
    :param dns_server_prefix: **ra_dns_server** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    **Instance Argument(s)**:

    :type dns_server_lifetime_multiplier: long
    :param dns_server_lifetime_multiplier: Lifetime multiplier for the Recursive DNS Server option

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_dns_server', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ra_dns_server', 'keyval': 'dns_server_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, ra_dns_server=ra_dns_server, dns_server_lifetime_multiplier=dns_server_lifetime_multiplier)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, ra_dns_server=ra_dns_server, dns_server_lifetime_multiplier=dns_server_lifetime_multiplier)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_nd_ra_dns_server_lifetime_multiplier_delete(self, ve=None, ra_dns_server=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ra_dns_server: dns_server_prefix
    :param ra_dns_server: Keyword argument tuple.

    :type dns_server_prefix: unicode
    :param dns_server_prefix: **ra_dns_server** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_dns_server', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ra_dns_server', 'keyval': 'dns_server_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lifetime-multiplier'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, ra_dns_server=ra_dns_server)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, ra_dns_server=ra_dns_server)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_nd_ra_domain_name_delete(self, ve=None, ra_domain_name=None, domain_name_lifetime_multiplier=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ra_domain_name: domain_name_string
    :param ra_domain_name: Keyword argument tuple.

    :type domain_name_string: unicode
    :param domain_name_string: **ra_domain_name** tuple argument.

    **Instance Argument(s)**:

    :type domain_name_lifetime_multiplier: long
    :param domain_name_lifetime_multiplier: Lifetime multiplier for DNS Search List option

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_domain_name', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ra_domain_name', 'keyval': 'domain_name_string', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, ra_domain_name=ra_domain_name, domain_name_lifetime_multiplier=domain_name_lifetime_multiplier)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, ra_domain_name=ra_domain_name, domain_name_lifetime_multiplier=domain_name_lifetime_multiplier)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_nd_ra_domain_name_lifetime_multiplier_delete(self, ve=None, ra_domain_name=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ra_domain_name: domain_name_string
    :param ra_domain_name: Keyword argument tuple.

    :type domain_name_string: unicode
    :param domain_name_string: **ra_domain_name** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_domain_name', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ra_domain_name', 'keyval': 'domain_name_string', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lifetime-multiplier'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, ra_domain_name=ra_domain_name)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, ra_domain_name=ra_domain_name)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_nd_ra_interval_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_interval', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'max_interval, min_'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_nd_ra_interval_max_interval_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_interval', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'max-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_nd_ra_interval_min_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_interval', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'min'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_nd_ra_lifetime_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ra-lifetime'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_nd_reachable_time_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'reachable-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_nd_retrans_timer_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'retrans-timer'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_nd_router_preference_high_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.router_preference', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'high'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_nd_router_preference_low_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.router_preference', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'low'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_nd_router_preference_medium_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.router_preference', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'medium'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_nd_send_ra_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'send-ra'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_nd_suppress_ra_all_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'all'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_nd_suppress_ra_mtu_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mtu'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_nd_suppress_ra_suppress_ra_flag_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'suppress-ra-flag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_neighbor_delete(self, ve=None, neighbor=None, hardware_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type neighbor: ipv6_address
    :param neighbor: Keyword argument tuple.

    :type ipv6_address: unicode
    :param ipv6_address: **neighbor** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    **Instance Argument(s)**:

    :type hardware_address: unicode
    :param hardware_address: Keyword argument.

        * pattern restriction: ::

            '[0-9a-fA-F]{4}(.[0-9a-fA-F]{4}){2}'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.neighbor', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'neighbor', 'keyval': 'ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, neighbor=neighbor, hardware_address=hardware_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, neighbor=neighbor, hardware_address=hardware_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_neighbor_hardware_address_delete(self, ve=None, neighbor=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type neighbor: ipv6_address
    :param neighbor: Keyword argument tuple.

    :type ipv6_address: unicode
    :param ipv6_address: **neighbor** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.neighbor', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'neighbor', 'keyval': 'ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hardware-address'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, neighbor=neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, neighbor=neighbor)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_ospf_active_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.interface_ospfv3_conf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'active'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_ospf_area_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.interface_ospfv3_conf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'area'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_ospf_authentication_ah_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ah'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_ospf_authentication_esp_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'esp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_ospf_authentication_esp_auth_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'esp-auth'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_ospf_authentication_esp_key_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'esp-key'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_ospf_authentication_esp_no_encrypt_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'esp-no-encrypt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_ospf_authentication_ipsec_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_ospf_authentication_ipsec_disable_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'disable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_ospf_authentication_ipsec_key_add_remove_interval_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'key-add-remove-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_ospf_authentication_key_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'key'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_ospf_authentication_no_encrypt_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'no-encrypt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_ospf_authentication_spi_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'spi'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_ospf_bfd_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.interface_ospfv3_conf.bfd', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_ospf_bfd_bfd_enable_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.interface_ospfv3_conf.bfd', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bfd-enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_ospf_cost_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.interface_ospfv3_conf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cost'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_ospf_dead_interval_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dead-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_ospf_hello_interval_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hello-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_ospf_hello_jitter_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hello-jitter'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_ospf_instance_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.interface_ospfv3_conf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'instance'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_ospf_mtu_ignore_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.interface_ospfv3_conf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mtu-ignore'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_ospf_network_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.interface_ospfv3_conf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'network'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_ospf_passive_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.interface_ospfv3_conf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'passive'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_ospf_priority_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.interface_ospfv3_conf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_ospf_retransmit_interval_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'retransmit-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_ospf_suppress_linklsa_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.interface_ospfv3_conf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'suppress-linklsa'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_ospf_transmit_delay_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'transmit-delay'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_policy_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.policy', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_policy_route_map_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.policy.route_map', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_policy_route_map_ipv6_route_map_name_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.policy.route_map', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ipv6-route-map-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_router_isis_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.intf_ipv6_router_isis.int_ipv6_router_isis', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'isis'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_vrrp_extended_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.ipv6_vrrp_extended', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_vrrp_extended_auth_type_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.ipv6_vrrp_extended.auth_type', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_vrrp_extended_auth_type_md5_auth_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.ipv6_vrrp_extended.auth_type.md5_auth', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_vrrp_extended_auth_type_md5_auth_auth_data_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.ipv6_vrrp_extended.auth_type.md5_auth', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'auth-data'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_vrrp_extended_group_delete(self, ve=None, vrrpv3e=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.vrrpv3e', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpv3e=vrrpv3e)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpv3e=vrrpv3e)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_vrrp_extended_group_advertise_backup_delete(self, ve=None, vrrpv3e=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.vrrpv3e', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'advertise-backup'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpv3e=vrrpv3e)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpv3e=vrrpv3e)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_vrrp_extended_group_advertisement_interval_delete(self, ve=None, vrrpv3e=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.vrrpv3e', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'advertisement-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpv3e=vrrpv3e)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpv3e=vrrpv3e)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_vrrp_extended_group_advertisement_interval_scale_delete(self, ve=None, vrrpv3e=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.vrrpv3e', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'advertisement-interval-scale'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpv3e=vrrpv3e)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpv3e=vrrpv3e)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_vrrp_extended_group_backup_advertisement_interval_delete(self, ve=None, vrrpv3e=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.vrrpv3e', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'backup-advertisement-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpv3e=vrrpv3e)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpv3e=vrrpv3e)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_vrrp_extended_group_description_delete(self, ve=None, vrrpv3e=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.vrrpv3e', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'description'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpv3e=vrrpv3e)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpv3e=vrrpv3e)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_vrrp_extended_group_enable_delete(self, ve=None, vrrpv3e=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.vrrpv3e', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpv3e=vrrpv3e)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpv3e=vrrpv3e)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_vrrp_extended_group_hold_time_delete(self, ve=None, vrrpv3e=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.vrrpv3e', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hold-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpv3e=vrrpv3e)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpv3e=vrrpv3e)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_vrrp_extended_group_nd_advertisement_timer_delete(self, ve=None, vrrpv3e=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.vrrpv3e', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'nd-advertisement-timer'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpv3e=vrrpv3e)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpv3e=vrrpv3e)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_vrrp_extended_group_preempt_mode_delete(self, ve=None, vrrpv3e=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.vrrpv3e', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'preempt-mode'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpv3e=vrrpv3e)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpv3e=vrrpv3e)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_vrrp_extended_group_priority_delete(self, ve=None, vrrpv3e=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.vrrpv3e', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpv3e=vrrpv3e)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpv3e=vrrpv3e)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_vrrp_extended_group_short_path_forwarding_delete(self, ve=None, vrrpv3e=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've'), ('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.vrrpv3e', u'vrrpv3e')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.vrrpv3e.short_path_forwarding', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'basic, revert_priority'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpv3e=vrrpv3e)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpv3e=vrrpv3e)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_vrrp_extended_group_short_path_forwarding_basic_delete(self, ve=None, vrrpv3e=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've'), ('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.vrrpv3e', u'vrrpv3e')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.vrrpv3e.short_path_forwarding', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'basic'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpv3e=vrrpv3e)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpv3e=vrrpv3e)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_vrrp_extended_group_short_path_forwarding_revert_priority_delete(self, ve=None, vrrpv3e=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've'), ('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.vrrpv3e', u'vrrpv3e')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.vrrpv3e.short_path_forwarding', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'revert-priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpv3e=vrrpv3e)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpv3e=vrrpv3e)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_vrrp_extended_group_track_interface_delete(self, ve=None, vrrpv3e=None, interface=None, track_priority=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Argument(s)**:

    :type track_priority: int
    :param track_priority: Track Priority

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've'), ('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.vrrpv3e', u'vrrpv3e')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.vrrpv3e.track.interface', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpv3e=vrrpv3e, interface=interface, track_priority=track_priority)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpv3e=vrrpv3e, interface=interface, track_priority=track_priority)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_vrrp_extended_group_track_interface_priority_delete(self, ve=None, vrrpv3e=None, interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've'), ('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.vrrpv3e', u'vrrpv3e')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.vrrpv3e.track.interface', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpv3e=vrrpv3e, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpv3e=vrrpv3e, interface=interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_vrrp_extended_group_track_network_delete(self, ve=None, vrrpv3e=None, network=None, network_priority=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type network: network_address
    :param network: Keyword argument tuple.

    :type network_address: unicode
    :param network_address: **network** tuple argument:  XXXX::YYYY/L;;IPv6 global address prefix in ipv6-address/Prefix length format

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    **Instance Argument(s)**:

    :type network_priority: int
    :param network_priority: Keyword argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've'), ('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.vrrpv3e', u'vrrpv3e')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.vrrpv3e.track.network', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'network', 'keyval': 'network_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpv3e=vrrpv3e, network=network, network_priority=network_priority)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpv3e=vrrpv3e, network=network, network_priority=network_priority)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_vrrp_extended_group_track_network_priority_delete(self, ve=None, vrrpv3e=None, network=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type network: network_address
    :param network: Keyword argument tuple.

    :type network_address: unicode
    :param network_address: **network** tuple argument:  XXXX::YYYY/L;;IPv6 global address prefix in ipv6-address/Prefix length format

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've'), ('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.vrrpv3e', u'vrrpv3e')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.vrrpv3e.track.network', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'network', 'keyval': 'network_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpv3e=vrrpv3e, network=network)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpv3e=vrrpv3e, network=network)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_vrrp_extended_group_virtual_ip_delete(self, ve=None, vrrpv3e=None, virtual_ip=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type virtual_ip: virtual_ipaddr
    :param virtual_ip: Keyword argument tuple.

    :type virtual_ipaddr: unicode
    :param virtual_ipaddr: **virtual_ip** tuple argument:  Virtual IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've'), ('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.vrrpv3e', u'vrrpv3e')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.vrrpv3e.virtual_ip', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'virtual_ip', 'keyval': 'virtual_ipaddr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpv3e=vrrpv3e, virtual_ip=virtual_ip)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpv3e=vrrpv3e, virtual_ip=virtual_ip)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_vrrp_extended_group_virtual_mac_delete(self, ve=None, vrrpv3e=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've'), ('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.vrrpv3e', u'vrrpv3e')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.vrrpv3e.virtual_mac', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpv3e=vrrpv3e)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpv3e=vrrpv3e)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_vrrp_extended_group_virtual_mac_02e0_5200_00xx_delete(self, ve=None, vrrpv3e=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've'), ('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.vrrpv3e', u'vrrpv3e')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.vrrpv3e.virtual_mac', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = '02e0.5200.00xx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpv3e=vrrpv3e)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpv3e=vrrpv3e)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_vrrp_group_delete(self, ve=None, vrrpv3=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3: vrid
    :param vrrpv3: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.vrrpv3', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpv3=vrrpv3)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpv3=vrrpv3)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_vrrp_group_advertisement_interval_delete(self, ve=None, vrrpv3=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3: vrid
    :param vrrpv3: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.vrrpv3', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'advertisement-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpv3=vrrpv3)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpv3=vrrpv3)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_vrrp_group_description_delete(self, ve=None, vrrpv3=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3: vrid
    :param vrrpv3: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.vrrpv3', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'description'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpv3=vrrpv3)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpv3=vrrpv3)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_vrrp_group_enable_delete(self, ve=None, vrrpv3=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3: vrid
    :param vrrpv3: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.vrrpv3', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpv3=vrrpv3)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpv3=vrrpv3)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_vrrp_group_hold_time_delete(self, ve=None, vrrpv3=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3: vrid
    :param vrrpv3: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.vrrpv3', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hold-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpv3=vrrpv3)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpv3=vrrpv3)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_vrrp_group_preempt_mode_delete(self, ve=None, vrrpv3=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3: vrid
    :param vrrpv3: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.vrrpv3', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'preempt-mode'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpv3=vrrpv3)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpv3=vrrpv3)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_vrrp_group_priority_delete(self, ve=None, vrrpv3=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3: vrid
    :param vrrpv3: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.vrrpv3', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpv3=vrrpv3)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpv3=vrrpv3)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_vrrp_group_track_interface_delete(self, ve=None, vrrpv3=None, interface=None, track_priority=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpv3: vrid
    :param vrrpv3: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Argument(s)**:

    :type track_priority: int
    :param track_priority: Track Priority

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've'), ('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.vrrpv3', u'vrrpv3')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.vrrpv3.track.interface', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpv3=vrrpv3, interface=interface, track_priority=track_priority)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpv3=vrrpv3, interface=interface, track_priority=track_priority)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_vrrp_group_track_interface_priority_delete(self, ve=None, vrrpv3=None, interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpv3: vrid
    :param vrrpv3: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've'), ('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.vrrpv3', u'vrrpv3')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.vrrpv3.track.interface', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpv3=vrrpv3, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpv3=vrrpv3, interface=interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_vrrp_group_use_v2_checksum_delete(self, ve=None, vrrpv3=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3: vrid
    :param vrrpv3: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.vrrpv3', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'use-v2-checksum'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpv3=vrrpv3)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpv3=vrrpv3)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_vrrp_group_virtual_ip_delete(self, ve=None, vrrpv3=None, virtual_ip=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpv3: vrid
    :param vrrpv3: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type virtual_ip: virtual_ipaddr
    :param virtual_ip: Keyword argument tuple.

    :type virtual_ipaddr: unicode
    :param virtual_ipaddr: **virtual_ip** tuple argument:  Virtual IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've'), ('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.vrrpv3', u'vrrpv3')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.vrrpv3.virtual_ip', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'virtual_ip', 'keyval': 'virtual_ipaddr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpv3=vrrpv3, virtual_ip=virtual_ip)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpv3=vrrpv3, virtual_ip=virtual_ip)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_ipv6_vrrp_suppress_interface_ra_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vrrp-suppress-interface-ra'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_isis_auth_check_level_1_disable_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.intf_isis.interface_isis.auth_check.auth_check_level1', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'disable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_isis_auth_check_level_2_disable_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.intf_isis.interface_isis.auth_check.auth_check_level2', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'disable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_isis_auth_key_delete(self, ve=None, interface_auth_key=None, interface_auth_key_str=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type interface_auth_key: interface_auth_key_level, interface_auth_key_str
    :param interface_auth_key: Keyword argument tuple.

    :type interface_auth_key_level: unicode
    :param interface_auth_key_level: **interface_auth_key** tuple argument.

        * enumeration restriction: ::

            ['level-2', 'level-1']

    :type interface_auth_key_str: unicode
    :param interface_auth_key_str: **interface_auth_key** tuple argument.

        * length restriction: ::

            ['1..63']

    **Instance Argument(s)**:

    :type interface_auth_key_str: unicode
    :param interface_auth_key_str: Keyword argument.

        * length restriction: ::

            ['1..63']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.intf_isis.interface_isis.interface_auth_key', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface_auth_key', 'keyval': 'interface_auth_key_level', 'extra_keyval': 'interface_auth_key_level, interface_auth_key_str'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, interface_auth_key=interface_auth_key, interface_auth_key_str=interface_auth_key_str)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, interface_auth_key=interface_auth_key, interface_auth_key_str=interface_auth_key_str)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_isis_auth_key_interface_auth_key_str_delete(self, ve=None, interface_auth_key=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type interface_auth_key: interface_auth_key_level
    :param interface_auth_key: Keyword argument tuple.

    :type interface_auth_key_level: unicode
    :param interface_auth_key_level: **interface_auth_key** tuple argument.

        * enumeration restriction: ::

            ['level-2', 'level-1']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.intf_isis.interface_isis.interface_auth_key', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface_auth_key', 'keyval': 'interface_auth_key_level', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'interface-auth-key-str'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, interface_auth_key=interface_auth_key)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, interface_auth_key=interface_auth_key)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_isis_auth_mode_md5_level_1_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.intf_isis.interface_isis.interface_auth_mode.interface_md5', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'level-1'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_isis_auth_mode_md5_level_2_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.intf_isis.interface_isis.interface_auth_mode.interface_md5', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'level-2'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_isis_bfd_disable_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.intf_isis.interface_isis.interface_bfd', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'disable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_isis_circuit_type_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.intf_isis.interface_isis', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'circuit-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_isis_hello_interval_delete(self, ve=None, interface_hello_interval=None, interface_hello_interval_val=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type interface_hello_interval: interface_hello_interval_level, interface_hello_interval_val
    :param interface_hello_interval: Keyword argument tuple.

    :type interface_hello_interval_level: unicode
    :param interface_hello_interval_level: **interface_hello_interval** tuple argument.

        * enumeration restriction: ::

            ['level-2', 'level-1']

    :type interface_hello_interval_val: long
    :param interface_hello_interval_val: **interface_hello_interval** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Argument(s)**:

    :type interface_hello_interval_val: long
    :param interface_hello_interval_val: Keyword argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.intf_isis.interface_isis.interface_hello_interval', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface_hello_interval', 'keyval': 'interface_hello_interval_level', 'extra_keyval': 'interface_hello_interval_level, interface_hello_interval_val'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, interface_hello_interval=interface_hello_interval, interface_hello_interval_val=interface_hello_interval_val)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, interface_hello_interval=interface_hello_interval, interface_hello_interval_val=interface_hello_interval_val)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_isis_hello_interval_interface_hello_interval_val_delete(self, ve=None, interface_hello_interval=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type interface_hello_interval: interface_hello_interval_level
    :param interface_hello_interval: Keyword argument tuple.

    :type interface_hello_interval_level: unicode
    :param interface_hello_interval_level: **interface_hello_interval** tuple argument.

        * enumeration restriction: ::

            ['level-2', 'level-1']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.intf_isis.interface_isis.interface_hello_interval', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface_hello_interval', 'keyval': 'interface_hello_interval_level', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'interface-hello-interval-val'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, interface_hello_interval=interface_hello_interval)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, interface_hello_interval=interface_hello_interval)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_isis_hello_multiplier_delete(self, ve=None, interface_hello_multiplier=None, interface_hello_multiplier_val=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type interface_hello_multiplier: interface_hello_multiplier_level, interface_hello_multiplier_val
    :param interface_hello_multiplier: Keyword argument tuple.

    :type interface_hello_multiplier_level: unicode
    :param interface_hello_multiplier_level: **interface_hello_multiplier** tuple argument.

        * enumeration restriction: ::

            ['level-2', 'level-1']

    :type interface_hello_multiplier_val: long
    :param interface_hello_multiplier_val: **interface_hello_multiplier** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Argument(s)**:

    :type interface_hello_multiplier_val: long
    :param interface_hello_multiplier_val: Keyword argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.intf_isis.interface_isis.interface_hello_multiplier', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface_hello_multiplier', 'keyval': 'interface_hello_multiplier_level', 'extra_keyval': 'interface_hello_multiplier_level, interface_hello_multiplier_val'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, interface_hello_multiplier=interface_hello_multiplier, interface_hello_multiplier_val=interface_hello_multiplier_val)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, interface_hello_multiplier=interface_hello_multiplier, interface_hello_multiplier_val=interface_hello_multiplier_val)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_isis_hello_multiplier_interface_hello_multiplier_val_delete(self, ve=None, interface_hello_multiplier=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type interface_hello_multiplier: interface_hello_multiplier_level
    :param interface_hello_multiplier: Keyword argument tuple.

    :type interface_hello_multiplier_level: unicode
    :param interface_hello_multiplier_level: **interface_hello_multiplier** tuple argument.

        * enumeration restriction: ::

            ['level-2', 'level-1']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.intf_isis.interface_isis.interface_hello_multiplier', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface_hello_multiplier', 'keyval': 'interface_hello_multiplier_level', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'interface-hello-multiplier-val'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, interface_hello_multiplier=interface_hello_multiplier)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, interface_hello_multiplier=interface_hello_multiplier)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_isis_hello_padding_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.intf_isis.interface_isis.interface_hello.interface_hello_padding', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_isis_hello_padding_disable_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.intf_isis.interface_isis.interface_hello.interface_hello_padding', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'disable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_isis_ipv6_metric_delete(self, ve=None, interface_ipv6_metric=None, interface_ipv6_metric_val=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type interface_ipv6_metric: interface_ipv6_metric_level, interface_ipv6_metric_val
    :param interface_ipv6_metric: Keyword argument tuple.

    :type interface_ipv6_metric_level: unicode
    :param interface_ipv6_metric_level: **interface_ipv6_metric** tuple argument.

        * enumeration restriction: ::

            ['level-2', 'level-1']

    :type interface_ipv6_metric_val: long
    :param interface_ipv6_metric_val: **interface_ipv6_metric** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Argument(s)**:

    :type interface_ipv6_metric_val: long
    :param interface_ipv6_metric_val: Keyword argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.intf_isis.interface_isis.interface_ipv6.interface_ipv6_metric', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface_ipv6_metric', 'keyval': 'interface_ipv6_metric_level', 'extra_keyval': 'interface_ipv6_metric_level, interface_ipv6_metric_val'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, interface_ipv6_metric=interface_ipv6_metric, interface_ipv6_metric_val=interface_ipv6_metric_val)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, interface_ipv6_metric=interface_ipv6_metric, interface_ipv6_metric_val=interface_ipv6_metric_val)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_isis_ipv6_metric_interface_ipv6_metric_val_delete(self, ve=None, interface_ipv6_metric=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type interface_ipv6_metric: interface_ipv6_metric_level
    :param interface_ipv6_metric: Keyword argument tuple.

    :type interface_ipv6_metric_level: unicode
    :param interface_ipv6_metric_level: **interface_ipv6_metric** tuple argument.

        * enumeration restriction: ::

            ['level-2', 'level-1']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.intf_isis.interface_isis.interface_ipv6.interface_ipv6_metric', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface_ipv6_metric', 'keyval': 'interface_ipv6_metric_level', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'interface-ipv6-metric-val'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, interface_ipv6_metric=interface_ipv6_metric)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, interface_ipv6_metric=interface_ipv6_metric)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_isis_ldp_sync_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.intf_isis.interface_isis', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ldp-sync'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_isis_metric_delete(self, ve=None, interface_metric=None, interface_metric_val=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type interface_metric: interface_metric_level, interface_metric_val
    :param interface_metric: Keyword argument tuple.

    :type interface_metric_level: unicode
    :param interface_metric_level: **interface_metric** tuple argument.

        * enumeration restriction: ::

            ['level-2', 'level-1']

    :type interface_metric_val: long
    :param interface_metric_val: **interface_metric** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Argument(s)**:

    :type interface_metric_val: long
    :param interface_metric_val: Keyword argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.intf_isis.interface_isis.interface_metric', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface_metric', 'keyval': 'interface_metric_level', 'extra_keyval': 'interface_metric_level, interface_metric_val'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, interface_metric=interface_metric, interface_metric_val=interface_metric_val)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, interface_metric=interface_metric, interface_metric_val=interface_metric_val)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_isis_metric_interface_metric_val_delete(self, ve=None, interface_metric=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type interface_metric: interface_metric_level
    :param interface_metric: Keyword argument tuple.

    :type interface_metric_level: unicode
    :param interface_metric_level: **interface_metric** tuple argument.

        * enumeration restriction: ::

            ['level-2', 'level-1']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.intf_isis.interface_isis.interface_metric', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface_metric', 'keyval': 'interface_metric_level', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'interface-metric-val'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, interface_metric=interface_metric)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, interface_metric=interface_metric)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_isis_passive_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.intf_isis.interface_isis', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'passive'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_isis_point_to_point_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.intf_isis.interface_isis', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'point-to-point'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_isis_priority_level_1_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.intf_isis.interface_isis.interface_priority', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'level-1'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_isis_priority_level_2_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.intf_isis.interface_isis.interface_priority', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'level-2'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_isis_reverse_metric_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.intf_isis.interface_isis.interface_reverse_metric', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_isis_reverse_metric_rev_metric_common_attributes_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.intf_isis.interface_isis.interface_reverse_metric.rev_metric_common_attributes', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_isis_reverse_metric_rev_metric_val_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.intf_isis.interface_isis.interface_reverse_metric.rev_metric_common_attributes', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rev-metric-val'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_isis_reverse_metric_te_def_metric_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.intf_isis.interface_isis.interface_reverse_metric.rev_metric_common_attributes', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'te-def-metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_isis_reverse_metric_whole_lan_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.intf_isis.interface_isis.interface_reverse_metric.rev_metric_common_attributes', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'whole-lan'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_qos_dscp_cos_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.qos', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dscp-cos'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_qos_dscp_mutation_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.qos', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dscp-mutation'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_qos_dscp_traffic_class_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.qos', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dscp-traffic-class'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_rpf_mode_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.rpf_mode', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_rpf_mode_mode_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.rpf_mode', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mode'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_shutdown_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ve: gve_name
    :param ve: Keyword argument tuple.

    :type gve_name: long
    :param gve_name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.interface_vlan.interface.ve', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface_vlan.interface.ve', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface_vlan.interface.ve', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.interface.ve', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u've', 'keyval': 'gve_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v6_0_2c.interface_vlan.interface.ve": {"global_ve_shutdown": "global_ve_shutdown", "gve_name": "gve_name"}, "pybind.slxos.v16r_1_00b.routing_system.interface.ve": {"global_ve_shutdown": "shutdown", "gve_name": "name"}, "pybind.nos.v7_1_0.interface_vlan.interface.ve": {"global_ve_shutdown": "global_ve_shutdown", "gve_name": "gve_name"}, "pybind.nos.v7_0_1b.interface_vlan.interface.ve": {"global_ve_shutdown": "global_ve_shutdown", "gve_name": "gve_name"}}
    rest_leaf_name = 'shutdown'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_vrf_forwarding_delete(self, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.vrf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'forwarding'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_vrrp_extended_group_delete(self, ve=None, vrrpe=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.vrrpe', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpe', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpe=vrrpe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpe=vrrpe)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_vrrp_extended_group_advertise_backup_delete(self, ve=None, vrrpe=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.vrrpe', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpe', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'advertise-backup'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpe=vrrpe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpe=vrrpe)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_vrrp_extended_group_advertisement_interval_delete(self, ve=None, vrrpe=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.vrrpe', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpe', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'advertisement-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpe=vrrpe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpe=vrrpe)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_vrrp_extended_group_advertisement_interval_scale_delete(self, ve=None, vrrpe=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.vrrpe', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpe', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'advertisement-interval-scale'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpe=vrrpe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpe=vrrpe)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_vrrp_extended_group_arp_unicast_request_receive_delete(self, ve=None, vrrpe=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've'), ('pybind.slxos.v16r_1_00b.routing_system.interface.ve.vrrpe', u'vrrpe')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.vrrpe.arp.unicast_request', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'receive'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpe=vrrpe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpe=vrrpe)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_vrrp_extended_group_backup_advertisement_interval_delete(self, ve=None, vrrpe=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.vrrpe', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpe', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'backup-advertisement-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpe=vrrpe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpe=vrrpe)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_vrrp_extended_group_description_delete(self, ve=None, vrrpe=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.vrrpe', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpe', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'description'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpe=vrrpe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpe=vrrpe)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_vrrp_extended_group_enable_delete(self, ve=None, vrrpe=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.vrrpe', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpe', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpe=vrrpe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpe=vrrpe)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_vrrp_extended_group_hold_time_delete(self, ve=None, vrrpe=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.vrrpe', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpe', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hold-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpe=vrrpe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpe=vrrpe)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_vrrp_extended_group_preempt_mode_delete(self, ve=None, vrrpe=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.vrrpe', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpe', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'preempt-mode'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpe=vrrpe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpe=vrrpe)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_vrrp_extended_group_priority_delete(self, ve=None, vrrpe=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.vrrpe', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpe', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpe=vrrpe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpe=vrrpe)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_vrrp_extended_group_short_path_forwarding_delete(self, ve=None, vrrpe=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've'), ('pybind.slxos.v16r_1_00b.routing_system.interface.ve.vrrpe', u'vrrpe')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.vrrpe.short_path_forwarding', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'basic, revert_priority'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpe=vrrpe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpe=vrrpe)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_vrrp_extended_group_short_path_forwarding_basic_delete(self, ve=None, vrrpe=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've'), ('pybind.slxos.v16r_1_00b.routing_system.interface.ve.vrrpe', u'vrrpe')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.vrrpe.short_path_forwarding', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'basic'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpe=vrrpe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpe=vrrpe)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_vrrp_extended_group_short_path_forwarding_revert_priority_delete(self, ve=None, vrrpe=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've'), ('pybind.slxos.v16r_1_00b.routing_system.interface.ve.vrrpe', u'vrrpe')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.vrrpe.short_path_forwarding', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'revert-priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpe=vrrpe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpe=vrrpe)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_vrrp_extended_group_track_interface_delete(self, ve=None, vrrpe=None, interface=None, track_priority=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Argument(s)**:

    :type track_priority: int
    :param track_priority: Track Priority

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've'), ('pybind.slxos.v16r_1_00b.routing_system.interface.ve.vrrpe', u'vrrpe')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.vrrpe.track.interface', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpe=vrrpe, interface=interface, track_priority=track_priority)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpe=vrrpe, interface=interface, track_priority=track_priority)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_vrrp_extended_group_track_interface_priority_delete(self, ve=None, vrrpe=None, interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've'), ('pybind.slxos.v16r_1_00b.routing_system.interface.ve.vrrpe', u'vrrpe')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.vrrpe.track.interface', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpe=vrrpe, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpe=vrrpe, interface=interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_vrrp_extended_group_track_network_delete(self, ve=None, vrrpe=None, network=None, network_priority=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type network: network_address
    :param network: Keyword argument tuple.

    :type network_address: unicode
    :param network_address: **network** tuple argument:  IPv4 global address

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]'
            '|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0'
            '-4][0-9]|25[0-5])/(([1-9])|([1-2][0-9])|(3[0-2])'
            ')'

    **Instance Argument(s)**:

    :type network_priority: int
    :param network_priority: Keyword argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've'), ('pybind.slxos.v16r_1_00b.routing_system.interface.ve.vrrpe', u'vrrpe')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.vrrpe.track.network', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'network', 'keyval': 'network_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpe=vrrpe, network=network, network_priority=network_priority)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpe=vrrpe, network=network, network_priority=network_priority)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_vrrp_extended_group_track_network_priority_delete(self, ve=None, vrrpe=None, network=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type network: network_address
    :param network: Keyword argument tuple.

    :type network_address: unicode
    :param network_address: **network** tuple argument:  IPv4 global address

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]'
            '|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0'
            '-4][0-9]|25[0-5])/(([1-9])|([1-2][0-9])|(3[0-2])'
            ')'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've'), ('pybind.slxos.v16r_1_00b.routing_system.interface.ve.vrrpe', u'vrrpe')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.vrrpe.track.network', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'network', 'keyval': 'network_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpe=vrrpe, network=network)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpe=vrrpe, network=network)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_vrrp_extended_group_virtual_ip_delete(self, ve=None, vrrpe=None, virtual_ip=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type virtual_ip: virtual_ipaddr
    :param virtual_ip: Keyword argument tuple.

    :type virtual_ipaddr: unicode
    :param virtual_ipaddr: **virtual_ip** tuple argument:  Virtual IPv4 address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've'), ('pybind.slxos.v16r_1_00b.routing_system.interface.ve.vrrpe', u'vrrpe')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.vrrpe.virtual_ip', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'virtual_ip', 'keyval': 'virtual_ipaddr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpe=vrrpe, virtual_ip=virtual_ip)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpe=vrrpe, virtual_ip=virtual_ip)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_vrrp_extended_group_virtual_mac_delete(self, ve=None, vrrpe=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.vrrpe', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpe', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'virtual-mac'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpe=vrrpe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpe=vrrpe)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_vrrp_extended_group_vrrpe_garp_timer_delete(self, ve=None, vrrpe=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.vrrpe', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpe', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vrrpe-garp-timer'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpe=vrrpe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpe=vrrpe)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_vrrp_group_delete(self, ve=None, vrrp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.vrrp', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrp=vrrp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_vrrp_group_advertisement_interval_delete(self, ve=None, vrrp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.vrrp', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'advertisement-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrp=vrrp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_vrrp_group_arp_unicast_request_receive_delete(self, ve=None, vrrp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've'), ('pybind.slxos.v16r_1_00b.routing_system.interface.ve.vrrp', u'vrrp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.vrrp.arp.unicast_request', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'receive'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrp=vrrp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_vrrp_group_description_delete(self, ve=None, vrrp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.vrrp', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'description'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrp=vrrp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_vrrp_group_enable_delete(self, ve=None, vrrp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.vrrp', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrp=vrrp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_vrrp_group_hold_time_delete(self, ve=None, vrrp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.vrrp', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hold-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrp=vrrp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_vrrp_group_preempt_mode_delete(self, ve=None, vrrp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.vrrp', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'preempt-mode'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrp=vrrp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_vrrp_group_priority_delete(self, ve=None, vrrp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.vrrp', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrp=vrrp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_vrrp_group_track_interface_delete(self, ve=None, vrrp=None, interface=None, track_priority=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Argument(s)**:

    :type track_priority: int
    :param track_priority: Track Priority

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've'), ('pybind.slxos.v16r_1_00b.routing_system.interface.ve.vrrp', u'vrrp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.vrrp.track.interface', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrp=vrrp, interface=interface, track_priority=track_priority)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrp=vrrp, interface=interface, track_priority=track_priority)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_vrrp_group_track_interface_priority_delete(self, ve=None, vrrp=None, interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've'), ('pybind.slxos.v16r_1_00b.routing_system.interface.ve.vrrp', u'vrrp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.vrrp.track.interface', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrp=vrrp, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrp=vrrp, interface=interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_vrrp_group_use_v2_checksum_delete(self, ve=None, vrrp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.vrrp', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'use-v2-checksum'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrp=vrrp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_ve_vrrp_group_virtual_ip_delete(self, ve=None, vrrp=None, virtual_ip=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type virtual_ip: virtual_ipaddr
    :param virtual_ip: Keyword argument tuple.

    :type virtual_ipaddr: unicode
    :param virtual_ipaddr: **virtual_ip** tuple argument:  Virtual IPv4 address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve', u've'), ('pybind.slxos.v16r_1_00b.routing_system.interface.ve.vrrp', u'vrrp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.interface.ve.vrrp.virtual_ip', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'virtual_ip', 'keyval': 'virtual_ipaddr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrp=vrrp, virtual_ip=virtual_ip)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrp=vrrp, virtual_ip=virtual_ip)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_vlan_description_delete(self, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Instance Keyword Argument Tuple**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.interface_vlan.interface.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface_vlan.interface.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface_vlan.interface.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'description'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_vlan_ifindex_delete(self, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Instance Keyword Argument Tuple**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.interface_vlan.interface.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface_vlan.interface.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface_vlan.interface.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ifindex'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_vlan_ip_arp_inspection_delete(self, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v7_1_0.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v6_0_2c.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2c.interface_vlan.interface.vlan.ip.arp.inspection', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface_vlan.interface.vlan.ip.arp.inspection', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface_vlan.interface.vlan.ip.arp.inspection', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_vlan_ip_arp_inspection_filter_delete(self, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v6_0_2c.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v7_0_1b.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2c.interface_vlan.interface.vlan.ip.arp.inspection.filter', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface_vlan.interface.vlan.ip.arp.inspection.filter', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface_vlan.interface.vlan.ip.arp.inspection.filter', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_vlan_ip_arp_inspection_filter_acl_name_delete(self, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v6_0_2c.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v7_0_1b.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2c.interface_vlan.interface.vlan.ip.arp.inspection.filter', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface_vlan.interface.vlan.ip.arp.inspection.filter', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface_vlan.interface.vlan.ip.arp.inspection.filter', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'acl-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_vlan_ip_arp_inspection_logging_acl_match_delete(self, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v7_1_0.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v7_0_1b.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2c.interface_vlan.interface.vlan.ip.arp.inspection.logging', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface_vlan.interface.vlan.ip.arp.inspection.logging', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface_vlan.interface.vlan.ip.arp.inspection.logging', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'acl-match'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_vlan_ip_arp_inspection_trust_delete(self, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v7_1_0.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v6_0_2c.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2c.interface_vlan.interface.vlan.ip.arp.inspection', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface_vlan.interface.vlan.ip.arp.inspection', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface_vlan.interface.vlan.ip.arp.inspection', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'trust'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_vlan_ip_igmp_last_member_query_count_delete(self, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v7_1_0.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v7_0_1b.interface_vlan.interface.vlan.ip.igmp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface_vlan.interface.vlan.ip.igmp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'last-member-query-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_vlan_ip_igmp_last_member_query_interval_delete(self, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v7_1_0.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v6_0_2c.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2c.interface_vlan.interface.vlan.ip.igmp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface_vlan.interface.vlan.ip.igmp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface_vlan.interface.vlan.ip.igmp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'last-member-query-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_vlan_ip_igmp_query_interval_delete(self, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v7_1_0.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v6_0_2c.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2c.interface_vlan.interface.vlan.ip.igmp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface_vlan.interface.vlan.ip.igmp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface_vlan.interface.vlan.ip.igmp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'query-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_vlan_ip_igmp_query_max_response_time_delete(self, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v7_1_0.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v6_0_2c.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2c.interface_vlan.interface.vlan.ip.igmp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface_vlan.interface.vlan.ip.igmp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface_vlan.interface.vlan.ip.igmp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'query-max-response-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_vlan_ip_igmp_robustness_variable_delete(self, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v7_1_0.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v7_0_1b.interface_vlan.interface.vlan.ip.igmp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface_vlan.interface.vlan.ip.igmp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'robustness-variable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_vlan_ip_igmp_snooping_enable_delete(self, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v7_1_0.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v7_0_1b.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2c.interface_vlan.interface.vlan.ip.igmp.snooping', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface_vlan.interface.vlan.ip.igmp.snooping', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface_vlan.interface.vlan.ip.igmp.snooping', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_vlan_ip_igmp_snooping_fast_leave_delete(self, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v7_1_0.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v7_0_1b.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2c.interface_vlan.interface.vlan.ip.igmp.snooping', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface_vlan.interface.vlan.ip.igmp.snooping', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface_vlan.interface.vlan.ip.igmp.snooping', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'fast-leave'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_vlan_ip_igmp_snooping_mrouter_interface_delete(self, vlan=None, interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type interface: if_type, value
    :param interface: Keyword argument tuple.

    :type if_type: unicode
    :param if_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['FortyGigabitEthernet',
            'GigabitEthernet',
            'Port-channel',
            'TenGigabitEthernet',
            'HundredGigabitEthernet']

    :type value: unicode
    :param value: **interface** tuple argument.

        * length restriction: ::

            ['1..10']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v6_0_2c.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v7_0_1b.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2c.interface_vlan.interface.vlan.ip.igmp.snooping.mrouter.interface', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface_vlan.interface.vlan.ip.igmp.snooping.mrouter.interface', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface_vlan.interface.vlan.ip.igmp.snooping.mrouter.interface', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'if_type, value', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan, interface=interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_vlan_ip_igmp_snooping_mrouter_timeout_delete(self, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v7_1_0.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v7_0_1b.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2c.interface_vlan.interface.vlan.ip.igmp.snooping', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface_vlan.interface.vlan.ip.igmp.snooping', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface_vlan.interface.vlan.ip.igmp.snooping', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mrouter-timeout'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_vlan_ip_igmp_snooping_querier_enable_delete(self, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v7_0_1b.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v7_1_0.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2c.interface_vlan.interface.vlan.ip.igmp.snooping.querier', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface_vlan.interface.vlan.ip.igmp.snooping.querier', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface_vlan.interface.vlan.ip.igmp.snooping.querier', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_vlan_ip_igmp_snooping_restrict_unknown_multicast_delete(self, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v7_1_0.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v7_0_1b.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2c.interface_vlan.interface.vlan.ip.igmp.snooping', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface_vlan.interface.vlan.ip.igmp.snooping', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface_vlan.interface.vlan.ip.igmp.snooping', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'restrict-unknown-multicast'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_vlan_ip_igmp_startup_query_count_delete(self, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v7_1_0.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v7_0_1b.interface_vlan.interface.vlan.ip.igmp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface_vlan.interface.vlan.ip.igmp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'startup-query-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_vlan_ip_igmp_startup_query_interval_delete(self, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v7_1_0.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v7_0_1b.interface_vlan.interface.vlan.ip.igmp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface_vlan.interface.vlan.ip.igmp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'startup-query-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_vlan_ip_igmp_static_group_delete(self, vlan=None, static_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type static_group: mcast_address, interface, if_type, value
    :param static_group: Keyword argument tuple.

    :type mcast_address: unicode
    :param mcast_address: **static_group** tuple argument:  Multicast Address to be Joined in the format A.B.C.D

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type interface: unicode
    :param interface: **static_group** tuple argument.

        * enumeration restriction: ::

            ['interface']

    :type if_type: unicode
    :param if_type: **static_group** tuple argument.

        * enumeration restriction: ::

            ['FortyGigabitEthernet',
            'GigabitEthernet',
            'Port-channel',
            'TenGigabitEthernet',
            'HundredGigabitEthernet']

    :type value: unicode
    :param value: **static_group** tuple argument.

        * length restriction: ::

            ['1..10']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v6_0_2c.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v7_1_0.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2c.interface_vlan.interface.vlan.ip.igmp.static_group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface_vlan.interface.vlan.ip.igmp.static_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface_vlan.interface.vlan.ip.igmp.static_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'static_group', 'keyval': 'mcast_address, interface, if_type, value', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan, static_group=static_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan, static_group=static_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_vlan_ip_pim_snooping_enable_delete(self, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v7_0_1b.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v7_0_1b.interface_vlan.interface.vlan.ip.igmpPIM.snooping', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface_vlan.interface.vlan.ip.igmpPIM.snooping', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_vlan_ipv6_mld_last_member_query_count_delete(self, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v6_0_2c.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v7_1_0.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2c.interface_vlan.interface.vlan.ipv6.mldVlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface_vlan.interface.vlan.ipv6.mldVlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface_vlan.interface.vlan.ipv6.mldVlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'last-member-query-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_vlan_ipv6_mld_last_member_query_interval_delete(self, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v6_0_2c.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v7_1_0.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2c.interface_vlan.interface.vlan.ipv6.mldVlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface_vlan.interface.vlan.ipv6.mldVlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface_vlan.interface.vlan.ipv6.mldVlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'last-member-query-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_vlan_ipv6_mld_query_interval_delete(self, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v6_0_2c.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v7_1_0.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2c.interface_vlan.interface.vlan.ipv6.mldVlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface_vlan.interface.vlan.ipv6.mldVlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface_vlan.interface.vlan.ipv6.mldVlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'query-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_vlan_ipv6_mld_query_max_response_time_delete(self, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v6_0_2c.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v7_1_0.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2c.interface_vlan.interface.vlan.ipv6.mldVlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface_vlan.interface.vlan.ipv6.mldVlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface_vlan.interface.vlan.ipv6.mldVlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'query-max-response-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_vlan_ipv6_mld_snooping_enable_delete(self, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v7_0_1b.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v7_1_0.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2c.interface_vlan.interface.vlan.ipv6.mldVlan.snooping', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface_vlan.interface.vlan.ipv6.mldVlan.snooping', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface_vlan.interface.vlan.ipv6.mldVlan.snooping', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_vlan_ipv6_mld_snooping_fast_leave_delete(self, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v7_0_1b.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v7_1_0.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2c.interface_vlan.interface.vlan.ipv6.mldVlan.snooping', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface_vlan.interface.vlan.ipv6.mldVlan.snooping', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface_vlan.interface.vlan.ipv6.mldVlan.snooping', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'fast-leave'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_vlan_ipv6_mld_snooping_mrouter_interface_delete(self, vlan=None, interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type interface: if_type, value
    :param interface: Keyword argument tuple.

    :type if_type: unicode
    :param if_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['FortyGigabitEthernet',
            'GigabitEthernet',
            'Port-channel',
            'TenGigabitEthernet',
            'HundredGigabitEthernet']

    :type value: unicode
    :param value: **interface** tuple argument.

        * length restriction: ::

            ['1..10']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v6_0_2c.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v7_1_0.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2c.interface_vlan.interface.vlan.ipv6.mldVlan.snooping.mrouter.interface', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface_vlan.interface.vlan.ipv6.mldVlan.snooping.mrouter.interface', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface_vlan.interface.vlan.ipv6.mldVlan.snooping.mrouter.interface', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'if_type, value', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan, interface=interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_vlan_ipv6_mld_snooping_querier_enable_delete(self, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v7_1_0.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v7_0_1b.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2c.interface_vlan.interface.vlan.ipv6.mldVlan.snooping.querier', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface_vlan.interface.vlan.ipv6.mldVlan.snooping.querier', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface_vlan.interface.vlan.ipv6.mldVlan.snooping.querier', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_vlan_ipv6_mld_snooping_restrict_unknown_multicast_delete(self, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v7_0_1b.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v7_1_0.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2c.interface_vlan.interface.vlan.ipv6.mldVlan.snooping', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface_vlan.interface.vlan.ipv6.mldVlan.snooping', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface_vlan.interface.vlan.ipv6.mldVlan.snooping', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'restrict-unknown-multicast'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_vlan_ipv6_mld_snooping_robustness_variable_delete(self, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v7_0_1b.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v7_1_0.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2c.interface_vlan.interface.vlan.ipv6.mldVlan.snooping', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface_vlan.interface.vlan.ipv6.mldVlan.snooping', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface_vlan.interface.vlan.ipv6.mldVlan.snooping', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'robustness-variable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_vlan_ipv6_mld_startup_query_count_delete(self, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v6_0_2c.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v7_1_0.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2c.interface_vlan.interface.vlan.ipv6.mldVlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface_vlan.interface.vlan.ipv6.mldVlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface_vlan.interface.vlan.ipv6.mldVlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'startup-query-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_vlan_ipv6_mld_startup_query_interval_delete(self, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v6_0_2c.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v7_1_0.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2c.interface_vlan.interface.vlan.ipv6.mldVlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface_vlan.interface.vlan.ipv6.mldVlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface_vlan.interface.vlan.ipv6.mldVlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'startup-query-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_vlan_ipv6_mld_static_group_delete(self, vlan=None, static_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type static_group: mcast_address, interface, if_type, value
    :param static_group: Keyword argument tuple.

    :type mcast_address: unicode
    :param mcast_address: **static_group** tuple argument:  Multicast Address to be Joined in format xxxx:xxxx/ml, xxxx:xxxx::/ml

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type interface: unicode
    :param interface: **static_group** tuple argument.

        * enumeration restriction: ::

            ['interface']

    :type if_type: unicode
    :param if_type: **static_group** tuple argument.

        * enumeration restriction: ::

            ['FortyGigabitEthernet',
            'GigabitEthernet',
            'Port-channel',
            'TenGigabitEthernet',
            'HundredGigabitEthernet']

    :type value: unicode
    :param value: **static_group** tuple argument.

        * length restriction: ::

            ['1..10']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v7_1_0.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v6_0_2c.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2c.interface_vlan.interface.vlan.ipv6.mldVlan.static_group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface_vlan.interface.vlan.ipv6.mldVlan.static_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface_vlan.interface.vlan.ipv6.mldVlan.static_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'static_group', 'keyval': 'mcast_address, interface, if_type, value', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan, static_group=static_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan, static_group=static_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_vlan_ipv6_pim_snooping_enable_delete(self, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v7_0_1b.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v7_0_1b.interface_vlan.interface.vlan.ipv6.mldPIM.snooping', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface_vlan.interface.vlan.ipv6.mldPIM.snooping', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_vlan_mac_delete(self, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v6_0_2c.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v7_0_1b.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2c.interface_vlan.interface.vlan.mac', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface_vlan.interface.vlan.mac', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface_vlan.interface.vlan.mac', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_vlan_mac_access_group_delete(self, vlan=None, access_group=None, traffic_type=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type access_group: mac_access_list, mac_direction, traffic_type
    :param access_group: Keyword argument tuple.

    :type mac_access_list: unicode
    :param mac_access_list: **access_group** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type mac_direction: unicode
    :param mac_direction: **access_group** tuple argument.

        * enumeration restriction: ::

            ['in', 'out']

    :type traffic_type: unicode
    :param traffic_type: **access_group** tuple argument.

        * enumeration restriction: ::

            ['switched', 'routed']

    **Instance Argument(s)**:

    :type traffic_type: unicode
    :param traffic_type: Keyword argument.

        * enumeration restriction: ::

            ['switched', 'routed']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v6_0_2c.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v7_1_0.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2c.interface_vlan.interface.vlan.mac.access_group', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface_vlan.interface.vlan.mac.access_group', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface_vlan.interface.vlan.mac.access_group', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'access_group', 'keyval': 'mac_access_list, mac_direction', 'extra_keyval': 'mac_access_list, mac_direction, traffic_type'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan, access_group=access_group, traffic_type=traffic_type)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan, access_group=access_group, traffic_type=traffic_type)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_vlan_name_delete(self, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Instance Keyword Argument Tuple**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.interface_vlan.interface.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface_vlan.interface.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface_vlan.interface.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_vlan_private_vlan_delete(self, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v7_1_0.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v7_0_1b.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2c.interface_vlan.interface.vlan.private_vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface_vlan.interface.vlan.private_vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface_vlan.interface.vlan.private_vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_vlan_private_vlan_association_delete(self, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v7_0_1b.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v7_1_0.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2c.interface_vlan.interface.vlan.private_vlan.association', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface_vlan.interface.vlan.private_vlan.association', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface_vlan.interface.vlan.private_vlan.association', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_vlan_private_vlan_association_add_delete(self, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v7_0_1b.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v7_1_0.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2c.interface_vlan.interface.vlan.private_vlan.association', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface_vlan.interface.vlan.private_vlan.association', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface_vlan.interface.vlan.private_vlan.association', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'add'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_vlan_private_vlan_association_remove_delete(self, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v7_0_1b.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v7_1_0.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2c.interface_vlan.interface.vlan.private_vlan.association', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface_vlan.interface.vlan.private_vlan.association', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface_vlan.interface.vlan.private_vlan.association', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'remove'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_vlan_private_vlan_pvlan_type_leaf_delete(self, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v7_1_0.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v7_0_1b.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2c.interface_vlan.interface.vlan.private_vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface_vlan.interface.vlan.private_vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface_vlan.interface.vlan.private_vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'pvlan-type-leaf'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_vlan_rspan_vlan_delete(self, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Instance Keyword Argument Tuple**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.interface_vlan.interface.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface_vlan.interface.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface_vlan.interface.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rspan-vlan'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_vlan_spanning_tree_shutdown_delete(self, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v7_0_1b.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v6_0_2c.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2c.interface_vlan.interface.vlan.spanning_tree', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface_vlan.interface.vlan.spanning_tree', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface_vlan.interface.vlan.spanning_tree', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'shutdown'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_vlan_suppress_arp_delete(self, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v7_1_0.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v7_0_1b.interface_vlan.interface.vlan.suppress_arp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface_vlan.interface.vlan.suppress_arp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_vlan_suppress_arp_enable_delete(self, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v7_1_0.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v7_0_1b.interface_vlan.interface.vlan.suppress_arp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface_vlan.interface.vlan.suppress_arp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_vlan_suppress_nd_delete(self, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v7_1_0.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v7_0_1b.interface_vlan.interface.vlan.suppress_nd', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface_vlan.interface.vlan.suppress_nd', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_vlan_suppress_nd_enable_delete(self, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v7_1_0.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v7_0_1b.interface_vlan.interface.vlan.suppress_nd', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface_vlan.interface.vlan.suppress_nd', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def interface_vlan_transport_service_delete(self, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Instance Keyword Argument Tuple**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.interface_vlan.interface.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface_vlan.interface.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface_vlan.interface.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'transport-service'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_access_list_extended_delete(self, extended=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.ip_acl.ip.access_list.extended', 'pybind.nos.v6_0_2c.brocade_ip_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ip_acl.ip.access_list.extended', 'pybind.nos.v7_0_1b.brocade_ip_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ip_acl.ip.access_list.extended', 'pybind.nos.v7_1_0.brocade_ip_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.extended', 'pybind.slxos.v16r_1_00b.brocade_ip_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_access_list_extended_seq_delete(self, extended=None, seq=None, action=None, protocol_type=None, src_host_any_sip=None, src_host_ip=None, src_mask=None, sport=None, sport_number_eq_neq_tcp=None, sport_number_lt_tcp=None, sport_number_gt_tcp=None, sport_number_eq_neq_udp=None, sport_number_lt_udp=None, sport_number_gt_udp=None, sport_number_range_lower_tcp=None, sport_number_range_lower_udp=None, sport_number_range_higher_tcp=None, sport_number_range_higher_udp=None, dst_host_any_dip=None, dst_host_ip=None, dst_mask=None, dport=None, dport_number_eq_neq_tcp=None, dport_number_lt_tcp=None, dport_number_gt_tcp=None, dport_number_eq_neq_udp=None, dport_number_lt_udp=None, dport_number_gt_udp=None, dport_number_range_lower_tcp=None, dport_number_range_lower_udp=None, dport_number_range_higher_tcp=None, dport_number_range_higher_udp=None, dscp=None, urg=None, ack=None, push=None, fin=None, rst=None, sync=None, vlan=None, count=None, log=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id, action, protocol_type, src_host_any_sip, src_host_ip, src_mask, sport, sport_number_eq_neq_tcp, sport_number_lt_tcp, sport_number_gt_tcp, sport_number_eq_neq_udp, sport_number_lt_udp, sport_number_gt_udp, sport_number_range_lower_tcp, sport_number_range_lower_udp, sport_number_range_higher_tcp, sport_number_range_higher_udp, dst_host_any_dip, dst_host_ip, dst_mask, dport, dport_number_eq_neq_tcp, dport_number_lt_tcp, dport_number_gt_tcp, dport_number_eq_neq_udp, dport_number_lt_udp, dport_number_gt_udp, dport_number_range_lower_tcp, dport_number_range_lower_udp, dport_number_range_higher_tcp, dport_number_range_higher_udp, dscp, urg, ack, push, fin, rst, sync, vlan, count, log
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type action: unicode
    :param action: **seq** tuple argument.

        * enumeration restriction: ::

            ['deny', 'hard-drop', 'permit']

    :type protocol_type: unicode
    :param protocol_type: **seq** tuple argument.

        * enumeration restriction: ::

            ['ip', 'udp', 'icmp', 'tcp']

    :type src_host_any_sip: unicode
    :param src_host_any_sip: **seq** tuple argument.

        * enumeration restriction: ::

            ['host', 'any']

    :type src_host_ip: unicode
    :param src_host_ip: **seq** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_mask: unicode
    :param src_mask: **seq** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type sport: unicode
    :param sport: **seq** tuple argument.

        * enumeration restriction: ::

            ['lt', 'gt', 'eq', 'range', 'neq']

    :type sport_number_eq_neq_tcp: unicode
    :param sport_number_eq_neq_tcp: **seq** tuple argument.

        * enumeration restriction: ::

            ['ftp',
            'domain',
            'tacacs',
            'hostname',
            'smtp',
            'www',
            'telnet',
            'echo',
            'bgp',
            'syslog',
            'ftp-data',
            'daytime',
            'time',
            'pim-auto-rp',
            'login',
            'talk']

    :type sport_number_lt_tcp: unicode
    :param sport_number_lt_tcp: **seq** tuple argument.

        * enumeration restriction: ::

            ['ftp',
            'domain',
            'tacacs',
            'hostname',
            'smtp',
            'www',
            'telnet',
            'echo',
            'bgp',
            'syslog',
            'ftp-data',
            'daytime',
            'time',
            'pim-auto-rp',
            'login',
            'talk']

    :type sport_number_gt_tcp: unicode
    :param sport_number_gt_tcp: **seq** tuple argument.

        * enumeration restriction: ::

            ['ftp',
            'domain',
            'tacacs',
            'hostname',
            'smtp',
            'www',
            'telnet',
            'echo',
            'bgp',
            'syslog',
            'ftp-data',
            'daytime',
            'time',
            'pim-auto-rp',
            'login',
            'talk']

    :type sport_number_eq_neq_udp: unicode
    :param sport_number_eq_neq_udp: **seq** tuple argument.

        * enumeration restriction: ::

            ['domain',
            'ntp',
            'rip',
            'echo',
            'syslog',
            'pim-auto-rp',
            'tacacs',
            'snmp',
            'bootps',
            'tftp',
            'bootpc']

    :type sport_number_lt_udp: unicode
    :param sport_number_lt_udp: **seq** tuple argument.

        * enumeration restriction: ::

            ['domain',
            'ntp',
            'rip',
            'echo',
            'syslog',
            'pim-auto-rp',
            'tacacs',
            'snmp',
            'bootps',
            'tftp',
            'bootpc']

    :type sport_number_gt_udp: unicode
    :param sport_number_gt_udp: **seq** tuple argument.

        * enumeration restriction: ::

            ['domain',
            'ntp',
            'rip',
            'echo',
            'syslog',
            'pim-auto-rp',
            'tacacs',
            'snmp',
            'bootps',
            'tftp',
            'bootpc']

    :type sport_number_range_lower_tcp: unicode
    :param sport_number_range_lower_tcp: **seq** tuple argument.

        * enumeration restriction: ::

            ['ftp',
            'domain',
            'tacacs',
            'hostname',
            'smtp',
            'www',
            'telnet',
            'echo',
            'bgp',
            'syslog',
            'ftp-data',
            'daytime',
            'time',
            'pim-auto-rp',
            'login',
            'talk']

    :type sport_number_range_lower_udp: unicode
    :param sport_number_range_lower_udp: **seq** tuple argument.

        * enumeration restriction: ::

            ['domain',
            'ntp',
            'rip',
            'echo',
            'syslog',
            'pim-auto-rp',
            'tacacs',
            'snmp',
            'bootps',
            'tftp',
            'bootpc']

    :type sport_number_range_higher_tcp: unicode
    :param sport_number_range_higher_tcp: **seq** tuple argument.

        * enumeration restriction: ::

            ['ftp',
            'domain',
            'tacacs',
            'hostname',
            'smtp',
            'www',
            'telnet',
            'echo',
            'bgp',
            'syslog',
            'ftp-data',
            'daytime',
            'time',
            'pim-auto-rp',
            'login',
            'talk']

    :type sport_number_range_higher_udp: unicode
    :param sport_number_range_higher_udp: **seq** tuple argument.

        * enumeration restriction: ::

            ['domain',
            'ntp',
            'rip',
            'echo',
            'syslog',
            'pim-auto-rp',
            'tacacs',
            'snmp',
            'bootps',
            'tftp',
            'bootpc']

    :type dst_host_any_dip: unicode
    :param dst_host_any_dip: **seq** tuple argument.

        * enumeration restriction: ::

            ['host', 'any']

    :type dst_host_ip: unicode
    :param dst_host_ip: **seq** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type dst_mask: unicode
    :param dst_mask: **seq** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type dport: unicode
    :param dport: **seq** tuple argument.

        * enumeration restriction: ::

            ['lt', 'gt', 'eq', 'range', 'neq']

    :type dport_number_eq_neq_tcp: unicode
    :param dport_number_eq_neq_tcp: **seq** tuple argument.

        * enumeration restriction: ::

            ['ftp',
            'domain',
            'tacacs',
            'hostname',
            'smtp',
            'www',
            'telnet',
            'echo',
            'bgp',
            'syslog',
            'ftp-data',
            'daytime',
            'time',
            'pim-auto-rp',
            'login',
            'talk']

    :type dport_number_lt_tcp: unicode
    :param dport_number_lt_tcp: **seq** tuple argument.

        * enumeration restriction: ::

            ['ftp',
            'domain',
            'tacacs',
            'hostname',
            'smtp',
            'www',
            'telnet',
            'echo',
            'bgp',
            'syslog',
            'ftp-data',
            'daytime',
            'time',
            'pim-auto-rp',
            'login',
            'talk']

    :type dport_number_gt_tcp: unicode
    :param dport_number_gt_tcp: **seq** tuple argument.

        * enumeration restriction: ::

            ['ftp',
            'domain',
            'tacacs',
            'hostname',
            'smtp',
            'www',
            'telnet',
            'echo',
            'bgp',
            'syslog',
            'ftp-data',
            'daytime',
            'time',
            'pim-auto-rp',
            'login',
            'talk']

    :type dport_number_eq_neq_udp: unicode
    :param dport_number_eq_neq_udp: **seq** tuple argument.

        * enumeration restriction: ::

            ['domain',
            'ntp',
            'rip',
            'echo',
            'syslog',
            'pim-auto-rp',
            'tacacs',
            'snmp',
            'bootps',
            'tftp',
            'bootpc']

    :type dport_number_lt_udp: unicode
    :param dport_number_lt_udp: **seq** tuple argument.

        * enumeration restriction: ::

            ['domain',
            'ntp',
            'rip',
            'echo',
            'syslog',
            'pim-auto-rp',
            'tacacs',
            'snmp',
            'bootps',
            'tftp',
            'bootpc']

    :type dport_number_gt_udp: unicode
    :param dport_number_gt_udp: **seq** tuple argument.

        * enumeration restriction: ::

            ['domain',
            'ntp',
            'rip',
            'echo',
            'syslog',
            'pim-auto-rp',
            'tacacs',
            'snmp',
            'bootps',
            'tftp',
            'bootpc']

    :type dport_number_range_lower_tcp: unicode
    :param dport_number_range_lower_tcp: **seq** tuple argument.

        * enumeration restriction: ::

            ['ftp',
            'domain',
            'tacacs',
            'hostname',
            'smtp',
            'www',
            'telnet',
            'echo',
            'bgp',
            'syslog',
            'ftp-data',
            'daytime',
            'time',
            'pim-auto-rp',
            'login',
            'talk']

    :type dport_number_range_lower_udp: unicode
    :param dport_number_range_lower_udp: **seq** tuple argument.

        * enumeration restriction: ::

            ['domain',
            'ntp',
            'rip',
            'echo',
            'syslog',
            'pim-auto-rp',
            'tacacs',
            'snmp',
            'bootps',
            'tftp',
            'bootpc']

    :type dport_number_range_higher_tcp: unicode
    :param dport_number_range_higher_tcp: **seq** tuple argument.

        * enumeration restriction: ::

            ['ftp',
            'domain',
            'tacacs',
            'hostname',
            'smtp',
            'www',
            'telnet',
            'echo',
            'bgp',
            'syslog',
            'ftp-data',
            'daytime',
            'time',
            'pim-auto-rp',
            'login',
            'talk']

    :type dport_number_range_higher_udp: unicode
    :param dport_number_range_higher_udp: **seq** tuple argument.

        * enumeration restriction: ::

            ['domain',
            'ntp',
            'rip',
            'echo',
            'syslog',
            'pim-auto-rp',
            'tacacs',
            'snmp',
            'bootps',
            'tftp',
            'bootpc']

    :type dscp: unicode
    :param dscp: **seq** tuple argument:  Differentiated Service Code Point

        * enumeration restriction: ::

            ['af23',
            'af22',
            'af21',
            'af33',
            'af41',
            'af43',
            'af31',
            'default',
            'af42',
            'af12',
            'af32',
            'af13',
            'cs6',
            'cs2',
            'cs5',
            'cs4',
            'cs7',
            'af11',
            'cs1',
            'cs3',
            'ef']

    :type urg: YANGBool
    :param urg: **seq** tuple argument:  Urgent

    :type ack: YANGBool
    :param ack: **seq** tuple argument:  Acknowledgement

    :type push: YANGBool
    :param push: **seq** tuple argument:  Push

    :type fin: YANGBool
    :param fin: **seq** tuple argument:  No more data

    :type rst: YANGBool
    :param rst: **seq** tuple argument:  Reset connection

    :type sync: YANGBool
    :param sync: **seq** tuple argument:  Synchronize

    :type vlan: long
    :param vlan: **seq** tuple argument:  Vlan

        * range restriction: ::

            ['0..4294967295']

    :type count: YANGBool
    :param count: **seq** tuple argument:  Packet Count

    :type log: YANGBool
    :param log: **seq** tuple argument:  Log Packet

    **Instance Argument(s)**:

    :type action: unicode
    :param action: Keyword argument.

        * enumeration restriction: ::

            ['deny', 'hard-drop', 'permit']

    :type protocol_type: unicode
    :param protocol_type: Keyword argument.

        * enumeration restriction: ::

            ['ip', 'udp', 'icmp', 'tcp']

    :type src_host_any_sip: unicode
    :param src_host_any_sip: Keyword argument.

        * enumeration restriction: ::

            ['host', 'any']

    :type src_host_ip: unicode
    :param src_host_ip: Keyword argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_mask: unicode
    :param src_mask: Keyword argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type sport: unicode
    :param sport: Keyword argument.

        * enumeration restriction: ::

            ['lt', 'gt', 'eq', 'range', 'neq']

    :type sport_number_eq_neq_tcp: unicode
    :param sport_number_eq_neq_tcp: Keyword argument.

        * enumeration restriction: ::

            ['ftp',
            'domain',
            'tacacs',
            'hostname',
            'smtp',
            'www',
            'telnet',
            'echo',
            'bgp',
            'syslog',
            'ftp-data',
            'daytime',
            'time',
            'pim-auto-rp',
            'login',
            'talk']

    :type sport_number_lt_tcp: unicode
    :param sport_number_lt_tcp: Keyword argument.

        * enumeration restriction: ::

            ['ftp',
            'domain',
            'tacacs',
            'hostname',
            'smtp',
            'www',
            'telnet',
            'echo',
            'bgp',
            'syslog',
            'ftp-data',
            'daytime',
            'time',
            'pim-auto-rp',
            'login',
            'talk']

    :type sport_number_gt_tcp: unicode
    :param sport_number_gt_tcp: Keyword argument.

        * enumeration restriction: ::

            ['ftp',
            'domain',
            'tacacs',
            'hostname',
            'smtp',
            'www',
            'telnet',
            'echo',
            'bgp',
            'syslog',
            'ftp-data',
            'daytime',
            'time',
            'pim-auto-rp',
            'login',
            'talk']

    :type sport_number_eq_neq_udp: unicode
    :param sport_number_eq_neq_udp: Keyword argument.

        * enumeration restriction: ::

            ['domain',
            'ntp',
            'rip',
            'echo',
            'syslog',
            'pim-auto-rp',
            'tacacs',
            'snmp',
            'bootps',
            'tftp',
            'bootpc']

    :type sport_number_lt_udp: unicode
    :param sport_number_lt_udp: Keyword argument.

        * enumeration restriction: ::

            ['domain',
            'ntp',
            'rip',
            'echo',
            'syslog',
            'pim-auto-rp',
            'tacacs',
            'snmp',
            'bootps',
            'tftp',
            'bootpc']

    :type sport_number_gt_udp: unicode
    :param sport_number_gt_udp: Keyword argument.

        * enumeration restriction: ::

            ['domain',
            'ntp',
            'rip',
            'echo',
            'syslog',
            'pim-auto-rp',
            'tacacs',
            'snmp',
            'bootps',
            'tftp',
            'bootpc']

    :type sport_number_range_lower_tcp: unicode
    :param sport_number_range_lower_tcp: Keyword argument.

        * enumeration restriction: ::

            ['ftp',
            'domain',
            'tacacs',
            'hostname',
            'smtp',
            'www',
            'telnet',
            'echo',
            'bgp',
            'syslog',
            'ftp-data',
            'daytime',
            'time',
            'pim-auto-rp',
            'login',
            'talk']

    :type sport_number_range_lower_udp: unicode
    :param sport_number_range_lower_udp: Keyword argument.

        * enumeration restriction: ::

            ['domain',
            'ntp',
            'rip',
            'echo',
            'syslog',
            'pim-auto-rp',
            'tacacs',
            'snmp',
            'bootps',
            'tftp',
            'bootpc']

    :type sport_number_range_higher_tcp: unicode
    :param sport_number_range_higher_tcp: Keyword argument.

        * enumeration restriction: ::

            ['ftp',
            'domain',
            'tacacs',
            'hostname',
            'smtp',
            'www',
            'telnet',
            'echo',
            'bgp',
            'syslog',
            'ftp-data',
            'daytime',
            'time',
            'pim-auto-rp',
            'login',
            'talk']

    :type sport_number_range_higher_udp: unicode
    :param sport_number_range_higher_udp: Keyword argument.

        * enumeration restriction: ::

            ['domain',
            'ntp',
            'rip',
            'echo',
            'syslog',
            'pim-auto-rp',
            'tacacs',
            'snmp',
            'bootps',
            'tftp',
            'bootpc']

    :type dst_host_any_dip: unicode
    :param dst_host_any_dip: Keyword argument.

        * enumeration restriction: ::

            ['host', 'any']

    :type dst_host_ip: unicode
    :param dst_host_ip: Keyword argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type dst_mask: unicode
    :param dst_mask: Keyword argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type dport: unicode
    :param dport: Keyword argument.

        * enumeration restriction: ::

            ['lt', 'gt', 'eq', 'range', 'neq']

    :type dport_number_eq_neq_tcp: unicode
    :param dport_number_eq_neq_tcp: Keyword argument.

        * enumeration restriction: ::

            ['ftp',
            'domain',
            'tacacs',
            'hostname',
            'smtp',
            'www',
            'telnet',
            'echo',
            'bgp',
            'syslog',
            'ftp-data',
            'daytime',
            'time',
            'pim-auto-rp',
            'login',
            'talk']

    :type dport_number_lt_tcp: unicode
    :param dport_number_lt_tcp: Keyword argument.

        * enumeration restriction: ::

            ['ftp',
            'domain',
            'tacacs',
            'hostname',
            'smtp',
            'www',
            'telnet',
            'echo',
            'bgp',
            'syslog',
            'ftp-data',
            'daytime',
            'time',
            'pim-auto-rp',
            'login',
            'talk']

    :type dport_number_gt_tcp: unicode
    :param dport_number_gt_tcp: Keyword argument.

        * enumeration restriction: ::

            ['ftp',
            'domain',
            'tacacs',
            'hostname',
            'smtp',
            'www',
            'telnet',
            'echo',
            'bgp',
            'syslog',
            'ftp-data',
            'daytime',
            'time',
            'pim-auto-rp',
            'login',
            'talk']

    :type dport_number_eq_neq_udp: unicode
    :param dport_number_eq_neq_udp: Keyword argument.

        * enumeration restriction: ::

            ['domain',
            'ntp',
            'rip',
            'echo',
            'syslog',
            'pim-auto-rp',
            'tacacs',
            'snmp',
            'bootps',
            'tftp',
            'bootpc']

    :type dport_number_lt_udp: unicode
    :param dport_number_lt_udp: Keyword argument.

        * enumeration restriction: ::

            ['domain',
            'ntp',
            'rip',
            'echo',
            'syslog',
            'pim-auto-rp',
            'tacacs',
            'snmp',
            'bootps',
            'tftp',
            'bootpc']

    :type dport_number_gt_udp: unicode
    :param dport_number_gt_udp: Keyword argument.

        * enumeration restriction: ::

            ['domain',
            'ntp',
            'rip',
            'echo',
            'syslog',
            'pim-auto-rp',
            'tacacs',
            'snmp',
            'bootps',
            'tftp',
            'bootpc']

    :type dport_number_range_lower_tcp: unicode
    :param dport_number_range_lower_tcp: Keyword argument.

        * enumeration restriction: ::

            ['ftp',
            'domain',
            'tacacs',
            'hostname',
            'smtp',
            'www',
            'telnet',
            'echo',
            'bgp',
            'syslog',
            'ftp-data',
            'daytime',
            'time',
            'pim-auto-rp',
            'login',
            'talk']

    :type dport_number_range_lower_udp: unicode
    :param dport_number_range_lower_udp: Keyword argument.

        * enumeration restriction: ::

            ['domain',
            'ntp',
            'rip',
            'echo',
            'syslog',
            'pim-auto-rp',
            'tacacs',
            'snmp',
            'bootps',
            'tftp',
            'bootpc']

    :type dport_number_range_higher_tcp: unicode
    :param dport_number_range_higher_tcp: Keyword argument.

        * enumeration restriction: ::

            ['ftp',
            'domain',
            'tacacs',
            'hostname',
            'smtp',
            'www',
            'telnet',
            'echo',
            'bgp',
            'syslog',
            'ftp-data',
            'daytime',
            'time',
            'pim-auto-rp',
            'login',
            'talk']

    :type dport_number_range_higher_udp: unicode
    :param dport_number_range_higher_udp: Keyword argument.

        * enumeration restriction: ::

            ['domain',
            'ntp',
            'rip',
            'echo',
            'syslog',
            'pim-auto-rp',
            'tacacs',
            'snmp',
            'bootps',
            'tftp',
            'bootpc']

    :type dscp: unicode
    :param dscp: Differentiated Service Code Point

        * enumeration restriction: ::

            ['af23',
            'af22',
            'af21',
            'af33',
            'af41',
            'af43',
            'af31',
            'default',
            'af42',
            'af12',
            'af32',
            'af13',
            'cs6',
            'cs2',
            'cs5',
            'cs4',
            'cs7',
            'af11',
            'cs1',
            'cs3',
            'ef']

    :type urg: YANGBool
    :param urg: Urgent

    :type ack: YANGBool
    :param ack: Acknowledgement

    :type push: YANGBool
    :param push: Push

    :type fin: YANGBool
    :param fin: No more data

    :type rst: YANGBool
    :param rst: Reset connection

    :type sync: YANGBool
    :param sync: Synchronize

    :type vlan: long
    :param vlan: Vlan

        * range restriction: ::

            ['0..4294967295']

    :type count: YANGBool
    :param count: Packet Count

    :type log: YANGBool
    :param log: Log Packet

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v6_0_2c.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v7_1_0.ip_acl.ip.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2c.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v6_0_2c.brocade_ip_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_0_1b.brocade_ip_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_1_0.brocade_ip_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v16r_1_00b.brocade_ip_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': 'seq_id, action, protocol_type, src_host_any_sip, src_host_ip, src_mask, sport, sport_number_eq_neq_tcp, sport_number_lt_tcp, sport_number_gt_tcp, sport_number_eq_neq_udp, sport_number_lt_udp, sport_number_gt_udp, sport_number_range_lower_tcp, sport_number_range_lower_udp, sport_number_range_higher_tcp, sport_number_range_higher_udp, dst_host_any_dip, dst_host_ip, dst_mask, dport, dport_number_eq_neq_tcp, dport_number_lt_tcp, dport_number_gt_tcp, dport_number_eq_neq_udp, dport_number_lt_udp, dport_number_gt_udp, dport_number_range_lower_tcp, dport_number_range_lower_udp, dport_number_range_higher_tcp, dport_number_range_higher_udp, dscp, urg, ack, push, fin, rst, sync, vlan, count, log'}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v7_0_1b.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq": {"dport_number_range_higher_udp": "dport_number_range_higher_udp", "sport_number_range_lower_tcp": "sport_number_range_lower_tcp", "push": "push", "sport_number_eq_neq_udp": "sport_number_eq_neq_udp", "sport_number_range_higher_tcp": "sport_number_range_higher_tcp", "sync": "sync", "sport": "sport", "src_mask": "src_mask", "dport_number_lt_udp": "dport_number_lt_udp", "sport_number_range_lower_udp": "sport_number_range_lower_udp", "log": "log", "seq_id": "seq_id", "dport_number_range_lower_tcp": "dport_number_range_lower_tcp", "dport_number_eq_neq_udp": "dport_number_eq_neq_udp", "src_host_ip": "src_host_ip", "sport_number_lt_tcp": "sport_number_lt_tcp", "sport_number_gt_tcp": "sport_number_gt_tcp", "dport_number_gt_udp": "dport_number_gt_udp", "fin": "fin", "dport_number_gt_tcp": "dport_number_gt_tcp", "vlan": "vlan", "dport_number_range_higher_tcp": "dport_number_range_higher_tcp", "sport_number_eq_neq_tcp": "sport_number_eq_neq_tcp", "dscp": "dscp", "sport_number_range_higher_udp": "sport_number_range_higher_udp", "action": "action", "dst_host_ip": "dst_host_ip", "rst": "rst", "dst_mask": "dst_mask", "protocol_type": "protocol_type", "count": "count", "urg": "urg", "dport_number_lt_tcp": "dport_number_lt_tcp", "ack": "ack", "dport_number_eq_neq_tcp": "dport_number_eq_neq_tcp", "dport_number_range_lower_udp": "dport_number_range_lower_udp", "dport": "dport", "src_host_any_sip": "src_host_any_sip", "dst_host_any_dip": "dst_host_any_dip", "sport_number_lt_udp": "sport_number_lt_udp", "sport_number_gt_udp": "sport_number_gt_udp"}, "pybind.nos.v7_1_0.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq": {"dport_number_range_higher_udp": "dport_number_range_higher_udp", "sport_number_range_lower_tcp": "sport_number_range_lower_tcp", "push": "push", "sport_number_eq_neq_udp": "sport_number_eq_neq_udp", "sport_number_range_higher_tcp": "sport_number_range_higher_tcp", "sync": "sync", "sport": "sport", "src_mask": "src_mask", "dport_number_lt_udp": "dport_number_lt_udp", "sport_number_range_lower_udp": "sport_number_range_lower_udp", "log": "log", "seq_id": "seq_id", "dport_number_range_lower_tcp": "dport_number_range_lower_tcp", "dport_number_eq_neq_udp": "dport_number_eq_neq_udp", "src_host_ip": "src_host_ip", "sport_number_lt_tcp": "sport_number_lt_tcp", "sport_number_gt_tcp": "sport_number_gt_tcp", "dport_number_gt_udp": "dport_number_gt_udp", "fin": "fin", "dport_number_gt_tcp": "dport_number_gt_tcp", "vlan": "vlan", "dport_number_range_higher_tcp": "dport_number_range_higher_tcp", "sport_number_eq_neq_tcp": "sport_number_eq_neq_tcp", "dscp": "dscp", "sport_number_range_higher_udp": "sport_number_range_higher_udp", "action": "action", "dst_host_ip": "dst_host_ip", "rst": "rst", "dst_mask": "dst_mask", "protocol_type": "protocol_type", "count": "count", "urg": "urg", "dport_number_lt_tcp": "dport_number_lt_tcp", "ack": "ack", "dport_number_eq_neq_tcp": "dport_number_eq_neq_tcp", "dport_number_range_lower_udp": "dport_number_range_lower_udp", "dport": "dport", "src_host_any_sip": "src_host_any_sip", "dst_host_any_dip": "dst_host_any_dip", "sport_number_lt_udp": "sport_number_lt_udp", "sport_number_gt_udp": "sport_number_gt_udp"}, "pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq": {}, "pybind.nos.v6_0_2c.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq": {"dport_number_range_higher_udp": "dport_number_range_higher_udp", "sport_number_range_lower_tcp": "sport_number_range_lower_tcp", "push": "push", "sport_number_eq_neq_udp": "sport_number_eq_neq_udp", "sport_number_range_higher_tcp": "sport_number_range_higher_tcp", "sync": "sync", "sport": "sport", "src_mask": "src_mask", "dport_number_lt_udp": "dport_number_lt_udp", "sport_number_range_lower_udp": "sport_number_range_lower_udp", "log": "log", "seq_id": "seq_id", "dport_number_range_lower_tcp": "dport_number_range_lower_tcp", "dport_number_eq_neq_udp": "dport_number_eq_neq_udp", "src_host_ip": "src_host_ip", "sport_number_lt_tcp": "sport_number_lt_tcp", "sport_number_gt_tcp": "sport_number_gt_tcp", "dport_number_gt_udp": "dport_number_gt_udp", "fin": "fin", "dport_number_gt_tcp": "dport_number_gt_tcp", "vlan": "vlan", "dport_number_range_higher_tcp": "dport_number_range_higher_tcp", "sport_number_eq_neq_tcp": "sport_number_eq_neq_tcp", "dscp": "dscp", "sport_number_range_higher_udp": "sport_number_range_higher_udp", "action": "action", "dst_host_ip": "dst_host_ip", "rst": "rst", "dst_mask": "dst_mask", "protocol_type": "protocol_type", "count": "count", "urg": "urg", "dport_number_lt_tcp": "dport_number_lt_tcp", "ack": "ack", "dport_number_eq_neq_tcp": "dport_number_eq_neq_tcp", "dport_number_range_lower_udp": "dport_number_range_lower_udp", "dport": "dport", "src_host_any_sip": "src_host_any_sip", "dst_host_any_dip": "dst_host_any_dip", "sport_number_lt_udp": "sport_number_lt_udp", "sport_number_gt_udp": "sport_number_gt_udp"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq, action=action, protocol_type=protocol_type, src_host_any_sip=src_host_any_sip, src_host_ip=src_host_ip, src_mask=src_mask, sport=sport, sport_number_eq_neq_tcp=sport_number_eq_neq_tcp, sport_number_lt_tcp=sport_number_lt_tcp, sport_number_gt_tcp=sport_number_gt_tcp, sport_number_eq_neq_udp=sport_number_eq_neq_udp, sport_number_lt_udp=sport_number_lt_udp, sport_number_gt_udp=sport_number_gt_udp, sport_number_range_lower_tcp=sport_number_range_lower_tcp, sport_number_range_lower_udp=sport_number_range_lower_udp, sport_number_range_higher_tcp=sport_number_range_higher_tcp, sport_number_range_higher_udp=sport_number_range_higher_udp, dst_host_any_dip=dst_host_any_dip, dst_host_ip=dst_host_ip, dst_mask=dst_mask, dport=dport, dport_number_eq_neq_tcp=dport_number_eq_neq_tcp, dport_number_lt_tcp=dport_number_lt_tcp, dport_number_gt_tcp=dport_number_gt_tcp, dport_number_eq_neq_udp=dport_number_eq_neq_udp, dport_number_lt_udp=dport_number_lt_udp, dport_number_gt_udp=dport_number_gt_udp, dport_number_range_lower_tcp=dport_number_range_lower_tcp, dport_number_range_lower_udp=dport_number_range_lower_udp, dport_number_range_higher_tcp=dport_number_range_higher_tcp, dport_number_range_higher_udp=dport_number_range_higher_udp, dscp=dscp, urg=urg, ack=ack, push=push, fin=fin, rst=rst, sync=sync, vlan=vlan, count=count, log=log)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq, action=action, protocol_type=protocol_type, src_host_any_sip=src_host_any_sip, src_host_ip=src_host_ip, src_mask=src_mask, sport=sport, sport_number_eq_neq_tcp=sport_number_eq_neq_tcp, sport_number_lt_tcp=sport_number_lt_tcp, sport_number_gt_tcp=sport_number_gt_tcp, sport_number_eq_neq_udp=sport_number_eq_neq_udp, sport_number_lt_udp=sport_number_lt_udp, sport_number_gt_udp=sport_number_gt_udp, sport_number_range_lower_tcp=sport_number_range_lower_tcp, sport_number_range_lower_udp=sport_number_range_lower_udp, sport_number_range_higher_tcp=sport_number_range_higher_tcp, sport_number_range_higher_udp=sport_number_range_higher_udp, dst_host_any_dip=dst_host_any_dip, dst_host_ip=dst_host_ip, dst_mask=dst_mask, dport=dport, dport_number_eq_neq_tcp=dport_number_eq_neq_tcp, dport_number_lt_tcp=dport_number_lt_tcp, dport_number_gt_tcp=dport_number_gt_tcp, dport_number_eq_neq_udp=dport_number_eq_neq_udp, dport_number_lt_udp=dport_number_lt_udp, dport_number_gt_udp=dport_number_gt_udp, dport_number_range_lower_tcp=dport_number_range_lower_tcp, dport_number_range_lower_udp=dport_number_range_lower_udp, dport_number_range_higher_tcp=dport_number_range_higher_tcp, dport_number_range_higher_udp=dport_number_range_higher_udp, dscp=dscp, urg=urg, ack=ack, push=push, fin=fin, rst=rst, sync=sync, vlan=vlan, count=count, log=log)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_access_list_extended_seq_ack_delete(self, extended=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v6_0_2c.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v7_1_0.ip_acl.ip.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2c.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v6_0_2c.brocade_ip_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_0_1b.brocade_ip_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_1_0.brocade_ip_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v16r_1_00b.brocade_ip_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ack'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_access_list_extended_seq_action_delete(self, extended=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v6_0_2c.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v7_1_0.ip_acl.ip.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2c.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v6_0_2c.brocade_ip_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_0_1b.brocade_ip_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_1_0.brocade_ip_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v16r_1_00b.brocade_ip_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'action'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_access_list_extended_seq_copy_sflow_delete(self, extended=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.extended', u'extended')]
    bindings_list = [('pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v16r_1_00b.brocade_ip_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'copy-sflow'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_access_list_extended_seq_count_delete(self, extended=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v6_0_2c.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v7_1_0.ip_acl.ip.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2c.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v6_0_2c.brocade_ip_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_0_1b.brocade_ip_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_1_0.brocade_ip_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v16r_1_00b.brocade_ip_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_access_list_extended_seq_dport_delete(self, extended=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v6_0_2c.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v7_1_0.ip_acl.ip.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2c.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v6_0_2c.brocade_ip_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_0_1b.brocade_ip_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_1_0.brocade_ip_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v16r_1_00b.brocade_ip_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dport'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_access_list_extended_seq_dport_number_eq_neq_tcp_delete(self, extended=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v6_0_2c.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v7_1_0.ip_acl.ip.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2c.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v6_0_2c.brocade_ip_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_0_1b.brocade_ip_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_1_0.brocade_ip_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v16r_1_00b.brocade_ip_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dport-number-eq-neq-tcp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_access_list_extended_seq_dport_number_eq_neq_udp_delete(self, extended=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v6_0_2c.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v7_1_0.ip_acl.ip.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2c.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v6_0_2c.brocade_ip_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_0_1b.brocade_ip_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_1_0.brocade_ip_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v16r_1_00b.brocade_ip_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dport-number-eq-neq-udp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_access_list_extended_seq_dport_number_gt_tcp_delete(self, extended=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v6_0_2c.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v7_1_0.ip_acl.ip.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2c.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v6_0_2c.brocade_ip_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_0_1b.brocade_ip_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_1_0.brocade_ip_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v16r_1_00b.brocade_ip_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dport-number-gt-tcp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_access_list_extended_seq_dport_number_gt_udp_delete(self, extended=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v6_0_2c.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v7_1_0.ip_acl.ip.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2c.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v6_0_2c.brocade_ip_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_0_1b.brocade_ip_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_1_0.brocade_ip_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v16r_1_00b.brocade_ip_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dport-number-gt-udp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_access_list_extended_seq_dport_number_lt_tcp_delete(self, extended=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v6_0_2c.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v7_1_0.ip_acl.ip.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2c.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v6_0_2c.brocade_ip_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_0_1b.brocade_ip_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_1_0.brocade_ip_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v16r_1_00b.brocade_ip_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dport-number-lt-tcp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_access_list_extended_seq_dport_number_lt_udp_delete(self, extended=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v6_0_2c.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v7_1_0.ip_acl.ip.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2c.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v6_0_2c.brocade_ip_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_0_1b.brocade_ip_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_1_0.brocade_ip_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v16r_1_00b.brocade_ip_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dport-number-lt-udp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_access_list_extended_seq_dport_number_range_higher_tcp_delete(self, extended=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v6_0_2c.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v7_1_0.ip_acl.ip.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2c.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v6_0_2c.brocade_ip_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_0_1b.brocade_ip_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_1_0.brocade_ip_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v16r_1_00b.brocade_ip_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dport-number-range-higher-tcp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_access_list_extended_seq_dport_number_range_higher_udp_delete(self, extended=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v6_0_2c.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v7_1_0.ip_acl.ip.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2c.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v6_0_2c.brocade_ip_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_0_1b.brocade_ip_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_1_0.brocade_ip_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v16r_1_00b.brocade_ip_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dport-number-range-higher-udp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_access_list_extended_seq_dport_number_range_lower_tcp_delete(self, extended=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v6_0_2c.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v7_1_0.ip_acl.ip.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2c.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v6_0_2c.brocade_ip_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_0_1b.brocade_ip_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_1_0.brocade_ip_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v16r_1_00b.brocade_ip_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dport-number-range-lower-tcp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_access_list_extended_seq_dport_number_range_lower_udp_delete(self, extended=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v6_0_2c.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v7_1_0.ip_acl.ip.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2c.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v6_0_2c.brocade_ip_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_0_1b.brocade_ip_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_1_0.brocade_ip_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v16r_1_00b.brocade_ip_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dport-number-range-lower-udp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_access_list_extended_seq_drop_precedence_force_delete(self, extended=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.extended', u'extended')]
    bindings_list = [('pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v16r_1_00b.brocade_ip_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'drop-precedence-force'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_access_list_extended_seq_dscp_delete(self, extended=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v6_0_2c.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v7_1_0.ip_acl.ip.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2c.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v6_0_2c.brocade_ip_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_0_1b.brocade_ip_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_1_0.brocade_ip_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v16r_1_00b.brocade_ip_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dscp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_access_list_extended_seq_dscp_force_delete(self, extended=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.extended', u'extended')]
    bindings_list = [('pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v16r_1_00b.brocade_ip_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dscp-force'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_access_list_extended_seq_dst_host_any_dip_delete(self, extended=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v6_0_2c.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v7_1_0.ip_acl.ip.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2c.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v6_0_2c.brocade_ip_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_0_1b.brocade_ip_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_1_0.brocade_ip_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v16r_1_00b.brocade_ip_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dst-host-any-dip'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_access_list_extended_seq_dst_host_ip_delete(self, extended=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v6_0_2c.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v7_1_0.ip_acl.ip.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2c.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v6_0_2c.brocade_ip_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_0_1b.brocade_ip_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_1_0.brocade_ip_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v16r_1_00b.brocade_ip_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dst-host-ip'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_access_list_extended_seq_dst_mask_delete(self, extended=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v6_0_2c.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v7_1_0.ip_acl.ip.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2c.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v6_0_2c.brocade_ip_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_0_1b.brocade_ip_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_1_0.brocade_ip_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v16r_1_00b.brocade_ip_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dst-mask'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_access_list_extended_seq_fin_delete(self, extended=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v6_0_2c.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v7_1_0.ip_acl.ip.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2c.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v6_0_2c.brocade_ip_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_0_1b.brocade_ip_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_1_0.brocade_ip_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v16r_1_00b.brocade_ip_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'fin'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_access_list_extended_seq_log_delete(self, extended=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v6_0_2c.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v7_1_0.ip_acl.ip.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2c.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v6_0_2c.brocade_ip_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_0_1b.brocade_ip_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_1_0.brocade_ip_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v16r_1_00b.brocade_ip_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'log'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_access_list_extended_seq_mirror_delete(self, extended=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.extended', u'extended')]
    bindings_list = [('pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v16r_1_00b.brocade_ip_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mirror'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_access_list_extended_seq_protocol_type_delete(self, extended=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v6_0_2c.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v7_1_0.ip_acl.ip.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2c.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v6_0_2c.brocade_ip_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_0_1b.brocade_ip_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_1_0.brocade_ip_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v16r_1_00b.brocade_ip_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'protocol-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_access_list_extended_seq_push_delete(self, extended=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v6_0_2c.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v7_1_0.ip_acl.ip.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2c.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v6_0_2c.brocade_ip_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_0_1b.brocade_ip_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_1_0.brocade_ip_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v16r_1_00b.brocade_ip_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'push'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_access_list_extended_seq_rst_delete(self, extended=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v6_0_2c.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v7_1_0.ip_acl.ip.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2c.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v6_0_2c.brocade_ip_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_0_1b.brocade_ip_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_1_0.brocade_ip_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v16r_1_00b.brocade_ip_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rst'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_access_list_extended_seq_sport_delete(self, extended=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v6_0_2c.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v7_1_0.ip_acl.ip.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2c.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v6_0_2c.brocade_ip_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_0_1b.brocade_ip_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_1_0.brocade_ip_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v16r_1_00b.brocade_ip_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'sport'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_access_list_extended_seq_sport_number_eq_neq_tcp_delete(self, extended=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v6_0_2c.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v7_1_0.ip_acl.ip.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2c.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v6_0_2c.brocade_ip_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_0_1b.brocade_ip_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_1_0.brocade_ip_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v16r_1_00b.brocade_ip_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'sport-number-eq-neq-tcp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_access_list_extended_seq_sport_number_eq_neq_udp_delete(self, extended=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v6_0_2c.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v7_1_0.ip_acl.ip.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2c.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v6_0_2c.brocade_ip_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_0_1b.brocade_ip_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_1_0.brocade_ip_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v16r_1_00b.brocade_ip_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'sport-number-eq-neq-udp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_access_list_extended_seq_sport_number_gt_tcp_delete(self, extended=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v6_0_2c.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v7_1_0.ip_acl.ip.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2c.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v6_0_2c.brocade_ip_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_0_1b.brocade_ip_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_1_0.brocade_ip_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v16r_1_00b.brocade_ip_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'sport-number-gt-tcp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_access_list_extended_seq_sport_number_gt_udp_delete(self, extended=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v6_0_2c.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v7_1_0.ip_acl.ip.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2c.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v6_0_2c.brocade_ip_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_0_1b.brocade_ip_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_1_0.brocade_ip_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v16r_1_00b.brocade_ip_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'sport-number-gt-udp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_access_list_extended_seq_sport_number_lt_tcp_delete(self, extended=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v6_0_2c.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v7_1_0.ip_acl.ip.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2c.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v6_0_2c.brocade_ip_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_0_1b.brocade_ip_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_1_0.brocade_ip_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v16r_1_00b.brocade_ip_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'sport-number-lt-tcp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_access_list_extended_seq_sport_number_lt_udp_delete(self, extended=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v6_0_2c.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v7_1_0.ip_acl.ip.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2c.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v6_0_2c.brocade_ip_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_0_1b.brocade_ip_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_1_0.brocade_ip_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v16r_1_00b.brocade_ip_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'sport-number-lt-udp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_access_list_extended_seq_sport_number_range_higher_tcp_delete(self, extended=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v6_0_2c.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v7_1_0.ip_acl.ip.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2c.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v6_0_2c.brocade_ip_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_0_1b.brocade_ip_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_1_0.brocade_ip_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v16r_1_00b.brocade_ip_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'sport-number-range-higher-tcp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_access_list_extended_seq_sport_number_range_higher_udp_delete(self, extended=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v6_0_2c.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v7_1_0.ip_acl.ip.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2c.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v6_0_2c.brocade_ip_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_0_1b.brocade_ip_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_1_0.brocade_ip_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v16r_1_00b.brocade_ip_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'sport-number-range-higher-udp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_access_list_extended_seq_sport_number_range_lower_tcp_delete(self, extended=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v6_0_2c.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v7_1_0.ip_acl.ip.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2c.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v6_0_2c.brocade_ip_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_0_1b.brocade_ip_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_1_0.brocade_ip_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v16r_1_00b.brocade_ip_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'sport-number-range-lower-tcp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_access_list_extended_seq_sport_number_range_lower_udp_delete(self, extended=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v6_0_2c.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v7_1_0.ip_acl.ip.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2c.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v6_0_2c.brocade_ip_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_0_1b.brocade_ip_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_1_0.brocade_ip_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v16r_1_00b.brocade_ip_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'sport-number-range-lower-udp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_access_list_extended_seq_src_host_any_sip_delete(self, extended=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v6_0_2c.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v7_1_0.ip_acl.ip.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2c.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v6_0_2c.brocade_ip_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_0_1b.brocade_ip_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_1_0.brocade_ip_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v16r_1_00b.brocade_ip_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'src-host-any-sip'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_access_list_extended_seq_src_host_ip_delete(self, extended=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v6_0_2c.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v7_1_0.ip_acl.ip.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2c.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v6_0_2c.brocade_ip_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_0_1b.brocade_ip_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_1_0.brocade_ip_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v16r_1_00b.brocade_ip_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'src-host-ip'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_access_list_extended_seq_src_mask_delete(self, extended=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v6_0_2c.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v7_1_0.ip_acl.ip.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2c.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v6_0_2c.brocade_ip_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_0_1b.brocade_ip_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_1_0.brocade_ip_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v16r_1_00b.brocade_ip_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'src-mask'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_access_list_extended_seq_sync_delete(self, extended=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v6_0_2c.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v7_1_0.ip_acl.ip.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2c.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v6_0_2c.brocade_ip_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_0_1b.brocade_ip_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_1_0.brocade_ip_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v16r_1_00b.brocade_ip_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'sync'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_access_list_extended_seq_urg_delete(self, extended=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v6_0_2c.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v7_1_0.ip_acl.ip.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2c.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v6_0_2c.brocade_ip_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_0_1b.brocade_ip_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_1_0.brocade_ip_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v16r_1_00b.brocade_ip_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'urg'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_access_list_extended_seq_vlan_delete(self, extended=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v6_0_2c.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v7_1_0.ip_acl.ip.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2c.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v6_0_2c.brocade_ip_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_0_1b.brocade_ip_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_1_0.brocade_ip_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v16r_1_00b.brocade_ip_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vlan'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_access_list_standard_delete(self, standard=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type standard: name
    :param standard: Keyword argument tuple.

    :type name: unicode
    :param name: **standard** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.ip_acl.ip.access_list.standard', 'pybind.nos.v6_0_2c.brocade_ip_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ip_acl.ip.access_list.standard', 'pybind.nos.v7_0_1b.brocade_ip_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ip_acl.ip.access_list.standard', 'pybind.nos.v7_1_0.brocade_ip_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.standard', 'pybind.slxos.v16r_1_00b.brocade_ip_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'standard', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, standard=standard)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, standard=standard)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_access_list_standard_seq_delete(self, standard=None, seq=None, action=None, src_host_any_sip=None, src_host_ip=None, src_mask=None, count=None, log=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type standard: name
    :param standard: Keyword argument tuple.

    :type name: unicode
    :param name: **standard** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id, action, src_host_any_sip, src_host_ip, src_mask, count, log
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type action: unicode
    :param action: **seq** tuple argument.

        * enumeration restriction: ::

            ['deny', 'hard-drop', 'permit']

    :type src_host_any_sip: unicode
    :param src_host_any_sip: **seq** tuple argument.

        * enumeration restriction: ::

            ['host', 'any']

    :type src_host_ip: unicode
    :param src_host_ip: **seq** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_mask: unicode
    :param src_mask: **seq** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type count: YANGBool
    :param count: **seq** tuple argument:  Packet count

    :type log: YANGBool
    :param log: **seq** tuple argument:  Log Packet

    **Instance Argument(s)**:

    :type action: unicode
    :param action: Keyword argument.

        * enumeration restriction: ::

            ['deny', 'hard-drop', 'permit']

    :type src_host_any_sip: unicode
    :param src_host_any_sip: Keyword argument.

        * enumeration restriction: ::

            ['host', 'any']

    :type src_host_ip: unicode
    :param src_host_ip: Keyword argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_mask: unicode
    :param src_mask: Keyword argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type count: YANGBool
    :param count: Packet count

    :type log: YANGBool
    :param log: Log Packet

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.ip_acl.ip.access_list.standard', u'standard'), ('pybind.nos.v7_0_1b.ip_acl.ip.access_list.standard', u'standard'), ('pybind.nos.v7_1_0.ip_acl.ip.access_list.standard', u'standard'), ('pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.standard', u'standard')]
    bindings_list = [('pybind.nos.v6_0_2c.ip_acl.ip.access_list.standard.hide_ip_acl_std.seq', 'pybind.nos.v6_0_2c.brocade_ip_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ip_acl.ip.access_list.standard.hide_ip_acl_std.seq', 'pybind.nos.v7_0_1b.brocade_ip_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ip_acl.ip.access_list.standard.hide_ip_acl_std.seq', 'pybind.nos.v7_1_0.brocade_ip_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.standard.hide_ip_acl_std.seq', 'pybind.slxos.v16r_1_00b.brocade_ip_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': 'seq_id, action, src_host_any_sip, src_host_ip, src_mask, count, log, copy_sflow'}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v7_1_0.ip_acl.ip.access_list.standard.hide_ip_acl_std.seq": {"count": "count", "log": "log", "seq_id": "seq_id", "src_host_ip": "src_host_ip", "action": "action", "src_host_any_sip": "src_host_any_sip", "src_mask": "src_mask"}, "pybind.nos.v7_0_1b.ip_acl.ip.access_list.standard.hide_ip_acl_std.seq": {"count": "count", "log": "log", "seq_id": "seq_id", "src_host_ip": "src_host_ip", "action": "action", "src_host_any_sip": "src_host_any_sip", "src_mask": "src_mask"}, "pybind.nos.v6_0_2c.ip_acl.ip.access_list.standard.hide_ip_acl_std.seq": {"count": "count", "log": "log", "seq_id": "seq_id", "src_host_ip": "src_host_ip", "action": "action", "src_host_any_sip": "src_host_any_sip", "src_mask": "src_mask"}, "pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.standard.hide_ip_acl_std.seq": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, standard=standard, seq=seq, action=action, src_host_any_sip=src_host_any_sip, src_host_ip=src_host_ip, src_mask=src_mask, count=count, log=log)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, standard=standard, seq=seq, action=action, src_host_any_sip=src_host_any_sip, src_host_ip=src_host_ip, src_mask=src_mask, count=count, log=log)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_access_list_standard_seq_action_delete(self, standard=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type standard: name
    :param standard: Keyword argument tuple.

    :type name: unicode
    :param name: **standard** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.ip_acl.ip.access_list.standard', u'standard'), ('pybind.nos.v7_0_1b.ip_acl.ip.access_list.standard', u'standard'), ('pybind.nos.v7_1_0.ip_acl.ip.access_list.standard', u'standard'), ('pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.standard', u'standard')]
    bindings_list = [('pybind.nos.v6_0_2c.ip_acl.ip.access_list.standard.hide_ip_acl_std.seq', 'pybind.nos.v6_0_2c.brocade_ip_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ip_acl.ip.access_list.standard.hide_ip_acl_std.seq', 'pybind.nos.v7_0_1b.brocade_ip_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ip_acl.ip.access_list.standard.hide_ip_acl_std.seq', 'pybind.nos.v7_1_0.brocade_ip_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.standard.hide_ip_acl_std.seq', 'pybind.slxos.v16r_1_00b.brocade_ip_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'action'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, standard=standard, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, standard=standard, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_access_list_standard_seq_copy_sflow_delete(self, standard=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type standard: name
    :param standard: Keyword argument tuple.

    :type name: unicode
    :param name: **standard** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.standard', u'standard')]
    bindings_list = [('pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.standard.hide_ip_acl_std.seq', 'pybind.slxos.v16r_1_00b.brocade_ip_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'copy-sflow'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, standard=standard, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, standard=standard, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_access_list_standard_seq_count_delete(self, standard=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type standard: name
    :param standard: Keyword argument tuple.

    :type name: unicode
    :param name: **standard** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.ip_acl.ip.access_list.standard', u'standard'), ('pybind.nos.v7_0_1b.ip_acl.ip.access_list.standard', u'standard'), ('pybind.nos.v7_1_0.ip_acl.ip.access_list.standard', u'standard'), ('pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.standard', u'standard')]
    bindings_list = [('pybind.nos.v6_0_2c.ip_acl.ip.access_list.standard.hide_ip_acl_std.seq', 'pybind.nos.v6_0_2c.brocade_ip_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ip_acl.ip.access_list.standard.hide_ip_acl_std.seq', 'pybind.nos.v7_0_1b.brocade_ip_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ip_acl.ip.access_list.standard.hide_ip_acl_std.seq', 'pybind.nos.v7_1_0.brocade_ip_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.standard.hide_ip_acl_std.seq', 'pybind.slxos.v16r_1_00b.brocade_ip_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, standard=standard, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, standard=standard, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_access_list_standard_seq_log_delete(self, standard=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type standard: name
    :param standard: Keyword argument tuple.

    :type name: unicode
    :param name: **standard** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.ip_acl.ip.access_list.standard', u'standard'), ('pybind.nos.v7_0_1b.ip_acl.ip.access_list.standard', u'standard'), ('pybind.nos.v7_1_0.ip_acl.ip.access_list.standard', u'standard'), ('pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.standard', u'standard')]
    bindings_list = [('pybind.nos.v6_0_2c.ip_acl.ip.access_list.standard.hide_ip_acl_std.seq', 'pybind.nos.v6_0_2c.brocade_ip_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ip_acl.ip.access_list.standard.hide_ip_acl_std.seq', 'pybind.nos.v7_0_1b.brocade_ip_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ip_acl.ip.access_list.standard.hide_ip_acl_std.seq', 'pybind.nos.v7_1_0.brocade_ip_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.standard.hide_ip_acl_std.seq', 'pybind.slxos.v16r_1_00b.brocade_ip_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'log'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, standard=standard, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, standard=standard, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_access_list_standard_seq_src_host_any_sip_delete(self, standard=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type standard: name
    :param standard: Keyword argument tuple.

    :type name: unicode
    :param name: **standard** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.ip_acl.ip.access_list.standard', u'standard'), ('pybind.nos.v7_0_1b.ip_acl.ip.access_list.standard', u'standard'), ('pybind.nos.v7_1_0.ip_acl.ip.access_list.standard', u'standard'), ('pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.standard', u'standard')]
    bindings_list = [('pybind.nos.v6_0_2c.ip_acl.ip.access_list.standard.hide_ip_acl_std.seq', 'pybind.nos.v6_0_2c.brocade_ip_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ip_acl.ip.access_list.standard.hide_ip_acl_std.seq', 'pybind.nos.v7_0_1b.brocade_ip_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ip_acl.ip.access_list.standard.hide_ip_acl_std.seq', 'pybind.nos.v7_1_0.brocade_ip_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.standard.hide_ip_acl_std.seq', 'pybind.slxos.v16r_1_00b.brocade_ip_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'src-host-any-sip'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, standard=standard, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, standard=standard, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_access_list_standard_seq_src_host_ip_delete(self, standard=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type standard: name
    :param standard: Keyword argument tuple.

    :type name: unicode
    :param name: **standard** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.ip_acl.ip.access_list.standard', u'standard'), ('pybind.nos.v7_0_1b.ip_acl.ip.access_list.standard', u'standard'), ('pybind.nos.v7_1_0.ip_acl.ip.access_list.standard', u'standard'), ('pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.standard', u'standard')]
    bindings_list = [('pybind.nos.v6_0_2c.ip_acl.ip.access_list.standard.hide_ip_acl_std.seq', 'pybind.nos.v6_0_2c.brocade_ip_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ip_acl.ip.access_list.standard.hide_ip_acl_std.seq', 'pybind.nos.v7_0_1b.brocade_ip_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ip_acl.ip.access_list.standard.hide_ip_acl_std.seq', 'pybind.nos.v7_1_0.brocade_ip_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.standard.hide_ip_acl_std.seq', 'pybind.slxos.v16r_1_00b.brocade_ip_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'src-host-ip'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, standard=standard, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, standard=standard, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_access_list_standard_seq_src_mask_delete(self, standard=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type standard: name
    :param standard: Keyword argument tuple.

    :type name: unicode
    :param name: **standard** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.ip_acl.ip.access_list.standard', u'standard'), ('pybind.nos.v7_0_1b.ip_acl.ip.access_list.standard', u'standard'), ('pybind.nos.v7_1_0.ip_acl.ip.access_list.standard', u'standard'), ('pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.standard', u'standard')]
    bindings_list = [('pybind.nos.v6_0_2c.ip_acl.ip.access_list.standard.hide_ip_acl_std.seq', 'pybind.nos.v6_0_2c.brocade_ip_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ip_acl.ip.access_list.standard.hide_ip_acl_std.seq', 'pybind.nos.v7_0_1b.brocade_ip_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ip_acl.ip.access_list.standard.hide_ip_acl_std.seq', 'pybind.nos.v7_1_0.brocade_ip_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ip_acl.ip.access_list.standard.hide_ip_acl_std.seq', 'pybind.slxos.v16r_1_00b.brocade_ip_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'src-mask'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, standard=standard, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, standard=standard, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_acl_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.ip_acl', 'pybind.nos.v6_0_2c.brocade_ip_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ip_acl', 'pybind.nos.v7_0_1b.brocade_ip_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ip_acl', 'pybind.nos.v7_1_0.brocade_ip_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ip_acl', 'pybind.slxos.v16r_1_00b.brocade_ip_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_as_path_access_list_delete(self, access_list=None, ip_action=None, ip_reg_expr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type access_list: name, seq_keyword, instance, ip_action, ip_reg_expr
    :param access_list: Keyword argument tuple.

    :type name: unicode
    :param name: **access_list** tuple argument.

        * length restriction: ::

            ['1..32']

    :type seq_keyword: unicode
    :param seq_keyword: **access_list** tuple argument.

        * enumeration restriction: ::

            ['seq']

    :type instance: int
    :param instance: **access_list** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type ip_action: unicode
    :param ip_action: **access_list** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type ip_reg_expr: unicode
    :param ip_reg_expr: **access_list** tuple argument.

    **Instance Argument(s)**:

    :type ip_action: unicode
    :param ip_action: Keyword argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type ip_reg_expr: unicode
    :param ip_reg_expr: Keyword argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.ip.hide_as_path_holder.as_path.access_list', 'pybind.nos.v6_0_2c.brocade_common_def', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ip.hide_as_path_holder.as_path.access_list', 'pybind.nos.v7_0_1b.brocade_common_def', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ip.hide_as_path_holder.as_path.access_list', 'pybind.nos.v7_1_0.brocade_common_def', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ip.hide_as_path_holder.as_path.access_list', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'access_list', 'keyval': 'name, seq_keyword, instance', 'extra_keyval': 'name, seq_keyword, instance, ip_action, ip_reg_expr'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, access_list=access_list, ip_action=ip_action, ip_reg_expr=ip_reg_expr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, access_list=access_list, ip_action=ip_action, ip_reg_expr=ip_reg_expr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_as_path_access_list_ip_action_delete(self, access_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type access_list: name, seq_keyword, instance
    :param access_list: Keyword argument tuple.

    :type name: unicode
    :param name: **access_list** tuple argument.

        * length restriction: ::

            ['1..32']

    :type seq_keyword: unicode
    :param seq_keyword: **access_list** tuple argument.

        * enumeration restriction: ::

            ['seq']

    :type instance: int
    :param instance: **access_list** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.ip.hide_as_path_holder.as_path.access_list', 'pybind.nos.v6_0_2c.brocade_common_def', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ip.hide_as_path_holder.as_path.access_list', 'pybind.nos.v7_0_1b.brocade_common_def', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ip.hide_as_path_holder.as_path.access_list', 'pybind.nos.v7_1_0.brocade_common_def', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ip.hide_as_path_holder.as_path.access_list', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'access_list', 'keyval': 'name, seq_keyword, instance', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ip-action'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, access_list=access_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, access_list=access_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_as_path_access_list_ip_reg_expr_delete(self, access_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type access_list: name, seq_keyword, instance
    :param access_list: Keyword argument tuple.

    :type name: unicode
    :param name: **access_list** tuple argument.

        * length restriction: ::

            ['1..32']

    :type seq_keyword: unicode
    :param seq_keyword: **access_list** tuple argument.

        * enumeration restriction: ::

            ['seq']

    :type instance: int
    :param instance: **access_list** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.ip.hide_as_path_holder.as_path.access_list', 'pybind.nos.v6_0_2c.brocade_common_def', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ip.hide_as_path_holder.as_path.access_list', 'pybind.nos.v7_0_1b.brocade_common_def', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ip.hide_as_path_holder.as_path.access_list', 'pybind.nos.v7_1_0.brocade_common_def', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ip.hide_as_path_holder.as_path.access_list', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'access_list', 'keyval': 'name, seq_keyword, instance', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ip-reg-expr'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, access_list=access_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, access_list=access_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_community_list_extended_delete(self, extended=None, ip_action=None, ip_community_reg_expr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type extended: name, seq_keyword, instance, ip_action, ip_community_reg_expr
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

    :type seq_keyword: unicode
    :param seq_keyword: **extended** tuple argument.

        * enumeration restriction: ::

            ['seq']

    :type instance: int
    :param instance: **extended** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type ip_action: unicode
    :param ip_action: **extended** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type ip_community_reg_expr: unicode
    :param ip_community_reg_expr: **extended** tuple argument.

    **Instance Argument(s)**:

    :type ip_action: unicode
    :param ip_action: Keyword argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type ip_community_reg_expr: unicode
    :param ip_community_reg_expr: Keyword argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.ip.hide_community_list_holder.community_list.extended', 'pybind.nos.v6_0_2c.brocade_common_def', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ip.hide_community_list_holder.community_list.extended', 'pybind.nos.v7_0_1b.brocade_common_def', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ip.hide_community_list_holder.community_list.extended', 'pybind.nos.v7_1_0.brocade_common_def', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ip.hide_community_list_holder.community_list.extended', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended', 'keyval': 'name, seq_keyword, instance', 'extra_keyval': 'name, seq_keyword, instance, ip_action, ip_community_reg_expr'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, ip_action=ip_action, ip_community_reg_expr=ip_community_reg_expr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, ip_action=ip_action, ip_community_reg_expr=ip_community_reg_expr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_community_list_extended_ip_action_delete(self, extended=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type extended: name, seq_keyword, instance
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

    :type seq_keyword: unicode
    :param seq_keyword: **extended** tuple argument.

        * enumeration restriction: ::

            ['seq']

    :type instance: int
    :param instance: **extended** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.ip.hide_community_list_holder.community_list.extended', 'pybind.nos.v6_0_2c.brocade_common_def', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ip.hide_community_list_holder.community_list.extended', 'pybind.nos.v7_0_1b.brocade_common_def', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ip.hide_community_list_holder.community_list.extended', 'pybind.nos.v7_1_0.brocade_common_def', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ip.hide_community_list_holder.community_list.extended', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended', 'keyval': 'name, seq_keyword, instance', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ip-action'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_community_list_extended_ip_community_reg_expr_delete(self, extended=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type extended: name, seq_keyword, instance
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

    :type seq_keyword: unicode
    :param seq_keyword: **extended** tuple argument.

        * enumeration restriction: ::

            ['seq']

    :type instance: int
    :param instance: **extended** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.ip.hide_community_list_holder.community_list.extended', 'pybind.nos.v6_0_2c.brocade_common_def', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ip.hide_community_list_holder.community_list.extended', 'pybind.nos.v7_0_1b.brocade_common_def', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ip.hide_community_list_holder.community_list.extended', 'pybind.nos.v7_1_0.brocade_common_def', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ip.hide_community_list_holder.community_list.extended', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended', 'keyval': 'name, seq_keyword, instance', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ip-community-reg-expr'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_community_list_standard_delete(self, standard=None, ip_action=None, std_community_expr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type standard: name, seq_keyword, instance, ip_action, std_community_expr
    :param standard: Keyword argument tuple.

    :type name: unicode
    :param name: **standard** tuple argument.

    :type seq_keyword: unicode
    :param seq_keyword: **standard** tuple argument.

        * enumeration restriction: ::

            ['seq']

    :type instance: int
    :param instance: **standard** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type ip_action: unicode
    :param ip_action: **standard** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type std_community_expr: unicode
    :param std_community_expr: **standard** tuple argument.

        * pattern restriction: ::

            '(\s*)|(\s*((local\-as)|(internet)|(no\-export)|('
            'no\-advertise)|((([1-9][0-9]{0,3})|([1-5][0-9]{4'
            '})|(6[0-4][0-9]{3})|(65[0-4][0-9]{2})|(655[0-2]['
            '0-9])|(6553[0-5])):(([0-9][0-9]{0,3})|([1-5][0-9'
            ']{4})|(6[0-4][0-9]{3})|(65[0-4][0-9]{2})|(655[0-'
            '2][0-9])|(6553[0-5])))|([1-9][0-9]{0,8})|([1-3]['
            '0-9]{9})|(4[0-1][0-9]{8})|(42[0-8][0-9]{7})|(429'
            '[0-3][0-9]{6})|(4294[0-8][0-9]{5})|(42949[0-5][0'
            '-9]{4})|(429496[0-6][0-9]{3})|(4294967[0-1][0-9]'
            '{2})|(42949672[0-8][0-9])|(429496729[0-5])))((\s'
            '+((local\-as)|(internet)|(no\-export)|(no\-adver'
            'tise)|((([1-9][0-9]{0,3})|([1-5][0-9]{4})|(6[0-4'
            '][0-9]{3})|(65[0-4][0-9]{2})|(655[0-2][0-9])|(65'
            '53[0-5])):(([0-9][0-9]{0,3})|([1-5][0-9]{4})|(6['
            '0-4][0-9]{3})|(65[0-4][0-9]{2})|(655[0-2][0-9])|'
            '(6553[0-5])))|([1-9][0-9]{0,8})|([1-3][0-9]{9})|'
            '(4[0-1][0-9]{8})|(42[0-8][0-9]{7})|(429[0-3][0-9'
            ']{6})|(4294[0-8][0-9]{5})|(42949[0-5][0-9]{4})|('
            '429496[0-6][0-9]{3})|(4294967[0-1][0-9]{2})|(429'
            '49672[0-8][0-9])|(429496729[0-5])))*)'

    **Instance Argument(s)**:

    :type ip_action: unicode
    :param ip_action: Keyword argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type std_community_expr: unicode
    :param std_community_expr: Keyword argument.

        * pattern restriction: ::

            '(\s*)|(\s*((local\-as)|(internet)|(no\-export)|('
            'no\-advertise)|((([1-9][0-9]{0,3})|([1-5][0-9]{4'
            '})|(6[0-4][0-9]{3})|(65[0-4][0-9]{2})|(655[0-2]['
            '0-9])|(6553[0-5])):(([0-9][0-9]{0,3})|([1-5][0-9'
            ']{4})|(6[0-4][0-9]{3})|(65[0-4][0-9]{2})|(655[0-'
            '2][0-9])|(6553[0-5])))|([1-9][0-9]{0,8})|([1-3]['
            '0-9]{9})|(4[0-1][0-9]{8})|(42[0-8][0-9]{7})|(429'
            '[0-3][0-9]{6})|(4294[0-8][0-9]{5})|(42949[0-5][0'
            '-9]{4})|(429496[0-6][0-9]{3})|(4294967[0-1][0-9]'
            '{2})|(42949672[0-8][0-9])|(429496729[0-5])))((\s'
            '+((local\-as)|(internet)|(no\-export)|(no\-adver'
            'tise)|((([1-9][0-9]{0,3})|([1-5][0-9]{4})|(6[0-4'
            '][0-9]{3})|(65[0-4][0-9]{2})|(655[0-2][0-9])|(65'
            '53[0-5])):(([0-9][0-9]{0,3})|([1-5][0-9]{4})|(6['
            '0-4][0-9]{3})|(65[0-4][0-9]{2})|(655[0-2][0-9])|'
            '(6553[0-5])))|([1-9][0-9]{0,8})|([1-3][0-9]{9})|'
            '(4[0-1][0-9]{8})|(42[0-8][0-9]{7})|(429[0-3][0-9'
            ']{6})|(4294[0-8][0-9]{5})|(42949[0-5][0-9]{4})|('
            '429496[0-6][0-9]{3})|(4294967[0-1][0-9]{2})|(429'
            '49672[0-8][0-9])|(429496729[0-5])))*)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.ip.hide_community_list_holder.community_list.standard', 'pybind.nos.v6_0_2c.brocade_common_def', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ip.hide_community_list_holder.community_list.standard', 'pybind.nos.v7_0_1b.brocade_common_def', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ip.hide_community_list_holder.community_list.standard', 'pybind.nos.v7_1_0.brocade_common_def', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ip.hide_community_list_holder.community_list.standard', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'standard', 'keyval': 'name, seq_keyword, instance', 'extra_keyval': 'name, seq_keyword, instance, ip_action, std_community_expr'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, standard=standard, ip_action=ip_action, std_community_expr=std_community_expr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, standard=standard, ip_action=ip_action, std_community_expr=std_community_expr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_community_list_standard_ip_action_delete(self, standard=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type standard: name, seq_keyword, instance
    :param standard: Keyword argument tuple.

    :type name: unicode
    :param name: **standard** tuple argument.

    :type seq_keyword: unicode
    :param seq_keyword: **standard** tuple argument.

        * enumeration restriction: ::

            ['seq']

    :type instance: int
    :param instance: **standard** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.ip.hide_community_list_holder.community_list.standard', 'pybind.nos.v6_0_2c.brocade_common_def', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ip.hide_community_list_holder.community_list.standard', 'pybind.nos.v7_0_1b.brocade_common_def', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ip.hide_community_list_holder.community_list.standard', 'pybind.nos.v7_1_0.brocade_common_def', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ip.hide_community_list_holder.community_list.standard', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'standard', 'keyval': 'name, seq_keyword, instance', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ip-action'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, standard=standard)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, standard=standard)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_community_list_standard_std_community_expr_delete(self, standard=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type standard: name, seq_keyword, instance
    :param standard: Keyword argument tuple.

    :type name: unicode
    :param name: **standard** tuple argument.

    :type seq_keyword: unicode
    :param seq_keyword: **standard** tuple argument.

        * enumeration restriction: ::

            ['seq']

    :type instance: int
    :param instance: **standard** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.ip.hide_community_list_holder.community_list.standard', 'pybind.nos.v6_0_2c.brocade_common_def', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ip.hide_community_list_holder.community_list.standard', 'pybind.nos.v7_0_1b.brocade_common_def', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ip.hide_community_list_holder.community_list.standard', 'pybind.nos.v7_1_0.brocade_common_def', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ip.hide_community_list_holder.community_list.standard', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'standard', 'keyval': 'name, seq_keyword, instance', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'std-community-expr'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, standard=standard)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, standard=standard)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_dhcp_relay_information_option_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ip.dhcp.relay.information', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'option'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_dns_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.ip.dns', 'pybind.nos.v6_0_2c.brocade_common_def', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ip.dns', 'pybind.nos.v7_0_1b.brocade_common_def', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ip.dns', 'pybind.nos.v7_1_0.brocade_common_def', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ip.dns', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_dns_dom_name_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.ip.dns.dom_name', 'pybind.nos.v6_0_2c.brocade_common_def', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ip.dns.dom_name', 'pybind.nos.v7_0_1b.brocade_common_def', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ip.dns.dom_name', 'pybind.nos.v7_1_0.brocade_common_def', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ip.dns.dom_name', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_dns_domain_name_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.ip.dns.dom_name', 'pybind.nos.v6_0_2c.brocade_common_def', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ip.dns.dom_name', 'pybind.nos.v7_0_1b.brocade_common_def', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ip.dns.dom_name', 'pybind.nos.v7_1_0.brocade_common_def', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ip.dns.dom_name', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'domain-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_dns_name_server_delete(self, name_server=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type name_server: name_server_ip
    :param name_server: Keyword argument tuple.

    :type name_server_ip: unicode
    :param name_server_ip: **name_server** tuple argument:  IPv4ADDRESS/IPv6ADDRESS;;The IPv4 or Ipv6 Address for Name Server

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.ip.dns.name_server', 'pybind.nos.v6_0_2c.brocade_common_def', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ip.dns.name_server', 'pybind.nos.v7_0_1b.brocade_common_def', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ip.dns.name_server', 'pybind.nos.v7_1_0.brocade_common_def', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ip.dns.name_server', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'name_server', 'keyval': 'name_server_ip', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, name_server=name_server)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, name_server=name_server)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_extcommunity_list_delete(self, extcommunity_list=None, ext_community_action=None, ext_community_expr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Instance Keyword Argument Tuple**:

    :type extcommunity_list: extcommunity_list_num, ext_community_action, ext_community_expr
    :param extcommunity_list: Keyword argument tuple.

    :type extcommunity_list_num: int
    :param extcommunity_list_num: **extcommunity_list** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type ext_community_action: unicode
    :param ext_community_action: **extcommunity_list** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type ext_community_expr: unicode
    :param ext_community_expr: **extcommunity_list** tuple argument:  Ext-community-list

        * pattern restriction: ::

            '(\s*)|(\s*((rt)|(soo)|((([1-9][0-9]{0,8})|([1-3]'
            '[0-9]{9})|(4[0-1][0-9]{8})|(42[0-8][0-9]{7})|(42'
            '9[0-3][0-9]{6})|(4294[0-8][0-9]{5})|(42949[0-5]['
            '0-9]{4})|(429496[0-6][0-9]{3})|(4294967[0-1][0-9'
            ']{2})|(42949672[0-8][0-9])|(429496729[0-5])):((['
            '1-9][0-9]{0,8})|([1-3][0-9]{9})|(4[0-1][0-9]{8})'
            '|(42[0-8][0-9]{7})|(429[0-3][0-9]{6})|(4294[0-8]'
            '[0-9]{5})|(42949[0-5][0-9]{4})|(429496[0-6][0-9]'
            '{3})|(4294967[0-1][0-9]{2})|(42949672[0-8][0-9])'
            '|(429496729[0-5])))|((([0-9]|[1-9][0-9]|1[0-9]{2'
            '}|2[0-4][0-9]|25[0-5])\.){3}([0-9]|[1-9][0-9]|1['
            '0-9]{2}|2[0-4][0-9]|25[0-5]):(([1-9][0-9]{0,8})|'
            '([1-3][0-9]{9})|(4[0-1][0-9]{8})|(42[0-8][0-9]{7'
            '})|(429[0-3][0-9]{6})|(4294[0-8][0-9]{5})|(42949'
            '[0-5][0-9]{4})|(429496[0-6][0-9]{3})|(4294967[0-'
            '1][0-9]{2})|(42949672[0-8][0-9])|(429496729[0-5]'
            ')))))((\s+((rt)|(soo)|((([1-9][0-9]{0,8})|([1-3]'
            '[0-9]{9})|(4[0-1][0-9]{8})|(42[0-8][0-9]{7})|(42'
            '9[0-3][0-9]{6})|(4294[0-8][0-9]{5})|(42949[0-5]['
            '0-9]{4})|(429496[0-6][0-9]{3})|(4294967[0-1][0-9'
            ']{2})|(42949672[0-8][0-9])|(429496729[0-5])):((['
            '1-9][0-9]{0,8})|([1-3][0-9]{9})|(4[0-1][0-9]{8})'
            '|(42[0-8][0-9]{7})|(429[0-3][0-9]{6})|(4294[0-8]'
            '[0-9]{5})|(42949[0-5][0-9]{4})|(429496[0-6][0-9]'
            '{3})|(4294967[0-1][0-9]{2})|(42949672[0-8][0-9])'
            '|(429496729[0-5])))|(((([0-9]|[1-9][0-9]|1[0-9]{'
            '2}|2[0-4][0-9]|25[0-5])\.){3}([0-9]|[1-9][0-9]|1'
            '[0-9]{2}|2[0-4][0-9]|25[0-5])):(([1-9][0-9]{0,8}'
            ')|([1-3][0-9]{9})|(4[0-1][0-9]{8})|(42[0-8][0-9]'
            '{7})|(429[0-3][0-9]{6})|(4294[0-8][0-9]{5})|(429'
            '49[0-5][0-9]{4})|(429496[0-6][0-9]{3})|(4294967['
            '0-1][0-9]{2})|(42949672[0-8][0-9])|(429496729[0-'
            '5])))))*)'

    **Instance Argument(s)**:

    :type ext_community_action: unicode
    :param ext_community_action: Keyword argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type ext_community_expr: unicode
    :param ext_community_expr: Ext-community-list

        * pattern restriction: ::

            '(\s*)|(\s*((rt)|(soo)|((([1-9][0-9]{0,8})|([1-3]'
            '[0-9]{9})|(4[0-1][0-9]{8})|(42[0-8][0-9]{7})|(42'
            '9[0-3][0-9]{6})|(4294[0-8][0-9]{5})|(42949[0-5]['
            '0-9]{4})|(429496[0-6][0-9]{3})|(4294967[0-1][0-9'
            ']{2})|(42949672[0-8][0-9])|(429496729[0-5])):((['
            '1-9][0-9]{0,8})|([1-3][0-9]{9})|(4[0-1][0-9]{8})'
            '|(42[0-8][0-9]{7})|(429[0-3][0-9]{6})|(4294[0-8]'
            '[0-9]{5})|(42949[0-5][0-9]{4})|(429496[0-6][0-9]'
            '{3})|(4294967[0-1][0-9]{2})|(42949672[0-8][0-9])'
            '|(429496729[0-5])))|((([0-9]|[1-9][0-9]|1[0-9]{2'
            '}|2[0-4][0-9]|25[0-5])\.){3}([0-9]|[1-9][0-9]|1['
            '0-9]{2}|2[0-4][0-9]|25[0-5]):(([1-9][0-9]{0,8})|'
            '([1-3][0-9]{9})|(4[0-1][0-9]{8})|(42[0-8][0-9]{7'
            '})|(429[0-3][0-9]{6})|(4294[0-8][0-9]{5})|(42949'
            '[0-5][0-9]{4})|(429496[0-6][0-9]{3})|(4294967[0-'
            '1][0-9]{2})|(42949672[0-8][0-9])|(429496729[0-5]'
            ')))))((\s+((rt)|(soo)|((([1-9][0-9]{0,8})|([1-3]'
            '[0-9]{9})|(4[0-1][0-9]{8})|(42[0-8][0-9]{7})|(42'
            '9[0-3][0-9]{6})|(4294[0-8][0-9]{5})|(42949[0-5]['
            '0-9]{4})|(429496[0-6][0-9]{3})|(4294967[0-1][0-9'
            ']{2})|(42949672[0-8][0-9])|(429496729[0-5])):((['
            '1-9][0-9]{0,8})|([1-3][0-9]{9})|(4[0-1][0-9]{8})'
            '|(42[0-8][0-9]{7})|(429[0-3][0-9]{6})|(4294[0-8]'
            '[0-9]{5})|(42949[0-5][0-9]{4})|(429496[0-6][0-9]'
            '{3})|(4294967[0-1][0-9]{2})|(42949672[0-8][0-9])'
            '|(429496729[0-5])))|(((([0-9]|[1-9][0-9]|1[0-9]{'
            '2}|2[0-4][0-9]|25[0-5])\.){3}([0-9]|[1-9][0-9]|1'
            '[0-9]{2}|2[0-4][0-9]|25[0-5])):(([1-9][0-9]{0,8}'
            ')|([1-3][0-9]{9})|(4[0-1][0-9]{8})|(42[0-8][0-9]'
            '{7})|(429[0-3][0-9]{6})|(4294[0-8][0-9]{5})|(429'
            '49[0-5][0-9]{4})|(429496[0-6][0-9]{3})|(4294967['
            '0-1][0-9]{2})|(42949672[0-8][0-9])|(429496729[0-'
            '5])))))*)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.ip.hide_ext_community_list_holder.extcommunity_list', 'pybind.nos.v6_0_2c.brocade_common_def', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ip.hide_ext_community_list_holder.extcommunity_list', 'pybind.nos.v7_0_1b.brocade_common_def', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ip.hide_ext_community_list_holder.extcommunity_list', 'pybind.nos.v7_1_0.brocade_common_def', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extcommunity_list', 'keyval': 'extcommunity_list_num', 'extra_keyval': 'extcommunity_list_num, ext_community_action, ext_community_expr'}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v7_1_0.ip.hide_ext_community_list_holder.extcommunity_list": {}, "pybind.nos.v6_0_2c.ip.hide_ext_community_list_holder.extcommunity_list": {"ext_community_action": "ext_community_action", "ext_community_expr": "ext_community_expr", "extcommunity_list_num": "extcommunity_list_num"}, "pybind.nos.v7_0_1b.ip.hide_ext_community_list_holder.extcommunity_list": {"ext_community_action": "ext_community_action", "ext_community_expr": "ext_community_expr", "extcommunity_list_num": "extcommunity_list_num"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extcommunity_list=extcommunity_list, ext_community_action=ext_community_action, ext_community_expr=ext_community_expr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extcommunity_list=extcommunity_list, ext_community_action=ext_community_action, ext_community_expr=ext_community_expr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_extcommunity_list_ext_community_action_delete(self, extcommunity_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Instance Keyword Argument Tuple**:

    :type extcommunity_list: extcommunity_list_num
    :param extcommunity_list: Keyword argument tuple.

    :type extcommunity_list_num: int
    :param extcommunity_list_num: **extcommunity_list** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.ip.hide_ext_community_list_holder.extcommunity_list', 'pybind.nos.v6_0_2c.brocade_common_def', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ip.hide_ext_community_list_holder.extcommunity_list', 'pybind.nos.v7_0_1b.brocade_common_def', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ip.hide_ext_community_list_holder.extcommunity_list', 'pybind.nos.v7_1_0.brocade_common_def', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extcommunity_list', 'keyval': 'extcommunity_list_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ext-community-action'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extcommunity_list=extcommunity_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extcommunity_list=extcommunity_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_extcommunity_list_ext_community_expr_delete(self, extcommunity_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Instance Keyword Argument Tuple**:

    :type extcommunity_list: extcommunity_list_num
    :param extcommunity_list: Keyword argument tuple.

    :type extcommunity_list_num: int
    :param extcommunity_list_num: **extcommunity_list** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.ip.hide_ext_community_list_holder.extcommunity_list', 'pybind.nos.v6_0_2c.brocade_common_def', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ip.hide_ext_community_list_holder.extcommunity_list', 'pybind.nos.v7_0_1b.brocade_common_def', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ip.hide_ext_community_list_holder.extcommunity_list', 'pybind.nos.v7_1_0.brocade_common_def', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extcommunity_list', 'keyval': 'extcommunity_list_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ext-community-expr'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extcommunity_list=extcommunity_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extcommunity_list=extcommunity_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_extcommunity_list_ext_community_regex_delete(self, extcommunity_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    **Instance Keyword Argument Tuple**:

    :type extcommunity_list: extcommunity_list_num
    :param extcommunity_list: Keyword argument tuple.

    :type extcommunity_list_num: int
    :param extcommunity_list_num: **extcommunity_list** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_1_0.ip.hide_ext_community_list_holder.extcommunity_list', 'pybind.nos.v7_1_0.brocade_common_def', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extcommunity_list', 'keyval': 'extcommunity_list_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ext-community-regex'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extcommunity_list=extcommunity_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extcommunity_list=extcommunity_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_extcommunity_list_standard_delete(self, standard=None, ext_community_action=None, ext_community_expr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type standard: extcommunity_list_name, ext_community_action, ext_community_expr
    :param standard: Keyword argument tuple.

    :type extcommunity_list_name: unicode
    :param extcommunity_list_name: **standard** tuple argument.

    :type ext_community_action: unicode
    :param ext_community_action: **standard** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type ext_community_expr: unicode
    :param ext_community_expr: **standard** tuple argument:  Ext-community-list

        * pattern restriction: ::

            '(\s*)|(\s*((rt)|(soo)|((([1-9][0-9]{0,8})|([1-3]'
            '[0-9]{9})|(4[0-1][0-9]{8})|(42[0-8][0-9]{7})|(42'
            '9[0-3][0-9]{6})|(4294[0-8][0-9]{5})|(42949[0-5]['
            '0-9]{4})|(429496[0-6][0-9]{3})|(4294967[0-1][0-9'
            ']{2})|(42949672[0-8][0-9])|(429496729[0-5])):((['
            '1-9][0-9]{0,8})|([1-3][0-9]{9})|(4[0-1][0-9]{8})'
            '|(42[0-8][0-9]{7})|(429[0-3][0-9]{6})|(4294[0-8]'
            '[0-9]{5})|(42949[0-5][0-9]{4})|(429496[0-6][0-9]'
            '{3})|(4294967[0-1][0-9]{2})|(42949672[0-8][0-9])'
            '|(429496729[0-5])))|((([0-9]|[1-9][0-9]|1[0-9]{2'
            '}|2[0-4][0-9]|25[0-5])\.){3}([0-9]|[1-9][0-9]|1['
            '0-9]{2}|2[0-4][0-9]|25[0-5]):(([1-9][0-9]{0,8})|'
            '([1-3][0-9]{9})|(4[0-1][0-9]{8})|(42[0-8][0-9]{7'
            '})|(429[0-3][0-9]{6})|(4294[0-8][0-9]{5})|(42949'
            '[0-5][0-9]{4})|(429496[0-6][0-9]{3})|(4294967[0-'
            '1][0-9]{2})|(42949672[0-8][0-9])|(429496729[0-5]'
            ')))))((\s+((rt)|(soo)|((([1-9][0-9]{0,8})|([1-3]'
            '[0-9]{9})|(4[0-1][0-9]{8})|(42[0-8][0-9]{7})|(42'
            '9[0-3][0-9]{6})|(4294[0-8][0-9]{5})|(42949[0-5]['
            '0-9]{4})|(429496[0-6][0-9]{3})|(4294967[0-1][0-9'
            ']{2})|(42949672[0-8][0-9])|(429496729[0-5])):((['
            '1-9][0-9]{0,8})|([1-3][0-9]{9})|(4[0-1][0-9]{8})'
            '|(42[0-8][0-9]{7})|(429[0-3][0-9]{6})|(4294[0-8]'
            '[0-9]{5})|(42949[0-5][0-9]{4})|(429496[0-6][0-9]'
            '{3})|(4294967[0-1][0-9]{2})|(42949672[0-8][0-9])'
            '|(429496729[0-5])))|(((([0-9]|[1-9][0-9]|1[0-9]{'
            '2}|2[0-4][0-9]|25[0-5])\.){3}([0-9]|[1-9][0-9]|1'
            '[0-9]{2}|2[0-4][0-9]|25[0-5])):(([1-9][0-9]{0,8}'
            ')|([1-3][0-9]{9})|(4[0-1][0-9]{8})|(42[0-8][0-9]'
            '{7})|(429[0-3][0-9]{6})|(4294[0-8][0-9]{5})|(429'
            '49[0-5][0-9]{4})|(429496[0-6][0-9]{3})|(4294967['
            '0-1][0-9]{2})|(42949672[0-8][0-9])|(429496729[0-'
            '5])))))*)'

    **Instance Argument(s)**:

    :type ext_community_action: unicode
    :param ext_community_action: Keyword argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type ext_community_expr: unicode
    :param ext_community_expr: Ext-community-list

        * pattern restriction: ::

            '(\s*)|(\s*((rt)|(soo)|((([1-9][0-9]{0,8})|([1-3]'
            '[0-9]{9})|(4[0-1][0-9]{8})|(42[0-8][0-9]{7})|(42'
            '9[0-3][0-9]{6})|(4294[0-8][0-9]{5})|(42949[0-5]['
            '0-9]{4})|(429496[0-6][0-9]{3})|(4294967[0-1][0-9'
            ']{2})|(42949672[0-8][0-9])|(429496729[0-5])):((['
            '1-9][0-9]{0,8})|([1-3][0-9]{9})|(4[0-1][0-9]{8})'
            '|(42[0-8][0-9]{7})|(429[0-3][0-9]{6})|(4294[0-8]'
            '[0-9]{5})|(42949[0-5][0-9]{4})|(429496[0-6][0-9]'
            '{3})|(4294967[0-1][0-9]{2})|(42949672[0-8][0-9])'
            '|(429496729[0-5])))|((([0-9]|[1-9][0-9]|1[0-9]{2'
            '}|2[0-4][0-9]|25[0-5])\.){3}([0-9]|[1-9][0-9]|1['
            '0-9]{2}|2[0-4][0-9]|25[0-5]):(([1-9][0-9]{0,8})|'
            '([1-3][0-9]{9})|(4[0-1][0-9]{8})|(42[0-8][0-9]{7'
            '})|(429[0-3][0-9]{6})|(4294[0-8][0-9]{5})|(42949'
            '[0-5][0-9]{4})|(429496[0-6][0-9]{3})|(4294967[0-'
            '1][0-9]{2})|(42949672[0-8][0-9])|(429496729[0-5]'
            ')))))((\s+((rt)|(soo)|((([1-9][0-9]{0,8})|([1-3]'
            '[0-9]{9})|(4[0-1][0-9]{8})|(42[0-8][0-9]{7})|(42'
            '9[0-3][0-9]{6})|(4294[0-8][0-9]{5})|(42949[0-5]['
            '0-9]{4})|(429496[0-6][0-9]{3})|(4294967[0-1][0-9'
            ']{2})|(42949672[0-8][0-9])|(429496729[0-5])):((['
            '1-9][0-9]{0,8})|([1-3][0-9]{9})|(4[0-1][0-9]{8})'
            '|(42[0-8][0-9]{7})|(429[0-3][0-9]{6})|(4294[0-8]'
            '[0-9]{5})|(42949[0-5][0-9]{4})|(429496[0-6][0-9]'
            '{3})|(4294967[0-1][0-9]{2})|(42949672[0-8][0-9])'
            '|(429496729[0-5])))|(((([0-9]|[1-9][0-9]|1[0-9]{'
            '2}|2[0-4][0-9]|25[0-5])\.){3}([0-9]|[1-9][0-9]|1'
            '[0-9]{2}|2[0-4][0-9]|25[0-5])):(([1-9][0-9]{0,8}'
            ')|([1-3][0-9]{9})|(4[0-1][0-9]{8})|(42[0-8][0-9]'
            '{7})|(429[0-3][0-9]{6})|(4294[0-8][0-9]{5})|(429'
            '49[0-5][0-9]{4})|(429496[0-6][0-9]{3})|(4294967['
            '0-1][0-9]{2})|(42949672[0-8][0-9])|(429496729[0-'
            '5])))))*)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.ip.hide_ext_community_list_holder.extcommunity_list.standard', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'standard', 'keyval': 'extcommunity_list_name', 'extra_keyval': 'extcommunity_list_name, ext_community_action, ext_community_expr'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, standard=standard, ext_community_action=ext_community_action, ext_community_expr=ext_community_expr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, standard=standard, ext_community_action=ext_community_action, ext_community_expr=ext_community_expr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_extcommunity_list_standard_ext_community_action_delete(self, standard=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type standard: extcommunity_list_name
    :param standard: Keyword argument tuple.

    :type extcommunity_list_name: unicode
    :param extcommunity_list_name: **standard** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.ip.hide_ext_community_list_holder.extcommunity_list.standard', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'standard', 'keyval': 'extcommunity_list_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ext-community-action'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, standard=standard)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, standard=standard)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_extcommunity_list_standard_ext_community_expr_delete(self, standard=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type standard: extcommunity_list_name
    :param standard: Keyword argument tuple.

    :type extcommunity_list_name: unicode
    :param extcommunity_list_name: **standard** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.ip.hide_ext_community_list_holder.extcommunity_list.standard', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'standard', 'keyval': 'extcommunity_list_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ext-community-expr'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, standard=standard)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, standard=standard)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_hide_as_path_holder_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.ip.hide_as_path_holder', 'pybind.nos.v6_0_2c.brocade_common_def', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ip.hide_as_path_holder', 'pybind.nos.v7_0_1b.brocade_common_def', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ip.hide_as_path_holder', 'pybind.nos.v7_1_0.brocade_common_def', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ip.hide_as_path_holder', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_hide_community_list_holder_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.ip.hide_community_list_holder', 'pybind.nos.v6_0_2c.brocade_common_def', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ip.hide_community_list_holder', 'pybind.nos.v7_0_1b.brocade_common_def', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ip.hide_community_list_holder', 'pybind.nos.v7_1_0.brocade_common_def', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ip.hide_community_list_holder', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_hide_ext_community_list_holder_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.ip.hide_ext_community_list_holder', 'pybind.nos.v6_0_2c.brocade_common_def', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ip.hide_ext_community_list_holder', 'pybind.nos.v7_0_1b.brocade_common_def', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ip.hide_ext_community_list_holder', 'pybind.nos.v7_1_0.brocade_common_def', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ip.hide_ext_community_list_holder', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_hide_prefix_holder_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.ip.hide_prefix_holder', 'pybind.nos.v6_0_2c.brocade_common_def', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ip.hide_prefix_holder', 'pybind.nos.v7_0_1b.brocade_common_def', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ip.hide_prefix_holder', 'pybind.nos.v7_1_0.brocade_common_def', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ip.hide_prefix_holder', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_icmp_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.ip.icmp', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_icmp_echo_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.ip.icmp.echo', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_icmp_echo_broadcast_request_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.ip.icmp.echo', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'broadcast-request'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_igmp_router_alert_check_disable_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping.ip.igmp', 'pybind.slxos.v16r_1_00b.brocade_igmp_snooping', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'router-alert-check-disable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_igmp_snooping_enable_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.igmp_snooping.ip.igmp.snooping', 'pybind.nos.v6_0_2c.brocade_igmp_snooping', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.igmp_snooping.ip.igmp.snooping', 'pybind.nos.v7_0_1b.brocade_igmp_snooping', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.igmp_snooping.ip.igmp.snooping', 'pybind.nos.v7_1_0.brocade_igmp_snooping', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.igmp_snooping.ip.igmp.igmp_snooping', 'pybind.slxos.v16r_1_00b.brocade_igmp_snooping', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v6_0_2c.igmp_snooping.ip.igmp.snooping": {"enable": "enable"}, "pybind.nos.v7_1_0.igmp_snooping.ip.igmp.snooping": {"enable": "enable"}, "pybind.nos.v7_0_1b.igmp_snooping.ip.igmp.snooping": {"enable": "enable"}, "pybind.slxos.v16r_1_00b.igmp_snooping.ip.igmp.igmp_snooping": {"enable": "igmps_enable"}}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_igmp_ssm_map_enable_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping.ip.igmp.ssm_map', 'pybind.slxos.v16r_1_00b.brocade_igmp_snooping', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_igmp_ssm_map_igmps_prefix_list_delete(self, igmps_prefix_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type igmps_prefix_list: igmps_prefix_list_name, igmps_prefix_src_addr
    :param igmps_prefix_list: Keyword argument tuple.

    :type igmps_prefix_list_name: unicode
    :param igmps_prefix_list_name: **igmps_prefix_list** tuple argument:  ASCII string    Access-list name or number

    :type igmps_prefix_src_addr: unicode
    :param igmps_prefix_src_addr: **igmps_prefix_list** tuple argument:  A.B.C.D     Source address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.igmp_snooping.ip.igmp.ssm_map.igmps_prefix_list', 'pybind.slxos.v16r_1_00b.brocade_igmp_snooping', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmps_prefix_list', 'keyval': 'igmps_prefix_list_name, igmps_prefix_src_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmps_prefix_list=igmps_prefix_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmps_prefix_list=igmps_prefix_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_import_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.ip.rtm_config.import_', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_import_routes_delete(self, routes=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type routes: src_vrf, route_map
    :param routes: Keyword argument tuple.

    :type src_vrf: unicode
    :param src_vrf: **routes** tuple argument:  ASCII string;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type route_map: unicode
    :param route_map: **routes** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.ip.rtm_config.import_.routes', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'routes', 'keyval': 'src_vrf, route_map', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, routes=routes)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, routes=routes)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_load_sharing_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.ip.rtm_config', 'pybind.nos.v6_0_2c.brocade_common_def', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ip.rtm_config', 'pybind.nos.v7_0_1b.brocade_common_def', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ip.rtm_config', 'pybind.nos.v7_1_0.brocade_common_def', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ip.rtm_config', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'load-sharing'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_mtu_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_0_1b.global_mtu_conf.ip', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.global_mtu_conf.ip', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mtu'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_pim_snooping_enable_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_0_1b.igmp_snooping.ip.pim.snooping', 'pybind.nos.v7_0_1b.brocade_igmp_snooping', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.igmp_snooping.ip.pim.snooping', 'pybind.nos.v7_1_0.brocade_igmp_snooping', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.igmp_snooping.ip.pim.snooping', 'pybind.slxos.v16r_1_00b.brocade_igmp_snooping', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_prefix_list_delete(self, prefix_list=None, action_ipp=None, prefix_ipp=None, ge_ipp=None, le_ipp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type prefix_list: name, seq_keyword, instance, action_ipp, prefix_ipp, ge_ipp, le_ipp
    :param prefix_list: Keyword argument tuple.

    :type name: unicode
    :param name: **prefix_list** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type seq_keyword: unicode
    :param seq_keyword: **prefix_list** tuple argument.

        * enumeration restriction: ::

            ['seq']

    :type instance: int
    :param instance: **prefix_list** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type action_ipp: unicode
    :param action_ipp: **prefix_list** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type prefix_ipp: unicode
    :param prefix_ipp: **prefix_list** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type ge_ipp: long
    :param ge_ipp: **prefix_list** tuple argument:  Minimum IP prefix length.

        * range restriction: ::

            ['0..4294967295']

    :type le_ipp: long
    :param le_ipp: **prefix_list** tuple argument:  Maximum IP prefix length.

        * range restriction: ::

            ['0..4294967295']

    **Instance Argument(s)**:

    :type action_ipp: unicode
    :param action_ipp: Keyword argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type prefix_ipp: unicode
    :param prefix_ipp: Keyword argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type ge_ipp: long
    :param ge_ipp: Minimum IP prefix length.

        * range restriction: ::

            ['0..4294967295']

    :type le_ipp: long
    :param le_ipp: Maximum IP prefix length.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.ip.hide_prefix_holder.prefix_list', 'pybind.nos.v6_0_2c.brocade_common_def', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ip.hide_prefix_holder.prefix_list', 'pybind.nos.v7_0_1b.brocade_common_def', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ip.hide_prefix_holder.prefix_list', 'pybind.nos.v7_1_0.brocade_common_def', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ip.hide_prefix_holder.prefix_list', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'prefix_list', 'keyval': 'name, seq_keyword, instance', 'extra_keyval': 'name, seq_keyword, instance, action_ipp, prefix_ipp, ge_ipp, le_ipp'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, prefix_list=prefix_list, action_ipp=action_ipp, prefix_ipp=prefix_ipp, ge_ipp=ge_ipp, le_ipp=le_ipp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, prefix_list=prefix_list, action_ipp=action_ipp, prefix_ipp=prefix_ipp, ge_ipp=ge_ipp, le_ipp=le_ipp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_prefix_list_action_ipp_delete(self, prefix_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type prefix_list: name, seq_keyword, instance
    :param prefix_list: Keyword argument tuple.

    :type name: unicode
    :param name: **prefix_list** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type seq_keyword: unicode
    :param seq_keyword: **prefix_list** tuple argument.

        * enumeration restriction: ::

            ['seq']

    :type instance: int
    :param instance: **prefix_list** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.ip.hide_prefix_holder.prefix_list', 'pybind.nos.v6_0_2c.brocade_common_def', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ip.hide_prefix_holder.prefix_list', 'pybind.nos.v7_0_1b.brocade_common_def', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ip.hide_prefix_holder.prefix_list', 'pybind.nos.v7_1_0.brocade_common_def', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ip.hide_prefix_holder.prefix_list', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'prefix_list', 'keyval': 'name, seq_keyword, instance', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'action-ipp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, prefix_list=prefix_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, prefix_list=prefix_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_prefix_list_ge_delete(self, prefix_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type prefix_list: name, seq_keyword, instance
    :param prefix_list: Keyword argument tuple.

    :type name: unicode
    :param name: **prefix_list** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type seq_keyword: unicode
    :param seq_keyword: **prefix_list** tuple argument.

        * enumeration restriction: ::

            ['seq']

    :type instance: int
    :param instance: **prefix_list** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.ip.hide_prefix_holder.prefix_list', 'pybind.nos.v6_0_2c.brocade_common_def', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ip.hide_prefix_holder.prefix_list', 'pybind.nos.v7_0_1b.brocade_common_def', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ip.hide_prefix_holder.prefix_list', 'pybind.nos.v7_1_0.brocade_common_def', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ip.hide_prefix_holder.prefix_list', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'prefix_list', 'keyval': 'name, seq_keyword, instance', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ge'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, prefix_list=prefix_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, prefix_list=prefix_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_prefix_list_le_delete(self, prefix_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type prefix_list: name, seq_keyword, instance
    :param prefix_list: Keyword argument tuple.

    :type name: unicode
    :param name: **prefix_list** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type seq_keyword: unicode
    :param seq_keyword: **prefix_list** tuple argument.

        * enumeration restriction: ::

            ['seq']

    :type instance: int
    :param instance: **prefix_list** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.ip.hide_prefix_holder.prefix_list', 'pybind.nos.v6_0_2c.brocade_common_def', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ip.hide_prefix_holder.prefix_list', 'pybind.nos.v7_0_1b.brocade_common_def', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ip.hide_prefix_holder.prefix_list', 'pybind.nos.v7_1_0.brocade_common_def', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ip.hide_prefix_holder.prefix_list', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'prefix_list', 'keyval': 'name, seq_keyword, instance', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'le'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, prefix_list=prefix_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, prefix_list=prefix_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_prefix_list_prefix_ipp_delete(self, prefix_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type prefix_list: name, seq_keyword, instance
    :param prefix_list: Keyword argument tuple.

    :type name: unicode
    :param name: **prefix_list** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type seq_keyword: unicode
    :param seq_keyword: **prefix_list** tuple argument.

        * enumeration restriction: ::

            ['seq']

    :type instance: int
    :param instance: **prefix_list** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.ip.hide_prefix_holder.prefix_list', 'pybind.nos.v6_0_2c.brocade_common_def', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ip.hide_prefix_holder.prefix_list', 'pybind.nos.v7_0_1b.brocade_common_def', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ip.hide_prefix_holder.prefix_list', 'pybind.nos.v7_1_0.brocade_common_def', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ip.hide_prefix_holder.prefix_list', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'prefix_list', 'keyval': 'name, seq_keyword, instance', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'prefix-ipp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, prefix_list=prefix_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, prefix_list=prefix_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_receive_access_group_delete(self, access_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type access_group: acl_name
    :param access_group: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **access_group** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ip.receive.access_group', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'access_group', 'keyval': 'acl_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, access_group=access_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, access_group=access_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_route_static_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.ip.rtm_config.route.static', 'pybind.nos.v6_0_2c.brocade_common_def', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ip.rtm_config.route.static', 'pybind.nos.v7_0_1b.brocade_common_def', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ip.rtm_config.route.static', 'pybind.nos.v7_1_0.brocade_common_def', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ip.rtm_config.route.static', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_route_static_bfd_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.ip.rtm_config.route.static.bfd', 'pybind.nos.v6_0_2c.brocade_common_def', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ip.rtm_config.route.static.bfd', 'pybind.nos.v7_0_1b.brocade_common_def', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ip.rtm_config.route.static.bfd', 'pybind.nos.v7_1_0.brocade_common_def', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ip.rtm_config.route.static.bfd', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v6_0_2c.ip.rtm_config.route.static.bfd": {}, "pybind.nos.v7_0_1b.ip.rtm_config.route.static.bfd": {}, "pybind.nos.v7_1_0.ip.rtm_config.route.static.bfd": {}, "pybind.slxos.v16r_1_00b.ip.rtm_config.route.static.bfd": {"holdover_interval": "holdover_interval"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_route_static_bfd_bfd_static_route_delete(self, bfd_static_route=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type bfd_static_route: bfd_static_route_dest, bfd_static_route_src
    :param bfd_static_route: Keyword argument tuple.

    :type bfd_static_route_dest: unicode
    :param bfd_static_route_dest: **bfd_static_route** tuple argument:  A.B.C.D ;; Destination IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type bfd_static_route_src: unicode
    :param bfd_static_route_src: **bfd_static_route** tuple argument:  A.B.C.D ;; Source IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.ip.rtm_config.route.static.bfd.bfd_static_route', 'pybind.nos.v6_0_2c.brocade_common_def', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ip.rtm_config.route.static.bfd.bfd_static_route', 'pybind.nos.v7_0_1b.brocade_common_def', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ip.rtm_config.route.static.bfd.bfd_static_route', 'pybind.nos.v7_1_0.brocade_common_def', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ip.rtm_config.route.static.bfd.bfd_static_route', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'bfd_static_route', 'keyval': 'bfd_static_route_dest, bfd_static_route_src', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bfd_static_route=bfd_static_route)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bfd_static_route=bfd_static_route)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_route_static_bfd_holdover_interval_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.ip.rtm_config.route.static.bfd', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'holdover-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_route_static_route_nh_delete(self, static_route_nh=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type static_route_nh: static_route_dest, static_route_next_hop
    :param static_route_nh: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_nh** tuple argument:  A.B.C.D/L ;; Destination IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type static_route_next_hop: unicode
    :param static_route_next_hop: **static_route_nh** tuple argument:  A.B.C.D ;; Next hop IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.ip.rtm_config.route.static_route_nh', 'pybind.nos.v6_0_2c.brocade_common_def', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ip.rtm_config.route.static_route_nh', 'pybind.nos.v7_0_1b.brocade_common_def', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ip.rtm_config.route.static_route_nh', 'pybind.nos.v7_1_0.brocade_common_def', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ip.rtm_config.route.static_route_nh', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'static_route_nh', 'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, static_route_nh=static_route_nh)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, static_route_nh=static_route_nh)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_route_static_route_nh_distance_delete(self, static_route_nh=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type static_route_nh: static_route_dest, static_route_next_hop
    :param static_route_nh: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_nh** tuple argument:  A.B.C.D/L ;; Destination IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type static_route_next_hop: unicode
    :param static_route_next_hop: **static_route_nh** tuple argument:  A.B.C.D ;; Next hop IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.ip.rtm_config.route.static_route_nh', u'static_route_nh'), ('pybind.nos.v7_1_0.ip.rtm_config.route.static_route_nh', u'static_route_nh'), ('pybind.slxos.v16r_1_00b.ip.rtm_config.route.static_route_nh', u'static_route_nh'), ('pybind.nos.v7_0_1b.ip.rtm_config.route.static_route_nh', u'static_route_nh')]
    bindings_list = [('pybind.nos.v6_0_2c.ip.rtm_config.route.static_route_nh.route_attributes', 'pybind.nos.v6_0_2c.brocade_common_def', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ip.rtm_config.route.static_route_nh.route_attributes', 'pybind.nos.v7_0_1b.brocade_common_def', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ip.rtm_config.route.static_route_nh.route_attributes', 'pybind.nos.v7_1_0.brocade_common_def', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ip.rtm_config.route.static_route_nh.route_attributes', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'distance'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, static_route_nh=static_route_nh)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, static_route_nh=static_route_nh)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_route_static_route_nh_metric_delete(self, static_route_nh=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type static_route_nh: static_route_dest, static_route_next_hop
    :param static_route_nh: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_nh** tuple argument:  A.B.C.D/L ;; Destination IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type static_route_next_hop: unicode
    :param static_route_next_hop: **static_route_nh** tuple argument:  A.B.C.D ;; Next hop IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.ip.rtm_config.route.static_route_nh', u'static_route_nh'), ('pybind.nos.v7_1_0.ip.rtm_config.route.static_route_nh', u'static_route_nh'), ('pybind.slxos.v16r_1_00b.ip.rtm_config.route.static_route_nh', u'static_route_nh'), ('pybind.nos.v7_0_1b.ip.rtm_config.route.static_route_nh', u'static_route_nh')]
    bindings_list = [('pybind.nos.v6_0_2c.ip.rtm_config.route.static_route_nh.route_attributes', 'pybind.nos.v6_0_2c.brocade_common_def', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ip.rtm_config.route.static_route_nh.route_attributes', 'pybind.nos.v7_0_1b.brocade_common_def', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ip.rtm_config.route.static_route_nh.route_attributes', 'pybind.nos.v7_1_0.brocade_common_def', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ip.rtm_config.route.static_route_nh.route_attributes', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, static_route_nh=static_route_nh)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, static_route_nh=static_route_nh)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_route_static_route_nh_tag_delete(self, static_route_nh=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type static_route_nh: static_route_dest, static_route_next_hop
    :param static_route_nh: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_nh** tuple argument:  A.B.C.D/L ;; Destination IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type static_route_next_hop: unicode
    :param static_route_next_hop: **static_route_nh** tuple argument:  A.B.C.D ;; Next hop IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.ip.rtm_config.route.static_route_nh', u'static_route_nh'), ('pybind.nos.v7_1_0.ip.rtm_config.route.static_route_nh', u'static_route_nh'), ('pybind.slxos.v16r_1_00b.ip.rtm_config.route.static_route_nh', u'static_route_nh'), ('pybind.nos.v7_0_1b.ip.rtm_config.route.static_route_nh', u'static_route_nh')]
    bindings_list = [('pybind.nos.v6_0_2c.ip.rtm_config.route.static_route_nh.route_attributes', 'pybind.nos.v6_0_2c.brocade_common_def', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ip.rtm_config.route.static_route_nh.route_attributes', 'pybind.nos.v7_0_1b.brocade_common_def', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ip.rtm_config.route.static_route_nh.route_attributes', 'pybind.nos.v7_1_0.brocade_common_def', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ip.rtm_config.route.static_route_nh.route_attributes', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, static_route_nh=static_route_nh)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, static_route_nh=static_route_nh)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_route_static_route_nh_vrf_delete(self, static_route_nh_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type static_route_nh_vrf: static_route_next_vrf_dest, next_hop_vrf, static_route_next_hop
    :param static_route_nh_vrf: Keyword argument tuple.

    :type static_route_next_vrf_dest: unicode
    :param static_route_next_vrf_dest: **static_route_nh_vrf** tuple argument:  A.B.C.D/L ;; Destination IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type next_hop_vrf: unicode
    :param next_hop_vrf: **static_route_nh_vrf** tuple argument:  Next Hop Vrf Name

    :type static_route_next_hop: unicode
    :param static_route_next_hop: **static_route_nh_vrf** tuple argument:  A.B.C.D ;; Next hop IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.ip.rtm_config.route.static_route_nh_vrf', 'pybind.nos.v6_0_2c.brocade_common_def', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ip.rtm_config.route.static_route_nh_vrf', 'pybind.nos.v7_0_1b.brocade_common_def', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ip.rtm_config.route.static_route_nh_vrf', 'pybind.nos.v7_1_0.brocade_common_def', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ip.rtm_config.route.static_route_nh_vrf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'static_route_nh_vrf', 'keyval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_next_hop', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, static_route_nh_vrf=static_route_nh_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, static_route_nh_vrf=static_route_nh_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_route_static_route_oif_delete(self, static_route_oif=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type static_route_oif: static_route_dest, static_route_oif_type, static_route_oif_name
    :param static_route_oif: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_oif** tuple argument:  A.B.C.D/L ;; Destination IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type static_route_oif_type: unicode
    :param static_route_oif_type: **static_route_oif** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ve',
            'fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'null']

    :type static_route_oif_name: unicode
    :param static_route_oif_name: **static_route_oif** tuple argument.

        * length restriction: ::

            ['1..16']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.ip.rtm_config.route.static_route_oif', 'pybind.nos.v6_0_2c.brocade_common_def', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ip.rtm_config.route.static_route_oif', 'pybind.nos.v7_0_1b.brocade_common_def', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ip.rtm_config.route.static_route_oif', 'pybind.nos.v7_1_0.brocade_common_def', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ip.rtm_config.route.static_route_oif', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'static_route_oif', 'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, static_route_oif=static_route_oif)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, static_route_oif=static_route_oif)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_route_static_route_oif_distance_delete(self, static_route_oif=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type static_route_oif: static_route_dest, static_route_oif_type, static_route_oif_name
    :param static_route_oif: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_oif** tuple argument:  A.B.C.D/L ;; Destination IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type static_route_oif_type: unicode
    :param static_route_oif_type: **static_route_oif** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ve',
            'fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'null']

    :type static_route_oif_name: unicode
    :param static_route_oif_name: **static_route_oif** tuple argument.

        * length restriction: ::

            ['1..16']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.ip.rtm_config.route.static_route_oif', u'static_route_oif'), ('pybind.nos.v6_0_2c.ip.rtm_config.route.static_route_oif', u'static_route_oif'), ('pybind.nos.v7_1_0.ip.rtm_config.route.static_route_oif', u'static_route_oif'), ('pybind.slxos.v16r_1_00b.ip.rtm_config.route.static_route_oif', u'static_route_oif')]
    bindings_list = [('pybind.nos.v6_0_2c.ip.rtm_config.route.static_route_oif.route_attributes', 'pybind.nos.v6_0_2c.brocade_common_def', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ip.rtm_config.route.static_route_oif.route_attributes', 'pybind.nos.v7_0_1b.brocade_common_def', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ip.rtm_config.route.static_route_oif.route_attributes', 'pybind.nos.v7_1_0.brocade_common_def', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ip.rtm_config.route.static_route_oif.route_attributes', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'distance'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, static_route_oif=static_route_oif)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, static_route_oif=static_route_oif)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_route_static_route_oif_metric_delete(self, static_route_oif=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type static_route_oif: static_route_dest, static_route_oif_type, static_route_oif_name
    :param static_route_oif: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_oif** tuple argument:  A.B.C.D/L ;; Destination IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type static_route_oif_type: unicode
    :param static_route_oif_type: **static_route_oif** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ve',
            'fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'null']

    :type static_route_oif_name: unicode
    :param static_route_oif_name: **static_route_oif** tuple argument.

        * length restriction: ::

            ['1..16']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.ip.rtm_config.route.static_route_oif', u'static_route_oif'), ('pybind.nos.v6_0_2c.ip.rtm_config.route.static_route_oif', u'static_route_oif'), ('pybind.nos.v7_1_0.ip.rtm_config.route.static_route_oif', u'static_route_oif'), ('pybind.slxos.v16r_1_00b.ip.rtm_config.route.static_route_oif', u'static_route_oif')]
    bindings_list = [('pybind.nos.v6_0_2c.ip.rtm_config.route.static_route_oif.route_attributes', 'pybind.nos.v6_0_2c.brocade_common_def', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ip.rtm_config.route.static_route_oif.route_attributes', 'pybind.nos.v7_0_1b.brocade_common_def', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ip.rtm_config.route.static_route_oif.route_attributes', 'pybind.nos.v7_1_0.brocade_common_def', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ip.rtm_config.route.static_route_oif.route_attributes', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, static_route_oif=static_route_oif)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, static_route_oif=static_route_oif)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_route_static_route_oif_tag_delete(self, static_route_oif=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type static_route_oif: static_route_dest, static_route_oif_type, static_route_oif_name
    :param static_route_oif: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_oif** tuple argument:  A.B.C.D/L ;; Destination IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type static_route_oif_type: unicode
    :param static_route_oif_type: **static_route_oif** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ve',
            'fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'null']

    :type static_route_oif_name: unicode
    :param static_route_oif_name: **static_route_oif** tuple argument.

        * length restriction: ::

            ['1..16']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.ip.rtm_config.route.static_route_oif', u'static_route_oif'), ('pybind.nos.v6_0_2c.ip.rtm_config.route.static_route_oif', u'static_route_oif'), ('pybind.nos.v7_1_0.ip.rtm_config.route.static_route_oif', u'static_route_oif'), ('pybind.slxos.v16r_1_00b.ip.rtm_config.route.static_route_oif', u'static_route_oif')]
    bindings_list = [('pybind.nos.v6_0_2c.ip.rtm_config.route.static_route_oif.route_attributes', 'pybind.nos.v6_0_2c.brocade_common_def', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ip.rtm_config.route.static_route_oif.route_attributes', 'pybind.nos.v7_0_1b.brocade_common_def', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ip.rtm_config.route.static_route_oif.route_attributes', 'pybind.nos.v7_1_0.brocade_common_def', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ip.rtm_config.route.static_route_oif.route_attributes', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, static_route_oif=static_route_oif)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, static_route_oif=static_route_oif)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_route_static_route_oif_vrf_delete(self, static_route_oif_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type static_route_oif_vrf: static_route_next_vrf_dest, next_hop_vrf, static_route_oif_type, static_route_oif_name
    :param static_route_oif_vrf: Keyword argument tuple.

    :type static_route_next_vrf_dest: unicode
    :param static_route_next_vrf_dest: **static_route_oif_vrf** tuple argument:  A.B.C.D/L ;; Destination IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type next_hop_vrf: unicode
    :param next_hop_vrf: **static_route_oif_vrf** tuple argument:  Next Hop Vrf Name

    :type static_route_oif_type: unicode
    :param static_route_oif_type: **static_route_oif_vrf** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            've']

    :type static_route_oif_name: unicode
    :param static_route_oif_name: **static_route_oif_vrf** tuple argument.

        * length restriction: ::

            ['1..16']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.ip.rtm_config.route.static_route_oif_vrf', 'pybind.nos.v6_0_2c.brocade_common_def', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ip.rtm_config.route.static_route_oif_vrf', 'pybind.nos.v7_0_1b.brocade_common_def', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ip.rtm_config.route.static_route_oif_vrf', 'pybind.nos.v7_1_0.brocade_common_def', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ip.rtm_config.route.static_route_oif_vrf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'static_route_oif_vrf', 'keyval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, static_route_oif_vrf=static_route_oif_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, static_route_oif_vrf=static_route_oif_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_router_id_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.ip.rtm_config', 'pybind.nos.v6_0_2c.brocade_common_def', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ip.rtm_config', 'pybind.nos.v7_0_1b.brocade_common_def', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ip.rtm_config', 'pybind.nos.v7_1_0.brocade_common_def', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ip.rtm_config', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'router-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ip_rtm_config_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.ip.rtm_config', 'pybind.nos.v6_0_2c.brocade_common_def', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ip.rtm_config', 'pybind.nos.v7_0_1b.brocade_common_def', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ip.rtm_config', 'pybind.nos.v7_1_0.brocade_common_def', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ip.rtm_config', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_access_list_extended_delete(self, extended=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.ipv6_acl.ipv6.access_list.extended', 'pybind.nos.v6_0_2c.brocade_ipv6_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ipv6_acl.ipv6.access_list.extended', 'pybind.nos.v7_0_1b.brocade_ipv6_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ipv6_acl.ipv6.access_list.extended', 'pybind.nos.v7_1_0.brocade_ipv6_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.extended', 'pybind.slxos.v16r_1_00b.brocade_ipv6_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_access_list_extended_seq_delete(self, extended=None, seq=None, action=None, protocol_type=None, src_host_any_sip=None, src_host_ip=None, src_mask=None, sport=None, sport_number_eq_neq_tcp=None, sport_number_lt_tcp=None, sport_number_gt_tcp=None, sport_number_eq_neq_udp=None, sport_number_lt_udp=None, sport_number_gt_udp=None, sport_number_range_lower_tcp=None, sport_number_range_lower_udp=None, sport_number_range_higher_tcp=None, sport_number_range_higher_udp=None, dst_host_any_dip=None, dst_host_ip=None, dst_mask=None, dport=None, dport_number_eq_neq_tcp=None, dport_number_lt_tcp=None, dport_number_gt_tcp=None, dport_number_eq_neq_udp=None, dport_number_lt_udp=None, dport_number_gt_udp=None, dport_number_range_lower_tcp=None, dport_number_range_lower_udp=None, dport_number_range_higher_tcp=None, dport_number_range_higher_udp=None, dscp=None, urg=None, ack=None, push=None, fin=None, rst=None, sync=None, vlan=None, count=None, log=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id, action, protocol_type, src_host_any_sip, src_host_ip, src_mask, sport, sport_number_eq_neq_tcp, sport_number_lt_tcp, sport_number_gt_tcp, sport_number_eq_neq_udp, sport_number_lt_udp, sport_number_gt_udp, sport_number_range_lower_tcp, sport_number_range_lower_udp, sport_number_range_higher_tcp, sport_number_range_higher_udp, dst_host_any_dip, dst_host_ip, dst_mask, dport, dport_number_eq_neq_tcp, dport_number_lt_tcp, dport_number_gt_tcp, dport_number_eq_neq_udp, dport_number_lt_udp, dport_number_gt_udp, dport_number_range_lower_tcp, dport_number_range_lower_udp, dport_number_range_higher_tcp, dport_number_range_higher_udp, dscp, urg, ack, push, fin, rst, sync, vlan, count, log
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type action: unicode
    :param action: **seq** tuple argument.

        * enumeration restriction: ::

            ['deny', 'hard-drop', 'permit']

    :type protocol_type: unicode
    :param protocol_type: **seq** tuple argument.

        * enumeration restriction: ::

            ['udp', 'ipv6-icmp', 'tcp', 'ipv6']

    :type src_host_any_sip: unicode
    :param src_host_any_sip: **seq** tuple argument.

        * enumeration restriction: ::

            ['host', 'any']

    :type src_host_ip: unicode
    :param src_host_ip: **seq** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type src_mask: unicode
    :param src_mask: **seq** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type sport: unicode
    :param sport: **seq** tuple argument.

        * enumeration restriction: ::

            ['lt', 'gt', 'eq', 'range', 'neq']

    :type sport_number_eq_neq_tcp: unicode
    :param sport_number_eq_neq_tcp: **seq** tuple argument.

        * enumeration restriction: ::

            ['ftp',
            'domain',
            'tacacs',
            'hostname',
            'smtp',
            'www',
            'telnet',
            'echo',
            'bgp',
            'syslog',
            'ftp-data',
            'daytime',
            'time',
            'pim-auto-rp',
            'login',
            'talk']

    :type sport_number_lt_tcp: unicode
    :param sport_number_lt_tcp: **seq** tuple argument.

        * enumeration restriction: ::

            ['ftp',
            'domain',
            'tacacs',
            'hostname',
            'smtp',
            'www',
            'telnet',
            'echo',
            'bgp',
            'syslog',
            'ftp-data',
            'daytime',
            'time',
            'pim-auto-rp',
            'login',
            'talk']

    :type sport_number_gt_tcp: unicode
    :param sport_number_gt_tcp: **seq** tuple argument.

        * enumeration restriction: ::

            ['ftp',
            'domain',
            'tacacs',
            'hostname',
            'smtp',
            'www',
            'telnet',
            'echo',
            'bgp',
            'syslog',
            'ftp-data',
            'daytime',
            'time',
            'pim-auto-rp',
            'login',
            'talk']

    :type sport_number_eq_neq_udp: unicode
    :param sport_number_eq_neq_udp: **seq** tuple argument.

        * enumeration restriction: ::

            ['domain',
            'ntp',
            'rip',
            'echo',
            'syslog',
            'pim-auto-rp',
            'tacacs',
            'snmp',
            'bootps',
            'tftp',
            'bootpc']

    :type sport_number_lt_udp: unicode
    :param sport_number_lt_udp: **seq** tuple argument.

        * enumeration restriction: ::

            ['domain',
            'ntp',
            'rip',
            'echo',
            'syslog',
            'pim-auto-rp',
            'tacacs',
            'snmp',
            'bootps',
            'tftp',
            'bootpc']

    :type sport_number_gt_udp: unicode
    :param sport_number_gt_udp: **seq** tuple argument.

        * enumeration restriction: ::

            ['domain',
            'ntp',
            'rip',
            'echo',
            'syslog',
            'pim-auto-rp',
            'tacacs',
            'snmp',
            'bootps',
            'tftp',
            'bootpc']

    :type sport_number_range_lower_tcp: unicode
    :param sport_number_range_lower_tcp: **seq** tuple argument.

        * enumeration restriction: ::

            ['ftp',
            'domain',
            'tacacs',
            'hostname',
            'smtp',
            'www',
            'telnet',
            'echo',
            'bgp',
            'syslog',
            'ftp-data',
            'daytime',
            'time',
            'pim-auto-rp',
            'login',
            'talk']

    :type sport_number_range_lower_udp: unicode
    :param sport_number_range_lower_udp: **seq** tuple argument.

        * enumeration restriction: ::

            ['domain',
            'ntp',
            'rip',
            'echo',
            'syslog',
            'pim-auto-rp',
            'tacacs',
            'snmp',
            'bootps',
            'tftp',
            'bootpc']

    :type sport_number_range_higher_tcp: unicode
    :param sport_number_range_higher_tcp: **seq** tuple argument.

        * enumeration restriction: ::

            ['ftp',
            'domain',
            'tacacs',
            'hostname',
            'smtp',
            'www',
            'telnet',
            'echo',
            'bgp',
            'syslog',
            'ftp-data',
            'daytime',
            'time',
            'pim-auto-rp',
            'login',
            'talk']

    :type sport_number_range_higher_udp: unicode
    :param sport_number_range_higher_udp: **seq** tuple argument.

        * enumeration restriction: ::

            ['domain',
            'ntp',
            'rip',
            'echo',
            'syslog',
            'pim-auto-rp',
            'tacacs',
            'snmp',
            'bootps',
            'tftp',
            'bootpc']

    :type dst_host_any_dip: unicode
    :param dst_host_any_dip: **seq** tuple argument.

        * enumeration restriction: ::

            ['host', 'any']

    :type dst_host_ip: unicode
    :param dst_host_ip: **seq** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type dst_mask: unicode
    :param dst_mask: **seq** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type dport: unicode
    :param dport: **seq** tuple argument.

        * enumeration restriction: ::

            ['lt', 'gt', 'eq', 'range', 'neq']

    :type dport_number_eq_neq_tcp: unicode
    :param dport_number_eq_neq_tcp: **seq** tuple argument.

        * enumeration restriction: ::

            ['ftp',
            'domain',
            'tacacs',
            'hostname',
            'smtp',
            'www',
            'telnet',
            'echo',
            'bgp',
            'syslog',
            'ftp-data',
            'daytime',
            'time',
            'pim-auto-rp',
            'login',
            'talk']

    :type dport_number_lt_tcp: unicode
    :param dport_number_lt_tcp: **seq** tuple argument.

        * enumeration restriction: ::

            ['ftp',
            'domain',
            'tacacs',
            'hostname',
            'smtp',
            'www',
            'telnet',
            'echo',
            'bgp',
            'syslog',
            'ftp-data',
            'daytime',
            'time',
            'pim-auto-rp',
            'login',
            'talk']

    :type dport_number_gt_tcp: unicode
    :param dport_number_gt_tcp: **seq** tuple argument.

        * enumeration restriction: ::

            ['ftp',
            'domain',
            'tacacs',
            'hostname',
            'smtp',
            'www',
            'telnet',
            'echo',
            'bgp',
            'syslog',
            'ftp-data',
            'daytime',
            'time',
            'pim-auto-rp',
            'login',
            'talk']

    :type dport_number_eq_neq_udp: unicode
    :param dport_number_eq_neq_udp: **seq** tuple argument.

        * enumeration restriction: ::

            ['domain',
            'ntp',
            'rip',
            'echo',
            'syslog',
            'pim-auto-rp',
            'tacacs',
            'snmp',
            'bootps',
            'tftp',
            'bootpc']

    :type dport_number_lt_udp: unicode
    :param dport_number_lt_udp: **seq** tuple argument.

        * enumeration restriction: ::

            ['domain',
            'ntp',
            'rip',
            'echo',
            'syslog',
            'pim-auto-rp',
            'tacacs',
            'snmp',
            'bootps',
            'tftp',
            'bootpc']

    :type dport_number_gt_udp: unicode
    :param dport_number_gt_udp: **seq** tuple argument.

        * enumeration restriction: ::

            ['domain',
            'ntp',
            'rip',
            'echo',
            'syslog',
            'pim-auto-rp',
            'tacacs',
            'snmp',
            'bootps',
            'tftp',
            'bootpc']

    :type dport_number_range_lower_tcp: unicode
    :param dport_number_range_lower_tcp: **seq** tuple argument.

        * enumeration restriction: ::

            ['ftp',
            'domain',
            'tacacs',
            'hostname',
            'smtp',
            'www',
            'telnet',
            'echo',
            'bgp',
            'syslog',
            'ftp-data',
            'daytime',
            'time',
            'pim-auto-rp',
            'login',
            'talk']

    :type dport_number_range_lower_udp: unicode
    :param dport_number_range_lower_udp: **seq** tuple argument.

        * enumeration restriction: ::

            ['domain',
            'ntp',
            'rip',
            'echo',
            'syslog',
            'pim-auto-rp',
            'tacacs',
            'snmp',
            'bootps',
            'tftp',
            'bootpc']

    :type dport_number_range_higher_tcp: unicode
    :param dport_number_range_higher_tcp: **seq** tuple argument.

        * enumeration restriction: ::

            ['ftp',
            'domain',
            'tacacs',
            'hostname',
            'smtp',
            'www',
            'telnet',
            'echo',
            'bgp',
            'syslog',
            'ftp-data',
            'daytime',
            'time',
            'pim-auto-rp',
            'login',
            'talk']

    :type dport_number_range_higher_udp: unicode
    :param dport_number_range_higher_udp: **seq** tuple argument.

        * enumeration restriction: ::

            ['domain',
            'ntp',
            'rip',
            'echo',
            'syslog',
            'pim-auto-rp',
            'tacacs',
            'snmp',
            'bootps',
            'tftp',
            'bootpc']

    :type dscp: unicode
    :param dscp: **seq** tuple argument:  Differentiated Service Code Point

        * enumeration restriction: ::

            ['af23',
            'af22',
            'af21',
            'af33',
            'af41',
            'af43',
            'af31',
            'default',
            'af42',
            'af12',
            'af32',
            'af13',
            'cs6',
            'cs2',
            'cs5',
            'cs4',
            'cs7',
            'af11',
            'cs1',
            'cs3',
            'ef']

    :type urg: YANGBool
    :param urg: **seq** tuple argument:  Urgent

    :type ack: YANGBool
    :param ack: **seq** tuple argument:  Acknowledgement

    :type push: YANGBool
    :param push: **seq** tuple argument:  Push

    :type fin: YANGBool
    :param fin: **seq** tuple argument:  No more data

    :type rst: YANGBool
    :param rst: **seq** tuple argument:  Reset connection

    :type sync: YANGBool
    :param sync: **seq** tuple argument:  Synchronize

    :type vlan: long
    :param vlan: **seq** tuple argument:  Vlan

        * range restriction: ::

            ['0..4294967295']

    :type count: YANGBool
    :param count: **seq** tuple argument:  Packet Count

    :type log: YANGBool
    :param log: **seq** tuple argument:  Log Packet

    **Instance Argument(s)**:

    :type action: unicode
    :param action: Keyword argument.

        * enumeration restriction: ::

            ['deny', 'hard-drop', 'permit']

    :type protocol_type: unicode
    :param protocol_type: Keyword argument.

        * enumeration restriction: ::

            ['udp', 'ipv6-icmp', 'tcp', 'ipv6']

    :type src_host_any_sip: unicode
    :param src_host_any_sip: Keyword argument.

        * enumeration restriction: ::

            ['host', 'any']

    :type src_host_ip: unicode
    :param src_host_ip: Keyword argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type src_mask: unicode
    :param src_mask: Keyword argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type sport: unicode
    :param sport: Keyword argument.

        * enumeration restriction: ::

            ['lt', 'gt', 'eq', 'range', 'neq']

    :type sport_number_eq_neq_tcp: unicode
    :param sport_number_eq_neq_tcp: Keyword argument.

        * enumeration restriction: ::

            ['ftp',
            'domain',
            'tacacs',
            'hostname',
            'smtp',
            'www',
            'telnet',
            'echo',
            'bgp',
            'syslog',
            'ftp-data',
            'daytime',
            'time',
            'pim-auto-rp',
            'login',
            'talk']

    :type sport_number_lt_tcp: unicode
    :param sport_number_lt_tcp: Keyword argument.

        * enumeration restriction: ::

            ['ftp',
            'domain',
            'tacacs',
            'hostname',
            'smtp',
            'www',
            'telnet',
            'echo',
            'bgp',
            'syslog',
            'ftp-data',
            'daytime',
            'time',
            'pim-auto-rp',
            'login',
            'talk']

    :type sport_number_gt_tcp: unicode
    :param sport_number_gt_tcp: Keyword argument.

        * enumeration restriction: ::

            ['ftp',
            'domain',
            'tacacs',
            'hostname',
            'smtp',
            'www',
            'telnet',
            'echo',
            'bgp',
            'syslog',
            'ftp-data',
            'daytime',
            'time',
            'pim-auto-rp',
            'login',
            'talk']

    :type sport_number_eq_neq_udp: unicode
    :param sport_number_eq_neq_udp: Keyword argument.

        * enumeration restriction: ::

            ['domain',
            'ntp',
            'rip',
            'echo',
            'syslog',
            'pim-auto-rp',
            'tacacs',
            'snmp',
            'bootps',
            'tftp',
            'bootpc']

    :type sport_number_lt_udp: unicode
    :param sport_number_lt_udp: Keyword argument.

        * enumeration restriction: ::

            ['domain',
            'ntp',
            'rip',
            'echo',
            'syslog',
            'pim-auto-rp',
            'tacacs',
            'snmp',
            'bootps',
            'tftp',
            'bootpc']

    :type sport_number_gt_udp: unicode
    :param sport_number_gt_udp: Keyword argument.

        * enumeration restriction: ::

            ['domain',
            'ntp',
            'rip',
            'echo',
            'syslog',
            'pim-auto-rp',
            'tacacs',
            'snmp',
            'bootps',
            'tftp',
            'bootpc']

    :type sport_number_range_lower_tcp: unicode
    :param sport_number_range_lower_tcp: Keyword argument.

        * enumeration restriction: ::

            ['ftp',
            'domain',
            'tacacs',
            'hostname',
            'smtp',
            'www',
            'telnet',
            'echo',
            'bgp',
            'syslog',
            'ftp-data',
            'daytime',
            'time',
            'pim-auto-rp',
            'login',
            'talk']

    :type sport_number_range_lower_udp: unicode
    :param sport_number_range_lower_udp: Keyword argument.

        * enumeration restriction: ::

            ['domain',
            'ntp',
            'rip',
            'echo',
            'syslog',
            'pim-auto-rp',
            'tacacs',
            'snmp',
            'bootps',
            'tftp',
            'bootpc']

    :type sport_number_range_higher_tcp: unicode
    :param sport_number_range_higher_tcp: Keyword argument.

        * enumeration restriction: ::

            ['ftp',
            'domain',
            'tacacs',
            'hostname',
            'smtp',
            'www',
            'telnet',
            'echo',
            'bgp',
            'syslog',
            'ftp-data',
            'daytime',
            'time',
            'pim-auto-rp',
            'login',
            'talk']

    :type sport_number_range_higher_udp: unicode
    :param sport_number_range_higher_udp: Keyword argument.

        * enumeration restriction: ::

            ['domain',
            'ntp',
            'rip',
            'echo',
            'syslog',
            'pim-auto-rp',
            'tacacs',
            'snmp',
            'bootps',
            'tftp',
            'bootpc']

    :type dst_host_any_dip: unicode
    :param dst_host_any_dip: Keyword argument.

        * enumeration restriction: ::

            ['host', 'any']

    :type dst_host_ip: unicode
    :param dst_host_ip: Keyword argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type dst_mask: unicode
    :param dst_mask: Keyword argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type dport: unicode
    :param dport: Keyword argument.

        * enumeration restriction: ::

            ['lt', 'gt', 'eq', 'range', 'neq']

    :type dport_number_eq_neq_tcp: unicode
    :param dport_number_eq_neq_tcp: Keyword argument.

        * enumeration restriction: ::

            ['ftp',
            'domain',
            'tacacs',
            'hostname',
            'smtp',
            'www',
            'telnet',
            'echo',
            'bgp',
            'syslog',
            'ftp-data',
            'daytime',
            'time',
            'pim-auto-rp',
            'login',
            'talk']

    :type dport_number_lt_tcp: unicode
    :param dport_number_lt_tcp: Keyword argument.

        * enumeration restriction: ::

            ['ftp',
            'domain',
            'tacacs',
            'hostname',
            'smtp',
            'www',
            'telnet',
            'echo',
            'bgp',
            'syslog',
            'ftp-data',
            'daytime',
            'time',
            'pim-auto-rp',
            'login',
            'talk']

    :type dport_number_gt_tcp: unicode
    :param dport_number_gt_tcp: Keyword argument.

        * enumeration restriction: ::

            ['ftp',
            'domain',
            'tacacs',
            'hostname',
            'smtp',
            'www',
            'telnet',
            'echo',
            'bgp',
            'syslog',
            'ftp-data',
            'daytime',
            'time',
            'pim-auto-rp',
            'login',
            'talk']

    :type dport_number_eq_neq_udp: unicode
    :param dport_number_eq_neq_udp: Keyword argument.

        * enumeration restriction: ::

            ['domain',
            'ntp',
            'rip',
            'echo',
            'syslog',
            'pim-auto-rp',
            'tacacs',
            'snmp',
            'bootps',
            'tftp',
            'bootpc']

    :type dport_number_lt_udp: unicode
    :param dport_number_lt_udp: Keyword argument.

        * enumeration restriction: ::

            ['domain',
            'ntp',
            'rip',
            'echo',
            'syslog',
            'pim-auto-rp',
            'tacacs',
            'snmp',
            'bootps',
            'tftp',
            'bootpc']

    :type dport_number_gt_udp: unicode
    :param dport_number_gt_udp: Keyword argument.

        * enumeration restriction: ::

            ['domain',
            'ntp',
            'rip',
            'echo',
            'syslog',
            'pim-auto-rp',
            'tacacs',
            'snmp',
            'bootps',
            'tftp',
            'bootpc']

    :type dport_number_range_lower_tcp: unicode
    :param dport_number_range_lower_tcp: Keyword argument.

        * enumeration restriction: ::

            ['ftp',
            'domain',
            'tacacs',
            'hostname',
            'smtp',
            'www',
            'telnet',
            'echo',
            'bgp',
            'syslog',
            'ftp-data',
            'daytime',
            'time',
            'pim-auto-rp',
            'login',
            'talk']

    :type dport_number_range_lower_udp: unicode
    :param dport_number_range_lower_udp: Keyword argument.

        * enumeration restriction: ::

            ['domain',
            'ntp',
            'rip',
            'echo',
            'syslog',
            'pim-auto-rp',
            'tacacs',
            'snmp',
            'bootps',
            'tftp',
            'bootpc']

    :type dport_number_range_higher_tcp: unicode
    :param dport_number_range_higher_tcp: Keyword argument.

        * enumeration restriction: ::

            ['ftp',
            'domain',
            'tacacs',
            'hostname',
            'smtp',
            'www',
            'telnet',
            'echo',
            'bgp',
            'syslog',
            'ftp-data',
            'daytime',
            'time',
            'pim-auto-rp',
            'login',
            'talk']

    :type dport_number_range_higher_udp: unicode
    :param dport_number_range_higher_udp: Keyword argument.

        * enumeration restriction: ::

            ['domain',
            'ntp',
            'rip',
            'echo',
            'syslog',
            'pim-auto-rp',
            'tacacs',
            'snmp',
            'bootps',
            'tftp',
            'bootpc']

    :type dscp: unicode
    :param dscp: Differentiated Service Code Point

        * enumeration restriction: ::

            ['af23',
            'af22',
            'af21',
            'af33',
            'af41',
            'af43',
            'af31',
            'default',
            'af42',
            'af12',
            'af32',
            'af13',
            'cs6',
            'cs2',
            'cs5',
            'cs4',
            'cs7',
            'af11',
            'cs1',
            'cs3',
            'ef']

    :type urg: YANGBool
    :param urg: Urgent

    :type ack: YANGBool
    :param ack: Acknowledgement

    :type push: YANGBool
    :param push: Push

    :type fin: YANGBool
    :param fin: No more data

    :type rst: YANGBool
    :param rst: Reset connection

    :type sync: YANGBool
    :param sync: Synchronize

    :type vlan: long
    :param vlan: Vlan

        * range restriction: ::

            ['0..4294967295']

    :type count: YANGBool
    :param count: Packet Count

    :type log: YANGBool
    :param log: Log Packet

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_1_0.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_0_1b.ipv6_acl.ipv6.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2c.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v6_0_2c.brocade_ipv6_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_0_1b.brocade_ipv6_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_1_0.brocade_ipv6_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v16r_1_00b.brocade_ipv6_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': 'seq_id, action, protocol_type, src_host_any_sip, src_host_ip, src_mask, sport, sport_number_eq_neq_tcp, sport_number_lt_tcp, sport_number_gt_tcp, sport_number_eq_neq_udp, sport_number_lt_udp, sport_number_gt_udp, sport_number_range_lower_tcp, sport_number_range_lower_udp, sport_number_range_higher_tcp, sport_number_range_higher_udp, dst_host_any_dip, dst_host_ip, dst_mask, dport, dport_number_eq_neq_tcp, dport_number_lt_tcp, dport_number_gt_tcp, dport_number_eq_neq_udp, dport_number_lt_udp, dport_number_gt_udp, dport_number_range_lower_tcp, dport_number_range_lower_udp, dport_number_range_higher_tcp, dport_number_range_higher_udp, dscp, urg, ack, push, fin, rst, sync, vlan, count, log'}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v7_1_0.ipv6_acl.ipv6.access_list.extended.seq": {"dport_number_range_higher_udp": "dport_number_range_higher_udp", "sport_number_range_lower_tcp": "sport_number_range_lower_tcp", "push": "push", "sport_number_eq_neq_udp": "sport_number_eq_neq_udp", "sport_number_range_higher_tcp": "sport_number_range_higher_tcp", "sync": "sync", "sport": "sport", "src_mask": "src_mask", "dport_number_lt_udp": "dport_number_lt_udp", "sport_number_range_lower_udp": "sport_number_range_lower_udp", "log": "log", "seq_id": "seq_id", "dport_number_range_lower_tcp": "dport_number_range_lower_tcp", "dport_number_eq_neq_udp": "dport_number_eq_neq_udp", "src_host_ip": "src_host_ip", "sport_number_lt_tcp": "sport_number_lt_tcp", "sport_number_gt_tcp": "sport_number_gt_tcp", "dport_number_gt_udp": "dport_number_gt_udp", "fin": "fin", "dport_number_gt_tcp": "dport_number_gt_tcp", "vlan": "vlan", "dport_number_range_higher_tcp": "dport_number_range_higher_tcp", "sport_number_eq_neq_tcp": "sport_number_eq_neq_tcp", "dscp": "dscp", "sport_number_range_higher_udp": "sport_number_range_higher_udp", "action": "action", "dst_host_ip": "dst_host_ip", "rst": "rst", "dst_mask": "dst_mask", "protocol_type": "protocol_type", "count": "count", "urg": "urg", "dport_number_lt_tcp": "dport_number_lt_tcp", "ack": "ack", "dport_number_eq_neq_tcp": "dport_number_eq_neq_tcp", "dport_number_range_lower_udp": "dport_number_range_lower_udp", "dport": "dport", "src_host_any_sip": "src_host_any_sip", "dst_host_any_dip": "dst_host_any_dip", "sport_number_lt_udp": "sport_number_lt_udp", "sport_number_gt_udp": "sport_number_gt_udp"}, "pybind.nos.v7_0_1b.ipv6_acl.ipv6.access_list.extended.seq": {"dport_number_range_higher_udp": "dport_number_range_higher_udp", "sport_number_range_lower_tcp": "sport_number_range_lower_tcp", "push": "push", "sport_number_eq_neq_udp": "sport_number_eq_neq_udp", "sport_number_range_higher_tcp": "sport_number_range_higher_tcp", "sync": "sync", "sport": "sport", "src_mask": "src_mask", "dport_number_lt_udp": "dport_number_lt_udp", "sport_number_range_lower_udp": "sport_number_range_lower_udp", "log": "log", "seq_id": "seq_id", "dport_number_range_lower_tcp": "dport_number_range_lower_tcp", "dport_number_eq_neq_udp": "dport_number_eq_neq_udp", "src_host_ip": "src_host_ip", "sport_number_lt_tcp": "sport_number_lt_tcp", "sport_number_gt_tcp": "sport_number_gt_tcp", "dport_number_gt_udp": "dport_number_gt_udp", "fin": "fin", "dport_number_gt_tcp": "dport_number_gt_tcp", "vlan": "vlan", "dport_number_range_higher_tcp": "dport_number_range_higher_tcp", "sport_number_eq_neq_tcp": "sport_number_eq_neq_tcp", "dscp": "dscp", "sport_number_range_higher_udp": "sport_number_range_higher_udp", "action": "action", "dst_host_ip": "dst_host_ip", "rst": "rst", "dst_mask": "dst_mask", "protocol_type": "protocol_type", "count": "count", "urg": "urg", "dport_number_lt_tcp": "dport_number_lt_tcp", "ack": "ack", "dport_number_eq_neq_tcp": "dport_number_eq_neq_tcp", "dport_number_range_lower_udp": "dport_number_range_lower_udp", "dport": "dport", "src_host_any_sip": "src_host_any_sip", "dst_host_any_dip": "dst_host_any_dip", "sport_number_lt_udp": "sport_number_lt_udp", "sport_number_gt_udp": "sport_number_gt_udp"}, "pybind.nos.v6_0_2c.ipv6_acl.ipv6.access_list.extended.seq": {"dport_number_range_higher_udp": "dport_number_range_higher_udp", "sport_number_range_lower_tcp": "sport_number_range_lower_tcp", "push": "push", "sport_number_eq_neq_udp": "sport_number_eq_neq_udp", "sport_number_range_higher_tcp": "sport_number_range_higher_tcp", "sync": "sync", "sport": "sport", "src_mask": "src_mask", "dport_number_lt_udp": "dport_number_lt_udp", "sport_number_range_lower_udp": "sport_number_range_lower_udp", "log": "log", "seq_id": "seq_id", "dport_number_range_lower_tcp": "dport_number_range_lower_tcp", "dport_number_eq_neq_udp": "dport_number_eq_neq_udp", "src_host_ip": "src_host_ip", "sport_number_lt_tcp": "sport_number_lt_tcp", "sport_number_gt_tcp": "sport_number_gt_tcp", "dport_number_gt_udp": "dport_number_gt_udp", "fin": "fin", "dport_number_gt_tcp": "dport_number_gt_tcp", "vlan": "vlan", "dport_number_range_higher_tcp": "dport_number_range_higher_tcp", "sport_number_eq_neq_tcp": "sport_number_eq_neq_tcp", "dscp": "dscp", "sport_number_range_higher_udp": "sport_number_range_higher_udp", "action": "action", "dst_host_ip": "dst_host_ip", "rst": "rst", "dst_mask": "dst_mask", "protocol_type": "protocol_type", "count": "count", "urg": "urg", "dport_number_lt_tcp": "dport_number_lt_tcp", "ack": "ack", "dport_number_eq_neq_tcp": "dport_number_eq_neq_tcp", "dport_number_range_lower_udp": "dport_number_range_lower_udp", "dport": "dport", "src_host_any_sip": "src_host_any_sip", "dst_host_any_dip": "dst_host_any_dip", "sport_number_lt_udp": "sport_number_lt_udp", "sport_number_gt_udp": "sport_number_gt_udp"}, "pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.extended.seq": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq, action=action, protocol_type=protocol_type, src_host_any_sip=src_host_any_sip, src_host_ip=src_host_ip, src_mask=src_mask, sport=sport, sport_number_eq_neq_tcp=sport_number_eq_neq_tcp, sport_number_lt_tcp=sport_number_lt_tcp, sport_number_gt_tcp=sport_number_gt_tcp, sport_number_eq_neq_udp=sport_number_eq_neq_udp, sport_number_lt_udp=sport_number_lt_udp, sport_number_gt_udp=sport_number_gt_udp, sport_number_range_lower_tcp=sport_number_range_lower_tcp, sport_number_range_lower_udp=sport_number_range_lower_udp, sport_number_range_higher_tcp=sport_number_range_higher_tcp, sport_number_range_higher_udp=sport_number_range_higher_udp, dst_host_any_dip=dst_host_any_dip, dst_host_ip=dst_host_ip, dst_mask=dst_mask, dport=dport, dport_number_eq_neq_tcp=dport_number_eq_neq_tcp, dport_number_lt_tcp=dport_number_lt_tcp, dport_number_gt_tcp=dport_number_gt_tcp, dport_number_eq_neq_udp=dport_number_eq_neq_udp, dport_number_lt_udp=dport_number_lt_udp, dport_number_gt_udp=dport_number_gt_udp, dport_number_range_lower_tcp=dport_number_range_lower_tcp, dport_number_range_lower_udp=dport_number_range_lower_udp, dport_number_range_higher_tcp=dport_number_range_higher_tcp, dport_number_range_higher_udp=dport_number_range_higher_udp, dscp=dscp, urg=urg, ack=ack, push=push, fin=fin, rst=rst, sync=sync, vlan=vlan, count=count, log=log)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq, action=action, protocol_type=protocol_type, src_host_any_sip=src_host_any_sip, src_host_ip=src_host_ip, src_mask=src_mask, sport=sport, sport_number_eq_neq_tcp=sport_number_eq_neq_tcp, sport_number_lt_tcp=sport_number_lt_tcp, sport_number_gt_tcp=sport_number_gt_tcp, sport_number_eq_neq_udp=sport_number_eq_neq_udp, sport_number_lt_udp=sport_number_lt_udp, sport_number_gt_udp=sport_number_gt_udp, sport_number_range_lower_tcp=sport_number_range_lower_tcp, sport_number_range_lower_udp=sport_number_range_lower_udp, sport_number_range_higher_tcp=sport_number_range_higher_tcp, sport_number_range_higher_udp=sport_number_range_higher_udp, dst_host_any_dip=dst_host_any_dip, dst_host_ip=dst_host_ip, dst_mask=dst_mask, dport=dport, dport_number_eq_neq_tcp=dport_number_eq_neq_tcp, dport_number_lt_tcp=dport_number_lt_tcp, dport_number_gt_tcp=dport_number_gt_tcp, dport_number_eq_neq_udp=dport_number_eq_neq_udp, dport_number_lt_udp=dport_number_lt_udp, dport_number_gt_udp=dport_number_gt_udp, dport_number_range_lower_tcp=dport_number_range_lower_tcp, dport_number_range_lower_udp=dport_number_range_lower_udp, dport_number_range_higher_tcp=dport_number_range_higher_tcp, dport_number_range_higher_udp=dport_number_range_higher_udp, dscp=dscp, urg=urg, ack=ack, push=push, fin=fin, rst=rst, sync=sync, vlan=vlan, count=count, log=log)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_access_list_extended_seq_ack_delete(self, extended=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_1_0.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_0_1b.ipv6_acl.ipv6.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2c.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v6_0_2c.brocade_ipv6_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_0_1b.brocade_ipv6_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_1_0.brocade_ipv6_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v16r_1_00b.brocade_ipv6_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ack'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_access_list_extended_seq_action_delete(self, extended=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_1_0.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_0_1b.ipv6_acl.ipv6.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2c.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v6_0_2c.brocade_ipv6_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_0_1b.brocade_ipv6_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_1_0.brocade_ipv6_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v16r_1_00b.brocade_ipv6_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'action'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_access_list_extended_seq_copy_sflow_delete(self, extended=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.extended', u'extended')]
    bindings_list = [('pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v16r_1_00b.brocade_ipv6_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'copy-sflow'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_access_list_extended_seq_count_delete(self, extended=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_1_0.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_0_1b.ipv6_acl.ipv6.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2c.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v6_0_2c.brocade_ipv6_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_0_1b.brocade_ipv6_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_1_0.brocade_ipv6_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v16r_1_00b.brocade_ipv6_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_access_list_extended_seq_dport_delete(self, extended=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_1_0.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_0_1b.ipv6_acl.ipv6.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2c.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v6_0_2c.brocade_ipv6_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_0_1b.brocade_ipv6_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_1_0.brocade_ipv6_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v16r_1_00b.brocade_ipv6_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dport'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_access_list_extended_seq_dport_number_eq_neq_tcp_delete(self, extended=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_1_0.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_0_1b.ipv6_acl.ipv6.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2c.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v6_0_2c.brocade_ipv6_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_0_1b.brocade_ipv6_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_1_0.brocade_ipv6_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v16r_1_00b.brocade_ipv6_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dport-number-eq-neq-tcp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_access_list_extended_seq_dport_number_eq_neq_udp_delete(self, extended=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_1_0.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_0_1b.ipv6_acl.ipv6.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2c.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v6_0_2c.brocade_ipv6_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_0_1b.brocade_ipv6_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_1_0.brocade_ipv6_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v16r_1_00b.brocade_ipv6_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dport-number-eq-neq-udp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_access_list_extended_seq_dport_number_gt_tcp_delete(self, extended=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_1_0.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_0_1b.ipv6_acl.ipv6.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2c.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v6_0_2c.brocade_ipv6_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_0_1b.brocade_ipv6_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_1_0.brocade_ipv6_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v16r_1_00b.brocade_ipv6_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dport-number-gt-tcp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_access_list_extended_seq_dport_number_gt_udp_delete(self, extended=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_1_0.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_0_1b.ipv6_acl.ipv6.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2c.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v6_0_2c.brocade_ipv6_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_0_1b.brocade_ipv6_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_1_0.brocade_ipv6_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v16r_1_00b.brocade_ipv6_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dport-number-gt-udp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_access_list_extended_seq_dport_number_lt_tcp_delete(self, extended=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_1_0.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_0_1b.ipv6_acl.ipv6.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2c.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v6_0_2c.brocade_ipv6_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_0_1b.brocade_ipv6_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_1_0.brocade_ipv6_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v16r_1_00b.brocade_ipv6_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dport-number-lt-tcp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_access_list_extended_seq_dport_number_lt_udp_delete(self, extended=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_1_0.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_0_1b.ipv6_acl.ipv6.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2c.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v6_0_2c.brocade_ipv6_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_0_1b.brocade_ipv6_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_1_0.brocade_ipv6_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v16r_1_00b.brocade_ipv6_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dport-number-lt-udp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_access_list_extended_seq_dport_number_range_higher_tcp_delete(self, extended=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_1_0.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_0_1b.ipv6_acl.ipv6.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2c.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v6_0_2c.brocade_ipv6_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_0_1b.brocade_ipv6_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_1_0.brocade_ipv6_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v16r_1_00b.brocade_ipv6_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dport-number-range-higher-tcp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_access_list_extended_seq_dport_number_range_higher_udp_delete(self, extended=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_1_0.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_0_1b.ipv6_acl.ipv6.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2c.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v6_0_2c.brocade_ipv6_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_0_1b.brocade_ipv6_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_1_0.brocade_ipv6_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v16r_1_00b.brocade_ipv6_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dport-number-range-higher-udp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_access_list_extended_seq_dport_number_range_lower_tcp_delete(self, extended=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_1_0.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_0_1b.ipv6_acl.ipv6.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2c.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v6_0_2c.brocade_ipv6_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_0_1b.brocade_ipv6_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_1_0.brocade_ipv6_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v16r_1_00b.brocade_ipv6_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dport-number-range-lower-tcp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_access_list_extended_seq_dport_number_range_lower_udp_delete(self, extended=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_1_0.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_0_1b.ipv6_acl.ipv6.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2c.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v6_0_2c.brocade_ipv6_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_0_1b.brocade_ipv6_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_1_0.brocade_ipv6_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v16r_1_00b.brocade_ipv6_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dport-number-range-lower-udp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_access_list_extended_seq_drop_precedence_force_delete(self, extended=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.extended', u'extended')]
    bindings_list = [('pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v16r_1_00b.brocade_ipv6_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'drop-precedence-force'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_access_list_extended_seq_dscp_delete(self, extended=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_1_0.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_0_1b.ipv6_acl.ipv6.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2c.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v6_0_2c.brocade_ipv6_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_0_1b.brocade_ipv6_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_1_0.brocade_ipv6_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v16r_1_00b.brocade_ipv6_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dscp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_access_list_extended_seq_dscp_force_delete(self, extended=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.extended', u'extended')]
    bindings_list = [('pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v16r_1_00b.brocade_ipv6_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dscp-force'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_access_list_extended_seq_dst_host_any_dip_delete(self, extended=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_1_0.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_0_1b.ipv6_acl.ipv6.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2c.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v6_0_2c.brocade_ipv6_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_0_1b.brocade_ipv6_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_1_0.brocade_ipv6_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v16r_1_00b.brocade_ipv6_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dst-host-any-dip'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_access_list_extended_seq_dst_host_ip_delete(self, extended=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_1_0.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_0_1b.ipv6_acl.ipv6.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2c.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v6_0_2c.brocade_ipv6_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_0_1b.brocade_ipv6_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_1_0.brocade_ipv6_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v16r_1_00b.brocade_ipv6_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dst-host-ip'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_access_list_extended_seq_dst_mask_delete(self, extended=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_1_0.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_0_1b.ipv6_acl.ipv6.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2c.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v6_0_2c.brocade_ipv6_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_0_1b.brocade_ipv6_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_1_0.brocade_ipv6_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v16r_1_00b.brocade_ipv6_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dst-mask'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_access_list_extended_seq_fin_delete(self, extended=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_1_0.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_0_1b.ipv6_acl.ipv6.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2c.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v6_0_2c.brocade_ipv6_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_0_1b.brocade_ipv6_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_1_0.brocade_ipv6_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v16r_1_00b.brocade_ipv6_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'fin'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_access_list_extended_seq_log_delete(self, extended=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_1_0.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_0_1b.ipv6_acl.ipv6.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2c.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v6_0_2c.brocade_ipv6_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_0_1b.brocade_ipv6_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_1_0.brocade_ipv6_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v16r_1_00b.brocade_ipv6_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'log'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_access_list_extended_seq_mirror_delete(self, extended=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.extended', u'extended')]
    bindings_list = [('pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v16r_1_00b.brocade_ipv6_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mirror'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_access_list_extended_seq_protocol_type_delete(self, extended=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_1_0.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_0_1b.ipv6_acl.ipv6.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2c.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v6_0_2c.brocade_ipv6_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_0_1b.brocade_ipv6_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_1_0.brocade_ipv6_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v16r_1_00b.brocade_ipv6_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'protocol-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_access_list_extended_seq_push_delete(self, extended=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_1_0.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_0_1b.ipv6_acl.ipv6.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2c.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v6_0_2c.brocade_ipv6_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_0_1b.brocade_ipv6_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_1_0.brocade_ipv6_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v16r_1_00b.brocade_ipv6_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'push'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_access_list_extended_seq_rst_delete(self, extended=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_1_0.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_0_1b.ipv6_acl.ipv6.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2c.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v6_0_2c.brocade_ipv6_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_0_1b.brocade_ipv6_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_1_0.brocade_ipv6_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v16r_1_00b.brocade_ipv6_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rst'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_access_list_extended_seq_sport_delete(self, extended=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_1_0.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_0_1b.ipv6_acl.ipv6.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2c.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v6_0_2c.brocade_ipv6_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_0_1b.brocade_ipv6_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_1_0.brocade_ipv6_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v16r_1_00b.brocade_ipv6_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'sport'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_access_list_extended_seq_sport_number_eq_neq_tcp_delete(self, extended=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_1_0.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_0_1b.ipv6_acl.ipv6.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2c.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v6_0_2c.brocade_ipv6_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_0_1b.brocade_ipv6_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_1_0.brocade_ipv6_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v16r_1_00b.brocade_ipv6_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'sport-number-eq-neq-tcp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_access_list_extended_seq_sport_number_eq_neq_udp_delete(self, extended=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_1_0.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_0_1b.ipv6_acl.ipv6.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2c.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v6_0_2c.brocade_ipv6_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_0_1b.brocade_ipv6_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_1_0.brocade_ipv6_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v16r_1_00b.brocade_ipv6_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'sport-number-eq-neq-udp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_access_list_extended_seq_sport_number_gt_tcp_delete(self, extended=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_1_0.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_0_1b.ipv6_acl.ipv6.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2c.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v6_0_2c.brocade_ipv6_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_0_1b.brocade_ipv6_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_1_0.brocade_ipv6_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v16r_1_00b.brocade_ipv6_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'sport-number-gt-tcp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_access_list_extended_seq_sport_number_gt_udp_delete(self, extended=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_1_0.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_0_1b.ipv6_acl.ipv6.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2c.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v6_0_2c.brocade_ipv6_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_0_1b.brocade_ipv6_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_1_0.brocade_ipv6_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v16r_1_00b.brocade_ipv6_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'sport-number-gt-udp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_access_list_extended_seq_sport_number_lt_tcp_delete(self, extended=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_1_0.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_0_1b.ipv6_acl.ipv6.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2c.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v6_0_2c.brocade_ipv6_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_0_1b.brocade_ipv6_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_1_0.brocade_ipv6_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v16r_1_00b.brocade_ipv6_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'sport-number-lt-tcp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_access_list_extended_seq_sport_number_lt_udp_delete(self, extended=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_1_0.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_0_1b.ipv6_acl.ipv6.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2c.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v6_0_2c.brocade_ipv6_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_0_1b.brocade_ipv6_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_1_0.brocade_ipv6_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v16r_1_00b.brocade_ipv6_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'sport-number-lt-udp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_access_list_extended_seq_sport_number_range_higher_tcp_delete(self, extended=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_1_0.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_0_1b.ipv6_acl.ipv6.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2c.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v6_0_2c.brocade_ipv6_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_0_1b.brocade_ipv6_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_1_0.brocade_ipv6_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v16r_1_00b.brocade_ipv6_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'sport-number-range-higher-tcp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_access_list_extended_seq_sport_number_range_higher_udp_delete(self, extended=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_1_0.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_0_1b.ipv6_acl.ipv6.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2c.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v6_0_2c.brocade_ipv6_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_0_1b.brocade_ipv6_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_1_0.brocade_ipv6_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v16r_1_00b.brocade_ipv6_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'sport-number-range-higher-udp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_access_list_extended_seq_sport_number_range_lower_tcp_delete(self, extended=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_1_0.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_0_1b.ipv6_acl.ipv6.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2c.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v6_0_2c.brocade_ipv6_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_0_1b.brocade_ipv6_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_1_0.brocade_ipv6_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v16r_1_00b.brocade_ipv6_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'sport-number-range-lower-tcp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_access_list_extended_seq_sport_number_range_lower_udp_delete(self, extended=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_1_0.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_0_1b.ipv6_acl.ipv6.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2c.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v6_0_2c.brocade_ipv6_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_0_1b.brocade_ipv6_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_1_0.brocade_ipv6_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v16r_1_00b.brocade_ipv6_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'sport-number-range-lower-udp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_access_list_extended_seq_src_host_any_sip_delete(self, extended=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_1_0.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_0_1b.ipv6_acl.ipv6.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2c.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v6_0_2c.brocade_ipv6_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_0_1b.brocade_ipv6_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_1_0.brocade_ipv6_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v16r_1_00b.brocade_ipv6_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'src-host-any-sip'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_access_list_extended_seq_src_host_ip_delete(self, extended=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_1_0.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_0_1b.ipv6_acl.ipv6.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2c.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v6_0_2c.brocade_ipv6_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_0_1b.brocade_ipv6_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_1_0.brocade_ipv6_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v16r_1_00b.brocade_ipv6_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'src-host-ip'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_access_list_extended_seq_src_mask_delete(self, extended=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_1_0.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_0_1b.ipv6_acl.ipv6.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2c.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v6_0_2c.brocade_ipv6_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_0_1b.brocade_ipv6_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_1_0.brocade_ipv6_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v16r_1_00b.brocade_ipv6_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'src-mask'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_access_list_extended_seq_sync_delete(self, extended=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_1_0.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_0_1b.ipv6_acl.ipv6.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2c.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v6_0_2c.brocade_ipv6_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_0_1b.brocade_ipv6_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_1_0.brocade_ipv6_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v16r_1_00b.brocade_ipv6_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'sync'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_access_list_extended_seq_urg_delete(self, extended=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_1_0.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_0_1b.ipv6_acl.ipv6.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2c.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v6_0_2c.brocade_ipv6_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_0_1b.brocade_ipv6_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_1_0.brocade_ipv6_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v16r_1_00b.brocade_ipv6_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'urg'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_access_list_extended_seq_vlan_delete(self, extended=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_1_0.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_0_1b.ipv6_acl.ipv6.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2c.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v6_0_2c.brocade_ipv6_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_0_1b.brocade_ipv6_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_1_0.brocade_ipv6_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v16r_1_00b.brocade_ipv6_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vlan'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_access_list_standard_delete(self, standard=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type standard: name
    :param standard: Keyword argument tuple.

    :type name: unicode
    :param name: **standard** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.ipv6_acl.ipv6.access_list.standard', 'pybind.nos.v6_0_2c.brocade_ipv6_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ipv6_acl.ipv6.access_list.standard', 'pybind.nos.v7_0_1b.brocade_ipv6_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ipv6_acl.ipv6.access_list.standard', 'pybind.nos.v7_1_0.brocade_ipv6_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.standard', 'pybind.slxos.v16r_1_00b.brocade_ipv6_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'standard', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, standard=standard)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, standard=standard)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_access_list_standard_seq_delete(self, standard=None, seq=None, action=None, src_host_any_sip=None, src_host_ip=None, src_mask=None, count=None, log=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type standard: name
    :param standard: Keyword argument tuple.

    :type name: unicode
    :param name: **standard** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id, action, src_host_any_sip, src_host_ip, src_mask, count, log
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type action: unicode
    :param action: **seq** tuple argument.

        * enumeration restriction: ::

            ['deny', 'hard-drop', 'permit']

    :type src_host_any_sip: unicode
    :param src_host_any_sip: **seq** tuple argument.

        * enumeration restriction: ::

            ['host', 'any']

    :type src_host_ip: unicode
    :param src_host_ip: **seq** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type src_mask: unicode
    :param src_mask: **seq** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type count: YANGBool
    :param count: **seq** tuple argument:  Packet count

    :type log: YANGBool
    :param log: **seq** tuple argument:  Log Packet

    **Instance Argument(s)**:

    :type action: unicode
    :param action: Keyword argument.

        * enumeration restriction: ::

            ['deny', 'hard-drop', 'permit']

    :type src_host_any_sip: unicode
    :param src_host_any_sip: Keyword argument.

        * enumeration restriction: ::

            ['host', 'any']

    :type src_host_ip: unicode
    :param src_host_ip: Keyword argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type src_mask: unicode
    :param src_mask: Keyword argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type count: YANGBool
    :param count: Packet count

    :type log: YANGBool
    :param log: Log Packet

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.ipv6_acl.ipv6.access_list.standard', u'standard'), ('pybind.nos.v7_1_0.ipv6_acl.ipv6.access_list.standard', u'standard'), ('pybind.nos.v7_0_1b.ipv6_acl.ipv6.access_list.standard', u'standard'), ('pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.standard', u'standard')]
    bindings_list = [('pybind.nos.v6_0_2c.ipv6_acl.ipv6.access_list.standard.seq', 'pybind.nos.v6_0_2c.brocade_ipv6_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ipv6_acl.ipv6.access_list.standard.seq', 'pybind.nos.v7_0_1b.brocade_ipv6_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ipv6_acl.ipv6.access_list.standard.seq', 'pybind.nos.v7_1_0.brocade_ipv6_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.standard.seq', 'pybind.slxos.v16r_1_00b.brocade_ipv6_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': 'seq_id, action, src_host_any_sip, src_host_ip, src_mask, count, log, copy_sflow'}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.standard.seq": {}, "pybind.nos.v7_1_0.ipv6_acl.ipv6.access_list.standard.seq": {"count": "count", "log": "log", "seq_id": "seq_id", "src_host_ip": "src_host_ip", "action": "action", "src_host_any_sip": "src_host_any_sip", "src_mask": "src_mask"}, "pybind.nos.v6_0_2c.ipv6_acl.ipv6.access_list.standard.seq": {"count": "count", "log": "log", "seq_id": "seq_id", "src_host_ip": "src_host_ip", "action": "action", "src_host_any_sip": "src_host_any_sip", "src_mask": "src_mask"}, "pybind.nos.v7_0_1b.ipv6_acl.ipv6.access_list.standard.seq": {"count": "count", "log": "log", "seq_id": "seq_id", "src_host_ip": "src_host_ip", "action": "action", "src_host_any_sip": "src_host_any_sip", "src_mask": "src_mask"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, standard=standard, seq=seq, action=action, src_host_any_sip=src_host_any_sip, src_host_ip=src_host_ip, src_mask=src_mask, count=count, log=log)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, standard=standard, seq=seq, action=action, src_host_any_sip=src_host_any_sip, src_host_ip=src_host_ip, src_mask=src_mask, count=count, log=log)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_access_list_standard_seq_action_delete(self, standard=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type standard: name
    :param standard: Keyword argument tuple.

    :type name: unicode
    :param name: **standard** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.ipv6_acl.ipv6.access_list.standard', u'standard'), ('pybind.nos.v7_1_0.ipv6_acl.ipv6.access_list.standard', u'standard'), ('pybind.nos.v7_0_1b.ipv6_acl.ipv6.access_list.standard', u'standard'), ('pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.standard', u'standard')]
    bindings_list = [('pybind.nos.v6_0_2c.ipv6_acl.ipv6.access_list.standard.seq', 'pybind.nos.v6_0_2c.brocade_ipv6_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ipv6_acl.ipv6.access_list.standard.seq', 'pybind.nos.v7_0_1b.brocade_ipv6_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ipv6_acl.ipv6.access_list.standard.seq', 'pybind.nos.v7_1_0.brocade_ipv6_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.standard.seq', 'pybind.slxos.v16r_1_00b.brocade_ipv6_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'action'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, standard=standard, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, standard=standard, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_access_list_standard_seq_copy_sflow_delete(self, standard=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type standard: name
    :param standard: Keyword argument tuple.

    :type name: unicode
    :param name: **standard** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.standard', u'standard')]
    bindings_list = [('pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.standard.seq', 'pybind.slxos.v16r_1_00b.brocade_ipv6_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'copy-sflow'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, standard=standard, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, standard=standard, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_access_list_standard_seq_count_delete(self, standard=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type standard: name
    :param standard: Keyword argument tuple.

    :type name: unicode
    :param name: **standard** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.ipv6_acl.ipv6.access_list.standard', u'standard'), ('pybind.nos.v7_1_0.ipv6_acl.ipv6.access_list.standard', u'standard'), ('pybind.nos.v7_0_1b.ipv6_acl.ipv6.access_list.standard', u'standard'), ('pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.standard', u'standard')]
    bindings_list = [('pybind.nos.v6_0_2c.ipv6_acl.ipv6.access_list.standard.seq', 'pybind.nos.v6_0_2c.brocade_ipv6_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ipv6_acl.ipv6.access_list.standard.seq', 'pybind.nos.v7_0_1b.brocade_ipv6_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ipv6_acl.ipv6.access_list.standard.seq', 'pybind.nos.v7_1_0.brocade_ipv6_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.standard.seq', 'pybind.slxos.v16r_1_00b.brocade_ipv6_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, standard=standard, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, standard=standard, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_access_list_standard_seq_log_delete(self, standard=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type standard: name
    :param standard: Keyword argument tuple.

    :type name: unicode
    :param name: **standard** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.ipv6_acl.ipv6.access_list.standard', u'standard'), ('pybind.nos.v7_1_0.ipv6_acl.ipv6.access_list.standard', u'standard'), ('pybind.nos.v7_0_1b.ipv6_acl.ipv6.access_list.standard', u'standard'), ('pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.standard', u'standard')]
    bindings_list = [('pybind.nos.v6_0_2c.ipv6_acl.ipv6.access_list.standard.seq', 'pybind.nos.v6_0_2c.brocade_ipv6_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ipv6_acl.ipv6.access_list.standard.seq', 'pybind.nos.v7_0_1b.brocade_ipv6_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ipv6_acl.ipv6.access_list.standard.seq', 'pybind.nos.v7_1_0.brocade_ipv6_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.standard.seq', 'pybind.slxos.v16r_1_00b.brocade_ipv6_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'log'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, standard=standard, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, standard=standard, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_access_list_standard_seq_src_host_any_sip_delete(self, standard=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type standard: name
    :param standard: Keyword argument tuple.

    :type name: unicode
    :param name: **standard** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.ipv6_acl.ipv6.access_list.standard', u'standard'), ('pybind.nos.v7_1_0.ipv6_acl.ipv6.access_list.standard', u'standard'), ('pybind.nos.v7_0_1b.ipv6_acl.ipv6.access_list.standard', u'standard'), ('pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.standard', u'standard')]
    bindings_list = [('pybind.nos.v6_0_2c.ipv6_acl.ipv6.access_list.standard.seq', 'pybind.nos.v6_0_2c.brocade_ipv6_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ipv6_acl.ipv6.access_list.standard.seq', 'pybind.nos.v7_0_1b.brocade_ipv6_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ipv6_acl.ipv6.access_list.standard.seq', 'pybind.nos.v7_1_0.brocade_ipv6_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.standard.seq', 'pybind.slxos.v16r_1_00b.brocade_ipv6_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'src-host-any-sip'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, standard=standard, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, standard=standard, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_access_list_standard_seq_src_host_ip_delete(self, standard=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type standard: name
    :param standard: Keyword argument tuple.

    :type name: unicode
    :param name: **standard** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.ipv6_acl.ipv6.access_list.standard', u'standard'), ('pybind.nos.v7_1_0.ipv6_acl.ipv6.access_list.standard', u'standard'), ('pybind.nos.v7_0_1b.ipv6_acl.ipv6.access_list.standard', u'standard'), ('pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.standard', u'standard')]
    bindings_list = [('pybind.nos.v6_0_2c.ipv6_acl.ipv6.access_list.standard.seq', 'pybind.nos.v6_0_2c.brocade_ipv6_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ipv6_acl.ipv6.access_list.standard.seq', 'pybind.nos.v7_0_1b.brocade_ipv6_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ipv6_acl.ipv6.access_list.standard.seq', 'pybind.nos.v7_1_0.brocade_ipv6_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.standard.seq', 'pybind.slxos.v16r_1_00b.brocade_ipv6_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'src-host-ip'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, standard=standard, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, standard=standard, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_access_list_standard_seq_src_mask_delete(self, standard=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type standard: name
    :param standard: Keyword argument tuple.

    :type name: unicode
    :param name: **standard** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.ipv6_acl.ipv6.access_list.standard', u'standard'), ('pybind.nos.v7_1_0.ipv6_acl.ipv6.access_list.standard', u'standard'), ('pybind.nos.v7_0_1b.ipv6_acl.ipv6.access_list.standard', u'standard'), ('pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.standard', u'standard')]
    bindings_list = [('pybind.nos.v6_0_2c.ipv6_acl.ipv6.access_list.standard.seq', 'pybind.nos.v6_0_2c.brocade_ipv6_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ipv6_acl.ipv6.access_list.standard.seq', 'pybind.nos.v7_0_1b.brocade_ipv6_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ipv6_acl.ipv6.access_list.standard.seq', 'pybind.nos.v7_1_0.brocade_ipv6_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ipv6_acl.ipv6.access_list.standard.seq', 'pybind.slxos.v16r_1_00b.brocade_ipv6_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'src-mask'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, standard=standard, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, standard=standard, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_acl_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.ipv6_acl', 'pybind.nos.v6_0_2c.brocade_ipv6_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ipv6_acl', 'pybind.nos.v7_0_1b.brocade_ipv6_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ipv6_acl', 'pybind.nos.v7_1_0.brocade_ipv6_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ipv6_acl', 'pybind.slxos.v16r_1_00b.brocade_ipv6_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_hide_prefix_holder_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.ipv6.hide_prefix_holder', 'pybind.nos.v6_0_2c.brocade_common_def', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ipv6.hide_prefix_holder', 'pybind.nos.v7_0_1b.brocade_common_def', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ipv6.hide_prefix_holder', 'pybind.nos.v7_1_0.brocade_common_def', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_import_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.ipv6.import_', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_import_routes_delete(self, routes=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type routes: src_vrf, route_map
    :param routes: Keyword argument tuple.

    :type src_vrf: unicode
    :param src_vrf: **routes** tuple argument:  ASCII string;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type route_map: unicode
    :param route_map: **routes** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.ipv6.import_.routes', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'routes', 'keyval': 'src_vrf, route_map', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, routes=routes)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, routes=routes)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_ipv6_global_cmds_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.ipv6.ipv6_global_cmds', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_ipv6route_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.ipv6.ipv6route', 'pybind.nos.v6_0_2c.brocade_common_def', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ipv6.ipv6route', 'pybind.nos.v7_0_1b.brocade_common_def', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ipv6.ipv6route', 'pybind.nos.v7_1_0.brocade_common_def', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ipv6.ipv6route', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_mld_snooping_enable_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.mld_snooping.ipv6.mld.snooping', 'pybind.nos.v6_0_2c.brocade_mld_snooping', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.mld_snooping.ipv6.mld.snooping', 'pybind.nos.v7_0_1b.brocade_mld_snooping', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.mld_snooping.ipv6.mld.snooping', 'pybind.nos.v7_1_0.brocade_mld_snooping', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.mld_snooping.ipv6.mld.snooping', 'pybind.slxos.v16r_1_00b.brocade_mld_snooping', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_mtu_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_0_1b.global_mtu_conf.ipv6', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.global_mtu_conf.ipv6', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mtu'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_nd_dad_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.ipv6.ipv6_global_cmds.nd_global.dad', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_nd_dad_time_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.ipv6.ipv6_global_cmds.nd_global.dad', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_nd_global_suppress_ra_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.ipv6.ipv6_global_cmds.nd_global', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'global-suppress-ra'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_nd_ra_dns_server_delete(self, dns_server_global=None, dns_server_lifetime_global=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type dns_server_global: dns_server_prefix_global
    :param dns_server_global: Keyword argument tuple.

    :type dns_server_prefix_global: unicode
    :param dns_server_prefix_global: **dns_server_global** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    **Instance Argument(s)**:

    :type dns_server_lifetime_global: long
    :param dns_server_lifetime_global: Lifetime multiplier for the Recursive DNS Server option

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.ipv6.ipv6_global_cmds.nd_global.dns_server_global', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'dns_server_global', 'keyval': 'dns_server_prefix_global', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dns_server_global=dns_server_global, dns_server_lifetime_global=dns_server_lifetime_global)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dns_server_global=dns_server_global, dns_server_lifetime_global=dns_server_lifetime_global)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_nd_ra_dns_server_lifetime_multiplier_delete(self, dns_server_global=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type dns_server_global: dns_server_prefix_global
    :param dns_server_global: Keyword argument tuple.

    :type dns_server_prefix_global: unicode
    :param dns_server_prefix_global: **dns_server_global** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.ipv6.ipv6_global_cmds.nd_global.dns_server_global', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'dns_server_global', 'keyval': 'dns_server_prefix_global', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lifetime-multiplier'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dns_server_global=dns_server_global)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dns_server_global=dns_server_global)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_nd_ra_domain_name_delete(self, domain_name_global=None, domain_name_lifetime_global=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type domain_name_global: domain_name_string_global
    :param domain_name_global: Keyword argument tuple.

    :type domain_name_string_global: unicode
    :param domain_name_string_global: **domain_name_global** tuple argument.

    **Instance Argument(s)**:

    :type domain_name_lifetime_global: long
    :param domain_name_lifetime_global: Lifetime multiplier for DNS Search List option

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.ipv6.ipv6_global_cmds.nd_global.domain_name_global', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'domain_name_global', 'keyval': 'domain_name_string_global', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain_name_global=domain_name_global, domain_name_lifetime_global=domain_name_lifetime_global)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain_name_global=domain_name_global, domain_name_lifetime_global=domain_name_lifetime_global)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_nd_ra_domain_name_lifetime_multiplier_delete(self, domain_name_global=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type domain_name_global: domain_name_string_global
    :param domain_name_global: Keyword argument tuple.

    :type domain_name_string_global: unicode
    :param domain_name_string_global: **domain_name_global** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.ipv6.ipv6_global_cmds.nd_global.domain_name_global', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'domain_name_global', 'keyval': 'domain_name_string_global', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lifetime-multiplier'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain_name_global=domain_name_global)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain_name_global=domain_name_global)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_pim_snooping_enable_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_0_1b.mld_snooping.ipv6.pim.snooping', 'pybind.nos.v7_0_1b.brocade_mld_snooping', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.mld_snooping.ipv6.pim.snooping', 'pybind.nos.v7_1_0.brocade_mld_snooping', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.mld_snooping.ipv6.pim.snooping', 'pybind.slxos.v16r_1_00b.brocade_mld_snooping', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_prefix_list_delete(self, prefix_list=None, action_ipp=None, ipv6_prefix_ipp=None, ge_ipp=None, le_ipp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type prefix_list: name, seq_keyword, instance, action_ipp, ipv6_prefix_ipp, ge_ipp, le_ipp
    :param prefix_list: Keyword argument tuple.

    :type name: unicode
    :param name: **prefix_list** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type seq_keyword: unicode
    :param seq_keyword: **prefix_list** tuple argument.

        * enumeration restriction: ::

            ['seq']

    :type instance: int
    :param instance: **prefix_list** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type action_ipp: unicode
    :param action_ipp: **prefix_list** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type ipv6_prefix_ipp: unicode
    :param ipv6_prefix_ipp: **prefix_list** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type ge_ipp: long
    :param ge_ipp: **prefix_list** tuple argument:  Minimum IPv6 prefix length.

        * range restriction: ::

            ['0..4294967295']

    :type le_ipp: long
    :param le_ipp: **prefix_list** tuple argument:  Maximum IPv6 prefix length.

        * range restriction: ::

            ['0..4294967295']

    **Instance Argument(s)**:

    :type action_ipp: unicode
    :param action_ipp: Keyword argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type ipv6_prefix_ipp: unicode
    :param ipv6_prefix_ipp: Keyword argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type ge_ipp: long
    :param ge_ipp: Minimum IPv6 prefix length.

        * range restriction: ::

            ['0..4294967295']

    :type le_ipp: long
    :param le_ipp: Maximum IPv6 prefix length.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.ipv6.hide_prefix_holder.prefix_list', 'pybind.nos.v6_0_2c.brocade_common_def', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ipv6.hide_prefix_holder.prefix_list', 'pybind.nos.v7_0_1b.brocade_common_def', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ipv6.hide_prefix_holder.prefix_list', 'pybind.nos.v7_1_0.brocade_common_def', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.ipv6.prefix_list', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'prefix_list', 'keyval': 'name, seq_keyword, instance', 'extra_keyval': 'name, seq_keyword, instance, action_ipp, ipv6_prefix_ipp, ge_ipp, le_ipp'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, prefix_list=prefix_list, action_ipp=action_ipp, ipv6_prefix_ipp=ipv6_prefix_ipp, ge_ipp=ge_ipp, le_ipp=le_ipp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, prefix_list=prefix_list, action_ipp=action_ipp, ipv6_prefix_ipp=ipv6_prefix_ipp, ge_ipp=ge_ipp, le_ipp=le_ipp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_prefix_list_action_ipp_delete(self, prefix_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type prefix_list: name, seq_keyword, instance
    :param prefix_list: Keyword argument tuple.

    :type name: unicode
    :param name: **prefix_list** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type seq_keyword: unicode
    :param seq_keyword: **prefix_list** tuple argument.

        * enumeration restriction: ::

            ['seq']

    :type instance: int
    :param instance: **prefix_list** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.ipv6.hide_prefix_holder.prefix_list', 'pybind.nos.v6_0_2c.brocade_common_def', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ipv6.hide_prefix_holder.prefix_list', 'pybind.nos.v7_0_1b.brocade_common_def', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ipv6.hide_prefix_holder.prefix_list', 'pybind.nos.v7_1_0.brocade_common_def', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.ipv6.prefix_list', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'prefix_list', 'keyval': 'name, seq_keyword, instance', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'action-ipp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, prefix_list=prefix_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, prefix_list=prefix_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_prefix_list_ge_delete(self, prefix_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type prefix_list: name, seq_keyword, instance
    :param prefix_list: Keyword argument tuple.

    :type name: unicode
    :param name: **prefix_list** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type seq_keyword: unicode
    :param seq_keyword: **prefix_list** tuple argument.

        * enumeration restriction: ::

            ['seq']

    :type instance: int
    :param instance: **prefix_list** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.ipv6.hide_prefix_holder.prefix_list', 'pybind.nos.v6_0_2c.brocade_common_def', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ipv6.hide_prefix_holder.prefix_list', 'pybind.nos.v7_0_1b.brocade_common_def', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ipv6.hide_prefix_holder.prefix_list', 'pybind.nos.v7_1_0.brocade_common_def', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.ipv6.prefix_list', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'prefix_list', 'keyval': 'name, seq_keyword, instance', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ge'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, prefix_list=prefix_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, prefix_list=prefix_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_prefix_list_ipv6_prefix_ipp_delete(self, prefix_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type prefix_list: name, seq_keyword, instance
    :param prefix_list: Keyword argument tuple.

    :type name: unicode
    :param name: **prefix_list** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type seq_keyword: unicode
    :param seq_keyword: **prefix_list** tuple argument.

        * enumeration restriction: ::

            ['seq']

    :type instance: int
    :param instance: **prefix_list** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.ipv6.hide_prefix_holder.prefix_list', 'pybind.nos.v6_0_2c.brocade_common_def', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ipv6.hide_prefix_holder.prefix_list', 'pybind.nos.v7_0_1b.brocade_common_def', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ipv6.hide_prefix_holder.prefix_list', 'pybind.nos.v7_1_0.brocade_common_def', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.ipv6.prefix_list', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'prefix_list', 'keyval': 'name, seq_keyword, instance', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ipv6-prefix-ipp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, prefix_list=prefix_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, prefix_list=prefix_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_prefix_list_le_delete(self, prefix_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type prefix_list: name, seq_keyword, instance
    :param prefix_list: Keyword argument tuple.

    :type name: unicode
    :param name: **prefix_list** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type seq_keyword: unicode
    :param seq_keyword: **prefix_list** tuple argument.

        * enumeration restriction: ::

            ['seq']

    :type instance: int
    :param instance: **prefix_list** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.ipv6.hide_prefix_holder.prefix_list', 'pybind.nos.v6_0_2c.brocade_common_def', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ipv6.hide_prefix_holder.prefix_list', 'pybind.nos.v7_0_1b.brocade_common_def', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ipv6.hide_prefix_holder.prefix_list', 'pybind.nos.v7_1_0.brocade_common_def', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.ipv6.prefix_list', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'prefix_list', 'keyval': 'name, seq_keyword, instance', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'le'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, prefix_list=prefix_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, prefix_list=prefix_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_protocol_vrrp_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.ipv6.proto_vrrpv3', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vrrp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_protocol_vrrp_extended_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.ipv6.proto_vrrpv3', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vrrp-extended'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_receive_access_group_delete(self, access_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type access_group: acl_name
    :param access_group: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **access_group** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.receive.access_group', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'access_group', 'keyval': 'acl_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, access_group=access_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, access_group=access_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_route_delete(self, route=None, next_hop=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type route: dest
    :param route: Keyword argument tuple.

    :type dest: unicode
    :param dest: **route** tuple argument:  IPv6Address/prefix.;; Destination IPv6 address-prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    **Instance Argument(s)**:

    :type next_hop: unicode
    :param next_hop: IPv6 address.;; Next hop IPv6 address. Choice keyword argument (Only one choice argument allowed per API invocation).

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.ipv6.ipv6route.route', 'pybind.nos.v6_0_2c.brocade_common_def', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ipv6.ipv6route.route', 'pybind.nos.v7_0_1b.brocade_common_def', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ipv6.ipv6route.route', 'pybind.nos.v7_1_0.brocade_common_def', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ipv6.ipv6route.route', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'route', 'keyval': 'dest', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_0_1b.ipv6.ipv6route.route': [u'next_hop'], 'pybind.nos.v7_1_0.ipv6.ipv6route.route': [u'next_hop'], 'pybind.nos.v6_0_2c.ipv6.ipv6route.route': [u'next_hop'], 'pybind.slxos.v16r_1_00b.ipv6.ipv6route.route': [u'next_hop']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route=route, next_hop=next_hop)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route=route, next_hop=next_hop)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_route_ipv6_static_route_oif_vrf_delete(self, ipv6_static_route_oif_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ipv6_static_route_oif_vrf: static_route_next_vrf_dest, next_hop_vrf, static_route_oif_type, static_route_oif_name
    :param ipv6_static_route_oif_vrf: Keyword argument tuple.

    :type static_route_next_vrf_dest: unicode
    :param static_route_next_vrf_dest: **ipv6_static_route_oif_vrf** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type next_hop_vrf: unicode
    :param next_hop_vrf: **ipv6_static_route_oif_vrf** tuple argument:  Next Hop Vrf Name

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type static_route_oif_type: unicode
    :param static_route_oif_type: **ipv6_static_route_oif_vrf** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ethernet', 'null', 've']

    :type static_route_oif_name: unicode
    :param static_route_oif_name: **ipv6_static_route_oif_vrf** tuple argument.

        * length restriction: ::

            ['1..16']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.ipv6.route.ipv6_static_route_oif_vrf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ipv6_static_route_oif_vrf', 'keyval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ipv6_static_route_oif_vrf=ipv6_static_route_oif_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ipv6_static_route_oif_vrf=ipv6_static_route_oif_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_route_link_local_static_route_nh_delete(self, link_local_static_route_nh=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type link_local_static_route_nh: link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name
    :param link_local_static_route_nh: Keyword argument tuple.

    :type link_local_static_route_dest: unicode
    :param link_local_static_route_dest: **link_local_static_route_nh** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type link_local_nexthop: unicode
    :param link_local_nexthop: **link_local_static_route_nh** tuple argument:  A:B::C:D ;; Next hop IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type link_local_route_oif_type: unicode
    :param link_local_route_oif_type: **link_local_static_route_nh** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ethernet', 'management', 'null', 've']

    :type link_local_route_oif_name: unicode
    :param link_local_route_oif_name: **link_local_static_route_nh** tuple argument.

        * length restriction: ::

            ['1..16']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.ipv6.route.link_local_static_route_nh', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'link_local_static_route_nh', 'keyval': 'link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, link_local_static_route_nh=link_local_static_route_nh)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, link_local_static_route_nh=link_local_static_route_nh)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_route_link_local_static_route_nh_distance_delete(self, link_local_static_route_nh=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type link_local_static_route_nh: link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name
    :param link_local_static_route_nh: Keyword argument tuple.

    :type link_local_static_route_dest: unicode
    :param link_local_static_route_dest: **link_local_static_route_nh** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type link_local_nexthop: unicode
    :param link_local_nexthop: **link_local_static_route_nh** tuple argument:  A:B::C:D ;; Next hop IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type link_local_route_oif_type: unicode
    :param link_local_route_oif_type: **link_local_static_route_nh** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ethernet', 'management', 'null', 've']

    :type link_local_route_oif_name: unicode
    :param link_local_route_oif_name: **link_local_static_route_nh** tuple argument.

        * length restriction: ::

            ['1..16']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.ipv6.route.link_local_static_route_nh', u'link_local_static_route_nh')]
    bindings_list = [('pybind.slxos.v16r_1_00b.ipv6.route.link_local_static_route_nh.route_attributes', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'distance'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, link_local_static_route_nh=link_local_static_route_nh)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, link_local_static_route_nh=link_local_static_route_nh)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_route_link_local_static_route_nh_metric_delete(self, link_local_static_route_nh=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type link_local_static_route_nh: link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name
    :param link_local_static_route_nh: Keyword argument tuple.

    :type link_local_static_route_dest: unicode
    :param link_local_static_route_dest: **link_local_static_route_nh** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type link_local_nexthop: unicode
    :param link_local_nexthop: **link_local_static_route_nh** tuple argument:  A:B::C:D ;; Next hop IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type link_local_route_oif_type: unicode
    :param link_local_route_oif_type: **link_local_static_route_nh** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ethernet', 'management', 'null', 've']

    :type link_local_route_oif_name: unicode
    :param link_local_route_oif_name: **link_local_static_route_nh** tuple argument.

        * length restriction: ::

            ['1..16']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.ipv6.route.link_local_static_route_nh', u'link_local_static_route_nh')]
    bindings_list = [('pybind.slxos.v16r_1_00b.ipv6.route.link_local_static_route_nh.route_attributes', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, link_local_static_route_nh=link_local_static_route_nh)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, link_local_static_route_nh=link_local_static_route_nh)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_route_link_local_static_route_nh_tag_delete(self, link_local_static_route_nh=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type link_local_static_route_nh: link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name
    :param link_local_static_route_nh: Keyword argument tuple.

    :type link_local_static_route_dest: unicode
    :param link_local_static_route_dest: **link_local_static_route_nh** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type link_local_nexthop: unicode
    :param link_local_nexthop: **link_local_static_route_nh** tuple argument:  A:B::C:D ;; Next hop IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type link_local_route_oif_type: unicode
    :param link_local_route_oif_type: **link_local_static_route_nh** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ethernet', 'management', 'null', 've']

    :type link_local_route_oif_name: unicode
    :param link_local_route_oif_name: **link_local_static_route_nh** tuple argument.

        * length restriction: ::

            ['1..16']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.ipv6.route.link_local_static_route_nh', u'link_local_static_route_nh')]
    bindings_list = [('pybind.slxos.v16r_1_00b.ipv6.route.link_local_static_route_nh.route_attributes', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, link_local_static_route_nh=link_local_static_route_nh)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, link_local_static_route_nh=link_local_static_route_nh)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_route_link_local_static_route_nh_vrf_delete(self, link_local_static_route_nh_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type link_local_static_route_nh_vrf: static_route_next_vrf_dest, next_hop_vrf, link_local_next_hop, link_local_route_oif_type, link_local_route_oif_name
    :param link_local_static_route_nh_vrf: Keyword argument tuple.

    :type static_route_next_vrf_dest: unicode
    :param static_route_next_vrf_dest: **link_local_static_route_nh_vrf** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type next_hop_vrf: unicode
    :param next_hop_vrf: **link_local_static_route_nh_vrf** tuple argument:  Next Hop Vrf Name

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type link_local_next_hop: unicode
    :param link_local_next_hop: **link_local_static_route_nh_vrf** tuple argument:  A:B::C:D ;; Next hop IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type link_local_route_oif_type: unicode
    :param link_local_route_oif_type: **link_local_static_route_nh_vrf** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ethernet', 'management', 'null', 've']

    :type link_local_route_oif_name: unicode
    :param link_local_route_oif_name: **link_local_static_route_nh_vrf** tuple argument.

        * length restriction: ::

            ['1..16']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.ipv6.route.link_local_static_route_nh_vrf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'link_local_static_route_nh_vrf', 'keyval': 'static_route_next_vrf_dest, next_hop_vrf, link_local_next_hop, link_local_route_oif_type, link_local_route_oif_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, link_local_static_route_nh_vrf=link_local_static_route_nh_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, link_local_static_route_nh_vrf=link_local_static_route_nh_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_route_next_hop_delete(self, route=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type route: dest
    :param route: Keyword argument tuple.

    :type dest: unicode
    :param dest: **route** tuple argument:  IPv6Address/prefix.;; Destination IPv6 address-prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.ipv6.ipv6route.route', 'pybind.nos.v6_0_2c.brocade_common_def', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ipv6.ipv6route.route', 'pybind.nos.v7_0_1b.brocade_common_def', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ipv6.ipv6route.route', 'pybind.nos.v7_1_0.brocade_common_def', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ipv6.ipv6route.route', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'route', 'keyval': 'dest', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'next-hop'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route=route)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route=route)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_route_static_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.ipv6.route.static', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_route_static_bfd_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.ipv6.route.static.bfd', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_route_static_bfd_bfd_ipv6_link_local_static_route_delete(self, bfd_ipv6_link_local_static_route=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type bfd_ipv6_link_local_static_route: bfd_ipv6_link_local_dest, bfd_ipv6_link_local_src, bfd_interface_type, bfd_interface_name
    :param bfd_ipv6_link_local_static_route: Keyword argument tuple.

    :type bfd_ipv6_link_local_dest: unicode
    :param bfd_ipv6_link_local_dest: **bfd_ipv6_link_local_static_route** tuple argument:  A:B::C:D ;; Destination IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type bfd_ipv6_link_local_src: unicode
    :param bfd_ipv6_link_local_src: **bfd_ipv6_link_local_static_route** tuple argument:  A:B::C:D ;; Source IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type bfd_interface_type: unicode
    :param bfd_interface_type: **bfd_ipv6_link_local_static_route** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ethernet', 'null', 've']

    :type bfd_interface_name: unicode
    :param bfd_interface_name: **bfd_ipv6_link_local_static_route** tuple argument.

        * length restriction: ::

            ['1..16']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.ipv6.route.static.bfd.bfd_ipv6_link_local_static_route', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'bfd_ipv6_link_local_static_route', 'keyval': 'bfd_ipv6_link_local_dest, bfd_ipv6_link_local_src, bfd_interface_type, bfd_interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bfd_ipv6_link_local_static_route=bfd_ipv6_link_local_static_route)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bfd_ipv6_link_local_static_route=bfd_ipv6_link_local_static_route)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_route_static_bfd_bfd_ipv6_static_route_delete(self, bfd_ipv6_static_route=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type bfd_ipv6_static_route: bfd_ipv6_static_route_dest, bfd_ipv6_static_route_src
    :param bfd_ipv6_static_route: Keyword argument tuple.

    :type bfd_ipv6_static_route_dest: unicode
    :param bfd_ipv6_static_route_dest: **bfd_ipv6_static_route** tuple argument:  A:B::C:D ;; Destination IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type bfd_ipv6_static_route_src: unicode
    :param bfd_ipv6_static_route_src: **bfd_ipv6_static_route** tuple argument:  A:B::C:D ;; Source IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.ipv6.route.static.bfd.bfd_ipv6_static_route', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'bfd_ipv6_static_route', 'keyval': 'bfd_ipv6_static_route_dest, bfd_ipv6_static_route_src', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bfd_ipv6_static_route=bfd_ipv6_static_route)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bfd_ipv6_static_route=bfd_ipv6_static_route)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_route_static_bfd_holdover_interval_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.ipv6.route.static.bfd', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'holdover-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_route_static_route_nh_delete(self, static_route_nh=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type static_route_nh: static_route_dest, static_route_next_hop
    :param static_route_nh: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_nh** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type static_route_next_hop: unicode
    :param static_route_next_hop: **static_route_nh** tuple argument:  A:B::C:D ;; Next hop IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.ipv6.route.static_route_nh', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'static_route_nh', 'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, static_route_nh=static_route_nh)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, static_route_nh=static_route_nh)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_route_static_route_nh_distance_delete(self, static_route_nh=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type static_route_nh: static_route_dest, static_route_next_hop
    :param static_route_nh: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_nh** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type static_route_next_hop: unicode
    :param static_route_next_hop: **static_route_nh** tuple argument:  A:B::C:D ;; Next hop IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.ipv6.route.static_route_nh', u'static_route_nh')]
    bindings_list = [('pybind.slxos.v16r_1_00b.ipv6.route.static_route_nh.route_attributes', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'distance'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, static_route_nh=static_route_nh)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, static_route_nh=static_route_nh)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_route_static_route_nh_metric_delete(self, static_route_nh=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type static_route_nh: static_route_dest, static_route_next_hop
    :param static_route_nh: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_nh** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type static_route_next_hop: unicode
    :param static_route_next_hop: **static_route_nh** tuple argument:  A:B::C:D ;; Next hop IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.ipv6.route.static_route_nh', u'static_route_nh')]
    bindings_list = [('pybind.slxos.v16r_1_00b.ipv6.route.static_route_nh.route_attributes', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, static_route_nh=static_route_nh)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, static_route_nh=static_route_nh)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_route_static_route_nh_tag_delete(self, static_route_nh=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type static_route_nh: static_route_dest, static_route_next_hop
    :param static_route_nh: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_nh** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type static_route_next_hop: unicode
    :param static_route_next_hop: **static_route_nh** tuple argument:  A:B::C:D ;; Next hop IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.ipv6.route.static_route_nh', u'static_route_nh')]
    bindings_list = [('pybind.slxos.v16r_1_00b.ipv6.route.static_route_nh.route_attributes', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, static_route_nh=static_route_nh)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, static_route_nh=static_route_nh)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_route_static_route_nh_vrf_delete(self, static_route_nh_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type static_route_nh_vrf: static_route_next_vrf_dest, next_hop_vrf, static_route_next_hop
    :param static_route_nh_vrf: Keyword argument tuple.

    :type static_route_next_vrf_dest: unicode
    :param static_route_next_vrf_dest: **static_route_nh_vrf** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type next_hop_vrf: unicode
    :param next_hop_vrf: **static_route_nh_vrf** tuple argument:  Next Hop Vrf Name

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type static_route_next_hop: unicode
    :param static_route_next_hop: **static_route_nh_vrf** tuple argument:  A:B::C:D ;; Next hop IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.ipv6.route.static_route_nh_vrf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'static_route_nh_vrf', 'keyval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_next_hop', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, static_route_nh_vrf=static_route_nh_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, static_route_nh_vrf=static_route_nh_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_route_static_route_oif_delete(self, static_route_oif=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type static_route_oif: static_route_dest, static_route_oif_type, static_route_oif_name
    :param static_route_oif: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_oif** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type static_route_oif_type: unicode
    :param static_route_oif_type: **static_route_oif** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ethernet', 'null', 've']

    :type static_route_oif_name: unicode
    :param static_route_oif_name: **static_route_oif** tuple argument.

        * length restriction: ::

            ['1..16']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.ipv6.route.static_route_oif', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'static_route_oif', 'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, static_route_oif=static_route_oif)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, static_route_oif=static_route_oif)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_route_static_route_oif_distance_delete(self, static_route_oif=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type static_route_oif: static_route_dest, static_route_oif_type, static_route_oif_name
    :param static_route_oif: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_oif** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type static_route_oif_type: unicode
    :param static_route_oif_type: **static_route_oif** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ethernet', 'null', 've']

    :type static_route_oif_name: unicode
    :param static_route_oif_name: **static_route_oif** tuple argument.

        * length restriction: ::

            ['1..16']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.ipv6.route.static_route_oif', u'static_route_oif')]
    bindings_list = [('pybind.slxos.v16r_1_00b.ipv6.route.static_route_oif.route_attributes', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'distance'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, static_route_oif=static_route_oif)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, static_route_oif=static_route_oif)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_route_static_route_oif_metric_delete(self, static_route_oif=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type static_route_oif: static_route_dest, static_route_oif_type, static_route_oif_name
    :param static_route_oif: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_oif** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type static_route_oif_type: unicode
    :param static_route_oif_type: **static_route_oif** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ethernet', 'null', 've']

    :type static_route_oif_name: unicode
    :param static_route_oif_name: **static_route_oif** tuple argument.

        * length restriction: ::

            ['1..16']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.ipv6.route.static_route_oif', u'static_route_oif')]
    bindings_list = [('pybind.slxos.v16r_1_00b.ipv6.route.static_route_oif.route_attributes', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, static_route_oif=static_route_oif)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, static_route_oif=static_route_oif)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_route_static_route_oif_tag_delete(self, static_route_oif=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type static_route_oif: static_route_dest, static_route_oif_type, static_route_oif_name
    :param static_route_oif: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_oif** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type static_route_oif_type: unicode
    :param static_route_oif_type: **static_route_oif** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ethernet', 'null', 've']

    :type static_route_oif_name: unicode
    :param static_route_oif_name: **static_route_oif** tuple argument.

        * length restriction: ::

            ['1..16']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.ipv6.route.static_route_oif', u'static_route_oif')]
    bindings_list = [('pybind.slxos.v16r_1_00b.ipv6.route.static_route_oif.route_attributes', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, static_route_oif=static_route_oif)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, static_route_oif=static_route_oif)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ospf', 'keyval': 'vrf', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_area_delete(self, ospf=None, area=None, normal=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    **Instance Argument(s)**:

    :type normal: YANGBool
    :param normal: Keyword argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.area', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'area', 'keyval': 'area_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area, normal=normal)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area, normal=normal)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_area_authentication_ah_delete(self, ospf=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.area', u'area')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.area.authentication.ipsec_auth_key_config', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ah'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_area_authentication_esp_delete(self, ospf=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.area', u'area')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.area.authentication.ipsec_auth_key_config', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'esp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_area_authentication_esp_auth_delete(self, ospf=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.area', u'area')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.area.authentication.ipsec_auth_key_config', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'esp-auth'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_area_authentication_esp_key_delete(self, ospf=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.area', u'area')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.area.authentication.ipsec_auth_key_config', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'esp-key'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_area_authentication_esp_no_encrypt_delete(self, ospf=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.area', u'area')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.area.authentication.ipsec_auth_key_config', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'esp-no-encrypt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_area_authentication_key_delete(self, ospf=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.area', u'area')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.area.authentication.ipsec_auth_key_config', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'key'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_area_authentication_no_encrypt_delete(self, ospf=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.area', u'area')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.area.authentication.ipsec_auth_key_config', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'no-encrypt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_area_authentication_spi_delete(self, ospf=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.area', u'area')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.area.authentication.ipsec_auth_key_config', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'spi'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_area_normal_delete(self, ospf=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.area', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'area', 'keyval': 'area_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'normal'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_area_nssa_default_information_originate_delete(self, ospf=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.area', u'area')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.area.nssa.area_default_information_originate', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'area_default_information_originate_metric, area_default_information_originate_metric_type'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_area_nssa_default_information_originate_metric_delete(self, ospf=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.area', u'area')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.area.nssa.area_default_information_originate', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_area_nssa_default_information_originate_metric_type_delete(self, ospf=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.area', u'area')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.area.nssa.area_default_information_originate', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_area_nssa_metric_delete(self, ospf=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.area', u'area')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.area.nssa.metric', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_area_nssa_no_redistribution_delete(self, ospf=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.area', u'area')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.area.nssa', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'no-redistribution'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_area_nssa_no_summary_delete(self, ospf=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.area', u'area')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.area.nssa', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'no-summary'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_area_nssa_nssa_area_metric_delete(self, ospf=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.area', u'area')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.area.nssa.metric', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'nssa-area-metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_area_nssa_translator_always_delete(self, ospf=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.area', u'area')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.area.nssa', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'translator-always'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_area_nssa_translator_interval_delete(self, ospf=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.area', u'area')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.area.nssa', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'translator-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_area_range_delete(self, ospf=None, area=None, area_range=None, range_effect=None, range_cost=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    **Instance Keyword Argument Tuple**:

    :type area_range: range_address, range_effect, range_cost
    :param area_range: Keyword argument tuple.

    :type range_address: unicode
    :param range_address: **area_range** tuple argument:  A:B::C:D/LEN;; IPv6 address to match

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type range_effect: unicode
    :param range_effect: **area_range** tuple argument:  Advertise/Do not advertise this type-3 summarization

        * enumeration restriction: ::

            ['advertise', 'not-advertise']

    :type range_cost: long
    :param range_cost: **area_range** tuple argument:  Configure area range cost

        * range restriction: ::

            ['0..4294967295']

    **Instance Argument(s)**:

    :type range_effect: unicode
    :param range_effect: Advertise/Do not advertise this type-3 summarization

        * enumeration restriction: ::

            ['advertise', 'not-advertise']

    :type range_cost: long
    :param range_cost: Configure area range cost

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.area', u'area')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.area.area_range', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'area_range', 'keyval': 'range_address', 'extra_keyval': 'range_address, range_effect, range_cost'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area, area_range=area_range, range_effect=range_effect, range_cost=range_cost)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area, area_range=area_range, range_effect=range_effect, range_cost=range_cost)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_area_range_cost_delete(self, ospf=None, area=None, area_range=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    **Instance Keyword Argument Tuple**:

    :type area_range: range_address
    :param area_range: Keyword argument tuple.

    :type range_address: unicode
    :param range_address: **area_range** tuple argument:  A:B::C:D/LEN;; IPv6 address to match

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.area', u'area')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.area.area_range', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'area_range', 'keyval': 'range_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cost'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area, area_range=area_range)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area, area_range=area_range)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_area_range_range_effect_delete(self, ospf=None, area=None, area_range=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    **Instance Keyword Argument Tuple**:

    :type area_range: range_address
    :param area_range: Keyword argument tuple.

    :type range_address: unicode
    :param range_address: **area_range** tuple argument:  A:B::C:D/LEN;; IPv6 address to match

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.area', u'area')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.area.area_range', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'area_range', 'keyval': 'range_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'range-effect'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area, area_range=area_range)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area, area_range=area_range)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_area_stub_no_summary_delete(self, ospf=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.area', u'area')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.area.stub', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'no-summary'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_area_stub_stub_area_metric_delete(self, ospf=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.area', u'area')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.area.stub', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'stub-area-metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_area_virtual_link_delete(self, ospf=None, area=None, virtual_link=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    **Instance Keyword Argument Tuple**:

    :type virtual_link: virtual_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virtual_link_neighbor: unicode
    :param virtual_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.area', u'area')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.area.virtual_link', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'virtual_link', 'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_area_virtual_link_authentication_ah_delete(self, ospf=None, area=None, virtual_link=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virtual_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virtual_link_neighbor: unicode
    :param virtual_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.area.virtual_link.link_properties.authentication.ipsec_auth_key_config', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ah'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_area_virtual_link_authentication_esp_delete(self, ospf=None, area=None, virtual_link=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virtual_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virtual_link_neighbor: unicode
    :param virtual_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.area.virtual_link.link_properties.authentication.ipsec_auth_key_config', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'esp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_area_virtual_link_authentication_esp_auth_delete(self, ospf=None, area=None, virtual_link=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virtual_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virtual_link_neighbor: unicode
    :param virtual_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.area.virtual_link.link_properties.authentication.ipsec_auth_key_config', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'esp-auth'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_area_virtual_link_authentication_esp_key_delete(self, ospf=None, area=None, virtual_link=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virtual_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virtual_link_neighbor: unicode
    :param virtual_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.area.virtual_link.link_properties.authentication.ipsec_auth_key_config', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'esp-key'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_area_virtual_link_authentication_esp_no_encrypt_delete(self, ospf=None, area=None, virtual_link=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virtual_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virtual_link_neighbor: unicode
    :param virtual_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.area.virtual_link.link_properties.authentication.ipsec_auth_key_config', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'esp-no-encrypt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_area_virtual_link_authentication_key_delete(self, ospf=None, area=None, virtual_link=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virtual_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virtual_link_neighbor: unicode
    :param virtual_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.area.virtual_link.link_properties.authentication.ipsec_auth_key_config', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'key'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_area_virtual_link_authentication_no_encrypt_delete(self, ospf=None, area=None, virtual_link=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virtual_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virtual_link_neighbor: unicode
    :param virtual_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.area.virtual_link.link_properties.authentication.ipsec_auth_key_config', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'no-encrypt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_area_virtual_link_authentication_spi_delete(self, ospf=None, area=None, virtual_link=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virtual_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virtual_link_neighbor: unicode
    :param virtual_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.area.virtual_link.link_properties.authentication.ipsec_auth_key_config', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'spi'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_area_virtual_link_dead_interval_delete(self, ospf=None, area=None, virtual_link=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virtual_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virtual_link_neighbor: unicode
    :param virtual_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.area.virtual_link.link_properties.link_interval_properties', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dead-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_area_virtual_link_hello_interval_delete(self, ospf=None, area=None, virtual_link=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virtual_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virtual_link_neighbor: unicode
    :param virtual_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.area.virtual_link.link_properties.link_interval_properties', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hello-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_area_virtual_link_hello_jitter_delete(self, ospf=None, area=None, virtual_link=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virtual_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virtual_link_neighbor: unicode
    :param virtual_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.area.virtual_link.link_properties.link_interval_properties', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hello-jitter'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_area_virtual_link_retransmit_interval_delete(self, ospf=None, area=None, virtual_link=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virtual_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virtual_link_neighbor: unicode
    :param virtual_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.area.virtual_link.link_properties.link_interval_properties', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'retransmit-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_area_virtual_link_transmit_delay_delete(self, ospf=None, area=None, virtual_link=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virtual_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virtual_link_neighbor: unicode
    :param virtual_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.area.virtual_link.link_properties.link_interval_properties', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'transmit-delay'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_auto_cost_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.auto_cost', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_auto_cost_reference_bandwidth_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.auto_cost', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'reference-bandwidth'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_bfd_bfd_enable_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.bfd', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bfd-enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_bfd_holdover_interval_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.bfd', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'holdover-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_database_overflow_interval_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ospf', 'keyval': 'vrf', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'database-overflow-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_default_information_originate_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.global_default_information_originate', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'global_default_information_originate_always, global_default_information_originate_metric, global_default_information_originate_metric_type'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_default_information_originate_always_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.global_default_information_originate', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'always'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_default_information_originate_metric_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.global_default_information_originate', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_default_information_originate_metric_type_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.global_default_information_originate', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_default_metric_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ospf', 'keyval': 'vrf', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'default-metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_default_passive_interface_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ospf', 'keyval': 'vrf', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'default-passive-interface'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_distance_delete(self, ospf=None, distance=None, distance_value=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type distance: route_type
    :param distance: Keyword argument tuple.

    :type route_type: unicode
    :param route_type: **distance** tuple argument:  The type of route propagation

        * enumeration restriction: ::

            ['intra-area', 'external', 'inter-area']

    **Instance Argument(s)**:

    :type distance_value: long
    :param distance_value: The distance for a given type of route

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.distance', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'distance', 'keyval': 'route_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, distance=distance, distance_value=distance_value)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, distance=distance, distance_value=distance_value)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_distance_distance_value_delete(self, ospf=None, distance=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type distance: route_type
    :param distance: Keyword argument tuple.

    :type route_type: unicode
    :param route_type: **distance** tuple argument:  The type of route propagation

        * enumeration restriction: ::

            ['intra-area', 'external', 'inter-area']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.distance', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'distance', 'keyval': 'route_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'distance-value'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, distance=distance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, distance=distance)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_distribute_list_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.distribute_list', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_distribute_list_prefix_list_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.distribute_list.prefix_list', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'distribute_list_prefix_list_name, distribute_list_prefix_list_in'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_distribute_list_prefix_list_distribute_list_prefix_list_name_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.distribute_list.prefix_list', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'distribute-list-prefix-list-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_distribute_list_prefix_list_in_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.distribute_list.prefix_list', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'in'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_distribute_list_route_map_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.distribute_list.route_map', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'distribute_list_route_map_name, distribute_list_route_map_in'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_distribute_list_route_map_distribute_list_route_map_name_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.distribute_list.route_map', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'distribute-list-route-map-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_distribute_list_route_map_in_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.distribute_list.route_map', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'in'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_external_lsdb_limit_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ospf', 'keyval': 'vrf', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'external-lsdb-limit'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_graceful_restart_helper_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.graceful_restart.helper', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_graceful_restart_helper_disable_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.graceful_restart.helper', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'disable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_graceful_restart_helper_strict_lsa_checking_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.graceful_restart.helper', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'strict-lsa-checking'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_key_add_remove_interval_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ospf', 'keyval': 'vrf', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'key-add-remove-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_key_rollover_interval_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ospf', 'keyval': 'vrf', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'key-rollover-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_log_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.log', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_log_adjacency_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.log.log_adjacency', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_log_adjacency_dr_only_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.log.log_adjacency', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dr-only'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_log_all_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.log', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'all'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_log_bad_packet_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.log.log_bad_packet', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_log_bad_packet_checksum_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.log.log_bad_packet', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'checksum'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_log_database_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.log', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'database'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_log_retransmit_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.log', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'retransmit'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_log_status_change_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ospf', 'keyval': 'vrf', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'log-status-change'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_max_metric_router_lsa_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.max_metric.router_lsa', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_max_metric_router_lsa_all_lsas_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.max_metric.router_lsa', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'all-lsas'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_max_metric_router_lsa_external_lsa_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.max_metric.router_lsa.external_lsa', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_max_metric_router_lsa_external_lsa_external_lsa_value_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.max_metric.router_lsa.external_lsa', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'external-lsa-value'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_max_metric_router_lsa_include_stub_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.max_metric.router_lsa', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'include-stub'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_max_metric_router_lsa_on_startup_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.max_metric.router_lsa.on_startup', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_max_metric_router_lsa_on_startup_on_startup_time_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.max_metric.router_lsa.on_startup', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'on-startup-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_max_metric_router_lsa_on_startup_wait_for_bgp_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.max_metric.router_lsa.on_startup', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'wait-for-bgp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_max_metric_router_lsa_summary_lsa_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.max_metric.router_lsa.summary_lsa', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_max_metric_router_lsa_summary_lsa_summary_lsa_value_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.max_metric.router_lsa.summary_lsa', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'summary-lsa-value'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_maximum_paths_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ospf', 'keyval': 'vrf', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'maximum-paths'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_metric_type_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ospf', 'keyval': 'vrf', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_nonstop_routing_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ospf', 'keyval': 'vrf', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'nonstop-routing'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_redistribute_bgp_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.redistribute.redistribute_bgp', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_redistribute_bgp_metric_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.redistribute.redistribute_bgp', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_redistribute_bgp_metric_type_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.redistribute.redistribute_bgp', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_redistribute_bgp_route_map_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.redistribute.redistribute_bgp', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_redistribute_connected_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.redistribute.redistribute_connected', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_redistribute_connected_metric_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.redistribute.redistribute_connected', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_redistribute_connected_metric_type_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.redistribute.redistribute_connected', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_redistribute_connected_route_map_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.redistribute.redistribute_connected', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_redistribute_isis_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.redistribute.redistribute_isis', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.redistribute.redistribute_isis': [u'level_2', u'level_1', u'level_1_2']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_redistribute_isis_level_1_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.redistribute.redistribute_isis', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'level-1'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_redistribute_isis_level_1_2_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.redistribute.redistribute_isis', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'level-1-2'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_redistribute_isis_level_2_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.redistribute.redistribute_isis', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'level-2'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_redistribute_isis_metric_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.redistribute.redistribute_isis', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_redistribute_isis_metric_type_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.redistribute.redistribute_isis', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_redistribute_isis_route_map_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.redistribute.redistribute_isis', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_redistribute_ospf_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.redistribute.redistribute_ospf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_redistribute_ospf_metric_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.redistribute.redistribute_ospf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_redistribute_ospf_metric_type_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.redistribute.redistribute_ospf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_redistribute_ospf_route_map_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.redistribute.redistribute_ospf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_redistribute_static_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.redistribute.redistribute_static', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_redistribute_static_metric_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.redistribute.redistribute_static', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_redistribute_static_metric_type_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.redistribute.redistribute_static', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_redistribute_static_route_map_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.redistribute.redistribute_static', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_summary_address_delete(self, ospf=None, summary_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type summary_address: summary_address_value
    :param summary_address: Keyword argument tuple.

    :type summary_address_value: unicode
    :param summary_address_value: **summary_address** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.summary_address', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'summary_address', 'keyval': 'summary_address_value', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, summary_address=summary_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, summary_address=summary_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_timers_lsa_group_pacing_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.timers', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lsa-group-pacing'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_timers_spf_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.timers.spf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'spf_delay, spf_hold_time'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_timers_spf_spf_delay_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.timers.spf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'spf-delay'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ipv6_router_ospf_timers_spf_spf_hold_time_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.ipv6.router.ospf.timers.spf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'spf-hold-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_database_delete(self, database=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type database: level
    :param database: Keyword argument tuple.

    :type level: long
    :param level: **database** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.database', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'database', 'keyval': 'level', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, database=database)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, database=database)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_database_detail_delete(self, database=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type database: level
    :param database: Keyword argument tuple.

    :type level: long
    :param level: **database** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.database', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'database', 'keyval': 'level', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'detail'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, database=database)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, database=database)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_database_isis_operation_delete(self, database=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type database: level
    :param database: Keyword argument tuple.

    :type level: long
    :param level: **database** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.database', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'database', 'keyval': 'level', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'isis-operation'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, database=database)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, database=database)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_database_lsp_entry_delete(self, database=None, lsp_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type database: level
    :param database: Keyword argument tuple.

    :type level: long
    :param level: **database** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type lsp_entry: lsp_level, lsp_id
    :param lsp_entry: Keyword argument tuple.

    :type lsp_level: long
    :param lsp_level: **lsp_entry** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: unicode
    :param lsp_id: **lsp_entry** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.isis_state.database', u'database')]
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.database.lsp_entry', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'level', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'lsp_entry', 'keyval': 'lsp_level, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, database=database, lsp_entry=lsp_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, database=database, lsp_entry=lsp_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_database_lsp_entry_lsp_area_address_delete(self, database=None, lsp_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type database: level
    :param database: Keyword argument tuple.

    :type level: long
    :param level: **database** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type lsp_entry: lsp_level, lsp_id
    :param lsp_entry: Keyword argument tuple.

    :type lsp_level: long
    :param lsp_level: **lsp_entry** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: unicode
    :param lsp_id: **lsp_entry** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.isis_state.database', u'database')]
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.database.lsp_entry', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'level', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'lsp_entry', 'keyval': 'lsp_level, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lsp-area-address'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, database=database, lsp_entry=lsp_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, database=database, lsp_entry=lsp_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_database_lsp_entry_lsp_att_delete(self, database=None, lsp_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type database: level
    :param database: Keyword argument tuple.

    :type level: long
    :param level: **database** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type lsp_entry: lsp_level, lsp_id
    :param lsp_entry: Keyword argument tuple.

    :type lsp_level: long
    :param lsp_level: **lsp_entry** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: unicode
    :param lsp_id: **lsp_entry** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.isis_state.database', u'database')]
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.database.lsp_entry', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'level', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'lsp_entry', 'keyval': 'lsp_level, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lsp-att'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, database=database, lsp_entry=lsp_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, database=database, lsp_entry=lsp_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_database_lsp_entry_lsp_checksum_delete(self, database=None, lsp_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type database: level
    :param database: Keyword argument tuple.

    :type level: long
    :param level: **database** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type lsp_entry: lsp_level, lsp_id
    :param lsp_entry: Keyword argument tuple.

    :type lsp_level: long
    :param lsp_level: **lsp_entry** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: unicode
    :param lsp_id: **lsp_entry** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.isis_state.database', u'database')]
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.database.lsp_entry', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'level', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'lsp_entry', 'keyval': 'lsp_level, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lsp-checksum'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, database=database, lsp_entry=lsp_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, database=database, lsp_entry=lsp_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_database_lsp_entry_lsp_holdtime_delete(self, database=None, lsp_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type database: level
    :param database: Keyword argument tuple.

    :type level: long
    :param level: **database** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type lsp_entry: lsp_level, lsp_id
    :param lsp_entry: Keyword argument tuple.

    :type lsp_level: long
    :param lsp_level: **lsp_entry** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: unicode
    :param lsp_id: **lsp_entry** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.isis_state.database', u'database')]
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.database.lsp_entry', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'level', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'lsp_entry', 'keyval': 'lsp_level, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lsp-holdtime'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, database=database, lsp_entry=lsp_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, database=database, lsp_entry=lsp_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_database_lsp_entry_lsp_hostname_delete(self, database=None, lsp_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type database: level
    :param database: Keyword argument tuple.

    :type level: long
    :param level: **database** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type lsp_entry: lsp_level, lsp_id
    :param lsp_entry: Keyword argument tuple.

    :type lsp_level: long
    :param lsp_level: **lsp_entry** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: unicode
    :param lsp_id: **lsp_entry** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.isis_state.database', u'database')]
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.database.lsp_entry', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'level', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'lsp_entry', 'keyval': 'lsp_level, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lsp-hostname'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, database=database, lsp_entry=lsp_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, database=database, lsp_entry=lsp_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_database_lsp_entry_lsp_nlpid_delete(self, database=None, lsp_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type database: level
    :param database: Keyword argument tuple.

    :type level: long
    :param level: **database** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type lsp_entry: lsp_level, lsp_id
    :param lsp_entry: Keyword argument tuple.

    :type lsp_level: long
    :param lsp_level: **lsp_entry** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: unicode
    :param lsp_id: **lsp_entry** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.isis_state.database', u'database')]
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.database.lsp_entry', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'level', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'lsp_entry', 'keyval': 'lsp_level, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lsp-nlpid'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, database=database, lsp_entry=lsp_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, database=database, lsp_entry=lsp_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_database_lsp_entry_lsp_ol_delete(self, database=None, lsp_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type database: level
    :param database: Keyword argument tuple.

    :type level: long
    :param level: **database** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type lsp_entry: lsp_level, lsp_id
    :param lsp_entry: Keyword argument tuple.

    :type lsp_level: long
    :param lsp_level: **lsp_entry** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: unicode
    :param lsp_id: **lsp_entry** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.isis_state.database', u'database')]
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.database.lsp_entry', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'level', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'lsp_entry', 'keyval': 'lsp_level, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lsp-ol'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, database=database, lsp_entry=lsp_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, database=database, lsp_entry=lsp_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_database_lsp_entry_lsp_p_delete(self, database=None, lsp_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type database: level
    :param database: Keyword argument tuple.

    :type level: long
    :param level: **database** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type lsp_entry: lsp_level, lsp_id
    :param lsp_entry: Keyword argument tuple.

    :type lsp_level: long
    :param lsp_level: **lsp_entry** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: unicode
    :param lsp_id: **lsp_entry** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.isis_state.database', u'database')]
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.database.lsp_entry', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'level', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'lsp_entry', 'keyval': 'lsp_level, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lsp-p'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, database=database, lsp_entry=lsp_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, database=database, lsp_entry=lsp_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_database_lsp_entry_lsp_seq_no_delete(self, database=None, lsp_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type database: level
    :param database: Keyword argument tuple.

    :type level: long
    :param level: **database** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type lsp_entry: lsp_level, lsp_id
    :param lsp_entry: Keyword argument tuple.

    :type lsp_level: long
    :param lsp_level: **lsp_entry** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: unicode
    :param lsp_id: **lsp_entry** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.isis_state.database', u'database')]
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.database.lsp_entry', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'level', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'lsp_entry', 'keyval': 'lsp_level, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lsp-seq-no'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, database=database, lsp_entry=lsp_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, database=database, lsp_entry=lsp_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_database_lsp_entry_lsp_tlv_entry_delete(self, database=None, lsp_entry=None, lsp_tlv_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type database: level
    :param database: Keyword argument tuple.

    :type level: long
    :param level: **database** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_entry: lsp_level, lsp_id
    :param lsp_entry: Keyword argument tuple.

    :type lsp_level: long
    :param lsp_level: **lsp_entry** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: unicode
    :param lsp_id: **lsp_entry** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type lsp_tlv_entry: type
    :param lsp_tlv_entry: Keyword argument tuple.

    :type type: long
    :param type: **lsp_tlv_entry** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.isis_state.database', u'database'), ('pybind.slxos.v16r_1_00b.isis_state.database.lsp_entry', u'lsp_entry')]
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.database.lsp_entry.lsp_tlv_entry', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'level', 'extra_keyval': ''}, {'keyval': 'lsp_level, lsp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'lsp_tlv_entry', 'keyval': 'type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, database=database, lsp_entry=lsp_entry, lsp_tlv_entry=lsp_tlv_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, database=database, lsp_entry=lsp_entry, lsp_tlv_entry=lsp_tlv_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_database_lsp_entry_lsp_tlv_entry_length_delete(self, database=None, lsp_entry=None, lsp_tlv_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type database: level
    :param database: Keyword argument tuple.

    :type level: long
    :param level: **database** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_entry: lsp_level, lsp_id
    :param lsp_entry: Keyword argument tuple.

    :type lsp_level: long
    :param lsp_level: **lsp_entry** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: unicode
    :param lsp_id: **lsp_entry** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type lsp_tlv_entry: type
    :param lsp_tlv_entry: Keyword argument tuple.

    :type type: long
    :param type: **lsp_tlv_entry** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.isis_state.database', u'database'), ('pybind.slxos.v16r_1_00b.isis_state.database.lsp_entry', u'lsp_entry')]
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.database.lsp_entry.lsp_tlv_entry', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'level', 'extra_keyval': ''}, {'keyval': 'lsp_level, lsp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'lsp_tlv_entry', 'keyval': 'type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'length'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, database=database, lsp_entry=lsp_entry, lsp_tlv_entry=lsp_tlv_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, database=database, lsp_entry=lsp_entry, lsp_tlv_entry=lsp_tlv_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_database_lsp_entry_lsp_tlv_entry_sub_tlv_entry_delete(self, database=None, lsp_entry=None, lsp_tlv_entry=None, sub_tlv_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type database: level
    :param database: Keyword argument tuple.

    :type level: long
    :param level: **database** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_entry: lsp_level, lsp_id
    :param lsp_entry: Keyword argument tuple.

    :type lsp_level: long
    :param lsp_level: **lsp_entry** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: unicode
    :param lsp_id: **lsp_entry** tuple argument.

    :type lsp_tlv_entry: type
    :param lsp_tlv_entry: Keyword argument tuple.

    :type type: long
    :param type: **lsp_tlv_entry** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type sub_tlv_entry: type
    :param sub_tlv_entry: Keyword argument tuple.

    :type type: long
    :param type: **sub_tlv_entry** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.isis_state.database', u'database'), ('pybind.slxos.v16r_1_00b.isis_state.database.lsp_entry', u'lsp_entry'), ('pybind.slxos.v16r_1_00b.isis_state.database.lsp_entry.lsp_tlv_entry', u'lsp_tlv_entry')]
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.database.lsp_entry.lsp_tlv_entry.sub_tlv_entry', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'level', 'extra_keyval': ''}, {'keyval': 'lsp_level, lsp_id', 'extra_keyval': ''}, {'keyval': 'type', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'sub_tlv_entry', 'keyval': 'type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, database=database, lsp_entry=lsp_entry, lsp_tlv_entry=lsp_tlv_entry, sub_tlv_entry=sub_tlv_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, database=database, lsp_entry=lsp_entry, lsp_tlv_entry=lsp_tlv_entry, sub_tlv_entry=sub_tlv_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_database_lsp_entry_lsp_tlv_entry_sub_tlv_entry_length_delete(self, database=None, lsp_entry=None, lsp_tlv_entry=None, sub_tlv_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type database: level
    :param database: Keyword argument tuple.

    :type level: long
    :param level: **database** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_entry: lsp_level, lsp_id
    :param lsp_entry: Keyword argument tuple.

    :type lsp_level: long
    :param lsp_level: **lsp_entry** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: unicode
    :param lsp_id: **lsp_entry** tuple argument.

    :type lsp_tlv_entry: type
    :param lsp_tlv_entry: Keyword argument tuple.

    :type type: long
    :param type: **lsp_tlv_entry** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type sub_tlv_entry: type
    :param sub_tlv_entry: Keyword argument tuple.

    :type type: long
    :param type: **sub_tlv_entry** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.isis_state.database', u'database'), ('pybind.slxos.v16r_1_00b.isis_state.database.lsp_entry', u'lsp_entry'), ('pybind.slxos.v16r_1_00b.isis_state.database.lsp_entry.lsp_tlv_entry', u'lsp_tlv_entry')]
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.database.lsp_entry.lsp_tlv_entry.sub_tlv_entry', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'level', 'extra_keyval': ''}, {'keyval': 'lsp_level, lsp_id', 'extra_keyval': ''}, {'keyval': 'type', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'sub_tlv_entry', 'keyval': 'type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'length'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, database=database, lsp_entry=lsp_entry, lsp_tlv_entry=lsp_tlv_entry, sub_tlv_entry=sub_tlv_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, database=database, lsp_entry=lsp_entry, lsp_tlv_entry=lsp_tlv_entry, sub_tlv_entry=sub_tlv_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_database_lsp_level1_checksum_delete(self, database=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type database: level
    :param database: Keyword argument tuple.

    :type level: long
    :param level: **database** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.database', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'database', 'keyval': 'level', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lsp-level1-checksum'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, database=database)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, database=database)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_database_lsp_level1_count_delete(self, database=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type database: level
    :param database: Keyword argument tuple.

    :type level: long
    :param level: **database** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.database', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'database', 'keyval': 'level', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lsp-level1-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, database=database)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, database=database)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_database_lsp_level1_fragments_delete(self, database=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type database: level
    :param database: Keyword argument tuple.

    :type level: long
    :param level: **database** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.database', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'database', 'keyval': 'level', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lsp-level1-fragments'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, database=database)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, database=database)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_database_lsp_level1_loading_delete(self, database=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type database: level
    :param database: Keyword argument tuple.

    :type level: long
    :param level: **database** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.database', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'database', 'keyval': 'level', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lsp-level1-loading'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, database=database)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, database=database)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_database_lsp_level1_my_count_delete(self, database=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type database: level
    :param database: Keyword argument tuple.

    :type level: long
    :param level: **database** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.database', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'database', 'keyval': 'level', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lsp-level1-my-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, database=database)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, database=database)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_database_lsp_level1_my_lsp_fragments_delete(self, database=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type database: level
    :param database: Keyword argument tuple.

    :type level: long
    :param level: **database** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.database', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'database', 'keyval': 'level', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lsp-level1-my-lsp-fragments'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, database=database)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, database=database)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_database_lsp_level1_my_pseudo_delete(self, database=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type database: level
    :param database: Keyword argument tuple.

    :type level: long
    :param level: **database** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.database', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'database', 'keyval': 'level', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lsp-level1-my-pseudo'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, database=database)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, database=database)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_database_lsp_level1_my_pseudo_fragments_delete(self, database=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type database: level
    :param database: Keyword argument tuple.

    :type level: long
    :param level: **database** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.database', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'database', 'keyval': 'level', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lsp-level1-my-pseudo-fragments'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, database=database)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, database=database)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_database_lsp_level1_pseudo_delete(self, database=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type database: level
    :param database: Keyword argument tuple.

    :type level: long
    :param level: **database** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.database', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'database', 'keyval': 'level', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lsp-level1-pseudo'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, database=database)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, database=database)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_database_lsp_level1_pseudo_fragments_delete(self, database=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type database: level
    :param database: Keyword argument tuple.

    :type level: long
    :param level: **database** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.database', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'database', 'keyval': 'level', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lsp-level1-pseudo-fragments'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, database=database)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, database=database)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_database_lsp_level2_checksum_delete(self, database=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type database: level
    :param database: Keyword argument tuple.

    :type level: long
    :param level: **database** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.database', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'database', 'keyval': 'level', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lsp-level2-checksum'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, database=database)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, database=database)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_database_lsp_level2_count_delete(self, database=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type database: level
    :param database: Keyword argument tuple.

    :type level: long
    :param level: **database** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.database', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'database', 'keyval': 'level', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lsp-level2-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, database=database)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, database=database)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_database_lsp_level2_fragments_delete(self, database=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type database: level
    :param database: Keyword argument tuple.

    :type level: long
    :param level: **database** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.database', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'database', 'keyval': 'level', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lsp-level2-fragments'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, database=database)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, database=database)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_database_lsp_level2_loading_delete(self, database=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type database: level
    :param database: Keyword argument tuple.

    :type level: long
    :param level: **database** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.database', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'database', 'keyval': 'level', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lsp-level2-loading'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, database=database)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, database=database)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_database_lsp_level2_my_count_delete(self, database=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type database: level
    :param database: Keyword argument tuple.

    :type level: long
    :param level: **database** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.database', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'database', 'keyval': 'level', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lsp-level2-my-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, database=database)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, database=database)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_database_lsp_level2_my_lsp_fragments_delete(self, database=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type database: level
    :param database: Keyword argument tuple.

    :type level: long
    :param level: **database** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.database', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'database', 'keyval': 'level', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lsp-level2-my-lsp-fragments'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, database=database)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, database=database)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_database_lsp_level2_my_pseudo_delete(self, database=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type database: level
    :param database: Keyword argument tuple.

    :type level: long
    :param level: **database** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.database', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'database', 'keyval': 'level', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lsp-level2-my-pseudo'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, database=database)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, database=database)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_database_lsp_level2_my_pseudo_fragments_delete(self, database=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type database: level
    :param database: Keyword argument tuple.

    :type level: long
    :param level: **database** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.database', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'database', 'keyval': 'level', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lsp-level2-my-pseudo-fragments'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, database=database)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, database=database)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_database_lsp_level2_pseudo_delete(self, database=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type database: level
    :param database: Keyword argument tuple.

    :type level: long
    :param level: **database** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.database', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'database', 'keyval': 'level', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lsp-level2-pseudo'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, database=database)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, database=database)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_database_lsp_level2_pseudo_fragments_delete(self, database=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type database: level
    :param database: Keyword argument tuple.

    :type level: long
    :param level: **database** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.database', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'database', 'keyval': 'level', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lsp-level2-pseudo-fragments'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, database=database)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, database=database)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_database_summary_delete(self, database=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type database: level
    :param database: Keyword argument tuple.

    :type level: long
    :param level: **database** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.database', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'database', 'keyval': 'level', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'summary'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, database=database)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, database=database)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_global_isis_info_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.global_isis_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_global_isis_info_admin_distance_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.global_isis_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'admin-distance'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_global_isis_info_area_addresses_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.global_isis_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'area-addresses'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_global_isis_info_auth_key_l1_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.global_isis_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'auth-key-l1'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_global_isis_info_auth_key_l2_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.global_isis_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'auth-key-l2'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_global_isis_info_auth_mode_l1_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.global_isis_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'auth-mode-l1'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_global_isis_info_auth_mode_l2_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.global_isis_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'auth-mode-l2'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_global_isis_info_bfd_enabled_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.global_isis_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bfd-enabled'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_global_isis_info_bfd_hold_interval_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.global_isis_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bfd-hold-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_global_isis_info_bgp_ipv4_converged_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.global_isis_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bgp-ipv4-converged'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_global_isis_info_bgp_ipv6_converged_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.global_isis_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bgp-ipv6-converged'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_global_isis_info_check_alarm_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.global_isis_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'check-alarm'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_global_isis_info_database_state_level_1_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.global_isis_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'database-state-level-1'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_global_isis_info_database_state_level_1_2_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.global_isis_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'database-state-level-1-2'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_global_isis_info_database_state_level_2_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.global_isis_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'database-state-level-2'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_global_isis_info_default_link_metric_l1_adv_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.global_isis_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'default-link-metric-l1-adv'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_global_isis_info_default_link_metric_l1_conf_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.global_isis_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'default-link-metric-l1-conf'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_global_isis_info_default_link_metric_l2_adv_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.global_isis_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'default-link-metric-l2-adv'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_global_isis_info_default_link_metric_l2_conf_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.global_isis_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'default-link-metric-l2-conf'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_global_isis_info_default_redis_metric_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.global_isis_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'default-redis-metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_global_isis_info_graceful_restart_helper_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.global_isis_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'graceful-restart-helper'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_global_isis_info_hello_padding_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.global_isis_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hello-padding'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_global_isis_info_hello_padding_ptp_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.global_isis_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hello-padding-ptp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_global_isis_info_is_type_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.global_isis_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'is-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_global_isis_info_isis_is_mp_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.global_isis_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'isis-is-mp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_global_isis_info_isis_protocol_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.global_isis_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'isis-protocol'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_global_isis_info_isis_reverse_metric_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.global_isis_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'isis-reverse-metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_global_isis_info_isis_reverse_metric_sbit_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.global_isis_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'isis-reverse-metric-sbit'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_global_isis_info_isis_reverse_metric_wbit_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.global_isis_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'isis-reverse-metric-wbit'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_global_isis_info_isis_shortcuts_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.global_isis_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'isis-shortcuts'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_global_isis_info_isis_state_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.global_isis_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'isis-state'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_global_isis_info_isis_te_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.global_isis_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'isis-te'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_global_isis_info_ldp_sync_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.global_isis_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ldp-sync'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_global_isis_info_ldp_sync_holddown_time_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.global_isis_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ldp-sync-holddown-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_global_isis_info_lsp_gen_interval_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.global_isis_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lsp-gen-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_global_isis_info_lsp_interval_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.global_isis_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lsp-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_global_isis_info_lsp_max_lifetime_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.global_isis_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lsp-max-lifetime'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_global_isis_info_lsp_refresh_interval_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.global_isis_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lsp-refresh-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_global_isis_info_lsp_retrans_interval_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.global_isis_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lsp-retrans-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_global_isis_info_max_paths_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.global_isis_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'max-paths'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_global_isis_info_metric_style_l1_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.global_isis_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric-style-l1'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_global_isis_info_metric_style_l2_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.global_isis_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric-style-l2'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_global_isis_info_no_routes_redis_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.global_isis_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'no-routes-redis'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_global_isis_info_nsr_enabled_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.global_isis_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'nsr-enabled'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_global_isis_info_nsr_standby_state_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.global_isis_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'nsr-standby-state'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_global_isis_info_nsr_state_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.global_isis_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'nsr-state'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_global_isis_info_nsr_sync_state_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.global_isis_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'nsr-sync-state'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_global_isis_info_overload_reason_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.global_isis_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'overload-reason'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_global_isis_info_overload_state_rem_time_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.global_isis_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'overload-state-rem-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_global_isis_info_overload_state_since_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.global_isis_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'overload-state-since'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_global_isis_info_pspf6_init_wait_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.global_isis_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'pspf6-init-wait'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_global_isis_info_pspf6_max_wait_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.global_isis_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'pspf6-max-wait'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_global_isis_info_pspf6_scheduled_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.global_isis_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'pspf6-scheduled'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_global_isis_info_pspf6_second_wait_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.global_isis_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'pspf6-second-wait'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_global_isis_info_pspf_init_wait_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.global_isis_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'pspf-init-wait'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_global_isis_info_pspf_max_wait_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.global_isis_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'pspf-max-wait'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_global_isis_info_pspf_optimization_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.global_isis_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'pspf-optimization'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_global_isis_info_pspf_scheduled_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.global_isis_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'pspf-scheduled'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_global_isis_info_pspf_second_wait_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.global_isis_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'pspf-second-wait'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_global_isis_info_ptp_handshake_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.global_isis_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ptp-handshake'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_global_isis_info_redis_protocol_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.global_isis_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redis-protocol'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_global_isis_info_snp_csnp_interval_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.global_isis_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'snp-csnp-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_global_isis_info_snp_psnp_interval_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.global_isis_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'snp-psnp-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_global_isis_info_spf6_init_wait_l1_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.global_isis_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'spf6-init-wait-l1'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_global_isis_info_spf6_init_wait_l2_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.global_isis_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'spf6-init-wait-l2'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_global_isis_info_spf6_max_wait_l1_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.global_isis_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'spf6-max-wait-l1'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_global_isis_info_spf6_max_wait_l2_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.global_isis_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'spf6-max-wait-l2'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_global_isis_info_spf6_scheduled_l1_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.global_isis_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'spf6-scheduled-l1'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_global_isis_info_spf6_scheduled_l2_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.global_isis_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'spf6-scheduled-l2'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_global_isis_info_spf6_second_wait_l1_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.global_isis_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'spf6-second-wait-l1'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_global_isis_info_spf6_second_wait_l2_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.global_isis_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'spf6-second-wait-l2'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_global_isis_info_spf_init_wait_l1_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.global_isis_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'spf-init-wait-l1'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_global_isis_info_spf_init_wait_l2_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.global_isis_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'spf-init-wait-l2'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_global_isis_info_spf_max_wait_l1_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.global_isis_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'spf-max-wait-l1'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_global_isis_info_spf_max_wait_l2_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.global_isis_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'spf-max-wait-l2'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_global_isis_info_spf_scheduled_l1_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.global_isis_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'spf-scheduled-l1'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_global_isis_info_spf_scheduled_l2_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.global_isis_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'spf-scheduled-l2'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_global_isis_info_spf_second_wait_l1_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.global_isis_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'spf-second-wait-l1'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_global_isis_info_spf_second_wait_l2_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.global_isis_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'spf-second-wait-l2'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_global_isis_info_system_id_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.global_isis_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'system-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_global_isis_info_v6_admin_distance_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.global_isis_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'v6-admin-distance'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_global_isis_info_v6_default_link_metric_l1_adv_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.global_isis_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'v6-default-link-metric-l1-adv'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_global_isis_info_v6_default_link_metric_l1_conf_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.global_isis_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'v6-default-link-metric-l1-conf'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_global_isis_info_v6_default_link_metric_l2_adv_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.global_isis_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'v6-default-link-metric-l2-adv'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_global_isis_info_v6_default_link_metric_l2_conf_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.global_isis_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'v6-default-link-metric-l2-conf'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_global_isis_info_v6_default_redis_metric_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.global_isis_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'v6-default-redis-metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_global_isis_info_v6_max_paths_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.global_isis_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'v6-max-paths'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_global_isis_info_v6_no_routes_redis_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.global_isis_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'v6-no-routes-redis'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_global_isis_info_v6_redis_protocol_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.global_isis_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'v6-redis-protocol'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_host_table_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.host_table', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_host_table_hostname_enabled_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.host_table', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hostname-enabled'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_host_table_isis_router_entry_delete(self, isis_router_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type isis_router_entry: system_id
    :param isis_router_entry: Keyword argument tuple.

    :type system_id: unicode
    :param system_id: **isis_router_entry** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.host_table.isis_router_entry', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'isis_router_entry', 'keyval': 'system_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_router_entry=isis_router_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_router_entry=isis_router_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_host_table_isis_router_entry_host_name_delete(self, isis_router_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type isis_router_entry: system_id
    :param isis_router_entry: Keyword argument tuple.

    :type system_id: unicode
    :param system_id: **isis_router_entry** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.host_table.isis_router_entry', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'isis_router_entry', 'keyval': 'system_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'host-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_router_entry=isis_router_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_router_entry=isis_router_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_host_table_isis_router_entry_is_local_delete(self, isis_router_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type isis_router_entry: system_id
    :param isis_router_entry: Keyword argument tuple.

    :type system_id: unicode
    :param system_id: **isis_router_entry** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.host_table.isis_router_entry', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'isis_router_entry', 'keyval': 'system_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'is-local'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_router_entry=isis_router_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_router_entry=isis_router_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_interface_brief_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_brief', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_interface_brief_isis_intf_brief_delete(self, isis_intf_brief=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type isis_intf_brief: intf_name
    :param isis_intf_brief: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf_brief** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_brief.isis_intf_brief', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'isis_intf_brief', 'keyval': 'intf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf_brief=isis_intf_brief)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf_brief=isis_intf_brief)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_interface_brief_isis_intf_brief_adj_changes_delete(self, isis_intf_brief=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type isis_intf_brief: intf_name
    :param isis_intf_brief: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf_brief** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_brief.isis_intf_brief', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'isis_intf_brief', 'keyval': 'intf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'adj-changes'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf_brief=isis_intf_brief)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf_brief=isis_intf_brief)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_interface_brief_isis_intf_brief_circ_adj_up_delete(self, isis_intf_brief=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type isis_intf_brief: intf_name
    :param isis_intf_brief: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf_brief** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_brief.isis_intf_brief', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'isis_intf_brief', 'keyval': 'intf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'circ-adj-up'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf_brief=isis_intf_brief)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf_brief=isis_intf_brief)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_interface_brief_isis_intf_brief_circ_changes_delete(self, isis_intf_brief=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type isis_intf_brief: intf_name
    :param isis_intf_brief: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf_brief** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_brief.isis_intf_brief', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'isis_intf_brief', 'keyval': 'intf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'circ-changes'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf_brief=isis_intf_brief)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf_brief=isis_intf_brief)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_interface_brief_isis_intf_brief_circ_state_delete(self, isis_intf_brief=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type isis_intf_brief: intf_name
    :param isis_intf_brief: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf_brief** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_brief.isis_intf_brief', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'isis_intf_brief', 'keyval': 'intf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'circ-state'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf_brief=isis_intf_brief)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf_brief=isis_intf_brief)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_interface_brief_isis_intf_brief_circuit_mode_delete(self, isis_intf_brief=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type isis_intf_brief: intf_name
    :param isis_intf_brief: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf_brief** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_brief.isis_intf_brief', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'isis_intf_brief', 'keyval': 'intf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'circuit-mode'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf_brief=isis_intf_brief)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf_brief=isis_intf_brief)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_interface_brief_isis_intf_brief_circuit_type_delete(self, isis_intf_brief=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type isis_intf_brief: intf_name
    :param isis_intf_brief: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf_brief** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_brief.isis_intf_brief', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'isis_intf_brief', 'keyval': 'intf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'circuit-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf_brief=isis_intf_brief)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf_brief=isis_intf_brief)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_interface_brief_isis_intf_brief_is_circuit_passive_delete(self, isis_intf_brief=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type isis_intf_brief: intf_name
    :param isis_intf_brief: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf_brief** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_brief.isis_intf_brief', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'isis_intf_brief', 'keyval': 'intf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'is-circuit-passive'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf_brief=isis_intf_brief)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf_brief=isis_intf_brief)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_interface_brief_isis_intf_brief_is_l1_dis_delete(self, isis_intf_brief=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type isis_intf_brief: intf_name
    :param isis_intf_brief: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf_brief** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_brief.isis_intf_brief', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'isis_intf_brief', 'keyval': 'intf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'is-l1-dis'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf_brief=isis_intf_brief)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf_brief=isis_intf_brief)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_interface_brief_isis_intf_brief_is_l2_dis_delete(self, isis_intf_brief=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type isis_intf_brief: intf_name
    :param isis_intf_brief: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf_brief** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_brief.isis_intf_brief', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'isis_intf_brief', 'keyval': 'intf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'is-l2-dis'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf_brief=isis_intf_brief)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf_brief=isis_intf_brief)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_interface_brief_isis_intf_brief_mtu_size_delete(self, isis_intf_brief=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type isis_intf_brief: intf_name
    :param isis_intf_brief: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf_brief** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_brief.isis_intf_brief', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'isis_intf_brief', 'keyval': 'intf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mtu-size'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf_brief=isis_intf_brief)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf_brief=isis_intf_brief)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_interface_detail_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_delete(self, isis_intf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type isis_intf: intf_name
    :param isis_intf: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'isis_intf', 'keyval': 'intf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_bfd_enabled_delete(self, isis_intf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type isis_intf: intf_name
    :param isis_intf: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'isis_intf', 'keyval': 'intf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bfd-enabled'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_circ_chstats_delete(self, isis_intf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_name
    :param isis_intf: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf.circ_chstats', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_circ_chstats_adj_changes_delete(self, isis_intf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_name
    :param isis_intf: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf.circ_chstats', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'adj-changes'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_circ_chstats_adj_rej_delete(self, isis_intf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_name
    :param isis_intf: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf.circ_chstats', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'adj-rej'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_circ_chstats_bad_lsps_delete(self, isis_intf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_name
    :param isis_intf: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf.circ_chstats', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bad-lsps'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_circ_chstats_circ_changes_delete(self, isis_intf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_name
    :param isis_intf: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf.circ_chstats', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'circ-changes'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_circ_chstats_ctrl_in_delete(self, isis_intf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_name
    :param isis_intf: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf.circ_chstats', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ctrl-in'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_circ_chstats_ctrl_out_delete(self, isis_intf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_name
    :param isis_intf: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf.circ_chstats', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ctrl-out'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_circ_chstats_l1authfail_delete(self, isis_intf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_name
    :param isis_intf: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf.circ_chstats', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'l1authfail'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_circ_chstats_l2authfail_delete(self, isis_intf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_name
    :param isis_intf: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf.circ_chstats', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'l2authfail'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_circuit_encap_delete(self, isis_intf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type isis_intf: intf_name
    :param isis_intf: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'isis_intf', 'keyval': 'intf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'circuit-encap'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_circuit_id_delete(self, isis_intf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type isis_intf: intf_name
    :param isis_intf: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'isis_intf', 'keyval': 'intf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'circuit-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_circuit_ifid_delete(self, isis_intf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type isis_intf: intf_name
    :param isis_intf: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'isis_intf', 'keyval': 'intf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'circuit-ifid'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_circuit_ip_state_delete(self, isis_intf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type isis_intf: intf_name
    :param isis_intf: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'isis_intf', 'keyval': 'intf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'circuit-ip-state'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_circuit_ipv6_state_delete(self, isis_intf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type isis_intf: intf_name
    :param isis_intf: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'isis_intf', 'keyval': 'intf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'circuit-ipv6-state'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_circuit_mode_delete(self, isis_intf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type isis_intf: intf_name
    :param isis_intf: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'isis_intf', 'keyval': 'intf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'circuit-mode'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_circuit_state_delete(self, isis_intf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type isis_intf: intf_name
    :param isis_intf: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'isis_intf', 'keyval': 'intf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'circuit-state'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_circuit_type_delete(self, isis_intf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type isis_intf: intf_name
    :param isis_intf: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'isis_intf', 'keyval': 'intf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'circuit-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_intf_index_delete(self, isis_intf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type isis_intf: intf_name
    :param isis_intf: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'isis_intf', 'keyval': 'intf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'intf-index'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_intf_type_delete(self, isis_intf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type isis_intf: intf_name
    :param isis_intf: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'isis_intf', 'keyval': 'intf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'intf-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_ip6_info_delete(self, isis_intf=None, ip6_info=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_name
    :param isis_intf: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type ip6_info: ip6_add
    :param ip6_info: Keyword argument tuple.

    :type ip6_add: unicode
    :param ip6_add: **ip6_info** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf.ip6_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ip6_info', 'keyval': 'ip6_add', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf, ip6_info=ip6_info)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf, ip6_info=ip6_info)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_ip6_info_ip6_prefix_delete(self, isis_intf=None, ip6_info=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_name
    :param isis_intf: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type ip6_info: ip6_add
    :param ip6_info: Keyword argument tuple.

    :type ip6_add: unicode
    :param ip6_add: **ip6_info** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf.ip6_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ip6_info', 'keyval': 'ip6_add', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ip6-prefix'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf, ip6_info=ip6_info)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf, ip6_info=ip6_info)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_ip6_info_is_link_local_delete(self, isis_intf=None, ip6_info=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_name
    :param isis_intf: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type ip6_info: ip6_add
    :param ip6_info: Keyword argument tuple.

    :type ip6_add: unicode
    :param ip6_add: **ip6_info** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf.ip6_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ip6_info', 'keyval': 'ip6_add', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'is-link-local'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf, ip6_info=ip6_info)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf, ip6_info=ip6_info)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_ip_info_delete(self, isis_intf=None, ip_info=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_name
    :param isis_intf: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type ip_info: ip_add
    :param ip_info: Keyword argument tuple.

    :type ip_add: unicode
    :param ip_add: **ip_info** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf.ip_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ip_info', 'keyval': 'ip_add', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf, ip_info=ip_info)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf, ip_info=ip_info)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_ip_info_ip_prefix_delete(self, isis_intf=None, ip_info=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_name
    :param isis_intf: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type ip_info: ip_add
    :param ip_info: Keyword argument tuple.

    :type ip_add: unicode
    :param ip_add: **ip_info** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf.ip_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ip_info', 'keyval': 'ip_add', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ip-prefix'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf, ip_info=ip_info)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf, ip_info=ip_info)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_is_circuit_passive_delete(self, isis_intf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type isis_intf: intf_name
    :param isis_intf: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'isis_intf', 'keyval': 'intf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'is-circuit-passive'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_l1_circ_metrics_delete(self, isis_intf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_name
    :param isis_intf: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf.l1_circ_metrics', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_l1_circ_metrics_active_adj_delete(self, isis_intf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_name
    :param isis_intf: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf.l1_circ_metrics', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'active-adj'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_l1_circ_metrics_auth_check_delete(self, isis_intf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_name
    :param isis_intf: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf.l1_circ_metrics', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'auth-check'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_l1_circ_metrics_auth_key_delete(self, isis_intf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_name
    :param isis_intf: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf.l1_circ_metrics', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'auth-key'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_l1_circ_metrics_auth_mode_delete(self, isis_intf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_name
    :param isis_intf: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf.l1_circ_metrics', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'auth-mode'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_l1_circ_metrics_circ_metric_delete(self, isis_intf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_name
    :param isis_intf: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf.l1_circ_metrics', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'circ-metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_l1_circ_metrics_circ_priority_delete(self, isis_intf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_name
    :param isis_intf: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf.l1_circ_metrics', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'circ-priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_l1_circ_metrics_dis_delete(self, isis_intf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_name
    :param isis_intf: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf.l1_circ_metrics', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dis'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_l1_circ_metrics_dis_ch_delete(self, isis_intf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_name
    :param isis_intf: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf.l1_circ_metrics', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dis-ch'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_l1_circ_metrics_hello_int_delete(self, isis_intf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_name
    :param isis_intf: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf.l1_circ_metrics', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hello-int'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_l1_circ_metrics_hello_mult_delete(self, isis_intf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_name
    :param isis_intf: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf.l1_circ_metrics', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hello-mult'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_l1_circ_metrics_ip6_circ_metric_delete(self, isis_intf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_name
    :param isis_intf: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf.l1_circ_metrics', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ip6-circ-metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_l1_circ_metrics_next_hello_delete(self, isis_intf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_name
    :param isis_intf: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf.l1_circ_metrics', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'next-hello'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_l2_circ_metrics_delete(self, isis_intf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_name
    :param isis_intf: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf.l2_circ_metrics', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_l2_circ_metrics_active_adj_delete(self, isis_intf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_name
    :param isis_intf: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf.l2_circ_metrics', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'active-adj'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_l2_circ_metrics_auth_check_delete(self, isis_intf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_name
    :param isis_intf: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf.l2_circ_metrics', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'auth-check'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_l2_circ_metrics_auth_key_delete(self, isis_intf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_name
    :param isis_intf: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf.l2_circ_metrics', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'auth-key'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_l2_circ_metrics_auth_mode_delete(self, isis_intf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_name
    :param isis_intf: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf.l2_circ_metrics', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'auth-mode'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_l2_circ_metrics_circ_metric_delete(self, isis_intf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_name
    :param isis_intf: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf.l2_circ_metrics', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'circ-metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_l2_circ_metrics_circ_priority_delete(self, isis_intf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_name
    :param isis_intf: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf.l2_circ_metrics', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'circ-priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_l2_circ_metrics_dis_delete(self, isis_intf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_name
    :param isis_intf: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf.l2_circ_metrics', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dis'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_l2_circ_metrics_dis_ch_delete(self, isis_intf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_name
    :param isis_intf: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf.l2_circ_metrics', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dis-ch'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_l2_circ_metrics_hello_int_delete(self, isis_intf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_name
    :param isis_intf: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf.l2_circ_metrics', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hello-int'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_l2_circ_metrics_hello_mult_delete(self, isis_intf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_name
    :param isis_intf: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf.l2_circ_metrics', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hello-mult'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_l2_circ_metrics_ip6_circ_metric_delete(self, isis_intf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_name
    :param isis_intf: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf.l2_circ_metrics', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ip6-circ-metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_l2_circ_metrics_next_hello_delete(self, isis_intf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_name
    :param isis_intf: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf.l2_circ_metrics', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'next-hello'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_ldp_sync_info_delete(self, isis_intf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_name
    :param isis_intf: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf.ldp_sync_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_ldp_sync_info_ldp_in_sync_delete(self, isis_intf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_name
    :param isis_intf: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf.ldp_sync_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ldp-in-sync'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_ldp_sync_info_ldp_sync_enabled_delete(self, isis_intf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_name
    :param isis_intf: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf.ldp_sync_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ldp-sync-enabled'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_ldp_sync_info_ldp_sync_hd_expired_delete(self, isis_intf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_name
    :param isis_intf: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf.ldp_sync_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ldp-sync-hd-expired'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_ldp_sync_info_ldp_sync_hold_down_delete(self, isis_intf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_name
    :param isis_intf: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf.ldp_sync_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ldp-sync-hold-down'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_ldp_sync_info_remain_hd_time_delete(self, isis_intf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_name
    :param isis_intf: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf.ldp_sync_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'remain-hd-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_mpls_info_delete(self, isis_intf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_name
    :param isis_intf: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf.mpls_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_mpls_info_admin_group_delete(self, isis_intf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_name
    :param isis_intf: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf.mpls_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'admin-group'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_mpls_info_max_link_bw_delete(self, isis_intf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_name
    :param isis_intf: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf.mpls_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'max-link-bw'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_mpls_info_max_reserv_bw_delete(self, isis_intf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_name
    :param isis_intf: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf.mpls_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'max-reserv-bw'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_mpls_info_te_enabled_delete(self, isis_intf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_name
    :param isis_intf: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf.mpls_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'te-enabled'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_mpls_info_te_metric_delete(self, isis_intf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_name
    :param isis_intf: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf.mpls_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'te-metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_mtu_size_delete(self, isis_intf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type isis_intf: intf_name
    :param isis_intf: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'isis_intf', 'keyval': 'intf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mtu-size'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_padding_enabled_delete(self, isis_intf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type isis_intf: intf_name
    :param isis_intf: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'isis_intf', 'keyval': 'intf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'padding-enabled'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_reverse_metric_info_delete(self, isis_intf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_name
    :param isis_intf: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf.reverse_metric_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_reverse_metric_info_is_global_config_delete(self, isis_intf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_name
    :param isis_intf: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf.reverse_metric_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'is-global-config'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_reverse_metric_info_rev_metric_te_def_metric_delete(self, isis_intf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_name
    :param isis_intf: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf.reverse_metric_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rev-metric-te-def-metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_reverse_metric_info_rev_metric_whole_lan_delete(self, isis_intf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_name
    :param isis_intf: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf.reverse_metric_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rev-metric-whole-lan'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_reverse_metric_info_reverse_metric_value_delete(self, isis_intf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_name
    :param isis_intf: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf.reverse_metric_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'reverse-metric-value'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_v4circuit_enabled_delete(self, isis_intf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type isis_intf: intf_name
    :param isis_intf: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'isis_intf', 'keyval': 'intf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'v4circuit-enabled'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_v6circuit_enabled_delete(self, isis_intf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type isis_intf: intf_name
    :param isis_intf: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.interface_detail.isis_intf', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'isis_intf', 'keyval': 'intf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'v6circuit-enabled'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_ipv4_routes_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.ipv4_routes', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_ipv4_routes_ipv4_route_entry_delete(self, ipv4_route_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ipv4_route_entry: ipv4_dest_addr, ipv4_subnet_mask, ipv4_prefix_len
    :param ipv4_route_entry: Keyword argument tuple.

    :type ipv4_dest_addr: unicode
    :param ipv4_dest_addr: **ipv4_route_entry** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv4_subnet_mask: unicode
    :param ipv4_subnet_mask: **ipv4_route_entry** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv4_prefix_len: int
    :param ipv4_prefix_len: **ipv4_route_entry** tuple argument.

        * range restriction: ::

            ['-128..127']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.ipv4_routes.ipv4_route_entry', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ipv4_route_entry', 'keyval': 'ipv4_dest_addr, ipv4_subnet_mask, ipv4_prefix_len', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ipv4_route_entry=ipv4_route_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ipv4_route_entry=ipv4_route_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_ipv4_routes_ipv4_route_entry_cost_delete(self, ipv4_route_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ipv4_route_entry: ipv4_dest_addr, ipv4_subnet_mask, ipv4_prefix_len
    :param ipv4_route_entry: Keyword argument tuple.

    :type ipv4_dest_addr: unicode
    :param ipv4_dest_addr: **ipv4_route_entry** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv4_subnet_mask: unicode
    :param ipv4_subnet_mask: **ipv4_route_entry** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv4_prefix_len: int
    :param ipv4_prefix_len: **ipv4_route_entry** tuple argument.

        * range restriction: ::

            ['-128..127']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.ipv4_routes.ipv4_route_entry', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ipv4_route_entry', 'keyval': 'ipv4_dest_addr, ipv4_subnet_mask, ipv4_prefix_len', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cost'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ipv4_route_entry=ipv4_route_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ipv4_route_entry=ipv4_route_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_ipv4_routes_ipv4_route_entry_flags_delete(self, ipv4_route_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ipv4_route_entry: ipv4_dest_addr, ipv4_subnet_mask, ipv4_prefix_len
    :param ipv4_route_entry: Keyword argument tuple.

    :type ipv4_dest_addr: unicode
    :param ipv4_dest_addr: **ipv4_route_entry** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv4_subnet_mask: unicode
    :param ipv4_subnet_mask: **ipv4_route_entry** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv4_prefix_len: int
    :param ipv4_prefix_len: **ipv4_route_entry** tuple argument.

        * range restriction: ::

            ['-128..127']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.ipv4_routes.ipv4_route_entry', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ipv4_route_entry', 'keyval': 'ipv4_dest_addr, ipv4_subnet_mask, ipv4_prefix_len', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'flags'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ipv4_route_entry=ipv4_route_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ipv4_route_entry=ipv4_route_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_ipv4_routes_ipv4_route_entry_is_l1_summarized_delete(self, ipv4_route_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ipv4_route_entry: ipv4_dest_addr, ipv4_subnet_mask, ipv4_prefix_len
    :param ipv4_route_entry: Keyword argument tuple.

    :type ipv4_dest_addr: unicode
    :param ipv4_dest_addr: **ipv4_route_entry** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv4_subnet_mask: unicode
    :param ipv4_subnet_mask: **ipv4_route_entry** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv4_prefix_len: int
    :param ipv4_prefix_len: **ipv4_route_entry** tuple argument.

        * range restriction: ::

            ['-128..127']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.ipv4_routes.ipv4_route_entry', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ipv4_route_entry', 'keyval': 'ipv4_dest_addr, ipv4_subnet_mask, ipv4_prefix_len', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'is-l1-summarized'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ipv4_route_entry=ipv4_route_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ipv4_route_entry=ipv4_route_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_ipv4_routes_ipv4_route_entry_is_l2_summarized_delete(self, ipv4_route_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ipv4_route_entry: ipv4_dest_addr, ipv4_subnet_mask, ipv4_prefix_len
    :param ipv4_route_entry: Keyword argument tuple.

    :type ipv4_dest_addr: unicode
    :param ipv4_dest_addr: **ipv4_route_entry** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv4_subnet_mask: unicode
    :param ipv4_subnet_mask: **ipv4_route_entry** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv4_prefix_len: int
    :param ipv4_prefix_len: **ipv4_route_entry** tuple argument.

        * range restriction: ::

            ['-128..127']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.ipv4_routes.ipv4_route_entry', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ipv4_route_entry', 'keyval': 'ipv4_dest_addr, ipv4_subnet_mask, ipv4_prefix_len', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'is-l2-summarized'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ipv4_route_entry=ipv4_route_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ipv4_route_entry=ipv4_route_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_ipv4_routes_ipv4_route_entry_is_summary_delete(self, ipv4_route_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ipv4_route_entry: ipv4_dest_addr, ipv4_subnet_mask, ipv4_prefix_len
    :param ipv4_route_entry: Keyword argument tuple.

    :type ipv4_dest_addr: unicode
    :param ipv4_dest_addr: **ipv4_route_entry** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv4_subnet_mask: unicode
    :param ipv4_subnet_mask: **ipv4_route_entry** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv4_prefix_len: int
    :param ipv4_prefix_len: **ipv4_route_entry** tuple argument.

        * range restriction: ::

            ['-128..127']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.ipv4_routes.ipv4_route_entry', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ipv4_route_entry', 'keyval': 'ipv4_dest_addr, ipv4_subnet_mask, ipv4_prefix_len', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'is-summary'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ipv4_route_entry=ipv4_route_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ipv4_route_entry=ipv4_route_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_ipv4_routes_ipv4_route_entry_level_delete(self, ipv4_route_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ipv4_route_entry: ipv4_dest_addr, ipv4_subnet_mask, ipv4_prefix_len
    :param ipv4_route_entry: Keyword argument tuple.

    :type ipv4_dest_addr: unicode
    :param ipv4_dest_addr: **ipv4_route_entry** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv4_subnet_mask: unicode
    :param ipv4_subnet_mask: **ipv4_route_entry** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv4_prefix_len: int
    :param ipv4_prefix_len: **ipv4_route_entry** tuple argument.

        * range restriction: ::

            ['-128..127']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.ipv4_routes.ipv4_route_entry', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ipv4_route_entry', 'keyval': 'ipv4_dest_addr, ipv4_subnet_mask, ipv4_prefix_len', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'level'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ipv4_route_entry=ipv4_route_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ipv4_route_entry=ipv4_route_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_ipv4_routes_ipv4_route_entry_nh_info_delete(self, ipv4_route_entry=None, nh_info=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ipv4_route_entry: ipv4_dest_addr, ipv4_subnet_mask, ipv4_prefix_len
    :param ipv4_route_entry: Keyword argument tuple.

    :type ipv4_dest_addr: unicode
    :param ipv4_dest_addr: **ipv4_route_entry** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv4_subnet_mask: unicode
    :param ipv4_subnet_mask: **ipv4_route_entry** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv4_prefix_len: int
    :param ipv4_prefix_len: **ipv4_route_entry** tuple argument.

        * range restriction: ::

            ['-128..127']

    **Instance Keyword Argument Tuple**:

    :type nh_info: outgoing_intf_name
    :param nh_info: Keyword argument tuple.

    :type outgoing_intf_name: unicode
    :param outgoing_intf_name: **nh_info** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.isis_state.ipv4_routes.ipv4_route_entry', u'ipv4_route_entry')]
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.ipv4_routes.ipv4_route_entry.nh_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ipv4_dest_addr, ipv4_subnet_mask, ipv4_prefix_len', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'nh_info', 'keyval': 'outgoing_intf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ipv4_route_entry=ipv4_route_entry, nh_info=nh_info)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ipv4_route_entry=ipv4_route_entry, nh_info=nh_info)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_ipv4_routes_ipv4_route_entry_nh_info_ipv4_nh_addr_delete(self, ipv4_route_entry=None, nh_info=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ipv4_route_entry: ipv4_dest_addr, ipv4_subnet_mask, ipv4_prefix_len
    :param ipv4_route_entry: Keyword argument tuple.

    :type ipv4_dest_addr: unicode
    :param ipv4_dest_addr: **ipv4_route_entry** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv4_subnet_mask: unicode
    :param ipv4_subnet_mask: **ipv4_route_entry** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv4_prefix_len: int
    :param ipv4_prefix_len: **ipv4_route_entry** tuple argument.

        * range restriction: ::

            ['-128..127']

    **Instance Keyword Argument Tuple**:

    :type nh_info: outgoing_intf_name
    :param nh_info: Keyword argument tuple.

    :type outgoing_intf_name: unicode
    :param outgoing_intf_name: **nh_info** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.isis_state.ipv4_routes.ipv4_route_entry', u'ipv4_route_entry')]
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.ipv4_routes.ipv4_route_entry.nh_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ipv4_dest_addr, ipv4_subnet_mask, ipv4_prefix_len', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'nh_info', 'keyval': 'outgoing_intf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ipv4-nh-addr'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ipv4_route_entry=ipv4_route_entry, nh_info=nh_info)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ipv4_route_entry=ipv4_route_entry, nh_info=nh_info)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_ipv4_routes_ipv4_route_entry_nh_info_is_mpls_tunnel_port_delete(self, ipv4_route_entry=None, nh_info=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ipv4_route_entry: ipv4_dest_addr, ipv4_subnet_mask, ipv4_prefix_len
    :param ipv4_route_entry: Keyword argument tuple.

    :type ipv4_dest_addr: unicode
    :param ipv4_dest_addr: **ipv4_route_entry** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv4_subnet_mask: unicode
    :param ipv4_subnet_mask: **ipv4_route_entry** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv4_prefix_len: int
    :param ipv4_prefix_len: **ipv4_route_entry** tuple argument.

        * range restriction: ::

            ['-128..127']

    **Instance Keyword Argument Tuple**:

    :type nh_info: outgoing_intf_name
    :param nh_info: Keyword argument tuple.

    :type outgoing_intf_name: unicode
    :param outgoing_intf_name: **nh_info** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.isis_state.ipv4_routes.ipv4_route_entry', u'ipv4_route_entry')]
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.ipv4_routes.ipv4_route_entry.nh_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ipv4_dest_addr, ipv4_subnet_mask, ipv4_prefix_len', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'nh_info', 'keyval': 'outgoing_intf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'is-mpls-tunnel-port'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ipv4_route_entry=ipv4_route_entry, nh_info=nh_info)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ipv4_route_entry=ipv4_route_entry, nh_info=nh_info)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_ipv4_routes_ipv4_route_entry_nh_info_lsp_info_delete(self, ipv4_route_entry=None, nh_info=None, lsp_info=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ipv4_route_entry: ipv4_dest_addr, ipv4_subnet_mask, ipv4_prefix_len
    :param ipv4_route_entry: Keyword argument tuple.

    :type ipv4_dest_addr: unicode
    :param ipv4_dest_addr: **ipv4_route_entry** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv4_subnet_mask: unicode
    :param ipv4_subnet_mask: **ipv4_route_entry** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv4_prefix_len: int
    :param ipv4_prefix_len: **ipv4_route_entry** tuple argument.

        * range restriction: ::

            ['-128..127']

    :type nh_info: outgoing_intf_name
    :param nh_info: Keyword argument tuple.

    :type outgoing_intf_name: unicode
    :param outgoing_intf_name: **nh_info** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type lsp_info: lsp_name
    :param lsp_info: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp_info** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.isis_state.ipv4_routes.ipv4_route_entry', u'ipv4_route_entry'), ('pybind.slxos.v16r_1_00b.isis_state.ipv4_routes.ipv4_route_entry.nh_info', u'nh_info')]
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.ipv4_routes.ipv4_route_entry.nh_info.lsp_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ipv4_dest_addr, ipv4_subnet_mask, ipv4_prefix_len', 'extra_keyval': ''}, {'keyval': 'outgoing_intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'lsp_info', 'keyval': 'lsp_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ipv4_route_entry=ipv4_route_entry, nh_info=nh_info, lsp_info=lsp_info)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ipv4_route_entry=ipv4_route_entry, nh_info=nh_info, lsp_info=lsp_info)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_ipv4_routes_ipv4_route_entry_tag_delete(self, ipv4_route_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ipv4_route_entry: ipv4_dest_addr, ipv4_subnet_mask, ipv4_prefix_len
    :param ipv4_route_entry: Keyword argument tuple.

    :type ipv4_dest_addr: unicode
    :param ipv4_dest_addr: **ipv4_route_entry** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv4_subnet_mask: unicode
    :param ipv4_subnet_mask: **ipv4_route_entry** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv4_prefix_len: int
    :param ipv4_prefix_len: **ipv4_route_entry** tuple argument.

        * range restriction: ::

            ['-128..127']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.ipv4_routes.ipv4_route_entry', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ipv4_route_entry', 'keyval': 'ipv4_dest_addr, ipv4_subnet_mask, ipv4_prefix_len', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ipv4_route_entry=ipv4_route_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ipv4_route_entry=ipv4_route_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_ipv4_routes_total_routes_count_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.ipv4_routes', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'total-routes-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_ipv6_routes_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.ipv6_routes', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_ipv6_routes_ecmp_route_count_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.ipv6_routes', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ecmp-route-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_ipv6_routes_ipv6_route_entry_delete(self, ipv6_route_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ipv6_route_entry: ipv6_dest_addr, ipv6_prefix_len
    :param ipv6_route_entry: Keyword argument tuple.

    :type ipv6_dest_addr: unicode
    :param ipv6_dest_addr: **ipv6_route_entry** tuple argument.

    :type ipv6_prefix_len: int
    :param ipv6_prefix_len: **ipv6_route_entry** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.ipv6_routes.ipv6_route_entry', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ipv6_route_entry', 'keyval': 'ipv6_dest_addr, ipv6_prefix_len', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ipv6_route_entry=ipv6_route_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ipv6_route_entry=ipv6_route_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_ipv6_routes_ipv6_route_entry_cost_delete(self, ipv6_route_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ipv6_route_entry: ipv6_dest_addr, ipv6_prefix_len
    :param ipv6_route_entry: Keyword argument tuple.

    :type ipv6_dest_addr: unicode
    :param ipv6_dest_addr: **ipv6_route_entry** tuple argument.

    :type ipv6_prefix_len: int
    :param ipv6_prefix_len: **ipv6_route_entry** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.ipv6_routes.ipv6_route_entry', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ipv6_route_entry', 'keyval': 'ipv6_dest_addr, ipv6_prefix_len', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cost'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ipv6_route_entry=ipv6_route_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ipv6_route_entry=ipv6_route_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_ipv6_routes_ipv6_route_entry_flags_delete(self, ipv6_route_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ipv6_route_entry: ipv6_dest_addr, ipv6_prefix_len
    :param ipv6_route_entry: Keyword argument tuple.

    :type ipv6_dest_addr: unicode
    :param ipv6_dest_addr: **ipv6_route_entry** tuple argument.

    :type ipv6_prefix_len: int
    :param ipv6_prefix_len: **ipv6_route_entry** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.ipv6_routes.ipv6_route_entry', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ipv6_route_entry', 'keyval': 'ipv6_dest_addr, ipv6_prefix_len', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'flags'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ipv6_route_entry=ipv6_route_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ipv6_route_entry=ipv6_route_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_ipv6_routes_ipv6_route_entry_is_l1_summarized_delete(self, ipv6_route_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ipv6_route_entry: ipv6_dest_addr, ipv6_prefix_len
    :param ipv6_route_entry: Keyword argument tuple.

    :type ipv6_dest_addr: unicode
    :param ipv6_dest_addr: **ipv6_route_entry** tuple argument.

    :type ipv6_prefix_len: int
    :param ipv6_prefix_len: **ipv6_route_entry** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.ipv6_routes.ipv6_route_entry', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ipv6_route_entry', 'keyval': 'ipv6_dest_addr, ipv6_prefix_len', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'is-l1-summarized'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ipv6_route_entry=ipv6_route_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ipv6_route_entry=ipv6_route_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_ipv6_routes_ipv6_route_entry_is_l2_summarized_delete(self, ipv6_route_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ipv6_route_entry: ipv6_dest_addr, ipv6_prefix_len
    :param ipv6_route_entry: Keyword argument tuple.

    :type ipv6_dest_addr: unicode
    :param ipv6_dest_addr: **ipv6_route_entry** tuple argument.

    :type ipv6_prefix_len: int
    :param ipv6_prefix_len: **ipv6_route_entry** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.ipv6_routes.ipv6_route_entry', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ipv6_route_entry', 'keyval': 'ipv6_dest_addr, ipv6_prefix_len', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'is-l2-summarized'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ipv6_route_entry=ipv6_route_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ipv6_route_entry=ipv6_route_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_ipv6_routes_ipv6_route_entry_is_summary_delete(self, ipv6_route_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ipv6_route_entry: ipv6_dest_addr, ipv6_prefix_len
    :param ipv6_route_entry: Keyword argument tuple.

    :type ipv6_dest_addr: unicode
    :param ipv6_dest_addr: **ipv6_route_entry** tuple argument.

    :type ipv6_prefix_len: int
    :param ipv6_prefix_len: **ipv6_route_entry** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.ipv6_routes.ipv6_route_entry', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ipv6_route_entry', 'keyval': 'ipv6_dest_addr, ipv6_prefix_len', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'is-summary'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ipv6_route_entry=ipv6_route_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ipv6_route_entry=ipv6_route_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_ipv6_routes_ipv6_route_entry_level_delete(self, ipv6_route_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ipv6_route_entry: ipv6_dest_addr, ipv6_prefix_len
    :param ipv6_route_entry: Keyword argument tuple.

    :type ipv6_dest_addr: unicode
    :param ipv6_dest_addr: **ipv6_route_entry** tuple argument.

    :type ipv6_prefix_len: int
    :param ipv6_prefix_len: **ipv6_route_entry** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.ipv6_routes.ipv6_route_entry', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ipv6_route_entry', 'keyval': 'ipv6_dest_addr, ipv6_prefix_len', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'level'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ipv6_route_entry=ipv6_route_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ipv6_route_entry=ipv6_route_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_ipv6_routes_ipv6_route_entry_nh_info_delete(self, ipv6_route_entry=None, nh_info=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ipv6_route_entry: ipv6_dest_addr, ipv6_prefix_len
    :param ipv6_route_entry: Keyword argument tuple.

    :type ipv6_dest_addr: unicode
    :param ipv6_dest_addr: **ipv6_route_entry** tuple argument.

    :type ipv6_prefix_len: int
    :param ipv6_prefix_len: **ipv6_route_entry** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type nh_info: outgoing_intf_name
    :param nh_info: Keyword argument tuple.

    :type outgoing_intf_name: unicode
    :param outgoing_intf_name: **nh_info** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.isis_state.ipv6_routes.ipv6_route_entry', u'ipv6_route_entry')]
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.ipv6_routes.ipv6_route_entry.nh_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ipv6_dest_addr, ipv6_prefix_len', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'nh_info', 'keyval': 'outgoing_intf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ipv6_route_entry=ipv6_route_entry, nh_info=nh_info)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ipv6_route_entry=ipv6_route_entry, nh_info=nh_info)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_ipv6_routes_ipv6_route_entry_nh_info_ipv6_nh_addr_delete(self, ipv6_route_entry=None, nh_info=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ipv6_route_entry: ipv6_dest_addr, ipv6_prefix_len
    :param ipv6_route_entry: Keyword argument tuple.

    :type ipv6_dest_addr: unicode
    :param ipv6_dest_addr: **ipv6_route_entry** tuple argument.

    :type ipv6_prefix_len: int
    :param ipv6_prefix_len: **ipv6_route_entry** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type nh_info: outgoing_intf_name
    :param nh_info: Keyword argument tuple.

    :type outgoing_intf_name: unicode
    :param outgoing_intf_name: **nh_info** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.isis_state.ipv6_routes.ipv6_route_entry', u'ipv6_route_entry')]
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.ipv6_routes.ipv6_route_entry.nh_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ipv6_dest_addr, ipv6_prefix_len', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'nh_info', 'keyval': 'outgoing_intf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ipv6-nh-addr'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ipv6_route_entry=ipv6_route_entry, nh_info=nh_info)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ipv6_route_entry=ipv6_route_entry, nh_info=nh_info)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_ipv6_routes_ipv6_route_entry_tag_delete(self, ipv6_route_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ipv6_route_entry: ipv6_dest_addr, ipv6_prefix_len
    :param ipv6_route_entry: Keyword argument tuple.

    :type ipv6_dest_addr: unicode
    :param ipv6_dest_addr: **ipv6_route_entry** tuple argument.

    :type ipv6_prefix_len: int
    :param ipv6_prefix_len: **ipv6_route_entry** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.ipv6_routes.ipv6_route_entry', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ipv6_route_entry', 'keyval': 'ipv6_dest_addr, ipv6_prefix_len', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ipv6_route_entry=ipv6_route_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ipv6_route_entry=ipv6_route_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_ipv6_routes_level1_route_count_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.ipv6_routes', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'level1-route-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_ipv6_routes_level2_route_count_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.ipv6_routes', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'level2-route-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_csnp_interval_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'csnp-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_debug_handler_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.debug_handler', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_debug_handler_debug_nsr_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.debug_handler', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'debug-nsr'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_enable_code_assertions_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable-code-assertions'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_fast_flood_wait_count_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'fast-flood-wait-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_graceful_restart_helper_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'graceful-restart-helper'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_hello_padding_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hello-padding'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_hello_padding_ptp_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hello-padding-ptp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.is_address_family_v4', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_administrative_distance_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.is_address_family_v4', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'administrative-distance'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_afi_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.is_address_family_v4', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'afi'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_default_metric_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.is_address_family_v4', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'default-metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_l1_default_link_metric_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.is_address_family_v4', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'l1-default-link-metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_l1_wide_metric_enabled_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.is_address_family_v4', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'l1-wide-metric-enabled'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_l2_default_link_metric_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.is_address_family_v4', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'l2-default-link-metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_l2_wide_metric_enabled_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.is_address_family_v4', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'l2-wide-metric-enabled'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_ldp_sync_enabled_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.is_address_family_v4', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ldp-sync-enabled'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_ldp_sync_hold_down_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.is_address_family_v4', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ldp-sync-hold-down'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_maximum_equal_cost_paths_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.is_address_family_v4', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'maximum-equal-cost-paths'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_originate_default_route_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.is_address_family_v4', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'originate-default-route'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_originate_default_routemap_name_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.is_address_family_v4', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'originate-default-routemap-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_redist_bgp_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.is_address_family_v4.redist_bgp', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_redist_bgp_redist_enabled_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.is_address_family_v4.redist_bgp', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redist-enabled'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_redist_bgp_redist_level_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.is_address_family_v4.redist_bgp', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redist-level'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_redist_bgp_redist_metric_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.is_address_family_v4.redist_bgp', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redist-metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_redist_bgp_redist_metric_type_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.is_address_family_v4.redist_bgp', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redist-metric-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_redist_bgp_redist_routemap_name_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.is_address_family_v4.redist_bgp', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redist-routemap-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_redist_connected_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.is_address_family_v4.redist_connected', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_redist_connected_redist_enabled_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.is_address_family_v4.redist_connected', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redist-enabled'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_redist_connected_redist_level_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.is_address_family_v4.redist_connected', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redist-level'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_redist_connected_redist_metric_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.is_address_family_v4.redist_connected', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redist-metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_redist_connected_redist_metric_type_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.is_address_family_v4.redist_connected', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redist-metric-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_redist_connected_redist_routemap_name_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.is_address_family_v4.redist_connected', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redist-routemap-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_redist_isis_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.is_address_family_v4.redist_isis', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_redist_isis_redist_is_l1_to_l2_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.is_address_family_v4.redist_isis', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redist-is-l1-to-l2'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_redist_isis_redist_is_l1_to_l2_prefix_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.is_address_family_v4.redist_isis', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redist-is-l1-to-l2-prefix'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_redist_isis_redist_is_l2_to_l1_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.is_address_family_v4.redist_isis', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redist-is-l2-to-l1'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_redist_isis_redist_is_l2_to_l1_prefix_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.is_address_family_v4.redist_isis', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redist-is-l2-to-l1-prefix'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_redist_ospf_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.is_address_family_v4.redist_ospf', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_redist_ospf_ospf_external1_enabled_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.is_address_family_v4.redist_ospf', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ospf-external1-enabled'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_redist_ospf_ospf_external2_enabled_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.is_address_family_v4.redist_ospf', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ospf-external2-enabled'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_redist_ospf_ospf_internal_enabled_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.is_address_family_v4.redist_ospf', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ospf-internal-enabled'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_redist_ospf_redist_enabled_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.is_address_family_v4.redist_ospf', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redist-enabled'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_redist_ospf_redist_level_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.is_address_family_v4.redist_ospf', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redist-level'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_redist_ospf_redist_metric_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.is_address_family_v4.redist_ospf', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redist-metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_redist_ospf_redist_metric_type_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.is_address_family_v4.redist_ospf', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redist-metric-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_redist_ospf_redist_routemap_name_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.is_address_family_v4.redist_ospf', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redist-routemap-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_redist_rip_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.is_address_family_v4.redist_rip', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_redist_rip_redist_enabled_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.is_address_family_v4.redist_rip', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redist-enabled'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_redist_rip_redist_level_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.is_address_family_v4.redist_rip', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redist-level'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_redist_rip_redist_metric_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.is_address_family_v4.redist_rip', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redist-metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_redist_rip_redist_metric_type_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.is_address_family_v4.redist_rip', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redist-metric-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_redist_rip_redist_routemap_name_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.is_address_family_v4.redist_rip', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redist-routemap-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_redist_static_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.is_address_family_v4.redist_static', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_redist_static_redist_enabled_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.is_address_family_v4.redist_static', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redist-enabled'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_redist_static_redist_level_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.is_address_family_v4.redist_static', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redist-level'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_redist_static_redist_metric_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.is_address_family_v4.redist_static', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redist-metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_redist_static_redist_metric_type_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.is_address_family_v4.redist_static', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redist-metric-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_redist_static_redist_routemap_name_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.is_address_family_v4.redist_static', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redist-routemap-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_safi_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.is_address_family_v4', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'safi'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_summary_address_v4_delete(self, summary_address_v4=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type summary_address_v4: address
    :param summary_address_v4: Keyword argument tuple.

    :type address: unicode
    :param address: **summary_address_v4** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.is_address_family_v4.summary_address_v4', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'summary_address_v4', 'keyval': 'address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, summary_address_v4=summary_address_v4)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, summary_address_v4=summary_address_v4)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_summary_address_v4_ipv4_mask_delete(self, summary_address_v4=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type summary_address_v4: address
    :param summary_address_v4: Keyword argument tuple.

    :type address: unicode
    :param address: **summary_address_v4** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.is_address_family_v4.summary_address_v4', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'summary_address_v4', 'keyval': 'address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ipv4-mask'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, summary_address_v4=summary_address_v4)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, summary_address_v4=summary_address_v4)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_summary_address_v4_level_delete(self, summary_address_v4=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type summary_address_v4: address
    :param summary_address_v4: Keyword argument tuple.

    :type address: unicode
    :param address: **summary_address_v4** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.is_address_family_v4.summary_address_v4', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'summary_address_v4', 'keyval': 'address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'level'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, summary_address_v4=summary_address_v4)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, summary_address_v4=summary_address_v4)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v6_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.is_address_family_v6', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v6_adjacency_check_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.is_address_family_v6', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'adjacency-check'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v6_administrative_distance_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.is_address_family_v6', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'administrative-distance'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v6_afi_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.is_address_family_v6', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'afi'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v6_default_metric_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.is_address_family_v6', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'default-metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v6_l1_default_link_metric_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.is_address_family_v6', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'l1-default-link-metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v6_l2_default_link_metric_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.is_address_family_v6', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'l2-default-link-metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v6_maximum_equal_cost_paths_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.is_address_family_v6', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'maximum-equal-cost-paths'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v6_mt_transition_state_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.is_address_family_v6', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mt-transition-state'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v6_multi_topology_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.is_address_family_v6', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'multi-topology'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v6_originate_default_route_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.is_address_family_v6', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'originate-default-route'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v6_originate_default_routemap_name_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.is_address_family_v6', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'originate-default-routemap-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v6_redist_bgp_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.is_address_family_v6.redist_bgp', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v6_redist_bgp_redist_enabled_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.is_address_family_v6.redist_bgp', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redist-enabled'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v6_redist_bgp_redist_level_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.is_address_family_v6.redist_bgp', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redist-level'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v6_redist_bgp_redist_metric_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.is_address_family_v6.redist_bgp', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redist-metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v6_redist_bgp_redist_metric_type_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.is_address_family_v6.redist_bgp', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redist-metric-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v6_redist_bgp_redist_routemap_name_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.is_address_family_v6.redist_bgp', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redist-routemap-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v6_redist_connected_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.is_address_family_v6.redist_connected', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v6_redist_connected_redist_enabled_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.is_address_family_v6.redist_connected', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redist-enabled'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v6_redist_connected_redist_level_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.is_address_family_v6.redist_connected', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redist-level'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v6_redist_connected_redist_metric_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.is_address_family_v6.redist_connected', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redist-metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v6_redist_connected_redist_metric_type_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.is_address_family_v6.redist_connected', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redist-metric-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v6_redist_connected_redist_routemap_name_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.is_address_family_v6.redist_connected', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redist-routemap-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v6_redist_isis_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.is_address_family_v6.redist_isis', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v6_redist_isis_redist_is_l1_to_l2_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.is_address_family_v6.redist_isis', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redist-is-l1-to-l2'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v6_redist_isis_redist_is_l1_to_l2_prefix_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.is_address_family_v6.redist_isis', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redist-is-l1-to-l2-prefix'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v6_redist_isis_redist_is_l2_to_l1_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.is_address_family_v6.redist_isis', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redist-is-l2-to-l1'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v6_redist_isis_redist_is_l2_to_l1_prefix_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.is_address_family_v6.redist_isis', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redist-is-l2-to-l1-prefix'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v6_redist_ospf_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.is_address_family_v6.redist_ospf', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v6_redist_ospf_ospf_external1_enabled_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.is_address_family_v6.redist_ospf', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ospf-external1-enabled'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v6_redist_ospf_ospf_external2_enabled_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.is_address_family_v6.redist_ospf', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ospf-external2-enabled'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v6_redist_ospf_ospf_internal_enabled_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.is_address_family_v6.redist_ospf', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ospf-internal-enabled'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v6_redist_ospf_redist_enabled_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.is_address_family_v6.redist_ospf', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redist-enabled'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v6_redist_ospf_redist_level_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.is_address_family_v6.redist_ospf', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redist-level'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v6_redist_ospf_redist_metric_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.is_address_family_v6.redist_ospf', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redist-metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v6_redist_ospf_redist_metric_type_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.is_address_family_v6.redist_ospf', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redist-metric-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v6_redist_ospf_redist_routemap_name_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.is_address_family_v6.redist_ospf', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redist-routemap-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v6_redist_rip_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.is_address_family_v6.redist_rip', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v6_redist_rip_redist_enabled_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.is_address_family_v6.redist_rip', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redist-enabled'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v6_redist_rip_redist_level_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.is_address_family_v6.redist_rip', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redist-level'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v6_redist_rip_redist_metric_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.is_address_family_v6.redist_rip', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redist-metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v6_redist_rip_redist_metric_type_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.is_address_family_v6.redist_rip', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redist-metric-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v6_redist_rip_redist_routemap_name_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.is_address_family_v6.redist_rip', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redist-routemap-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v6_redist_static_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.is_address_family_v6.redist_static', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v6_redist_static_redist_enabled_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.is_address_family_v6.redist_static', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redist-enabled'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v6_redist_static_redist_level_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.is_address_family_v6.redist_static', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redist-level'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v6_redist_static_redist_metric_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.is_address_family_v6.redist_static', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redist-metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v6_redist_static_redist_metric_type_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.is_address_family_v6.redist_static', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redist-metric-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v6_redist_static_redist_routemap_name_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.is_address_family_v6.redist_static', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redist-routemap-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v6_safi_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.is_address_family_v6', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'safi'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v6_summary_prefix_v6_delete(self, summary_prefix_v6=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type summary_prefix_v6: address
    :param summary_prefix_v6: Keyword argument tuple.

    :type address: unicode
    :param address: **summary_prefix_v6** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.is_address_family_v6.summary_prefix_v6', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'summary_prefix_v6', 'keyval': 'address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, summary_prefix_v6=summary_prefix_v6)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, summary_prefix_v6=summary_prefix_v6)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v6_summary_prefix_v6_level_delete(self, summary_prefix_v6=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type summary_prefix_v6: address
    :param summary_prefix_v6: Keyword argument tuple.

    :type address: unicode
    :param address: **summary_prefix_v6** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.is_address_family_v6.summary_prefix_v6', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'summary_prefix_v6', 'keyval': 'address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'level'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, summary_prefix_v6=summary_prefix_v6)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, summary_prefix_v6=summary_prefix_v6)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_isis_hostname_enabled_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'isis-hostname-enabled'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_isis_system_info_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.isis_system_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_isis_system_info_nsap_delete(self, nsap=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type nsap: net_addr
    :param nsap: Keyword argument tuple.

    :type net_addr: unicode
    :param net_addr: **nsap** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.isis_system_info.nsap', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'nsap', 'keyval': 'net_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, nsap=nsap)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, nsap=nsap)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_isis_system_info_nsap_length_delete(self, nsap=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type nsap: net_addr
    :param nsap: Keyword argument tuple.

    :type net_addr: unicode
    :param net_addr: **nsap** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.isis_system_info.nsap', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'nsap', 'keyval': 'net_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'length'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, nsap=nsap)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, nsap=nsap)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_isis_system_info_operation_mode_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.isis_system_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'operation-mode'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_isis_system_info_protocol_enabled_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.isis_system_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'protocol-enabled'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_isis_system_info_system_id_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.isis_system_info', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'system-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_ispf_enabled_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ispf-enabled'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_istct_spf_enabled_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'istct-spf-enabled'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_l1_auth_profile_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.l1_auth_profile', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_l1_auth_profile_auth_check_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.l1_auth_profile', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'auth-check'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_l1_auth_profile_auth_key_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.l1_auth_profile', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'auth-key'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_l1_auth_profile_auth_mode_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.l1_auth_profile', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'auth-mode'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_l1_spf6_timer_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.l1_spf6_timer', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_l1_spf6_timer_hold_down_time_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.l1_spf6_timer', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hold-down-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_l1_spf6_timer_init_delay_time_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.l1_spf6_timer', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'init-delay-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_l1_spf6_timer_max_time_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.l1_spf6_timer', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'max-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_l1_spf_timer_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.l1_spf_timer', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_l1_spf_timer_hold_down_time_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.l1_spf_timer', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hold-down-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_l1_spf_timer_init_delay_time_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.l1_spf_timer', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'init-delay-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_l1_spf_timer_max_time_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.l1_spf_timer', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'max-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_l2_auth_profile_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.l2_auth_profile', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_l2_auth_profile_auth_check_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.l2_auth_profile', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'auth-check'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_l2_auth_profile_auth_key_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.l2_auth_profile', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'auth-key'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_l2_auth_profile_auth_mode_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.l2_auth_profile', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'auth-mode'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_l2_spf6_timer_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.l2_spf6_timer', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_l2_spf6_timer_hold_down_time_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.l2_spf6_timer', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hold-down-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_l2_spf6_timer_init_delay_time_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.l2_spf6_timer', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'init-delay-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_l2_spf6_timer_max_time_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.l2_spf6_timer', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'max-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_l2_spf_timer_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.l2_spf_timer', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_l2_spf_timer_hold_down_time_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.l2_spf_timer', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hold-down-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_l2_spf_timer_init_delay_time_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.l2_spf_timer', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'init-delay-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_l2_spf_timer_max_time_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.l2_spf_timer', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'max-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_log_handler_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.log_handler', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_log_handler_log_adj_state_change_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.log_handler', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'log-adj-state-change'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_log_handler_log_bad_lsp_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.log_handler', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'log-bad-lsp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_lsp_fast_flood_count_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lsp-fast-flood-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_lsp_flood_count_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lsp-flood-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_lsp_gen_interval_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lsp-gen-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_lsp_interval_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lsp-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_lsp_lifetime_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lsp-lifetime'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_lsp_refresh_interval_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lsp-refresh-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_nsr_state_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'nsr-state'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_overload_bgp_wait_time_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'overload-bgp-wait-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_overload_startup_time_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'overload-startup-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_overload_state_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'overload-state'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_overload_wait_on_bgp_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'overload-wait-on-bgp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_pspf6_timer_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.pspf6_timer', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_pspf6_timer_hold_down_time_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.pspf6_timer', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hold-down-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_pspf6_timer_init_delay_time_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.pspf6_timer', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'init-delay-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_pspf6_timer_max_time_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.pspf6_timer', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'max-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_pspf_enabled_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'pspf-enabled'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_pspf_timer_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.pspf_timer', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_pspf_timer_hold_down_time_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.pspf_timer', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hold-down-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_pspf_timer_init_delay_time_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.pspf_timer', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'init-delay-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_pspf_timer_max_time_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.pspf_timer', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'max-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_retransmit_interval_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'retransmit-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_reverse_metric_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.reverse_metric', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_reverse_metric_rev_metric_te_def_metric_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.reverse_metric', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rev-metric-te-def-metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_reverse_metric_rev_metric_tlv_type_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.reverse_metric', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rev-metric-tlv-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_reverse_metric_rev_metric_whole_lan_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.reverse_metric', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rev-metric-whole-lan'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isis_state_router_isis_config_reverse_metric_reverse_metric_value_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.isis_state.router_isis_config.reverse_metric', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'reverse-metric-value'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isns_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_1_0.isns', 'pybind.nos.v7_1_0.brocade_isns', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isns_vrf_forwarding_delete(self, isns_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    **Instance Keyword Argument Tuple**:

    :type isns_vrf: isns_vrf_instance
    :param isns_vrf: Keyword argument tuple.

    :type isns_vrf_instance: long
    :param isns_vrf_instance: **isns_vrf** tuple argument:  iSNS VRF forwarding value 1

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_1_0.isns.isns_vrf', 'pybind.nos.v7_1_0.brocade_isns', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'isns_vrf', 'keyval': 'isns_vrf_instance', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isns_vrf=isns_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isns_vrf=isns_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isns_vrf_forwarding_discovery_domain_delete(self, isns_vrf=None, isns_discovery_domain=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isns_vrf: isns_vrf_instance
    :param isns_vrf: Keyword argument tuple.

    :type isns_vrf_instance: long
    :param isns_vrf_instance: **isns_vrf** tuple argument:  iSNS VRF forwarding value 1

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type isns_discovery_domain: isns_discovery_domain_name
    :param isns_discovery_domain: Keyword argument tuple.

    :type isns_discovery_domain_name: unicode
    :param isns_discovery_domain_name: **isns_discovery_domain** tuple argument:  iSNS Discovery Domain Name (Max Size - 256)

        * length restriction: ::

            ['1..255']

        * pattern restriction: ::

            '[-_0-9a-zA-Z]{1,255}'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.isns.isns_vrf', u'isns_vrf')]
    bindings_list = [('pybind.nos.v7_1_0.isns.isns_vrf.isns_discovery_domain', 'pybind.nos.v7_1_0.brocade_isns', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'isns_vrf_instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'isns_discovery_domain', 'keyval': 'isns_discovery_domain_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isns_vrf=isns_vrf, isns_discovery_domain=isns_discovery_domain)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isns_vrf=isns_vrf, isns_discovery_domain=isns_discovery_domain)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isns_vrf_forwarding_discovery_domain_set_delete(self, isns_vrf=None, isns_discovery_domain_set=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isns_vrf: isns_vrf_instance
    :param isns_vrf: Keyword argument tuple.

    :type isns_vrf_instance: long
    :param isns_vrf_instance: **isns_vrf** tuple argument:  iSNS VRF forwarding value 1

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type isns_discovery_domain_set: isns_discovery_domain_set_name
    :param isns_discovery_domain_set: Keyword argument tuple.

    :type isns_discovery_domain_set_name: unicode
    :param isns_discovery_domain_set_name: **isns_discovery_domain_set** tuple argument:  iSNS Discovery Domain Set Name (Max Size - 256)

        * length restriction: ::

            ['1..255']

        * pattern restriction: ::

            '[-_0-9a-zA-Z]{1,255}'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.isns.isns_vrf', u'isns_vrf')]
    bindings_list = [('pybind.nos.v7_1_0.isns.isns_vrf.isns_discovery_domain_set', 'pybind.nos.v7_1_0.brocade_isns', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'isns_vrf_instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'isns_discovery_domain_set', 'keyval': 'isns_discovery_domain_set_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isns_vrf=isns_vrf, isns_discovery_domain_set=isns_discovery_domain_set)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isns_vrf=isns_vrf, isns_discovery_domain_set=isns_discovery_domain_set)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isns_vrf_forwarding_discovery_domain_set_enable_delete(self, isns_vrf=None, isns_discovery_domain_set=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isns_vrf: isns_vrf_instance
    :param isns_vrf: Keyword argument tuple.

    :type isns_vrf_instance: long
    :param isns_vrf_instance: **isns_vrf** tuple argument:  iSNS VRF forwarding value 1

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type isns_discovery_domain_set: isns_discovery_domain_set_name
    :param isns_discovery_domain_set: Keyword argument tuple.

    :type isns_discovery_domain_set_name: unicode
    :param isns_discovery_domain_set_name: **isns_discovery_domain_set** tuple argument:  iSNS Discovery Domain Set Name (Max Size - 256)

        * length restriction: ::

            ['1..255']

        * pattern restriction: ::

            '[-_0-9a-zA-Z]{1,255}'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.isns.isns_vrf', u'isns_vrf')]
    bindings_list = [('pybind.nos.v7_1_0.isns.isns_vrf.isns_discovery_domain_set', 'pybind.nos.v7_1_0.brocade_isns', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'isns_vrf_instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'isns_discovery_domain_set', 'keyval': 'isns_discovery_domain_set_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isns_vrf=isns_vrf, isns_discovery_domain_set=isns_discovery_domain_set)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isns_vrf=isns_vrf, isns_discovery_domain_set=isns_discovery_domain_set)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isns_vrf_forwarding_esi_timeout_delete(self, isns_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    **Instance Keyword Argument Tuple**:

    :type isns_vrf: isns_vrf_instance
    :param isns_vrf: Keyword argument tuple.

    :type isns_vrf_instance: long
    :param isns_vrf_instance: **isns_vrf** tuple argument:  iSNS VRF forwarding value 1

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_1_0.isns.isns_vrf', 'pybind.nos.v7_1_0.brocade_isns', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'isns_vrf', 'keyval': 'isns_vrf_instance', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'esi-timeout'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isns_vrf=isns_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isns_vrf=isns_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def isns_vrf_forwarding_isns_ipaddress_delete(self, isns_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    **Instance Keyword Argument Tuple**:

    :type isns_vrf: isns_vrf_instance
    :param isns_vrf: Keyword argument tuple.

    :type isns_vrf_instance: long
    :param isns_vrf_instance: **isns_vrf** tuple argument:  iSNS VRF forwarding value 1

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_1_0.isns.isns_vrf', 'pybind.nos.v7_1_0.brocade_isns', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'isns_vrf', 'keyval': 'isns_vrf_instance', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'isns-ipaddress'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isns_vrf=isns_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isns_vrf=isns_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def lacp_system_priority_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.lacp', 'pybind.nos.v6_0_2c.brocade_lacp', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.lacp', 'pybind.nos.v7_0_1b.brocade_lacp', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.lacp', 'pybind.nos.v7_1_0.brocade_lacp', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.lacp', 'pybind.slxos.v16r_1_00b.brocade_lacp', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'system-priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def lag_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.load_balance_lag.lag', 'pybind.slxos.v16r_1_00b.brocade_rbridge_lag', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def lag_hash_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.load_balance_lag.lag.hash', 'pybind.slxos.v16r_1_00b.brocade_rbridge_lag', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def lag_hash_bos_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.load_balance_lag.lag.hash.bos', 'pybind.slxos.v16r_1_00b.brocade_rbridge_lag', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'start_skip'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def lag_hash_bos_start_skip_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.load_balance_lag.lag.hash.bos', 'pybind.slxos.v16r_1_00b.brocade_rbridge_lag', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'start-skip'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def lag_hash_hdr_count_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.load_balance_lag.lag.hash', 'pybind.slxos.v16r_1_00b.brocade_rbridge_lag', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hdr-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def lag_hash_hdr_start_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.load_balance_lag.lag.hash.hdr_start', 'pybind.slxos.v16r_1_00b.brocade_rbridge_lag', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'fwd_term'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def lag_hash_hdr_start_fwd_term_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.load_balance_lag.lag.hash.hdr_start', 'pybind.slxos.v16r_1_00b.brocade_rbridge_lag', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'fwd-term'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def lag_hash_normalize_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.load_balance_lag.lag.hash', 'pybind.slxos.v16r_1_00b.brocade_rbridge_lag', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'normalize'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def lag_hash_pwctrlword_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.load_balance_lag.lag.hash', 'pybind.slxos.v16r_1_00b.brocade_rbridge_lag', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'pwctrlword'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def lag_hash_rotate_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.load_balance_lag.lag.hash', 'pybind.slxos.v16r_1_00b.brocade_rbridge_lag', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rotate'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def lag_hash_speculate_mpls_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.load_balance_lag.lag.hash.speculate_mpls', 'pybind.slxos.v16r_1_00b.brocade_rbridge_lag', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def lag_hash_speculate_mpls_enable_eth_ip_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.load_balance_lag.lag.hash.speculate_mpls', 'pybind.slxos.v16r_1_00b.brocade_rbridge_lag', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable-eth-ip'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def lag_hash_srcport_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.load_balance_lag.lag.hash', 'pybind.slxos.v16r_1_00b.brocade_rbridge_lag', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'srcport'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ldap_server_host_delete(self, host=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type host: hostname
    :param host: Keyword argument tuple.

    :type hostname: unicode
    :param hostname: **host** tuple argument:  INETADDRESS   Domain name or IP Address of this LDAP server

        * length restriction: ::

            ['1..max']

        * pattern restriction: ::

            '\p{IsBasicLatin}{0,255}'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.ldap_server.host', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ldap_server.host', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ldap_server.host', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ldap_server.host', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'host', 'keyval': 'hostname, use_vrf', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v7_0_1b.ldap_server.host": {}, "pybind.nos.v6_0_2c.ldap_server.host": {"retries": "retries", "hostname": "hostname", "basedn": "basedn", "port": "port", "timeout": "timeout"}, "pybind.slxos.v16r_1_00b.ldap_server.host": {}, "pybind.nos.v7_1_0.ldap_server.host": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, host=host)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, host=host)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ldap_server_host_basedn_delete(self, host=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type host: hostname
    :param host: Keyword argument tuple.

    :type hostname: unicode
    :param hostname: **host** tuple argument:  INETADDRESS   Domain name or IP Address of this LDAP server

        * length restriction: ::

            ['1..max']

        * pattern restriction: ::

            '\p{IsBasicLatin}{0,255}'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.ldap_server.host', u'host')]
    bindings_list = [('pybind.nos.v6_0_2c.ldap_server.host', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ldap_server.host', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ldap_server.host', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ldap_server.host.ldap_server_options', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'hostname, use_vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'host', 'keyval': 'hostname, use_vrf', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v7_0_1b.ldap_server.host": {}, "pybind.nos.v6_0_2c.ldap_server.host": {"basedn": "basedn", "hostname": "hostname"}, "pybind.slxos.v16r_1_00b.ldap_server.host.ldap_server_options": {}, "pybind.nos.v7_1_0.ldap_server.host": {}}
    rest_leaf_name = 'basedn'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, host=host)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, host=host)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ldap_server_host_port_delete(self, host=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type host: hostname
    :param host: Keyword argument tuple.

    :type hostname: unicode
    :param hostname: **host** tuple argument:  INETADDRESS   Domain name or IP Address of this LDAP server

        * length restriction: ::

            ['1..max']

        * pattern restriction: ::

            '\p{IsBasicLatin}{0,255}'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.ldap_server.host', u'host')]
    bindings_list = [('pybind.nos.v6_0_2c.ldap_server.host', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ldap_server.host', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ldap_server.host', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ldap_server.host.ldap_server_options', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'hostname, use_vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'host', 'keyval': 'hostname, use_vrf', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v7_0_1b.ldap_server.host": {}, "pybind.nos.v6_0_2c.ldap_server.host": {"hostname": "hostname", "port": "port"}, "pybind.slxos.v16r_1_00b.ldap_server.host.ldap_server_options": {}, "pybind.nos.v7_1_0.ldap_server.host": {}}
    rest_leaf_name = 'port'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, host=host)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, host=host)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ldap_server_host_retries_delete(self, host=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type host: hostname
    :param host: Keyword argument tuple.

    :type hostname: unicode
    :param hostname: **host** tuple argument:  INETADDRESS   Domain name or IP Address of this LDAP server

        * length restriction: ::

            ['1..max']

        * pattern restriction: ::

            '\p{IsBasicLatin}{0,255}'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.ldap_server.host', u'host')]
    bindings_list = [('pybind.nos.v6_0_2c.ldap_server.host', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ldap_server.host', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ldap_server.host', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ldap_server.host.ldap_server_options', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'hostname, use_vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'host', 'keyval': 'hostname, use_vrf', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v7_0_1b.ldap_server.host": {}, "pybind.nos.v6_0_2c.ldap_server.host": {"retries": "retries", "hostname": "hostname"}, "pybind.slxos.v16r_1_00b.ldap_server.host.ldap_server_options": {}, "pybind.nos.v7_1_0.ldap_server.host": {}}
    rest_leaf_name = 'retries'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, host=host)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, host=host)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ldap_server_host_timeout_delete(self, host=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type host: hostname
    :param host: Keyword argument tuple.

    :type hostname: unicode
    :param hostname: **host** tuple argument:  INETADDRESS   Domain name or IP Address of this LDAP server

        * length restriction: ::

            ['1..max']

        * pattern restriction: ::

            '\p{IsBasicLatin}{0,255}'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.ldap_server.host', u'host')]
    bindings_list = [('pybind.nos.v6_0_2c.ldap_server.host', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ldap_server.host', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ldap_server.host', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ldap_server.host.ldap_server_options', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'hostname, use_vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'host', 'keyval': 'hostname, use_vrf', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v7_0_1b.ldap_server.host": {}, "pybind.nos.v6_0_2c.ldap_server.host": {"hostname": "hostname", "timeout": "timeout"}, "pybind.slxos.v16r_1_00b.ldap_server.host.ldap_server_options": {}, "pybind.nos.v7_1_0.ldap_server.host": {}}
    rest_leaf_name = 'timeout'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, host=host)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, host=host)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ldap_server_maprole_group_delete(self, group=None, switch_role=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type group: ad_group, switch_role
    :param group: Keyword argument tuple.

    :type ad_group: unicode
    :param ad_group: **group** tuple argument:  AD group belongs to user on the AD Server

        * length restriction: ::

            ['1..max']

    :type switch_role: unicode
    :param switch_role: **group** tuple argument:  AD group belongs to user on the AD Server

        * length restriction: ::

            ['4 .. 32']

    **Instance Argument(s)**:

    :type switch_role: unicode
    :param switch_role: AD group belongs to user on the AD Server

        * length restriction: ::

            ['4 .. 32']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.ldap_server.maprole.group', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ldap_server.maprole.group', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ldap_server.maprole.group', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ldap_server.maprole.group', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'group', 'keyval': 'ad_group', 'extra_keyval': 'ad_group, switch_role'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, group=group, switch_role=switch_role)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, group=group, switch_role=switch_role)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ldap_server_maprole_group_role_delete(self, group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type group: ad_group
    :param group: Keyword argument tuple.

    :type ad_group: unicode
    :param ad_group: **group** tuple argument:  AD group belongs to user on the AD Server

        * length restriction: ::

            ['1..max']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.ldap_server.maprole.group', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ldap_server.maprole.group', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ldap_server.maprole.group', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ldap_server.maprole.group', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'group', 'keyval': 'ad_group', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'role'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, group=group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, group=group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def line_delete(self, line=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type line: sessionid
    :param line: Keyword argument tuple.

    :type sessionid: unicode
    :param sessionid: **line** tuple argument:  Terminal type

        * enumeration restriction: ::

            ['vty']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.terminal_cfg.line', 'pybind.nos.v6_0_2c.brocade_terminal', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.terminal_cfg.line', 'pybind.nos.v7_0_1b.brocade_terminal', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.terminal_cfg.line', 'pybind.nos.v7_1_0.brocade_terminal', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.terminal_cfg.line', 'pybind.slxos.v16r_1_00b.brocade_terminal', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'line', 'keyval': 'sessionid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, line=line)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, line=line)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def line_exec_timeout_delete(self, line=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type line: sessionid
    :param line: Keyword argument tuple.

    :type sessionid: unicode
    :param sessionid: **line** tuple argument:  Terminal type

        * enumeration restriction: ::

            ['vty']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.terminal_cfg.line', 'pybind.nos.v6_0_2c.brocade_terminal', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.terminal_cfg.line', 'pybind.nos.v7_0_1b.brocade_terminal', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.terminal_cfg.line', 'pybind.nos.v7_1_0.brocade_terminal', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.terminal_cfg.line', 'pybind.slxos.v16r_1_00b.brocade_terminal', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'line', 'keyval': 'sessionid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'exec-timeout'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, line=line)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, line=line)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def linecard_linecards_delete(self, linecards=None, linecardType=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type linecards: linecardName, linecardType
    :param linecards: Keyword argument tuple.

    :type linecardName: unicode
    :param linecardName: **linecards** tuple argument.

        * pattern restriction: ::

            '([1-9]|[1][0-6])'

    :type linecardType: unicode
    :param linecardType: **linecards** tuple argument.

        * enumeration restriction: ::

            ['LC36X100G', 'LC72X10G']

    **Instance Argument(s)**:

    :type linecardType: unicode
    :param linecardType: Keyword argument.

        * enumeration restriction: ::

            ['LC36X100G', 'LC72X10G']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.global_lc_holder.linecard.linecards', 'pybind.slxos.v16r_1_00b.brocade_linecard_management', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'linecards', 'keyval': 'linecardName', 'extra_keyval': 'linecardName, linecardType'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, linecards=linecards, linecardType=linecardType)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, linecards=linecards, linecardType=linecardType)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def linecard_linecards_linecardtype_delete(self, linecards=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type linecards: linecardName
    :param linecards: Keyword argument tuple.

    :type linecardName: unicode
    :param linecardName: **linecards** tuple argument.

        * pattern restriction: ::

            '([1-9]|[1][0-6])'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.global_lc_holder.linecard.linecards', 'pybind.slxos.v16r_1_00b.brocade_linecard_management', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'linecards', 'keyval': 'linecardName', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'linecardType'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, linecards=linecards)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, linecards=linecards)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def link_fault_signaling_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.link_fault_signaling', 'pybind.slxos.v16r_1_00b.brocade_lfs', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'rx, tx'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def link_fault_signaling_rx_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.link_fault_signaling', 'pybind.slxos.v16r_1_00b.brocade_lfs', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def link_fault_signaling_tx_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.link_fault_signaling', 'pybind.slxos.v16r_1_00b.brocade_lfs', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def load_balance_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.load_balance_lag.load_balance', 'pybind.slxos.v16r_1_00b.brocade_rbridge_lag', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def load_balance_hash_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.load_balance_lag.load_balance.hash', 'pybind.slxos.v16r_1_00b.brocade_rbridge_lag', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def load_balance_hash_ethernet_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.load_balance_lag.load_balance.hash.ethernet', 'pybind.slxos.v16r_1_00b.brocade_rbridge_lag', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def load_balance_hash_ethernet_da_mac_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.load_balance_lag.load_balance.hash.ethernet', 'pybind.slxos.v16r_1_00b.brocade_rbridge_lag', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'da-mac'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def load_balance_hash_ethernet_etype_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.load_balance_lag.load_balance.hash.ethernet', 'pybind.slxos.v16r_1_00b.brocade_rbridge_lag', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'etype'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def load_balance_hash_ethernet_sa_mac_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.load_balance_lag.load_balance.hash.ethernet', 'pybind.slxos.v16r_1_00b.brocade_rbridge_lag', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'sa-mac'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def load_balance_hash_ethernet_vlan_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.load_balance_lag.load_balance.hash.ethernet', 'pybind.slxos.v16r_1_00b.brocade_rbridge_lag', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vlan'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def load_balance_hash_ip_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.load_balance_lag.load_balance.hash.ip', 'pybind.slxos.v16r_1_00b.brocade_rbridge_lag', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def load_balance_hash_ip_dst_ip_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.load_balance_lag.load_balance.hash.ip', 'pybind.slxos.v16r_1_00b.brocade_rbridge_lag', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dst-ip'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def load_balance_hash_ip_dst_l4_port_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.load_balance_lag.load_balance.hash.ip', 'pybind.slxos.v16r_1_00b.brocade_rbridge_lag', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dst-l4-port'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def load_balance_hash_ip_protocol_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.load_balance_lag.load_balance.hash.ip', 'pybind.slxos.v16r_1_00b.brocade_rbridge_lag', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'protocol'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def load_balance_hash_ip_src_ip_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.load_balance_lag.load_balance.hash.ip', 'pybind.slxos.v16r_1_00b.brocade_rbridge_lag', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'src-ip'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def load_balance_hash_ip_src_l4_port_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.load_balance_lag.load_balance.hash.ip', 'pybind.slxos.v16r_1_00b.brocade_rbridge_lag', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'src-l4-port'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def load_balance_hash_ipv6_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.load_balance_lag.load_balance.hash.ipv6', 'pybind.slxos.v16r_1_00b.brocade_rbridge_lag', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def load_balance_hash_ipv6_ipv6_dst_ip_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.load_balance_lag.load_balance.hash.ipv6', 'pybind.slxos.v16r_1_00b.brocade_rbridge_lag', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ipv6-dst-ip'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def load_balance_hash_ipv6_ipv6_dst_l4_port_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.load_balance_lag.load_balance.hash.ipv6', 'pybind.slxos.v16r_1_00b.brocade_rbridge_lag', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ipv6-dst-l4-port'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def load_balance_hash_ipv6_ipv6_next_hdr_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.load_balance_lag.load_balance.hash.ipv6', 'pybind.slxos.v16r_1_00b.brocade_rbridge_lag', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ipv6-next-hdr'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def load_balance_hash_ipv6_ipv6_src_ip_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.load_balance_lag.load_balance.hash.ipv6', 'pybind.slxos.v16r_1_00b.brocade_rbridge_lag', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ipv6-src-ip'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def load_balance_hash_ipv6_ipv6_src_l4_port_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.load_balance_lag.load_balance.hash.ipv6', 'pybind.slxos.v16r_1_00b.brocade_rbridge_lag', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ipv6-src-l4-port'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def load_balance_hash_mpls_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.load_balance_lag.load_balance.hash.mpls', 'pybind.slxos.v16r_1_00b.brocade_rbridge_lag', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def load_balance_hash_mpls_label1_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.load_balance_lag.load_balance.hash.mpls', 'pybind.slxos.v16r_1_00b.brocade_rbridge_lag', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'label1'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def load_balance_hash_mpls_label2_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.load_balance_lag.load_balance.hash.mpls', 'pybind.slxos.v16r_1_00b.brocade_rbridge_lag', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'label2'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def load_balance_hash_mpls_label3_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.load_balance_lag.load_balance.hash.mpls', 'pybind.slxos.v16r_1_00b.brocade_rbridge_lag', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'label3'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def load_balance_lag_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.load_balance_lag', 'pybind.slxos.v16r_1_00b.brocade_rbridge_lag', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def local_node_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.local_node', 'pybind.nos.v6_0_2c.brocade_vcs', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.local_node', 'pybind.nos.v7_0_1b.brocade_vcs', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.local_node', 'pybind.nos.v7_1_0.brocade_vcs', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.local_node', 'pybind.slxos.v16r_1_00b.brocade_vcs', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def local_node_swbd_number_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.local_node', 'pybind.nos.v6_0_2c.brocade_vcs', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.local_node', 'pybind.nos.v7_0_1b.brocade_vcs', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.local_node', 'pybind.nos.v7_1_0.brocade_vcs', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.local_node', 'pybind.slxos.v16r_1_00b.brocade_vcs', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'swbd-number'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def logging_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.destination_console.logging', 'pybind.nos.v6_0_2c.brocade_ras', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.destination_console.logging', 'pybind.nos.v7_0_1b.brocade_ras', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.destination_console.logging', 'pybind.nos.v7_1_0.brocade_ras', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.destination_console.logging', 'pybind.slxos.v16r_1_00b.brocade_ras', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def logging_2_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.logging', 'pybind.nos.v6_0_2c.brocade_ras', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.logging', 'pybind.nos.v7_0_1b.brocade_ras', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.logging', 'pybind.nos.v7_1_0.brocade_ras', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.logging', 'pybind.slxos.v16r_1_00b.brocade_ras', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def logging_auditlog_class_delete(self, class_=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type class_: class_
    :param class_: Keyword argument tuple.

    :type class_: unicode
    :param class_: **class_** tuple argument.

        * enumeration restriction: ::

            ['CONFIGURATION', 'SECURITY', 'FIRMWARE']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.logging.auditlog.class_', 'pybind.nos.v6_0_2c.brocade_ras', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.logging.auditlog.class_', 'pybind.nos.v7_0_1b.brocade_ras', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.logging.auditlog.class_', 'pybind.nos.v7_1_0.brocade_ras', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.logging.auditlog.class_', 'pybind.slxos.v16r_1_00b.brocade_ras', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'class_', 'keyval': 'class_', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, class_=class_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, class_=class_)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def logging_raslog_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.logging.raslog', 'pybind.nos.v6_0_2c.brocade_ras', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.logging.raslog', 'pybind.nos.v7_0_1b.brocade_ras', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.logging.raslog', 'pybind.nos.v7_1_0.brocade_ras', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.logging.raslog', 'pybind.slxos.v16r_1_00b.brocade_ras', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def logging_raslog_console_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.logging.raslog', 'pybind.nos.v6_0_2c.brocade_ras', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.logging.raslog', 'pybind.nos.v7_0_1b.brocade_ras', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.logging.raslog', 'pybind.nos.v7_1_0.brocade_ras', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.logging.raslog', 'pybind.slxos.v16r_1_00b.brocade_ras', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'console'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def logging_raslog_interface_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.logging.raslog.interface', 'pybind.slxos.v16r_1_00b.brocade_ras', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def logging_raslog_interface_description_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.logging.raslog.interface', 'pybind.slxos.v16r_1_00b.brocade_ras', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'description'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def logging_raslog_message_msgid_severity_delete(self, msgid=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type msgid: msgId
    :param msgid: Keyword argument tuple.

    :type msgId: unicode
    :param msgId: **msgid** tuple argument:  Specify the Msg ID

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.logging.raslog.message.msgId', 'pybind.nos.v6_0_2c.brocade_ras', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.logging.raslog.message.msgId', 'pybind.nos.v7_0_1b.brocade_ras', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.logging.raslog.message.msgId', 'pybind.nos.v7_1_0.brocade_ras', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.logging.raslog.message.msgId', 'pybind.slxos.v16r_1_00b.brocade_ras', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'msgid', 'keyval': 'msgId', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'severity'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, msgid=msgid)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, msgid=msgid)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def logging_raslog_message_msgid_suppress_delete(self, msgid=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type msgid: msgId
    :param msgid: Keyword argument tuple.

    :type msgId: unicode
    :param msgId: **msgid** tuple argument:  Specify the Msg ID

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.logging.raslog.message.msgId', 'pybind.nos.v6_0_2c.brocade_ras', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.logging.raslog.message.msgId', 'pybind.nos.v7_0_1b.brocade_ras', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.logging.raslog.message.msgId', 'pybind.nos.v7_1_0.brocade_ras', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.logging.raslog.message.msgId', 'pybind.slxos.v16r_1_00b.brocade_ras', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'msgid', 'keyval': 'msgId', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'suppress'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, msgid=msgid)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, msgid=msgid)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def logging_raslog_message_msgid_syslog_delete(self, msgid=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type msgid: msgId
    :param msgid: Keyword argument tuple.

    :type msgId: unicode
    :param msgId: **msgid** tuple argument:  Specify the Msg ID

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.logging.raslog.message.msgId', 'pybind.nos.v6_0_2c.brocade_ras', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.logging.raslog.message.msgId', 'pybind.nos.v7_0_1b.brocade_ras', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.logging.raslog.message.msgId', 'pybind.nos.v7_1_0.brocade_ras', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.logging.raslog.message.msgId', 'pybind.slxos.v16r_1_00b.brocade_ras', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'msgid', 'keyval': 'msgId', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'syslog'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, msgid=msgid)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, msgid=msgid)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def logging_raslog_module_modid_delete(self, modid=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type modid: modId
    :param modid: Keyword argument tuple.

    :type modId: unicode
    :param modId: **modid** tuple argument:  Specify the Module ID

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.logging.raslog.module.modId', 'pybind.nos.v6_0_2c.brocade_ras', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.logging.raslog.module.modId', 'pybind.nos.v7_0_1b.brocade_ras', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.logging.raslog.module.modId', 'pybind.nos.v7_1_0.brocade_ras', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.logging.raslog.module.modId', 'pybind.slxos.v16r_1_00b.brocade_ras', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'modid', 'keyval': 'modId', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, modid=modid)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, modid=modid)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def logging_syslog_client_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.logging.syslog_client', 'pybind.nos.v6_0_2c.brocade_ras', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.logging.syslog_client', 'pybind.nos.v7_0_1b.brocade_ras', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.logging.syslog_client', 'pybind.nos.v7_1_0.brocade_ras', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.logging.syslog_client', 'pybind.slxos.v16r_1_00b.brocade_ras', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def logging_syslog_client_localip_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.logging.syslog_client', 'pybind.nos.v6_0_2c.brocade_ras', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.logging.syslog_client', 'pybind.nos.v7_0_1b.brocade_ras', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.logging.syslog_client', 'pybind.nos.v7_1_0.brocade_ras', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.logging.syslog_client', 'pybind.slxos.v16r_1_00b.brocade_ras', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'localip'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def logging_syslog_facility_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.logging.syslog_facility', 'pybind.nos.v6_0_2c.brocade_ras', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.logging.syslog_facility', 'pybind.nos.v7_0_1b.brocade_ras', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.logging.syslog_facility', 'pybind.nos.v7_1_0.brocade_ras', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.logging.syslog_facility', 'pybind.slxos.v16r_1_00b.brocade_ras', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def logging_syslog_facility_local_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.logging.syslog_facility', 'pybind.nos.v6_0_2c.brocade_ras', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.logging.syslog_facility', 'pybind.nos.v7_0_1b.brocade_ras', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.logging.syslog_facility', 'pybind.nos.v7_1_0.brocade_ras', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.logging.syslog_facility', 'pybind.slxos.v16r_1_00b.brocade_ras', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'local'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def logging_syslog_server_delete(self, syslog_server=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type syslog_server: syslogip, use_vrf, secure, port
    :param syslog_server: Keyword argument tuple.

    :type syslogip: unicode
    :param syslogip: **syslog_server** tuple argument:  IPADDRESS		The IPv4 or IPv6 Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type use_vrf: unicode
    :param use_vrf: **syslog_server** tuple argument:  vrf to use for sending notification to the receiver. (Default=management).

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type secure: YANGBool
    :param secure: **syslog_server** tuple argument:  Indicates if transport is secure

    :type port: int
    :param port: **syslog_server** tuple argument:  Port number on which the syslog server is listening

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.logging.syslog_server', 'pybind.nos.v6_0_2c.brocade_ras', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.logging.syslog_server', 'pybind.nos.v7_0_1b.brocade_ras', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.logging.syslog_server', 'pybind.nos.v7_1_0.brocade_ras', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.logging.syslog_server', 'pybind.slxos.v16r_1_00b.brocade_ras', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'syslog_server', 'keyval': 'syslogip, use_vrf', 'extra_keyval': 'syslogip, use_vrf, secure, port'}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v7_0_1b.logging.syslog_server": {"port": "port", "syslogip": "syslogip", "use_vrf": "use_vrf", "secure": "secure"}, "pybind.slxos.v16r_1_00b.logging.syslog_server": {}, "pybind.nos.v6_0_2c.logging.syslog_server": {"port": "port", "syslogip": "syslogip", "use_vrf": "use_vrf", "secure": "secure"}, "pybind.nos.v7_1_0.logging.syslog_server": {"port": "port", "syslogip": "syslogip", "use_vrf": "use_vrf", "secure": "secure"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, syslog_server=syslog_server)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, syslog_server=syslog_server)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def logging_syslog_server_port_delete(self, syslog_server=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type syslog_server: syslogip, use_vrf
    :param syslog_server: Keyword argument tuple.

    :type syslogip: unicode
    :param syslogip: **syslog_server** tuple argument:  IPADDRESS		The IPv4 or IPv6 Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type use_vrf: unicode
    :param use_vrf: **syslog_server** tuple argument:  vrf to use for sending notification to the receiver. (Default=management).

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.logging.syslog_server', u'syslog_server')]
    bindings_list = [('pybind.nos.v6_0_2c.logging.syslog_server', 'pybind.nos.v6_0_2c.brocade_ras', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.logging.syslog_server', 'pybind.nos.v7_0_1b.brocade_ras', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.logging.syslog_server', 'pybind.nos.v7_1_0.brocade_ras', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.logging.syslog_server.syslog_secure', 'pybind.slxos.v16r_1_00b.brocade_ras', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'syslogip, use_vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'syslog_server', 'keyval': 'syslogip, use_vrf', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v7_0_1b.logging.syslog_server": {"syslogip": "syslogip", "port": "port", "use_vrf": "use_vrf"}, "pybind.slxos.v16r_1_00b.logging.syslog_server.syslog_secure": {}, "pybind.nos.v6_0_2c.logging.syslog_server": {"syslogip": "syslogip", "port": "port", "use_vrf": "use_vrf"}, "pybind.nos.v7_1_0.logging.syslog_server": {"syslogip": "syslogip", "port": "port", "use_vrf": "use_vrf"}}
    rest_leaf_name = 'port'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, syslog_server=syslog_server)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, syslog_server=syslog_server)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def logging_syslog_server_secure_delete(self, syslog_server=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type syslog_server: syslogip, use_vrf
    :param syslog_server: Keyword argument tuple.

    :type syslogip: unicode
    :param syslogip: **syslog_server** tuple argument:  IPADDRESS		The IPv4 or IPv6 Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type use_vrf: unicode
    :param use_vrf: **syslog_server** tuple argument:  vrf to use for sending notification to the receiver. (Default=management).

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.logging.syslog_server', u'syslog_server')]
    bindings_list = [('pybind.nos.v6_0_2c.logging.syslog_server', 'pybind.nos.v6_0_2c.brocade_ras', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.logging.syslog_server', 'pybind.nos.v7_0_1b.brocade_ras', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.logging.syslog_server', 'pybind.nos.v7_1_0.brocade_ras', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.logging.syslog_server.syslog_secure', 'pybind.slxos.v16r_1_00b.brocade_ras', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'syslogip, use_vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'syslog_server', 'keyval': 'syslogip, use_vrf', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v7_0_1b.logging.syslog_server": {"syslogip": "syslogip", "secure": "secure", "use_vrf": "use_vrf"}, "pybind.slxos.v16r_1_00b.logging.syslog_server.syslog_secure": {}, "pybind.nos.v6_0_2c.logging.syslog_server": {"syslogip": "syslogip", "secure": "secure", "use_vrf": "use_vrf"}, "pybind.nos.v7_1_0.logging.syslog_server": {"syslogip": "syslogip", "secure": "secure", "use_vrf": "use_vrf"}}
    rest_leaf_name = 'secure'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, syslog_server=syslog_server)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, syslog_server=syslog_server)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def logical_interface_state_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.logical_interface_state', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def logical_interface_state_main_interface_physical_delete(self, main_interface_physical=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type main_interface_physical: intf_name
    :param main_interface_physical: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **main_interface_physical** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.logical_interface_state.main_interface_physical', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'main_interface_physical', 'keyval': 'intf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, main_interface_physical=main_interface_physical)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, main_interface_physical=main_interface_physical)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def logical_interface_state_main_interface_physical_admin_status_delete(self, main_interface_physical=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type main_interface_physical: intf_name
    :param main_interface_physical: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **main_interface_physical** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.logical_interface_state.main_interface_physical', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'main_interface_physical', 'keyval': 'intf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'admin-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, main_interface_physical=main_interface_physical)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, main_interface_physical=main_interface_physical)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def logical_interface_state_main_interface_physical_counters_delete(self, main_interface_physical=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type main_interface_physical: intf_name
    :param main_interface_physical: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **main_interface_physical** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.logical_interface_state.main_interface_physical', u'main_interface_physical')]
    bindings_list = [('pybind.slxos.v16r_1_00b.logical_interface_state.main_interface_physical.counters', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, main_interface_physical=main_interface_physical)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, main_interface_physical=main_interface_physical)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def logical_interface_state_main_interface_physical_counters_binded_lifs_delete(self, main_interface_physical=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type main_interface_physical: intf_name
    :param main_interface_physical: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **main_interface_physical** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.logical_interface_state.main_interface_physical', u'main_interface_physical')]
    bindings_list = [('pybind.slxos.v16r_1_00b.logical_interface_state.main_interface_physical.counters', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'binded-lifs'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, main_interface_physical=main_interface_physical)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, main_interface_physical=main_interface_physical)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def logical_interface_state_main_interface_physical_counters_explicit_lifs_delete(self, main_interface_physical=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type main_interface_physical: intf_name
    :param main_interface_physical: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **main_interface_physical** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.logical_interface_state.main_interface_physical', u'main_interface_physical')]
    bindings_list = [('pybind.slxos.v16r_1_00b.logical_interface_state.main_interface_physical.counters', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'explicit-lifs'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, main_interface_physical=main_interface_physical)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, main_interface_physical=main_interface_physical)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def logical_interface_state_main_interface_physical_counters_implicit_lifs_delete(self, main_interface_physical=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type main_interface_physical: intf_name
    :param main_interface_physical: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **main_interface_physical** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.logical_interface_state.main_interface_physical', u'main_interface_physical')]
    bindings_list = [('pybind.slxos.v16r_1_00b.logical_interface_state.main_interface_physical.counters', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'implicit-lifs'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, main_interface_physical=main_interface_physical)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, main_interface_physical=main_interface_physical)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def logical_interface_state_main_interface_physical_counters_lif_type_delete(self, main_interface_physical=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type main_interface_physical: intf_name
    :param main_interface_physical: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **main_interface_physical** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.logical_interface_state.main_interface_physical', u'main_interface_physical')]
    bindings_list = [('pybind.slxos.v16r_1_00b.logical_interface_state.main_interface_physical.counters', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lif-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, main_interface_physical=main_interface_physical)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, main_interface_physical=main_interface_physical)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def logical_interface_state_main_interface_physical_counters_protocol_status_up_lifs_delete(self, main_interface_physical=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type main_interface_physical: intf_name
    :param main_interface_physical: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **main_interface_physical** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.logical_interface_state.main_interface_physical', u'main_interface_physical')]
    bindings_list = [('pybind.slxos.v16r_1_00b.logical_interface_state.main_interface_physical.counters', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'protocol-status-up-lifs'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, main_interface_physical=main_interface_physical)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, main_interface_physical=main_interface_physical)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def logical_interface_state_main_interface_physical_counters_total_lifs_delete(self, main_interface_physical=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type main_interface_physical: intf_name
    :param main_interface_physical: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **main_interface_physical** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.logical_interface_state.main_interface_physical', u'main_interface_physical')]
    bindings_list = [('pybind.slxos.v16r_1_00b.logical_interface_state.main_interface_physical.counters', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'total-lifs'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, main_interface_physical=main_interface_physical)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, main_interface_physical=main_interface_physical)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def logical_interface_state_main_interface_physical_counters_unbinded_lifs_delete(self, main_interface_physical=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type main_interface_physical: intf_name
    :param main_interface_physical: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **main_interface_physical** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.logical_interface_state.main_interface_physical', u'main_interface_physical')]
    bindings_list = [('pybind.slxos.v16r_1_00b.logical_interface_state.main_interface_physical.counters', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'unbinded-lifs'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, main_interface_physical=main_interface_physical)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, main_interface_physical=main_interface_physical)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def logical_interface_state_main_interface_physical_interface_index_delete(self, main_interface_physical=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type main_interface_physical: intf_name
    :param main_interface_physical: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **main_interface_physical** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.logical_interface_state.main_interface_physical', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'main_interface_physical', 'keyval': 'intf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'interface-index'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, main_interface_physical=main_interface_physical)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, main_interface_physical=main_interface_physical)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def logical_interface_state_main_interface_physical_intf_type_delete(self, main_interface_physical=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type main_interface_physical: intf_name
    :param main_interface_physical: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **main_interface_physical** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.logical_interface_state.main_interface_physical', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'main_interface_physical', 'keyval': 'intf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'intf-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, main_interface_physical=main_interface_physical)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, main_interface_physical=main_interface_physical)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def logical_interface_state_main_interface_physical_is_tagged_delete(self, main_interface_physical=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type main_interface_physical: intf_name
    :param main_interface_physical: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **main_interface_physical** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.logical_interface_state.main_interface_physical', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'main_interface_physical', 'keyval': 'intf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'is-tagged'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, main_interface_physical=main_interface_physical)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, main_interface_physical=main_interface_physical)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def logical_interface_state_main_interface_physical_logical_interface_physical_delete(self, main_interface_physical=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type main_interface_physical: intf_name
    :param main_interface_physical: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **main_interface_physical** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.logical_interface_state.main_interface_physical', u'main_interface_physical')]
    bindings_list = [('pybind.slxos.v16r_1_00b.logical_interface_state.main_interface_physical.logical_interface_physical', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, main_interface_physical=main_interface_physical)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, main_interface_physical=main_interface_physical)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def logical_interface_state_main_interface_physical_logical_interface_physical_admin_status_delete(self, main_interface_physical=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type main_interface_physical: intf_name
    :param main_interface_physical: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **main_interface_physical** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.logical_interface_state.main_interface_physical', u'main_interface_physical')]
    bindings_list = [('pybind.slxos.v16r_1_00b.logical_interface_state.main_interface_physical.logical_interface_physical', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'admin-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, main_interface_physical=main_interface_physical)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, main_interface_physical=main_interface_physical)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def logical_interface_state_main_interface_physical_logical_interface_physical_bridge_domain_index_delete(self, main_interface_physical=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type main_interface_physical: intf_name
    :param main_interface_physical: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **main_interface_physical** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.logical_interface_state.main_interface_physical', u'main_interface_physical')]
    bindings_list = [('pybind.slxos.v16r_1_00b.logical_interface_state.main_interface_physical.logical_interface_physical', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bridge-domain-index'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, main_interface_physical=main_interface_physical)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, main_interface_physical=main_interface_physical)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def logical_interface_state_main_interface_physical_logical_interface_physical_inner_vlan_id_delete(self, main_interface_physical=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type main_interface_physical: intf_name
    :param main_interface_physical: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **main_interface_physical** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.logical_interface_state.main_interface_physical', u'main_interface_physical')]
    bindings_list = [('pybind.slxos.v16r_1_00b.logical_interface_state.main_interface_physical.logical_interface_physical', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'inner-vlan-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, main_interface_physical=main_interface_physical)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, main_interface_physical=main_interface_physical)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def logical_interface_state_main_interface_physical_logical_interface_physical_interface_name_delete(self, main_interface_physical=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type main_interface_physical: intf_name
    :param main_interface_physical: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **main_interface_physical** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.logical_interface_state.main_interface_physical', u'main_interface_physical')]
    bindings_list = [('pybind.slxos.v16r_1_00b.logical_interface_state.main_interface_physical.logical_interface_physical', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'interface-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, main_interface_physical=main_interface_physical)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, main_interface_physical=main_interface_physical)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def logical_interface_state_main_interface_physical_logical_interface_physical_intf_type_delete(self, main_interface_physical=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type main_interface_physical: intf_name
    :param main_interface_physical: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **main_interface_physical** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.logical_interface_state.main_interface_physical', u'main_interface_physical')]
    bindings_list = [('pybind.slxos.v16r_1_00b.logical_interface_state.main_interface_physical.logical_interface_physical', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'intf-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, main_interface_physical=main_interface_physical)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, main_interface_physical=main_interface_physical)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def logical_interface_state_main_interface_physical_logical_interface_physical_is_binded_delete(self, main_interface_physical=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type main_interface_physical: intf_name
    :param main_interface_physical: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **main_interface_physical** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.logical_interface_state.main_interface_physical', u'main_interface_physical')]
    bindings_list = [('pybind.slxos.v16r_1_00b.logical_interface_state.main_interface_physical.logical_interface_physical', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'is-binded'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, main_interface_physical=main_interface_physical)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, main_interface_physical=main_interface_physical)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def logical_interface_state_main_interface_physical_logical_interface_physical_is_tagged_delete(self, main_interface_physical=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type main_interface_physical: intf_name
    :param main_interface_physical: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **main_interface_physical** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.logical_interface_state.main_interface_physical', u'main_interface_physical')]
    bindings_list = [('pybind.slxos.v16r_1_00b.logical_interface_state.main_interface_physical.logical_interface_physical', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'is-tagged'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, main_interface_physical=main_interface_physical)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, main_interface_physical=main_interface_physical)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def logical_interface_state_main_interface_physical_logical_interface_physical_lif_index_delete(self, main_interface_physical=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type main_interface_physical: intf_name
    :param main_interface_physical: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **main_interface_physical** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.logical_interface_state.main_interface_physical', u'main_interface_physical')]
    bindings_list = [('pybind.slxos.v16r_1_00b.logical_interface_state.main_interface_physical.logical_interface_physical', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lif-index'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, main_interface_physical=main_interface_physical)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, main_interface_physical=main_interface_physical)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def logical_interface_state_main_interface_physical_logical_interface_physical_logical_interface_name_delete(self, main_interface_physical=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type main_interface_physical: intf_name
    :param main_interface_physical: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **main_interface_physical** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.logical_interface_state.main_interface_physical', u'main_interface_physical')]
    bindings_list = [('pybind.slxos.v16r_1_00b.logical_interface_state.main_interface_physical.logical_interface_physical', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'logical-interface-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, main_interface_physical=main_interface_physical)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, main_interface_physical=main_interface_physical)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def logical_interface_state_main_interface_physical_logical_interface_physical_outer_vlan_id_delete(self, main_interface_physical=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type main_interface_physical: intf_name
    :param main_interface_physical: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **main_interface_physical** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.logical_interface_state.main_interface_physical', u'main_interface_physical')]
    bindings_list = [('pybind.slxos.v16r_1_00b.logical_interface_state.main_interface_physical.logical_interface_physical', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'outer-vlan-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, main_interface_physical=main_interface_physical)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, main_interface_physical=main_interface_physical)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def logical_interface_state_main_interface_physical_logical_interface_physical_protocol_status_delete(self, main_interface_physical=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type main_interface_physical: intf_name
    :param main_interface_physical: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **main_interface_physical** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.logical_interface_state.main_interface_physical', u'main_interface_physical')]
    bindings_list = [('pybind.slxos.v16r_1_00b.logical_interface_state.main_interface_physical.logical_interface_physical', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'protocol-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, main_interface_physical=main_interface_physical)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, main_interface_physical=main_interface_physical)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def logical_interface_state_main_interface_physical_logical_interface_physical_source_type_delete(self, main_interface_physical=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type main_interface_physical: intf_name
    :param main_interface_physical: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **main_interface_physical** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.logical_interface_state.main_interface_physical', u'main_interface_physical')]
    bindings_list = [('pybind.slxos.v16r_1_00b.logical_interface_state.main_interface_physical.logical_interface_physical', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'source-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, main_interface_physical=main_interface_physical)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, main_interface_physical=main_interface_physical)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def logical_interface_state_main_interface_physical_port_mode_delete(self, main_interface_physical=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type main_interface_physical: intf_name
    :param main_interface_physical: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **main_interface_physical** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.logical_interface_state.main_interface_physical', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'main_interface_physical', 'keyval': 'intf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'port-mode'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, main_interface_physical=main_interface_physical)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, main_interface_physical=main_interface_physical)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def logical_interface_state_main_interface_physical_protocol_status_delete(self, main_interface_physical=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type main_interface_physical: intf_name
    :param main_interface_physical: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **main_interface_physical** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.logical_interface_state.main_interface_physical', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'main_interface_physical', 'keyval': 'intf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'protocol-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, main_interface_physical=main_interface_physical)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, main_interface_physical=main_interface_physical)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def logical_interface_state_main_interface_pseudo_wire_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.logical_interface_state.main_interface_pseudo_wire', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def logical_interface_state_main_interface_pseudo_wire_admin_status_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.logical_interface_state.main_interface_pseudo_wire', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'admin-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def logical_interface_state_main_interface_pseudo_wire_counters_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.logical_interface_state.main_interface_pseudo_wire.counters', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def logical_interface_state_main_interface_pseudo_wire_counters_binded_lifs_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.logical_interface_state.main_interface_pseudo_wire.counters', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'binded-lifs'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def logical_interface_state_main_interface_pseudo_wire_counters_explicit_lifs_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.logical_interface_state.main_interface_pseudo_wire.counters', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'explicit-lifs'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def logical_interface_state_main_interface_pseudo_wire_counters_implicit_lifs_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.logical_interface_state.main_interface_pseudo_wire.counters', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'implicit-lifs'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def logical_interface_state_main_interface_pseudo_wire_counters_lif_type_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.logical_interface_state.main_interface_pseudo_wire.counters', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lif-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def logical_interface_state_main_interface_pseudo_wire_counters_protocol_status_up_lifs_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.logical_interface_state.main_interface_pseudo_wire.counters', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'protocol-status-up-lifs'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def logical_interface_state_main_interface_pseudo_wire_counters_total_lifs_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.logical_interface_state.main_interface_pseudo_wire.counters', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'total-lifs'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def logical_interface_state_main_interface_pseudo_wire_counters_unbinded_lifs_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.logical_interface_state.main_interface_pseudo_wire.counters', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'unbinded-lifs'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def logical_interface_state_main_interface_pseudo_wire_interface_index_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.logical_interface_state.main_interface_pseudo_wire', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'interface-index'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def logical_interface_state_main_interface_pseudo_wire_logical_interface_pseudo_wire_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.logical_interface_state.main_interface_pseudo_wire.logical_interface_pseudo_wire', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def logical_interface_state_main_interface_pseudo_wire_logical_interface_pseudo_wire_admin_status_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.logical_interface_state.main_interface_pseudo_wire.logical_interface_pseudo_wire', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'admin-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def logical_interface_state_main_interface_pseudo_wire_logical_interface_pseudo_wire_bridge_domain_index_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.logical_interface_state.main_interface_pseudo_wire.logical_interface_pseudo_wire', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bridge-domain-index'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def logical_interface_state_main_interface_pseudo_wire_logical_interface_pseudo_wire_interface_name_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.logical_interface_state.main_interface_pseudo_wire.logical_interface_pseudo_wire', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'interface-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def logical_interface_state_main_interface_pseudo_wire_logical_interface_pseudo_wire_ip_address_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.logical_interface_state.main_interface_pseudo_wire.logical_interface_pseudo_wire', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ip-address'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def logical_interface_state_main_interface_pseudo_wire_logical_interface_pseudo_wire_is_binded_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.logical_interface_state.main_interface_pseudo_wire.logical_interface_pseudo_wire', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'is-binded'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def logical_interface_state_main_interface_pseudo_wire_logical_interface_pseudo_wire_lif_index_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.logical_interface_state.main_interface_pseudo_wire.logical_interface_pseudo_wire', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lif-index'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def logical_interface_state_main_interface_pseudo_wire_logical_interface_pseudo_wire_logical_interface_name_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.logical_interface_state.main_interface_pseudo_wire.logical_interface_pseudo_wire', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'logical-interface-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def logical_interface_state_main_interface_pseudo_wire_logical_interface_pseudo_wire_protocol_status_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.logical_interface_state.main_interface_pseudo_wire.logical_interface_pseudo_wire', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'protocol-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def logical_interface_state_main_interface_pseudo_wire_logical_interface_pseudo_wire_source_type_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.logical_interface_state.main_interface_pseudo_wire.logical_interface_pseudo_wire', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'source-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def logical_interface_state_main_interface_pseudo_wire_protocol_status_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.logical_interface_state.main_interface_pseudo_wire', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'protocol-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def logical_interface_state_main_interface_tunnel_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.logical_interface_state.main_interface_tunnel', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def logical_interface_state_main_interface_tunnel_admin_status_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.logical_interface_state.main_interface_tunnel', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'admin-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def logical_interface_state_main_interface_tunnel_counters_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.logical_interface_state.main_interface_tunnel.counters', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def logical_interface_state_main_interface_tunnel_counters_binded_lifs_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.logical_interface_state.main_interface_tunnel.counters', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'binded-lifs'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def logical_interface_state_main_interface_tunnel_counters_explicit_lifs_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.logical_interface_state.main_interface_tunnel.counters', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'explicit-lifs'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def logical_interface_state_main_interface_tunnel_counters_implicit_lifs_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.logical_interface_state.main_interface_tunnel.counters', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'implicit-lifs'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def logical_interface_state_main_interface_tunnel_counters_lif_type_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.logical_interface_state.main_interface_tunnel.counters', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lif-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def logical_interface_state_main_interface_tunnel_counters_protocol_status_up_lifs_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.logical_interface_state.main_interface_tunnel.counters', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'protocol-status-up-lifs'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def logical_interface_state_main_interface_tunnel_counters_total_lifs_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.logical_interface_state.main_interface_tunnel.counters', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'total-lifs'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def logical_interface_state_main_interface_tunnel_counters_unbinded_lifs_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.logical_interface_state.main_interface_tunnel.counters', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'unbinded-lifs'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def logical_interface_state_main_interface_tunnel_interface_index_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.logical_interface_state.main_interface_tunnel', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'interface-index'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def logical_interface_state_main_interface_tunnel_logical_interface_tunnel_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.logical_interface_state.main_interface_tunnel.logical_interface_tunnel', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def logical_interface_state_main_interface_tunnel_logical_interface_tunnel_admin_status_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.logical_interface_state.main_interface_tunnel.logical_interface_tunnel', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'admin-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def logical_interface_state_main_interface_tunnel_logical_interface_tunnel_bridge_domain_index_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.logical_interface_state.main_interface_tunnel.logical_interface_tunnel', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bridge-domain-index'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def logical_interface_state_main_interface_tunnel_logical_interface_tunnel_interface_name_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.logical_interface_state.main_interface_tunnel.logical_interface_tunnel', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'interface-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def logical_interface_state_main_interface_tunnel_logical_interface_tunnel_is_binded_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.logical_interface_state.main_interface_tunnel.logical_interface_tunnel', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'is-binded'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def logical_interface_state_main_interface_tunnel_logical_interface_tunnel_lif_index_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.logical_interface_state.main_interface_tunnel.logical_interface_tunnel', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lif-index'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def logical_interface_state_main_interface_tunnel_logical_interface_tunnel_logical_interface_name_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.logical_interface_state.main_interface_tunnel.logical_interface_tunnel', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'logical-interface-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def logical_interface_state_main_interface_tunnel_logical_interface_tunnel_protocol_status_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.logical_interface_state.main_interface_tunnel.logical_interface_tunnel', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'protocol-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def logical_interface_state_main_interface_tunnel_logical_interface_tunnel_source_type_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.logical_interface_state.main_interface_tunnel.logical_interface_tunnel', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'source-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def logical_interface_state_main_interface_tunnel_logical_interface_tunnel_vni_tni_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.logical_interface_state.main_interface_tunnel.logical_interface_tunnel', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vni-tni'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def logical_interface_state_main_interface_tunnel_protocol_status_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.logical_interface_state.main_interface_tunnel', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'protocol-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def logtest_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.logtest', 'pybind.nos.v6_0_2c.brocade_ras', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.logtest', 'pybind.nos.v7_0_1b.brocade_ras', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.logtest', 'pybind.nos.v7_1_0.brocade_ras', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.logtest', 'pybind.slxos.v16r_1_00b.brocade_ras', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mac_access_list_extended_delete(self, extended=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.mac.access_list.extended', 'pybind.nos.v6_0_2c.brocade_mac_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.mac.access_list.extended', 'pybind.nos.v7_0_1b.brocade_mac_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.mac.access_list.extended', 'pybind.nos.v7_1_0.brocade_mac_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.mac.access_list.extended', 'pybind.slxos.v16r_1_00b.brocade_mac_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mac_access_list_extended_seq_delete(self, extended=None, seq=None, action=None, source=None, srchost=None, src_mac_addr_mask=None, dst=None, dsthost=None, dst_mac_addr_mask=None, ethertype=None, vlan=None, count=None, log=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id, action, source, srchost, src_mac_addr_mask, dst, dsthost, dst_mac_addr_mask, ethertype, vlan, count, log
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type action: unicode
    :param action: **seq** tuple argument.

        * enumeration restriction: ::

            ['deny', 'hard-drop', 'permit']

    :type source: unicode
    :param source: **seq** tuple argument.

    :type srchost: unicode
    :param srchost: **seq** tuple argument:  source mac address HHHH.HHHH.HHHH

    :type src_mac_addr_mask: unicode
    :param src_mac_addr_mask: **seq** tuple argument.

    :type dst: unicode
    :param dst: **seq** tuple argument.

    :type dsthost: unicode
    :param dsthost: **seq** tuple argument:  Destination mac address HHHH.HHHH.HHHH

    :type dst_mac_addr_mask: unicode
    :param dst_mac_addr_mask: **seq** tuple argument.

    :type ethertype: unicode
    :param ethertype: **seq** tuple argument.

        * enumeration restriction: ::

            ['arp', 'fcoe', 'ipv4']

    :type vlan: long
    :param vlan: **seq** tuple argument:  Vlan

        * range restriction: ::

            ['0..4294967295']

    :type count: YANGBool
    :param count: **seq** tuple argument:  Packet count

    :type log: YANGBool
    :param log: **seq** tuple argument:  Log Packet

    **Instance Argument(s)**:

    :type action: unicode
    :param action: Keyword argument.

        * enumeration restriction: ::

            ['deny', 'hard-drop', 'permit']

    :type source: unicode
    :param source: Keyword argument.

    :type srchost: unicode
    :param srchost: source mac address HHHH.HHHH.HHHH

    :type src_mac_addr_mask: unicode
    :param src_mac_addr_mask: Keyword argument.

    :type dst: unicode
    :param dst: Keyword argument.

    :type dsthost: unicode
    :param dsthost: Destination mac address HHHH.HHHH.HHHH

    :type dst_mac_addr_mask: unicode
    :param dst_mac_addr_mask: Keyword argument.

    :type ethertype: unicode
    :param ethertype: Keyword argument.

        * enumeration restriction: ::

            ['arp', 'fcoe', 'ipv4']

    :type vlan: long
    :param vlan: Vlan

        * range restriction: ::

            ['0..4294967295']

    :type count: YANGBool
    :param count: Packet count

    :type log: YANGBool
    :param log: Log Packet

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mac.access_list.extended', u'extended'), ('pybind.nos.v7_0_1b.mac.access_list.extended', u'extended'), ('pybind.nos.v7_1_0.mac.access_list.extended', u'extended'), ('pybind.nos.v6_0_2c.mac.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2c.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.nos.v6_0_2c.brocade_mac_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.nos.v7_0_1b.brocade_mac_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.nos.v7_1_0.brocade_mac_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.slxos.v16r_1_00b.brocade_mac_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': 'seq_id, action, source, srchost, src_mac_addr_mask, dst, dsthost, dst_mac_addr_mask, ethertype, vlan, count, log'}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v7_0_1b.mac.access_list.extended.hide_mac_acl_ext.seq": {"dsthost": "dsthost", "count": "count", "log": "log", "srchost": "srchost", "seq_id": "seq_id", "dst": "dst", "vlan": "vlan", "dst_mac_addr_mask": "dst_mac_addr_mask", "source": "source", "src_mac_addr_mask": "src_mac_addr_mask", "ethertype": "ethertype", "action": "action"}, "pybind.nos.v6_0_2c.mac.access_list.extended.hide_mac_acl_ext.seq": {"dsthost": "dsthost", "count": "count", "log": "log", "srchost": "srchost", "seq_id": "seq_id", "dst": "dst", "vlan": "vlan", "dst_mac_addr_mask": "dst_mac_addr_mask", "source": "source", "src_mac_addr_mask": "src_mac_addr_mask", "ethertype": "ethertype", "action": "action"}, "pybind.nos.v7_1_0.mac.access_list.extended.hide_mac_acl_ext.seq": {"dsthost": "dsthost", "count": "count", "log": "log", "srchost": "srchost", "seq_id": "seq_id", "dst": "dst", "vlan": "vlan", "dst_mac_addr_mask": "dst_mac_addr_mask", "source": "source", "src_mac_addr_mask": "src_mac_addr_mask", "ethertype": "ethertype", "action": "action"}, "pybind.slxos.v16r_1_00b.mac.access_list.extended.hide_mac_acl_ext.seq": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq, action=action, source=source, srchost=srchost, src_mac_addr_mask=src_mac_addr_mask, dst=dst, dsthost=dsthost, dst_mac_addr_mask=dst_mac_addr_mask, ethertype=ethertype, vlan=vlan, count=count, log=log)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq, action=action, source=source, srchost=srchost, src_mac_addr_mask=src_mac_addr_mask, dst=dst, dsthost=dsthost, dst_mac_addr_mask=dst_mac_addr_mask, ethertype=ethertype, vlan=vlan, count=count, log=log)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mac_access_list_extended_seq_action_delete(self, extended=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mac.access_list.extended', u'extended'), ('pybind.nos.v7_0_1b.mac.access_list.extended', u'extended'), ('pybind.nos.v7_1_0.mac.access_list.extended', u'extended'), ('pybind.nos.v6_0_2c.mac.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2c.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.nos.v6_0_2c.brocade_mac_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.nos.v7_0_1b.brocade_mac_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.nos.v7_1_0.brocade_mac_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.slxos.v16r_1_00b.brocade_mac_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'action'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mac_access_list_extended_seq_copy_sflow_delete(self, extended=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mac.access_list.extended', u'extended')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.slxos.v16r_1_00b.brocade_mac_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'copy-sflow'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mac_access_list_extended_seq_count_delete(self, extended=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mac.access_list.extended', u'extended'), ('pybind.nos.v7_0_1b.mac.access_list.extended', u'extended'), ('pybind.nos.v7_1_0.mac.access_list.extended', u'extended'), ('pybind.nos.v6_0_2c.mac.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2c.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.nos.v6_0_2c.brocade_mac_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.nos.v7_0_1b.brocade_mac_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.nos.v7_1_0.brocade_mac_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.slxos.v16r_1_00b.brocade_mac_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mac_access_list_extended_seq_drop_precedence_force_delete(self, extended=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mac.access_list.extended', u'extended')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.slxos.v16r_1_00b.brocade_mac_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'drop-precedence-force'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mac_access_list_extended_seq_dst_delete(self, extended=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mac.access_list.extended', u'extended'), ('pybind.nos.v7_0_1b.mac.access_list.extended', u'extended'), ('pybind.nos.v7_1_0.mac.access_list.extended', u'extended'), ('pybind.nos.v6_0_2c.mac.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2c.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.nos.v6_0_2c.brocade_mac_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.nos.v7_0_1b.brocade_mac_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.nos.v7_1_0.brocade_mac_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.slxos.v16r_1_00b.brocade_mac_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dst'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mac_access_list_extended_seq_dst_mac_addr_mask_delete(self, extended=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mac.access_list.extended', u'extended'), ('pybind.nos.v7_0_1b.mac.access_list.extended', u'extended'), ('pybind.nos.v7_1_0.mac.access_list.extended', u'extended'), ('pybind.nos.v6_0_2c.mac.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2c.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.nos.v6_0_2c.brocade_mac_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.nos.v7_0_1b.brocade_mac_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.nos.v7_1_0.brocade_mac_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.slxos.v16r_1_00b.brocade_mac_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dst-mac-addr-mask'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mac_access_list_extended_seq_dsthost_delete(self, extended=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mac.access_list.extended', u'extended'), ('pybind.nos.v7_0_1b.mac.access_list.extended', u'extended'), ('pybind.nos.v7_1_0.mac.access_list.extended', u'extended'), ('pybind.nos.v6_0_2c.mac.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2c.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.nos.v6_0_2c.brocade_mac_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.nos.v7_0_1b.brocade_mac_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.nos.v7_1_0.brocade_mac_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.slxos.v16r_1_00b.brocade_mac_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dsthost'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mac_access_list_extended_seq_ethertype_delete(self, extended=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mac.access_list.extended', u'extended'), ('pybind.nos.v7_0_1b.mac.access_list.extended', u'extended'), ('pybind.nos.v7_1_0.mac.access_list.extended', u'extended'), ('pybind.nos.v6_0_2c.mac.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2c.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.nos.v6_0_2c.brocade_mac_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.nos.v7_0_1b.brocade_mac_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.nos.v7_1_0.brocade_mac_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.slxos.v16r_1_00b.brocade_mac_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ethertype'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mac_access_list_extended_seq_log_delete(self, extended=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mac.access_list.extended', u'extended'), ('pybind.nos.v7_0_1b.mac.access_list.extended', u'extended'), ('pybind.nos.v7_1_0.mac.access_list.extended', u'extended'), ('pybind.nos.v6_0_2c.mac.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2c.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.nos.v6_0_2c.brocade_mac_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.nos.v7_0_1b.brocade_mac_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.nos.v7_1_0.brocade_mac_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.slxos.v16r_1_00b.brocade_mac_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'log'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mac_access_list_extended_seq_mirror_delete(self, extended=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mac.access_list.extended', u'extended')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.slxos.v16r_1_00b.brocade_mac_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mirror'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mac_access_list_extended_seq_pcp_delete(self, extended=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mac.access_list.extended', u'extended')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.slxos.v16r_1_00b.brocade_mac_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'pcp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mac_access_list_extended_seq_pcp_force_delete(self, extended=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mac.access_list.extended', u'extended')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.slxos.v16r_1_00b.brocade_mac_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'pcp-force'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mac_access_list_extended_seq_source_delete(self, extended=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mac.access_list.extended', u'extended'), ('pybind.nos.v7_0_1b.mac.access_list.extended', u'extended'), ('pybind.nos.v7_1_0.mac.access_list.extended', u'extended'), ('pybind.nos.v6_0_2c.mac.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2c.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.nos.v6_0_2c.brocade_mac_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.nos.v7_0_1b.brocade_mac_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.nos.v7_1_0.brocade_mac_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.slxos.v16r_1_00b.brocade_mac_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'source'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mac_access_list_extended_seq_src_mac_addr_mask_delete(self, extended=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mac.access_list.extended', u'extended'), ('pybind.nos.v7_0_1b.mac.access_list.extended', u'extended'), ('pybind.nos.v7_1_0.mac.access_list.extended', u'extended'), ('pybind.nos.v6_0_2c.mac.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2c.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.nos.v6_0_2c.brocade_mac_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.nos.v7_0_1b.brocade_mac_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.nos.v7_1_0.brocade_mac_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.slxos.v16r_1_00b.brocade_mac_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'src-mac-addr-mask'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mac_access_list_extended_seq_srchost_delete(self, extended=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mac.access_list.extended', u'extended'), ('pybind.nos.v7_0_1b.mac.access_list.extended', u'extended'), ('pybind.nos.v7_1_0.mac.access_list.extended', u'extended'), ('pybind.nos.v6_0_2c.mac.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2c.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.nos.v6_0_2c.brocade_mac_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.nos.v7_0_1b.brocade_mac_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.nos.v7_1_0.brocade_mac_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.slxos.v16r_1_00b.brocade_mac_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'srchost'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mac_access_list_extended_seq_vlan_delete(self, extended=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mac.access_list.extended', u'extended'), ('pybind.nos.v7_0_1b.mac.access_list.extended', u'extended'), ('pybind.nos.v7_1_0.mac.access_list.extended', u'extended'), ('pybind.nos.v6_0_2c.mac.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2c.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.nos.v6_0_2c.brocade_mac_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.nos.v7_0_1b.brocade_mac_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.nos.v7_1_0.brocade_mac_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.slxos.v16r_1_00b.brocade_mac_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vlan'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mac_access_list_standard_delete(self, standard=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type standard: name
    :param standard: Keyword argument tuple.

    :type name: unicode
    :param name: **standard** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.mac.access_list.standard', 'pybind.nos.v6_0_2c.brocade_mac_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.mac.access_list.standard', 'pybind.nos.v7_0_1b.brocade_mac_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.mac.access_list.standard', 'pybind.nos.v7_1_0.brocade_mac_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.mac.access_list.standard', 'pybind.slxos.v16r_1_00b.brocade_mac_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'standard', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, standard=standard)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, standard=standard)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mac_access_list_standard_seq_delete(self, standard=None, seq=None, action=None, source=None, srchost=None, src_mac_addr_mask=None, count=None, log=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type standard: name
    :param standard: Keyword argument tuple.

    :type name: unicode
    :param name: **standard** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id, action, source, srchost, src_mac_addr_mask, count, log
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type action: unicode
    :param action: **seq** tuple argument.

        * enumeration restriction: ::

            ['deny', 'hard-drop', 'permit']

    :type source: unicode
    :param source: **seq** tuple argument.

    :type srchost: unicode
    :param srchost: **seq** tuple argument.

    :type src_mac_addr_mask: unicode
    :param src_mac_addr_mask: **seq** tuple argument.

    :type count: YANGBool
    :param count: **seq** tuple argument:  Packet count

    :type log: YANGBool
    :param log: **seq** tuple argument:  Log Packet

    **Instance Argument(s)**:

    :type action: unicode
    :param action: Keyword argument.

        * enumeration restriction: ::

            ['deny', 'hard-drop', 'permit']

    :type source: unicode
    :param source: Keyword argument.

    :type srchost: unicode
    :param srchost: Keyword argument.

    :type src_mac_addr_mask: unicode
    :param src_mac_addr_mask: Keyword argument.

    :type count: YANGBool
    :param count: Packet count

    :type log: YANGBool
    :param log: Log Packet

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.mac.access_list.standard', u'standard'), ('pybind.slxos.v16r_1_00b.mac.access_list.standard', u'standard'), ('pybind.nos.v6_0_2c.mac.access_list.standard', u'standard'), ('pybind.nos.v7_0_1b.mac.access_list.standard', u'standard')]
    bindings_list = [('pybind.nos.v6_0_2c.mac.access_list.standard.hide_mac_acl_std.seq', 'pybind.nos.v6_0_2c.brocade_mac_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.mac.access_list.standard.hide_mac_acl_std.seq', 'pybind.nos.v7_0_1b.brocade_mac_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.mac.access_list.standard.hide_mac_acl_std.seq', 'pybind.nos.v7_1_0.brocade_mac_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.mac.access_list.standard.hide_mac_acl_std.seq', 'pybind.slxos.v16r_1_00b.brocade_mac_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': 'seq_id, action, source, srchost, src_mac_addr_mask, count, log'}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v7_0_1b.mac.access_list.standard.hide_mac_acl_std.seq": {"count": "count", "log": "log", "srchost": "srchost", "seq_id": "seq_id", "source": "source", "src_mac_addr_mask": "src_mac_addr_mask", "action": "action"}, "pybind.nos.v6_0_2c.mac.access_list.standard.hide_mac_acl_std.seq": {"count": "count", "log": "log", "srchost": "srchost", "seq_id": "seq_id", "source": "source", "src_mac_addr_mask": "src_mac_addr_mask", "action": "action"}, "pybind.nos.v7_1_0.mac.access_list.standard.hide_mac_acl_std.seq": {"count": "count", "log": "log", "srchost": "srchost", "seq_id": "seq_id", "source": "source", "src_mac_addr_mask": "src_mac_addr_mask", "action": "action"}, "pybind.slxos.v16r_1_00b.mac.access_list.standard.hide_mac_acl_std.seq": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, standard=standard, seq=seq, action=action, source=source, srchost=srchost, src_mac_addr_mask=src_mac_addr_mask, count=count, log=log)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, standard=standard, seq=seq, action=action, source=source, srchost=srchost, src_mac_addr_mask=src_mac_addr_mask, count=count, log=log)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mac_access_list_standard_seq_action_delete(self, standard=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type standard: name
    :param standard: Keyword argument tuple.

    :type name: unicode
    :param name: **standard** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.mac.access_list.standard', u'standard'), ('pybind.slxos.v16r_1_00b.mac.access_list.standard', u'standard'), ('pybind.nos.v6_0_2c.mac.access_list.standard', u'standard'), ('pybind.nos.v7_0_1b.mac.access_list.standard', u'standard')]
    bindings_list = [('pybind.nos.v6_0_2c.mac.access_list.standard.hide_mac_acl_std.seq', 'pybind.nos.v6_0_2c.brocade_mac_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.mac.access_list.standard.hide_mac_acl_std.seq', 'pybind.nos.v7_0_1b.brocade_mac_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.mac.access_list.standard.hide_mac_acl_std.seq', 'pybind.nos.v7_1_0.brocade_mac_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.mac.access_list.standard.hide_mac_acl_std.seq', 'pybind.slxos.v16r_1_00b.brocade_mac_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'action'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, standard=standard, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, standard=standard, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mac_access_list_standard_seq_copy_sflow_delete(self, standard=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type standard: name
    :param standard: Keyword argument tuple.

    :type name: unicode
    :param name: **standard** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mac.access_list.standard', u'standard')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mac.access_list.standard.hide_mac_acl_std.seq', 'pybind.slxos.v16r_1_00b.brocade_mac_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'copy-sflow'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, standard=standard, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, standard=standard, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mac_access_list_standard_seq_count_delete(self, standard=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type standard: name
    :param standard: Keyword argument tuple.

    :type name: unicode
    :param name: **standard** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.mac.access_list.standard', u'standard'), ('pybind.slxos.v16r_1_00b.mac.access_list.standard', u'standard'), ('pybind.nos.v6_0_2c.mac.access_list.standard', u'standard'), ('pybind.nos.v7_0_1b.mac.access_list.standard', u'standard')]
    bindings_list = [('pybind.nos.v6_0_2c.mac.access_list.standard.hide_mac_acl_std.seq', 'pybind.nos.v6_0_2c.brocade_mac_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.mac.access_list.standard.hide_mac_acl_std.seq', 'pybind.nos.v7_0_1b.brocade_mac_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.mac.access_list.standard.hide_mac_acl_std.seq', 'pybind.nos.v7_1_0.brocade_mac_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.mac.access_list.standard.hide_mac_acl_std.seq', 'pybind.slxos.v16r_1_00b.brocade_mac_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, standard=standard, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, standard=standard, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mac_access_list_standard_seq_log_delete(self, standard=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type standard: name
    :param standard: Keyword argument tuple.

    :type name: unicode
    :param name: **standard** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.mac.access_list.standard', u'standard'), ('pybind.slxos.v16r_1_00b.mac.access_list.standard', u'standard'), ('pybind.nos.v6_0_2c.mac.access_list.standard', u'standard'), ('pybind.nos.v7_0_1b.mac.access_list.standard', u'standard')]
    bindings_list = [('pybind.nos.v6_0_2c.mac.access_list.standard.hide_mac_acl_std.seq', 'pybind.nos.v6_0_2c.brocade_mac_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.mac.access_list.standard.hide_mac_acl_std.seq', 'pybind.nos.v7_0_1b.brocade_mac_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.mac.access_list.standard.hide_mac_acl_std.seq', 'pybind.nos.v7_1_0.brocade_mac_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.mac.access_list.standard.hide_mac_acl_std.seq', 'pybind.slxos.v16r_1_00b.brocade_mac_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'log'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, standard=standard, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, standard=standard, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mac_access_list_standard_seq_source_delete(self, standard=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type standard: name
    :param standard: Keyword argument tuple.

    :type name: unicode
    :param name: **standard** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.mac.access_list.standard', u'standard'), ('pybind.slxos.v16r_1_00b.mac.access_list.standard', u'standard'), ('pybind.nos.v6_0_2c.mac.access_list.standard', u'standard'), ('pybind.nos.v7_0_1b.mac.access_list.standard', u'standard')]
    bindings_list = [('pybind.nos.v6_0_2c.mac.access_list.standard.hide_mac_acl_std.seq', 'pybind.nos.v6_0_2c.brocade_mac_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.mac.access_list.standard.hide_mac_acl_std.seq', 'pybind.nos.v7_0_1b.brocade_mac_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.mac.access_list.standard.hide_mac_acl_std.seq', 'pybind.nos.v7_1_0.brocade_mac_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.mac.access_list.standard.hide_mac_acl_std.seq', 'pybind.slxos.v16r_1_00b.brocade_mac_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'source'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, standard=standard, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, standard=standard, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mac_access_list_standard_seq_src_mac_addr_mask_delete(self, standard=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type standard: name
    :param standard: Keyword argument tuple.

    :type name: unicode
    :param name: **standard** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.mac.access_list.standard', u'standard'), ('pybind.slxos.v16r_1_00b.mac.access_list.standard', u'standard'), ('pybind.nos.v6_0_2c.mac.access_list.standard', u'standard'), ('pybind.nos.v7_0_1b.mac.access_list.standard', u'standard')]
    bindings_list = [('pybind.nos.v6_0_2c.mac.access_list.standard.hide_mac_acl_std.seq', 'pybind.nos.v6_0_2c.brocade_mac_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.mac.access_list.standard.hide_mac_acl_std.seq', 'pybind.nos.v7_0_1b.brocade_mac_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.mac.access_list.standard.hide_mac_acl_std.seq', 'pybind.nos.v7_1_0.brocade_mac_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.mac.access_list.standard.hide_mac_acl_std.seq', 'pybind.slxos.v16r_1_00b.brocade_mac_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'src-mac-addr-mask'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, standard=standard, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, standard=standard, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mac_access_list_standard_seq_srchost_delete(self, standard=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type standard: name
    :param standard: Keyword argument tuple.

    :type name: unicode
    :param name: **standard** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.mac.access_list.standard', u'standard'), ('pybind.slxos.v16r_1_00b.mac.access_list.standard', u'standard'), ('pybind.nos.v6_0_2c.mac.access_list.standard', u'standard'), ('pybind.nos.v7_0_1b.mac.access_list.standard', u'standard')]
    bindings_list = [('pybind.nos.v6_0_2c.mac.access_list.standard.hide_mac_acl_std.seq', 'pybind.nos.v6_0_2c.brocade_mac_access_list', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.mac.access_list.standard.hide_mac_acl_std.seq', 'pybind.nos.v7_0_1b.brocade_mac_access_list', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.mac.access_list.standard.hide_mac_acl_std.seq', 'pybind.nos.v7_1_0.brocade_mac_access_list', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.mac.access_list.standard.hide_mac_acl_std.seq', 'pybind.slxos.v16r_1_00b.brocade_mac_access_list', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'srchost'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, standard=standard, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, standard=standard, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mac_address_table_aging_time_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.mac_address_table.aging_time', 'pybind.nos.v6_0_2c.brocade_mac_address_table', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.mac_address_table.aging_time', 'pybind.nos.v7_0_1b.brocade_mac_address_table', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.mac_address_table.aging_time', 'pybind.nos.v7_1_0.brocade_mac_address_table', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.mac_address_table.aging_time', 'pybind.slxos.v16r_1_00b.brocade_mac_address_table', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mac_address_table_aging_time_conversational_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.mac_address_table.aging_time', 'pybind.nos.v6_0_2c.brocade_mac_address_table', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.mac_address_table.aging_time', 'pybind.nos.v7_0_1b.brocade_mac_address_table', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.mac_address_table.aging_time', 'pybind.nos.v7_1_0.brocade_mac_address_table', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.mac_address_table.aging_time', 'pybind.slxos.v16r_1_00b.brocade_mac_address_table', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'conversational'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mac_address_table_aging_time_legacy_time_out_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.mac_address_table.aging_time', 'pybind.nos.v6_0_2c.brocade_mac_address_table', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.mac_address_table.aging_time', 'pybind.nos.v7_0_1b.brocade_mac_address_table', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.mac_address_table.aging_time', 'pybind.nos.v7_1_0.brocade_mac_address_table', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.mac_address_table.aging_time', 'pybind.slxos.v16r_1_00b.brocade_mac_address_table', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'legacy-time-out'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mac_address_table_consistency_check_interval_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.mac_address_table.consistency_check', 'pybind.nos.v6_0_2c.brocade_mac_address_table', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.mac_address_table.consistency_check', 'pybind.nos.v7_0_1b.brocade_mac_address_table', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.mac_address_table.consistency_check', 'pybind.nos.v7_1_0.brocade_mac_address_table', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.mac_address_table.consistency_check', 'pybind.slxos.v16r_1_00b.brocade_mac_address_table', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mac_address_table_consistency_check_suppress_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.mac_address_table.consistency_check', 'pybind.nos.v6_0_2c.brocade_mac_address_table', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.mac_address_table.consistency_check', 'pybind.nos.v7_0_1b.brocade_mac_address_table', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.mac_address_table.consistency_check', 'pybind.nos.v7_1_0.brocade_mac_address_table', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.mac_address_table.consistency_check', 'pybind.slxos.v16r_1_00b.brocade_mac_address_table', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'suppress'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mac_address_table_learning_mode_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.mac_address_table', 'pybind.nos.v6_0_2c.brocade_mac_address_table', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.mac_address_table', 'pybind.nos.v7_0_1b.brocade_mac_address_table', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.mac_address_table', 'pybind.nos.v7_1_0.brocade_mac_address_table', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.mac_address_table', 'pybind.slxos.v16r_1_00b.brocade_mac_address_table', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'learning-mode'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mac_address_table_mac_move_action_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_1_0.mac_address_table.mac_move', 'pybind.nos.v7_1_0.brocade_mac_address_table', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'action'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mac_address_table_mac_move_auto_recovery_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_1_0.mac_address_table.mac_move.auto_recovery', 'pybind.nos.v7_1_0.brocade_mac_address_table', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mac_address_table_mac_move_auto_recovery_enable_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_1_0.mac_address_table.mac_move.auto_recovery', 'pybind.nos.v7_1_0.brocade_mac_address_table', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mac_address_table_mac_move_auto_recovery_time_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_1_0.mac_address_table.mac_move.auto_recovery', 'pybind.nos.v7_1_0.brocade_mac_address_table', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mac_address_table_mac_move_detect_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.mac_address_table.mac_move', 'pybind.nos.v6_0_2c.brocade_mac_address_table', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.mac_address_table.mac_move', 'pybind.nos.v7_0_1b.brocade_mac_address_table', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.mac_address_table.mac_move', 'pybind.nos.v7_1_0.brocade_mac_address_table', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.mac_address_table.mac_move', 'pybind.slxos.v16r_1_00b.brocade_mac_address_table', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'detect'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mac_address_table_mac_move_limit_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.mac_address_table.mac_move', 'pybind.nos.v6_0_2c.brocade_mac_address_table', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.mac_address_table.mac_move', 'pybind.nos.v7_0_1b.brocade_mac_address_table', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.mac_address_table.mac_move', 'pybind.nos.v7_1_0.brocade_mac_address_table', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.mac_address_table.mac_move', 'pybind.slxos.v16r_1_00b.brocade_mac_address_table', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'limit'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mac_address_table_static_delete(self, static=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Instance Keyword Argument Tuple**:

    :type static: mac_address, forward, interface_type, interface_name, vlan, vlanid
    :param static: Keyword argument tuple.

    :type mac_address: unicode
    :param mac_address: **static** tuple argument.

    :type forward: unicode
    :param forward: **static** tuple argument:  Forward

        * enumeration restriction: ::

            ['forward']

    :type interface_type: unicode
    :param interface_type: **static** tuple argument:  Interface

        * enumeration restriction: ::

            ['fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'port-channel']

    :type interface_name: unicode
    :param interface_name: **static** tuple argument:  Interface identifier

    :type vlan: unicode
    :param vlan: **static** tuple argument:  vlan

        * enumeration restriction: ::

            ['vlan']

    :type vlanid: long
    :param vlanid: **static** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.mac_address_table.static', 'pybind.nos.v6_0_2c.brocade_mac_address_table', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.mac_address_table.static', 'pybind.nos.v7_0_1b.brocade_mac_address_table', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.mac_address_table.static', 'pybind.nos.v7_1_0.brocade_mac_address_table', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'static', 'keyval': 'mac_address, forward, interface_type, interface_name, vlan, vlanid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, static=static)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, static=static)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mac_address_table_static_static_ac_lif_delete(self, static_ac_lif=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type static_ac_lif: mac_address_lif, forward_lif, logical_interface, interface_type_lif, logical_interface_name
    :param static_ac_lif: Keyword argument tuple.

    :type mac_address_lif: unicode
    :param mac_address_lif: **static_ac_lif** tuple argument.

    :type forward_lif: unicode
    :param forward_lif: **static_ac_lif** tuple argument:  Forward

        * enumeration restriction: ::

            ['forward']

    :type logical_interface: unicode
    :param logical_interface: **static_ac_lif** tuple argument:  Logical Interface

        * enumeration restriction: ::

            ['logical-interface']

    :type interface_type_lif: unicode
    :param interface_type_lif: **static_ac_lif** tuple argument:  Logical Ethernet Interface

        * enumeration restriction: ::

            ['ethernet']

    :type logical_interface_name: unicode
    :param logical_interface_name: **static_ac_lif** tuple argument:  Logical interface name

        * pattern restriction: ::

            '(([0-9]|1[0-6])/([1-9]|[1-9][0-9])(:[1-4])?\.([1'
            '-9]|[1-9][0-9]+))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mac_address_table.static.static_ac_lif', 'pybind.slxos.v16r_1_00b.brocade_mac_address_table', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'static_ac_lif', 'keyval': 'mac_address_lif, forward_lif, logical_interface, interface_type_lif, logical_interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, static_ac_lif=static_ac_lif)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, static_ac_lif=static_ac_lif)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mac_address_table_static_static_mac_delete(self, static_mac=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type static_mac: mac_address, forward, interface_type, interface_name, vlan, vlanid
    :param static_mac: Keyword argument tuple.

    :type mac_address: unicode
    :param mac_address: **static_mac** tuple argument.

    :type forward: unicode
    :param forward: **static_mac** tuple argument:  Forward

        * enumeration restriction: ::

            ['forward']

    :type interface_type: unicode
    :param interface_type: **static_mac** tuple argument:  Interface

        * enumeration restriction: ::

            ['ethernet', 'port-channel']

    :type interface_name: unicode
    :param interface_name: **static_mac** tuple argument:  Interface identifier

    :type vlan: unicode
    :param vlan: **static_mac** tuple argument:  vlan

        * enumeration restriction: ::

            ['vlan']

    :type vlanid: long
    :param vlanid: **static_mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mac_address_table.static.static_mac', 'pybind.slxos.v16r_1_00b.brocade_mac_address_table', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'static_mac', 'keyval': 'mac_address, forward, interface_type, interface_name, vlan, vlanid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, static_mac=static_mac)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, static_mac=static_mac)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mac_group_delete(self, mac_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type mac_group: mac_group_id
    :param mac_group: Keyword argument tuple.

    :type mac_group_id: long
    :param mac_group_id: **mac_group** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.mac_group', 'pybind.nos.v6_0_2c.brocade_mac_address_table', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.mac_group', 'pybind.nos.v7_0_1b.brocade_mac_address_table', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.mac_group', 'pybind.nos.v7_1_0.brocade_mac_address_table', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.mac_group', 'pybind.slxos.v16r_1_00b.brocade_mac_address_table', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'mac_group', 'keyval': 'mac_group_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mac_group=mac_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mac_group=mac_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mac_group_mac_delete(self, mac_group=None, mac_group_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mac_group: mac_group_id
    :param mac_group: Keyword argument tuple.

    :type mac_group_id: long
    :param mac_group_id: **mac_group** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type mac_group_entry: entry_address
    :param mac_group_entry: Keyword argument tuple.

    :type entry_address: unicode
    :param entry_address: **mac_group_entry** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mac_group', 'mac_group'), ('pybind.nos.v7_1_0.mac_group', 'mac_group'), ('pybind.nos.v6_0_2c.mac_group', 'mac_group'), ('pybind.nos.v7_0_1b.mac_group', 'mac_group')]
    bindings_list = [('pybind.nos.v6_0_2c.mac_group.mac_group_entry', 'pybind.nos.v6_0_2c.brocade_mac_address_table', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.mac_group.mac_group_entry', 'pybind.nos.v7_0_1b.brocade_mac_address_table', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.mac_group.mac_group_entry', 'pybind.nos.v7_1_0.brocade_mac_address_table', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.mac_group.mac_group_entry', 'pybind.slxos.v16r_1_00b.brocade_mac_address_table', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'mac_group_id', 'extra_keyval': ''}, {'keyval': 'mac_group_id', 'extra_keyval': ''}, {'keyval': 'mac_group_id', 'extra_keyval': ''}, {'keyval': 'mac_group_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mac_group_entry', 'keyval': 'entry_address', 'extra_keyval': 'entry_address'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mac_group=mac_group, mac_group_entry=mac_group_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mac_group=mac_group, mac_group_entry=mac_group_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mct_l2ys_state_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mct_l2ys_state', 'pybind.slxos.v16r_1_00b.brocade_l2sys_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mct_l2ys_state_show_cluster_mem_vlan_delete(self, show_cluster_mem_vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type show_cluster_mem_vlan: cluster_id
    :param show_cluster_mem_vlan: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster_mem_vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mct_l2ys_state.show_cluster_mem_vlan', 'pybind.slxos.v16r_1_00b.brocade_l2sys_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'show_cluster_mem_vlan', 'keyval': 'cluster_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster_mem_vlan=show_cluster_mem_vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster_mem_vlan=show_cluster_mem_vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mct_l2ys_state_show_cluster_mem_vlan_num_vlans_delete(self, show_cluster_mem_vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type show_cluster_mem_vlan: cluster_id
    :param show_cluster_mem_vlan: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster_mem_vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mct_l2ys_state.show_cluster_mem_vlan', 'pybind.slxos.v16r_1_00b.brocade_l2sys_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'show_cluster_mem_vlan', 'keyval': 'cluster_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'num-vlans'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster_mem_vlan=show_cluster_mem_vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster_mem_vlan=show_cluster_mem_vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mct_l2ys_state_show_cluster_mem_vlan_vlan_label_info_delete(self, show_cluster_mem_vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type show_cluster_mem_vlan: cluster_id
    :param show_cluster_mem_vlan: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster_mem_vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mct_l2ys_state.show_cluster_mem_vlan', u'show_cluster_mem_vlan')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mct_l2ys_state.show_cluster_mem_vlan.vlan_label_info', 'pybind.slxos.v16r_1_00b.brocade_l2sys_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster_mem_vlan=show_cluster_mem_vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster_mem_vlan=show_cluster_mem_vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mct_l2ys_state_show_cluster_mem_vlan_vlan_label_info_unicast_label_local_delete(self, show_cluster_mem_vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type show_cluster_mem_vlan: cluster_id
    :param show_cluster_mem_vlan: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster_mem_vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mct_l2ys_state.show_cluster_mem_vlan', u'show_cluster_mem_vlan')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mct_l2ys_state.show_cluster_mem_vlan.vlan_label_info', 'pybind.slxos.v16r_1_00b.brocade_l2sys_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'unicast-label-local'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster_mem_vlan=show_cluster_mem_vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster_mem_vlan=show_cluster_mem_vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mct_l2ys_state_show_cluster_mem_vlan_vlan_label_info_unicast_label_remote_delete(self, show_cluster_mem_vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type show_cluster_mem_vlan: cluster_id
    :param show_cluster_mem_vlan: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster_mem_vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mct_l2ys_state.show_cluster_mem_vlan', u'show_cluster_mem_vlan')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mct_l2ys_state.show_cluster_mem_vlan.vlan_label_info', 'pybind.slxos.v16r_1_00b.brocade_l2sys_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'unicast-label-remote'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster_mem_vlan=show_cluster_mem_vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster_mem_vlan=show_cluster_mem_vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mct_l2ys_state_show_cluster_mem_vlan_vlan_label_info_vlan_id_delete(self, show_cluster_mem_vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type show_cluster_mem_vlan: cluster_id
    :param show_cluster_mem_vlan: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster_mem_vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mct_l2ys_state.show_cluster_mem_vlan', u'show_cluster_mem_vlan')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mct_l2ys_state.show_cluster_mem_vlan.vlan_label_info', 'pybind.slxos.v16r_1_00b.brocade_l2sys_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vlan-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster_mem_vlan=show_cluster_mem_vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster_mem_vlan=show_cluster_mem_vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mct_state_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mct_state', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mct_state_show_cluster_delete(self, show_cluster=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type show_cluster: cluster_id
    :param show_cluster: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mct_state.show_cluster', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'show_cluster', 'keyval': 'cluster_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster=show_cluster)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster=show_cluster)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mct_state_show_cluster_active_vlan_list_delete(self, show_cluster=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type show_cluster: cluster_id
    :param show_cluster: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mct_state.show_cluster', u'show_cluster')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mct_state.show_cluster.active_vlan_list', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster=show_cluster)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster=show_cluster)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mct_state_show_cluster_active_vlan_list_vlan_id_delete(self, show_cluster=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type show_cluster: cluster_id
    :param show_cluster: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mct_state.show_cluster', u'show_cluster')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mct_state.show_cluster.active_vlan_list', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vlan-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster=show_cluster)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster=show_cluster)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mct_state_show_cluster_client_info_list_delete(self, show_cluster=None, client_info_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type show_cluster: cluster_id
    :param show_cluster: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type client_info_list: cluster_id, client_id
    :param client_info_list: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **client_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type client_id: long
    :param client_id: **client_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mct_state.show_cluster', u'show_cluster')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mct_state.show_cluster.client_info_list', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'client_info_list', 'keyval': 'cluster_id, client_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster=show_cluster, client_info_list=client_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster=show_cluster, client_info_list=client_info_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mct_state_show_cluster_client_info_list_client_esi_delete(self, show_cluster=None, client_info_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type show_cluster: cluster_id
    :param show_cluster: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type client_info_list: cluster_id, client_id
    :param client_info_list: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **client_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type client_id: long
    :param client_id: **client_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mct_state.show_cluster', u'show_cluster')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mct_state.show_cluster.client_info_list', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'client_info_list', 'keyval': 'cluster_id, client_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'client-esi'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster=show_cluster, client_info_list=client_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster=show_cluster, client_info_list=client_info_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mct_state_show_cluster_client_info_list_client_interface_delete(self, show_cluster=None, client_info_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type show_cluster: cluster_id
    :param show_cluster: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type client_info_list: cluster_id, client_id
    :param client_info_list: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **client_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type client_id: long
    :param client_id: **client_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mct_state.show_cluster', u'show_cluster')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mct_state.show_cluster.client_info_list', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'client_info_list', 'keyval': 'cluster_id, client_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'client-interface'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster=show_cluster, client_info_list=client_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster=show_cluster, client_info_list=client_info_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mct_state_show_cluster_client_info_list_client_name_delete(self, show_cluster=None, client_info_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type show_cluster: cluster_id
    :param show_cluster: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type client_info_list: cluster_id, client_id
    :param client_info_list: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **client_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type client_id: long
    :param client_id: **client_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mct_state.show_cluster', u'show_cluster')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mct_state.show_cluster.client_info_list', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'client_info_list', 'keyval': 'cluster_id, client_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'client-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster=show_cluster, client_info_list=client_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster=show_cluster, client_info_list=client_info_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mct_state_show_cluster_client_info_list_client_state_delete(self, show_cluster=None, client_info_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type show_cluster: cluster_id
    :param show_cluster: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type client_info_list: cluster_id, client_id
    :param client_info_list: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **client_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type client_id: long
    :param client_id: **client_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mct_state.show_cluster', u'show_cluster')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mct_state.show_cluster.client_info_list', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'client_info_list', 'keyval': 'cluster_id, client_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'client-state'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster=show_cluster, client_info_list=client_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster=show_cluster, client_info_list=client_info_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mct_state_show_cluster_client_info_list_config_vlans_delete(self, show_cluster=None, client_info_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type show_cluster: cluster_id
    :param show_cluster: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type client_info_list: cluster_id, client_id
    :param client_info_list: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **client_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type client_id: long
    :param client_id: **client_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mct_state.show_cluster', u'show_cluster'), ('pybind.slxos.v16r_1_00b.mct_state.show_cluster.client_info_list', u'client_info_list')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mct_state.show_cluster.client_info_list.config_vlans', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_id', 'extra_keyval': ''}, {'keyval': 'cluster_id, client_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster=show_cluster, client_info_list=client_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster=show_cluster, client_info_list=client_info_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mct_state_show_cluster_client_info_list_config_vlans_vlan_id_delete(self, show_cluster=None, client_info_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type show_cluster: cluster_id
    :param show_cluster: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type client_info_list: cluster_id, client_id
    :param client_info_list: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **client_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type client_id: long
    :param client_id: **client_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mct_state.show_cluster', u'show_cluster'), ('pybind.slxos.v16r_1_00b.mct_state.show_cluster.client_info_list', u'client_info_list')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mct_state.show_cluster.client_info_list.config_vlans', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_id', 'extra_keyval': ''}, {'keyval': 'cluster_id, client_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vlan-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster=show_cluster, client_info_list=client_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster=show_cluster, client_info_list=client_info_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mct_state_show_cluster_client_info_list_num_config_vlans_delete(self, show_cluster=None, client_info_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type show_cluster: cluster_id
    :param show_cluster: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type client_info_list: cluster_id, client_id
    :param client_info_list: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **client_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type client_id: long
    :param client_id: **client_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mct_state.show_cluster', u'show_cluster')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mct_state.show_cluster.client_info_list', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'client_info_list', 'keyval': 'cluster_id, client_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'num-config-vlans'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster=show_cluster, client_info_list=client_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster=show_cluster, client_info_list=client_info_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mct_state_show_cluster_client_interfaces_shutdown_delete(self, show_cluster=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type show_cluster: cluster_id
    :param show_cluster: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mct_state.show_cluster', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'show_cluster', 'keyval': 'cluster_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'client-interfaces-shutdown'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster=show_cluster)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster=show_cluster)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mct_state_show_cluster_client_isolation_status_delete(self, show_cluster=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type show_cluster: cluster_id
    :param show_cluster: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mct_state.show_cluster', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'show_cluster', 'keyval': 'cluster_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'client-isolation-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster=show_cluster)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster=show_cluster)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mct_state_show_cluster_cluster_name_delete(self, show_cluster=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type show_cluster: cluster_id
    :param show_cluster: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mct_state.show_cluster', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'show_cluster', 'keyval': 'cluster_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cluster-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster=show_cluster)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster=show_cluster)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mct_state_show_cluster_cluster_status_delete(self, show_cluster=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type show_cluster: cluster_id
    :param show_cluster: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mct_state.show_cluster', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'show_cluster', 'keyval': 'cluster_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cluster-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster=show_cluster)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster=show_cluster)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mct_state_show_cluster_config_vlan_list_delete(self, show_cluster=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type show_cluster: cluster_id
    :param show_cluster: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mct_state.show_cluster', u'show_cluster')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mct_state.show_cluster.config_vlan_list', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster=show_cluster)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster=show_cluster)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mct_state_show_cluster_config_vlan_list_vlan_id_delete(self, show_cluster=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type show_cluster: cluster_id
    :param show_cluster: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mct_state.show_cluster', u'show_cluster')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mct_state.show_cluster.config_vlan_list', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vlan-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster=show_cluster)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster=show_cluster)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mct_state_show_cluster_is_cluster_client_command_delete(self, show_cluster=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type show_cluster: cluster_id
    :param show_cluster: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mct_state.show_cluster', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'show_cluster', 'keyval': 'cluster_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'is-cluster-client-command'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster=show_cluster)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster=show_cluster)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mct_state_show_cluster_num_active_vlans_delete(self, show_cluster=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type show_cluster: cluster_id
    :param show_cluster: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mct_state.show_cluster', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'show_cluster', 'keyval': 'cluster_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'num-active-vlans'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster=show_cluster)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster=show_cluster)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mct_state_show_cluster_num_clients_delete(self, show_cluster=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type show_cluster: cluster_id
    :param show_cluster: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mct_state.show_cluster', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'show_cluster', 'keyval': 'cluster_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'num-clients'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster=show_cluster)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster=show_cluster)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mct_state_show_cluster_num_config_vlans_delete(self, show_cluster=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type show_cluster: cluster_id
    :param show_cluster: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mct_state.show_cluster', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'show_cluster', 'keyval': 'cluster_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'num-config-vlans'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster=show_cluster)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster=show_cluster)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mct_state_show_cluster_num_peers_delete(self, show_cluster=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type show_cluster: cluster_id
    :param show_cluster: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mct_state.show_cluster', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'show_cluster', 'keyval': 'cluster_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'num-peers'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster=show_cluster)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster=show_cluster)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mct_state_show_cluster_peer_info_list_delete(self, show_cluster=None, peer_info_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type show_cluster: cluster_id
    :param show_cluster: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type peer_info_list: peer_ip_addr
    :param peer_info_list: Keyword argument tuple.

    :type peer_ip_addr: long
    :param peer_ip_addr: **peer_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mct_state.show_cluster', u'show_cluster')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mct_state.show_cluster.peer_info_list', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'peer_info_list', 'keyval': 'peer_ip_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster=show_cluster, peer_info_list=peer_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster=show_cluster, peer_info_list=peer_info_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mct_state_show_cluster_peer_info_list_peer_state_delete(self, show_cluster=None, peer_info_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type show_cluster: cluster_id
    :param show_cluster: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type peer_info_list: peer_ip_addr
    :param peer_info_list: Keyword argument tuple.

    :type peer_ip_addr: long
    :param peer_ip_addr: **peer_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mct_state.show_cluster', u'show_cluster')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mct_state.show_cluster.peer_info_list', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'peer_info_list', 'keyval': 'peer_ip_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'peer-state'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster=show_cluster, peer_info_list=peer_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster=show_cluster, peer_info_list=peer_info_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mctd_client_state_state_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mctd_client_state_state', 'pybind.slxos.v16r_1_00b.brocade_mct_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mctd_client_state_state_show_cluster_mctd_client_delete(self, show_cluster_mctd_client=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type show_cluster_mctd_client: cluster_id
    :param show_cluster_mctd_client: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster_mctd_client** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mctd_client_state_state.show_cluster_mctd_client', 'pybind.slxos.v16r_1_00b.brocade_mct_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'show_cluster_mctd_client', 'keyval': 'cluster_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster_mctd_client=show_cluster_mctd_client)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster_mctd_client=show_cluster_mctd_client)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mctd_client_state_state_show_cluster_mctd_client_client_state_info_delete(self, show_cluster_mctd_client=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type show_cluster_mctd_client: cluster_id
    :param show_cluster_mctd_client: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster_mctd_client** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mctd_client_state_state.show_cluster_mctd_client', u'show_cluster_mctd_client')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mctd_client_state_state.show_cluster_mctd_client.client_state_info', 'pybind.slxos.v16r_1_00b.brocade_mct_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster_mctd_client=show_cluster_mctd_client)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster_mctd_client=show_cluster_mctd_client)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mctd_client_state_state_show_cluster_mctd_client_client_state_info_client_id_delete(self, show_cluster_mctd_client=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type show_cluster_mctd_client: cluster_id
    :param show_cluster_mctd_client: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster_mctd_client** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mctd_client_state_state.show_cluster_mctd_client', u'show_cluster_mctd_client')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mctd_client_state_state.show_cluster_mctd_client.client_state_info', 'pybind.slxos.v16r_1_00b.brocade_mct_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'client-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster_mctd_client=show_cluster_mctd_client)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster_mctd_client=show_cluster_mctd_client)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mctd_client_state_state_show_cluster_mctd_client_client_state_info_client_name_delete(self, show_cluster_mctd_client=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type show_cluster_mctd_client: cluster_id
    :param show_cluster_mctd_client: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster_mctd_client** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mctd_client_state_state.show_cluster_mctd_client', u'show_cluster_mctd_client')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mctd_client_state_state.show_cluster_mctd_client.client_state_info', 'pybind.slxos.v16r_1_00b.brocade_mct_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'client-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster_mctd_client=show_cluster_mctd_client)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster_mctd_client=show_cluster_mctd_client)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mctd_client_state_state_show_cluster_mctd_client_client_state_info_local_esi_label_delete(self, show_cluster_mctd_client=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type show_cluster_mctd_client: cluster_id
    :param show_cluster_mctd_client: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster_mctd_client** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mctd_client_state_state.show_cluster_mctd_client', u'show_cluster_mctd_client')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mctd_client_state_state.show_cluster_mctd_client.client_state_info', 'pybind.slxos.v16r_1_00b.brocade_mct_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'local-esi-label'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster_mctd_client=show_cluster_mctd_client)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster_mctd_client=show_cluster_mctd_client)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mctd_client_state_state_show_cluster_mctd_client_client_state_info_local_state_delete(self, show_cluster_mctd_client=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type show_cluster_mctd_client: cluster_id
    :param show_cluster_mctd_client: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster_mctd_client** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mctd_client_state_state.show_cluster_mctd_client', u'show_cluster_mctd_client')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mctd_client_state_state.show_cluster_mctd_client.client_state_info', 'pybind.slxos.v16r_1_00b.brocade_mct_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'local-state'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster_mctd_client=show_cluster_mctd_client)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster_mctd_client=show_cluster_mctd_client)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mctd_client_state_state_show_cluster_mctd_client_client_state_info_remote_esi_label_delete(self, show_cluster_mctd_client=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type show_cluster_mctd_client: cluster_id
    :param show_cluster_mctd_client: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster_mctd_client** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mctd_client_state_state.show_cluster_mctd_client', u'show_cluster_mctd_client')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mctd_client_state_state.show_cluster_mctd_client.client_state_info', 'pybind.slxos.v16r_1_00b.brocade_mct_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'remote-esi-label'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster_mctd_client=show_cluster_mctd_client)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster_mctd_client=show_cluster_mctd_client)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mctd_client_state_state_show_cluster_mctd_client_client_state_info_remote_state_delete(self, show_cluster_mctd_client=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type show_cluster_mctd_client: cluster_id
    :param show_cluster_mctd_client: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster_mctd_client** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mctd_client_state_state.show_cluster_mctd_client', u'show_cluster_mctd_client')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mctd_client_state_state.show_cluster_mctd_client.client_state_info', 'pybind.slxos.v16r_1_00b.brocade_mct_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'remote-state'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster_mctd_client=show_cluster_mctd_client)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster_mctd_client=show_cluster_mctd_client)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mctd_client_state_state_show_cluster_mctd_client_num_clients_delete(self, show_cluster_mctd_client=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type show_cluster_mctd_client: cluster_id
    :param show_cluster_mctd_client: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster_mctd_client** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mctd_client_state_state.show_cluster_mctd_client', 'pybind.slxos.v16r_1_00b.brocade_mct_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'show_cluster_mctd_client', 'keyval': 'cluster_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'num-clients'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster_mctd_client=show_cluster_mctd_client)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster_mctd_client=show_cluster_mctd_client)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mctd_client_state_state_show_cluster_mem_vlan_delete(self, show_cluster_mem_vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type show_cluster_mem_vlan: cluster_id
    :param show_cluster_mem_vlan: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster_mem_vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mctd_client_state_state.show_cluster_mem_vlan', 'pybind.slxos.v16r_1_00b.brocade_mct_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'show_cluster_mem_vlan', 'keyval': 'cluster_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster_mem_vlan=show_cluster_mem_vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster_mem_vlan=show_cluster_mem_vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mctd_client_state_state_show_cluster_mem_vlan_num_vlans_delete(self, show_cluster_mem_vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type show_cluster_mem_vlan: cluster_id
    :param show_cluster_mem_vlan: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster_mem_vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mctd_client_state_state.show_cluster_mem_vlan', 'pybind.slxos.v16r_1_00b.brocade_mct_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'show_cluster_mem_vlan', 'keyval': 'cluster_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'num-vlans'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster_mem_vlan=show_cluster_mem_vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster_mem_vlan=show_cluster_mem_vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mctd_client_state_state_show_cluster_mem_vlan_vlan_label_info_delete(self, show_cluster_mem_vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type show_cluster_mem_vlan: cluster_id
    :param show_cluster_mem_vlan: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster_mem_vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mctd_client_state_state.show_cluster_mem_vlan', u'show_cluster_mem_vlan')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mctd_client_state_state.show_cluster_mem_vlan.vlan_label_info', 'pybind.slxos.v16r_1_00b.brocade_mct_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster_mem_vlan=show_cluster_mem_vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster_mem_vlan=show_cluster_mem_vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mctd_client_state_state_show_cluster_mem_vlan_vlan_label_info_mcast_label_local_delete(self, show_cluster_mem_vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type show_cluster_mem_vlan: cluster_id
    :param show_cluster_mem_vlan: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster_mem_vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mctd_client_state_state.show_cluster_mem_vlan', u'show_cluster_mem_vlan')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mctd_client_state_state.show_cluster_mem_vlan.vlan_label_info', 'pybind.slxos.v16r_1_00b.brocade_mct_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mcast-label-local'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster_mem_vlan=show_cluster_mem_vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster_mem_vlan=show_cluster_mem_vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mctd_client_state_state_show_cluster_mem_vlan_vlan_label_info_mcast_label_remote_delete(self, show_cluster_mem_vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type show_cluster_mem_vlan: cluster_id
    :param show_cluster_mem_vlan: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster_mem_vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mctd_client_state_state.show_cluster_mem_vlan', u'show_cluster_mem_vlan')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mctd_client_state_state.show_cluster_mem_vlan.vlan_label_info', 'pybind.slxos.v16r_1_00b.brocade_mct_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mcast-label-remote'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster_mem_vlan=show_cluster_mem_vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster_mem_vlan=show_cluster_mem_vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mctd_client_state_state_show_cluster_mem_vlan_vlan_label_info_vlan_id_delete(self, show_cluster_mem_vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type show_cluster_mem_vlan: cluster_id
    :param show_cluster_mem_vlan: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster_mem_vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mctd_client_state_state.show_cluster_mem_vlan', u'show_cluster_mem_vlan')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mctd_client_state_state.show_cluster_mem_vlan.vlan_label_info', 'pybind.slxos.v16r_1_00b.brocade_mct_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vlan-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster_mem_vlan=show_cluster_mem_vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster_mem_vlan=show_cluster_mem_vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mld_snooping_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.mld_snooping', 'pybind.nos.v6_0_2c.brocade_mld_snooping', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.mld_snooping', 'pybind.nos.v7_0_1b.brocade_mld_snooping', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.mld_snooping', 'pybind.nos.v7_1_0.brocade_mld_snooping', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.mld_snooping', 'pybind.slxos.v16r_1_00b.brocade_mld_snooping', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def monitor_session_delete(self, session=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type session: session_number
    :param session: Keyword argument tuple.

    :type session_number: long
    :param session_number: **session** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.monitor.session', 'pybind.nos.v6_0_2c.brocade_span', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.monitor.session', 'pybind.nos.v7_0_1b.brocade_span', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.monitor.session', 'pybind.nos.v7_1_0.brocade_span', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.monitor.session', 'pybind.slxos.v16r_1_00b.brocade_span', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'session', 'keyval': 'session_number', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, session=session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, session=session)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def monitor_session_description_delete(self, session=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type session: session_number
    :param session: Keyword argument tuple.

    :type session_number: long
    :param session_number: **session** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.monitor.session', 'pybind.nos.v6_0_2c.brocade_span', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.monitor.session', 'pybind.nos.v7_0_1b.brocade_span', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.monitor.session', 'pybind.nos.v7_1_0.brocade_span', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.monitor.session', 'pybind.slxos.v16r_1_00b.brocade_span', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'session', 'keyval': 'session_number', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'description'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, session=session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, session=session)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_config_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_auto_bandwidth_template_delete(self, auto_bandwidth_template=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type auto_bandwidth_template: name
    :param auto_bandwidth_template: Keyword argument tuple.

    :type name: unicode
    :param name: **auto_bandwidth_template** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.auto_bandwidth_template', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'auto_bandwidth_template', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, auto_bandwidth_template=auto_bandwidth_template)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, auto_bandwidth_template=auto_bandwidth_template)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_auto_bandwidth_template_adjustment_interval_delete(self, auto_bandwidth_template=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type auto_bandwidth_template: name
    :param auto_bandwidth_template: Keyword argument tuple.

    :type name: unicode
    :param name: **auto_bandwidth_template** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.auto_bandwidth_template', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'auto_bandwidth_template', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'adjustment-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, auto_bandwidth_template=auto_bandwidth_template)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, auto_bandwidth_template=auto_bandwidth_template)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_auto_bandwidth_template_adjustment_threshold_delete(self, auto_bandwidth_template=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type auto_bandwidth_template: name
    :param auto_bandwidth_template: Keyword argument tuple.

    :type name: unicode
    :param name: **auto_bandwidth_template** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.auto_bandwidth_template', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'auto_bandwidth_template', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'adjustment-threshold'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, auto_bandwidth_template=auto_bandwidth_template)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, auto_bandwidth_template=auto_bandwidth_template)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_auto_bandwidth_template_associated_paths_delete(self, auto_bandwidth_template=None, associated_paths=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type auto_bandwidth_template: name
    :param auto_bandwidth_template: Keyword argument tuple.

    :type name: unicode
    :param name: **auto_bandwidth_template** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type associated_paths: lsp_name
    :param associated_paths: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **associated_paths** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.auto_bandwidth_template', u'auto_bandwidth_template')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.auto_bandwidth_template.associated_paths', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'associated_paths', 'keyval': 'lsp_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, auto_bandwidth_template=auto_bandwidth_template, associated_paths=associated_paths)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, auto_bandwidth_template=auto_bandwidth_template, associated_paths=associated_paths)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_auto_bandwidth_template_associated_paths_count_delete(self, auto_bandwidth_template=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type auto_bandwidth_template: name
    :param auto_bandwidth_template: Keyword argument tuple.

    :type name: unicode
    :param name: **auto_bandwidth_template** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.auto_bandwidth_template', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'auto_bandwidth_template', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'associated-paths-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, auto_bandwidth_template=auto_bandwidth_template)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, auto_bandwidth_template=auto_bandwidth_template)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_auto_bandwidth_template_associated_paths_is_active_delete(self, auto_bandwidth_template=None, associated_paths=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type auto_bandwidth_template: name
    :param auto_bandwidth_template: Keyword argument tuple.

    :type name: unicode
    :param name: **auto_bandwidth_template** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type associated_paths: lsp_name
    :param associated_paths: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **associated_paths** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.auto_bandwidth_template', u'auto_bandwidth_template')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.auto_bandwidth_template.associated_paths', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'associated_paths', 'keyval': 'lsp_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'is-active'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, auto_bandwidth_template=auto_bandwidth_template, associated_paths=associated_paths)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, auto_bandwidth_template=auto_bandwidth_template, associated_paths=associated_paths)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_auto_bandwidth_template_associated_paths_path_name_delete(self, auto_bandwidth_template=None, associated_paths=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type auto_bandwidth_template: name
    :param auto_bandwidth_template: Keyword argument tuple.

    :type name: unicode
    :param name: **auto_bandwidth_template** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type associated_paths: lsp_name
    :param associated_paths: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **associated_paths** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.auto_bandwidth_template', u'auto_bandwidth_template')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.auto_bandwidth_template.associated_paths', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'associated_paths', 'keyval': 'lsp_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'path-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, auto_bandwidth_template=auto_bandwidth_template, associated_paths=associated_paths)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, auto_bandwidth_template=auto_bandwidth_template, associated_paths=associated_paths)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_auto_bandwidth_template_maximum_bandwidth_delete(self, auto_bandwidth_template=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type auto_bandwidth_template: name
    :param auto_bandwidth_template: Keyword argument tuple.

    :type name: unicode
    :param name: **auto_bandwidth_template** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.auto_bandwidth_template', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'auto_bandwidth_template', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'maximum-bandwidth'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, auto_bandwidth_template=auto_bandwidth_template)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, auto_bandwidth_template=auto_bandwidth_template)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_auto_bandwidth_template_minimum_bandwidth_delete(self, auto_bandwidth_template=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type auto_bandwidth_template: name
    :param auto_bandwidth_template: Keyword argument tuple.

    :type name: unicode
    :param name: **auto_bandwidth_template** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.auto_bandwidth_template', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'auto_bandwidth_template', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'minimum-bandwidth'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, auto_bandwidth_template=auto_bandwidth_template)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, auto_bandwidth_template=auto_bandwidth_template)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_auto_bandwidth_template_mode_delete(self, auto_bandwidth_template=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type auto_bandwidth_template: name
    :param auto_bandwidth_template: Keyword argument tuple.

    :type name: unicode
    :param name: **auto_bandwidth_template** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.auto_bandwidth_template', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'auto_bandwidth_template', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mode'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, auto_bandwidth_template=auto_bandwidth_template)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, auto_bandwidth_template=auto_bandwidth_template)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_auto_bandwidth_template_overflow_limit_delete(self, auto_bandwidth_template=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type auto_bandwidth_template: name
    :param auto_bandwidth_template: Keyword argument tuple.

    :type name: unicode
    :param name: **auto_bandwidth_template** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.auto_bandwidth_template', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'auto_bandwidth_template', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'overflow-limit'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, auto_bandwidth_template=auto_bandwidth_template)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, auto_bandwidth_template=auto_bandwidth_template)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_auto_bandwidth_template_sample_recording_delete(self, auto_bandwidth_template=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type auto_bandwidth_template: name
    :param auto_bandwidth_template: Keyword argument tuple.

    :type name: unicode
    :param name: **auto_bandwidth_template** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.auto_bandwidth_template', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'auto_bandwidth_template', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'sample-recording'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, auto_bandwidth_template=auto_bandwidth_template)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, auto_bandwidth_template=auto_bandwidth_template)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_auto_bandwidth_template_underflow_limit_delete(self, auto_bandwidth_template=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type auto_bandwidth_template: name
    :param auto_bandwidth_template: Keyword argument tuple.

    :type name: unicode
    :param name: **auto_bandwidth_template** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.auto_bandwidth_template', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'auto_bandwidth_template', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'underflow-limit'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, auto_bandwidth_template=auto_bandwidth_template)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, auto_bandwidth_template=auto_bandwidth_template)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_autobw_threshold_table_entry_delete(self, autobw_threshold_table_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type autobw_threshold_table_entry: bandwidth
    :param autobw_threshold_table_entry: Keyword argument tuple.

    :type bandwidth: long
    :param bandwidth: **autobw_threshold_table_entry** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.autobw_threshold_table_entry', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'autobw_threshold_table_entry', 'keyval': 'bandwidth', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, autobw_threshold_table_entry=autobw_threshold_table_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, autobw_threshold_table_entry=autobw_threshold_table_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_autobw_threshold_table_entry_is_percentage_threshold_delete(self, autobw_threshold_table_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type autobw_threshold_table_entry: bandwidth
    :param autobw_threshold_table_entry: Keyword argument tuple.

    :type bandwidth: long
    :param bandwidth: **autobw_threshold_table_entry** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.autobw_threshold_table_entry', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'autobw_threshold_table_entry', 'keyval': 'bandwidth', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'is-percentage-threshold'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, autobw_threshold_table_entry=autobw_threshold_table_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, autobw_threshold_table_entry=autobw_threshold_table_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_autobw_threshold_table_entry_threshold_delete(self, autobw_threshold_table_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type autobw_threshold_table_entry: bandwidth
    :param autobw_threshold_table_entry: Keyword argument tuple.

    :type bandwidth: long
    :param bandwidth: **autobw_threshold_table_entry** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.autobw_threshold_table_entry', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'autobw_threshold_table_entry', 'keyval': 'bandwidth', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'threshold'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, autobw_threshold_table_entry=autobw_threshold_table_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, autobw_threshold_table_entry=autobw_threshold_table_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_autobw_threshold_table_summary_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.autobw_threshold_table_summary', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_autobw_threshold_table_summary_total_number_of_autobw_threshold_table_entries_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.autobw_threshold_table_summary', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'total-number-of-autobw-threshold-table-entries'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_bfd_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.bfd', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_bfd_admin_status_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.bfd', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'admin-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_bfd_detection_time_multiplier_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.bfd', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'detection-time-multiplier'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_bfd_min_rx_interval_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.bfd', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'min-rx-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_bfd_min_tx_interval_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.bfd', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'min-tx-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_dynamic_bypass_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.dynamic_bypass', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_dynamic_bypass_dynamic_bypass_global_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.dynamic_bypass.dynamic_bypass_global', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_dynamic_bypass_dynamic_bypass_global_bypass_count_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.dynamic_bypass.dynamic_bypass_global', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bypass-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_dynamic_bypass_dynamic_bypass_global_config_enable_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.dynamic_bypass.dynamic_bypass_global', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_dynamic_bypass_dynamic_bypass_global_config_enable_all_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.dynamic_bypass.dynamic_bypass_global', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-enable-all'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_dynamic_bypass_dynamic_bypass_global_max_bypasses_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.dynamic_bypass.dynamic_bypass_global', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'max-bypasses'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_dynamic_bypass_dynamic_bypass_global_max_bypasses_per_mp_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.dynamic_bypass.dynamic_bypass_global', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'max-bypasses-per-mp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_dynamic_bypass_dynamic_bypass_global_reoptimize_timer_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.dynamic_bypass.dynamic_bypass_global', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'reoptimize-timer'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_dynamic_bypass_dynamic_bypass_interface_delete(self, dynamic_bypass_interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type dynamic_bypass_interface: if_name, if_type
    :param dynamic_bypass_interface: Keyword argument tuple.

    :type if_name: unicode
    :param if_name: **dynamic_bypass_interface** tuple argument.

    :type if_type: unicode
    :param if_type: **dynamic_bypass_interface** tuple argument.

        * enumeration restriction: ::

            ['loopback-interface',
            'ethernet-interface',
            'port-channel-interface',
            'unknown-interface',
            've-interface',
            'fbr-channel-interface']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.dynamic_bypass.dynamic_bypass_interface', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'dynamic_bypass_interface', 'keyval': 'if_name, if_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dynamic_bypass_interface=dynamic_bypass_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dynamic_bypass_interface=dynamic_bypass_interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_dynamic_bypass_dynamic_bypass_interface_active_status_delete(self, dynamic_bypass_interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type dynamic_bypass_interface: if_name, if_type
    :param dynamic_bypass_interface: Keyword argument tuple.

    :type if_name: unicode
    :param if_name: **dynamic_bypass_interface** tuple argument.

    :type if_type: unicode
    :param if_type: **dynamic_bypass_interface** tuple argument.

        * enumeration restriction: ::

            ['loopback-interface',
            'ethernet-interface',
            'port-channel-interface',
            'unknown-interface',
            've-interface',
            'fbr-channel-interface']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.dynamic_bypass.dynamic_bypass_interface', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'dynamic_bypass_interface', 'keyval': 'if_name, if_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'active-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dynamic_bypass_interface=dynamic_bypass_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dynamic_bypass_interface=dynamic_bypass_interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_dynamic_bypass_dynamic_bypass_interface_adaptive_delete(self, dynamic_bypass_interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type dynamic_bypass_interface: if_name, if_type
    :param dynamic_bypass_interface: Keyword argument tuple.

    :type if_name: unicode
    :param if_name: **dynamic_bypass_interface** tuple argument.

    :type if_type: unicode
    :param if_type: **dynamic_bypass_interface** tuple argument.

        * enumeration restriction: ::

            ['loopback-interface',
            'ethernet-interface',
            'port-channel-interface',
            'unknown-interface',
            've-interface',
            'fbr-channel-interface']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.dynamic_bypass.dynamic_bypass_interface', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'dynamic_bypass_interface', 'keyval': 'if_name, if_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'adaptive'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dynamic_bypass_interface=dynamic_bypass_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dynamic_bypass_interface=dynamic_bypass_interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_dynamic_bypass_dynamic_bypass_interface_admin_status_delete(self, dynamic_bypass_interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type dynamic_bypass_interface: if_name, if_type
    :param dynamic_bypass_interface: Keyword argument tuple.

    :type if_name: unicode
    :param if_name: **dynamic_bypass_interface** tuple argument.

    :type if_type: unicode
    :param if_type: **dynamic_bypass_interface** tuple argument.

        * enumeration restriction: ::

            ['loopback-interface',
            'ethernet-interface',
            'port-channel-interface',
            'unknown-interface',
            've-interface',
            'fbr-channel-interface']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.dynamic_bypass.dynamic_bypass_interface', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'dynamic_bypass_interface', 'keyval': 'if_name, if_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'admin-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dynamic_bypass_interface=dynamic_bypass_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dynamic_bypass_interface=dynamic_bypass_interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_dynamic_bypass_dynamic_bypass_interface_admin_type_delete(self, dynamic_bypass_interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type dynamic_bypass_interface: if_name, if_type
    :param dynamic_bypass_interface: Keyword argument tuple.

    :type if_name: unicode
    :param if_name: **dynamic_bypass_interface** tuple argument.

    :type if_type: unicode
    :param if_type: **dynamic_bypass_interface** tuple argument.

        * enumeration restriction: ::

            ['loopback-interface',
            'ethernet-interface',
            'port-channel-interface',
            'unknown-interface',
            've-interface',
            'fbr-channel-interface']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.dynamic_bypass.dynamic_bypass_interface', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'dynamic_bypass_interface', 'keyval': 'if_name, if_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'admin-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dynamic_bypass_interface=dynamic_bypass_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dynamic_bypass_interface=dynamic_bypass_interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_dynamic_bypass_dynamic_bypass_interface_bypass_count_delete(self, dynamic_bypass_interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type dynamic_bypass_interface: if_name, if_type
    :param dynamic_bypass_interface: Keyword argument tuple.

    :type if_name: unicode
    :param if_name: **dynamic_bypass_interface** tuple argument.

    :type if_type: unicode
    :param if_type: **dynamic_bypass_interface** tuple argument.

        * enumeration restriction: ::

            ['loopback-interface',
            'ethernet-interface',
            'port-channel-interface',
            'unknown-interface',
            've-interface',
            'fbr-channel-interface']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.dynamic_bypass.dynamic_bypass_interface', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'dynamic_bypass_interface', 'keyval': 'if_name, if_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bypass-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dynamic_bypass_interface=dynamic_bypass_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dynamic_bypass_interface=dynamic_bypass_interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_dynamic_bypass_dynamic_bypass_interface_cos_delete(self, dynamic_bypass_interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type dynamic_bypass_interface: if_name, if_type
    :param dynamic_bypass_interface: Keyword argument tuple.

    :type if_name: unicode
    :param if_name: **dynamic_bypass_interface** tuple argument.

    :type if_type: unicode
    :param if_type: **dynamic_bypass_interface** tuple argument.

        * enumeration restriction: ::

            ['loopback-interface',
            'ethernet-interface',
            'port-channel-interface',
            'unknown-interface',
            've-interface',
            'fbr-channel-interface']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.dynamic_bypass.dynamic_bypass_interface', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'dynamic_bypass_interface', 'keyval': 'if_name, if_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cos'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dynamic_bypass_interface=dynamic_bypass_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dynamic_bypass_interface=dynamic_bypass_interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_dynamic_bypass_dynamic_bypass_interface_cspf_comp_mode_delete(self, dynamic_bypass_interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type dynamic_bypass_interface: if_name, if_type
    :param dynamic_bypass_interface: Keyword argument tuple.

    :type if_name: unicode
    :param if_name: **dynamic_bypass_interface** tuple argument.

    :type if_type: unicode
    :param if_type: **dynamic_bypass_interface** tuple argument.

        * enumeration restriction: ::

            ['loopback-interface',
            'ethernet-interface',
            'port-channel-interface',
            'unknown-interface',
            've-interface',
            'fbr-channel-interface']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.dynamic_bypass.dynamic_bypass_interface', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'dynamic_bypass_interface', 'keyval': 'if_name, if_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cspf-comp-mode'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dynamic_bypass_interface=dynamic_bypass_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dynamic_bypass_interface=dynamic_bypass_interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_dynamic_bypass_dynamic_bypass_interface_exclude_any_delete(self, dynamic_bypass_interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type dynamic_bypass_interface: if_name, if_type
    :param dynamic_bypass_interface: Keyword argument tuple.

    :type if_name: unicode
    :param if_name: **dynamic_bypass_interface** tuple argument.

    :type if_type: unicode
    :param if_type: **dynamic_bypass_interface** tuple argument.

        * enumeration restriction: ::

            ['loopback-interface',
            'ethernet-interface',
            'port-channel-interface',
            'unknown-interface',
            've-interface',
            'fbr-channel-interface']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.dynamic_bypass.dynamic_bypass_interface', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'dynamic_bypass_interface', 'keyval': 'if_name, if_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'exclude-any'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dynamic_bypass_interface=dynamic_bypass_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dynamic_bypass_interface=dynamic_bypass_interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_dynamic_bypass_dynamic_bypass_interface_from_addr_delete(self, dynamic_bypass_interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type dynamic_bypass_interface: if_name, if_type
    :param dynamic_bypass_interface: Keyword argument tuple.

    :type if_name: unicode
    :param if_name: **dynamic_bypass_interface** tuple argument.

    :type if_type: unicode
    :param if_type: **dynamic_bypass_interface** tuple argument.

        * enumeration restriction: ::

            ['loopback-interface',
            'ethernet-interface',
            'port-channel-interface',
            'unknown-interface',
            've-interface',
            'fbr-channel-interface']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.dynamic_bypass.dynamic_bypass_interface', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'dynamic_bypass_interface', 'keyval': 'if_name, if_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'from-addr'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dynamic_bypass_interface=dynamic_bypass_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dynamic_bypass_interface=dynamic_bypass_interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_dynamic_bypass_dynamic_bypass_interface_hold_priority_delete(self, dynamic_bypass_interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type dynamic_bypass_interface: if_name, if_type
    :param dynamic_bypass_interface: Keyword argument tuple.

    :type if_name: unicode
    :param if_name: **dynamic_bypass_interface** tuple argument.

    :type if_type: unicode
    :param if_type: **dynamic_bypass_interface** tuple argument.

        * enumeration restriction: ::

            ['loopback-interface',
            'ethernet-interface',
            'port-channel-interface',
            'unknown-interface',
            've-interface',
            'fbr-channel-interface']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.dynamic_bypass.dynamic_bypass_interface', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'dynamic_bypass_interface', 'keyval': 'if_name, if_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hold-priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dynamic_bypass_interface=dynamic_bypass_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dynamic_bypass_interface=dynamic_bypass_interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_dynamic_bypass_dynamic_bypass_interface_hop_limit_delete(self, dynamic_bypass_interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type dynamic_bypass_interface: if_name, if_type
    :param dynamic_bypass_interface: Keyword argument tuple.

    :type if_name: unicode
    :param if_name: **dynamic_bypass_interface** tuple argument.

    :type if_type: unicode
    :param if_type: **dynamic_bypass_interface** tuple argument.

        * enumeration restriction: ::

            ['loopback-interface',
            'ethernet-interface',
            'port-channel-interface',
            'unknown-interface',
            've-interface',
            'fbr-channel-interface']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.dynamic_bypass.dynamic_bypass_interface', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'dynamic_bypass_interface', 'keyval': 'if_name, if_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hop-limit'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dynamic_bypass_interface=dynamic_bypass_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dynamic_bypass_interface=dynamic_bypass_interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_dynamic_bypass_dynamic_bypass_interface_include_all_delete(self, dynamic_bypass_interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type dynamic_bypass_interface: if_name, if_type
    :param dynamic_bypass_interface: Keyword argument tuple.

    :type if_name: unicode
    :param if_name: **dynamic_bypass_interface** tuple argument.

    :type if_type: unicode
    :param if_type: **dynamic_bypass_interface** tuple argument.

        * enumeration restriction: ::

            ['loopback-interface',
            'ethernet-interface',
            'port-channel-interface',
            'unknown-interface',
            've-interface',
            'fbr-channel-interface']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.dynamic_bypass.dynamic_bypass_interface', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'dynamic_bypass_interface', 'keyval': 'if_name, if_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'include-all'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dynamic_bypass_interface=dynamic_bypass_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dynamic_bypass_interface=dynamic_bypass_interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_dynamic_bypass_dynamic_bypass_interface_include_any_delete(self, dynamic_bypass_interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type dynamic_bypass_interface: if_name, if_type
    :param dynamic_bypass_interface: Keyword argument tuple.

    :type if_name: unicode
    :param if_name: **dynamic_bypass_interface** tuple argument.

    :type if_type: unicode
    :param if_type: **dynamic_bypass_interface** tuple argument.

        * enumeration restriction: ::

            ['loopback-interface',
            'ethernet-interface',
            'port-channel-interface',
            'unknown-interface',
            've-interface',
            'fbr-channel-interface']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.dynamic_bypass.dynamic_bypass_interface', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'dynamic_bypass_interface', 'keyval': 'if_name, if_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'include-any'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dynamic_bypass_interface=dynamic_bypass_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dynamic_bypass_interface=dynamic_bypass_interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_dynamic_bypass_dynamic_bypass_interface_max_bypasses_per_mp_delete(self, dynamic_bypass_interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type dynamic_bypass_interface: if_name, if_type
    :param dynamic_bypass_interface: Keyword argument tuple.

    :type if_name: unicode
    :param if_name: **dynamic_bypass_interface** tuple argument.

    :type if_type: unicode
    :param if_type: **dynamic_bypass_interface** tuple argument.

        * enumeration restriction: ::

            ['loopback-interface',
            'ethernet-interface',
            'port-channel-interface',
            'unknown-interface',
            've-interface',
            'fbr-channel-interface']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.dynamic_bypass.dynamic_bypass_interface', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'dynamic_bypass_interface', 'keyval': 'if_name, if_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'max-bypasses-per-mp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dynamic_bypass_interface=dynamic_bypass_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dynamic_bypass_interface=dynamic_bypass_interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_dynamic_bypass_dynamic_bypass_interface_mp_count_delete(self, dynamic_bypass_interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type dynamic_bypass_interface: if_name, if_type
    :param dynamic_bypass_interface: Keyword argument tuple.

    :type if_name: unicode
    :param if_name: **dynamic_bypass_interface** tuple argument.

    :type if_type: unicode
    :param if_type: **dynamic_bypass_interface** tuple argument.

        * enumeration restriction: ::

            ['loopback-interface',
            'ethernet-interface',
            'port-channel-interface',
            'unknown-interface',
            've-interface',
            'fbr-channel-interface']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.dynamic_bypass.dynamic_bypass_interface', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'dynamic_bypass_interface', 'keyval': 'if_name, if_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mp-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dynamic_bypass_interface=dynamic_bypass_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dynamic_bypass_interface=dynamic_bypass_interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_dynamic_bypass_dynamic_bypass_interface_mp_infos_delete(self, dynamic_bypass_interface=None, mp_infos=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type dynamic_bypass_interface: if_name, if_type
    :param dynamic_bypass_interface: Keyword argument tuple.

    :type if_name: unicode
    :param if_name: **dynamic_bypass_interface** tuple argument.

    :type if_type: unicode
    :param if_type: **dynamic_bypass_interface** tuple argument.

        * enumeration restriction: ::

            ['loopback-interface',
            'ethernet-interface',
            'port-channel-interface',
            'unknown-interface',
            've-interface',
            'fbr-channel-interface']

    **Instance Keyword Argument Tuple**:

    :type mp_infos: router_id
    :param mp_infos: Keyword argument tuple.

    :type router_id: unicode
    :param router_id: **mp_infos** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.dynamic_bypass.dynamic_bypass_interface', u'dynamic_bypass_interface')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.dynamic_bypass.dynamic_bypass_interface.mp_infos', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'if_name, if_type', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mp_infos', 'keyval': 'router_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dynamic_bypass_interface=dynamic_bypass_interface, mp_infos=mp_infos)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dynamic_bypass_interface=dynamic_bypass_interface, mp_infos=mp_infos)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_dynamic_bypass_dynamic_bypass_interface_mp_infos_bypass_count_delete(self, dynamic_bypass_interface=None, mp_infos=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type dynamic_bypass_interface: if_name, if_type
    :param dynamic_bypass_interface: Keyword argument tuple.

    :type if_name: unicode
    :param if_name: **dynamic_bypass_interface** tuple argument.

    :type if_type: unicode
    :param if_type: **dynamic_bypass_interface** tuple argument.

        * enumeration restriction: ::

            ['loopback-interface',
            'ethernet-interface',
            'port-channel-interface',
            'unknown-interface',
            've-interface',
            'fbr-channel-interface']

    **Instance Keyword Argument Tuple**:

    :type mp_infos: router_id
    :param mp_infos: Keyword argument tuple.

    :type router_id: unicode
    :param router_id: **mp_infos** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.dynamic_bypass.dynamic_bypass_interface', u'dynamic_bypass_interface')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.dynamic_bypass.dynamic_bypass_interface.mp_infos', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'if_name, if_type', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mp_infos', 'keyval': 'router_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bypass-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dynamic_bypass_interface=dynamic_bypass_interface, mp_infos=mp_infos)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dynamic_bypass_interface=dynamic_bypass_interface, mp_infos=mp_infos)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_dynamic_bypass_dynamic_bypass_interface_name_prefix_delete(self, dynamic_bypass_interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type dynamic_bypass_interface: if_name, if_type
    :param dynamic_bypass_interface: Keyword argument tuple.

    :type if_name: unicode
    :param if_name: **dynamic_bypass_interface** tuple argument.

    :type if_type: unicode
    :param if_type: **dynamic_bypass_interface** tuple argument.

        * enumeration restriction: ::

            ['loopback-interface',
            'ethernet-interface',
            'port-channel-interface',
            'unknown-interface',
            've-interface',
            'fbr-channel-interface']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.dynamic_bypass.dynamic_bypass_interface', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'dynamic_bypass_interface', 'keyval': 'if_name, if_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'name-prefix'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dynamic_bypass_interface=dynamic_bypass_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dynamic_bypass_interface=dynamic_bypass_interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_dynamic_bypass_dynamic_bypass_interface_primary_path_delete(self, dynamic_bypass_interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type dynamic_bypass_interface: if_name, if_type
    :param dynamic_bypass_interface: Keyword argument tuple.

    :type if_name: unicode
    :param if_name: **dynamic_bypass_interface** tuple argument.

    :type if_type: unicode
    :param if_type: **dynamic_bypass_interface** tuple argument.

        * enumeration restriction: ::

            ['loopback-interface',
            'ethernet-interface',
            'port-channel-interface',
            'unknown-interface',
            've-interface',
            'fbr-channel-interface']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.dynamic_bypass.dynamic_bypass_interface', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'dynamic_bypass_interface', 'keyval': 'if_name, if_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'primary-path'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dynamic_bypass_interface=dynamic_bypass_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dynamic_bypass_interface=dynamic_bypass_interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_dynamic_bypass_dynamic_bypass_interface_record_route_delete(self, dynamic_bypass_interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type dynamic_bypass_interface: if_name, if_type
    :param dynamic_bypass_interface: Keyword argument tuple.

    :type if_name: unicode
    :param if_name: **dynamic_bypass_interface** tuple argument.

    :type if_type: unicode
    :param if_type: **dynamic_bypass_interface** tuple argument.

        * enumeration restriction: ::

            ['loopback-interface',
            'ethernet-interface',
            'port-channel-interface',
            'unknown-interface',
            've-interface',
            'fbr-channel-interface']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.dynamic_bypass.dynamic_bypass_interface', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'dynamic_bypass_interface', 'keyval': 'if_name, if_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'record-route'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dynamic_bypass_interface=dynamic_bypass_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dynamic_bypass_interface=dynamic_bypass_interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_dynamic_bypass_dynamic_bypass_interface_reoptimize_timer_delete(self, dynamic_bypass_interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type dynamic_bypass_interface: if_name, if_type
    :param dynamic_bypass_interface: Keyword argument tuple.

    :type if_name: unicode
    :param if_name: **dynamic_bypass_interface** tuple argument.

    :type if_type: unicode
    :param if_type: **dynamic_bypass_interface** tuple argument.

        * enumeration restriction: ::

            ['loopback-interface',
            'ethernet-interface',
            'port-channel-interface',
            'unknown-interface',
            've-interface',
            'fbr-channel-interface']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.dynamic_bypass.dynamic_bypass_interface', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'dynamic_bypass_interface', 'keyval': 'if_name, if_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'reoptimize-timer'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dynamic_bypass_interface=dynamic_bypass_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dynamic_bypass_interface=dynamic_bypass_interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_dynamic_bypass_dynamic_bypass_interface_setup_priority_delete(self, dynamic_bypass_interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type dynamic_bypass_interface: if_name, if_type
    :param dynamic_bypass_interface: Keyword argument tuple.

    :type if_name: unicode
    :param if_name: **dynamic_bypass_interface** tuple argument.

    :type if_type: unicode
    :param if_type: **dynamic_bypass_interface** tuple argument.

        * enumeration restriction: ::

            ['loopback-interface',
            'ethernet-interface',
            'port-channel-interface',
            'unknown-interface',
            've-interface',
            'fbr-channel-interface']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.dynamic_bypass.dynamic_bypass_interface', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'dynamic_bypass_interface', 'keyval': 'if_name, if_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'setup-priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dynamic_bypass_interface=dynamic_bypass_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dynamic_bypass_interface=dynamic_bypass_interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_dynamic_bypass_dynamic_bypass_interface_status_flags_delete(self, dynamic_bypass_interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type dynamic_bypass_interface: if_name, if_type
    :param dynamic_bypass_interface: Keyword argument tuple.

    :type if_name: unicode
    :param if_name: **dynamic_bypass_interface** tuple argument.

    :type if_type: unicode
    :param if_type: **dynamic_bypass_interface** tuple argument.

        * enumeration restriction: ::

            ['loopback-interface',
            'ethernet-interface',
            'port-channel-interface',
            'unknown-interface',
            've-interface',
            'fbr-channel-interface']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.dynamic_bypass.dynamic_bypass_interface', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'dynamic_bypass_interface', 'keyval': 'if_name, if_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'status-flags'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dynamic_bypass_interface=dynamic_bypass_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dynamic_bypass_interface=dynamic_bypass_interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_dynamic_bypass_dynamic_bypass_interface_tie_breaking_delete(self, dynamic_bypass_interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type dynamic_bypass_interface: if_name, if_type
    :param dynamic_bypass_interface: Keyword argument tuple.

    :type if_name: unicode
    :param if_name: **dynamic_bypass_interface** tuple argument.

    :type if_type: unicode
    :param if_type: **dynamic_bypass_interface** tuple argument.

        * enumeration restriction: ::

            ['loopback-interface',
            'ethernet-interface',
            'port-channel-interface',
            'unknown-interface',
            've-interface',
            'fbr-channel-interface']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.dynamic_bypass.dynamic_bypass_interface', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'dynamic_bypass_interface', 'keyval': 'if_name, if_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tie-breaking'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dynamic_bypass_interface=dynamic_bypass_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dynamic_bypass_interface=dynamic_bypass_interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_dynamic_bypass_dynamic_bypass_interface_traffic_eng_max_burst_delete(self, dynamic_bypass_interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type dynamic_bypass_interface: if_name, if_type
    :param dynamic_bypass_interface: Keyword argument tuple.

    :type if_name: unicode
    :param if_name: **dynamic_bypass_interface** tuple argument.

    :type if_type: unicode
    :param if_type: **dynamic_bypass_interface** tuple argument.

        * enumeration restriction: ::

            ['loopback-interface',
            'ethernet-interface',
            'port-channel-interface',
            'unknown-interface',
            've-interface',
            'fbr-channel-interface']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.dynamic_bypass.dynamic_bypass_interface', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'dynamic_bypass_interface', 'keyval': 'if_name, if_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'traffic-eng-max-burst'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dynamic_bypass_interface=dynamic_bypass_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dynamic_bypass_interface=dynamic_bypass_interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_dynamic_bypass_dynamic_bypass_interface_traffic_eng_max_rate_delete(self, dynamic_bypass_interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type dynamic_bypass_interface: if_name, if_type
    :param dynamic_bypass_interface: Keyword argument tuple.

    :type if_name: unicode
    :param if_name: **dynamic_bypass_interface** tuple argument.

    :type if_type: unicode
    :param if_type: **dynamic_bypass_interface** tuple argument.

        * enumeration restriction: ::

            ['loopback-interface',
            'ethernet-interface',
            'port-channel-interface',
            'unknown-interface',
            've-interface',
            'fbr-channel-interface']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.dynamic_bypass.dynamic_bypass_interface', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'dynamic_bypass_interface', 'keyval': 'if_name, if_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'traffic-eng-max-rate'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dynamic_bypass_interface=dynamic_bypass_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dynamic_bypass_interface=dynamic_bypass_interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_dynamic_bypass_dynamic_bypass_interface_traffic_eng_mean_rate_delete(self, dynamic_bypass_interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type dynamic_bypass_interface: if_name, if_type
    :param dynamic_bypass_interface: Keyword argument tuple.

    :type if_name: unicode
    :param if_name: **dynamic_bypass_interface** tuple argument.

    :type if_type: unicode
    :param if_type: **dynamic_bypass_interface** tuple argument.

        * enumeration restriction: ::

            ['loopback-interface',
            'ethernet-interface',
            'port-channel-interface',
            'unknown-interface',
            've-interface',
            'fbr-channel-interface']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.dynamic_bypass.dynamic_bypass_interface', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'dynamic_bypass_interface', 'keyval': 'if_name, if_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'traffic-eng-mean-rate'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dynamic_bypass_interface=dynamic_bypass_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dynamic_bypass_interface=dynamic_bypass_interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_forwarding_entry_delete(self, forwarding_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type forwarding_entry: entry_index, sync_index
    :param forwarding_entry: Keyword argument tuple.

    :type entry_index: long
    :param entry_index: **forwarding_entry** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type sync_index: long
    :param sync_index: **forwarding_entry** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.forwarding_entry', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'forwarding_entry', 'keyval': 'entry_index, sync_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, forwarding_entry=forwarding_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, forwarding_entry=forwarding_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_forwarding_entry_dest_ip_prefix_delete(self, forwarding_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type forwarding_entry: entry_index, sync_index
    :param forwarding_entry: Keyword argument tuple.

    :type entry_index: long
    :param entry_index: **forwarding_entry** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type sync_index: long
    :param sync_index: **forwarding_entry** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.forwarding_entry', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'forwarding_entry', 'keyval': 'entry_index, sync_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dest-ip-prefix'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, forwarding_entry=forwarding_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, forwarding_entry=forwarding_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_forwarding_entry_in_label_delete(self, forwarding_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type forwarding_entry: entry_index, sync_index
    :param forwarding_entry: Keyword argument tuple.

    :type entry_index: long
    :param entry_index: **forwarding_entry** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type sync_index: long
    :param sync_index: **forwarding_entry** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.forwarding_entry', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'forwarding_entry', 'keyval': 'entry_index, sync_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'in-label'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, forwarding_entry=forwarding_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, forwarding_entry=forwarding_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_forwarding_entry_nexthop_ip_addr_delete(self, forwarding_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type forwarding_entry: entry_index, sync_index
    :param forwarding_entry: Keyword argument tuple.

    :type entry_index: long
    :param entry_index: **forwarding_entry** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type sync_index: long
    :param sync_index: **forwarding_entry** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.forwarding_entry', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'forwarding_entry', 'keyval': 'entry_index, sync_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'nexthop-ip-addr'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, forwarding_entry=forwarding_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, forwarding_entry=forwarding_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_forwarding_entry_out_interface_name_delete(self, forwarding_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type forwarding_entry: entry_index, sync_index
    :param forwarding_entry: Keyword argument tuple.

    :type entry_index: long
    :param entry_index: **forwarding_entry** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type sync_index: long
    :param sync_index: **forwarding_entry** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.forwarding_entry', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'forwarding_entry', 'keyval': 'entry_index, sync_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'out-interface-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, forwarding_entry=forwarding_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, forwarding_entry=forwarding_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_forwarding_entry_out_label_delete(self, forwarding_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type forwarding_entry: entry_index, sync_index
    :param forwarding_entry: Keyword argument tuple.

    :type entry_index: long
    :param entry_index: **forwarding_entry** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type sync_index: long
    :param sync_index: **forwarding_entry** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.forwarding_entry', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'forwarding_entry', 'keyval': 'entry_index, sync_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'out-label'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, forwarding_entry=forwarding_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, forwarding_entry=forwarding_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_forwarding_entry_protocol_delete(self, forwarding_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type forwarding_entry: entry_index, sync_index
    :param forwarding_entry: Keyword argument tuple.

    :type entry_index: long
    :param entry_index: **forwarding_entry** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type sync_index: long
    :param sync_index: **forwarding_entry** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.forwarding_entry', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'forwarding_entry', 'keyval': 'entry_index, sync_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'protocol'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, forwarding_entry=forwarding_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, forwarding_entry=forwarding_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_forwarding_entry_type_delete(self, forwarding_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type forwarding_entry: entry_index, sync_index
    :param forwarding_entry: Keyword argument tuple.

    :type entry_index: long
    :param entry_index: **forwarding_entry** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type sync_index: long
    :param sync_index: **forwarding_entry** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.forwarding_entry', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'forwarding_entry', 'keyval': 'entry_index, sync_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, forwarding_entry=forwarding_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, forwarding_entry=forwarding_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_interface_delete(self, interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type interface: interface_index
    :param interface: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **interface** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.interface', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interface=interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_interface_admin_group_delete(self, interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type interface: interface_index
    :param interface: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **interface** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.interface', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'admin-group'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interface=interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_interface_admin_group_max_delete(self, interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type interface: interface_index
    :param interface: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **interface** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.interface', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'admin-group-max'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interface=interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_interface_admin_group_min_delete(self, interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type interface: interface_index
    :param interface: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **interface** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.interface', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'admin-group-min'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interface=interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_interface_admin_status_delete(self, interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type interface: interface_index
    :param interface: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **interface** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.interface', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'admin-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interface=interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_interface_bypass_lsp_count_delete(self, interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type interface: interface_index
    :param interface: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **interface** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.interface', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bypass-lsp-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interface=interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_interface_interface_name_delete(self, interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type interface: interface_index
    :param interface: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **interface** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.interface', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'interface-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interface=interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_interface_is_gre_port_delete(self, interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type interface: interface_index
    :param interface: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **interface** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.interface', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'is-gre-port'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interface=interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_interface_is_ldp_enabled_delete(self, interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type interface: interface_index
    :param interface: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **interface** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.interface', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'is-ldp-enabled'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interface=interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_interface_ldp_transit_tunnel_count_delete(self, interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type interface: interface_index
    :param interface: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **interface** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.interface', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ldp-transit-tunnel-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interface=interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_interface_ldp_tunnel_count_delete(self, interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type interface: interface_index
    :param interface: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **interface** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.interface', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ldp-tunnel-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interface=interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_interface_max_bandwidth_delete(self, interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type interface: interface_index
    :param interface: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **interface** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.interface', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'max-bandwidth'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interface=interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_interface_max_lsp_priority_level_delete(self, interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type interface: interface_index
    :param interface: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **interface** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.interface', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'max-lsp-priority-level'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interface=interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_interface_max_resv_bandwidth_delete(self, interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type interface: interface_index
    :param interface: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **interface** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.interface', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'max-resv-bandwidth'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interface=interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_interface_max_resv_bandwidth_percentage_delete(self, interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type interface: interface_index
    :param interface: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **interface** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.interface', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'max-resv-bandwidth-percentage'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interface=interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_interface_mtu_delete(self, interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type interface: interface_index
    :param interface: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **interface** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.interface', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mtu'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interface=interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_interface_oper_status_delete(self, interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type interface: interface_index
    :param interface: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **interface** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.interface', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'oper-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interface=interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_interface_te_metric_delete(self, interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type interface: interface_index
    :param interface: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **interface** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.interface', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'te-metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interface=interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_delete(self, ldp_fec_prefix_longer=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_fec_prefix_longer', 'keyval': 'prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_key_delete(self, ldp_fec_prefix_longer=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer.key', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_key_data_fec_type_delete(self, ldp_fec_prefix_longer=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer.key', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'data-fec-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_key_inet_addr_delete(self, ldp_fec_prefix_longer=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer.key', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'inet-addr'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_key_inet_addr_len_delete(self, ldp_fec_prefix_longer=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer.key', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'inet-addr-len'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_key_inet_addr_type_delete(self, ldp_fec_prefix_longer=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer.key', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'inet-addr-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_key_prefix_len_delete(self, ldp_fec_prefix_longer=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer.key', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'prefix-len'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_key_type_delete(self, ldp_fec_prefix_longer=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer.key', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_key_vc_agi_len_delete(self, ldp_fec_prefix_longer=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer.key', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vc-agi-len'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_key_vc_agi_offset_delete(self, ldp_fec_prefix_longer=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer.key', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vc-agi-offset'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_key_vc_control_word_config_delete(self, ldp_fec_prefix_longer=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer.key', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vc-control-word-config'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_key_vc_gen_id_delete(self, ldp_fec_prefix_longer=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer.key', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vc-gen-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_key_vc_gen_id_size_delete(self, ldp_fec_prefix_longer=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer.key', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vc-gen-id-size'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_key_vc_group_id_delete(self, ldp_fec_prefix_longer=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer.key', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vc-group-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_key_vc_id_delete(self, ldp_fec_prefix_longer=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer.key', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vc-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_key_vc_ldp_peer_id_delete(self, ldp_fec_prefix_longer=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer.key', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vc-ldp-peer-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_key_vc_saii_len_delete(self, ldp_fec_prefix_longer=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer.key', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vc-saii-len'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_key_vc_saii_offset_delete(self, ldp_fec_prefix_longer=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer.key', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vc-saii-offset'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_key_vc_taii_len_delete(self, ldp_fec_prefix_longer=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer.key', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vc-taii-len'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_key_vc_taii_offset_delete(self, ldp_fec_prefix_longer=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer.key', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vc-taii-offset'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_key_vc_type_delete(self, ldp_fec_prefix_longer=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer.key', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vc-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_key_vc_use_control_word_delete(self, ldp_fec_prefix_longer=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer.key', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vc-use-control-word'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_prefix_prefix_delete(self, ldp_fec_prefix_longer=None, prefix_prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type prefix_prefix: prefix
    :param prefix_prefix: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **prefix_prefix** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_prefix', 'keyval': 'prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_prefix_prefix_prefix_downstream_delete(self, ldp_fec_prefix_longer=None, prefix_prefix=None, prefix_downstream=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    :type prefix_prefix: prefix
    :param prefix_prefix: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **prefix_prefix** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type prefix_downstream: local_ldp_id
    :param prefix_downstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **prefix_downstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer'), ('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix', u'prefix_prefix')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix.prefix_downstream', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}, {'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_downstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix, prefix_downstream=prefix_downstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix, prefix_downstream=prefix_downstream)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_prefix_prefix_prefix_downstream_fec_dm_state_dw_delete(self, ldp_fec_prefix_longer=None, prefix_prefix=None, prefix_downstream=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    :type prefix_prefix: prefix
    :param prefix_prefix: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **prefix_prefix** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type prefix_downstream: local_ldp_id
    :param prefix_downstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **prefix_downstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer'), ('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix', u'prefix_prefix')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix.prefix_downstream', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}, {'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_downstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'fec-dm-state-dw'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix, prefix_downstream=prefix_downstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix, prefix_downstream=prefix_downstream)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_prefix_prefix_prefix_downstream_fec_filtered_state_delete(self, ldp_fec_prefix_longer=None, prefix_prefix=None, prefix_downstream=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    :type prefix_prefix: prefix
    :param prefix_prefix: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **prefix_prefix** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type prefix_downstream: local_ldp_id
    :param prefix_downstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **prefix_downstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer'), ('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix', u'prefix_prefix')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix.prefix_downstream', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}, {'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_downstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'fec-filtered-state'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix, prefix_downstream=prefix_downstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix, prefix_downstream=prefix_downstream)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_prefix_prefix_prefix_downstream_fec_stale_delete(self, ldp_fec_prefix_longer=None, prefix_prefix=None, prefix_downstream=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    :type prefix_prefix: prefix
    :param prefix_prefix: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **prefix_prefix** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type prefix_downstream: local_ldp_id
    :param prefix_downstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **prefix_downstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer'), ('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix', u'prefix_prefix')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix.prefix_downstream', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}, {'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_downstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'fec-stale'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix, prefix_downstream=prefix_downstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix, prefix_downstream=prefix_downstream)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_prefix_prefix_prefix_downstream_feccb_delete(self, ldp_fec_prefix_longer=None, prefix_prefix=None, prefix_downstream=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    :type prefix_prefix: prefix
    :param prefix_prefix: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **prefix_prefix** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type prefix_downstream: local_ldp_id
    :param prefix_downstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **prefix_downstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer'), ('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix', u'prefix_prefix')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix.prefix_downstream', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}, {'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_downstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'feccb'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix, prefix_downstream=prefix_downstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix, prefix_downstream=prefix_downstream)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_prefix_prefix_prefix_downstream_label_delete(self, ldp_fec_prefix_longer=None, prefix_prefix=None, prefix_downstream=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    :type prefix_prefix: prefix
    :param prefix_prefix: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **prefix_prefix** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type prefix_downstream: local_ldp_id
    :param prefix_downstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **prefix_downstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer'), ('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix', u'prefix_prefix')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix.prefix_downstream', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}, {'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_downstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'label'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix, prefix_downstream=prefix_downstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix, prefix_downstream=prefix_downstream)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_prefix_prefix_prefix_downstream_local_ldp_lblspc_delete(self, ldp_fec_prefix_longer=None, prefix_prefix=None, prefix_downstream=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    :type prefix_prefix: prefix
    :param prefix_prefix: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **prefix_prefix** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type prefix_downstream: local_ldp_id
    :param prefix_downstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **prefix_downstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer'), ('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix', u'prefix_prefix')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix.prefix_downstream', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}, {'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_downstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'local-ldp-lblspc'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix, prefix_downstream=prefix_downstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix, prefix_downstream=prefix_downstream)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_prefix_prefix_prefix_downstream_peer_ldp_id_delete(self, ldp_fec_prefix_longer=None, prefix_prefix=None, prefix_downstream=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    :type prefix_prefix: prefix
    :param prefix_prefix: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **prefix_prefix** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type prefix_downstream: local_ldp_id
    :param prefix_downstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **prefix_downstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer'), ('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix', u'prefix_prefix')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix.prefix_downstream', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}, {'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_downstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'peer-ldp-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix, prefix_downstream=prefix_downstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix, prefix_downstream=prefix_downstream)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_prefix_prefix_prefix_downstream_peer_ldp_lblspc_delete(self, ldp_fec_prefix_longer=None, prefix_prefix=None, prefix_downstream=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    :type prefix_prefix: prefix
    :param prefix_prefix: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **prefix_prefix** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type prefix_downstream: local_ldp_id
    :param prefix_downstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **prefix_downstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer'), ('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix', u'prefix_prefix')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix.prefix_downstream', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}, {'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_downstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'peer-ldp-lblspc'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix, prefix_downstream=prefix_downstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix, prefix_downstream=prefix_downstream)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_prefix_prefix_prefix_downstream_state_delete(self, ldp_fec_prefix_longer=None, prefix_prefix=None, prefix_downstream=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    :type prefix_prefix: prefix
    :param prefix_prefix: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **prefix_prefix** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type prefix_downstream: local_ldp_id
    :param prefix_downstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **prefix_downstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer'), ('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix', u'prefix_prefix')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix.prefix_downstream', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}, {'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_downstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'state'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix, prefix_downstream=prefix_downstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix, prefix_downstream=prefix_downstream)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_prefix_prefix_prefix_egress_delete(self, ldp_fec_prefix_longer=None, prefix_prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type prefix_prefix: prefix
    :param prefix_prefix: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **prefix_prefix** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_prefix', 'keyval': 'prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'prefix-egress'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_prefix_prefix_prefix_excess_dms_delete(self, ldp_fec_prefix_longer=None, prefix_prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type prefix_prefix: prefix
    :param prefix_prefix: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **prefix_prefix** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_prefix', 'keyval': 'prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'prefix-excess-dms'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_prefix_prefix_prefix_feccb_delete(self, ldp_fec_prefix_longer=None, prefix_prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type prefix_prefix: prefix
    :param prefix_prefix: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **prefix_prefix** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_prefix', 'keyval': 'prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'prefix-feccb'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_prefix_prefix_prefix_idx_delete(self, ldp_fec_prefix_longer=None, prefix_prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type prefix_prefix: prefix
    :param prefix_prefix: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **prefix_prefix** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_prefix', 'keyval': 'prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'prefix-idx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_prefix_prefix_prefix_ingress_delete(self, ldp_fec_prefix_longer=None, prefix_prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type prefix_prefix: prefix
    :param prefix_prefix: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **prefix_prefix** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_prefix', 'keyval': 'prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'prefix-ingress'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_prefix_prefix_prefix_is_ldp_o_rsvp_delete(self, ldp_fec_prefix_longer=None, prefix_prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type prefix_prefix: prefix
    :param prefix_prefix: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **prefix_prefix** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_prefix', 'keyval': 'prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'prefix-is-ldp-o-rsvp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_prefix_prefix_prefix_lwd_delete(self, ldp_fec_prefix_longer=None, prefix_prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type prefix_prefix: prefix
    :param prefix_prefix: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **prefix_prefix** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_prefix', 'keyval': 'prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'prefix-lwd'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_prefix_prefix_prefix_lwd_started_delete(self, ldp_fec_prefix_longer=None, prefix_prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type prefix_prefix: prefix
    :param prefix_prefix: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **prefix_prefix** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_prefix', 'keyval': 'prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'prefix-lwd-started'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_prefix_prefix_prefix_nexthops_delete(self, ldp_fec_prefix_longer=None, prefix_prefix=None, prefix_nexthops=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    :type prefix_prefix: prefix
    :param prefix_prefix: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **prefix_prefix** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type prefix_nexthops: nexthop
    :param prefix_nexthops: Keyword argument tuple.

    :type nexthop: unicode
    :param nexthop: **prefix_nexthops** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer'), ('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix', u'prefix_prefix')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix.prefix_nexthops', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}, {'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_nexthops', 'keyval': 'nexthop', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix, prefix_nexthops=prefix_nexthops)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix, prefix_nexthops=prefix_nexthops)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_prefix_prefix_prefix_nexthops_out_intf_delete(self, ldp_fec_prefix_longer=None, prefix_prefix=None, prefix_nexthops=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    :type prefix_prefix: prefix
    :param prefix_prefix: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **prefix_prefix** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type prefix_nexthops: nexthop
    :param prefix_nexthops: Keyword argument tuple.

    :type nexthop: unicode
    :param nexthop: **prefix_nexthops** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer'), ('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix', u'prefix_prefix')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix.prefix_nexthops', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}, {'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_nexthops', 'keyval': 'nexthop', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'out-intf'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix, prefix_nexthops=prefix_nexthops)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix, prefix_nexthops=prefix_nexthops)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_prefix_prefix_prefix_pend_notif_delete(self, ldp_fec_prefix_longer=None, prefix_prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type prefix_prefix: prefix
    :param prefix_prefix: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **prefix_prefix** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_prefix', 'keyval': 'prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'prefix-pend-notif'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_prefix_prefix_prefix_state_delete(self, ldp_fec_prefix_longer=None, prefix_prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type prefix_prefix: prefix
    :param prefix_prefix: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **prefix_prefix** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_prefix', 'keyval': 'prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'prefix-state'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_prefix_prefix_prefix_type_delete(self, ldp_fec_prefix_longer=None, prefix_prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type prefix_prefix: prefix
    :param prefix_prefix: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **prefix_prefix** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_prefix', 'keyval': 'prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'prefix-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_prefix_prefix_prefix_um_dist_done_delete(self, ldp_fec_prefix_longer=None, prefix_prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type prefix_prefix: prefix
    :param prefix_prefix: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **prefix_prefix** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_prefix', 'keyval': 'prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'prefix-um-dist-done'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_prefix_prefix_prefix_upstream_delete(self, ldp_fec_prefix_longer=None, prefix_prefix=None, prefix_upstream=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    :type prefix_prefix: prefix
    :param prefix_prefix: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **prefix_prefix** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type prefix_upstream: local_ldp_id
    :param prefix_upstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **prefix_upstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer'), ('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix', u'prefix_prefix')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix.prefix_upstream', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}, {'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_upstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix, prefix_upstream=prefix_upstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix, prefix_upstream=prefix_upstream)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_prefix_prefix_prefix_upstream_fec_dm_state_dw_delete(self, ldp_fec_prefix_longer=None, prefix_prefix=None, prefix_upstream=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    :type prefix_prefix: prefix
    :param prefix_prefix: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **prefix_prefix** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type prefix_upstream: local_ldp_id
    :param prefix_upstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **prefix_upstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer'), ('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix', u'prefix_prefix')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix.prefix_upstream', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}, {'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_upstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'fec-dm-state-dw'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix, prefix_upstream=prefix_upstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix, prefix_upstream=prefix_upstream)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_prefix_prefix_prefix_upstream_fec_filtered_state_delete(self, ldp_fec_prefix_longer=None, prefix_prefix=None, prefix_upstream=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    :type prefix_prefix: prefix
    :param prefix_prefix: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **prefix_prefix** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type prefix_upstream: local_ldp_id
    :param prefix_upstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **prefix_upstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer'), ('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix', u'prefix_prefix')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix.prefix_upstream', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}, {'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_upstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'fec-filtered-state'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix, prefix_upstream=prefix_upstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix, prefix_upstream=prefix_upstream)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_prefix_prefix_prefix_upstream_fec_stale_delete(self, ldp_fec_prefix_longer=None, prefix_prefix=None, prefix_upstream=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    :type prefix_prefix: prefix
    :param prefix_prefix: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **prefix_prefix** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type prefix_upstream: local_ldp_id
    :param prefix_upstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **prefix_upstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer'), ('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix', u'prefix_prefix')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix.prefix_upstream', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}, {'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_upstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'fec-stale'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix, prefix_upstream=prefix_upstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix, prefix_upstream=prefix_upstream)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_prefix_prefix_prefix_upstream_feccb_delete(self, ldp_fec_prefix_longer=None, prefix_prefix=None, prefix_upstream=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    :type prefix_prefix: prefix
    :param prefix_prefix: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **prefix_prefix** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type prefix_upstream: local_ldp_id
    :param prefix_upstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **prefix_upstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer'), ('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix', u'prefix_prefix')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix.prefix_upstream', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}, {'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_upstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'feccb'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix, prefix_upstream=prefix_upstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix, prefix_upstream=prefix_upstream)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_prefix_prefix_prefix_upstream_label_delete(self, ldp_fec_prefix_longer=None, prefix_prefix=None, prefix_upstream=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    :type prefix_prefix: prefix
    :param prefix_prefix: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **prefix_prefix** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type prefix_upstream: local_ldp_id
    :param prefix_upstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **prefix_upstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer'), ('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix', u'prefix_prefix')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix.prefix_upstream', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}, {'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_upstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'label'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix, prefix_upstream=prefix_upstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix, prefix_upstream=prefix_upstream)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_prefix_prefix_prefix_upstream_local_ldp_lblspc_delete(self, ldp_fec_prefix_longer=None, prefix_prefix=None, prefix_upstream=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    :type prefix_prefix: prefix
    :param prefix_prefix: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **prefix_prefix** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type prefix_upstream: local_ldp_id
    :param prefix_upstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **prefix_upstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer'), ('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix', u'prefix_prefix')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix.prefix_upstream', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}, {'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_upstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'local-ldp-lblspc'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix, prefix_upstream=prefix_upstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix, prefix_upstream=prefix_upstream)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_prefix_prefix_prefix_upstream_peer_ldp_id_delete(self, ldp_fec_prefix_longer=None, prefix_prefix=None, prefix_upstream=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    :type prefix_prefix: prefix
    :param prefix_prefix: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **prefix_prefix** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type prefix_upstream: local_ldp_id
    :param prefix_upstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **prefix_upstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer'), ('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix', u'prefix_prefix')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix.prefix_upstream', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}, {'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_upstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'peer-ldp-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix, prefix_upstream=prefix_upstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix, prefix_upstream=prefix_upstream)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_prefix_prefix_prefix_upstream_peer_ldp_lblspc_delete(self, ldp_fec_prefix_longer=None, prefix_prefix=None, prefix_upstream=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    :type prefix_prefix: prefix
    :param prefix_prefix: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **prefix_prefix** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type prefix_upstream: local_ldp_id
    :param prefix_upstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **prefix_upstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer'), ('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix', u'prefix_prefix')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix.prefix_upstream', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}, {'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_upstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'peer-ldp-lblspc'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix, prefix_upstream=prefix_upstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix, prefix_upstream=prefix_upstream)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_prefix_prefix_prefix_upstream_state_delete(self, ldp_fec_prefix_longer=None, prefix_prefix=None, prefix_upstream=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    :type prefix_prefix: prefix
    :param prefix_prefix: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **prefix_prefix** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type prefix_upstream: local_ldp_id
    :param prefix_upstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **prefix_upstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer'), ('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix', u'prefix_prefix')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix.prefix_upstream', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}, {'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_upstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'state'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix, prefix_upstream=prefix_upstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix, prefix_upstream=prefix_upstream)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_prefix_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_prefix', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_prefix_prefix_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_prefix', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'prefix'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_prefix_prefix_downstream_delete(self, prefix_downstream=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type prefix_downstream: local_ldp_id
    :param prefix_downstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **prefix_downstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_prefix.prefix_downstream', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'prefix_downstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, prefix_downstream=prefix_downstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, prefix_downstream=prefix_downstream)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_prefix_prefix_downstream_fec_dm_state_dw_delete(self, prefix_downstream=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type prefix_downstream: local_ldp_id
    :param prefix_downstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **prefix_downstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_prefix.prefix_downstream', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'prefix_downstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'fec-dm-state-dw'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, prefix_downstream=prefix_downstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, prefix_downstream=prefix_downstream)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_prefix_prefix_downstream_fec_filtered_state_delete(self, prefix_downstream=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type prefix_downstream: local_ldp_id
    :param prefix_downstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **prefix_downstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_prefix.prefix_downstream', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'prefix_downstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'fec-filtered-state'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, prefix_downstream=prefix_downstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, prefix_downstream=prefix_downstream)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_prefix_prefix_downstream_fec_stale_delete(self, prefix_downstream=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type prefix_downstream: local_ldp_id
    :param prefix_downstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **prefix_downstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_prefix.prefix_downstream', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'prefix_downstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'fec-stale'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, prefix_downstream=prefix_downstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, prefix_downstream=prefix_downstream)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_prefix_prefix_downstream_feccb_delete(self, prefix_downstream=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type prefix_downstream: local_ldp_id
    :param prefix_downstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **prefix_downstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_prefix.prefix_downstream', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'prefix_downstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'feccb'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, prefix_downstream=prefix_downstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, prefix_downstream=prefix_downstream)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_prefix_prefix_downstream_label_delete(self, prefix_downstream=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type prefix_downstream: local_ldp_id
    :param prefix_downstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **prefix_downstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_prefix.prefix_downstream', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'prefix_downstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'label'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, prefix_downstream=prefix_downstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, prefix_downstream=prefix_downstream)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_prefix_prefix_downstream_local_ldp_lblspc_delete(self, prefix_downstream=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type prefix_downstream: local_ldp_id
    :param prefix_downstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **prefix_downstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_prefix.prefix_downstream', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'prefix_downstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'local-ldp-lblspc'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, prefix_downstream=prefix_downstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, prefix_downstream=prefix_downstream)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_prefix_prefix_downstream_peer_ldp_id_delete(self, prefix_downstream=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type prefix_downstream: local_ldp_id
    :param prefix_downstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **prefix_downstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_prefix.prefix_downstream', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'prefix_downstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'peer-ldp-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, prefix_downstream=prefix_downstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, prefix_downstream=prefix_downstream)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_prefix_prefix_downstream_peer_ldp_lblspc_delete(self, prefix_downstream=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type prefix_downstream: local_ldp_id
    :param prefix_downstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **prefix_downstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_prefix.prefix_downstream', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'prefix_downstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'peer-ldp-lblspc'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, prefix_downstream=prefix_downstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, prefix_downstream=prefix_downstream)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_prefix_prefix_downstream_state_delete(self, prefix_downstream=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type prefix_downstream: local_ldp_id
    :param prefix_downstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **prefix_downstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_prefix.prefix_downstream', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'prefix_downstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'state'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, prefix_downstream=prefix_downstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, prefix_downstream=prefix_downstream)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_prefix_prefix_egress_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_prefix', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'prefix-egress'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_prefix_prefix_excess_dms_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_prefix', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'prefix-excess-dms'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_prefix_prefix_feccb_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_prefix', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'prefix-feccb'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_prefix_prefix_idx_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_prefix', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'prefix-idx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_prefix_prefix_ingress_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_prefix', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'prefix-ingress'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_prefix_prefix_is_ldp_o_rsvp_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_prefix', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'prefix-is-ldp-o-rsvp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_prefix_prefix_lwd_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_prefix', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'prefix-lwd'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_prefix_prefix_lwd_started_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_prefix', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'prefix-lwd-started'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_prefix_prefix_nexthops_delete(self, prefix_nexthops=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type prefix_nexthops: nexthop
    :param prefix_nexthops: Keyword argument tuple.

    :type nexthop: unicode
    :param nexthop: **prefix_nexthops** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_prefix.prefix_nexthops', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'prefix_nexthops', 'keyval': 'nexthop', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, prefix_nexthops=prefix_nexthops)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, prefix_nexthops=prefix_nexthops)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_prefix_prefix_nexthops_out_intf_delete(self, prefix_nexthops=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type prefix_nexthops: nexthop
    :param prefix_nexthops: Keyword argument tuple.

    :type nexthop: unicode
    :param nexthop: **prefix_nexthops** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_prefix.prefix_nexthops', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'prefix_nexthops', 'keyval': 'nexthop', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'out-intf'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, prefix_nexthops=prefix_nexthops)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, prefix_nexthops=prefix_nexthops)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_prefix_prefix_pend_notif_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_prefix', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'prefix-pend-notif'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_prefix_prefix_state_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_prefix', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'prefix-state'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_prefix_prefix_type_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_prefix', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'prefix-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_prefix_prefix_um_dist_done_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_prefix', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'prefix-um-dist-done'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_prefix_prefix_upstream_delete(self, prefix_upstream=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type prefix_upstream: local_ldp_id
    :param prefix_upstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **prefix_upstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_prefix.prefix_upstream', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'prefix_upstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, prefix_upstream=prefix_upstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, prefix_upstream=prefix_upstream)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_prefix_prefix_upstream_fec_dm_state_dw_delete(self, prefix_upstream=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type prefix_upstream: local_ldp_id
    :param prefix_upstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **prefix_upstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_prefix.prefix_upstream', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'prefix_upstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'fec-dm-state-dw'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, prefix_upstream=prefix_upstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, prefix_upstream=prefix_upstream)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_prefix_prefix_upstream_fec_filtered_state_delete(self, prefix_upstream=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type prefix_upstream: local_ldp_id
    :param prefix_upstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **prefix_upstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_prefix.prefix_upstream', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'prefix_upstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'fec-filtered-state'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, prefix_upstream=prefix_upstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, prefix_upstream=prefix_upstream)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_prefix_prefix_upstream_fec_stale_delete(self, prefix_upstream=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type prefix_upstream: local_ldp_id
    :param prefix_upstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **prefix_upstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_prefix.prefix_upstream', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'prefix_upstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'fec-stale'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, prefix_upstream=prefix_upstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, prefix_upstream=prefix_upstream)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_prefix_prefix_upstream_feccb_delete(self, prefix_upstream=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type prefix_upstream: local_ldp_id
    :param prefix_upstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **prefix_upstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_prefix.prefix_upstream', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'prefix_upstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'feccb'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, prefix_upstream=prefix_upstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, prefix_upstream=prefix_upstream)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_prefix_prefix_upstream_label_delete(self, prefix_upstream=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type prefix_upstream: local_ldp_id
    :param prefix_upstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **prefix_upstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_prefix.prefix_upstream', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'prefix_upstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'label'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, prefix_upstream=prefix_upstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, prefix_upstream=prefix_upstream)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_prefix_prefix_upstream_local_ldp_lblspc_delete(self, prefix_upstream=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type prefix_upstream: local_ldp_id
    :param prefix_upstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **prefix_upstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_prefix.prefix_upstream', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'prefix_upstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'local-ldp-lblspc'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, prefix_upstream=prefix_upstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, prefix_upstream=prefix_upstream)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_prefix_prefix_upstream_peer_ldp_id_delete(self, prefix_upstream=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type prefix_upstream: local_ldp_id
    :param prefix_upstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **prefix_upstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_prefix.prefix_upstream', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'prefix_upstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'peer-ldp-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, prefix_upstream=prefix_upstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, prefix_upstream=prefix_upstream)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_prefix_prefix_upstream_peer_ldp_lblspc_delete(self, prefix_upstream=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type prefix_upstream: local_ldp_id
    :param prefix_upstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **prefix_upstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_prefix.prefix_upstream', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'prefix_upstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'peer-ldp-lblspc'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, prefix_upstream=prefix_upstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, prefix_upstream=prefix_upstream)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_prefix_prefix_upstream_state_delete(self, prefix_upstream=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type prefix_upstream: local_ldp_id
    :param prefix_upstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **prefix_upstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefix_prefix.prefix_upstream', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'prefix_upstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'state'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, prefix_upstream=prefix_upstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, prefix_upstream=prefix_upstream)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefixes_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefixes', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefixes_filtered_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefixes', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'filtered'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefixes_key_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefixes.key', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefixes_key_data_fec_type_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefixes.key', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'data-fec-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefixes_key_inet_addr_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefixes.key', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'inet-addr'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefixes_key_inet_addr_len_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefixes.key', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'inet-addr-len'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefixes_key_inet_addr_type_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefixes.key', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'inet-addr-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefixes_key_prefix_len_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefixes.key', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'prefix-len'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefixes_key_type_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefixes.key', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefixes_key_vc_agi_len_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefixes.key', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vc-agi-len'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefixes_key_vc_agi_offset_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefixes.key', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vc-agi-offset'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefixes_key_vc_control_word_config_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefixes.key', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vc-control-word-config'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefixes_key_vc_gen_id_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefixes.key', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vc-gen-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefixes_key_vc_gen_id_size_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefixes.key', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vc-gen-id-size'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefixes_key_vc_group_id_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefixes.key', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vc-group-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefixes_key_vc_id_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefixes.key', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vc-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefixes_key_vc_ldp_peer_id_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefixes.key', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vc-ldp-peer-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefixes_key_vc_saii_len_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefixes.key', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vc-saii-len'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefixes_key_vc_saii_offset_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefixes.key', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vc-saii-offset'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefixes_key_vc_taii_len_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefixes.key', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vc-taii-len'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefixes_key_vc_taii_offset_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefixes.key', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vc-taii-offset'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefixes_key_vc_type_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefixes.key', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vc-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefixes_key_vc_use_control_word_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefixes.key', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vc-use-control-word'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefixes_prefix_delete(self, prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type prefix: destination
    :param prefix: Keyword argument tuple.

    :type destination: unicode
    :param destination: **prefix** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefixes.prefix', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'prefix', 'keyval': 'destination', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, prefix=prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefixes_prefix_egress_delete(self, prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type prefix: destination
    :param prefix: Keyword argument tuple.

    :type destination: unicode
    :param destination: **prefix** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefixes.prefix', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'prefix', 'keyval': 'destination', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'egress'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, prefix=prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefixes_prefix_filtered_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefixes', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'prefix-filtered'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefixes_prefix_filtered_prefix_delete(self, prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type prefix: destination
    :param prefix: Keyword argument tuple.

    :type destination: unicode
    :param destination: **prefix** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefixes.prefix', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'prefix', 'keyval': 'destination', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'filtered'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, prefix=prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefixes_prefix_ingress_delete(self, prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type prefix: destination
    :param prefix: Keyword argument tuple.

    :type destination: unicode
    :param destination: **prefix** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefixes.prefix', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'prefix', 'keyval': 'destination', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ingress'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, prefix=prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefixes_prefix_lwd_delete(self, prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type prefix: destination
    :param prefix: Keyword argument tuple.

    :type destination: unicode
    :param destination: **prefix** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefixes.prefix', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'prefix', 'keyval': 'destination', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lwd'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, prefix=prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefixes_prefix_nexthops_delete(self, prefix=None, nexthops=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type prefix: destination
    :param prefix: Keyword argument tuple.

    :type destination: unicode
    :param destination: **prefix** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type nexthops: nexthop
    :param nexthops: Keyword argument tuple.

    :type nexthop: unicode
    :param nexthop: **nexthops** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefixes.prefix', u'prefix')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefixes.prefix.nexthops', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'destination', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'nexthops', 'keyval': 'nexthop', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, prefix=prefix, nexthops=nexthops)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, prefix=prefix, nexthops=nexthops)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefixes_prefix_nexthops_out_intf_delete(self, prefix=None, nexthops=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type prefix: destination
    :param prefix: Keyword argument tuple.

    :type destination: unicode
    :param destination: **prefix** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type nexthops: nexthop
    :param nexthops: Keyword argument tuple.

    :type nexthop: unicode
    :param nexthop: **nexthops** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefixes.prefix', u'prefix')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefixes.prefix.nexthops', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'destination', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'nexthops', 'keyval': 'nexthop', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'out-intf'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, prefix=prefix, nexthops=nexthops)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, prefix=prefix, nexthops=nexthops)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefixes_prefix_state_delete(self, prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type prefix: destination
    :param prefix: Keyword argument tuple.

    :type destination: unicode
    :param destination: **prefix** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefixes.prefix', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'prefix', 'keyval': 'destination', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'state'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, prefix=prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefixes_tot_no_of_prefix_fec_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefixes', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tot-no-of-prefix-fec'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefixes_tot_no_of_prefix_fec_filtered_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefixes', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tot-no-of-prefix-fec-filtered'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefixes_tot_no_of_prefix_fec_installed_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefixes', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tot-no-of-prefix-fec-installed'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefixes_tot_no_of_prefix_fec_lwd_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_prefixes', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tot-no-of-prefix-fec-lwd'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_summary_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_summary', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_summary_tot_no_of_prefix_fec_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_summary', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tot-no-of-prefix-fec'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_summary_tot_no_of_prefix_fec_filtered_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_summary', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tot-no-of-prefix-fec-filtered'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_summary_tot_no_of_prefix_fec_installed_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_summary', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tot-no-of-prefix-fec-installed'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_summary_tot_no_of_route_upd_proc_errors_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_summary', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tot-no-of-route-upd-proc-errors'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_summary_tot_no_of_vc_fec_128_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_summary', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tot-no-of-vc-fec-128'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_summary_tot_no_of_vc_fec_129_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_summary', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tot-no-of-vc-fec-129'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_summary_tot_no_of_vc_fec_installed_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_summary', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tot-no-of-vc-fec-installed'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_summary_tot_no_of_vc_fec_proc_errors_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_summary', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tot-no-of-vc-fec-proc-errors'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcid_delete(self, ldp_fec_vcid=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ldp_fec_vcid: vc_id
    :param ldp_fec_vcid: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vcid** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_vcid', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_fec_vcid', 'keyval': 'vc_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vcid=ldp_fec_vcid)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vcid=ldp_fec_vcid)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcid_prefix_egress_delete(self, ldp_fec_vcid=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ldp_fec_vcid: vc_id
    :param ldp_fec_vcid: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vcid** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_vcid', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_fec_vcid', 'keyval': 'vc_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'prefix-egress'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vcid=ldp_fec_vcid)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vcid=ldp_fec_vcid)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcid_prefix_ingress_delete(self, ldp_fec_vcid=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ldp_fec_vcid: vc_id
    :param ldp_fec_vcid: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vcid** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_vcid', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_fec_vcid', 'keyval': 'vc_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'prefix-ingress'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vcid=ldp_fec_vcid)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vcid=ldp_fec_vcid)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcid_prefix_pend_notif_delete(self, ldp_fec_vcid=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ldp_fec_vcid: vc_id
    :param ldp_fec_vcid: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vcid** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_vcid', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_fec_vcid', 'keyval': 'vc_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'prefix-pend-notif'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vcid=ldp_fec_vcid)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vcid=ldp_fec_vcid)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcid_prefix_state_delete(self, ldp_fec_vcid=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ldp_fec_vcid: vc_id
    :param ldp_fec_vcid: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vcid** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_vcid', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_fec_vcid', 'keyval': 'vc_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'prefix-state'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vcid=ldp_fec_vcid)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vcid=ldp_fec_vcid)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcid_prefix_um_dist_done_delete(self, ldp_fec_vcid=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ldp_fec_vcid: vc_id
    :param ldp_fec_vcid: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vcid** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_vcid', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_fec_vcid', 'keyval': 'vc_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'prefix-um-dist-done'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vcid=ldp_fec_vcid)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vcid=ldp_fec_vcid)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcid_vc_agi_delete(self, ldp_fec_vcid=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ldp_fec_vcid: vc_id
    :param ldp_fec_vcid: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vcid** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_vcid', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_fec_vcid', 'keyval': 'vc_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vc-agi'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vcid=ldp_fec_vcid)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vcid=ldp_fec_vcid)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcid_vc_downstream_delete(self, ldp_fec_vcid=None, vc_downstream=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_vcid: vc_id
    :param ldp_fec_vcid: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vcid** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vc_downstream: local_ldp_id
    :param vc_downstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **vc_downstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_vcid', u'ldp_fec_vcid')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_vcid.vc_downstream', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vc_downstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vcid=ldp_fec_vcid, vc_downstream=vc_downstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vcid=ldp_fec_vcid, vc_downstream=vc_downstream)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcid_vc_downstream_fec_dm_state_dw_delete(self, ldp_fec_vcid=None, vc_downstream=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_vcid: vc_id
    :param ldp_fec_vcid: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vcid** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vc_downstream: local_ldp_id
    :param vc_downstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **vc_downstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_vcid', u'ldp_fec_vcid')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_vcid.vc_downstream', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vc_downstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'fec-dm-state-dw'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vcid=ldp_fec_vcid, vc_downstream=vc_downstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vcid=ldp_fec_vcid, vc_downstream=vc_downstream)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcid_vc_downstream_fec_filtered_state_delete(self, ldp_fec_vcid=None, vc_downstream=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_vcid: vc_id
    :param ldp_fec_vcid: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vcid** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vc_downstream: local_ldp_id
    :param vc_downstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **vc_downstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_vcid', u'ldp_fec_vcid')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_vcid.vc_downstream', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vc_downstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'fec-filtered-state'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vcid=ldp_fec_vcid, vc_downstream=vc_downstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vcid=ldp_fec_vcid, vc_downstream=vc_downstream)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcid_vc_downstream_fec_stale_delete(self, ldp_fec_vcid=None, vc_downstream=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_vcid: vc_id
    :param ldp_fec_vcid: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vcid** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vc_downstream: local_ldp_id
    :param vc_downstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **vc_downstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_vcid', u'ldp_fec_vcid')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_vcid.vc_downstream', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vc_downstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'fec-stale'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vcid=ldp_fec_vcid, vc_downstream=vc_downstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vcid=ldp_fec_vcid, vc_downstream=vc_downstream)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcid_vc_downstream_feccb_delete(self, ldp_fec_vcid=None, vc_downstream=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_vcid: vc_id
    :param ldp_fec_vcid: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vcid** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vc_downstream: local_ldp_id
    :param vc_downstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **vc_downstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_vcid', u'ldp_fec_vcid')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_vcid.vc_downstream', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vc_downstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'feccb'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vcid=ldp_fec_vcid, vc_downstream=vc_downstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vcid=ldp_fec_vcid, vc_downstream=vc_downstream)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcid_vc_downstream_label_delete(self, ldp_fec_vcid=None, vc_downstream=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_vcid: vc_id
    :param ldp_fec_vcid: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vcid** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vc_downstream: local_ldp_id
    :param vc_downstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **vc_downstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_vcid', u'ldp_fec_vcid')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_vcid.vc_downstream', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vc_downstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'label'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vcid=ldp_fec_vcid, vc_downstream=vc_downstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vcid=ldp_fec_vcid, vc_downstream=vc_downstream)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcid_vc_downstream_local_ldp_lblspc_delete(self, ldp_fec_vcid=None, vc_downstream=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_vcid: vc_id
    :param ldp_fec_vcid: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vcid** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vc_downstream: local_ldp_id
    :param vc_downstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **vc_downstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_vcid', u'ldp_fec_vcid')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_vcid.vc_downstream', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vc_downstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'local-ldp-lblspc'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vcid=ldp_fec_vcid, vc_downstream=vc_downstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vcid=ldp_fec_vcid, vc_downstream=vc_downstream)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcid_vc_downstream_peer_ldp_id_delete(self, ldp_fec_vcid=None, vc_downstream=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_vcid: vc_id
    :param ldp_fec_vcid: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vcid** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vc_downstream: local_ldp_id
    :param vc_downstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **vc_downstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_vcid', u'ldp_fec_vcid')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_vcid.vc_downstream', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vc_downstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'peer-ldp-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vcid=ldp_fec_vcid, vc_downstream=vc_downstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vcid=ldp_fec_vcid, vc_downstream=vc_downstream)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcid_vc_downstream_peer_ldp_lblspc_delete(self, ldp_fec_vcid=None, vc_downstream=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_vcid: vc_id
    :param ldp_fec_vcid: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vcid** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vc_downstream: local_ldp_id
    :param vc_downstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **vc_downstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_vcid', u'ldp_fec_vcid')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_vcid.vc_downstream', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vc_downstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'peer-ldp-lblspc'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vcid=ldp_fec_vcid, vc_downstream=vc_downstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vcid=ldp_fec_vcid, vc_downstream=vc_downstream)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcid_vc_downstream_state_delete(self, ldp_fec_vcid=None, vc_downstream=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_vcid: vc_id
    :param ldp_fec_vcid: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vcid** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vc_downstream: local_ldp_id
    :param vc_downstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **vc_downstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_vcid', u'ldp_fec_vcid')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_vcid.vc_downstream', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vc_downstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'state'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vcid=ldp_fec_vcid, vc_downstream=vc_downstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vcid=ldp_fec_vcid, vc_downstream=vc_downstream)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcid_vc_fec_type_delete(self, ldp_fec_vcid=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ldp_fec_vcid: vc_id
    :param ldp_fec_vcid: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vcid** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_vcid', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_fec_vcid', 'keyval': 'vc_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vc-fec-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vcid=ldp_fec_vcid)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vcid=ldp_fec_vcid)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcid_vc_feccb_delete(self, ldp_fec_vcid=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ldp_fec_vcid: vc_id
    :param ldp_fec_vcid: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vcid** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_vcid', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_fec_vcid', 'keyval': 'vc_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vc-feccb'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vcid=ldp_fec_vcid)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vcid=ldp_fec_vcid)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcid_vc_grp_id_delete(self, ldp_fec_vcid=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ldp_fec_vcid: vc_id
    :param ldp_fec_vcid: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vcid** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_vcid', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_fec_vcid', 'keyval': 'vc_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vc-grp-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vcid=ldp_fec_vcid)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vcid=ldp_fec_vcid)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcid_vc_idx_delete(self, ldp_fec_vcid=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ldp_fec_vcid: vc_id
    :param ldp_fec_vcid: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vcid** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_vcid', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_fec_vcid', 'keyval': 'vc_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vc-idx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vcid=ldp_fec_vcid)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vcid=ldp_fec_vcid)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcid_vc_local_mtu_delete(self, ldp_fec_vcid=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ldp_fec_vcid: vc_id
    :param ldp_fec_vcid: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vcid** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_vcid', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_fec_vcid', 'keyval': 'vc_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vc-local-mtu'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vcid=ldp_fec_vcid)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vcid=ldp_fec_vcid)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcid_vc_mtu_enforcement_delete(self, ldp_fec_vcid=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ldp_fec_vcid: vc_id
    :param ldp_fec_vcid: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vcid** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_vcid', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_fec_vcid', 'keyval': 'vc_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vc-mtu-enforcement'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vcid=ldp_fec_vcid)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vcid=ldp_fec_vcid)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcid_vc_remote_mtu_delete(self, ldp_fec_vcid=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ldp_fec_vcid: vc_id
    :param ldp_fec_vcid: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vcid** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_vcid', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_fec_vcid', 'keyval': 'vc_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vc-remote-mtu'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vcid=ldp_fec_vcid)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vcid=ldp_fec_vcid)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcid_vc_type_delete(self, ldp_fec_vcid=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ldp_fec_vcid: vc_id
    :param ldp_fec_vcid: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vcid** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_vcid', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_fec_vcid', 'keyval': 'vc_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vc-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vcid=ldp_fec_vcid)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vcid=ldp_fec_vcid)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcid_vc_upstream_delete(self, ldp_fec_vcid=None, vc_upstream=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_vcid: vc_id
    :param ldp_fec_vcid: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vcid** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vc_upstream: local_ldp_id
    :param vc_upstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **vc_upstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_vcid', u'ldp_fec_vcid')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_vcid.vc_upstream', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vc_upstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vcid=ldp_fec_vcid, vc_upstream=vc_upstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vcid=ldp_fec_vcid, vc_upstream=vc_upstream)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcid_vc_upstream_fec_dm_state_dw_delete(self, ldp_fec_vcid=None, vc_upstream=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_vcid: vc_id
    :param ldp_fec_vcid: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vcid** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vc_upstream: local_ldp_id
    :param vc_upstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **vc_upstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_vcid', u'ldp_fec_vcid')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_vcid.vc_upstream', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vc_upstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'fec-dm-state-dw'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vcid=ldp_fec_vcid, vc_upstream=vc_upstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vcid=ldp_fec_vcid, vc_upstream=vc_upstream)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcid_vc_upstream_fec_filtered_state_delete(self, ldp_fec_vcid=None, vc_upstream=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_vcid: vc_id
    :param ldp_fec_vcid: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vcid** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vc_upstream: local_ldp_id
    :param vc_upstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **vc_upstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_vcid', u'ldp_fec_vcid')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_vcid.vc_upstream', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vc_upstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'fec-filtered-state'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vcid=ldp_fec_vcid, vc_upstream=vc_upstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vcid=ldp_fec_vcid, vc_upstream=vc_upstream)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcid_vc_upstream_fec_stale_delete(self, ldp_fec_vcid=None, vc_upstream=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_vcid: vc_id
    :param ldp_fec_vcid: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vcid** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vc_upstream: local_ldp_id
    :param vc_upstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **vc_upstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_vcid', u'ldp_fec_vcid')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_vcid.vc_upstream', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vc_upstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'fec-stale'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vcid=ldp_fec_vcid, vc_upstream=vc_upstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vcid=ldp_fec_vcid, vc_upstream=vc_upstream)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcid_vc_upstream_feccb_delete(self, ldp_fec_vcid=None, vc_upstream=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_vcid: vc_id
    :param ldp_fec_vcid: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vcid** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vc_upstream: local_ldp_id
    :param vc_upstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **vc_upstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_vcid', u'ldp_fec_vcid')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_vcid.vc_upstream', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vc_upstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'feccb'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vcid=ldp_fec_vcid, vc_upstream=vc_upstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vcid=ldp_fec_vcid, vc_upstream=vc_upstream)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcid_vc_upstream_label_delete(self, ldp_fec_vcid=None, vc_upstream=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_vcid: vc_id
    :param ldp_fec_vcid: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vcid** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vc_upstream: local_ldp_id
    :param vc_upstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **vc_upstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_vcid', u'ldp_fec_vcid')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_vcid.vc_upstream', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vc_upstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'label'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vcid=ldp_fec_vcid, vc_upstream=vc_upstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vcid=ldp_fec_vcid, vc_upstream=vc_upstream)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcid_vc_upstream_local_ldp_lblspc_delete(self, ldp_fec_vcid=None, vc_upstream=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_vcid: vc_id
    :param ldp_fec_vcid: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vcid** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vc_upstream: local_ldp_id
    :param vc_upstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **vc_upstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_vcid', u'ldp_fec_vcid')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_vcid.vc_upstream', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vc_upstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'local-ldp-lblspc'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vcid=ldp_fec_vcid, vc_upstream=vc_upstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vcid=ldp_fec_vcid, vc_upstream=vc_upstream)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcid_vc_upstream_peer_ldp_id_delete(self, ldp_fec_vcid=None, vc_upstream=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_vcid: vc_id
    :param ldp_fec_vcid: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vcid** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vc_upstream: local_ldp_id
    :param vc_upstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **vc_upstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_vcid', u'ldp_fec_vcid')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_vcid.vc_upstream', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vc_upstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'peer-ldp-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vcid=ldp_fec_vcid, vc_upstream=vc_upstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vcid=ldp_fec_vcid, vc_upstream=vc_upstream)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcid_vc_upstream_peer_ldp_lblspc_delete(self, ldp_fec_vcid=None, vc_upstream=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_vcid: vc_id
    :param ldp_fec_vcid: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vcid** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vc_upstream: local_ldp_id
    :param vc_upstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **vc_upstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_vcid', u'ldp_fec_vcid')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_vcid.vc_upstream', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vc_upstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'peer-ldp-lblspc'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vcid=ldp_fec_vcid, vc_upstream=vc_upstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vcid=ldp_fec_vcid, vc_upstream=vc_upstream)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcid_vc_upstream_state_delete(self, ldp_fec_vcid=None, vc_upstream=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_vcid: vc_id
    :param ldp_fec_vcid: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vcid** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vc_upstream: local_ldp_id
    :param vc_upstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **vc_upstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_vcid', u'ldp_fec_vcid')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_vcid.vc_upstream', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vc_upstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'state'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vcid=ldp_fec_vcid, vc_upstream=vc_upstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vcid=ldp_fec_vcid, vc_upstream=vc_upstream)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcs_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_vcs', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcs_key_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_vcs.key', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcs_key_data_fec_type_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_vcs.key', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'data-fec-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcs_key_inet_addr_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_vcs.key', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'inet-addr'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcs_key_inet_addr_len_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_vcs.key', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'inet-addr-len'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcs_key_inet_addr_type_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_vcs.key', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'inet-addr-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcs_key_prefix_len_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_vcs.key', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'prefix-len'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcs_key_type_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_vcs.key', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcs_key_vc_agi_len_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_vcs.key', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vc-agi-len'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcs_key_vc_agi_offset_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_vcs.key', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vc-agi-offset'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcs_key_vc_control_word_config_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_vcs.key', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vc-control-word-config'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcs_key_vc_gen_id_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_vcs.key', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vc-gen-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcs_key_vc_gen_id_size_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_vcs.key', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vc-gen-id-size'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcs_key_vc_group_id_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_vcs.key', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vc-group-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcs_key_vc_id_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_vcs.key', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vc-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcs_key_vc_ldp_peer_id_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_vcs.key', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vc-ldp-peer-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcs_key_vc_saii_len_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_vcs.key', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vc-saii-len'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcs_key_vc_saii_offset_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_vcs.key', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vc-saii-offset'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcs_key_vc_taii_len_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_vcs.key', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vc-taii-len'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcs_key_vc_taii_offset_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_vcs.key', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vc-taii-offset'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcs_key_vc_type_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_vcs.key', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vc-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcs_key_vc_use_control_word_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_vcs.key', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vc-use-control-word'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcs_tot_no_of_vc_fec_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_vcs', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tot-no-of-vc-fec'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcs_tot_no_of_vc_fec_installed_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_vcs', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tot-no-of-vc-fec-installed'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcs_vc_delete(self, vc=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type vc: peer_id
    :param vc: Keyword argument tuple.

    :type peer_id: unicode
    :param peer_id: **vc** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_vcs.vc', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'vc', 'keyval': 'peer_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vc=vc)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vc=vc)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcs_vc_egress_delete(self, vc=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type vc: peer_id
    :param vc: Keyword argument tuple.

    :type peer_id: unicode
    :param peer_id: **vc** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_vcs.vc', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'vc', 'keyval': 'peer_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'egress'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vc=vc)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vc=vc)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcs_vc_ingress_delete(self, vc=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type vc: peer_id
    :param vc: Keyword argument tuple.

    :type peer_id: unicode
    :param peer_id: **vc** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_vcs.vc', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'vc', 'keyval': 'peer_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ingress'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vc=vc)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vc=vc)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcs_vc_peer_fec_type_delete(self, vc=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type vc: peer_id
    :param vc: Keyword argument tuple.

    :type peer_id: unicode
    :param peer_id: **vc** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_vcs.vc', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'vc', 'keyval': 'peer_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'peer-fec-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vc=vc)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vc=vc)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcs_vc_peer_lblspc_delete(self, vc=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type vc: peer_id
    :param vc: Keyword argument tuple.

    :type peer_id: unicode
    :param peer_id: **vc** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_vcs.vc', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'vc', 'keyval': 'peer_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'peer-lblspc'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vc=vc)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vc=vc)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcs_vc_peer_vc_type_delete(self, vc=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type vc: peer_id
    :param vc: Keyword argument tuple.

    :type peer_id: unicode
    :param peer_id: **vc** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_vcs.vc', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'vc', 'keyval': 'peer_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'peer-vc-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vc=vc)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vc=vc)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcs_vc_state_delete(self, vc=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type vc: peer_id
    :param vc: Keyword argument tuple.

    :type peer_id: unicode
    :param peer_id: **vc** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_vcs.vc', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'vc', 'keyval': 'peer_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'state'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vc=vc)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vc=vc)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcs_vc_vc_id_delete(self, vc=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type vc: peer_id
    :param vc: Keyword argument tuple.

    :type peer_id: unicode
    :param peer_id: **vc** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.fec.ldp_fec_vcs.vc', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'vc', 'keyval': 'peer_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vc-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vc=vc)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vc=vc)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_interface_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.interface', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_interface_ldp_interface_data_delete(self, ldp_interface_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ldp_interface_data: ldp_interface_name, ldp_interface_type
    :param ldp_interface_data: Keyword argument tuple.

    :type ldp_interface_name: unicode
    :param ldp_interface_name: **ldp_interface_data** tuple argument.

    :type ldp_interface_type: unicode
    :param ldp_interface_type: **ldp_interface_data** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.interface.ldp_interface_data', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_interface_data', 'keyval': 'ldp_interface_name, ldp_interface_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_interface_data=ldp_interface_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_interface_data=ldp_interface_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_interface_ldp_interface_data_ldp_interface_hello_intl_delete(self, ldp_interface_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ldp_interface_data: ldp_interface_name, ldp_interface_type
    :param ldp_interface_data: Keyword argument tuple.

    :type ldp_interface_name: unicode
    :param ldp_interface_name: **ldp_interface_data** tuple argument.

    :type ldp_interface_type: unicode
    :param ldp_interface_type: **ldp_interface_data** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.interface.ldp_interface_data', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_interface_data', 'keyval': 'ldp_interface_name, ldp_interface_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ldp-interface-hello-intl'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_interface_data=ldp_interface_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_interface_data=ldp_interface_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_interface_ldp_interface_data_ldp_interface_hello_next_delete(self, ldp_interface_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ldp_interface_data: ldp_interface_name, ldp_interface_type
    :param ldp_interface_data: Keyword argument tuple.

    :type ldp_interface_name: unicode
    :param ldp_interface_name: **ldp_interface_data** tuple argument.

    :type ldp_interface_type: unicode
    :param ldp_interface_type: **ldp_interface_data** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.interface.ldp_interface_data', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_interface_data', 'keyval': 'ldp_interface_name, ldp_interface_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ldp-interface-hello-next'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_interface_data=ldp_interface_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_interface_data=ldp_interface_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_interface_ldp_interface_data_ldp_interface_hello_timeout_delete(self, ldp_interface_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ldp_interface_data: ldp_interface_name, ldp_interface_type
    :param ldp_interface_data: Keyword argument tuple.

    :type ldp_interface_name: unicode
    :param ldp_interface_name: **ldp_interface_data** tuple argument.

    :type ldp_interface_type: unicode
    :param ldp_interface_type: **ldp_interface_data** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.interface.ldp_interface_data', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_interface_data', 'keyval': 'ldp_interface_name, ldp_interface_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ldp-interface-hello-timeout'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_interface_data=ldp_interface_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_interface_data=ldp_interface_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_interface_ldp_interface_data_ldp_interface_lbpsp_delete(self, ldp_interface_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ldp_interface_data: ldp_interface_name, ldp_interface_type
    :param ldp_interface_data: Keyword argument tuple.

    :type ldp_interface_name: unicode
    :param ldp_interface_name: **ldp_interface_data** tuple argument.

    :type ldp_interface_type: unicode
    :param ldp_interface_type: **ldp_interface_data** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.interface.ldp_interface_data', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_interface_data', 'keyval': 'ldp_interface_name, ldp_interface_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ldp-interface-lbpsp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_interface_data=ldp_interface_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_interface_data=ldp_interface_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_interface_ldp_interface_data_ldp_interface_nbr_cnt_delete(self, ldp_interface_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ldp_interface_data: ldp_interface_name, ldp_interface_type
    :param ldp_interface_data: Keyword argument tuple.

    :type ldp_interface_name: unicode
    :param ldp_interface_name: **ldp_interface_data** tuple argument.

    :type ldp_interface_type: unicode
    :param ldp_interface_type: **ldp_interface_data** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.interface.ldp_interface_data', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_interface_data', 'keyval': 'ldp_interface_name, ldp_interface_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ldp-interface-nbr-cnt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_interface_data=ldp_interface_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_interface_data=ldp_interface_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_database_delete(self, ldp_database=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ldp_database: ldp_database_peer_ip
    :param ldp_database: Keyword argument tuple.

    :type ldp_database_peer_ip: unicode
    :param ldp_database_peer_ip: **ldp_database** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_database', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_database', 'keyval': 'ldp_database_peer_ip', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_database=ldp_database)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_database=ldp_database)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_database_ldp_database_own_ip_delete(self, ldp_database=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ldp_database: ldp_database_peer_ip
    :param ldp_database: Keyword argument tuple.

    :type ldp_database_peer_ip: unicode
    :param ldp_database_peer_ip: **ldp_database** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_database', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_database', 'keyval': 'ldp_database_peer_ip', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ldp-database-own-ip'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_database=ldp_database)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_database=ldp_database)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_database_mpls_ldp_database_downstream_delete(self, ldp_database=None, mpls_ldp_database_downstream=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_database: ldp_database_peer_ip
    :param ldp_database: Keyword argument tuple.

    :type ldp_database_peer_ip: unicode
    :param ldp_database_peer_ip: **ldp_database** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type mpls_ldp_database_downstream: mpls_ldp_database_ds_fec_prefix
    :param mpls_ldp_database_downstream: Keyword argument tuple.

    :type mpls_ldp_database_ds_fec_prefix: unicode
    :param mpls_ldp_database_ds_fec_prefix: **mpls_ldp_database_downstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_database', u'ldp_database')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_database.mpls_ldp_database_downstream', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ldp_database_peer_ip', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mpls_ldp_database_downstream', 'keyval': 'mpls_ldp_database_ds_fec_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_database=ldp_database, mpls_ldp_database_downstream=mpls_ldp_database_downstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_database=ldp_database, mpls_ldp_database_downstream=mpls_ldp_database_downstream)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_database_mpls_ldp_database_downstream_mpls_ldp_database_ds_fec_filtered_delete(self, ldp_database=None, mpls_ldp_database_downstream=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_database: ldp_database_peer_ip
    :param ldp_database: Keyword argument tuple.

    :type ldp_database_peer_ip: unicode
    :param ldp_database_peer_ip: **ldp_database** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type mpls_ldp_database_downstream: mpls_ldp_database_ds_fec_prefix
    :param mpls_ldp_database_downstream: Keyword argument tuple.

    :type mpls_ldp_database_ds_fec_prefix: unicode
    :param mpls_ldp_database_ds_fec_prefix: **mpls_ldp_database_downstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_database', u'ldp_database')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_database.mpls_ldp_database_downstream', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ldp_database_peer_ip', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mpls_ldp_database_downstream', 'keyval': 'mpls_ldp_database_ds_fec_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mpls-ldp-database-ds-fec-filtered'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_database=ldp_database, mpls_ldp_database_downstream=mpls_ldp_database_downstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_database=ldp_database, mpls_ldp_database_downstream=mpls_ldp_database_downstream)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_database_mpls_ldp_database_downstream_mpls_ldp_database_ds_fec_label_delete(self, ldp_database=None, mpls_ldp_database_downstream=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_database: ldp_database_peer_ip
    :param ldp_database: Keyword argument tuple.

    :type ldp_database_peer_ip: unicode
    :param ldp_database_peer_ip: **ldp_database** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type mpls_ldp_database_downstream: mpls_ldp_database_ds_fec_prefix
    :param mpls_ldp_database_downstream: Keyword argument tuple.

    :type mpls_ldp_database_ds_fec_prefix: unicode
    :param mpls_ldp_database_ds_fec_prefix: **mpls_ldp_database_downstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_database', u'ldp_database')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_database.mpls_ldp_database_downstream', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ldp_database_peer_ip', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mpls_ldp_database_downstream', 'keyval': 'mpls_ldp_database_ds_fec_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mpls-ldp-database-ds-fec-label'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_database=ldp_database, mpls_ldp_database_downstream=mpls_ldp_database_downstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_database=ldp_database, mpls_ldp_database_downstream=mpls_ldp_database_downstream)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_database_mpls_ldp_database_downstream_mpls_ldp_database_ds_fec_lwd_delete(self, ldp_database=None, mpls_ldp_database_downstream=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_database: ldp_database_peer_ip
    :param ldp_database: Keyword argument tuple.

    :type ldp_database_peer_ip: unicode
    :param ldp_database_peer_ip: **ldp_database** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type mpls_ldp_database_downstream: mpls_ldp_database_ds_fec_prefix
    :param mpls_ldp_database_downstream: Keyword argument tuple.

    :type mpls_ldp_database_ds_fec_prefix: unicode
    :param mpls_ldp_database_ds_fec_prefix: **mpls_ldp_database_downstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_database', u'ldp_database')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_database.mpls_ldp_database_downstream', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ldp_database_peer_ip', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mpls_ldp_database_downstream', 'keyval': 'mpls_ldp_database_ds_fec_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mpls-ldp-database-ds-fec-lwd'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_database=ldp_database, mpls_ldp_database_downstream=mpls_ldp_database_downstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_database=ldp_database, mpls_ldp_database_downstream=mpls_ldp_database_downstream)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_database_mpls_ldp_database_downstream_mpls_ldp_database_ds_fec_prefix_length_delete(self, ldp_database=None, mpls_ldp_database_downstream=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_database: ldp_database_peer_ip
    :param ldp_database: Keyword argument tuple.

    :type ldp_database_peer_ip: unicode
    :param ldp_database_peer_ip: **ldp_database** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type mpls_ldp_database_downstream: mpls_ldp_database_ds_fec_prefix
    :param mpls_ldp_database_downstream: Keyword argument tuple.

    :type mpls_ldp_database_ds_fec_prefix: unicode
    :param mpls_ldp_database_ds_fec_prefix: **mpls_ldp_database_downstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_database', u'ldp_database')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_database.mpls_ldp_database_downstream', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ldp_database_peer_ip', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mpls_ldp_database_downstream', 'keyval': 'mpls_ldp_database_ds_fec_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mpls-ldp-database-ds-fec-prefix-length'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_database=ldp_database, mpls_ldp_database_downstream=mpls_ldp_database_downstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_database=ldp_database, mpls_ldp_database_downstream=mpls_ldp_database_downstream)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_database_mpls_ldp_database_downstream_mpls_ldp_database_ds_fec_stale_delete(self, ldp_database=None, mpls_ldp_database_downstream=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_database: ldp_database_peer_ip
    :param ldp_database: Keyword argument tuple.

    :type ldp_database_peer_ip: unicode
    :param ldp_database_peer_ip: **ldp_database** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type mpls_ldp_database_downstream: mpls_ldp_database_ds_fec_prefix
    :param mpls_ldp_database_downstream: Keyword argument tuple.

    :type mpls_ldp_database_ds_fec_prefix: unicode
    :param mpls_ldp_database_ds_fec_prefix: **mpls_ldp_database_downstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_database', u'ldp_database')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_database.mpls_ldp_database_downstream', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ldp_database_peer_ip', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mpls_ldp_database_downstream', 'keyval': 'mpls_ldp_database_ds_fec_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mpls-ldp-database-ds-fec-stale'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_database=ldp_database, mpls_ldp_database_downstream=mpls_ldp_database_downstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_database=ldp_database, mpls_ldp_database_downstream=mpls_ldp_database_downstream)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_database_mpls_ldp_database_downstream_mpls_ldp_database_ds_fec_state_delete(self, ldp_database=None, mpls_ldp_database_downstream=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_database: ldp_database_peer_ip
    :param ldp_database: Keyword argument tuple.

    :type ldp_database_peer_ip: unicode
    :param ldp_database_peer_ip: **ldp_database** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type mpls_ldp_database_downstream: mpls_ldp_database_ds_fec_prefix
    :param mpls_ldp_database_downstream: Keyword argument tuple.

    :type mpls_ldp_database_ds_fec_prefix: unicode
    :param mpls_ldp_database_ds_fec_prefix: **mpls_ldp_database_downstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_database', u'ldp_database')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_database.mpls_ldp_database_downstream', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ldp_database_peer_ip', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mpls_ldp_database_downstream', 'keyval': 'mpls_ldp_database_ds_fec_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mpls-ldp-database-ds-fec-state'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_database=ldp_database, mpls_ldp_database_downstream=mpls_ldp_database_downstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_database=ldp_database, mpls_ldp_database_downstream=mpls_ldp_database_downstream)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_database_mpls_ldp_database_downstream_mpls_ldp_database_ds_fec_type_delete(self, ldp_database=None, mpls_ldp_database_downstream=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_database: ldp_database_peer_ip
    :param ldp_database: Keyword argument tuple.

    :type ldp_database_peer_ip: unicode
    :param ldp_database_peer_ip: **ldp_database** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type mpls_ldp_database_downstream: mpls_ldp_database_ds_fec_prefix
    :param mpls_ldp_database_downstream: Keyword argument tuple.

    :type mpls_ldp_database_ds_fec_prefix: unicode
    :param mpls_ldp_database_ds_fec_prefix: **mpls_ldp_database_downstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_database', u'ldp_database')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_database.mpls_ldp_database_downstream', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ldp_database_peer_ip', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mpls_ldp_database_downstream', 'keyval': 'mpls_ldp_database_ds_fec_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mpls-ldp-database-ds-fec-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_database=ldp_database, mpls_ldp_database_downstream=mpls_ldp_database_downstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_database=ldp_database, mpls_ldp_database_downstream=mpls_ldp_database_downstream)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_database_mpls_ldp_database_upstream_delete(self, ldp_database=None, mpls_ldp_database_upstream=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_database: ldp_database_peer_ip
    :param ldp_database: Keyword argument tuple.

    :type ldp_database_peer_ip: unicode
    :param ldp_database_peer_ip: **ldp_database** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type mpls_ldp_database_upstream: mpls_ldp_database_us_fec_prefix
    :param mpls_ldp_database_upstream: Keyword argument tuple.

    :type mpls_ldp_database_us_fec_prefix: unicode
    :param mpls_ldp_database_us_fec_prefix: **mpls_ldp_database_upstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_database', u'ldp_database')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_database.mpls_ldp_database_upstream', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ldp_database_peer_ip', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mpls_ldp_database_upstream', 'keyval': 'mpls_ldp_database_us_fec_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_database=ldp_database, mpls_ldp_database_upstream=mpls_ldp_database_upstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_database=ldp_database, mpls_ldp_database_upstream=mpls_ldp_database_upstream)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_database_mpls_ldp_database_upstream_mpls_ldp_database_us_fec_label_delete(self, ldp_database=None, mpls_ldp_database_upstream=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_database: ldp_database_peer_ip
    :param ldp_database: Keyword argument tuple.

    :type ldp_database_peer_ip: unicode
    :param ldp_database_peer_ip: **ldp_database** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type mpls_ldp_database_upstream: mpls_ldp_database_us_fec_prefix
    :param mpls_ldp_database_upstream: Keyword argument tuple.

    :type mpls_ldp_database_us_fec_prefix: unicode
    :param mpls_ldp_database_us_fec_prefix: **mpls_ldp_database_upstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_database', u'ldp_database')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_database.mpls_ldp_database_upstream', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ldp_database_peer_ip', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mpls_ldp_database_upstream', 'keyval': 'mpls_ldp_database_us_fec_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mpls-ldp-database-us-fec-label'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_database=ldp_database, mpls_ldp_database_upstream=mpls_ldp_database_upstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_database=ldp_database, mpls_ldp_database_upstream=mpls_ldp_database_upstream)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_database_mpls_ldp_database_upstream_mpls_ldp_database_us_fec_prefix_length_delete(self, ldp_database=None, mpls_ldp_database_upstream=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_database: ldp_database_peer_ip
    :param ldp_database: Keyword argument tuple.

    :type ldp_database_peer_ip: unicode
    :param ldp_database_peer_ip: **ldp_database** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type mpls_ldp_database_upstream: mpls_ldp_database_us_fec_prefix
    :param mpls_ldp_database_upstream: Keyword argument tuple.

    :type mpls_ldp_database_us_fec_prefix: unicode
    :param mpls_ldp_database_us_fec_prefix: **mpls_ldp_database_upstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_database', u'ldp_database')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_database.mpls_ldp_database_upstream', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ldp_database_peer_ip', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mpls_ldp_database_upstream', 'keyval': 'mpls_ldp_database_us_fec_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mpls-ldp-database-us-fec-prefix-length'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_database=ldp_database, mpls_ldp_database_upstream=mpls_ldp_database_upstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_database=ldp_database, mpls_ldp_database_upstream=mpls_ldp_database_upstream)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_database_mpls_ldp_database_upstream_mpls_ldp_database_us_fec_stale_delete(self, ldp_database=None, mpls_ldp_database_upstream=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_database: ldp_database_peer_ip
    :param ldp_database: Keyword argument tuple.

    :type ldp_database_peer_ip: unicode
    :param ldp_database_peer_ip: **ldp_database** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type mpls_ldp_database_upstream: mpls_ldp_database_us_fec_prefix
    :param mpls_ldp_database_upstream: Keyword argument tuple.

    :type mpls_ldp_database_us_fec_prefix: unicode
    :param mpls_ldp_database_us_fec_prefix: **mpls_ldp_database_upstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_database', u'ldp_database')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_database.mpls_ldp_database_upstream', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ldp_database_peer_ip', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mpls_ldp_database_upstream', 'keyval': 'mpls_ldp_database_us_fec_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mpls-ldp-database-us-fec-stale'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_database=ldp_database, mpls_ldp_database_upstream=mpls_ldp_database_upstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_database=ldp_database, mpls_ldp_database_upstream=mpls_ldp_database_upstream)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_database_mpls_ldp_database_upstream_mpls_ldp_database_us_fec_type_delete(self, ldp_database=None, mpls_ldp_database_upstream=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_database: ldp_database_peer_ip
    :param ldp_database: Keyword argument tuple.

    :type ldp_database_peer_ip: unicode
    :param ldp_database_peer_ip: **ldp_database** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type mpls_ldp_database_upstream: mpls_ldp_database_us_fec_prefix
    :param mpls_ldp_database_upstream: Keyword argument tuple.

    :type mpls_ldp_database_us_fec_prefix: unicode
    :param mpls_ldp_database_us_fec_prefix: **mpls_ldp_database_upstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_database', u'ldp_database')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_database.mpls_ldp_database_upstream', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ldp_database_peer_ip', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mpls_ldp_database_upstream', 'keyval': 'mpls_ldp_database_us_fec_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mpls-ldp-database-us-fec-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_database=ldp_database, mpls_ldp_database_upstream=mpls_ldp_database_upstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_database=ldp_database, mpls_ldp_database_upstream=mpls_ldp_database_upstream)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_neighbors_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_neighbors', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_neighbors_neighbor_delete(self, neighbor=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type neighbor: neighbor_ldpid, labelspaceid
    :param neighbor: Keyword argument tuple.

    :type neighbor_ldpid: unicode
    :param neighbor_ldpid: **neighbor** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type labelspaceid: int
    :param labelspaceid: **neighbor** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_neighbors.neighbor', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'neighbor', 'keyval': 'neighbor_ldpid, labelspaceid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor=neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor=neighbor)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_neighbors_neighbor_configured_hold_time_delete(self, neighbor=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type neighbor: neighbor_ldpid, labelspaceid
    :param neighbor: Keyword argument tuple.

    :type neighbor_ldpid: unicode
    :param neighbor_ldpid: **neighbor** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type labelspaceid: int
    :param labelspaceid: **neighbor** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_neighbors.neighbor', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'neighbor', 'keyval': 'neighbor_ldpid, labelspaceid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'configured-hold-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor=neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor=neighbor)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_neighbors_neighbor_interface_name_delete(self, neighbor=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type neighbor: neighbor_ldpid, labelspaceid
    :param neighbor: Keyword argument tuple.

    :type neighbor_ldpid: unicode
    :param neighbor_ldpid: **neighbor** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type labelspaceid: int
    :param labelspaceid: **neighbor** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_neighbors.neighbor', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'neighbor', 'keyval': 'neighbor_ldpid, labelspaceid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'interface-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor=neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor=neighbor)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_neighbors_neighbor_max_hold_time_delete(self, neighbor=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type neighbor: neighbor_ldpid, labelspaceid
    :param neighbor: Keyword argument tuple.

    :type neighbor_ldpid: unicode
    :param neighbor_ldpid: **neighbor** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type labelspaceid: int
    :param labelspaceid: **neighbor** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_neighbors.neighbor', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'neighbor', 'keyval': 'neighbor_ldpid, labelspaceid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'max-hold-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor=neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor=neighbor)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_neighbors_neighbor_neighbor_proposed_hold_time_delete(self, neighbor=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type neighbor: neighbor_ldpid, labelspaceid
    :param neighbor: Keyword argument tuple.

    :type neighbor_ldpid: unicode
    :param neighbor_ldpid: **neighbor** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type labelspaceid: int
    :param labelspaceid: **neighbor** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_neighbors.neighbor', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'neighbor', 'keyval': 'neighbor_ldpid, labelspaceid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'neighbor-proposed-hold-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor=neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor=neighbor)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_neighbors_neighbor_neighbor_transport_delete(self, neighbor=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type neighbor: neighbor_ldpid, labelspaceid
    :param neighbor: Keyword argument tuple.

    :type neighbor_ldpid: unicode
    :param neighbor_ldpid: **neighbor** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type labelspaceid: int
    :param labelspaceid: **neighbor** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_neighbors.neighbor', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'neighbor', 'keyval': 'neighbor_ldpid, labelspaceid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'neighbor-transport'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor=neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor=neighbor)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_neighbors_neighbor_time_left_delete(self, neighbor=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type neighbor: neighbor_ldpid, labelspaceid
    :param neighbor: Keyword argument tuple.

    :type neighbor_ldpid: unicode
    :param neighbor_ldpid: **neighbor** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type labelspaceid: int
    :param labelspaceid: **neighbor** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_neighbors.neighbor', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'neighbor', 'keyval': 'neighbor_ldpid, labelspaceid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'time-left'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor=neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor=neighbor)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_neighbors_neighbor_up_time_delete(self, neighbor=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type neighbor: neighbor_ldpid, labelspaceid
    :param neighbor: Keyword argument tuple.

    :type neighbor_ldpid: unicode
    :param neighbor_ldpid: **neighbor** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type labelspaceid: int
    :param labelspaceid: **neighbor** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_neighbors.neighbor', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'neighbor', 'keyval': 'neighbor_ldpid, labelspaceid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'up-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor=neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor=neighbor)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_neighbors_num_link_neighbors_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_neighbors', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'num-link-neighbors'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_neighbors_num_targeted_neighbors_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_neighbors', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'num-targeted-neighbors'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_out_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_out', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_out_advertise_fecs_for_prefix_list_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_out', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'advertise-fecs-for-prefix-list'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_out_advertise_fecs_for_prefix_list_exists_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_out', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'advertise-fecs-for-prefix-list-exists'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_out_end_of_lib_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_out', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'end-of-lib'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_out_eol_notification_time_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_out', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'eol-notification-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_out_fec_128_used_for_auto_disc_configured_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_out', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'fec-128-used-for-auto-disc-configured'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_out_fec_128_used_for_auto_disc_current_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_out', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'fec-128-used-for-auto-disc-current'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_out_forwarding_state_timer_remaining_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_out', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'forwarding-state-timer-remaining'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_out_forwarding_state_timer_running_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_out', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'forwarding-state-timer-running'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_out_gr_enable_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_out', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'gr-enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_out_gr_helper_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_out', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'gr-helper'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_out_gr_max_peer_reconnect_time_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_out', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'gr-max-peer-reconnect-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_out_gr_max_peer_recovery_time_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_out', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'gr-max-peer-recovery-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_out_gr_reconnect_time_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_out', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'gr-reconnect-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_out_gr_recovery_time_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_out', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'gr-recovery-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_out_hello_interval_link_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_out', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hello-interval-link'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_out_hello_interval_target_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_out', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hello-interval-target'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_out_hold_time_sent_link_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_out', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hold-time-sent-link'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_out_hold_time_sent_target_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_out', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hold-time-sent-target'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_out_inbound_fecs_filtering_prefix_list_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_out', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'inbound-fecs-filtering-prefix-list'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_out_inbound_fecs_filtering_prefix_list_exists_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_out', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'inbound-fecs-filtering-prefix-list-exists'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_out_ka_interval_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_out', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ka-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_out_ka_multiple_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_out', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ka-multiple'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_out_ka_timeout_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_out', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ka-timeout'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_out_ka_timeout_default_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_out', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ka-timeout-default'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_out_ldp_initialized_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_out', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ldp-initialized'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_out_load_sharing_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_out', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'load-sharing'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_out_loopback_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_out', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'loopback'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_out_lsr_id_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_out', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lsr-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_out_lsr_id_configured_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_out', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lsr-id-configured'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_out_lwd_default_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_out', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lwd-default'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_out_lwd_delay_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_out', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lwd-delay'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_out_outbound_fecs_filtering_prefix_list_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_out', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'outbound-fecs-filtering-prefix-list'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_out_outbound_fecs_filtering_prefix_list_exists_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_out', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'outbound-fecs-filtering-prefix-list-exists'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_out_rx_silence_time_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_out', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rx-silence-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_out_tunnel_metric_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_out', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tunnel-metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_out_tx_silence_time_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_out', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tx-silence-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_session_delete(self, ldp_session=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_session', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_session', 'keyval': 'peer_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_session_adjacency_delete(self, ldp_session=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_session', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_session', 'keyval': 'peer_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'adjacency'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_session_does_session_support_eol_delete(self, ldp_session=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_session', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_session', 'keyval': 'peer_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'does-session-support-eol'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_session_entity_index_delete(self, ldp_session=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_session', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_session', 'keyval': 'peer_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'entity-index'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_session_eol_notification_time_delete(self, ldp_session=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_session', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_session', 'keyval': 'peer_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'eol-notification-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_session_eol_notification_time_remaining_delete(self, ldp_session=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_session', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_session', 'keyval': 'peer_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'eol-notification-time-remaining'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_session_eol_rx_label_silence_time_delete(self, ldp_session=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_session', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_session', 'keyval': 'peer_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'eol-rx-label-silence-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_session_eol_rx_label_silence_time_remaining_delete(self, ldp_session=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_session', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_session', 'keyval': 'peer_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'eol-rx-label-silence-time-remaining'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_session_eol_tx_label_silence_time_delete(self, ldp_session=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_session', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_session', 'keyval': 'peer_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'eol-tx-label-silence-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_session_eol_tx_label_silence_time_remaining_delete(self, ldp_session=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_session', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_session', 'keyval': 'peer_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'eol-tx-label-silence-time-remaining'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_session_filter_prefix_list_exists_delete(self, ldp_session=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_session', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_session', 'keyval': 'peer_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'filter-prefix-list-exists'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_session_filter_prefix_list_name_delete(self, ldp_session=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_session', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_session', 'keyval': 'peer_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'filter-prefix-list-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_session_filtered_delete(self, ldp_session=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_session', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_session', 'keyval': 'peer_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'filtered'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_session_filtered_fecs_in_delete(self, ldp_session=None, filtered_fecs_in=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type filtered_fecs_in: fec_addr
    :param filtered_fecs_in: Keyword argument tuple.

    :type fec_addr: unicode
    :param fec_addr: **filtered_fecs_in** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_session', u'ldp_session')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_session.filtered_fecs_in', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'peer_ldp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'filtered_fecs_in', 'keyval': 'fec_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session, filtered_fecs_in=filtered_fecs_in)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session, filtered_fecs_in=filtered_fecs_in)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_session_filtered_fecs_in_label_delete(self, ldp_session=None, filtered_fecs_in=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type filtered_fecs_in: fec_addr
    :param filtered_fecs_in: Keyword argument tuple.

    :type fec_addr: unicode
    :param fec_addr: **filtered_fecs_in** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_session', u'ldp_session')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_session.filtered_fecs_in', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'peer_ldp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'filtered_fecs_in', 'keyval': 'fec_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'label'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session, filtered_fecs_in=filtered_fecs_in)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session, filtered_fecs_in=filtered_fecs_in)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_session_filtered_fecs_in_prefix_len_delete(self, ldp_session=None, filtered_fecs_in=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type filtered_fecs_in: fec_addr
    :param filtered_fecs_in: Keyword argument tuple.

    :type fec_addr: unicode
    :param fec_addr: **filtered_fecs_in** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_session', u'ldp_session')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_session.filtered_fecs_in', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'peer_ldp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'filtered_fecs_in', 'keyval': 'fec_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'prefix-len'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session, filtered_fecs_in=filtered_fecs_in)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session, filtered_fecs_in=filtered_fecs_in)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_session_filtered_fecs_out_delete(self, ldp_session=None, filtered_fecs_out=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type filtered_fecs_out: fec_addr
    :param filtered_fecs_out: Keyword argument tuple.

    :type fec_addr: unicode
    :param fec_addr: **filtered_fecs_out** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_session', u'ldp_session')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_session.filtered_fecs_out', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'peer_ldp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'filtered_fecs_out', 'keyval': 'fec_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session, filtered_fecs_out=filtered_fecs_out)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session, filtered_fecs_out=filtered_fecs_out)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_session_filtered_fecs_out_label_delete(self, ldp_session=None, filtered_fecs_out=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type filtered_fecs_out: fec_addr
    :param filtered_fecs_out: Keyword argument tuple.

    :type fec_addr: unicode
    :param fec_addr: **filtered_fecs_out** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_session', u'ldp_session')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_session.filtered_fecs_out', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'peer_ldp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'filtered_fecs_out', 'keyval': 'fec_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'label'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session, filtered_fecs_out=filtered_fecs_out)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session, filtered_fecs_out=filtered_fecs_out)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_session_filtered_fecs_out_prefix_len_delete(self, ldp_session=None, filtered_fecs_out=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type filtered_fecs_out: fec_addr
    :param filtered_fecs_out: Keyword argument tuple.

    :type fec_addr: unicode
    :param fec_addr: **filtered_fecs_out** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_session', u'ldp_session')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_session.filtered_fecs_out', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'peer_ldp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'filtered_fecs_out', 'keyval': 'fec_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'prefix-len'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session, filtered_fecs_out=filtered_fecs_out)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session, filtered_fecs_out=filtered_fecs_out)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_session_gr_enabled_delete(self, ldp_session=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_session', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_session', 'keyval': 'peer_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'gr-enabled'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_session_gr_state_delete(self, ldp_session=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_session', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_session', 'keyval': 'peer_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'gr-state'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_session_is_fecs_pending_uninstall_delete(self, ldp_session=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_session', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_session', 'keyval': 'peer_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'is-fecs-pending-uninstall'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_session_is_only_gr_valid_delete(self, ldp_session=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_session', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_session', 'keyval': 'peer_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'is-only-gr-valid'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_session_is_retry_delete(self, ldp_session=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_session', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_session', 'keyval': 'peer_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'is-retry'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_session_keepalive_interval_delete(self, ldp_session=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_session', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_session', 'keyval': 'peer_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'keepalive-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_session_local_eol_unrecognized_notification_delete(self, ldp_session=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_session', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_session', 'keyval': 'peer_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'local-eol-unrecognized-notification'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_session_local_keepalive_timeout_delete(self, ldp_session=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_session', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_session', 'keyval': 'peer_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'local-keepalive-timeout'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_session_local_lblspc_id_delete(self, ldp_session=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_session', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_session', 'keyval': 'peer_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'local-lblspc-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_session_local_ldp_id_delete(self, ldp_session=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_session', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_session', 'keyval': 'peer_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'local-ldp-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_session_local_state_delete(self, ldp_session=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_session', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_session', 'keyval': 'peer_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'local-state'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_session_max_hold_delete(self, ldp_session=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_session', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_session', 'keyval': 'peer_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'max-hold'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_session_md5_auth_key_delete(self, ldp_session=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_session', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_session', 'keyval': 'peer_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'md5-auth-key'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_session_next_keepalive_delete(self, ldp_session=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_session', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_session', 'keyval': 'peer_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'next-keepalive'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_session_next_retry_delete(self, ldp_session=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_session', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_session', 'keyval': 'peer_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'next-retry'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_session_num_fecs_filtered_in_delete(self, ldp_session=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_session', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_session', 'keyval': 'peer_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'num-fecs-filtered-in'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_session_num_fecs_filtered_out_delete(self, ldp_session=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_session', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_session', 'keyval': 'peer_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'num-fecs-filtered-out'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_session_num_fecs_installed_from_peer_delete(self, ldp_session=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_session', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_session', 'keyval': 'peer_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'num-fecs-installed-from-peer'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_session_num_fecs_received_from_peer_delete(self, ldp_session=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_session', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_session', 'keyval': 'peer_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'num-fecs-received-from-peer'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_session_peer_lblspc_id_delete(self, ldp_session=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_session', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_session', 'keyval': 'peer_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'peer-lblspc-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_session_peer_proposed_keepalive_timeout_delete(self, ldp_session=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_session', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_session', 'keyval': 'peer_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'peer-proposed-keepalive-timeout'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_session_peer_reconnect_time_delete(self, ldp_session=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_session', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_session', 'keyval': 'peer_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'peer-reconnect-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_session_peer_recovery_time_delete(self, ldp_session=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_session', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_session', 'keyval': 'peer_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'peer-recovery-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_session_reconnect_time_in_use_delete(self, ldp_session=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_session', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_session', 'keyval': 'peer_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'reconnect-time-in-use'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_session_reconnect_time_remaining_delete(self, ldp_session=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_session', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_session', 'keyval': 'peer_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'reconnect-time-remaining'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_session_recovery_time_in_use_delete(self, ldp_session=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_session', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_session', 'keyval': 'peer_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'recovery-time-in-use'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_session_recovery_time_remaining_delete(self, ldp_session=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_session', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_session', 'keyval': 'peer_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'recovery-time-remaining'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_session_remote_eol_unrecognized_notification_delete(self, ldp_session=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_session', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_session', 'keyval': 'peer_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'remote-eol-unrecognized-notification'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_session_remote_state_delete(self, ldp_session=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_session', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_session', 'keyval': 'peer_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'remote-state'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_session_role_delete(self, ldp_session=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_session', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_session', 'keyval': 'peer_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'role'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_session_session_ldp_stats_delete(self, ldp_session=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_session', u'ldp_session')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_session.session_ldp_stats', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'peer_ldp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_session_session_ldp_stats_ldp_protocol_errors_instance_total_delete(self, ldp_session=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_session', u'ldp_session')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_errors_instance_total', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'peer_ldp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_session_session_ldp_stats_ldp_protocol_errors_instance_total_protocol_errors_delete(self, ldp_session=None, protocol_errors=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type protocol_errors: error_type
    :param protocol_errors: Keyword argument tuple.

    :type error_type: long
    :param error_type: **protocol_errors** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_session', u'ldp_session')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_errors_instance_total.protocol_errors', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'peer_ldp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'protocol_errors', 'keyval': 'error_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session, protocol_errors=protocol_errors)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session, protocol_errors=protocol_errors)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_session_session_ldp_stats_ldp_protocol_errors_instance_total_protocol_errors_count_delete(self, ldp_session=None, protocol_errors=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type protocol_errors: error_type
    :param protocol_errors: Keyword argument tuple.

    :type error_type: long
    :param error_type: **protocol_errors** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_session', u'ldp_session')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_errors_instance_total.protocol_errors', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'peer_ldp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'protocol_errors', 'keyval': 'error_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session, protocol_errors=protocol_errors)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session, protocol_errors=protocol_errors)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_session_session_ldp_stats_ldp_protocol_stats_instance_total_delete(self, ldp_session=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_session', u'ldp_session')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_stats_instance_total', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'peer_ldp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_session_session_ldp_stats_ldp_protocol_stats_instance_total_protocol_stats_delete(self, ldp_session=None, protocol_stats=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type protocol_stats: stat_type
    :param protocol_stats: Keyword argument tuple.

    :type stat_type: long
    :param stat_type: **protocol_stats** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_session', u'ldp_session')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_stats_instance_total.protocol_stats', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'peer_ldp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'protocol_stats', 'keyval': 'stat_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session, protocol_stats=protocol_stats)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session, protocol_stats=protocol_stats)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_session_session_ldp_stats_ldp_protocol_stats_instance_total_protocol_stats_rx_count_delete(self, ldp_session=None, protocol_stats=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type protocol_stats: stat_type
    :param protocol_stats: Keyword argument tuple.

    :type stat_type: long
    :param stat_type: **protocol_stats** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_session', u'ldp_session')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_stats_instance_total.protocol_stats', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'peer_ldp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'protocol_stats', 'keyval': 'stat_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rx-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session, protocol_stats=protocol_stats)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session, protocol_stats=protocol_stats)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_session_session_ldp_stats_ldp_protocol_stats_instance_total_protocol_stats_tx_count_delete(self, ldp_session=None, protocol_stats=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type protocol_stats: stat_type
    :param protocol_stats: Keyword argument tuple.

    :type stat_type: long
    :param stat_type: **protocol_stats** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_session', u'ldp_session')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_stats_instance_total.protocol_stats', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'peer_ldp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'protocol_stats', 'keyval': 'stat_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tx-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session, protocol_stats=protocol_stats)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session, protocol_stats=protocol_stats)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_session_session_status_delete(self, ldp_session=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_session', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_session', 'keyval': 'peer_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'session-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_session_session_up_time_delete(self, ldp_session=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_session', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_session', 'keyval': 'peer_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'session-up-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_session_state_delete(self, ldp_session=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_session', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_session', 'keyval': 'peer_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'state'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_session_summary_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_session_summary', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_session_summary_num_link_sessions_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_session_summary', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'num-link-sessions'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_session_summary_num_operational_link_sessions_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_session_summary', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'num-operational-link-sessions'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_session_summary_num_operational_targeted_sessions_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_session_summary', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'num-operational-targeted-sessions'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_session_summary_num_targeted_sessions_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_session_summary', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'num-targeted-sessions'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_session_targeted_adj_added_delete(self, ldp_session=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_session', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_session', 'keyval': 'peer_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'targeted-adj-added'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_session_tcp_conn_local_delete(self, ldp_session=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_session', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_session', 'keyval': 'peer_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tcp-conn-local'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_session_tcp_conn_remote_delete(self, ldp_session=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_session', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_session', 'keyval': 'peer_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tcp-conn-remote'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_session_tcp_state_delete(self, ldp_session=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_session', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_session', 'keyval': 'peer_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tcp-state'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_ldp_session_time_left_delete(self, ldp_session=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.ldp_session', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_session', 'keyval': 'peer_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'time-left'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_path_delete(self, path=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type path: destination_route
    :param path: Keyword argument tuple.

    :type destination_route: unicode
    :param destination_route: **path** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.path', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'path', 'keyval': 'destination_route', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, path=path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, path=path)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_path_downstream_sessions_delete(self, path=None, downstream_sessions=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type path: destination_route
    :param path: Keyword argument tuple.

    :type destination_route: unicode
    :param destination_route: **path** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type downstream_sessions: ip
    :param downstream_sessions: Keyword argument tuple.

    :type ip: unicode
    :param ip: **downstream_sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.path', u'path')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.path.downstream_sessions', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'destination_route', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'downstream_sessions', 'keyval': 'ip', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, path=path, downstream_sessions=downstream_sessions)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, path=path, downstream_sessions=downstream_sessions)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_path_downstream_sessions_interface_delete(self, path=None, downstream_sessions=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type path: destination_route
    :param path: Keyword argument tuple.

    :type destination_route: unicode
    :param destination_route: **path** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type downstream_sessions: ip
    :param downstream_sessions: Keyword argument tuple.

    :type ip: unicode
    :param ip: **downstream_sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.path', u'path')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.path.downstream_sessions', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'destination_route', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'downstream_sessions', 'keyval': 'ip', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'interface'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, path=path, downstream_sessions=downstream_sessions)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, path=path, downstream_sessions=downstream_sessions)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_path_downstream_sessions_label_delete(self, path=None, downstream_sessions=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type path: destination_route
    :param path: Keyword argument tuple.

    :type destination_route: unicode
    :param destination_route: **path** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type downstream_sessions: ip
    :param downstream_sessions: Keyword argument tuple.

    :type ip: unicode
    :param ip: **downstream_sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.path', u'path')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.path.downstream_sessions', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'destination_route', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'downstream_sessions', 'keyval': 'ip', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'label'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, path=path, downstream_sessions=downstream_sessions)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, path=path, downstream_sessions=downstream_sessions)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_path_downstream_sessions_labelspace_delete(self, path=None, downstream_sessions=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type path: destination_route
    :param path: Keyword argument tuple.

    :type destination_route: unicode
    :param destination_route: **path** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type downstream_sessions: ip
    :param downstream_sessions: Keyword argument tuple.

    :type ip: unicode
    :param ip: **downstream_sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.path', u'path')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.path.downstream_sessions', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'destination_route', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'downstream_sessions', 'keyval': 'ip', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'labelspace'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, path=path, downstream_sessions=downstream_sessions)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, path=path, downstream_sessions=downstream_sessions)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_path_upstream_sessions_delete(self, path=None, upstream_sessions=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type path: destination_route
    :param path: Keyword argument tuple.

    :type destination_route: unicode
    :param destination_route: **path** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type upstream_sessions: ip
    :param upstream_sessions: Keyword argument tuple.

    :type ip: unicode
    :param ip: **upstream_sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.path', u'path')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.path.upstream_sessions', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'destination_route', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'upstream_sessions', 'keyval': 'ip', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, path=path, upstream_sessions=upstream_sessions)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, path=path, upstream_sessions=upstream_sessions)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_path_upstream_sessions_interface_delete(self, path=None, upstream_sessions=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type path: destination_route
    :param path: Keyword argument tuple.

    :type destination_route: unicode
    :param destination_route: **path** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type upstream_sessions: ip
    :param upstream_sessions: Keyword argument tuple.

    :type ip: unicode
    :param ip: **upstream_sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.path', u'path')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.path.upstream_sessions', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'destination_route', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'upstream_sessions', 'keyval': 'ip', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'interface'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, path=path, upstream_sessions=upstream_sessions)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, path=path, upstream_sessions=upstream_sessions)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_path_upstream_sessions_label_delete(self, path=None, upstream_sessions=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type path: destination_route
    :param path: Keyword argument tuple.

    :type destination_route: unicode
    :param destination_route: **path** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type upstream_sessions: ip
    :param upstream_sessions: Keyword argument tuple.

    :type ip: unicode
    :param ip: **upstream_sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.path', u'path')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.path.upstream_sessions', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'destination_route', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'upstream_sessions', 'keyval': 'ip', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'label'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, path=path, upstream_sessions=upstream_sessions)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, path=path, upstream_sessions=upstream_sessions)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_path_upstream_sessions_labelspace_delete(self, path=None, upstream_sessions=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type path: destination_route
    :param path: Keyword argument tuple.

    :type destination_route: unicode
    :param destination_route: **path** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type upstream_sessions: ip
    :param upstream_sessions: Keyword argument tuple.

    :type ip: unicode
    :param ip: **upstream_sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.path', u'path')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.path.upstream_sessions', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'destination_route', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'upstream_sessions', 'keyval': 'ip', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'labelspace'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, path=path, upstream_sessions=upstream_sessions)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, path=path, upstream_sessions=upstream_sessions)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_statistics_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.statistics', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_statistics_ldp_protocol_errors_instance_since_clear_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.statistics.ldp_protocol_errors_instance_since_clear', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_statistics_ldp_protocol_errors_instance_since_clear_protocol_errors_delete(self, protocol_errors=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type protocol_errors: error_type
    :param protocol_errors: Keyword argument tuple.

    :type error_type: long
    :param error_type: **protocol_errors** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.statistics.ldp_protocol_errors_instance_since_clear.protocol_errors', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'protocol_errors', 'keyval': 'error_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, protocol_errors=protocol_errors)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, protocol_errors=protocol_errors)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_statistics_ldp_protocol_errors_instance_since_clear_protocol_errors_count_delete(self, protocol_errors=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type protocol_errors: error_type
    :param protocol_errors: Keyword argument tuple.

    :type error_type: long
    :param error_type: **protocol_errors** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.statistics.ldp_protocol_errors_instance_since_clear.protocol_errors', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'protocol_errors', 'keyval': 'error_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, protocol_errors=protocol_errors)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, protocol_errors=protocol_errors)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_statistics_ldp_protocol_errors_instance_total_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.statistics.ldp_protocol_errors_instance_total', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_statistics_ldp_protocol_errors_instance_total_protocol_errors_delete(self, protocol_errors=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type protocol_errors: error_type
    :param protocol_errors: Keyword argument tuple.

    :type error_type: long
    :param error_type: **protocol_errors** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.statistics.ldp_protocol_errors_instance_total.protocol_errors', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'protocol_errors', 'keyval': 'error_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, protocol_errors=protocol_errors)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, protocol_errors=protocol_errors)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_statistics_ldp_protocol_errors_instance_total_protocol_errors_count_delete(self, protocol_errors=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type protocol_errors: error_type
    :param protocol_errors: Keyword argument tuple.

    :type error_type: long
    :param error_type: **protocol_errors** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.statistics.ldp_protocol_errors_instance_total.protocol_errors', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'protocol_errors', 'keyval': 'error_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, protocol_errors=protocol_errors)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, protocol_errors=protocol_errors)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_statistics_ldp_protocol_stats_instance_since_clear_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.statistics.ldp_protocol_stats_instance_since_clear', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_statistics_ldp_protocol_stats_instance_since_clear_protocol_stats_delete(self, protocol_stats=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type protocol_stats: stat_type
    :param protocol_stats: Keyword argument tuple.

    :type stat_type: long
    :param stat_type: **protocol_stats** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.statistics.ldp_protocol_stats_instance_since_clear.protocol_stats', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'protocol_stats', 'keyval': 'stat_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, protocol_stats=protocol_stats)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, protocol_stats=protocol_stats)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_statistics_ldp_protocol_stats_instance_since_clear_protocol_stats_rx_count_delete(self, protocol_stats=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type protocol_stats: stat_type
    :param protocol_stats: Keyword argument tuple.

    :type stat_type: long
    :param stat_type: **protocol_stats** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.statistics.ldp_protocol_stats_instance_since_clear.protocol_stats', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'protocol_stats', 'keyval': 'stat_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rx-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, protocol_stats=protocol_stats)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, protocol_stats=protocol_stats)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_statistics_ldp_protocol_stats_instance_since_clear_protocol_stats_tx_count_delete(self, protocol_stats=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type protocol_stats: stat_type
    :param protocol_stats: Keyword argument tuple.

    :type stat_type: long
    :param stat_type: **protocol_stats** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.statistics.ldp_protocol_stats_instance_since_clear.protocol_stats', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'protocol_stats', 'keyval': 'stat_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tx-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, protocol_stats=protocol_stats)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, protocol_stats=protocol_stats)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_statistics_ldp_protocol_stats_instance_total_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.statistics.ldp_protocol_stats_instance_total', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_statistics_ldp_protocol_stats_instance_total_protocol_stats_delete(self, protocol_stats=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type protocol_stats: stat_type
    :param protocol_stats: Keyword argument tuple.

    :type stat_type: long
    :param stat_type: **protocol_stats** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.statistics.ldp_protocol_stats_instance_total.protocol_stats', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'protocol_stats', 'keyval': 'stat_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, protocol_stats=protocol_stats)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, protocol_stats=protocol_stats)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_statistics_ldp_protocol_stats_instance_total_protocol_stats_rx_count_delete(self, protocol_stats=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type protocol_stats: stat_type
    :param protocol_stats: Keyword argument tuple.

    :type stat_type: long
    :param stat_type: **protocol_stats** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.statistics.ldp_protocol_stats_instance_total.protocol_stats', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'protocol_stats', 'keyval': 'stat_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rx-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, protocol_stats=protocol_stats)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, protocol_stats=protocol_stats)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_statistics_ldp_protocol_stats_instance_total_protocol_stats_tx_count_delete(self, protocol_stats=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type protocol_stats: stat_type
    :param protocol_stats: Keyword argument tuple.

    :type stat_type: long
    :param stat_type: **protocol_stats** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.statistics.ldp_protocol_stats_instance_total.protocol_stats', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'protocol_stats', 'keyval': 'stat_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tx-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, protocol_stats=protocol_stats)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, protocol_stats=protocol_stats)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_targeted_peer_delete(self, targeted_peer=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type targeted_peer: mpls_ldp_targeted_peer_id
    :param targeted_peer: Keyword argument tuple.

    :type mpls_ldp_targeted_peer_id: unicode
    :param mpls_ldp_targeted_peer_id: **targeted_peer** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.targeted_peer', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'targeted_peer', 'keyval': 'mpls_ldp_targeted_peer_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, targeted_peer=targeted_peer)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, targeted_peer=targeted_peer)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_tunnels_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.tunnels', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_tunnels_ldp_tunnels_delete(self, ldp_tunnels=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ldp_tunnels: tunnel_destination, prefix_length
    :param ldp_tunnels: Keyword argument tuple.

    :type tunnel_destination: unicode
    :param tunnel_destination: **ldp_tunnels** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type prefix_length: long
    :param prefix_length: **ldp_tunnels** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.tunnels.ldp_tunnels', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_tunnels', 'keyval': 'tunnel_destination, prefix_length', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_tunnels=ldp_tunnels)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_tunnels=ldp_tunnels)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_tunnels_ldp_tunnels_name_delete(self, ldp_tunnels=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ldp_tunnels: tunnel_destination, prefix_length
    :param ldp_tunnels: Keyword argument tuple.

    :type tunnel_destination: unicode
    :param tunnel_destination: **ldp_tunnels** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type prefix_length: long
    :param prefix_length: **ldp_tunnels** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.tunnels.ldp_tunnels', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_tunnels', 'keyval': 'tunnel_destination, prefix_length', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_tunnels=ldp_tunnels)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_tunnels=ldp_tunnels)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_tunnels_ldp_tunnels_out_segments_delete(self, ldp_tunnels=None, out_segments=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_tunnels: tunnel_destination, prefix_length
    :param ldp_tunnels: Keyword argument tuple.

    :type tunnel_destination: unicode
    :param tunnel_destination: **ldp_tunnels** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type prefix_length: long
    :param prefix_length: **ldp_tunnels** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type out_segments: outgoing_interface
    :param out_segments: Keyword argument tuple.

    :type outgoing_interface: unicode
    :param outgoing_interface: **out_segments** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.tunnels.ldp_tunnels', u'ldp_tunnels')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.tunnels.ldp_tunnels.out_segments', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'tunnel_destination, prefix_length', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'out_segments', 'keyval': 'outgoing_interface', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_tunnels=ldp_tunnels, out_segments=out_segments)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_tunnels=ldp_tunnels, out_segments=out_segments)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_tunnels_ldp_tunnels_out_segments_next_hop_ipaddress_delete(self, ldp_tunnels=None, out_segments=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_tunnels: tunnel_destination, prefix_length
    :param ldp_tunnels: Keyword argument tuple.

    :type tunnel_destination: unicode
    :param tunnel_destination: **ldp_tunnels** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type prefix_length: long
    :param prefix_length: **ldp_tunnels** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type out_segments: outgoing_interface
    :param out_segments: Keyword argument tuple.

    :type outgoing_interface: unicode
    :param outgoing_interface: **out_segments** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.tunnels.ldp_tunnels', u'ldp_tunnels')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.tunnels.ldp_tunnels.out_segments', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'tunnel_destination, prefix_length', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'out_segments', 'keyval': 'outgoing_interface', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'next-hop-ipaddress'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_tunnels=ldp_tunnels, out_segments=out_segments)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_tunnels=ldp_tunnels, out_segments=out_segments)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_tunnels_ldp_tunnels_protocol_type_delete(self, ldp_tunnels=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ldp_tunnels: tunnel_destination, prefix_length
    :param ldp_tunnels: Keyword argument tuple.

    :type tunnel_destination: unicode
    :param tunnel_destination: **ldp_tunnels** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type prefix_length: long
    :param prefix_length: **ldp_tunnels** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.tunnels.ldp_tunnels', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_tunnels', 'keyval': 'tunnel_destination, prefix_length', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'protocol-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_tunnels=ldp_tunnels)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_tunnels=ldp_tunnels)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_tunnels_ldp_tunnels_tunnel_interface_index_delete(self, ldp_tunnels=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ldp_tunnels: tunnel_destination, prefix_length
    :param ldp_tunnels: Keyword argument tuple.

    :type tunnel_destination: unicode
    :param tunnel_destination: **ldp_tunnels** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type prefix_length: long
    :param prefix_length: **ldp_tunnels** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.tunnels.ldp_tunnels', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_tunnels', 'keyval': 'tunnel_destination, prefix_length', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tunnel-interface-index'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_tunnels=ldp_tunnels)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_tunnels=ldp_tunnels)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_tunnels_ldp_tunnels_tunnel_metric_delete(self, ldp_tunnels=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ldp_tunnels: tunnel_destination, prefix_length
    :param ldp_tunnels: Keyword argument tuple.

    :type tunnel_destination: unicode
    :param tunnel_destination: **ldp_tunnels** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type prefix_length: long
    :param prefix_length: **ldp_tunnels** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.tunnels.ldp_tunnels', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_tunnels', 'keyval': 'tunnel_destination, prefix_length', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tunnel-metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_tunnels=ldp_tunnels)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_tunnels=ldp_tunnels)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_tunnels_ldp_tunnels_tunnel_vif_delete(self, ldp_tunnels=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ldp_tunnels: tunnel_destination, prefix_length
    :param ldp_tunnels: Keyword argument tuple.

    :type tunnel_destination: unicode
    :param tunnel_destination: **ldp_tunnels** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type prefix_length: long
    :param prefix_length: **ldp_tunnels** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.tunnels.ldp_tunnels', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_tunnels', 'keyval': 'tunnel_destination, prefix_length', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tunnel-vif'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_tunnels=ldp_tunnels)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_tunnels=ldp_tunnels)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_ldp_tunnels_total_tunnel_count_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.ldp.tunnels', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'total-tunnel-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'lsp', 'keyval': 'lsp_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_backup_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.backup', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_backup_backup_count_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.backup', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'backup-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_backup_backup_ingress_delete(self, lsp=None, backup_ingress=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type backup_ingress: backup_from_address, backup_to_address, backup_name
    :param backup_ingress: Keyword argument tuple.

    :type backup_from_address: unicode
    :param backup_from_address: **backup_ingress** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type backup_to_address: unicode
    :param backup_to_address: **backup_ingress** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type backup_name: unicode
    :param backup_name: **backup_ingress** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.backup.backup_ingress', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'backup_ingress', 'keyval': 'backup_from_address, backup_to_address, backup_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, backup_ingress=backup_ingress)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, backup_ingress=backup_ingress)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_backup_backup_ingress_active_count_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.backup', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'backup-ingress-active-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_backup_backup_ingress_backup_is_active_delete(self, lsp=None, backup_ingress=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type backup_ingress: backup_from_address, backup_to_address, backup_name
    :param backup_ingress: Keyword argument tuple.

    :type backup_from_address: unicode
    :param backup_from_address: **backup_ingress** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type backup_to_address: unicode
    :param backup_to_address: **backup_ingress** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type backup_name: unicode
    :param backup_name: **backup_ingress** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.backup.backup_ingress', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'backup_ingress', 'keyval': 'backup_from_address, backup_to_address, backup_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'backup-is-active'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, backup_ingress=backup_ingress)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, backup_ingress=backup_ingress)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_backup_backup_ingress_backup_type_ingress_delete(self, lsp=None, backup_ingress=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type backup_ingress: backup_from_address, backup_to_address, backup_name
    :param backup_ingress: Keyword argument tuple.

    :type backup_from_address: unicode
    :param backup_from_address: **backup_ingress** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type backup_to_address: unicode
    :param backup_to_address: **backup_ingress** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type backup_name: unicode
    :param backup_name: **backup_ingress** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.backup.backup_ingress', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'backup_ingress', 'keyval': 'backup_from_address, backup_to_address, backup_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'backup-type-ingress'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, backup_ingress=backup_ingress)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, backup_ingress=backup_ingress)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_backup_backup_ingress_backup_type_transit_delete(self, lsp=None, backup_ingress=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type backup_ingress: backup_from_address, backup_to_address, backup_name
    :param backup_ingress: Keyword argument tuple.

    :type backup_from_address: unicode
    :param backup_from_address: **backup_ingress** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type backup_to_address: unicode
    :param backup_to_address: **backup_ingress** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type backup_name: unicode
    :param backup_name: **backup_ingress** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.backup.backup_ingress', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'backup_ingress', 'keyval': 'backup_from_address, backup_to_address, backup_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'backup-type-transit'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, backup_ingress=backup_ingress)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, backup_ingress=backup_ingress)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_backup_backup_ingress_count_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.backup', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'backup-ingress-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_backup_backup_present_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.backup', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'backup-present'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_backup_backup_transit_delete(self, lsp=None, backup_transit=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type backup_transit: backup_from_address, backup_to_address, backup_name
    :param backup_transit: Keyword argument tuple.

    :type backup_from_address: unicode
    :param backup_from_address: **backup_transit** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type backup_to_address: unicode
    :param backup_to_address: **backup_transit** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type backup_name: unicode
    :param backup_name: **backup_transit** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.backup.backup_transit', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'backup_transit', 'keyval': 'backup_from_address, backup_to_address, backup_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, backup_transit=backup_transit)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, backup_transit=backup_transit)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_backup_backup_transit_active_count_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.backup', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'backup-transit-active-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_backup_backup_transit_backup_is_active_delete(self, lsp=None, backup_transit=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type backup_transit: backup_from_address, backup_to_address, backup_name
    :param backup_transit: Keyword argument tuple.

    :type backup_from_address: unicode
    :param backup_from_address: **backup_transit** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type backup_to_address: unicode
    :param backup_to_address: **backup_transit** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type backup_name: unicode
    :param backup_name: **backup_transit** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.backup.backup_transit', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'backup_transit', 'keyval': 'backup_from_address, backup_to_address, backup_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'backup-is-active'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, backup_transit=backup_transit)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, backup_transit=backup_transit)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_backup_backup_transit_backup_type_ingress_delete(self, lsp=None, backup_transit=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type backup_transit: backup_from_address, backup_to_address, backup_name
    :param backup_transit: Keyword argument tuple.

    :type backup_from_address: unicode
    :param backup_from_address: **backup_transit** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type backup_to_address: unicode
    :param backup_to_address: **backup_transit** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type backup_name: unicode
    :param backup_name: **backup_transit** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.backup.backup_transit', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'backup_transit', 'keyval': 'backup_from_address, backup_to_address, backup_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'backup-type-ingress'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, backup_transit=backup_transit)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, backup_transit=backup_transit)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_backup_backup_transit_backup_type_transit_delete(self, lsp=None, backup_transit=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type backup_transit: backup_from_address, backup_to_address, backup_name
    :param backup_transit: Keyword argument tuple.

    :type backup_from_address: unicode
    :param backup_from_address: **backup_transit** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type backup_to_address: unicode
    :param backup_to_address: **backup_transit** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type backup_name: unicode
    :param backup_name: **backup_transit** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.backup.backup_transit', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'backup_transit', 'keyval': 'backup_from_address, backup_to_address, backup_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'backup-type-transit'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, backup_transit=backup_transit)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, backup_transit=backup_transit)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_backup_backup_transit_count_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.backup', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'backup-transit-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_basic_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.basic', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_basic_admin_up_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.basic', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'admin-up'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_basic_down_reason_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.basic', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'down-reason'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_basic_from_address_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.basic', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'from-address'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_basic_from_address_configured_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.basic', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'from-address-configured'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_basic_frr_active_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.basic', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'frr-active'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_basic_frr_up_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.basic', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'frr-up'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_basic_lsp_has_frr_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.basic', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lsp-has-frr'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_basic_lsp_has_primary_path_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.basic', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lsp-has-primary-path'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_basic_lsp_has_secondary_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.basic', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lsp-has-secondary'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_basic_lsp_has_selected_secondary_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.basic', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lsp-has-selected-secondary'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_basic_lsp_is_active_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.basic', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lsp-is-active'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_basic_lsp_type_bypass_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.basic', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lsp-type-bypass'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_basic_lsp_type_dynamic_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.basic', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lsp-type-dynamic'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_basic_operational_status_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.basic', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'operational-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_basic_out_interface_name_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.basic', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'out-interface-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_basic_out_label_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.basic', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'out-label'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_basic_path_name_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.basic', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'path-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_basic_primary_active_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.basic', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'primary-active'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_basic_primary_is_selected_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.basic', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'primary-is-selected'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_basic_primary_up_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.basic', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'primary-up'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_basic_retry_count_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.basic', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'retry-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_basic_secondary_active_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.basic', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'secondary-active'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_basic_secondary_up_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.basic', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'secondary-up'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_basic_selected_secondary_active_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.basic', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'selected-secondary-active'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_basic_selected_secondary_up_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.basic', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'selected-secondary-up'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_basic_to_address_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.basic', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'to-address'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_basic_tunnel_vif_index_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.basic', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tunnel-vif-index'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_basic_up_down_count_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.basic', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'up-down-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_bypass_lsp_type_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'lsp', 'keyval': 'lsp_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bypass-lsp-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_forwarding_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.forwarding', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_forwarding_forwarding_up_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.forwarding', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'forwarding-up'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_forwarding_frr_active_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.forwarding', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'frr-active'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_forwarding_frr_up_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.forwarding', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'frr-up'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_forwarding_instance_id_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.forwarding', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'instance-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_forwarding_lsp_id_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.forwarding', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lsp-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_forwarding_out_label_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.forwarding', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'out-label'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_forwarding_out_port_id_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.forwarding', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'out-port-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_forwarding_out_port_name_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.forwarding', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'out-port-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_forwarding_primary_active_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.forwarding', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'primary-active'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_forwarding_primary_up_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.forwarding', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'primary-up'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_forwarding_secondary_active_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.forwarding', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'secondary-active'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_forwarding_secondary_up_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.forwarding', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'secondary-up'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_forwarding_selected_secondary_active_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.forwarding', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'selected-secondary-active'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_forwarding_selected_secondary_up_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.forwarding', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'selected-secondary-up'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_forwarding_tunnel_vif_index_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.forwarding', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tunnel-vif-index'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_frr_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.frr', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_frr_active_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.frr', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'active'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_frr_admin_group_configured_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.frr', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'admin-group-configured'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_frr_bandwidth_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.frr', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bandwidth'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_frr_bandwidth_configured_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.frr', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bandwidth-configured'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_frr_bypass_name_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.frr', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bypass-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_frr_computation_mode_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.frr', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'computation-mode'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_frr_configured_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.frr', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'configured'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_frr_down_reason_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.frr', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'down-reason'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_frr_exclude_any_delete(self, lsp=None, exclude_any=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type exclude_any: admin_group_id
    :param exclude_any: Keyword argument tuple.

    :type admin_group_id: long
    :param admin_group_id: **exclude_any** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.frr.exclude_any', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'exclude_any', 'keyval': 'admin_group_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, exclude_any=exclude_any)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, exclude_any=exclude_any)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_frr_exclude_any_admin_group_name_delete(self, lsp=None, exclude_any=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type exclude_any: admin_group_id
    :param exclude_any: Keyword argument tuple.

    :type admin_group_id: long
    :param admin_group_id: **exclude_any** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.frr.exclude_any', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'exclude_any', 'keyval': 'admin_group_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'admin-group-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, exclude_any=exclude_any)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, exclude_any=exclude_any)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_frr_frr_up_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.frr', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'frr-up'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_frr_fwdg_state_detour_active_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.frr', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'fwdg-state-detour-active'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_frr_fwdg_state_detour_down_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.frr', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'fwdg-state-detour-down'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_frr_fwdg_state_detour_up_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.frr', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'fwdg-state-detour-up'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_frr_fwdg_state_primary_active_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.frr', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'fwdg-state-primary-active'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_frr_fwdg_state_primary_down_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.frr', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'fwdg-state-primary-down'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_frr_fwdg_state_primary_up_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.frr', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'fwdg-state-primary-up'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_frr_fwdg_state_secondary_active_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.frr', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'fwdg-state-secondary-active'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_frr_fwdg_state_secondary_down_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.frr', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'fwdg-state-secondary-down'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_frr_fwdg_state_secondary_up_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.frr', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'fwdg-state-secondary-up'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_frr_global_revertive_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.frr', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'global-revertive'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_frr_group_computation_mode_add_penalty_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.frr', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'group-computation-mode-add-penalty'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_frr_group_computation_mode_default_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.frr', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'group-computation-mode-default'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_frr_group_computation_mode_exclude_groups_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.frr', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'group-computation-mode-exclude-groups'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_frr_group_computation_mode_high_cost_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.frr', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'group-computation-mode-high-cost'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_frr_has_secondary_swithover_time_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.frr', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'has-secondary-swithover-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_frr_hold_time_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.frr', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hold-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_frr_holding_priority_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.frr', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'holding-priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_frr_hop_limit_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.frr', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hop-limit'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_frr_hop_limit_configured_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.frr', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hop-limit-configured'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_frr_include_all_delete(self, lsp=None, include_all=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type include_all: admin_group_id
    :param include_all: Keyword argument tuple.

    :type admin_group_id: long
    :param admin_group_id: **include_all** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.frr.include_all', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'include_all', 'keyval': 'admin_group_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, include_all=include_all)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, include_all=include_all)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_frr_include_all_admin_group_name_delete(self, lsp=None, include_all=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type include_all: admin_group_id
    :param include_all: Keyword argument tuple.

    :type admin_group_id: long
    :param admin_group_id: **include_all** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.frr.include_all', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'include_all', 'keyval': 'admin_group_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'admin-group-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, include_all=include_all)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, include_all=include_all)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_frr_include_any_delete(self, lsp=None, include_any=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type include_any: admin_group_id
    :param include_any: Keyword argument tuple.

    :type admin_group_id: long
    :param admin_group_id: **include_any** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.frr.include_any', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'include_any', 'keyval': 'admin_group_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, include_any=include_any)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, include_any=include_any)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_frr_include_any_admin_group_name_delete(self, lsp=None, include_any=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type include_any: admin_group_id
    :param include_any: Keyword argument tuple.

    :type admin_group_id: long
    :param admin_group_id: **include_any** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.frr.include_any', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'include_any', 'keyval': 'admin_group_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'admin-group-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, include_any=include_any)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, include_any=include_any)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_frr_one_to_many_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.frr', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'one-to-many'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_frr_one_to_one_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.frr', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'one-to-one'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_frr_out_label_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.frr', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'out-label'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_frr_out_port_id_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.frr', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'out-port-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_frr_out_port_name_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.frr', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'out-port-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_frr_path_cost_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.frr', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'path-cost'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_frr_priority_configured_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.frr', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority-configured'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_frr_protection_type_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.frr', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'protection-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_frr_revertive_timer_expired_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.frr', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'revertive-timer-expired'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_frr_secondary_swithover_time_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.frr', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'secondary-swithover-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_frr_setup_priority_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.frr', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'setup-priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_config_abw_configured_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-abw-configured'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_config_adaptive_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-adaptive'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_config_admin_group_configured_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-admin-group-configured'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_config_admin_up_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-admin-up'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_config_bfd_configured_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-bfd-configured'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_config_cos_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-cos'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_config_cos_configured_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-cos-configured'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_config_cspf_computation_mode_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-cspf-computation-mode'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_config_cspf_disabled_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-cspf-disabled'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_config_enable_ldp_tunnelling_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-enable-ldp-tunnelling'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_config_exclude_any_delete(self, lsp=None, instances=None, config_exclude_any=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type config_exclude_any: admin_group_id
    :param config_exclude_any: Keyword argument tuple.

    :type admin_group_id: long
    :param admin_group_id: **config_exclude_any** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp'), ('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', u'instances')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances.config_exclude_any', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'config_exclude_any', 'keyval': 'admin_group_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances, config_exclude_any=config_exclude_any)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances, config_exclude_any=config_exclude_any)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_config_exclude_any_admin_group_name_delete(self, lsp=None, instances=None, config_exclude_any=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type config_exclude_any: admin_group_id
    :param config_exclude_any: Keyword argument tuple.

    :type admin_group_id: long
    :param admin_group_id: **config_exclude_any** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp'), ('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', u'instances')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances.config_exclude_any', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'config_exclude_any', 'keyval': 'admin_group_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'admin-group-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances, config_exclude_any=config_exclude_any)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances, config_exclude_any=config_exclude_any)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_config_exclude_interface_change_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-exclude-interface-change'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_config_exclude_interface_configured_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-exclude-interface-configured'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_config_exclude_interfaces_delete(self, lsp=None, instances=None, config_exclude_interfaces=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type config_exclude_interfaces: exclude_interface_name
    :param config_exclude_interfaces: Keyword argument tuple.

    :type exclude_interface_name: unicode
    :param exclude_interface_name: **config_exclude_interfaces** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp'), ('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', u'instances')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances.config_exclude_interfaces', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'config_exclude_interfaces', 'keyval': 'exclude_interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances, config_exclude_interfaces=config_exclude_interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances, config_exclude_interfaces=config_exclude_interfaces)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_config_from_address_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-from-address'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_config_from_address_configured_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-from-address-configured'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_config_frr_admin_group_configured_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-frr-admin-group-configured'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_config_frr_bandwidth_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-frr-bandwidth'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_config_frr_bandwidth_configured_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-frr-bandwidth-configured'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_config_frr_configured_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-frr-configured'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_config_frr_exclude_any_delete(self, lsp=None, instances=None, config_frr_exclude_any=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type config_frr_exclude_any: admin_group_id
    :param config_frr_exclude_any: Keyword argument tuple.

    :type admin_group_id: long
    :param admin_group_id: **config_frr_exclude_any** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp'), ('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', u'instances')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances.config_frr_exclude_any', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'config_frr_exclude_any', 'keyval': 'admin_group_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances, config_frr_exclude_any=config_frr_exclude_any)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances, config_frr_exclude_any=config_frr_exclude_any)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_config_frr_exclude_any_admin_group_name_delete(self, lsp=None, instances=None, config_frr_exclude_any=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type config_frr_exclude_any: admin_group_id
    :param config_frr_exclude_any: Keyword argument tuple.

    :type admin_group_id: long
    :param admin_group_id: **config_frr_exclude_any** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp'), ('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', u'instances')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances.config_frr_exclude_any', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'config_frr_exclude_any', 'keyval': 'admin_group_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'admin-group-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances, config_frr_exclude_any=config_frr_exclude_any)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances, config_frr_exclude_any=config_frr_exclude_any)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_config_frr_global_revertive_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-frr-global-revertive'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_config_frr_hold_time_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-frr-hold-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_config_frr_holding_priority_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-frr-holding-priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_config_frr_hop_limit_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-frr-hop-limit'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_config_frr_hop_limit_configured_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-frr-hop-limit-configured'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_config_frr_include_all_delete(self, lsp=None, instances=None, config_frr_include_all=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type config_frr_include_all: admin_group_id
    :param config_frr_include_all: Keyword argument tuple.

    :type admin_group_id: long
    :param admin_group_id: **config_frr_include_all** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp'), ('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', u'instances')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances.config_frr_include_all', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'config_frr_include_all', 'keyval': 'admin_group_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances, config_frr_include_all=config_frr_include_all)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances, config_frr_include_all=config_frr_include_all)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_config_frr_include_all_admin_group_name_delete(self, lsp=None, instances=None, config_frr_include_all=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type config_frr_include_all: admin_group_id
    :param config_frr_include_all: Keyword argument tuple.

    :type admin_group_id: long
    :param admin_group_id: **config_frr_include_all** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp'), ('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', u'instances')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances.config_frr_include_all', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'config_frr_include_all', 'keyval': 'admin_group_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'admin-group-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances, config_frr_include_all=config_frr_include_all)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances, config_frr_include_all=config_frr_include_all)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_config_frr_include_any_delete(self, lsp=None, instances=None, config_frr_include_any=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type config_frr_include_any: admin_group_id
    :param config_frr_include_any: Keyword argument tuple.

    :type admin_group_id: long
    :param admin_group_id: **config_frr_include_any** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp'), ('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', u'instances')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances.config_frr_include_any', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'config_frr_include_any', 'keyval': 'admin_group_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances, config_frr_include_any=config_frr_include_any)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances, config_frr_include_any=config_frr_include_any)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_config_frr_include_any_admin_group_name_delete(self, lsp=None, instances=None, config_frr_include_any=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type config_frr_include_any: admin_group_id
    :param config_frr_include_any: Keyword argument tuple.

    :type admin_group_id: long
    :param admin_group_id: **config_frr_include_any** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp'), ('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', u'instances')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances.config_frr_include_any', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'config_frr_include_any', 'keyval': 'admin_group_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'admin-group-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances, config_frr_include_any=config_frr_include_any)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances, config_frr_include_any=config_frr_include_any)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_config_frr_one_to_many_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-frr-one-to-many'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_config_frr_one_to_one_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-frr-one-to-one'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_config_frr_priority_configured_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-frr-priority-configured'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_config_frr_setup_priority_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-frr-setup-priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_config_holding_prority_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-holding-prority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_config_hop_limit_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-hop-limit'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_config_hop_limit_configured_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-hop-limit-configured'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_config_hot_standby_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-hot-standby'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_config_include_all_delete(self, lsp=None, instances=None, config_include_all=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type config_include_all: admin_group_id
    :param config_include_all: Keyword argument tuple.

    :type admin_group_id: long
    :param admin_group_id: **config_include_all** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp'), ('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', u'instances')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances.config_include_all', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'config_include_all', 'keyval': 'admin_group_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances, config_include_all=config_include_all)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances, config_include_all=config_include_all)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_config_include_all_admin_group_name_delete(self, lsp=None, instances=None, config_include_all=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type config_include_all: admin_group_id
    :param config_include_all: Keyword argument tuple.

    :type admin_group_id: long
    :param admin_group_id: **config_include_all** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp'), ('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', u'instances')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances.config_include_all', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'config_include_all', 'keyval': 'admin_group_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'admin-group-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances, config_include_all=config_include_all)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances, config_include_all=config_include_all)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_config_include_any_delete(self, lsp=None, instances=None, config_include_any=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type config_include_any: admin_group_id
    :param config_include_any: Keyword argument tuple.

    :type admin_group_id: long
    :param admin_group_id: **config_include_any** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp'), ('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', u'instances')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances.config_include_any', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'config_include_any', 'keyval': 'admin_group_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances, config_include_any=config_include_any)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances, config_include_any=config_include_any)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_config_include_any_admin_group_name_delete(self, lsp=None, instances=None, config_include_any=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type config_include_any: admin_group_id
    :param config_include_any: Keyword argument tuple.

    :type admin_group_id: long
    :param admin_group_id: **config_include_any** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp'), ('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', u'instances')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances.config_include_any', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'config_include_any', 'keyval': 'admin_group_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'admin-group-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances, config_include_any=config_include_any)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances, config_include_any=config_include_any)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_config_isis_announce_configured_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-isis-announce-configured'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_config_isis_announce_metric_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-isis-announce-metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_config_isis_ignore_metric_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-isis-ignore-metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_config_isis_level_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-isis-level'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_config_isis_relative_metric_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-isis-relative-metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_config_isis_shortcut_level_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-isis-shortcut-level'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_config_isis_shortcut_level_configured_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-isis-shortcut-level-configured'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_config_metric_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_config_metric_configured_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-metric-configured'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_config_mtu_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-mtu'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_config_mtu_configured_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-mtu-configured'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_config_notify_isis_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-notify-isis'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_config_notify_ospf_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-notify-ospf'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_config_number_of_retries_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-number-of-retries'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_config_number_of_retries_configured_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-number-of-retries-configured'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_config_ospf_aaf_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-ospf-aaf'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_config_ospf_announce_metric_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-ospf-announce-metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_config_ospf_area_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-ospf-area'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_config_ospf_ignore_metric_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-ospf-ignore-metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_config_ospf_relative_metric_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-ospf-relative-metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_config_path_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-path'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_config_path_configured_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-path-configured'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_config_path_select_mode_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-path-select-mode'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_config_path_selected_path_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-path-selected-path'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_config_path_selected_secondary_name_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-path-selected-secondary-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_config_persistenct_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-persistenct'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_config_pinned_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-pinned'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_config_prority_configured_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-prority-configured'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_config_reoptimize_time_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-reoptimize-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_config_reoptimize_timer_configured_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-reoptimize-timer-configured'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_config_retry_count_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-retry-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_config_retry_count_configured_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-retry-count-configured'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_config_revert_time_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-revert-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_config_revert_time_configured_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-revert-time-configured'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_config_rro_disabled_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-rro-disabled'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_config_setup_prority_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-setup-prority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_config_shortcut_area_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-shortcut-area'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_config_shortcut_area_configured_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-shortcut-area-configured'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_config_shortcut_isis_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-shortcut-isis'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_config_shortcut_ospf_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-shortcut-ospf'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_config_soft_prempt_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-soft-prempt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_config_tie_break_least_fill_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-tie-break-least-fill'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_config_tie_break_most_fill_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-tie-break-most-fill'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_config_tie_break_random_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-tie-break-random'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_config_tie_breaking_configured_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-tie-breaking-configured'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_config_to_address_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-to-address'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_config_traffic_eng_max_burst_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-traffic-eng-max-burst'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_config_traffic_eng_max_rate_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-traffic-eng-max-rate'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_config_traffic_eng_mean_rate_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-traffic-eng-mean-rate'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_config_traffic_eng_rate_configured_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-traffic-eng-rate-configured'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_config_tspec_mtu_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-tspec-mtu'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_config_tspec_mtu_configured_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-tspec-mtu-configured'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_config_type_bypass_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-type-bypass'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_config_type_dynamic_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-type-dynamic'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_cspf_computation_error_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cspf-computation-error'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_cspf_computation_mode_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cspf-computation-mode'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_cspf_exclude_hops_delete(self, lsp=None, instances=None, cspf_exclude_hops=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type cspf_exclude_hops: hop_index, hop_address
    :param cspf_exclude_hops: Keyword argument tuple.

    :type hop_index: long
    :param hop_index: **cspf_exclude_hops** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type hop_address: unicode
    :param hop_address: **cspf_exclude_hops** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp'), ('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', u'instances')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances.cspf_exclude_hops', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'cspf_exclude_hops', 'keyval': 'hop_index, hop_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances, cspf_exclude_hops=cspf_exclude_hops)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances, cspf_exclude_hops=cspf_exclude_hops)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_cspf_exclude_hops_bandwidth_protection_delete(self, lsp=None, instances=None, cspf_exclude_hops=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type cspf_exclude_hops: hop_index, hop_address
    :param cspf_exclude_hops: Keyword argument tuple.

    :type hop_index: long
    :param hop_index: **cspf_exclude_hops** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type hop_address: unicode
    :param hop_address: **cspf_exclude_hops** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp'), ('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', u'instances')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances.cspf_exclude_hops', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'cspf_exclude_hops', 'keyval': 'hop_index, hop_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bandwidth-protection'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances, cspf_exclude_hops=cspf_exclude_hops)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances, cspf_exclude_hops=cspf_exclude_hops)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_cspf_exclude_hops_hop_is_router_id_delete(self, lsp=None, instances=None, cspf_exclude_hops=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type cspf_exclude_hops: hop_index, hop_address
    :param cspf_exclude_hops: Keyword argument tuple.

    :type hop_index: long
    :param hop_index: **cspf_exclude_hops** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type hop_address: unicode
    :param hop_address: **cspf_exclude_hops** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp'), ('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', u'instances')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances.cspf_exclude_hops', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'cspf_exclude_hops', 'keyval': 'hop_index, hop_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hop-is-router-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances, cspf_exclude_hops=cspf_exclude_hops)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances, cspf_exclude_hops=cspf_exclude_hops)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_cspf_exclude_hops_node_protection_delete(self, lsp=None, instances=None, cspf_exclude_hops=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type cspf_exclude_hops: hop_index, hop_address
    :param cspf_exclude_hops: Keyword argument tuple.

    :type hop_index: long
    :param hop_index: **cspf_exclude_hops** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type hop_address: unicode
    :param hop_address: **cspf_exclude_hops** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp'), ('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', u'instances')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances.cspf_exclude_hops', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'cspf_exclude_hops', 'keyval': 'hop_index, hop_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'node-protection'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances, cspf_exclude_hops=cspf_exclude_hops)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances, cspf_exclude_hops=cspf_exclude_hops)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_cspf_exclude_hops_present_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cspf-exclude-hops-present'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_cspf_exclude_hops_protection_delete(self, lsp=None, instances=None, cspf_exclude_hops=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type cspf_exclude_hops: hop_index, hop_address
    :param cspf_exclude_hops: Keyword argument tuple.

    :type hop_index: long
    :param hop_index: **cspf_exclude_hops** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type hop_address: unicode
    :param hop_address: **cspf_exclude_hops** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp'), ('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', u'instances')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances.cspf_exclude_hops', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'cspf_exclude_hops', 'keyval': 'hop_index, hop_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'protection'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances, cspf_exclude_hops=cspf_exclude_hops)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances, cspf_exclude_hops=cspf_exclude_hops)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_cspf_exclude_hops_protection_in_use_delete(self, lsp=None, instances=None, cspf_exclude_hops=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type cspf_exclude_hops: hop_index, hop_address
    :param cspf_exclude_hops: Keyword argument tuple.

    :type hop_index: long
    :param hop_index: **cspf_exclude_hops** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type hop_address: unicode
    :param hop_address: **cspf_exclude_hops** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp'), ('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', u'instances')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances.cspf_exclude_hops', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'cspf_exclude_hops', 'keyval': 'hop_index, hop_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'protection-in-use'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances, cspf_exclude_hops=cspf_exclude_hops)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances, cspf_exclude_hops=cspf_exclude_hops)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_cspf_exclude_hops_type_delete(self, lsp=None, instances=None, cspf_exclude_hops=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type cspf_exclude_hops: hop_index, hop_address
    :param cspf_exclude_hops: Keyword argument tuple.

    :type hop_index: long
    :param hop_index: **cspf_exclude_hops** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type hop_address: unicode
    :param hop_address: **cspf_exclude_hops** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp'), ('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', u'instances')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances.cspf_exclude_hops', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'cspf_exclude_hops', 'keyval': 'hop_index, hop_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances, cspf_exclude_hops=cspf_exclude_hops)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances, cspf_exclude_hops=cspf_exclude_hops)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_cspf_group_computation_mode_add_penalty_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cspf-group-computation-mode-add-penalty'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_cspf_group_computation_mode_default_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cspf-group-computation-mode-default'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_cspf_group_computation_mode_exclude_groups_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cspf-group-computation-mode-exclude-groups'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_cspf_group_computation_mode_high_cost_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cspf-group-computation-mode-high-cost'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_cspf_path_area_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cspf-path-area'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_cspf_path_cost_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cspf-path-cost'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_cspf_path_hops_delete(self, lsp=None, instances=None, cspf_path_hops=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type cspf_path_hops: hop_index, hop_address
    :param cspf_path_hops: Keyword argument tuple.

    :type hop_index: long
    :param hop_index: **cspf_path_hops** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type hop_address: unicode
    :param hop_address: **cspf_path_hops** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp'), ('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', u'instances')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances.cspf_path_hops', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'cspf_path_hops', 'keyval': 'hop_index, hop_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances, cspf_path_hops=cspf_path_hops)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances, cspf_path_hops=cspf_path_hops)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_cspf_path_hops_bandwidth_protection_delete(self, lsp=None, instances=None, cspf_path_hops=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type cspf_path_hops: hop_index, hop_address
    :param cspf_path_hops: Keyword argument tuple.

    :type hop_index: long
    :param hop_index: **cspf_path_hops** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type hop_address: unicode
    :param hop_address: **cspf_path_hops** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp'), ('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', u'instances')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances.cspf_path_hops', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'cspf_path_hops', 'keyval': 'hop_index, hop_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bandwidth-protection'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances, cspf_path_hops=cspf_path_hops)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances, cspf_path_hops=cspf_path_hops)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_cspf_path_hops_hop_is_router_id_delete(self, lsp=None, instances=None, cspf_path_hops=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type cspf_path_hops: hop_index, hop_address
    :param cspf_path_hops: Keyword argument tuple.

    :type hop_index: long
    :param hop_index: **cspf_path_hops** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type hop_address: unicode
    :param hop_address: **cspf_path_hops** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp'), ('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', u'instances')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances.cspf_path_hops', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'cspf_path_hops', 'keyval': 'hop_index, hop_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hop-is-router-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances, cspf_path_hops=cspf_path_hops)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances, cspf_path_hops=cspf_path_hops)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_cspf_path_hops_node_protection_delete(self, lsp=None, instances=None, cspf_path_hops=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type cspf_path_hops: hop_index, hop_address
    :param cspf_path_hops: Keyword argument tuple.

    :type hop_index: long
    :param hop_index: **cspf_path_hops** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type hop_address: unicode
    :param hop_address: **cspf_path_hops** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp'), ('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', u'instances')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances.cspf_path_hops', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'cspf_path_hops', 'keyval': 'hop_index, hop_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'node-protection'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances, cspf_path_hops=cspf_path_hops)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances, cspf_path_hops=cspf_path_hops)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_cspf_path_hops_protection_delete(self, lsp=None, instances=None, cspf_path_hops=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type cspf_path_hops: hop_index, hop_address
    :param cspf_path_hops: Keyword argument tuple.

    :type hop_index: long
    :param hop_index: **cspf_path_hops** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type hop_address: unicode
    :param hop_address: **cspf_path_hops** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp'), ('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', u'instances')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances.cspf_path_hops', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'cspf_path_hops', 'keyval': 'hop_index, hop_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'protection'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances, cspf_path_hops=cspf_path_hops)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances, cspf_path_hops=cspf_path_hops)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_cspf_path_hops_protection_in_use_delete(self, lsp=None, instances=None, cspf_path_hops=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type cspf_path_hops: hop_index, hop_address
    :param cspf_path_hops: Keyword argument tuple.

    :type hop_index: long
    :param hop_index: **cspf_path_hops** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type hop_address: unicode
    :param hop_address: **cspf_path_hops** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp'), ('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', u'instances')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances.cspf_path_hops', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'cspf_path_hops', 'keyval': 'hop_index, hop_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'protection-in-use'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances, cspf_path_hops=cspf_path_hops)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances, cspf_path_hops=cspf_path_hops)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_cspf_path_hops_type_delete(self, lsp=None, instances=None, cspf_path_hops=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type cspf_path_hops: hop_index, hop_address
    :param cspf_path_hops: Keyword argument tuple.

    :type hop_index: long
    :param hop_index: **cspf_path_hops** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type hop_address: unicode
    :param hop_address: **cspf_path_hops** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp'), ('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', u'instances')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances.cspf_path_hops', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'cspf_path_hops', 'keyval': 'hop_index, hop_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances, cspf_path_hops=cspf_path_hops)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances, cspf_path_hops=cspf_path_hops)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_current_instance_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'current-instance'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_instance_admin_up_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'instance-admin-up'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_instance_down_reason_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'instance-down-reason'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_instance_frr_active_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'instance-frr-active'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_instance_frr_configured_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'instance-frr-configured'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_instance_frr_up_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'instance-frr-up'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_instance_is_active_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'instance-is-active'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_instance_is_up_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'instance-is-up'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_instance_metric_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'instance-metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_instance_out_label_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'instance-out-label'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_instance_out_port_id_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'instance-out-port-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_instance_out_port_name_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'instance-out-port-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_instance_retry_count_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'instance-retry-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_instance_revert_time_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'instance-revert-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_instance_up_down_count_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'instance-up-down-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_is_adaptive_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'is-adaptive'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_is_bypass_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'is-bypass'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_is_current_secondary_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'is-current-secondary'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_is_dynamic_bypass_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'is-dynamic-bypass'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_is_primary_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'is-primary'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_is_selected_secondary_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'is-selected-secondary'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_maximum_bandwidth_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'maximum-bandwidth'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_new_instance_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'new-instance'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_old_instance_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'old-instance'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_path_computed_by_cspf_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'path-computed-by-cspf'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_path_computed_by_interface_constraint_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'path-computed-by-interface-constraint'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_reoptimize_ignore_count_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'reoptimize-ignore-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_reoptimize_time_count_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'reoptimize-time-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_rsvp_session_path_error_code_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rsvp-session-path-error-code'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_rsvp_session_path_error_node_address_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rsvp-session-path-error-node-address'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_rsvp_session_path_error_value_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rsvp-session-path-error-value'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_rsvp_session_present_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rsvp-session-present'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_rsvp_session_rro_hops_delete(self, lsp=None, instances=None, rsvp_session_rro_hops=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type rsvp_session_rro_hops: hop_index, hop_address
    :param rsvp_session_rro_hops: Keyword argument tuple.

    :type hop_index: long
    :param hop_index: **rsvp_session_rro_hops** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type hop_address: unicode
    :param hop_address: **rsvp_session_rro_hops** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp'), ('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', u'instances')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances.rsvp_session_rro_hops', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'rsvp_session_rro_hops', 'keyval': 'hop_index, hop_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances, rsvp_session_rro_hops=rsvp_session_rro_hops)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances, rsvp_session_rro_hops=rsvp_session_rro_hops)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_rsvp_session_rro_hops_bandwidth_protection_delete(self, lsp=None, instances=None, rsvp_session_rro_hops=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type rsvp_session_rro_hops: hop_index, hop_address
    :param rsvp_session_rro_hops: Keyword argument tuple.

    :type hop_index: long
    :param hop_index: **rsvp_session_rro_hops** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type hop_address: unicode
    :param hop_address: **rsvp_session_rro_hops** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp'), ('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', u'instances')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances.rsvp_session_rro_hops', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'rsvp_session_rro_hops', 'keyval': 'hop_index, hop_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bandwidth-protection'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances, rsvp_session_rro_hops=rsvp_session_rro_hops)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances, rsvp_session_rro_hops=rsvp_session_rro_hops)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_rsvp_session_rro_hops_hop_is_router_id_delete(self, lsp=None, instances=None, rsvp_session_rro_hops=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type rsvp_session_rro_hops: hop_index, hop_address
    :param rsvp_session_rro_hops: Keyword argument tuple.

    :type hop_index: long
    :param hop_index: **rsvp_session_rro_hops** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type hop_address: unicode
    :param hop_address: **rsvp_session_rro_hops** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp'), ('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', u'instances')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances.rsvp_session_rro_hops', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'rsvp_session_rro_hops', 'keyval': 'hop_index, hop_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hop-is-router-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances, rsvp_session_rro_hops=rsvp_session_rro_hops)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances, rsvp_session_rro_hops=rsvp_session_rro_hops)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_rsvp_session_rro_hops_node_protection_delete(self, lsp=None, instances=None, rsvp_session_rro_hops=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type rsvp_session_rro_hops: hop_index, hop_address
    :param rsvp_session_rro_hops: Keyword argument tuple.

    :type hop_index: long
    :param hop_index: **rsvp_session_rro_hops** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type hop_address: unicode
    :param hop_address: **rsvp_session_rro_hops** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp'), ('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', u'instances')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances.rsvp_session_rro_hops', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'rsvp_session_rro_hops', 'keyval': 'hop_index, hop_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'node-protection'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances, rsvp_session_rro_hops=rsvp_session_rro_hops)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances, rsvp_session_rro_hops=rsvp_session_rro_hops)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_rsvp_session_rro_hops_present_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rsvp-session-rro-hops-present'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_rsvp_session_rro_hops_protection_delete(self, lsp=None, instances=None, rsvp_session_rro_hops=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type rsvp_session_rro_hops: hop_index, hop_address
    :param rsvp_session_rro_hops: Keyword argument tuple.

    :type hop_index: long
    :param hop_index: **rsvp_session_rro_hops** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type hop_address: unicode
    :param hop_address: **rsvp_session_rro_hops** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp'), ('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', u'instances')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances.rsvp_session_rro_hops', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'rsvp_session_rro_hops', 'keyval': 'hop_index, hop_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'protection'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances, rsvp_session_rro_hops=rsvp_session_rro_hops)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances, rsvp_session_rro_hops=rsvp_session_rro_hops)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_rsvp_session_rro_hops_protection_in_use_delete(self, lsp=None, instances=None, rsvp_session_rro_hops=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type rsvp_session_rro_hops: hop_index, hop_address
    :param rsvp_session_rro_hops: Keyword argument tuple.

    :type hop_index: long
    :param hop_index: **rsvp_session_rro_hops** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type hop_address: unicode
    :param hop_address: **rsvp_session_rro_hops** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp'), ('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', u'instances')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances.rsvp_session_rro_hops', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'rsvp_session_rro_hops', 'keyval': 'hop_index, hop_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'protection-in-use'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances, rsvp_session_rro_hops=rsvp_session_rro_hops)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances, rsvp_session_rro_hops=rsvp_session_rro_hops)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_rsvp_session_rro_hops_type_delete(self, lsp=None, instances=None, rsvp_session_rro_hops=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type rsvp_session_rro_hops: hop_index, hop_address
    :param rsvp_session_rro_hops: Keyword argument tuple.

    :type hop_index: long
    :param hop_index: **rsvp_session_rro_hops** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type hop_address: unicode
    :param hop_address: **rsvp_session_rro_hops** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp'), ('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', u'instances')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances.rsvp_session_rro_hops', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'rsvp_session_rro_hops', 'keyval': 'hop_index, hop_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances, rsvp_session_rro_hops=rsvp_session_rro_hops)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances, rsvp_session_rro_hops=rsvp_session_rro_hops)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_rsvp_session_state_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rsvp-session-state'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_rsvp_session_state_up_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rsvp-session-state-up'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_unreserved_priority_0_bandwidth_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'unreserved-priority-0-bandwidth'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_unreserved_priority_1_bandwidth_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'unreserved-priority-1-bandwidth'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_unreserved_priority_2_bandwidth_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'unreserved-priority-2-bandwidth'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_unreserved_priority_3_bandwidth_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'unreserved-priority-3-bandwidth'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_unreserved_priority_4_bandwidth_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'unreserved-priority-4-bandwidth'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_unreserved_priority_5_bandwidth_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'unreserved-priority-5-bandwidth'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_unreserved_priority_6_bandwidth_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'unreserved-priority-6-bandwidth'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_instances_unreserved_priority_7_bandwidth_delete(self, lsp=None, instances=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.instances', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'unreserved-priority-7-bandwidth'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_interface_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'lsp', 'keyval': 'lsp_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'interface'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_lsp_type_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'lsp', 'keyval': 'lsp_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lsp-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_secondary_path_delete(self, lsp=None, secondary_path=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type secondary_path: path_name
    :param secondary_path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **secondary_path** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.secondary_path', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'secondary_path', 'keyval': 'path_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_secondary_path_active_delete(self, lsp=None, secondary_path=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type secondary_path: path_name
    :param secondary_path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **secondary_path** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.secondary_path', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'secondary_path', 'keyval': 'path_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'active'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_secondary_path_committed_delete(self, lsp=None, secondary_path=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type secondary_path: path_name
    :param secondary_path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **secondary_path** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.secondary_path', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'secondary_path', 'keyval': 'path_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'committed'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_secondary_path_config_abw_configured_delete(self, lsp=None, secondary_path=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type secondary_path: path_name
    :param secondary_path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **secondary_path** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.secondary_path', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'secondary_path', 'keyval': 'path_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-abw-configured'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_secondary_path_config_adaptive_delete(self, lsp=None, secondary_path=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type secondary_path: path_name
    :param secondary_path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **secondary_path** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.secondary_path', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'secondary_path', 'keyval': 'path_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-adaptive'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_secondary_path_config_admin_group_configured_delete(self, lsp=None, secondary_path=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type secondary_path: path_name
    :param secondary_path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **secondary_path** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.secondary_path', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'secondary_path', 'keyval': 'path_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-admin-group-configured'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_secondary_path_config_cos_delete(self, lsp=None, secondary_path=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type secondary_path: path_name
    :param secondary_path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **secondary_path** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.secondary_path', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'secondary_path', 'keyval': 'path_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-cos'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_secondary_path_config_cos_configured_delete(self, lsp=None, secondary_path=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type secondary_path: path_name
    :param secondary_path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **secondary_path** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.secondary_path', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'secondary_path', 'keyval': 'path_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-cos-configured'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_secondary_path_config_cspf_computation_mode_delete(self, lsp=None, secondary_path=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type secondary_path: path_name
    :param secondary_path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **secondary_path** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.secondary_path', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'secondary_path', 'keyval': 'path_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-cspf-computation-mode'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_secondary_path_config_cspf_disabled_delete(self, lsp=None, secondary_path=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type secondary_path: path_name
    :param secondary_path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **secondary_path** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.secondary_path', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'secondary_path', 'keyval': 'path_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-cspf-disabled'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_secondary_path_config_exclude_any_delete(self, lsp=None, secondary_path=None, config_exclude_any=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type secondary_path: path_name
    :param secondary_path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **secondary_path** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type config_exclude_any: admin_group_id
    :param config_exclude_any: Keyword argument tuple.

    :type admin_group_id: long
    :param admin_group_id: **config_exclude_any** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp'), ('pybind.slxos.v16r_1_00b.mpls_state.lsp.secondary_path', u'secondary_path')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.secondary_path.config_exclude_any', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'path_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'config_exclude_any', 'keyval': 'admin_group_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path, config_exclude_any=config_exclude_any)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path, config_exclude_any=config_exclude_any)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_secondary_path_config_exclude_any_admin_group_name_delete(self, lsp=None, secondary_path=None, config_exclude_any=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type secondary_path: path_name
    :param secondary_path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **secondary_path** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type config_exclude_any: admin_group_id
    :param config_exclude_any: Keyword argument tuple.

    :type admin_group_id: long
    :param admin_group_id: **config_exclude_any** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp'), ('pybind.slxos.v16r_1_00b.mpls_state.lsp.secondary_path', u'secondary_path')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.secondary_path.config_exclude_any', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'path_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'config_exclude_any', 'keyval': 'admin_group_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'admin-group-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path, config_exclude_any=config_exclude_any)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path, config_exclude_any=config_exclude_any)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_secondary_path_config_holding_prority_delete(self, lsp=None, secondary_path=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type secondary_path: path_name
    :param secondary_path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **secondary_path** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.secondary_path', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'secondary_path', 'keyval': 'path_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-holding-prority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_secondary_path_config_hop_limit_delete(self, lsp=None, secondary_path=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type secondary_path: path_name
    :param secondary_path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **secondary_path** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.secondary_path', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'secondary_path', 'keyval': 'path_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-hop-limit'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_secondary_path_config_hop_limit_configured_delete(self, lsp=None, secondary_path=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type secondary_path: path_name
    :param secondary_path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **secondary_path** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.secondary_path', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'secondary_path', 'keyval': 'path_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-hop-limit-configured'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_secondary_path_config_hot_standby_delete(self, lsp=None, secondary_path=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type secondary_path: path_name
    :param secondary_path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **secondary_path** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.secondary_path', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'secondary_path', 'keyval': 'path_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-hot-standby'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_secondary_path_config_include_all_delete(self, lsp=None, secondary_path=None, config_include_all=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type secondary_path: path_name
    :param secondary_path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **secondary_path** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type config_include_all: admin_group_id
    :param config_include_all: Keyword argument tuple.

    :type admin_group_id: long
    :param admin_group_id: **config_include_all** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp'), ('pybind.slxos.v16r_1_00b.mpls_state.lsp.secondary_path', u'secondary_path')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.secondary_path.config_include_all', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'path_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'config_include_all', 'keyval': 'admin_group_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path, config_include_all=config_include_all)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path, config_include_all=config_include_all)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_secondary_path_config_include_all_admin_group_name_delete(self, lsp=None, secondary_path=None, config_include_all=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type secondary_path: path_name
    :param secondary_path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **secondary_path** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type config_include_all: admin_group_id
    :param config_include_all: Keyword argument tuple.

    :type admin_group_id: long
    :param admin_group_id: **config_include_all** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp'), ('pybind.slxos.v16r_1_00b.mpls_state.lsp.secondary_path', u'secondary_path')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.secondary_path.config_include_all', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'path_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'config_include_all', 'keyval': 'admin_group_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'admin-group-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path, config_include_all=config_include_all)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path, config_include_all=config_include_all)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_secondary_path_config_include_any_delete(self, lsp=None, secondary_path=None, config_include_any=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type secondary_path: path_name
    :param secondary_path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **secondary_path** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type config_include_any: admin_group_id
    :param config_include_any: Keyword argument tuple.

    :type admin_group_id: long
    :param admin_group_id: **config_include_any** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp'), ('pybind.slxos.v16r_1_00b.mpls_state.lsp.secondary_path', u'secondary_path')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.secondary_path.config_include_any', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'path_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'config_include_any', 'keyval': 'admin_group_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path, config_include_any=config_include_any)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path, config_include_any=config_include_any)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_secondary_path_config_include_any_admin_group_name_delete(self, lsp=None, secondary_path=None, config_include_any=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type secondary_path: path_name
    :param secondary_path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **secondary_path** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type config_include_any: admin_group_id
    :param config_include_any: Keyword argument tuple.

    :type admin_group_id: long
    :param admin_group_id: **config_include_any** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp'), ('pybind.slxos.v16r_1_00b.mpls_state.lsp.secondary_path', u'secondary_path')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.secondary_path.config_include_any', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'path_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'config_include_any', 'keyval': 'admin_group_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'admin-group-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path, config_include_any=config_include_any)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path, config_include_any=config_include_any)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_secondary_path_config_mtu_delete(self, lsp=None, secondary_path=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type secondary_path: path_name
    :param secondary_path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **secondary_path** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.secondary_path', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'secondary_path', 'keyval': 'path_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-mtu'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_secondary_path_config_mtu_configured_delete(self, lsp=None, secondary_path=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type secondary_path: path_name
    :param secondary_path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **secondary_path** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.secondary_path', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'secondary_path', 'keyval': 'path_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-mtu-configured'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_secondary_path_config_persistent_delete(self, lsp=None, secondary_path=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type secondary_path: path_name
    :param secondary_path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **secondary_path** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.secondary_path', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'secondary_path', 'keyval': 'path_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-persistent'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_secondary_path_config_pinned_delete(self, lsp=None, secondary_path=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type secondary_path: path_name
    :param secondary_path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **secondary_path** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.secondary_path', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'secondary_path', 'keyval': 'path_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-pinned'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_secondary_path_config_priority_configured_delete(self, lsp=None, secondary_path=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type secondary_path: path_name
    :param secondary_path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **secondary_path** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.secondary_path', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'secondary_path', 'keyval': 'path_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-priority-configured'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_secondary_path_config_reoptimize_timer_delete(self, lsp=None, secondary_path=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type secondary_path: path_name
    :param secondary_path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **secondary_path** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.secondary_path', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'secondary_path', 'keyval': 'path_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-reoptimize-timer'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_secondary_path_config_reoptimize_timer_configured_delete(self, lsp=None, secondary_path=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type secondary_path: path_name
    :param secondary_path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **secondary_path** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.secondary_path', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'secondary_path', 'keyval': 'path_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-reoptimize-timer-configured'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_secondary_path_config_reoptimize_timer_count_delete(self, lsp=None, secondary_path=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type secondary_path: path_name
    :param secondary_path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **secondary_path** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.secondary_path', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'secondary_path', 'keyval': 'path_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-reoptimize-timer-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_secondary_path_config_rro_disabled_delete(self, lsp=None, secondary_path=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type secondary_path: path_name
    :param secondary_path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **secondary_path** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.secondary_path', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'secondary_path', 'keyval': 'path_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-rro-disabled'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_secondary_path_config_setup_prority_delete(self, lsp=None, secondary_path=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type secondary_path: path_name
    :param secondary_path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **secondary_path** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.secondary_path', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'secondary_path', 'keyval': 'path_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-setup-prority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_secondary_path_config_soft_prempt_delete(self, lsp=None, secondary_path=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type secondary_path: path_name
    :param secondary_path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **secondary_path** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.secondary_path', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'secondary_path', 'keyval': 'path_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-soft-prempt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_secondary_path_config_tie_break_least_fill_delete(self, lsp=None, secondary_path=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type secondary_path: path_name
    :param secondary_path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **secondary_path** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.secondary_path', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'secondary_path', 'keyval': 'path_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-tie-break-least-fill'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_secondary_path_config_tie_break_most_fill_delete(self, lsp=None, secondary_path=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type secondary_path: path_name
    :param secondary_path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **secondary_path** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.secondary_path', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'secondary_path', 'keyval': 'path_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-tie-break-most-fill'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_secondary_path_config_tie_break_random_delete(self, lsp=None, secondary_path=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type secondary_path: path_name
    :param secondary_path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **secondary_path** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.secondary_path', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'secondary_path', 'keyval': 'path_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-tie-break-random'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_secondary_path_config_tie_breaking_configured_delete(self, lsp=None, secondary_path=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type secondary_path: path_name
    :param secondary_path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **secondary_path** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.secondary_path', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'secondary_path', 'keyval': 'path_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-tie-breaking-configured'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_secondary_path_config_traffic_eng_max_burst_delete(self, lsp=None, secondary_path=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type secondary_path: path_name
    :param secondary_path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **secondary_path** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.secondary_path', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'secondary_path', 'keyval': 'path_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-traffic-eng-max-burst'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_secondary_path_config_traffic_eng_max_rate_delete(self, lsp=None, secondary_path=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type secondary_path: path_name
    :param secondary_path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **secondary_path** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.secondary_path', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'secondary_path', 'keyval': 'path_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-traffic-eng-max-rate'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_secondary_path_config_traffic_eng_mean_rate_delete(self, lsp=None, secondary_path=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type secondary_path: path_name
    :param secondary_path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **secondary_path** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.secondary_path', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'secondary_path', 'keyval': 'path_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-traffic-eng-mean-rate'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_secondary_path_config_traffic_eng_rate_configured_delete(self, lsp=None, secondary_path=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type secondary_path: path_name
    :param secondary_path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **secondary_path** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.secondary_path', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'secondary_path', 'keyval': 'path_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-traffic-eng-rate-configured'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_secondary_path_config_tspec_mtu_delete(self, lsp=None, secondary_path=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type secondary_path: path_name
    :param secondary_path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **secondary_path** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.secondary_path', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'secondary_path', 'keyval': 'path_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-tspec-mtu'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_secondary_path_config_tspec_mtu_configured_delete(self, lsp=None, secondary_path=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type secondary_path: path_name
    :param secondary_path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **secondary_path** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.secondary_path', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'secondary_path', 'keyval': 'path_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-tspec-mtu-configured'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_secondary_path_instance_id_delete(self, lsp=None, secondary_path=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type secondary_path: path_name
    :param secondary_path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **secondary_path** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.secondary_path', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'secondary_path', 'keyval': 'path_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'instance-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_secondary_path_is_current_secondary_delete(self, lsp=None, secondary_path=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type secondary_path: path_name
    :param secondary_path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **secondary_path** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.secondary_path', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'secondary_path', 'keyval': 'path_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'is-current-secondary'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_secondary_path_is_new_instance_delete(self, lsp=None, secondary_path=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type secondary_path: path_name
    :param secondary_path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **secondary_path** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.secondary_path', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'secondary_path', 'keyval': 'path_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'is-new-instance'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_secondary_path_is_selected_secondary_delete(self, lsp=None, secondary_path=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type secondary_path: path_name
    :param secondary_path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **secondary_path** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.secondary_path', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'secondary_path', 'keyval': 'path_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'is-selected-secondary'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_lsp_secondary_path_path_up_delete(self, lsp=None, secondary_path=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type secondary_path: path_name
    :param secondary_path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **secondary_path** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.lsp.secondary_path', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'secondary_path', 'keyval': 'path_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'path-up'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_memory_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.memory', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_memory_pools_delete(self, pools=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type pools: pool_index
    :param pools: Keyword argument tuple.

    :type pool_index: long
    :param pool_index: **pools** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.memory.pools', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'pools', 'keyval': 'pool_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pools=pools)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pools=pools)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_memory_pools_sub_pools_delete(self, pools=None, sub_pools=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type pools: pool_index
    :param pools: Keyword argument tuple.

    :type pool_index: long
    :param pool_index: **pools** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type sub_pools: sub_pool_index
    :param sub_pools: Keyword argument tuple.

    :type sub_pool_index: long
    :param sub_pool_index: **sub_pools** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.memory.pools', u'pools')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.memory.pools.sub_pools', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'pool_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'sub_pools', 'keyval': 'sub_pool_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pools=pools, sub_pools=sub_pools)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pools=pools, sub_pools=sub_pools)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_memory_pools_sub_pools_block_size_delete(self, pools=None, sub_pools=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type pools: pool_index
    :param pools: Keyword argument tuple.

    :type pool_index: long
    :param pool_index: **pools** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type sub_pools: sub_pool_index
    :param sub_pools: Keyword argument tuple.

    :type sub_pool_index: long
    :param sub_pool_index: **sub_pools** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.memory.pools', u'pools')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.memory.pools.sub_pools', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'pool_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'sub_pools', 'keyval': 'sub_pool_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'block-size'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pools=pools, sub_pools=sub_pools)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pools=pools, sub_pools=sub_pools)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_memory_pools_sub_pools_current_blocks_delete(self, pools=None, sub_pools=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type pools: pool_index
    :param pools: Keyword argument tuple.

    :type pool_index: long
    :param pool_index: **pools** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type sub_pools: sub_pool_index
    :param sub_pools: Keyword argument tuple.

    :type sub_pool_index: long
    :param sub_pool_index: **sub_pools** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.memory.pools', u'pools')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.memory.pools.sub_pools', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'pool_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'sub_pools', 'keyval': 'sub_pool_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'current-blocks'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pools=pools, sub_pools=sub_pools)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pools=pools, sub_pools=sub_pools)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_memory_pools_sub_pools_current_gens_delete(self, pools=None, sub_pools=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type pools: pool_index
    :param pools: Keyword argument tuple.

    :type pool_index: long
    :param pool_index: **pools** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type sub_pools: sub_pool_index
    :param sub_pools: Keyword argument tuple.

    :type sub_pool_index: long
    :param sub_pool_index: **sub_pools** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.memory.pools', u'pools')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.memory.pools.sub_pools', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'pool_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'sub_pools', 'keyval': 'sub_pool_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'current-gens'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pools=pools, sub_pools=sub_pools)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pools=pools, sub_pools=sub_pools)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_memory_pools_sub_pools_free_blocks_delete(self, pools=None, sub_pools=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type pools: pool_index
    :param pools: Keyword argument tuple.

    :type pool_index: long
    :param pool_index: **pools** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type sub_pools: sub_pool_index
    :param sub_pools: Keyword argument tuple.

    :type sub_pool_index: long
    :param sub_pool_index: **sub_pools** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.memory.pools', u'pools')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.memory.pools.sub_pools', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'pool_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'sub_pools', 'keyval': 'sub_pool_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'free-blocks'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pools=pools, sub_pools=sub_pools)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pools=pools, sub_pools=sub_pools)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_memory_pools_sub_pools_gen_blocks_delete(self, pools=None, sub_pools=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type pools: pool_index
    :param pools: Keyword argument tuple.

    :type pool_index: long
    :param pool_index: **pools** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type sub_pools: sub_pool_index
    :param sub_pools: Keyword argument tuple.

    :type sub_pool_index: long
    :param sub_pool_index: **sub_pools** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.memory.pools', u'pools')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.memory.pools.sub_pools', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'pool_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'sub_pools', 'keyval': 'sub_pool_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'gen-blocks'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pools=pools, sub_pools=sub_pools)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pools=pools, sub_pools=sub_pools)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_memory_pools_sub_pools_gen_size_delete(self, pools=None, sub_pools=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type pools: pool_index
    :param pools: Keyword argument tuple.

    :type pool_index: long
    :param pool_index: **pools** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type sub_pools: sub_pool_index
    :param sub_pools: Keyword argument tuple.

    :type sub_pool_index: long
    :param sub_pool_index: **sub_pools** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.memory.pools', u'pools')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.memory.pools.sub_pools', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'pool_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'sub_pools', 'keyval': 'sub_pool_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'gen-size'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pools=pools, sub_pools=sub_pools)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pools=pools, sub_pools=sub_pools)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_memory_stats_delete(self, stats=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type stats: mem_stats_index
    :param stats: Keyword argument tuple.

    :type mem_stats_index: long
    :param mem_stats_index: **stats** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.memory.stats', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'stats', 'keyval': 'mem_stats_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, stats=stats)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, stats=stats)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_memory_stats_alloc_fails_delete(self, stats=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type stats: mem_stats_index
    :param stats: Keyword argument tuple.

    :type mem_stats_index: long
    :param mem_stats_index: **stats** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.memory.stats', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'stats', 'keyval': 'mem_stats_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'alloc-fails'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, stats=stats)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, stats=stats)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_memory_stats_free_fails_delete(self, stats=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type stats: mem_stats_index
    :param stats: Keyword argument tuple.

    :type mem_stats_index: long
    :param mem_stats_index: **stats** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.memory.stats', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'stats', 'keyval': 'mem_stats_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'free-fails'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, stats=stats)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, stats=stats)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_memory_stats_mem_type_delete(self, stats=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type stats: mem_stats_index
    :param stats: Keyword argument tuple.

    :type mem_stats_index: long
    :param mem_stats_index: **stats** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.memory.stats', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'stats', 'keyval': 'mem_stats_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mem-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, stats=stats)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, stats=stats)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_memory_stats_num_alloc_delete(self, stats=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type stats: mem_stats_index
    :param stats: Keyword argument tuple.

    :type mem_stats_index: long
    :param mem_stats_index: **stats** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.memory.stats', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'stats', 'keyval': 'mem_stats_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'num-alloc'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, stats=stats)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, stats=stats)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_memory_stats_peak_alloc_delete(self, stats=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type stats: mem_stats_index
    :param stats: Keyword argument tuple.

    :type mem_stats_index: long
    :param mem_stats_index: **stats** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.memory.stats', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'stats', 'keyval': 'mem_stats_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'peak-alloc'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, stats=stats)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, stats=stats)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_memory_stats_total_allocs_delete(self, stats=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type stats: mem_stats_index
    :param stats: Keyword argument tuple.

    :type mem_stats_index: long
    :param mem_stats_index: **stats** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.memory.stats', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'stats', 'keyval': 'mem_stats_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'total-allocs'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, stats=stats)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, stats=stats)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_memory_stats_total_bytes_delete(self, stats=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type stats: mem_stats_index
    :param stats: Keyword argument tuple.

    :type mem_stats_index: long
    :param mem_stats_index: **stats** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.memory.stats', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'stats', 'keyval': 'mem_stats_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'total-bytes'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, stats=stats)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, stats=stats)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_memory_stats_total_frees_delete(self, stats=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type stats: mem_stats_index
    :param stats: Keyword argument tuple.

    :type mem_stats_index: long
    :param mem_stats_index: **stats** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.memory.stats', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'stats', 'keyval': 'mem_stats_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'total-frees'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, stats=stats)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, stats=stats)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_memory_total_non_pool_memory_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.memory', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'total-non-pool-memory'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_path_delete(self, path=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type path: path_name
    :param path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **path** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.path', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'path', 'keyval': 'path_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, path=path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, path=path)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_path_path_hops_delete(self, path=None, path_hops=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type path: path_name
    :param path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **path** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type path_hops: hop_address
    :param path_hops: Keyword argument tuple.

    :type hop_address: unicode
    :param hop_address: **path_hops** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.path', u'path')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.path.path_hops', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'path_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'path_hops', 'keyval': 'hop_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, path=path, path_hops=path_hops)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, path=path, path_hops=path_hops)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_path_path_hops_hop_type_delete(self, path=None, path_hops=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type path: path_name
    :param path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **path** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type path_hops: hop_address
    :param path_hops: Keyword argument tuple.

    :type hop_address: unicode
    :param hop_address: **path_hops** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.path', u'path')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.path.path_hops', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'path_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'path_hops', 'keyval': 'hop_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hop-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, path=path, path_hops=path_hops)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, path=path, path_hops=path_hops)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_path_path_lsps_delete(self, path=None, path_lsps=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type path: path_name
    :param path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **path** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type path_lsps: lsp_name
    :param path_lsps: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **path_lsps** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.path', u'path')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.path.path_lsps', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'path_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'path_lsps', 'keyval': 'lsp_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, path=path, path_lsps=path_lsps)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, path=path, path_lsps=path_lsps)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_path_path_lsps_lsp_type_delete(self, path=None, path_lsps=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type path: path_name
    :param path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **path** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type path_lsps: lsp_name
    :param path_lsps: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **path_lsps** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.path', u'path')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.path.path_lsps', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'path_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'path_lsps', 'keyval': 'lsp_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lsp-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, path=path, path_lsps=path_lsps)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, path=path, path_lsps=path_lsps)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_path_usage_count_delete(self, path=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type path: path_name
    :param path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **path** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.path', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'path', 'keyval': 'path_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'usage-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, path=path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, path=path)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_policy_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.policy', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_policy_admin_groups_delete(self, admin_groups=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type admin_groups: name
    :param admin_groups: Keyword argument tuple.

    :type name: unicode
    :param name: **admin_groups** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.policy.admin_groups', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'admin_groups', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, admin_groups=admin_groups)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, admin_groups=admin_groups)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_policy_admin_groups_group_number_delete(self, admin_groups=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type admin_groups: name
    :param admin_groups: Keyword argument tuple.

    :type name: unicode
    :param name: **admin_groups** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.policy.admin_groups', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'admin_groups', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'group-number'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, admin_groups=admin_groups)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, admin_groups=admin_groups)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_policy_auto_bandwidth_enabled_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.policy', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'auto-bandwidth-enabled'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_policy_autobw_num_sample_record_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.policy', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'autobw-num-sample-record'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_policy_autobw_sample_interval_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.policy', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'autobw-sample-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_policy_cspf_comp_ignore_overload_bit_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.policy', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cspf-comp-ignore-overload-bit'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_policy_cspf_comp_mode_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.policy', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cspf-comp-mode'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_policy_cspf_group_computation_mode_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.policy', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cspf-group-computation-mode'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_policy_cspf_intf_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.policy', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cspf-intf'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_policy_fast_retry_on_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.policy', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'fast-retry-on'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_policy_frr_backup_retry_interval_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.policy', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'frr-backup-retry-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_policy_handle_isis_nbr_down_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.policy', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'handle-isis-nbr-down'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_policy_handle_ospf_nbr_down_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.policy', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'handle-ospf-nbr-down'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_policy_implicit_commit_value_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.policy', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'implicit-commit-value'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_policy_ingress_tnnl_actg_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.policy', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ingress-tnnl-actg'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_policy_label_propagate_ttl_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.policy', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'label-propagate-ttl'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_policy_load_interval_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.policy', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'load-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_policy_lsp_retry_interval_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.policy', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lsp-retry-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_policy_max_lsp_retries_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.policy', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'max-lsp-retries'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_policy_propagate_ttl_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.policy', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'propagate-ttl'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_policy_rsvp_flooding_thresholds_delete(self, rsvp_flooding_thresholds=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type rsvp_flooding_thresholds: threshold_type
    :param rsvp_flooding_thresholds: Keyword argument tuple.

    :type threshold_type: unicode
    :param threshold_type: **rsvp_flooding_thresholds** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.policy.rsvp_flooding_thresholds', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'rsvp_flooding_thresholds', 'keyval': 'threshold_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rsvp_flooding_thresholds=rsvp_flooding_thresholds)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rsvp_flooding_thresholds=rsvp_flooding_thresholds)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_policy_rsvp_periodic_flooding_timer_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.policy', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rsvp-periodic-flooding-timer'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_policy_rtm_route_filter_all_ibgp_enabled_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.policy', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rtm-route-filter-all-ibgp-enabled'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_policy_rtm_route_filter_enabled_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.policy', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rtm-route-filter-enabled'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_policy_soft_preempt_cleanup_timer_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.policy', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'soft-preempt-cleanup-timer'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_policy_te_policy_area_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.policy', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'te-policy-area'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_policy_te_policy_flags_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.policy', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'te-policy-flags'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_policy_te_policy_protocol_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.policy', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'te-policy-protocol'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_policy_transit_session_actg_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.policy', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'transit-session-actg'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_policy_vrf_propagate_ttl_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.policy', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vrf-propagate-ttl'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_route_delete(self, route=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type route: entry_index
    :param route: Keyword argument tuple.

    :type entry_index: long
    :param entry_index: **route** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.route', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'route', 'keyval': 'entry_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route=route)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route=route)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_route_dest_ip_prefix_delete(self, route=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type route: entry_index
    :param route: Keyword argument tuple.

    :type entry_index: long
    :param entry_index: **route** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.route', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'route', 'keyval': 'entry_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dest-ip-prefix'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route=route)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route=route)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_route_gateway_ip_addr_delete(self, route=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type route: entry_index
    :param route: Keyword argument tuple.

    :type entry_index: long
    :param entry_index: **route** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.route', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'route', 'keyval': 'entry_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'gateway-ip-addr'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route=route)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route=route)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_route_metric_delete(self, route=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type route: entry_index
    :param route: Keyword argument tuple.

    :type entry_index: long
    :param entry_index: **route** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.route', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'route', 'keyval': 'entry_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route=route)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route=route)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_route_out_interface_name_delete(self, route=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type route: entry_index
    :param route: Keyword argument tuple.

    :type entry_index: long
    :param entry_index: **route** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.route', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'route', 'keyval': 'entry_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'out-interface-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route=route)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route=route)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_route_out_label_delete(self, route=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type route: entry_index
    :param route: Keyword argument tuple.

    :type entry_index: long
    :param entry_index: **route** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.route', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'route', 'keyval': 'entry_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'out-label'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route=route)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route=route)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_route_outseg_index_delete(self, route=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type route: entry_index
    :param route: Keyword argument tuple.

    :type entry_index: long
    :param entry_index: **route** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.route', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'route', 'keyval': 'entry_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'outseg-index'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route=route)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route=route)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_route_protocol_delete(self, route=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type route: entry_index
    :param route: Keyword argument tuple.

    :type entry_index: long
    :param entry_index: **route** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.route', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'route', 'keyval': 'entry_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'protocol'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route=route)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route=route)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_route_use_count_delete(self, route=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type route: entry_index
    :param route: Keyword argument tuple.

    :type entry_index: long
    :param entry_index: **route** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.route', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'route', 'keyval': 'entry_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'use-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route=route)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route=route)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_route_vif_index_delete(self, route=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type route: entry_index
    :param route: Keyword argument tuple.

    :type entry_index: long
    :param entry_index: **route** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.route', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'route', 'keyval': 'entry_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vif-index'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route=route)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route=route)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_backup_bandwidth_requirement_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'backup-bandwidth-requirement'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_delay_resv_sending_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'delay-resv-sending'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_igp_sync_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.igp_sync', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_igp_sync_isis_nbr_down_enabled_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.igp_sync', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'isis-nbr-down-enabled'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_igp_sync_link_delete(self, link=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type link: ip_address, nbr_ip_address
    :param link: Keyword argument tuple.

    :type ip_address: unicode
    :param ip_address: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type nbr_ip_address: unicode
    :param nbr_ip_address: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.igp_sync.link', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'link', 'keyval': 'ip_address, nbr_ip_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, link=link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, link=link)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_igp_sync_link_lsp_delete(self, link=None, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type link: ip_address, nbr_ip_address
    :param link: Keyword argument tuple.

    :type ip_address: unicode
    :param ip_address: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type nbr_ip_address: unicode
    :param nbr_ip_address: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type lsp: lsp_name, path_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type path_name: unicode
    :param path_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.igp_sync.link', u'link')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.igp_sync.link.lsp', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ip_address, nbr_ip_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'lsp', 'keyval': 'lsp_name, path_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, link=link, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, link=link, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_igp_sync_link_lsp_count_delete(self, link=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type link: ip_address, nbr_ip_address
    :param link: Keyword argument tuple.

    :type ip_address: unicode
    :param ip_address: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type nbr_ip_address: unicode
    :param nbr_ip_address: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.igp_sync.link', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'link', 'keyval': 'ip_address, nbr_ip_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lsp-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, link=link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, link=link)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_igp_sync_link_lsp_cspf_enabled_delete(self, link=None, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type link: ip_address, nbr_ip_address
    :param link: Keyword argument tuple.

    :type ip_address: unicode
    :param ip_address: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type nbr_ip_address: unicode
    :param nbr_ip_address: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type lsp: lsp_name, path_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type path_name: unicode
    :param path_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.igp_sync.link', u'link')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.igp_sync.link.lsp', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ip_address, nbr_ip_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'lsp', 'keyval': 'lsp_name, path_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cspf-enabled'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, link=link, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, link=link, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_igp_sync_link_lsp_cspf_hop_delete(self, link=None, lsp=None, cspf_hop=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type link: ip_address, nbr_ip_address
    :param link: Keyword argument tuple.

    :type ip_address: unicode
    :param ip_address: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type nbr_ip_address: unicode
    :param nbr_ip_address: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type lsp: lsp_name, path_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type path_name: unicode
    :param path_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type cspf_hop: index
    :param cspf_hop: Keyword argument tuple.

    :type index: long
    :param index: **cspf_hop** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.igp_sync.link', u'link'), ('pybind.slxos.v16r_1_00b.mpls_state.rsvp.igp_sync.link.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.igp_sync.link.lsp.cspf_hop', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ip_address, nbr_ip_address', 'extra_keyval': ''}, {'keyval': 'lsp_name, path_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'cspf_hop', 'keyval': 'index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, link=link, lsp=lsp, cspf_hop=cspf_hop)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, link=link, lsp=lsp, cspf_hop=cspf_hop)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_igp_sync_link_lsp_cspf_hop_count_delete(self, link=None, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type link: ip_address, nbr_ip_address
    :param link: Keyword argument tuple.

    :type ip_address: unicode
    :param ip_address: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type nbr_ip_address: unicode
    :param nbr_ip_address: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type lsp: lsp_name, path_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type path_name: unicode
    :param path_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.igp_sync.link', u'link')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.igp_sync.link.lsp', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ip_address, nbr_ip_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'lsp', 'keyval': 'lsp_name, path_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cspf-hop-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, link=link, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, link=link, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_igp_sync_link_lsp_cspf_hop_ip_address_delete(self, link=None, lsp=None, cspf_hop=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type link: ip_address, nbr_ip_address
    :param link: Keyword argument tuple.

    :type ip_address: unicode
    :param ip_address: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type nbr_ip_address: unicode
    :param nbr_ip_address: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type lsp: lsp_name, path_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type path_name: unicode
    :param path_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type cspf_hop: index
    :param cspf_hop: Keyword argument tuple.

    :type index: long
    :param index: **cspf_hop** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.igp_sync.link', u'link'), ('pybind.slxos.v16r_1_00b.mpls_state.rsvp.igp_sync.link.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.igp_sync.link.lsp.cspf_hop', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ip_address, nbr_ip_address', 'extra_keyval': ''}, {'keyval': 'lsp_name, path_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'cspf_hop', 'keyval': 'index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ip-address'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, link=link, lsp=lsp, cspf_hop=cspf_hop)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, link=link, lsp=lsp, cspf_hop=cspf_hop)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_igp_sync_link_lsp_cspf_hop_nbr_ip_address_delete(self, link=None, lsp=None, cspf_hop=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type link: ip_address, nbr_ip_address
    :param link: Keyword argument tuple.

    :type ip_address: unicode
    :param ip_address: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type nbr_ip_address: unicode
    :param nbr_ip_address: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type lsp: lsp_name, path_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type path_name: unicode
    :param path_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type cspf_hop: index
    :param cspf_hop: Keyword argument tuple.

    :type index: long
    :param index: **cspf_hop** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.igp_sync.link', u'link'), ('pybind.slxos.v16r_1_00b.mpls_state.rsvp.igp_sync.link.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.igp_sync.link.lsp.cspf_hop', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ip_address, nbr_ip_address', 'extra_keyval': ''}, {'keyval': 'lsp_name, path_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'cspf_hop', 'keyval': 'index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'nbr-ip-address'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, link=link, lsp=lsp, cspf_hop=cspf_hop)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, link=link, lsp=lsp, cspf_hop=cspf_hop)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_igp_sync_link_lsp_frr_enabled_delete(self, link=None, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type link: ip_address, nbr_ip_address
    :param link: Keyword argument tuple.

    :type ip_address: unicode
    :param ip_address: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type nbr_ip_address: unicode
    :param nbr_ip_address: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type lsp: lsp_name, path_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type path_name: unicode
    :param path_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.igp_sync.link', u'link')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.igp_sync.link.lsp', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ip_address, nbr_ip_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'lsp', 'keyval': 'lsp_name, path_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'frr-enabled'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, link=link, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, link=link, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_igp_sync_link_lsp_link_delete(self, link=None, lsp=None, link_=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type link: ip_address, nbr_ip_address
    :param link: Keyword argument tuple.

    :type ip_address: unicode
    :param ip_address: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type nbr_ip_address: unicode
    :param nbr_ip_address: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type lsp: lsp_name, path_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type path_name: unicode
    :param path_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type link_: index
    :param link_: Keyword argument tuple.

    :type index: long
    :param index: **link_** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.igp_sync.link', u'link'), ('pybind.slxos.v16r_1_00b.mpls_state.rsvp.igp_sync.link.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.igp_sync.link.lsp.link', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ip_address, nbr_ip_address', 'extra_keyval': ''}, {'keyval': 'lsp_name, path_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'link_', 'keyval': 'index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, link=link, lsp=lsp, link_=link_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, link=link, lsp=lsp, link_=link_)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_igp_sync_link_lsp_link_count_delete(self, link=None, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type link: ip_address, nbr_ip_address
    :param link: Keyword argument tuple.

    :type ip_address: unicode
    :param ip_address: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type nbr_ip_address: unicode
    :param nbr_ip_address: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type lsp: lsp_name, path_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type path_name: unicode
    :param path_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.igp_sync.link', u'link')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.igp_sync.link.lsp', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ip_address, nbr_ip_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'lsp', 'keyval': 'lsp_name, path_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'link-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, link=link, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, link=link, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_igp_sync_link_lsp_link_ip_address_delete(self, link=None, lsp=None, link_=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type link: ip_address, nbr_ip_address
    :param link: Keyword argument tuple.

    :type ip_address: unicode
    :param ip_address: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type nbr_ip_address: unicode
    :param nbr_ip_address: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type lsp: lsp_name, path_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type path_name: unicode
    :param path_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type link_: index
    :param link_: Keyword argument tuple.

    :type index: long
    :param index: **link_** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.igp_sync.link', u'link'), ('pybind.slxos.v16r_1_00b.mpls_state.rsvp.igp_sync.link.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.igp_sync.link.lsp.link', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ip_address, nbr_ip_address', 'extra_keyval': ''}, {'keyval': 'lsp_name, path_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'link_', 'keyval': 'index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ip-address'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, link=link, lsp=lsp, link_=link_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, link=link, lsp=lsp, link_=link_)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_igp_sync_link_lsp_link_nbr_ip_address_delete(self, link=None, lsp=None, link_=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type link: ip_address, nbr_ip_address
    :param link: Keyword argument tuple.

    :type ip_address: unicode
    :param ip_address: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type nbr_ip_address: unicode
    :param nbr_ip_address: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type lsp: lsp_name, path_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type path_name: unicode
    :param path_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type link_: index
    :param link_: Keyword argument tuple.

    :type index: long
    :param index: **link_** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.igp_sync.link', u'link'), ('pybind.slxos.v16r_1_00b.mpls_state.rsvp.igp_sync.link.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.igp_sync.link.lsp.link', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ip_address, nbr_ip_address', 'extra_keyval': ''}, {'keyval': 'lsp_name, path_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'link_', 'keyval': 'index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'nbr-ip-address'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, link=link, lsp=lsp, link_=link_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, link=link, lsp=lsp, link_=link_)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_igp_sync_link_lsp_nbr_down_enabled_delete(self, link=None, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type link: ip_address, nbr_ip_address
    :param link: Keyword argument tuple.

    :type ip_address: unicode
    :param ip_address: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type nbr_ip_address: unicode
    :param nbr_ip_address: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type lsp: lsp_name, path_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type path_name: unicode
    :param path_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.igp_sync.link', u'link')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.igp_sync.link.lsp', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ip_address, nbr_ip_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'lsp', 'keyval': 'lsp_name, path_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'nbr-down-enabled'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, link=link, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, link=link, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_igp_sync_link_lsp_nbr_down_inprogress_delete(self, link=None, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type link: ip_address, nbr_ip_address
    :param link: Keyword argument tuple.

    :type ip_address: unicode
    :param ip_address: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type nbr_ip_address: unicode
    :param nbr_ip_address: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type lsp: lsp_name, path_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type path_name: unicode
    :param path_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.igp_sync.link', u'link')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.igp_sync.link.lsp', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ip_address, nbr_ip_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'lsp', 'keyval': 'lsp_name, path_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'nbr-down-inprogress'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, link=link, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, link=link, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_igp_sync_link_lsp_rro_enabled_delete(self, link=None, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type link: ip_address, nbr_ip_address
    :param link: Keyword argument tuple.

    :type ip_address: unicode
    :param ip_address: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type nbr_ip_address: unicode
    :param nbr_ip_address: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type lsp: lsp_name, path_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type path_name: unicode
    :param path_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.igp_sync.link', u'link')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.igp_sync.link.lsp', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ip_address, nbr_ip_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'lsp', 'keyval': 'lsp_name, path_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rro-enabled'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, link=link, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, link=link, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_igp_sync_link_lsp_rro_hop_delete(self, link=None, lsp=None, rro_hop=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type link: ip_address, nbr_ip_address
    :param link: Keyword argument tuple.

    :type ip_address: unicode
    :param ip_address: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type nbr_ip_address: unicode
    :param nbr_ip_address: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type lsp: lsp_name, path_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type path_name: unicode
    :param path_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type rro_hop: index
    :param rro_hop: Keyword argument tuple.

    :type index: long
    :param index: **rro_hop** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.igp_sync.link', u'link'), ('pybind.slxos.v16r_1_00b.mpls_state.rsvp.igp_sync.link.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.igp_sync.link.lsp.rro_hop', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ip_address, nbr_ip_address', 'extra_keyval': ''}, {'keyval': 'lsp_name, path_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'rro_hop', 'keyval': 'index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, link=link, lsp=lsp, rro_hop=rro_hop)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, link=link, lsp=lsp, rro_hop=rro_hop)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_igp_sync_link_lsp_rro_hop_count_delete(self, link=None, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type link: ip_address, nbr_ip_address
    :param link: Keyword argument tuple.

    :type ip_address: unicode
    :param ip_address: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type nbr_ip_address: unicode
    :param nbr_ip_address: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type lsp: lsp_name, path_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type path_name: unicode
    :param path_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.igp_sync.link', u'link')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.igp_sync.link.lsp', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ip_address, nbr_ip_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'lsp', 'keyval': 'lsp_name, path_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rro-hop-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, link=link, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, link=link, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_igp_sync_link_lsp_rro_hop_ip_address_delete(self, link=None, lsp=None, rro_hop=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type link: ip_address, nbr_ip_address
    :param link: Keyword argument tuple.

    :type ip_address: unicode
    :param ip_address: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type nbr_ip_address: unicode
    :param nbr_ip_address: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type lsp: lsp_name, path_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type path_name: unicode
    :param path_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type rro_hop: index
    :param rro_hop: Keyword argument tuple.

    :type index: long
    :param index: **rro_hop** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.igp_sync.link', u'link'), ('pybind.slxos.v16r_1_00b.mpls_state.rsvp.igp_sync.link.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.igp_sync.link.lsp.rro_hop', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ip_address, nbr_ip_address', 'extra_keyval': ''}, {'keyval': 'lsp_name, path_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'rro_hop', 'keyval': 'index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ip-address'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, link=link, lsp=lsp, rro_hop=rro_hop)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, link=link, lsp=lsp, rro_hop=rro_hop)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_igp_sync_link_lsp_rro_hop_nbr_ip_address_delete(self, link=None, lsp=None, rro_hop=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type link: ip_address, nbr_ip_address
    :param link: Keyword argument tuple.

    :type ip_address: unicode
    :param ip_address: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type nbr_ip_address: unicode
    :param nbr_ip_address: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type lsp: lsp_name, path_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type path_name: unicode
    :param path_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type rro_hop: index
    :param rro_hop: Keyword argument tuple.

    :type index: long
    :param index: **rro_hop** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.igp_sync.link', u'link'), ('pybind.slxos.v16r_1_00b.mpls_state.rsvp.igp_sync.link.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.igp_sync.link.lsp.rro_hop', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ip_address, nbr_ip_address', 'extra_keyval': ''}, {'keyval': 'lsp_name, path_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'rro_hop', 'keyval': 'index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'nbr-ip-address'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, link=link, lsp=lsp, rro_hop=rro_hop)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, link=link, lsp=lsp, rro_hop=rro_hop)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_igp_sync_link_remote_ip_delete(self, link=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type link: ip_address, nbr_ip_address
    :param link: Keyword argument tuple.

    :type ip_address: unicode
    :param ip_address: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type nbr_ip_address: unicode
    :param nbr_ip_address: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.igp_sync.link', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'link', 'keyval': 'ip_address, nbr_ip_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'remote-ip'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, link=link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, link=link)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_igp_sync_lsp_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type lsp: lsp_name, path_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type path_name: unicode
    :param path_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.igp_sync.lsp', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'lsp', 'keyval': 'lsp_name, path_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_igp_sync_lsp_cspf_enabled_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type lsp: lsp_name, path_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type path_name: unicode
    :param path_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.igp_sync.lsp', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'lsp', 'keyval': 'lsp_name, path_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cspf-enabled'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_igp_sync_lsp_cspf_hop_delete(self, lsp=None, cspf_hop=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name, path_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type path_name: unicode
    :param path_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type cspf_hop: index
    :param cspf_hop: Keyword argument tuple.

    :type index: long
    :param index: **cspf_hop** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.igp_sync.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.igp_sync.lsp.cspf_hop', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name, path_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'cspf_hop', 'keyval': 'index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, cspf_hop=cspf_hop)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, cspf_hop=cspf_hop)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_igp_sync_lsp_cspf_hop_count_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type lsp: lsp_name, path_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type path_name: unicode
    :param path_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.igp_sync.lsp', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'lsp', 'keyval': 'lsp_name, path_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cspf-hop-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_igp_sync_lsp_cspf_hop_ip_address_delete(self, lsp=None, cspf_hop=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name, path_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type path_name: unicode
    :param path_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type cspf_hop: index
    :param cspf_hop: Keyword argument tuple.

    :type index: long
    :param index: **cspf_hop** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.igp_sync.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.igp_sync.lsp.cspf_hop', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name, path_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'cspf_hop', 'keyval': 'index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ip-address'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, cspf_hop=cspf_hop)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, cspf_hop=cspf_hop)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_igp_sync_lsp_cspf_hop_nbr_ip_address_delete(self, lsp=None, cspf_hop=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name, path_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type path_name: unicode
    :param path_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type cspf_hop: index
    :param cspf_hop: Keyword argument tuple.

    :type index: long
    :param index: **cspf_hop** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.igp_sync.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.igp_sync.lsp.cspf_hop', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name, path_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'cspf_hop', 'keyval': 'index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'nbr-ip-address'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, cspf_hop=cspf_hop)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, cspf_hop=cspf_hop)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_igp_sync_lsp_frr_enabled_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type lsp: lsp_name, path_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type path_name: unicode
    :param path_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.igp_sync.lsp', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'lsp', 'keyval': 'lsp_name, path_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'frr-enabled'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_igp_sync_lsp_link_delete(self, lsp=None, link=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name, path_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type path_name: unicode
    :param path_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type link: index
    :param link: Keyword argument tuple.

    :type index: long
    :param index: **link** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.igp_sync.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.igp_sync.lsp.link', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name, path_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'link', 'keyval': 'index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, link=link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, link=link)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_igp_sync_lsp_link_count_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type lsp: lsp_name, path_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type path_name: unicode
    :param path_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.igp_sync.lsp', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'lsp', 'keyval': 'lsp_name, path_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'link-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_igp_sync_lsp_link_ip_address_delete(self, lsp=None, link=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name, path_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type path_name: unicode
    :param path_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type link: index
    :param link: Keyword argument tuple.

    :type index: long
    :param index: **link** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.igp_sync.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.igp_sync.lsp.link', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name, path_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'link', 'keyval': 'index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ip-address'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, link=link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, link=link)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_igp_sync_lsp_link_nbr_ip_address_delete(self, lsp=None, link=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name, path_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type path_name: unicode
    :param path_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type link: index
    :param link: Keyword argument tuple.

    :type index: long
    :param index: **link** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.igp_sync.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.igp_sync.lsp.link', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name, path_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'link', 'keyval': 'index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'nbr-ip-address'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, link=link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, link=link)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_igp_sync_lsp_nbr_down_enabled_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type lsp: lsp_name, path_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type path_name: unicode
    :param path_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.igp_sync.lsp', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'lsp', 'keyval': 'lsp_name, path_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'nbr-down-enabled'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_igp_sync_lsp_nbr_down_inprogress_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type lsp: lsp_name, path_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type path_name: unicode
    :param path_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.igp_sync.lsp', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'lsp', 'keyval': 'lsp_name, path_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'nbr-down-inprogress'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_igp_sync_lsp_rro_enabled_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type lsp: lsp_name, path_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type path_name: unicode
    :param path_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.igp_sync.lsp', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'lsp', 'keyval': 'lsp_name, path_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rro-enabled'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_igp_sync_lsp_rro_hop_delete(self, lsp=None, rro_hop=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name, path_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type path_name: unicode
    :param path_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type rro_hop: index
    :param rro_hop: Keyword argument tuple.

    :type index: long
    :param index: **rro_hop** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.igp_sync.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.igp_sync.lsp.rro_hop', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name, path_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'rro_hop', 'keyval': 'index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, rro_hop=rro_hop)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, rro_hop=rro_hop)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_igp_sync_lsp_rro_hop_count_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type lsp: lsp_name, path_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type path_name: unicode
    :param path_name: **lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.igp_sync.lsp', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'lsp', 'keyval': 'lsp_name, path_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rro-hop-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_igp_sync_lsp_rro_hop_ip_address_delete(self, lsp=None, rro_hop=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name, path_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type path_name: unicode
    :param path_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type rro_hop: index
    :param rro_hop: Keyword argument tuple.

    :type index: long
    :param index: **rro_hop** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.igp_sync.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.igp_sync.lsp.rro_hop', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name, path_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'rro_hop', 'keyval': 'index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ip-address'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, rro_hop=rro_hop)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, rro_hop=rro_hop)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_igp_sync_lsp_rro_hop_nbr_ip_address_delete(self, lsp=None, rro_hop=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name, path_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type path_name: unicode
    :param path_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type rro_hop: index
    :param rro_hop: Keyword argument tuple.

    :type index: long
    :param index: **rro_hop** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.igp_sync.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.igp_sync.lsp.rro_hop', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name, path_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'rro_hop', 'keyval': 'index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'nbr-ip-address'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, rro_hop=rro_hop)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, rro_hop=rro_hop)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_igp_sync_ospf_nbr_down_enabled_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.igp_sync', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ospf-nbr-down-enabled'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_interfaces_delete(self, interfaces=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type interfaces: interface_index
    :param interfaces: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **interfaces** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interfaces', 'keyval': 'interface_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_interfaces_active_backup_outsegs_delete(self, interfaces=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type interfaces: interface_index
    :param interfaces: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **interfaces** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interfaces', 'keyval': 'interface_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'active-backup-outsegs'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_interfaces_active_outsegs_delete(self, interfaces=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type interfaces: interface_index
    :param interfaces: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **interfaces** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interfaces', 'keyval': 'interface_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'active-outsegs'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_interfaces_admin_status_delete(self, interfaces=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type interfaces: interface_index
    :param interfaces: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **interfaces** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interfaces', 'keyval': 'interface_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'admin-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_interfaces_bandwith_resv_outsegs_delete(self, interfaces=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type interfaces: interface_index
    :param interfaces: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **interfaces** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interfaces', 'keyval': 'interface_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bandwith-resv-outsegs'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_interfaces_bundle_messages_delete(self, interfaces=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type interfaces: interface_index
    :param interfaces: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **interfaces** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interfaces', 'keyval': 'interface_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bundle-messages'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_interfaces_bypass_interface_delete(self, interfaces=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type interfaces: interface_index
    :param interfaces: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **interfaces** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interfaces', 'keyval': 'interface_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bypass-interface'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_interfaces_bypass_tunnel_interface_name_delete(self, interfaces=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type interfaces: interface_index
    :param interfaces: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **interfaces** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interfaces', 'keyval': 'interface_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bypass-tunnel-interface-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_interfaces_duplicate_preempts_dropped_delete(self, interfaces=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type interfaces: interface_index
    :param interfaces: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **interfaces** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interfaces', 'keyval': 'interface_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'duplicate-preempts-dropped'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_interfaces_error_counters_delete(self, interfaces=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_index
    :param interfaces: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **interfaces** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces.error_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_interfaces_error_counters_nackobject_errors_delete(self, interfaces=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_index
    :param interfaces: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **interfaces** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces.error_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'nackobject-errors'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_interfaces_error_counters_nackobject_errors_since_last_clear_delete(self, interfaces=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_index
    :param interfaces: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **interfaces** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces.error_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'nackobject-errors-since-last-clear'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_interfaces_error_counters_pkt_with_msgid_drop_delete(self, interfaces=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_index
    :param interfaces: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **interfaces** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces.error_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'pkt-with-msgid-drop'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_interfaces_error_counters_pkt_with_msgid_drop_since_last_clear_delete(self, interfaces=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_index
    :param interfaces: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **interfaces** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces.error_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'pkt-with-msgid-drop-since-last-clear'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_interfaces_error_counters_pkt_with_sref_drop_delete(self, interfaces=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_index
    :param interfaces: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **interfaces** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces.error_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'pkt-with-sref-drop'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_interfaces_error_counters_pkt_with_sref_drop_since_last_clear_delete(self, interfaces=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_index
    :param interfaces: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **interfaces** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces.error_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'pkt-with-sref-drop-since-last-clear'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_interfaces_error_counters_recv_md5_auth_errors_delete(self, interfaces=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_index
    :param interfaces: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **interfaces** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces.error_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'recv-md5-auth-errors'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_interfaces_error_counters_recv_md5_auth_errors_since_last_clear_delete(self, interfaces=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_index
    :param interfaces: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **interfaces** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces.error_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'recv-md5-auth-errors-since-last-clear'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_interfaces_hello_interval_delete(self, interfaces=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type interfaces: interface_index
    :param interfaces: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **interfaces** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interfaces', 'keyval': 'interface_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hello-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_interfaces_hello_status_delete(self, interfaces=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type interfaces: interface_index
    :param interfaces: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **interfaces** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interfaces', 'keyval': 'interface_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hello-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_interfaces_hello_tolerance_delete(self, interfaces=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type interfaces: interface_index
    :param interfaces: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **interfaces** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interfaces', 'keyval': 'interface_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hello-tolerance'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_interfaces_inactive_backup_outsegs_delete(self, interfaces=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type interfaces: interface_index
    :param interfaces: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **interfaces** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interfaces', 'keyval': 'interface_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'inactive-backup-outsegs'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_interfaces_inactive_outsegs_delete(self, interfaces=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type interfaces: interface_index
    :param interfaces: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **interfaces** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interfaces', 'keyval': 'interface_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'inactive-outsegs'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_interfaces_interface_flooding_down_threshold_delete(self, interfaces=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type interfaces: interface_index
    :param interfaces: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **interfaces** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interfaces', 'keyval': 'interface_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'interface-flooding-down-threshold'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_interfaces_interface_flooding_up_threshold_delete(self, interfaces=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type interfaces: interface_index
    :param interfaces: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **interfaces** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interfaces', 'keyval': 'interface_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'interface-flooding-up-threshold'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_interfaces_interface_name_delete(self, interfaces=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type interfaces: interface_index
    :param interfaces: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **interfaces** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interfaces', 'keyval': 'interface_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'interface-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_interfaces_interface_preempts_delete(self, interfaces=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type interfaces: interface_index
    :param interfaces: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **interfaces** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interfaces', 'keyval': 'interface_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'interface-preempts'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_interfaces_interface_resv_soft_preempts_delete(self, interfaces=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type interfaces: interface_index
    :param interfaces: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **interfaces** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interfaces', 'keyval': 'interface_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'interface-resv-soft-preempts'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_interfaces_interface_tunnel_name_delete(self, interfaces=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type interfaces: interface_index
    :param interfaces: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **interfaces** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interfaces', 'keyval': 'interface_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'interface-tunnel-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_interfaces_interface_type_delete(self, interfaces=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type interfaces: interface_index
    :param interfaces: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **interfaces** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interfaces', 'keyval': 'interface_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'interface-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_interfaces_is_md5_auth_enabled_delete(self, interfaces=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type interfaces: interface_index
    :param interfaces: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **interfaces** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interfaces', 'keyval': 'interface_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'is-md5-auth-enabled'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_interfaces_is_tunnel_interface_delete(self, interfaces=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type interfaces: interface_index
    :param interfaces: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **interfaces** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interfaces', 'keyval': 'interface_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'is-tunnel-interface'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_interfaces_oper_status_delete(self, interfaces=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type interfaces: interface_index
    :param interfaces: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **interfaces** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interfaces', 'keyval': 'interface_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'oper-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_interfaces_packet_counters_delete(self, interfaces=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_index
    :param interfaces: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **interfaces** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_interfaces_packet_counters_ack_rx_delete(self, interfaces=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_index
    :param interfaces: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **interfaces** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ack-rx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_interfaces_packet_counters_ack_rx_since_last_clear_delete(self, interfaces=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_index
    :param interfaces: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **interfaces** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ack-rx-since-last-clear'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_interfaces_packet_counters_ack_tx_delete(self, interfaces=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_index
    :param interfaces: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **interfaces** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ack-tx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_interfaces_packet_counters_ack_tx_since_last_clear_delete(self, interfaces=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_index
    :param interfaces: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **interfaces** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ack-tx-since-last-clear'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_interfaces_packet_counters_bundle_rx_delete(self, interfaces=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_index
    :param interfaces: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **interfaces** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bundle-rx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_interfaces_packet_counters_bundle_rx_since_last_clear_delete(self, interfaces=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_index
    :param interfaces: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **interfaces** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bundle-rx-since-last-clear'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_interfaces_packet_counters_bundle_tx_delete(self, interfaces=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_index
    :param interfaces: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **interfaces** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bundle-tx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_interfaces_packet_counters_bundle_tx_since_last_clear_delete(self, interfaces=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_index
    :param interfaces: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **interfaces** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bundle-tx-since-last-clear'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_interfaces_packet_counters_hello_rx_delete(self, interfaces=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_index
    :param interfaces: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **interfaces** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hello-rx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_interfaces_packet_counters_hello_rx_since_last_clear_delete(self, interfaces=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_index
    :param interfaces: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **interfaces** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hello-rx-since-last-clear'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_interfaces_packet_counters_hello_tx_delete(self, interfaces=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_index
    :param interfaces: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **interfaces** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hello-tx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_interfaces_packet_counters_hello_tx_since_last_clear_delete(self, interfaces=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_index
    :param interfaces: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **interfaces** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hello-tx-since-last-clear'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_interfaces_packet_counters_path_rx_delete(self, interfaces=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_index
    :param interfaces: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **interfaces** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'path-rx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_interfaces_packet_counters_path_rx_since_last_clear_delete(self, interfaces=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_index
    :param interfaces: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **interfaces** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'path-rx-since-last-clear'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_interfaces_packet_counters_path_tx_delete(self, interfaces=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_index
    :param interfaces: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **interfaces** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'path-tx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_interfaces_packet_counters_path_tx_since_last_clear_delete(self, interfaces=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_index
    :param interfaces: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **interfaces** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'path-tx-since-last-clear'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_interfaces_packet_counters_patherr_rx_delete(self, interfaces=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_index
    :param interfaces: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **interfaces** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'patherr-rx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_interfaces_packet_counters_patherr_rx_since_last_clear_delete(self, interfaces=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_index
    :param interfaces: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **interfaces** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'patherr-rx-since-last-clear'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_interfaces_packet_counters_patherr_tx_delete(self, interfaces=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_index
    :param interfaces: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **interfaces** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'patherr-tx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_interfaces_packet_counters_patherr_tx_since_last_clear_delete(self, interfaces=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_index
    :param interfaces: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **interfaces** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'patherr-tx-since-last-clear'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_interfaces_packet_counters_pathtear_rx_delete(self, interfaces=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_index
    :param interfaces: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **interfaces** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'pathtear-rx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_interfaces_packet_counters_pathtear_rx_since_last_clear_delete(self, interfaces=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_index
    :param interfaces: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **interfaces** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'pathtear-rx-since-last-clear'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_interfaces_packet_counters_pathtear_tx_delete(self, interfaces=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_index
    :param interfaces: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **interfaces** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'pathtear-tx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_interfaces_packet_counters_pathtear_tx_since_last_clear_delete(self, interfaces=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_index
    :param interfaces: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **interfaces** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'pathtear-tx-since-last-clear'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_interfaces_packet_counters_resv_rx_delete(self, interfaces=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_index
    :param interfaces: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **interfaces** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'resv-rx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_interfaces_packet_counters_resv_rx_since_last_clear_delete(self, interfaces=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_index
    :param interfaces: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **interfaces** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'resv-rx-since-last-clear'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_interfaces_packet_counters_resv_tx_delete(self, interfaces=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_index
    :param interfaces: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **interfaces** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'resv-tx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_interfaces_packet_counters_resv_tx_since_last_clear_delete(self, interfaces=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_index
    :param interfaces: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **interfaces** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'resv-tx-since-last-clear'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_interfaces_packet_counters_resvconf_rx_delete(self, interfaces=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_index
    :param interfaces: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **interfaces** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'resvconf-rx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_interfaces_packet_counters_resvconf_rx_since_last_clear_delete(self, interfaces=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_index
    :param interfaces: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **interfaces** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'resvconf-rx-since-last-clear'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_interfaces_packet_counters_resvconf_tx_delete(self, interfaces=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_index
    :param interfaces: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **interfaces** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'resvconf-tx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_interfaces_packet_counters_resvconf_tx_since_last_clear_delete(self, interfaces=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_index
    :param interfaces: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **interfaces** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'resvconf-tx-since-last-clear'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_interfaces_packet_counters_resverr_rx_delete(self, interfaces=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_index
    :param interfaces: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **interfaces** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'resverr-rx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_interfaces_packet_counters_resverr_rx_since_last_clear_delete(self, interfaces=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_index
    :param interfaces: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **interfaces** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'resverr-rx-since-last-clear'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_interfaces_packet_counters_resverr_tx_delete(self, interfaces=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_index
    :param interfaces: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **interfaces** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'resverr-tx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_interfaces_packet_counters_resverr_tx_since_last_clear_delete(self, interfaces=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_index
    :param interfaces: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **interfaces** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'resverr-tx-since-last-clear'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_interfaces_packet_counters_resvtear_rx_delete(self, interfaces=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_index
    :param interfaces: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **interfaces** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'resvtear-rx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_interfaces_packet_counters_resvtear_rx_since_last_clear_delete(self, interfaces=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_index
    :param interfaces: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **interfaces** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'resvtear-rx-since-last-clear'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_interfaces_packet_counters_resvtear_tx_delete(self, interfaces=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_index
    :param interfaces: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **interfaces** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'resvtear-tx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_interfaces_packet_counters_resvtear_tx_since_last_clear_delete(self, interfaces=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_index
    :param interfaces: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **interfaces** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'resvtear-tx-since-last-clear'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_interfaces_packet_counters_sumrefresh_rx_delete(self, interfaces=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_index
    :param interfaces: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **interfaces** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'sumrefresh-rx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_interfaces_packet_counters_sumrefresh_rx_since_last_clear_delete(self, interfaces=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_index
    :param interfaces: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **interfaces** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'sumrefresh-rx-since-last-clear'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_interfaces_packet_counters_sumrefresh_tx_delete(self, interfaces=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_index
    :param interfaces: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **interfaces** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'sumrefresh-tx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_interfaces_packet_counters_sumrefresh_tx_since_last_clear_delete(self, interfaces=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_index
    :param interfaces: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **interfaces** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'sumrefresh-tx-since-last-clear'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_interfaces_reliable_messages_delete(self, interfaces=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type interfaces: interface_index
    :param interfaces: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **interfaces** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interfaces', 'keyval': 'interface_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'reliable-messages'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_interfaces_summary_refresh_delete(self, interfaces=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type interfaces: interface_index
    :param interfaces: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **interfaces** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.interfaces', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interfaces', 'keyval': 'interface_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'summary-refresh'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_neighbors_delete(self, neighbors=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type neighbors: neighbor_ip_addr
    :param neighbors: Keyword argument tuple.

    :type neighbor_ip_addr: unicode
    :param neighbor_ip_addr: **neighbors** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.neighbors', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'neighbors', 'keyval': 'neighbor_ip_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbors=neighbors)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbors=neighbors)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_neighbors_active_lsps_delete(self, neighbors=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type neighbors: neighbor_ip_addr
    :param neighbors: Keyword argument tuple.

    :type neighbor_ip_addr: unicode
    :param neighbor_ip_addr: **neighbors** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.neighbors', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'neighbors', 'keyval': 'neighbor_ip_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'active-lsps'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbors=neighbors)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbors=neighbors)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_neighbors_last_hello_rx_delete(self, neighbors=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type neighbors: neighbor_ip_addr
    :param neighbors: Keyword argument tuple.

    :type neighbor_ip_addr: unicode
    :param neighbor_ip_addr: **neighbors** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.neighbors', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'neighbors', 'keyval': 'neighbor_ip_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'last-hello-rx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbors=neighbors)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbors=neighbors)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_neighbors_msg_id_support_delete(self, neighbors=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type neighbors: neighbor_ip_addr
    :param neighbors: Keyword argument tuple.

    :type neighbor_ip_addr: unicode
    :param neighbor_ip_addr: **neighbors** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.neighbors', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'neighbors', 'keyval': 'neighbor_ip_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'msg-id-support'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbors=neighbors)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbors=neighbors)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_neighbors_neighbor_interface_delete(self, neighbors=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type neighbors: neighbor_ip_addr
    :param neighbors: Keyword argument tuple.

    :type neighbor_ip_addr: unicode
    :param neighbor_ip_addr: **neighbors** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.neighbors', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'neighbors', 'keyval': 'neighbor_ip_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'neighbor-interface'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbors=neighbors)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbors=neighbors)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_neighbors_neighbor_last_status_change_delete(self, neighbors=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type neighbors: neighbor_ip_addr
    :param neighbors: Keyword argument tuple.

    :type neighbor_ip_addr: unicode
    :param neighbor_ip_addr: **neighbors** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.neighbors', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'neighbors', 'keyval': 'neighbor_ip_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'neighbor-last-status-change'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbors=neighbors)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbors=neighbors)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_neighbors_neighbor_local_instance_delete(self, neighbors=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type neighbors: neighbor_ip_addr
    :param neighbors: Keyword argument tuple.

    :type neighbor_ip_addr: unicode
    :param neighbor_ip_addr: **neighbors** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.neighbors', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'neighbors', 'keyval': 'neighbor_ip_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'neighbor-local-instance'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbors=neighbors)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbors=neighbors)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_neighbors_neighbor_remote_instance_delete(self, neighbors=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type neighbors: neighbor_ip_addr
    :param neighbors: Keyword argument tuple.

    :type neighbor_ip_addr: unicode
    :param neighbor_ip_addr: **neighbors** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.neighbors', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'neighbors', 'keyval': 'neighbor_ip_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'neighbor-remote-instance'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbors=neighbors)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbors=neighbors)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_neighbors_neighbor_status_delete(self, neighbors=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type neighbors: neighbor_ip_addr
    :param neighbors: Keyword argument tuple.

    :type neighbor_ip_addr: unicode
    :param neighbor_ip_addr: **neighbors** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.neighbors', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'neighbors', 'keyval': 'neighbor_ip_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'neighbor-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbors=neighbors)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbors=neighbors)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_neighbors_next_hello_req_tx_delete(self, neighbors=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type neighbors: neighbor_ip_addr
    :param neighbors: Keyword argument tuple.

    :type neighbor_ip_addr: unicode
    :param neighbor_ip_addr: **neighbors** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.neighbors', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'neighbors', 'keyval': 'neighbor_ip_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'next-hello-req-tx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbors=neighbors)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbors=neighbors)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_neighbors_refresh_reduction_support_delete(self, neighbors=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type neighbors: neighbor_ip_addr
    :param neighbors: Keyword argument tuple.

    :type neighbor_ip_addr: unicode
    :param neighbor_ip_addr: **neighbors** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.neighbors', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'neighbors', 'keyval': 'neighbor_ip_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'refresh-reduction-support'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbors=neighbors)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbors=neighbors)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_neighbors_rsvp_hello_interval_delete(self, neighbors=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type neighbors: neighbor_ip_addr
    :param neighbors: Keyword argument tuple.

    :type neighbor_ip_addr: unicode
    :param neighbor_ip_addr: **neighbors** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.neighbors', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'neighbors', 'keyval': 'neighbor_ip_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rsvp-hello-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbors=neighbors)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbors=neighbors)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_neighbors_rsvp_hello_rx_delete(self, neighbors=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type neighbors: neighbor_ip_addr
    :param neighbors: Keyword argument tuple.

    :type neighbor_ip_addr: unicode
    :param neighbor_ip_addr: **neighbors** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.neighbors', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'neighbors', 'keyval': 'neighbor_ip_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rsvp-hello-rx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbors=neighbors)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbors=neighbors)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_neighbors_rsvp_hello_tolerance_delete(self, neighbors=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type neighbors: neighbor_ip_addr
    :param neighbors: Keyword argument tuple.

    :type neighbor_ip_addr: unicode
    :param neighbor_ip_addr: **neighbors** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.neighbors', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'neighbors', 'keyval': 'neighbor_ip_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rsvp-hello-tolerance'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbors=neighbors)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbors=neighbors)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_neighbors_rsvp_hello_tx_delete(self, neighbors=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type neighbors: neighbor_ip_addr
    :param neighbors: Keyword argument tuple.

    :type neighbor_ip_addr: unicode
    :param neighbor_ip_addr: **neighbors** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.neighbors', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'neighbors', 'keyval': 'neighbor_ip_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rsvp-hello-tx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbors=neighbors)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbors=neighbors)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_protocol_status_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'protocol-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_refresh_interval_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'refresh-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_refresh_multiple_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'refresh-multiple'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_sessions_delete(self, sessions=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'sessions', 'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_delete(self, sessions=None, psbs=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_flap_lock_delete(self, sessions=None, psbs=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'flap-lock'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_frr_bandwidth_delete(self, sessions=None, psbs=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'frr-bandwidth'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_frr_bandwidth_protection_available_delete(self, sessions=None, psbs=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'frr-bandwidth-protection-available'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_frr_cost_delete(self, sessions=None, psbs=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'frr-cost'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_frr_cspf_group_computation_mode_delete(self, sessions=None, psbs=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'frr-cspf-group-computation-mode'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_frr_cspf_group_computation_mode_use_bypass_liberal_delete(self, sessions=None, psbs=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'frr-cspf-group-computation-mode-use-bypass-liberal'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_frr_detour_delete(self, sessions=None, psbs=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'frr-detour'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_frr_facility_delete(self, sessions=None, psbs=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'frr-facility'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_frr_facility_method_delete(self, sessions=None, psbs=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'frr-facility-method'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_frr_hoplimit_delete(self, sessions=None, psbs=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'frr-hoplimit'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_frr_lsp_bringup_abandoned_delete(self, sessions=None, psbs=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'frr-lsp-bringup-abandoned'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_frr_next_retry_delete(self, sessions=None, psbs=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'frr-next-retry'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_frr_nh_link_protection_available_delete(self, sessions=None, psbs=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'frr-nh-link-protection-available'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_frr_nh_link_protection_in_use_delete(self, sessions=None, psbs=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'frr-nh-link-protection-in-use'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_frr_nh_node_protection_available_delete(self, sessions=None, psbs=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'frr-nh-node-protection-available'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_frr_nh_node_protection_in_use_delete(self, sessions=None, psbs=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'frr-nh-node-protection-in-use'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_frr_psb_hold_priority_delete(self, sessions=None, psbs=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'frr-psb-hold-priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_frr_psb_setup_priority_delete(self, sessions=None, psbs=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'frr-psb-setup-priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_frr_retries_delete(self, sessions=None, psbs=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'frr-retries'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_frr_session_protection_available_delete(self, sessions=None, psbs=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'frr-session-protection-available'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_frr_unknown_backup_mode_desired_delete(self, sessions=None, psbs=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'frr-unknown-backup-mode-desired'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_frr_unknown_flags_delete(self, sessions=None, psbs=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'frr-unknown-flags'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_frr_updown_transitions_delete(self, sessions=None, psbs=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'frr-updown-transitions'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_is_backup_psb_delete(self, sessions=None, psbs=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'is-backup-psb'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_is_downstream_backup_psb_delete(self, sessions=None, psbs=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'is-downstream-backup-psb'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_is_ps_frr_backup_received_delete(self, sessions=None, psbs=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'is-ps-frr-backup-received'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_is_ps_frr_backup_sent_delete(self, sessions=None, psbs=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'is-ps-frr-backup-sent'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_is_ps_frr_detour_received_delete(self, sessions=None, psbs=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'is-ps-frr-detour-received'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_is_ps_frr_detour_sent_delete(self, sessions=None, psbs=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'is-ps-frr-detour-sent'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_is_upstream_psb_delete(self, sessions=None, psbs=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'is-upstream-psb'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_lsp_id_delete(self, sessions=None, psbs=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lsp-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_path_downstream_only_delete(self, sessions=None, psbs=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'path-downstream-only'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_path_operational_status_delete(self, sessions=None, psbs=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'path-operational-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_path_received_auth_on_delete(self, sessions=None, psbs=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'path-received-auth-on'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_path_received_from_ip_delete(self, sessions=None, psbs=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'path-received-from-ip'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_path_received_interface_delete(self, sessions=None, psbs=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'path-received-interface'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_path_received_message_id_delete(self, sessions=None, psbs=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'path-received-message-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_path_refresh_delete(self, sessions=None, psbs=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'path-refresh'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_path_refresh_ttd_delete(self, sessions=None, psbs=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'path-refresh-ttd'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_path_sent_auth_on_delete(self, sessions=None, psbs=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'path-sent-auth-on'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_path_sent_interface_delete(self, sessions=None, psbs=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'path-sent-interface'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_path_sent_message_id_delete(self, sessions=None, psbs=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'path-sent-message-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_path_sent_to_ip_delete(self, sessions=None, psbs=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'path-sent-to-ip'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_psb_hold_priority_delete(self, sessions=None, psbs=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'psb-hold-priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_psb_setup_priority_delete(self, sessions=None, psbs=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'psb-setup-priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_resv_received_auth_on_delete(self, sessions=None, psbs=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'resv-received-auth-on'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_resv_received_from_ip_delete(self, sessions=None, psbs=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'resv-received-from-ip'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_resv_received_interface_delete(self, sessions=None, psbs=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'resv-received-interface'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_resv_received_message_id_delete(self, sessions=None, psbs=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'resv-received-message-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_resv_refresh_delete(self, sessions=None, psbs=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'resv-refresh'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_resv_refresh_ttd_delete(self, sessions=None, psbs=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'resv-refresh-ttd'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_sa_flag_bandwidth_protect_delete(self, sessions=None, psbs=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'sa-flag-bandwidth-protect'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_sa_flag_label_recording_delete(self, sessions=None, psbs=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'sa-flag-label-recording'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_sa_flag_local_protect_delete(self, sessions=None, psbs=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'sa-flag-local-protect'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_sa_flag_se_style_delete(self, sessions=None, psbs=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'sa-flag-se-style'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_sa_flag_session_protection_type_delete(self, sessions=None, psbs=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'sa-flag-session-protection-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_sa_flag_soft_preemption_desired_delete(self, sessions=None, psbs=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'sa-flag-soft-preemption-desired'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_session_attribute_all_flags_delete(self, sessions=None, psbs=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'session-attribute-all-flags'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_session_ero_hops_delete(self, sessions=None, psbs=None, session_ero_hops=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type session_ero_hops: ip_addr
    :param session_ero_hops: Keyword argument tuple.

    :type ip_addr: unicode
    :param ip_addr: **session_ero_hops** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions.psbs', u'psbs')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions.psbs.session_ero_hops', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'path_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'session_ero_hops', 'keyval': 'ip_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs, session_ero_hops=session_ero_hops)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs, session_ero_hops=session_ero_hops)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_session_ero_hops_ero_flag_is_strict_hop_delete(self, sessions=None, psbs=None, session_ero_hops=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type session_ero_hops: ip_addr
    :param session_ero_hops: Keyword argument tuple.

    :type ip_addr: unicode
    :param ip_addr: **session_ero_hops** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions.psbs', u'psbs')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions.psbs.session_ero_hops', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'path_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'session_ero_hops', 'keyval': 'ip_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ero-flag-is-strict-hop'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs, session_ero_hops=session_ero_hops)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs, session_ero_hops=session_ero_hops)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_session_in_label_delete(self, sessions=None, psbs=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'session-in-label'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_session_name_delete(self, sessions=None, psbs=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'session-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_session_out_interface_delete(self, sessions=None, psbs=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'session-out-interface'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_session_out_label_delete(self, sessions=None, psbs=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'session-out-label'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_session_preemption_wait_timer_delete(self, sessions=None, psbs=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'session-preemption-wait-timer'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_session_riding_bypass_name_delete(self, sessions=None, psbs=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'session-riding-bypass-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_session_rro_hops_delete(self, sessions=None, psbs=None, session_rro_hops=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type session_rro_hops: ip_addr
    :param session_rro_hops: Keyword argument tuple.

    :type ip_addr: unicode
    :param ip_addr: **session_rro_hops** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions.psbs', u'psbs')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions.psbs.session_rro_hops', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'path_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'session_rro_hops', 'keyval': 'ip_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs, session_rro_hops=session_rro_hops)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs, session_rro_hops=session_rro_hops)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_session_rro_hops_rro_flag_is_local_protect_available_delete(self, sessions=None, psbs=None, session_rro_hops=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type session_rro_hops: ip_addr
    :param session_rro_hops: Keyword argument tuple.

    :type ip_addr: unicode
    :param ip_addr: **session_rro_hops** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions.psbs', u'psbs')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions.psbs.session_rro_hops', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'path_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'session_rro_hops', 'keyval': 'ip_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rro-flag-is-local-protect-available'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs, session_rro_hops=session_rro_hops)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs, session_rro_hops=session_rro_hops)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_session_rro_hops_rro_flag_is_local_protect_in_use_delete(self, sessions=None, psbs=None, session_rro_hops=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type session_rro_hops: ip_addr
    :param session_rro_hops: Keyword argument tuple.

    :type ip_addr: unicode
    :param ip_addr: **session_rro_hops** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions.psbs', u'psbs')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions.psbs.session_rro_hops', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'path_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'session_rro_hops', 'keyval': 'ip_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rro-flag-is-local-protect-in-use'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs, session_rro_hops=session_rro_hops)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs, session_rro_hops=session_rro_hops)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_session_rro_hops_rro_flag_rro_bandwidth_protect_delete(self, sessions=None, psbs=None, session_rro_hops=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type session_rro_hops: ip_addr
    :param session_rro_hops: Keyword argument tuple.

    :type ip_addr: unicode
    :param ip_addr: **session_rro_hops** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions.psbs', u'psbs')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions.psbs.session_rro_hops', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'path_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'session_rro_hops', 'keyval': 'ip_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rro-flag-rro-bandwidth-protect'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs, session_rro_hops=session_rro_hops)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs, session_rro_hops=session_rro_hops)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_session_rro_hops_rro_flag_rro_is_router_id_delete(self, sessions=None, psbs=None, session_rro_hops=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type session_rro_hops: ip_addr
    :param session_rro_hops: Keyword argument tuple.

    :type ip_addr: unicode
    :param ip_addr: **session_rro_hops** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions.psbs', u'psbs')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions.psbs.session_rro_hops', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'path_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'session_rro_hops', 'keyval': 'ip_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rro-flag-rro-is-router-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs, session_rro_hops=session_rro_hops)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs, session_rro_hops=session_rro_hops)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_session_rro_hops_rro_flag_rro_node_protect_delete(self, sessions=None, psbs=None, session_rro_hops=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type session_rro_hops: ip_addr
    :param session_rro_hops: Keyword argument tuple.

    :type ip_addr: unicode
    :param ip_addr: **session_rro_hops** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions.psbs', u'psbs')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions.psbs.session_rro_hops', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'path_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'session_rro_hops', 'keyval': 'ip_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rro-flag-rro-node-protect'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs, session_rro_hops=session_rro_hops)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs, session_rro_hops=session_rro_hops)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_session_soft_preemption_wait_timer_delete(self, sessions=None, psbs=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'session-soft-preemption-wait-timer'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_session_style_delete(self, sessions=None, psbs=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'session-style'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_session_type_delete(self, sessions=None, psbs=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'session-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_tspec_m_delete(self, sessions=None, psbs=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tspec-m'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_tspec_minimum_delete(self, sessions=None, psbs=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tspec-minimum'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_tspec_peak_delete(self, sessions=None, psbs=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tspec-peak'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_tspec_rate_delete(self, sessions=None, psbs=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tspec-rate'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_tspec_size_delete(self, sessions=None, psbs=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tspec-size'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_sessions_session_operational_status_delete(self, sessions=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.sessions', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'sessions', 'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'session-operational-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_statistics_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.statistics', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_counters_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_counters_ack_rx_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ack-rx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_counters_ack_rx_since_last_clear_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ack-rx-since-last-clear'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_counters_ack_tx_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ack-tx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_counters_ack_tx_since_last_clear_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ack-tx-since-last-clear'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_counters_bundle_rx_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bundle-rx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_counters_bundle_rx_since_last_clear_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bundle-rx-since-last-clear'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_counters_bundle_tx_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bundle-tx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_counters_bundle_tx_since_last_clear_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bundle-tx-since-last-clear'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_counters_hello_rx_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hello-rx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_counters_hello_rx_since_last_clear_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hello-rx-since-last-clear'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_counters_hello_tx_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hello-tx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_counters_hello_tx_since_last_clear_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hello-tx-since-last-clear'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_counters_path_rx_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'path-rx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_counters_path_rx_since_last_clear_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'path-rx-since-last-clear'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_counters_path_tx_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'path-tx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_counters_path_tx_since_last_clear_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'path-tx-since-last-clear'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_counters_patherr_rx_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'patherr-rx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_counters_patherr_rx_since_last_clear_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'patherr-rx-since-last-clear'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_counters_patherr_tx_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'patherr-tx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_counters_patherr_tx_since_last_clear_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'patherr-tx-since-last-clear'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_counters_pathtear_rx_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'pathtear-rx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_counters_pathtear_rx_since_last_clear_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'pathtear-rx-since-last-clear'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_counters_pathtear_tx_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'pathtear-tx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_counters_pathtear_tx_since_last_clear_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'pathtear-tx-since-last-clear'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_counters_resv_rx_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'resv-rx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_counters_resv_rx_since_last_clear_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'resv-rx-since-last-clear'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_counters_resv_tx_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'resv-tx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_counters_resv_tx_since_last_clear_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'resv-tx-since-last-clear'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_counters_resvconf_rx_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'resvconf-rx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_counters_resvconf_rx_since_last_clear_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'resvconf-rx-since-last-clear'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_counters_resvconf_tx_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'resvconf-tx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_counters_resvconf_tx_since_last_clear_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'resvconf-tx-since-last-clear'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_counters_resverr_rx_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'resverr-rx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_counters_resverr_rx_since_last_clear_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'resverr-rx-since-last-clear'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_counters_resverr_tx_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'resverr-tx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_counters_resverr_tx_since_last_clear_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'resverr-tx-since-last-clear'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_counters_resvtear_rx_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'resvtear-rx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_counters_resvtear_rx_since_last_clear_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'resvtear-rx-since-last-clear'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_counters_resvtear_tx_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'resvtear-tx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_counters_resvtear_tx_since_last_clear_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'resvtear-tx-since-last-clear'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_counters_sumrefresh_rx_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'sumrefresh-rx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_counters_sumrefresh_rx_since_last_clear_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'sumrefresh-rx-since-last-clear'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_counters_sumrefresh_tx_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'sumrefresh-tx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_counters_sumrefresh_tx_since_last_clear_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'sumrefresh-tx-since-last-clear'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_error_counters_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_error_counters_ack_errors_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ack-errors'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_error_counters_ack_errors_since_last_clear_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ack-errors-since-last-clear'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_error_counters_bundle_errors_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bundle-errors'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_error_counters_bundle_errors_since_last_clear_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bundle-errors-since-last-clear'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_error_counters_hello_errors_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hello-errors'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_error_counters_hello_errors_since_last_clear_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hello-errors-since-last-clear'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_error_counters_mem_alloc_fail_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mem-alloc-fail'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_error_counters_mem_alloc_fail_since_last_clear_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mem-alloc-fail-since-last-clear'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_error_counters_nackobject_errors_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'nackobject-errors'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_error_counters_nackobject_errors_since_last_clear_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'nackobject-errors-since-last-clear'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_error_counters_path_errors_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'path-errors'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_error_counters_path_errors_since_last_clear_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'path-errors-since-last-clear'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_error_counters_path_state_timeout_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'path-state-timeout'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_error_counters_path_state_timeout_since_last_clear_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'path-state-timeout-since-last-clear'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_error_counters_patherr_errors_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'patherr-errors'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_error_counters_patherr_errors_since_last_clear_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'patherr-errors-since-last-clear'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_error_counters_pathtear_errors_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'pathtear-errors'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_error_counters_pathtear_errors_since_last_clear_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'pathtear-errors-since-last-clear'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_error_counters_pkt_with_msg_id_drop_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'pkt-with-msg-id-drop'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_error_counters_pkt_with_msg_id_drop_since_last_clear_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'pkt-with-msg-id-drop-since-last-clear'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_error_counters_pkt_with_sref_drop_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'pkt-with-sref-drop'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_error_counters_pkt_with_sref_drop_since_last_clear_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'pkt-with-sref-drop-since-last-clear'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_error_counters_resv_errors_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'resv-errors'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_error_counters_resv_errors_since_last_clear_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'resv-errors-since-last-clear'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_error_counters_resv_state_timeout_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'resv-state-timeout'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_error_counters_resv_state_timeout_since_last_clear_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'resv-state-timeout-since-last-clear'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_error_counters_resvconf_errors_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'resvconf-errors'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_error_counters_resvconf_errors_since_last_clear_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'resvconf-errors-since-last-clear'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_error_counters_resverr_errors_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'resverr-errors'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_error_counters_resverr_errors_since_last_clear_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'resverr-errors-since-last-clear'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_error_counters_resvtear_errors_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'resvtear-errors'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_error_counters_resvtear_errors_since_last_clear_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'resvtear-errors-since-last-clear'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_error_counters_rx_md5_auth_error_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rx-md5-auth-error'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_error_counters_rx_md5_auth_error_since_last_clear_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rx-md5-auth-error-since-last-clear'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_error_counters_rx_pkt_bad_checksum_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rx-pkt-bad-checksum'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_error_counters_rx_pkt_bad_checksum_since_last_clear_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rx-pkt-bad-checksum-since-last-clear'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_error_counters_rx_pkt_bad_length_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rx-pkt-bad-length'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_error_counters_rx_pkt_bad_length_since_last_clear_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rx-pkt-bad-length-since-last-clear'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_error_counters_rx_pkt_bad_version_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rx-pkt-bad-version'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_error_counters_rx_pkt_bad_version_since_last_clear_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rx-pkt-bad-version-since-last-clear'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_error_counters_rx_pkt_unknown_type_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rx-pkt-unknown-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_error_counters_rx_pkt_unknown_type_since_last_clear_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rx-pkt-unknown-type-since-last-clear'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_error_counters_sumrefresh_errors_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'sumrefresh-errors'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_error_counters_sumrefresh_errors_since_last_clear_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'sumrefresh-errors-since-last-clear'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_rsvp_transport_address_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.rsvp', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'transport-address'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_statistics_oam_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.statistics_oam', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_statistics_oam_echo_req_received_count_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.statistics_oam', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'echo-req-received-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_statistics_oam_echo_req_sent_count_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.statistics_oam', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'echo-req-sent-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_statistics_oam_echo_req_timeout_count_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.statistics_oam', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'echo-req-timeout-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_statistics_oam_echo_resp_received_count_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.statistics_oam', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'echo-resp-received-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_statistics_oam_echo_resp_sent_count_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.statistics_oam', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'echo-resp-sent-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_statistics_oam_return_codes_delete(self, return_codes=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type return_codes: number
    :param return_codes: Keyword argument tuple.

    :type number: long
    :param number: **return_codes** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.statistics_oam.return_codes', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'return_codes', 'keyval': 'number', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, return_codes=return_codes)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, return_codes=return_codes)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_statistics_oam_return_codes_name_delete(self, return_codes=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type return_codes: number
    :param return_codes: Keyword argument tuple.

    :type number: long
    :param number: **return_codes** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.statistics_oam.return_codes', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'return_codes', 'keyval': 'number', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, return_codes=return_codes)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, return_codes=return_codes)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_statistics_oam_return_codes_rx_count_delete(self, return_codes=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type return_codes: number
    :param return_codes: Keyword argument tuple.

    :type number: long
    :param number: **return_codes** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.statistics_oam.return_codes', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'return_codes', 'keyval': 'number', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rx-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, return_codes=return_codes)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, return_codes=return_codes)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_statistics_oam_return_codes_tx_count_delete(self, return_codes=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type return_codes: number
    :param return_codes: Keyword argument tuple.

    :type number: long
    :param number: **return_codes** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.statistics_oam.return_codes', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'return_codes', 'keyval': 'number', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tx-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, return_codes=return_codes)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, return_codes=return_codes)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_statistics_oam_usr_ping_count_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.statistics_oam', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'usr-ping-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_statistics_oam_usr_traceroute_count_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.statistics_oam', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'usr-traceroute-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_summary_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.summary', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_summary_auto_bw_templates_configured_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.summary', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'auto-bw-templates-configured'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_summary_auto_bw_templates_supported_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.summary', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'auto-bw-templates-supported'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_summary_backup_lsps_up_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.summary', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'backup-lsps-up'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_summary_bypass_lsps_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.summary', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bypass-lsps'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_summary_bypass_lsps_enabled_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.summary', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bypass-lsps-enabled'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_summary_bypass_lsps_up_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.summary', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bypass-lsps-up'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_summary_cross_connects_allocated_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.summary', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cross-connects-allocated'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_summary_cross_connects_supported_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.summary', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cross-connects-supported'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_summary_cspf_groups_configured_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.summary', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cspf-groups-configured'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_summary_detour_lsps_up_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.summary', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'detour-lsps-up'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_summary_ldp_lsps_operational_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.summary', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ldp-lsps-operational'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_summary_lsps_configured_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.summary', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lsps-configured'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_summary_lsps_enabled_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.summary', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lsps-enabled'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_summary_lsps_operational_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.summary', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lsps-operational'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_summary_paths_configured_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.summary', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'paths-configured'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_summary_times_enabled_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.summary', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'times-enabled'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_summary_transit_lsps_configured_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.summary', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'transit-lsps-configured'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_summary_transit_lsps_enabled_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.summary', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'transit-lsps-enabled'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_summary_transit_lsps_operational_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.summary', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'transit-lsps-operational'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_summary_tunnels_allocated_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.summary', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tunnels-allocated'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_summary_tunnels_supported_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.summary', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tunnels-supported'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_te_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.te', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_te_database_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.database', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_te_database_area_delete(self, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type area: area_id, level_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type level_id: long
    :param level_id: **area** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.database.area', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'area', 'keyval': 'area_id, level_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_te_database_area_host_name_delete(self, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type area: area_id, level_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type level_id: long
    :param level_id: **area** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.database.area', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'area', 'keyval': 'area_id, level_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'host-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_te_database_area_igp_isis_delete(self, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type area: area_id, level_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type level_id: long
    :param level_id: **area** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.database.area', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'area', 'keyval': 'area_id, level_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'igp-isis'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_te_database_area_igp_ospf_delete(self, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type area: area_id, level_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type level_id: long
    :param level_id: **area** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.database.area', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'area', 'keyval': 'area_id, level_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'igp-ospf'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_te_database_area_node_delete(self, area=None, node=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type area: area_id, level_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type level_id: long
    :param level_id: **area** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type node: local_node_id, local_router_id
    :param node: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **node** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **node** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.database.area', u'area')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.database.area.node', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'area_id, level_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'node', 'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, area=area, node=node)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, area=area, node=node)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_te_database_area_node_area_id_delete(self, area=None, node=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type area: area_id, level_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type level_id: long
    :param level_id: **area** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type node: local_node_id, local_router_id
    :param node: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **node** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **node** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.database.area', u'area')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.database.area.node', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'area_id, level_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'node', 'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'area-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, area=area, node=node)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, area=area, node=node)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_te_database_area_node_gen_code_delete(self, area=None, node=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type area: area_id, level_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type level_id: long
    :param level_id: **area** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type node: local_node_id, local_router_id
    :param node: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **node** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **node** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.database.area', u'area')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.database.area.node', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'area_id, level_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'node', 'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'gen-code'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, area=area, node=node)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, area=area, node=node)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_te_database_area_node_host_name_delete(self, area=None, node=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type area: area_id, level_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type level_id: long
    :param level_id: **area** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type node: local_node_id, local_router_id
    :param node: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **node** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **node** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.database.area', u'area')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.database.area.node', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'area_id, level_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'node', 'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'host-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, area=area, node=node)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, area=area, node=node)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_te_database_area_node_igp_isis_delete(self, area=None, node=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type area: area_id, level_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type level_id: long
    :param level_id: **area** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type node: local_node_id, local_router_id
    :param node: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **node** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **node** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.database.area', u'area')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.database.area.node', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'area_id, level_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'node', 'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'igp-isis'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, area=area, node=node)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, area=area, node=node)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_te_database_area_node_igp_ospf_delete(self, area=None, node=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type area: area_id, level_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type level_id: long
    :param level_id: **area** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type node: local_node_id, local_router_id
    :param node: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **node** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **node** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.database.area', u'area')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.database.area.node', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'area_id, level_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'node', 'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'igp-ospf'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, area=area, node=node)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, area=area, node=node)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_te_database_area_node_level_id_delete(self, area=None, node=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type area: area_id, level_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type level_id: long
    :param level_id: **area** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type node: local_node_id, local_router_id
    :param node: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **node** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **node** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.database.area', u'area')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.database.area.node', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'area_id, level_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'node', 'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'level-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, area=area, node=node)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, area=area, node=node)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_te_database_area_node_link_delete(self, area=None, node=None, link=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type area: area_id, level_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type level_id: long
    :param level_id: **area** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type node: local_node_id, local_router_id
    :param node: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **node** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **node** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type link: local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip
    :param link: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **link** tuple argument.

    :type remote_node_id: unicode
    :param remote_node_id: **link** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_router_id: unicode
    :param remote_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type local_ip: unicode
    :param local_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_ip: unicode
    :param remote_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.database.area', u'area'), ('pybind.slxos.v16r_1_00b.mpls_state.te.database.area.node', u'node')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.database.area.node.link', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'link', 'keyval': 'local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, area=area, node=node, link=link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, area=area, node=node, link=link)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_te_database_area_node_link_admin_group_delete(self, area=None, node=None, link=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type area: area_id, level_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type level_id: long
    :param level_id: **area** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type node: local_node_id, local_router_id
    :param node: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **node** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **node** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type link: local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip
    :param link: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **link** tuple argument.

    :type remote_node_id: unicode
    :param remote_node_id: **link** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_router_id: unicode
    :param remote_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type local_ip: unicode
    :param local_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_ip: unicode
    :param remote_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.database.area', u'area'), ('pybind.slxos.v16r_1_00b.mpls_state.te.database.area.node', u'node')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.database.area.node.link', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'link', 'keyval': 'local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'admin-group'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, area=area, node=node, link=link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, area=area, node=node, link=link)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_te_database_area_node_link_area_id_delete(self, area=None, node=None, link=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type area: area_id, level_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type level_id: long
    :param level_id: **area** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type node: local_node_id, local_router_id
    :param node: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **node** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **node** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type link: local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip
    :param link: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **link** tuple argument.

    :type remote_node_id: unicode
    :param remote_node_id: **link** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_router_id: unicode
    :param remote_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type local_ip: unicode
    :param local_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_ip: unicode
    :param remote_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.database.area', u'area'), ('pybind.slxos.v16r_1_00b.mpls_state.te.database.area.node', u'node')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.database.area.node.link', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'link', 'keyval': 'local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'area-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, area=area, node=node, link=link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, area=area, node=node, link=link)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_te_database_area_node_link_gen_code_delete(self, area=None, node=None, link=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type area: area_id, level_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type level_id: long
    :param level_id: **area** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type node: local_node_id, local_router_id
    :param node: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **node** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **node** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type link: local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip
    :param link: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **link** tuple argument.

    :type remote_node_id: unicode
    :param remote_node_id: **link** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_router_id: unicode
    :param remote_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type local_ip: unicode
    :param local_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_ip: unicode
    :param remote_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.database.area', u'area'), ('pybind.slxos.v16r_1_00b.mpls_state.te.database.area.node', u'node')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.database.area.node.link', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'link', 'keyval': 'local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'gen-code'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, area=area, node=node, link=link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, area=area, node=node, link=link)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_te_database_area_node_link_igp_isis_delete(self, area=None, node=None, link=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type area: area_id, level_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type level_id: long
    :param level_id: **area** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type node: local_node_id, local_router_id
    :param node: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **node** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **node** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type link: local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip
    :param link: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **link** tuple argument.

    :type remote_node_id: unicode
    :param remote_node_id: **link** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_router_id: unicode
    :param remote_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type local_ip: unicode
    :param local_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_ip: unicode
    :param remote_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.database.area', u'area'), ('pybind.slxos.v16r_1_00b.mpls_state.te.database.area.node', u'node')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.database.area.node.link', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'link', 'keyval': 'local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'igp-isis'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, area=area, node=node, link=link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, area=area, node=node, link=link)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_te_database_area_node_link_igp_metric_delete(self, area=None, node=None, link=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type area: area_id, level_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type level_id: long
    :param level_id: **area** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type node: local_node_id, local_router_id
    :param node: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **node** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **node** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type link: local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip
    :param link: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **link** tuple argument.

    :type remote_node_id: unicode
    :param remote_node_id: **link** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_router_id: unicode
    :param remote_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type local_ip: unicode
    :param local_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_ip: unicode
    :param remote_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.database.area', u'area'), ('pybind.slxos.v16r_1_00b.mpls_state.te.database.area.node', u'node')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.database.area.node.link', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'link', 'keyval': 'local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'igp-metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, area=area, node=node, link=link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, area=area, node=node, link=link)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_te_database_area_node_link_igp_ospf_delete(self, area=None, node=None, link=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type area: area_id, level_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type level_id: long
    :param level_id: **area** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type node: local_node_id, local_router_id
    :param node: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **node** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **node** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type link: local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip
    :param link: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **link** tuple argument.

    :type remote_node_id: unicode
    :param remote_node_id: **link** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_router_id: unicode
    :param remote_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type local_ip: unicode
    :param local_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_ip: unicode
    :param remote_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.database.area', u'area'), ('pybind.slxos.v16r_1_00b.mpls_state.te.database.area.node', u'node')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.database.area.node.link', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'link', 'keyval': 'local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'igp-ospf'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, area=area, node=node, link=link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, area=area, node=node, link=link)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_te_database_area_node_link_level_id_delete(self, area=None, node=None, link=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type area: area_id, level_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type level_id: long
    :param level_id: **area** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type node: local_node_id, local_router_id
    :param node: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **node** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **node** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type link: local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip
    :param link: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **link** tuple argument.

    :type remote_node_id: unicode
    :param remote_node_id: **link** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_router_id: unicode
    :param remote_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type local_ip: unicode
    :param local_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_ip: unicode
    :param remote_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.database.area', u'area'), ('pybind.slxos.v16r_1_00b.mpls_state.te.database.area.node', u'node')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.database.area.node.link', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'link', 'keyval': 'local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'level-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, area=area, node=node, link=link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, area=area, node=node, link=link)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_te_database_area_node_link_local_host_name_delete(self, area=None, node=None, link=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type area: area_id, level_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type level_id: long
    :param level_id: **area** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type node: local_node_id, local_router_id
    :param node: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **node** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **node** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type link: local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip
    :param link: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **link** tuple argument.

    :type remote_node_id: unicode
    :param remote_node_id: **link** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_router_id: unicode
    :param remote_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type local_ip: unicode
    :param local_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_ip: unicode
    :param remote_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.database.area', u'area'), ('pybind.slxos.v16r_1_00b.mpls_state.te.database.area.node', u'node')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.database.area.node.link', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'link', 'keyval': 'local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'local-host-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, area=area, node=node, link=link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, area=area, node=node, link=link)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_te_database_area_node_link_lsa_id_delete(self, area=None, node=None, link=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type area: area_id, level_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type level_id: long
    :param level_id: **area** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type node: local_node_id, local_router_id
    :param node: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **node** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **node** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type link: local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip
    :param link: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **link** tuple argument.

    :type remote_node_id: unicode
    :param remote_node_id: **link** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_router_id: unicode
    :param remote_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type local_ip: unicode
    :param local_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_ip: unicode
    :param remote_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.database.area', u'area'), ('pybind.slxos.v16r_1_00b.mpls_state.te.database.area.node', u'node')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.database.area.node.link', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'link', 'keyval': 'local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lsa-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, area=area, node=node, link=link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, area=area, node=node, link=link)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_te_database_area_node_link_max_bandwidth_delete(self, area=None, node=None, link=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type area: area_id, level_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type level_id: long
    :param level_id: **area** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type node: local_node_id, local_router_id
    :param node: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **node** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **node** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type link: local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip
    :param link: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **link** tuple argument.

    :type remote_node_id: unicode
    :param remote_node_id: **link** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_router_id: unicode
    :param remote_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type local_ip: unicode
    :param local_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_ip: unicode
    :param remote_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.database.area', u'area'), ('pybind.slxos.v16r_1_00b.mpls_state.te.database.area.node', u'node')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.database.area.node.link', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'link', 'keyval': 'local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'max-bandwidth'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, area=area, node=node, link=link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, area=area, node=node, link=link)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_te_database_area_node_link_max_reservable_bandwidth_delete(self, area=None, node=None, link=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type area: area_id, level_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type level_id: long
    :param level_id: **area** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type node: local_node_id, local_router_id
    :param node: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **node** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **node** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type link: local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip
    :param link: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **link** tuple argument.

    :type remote_node_id: unicode
    :param remote_node_id: **link** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_router_id: unicode
    :param remote_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type local_ip: unicode
    :param local_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_ip: unicode
    :param remote_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.database.area', u'area'), ('pybind.slxos.v16r_1_00b.mpls_state.te.database.area.node', u'node')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.database.area.node.link', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'link', 'keyval': 'local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'max-reservable-bandwidth'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, area=area, node=node, link=link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, area=area, node=node, link=link)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_te_database_area_node_link_network_delete(self, area=None, node=None, link=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type area: area_id, level_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type level_id: long
    :param level_id: **area** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type node: local_node_id, local_router_id
    :param node: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **node** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **node** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type link: local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip
    :param link: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **link** tuple argument.

    :type remote_node_id: unicode
    :param remote_node_id: **link** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_router_id: unicode
    :param remote_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type local_ip: unicode
    :param local_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_ip: unicode
    :param remote_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.database.area', u'area'), ('pybind.slxos.v16r_1_00b.mpls_state.te.database.area.node', u'node')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.database.area.node.link', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'link', 'keyval': 'local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'network'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, area=area, node=node, link=link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, area=area, node=node, link=link)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_te_database_area_node_link_p2mp_delete(self, area=None, node=None, link=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type area: area_id, level_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type level_id: long
    :param level_id: **area** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type node: local_node_id, local_router_id
    :param node: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **node** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **node** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type link: local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip
    :param link: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **link** tuple argument.

    :type remote_node_id: unicode
    :param remote_node_id: **link** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_router_id: unicode
    :param remote_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type local_ip: unicode
    :param local_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_ip: unicode
    :param remote_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.database.area', u'area'), ('pybind.slxos.v16r_1_00b.mpls_state.te.database.area.node', u'node')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.database.area.node.link', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'link', 'keyval': 'local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'p2mp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, area=area, node=node, link=link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, area=area, node=node, link=link)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_te_database_area_node_link_p2p_delete(self, area=None, node=None, link=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type area: area_id, level_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type level_id: long
    :param level_id: **area** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type node: local_node_id, local_router_id
    :param node: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **node** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **node** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type link: local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip
    :param link: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **link** tuple argument.

    :type remote_node_id: unicode
    :param remote_node_id: **link** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_router_id: unicode
    :param remote_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type local_ip: unicode
    :param local_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_ip: unicode
    :param remote_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.database.area', u'area'), ('pybind.slxos.v16r_1_00b.mpls_state.te.database.area.node', u'node')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.database.area.node.link', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'link', 'keyval': 'local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'p2p'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, area=area, node=node, link=link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, area=area, node=node, link=link)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_te_database_area_node_link_pending_delete_delete(self, area=None, node=None, link=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type area: area_id, level_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type level_id: long
    :param level_id: **area** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type node: local_node_id, local_router_id
    :param node: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **node** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **node** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type link: local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip
    :param link: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **link** tuple argument.

    :type remote_node_id: unicode
    :param remote_node_id: **link** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_router_id: unicode
    :param remote_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type local_ip: unicode
    :param local_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_ip: unicode
    :param remote_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.database.area', u'area'), ('pybind.slxos.v16r_1_00b.mpls_state.te.database.area.node', u'node')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.database.area.node.link', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'link', 'keyval': 'local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'pending-delete'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, area=area, node=node, link=link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, area=area, node=node, link=link)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_te_database_area_node_link_remote_host_name_delete(self, area=None, node=None, link=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type area: area_id, level_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type level_id: long
    :param level_id: **area** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type node: local_node_id, local_router_id
    :param node: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **node** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **node** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type link: local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip
    :param link: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **link** tuple argument.

    :type remote_node_id: unicode
    :param remote_node_id: **link** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_router_id: unicode
    :param remote_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type local_ip: unicode
    :param local_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_ip: unicode
    :param remote_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.database.area', u'area'), ('pybind.slxos.v16r_1_00b.mpls_state.te.database.area.node', u'node')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.database.area.node.link', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'link', 'keyval': 'local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'remote-host-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, area=area, node=node, link=link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, area=area, node=node, link=link)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_te_database_area_node_link_router_delete(self, area=None, node=None, link=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type area: area_id, level_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type level_id: long
    :param level_id: **area** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type node: local_node_id, local_router_id
    :param node: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **node** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **node** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type link: local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip
    :param link: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **link** tuple argument.

    :type remote_node_id: unicode
    :param remote_node_id: **link** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_router_id: unicode
    :param remote_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type local_ip: unicode
    :param local_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_ip: unicode
    :param remote_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.database.area', u'area'), ('pybind.slxos.v16r_1_00b.mpls_state.te.database.area.node', u'node')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.database.area.node.link', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'link', 'keyval': 'local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'router'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, area=area, node=node, link=link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, area=area, node=node, link=link)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_te_database_area_node_link_srlg_delete(self, area=None, node=None, link=None, srlg=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type area: area_id, level_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type level_id: long
    :param level_id: **area** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type node: local_node_id, local_router_id
    :param node: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **node** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **node** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type link: local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip
    :param link: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **link** tuple argument.

    :type remote_node_id: unicode
    :param remote_node_id: **link** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_router_id: unicode
    :param remote_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type local_ip: unicode
    :param local_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_ip: unicode
    :param remote_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type srlg: name
    :param srlg: Keyword argument tuple.

    :type name: unicode
    :param name: **srlg** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.database.area', u'area'), ('pybind.slxos.v16r_1_00b.mpls_state.te.database.area.node', u'node'), ('pybind.slxos.v16r_1_00b.mpls_state.te.database.area.node.link', u'link')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.database.area.node.link.srlg', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'srlg', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, area=area, node=node, link=link, srlg=srlg)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, area=area, node=node, link=link, srlg=srlg)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_te_database_area_node_link_srlg_penalty_delete(self, area=None, node=None, link=None, srlg=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type area: area_id, level_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type level_id: long
    :param level_id: **area** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type node: local_node_id, local_router_id
    :param node: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **node** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **node** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type link: local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip
    :param link: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **link** tuple argument.

    :type remote_node_id: unicode
    :param remote_node_id: **link** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_router_id: unicode
    :param remote_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type local_ip: unicode
    :param local_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_ip: unicode
    :param remote_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type srlg: name
    :param srlg: Keyword argument tuple.

    :type name: unicode
    :param name: **srlg** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.database.area', u'area'), ('pybind.slxos.v16r_1_00b.mpls_state.te.database.area.node', u'node'), ('pybind.slxos.v16r_1_00b.mpls_state.te.database.area.node.link', u'link')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.database.area.node.link.srlg', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'srlg', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'penalty'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, area=area, node=node, link=link, srlg=srlg)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, area=area, node=node, link=link, srlg=srlg)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_te_database_area_node_link_te_metric_delete(self, area=None, node=None, link=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type area: area_id, level_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type level_id: long
    :param level_id: **area** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type node: local_node_id, local_router_id
    :param node: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **node** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **node** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type link: local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip
    :param link: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **link** tuple argument.

    :type remote_node_id: unicode
    :param remote_node_id: **link** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_router_id: unicode
    :param remote_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type local_ip: unicode
    :param local_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_ip: unicode
    :param remote_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.database.area', u'area'), ('pybind.slxos.v16r_1_00b.mpls_state.te.database.area.node', u'node')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.database.area.node.link', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'link', 'keyval': 'local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'te-metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, area=area, node=node, link=link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, area=area, node=node, link=link)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_te_database_area_node_link_unreserved_priority_0_bandwidth_delete(self, area=None, node=None, link=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type area: area_id, level_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type level_id: long
    :param level_id: **area** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type node: local_node_id, local_router_id
    :param node: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **node** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **node** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type link: local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip
    :param link: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **link** tuple argument.

    :type remote_node_id: unicode
    :param remote_node_id: **link** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_router_id: unicode
    :param remote_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type local_ip: unicode
    :param local_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_ip: unicode
    :param remote_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.database.area', u'area'), ('pybind.slxos.v16r_1_00b.mpls_state.te.database.area.node', u'node')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.database.area.node.link', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'link', 'keyval': 'local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'unreserved-priority-0-bandwidth'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, area=area, node=node, link=link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, area=area, node=node, link=link)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_te_database_area_node_link_unreserved_priority_1_bandwidth_delete(self, area=None, node=None, link=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type area: area_id, level_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type level_id: long
    :param level_id: **area** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type node: local_node_id, local_router_id
    :param node: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **node** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **node** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type link: local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip
    :param link: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **link** tuple argument.

    :type remote_node_id: unicode
    :param remote_node_id: **link** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_router_id: unicode
    :param remote_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type local_ip: unicode
    :param local_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_ip: unicode
    :param remote_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.database.area', u'area'), ('pybind.slxos.v16r_1_00b.mpls_state.te.database.area.node', u'node')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.database.area.node.link', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'link', 'keyval': 'local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'unreserved-priority-1-bandwidth'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, area=area, node=node, link=link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, area=area, node=node, link=link)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_te_database_area_node_link_unreserved_priority_2_bandwidth_delete(self, area=None, node=None, link=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type area: area_id, level_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type level_id: long
    :param level_id: **area** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type node: local_node_id, local_router_id
    :param node: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **node** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **node** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type link: local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip
    :param link: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **link** tuple argument.

    :type remote_node_id: unicode
    :param remote_node_id: **link** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_router_id: unicode
    :param remote_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type local_ip: unicode
    :param local_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_ip: unicode
    :param remote_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.database.area', u'area'), ('pybind.slxos.v16r_1_00b.mpls_state.te.database.area.node', u'node')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.database.area.node.link', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'link', 'keyval': 'local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'unreserved-priority-2-bandwidth'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, area=area, node=node, link=link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, area=area, node=node, link=link)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_te_database_area_node_link_unreserved_priority_3_bandwidth_delete(self, area=None, node=None, link=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type area: area_id, level_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type level_id: long
    :param level_id: **area** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type node: local_node_id, local_router_id
    :param node: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **node** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **node** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type link: local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip
    :param link: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **link** tuple argument.

    :type remote_node_id: unicode
    :param remote_node_id: **link** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_router_id: unicode
    :param remote_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type local_ip: unicode
    :param local_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_ip: unicode
    :param remote_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.database.area', u'area'), ('pybind.slxos.v16r_1_00b.mpls_state.te.database.area.node', u'node')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.database.area.node.link', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'link', 'keyval': 'local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'unreserved-priority-3-bandwidth'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, area=area, node=node, link=link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, area=area, node=node, link=link)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_te_database_area_node_link_unreserved_priority_4_bandwidth_delete(self, area=None, node=None, link=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type area: area_id, level_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type level_id: long
    :param level_id: **area** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type node: local_node_id, local_router_id
    :param node: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **node** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **node** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type link: local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip
    :param link: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **link** tuple argument.

    :type remote_node_id: unicode
    :param remote_node_id: **link** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_router_id: unicode
    :param remote_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type local_ip: unicode
    :param local_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_ip: unicode
    :param remote_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.database.area', u'area'), ('pybind.slxos.v16r_1_00b.mpls_state.te.database.area.node', u'node')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.database.area.node.link', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'link', 'keyval': 'local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'unreserved-priority-4-bandwidth'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, area=area, node=node, link=link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, area=area, node=node, link=link)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_te_database_area_node_link_unreserved_priority_5_bandwidth_delete(self, area=None, node=None, link=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type area: area_id, level_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type level_id: long
    :param level_id: **area** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type node: local_node_id, local_router_id
    :param node: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **node** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **node** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type link: local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip
    :param link: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **link** tuple argument.

    :type remote_node_id: unicode
    :param remote_node_id: **link** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_router_id: unicode
    :param remote_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type local_ip: unicode
    :param local_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_ip: unicode
    :param remote_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.database.area', u'area'), ('pybind.slxos.v16r_1_00b.mpls_state.te.database.area.node', u'node')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.database.area.node.link', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'link', 'keyval': 'local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'unreserved-priority-5-bandwidth'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, area=area, node=node, link=link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, area=area, node=node, link=link)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_te_database_area_node_link_unreserved_priority_6_bandwidth_delete(self, area=None, node=None, link=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type area: area_id, level_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type level_id: long
    :param level_id: **area** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type node: local_node_id, local_router_id
    :param node: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **node** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **node** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type link: local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip
    :param link: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **link** tuple argument.

    :type remote_node_id: unicode
    :param remote_node_id: **link** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_router_id: unicode
    :param remote_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type local_ip: unicode
    :param local_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_ip: unicode
    :param remote_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.database.area', u'area'), ('pybind.slxos.v16r_1_00b.mpls_state.te.database.area.node', u'node')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.database.area.node.link', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'link', 'keyval': 'local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'unreserved-priority-6-bandwidth'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, area=area, node=node, link=link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, area=area, node=node, link=link)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_te_database_area_node_link_unreserved_priority_7_bandwidth_delete(self, area=None, node=None, link=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type area: area_id, level_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type level_id: long
    :param level_id: **area** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type node: local_node_id, local_router_id
    :param node: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **node** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **node** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type link: local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip
    :param link: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **link** tuple argument.

    :type remote_node_id: unicode
    :param remote_node_id: **link** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_router_id: unicode
    :param remote_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type local_ip: unicode
    :param local_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_ip: unicode
    :param remote_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.database.area', u'area'), ('pybind.slxos.v16r_1_00b.mpls_state.te.database.area.node', u'node')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.database.area.node.link', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'link', 'keyval': 'local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'unreserved-priority-7-bandwidth'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, area=area, node=node, link=link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, area=area, node=node, link=link)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_te_database_area_node_lsa_id_delete(self, area=None, node=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type area: area_id, level_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type level_id: long
    :param level_id: **area** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type node: local_node_id, local_router_id
    :param node: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **node** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **node** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.database.area', u'area')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.database.area.node', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'area_id, level_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'node', 'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lsa-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, area=area, node=node)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, area=area, node=node)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_te_database_area_node_network_delete(self, area=None, node=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type area: area_id, level_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type level_id: long
    :param level_id: **area** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type node: local_node_id, local_router_id
    :param node: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **node** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **node** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.database.area', u'area')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.database.area.node', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'area_id, level_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'node', 'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'network'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, area=area, node=node)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, area=area, node=node)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_te_database_area_node_overloaded_delete(self, area=None, node=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type area: area_id, level_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type level_id: long
    :param level_id: **area** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type node: local_node_id, local_router_id
    :param node: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **node** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **node** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.database.area', u'area')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.database.area.node', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'area_id, level_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'node', 'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'overloaded'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, area=area, node=node)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, area=area, node=node)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_te_database_area_node_router_delete(self, area=None, node=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type area: area_id, level_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type level_id: long
    :param level_id: **area** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type node: local_node_id, local_router_id
    :param node: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **node** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **node** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.database.area', u'area')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.database.area.node', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'area_id, level_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'node', 'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'router'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, area=area, node=node)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, area=area, node=node)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_te_database_area_node_srlg_delete(self, area=None, node=None, srlg=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type area: area_id, level_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type level_id: long
    :param level_id: **area** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type node: local_node_id, local_router_id
    :param node: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **node** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **node** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type srlg: name
    :param srlg: Keyword argument tuple.

    :type name: unicode
    :param name: **srlg** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.database.area', u'area'), ('pybind.slxos.v16r_1_00b.mpls_state.te.database.area.node', u'node')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.database.area.node.srlg', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'srlg', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, area=area, node=node, srlg=srlg)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, area=area, node=node, srlg=srlg)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_te_database_area_node_srlg_penalty_delete(self, area=None, node=None, srlg=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type area: area_id, level_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type level_id: long
    :param level_id: **area** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type node: local_node_id, local_router_id
    :param node: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **node** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **node** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type srlg: name
    :param srlg: Keyword argument tuple.

    :type name: unicode
    :param name: **srlg** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.database.area', u'area'), ('pybind.slxos.v16r_1_00b.mpls_state.te.database.area.node', u'node')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.database.area.node.srlg', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'srlg', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'penalty'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, area=area, node=node, srlg=srlg)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, area=area, node=node, srlg=srlg)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_te_database_area_node_total_p2mp_links_delete(self, area=None, node=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type area: area_id, level_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type level_id: long
    :param level_id: **area** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type node: local_node_id, local_router_id
    :param node: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **node** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **node** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.database.area', u'area')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.database.area.node', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'area_id, level_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'node', 'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'total-p2mp-links'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, area=area, node=node)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, area=area, node=node)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_te_database_area_node_total_p2p_links_delete(self, area=None, node=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type area: area_id, level_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type level_id: long
    :param level_id: **area** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type node: local_node_id, local_router_id
    :param node: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **node** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **node** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.database.area', u'area')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.database.area.node', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'area_id, level_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'node', 'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'total-p2p-links'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, area=area, node=node)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, area=area, node=node)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_te_database_area_router_id_delete(self, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type area: area_id, level_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type level_id: long
    :param level_id: **area** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.database.area', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'area', 'keyval': 'area_id, level_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'router-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_te_database_area_total_network_nodes_delete(self, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type area: area_id, level_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type level_id: long
    :param level_id: **area** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.database.area', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'area', 'keyval': 'area_id, level_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'total-network-nodes'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_te_database_area_total_p2mp_links_delete(self, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type area: area_id, level_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type level_id: long
    :param level_id: **area** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.database.area', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'area', 'keyval': 'area_id, level_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'total-p2mp-links'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_te_database_area_total_p2p_links_delete(self, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type area: area_id, level_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type level_id: long
    :param level_id: **area** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.database.area', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'area', 'keyval': 'area_id, level_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'total-p2p-links'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_te_database_area_total_router_nodes_delete(self, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type area: area_id, level_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type level_id: long
    :param level_id: **area** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.database.area', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'area', 'keyval': 'area_id, level_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'total-router-nodes'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_te_database_router_id_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.database', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'router-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_te_isis_level_id_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.te', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'isis-level-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_te_isis_te_enabled_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.te', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'isis-te-enabled'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_te_ospf_area_id_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.te', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ospf-area-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_te_ospf_te_enabled_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.te', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ospf-te-enabled'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_te_router_id_map_delete(self, router_id_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type router_id_map: ip_address
    :param router_id_map: Keyword argument tuple.

    :type ip_address: unicode
    :param ip_address: **router_id_map** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.router_id_map', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'router_id_map', 'keyval': 'ip_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, router_id_map=router_id_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, router_id_map=router_id_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_te_router_id_map_igp_isis_delete(self, router_id_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type router_id_map: ip_address
    :param router_id_map: Keyword argument tuple.

    :type ip_address: unicode
    :param ip_address: **router_id_map** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.router_id_map', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'router_id_map', 'keyval': 'ip_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'igp-isis'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, router_id_map=router_id_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, router_id_map=router_id_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_te_router_id_map_igp_ospf_delete(self, router_id_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type router_id_map: ip_address
    :param router_id_map: Keyword argument tuple.

    :type ip_address: unicode
    :param ip_address: **router_id_map** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.router_id_map', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'router_id_map', 'keyval': 'ip_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'igp-ospf'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, router_id_map=router_id_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, router_id_map=router_id_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_te_router_id_map_isis_level_delete(self, router_id_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type router_id_map: ip_address
    :param router_id_map: Keyword argument tuple.

    :type ip_address: unicode
    :param ip_address: **router_id_map** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.router_id_map', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'router_id_map', 'keyval': 'ip_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'isis-level'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, router_id_map=router_id_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, router_id_map=router_id_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_te_router_id_map_origin_lsp_delete(self, router_id_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type router_id_map: ip_address
    :param router_id_map: Keyword argument tuple.

    :type ip_address: unicode
    :param ip_address: **router_id_map** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.router_id_map', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'router_id_map', 'keyval': 'ip_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'origin-lsp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, router_id_map=router_id_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, router_id_map=router_id_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_te_router_id_map_origin_other_delete(self, router_id_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type router_id_map: ip_address
    :param router_id_map: Keyword argument tuple.

    :type ip_address: unicode
    :param ip_address: **router_id_map** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.router_id_map', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'router_id_map', 'keyval': 'ip_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'origin-other'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, router_id_map=router_id_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, router_id_map=router_id_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_te_router_id_map_origin_path_delete(self, router_id_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type router_id_map: ip_address
    :param router_id_map: Keyword argument tuple.

    :type ip_address: unicode
    :param ip_address: **router_id_map** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.router_id_map', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'router_id_map', 'keyval': 'ip_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'origin-path'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, router_id_map=router_id_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, router_id_map=router_id_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_te_router_id_map_origin_ted_delete(self, router_id_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type router_id_map: ip_address
    :param router_id_map: Keyword argument tuple.

    :type ip_address: unicode
    :param ip_address: **router_id_map** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.router_id_map', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'router_id_map', 'keyval': 'ip_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'origin-ted'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, router_id_map=router_id_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, router_id_map=router_id_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_te_router_id_map_ospf_area_delete(self, router_id_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type router_id_map: ip_address
    :param router_id_map: Keyword argument tuple.

    :type ip_address: unicode
    :param ip_address: **router_id_map** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.router_id_map', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'router_id_map', 'keyval': 'ip_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ospf-area'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, router_id_map=router_id_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, router_id_map=router_id_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_te_router_id_map_resolved_delete(self, router_id_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type router_id_map: ip_address
    :param router_id_map: Keyword argument tuple.

    :type ip_address: unicode
    :param ip_address: **router_id_map** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.router_id_map', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'router_id_map', 'keyval': 'ip_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'resolved'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, router_id_map=router_id_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, router_id_map=router_id_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_te_router_id_map_router_id_delete(self, router_id_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type router_id_map: ip_address
    :param router_id_map: Keyword argument tuple.

    :type ip_address: unicode
    :param ip_address: **router_id_map** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.te.router_id_map', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'router_id_map', 'keyval': 'ip_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'router-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, router_id_map=router_id_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, router_id_map=router_id_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_transit_traffic_statistics_delete(self, transit_traffic_statistics=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type transit_traffic_statistics: in_label
    :param transit_traffic_statistics: Keyword argument tuple.

    :type in_label: long
    :param in_label: **transit_traffic_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.transit_traffic_statistics', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'transit_traffic_statistics', 'keyval': 'in_label', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, transit_traffic_statistics=transit_traffic_statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, transit_traffic_statistics=transit_traffic_statistics)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_transit_traffic_statistics_protocol_delete(self, transit_traffic_statistics=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type transit_traffic_statistics: in_label
    :param transit_traffic_statistics: Keyword argument tuple.

    :type in_label: long
    :param in_label: **transit_traffic_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.transit_traffic_statistics', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'transit_traffic_statistics', 'keyval': 'in_label', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'protocol'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, transit_traffic_statistics=transit_traffic_statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, transit_traffic_statistics=transit_traffic_statistics)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_transit_traffic_statistics_statistics_delete(self, transit_traffic_statistics=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type transit_traffic_statistics: in_label
    :param transit_traffic_statistics: Keyword argument tuple.

    :type in_label: long
    :param in_label: **transit_traffic_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.transit_traffic_statistics', u'transit_traffic_statistics')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.transit_traffic_statistics.statistics', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'in_label', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, transit_traffic_statistics=transit_traffic_statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, transit_traffic_statistics=transit_traffic_statistics)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_transit_traffic_statistics_statistics_averaging_interval_seconds_delete(self, transit_traffic_statistics=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type transit_traffic_statistics: in_label
    :param transit_traffic_statistics: Keyword argument tuple.

    :type in_label: long
    :param in_label: **transit_traffic_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.transit_traffic_statistics', u'transit_traffic_statistics')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.transit_traffic_statistics.statistics', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'in_label', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'averaging-interval-seconds'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, transit_traffic_statistics=transit_traffic_statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, transit_traffic_statistics=transit_traffic_statistics)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_transit_traffic_statistics_statistics_bytes_per_second_delete(self, transit_traffic_statistics=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type transit_traffic_statistics: in_label
    :param transit_traffic_statistics: Keyword argument tuple.

    :type in_label: long
    :param in_label: **transit_traffic_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.transit_traffic_statistics', u'transit_traffic_statistics')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.transit_traffic_statistics.statistics', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'in_label', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bytes-per-second'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, transit_traffic_statistics=transit_traffic_statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, transit_traffic_statistics=transit_traffic_statistics)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_transit_traffic_statistics_statistics_number_of_bytes_delete(self, transit_traffic_statistics=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type transit_traffic_statistics: in_label
    :param transit_traffic_statistics: Keyword argument tuple.

    :type in_label: long
    :param in_label: **transit_traffic_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.transit_traffic_statistics', u'transit_traffic_statistics')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.transit_traffic_statistics.statistics', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'in_label', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'number-of-bytes'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, transit_traffic_statistics=transit_traffic_statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, transit_traffic_statistics=transit_traffic_statistics)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_transit_traffic_statistics_statistics_number_of_bytes_since_clear_delete(self, transit_traffic_statistics=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type transit_traffic_statistics: in_label
    :param transit_traffic_statistics: Keyword argument tuple.

    :type in_label: long
    :param in_label: **transit_traffic_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.transit_traffic_statistics', u'transit_traffic_statistics')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.transit_traffic_statistics.statistics', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'in_label', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'number-of-bytes-since-clear'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, transit_traffic_statistics=transit_traffic_statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, transit_traffic_statistics=transit_traffic_statistics)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_transit_traffic_statistics_statistics_number_of_packets_delete(self, transit_traffic_statistics=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type transit_traffic_statistics: in_label
    :param transit_traffic_statistics: Keyword argument tuple.

    :type in_label: long
    :param in_label: **transit_traffic_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.transit_traffic_statistics', u'transit_traffic_statistics')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.transit_traffic_statistics.statistics', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'in_label', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'number-of-packets'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, transit_traffic_statistics=transit_traffic_statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, transit_traffic_statistics=transit_traffic_statistics)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_transit_traffic_statistics_statistics_number_of_packets_since_clear_delete(self, transit_traffic_statistics=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type transit_traffic_statistics: in_label
    :param transit_traffic_statistics: Keyword argument tuple.

    :type in_label: long
    :param in_label: **transit_traffic_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.transit_traffic_statistics', u'transit_traffic_statistics')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.transit_traffic_statistics.statistics', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'in_label', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'number-of-packets-since-clear'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, transit_traffic_statistics=transit_traffic_statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, transit_traffic_statistics=transit_traffic_statistics)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_transit_traffic_statistics_statistics_packets_per_second_delete(self, transit_traffic_statistics=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type transit_traffic_statistics: in_label
    :param transit_traffic_statistics: Keyword argument tuple.

    :type in_label: long
    :param in_label: **transit_traffic_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.transit_traffic_statistics', u'transit_traffic_statistics')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.transit_traffic_statistics.statistics', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'in_label', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'packets-per-second'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, transit_traffic_statistics=transit_traffic_statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, transit_traffic_statistics=transit_traffic_statistics)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_transit_traffic_statistics_statistics_valid_delete(self, transit_traffic_statistics=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type transit_traffic_statistics: in_label
    :param transit_traffic_statistics: Keyword argument tuple.

    :type in_label: long
    :param in_label: **transit_traffic_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.transit_traffic_statistics', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'transit_traffic_statistics', 'keyval': 'in_label', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'statistics-valid'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, transit_traffic_statistics=transit_traffic_statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, transit_traffic_statistics=transit_traffic_statistics)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_tunnel_traffic_statistics_delete(self, tunnel_traffic_statistics=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type tunnel_traffic_statistics: index
    :param tunnel_traffic_statistics: Keyword argument tuple.

    :type index: long
    :param index: **tunnel_traffic_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.tunnel_traffic_statistics', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tunnel_traffic_statistics', 'keyval': 'index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tunnel_traffic_statistics=tunnel_traffic_statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tunnel_traffic_statistics=tunnel_traffic_statistics)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_tunnel_traffic_statistics_is_bypass_delete(self, tunnel_traffic_statistics=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type tunnel_traffic_statistics: index
    :param tunnel_traffic_statistics: Keyword argument tuple.

    :type index: long
    :param index: **tunnel_traffic_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.tunnel_traffic_statistics', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tunnel_traffic_statistics', 'keyval': 'index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'is-bypass'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tunnel_traffic_statistics=tunnel_traffic_statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tunnel_traffic_statistics=tunnel_traffic_statistics)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_tunnel_traffic_statistics_name_delete(self, tunnel_traffic_statistics=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type tunnel_traffic_statistics: index
    :param tunnel_traffic_statistics: Keyword argument tuple.

    :type index: long
    :param index: **tunnel_traffic_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.tunnel_traffic_statistics', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tunnel_traffic_statistics', 'keyval': 'index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tunnel_traffic_statistics=tunnel_traffic_statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tunnel_traffic_statistics=tunnel_traffic_statistics)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_tunnel_traffic_statistics_protocol_delete(self, tunnel_traffic_statistics=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type tunnel_traffic_statistics: index
    :param tunnel_traffic_statistics: Keyword argument tuple.

    :type index: long
    :param index: **tunnel_traffic_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.tunnel_traffic_statistics', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tunnel_traffic_statistics', 'keyval': 'index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'protocol'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tunnel_traffic_statistics=tunnel_traffic_statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tunnel_traffic_statistics=tunnel_traffic_statistics)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_tunnel_traffic_statistics_statistics_delete(self, tunnel_traffic_statistics=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tunnel_traffic_statistics: index
    :param tunnel_traffic_statistics: Keyword argument tuple.

    :type index: long
    :param index: **tunnel_traffic_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.tunnel_traffic_statistics', u'tunnel_traffic_statistics')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.tunnel_traffic_statistics.statistics', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tunnel_traffic_statistics=tunnel_traffic_statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tunnel_traffic_statistics=tunnel_traffic_statistics)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_tunnel_traffic_statistics_statistics_averaging_interval_seconds_delete(self, tunnel_traffic_statistics=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tunnel_traffic_statistics: index
    :param tunnel_traffic_statistics: Keyword argument tuple.

    :type index: long
    :param index: **tunnel_traffic_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.tunnel_traffic_statistics', u'tunnel_traffic_statistics')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.tunnel_traffic_statistics.statistics', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'averaging-interval-seconds'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tunnel_traffic_statistics=tunnel_traffic_statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tunnel_traffic_statistics=tunnel_traffic_statistics)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_tunnel_traffic_statistics_statistics_bytes_per_second_delete(self, tunnel_traffic_statistics=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tunnel_traffic_statistics: index
    :param tunnel_traffic_statistics: Keyword argument tuple.

    :type index: long
    :param index: **tunnel_traffic_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.tunnel_traffic_statistics', u'tunnel_traffic_statistics')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.tunnel_traffic_statistics.statistics', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bytes-per-second'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tunnel_traffic_statistics=tunnel_traffic_statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tunnel_traffic_statistics=tunnel_traffic_statistics)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_tunnel_traffic_statistics_statistics_number_of_bytes_delete(self, tunnel_traffic_statistics=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tunnel_traffic_statistics: index
    :param tunnel_traffic_statistics: Keyword argument tuple.

    :type index: long
    :param index: **tunnel_traffic_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.tunnel_traffic_statistics', u'tunnel_traffic_statistics')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.tunnel_traffic_statistics.statistics', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'number-of-bytes'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tunnel_traffic_statistics=tunnel_traffic_statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tunnel_traffic_statistics=tunnel_traffic_statistics)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_tunnel_traffic_statistics_statistics_number_of_bytes_since_clear_delete(self, tunnel_traffic_statistics=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tunnel_traffic_statistics: index
    :param tunnel_traffic_statistics: Keyword argument tuple.

    :type index: long
    :param index: **tunnel_traffic_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.tunnel_traffic_statistics', u'tunnel_traffic_statistics')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.tunnel_traffic_statistics.statistics', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'number-of-bytes-since-clear'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tunnel_traffic_statistics=tunnel_traffic_statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tunnel_traffic_statistics=tunnel_traffic_statistics)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_tunnel_traffic_statistics_statistics_number_of_packets_delete(self, tunnel_traffic_statistics=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tunnel_traffic_statistics: index
    :param tunnel_traffic_statistics: Keyword argument tuple.

    :type index: long
    :param index: **tunnel_traffic_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.tunnel_traffic_statistics', u'tunnel_traffic_statistics')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.tunnel_traffic_statistics.statistics', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'number-of-packets'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tunnel_traffic_statistics=tunnel_traffic_statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tunnel_traffic_statistics=tunnel_traffic_statistics)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_tunnel_traffic_statistics_statistics_number_of_packets_since_clear_delete(self, tunnel_traffic_statistics=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tunnel_traffic_statistics: index
    :param tunnel_traffic_statistics: Keyword argument tuple.

    :type index: long
    :param index: **tunnel_traffic_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.tunnel_traffic_statistics', u'tunnel_traffic_statistics')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.tunnel_traffic_statistics.statistics', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'number-of-packets-since-clear'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tunnel_traffic_statistics=tunnel_traffic_statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tunnel_traffic_statistics=tunnel_traffic_statistics)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_tunnel_traffic_statistics_statistics_packets_per_second_delete(self, tunnel_traffic_statistics=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tunnel_traffic_statistics: index
    :param tunnel_traffic_statistics: Keyword argument tuple.

    :type index: long
    :param index: **tunnel_traffic_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_state.tunnel_traffic_statistics', u'tunnel_traffic_statistics')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.tunnel_traffic_statistics.statistics', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'packets-per-second'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tunnel_traffic_statistics=tunnel_traffic_statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tunnel_traffic_statistics=tunnel_traffic_statistics)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mpls_state_tunnel_traffic_statistics_statistics_valid_delete(self, tunnel_traffic_statistics=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type tunnel_traffic_statistics: index
    :param tunnel_traffic_statistics: Keyword argument tuple.

    :type index: long
    :param index: **tunnel_traffic_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_state.tunnel_traffic_statistics', 'pybind.slxos.v16r_1_00b.brocade_mpls_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tunnel_traffic_statistics', 'keyval': 'index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'statistics-valid'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tunnel_traffic_statistics=tunnel_traffic_statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tunnel_traffic_statistics=tunnel_traffic_statistics)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def mtu_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_0_1b.global_mtu_conf', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.global_mtu_conf', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mtu'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def nas_auto_qos_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.nas.auto_qos', 'pybind.nos.v6_0_2c.brocade_qos', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.nas.auto_qos', 'pybind.nos.v7_0_1b.brocade_qos', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.nas.auto_qos', 'pybind.nos.v7_1_0.brocade_qos', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.nas.auto_qos', 'pybind.slxos.v16r_1_00b.brocade_qos_cee', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def nas_auto_qos_set_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.nas.auto_qos.set_', 'pybind.nos.v6_0_2c.brocade_qos', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.nas.auto_qos.set_', 'pybind.nos.v7_0_1b.brocade_qos', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.nas.auto_qos.set_', 'pybind.nos.v7_1_0.brocade_qos', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.nas.auto_qos.set_', 'pybind.slxos.v16r_1_00b.brocade_qos_cee', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def nas_auto_qos_set_cos_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.nas.auto_qos.set_', 'pybind.nos.v6_0_2c.brocade_qos', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.nas.auto_qos.set_', 'pybind.nos.v7_0_1b.brocade_qos', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.nas.auto_qos.set_', 'pybind.nos.v7_1_0.brocade_qos', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.nas.auto_qos.set_', 'pybind.slxos.v16r_1_00b.brocade_qos_cee', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cos'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def nas_auto_qos_set_dscp_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.nas.auto_qos.set_', 'pybind.nos.v6_0_2c.brocade_qos', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.nas.auto_qos.set_', 'pybind.nos.v7_0_1b.brocade_qos', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.nas.auto_qos.set_', 'pybind.nos.v7_1_0.brocade_qos', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.nas.auto_qos.set_', 'pybind.slxos.v16r_1_00b.brocade_qos_cee', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dscp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def nas_server_ip_delete(self, server_ip=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type server_ip: server_ip
    :param server_ip: Keyword argument tuple.

    :type server_ip: unicode
    :param server_ip: **server_ip** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.nas.server_ip', 'pybind.nos.v6_0_2c.brocade_qos', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.nas.server_ip', 'pybind.nos.v7_0_1b.brocade_qos', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.nas.server_ip', 'pybind.nos.v7_1_0.brocade_qos', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.nas.server_ip', 'pybind.slxos.v16r_1_00b.brocade_qos_cee', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'server_ip', 'keyval': 'server_ip', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, server_ip=server_ip)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, server_ip=server_ip)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def nas_server_ip_vlan_delete(self, server_ip=None, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type server_ip: server_ip
    :param server_ip: Keyword argument tuple.

    :type server_ip: unicode
    :param server_ip: **server_ip** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    **Instance Keyword Argument Tuple**:

    :type vlan: vlan_number
    :param vlan: Keyword argument tuple.

    :type vlan_number: long
    :param vlan_number: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.nas.server_ip', u'server_ip'), ('pybind.nos.v7_0_1b.nas.server_ip', u'server_ip'), ('pybind.nos.v6_0_2c.nas.server_ip', u'server_ip'), ('pybind.nos.v7_1_0.nas.server_ip', u'server_ip')]
    bindings_list = [('pybind.nos.v6_0_2c.nas.server_ip.vlan', 'pybind.nos.v6_0_2c.brocade_qos', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.nas.server_ip.vlan', 'pybind.nos.v7_0_1b.brocade_qos', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.nas.server_ip.vlan', 'pybind.nos.v7_1_0.brocade_qos', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.nas.server_ip.vlan', 'pybind.slxos.v16r_1_00b.brocade_qos_cee', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'server_ip', 'extra_keyval': ''}, {'keyval': 'server_ip', 'extra_keyval': ''}, {'keyval': 'server_ip', 'extra_keyval': ''}, {'keyval': 'server_ip', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'vlan_number', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, server_ip=server_ip, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, server_ip=server_ip, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def nas_server_ip_vrf_delete(self, server_ip=None, vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type server_ip: server_ip
    :param server_ip: Keyword argument tuple.

    :type server_ip: unicode
    :param server_ip: **server_ip** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    **Instance Keyword Argument Tuple**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument.

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.nas.server_ip', u'server_ip'), ('pybind.nos.v7_1_0.nas.server_ip', u'server_ip'), ('pybind.nos.v7_0_1b.nas.server_ip', u'server_ip'), ('pybind.nos.v6_0_2c.nas.server_ip', u'server_ip')]
    bindings_list = [('pybind.nos.v6_0_2c.nas.server_ip.vrf', 'pybind.nos.v6_0_2c.brocade_qos', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.nas.server_ip.vrf', 'pybind.nos.v7_0_1b.brocade_qos', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.nas.server_ip.vrf', 'pybind.nos.v7_1_0.brocade_qos', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.nas.server_ip.vrf', 'pybind.slxos.v16r_1_00b.brocade_qos_cee', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'server_ip', 'extra_keyval': ''}, {'keyval': 'server_ip', 'extra_keyval': ''}, {'keyval': 'server_ip', 'extra_keyval': ''}, {'keyval': 'server_ip', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrf', 'keyval': 'vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, server_ip=server_ip, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, server_ip=server_ip, vrf=vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def no_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.no', 'pybind.nos.v6_0_2c.brocade_common_def', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.no', 'pybind.nos.v7_0_1b.brocade_common_def', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.no', 'pybind.nos.v7_1_0.brocade_common_def', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.no', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def no_crypto_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.no.nocrypto', 'pybind.nos.v6_0_2c.brocade_common_def', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.no.nocrypto', 'pybind.nos.v7_0_1b.brocade_common_def', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.no.nocrypto', 'pybind.nos.v7_1_0.brocade_common_def', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.no.nocrypto', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def no_fcsp_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.no.fcsp', 'pybind.nos.v6_0_2c.brocade_common_def', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.no.fcsp', 'pybind.nos.v7_0_1b.brocade_common_def', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.no.fcsp', 'pybind.nos.v7_1_0.brocade_common_def', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.no.fcsp', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def nsx_controller_delete(self, nsx_controller=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type nsx_controller: name
    :param nsx_controller: Keyword argument tuple.

    :type name: unicode
    :param name: **nsx_controller** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.nsx_controller', 'pybind.nos.v6_0_2c.brocade_tunnels', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.nsx_controller', 'pybind.nos.v7_0_1b.brocade_tunnels', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.nsx_controller', 'pybind.nos.v7_1_0.brocade_tunnels', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.nsx_controller', 'pybind.slxos.v16r_1_00b.brocade_tunnels', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'nsx_controller', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, nsx_controller=nsx_controller)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, nsx_controller=nsx_controller)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def nsx_controller_activate_delete(self, nsx_controller=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type nsx_controller: name
    :param nsx_controller: Keyword argument tuple.

    :type name: unicode
    :param name: **nsx_controller** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.nsx_controller', 'pybind.nos.v6_0_2c.brocade_tunnels', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.nsx_controller', 'pybind.nos.v7_0_1b.brocade_tunnels', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.nsx_controller', 'pybind.nos.v7_1_0.brocade_tunnels', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.nsx_controller', 'pybind.slxos.v16r_1_00b.brocade_tunnels', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'nsx_controller', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'activate'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, nsx_controller=nsx_controller)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, nsx_controller=nsx_controller)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def nsx_controller_ip_address_delete(self, nsx_controller=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type nsx_controller: name
    :param nsx_controller: Keyword argument tuple.

    :type name: unicode
    :param name: **nsx_controller** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.nsx_controller', 'nsx_controller'), ('pybind.nos.v7_1_0.nsx_controller', 'nsx_controller'), ('pybind.nos.v7_0_1b.nsx_controller', 'nsx_controller'), ('pybind.slxos.v16r_1_00b.nsx_controller', 'nsx_controller')]
    bindings_list = [('pybind.nos.v6_0_2c.nsx_controller.connection_addr', 'pybind.nos.v6_0_2c.brocade_tunnels', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.nsx_controller.connection_addr', 'pybind.nos.v7_0_1b.brocade_tunnels', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.nsx_controller.connection_addr', 'pybind.nos.v7_1_0.brocade_tunnels', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.nsx_controller.connection_addr', 'pybind.slxos.v16r_1_00b.brocade_tunnels', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'address'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, nsx_controller=nsx_controller)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, nsx_controller=nsx_controller)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def nsx_controller_ip_method_delete(self, nsx_controller=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type nsx_controller: name
    :param nsx_controller: Keyword argument tuple.

    :type name: unicode
    :param name: **nsx_controller** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.nsx_controller', 'nsx_controller'), ('pybind.nos.v7_1_0.nsx_controller', 'nsx_controller'), ('pybind.nos.v7_0_1b.nsx_controller', 'nsx_controller'), ('pybind.slxos.v16r_1_00b.nsx_controller', 'nsx_controller')]
    bindings_list = [('pybind.nos.v6_0_2c.nsx_controller.connection_addr', 'pybind.nos.v6_0_2c.brocade_tunnels', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.nsx_controller.connection_addr', 'pybind.nos.v7_0_1b.brocade_tunnels', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.nsx_controller.connection_addr', 'pybind.nos.v7_1_0.brocade_tunnels', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.nsx_controller.connection_addr', 'pybind.slxos.v16r_1_00b.brocade_tunnels', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'method'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, nsx_controller=nsx_controller)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, nsx_controller=nsx_controller)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def nsx_controller_ip_port_delete(self, nsx_controller=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type nsx_controller: name
    :param nsx_controller: Keyword argument tuple.

    :type name: unicode
    :param name: **nsx_controller** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.nsx_controller', 'nsx_controller'), ('pybind.nos.v7_1_0.nsx_controller', 'nsx_controller'), ('pybind.nos.v7_0_1b.nsx_controller', 'nsx_controller'), ('pybind.slxos.v16r_1_00b.nsx_controller', 'nsx_controller')]
    bindings_list = [('pybind.nos.v6_0_2c.nsx_controller.connection_addr', 'pybind.nos.v6_0_2c.brocade_tunnels', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.nsx_controller.connection_addr', 'pybind.nos.v7_0_1b.brocade_tunnels', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.nsx_controller.connection_addr', 'pybind.nos.v7_1_0.brocade_tunnels', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.nsx_controller.connection_addr', 'pybind.slxos.v16r_1_00b.brocade_tunnels', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'port'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, nsx_controller=nsx_controller)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, nsx_controller=nsx_controller)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def nsx_controller_reconnect_interval_delete(self, nsx_controller=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type nsx_controller: name
    :param nsx_controller: Keyword argument tuple.

    :type name: unicode
    :param name: **nsx_controller** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.nsx_controller', 'pybind.nos.v6_0_2c.brocade_tunnels', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.nsx_controller', 'pybind.nos.v7_0_1b.brocade_tunnels', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.nsx_controller', 'pybind.nos.v7_1_0.brocade_tunnels', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.nsx_controller', 'pybind.slxos.v16r_1_00b.brocade_tunnels', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'nsx_controller', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'reconnect-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, nsx_controller=nsx_controller)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, nsx_controller=nsx_controller)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ntp_authentication_key_delete(self, authentication_key=None, md5=None, sha1=None, encryption_level=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type authentication_key: keyid, md5, sha1, encryption_level
    :param authentication_key: Keyword argument tuple.

    :type keyid: long
    :param keyid: **authentication_key** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type md5: unicode
    :param md5: **authentication_key** tuple argument:  MD5 Encryption

        * length restriction: ::

            ['1 .. max']

    :type sha1: unicode
    :param sha1: **authentication_key** tuple argument:  SHA1 Encryption

        * length restriction: ::

            ['1 .. max']

    :type encryption_level: unicode
    :param encryption_level: **authentication_key** tuple argument:  Level of encryption of the md5 key (default=7)

        * enumeration restriction: ::

            ['0', '7']

    **Instance Argument(s)**:

    :type md5: unicode
    :param md5: MD5 Encryption. Choice keyword argument (Only one choice argument allowed per API invocation).

        * length restriction: ::

            ['1 .. max']

    :type sha1: unicode
    :param sha1: SHA1 Encryption. Choice keyword argument (Only one choice argument allowed per API invocation).

        * length restriction: ::

            ['1 .. max']

    :type encryption_level: unicode
    :param encryption_level: Level of encryption of the md5 key (default=7)

        * enumeration restriction: ::

            ['0', '7']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.ntp.authentication_key', 'pybind.nos.v6_0_2c.brocade_ntp', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ntp.authentication_key', 'pybind.nos.v7_0_1b.brocade_ntp', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ntp.authentication_key', 'pybind.nos.v7_1_0.brocade_ntp', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ntp.authentication_key', 'pybind.slxos.v16r_1_00b.brocade_ntp', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'authentication_key', 'keyval': 'keyid', 'extra_keyval': 'keyid, md5, sha1, encryption_level'}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v6_0_2c.ntp.authentication_key": {"encryption_level": "encryption_level", "sha1": "sha1", "keyid": "keyid", "md5": "md5"}, "pybind.nos.v7_0_1b.ntp.authentication_key": {"encryption_level": "encryption_level", "sha1": "sha1", "keyid": "keyid", "md5": "md5"}, "pybind.slxos.v16r_1_00b.ntp.authentication_key": {}, "pybind.nos.v7_1_0.ntp.authentication_key": {"encryption_level": "encryption_level", "sha1": "sha1", "keyid": "keyid", "md5": "md5"}}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v6_0_2c.ntp.authentication_key': [u'md5', u'sha1'], 'pybind.nos.v7_0_1b.ntp.authentication_key': [u'md5', u'sha1'], 'pybind.nos.v7_1_0.ntp.authentication_key': [u'md5', u'sha1']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, authentication_key=authentication_key, md5=md5, sha1=sha1, encryption_level=encryption_level)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, authentication_key=authentication_key, md5=md5, sha1=sha1, encryption_level=encryption_level)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ntp_authentication_key_encryption_level_delete(self, authentication_key=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Instance Keyword Argument Tuple**:

    :type authentication_key: keyid
    :param authentication_key: Keyword argument tuple.

    :type keyid: long
    :param keyid: **authentication_key** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.ntp.authentication_key', 'pybind.nos.v6_0_2c.brocade_ntp', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ntp.authentication_key', 'pybind.nos.v7_0_1b.brocade_ntp', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ntp.authentication_key', 'pybind.nos.v7_1_0.brocade_ntp', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'authentication_key', 'keyval': 'keyid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'encryption-level'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, authentication_key=authentication_key)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, authentication_key=authentication_key)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ntp_authentication_key_md5_delete(self, authentication_key=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type authentication_key: keyid
    :param authentication_key: Keyword argument tuple.

    :type keyid: long
    :param keyid: **authentication_key** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.ntp.authentication_key', 'pybind.nos.v6_0_2c.brocade_ntp', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ntp.authentication_key', 'pybind.nos.v7_0_1b.brocade_ntp', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ntp.authentication_key', 'pybind.nos.v7_1_0.brocade_ntp', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ntp.authentication_key', 'pybind.slxos.v16r_1_00b.brocade_ntp', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'authentication_key', 'keyval': 'keyid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'md5'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, authentication_key=authentication_key)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, authentication_key=authentication_key)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ntp_authentication_key_sha1_delete(self, authentication_key=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Instance Keyword Argument Tuple**:

    :type authentication_key: keyid
    :param authentication_key: Keyword argument tuple.

    :type keyid: long
    :param keyid: **authentication_key** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.ntp.authentication_key', 'pybind.nos.v6_0_2c.brocade_ntp', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ntp.authentication_key', 'pybind.nos.v7_0_1b.brocade_ntp', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ntp.authentication_key', 'pybind.nos.v7_1_0.brocade_ntp', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'authentication_key', 'keyval': 'keyid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'sha1'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, authentication_key=authentication_key)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, authentication_key=authentication_key)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ntp_server_delete(self, server=None, key=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type server: ip
    :param server: Keyword argument tuple.

    :type ip: unicode
    :param ip: **server** tuple argument:  Network Time Protocol server ip address(es)

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Argument(s)**:

    :type key: long
    :param key: authentication key

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.ntp.server', 'pybind.nos.v6_0_2c.brocade_ntp', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ntp.server', 'pybind.nos.v7_0_1b.brocade_ntp', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ntp.server', 'pybind.nos.v7_1_0.brocade_ntp', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ntp.server', 'pybind.slxos.v16r_1_00b.brocade_ntp', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'server', 'keyval': 'ip, use_vrf', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v16r_1_00b.ntp.server": {"ip": "ip"}, "pybind.nos.v6_0_2c.ntp.server": {"ip": "ip", "key": "key"}, "pybind.nos.v7_1_0.ntp.server": {}, "pybind.nos.v7_0_1b.ntp.server": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, server=server, key=key)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, server=server, key=key)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ntp_server_key_delete(self, server=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type server: ip
    :param server: Keyword argument tuple.

    :type ip: unicode
    :param ip: **server** tuple argument:  Network Time Protocol server ip address(es)

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.ntp.server', u'server')]
    bindings_list = [('pybind.nos.v6_0_2c.ntp.server', 'pybind.nos.v6_0_2c.brocade_ntp', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ntp.server', 'pybind.nos.v7_0_1b.brocade_ntp', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ntp.server', 'pybind.nos.v7_1_0.brocade_ntp', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ntp.server.server_key', 'pybind.slxos.v16r_1_00b.brocade_ntp', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ip, use_vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'server', 'keyval': 'ip, use_vrf', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v16r_1_00b.ntp.server.server_key": {}, "pybind.nos.v6_0_2c.ntp.server": {"ip": "ip", "key": "key"}, "pybind.nos.v7_1_0.ntp.server": {}, "pybind.nos.v7_0_1b.ntp.server": {}}
    rest_leaf_name = 'key'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, server=server)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, server=server)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ntp_source_ip_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.ntp', 'pybind.nos.v6_0_2c.brocade_ntp', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ntp', 'pybind.nos.v7_0_1b.brocade_ntp', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ntp', 'pybind.nos.v7_1_0.brocade_ntp', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ntp', 'pybind.slxos.v16r_1_00b.brocade_ntp', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'source-ip'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_global.openflow', 'pybind.slxos.v16r_1_00b.brocade_openflow', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_controller_delete(self, openflow_controller=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type openflow_controller: controller_name
    :param openflow_controller: Keyword argument tuple.

    :type controller_name: unicode
    :param controller_name: **openflow_controller** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.openflow_controller', 'pybind.nos.v6_0_2c.brocade_openflow', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.openflow_controller', 'pybind.nos.v7_0_1b.brocade_openflow', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.openflow_controller', 'pybind.nos.v7_1_0.brocade_openflow', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.openflow_global.openflow.controller', 'pybind.slxos.v16r_1_00b.brocade_openflow', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'openflow_controller', 'keyval': 'controller_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, openflow_controller=openflow_controller)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, openflow_controller=openflow_controller)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_controller_connection_method_delete(self, controller=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type controller: controller_name
    :param controller: Keyword argument tuple.

    :type controller_name: unicode
    :param controller_name: **controller** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.openflow_global.openflow.controller', u'controller')]
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_global.openflow.controller.active_controller', 'pybind.slxos.v16r_1_00b.brocade_openflow', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'controller_name', 'extra_keyval': 'controller_name'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'connection-method'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, controller=controller)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, controller=controller)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_controller_ip_address_delete(self, openflow_controller=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type openflow_controller: controller_name
    :param openflow_controller: Keyword argument tuple.

    :type controller_name: unicode
    :param controller_name: **openflow_controller** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.openflow_controller', 'openflow_controller'), ('pybind.slxos.v16r_1_00b.openflow_global.openflow.controller', u'controller'), ('pybind.nos.v7_0_1b.openflow_controller', 'openflow_controller'), ('pybind.nos.v6_0_2c.openflow_controller', 'openflow_controller')]
    bindings_list = [('pybind.nos.v6_0_2c.openflow_controller.connection_address', 'pybind.nos.v6_0_2c.brocade_openflow', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.openflow_controller.connection_address', 'pybind.nos.v7_0_1b.brocade_openflow', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.openflow_controller.connection_address', 'pybind.nos.v7_1_0.brocade_openflow', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.openflow_global.openflow.controller.active_controller', 'pybind.slxos.v16r_1_00b.brocade_openflow', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'controller_name', 'extra_keyval': ''}, {'keyval': 'controller_name', 'extra_keyval': 'controller_name'}, {'keyval': 'controller_name', 'extra_keyval': ''}, {'keyval': 'controller_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'address'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, openflow_controller=openflow_controller)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, openflow_controller=openflow_controller)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_controller_ip_method_delete(self, openflow_controller=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type openflow_controller: controller_name
    :param openflow_controller: Keyword argument tuple.

    :type controller_name: unicode
    :param controller_name: **openflow_controller** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.openflow_controller', 'openflow_controller'), ('pybind.nos.v6_0_2c.openflow_controller', 'openflow_controller'), ('pybind.nos.v7_1_0.openflow_controller', 'openflow_controller')]
    bindings_list = [('pybind.nos.v6_0_2c.openflow_controller.connection_address', 'pybind.nos.v6_0_2c.brocade_openflow', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.openflow_controller.connection_address', 'pybind.nos.v7_0_1b.brocade_openflow', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.openflow_controller.connection_address', 'pybind.nos.v7_1_0.brocade_openflow', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'controller_name', 'extra_keyval': ''}, {'keyval': 'controller_name', 'extra_keyval': ''}, {'keyval': 'controller_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'method'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, openflow_controller=openflow_controller)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, openflow_controller=openflow_controller)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_controller_ip_port_delete(self, openflow_controller=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type openflow_controller: controller_name
    :param openflow_controller: Keyword argument tuple.

    :type controller_name: unicode
    :param controller_name: **openflow_controller** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.openflow_controller', 'openflow_controller'), ('pybind.nos.v6_0_2c.openflow_controller', 'openflow_controller'), ('pybind.nos.v7_1_0.openflow_controller', 'openflow_controller')]
    bindings_list = [('pybind.nos.v6_0_2c.openflow_controller.connection_address', 'pybind.nos.v6_0_2c.brocade_openflow', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.openflow_controller.connection_address', 'pybind.nos.v7_0_1b.brocade_openflow', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.openflow_controller.connection_address', 'pybind.nos.v7_1_0.brocade_openflow', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'controller_name', 'extra_keyval': ''}, {'keyval': 'controller_name', 'extra_keyval': ''}, {'keyval': 'controller_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'port'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, openflow_controller=openflow_controller)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, openflow_controller=openflow_controller)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_controller_ip_use_vrf_delete(self, openflow_controller=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type openflow_controller: controller_name
    :param openflow_controller: Keyword argument tuple.

    :type controller_name: unicode
    :param controller_name: **openflow_controller** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.openflow_controller', 'openflow_controller'), ('pybind.nos.v7_1_0.openflow_controller', 'openflow_controller')]
    bindings_list = [('pybind.nos.v7_0_1b.openflow_controller.connection_address', 'pybind.nos.v7_0_1b.brocade_openflow', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.openflow_controller.connection_address', 'pybind.nos.v7_1_0.brocade_openflow', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'controller_name', 'extra_keyval': ''}, {'keyval': 'controller_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'use-vrf'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, openflow_controller=openflow_controller)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, openflow_controller=openflow_controller)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_controller_passive_delete(self, controller=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type controller: controller_name
    :param controller: Keyword argument tuple.

    :type controller_name: unicode
    :param controller_name: **controller** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.openflow_global.openflow.controller', u'controller')]
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_global.openflow.controller.passive', 'pybind.slxos.v16r_1_00b.brocade_openflow', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'controller_name', 'extra_keyval': 'controller_name'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'passive_connection_method, passive_controller_address, passive_connection_port, passive_controller_vrf'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, controller=controller)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, controller=controller)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_controller_passive_ip_address_delete(self, controller=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type controller: controller_name
    :param controller: Keyword argument tuple.

    :type controller_name: unicode
    :param controller_name: **controller** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.openflow_global.openflow.controller', u'controller')]
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_global.openflow.controller.passive', 'pybind.slxos.v16r_1_00b.brocade_openflow', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'controller_name', 'extra_keyval': 'controller_name'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ip-address'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, controller=controller)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, controller=controller)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_controller_passive_passive_connection_method_delete(self, controller=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type controller: controller_name
    :param controller: Keyword argument tuple.

    :type controller_name: unicode
    :param controller_name: **controller** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.openflow_global.openflow.controller', u'controller')]
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_global.openflow.controller.passive', 'pybind.slxos.v16r_1_00b.brocade_openflow', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'controller_name', 'extra_keyval': 'controller_name'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'passive-connection-method'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, controller=controller)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, controller=controller)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_controller_passive_port_delete(self, controller=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type controller: controller_name
    :param controller: Keyword argument tuple.

    :type controller_name: unicode
    :param controller_name: **controller** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.openflow_global.openflow.controller', u'controller')]
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_global.openflow.controller.passive', 'pybind.slxos.v16r_1_00b.brocade_openflow', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'controller_name', 'extra_keyval': 'controller_name'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'port'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, controller=controller)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, controller=controller)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_controller_passive_use_vrf_delete(self, controller=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type controller: controller_name
    :param controller: Keyword argument tuple.

    :type controller_name: unicode
    :param controller_name: **controller** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.openflow_global.openflow.controller', u'controller')]
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_global.openflow.controller.passive', 'pybind.slxos.v16r_1_00b.brocade_openflow', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'controller_name', 'extra_keyval': 'controller_name'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'use-vrf'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, controller=controller)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, controller=controller)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_controller_port_delete(self, controller=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type controller: controller_name
    :param controller: Keyword argument tuple.

    :type controller_name: unicode
    :param controller_name: **controller** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.openflow_global.openflow.controller', u'controller')]
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_global.openflow.controller.active_controller', 'pybind.slxos.v16r_1_00b.brocade_openflow', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'controller_name', 'extra_keyval': 'controller_name'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'port'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, controller=controller)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, controller=controller)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_controller_use_vrf_delete(self, controller=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type controller: controller_name
    :param controller: Keyword argument tuple.

    :type controller_name: unicode
    :param controller_name: **controller** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.openflow_global.openflow.controller', u'controller')]
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_global.openflow.controller.active_controller', 'pybind.slxos.v16r_1_00b.brocade_openflow', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'controller_name', 'extra_keyval': 'controller_name'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'use-vrf'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, controller=controller)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, controller=controller)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_default_behavior_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_global.openflow.default_behavior', 'pybind.slxos.v16r_1_00b.brocade_openflow', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_default_behavior_send_to_controller_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_global.openflow.default_behavior', 'pybind.slxos.v16r_1_00b.brocade_openflow', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'send-to-controller'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_enable_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_global.openflow.enable', 'pybind.slxos.v16r_1_00b.brocade_openflow', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_enable_ofvertype_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_global.openflow.enable', 'pybind.slxos.v16r_1_00b.brocade_openflow', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ofVerType'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_global_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_global', 'pybind.slxos.v16r_1_00b.brocade_openflow', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_controller_delete(self, controller=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type controller: name
    :param controller: Keyword argument tuple.

    :type name: unicode
    :param name: **controller** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.controller', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'controller', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, controller=controller)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, controller=controller)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_controller_connection_type_delete(self, controller=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type controller: name
    :param controller: Keyword argument tuple.

    :type name: unicode
    :param name: **controller** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.controller', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'controller', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'connection-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, controller=controller)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, controller=controller)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_controller_ip_addr_delete(self, controller=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type controller: name
    :param controller: Keyword argument tuple.

    :type name: unicode
    :param name: **controller** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.controller', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'controller', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ip-addr'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, controller=controller)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, controller=controller)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_controller_mode_delete(self, controller=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type controller: name
    :param controller: Keyword argument tuple.

    :type name: unicode
    :param name: **controller** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.controller', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'controller', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mode'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, controller=controller)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, controller=controller)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_controller_port_delete(self, controller=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type controller: name
    :param controller: Keyword argument tuple.

    :type name: unicode
    :param name: **controller** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.controller', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'controller', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'port'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, controller=controller)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, controller=controller)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_controller_role_delete(self, controller=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type controller: name
    :param controller: Keyword argument tuple.

    :type name: unicode
    :param name: **controller** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.controller', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'controller', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'role'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, controller=controller)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, controller=controller)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_controller_status_delete(self, controller=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type controller: name
    :param controller: Keyword argument tuple.

    :type name: unicode
    :param name: **controller** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.controller', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'controller', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, controller=controller)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, controller=controller)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_controller_type_delete(self, controller=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type controller: name
    :param controller: Keyword argument tuple.

    :type name: unicode
    :param name: **controller** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.controller', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'controller', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, controller=controller)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, controller=controller)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_controller_vrf_name_delete(self, controller=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type controller: name
    :param controller: Keyword argument tuple.

    :type name: unicode
    :param name: **controller** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.controller', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'controller', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vrf-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, controller=controller)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, controller=controller)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_detail_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.detail', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_detail_active_flows_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.detail', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'active-flows'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_detail_admin_status_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.detail', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'admin-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_detail_controller_detail_list_delete(self, controller_detail_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type controller_detail_list: controller_idx
    :param controller_detail_list: Keyword argument tuple.

    :type controller_idx: long
    :param controller_idx: **controller_detail_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.detail.controller_detail_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'controller_detail_list', 'keyval': 'controller_idx', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, controller_detail_list=controller_detail_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, controller_detail_list=controller_detail_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_detail_controller_detail_list_controller_async_list_delete(self, controller_detail_list=None, controller_async_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type controller_detail_list: controller_idx
    :param controller_detail_list: Keyword argument tuple.

    :type controller_idx: long
    :param controller_idx: **controller_detail_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type controller_async_list: async_type
    :param controller_async_list: Keyword argument tuple.

    :type async_type: unicode
    :param async_type: **controller_async_list** tuple argument.

        * enumeration restriction: ::

            ['dcm-async-invalid',
            'dcm-packet-in',
            'dcm-port-status',
            'dcm-flow-removed']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.openflow_state.detail.controller_detail_list', u'controller_detail_list')]
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.detail.controller_detail_list.controller_async_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'controller_idx', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'controller_async_list', 'keyval': 'async_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, controller_detail_list=controller_detail_list, controller_async_list=controller_async_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, controller_detail_list=controller_detail_list, controller_async_list=controller_async_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_detail_controller_detail_list_controller_async_list_config_data_delete(self, controller_detail_list=None, controller_async_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type controller_detail_list: controller_idx
    :param controller_detail_list: Keyword argument tuple.

    :type controller_idx: long
    :param controller_idx: **controller_detail_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type controller_async_list: async_type
    :param controller_async_list: Keyword argument tuple.

    :type async_type: unicode
    :param async_type: **controller_async_list** tuple argument.

        * enumeration restriction: ::

            ['dcm-async-invalid',
            'dcm-packet-in',
            'dcm-port-status',
            'dcm-flow-removed']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.openflow_state.detail.controller_detail_list', u'controller_detail_list')]
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.detail.controller_detail_list.controller_async_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'controller_idx', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'controller_async_list', 'keyval': 'async_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'config-data'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, controller_detail_list=controller_detail_list, controller_async_list=controller_async_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, controller_detail_list=controller_detail_list, controller_async_list=controller_async_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_detail_controller_detail_list_controller_info_delete(self, controller_detail_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type controller_detail_list: controller_idx
    :param controller_detail_list: Keyword argument tuple.

    :type controller_idx: long
    :param controller_idx: **controller_detail_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.openflow_state.detail.controller_detail_list', u'controller_detail_list')]
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.detail.controller_detail_list.controller_info', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'controller_idx', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, controller_detail_list=controller_detail_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, controller_detail_list=controller_detail_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_detail_controller_detail_list_controller_info_connection_type_delete(self, controller_detail_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type controller_detail_list: controller_idx
    :param controller_detail_list: Keyword argument tuple.

    :type controller_idx: long
    :param controller_idx: **controller_detail_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.openflow_state.detail.controller_detail_list', u'controller_detail_list')]
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.detail.controller_detail_list.controller_info', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'controller_idx', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'connection-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, controller_detail_list=controller_detail_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, controller_detail_list=controller_detail_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_detail_controller_detail_list_controller_info_ip_addr_delete(self, controller_detail_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type controller_detail_list: controller_idx
    :param controller_detail_list: Keyword argument tuple.

    :type controller_idx: long
    :param controller_idx: **controller_detail_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.openflow_state.detail.controller_detail_list', u'controller_detail_list')]
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.detail.controller_detail_list.controller_info', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'controller_idx', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ip-addr'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, controller_detail_list=controller_detail_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, controller_detail_list=controller_detail_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_detail_controller_detail_list_controller_info_mode_delete(self, controller_detail_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type controller_detail_list: controller_idx
    :param controller_detail_list: Keyword argument tuple.

    :type controller_idx: long
    :param controller_idx: **controller_detail_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.openflow_state.detail.controller_detail_list', u'controller_detail_list')]
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.detail.controller_detail_list.controller_info', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'controller_idx', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mode'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, controller_detail_list=controller_detail_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, controller_detail_list=controller_detail_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_detail_controller_detail_list_controller_info_name_delete(self, controller_detail_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type controller_detail_list: controller_idx
    :param controller_detail_list: Keyword argument tuple.

    :type controller_idx: long
    :param controller_idx: **controller_detail_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.openflow_state.detail.controller_detail_list', u'controller_detail_list')]
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.detail.controller_detail_list.controller_info', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'controller_idx', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, controller_detail_list=controller_detail_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, controller_detail_list=controller_detail_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_detail_controller_detail_list_controller_info_port_delete(self, controller_detail_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type controller_detail_list: controller_idx
    :param controller_detail_list: Keyword argument tuple.

    :type controller_idx: long
    :param controller_idx: **controller_detail_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.openflow_state.detail.controller_detail_list', u'controller_detail_list')]
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.detail.controller_detail_list.controller_info', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'controller_idx', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'port'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, controller_detail_list=controller_detail_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, controller_detail_list=controller_detail_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_detail_controller_detail_list_controller_info_role_delete(self, controller_detail_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type controller_detail_list: controller_idx
    :param controller_detail_list: Keyword argument tuple.

    :type controller_idx: long
    :param controller_idx: **controller_detail_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.openflow_state.detail.controller_detail_list', u'controller_detail_list')]
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.detail.controller_detail_list.controller_info', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'controller_idx', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'role'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, controller_detail_list=controller_detail_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, controller_detail_list=controller_detail_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_detail_controller_detail_list_controller_info_status_delete(self, controller_detail_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type controller_detail_list: controller_idx
    :param controller_detail_list: Keyword argument tuple.

    :type controller_idx: long
    :param controller_idx: **controller_detail_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.openflow_state.detail.controller_detail_list', u'controller_detail_list')]
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.detail.controller_detail_list.controller_info', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'controller_idx', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, controller_detail_list=controller_detail_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, controller_detail_list=controller_detail_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_detail_controller_detail_list_controller_info_type_delete(self, controller_detail_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type controller_detail_list: controller_idx
    :param controller_detail_list: Keyword argument tuple.

    :type controller_idx: long
    :param controller_idx: **controller_detail_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.openflow_state.detail.controller_detail_list', u'controller_detail_list')]
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.detail.controller_detail_list.controller_info', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'controller_idx', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, controller_detail_list=controller_detail_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, controller_detail_list=controller_detail_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_detail_controller_detail_list_controller_info_vrf_name_delete(self, controller_detail_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type controller_detail_list: controller_idx
    :param controller_detail_list: Keyword argument tuple.

    :type controller_idx: long
    :param controller_idx: **controller_detail_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.openflow_state.detail.controller_detail_list', u'controller_detail_list')]
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.detail.controller_detail_list.controller_info', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'controller_idx', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vrf-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, controller_detail_list=controller_detail_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, controller_detail_list=controller_detail_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_detail_data_path_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.detail', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'data-path'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_detail_default_action_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.detail', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'default-action'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_detail_enabled_ports_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.detail', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enabled-ports'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_detail_hybrid_interfaces_delete(self, hybrid_interfaces=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type hybrid_interfaces: hybrid_interface
    :param hybrid_interfaces: Keyword argument tuple.

    :type hybrid_interface: unicode
    :param hybrid_interface: **hybrid_interfaces** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.detail.hybrid_interfaces', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'hybrid_interfaces', 'keyval': 'hybrid_interface', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hybrid_interfaces=hybrid_interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hybrid_interfaces=hybrid_interfaces)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_detail_hybrid_interfaces_protected_vlans_delete(self, hybrid_interfaces=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type hybrid_interfaces: hybrid_interface
    :param hybrid_interfaces: Keyword argument tuple.

    :type hybrid_interface: unicode
    :param hybrid_interface: **hybrid_interfaces** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.detail.hybrid_interfaces', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'hybrid_interfaces', 'keyval': 'hybrid_interface', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'protected-vlans'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hybrid_interfaces=hybrid_interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hybrid_interfaces=hybrid_interfaces)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_detail_l2_match_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.detail', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'l2-match'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_detail_l3_match_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.detail', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'l3-match'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_detail_max_l2_flows_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.detail', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'max-l2-flows'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_detail_num_controllers_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.detail', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'num-controllers'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_detail_ssl_status_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.detail', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ssl-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_flow_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_flow_data_bytes_sent_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'data-bytes-sent'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_flow_data_packets_sent_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'data-packets-sent'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_flow_flow_info_list_delete(self, flow_info_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow.flow_info_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'flow_info_list', 'keyval': 'flow_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_info_list=flow_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_info_list=flow_info_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_flow_flow_info_list_action_data_delete(self, flow_info_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow.flow_info_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'flow_info_list', 'keyval': 'flow_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'action-data'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_info_list=flow_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_info_list=flow_info_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_flow_flow_info_list_destination_ip_delete(self, flow_info_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow.flow_info_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'flow_info_list', 'keyval': 'flow_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'destination-ip'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_info_list=flow_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_info_list=flow_info_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_flow_flow_info_list_destination_ip_mask_delete(self, flow_info_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow.flow_info_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'flow_info_list', 'keyval': 'flow_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'destination-ip-mask'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_info_list=flow_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_info_list=flow_info_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_flow_flow_info_list_destination_mac_delete(self, flow_info_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow.flow_info_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'flow_info_list', 'keyval': 'flow_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'destination-mac'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_info_list=flow_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_info_list=flow_info_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_flow_flow_info_list_ether_type_delete(self, flow_info_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow.flow_info_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'flow_info_list', 'keyval': 'flow_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ether-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_info_list=flow_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_info_list=flow_info_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_flow_flow_info_list_flow_action_list_delete(self, flow_info_list=None, flow_action_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type flow_action_list: action_idx
    :param flow_action_list: Keyword argument tuple.

    :type action_idx: long
    :param action_idx: **flow_action_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow.flow_info_list', u'flow_info_list')]
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow.flow_info_list.flow_action_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'flow_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'flow_action_list', 'keyval': 'action_idx', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_info_list=flow_info_list, flow_action_list=flow_action_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_info_list=flow_info_list, flow_action_list=flow_action_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_flow_flow_info_list_flow_action_list_action_vlan_upbits_delete(self, flow_info_list=None, flow_action_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type flow_action_list: action_idx
    :param flow_action_list: Keyword argument tuple.

    :type action_idx: long
    :param action_idx: **flow_action_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow.flow_info_list', u'flow_info_list')]
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow.flow_info_list.flow_action_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'flow_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'flow_action_list', 'keyval': 'action_idx', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'action-vlan-upbits'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_info_list=flow_info_list, flow_action_list=flow_action_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_info_list=flow_info_list, flow_action_list=flow_action_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_flow_flow_info_list_flow_action_list_group_id_delete(self, flow_info_list=None, flow_action_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type flow_action_list: action_idx
    :param flow_action_list: Keyword argument tuple.

    :type action_idx: long
    :param action_idx: **flow_action_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow.flow_info_list', u'flow_info_list')]
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow.flow_info_list.flow_action_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'flow_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'flow_action_list', 'keyval': 'action_idx', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'group-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_info_list=flow_info_list, flow_action_list=flow_action_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_info_list=flow_info_list, flow_action_list=flow_action_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_flow_flow_info_list_flow_action_list_out_ports_delete(self, flow_info_list=None, flow_action_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type flow_action_list: action_idx
    :param flow_action_list: Keyword argument tuple.

    :type action_idx: long
    :param action_idx: **flow_action_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow.flow_info_list', u'flow_info_list')]
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow.flow_info_list.flow_action_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'flow_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'flow_action_list', 'keyval': 'action_idx', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'out-ports'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_info_list=flow_info_list, flow_action_list=flow_action_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_info_list=flow_info_list, flow_action_list=flow_action_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_flow_flow_info_list_flow_action_list_out_vlan_etype_delete(self, flow_info_list=None, flow_action_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type flow_action_list: action_idx
    :param flow_action_list: Keyword argument tuple.

    :type action_idx: long
    :param action_idx: **flow_action_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow.flow_info_list', u'flow_info_list')]
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow.flow_info_list.flow_action_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'flow_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'flow_action_list', 'keyval': 'action_idx', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'out-vlan-etype'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_info_list=flow_info_list, flow_action_list=flow_action_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_info_list=flow_info_list, flow_action_list=flow_action_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_flow_flow_info_list_flow_action_list_out_vlan_tag_delete(self, flow_info_list=None, flow_action_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type flow_action_list: action_idx
    :param flow_action_list: Keyword argument tuple.

    :type action_idx: long
    :param action_idx: **flow_action_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow.flow_info_list', u'flow_info_list')]
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow.flow_info_list.flow_action_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'flow_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'flow_action_list', 'keyval': 'action_idx', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'out-vlan-tag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_info_list=flow_info_list, flow_action_list=flow_action_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_info_list=flow_info_list, flow_action_list=flow_action_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_flow_flow_info_list_flow_action_list_queue_id_delete(self, flow_info_list=None, flow_action_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type flow_action_list: action_idx
    :param flow_action_list: Keyword argument tuple.

    :type action_idx: long
    :param action_idx: **flow_action_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow.flow_info_list', u'flow_info_list')]
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow.flow_info_list.flow_action_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'flow_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'flow_action_list', 'keyval': 'action_idx', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'queue-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_info_list=flow_info_list, flow_action_list=flow_action_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_info_list=flow_info_list, flow_action_list=flow_action_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_flow_flow_info_list_flow_action_list_vlan_id_delete(self, flow_info_list=None, flow_action_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type flow_action_list: action_idx
    :param flow_action_list: Keyword argument tuple.

    :type action_idx: long
    :param action_idx: **flow_action_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow.flow_info_list', u'flow_info_list')]
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow.flow_info_list.flow_action_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'flow_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'flow_action_list', 'keyval': 'action_idx', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vlan-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_info_list=flow_info_list, flow_action_list=flow_action_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_info_list=flow_info_list, flow_action_list=flow_action_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_flow_flow_info_list_in_port_delete(self, flow_info_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow.flow_info_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'flow_info_list', 'keyval': 'flow_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'in-port'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_info_list=flow_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_info_list=flow_info_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_flow_flow_info_list_in_vlan_delete(self, flow_info_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow.flow_info_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'flow_info_list', 'keyval': 'flow_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'in-vlan'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_info_list=flow_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_info_list=flow_info_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_flow_flow_info_list_instructions_delete(self, flow_info_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow.flow_info_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'flow_info_list', 'keyval': 'flow_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'instructions'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_info_list=flow_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_info_list=flow_info_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_flow_flow_info_list_ip_protocol_delete(self, flow_info_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow.flow_info_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'flow_info_list', 'keyval': 'flow_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ip-protocol'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_info_list=flow_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_info_list=flow_info_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_flow_flow_info_list_ip_protocol_destination_port_delete(self, flow_info_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow.flow_info_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'flow_info_list', 'keyval': 'flow_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ip-protocol-destination-port'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_info_list=flow_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_info_list=flow_info_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_flow_flow_info_list_ip_protocol_source_port_delete(self, flow_info_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow.flow_info_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'flow_info_list', 'keyval': 'flow_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ip-protocol-source-port'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_info_list=flow_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_info_list=flow_info_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_flow_flow_info_list_meter_id_delete(self, flow_info_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow.flow_info_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'flow_info_list', 'keyval': 'flow_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'meter-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_info_list=flow_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_info_list=flow_info_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_flow_flow_info_list_nw_tos_delete(self, flow_info_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow.flow_info_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'flow_info_list', 'keyval': 'flow_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'nw-tos'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_info_list=flow_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_info_list=flow_info_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_flow_flow_info_list_priority_delete(self, flow_info_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow.flow_info_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'flow_info_list', 'keyval': 'flow_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_info_list=flow_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_info_list=flow_info_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_flow_flow_info_list_source_ip_delete(self, flow_info_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow.flow_info_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'flow_info_list', 'keyval': 'flow_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'source-ip'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_info_list=flow_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_info_list=flow_info_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_flow_flow_info_list_source_ip_mask_delete(self, flow_info_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow.flow_info_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'flow_info_list', 'keyval': 'flow_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'source-ip-mask'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_info_list=flow_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_info_list=flow_info_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_flow_flow_info_list_source_mac_delete(self, flow_info_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow.flow_info_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'flow_info_list', 'keyval': 'flow_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'source-mac'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_info_list=flow_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_info_list=flow_info_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_flow_flow_info_list_status_delete(self, flow_info_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow.flow_info_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'flow_info_list', 'keyval': 'flow_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_info_list=flow_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_info_list=flow_info_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_flow_flow_info_list_total_bytes_delete(self, flow_info_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow.flow_info_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'flow_info_list', 'keyval': 'flow_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'total-bytes'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_info_list=flow_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_info_list=flow_info_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_flow_flow_info_list_total_packets_delete(self, flow_info_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow.flow_info_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'flow_info_list', 'keyval': 'flow_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'total-packets'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_info_list=flow_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_info_list=flow_info_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_flow_flow_info_list_vlan_upbits_delete(self, flow_info_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow.flow_info_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'flow_info_list', 'keyval': 'flow_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vlan-upbits'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_info_list=flow_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_info_list=flow_info_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_flow_hw_generic_flows_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hw-generic-flows'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_flow_id_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow_id', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_flow_id_action_data_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow_id', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'action-data'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_flow_id_destination_ip_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow_id', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'destination-ip'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_flow_id_destination_ip_mask_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow_id', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'destination-ip-mask'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_flow_id_destination_mac_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow_id', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'destination-mac'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_flow_id_ether_type_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow_id', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ether-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_flow_id_flow_action_list_delete(self, flow_action_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type flow_action_list: action_idx
    :param flow_action_list: Keyword argument tuple.

    :type action_idx: long
    :param action_idx: **flow_action_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow_id.flow_action_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'flow_action_list', 'keyval': 'action_idx', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_action_list=flow_action_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_action_list=flow_action_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_flow_id_flow_action_list_action_vlan_upbits_delete(self, flow_action_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type flow_action_list: action_idx
    :param flow_action_list: Keyword argument tuple.

    :type action_idx: long
    :param action_idx: **flow_action_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow_id.flow_action_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'flow_action_list', 'keyval': 'action_idx', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'action-vlan-upbits'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_action_list=flow_action_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_action_list=flow_action_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_flow_id_flow_action_list_group_id_delete(self, flow_action_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type flow_action_list: action_idx
    :param flow_action_list: Keyword argument tuple.

    :type action_idx: long
    :param action_idx: **flow_action_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow_id.flow_action_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'flow_action_list', 'keyval': 'action_idx', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'group-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_action_list=flow_action_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_action_list=flow_action_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_flow_id_flow_action_list_out_ports_delete(self, flow_action_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type flow_action_list: action_idx
    :param flow_action_list: Keyword argument tuple.

    :type action_idx: long
    :param action_idx: **flow_action_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow_id.flow_action_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'flow_action_list', 'keyval': 'action_idx', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'out-ports'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_action_list=flow_action_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_action_list=flow_action_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_flow_id_flow_action_list_out_vlan_etype_delete(self, flow_action_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type flow_action_list: action_idx
    :param flow_action_list: Keyword argument tuple.

    :type action_idx: long
    :param action_idx: **flow_action_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow_id.flow_action_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'flow_action_list', 'keyval': 'action_idx', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'out-vlan-etype'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_action_list=flow_action_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_action_list=flow_action_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_flow_id_flow_action_list_out_vlan_tag_delete(self, flow_action_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type flow_action_list: action_idx
    :param flow_action_list: Keyword argument tuple.

    :type action_idx: long
    :param action_idx: **flow_action_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow_id.flow_action_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'flow_action_list', 'keyval': 'action_idx', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'out-vlan-tag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_action_list=flow_action_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_action_list=flow_action_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_flow_id_flow_action_list_queue_id_delete(self, flow_action_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type flow_action_list: action_idx
    :param flow_action_list: Keyword argument tuple.

    :type action_idx: long
    :param action_idx: **flow_action_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow_id.flow_action_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'flow_action_list', 'keyval': 'action_idx', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'queue-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_action_list=flow_action_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_action_list=flow_action_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_flow_id_flow_action_list_vlan_id_delete(self, flow_action_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type flow_action_list: action_idx
    :param flow_action_list: Keyword argument tuple.

    :type action_idx: long
    :param action_idx: **flow_action_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow_id.flow_action_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'flow_action_list', 'keyval': 'action_idx', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vlan-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_action_list=flow_action_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_action_list=flow_action_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_flow_id_flow_id_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow_id', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'flow-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_flow_id_in_port_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow_id', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'in-port'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_flow_id_in_vlan_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow_id', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'in-vlan'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_flow_id_instructions_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow_id', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'instructions'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_flow_id_ip_protocol_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow_id', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ip-protocol'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_flow_id_ip_protocol_destination_port_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow_id', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ip-protocol-destination-port'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_flow_id_ip_protocol_source_port_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow_id', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ip-protocol-source-port'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_flow_id_meter_id_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow_id', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'meter-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_flow_id_nw_tos_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow_id', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'nw-tos'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_flow_id_priority_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow_id', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_flow_id_source_ip_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow_id', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'source-ip'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_flow_id_source_ip_mask_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow_id', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'source-ip-mask'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_flow_id_source_mac_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow_id', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'source-mac'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_flow_id_status_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow_id', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_flow_id_total_bytes_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow_id', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'total-bytes'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_flow_id_total_packets_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow_id', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'total-packets'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_flow_id_vlan_upbits_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow_id', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vlan-upbits'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_flow_interface_delete(self, flow_interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type flow_interface: interface_type, interface_value
    :param flow_interface: Keyword argument tuple.

    :type interface_type: long
    :param interface_type: **flow_interface** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type interface_value: unicode
    :param interface_value: **flow_interface** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow_interface', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'flow_interface', 'keyval': 'interface_type, interface_value', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_interface=flow_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_interface=flow_interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_flow_interface_flow_info_list_delete(self, flow_interface=None, flow_info_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type flow_interface: interface_type, interface_value
    :param flow_interface: Keyword argument tuple.

    :type interface_type: long
    :param interface_type: **flow_interface** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type interface_value: unicode
    :param interface_value: **flow_interface** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow_interface', u'flow_interface')]
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow_interface.flow_info_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'flow_info_list', 'keyval': 'flow_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_interface=flow_interface, flow_info_list=flow_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_interface=flow_interface, flow_info_list=flow_info_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_flow_interface_flow_info_list_action_data_delete(self, flow_interface=None, flow_info_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type flow_interface: interface_type, interface_value
    :param flow_interface: Keyword argument tuple.

    :type interface_type: long
    :param interface_type: **flow_interface** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type interface_value: unicode
    :param interface_value: **flow_interface** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow_interface', u'flow_interface')]
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow_interface.flow_info_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'flow_info_list', 'keyval': 'flow_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'action-data'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_interface=flow_interface, flow_info_list=flow_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_interface=flow_interface, flow_info_list=flow_info_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_flow_interface_flow_info_list_destination_ip_delete(self, flow_interface=None, flow_info_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type flow_interface: interface_type, interface_value
    :param flow_interface: Keyword argument tuple.

    :type interface_type: long
    :param interface_type: **flow_interface** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type interface_value: unicode
    :param interface_value: **flow_interface** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow_interface', u'flow_interface')]
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow_interface.flow_info_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'flow_info_list', 'keyval': 'flow_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'destination-ip'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_interface=flow_interface, flow_info_list=flow_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_interface=flow_interface, flow_info_list=flow_info_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_flow_interface_flow_info_list_destination_ip_mask_delete(self, flow_interface=None, flow_info_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type flow_interface: interface_type, interface_value
    :param flow_interface: Keyword argument tuple.

    :type interface_type: long
    :param interface_type: **flow_interface** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type interface_value: unicode
    :param interface_value: **flow_interface** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow_interface', u'flow_interface')]
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow_interface.flow_info_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'flow_info_list', 'keyval': 'flow_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'destination-ip-mask'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_interface=flow_interface, flow_info_list=flow_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_interface=flow_interface, flow_info_list=flow_info_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_flow_interface_flow_info_list_destination_mac_delete(self, flow_interface=None, flow_info_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type flow_interface: interface_type, interface_value
    :param flow_interface: Keyword argument tuple.

    :type interface_type: long
    :param interface_type: **flow_interface** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type interface_value: unicode
    :param interface_value: **flow_interface** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow_interface', u'flow_interface')]
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow_interface.flow_info_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'flow_info_list', 'keyval': 'flow_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'destination-mac'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_interface=flow_interface, flow_info_list=flow_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_interface=flow_interface, flow_info_list=flow_info_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_flow_interface_flow_info_list_ether_type_delete(self, flow_interface=None, flow_info_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type flow_interface: interface_type, interface_value
    :param flow_interface: Keyword argument tuple.

    :type interface_type: long
    :param interface_type: **flow_interface** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type interface_value: unicode
    :param interface_value: **flow_interface** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow_interface', u'flow_interface')]
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow_interface.flow_info_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'flow_info_list', 'keyval': 'flow_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ether-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_interface=flow_interface, flow_info_list=flow_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_interface=flow_interface, flow_info_list=flow_info_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_flow_interface_flow_info_list_flow_action_list_delete(self, flow_interface=None, flow_info_list=None, flow_action_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type flow_interface: interface_type, interface_value
    :param flow_interface: Keyword argument tuple.

    :type interface_type: long
    :param interface_type: **flow_interface** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type interface_value: unicode
    :param interface_value: **flow_interface** tuple argument.

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type flow_action_list: action_idx
    :param flow_action_list: Keyword argument tuple.

    :type action_idx: long
    :param action_idx: **flow_action_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow_interface', u'flow_interface'), ('pybind.slxos.v16r_1_00b.openflow_state.flow_interface.flow_info_list', u'flow_info_list')]
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow_interface.flow_info_list.flow_action_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_value', 'extra_keyval': ''}, {'keyval': 'flow_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'flow_action_list', 'keyval': 'action_idx', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_interface=flow_interface, flow_info_list=flow_info_list, flow_action_list=flow_action_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_interface=flow_interface, flow_info_list=flow_info_list, flow_action_list=flow_action_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_flow_interface_flow_info_list_flow_action_list_action_vlan_upbits_delete(self, flow_interface=None, flow_info_list=None, flow_action_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type flow_interface: interface_type, interface_value
    :param flow_interface: Keyword argument tuple.

    :type interface_type: long
    :param interface_type: **flow_interface** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type interface_value: unicode
    :param interface_value: **flow_interface** tuple argument.

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type flow_action_list: action_idx
    :param flow_action_list: Keyword argument tuple.

    :type action_idx: long
    :param action_idx: **flow_action_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow_interface', u'flow_interface'), ('pybind.slxos.v16r_1_00b.openflow_state.flow_interface.flow_info_list', u'flow_info_list')]
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow_interface.flow_info_list.flow_action_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_value', 'extra_keyval': ''}, {'keyval': 'flow_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'flow_action_list', 'keyval': 'action_idx', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'action-vlan-upbits'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_interface=flow_interface, flow_info_list=flow_info_list, flow_action_list=flow_action_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_interface=flow_interface, flow_info_list=flow_info_list, flow_action_list=flow_action_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_flow_interface_flow_info_list_flow_action_list_group_id_delete(self, flow_interface=None, flow_info_list=None, flow_action_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type flow_interface: interface_type, interface_value
    :param flow_interface: Keyword argument tuple.

    :type interface_type: long
    :param interface_type: **flow_interface** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type interface_value: unicode
    :param interface_value: **flow_interface** tuple argument.

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type flow_action_list: action_idx
    :param flow_action_list: Keyword argument tuple.

    :type action_idx: long
    :param action_idx: **flow_action_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow_interface', u'flow_interface'), ('pybind.slxos.v16r_1_00b.openflow_state.flow_interface.flow_info_list', u'flow_info_list')]
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow_interface.flow_info_list.flow_action_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_value', 'extra_keyval': ''}, {'keyval': 'flow_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'flow_action_list', 'keyval': 'action_idx', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'group-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_interface=flow_interface, flow_info_list=flow_info_list, flow_action_list=flow_action_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_interface=flow_interface, flow_info_list=flow_info_list, flow_action_list=flow_action_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_flow_interface_flow_info_list_flow_action_list_out_ports_delete(self, flow_interface=None, flow_info_list=None, flow_action_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type flow_interface: interface_type, interface_value
    :param flow_interface: Keyword argument tuple.

    :type interface_type: long
    :param interface_type: **flow_interface** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type interface_value: unicode
    :param interface_value: **flow_interface** tuple argument.

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type flow_action_list: action_idx
    :param flow_action_list: Keyword argument tuple.

    :type action_idx: long
    :param action_idx: **flow_action_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow_interface', u'flow_interface'), ('pybind.slxos.v16r_1_00b.openflow_state.flow_interface.flow_info_list', u'flow_info_list')]
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow_interface.flow_info_list.flow_action_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_value', 'extra_keyval': ''}, {'keyval': 'flow_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'flow_action_list', 'keyval': 'action_idx', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'out-ports'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_interface=flow_interface, flow_info_list=flow_info_list, flow_action_list=flow_action_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_interface=flow_interface, flow_info_list=flow_info_list, flow_action_list=flow_action_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_flow_interface_flow_info_list_flow_action_list_out_vlan_etype_delete(self, flow_interface=None, flow_info_list=None, flow_action_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type flow_interface: interface_type, interface_value
    :param flow_interface: Keyword argument tuple.

    :type interface_type: long
    :param interface_type: **flow_interface** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type interface_value: unicode
    :param interface_value: **flow_interface** tuple argument.

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type flow_action_list: action_idx
    :param flow_action_list: Keyword argument tuple.

    :type action_idx: long
    :param action_idx: **flow_action_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow_interface', u'flow_interface'), ('pybind.slxos.v16r_1_00b.openflow_state.flow_interface.flow_info_list', u'flow_info_list')]
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow_interface.flow_info_list.flow_action_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_value', 'extra_keyval': ''}, {'keyval': 'flow_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'flow_action_list', 'keyval': 'action_idx', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'out-vlan-etype'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_interface=flow_interface, flow_info_list=flow_info_list, flow_action_list=flow_action_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_interface=flow_interface, flow_info_list=flow_info_list, flow_action_list=flow_action_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_flow_interface_flow_info_list_flow_action_list_out_vlan_tag_delete(self, flow_interface=None, flow_info_list=None, flow_action_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type flow_interface: interface_type, interface_value
    :param flow_interface: Keyword argument tuple.

    :type interface_type: long
    :param interface_type: **flow_interface** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type interface_value: unicode
    :param interface_value: **flow_interface** tuple argument.

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type flow_action_list: action_idx
    :param flow_action_list: Keyword argument tuple.

    :type action_idx: long
    :param action_idx: **flow_action_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow_interface', u'flow_interface'), ('pybind.slxos.v16r_1_00b.openflow_state.flow_interface.flow_info_list', u'flow_info_list')]
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow_interface.flow_info_list.flow_action_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_value', 'extra_keyval': ''}, {'keyval': 'flow_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'flow_action_list', 'keyval': 'action_idx', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'out-vlan-tag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_interface=flow_interface, flow_info_list=flow_info_list, flow_action_list=flow_action_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_interface=flow_interface, flow_info_list=flow_info_list, flow_action_list=flow_action_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_flow_interface_flow_info_list_flow_action_list_queue_id_delete(self, flow_interface=None, flow_info_list=None, flow_action_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type flow_interface: interface_type, interface_value
    :param flow_interface: Keyword argument tuple.

    :type interface_type: long
    :param interface_type: **flow_interface** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type interface_value: unicode
    :param interface_value: **flow_interface** tuple argument.

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type flow_action_list: action_idx
    :param flow_action_list: Keyword argument tuple.

    :type action_idx: long
    :param action_idx: **flow_action_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow_interface', u'flow_interface'), ('pybind.slxos.v16r_1_00b.openflow_state.flow_interface.flow_info_list', u'flow_info_list')]
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow_interface.flow_info_list.flow_action_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_value', 'extra_keyval': ''}, {'keyval': 'flow_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'flow_action_list', 'keyval': 'action_idx', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'queue-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_interface=flow_interface, flow_info_list=flow_info_list, flow_action_list=flow_action_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_interface=flow_interface, flow_info_list=flow_info_list, flow_action_list=flow_action_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_flow_interface_flow_info_list_flow_action_list_vlan_id_delete(self, flow_interface=None, flow_info_list=None, flow_action_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type flow_interface: interface_type, interface_value
    :param flow_interface: Keyword argument tuple.

    :type interface_type: long
    :param interface_type: **flow_interface** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type interface_value: unicode
    :param interface_value: **flow_interface** tuple argument.

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type flow_action_list: action_idx
    :param flow_action_list: Keyword argument tuple.

    :type action_idx: long
    :param action_idx: **flow_action_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow_interface', u'flow_interface'), ('pybind.slxos.v16r_1_00b.openflow_state.flow_interface.flow_info_list', u'flow_info_list')]
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow_interface.flow_info_list.flow_action_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_value', 'extra_keyval': ''}, {'keyval': 'flow_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'flow_action_list', 'keyval': 'action_idx', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vlan-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_interface=flow_interface, flow_info_list=flow_info_list, flow_action_list=flow_action_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_interface=flow_interface, flow_info_list=flow_info_list, flow_action_list=flow_action_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_flow_interface_flow_info_list_in_port_delete(self, flow_interface=None, flow_info_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type flow_interface: interface_type, interface_value
    :param flow_interface: Keyword argument tuple.

    :type interface_type: long
    :param interface_type: **flow_interface** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type interface_value: unicode
    :param interface_value: **flow_interface** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow_interface', u'flow_interface')]
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow_interface.flow_info_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'flow_info_list', 'keyval': 'flow_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'in-port'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_interface=flow_interface, flow_info_list=flow_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_interface=flow_interface, flow_info_list=flow_info_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_flow_interface_flow_info_list_in_vlan_delete(self, flow_interface=None, flow_info_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type flow_interface: interface_type, interface_value
    :param flow_interface: Keyword argument tuple.

    :type interface_type: long
    :param interface_type: **flow_interface** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type interface_value: unicode
    :param interface_value: **flow_interface** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow_interface', u'flow_interface')]
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow_interface.flow_info_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'flow_info_list', 'keyval': 'flow_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'in-vlan'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_interface=flow_interface, flow_info_list=flow_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_interface=flow_interface, flow_info_list=flow_info_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_flow_interface_flow_info_list_instructions_delete(self, flow_interface=None, flow_info_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type flow_interface: interface_type, interface_value
    :param flow_interface: Keyword argument tuple.

    :type interface_type: long
    :param interface_type: **flow_interface** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type interface_value: unicode
    :param interface_value: **flow_interface** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow_interface', u'flow_interface')]
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow_interface.flow_info_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'flow_info_list', 'keyval': 'flow_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'instructions'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_interface=flow_interface, flow_info_list=flow_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_interface=flow_interface, flow_info_list=flow_info_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_flow_interface_flow_info_list_ip_protocol_delete(self, flow_interface=None, flow_info_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type flow_interface: interface_type, interface_value
    :param flow_interface: Keyword argument tuple.

    :type interface_type: long
    :param interface_type: **flow_interface** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type interface_value: unicode
    :param interface_value: **flow_interface** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow_interface', u'flow_interface')]
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow_interface.flow_info_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'flow_info_list', 'keyval': 'flow_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ip-protocol'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_interface=flow_interface, flow_info_list=flow_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_interface=flow_interface, flow_info_list=flow_info_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_flow_interface_flow_info_list_ip_protocol_destination_port_delete(self, flow_interface=None, flow_info_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type flow_interface: interface_type, interface_value
    :param flow_interface: Keyword argument tuple.

    :type interface_type: long
    :param interface_type: **flow_interface** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type interface_value: unicode
    :param interface_value: **flow_interface** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow_interface', u'flow_interface')]
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow_interface.flow_info_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'flow_info_list', 'keyval': 'flow_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ip-protocol-destination-port'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_interface=flow_interface, flow_info_list=flow_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_interface=flow_interface, flow_info_list=flow_info_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_flow_interface_flow_info_list_ip_protocol_source_port_delete(self, flow_interface=None, flow_info_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type flow_interface: interface_type, interface_value
    :param flow_interface: Keyword argument tuple.

    :type interface_type: long
    :param interface_type: **flow_interface** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type interface_value: unicode
    :param interface_value: **flow_interface** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow_interface', u'flow_interface')]
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow_interface.flow_info_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'flow_info_list', 'keyval': 'flow_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ip-protocol-source-port'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_interface=flow_interface, flow_info_list=flow_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_interface=flow_interface, flow_info_list=flow_info_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_flow_interface_flow_info_list_meter_id_delete(self, flow_interface=None, flow_info_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type flow_interface: interface_type, interface_value
    :param flow_interface: Keyword argument tuple.

    :type interface_type: long
    :param interface_type: **flow_interface** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type interface_value: unicode
    :param interface_value: **flow_interface** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow_interface', u'flow_interface')]
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow_interface.flow_info_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'flow_info_list', 'keyval': 'flow_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'meter-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_interface=flow_interface, flow_info_list=flow_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_interface=flow_interface, flow_info_list=flow_info_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_flow_interface_flow_info_list_nw_tos_delete(self, flow_interface=None, flow_info_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type flow_interface: interface_type, interface_value
    :param flow_interface: Keyword argument tuple.

    :type interface_type: long
    :param interface_type: **flow_interface** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type interface_value: unicode
    :param interface_value: **flow_interface** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow_interface', u'flow_interface')]
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow_interface.flow_info_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'flow_info_list', 'keyval': 'flow_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'nw-tos'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_interface=flow_interface, flow_info_list=flow_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_interface=flow_interface, flow_info_list=flow_info_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_flow_interface_flow_info_list_priority_delete(self, flow_interface=None, flow_info_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type flow_interface: interface_type, interface_value
    :param flow_interface: Keyword argument tuple.

    :type interface_type: long
    :param interface_type: **flow_interface** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type interface_value: unicode
    :param interface_value: **flow_interface** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow_interface', u'flow_interface')]
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow_interface.flow_info_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'flow_info_list', 'keyval': 'flow_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_interface=flow_interface, flow_info_list=flow_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_interface=flow_interface, flow_info_list=flow_info_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_flow_interface_flow_info_list_source_ip_delete(self, flow_interface=None, flow_info_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type flow_interface: interface_type, interface_value
    :param flow_interface: Keyword argument tuple.

    :type interface_type: long
    :param interface_type: **flow_interface** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type interface_value: unicode
    :param interface_value: **flow_interface** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow_interface', u'flow_interface')]
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow_interface.flow_info_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'flow_info_list', 'keyval': 'flow_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'source-ip'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_interface=flow_interface, flow_info_list=flow_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_interface=flow_interface, flow_info_list=flow_info_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_flow_interface_flow_info_list_source_ip_mask_delete(self, flow_interface=None, flow_info_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type flow_interface: interface_type, interface_value
    :param flow_interface: Keyword argument tuple.

    :type interface_type: long
    :param interface_type: **flow_interface** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type interface_value: unicode
    :param interface_value: **flow_interface** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow_interface', u'flow_interface')]
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow_interface.flow_info_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'flow_info_list', 'keyval': 'flow_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'source-ip-mask'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_interface=flow_interface, flow_info_list=flow_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_interface=flow_interface, flow_info_list=flow_info_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_flow_interface_flow_info_list_source_mac_delete(self, flow_interface=None, flow_info_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type flow_interface: interface_type, interface_value
    :param flow_interface: Keyword argument tuple.

    :type interface_type: long
    :param interface_type: **flow_interface** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type interface_value: unicode
    :param interface_value: **flow_interface** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow_interface', u'flow_interface')]
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow_interface.flow_info_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'flow_info_list', 'keyval': 'flow_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'source-mac'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_interface=flow_interface, flow_info_list=flow_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_interface=flow_interface, flow_info_list=flow_info_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_flow_interface_flow_info_list_status_delete(self, flow_interface=None, flow_info_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type flow_interface: interface_type, interface_value
    :param flow_interface: Keyword argument tuple.

    :type interface_type: long
    :param interface_type: **flow_interface** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type interface_value: unicode
    :param interface_value: **flow_interface** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow_interface', u'flow_interface')]
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow_interface.flow_info_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'flow_info_list', 'keyval': 'flow_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_interface=flow_interface, flow_info_list=flow_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_interface=flow_interface, flow_info_list=flow_info_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_flow_interface_flow_info_list_total_bytes_delete(self, flow_interface=None, flow_info_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type flow_interface: interface_type, interface_value
    :param flow_interface: Keyword argument tuple.

    :type interface_type: long
    :param interface_type: **flow_interface** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type interface_value: unicode
    :param interface_value: **flow_interface** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow_interface', u'flow_interface')]
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow_interface.flow_info_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'flow_info_list', 'keyval': 'flow_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'total-bytes'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_interface=flow_interface, flow_info_list=flow_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_interface=flow_interface, flow_info_list=flow_info_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_flow_interface_flow_info_list_total_packets_delete(self, flow_interface=None, flow_info_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type flow_interface: interface_type, interface_value
    :param flow_interface: Keyword argument tuple.

    :type interface_type: long
    :param interface_type: **flow_interface** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type interface_value: unicode
    :param interface_value: **flow_interface** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow_interface', u'flow_interface')]
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow_interface.flow_info_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'flow_info_list', 'keyval': 'flow_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'total-packets'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_interface=flow_interface, flow_info_list=flow_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_interface=flow_interface, flow_info_list=flow_info_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_flow_interface_flow_info_list_vlan_upbits_delete(self, flow_interface=None, flow_info_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type flow_interface: interface_type, interface_value
    :param flow_interface: Keyword argument tuple.

    :type interface_type: long
    :param interface_type: **flow_interface** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type interface_value: unicode
    :param interface_value: **flow_interface** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow_interface', u'flow_interface')]
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow_interface.flow_info_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'flow_info_list', 'keyval': 'flow_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vlan-upbits'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_interface=flow_interface, flow_info_list=flow_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_interface=flow_interface, flow_info_list=flow_info_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_flow_l23_interfaces_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'l23-interfaces'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_flow_l2_interfaces_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'l2-interfaces'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_flow_l3_interfaces_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'l3-interfaces'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_flow_port_based_flows_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.flow', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'port-based-flows'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_group_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.group', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_group_group_info_list_delete(self, group_info_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type group_info_list: group_id
    :param group_info_list: Keyword argument tuple.

    :type group_id: long
    :param group_id: **group_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.group.group_info_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'group_info_list', 'keyval': 'group_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, group_info_list=group_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, group_info_list=group_info_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_group_group_info_list_byte_count_delete(self, group_info_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type group_info_list: group_id
    :param group_info_list: Keyword argument tuple.

    :type group_id: long
    :param group_id: **group_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.group.group_info_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'group_info_list', 'keyval': 'group_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'byte-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, group_info_list=group_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, group_info_list=group_info_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_group_group_info_list_flow_count_delete(self, group_info_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type group_info_list: group_id
    :param group_info_list: Keyword argument tuple.

    :type group_id: long
    :param group_id: **group_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.group.group_info_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'group_info_list', 'keyval': 'group_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'flow-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, group_info_list=group_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, group_info_list=group_info_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_group_group_info_list_group_bucket_list_delete(self, group_info_list=None, group_bucket_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type group_info_list: group_id
    :param group_info_list: Keyword argument tuple.

    :type group_id: long
    :param group_id: **group_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type group_bucket_list: bucket_id
    :param group_bucket_list: Keyword argument tuple.

    :type bucket_id: long
    :param bucket_id: **group_bucket_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.openflow_state.group.group_info_list', u'group_info_list')]
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.group.group_info_list.group_bucket_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'group_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'group_bucket_list', 'keyval': 'bucket_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, group_info_list=group_info_list, group_bucket_list=group_bucket_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, group_info_list=group_info_list, group_bucket_list=group_bucket_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_group_group_info_list_group_bucket_list_group_action_list_delete(self, group_info_list=None, group_bucket_list=None, group_action_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type group_info_list: group_id
    :param group_info_list: Keyword argument tuple.

    :type group_id: long
    :param group_id: **group_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type group_bucket_list: bucket_id
    :param group_bucket_list: Keyword argument tuple.

    :type bucket_id: long
    :param bucket_id: **group_bucket_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type group_action_list: action_id
    :param group_action_list: Keyword argument tuple.

    :type action_id: long
    :param action_id: **group_action_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.openflow_state.group.group_info_list', u'group_info_list'), ('pybind.slxos.v16r_1_00b.openflow_state.group.group_info_list.group_bucket_list', u'group_bucket_list')]
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.group.group_info_list.group_bucket_list.group_action_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'group_id', 'extra_keyval': ''}, {'keyval': 'bucket_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'group_action_list', 'keyval': 'action_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, group_info_list=group_info_list, group_bucket_list=group_bucket_list, group_action_list=group_action_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, group_info_list=group_info_list, group_bucket_list=group_bucket_list, group_action_list=group_action_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_group_group_info_list_group_bucket_list_group_action_list_out_port_delete(self, group_info_list=None, group_bucket_list=None, group_action_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type group_info_list: group_id
    :param group_info_list: Keyword argument tuple.

    :type group_id: long
    :param group_id: **group_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type group_bucket_list: bucket_id
    :param group_bucket_list: Keyword argument tuple.

    :type bucket_id: long
    :param bucket_id: **group_bucket_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type group_action_list: action_id
    :param group_action_list: Keyword argument tuple.

    :type action_id: long
    :param action_id: **group_action_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.openflow_state.group.group_info_list', u'group_info_list'), ('pybind.slxos.v16r_1_00b.openflow_state.group.group_info_list.group_bucket_list', u'group_bucket_list')]
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.group.group_info_list.group_bucket_list.group_action_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'group_id', 'extra_keyval': ''}, {'keyval': 'bucket_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'group_action_list', 'keyval': 'action_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'out-port'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, group_info_list=group_info_list, group_bucket_list=group_bucket_list, group_action_list=group_action_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, group_info_list=group_info_list, group_bucket_list=group_bucket_list, group_action_list=group_action_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_group_group_info_list_group_bucket_list_group_action_list_out_vlan_etype_delete(self, group_info_list=None, group_bucket_list=None, group_action_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type group_info_list: group_id
    :param group_info_list: Keyword argument tuple.

    :type group_id: long
    :param group_id: **group_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type group_bucket_list: bucket_id
    :param group_bucket_list: Keyword argument tuple.

    :type bucket_id: long
    :param bucket_id: **group_bucket_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type group_action_list: action_id
    :param group_action_list: Keyword argument tuple.

    :type action_id: long
    :param action_id: **group_action_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.openflow_state.group.group_info_list', u'group_info_list'), ('pybind.slxos.v16r_1_00b.openflow_state.group.group_info_list.group_bucket_list', u'group_bucket_list')]
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.group.group_info_list.group_bucket_list.group_action_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'group_id', 'extra_keyval': ''}, {'keyval': 'bucket_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'group_action_list', 'keyval': 'action_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'out-vlan-etype'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, group_info_list=group_info_list, group_bucket_list=group_bucket_list, group_action_list=group_action_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, group_info_list=group_info_list, group_bucket_list=group_bucket_list, group_action_list=group_action_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_group_group_info_list_group_bucket_list_group_action_list_out_vlan_tag_delete(self, group_info_list=None, group_bucket_list=None, group_action_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type group_info_list: group_id
    :param group_info_list: Keyword argument tuple.

    :type group_id: long
    :param group_id: **group_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type group_bucket_list: bucket_id
    :param group_bucket_list: Keyword argument tuple.

    :type bucket_id: long
    :param bucket_id: **group_bucket_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type group_action_list: action_id
    :param group_action_list: Keyword argument tuple.

    :type action_id: long
    :param action_id: **group_action_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.openflow_state.group.group_info_list', u'group_info_list'), ('pybind.slxos.v16r_1_00b.openflow_state.group.group_info_list.group_bucket_list', u'group_bucket_list')]
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.group.group_info_list.group_bucket_list.group_action_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'group_id', 'extra_keyval': ''}, {'keyval': 'bucket_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'group_action_list', 'keyval': 'action_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'out-vlan-tag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, group_info_list=group_info_list, group_bucket_list=group_bucket_list, group_action_list=group_action_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, group_info_list=group_info_list, group_bucket_list=group_bucket_list, group_action_list=group_action_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_group_group_info_list_group_bucket_list_group_action_list_vlan_id_delete(self, group_info_list=None, group_bucket_list=None, group_action_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type group_info_list: group_id
    :param group_info_list: Keyword argument tuple.

    :type group_id: long
    :param group_id: **group_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type group_bucket_list: bucket_id
    :param group_bucket_list: Keyword argument tuple.

    :type bucket_id: long
    :param bucket_id: **group_bucket_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type group_action_list: action_id
    :param group_action_list: Keyword argument tuple.

    :type action_id: long
    :param action_id: **group_action_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.openflow_state.group.group_info_list', u'group_info_list'), ('pybind.slxos.v16r_1_00b.openflow_state.group.group_info_list.group_bucket_list', u'group_bucket_list')]
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.group.group_info_list.group_bucket_list.group_action_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'group_id', 'extra_keyval': ''}, {'keyval': 'bucket_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'group_action_list', 'keyval': 'action_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vlan-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, group_info_list=group_info_list, group_bucket_list=group_bucket_list, group_action_list=group_action_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, group_info_list=group_info_list, group_bucket_list=group_bucket_list, group_action_list=group_action_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_group_group_info_list_group_bucket_list_watch_port_delete(self, group_info_list=None, group_bucket_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type group_info_list: group_id
    :param group_info_list: Keyword argument tuple.

    :type group_id: long
    :param group_id: **group_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type group_bucket_list: bucket_id
    :param group_bucket_list: Keyword argument tuple.

    :type bucket_id: long
    :param bucket_id: **group_bucket_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.openflow_state.group.group_info_list', u'group_info_list')]
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.group.group_info_list.group_bucket_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'group_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'group_bucket_list', 'keyval': 'bucket_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'watch-port'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, group_info_list=group_info_list, group_bucket_list=group_bucket_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, group_info_list=group_info_list, group_bucket_list=group_bucket_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_group_group_info_list_group_bucket_list_weight_delete(self, group_info_list=None, group_bucket_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type group_info_list: group_id
    :param group_info_list: Keyword argument tuple.

    :type group_id: long
    :param group_id: **group_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type group_bucket_list: bucket_id
    :param group_bucket_list: Keyword argument tuple.

    :type bucket_id: long
    :param bucket_id: **group_bucket_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.openflow_state.group.group_info_list', u'group_info_list')]
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.group.group_info_list.group_bucket_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'group_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'group_bucket_list', 'keyval': 'bucket_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'weight'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, group_info_list=group_info_list, group_bucket_list=group_bucket_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, group_info_list=group_info_list, group_bucket_list=group_bucket_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_group_group_info_list_group_type_delete(self, group_info_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type group_info_list: group_id
    :param group_info_list: Keyword argument tuple.

    :type group_id: long
    :param group_id: **group_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.group.group_info_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'group_info_list', 'keyval': 'group_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'group-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, group_info_list=group_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, group_info_list=group_info_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_group_group_info_list_num_of_bkts_delete(self, group_info_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type group_info_list: group_id
    :param group_info_list: Keyword argument tuple.

    :type group_id: long
    :param group_id: **group_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.group.group_info_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'group_info_list', 'keyval': 'group_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'num-of-bkts'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, group_info_list=group_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, group_info_list=group_info_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_group_group_info_list_packet_count_delete(self, group_info_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type group_info_list: group_id
    :param group_info_list: Keyword argument tuple.

    :type group_id: long
    :param group_id: **group_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.group.group_info_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'group_info_list', 'keyval': 'group_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'packet-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, group_info_list=group_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, group_info_list=group_info_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_group_group_info_list_transaction_id_delete(self, group_info_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type group_info_list: group_id
    :param group_info_list: Keyword argument tuple.

    :type group_id: long
    :param group_id: **group_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.group.group_info_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'group_info_list', 'keyval': 'group_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'transaction-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, group_info_list=group_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, group_info_list=group_info_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_group_id_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.group_id', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_group_id_byte_count_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.group_id', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'byte-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_group_id_flow_count_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.group_id', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'flow-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_group_id_group_bucket_list_delete(self, group_bucket_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type group_bucket_list: bucket_id
    :param group_bucket_list: Keyword argument tuple.

    :type bucket_id: long
    :param bucket_id: **group_bucket_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.group_id.group_bucket_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'group_bucket_list', 'keyval': 'bucket_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, group_bucket_list=group_bucket_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, group_bucket_list=group_bucket_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_group_id_group_bucket_list_group_action_list_delete(self, group_bucket_list=None, group_action_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type group_bucket_list: bucket_id
    :param group_bucket_list: Keyword argument tuple.

    :type bucket_id: long
    :param bucket_id: **group_bucket_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type group_action_list: action_id
    :param group_action_list: Keyword argument tuple.

    :type action_id: long
    :param action_id: **group_action_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.openflow_state.group_id.group_bucket_list', u'group_bucket_list')]
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.group_id.group_bucket_list.group_action_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bucket_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'group_action_list', 'keyval': 'action_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, group_bucket_list=group_bucket_list, group_action_list=group_action_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, group_bucket_list=group_bucket_list, group_action_list=group_action_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_group_id_group_bucket_list_group_action_list_out_port_delete(self, group_bucket_list=None, group_action_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type group_bucket_list: bucket_id
    :param group_bucket_list: Keyword argument tuple.

    :type bucket_id: long
    :param bucket_id: **group_bucket_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type group_action_list: action_id
    :param group_action_list: Keyword argument tuple.

    :type action_id: long
    :param action_id: **group_action_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.openflow_state.group_id.group_bucket_list', u'group_bucket_list')]
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.group_id.group_bucket_list.group_action_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bucket_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'group_action_list', 'keyval': 'action_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'out-port'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, group_bucket_list=group_bucket_list, group_action_list=group_action_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, group_bucket_list=group_bucket_list, group_action_list=group_action_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_group_id_group_bucket_list_group_action_list_out_vlan_etype_delete(self, group_bucket_list=None, group_action_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type group_bucket_list: bucket_id
    :param group_bucket_list: Keyword argument tuple.

    :type bucket_id: long
    :param bucket_id: **group_bucket_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type group_action_list: action_id
    :param group_action_list: Keyword argument tuple.

    :type action_id: long
    :param action_id: **group_action_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.openflow_state.group_id.group_bucket_list', u'group_bucket_list')]
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.group_id.group_bucket_list.group_action_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bucket_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'group_action_list', 'keyval': 'action_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'out-vlan-etype'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, group_bucket_list=group_bucket_list, group_action_list=group_action_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, group_bucket_list=group_bucket_list, group_action_list=group_action_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_group_id_group_bucket_list_group_action_list_out_vlan_tag_delete(self, group_bucket_list=None, group_action_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type group_bucket_list: bucket_id
    :param group_bucket_list: Keyword argument tuple.

    :type bucket_id: long
    :param bucket_id: **group_bucket_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type group_action_list: action_id
    :param group_action_list: Keyword argument tuple.

    :type action_id: long
    :param action_id: **group_action_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.openflow_state.group_id.group_bucket_list', u'group_bucket_list')]
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.group_id.group_bucket_list.group_action_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bucket_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'group_action_list', 'keyval': 'action_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'out-vlan-tag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, group_bucket_list=group_bucket_list, group_action_list=group_action_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, group_bucket_list=group_bucket_list, group_action_list=group_action_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_group_id_group_bucket_list_group_action_list_vlan_id_delete(self, group_bucket_list=None, group_action_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type group_bucket_list: bucket_id
    :param group_bucket_list: Keyword argument tuple.

    :type bucket_id: long
    :param bucket_id: **group_bucket_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type group_action_list: action_id
    :param group_action_list: Keyword argument tuple.

    :type action_id: long
    :param action_id: **group_action_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.openflow_state.group_id.group_bucket_list', u'group_bucket_list')]
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.group_id.group_bucket_list.group_action_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bucket_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'group_action_list', 'keyval': 'action_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vlan-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, group_bucket_list=group_bucket_list, group_action_list=group_action_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, group_bucket_list=group_bucket_list, group_action_list=group_action_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_group_id_group_bucket_list_watch_port_delete(self, group_bucket_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type group_bucket_list: bucket_id
    :param group_bucket_list: Keyword argument tuple.

    :type bucket_id: long
    :param bucket_id: **group_bucket_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.group_id.group_bucket_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'group_bucket_list', 'keyval': 'bucket_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'watch-port'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, group_bucket_list=group_bucket_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, group_bucket_list=group_bucket_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_group_id_group_bucket_list_weight_delete(self, group_bucket_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type group_bucket_list: bucket_id
    :param group_bucket_list: Keyword argument tuple.

    :type bucket_id: long
    :param bucket_id: **group_bucket_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.group_id.group_bucket_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'group_bucket_list', 'keyval': 'bucket_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'weight'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, group_bucket_list=group_bucket_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, group_bucket_list=group_bucket_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_group_id_group_id_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.group_id', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'group-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_group_id_group_type_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.group_id', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'group-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_group_id_num_of_bkts_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.group_id', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'num-of-bkts'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_group_id_packet_count_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.group_id', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'packet-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_group_id_transaction_id_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.group_id', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'transaction-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_group_max_actions_per_bucket_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.group', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'max-actions-per-bucket'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_group_max_bkts_per_group_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.group', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'max-bkts-per-group'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_group_max_groups_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.group', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'max-groups'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_group_total_groups_all_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.group', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'total-groups-all'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_group_total_groups_fast_failover_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.group', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'total-groups-fast-failover'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_group_total_groups_indirect_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.group', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'total-groups-indirect'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_group_total_groups_select_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.group', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'total-groups-select'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_interface_delete(self, interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type interface: port
    :param interface: Keyword argument tuple.

    :type port: unicode
    :param port: **interface** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.interface', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'port', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interface=interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_interface_link_delete(self, interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type interface: port
    :param interface: Keyword argument tuple.

    :type port: unicode
    :param port: **interface** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.interface', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'port', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'link'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interface=interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_interface_mac_delete(self, interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type interface: port
    :param interface: Keyword argument tuple.

    :type port: unicode
    :param port: **interface** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.interface', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'port', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mac'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interface=interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_interface_mode_delete(self, interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type interface: port
    :param interface: Keyword argument tuple.

    :type port: unicode
    :param port: **interface** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.interface', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'port', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mode'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interface=interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_interface_port_id_delete(self, interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type interface: port
    :param interface: Keyword argument tuple.

    :type port: unicode
    :param port: **interface** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.interface', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'port', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'port-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interface=interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_interface_port_state_delete(self, interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type interface: port
    :param interface: Keyword argument tuple.

    :type port: unicode
    :param port: **interface** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.interface', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'port', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'port-state'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interface=interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_interface_speed_delete(self, interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type interface: port
    :param interface: Keyword argument tuple.

    :type port: unicode
    :param port: **interface** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.interface', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'port', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'speed'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interface=interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_meter_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.meter', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_meter_id_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.meter_id', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_meter_id_flow_count_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.meter_id', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'flow-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_meter_id_in_byte_count_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.meter_id', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'in-byte-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_meter_id_in_packet_count_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.meter_id', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'in-packet-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_meter_id_meter_id_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.meter_id', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'meter-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_meter_id_meterband_info_list_delete(self, meterband_info_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type meterband_info_list: band_type
    :param meterband_info_list: Keyword argument tuple.

    :type band_type: long
    :param band_type: **meterband_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.meter_id.meterband_info_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'meterband_info_list', 'keyval': 'band_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, meterband_info_list=meterband_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, meterband_info_list=meterband_info_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_meter_id_meterband_info_list_burst_size_delete(self, meterband_info_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type meterband_info_list: band_type
    :param meterband_info_list: Keyword argument tuple.

    :type band_type: long
    :param band_type: **meterband_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.meter_id.meterband_info_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'meterband_info_list', 'keyval': 'band_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'burst-size'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, meterband_info_list=meterband_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, meterband_info_list=meterband_info_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_meter_id_meterband_info_list_in_byte_band_count_delete(self, meterband_info_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type meterband_info_list: band_type
    :param meterband_info_list: Keyword argument tuple.

    :type band_type: long
    :param band_type: **meterband_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.meter_id.meterband_info_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'meterband_info_list', 'keyval': 'band_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'in-byte-band-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, meterband_info_list=meterband_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, meterband_info_list=meterband_info_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_meter_id_meterband_info_list_in_packet_band_count_delete(self, meterband_info_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type meterband_info_list: band_type
    :param meterband_info_list: Keyword argument tuple.

    :type band_type: long
    :param band_type: **meterband_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.meter_id.meterband_info_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'meterband_info_list', 'keyval': 'band_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'in-packet-band-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, meterband_info_list=meterband_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, meterband_info_list=meterband_info_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_meter_id_meterband_info_list_rate_delete(self, meterband_info_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type meterband_info_list: band_type
    :param meterband_info_list: Keyword argument tuple.

    :type band_type: long
    :param band_type: **meterband_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.meter_id.meterband_info_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'meterband_info_list', 'keyval': 'band_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rate'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, meterband_info_list=meterband_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, meterband_info_list=meterband_info_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_meter_id_meterflags_type_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.meter_id', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'meterflags-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_meter_id_num_of_bands_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.meter_id', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'num-of-bands'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_meter_id_transaction_id_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.meter_id', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'transaction-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_meter_meter_info_list_delete(self, meter_info_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type meter_info_list: meter_id
    :param meter_info_list: Keyword argument tuple.

    :type meter_id: long
    :param meter_id: **meter_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.meter.meter_info_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'meter_info_list', 'keyval': 'meter_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, meter_info_list=meter_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, meter_info_list=meter_info_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_meter_meter_info_list_flow_count_delete(self, meter_info_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type meter_info_list: meter_id
    :param meter_info_list: Keyword argument tuple.

    :type meter_id: long
    :param meter_id: **meter_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.meter.meter_info_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'meter_info_list', 'keyval': 'meter_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'flow-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, meter_info_list=meter_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, meter_info_list=meter_info_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_meter_meter_info_list_in_byte_count_delete(self, meter_info_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type meter_info_list: meter_id
    :param meter_info_list: Keyword argument tuple.

    :type meter_id: long
    :param meter_id: **meter_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.meter.meter_info_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'meter_info_list', 'keyval': 'meter_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'in-byte-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, meter_info_list=meter_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, meter_info_list=meter_info_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_meter_meter_info_list_in_packet_count_delete(self, meter_info_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type meter_info_list: meter_id
    :param meter_info_list: Keyword argument tuple.

    :type meter_id: long
    :param meter_id: **meter_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.meter.meter_info_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'meter_info_list', 'keyval': 'meter_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'in-packet-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, meter_info_list=meter_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, meter_info_list=meter_info_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_meter_meter_info_list_meterband_info_list_delete(self, meter_info_list=None, meterband_info_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type meter_info_list: meter_id
    :param meter_info_list: Keyword argument tuple.

    :type meter_id: long
    :param meter_id: **meter_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type meterband_info_list: band_type
    :param meterband_info_list: Keyword argument tuple.

    :type band_type: long
    :param band_type: **meterband_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.openflow_state.meter.meter_info_list', u'meter_info_list')]
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.meter.meter_info_list.meterband_info_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'meter_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'meterband_info_list', 'keyval': 'band_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, meter_info_list=meter_info_list, meterband_info_list=meterband_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, meter_info_list=meter_info_list, meterband_info_list=meterband_info_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_meter_meter_info_list_meterband_info_list_burst_size_delete(self, meter_info_list=None, meterband_info_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type meter_info_list: meter_id
    :param meter_info_list: Keyword argument tuple.

    :type meter_id: long
    :param meter_id: **meter_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type meterband_info_list: band_type
    :param meterband_info_list: Keyword argument tuple.

    :type band_type: long
    :param band_type: **meterband_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.openflow_state.meter.meter_info_list', u'meter_info_list')]
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.meter.meter_info_list.meterband_info_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'meter_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'meterband_info_list', 'keyval': 'band_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'burst-size'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, meter_info_list=meter_info_list, meterband_info_list=meterband_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, meter_info_list=meter_info_list, meterband_info_list=meterband_info_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_meter_meter_info_list_meterband_info_list_in_byte_band_count_delete(self, meter_info_list=None, meterband_info_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type meter_info_list: meter_id
    :param meter_info_list: Keyword argument tuple.

    :type meter_id: long
    :param meter_id: **meter_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type meterband_info_list: band_type
    :param meterband_info_list: Keyword argument tuple.

    :type band_type: long
    :param band_type: **meterband_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.openflow_state.meter.meter_info_list', u'meter_info_list')]
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.meter.meter_info_list.meterband_info_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'meter_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'meterband_info_list', 'keyval': 'band_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'in-byte-band-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, meter_info_list=meter_info_list, meterband_info_list=meterband_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, meter_info_list=meter_info_list, meterband_info_list=meterband_info_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_meter_meter_info_list_meterband_info_list_in_packet_band_count_delete(self, meter_info_list=None, meterband_info_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type meter_info_list: meter_id
    :param meter_info_list: Keyword argument tuple.

    :type meter_id: long
    :param meter_id: **meter_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type meterband_info_list: band_type
    :param meterband_info_list: Keyword argument tuple.

    :type band_type: long
    :param band_type: **meterband_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.openflow_state.meter.meter_info_list', u'meter_info_list')]
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.meter.meter_info_list.meterband_info_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'meter_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'meterband_info_list', 'keyval': 'band_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'in-packet-band-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, meter_info_list=meter_info_list, meterband_info_list=meterband_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, meter_info_list=meter_info_list, meterband_info_list=meterband_info_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_meter_meter_info_list_meterband_info_list_rate_delete(self, meter_info_list=None, meterband_info_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type meter_info_list: meter_id
    :param meter_info_list: Keyword argument tuple.

    :type meter_id: long
    :param meter_id: **meter_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type meterband_info_list: band_type
    :param meterband_info_list: Keyword argument tuple.

    :type band_type: long
    :param band_type: **meterband_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.openflow_state.meter.meter_info_list', u'meter_info_list')]
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.meter.meter_info_list.meterband_info_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'meter_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'meterband_info_list', 'keyval': 'band_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rate'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, meter_info_list=meter_info_list, meterband_info_list=meterband_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, meter_info_list=meter_info_list, meterband_info_list=meterband_info_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_meter_meter_info_list_meterflags_type_delete(self, meter_info_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type meter_info_list: meter_id
    :param meter_info_list: Keyword argument tuple.

    :type meter_id: long
    :param meter_id: **meter_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.meter.meter_info_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'meter_info_list', 'keyval': 'meter_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'meterflags-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, meter_info_list=meter_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, meter_info_list=meter_info_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_meter_meter_info_list_num_of_bands_delete(self, meter_info_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type meter_info_list: meter_id
    :param meter_info_list: Keyword argument tuple.

    :type meter_id: long
    :param meter_id: **meter_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.meter.meter_info_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'meter_info_list', 'keyval': 'meter_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'num-of-bands'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, meter_info_list=meter_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, meter_info_list=meter_info_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_meter_meter_info_list_transaction_id_delete(self, meter_info_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type meter_info_list: meter_id
    :param meter_info_list: Keyword argument tuple.

    :type meter_id: long
    :param meter_id: **meter_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.meter.meter_info_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'meter_info_list', 'keyval': 'meter_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'transaction-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, meter_info_list=meter_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, meter_info_list=meter_info_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_meter_num_of_meters_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.meter', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'num-of-meters'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_queues_interface_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.queues_interface', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_queues_interface_interface_value_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.queues_interface', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'interface-value'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_queues_interface_queue_info_list_delete(self, queue_info_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type queue_info_list: interface, num
    :param queue_info_list: Keyword argument tuple.

    :type interface: unicode
    :param interface: **queue_info_list** tuple argument.

    :type num: long
    :param num: **queue_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.queues_interface.queue_info_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'queue_info_list', 'keyval': 'interface, num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, queue_info_list=queue_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, queue_info_list=queue_info_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_queues_interface_queue_info_list_tx_bytes_delete(self, queue_info_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type queue_info_list: interface, num
    :param queue_info_list: Keyword argument tuple.

    :type interface: unicode
    :param interface: **queue_info_list** tuple argument.

    :type num: long
    :param num: **queue_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.queues_interface.queue_info_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'queue_info_list', 'keyval': 'interface, num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tx-bytes'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, queue_info_list=queue_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, queue_info_list=queue_info_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_queues_interface_queue_info_list_tx_packets_delete(self, queue_info_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type queue_info_list: interface, num
    :param queue_info_list: Keyword argument tuple.

    :type interface: unicode
    :param interface: **queue_info_list** tuple argument.

    :type num: long
    :param num: **queue_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.queues_interface.queue_info_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'queue_info_list', 'keyval': 'interface, num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tx-packets'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, queue_info_list=queue_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, queue_info_list=queue_info_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_resources_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.resources', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_resources_group_resouces_list_delete(self, group_resouces_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type group_resouces_list: group_type
    :param group_resouces_list: Keyword argument tuple.

    :type group_type: unicode
    :param group_type: **group_resouces_list** tuple argument.

        * enumeration restriction: ::

            ['dcm-group-type-all',
            'dcm-group-type-select',
            'dcm-group-type-invalid',
            'dcm-group-type-indirect',
            'dcm-group-type-fast-failover']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.resources.group_resouces_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'group_resouces_list', 'keyval': 'group_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, group_resouces_list=group_resouces_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, group_resouces_list=group_resouces_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_resources_group_resouces_list_free_delete(self, group_resouces_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type group_resouces_list: group_type
    :param group_resouces_list: Keyword argument tuple.

    :type group_type: unicode
    :param group_type: **group_resouces_list** tuple argument.

        * enumeration restriction: ::

            ['dcm-group-type-all',
            'dcm-group-type-select',
            'dcm-group-type-invalid',
            'dcm-group-type-indirect',
            'dcm-group-type-fast-failover']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.resources.group_resouces_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'group_resouces_list', 'keyval': 'group_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'free'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, group_resouces_list=group_resouces_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, group_resouces_list=group_resouces_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_resources_group_resouces_list_max_delete(self, group_resouces_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type group_resouces_list: group_type
    :param group_resouces_list: Keyword argument tuple.

    :type group_type: unicode
    :param group_type: **group_resouces_list** tuple argument.

        * enumeration restriction: ::

            ['dcm-group-type-all',
            'dcm-group-type-select',
            'dcm-group-type-invalid',
            'dcm-group-type-indirect',
            'dcm-group-type-fast-failover']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.resources.group_resouces_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'group_resouces_list', 'keyval': 'group_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'max'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, group_resouces_list=group_resouces_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, group_resouces_list=group_resouces_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_resources_group_resouces_list_used_delete(self, group_resouces_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type group_resouces_list: group_type
    :param group_resouces_list: Keyword argument tuple.

    :type group_type: unicode
    :param group_type: **group_resouces_list** tuple argument.

        * enumeration restriction: ::

            ['dcm-group-type-all',
            'dcm-group-type-select',
            'dcm-group-type-invalid',
            'dcm-group-type-indirect',
            'dcm-group-type-fast-failover']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.resources.group_resouces_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'group_resouces_list', 'keyval': 'group_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'used'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, group_resouces_list=group_resouces_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, group_resouces_list=group_resouces_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_resources_meter_free_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.resources', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'meter-free'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_resources_meter_max_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.resources', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'meter-max'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_resources_meter_used_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.resources', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'meter-used'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_resources_slot_resouces_list_delete(self, slot_resouces_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type slot_resouces_list: slot_id
    :param slot_resouces_list: Keyword argument tuple.

    :type slot_id: long
    :param slot_id: **slot_resouces_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.resources.slot_resouces_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'slot_resouces_list', 'keyval': 'slot_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, slot_resouces_list=slot_resouces_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, slot_resouces_list=slot_resouces_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_resources_slot_resouces_list_module_delete(self, slot_resouces_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type slot_resouces_list: slot_id
    :param slot_resouces_list: Keyword argument tuple.

    :type slot_id: long
    :param slot_id: **slot_resouces_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.resources.slot_resouces_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'slot_resouces_list', 'keyval': 'slot_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'module'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, slot_resouces_list=slot_resouces_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, slot_resouces_list=slot_resouces_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_resources_slot_resouces_list_slot_match_profile_list_delete(self, slot_resouces_list=None, slot_match_profile_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type slot_resouces_list: slot_id
    :param slot_resouces_list: Keyword argument tuple.

    :type slot_id: long
    :param slot_id: **slot_resouces_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type slot_match_profile_list: slot_match_profile_idx
    :param slot_match_profile_list: Keyword argument tuple.

    :type slot_match_profile_idx: long
    :param slot_match_profile_idx: **slot_match_profile_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.openflow_state.resources.slot_resouces_list', u'slot_resouces_list')]
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.resources.slot_resouces_list.slot_match_profile_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'slot_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'slot_match_profile_list', 'keyval': 'slot_match_profile_idx', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, slot_resouces_list=slot_resouces_list, slot_match_profile_list=slot_match_profile_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, slot_resouces_list=slot_resouces_list, slot_match_profile_list=slot_match_profile_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_resources_slot_resouces_list_slot_match_profile_list_free_flows_delete(self, slot_resouces_list=None, slot_match_profile_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type slot_resouces_list: slot_id
    :param slot_resouces_list: Keyword argument tuple.

    :type slot_id: long
    :param slot_id: **slot_resouces_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type slot_match_profile_list: slot_match_profile_idx
    :param slot_match_profile_list: Keyword argument tuple.

    :type slot_match_profile_idx: long
    :param slot_match_profile_idx: **slot_match_profile_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.openflow_state.resources.slot_resouces_list', u'slot_resouces_list')]
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.resources.slot_resouces_list.slot_match_profile_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'slot_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'slot_match_profile_list', 'keyval': 'slot_match_profile_idx', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'free-flows'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, slot_resouces_list=slot_resouces_list, slot_match_profile_list=slot_match_profile_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, slot_resouces_list=slot_resouces_list, slot_match_profile_list=slot_match_profile_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_resources_slot_resouces_list_slot_match_profile_list_max_flows_delete(self, slot_resouces_list=None, slot_match_profile_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type slot_resouces_list: slot_id
    :param slot_resouces_list: Keyword argument tuple.

    :type slot_id: long
    :param slot_id: **slot_resouces_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type slot_match_profile_list: slot_match_profile_idx
    :param slot_match_profile_list: Keyword argument tuple.

    :type slot_match_profile_idx: long
    :param slot_match_profile_idx: **slot_match_profile_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.openflow_state.resources.slot_resouces_list', u'slot_resouces_list')]
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.resources.slot_resouces_list.slot_match_profile_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'slot_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'slot_match_profile_list', 'keyval': 'slot_match_profile_idx', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'max-flows'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, slot_resouces_list=slot_resouces_list, slot_match_profile_list=slot_match_profile_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, slot_resouces_list=slot_resouces_list, slot_match_profile_list=slot_match_profile_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_resources_slot_resouces_list_slot_match_profile_list_slot_chip_resource_list_delete(self, slot_resouces_list=None, slot_match_profile_list=None, slot_chip_resource_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type slot_resouces_list: slot_id
    :param slot_resouces_list: Keyword argument tuple.

    :type slot_id: long
    :param slot_id: **slot_resouces_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type slot_match_profile_list: slot_match_profile_idx
    :param slot_match_profile_list: Keyword argument tuple.

    :type slot_match_profile_idx: long
    :param slot_match_profile_idx: **slot_match_profile_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type slot_chip_resource_list: slot_chip_idx
    :param slot_chip_resource_list: Keyword argument tuple.

    :type slot_chip_idx: long
    :param slot_chip_idx: **slot_chip_resource_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.openflow_state.resources.slot_resouces_list', u'slot_resouces_list'), ('pybind.slxos.v16r_1_00b.openflow_state.resources.slot_resouces_list.slot_match_profile_list', u'slot_match_profile_list')]
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.resources.slot_resouces_list.slot_match_profile_list.slot_chip_resource_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'slot_id', 'extra_keyval': ''}, {'keyval': 'slot_match_profile_idx', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'slot_chip_resource_list', 'keyval': 'slot_chip_idx', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, slot_resouces_list=slot_resouces_list, slot_match_profile_list=slot_match_profile_list, slot_chip_resource_list=slot_chip_resource_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, slot_resouces_list=slot_resouces_list, slot_match_profile_list=slot_match_profile_list, slot_chip_resource_list=slot_chip_resource_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_resources_slot_resouces_list_slot_match_profile_list_slot_chip_resource_list_free_flows_delete(self, slot_resouces_list=None, slot_match_profile_list=None, slot_chip_resource_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type slot_resouces_list: slot_id
    :param slot_resouces_list: Keyword argument tuple.

    :type slot_id: long
    :param slot_id: **slot_resouces_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type slot_match_profile_list: slot_match_profile_idx
    :param slot_match_profile_list: Keyword argument tuple.

    :type slot_match_profile_idx: long
    :param slot_match_profile_idx: **slot_match_profile_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type slot_chip_resource_list: slot_chip_idx
    :param slot_chip_resource_list: Keyword argument tuple.

    :type slot_chip_idx: long
    :param slot_chip_idx: **slot_chip_resource_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.openflow_state.resources.slot_resouces_list', u'slot_resouces_list'), ('pybind.slxos.v16r_1_00b.openflow_state.resources.slot_resouces_list.slot_match_profile_list', u'slot_match_profile_list')]
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.resources.slot_resouces_list.slot_match_profile_list.slot_chip_resource_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'slot_id', 'extra_keyval': ''}, {'keyval': 'slot_match_profile_idx', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'slot_chip_resource_list', 'keyval': 'slot_chip_idx', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'free-flows'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, slot_resouces_list=slot_resouces_list, slot_match_profile_list=slot_match_profile_list, slot_chip_resource_list=slot_chip_resource_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, slot_resouces_list=slot_resouces_list, slot_match_profile_list=slot_match_profile_list, slot_chip_resource_list=slot_chip_resource_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_resources_slot_resouces_list_slot_match_profile_list_slot_chip_resource_list_max_flows_delete(self, slot_resouces_list=None, slot_match_profile_list=None, slot_chip_resource_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type slot_resouces_list: slot_id
    :param slot_resouces_list: Keyword argument tuple.

    :type slot_id: long
    :param slot_id: **slot_resouces_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type slot_match_profile_list: slot_match_profile_idx
    :param slot_match_profile_list: Keyword argument tuple.

    :type slot_match_profile_idx: long
    :param slot_match_profile_idx: **slot_match_profile_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type slot_chip_resource_list: slot_chip_idx
    :param slot_chip_resource_list: Keyword argument tuple.

    :type slot_chip_idx: long
    :param slot_chip_idx: **slot_chip_resource_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.openflow_state.resources.slot_resouces_list', u'slot_resouces_list'), ('pybind.slxos.v16r_1_00b.openflow_state.resources.slot_resouces_list.slot_match_profile_list', u'slot_match_profile_list')]
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.resources.slot_resouces_list.slot_match_profile_list.slot_chip_resource_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'slot_id', 'extra_keyval': ''}, {'keyval': 'slot_match_profile_idx', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'slot_chip_resource_list', 'keyval': 'slot_chip_idx', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'max-flows'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, slot_resouces_list=slot_resouces_list, slot_match_profile_list=slot_match_profile_list, slot_chip_resource_list=slot_chip_resource_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, slot_resouces_list=slot_resouces_list, slot_match_profile_list=slot_match_profile_list, slot_chip_resource_list=slot_chip_resource_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_resources_slot_resouces_list_slot_match_profile_list_slot_chip_resource_list_used_flows_delete(self, slot_resouces_list=None, slot_match_profile_list=None, slot_chip_resource_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type slot_resouces_list: slot_id
    :param slot_resouces_list: Keyword argument tuple.

    :type slot_id: long
    :param slot_id: **slot_resouces_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type slot_match_profile_list: slot_match_profile_idx
    :param slot_match_profile_list: Keyword argument tuple.

    :type slot_match_profile_idx: long
    :param slot_match_profile_idx: **slot_match_profile_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type slot_chip_resource_list: slot_chip_idx
    :param slot_chip_resource_list: Keyword argument tuple.

    :type slot_chip_idx: long
    :param slot_chip_idx: **slot_chip_resource_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.openflow_state.resources.slot_resouces_list', u'slot_resouces_list'), ('pybind.slxos.v16r_1_00b.openflow_state.resources.slot_resouces_list.slot_match_profile_list', u'slot_match_profile_list')]
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.resources.slot_resouces_list.slot_match_profile_list.slot_chip_resource_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'slot_id', 'extra_keyval': ''}, {'keyval': 'slot_match_profile_idx', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'slot_chip_resource_list', 'keyval': 'slot_chip_idx', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'used-flows'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, slot_resouces_list=slot_resouces_list, slot_match_profile_list=slot_match_profile_list, slot_chip_resource_list=slot_chip_resource_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, slot_resouces_list=slot_resouces_list, slot_match_profile_list=slot_match_profile_list, slot_chip_resource_list=slot_chip_resource_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_resources_slot_resouces_list_slot_match_profile_list_used_flows_delete(self, slot_resouces_list=None, slot_match_profile_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type slot_resouces_list: slot_id
    :param slot_resouces_list: Keyword argument tuple.

    :type slot_id: long
    :param slot_id: **slot_resouces_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type slot_match_profile_list: slot_match_profile_idx
    :param slot_match_profile_list: Keyword argument tuple.

    :type slot_match_profile_idx: long
    :param slot_match_profile_idx: **slot_match_profile_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.openflow_state.resources.slot_resouces_list', u'slot_resouces_list')]
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.resources.slot_resouces_list.slot_match_profile_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'slot_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'slot_match_profile_list', 'keyval': 'slot_match_profile_idx', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'used-flows'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, slot_resouces_list=slot_resouces_list, slot_match_profile_list=slot_match_profile_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, slot_resouces_list=slot_resouces_list, slot_match_profile_list=slot_match_profile_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def openflow_state_resources_tcam_profile_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.openflow_state.resources', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tcam-profile'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def opstest_state_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.opstest_state', 'pybind.slxos.v16r_1_00b.brocade_opstest', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def opstest_state_arpentries_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.opstest_state.arpentries', 'pybind.slxos.v16r_1_00b.brocade_opstest', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def opstest_state_arpentries_arpe_delete(self, arpe=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type arpe: ip, ifname
    :param arpe: Keyword argument tuple.

    :type ip: unicode
    :param ip: **arpe** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ifname: unicode
    :param ifname: **arpe** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.opstest_state.arpentries.arpe', 'pybind.slxos.v16r_1_00b.brocade_opstest', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'arpe', 'keyval': 'ip, ifname', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, arpe=arpe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, arpe=arpe)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def opstest_state_arpentries_arpe_hwaddr_delete(self, arpe=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type arpe: ip, ifname
    :param arpe: Keyword argument tuple.

    :type ip: unicode
    :param ip: **arpe** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ifname: unicode
    :param ifname: **arpe** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.opstest_state.arpentries.arpe', 'pybind.slxos.v16r_1_00b.brocade_opstest', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'arpe', 'keyval': 'ip, ifname', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hwaddr'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, arpe=arpe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, arpe=arpe)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def opstest_state_arpentries_arpe_permanent_delete(self, arpe=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type arpe: ip, ifname
    :param arpe: Keyword argument tuple.

    :type ip: unicode
    :param ip: **arpe** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ifname: unicode
    :param ifname: **arpe** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.opstest_state.arpentries.arpe', 'pybind.slxos.v16r_1_00b.brocade_opstest', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'arpe', 'keyval': 'ip, ifname', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'permanent'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, arpe=arpe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, arpe=arpe)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def opstest_state_arpentries_arpe_published_delete(self, arpe=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type arpe: ip, ifname
    :param arpe: Keyword argument tuple.

    :type ip: unicode
    :param ip: **arpe** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ifname: unicode
    :param ifname: **arpe** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.opstest_state.arpentries.arpe', 'pybind.slxos.v16r_1_00b.brocade_opstest', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'arpe', 'keyval': 'ip, ifname', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'published'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, arpe=arpe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, arpe=arpe)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def opstest_state_routes_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.opstest_state.routes', 'pybind.slxos.v16r_1_00b.brocade_opstest', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def opstest_state_routes_route_delete(self, route=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type route: destPrefix
    :param route: Keyword argument tuple.

    :type destPrefix: unicode
    :param destPrefix: **route** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.opstest_state.routes.route', 'pybind.slxos.v16r_1_00b.brocade_opstest', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'route', 'keyval': 'destPrefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route=route)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route=route)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def opstest_state_routes_route_children_delete(self, route=None, children=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route: destPrefix
    :param route: Keyword argument tuple.

    :type destPrefix: unicode
    :param destPrefix: **route** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type children: keyid
    :param children: Keyword argument tuple.

    :type keyid: long
    :param keyid: **children** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.opstest_state.routes.route', u'route')]
    bindings_list = [('pybind.slxos.v16r_1_00b.opstest_state.routes.route.children', 'pybind.slxos.v16r_1_00b.brocade_opstest', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'destPrefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'children', 'keyval': 'keyid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route=route, children=children)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route=route, children=children)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def opstest_state_routes_route_children_attr1_delete(self, route=None, children=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route: destPrefix
    :param route: Keyword argument tuple.

    :type destPrefix: unicode
    :param destPrefix: **route** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type children: keyid
    :param children: Keyword argument tuple.

    :type keyid: long
    :param keyid: **children** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.opstest_state.routes.route', u'route')]
    bindings_list = [('pybind.slxos.v16r_1_00b.opstest_state.routes.route.children', 'pybind.slxos.v16r_1_00b.brocade_opstest', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'destPrefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'children', 'keyval': 'keyid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'attr1'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route=route, children=children)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route=route, children=children)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def opstest_state_routes_route_children_attr2_delete(self, route=None, children=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route: destPrefix
    :param route: Keyword argument tuple.

    :type destPrefix: unicode
    :param destPrefix: **route** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type children: keyid
    :param children: Keyword argument tuple.

    :type keyid: long
    :param keyid: **children** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.opstest_state.routes.route', u'route')]
    bindings_list = [('pybind.slxos.v16r_1_00b.opstest_state.routes.route.children', 'pybind.slxos.v16r_1_00b.brocade_opstest', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'destPrefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'children', 'keyval': 'keyid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'attr2'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route=route, children=children)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route=route, children=children)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def opstest_state_routes_route_children_layer2_delete(self, route=None, children=None, layer2=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route: destPrefix
    :param route: Keyword argument tuple.

    :type destPrefix: unicode
    :param destPrefix: **route** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type children: keyid
    :param children: Keyword argument tuple.

    :type keyid: long
    :param keyid: **children** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type layer2: layer2id
    :param layer2: Keyword argument tuple.

    :type layer2id: long
    :param layer2id: **layer2** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.opstest_state.routes.route', u'route'), ('pybind.slxos.v16r_1_00b.opstest_state.routes.route.children', u'children')]
    bindings_list = [('pybind.slxos.v16r_1_00b.opstest_state.routes.route.children.layer2', 'pybind.slxos.v16r_1_00b.brocade_opstest', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'destPrefix', 'extra_keyval': ''}, {'keyval': 'keyid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'layer2', 'keyval': 'layer2id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route=route, children=children, layer2=layer2)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route=route, children=children, layer2=layer2)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def opstest_state_routes_route_children_layer2_attr3_delete(self, route=None, children=None, layer2=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route: destPrefix
    :param route: Keyword argument tuple.

    :type destPrefix: unicode
    :param destPrefix: **route** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type children: keyid
    :param children: Keyword argument tuple.

    :type keyid: long
    :param keyid: **children** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type layer2: layer2id
    :param layer2: Keyword argument tuple.

    :type layer2id: long
    :param layer2id: **layer2** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.opstest_state.routes.route', u'route'), ('pybind.slxos.v16r_1_00b.opstest_state.routes.route.children', u'children')]
    bindings_list = [('pybind.slxos.v16r_1_00b.opstest_state.routes.route.children.layer2', 'pybind.slxos.v16r_1_00b.brocade_opstest', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'destPrefix', 'extra_keyval': ''}, {'keyval': 'keyid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'layer2', 'keyval': 'layer2id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'attr3'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route=route, children=children, layer2=layer2)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route=route, children=children, layer2=layer2)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def opstest_state_routes_route_children_layer2_attr4_delete(self, route=None, children=None, layer2=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route: destPrefix
    :param route: Keyword argument tuple.

    :type destPrefix: unicode
    :param destPrefix: **route** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type children: keyid
    :param children: Keyword argument tuple.

    :type keyid: long
    :param keyid: **children** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type layer2: layer2id
    :param layer2: Keyword argument tuple.

    :type layer2id: long
    :param layer2id: **layer2** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.opstest_state.routes.route', u'route'), ('pybind.slxos.v16r_1_00b.opstest_state.routes.route.children', u'children')]
    bindings_list = [('pybind.slxos.v16r_1_00b.opstest_state.routes.route.children.layer2', 'pybind.slxos.v16r_1_00b.brocade_opstest', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'destPrefix', 'extra_keyval': ''}, {'keyval': 'keyid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'layer2', 'keyval': 'layer2id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'attr4'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route=route, children=children, layer2=layer2)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route=route, children=children, layer2=layer2)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def opstest_state_routes_route_children_layer2_grandparentkey_delete(self, route=None, children=None, layer2=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route: destPrefix
    :param route: Keyword argument tuple.

    :type destPrefix: unicode
    :param destPrefix: **route** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type children: keyid
    :param children: Keyword argument tuple.

    :type keyid: long
    :param keyid: **children** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type layer2: layer2id
    :param layer2: Keyword argument tuple.

    :type layer2id: long
    :param layer2id: **layer2** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.opstest_state.routes.route', u'route'), ('pybind.slxos.v16r_1_00b.opstest_state.routes.route.children', u'children')]
    bindings_list = [('pybind.slxos.v16r_1_00b.opstest_state.routes.route.children.layer2', 'pybind.slxos.v16r_1_00b.brocade_opstest', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'destPrefix', 'extra_keyval': ''}, {'keyval': 'keyid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'layer2', 'keyval': 'layer2id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'grandparentKey'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route=route, children=children, layer2=layer2)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route=route, children=children, layer2=layer2)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def opstest_state_routes_route_children_layer2_parentkeyid_delete(self, route=None, children=None, layer2=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route: destPrefix
    :param route: Keyword argument tuple.

    :type destPrefix: unicode
    :param destPrefix: **route** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type children: keyid
    :param children: Keyword argument tuple.

    :type keyid: long
    :param keyid: **children** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type layer2: layer2id
    :param layer2: Keyword argument tuple.

    :type layer2id: long
    :param layer2id: **layer2** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.opstest_state.routes.route', u'route'), ('pybind.slxos.v16r_1_00b.opstest_state.routes.route.children', u'children')]
    bindings_list = [('pybind.slxos.v16r_1_00b.opstest_state.routes.route.children.layer2', 'pybind.slxos.v16r_1_00b.brocade_opstest', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'destPrefix', 'extra_keyval': ''}, {'keyval': 'keyid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'layer2', 'keyval': 'layer2id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'parentkeyid'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route=route, children=children, layer2=layer2)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route=route, children=children, layer2=layer2)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def opstest_state_routes_route_children_parentkey_delete(self, route=None, children=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route: destPrefix
    :param route: Keyword argument tuple.

    :type destPrefix: unicode
    :param destPrefix: **route** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type children: keyid
    :param children: Keyword argument tuple.

    :type keyid: long
    :param keyid: **children** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.opstest_state.routes.route', u'route')]
    bindings_list = [('pybind.slxos.v16r_1_00b.opstest_state.routes.route.children', 'pybind.slxos.v16r_1_00b.brocade_opstest', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'destPrefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'children', 'keyval': 'keyid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'parentKey'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route=route, children=children)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route=route, children=children)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def opstest_state_routes_route_entrymultipathindex_delete(self, route=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type route: destPrefix
    :param route: Keyword argument tuple.

    :type destPrefix: unicode
    :param destPrefix: **route** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.opstest_state.routes.route', 'pybind.slxos.v16r_1_00b.brocade_opstest', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'route', 'keyval': 'destPrefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'entryMultipathIndex'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route=route)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route=route)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def opstest_state_routes_route_gateway_delete(self, route=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type route: destPrefix
    :param route: Keyword argument tuple.

    :type destPrefix: unicode
    :param destPrefix: **route** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.opstest_state.routes.route', 'pybind.slxos.v16r_1_00b.brocade_opstest', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'route', 'keyval': 'destPrefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'gateway'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route=route)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route=route)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def opstest_state_routes_route_metric_delete(self, route=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type route: destPrefix
    :param route: Keyword argument tuple.

    :type destPrefix: unicode
    :param destPrefix: **route** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.opstest_state.routes.route', 'pybind.slxos.v16r_1_00b.brocade_opstest', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'route', 'keyval': 'destPrefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route=route)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route=route)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def opstest_state_routes_route_outinterfacename_delete(self, route=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type route: destPrefix
    :param route: Keyword argument tuple.

    :type destPrefix: unicode
    :param destPrefix: **route** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.opstest_state.routes.route', 'pybind.slxos.v16r_1_00b.brocade_opstest', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'route', 'keyval': 'destPrefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'outInterfaceName'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route=route)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route=route)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def opstest_state_routes_route_outlabel_delete(self, route=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type route: destPrefix
    :param route: Keyword argument tuple.

    :type destPrefix: unicode
    :param destPrefix: **route** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.opstest_state.routes.route', 'pybind.slxos.v16r_1_00b.brocade_opstest', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'route', 'keyval': 'destPrefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'outLabel'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route=route)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route=route)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def opstest_state_routes_route_prefixlength_delete(self, route=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type route: destPrefix
    :param route: Keyword argument tuple.

    :type destPrefix: unicode
    :param destPrefix: **route** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.opstest_state.routes.route', 'pybind.slxos.v16r_1_00b.brocade_opstest', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'route', 'keyval': 'destPrefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'prefixLength'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route=route)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route=route)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def opstest_state_routes_route_protocol_delete(self, route=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type route: destPrefix
    :param route: Keyword argument tuple.

    :type destPrefix: unicode
    :param destPrefix: **route** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.opstest_state.routes.route', 'pybind.slxos.v16r_1_00b.brocade_opstest', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'route', 'keyval': 'destPrefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'protocol'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route=route)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route=route)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def opstest_state_routes_route_usecount_delete(self, route=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type route: destPrefix
    :param route: Keyword argument tuple.

    :type destPrefix: unicode
    :param destPrefix: **route** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.opstest_state.routes.route', 'pybind.slxos.v16r_1_00b.brocade_opstest', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'route', 'keyval': 'destPrefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'useCount'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route=route)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route=route)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def opstest_state_routes_route_vifindex_delete(self, route=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type route: destPrefix
    :param route: Keyword argument tuple.

    :type destPrefix: unicode
    :param destPrefix: **route** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.opstest_state.routes.route', 'pybind.slxos.v16r_1_00b.brocade_opstest', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'route', 'keyval': 'destPrefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vifIndex'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route=route)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route=route)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def opstest_state_summary_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.opstest_state.summary', 'pybind.slxos.v16r_1_00b.brocade_opstest', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def opstest_state_summary_autobw_templates_configured_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.opstest_state.summary', 'pybind.slxos.v16r_1_00b.brocade_opstest', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'autobw_templates_configured'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def opstest_state_summary_autobw_templates_supported_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.opstest_state.summary', 'pybind.slxos.v16r_1_00b.brocade_opstest', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'autobw_templates_supported'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def opstest_state_summary_backup_lsps_up_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.opstest_state.summary', 'pybind.slxos.v16r_1_00b.brocade_opstest', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'backup_lsps_up'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def opstest_state_summary_bypass_lsps_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.opstest_state.summary', 'pybind.slxos.v16r_1_00b.brocade_opstest', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bypass_lsps'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def opstest_state_summary_bypass_lspsenabled_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.opstest_state.summary', 'pybind.slxos.v16r_1_00b.brocade_opstest', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bypass_lspsEnabled'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def opstest_state_summary_bypass_lspsup_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.opstest_state.summary', 'pybind.slxos.v16r_1_00b.brocade_opstest', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bypass_lspsUp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def opstest_state_summary_cross_connects_allocated_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.opstest_state.summary', 'pybind.slxos.v16r_1_00b.brocade_opstest', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cross_connects_allocated'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def opstest_state_summary_cross_connects_supported_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.opstest_state.summary', 'pybind.slxos.v16r_1_00b.brocade_opstest', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cross_connects_supported'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def opstest_state_summary_cspf_groups_configured_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.opstest_state.summary', 'pybind.slxos.v16r_1_00b.brocade_opstest', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cspf_groups_configured'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def opstest_state_summary_detour_lsps_up_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.opstest_state.summary', 'pybind.slxos.v16r_1_00b.brocade_opstest', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'detour_lsps_up'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def opstest_state_summary_ldp_lsps_operational_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.opstest_state.summary', 'pybind.slxos.v16r_1_00b.brocade_opstest', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ldp_lsps_operational'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def opstest_state_summary_lsps_configured_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.opstest_state.summary', 'pybind.slxos.v16r_1_00b.brocade_opstest', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lsps_configured'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def opstest_state_summary_lsps_enabled_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.opstest_state.summary', 'pybind.slxos.v16r_1_00b.brocade_opstest', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lsps_enabled'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def opstest_state_summary_lsps_operational_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.opstest_state.summary', 'pybind.slxos.v16r_1_00b.brocade_opstest', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lsps_operational'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def opstest_state_summary_paths_configured_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.opstest_state.summary', 'pybind.slxos.v16r_1_00b.brocade_opstest', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'paths_configured'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def opstest_state_summary_times_enabled_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.opstest_state.summary', 'pybind.slxos.v16r_1_00b.brocade_opstest', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'times_enabled'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def opstest_state_summary_transit_lsps_configured_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.opstest_state.summary', 'pybind.slxos.v16r_1_00b.brocade_opstest', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'transit_lsps_configured'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def opstest_state_summary_transit_lsps_enabled_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.opstest_state.summary', 'pybind.slxos.v16r_1_00b.brocade_opstest', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'transit_lsps_enabled'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def opstest_state_summary_transit_lsps_operational_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.opstest_state.summary', 'pybind.slxos.v16r_1_00b.brocade_opstest', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'transit_lsps_operational'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def opstest_state_summary_tunnels_allocated_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.opstest_state.summary', 'pybind.slxos.v16r_1_00b.brocade_opstest', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tunnels_allocated'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def opstest_state_summary_tunnels_supported_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.opstest_state.summary', 'pybind.slxos.v16r_1_00b.brocade_opstest', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tunnels_supported'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.overlay', 'pybind.slxos.v16r_1_00b.brocade_vxlan_visibility', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_access_list_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.overlay.access_list', 'pybind.slxos.v16r_1_00b.brocade_vxlan_visibility', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_access_list_type_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.overlay.access_list.type', 'pybind.slxos.v16r_1_00b.brocade_vxlan_visibility', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_access_list_type_vxlan_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.overlay.access_list.type.vxlan', 'pybind.slxos.v16r_1_00b.brocade_vxlan_visibility', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_access_list_type_vxlan_extended_delete(self, extended=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type extended: ext_user_acl_name
    :param extended: Keyword argument tuple.

    :type ext_user_acl_name: unicode
    :param ext_user_acl_name: **extended** tuple argument:  Access List Name (Max 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.overlay.access_list.type.vxlan.extended', 'pybind.slxos.v16r_1_00b.brocade_vxlan_visibility', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended', 'keyval': 'ext_user_acl_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_access_list_type_vxlan_extended_seq_delete(self, extended=None, ext_seq=None, ext_permit_deny=None, ext_dst_vtep_ip=None, ext_dst_vtep_ip_any=None, ext_src_vtep_ip=None, ext_src_vtep_ip_any=None, ext_vni=None, ext_vni_any=None, ext_vni_mask=None, ext_count=None, ext_mirror=None, ext_redirect=None, ext_sflow=None, native=None, tag=None, dst_ip_host=None, dst_ip=None, dst_ip_any=None, src_ip_host=None, src_ip=None, src_ip_any=None, dst_port=None, dst_port_any=None, src_port=None, src_port_any=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: ext_user_acl_name
    :param extended: Keyword argument tuple.

    :type ext_user_acl_name: unicode
    :param ext_user_acl_name: **extended** tuple argument:  Access List Name (Max 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type ext_seq: ext_seq_num, ext_permit_deny, ext_dst_vtep_ip, ext_dst_vtep_ip_any, ext_src_vtep_ip, ext_src_vtep_ip_any, ext_vni, ext_vni_any, ext_vni_mask, ext_count, ext_mirror, ext_redirect, ext_sflow, native, tag, dst_ip_host, dst_ip, dst_ip_any, src_ip_host, src_ip, src_ip_any, dst_port, dst_port_any, src_port, src_port_any
    :param ext_seq: Keyword argument tuple.

    :type ext_seq_num: long
    :param ext_seq_num: **ext_seq** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ext_permit_deny: unicode
    :param ext_permit_deny: **ext_seq** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type ext_dst_vtep_ip: unicode
    :param ext_dst_vtep_ip: **ext_seq** tuple argument:  dst vtep ip address: A.B.C.D

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ext_dst_vtep_ip_any: YANGBool
    :param ext_dst_vtep_ip_any: **ext_seq** tuple argument:  dst vtep ip address: any

    :type ext_src_vtep_ip: unicode
    :param ext_src_vtep_ip: **ext_seq** tuple argument:  src vtep ip address: A.B.C.D

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ext_src_vtep_ip_any: YANGBool
    :param ext_src_vtep_ip_any: **ext_seq** tuple argument:  src vtep ip address: any

    :type ext_vni: long
    :param ext_vni: **ext_seq** tuple argument:  vni number: 1..16777215

        * range restriction: ::

            ['0..4294967295']

    :type ext_vni_any: YANGBool
    :param ext_vni_any: **ext_seq** tuple argument:  vni any

    :type ext_vni_mask: unicode
    :param ext_vni_mask: **ext_seq** tuple argument:  vni mask:Hexadecimal 0..FFFFFF

        * pattern restriction: ::

            '0|[1-9a-fA-F][0-9a-fA-F]{0,5}'

    :type ext_count: YANGBool
    :param ext_count: **ext_seq** tuple argument:  count

    :type ext_mirror: unicode
    :param ext_mirror: **ext_seq** tuple argument:  mirror <interface-name>

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type ext_redirect: unicode
    :param ext_redirect: **ext_seq** tuple argument:  redirect <interface-name>

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type ext_sflow: YANGBool
    :param ext_sflow: **ext_seq** tuple argument:  sflow

    :type native: YANGBool
    :param native: **ext_seq** tuple argument.

    :type tag: unicode
    :param tag: **ext_seq** tuple argument.

        * enumeration restriction: ::

            ['none', 'single', 'any']

    :type dst_ip_host: unicode
    :param dst_ip_host: **ext_seq** tuple argument:  dst ip host: A.B.C.D

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type dst_ip: unicode
    :param dst_ip: **ext_seq** tuple argument:  dst ip: A.B.C.D/mask

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]'
            '|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0'
            '-4][0-9]|25[0-5])/(([1-9])|([1-2][0-9])|(3[0-1])'
            ')'

    :type dst_ip_any: YANGBool
    :param dst_ip_any: **ext_seq** tuple argument:  dst ip address: any

    :type src_ip_host: unicode
    :param src_ip_host: **ext_seq** tuple argument:  src ip host: A.B.C.D

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip: unicode
    :param src_ip: **ext_seq** tuple argument:  src ip: A.B.C.D/mask

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]'
            '|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0'
            '-4][0-9]|25[0-5])/(([1-9])|([1-2][0-9])|(3[0-1])'
            ')'

    :type src_ip_any: YANGBool
    :param src_ip_any: **ext_seq** tuple argument:  src ip address: any

    :type dst_port: long
    :param dst_port: **ext_seq** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type dst_port_any: YANGBool
    :param dst_port_any: **ext_seq** tuple argument:  dst-port-any

    :type src_port: long
    :param src_port: **ext_seq** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type src_port_any: YANGBool
    :param src_port_any: **ext_seq** tuple argument:  src-port-any

    **Instance Argument(s)**:

    :type ext_permit_deny: unicode
    :param ext_permit_deny: Keyword argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type ext_dst_vtep_ip: unicode
    :param ext_dst_vtep_ip: dst vtep ip address: A.B.C.D. Choice keyword argument (Only one choice argument allowed per API invocation).

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ext_dst_vtep_ip_any: YANGBool
    :param ext_dst_vtep_ip_any: dst vtep ip address: any. Choice keyword argument (Only one choice argument allowed per API invocation).

    :type ext_src_vtep_ip: unicode
    :param ext_src_vtep_ip: src vtep ip address: A.B.C.D. Choice keyword argument (Only one choice argument allowed per API invocation).

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ext_src_vtep_ip_any: YANGBool
    :param ext_src_vtep_ip_any: src vtep ip address: any. Choice keyword argument (Only one choice argument allowed per API invocation).

    :type ext_vni: long
    :param ext_vni: vni number: 1..16777215. Choice keyword argument (Only one choice argument allowed per API invocation).

        * range restriction: ::

            ['0..4294967295']

    :type ext_vni_any: YANGBool
    :param ext_vni_any: vni any. Choice keyword argument (Only one choice argument allowed per API invocation).

    :type ext_vni_mask: unicode
    :param ext_vni_mask: vni mask:Hexadecimal 0..FFFFFF

        * pattern restriction: ::

            '0|[1-9a-fA-F][0-9a-fA-F]{0,5}'

    :type ext_count: YANGBool
    :param ext_count: count

    :type ext_mirror: unicode
    :param ext_mirror: mirror <interface-name>

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type ext_redirect: unicode
    :param ext_redirect: redirect <interface-name>

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type ext_sflow: YANGBool
    :param ext_sflow: sflow

    :type native: YANGBool
    :param native: Keyword argument.

    :type tag: unicode
    :param tag: Keyword argument.

        * enumeration restriction: ::

            ['none', 'single', 'any']

    :type dst_ip_host: unicode
    :param dst_ip_host: dst ip host: A.B.C.D. Choice keyword argument (Only one choice argument allowed per API invocation).

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type dst_ip: unicode
    :param dst_ip: dst ip: A.B.C.D/mask. Choice keyword argument (Only one choice argument allowed per API invocation).

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]'
            '|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0'
            '-4][0-9]|25[0-5])/(([1-9])|([1-2][0-9])|(3[0-1])'
            ')'

    :type dst_ip_any: YANGBool
    :param dst_ip_any: dst ip address: any. Choice keyword argument (Only one choice argument allowed per API invocation).

    :type src_ip_host: unicode
    :param src_ip_host: src ip host: A.B.C.D. Choice keyword argument (Only one choice argument allowed per API invocation).

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip: unicode
    :param src_ip: src ip: A.B.C.D/mask. Choice keyword argument (Only one choice argument allowed per API invocation).

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]'
            '|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0'
            '-4][0-9]|25[0-5])/(([1-9])|([1-2][0-9])|(3[0-1])'
            ')'

    :type src_ip_any: YANGBool
    :param src_ip_any: src ip address: any. Choice keyword argument (Only one choice argument allowed per API invocation).

    :type dst_port: long
    :param dst_port: Choice keyword argument (Only one choice argument allowed per API invocation).

        * range restriction: ::

            ['0..4294967295']

    :type dst_port_any: YANGBool
    :param dst_port_any: dst-port-any. Choice keyword argument (Only one choice argument allowed per API invocation).

    :type src_port: long
    :param src_port: Choice keyword argument (Only one choice argument allowed per API invocation).

        * range restriction: ::

            ['0..4294967295']

    :type src_port_any: YANGBool
    :param src_port_any: src-port-any. Choice keyword argument (Only one choice argument allowed per API invocation).

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.overlay.access_list.type.vxlan.extended', u'extended')]
    bindings_list = [('pybind.slxos.v16r_1_00b.overlay.access_list.type.vxlan.extended.ext_seq', 'pybind.slxos.v16r_1_00b.brocade_vxlan_visibility', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ext_user_acl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ext_seq', 'keyval': 'ext_seq_num', 'extra_keyval': 'ext_seq_num, ext_permit_deny, ext_dst_vtep_ip, ext_dst_vtep_ip_any, ext_src_vtep_ip, ext_src_vtep_ip_any, ext_vni, ext_vni_any, ext_vni_mask, ext_count, ext_mirror, ext_redirect, ext_sflow, native, tag, dst_ip_host, dst_ip, dst_ip_any, src_ip_host, src_ip, src_ip_any, dst_port, dst_port_any, src_port, src_port_any'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v16r_1_00b.overlay.access_list.type.vxlan.extended.ext_seq': [u'ext_dst_vtep_ip_any', u'ext_dst_vtep_ip', u'ext_src_vtep_ip_any', u'ext_src_vtep_ip', u'ext_vni', u'ext_vni_any', u'dst_ip_host', u'dst_ip_any', u'dst_ip', u'src_ip_host', u'src_ip', u'src_ip_any', u'dst_port_any', u'dst_port', u'src_port_any', u'src_port']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, ext_seq=ext_seq, ext_permit_deny=ext_permit_deny, ext_dst_vtep_ip=ext_dst_vtep_ip, ext_dst_vtep_ip_any=ext_dst_vtep_ip_any, ext_src_vtep_ip=ext_src_vtep_ip, ext_src_vtep_ip_any=ext_src_vtep_ip_any, ext_vni=ext_vni, ext_vni_any=ext_vni_any, ext_vni_mask=ext_vni_mask, ext_count=ext_count, ext_mirror=ext_mirror, ext_redirect=ext_redirect, ext_sflow=ext_sflow, native=native, tag=tag, dst_ip_host=dst_ip_host, dst_ip=dst_ip, dst_ip_any=dst_ip_any, src_ip_host=src_ip_host, src_ip=src_ip, src_ip_any=src_ip_any, dst_port=dst_port, dst_port_any=dst_port_any, src_port=src_port, src_port_any=src_port_any)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, ext_seq=ext_seq, ext_permit_deny=ext_permit_deny, ext_dst_vtep_ip=ext_dst_vtep_ip, ext_dst_vtep_ip_any=ext_dst_vtep_ip_any, ext_src_vtep_ip=ext_src_vtep_ip, ext_src_vtep_ip_any=ext_src_vtep_ip_any, ext_vni=ext_vni, ext_vni_any=ext_vni_any, ext_vni_mask=ext_vni_mask, ext_count=ext_count, ext_mirror=ext_mirror, ext_redirect=ext_redirect, ext_sflow=ext_sflow, native=native, tag=tag, dst_ip_host=dst_ip_host, dst_ip=dst_ip, dst_ip_any=dst_ip_any, src_ip_host=src_ip_host, src_ip=src_ip, src_ip_any=src_ip_any, dst_port=dst_port, dst_port_any=dst_port_any, src_port=src_port, src_port_any=src_port_any)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_access_list_type_vxlan_extended_seq_count_delete(self, extended=None, ext_seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: ext_user_acl_name
    :param extended: Keyword argument tuple.

    :type ext_user_acl_name: unicode
    :param ext_user_acl_name: **extended** tuple argument:  Access List Name (Max 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type ext_seq: ext_seq_num
    :param ext_seq: Keyword argument tuple.

    :type ext_seq_num: long
    :param ext_seq_num: **ext_seq** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.overlay.access_list.type.vxlan.extended', u'extended')]
    bindings_list = [('pybind.slxos.v16r_1_00b.overlay.access_list.type.vxlan.extended.ext_seq', 'pybind.slxos.v16r_1_00b.brocade_vxlan_visibility', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ext_user_acl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ext_seq', 'keyval': 'ext_seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, ext_seq=ext_seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, ext_seq=ext_seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_access_list_type_vxlan_extended_seq_dst_ip_delete(self, extended=None, ext_seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: ext_user_acl_name
    :param extended: Keyword argument tuple.

    :type ext_user_acl_name: unicode
    :param ext_user_acl_name: **extended** tuple argument:  Access List Name (Max 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type ext_seq: ext_seq_num
    :param ext_seq: Keyword argument tuple.

    :type ext_seq_num: long
    :param ext_seq_num: **ext_seq** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.overlay.access_list.type.vxlan.extended', u'extended')]
    bindings_list = [('pybind.slxos.v16r_1_00b.overlay.access_list.type.vxlan.extended.ext_seq', 'pybind.slxos.v16r_1_00b.brocade_vxlan_visibility', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ext_user_acl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ext_seq', 'keyval': 'ext_seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dst-ip'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, ext_seq=ext_seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, ext_seq=ext_seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_access_list_type_vxlan_extended_seq_dst_ip_any_delete(self, extended=None, ext_seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: ext_user_acl_name
    :param extended: Keyword argument tuple.

    :type ext_user_acl_name: unicode
    :param ext_user_acl_name: **extended** tuple argument:  Access List Name (Max 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type ext_seq: ext_seq_num
    :param ext_seq: Keyword argument tuple.

    :type ext_seq_num: long
    :param ext_seq_num: **ext_seq** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.overlay.access_list.type.vxlan.extended', u'extended')]
    bindings_list = [('pybind.slxos.v16r_1_00b.overlay.access_list.type.vxlan.extended.ext_seq', 'pybind.slxos.v16r_1_00b.brocade_vxlan_visibility', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ext_user_acl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ext_seq', 'keyval': 'ext_seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dst-ip-any'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, ext_seq=ext_seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, ext_seq=ext_seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_access_list_type_vxlan_extended_seq_dst_ip_host_delete(self, extended=None, ext_seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: ext_user_acl_name
    :param extended: Keyword argument tuple.

    :type ext_user_acl_name: unicode
    :param ext_user_acl_name: **extended** tuple argument:  Access List Name (Max 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type ext_seq: ext_seq_num
    :param ext_seq: Keyword argument tuple.

    :type ext_seq_num: long
    :param ext_seq_num: **ext_seq** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.overlay.access_list.type.vxlan.extended', u'extended')]
    bindings_list = [('pybind.slxos.v16r_1_00b.overlay.access_list.type.vxlan.extended.ext_seq', 'pybind.slxos.v16r_1_00b.brocade_vxlan_visibility', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ext_user_acl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ext_seq', 'keyval': 'ext_seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dst-ip-host'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, ext_seq=ext_seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, ext_seq=ext_seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_access_list_type_vxlan_extended_seq_dst_port_delete(self, extended=None, ext_seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: ext_user_acl_name
    :param extended: Keyword argument tuple.

    :type ext_user_acl_name: unicode
    :param ext_user_acl_name: **extended** tuple argument:  Access List Name (Max 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type ext_seq: ext_seq_num
    :param ext_seq: Keyword argument tuple.

    :type ext_seq_num: long
    :param ext_seq_num: **ext_seq** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.overlay.access_list.type.vxlan.extended', u'extended')]
    bindings_list = [('pybind.slxos.v16r_1_00b.overlay.access_list.type.vxlan.extended.ext_seq', 'pybind.slxos.v16r_1_00b.brocade_vxlan_visibility', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ext_user_acl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ext_seq', 'keyval': 'ext_seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dst-port'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, ext_seq=ext_seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, ext_seq=ext_seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_access_list_type_vxlan_extended_seq_dst_port_any_delete(self, extended=None, ext_seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: ext_user_acl_name
    :param extended: Keyword argument tuple.

    :type ext_user_acl_name: unicode
    :param ext_user_acl_name: **extended** tuple argument:  Access List Name (Max 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type ext_seq: ext_seq_num
    :param ext_seq: Keyword argument tuple.

    :type ext_seq_num: long
    :param ext_seq_num: **ext_seq** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.overlay.access_list.type.vxlan.extended', u'extended')]
    bindings_list = [('pybind.slxos.v16r_1_00b.overlay.access_list.type.vxlan.extended.ext_seq', 'pybind.slxos.v16r_1_00b.brocade_vxlan_visibility', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ext_user_acl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ext_seq', 'keyval': 'ext_seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dst-port-any'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, ext_seq=ext_seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, ext_seq=ext_seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_access_list_type_vxlan_extended_seq_dst_vtep_ip_any_delete(self, extended=None, ext_seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: ext_user_acl_name
    :param extended: Keyword argument tuple.

    :type ext_user_acl_name: unicode
    :param ext_user_acl_name: **extended** tuple argument:  Access List Name (Max 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type ext_seq: ext_seq_num
    :param ext_seq: Keyword argument tuple.

    :type ext_seq_num: long
    :param ext_seq_num: **ext_seq** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.overlay.access_list.type.vxlan.extended', u'extended')]
    bindings_list = [('pybind.slxos.v16r_1_00b.overlay.access_list.type.vxlan.extended.ext_seq', 'pybind.slxos.v16r_1_00b.brocade_vxlan_visibility', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ext_user_acl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ext_seq', 'keyval': 'ext_seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dst-vtep-ip-any'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, ext_seq=ext_seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, ext_seq=ext_seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_access_list_type_vxlan_extended_seq_dst_vtep_ip_host_delete(self, extended=None, ext_seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: ext_user_acl_name
    :param extended: Keyword argument tuple.

    :type ext_user_acl_name: unicode
    :param ext_user_acl_name: **extended** tuple argument:  Access List Name (Max 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type ext_seq: ext_seq_num
    :param ext_seq: Keyword argument tuple.

    :type ext_seq_num: long
    :param ext_seq_num: **ext_seq** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.overlay.access_list.type.vxlan.extended', u'extended')]
    bindings_list = [('pybind.slxos.v16r_1_00b.overlay.access_list.type.vxlan.extended.ext_seq', 'pybind.slxos.v16r_1_00b.brocade_vxlan_visibility', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ext_user_acl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ext_seq', 'keyval': 'ext_seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dst-vtep-ip-host'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, ext_seq=ext_seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, ext_seq=ext_seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_access_list_type_vxlan_extended_seq_ext_permit_deny_delete(self, extended=None, ext_seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: ext_user_acl_name
    :param extended: Keyword argument tuple.

    :type ext_user_acl_name: unicode
    :param ext_user_acl_name: **extended** tuple argument:  Access List Name (Max 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type ext_seq: ext_seq_num
    :param ext_seq: Keyword argument tuple.

    :type ext_seq_num: long
    :param ext_seq_num: **ext_seq** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.overlay.access_list.type.vxlan.extended', u'extended')]
    bindings_list = [('pybind.slxos.v16r_1_00b.overlay.access_list.type.vxlan.extended.ext_seq', 'pybind.slxos.v16r_1_00b.brocade_vxlan_visibility', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ext_user_acl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ext_seq', 'keyval': 'ext_seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ext-permit-deny'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, ext_seq=ext_seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, ext_seq=ext_seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_access_list_type_vxlan_extended_seq_mirror_delete(self, extended=None, ext_seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: ext_user_acl_name
    :param extended: Keyword argument tuple.

    :type ext_user_acl_name: unicode
    :param ext_user_acl_name: **extended** tuple argument:  Access List Name (Max 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type ext_seq: ext_seq_num
    :param ext_seq: Keyword argument tuple.

    :type ext_seq_num: long
    :param ext_seq_num: **ext_seq** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.overlay.access_list.type.vxlan.extended', u'extended')]
    bindings_list = [('pybind.slxos.v16r_1_00b.overlay.access_list.type.vxlan.extended.ext_seq', 'pybind.slxos.v16r_1_00b.brocade_vxlan_visibility', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ext_user_acl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ext_seq', 'keyval': 'ext_seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mirror'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, ext_seq=ext_seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, ext_seq=ext_seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_access_list_type_vxlan_extended_seq_native_delete(self, extended=None, ext_seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: ext_user_acl_name
    :param extended: Keyword argument tuple.

    :type ext_user_acl_name: unicode
    :param ext_user_acl_name: **extended** tuple argument:  Access List Name (Max 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type ext_seq: ext_seq_num
    :param ext_seq: Keyword argument tuple.

    :type ext_seq_num: long
    :param ext_seq_num: **ext_seq** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.overlay.access_list.type.vxlan.extended', u'extended')]
    bindings_list = [('pybind.slxos.v16r_1_00b.overlay.access_list.type.vxlan.extended.ext_seq', 'pybind.slxos.v16r_1_00b.brocade_vxlan_visibility', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ext_user_acl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ext_seq', 'keyval': 'ext_seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'native'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, ext_seq=ext_seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, ext_seq=ext_seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_access_list_type_vxlan_extended_seq_redirect_delete(self, extended=None, ext_seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: ext_user_acl_name
    :param extended: Keyword argument tuple.

    :type ext_user_acl_name: unicode
    :param ext_user_acl_name: **extended** tuple argument:  Access List Name (Max 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type ext_seq: ext_seq_num
    :param ext_seq: Keyword argument tuple.

    :type ext_seq_num: long
    :param ext_seq_num: **ext_seq** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.overlay.access_list.type.vxlan.extended', u'extended')]
    bindings_list = [('pybind.slxos.v16r_1_00b.overlay.access_list.type.vxlan.extended.ext_seq', 'pybind.slxos.v16r_1_00b.brocade_vxlan_visibility', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ext_user_acl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ext_seq', 'keyval': 'ext_seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redirect'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, ext_seq=ext_seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, ext_seq=ext_seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_access_list_type_vxlan_extended_seq_sflow_delete(self, extended=None, ext_seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: ext_user_acl_name
    :param extended: Keyword argument tuple.

    :type ext_user_acl_name: unicode
    :param ext_user_acl_name: **extended** tuple argument:  Access List Name (Max 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type ext_seq: ext_seq_num
    :param ext_seq: Keyword argument tuple.

    :type ext_seq_num: long
    :param ext_seq_num: **ext_seq** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.overlay.access_list.type.vxlan.extended', u'extended')]
    bindings_list = [('pybind.slxos.v16r_1_00b.overlay.access_list.type.vxlan.extended.ext_seq', 'pybind.slxos.v16r_1_00b.brocade_vxlan_visibility', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ext_user_acl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ext_seq', 'keyval': 'ext_seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'sflow'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, ext_seq=ext_seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, ext_seq=ext_seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_access_list_type_vxlan_extended_seq_src_ip_delete(self, extended=None, ext_seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: ext_user_acl_name
    :param extended: Keyword argument tuple.

    :type ext_user_acl_name: unicode
    :param ext_user_acl_name: **extended** tuple argument:  Access List Name (Max 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type ext_seq: ext_seq_num
    :param ext_seq: Keyword argument tuple.

    :type ext_seq_num: long
    :param ext_seq_num: **ext_seq** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.overlay.access_list.type.vxlan.extended', u'extended')]
    bindings_list = [('pybind.slxos.v16r_1_00b.overlay.access_list.type.vxlan.extended.ext_seq', 'pybind.slxos.v16r_1_00b.brocade_vxlan_visibility', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ext_user_acl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ext_seq', 'keyval': 'ext_seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'src-ip'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, ext_seq=ext_seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, ext_seq=ext_seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_access_list_type_vxlan_extended_seq_src_ip_any_delete(self, extended=None, ext_seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: ext_user_acl_name
    :param extended: Keyword argument tuple.

    :type ext_user_acl_name: unicode
    :param ext_user_acl_name: **extended** tuple argument:  Access List Name (Max 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type ext_seq: ext_seq_num
    :param ext_seq: Keyword argument tuple.

    :type ext_seq_num: long
    :param ext_seq_num: **ext_seq** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.overlay.access_list.type.vxlan.extended', u'extended')]
    bindings_list = [('pybind.slxos.v16r_1_00b.overlay.access_list.type.vxlan.extended.ext_seq', 'pybind.slxos.v16r_1_00b.brocade_vxlan_visibility', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ext_user_acl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ext_seq', 'keyval': 'ext_seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'src-ip-any'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, ext_seq=ext_seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, ext_seq=ext_seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_access_list_type_vxlan_extended_seq_src_ip_host_delete(self, extended=None, ext_seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: ext_user_acl_name
    :param extended: Keyword argument tuple.

    :type ext_user_acl_name: unicode
    :param ext_user_acl_name: **extended** tuple argument:  Access List Name (Max 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type ext_seq: ext_seq_num
    :param ext_seq: Keyword argument tuple.

    :type ext_seq_num: long
    :param ext_seq_num: **ext_seq** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.overlay.access_list.type.vxlan.extended', u'extended')]
    bindings_list = [('pybind.slxos.v16r_1_00b.overlay.access_list.type.vxlan.extended.ext_seq', 'pybind.slxos.v16r_1_00b.brocade_vxlan_visibility', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ext_user_acl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ext_seq', 'keyval': 'ext_seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'src-ip-host'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, ext_seq=ext_seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, ext_seq=ext_seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_access_list_type_vxlan_extended_seq_src_port_delete(self, extended=None, ext_seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: ext_user_acl_name
    :param extended: Keyword argument tuple.

    :type ext_user_acl_name: unicode
    :param ext_user_acl_name: **extended** tuple argument:  Access List Name (Max 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type ext_seq: ext_seq_num
    :param ext_seq: Keyword argument tuple.

    :type ext_seq_num: long
    :param ext_seq_num: **ext_seq** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.overlay.access_list.type.vxlan.extended', u'extended')]
    bindings_list = [('pybind.slxos.v16r_1_00b.overlay.access_list.type.vxlan.extended.ext_seq', 'pybind.slxos.v16r_1_00b.brocade_vxlan_visibility', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ext_user_acl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ext_seq', 'keyval': 'ext_seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'src-port'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, ext_seq=ext_seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, ext_seq=ext_seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_access_list_type_vxlan_extended_seq_src_port_any_delete(self, extended=None, ext_seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: ext_user_acl_name
    :param extended: Keyword argument tuple.

    :type ext_user_acl_name: unicode
    :param ext_user_acl_name: **extended** tuple argument:  Access List Name (Max 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type ext_seq: ext_seq_num
    :param ext_seq: Keyword argument tuple.

    :type ext_seq_num: long
    :param ext_seq_num: **ext_seq** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.overlay.access_list.type.vxlan.extended', u'extended')]
    bindings_list = [('pybind.slxos.v16r_1_00b.overlay.access_list.type.vxlan.extended.ext_seq', 'pybind.slxos.v16r_1_00b.brocade_vxlan_visibility', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ext_user_acl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ext_seq', 'keyval': 'ext_seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'src-port-any'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, ext_seq=ext_seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, ext_seq=ext_seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_access_list_type_vxlan_extended_seq_src_vtep_ip_any_delete(self, extended=None, ext_seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: ext_user_acl_name
    :param extended: Keyword argument tuple.

    :type ext_user_acl_name: unicode
    :param ext_user_acl_name: **extended** tuple argument:  Access List Name (Max 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type ext_seq: ext_seq_num
    :param ext_seq: Keyword argument tuple.

    :type ext_seq_num: long
    :param ext_seq_num: **ext_seq** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.overlay.access_list.type.vxlan.extended', u'extended')]
    bindings_list = [('pybind.slxos.v16r_1_00b.overlay.access_list.type.vxlan.extended.ext_seq', 'pybind.slxos.v16r_1_00b.brocade_vxlan_visibility', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ext_user_acl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ext_seq', 'keyval': 'ext_seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'src-vtep-ip-any'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, ext_seq=ext_seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, ext_seq=ext_seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_access_list_type_vxlan_extended_seq_src_vtep_ip_host_delete(self, extended=None, ext_seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: ext_user_acl_name
    :param extended: Keyword argument tuple.

    :type ext_user_acl_name: unicode
    :param ext_user_acl_name: **extended** tuple argument:  Access List Name (Max 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type ext_seq: ext_seq_num
    :param ext_seq: Keyword argument tuple.

    :type ext_seq_num: long
    :param ext_seq_num: **ext_seq** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.overlay.access_list.type.vxlan.extended', u'extended')]
    bindings_list = [('pybind.slxos.v16r_1_00b.overlay.access_list.type.vxlan.extended.ext_seq', 'pybind.slxos.v16r_1_00b.brocade_vxlan_visibility', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ext_user_acl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ext_seq', 'keyval': 'ext_seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'src-vtep-ip-host'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, ext_seq=ext_seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, ext_seq=ext_seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_access_list_type_vxlan_extended_seq_tag_delete(self, extended=None, ext_seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: ext_user_acl_name
    :param extended: Keyword argument tuple.

    :type ext_user_acl_name: unicode
    :param ext_user_acl_name: **extended** tuple argument:  Access List Name (Max 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type ext_seq: ext_seq_num
    :param ext_seq: Keyword argument tuple.

    :type ext_seq_num: long
    :param ext_seq_num: **ext_seq** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.overlay.access_list.type.vxlan.extended', u'extended')]
    bindings_list = [('pybind.slxos.v16r_1_00b.overlay.access_list.type.vxlan.extended.ext_seq', 'pybind.slxos.v16r_1_00b.brocade_vxlan_visibility', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ext_user_acl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ext_seq', 'keyval': 'ext_seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, ext_seq=ext_seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, ext_seq=ext_seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_access_list_type_vxlan_extended_seq_vni_delete(self, extended=None, ext_seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: ext_user_acl_name
    :param extended: Keyword argument tuple.

    :type ext_user_acl_name: unicode
    :param ext_user_acl_name: **extended** tuple argument:  Access List Name (Max 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type ext_seq: ext_seq_num
    :param ext_seq: Keyword argument tuple.

    :type ext_seq_num: long
    :param ext_seq_num: **ext_seq** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.overlay.access_list.type.vxlan.extended', u'extended')]
    bindings_list = [('pybind.slxos.v16r_1_00b.overlay.access_list.type.vxlan.extended.ext_seq', 'pybind.slxos.v16r_1_00b.brocade_vxlan_visibility', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ext_user_acl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ext_seq', 'keyval': 'ext_seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vni'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, ext_seq=ext_seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, ext_seq=ext_seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_access_list_type_vxlan_extended_seq_vni_any_delete(self, extended=None, ext_seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: ext_user_acl_name
    :param extended: Keyword argument tuple.

    :type ext_user_acl_name: unicode
    :param ext_user_acl_name: **extended** tuple argument:  Access List Name (Max 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type ext_seq: ext_seq_num
    :param ext_seq: Keyword argument tuple.

    :type ext_seq_num: long
    :param ext_seq_num: **ext_seq** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.overlay.access_list.type.vxlan.extended', u'extended')]
    bindings_list = [('pybind.slxos.v16r_1_00b.overlay.access_list.type.vxlan.extended.ext_seq', 'pybind.slxos.v16r_1_00b.brocade_vxlan_visibility', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ext_user_acl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ext_seq', 'keyval': 'ext_seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vni-any'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, ext_seq=ext_seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, ext_seq=ext_seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_access_list_type_vxlan_extended_seq_vni_mask_delete(self, extended=None, ext_seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: ext_user_acl_name
    :param extended: Keyword argument tuple.

    :type ext_user_acl_name: unicode
    :param ext_user_acl_name: **extended** tuple argument:  Access List Name (Max 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type ext_seq: ext_seq_num
    :param ext_seq: Keyword argument tuple.

    :type ext_seq_num: long
    :param ext_seq_num: **ext_seq** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.overlay.access_list.type.vxlan.extended', u'extended')]
    bindings_list = [('pybind.slxos.v16r_1_00b.overlay.access_list.type.vxlan.extended.ext_seq', 'pybind.slxos.v16r_1_00b.brocade_vxlan_visibility', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ext_user_acl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ext_seq', 'keyval': 'ext_seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vni-mask'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, ext_seq=ext_seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, ext_seq=ext_seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_access_list_type_vxlan_standard_delete(self, standard=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type standard: user_acl_name
    :param standard: Keyword argument tuple.

    :type user_acl_name: unicode
    :param user_acl_name: **standard** tuple argument:  Access List Name (Max 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.overlay.access_list.type.vxlan.standard', 'pybind.slxos.v16r_1_00b.brocade_vxlan_visibility', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'standard', 'keyval': 'user_acl_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, standard=standard)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, standard=standard)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_access_list_type_vxlan_standard_seq_delete(self, standard=None, seq=None, permit_deny=None, dst_vtep_ip=None, dst_vtep_ip_any=None, src_vtep_ip=None, src_vtep_ip_any=None, vni=None, vni_any=None, vni_mask=None, count=None, redirect=None, sflow=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type standard: user_acl_name
    :param standard: Keyword argument tuple.

    :type user_acl_name: unicode
    :param user_acl_name: **standard** tuple argument:  Access List Name (Max 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_num, permit_deny, dst_vtep_ip, dst_vtep_ip_any, src_vtep_ip, src_vtep_ip_any, vni, vni_any, vni_mask, count, redirect, sflow
    :param seq: Keyword argument tuple.

    :type seq_num: long
    :param seq_num: **seq** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type permit_deny: unicode
    :param permit_deny: **seq** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type dst_vtep_ip: unicode
    :param dst_vtep_ip: **seq** tuple argument:  dst vtep ip address: A.B.C.D

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type dst_vtep_ip_any: YANGBool
    :param dst_vtep_ip_any: **seq** tuple argument:  dst vtep ip address: any

    :type src_vtep_ip: unicode
    :param src_vtep_ip: **seq** tuple argument:  src vtep ip address: A.B.C.D

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_vtep_ip_any: YANGBool
    :param src_vtep_ip_any: **seq** tuple argument:  src vtep ip address: any

    :type vni: long
    :param vni: **seq** tuple argument:  vni number: 1..16777215

        * range restriction: ::

            ['0..4294967295']

    :type vni_any: YANGBool
    :param vni_any: **seq** tuple argument:  vni any

    :type vni_mask: unicode
    :param vni_mask: **seq** tuple argument:  vni mask:Hexadecimal 0..FFFFFF

        * pattern restriction: ::

            '0|[1-9a-fA-F][0-9a-fA-F]{0,5}'

    :type count: YANGBool
    :param count: **seq** tuple argument:  count

    :type redirect: unicode
    :param redirect: **seq** tuple argument:  redirect <interface-name>

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type sflow: YANGBool
    :param sflow: **seq** tuple argument:  sflow

    **Instance Argument(s)**:

    :type permit_deny: unicode
    :param permit_deny: Keyword argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type dst_vtep_ip: unicode
    :param dst_vtep_ip: dst vtep ip address: A.B.C.D. Choice keyword argument (Only one choice argument allowed per API invocation).

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type dst_vtep_ip_any: YANGBool
    :param dst_vtep_ip_any: dst vtep ip address: any. Choice keyword argument (Only one choice argument allowed per API invocation).

    :type src_vtep_ip: unicode
    :param src_vtep_ip: src vtep ip address: A.B.C.D. Choice keyword argument (Only one choice argument allowed per API invocation).

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_vtep_ip_any: YANGBool
    :param src_vtep_ip_any: src vtep ip address: any. Choice keyword argument (Only one choice argument allowed per API invocation).

    :type vni: long
    :param vni: vni number: 1..16777215. Choice keyword argument (Only one choice argument allowed per API invocation).

        * range restriction: ::

            ['0..4294967295']

    :type vni_any: YANGBool
    :param vni_any: vni any. Choice keyword argument (Only one choice argument allowed per API invocation).

    :type vni_mask: unicode
    :param vni_mask: vni mask:Hexadecimal 0..FFFFFF

        * pattern restriction: ::

            '0|[1-9a-fA-F][0-9a-fA-F]{0,5}'

    :type count: YANGBool
    :param count: count

    :type redirect: unicode
    :param redirect: redirect <interface-name>

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type sflow: YANGBool
    :param sflow: sflow

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.overlay.access_list.type.vxlan.standard', u'standard')]
    bindings_list = [('pybind.slxos.v16r_1_00b.overlay.access_list.type.vxlan.standard.seq', 'pybind.slxos.v16r_1_00b.brocade_vxlan_visibility', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'user_acl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_num', 'extra_keyval': 'seq_num, permit_deny, dst_vtep_ip, dst_vtep_ip_any, src_vtep_ip, src_vtep_ip_any, vni, vni_any, vni_mask, count, redirect, sflow'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v16r_1_00b.overlay.access_list.type.vxlan.standard.seq': [u'src_vtep_ip_any', u'src_vtep_ip', u'vni', u'vni_any', u'dst_vtep_ip', u'dst_vtep_ip_any']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, standard=standard, seq=seq, permit_deny=permit_deny, dst_vtep_ip=dst_vtep_ip, dst_vtep_ip_any=dst_vtep_ip_any, src_vtep_ip=src_vtep_ip, src_vtep_ip_any=src_vtep_ip_any, vni=vni, vni_any=vni_any, vni_mask=vni_mask, count=count, redirect=redirect, sflow=sflow)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, standard=standard, seq=seq, permit_deny=permit_deny, dst_vtep_ip=dst_vtep_ip, dst_vtep_ip_any=dst_vtep_ip_any, src_vtep_ip=src_vtep_ip, src_vtep_ip_any=src_vtep_ip_any, vni=vni, vni_any=vni_any, vni_mask=vni_mask, count=count, redirect=redirect, sflow=sflow)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_access_list_type_vxlan_standard_seq_count_delete(self, standard=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type standard: user_acl_name
    :param standard: Keyword argument tuple.

    :type user_acl_name: unicode
    :param user_acl_name: **standard** tuple argument:  Access List Name (Max 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_num
    :param seq: Keyword argument tuple.

    :type seq_num: long
    :param seq_num: **seq** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.overlay.access_list.type.vxlan.standard', u'standard')]
    bindings_list = [('pybind.slxos.v16r_1_00b.overlay.access_list.type.vxlan.standard.seq', 'pybind.slxos.v16r_1_00b.brocade_vxlan_visibility', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'user_acl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, standard=standard, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, standard=standard, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_access_list_type_vxlan_standard_seq_dst_vtep_ip_any_delete(self, standard=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type standard: user_acl_name
    :param standard: Keyword argument tuple.

    :type user_acl_name: unicode
    :param user_acl_name: **standard** tuple argument:  Access List Name (Max 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_num
    :param seq: Keyword argument tuple.

    :type seq_num: long
    :param seq_num: **seq** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.overlay.access_list.type.vxlan.standard', u'standard')]
    bindings_list = [('pybind.slxos.v16r_1_00b.overlay.access_list.type.vxlan.standard.seq', 'pybind.slxos.v16r_1_00b.brocade_vxlan_visibility', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'user_acl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dst-vtep-ip-any'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, standard=standard, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, standard=standard, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_access_list_type_vxlan_standard_seq_dst_vtep_ip_host_delete(self, standard=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type standard: user_acl_name
    :param standard: Keyword argument tuple.

    :type user_acl_name: unicode
    :param user_acl_name: **standard** tuple argument:  Access List Name (Max 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_num
    :param seq: Keyword argument tuple.

    :type seq_num: long
    :param seq_num: **seq** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.overlay.access_list.type.vxlan.standard', u'standard')]
    bindings_list = [('pybind.slxos.v16r_1_00b.overlay.access_list.type.vxlan.standard.seq', 'pybind.slxos.v16r_1_00b.brocade_vxlan_visibility', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'user_acl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dst-vtep-ip-host'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, standard=standard, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, standard=standard, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_access_list_type_vxlan_standard_seq_permit_deny_delete(self, standard=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type standard: user_acl_name
    :param standard: Keyword argument tuple.

    :type user_acl_name: unicode
    :param user_acl_name: **standard** tuple argument:  Access List Name (Max 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_num
    :param seq: Keyword argument tuple.

    :type seq_num: long
    :param seq_num: **seq** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.overlay.access_list.type.vxlan.standard', u'standard')]
    bindings_list = [('pybind.slxos.v16r_1_00b.overlay.access_list.type.vxlan.standard.seq', 'pybind.slxos.v16r_1_00b.brocade_vxlan_visibility', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'user_acl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'permit-deny'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, standard=standard, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, standard=standard, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_access_list_type_vxlan_standard_seq_redirect_delete(self, standard=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type standard: user_acl_name
    :param standard: Keyword argument tuple.

    :type user_acl_name: unicode
    :param user_acl_name: **standard** tuple argument:  Access List Name (Max 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_num
    :param seq: Keyword argument tuple.

    :type seq_num: long
    :param seq_num: **seq** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.overlay.access_list.type.vxlan.standard', u'standard')]
    bindings_list = [('pybind.slxos.v16r_1_00b.overlay.access_list.type.vxlan.standard.seq', 'pybind.slxos.v16r_1_00b.brocade_vxlan_visibility', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'user_acl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redirect'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, standard=standard, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, standard=standard, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_access_list_type_vxlan_standard_seq_sflow_delete(self, standard=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type standard: user_acl_name
    :param standard: Keyword argument tuple.

    :type user_acl_name: unicode
    :param user_acl_name: **standard** tuple argument:  Access List Name (Max 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_num
    :param seq: Keyword argument tuple.

    :type seq_num: long
    :param seq_num: **seq** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.overlay.access_list.type.vxlan.standard', u'standard')]
    bindings_list = [('pybind.slxos.v16r_1_00b.overlay.access_list.type.vxlan.standard.seq', 'pybind.slxos.v16r_1_00b.brocade_vxlan_visibility', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'user_acl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'sflow'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, standard=standard, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, standard=standard, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_access_list_type_vxlan_standard_seq_src_vtep_ip_any_delete(self, standard=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type standard: user_acl_name
    :param standard: Keyword argument tuple.

    :type user_acl_name: unicode
    :param user_acl_name: **standard** tuple argument:  Access List Name (Max 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_num
    :param seq: Keyword argument tuple.

    :type seq_num: long
    :param seq_num: **seq** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.overlay.access_list.type.vxlan.standard', u'standard')]
    bindings_list = [('pybind.slxos.v16r_1_00b.overlay.access_list.type.vxlan.standard.seq', 'pybind.slxos.v16r_1_00b.brocade_vxlan_visibility', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'user_acl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'src-vtep-ip-any'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, standard=standard, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, standard=standard, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_access_list_type_vxlan_standard_seq_src_vtep_ip_host_delete(self, standard=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type standard: user_acl_name
    :param standard: Keyword argument tuple.

    :type user_acl_name: unicode
    :param user_acl_name: **standard** tuple argument:  Access List Name (Max 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_num
    :param seq: Keyword argument tuple.

    :type seq_num: long
    :param seq_num: **seq** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.overlay.access_list.type.vxlan.standard', u'standard')]
    bindings_list = [('pybind.slxos.v16r_1_00b.overlay.access_list.type.vxlan.standard.seq', 'pybind.slxos.v16r_1_00b.brocade_vxlan_visibility', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'user_acl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'src-vtep-ip-host'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, standard=standard, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, standard=standard, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_access_list_type_vxlan_standard_seq_vni_delete(self, standard=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type standard: user_acl_name
    :param standard: Keyword argument tuple.

    :type user_acl_name: unicode
    :param user_acl_name: **standard** tuple argument:  Access List Name (Max 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_num
    :param seq: Keyword argument tuple.

    :type seq_num: long
    :param seq_num: **seq** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.overlay.access_list.type.vxlan.standard', u'standard')]
    bindings_list = [('pybind.slxos.v16r_1_00b.overlay.access_list.type.vxlan.standard.seq', 'pybind.slxos.v16r_1_00b.brocade_vxlan_visibility', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'user_acl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vni'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, standard=standard, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, standard=standard, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_access_list_type_vxlan_standard_seq_vni_any_delete(self, standard=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type standard: user_acl_name
    :param standard: Keyword argument tuple.

    :type user_acl_name: unicode
    :param user_acl_name: **standard** tuple argument:  Access List Name (Max 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_num
    :param seq: Keyword argument tuple.

    :type seq_num: long
    :param seq_num: **seq** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.overlay.access_list.type.vxlan.standard', u'standard')]
    bindings_list = [('pybind.slxos.v16r_1_00b.overlay.access_list.type.vxlan.standard.seq', 'pybind.slxos.v16r_1_00b.brocade_vxlan_visibility', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'user_acl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vni-any'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, standard=standard, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, standard=standard, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_access_list_type_vxlan_standard_seq_vni_mask_delete(self, standard=None, seq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type standard: user_acl_name
    :param standard: Keyword argument tuple.

    :type user_acl_name: unicode
    :param user_acl_name: **standard** tuple argument:  Access List Name (Max 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_num
    :param seq: Keyword argument tuple.

    :type seq_num: long
    :param seq_num: **seq** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.overlay.access_list.type.vxlan.standard', u'standard')]
    bindings_list = [('pybind.slxos.v16r_1_00b.overlay.access_list.type.vxlan.standard.seq', 'pybind.slxos.v16r_1_00b.brocade_vxlan_visibility', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'user_acl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vni-mask'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, standard=standard, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, standard=standard, seq=seq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_gateway_delete(self, overlay_gateway=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.overlay_gateway', 'pybind.nos.v6_0_2c.brocade_tunnels', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.overlay_gateway', 'pybind.nos.v7_0_1b.brocade_tunnels', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.overlay_gateway', 'pybind.nos.v7_1_0.brocade_tunnels', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.overlay_gateway', 'pybind.slxos.v16r_1_00b.brocade_tunnels', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'overlay_gateway', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_gateway_activate_delete(self, overlay_gateway=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.overlay_gateway', 'pybind.nos.v6_0_2c.brocade_tunnels', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.overlay_gateway', 'pybind.nos.v7_0_1b.brocade_tunnels', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.overlay_gateway', 'pybind.nos.v7_1_0.brocade_tunnels', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.overlay_gateway', 'pybind.slxos.v16r_1_00b.brocade_tunnels', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'overlay_gateway', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'activate'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_gateway_attach_delete(self, overlay_gateway=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_0_1b.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_1_0.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v6_0_2c.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.nos.v6_0_2c.overlay_gateway.attach', 'pybind.nos.v6_0_2c.brocade_tunnels', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.overlay_gateway.attach', 'pybind.nos.v7_0_1b.brocade_tunnels', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.overlay_gateway.attach', 'pybind.nos.v7_1_0.brocade_tunnels', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.overlay_gateway.attach', 'pybind.slxos.v16r_1_00b.brocade_tunnels', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_gateway_attach_rbridge_id_delete(self, overlay_gateway=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_1_0.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v6_0_2c.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.nos.v6_0_2c.overlay_gateway.attach.rbridge_id', 'pybind.nos.v6_0_2c.brocade_tunnels', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.overlay_gateway.attach.rbridge_id', 'pybind.nos.v7_0_1b.brocade_tunnels', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.overlay_gateway.attach.rbridge_id', 'pybind.nos.v7_1_0.brocade_tunnels', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_gateway_attach_rbridge_id_add_delete(self, overlay_gateway=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_1_0.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v6_0_2c.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.nos.v6_0_2c.overlay_gateway.attach.rbridge_id', 'pybind.nos.v6_0_2c.brocade_tunnels', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.overlay_gateway.attach.rbridge_id', 'pybind.nos.v7_0_1b.brocade_tunnels', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.overlay_gateway.attach.rbridge_id', 'pybind.nos.v7_1_0.brocade_tunnels', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'add'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_gateway_attach_rbridge_id_remove_delete(self, overlay_gateway=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_1_0.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v6_0_2c.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.nos.v6_0_2c.overlay_gateway.attach.rbridge_id', 'pybind.nos.v6_0_2c.brocade_tunnels', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.overlay_gateway.attach.rbridge_id', 'pybind.nos.v7_0_1b.brocade_tunnels', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.overlay_gateway.attach.rbridge_id', 'pybind.nos.v7_1_0.brocade_tunnels', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'remove'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_gateway_attach_vlan_delete(self, overlay_gateway=None, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    **Instance Keyword Argument Tuple**:

    :type vlan: vid, mac
    :param vlan: Keyword argument tuple.

    :type vid: long
    :param vid: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type mac: unicode
    :param mac: **vlan** tuple argument:  Configure VLAN-MAC attachment

        * pattern restriction: ::

            '[0-9a-fA-F]{4}(\.[0-9a-fA-F]{4}){2}'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_1_0.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v6_0_2c.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_0_1b.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.nos.v6_0_2c.overlay_gateway.attach.vlan', 'pybind.nos.v6_0_2c.brocade_tunnels', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.overlay_gateway.attach.vlan', 'pybind.nos.v7_0_1b.brocade_tunnels', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.overlay_gateway.attach.vlan', 'pybind.nos.v7_1_0.brocade_tunnels', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.overlay_gateway.attach.vlan', 'pybind.slxos.v16r_1_00b.brocade_tunnels', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'vid, mac', 'extra_keyval': 'vid, mac'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_gateway_enable_delete(self, overlay_gateway=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v16r_1_00b.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v6_0_2c.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_0_1b.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.nos.v6_0_2c.overlay_gateway.enable', 'pybind.nos.v6_0_2c.brocade_tunnels', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.overlay_gateway.enable', 'pybind.nos.v7_0_1b.brocade_tunnels', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.overlay_gateway.enable', 'pybind.nos.v7_1_0.brocade_tunnels', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.overlay_gateway.enable', 'pybind.slxos.v16r_1_00b.brocade_tunnels', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_gateway_enable_statistics_delete(self, overlay_gateway=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_0_1b.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_1_0.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v6_0_2c.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.nos.v6_0_2c.overlay_gateway.enable.statistics', 'pybind.nos.v6_0_2c.brocade_tunnels', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.overlay_gateway.enable.statistics', 'pybind.nos.v7_0_1b.brocade_tunnels', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.overlay_gateway.enable.statistics', 'pybind.nos.v7_1_0.brocade_tunnels', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.overlay_gateway.enable.statistics', 'pybind.slxos.v16r_1_00b.brocade_tunnels', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'stats_direction, vlan_action, vlan_list'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_gateway_enable_statistics_direction_delete(self, overlay_gateway=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_0_1b.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_1_0.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v6_0_2c.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.nos.v6_0_2c.overlay_gateway.enable.statistics', 'pybind.nos.v6_0_2c.brocade_tunnels', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.overlay_gateway.enable.statistics', 'pybind.nos.v7_0_1b.brocade_tunnels', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.overlay_gateway.enable.statistics', 'pybind.nos.v7_1_0.brocade_tunnels', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.overlay_gateway.enable.statistics', 'pybind.slxos.v16r_1_00b.brocade_tunnels', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'direction'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_gateway_enable_statistics_vlan_delete(self, overlay_gateway=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_0_1b.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_1_0.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v6_0_2c.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.nos.v6_0_2c.overlay_gateway.enable.statistics', 'pybind.nos.v6_0_2c.brocade_tunnels', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.overlay_gateway.enable.statistics', 'pybind.nos.v7_0_1b.brocade_tunnels', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.overlay_gateway.enable.statistics', 'pybind.nos.v7_1_0.brocade_tunnels', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.overlay_gateway.enable.statistics', 'pybind.slxos.v16r_1_00b.brocade_tunnels', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vlan'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_gateway_enable_statistics_vlan_list_delete(self, overlay_gateway=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_0_1b.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_1_0.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v6_0_2c.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.nos.v6_0_2c.overlay_gateway.enable.statistics', 'pybind.nos.v6_0_2c.brocade_tunnels', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.overlay_gateway.enable.statistics', 'pybind.nos.v7_0_1b.brocade_tunnels', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.overlay_gateway.enable.statistics', 'pybind.nos.v7_1_0.brocade_tunnels', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.overlay_gateway.enable.statistics', 'pybind.slxos.v16r_1_00b.brocade_tunnels', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vlan-list'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_gateway_ip_delete(self, overlay_gateway=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_1_0.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v16r_1_00b.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_0_1b.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.nos.v6_0_2c.overlay_gateway.access_lists.ipv4', 'pybind.nos.v6_0_2c.brocade_tunnels', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.overlay_gateway.access_lists.ipv4', 'pybind.nos.v7_0_1b.brocade_tunnels', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.overlay_gateway.access_lists.ipv4', 'pybind.nos.v7_1_0.brocade_tunnels', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.overlay_gateway.access_lists.ipv4', 'pybind.slxos.v16r_1_00b.brocade_tunnels', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_gateway_ip_2_delete(self, overlay_gateway=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_0_1b.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v6_0_2c.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_1_0.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.nos.v6_0_2c.overlay_gateway.ip', 'pybind.nos.v6_0_2c.brocade_tunnels', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.overlay_gateway.ip', 'pybind.nos.v7_0_1b.brocade_tunnels', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.overlay_gateway.ip', 'pybind.nos.v7_1_0.brocade_tunnels', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.overlay_gateway.ip', 'pybind.slxos.v16r_1_00b.brocade_tunnels', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_gateway_ip_access_group_delete(self, overlay_gateway=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v16r_1_00b.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v6_0_2c.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_0_1b.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.nos.v6_0_2c.overlay_gateway.access_lists.ipv4.in_', 'pybind.nos.v6_0_2c.brocade_tunnels', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.overlay_gateway.access_lists.ipv4.in_', 'pybind.nos.v7_0_1b.brocade_tunnels', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.overlay_gateway.access_lists.ipv4.in_', 'pybind.nos.v7_1_0.brocade_tunnels', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.overlay_gateway.access_lists.ipv4.in_', 'pybind.slxos.v16r_1_00b.brocade_tunnels', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'access-group'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_gateway_ip_access_group_out_delete(self, overlay_gateway=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_0_1b.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_1_0.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v16r_1_00b.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.nos.v6_0_2c.overlay_gateway.access_lists.ipv4.out', 'pybind.nos.v6_0_2c.brocade_tunnels', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.overlay_gateway.access_lists.ipv4.out', 'pybind.nos.v7_0_1b.brocade_tunnels', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.overlay_gateway.access_lists.ipv4.out', 'pybind.nos.v7_1_0.brocade_tunnels', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.overlay_gateway.access_lists.ipv4.out', 'pybind.slxos.v16r_1_00b.brocade_tunnels', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'access-group'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_gateway_ip_in_delete(self, overlay_gateway=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v16r_1_00b.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v6_0_2c.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_0_1b.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.nos.v6_0_2c.overlay_gateway.access_lists.ipv4.in_', 'pybind.nos.v6_0_2c.brocade_tunnels', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.overlay_gateway.access_lists.ipv4.in_', 'pybind.nos.v7_0_1b.brocade_tunnels', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.overlay_gateway.access_lists.ipv4.in_', 'pybind.nos.v7_1_0.brocade_tunnels', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.overlay_gateway.access_lists.ipv4.in_', 'pybind.slxos.v16r_1_00b.brocade_tunnels', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'in'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_gateway_ip_interface_delete(self, overlay_gateway=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_1_0.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v6_0_2c.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v16r_1_00b.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.nos.v6_0_2c.overlay_gateway.ip.interface', 'pybind.nos.v6_0_2c.brocade_tunnels', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.overlay_gateway.ip.interface', 'pybind.nos.v7_0_1b.brocade_tunnels', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.overlay_gateway.ip.interface', 'pybind.nos.v7_1_0.brocade_tunnels', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.overlay_gateway.ip.interface', 'pybind.slxos.v16r_1_00b.brocade_tunnels', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_gateway_ip_interface_loopback_delete(self, overlay_gateway=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_0_1b.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v6_0_2c.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v16r_1_00b.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.nos.v6_0_2c.overlay_gateway.ip.interface.loopback', 'pybind.nos.v6_0_2c.brocade_tunnels', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.overlay_gateway.ip.interface.loopback', 'pybind.nos.v7_0_1b.brocade_tunnels', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.overlay_gateway.ip.interface.loopback', 'pybind.nos.v7_1_0.brocade_tunnels', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.overlay_gateway.ip.interface.loopback', 'pybind.slxos.v16r_1_00b.brocade_tunnels', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_gateway_ip_interface_loopback_loopback_id_delete(self, overlay_gateway=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_0_1b.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v6_0_2c.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v16r_1_00b.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.nos.v6_0_2c.overlay_gateway.ip.interface.loopback', 'pybind.nos.v6_0_2c.brocade_tunnels', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.overlay_gateway.ip.interface.loopback', 'pybind.nos.v7_0_1b.brocade_tunnels', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.overlay_gateway.ip.interface.loopback', 'pybind.nos.v7_1_0.brocade_tunnels', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.overlay_gateway.ip.interface.loopback', 'pybind.slxos.v16r_1_00b.brocade_tunnels', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'loopback-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_gateway_ip_interface_ve_delete(self, overlay_gateway=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v6_0_2c.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v16r_1_00b.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_0_1b.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.nos.v6_0_2c.overlay_gateway.ip.interface.ve', 'pybind.nos.v6_0_2c.brocade_tunnels', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.overlay_gateway.ip.interface.ve', 'pybind.nos.v7_0_1b.brocade_tunnels', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.overlay_gateway.ip.interface.ve', 'pybind.nos.v7_1_0.brocade_tunnels', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.overlay_gateway.ip.interface.ve', 'pybind.slxos.v16r_1_00b.brocade_tunnels', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_gateway_ip_interface_ve_ve_id_delete(self, overlay_gateway=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v6_0_2c.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v16r_1_00b.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_0_1b.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.nos.v6_0_2c.overlay_gateway.ip.interface.ve', 'pybind.nos.v6_0_2c.brocade_tunnels', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.overlay_gateway.ip.interface.ve', 'pybind.nos.v7_0_1b.brocade_tunnels', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.overlay_gateway.ip.interface.ve', 'pybind.nos.v7_1_0.brocade_tunnels', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.overlay_gateway.ip.interface.ve', 'pybind.slxos.v16r_1_00b.brocade_tunnels', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 've-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_gateway_ip_interface_ve_vrrp_extended_group_delete(self, overlay_gateway=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v6_0_2c.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v16r_1_00b.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_0_1b.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.nos.v6_0_2c.overlay_gateway.ip.interface.ve', 'pybind.nos.v6_0_2c.brocade_tunnels', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.overlay_gateway.ip.interface.ve', 'pybind.nos.v7_0_1b.brocade_tunnels', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.overlay_gateway.ip.interface.ve', 'pybind.nos.v7_1_0.brocade_tunnels', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.overlay_gateway.ip.interface.ve', 'pybind.slxos.v16r_1_00b.brocade_tunnels', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vrrp-extended-group'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_gateway_ip_out_delete(self, overlay_gateway=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_0_1b.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_1_0.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v16r_1_00b.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.nos.v6_0_2c.overlay_gateway.access_lists.ipv4.out', 'pybind.nos.v6_0_2c.brocade_tunnels', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.overlay_gateway.access_lists.ipv4.out', 'pybind.nos.v7_0_1b.brocade_tunnels', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.overlay_gateway.access_lists.ipv4.out', 'pybind.nos.v7_1_0.brocade_tunnels', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.overlay_gateway.access_lists.ipv4.out', 'pybind.slxos.v16r_1_00b.brocade_tunnels', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'out'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_gateway_ipv6_delete(self, overlay_gateway=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v6_0_2c.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_0_1b.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_1_0.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.nos.v6_0_2c.overlay_gateway.access_lists.ipv6', 'pybind.nos.v6_0_2c.brocade_tunnels', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.overlay_gateway.access_lists.ipv6', 'pybind.nos.v7_0_1b.brocade_tunnels', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.overlay_gateway.access_lists.ipv6', 'pybind.nos.v7_1_0.brocade_tunnels', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.overlay_gateway.access_lists.ipv6', 'pybind.slxos.v16r_1_00b.brocade_tunnels', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_gateway_ipv6_access_group_delete(self, overlay_gateway=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v6_0_2c.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_1_0.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_0_1b.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.nos.v6_0_2c.overlay_gateway.access_lists.ipv6.in_', 'pybind.nos.v6_0_2c.brocade_tunnels', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.overlay_gateway.access_lists.ipv6.in_', 'pybind.nos.v7_0_1b.brocade_tunnels', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.overlay_gateway.access_lists.ipv6.in_', 'pybind.nos.v7_1_0.brocade_tunnels', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.overlay_gateway.access_lists.ipv6.in_', 'pybind.slxos.v16r_1_00b.brocade_tunnels', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'access-group'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_gateway_ipv6_access_group_out_delete(self, overlay_gateway=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_1_0.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_0_1b.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v16r_1_00b.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.nos.v6_0_2c.overlay_gateway.access_lists.ipv6.out', 'pybind.nos.v6_0_2c.brocade_tunnels', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.overlay_gateway.access_lists.ipv6.out', 'pybind.nos.v7_0_1b.brocade_tunnels', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.overlay_gateway.access_lists.ipv6.out', 'pybind.nos.v7_1_0.brocade_tunnels', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.overlay_gateway.access_lists.ipv6.out', 'pybind.slxos.v16r_1_00b.brocade_tunnels', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'access-group'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_gateway_ipv6_in_delete(self, overlay_gateway=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v6_0_2c.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_1_0.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_0_1b.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.nos.v6_0_2c.overlay_gateway.access_lists.ipv6.in_', 'pybind.nos.v6_0_2c.brocade_tunnels', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.overlay_gateway.access_lists.ipv6.in_', 'pybind.nos.v7_0_1b.brocade_tunnels', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.overlay_gateway.access_lists.ipv6.in_', 'pybind.nos.v7_1_0.brocade_tunnels', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.overlay_gateway.access_lists.ipv6.in_', 'pybind.slxos.v16r_1_00b.brocade_tunnels', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'in'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_gateway_ipv6_out_delete(self, overlay_gateway=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_1_0.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_0_1b.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v16r_1_00b.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.nos.v6_0_2c.overlay_gateway.access_lists.ipv6.out', 'pybind.nos.v6_0_2c.brocade_tunnels', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.overlay_gateway.access_lists.ipv6.out', 'pybind.nos.v7_0_1b.brocade_tunnels', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.overlay_gateway.access_lists.ipv6.out', 'pybind.nos.v7_1_0.brocade_tunnels', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.overlay_gateway.access_lists.ipv6.out', 'pybind.slxos.v16r_1_00b.brocade_tunnels', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'out'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_gateway_mac_delete(self, overlay_gateway=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v16r_1_00b.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_0_1b.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v6_0_2c.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.nos.v6_0_2c.overlay_gateway.access_lists.mac', 'pybind.nos.v6_0_2c.brocade_tunnels', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.overlay_gateway.access_lists.mac', 'pybind.nos.v7_0_1b.brocade_tunnels', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.overlay_gateway.access_lists.mac', 'pybind.nos.v7_1_0.brocade_tunnels', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.overlay_gateway.access_lists.mac', 'pybind.slxos.v16r_1_00b.brocade_tunnels', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_gateway_mac_access_group_delete(self, overlay_gateway=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v16r_1_00b.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v6_0_2c.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_1_0.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.nos.v6_0_2c.overlay_gateway.access_lists.mac.in_', 'pybind.nos.v6_0_2c.brocade_tunnels', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.overlay_gateway.access_lists.mac.in_', 'pybind.nos.v7_0_1b.brocade_tunnels', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.overlay_gateway.access_lists.mac.in_', 'pybind.nos.v7_1_0.brocade_tunnels', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.overlay_gateway.access_lists.mac.in_', 'pybind.slxos.v16r_1_00b.brocade_tunnels', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'access-group'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_gateway_mac_access_group_out_delete(self, overlay_gateway=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_0_1b.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v6_0_2c.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_1_0.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.nos.v6_0_2c.overlay_gateway.access_lists.mac.out', 'pybind.nos.v6_0_2c.brocade_tunnels', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.overlay_gateway.access_lists.mac.out', 'pybind.nos.v7_0_1b.brocade_tunnels', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.overlay_gateway.access_lists.mac.out', 'pybind.nos.v7_1_0.brocade_tunnels', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.overlay_gateway.access_lists.mac.out', 'pybind.slxos.v16r_1_00b.brocade_tunnels', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'access-group'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_gateway_mac_in_delete(self, overlay_gateway=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v16r_1_00b.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v6_0_2c.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_1_0.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.nos.v6_0_2c.overlay_gateway.access_lists.mac.in_', 'pybind.nos.v6_0_2c.brocade_tunnels', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.overlay_gateway.access_lists.mac.in_', 'pybind.nos.v7_0_1b.brocade_tunnels', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.overlay_gateway.access_lists.mac.in_', 'pybind.nos.v7_1_0.brocade_tunnels', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.overlay_gateway.access_lists.mac.in_', 'pybind.slxos.v16r_1_00b.brocade_tunnels', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'in'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_gateway_mac_out_delete(self, overlay_gateway=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_0_1b.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v6_0_2c.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_1_0.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.nos.v6_0_2c.overlay_gateway.access_lists.mac.out', 'pybind.nos.v6_0_2c.brocade_tunnels', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.overlay_gateway.access_lists.mac.out', 'pybind.nos.v7_0_1b.brocade_tunnels', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.overlay_gateway.access_lists.mac.out', 'pybind.nos.v7_1_0.brocade_tunnels', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.overlay_gateway.access_lists.mac.out', 'pybind.slxos.v16r_1_00b.brocade_tunnels', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'out'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_gateway_map_vlan_vni_delete(self, overlay_gateway=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_1_0.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v6_0_2c.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_0_1b.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.nos.v6_0_2c.overlay_gateway.map_.vlan.vni', 'pybind.nos.v6_0_2c.brocade_tunnels', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.overlay_gateway.map_.vlan.vni', 'pybind.nos.v7_0_1b.brocade_tunnels', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.overlay_gateway.map_.vlan.vni', 'pybind.nos.v7_1_0.brocade_tunnels', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.overlay_gateway.map_.vlan.vni', 'pybind.slxos.v16r_1_00b.brocade_tunnels', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_gateway_map_vlan_vni_auto_delete(self, overlay_gateway=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_1_0.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v6_0_2c.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_0_1b.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.nos.v6_0_2c.overlay_gateway.map_.vlan.vni', 'pybind.nos.v6_0_2c.brocade_tunnels', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.overlay_gateway.map_.vlan.vni', 'pybind.nos.v7_0_1b.brocade_tunnels', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.overlay_gateway.map_.vlan.vni', 'pybind.nos.v7_1_0.brocade_tunnels', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.overlay_gateway.map_.vlan.vni', 'pybind.slxos.v16r_1_00b.brocade_tunnels', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'auto'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_gateway_map_vlan_vni_mapping_delete(self, overlay_gateway=None, vlan_vni_mapping=None, vni=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    **Instance Keyword Argument Tuple**:

    :type vlan_vni_mapping: vid
    :param vlan_vni_mapping: Keyword argument tuple.

    :type vid: long
    :param vid: **vlan_vni_mapping** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Argument(s)**:

    :type vni: long
    :param vni: Specify VNI mapping for the VLAN.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v6_0_2c.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_1_0.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v16r_1_00b.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.nos.v6_0_2c.overlay_gateway.map_.vlan_vni_mapping', 'pybind.nos.v6_0_2c.brocade_tunnels', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.overlay_gateway.map_.vlan_vni_mapping', 'pybind.nos.v7_0_1b.brocade_tunnels', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.overlay_gateway.map_.vlan_vni_mapping', 'pybind.nos.v7_1_0.brocade_tunnels', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.overlay_gateway.map_.vlan_vni_mapping', 'pybind.slxos.v16r_1_00b.brocade_tunnels', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan_vni_mapping', 'keyval': 'vid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway, vlan_vni_mapping=vlan_vni_mapping, vni=vni)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway, vlan_vni_mapping=vlan_vni_mapping, vni=vni)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_gateway_map_vlan_vni_mapping_vni_delete(self, overlay_gateway=None, vlan_vni_mapping=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    **Instance Keyword Argument Tuple**:

    :type vlan_vni_mapping: vid
    :param vlan_vni_mapping: Keyword argument tuple.

    :type vid: long
    :param vid: **vlan_vni_mapping** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v6_0_2c.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_1_0.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v16r_1_00b.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.nos.v6_0_2c.overlay_gateway.map_.vlan_vni_mapping', 'pybind.nos.v6_0_2c.brocade_tunnels', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.overlay_gateway.map_.vlan_vni_mapping', 'pybind.nos.v7_0_1b.brocade_tunnels', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.overlay_gateway.map_.vlan_vni_mapping', 'pybind.nos.v7_1_0.brocade_tunnels', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.overlay_gateway.map_.vlan_vni_mapping', 'pybind.slxos.v16r_1_00b.brocade_tunnels', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan_vni_mapping', 'keyval': 'vid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vni'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway, vlan_vni_mapping=vlan_vni_mapping)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway, vlan_vni_mapping=vlan_vni_mapping)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_gateway_monitor_direction_delete(self, overlay_gateway=None, monitor=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    **Instance Keyword Argument Tuple**:

    :type monitor: session
    :param monitor: Keyword argument tuple.

    :type session: long
    :param session: **monitor** tuple argument:  Session number

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_1_0.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v16r_1_00b.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_0_1b.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.nos.v6_0_2c.overlay_gateway.monitor', 'pybind.nos.v6_0_2c.brocade_tunnels', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.overlay_gateway.monitor', 'pybind.nos.v7_0_1b.brocade_tunnels', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.overlay_gateway.monitor', 'pybind.nos.v7_1_0.brocade_tunnels', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.overlay_gateway.monitor', 'pybind.slxos.v16r_1_00b.brocade_tunnels', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'monitor', 'keyval': 'session', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'direction'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway, monitor=monitor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway, monitor=monitor)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_gateway_monitor_remote_endpoint_delete(self, overlay_gateway=None, monitor=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    **Instance Keyword Argument Tuple**:

    :type monitor: session
    :param monitor: Keyword argument tuple.

    :type session: long
    :param session: **monitor** tuple argument:  Session number

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_1_0.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v16r_1_00b.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_0_1b.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.nos.v6_0_2c.overlay_gateway.monitor', 'pybind.nos.v6_0_2c.brocade_tunnels', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.overlay_gateway.monitor', 'pybind.nos.v7_0_1b.brocade_tunnels', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.overlay_gateway.monitor', 'pybind.nos.v7_1_0.brocade_tunnels', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.overlay_gateway.monitor', 'pybind.slxos.v16r_1_00b.brocade_tunnels', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'monitor', 'keyval': 'session', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'remote-endpoint'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway, monitor=monitor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway, monitor=monitor)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_gateway_monitor_vlan_add_remove_delete(self, overlay_gateway=None, monitor=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    **Instance Keyword Argument Tuple**:

    :type monitor: session
    :param monitor: Keyword argument tuple.

    :type session: long
    :param session: **monitor** tuple argument:  Session number

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_1_0.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v16r_1_00b.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_0_1b.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.nos.v6_0_2c.overlay_gateway.monitor', 'pybind.nos.v6_0_2c.brocade_tunnels', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.overlay_gateway.monitor', 'pybind.nos.v7_0_1b.brocade_tunnels', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.overlay_gateway.monitor', 'pybind.nos.v7_1_0.brocade_tunnels', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.overlay_gateway.monitor', 'pybind.slxos.v16r_1_00b.brocade_tunnels', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'monitor', 'keyval': 'session', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vlan-add-remove'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway, monitor=monitor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway, monitor=monitor)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_gateway_monitor_vlan_leaf_delete(self, overlay_gateway=None, monitor=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    **Instance Keyword Argument Tuple**:

    :type monitor: session
    :param monitor: Keyword argument tuple.

    :type session: long
    :param session: **monitor** tuple argument:  Session number

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_1_0.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v16r_1_00b.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_0_1b.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.nos.v6_0_2c.overlay_gateway.monitor', 'pybind.nos.v6_0_2c.brocade_tunnels', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.overlay_gateway.monitor', 'pybind.nos.v7_0_1b.brocade_tunnels', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.overlay_gateway.monitor', 'pybind.nos.v7_1_0.brocade_tunnels', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.overlay_gateway.monitor', 'pybind.slxos.v16r_1_00b.brocade_tunnels', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'monitor', 'keyval': 'session', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vlan-leaf'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway, monitor=monitor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway, monitor=monitor)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_gateway_monitor_vlan_range_delete(self, overlay_gateway=None, monitor=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    **Instance Keyword Argument Tuple**:

    :type monitor: session
    :param monitor: Keyword argument tuple.

    :type session: long
    :param session: **monitor** tuple argument:  Session number

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_1_0.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v16r_1_00b.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_0_1b.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.nos.v6_0_2c.overlay_gateway.monitor', 'pybind.nos.v6_0_2c.brocade_tunnels', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.overlay_gateway.monitor', 'pybind.nos.v7_0_1b.brocade_tunnels', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.overlay_gateway.monitor', 'pybind.nos.v7_1_0.brocade_tunnels', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.overlay_gateway.monitor', 'pybind.slxos.v16r_1_00b.brocade_tunnels', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'monitor', 'keyval': 'session', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vlan-range'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway, monitor=monitor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway, monitor=monitor)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_gateway_sflow_delete(self, overlay_gateway=None, sflow=None, sflow_remote_endpoint=None, sflow_vlan_action=None, sflow_vlan_range=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    **Instance Keyword Argument Tuple**:

    :type sflow: sflow_profile_name, sflow_remote_endpoint, sflow_vlan_action, sflow_vlan_range
    :param sflow: Keyword argument tuple.

    :type sflow_profile_name: unicode
    :param sflow_profile_name: **sflow** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type sflow_remote_endpoint: unicode
    :param sflow_remote_endpoint: **sflow** tuple argument:  Tunnel destination end point address

        * enumeration restriction: ::

            ['any']

    :type sflow_vlan_action: unicode
    :param sflow_vlan_action: **sflow** tuple argument:  Target VLAN IDs

        * enumeration restriction: ::

            ['add', 'remove']

    :type sflow_vlan_range: unicode
    :param sflow_vlan_range: **sflow** tuple argument.

        * pattern restriction: ::

            '[0-9]+(-[0-9]+)?(,[0-9]+(-[0-9]+)?)*'

    **Instance Argument(s)**:

    :type sflow_remote_endpoint: unicode
    :param sflow_remote_endpoint: Tunnel destination end point address

        * enumeration restriction: ::

            ['any']

    :type sflow_vlan_action: unicode
    :param sflow_vlan_action: Target VLAN IDs

        * enumeration restriction: ::

            ['add', 'remove']

    :type sflow_vlan_range: unicode
    :param sflow_vlan_range: Keyword argument.

        * pattern restriction: ::

            '[0-9]+(-[0-9]+)?(,[0-9]+(-[0-9]+)?)*'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v16r_1_00b.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_1_0.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v6_0_2c.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.nos.v6_0_2c.overlay_gateway.sflow', 'pybind.nos.v6_0_2c.brocade_tunnels', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.overlay_gateway.sflow', 'pybind.nos.v7_0_1b.brocade_tunnels', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.overlay_gateway.sflow', 'pybind.nos.v7_1_0.brocade_tunnels', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.overlay_gateway.sflow', 'pybind.slxos.v16r_1_00b.brocade_tunnels', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'sflow', 'keyval': 'sflow_profile_name', 'extra_keyval': 'sflow_profile_name, sflow_remote_endpoint, sflow_vlan_action, sflow_vlan_range'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway, sflow=sflow, sflow_remote_endpoint=sflow_remote_endpoint, sflow_vlan_action=sflow_vlan_action, sflow_vlan_range=sflow_vlan_range)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway, sflow=sflow, sflow_remote_endpoint=sflow_remote_endpoint, sflow_vlan_action=sflow_vlan_action, sflow_vlan_range=sflow_vlan_range)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_gateway_sflow_remote_endpoint_delete(self, overlay_gateway=None, sflow=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    **Instance Keyword Argument Tuple**:

    :type sflow: sflow_profile_name
    :param sflow: Keyword argument tuple.

    :type sflow_profile_name: unicode
    :param sflow_profile_name: **sflow** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v16r_1_00b.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_1_0.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v6_0_2c.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.nos.v6_0_2c.overlay_gateway.sflow', 'pybind.nos.v6_0_2c.brocade_tunnels', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.overlay_gateway.sflow', 'pybind.nos.v7_0_1b.brocade_tunnels', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.overlay_gateway.sflow', 'pybind.nos.v7_1_0.brocade_tunnels', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.overlay_gateway.sflow', 'pybind.slxos.v16r_1_00b.brocade_tunnels', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'sflow', 'keyval': 'sflow_profile_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'remote-endpoint'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway, sflow=sflow)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway, sflow=sflow)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_gateway_sflow_sflow_vlan_range_delete(self, overlay_gateway=None, sflow=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    **Instance Keyword Argument Tuple**:

    :type sflow: sflow_profile_name
    :param sflow: Keyword argument tuple.

    :type sflow_profile_name: unicode
    :param sflow_profile_name: **sflow** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v16r_1_00b.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_1_0.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v6_0_2c.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.nos.v6_0_2c.overlay_gateway.sflow', 'pybind.nos.v6_0_2c.brocade_tunnels', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.overlay_gateway.sflow', 'pybind.nos.v7_0_1b.brocade_tunnels', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.overlay_gateway.sflow', 'pybind.nos.v7_1_0.brocade_tunnels', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.overlay_gateway.sflow', 'pybind.slxos.v16r_1_00b.brocade_tunnels', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'sflow', 'keyval': 'sflow_profile_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'sflow-vlan-range'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway, sflow=sflow)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway, sflow=sflow)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_gateway_sflow_vlan_delete(self, overlay_gateway=None, sflow=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    **Instance Keyword Argument Tuple**:

    :type sflow: sflow_profile_name
    :param sflow: Keyword argument tuple.

    :type sflow_profile_name: unicode
    :param sflow_profile_name: **sflow** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v16r_1_00b.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_1_0.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v6_0_2c.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.nos.v6_0_2c.overlay_gateway.sflow', 'pybind.nos.v6_0_2c.brocade_tunnels', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.overlay_gateway.sflow', 'pybind.nos.v7_0_1b.brocade_tunnels', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.overlay_gateway.sflow', 'pybind.nos.v7_1_0.brocade_tunnels', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.overlay_gateway.sflow', 'pybind.slxos.v16r_1_00b.brocade_tunnels', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'sflow', 'keyval': 'sflow_profile_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vlan'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway, sflow=sflow)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway, sflow=sflow)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_gateway_site_delete(self, overlay_gateway=None, site=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    **Instance Keyword Argument Tuple**:

    :type site: name
    :param site: Keyword argument tuple.

    :type name: unicode
    :param name: **site** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,63}'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v6_0_2c.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_1_0.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v16r_1_00b.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.nos.v6_0_2c.overlay_gateway.site', 'pybind.nos.v6_0_2c.brocade_tunnels', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.overlay_gateway.site', 'pybind.nos.v7_0_1b.brocade_tunnels', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.overlay_gateway.site', 'pybind.nos.v7_1_0.brocade_tunnels', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.overlay_gateway.site', 'pybind.slxos.v16r_1_00b.brocade_tunnels', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'site', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway, site=site)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway, site=site)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_gateway_site_bfd_delete(self, overlay_gateway=None, site=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    **Instance Keyword Argument Tuple**:

    :type site: name
    :param site: Keyword argument tuple.

    :type name: unicode
    :param name: **site** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,63}'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v6_0_2c.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_1_0.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v16r_1_00b.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.nos.v6_0_2c.overlay_gateway.site', 'pybind.nos.v6_0_2c.brocade_tunnels', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.overlay_gateway.site', 'pybind.nos.v7_0_1b.brocade_tunnels', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.overlay_gateway.site', 'pybind.nos.v7_1_0.brocade_tunnels', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.overlay_gateway.site', 'pybind.slxos.v16r_1_00b.brocade_tunnels', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'site', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bfd'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway, site=site)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway, site=site)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_gateway_site_bfd_interval_delete(self, overlay_gateway=None, site=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type site: name
    :param site: Keyword argument tuple.

    :type name: unicode
    :param name: **site** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,63}'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v16r_1_00b.overlay_gateway.site', u'site'), ('pybind.nos.v7_1_0.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_1_0.overlay_gateway.site', u'site'), ('pybind.nos.v7_0_1b.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_0_1b.overlay_gateway.site', u'site'), ('pybind.nos.v6_0_2c.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v6_0_2c.overlay_gateway.site', u'site')]
    bindings_list = [('pybind.nos.v6_0_2c.overlay_gateway.site.bfd.params.interval', 'pybind.nos.v6_0_2c.brocade_tunnels', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.overlay_gateway.site.bfd.params.interval', 'pybind.nos.v7_0_1b.brocade_tunnels', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.overlay_gateway.site.bfd.params.interval', 'pybind.nos.v7_1_0.brocade_tunnels', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.overlay_gateway.site.bfd.params.interval', 'pybind.slxos.v16r_1_00b.brocade_tunnels', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway, site=site)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway, site=site)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_gateway_site_bfd_interval_min_rx_delete(self, overlay_gateway=None, site=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type site: name
    :param site: Keyword argument tuple.

    :type name: unicode
    :param name: **site** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,63}'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v16r_1_00b.overlay_gateway.site', u'site'), ('pybind.nos.v7_1_0.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_1_0.overlay_gateway.site', u'site'), ('pybind.nos.v7_0_1b.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_0_1b.overlay_gateway.site', u'site'), ('pybind.nos.v6_0_2c.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v6_0_2c.overlay_gateway.site', u'site')]
    bindings_list = [('pybind.nos.v6_0_2c.overlay_gateway.site.bfd.params.interval', 'pybind.nos.v6_0_2c.brocade_tunnels', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.overlay_gateway.site.bfd.params.interval', 'pybind.nos.v7_0_1b.brocade_tunnels', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.overlay_gateway.site.bfd.params.interval', 'pybind.nos.v7_1_0.brocade_tunnels', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.overlay_gateway.site.bfd.params.interval', 'pybind.slxos.v16r_1_00b.brocade_tunnels', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'min-rx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway, site=site)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway, site=site)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_gateway_site_bfd_interval_min_tx_delete(self, overlay_gateway=None, site=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type site: name
    :param site: Keyword argument tuple.

    :type name: unicode
    :param name: **site** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,63}'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v16r_1_00b.overlay_gateway.site', u'site'), ('pybind.nos.v7_1_0.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_1_0.overlay_gateway.site', u'site'), ('pybind.nos.v7_0_1b.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_0_1b.overlay_gateway.site', u'site'), ('pybind.nos.v6_0_2c.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v6_0_2c.overlay_gateway.site', u'site')]
    bindings_list = [('pybind.nos.v6_0_2c.overlay_gateway.site.bfd.params.interval', 'pybind.nos.v6_0_2c.brocade_tunnels', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.overlay_gateway.site.bfd.params.interval', 'pybind.nos.v7_0_1b.brocade_tunnels', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.overlay_gateway.site.bfd.params.interval', 'pybind.nos.v7_1_0.brocade_tunnels', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.overlay_gateway.site.bfd.params.interval', 'pybind.slxos.v16r_1_00b.brocade_tunnels', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'min-tx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway, site=site)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway, site=site)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_gateway_site_bfd_interval_multiplier_delete(self, overlay_gateway=None, site=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type site: name
    :param site: Keyword argument tuple.

    :type name: unicode
    :param name: **site** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,63}'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v16r_1_00b.overlay_gateway.site', u'site'), ('pybind.nos.v7_1_0.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_1_0.overlay_gateway.site', u'site'), ('pybind.nos.v7_0_1b.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_0_1b.overlay_gateway.site', u'site'), ('pybind.nos.v6_0_2c.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v6_0_2c.overlay_gateway.site', u'site')]
    bindings_list = [('pybind.nos.v6_0_2c.overlay_gateway.site.bfd.params.interval', 'pybind.nos.v6_0_2c.brocade_tunnels', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.overlay_gateway.site.bfd.params.interval', 'pybind.nos.v7_0_1b.brocade_tunnels', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.overlay_gateway.site.bfd.params.interval', 'pybind.nos.v7_1_0.brocade_tunnels', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.overlay_gateway.site.bfd.params.interval', 'pybind.slxos.v16r_1_00b.brocade_tunnels', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'multiplier'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway, site=site)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway, site=site)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_gateway_site_bfd_shutdown_delete(self, overlay_gateway=None, site=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type site: name
    :param site: Keyword argument tuple.

    :type name: unicode
    :param name: **site** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,63}'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v16r_1_00b.overlay_gateway.site', u'site'), ('pybind.nos.v6_0_2c.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v6_0_2c.overlay_gateway.site', u'site'), ('pybind.nos.v7_1_0.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_1_0.overlay_gateway.site', u'site'), ('pybind.nos.v7_0_1b.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_0_1b.overlay_gateway.site', u'site')]
    bindings_list = [('pybind.nos.v6_0_2c.overlay_gateway.site.bfd.params', 'pybind.nos.v6_0_2c.brocade_tunnels', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.overlay_gateway.site.bfd.params', 'pybind.nos.v7_0_1b.brocade_tunnels', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.overlay_gateway.site.bfd.params', 'pybind.nos.v7_1_0.brocade_tunnels', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.overlay_gateway.site.bfd.params', 'pybind.slxos.v16r_1_00b.brocade_tunnels', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'shutdown'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway, site=site)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway, site=site)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_gateway_site_extend_delete(self, overlay_gateway=None, site=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type site: name
    :param site: Keyword argument tuple.

    :type name: unicode
    :param name: **site** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,63}'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_1_0.overlay_gateway.site', u'site'), ('pybind.slxos.v16r_1_00b.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v16r_1_00b.overlay_gateway.site', u'site'), ('pybind.nos.v7_0_1b.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_0_1b.overlay_gateway.site', u'site'), ('pybind.nos.v6_0_2c.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v6_0_2c.overlay_gateway.site', u'site')]
    bindings_list = [('pybind.nos.v6_0_2c.overlay_gateway.site.extend', 'pybind.nos.v6_0_2c.brocade_tunnels', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.overlay_gateway.site.extend', 'pybind.nos.v7_0_1b.brocade_tunnels', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.overlay_gateway.site.extend', 'pybind.nos.v7_1_0.brocade_tunnels', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.overlay_gateway.site.extend', 'pybind.slxos.v16r_1_00b.brocade_tunnels', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway, site=site)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway, site=site)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_gateway_site_extend_vlan_delete(self, overlay_gateway=None, site=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type site: name
    :param site: Keyword argument tuple.

    :type name: unicode
    :param name: **site** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,63}'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_1_0.overlay_gateway.site', u'site'), ('pybind.nos.v7_0_1b.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_0_1b.overlay_gateway.site', u'site'), ('pybind.nos.v6_0_2c.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v6_0_2c.overlay_gateway.site', u'site'), ('pybind.slxos.v16r_1_00b.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v16r_1_00b.overlay_gateway.site', u'site')]
    bindings_list = [('pybind.nos.v6_0_2c.overlay_gateway.site.extend.vlan', 'pybind.nos.v6_0_2c.brocade_tunnels', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.overlay_gateway.site.extend.vlan', 'pybind.nos.v7_0_1b.brocade_tunnels', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.overlay_gateway.site.extend.vlan', 'pybind.nos.v7_1_0.brocade_tunnels', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.overlay_gateway.site.extend.vlan', 'pybind.slxos.v16r_1_00b.brocade_tunnels', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway, site=site)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway, site=site)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_gateway_site_extend_vlan_add_delete(self, overlay_gateway=None, site=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type site: name
    :param site: Keyword argument tuple.

    :type name: unicode
    :param name: **site** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,63}'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_1_0.overlay_gateway.site', u'site'), ('pybind.nos.v7_0_1b.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_0_1b.overlay_gateway.site', u'site'), ('pybind.nos.v6_0_2c.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v6_0_2c.overlay_gateway.site', u'site'), ('pybind.slxos.v16r_1_00b.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v16r_1_00b.overlay_gateway.site', u'site')]
    bindings_list = [('pybind.nos.v6_0_2c.overlay_gateway.site.extend.vlan', 'pybind.nos.v6_0_2c.brocade_tunnels', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.overlay_gateway.site.extend.vlan', 'pybind.nos.v7_0_1b.brocade_tunnels', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.overlay_gateway.site.extend.vlan', 'pybind.nos.v7_1_0.brocade_tunnels', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.overlay_gateway.site.extend.vlan', 'pybind.slxos.v16r_1_00b.brocade_tunnels', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'add'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway, site=site)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway, site=site)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_gateway_site_extend_vlan_remove_delete(self, overlay_gateway=None, site=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type site: name
    :param site: Keyword argument tuple.

    :type name: unicode
    :param name: **site** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,63}'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_1_0.overlay_gateway.site', u'site'), ('pybind.nos.v7_0_1b.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_0_1b.overlay_gateway.site', u'site'), ('pybind.nos.v6_0_2c.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v6_0_2c.overlay_gateway.site', u'site'), ('pybind.slxos.v16r_1_00b.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v16r_1_00b.overlay_gateway.site', u'site')]
    bindings_list = [('pybind.nos.v6_0_2c.overlay_gateway.site.extend.vlan', 'pybind.nos.v6_0_2c.brocade_tunnels', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.overlay_gateway.site.extend.vlan', 'pybind.nos.v7_0_1b.brocade_tunnels', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.overlay_gateway.site.extend.vlan', 'pybind.nos.v7_1_0.brocade_tunnels', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.overlay_gateway.site.extend.vlan', 'pybind.slxos.v16r_1_00b.brocade_tunnels', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'remove'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway, site=site)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway, site=site)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_gateway_site_ip_delete(self, overlay_gateway=None, site=None, tunnel_dst=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type site: name
    :param site: Keyword argument tuple.

    :type name: unicode
    :param name: **site** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,63}'

    **Instance Keyword Argument Tuple**:

    :type tunnel_dst: address
    :param tunnel_dst: Keyword argument tuple.

    :type address: unicode
    :param address: **tunnel_dst** tuple argument:  Tunnel destination IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v16r_1_00b.overlay_gateway.site', u'site'), ('pybind.nos.v7_1_0.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_1_0.overlay_gateway.site', u'site'), ('pybind.nos.v6_0_2c.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v6_0_2c.overlay_gateway.site', u'site'), ('pybind.nos.v7_0_1b.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_0_1b.overlay_gateway.site', u'site')]
    bindings_list = [('pybind.nos.v6_0_2c.overlay_gateway.site.tunnel_dst', 'pybind.nos.v6_0_2c.brocade_tunnels', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.overlay_gateway.site.tunnel_dst', 'pybind.nos.v7_0_1b.brocade_tunnels', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.overlay_gateway.site.tunnel_dst', 'pybind.nos.v7_1_0.brocade_tunnels', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.overlay_gateway.site.tunnel_dst', 'pybind.slxos.v16r_1_00b.brocade_tunnels', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'tunnel_dst', 'keyval': 'address', 'extra_keyval': 'address'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway, site=site, tunnel_dst=tunnel_dst)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway, site=site, tunnel_dst=tunnel_dst)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_gateway_site_mac_learning_protocol_delete(self, overlay_gateway=None, site=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type site: name
    :param site: Keyword argument tuple.

    :type name: unicode
    :param name: **site** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,63}'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_1_0.overlay_gateway.site', u'site'), ('pybind.nos.v7_0_1b.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_0_1b.overlay_gateway.site', u'site')]
    bindings_list = [('pybind.nos.v7_0_1b.overlay_gateway.site.mac_learning', 'pybind.nos.v7_0_1b.brocade_tunnels', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.overlay_gateway.site.mac_learning', 'pybind.nos.v7_1_0.brocade_tunnels', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'protocol'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway, site=site)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway, site=site)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_gateway_site_shutdown_delete(self, overlay_gateway=None, site=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    **Instance Keyword Argument Tuple**:

    :type site: name
    :param site: Keyword argument tuple.

    :type name: unicode
    :param name: **site** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,63}'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v6_0_2c.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_1_0.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v16r_1_00b.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.nos.v6_0_2c.overlay_gateway.site', 'pybind.nos.v6_0_2c.brocade_tunnels', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.overlay_gateway.site', 'pybind.nos.v7_0_1b.brocade_tunnels', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.overlay_gateway.site', 'pybind.nos.v7_1_0.brocade_tunnels', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.overlay_gateway.site', 'pybind.slxos.v16r_1_00b.brocade_tunnels', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'site', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'shutdown'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway, site=site)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway, site=site)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_gateway_type_delete(self, overlay_gateway=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.overlay_gateway', 'pybind.nos.v6_0_2c.brocade_tunnels', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.overlay_gateway', 'pybind.nos.v7_0_1b.brocade_tunnels', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.overlay_gateway', 'pybind.nos.v7_1_0.brocade_tunnels', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.overlay_gateway', 'pybind.slxos.v16r_1_00b.brocade_tunnels', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'overlay_gateway', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_transit_delete(self, overlay_transit=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type overlay_transit: user_transit_name
    :param overlay_transit: Keyword argument tuple.

    :type user_transit_name: unicode
    :param user_transit_name: **overlay_transit** tuple argument:  User Transit Name (Max 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.overlay_transit', 'pybind.slxos.v16r_1_00b.brocade_vxlan_visibility', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'overlay_transit', 'keyval': 'user_transit_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_transit=overlay_transit)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_transit=overlay_transit)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_transit_overlay_delete(self, overlay_transit=None, transit_overlay=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_transit: user_transit_name
    :param overlay_transit: Keyword argument tuple.

    :type user_transit_name: unicode
    :param user_transit_name: **overlay_transit** tuple argument:  User Transit Name (Max 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type transit_overlay: access_group, in_out
    :param transit_overlay: Keyword argument tuple.

    :type access_group: unicode
    :param access_group: **transit_overlay** tuple argument:  Access Group Name (Max 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    :type in_out: unicode
    :param in_out: **transit_overlay** tuple argument.

        * enumeration restriction: ::

            ['in', 'out']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.overlay_transit', 'overlay_transit')]
    bindings_list = [('pybind.slxos.v16r_1_00b.overlay_transit.transit_overlay', 'pybind.slxos.v16r_1_00b.brocade_vxlan_visibility', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'user_transit_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'transit_overlay', 'keyval': 'access_group, in_out', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_transit=overlay_transit, transit_overlay=transit_overlay)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_transit=overlay_transit, transit_overlay=transit_overlay)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_transit_state_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.overlay_transit_state', 'pybind.slxos.v16r_1_00b.brocade_ssm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_transit_state_extended_data_delete(self, extended_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type extended_data: acl_name, seq_num
    :param extended_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.overlay_transit_state.extended_data', 'pybind.slxos.v16r_1_00b.brocade_ssm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended_data=extended_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended_data=extended_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_transit_state_extended_data_byte_count_delete(self, extended_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type extended_data: acl_name, seq_num
    :param extended_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.overlay_transit_state.extended_data', 'pybind.slxos.v16r_1_00b.brocade_ssm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'byte-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended_data=extended_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended_data=extended_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_transit_state_extended_data_count_delete(self, extended_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type extended_data: acl_name, seq_num
    :param extended_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.overlay_transit_state.extended_data', 'pybind.slxos.v16r_1_00b.brocade_ssm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended_data=extended_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended_data=extended_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_transit_state_extended_data_dst_ip_delete(self, extended_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type extended_data: acl_name, seq_num
    :param extended_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.overlay_transit_state.extended_data', 'pybind.slxos.v16r_1_00b.brocade_ssm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dst-ip'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended_data=extended_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended_data=extended_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_transit_state_extended_data_dst_ip_mask_delete(self, extended_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type extended_data: acl_name, seq_num
    :param extended_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.overlay_transit_state.extended_data', 'pybind.slxos.v16r_1_00b.brocade_ssm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dst-ip-mask'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended_data=extended_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended_data=extended_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_transit_state_extended_data_dst_port_delete(self, extended_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type extended_data: acl_name, seq_num
    :param extended_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.overlay_transit_state.extended_data', 'pybind.slxos.v16r_1_00b.brocade_ssm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dst-port'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended_data=extended_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended_data=extended_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_transit_state_extended_data_dst_vtep_ip_delete(self, extended_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type extended_data: acl_name, seq_num
    :param extended_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.overlay_transit_state.extended_data', 'pybind.slxos.v16r_1_00b.brocade_ssm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dst-vtep-ip'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended_data=extended_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended_data=extended_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_transit_state_extended_data_mirror_interface_delete(self, extended_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type extended_data: acl_name, seq_num
    :param extended_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.overlay_transit_state.extended_data', 'pybind.slxos.v16r_1_00b.brocade_ssm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mirror-interface'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended_data=extended_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended_data=extended_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_transit_state_extended_data_native_tag_delete(self, extended_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type extended_data: acl_name, seq_num
    :param extended_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.overlay_transit_state.extended_data', 'pybind.slxos.v16r_1_00b.brocade_ssm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'native-tag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended_data=extended_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended_data=extended_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_transit_state_extended_data_permit_deny_delete(self, extended_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type extended_data: acl_name, seq_num
    :param extended_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.overlay_transit_state.extended_data', 'pybind.slxos.v16r_1_00b.brocade_ssm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'permit-deny'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended_data=extended_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended_data=extended_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_transit_state_extended_data_redir_interface_delete(self, extended_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type extended_data: acl_name, seq_num
    :param extended_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.overlay_transit_state.extended_data', 'pybind.slxos.v16r_1_00b.brocade_ssm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redir-interface'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended_data=extended_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended_data=extended_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_transit_state_extended_data_sflow_delete(self, extended_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type extended_data: acl_name, seq_num
    :param extended_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.overlay_transit_state.extended_data', 'pybind.slxos.v16r_1_00b.brocade_ssm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'sflow'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended_data=extended_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended_data=extended_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_transit_state_extended_data_src_ip_delete(self, extended_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type extended_data: acl_name, seq_num
    :param extended_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.overlay_transit_state.extended_data', 'pybind.slxos.v16r_1_00b.brocade_ssm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'src-ip'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended_data=extended_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended_data=extended_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_transit_state_extended_data_src_ip_mask_delete(self, extended_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type extended_data: acl_name, seq_num
    :param extended_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.overlay_transit_state.extended_data', 'pybind.slxos.v16r_1_00b.brocade_ssm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'src-ip-mask'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended_data=extended_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended_data=extended_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_transit_state_extended_data_src_port_delete(self, extended_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type extended_data: acl_name, seq_num
    :param extended_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.overlay_transit_state.extended_data', 'pybind.slxos.v16r_1_00b.brocade_ssm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'src-port'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended_data=extended_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended_data=extended_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_transit_state_extended_data_src_vtep_ip_delete(self, extended_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type extended_data: acl_name, seq_num
    :param extended_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.overlay_transit_state.extended_data', 'pybind.slxos.v16r_1_00b.brocade_ssm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'src-vtep-ip'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended_data=extended_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended_data=extended_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_transit_state_extended_data_transit_name_delete(self, extended_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type extended_data: acl_name, seq_num
    :param extended_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.overlay_transit_state.extended_data', 'pybind.slxos.v16r_1_00b.brocade_ssm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'transit-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended_data=extended_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended_data=extended_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_transit_state_extended_data_vni_delete(self, extended_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type extended_data: acl_name, seq_num
    :param extended_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.overlay_transit_state.extended_data', 'pybind.slxos.v16r_1_00b.brocade_ssm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vni'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended_data=extended_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended_data=extended_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_transit_state_extended_data_vni_mask_delete(self, extended_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type extended_data: acl_name, seq_num
    :param extended_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.overlay_transit_state.extended_data', 'pybind.slxos.v16r_1_00b.brocade_ssm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vni-mask'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended_data=extended_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended_data=extended_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def overlay_transit_state_overlay_transit_name_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.overlay_transit_state', 'pybind.slxos.v16r_1_00b.brocade_ssm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'overlay-transit-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ovsdb_server_delete(self, ovsdb_server=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Instance Keyword Argument Tuple**:

    :type ovsdb_server: name
    :param ovsdb_server: Keyword argument tuple.

    :type name: unicode
    :param name: **ovsdb_server** tuple argument:  Ovsdb server name

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_0_1b.ovsdb_server', 'pybind.nos.v7_0_1b.brocade_tunnels', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ovsdb_server', 'pybind.nos.v7_1_0.brocade_tunnels', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'ovsdb_server', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v7_1_0.ovsdb_server": {}, "pybind.nos.v7_0_1b.ovsdb_server": {"activate": "activate", "name": "name", "port": "port"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ovsdb_server=ovsdb_server)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ovsdb_server=ovsdb_server)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ovsdb_server_activate_delete(self, ovsdb_server=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Instance Keyword Argument Tuple**:

    :type ovsdb_server: name
    :param ovsdb_server: Keyword argument tuple.

    :type name: unicode
    :param name: **ovsdb_server** tuple argument:  Ovsdb server name

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_0_1b.ovsdb_server', 'pybind.nos.v7_0_1b.brocade_tunnels', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ovsdb_server', 'pybind.nos.v7_1_0.brocade_tunnels', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'ovsdb_server', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'activate'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ovsdb_server=ovsdb_server)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ovsdb_server=ovsdb_server)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ovsdb_server_ip_delete(self, ovsdb_server=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ovsdb_server: name
    :param ovsdb_server: Keyword argument tuple.

    :type name: unicode
    :param name: **ovsdb_server** tuple argument:  Ovsdb server name

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.ovsdb_server', 'ovsdb_server')]
    bindings_list = [('pybind.nos.v7_1_0.ovsdb_server.ip', 'pybind.nos.v7_1_0.brocade_tunnels', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ovsdb_server=ovsdb_server)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ovsdb_server=ovsdb_server)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ovsdb_server_ip_address_delete(self, ovsdb_server=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ovsdb_server: name
    :param ovsdb_server: Keyword argument tuple.

    :type name: unicode
    :param name: **ovsdb_server** tuple argument:  Ovsdb server name

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.ovsdb_server', 'ovsdb_server')]
    bindings_list = [('pybind.nos.v7_1_0.ovsdb_server.ip', 'pybind.nos.v7_1_0.brocade_tunnels', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'address'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ovsdb_server=ovsdb_server)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ovsdb_server=ovsdb_server)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ovsdb_server_method_delete(self, ovsdb_server=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    **Instance Keyword Argument Tuple**:

    :type ovsdb_server: name
    :param ovsdb_server: Keyword argument tuple.

    :type name: unicode
    :param name: **ovsdb_server** tuple argument:  Ovsdb server name

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_1_0.ovsdb_server', 'pybind.nos.v7_1_0.brocade_tunnels', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'ovsdb_server', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'method'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ovsdb_server=ovsdb_server)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ovsdb_server=ovsdb_server)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ovsdb_server_port_delete(self, ovsdb_server=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Instance Keyword Argument Tuple**:

    :type ovsdb_server: name
    :param ovsdb_server: Keyword argument tuple.

    :type name: unicode
    :param name: **ovsdb_server** tuple argument:  Ovsdb server name

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_0_1b.ovsdb_server', 'pybind.nos.v7_0_1b.brocade_tunnels', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ovsdb_server', 'pybind.nos.v7_1_0.brocade_tunnels', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'ovsdb_server', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'port'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ovsdb_server=ovsdb_server)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ovsdb_server=ovsdb_server)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def password_attributes_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.password_attributes', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def password_attributes_admin_lockout_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.password_attributes', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.password_attributes', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.password_attributes', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.password_attributes', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'admin-lockout'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def password_attributes_character_restriction_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.password_attributes.character_restriction', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def password_attributes_character_restriction_lower_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.password_attributes.character_restriction', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.password_attributes.character_restriction', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.password_attributes.character_restriction', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.password_attributes.character_restriction', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lower'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def password_attributes_character_restriction_numeric_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.password_attributes.character_restriction', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.password_attributes.character_restriction', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.password_attributes.character_restriction', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.password_attributes.character_restriction', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'numeric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def password_attributes_character_restriction_special_char_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.password_attributes.character_restriction', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.password_attributes.character_restriction', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.password_attributes.character_restriction', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.password_attributes.character_restriction', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'special-char'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def password_attributes_character_restriction_upper_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.password_attributes.character_restriction', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.password_attributes.character_restriction', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.password_attributes.character_restriction', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.password_attributes.character_restriction', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'upper'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def password_attributes_max_lockout_duration_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.password_attributes', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.password_attributes', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.password_attributes', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.password_attributes', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'max-lockout-duration'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def password_attributes_max_retry_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.password_attributes', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.password_attributes', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.password_attributes', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.password_attributes', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'max-retry'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def password_attributes_min_length_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.password_attributes', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.password_attributes', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.password_attributes', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.password_attributes', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'min-length'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def pim_anycast_state_delete(self, pim_anycast_state=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type pim_anycast_state: anycast_rp
    :param pim_anycast_state: Keyword argument tuple.

    :type anycast_rp: unicode
    :param anycast_rp: **pim_anycast_state** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.pim_anycast_state', 'pybind.slxos.v16r_1_00b.brocade_pim_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'pim_anycast_state', 'keyval': 'anycast_rp', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim_anycast_state=pim_anycast_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim_anycast_state=pim_anycast_state)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def pim_anycast_state_peer_list_delete(self, pim_anycast_state=None, peer_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type pim_anycast_state: anycast_rp
    :param pim_anycast_state: Keyword argument tuple.

    :type anycast_rp: unicode
    :param anycast_rp: **pim_anycast_state** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type peer_list: ipv4_addr
    :param peer_list: Keyword argument tuple.

    :type ipv4_addr: long
    :param ipv4_addr: **peer_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.pim_anycast_state', 'pim_anycast_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.pim_anycast_state.peer_list', 'pybind.slxos.v16r_1_00b.brocade_pim_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'anycast_rp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'peer_list', 'keyval': 'ipv4_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim_anycast_state=pim_anycast_state, peer_list=peer_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim_anycast_state=pim_anycast_state, peer_list=peer_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def pim_anycast_state_prefix_name_delete(self, pim_anycast_state=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type pim_anycast_state: anycast_rp
    :param pim_anycast_state: Keyword argument tuple.

    :type anycast_rp: unicode
    :param anycast_rp: **pim_anycast_state** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.pim_anycast_state', 'pybind.slxos.v16r_1_00b.brocade_pim_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'pim_anycast_state', 'keyval': 'anycast_rp', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'prefix-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim_anycast_state=pim_anycast_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim_anycast_state=pim_anycast_state)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def pim_ecmp_state_delete(self, pim_ecmp_state=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type pim_ecmp_state: addr_filter
    :param pim_ecmp_state: Keyword argument tuple.

    :type addr_filter: unicode
    :param addr_filter: **pim_ecmp_state** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.pim_ecmp_state', 'pybind.slxos.v16r_1_00b.brocade_pim_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'pim_ecmp_state', 'keyval': 'addr_filter', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim_ecmp_state=pim_ecmp_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim_ecmp_state=pim_ecmp_state)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def pim_ecmp_state_pim_ecmp_delete(self, pim_ecmp_state=None, pim_ecmp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type pim_ecmp_state: addr_filter
    :param pim_ecmp_state: Keyword argument tuple.

    :type addr_filter: unicode
    :param addr_filter: **pim_ecmp_state** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type pim_ecmp: src_ip, rp_addr
    :param pim_ecmp: Keyword argument tuple.

    :type src_ip: unicode
    :param src_ip: **pim_ecmp** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type rp_addr: unicode
    :param rp_addr: **pim_ecmp** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.pim_ecmp_state', 'pim_ecmp_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.pim_ecmp_state.pim_ecmp', 'pybind.slxos.v16r_1_00b.brocade_pim_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'addr_filter', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'pim_ecmp', 'keyval': 'src_ip, rp_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim_ecmp_state=pim_ecmp_state, pim_ecmp=pim_ecmp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim_ecmp_state=pim_ecmp_state, pim_ecmp=pim_ecmp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def pim_ecmp_state_pim_ecmp_interface_count_delete(self, pim_ecmp_state=None, pim_ecmp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type pim_ecmp_state: addr_filter
    :param pim_ecmp_state: Keyword argument tuple.

    :type addr_filter: unicode
    :param addr_filter: **pim_ecmp_state** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type pim_ecmp: src_ip, rp_addr
    :param pim_ecmp: Keyword argument tuple.

    :type src_ip: unicode
    :param src_ip: **pim_ecmp** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type rp_addr: unicode
    :param rp_addr: **pim_ecmp** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.pim_ecmp_state', 'pim_ecmp_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.pim_ecmp_state.pim_ecmp', 'pybind.slxos.v16r_1_00b.brocade_pim_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'addr_filter', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'pim_ecmp', 'keyval': 'src_ip, rp_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'interface-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim_ecmp_state=pim_ecmp_state, pim_ecmp=pim_ecmp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim_ecmp_state=pim_ecmp_state, pim_ecmp=pim_ecmp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def pim_ecmp_state_pim_ecmp_interface_name_delete(self, pim_ecmp_state=None, pim_ecmp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type pim_ecmp_state: addr_filter
    :param pim_ecmp_state: Keyword argument tuple.

    :type addr_filter: unicode
    :param addr_filter: **pim_ecmp_state** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type pim_ecmp: src_ip, rp_addr
    :param pim_ecmp: Keyword argument tuple.

    :type src_ip: unicode
    :param src_ip: **pim_ecmp** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type rp_addr: unicode
    :param rp_addr: **pim_ecmp** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.pim_ecmp_state', 'pim_ecmp_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.pim_ecmp_state.pim_ecmp', 'pybind.slxos.v16r_1_00b.brocade_pim_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'addr_filter', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'pim_ecmp', 'keyval': 'src_ip, rp_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'interface-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim_ecmp_state=pim_ecmp_state, pim_ecmp=pim_ecmp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim_ecmp_state=pim_ecmp_state, pim_ecmp=pim_ecmp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def pim_ecmp_state_pim_ecmp_upstream_nbr_delete(self, pim_ecmp_state=None, pim_ecmp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type pim_ecmp_state: addr_filter
    :param pim_ecmp_state: Keyword argument tuple.

    :type addr_filter: unicode
    :param addr_filter: **pim_ecmp_state** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type pim_ecmp: src_ip, rp_addr
    :param pim_ecmp: Keyword argument tuple.

    :type src_ip: unicode
    :param src_ip: **pim_ecmp** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type rp_addr: unicode
    :param rp_addr: **pim_ecmp** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.pim_ecmp_state', 'pim_ecmp_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.pim_ecmp_state.pim_ecmp', 'pybind.slxos.v16r_1_00b.brocade_pim_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'addr_filter', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'pim_ecmp', 'keyval': 'src_ip, rp_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'upstream-nbr'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim_ecmp_state=pim_ecmp_state, pim_ecmp=pim_ecmp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim_ecmp_state=pim_ecmp_state, pim_ecmp=pim_ecmp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def pim_global_state_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.pim_global_state', 'pybind.slxos.v16r_1_00b.brocade_pim_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def pim_global_state_current_count_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.pim_global_state', 'pybind.slxos.v16r_1_00b.brocade_pim_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'current-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def pim_global_state_enable_status_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.pim_global_state', 'pybind.slxos.v16r_1_00b.brocade_pim_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def pim_global_state_hello_interval_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.pim_global_state', 'pybind.slxos.v16r_1_00b.brocade_pim_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hello-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def pim_global_state_hw_drop_status_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.pim_global_state', 'pybind.slxos.v16r_1_00b.brocade_pim_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hw-drop-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def pim_global_state_inact_interval_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.pim_global_state', 'pybind.slxos.v16r_1_00b.brocade_pim_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'inact-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def pim_global_state_interfaces_delete(self, interfaces=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type interfaces: interface_name
    :param interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interfaces** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.pim_global_state.interfaces', 'pybind.slxos.v16r_1_00b.brocade_pim_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interfaces', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def pim_global_state_interfaces_pim_interface_data_delete(self, interfaces=None, pim_interface_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_name
    :param interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interfaces** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type pim_interface_data: interface_name, interface_type
    :param pim_interface_data: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **pim_interface_data** tuple argument.

    :type interface_type: unicode
    :param interface_type: **pim_interface_data** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.pim_global_state.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v16r_1_00b.pim_global_state.interfaces.pim_interface_data', 'pybind.slxos.v16r_1_00b.brocade_pim_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'pim_interface_data', 'keyval': 'interface_name, interface_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces, pim_interface_data=pim_interface_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces, pim_interface_data=pim_interface_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def pim_global_state_interfaces_pim_interface_data_dr_info_delete(self, interfaces=None, pim_interface_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_name
    :param interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interfaces** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type pim_interface_data: interface_name, interface_type
    :param pim_interface_data: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **pim_interface_data** tuple argument.

    :type interface_type: unicode
    :param interface_type: **pim_interface_data** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.pim_global_state.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v16r_1_00b.pim_global_state.interfaces.pim_interface_data', 'pybind.slxos.v16r_1_00b.brocade_pim_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'pim_interface_data', 'keyval': 'interface_name, interface_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dr-info'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces, pim_interface_data=pim_interface_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces, pim_interface_data=pim_interface_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def pim_global_state_interfaces_pim_interface_data_dr_priority_delete(self, interfaces=None, pim_interface_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_name
    :param interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interfaces** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type pim_interface_data: interface_name, interface_type
    :param pim_interface_data: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **pim_interface_data** tuple argument.

    :type interface_type: unicode
    :param interface_type: **pim_interface_data** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.pim_global_state.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v16r_1_00b.pim_global_state.interfaces.pim_interface_data', 'pybind.slxos.v16r_1_00b.brocade_pim_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'pim_interface_data', 'keyval': 'interface_name, interface_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dr-priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces, pim_interface_data=pim_interface_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces, pim_interface_data=pim_interface_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def pim_global_state_interfaces_pim_interface_data_enable_status_delete(self, interfaces=None, pim_interface_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_name
    :param interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interfaces** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type pim_interface_data: interface_name, interface_type
    :param pim_interface_data: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **pim_interface_data** tuple argument.

    :type interface_type: unicode
    :param interface_type: **pim_interface_data** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.pim_global_state.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v16r_1_00b.pim_global_state.interfaces.pim_interface_data', 'pybind.slxos.v16r_1_00b.brocade_pim_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'pim_interface_data', 'keyval': 'interface_name, interface_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces, pim_interface_data=pim_interface_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces, pim_interface_data=pim_interface_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def pim_global_state_interfaces_pim_interface_data_local_ip_addr_delete(self, interfaces=None, pim_interface_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_name
    :param interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interfaces** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type pim_interface_data: interface_name, interface_type
    :param pim_interface_data: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **pim_interface_data** tuple argument.

    :type interface_type: unicode
    :param interface_type: **pim_interface_data** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.pim_global_state.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v16r_1_00b.pim_global_state.interfaces.pim_interface_data', 'pybind.slxos.v16r_1_00b.brocade_pim_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'pim_interface_data', 'keyval': 'interface_name, interface_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'local-ip-addr'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces, pim_interface_data=pim_interface_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces, pim_interface_data=pim_interface_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def pim_global_state_interfaces_pim_interface_data_mode_delete(self, interfaces=None, pim_interface_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_name
    :param interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interfaces** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type pim_interface_data: interface_name, interface_type
    :param pim_interface_data: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **pim_interface_data** tuple argument.

    :type interface_type: unicode
    :param interface_type: **pim_interface_data** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.pim_global_state.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v16r_1_00b.pim_global_state.interfaces.pim_interface_data', 'pybind.slxos.v16r_1_00b.brocade_pim_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'pim_interface_data', 'keyval': 'interface_name, interface_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mode'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces, pim_interface_data=pim_interface_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces, pim_interface_data=pim_interface_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def pim_global_state_interfaces_pim_interface_data_multicast_boundry_delete(self, interfaces=None, pim_interface_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_name
    :param interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interfaces** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type pim_interface_data: interface_name, interface_type
    :param pim_interface_data: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **pim_interface_data** tuple argument.

    :type interface_type: unicode
    :param interface_type: **pim_interface_data** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.pim_global_state.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v16r_1_00b.pim_global_state.interfaces.pim_interface_data', 'pybind.slxos.v16r_1_00b.brocade_pim_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'pim_interface_data', 'keyval': 'interface_name, interface_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'multicast-boundry'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces, pim_interface_data=pim_interface_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces, pim_interface_data=pim_interface_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def pim_global_state_interfaces_pim_interface_data_pim_version_delete(self, interfaces=None, pim_interface_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_name
    :param interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interfaces** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type pim_interface_data: interface_name, interface_type
    :param pim_interface_data: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **pim_interface_data** tuple argument.

    :type interface_type: unicode
    :param interface_type: **pim_interface_data** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.pim_global_state.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v16r_1_00b.pim_global_state.interfaces.pim_interface_data', 'pybind.slxos.v16r_1_00b.brocade_pim_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'pim_interface_data', 'keyval': 'interface_name, interface_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'pim-version'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces, pim_interface_data=pim_interface_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces, pim_interface_data=pim_interface_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def pim_global_state_interfaces_pim_interface_data_ttl_threshold_delete(self, interfaces=None, pim_interface_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_name
    :param interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interfaces** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type pim_interface_data: interface_name, interface_type
    :param pim_interface_data: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **pim_interface_data** tuple argument.

    :type interface_type: unicode
    :param interface_type: **pim_interface_data** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.pim_global_state.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v16r_1_00b.pim_global_state.interfaces.pim_interface_data', 'pybind.slxos.v16r_1_00b.brocade_pim_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'pim_interface_data', 'keyval': 'interface_name, interface_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ttl-threshold'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces, pim_interface_data=pim_interface_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces, pim_interface_data=pim_interface_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def pim_global_state_jp_interval_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.pim_global_state', 'pybind.slxos.v16r_1_00b.brocade_pim_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'jp-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def pim_global_state_max_mcache_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.pim_global_state', 'pybind.slxos.v16r_1_00b.brocade_pim_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'max-mcache'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def pim_global_state_nbr_timeout_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.pim_global_state', 'pybind.slxos.v16r_1_00b.brocade_pim_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'nbr-timeout'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def pim_global_state_prune_wait_interval_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.pim_global_state', 'pybind.slxos.v16r_1_00b.brocade_pim_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'prune-wait-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def pim_global_state_reg_probe_time_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.pim_global_state', 'pybind.slxos.v16r_1_00b.brocade_pim_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'reg-probe-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def pim_global_state_reg_stop_delay_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.pim_global_state', 'pybind.slxos.v16r_1_00b.brocade_pim_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'reg-stop-delay'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def pim_global_state_reg_suppress_interval_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.pim_global_state', 'pybind.slxos.v16r_1_00b.brocade_pim_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'reg-suppress-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def pim_global_state_reg_suppress_time_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.pim_global_state', 'pybind.slxos.v16r_1_00b.brocade_pim_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'reg-suppress-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def pim_global_state_route_precedence_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.pim_global_state', 'pybind.slxos.v16r_1_00b.brocade_pim_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-precedence'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def pim_global_state_spt_threshold_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.pim_global_state', 'pybind.slxos.v16r_1_00b.brocade_pim_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'spt-threshold'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def pim_global_state_ssm_default_prefix_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.pim_global_state', 'pybind.slxos.v16r_1_00b.brocade_pim_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ssm-default-prefix'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def pim_global_state_ssm_prefix_name_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.pim_global_state', 'pybind.slxos.v16r_1_00b.brocade_pim_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ssm-prefix-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def pim_global_state_ssm_status_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.pim_global_state', 'pybind.slxos.v16r_1_00b.brocade_pim_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ssm-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def police_priority_map_delete(self, police_priority_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Instance Keyword Argument Tuple**:

    :type police_priority_map: name
    :param police_priority_map: Keyword argument tuple.

    :type name: unicode
    :param name: **police_priority_map** tuple argument:  Policer Priority Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.police_priority_map', 'pybind.nos.v6_0_2c.brocade_policer', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.police_priority_map', 'pybind.nos.v7_0_1b.brocade_policer', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.police_priority_map', 'pybind.nos.v7_1_0.brocade_policer', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'police_priority_map', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, police_priority_map=police_priority_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, police_priority_map=police_priority_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def police_priority_map_conform_delete(self, police_priority_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type police_priority_map: name
    :param police_priority_map: Keyword argument tuple.

    :type name: unicode
    :param name: **police_priority_map** tuple argument:  Policer Priority Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.police_priority_map', 'police_priority_map'), ('pybind.nos.v7_0_1b.police_priority_map', 'police_priority_map'), ('pybind.nos.v7_1_0.police_priority_map', 'police_priority_map')]
    bindings_list = [('pybind.nos.v6_0_2c.police_priority_map.conform', 'pybind.nos.v6_0_2c.brocade_policer', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.police_priority_map.conform', 'pybind.nos.v7_0_1b.brocade_policer', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.police_priority_map.conform', 'pybind.nos.v7_1_0.brocade_policer', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'map_pri0_conform, map_pri1_conform, map_pri2_conform, map_pri3_conform, map_pri4_conform, map_pri5_conform, map_pri6_conform, map_pri7_conform'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, police_priority_map=police_priority_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, police_priority_map=police_priority_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def police_priority_map_conform_map_pri0_conform_delete(self, police_priority_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type police_priority_map: name
    :param police_priority_map: Keyword argument tuple.

    :type name: unicode
    :param name: **police_priority_map** tuple argument:  Policer Priority Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.police_priority_map', 'police_priority_map'), ('pybind.nos.v7_0_1b.police_priority_map', 'police_priority_map'), ('pybind.nos.v7_1_0.police_priority_map', 'police_priority_map')]
    bindings_list = [('pybind.nos.v6_0_2c.police_priority_map.conform', 'pybind.nos.v6_0_2c.brocade_policer', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.police_priority_map.conform', 'pybind.nos.v7_0_1b.brocade_policer', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.police_priority_map.conform', 'pybind.nos.v7_1_0.brocade_policer', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'map-pri0-conform'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, police_priority_map=police_priority_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, police_priority_map=police_priority_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def police_priority_map_conform_map_pri1_conform_delete(self, police_priority_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type police_priority_map: name
    :param police_priority_map: Keyword argument tuple.

    :type name: unicode
    :param name: **police_priority_map** tuple argument:  Policer Priority Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.police_priority_map', 'police_priority_map'), ('pybind.nos.v7_0_1b.police_priority_map', 'police_priority_map'), ('pybind.nos.v7_1_0.police_priority_map', 'police_priority_map')]
    bindings_list = [('pybind.nos.v6_0_2c.police_priority_map.conform', 'pybind.nos.v6_0_2c.brocade_policer', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.police_priority_map.conform', 'pybind.nos.v7_0_1b.brocade_policer', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.police_priority_map.conform', 'pybind.nos.v7_1_0.brocade_policer', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'map-pri1-conform'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, police_priority_map=police_priority_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, police_priority_map=police_priority_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def police_priority_map_conform_map_pri2_conform_delete(self, police_priority_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type police_priority_map: name
    :param police_priority_map: Keyword argument tuple.

    :type name: unicode
    :param name: **police_priority_map** tuple argument:  Policer Priority Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.police_priority_map', 'police_priority_map'), ('pybind.nos.v7_0_1b.police_priority_map', 'police_priority_map'), ('pybind.nos.v7_1_0.police_priority_map', 'police_priority_map')]
    bindings_list = [('pybind.nos.v6_0_2c.police_priority_map.conform', 'pybind.nos.v6_0_2c.brocade_policer', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.police_priority_map.conform', 'pybind.nos.v7_0_1b.brocade_policer', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.police_priority_map.conform', 'pybind.nos.v7_1_0.brocade_policer', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'map-pri2-conform'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, police_priority_map=police_priority_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, police_priority_map=police_priority_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def police_priority_map_conform_map_pri3_conform_delete(self, police_priority_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type police_priority_map: name
    :param police_priority_map: Keyword argument tuple.

    :type name: unicode
    :param name: **police_priority_map** tuple argument:  Policer Priority Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.police_priority_map', 'police_priority_map'), ('pybind.nos.v7_0_1b.police_priority_map', 'police_priority_map'), ('pybind.nos.v7_1_0.police_priority_map', 'police_priority_map')]
    bindings_list = [('pybind.nos.v6_0_2c.police_priority_map.conform', 'pybind.nos.v6_0_2c.brocade_policer', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.police_priority_map.conform', 'pybind.nos.v7_0_1b.brocade_policer', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.police_priority_map.conform', 'pybind.nos.v7_1_0.brocade_policer', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'map-pri3-conform'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, police_priority_map=police_priority_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, police_priority_map=police_priority_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def police_priority_map_conform_map_pri4_conform_delete(self, police_priority_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type police_priority_map: name
    :param police_priority_map: Keyword argument tuple.

    :type name: unicode
    :param name: **police_priority_map** tuple argument:  Policer Priority Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.police_priority_map', 'police_priority_map'), ('pybind.nos.v7_0_1b.police_priority_map', 'police_priority_map'), ('pybind.nos.v7_1_0.police_priority_map', 'police_priority_map')]
    bindings_list = [('pybind.nos.v6_0_2c.police_priority_map.conform', 'pybind.nos.v6_0_2c.brocade_policer', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.police_priority_map.conform', 'pybind.nos.v7_0_1b.brocade_policer', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.police_priority_map.conform', 'pybind.nos.v7_1_0.brocade_policer', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'map-pri4-conform'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, police_priority_map=police_priority_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, police_priority_map=police_priority_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def police_priority_map_conform_map_pri5_conform_delete(self, police_priority_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type police_priority_map: name
    :param police_priority_map: Keyword argument tuple.

    :type name: unicode
    :param name: **police_priority_map** tuple argument:  Policer Priority Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.police_priority_map', 'police_priority_map'), ('pybind.nos.v7_0_1b.police_priority_map', 'police_priority_map'), ('pybind.nos.v7_1_0.police_priority_map', 'police_priority_map')]
    bindings_list = [('pybind.nos.v6_0_2c.police_priority_map.conform', 'pybind.nos.v6_0_2c.brocade_policer', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.police_priority_map.conform', 'pybind.nos.v7_0_1b.brocade_policer', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.police_priority_map.conform', 'pybind.nos.v7_1_0.brocade_policer', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'map-pri5-conform'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, police_priority_map=police_priority_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, police_priority_map=police_priority_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def police_priority_map_conform_map_pri6_conform_delete(self, police_priority_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type police_priority_map: name
    :param police_priority_map: Keyword argument tuple.

    :type name: unicode
    :param name: **police_priority_map** tuple argument:  Policer Priority Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.police_priority_map', 'police_priority_map'), ('pybind.nos.v7_0_1b.police_priority_map', 'police_priority_map'), ('pybind.nos.v7_1_0.police_priority_map', 'police_priority_map')]
    bindings_list = [('pybind.nos.v6_0_2c.police_priority_map.conform', 'pybind.nos.v6_0_2c.brocade_policer', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.police_priority_map.conform', 'pybind.nos.v7_0_1b.brocade_policer', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.police_priority_map.conform', 'pybind.nos.v7_1_0.brocade_policer', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'map-pri6-conform'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, police_priority_map=police_priority_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, police_priority_map=police_priority_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def police_priority_map_conform_map_pri7_conform_delete(self, police_priority_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type police_priority_map: name
    :param police_priority_map: Keyword argument tuple.

    :type name: unicode
    :param name: **police_priority_map** tuple argument:  Policer Priority Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.police_priority_map', 'police_priority_map'), ('pybind.nos.v7_0_1b.police_priority_map', 'police_priority_map'), ('pybind.nos.v7_1_0.police_priority_map', 'police_priority_map')]
    bindings_list = [('pybind.nos.v6_0_2c.police_priority_map.conform', 'pybind.nos.v6_0_2c.brocade_policer', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.police_priority_map.conform', 'pybind.nos.v7_0_1b.brocade_policer', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.police_priority_map.conform', 'pybind.nos.v7_1_0.brocade_policer', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'map-pri7-conform'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, police_priority_map=police_priority_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, police_priority_map=police_priority_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def police_priority_map_exceed_delete(self, police_priority_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type police_priority_map: name
    :param police_priority_map: Keyword argument tuple.

    :type name: unicode
    :param name: **police_priority_map** tuple argument:  Policer Priority Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.police_priority_map', 'police_priority_map'), ('pybind.nos.v7_1_0.police_priority_map', 'police_priority_map'), ('pybind.nos.v6_0_2c.police_priority_map', 'police_priority_map')]
    bindings_list = [('pybind.nos.v6_0_2c.police_priority_map.exceed', 'pybind.nos.v6_0_2c.brocade_policer', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.police_priority_map.exceed', 'pybind.nos.v7_0_1b.brocade_policer', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.police_priority_map.exceed', 'pybind.nos.v7_1_0.brocade_policer', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'map_pri0_exceed, map_pri1_exceed, map_pri2_exceed, map_pri3_exceed, map_pri4_exceed, map_pri5_exceed, map_pri6_exceed, map_pri7_exceed'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, police_priority_map=police_priority_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, police_priority_map=police_priority_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def police_priority_map_exceed_map_pri0_exceed_delete(self, police_priority_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type police_priority_map: name
    :param police_priority_map: Keyword argument tuple.

    :type name: unicode
    :param name: **police_priority_map** tuple argument:  Policer Priority Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.police_priority_map', 'police_priority_map'), ('pybind.nos.v7_1_0.police_priority_map', 'police_priority_map'), ('pybind.nos.v6_0_2c.police_priority_map', 'police_priority_map')]
    bindings_list = [('pybind.nos.v6_0_2c.police_priority_map.exceed', 'pybind.nos.v6_0_2c.brocade_policer', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.police_priority_map.exceed', 'pybind.nos.v7_0_1b.brocade_policer', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.police_priority_map.exceed', 'pybind.nos.v7_1_0.brocade_policer', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'map-pri0-exceed'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, police_priority_map=police_priority_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, police_priority_map=police_priority_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def police_priority_map_exceed_map_pri1_exceed_delete(self, police_priority_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type police_priority_map: name
    :param police_priority_map: Keyword argument tuple.

    :type name: unicode
    :param name: **police_priority_map** tuple argument:  Policer Priority Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.police_priority_map', 'police_priority_map'), ('pybind.nos.v7_1_0.police_priority_map', 'police_priority_map'), ('pybind.nos.v6_0_2c.police_priority_map', 'police_priority_map')]
    bindings_list = [('pybind.nos.v6_0_2c.police_priority_map.exceed', 'pybind.nos.v6_0_2c.brocade_policer', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.police_priority_map.exceed', 'pybind.nos.v7_0_1b.brocade_policer', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.police_priority_map.exceed', 'pybind.nos.v7_1_0.brocade_policer', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'map-pri1-exceed'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, police_priority_map=police_priority_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, police_priority_map=police_priority_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def police_priority_map_exceed_map_pri2_exceed_delete(self, police_priority_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type police_priority_map: name
    :param police_priority_map: Keyword argument tuple.

    :type name: unicode
    :param name: **police_priority_map** tuple argument:  Policer Priority Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.police_priority_map', 'police_priority_map'), ('pybind.nos.v7_1_0.police_priority_map', 'police_priority_map'), ('pybind.nos.v6_0_2c.police_priority_map', 'police_priority_map')]
    bindings_list = [('pybind.nos.v6_0_2c.police_priority_map.exceed', 'pybind.nos.v6_0_2c.brocade_policer', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.police_priority_map.exceed', 'pybind.nos.v7_0_1b.brocade_policer', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.police_priority_map.exceed', 'pybind.nos.v7_1_0.brocade_policer', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'map-pri2-exceed'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, police_priority_map=police_priority_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, police_priority_map=police_priority_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def police_priority_map_exceed_map_pri3_exceed_delete(self, police_priority_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type police_priority_map: name
    :param police_priority_map: Keyword argument tuple.

    :type name: unicode
    :param name: **police_priority_map** tuple argument:  Policer Priority Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.police_priority_map', 'police_priority_map'), ('pybind.nos.v7_1_0.police_priority_map', 'police_priority_map'), ('pybind.nos.v6_0_2c.police_priority_map', 'police_priority_map')]
    bindings_list = [('pybind.nos.v6_0_2c.police_priority_map.exceed', 'pybind.nos.v6_0_2c.brocade_policer', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.police_priority_map.exceed', 'pybind.nos.v7_0_1b.brocade_policer', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.police_priority_map.exceed', 'pybind.nos.v7_1_0.brocade_policer', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'map-pri3-exceed'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, police_priority_map=police_priority_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, police_priority_map=police_priority_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def police_priority_map_exceed_map_pri4_exceed_delete(self, police_priority_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type police_priority_map: name
    :param police_priority_map: Keyword argument tuple.

    :type name: unicode
    :param name: **police_priority_map** tuple argument:  Policer Priority Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.police_priority_map', 'police_priority_map'), ('pybind.nos.v7_1_0.police_priority_map', 'police_priority_map'), ('pybind.nos.v6_0_2c.police_priority_map', 'police_priority_map')]
    bindings_list = [('pybind.nos.v6_0_2c.police_priority_map.exceed', 'pybind.nos.v6_0_2c.brocade_policer', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.police_priority_map.exceed', 'pybind.nos.v7_0_1b.brocade_policer', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.police_priority_map.exceed', 'pybind.nos.v7_1_0.brocade_policer', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'map-pri4-exceed'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, police_priority_map=police_priority_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, police_priority_map=police_priority_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def police_priority_map_exceed_map_pri5_exceed_delete(self, police_priority_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type police_priority_map: name
    :param police_priority_map: Keyword argument tuple.

    :type name: unicode
    :param name: **police_priority_map** tuple argument:  Policer Priority Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.police_priority_map', 'police_priority_map'), ('pybind.nos.v7_1_0.police_priority_map', 'police_priority_map'), ('pybind.nos.v6_0_2c.police_priority_map', 'police_priority_map')]
    bindings_list = [('pybind.nos.v6_0_2c.police_priority_map.exceed', 'pybind.nos.v6_0_2c.brocade_policer', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.police_priority_map.exceed', 'pybind.nos.v7_0_1b.brocade_policer', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.police_priority_map.exceed', 'pybind.nos.v7_1_0.brocade_policer', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'map-pri5-exceed'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, police_priority_map=police_priority_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, police_priority_map=police_priority_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def police_priority_map_exceed_map_pri6_exceed_delete(self, police_priority_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type police_priority_map: name
    :param police_priority_map: Keyword argument tuple.

    :type name: unicode
    :param name: **police_priority_map** tuple argument:  Policer Priority Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.police_priority_map', 'police_priority_map'), ('pybind.nos.v7_1_0.police_priority_map', 'police_priority_map'), ('pybind.nos.v6_0_2c.police_priority_map', 'police_priority_map')]
    bindings_list = [('pybind.nos.v6_0_2c.police_priority_map.exceed', 'pybind.nos.v6_0_2c.brocade_policer', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.police_priority_map.exceed', 'pybind.nos.v7_0_1b.brocade_policer', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.police_priority_map.exceed', 'pybind.nos.v7_1_0.brocade_policer', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'map-pri6-exceed'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, police_priority_map=police_priority_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, police_priority_map=police_priority_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def police_priority_map_exceed_map_pri7_exceed_delete(self, police_priority_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type police_priority_map: name
    :param police_priority_map: Keyword argument tuple.

    :type name: unicode
    :param name: **police_priority_map** tuple argument:  Policer Priority Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.police_priority_map', 'police_priority_map'), ('pybind.nos.v7_1_0.police_priority_map', 'police_priority_map'), ('pybind.nos.v6_0_2c.police_priority_map', 'police_priority_map')]
    bindings_list = [('pybind.nos.v6_0_2c.police_priority_map.exceed', 'pybind.nos.v6_0_2c.brocade_policer', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.police_priority_map.exceed', 'pybind.nos.v7_0_1b.brocade_policer', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.police_priority_map.exceed', 'pybind.nos.v7_1_0.brocade_policer', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'map-pri7-exceed'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, police_priority_map=police_priority_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, police_priority_map=police_priority_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def policy_map_delete(self, policy_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type policy_map: po_name
    :param policy_map: Keyword argument tuple.

    :type po_name: unicode
    :param po_name: **policy_map** tuple argument:  Policy Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.policy_map', 'pybind.nos.v6_0_2c.brocade_policer', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.policy_map', 'pybind.nos.v7_0_1b.brocade_policer', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.policy_map', 'pybind.nos.v7_1_0.brocade_policer', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.policy_map', 'pybind.slxos.v16r_1_00b.brocade_qos_mqc', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'policy_map', 'keyval': 'po_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v7_0_1b.policy_map": {"po_name": "po_name"}, "pybind.nos.v7_1_0.policy_map": {"po_name": "po_name"}, "pybind.slxos.v16r_1_00b.policy_map": {"po_name": "name"}, "pybind.nos.v6_0_2c.policy_map": {"po_name": "po_name"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_map=policy_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_map=policy_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def policy_map_class_delete(self, policy_map=None, class_=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy_map: po_name
    :param policy_map: Keyword argument tuple.

    :type po_name: unicode
    :param po_name: **policy_map** tuple argument:  Policy Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    **Instance Keyword Argument Tuple**:

    :type class_: cl_name
    :param class_: Keyword argument tuple.

    :type cl_name: unicode
    :param cl_name: **class_** tuple argument:  Policy Map Class Name (Max Size -64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.policy_map', 'policy_map'), ('pybind.nos.v7_0_1b.policy_map', 'policy_map'), ('pybind.nos.v6_0_2c.policy_map', 'policy_map'), ('pybind.slxos.v16r_1_00b.policy_map', 'policy_map')]
    bindings_list = [('pybind.nos.v6_0_2c.policy_map.class_', 'pybind.nos.v6_0_2c.brocade_policer', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.policy_map.class_', 'pybind.nos.v7_0_1b.brocade_policer', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.policy_map.class_', 'pybind.nos.v7_1_0.brocade_policer', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.policy_map.class_', 'pybind.slxos.v16r_1_00b.brocade_qos_mqc', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'class_', 'keyval': 'cl_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v6_0_2c.policy_map.class_": {"cl_name": "cl_name"}, "pybind.slxos.v16r_1_00b.policy_map.class_": {}, "pybind.nos.v7_0_1b.policy_map.class_": {"cl_name": "cl_name"}, "pybind.nos.v7_1_0.policy_map.class_": {"cl_name": "cl_name"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_map=policy_map, class_=class_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_map=policy_map, class_=class_)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def policy_map_class_map_cos_mutation_delete(self, policy_map=None, class_=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy_map: po_name
    :param policy_map: Keyword argument tuple.

    :type po_name: unicode
    :param po_name: **policy_map** tuple argument:  Policy Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type class_: cl_name
    :param class_: Keyword argument tuple.

    :type cl_name: unicode
    :param cl_name: **class_** tuple argument:  Policy Map Class Name (Max Size -64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.policy_map', 'policy_map'), ('pybind.slxos.v16r_1_00b.policy_map.class_', u'class_'), ('pybind.nos.v6_0_2c.policy_map', 'policy_map'), ('pybind.nos.v6_0_2c.policy_map.class_', u'class_'), ('pybind.nos.v7_1_0.policy_map', 'policy_map'), ('pybind.nos.v7_1_0.policy_map.class_', u'class_'), ('pybind.nos.v7_0_1b.policy_map', 'policy_map'), ('pybind.nos.v7_0_1b.policy_map.class_', u'class_')]
    bindings_list = [('pybind.nos.v6_0_2c.policy_map.class_.map_', 'pybind.nos.v6_0_2c.brocade_policer', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.policy_map.class_.map_', 'pybind.nos.v7_0_1b.brocade_policer', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.policy_map.class_.map_', 'pybind.nos.v7_1_0.brocade_policer', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.policy_map.class_.map_', 'pybind.slxos.v16r_1_00b.brocade_qos_mqc', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cos-mutation'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_map=policy_map, class_=class_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_map=policy_map, class_=class_)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def policy_map_class_map_cos_traffic_class_delete(self, policy_map=None, class_=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy_map: po_name
    :param policy_map: Keyword argument tuple.

    :type po_name: unicode
    :param po_name: **policy_map** tuple argument:  Policy Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type class_: cl_name
    :param class_: Keyword argument tuple.

    :type cl_name: unicode
    :param cl_name: **class_** tuple argument:  Policy Map Class Name (Max Size -64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.policy_map', 'policy_map'), ('pybind.slxos.v16r_1_00b.policy_map.class_', u'class_'), ('pybind.nos.v6_0_2c.policy_map', 'policy_map'), ('pybind.nos.v6_0_2c.policy_map.class_', u'class_'), ('pybind.nos.v7_1_0.policy_map', 'policy_map'), ('pybind.nos.v7_1_0.policy_map.class_', u'class_'), ('pybind.nos.v7_0_1b.policy_map', 'policy_map'), ('pybind.nos.v7_0_1b.policy_map.class_', u'class_')]
    bindings_list = [('pybind.nos.v6_0_2c.policy_map.class_.map_', 'pybind.nos.v6_0_2c.brocade_policer', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.policy_map.class_.map_', 'pybind.nos.v7_0_1b.brocade_policer', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.policy_map.class_.map_', 'pybind.nos.v7_1_0.brocade_policer', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.policy_map.class_.map_', 'pybind.slxos.v16r_1_00b.brocade_qos_mqc', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cos-traffic-class'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_map=policy_map, class_=class_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_map=policy_map, class_=class_)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def policy_map_class_map_dscp_cos_delete(self, policy_map=None, class_=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy_map: po_name
    :param policy_map: Keyword argument tuple.

    :type po_name: unicode
    :param po_name: **policy_map** tuple argument:  Policy Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type class_: cl_name
    :param class_: Keyword argument tuple.

    :type cl_name: unicode
    :param cl_name: **class_** tuple argument:  Policy Map Class Name (Max Size -64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.policy_map', 'policy_map'), ('pybind.slxos.v16r_1_00b.policy_map.class_', u'class_'), ('pybind.nos.v6_0_2c.policy_map', 'policy_map'), ('pybind.nos.v6_0_2c.policy_map.class_', u'class_'), ('pybind.nos.v7_1_0.policy_map', 'policy_map'), ('pybind.nos.v7_1_0.policy_map.class_', u'class_'), ('pybind.nos.v7_0_1b.policy_map', 'policy_map'), ('pybind.nos.v7_0_1b.policy_map.class_', u'class_')]
    bindings_list = [('pybind.nos.v6_0_2c.policy_map.class_.map_', 'pybind.nos.v6_0_2c.brocade_policer', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.policy_map.class_.map_', 'pybind.nos.v7_0_1b.brocade_policer', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.policy_map.class_.map_', 'pybind.nos.v7_1_0.brocade_policer', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.policy_map.class_.map_', 'pybind.slxos.v16r_1_00b.brocade_qos_mqc', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dscp-cos'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_map=policy_map, class_=class_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_map=policy_map, class_=class_)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def policy_map_class_map_dscp_mutation_delete(self, policy_map=None, class_=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy_map: po_name
    :param policy_map: Keyword argument tuple.

    :type po_name: unicode
    :param po_name: **policy_map** tuple argument:  Policy Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type class_: cl_name
    :param class_: Keyword argument tuple.

    :type cl_name: unicode
    :param cl_name: **class_** tuple argument:  Policy Map Class Name (Max Size -64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.policy_map', 'policy_map'), ('pybind.slxos.v16r_1_00b.policy_map.class_', u'class_'), ('pybind.nos.v6_0_2c.policy_map', 'policy_map'), ('pybind.nos.v6_0_2c.policy_map.class_', u'class_'), ('pybind.nos.v7_1_0.policy_map', 'policy_map'), ('pybind.nos.v7_1_0.policy_map.class_', u'class_'), ('pybind.nos.v7_0_1b.policy_map', 'policy_map'), ('pybind.nos.v7_0_1b.policy_map.class_', u'class_')]
    bindings_list = [('pybind.nos.v6_0_2c.policy_map.class_.map_', 'pybind.nos.v6_0_2c.brocade_policer', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.policy_map.class_.map_', 'pybind.nos.v7_0_1b.brocade_policer', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.policy_map.class_.map_', 'pybind.nos.v7_1_0.brocade_policer', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.policy_map.class_.map_', 'pybind.slxos.v16r_1_00b.brocade_qos_mqc', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dscp-mutation'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_map=policy_map, class_=class_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_map=policy_map, class_=class_)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def policy_map_class_map_dscp_traffic_class_delete(self, policy_map=None, class_=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy_map: po_name
    :param policy_map: Keyword argument tuple.

    :type po_name: unicode
    :param po_name: **policy_map** tuple argument:  Policy Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type class_: cl_name
    :param class_: Keyword argument tuple.

    :type cl_name: unicode
    :param cl_name: **class_** tuple argument:  Policy Map Class Name (Max Size -64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.policy_map', 'policy_map'), ('pybind.slxos.v16r_1_00b.policy_map.class_', u'class_'), ('pybind.nos.v6_0_2c.policy_map', 'policy_map'), ('pybind.nos.v6_0_2c.policy_map.class_', u'class_'), ('pybind.nos.v7_1_0.policy_map', 'policy_map'), ('pybind.nos.v7_1_0.policy_map.class_', u'class_'), ('pybind.nos.v7_0_1b.policy_map', 'policy_map'), ('pybind.nos.v7_0_1b.policy_map.class_', u'class_')]
    bindings_list = [('pybind.nos.v6_0_2c.policy_map.class_.map_', 'pybind.nos.v6_0_2c.brocade_policer', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.policy_map.class_.map_', 'pybind.nos.v7_0_1b.brocade_policer', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.policy_map.class_.map_', 'pybind.nos.v7_1_0.brocade_policer', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.policy_map.class_.map_', 'pybind.slxos.v16r_1_00b.brocade_qos_mqc', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dscp-traffic-class'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_map=policy_map, class_=class_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_map=policy_map, class_=class_)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def policy_map_class_map_sflow_delete(self, policy_map=None, class_=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy_map: po_name
    :param policy_map: Keyword argument tuple.

    :type po_name: unicode
    :param po_name: **policy_map** tuple argument:  Policy Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type class_: cl_name
    :param class_: Keyword argument tuple.

    :type cl_name: unicode
    :param cl_name: **class_** tuple argument:  Policy Map Class Name (Max Size -64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.policy_map', 'policy_map'), ('pybind.nos.v6_0_2c.policy_map.class_', u'class_'), ('pybind.nos.v7_1_0.policy_map', 'policy_map'), ('pybind.nos.v7_1_0.policy_map.class_', u'class_'), ('pybind.nos.v7_0_1b.policy_map', 'policy_map'), ('pybind.nos.v7_0_1b.policy_map.class_', u'class_')]
    bindings_list = [('pybind.nos.v6_0_2c.policy_map.class_.map_', 'pybind.nos.v6_0_2c.brocade_policer', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.policy_map.class_.map_', 'pybind.nos.v7_0_1b.brocade_policer', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.policy_map.class_.map_', 'pybind.nos.v7_1_0.brocade_policer', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'sflow'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_map=policy_map, class_=class_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_map=policy_map, class_=class_)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def policy_map_class_police_delete(self, policy_map=None, class_=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy_map: po_name
    :param policy_map: Keyword argument tuple.

    :type po_name: unicode
    :param po_name: **policy_map** tuple argument:  Policy Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type class_: cl_name
    :param class_: Keyword argument tuple.

    :type cl_name: unicode
    :param cl_name: **class_** tuple argument:  Policy Map Class Name (Max Size -64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.policy_map', 'policy_map'), ('pybind.nos.v7_0_1b.policy_map.class_', u'class_'), ('pybind.nos.v6_0_2c.policy_map', 'policy_map'), ('pybind.nos.v6_0_2c.policy_map.class_', u'class_'), ('pybind.nos.v7_1_0.policy_map', 'policy_map'), ('pybind.nos.v7_1_0.policy_map.class_', u'class_'), ('pybind.slxos.v16r_1_00b.policy_map', 'policy_map'), ('pybind.slxos.v16r_1_00b.policy_map.class_', u'class_')]
    bindings_list = [('pybind.nos.v6_0_2c.policy_map.class_.police', 'pybind.nos.v6_0_2c.brocade_policer', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.policy_map.class_.police', 'pybind.nos.v7_0_1b.brocade_policer', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.policy_map.class_.police', 'pybind.nos.v7_1_0.brocade_policer', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.policy_map.class_.police', 'pybind.slxos.v16r_1_00b.brocade_qos_mqc', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'cir, cbs, eir, ebs'}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v6_0_2c.policy_map.class_.police": {"exceed_set_tc": "exceed_set_tc", "eir": "eir", "cbs": "cbs", "ebs": "ebs", "conform_set_prec": "conform_set_prec", "cir": "cir", "conform_set_dscp": "conform_set_dscp", "exceed_set_dscp": "exceed_set_dscp", "set_priority": "set_priority", "conform_set_tc": "conform_set_tc", "exceed_set_prec": "exceed_set_prec"}, "pybind.nos.v7_0_1b.policy_map.class_.police": {"exceed_set_tc": "exceed_set_tc", "eir": "eir", "cbs": "cbs", "ebs": "ebs", "conform_set_prec": "conform_set_prec", "cir": "cir", "conform_set_dscp": "conform_set_dscp", "exceed_set_dscp": "exceed_set_dscp", "set_priority": "set_priority", "conform_set_tc": "conform_set_tc", "exceed_set_prec": "exceed_set_prec"}, "pybind.nos.v7_1_0.policy_map.class_.police": {"exceed_set_tc": "exceed_set_tc", "eir": "eir", "cbs": "cbs", "ebs": "ebs", "conform_set_prec": "conform_set_prec", "cir": "cir", "conform_set_dscp": "conform_set_dscp", "exceed_set_dscp": "exceed_set_dscp", "set_priority": "set_priority", "conform_set_tc": "conform_set_tc", "exceed_set_prec": "exceed_set_prec"}, "pybind.slxos.v16r_1_00b.policy_map.class_.police": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_map=policy_map, class_=class_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_map=policy_map, class_=class_)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def policy_map_class_police_cbs_delete(self, policy_map=None, class_=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy_map: po_name
    :param policy_map: Keyword argument tuple.

    :type po_name: unicode
    :param po_name: **policy_map** tuple argument:  Policy Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type class_: cl_name
    :param class_: Keyword argument tuple.

    :type cl_name: unicode
    :param cl_name: **class_** tuple argument:  Policy Map Class Name (Max Size -64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.policy_map', 'policy_map'), ('pybind.nos.v7_0_1b.policy_map.class_', u'class_'), ('pybind.nos.v6_0_2c.policy_map', 'policy_map'), ('pybind.nos.v6_0_2c.policy_map.class_', u'class_'), ('pybind.nos.v7_1_0.policy_map', 'policy_map'), ('pybind.nos.v7_1_0.policy_map.class_', u'class_'), ('pybind.slxos.v16r_1_00b.policy_map', 'policy_map'), ('pybind.slxos.v16r_1_00b.policy_map.class_', u'class_')]
    bindings_list = [('pybind.nos.v6_0_2c.policy_map.class_.police', 'pybind.nos.v6_0_2c.brocade_policer', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.policy_map.class_.police', 'pybind.nos.v7_0_1b.brocade_policer', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.policy_map.class_.police', 'pybind.nos.v7_1_0.brocade_policer', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.policy_map.class_.police', 'pybind.slxos.v16r_1_00b.brocade_qos_mqc', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cbs'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_map=policy_map, class_=class_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_map=policy_map, class_=class_)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def policy_map_class_police_cir_delete(self, policy_map=None, class_=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy_map: po_name
    :param policy_map: Keyword argument tuple.

    :type po_name: unicode
    :param po_name: **policy_map** tuple argument:  Policy Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type class_: cl_name
    :param class_: Keyword argument tuple.

    :type cl_name: unicode
    :param cl_name: **class_** tuple argument:  Policy Map Class Name (Max Size -64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.policy_map', 'policy_map'), ('pybind.nos.v7_0_1b.policy_map.class_', u'class_'), ('pybind.nos.v6_0_2c.policy_map', 'policy_map'), ('pybind.nos.v6_0_2c.policy_map.class_', u'class_'), ('pybind.nos.v7_1_0.policy_map', 'policy_map'), ('pybind.nos.v7_1_0.policy_map.class_', u'class_'), ('pybind.slxos.v16r_1_00b.policy_map', 'policy_map'), ('pybind.slxos.v16r_1_00b.policy_map.class_', u'class_')]
    bindings_list = [('pybind.nos.v6_0_2c.policy_map.class_.police', 'pybind.nos.v6_0_2c.brocade_policer', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.policy_map.class_.police', 'pybind.nos.v7_0_1b.brocade_policer', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.policy_map.class_.police', 'pybind.nos.v7_1_0.brocade_policer', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.policy_map.class_.police', 'pybind.slxos.v16r_1_00b.brocade_qos_mqc', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cir'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_map=policy_map, class_=class_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_map=policy_map, class_=class_)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def policy_map_class_police_conform_set_dscp_delete(self, policy_map=None, class_=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy_map: po_name
    :param policy_map: Keyword argument tuple.

    :type po_name: unicode
    :param po_name: **policy_map** tuple argument:  Policy Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type class_: cl_name
    :param class_: Keyword argument tuple.

    :type cl_name: unicode
    :param cl_name: **class_** tuple argument:  Policy Map Class Name (Max Size -64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.policy_map', 'policy_map'), ('pybind.nos.v6_0_2c.policy_map.class_', u'class_'), ('pybind.nos.v7_1_0.policy_map', 'policy_map'), ('pybind.nos.v7_1_0.policy_map.class_', u'class_'), ('pybind.nos.v7_0_1b.policy_map', 'policy_map'), ('pybind.nos.v7_0_1b.policy_map.class_', u'class_')]
    bindings_list = [('pybind.nos.v6_0_2c.policy_map.class_.police', 'pybind.nos.v6_0_2c.brocade_policer', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.policy_map.class_.police', 'pybind.nos.v7_0_1b.brocade_policer', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.policy_map.class_.police', 'pybind.nos.v7_1_0.brocade_policer', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'conform-set-dscp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_map=policy_map, class_=class_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_map=policy_map, class_=class_)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def policy_map_class_police_conform_set_prec_delete(self, policy_map=None, class_=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy_map: po_name
    :param policy_map: Keyword argument tuple.

    :type po_name: unicode
    :param po_name: **policy_map** tuple argument:  Policy Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type class_: cl_name
    :param class_: Keyword argument tuple.

    :type cl_name: unicode
    :param cl_name: **class_** tuple argument:  Policy Map Class Name (Max Size -64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.policy_map', 'policy_map'), ('pybind.nos.v6_0_2c.policy_map.class_', u'class_'), ('pybind.nos.v7_1_0.policy_map', 'policy_map'), ('pybind.nos.v7_1_0.policy_map.class_', u'class_'), ('pybind.nos.v7_0_1b.policy_map', 'policy_map'), ('pybind.nos.v7_0_1b.policy_map.class_', u'class_')]
    bindings_list = [('pybind.nos.v6_0_2c.policy_map.class_.police', 'pybind.nos.v6_0_2c.brocade_policer', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.policy_map.class_.police', 'pybind.nos.v7_0_1b.brocade_policer', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.policy_map.class_.police', 'pybind.nos.v7_1_0.brocade_policer', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'conform-set-prec'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_map=policy_map, class_=class_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_map=policy_map, class_=class_)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def policy_map_class_police_conform_set_tc_delete(self, policy_map=None, class_=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy_map: po_name
    :param policy_map: Keyword argument tuple.

    :type po_name: unicode
    :param po_name: **policy_map** tuple argument:  Policy Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type class_: cl_name
    :param class_: Keyword argument tuple.

    :type cl_name: unicode
    :param cl_name: **class_** tuple argument:  Policy Map Class Name (Max Size -64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.policy_map', 'policy_map'), ('pybind.nos.v6_0_2c.policy_map.class_', u'class_'), ('pybind.nos.v7_1_0.policy_map', 'policy_map'), ('pybind.nos.v7_1_0.policy_map.class_', u'class_'), ('pybind.nos.v7_0_1b.policy_map', 'policy_map'), ('pybind.nos.v7_0_1b.policy_map.class_', u'class_')]
    bindings_list = [('pybind.nos.v6_0_2c.policy_map.class_.police', 'pybind.nos.v6_0_2c.brocade_policer', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.policy_map.class_.police', 'pybind.nos.v7_0_1b.brocade_policer', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.policy_map.class_.police', 'pybind.nos.v7_1_0.brocade_policer', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'conform-set-tc'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_map=policy_map, class_=class_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_map=policy_map, class_=class_)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def policy_map_class_police_ebs_delete(self, policy_map=None, class_=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy_map: po_name
    :param policy_map: Keyword argument tuple.

    :type po_name: unicode
    :param po_name: **policy_map** tuple argument:  Policy Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type class_: cl_name
    :param class_: Keyword argument tuple.

    :type cl_name: unicode
    :param cl_name: **class_** tuple argument:  Policy Map Class Name (Max Size -64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.policy_map', 'policy_map'), ('pybind.nos.v7_0_1b.policy_map.class_', u'class_'), ('pybind.nos.v6_0_2c.policy_map', 'policy_map'), ('pybind.nos.v6_0_2c.policy_map.class_', u'class_'), ('pybind.nos.v7_1_0.policy_map', 'policy_map'), ('pybind.nos.v7_1_0.policy_map.class_', u'class_'), ('pybind.slxos.v16r_1_00b.policy_map', 'policy_map'), ('pybind.slxos.v16r_1_00b.policy_map.class_', u'class_')]
    bindings_list = [('pybind.nos.v6_0_2c.policy_map.class_.police', 'pybind.nos.v6_0_2c.brocade_policer', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.policy_map.class_.police', 'pybind.nos.v7_0_1b.brocade_policer', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.policy_map.class_.police', 'pybind.nos.v7_1_0.brocade_policer', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.policy_map.class_.police', 'pybind.slxos.v16r_1_00b.brocade_qos_mqc', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ebs'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_map=policy_map, class_=class_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_map=policy_map, class_=class_)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def policy_map_class_police_eir_delete(self, policy_map=None, class_=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy_map: po_name
    :param policy_map: Keyword argument tuple.

    :type po_name: unicode
    :param po_name: **policy_map** tuple argument:  Policy Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type class_: cl_name
    :param class_: Keyword argument tuple.

    :type cl_name: unicode
    :param cl_name: **class_** tuple argument:  Policy Map Class Name (Max Size -64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.policy_map', 'policy_map'), ('pybind.nos.v7_0_1b.policy_map.class_', u'class_'), ('pybind.nos.v6_0_2c.policy_map', 'policy_map'), ('pybind.nos.v6_0_2c.policy_map.class_', u'class_'), ('pybind.nos.v7_1_0.policy_map', 'policy_map'), ('pybind.nos.v7_1_0.policy_map.class_', u'class_'), ('pybind.slxos.v16r_1_00b.policy_map', 'policy_map'), ('pybind.slxos.v16r_1_00b.policy_map.class_', u'class_')]
    bindings_list = [('pybind.nos.v6_0_2c.policy_map.class_.police', 'pybind.nos.v6_0_2c.brocade_policer', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.policy_map.class_.police', 'pybind.nos.v7_0_1b.brocade_policer', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.policy_map.class_.police', 'pybind.nos.v7_1_0.brocade_policer', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.policy_map.class_.police', 'pybind.slxos.v16r_1_00b.brocade_qos_mqc', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'eir'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_map=policy_map, class_=class_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_map=policy_map, class_=class_)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def policy_map_class_police_exceed_set_dscp_delete(self, policy_map=None, class_=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy_map: po_name
    :param policy_map: Keyword argument tuple.

    :type po_name: unicode
    :param po_name: **policy_map** tuple argument:  Policy Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type class_: cl_name
    :param class_: Keyword argument tuple.

    :type cl_name: unicode
    :param cl_name: **class_** tuple argument:  Policy Map Class Name (Max Size -64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.policy_map', 'policy_map'), ('pybind.nos.v6_0_2c.policy_map.class_', u'class_'), ('pybind.nos.v7_1_0.policy_map', 'policy_map'), ('pybind.nos.v7_1_0.policy_map.class_', u'class_'), ('pybind.nos.v7_0_1b.policy_map', 'policy_map'), ('pybind.nos.v7_0_1b.policy_map.class_', u'class_')]
    bindings_list = [('pybind.nos.v6_0_2c.policy_map.class_.police', 'pybind.nos.v6_0_2c.brocade_policer', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.policy_map.class_.police', 'pybind.nos.v7_0_1b.brocade_policer', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.policy_map.class_.police', 'pybind.nos.v7_1_0.brocade_policer', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'exceed-set-dscp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_map=policy_map, class_=class_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_map=policy_map, class_=class_)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def policy_map_class_police_exceed_set_prec_delete(self, policy_map=None, class_=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy_map: po_name
    :param policy_map: Keyword argument tuple.

    :type po_name: unicode
    :param po_name: **policy_map** tuple argument:  Policy Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type class_: cl_name
    :param class_: Keyword argument tuple.

    :type cl_name: unicode
    :param cl_name: **class_** tuple argument:  Policy Map Class Name (Max Size -64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.policy_map', 'policy_map'), ('pybind.nos.v6_0_2c.policy_map.class_', u'class_'), ('pybind.nos.v7_1_0.policy_map', 'policy_map'), ('pybind.nos.v7_1_0.policy_map.class_', u'class_'), ('pybind.nos.v7_0_1b.policy_map', 'policy_map'), ('pybind.nos.v7_0_1b.policy_map.class_', u'class_')]
    bindings_list = [('pybind.nos.v6_0_2c.policy_map.class_.police', 'pybind.nos.v6_0_2c.brocade_policer', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.policy_map.class_.police', 'pybind.nos.v7_0_1b.brocade_policer', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.policy_map.class_.police', 'pybind.nos.v7_1_0.brocade_policer', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'exceed-set-prec'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_map=policy_map, class_=class_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_map=policy_map, class_=class_)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def policy_map_class_police_exceed_set_tc_delete(self, policy_map=None, class_=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy_map: po_name
    :param policy_map: Keyword argument tuple.

    :type po_name: unicode
    :param po_name: **policy_map** tuple argument:  Policy Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type class_: cl_name
    :param class_: Keyword argument tuple.

    :type cl_name: unicode
    :param cl_name: **class_** tuple argument:  Policy Map Class Name (Max Size -64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.policy_map', 'policy_map'), ('pybind.nos.v6_0_2c.policy_map.class_', u'class_'), ('pybind.nos.v7_1_0.policy_map', 'policy_map'), ('pybind.nos.v7_1_0.policy_map.class_', u'class_'), ('pybind.nos.v7_0_1b.policy_map', 'policy_map'), ('pybind.nos.v7_0_1b.policy_map.class_', u'class_')]
    bindings_list = [('pybind.nos.v6_0_2c.policy_map.class_.police', 'pybind.nos.v6_0_2c.brocade_policer', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.policy_map.class_.police', 'pybind.nos.v7_0_1b.brocade_policer', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.policy_map.class_.police', 'pybind.nos.v7_1_0.brocade_policer', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'exceed-set-tc'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_map=policy_map, class_=class_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_map=policy_map, class_=class_)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def policy_map_class_police_set_priority_delete(self, policy_map=None, class_=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy_map: po_name
    :param policy_map: Keyword argument tuple.

    :type po_name: unicode
    :param po_name: **policy_map** tuple argument:  Policy Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type class_: cl_name
    :param class_: Keyword argument tuple.

    :type cl_name: unicode
    :param cl_name: **class_** tuple argument:  Policy Map Class Name (Max Size -64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.policy_map', 'policy_map'), ('pybind.nos.v6_0_2c.policy_map.class_', u'class_'), ('pybind.nos.v7_1_0.policy_map', 'policy_map'), ('pybind.nos.v7_1_0.policy_map.class_', u'class_'), ('pybind.nos.v7_0_1b.policy_map', 'policy_map'), ('pybind.nos.v7_0_1b.policy_map.class_', u'class_')]
    bindings_list = [('pybind.nos.v6_0_2c.policy_map.class_.police', 'pybind.nos.v6_0_2c.brocade_policer', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.policy_map.class_.police', 'pybind.nos.v7_0_1b.brocade_policer', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.policy_map.class_.police', 'pybind.nos.v7_1_0.brocade_policer', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'set-priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_map=policy_map, class_=class_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_map=policy_map, class_=class_)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def policy_map_class_priority_mapping_table_delete(self, policy_map=None, class_=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy_map: po_name
    :param policy_map: Keyword argument tuple.

    :type po_name: unicode
    :param po_name: **policy_map** tuple argument:  Policy Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type class_: cl_name
    :param class_: Keyword argument tuple.

    :type cl_name: unicode
    :param cl_name: **class_** tuple argument:  Policy Map Class Name (Max Size -64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.policy_map', 'policy_map'), ('pybind.nos.v7_0_1b.policy_map.class_', u'class_'), ('pybind.nos.v6_0_2c.policy_map', 'policy_map'), ('pybind.nos.v6_0_2c.policy_map.class_', u'class_'), ('pybind.slxos.v16r_1_00b.policy_map', 'policy_map'), ('pybind.slxos.v16r_1_00b.policy_map.class_', u'class_'), ('pybind.nos.v7_1_0.policy_map', 'policy_map'), ('pybind.nos.v7_1_0.policy_map.class_', u'class_')]
    bindings_list = [('pybind.nos.v6_0_2c.policy_map.class_.priority_mapping_table', 'pybind.nos.v6_0_2c.brocade_policer', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.policy_map.class_.priority_mapping_table', 'pybind.nos.v7_0_1b.brocade_policer', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.policy_map.class_.priority_mapping_table', 'pybind.nos.v7_1_0.brocade_policer', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.policy_map.class_.priority_mapping_table', 'pybind.slxos.v16r_1_00b.brocade_qos_mqc', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_map=policy_map, class_=class_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_map=policy_map, class_=class_)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def policy_map_class_priority_mapping_table_import_delete(self, policy_map=None, class_=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy_map: po_name
    :param policy_map: Keyword argument tuple.

    :type po_name: unicode
    :param po_name: **policy_map** tuple argument:  Policy Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type class_: cl_name
    :param class_: Keyword argument tuple.

    :type cl_name: unicode
    :param cl_name: **class_** tuple argument:  Policy Map Class Name (Max Size -64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.policy_map', 'policy_map'), ('pybind.slxos.v16r_1_00b.policy_map.class_', u'class_'), ('pybind.nos.v7_1_0.policy_map', 'policy_map'), ('pybind.nos.v7_1_0.policy_map.class_', u'class_'), ('pybind.nos.v6_0_2c.policy_map', 'policy_map'), ('pybind.nos.v6_0_2c.policy_map.class_', u'class_'), ('pybind.nos.v7_0_1b.policy_map', 'policy_map'), ('pybind.nos.v7_0_1b.policy_map.class_', u'class_')]
    bindings_list = [('pybind.nos.v6_0_2c.policy_map.class_.priority_mapping_table.import_', 'pybind.nos.v6_0_2c.brocade_policer', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.policy_map.class_.priority_mapping_table.import_', 'pybind.nos.v7_0_1b.brocade_policer', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.policy_map.class_.priority_mapping_table.import_', 'pybind.nos.v7_1_0.brocade_policer', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.policy_map.class_.priority_mapping_table.import_', 'pybind.slxos.v16r_1_00b.brocade_qos_mqc', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_map=policy_map, class_=class_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_map=policy_map, class_=class_)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def policy_map_class_priority_mapping_table_import_cee_delete(self, policy_map=None, class_=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy_map: po_name
    :param policy_map: Keyword argument tuple.

    :type po_name: unicode
    :param po_name: **policy_map** tuple argument:  Policy Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type class_: cl_name
    :param class_: Keyword argument tuple.

    :type cl_name: unicode
    :param cl_name: **class_** tuple argument:  Policy Map Class Name (Max Size -64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.policy_map', 'policy_map'), ('pybind.slxos.v16r_1_00b.policy_map.class_', u'class_'), ('pybind.nos.v7_1_0.policy_map', 'policy_map'), ('pybind.nos.v7_1_0.policy_map.class_', u'class_'), ('pybind.nos.v6_0_2c.policy_map', 'policy_map'), ('pybind.nos.v6_0_2c.policy_map.class_', u'class_'), ('pybind.nos.v7_0_1b.policy_map', 'policy_map'), ('pybind.nos.v7_0_1b.policy_map.class_', u'class_')]
    bindings_list = [('pybind.nos.v6_0_2c.policy_map.class_.priority_mapping_table.import_', 'pybind.nos.v6_0_2c.brocade_policer', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.policy_map.class_.priority_mapping_table.import_', 'pybind.nos.v7_0_1b.brocade_policer', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.policy_map.class_.priority_mapping_table.import_', 'pybind.nos.v7_1_0.brocade_policer', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.policy_map.class_.priority_mapping_table.import_', 'pybind.slxos.v16r_1_00b.brocade_qos_mqc', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cee'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_map=policy_map, class_=class_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_map=policy_map, class_=class_)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def policy_map_class_scheduler_delete(self, policy_map=None, class_=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy_map: po_name
    :param policy_map: Keyword argument tuple.

    :type po_name: unicode
    :param po_name: **policy_map** tuple argument:  Policy Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type class_: cl_name
    :param class_: Keyword argument tuple.

    :type cl_name: unicode
    :param cl_name: **class_** tuple argument:  Policy Map Class Name (Max Size -64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.policy_map', 'policy_map'), ('pybind.nos.v6_0_2c.policy_map.class_', u'class_'), ('pybind.nos.v7_0_1b.policy_map', 'policy_map'), ('pybind.nos.v7_0_1b.policy_map.class_', u'class_'), ('pybind.slxos.v16r_1_00b.policy_map', 'policy_map'), ('pybind.slxos.v16r_1_00b.policy_map.class_', u'class_'), ('pybind.nos.v7_1_0.policy_map', 'policy_map'), ('pybind.nos.v7_1_0.policy_map.class_', u'class_')]
    bindings_list = [('pybind.nos.v6_0_2c.policy_map.class_.scheduler', 'pybind.nos.v6_0_2c.brocade_policer', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.policy_map.class_.scheduler', 'pybind.nos.v7_0_1b.brocade_policer', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.policy_map.class_.scheduler', 'pybind.nos.v7_1_0.brocade_policer', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.policy_map.class_.scheduler', 'pybind.slxos.v16r_1_00b.brocade_qos_mqc', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_map=policy_map, class_=class_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_map=policy_map, class_=class_)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def policy_map_class_scheduler_strict_priority_delete(self, policy_map=None, class_=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy_map: po_name
    :param policy_map: Keyword argument tuple.

    :type po_name: unicode
    :param po_name: **policy_map** tuple argument:  Policy Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type class_: cl_name
    :param class_: Keyword argument tuple.

    :type cl_name: unicode
    :param cl_name: **class_** tuple argument:  Policy Map Class Name (Max Size -64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.policy_map', 'policy_map'), ('pybind.nos.v7_0_1b.policy_map.class_', u'class_'), ('pybind.nos.v7_1_0.policy_map', 'policy_map'), ('pybind.nos.v7_1_0.policy_map.class_', u'class_'), ('pybind.nos.v6_0_2c.policy_map', 'policy_map'), ('pybind.nos.v6_0_2c.policy_map.class_', u'class_'), ('pybind.slxos.v16r_1_00b.policy_map', 'policy_map'), ('pybind.slxos.v16r_1_00b.policy_map.class_', u'class_')]
    bindings_list = [('pybind.nos.v6_0_2c.policy_map.class_.scheduler.strict_priority', 'pybind.nos.v6_0_2c.brocade_policer', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.policy_map.class_.scheduler.strict_priority', 'pybind.nos.v7_0_1b.brocade_policer', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.policy_map.class_.scheduler.strict_priority', 'pybind.nos.v7_1_0.brocade_policer', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.policy_map.class_.scheduler.strict_priority', 'pybind.slxos.v16r_1_00b.brocade_qos_mqc', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'priority_number, scheduler_type, dwrr_traffic_class0, dwrr_traffic_class1, dwrr_traffic_class2, dwrr_traffic_class3, dwrr_traffic_class4, dwrr_traffic_class5, dwrr_traffic_class6, dwrr_traffic_class_last, TC1, TC2, TC3, TC4, TC5, TC6, TC7'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_map=policy_map, class_=class_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_map=policy_map, class_=class_)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def policy_map_class_scheduler_strict_priority_dwrr_traffic_class0_delete(self, policy_map=None, class_=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy_map: po_name
    :param policy_map: Keyword argument tuple.

    :type po_name: unicode
    :param po_name: **policy_map** tuple argument:  Policy Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type class_: cl_name
    :param class_: Keyword argument tuple.

    :type cl_name: unicode
    :param cl_name: **class_** tuple argument:  Policy Map Class Name (Max Size -64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.policy_map', 'policy_map'), ('pybind.nos.v7_0_1b.policy_map.class_', u'class_'), ('pybind.nos.v7_1_0.policy_map', 'policy_map'), ('pybind.nos.v7_1_0.policy_map.class_', u'class_'), ('pybind.nos.v6_0_2c.policy_map', 'policy_map'), ('pybind.nos.v6_0_2c.policy_map.class_', u'class_'), ('pybind.slxos.v16r_1_00b.policy_map', 'policy_map'), ('pybind.slxos.v16r_1_00b.policy_map.class_', u'class_')]
    bindings_list = [('pybind.nos.v6_0_2c.policy_map.class_.scheduler.strict_priority', 'pybind.nos.v6_0_2c.brocade_policer', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.policy_map.class_.scheduler.strict_priority', 'pybind.nos.v7_0_1b.brocade_policer', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.policy_map.class_.scheduler.strict_priority', 'pybind.nos.v7_1_0.brocade_policer', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.policy_map.class_.scheduler.strict_priority', 'pybind.slxos.v16r_1_00b.brocade_qos_mqc', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dwrr-traffic-class0'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_map=policy_map, class_=class_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_map=policy_map, class_=class_)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def policy_map_class_scheduler_strict_priority_dwrr_traffic_class1_delete(self, policy_map=None, class_=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy_map: po_name
    :param policy_map: Keyword argument tuple.

    :type po_name: unicode
    :param po_name: **policy_map** tuple argument:  Policy Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type class_: cl_name
    :param class_: Keyword argument tuple.

    :type cl_name: unicode
    :param cl_name: **class_** tuple argument:  Policy Map Class Name (Max Size -64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.policy_map', 'policy_map'), ('pybind.nos.v7_0_1b.policy_map.class_', u'class_'), ('pybind.nos.v7_1_0.policy_map', 'policy_map'), ('pybind.nos.v7_1_0.policy_map.class_', u'class_'), ('pybind.nos.v6_0_2c.policy_map', 'policy_map'), ('pybind.nos.v6_0_2c.policy_map.class_', u'class_'), ('pybind.slxos.v16r_1_00b.policy_map', 'policy_map'), ('pybind.slxos.v16r_1_00b.policy_map.class_', u'class_')]
    bindings_list = [('pybind.nos.v6_0_2c.policy_map.class_.scheduler.strict_priority', 'pybind.nos.v6_0_2c.brocade_policer', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.policy_map.class_.scheduler.strict_priority', 'pybind.nos.v7_0_1b.brocade_policer', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.policy_map.class_.scheduler.strict_priority', 'pybind.nos.v7_1_0.brocade_policer', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.policy_map.class_.scheduler.strict_priority', 'pybind.slxos.v16r_1_00b.brocade_qos_mqc', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dwrr-traffic-class1'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_map=policy_map, class_=class_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_map=policy_map, class_=class_)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def policy_map_class_scheduler_strict_priority_dwrr_traffic_class2_delete(self, policy_map=None, class_=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy_map: po_name
    :param policy_map: Keyword argument tuple.

    :type po_name: unicode
    :param po_name: **policy_map** tuple argument:  Policy Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type class_: cl_name
    :param class_: Keyword argument tuple.

    :type cl_name: unicode
    :param cl_name: **class_** tuple argument:  Policy Map Class Name (Max Size -64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.policy_map', 'policy_map'), ('pybind.nos.v7_0_1b.policy_map.class_', u'class_'), ('pybind.nos.v7_1_0.policy_map', 'policy_map'), ('pybind.nos.v7_1_0.policy_map.class_', u'class_'), ('pybind.nos.v6_0_2c.policy_map', 'policy_map'), ('pybind.nos.v6_0_2c.policy_map.class_', u'class_'), ('pybind.slxos.v16r_1_00b.policy_map', 'policy_map'), ('pybind.slxos.v16r_1_00b.policy_map.class_', u'class_')]
    bindings_list = [('pybind.nos.v6_0_2c.policy_map.class_.scheduler.strict_priority', 'pybind.nos.v6_0_2c.brocade_policer', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.policy_map.class_.scheduler.strict_priority', 'pybind.nos.v7_0_1b.brocade_policer', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.policy_map.class_.scheduler.strict_priority', 'pybind.nos.v7_1_0.brocade_policer', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.policy_map.class_.scheduler.strict_priority', 'pybind.slxos.v16r_1_00b.brocade_qos_mqc', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dwrr-traffic-class2'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_map=policy_map, class_=class_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_map=policy_map, class_=class_)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def policy_map_class_scheduler_strict_priority_dwrr_traffic_class3_delete(self, policy_map=None, class_=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy_map: po_name
    :param policy_map: Keyword argument tuple.

    :type po_name: unicode
    :param po_name: **policy_map** tuple argument:  Policy Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type class_: cl_name
    :param class_: Keyword argument tuple.

    :type cl_name: unicode
    :param cl_name: **class_** tuple argument:  Policy Map Class Name (Max Size -64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.policy_map', 'policy_map'), ('pybind.nos.v7_0_1b.policy_map.class_', u'class_'), ('pybind.nos.v7_1_0.policy_map', 'policy_map'), ('pybind.nos.v7_1_0.policy_map.class_', u'class_'), ('pybind.nos.v6_0_2c.policy_map', 'policy_map'), ('pybind.nos.v6_0_2c.policy_map.class_', u'class_'), ('pybind.slxos.v16r_1_00b.policy_map', 'policy_map'), ('pybind.slxos.v16r_1_00b.policy_map.class_', u'class_')]
    bindings_list = [('pybind.nos.v6_0_2c.policy_map.class_.scheduler.strict_priority', 'pybind.nos.v6_0_2c.brocade_policer', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.policy_map.class_.scheduler.strict_priority', 'pybind.nos.v7_0_1b.brocade_policer', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.policy_map.class_.scheduler.strict_priority', 'pybind.nos.v7_1_0.brocade_policer', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.policy_map.class_.scheduler.strict_priority', 'pybind.slxos.v16r_1_00b.brocade_qos_mqc', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dwrr-traffic-class3'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_map=policy_map, class_=class_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_map=policy_map, class_=class_)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def policy_map_class_scheduler_strict_priority_dwrr_traffic_class4_delete(self, policy_map=None, class_=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy_map: po_name
    :param policy_map: Keyword argument tuple.

    :type po_name: unicode
    :param po_name: **policy_map** tuple argument:  Policy Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type class_: cl_name
    :param class_: Keyword argument tuple.

    :type cl_name: unicode
    :param cl_name: **class_** tuple argument:  Policy Map Class Name (Max Size -64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.policy_map', 'policy_map'), ('pybind.nos.v7_0_1b.policy_map.class_', u'class_'), ('pybind.nos.v7_1_0.policy_map', 'policy_map'), ('pybind.nos.v7_1_0.policy_map.class_', u'class_'), ('pybind.nos.v6_0_2c.policy_map', 'policy_map'), ('pybind.nos.v6_0_2c.policy_map.class_', u'class_'), ('pybind.slxos.v16r_1_00b.policy_map', 'policy_map'), ('pybind.slxos.v16r_1_00b.policy_map.class_', u'class_')]
    bindings_list = [('pybind.nos.v6_0_2c.policy_map.class_.scheduler.strict_priority', 'pybind.nos.v6_0_2c.brocade_policer', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.policy_map.class_.scheduler.strict_priority', 'pybind.nos.v7_0_1b.brocade_policer', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.policy_map.class_.scheduler.strict_priority', 'pybind.nos.v7_1_0.brocade_policer', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.policy_map.class_.scheduler.strict_priority', 'pybind.slxos.v16r_1_00b.brocade_qos_mqc', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dwrr-traffic-class4'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_map=policy_map, class_=class_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_map=policy_map, class_=class_)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def policy_map_class_scheduler_strict_priority_dwrr_traffic_class5_delete(self, policy_map=None, class_=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy_map: po_name
    :param policy_map: Keyword argument tuple.

    :type po_name: unicode
    :param po_name: **policy_map** tuple argument:  Policy Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type class_: cl_name
    :param class_: Keyword argument tuple.

    :type cl_name: unicode
    :param cl_name: **class_** tuple argument:  Policy Map Class Name (Max Size -64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.policy_map', 'policy_map'), ('pybind.nos.v7_0_1b.policy_map.class_', u'class_'), ('pybind.nos.v7_1_0.policy_map', 'policy_map'), ('pybind.nos.v7_1_0.policy_map.class_', u'class_'), ('pybind.nos.v6_0_2c.policy_map', 'policy_map'), ('pybind.nos.v6_0_2c.policy_map.class_', u'class_'), ('pybind.slxos.v16r_1_00b.policy_map', 'policy_map'), ('pybind.slxos.v16r_1_00b.policy_map.class_', u'class_')]
    bindings_list = [('pybind.nos.v6_0_2c.policy_map.class_.scheduler.strict_priority', 'pybind.nos.v6_0_2c.brocade_policer', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.policy_map.class_.scheduler.strict_priority', 'pybind.nos.v7_0_1b.brocade_policer', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.policy_map.class_.scheduler.strict_priority', 'pybind.nos.v7_1_0.brocade_policer', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.policy_map.class_.scheduler.strict_priority', 'pybind.slxos.v16r_1_00b.brocade_qos_mqc', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dwrr-traffic-class5'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_map=policy_map, class_=class_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_map=policy_map, class_=class_)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def policy_map_class_scheduler_strict_priority_dwrr_traffic_class6_delete(self, policy_map=None, class_=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy_map: po_name
    :param policy_map: Keyword argument tuple.

    :type po_name: unicode
    :param po_name: **policy_map** tuple argument:  Policy Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type class_: cl_name
    :param class_: Keyword argument tuple.

    :type cl_name: unicode
    :param cl_name: **class_** tuple argument:  Policy Map Class Name (Max Size -64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.policy_map', 'policy_map'), ('pybind.nos.v7_0_1b.policy_map.class_', u'class_'), ('pybind.nos.v7_1_0.policy_map', 'policy_map'), ('pybind.nos.v7_1_0.policy_map.class_', u'class_'), ('pybind.nos.v6_0_2c.policy_map', 'policy_map'), ('pybind.nos.v6_0_2c.policy_map.class_', u'class_'), ('pybind.slxos.v16r_1_00b.policy_map', 'policy_map'), ('pybind.slxos.v16r_1_00b.policy_map.class_', u'class_')]
    bindings_list = [('pybind.nos.v6_0_2c.policy_map.class_.scheduler.strict_priority', 'pybind.nos.v6_0_2c.brocade_policer', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.policy_map.class_.scheduler.strict_priority', 'pybind.nos.v7_0_1b.brocade_policer', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.policy_map.class_.scheduler.strict_priority', 'pybind.nos.v7_1_0.brocade_policer', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.policy_map.class_.scheduler.strict_priority', 'pybind.slxos.v16r_1_00b.brocade_qos_mqc', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dwrr-traffic-class6'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_map=policy_map, class_=class_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_map=policy_map, class_=class_)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def policy_map_class_scheduler_strict_priority_dwrr_traffic_class_last_delete(self, policy_map=None, class_=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy_map: po_name
    :param policy_map: Keyword argument tuple.

    :type po_name: unicode
    :param po_name: **policy_map** tuple argument:  Policy Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type class_: cl_name
    :param class_: Keyword argument tuple.

    :type cl_name: unicode
    :param cl_name: **class_** tuple argument:  Policy Map Class Name (Max Size -64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.policy_map', 'policy_map'), ('pybind.nos.v7_0_1b.policy_map.class_', u'class_'), ('pybind.nos.v7_1_0.policy_map', 'policy_map'), ('pybind.nos.v7_1_0.policy_map.class_', u'class_'), ('pybind.nos.v6_0_2c.policy_map', 'policy_map'), ('pybind.nos.v6_0_2c.policy_map.class_', u'class_'), ('pybind.slxos.v16r_1_00b.policy_map', 'policy_map'), ('pybind.slxos.v16r_1_00b.policy_map.class_', u'class_')]
    bindings_list = [('pybind.nos.v6_0_2c.policy_map.class_.scheduler.strict_priority', 'pybind.nos.v6_0_2c.brocade_policer', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.policy_map.class_.scheduler.strict_priority', 'pybind.nos.v7_0_1b.brocade_policer', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.policy_map.class_.scheduler.strict_priority', 'pybind.nos.v7_1_0.brocade_policer', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.policy_map.class_.scheduler.strict_priority', 'pybind.slxos.v16r_1_00b.brocade_qos_mqc', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dwrr-traffic-class-last'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_map=policy_map, class_=class_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_map=policy_map, class_=class_)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def policy_map_class_scheduler_strict_priority_priority_number_delete(self, policy_map=None, class_=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy_map: po_name
    :param policy_map: Keyword argument tuple.

    :type po_name: unicode
    :param po_name: **policy_map** tuple argument:  Policy Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type class_: cl_name
    :param class_: Keyword argument tuple.

    :type cl_name: unicode
    :param cl_name: **class_** tuple argument:  Policy Map Class Name (Max Size -64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.policy_map', 'policy_map'), ('pybind.nos.v7_0_1b.policy_map.class_', u'class_'), ('pybind.nos.v7_1_0.policy_map', 'policy_map'), ('pybind.nos.v7_1_0.policy_map.class_', u'class_'), ('pybind.nos.v6_0_2c.policy_map', 'policy_map'), ('pybind.nos.v6_0_2c.policy_map.class_', u'class_'), ('pybind.slxos.v16r_1_00b.policy_map', 'policy_map'), ('pybind.slxos.v16r_1_00b.policy_map.class_', u'class_')]
    bindings_list = [('pybind.nos.v6_0_2c.policy_map.class_.scheduler.strict_priority', 'pybind.nos.v6_0_2c.brocade_policer', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.policy_map.class_.scheduler.strict_priority', 'pybind.nos.v7_0_1b.brocade_policer', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.policy_map.class_.scheduler.strict_priority', 'pybind.nos.v7_1_0.brocade_policer', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.policy_map.class_.scheduler.strict_priority', 'pybind.slxos.v16r_1_00b.brocade_qos_mqc', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority-number'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_map=policy_map, class_=class_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_map=policy_map, class_=class_)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def policy_map_class_scheduler_strict_priority_scheduler_type_delete(self, policy_map=None, class_=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy_map: po_name
    :param policy_map: Keyword argument tuple.

    :type po_name: unicode
    :param po_name: **policy_map** tuple argument:  Policy Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type class_: cl_name
    :param class_: Keyword argument tuple.

    :type cl_name: unicode
    :param cl_name: **class_** tuple argument:  Policy Map Class Name (Max Size -64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.policy_map', 'policy_map'), ('pybind.nos.v7_0_1b.policy_map.class_', u'class_'), ('pybind.nos.v7_1_0.policy_map', 'policy_map'), ('pybind.nos.v7_1_0.policy_map.class_', u'class_'), ('pybind.nos.v6_0_2c.policy_map', 'policy_map'), ('pybind.nos.v6_0_2c.policy_map.class_', u'class_'), ('pybind.slxos.v16r_1_00b.policy_map', 'policy_map'), ('pybind.slxos.v16r_1_00b.policy_map.class_', u'class_')]
    bindings_list = [('pybind.nos.v6_0_2c.policy_map.class_.scheduler.strict_priority', 'pybind.nos.v6_0_2c.brocade_policer', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.policy_map.class_.scheduler.strict_priority', 'pybind.nos.v7_0_1b.brocade_policer', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.policy_map.class_.scheduler.strict_priority', 'pybind.nos.v7_1_0.brocade_policer', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.policy_map.class_.scheduler.strict_priority', 'pybind.slxos.v16r_1_00b.brocade_qos_mqc', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'scheduler-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_map=policy_map, class_=class_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_map=policy_map, class_=class_)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def policy_map_class_scheduler_strict_priority_tc1_delete(self, policy_map=None, class_=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy_map: po_name
    :param policy_map: Keyword argument tuple.

    :type po_name: unicode
    :param po_name: **policy_map** tuple argument:  Policy Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type class_: cl_name
    :param class_: Keyword argument tuple.

    :type cl_name: unicode
    :param cl_name: **class_** tuple argument:  Policy Map Class Name (Max Size -64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.policy_map', 'policy_map'), ('pybind.nos.v7_0_1b.policy_map.class_', u'class_'), ('pybind.nos.v7_1_0.policy_map', 'policy_map'), ('pybind.nos.v7_1_0.policy_map.class_', u'class_'), ('pybind.nos.v6_0_2c.policy_map', 'policy_map'), ('pybind.nos.v6_0_2c.policy_map.class_', u'class_'), ('pybind.slxos.v16r_1_00b.policy_map', 'policy_map'), ('pybind.slxos.v16r_1_00b.policy_map.class_', u'class_')]
    bindings_list = [('pybind.nos.v6_0_2c.policy_map.class_.scheduler.strict_priority', 'pybind.nos.v6_0_2c.brocade_policer', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.policy_map.class_.scheduler.strict_priority', 'pybind.nos.v7_0_1b.brocade_policer', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.policy_map.class_.scheduler.strict_priority', 'pybind.nos.v7_1_0.brocade_policer', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.policy_map.class_.scheduler.strict_priority', 'pybind.slxos.v16r_1_00b.brocade_qos_mqc', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'TC1'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_map=policy_map, class_=class_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_map=policy_map, class_=class_)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def policy_map_class_scheduler_strict_priority_tc2_delete(self, policy_map=None, class_=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy_map: po_name
    :param policy_map: Keyword argument tuple.

    :type po_name: unicode
    :param po_name: **policy_map** tuple argument:  Policy Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type class_: cl_name
    :param class_: Keyword argument tuple.

    :type cl_name: unicode
    :param cl_name: **class_** tuple argument:  Policy Map Class Name (Max Size -64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.policy_map', 'policy_map'), ('pybind.nos.v7_0_1b.policy_map.class_', u'class_'), ('pybind.nos.v7_1_0.policy_map', 'policy_map'), ('pybind.nos.v7_1_0.policy_map.class_', u'class_'), ('pybind.nos.v6_0_2c.policy_map', 'policy_map'), ('pybind.nos.v6_0_2c.policy_map.class_', u'class_'), ('pybind.slxos.v16r_1_00b.policy_map', 'policy_map'), ('pybind.slxos.v16r_1_00b.policy_map.class_', u'class_')]
    bindings_list = [('pybind.nos.v6_0_2c.policy_map.class_.scheduler.strict_priority', 'pybind.nos.v6_0_2c.brocade_policer', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.policy_map.class_.scheduler.strict_priority', 'pybind.nos.v7_0_1b.brocade_policer', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.policy_map.class_.scheduler.strict_priority', 'pybind.nos.v7_1_0.brocade_policer', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.policy_map.class_.scheduler.strict_priority', 'pybind.slxos.v16r_1_00b.brocade_qos_mqc', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'TC2'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_map=policy_map, class_=class_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_map=policy_map, class_=class_)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def policy_map_class_scheduler_strict_priority_tc3_delete(self, policy_map=None, class_=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy_map: po_name
    :param policy_map: Keyword argument tuple.

    :type po_name: unicode
    :param po_name: **policy_map** tuple argument:  Policy Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type class_: cl_name
    :param class_: Keyword argument tuple.

    :type cl_name: unicode
    :param cl_name: **class_** tuple argument:  Policy Map Class Name (Max Size -64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.policy_map', 'policy_map'), ('pybind.nos.v7_0_1b.policy_map.class_', u'class_'), ('pybind.nos.v7_1_0.policy_map', 'policy_map'), ('pybind.nos.v7_1_0.policy_map.class_', u'class_'), ('pybind.nos.v6_0_2c.policy_map', 'policy_map'), ('pybind.nos.v6_0_2c.policy_map.class_', u'class_'), ('pybind.slxos.v16r_1_00b.policy_map', 'policy_map'), ('pybind.slxos.v16r_1_00b.policy_map.class_', u'class_')]
    bindings_list = [('pybind.nos.v6_0_2c.policy_map.class_.scheduler.strict_priority', 'pybind.nos.v6_0_2c.brocade_policer', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.policy_map.class_.scheduler.strict_priority', 'pybind.nos.v7_0_1b.brocade_policer', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.policy_map.class_.scheduler.strict_priority', 'pybind.nos.v7_1_0.brocade_policer', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.policy_map.class_.scheduler.strict_priority', 'pybind.slxos.v16r_1_00b.brocade_qos_mqc', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'TC3'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_map=policy_map, class_=class_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_map=policy_map, class_=class_)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def policy_map_class_scheduler_strict_priority_tc4_delete(self, policy_map=None, class_=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy_map: po_name
    :param policy_map: Keyword argument tuple.

    :type po_name: unicode
    :param po_name: **policy_map** tuple argument:  Policy Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type class_: cl_name
    :param class_: Keyword argument tuple.

    :type cl_name: unicode
    :param cl_name: **class_** tuple argument:  Policy Map Class Name (Max Size -64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.policy_map', 'policy_map'), ('pybind.nos.v7_0_1b.policy_map.class_', u'class_'), ('pybind.nos.v7_1_0.policy_map', 'policy_map'), ('pybind.nos.v7_1_0.policy_map.class_', u'class_'), ('pybind.nos.v6_0_2c.policy_map', 'policy_map'), ('pybind.nos.v6_0_2c.policy_map.class_', u'class_'), ('pybind.slxos.v16r_1_00b.policy_map', 'policy_map'), ('pybind.slxos.v16r_1_00b.policy_map.class_', u'class_')]
    bindings_list = [('pybind.nos.v6_0_2c.policy_map.class_.scheduler.strict_priority', 'pybind.nos.v6_0_2c.brocade_policer', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.policy_map.class_.scheduler.strict_priority', 'pybind.nos.v7_0_1b.brocade_policer', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.policy_map.class_.scheduler.strict_priority', 'pybind.nos.v7_1_0.brocade_policer', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.policy_map.class_.scheduler.strict_priority', 'pybind.slxos.v16r_1_00b.brocade_qos_mqc', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'TC4'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_map=policy_map, class_=class_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_map=policy_map, class_=class_)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def policy_map_class_scheduler_strict_priority_tc5_delete(self, policy_map=None, class_=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy_map: po_name
    :param policy_map: Keyword argument tuple.

    :type po_name: unicode
    :param po_name: **policy_map** tuple argument:  Policy Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type class_: cl_name
    :param class_: Keyword argument tuple.

    :type cl_name: unicode
    :param cl_name: **class_** tuple argument:  Policy Map Class Name (Max Size -64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.policy_map', 'policy_map'), ('pybind.nos.v7_0_1b.policy_map.class_', u'class_'), ('pybind.nos.v7_1_0.policy_map', 'policy_map'), ('pybind.nos.v7_1_0.policy_map.class_', u'class_'), ('pybind.nos.v6_0_2c.policy_map', 'policy_map'), ('pybind.nos.v6_0_2c.policy_map.class_', u'class_'), ('pybind.slxos.v16r_1_00b.policy_map', 'policy_map'), ('pybind.slxos.v16r_1_00b.policy_map.class_', u'class_')]
    bindings_list = [('pybind.nos.v6_0_2c.policy_map.class_.scheduler.strict_priority', 'pybind.nos.v6_0_2c.brocade_policer', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.policy_map.class_.scheduler.strict_priority', 'pybind.nos.v7_0_1b.brocade_policer', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.policy_map.class_.scheduler.strict_priority', 'pybind.nos.v7_1_0.brocade_policer', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.policy_map.class_.scheduler.strict_priority', 'pybind.slxos.v16r_1_00b.brocade_qos_mqc', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'TC5'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_map=policy_map, class_=class_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_map=policy_map, class_=class_)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def policy_map_class_scheduler_strict_priority_tc6_delete(self, policy_map=None, class_=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy_map: po_name
    :param policy_map: Keyword argument tuple.

    :type po_name: unicode
    :param po_name: **policy_map** tuple argument:  Policy Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type class_: cl_name
    :param class_: Keyword argument tuple.

    :type cl_name: unicode
    :param cl_name: **class_** tuple argument:  Policy Map Class Name (Max Size -64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.policy_map', 'policy_map'), ('pybind.nos.v7_0_1b.policy_map.class_', u'class_'), ('pybind.nos.v7_1_0.policy_map', 'policy_map'), ('pybind.nos.v7_1_0.policy_map.class_', u'class_'), ('pybind.nos.v6_0_2c.policy_map', 'policy_map'), ('pybind.nos.v6_0_2c.policy_map.class_', u'class_'), ('pybind.slxos.v16r_1_00b.policy_map', 'policy_map'), ('pybind.slxos.v16r_1_00b.policy_map.class_', u'class_')]
    bindings_list = [('pybind.nos.v6_0_2c.policy_map.class_.scheduler.strict_priority', 'pybind.nos.v6_0_2c.brocade_policer', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.policy_map.class_.scheduler.strict_priority', 'pybind.nos.v7_0_1b.brocade_policer', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.policy_map.class_.scheduler.strict_priority', 'pybind.nos.v7_1_0.brocade_policer', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.policy_map.class_.scheduler.strict_priority', 'pybind.slxos.v16r_1_00b.brocade_qos_mqc', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'TC6'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_map=policy_map, class_=class_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_map=policy_map, class_=class_)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def policy_map_class_scheduler_strict_priority_tc7_delete(self, policy_map=None, class_=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy_map: po_name
    :param policy_map: Keyword argument tuple.

    :type po_name: unicode
    :param po_name: **policy_map** tuple argument:  Policy Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type class_: cl_name
    :param class_: Keyword argument tuple.

    :type cl_name: unicode
    :param cl_name: **class_** tuple argument:  Policy Map Class Name (Max Size -64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.policy_map', 'policy_map'), ('pybind.nos.v7_0_1b.policy_map.class_', u'class_'), ('pybind.nos.v7_1_0.policy_map', 'policy_map'), ('pybind.nos.v7_1_0.policy_map.class_', u'class_'), ('pybind.nos.v6_0_2c.policy_map', 'policy_map'), ('pybind.nos.v6_0_2c.policy_map.class_', u'class_'), ('pybind.slxos.v16r_1_00b.policy_map', 'policy_map'), ('pybind.slxos.v16r_1_00b.policy_map.class_', u'class_')]
    bindings_list = [('pybind.nos.v6_0_2c.policy_map.class_.scheduler.strict_priority', 'pybind.nos.v6_0_2c.brocade_policer', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.policy_map.class_.scheduler.strict_priority', 'pybind.nos.v7_0_1b.brocade_policer', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.policy_map.class_.scheduler.strict_priority', 'pybind.nos.v7_1_0.brocade_policer', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.policy_map.class_.scheduler.strict_priority', 'pybind.slxos.v16r_1_00b.brocade_qos_mqc', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'TC7'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_map=policy_map, class_=class_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_map=policy_map, class_=class_)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def policy_map_class_set_cos_delete(self, policy_map=None, class_=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy_map: po_name
    :param policy_map: Keyword argument tuple.

    :type po_name: unicode
    :param po_name: **policy_map** tuple argument:  Policy Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type class_: cl_name
    :param class_: Keyword argument tuple.

    :type cl_name: unicode
    :param cl_name: **class_** tuple argument:  Policy Map Class Name (Max Size -64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.policy_map', 'policy_map'), ('pybind.nos.v7_0_1b.policy_map.class_', u'class_'), ('pybind.nos.v6_0_2c.policy_map', 'policy_map'), ('pybind.nos.v6_0_2c.policy_map.class_', u'class_'), ('pybind.slxos.v16r_1_00b.policy_map', 'policy_map'), ('pybind.slxos.v16r_1_00b.policy_map.class_', u'class_'), ('pybind.nos.v7_1_0.policy_map', 'policy_map'), ('pybind.nos.v7_1_0.policy_map.class_', u'class_')]
    bindings_list = [('pybind.nos.v6_0_2c.policy_map.class_.set_.set_cos_tc', 'pybind.nos.v6_0_2c.brocade_policer', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.policy_map.class_.set_.set_cos_tc', 'pybind.nos.v7_0_1b.brocade_policer', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.policy_map.class_.set_.set_cos_tc', 'pybind.nos.v7_1_0.brocade_policer', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.policy_map.class_.set_.set_cos_tc', 'pybind.slxos.v16r_1_00b.brocade_qos_mqc', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cos'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_map=policy_map, class_=class_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_map=policy_map, class_=class_)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def policy_map_class_set_dscp_delete(self, policy_map=None, class_=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy_map: po_name
    :param policy_map: Keyword argument tuple.

    :type po_name: unicode
    :param po_name: **policy_map** tuple argument:  Policy Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type class_: cl_name
    :param class_: Keyword argument tuple.

    :type cl_name: unicode
    :param cl_name: **class_** tuple argument:  Policy Map Class Name (Max Size -64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.policy_map', 'policy_map'), ('pybind.slxos.v16r_1_00b.policy_map.class_', u'class_'), ('pybind.nos.v6_0_2c.policy_map', 'policy_map'), ('pybind.nos.v6_0_2c.policy_map.class_', u'class_'), ('pybind.nos.v7_1_0.policy_map', 'policy_map'), ('pybind.nos.v7_1_0.policy_map.class_', u'class_'), ('pybind.nos.v7_0_1b.policy_map', 'policy_map'), ('pybind.nos.v7_0_1b.policy_map.class_', u'class_')]
    bindings_list = [('pybind.nos.v6_0_2c.policy_map.class_.set_.set_dscp', 'pybind.nos.v6_0_2c.brocade_policer', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.policy_map.class_.set_.set_dscp', 'pybind.nos.v7_0_1b.brocade_policer', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.policy_map.class_.set_.set_dscp', 'pybind.nos.v7_1_0.brocade_policer', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.policy_map.class_.set_.set_dscp', 'pybind.slxos.v16r_1_00b.brocade_qos_mqc', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dscp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_map=policy_map, class_=class_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_map=policy_map, class_=class_)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def policy_map_class_set_set_cos_tc_delete(self, policy_map=None, class_=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy_map: po_name
    :param policy_map: Keyword argument tuple.

    :type po_name: unicode
    :param po_name: **policy_map** tuple argument:  Policy Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type class_: cl_name
    :param class_: Keyword argument tuple.

    :type cl_name: unicode
    :param cl_name: **class_** tuple argument:  Policy Map Class Name (Max Size -64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.policy_map', 'policy_map'), ('pybind.nos.v7_0_1b.policy_map.class_', u'class_'), ('pybind.nos.v6_0_2c.policy_map', 'policy_map'), ('pybind.nos.v6_0_2c.policy_map.class_', u'class_'), ('pybind.slxos.v16r_1_00b.policy_map', 'policy_map'), ('pybind.slxos.v16r_1_00b.policy_map.class_', u'class_'), ('pybind.nos.v7_1_0.policy_map', 'policy_map'), ('pybind.nos.v7_1_0.policy_map.class_', u'class_')]
    bindings_list = [('pybind.nos.v6_0_2c.policy_map.class_.set_.set_cos_tc', 'pybind.nos.v6_0_2c.brocade_policer', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.policy_map.class_.set_.set_cos_tc', 'pybind.nos.v7_0_1b.brocade_policer', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.policy_map.class_.set_.set_cos_tc', 'pybind.nos.v7_1_0.brocade_policer', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.policy_map.class_.set_.set_cos_tc', 'pybind.slxos.v16r_1_00b.brocade_qos_mqc', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'cos, traffic_class'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_map=policy_map, class_=class_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_map=policy_map, class_=class_)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def policy_map_class_set_set_dscp_delete(self, policy_map=None, class_=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy_map: po_name
    :param policy_map: Keyword argument tuple.

    :type po_name: unicode
    :param po_name: **policy_map** tuple argument:  Policy Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type class_: cl_name
    :param class_: Keyword argument tuple.

    :type cl_name: unicode
    :param cl_name: **class_** tuple argument:  Policy Map Class Name (Max Size -64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.policy_map', 'policy_map'), ('pybind.slxos.v16r_1_00b.policy_map.class_', u'class_'), ('pybind.nos.v6_0_2c.policy_map', 'policy_map'), ('pybind.nos.v6_0_2c.policy_map.class_', u'class_'), ('pybind.nos.v7_1_0.policy_map', 'policy_map'), ('pybind.nos.v7_1_0.policy_map.class_', u'class_'), ('pybind.nos.v7_0_1b.policy_map', 'policy_map'), ('pybind.nos.v7_0_1b.policy_map.class_', u'class_')]
    bindings_list = [('pybind.nos.v6_0_2c.policy_map.class_.set_.set_dscp', 'pybind.nos.v6_0_2c.brocade_policer', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.policy_map.class_.set_.set_dscp', 'pybind.nos.v7_0_1b.brocade_policer', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.policy_map.class_.set_.set_dscp', 'pybind.nos.v7_1_0.brocade_policer', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.policy_map.class_.set_.set_dscp', 'pybind.slxos.v16r_1_00b.brocade_qos_mqc', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_map=policy_map, class_=class_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_map=policy_map, class_=class_)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def policy_map_class_set_traffic_class_delete(self, policy_map=None, class_=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy_map: po_name
    :param policy_map: Keyword argument tuple.

    :type po_name: unicode
    :param po_name: **policy_map** tuple argument:  Policy Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type class_: cl_name
    :param class_: Keyword argument tuple.

    :type cl_name: unicode
    :param cl_name: **class_** tuple argument:  Policy Map Class Name (Max Size -64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.policy_map', 'policy_map'), ('pybind.nos.v7_0_1b.policy_map.class_', u'class_'), ('pybind.nos.v6_0_2c.policy_map', 'policy_map'), ('pybind.nos.v6_0_2c.policy_map.class_', u'class_'), ('pybind.slxos.v16r_1_00b.policy_map', 'policy_map'), ('pybind.slxos.v16r_1_00b.policy_map.class_', u'class_'), ('pybind.nos.v7_1_0.policy_map', 'policy_map'), ('pybind.nos.v7_1_0.policy_map.class_', u'class_')]
    bindings_list = [('pybind.nos.v6_0_2c.policy_map.class_.set_.set_cos_tc', 'pybind.nos.v6_0_2c.brocade_policer', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.policy_map.class_.set_.set_cos_tc', 'pybind.nos.v7_0_1b.brocade_policer', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.policy_map.class_.set_.set_cos_tc', 'pybind.nos.v7_1_0.brocade_policer', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.policy_map.class_.set_.set_cos_tc', 'pybind.slxos.v16r_1_00b.brocade_qos_mqc', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'traffic-class'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_map=policy_map, class_=class_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_map=policy_map, class_=class_)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def policy_map_class_sflow_profile_delete(self, policy_map=None, class_=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy_map: name
    :param policy_map: Keyword argument tuple.

    :type name: unicode
    :param name: **policy_map** tuple argument:  Policy Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    **Instance Keyword Argument Tuple**:

    :type class_: cl_name
    :param class_: Keyword argument tuple.

    :type cl_name: unicode
    :param cl_name: **class_** tuple argument:  Policy Map Class Name (Max Size -64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.policy_map', 'policy_map')]
    bindings_list = [('pybind.slxos.v16r_1_00b.policy_map.class_', 'pybind.slxos.v16r_1_00b.brocade_qos_mqc', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'class_', 'keyval': 'cl_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'sflow-profile'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_map=policy_map, class_=class_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_map=policy_map, class_=class_)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def policy_map_class_shape_delete(self, policy_map=None, class_=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy_map: po_name
    :param policy_map: Keyword argument tuple.

    :type po_name: unicode
    :param po_name: **policy_map** tuple argument:  Policy Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type class_: cl_name
    :param class_: Keyword argument tuple.

    :type cl_name: unicode
    :param cl_name: **class_** tuple argument:  Policy Map Class Name (Max Size -64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.policy_map', 'policy_map'), ('pybind.nos.v7_1_0.policy_map.class_', u'class_'), ('pybind.slxos.v16r_1_00b.policy_map', 'policy_map'), ('pybind.slxos.v16r_1_00b.policy_map.class_', u'class_'), ('pybind.nos.v7_0_1b.policy_map', 'policy_map'), ('pybind.nos.v7_0_1b.policy_map.class_', u'class_'), ('pybind.nos.v6_0_2c.policy_map', 'policy_map'), ('pybind.nos.v6_0_2c.policy_map.class_', u'class_')]
    bindings_list = [('pybind.nos.v6_0_2c.policy_map.class_.shape', 'pybind.nos.v6_0_2c.brocade_policer', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.policy_map.class_.shape', 'pybind.nos.v7_0_1b.brocade_policer', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.policy_map.class_.shape', 'pybind.nos.v7_1_0.brocade_policer', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.policy_map.class_.shape', 'pybind.slxos.v16r_1_00b.brocade_qos_mqc', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_map=policy_map, class_=class_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_map=policy_map, class_=class_)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def policy_map_class_shape_shaping_rate_delete(self, policy_map=None, class_=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy_map: po_name
    :param policy_map: Keyword argument tuple.

    :type po_name: unicode
    :param po_name: **policy_map** tuple argument:  Policy Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type class_: cl_name
    :param class_: Keyword argument tuple.

    :type cl_name: unicode
    :param cl_name: **class_** tuple argument:  Policy Map Class Name (Max Size -64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.policy_map', 'policy_map'), ('pybind.nos.v7_1_0.policy_map.class_', u'class_'), ('pybind.slxos.v16r_1_00b.policy_map', 'policy_map'), ('pybind.slxos.v16r_1_00b.policy_map.class_', u'class_'), ('pybind.nos.v7_0_1b.policy_map', 'policy_map'), ('pybind.nos.v7_0_1b.policy_map.class_', u'class_'), ('pybind.nos.v6_0_2c.policy_map', 'policy_map'), ('pybind.nos.v6_0_2c.policy_map.class_', u'class_')]
    bindings_list = [('pybind.nos.v6_0_2c.policy_map.class_.shape', 'pybind.nos.v6_0_2c.brocade_policer', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.policy_map.class_.shape', 'pybind.nos.v7_0_1b.brocade_policer', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.policy_map.class_.shape', 'pybind.nos.v7_1_0.brocade_policer', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.policy_map.class_.shape', 'pybind.slxos.v16r_1_00b.brocade_qos_mqc', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'shaping_rate'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_map=policy_map, class_=class_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_map=policy_map, class_=class_)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def policy_map_class_span_delete(self, policy_map=None, class_=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy_map: po_name
    :param policy_map: Keyword argument tuple.

    :type po_name: unicode
    :param po_name: **policy_map** tuple argument:  Policy Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type class_: cl_name
    :param class_: Keyword argument tuple.

    :type cl_name: unicode
    :param cl_name: **class_** tuple argument:  Policy Map Class Name (Max Size -64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.policy_map', 'policy_map'), ('pybind.slxos.v16r_1_00b.policy_map.class_', u'class_'), ('pybind.nos.v6_0_2c.policy_map', 'policy_map'), ('pybind.nos.v6_0_2c.policy_map.class_', u'class_'), ('pybind.nos.v7_1_0.policy_map', 'policy_map'), ('pybind.nos.v7_1_0.policy_map.class_', u'class_'), ('pybind.nos.v7_0_1b.policy_map', 'policy_map'), ('pybind.nos.v7_0_1b.policy_map.class_', u'class_')]
    bindings_list = [('pybind.nos.v6_0_2c.policy_map.class_.span', 'pybind.nos.v6_0_2c.brocade_policer', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.policy_map.class_.span', 'pybind.nos.v7_0_1b.brocade_policer', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.policy_map.class_.span', 'pybind.nos.v7_1_0.brocade_policer', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.policy_map.class_.span', 'pybind.slxos.v16r_1_00b.brocade_qos_mqc', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_map=policy_map, class_=class_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_map=policy_map, class_=class_)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def policy_map_class_span_session_delete(self, policy_map=None, class_=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy_map: po_name
    :param policy_map: Keyword argument tuple.

    :type po_name: unicode
    :param po_name: **policy_map** tuple argument:  Policy Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type class_: cl_name
    :param class_: Keyword argument tuple.

    :type cl_name: unicode
    :param cl_name: **class_** tuple argument:  Policy Map Class Name (Max Size -64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.policy_map', 'policy_map'), ('pybind.slxos.v16r_1_00b.policy_map.class_', u'class_'), ('pybind.nos.v6_0_2c.policy_map', 'policy_map'), ('pybind.nos.v6_0_2c.policy_map.class_', u'class_'), ('pybind.nos.v7_1_0.policy_map', 'policy_map'), ('pybind.nos.v7_1_0.policy_map.class_', u'class_'), ('pybind.nos.v7_0_1b.policy_map', 'policy_map'), ('pybind.nos.v7_0_1b.policy_map.class_', u'class_')]
    bindings_list = [('pybind.nos.v6_0_2c.policy_map.class_.span', 'pybind.nos.v6_0_2c.brocade_policer', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.policy_map.class_.span', 'pybind.nos.v7_0_1b.brocade_policer', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.policy_map.class_.span', 'pybind.nos.v7_1_0.brocade_policer', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.policy_map.class_.span', 'pybind.slxos.v16r_1_00b.brocade_qos_mqc', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'session'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_map=policy_map, class_=class_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_map=policy_map, class_=class_)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def port_channel_redundancy_group_delete(self, port_channel_redundancy_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type port_channel_redundancy_group: group_id
    :param port_channel_redundancy_group: Keyword argument tuple.

    :type group_id: long
    :param group_id: **port_channel_redundancy_group** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.port_channel_redundancy_group', 'pybind.nos.v6_0_2c.brocade_lag', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.port_channel_redundancy_group', 'pybind.nos.v7_0_1b.brocade_lag', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.port_channel_redundancy_group', 'pybind.nos.v7_1_0.brocade_lag', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.port_channel_redundancy_group', 'pybind.slxos.v16r_1_00b.brocade_lag', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'port_channel_redundancy_group', 'keyval': 'group_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel_redundancy_group=port_channel_redundancy_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel_redundancy_group=port_channel_redundancy_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def port_channel_redundancy_group_activate_delete(self, port_channel_redundancy_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type port_channel_redundancy_group: group_id
    :param port_channel_redundancy_group: Keyword argument tuple.

    :type group_id: long
    :param group_id: **port_channel_redundancy_group** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.port_channel_redundancy_group', 'pybind.nos.v6_0_2c.brocade_lag', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.port_channel_redundancy_group', 'pybind.nos.v7_0_1b.brocade_lag', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.port_channel_redundancy_group', 'pybind.nos.v7_1_0.brocade_lag', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.port_channel_redundancy_group', 'pybind.slxos.v16r_1_00b.brocade_lag', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'port_channel_redundancy_group', 'keyval': 'group_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'activate'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel_redundancy_group=port_channel_redundancy_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel_redundancy_group=port_channel_redundancy_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def port_channel_redundancy_group_port_channel_delete(self, port_channel_redundancy_group=None, port_channel=None, port_channel_active=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel_redundancy_group: group_id
    :param port_channel_redundancy_group: Keyword argument tuple.

    :type group_id: long
    :param group_id: **port_channel_redundancy_group** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type port_channel: name, port_channel_active
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type port_channel_active: YANGBool
    :param port_channel_active: **port_channel** tuple argument:  Select port-channel as active in port-channel redundancy group.

    **Instance Argument(s)**:

    :type port_channel_active: YANGBool
    :param port_channel_active: Select port-channel as active in port-channel redundancy group.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.port_channel_redundancy_group', 'port_channel_redundancy_group'), ('pybind.nos.v7_0_1b.port_channel_redundancy_group', 'port_channel_redundancy_group'), ('pybind.nos.v7_1_0.port_channel_redundancy_group', 'port_channel_redundancy_group'), ('pybind.slxos.v16r_1_00b.port_channel_redundancy_group', 'port_channel_redundancy_group')]
    bindings_list = [('pybind.nos.v6_0_2c.port_channel_redundancy_group.port_channel', 'pybind.nos.v6_0_2c.brocade_lag', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.port_channel_redundancy_group.port_channel', 'pybind.nos.v7_0_1b.brocade_lag', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.port_channel_redundancy_group.port_channel', 'pybind.nos.v7_1_0.brocade_lag', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.port_channel_redundancy_group.port_channel', 'pybind.slxos.v16r_1_00b.brocade_lag', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'group_id', 'extra_keyval': ''}, {'keyval': 'group_id', 'extra_keyval': ''}, {'keyval': 'group_id', 'extra_keyval': ''}, {'keyval': 'group_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'port_channel', 'keyval': 'name', 'extra_keyval': 'name, port_channel_active'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel_redundancy_group=port_channel_redundancy_group, port_channel=port_channel, port_channel_active=port_channel_active)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel_redundancy_group=port_channel_redundancy_group, port_channel=port_channel, port_channel_active=port_channel_active)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def port_channel_redundancy_group_port_channel_active_delete(self, port_channel_redundancy_group=None, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel_redundancy_group: group_id
    :param port_channel_redundancy_group: Keyword argument tuple.

    :type group_id: long
    :param group_id: **port_channel_redundancy_group** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.port_channel_redundancy_group', 'port_channel_redundancy_group'), ('pybind.nos.v7_0_1b.port_channel_redundancy_group', 'port_channel_redundancy_group'), ('pybind.nos.v7_1_0.port_channel_redundancy_group', 'port_channel_redundancy_group'), ('pybind.slxos.v16r_1_00b.port_channel_redundancy_group', 'port_channel_redundancy_group')]
    bindings_list = [('pybind.nos.v6_0_2c.port_channel_redundancy_group.port_channel', 'pybind.nos.v6_0_2c.brocade_lag', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.port_channel_redundancy_group.port_channel', 'pybind.nos.v7_0_1b.brocade_lag', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.port_channel_redundancy_group.port_channel', 'pybind.nos.v7_1_0.brocade_lag', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.port_channel_redundancy_group.port_channel', 'pybind.slxos.v16r_1_00b.brocade_lag', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'group_id', 'extra_keyval': ''}, {'keyval': 'group_id', 'extra_keyval': ''}, {'keyval': 'group_id', 'extra_keyval': ''}, {'keyval': 'group_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'port_channel', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'active'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel_redundancy_group=port_channel_redundancy_group, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel_redundancy_group=port_channel_redundancy_group, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def port_profile_delete(self, port_profile=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.port_profile', 'pybind.nos.v6_0_2c.brocade_port_profile', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.port_profile', 'pybind.nos.v7_0_1b.brocade_port_profile', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.port_profile', 'pybind.nos.v7_1_0.brocade_port_profile', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.port_profile', 'pybind.slxos.v16r_1_00b.brocade_port_profile', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'port_profile', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def port_profile_activate_delete(self, port_profile=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.port_profile_global.port_profile', 'pybind.nos.v6_0_2c.brocade_port_profile', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.port_profile_global.port_profile', 'pybind.nos.v7_0_1b.brocade_port_profile', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.port_profile_global.port_profile', 'pybind.nos.v7_1_0.brocade_port_profile', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.port_profile_global.port_profile', 'pybind.slxos.v16r_1_00b.brocade_port_profile', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'port_profile', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'activate'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def port_profile_allow_non_profiled_macs_delete(self, port_profile=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.port_profile', 'port_profile'), ('pybind.nos.v7_0_1b.port_profile', 'port_profile'), ('pybind.nos.v7_1_0.port_profile', 'port_profile'), ('pybind.slxos.v16r_1_00b.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2c.port_profile.allow', 'pybind.nos.v6_0_2c.brocade_port_profile', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.port_profile.allow', 'pybind.nos.v7_0_1b.brocade_port_profile', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.port_profile.allow', 'pybind.nos.v7_1_0.brocade_port_profile', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.port_profile.allow', 'pybind.slxos.v16r_1_00b.brocade_port_profile', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'non-profiled-macs'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def port_profile_domain_delete(self, port_profile_domain=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type port_profile_domain: port_profile_domain_name
    :param port_profile_domain: Keyword argument tuple.

    :type port_profile_domain_name: unicode
    :param port_profile_domain_name: **port_profile_domain** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.port_profile_domain', 'pybind.nos.v6_0_2c.brocade_port_profile', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.port_profile_domain', 'pybind.nos.v7_0_1b.brocade_port_profile', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.port_profile_domain', 'pybind.nos.v7_1_0.brocade_port_profile', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.port_profile_domain', 'pybind.slxos.v16r_1_00b.brocade_port_profile', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'port_profile_domain', 'keyval': 'port_profile_domain_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile_domain=port_profile_domain)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile_domain=port_profile_domain)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def port_profile_domain_port_profile_delete(self, port_profile_domain=None, profile=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile_domain: port_profile_domain_name
    :param port_profile_domain: Keyword argument tuple.

    :type port_profile_domain_name: unicode
    :param port_profile_domain_name: **port_profile_domain** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    **Instance Keyword Argument Tuple**:

    :type profile: profile_name
    :param profile: Keyword argument tuple.

    :type profile_name: unicode
    :param profile_name: **profile** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.port_profile_domain', 'port_profile_domain'), ('pybind.nos.v6_0_2c.port_profile_domain', 'port_profile_domain'), ('pybind.nos.v7_1_0.port_profile_domain', 'port_profile_domain'), ('pybind.nos.v7_0_1b.port_profile_domain', 'port_profile_domain')]
    bindings_list = [('pybind.nos.v6_0_2c.port_profile_domain.profile', 'pybind.nos.v6_0_2c.brocade_port_profile', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.port_profile_domain.profile', 'pybind.nos.v7_0_1b.brocade_port_profile', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.port_profile_domain.profile', 'pybind.nos.v7_1_0.brocade_port_profile', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.port_profile_domain.profile', 'pybind.slxos.v16r_1_00b.brocade_port_profile', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'port_profile_domain_name', 'extra_keyval': ''}, {'keyval': 'port_profile_domain_name', 'extra_keyval': ''}, {'keyval': 'port_profile_domain_name', 'extra_keyval': ''}, {'keyval': 'port_profile_domain_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'profile', 'keyval': 'profile_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile_domain=port_profile_domain, profile=profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile_domain=port_profile_domain, profile=profile)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def port_profile_fcoe_profile_delete(self, port_profile=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.port_profile', 'port_profile'), ('pybind.nos.v7_1_0.port_profile', 'port_profile'), ('pybind.nos.v7_0_1b.port_profile', 'port_profile'), ('pybind.nos.v6_0_2c.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2c.port_profile.fcoe_profile', 'pybind.nos.v6_0_2c.brocade_port_profile', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.port_profile.fcoe_profile', 'pybind.nos.v7_0_1b.brocade_port_profile', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.port_profile.fcoe_profile', 'pybind.nos.v7_1_0.brocade_port_profile', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.port_profile.fcoe_profile', 'pybind.slxos.v16r_1_00b.brocade_port_profile', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def port_profile_fcoe_profile_fcoeport_delete(self, port_profile=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.port_profile', 'port_profile'), ('pybind.nos.v7_0_1b.port_profile', 'port_profile'), ('pybind.nos.v6_0_2c.port_profile', 'port_profile'), ('pybind.nos.v7_1_0.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2c.port_profile.fcoe_profile.fcoeport', 'pybind.nos.v6_0_2c.brocade_port_profile', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.port_profile.fcoe_profile.fcoeport', 'pybind.nos.v7_0_1b.brocade_port_profile', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.port_profile.fcoe_profile.fcoeport', 'pybind.nos.v7_1_0.brocade_port_profile', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.port_profile.fcoe_profile.fcoeport', 'pybind.slxos.v16r_1_00b.brocade_port_profile', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def port_profile_fcoe_profile_fcoeport_fcoe_map_name_delete(self, port_profile=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.port_profile', 'port_profile'), ('pybind.nos.v7_0_1b.port_profile', 'port_profile'), ('pybind.nos.v6_0_2c.port_profile', 'port_profile'), ('pybind.nos.v7_1_0.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2c.port_profile.fcoe_profile.fcoeport', 'pybind.nos.v6_0_2c.brocade_port_profile', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.port_profile.fcoe_profile.fcoeport', 'pybind.nos.v7_0_1b.brocade_port_profile', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.port_profile.fcoe_profile.fcoeport', 'pybind.nos.v7_1_0.brocade_port_profile', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.port_profile.fcoe_profile.fcoeport', 'pybind.slxos.v16r_1_00b.brocade_port_profile', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'fcoe-map-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def port_profile_global_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.port_profile_global', 'pybind.nos.v6_0_2c.brocade_port_profile', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.port_profile_global', 'pybind.nos.v7_0_1b.brocade_port_profile', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.port_profile_global', 'pybind.nos.v7_1_0.brocade_port_profile', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.port_profile_global', 'pybind.slxos.v16r_1_00b.brocade_port_profile', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def port_profile_port_profile_global_delete(self, port_profile=None, activate=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    **Instance Argument(s)**:

    :type activate: YANGBool
    :param activate: Activate the profile

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.port_profile_global.port_profile', 'pybind.nos.v6_0_2c.brocade_port_profile', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.port_profile_global.port_profile', 'pybind.nos.v7_0_1b.brocade_port_profile', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.port_profile_global.port_profile', 'pybind.nos.v7_1_0.brocade_port_profile', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.port_profile_global.port_profile', 'pybind.slxos.v16r_1_00b.brocade_port_profile', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'port_profile', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile, activate=activate)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile, activate=activate)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def port_profile_qos_profile_delete(self, port_profile=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.port_profile', 'port_profile'), ('pybind.nos.v7_0_1b.port_profile', 'port_profile'), ('pybind.nos.v7_1_0.port_profile', 'port_profile'), ('pybind.slxos.v16r_1_00b.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2c.port_profile.qos_profile', 'pybind.nos.v6_0_2c.brocade_port_profile', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.port_profile.qos_profile', 'pybind.nos.v7_0_1b.brocade_port_profile', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.port_profile.qos_profile', 'pybind.nos.v7_1_0.brocade_port_profile', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.port_profile.qos_profile', 'pybind.slxos.v16r_1_00b.brocade_port_profile', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def port_profile_qos_profile_cee_delete(self, port_profile=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.port_profile', 'port_profile'), ('pybind.nos.v7_0_1b.port_profile', 'port_profile'), ('pybind.nos.v7_1_0.port_profile', 'port_profile'), ('pybind.slxos.v16r_1_00b.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2c.port_profile.qos_profile', 'pybind.nos.v6_0_2c.brocade_port_profile', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.port_profile.qos_profile', 'pybind.nos.v7_0_1b.brocade_port_profile', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.port_profile.qos_profile', 'pybind.nos.v7_1_0.brocade_port_profile', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.port_profile.qos_profile', 'pybind.slxos.v16r_1_00b.brocade_port_profile', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cee'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def port_profile_qos_profile_qos_delete(self, port_profile=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.port_profile', 'port_profile'), ('pybind.nos.v7_0_1b.port_profile', 'port_profile'), ('pybind.slxos.v16r_1_00b.port_profile', 'port_profile'), ('pybind.nos.v7_1_0.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2c.port_profile.qos_profile.qos', 'pybind.nos.v6_0_2c.brocade_port_profile', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.port_profile.qos_profile.qos', 'pybind.nos.v7_0_1b.brocade_port_profile', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.port_profile.qos_profile.qos', 'pybind.nos.v7_1_0.brocade_port_profile', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.port_profile.qos_profile.qos', 'pybind.slxos.v16r_1_00b.brocade_port_profile', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def port_profile_qos_profile_qos_cos_delete(self, port_profile=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.port_profile', 'port_profile'), ('pybind.nos.v7_0_1b.port_profile', 'port_profile'), ('pybind.slxos.v16r_1_00b.port_profile', 'port_profile'), ('pybind.nos.v7_1_0.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2c.port_profile.qos_profile.qos', 'pybind.nos.v6_0_2c.brocade_port_profile', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.port_profile.qos_profile.qos', 'pybind.nos.v7_0_1b.brocade_port_profile', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.port_profile.qos_profile.qos', 'pybind.nos.v7_1_0.brocade_port_profile', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.port_profile.qos_profile.qos', 'pybind.slxos.v16r_1_00b.brocade_port_profile', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cos'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def port_profile_qos_profile_qos_cos_mutation_delete(self, port_profile=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.port_profile', 'port_profile'), ('pybind.nos.v7_0_1b.port_profile', 'port_profile'), ('pybind.slxos.v16r_1_00b.port_profile', 'port_profile'), ('pybind.nos.v7_1_0.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2c.port_profile.qos_profile.qos', 'pybind.nos.v6_0_2c.brocade_port_profile', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.port_profile.qos_profile.qos', 'pybind.nos.v7_0_1b.brocade_port_profile', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.port_profile.qos_profile.qos', 'pybind.nos.v7_1_0.brocade_port_profile', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.port_profile.qos_profile.qos', 'pybind.slxos.v16r_1_00b.brocade_port_profile', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cos-mutation'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def port_profile_qos_profile_qos_cos_traffic_class_delete(self, port_profile=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.port_profile', 'port_profile'), ('pybind.nos.v7_0_1b.port_profile', 'port_profile'), ('pybind.slxos.v16r_1_00b.port_profile', 'port_profile'), ('pybind.nos.v7_1_0.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2c.port_profile.qos_profile.qos', 'pybind.nos.v6_0_2c.brocade_port_profile', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.port_profile.qos_profile.qos', 'pybind.nos.v7_0_1b.brocade_port_profile', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.port_profile.qos_profile.qos', 'pybind.nos.v7_1_0.brocade_port_profile', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.port_profile.qos_profile.qos', 'pybind.slxos.v16r_1_00b.brocade_port_profile', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cos-traffic-class'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def port_profile_qos_profile_qos_flowcontrol_delete(self, port_profile=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.port_profile', 'port_profile'), ('pybind.nos.v7_1_0.port_profile', 'port_profile'), ('pybind.nos.v6_0_2c.port_profile', 'port_profile'), ('pybind.nos.v7_0_1b.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2c.port_profile.qos_profile.qos.flowcontrol', 'pybind.nos.v6_0_2c.brocade_port_profile', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.port_profile.qos_profile.qos.flowcontrol', 'pybind.nos.v7_0_1b.brocade_port_profile', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.port_profile.qos_profile.qos.flowcontrol', 'pybind.nos.v7_1_0.brocade_port_profile', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.port_profile.qos_profile.qos.flowcontrol', 'pybind.slxos.v16r_1_00b.brocade_port_profile', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def port_profile_qos_profile_qos_flowcontrol_flowcontrolglobal_delete(self, port_profile=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.port_profile', 'port_profile'), ('pybind.slxos.v16r_1_00b.port_profile', 'port_profile'), ('pybind.nos.v7_0_1b.port_profile', 'port_profile'), ('pybind.nos.v6_0_2c.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2c.port_profile.qos_profile.qos.flowcontrol.flowcontrolglobal', 'pybind.nos.v6_0_2c.brocade_port_profile', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.port_profile.qos_profile.qos.flowcontrol.flowcontrolglobal', 'pybind.nos.v7_0_1b.brocade_port_profile', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.port_profile.qos_profile.qos.flowcontrol.flowcontrolglobal', 'pybind.nos.v7_1_0.brocade_port_profile', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.port_profile.qos_profile.qos.flowcontrol.flowcontrolglobal', 'pybind.slxos.v16r_1_00b.brocade_port_profile', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def port_profile_qos_profile_qos_flowcontrol_pfc_delete(self, port_profile=None, pfc=None, pfc_tx=None, pfc_rx=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    **Instance Keyword Argument Tuple**:

    :type pfc: pfc_cos
    :param pfc: Keyword argument tuple.

    :type pfc_cos: long
    :param pfc_cos: **pfc** tuple argument:  CoS value

        * range restriction: ::

            ['-2147483648..2147483647']

    **Instance Argument(s)**:

    :type pfc_tx: unicode
    :param pfc_tx: Configure Pause generation

        * enumeration restriction: ::

            ['on', 'off']

    :type pfc_rx: unicode
    :param pfc_rx: Configure Pause reception

        * enumeration restriction: ::

            ['on', 'off']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.port_profile', 'port_profile'), ('pybind.nos.v7_1_0.port_profile', 'port_profile'), ('pybind.nos.v6_0_2c.port_profile', 'port_profile'), ('pybind.slxos.v16r_1_00b.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2c.port_profile.qos_profile.qos.flowcontrol.pfc', 'pybind.nos.v6_0_2c.brocade_port_profile', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.port_profile.qos_profile.qos.flowcontrol.pfc', 'pybind.nos.v7_0_1b.brocade_port_profile', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.port_profile.qos_profile.qos.flowcontrol.pfc', 'pybind.nos.v7_1_0.brocade_port_profile', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.port_profile.qos_profile.qos.flowcontrol.pfc', 'pybind.slxos.v16r_1_00b.brocade_port_profile', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'pfc', 'keyval': 'pfc_cos', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile, pfc=pfc, pfc_tx=pfc_tx, pfc_rx=pfc_rx)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile, pfc=pfc, pfc_tx=pfc_tx, pfc_rx=pfc_rx)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def port_profile_qos_profile_qos_flowcontrol_pfc_rx_delete(self, port_profile=None, pfc=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    **Instance Keyword Argument Tuple**:

    :type pfc: pfc_cos
    :param pfc: Keyword argument tuple.

    :type pfc_cos: long
    :param pfc_cos: **pfc** tuple argument:  CoS value

        * range restriction: ::

            ['-2147483648..2147483647']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.port_profile', 'port_profile'), ('pybind.nos.v7_1_0.port_profile', 'port_profile'), ('pybind.nos.v6_0_2c.port_profile', 'port_profile'), ('pybind.slxos.v16r_1_00b.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2c.port_profile.qos_profile.qos.flowcontrol.pfc', 'pybind.nos.v6_0_2c.brocade_port_profile', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.port_profile.qos_profile.qos.flowcontrol.pfc', 'pybind.nos.v7_0_1b.brocade_port_profile', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.port_profile.qos_profile.qos.flowcontrol.pfc', 'pybind.nos.v7_1_0.brocade_port_profile', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.port_profile.qos_profile.qos.flowcontrol.pfc', 'pybind.slxos.v16r_1_00b.brocade_port_profile', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'pfc', 'keyval': 'pfc_cos', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile, pfc=pfc)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile, pfc=pfc)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def port_profile_qos_profile_qos_flowcontrol_pfc_tx_delete(self, port_profile=None, pfc=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    **Instance Keyword Argument Tuple**:

    :type pfc: pfc_cos
    :param pfc: Keyword argument tuple.

    :type pfc_cos: long
    :param pfc_cos: **pfc** tuple argument:  CoS value

        * range restriction: ::

            ['-2147483648..2147483647']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.port_profile', 'port_profile'), ('pybind.nos.v7_1_0.port_profile', 'port_profile'), ('pybind.nos.v6_0_2c.port_profile', 'port_profile'), ('pybind.slxos.v16r_1_00b.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2c.port_profile.qos_profile.qos.flowcontrol.pfc', 'pybind.nos.v6_0_2c.brocade_port_profile', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.port_profile.qos_profile.qos.flowcontrol.pfc', 'pybind.nos.v7_0_1b.brocade_port_profile', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.port_profile.qos_profile.qos.flowcontrol.pfc', 'pybind.nos.v7_1_0.brocade_port_profile', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.port_profile.qos_profile.qos.flowcontrol.pfc', 'pybind.slxos.v16r_1_00b.brocade_port_profile', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'pfc', 'keyval': 'pfc_cos', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile, pfc=pfc)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile, pfc=pfc)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def port_profile_qos_profile_qos_flowcontrol_rx_delete(self, port_profile=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.port_profile', 'port_profile'), ('pybind.slxos.v16r_1_00b.port_profile', 'port_profile'), ('pybind.nos.v7_0_1b.port_profile', 'port_profile'), ('pybind.nos.v6_0_2c.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2c.port_profile.qos_profile.qos.flowcontrol.flowcontrolglobal', 'pybind.nos.v6_0_2c.brocade_port_profile', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.port_profile.qos_profile.qos.flowcontrol.flowcontrolglobal', 'pybind.nos.v7_0_1b.brocade_port_profile', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.port_profile.qos_profile.qos.flowcontrol.flowcontrolglobal', 'pybind.nos.v7_1_0.brocade_port_profile', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.port_profile.qos_profile.qos.flowcontrol.flowcontrolglobal', 'pybind.slxos.v16r_1_00b.brocade_port_profile', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def port_profile_qos_profile_qos_flowcontrol_tx_delete(self, port_profile=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.port_profile', 'port_profile'), ('pybind.slxos.v16r_1_00b.port_profile', 'port_profile'), ('pybind.nos.v7_0_1b.port_profile', 'port_profile'), ('pybind.nos.v6_0_2c.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2c.port_profile.qos_profile.qos.flowcontrol.flowcontrolglobal', 'pybind.nos.v6_0_2c.brocade_port_profile', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.port_profile.qos_profile.qos.flowcontrol.flowcontrolglobal', 'pybind.nos.v7_0_1b.brocade_port_profile', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.port_profile.qos_profile.qos.flowcontrol.flowcontrolglobal', 'pybind.nos.v7_1_0.brocade_port_profile', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.port_profile.qos_profile.qos.flowcontrol.flowcontrolglobal', 'pybind.slxos.v16r_1_00b.brocade_port_profile', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def port_profile_qos_profile_qos_trust_delete(self, port_profile=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.port_profile', 'port_profile'), ('pybind.nos.v7_1_0.port_profile', 'port_profile'), ('pybind.slxos.v16r_1_00b.port_profile', 'port_profile'), ('pybind.nos.v7_0_1b.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2c.port_profile.qos_profile.qos.trust', 'pybind.nos.v6_0_2c.brocade_port_profile', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.port_profile.qos_profile.qos.trust', 'pybind.nos.v7_0_1b.brocade_port_profile', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.port_profile.qos_profile.qos.trust', 'pybind.nos.v7_1_0.brocade_port_profile', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.port_profile.qos_profile.qos.trust', 'pybind.slxos.v16r_1_00b.brocade_port_profile', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def port_profile_qos_profile_qos_trust_cos_delete(self, port_profile=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.port_profile', 'port_profile'), ('pybind.nos.v7_1_0.port_profile', 'port_profile'), ('pybind.slxos.v16r_1_00b.port_profile', 'port_profile'), ('pybind.nos.v7_0_1b.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2c.port_profile.qos_profile.qos.trust', 'pybind.nos.v6_0_2c.brocade_port_profile', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.port_profile.qos_profile.qos.trust', 'pybind.nos.v7_0_1b.brocade_port_profile', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.port_profile.qos_profile.qos.trust', 'pybind.nos.v7_1_0.brocade_port_profile', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.port_profile.qos_profile.qos.trust', 'pybind.slxos.v16r_1_00b.brocade_port_profile', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cos'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def port_profile_restrict_flooding_delete(self, port_profile=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.port_profile', 'port_profile'), ('pybind.slxos.v16r_1_00b.port_profile', 'port_profile'), ('pybind.nos.v7_0_1b.port_profile', 'port_profile'), ('pybind.nos.v6_0_2c.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2c.port_profile.restrict_flooding_container', 'pybind.nos.v6_0_2c.brocade_port_profile', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.port_profile.restrict_flooding_container', 'pybind.nos.v7_0_1b.brocade_port_profile', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.port_profile.restrict_flooding_container', 'pybind.nos.v7_1_0.brocade_port_profile', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.port_profile.restrict_flooding_container', 'pybind.slxos.v16r_1_00b.brocade_port_profile', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'restrict-flooding'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def port_profile_security_profile_delete(self, port_profile=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.port_profile', 'port_profile'), ('pybind.nos.v6_0_2c.port_profile', 'port_profile'), ('pybind.nos.v7_0_1b.port_profile', 'port_profile'), ('pybind.slxos.v16r_1_00b.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2c.port_profile.security_profile', 'pybind.nos.v6_0_2c.brocade_port_profile', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.port_profile.security_profile', 'pybind.nos.v7_0_1b.brocade_port_profile', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.port_profile.security_profile', 'pybind.nos.v7_1_0.brocade_port_profile', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.port_profile.security_profile', 'pybind.slxos.v16r_1_00b.brocade_port_profile', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def port_profile_security_profile_ip_access_group_in_delete(self, port_profile=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.port_profile', 'port_profile'), ('pybind.nos.v7_0_1b.port_profile', 'port_profile'), ('pybind.nos.v7_1_0.port_profile', 'port_profile'), ('pybind.nos.v6_0_2c.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2c.port_profile.security_profile.ip.access_group', 'pybind.nos.v6_0_2c.brocade_port_profile', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.port_profile.security_profile.ip.access_group', 'pybind.nos.v7_0_1b.brocade_port_profile', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.port_profile.security_profile.ip.access_group', 'pybind.nos.v7_1_0.brocade_port_profile', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.port_profile.security_profile.ip.access_group', 'pybind.slxos.v16r_1_00b.brocade_port_profile', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'in'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def port_profile_security_profile_ip_access_group_ipv4_access_group_name_delete(self, port_profile=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.port_profile', 'port_profile'), ('pybind.nos.v7_0_1b.port_profile', 'port_profile'), ('pybind.nos.v7_1_0.port_profile', 'port_profile'), ('pybind.nos.v6_0_2c.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2c.port_profile.security_profile.ip.access_group', 'pybind.nos.v6_0_2c.brocade_port_profile', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.port_profile.security_profile.ip.access_group', 'pybind.nos.v7_0_1b.brocade_port_profile', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.port_profile.security_profile.ip.access_group', 'pybind.nos.v7_1_0.brocade_port_profile', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.port_profile.security_profile.ip.access_group', 'pybind.slxos.v16r_1_00b.brocade_port_profile', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ipv4-access-group-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def port_profile_security_profile_ipv6_access_group_in_delete(self, port_profile=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.port_profile', 'port_profile'), ('pybind.nos.v7_0_1b.port_profile', 'port_profile'), ('pybind.nos.v6_0_2c.port_profile', 'port_profile'), ('pybind.slxos.v16r_1_00b.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2c.port_profile.security_profile.ipv6.access_group', 'pybind.nos.v6_0_2c.brocade_port_profile', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.port_profile.security_profile.ipv6.access_group', 'pybind.nos.v7_0_1b.brocade_port_profile', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.port_profile.security_profile.ipv6.access_group', 'pybind.nos.v7_1_0.brocade_port_profile', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.port_profile.security_profile.ipv6.access_group', 'pybind.slxos.v16r_1_00b.brocade_port_profile', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'in'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def port_profile_security_profile_ipv6_access_group_ipv6_access_group_name_delete(self, port_profile=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.port_profile', 'port_profile'), ('pybind.nos.v7_0_1b.port_profile', 'port_profile'), ('pybind.nos.v6_0_2c.port_profile', 'port_profile'), ('pybind.slxos.v16r_1_00b.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2c.port_profile.security_profile.ipv6.access_group', 'pybind.nos.v6_0_2c.brocade_port_profile', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.port_profile.security_profile.ipv6.access_group', 'pybind.nos.v7_0_1b.brocade_port_profile', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.port_profile.security_profile.ipv6.access_group', 'pybind.nos.v7_1_0.brocade_port_profile', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.port_profile.security_profile.ipv6.access_group', 'pybind.slxos.v16r_1_00b.brocade_port_profile', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ipv6-access-group-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def port_profile_security_profile_mac_access_group_access_group_name_delete(self, port_profile=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.port_profile', 'port_profile'), ('pybind.nos.v7_1_0.port_profile', 'port_profile'), ('pybind.nos.v7_0_1b.port_profile', 'port_profile'), ('pybind.slxos.v16r_1_00b.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2c.port_profile.security_profile.mac.access_group', 'pybind.nos.v6_0_2c.brocade_port_profile', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.port_profile.security_profile.mac.access_group', 'pybind.nos.v7_0_1b.brocade_port_profile', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.port_profile.security_profile.mac.access_group', 'pybind.nos.v7_1_0.brocade_port_profile', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.port_profile.security_profile.mac.access_group', 'pybind.slxos.v16r_1_00b.brocade_port_profile', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'access-group-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def port_profile_security_profile_mac_access_group_in_delete(self, port_profile=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.port_profile', 'port_profile'), ('pybind.nos.v7_1_0.port_profile', 'port_profile'), ('pybind.nos.v7_0_1b.port_profile', 'port_profile'), ('pybind.slxos.v16r_1_00b.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2c.port_profile.security_profile.mac.access_group', 'pybind.nos.v6_0_2c.brocade_port_profile', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.port_profile.security_profile.mac.access_group', 'pybind.nos.v7_0_1b.brocade_port_profile', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.port_profile.security_profile.mac.access_group', 'pybind.nos.v7_1_0.brocade_port_profile', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.port_profile.security_profile.mac.access_group', 'pybind.slxos.v16r_1_00b.brocade_port_profile', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'in'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def port_profile_static_delete(self, port_profile=None, static=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    **Instance Keyword Argument Tuple**:

    :type static: mac_address
    :param static: Keyword argument tuple.

    :type mac_address: unicode
    :param mac_address: **static** tuple argument:  mac address in HHHH.HHHH.HHHH format

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.port_profile_global.port_profile', u'port_profile'), ('pybind.nos.v7_1_0.port_profile_global.port_profile', u'port_profile'), ('pybind.nos.v7_0_1b.port_profile_global.port_profile', u'port_profile'), ('pybind.slxos.v16r_1_00b.port_profile_global.port_profile', u'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2c.port_profile_global.port_profile.static', 'pybind.nos.v6_0_2c.brocade_port_profile', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.port_profile_global.port_profile.static', 'pybind.nos.v7_0_1b.brocade_port_profile', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.port_profile_global.port_profile.static', 'pybind.nos.v7_1_0.brocade_port_profile', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.port_profile_global.port_profile.static', 'pybind.slxos.v16r_1_00b.brocade_port_profile', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'static', 'keyval': 'mac_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile, static=static)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile, static=static)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def port_profile_vlan_profile_delete(self, port_profile=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.port_profile', 'port_profile'), ('pybind.slxos.v16r_1_00b.port_profile', 'port_profile'), ('pybind.nos.v6_0_2c.port_profile', 'port_profile'), ('pybind.nos.v7_1_0.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2c.port_profile.vlan_profile', 'pybind.nos.v6_0_2c.brocade_port_profile', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.port_profile.vlan_profile', 'pybind.nos.v7_0_1b.brocade_port_profile', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.port_profile.vlan_profile', 'pybind.nos.v7_1_0.brocade_port_profile', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.port_profile.vlan_profile', 'pybind.slxos.v16r_1_00b.brocade_port_profile', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def port_profile_vlan_profile_switchport_delete(self, port_profile=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.port_profile', 'port_profile'), ('pybind.nos.v7_1_0.port_profile', 'port_profile'), ('pybind.nos.v7_0_1b.port_profile', 'port_profile'), ('pybind.slxos.v16r_1_00b.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2c.port_profile.vlan_profile.switchport_basic', 'pybind.nos.v6_0_2c.brocade_port_profile', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.port_profile.vlan_profile.switchport_basic', 'pybind.nos.v7_0_1b.brocade_port_profile', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.port_profile.vlan_profile.switchport_basic', 'pybind.nos.v7_1_0.brocade_port_profile', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.port_profile.vlan_profile.switchport_basic', 'pybind.slxos.v16r_1_00b.brocade_port_profile', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'switchport'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def port_profile_vlan_profile_switchport_access_mac_group_vlan_classification_delete(self, port_profile=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.port_profile', 'port_profile'), ('pybind.nos.v7_1_0.port_profile', 'port_profile'), ('pybind.slxos.v16r_1_00b.port_profile', 'port_profile'), ('pybind.nos.v7_0_1b.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2c.port_profile.vlan_profile.switchport.access_mac_group_vlan_classification', 'pybind.nos.v6_0_2c.brocade_port_profile', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.port_profile.vlan_profile.switchport.access_mac_group_vlan_classification', 'pybind.nos.v7_0_1b.brocade_port_profile', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.port_profile.vlan_profile.switchport.access_mac_group_vlan_classification', 'pybind.nos.v7_1_0.brocade_port_profile', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.port_profile.vlan_profile.switchport.access_mac_group_vlan_classification', 'pybind.slxos.v16r_1_00b.brocade_port_profile', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def port_profile_vlan_profile_switchport_access_mac_vlan_classification_delete(self, port_profile=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.port_profile', 'port_profile'), ('pybind.slxos.v16r_1_00b.port_profile', 'port_profile'), ('pybind.nos.v6_0_2c.port_profile', 'port_profile'), ('pybind.nos.v7_0_1b.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2c.port_profile.vlan_profile.switchport.access_mac_vlan_classification', 'pybind.nos.v6_0_2c.brocade_port_profile', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.port_profile.vlan_profile.switchport.access_mac_vlan_classification', 'pybind.nos.v7_0_1b.brocade_port_profile', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.port_profile.vlan_profile.switchport.access_mac_vlan_classification', 'pybind.nos.v7_1_0.brocade_port_profile', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.port_profile.vlan_profile.switchport.access_mac_vlan_classification', 'pybind.slxos.v16r_1_00b.brocade_port_profile', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def port_profile_vlan_profile_switchport_access_vlan_delete(self, port_profile=None, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    **Instance Keyword Argument Tuple**:

    :type vlan: access_vlan_id, access_mac_group
    :param vlan: Keyword argument tuple.

    :type access_vlan_id: long
    :param access_vlan_id: **vlan** tuple argument:  Set the default VLAN for the interface

        * range restriction: ::

            ['0..4294967295']

    :type access_mac_group: long
    :param access_mac_group: **vlan** tuple argument:  Associate a Mac group with a vlan

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.port_profile', 'port_profile'), ('pybind.nos.v7_1_0.port_profile', 'port_profile'), ('pybind.nos.v6_0_2c.port_profile', 'port_profile'), ('pybind.slxos.v16r_1_00b.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2c.port_profile.vlan_profile.switchport.access_mac_group_vlan_classification.access.vlan', 'pybind.nos.v6_0_2c.brocade_port_profile', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.port_profile.vlan_profile.switchport.access_mac_group_vlan_classification.access.vlan', 'pybind.nos.v7_0_1b.brocade_port_profile', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.port_profile.vlan_profile.switchport.access_mac_group_vlan_classification.access.vlan', 'pybind.nos.v7_1_0.brocade_port_profile', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.port_profile.vlan_profile.switchport.access_mac_group_vlan_classification.access.vlan', 'pybind.slxos.v16r_1_00b.brocade_port_profile', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'access_vlan_id, access_mac_group', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def port_profile_vlan_profile_switchport_access_vlan_access_mac_vlan_classification_delete(self, port_profile=None, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    **Instance Keyword Argument Tuple**:

    :type vlan: access_vlan_id, access_mac_address
    :param vlan: Keyword argument tuple.

    :type access_vlan_id: long
    :param access_vlan_id: **vlan** tuple argument:  Set the default VLAN for the interface

        * range restriction: ::

            ['0..4294967295']

    :type access_mac_address: unicode
    :param access_mac_address: **vlan** tuple argument:  Associate the Mac address with a vlan

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.port_profile', 'port_profile'), ('pybind.nos.v6_0_2c.port_profile', 'port_profile'), ('pybind.nos.v7_0_1b.port_profile', 'port_profile'), ('pybind.slxos.v16r_1_00b.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2c.port_profile.vlan_profile.switchport.access_mac_vlan_classification.access.vlan', 'pybind.nos.v6_0_2c.brocade_port_profile', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.port_profile.vlan_profile.switchport.access_mac_vlan_classification.access.vlan', 'pybind.nos.v7_0_1b.brocade_port_profile', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.port_profile.vlan_profile.switchport.access_mac_vlan_classification.access.vlan', 'pybind.nos.v7_1_0.brocade_port_profile', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.port_profile.vlan_profile.switchport.access_mac_vlan_classification.access.vlan', 'pybind.slxos.v16r_1_00b.brocade_port_profile', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'access_vlan_id, access_mac_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def port_profile_vlan_profile_switchport_access_vlan_name_delete(self, port_profile=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.port_profile', 'port_profile'), ('pybind.slxos.v16r_1_00b.port_profile', 'port_profile'), ('pybind.nos.v6_0_2c.port_profile', 'port_profile'), ('pybind.nos.v7_0_1b.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2c.port_profile.vlan_profile.switchport.access.vlan', 'pybind.nos.v6_0_2c.brocade_port_profile', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.port_profile.vlan_profile.switchport.access.vlan', 'pybind.nos.v7_0_1b.brocade_port_profile', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.port_profile.vlan_profile.switchport.access.vlan', 'pybind.nos.v7_1_0.brocade_port_profile', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.port_profile.vlan_profile.switchport.access.vlan', 'pybind.slxos.v16r_1_00b.brocade_port_profile', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def port_profile_vlan_profile_switchport_basic_delete(self, port_profile=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.port_profile', 'port_profile'), ('pybind.nos.v7_1_0.port_profile', 'port_profile'), ('pybind.nos.v7_0_1b.port_profile', 'port_profile'), ('pybind.slxos.v16r_1_00b.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2c.port_profile.vlan_profile.switchport_basic', 'pybind.nos.v6_0_2c.brocade_port_profile', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.port_profile.vlan_profile.switchport_basic', 'pybind.nos.v7_0_1b.brocade_port_profile', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.port_profile.vlan_profile.switchport_basic', 'pybind.nos.v7_1_0.brocade_port_profile', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.port_profile.vlan_profile.switchport_basic', 'pybind.slxos.v16r_1_00b.brocade_port_profile', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def port_profile_vlan_profile_switchport_mode_delete(self, port_profile=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.port_profile', 'port_profile'), ('pybind.nos.v7_1_0.port_profile', 'port_profile'), ('pybind.nos.v6_0_2c.port_profile', 'port_profile'), ('pybind.slxos.v16r_1_00b.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2c.port_profile.vlan_profile.switchport.mode', 'pybind.nos.v6_0_2c.brocade_port_profile', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.port_profile.vlan_profile.switchport.mode', 'pybind.nos.v7_0_1b.brocade_port_profile', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.port_profile.vlan_profile.switchport.mode', 'pybind.nos.v7_1_0.brocade_port_profile', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.port_profile.vlan_profile.switchport.mode', 'pybind.slxos.v16r_1_00b.brocade_port_profile', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def port_profile_vlan_profile_switchport_mode_vlan_mode_delete(self, port_profile=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.port_profile', 'port_profile'), ('pybind.nos.v7_1_0.port_profile', 'port_profile'), ('pybind.nos.v6_0_2c.port_profile', 'port_profile'), ('pybind.slxos.v16r_1_00b.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2c.port_profile.vlan_profile.switchport.mode', 'pybind.nos.v6_0_2c.brocade_port_profile', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.port_profile.vlan_profile.switchport.mode', 'pybind.nos.v7_0_1b.brocade_port_profile', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.port_profile.vlan_profile.switchport.mode', 'pybind.nos.v7_1_0.brocade_port_profile', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.port_profile.vlan_profile.switchport.mode', 'pybind.slxos.v16r_1_00b.brocade_port_profile', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vlan-mode'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def port_profile_vlan_profile_switchport_trunk_allowed_delete(self, port_profile=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.port_profile', 'port_profile'), ('pybind.nos.v7_0_1b.port_profile', 'port_profile'), ('pybind.nos.v7_1_0.port_profile', 'port_profile'), ('pybind.nos.v6_0_2c.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2c.port_profile.vlan_profile.switchport.trunk.allowed', 'pybind.nos.v6_0_2c.brocade_port_profile', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.port_profile.vlan_profile.switchport.trunk.allowed', 'pybind.nos.v7_0_1b.brocade_port_profile', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.port_profile.vlan_profile.switchport.trunk.allowed', 'pybind.nos.v7_1_0.brocade_port_profile', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.port_profile.vlan_profile.switchport.trunk.allowed', 'pybind.slxos.v16r_1_00b.brocade_port_profile', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def port_profile_vlan_profile_switchport_trunk_allowed_trunk_vlan_classification_delete(self, port_profile=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.port_profile', 'port_profile'), ('pybind.slxos.v16r_1_00b.port_profile', 'port_profile'), ('pybind.nos.v6_0_2c.port_profile', 'port_profile'), ('pybind.nos.v7_0_1b.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2c.port_profile.vlan_profile.switchport.trunk.trunk_vlan_classification.allowed', 'pybind.nos.v6_0_2c.brocade_port_profile', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.port_profile.vlan_profile.switchport.trunk.trunk_vlan_classification.allowed', 'pybind.nos.v7_0_1b.brocade_port_profile', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.port_profile.vlan_profile.switchport.trunk.trunk_vlan_classification.allowed', 'pybind.nos.v7_1_0.brocade_port_profile', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.port_profile.vlan_profile.switchport.trunk.trunk_vlan_classification.allowed', 'pybind.slxos.v16r_1_00b.brocade_port_profile', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def port_profile_vlan_profile_switchport_trunk_allowed_vlan_delete(self, port_profile=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.port_profile', 'port_profile'), ('pybind.nos.v7_1_0.port_profile', 'port_profile'), ('pybind.nos.v7_0_1b.port_profile', 'port_profile'), ('pybind.nos.v6_0_2c.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2c.port_profile.vlan_profile.switchport.trunk.allowed.vlan', 'pybind.nos.v6_0_2c.brocade_port_profile', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.port_profile.vlan_profile.switchport.trunk.allowed.vlan', 'pybind.nos.v7_0_1b.brocade_port_profile', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.port_profile.vlan_profile.switchport.trunk.allowed.vlan', 'pybind.nos.v7_1_0.brocade_port_profile', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.port_profile.vlan_profile.switchport.trunk.allowed.vlan', 'pybind.slxos.v16r_1_00b.brocade_port_profile', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def port_profile_vlan_profile_switchport_trunk_allowed_vlan_add_delete(self, port_profile=None, add=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    **Instance Keyword Argument Tuple**:

    :type add: trunk_vlan_id, trunk_ctag_id
    :param add: Keyword argument tuple.

    :type trunk_vlan_id: long
    :param trunk_vlan_id: **add** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type trunk_ctag_id: long
    :param trunk_ctag_id: **add** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.port_profile', 'port_profile'), ('pybind.nos.v6_0_2c.port_profile', 'port_profile'), ('pybind.nos.v7_1_0.port_profile', 'port_profile'), ('pybind.slxos.v16r_1_00b.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2c.port_profile.vlan_profile.switchport.trunk.trunk_vlan_classification.allowed.vlan.add_', 'pybind.nos.v6_0_2c.brocade_port_profile', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.port_profile.vlan_profile.switchport.trunk.trunk_vlan_classification.allowed.vlan.add_', 'pybind.nos.v7_0_1b.brocade_port_profile', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.port_profile.vlan_profile.switchport.trunk.trunk_vlan_classification.allowed.vlan.add_', 'pybind.nos.v7_1_0.brocade_port_profile', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.port_profile.vlan_profile.switchport.trunk.trunk_vlan_classification.allowed.vlan.add_', 'pybind.slxos.v16r_1_00b.brocade_port_profile', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'add', 'keyval': 'trunk_vlan_id, trunk_ctag_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile, add=add)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile, add=add)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def port_profile_vlan_profile_switchport_trunk_allowed_vlan_all_delete(self, port_profile=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.port_profile', 'port_profile'), ('pybind.nos.v7_1_0.port_profile', 'port_profile'), ('pybind.nos.v7_0_1b.port_profile', 'port_profile'), ('pybind.nos.v6_0_2c.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2c.port_profile.vlan_profile.switchport.trunk.allowed.vlan', 'pybind.nos.v6_0_2c.brocade_port_profile', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.port_profile.vlan_profile.switchport.trunk.allowed.vlan', 'pybind.nos.v7_0_1b.brocade_port_profile', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.port_profile.vlan_profile.switchport.trunk.allowed.vlan', 'pybind.nos.v7_1_0.brocade_port_profile', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.port_profile.vlan_profile.switchport.trunk.allowed.vlan', 'pybind.slxos.v16r_1_00b.brocade_port_profile', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'all'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def port_profile_vlan_profile_switchport_trunk_allowed_vlan_except_delete(self, port_profile=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.port_profile', 'port_profile'), ('pybind.nos.v7_1_0.port_profile', 'port_profile'), ('pybind.nos.v7_0_1b.port_profile', 'port_profile'), ('pybind.nos.v6_0_2c.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2c.port_profile.vlan_profile.switchport.trunk.allowed.vlan', 'pybind.nos.v6_0_2c.brocade_port_profile', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.port_profile.vlan_profile.switchport.trunk.allowed.vlan', 'pybind.nos.v7_0_1b.brocade_port_profile', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.port_profile.vlan_profile.switchport.trunk.allowed.vlan', 'pybind.nos.v7_1_0.brocade_port_profile', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.port_profile.vlan_profile.switchport.trunk.allowed.vlan', 'pybind.slxos.v16r_1_00b.brocade_port_profile', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'except'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def port_profile_vlan_profile_switchport_trunk_allowed_vlan_none_delete(self, port_profile=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.port_profile', 'port_profile'), ('pybind.nos.v7_1_0.port_profile', 'port_profile'), ('pybind.nos.v7_0_1b.port_profile', 'port_profile'), ('pybind.nos.v6_0_2c.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2c.port_profile.vlan_profile.switchport.trunk.allowed.vlan', 'pybind.nos.v6_0_2c.brocade_port_profile', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.port_profile.vlan_profile.switchport.trunk.allowed.vlan', 'pybind.nos.v7_0_1b.brocade_port_profile', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.port_profile.vlan_profile.switchport.trunk.allowed.vlan', 'pybind.nos.v7_1_0.brocade_port_profile', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.port_profile.vlan_profile.switchport.trunk.allowed.vlan', 'pybind.slxos.v16r_1_00b.brocade_port_profile', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'none'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def port_profile_vlan_profile_switchport_trunk_allowed_vlan_remove_delete(self, port_profile=None, remove=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    **Instance Keyword Argument Tuple**:

    :type remove: trunk_vlan_id, trunk_ctag_id
    :param remove: Keyword argument tuple.

    :type trunk_vlan_id: long
    :param trunk_vlan_id: **remove** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type trunk_ctag_id: long
    :param trunk_ctag_id: **remove** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.port_profile', 'port_profile'), ('pybind.nos.v6_0_2c.port_profile', 'port_profile'), ('pybind.nos.v7_0_1b.port_profile', 'port_profile'), ('pybind.slxos.v16r_1_00b.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2c.port_profile.vlan_profile.switchport.trunk.trunk_vlan_classification.allowed.vlan.remove_', 'pybind.nos.v6_0_2c.brocade_port_profile', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.port_profile.vlan_profile.switchport.trunk.trunk_vlan_classification.allowed.vlan.remove_', 'pybind.nos.v7_0_1b.brocade_port_profile', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.port_profile.vlan_profile.switchport.trunk.trunk_vlan_classification.allowed.vlan.remove_', 'pybind.nos.v7_1_0.brocade_port_profile', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.port_profile.vlan_profile.switchport.trunk.trunk_vlan_classification.allowed.vlan.remove_', 'pybind.slxos.v16r_1_00b.brocade_port_profile', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'remove', 'keyval': 'trunk_vlan_id, trunk_ctag_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile, remove=remove)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile, remove=remove)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def port_profile_vlan_profile_switchport_trunk_allowed_vlan_trunk_vlan_classification_delete(self, port_profile=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.port_profile', 'port_profile'), ('pybind.nos.v6_0_2c.port_profile', 'port_profile'), ('pybind.nos.v7_0_1b.port_profile', 'port_profile'), ('pybind.nos.v7_1_0.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2c.port_profile.vlan_profile.switchport.trunk.trunk_vlan_classification.allowed.vlan', 'pybind.nos.v6_0_2c.brocade_port_profile', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.port_profile.vlan_profile.switchport.trunk.trunk_vlan_classification.allowed.vlan', 'pybind.nos.v7_0_1b.brocade_port_profile', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.port_profile.vlan_profile.switchport.trunk.trunk_vlan_classification.allowed.vlan', 'pybind.nos.v7_1_0.brocade_port_profile', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.port_profile.vlan_profile.switchport.trunk.trunk_vlan_classification.allowed.vlan', 'pybind.slxos.v16r_1_00b.brocade_port_profile', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def port_profile_vlan_profile_switchport_trunk_ctag_delete(self, port_profile=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.port_profile', 'port_profile'), ('pybind.nos.v7_1_0.port_profile', 'port_profile'), ('pybind.nos.v7_0_1b.port_profile', 'port_profile'), ('pybind.slxos.v16r_1_00b.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2c.port_profile.vlan_profile.switchport.trunk.native_vlan_classification', 'pybind.nos.v6_0_2c.brocade_port_profile', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.port_profile.vlan_profile.switchport.trunk.native_vlan_classification', 'pybind.nos.v7_0_1b.brocade_port_profile', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.port_profile.vlan_profile.switchport.trunk.native_vlan_classification', 'pybind.nos.v7_1_0.brocade_port_profile', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.port_profile.vlan_profile.switchport.trunk.native_vlan_classification', 'pybind.slxos.v16r_1_00b.brocade_port_profile', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ctag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def port_profile_vlan_profile_switchport_trunk_native_vlan_delete(self, port_profile=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.port_profile', 'port_profile'), ('pybind.nos.v6_0_2c.port_profile', 'port_profile'), ('pybind.slxos.v16r_1_00b.port_profile', 'port_profile'), ('pybind.nos.v7_1_0.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2c.port_profile.vlan_profile.switchport.trunk', 'pybind.nos.v6_0_2c.brocade_port_profile', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.port_profile.vlan_profile.switchport.trunk', 'pybind.nos.v7_0_1b.brocade_port_profile', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.port_profile.vlan_profile.switchport.trunk', 'pybind.nos.v7_1_0.brocade_port_profile', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.port_profile.vlan_profile.switchport.trunk', 'pybind.slxos.v16r_1_00b.brocade_port_profile', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'native-vlan'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def port_profile_vlan_profile_switchport_trunk_native_vlan_classification_delete(self, port_profile=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.port_profile', 'port_profile'), ('pybind.nos.v7_1_0.port_profile', 'port_profile'), ('pybind.nos.v7_0_1b.port_profile', 'port_profile'), ('pybind.slxos.v16r_1_00b.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2c.port_profile.vlan_profile.switchport.trunk.native_vlan_classification', 'pybind.nos.v6_0_2c.brocade_port_profile', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.port_profile.vlan_profile.switchport.trunk.native_vlan_classification', 'pybind.nos.v7_0_1b.brocade_port_profile', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.port_profile.vlan_profile.switchport.trunk.native_vlan_classification', 'pybind.nos.v7_1_0.brocade_port_profile', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.port_profile.vlan_profile.switchport.trunk.native_vlan_classification', 'pybind.slxos.v16r_1_00b.brocade_port_profile', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'native_vlan_id, native_vlan_ctag_id'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def port_profile_vlan_profile_switchport_trunk_native_vlan_native_vlan_classification_delete(self, port_profile=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.port_profile', 'port_profile'), ('pybind.nos.v7_1_0.port_profile', 'port_profile'), ('pybind.nos.v7_0_1b.port_profile', 'port_profile'), ('pybind.slxos.v16r_1_00b.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2c.port_profile.vlan_profile.switchport.trunk.native_vlan_classification', 'pybind.nos.v6_0_2c.brocade_port_profile', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.port_profile.vlan_profile.switchport.trunk.native_vlan_classification', 'pybind.nos.v7_0_1b.brocade_port_profile', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.port_profile.vlan_profile.switchport.trunk.native_vlan_classification', 'pybind.nos.v7_1_0.brocade_port_profile', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.port_profile.vlan_profile.switchport.trunk.native_vlan_classification', 'pybind.slxos.v16r_1_00b.brocade_port_profile', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'native-vlan'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def port_profile_vlan_profile_switchport_trunk_trunk_vlan_classification_delete(self, port_profile=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.port_profile', 'port_profile'), ('pybind.nos.v7_1_0.port_profile', 'port_profile'), ('pybind.nos.v7_0_1b.port_profile', 'port_profile'), ('pybind.slxos.v16r_1_00b.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2c.port_profile.vlan_profile.switchport.trunk.trunk_vlan_classification', 'pybind.nos.v6_0_2c.brocade_port_profile', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.port_profile.vlan_profile.switchport.trunk.trunk_vlan_classification', 'pybind.nos.v7_0_1b.brocade_port_profile', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.port_profile.vlan_profile.switchport.trunk.trunk_vlan_classification', 'pybind.nos.v7_1_0.brocade_port_profile', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.port_profile.vlan_profile.switchport.trunk.trunk_vlan_classification', 'pybind.slxos.v16r_1_00b.brocade_port_profile', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def preprovision_rbridge_id_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type rbridge_id: rbridge_id, wwn
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type wwn: unicode
    :param wwn: **rbridge_id** tuple argument:  World Wide Name (WWN)

        * pattern restriction: ::

            '[0-9a-fA-F][0-9a-fA-F]:[0-9a-fA-F][0-9a-fA-F]:[0'
            '-9a-fA-F][0-9a-fA-F]:[0-9a-fA-F][0-9a-fA-F]:[0-9'
            'a-fA-F][0-9a-fA-F]:[0-9a-fA-F][0-9a-fA-F]:[0-9a-'
            'fA-F][0-9a-fA-F]:[0-9a-fA-F][0-9a-fA-F]'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.preprovision.rbridge_id', 'pybind.nos.v6_0_2c.brocade_preprovision', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.preprovision.rbridge_id', 'pybind.nos.v7_0_1b.brocade_preprovision', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.preprovision.rbridge_id', 'pybind.nos.v7_1_0.brocade_preprovision', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.preprovision.rbridge_id', 'pybind.slxos.v16r_1_00b.brocade_preprovision', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'rbridge_id', 'keyval': 'rbridge_id, wwn', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_cfm_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.protocol.cfm', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_cfm_domain_name_delete(self, domain_name=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type domain_name: domain_name
    :param domain_name: Keyword argument tuple.

    :type domain_name: unicode
    :param domain_name: **domain_name** tuple argument:  String length 21 char

        * length restriction: ::

            ['1..21']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.protocol.cfm.domain_name', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'domain_name', 'keyval': 'domain_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain_name=domain_name)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain_name=domain_name)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_cfm_domain_name_level_delete(self, domain_name=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type domain_name: domain_name
    :param domain_name: Keyword argument tuple.

    :type domain_name: unicode
    :param domain_name: **domain_name** tuple argument:  String length 21 char

        * length restriction: ::

            ['1..21']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.protocol.cfm.domain_name', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'domain_name', 'keyval': 'domain_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'level'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain_name=domain_name)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain_name=domain_name)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_cfm_domain_name_ma_name_delete(self, domain_name=None, ma_name=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain_name: domain_name
    :param domain_name: Keyword argument tuple.

    :type domain_name: unicode
    :param domain_name: **domain_name** tuple argument:  String length 21 char

        * length restriction: ::

            ['1..21']

    **Instance Keyword Argument Tuple**:

    :type ma_name: ma_name
    :param ma_name: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma_name** tuple argument:  String length 21 char

        * length restriction: ::

            ['1..21']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.protocol.cfm.domain_name', u'domain_name')]
    bindings_list = [('pybind.slxos.v16r_1_00b.protocol.cfm.domain_name.ma_name', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'domain_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ma_name', 'keyval': 'ma_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v16r_1_00b.protocol.cfm.domain_name.ma_name': [u'ma_vlan_vid', u'ma_bd_vid']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain_name=domain_name, ma_name=ma_name)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain_name=domain_name, ma_name=ma_name)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_cfm_domain_name_ma_name_bridge_domain_delete(self, domain_name=None, ma_name=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain_name: domain_name
    :param domain_name: Keyword argument tuple.

    :type domain_name: unicode
    :param domain_name: **domain_name** tuple argument:  String length 21 char

        * length restriction: ::

            ['1..21']

    **Instance Keyword Argument Tuple**:

    :type ma_name: ma_name
    :param ma_name: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma_name** tuple argument:  String length 21 char

        * length restriction: ::

            ['1..21']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.protocol.cfm.domain_name', u'domain_name')]
    bindings_list = [('pybind.slxos.v16r_1_00b.protocol.cfm.domain_name.ma_name', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'domain_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ma_name', 'keyval': 'ma_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bridge-domain'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain_name=domain_name, ma_name=ma_name)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain_name=domain_name, ma_name=ma_name)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_cfm_domain_name_ma_name_ccm_interval_delete(self, domain_name=None, ma_name=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain_name: domain_name
    :param domain_name: Keyword argument tuple.

    :type domain_name: unicode
    :param domain_name: **domain_name** tuple argument:  String length 21 char

        * length restriction: ::

            ['1..21']

    :type ma_name: ma_name
    :param ma_name: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma_name** tuple argument:  String length 21 char

        * length restriction: ::

            ['1..21']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.protocol.cfm.domain_name', u'domain_name'), ('pybind.slxos.v16r_1_00b.protocol.cfm.domain_name.ma_name', u'ma_name')]
    bindings_list = [('pybind.slxos.v16r_1_00b.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'domain_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ccm-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain_name=domain_name, ma_name=ma_name)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain_name=domain_name, ma_name=ma_name)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_cfm_domain_name_ma_name_id_delete(self, domain_name=None, ma_name=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain_name: domain_name
    :param domain_name: Keyword argument tuple.

    :type domain_name: unicode
    :param domain_name: **domain_name** tuple argument:  String length 21 char

        * length restriction: ::

            ['1..21']

    **Instance Keyword Argument Tuple**:

    :type ma_name: ma_name
    :param ma_name: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma_name** tuple argument:  String length 21 char

        * length restriction: ::

            ['1..21']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.protocol.cfm.domain_name', u'domain_name')]
    bindings_list = [('pybind.slxos.v16r_1_00b.protocol.cfm.domain_name.ma_name', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'domain_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ma_name', 'keyval': 'ma_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain_name=domain_name, ma_name=ma_name)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain_name=domain_name, ma_name=ma_name)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_cfm_domain_name_ma_name_mep_delete(self, domain_name=None, ma_name=None, mep=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain_name: domain_name
    :param domain_name: Keyword argument tuple.

    :type domain_name: unicode
    :param domain_name: **domain_name** tuple argument:  String length 21 char

        * length restriction: ::

            ['1..21']

    :type ma_name: ma_name
    :param ma_name: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma_name** tuple argument:  String length 21 char

        * length restriction: ::

            ['1..21']

    **Instance Keyword Argument Tuple**:

    :type mep: mep_id
    :param mep: Keyword argument tuple.

    :type mep_id: long
    :param mep_id: **mep** tuple argument:  DECIMAL :: <1-8191>

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.protocol.cfm.domain_name', u'domain_name'), ('pybind.slxos.v16r_1_00b.protocol.cfm.domain_name.ma_name', u'ma_name')]
    bindings_list = [('pybind.slxos.v16r_1_00b.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands.mep', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'domain_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mep', 'keyval': 'mep_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain_name=domain_name, ma_name=ma_name, mep=mep)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain_name=domain_name, ma_name=ma_name, mep=mep)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_cfm_domain_name_ma_name_mep_mep_down_up_delete(self, domain_name=None, ma_name=None, mep=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain_name: domain_name
    :param domain_name: Keyword argument tuple.

    :type domain_name: unicode
    :param domain_name: **domain_name** tuple argument:  String length 21 char

        * length restriction: ::

            ['1..21']

    :type ma_name: ma_name
    :param ma_name: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma_name** tuple argument:  String length 21 char

        * length restriction: ::

            ['1..21']

    **Instance Keyword Argument Tuple**:

    :type mep: mep_id
    :param mep: Keyword argument tuple.

    :type mep_id: long
    :param mep_id: **mep** tuple argument:  DECIMAL :: <1-8191>

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.protocol.cfm.domain_name', u'domain_name'), ('pybind.slxos.v16r_1_00b.protocol.cfm.domain_name.ma_name', u'ma_name')]
    bindings_list = [('pybind.slxos.v16r_1_00b.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands.mep', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'domain_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mep', 'keyval': 'mep_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mep-down-up'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain_name=domain_name, ma_name=ma_name, mep=mep)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain_name=domain_name, ma_name=ma_name, mep=mep)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_cfm_domain_name_ma_name_mep_mep_intf_name_delete(self, domain_name=None, ma_name=None, mep=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain_name: domain_name
    :param domain_name: Keyword argument tuple.

    :type domain_name: unicode
    :param domain_name: **domain_name** tuple argument:  String length 21 char

        * length restriction: ::

            ['1..21']

    :type ma_name: ma_name
    :param ma_name: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma_name** tuple argument:  String length 21 char

        * length restriction: ::

            ['1..21']

    **Instance Keyword Argument Tuple**:

    :type mep: mep_id
    :param mep: Keyword argument tuple.

    :type mep_id: long
    :param mep_id: **mep** tuple argument:  DECIMAL :: <1-8191>

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.protocol.cfm.domain_name', u'domain_name'), ('pybind.slxos.v16r_1_00b.protocol.cfm.domain_name.ma_name', u'ma_name')]
    bindings_list = [('pybind.slxos.v16r_1_00b.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands.mep', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'domain_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mep', 'keyval': 'mep_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mep-intf-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain_name=domain_name, ma_name=ma_name, mep=mep)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain_name=domain_name, ma_name=ma_name, mep=mep)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_cfm_domain_name_ma_name_mep_mep_intf_type_delete(self, domain_name=None, ma_name=None, mep=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain_name: domain_name
    :param domain_name: Keyword argument tuple.

    :type domain_name: unicode
    :param domain_name: **domain_name** tuple argument:  String length 21 char

        * length restriction: ::

            ['1..21']

    :type ma_name: ma_name
    :param ma_name: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma_name** tuple argument:  String length 21 char

        * length restriction: ::

            ['1..21']

    **Instance Keyword Argument Tuple**:

    :type mep: mep_id
    :param mep: Keyword argument tuple.

    :type mep_id: long
    :param mep_id: **mep** tuple argument:  DECIMAL :: <1-8191>

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.protocol.cfm.domain_name', u'domain_name'), ('pybind.slxos.v16r_1_00b.protocol.cfm.domain_name.ma_name', u'ma_name')]
    bindings_list = [('pybind.slxos.v16r_1_00b.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands.mep', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'domain_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mep', 'keyval': 'mep_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mep-intf-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain_name=domain_name, ma_name=ma_name, mep=mep)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain_name=domain_name, ma_name=ma_name, mep=mep)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_cfm_domain_name_ma_name_mep_remote_mep_delete(self, domain_name=None, ma_name=None, mep=None, remote_mep=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain_name: domain_name
    :param domain_name: Keyword argument tuple.

    :type domain_name: unicode
    :param domain_name: **domain_name** tuple argument:  String length 21 char

        * length restriction: ::

            ['1..21']

    :type ma_name: ma_name
    :param ma_name: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma_name** tuple argument:  String length 21 char

        * length restriction: ::

            ['1..21']

    :type mep: mep_id
    :param mep: Keyword argument tuple.

    :type mep_id: long
    :param mep_id: **mep** tuple argument:  DECIMAL :: <1-8191>

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type remote_mep: remote_mep
    :param remote_mep: Keyword argument tuple.

    :type remote_mep: long
    :param remote_mep: **remote_mep** tuple argument:  DECIMAL :: <1-8191>

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.protocol.cfm.domain_name', u'domain_name'), ('pybind.slxos.v16r_1_00b.protocol.cfm.domain_name.ma_name', u'ma_name'), ('pybind.slxos.v16r_1_00b.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands.mep', u'mep')]
    bindings_list = [('pybind.slxos.v16r_1_00b.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands.mep.cfm_mep_sub_commands.remote_mep', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'domain_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'mep_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'remote_mep', 'keyval': 'remote_mep', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain_name=domain_name, ma_name=ma_name, mep=mep, remote_mep=remote_mep)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain_name=domain_name, ma_name=ma_name, mep=mep, remote_mep=remote_mep)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_cfm_domain_name_ma_name_mep_tlv_type_delete(self, domain_name=None, ma_name=None, mep=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain_name: domain_name
    :param domain_name: Keyword argument tuple.

    :type domain_name: unicode
    :param domain_name: **domain_name** tuple argument:  String length 21 char

        * length restriction: ::

            ['1..21']

    :type ma_name: ma_name
    :param ma_name: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma_name** tuple argument:  String length 21 char

        * length restriction: ::

            ['1..21']

    :type mep: mep_id
    :param mep: Keyword argument tuple.

    :type mep_id: long
    :param mep_id: **mep** tuple argument:  DECIMAL :: <1-8191>

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.protocol.cfm.domain_name', u'domain_name'), ('pybind.slxos.v16r_1_00b.protocol.cfm.domain_name.ma_name', u'ma_name'), ('pybind.slxos.v16r_1_00b.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands.mep', u'mep')]
    bindings_list = [('pybind.slxos.v16r_1_00b.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands.mep.cfm_mep_sub_commands', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'domain_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'mep_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tlv-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain_name=domain_name, ma_name=ma_name, mep=mep)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain_name=domain_name, ma_name=ma_name, mep=mep)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_cfm_domain_name_ma_name_mep_vlan_delete(self, domain_name=None, ma_name=None, mep=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain_name: domain_name
    :param domain_name: Keyword argument tuple.

    :type domain_name: unicode
    :param domain_name: **domain_name** tuple argument:  String length 21 char

        * length restriction: ::

            ['1..21']

    :type ma_name: ma_name
    :param ma_name: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma_name** tuple argument:  String length 21 char

        * length restriction: ::

            ['1..21']

    **Instance Keyword Argument Tuple**:

    :type mep: mep_id
    :param mep: Keyword argument tuple.

    :type mep_id: long
    :param mep_id: **mep** tuple argument:  DECIMAL :: <1-8191>

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.protocol.cfm.domain_name', u'domain_name'), ('pybind.slxos.v16r_1_00b.protocol.cfm.domain_name.ma_name', u'ma_name')]
    bindings_list = [('pybind.slxos.v16r_1_00b.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands.mep', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'domain_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mep', 'keyval': 'mep_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vlan'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain_name=domain_name, ma_name=ma_name, mep=mep)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain_name=domain_name, ma_name=ma_name, mep=mep)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_cfm_domain_name_ma_name_mip_policy_delete(self, domain_name=None, ma_name=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain_name: domain_name
    :param domain_name: Keyword argument tuple.

    :type domain_name: unicode
    :param domain_name: **domain_name** tuple argument:  String length 21 char

        * length restriction: ::

            ['1..21']

    :type ma_name: ma_name
    :param ma_name: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma_name** tuple argument:  String length 21 char

        * length restriction: ::

            ['1..21']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.protocol.cfm.domain_name', u'domain_name'), ('pybind.slxos.v16r_1_00b.protocol.cfm.domain_name.ma_name', u'ma_name')]
    bindings_list = [('pybind.slxos.v16r_1_00b.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'domain_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mip-policy'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain_name=domain_name, ma_name=ma_name)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain_name=domain_name, ma_name=ma_name)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_cfm_domain_name_ma_name_priority_delete(self, domain_name=None, ma_name=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain_name: domain_name
    :param domain_name: Keyword argument tuple.

    :type domain_name: unicode
    :param domain_name: **domain_name** tuple argument:  String length 21 char

        * length restriction: ::

            ['1..21']

    **Instance Keyword Argument Tuple**:

    :type ma_name: ma_name
    :param ma_name: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma_name** tuple argument:  String length 21 char

        * length restriction: ::

            ['1..21']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.protocol.cfm.domain_name', u'domain_name')]
    bindings_list = [('pybind.slxos.v16r_1_00b.protocol.cfm.domain_name.ma_name', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'domain_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ma_name', 'keyval': 'ma_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain_name=domain_name, ma_name=ma_name)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain_name=domain_name, ma_name=ma_name)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_cfm_domain_name_ma_name_vlan_delete(self, domain_name=None, ma_name=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain_name: domain_name
    :param domain_name: Keyword argument tuple.

    :type domain_name: unicode
    :param domain_name: **domain_name** tuple argument:  String length 21 char

        * length restriction: ::

            ['1..21']

    **Instance Keyword Argument Tuple**:

    :type ma_name: ma_name
    :param ma_name: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma_name** tuple argument:  String length 21 char

        * length restriction: ::

            ['1..21']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.protocol.cfm.domain_name', u'domain_name')]
    bindings_list = [('pybind.slxos.v16r_1_00b.protocol.cfm.domain_name.ma_name', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'domain_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ma_name', 'keyval': 'ma_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vlan'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain_name=domain_name, ma_name=ma_name)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain_name=domain_name, ma_name=ma_name)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_edge_loop_detection_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.protocol.edge_loop_detection', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.edge_loop_detection', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.edge_loop_detection', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.edge_loop_detection', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_edge_loop_detection_hello_interval_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.protocol.edge_loop_detection', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.edge_loop_detection', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.edge_loop_detection', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.edge_loop_detection', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hello-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_edge_loop_detection_mac_refresh_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.protocol.edge_loop_detection.mac_refresh_time_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.edge_loop_detection.mac_refresh_time_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.edge_loop_detection.mac_refresh_time_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.edge_loop_detection.mac_refresh_time_config', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_edge_loop_detection_mac_refresh_mac_refresh_time_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.protocol.edge_loop_detection.mac_refresh_time_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.edge_loop_detection.mac_refresh_time_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.edge_loop_detection.mac_refresh_time_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.edge_loop_detection.mac_refresh_time_config', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mac-refresh-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_edge_loop_detection_mac_refresh_mac_refresh_type_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.protocol.edge_loop_detection.mac_refresh_time_config', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.edge_loop_detection.mac_refresh_time_config', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.edge_loop_detection.mac_refresh_time_config', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.edge_loop_detection.mac_refresh_time_config', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mac-refresh-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_edge_loop_detection_pdu_rx_limit_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.protocol.edge_loop_detection', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.edge_loop_detection', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.edge_loop_detection', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.edge_loop_detection', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'pdu-rx-limit'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_edge_loop_detection_shutdown_time_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.protocol.edge_loop_detection', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.edge_loop_detection', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.edge_loop_detection', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.edge_loop_detection', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'shutdown-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_lldp_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.protocol.lldp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.lldp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.lldp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.lldp', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_lldp_advertise_dcbx_fcoe_app_tlv_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.protocol.lldp.advertise', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.lldp.advertise', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.lldp.advertise', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.lldp.advertise', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dcbx-fcoe-app-tlv'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_lldp_advertise_dcbx_fcoe_logical_link_tlv_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.protocol.lldp.advertise', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.lldp.advertise', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.lldp.advertise', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.lldp.advertise', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dcbx-fcoe-logical-link-tlv'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_lldp_advertise_dcbx_iscsi_app_tlv_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.protocol.lldp.advertise', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.lldp.advertise', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.lldp.advertise', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.lldp.advertise', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dcbx-iscsi-app-tlv'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_lldp_advertise_dcbx_tlv_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.protocol.lldp.advertise', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.lldp.advertise', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.lldp.advertise', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.lldp.advertise', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dcbx-tlv'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_lldp_advertise_dot1_tlv_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.protocol.lldp.advertise', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.lldp.advertise', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.lldp.advertise', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.lldp.advertise', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dot1-tlv'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_lldp_advertise_dot3_tlv_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.protocol.lldp.advertise', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.lldp.advertise', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.lldp.advertise', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.lldp.advertise', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dot3-tlv'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_lldp_advertise_optional_tlv_management_address_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.protocol.lldp.advertise.optional_tlv', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.lldp.advertise.optional_tlv', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.lldp.advertise.optional_tlv', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.lldp.advertise.optional_tlv', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'management-address'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_lldp_advertise_optional_tlv_port_description_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.protocol.lldp.advertise.optional_tlv', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.lldp.advertise.optional_tlv', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.lldp.advertise.optional_tlv', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.lldp.advertise.optional_tlv', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'port-description'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_lldp_advertise_optional_tlv_system_capabilities_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.protocol.lldp.advertise.optional_tlv', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.lldp.advertise.optional_tlv', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.lldp.advertise.optional_tlv', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.lldp.advertise.optional_tlv', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'system-capabilities'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_lldp_advertise_optional_tlv_system_description_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.protocol.lldp.advertise.optional_tlv', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.lldp.advertise.optional_tlv', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.lldp.advertise.optional_tlv', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.lldp.advertise.optional_tlv', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'system-description'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_lldp_advertise_optional_tlv_system_name_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.protocol.lldp.advertise.optional_tlv', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.lldp.advertise.optional_tlv', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.lldp.advertise.optional_tlv', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.lldp.advertise.optional_tlv', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'system-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_lldp_description_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.protocol.lldp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.lldp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.lldp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.lldp', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'description'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_lldp_disable_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.protocol.lldp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.lldp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.lldp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.lldp', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'disable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_lldp_hello_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.protocol.lldp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.lldp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.lldp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.lldp', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hello'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_lldp_iscsi_priority_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.protocol.lldp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.lldp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.lldp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.lldp', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'iscsi-priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_lldp_mode_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.protocol.lldp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.lldp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.lldp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.lldp', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mode'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_lldp_multiplier_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.protocol.lldp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.lldp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.lldp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.lldp', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'multiplier'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_lldp_profile_delete(self, profile=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type profile: profile_name
    :param profile: Keyword argument tuple.

    :type profile_name: unicode
    :param profile_name: **profile** tuple argument.

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '(\S)+'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.protocol.lldp.profile', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.lldp.profile', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.lldp.profile', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.lldp.profile', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'profile', 'keyval': 'profile_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, profile=profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, profile=profile)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_lldp_profile_advertise_dcbx_fcoe_app_tlv_delete(self, profile=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type profile: profile_name
    :param profile: Keyword argument tuple.

    :type profile_name: unicode
    :param profile_name: **profile** tuple argument.

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '(\S)+'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.protocol.lldp.profile', u'profile'), ('pybind.slxos.v16r_1_00b.protocol.lldp.profile', u'profile'), ('pybind.nos.v6_0_2c.protocol.lldp.profile', u'profile'), ('pybind.nos.v7_0_1b.protocol.lldp.profile', u'profile')]
    bindings_list = [('pybind.nos.v6_0_2c.protocol.lldp.profile.advertise', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.lldp.profile.advertise', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.lldp.profile.advertise', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.lldp.profile.advertise', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'profile_name', 'extra_keyval': ''}, {'keyval': 'profile_name', 'extra_keyval': ''}, {'keyval': 'profile_name', 'extra_keyval': ''}, {'keyval': 'profile_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dcbx-fcoe-app-tlv'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, profile=profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, profile=profile)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_lldp_profile_advertise_dcbx_fcoe_logical_link_tlv_delete(self, profile=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type profile: profile_name
    :param profile: Keyword argument tuple.

    :type profile_name: unicode
    :param profile_name: **profile** tuple argument.

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '(\S)+'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.protocol.lldp.profile', u'profile'), ('pybind.slxos.v16r_1_00b.protocol.lldp.profile', u'profile'), ('pybind.nos.v6_0_2c.protocol.lldp.profile', u'profile'), ('pybind.nos.v7_0_1b.protocol.lldp.profile', u'profile')]
    bindings_list = [('pybind.nos.v6_0_2c.protocol.lldp.profile.advertise', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.lldp.profile.advertise', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.lldp.profile.advertise', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.lldp.profile.advertise', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'profile_name', 'extra_keyval': ''}, {'keyval': 'profile_name', 'extra_keyval': ''}, {'keyval': 'profile_name', 'extra_keyval': ''}, {'keyval': 'profile_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dcbx-fcoe-logical-link-tlv'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, profile=profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, profile=profile)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_lldp_profile_advertise_dcbx_iscsi_app_tlv_delete(self, profile=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type profile: profile_name
    :param profile: Keyword argument tuple.

    :type profile_name: unicode
    :param profile_name: **profile** tuple argument.

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '(\S)+'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.protocol.lldp.profile', u'profile'), ('pybind.slxos.v16r_1_00b.protocol.lldp.profile', u'profile'), ('pybind.nos.v6_0_2c.protocol.lldp.profile', u'profile'), ('pybind.nos.v7_0_1b.protocol.lldp.profile', u'profile')]
    bindings_list = [('pybind.nos.v6_0_2c.protocol.lldp.profile.advertise', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.lldp.profile.advertise', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.lldp.profile.advertise', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.lldp.profile.advertise', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'profile_name', 'extra_keyval': ''}, {'keyval': 'profile_name', 'extra_keyval': ''}, {'keyval': 'profile_name', 'extra_keyval': ''}, {'keyval': 'profile_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dcbx-iscsi-app-tlv'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, profile=profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, profile=profile)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_lldp_profile_advertise_dcbx_tlv_delete(self, profile=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type profile: profile_name
    :param profile: Keyword argument tuple.

    :type profile_name: unicode
    :param profile_name: **profile** tuple argument.

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '(\S)+'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.protocol.lldp.profile', u'profile'), ('pybind.slxos.v16r_1_00b.protocol.lldp.profile', u'profile'), ('pybind.nos.v6_0_2c.protocol.lldp.profile', u'profile'), ('pybind.nos.v7_0_1b.protocol.lldp.profile', u'profile')]
    bindings_list = [('pybind.nos.v6_0_2c.protocol.lldp.profile.advertise', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.lldp.profile.advertise', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.lldp.profile.advertise', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.lldp.profile.advertise', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'profile_name', 'extra_keyval': ''}, {'keyval': 'profile_name', 'extra_keyval': ''}, {'keyval': 'profile_name', 'extra_keyval': ''}, {'keyval': 'profile_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dcbx-tlv'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, profile=profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, profile=profile)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_lldp_profile_advertise_dot1_tlv_delete(self, profile=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type profile: profile_name
    :param profile: Keyword argument tuple.

    :type profile_name: unicode
    :param profile_name: **profile** tuple argument.

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '(\S)+'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.protocol.lldp.profile', u'profile'), ('pybind.slxos.v16r_1_00b.protocol.lldp.profile', u'profile'), ('pybind.nos.v6_0_2c.protocol.lldp.profile', u'profile'), ('pybind.nos.v7_0_1b.protocol.lldp.profile', u'profile')]
    bindings_list = [('pybind.nos.v6_0_2c.protocol.lldp.profile.advertise', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.lldp.profile.advertise', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.lldp.profile.advertise', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.lldp.profile.advertise', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'profile_name', 'extra_keyval': ''}, {'keyval': 'profile_name', 'extra_keyval': ''}, {'keyval': 'profile_name', 'extra_keyval': ''}, {'keyval': 'profile_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dot1-tlv'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, profile=profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, profile=profile)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_lldp_profile_advertise_dot3_tlv_delete(self, profile=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type profile: profile_name
    :param profile: Keyword argument tuple.

    :type profile_name: unicode
    :param profile_name: **profile** tuple argument.

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '(\S)+'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.protocol.lldp.profile', u'profile'), ('pybind.slxos.v16r_1_00b.protocol.lldp.profile', u'profile'), ('pybind.nos.v6_0_2c.protocol.lldp.profile', u'profile'), ('pybind.nos.v7_0_1b.protocol.lldp.profile', u'profile')]
    bindings_list = [('pybind.nos.v6_0_2c.protocol.lldp.profile.advertise', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.lldp.profile.advertise', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.lldp.profile.advertise', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.lldp.profile.advertise', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'profile_name', 'extra_keyval': ''}, {'keyval': 'profile_name', 'extra_keyval': ''}, {'keyval': 'profile_name', 'extra_keyval': ''}, {'keyval': 'profile_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dot3-tlv'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, profile=profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, profile=profile)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_lldp_profile_advertise_optional_tlv_management_address_delete(self, profile=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type profile: profile_name
    :param profile: Keyword argument tuple.

    :type profile_name: unicode
    :param profile_name: **profile** tuple argument.

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '(\S)+'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.protocol.lldp.profile', u'profile'), ('pybind.nos.v6_0_2c.protocol.lldp.profile', u'profile'), ('pybind.nos.v7_0_1b.protocol.lldp.profile', u'profile'), ('pybind.nos.v7_1_0.protocol.lldp.profile', u'profile')]
    bindings_list = [('pybind.nos.v6_0_2c.protocol.lldp.profile.advertise.optional_tlv', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.lldp.profile.advertise.optional_tlv', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.lldp.profile.advertise.optional_tlv', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.lldp.profile.advertise.optional_tlv', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'profile_name', 'extra_keyval': ''}, {'keyval': 'profile_name', 'extra_keyval': ''}, {'keyval': 'profile_name', 'extra_keyval': ''}, {'keyval': 'profile_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'management-address'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, profile=profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, profile=profile)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_lldp_profile_advertise_optional_tlv_port_description_delete(self, profile=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type profile: profile_name
    :param profile: Keyword argument tuple.

    :type profile_name: unicode
    :param profile_name: **profile** tuple argument.

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '(\S)+'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.protocol.lldp.profile', u'profile'), ('pybind.nos.v6_0_2c.protocol.lldp.profile', u'profile'), ('pybind.nos.v7_0_1b.protocol.lldp.profile', u'profile'), ('pybind.nos.v7_1_0.protocol.lldp.profile', u'profile')]
    bindings_list = [('pybind.nos.v6_0_2c.protocol.lldp.profile.advertise.optional_tlv', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.lldp.profile.advertise.optional_tlv', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.lldp.profile.advertise.optional_tlv', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.lldp.profile.advertise.optional_tlv', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'profile_name', 'extra_keyval': ''}, {'keyval': 'profile_name', 'extra_keyval': ''}, {'keyval': 'profile_name', 'extra_keyval': ''}, {'keyval': 'profile_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'port-description'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, profile=profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, profile=profile)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_lldp_profile_advertise_optional_tlv_system_capabilities_delete(self, profile=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type profile: profile_name
    :param profile: Keyword argument tuple.

    :type profile_name: unicode
    :param profile_name: **profile** tuple argument.

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '(\S)+'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.protocol.lldp.profile', u'profile'), ('pybind.nos.v6_0_2c.protocol.lldp.profile', u'profile'), ('pybind.nos.v7_0_1b.protocol.lldp.profile', u'profile'), ('pybind.nos.v7_1_0.protocol.lldp.profile', u'profile')]
    bindings_list = [('pybind.nos.v6_0_2c.protocol.lldp.profile.advertise.optional_tlv', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.lldp.profile.advertise.optional_tlv', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.lldp.profile.advertise.optional_tlv', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.lldp.profile.advertise.optional_tlv', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'profile_name', 'extra_keyval': ''}, {'keyval': 'profile_name', 'extra_keyval': ''}, {'keyval': 'profile_name', 'extra_keyval': ''}, {'keyval': 'profile_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'system-capabilities'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, profile=profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, profile=profile)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_lldp_profile_advertise_optional_tlv_system_description_delete(self, profile=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type profile: profile_name
    :param profile: Keyword argument tuple.

    :type profile_name: unicode
    :param profile_name: **profile** tuple argument.

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '(\S)+'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.protocol.lldp.profile', u'profile'), ('pybind.nos.v6_0_2c.protocol.lldp.profile', u'profile'), ('pybind.nos.v7_0_1b.protocol.lldp.profile', u'profile'), ('pybind.nos.v7_1_0.protocol.lldp.profile', u'profile')]
    bindings_list = [('pybind.nos.v6_0_2c.protocol.lldp.profile.advertise.optional_tlv', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.lldp.profile.advertise.optional_tlv', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.lldp.profile.advertise.optional_tlv', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.lldp.profile.advertise.optional_tlv', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'profile_name', 'extra_keyval': ''}, {'keyval': 'profile_name', 'extra_keyval': ''}, {'keyval': 'profile_name', 'extra_keyval': ''}, {'keyval': 'profile_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'system-description'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, profile=profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, profile=profile)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_lldp_profile_advertise_optional_tlv_system_name_delete(self, profile=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type profile: profile_name
    :param profile: Keyword argument tuple.

    :type profile_name: unicode
    :param profile_name: **profile** tuple argument.

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '(\S)+'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.protocol.lldp.profile', u'profile'), ('pybind.nos.v6_0_2c.protocol.lldp.profile', u'profile'), ('pybind.nos.v7_0_1b.protocol.lldp.profile', u'profile'), ('pybind.nos.v7_1_0.protocol.lldp.profile', u'profile')]
    bindings_list = [('pybind.nos.v6_0_2c.protocol.lldp.profile.advertise.optional_tlv', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.lldp.profile.advertise.optional_tlv', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.lldp.profile.advertise.optional_tlv', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.lldp.profile.advertise.optional_tlv', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'profile_name', 'extra_keyval': ''}, {'keyval': 'profile_name', 'extra_keyval': ''}, {'keyval': 'profile_name', 'extra_keyval': ''}, {'keyval': 'profile_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'system-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, profile=profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, profile=profile)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_lldp_profile_description_delete(self, profile=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type profile: profile_name
    :param profile: Keyword argument tuple.

    :type profile_name: unicode
    :param profile_name: **profile** tuple argument.

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '(\S)+'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.protocol.lldp.profile', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.lldp.profile', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.lldp.profile', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.lldp.profile', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'profile', 'keyval': 'profile_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'description'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, profile=profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, profile=profile)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_lldp_profile_hello_delete(self, profile=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type profile: profile_name
    :param profile: Keyword argument tuple.

    :type profile_name: unicode
    :param profile_name: **profile** tuple argument.

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '(\S)+'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.protocol.lldp.profile', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.lldp.profile', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.lldp.profile', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.lldp.profile', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'profile', 'keyval': 'profile_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hello'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, profile=profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, profile=profile)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_lldp_profile_mode_delete(self, profile=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type profile: profile_name
    :param profile: Keyword argument tuple.

    :type profile_name: unicode
    :param profile_name: **profile** tuple argument.

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '(\S)+'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.protocol.lldp.profile', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.lldp.profile', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.lldp.profile', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.lldp.profile', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'profile', 'keyval': 'profile_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mode'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, profile=profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, profile=profile)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_lldp_profile_multiplier_delete(self, profile=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type profile: profile_name
    :param profile: Keyword argument tuple.

    :type profile_name: unicode
    :param profile_name: **profile** tuple argument.

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '(\S)+'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.protocol.lldp.profile', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.lldp.profile', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.lldp.profile', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.lldp.profile', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'profile', 'keyval': 'profile_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'multiplier'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, profile=profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, profile=profile)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_lldp_system_description_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.protocol.lldp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.lldp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.lldp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.lldp', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'system-description'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_lldp_system_name_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.protocol.lldp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.lldp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.lldp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.lldp', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'system-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_spanning_tree_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.protocol.spanning_tree', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.spanning_tree', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.spanning_tree', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.spanning_tree', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_spanning_tree_mstp_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.protocol.spanning_tree.mstp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.spanning_tree.mstp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.spanning_tree.mstp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.spanning_tree.mstp', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v6_0_2c.protocol.spanning_tree.mstp": {"max_age": "max_age", "description": "description", "hello_time": "hello_time", "bridge_priority": "bridge_priority", "region": "region", "max_hops": "max_hops", "cisco_interoperability": "cisco_interoperability", "shutdown": "shutdown", "transmit_holdcount": "transmit_holdcount", "forward_delay": "forward_delay", "revision": "revision"}, "pybind.nos.v7_1_0.protocol.spanning_tree.mstp": {"max_age": "max_age", "description": "description", "hello_time": "hello_time", "bridge_priority": "bridge_priority", "region": "region", "max_hops": "max_hops", "cisco_interoperability": "cisco_interoperability", "shutdown": "shutdown", "transmit_holdcount": "transmit_holdcount", "forward_delay": "forward_delay", "revision": "revision"}, "pybind.nos.v7_0_1b.protocol.spanning_tree.mstp": {"max_age": "max_age", "description": "description", "hello_time": "hello_time", "bridge_priority": "bridge_priority", "region": "region", "max_hops": "max_hops", "cisco_interoperability": "cisco_interoperability", "shutdown": "shutdown", "transmit_holdcount": "transmit_holdcount", "forward_delay": "forward_delay", "revision": "revision"}, "pybind.slxos.v16r_1_00b.protocol.spanning_tree.mstp": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_spanning_tree_mstp_bridge_priority_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.protocol.spanning_tree.mstp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.spanning_tree.mstp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.spanning_tree.mstp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.spanning_tree.mstp', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bridge-priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_spanning_tree_mstp_cisco_interoperability_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.protocol.spanning_tree.mstp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.spanning_tree.mstp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.spanning_tree.mstp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.spanning_tree.mstp', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cisco-interoperability'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_spanning_tree_mstp_description_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.protocol.spanning_tree.mstp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.spanning_tree.mstp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.spanning_tree.mstp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.spanning_tree.mstp', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'description'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_spanning_tree_mstp_error_disable_timeout_enable_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.protocol.spanning_tree.mstp.error_disable_timeout', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.spanning_tree.mstp.error_disable_timeout', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.spanning_tree.mstp.error_disable_timeout', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.spanning_tree.mstp.error_disable_timeout', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_spanning_tree_mstp_error_disable_timeout_interval_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.protocol.spanning_tree.mstp.error_disable_timeout', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.spanning_tree.mstp.error_disable_timeout', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.spanning_tree.mstp.error_disable_timeout', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.spanning_tree.mstp.error_disable_timeout', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_spanning_tree_mstp_forward_delay_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.protocol.spanning_tree.mstp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.spanning_tree.mstp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.spanning_tree.mstp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.spanning_tree.mstp.timer_config', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'forward-delay'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_spanning_tree_mstp_hello_time_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.protocol.spanning_tree.mstp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.spanning_tree.mstp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.spanning_tree.mstp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.spanning_tree.mstp.timer_config', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hello-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_spanning_tree_mstp_instance_delete(self, instance=None, vlan=None, priority=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type instance: id
    :param instance: Keyword argument tuple.

    :type id: int
    :param id: **instance** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Argument(s)**:

    :type vlan: unicode
    :param vlan: Vlan

        * pattern restriction: ::

            '(([1-9][0-9]{0,2})|([1-3][0-9]{3})|(40[0-8][0-9]'
            ')|(4090))(-(([1-9][0-9]{0,2})|([1-3][0-9]{3})|(4'
            '0[0-8][0-9])|(4090)))?((,(([1-9][0-9]{0,2})|([1-'
            '3][0-9]{3})|(40[0-8][0-9])|(4090))(-(([1-9][0-9]'
            '{0,2})|([1-3][0-9]{3})|(40[0-8][0-9])|(4090)))?)'
            '?)*'

    :type priority: long
    :param priority: Priority - bridge priority for the common instance

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.protocol.spanning_tree.mstp.instance', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.spanning_tree.mstp.instance', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.spanning_tree.mstp.instance', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.spanning_tree.mstp.instance', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'instance', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, instance=instance, vlan=vlan, priority=priority)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, instance=instance, vlan=vlan, priority=priority)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_spanning_tree_mstp_max_age_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.protocol.spanning_tree.mstp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.spanning_tree.mstp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.spanning_tree.mstp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.spanning_tree.mstp.timer_config', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'max-age'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_spanning_tree_mstp_max_hops_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.protocol.spanning_tree.mstp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.spanning_tree.mstp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.spanning_tree.mstp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.spanning_tree.mstp', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'max-hops'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_spanning_tree_mstp_port_channel_path_cost_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.protocol.spanning_tree.mstp.port_channel', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.spanning_tree.mstp.port_channel', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.spanning_tree.mstp.port_channel', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.spanning_tree.mstp.port_channel', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'path-cost'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_spanning_tree_mstp_region_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.protocol.spanning_tree.mstp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.spanning_tree.mstp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.spanning_tree.mstp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.spanning_tree.mstp', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'region'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_spanning_tree_mstp_revision_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.protocol.spanning_tree.mstp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.spanning_tree.mstp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.spanning_tree.mstp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.spanning_tree.mstp', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'revision'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_spanning_tree_mstp_shutdown_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.protocol.spanning_tree.mstp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.spanning_tree.mstp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.spanning_tree.mstp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.spanning_tree.mstp', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'shutdown'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_spanning_tree_mstp_system_id_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_0_1b.protocol.spanning_tree.mstp.system_id', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.spanning_tree.mstp.system_id', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_spanning_tree_mstp_system_id_oui_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_0_1b.protocol.spanning_tree.mstp.system_id', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.spanning_tree.mstp.system_id', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'oui'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_spanning_tree_mstp_timer_config_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.protocol.spanning_tree.mstp.timer_config', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'hello_time, forward_delay, max_age'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_spanning_tree_mstp_transmit_holdcount_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.protocol.spanning_tree.mstp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.spanning_tree.mstp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.spanning_tree.mstp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.spanning_tree.mstp', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'transmit-holdcount'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_spanning_tree_pvst_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.protocol.spanning_tree.pvst', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.spanning_tree.pvst', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.spanning_tree.pvst', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.spanning_tree.pvst', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v16r_1_00b.protocol.spanning_tree.pvst": {}, "pybind.nos.v6_0_2c.protocol.spanning_tree.pvst": {"max_age": "max_age", "description": "description", "hello_time": "hello_time", "bridge_priority": "bridge_priority", "shutdown": "shutdown", "forward_delay": "forward_delay"}, "pybind.nos.v7_0_1b.protocol.spanning_tree.pvst": {"max_age": "max_age", "description": "description", "hello_time": "hello_time", "bridge_priority": "bridge_priority", "shutdown": "shutdown", "forward_delay": "forward_delay"}, "pybind.nos.v7_1_0.protocol.spanning_tree.pvst": {"max_age": "max_age", "description": "description", "hello_time": "hello_time", "bridge_priority": "bridge_priority", "shutdown": "shutdown", "forward_delay": "forward_delay"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_spanning_tree_pvst_bridge_priority_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.protocol.spanning_tree.pvst', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.spanning_tree.pvst', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.spanning_tree.pvst', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.spanning_tree.pvst', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bridge-priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_spanning_tree_pvst_description_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.protocol.spanning_tree.pvst', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.spanning_tree.pvst', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.spanning_tree.pvst', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.spanning_tree.pvst', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'description'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_spanning_tree_pvst_error_disable_timeout_enable_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.protocol.spanning_tree.pvst.error_disable_timeout', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.spanning_tree.pvst.error_disable_timeout', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.spanning_tree.pvst.error_disable_timeout', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.spanning_tree.pvst.error_disable_timeout', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_spanning_tree_pvst_error_disable_timeout_interval_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.protocol.spanning_tree.pvst.error_disable_timeout', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.spanning_tree.pvst.error_disable_timeout', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.spanning_tree.pvst.error_disable_timeout', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.spanning_tree.pvst.error_disable_timeout', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_spanning_tree_pvst_forward_delay_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.protocol.spanning_tree.pvst', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.spanning_tree.pvst', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.spanning_tree.pvst', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.spanning_tree.pvst.timer_config', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'forward-delay'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_spanning_tree_pvst_hello_time_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.protocol.spanning_tree.pvst', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.spanning_tree.pvst', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.spanning_tree.pvst', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.spanning_tree.pvst.timer_config', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hello-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_spanning_tree_pvst_max_age_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.protocol.spanning_tree.pvst', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.spanning_tree.pvst', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.spanning_tree.pvst', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.spanning_tree.pvst.timer_config', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'max-age'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_spanning_tree_pvst_port_channel_path_cost_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.protocol.spanning_tree.pvst.port_channel', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.spanning_tree.pvst.port_channel', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.spanning_tree.pvst.port_channel', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.spanning_tree.pvst.port_channel', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'path-cost'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_spanning_tree_pvst_shutdown_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.protocol.spanning_tree.pvst', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.spanning_tree.pvst', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.spanning_tree.pvst', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.spanning_tree.pvst', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'shutdown'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_spanning_tree_pvst_system_id_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_0_1b.protocol.spanning_tree.pvst.system_id', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.spanning_tree.pvst.system_id', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_spanning_tree_pvst_system_id_oui_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_0_1b.protocol.spanning_tree.pvst.system_id', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.spanning_tree.pvst.system_id', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'oui'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_spanning_tree_pvst_timer_config_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.protocol.spanning_tree.pvst.timer_config', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'hello_time, forward_delay, max_age'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_spanning_tree_pvst_vlan_forward_delay_delete(self, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type vlan: id
    :param vlan: Keyword argument tuple.

    :type id: long
    :param id: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.protocol.spanning_tree.pvst.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2c.protocol.spanning_tree.pvst.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.spanning_tree.pvst.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.spanning_tree.pvst.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.spanning_tree.pvst.vlan.timer_config', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v16r_1_00b.protocol.spanning_tree.pvst.vlan.timer_config": {}, "pybind.nos.v7_1_0.protocol.spanning_tree.pvst.vlan": {"id": "id", "forward_delay": "forward_delay"}, "pybind.nos.v7_0_1b.protocol.spanning_tree.pvst.vlan": {"id": "id", "forward_delay": "forward_delay"}, "pybind.nos.v6_0_2c.protocol.spanning_tree.pvst.vlan": {"id": "id", "forward_delay": "forward_delay"}}
    rest_leaf_name = 'forward-delay'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_spanning_tree_pvst_vlan_hello_time_delete(self, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type vlan: id
    :param vlan: Keyword argument tuple.

    :type id: long
    :param id: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.protocol.spanning_tree.pvst.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2c.protocol.spanning_tree.pvst.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.spanning_tree.pvst.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.spanning_tree.pvst.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.spanning_tree.pvst.vlan.timer_config', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v16r_1_00b.protocol.spanning_tree.pvst.vlan.timer_config": {}, "pybind.nos.v7_1_0.protocol.spanning_tree.pvst.vlan": {"id": "id", "hello_time": "hello_time"}, "pybind.nos.v7_0_1b.protocol.spanning_tree.pvst.vlan": {"id": "id", "hello_time": "hello_time"}, "pybind.nos.v6_0_2c.protocol.spanning_tree.pvst.vlan": {"id": "id", "hello_time": "hello_time"}}
    rest_leaf_name = 'hello-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_spanning_tree_pvst_vlan_max_age_delete(self, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type vlan: id
    :param vlan: Keyword argument tuple.

    :type id: long
    :param id: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.protocol.spanning_tree.pvst.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2c.protocol.spanning_tree.pvst.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.spanning_tree.pvst.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.spanning_tree.pvst.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.spanning_tree.pvst.vlan.timer_config', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v16r_1_00b.protocol.spanning_tree.pvst.vlan.timer_config": {}, "pybind.nos.v7_1_0.protocol.spanning_tree.pvst.vlan": {"max_age": "max_age", "id": "id"}, "pybind.nos.v7_0_1b.protocol.spanning_tree.pvst.vlan": {"max_age": "max_age", "id": "id"}, "pybind.nos.v6_0_2c.protocol.spanning_tree.pvst.vlan": {"max_age": "max_age", "id": "id"}}
    rest_leaf_name = 'max-age'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_spanning_tree_pvst_vlan_priority_delete(self, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type vlan: id
    :param vlan: Keyword argument tuple.

    :type id: long
    :param id: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.protocol.spanning_tree.pvst.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.spanning_tree.pvst.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.spanning_tree.pvst.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.spanning_tree.pvst.vlan', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_spanning_tree_rpvst_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.protocol.spanning_tree.rpvst', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.spanning_tree.rpvst', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.spanning_tree.rpvst', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.spanning_tree.rpvst', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v6_0_2c.protocol.spanning_tree.rpvst": {"max_age": "max_age", "description": "description", "hello_time": "hello_time", "bridge_priority": "bridge_priority", "shutdown": "shutdown", "transmit_holdcount": "transmit_holdcount", "forward_delay": "forward_delay"}, "pybind.slxos.v16r_1_00b.protocol.spanning_tree.rpvst": {}, "pybind.nos.v7_1_0.protocol.spanning_tree.rpvst": {"max_age": "max_age", "description": "description", "hello_time": "hello_time", "bridge_priority": "bridge_priority", "shutdown": "shutdown", "transmit_holdcount": "transmit_holdcount", "forward_delay": "forward_delay"}, "pybind.nos.v7_0_1b.protocol.spanning_tree.rpvst": {"max_age": "max_age", "description": "description", "hello_time": "hello_time", "bridge_priority": "bridge_priority", "shutdown": "shutdown", "transmit_holdcount": "transmit_holdcount", "forward_delay": "forward_delay"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_spanning_tree_rpvst_bridge_priority_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.protocol.spanning_tree.rpvst', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.spanning_tree.rpvst', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.spanning_tree.rpvst', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.spanning_tree.rpvst', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bridge-priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_spanning_tree_rpvst_description_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.protocol.spanning_tree.rpvst', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.spanning_tree.rpvst', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.spanning_tree.rpvst', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.spanning_tree.rpvst', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'description'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_spanning_tree_rpvst_error_disable_timeout_enable_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.protocol.spanning_tree.rpvst.error_disable_timeout', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.spanning_tree.rpvst.error_disable_timeout', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.spanning_tree.rpvst.error_disable_timeout', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.spanning_tree.rpvst.error_disable_timeout', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_spanning_tree_rpvst_error_disable_timeout_interval_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.protocol.spanning_tree.rpvst.error_disable_timeout', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.spanning_tree.rpvst.error_disable_timeout', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.spanning_tree.rpvst.error_disable_timeout', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.spanning_tree.rpvst.error_disable_timeout', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_spanning_tree_rpvst_forward_delay_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.protocol.spanning_tree.rpvst', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.spanning_tree.rpvst', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.spanning_tree.rpvst', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.spanning_tree.rpvst.timer_config', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'forward-delay'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_spanning_tree_rpvst_hello_time_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.protocol.spanning_tree.rpvst', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.spanning_tree.rpvst', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.spanning_tree.rpvst', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.spanning_tree.rpvst.timer_config', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hello-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_spanning_tree_rpvst_max_age_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.protocol.spanning_tree.rpvst', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.spanning_tree.rpvst', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.spanning_tree.rpvst', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.spanning_tree.rpvst.timer_config', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'max-age'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_spanning_tree_rpvst_port_channel_path_cost_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.protocol.spanning_tree.rpvst.port_channel', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.spanning_tree.rpvst.port_channel', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.spanning_tree.rpvst.port_channel', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.spanning_tree.rpvst.port_channel', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'path-cost'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_spanning_tree_rpvst_shutdown_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.protocol.spanning_tree.rpvst', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.spanning_tree.rpvst', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.spanning_tree.rpvst', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.spanning_tree.rpvst', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'shutdown'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_spanning_tree_rpvst_system_id_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_0_1b.protocol.spanning_tree.rpvst.system_id', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.spanning_tree.rpvst.system_id', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_spanning_tree_rpvst_system_id_oui_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_0_1b.protocol.spanning_tree.rpvst.system_id', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.spanning_tree.rpvst.system_id', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'oui'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_spanning_tree_rpvst_timer_config_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.protocol.spanning_tree.rpvst.timer_config', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'hello_time, forward_delay, max_age'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_spanning_tree_rpvst_transmit_holdcount_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.protocol.spanning_tree.rpvst', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.spanning_tree.rpvst', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.spanning_tree.rpvst', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.spanning_tree.rpvst', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'transmit-holdcount'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_spanning_tree_rpvst_vlan_forward_delay_delete(self, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type vlan: id
    :param vlan: Keyword argument tuple.

    :type id: long
    :param id: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.protocol.spanning_tree.rpvst.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2c.protocol.spanning_tree.rpvst.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.spanning_tree.rpvst.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.spanning_tree.rpvst.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.spanning_tree.rpvst.vlan.timer_config', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v7_0_1b.protocol.spanning_tree.rpvst.vlan": {"id": "id", "forward_delay": "forward_delay"}, "pybind.nos.v6_0_2c.protocol.spanning_tree.rpvst.vlan": {"id": "id", "forward_delay": "forward_delay"}, "pybind.nos.v7_1_0.protocol.spanning_tree.rpvst.vlan": {"id": "id", "forward_delay": "forward_delay"}, "pybind.slxos.v16r_1_00b.protocol.spanning_tree.rpvst.vlan.timer_config": {}}
    rest_leaf_name = 'forward-delay'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_spanning_tree_rpvst_vlan_hello_time_delete(self, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type vlan: id
    :param vlan: Keyword argument tuple.

    :type id: long
    :param id: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.protocol.spanning_tree.rpvst.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2c.protocol.spanning_tree.rpvst.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.spanning_tree.rpvst.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.spanning_tree.rpvst.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.spanning_tree.rpvst.vlan.timer_config', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v7_0_1b.protocol.spanning_tree.rpvst.vlan": {"id": "id", "hello_time": "hello_time"}, "pybind.nos.v6_0_2c.protocol.spanning_tree.rpvst.vlan": {"id": "id", "hello_time": "hello_time"}, "pybind.nos.v7_1_0.protocol.spanning_tree.rpvst.vlan": {"id": "id", "hello_time": "hello_time"}, "pybind.slxos.v16r_1_00b.protocol.spanning_tree.rpvst.vlan.timer_config": {}}
    rest_leaf_name = 'hello-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_spanning_tree_rpvst_vlan_max_age_delete(self, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type vlan: id
    :param vlan: Keyword argument tuple.

    :type id: long
    :param id: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.protocol.spanning_tree.rpvst.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2c.protocol.spanning_tree.rpvst.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.spanning_tree.rpvst.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.spanning_tree.rpvst.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.spanning_tree.rpvst.vlan.timer_config', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v7_0_1b.protocol.spanning_tree.rpvst.vlan": {"max_age": "max_age", "id": "id"}, "pybind.nos.v6_0_2c.protocol.spanning_tree.rpvst.vlan": {"max_age": "max_age", "id": "id"}, "pybind.nos.v7_1_0.protocol.spanning_tree.rpvst.vlan": {"max_age": "max_age", "id": "id"}, "pybind.slxos.v16r_1_00b.protocol.spanning_tree.rpvst.vlan.timer_config": {}}
    rest_leaf_name = 'max-age'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_spanning_tree_rpvst_vlan_priority_delete(self, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type vlan: id
    :param vlan: Keyword argument tuple.

    :type id: long
    :param id: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.protocol.spanning_tree.rpvst.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.spanning_tree.rpvst.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.spanning_tree.rpvst.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.spanning_tree.rpvst.vlan', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_spanning_tree_rstp_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.protocol.spanning_tree.rstp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.spanning_tree.rstp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.spanning_tree.rstp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.spanning_tree.rstp', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v7_0_1b.protocol.spanning_tree.rstp": {"max_age": "max_age", "description": "description", "hello_time": "hello_time", "bridge_priority": "bridge_priority", "shutdown": "shutdown", "transmit_holdcount": "transmit_holdcount", "forward_delay": "forward_delay"}, "pybind.slxos.v16r_1_00b.protocol.spanning_tree.rstp": {}, "pybind.nos.v6_0_2c.protocol.spanning_tree.rstp": {"max_age": "max_age", "description": "description", "hello_time": "hello_time", "bridge_priority": "bridge_priority", "shutdown": "shutdown", "transmit_holdcount": "transmit_holdcount", "forward_delay": "forward_delay"}, "pybind.nos.v7_1_0.protocol.spanning_tree.rstp": {"max_age": "max_age", "description": "description", "hello_time": "hello_time", "bridge_priority": "bridge_priority", "shutdown": "shutdown", "transmit_holdcount": "transmit_holdcount", "forward_delay": "forward_delay"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_spanning_tree_rstp_bridge_priority_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.protocol.spanning_tree.rstp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.spanning_tree.rstp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.spanning_tree.rstp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.spanning_tree.rstp', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bridge-priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_spanning_tree_rstp_description_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.protocol.spanning_tree.rstp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.spanning_tree.rstp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.spanning_tree.rstp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.spanning_tree.rstp', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'description'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_spanning_tree_rstp_error_disable_timeout_enable_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.protocol.spanning_tree.rstp.error_disable_timeout', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.spanning_tree.rstp.error_disable_timeout', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.spanning_tree.rstp.error_disable_timeout', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.spanning_tree.rstp.error_disable_timeout', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_spanning_tree_rstp_error_disable_timeout_interval_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.protocol.spanning_tree.rstp.error_disable_timeout', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.spanning_tree.rstp.error_disable_timeout', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.spanning_tree.rstp.error_disable_timeout', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.spanning_tree.rstp.error_disable_timeout', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_spanning_tree_rstp_forward_delay_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.protocol.spanning_tree.rstp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.spanning_tree.rstp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.spanning_tree.rstp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.spanning_tree.rstp.timer_config', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'forward-delay'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_spanning_tree_rstp_hello_time_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.protocol.spanning_tree.rstp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.spanning_tree.rstp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.spanning_tree.rstp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.spanning_tree.rstp.timer_config', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hello-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_spanning_tree_rstp_max_age_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.protocol.spanning_tree.rstp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.spanning_tree.rstp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.spanning_tree.rstp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.spanning_tree.rstp.timer_config', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'max-age'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_spanning_tree_rstp_port_channel_path_cost_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.protocol.spanning_tree.rstp.port_channel', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.spanning_tree.rstp.port_channel', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.spanning_tree.rstp.port_channel', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.spanning_tree.rstp.port_channel', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'path-cost'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_spanning_tree_rstp_shutdown_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.protocol.spanning_tree.rstp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.spanning_tree.rstp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.spanning_tree.rstp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.spanning_tree.rstp', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'shutdown'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_spanning_tree_rstp_system_id_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_0_1b.protocol.spanning_tree.rstp.system_id', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.spanning_tree.rstp.system_id', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_spanning_tree_rstp_system_id_oui_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_0_1b.protocol.spanning_tree.rstp.system_id', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.spanning_tree.rstp.system_id', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'oui'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_spanning_tree_rstp_timer_config_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.protocol.spanning_tree.rstp.timer_config', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'hello_time, forward_delay, max_age'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_spanning_tree_rstp_transmit_holdcount_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.protocol.spanning_tree.rstp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.spanning_tree.rstp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.spanning_tree.rstp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.spanning_tree.rstp', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'transmit-holdcount'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_spanning_tree_stp_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.protocol.spanning_tree.stp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.spanning_tree.stp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.spanning_tree.stp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.spanning_tree.stp', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v16r_1_00b.protocol.spanning_tree.stp": {}, "pybind.nos.v7_0_1b.protocol.spanning_tree.stp": {"max_age": "max_age", "description": "description", "hello_time": "hello_time", "bridge_priority": "bridge_priority", "shutdown": "shutdown", "forward_delay": "forward_delay"}, "pybind.nos.v7_1_0.protocol.spanning_tree.stp": {"max_age": "max_age", "description": "description", "hello_time": "hello_time", "bridge_priority": "bridge_priority", "shutdown": "shutdown", "forward_delay": "forward_delay"}, "pybind.nos.v6_0_2c.protocol.spanning_tree.stp": {"max_age": "max_age", "description": "description", "hello_time": "hello_time", "bridge_priority": "bridge_priority", "shutdown": "shutdown", "forward_delay": "forward_delay"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_spanning_tree_stp_bridge_priority_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.protocol.spanning_tree.stp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.spanning_tree.stp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.spanning_tree.stp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.spanning_tree.stp', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bridge-priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_spanning_tree_stp_description_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.protocol.spanning_tree.stp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.spanning_tree.stp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.spanning_tree.stp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.spanning_tree.stp', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'description'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_spanning_tree_stp_error_disable_timeout_enable_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.protocol.spanning_tree.stp.error_disable_timeout', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.spanning_tree.stp.error_disable_timeout', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.spanning_tree.stp.error_disable_timeout', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.spanning_tree.stp.error_disable_timeout', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_spanning_tree_stp_error_disable_timeout_interval_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.protocol.spanning_tree.stp.error_disable_timeout', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.spanning_tree.stp.error_disable_timeout', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.spanning_tree.stp.error_disable_timeout', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.spanning_tree.stp.error_disable_timeout', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_spanning_tree_stp_forward_delay_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.protocol.spanning_tree.stp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.spanning_tree.stp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.spanning_tree.stp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.spanning_tree.stp.timer_config', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'forward-delay'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_spanning_tree_stp_hello_time_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.protocol.spanning_tree.stp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.spanning_tree.stp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.spanning_tree.stp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.spanning_tree.stp.timer_config', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hello-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_spanning_tree_stp_max_age_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.protocol.spanning_tree.stp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.spanning_tree.stp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.spanning_tree.stp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.spanning_tree.stp.timer_config', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'max-age'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_spanning_tree_stp_port_channel_path_cost_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.protocol.spanning_tree.stp.port_channel', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.spanning_tree.stp.port_channel', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.spanning_tree.stp.port_channel', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.spanning_tree.stp.port_channel', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'path-cost'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_spanning_tree_stp_shutdown_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.protocol.spanning_tree.stp', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.spanning_tree.stp', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.spanning_tree.stp', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.spanning_tree.stp', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'shutdown'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_spanning_tree_stp_system_id_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_0_1b.protocol.spanning_tree.stp.system_id', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.spanning_tree.stp.system_id', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_spanning_tree_stp_system_id_oui_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_0_1b.protocol.spanning_tree.stp.system_id', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.spanning_tree.stp.system_id', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'oui'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_spanning_tree_stp_timer_config_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.protocol.spanning_tree.stp.timer_config', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'hello_time, forward_delay, max_age'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_udld_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.protocol.udld', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.udld', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.udld', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.udld', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_udld_hello_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.protocol.udld', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.udld', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.udld', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.udld', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hello'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_udld_multiplier_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.protocol.udld', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.udld', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.udld', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.udld', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'multiplier'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_udld_shutdown_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.protocol.udld', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol.udld', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol.udld', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol.udld', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'shutdown'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_vrrp_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.protocol.hide_vrrp_holder', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vrrp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_vrrp_extended_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.protocol.hide_vrrp_holder', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vrrp-extended'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def protocol_vrrpv3_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.protocol_vrrpv3', 'pybind.nos.v6_0_2c.brocade_vrrpv3', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.protocol_vrrpv3', 'pybind.nos.v7_0_1b.brocade_vrrpv3', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.protocol_vrrpv3', 'pybind.nos.v7_1_0.brocade_vrrpv3', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.protocol_vrrpv3', 'pybind.slxos.v16r_1_00b.brocade_vrrpv3', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def pw_profile_delete(self, pw_profile=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type pw_profile: pw_profile_name
    :param pw_profile: Keyword argument tuple.

    :type pw_profile_name: unicode
    :param pw_profile_name: **pw_profile** tuple argument:  Pw-profile name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.pw_profile', 'pybind.slxos.v16r_1_00b.brocade_pw_profile', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'pw_profile', 'keyval': 'pw_profile_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pw_profile=pw_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pw_profile=pw_profile)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def pw_profile_mtu_delete(self, pw_profile=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type pw_profile: pw_profile_name
    :param pw_profile: Keyword argument tuple.

    :type pw_profile_name: unicode
    :param pw_profile_name: **pw_profile** tuple argument:  Pw-profile name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.pw_profile', 'pw_profile')]
    bindings_list = [('pybind.slxos.v16r_1_00b.pw_profile.mtu', 'pybind.slxos.v16r_1_00b.brocade_pw_profile', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'pw_profile_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pw_profile=pw_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pw_profile=pw_profile)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def pw_profile_mtu_enforce_delete(self, pw_profile=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type pw_profile: pw_profile_name
    :param pw_profile: Keyword argument tuple.

    :type pw_profile_name: unicode
    :param pw_profile_name: **pw_profile** tuple argument:  Pw-profile name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.pw_profile', 'pybind.slxos.v16r_1_00b.brocade_pw_profile', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'pw_profile', 'keyval': 'pw_profile_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mtu-enforce'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pw_profile=pw_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pw_profile=pw_profile)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def pw_profile_mtu_mtu_value_delete(self, pw_profile=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type pw_profile: pw_profile_name
    :param pw_profile: Keyword argument tuple.

    :type pw_profile_name: unicode
    :param pw_profile_name: **pw_profile** tuple argument:  Pw-profile name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.pw_profile', 'pw_profile')]
    bindings_list = [('pybind.slxos.v16r_1_00b.pw_profile.mtu', 'pybind.slxos.v16r_1_00b.brocade_pw_profile', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'pw_profile_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mtu-value'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pw_profile=pw_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pw_profile=pw_profile)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def pw_profile_vc_mode_delete(self, pw_profile=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type pw_profile: pw_profile_name
    :param pw_profile: Keyword argument tuple.

    :type pw_profile_name: unicode
    :param pw_profile_name: **pw_profile** tuple argument:  Pw-profile name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.pw_profile', 'pw_profile')]
    bindings_list = [('pybind.slxos.v16r_1_00b.pw_profile.vc_mode', 'pybind.slxos.v16r_1_00b.brocade_pw_profile', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'pw_profile_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pw_profile=pw_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pw_profile=pw_profile)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def pw_profile_vc_mode_vc_mode_delete(self, pw_profile=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type pw_profile: pw_profile_name
    :param pw_profile: Keyword argument tuple.

    :type pw_profile_name: unicode
    :param pw_profile_name: **pw_profile** tuple argument:  Pw-profile name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.pw_profile', 'pw_profile')]
    bindings_list = [('pybind.slxos.v16r_1_00b.pw_profile.vc_mode', 'pybind.slxos.v16r_1_00b.brocade_pw_profile', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'pw_profile_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vc-mode'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pw_profile=pw_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pw_profile=pw_profile)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_cpu_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.qos.cpu', 'pybind.slxos.v16r_1_00b.brocade_qos_mls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_cpu_slot_group_prio_shaper_burst_delete(self, slot=None, group=None, group_prio=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type slot: slot_id
    :param slot: Keyword argument tuple.

    :type slot_id: unicode
    :param slot_id: **slot** tuple argument.

        * length restriction: ::

            ['1..3']

    :type group: group_id
    :param group: Keyword argument tuple.

    :type group_id: unicode
    :param group_id: **group** tuple argument.

        * length restriction: ::

            ['1..3']

    :type group_prio: group_prio_id
    :param group_prio: Keyword argument tuple.

    :type group_prio_id: unicode
    :param group_prio_id: **group_prio** tuple argument.

        * length restriction: ::

            ['1..3']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.qos.cpu.slot', u'slot'), ('pybind.slxos.v16r_1_00b.qos.cpu.slot.port_group.group', u'group'), ('pybind.slxos.v16r_1_00b.qos.cpu.slot.port_group.group.group_config_shaper_wfq.group_prio', u'group_prio')]
    bindings_list = [('pybind.slxos.v16r_1_00b.qos.cpu.slot.port_group.group.group_config_shaper_wfq.group_prio.group_prio_config_shaper_wfq.group_prio_shaper', 'pybind.slxos.v16r_1_00b.brocade_qos_mls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'slot_id', 'extra_keyval': ''}, {'keyval': 'group_id', 'extra_keyval': ''}, {'keyval': 'group_prio_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'burst'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, slot=slot, group=group, group_prio=group_prio)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, slot=slot, group=group, group_prio=group_prio)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_cpu_slot_group_prio_shaper_rate_delete(self, slot=None, group=None, group_prio=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type slot: slot_id
    :param slot: Keyword argument tuple.

    :type slot_id: unicode
    :param slot_id: **slot** tuple argument.

        * length restriction: ::

            ['1..3']

    :type group: group_id
    :param group: Keyword argument tuple.

    :type group_id: unicode
    :param group_id: **group** tuple argument.

        * length restriction: ::

            ['1..3']

    :type group_prio: group_prio_id
    :param group_prio: Keyword argument tuple.

    :type group_prio_id: unicode
    :param group_prio_id: **group_prio** tuple argument.

        * length restriction: ::

            ['1..3']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.qos.cpu.slot', u'slot'), ('pybind.slxos.v16r_1_00b.qos.cpu.slot.port_group.group', u'group'), ('pybind.slxos.v16r_1_00b.qos.cpu.slot.port_group.group.group_config_shaper_wfq.group_prio', u'group_prio')]
    bindings_list = [('pybind.slxos.v16r_1_00b.qos.cpu.slot.port_group.group.group_config_shaper_wfq.group_prio.group_prio_config_shaper_wfq.group_prio_shaper', 'pybind.slxos.v16r_1_00b.brocade_qos_mls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'slot_id', 'extra_keyval': ''}, {'keyval': 'group_id', 'extra_keyval': ''}, {'keyval': 'group_prio_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rate'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, slot=slot, group=group, group_prio=group_prio)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, slot=slot, group=group, group_prio=group_prio)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_cpu_slot_group_prio_wfq_weight_delete(self, slot=None, group=None, group_prio=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type slot: slot_id
    :param slot: Keyword argument tuple.

    :type slot_id: unicode
    :param slot_id: **slot** tuple argument.

        * length restriction: ::

            ['1..3']

    :type group: group_id
    :param group: Keyword argument tuple.

    :type group_id: unicode
    :param group_id: **group** tuple argument.

        * length restriction: ::

            ['1..3']

    :type group_prio: group_prio_id
    :param group_prio: Keyword argument tuple.

    :type group_prio_id: unicode
    :param group_prio_id: **group_prio** tuple argument.

        * length restriction: ::

            ['1..3']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.qos.cpu.slot', u'slot'), ('pybind.slxos.v16r_1_00b.qos.cpu.slot.port_group.group', u'group'), ('pybind.slxos.v16r_1_00b.qos.cpu.slot.port_group.group.group_config_shaper_wfq.group_prio', u'group_prio')]
    bindings_list = [('pybind.slxos.v16r_1_00b.qos.cpu.slot.port_group.group.group_config_shaper_wfq.group_prio.group_prio_config_shaper_wfq.group_prio_wfq', 'pybind.slxos.v16r_1_00b.brocade_qos_mls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'slot_id', 'extra_keyval': ''}, {'keyval': 'group_id', 'extra_keyval': ''}, {'keyval': 'group_prio_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'weight'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, slot=slot, group=group, group_prio=group_prio)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, slot=slot, group=group, group_prio=group_prio)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_cpu_slot_group_shaper_burst_delete(self, slot=None, group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type slot: slot_id
    :param slot: Keyword argument tuple.

    :type slot_id: unicode
    :param slot_id: **slot** tuple argument.

        * length restriction: ::

            ['1..3']

    :type group: group_id
    :param group: Keyword argument tuple.

    :type group_id: unicode
    :param group_id: **group** tuple argument.

        * length restriction: ::

            ['1..3']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.qos.cpu.slot', u'slot'), ('pybind.slxos.v16r_1_00b.qos.cpu.slot.port_group.group', u'group')]
    bindings_list = [('pybind.slxos.v16r_1_00b.qos.cpu.slot.port_group.group.group_config_shaper_wfq.group_shaper', 'pybind.slxos.v16r_1_00b.brocade_qos_mls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'slot_id', 'extra_keyval': ''}, {'keyval': 'group_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'burst'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, slot=slot, group=group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, slot=slot, group=group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_cpu_slot_group_shaper_rate_delete(self, slot=None, group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type slot: slot_id
    :param slot: Keyword argument tuple.

    :type slot_id: unicode
    :param slot_id: **slot** tuple argument.

        * length restriction: ::

            ['1..3']

    :type group: group_id
    :param group: Keyword argument tuple.

    :type group_id: unicode
    :param group_id: **group** tuple argument.

        * length restriction: ::

            ['1..3']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.qos.cpu.slot', u'slot'), ('pybind.slxos.v16r_1_00b.qos.cpu.slot.port_group.group', u'group')]
    bindings_list = [('pybind.slxos.v16r_1_00b.qos.cpu.slot.port_group.group.group_config_shaper_wfq.group_shaper', 'pybind.slxos.v16r_1_00b.brocade_qos_mls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'slot_id', 'extra_keyval': ''}, {'keyval': 'group_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rate'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, slot=slot, group=group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, slot=slot, group=group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_cpu_slot_group_wfq_weight_delete(self, slot=None, group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type slot: slot_id
    :param slot: Keyword argument tuple.

    :type slot_id: unicode
    :param slot_id: **slot** tuple argument.

        * length restriction: ::

            ['1..3']

    :type group: group_id
    :param group: Keyword argument tuple.

    :type group_id: unicode
    :param group_id: **group** tuple argument.

        * length restriction: ::

            ['1..3']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.qos.cpu.slot', u'slot'), ('pybind.slxos.v16r_1_00b.qos.cpu.slot.port_group.group', u'group')]
    bindings_list = [('pybind.slxos.v16r_1_00b.qos.cpu.slot.port_group.group.group_config_shaper_wfq.group_wfq', 'pybind.slxos.v16r_1_00b.brocade_qos_mls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'slot_id', 'extra_keyval': ''}, {'keyval': 'group_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'weight'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, slot=slot, group=group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, slot=slot, group=group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_cpu_slot_port_shaper_burst_delete(self, slot=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type slot: slot_id
    :param slot: Keyword argument tuple.

    :type slot_id: unicode
    :param slot_id: **slot** tuple argument.

        * length restriction: ::

            ['1..3']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.qos.cpu.slot', u'slot')]
    bindings_list = [('pybind.slxos.v16r_1_00b.qos.cpu.slot.port_group.port.port_shaper', 'pybind.slxos.v16r_1_00b.brocade_qos_mls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'slot_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'burst'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, slot=slot)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, slot=slot)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_cpu_slot_port_shaper_rate_delete(self, slot=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type slot: slot_id
    :param slot: Keyword argument tuple.

    :type slot_id: unicode
    :param slot_id: **slot** tuple argument.

        * length restriction: ::

            ['1..3']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.qos.cpu.slot', u'slot')]
    bindings_list = [('pybind.slxos.v16r_1_00b.qos.cpu.slot.port_group.port.port_shaper', 'pybind.slxos.v16r_1_00b.brocade_qos_mls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'slot_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rate'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, slot=slot)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, slot=slot)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_map_cos_mutation_delete(self, cos_mutation=None, cos0=None, cos1=None, cos2=None, cos3=None, cos4=None, cos5=None, cos6=None, cos7=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type cos_mutation: name, cos0, cos1, cos2, cos3, cos4, cos5, cos6, cos7
    :param cos_mutation: Keyword argument tuple.

    :type name: unicode
    :param name: **cos_mutation** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type cos0: long
    :param cos0: **cos_mutation** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type cos1: long
    :param cos1: **cos_mutation** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type cos2: long
    :param cos2: **cos_mutation** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type cos3: long
    :param cos3: **cos_mutation** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type cos4: long
    :param cos4: **cos_mutation** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type cos5: long
    :param cos5: **cos_mutation** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type cos6: long
    :param cos6: **cos_mutation** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type cos7: long
    :param cos7: **cos_mutation** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    **Instance Argument(s)**:

    :type cos0: long
    :param cos0: Keyword argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type cos1: long
    :param cos1: Keyword argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type cos2: long
    :param cos2: Keyword argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type cos3: long
    :param cos3: Keyword argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type cos4: long
    :param cos4: Keyword argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type cos5: long
    :param cos5: Keyword argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type cos6: long
    :param cos6: Keyword argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type cos7: long
    :param cos7: Keyword argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.qos.map_.cos_mutation', 'pybind.nos.v6_0_2c.brocade_qos', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.qos.map_.cos_mutation', 'pybind.nos.v7_0_1b.brocade_qos', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.qos.map_.cos_mutation', 'pybind.nos.v7_1_0.brocade_qos', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.qos.map_.cos_mutation', 'pybind.slxos.v16r_1_00b.brocade_qos_mls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'cos_mutation', 'keyval': 'name', 'extra_keyval': 'name, cos0, cos1, cos2, cos3, cos4, cos5, cos6, cos7'}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v7_1_0.qos.map_.cos_mutation": {"name": "name", "cos7": "cos7", "cos6": "cos6", "cos5": "cos5", "cos4": "cos4", "cos3": "cos3", "cos2": "cos2", "cos1": "cos1", "cos0": "cos0"}, "pybind.nos.v7_0_1b.qos.map_.cos_mutation": {"name": "name", "cos7": "cos7", "cos6": "cos6", "cos5": "cos5", "cos4": "cos4", "cos3": "cos3", "cos2": "cos2", "cos1": "cos1", "cos0": "cos0"}, "pybind.nos.v6_0_2c.qos.map_.cos_mutation": {"name": "name", "cos7": "cos7", "cos6": "cos6", "cos5": "cos5", "cos4": "cos4", "cos3": "cos3", "cos2": "cos2", "cos1": "cos1", "cos0": "cos0"}, "pybind.slxos.v16r_1_00b.qos.map_.cos_mutation": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cos_mutation=cos_mutation, cos0=cos0, cos1=cos1, cos2=cos2, cos3=cos3, cos4=cos4, cos5=cos5, cos6=cos6, cos7=cos7)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cos_mutation=cos_mutation, cos0=cos0, cos1=cos1, cos2=cos2, cos3=cos3, cos4=cos4, cos5=cos5, cos6=cos6, cos7=cos7)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_map_cos_mutation_cos0_delete(self, cos_mutation=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Instance Keyword Argument Tuple**:

    :type cos_mutation: name
    :param cos_mutation: Keyword argument tuple.

    :type name: unicode
    :param name: **cos_mutation** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.qos.map_.cos_mutation', 'pybind.nos.v6_0_2c.brocade_qos', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.qos.map_.cos_mutation', 'pybind.nos.v7_0_1b.brocade_qos', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.qos.map_.cos_mutation', 'pybind.nos.v7_1_0.brocade_qos', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'cos_mutation', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cos0'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cos_mutation=cos_mutation)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cos_mutation=cos_mutation)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_map_cos_mutation_cos1_delete(self, cos_mutation=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Instance Keyword Argument Tuple**:

    :type cos_mutation: name
    :param cos_mutation: Keyword argument tuple.

    :type name: unicode
    :param name: **cos_mutation** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.qos.map_.cos_mutation', 'pybind.nos.v6_0_2c.brocade_qos', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.qos.map_.cos_mutation', 'pybind.nos.v7_0_1b.brocade_qos', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.qos.map_.cos_mutation', 'pybind.nos.v7_1_0.brocade_qos', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'cos_mutation', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cos1'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cos_mutation=cos_mutation)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cos_mutation=cos_mutation)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_map_cos_mutation_cos2_delete(self, cos_mutation=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Instance Keyword Argument Tuple**:

    :type cos_mutation: name
    :param cos_mutation: Keyword argument tuple.

    :type name: unicode
    :param name: **cos_mutation** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.qos.map_.cos_mutation', 'pybind.nos.v6_0_2c.brocade_qos', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.qos.map_.cos_mutation', 'pybind.nos.v7_0_1b.brocade_qos', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.qos.map_.cos_mutation', 'pybind.nos.v7_1_0.brocade_qos', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'cos_mutation', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cos2'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cos_mutation=cos_mutation)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cos_mutation=cos_mutation)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_map_cos_mutation_cos3_delete(self, cos_mutation=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Instance Keyword Argument Tuple**:

    :type cos_mutation: name
    :param cos_mutation: Keyword argument tuple.

    :type name: unicode
    :param name: **cos_mutation** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.qos.map_.cos_mutation', 'pybind.nos.v6_0_2c.brocade_qos', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.qos.map_.cos_mutation', 'pybind.nos.v7_0_1b.brocade_qos', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.qos.map_.cos_mutation', 'pybind.nos.v7_1_0.brocade_qos', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'cos_mutation', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cos3'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cos_mutation=cos_mutation)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cos_mutation=cos_mutation)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_map_cos_mutation_cos4_delete(self, cos_mutation=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Instance Keyword Argument Tuple**:

    :type cos_mutation: name
    :param cos_mutation: Keyword argument tuple.

    :type name: unicode
    :param name: **cos_mutation** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.qos.map_.cos_mutation', 'pybind.nos.v6_0_2c.brocade_qos', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.qos.map_.cos_mutation', 'pybind.nos.v7_0_1b.brocade_qos', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.qos.map_.cos_mutation', 'pybind.nos.v7_1_0.brocade_qos', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'cos_mutation', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cos4'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cos_mutation=cos_mutation)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cos_mutation=cos_mutation)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_map_cos_mutation_cos5_delete(self, cos_mutation=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Instance Keyword Argument Tuple**:

    :type cos_mutation: name
    :param cos_mutation: Keyword argument tuple.

    :type name: unicode
    :param name: **cos_mutation** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.qos.map_.cos_mutation', 'pybind.nos.v6_0_2c.brocade_qos', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.qos.map_.cos_mutation', 'pybind.nos.v7_0_1b.brocade_qos', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.qos.map_.cos_mutation', 'pybind.nos.v7_1_0.brocade_qos', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'cos_mutation', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cos5'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cos_mutation=cos_mutation)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cos_mutation=cos_mutation)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_map_cos_mutation_cos6_delete(self, cos_mutation=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Instance Keyword Argument Tuple**:

    :type cos_mutation: name
    :param cos_mutation: Keyword argument tuple.

    :type name: unicode
    :param name: **cos_mutation** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.qos.map_.cos_mutation', 'pybind.nos.v6_0_2c.brocade_qos', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.qos.map_.cos_mutation', 'pybind.nos.v7_0_1b.brocade_qos', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.qos.map_.cos_mutation', 'pybind.nos.v7_1_0.brocade_qos', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'cos_mutation', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cos6'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cos_mutation=cos_mutation)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cos_mutation=cos_mutation)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_map_cos_mutation_cos7_delete(self, cos_mutation=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Instance Keyword Argument Tuple**:

    :type cos_mutation: name
    :param cos_mutation: Keyword argument tuple.

    :type name: unicode
    :param name: **cos_mutation** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.qos.map_.cos_mutation', 'pybind.nos.v6_0_2c.brocade_qos', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.qos.map_.cos_mutation', 'pybind.nos.v7_0_1b.brocade_qos', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.qos.map_.cos_mutation', 'pybind.nos.v7_1_0.brocade_qos', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'cos_mutation', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cos7'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cos_mutation=cos_mutation)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cos_mutation=cos_mutation)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_map_cos_mutation_map_delete(self, cos_mutation=None, cos_to_cos_mappings=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cos_mutation: name
    :param cos_mutation: Keyword argument tuple.

    :type name: unicode
    :param name: **cos_mutation** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    **Instance Keyword Argument Tuple**:

    :type cos_to_cos_mappings: from_cos
    :param cos_to_cos_mappings: Keyword argument tuple.

    :type from_cos: int
    :param from_cos: **cos_to_cos_mappings** tuple argument:  In CoS

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.qos.map_.cos_mutation', u'cos_mutation')]
    bindings_list = [('pybind.slxos.v16r_1_00b.qos.map_.cos_mutation.cos_to_cos_mappings', 'pybind.slxos.v16r_1_00b.brocade_qos_mls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'cos_to_cos_mappings', 'keyval': 'from_cos', 'extra_keyval': 'from_cos'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cos_mutation=cos_mutation, cos_to_cos_mappings=cos_to_cos_mappings)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cos_mutation=cos_mutation, cos_to_cos_mappings=cos_to_cos_mappings)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_map_cos_mutation_map_to_delete(self, cos_mutation=None, cos_to_cos_mappings=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cos_mutation: name
    :param cos_mutation: Keyword argument tuple.

    :type name: unicode
    :param name: **cos_mutation** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type cos_to_cos_mappings: from_cos
    :param cos_to_cos_mappings: Keyword argument tuple.

    :type from_cos: int
    :param from_cos: **cos_to_cos_mappings** tuple argument:  In CoS

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.qos.map_.cos_mutation', u'cos_mutation'), ('pybind.slxos.v16r_1_00b.qos.map_.cos_mutation.cos_to_cos_mappings', u'cos_to_cos_mappings')]
    bindings_list = [('pybind.slxos.v16r_1_00b.qos.map_.cos_mutation.cos_to_cos_mappings.to', 'pybind.slxos.v16r_1_00b.brocade_qos_mls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'from_cos', 'extra_keyval': 'from_cos'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'to_cos'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cos_mutation=cos_mutation, cos_to_cos_mappings=cos_to_cos_mappings)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cos_mutation=cos_mutation, cos_to_cos_mappings=cos_to_cos_mappings)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_map_cos_traffic_class_delete(self, cos_traffic_class=None, cos0=None, cos1=None, cos2=None, cos3=None, cos4=None, cos5=None, cos6=None, cos7=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type cos_traffic_class: name, cos0, cos1, cos2, cos3, cos4, cos5, cos6, cos7
    :param cos_traffic_class: Keyword argument tuple.

    :type name: unicode
    :param name: **cos_traffic_class** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type cos0: long
    :param cos0: **cos_traffic_class** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type cos1: long
    :param cos1: **cos_traffic_class** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type cos2: long
    :param cos2: **cos_traffic_class** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type cos3: long
    :param cos3: **cos_traffic_class** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type cos4: long
    :param cos4: **cos_traffic_class** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type cos5: long
    :param cos5: **cos_traffic_class** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type cos6: long
    :param cos6: **cos_traffic_class** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type cos7: long
    :param cos7: **cos_traffic_class** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    **Instance Argument(s)**:

    :type cos0: long
    :param cos0: Keyword argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type cos1: long
    :param cos1: Keyword argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type cos2: long
    :param cos2: Keyword argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type cos3: long
    :param cos3: Keyword argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type cos4: long
    :param cos4: Keyword argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type cos5: long
    :param cos5: Keyword argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type cos6: long
    :param cos6: Keyword argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type cos7: long
    :param cos7: Keyword argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.qos.map_.cos_traffic_class', 'pybind.nos.v6_0_2c.brocade_qos', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.qos.map_.cos_traffic_class', 'pybind.nos.v7_0_1b.brocade_qos', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.qos.map_.cos_traffic_class', 'pybind.nos.v7_1_0.brocade_qos', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.qos.map_.cos_traffic_class', 'pybind.slxos.v16r_1_00b.brocade_qos_mls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'cos_traffic_class', 'keyval': 'name', 'extra_keyval': 'name, cos0, cos1, cos2, cos3, cos4, cos5, cos6, cos7'}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v7_1_0.qos.map_.cos_traffic_class": {"name": "name", "cos7": "cos7", "cos6": "cos6", "cos5": "cos5", "cos4": "cos4", "cos3": "cos3", "cos2": "cos2", "cos1": "cos1", "cos0": "cos0"}, "pybind.slxos.v16r_1_00b.qos.map_.cos_traffic_class": {}, "pybind.nos.v6_0_2c.qos.map_.cos_traffic_class": {"name": "name", "cos7": "cos7", "cos6": "cos6", "cos5": "cos5", "cos4": "cos4", "cos3": "cos3", "cos2": "cos2", "cos1": "cos1", "cos0": "cos0"}, "pybind.nos.v7_0_1b.qos.map_.cos_traffic_class": {"name": "name", "cos7": "cos7", "cos6": "cos6", "cos5": "cos5", "cos4": "cos4", "cos3": "cos3", "cos2": "cos2", "cos1": "cos1", "cos0": "cos0"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cos_traffic_class=cos_traffic_class, cos0=cos0, cos1=cos1, cos2=cos2, cos3=cos3, cos4=cos4, cos5=cos5, cos6=cos6, cos7=cos7)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cos_traffic_class=cos_traffic_class, cos0=cos0, cos1=cos1, cos2=cos2, cos3=cos3, cos4=cos4, cos5=cos5, cos6=cos6, cos7=cos7)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_map_cos_traffic_class_cos0_delete(self, cos_traffic_class=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Instance Keyword Argument Tuple**:

    :type cos_traffic_class: name
    :param cos_traffic_class: Keyword argument tuple.

    :type name: unicode
    :param name: **cos_traffic_class** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.qos.map_.cos_traffic_class', 'pybind.nos.v6_0_2c.brocade_qos', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.qos.map_.cos_traffic_class', 'pybind.nos.v7_0_1b.brocade_qos', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.qos.map_.cos_traffic_class', 'pybind.nos.v7_1_0.brocade_qos', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'cos_traffic_class', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cos0'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cos_traffic_class=cos_traffic_class)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cos_traffic_class=cos_traffic_class)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_map_cos_traffic_class_cos1_delete(self, cos_traffic_class=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Instance Keyword Argument Tuple**:

    :type cos_traffic_class: name
    :param cos_traffic_class: Keyword argument tuple.

    :type name: unicode
    :param name: **cos_traffic_class** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.qos.map_.cos_traffic_class', 'pybind.nos.v6_0_2c.brocade_qos', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.qos.map_.cos_traffic_class', 'pybind.nos.v7_0_1b.brocade_qos', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.qos.map_.cos_traffic_class', 'pybind.nos.v7_1_0.brocade_qos', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'cos_traffic_class', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cos1'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cos_traffic_class=cos_traffic_class)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cos_traffic_class=cos_traffic_class)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_map_cos_traffic_class_cos2_delete(self, cos_traffic_class=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Instance Keyword Argument Tuple**:

    :type cos_traffic_class: name
    :param cos_traffic_class: Keyword argument tuple.

    :type name: unicode
    :param name: **cos_traffic_class** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.qos.map_.cos_traffic_class', 'pybind.nos.v6_0_2c.brocade_qos', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.qos.map_.cos_traffic_class', 'pybind.nos.v7_0_1b.brocade_qos', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.qos.map_.cos_traffic_class', 'pybind.nos.v7_1_0.brocade_qos', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'cos_traffic_class', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cos2'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cos_traffic_class=cos_traffic_class)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cos_traffic_class=cos_traffic_class)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_map_cos_traffic_class_cos3_delete(self, cos_traffic_class=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Instance Keyword Argument Tuple**:

    :type cos_traffic_class: name
    :param cos_traffic_class: Keyword argument tuple.

    :type name: unicode
    :param name: **cos_traffic_class** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.qos.map_.cos_traffic_class', 'pybind.nos.v6_0_2c.brocade_qos', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.qos.map_.cos_traffic_class', 'pybind.nos.v7_0_1b.brocade_qos', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.qos.map_.cos_traffic_class', 'pybind.nos.v7_1_0.brocade_qos', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'cos_traffic_class', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cos3'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cos_traffic_class=cos_traffic_class)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cos_traffic_class=cos_traffic_class)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_map_cos_traffic_class_cos4_delete(self, cos_traffic_class=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Instance Keyword Argument Tuple**:

    :type cos_traffic_class: name
    :param cos_traffic_class: Keyword argument tuple.

    :type name: unicode
    :param name: **cos_traffic_class** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.qos.map_.cos_traffic_class', 'pybind.nos.v6_0_2c.brocade_qos', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.qos.map_.cos_traffic_class', 'pybind.nos.v7_0_1b.brocade_qos', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.qos.map_.cos_traffic_class', 'pybind.nos.v7_1_0.brocade_qos', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'cos_traffic_class', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cos4'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cos_traffic_class=cos_traffic_class)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cos_traffic_class=cos_traffic_class)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_map_cos_traffic_class_cos5_delete(self, cos_traffic_class=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Instance Keyword Argument Tuple**:

    :type cos_traffic_class: name
    :param cos_traffic_class: Keyword argument tuple.

    :type name: unicode
    :param name: **cos_traffic_class** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.qos.map_.cos_traffic_class', 'pybind.nos.v6_0_2c.brocade_qos', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.qos.map_.cos_traffic_class', 'pybind.nos.v7_0_1b.brocade_qos', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.qos.map_.cos_traffic_class', 'pybind.nos.v7_1_0.brocade_qos', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'cos_traffic_class', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cos5'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cos_traffic_class=cos_traffic_class)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cos_traffic_class=cos_traffic_class)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_map_cos_traffic_class_cos6_delete(self, cos_traffic_class=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Instance Keyword Argument Tuple**:

    :type cos_traffic_class: name
    :param cos_traffic_class: Keyword argument tuple.

    :type name: unicode
    :param name: **cos_traffic_class** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.qos.map_.cos_traffic_class', 'pybind.nos.v6_0_2c.brocade_qos', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.qos.map_.cos_traffic_class', 'pybind.nos.v7_0_1b.brocade_qos', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.qos.map_.cos_traffic_class', 'pybind.nos.v7_1_0.brocade_qos', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'cos_traffic_class', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cos6'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cos_traffic_class=cos_traffic_class)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cos_traffic_class=cos_traffic_class)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_map_cos_traffic_class_cos7_delete(self, cos_traffic_class=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Instance Keyword Argument Tuple**:

    :type cos_traffic_class: name
    :param cos_traffic_class: Keyword argument tuple.

    :type name: unicode
    :param name: **cos_traffic_class** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.qos.map_.cos_traffic_class', 'pybind.nos.v6_0_2c.brocade_qos', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.qos.map_.cos_traffic_class', 'pybind.nos.v7_0_1b.brocade_qos', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.qos.map_.cos_traffic_class', 'pybind.nos.v7_1_0.brocade_qos', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'cos_traffic_class', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cos7'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cos_traffic_class=cos_traffic_class)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cos_traffic_class=cos_traffic_class)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_map_cos_traffic_class_map_delete(self, cos_traffic_class=None, cos_to_tc_dp_mappings=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cos_traffic_class: name
    :param cos_traffic_class: Keyword argument tuple.

    :type name: unicode
    :param name: **cos_traffic_class** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    **Instance Keyword Argument Tuple**:

    :type cos_to_tc_dp_mappings: from_cos
    :param cos_to_tc_dp_mappings: Keyword argument tuple.

    :type from_cos: int
    :param from_cos: **cos_to_tc_dp_mappings** tuple argument:  In CoS

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.qos.map_.cos_traffic_class', u'cos_traffic_class')]
    bindings_list = [('pybind.slxos.v16r_1_00b.qos.map_.cos_traffic_class.cos_to_tc_dp_mappings', 'pybind.slxos.v16r_1_00b.brocade_qos_mls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'cos_to_tc_dp_mappings', 'keyval': 'from_cos', 'extra_keyval': 'from_cos'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cos_traffic_class=cos_traffic_class, cos_to_tc_dp_mappings=cos_to_tc_dp_mappings)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cos_traffic_class=cos_traffic_class, cos_to_tc_dp_mappings=cos_to_tc_dp_mappings)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_map_cos_traffic_class_map_to_delete(self, cos_traffic_class=None, cos_to_tc_dp_mappings=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cos_traffic_class: name
    :param cos_traffic_class: Keyword argument tuple.

    :type name: unicode
    :param name: **cos_traffic_class** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type cos_to_tc_dp_mappings: from_cos
    :param cos_to_tc_dp_mappings: Keyword argument tuple.

    :type from_cos: int
    :param from_cos: **cos_to_tc_dp_mappings** tuple argument:  In CoS

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.qos.map_.cos_traffic_class', u'cos_traffic_class'), ('pybind.slxos.v16r_1_00b.qos.map_.cos_traffic_class.cos_to_tc_dp_mappings', u'cos_to_tc_dp_mappings')]
    bindings_list = [('pybind.slxos.v16r_1_00b.qos.map_.cos_traffic_class.cos_to_tc_dp_mappings.to', 'pybind.slxos.v16r_1_00b.brocade_qos_mls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'from_cos', 'extra_keyval': 'from_cos'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'to_traffic_class, to_drop_precedence'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cos_traffic_class=cos_traffic_class, cos_to_tc_dp_mappings=cos_to_tc_dp_mappings)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cos_traffic_class=cos_traffic_class, cos_to_tc_dp_mappings=cos_to_tc_dp_mappings)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_map_cos_traffic_class_map_to_drop_precedence_delete(self, cos_traffic_class=None, cos_to_tc_dp_mappings=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cos_traffic_class: name
    :param cos_traffic_class: Keyword argument tuple.

    :type name: unicode
    :param name: **cos_traffic_class** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type cos_to_tc_dp_mappings: from_cos
    :param cos_to_tc_dp_mappings: Keyword argument tuple.

    :type from_cos: int
    :param from_cos: **cos_to_tc_dp_mappings** tuple argument:  In CoS

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.qos.map_.cos_traffic_class', u'cos_traffic_class'), ('pybind.slxos.v16r_1_00b.qos.map_.cos_traffic_class.cos_to_tc_dp_mappings', u'cos_to_tc_dp_mappings')]
    bindings_list = [('pybind.slxos.v16r_1_00b.qos.map_.cos_traffic_class.cos_to_tc_dp_mappings.to', 'pybind.slxos.v16r_1_00b.brocade_qos_mls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'from_cos', 'extra_keyval': 'from_cos'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'drop-precedence'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cos_traffic_class=cos_traffic_class, cos_to_tc_dp_mappings=cos_to_tc_dp_mappings)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cos_traffic_class=cos_traffic_class, cos_to_tc_dp_mappings=cos_to_tc_dp_mappings)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_map_cos_traffic_class_map_to_traffic_class_delete(self, cos_traffic_class=None, cos_to_tc_dp_mappings=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cos_traffic_class: name
    :param cos_traffic_class: Keyword argument tuple.

    :type name: unicode
    :param name: **cos_traffic_class** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type cos_to_tc_dp_mappings: from_cos
    :param cos_to_tc_dp_mappings: Keyword argument tuple.

    :type from_cos: int
    :param from_cos: **cos_to_tc_dp_mappings** tuple argument:  In CoS

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.qos.map_.cos_traffic_class', u'cos_traffic_class'), ('pybind.slxos.v16r_1_00b.qos.map_.cos_traffic_class.cos_to_tc_dp_mappings', u'cos_to_tc_dp_mappings')]
    bindings_list = [('pybind.slxos.v16r_1_00b.qos.map_.cos_traffic_class.cos_to_tc_dp_mappings.to', 'pybind.slxos.v16r_1_00b.brocade_qos_mls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'from_cos', 'extra_keyval': 'from_cos'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'traffic-class'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cos_traffic_class=cos_traffic_class, cos_to_tc_dp_mappings=cos_to_tc_dp_mappings)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cos_traffic_class=cos_traffic_class, cos_to_tc_dp_mappings=cos_to_tc_dp_mappings)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_map_dscp_cos_delete(self, dscp_cos=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type dscp_cos: dscp_cos_map_name
    :param dscp_cos: Keyword argument tuple.

    :type dscp_cos_map_name: unicode
    :param dscp_cos_map_name: **dscp_cos** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.qos.map_.dscp_cos', 'pybind.nos.v6_0_2c.brocade_qos', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.qos.map_.dscp_cos', 'pybind.nos.v7_0_1b.brocade_qos', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.qos.map_.dscp_cos', 'pybind.nos.v7_1_0.brocade_qos', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.qos.map_.dscp_cos', 'pybind.slxos.v16r_1_00b.brocade_qos_mls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'dscp_cos', 'keyval': 'dscp_cos_map_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dscp_cos=dscp_cos)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dscp_cos=dscp_cos)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_map_dscp_cos_map_delete(self, dscp_cos=None, dscp_to_cos_mapping=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type dscp_cos: dscp_cos_map_name
    :param dscp_cos: Keyword argument tuple.

    :type dscp_cos_map_name: unicode
    :param dscp_cos_map_name: **dscp_cos** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    **Instance Keyword Argument Tuple**:

    :type dscp_to_cos_mapping: dscp_in_values
    :param dscp_to_cos_mapping: Keyword argument tuple.

    :type dscp_in_values: unicode
    :param dscp_in_values: **dscp_to_cos_mapping** tuple argument:  In DSCP

        * pattern restriction: ::

            '(([0-9])|([1-5][0-9])|(6[0-3]))(-(([0-9])|([1-5]'
            '[0-9])|(6[0-3])))?((,(([0-9])|([1-5][0-9])|(6[0-'
            '3]))(-(([0-9])|([1-5][0-9])|(6[0-3])))?)?)*'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.qos.map_.dscp_cos', u'dscp_cos')]
    bindings_list = [('pybind.slxos.v16r_1_00b.qos.map_.dscp_cos.dscp_to_cos_mapping', 'pybind.slxos.v16r_1_00b.brocade_qos_mls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dscp_cos_map_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'dscp_to_cos_mapping', 'keyval': 'dscp_in_values', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dscp_cos=dscp_cos, dscp_to_cos_mapping=dscp_to_cos_mapping)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dscp_cos=dscp_cos, dscp_to_cos_mapping=dscp_to_cos_mapping)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_map_dscp_cos_map_to_delete(self, dscp_cos=None, dscp_to_cos_mapping=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type dscp_cos: dscp_cos_map_name
    :param dscp_cos: Keyword argument tuple.

    :type dscp_cos_map_name: unicode
    :param dscp_cos_map_name: **dscp_cos** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type dscp_to_cos_mapping: dscp_in_values
    :param dscp_to_cos_mapping: Keyword argument tuple.

    :type dscp_in_values: unicode
    :param dscp_in_values: **dscp_to_cos_mapping** tuple argument:  In DSCP

        * pattern restriction: ::

            '(([0-9])|([1-5][0-9])|(6[0-3]))(-(([0-9])|([1-5]'
            '[0-9])|(6[0-3])))?((,(([0-9])|([1-5][0-9])|(6[0-'
            '3]))(-(([0-9])|([1-5][0-9])|(6[0-3])))?)?)*'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.qos.map_.dscp_cos', u'dscp_cos'), ('pybind.slxos.v16r_1_00b.qos.map_.dscp_cos.dscp_to_cos_mapping', u'dscp_to_cos_mapping')]
    bindings_list = [('pybind.slxos.v16r_1_00b.qos.map_.dscp_cos.dscp_to_cos_mapping.to', 'pybind.slxos.v16r_1_00b.brocade_qos_mls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dscp_cos_map_name', 'extra_keyval': ''}, {'keyval': 'dscp_in_values', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'to_value'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dscp_cos=dscp_cos, dscp_to_cos_mapping=dscp_to_cos_mapping)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dscp_cos=dscp_cos, dscp_to_cos_mapping=dscp_to_cos_mapping)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_map_dscp_cos_map_to_cos_delete(self, dscp_cos=None, dscp_to_cos_mapping=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type dscp_cos: dscp_cos_map_name
    :param dscp_cos: Keyword argument tuple.

    :type dscp_cos_map_name: unicode
    :param dscp_cos_map_name: **dscp_cos** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type dscp_to_cos_mapping: dscp_in_values
    :param dscp_to_cos_mapping: Keyword argument tuple.

    :type dscp_in_values: unicode
    :param dscp_in_values: **dscp_to_cos_mapping** tuple argument:  In DSCP

        * pattern restriction: ::

            '(([0-9])|([1-5][0-9])|(6[0-3]))(-(([0-9])|([1-5]'
            '[0-9])|(6[0-3])))?((,(([0-9])|([1-5][0-9])|(6[0-'
            '3]))(-(([0-9])|([1-5][0-9])|(6[0-3])))?)?)*'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.qos.map_.dscp_cos', u'dscp_cos'), ('pybind.slxos.v16r_1_00b.qos.map_.dscp_cos.dscp_to_cos_mapping', u'dscp_to_cos_mapping')]
    bindings_list = [('pybind.slxos.v16r_1_00b.qos.map_.dscp_cos.dscp_to_cos_mapping.to', 'pybind.slxos.v16r_1_00b.brocade_qos_mls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dscp_cos_map_name', 'extra_keyval': ''}, {'keyval': 'dscp_in_values', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cos'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dscp_cos=dscp_cos, dscp_to_cos_mapping=dscp_to_cos_mapping)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dscp_cos=dscp_cos, dscp_to_cos_mapping=dscp_to_cos_mapping)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_map_dscp_cos_mark_delete(self, dscp_cos=None, mark=None, to=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type dscp_cos: dscp_cos_map_name
    :param dscp_cos: Keyword argument tuple.

    :type dscp_cos_map_name: unicode
    :param dscp_cos_map_name: **dscp_cos** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    **Instance Keyword Argument Tuple**:

    :type mark: dscp_in_values
    :param mark: Keyword argument tuple.

    :type dscp_in_values: unicode
    :param dscp_in_values: **mark** tuple argument:  0-63;;Incoming DSCP

        * pattern restriction: ::

            '(([0-9])|([1-5][0-9])|(6[0-3]))(-(([0-9])|([1-5]'
            '[0-9])|(6[0-3])))?((,(([0-9])|([1-5][0-9])|(6[0-'
            '3]))(-(([0-9])|([1-5][0-9])|(6[0-3])))?)?)*'

    **Instance Argument(s)**:

    :type to: long
    :param to: Keyword argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.qos.map_.dscp_cos', u'dscp_cos'), ('pybind.nos.v7_0_1b.qos.map_.dscp_cos', u'dscp_cos'), ('pybind.nos.v7_1_0.qos.map_.dscp_cos', u'dscp_cos')]
    bindings_list = [('pybind.nos.v6_0_2c.qos.map_.dscp_cos.mark', 'pybind.nos.v6_0_2c.brocade_qos', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.qos.map_.dscp_cos.mark', 'pybind.nos.v7_0_1b.brocade_qos', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.qos.map_.dscp_cos.mark', 'pybind.nos.v7_1_0.brocade_qos', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dscp_cos_map_name', 'extra_keyval': ''}, {'keyval': 'dscp_cos_map_name', 'extra_keyval': ''}, {'keyval': 'dscp_cos_map_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mark', 'keyval': 'dscp_in_values', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dscp_cos=dscp_cos, mark=mark, to=to)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dscp_cos=dscp_cos, mark=mark, to=to)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_map_dscp_cos_mark_to_delete(self, dscp_cos=None, mark=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type dscp_cos: dscp_cos_map_name
    :param dscp_cos: Keyword argument tuple.

    :type dscp_cos_map_name: unicode
    :param dscp_cos_map_name: **dscp_cos** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    **Instance Keyword Argument Tuple**:

    :type mark: dscp_in_values
    :param mark: Keyword argument tuple.

    :type dscp_in_values: unicode
    :param dscp_in_values: **mark** tuple argument:  0-63;;Incoming DSCP

        * pattern restriction: ::

            '(([0-9])|([1-5][0-9])|(6[0-3]))(-(([0-9])|([1-5]'
            '[0-9])|(6[0-3])))?((,(([0-9])|([1-5][0-9])|(6[0-'
            '3]))(-(([0-9])|([1-5][0-9])|(6[0-3])))?)?)*'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.qos.map_.dscp_cos', u'dscp_cos'), ('pybind.nos.v7_0_1b.qos.map_.dscp_cos', u'dscp_cos'), ('pybind.nos.v7_1_0.qos.map_.dscp_cos', u'dscp_cos')]
    bindings_list = [('pybind.nos.v6_0_2c.qos.map_.dscp_cos.mark', 'pybind.nos.v6_0_2c.brocade_qos', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.qos.map_.dscp_cos.mark', 'pybind.nos.v7_0_1b.brocade_qos', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.qos.map_.dscp_cos.mark', 'pybind.nos.v7_1_0.brocade_qos', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dscp_cos_map_name', 'extra_keyval': ''}, {'keyval': 'dscp_cos_map_name', 'extra_keyval': ''}, {'keyval': 'dscp_cos_map_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mark', 'keyval': 'dscp_in_values', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'to'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dscp_cos=dscp_cos, mark=mark)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dscp_cos=dscp_cos, mark=mark)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_map_dscp_mutation_delete(self, dscp_mutation=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type dscp_mutation: dscp_mutation_map_name
    :param dscp_mutation: Keyword argument tuple.

    :type dscp_mutation_map_name: unicode
    :param dscp_mutation_map_name: **dscp_mutation** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.qos.map_.dscp_mutation', 'pybind.nos.v6_0_2c.brocade_qos', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.qos.map_.dscp_mutation', 'pybind.nos.v7_0_1b.brocade_qos', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.qos.map_.dscp_mutation', 'pybind.nos.v7_1_0.brocade_qos', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.qos.map_.dscp_mutation', 'pybind.slxos.v16r_1_00b.brocade_qos_mls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'dscp_mutation', 'keyval': 'dscp_mutation_map_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dscp_mutation=dscp_mutation)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dscp_mutation=dscp_mutation)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_map_dscp_mutation_map_delete(self, dscp_mutation=None, dscp_to_dscp_mapping=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type dscp_mutation: dscp_mutation_map_name
    :param dscp_mutation: Keyword argument tuple.

    :type dscp_mutation_map_name: unicode
    :param dscp_mutation_map_name: **dscp_mutation** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    **Instance Keyword Argument Tuple**:

    :type dscp_to_dscp_mapping: dscp_in_values
    :param dscp_to_dscp_mapping: Keyword argument tuple.

    :type dscp_in_values: unicode
    :param dscp_in_values: **dscp_to_dscp_mapping** tuple argument:  In DSCP

        * pattern restriction: ::

            '(([0-9])|([1-5][0-9])|(6[0-3]))(-(([0-9])|([1-5]'
            '[0-9])|(6[0-3])))?((,(([0-9])|([1-5][0-9])|(6[0-'
            '3]))(-(([0-9])|([1-5][0-9])|(6[0-3])))?)?)*'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.qos.map_.dscp_mutation', u'dscp_mutation')]
    bindings_list = [('pybind.slxos.v16r_1_00b.qos.map_.dscp_mutation.dscp_to_dscp_mapping', 'pybind.slxos.v16r_1_00b.brocade_qos_mls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dscp_mutation_map_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'dscp_to_dscp_mapping', 'keyval': 'dscp_in_values', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dscp_mutation=dscp_mutation, dscp_to_dscp_mapping=dscp_to_dscp_mapping)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dscp_mutation=dscp_mutation, dscp_to_dscp_mapping=dscp_to_dscp_mapping)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_map_dscp_mutation_map_to_delete(self, dscp_mutation=None, dscp_to_dscp_mapping=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type dscp_mutation: dscp_mutation_map_name
    :param dscp_mutation: Keyword argument tuple.

    :type dscp_mutation_map_name: unicode
    :param dscp_mutation_map_name: **dscp_mutation** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type dscp_to_dscp_mapping: dscp_in_values
    :param dscp_to_dscp_mapping: Keyword argument tuple.

    :type dscp_in_values: unicode
    :param dscp_in_values: **dscp_to_dscp_mapping** tuple argument:  In DSCP

        * pattern restriction: ::

            '(([0-9])|([1-5][0-9])|(6[0-3]))(-(([0-9])|([1-5]'
            '[0-9])|(6[0-3])))?((,(([0-9])|([1-5][0-9])|(6[0-'
            '3]))(-(([0-9])|([1-5][0-9])|(6[0-3])))?)?)*'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.qos.map_.dscp_mutation', u'dscp_mutation'), ('pybind.slxos.v16r_1_00b.qos.map_.dscp_mutation.dscp_to_dscp_mapping', u'dscp_to_dscp_mapping')]
    bindings_list = [('pybind.slxos.v16r_1_00b.qos.map_.dscp_mutation.dscp_to_dscp_mapping.to', 'pybind.slxos.v16r_1_00b.brocade_qos_mls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dscp_mutation_map_name', 'extra_keyval': ''}, {'keyval': 'dscp_in_values', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'to_value'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dscp_mutation=dscp_mutation, dscp_to_dscp_mapping=dscp_to_dscp_mapping)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dscp_mutation=dscp_mutation, dscp_to_dscp_mapping=dscp_to_dscp_mapping)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_map_dscp_mutation_mark_delete(self, dscp_mutation=None, mark=None, to=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type dscp_mutation: dscp_mutation_map_name
    :param dscp_mutation: Keyword argument tuple.

    :type dscp_mutation_map_name: unicode
    :param dscp_mutation_map_name: **dscp_mutation** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    **Instance Keyword Argument Tuple**:

    :type mark: dscp_in_values
    :param mark: Keyword argument tuple.

    :type dscp_in_values: unicode
    :param dscp_in_values: **mark** tuple argument:  0-63;;Incoming DSCP

        * pattern restriction: ::

            '(([0-9])|([1-5][0-9])|(6[0-3]))(-(([0-9])|([1-5]'
            '[0-9])|(6[0-3])))?((,(([0-9])|([1-5][0-9])|(6[0-'
            '3]))(-(([0-9])|([1-5][0-9])|(6[0-3])))?)?)*'

    **Instance Argument(s)**:

    :type to: long
    :param to: Keyword argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.qos.map_.dscp_mutation', u'dscp_mutation'), ('pybind.nos.v6_0_2c.qos.map_.dscp_mutation', u'dscp_mutation'), ('pybind.nos.v7_0_1b.qos.map_.dscp_mutation', u'dscp_mutation')]
    bindings_list = [('pybind.nos.v6_0_2c.qos.map_.dscp_mutation.mark', 'pybind.nos.v6_0_2c.brocade_qos', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.qos.map_.dscp_mutation.mark', 'pybind.nos.v7_0_1b.brocade_qos', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.qos.map_.dscp_mutation.mark', 'pybind.nos.v7_1_0.brocade_qos', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dscp_mutation_map_name', 'extra_keyval': ''}, {'keyval': 'dscp_mutation_map_name', 'extra_keyval': ''}, {'keyval': 'dscp_mutation_map_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mark', 'keyval': 'dscp_in_values', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dscp_mutation=dscp_mutation, mark=mark, to=to)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dscp_mutation=dscp_mutation, mark=mark, to=to)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_map_dscp_mutation_mark_to_delete(self, dscp_mutation=None, mark=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type dscp_mutation: dscp_mutation_map_name
    :param dscp_mutation: Keyword argument tuple.

    :type dscp_mutation_map_name: unicode
    :param dscp_mutation_map_name: **dscp_mutation** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    **Instance Keyword Argument Tuple**:

    :type mark: dscp_in_values
    :param mark: Keyword argument tuple.

    :type dscp_in_values: unicode
    :param dscp_in_values: **mark** tuple argument:  0-63;;Incoming DSCP

        * pattern restriction: ::

            '(([0-9])|([1-5][0-9])|(6[0-3]))(-(([0-9])|([1-5]'
            '[0-9])|(6[0-3])))?((,(([0-9])|([1-5][0-9])|(6[0-'
            '3]))(-(([0-9])|([1-5][0-9])|(6[0-3])))?)?)*'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.qos.map_.dscp_mutation', u'dscp_mutation'), ('pybind.nos.v6_0_2c.qos.map_.dscp_mutation', u'dscp_mutation'), ('pybind.nos.v7_0_1b.qos.map_.dscp_mutation', u'dscp_mutation')]
    bindings_list = [('pybind.nos.v6_0_2c.qos.map_.dscp_mutation.mark', 'pybind.nos.v6_0_2c.brocade_qos', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.qos.map_.dscp_mutation.mark', 'pybind.nos.v7_0_1b.brocade_qos', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.qos.map_.dscp_mutation.mark', 'pybind.nos.v7_1_0.brocade_qos', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dscp_mutation_map_name', 'extra_keyval': ''}, {'keyval': 'dscp_mutation_map_name', 'extra_keyval': ''}, {'keyval': 'dscp_mutation_map_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mark', 'keyval': 'dscp_in_values', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'to'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dscp_mutation=dscp_mutation, mark=mark)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dscp_mutation=dscp_mutation, mark=mark)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_map_dscp_traffic_class_delete(self, dscp_traffic_class=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type dscp_traffic_class: dscp_traffic_class_map_name
    :param dscp_traffic_class: Keyword argument tuple.

    :type dscp_traffic_class_map_name: unicode
    :param dscp_traffic_class_map_name: **dscp_traffic_class** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.qos.map_.dscp_traffic_class', 'pybind.nos.v6_0_2c.brocade_qos', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.qos.map_.dscp_traffic_class', 'pybind.nos.v7_0_1b.brocade_qos', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.qos.map_.dscp_traffic_class', 'pybind.nos.v7_1_0.brocade_qos', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.qos.map_.dscp_traffic_class', 'pybind.slxos.v16r_1_00b.brocade_qos_mls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'dscp_traffic_class', 'keyval': 'dscp_traffic_class_map_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dscp_traffic_class=dscp_traffic_class)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dscp_traffic_class=dscp_traffic_class)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_map_dscp_traffic_class_map_delete(self, dscp_traffic_class=None, dscp_to_tc_dp_mapping=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type dscp_traffic_class: dscp_traffic_class_map_name
    :param dscp_traffic_class: Keyword argument tuple.

    :type dscp_traffic_class_map_name: unicode
    :param dscp_traffic_class_map_name: **dscp_traffic_class** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    **Instance Keyword Argument Tuple**:

    :type dscp_to_tc_dp_mapping: dscp_in_values
    :param dscp_to_tc_dp_mapping: Keyword argument tuple.

    :type dscp_in_values: unicode
    :param dscp_in_values: **dscp_to_tc_dp_mapping** tuple argument:  In DSCP

        * pattern restriction: ::

            '(([0-9])|([1-5][0-9])|(6[0-3]))(-(([0-9])|([1-5]'
            '[0-9])|(6[0-3])))?((,(([0-9])|([1-5][0-9])|(6[0-'
            '3]))(-(([0-9])|([1-5][0-9])|(6[0-3])))?)?)*'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.qos.map_.dscp_traffic_class', u'dscp_traffic_class')]
    bindings_list = [('pybind.slxos.v16r_1_00b.qos.map_.dscp_traffic_class.dscp_to_tc_dp_mapping', 'pybind.slxos.v16r_1_00b.brocade_qos_mls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dscp_traffic_class_map_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'dscp_to_tc_dp_mapping', 'keyval': 'dscp_in_values', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dscp_traffic_class=dscp_traffic_class, dscp_to_tc_dp_mapping=dscp_to_tc_dp_mapping)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dscp_traffic_class=dscp_traffic_class, dscp_to_tc_dp_mapping=dscp_to_tc_dp_mapping)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_map_dscp_traffic_class_map_to_delete(self, dscp_traffic_class=None, dscp_to_tc_dp_mapping=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type dscp_traffic_class: dscp_traffic_class_map_name
    :param dscp_traffic_class: Keyword argument tuple.

    :type dscp_traffic_class_map_name: unicode
    :param dscp_traffic_class_map_name: **dscp_traffic_class** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type dscp_to_tc_dp_mapping: dscp_in_values
    :param dscp_to_tc_dp_mapping: Keyword argument tuple.

    :type dscp_in_values: unicode
    :param dscp_in_values: **dscp_to_tc_dp_mapping** tuple argument:  In DSCP

        * pattern restriction: ::

            '(([0-9])|([1-5][0-9])|(6[0-3]))(-(([0-9])|([1-5]'
            '[0-9])|(6[0-3])))?((,(([0-9])|([1-5][0-9])|(6[0-'
            '3]))(-(([0-9])|([1-5][0-9])|(6[0-3])))?)?)*'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.qos.map_.dscp_traffic_class', u'dscp_traffic_class'), ('pybind.slxos.v16r_1_00b.qos.map_.dscp_traffic_class.dscp_to_tc_dp_mapping', u'dscp_to_tc_dp_mapping')]
    bindings_list = [('pybind.slxos.v16r_1_00b.qos.map_.dscp_traffic_class.dscp_to_tc_dp_mapping.to', 'pybind.slxos.v16r_1_00b.brocade_qos_mls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dscp_traffic_class_map_name', 'extra_keyval': ''}, {'keyval': 'dscp_in_values', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'to_value, to_drop_precedence'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dscp_traffic_class=dscp_traffic_class, dscp_to_tc_dp_mapping=dscp_to_tc_dp_mapping)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dscp_traffic_class=dscp_traffic_class, dscp_to_tc_dp_mapping=dscp_to_tc_dp_mapping)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_map_dscp_traffic_class_map_to_drop_precedence_delete(self, dscp_traffic_class=None, dscp_to_tc_dp_mapping=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type dscp_traffic_class: dscp_traffic_class_map_name
    :param dscp_traffic_class: Keyword argument tuple.

    :type dscp_traffic_class_map_name: unicode
    :param dscp_traffic_class_map_name: **dscp_traffic_class** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type dscp_to_tc_dp_mapping: dscp_in_values
    :param dscp_to_tc_dp_mapping: Keyword argument tuple.

    :type dscp_in_values: unicode
    :param dscp_in_values: **dscp_to_tc_dp_mapping** tuple argument:  In DSCP

        * pattern restriction: ::

            '(([0-9])|([1-5][0-9])|(6[0-3]))(-(([0-9])|([1-5]'
            '[0-9])|(6[0-3])))?((,(([0-9])|([1-5][0-9])|(6[0-'
            '3]))(-(([0-9])|([1-5][0-9])|(6[0-3])))?)?)*'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.qos.map_.dscp_traffic_class', u'dscp_traffic_class'), ('pybind.slxos.v16r_1_00b.qos.map_.dscp_traffic_class.dscp_to_tc_dp_mapping', u'dscp_to_tc_dp_mapping')]
    bindings_list = [('pybind.slxos.v16r_1_00b.qos.map_.dscp_traffic_class.dscp_to_tc_dp_mapping.to', 'pybind.slxos.v16r_1_00b.brocade_qos_mls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dscp_traffic_class_map_name', 'extra_keyval': ''}, {'keyval': 'dscp_in_values', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'drop-precedence'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dscp_traffic_class=dscp_traffic_class, dscp_to_tc_dp_mapping=dscp_to_tc_dp_mapping)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dscp_traffic_class=dscp_traffic_class, dscp_to_tc_dp_mapping=dscp_to_tc_dp_mapping)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_map_dscp_traffic_class_map_to_traffic_class_delete(self, dscp_traffic_class=None, dscp_to_tc_dp_mapping=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type dscp_traffic_class: dscp_traffic_class_map_name
    :param dscp_traffic_class: Keyword argument tuple.

    :type dscp_traffic_class_map_name: unicode
    :param dscp_traffic_class_map_name: **dscp_traffic_class** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type dscp_to_tc_dp_mapping: dscp_in_values
    :param dscp_to_tc_dp_mapping: Keyword argument tuple.

    :type dscp_in_values: unicode
    :param dscp_in_values: **dscp_to_tc_dp_mapping** tuple argument:  In DSCP

        * pattern restriction: ::

            '(([0-9])|([1-5][0-9])|(6[0-3]))(-(([0-9])|([1-5]'
            '[0-9])|(6[0-3])))?((,(([0-9])|([1-5][0-9])|(6[0-'
            '3]))(-(([0-9])|([1-5][0-9])|(6[0-3])))?)?)*'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.qos.map_.dscp_traffic_class', u'dscp_traffic_class'), ('pybind.slxos.v16r_1_00b.qos.map_.dscp_traffic_class.dscp_to_tc_dp_mapping', u'dscp_to_tc_dp_mapping')]
    bindings_list = [('pybind.slxos.v16r_1_00b.qos.map_.dscp_traffic_class.dscp_to_tc_dp_mapping.to', 'pybind.slxos.v16r_1_00b.brocade_qos_mls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dscp_traffic_class_map_name', 'extra_keyval': ''}, {'keyval': 'dscp_in_values', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'traffic-class'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dscp_traffic_class=dscp_traffic_class, dscp_to_tc_dp_mapping=dscp_to_tc_dp_mapping)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dscp_traffic_class=dscp_traffic_class, dscp_to_tc_dp_mapping=dscp_to_tc_dp_mapping)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_map_dscp_traffic_class_mark_delete(self, dscp_traffic_class=None, mark=None, to=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type dscp_traffic_class: dscp_traffic_class_map_name
    :param dscp_traffic_class: Keyword argument tuple.

    :type dscp_traffic_class_map_name: unicode
    :param dscp_traffic_class_map_name: **dscp_traffic_class** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    **Instance Keyword Argument Tuple**:

    :type mark: dscp_in_values
    :param mark: Keyword argument tuple.

    :type dscp_in_values: unicode
    :param dscp_in_values: **mark** tuple argument:  0-63;;Incoming DSCP

        * pattern restriction: ::

            '(([0-9])|([1-5][0-9])|(6[0-3]))(-(([0-9])|([1-5]'
            '[0-9])|(6[0-3])))?((,(([0-9])|([1-5][0-9])|(6[0-'
            '3]))(-(([0-9])|([1-5][0-9])|(6[0-3])))?)?)*'

    **Instance Argument(s)**:

    :type to: long
    :param to: Keyword argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.qos.map_.dscp_traffic_class', u'dscp_traffic_class'), ('pybind.nos.v6_0_2c.qos.map_.dscp_traffic_class', u'dscp_traffic_class'), ('pybind.nos.v7_1_0.qos.map_.dscp_traffic_class', u'dscp_traffic_class')]
    bindings_list = [('pybind.nos.v6_0_2c.qos.map_.dscp_traffic_class.mark', 'pybind.nos.v6_0_2c.brocade_qos', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.qos.map_.dscp_traffic_class.mark', 'pybind.nos.v7_0_1b.brocade_qos', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.qos.map_.dscp_traffic_class.mark', 'pybind.nos.v7_1_0.brocade_qos', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dscp_traffic_class_map_name', 'extra_keyval': ''}, {'keyval': 'dscp_traffic_class_map_name', 'extra_keyval': ''}, {'keyval': 'dscp_traffic_class_map_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mark', 'keyval': 'dscp_in_values', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dscp_traffic_class=dscp_traffic_class, mark=mark, to=to)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dscp_traffic_class=dscp_traffic_class, mark=mark, to=to)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_map_dscp_traffic_class_mark_to_delete(self, dscp_traffic_class=None, mark=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type dscp_traffic_class: dscp_traffic_class_map_name
    :param dscp_traffic_class: Keyword argument tuple.

    :type dscp_traffic_class_map_name: unicode
    :param dscp_traffic_class_map_name: **dscp_traffic_class** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    **Instance Keyword Argument Tuple**:

    :type mark: dscp_in_values
    :param mark: Keyword argument tuple.

    :type dscp_in_values: unicode
    :param dscp_in_values: **mark** tuple argument:  0-63;;Incoming DSCP

        * pattern restriction: ::

            '(([0-9])|([1-5][0-9])|(6[0-3]))(-(([0-9])|([1-5]'
            '[0-9])|(6[0-3])))?((,(([0-9])|([1-5][0-9])|(6[0-'
            '3]))(-(([0-9])|([1-5][0-9])|(6[0-3])))?)?)*'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.qos.map_.dscp_traffic_class', u'dscp_traffic_class'), ('pybind.nos.v6_0_2c.qos.map_.dscp_traffic_class', u'dscp_traffic_class'), ('pybind.nos.v7_1_0.qos.map_.dscp_traffic_class', u'dscp_traffic_class')]
    bindings_list = [('pybind.nos.v6_0_2c.qos.map_.dscp_traffic_class.mark', 'pybind.nos.v6_0_2c.brocade_qos', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.qos.map_.dscp_traffic_class.mark', 'pybind.nos.v7_0_1b.brocade_qos', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.qos.map_.dscp_traffic_class.mark', 'pybind.nos.v7_1_0.brocade_qos', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dscp_traffic_class_map_name', 'extra_keyval': ''}, {'keyval': 'dscp_traffic_class_map_name', 'extra_keyval': ''}, {'keyval': 'dscp_traffic_class_map_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mark', 'keyval': 'dscp_in_values', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'to'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dscp_traffic_class=dscp_traffic_class, mark=mark)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dscp_traffic_class=dscp_traffic_class, mark=mark)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_map_traffic_class_cos_delete(self, traffic_class_cos=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type traffic_class_cos: traffic_class_cos_map_name
    :param traffic_class_cos: Keyword argument tuple.

    :type traffic_class_cos_map_name: unicode
    :param traffic_class_cos_map_name: **traffic_class_cos** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.qos.map_.traffic_class_cos', 'pybind.slxos.v16r_1_00b.brocade_qos_mls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'traffic_class_cos', 'keyval': 'traffic_class_cos_map_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, traffic_class_cos=traffic_class_cos)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, traffic_class_cos=traffic_class_cos)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_map_traffic_class_cos_map_delete(self, traffic_class_cos=None, tc_dp_to_cos_mapping=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type traffic_class_cos: traffic_class_cos_map_name
    :param traffic_class_cos: Keyword argument tuple.

    :type traffic_class_cos_map_name: unicode
    :param traffic_class_cos_map_name: **traffic_class_cos** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    **Instance Keyword Argument Tuple**:

    :type tc_dp_to_cos_mapping: from_traffic_class, from_drop_precedence
    :param tc_dp_to_cos_mapping: Keyword argument tuple.

    :type from_traffic_class: int
    :param from_traffic_class: **tc_dp_to_cos_mapping** tuple argument:  In Traffic-Class

        * range restriction: ::

            ['0..255']

    :type from_drop_precedence: int
    :param from_drop_precedence: **tc_dp_to_cos_mapping** tuple argument:  In Drop-Precedence

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.qos.map_.traffic_class_cos', u'traffic_class_cos')]
    bindings_list = [('pybind.slxos.v16r_1_00b.qos.map_.traffic_class_cos.tc_dp_to_cos_mapping', 'pybind.slxos.v16r_1_00b.brocade_qos_mls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'traffic_class_cos_map_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'tc_dp_to_cos_mapping', 'keyval': 'from_traffic_class, from_drop_precedence', 'extra_keyval': 'from_traffic_class, from_drop_precedence'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, traffic_class_cos=traffic_class_cos, tc_dp_to_cos_mapping=tc_dp_to_cos_mapping)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, traffic_class_cos=traffic_class_cos, tc_dp_to_cos_mapping=tc_dp_to_cos_mapping)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_map_traffic_class_cos_map_to_delete(self, traffic_class_cos=None, tc_dp_to_cos_mapping=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type traffic_class_cos: traffic_class_cos_map_name
    :param traffic_class_cos: Keyword argument tuple.

    :type traffic_class_cos_map_name: unicode
    :param traffic_class_cos_map_name: **traffic_class_cos** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type tc_dp_to_cos_mapping: from_traffic_class, from_drop_precedence
    :param tc_dp_to_cos_mapping: Keyword argument tuple.

    :type from_traffic_class: int
    :param from_traffic_class: **tc_dp_to_cos_mapping** tuple argument:  In Traffic-Class

        * range restriction: ::

            ['0..255']

    :type from_drop_precedence: int
    :param from_drop_precedence: **tc_dp_to_cos_mapping** tuple argument:  In Drop-Precedence

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.qos.map_.traffic_class_cos', u'traffic_class_cos'), ('pybind.slxos.v16r_1_00b.qos.map_.traffic_class_cos.tc_dp_to_cos_mapping', u'tc_dp_to_cos_mapping')]
    bindings_list = [('pybind.slxos.v16r_1_00b.qos.map_.traffic_class_cos.tc_dp_to_cos_mapping.to', 'pybind.slxos.v16r_1_00b.brocade_qos_mls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'traffic_class_cos_map_name', 'extra_keyval': ''}, {'keyval': 'from_traffic_class, from_drop_precedence', 'extra_keyval': 'from_traffic_class, from_drop_precedence'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'to_cos'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, traffic_class_cos=traffic_class_cos, tc_dp_to_cos_mapping=tc_dp_to_cos_mapping)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, traffic_class_cos=traffic_class_cos, tc_dp_to_cos_mapping=tc_dp_to_cos_mapping)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_map_traffic_class_cos_map_to_cos_delete(self, traffic_class_cos=None, tc_dp_to_cos_mapping=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type traffic_class_cos: traffic_class_cos_map_name
    :param traffic_class_cos: Keyword argument tuple.

    :type traffic_class_cos_map_name: unicode
    :param traffic_class_cos_map_name: **traffic_class_cos** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type tc_dp_to_cos_mapping: from_traffic_class, from_drop_precedence
    :param tc_dp_to_cos_mapping: Keyword argument tuple.

    :type from_traffic_class: int
    :param from_traffic_class: **tc_dp_to_cos_mapping** tuple argument:  In Traffic-Class

        * range restriction: ::

            ['0..255']

    :type from_drop_precedence: int
    :param from_drop_precedence: **tc_dp_to_cos_mapping** tuple argument:  In Drop-Precedence

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.qos.map_.traffic_class_cos', u'traffic_class_cos'), ('pybind.slxos.v16r_1_00b.qos.map_.traffic_class_cos.tc_dp_to_cos_mapping', u'tc_dp_to_cos_mapping')]
    bindings_list = [('pybind.slxos.v16r_1_00b.qos.map_.traffic_class_cos.tc_dp_to_cos_mapping.to', 'pybind.slxos.v16r_1_00b.brocade_qos_mls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'traffic_class_cos_map_name', 'extra_keyval': ''}, {'keyval': 'from_traffic_class, from_drop_precedence', 'extra_keyval': 'from_traffic_class, from_drop_precedence'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cos'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, traffic_class_cos=traffic_class_cos, tc_dp_to_cos_mapping=tc_dp_to_cos_mapping)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, traffic_class_cos=traffic_class_cos, tc_dp_to_cos_mapping=tc_dp_to_cos_mapping)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_mpls_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.qos_mpls', 'pybind.slxos.v16r_1_00b.brocade_qos_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_mpls_map_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.qos_mpls.map_', 'pybind.slxos.v16r_1_00b.brocade_qos_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_mpls_map_apply_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.qos_mpls.map_apply', 'pybind.slxos.v16r_1_00b.brocade_qos_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_mpls_map_apply_dscp_exp_all_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.qos_mpls.map_apply.apply_dscp_exp_map_name', 'pybind.slxos.v16r_1_00b.brocade_qos_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'All'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_mpls_map_apply_dscp_exp_all_zero_map_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.qos_mpls.map_apply.apply_dscp_exp_map_name', 'pybind.slxos.v16r_1_00b.brocade_qos_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'all-zero-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_mpls_map_apply_dscp_exp_default_map_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.qos_mpls.map_apply.apply_dscp_exp_map_name', 'pybind.slxos.v16r_1_00b.brocade_qos_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'default-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_mpls_map_apply_dscp_exp_map_name_cmd3_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.qos_mpls.map_apply.apply_dscp_exp_map_name', 'pybind.slxos.v16r_1_00b.brocade_qos_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'map-name-cmd3'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_mpls_map_apply_exp_dscp_all_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.qos_mpls.map_apply.apply_exp_dscp_map_name', 'pybind.slxos.v16r_1_00b.brocade_qos_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'All'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_mpls_map_apply_exp_dscp_all_zero_map_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.qos_mpls.map_apply.apply_exp_dscp_map_name', 'pybind.slxos.v16r_1_00b.brocade_qos_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'all-zero-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_mpls_map_apply_exp_dscp_default_map_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.qos_mpls.map_apply.apply_exp_dscp_map_name', 'pybind.slxos.v16r_1_00b.brocade_qos_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'default-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_mpls_map_apply_exp_dscp_map_name_cmd4_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.qos_mpls.map_apply.apply_exp_dscp_map_name', 'pybind.slxos.v16r_1_00b.brocade_qos_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'map-name-cmd4'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_mpls_map_apply_exp_traffic_class_all_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.qos_mpls.map_apply.apply_exp_traffic_class_map_name', 'pybind.slxos.v16r_1_00b.brocade_qos_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'All'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_mpls_map_apply_exp_traffic_class_all_zero_map_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.qos_mpls.map_apply.apply_exp_traffic_class_map_name', 'pybind.slxos.v16r_1_00b.brocade_qos_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'all-zero-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_mpls_map_apply_exp_traffic_class_default_map_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.qos_mpls.map_apply.apply_exp_traffic_class_map_name', 'pybind.slxos.v16r_1_00b.brocade_qos_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'default-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_mpls_map_apply_exp_traffic_class_map_name_cmd1_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.qos_mpls.map_apply.apply_exp_traffic_class_map_name', 'pybind.slxos.v16r_1_00b.brocade_qos_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'map-name-cmd1'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_mpls_map_apply_inexp_outexp_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.qos_mpls.map_apply.apply_inexp_outexp_map_name', 'pybind.slxos.v16r_1_00b.brocade_qos_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v16r_1_00b.qos_mpls.map_apply.apply_inexp_outexp_map_name': [u'all_zero_map_cmd5', u'default_map_cmd5', u'map_name_cmd5']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_mpls_map_apply_inexp_outexp_all_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.qos_mpls.map_apply.apply_inexp_outexp_map_name', 'pybind.slxos.v16r_1_00b.brocade_qos_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'All'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_mpls_map_apply_inexp_outexp_all_zero_map_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.qos_mpls.map_apply.apply_inexp_outexp_map_name', 'pybind.slxos.v16r_1_00b.brocade_qos_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'all-zero-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_mpls_map_apply_inexp_outexp_default_map_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.qos_mpls.map_apply.apply_inexp_outexp_map_name', 'pybind.slxos.v16r_1_00b.brocade_qos_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'default-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_mpls_map_apply_inexp_outexp_map_name_cmd5_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.qos_mpls.map_apply.apply_inexp_outexp_map_name', 'pybind.slxos.v16r_1_00b.brocade_qos_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'map-name-cmd5'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_mpls_map_apply_traffic_class_exp_all_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.qos_mpls.map_apply.apply_traffic_class_exp_map_name', 'pybind.slxos.v16r_1_00b.brocade_qos_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'All'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_mpls_map_apply_traffic_class_exp_all_zero_map_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.qos_mpls.map_apply.apply_traffic_class_exp_map_name', 'pybind.slxos.v16r_1_00b.brocade_qos_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'all-zero-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_mpls_map_apply_traffic_class_exp_default_map_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.qos_mpls.map_apply.apply_traffic_class_exp_map_name', 'pybind.slxos.v16r_1_00b.brocade_qos_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'default-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_mpls_map_apply_traffic_class_exp_map_name_cmd2_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.qos_mpls.map_apply.apply_traffic_class_exp_map_name', 'pybind.slxos.v16r_1_00b.brocade_qos_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'map-name-cmd2'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_mpls_map_dscp_exp_delete(self, dscp_exp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type dscp_exp: dscp_exp_map_name
    :param dscp_exp: Keyword argument tuple.

    :type dscp_exp_map_name: unicode
    :param dscp_exp_map_name: **dscp_exp** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.qos_mpls.map_.dscp_exp', 'pybind.slxos.v16r_1_00b.brocade_qos_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'dscp_exp', 'keyval': 'dscp_exp_map_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dscp_exp=dscp_exp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dscp_exp=dscp_exp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_mpls_map_dscp_exp_dscp_to_delete(self, dscp_exp=None, dscp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type dscp_exp: dscp_exp_map_name
    :param dscp_exp: Keyword argument tuple.

    :type dscp_exp_map_name: unicode
    :param dscp_exp_map_name: **dscp_exp** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type dscp: dscp_in_values
    :param dscp: Keyword argument tuple.

    :type dscp_in_values: long
    :param dscp_in_values: **dscp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.qos_mpls.map_.dscp_exp', u'dscp_exp'), ('pybind.slxos.v16r_1_00b.qos_mpls.map_.dscp_exp.dscp', u'dscp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.qos_mpls.map_.dscp_exp.dscp.to', 'pybind.slxos.v16r_1_00b.brocade_qos_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dscp_exp_map_name', 'extra_keyval': ''}, {'keyval': 'dscp_in_values', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dscp_exp=dscp_exp, dscp=dscp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dscp_exp=dscp_exp, dscp=dscp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_mpls_map_dscp_exp_dscp_to_exp_delete(self, dscp_exp=None, dscp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type dscp_exp: dscp_exp_map_name
    :param dscp_exp: Keyword argument tuple.

    :type dscp_exp_map_name: unicode
    :param dscp_exp_map_name: **dscp_exp** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type dscp: dscp_in_values
    :param dscp: Keyword argument tuple.

    :type dscp_in_values: long
    :param dscp_in_values: **dscp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.qos_mpls.map_.dscp_exp', u'dscp_exp'), ('pybind.slxos.v16r_1_00b.qos_mpls.map_.dscp_exp.dscp', u'dscp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.qos_mpls.map_.dscp_exp.dscp.to', 'pybind.slxos.v16r_1_00b.brocade_qos_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dscp_exp_map_name', 'extra_keyval': ''}, {'keyval': 'dscp_in_values', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'exp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dscp_exp=dscp_exp, dscp=dscp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dscp_exp=dscp_exp, dscp=dscp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_mpls_map_exp_dscp_delete(self, exp_dscp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type exp_dscp: exp_dscp_map_name
    :param exp_dscp: Keyword argument tuple.

    :type exp_dscp_map_name: unicode
    :param exp_dscp_map_name: **exp_dscp** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.qos_mpls.map_.exp_dscp', 'pybind.slxos.v16r_1_00b.brocade_qos_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'exp_dscp', 'keyval': 'exp_dscp_map_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, exp_dscp=exp_dscp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, exp_dscp=exp_dscp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_mpls_map_exp_dscp_exp_to_delete(self, exp_dscp=None, exp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type exp_dscp: exp_dscp_map_name
    :param exp_dscp: Keyword argument tuple.

    :type exp_dscp_map_name: unicode
    :param exp_dscp_map_name: **exp_dscp** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type exp: exp_in_values
    :param exp: Keyword argument tuple.

    :type exp_in_values: long
    :param exp_in_values: **exp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.qos_mpls.map_.exp_dscp', u'exp_dscp'), ('pybind.slxos.v16r_1_00b.qos_mpls.map_.exp_dscp.exp', u'exp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.qos_mpls.map_.exp_dscp.exp.to', 'pybind.slxos.v16r_1_00b.brocade_qos_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'exp_dscp_map_name', 'extra_keyval': ''}, {'keyval': 'exp_in_values', 'extra_keyval': 'exp_in_values'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, exp_dscp=exp_dscp, exp=exp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, exp_dscp=exp_dscp, exp=exp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_mpls_map_exp_dscp_exp_to_dscp_delete(self, exp_dscp=None, exp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type exp_dscp: exp_dscp_map_name
    :param exp_dscp: Keyword argument tuple.

    :type exp_dscp_map_name: unicode
    :param exp_dscp_map_name: **exp_dscp** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type exp: exp_in_values
    :param exp: Keyword argument tuple.

    :type exp_in_values: long
    :param exp_in_values: **exp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.qos_mpls.map_.exp_dscp', u'exp_dscp'), ('pybind.slxos.v16r_1_00b.qos_mpls.map_.exp_dscp.exp', u'exp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.qos_mpls.map_.exp_dscp.exp.to', 'pybind.slxos.v16r_1_00b.brocade_qos_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'exp_dscp_map_name', 'extra_keyval': ''}, {'keyval': 'exp_in_values', 'extra_keyval': 'exp_in_values'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dscp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, exp_dscp=exp_dscp, exp=exp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, exp_dscp=exp_dscp, exp=exp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_mpls_map_exp_traffic_class_delete(self, exp_traffic_class=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type exp_traffic_class: exp_traffic_class_map_name
    :param exp_traffic_class: Keyword argument tuple.

    :type exp_traffic_class_map_name: unicode
    :param exp_traffic_class_map_name: **exp_traffic_class** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.qos_mpls.map_.exp_traffic_class', 'pybind.slxos.v16r_1_00b.brocade_qos_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'exp_traffic_class', 'keyval': 'exp_traffic_class_map_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, exp_traffic_class=exp_traffic_class)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, exp_traffic_class=exp_traffic_class)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_mpls_map_exp_traffic_class_exp_to_delete(self, exp_traffic_class=None, exp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type exp_traffic_class: exp_traffic_class_map_name
    :param exp_traffic_class: Keyword argument tuple.

    :type exp_traffic_class_map_name: unicode
    :param exp_traffic_class_map_name: **exp_traffic_class** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type exp: exp_in_values
    :param exp: Keyword argument tuple.

    :type exp_in_values: long
    :param exp_in_values: **exp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.qos_mpls.map_.exp_traffic_class', u'exp_traffic_class'), ('pybind.slxos.v16r_1_00b.qos_mpls.map_.exp_traffic_class.exp', u'exp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.qos_mpls.map_.exp_traffic_class.exp.to', 'pybind.slxos.v16r_1_00b.brocade_qos_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'exp_traffic_class_map_name', 'extra_keyval': ''}, {'keyval': 'exp_in_values', 'extra_keyval': 'exp_in_values'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, exp_traffic_class=exp_traffic_class, exp=exp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, exp_traffic_class=exp_traffic_class, exp=exp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_mpls_map_exp_traffic_class_exp_to_drop_precedence_delete(self, exp_traffic_class=None, exp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type exp_traffic_class: exp_traffic_class_map_name
    :param exp_traffic_class: Keyword argument tuple.

    :type exp_traffic_class_map_name: unicode
    :param exp_traffic_class_map_name: **exp_traffic_class** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type exp: exp_in_values
    :param exp: Keyword argument tuple.

    :type exp_in_values: long
    :param exp_in_values: **exp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.qos_mpls.map_.exp_traffic_class', u'exp_traffic_class'), ('pybind.slxos.v16r_1_00b.qos_mpls.map_.exp_traffic_class.exp', u'exp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.qos_mpls.map_.exp_traffic_class.exp.to', 'pybind.slxos.v16r_1_00b.brocade_qos_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'exp_traffic_class_map_name', 'extra_keyval': ''}, {'keyval': 'exp_in_values', 'extra_keyval': 'exp_in_values'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'drop-precedence'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, exp_traffic_class=exp_traffic_class, exp=exp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, exp_traffic_class=exp_traffic_class, exp=exp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_mpls_map_exp_traffic_class_exp_to_traffic_class_delete(self, exp_traffic_class=None, exp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type exp_traffic_class: exp_traffic_class_map_name
    :param exp_traffic_class: Keyword argument tuple.

    :type exp_traffic_class_map_name: unicode
    :param exp_traffic_class_map_name: **exp_traffic_class** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type exp: exp_in_values
    :param exp: Keyword argument tuple.

    :type exp_in_values: long
    :param exp_in_values: **exp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.qos_mpls.map_.exp_traffic_class', u'exp_traffic_class'), ('pybind.slxos.v16r_1_00b.qos_mpls.map_.exp_traffic_class.exp', u'exp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.qos_mpls.map_.exp_traffic_class.exp.to', 'pybind.slxos.v16r_1_00b.brocade_qos_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'exp_traffic_class_map_name', 'extra_keyval': ''}, {'keyval': 'exp_in_values', 'extra_keyval': 'exp_in_values'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'traffic-class'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, exp_traffic_class=exp_traffic_class, exp=exp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, exp_traffic_class=exp_traffic_class, exp=exp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_mpls_map_inexp_outexp_delete(self, inexp_outexp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type inexp_outexp: inexp_outexp_map_name
    :param inexp_outexp: Keyword argument tuple.

    :type inexp_outexp_map_name: unicode
    :param inexp_outexp_map_name: **inexp_outexp** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.qos_mpls.map_.inexp_outexp', 'pybind.slxos.v16r_1_00b.brocade_qos_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'inexp_outexp', 'keyval': 'inexp_outexp_map_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, inexp_outexp=inexp_outexp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, inexp_outexp=inexp_outexp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_mpls_map_inexp_outexp_in_exp_to_delete(self, inexp_outexp=None, in_exp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type inexp_outexp: inexp_outexp_map_name
    :param inexp_outexp: Keyword argument tuple.

    :type inexp_outexp_map_name: unicode
    :param inexp_outexp_map_name: **inexp_outexp** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type in_exp: in_exp_in_values
    :param in_exp: Keyword argument tuple.

    :type in_exp_in_values: long
    :param in_exp_in_values: **in_exp** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.qos_mpls.map_.inexp_outexp', u'inexp_outexp'), ('pybind.slxos.v16r_1_00b.qos_mpls.map_.inexp_outexp.in_exp', u'in_exp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.qos_mpls.map_.inexp_outexp.in_exp.to', 'pybind.slxos.v16r_1_00b.brocade_qos_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'inexp_outexp_map_name', 'extra_keyval': ''}, {'keyval': 'in_exp_in_values', 'extra_keyval': 'in_exp_in_values'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, inexp_outexp=inexp_outexp, in_exp=in_exp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, inexp_outexp=inexp_outexp, in_exp=in_exp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_mpls_map_inexp_outexp_in_exp_to_out_exp_delete(self, inexp_outexp=None, in_exp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type inexp_outexp: inexp_outexp_map_name
    :param inexp_outexp: Keyword argument tuple.

    :type inexp_outexp_map_name: unicode
    :param inexp_outexp_map_name: **inexp_outexp** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type in_exp: in_exp_in_values
    :param in_exp: Keyword argument tuple.

    :type in_exp_in_values: long
    :param in_exp_in_values: **in_exp** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.qos_mpls.map_.inexp_outexp', u'inexp_outexp'), ('pybind.slxos.v16r_1_00b.qos_mpls.map_.inexp_outexp.in_exp', u'in_exp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.qos_mpls.map_.inexp_outexp.in_exp.to', 'pybind.slxos.v16r_1_00b.brocade_qos_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'inexp_outexp_map_name', 'extra_keyval': ''}, {'keyval': 'in_exp_in_values', 'extra_keyval': 'in_exp_in_values'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'out-exp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, inexp_outexp=inexp_outexp, in_exp=in_exp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, inexp_outexp=inexp_outexp, in_exp=in_exp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_mpls_map_traffic_class_exp_delete(self, traffic_class_exp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type traffic_class_exp: traffic_class_exp_map_name
    :param traffic_class_exp: Keyword argument tuple.

    :type traffic_class_exp_map_name: unicode
    :param traffic_class_exp_map_name: **traffic_class_exp** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.qos_mpls.map_.traffic_class_exp', 'pybind.slxos.v16r_1_00b.brocade_qos_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'traffic_class_exp', 'keyval': 'traffic_class_exp_map_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, traffic_class_exp=traffic_class_exp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, traffic_class_exp=traffic_class_exp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_queue_multicast_scheduler_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.qos.queue.multicast.scheduler', 'pybind.nos.v6_0_2c.brocade_qos', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.qos.queue.multicast.scheduler', 'pybind.nos.v7_0_1b.brocade_qos', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.qos.queue.multicast.scheduler', 'pybind.nos.v7_1_0.brocade_qos', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_queue_multicast_scheduler_dwrr_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.qos.queue.multicast.scheduler.dwrr', 'pybind.nos.v6_0_2c.brocade_qos', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.qos.queue.multicast.scheduler.dwrr', 'pybind.nos.v7_0_1b.brocade_qos', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.qos.queue.multicast.scheduler.dwrr', 'pybind.nos.v7_1_0.brocade_qos', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'dwrr_traffic_class0, dwrr_traffic_class1, dwrr_traffic_class2, dwrr_traffic_class3, dwrr_traffic_class4, dwrr_traffic_class5, dwrr_traffic_class6, dwrr_traffic_class7'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_queue_multicast_scheduler_dwrr_dwrr_traffic_class0_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.qos.queue.multicast.scheduler.dwrr', 'pybind.nos.v6_0_2c.brocade_qos', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.qos.queue.multicast.scheduler.dwrr', 'pybind.nos.v7_0_1b.brocade_qos', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.qos.queue.multicast.scheduler.dwrr', 'pybind.nos.v7_1_0.brocade_qos', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dwrr-traffic-class0'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_queue_multicast_scheduler_dwrr_dwrr_traffic_class1_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.qos.queue.multicast.scheduler.dwrr', 'pybind.nos.v6_0_2c.brocade_qos', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.qos.queue.multicast.scheduler.dwrr', 'pybind.nos.v7_0_1b.brocade_qos', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.qos.queue.multicast.scheduler.dwrr', 'pybind.nos.v7_1_0.brocade_qos', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dwrr-traffic-class1'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_queue_multicast_scheduler_dwrr_dwrr_traffic_class2_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.qos.queue.multicast.scheduler.dwrr', 'pybind.nos.v6_0_2c.brocade_qos', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.qos.queue.multicast.scheduler.dwrr', 'pybind.nos.v7_0_1b.brocade_qos', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.qos.queue.multicast.scheduler.dwrr', 'pybind.nos.v7_1_0.brocade_qos', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dwrr-traffic-class2'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_queue_multicast_scheduler_dwrr_dwrr_traffic_class3_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.qos.queue.multicast.scheduler.dwrr', 'pybind.nos.v6_0_2c.brocade_qos', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.qos.queue.multicast.scheduler.dwrr', 'pybind.nos.v7_0_1b.brocade_qos', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.qos.queue.multicast.scheduler.dwrr', 'pybind.nos.v7_1_0.brocade_qos', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dwrr-traffic-class3'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_queue_multicast_scheduler_dwrr_dwrr_traffic_class4_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.qos.queue.multicast.scheduler.dwrr', 'pybind.nos.v6_0_2c.brocade_qos', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.qos.queue.multicast.scheduler.dwrr', 'pybind.nos.v7_0_1b.brocade_qos', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.qos.queue.multicast.scheduler.dwrr', 'pybind.nos.v7_1_0.brocade_qos', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dwrr-traffic-class4'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_queue_multicast_scheduler_dwrr_dwrr_traffic_class5_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.qos.queue.multicast.scheduler.dwrr', 'pybind.nos.v6_0_2c.brocade_qos', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.qos.queue.multicast.scheduler.dwrr', 'pybind.nos.v7_0_1b.brocade_qos', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.qos.queue.multicast.scheduler.dwrr', 'pybind.nos.v7_1_0.brocade_qos', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dwrr-traffic-class5'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_queue_multicast_scheduler_dwrr_dwrr_traffic_class6_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.qos.queue.multicast.scheduler.dwrr', 'pybind.nos.v6_0_2c.brocade_qos', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.qos.queue.multicast.scheduler.dwrr', 'pybind.nos.v7_0_1b.brocade_qos', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.qos.queue.multicast.scheduler.dwrr', 'pybind.nos.v7_1_0.brocade_qos', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dwrr-traffic-class6'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_queue_multicast_scheduler_dwrr_dwrr_traffic_class7_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.qos.queue.multicast.scheduler.dwrr', 'pybind.nos.v6_0_2c.brocade_qos', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.qos.queue.multicast.scheduler.dwrr', 'pybind.nos.v7_0_1b.brocade_qos', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.qos.queue.multicast.scheduler.dwrr', 'pybind.nos.v7_1_0.brocade_qos', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dwrr-traffic-class7'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_queue_scheduler_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.qos.queue.scheduler', 'pybind.nos.v6_0_2c.brocade_qos', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.qos.queue.scheduler', 'pybind.nos.v7_0_1b.brocade_qos', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.qos.queue.scheduler', 'pybind.nos.v7_1_0.brocade_qos', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_queue_scheduler_strict_priority_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.qos.queue.scheduler.strict_priority', 'pybind.nos.v6_0_2c.brocade_qos', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.qos.queue.scheduler.strict_priority', 'pybind.nos.v7_0_1b.brocade_qos', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.qos.queue.scheduler.strict_priority', 'pybind.nos.v7_1_0.brocade_qos', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'priority_number, scheduler_type, dwrr_traffic_class0, dwrr_traffic_class1, dwrr_traffic_class2, dwrr_traffic_class3, dwrr_traffic_class4, dwrr_traffic_class5, dwrr_traffic_class6, dwrr_traffic_class_last'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_queue_scheduler_strict_priority_dwrr_traffic_class0_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.qos.queue.scheduler.strict_priority', 'pybind.nos.v6_0_2c.brocade_qos', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.qos.queue.scheduler.strict_priority', 'pybind.nos.v7_0_1b.brocade_qos', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.qos.queue.scheduler.strict_priority', 'pybind.nos.v7_1_0.brocade_qos', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dwrr-traffic-class0'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_queue_scheduler_strict_priority_dwrr_traffic_class1_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.qos.queue.scheduler.strict_priority', 'pybind.nos.v6_0_2c.brocade_qos', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.qos.queue.scheduler.strict_priority', 'pybind.nos.v7_0_1b.brocade_qos', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.qos.queue.scheduler.strict_priority', 'pybind.nos.v7_1_0.brocade_qos', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dwrr-traffic-class1'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_queue_scheduler_strict_priority_dwrr_traffic_class2_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.qos.queue.scheduler.strict_priority', 'pybind.nos.v6_0_2c.brocade_qos', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.qos.queue.scheduler.strict_priority', 'pybind.nos.v7_0_1b.brocade_qos', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.qos.queue.scheduler.strict_priority', 'pybind.nos.v7_1_0.brocade_qos', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dwrr-traffic-class2'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_queue_scheduler_strict_priority_dwrr_traffic_class3_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.qos.queue.scheduler.strict_priority', 'pybind.nos.v6_0_2c.brocade_qos', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.qos.queue.scheduler.strict_priority', 'pybind.nos.v7_0_1b.brocade_qos', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.qos.queue.scheduler.strict_priority', 'pybind.nos.v7_1_0.brocade_qos', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dwrr-traffic-class3'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_queue_scheduler_strict_priority_dwrr_traffic_class4_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.qos.queue.scheduler.strict_priority', 'pybind.nos.v6_0_2c.brocade_qos', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.qos.queue.scheduler.strict_priority', 'pybind.nos.v7_0_1b.brocade_qos', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.qos.queue.scheduler.strict_priority', 'pybind.nos.v7_1_0.brocade_qos', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dwrr-traffic-class4'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_queue_scheduler_strict_priority_dwrr_traffic_class5_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.qos.queue.scheduler.strict_priority', 'pybind.nos.v6_0_2c.brocade_qos', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.qos.queue.scheduler.strict_priority', 'pybind.nos.v7_0_1b.brocade_qos', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.qos.queue.scheduler.strict_priority', 'pybind.nos.v7_1_0.brocade_qos', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dwrr-traffic-class5'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_queue_scheduler_strict_priority_dwrr_traffic_class6_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.qos.queue.scheduler.strict_priority', 'pybind.nos.v6_0_2c.brocade_qos', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.qos.queue.scheduler.strict_priority', 'pybind.nos.v7_0_1b.brocade_qos', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.qos.queue.scheduler.strict_priority', 'pybind.nos.v7_1_0.brocade_qos', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dwrr-traffic-class6'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_queue_scheduler_strict_priority_dwrr_traffic_class_last_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.qos.queue.scheduler.strict_priority', 'pybind.nos.v6_0_2c.brocade_qos', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.qos.queue.scheduler.strict_priority', 'pybind.nos.v7_0_1b.brocade_qos', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.qos.queue.scheduler.strict_priority', 'pybind.nos.v7_1_0.brocade_qos', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dwrr-traffic-class-last'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_queue_scheduler_strict_priority_priority_number_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.qos.queue.scheduler.strict_priority', 'pybind.nos.v6_0_2c.brocade_qos', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.qos.queue.scheduler.strict_priority', 'pybind.nos.v7_0_1b.brocade_qos', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.qos.queue.scheduler.strict_priority', 'pybind.nos.v7_1_0.brocade_qos', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority-number'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_queue_scheduler_strict_priority_scheduler_type_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.qos.queue.scheduler.strict_priority', 'pybind.nos.v6_0_2c.brocade_qos', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.qos.queue.scheduler.strict_priority', 'pybind.nos.v7_0_1b.brocade_qos', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.qos.queue.scheduler.strict_priority', 'pybind.nos.v7_1_0.brocade_qos', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'scheduler-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_rcv_queue_multicast_rate_limit_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.qos.rcv_queue.multicast.rate_limit', 'pybind.nos.v6_0_2c.brocade_qos', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.qos.rcv_queue.multicast.rate_limit', 'pybind.nos.v7_0_1b.brocade_qos', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.qos.rcv_queue.multicast.rate_limit', 'pybind.nos.v7_1_0.brocade_qos', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'limit, burst'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_rcv_queue_multicast_rate_limit_burst_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.qos.rcv_queue.multicast.rate_limit', 'pybind.nos.v6_0_2c.brocade_qos', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.qos.rcv_queue.multicast.rate_limit', 'pybind.nos.v7_0_1b.brocade_qos', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.qos.rcv_queue.multicast.rate_limit', 'pybind.nos.v7_1_0.brocade_qos', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'burst'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_rcv_queue_multicast_rate_limit_limit_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.qos.rcv_queue.multicast.rate_limit', 'pybind.nos.v6_0_2c.brocade_qos', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.qos.rcv_queue.multicast.rate_limit', 'pybind.nos.v7_0_1b.brocade_qos', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.qos.rcv_queue.multicast.rate_limit', 'pybind.nos.v7_1_0.brocade_qos', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'limit'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_rcv_queue_multicast_threshold_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.qos.rcv_queue.multicast.threshold', 'pybind.nos.v6_0_2c.brocade_qos', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.qos.rcv_queue.multicast.threshold', 'pybind.nos.v7_0_1b.brocade_qos', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.qos.rcv_queue.multicast.threshold', 'pybind.nos.v7_1_0.brocade_qos', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'traffic_class0, traffic_class1, traffic_class2, traffic_class3, traffic_class4, traffic_class5, traffic_class6, traffic_class7'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_rcv_queue_multicast_threshold_traffic_class0_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.qos.rcv_queue.multicast.threshold', 'pybind.nos.v6_0_2c.brocade_qos', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.qos.rcv_queue.multicast.threshold', 'pybind.nos.v7_0_1b.brocade_qos', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.qos.rcv_queue.multicast.threshold', 'pybind.nos.v7_1_0.brocade_qos', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'traffic-class0'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_rcv_queue_multicast_threshold_traffic_class1_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.qos.rcv_queue.multicast.threshold', 'pybind.nos.v6_0_2c.brocade_qos', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.qos.rcv_queue.multicast.threshold', 'pybind.nos.v7_0_1b.brocade_qos', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.qos.rcv_queue.multicast.threshold', 'pybind.nos.v7_1_0.brocade_qos', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'traffic-class1'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_rcv_queue_multicast_threshold_traffic_class2_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.qos.rcv_queue.multicast.threshold', 'pybind.nos.v6_0_2c.brocade_qos', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.qos.rcv_queue.multicast.threshold', 'pybind.nos.v7_0_1b.brocade_qos', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.qos.rcv_queue.multicast.threshold', 'pybind.nos.v7_1_0.brocade_qos', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'traffic-class2'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_rcv_queue_multicast_threshold_traffic_class3_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.qos.rcv_queue.multicast.threshold', 'pybind.nos.v6_0_2c.brocade_qos', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.qos.rcv_queue.multicast.threshold', 'pybind.nos.v7_0_1b.brocade_qos', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.qos.rcv_queue.multicast.threshold', 'pybind.nos.v7_1_0.brocade_qos', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'traffic-class3'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_rcv_queue_multicast_threshold_traffic_class4_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.qos.rcv_queue.multicast.threshold', 'pybind.nos.v6_0_2c.brocade_qos', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.qos.rcv_queue.multicast.threshold', 'pybind.nos.v7_0_1b.brocade_qos', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.qos.rcv_queue.multicast.threshold', 'pybind.nos.v7_1_0.brocade_qos', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'traffic-class4'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_rcv_queue_multicast_threshold_traffic_class5_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.qos.rcv_queue.multicast.threshold', 'pybind.nos.v6_0_2c.brocade_qos', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.qos.rcv_queue.multicast.threshold', 'pybind.nos.v7_0_1b.brocade_qos', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.qos.rcv_queue.multicast.threshold', 'pybind.nos.v7_1_0.brocade_qos', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'traffic-class5'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_rcv_queue_multicast_threshold_traffic_class6_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.qos.rcv_queue.multicast.threshold', 'pybind.nos.v6_0_2c.brocade_qos', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.qos.rcv_queue.multicast.threshold', 'pybind.nos.v7_0_1b.brocade_qos', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.qos.rcv_queue.multicast.threshold', 'pybind.nos.v7_1_0.brocade_qos', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'traffic-class6'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_rcv_queue_multicast_threshold_traffic_class7_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.qos.rcv_queue.multicast.threshold', 'pybind.nos.v6_0_2c.brocade_qos', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.qos.rcv_queue.multicast.threshold', 'pybind.nos.v7_0_1b.brocade_qos', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.qos.rcv_queue.multicast.threshold', 'pybind.nos.v7_1_0.brocade_qos', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'traffic-class7'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_red_profile_delete(self, red_profile=None, min_threshold=None, max_threshold=None, drop_probability=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type red_profile: profile_id, min_threshold, max_threshold, drop_probability
    :param red_profile: Keyword argument tuple.

    :type profile_id: long
    :param profile_id: **red_profile** tuple argument:  0-383;;Profile Id

        * range restriction: ::

            ['-2147483648..2147483647']

    :type min_threshold: long
    :param min_threshold: **red_profile** tuple argument:  Minimum Threshold in Percentage

        * range restriction: ::

            ['-2147483648..2147483647']

    :type max_threshold: long
    :param max_threshold: **red_profile** tuple argument:  Maximum Threshold in Percentage

        * range restriction: ::

            ['-2147483648..2147483647']

    :type drop_probability: long
    :param drop_probability: **red_profile** tuple argument:  Drop Probability in Percentage

        * range restriction: ::

            ['-2147483648..2147483647']

    **Instance Argument(s)**:

    :type min_threshold: long
    :param min_threshold: Minimum Threshold in Percentage

        * range restriction: ::

            ['-2147483648..2147483647']

    :type max_threshold: long
    :param max_threshold: Maximum Threshold in Percentage

        * range restriction: ::

            ['-2147483648..2147483647']

    :type drop_probability: long
    :param drop_probability: Drop Probability in Percentage

        * range restriction: ::

            ['-2147483648..2147483647']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.qos.red_profile', 'pybind.nos.v6_0_2c.brocade_qos', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.qos.red_profile', 'pybind.nos.v7_0_1b.brocade_qos', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.qos.red_profile', 'pybind.nos.v7_1_0.brocade_qos', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.qos.red_profile', 'pybind.slxos.v16r_1_00b.brocade_qos_mls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'red_profile', 'keyval': 'profile_id', 'extra_keyval': 'profile_id, min_threshold, max_threshold, drop_probability'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, red_profile=red_profile, min_threshold=min_threshold, max_threshold=max_threshold, drop_probability=drop_probability)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, red_profile=red_profile, min_threshold=min_threshold, max_threshold=max_threshold, drop_probability=drop_probability)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_red_profile_drop_probability_delete(self, red_profile=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type red_profile: profile_id
    :param red_profile: Keyword argument tuple.

    :type profile_id: long
    :param profile_id: **red_profile** tuple argument:  0-383;;Profile Id

        * range restriction: ::

            ['-2147483648..2147483647']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.qos.red_profile', 'pybind.nos.v6_0_2c.brocade_qos', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.qos.red_profile', 'pybind.nos.v7_0_1b.brocade_qos', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.qos.red_profile', 'pybind.nos.v7_1_0.brocade_qos', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.qos.red_profile', 'pybind.slxos.v16r_1_00b.brocade_qos_mls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'red_profile', 'keyval': 'profile_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'drop-probability'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, red_profile=red_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, red_profile=red_profile)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_red_profile_max_threshold_delete(self, red_profile=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type red_profile: profile_id
    :param red_profile: Keyword argument tuple.

    :type profile_id: long
    :param profile_id: **red_profile** tuple argument:  0-383;;Profile Id

        * range restriction: ::

            ['-2147483648..2147483647']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.qos.red_profile', 'pybind.nos.v6_0_2c.brocade_qos', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.qos.red_profile', 'pybind.nos.v7_0_1b.brocade_qos', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.qos.red_profile', 'pybind.nos.v7_1_0.brocade_qos', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.qos.red_profile', 'pybind.slxos.v16r_1_00b.brocade_qos_mls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'red_profile', 'keyval': 'profile_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'max-threshold'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, red_profile=red_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, red_profile=red_profile)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_red_profile_min_threshold_delete(self, red_profile=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type red_profile: profile_id
    :param red_profile: Keyword argument tuple.

    :type profile_id: long
    :param profile_id: **red_profile** tuple argument:  0-383;;Profile Id

        * range restriction: ::

            ['-2147483648..2147483647']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.qos.red_profile', 'pybind.nos.v6_0_2c.brocade_qos', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.qos.red_profile', 'pybind.nos.v7_0_1b.brocade_qos', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.qos.red_profile', 'pybind.nos.v7_1_0.brocade_qos', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.qos.red_profile', 'pybind.slxos.v16r_1_00b.brocade_qos_mls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'red_profile', 'keyval': 'profile_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'min-threshold'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, red_profile=red_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, red_profile=red_profile)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_rx_queue_limit_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.qos.rx_queue', 'pybind.slxos.v16r_1_00b.brocade_qos_mls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'limit'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_service_policy_delete(self, service_policy=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type service_policy: direction, policy_map_name
    :param service_policy: Keyword argument tuple.

    :type direction: unicode
    :param direction: **service_policy** tuple argument.

        * enumeration restriction: ::

            ['in']

    :type policy_map_name: unicode
    :param policy_map_name: **service_policy** tuple argument:  MAP_NAME;;Qos Policy map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.system_qos.qos.service_policy', 'pybind.nos.v6_0_2c.brocade_policer', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.system_qos.qos.service_policy', 'pybind.nos.v7_0_1b.brocade_policer', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.system_qos.qos.service_policy', 'pybind.nos.v7_1_0.brocade_policer', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.system_qos.qos.service_policy', 'pybind.slxos.v16r_1_00b.brocade_qos_mqc', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'service_policy', 'keyval': 'direction, policy_map_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, service_policy=service_policy)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, service_policy=service_policy)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_service_policy_attach_delete(self, service_policy=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type service_policy: direction, policy_map_name
    :param service_policy: Keyword argument tuple.

    :type direction: unicode
    :param direction: **service_policy** tuple argument.

        * enumeration restriction: ::

            ['in']

    :type policy_map_name: unicode
    :param policy_map_name: **service_policy** tuple argument:  MAP_NAME;;Qos Policy map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.system_qos.qos.service_policy', u'service_policy'), ('pybind.nos.v6_0_2c.system_qos.qos.service_policy', u'service_policy'), ('pybind.nos.v7_1_0.system_qos.qos.service_policy', u'service_policy')]
    bindings_list = [('pybind.nos.v6_0_2c.system_qos.qos.service_policy.attach', 'pybind.nos.v6_0_2c.brocade_policer', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.system_qos.qos.service_policy.attach', 'pybind.nos.v7_0_1b.brocade_policer', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.system_qos.qos.service_policy.attach', 'pybind.nos.v7_1_0.brocade_policer', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'direction, policy_map_name', 'extra_keyval': ''}, {'keyval': 'direction, policy_map_name', 'extra_keyval': ''}, {'keyval': 'direction, policy_map_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, service_policy=service_policy)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, service_policy=service_policy)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_service_policy_attach_rbridge_id_delete(self, service_policy=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type service_policy: direction, policy_map_name
    :param service_policy: Keyword argument tuple.

    :type direction: unicode
    :param direction: **service_policy** tuple argument.

        * enumeration restriction: ::

            ['in']

    :type policy_map_name: unicode
    :param policy_map_name: **service_policy** tuple argument:  MAP_NAME;;Qos Policy map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.system_qos.qos.service_policy', u'service_policy'), ('pybind.nos.v7_1_0.system_qos.qos.service_policy', u'service_policy'), ('pybind.nos.v7_0_1b.system_qos.qos.service_policy', u'service_policy')]
    bindings_list = [('pybind.nos.v6_0_2c.system_qos.qos.service_policy.attach.rbridge_id', 'pybind.nos.v6_0_2c.brocade_policer', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.system_qos.qos.service_policy.attach.rbridge_id', 'pybind.nos.v7_0_1b.brocade_policer', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.system_qos.qos.service_policy.attach.rbridge_id', 'pybind.nos.v7_1_0.brocade_policer', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'direction, policy_map_name', 'extra_keyval': ''}, {'keyval': 'direction, policy_map_name', 'extra_keyval': ''}, {'keyval': 'direction, policy_map_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, service_policy=service_policy)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, service_policy=service_policy)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_service_policy_attach_rbridge_id_add_delete(self, service_policy=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type service_policy: direction, policy_map_name
    :param service_policy: Keyword argument tuple.

    :type direction: unicode
    :param direction: **service_policy** tuple argument.

        * enumeration restriction: ::

            ['in']

    :type policy_map_name: unicode
    :param policy_map_name: **service_policy** tuple argument:  MAP_NAME;;Qos Policy map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.system_qos.qos.service_policy', u'service_policy'), ('pybind.nos.v6_0_2c.system_qos.qos.service_policy', u'service_policy'), ('pybind.nos.v7_0_1b.system_qos.qos.service_policy', u'service_policy')]
    bindings_list = [('pybind.nos.v6_0_2c.system_qos.qos.service_policy.attach.rbridge_id.add_', 'pybind.nos.v6_0_2c.brocade_policer', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.system_qos.qos.service_policy.attach.rbridge_id.add_', 'pybind.nos.v7_0_1b.brocade_policer', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.system_qos.qos.service_policy.attach.rbridge_id.add_', 'pybind.nos.v7_1_0.brocade_policer', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'direction, policy_map_name', 'extra_keyval': ''}, {'keyval': 'direction, policy_map_name', 'extra_keyval': ''}, {'keyval': 'direction, policy_map_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, service_policy=service_policy)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, service_policy=service_policy)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_service_policy_attach_rbridge_id_add_rb_add_range_delete(self, service_policy=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type service_policy: direction, policy_map_name
    :param service_policy: Keyword argument tuple.

    :type direction: unicode
    :param direction: **service_policy** tuple argument.

        * enumeration restriction: ::

            ['in']

    :type policy_map_name: unicode
    :param policy_map_name: **service_policy** tuple argument:  MAP_NAME;;Qos Policy map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.system_qos.qos.service_policy', u'service_policy'), ('pybind.nos.v6_0_2c.system_qos.qos.service_policy', u'service_policy'), ('pybind.nos.v7_0_1b.system_qos.qos.service_policy', u'service_policy')]
    bindings_list = [('pybind.nos.v6_0_2c.system_qos.qos.service_policy.attach.rbridge_id.add_', 'pybind.nos.v6_0_2c.brocade_policer', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.system_qos.qos.service_policy.attach.rbridge_id.add_', 'pybind.nos.v7_0_1b.brocade_policer', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.system_qos.qos.service_policy.attach.rbridge_id.add_', 'pybind.nos.v7_1_0.brocade_policer', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'direction, policy_map_name', 'extra_keyval': ''}, {'keyval': 'direction, policy_map_name', 'extra_keyval': ''}, {'keyval': 'direction, policy_map_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rb-add-range'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, service_policy=service_policy)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, service_policy=service_policy)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_service_policy_attach_rbridge_id_remove_delete(self, service_policy=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type service_policy: direction, policy_map_name
    :param service_policy: Keyword argument tuple.

    :type direction: unicode
    :param direction: **service_policy** tuple argument.

        * enumeration restriction: ::

            ['in']

    :type policy_map_name: unicode
    :param policy_map_name: **service_policy** tuple argument:  MAP_NAME;;Qos Policy map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.system_qos.qos.service_policy', u'service_policy'), ('pybind.nos.v7_0_1b.system_qos.qos.service_policy', u'service_policy'), ('pybind.nos.v6_0_2c.system_qos.qos.service_policy', u'service_policy')]
    bindings_list = [('pybind.nos.v6_0_2c.system_qos.qos.service_policy.attach.rbridge_id.remove_', 'pybind.nos.v6_0_2c.brocade_policer', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.system_qos.qos.service_policy.attach.rbridge_id.remove_', 'pybind.nos.v7_0_1b.brocade_policer', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.system_qos.qos.service_policy.attach.rbridge_id.remove_', 'pybind.nos.v7_1_0.brocade_policer', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'direction, policy_map_name', 'extra_keyval': ''}, {'keyval': 'direction, policy_map_name', 'extra_keyval': ''}, {'keyval': 'direction, policy_map_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, service_policy=service_policy)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, service_policy=service_policy)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_service_policy_attach_rbridge_id_remove_rb_remove_range_delete(self, service_policy=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type service_policy: direction, policy_map_name
    :param service_policy: Keyword argument tuple.

    :type direction: unicode
    :param direction: **service_policy** tuple argument.

        * enumeration restriction: ::

            ['in']

    :type policy_map_name: unicode
    :param policy_map_name: **service_policy** tuple argument:  MAP_NAME;;Qos Policy map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.system_qos.qos.service_policy', u'service_policy'), ('pybind.nos.v7_0_1b.system_qos.qos.service_policy', u'service_policy'), ('pybind.nos.v6_0_2c.system_qos.qos.service_policy', u'service_policy')]
    bindings_list = [('pybind.nos.v6_0_2c.system_qos.qos.service_policy.attach.rbridge_id.remove_', 'pybind.nos.v6_0_2c.brocade_policer', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.system_qos.qos.service_policy.attach.rbridge_id.remove_', 'pybind.nos.v7_0_1b.brocade_policer', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.system_qos.qos.service_policy.attach.rbridge_id.remove_', 'pybind.nos.v7_1_0.brocade_policer', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'direction, policy_map_name', 'extra_keyval': ''}, {'keyval': 'direction, policy_map_name', 'extra_keyval': ''}, {'keyval': 'direction, policy_map_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rb-remove-range'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, service_policy=service_policy)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, service_policy=service_policy)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_system_qos_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.system_qos.qos', 'pybind.nos.v6_0_2c.brocade_policer', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.system_qos.qos', 'pybind.nos.v7_0_1b.brocade_policer', 'pybind.nos.v7_0_1b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_tx_queue_limit_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.qos.tx_queue', 'pybind.slxos.v16r_1_00b.brocade_qos_mls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'limit'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_tx_queue_scheduler_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.qos.tx_queue.scheduler', 'pybind.slxos.v16r_1_00b.brocade_qos_mls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_tx_queue_scheduler_strict_priority_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.qos.tx_queue.scheduler.strict_priority', 'pybind.slxos.v16r_1_00b.brocade_qos_mls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'priority_number, scheduler_type, dwrr_traffic_class0, dwrr_traffic_class1, dwrr_traffic_class2, dwrr_traffic_class3, dwrr_traffic_class4, dwrr_traffic_class5, dwrr_traffic_class6, dwrr_traffic_class_last'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_tx_queue_scheduler_strict_priority_dwrr_traffic_class0_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.qos.tx_queue.scheduler.strict_priority', 'pybind.slxos.v16r_1_00b.brocade_qos_mls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dwrr-traffic-class0'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_tx_queue_scheduler_strict_priority_dwrr_traffic_class1_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.qos.tx_queue.scheduler.strict_priority', 'pybind.slxos.v16r_1_00b.brocade_qos_mls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dwrr-traffic-class1'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_tx_queue_scheduler_strict_priority_dwrr_traffic_class2_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.qos.tx_queue.scheduler.strict_priority', 'pybind.slxos.v16r_1_00b.brocade_qos_mls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dwrr-traffic-class2'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_tx_queue_scheduler_strict_priority_dwrr_traffic_class3_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.qos.tx_queue.scheduler.strict_priority', 'pybind.slxos.v16r_1_00b.brocade_qos_mls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dwrr-traffic-class3'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_tx_queue_scheduler_strict_priority_dwrr_traffic_class4_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.qos.tx_queue.scheduler.strict_priority', 'pybind.slxos.v16r_1_00b.brocade_qos_mls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dwrr-traffic-class4'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_tx_queue_scheduler_strict_priority_dwrr_traffic_class5_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.qos.tx_queue.scheduler.strict_priority', 'pybind.slxos.v16r_1_00b.brocade_qos_mls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dwrr-traffic-class5'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_tx_queue_scheduler_strict_priority_dwrr_traffic_class6_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.qos.tx_queue.scheduler.strict_priority', 'pybind.slxos.v16r_1_00b.brocade_qos_mls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dwrr-traffic-class6'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_tx_queue_scheduler_strict_priority_dwrr_traffic_class_last_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.qos.tx_queue.scheduler.strict_priority', 'pybind.slxos.v16r_1_00b.brocade_qos_mls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dwrr-traffic-class-last'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_tx_queue_scheduler_strict_priority_priority_number_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.qos.tx_queue.scheduler.strict_priority', 'pybind.slxos.v16r_1_00b.brocade_qos_mls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority-number'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def qos_tx_queue_scheduler_strict_priority_scheduler_type_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.qos.tx_queue.scheduler.strict_priority', 'pybind.slxos.v16r_1_00b.brocade_qos_mls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'scheduler-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def queues_state_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.queues_state', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def queues_state_queue_interface_list_delete(self, queue_interface_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type queue_interface_list: interface_value
    :param queue_interface_list: Keyword argument tuple.

    :type interface_value: unicode
    :param interface_value: **queue_interface_list** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.queues_state.queue_interface_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'queue_interface_list', 'keyval': 'interface_value', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, queue_interface_list=queue_interface_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, queue_interface_list=queue_interface_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def queues_state_queue_interface_list_queue_info_list_delete(self, queue_interface_list=None, queue_info_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type queue_interface_list: interface_value
    :param queue_interface_list: Keyword argument tuple.

    :type interface_value: unicode
    :param interface_value: **queue_interface_list** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type queue_info_list: interface, num
    :param queue_info_list: Keyword argument tuple.

    :type interface: unicode
    :param interface: **queue_info_list** tuple argument.

    :type num: long
    :param num: **queue_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.queues_state.queue_interface_list', u'queue_interface_list')]
    bindings_list = [('pybind.slxos.v16r_1_00b.queues_state.queue_interface_list.queue_info_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'queue_info_list', 'keyval': 'interface, num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, queue_interface_list=queue_interface_list, queue_info_list=queue_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, queue_interface_list=queue_interface_list, queue_info_list=queue_info_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def queues_state_queue_interface_list_queue_info_list_tx_bytes_delete(self, queue_interface_list=None, queue_info_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type queue_interface_list: interface_value
    :param queue_interface_list: Keyword argument tuple.

    :type interface_value: unicode
    :param interface_value: **queue_interface_list** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type queue_info_list: interface, num
    :param queue_info_list: Keyword argument tuple.

    :type interface: unicode
    :param interface: **queue_info_list** tuple argument.

    :type num: long
    :param num: **queue_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.queues_state.queue_interface_list', u'queue_interface_list')]
    bindings_list = [('pybind.slxos.v16r_1_00b.queues_state.queue_interface_list.queue_info_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'queue_info_list', 'keyval': 'interface, num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tx-bytes'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, queue_interface_list=queue_interface_list, queue_info_list=queue_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, queue_interface_list=queue_interface_list, queue_info_list=queue_info_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def queues_state_queue_interface_list_queue_info_list_tx_packets_delete(self, queue_interface_list=None, queue_info_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type queue_interface_list: interface_value
    :param queue_interface_list: Keyword argument tuple.

    :type interface_value: unicode
    :param interface_value: **queue_interface_list** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type queue_info_list: interface, num
    :param queue_info_list: Keyword argument tuple.

    :type interface: unicode
    :param interface: **queue_info_list** tuple argument.

    :type num: long
    :param num: **queue_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.queues_state.queue_interface_list', u'queue_interface_list')]
    bindings_list = [('pybind.slxos.v16r_1_00b.queues_state.queue_interface_list.queue_info_list', 'pybind.slxos.v16r_1_00b.brocade_openflow_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'queue_info_list', 'keyval': 'interface, num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tx-packets'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, queue_interface_list=queue_interface_list, queue_info_list=queue_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, queue_interface_list=queue_interface_list, queue_info_list=queue_info_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def radius_server_host_delete(self, host=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type host: hostname
    :param host: Keyword argument tuple.

    :type hostname: unicode
    :param hostname: **host** tuple argument:  INETADDRESS   Domain name or IP Address of this RADIUS server

        * length restriction: ::

            ['0..max']

        * pattern restriction: ::

            '\p{IsBasicLatin}{0,255}'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.radius_server.host', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.radius_server.host', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.radius_server.host', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.radius_server.host', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'host', 'keyval': 'hostname, use_vrf', 'extra_keyval': 'hostname, use_vrf, auth_port, protocol, key, encryption_level, retries, timeout'}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v7_0_1b.radius_server.host": {}, "pybind.nos.v6_0_2c.radius_server.host": {"encryption_level": "encryption_level", "retries": "retries", "protocol": "protocol", "timeout": "timeout", "hostname": "hostname", "auth_port": "auth_port", "key": "key"}, "pybind.nos.v7_1_0.radius_server.host": {}, "pybind.slxos.v16r_1_00b.radius_server.host": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, host=host)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, host=host)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def radius_server_host_auth_port_delete(self, host=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type host: hostname
    :param host: Keyword argument tuple.

    :type hostname: unicode
    :param hostname: **host** tuple argument:  INETADDRESS   Domain name or IP Address of this RADIUS server

        * length restriction: ::

            ['0..max']

        * pattern restriction: ::

            '\p{IsBasicLatin}{0,255}'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.radius_server.host', u'host')]
    bindings_list = [('pybind.nos.v6_0_2c.radius_server.host', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.radius_server.host', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.radius_server.host', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.radius_server.host.radius_server_options', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'hostname, use_vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'host', 'keyval': 'hostname, use_vrf', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v7_0_1b.radius_server.host": {}, "pybind.slxos.v16r_1_00b.radius_server.host.radius_server_options": {}, "pybind.nos.v6_0_2c.radius_server.host": {"hostname": "hostname", "auth_port": "auth_port"}, "pybind.nos.v7_1_0.radius_server.host": {}}
    rest_leaf_name = 'auth-port'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, host=host)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, host=host)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def radius_server_host_encryption_level_delete(self, host=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type host: hostname
    :param host: Keyword argument tuple.

    :type hostname: unicode
    :param hostname: **host** tuple argument:  INETADDRESS   Domain name or IP Address of this RADIUS server

        * length restriction: ::

            ['0..max']

        * pattern restriction: ::

            '\p{IsBasicLatin}{0,255}'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.radius_server.host', u'host')]
    bindings_list = [('pybind.nos.v6_0_2c.radius_server.host', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.radius_server.host', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.radius_server.host', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.radius_server.host.radius_server_options', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'hostname, use_vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'host', 'keyval': 'hostname, use_vrf', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v7_0_1b.radius_server.host": {}, "pybind.slxos.v16r_1_00b.radius_server.host.radius_server_options": {}, "pybind.nos.v6_0_2c.radius_server.host": {"encryption_level": "encryption_level", "hostname": "hostname"}, "pybind.nos.v7_1_0.radius_server.host": {}}
    rest_leaf_name = 'encryption-level'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, host=host)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, host=host)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def radius_server_host_key_delete(self, host=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type host: hostname
    :param host: Keyword argument tuple.

    :type hostname: unicode
    :param hostname: **host** tuple argument:  INETADDRESS   Domain name or IP Address of this RADIUS server

        * length restriction: ::

            ['0..max']

        * pattern restriction: ::

            '\p{IsBasicLatin}{0,255}'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.radius_server.host', u'host')]
    bindings_list = [('pybind.nos.v6_0_2c.radius_server.host', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.radius_server.host', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.radius_server.host', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.radius_server.host.radius_server_options', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'hostname, use_vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'host', 'keyval': 'hostname, use_vrf', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v7_0_1b.radius_server.host": {}, "pybind.slxos.v16r_1_00b.radius_server.host.radius_server_options": {}, "pybind.nos.v6_0_2c.radius_server.host": {"hostname": "hostname", "key": "key"}, "pybind.nos.v7_1_0.radius_server.host": {}}
    rest_leaf_name = 'key'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, host=host)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, host=host)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def radius_server_host_protocol_delete(self, host=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type host: hostname
    :param host: Keyword argument tuple.

    :type hostname: unicode
    :param hostname: **host** tuple argument:  INETADDRESS   Domain name or IP Address of this RADIUS server

        * length restriction: ::

            ['0..max']

        * pattern restriction: ::

            '\p{IsBasicLatin}{0,255}'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.radius_server.host', u'host')]
    bindings_list = [('pybind.nos.v6_0_2c.radius_server.host', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.radius_server.host', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.radius_server.host', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.radius_server.host.radius_server_options', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'hostname, use_vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'host', 'keyval': 'hostname, use_vrf', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v7_0_1b.radius_server.host": {}, "pybind.slxos.v16r_1_00b.radius_server.host.radius_server_options": {}, "pybind.nos.v6_0_2c.radius_server.host": {"hostname": "hostname", "protocol": "protocol"}, "pybind.nos.v7_1_0.radius_server.host": {}}
    rest_leaf_name = 'protocol'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, host=host)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, host=host)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def radius_server_host_retries_delete(self, host=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type host: hostname
    :param host: Keyword argument tuple.

    :type hostname: unicode
    :param hostname: **host** tuple argument:  INETADDRESS   Domain name or IP Address of this RADIUS server

        * length restriction: ::

            ['0..max']

        * pattern restriction: ::

            '\p{IsBasicLatin}{0,255}'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.radius_server.host', u'host')]
    bindings_list = [('pybind.nos.v6_0_2c.radius_server.host', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.radius_server.host', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.radius_server.host', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.radius_server.host.radius_server_options', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'hostname, use_vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'host', 'keyval': 'hostname, use_vrf', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v7_0_1b.radius_server.host": {}, "pybind.slxos.v16r_1_00b.radius_server.host.radius_server_options": {}, "pybind.nos.v6_0_2c.radius_server.host": {"retries": "retries", "hostname": "hostname"}, "pybind.nos.v7_1_0.radius_server.host": {}}
    rest_leaf_name = 'retries'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, host=host)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, host=host)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def radius_server_host_timeout_delete(self, host=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type host: hostname
    :param host: Keyword argument tuple.

    :type hostname: unicode
    :param hostname: **host** tuple argument:  INETADDRESS   Domain name or IP Address of this RADIUS server

        * length restriction: ::

            ['0..max']

        * pattern restriction: ::

            '\p{IsBasicLatin}{0,255}'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.radius_server.host', u'host')]
    bindings_list = [('pybind.nos.v6_0_2c.radius_server.host', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.radius_server.host', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.radius_server.host', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.radius_server.host.radius_server_options', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'hostname, use_vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'host', 'keyval': 'hostname, use_vrf', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v7_0_1b.radius_server.host": {}, "pybind.slxos.v16r_1_00b.radius_server.host.radius_server_options": {}, "pybind.nos.v6_0_2c.radius_server.host": {"hostname": "hostname", "timeout": "timeout"}, "pybind.nos.v7_1_0.radius_server.host": {}}
    rest_leaf_name = 'timeout'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, host=host)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, host=host)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ag_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ag', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ag', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ag', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.ag', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ag_counter_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ag.counter', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ag.counter', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ag.counter', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.ag.counter', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ag_counter_reliability_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ag.counter', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ag.counter', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ag.counter', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.ag.counter', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'reliability'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ag_enable_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ag', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ag', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ag', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.ag', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ag_nport_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ag.nport_menu', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ag.nport_menu', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ag.nport_menu', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.ag.nport_menu', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ag_nport_interface_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ag.nport_menu.nport_interface', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ag.nport_menu.nport_interface', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ag.nport_menu.nport_interface', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.ag.nport_menu.nport_interface', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ag_nport_interface_fiberchannel_delete(self, rbridge_id=None, nport=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type nport: agNPortNb
    :param nport: Keyword argument tuple.

    :type agNPortNb: unicode
    :param agNPortNb: **nport** tuple argument.

        * length restriction: ::

            ['1..250']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ag.nport_menu.nport_interface.nport', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ag.nport_menu.nport_interface.nport', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ag.nport_menu.nport_interface.nport', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.ag.nport_menu.nport_interface.nport', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'nport', 'keyval': 'agNPortNb', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, nport=nport)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, nport=nport)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ag_nport_interface_fiberchannel_map_delete(self, rbridge_id=None, nport=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type nport: agNPortNb
    :param nport: Keyword argument tuple.

    :type agNPortNb: unicode
    :param agNPortNb: **nport** tuple argument.

        * length restriction: ::

            ['1..250']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ag.nport_menu.nport_interface.nport', u'nport'), ('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id'), ('pybind.slxos.v16r_1_00b.rbridge_id.ag.nport_menu.nport_interface.nport', u'nport'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ag.nport_menu.nport_interface.nport', u'nport'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ag.nport_menu.nport_interface.nport', u'nport')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ag.nport_menu.nport_interface.nport.map_', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ag.nport_menu.nport_interface.nport.map_', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ag.nport_menu.nport_interface.nport.map_', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.ag.nport_menu.nport_interface.nport.map_', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'agNPortNb', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'agNPortNb', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'agNPortNb', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'agNPortNb', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, nport=nport)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, nport=nport)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ag_nport_interface_fiberchannel_map_fport_delete(self, rbridge_id=None, nport=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type nport: agNPortNb
    :param nport: Keyword argument tuple.

    :type agNPortNb: unicode
    :param agNPortNb: **nport** tuple argument.

        * length restriction: ::

            ['1..250']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ag.nport_menu.nport_interface.nport', u'nport'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ag.nport_menu.nport_interface.nport', u'nport'), ('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id'), ('pybind.slxos.v16r_1_00b.rbridge_id.ag.nport_menu.nport_interface.nport', u'nport'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ag.nport_menu.nport_interface.nport', u'nport')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ag.nport_menu.nport_interface.nport.map_.map_fport', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ag.nport_menu.nport_interface.nport.map_.map_fport', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ag.nport_menu.nport_interface.nport.map_.map_fport', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.ag.nport_menu.nport_interface.nport.map_.map_fport', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'agNPortNb', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'agNPortNb', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'agNPortNb', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'agNPortNb', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, nport=nport)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, nport=nport)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ag_nport_interface_fiberchannel_map_fport_interface_delete(self, rbridge_id=None, nport=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type nport: agNPortNb
    :param nport: Keyword argument tuple.

    :type agNPortNb: unicode
    :param agNPortNb: **nport** tuple argument.

        * length restriction: ::

            ['1..250']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id'), ('pybind.slxos.v16r_1_00b.rbridge_id.ag.nport_menu.nport_interface.nport', u'nport'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ag.nport_menu.nport_interface.nport', u'nport'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ag.nport_menu.nport_interface.nport', u'nport'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ag.nport_menu.nport_interface.nport', u'nport')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ag.nport_menu.nport_interface.nport.map_.map_fport.map_fport_interface', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ag.nport_menu.nport_interface.nport.map_.map_fport.map_fport_interface', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ag.nport_menu.nport_interface.nport.map_.map_fport.map_fport_interface', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.ag.nport_menu.nport_interface.nport.map_.map_fport.map_fport_interface', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'agNPortNb', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'agNPortNb', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'agNPortNb', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'agNPortNb', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, nport=nport)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, nport=nport)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ag_pg_delete(self, rbridge_id=None, pg=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type pg: pgid
    :param pg: Keyword argument tuple.

    :type pgid: long
    :param pgid: **pg** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ag.pg', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ag.pg', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ag.pg', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.ag.pg', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'pg', 'keyval': 'pgid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, pg=pg)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, pg=pg)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ag_pg_nport_delete(self, rbridge_id=None, pg=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type pg: pgid
    :param pg: Keyword argument tuple.

    :type pgid: long
    :param pgid: **pg** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ag.pg', u'pg'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ag.pg', u'pg'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ag.pg', u'pg'), ('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id'), ('pybind.slxos.v16r_1_00b.rbridge_id.ag.pg', u'pg')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ag.pg.nport', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ag.pg.nport', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ag.pg.nport', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.ag.pg.nport', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'pgid', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'pgid', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'pgid', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'pgid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, pg=pg)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, pg=pg)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ag_pg_nport_interface_delete(self, rbridge_id=None, pg=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type pg: pgid
    :param pg: Keyword argument tuple.

    :type pgid: long
    :param pgid: **pg** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ag.pg', u'pg'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ag.pg', u'pg'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ag.pg', u'pg'), ('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id'), ('pybind.slxos.v16r_1_00b.rbridge_id.ag.pg', u'pg')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ag.pg.nport.pg_nport_interface', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ag.pg.nport.pg_nport_interface', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ag.pg.nport.pg_nport_interface', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.ag.pg.nport.pg_nport_interface', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'pgid', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'pgid', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'pgid', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'pgid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, pg=pg)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, pg=pg)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ag_pg_rename_delete(self, rbridge_id=None, pg=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type pg: pgid
    :param pg: Keyword argument tuple.

    :type pgid: long
    :param pgid: **pg** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ag.pg', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ag.pg', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ag.pg', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.ag.pg', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'pg', 'keyval': 'pgid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rename'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, pg=pg)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, pg=pg)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ag_timeout_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ag.timeout', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ag.timeout', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ag.timeout', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.ag.timeout', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ag_timeout_fnm_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ag.timeout', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ag.timeout', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ag.timeout', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.ag.timeout', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'fnm'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_arp_delete(self, rbridge_id=None, arp_entry=None, mac_address_value=None, interfacename=None, GigabitEthernet=None, TenGigabitEthernet=None, FortyGigabitEthernet=None, HundredGigabitEthernet=None, Ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type arp_entry: arp_ip_address, mac_address_value, interfacename, GigabitEthernet, TenGigabitEthernet, FortyGigabitEthernet, HundredGigabitEthernet, Ve
    :param arp_entry: Keyword argument tuple.

    :type arp_ip_address: unicode
    :param arp_ip_address: **arp_entry** tuple argument:  A.B.C.D;; IP address of the ARP entry

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type mac_address_value: unicode
    :param mac_address_value: **arp_entry** tuple argument.

    :type interfacename: unicode
    :param interfacename: **arp_entry** tuple argument.

        * enumeration restriction: ::

            ['interface']

    :type GigabitEthernet: unicode
    :param GigabitEthernet: **arp_entry** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type TenGigabitEthernet: unicode
    :param TenGigabitEthernet: **arp_entry** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type FortyGigabitEthernet: unicode
    :param FortyGigabitEthernet: **arp_entry** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type HundredGigabitEthernet: unicode
    :param HundredGigabitEthernet: **arp_entry** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type Ve: long
    :param Ve: **arp_entry** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Argument(s)**:

    :type mac_address_value: unicode
    :param mac_address_value: Keyword argument.

    :type interfacename: unicode
    :param interfacename: Keyword argument.

        * enumeration restriction: ::

            ['interface']

    :type GigabitEthernet: unicode
    :param GigabitEthernet: Choice keyword argument (Only one choice argument allowed per API invocation).

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type TenGigabitEthernet: unicode
    :param TenGigabitEthernet: Choice keyword argument (Only one choice argument allowed per API invocation).

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type FortyGigabitEthernet: unicode
    :param FortyGigabitEthernet: Choice keyword argument (Only one choice argument allowed per API invocation).

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type HundredGigabitEthernet: unicode
    :param HundredGigabitEthernet: Choice keyword argument (Only one choice argument allowed per API invocation).

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type Ve: long
    :param Ve: Choice keyword argument (Only one choice argument allowed per API invocation).

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.arp_entry', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.arp_entry', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.arp_entry', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'arp_entry', 'keyval': 'arp_ip_address', 'extra_keyval': 'arp_ip_address, mac_address_value, interfacename, Port_channel, GigabitEthernet, TenGigabitEthernet, FortyGigabitEthernet, HundredGigabitEthernet, Ve'}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v7_0_1b.rbridge_id.arp_entry": {}, "pybind.nos.v6_0_2c.rbridge_id.arp_entry": {"mac_address_value": "mac_address_value", "interfacename": "interfacename", "FortyGigabitEthernet": "FortyGigabitEthernet", "GigabitEthernet": "GigabitEthernet", "TenGigabitEthernet": "TenGigabitEthernet", "arp_ip_address": "arp_ip_address", "HundredGigabitEthernet": "HundredGigabitEthernet", "Ve": "Ve"}, "pybind.nos.v7_1_0.rbridge_id.arp_entry": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_0_1b.rbridge_id.arp_entry': [u'Port_channel', u'Ve', u'FortyGigabitEthernet', u'GigabitEthernet', u'TenGigabitEthernet', u'HundredGigabitEthernet'], 'pybind.nos.v6_0_2c.rbridge_id.arp_entry': [u'FortyGigabitEthernet', u'GigabitEthernet', u'TenGigabitEthernet', u'HundredGigabitEthernet', u'Ve'], 'pybind.nos.v7_1_0.rbridge_id.arp_entry': [u'Port_channel', u'Ve', u'FortyGigabitEthernet', u'GigabitEthernet', u'TenGigabitEthernet', u'HundredGigabitEthernet']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, arp_entry=arp_entry, mac_address_value=mac_address_value, interfacename=interfacename, GigabitEthernet=GigabitEthernet, TenGigabitEthernet=TenGigabitEthernet, FortyGigabitEthernet=FortyGigabitEthernet, HundredGigabitEthernet=HundredGigabitEthernet, Ve=Ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, arp_entry=arp_entry, mac_address_value=mac_address_value, interfacename=interfacename, GigabitEthernet=GigabitEthernet, TenGigabitEthernet=TenGigabitEthernet, FortyGigabitEthernet=FortyGigabitEthernet, HundredGigabitEthernet=HundredGigabitEthernet, Ve=Ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_arp_fortygigabitethernet_delete(self, rbridge_id=None, arp_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type arp_entry: arp_ip_address
    :param arp_entry: Keyword argument tuple.

    :type arp_ip_address: unicode
    :param arp_ip_address: **arp_entry** tuple argument:  A.B.C.D;; IP address of the ARP entry

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.arp_entry', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.arp_entry', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.arp_entry', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'arp_entry', 'keyval': 'arp_ip_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'FortyGigabitEthernet'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, arp_entry=arp_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, arp_entry=arp_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_arp_gigabitethernet_delete(self, rbridge_id=None, arp_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type arp_entry: arp_ip_address
    :param arp_entry: Keyword argument tuple.

    :type arp_ip_address: unicode
    :param arp_ip_address: **arp_entry** tuple argument:  A.B.C.D;; IP address of the ARP entry

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.arp_entry', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.arp_entry', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.arp_entry', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'arp_entry', 'keyval': 'arp_ip_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'GigabitEthernet'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, arp_entry=arp_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, arp_entry=arp_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_arp_hundredgigabitethernet_delete(self, rbridge_id=None, arp_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type arp_entry: arp_ip_address
    :param arp_entry: Keyword argument tuple.

    :type arp_ip_address: unicode
    :param arp_ip_address: **arp_entry** tuple argument:  A.B.C.D;; IP address of the ARP entry

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.arp_entry', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.arp_entry', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.arp_entry', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'arp_entry', 'keyval': 'arp_ip_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'HundredGigabitEthernet'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, arp_entry=arp_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, arp_entry=arp_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_arp_interfacename_delete(self, rbridge_id=None, arp_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type arp_entry: arp_ip_address
    :param arp_entry: Keyword argument tuple.

    :type arp_ip_address: unicode
    :param arp_ip_address: **arp_entry** tuple argument:  A.B.C.D;; IP address of the ARP entry

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.arp_entry', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.arp_entry', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.arp_entry', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'arp_entry', 'keyval': 'arp_ip_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'interfacename'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, arp_entry=arp_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, arp_entry=arp_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_arp_mac_address_value_delete(self, rbridge_id=None, arp_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type arp_entry: arp_ip_address
    :param arp_entry: Keyword argument tuple.

    :type arp_ip_address: unicode
    :param arp_ip_address: **arp_entry** tuple argument:  A.B.C.D;; IP address of the ARP entry

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.arp_entry', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.arp_entry', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.arp_entry', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'arp_entry', 'keyval': 'arp_ip_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mac-address-value'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, arp_entry=arp_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, arp_entry=arp_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_arp_port_channel_delete(self, rbridge_id=None, arp_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type arp_entry: arp_ip_address
    :param arp_entry: Keyword argument tuple.

    :type arp_ip_address: unicode
    :param arp_ip_address: **arp_entry** tuple argument:  A.B.C.D;; IP address of the ARP entry

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.arp_entry', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.arp_entry', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'arp_entry', 'keyval': 'arp_ip_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'Port-channel'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, arp_entry=arp_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, arp_entry=arp_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_arp_tengigabitethernet_delete(self, rbridge_id=None, arp_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type arp_entry: arp_ip_address
    :param arp_entry: Keyword argument tuple.

    :type arp_ip_address: unicode
    :param arp_ip_address: **arp_entry** tuple argument:  A.B.C.D;; IP address of the ARP entry

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.arp_entry', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.arp_entry', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.arp_entry', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'arp_entry', 'keyval': 'arp_ip_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'TenGigabitEthernet'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, arp_entry=arp_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, arp_entry=arp_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_arp_ve_delete(self, rbridge_id=None, arp_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type arp_entry: arp_ip_address
    :param arp_entry: Keyword argument tuple.

    :type arp_ip_address: unicode
    :param arp_ip_address: **arp_entry** tuple argument:  A.B.C.D;; IP address of the ARP entry

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.arp_entry', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.arp_entry', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.arp_entry', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'arp_entry', 'keyval': 'arp_ip_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'Ve'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, arp_entry=arp_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, arp_entry=arp_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_bfd_session_setup_delay_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.bfd_session_setup_delay', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.bfd_session_setup_delay', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_bfd_session_setup_delay_delay_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.bfd_session_setup_delay', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.bfd_session_setup_delay', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'delay'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_bp_rate_limit_heavy_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.bp_rate_limit.heavy', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.bp_rate_limit.heavy', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.bp_rate_limit.heavy', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_bp_rate_limit_heavy_module_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.bp_rate_limit.heavy.module', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.bp_rate_limit.heavy.module', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.bp_rate_limit.heavy.module', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_bp_rate_limit_heavy_module_add_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.bp_rate_limit.heavy.module', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.bp_rate_limit.heavy.module', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.bp_rate_limit.heavy.module', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'add'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_bp_rate_limit_heavy_module_remove_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.bp_rate_limit.heavy.module', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.bp_rate_limit.heavy.module', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.bp_rate_limit.heavy.module', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'remove'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_bp_rate_limit_queue_delete(self, rbridge_id=None, queue=None, limit_percent=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type queue: queue_id
    :param queue: Keyword argument tuple.

    :type queue_id: long
    :param queue_id: **queue** tuple argument:  BP queue number (only queue 0 is supported)

        * range restriction: ::

            ['0..4294967295']

    **Instance Argument(s)**:

    :type limit_percent: long
    :param limit_percent: BP queue limit in percentage

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.bp_rate_limit.queue', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.bp_rate_limit.queue', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.bp_rate_limit.queue', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'queue', 'keyval': 'queue_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, queue=queue, limit_percent=limit_percent)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, queue=queue, limit_percent=limit_percent)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_bp_rate_limit_queue_limit_percent_delete(self, rbridge_id=None, queue=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type queue: queue_id
    :param queue: Keyword argument tuple.

    :type queue_id: long
    :param queue_id: **queue** tuple argument:  BP queue number (only queue 0 is supported)

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.bp_rate_limit.queue', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.bp_rate_limit.queue', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.bp_rate_limit.queue', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'queue', 'keyval': 'queue_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'limit-percent'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, queue=queue)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, queue=queue)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_chassis_oper_address_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.chassis.oper_address', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.chassis.oper_address', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.chassis.oper_address', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_chassis_virtual_ip_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.chassis', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.chassis', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.chassis', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.chassis', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'virtual-ip'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_chassis_virtual_ip_oper_address_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.chassis.oper_address', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.chassis.oper_address', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.chassis.oper_address', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'virtual-ip'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_chassis_virtual_ip_v4_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.slxos.v16r_1_00b.rbridge_id.chassis.oper_address', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'v4'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_chassis_virtual_ipv6_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.chassis', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.chassis', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.chassis', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.chassis', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'virtual-ipv6'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_clock_timezone_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.clock', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.clock', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.clock', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'timezone'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_crypto_ca_delete(self, rbridge_id=None, ca=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ca: trustpoint
    :param ca: Keyword argument tuple.

    :type trustpoint: unicode
    :param trustpoint: **ca** tuple argument:  Trustpoint name

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.crypto.ca', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.crypto.ca', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.crypto.ca', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ca', 'keyval': 'trustpoint', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ca=ca)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ca=ca)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_crypto_ca_keypair_delete(self, rbridge_id=None, ca=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ca: trustpoint
    :param ca: Keyword argument tuple.

    :type trustpoint: unicode
    :param trustpoint: **ca** tuple argument:  Trustpoint name

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.crypto.ca', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.crypto.ca', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.crypto.ca', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ca', 'keyval': 'trustpoint', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'keypair'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ca=ca)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ca=ca)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_crypto_key_delete(self, rbridge_id=None, key=None, type=None, modulus=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type key: label, type, modulus
    :param key: Keyword argument tuple.

    :type label: unicode
    :param label: **key** tuple argument:  Key Label

        * length restriction: ::

            ['1..64']

    :type type: unicode
    :param type: **key** tuple argument:  Key Type

        * enumeration restriction: ::

            ['dsa', 'rsa', 'ecdsa']

    :type modulus: long
    :param modulus: **key** tuple argument:  Key Size

        * range restriction: ::

            ['0..4294967295']

    **Instance Argument(s)**:

    :type type: unicode
    :param type: Key Type

        * enumeration restriction: ::

            ['dsa', 'rsa', 'ecdsa']

    :type modulus: long
    :param modulus: Key Size

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.crypto.key', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.crypto.key', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.crypto.key', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'key', 'keyval': 'label', 'extra_keyval': 'label, type, modulus'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, key=key, type=type, modulus=modulus)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, key=key, type=type, modulus=modulus)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_crypto_key_modulus_delete(self, rbridge_id=None, key=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type key: label
    :param key: Keyword argument tuple.

    :type label: unicode
    :param label: **key** tuple argument:  Key Label

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.crypto.key', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.crypto.key', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.crypto.key', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'key', 'keyval': 'label', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'modulus'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, key=key)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, key=key)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_crypto_key_type_delete(self, rbridge_id=None, key=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type key: label
    :param key: Keyword argument tuple.

    :type label: unicode
    :param label: **key** tuple argument:  Key Label

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.crypto.key', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.crypto.key', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.crypto.key', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'key', 'keyval': 'label', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, key=key)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, key=key)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_default_config_enable_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.default_config', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.default_config', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.default_config', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.default_config', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_dhcpd_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_1_0.rbridge_id.dhcpd', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_dhcpd_enable_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_1_0.rbridge_id.dhcpd', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_event_handler_activate_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.event_handler.activate', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.event_handler.activate', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.event_handler.activate', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_event_handler_activate_name_delete(self, rbridge_id=None, name=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type name: name
    :param name: Keyword argument tuple.

    :type name: unicode
    :param name: **name** tuple argument:  Event handler name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.event_handler.activate.name', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.event_handler.activate.name', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.event_handler.activate.name', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'name', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v6_0_2c.rbridge_id.event_handler.activate.name": {"name": "name", "interval": "interval", "trigger_mode": "trigger_mode", "delay": "delay", "iterations": "iterations", "run_mode": "run_mode"}, "pybind.nos.v7_1_0.rbridge_id.event_handler.activate.name": {}, "pybind.nos.v7_0_1b.rbridge_id.event_handler.activate.name": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, name=name)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, name=name)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_event_handler_activate_name_action_timeout_delete(self, rbridge_id=None, name=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type name: name
    :param name: Keyword argument tuple.

    :type name: unicode
    :param name: **name** tuple argument:  Event handler name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.event_handler.activate.name', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.event_handler.activate.name', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'name', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'action-timeout'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, name=name)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, name=name)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_event_handler_activate_name_delay_delete(self, rbridge_id=None, name=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type name: name
    :param name: Keyword argument tuple.

    :type name: unicode
    :param name: **name** tuple argument:  Event handler name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.event_handler.activate.name', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.event_handler.activate.name', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.event_handler.activate.name', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'name', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'delay'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, name=name)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, name=name)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_event_handler_activate_name_interval_delete(self, rbridge_id=None, name=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type name: name
    :param name: Keyword argument tuple.

    :type name: unicode
    :param name: **name** tuple argument:  Event handler name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.event_handler.activate.name', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.event_handler.activate.name', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.event_handler.activate.name', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'name', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, name=name)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, name=name)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_event_handler_activate_name_iterations_delete(self, rbridge_id=None, name=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type name: name
    :param name: Keyword argument tuple.

    :type name: unicode
    :param name: **name** tuple argument:  Event handler name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.event_handler.activate.name', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.event_handler.activate.name', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.event_handler.activate.name', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'name', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'iterations'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, name=name)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, name=name)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_event_handler_activate_name_run_mode_delete(self, rbridge_id=None, name=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type name: name
    :param name: Keyword argument tuple.

    :type name: unicode
    :param name: **name** tuple argument:  Event handler name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.event_handler.activate.name', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.event_handler.activate.name', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.event_handler.activate.name', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'name', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'run-mode'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, name=name)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, name=name)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_event_handler_activate_name_time_window_delete(self, rbridge_id=None, name=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type name: name
    :param name: Keyword argument tuple.

    :type name: unicode
    :param name: **name** tuple argument:  Event handler name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.event_handler.activate.name', u'name'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.event_handler.activate.name', u'name')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.event_handler.activate.name.trigger_function_container', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.event_handler.activate.name.trigger_function_container', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'time-window'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, name=name)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, name=name)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_event_handler_activate_name_trigger_function_delete(self, rbridge_id=None, name=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type name: name
    :param name: Keyword argument tuple.

    :type name: unicode
    :param name: **name** tuple argument:  Event handler name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.event_handler.activate.name', u'name'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.event_handler.activate.name', u'name')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.event_handler.activate.name.trigger_function_container', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.event_handler.activate.name.trigger_function_container', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'trigger-function'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, name=name)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, name=name)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_event_handler_activate_name_trigger_function_time_window_delete(self, rbridge_id=None, name=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type name: name
    :param name: Keyword argument tuple.

    :type name: unicode
    :param name: **name** tuple argument:  Event handler name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.event_handler.activate.name', u'name')]
    bindings_list = [('pybind.nos.v7_1_0.rbridge_id.event_handler.activate.name.trigger_function', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'time-window'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, name=name)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, name=name)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_event_handler_activate_name_trigger_function_trigger_function_delete(self, rbridge_id=None, name=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type name: name
    :param name: Keyword argument tuple.

    :type name: unicode
    :param name: **name** tuple argument:  Event handler name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.event_handler.activate.name', u'name')]
    bindings_list = [('pybind.nos.v7_1_0.rbridge_id.event_handler.activate.name.trigger_function', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'trigger-function'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, name=name)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, name=name)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_event_handler_activate_name_trigger_mode_delete(self, rbridge_id=None, name=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type name: name
    :param name: Keyword argument tuple.

    :type name: unicode
    :param name: **name** tuple argument:  Event handler name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.event_handler.activate.name', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.event_handler.activate.name', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.event_handler.activate.name', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'name', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'trigger-mode'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, name=name)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, name=name)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_evpn_instance_delete(self, rbridge_id=None, evpn_instance=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type evpn_instance: instance_name
    :param evpn_instance: Keyword argument tuple.

    :type instance_name: unicode
    :param instance_name: **evpn_instance** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.evpn_instance', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.evpn_instance', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'evpn_instance', 'keyval': 'instance_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_instance=evpn_instance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_instance=evpn_instance)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_evpn_instance_df_delay_timer_delete(self, rbridge_id=None, evpn_instance=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type evpn_instance: instance_name
    :param evpn_instance: Keyword argument tuple.

    :type instance_name: unicode
    :param instance_name: **evpn_instance** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.evpn_instance', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.evpn_instance', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'evpn_instance', 'keyval': 'instance_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'df-delay-timer'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_instance=evpn_instance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_instance=evpn_instance)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_evpn_instance_rd_auto_delete(self, rbridge_id=None, evpn_instance=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type evpn_instance: instance_name
    :param evpn_instance: Keyword argument tuple.

    :type instance_name: unicode
    :param instance_name: **evpn_instance** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.evpn_instance', u'evpn_instance'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.evpn_instance', u'evpn_instance')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.evpn_instance.route_distinguisher', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.evpn_instance.route_distinguisher', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'auto'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_instance=evpn_instance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_instance=evpn_instance)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_evpn_instance_route_target_both_delete(self, rbridge_id=None, evpn_instance=None, both=None, ignore_as=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type evpn_instance: instance_name
    :param evpn_instance: Keyword argument tuple.

    :type instance_name: unicode
    :param instance_name: **evpn_instance** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    **Instance Keyword Argument Tuple**:

    :type both: target_community
    :param both: Keyword argument tuple.

    :type target_community: unicode
    :param target_community: **both** tuple argument:  auto;; Target VPN Extended Community

    **Instance Argument(s)**:

    :type ignore_as: YANGBool
    :param ignore_as: Ignore-as

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.evpn_instance', u'evpn_instance'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.evpn_instance', u'evpn_instance')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.evpn_instance.route_target.both', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.evpn_instance.route_target.both', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'both', 'keyval': 'target_community', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_instance=evpn_instance, both=both, ignore_as=ignore_as)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_instance=evpn_instance, both=both, ignore_as=ignore_as)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_evpn_instance_route_target_both_ignore_as_delete(self, rbridge_id=None, evpn_instance=None, both=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type evpn_instance: instance_name
    :param evpn_instance: Keyword argument tuple.

    :type instance_name: unicode
    :param instance_name: **evpn_instance** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    **Instance Keyword Argument Tuple**:

    :type both: target_community
    :param both: Keyword argument tuple.

    :type target_community: unicode
    :param target_community: **both** tuple argument:  auto;; Target VPN Extended Community

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.evpn_instance', u'evpn_instance'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.evpn_instance', u'evpn_instance')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.evpn_instance.route_target.both', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.evpn_instance.route_target.both', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'both', 'keyval': 'target_community', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ignore-as'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_instance=evpn_instance, both=both)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_instance=evpn_instance, both=both)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_evpn_instance_route_target_export_delete(self, rbridge_id=None, evpn_instance=None, export=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type evpn_instance: instance_name
    :param evpn_instance: Keyword argument tuple.

    :type instance_name: unicode
    :param instance_name: **evpn_instance** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    **Instance Keyword Argument Tuple**:

    :type export: target_community
    :param export: Keyword argument tuple.

    :type target_community: unicode
    :param target_community: **export** tuple argument:  auto;; Target VPN Extended Community

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.evpn_instance', u'evpn_instance'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.evpn_instance', u'evpn_instance')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.evpn_instance.route_target.export', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.evpn_instance.route_target.export', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'export', 'keyval': 'target_community', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_instance=evpn_instance, export=export)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_instance=evpn_instance, export=export)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_evpn_instance_route_target_import_delete(self, rbridge_id=None, evpn_instance=None, import_=None, ignore_as=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type evpn_instance: instance_name
    :param evpn_instance: Keyword argument tuple.

    :type instance_name: unicode
    :param instance_name: **evpn_instance** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    **Instance Keyword Argument Tuple**:

    :type import_: target_community
    :param import_: Keyword argument tuple.

    :type target_community: unicode
    :param target_community: **import_** tuple argument:  auto ;; Target VPN Extended Community

    **Instance Argument(s)**:

    :type ignore_as: YANGBool
    :param ignore_as: Ignore-as

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.evpn_instance', u'evpn_instance'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.evpn_instance', u'evpn_instance')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.evpn_instance.route_target.import_', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.evpn_instance.route_target.import_', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'import_', 'keyval': 'target_community', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_instance=evpn_instance, import_=import_, ignore_as=ignore_as)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_instance=evpn_instance, import_=import_, ignore_as=ignore_as)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_evpn_instance_route_target_import_ignore_as_delete(self, rbridge_id=None, evpn_instance=None, import_=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type evpn_instance: instance_name
    :param evpn_instance: Keyword argument tuple.

    :type instance_name: unicode
    :param instance_name: **evpn_instance** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    **Instance Keyword Argument Tuple**:

    :type import_: target_community
    :param import_: Keyword argument tuple.

    :type target_community: unicode
    :param target_community: **import_** tuple argument:  auto ;; Target VPN Extended Community

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.evpn_instance', u'evpn_instance'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.evpn_instance', u'evpn_instance')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.evpn_instance.route_target.import_', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.evpn_instance.route_target.import_', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'import_', 'keyval': 'target_community', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ignore-as'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_instance=evpn_instance, import_=import_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_instance=evpn_instance, import_=import_)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_evpn_instance_vni_add_delete(self, rbridge_id=None, evpn_instance=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type evpn_instance: instance_name
    :param evpn_instance: Keyword argument tuple.

    :type instance_name: unicode
    :param instance_name: **evpn_instance** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.evpn_instance', u'evpn_instance'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.evpn_instance', u'evpn_instance')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.evpn_instance.vni.vni_add', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.evpn_instance.vni.vni_add', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'add'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_instance=evpn_instance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_instance=evpn_instance)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_evpn_instance_vni_evpn_vni_delete(self, rbridge_id=None, evpn_instance=None, evpn_vni=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type evpn_instance: instance_name
    :param evpn_instance: Keyword argument tuple.

    :type instance_name: unicode
    :param instance_name: **evpn_instance** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    **Instance Keyword Argument Tuple**:

    :type evpn_vni: vni_number
    :param evpn_vni: Keyword argument tuple.

    :type vni_number: long
    :param vni_number: **evpn_vni** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.evpn_instance', u'evpn_instance'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.evpn_instance', u'evpn_instance')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.evpn_instance.vni.evpn_vni', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.evpn_instance.vni.evpn_vni', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'evpn_vni', 'keyval': 'vni_number', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_instance=evpn_instance, evpn_vni=evpn_vni)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_instance=evpn_instance, evpn_vni=evpn_vni)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_evpn_instance_vni_evpn_vni_rd_delete(self, rbridge_id=None, evpn_instance=None, evpn_vni=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type evpn_instance: instance_name
    :param evpn_instance: Keyword argument tuple.

    :type instance_name: unicode
    :param instance_name: **evpn_instance** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    **Instance Keyword Argument Tuple**:

    :type evpn_vni: vni_number
    :param evpn_vni: Keyword argument tuple.

    :type vni_number: long
    :param vni_number: **evpn_vni** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.evpn_instance', u'evpn_instance'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.evpn_instance', u'evpn_instance')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.evpn_instance.vni.evpn_vni', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.evpn_instance.vni.evpn_vni', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'evpn_vni', 'keyval': 'vni_number', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rd'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_instance=evpn_instance, evpn_vni=evpn_vni)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_instance=evpn_instance, evpn_vni=evpn_vni)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_evpn_instance_vni_evpn_vni_route_target_both_delete(self, rbridge_id=None, evpn_instance=None, evpn_vni=None, both=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type evpn_instance: instance_name
    :param evpn_instance: Keyword argument tuple.

    :type instance_name: unicode
    :param instance_name: **evpn_instance** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type evpn_vni: vni_number
    :param evpn_vni: Keyword argument tuple.

    :type vni_number: long
    :param vni_number: **evpn_vni** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type both: target_community
    :param both: Keyword argument tuple.

    :type target_community: unicode
    :param target_community: **both** tuple argument:  ASN:nn;; Target VPN Extended Community

        * pattern restriction: ::

            '(((([1-9][0-9]{0,3})|([1-5][0-9]{4})|(6[0-4][0-9'
            ']{3})|(65[0-4][0-9]{2})|(655[0-2][0-9])|(6553[0-'
            '5])):(([0-9][0-9]{0,8})|([1-3][0-9]{9})|(4[0-1]['
            '0-9]{8})|(42[0-8][0-9]{7})|(429[0-3][0-9]{6})|(4'
            '294[0-8][0-9]{5})|(42949[0-5][0-9]{4})|(429496[0'
            '-6][0-9]{3})|(4294967[0-1][0-9]{2})|(42949672[0-'
            '8][0-9])|(429496729[0-5])))|((([1-9][0-9]{0,8})|'
            '(4[0-1][0-9]{8})|(42[0-8][0-9]{7})|(429[0-3][0-9'
            ']{6})|(4294[0-8][0-9]{5})|(42949[0-5][0-9]{4})|('
            '429496[0-6][0-9]{3})|(4294967[0-1][0-9]{2})|(429'
            '49672[0-8][0-9])):(([1-9][0-9]{0,3})|([1-5][0-9]'
            '{4})|(6[0-4][0-9]{3})|(65[0-4][0-9]{2})|(655[0-2'
            '][0-9])|(6553[0-5])))|(((([1-9]|[1-9][0-9]|1[0-9'
            ']{2}|2[0-4][0-9]|25[0-5])\.)(([0-9]|[1-9][0-9]|1'
            '[0-9]{2}|2[0-4][0-9]|25[0-5])\.){2}([0-9]|[1-9]['
            '0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])):(([1-9][0-9'
            ']{0,3})|([1-5][0-9]{4})|(6[0-4][0-9]{3})|(65[0-4'
            '][0-9]{2})|(655[0-2][0-9])|(6553[0-5]))))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.evpn_instance', u'evpn_instance'), ('pybind.nos.v7_1_0.rbridge_id.evpn_instance.vni.evpn_vni', u'evpn_vni'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.evpn_instance', u'evpn_instance'), ('pybind.nos.v7_0_1b.rbridge_id.evpn_instance.vni.evpn_vni', u'evpn_vni')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.evpn_instance.vni.evpn_vni.route_target.both', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.evpn_instance.vni.evpn_vni.route_target.both', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}, {'keyval': 'vni_number', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}, {'keyval': 'vni_number', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'both', 'keyval': 'target_community', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_instance=evpn_instance, evpn_vni=evpn_vni, both=both)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_instance=evpn_instance, evpn_vni=evpn_vni, both=both)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_evpn_instance_vni_evpn_vni_route_target_export_delete(self, rbridge_id=None, evpn_instance=None, evpn_vni=None, export=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type evpn_instance: instance_name
    :param evpn_instance: Keyword argument tuple.

    :type instance_name: unicode
    :param instance_name: **evpn_instance** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type evpn_vni: vni_number
    :param evpn_vni: Keyword argument tuple.

    :type vni_number: long
    :param vni_number: **evpn_vni** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type export: target_community
    :param export: Keyword argument tuple.

    :type target_community: unicode
    :param target_community: **export** tuple argument:  ASN:nn;; Target VPN Extended Community

        * pattern restriction: ::

            '(((([1-9][0-9]{0,3})|([1-5][0-9]{4})|(6[0-4][0-9'
            ']{3})|(65[0-4][0-9]{2})|(655[0-2][0-9])|(6553[0-'
            '5])):(([0-9][0-9]{0,8})|([1-3][0-9]{9})|(4[0-1]['
            '0-9]{8})|(42[0-8][0-9]{7})|(429[0-3][0-9]{6})|(4'
            '294[0-8][0-9]{5})|(42949[0-5][0-9]{4})|(429496[0'
            '-6][0-9]{3})|(4294967[0-1][0-9]{2})|(42949672[0-'
            '8][0-9])|(429496729[0-5])))|((([1-9][0-9]{0,8})|'
            '(4[0-1][0-9]{8})|(42[0-8][0-9]{7})|(429[0-3][0-9'
            ']{6})|(4294[0-8][0-9]{5})|(42949[0-5][0-9]{4})|('
            '429496[0-6][0-9]{3})|(4294967[0-1][0-9]{2})|(429'
            '49672[0-8][0-9])):(([1-9][0-9]{0,3})|([1-5][0-9]'
            '{4})|(6[0-4][0-9]{3})|(65[0-4][0-9]{2})|(655[0-2'
            '][0-9])|(6553[0-5])))|(((([1-9]|[1-9][0-9]|1[0-9'
            ']{2}|2[0-4][0-9]|25[0-5])\.)(([0-9]|[1-9][0-9]|1'
            '[0-9]{2}|2[0-4][0-9]|25[0-5])\.){2}([0-9]|[1-9]['
            '0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])):(([1-9][0-9'
            ']{0,3})|([1-5][0-9]{4})|(6[0-4][0-9]{3})|(65[0-4'
            '][0-9]{2})|(655[0-2][0-9])|(6553[0-5]))))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.evpn_instance', u'evpn_instance'), ('pybind.nos.v7_1_0.rbridge_id.evpn_instance.vni.evpn_vni', u'evpn_vni'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.evpn_instance', u'evpn_instance'), ('pybind.nos.v7_0_1b.rbridge_id.evpn_instance.vni.evpn_vni', u'evpn_vni')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.evpn_instance.vni.evpn_vni.route_target.export', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.evpn_instance.vni.evpn_vni.route_target.export', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}, {'keyval': 'vni_number', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}, {'keyval': 'vni_number', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'export', 'keyval': 'target_community', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_instance=evpn_instance, evpn_vni=evpn_vni, export=export)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_instance=evpn_instance, evpn_vni=evpn_vni, export=export)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_evpn_instance_vni_evpn_vni_route_target_import_delete(self, rbridge_id=None, evpn_instance=None, evpn_vni=None, import_=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type evpn_instance: instance_name
    :param evpn_instance: Keyword argument tuple.

    :type instance_name: unicode
    :param instance_name: **evpn_instance** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type evpn_vni: vni_number
    :param evpn_vni: Keyword argument tuple.

    :type vni_number: long
    :param vni_number: **evpn_vni** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type import_: target_community
    :param import_: Keyword argument tuple.

    :type target_community: unicode
    :param target_community: **import_** tuple argument:  ASN:nn;; Target VPN Extended Community

        * pattern restriction: ::

            '(((([1-9][0-9]{0,3})|([1-5][0-9]{4})|(6[0-4][0-9'
            ']{3})|(65[0-4][0-9]{2})|(655[0-2][0-9])|(6553[0-'
            '5])):(([0-9][0-9]{0,8})|([1-3][0-9]{9})|(4[0-1]['
            '0-9]{8})|(42[0-8][0-9]{7})|(429[0-3][0-9]{6})|(4'
            '294[0-8][0-9]{5})|(42949[0-5][0-9]{4})|(429496[0'
            '-6][0-9]{3})|(4294967[0-1][0-9]{2})|(42949672[0-'
            '8][0-9])|(429496729[0-5])))|((([1-9][0-9]{0,8})|'
            '(4[0-1][0-9]{8})|(42[0-8][0-9]{7})|(429[0-3][0-9'
            ']{6})|(4294[0-8][0-9]{5})|(42949[0-5][0-9]{4})|('
            '429496[0-6][0-9]{3})|(4294967[0-1][0-9]{2})|(429'
            '49672[0-8][0-9])):(([1-9][0-9]{0,3})|([1-5][0-9]'
            '{4})|(6[0-4][0-9]{3})|(65[0-4][0-9]{2})|(655[0-2'
            '][0-9])|(6553[0-5])))|(((([1-9]|[1-9][0-9]|1[0-9'
            ']{2}|2[0-4][0-9]|25[0-5])\.)(([0-9]|[1-9][0-9]|1'
            '[0-9]{2}|2[0-4][0-9]|25[0-5])\.){2}([0-9]|[1-9]['
            '0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])):(([1-9][0-9'
            ']{0,3})|([1-5][0-9]{4})|(6[0-4][0-9]{3})|(65[0-4'
            '][0-9]{2})|(655[0-2][0-9])|(6553[0-5]))))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.evpn_instance', u'evpn_instance'), ('pybind.nos.v7_1_0.rbridge_id.evpn_instance.vni.evpn_vni', u'evpn_vni'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.evpn_instance', u'evpn_instance'), ('pybind.nos.v7_0_1b.rbridge_id.evpn_instance.vni.evpn_vni', u'evpn_vni')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.evpn_instance.vni.evpn_vni.route_target.import_', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.evpn_instance.vni.evpn_vni.route_target.import_', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}, {'keyval': 'vni_number', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}, {'keyval': 'vni_number', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'import_', 'keyval': 'target_community', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_instance=evpn_instance, evpn_vni=evpn_vni, import_=import_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_instance=evpn_instance, evpn_vni=evpn_vni, import_=import_)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_evpn_instance_vni_remove_delete(self, rbridge_id=None, evpn_instance=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type evpn_instance: instance_name
    :param evpn_instance: Keyword argument tuple.

    :type instance_name: unicode
    :param instance_name: **evpn_instance** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.evpn_instance', u'evpn_instance'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.evpn_instance', u'evpn_instance')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.evpn_instance.vni.vni_add', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.evpn_instance.vni.vni_add', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'remove'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_instance=evpn_instance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_instance=evpn_instance)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_evpn_instance_vni_vni_add_delete(self, rbridge_id=None, evpn_instance=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type evpn_instance: instance_name
    :param evpn_instance: Keyword argument tuple.

    :type instance_name: unicode
    :param instance_name: **evpn_instance** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.evpn_instance', u'evpn_instance'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.evpn_instance', u'evpn_instance')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.evpn_instance.vni.vni_add', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.evpn_instance.vni.vni_add', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_instance=evpn_instance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_instance=evpn_instance)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_fabric_ecmp_load_balance_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.fabric.ecmp', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.fabric.ecmp', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.fabric.ecmp', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.fabric.ecmp', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'load-balance'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_fabric_ecmp_load_balance_hash_swap_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.fabric.ecmp', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.fabric.ecmp', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.fabric.ecmp', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.fabric.ecmp', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'load-balance-hash-swap'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_fabric_login_policy_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.fabric.login_policy', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.fabric.login_policy', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.fabric.login_policy', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.fabric.login_policy', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_fabric_login_policy_duplicatewwn_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.fabric.login_policy.duplicateWWN', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.fabric.login_policy.duplicateWWN', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.fabric.login_policy.duplicateWWN', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.fabric.login_policy.duplicateWWN', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_fabric_login_policy_duplicatewwn_precedence_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.fabric.login_policy.duplicateWWN', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.fabric.login_policy.duplicateWWN', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.fabric.login_policy.duplicateWWN', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.fabric.login_policy.duplicateWWN', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'precedence'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_fabric_neighbor_discovery_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.fabric', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.fabric', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'neighbor-discovery'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_fabric_port_channel_load_balance_delete(self, rbridge_id=None, port_channel=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type port_channel: po_id
    :param port_channel: Keyword argument tuple.

    :type po_id: long
    :param po_id: **port_channel** tuple argument:  Port-channel id

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.fabric.port_channel', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.fabric.port_channel', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.fabric.port_channel', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.fabric.port_channel', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'port_channel', 'keyval': 'po_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'load-balance'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, port_channel=port_channel)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_fabric_route_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.fabric.route', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.fabric.route', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.fabric.route', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.fabric.route', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_fabric_route_mcast_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.fabric.route.mcast', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.fabric.route.mcast', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.fabric.route.mcast', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.fabric.route.mcast', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_fabric_route_mcast_priority_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.fabric.route.mcast', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.fabric.route.mcast', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.fabric.route.mcast', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.fabric.route.mcast', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_fcoe_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.fcoe_config', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.fcoe_config', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.fcoe_config', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.fcoe_config', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_fcoe_fabric_map_delete(self, rbridge_id=None, fcoe_enode_fabric_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type fcoe_enode_fabric_map: fcoe_enode_fabric_map_name
    :param fcoe_enode_fabric_map: Keyword argument tuple.

    :type fcoe_enode_fabric_map_name: unicode
    :param fcoe_enode_fabric_map_name: **fcoe_enode_fabric_map** tuple argument:  Configure an FCoE Fabric-map 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            'default'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.fcoe_config.fcoe_enode_fabric_map', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.fcoe_config.fcoe_enode_fabric_map', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.fcoe_config.fcoe_enode_fabric_map', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.fcoe_config.fcoe_enode_fabric_map', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'fcoe_enode_fabric_map', 'keyval': 'fcoe_enode_fabric_map_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, fcoe_enode_fabric_map=fcoe_enode_fabric_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, fcoe_enode_fabric_map=fcoe_enode_fabric_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_fcoe_fcoe_enodes_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.fcoe_config', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.fcoe_config', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.fcoe_config', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.fcoe_config', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'fcoe-enodes'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_fcsp_auth_auth_type_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.fcsp.auth.proto', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.fcsp.auth.proto', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.fcsp.auth.proto', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'auth-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_fcsp_auth_group_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.fcsp.auth.proto', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.fcsp.auth.proto', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.fcsp.auth.proto', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'group'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_fcsp_auth_hash_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.fcsp.auth.proto', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.fcsp.auth.proto', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.fcsp.auth.proto', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hash'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_fcsp_auth_policy_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.fcsp.auth.policy', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.fcsp.auth.policy', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.fcsp.auth.policy', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_fcsp_auth_policy_switch_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.fcsp.auth.policy', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.fcsp.auth.policy', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.fcsp.auth.policy', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'switch'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_fcsp_auth_proto_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.fcsp.auth.proto', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.fcsp.auth.proto', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.fcsp.auth.proto', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_filter_change_update_delay_delete(self, rbridge_id=None, filter_change_update_delay=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type filter_change_update_delay: filter_delay_value
    :param filter_change_update_delay: Keyword argument tuple.

    :type filter_delay_value: long
    :param filter_delay_value: **filter_change_update_delay** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.filter_change_update_delay', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.filter_change_update_delay', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.filter_change_update_delay', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'filter_change_update_delay', 'keyval': 'filter_delay_value', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, filter_change_update_delay=filter_change_update_delay)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, filter_change_update_delay=filter_change_update_delay)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_hardware_profile_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.hardware_profile', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.hardware_profile', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.hardware_profile', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_hardware_profile_kap_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.hardware_profile.kap', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.hardware_profile.kap', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.hardware_profile.kap', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_hardware_profile_kap_custom_profile_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.hardware_profile.kap.customized', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.hardware_profile.kap.customized', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.hardware_profile.kap.customized', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_hardware_profile_kap_custom_profile_kap_profilename_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.hardware_profile.kap.customized', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.hardware_profile.kap.customized', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.hardware_profile.kap.customized', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'kap_profilename'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_hardware_profile_kap_kap_profiletype_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.hardware_profile.kap.predefined', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.hardware_profile.kap.predefined', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.hardware_profile.kap.predefined', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'kap_profiletype'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_hardware_profile_kap_predefined_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.hardware_profile.kap.predefined', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.hardware_profile.kap.predefined', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.hardware_profile.kap.predefined', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_hardware_profile_route_table_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.hardware_profile.route_table', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.hardware_profile.route_table', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.hardware_profile.route_table', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_hardware_profile_route_table_maximum_paths_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.hardware_profile.route_table.predefined.routing_parameter', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.hardware_profile.route_table.predefined.routing_parameter', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.hardware_profile.route_table.predefined.routing_parameter', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'maximum_paths'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_hardware_profile_route_table_openflow_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.hardware_profile.route_table.predefined.routing_parameter', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.hardware_profile.route_table.predefined.routing_parameter', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.hardware_profile.route_table.predefined.routing_parameter', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'openflow'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_hardware_profile_route_table_predefined_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.hardware_profile.route_table.predefined', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.hardware_profile.route_table.predefined', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.hardware_profile.route_table.predefined', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'routing_profiletype'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_hardware_profile_route_table_routing_parameter_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.hardware_profile.route_table.predefined.routing_parameter', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.hardware_profile.route_table.predefined.routing_parameter', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.hardware_profile.route_table.predefined.routing_parameter', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'maximum_paths, openflow_enable'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_hardware_profile_route_table_routing_profiletype_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.hardware_profile.route_table.predefined', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.hardware_profile.route_table.predefined', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.hardware_profile.route_table.predefined', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'routing_profiletype'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_hardware_profile_tcam_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.hardware_profile.tcam', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.hardware_profile.tcam', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.hardware_profile.tcam', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_hardware_profile_tcam_predefined_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.hardware_profile.tcam.predefined', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.hardware_profile.tcam.predefined', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.hardware_profile.tcam.predefined', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_hardware_profile_tcam_tcam_profiletype_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.hardware_profile.tcam.predefined', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.hardware_profile.tcam.predefined', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.hardware_profile.tcam.predefined', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tcam_profiletype'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_hardware_profile_vlan_classification_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.hardware_profile.vlan_classification', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.hardware_profile.vlan_classification', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.hardware_profile.vlan_classification', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_hardware_profile_vlan_classification_predefined_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.hardware_profile.vlan_classification.predefined', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.hardware_profile.vlan_classification.predefined', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.hardware_profile.vlan_classification.predefined', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_hardware_profile_vlan_classification_vlan_profiletype_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.hardware_profile.vlan_classification.predefined', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.hardware_profile.vlan_classification.predefined', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.hardware_profile.vlan_classification.predefined', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vlan_profiletype'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_host_table_aging_mode_conversational_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.host_table.aging_mode', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.host_table.aging_mode', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'conversational'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_host_table_aging_time_conversational_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.host_table.aging_time', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.host_table.aging_time', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'conversational'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_http_server_http_vrf_cont_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.http.server.http_vrf_cont', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.http.server.http_vrf_cont', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_http_server_shutdown_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.http.server', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.http.server', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.http.server', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'shutdown'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_http_server_use_vrf_delete(self, rbridge_id=None, use_vrf=None, http_vrf_shutdown=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type use_vrf: use_vrf_name, http_vrf_shutdown
    :param use_vrf: Keyword argument tuple.

    :type use_vrf_name: unicode
    :param use_vrf_name: **use_vrf** tuple argument.

        * length restriction: ::

            ['0..max']

    :type http_vrf_shutdown: YANGBool
    :param http_vrf_shutdown: **use_vrf** tuple argument:  Shutdown HTTP/HTTPS server on the given vrf

    **Instance Argument(s)**:

    :type http_vrf_shutdown: YANGBool
    :param http_vrf_shutdown: Shutdown HTTP/HTTPS server on the given vrf

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.http.server.http_vrf_cont.use_vrf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.http.server.http_vrf_cont.use_vrf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'use_vrf', 'keyval': 'use_vrf_name', 'extra_keyval': 'use_vrf_name, secure_and_plain, http_vrf_shutdown'}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v7_0_1b.rbridge_id.http.server.http_vrf_cont.use_vrf": {"http_vrf_shutdown": "http_vrf_shutdown", "use_vrf_name": "use_vrf_name"}, "pybind.nos.v7_1_0.rbridge_id.http.server.http_vrf_cont.use_vrf": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, use_vrf=use_vrf, http_vrf_shutdown=http_vrf_shutdown)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, use_vrf=use_vrf, http_vrf_shutdown=http_vrf_shutdown)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_http_server_use_vrf_secure_and_plain_delete(self, rbridge_id=None, use_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type use_vrf: use_vrf_name
    :param use_vrf: Keyword argument tuple.

    :type use_vrf_name: unicode
    :param use_vrf_name: **use_vrf** tuple argument.

        * length restriction: ::

            ['0..max']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_1_0.rbridge_id.http.server.http_vrf_cont.use_vrf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'use_vrf', 'keyval': 'use_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'secure-and-plain'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, use_vrf=use_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, use_vrf=use_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_http_server_use_vrf_shutdown_delete(self, rbridge_id=None, use_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type use_vrf: use_vrf_name
    :param use_vrf: Keyword argument tuple.

    :type use_vrf_name: unicode
    :param use_vrf_name: **use_vrf** tuple argument.

        * length restriction: ::

            ['0..max']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.http.server.http_vrf_cont.use_vrf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.http.server.http_vrf_cont.use_vrf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'use_vrf', 'keyval': 'use_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'shutdown'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, use_vrf=use_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, use_vrf=use_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_loopback_delete(self, rbridge_id=None, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.loopback', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'loopback', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_loopback_ip_address_delete(self, rbridge_id=None, loopback=None, address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type address: address
    :param address: Keyword argument tuple.

    :type address: unicode
    :param address: **address** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]'
            '|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0'
            '-4][0-9]|25[0-5])/32'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.loopback.ip.ip_config.address', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback.ip.ip_config.address', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback.ip.ip_config.address', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'address', 'keyval': 'address', 'extra_keyval': 'address'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback, address=address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback, address=address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_loopback_ip_interface_loopback_ospf_conf_delete(self, rbridge_id=None, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_loopback_ip_ip_config_delete(self, rbridge_id=None, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.loopback.ip.ip_config', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback.ip.ip_config', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback.ip.ip_config', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_loopback_ip_multicast_boundary_delete(self, rbridge_id=None, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v7_1_0.rbridge_id.interface.loopback.ip.pim_intf_lo_cont.pim_int_cmd', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'multicast-boundary'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_loopback_ip_ospf_active_delete(self, rbridge_id=None, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'active'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_loopback_ip_ospf_area_delete(self, rbridge_id=None, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'area'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_loopback_ip_ospf_auth_change_wait_time_delete(self, rbridge_id=None, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'auth-change-wait-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_loopback_ip_ospf_authentication_key_delete(self, rbridge_id=None, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config.authentication_key', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config.authentication_key', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config.authentication_key', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_loopback_ip_ospf_authentication_key_auth_key_delete(self, rbridge_id=None, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config.authentication_key.auth_key_table', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config.authentication_key.auth_key_table', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config.authentication_key.auth_key_table', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'auth-key'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_loopback_ip_ospf_authentication_key_auth_key_table_delete(self, rbridge_id=None, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config.authentication_key.auth_key_table', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config.authentication_key.auth_key_table', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config.authentication_key.auth_key_table', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'encrypttype, auth_key'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_loopback_ip_ospf_authentication_key_encrypttype_delete(self, rbridge_id=None, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config.authentication_key.auth_key_table', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config.authentication_key.auth_key_table', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config.authentication_key.auth_key_table', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'encrypttype'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_loopback_ip_ospf_authentication_key_no_encrypt_auth_key_delete(self, rbridge_id=None, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config.authentication_key.no_encrypt_auth_key_table', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config.authentication_key.no_encrypt_auth_key_table', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config.authentication_key.no_encrypt_auth_key_table', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'no-encrypt-auth-key'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_loopback_ip_ospf_authentication_key_no_encrypt_auth_key_table_delete(self, rbridge_id=None, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config.authentication_key.no_encrypt_auth_key_table', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config.authentication_key.no_encrypt_auth_key_table', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config.authentication_key.no_encrypt_auth_key_table', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_loopback_ip_ospf_bfd_delete(self, rbridge_id=None, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config.bfd', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config.bfd', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config.bfd', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_loopback_ip_ospf_bfd_intf_bfd_enable_delete(self, rbridge_id=None, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config.bfd', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config.bfd', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config.bfd', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'intf-bfd-enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_loopback_ip_ospf_cost_delete(self, rbridge_id=None, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cost'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_loopback_ip_ospf_database_filter_all_external_delete(self, rbridge_id=None, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'all-external'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_loopback_ip_ospf_database_filter_all_out_delete(self, rbridge_id=None, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'all-out'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_loopback_ip_ospf_database_filter_all_summary_external_delete(self, rbridge_id=None, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'all-summary-external'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_loopback_ip_ospf_dead_interval_delete(self, rbridge_id=None, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dead-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_loopback_ip_ospf_hello_interval_delete(self, rbridge_id=None, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hello-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_loopback_ip_ospf_md5_authentication_key_delete(self, rbridge_id=None, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config.md5_authentication.no_encrypt_key_table', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config.md5_authentication.no_encrypt_key_table', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config.md5_authentication.no_encrypt_key_table', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'key'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_loopback_ip_ospf_md5_authentication_key_activation_wait_time_delete(self, rbridge_id=None, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config.md5_authentication', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config.md5_authentication', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config.md5_authentication', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'key-activation-wait-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_loopback_ip_ospf_md5_authentication_key_id_delete(self, rbridge_id=None, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config.md5_authentication.no_encrypt_key_table', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config.md5_authentication.no_encrypt_key_table', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config.md5_authentication.no_encrypt_key_table', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'key-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_loopback_ip_ospf_md5_authentication_key_id_key_delete(self, rbridge_id=None, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config.md5_authentication.key_table', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config.md5_authentication.key_table', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config.md5_authentication.key_table', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'key'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_loopback_ip_ospf_md5_authentication_key_id_key_id_delete(self, rbridge_id=None, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config.md5_authentication.key_table', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config.md5_authentication.key_table', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config.md5_authentication.key_table', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'key-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_loopback_ip_ospf_md5_authentication_key_id_md5_authentication_key_delete(self, rbridge_id=None, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config.md5_authentication.key_table', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config.md5_authentication.key_table', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config.md5_authentication.key_table', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'md5-authentication-key'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_loopback_ip_ospf_mtu_ignore_delete(self, rbridge_id=None, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mtu-ignore'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_loopback_ip_ospf_network_delete(self, rbridge_id=None, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'network'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_loopback_ip_ospf_passive_delete(self, rbridge_id=None, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'passive'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_loopback_ip_ospf_priority_delete(self, rbridge_id=None, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_loopback_ip_ospf_retransmit_interval_delete(self, rbridge_id=None, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'retransmit-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_loopback_ip_ospf_transmit_delay_delete(self, rbridge_id=None, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'transmit-delay'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_loopback_ip_pim_dr_priority_delete(self, rbridge_id=None, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v7_1_0.rbridge_id.interface.loopback.ip.pim_intf_lo_cont.pim_int_cmd.pim', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dr-priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_loopback_ip_pim_int_cmd_delete(self, rbridge_id=None, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v7_1_0.rbridge_id.interface.loopback.ip.pim_intf_lo_cont.pim_int_cmd', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_loopback_ip_pim_intf_lo_cont_delete(self, rbridge_id=None, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v7_1_0.rbridge_id.interface.loopback.ip.pim_intf_lo_cont', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_loopback_ip_pim_multinet_enable_delete(self, rbridge_id=None, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v7_1_0.rbridge_id.interface.loopback.ip.pim_intf_lo_cont.pim_int_cmd.pim.multinet', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_loopback_ip_pim_neighbor_filter_delete(self, rbridge_id=None, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v7_1_0.rbridge_id.interface.loopback.ip.pim_intf_lo_cont.pim_int_cmd.pim', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'neighbor-filter'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_loopback_ip_pim_sparse_delete(self, rbridge_id=None, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v7_1_0.rbridge_id.interface.loopback.ip.pim_intf_lo_cont.pim_int_cmd', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'pim-sparse'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_loopback_ipv6_address_delete(self, rbridge_id=None, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.loopback.ipv6.ipv6_config.address', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback.ipv6.ipv6_config.address', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback.ipv6.ipv6_config.address', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_loopback_ipv6_address_ipv6_address_delete(self, rbridge_id=None, loopback=None, ipv6_address=None, eui64=None, anycast=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ipv6_address: address, eui64, anycast
    :param ipv6_address: Keyword argument tuple.

    :type address: unicode
    :param address: **ipv6_address** tuple argument:  A:B::C:D/LEN;; IPv6 prefix format: xxxx:xxxx/ml, xxxx:xxxx::/ml, xxxx::xx/128

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type eui64: YANGBool
    :param eui64: **ipv6_address** tuple argument:  Configure ipv6 address with an automatically computed EUI-64 interface Id

    :type anycast: YANGBool
    :param anycast: **ipv6_address** tuple argument:  Configure ipv6 address as anycast

    **Instance Argument(s)**:

    :type eui64: YANGBool
    :param eui64: Configure ipv6 address with an automatically computed EUI-64 interface Id

    :type anycast: YANGBool
    :param anycast: Configure ipv6 address as anycast

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.loopback.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_address', 'keyval': 'address', 'extra_keyval': 'address, eui64, anycast'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback, ipv6_address=ipv6_address, eui64=eui64, anycast=anycast)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback, ipv6_address=ipv6_address, eui64=eui64, anycast=anycast)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_loopback_ipv6_address_ipv6_address_anycast_delete(self, rbridge_id=None, loopback=None, ipv6_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ipv6_address: address
    :param ipv6_address: Keyword argument tuple.

    :type address: unicode
    :param address: **ipv6_address** tuple argument:  A:B::C:D/LEN;; IPv6 prefix format: xxxx:xxxx/ml, xxxx:xxxx::/ml, xxxx::xx/128

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.loopback.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_address', 'keyval': 'address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'anycast'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback, ipv6_address=ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback, ipv6_address=ipv6_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_loopback_ipv6_address_ipv6_address_eui_64_delete(self, rbridge_id=None, loopback=None, ipv6_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ipv6_address: address
    :param ipv6_address: Keyword argument tuple.

    :type address: unicode
    :param address: **ipv6_address** tuple argument:  A:B::C:D/LEN;; IPv6 prefix format: xxxx:xxxx/ml, xxxx:xxxx::/ml, xxxx::xx/128

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.loopback.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_address', 'keyval': 'address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'eui-64'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback, ipv6_address=ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback, ipv6_address=ipv6_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_loopback_ipv6_address_link_local_delete(self, rbridge_id=None, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.loopback.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'link-local'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_loopback_ipv6_address_link_local_address_delete(self, rbridge_id=None, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.loopback.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'link-local-address'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_loopback_ipv6_address_link_local_config_delete(self, rbridge_id=None, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.loopback.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'link_local_address, link_local'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_loopback_ipv6_address_use_link_local_only_delete(self, rbridge_id=None, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.loopback.ipv6.ipv6_config.address', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback.ipv6.ipv6_config.address', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback.ipv6.ipv6_config.address', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'use-link-local-only'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_loopback_ipv6_ipv6_config_delete(self, rbridge_id=None, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.loopback.ipv6.ipv6_config', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback.ipv6.ipv6_config', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback.ipv6.ipv6_config', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_loopback_ipv6_ospf_active_delete(self, rbridge_id=None, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'active'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_loopback_ipv6_ospf_area_delete(self, rbridge_id=None, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'area'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_loopback_ipv6_ospf_authentication_ah_delete(self, rbridge_id=None, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ah'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_loopback_ipv6_ospf_authentication_esp_delete(self, rbridge_id=None, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'esp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_loopback_ipv6_ospf_authentication_esp_auth_delete(self, rbridge_id=None, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'esp-auth'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_loopback_ipv6_ospf_authentication_esp_key_delete(self, rbridge_id=None, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'esp-key'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_loopback_ipv6_ospf_authentication_esp_no_encrypt_delete(self, rbridge_id=None, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'esp-no-encrypt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_loopback_ipv6_ospf_authentication_ipsec_delete(self, rbridge_id=None, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_loopback_ipv6_ospf_authentication_ipsec_disable_delete(self, rbridge_id=None, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'disable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_loopback_ipv6_ospf_authentication_ipsec_key_add_remove_interval_delete(self, rbridge_id=None, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'key-add-remove-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_loopback_ipv6_ospf_authentication_key_delete(self, rbridge_id=None, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'key'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_loopback_ipv6_ospf_authentication_no_encrypt_delete(self, rbridge_id=None, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'no-encrypt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_loopback_ipv6_ospf_authentication_spi_delete(self, rbridge_id=None, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'spi'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_loopback_ipv6_ospf_bfd_delete(self, rbridge_id=None, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf.bfd', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf.bfd', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf.bfd', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_loopback_ipv6_ospf_bfd_bfd_enable_delete(self, rbridge_id=None, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf.bfd', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf.bfd', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf.bfd', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bfd-enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_loopback_ipv6_ospf_cost_delete(self, rbridge_id=None, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cost'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_loopback_ipv6_ospf_dead_interval_delete(self, rbridge_id=None, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dead-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_loopback_ipv6_ospf_hello_interval_delete(self, rbridge_id=None, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hello-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_loopback_ipv6_ospf_hello_jitter_delete(self, rbridge_id=None, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hello-jitter'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_loopback_ipv6_ospf_instance_delete(self, rbridge_id=None, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'instance'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_loopback_ipv6_ospf_link_interval_properties_delete(self, rbridge_id=None, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_loopback_ipv6_ospf_mtu_ignore_delete(self, rbridge_id=None, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mtu-ignore'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_loopback_ipv6_ospf_network_delete(self, rbridge_id=None, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'network'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_loopback_ipv6_ospf_passive_delete(self, rbridge_id=None, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'passive'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_loopback_ipv6_ospf_priority_delete(self, rbridge_id=None, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_loopback_ipv6_ospf_retransmit_interval_delete(self, rbridge_id=None, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'retransmit-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_loopback_ipv6_ospf_suppress_linklsa_delete(self, rbridge_id=None, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'suppress-linklsa'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_loopback_ipv6_ospf_transmit_delay_delete(self, rbridge_id=None, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'transmit-delay'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_loopback_shutdown_delete(self, rbridge_id=None, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.loopback.intf_loopback', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback.intf_loopback', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback.intf_loopback', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'shutdown'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_loopback_snmp_trap_link_status_delete(self, rbridge_id=None, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.loopback.snmp.trap', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback.snmp.trap', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback.snmp.trap', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'link-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_loopback_vrf_forwarding_delete(self, rbridge_id=None, loopback=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.loopback.vrf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.loopback.vrf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.loopback.vrf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'forwarding'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_nodespecific_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface_nodespecific', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface_nodespecific', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface_nodespecific', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.interface_nodespecific', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_nodespecific_ns_ethernet_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface_nodespecific', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface_nodespecific', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface_nodespecific', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.interface_nodespecific', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ns-ethernet'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_nodespecific_ns_vlan_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface_nodespecific', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface_nodespecific', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface_nodespecific', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.interface_nodespecific', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ns-vlan'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u've', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_bfd_interval_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.bfd.interval', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.bfd.interval', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.bfd.interval', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_bfd_interval_min_rx_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.bfd.interval', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.bfd.interval', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.bfd.interval', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'min-rx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_bfd_interval_min_tx_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.bfd.interval', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.bfd.interval', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.bfd.interval', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'min-tx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_bfd_interval_multiplier_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.bfd.interval', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.bfd.interval', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.bfd.interval', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'multiplier'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_bfd_shutdown_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.bfd', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.bfd', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.bfd', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'shutdown'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ip_access_group_delete(self, rbridge_id=None, ve=None, access_group=None, traffic_type=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type access_group: ip_access_list, ip_direction, traffic_type
    :param access_group: Keyword argument tuple.

    :type ip_access_list: unicode
    :param ip_access_list: **access_group** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type ip_direction: unicode
    :param ip_direction: **access_group** tuple argument.

        * enumeration restriction: ::

            ['in', 'out']

    :type traffic_type: unicode
    :param traffic_type: **access_group** tuple argument.

        * enumeration restriction: ::

            ['switched', 'routed']

    **Instance Argument(s)**:

    :type traffic_type: unicode
    :param traffic_type: Keyword argument.

        * enumeration restriction: ::

            ['switched', 'routed']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ip_acl_interface.ip.access_group', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ip_acl_interface.ip.access_group', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ip_acl_interface.ip.access_group', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'access_group', 'keyval': 'ip_access_list, ip_direction', 'extra_keyval': 'ip_access_list, ip_direction, traffic_type'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, access_group=access_group, traffic_type=traffic_type)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, access_group=access_group, traffic_type=traffic_type)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ip_address_delete(self, rbridge_id=None, ve=None, address=None, secondary=None, ospf_passive=None, ospf_ignore=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type address: address, secondary, ospf_passive, ospf_ignore
    :param address: Keyword argument tuple.

    :type address: unicode
    :param address: **address** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]'
            '|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0'
            '-4][0-9]|25[0-5])/(([1-9])|([1-2][0-9])|(3[0-1])'
            ')'

    :type secondary: YANGBool
    :param secondary: **address** tuple argument:  Secondary ip address on the specific interface

    :type ospf_passive: YANGBool
    :param ospf_passive: **address** tuple argument:  ospf pasive address on the specific interface

    :type ospf_ignore: YANGBool
    :param ospf_ignore: **address** tuple argument:  ospf active address on the specific interface

    **Instance Argument(s)**:

    :type secondary: YANGBool
    :param secondary: Secondary ip address on the specific interface

    :type ospf_passive: YANGBool
    :param ospf_passive: ospf pasive address on the specific interface

    :type ospf_ignore: YANGBool
    :param ospf_ignore: ospf active address on the specific interface

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ip.ip_config.address', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ip.ip_config.address', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ip.ip_config.address', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'address', 'keyval': 'address', 'extra_keyval': 'address, secondary, ospf_passive, ospf_ignore'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, address=address, secondary=secondary, ospf_passive=ospf_passive, ospf_ignore=ospf_ignore)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, address=address, secondary=secondary, ospf_passive=ospf_passive, ospf_ignore=ospf_ignore)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ip_address_ospf_ignore_delete(self, rbridge_id=None, ve=None, address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type address: address
    :param address: Keyword argument tuple.

    :type address: unicode
    :param address: **address** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]'
            '|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0'
            '-4][0-9]|25[0-5])/(([1-9])|([1-2][0-9])|(3[0-1])'
            ')'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ip.ip_config.address', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ip.ip_config.address', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ip.ip_config.address', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'address', 'keyval': 'address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ospf-ignore'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, address=address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, address=address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ip_address_ospf_passive_delete(self, rbridge_id=None, ve=None, address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type address: address
    :param address: Keyword argument tuple.

    :type address: unicode
    :param address: **address** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]'
            '|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0'
            '-4][0-9]|25[0-5])/(([1-9])|([1-2][0-9])|(3[0-1])'
            ')'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ip.ip_config.address', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ip.ip_config.address', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ip.ip_config.address', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'address', 'keyval': 'address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ospf-passive'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, address=address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, address=address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ip_address_secondary_delete(self, rbridge_id=None, ve=None, address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type address: address
    :param address: Keyword argument tuple.

    :type address: unicode
    :param address: **address** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]'
            '|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0'
            '-4][0-9]|25[0-5])/(([1-9])|([1-2][0-9])|(3[0-1])'
            ')'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ip.ip_config.address', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ip.ip_config.address', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ip.ip_config.address', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'address', 'keyval': 'address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'secondary'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, address=address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, address=address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ip_anycast_address_delete(self, rbridge_id=None, ve=None, ip_anycast_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ip_anycast_address: ip_address
    :param ip_anycast_address: Keyword argument tuple.

    :type ip_address: unicode
    :param ip_address: **ip_anycast_address** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]'
            '|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0'
            '-4][0-9]|25[0-5])/(([1-9])|([1-2][0-9])|(3[0-1])'
            ')'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ip.ip_anycast_address', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ip.ip_anycast_address', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ip_anycast_address', 'keyval': 'ip_address', 'extra_keyval': 'ip_address'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, ip_anycast_address=ip_anycast_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, ip_anycast_address=ip_anycast_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ip_arp_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ip.ip_config.arp', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ip.ip_config.arp', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ip_arp_aging_timeout_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ip.ip_config', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ip.ip_config', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ip.ip_config', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'arp-aging-timeout'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ip_arp_learn_any_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ip.ip_config.arp', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ip.ip_config.arp', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'learn-any'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ip_dhcp_relay_gateway_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ip.interface_ve_dhcp_conf.dhcp.relay', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ip.interface_ve_dhcp_conf.dhcp.relay', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ip.interface_ve_dhcp_conf.dhcp.relay', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'gateway'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ip_dhcp_relay_servers_delete(self, rbridge_id=None, ve=None, servers=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type servers: relay_ip_addr, server_vrf_name
    :param servers: Keyword argument tuple.

    :type relay_ip_addr: unicode
    :param relay_ip_addr: **servers** tuple argument:  A.B.C.D;; IP address of the DHCP server

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type server_vrf_name: unicode
    :param server_vrf_name: **servers** tuple argument:  VRF name of the DHCP server

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ip.interface_ve_dhcp_conf.dhcp.relay.servers', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ip.interface_ve_dhcp_conf.dhcp.relay.servers', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ip.interface_ve_dhcp_conf.dhcp.relay.servers', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'servers', 'keyval': 'relay_ip_addr, server_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, servers=servers)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, servers=servers)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ip_directed_broadcast_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ip.ip_config', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ip.ip_config', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ip.ip_config', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'directed-broadcast'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ip_fabric_virtual_gateway_delete(self, rbridge_id=None, ve=None, ip_local_anycast_gateway=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ip_local_anycast_gateway: local_ip_gw_id
    :param ip_local_anycast_gateway: Keyword argument tuple.

    :type local_ip_gw_id: long
    :param local_ip_gw_id: **ip_local_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ip.ip_local_anycast_gateway', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ip.ip_local_anycast_gateway', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ip.ip_local_anycast_gateway', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ip_local_anycast_gateway', 'keyval': 'local_ip_gw_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, ip_local_anycast_gateway=ip_local_anycast_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, ip_local_anycast_gateway=ip_local_anycast_gateway)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ip_fabric_virtual_gateway_disable_delete(self, rbridge_id=None, ve=None, ip_local_anycast_gateway=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ip_local_anycast_gateway: local_ip_gw_id
    :param ip_local_anycast_gateway: Keyword argument tuple.

    :type local_ip_gw_id: long
    :param local_ip_gw_id: **ip_local_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ip.ip_local_anycast_gateway', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ip.ip_local_anycast_gateway', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ip.ip_local_anycast_gateway', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ip_local_anycast_gateway', 'keyval': 'local_ip_gw_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'disable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, ip_local_anycast_gateway=ip_local_anycast_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, ip_local_anycast_gateway=ip_local_anycast_gateway)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ip_fabric_virtual_gateway_enable_delete(self, rbridge_id=None, ve=None, ip_local_anycast_gateway=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ip_local_anycast_gateway: local_ip_gw_id
    :param ip_local_anycast_gateway: Keyword argument tuple.

    :type local_ip_gw_id: long
    :param local_ip_gw_id: **ip_local_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ip.ip_local_anycast_gateway', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ip.ip_local_anycast_gateway', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ip.ip_local_anycast_gateway', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ip_local_anycast_gateway', 'keyval': 'local_ip_gw_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, ip_local_anycast_gateway=ip_local_anycast_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, ip_local_anycast_gateway=ip_local_anycast_gateway)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ip_fabric_virtual_gateway_load_balancing_delete(self, rbridge_id=None, ve=None, ip_local_anycast_gateway=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ip_local_anycast_gateway: local_ip_gw_id
    :param ip_local_anycast_gateway: Keyword argument tuple.

    :type local_ip_gw_id: long
    :param local_ip_gw_id: **ip_local_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ip.ip_local_anycast_gateway', u'ip_local_anycast_gateway'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ip.ip_local_anycast_gateway', u'ip_local_anycast_gateway'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ip.ip_local_anycast_gateway', u'ip_local_anycast_gateway')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ip.ip_local_anycast_gateway.load_balancing', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ip.ip_local_anycast_gateway.load_balancing', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ip.ip_local_anycast_gateway.load_balancing', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ip_gw_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ip_gw_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ip_gw_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, ip_local_anycast_gateway=ip_local_anycast_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, ip_local_anycast_gateway=ip_local_anycast_gateway)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ip_fabric_virtual_gateway_load_balancing_basic_delete(self, rbridge_id=None, ve=None, ip_local_anycast_gateway=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ip_local_anycast_gateway: local_ip_gw_id
    :param ip_local_anycast_gateway: Keyword argument tuple.

    :type local_ip_gw_id: long
    :param local_ip_gw_id: **ip_local_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ip.ip_local_anycast_gateway', u'ip_local_anycast_gateway'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ip.ip_local_anycast_gateway', u'ip_local_anycast_gateway'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ip.ip_local_anycast_gateway', u'ip_local_anycast_gateway')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ip.ip_local_anycast_gateway.load_balancing', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ip.ip_local_anycast_gateway.load_balancing', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ip.ip_local_anycast_gateway.load_balancing', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ip_gw_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ip_gw_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ip_gw_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'basic'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, ip_local_anycast_gateway=ip_local_anycast_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, ip_local_anycast_gateway=ip_local_anycast_gateway)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ip_fabric_virtual_gateway_load_balancing_threshold_priority_delete(self, rbridge_id=None, ve=None, ip_local_anycast_gateway=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ip_local_anycast_gateway: local_ip_gw_id
    :param ip_local_anycast_gateway: Keyword argument tuple.

    :type local_ip_gw_id: long
    :param local_ip_gw_id: **ip_local_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ip.ip_local_anycast_gateway', u'ip_local_anycast_gateway'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ip.ip_local_anycast_gateway', u'ip_local_anycast_gateway'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ip.ip_local_anycast_gateway', u'ip_local_anycast_gateway')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ip.ip_local_anycast_gateway.load_balancing', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ip.ip_local_anycast_gateway.load_balancing', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ip.ip_local_anycast_gateway.load_balancing', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ip_gw_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ip_gw_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ip_gw_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'threshold-priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, ip_local_anycast_gateway=ip_local_anycast_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, ip_local_anycast_gateway=ip_local_anycast_gateway)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ip_fabric_virtual_gateway_track_delete(self, rbridge_id=None, ve=None, ip_local_anycast_gateway=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ip_local_anycast_gateway: local_ip_gw_id
    :param ip_local_anycast_gateway: Keyword argument tuple.

    :type local_ip_gw_id: long
    :param local_ip_gw_id: **ip_local_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ip.ip_local_anycast_gateway', u'ip_local_anycast_gateway'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ip.ip_local_anycast_gateway', u'ip_local_anycast_gateway'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ip.ip_local_anycast_gateway', u'ip_local_anycast_gateway')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ip.ip_local_anycast_gateway.track', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ip.ip_local_anycast_gateway.track', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ip.ip_local_anycast_gateway.track', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ip_gw_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ip_gw_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ip_gw_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, ip_local_anycast_gateway=ip_local_anycast_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, ip_local_anycast_gateway=ip_local_anycast_gateway)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ip_fabric_virtual_gateway_track_interface_delete(self, rbridge_id=None, ve=None, ip_local_anycast_gateway=None, interface=None, interface_priority=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ip_local_anycast_gateway: local_ip_gw_id
    :param ip_local_anycast_gateway: Keyword argument tuple.

    :type local_ip_gw_id: long
    :param local_ip_gw_id: **ip_local_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Argument(s)**:

    :type interface_priority: long
    :param interface_priority: Track Priority

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ip.ip_local_anycast_gateway', u'ip_local_anycast_gateway'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ip.ip_local_anycast_gateway', u'ip_local_anycast_gateway'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ip.ip_local_anycast_gateway', u'ip_local_anycast_gateway')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ip.ip_local_anycast_gateway.track.interface', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ip.ip_local_anycast_gateway.track.interface', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ip.ip_local_anycast_gateway.track.interface', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ip_gw_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ip_gw_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ip_gw_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, ip_local_anycast_gateway=ip_local_anycast_gateway, interface=interface, interface_priority=interface_priority)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, ip_local_anycast_gateway=ip_local_anycast_gateway, interface=interface, interface_priority=interface_priority)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ip_fabric_virtual_gateway_track_interface_priority_delete(self, rbridge_id=None, ve=None, ip_local_anycast_gateway=None, interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ip_local_anycast_gateway: local_ip_gw_id
    :param ip_local_anycast_gateway: Keyword argument tuple.

    :type local_ip_gw_id: long
    :param local_ip_gw_id: **ip_local_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ip.ip_local_anycast_gateway', u'ip_local_anycast_gateway'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ip.ip_local_anycast_gateway', u'ip_local_anycast_gateway'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ip.ip_local_anycast_gateway', u'ip_local_anycast_gateway')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ip.ip_local_anycast_gateway.track.interface', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ip.ip_local_anycast_gateway.track.interface', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ip.ip_local_anycast_gateway.track.interface', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ip_gw_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ip_gw_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ip_gw_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, ip_local_anycast_gateway=ip_local_anycast_gateway, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, ip_local_anycast_gateway=ip_local_anycast_gateway, interface=interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ip_fabric_virtual_gateway_track_network_delete(self, rbridge_id=None, ve=None, ip_local_anycast_gateway=None, network=None, network_priority=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ip_local_anycast_gateway: local_ip_gw_id
    :param ip_local_anycast_gateway: Keyword argument tuple.

    :type local_ip_gw_id: long
    :param local_ip_gw_id: **ip_local_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type network: network_address
    :param network: Keyword argument tuple.

    :type network_address: unicode
    :param network_address: **network** tuple argument.

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]'
            '|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0'
            '-4][0-9]|25[0-5])/(([1-9])|([1-2][0-9])|(3[0-1])'
            ')'

    **Instance Argument(s)**:

    :type network_priority: long
    :param network_priority: Track Priority

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ip.ip_local_anycast_gateway', u'ip_local_anycast_gateway'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ip.ip_local_anycast_gateway', u'ip_local_anycast_gateway'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ip.ip_local_anycast_gateway', u'ip_local_anycast_gateway')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ip.ip_local_anycast_gateway.track.network', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ip.ip_local_anycast_gateway.track.network', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ip.ip_local_anycast_gateway.track.network', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ip_gw_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ip_gw_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ip_gw_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'network', 'keyval': 'network_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, ip_local_anycast_gateway=ip_local_anycast_gateway, network=network, network_priority=network_priority)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, ip_local_anycast_gateway=ip_local_anycast_gateway, network=network, network_priority=network_priority)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ip_fabric_virtual_gateway_track_network_priority_delete(self, rbridge_id=None, ve=None, ip_local_anycast_gateway=None, network=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ip_local_anycast_gateway: local_ip_gw_id
    :param ip_local_anycast_gateway: Keyword argument tuple.

    :type local_ip_gw_id: long
    :param local_ip_gw_id: **ip_local_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type network: network_address
    :param network: Keyword argument tuple.

    :type network_address: unicode
    :param network_address: **network** tuple argument.

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]'
            '|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0'
            '-4][0-9]|25[0-5])/(([1-9])|([1-2][0-9])|(3[0-1])'
            ')'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ip.ip_local_anycast_gateway', u'ip_local_anycast_gateway'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ip.ip_local_anycast_gateway', u'ip_local_anycast_gateway'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ip.ip_local_anycast_gateway', u'ip_local_anycast_gateway')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ip.ip_local_anycast_gateway.track.network', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ip.ip_local_anycast_gateway.track.network', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ip.ip_local_anycast_gateway.track.network', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ip_gw_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ip_gw_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ip_gw_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'network', 'keyval': 'network_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, ip_local_anycast_gateway=ip_local_anycast_gateway, network=network)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, ip_local_anycast_gateway=ip_local_anycast_gateway, network=network)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ip_fabric_virtual_gateway_track_next_hop_delete(self, rbridge_id=None, ve=None, ip_local_anycast_gateway=None, next_hop=None, next_hop_priority=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ip_local_anycast_gateway: local_ip_gw_id
    :param ip_local_anycast_gateway: Keyword argument tuple.

    :type local_ip_gw_id: long
    :param local_ip_gw_id: **ip_local_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type next_hop: next_hop_address
    :param next_hop: Keyword argument tuple.

    :type next_hop_address: unicode
    :param next_hop_address: **next_hop** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Argument(s)**:

    :type next_hop_priority: long
    :param next_hop_priority: Track Priority

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ip.ip_local_anycast_gateway', u'ip_local_anycast_gateway'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ip.ip_local_anycast_gateway', u'ip_local_anycast_gateway'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ip.ip_local_anycast_gateway', u'ip_local_anycast_gateway')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ip.ip_local_anycast_gateway.track.next_hop', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ip.ip_local_anycast_gateway.track.next_hop', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ip.ip_local_anycast_gateway.track.next_hop', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ip_gw_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ip_gw_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ip_gw_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'next_hop', 'keyval': 'next_hop_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, ip_local_anycast_gateway=ip_local_anycast_gateway, next_hop=next_hop, next_hop_priority=next_hop_priority)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, ip_local_anycast_gateway=ip_local_anycast_gateway, next_hop=next_hop, next_hop_priority=next_hop_priority)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ip_fabric_virtual_gateway_track_next_hop_priority_delete(self, rbridge_id=None, ve=None, ip_local_anycast_gateway=None, next_hop=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ip_local_anycast_gateway: local_ip_gw_id
    :param ip_local_anycast_gateway: Keyword argument tuple.

    :type local_ip_gw_id: long
    :param local_ip_gw_id: **ip_local_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type next_hop: next_hop_address
    :param next_hop: Keyword argument tuple.

    :type next_hop_address: unicode
    :param next_hop_address: **next_hop** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ip.ip_local_anycast_gateway', u'ip_local_anycast_gateway'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ip.ip_local_anycast_gateway', u'ip_local_anycast_gateway'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ip.ip_local_anycast_gateway', u'ip_local_anycast_gateway')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ip.ip_local_anycast_gateway.track.next_hop', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ip.ip_local_anycast_gateway.track.next_hop', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ip.ip_local_anycast_gateway.track.next_hop', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ip_gw_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ip_gw_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ip_gw_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'next_hop', 'keyval': 'next_hop_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, ip_local_anycast_gateway=ip_local_anycast_gateway, next_hop=next_hop)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, ip_local_anycast_gateway=ip_local_anycast_gateway, next_hop=next_hop)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ip_icmp_address_mask_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ip.icmp', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ip.icmp', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ip.icmp', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'address-mask'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ip_icmp_echo_reply_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ip.icmp', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ip.icmp', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ip.icmp', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'echo-reply'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ip_icmp_rate_limiting_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ip.icmp', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ip.icmp', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ip.icmp', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rate-limiting'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ip_icmp_redirect_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ip.icmp', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ip.icmp', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ip.icmp', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redirect'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ip_icmp_unreachable_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ip.icmp', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ip.icmp', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ip.icmp', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'unreachable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ip_igmp_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ip.igmp', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ip.igmp', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ip.igmp', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ip_igmp_immediate_leave_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ip.igmp', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ip.igmp', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ip.igmp', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'immediate-leave'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ip_igmp_last_member_query_interval_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ip.igmp', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ip.igmp', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ip.igmp', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'last-member-query-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ip_igmp_query_interval_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ip.igmp', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ip.igmp', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ip.igmp', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'query-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ip_igmp_query_max_response_time_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ip.igmp', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ip.igmp', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ip.igmp', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'query-max-response-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ip_igmp_static_group_delete(self, rbridge_id=None, ve=None, static_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type static_group: sg_addr
    :param static_group: Keyword argument tuple.

    :type sg_addr: unicode
    :param sg_addr: **static_group** tuple argument:  Multicast Address to be Joined in the format A.B.C.D

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ip.igmp.static_group', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ip.igmp.static_group', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ip.igmp.static_group', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'static_group', 'keyval': 'sg_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, static_group=static_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, static_group=static_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ip_interface_ve_dhcp_conf_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ip.interface_ve_dhcp_conf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ip.interface_ve_dhcp_conf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ip.interface_ve_dhcp_conf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ip_interface_vlan_ospf_conf_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ip_ip_config_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ip.ip_config', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ip.ip_config', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ip.ip_config', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ip_mtu_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ip.ip_config', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ip.ip_config', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ip.ip_config', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mtu'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ip_multicast_boundary_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ip.pim_intf_vlan_cont.pim_int_cmd', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ip.pim_intf_vlan_cont.pim_int_cmd', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ip.pim_intf_vlan_cont.pim_int_cmd', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'multicast-boundary'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ip_ospf_active_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'active'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ip_ospf_area_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'area'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ip_ospf_auth_change_wait_time_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'auth-change-wait-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ip_ospf_authentication_key_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config.authentication_key', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config.authentication_key', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config.authentication_key', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ip_ospf_authentication_key_auth_key_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config.authentication_key.auth_key_table', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config.authentication_key.auth_key_table', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config.authentication_key.auth_key_table', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'auth-key'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ip_ospf_authentication_key_auth_key_table_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config.authentication_key.auth_key_table', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config.authentication_key.auth_key_table', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config.authentication_key.auth_key_table', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'encrypttype, auth_key'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ip_ospf_authentication_key_encrypttype_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config.authentication_key.auth_key_table', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config.authentication_key.auth_key_table', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config.authentication_key.auth_key_table', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'encrypttype'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ip_ospf_authentication_key_no_encrypt_auth_key_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config.authentication_key.no_encrypt_auth_key_table', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config.authentication_key.no_encrypt_auth_key_table', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config.authentication_key.no_encrypt_auth_key_table', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'no-encrypt-auth-key'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ip_ospf_authentication_key_no_encrypt_auth_key_table_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config.authentication_key.no_encrypt_auth_key_table', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config.authentication_key.no_encrypt_auth_key_table', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config.authentication_key.no_encrypt_auth_key_table', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ip_ospf_bfd_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config.bfd', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config.bfd', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config.bfd', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ip_ospf_bfd_intf_bfd_enable_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config.bfd', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config.bfd', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config.bfd', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'intf-bfd-enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ip_ospf_cost_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cost'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ip_ospf_database_filter_all_external_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'all-external'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ip_ospf_database_filter_all_out_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'all-out'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ip_ospf_database_filter_all_summary_external_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'all-summary-external'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ip_ospf_dead_interval_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dead-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ip_ospf_hello_interval_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hello-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ip_ospf_md5_authentication_key_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config.md5_authentication.no_encrypt_key_table', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config.md5_authentication.no_encrypt_key_table', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config.md5_authentication.no_encrypt_key_table', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'key'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ip_ospf_md5_authentication_key_activation_wait_time_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config.md5_authentication', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config.md5_authentication', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config.md5_authentication', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'key-activation-wait-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ip_ospf_md5_authentication_key_id_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config.md5_authentication.no_encrypt_key_table', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config.md5_authentication.no_encrypt_key_table', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config.md5_authentication.no_encrypt_key_table', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'key-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ip_ospf_md5_authentication_key_id_key_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config.md5_authentication.key_table', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config.md5_authentication.key_table', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config.md5_authentication.key_table', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'key'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ip_ospf_md5_authentication_key_id_key_id_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config.md5_authentication.key_table', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config.md5_authentication.key_table', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config.md5_authentication.key_table', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'key-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ip_ospf_md5_authentication_key_id_md5_authentication_key_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config.md5_authentication.key_table', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config.md5_authentication.key_table', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config.md5_authentication.key_table', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'md5-authentication-key'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ip_ospf_mtu_ignore_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mtu-ignore'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ip_ospf_network_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'network'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ip_ospf_passive_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'passive'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ip_ospf_priority_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ip_ospf_retransmit_interval_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'retransmit-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ip_ospf_transmit_delay_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'transmit-delay'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ip_pbr_interface_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ip_pbr_interface', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ip_pbr_interface', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ip_pbr_interface', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ip_pim_dr_priority_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ip.pim_intf_vlan_cont.pim_int_cmd.pim', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ip.pim_intf_vlan_cont.pim_int_cmd.pim', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ip.pim_intf_vlan_cont.pim_int_cmd.pim', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dr-priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ip_pim_int_cmd_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ip.pim_intf_vlan_cont.pim_int_cmd', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ip.pim_intf_vlan_cont.pim_int_cmd', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ip.pim_intf_vlan_cont.pim_int_cmd', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ip_pim_intf_vlan_cont_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ip.pim_intf_vlan_cont', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ip.pim_intf_vlan_cont', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ip.pim_intf_vlan_cont', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ip_pim_multinet_enable_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v7_1_0.rbridge_id.interface.ve.ip.pim_intf_vlan_cont.pim_int_cmd.pim.multinet', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ip_pim_neighbor_filter_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ip.pim_intf_vlan_cont.pim_int_cmd.pim', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ip.pim_intf_vlan_cont.pim_int_cmd.pim', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ip.pim_intf_vlan_cont.pim_int_cmd.pim', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'neighbor-filter'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ip_pim_sparse_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ip.pim_intf_vlan_cont.pim_int_cmd', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ip.pim_intf_vlan_cont.pim_int_cmd', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ip.pim_intf_vlan_cont.pim_int_cmd', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'pim-sparse'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ip_policy_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ip_pbr_interface.ip.policy', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ip_pbr_interface.ip.policy', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ip_pbr_interface.ip.policy', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ip_policy_route_map_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ip_pbr_interface.ip.policy.route_map', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ip_pbr_interface.ip.policy.route_map', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ip_pbr_interface.ip.policy.route_map', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ip_policy_route_map_route_map_name_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ip_pbr_interface.ip.policy.route_map', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ip_pbr_interface.ip.policy.route_map', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ip_pbr_interface.ip.policy.route_map', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ip_proxy_arp_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ip.ip_config', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ip.ip_config', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ip.ip_config', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'proxy-arp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_access_group_delete(self, rbridge_id=None, ve=None, access_group=None, traffic_type=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type access_group: ipv6_access_list, ip_direction, traffic_type
    :param access_group: Keyword argument tuple.

    :type ipv6_access_list: unicode
    :param ipv6_access_list: **access_group** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type ip_direction: unicode
    :param ip_direction: **access_group** tuple argument.

        * enumeration restriction: ::

            ['in', 'out']

    :type traffic_type: unicode
    :param traffic_type: **access_group** tuple argument.

        * enumeration restriction: ::

            ['switched', 'routed']

    **Instance Argument(s)**:

    :type traffic_type: unicode
    :param traffic_type: Keyword argument.

        * enumeration restriction: ::

            ['switched', 'routed']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.access_group', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.access_group', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.access_group', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'access_group', 'keyval': 'ipv6_access_list, ip_direction', 'extra_keyval': 'ipv6_access_list, ip_direction, traffic_type'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, access_group=access_group, traffic_type=traffic_type)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, access_group=access_group, traffic_type=traffic_type)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_access_group_traffic_type_delete(self, rbridge_id=None, ve=None, access_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type access_group: ipv6_access_list, ip_direction
    :param access_group: Keyword argument tuple.

    :type ipv6_access_list: unicode
    :param ipv6_access_list: **access_group** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type ip_direction: unicode
    :param ip_direction: **access_group** tuple argument.

        * enumeration restriction: ::

            ['in', 'out']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.access_group', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.access_group', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.access_group', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'access_group', 'keyval': 'ipv6_access_list, ip_direction', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'traffic-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, access_group=access_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, access_group=access_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_address_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.ipv6_config.address', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.ipv6_config.address', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.ipv6_config.address', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_address_ipv6_address_delete(self, rbridge_id=None, ve=None, ipv6_address=None, secondary=None, anycast=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ipv6_address: address, secondary, anycast
    :param ipv6_address: Keyword argument tuple.

    :type address: unicode
    :param address: **ipv6_address** tuple argument:  A:B::C:D/LEN;; IPv6 prefix format: xxxx:xxxx/ml, xxxx:xxxx::/ml, xxxx::xx/128

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type secondary: YANGBool
    :param secondary: **ipv6_address** tuple argument:  Configure Secondary ipv6 address on an interface

    :type anycast: YANGBool
    :param anycast: **ipv6_address** tuple argument:  Configure ipv6 address as anycast

    **Instance Argument(s)**:

    :type secondary: YANGBool
    :param secondary: Configure Secondary ipv6 address on an interface

    :type anycast: YANGBool
    :param anycast: Configure ipv6 address as anycast

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_address', 'keyval': 'address', 'extra_keyval': 'address, secondary, anycast'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, ipv6_address=ipv6_address, secondary=secondary, anycast=anycast)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, ipv6_address=ipv6_address, secondary=secondary, anycast=anycast)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_address_ipv6_address_anycast_delete(self, rbridge_id=None, ve=None, ipv6_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ipv6_address: address
    :param ipv6_address: Keyword argument tuple.

    :type address: unicode
    :param address: **ipv6_address** tuple argument:  A:B::C:D/LEN;; IPv6 prefix format: xxxx:xxxx/ml, xxxx:xxxx::/ml, xxxx::xx/128

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_address', 'keyval': 'address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'anycast'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, ipv6_address=ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, ipv6_address=ipv6_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_address_ipv6_address_eui_64_delete(self, rbridge_id=None, ve=None, ipv6_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv6_address: address, secondary, anycast
    :param ipv6_address: Keyword argument tuple.

    :type address: unicode
    :param address: **ipv6_address** tuple argument:  A:B::C:D/LEN;; IPv6 prefix format: xxxx:xxxx/ml, xxxx:xxxx::/ml, xxxx::xx/128

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type secondary: YANGBool
    :param secondary: **ipv6_address** tuple argument:  Configure Secondary ipv6 address on an interface

    :type anycast: YANGBool
    :param anycast: **ipv6_address** tuple argument:  Configure ipv6 address as anycast

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.ipv6_config.address.ipv6_address', u'ipv6_address'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.ipv6_config.address.ipv6_address', u'ipv6_address'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.ipv6_config.address.ipv6_address', u'ipv6_address')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.ipv6_config.address.ipv6_address.eui_config', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.ipv6_config.address.ipv6_address.eui_config', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.ipv6_config.address.ipv6_address.eui_config', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'address', 'extra_keyval': 'address, secondary, anycast'}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'address', 'extra_keyval': 'address, secondary, anycast'}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'address', 'extra_keyval': 'address, secondary, anycast'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'eui-64'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, ipv6_address=ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, ipv6_address=ipv6_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_address_ipv6_address_secondary_delete(self, rbridge_id=None, ve=None, ipv6_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ipv6_address: address
    :param ipv6_address: Keyword argument tuple.

    :type address: unicode
    :param address: **ipv6_address** tuple argument:  A:B::C:D/LEN;; IPv6 prefix format: xxxx:xxxx/ml, xxxx:xxxx::/ml, xxxx::xx/128

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_address', 'keyval': 'address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'secondary'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, ipv6_address=ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, ipv6_address=ipv6_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_address_ipv6_address_secondary_eui_config_delete(self, rbridge_id=None, ve=None, ipv6_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv6_address: address, secondary, anycast
    :param ipv6_address: Keyword argument tuple.

    :type address: unicode
    :param address: **ipv6_address** tuple argument:  A:B::C:D/LEN;; IPv6 prefix format: xxxx:xxxx/ml, xxxx:xxxx::/ml, xxxx::xx/128

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type secondary: YANGBool
    :param secondary: **ipv6_address** tuple argument:  Configure Secondary ipv6 address on an interface

    :type anycast: YANGBool
    :param anycast: **ipv6_address** tuple argument:  Configure ipv6 address as anycast

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.ipv6_config.address.ipv6_address', u'ipv6_address'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.ipv6_config.address.ipv6_address', u'ipv6_address'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.ipv6_config.address.ipv6_address', u'ipv6_address')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.ipv6_config.address.ipv6_address.eui_config', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.ipv6_config.address.ipv6_address.eui_config', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.ipv6_config.address.ipv6_address.eui_config', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'address', 'extra_keyval': 'address, secondary, anycast'}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'address', 'extra_keyval': 'address, secondary, anycast'}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'address', 'extra_keyval': 'address, secondary, anycast'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'secondary'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, ipv6_address=ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, ipv6_address=ipv6_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_address_link_local_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'link-local'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_address_link_local_address_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'link-local-address'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_address_link_local_config_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'link_local_address, link_local'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_address_use_link_local_only_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.ipv6_config.address', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.ipv6_config.address', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.ipv6_config.address', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'use-link-local-only'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_anycast_address_delete(self, rbridge_id=None, ve=None, ipv6_anycast_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ipv6_anycast_address: ipv6_address
    :param ipv6_anycast_address: Keyword argument tuple.

    :type ipv6_address: unicode
    :param ipv6_address: **ipv6_anycast_address** tuple argument:  A:B::C:D/LEN;; IPv6 prefix format: xxxx:xxxx/ml, xxxx:xxxx::/ml, xxxx::xx/128

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.ipv6_anycast_address', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.ipv6_anycast_address', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_anycast_address', 'keyval': 'ipv6_address', 'extra_keyval': 'ipv6_address'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, ipv6_anycast_address=ipv6_anycast_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, ipv6_anycast_address=ipv6_anycast_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_dhcp_relay_servers_delete(self, rbridge_id=None, ve=None, servers=None, server_vrf_name=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type servers: relay_ip_addr, server_vrf_name
    :param servers: Keyword argument tuple.

    :type relay_ip_addr: unicode
    :param relay_ip_addr: **servers** tuple argument:  IPv6 address of the DHCPv6 server

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type server_vrf_name: unicode
    :param server_vrf_name: **servers** tuple argument:  VRF name of the DHCPv6 server

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Argument(s)**:

    :type server_vrf_name: unicode
    :param server_vrf_name: VRF name of the DHCPv6 server

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.interface_ve_dhcp_conf.dhcp.relay.servers', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.interface_ve_dhcp_conf.dhcp.relay.servers', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.interface_ve_dhcp_conf.dhcp.relay.servers', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'servers', 'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, servers=servers, server_vrf_name=server_vrf_name)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, servers=servers, server_vrf_name=server_vrf_name)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_dhcp_relay_servers_interface_delete(self, rbridge_id=None, ve=None, servers=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type servers: relay_ip_addr, server_vrf_name
    :param servers: Keyword argument tuple.

    :type relay_ip_addr: unicode
    :param relay_ip_addr: **servers** tuple argument:  IPv6 address of the DHCPv6 server

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type server_vrf_name: unicode
    :param server_vrf_name: **servers** tuple argument:  VRF name of the DHCPv6 server

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.interface_ve_dhcp_conf.dhcp.relay.servers', u'servers'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.interface_ve_dhcp_conf.dhcp.relay.servers', u'servers'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.interface_ve_dhcp_conf.dhcp.relay.servers', u'servers')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.interface_ve_dhcp_conf.dhcp.relay.servers.interface', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.interface_ve_dhcp_conf.dhcp.relay.servers.interface', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.interface_ve_dhcp_conf.dhcp.relay.servers.interface', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'interface_type, interface_name'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, servers=servers)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, servers=servers)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_dhcp_relay_servers_interface_interface_delete(self, rbridge_id=None, ve=None, servers=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type servers: relay_ip_addr, server_vrf_name
    :param servers: Keyword argument tuple.

    :type relay_ip_addr: unicode
    :param relay_ip_addr: **servers** tuple argument:  IPv6 address of the DHCPv6 server

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type server_vrf_name: unicode
    :param server_vrf_name: **servers** tuple argument:  VRF name of the DHCPv6 server

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.interface_ve_dhcp_conf.dhcp.relay.servers', u'servers'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.interface_ve_dhcp_conf.dhcp.relay.servers', u'servers'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.interface_ve_dhcp_conf.dhcp.relay.servers', u'servers')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.interface_ve_dhcp_conf.dhcp.relay.servers.interface', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.interface_ve_dhcp_conf.dhcp.relay.servers.interface', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.interface_ve_dhcp_conf.dhcp.relay.servers.interface', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'interface'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, servers=servers)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, servers=servers)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_dhcp_relay_servers_interface_interface_name_delete(self, rbridge_id=None, ve=None, servers=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type servers: relay_ip_addr, server_vrf_name
    :param servers: Keyword argument tuple.

    :type relay_ip_addr: unicode
    :param relay_ip_addr: **servers** tuple argument:  IPv6 address of the DHCPv6 server

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type server_vrf_name: unicode
    :param server_vrf_name: **servers** tuple argument:  VRF name of the DHCPv6 server

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.interface_ve_dhcp_conf.dhcp.relay.servers', u'servers'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.interface_ve_dhcp_conf.dhcp.relay.servers', u'servers'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.interface_ve_dhcp_conf.dhcp.relay.servers', u'servers')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.interface_ve_dhcp_conf.dhcp.relay.servers.interface', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.interface_ve_dhcp_conf.dhcp.relay.servers.interface', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.interface_ve_dhcp_conf.dhcp.relay.servers.interface', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'interface-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, servers=servers)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, servers=servers)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_dhcp_relay_servers_use_vrf_delete(self, rbridge_id=None, ve=None, servers=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type servers: relay_ip_addr
    :param servers: Keyword argument tuple.

    :type relay_ip_addr: unicode
    :param relay_ip_addr: **servers** tuple argument:  IPv6 address of the DHCPv6 server

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.interface_ve_dhcp_conf.dhcp.relay.servers', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.interface_ve_dhcp_conf.dhcp.relay.servers', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.interface_ve_dhcp_conf.dhcp.relay.servers', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'servers', 'keyval': 'relay_ip_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'use-vrf'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, servers=servers)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, servers=servers)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_fabric_virtual_gateway_delete(self, rbridge_id=None, ve=None, ipv6_local_anycast_gateway=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ipv6_local_anycast_gateway: local_ipv6_gw_id
    :param ipv6_local_anycast_gateway: Keyword argument tuple.

    :type local_ipv6_gw_id: long
    :param local_ipv6_gw_id: **ipv6_local_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_local_anycast_gateway', 'keyval': 'local_ipv6_gw_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, ipv6_local_anycast_gateway=ipv6_local_anycast_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, ipv6_local_anycast_gateway=ipv6_local_anycast_gateway)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_fabric_virtual_gateway_disable_delete(self, rbridge_id=None, ve=None, ipv6_local_anycast_gateway=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ipv6_local_anycast_gateway: local_ipv6_gw_id
    :param ipv6_local_anycast_gateway: Keyword argument tuple.

    :type local_ipv6_gw_id: long
    :param local_ipv6_gw_id: **ipv6_local_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_local_anycast_gateway', 'keyval': 'local_ipv6_gw_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'disable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, ipv6_local_anycast_gateway=ipv6_local_anycast_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, ipv6_local_anycast_gateway=ipv6_local_anycast_gateway)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_fabric_virtual_gateway_enable_delete(self, rbridge_id=None, ve=None, ipv6_local_anycast_gateway=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ipv6_local_anycast_gateway: local_ipv6_gw_id
    :param ipv6_local_anycast_gateway: Keyword argument tuple.

    :type local_ipv6_gw_id: long
    :param local_ipv6_gw_id: **ipv6_local_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_local_anycast_gateway', 'keyval': 'local_ipv6_gw_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, ipv6_local_anycast_gateway=ipv6_local_anycast_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, ipv6_local_anycast_gateway=ipv6_local_anycast_gateway)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_fabric_virtual_gateway_load_balancing_delete(self, rbridge_id=None, ve=None, ipv6_local_anycast_gateway=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv6_local_anycast_gateway: local_ipv6_gw_id
    :param ipv6_local_anycast_gateway: Keyword argument tuple.

    :type local_ipv6_gw_id: long
    :param local_ipv6_gw_id: **ipv6_local_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway', u'ipv6_local_anycast_gateway'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway', u'ipv6_local_anycast_gateway'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway', u'ipv6_local_anycast_gateway')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway.load_balancing', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway.load_balancing', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway.load_balancing', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ipv6_gw_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ipv6_gw_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ipv6_gw_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, ipv6_local_anycast_gateway=ipv6_local_anycast_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, ipv6_local_anycast_gateway=ipv6_local_anycast_gateway)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_fabric_virtual_gateway_load_balancing_basic_delete(self, rbridge_id=None, ve=None, ipv6_local_anycast_gateway=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv6_local_anycast_gateway: local_ipv6_gw_id
    :param ipv6_local_anycast_gateway: Keyword argument tuple.

    :type local_ipv6_gw_id: long
    :param local_ipv6_gw_id: **ipv6_local_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway', u'ipv6_local_anycast_gateway'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway', u'ipv6_local_anycast_gateway'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway', u'ipv6_local_anycast_gateway')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway.load_balancing', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway.load_balancing', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway.load_balancing', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ipv6_gw_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ipv6_gw_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ipv6_gw_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'basic'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, ipv6_local_anycast_gateway=ipv6_local_anycast_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, ipv6_local_anycast_gateway=ipv6_local_anycast_gateway)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_fabric_virtual_gateway_load_balancing_threshold_priority_delete(self, rbridge_id=None, ve=None, ipv6_local_anycast_gateway=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv6_local_anycast_gateway: local_ipv6_gw_id
    :param ipv6_local_anycast_gateway: Keyword argument tuple.

    :type local_ipv6_gw_id: long
    :param local_ipv6_gw_id: **ipv6_local_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway', u'ipv6_local_anycast_gateway'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway', u'ipv6_local_anycast_gateway'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway', u'ipv6_local_anycast_gateway')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway.load_balancing', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway.load_balancing', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway.load_balancing', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ipv6_gw_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ipv6_gw_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ipv6_gw_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'threshold-priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, ipv6_local_anycast_gateway=ipv6_local_anycast_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, ipv6_local_anycast_gateway=ipv6_local_anycast_gateway)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_fabric_virtual_gateway_track_delete(self, rbridge_id=None, ve=None, ipv6_local_anycast_gateway=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv6_local_anycast_gateway: local_ipv6_gw_id
    :param ipv6_local_anycast_gateway: Keyword argument tuple.

    :type local_ipv6_gw_id: long
    :param local_ipv6_gw_id: **ipv6_local_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway', u'ipv6_local_anycast_gateway'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway', u'ipv6_local_anycast_gateway'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway', u'ipv6_local_anycast_gateway')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway.ipv6_track', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway.ipv6_track', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway.ipv6_track', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ipv6_gw_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ipv6_gw_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ipv6_gw_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, ipv6_local_anycast_gateway=ipv6_local_anycast_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, ipv6_local_anycast_gateway=ipv6_local_anycast_gateway)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_fabric_virtual_gateway_track_interface_delete(self, rbridge_id=None, ve=None, ipv6_local_anycast_gateway=None, ipv6_interface=None, ipv6_interface_priority=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv6_local_anycast_gateway: local_ipv6_gw_id
    :param ipv6_local_anycast_gateway: Keyword argument tuple.

    :type local_ipv6_gw_id: long
    :param local_ipv6_gw_id: **ipv6_local_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ipv6_interface: ipv6_interface_type, ipv6_interface_name
    :param ipv6_interface: Keyword argument tuple.

    :type ipv6_interface_type: unicode
    :param ipv6_interface_type: **ipv6_interface** tuple argument.

        * enumeration restriction: ::

            ['fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'port-channel']

    :type ipv6_interface_name: unicode
    :param ipv6_interface_name: **ipv6_interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Argument(s)**:

    :type ipv6_interface_priority: long
    :param ipv6_interface_priority: Track Priority

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway', u'ipv6_local_anycast_gateway'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway', u'ipv6_local_anycast_gateway'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway', u'ipv6_local_anycast_gateway')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway.ipv6_track.ipv6_interface', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway.ipv6_track.ipv6_interface', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway.ipv6_track.ipv6_interface', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ipv6_gw_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ipv6_gw_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ipv6_gw_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_interface', 'keyval': 'ipv6_interface_type, ipv6_interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, ipv6_local_anycast_gateway=ipv6_local_anycast_gateway, ipv6_interface=ipv6_interface, ipv6_interface_priority=ipv6_interface_priority)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, ipv6_local_anycast_gateway=ipv6_local_anycast_gateway, ipv6_interface=ipv6_interface, ipv6_interface_priority=ipv6_interface_priority)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_fabric_virtual_gateway_track_interface_priority_delete(self, rbridge_id=None, ve=None, ipv6_local_anycast_gateway=None, ipv6_interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv6_local_anycast_gateway: local_ipv6_gw_id
    :param ipv6_local_anycast_gateway: Keyword argument tuple.

    :type local_ipv6_gw_id: long
    :param local_ipv6_gw_id: **ipv6_local_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ipv6_interface: ipv6_interface_type, ipv6_interface_name
    :param ipv6_interface: Keyword argument tuple.

    :type ipv6_interface_type: unicode
    :param ipv6_interface_type: **ipv6_interface** tuple argument.

        * enumeration restriction: ::

            ['fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'port-channel']

    :type ipv6_interface_name: unicode
    :param ipv6_interface_name: **ipv6_interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway', u'ipv6_local_anycast_gateway'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway', u'ipv6_local_anycast_gateway'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway', u'ipv6_local_anycast_gateway')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway.ipv6_track.ipv6_interface', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway.ipv6_track.ipv6_interface', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway.ipv6_track.ipv6_interface', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ipv6_gw_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ipv6_gw_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ipv6_gw_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_interface', 'keyval': 'ipv6_interface_type, ipv6_interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, ipv6_local_anycast_gateway=ipv6_local_anycast_gateway, ipv6_interface=ipv6_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, ipv6_local_anycast_gateway=ipv6_local_anycast_gateway, ipv6_interface=ipv6_interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_fabric_virtual_gateway_track_network_delete(self, rbridge_id=None, ve=None, ipv6_local_anycast_gateway=None, ipv6_network=None, ipv6_network_priority=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv6_local_anycast_gateway: local_ipv6_gw_id
    :param ipv6_local_anycast_gateway: Keyword argument tuple.

    :type local_ipv6_gw_id: long
    :param local_ipv6_gw_id: **ipv6_local_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ipv6_network: ipv6_network_address
    :param ipv6_network: Keyword argument tuple.

    :type ipv6_network_address: unicode
    :param ipv6_network_address: **ipv6_network** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    **Instance Argument(s)**:

    :type ipv6_network_priority: long
    :param ipv6_network_priority: Track Priority

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway', u'ipv6_local_anycast_gateway'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway', u'ipv6_local_anycast_gateway'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway', u'ipv6_local_anycast_gateway')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway.ipv6_track.ipv6_network', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway.ipv6_track.ipv6_network', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway.ipv6_track.ipv6_network', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ipv6_gw_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ipv6_gw_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ipv6_gw_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_network', 'keyval': 'ipv6_network_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, ipv6_local_anycast_gateway=ipv6_local_anycast_gateway, ipv6_network=ipv6_network, ipv6_network_priority=ipv6_network_priority)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, ipv6_local_anycast_gateway=ipv6_local_anycast_gateway, ipv6_network=ipv6_network, ipv6_network_priority=ipv6_network_priority)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_fabric_virtual_gateway_track_network_priority_delete(self, rbridge_id=None, ve=None, ipv6_local_anycast_gateway=None, ipv6_network=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv6_local_anycast_gateway: local_ipv6_gw_id
    :param ipv6_local_anycast_gateway: Keyword argument tuple.

    :type local_ipv6_gw_id: long
    :param local_ipv6_gw_id: **ipv6_local_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ipv6_network: ipv6_network_address
    :param ipv6_network: Keyword argument tuple.

    :type ipv6_network_address: unicode
    :param ipv6_network_address: **ipv6_network** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway', u'ipv6_local_anycast_gateway'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway', u'ipv6_local_anycast_gateway'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway', u'ipv6_local_anycast_gateway')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway.ipv6_track.ipv6_network', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway.ipv6_track.ipv6_network', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway.ipv6_track.ipv6_network', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ipv6_gw_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ipv6_gw_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ipv6_gw_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_network', 'keyval': 'ipv6_network_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, ipv6_local_anycast_gateway=ipv6_local_anycast_gateway, ipv6_network=ipv6_network)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, ipv6_local_anycast_gateway=ipv6_local_anycast_gateway, ipv6_network=ipv6_network)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_fabric_virtual_gateway_track_next_hop_delete(self, rbridge_id=None, ve=None, ipv6_local_anycast_gateway=None, ipv6_next_hop=None, ipv6_next_hop_priority=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv6_local_anycast_gateway: local_ipv6_gw_id
    :param ipv6_local_anycast_gateway: Keyword argument tuple.

    :type local_ipv6_gw_id: long
    :param local_ipv6_gw_id: **ipv6_local_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ipv6_next_hop: ipv6_next_hop_address
    :param ipv6_next_hop: Keyword argument tuple.

    :type ipv6_next_hop_address: unicode
    :param ipv6_next_hop_address: **ipv6_next_hop** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    **Instance Argument(s)**:

    :type ipv6_next_hop_priority: long
    :param ipv6_next_hop_priority: Track Priority

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway', u'ipv6_local_anycast_gateway'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway', u'ipv6_local_anycast_gateway'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway', u'ipv6_local_anycast_gateway')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway.ipv6_track.ipv6_next_hop', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway.ipv6_track.ipv6_next_hop', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway.ipv6_track.ipv6_next_hop', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ipv6_gw_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ipv6_gw_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ipv6_gw_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_next_hop', 'keyval': 'ipv6_next_hop_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, ipv6_local_anycast_gateway=ipv6_local_anycast_gateway, ipv6_next_hop=ipv6_next_hop, ipv6_next_hop_priority=ipv6_next_hop_priority)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, ipv6_local_anycast_gateway=ipv6_local_anycast_gateway, ipv6_next_hop=ipv6_next_hop, ipv6_next_hop_priority=ipv6_next_hop_priority)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_fabric_virtual_gateway_track_next_hop_priority_delete(self, rbridge_id=None, ve=None, ipv6_local_anycast_gateway=None, ipv6_next_hop=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv6_local_anycast_gateway: local_ipv6_gw_id
    :param ipv6_local_anycast_gateway: Keyword argument tuple.

    :type local_ipv6_gw_id: long
    :param local_ipv6_gw_id: **ipv6_local_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ipv6_next_hop: ipv6_next_hop_address
    :param ipv6_next_hop: Keyword argument tuple.

    :type ipv6_next_hop_address: unicode
    :param ipv6_next_hop_address: **ipv6_next_hop** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway', u'ipv6_local_anycast_gateway'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway', u'ipv6_local_anycast_gateway'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway', u'ipv6_local_anycast_gateway')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway.ipv6_track.ipv6_next_hop', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway.ipv6_track.ipv6_next_hop', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway.ipv6_track.ipv6_next_hop', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ipv6_gw_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ipv6_gw_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ipv6_gw_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_next_hop', 'keyval': 'ipv6_next_hop_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, ipv6_local_anycast_gateway=ipv6_local_anycast_gateway, ipv6_next_hop=ipv6_next_hop)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, ipv6_local_anycast_gateway=ipv6_local_anycast_gateway, ipv6_next_hop=ipv6_next_hop)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_hop_by_hop_trap_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.ipv6_ve_intf_cmds', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.ipv6_ve_intf_cmds', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.ipv6_ve_intf_cmds', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hop-by-hop-trap'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_icmpv6_echo_reply_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.icmpv6', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.icmpv6', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.icmpv6', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'echo-reply'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_icmpv6_rate_limiting_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.icmpv6', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.icmpv6', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.icmpv6', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rate-limiting'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_icmpv6_redirect_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.icmpv6', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.icmpv6', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.icmpv6', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redirect'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_icmpv6_unreachable_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.icmpv6', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.icmpv6', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.icmpv6', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'unreachable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_interface_ve_dhcp_conf_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.interface_ve_dhcp_conf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.interface_ve_dhcp_conf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.interface_ve_dhcp_conf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_ipv6_config_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.ipv6_config', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.ipv6_config', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.ipv6_config', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_ipv6_intf_cmds_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_ipv6_nd_ra_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.ipv6_nd_ra', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.ipv6_nd_ra', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_ipv6_ve_intf_cmds_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.ipv6_ve_intf_cmds', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.ipv6_ve_intf_cmds', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.ipv6_ve_intf_cmds', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_mtu_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.ipv6_config', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.ipv6_config', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.ipv6_config', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mtu'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_nd_broadcast_mac_trap_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'broadcast-mac-trap'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_nd_cache_expire_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.cache', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.cache', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.cache', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'expire'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_nd_dad_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.dad', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.dad', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.dad', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_nd_dad_attempts_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.dad', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.dad', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.dad', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'attempts'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_nd_dad_time_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.dad', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.dad', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.dad', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_nd_hoplimit_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hoplimit'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_nd_managed_config_flag_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'managed-config-flag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_nd_mtu_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mtu'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_nd_ns_interval_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ns-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_nd_nud_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_nd_nud_retry_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'base, interval, max_attempts'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_nd_nud_retry_base_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'base'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_nd_nud_retry_interval_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_nd_nud_retry_max_attempts_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'max-attempts'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_nd_other_config_flag_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'other-config-flag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_nd_prefix_delete(self, rbridge_id=None, ve=None, prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix', 'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, prefix=prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_nd_prefix_infinite_delete(self, rbridge_id=None, ve=None, prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'infinite'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, prefix=prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_nd_prefix_infinite_preferred_delete(self, rbridge_id=None, ve=None, prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'infinite'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, prefix=prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_nd_prefix_no_advertise_delete(self, rbridge_id=None, ve=None, prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'no-advertise'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, prefix=prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_nd_prefix_no_autoconfig_delete(self, rbridge_id=None, ve=None, prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'no-autoconfig'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, prefix=prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_nd_prefix_no_onlink_delete(self, rbridge_id=None, ve=None, prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'no-onlink'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, prefix=prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_nd_prefix_off_link_delete(self, rbridge_id=None, ve=None, prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'off-link'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, prefix=prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_nd_prefix_preferred_delete(self, rbridge_id=None, ve=None, prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'preferred_lifetime, preferred_infinite'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred': [u'preferred_infinite', u'preferred_lifetime'], 'pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred': [u'preferred_infinite', u'preferred_lifetime'], 'pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred': [u'preferred_infinite', u'preferred_lifetime']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, prefix=prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_nd_prefix_preferred_lifetime_delete(self, rbridge_id=None, ve=None, prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'preferred-lifetime'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, prefix=prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_nd_prefix_prefix_flags_delete(self, rbridge_id=None, ve=None, prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'no_autoconfig, no_onlink, off_link'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, prefix=prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_nd_prefix_valid_lifetime_delete(self, rbridge_id=None, ve=None, prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'valid-lifetime'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, prefix=prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_nd_proxy_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'proxy'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_nd_ra_interval_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_interval', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_interval', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_interval', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'max_interval, min_'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_nd_ra_interval_max_interval_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_interval', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_interval', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_interval', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'max-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_nd_ra_interval_min_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_interval', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_interval', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_interval', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'min'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_nd_ra_lifetime_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ra-lifetime'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_nd_reachable_time_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'reachable-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_nd_retrans_timer_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'retrans-timer'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_nd_set_cache_expire_time_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'set-cache-expire-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_nd_set_hoplimit_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'set-hoplimit'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_nd_suppress_ra_all_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'all'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_nd_suppress_ra_mtu_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mtu'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_nd_suppress_ra_suppress_ra_flag_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'suppress-ra-flag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_neighbor_delete(self, rbridge_id=None, ve=None, neighbor=None, hardware_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type neighbor: ipv6_address
    :param neighbor: Keyword argument tuple.

    :type ipv6_address: unicode
    :param ipv6_address: **neighbor** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    **Instance Argument(s)**:

    :type hardware_address: unicode
    :param hardware_address: Keyword argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.neighbor', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.neighbor', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.neighbor', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'neighbor', 'keyval': 'ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, neighbor=neighbor, hardware_address=hardware_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, neighbor=neighbor, hardware_address=hardware_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_neighbor_hardware_address_delete(self, rbridge_id=None, ve=None, neighbor=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type neighbor: ipv6_address
    :param neighbor: Keyword argument tuple.

    :type ipv6_address: unicode
    :param ipv6_address: **neighbor** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.neighbor', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.neighbor', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.neighbor', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'neighbor', 'keyval': 'ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hardware-address'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, neighbor=neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, neighbor=neighbor)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_ospf_active_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'active'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_ospf_area_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'area'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_ospf_authentication_ah_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ah'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_ospf_authentication_esp_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'esp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_ospf_authentication_esp_auth_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'esp-auth'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_ospf_authentication_esp_key_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'esp-key'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_ospf_authentication_esp_no_encrypt_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'esp-no-encrypt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_ospf_authentication_ipsec_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_ospf_authentication_ipsec_disable_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'disable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_ospf_authentication_ipsec_key_add_remove_interval_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'key-add-remove-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_ospf_authentication_key_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'key'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_ospf_authentication_no_encrypt_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'no-encrypt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_ospf_authentication_spi_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'spi'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_ospf_bfd_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf.bfd', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf.bfd', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf.bfd', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_ospf_bfd_bfd_enable_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf.bfd', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf.bfd', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf.bfd', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bfd-enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_ospf_cost_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cost'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_ospf_dead_interval_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dead-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_ospf_hello_interval_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hello-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_ospf_hello_jitter_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hello-jitter'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_ospf_instance_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'instance'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_ospf_link_interval_properties_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_ospf_mtu_ignore_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mtu-ignore'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_ospf_network_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'network'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_ospf_passive_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'passive'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_ospf_priority_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_ospf_retransmit_interval_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'retransmit-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_ospf_suppress_linklsa_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'suppress-linklsa'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_ospf_transmit_delay_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'transmit-delay'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_policy_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.policy', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.policy', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.policy', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_policy_route_map_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.policy.route_map', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.policy.route_map', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.policy.route_map', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_policy_route_map_ipv6_route_map_name_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.policy.route_map', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.policy.route_map', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.policy.route_map', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ipv6-route-map-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_vrrp_extended_group_delete(self, rbridge_id=None, ve=None, vrrpv3e=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.vrrpv3e', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.vrrpv3e', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.vrrpv3e', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpv3e=vrrpv3e)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpv3e=vrrpv3e)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_vrrp_extended_group_advertise_backup_delete(self, rbridge_id=None, ve=None, vrrpv3e=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.vrrpv3e', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.vrrpv3e', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.vrrpv3e', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'advertise-backup'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpv3e=vrrpv3e)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpv3e=vrrpv3e)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_vrrp_extended_group_advertisement_interval_delete(self, rbridge_id=None, ve=None, vrrpv3e=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.vrrpv3e', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.vrrpv3e', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.vrrpv3e', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'advertisement-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpv3e=vrrpv3e)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpv3e=vrrpv3e)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_vrrp_extended_group_advertisement_interval_scale_delete(self, rbridge_id=None, ve=None, vrrpv3e=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.vrrpv3e', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.vrrpv3e', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.vrrpv3e', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'advertisement-interval-scale'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpv3e=vrrpv3e)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpv3e=vrrpv3e)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_vrrp_extended_group_backup_advertisement_interval_delete(self, rbridge_id=None, ve=None, vrrpv3e=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.vrrpv3e', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.vrrpv3e', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.vrrpv3e', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'backup-advertisement-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpv3e=vrrpv3e)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpv3e=vrrpv3e)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_vrrp_extended_group_description_delete(self, rbridge_id=None, ve=None, vrrpv3e=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.vrrpv3e', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.vrrpv3e', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.vrrpv3e', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'description'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpv3e=vrrpv3e)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpv3e=vrrpv3e)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_vrrp_extended_group_enable_delete(self, rbridge_id=None, ve=None, vrrpv3e=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.vrrpv3e', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.vrrpv3e', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.vrrpv3e', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpv3e=vrrpv3e)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpv3e=vrrpv3e)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_vrrp_extended_group_hold_time_delete(self, rbridge_id=None, ve=None, vrrpv3e=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.vrrpv3e', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.vrrpv3e', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.vrrpv3e', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hold-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpv3e=vrrpv3e)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpv3e=vrrpv3e)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_vrrp_extended_group_nd_advertisement_timer_delete(self, rbridge_id=None, ve=None, vrrpv3e=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.vrrpv3e', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.vrrpv3e', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.vrrpv3e', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'nd-advertisement-timer'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpv3e=vrrpv3e)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpv3e=vrrpv3e)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_vrrp_extended_group_preempt_mode_delete(self, rbridge_id=None, ve=None, vrrpv3e=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.vrrpv3e', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.vrrpv3e', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.vrrpv3e', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'preempt-mode'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpv3e=vrrpv3e)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpv3e=vrrpv3e)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_vrrp_extended_group_priority_delete(self, rbridge_id=None, ve=None, vrrpv3e=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.vrrpv3e', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.vrrpv3e', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.vrrpv3e', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpv3e=vrrpv3e)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpv3e=vrrpv3e)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_vrrp_extended_group_short_path_forwarding_delete(self, rbridge_id=None, ve=None, vrrpv3e=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.vrrpv3e', u'vrrpv3e')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.vrrpv3e.short_path_forwarding', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'basic, revert_priority'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpv3e=vrrpv3e)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpv3e=vrrpv3e)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_vrrp_extended_group_short_path_forwarding_basic_delete(self, rbridge_id=None, ve=None, vrrpv3e=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.vrrpv3e', u'vrrpv3e'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.vrrpv3e', u'vrrpv3e'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.vrrpv3e', u'vrrpv3e')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.vrrpv3e.short_path_forwarding', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.vrrpv3e.short_path_forwarding', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.vrrpv3e.short_path_forwarding', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'basic'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpv3e=vrrpv3e)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpv3e=vrrpv3e)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_vrrp_extended_group_short_path_forwarding_revert_priority_delete(self, rbridge_id=None, ve=None, vrrpv3e=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.vrrpv3e', u'vrrpv3e'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.vrrpv3e', u'vrrpv3e'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.vrrpv3e', u'vrrpv3e')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.vrrpv3e.short_path_forwarding', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.vrrpv3e.short_path_forwarding', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.vrrpv3e.short_path_forwarding', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'revert-priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpv3e=vrrpv3e)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpv3e=vrrpv3e)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_vrrp_extended_group_track_interface_delete(self, rbridge_id=None, ve=None, vrrpv3e=None, interface=None, track_priority=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Argument(s)**:

    :type track_priority: int
    :param track_priority: Track Priority

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.vrrpv3e', u'vrrpv3e'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.vrrpv3e', u'vrrpv3e'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.vrrpv3e', u'vrrpv3e')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.vrrpv3e.track.interface', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.vrrpv3e.track.interface', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.vrrpv3e.track.interface', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpv3e=vrrpv3e, interface=interface, track_priority=track_priority)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpv3e=vrrpv3e, interface=interface, track_priority=track_priority)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_vrrp_extended_group_track_interface_priority_delete(self, rbridge_id=None, ve=None, vrrpv3e=None, interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.vrrpv3e', u'vrrpv3e'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.vrrpv3e', u'vrrpv3e'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.vrrpv3e', u'vrrpv3e')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.vrrpv3e.track.interface', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.vrrpv3e.track.interface', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.vrrpv3e.track.interface', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpv3e=vrrpv3e, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpv3e=vrrpv3e, interface=interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_vrrp_extended_group_track_network_delete(self, rbridge_id=None, ve=None, vrrpv3e=None, network=None, network_priority=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type network: network_address
    :param network: Keyword argument tuple.

    :type network_address: unicode
    :param network_address: **network** tuple argument:  XXXX::YYYY/L;;IPv6 global address prefix in ipv6-address/Prefix length format

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    **Instance Argument(s)**:

    :type network_priority: int
    :param network_priority: Keyword argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.vrrpv3e', u'vrrpv3e'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.vrrpv3e', u'vrrpv3e'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.vrrpv3e', u'vrrpv3e')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.vrrpv3e.track.network', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.vrrpv3e.track.network', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.vrrpv3e.track.network', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'network', 'keyval': 'network_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpv3e=vrrpv3e, network=network, network_priority=network_priority)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpv3e=vrrpv3e, network=network, network_priority=network_priority)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_vrrp_extended_group_track_network_priority_delete(self, rbridge_id=None, ve=None, vrrpv3e=None, network=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type network: network_address
    :param network: Keyword argument tuple.

    :type network_address: unicode
    :param network_address: **network** tuple argument:  XXXX::YYYY/L;;IPv6 global address prefix in ipv6-address/Prefix length format

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.vrrpv3e', u'vrrpv3e'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.vrrpv3e', u'vrrpv3e'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.vrrpv3e', u'vrrpv3e')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.vrrpv3e.track.network', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.vrrpv3e.track.network', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.vrrpv3e.track.network', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'network', 'keyval': 'network_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpv3e=vrrpv3e, network=network)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpv3e=vrrpv3e, network=network)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_vrrp_extended_group_virtual_ip_delete(self, rbridge_id=None, ve=None, vrrpv3e=None, virtual_ip=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type virtual_ip: virtual_ipaddr
    :param virtual_ip: Keyword argument tuple.

    :type virtual_ipaddr: unicode
    :param virtual_ipaddr: **virtual_ip** tuple argument:  Virtual IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.vrrpv3e', u'vrrpv3e'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.vrrpv3e', u'vrrpv3e'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.vrrpv3e', u'vrrpv3e')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.vrrpv3e.virtual_ip', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.vrrpv3e.virtual_ip', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.vrrpv3e.virtual_ip', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'virtual_ip', 'keyval': 'virtual_ipaddr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpv3e=vrrpv3e, virtual_ip=virtual_ip)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpv3e=vrrpv3e, virtual_ip=virtual_ip)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_vrrp_extended_group_virtual_mac_delete(self, rbridge_id=None, ve=None, vrrpv3e=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.vrrpv3e', u'vrrpv3e'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.vrrpv3e', u'vrrpv3e'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.vrrpv3e', u'vrrpv3e')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.vrrpv3e.virtual_mac', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.vrrpv3e.virtual_mac', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.vrrpv3e.virtual_mac', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpv3e=vrrpv3e)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpv3e=vrrpv3e)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_vrrp_extended_group_virtual_mac_02e0_5200_00xx_delete(self, rbridge_id=None, ve=None, vrrpv3e=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.vrrpv3e', u'vrrpv3e'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.vrrpv3e', u'vrrpv3e'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.vrrpv3e', u'vrrpv3e')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.vrrpv3e.virtual_mac', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.vrrpv3e.virtual_mac', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.vrrpv3e.virtual_mac', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = '02e0.5200.00xx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpv3e=vrrpv3e)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpv3e=vrrpv3e)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_vrrp_group_delete(self, rbridge_id=None, ve=None, vrrpv3=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3: vrid
    :param vrrpv3: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.vrrpv3', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.vrrpv3', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.vrrpv3', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpv3=vrrpv3)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpv3=vrrpv3)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_vrrp_group_advertisement_interval_delete(self, rbridge_id=None, ve=None, vrrpv3=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3: vrid
    :param vrrpv3: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.vrrpv3', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.vrrpv3', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.vrrpv3', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'advertisement-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpv3=vrrpv3)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpv3=vrrpv3)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_vrrp_group_description_delete(self, rbridge_id=None, ve=None, vrrpv3=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3: vrid
    :param vrrpv3: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.vrrpv3', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.vrrpv3', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.vrrpv3', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'description'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpv3=vrrpv3)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpv3=vrrpv3)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_vrrp_group_enable_delete(self, rbridge_id=None, ve=None, vrrpv3=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3: vrid
    :param vrrpv3: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.vrrpv3', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.vrrpv3', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.vrrpv3', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpv3=vrrpv3)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpv3=vrrpv3)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_vrrp_group_hold_time_delete(self, rbridge_id=None, ve=None, vrrpv3=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3: vrid
    :param vrrpv3: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.vrrpv3', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.vrrpv3', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.vrrpv3', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hold-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpv3=vrrpv3)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpv3=vrrpv3)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_vrrp_group_preempt_mode_delete(self, rbridge_id=None, ve=None, vrrpv3=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3: vrid
    :param vrrpv3: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.vrrpv3', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.vrrpv3', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.vrrpv3', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'preempt-mode'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpv3=vrrpv3)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpv3=vrrpv3)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_vrrp_group_priority_delete(self, rbridge_id=None, ve=None, vrrpv3=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3: vrid
    :param vrrpv3: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.vrrpv3', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.vrrpv3', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.vrrpv3', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpv3=vrrpv3)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpv3=vrrpv3)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_vrrp_group_track_interface_delete(self, rbridge_id=None, ve=None, vrrpv3=None, interface=None, track_priority=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpv3: vrid
    :param vrrpv3: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Argument(s)**:

    :type track_priority: int
    :param track_priority: Track Priority

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.vrrpv3', u'vrrpv3'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.vrrpv3', u'vrrpv3'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.vrrpv3', u'vrrpv3')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.vrrpv3.track.interface', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.vrrpv3.track.interface', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.vrrpv3.track.interface', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpv3=vrrpv3, interface=interface, track_priority=track_priority)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpv3=vrrpv3, interface=interface, track_priority=track_priority)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_vrrp_group_track_interface_priority_delete(self, rbridge_id=None, ve=None, vrrpv3=None, interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpv3: vrid
    :param vrrpv3: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.vrrpv3', u'vrrpv3'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.vrrpv3', u'vrrpv3'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.vrrpv3', u'vrrpv3')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.vrrpv3.track.interface', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.vrrpv3.track.interface', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.vrrpv3.track.interface', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpv3=vrrpv3, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpv3=vrrpv3, interface=interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_vrrp_group_use_v2_checksum_delete(self, rbridge_id=None, ve=None, vrrpv3=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3: vrid
    :param vrrpv3: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.vrrpv3', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.vrrpv3', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.vrrpv3', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'use-v2-checksum'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpv3=vrrpv3)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpv3=vrrpv3)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_vrrp_group_virtual_ip_delete(self, rbridge_id=None, ve=None, vrrpv3=None, virtual_ip=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpv3: vrid
    :param vrrpv3: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type virtual_ip: virtual_ipaddr
    :param virtual_ip: Keyword argument tuple.

    :type virtual_ipaddr: unicode
    :param virtual_ipaddr: **virtual_ip** tuple argument:  Virtual IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.vrrpv3', u'vrrpv3'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.vrrpv3', u'vrrpv3'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.vrrpv3', u'vrrpv3')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.vrrpv3.virtual_ip', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.vrrpv3.virtual_ip', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.vrrpv3.virtual_ip', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'virtual_ip', 'keyval': 'virtual_ipaddr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpv3=vrrpv3, virtual_ip=virtual_ip)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpv3=vrrpv3, virtual_ip=virtual_ip)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_vrrp_suppress_interface_ra_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vrrp-suppress-interface-ra'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_shutdown_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u've', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'shutdown'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_snmp_trap_link_status_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.snmp.trap', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.snmp.trap', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.snmp.trap', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'link-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_vrf_forwarding_delete(self, rbridge_id=None, ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.vrf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.vrf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.vrf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'forwarding'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_vrrp_extended_group_delete(self, rbridge_id=None, ve=None, vrrpe=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.vrrpe', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.vrrpe', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.vrrpe', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpe', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpe=vrrpe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpe=vrrpe)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_vrrp_extended_group_advertise_backup_delete(self, rbridge_id=None, ve=None, vrrpe=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.vrrpe', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.vrrpe', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.vrrpe', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpe', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'advertise-backup'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpe=vrrpe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpe=vrrpe)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_vrrp_extended_group_advertisement_interval_delete(self, rbridge_id=None, ve=None, vrrpe=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.vrrpe', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.vrrpe', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.vrrpe', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpe', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'advertisement-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpe=vrrpe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpe=vrrpe)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_vrrp_extended_group_advertisement_interval_scale_delete(self, rbridge_id=None, ve=None, vrrpe=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.vrrpe', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.vrrpe', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.vrrpe', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpe', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'advertisement-interval-scale'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpe=vrrpe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpe=vrrpe)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_vrrp_extended_group_arp_unicast_request_receive_delete(self, rbridge_id=None, ve=None, vrrpe=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.vrrpe', u'vrrpe'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.vrrpe', u'vrrpe'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve.vrrpe', u'vrrpe')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.vrrpe.arp.unicast_request', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.vrrpe.arp.unicast_request', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.vrrpe.arp.unicast_request', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'receive'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpe=vrrpe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpe=vrrpe)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_vrrp_extended_group_backup_advertisement_interval_delete(self, rbridge_id=None, ve=None, vrrpe=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.vrrpe', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.vrrpe', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.vrrpe', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpe', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'backup-advertisement-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpe=vrrpe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpe=vrrpe)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_vrrp_extended_group_description_delete(self, rbridge_id=None, ve=None, vrrpe=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.vrrpe', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.vrrpe', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.vrrpe', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpe', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'description'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpe=vrrpe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpe=vrrpe)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_vrrp_extended_group_enable_delete(self, rbridge_id=None, ve=None, vrrpe=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.vrrpe', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.vrrpe', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.vrrpe', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpe', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpe=vrrpe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpe=vrrpe)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_vrrp_extended_group_hold_time_delete(self, rbridge_id=None, ve=None, vrrpe=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.vrrpe', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.vrrpe', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.vrrpe', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpe', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hold-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpe=vrrpe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpe=vrrpe)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_vrrp_extended_group_preempt_mode_delete(self, rbridge_id=None, ve=None, vrrpe=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.vrrpe', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.vrrpe', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.vrrpe', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpe', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'preempt-mode'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpe=vrrpe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpe=vrrpe)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_vrrp_extended_group_priority_delete(self, rbridge_id=None, ve=None, vrrpe=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.vrrpe', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.vrrpe', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.vrrpe', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpe', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpe=vrrpe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpe=vrrpe)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_vrrp_extended_group_short_path_forwarding_delete(self, rbridge_id=None, ve=None, vrrpe=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.vrrpe', u'vrrpe'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve.vrrpe', u'vrrpe'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.vrrpe', u'vrrpe')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.vrrpe.short_path_forwarding', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.vrrpe.short_path_forwarding', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.vrrpe.short_path_forwarding', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'basic, revert_priority'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpe=vrrpe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpe=vrrpe)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_vrrp_extended_group_short_path_forwarding_basic_delete(self, rbridge_id=None, ve=None, vrrpe=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.vrrpe', u'vrrpe'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve.vrrpe', u'vrrpe'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.vrrpe', u'vrrpe')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.vrrpe.short_path_forwarding', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.vrrpe.short_path_forwarding', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.vrrpe.short_path_forwarding', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'basic'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpe=vrrpe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpe=vrrpe)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_vrrp_extended_group_short_path_forwarding_revert_priority_delete(self, rbridge_id=None, ve=None, vrrpe=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.vrrpe', u'vrrpe'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve.vrrpe', u'vrrpe'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.vrrpe', u'vrrpe')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.vrrpe.short_path_forwarding', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.vrrpe.short_path_forwarding', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.vrrpe.short_path_forwarding', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'revert-priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpe=vrrpe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpe=vrrpe)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_vrrp_extended_group_track_interface_delete(self, rbridge_id=None, ve=None, vrrpe=None, interface=None, track_priority=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Argument(s)**:

    :type track_priority: int
    :param track_priority: Track Priority

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve.vrrpe', u'vrrpe'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.vrrpe', u'vrrpe'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.vrrpe', u'vrrpe')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.vrrpe.track.interface', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.vrrpe.track.interface', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.vrrpe.track.interface', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpe=vrrpe, interface=interface, track_priority=track_priority)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpe=vrrpe, interface=interface, track_priority=track_priority)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_vrrp_extended_group_track_interface_priority_delete(self, rbridge_id=None, ve=None, vrrpe=None, interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve.vrrpe', u'vrrpe'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.vrrpe', u'vrrpe'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.vrrpe', u'vrrpe')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.vrrpe.track.interface', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.vrrpe.track.interface', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.vrrpe.track.interface', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpe=vrrpe, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpe=vrrpe, interface=interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_vrrp_extended_group_track_network_delete(self, rbridge_id=None, ve=None, vrrpe=None, network=None, network_priority=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type network: network_address
    :param network: Keyword argument tuple.

    :type network_address: unicode
    :param network_address: **network** tuple argument:  IPv4 global address

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]'
            '|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0'
            '-4][0-9]|25[0-5])/(([1-9])|([1-2][0-9])|(3[0-1])'
            ')'

    **Instance Argument(s)**:

    :type network_priority: int
    :param network_priority: Keyword argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.vrrpe', u'vrrpe'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.vrrpe', u'vrrpe'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve.vrrpe', u'vrrpe')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.vrrpe.track.network', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.vrrpe.track.network', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.vrrpe.track.network', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'network', 'keyval': 'network_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpe=vrrpe, network=network, network_priority=network_priority)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpe=vrrpe, network=network, network_priority=network_priority)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_vrrp_extended_group_track_network_priority_delete(self, rbridge_id=None, ve=None, vrrpe=None, network=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type network: network_address
    :param network: Keyword argument tuple.

    :type network_address: unicode
    :param network_address: **network** tuple argument:  IPv4 global address

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]'
            '|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0'
            '-4][0-9]|25[0-5])/(([1-9])|([1-2][0-9])|(3[0-1])'
            ')'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.vrrpe', u'vrrpe'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.vrrpe', u'vrrpe'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve.vrrpe', u'vrrpe')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.vrrpe.track.network', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.vrrpe.track.network', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.vrrpe.track.network', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'network', 'keyval': 'network_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpe=vrrpe, network=network)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpe=vrrpe, network=network)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_vrrp_extended_group_virtual_ip_delete(self, rbridge_id=None, ve=None, vrrpe=None, virtual_ip=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type virtual_ip: virtual_ipaddr
    :param virtual_ip: Keyword argument tuple.

    :type virtual_ipaddr: unicode
    :param virtual_ipaddr: **virtual_ip** tuple argument:  Virtual IPv4 address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve.vrrpe', u'vrrpe'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.vrrpe', u'vrrpe'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.vrrpe', u'vrrpe')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.vrrpe.virtual_ip', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.vrrpe.virtual_ip', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.vrrpe.virtual_ip', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'virtual_ip', 'keyval': 'virtual_ipaddr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpe=vrrpe, virtual_ip=virtual_ip)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpe=vrrpe, virtual_ip=virtual_ip)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_vrrp_extended_group_virtual_mac_delete(self, rbridge_id=None, ve=None, vrrpe=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.vrrpe', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.vrrpe', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.vrrpe', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpe', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'virtual-mac'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpe=vrrpe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpe=vrrpe)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_vrrp_extended_group_vrrpe_garp_timer_delete(self, rbridge_id=None, ve=None, vrrpe=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.vrrpe', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.vrrpe', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.vrrpe', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpe', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vrrpe-garp-timer'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpe=vrrpe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpe=vrrpe)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_vrrp_group_delete(self, rbridge_id=None, ve=None, vrrp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.vrrp', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.vrrp', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.vrrp', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrp=vrrp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_vrrp_group_advertisement_interval_delete(self, rbridge_id=None, ve=None, vrrp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.vrrp', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.vrrp', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.vrrp', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'advertisement-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrp=vrrp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_vrrp_group_arp_unicast_request_receive_delete(self, rbridge_id=None, ve=None, vrrp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.vrrp', u'vrrp'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve.vrrp', u'vrrp'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.vrrp', u'vrrp')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.vrrp.arp.unicast_request', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.vrrp.arp.unicast_request', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.vrrp.arp.unicast_request', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'receive'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrp=vrrp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_vrrp_group_description_delete(self, rbridge_id=None, ve=None, vrrp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.vrrp', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.vrrp', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.vrrp', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'description'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrp=vrrp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_vrrp_group_enable_delete(self, rbridge_id=None, ve=None, vrrp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.vrrp', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.vrrp', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.vrrp', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrp=vrrp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_vrrp_group_hold_time_delete(self, rbridge_id=None, ve=None, vrrp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.vrrp', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.vrrp', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.vrrp', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hold-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrp=vrrp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_vrrp_group_preempt_mode_delete(self, rbridge_id=None, ve=None, vrrp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.vrrp', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.vrrp', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.vrrp', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'preempt-mode'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrp=vrrp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_vrrp_group_priority_delete(self, rbridge_id=None, ve=None, vrrp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.vrrp', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.vrrp', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.vrrp', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrp=vrrp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_vrrp_group_track_interface_delete(self, rbridge_id=None, ve=None, vrrp=None, interface=None, track_priority=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Argument(s)**:

    :type track_priority: int
    :param track_priority: Track Priority

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve.vrrp', u'vrrp'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.vrrp', u'vrrp'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.vrrp', u'vrrp')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.vrrp.track.interface', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.vrrp.track.interface', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.vrrp.track.interface', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrp=vrrp, interface=interface, track_priority=track_priority)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrp=vrrp, interface=interface, track_priority=track_priority)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_vrrp_group_track_interface_priority_delete(self, rbridge_id=None, ve=None, vrrp=None, interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve.vrrp', u'vrrp'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.vrrp', u'vrrp'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.vrrp', u'vrrp')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.vrrp.track.interface', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.vrrp.track.interface', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.vrrp.track.interface', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrp=vrrp, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrp=vrrp, interface=interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_vrrp_group_use_v2_checksum_delete(self, rbridge_id=None, ve=None, vrrp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.vrrp', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.vrrp', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.vrrp', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'use-v2-checksum'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrp=vrrp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_interface_ve_vrrp_group_virtual_ip_delete(self, rbridge_id=None, ve=None, vrrp=None, virtual_ip=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type virtual_ip: virtual_ipaddr
    :param virtual_ip: Keyword argument tuple.

    :type virtual_ipaddr: unicode
    :param virtual_ipaddr: **virtual_ip** tuple argument:  Virtual IPv4 address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.vrrp', u'vrrp'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.vrrp', u'vrrp'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2c.rbridge_id.interface.ve.vrrp', u'vrrp')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.interface.ve.vrrp.virtual_ip', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.interface.ve.vrrp.virtual_ip', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.interface.ve.vrrp.virtual_ip', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'virtual_ip', 'keyval': 'virtual_ipaddr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrp=vrrp, virtual_ip=virtual_ip)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrp=vrrp, virtual_ip=virtual_ip)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ip_anycast_gateway_mac_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.ip.static_ag_ip_config.anycast_gateway_mac', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ip.static_ag_ip_config.anycast_gateway_mac', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ip_anycast_gateway_mac_default_mac_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.ip.static_ag_ip_config.anycast_gateway_mac', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ip.static_ag_ip_config.anycast_gateway_mac', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'default-mac'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ip_anycast_gateway_mac_ip_anycast_gateway_mac_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.ip.static_ag_ip_config.anycast_gateway_mac', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ip.static_ag_ip_config.anycast_gateway_mac', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ip-anycast-gateway-mac'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ip_as_path_access_list_delete(self, rbridge_id=None, access_list=None, ip_action=None, ip_reg_expr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type access_list: name, seq_keyword, instance, ip_action, ip_reg_expr
    :param access_list: Keyword argument tuple.

    :type name: unicode
    :param name: **access_list** tuple argument.

        * length restriction: ::

            ['1..32']

    :type seq_keyword: unicode
    :param seq_keyword: **access_list** tuple argument.

        * enumeration restriction: ::

            ['seq']

    :type instance: int
    :param instance: **access_list** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type ip_action: unicode
    :param ip_action: **access_list** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type ip_reg_expr: unicode
    :param ip_reg_expr: **access_list** tuple argument.

    **Instance Argument(s)**:

    :type ip_action: unicode
    :param ip_action: Keyword argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type ip_reg_expr: unicode
    :param ip_reg_expr: Keyword argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ip.as_path.access_list', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ip.as_path.access_list', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ip.as_path.access_list', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'access_list', 'keyval': 'name, seq_keyword, instance', 'extra_keyval': 'name, seq_keyword, instance, ip_action, ip_reg_expr'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, access_list=access_list, ip_action=ip_action, ip_reg_expr=ip_reg_expr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, access_list=access_list, ip_action=ip_action, ip_reg_expr=ip_reg_expr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ip_as_path_access_list_ip_action_delete(self, rbridge_id=None, access_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type access_list: name, seq_keyword, instance
    :param access_list: Keyword argument tuple.

    :type name: unicode
    :param name: **access_list** tuple argument.

        * length restriction: ::

            ['1..32']

    :type seq_keyword: unicode
    :param seq_keyword: **access_list** tuple argument.

        * enumeration restriction: ::

            ['seq']

    :type instance: int
    :param instance: **access_list** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ip.as_path.access_list', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ip.as_path.access_list', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ip.as_path.access_list', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'access_list', 'keyval': 'name, seq_keyword, instance', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ip-action'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, access_list=access_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, access_list=access_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ip_as_path_access_list_ip_reg_expr_delete(self, rbridge_id=None, access_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type access_list: name, seq_keyword, instance
    :param access_list: Keyword argument tuple.

    :type name: unicode
    :param name: **access_list** tuple argument.

        * length restriction: ::

            ['1..32']

    :type seq_keyword: unicode
    :param seq_keyword: **access_list** tuple argument.

        * enumeration restriction: ::

            ['seq']

    :type instance: int
    :param instance: **access_list** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ip.as_path.access_list', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ip.as_path.access_list', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ip.as_path.access_list', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'access_list', 'keyval': 'name, seq_keyword, instance', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ip-reg-expr'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, access_list=access_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, access_list=access_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ip_community_list_extended_delete(self, rbridge_id=None, extended=None, ip_action=None, ip_community_reg_expr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type extended: name, seq_keyword, instance, ip_action, ip_community_reg_expr
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

    :type seq_keyword: unicode
    :param seq_keyword: **extended** tuple argument.

        * enumeration restriction: ::

            ['seq']

    :type instance: int
    :param instance: **extended** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type ip_action: unicode
    :param ip_action: **extended** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type ip_community_reg_expr: unicode
    :param ip_community_reg_expr: **extended** tuple argument.

    **Instance Argument(s)**:

    :type ip_action: unicode
    :param ip_action: Keyword argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type ip_community_reg_expr: unicode
    :param ip_community_reg_expr: Keyword argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ip.community_list.extended', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ip.community_list.extended', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ip.community_list.extended', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.ip.community_list.extended', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'extended', 'keyval': 'name, seq_keyword, instance', 'extra_keyval': 'name, seq_keyword, instance, ip_action, ip_community_reg_expr'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, extended=extended, ip_action=ip_action, ip_community_reg_expr=ip_community_reg_expr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, extended=extended, ip_action=ip_action, ip_community_reg_expr=ip_community_reg_expr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ip_community_list_extended_ip_action_delete(self, rbridge_id=None, extended=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type extended: name, seq_keyword, instance
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

    :type seq_keyword: unicode
    :param seq_keyword: **extended** tuple argument.

        * enumeration restriction: ::

            ['seq']

    :type instance: int
    :param instance: **extended** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ip.community_list.extended', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ip.community_list.extended', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ip.community_list.extended', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.ip.community_list.extended', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'extended', 'keyval': 'name, seq_keyword, instance', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ip-action'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, extended=extended)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, extended=extended)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ip_community_list_extended_ip_community_reg_expr_delete(self, rbridge_id=None, extended=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type extended: name, seq_keyword, instance
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

    :type seq_keyword: unicode
    :param seq_keyword: **extended** tuple argument.

        * enumeration restriction: ::

            ['seq']

    :type instance: int
    :param instance: **extended** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ip.community_list.extended', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ip.community_list.extended', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ip.community_list.extended', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.ip.community_list.extended', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'extended', 'keyval': 'name, seq_keyword, instance', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ip-community-reg-expr'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, extended=extended)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, extended=extended)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ip_community_list_standard_delete(self, rbridge_id=None, standard=None, ip_action=None, std_community_expr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type standard: name, seq_keyword, instance, ip_action, std_community_expr
    :param standard: Keyword argument tuple.

    :type name: unicode
    :param name: **standard** tuple argument.

    :type seq_keyword: unicode
    :param seq_keyword: **standard** tuple argument.

        * enumeration restriction: ::

            ['seq']

    :type instance: int
    :param instance: **standard** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type ip_action: unicode
    :param ip_action: **standard** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type std_community_expr: unicode
    :param std_community_expr: **standard** tuple argument.

        * pattern restriction: ::

            '(\s*)|(\s*((local\-as)|(internet)|(no\-export)|('
            'no\-advertise)|((([1-9][0-9]{0,3})|([1-5][0-9]{4'
            '})|(6[0-4][0-9]{3})|(65[0-4][0-9]{2})|(655[0-2]['
            '0-9])|(6553[0-5])):(([0-9][0-9]{0,3})|([1-5][0-9'
            ']{4})|(6[0-4][0-9]{3})|(65[0-4][0-9]{2})|(655[0-'
            '2][0-9])|(6553[0-5])))|([1-9][0-9]{0,8})|([1-3]['
            '0-9]{9})|(4[0-1][0-9]{8})|(42[0-8][0-9]{7})|(429'
            '[0-3][0-9]{6})|(4294[0-8][0-9]{5})|(42949[0-5][0'
            '-9]{4})|(429496[0-6][0-9]{3})|(4294967[0-1][0-9]'
            '{2})|(42949672[0-8][0-9])|(429496729[0-5])))((\s'
            '+((local\-as)|(internet)|(no\-export)|(no\-adver'
            'tise)|((([1-9][0-9]{0,3})|([1-5][0-9]{4})|(6[0-4'
            '][0-9]{3})|(65[0-4][0-9]{2})|(655[0-2][0-9])|(65'
            '53[0-5])):(([0-9][0-9]{0,3})|([1-5][0-9]{4})|(6['
            '0-4][0-9]{3})|(65[0-4][0-9]{2})|(655[0-2][0-9])|'
            '(6553[0-5])))|([1-9][0-9]{0,8})|([1-3][0-9]{9})|'
            '(4[0-1][0-9]{8})|(42[0-8][0-9]{7})|(429[0-3][0-9'
            ']{6})|(4294[0-8][0-9]{5})|(42949[0-5][0-9]{4})|('
            '429496[0-6][0-9]{3})|(4294967[0-1][0-9]{2})|(429'
            '49672[0-8][0-9])|(429496729[0-5])))*)'

    **Instance Argument(s)**:

    :type ip_action: unicode
    :param ip_action: Keyword argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type std_community_expr: unicode
    :param std_community_expr: Keyword argument.

        * pattern restriction: ::

            '(\s*)|(\s*((local\-as)|(internet)|(no\-export)|('
            'no\-advertise)|((([1-9][0-9]{0,3})|([1-5][0-9]{4'
            '})|(6[0-4][0-9]{3})|(65[0-4][0-9]{2})|(655[0-2]['
            '0-9])|(6553[0-5])):(([0-9][0-9]{0,3})|([1-5][0-9'
            ']{4})|(6[0-4][0-9]{3})|(65[0-4][0-9]{2})|(655[0-'
            '2][0-9])|(6553[0-5])))|([1-9][0-9]{0,8})|([1-3]['
            '0-9]{9})|(4[0-1][0-9]{8})|(42[0-8][0-9]{7})|(429'
            '[0-3][0-9]{6})|(4294[0-8][0-9]{5})|(42949[0-5][0'
            '-9]{4})|(429496[0-6][0-9]{3})|(4294967[0-1][0-9]'
            '{2})|(42949672[0-8][0-9])|(429496729[0-5])))((\s'
            '+((local\-as)|(internet)|(no\-export)|(no\-adver'
            'tise)|((([1-9][0-9]{0,3})|([1-5][0-9]{4})|(6[0-4'
            '][0-9]{3})|(65[0-4][0-9]{2})|(655[0-2][0-9])|(65'
            '53[0-5])):(([0-9][0-9]{0,3})|([1-5][0-9]{4})|(6['
            '0-4][0-9]{3})|(65[0-4][0-9]{2})|(655[0-2][0-9])|'
            '(6553[0-5])))|([1-9][0-9]{0,8})|([1-3][0-9]{9})|'
            '(4[0-1][0-9]{8})|(42[0-8][0-9]{7})|(429[0-3][0-9'
            ']{6})|(4294[0-8][0-9]{5})|(42949[0-5][0-9]{4})|('
            '429496[0-6][0-9]{3})|(4294967[0-1][0-9]{2})|(429'
            '49672[0-8][0-9])|(429496729[0-5])))*)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ip.community_list.standard', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ip.community_list.standard', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ip.community_list.standard', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.ip.community_list.standard', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'standard', 'keyval': 'name, seq_keyword, instance', 'extra_keyval': 'name, seq_keyword, instance, ip_action, std_community_expr'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, standard=standard, ip_action=ip_action, std_community_expr=std_community_expr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, standard=standard, ip_action=ip_action, std_community_expr=std_community_expr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ip_community_list_standard_ip_action_delete(self, rbridge_id=None, standard=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type standard: name, seq_keyword, instance
    :param standard: Keyword argument tuple.

    :type name: unicode
    :param name: **standard** tuple argument.

    :type seq_keyword: unicode
    :param seq_keyword: **standard** tuple argument.

        * enumeration restriction: ::

            ['seq']

    :type instance: int
    :param instance: **standard** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ip.community_list.standard', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ip.community_list.standard', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ip.community_list.standard', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.ip.community_list.standard', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'standard', 'keyval': 'name, seq_keyword, instance', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ip-action'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, standard=standard)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, standard=standard)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ip_community_list_standard_std_community_expr_delete(self, rbridge_id=None, standard=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type standard: name, seq_keyword, instance
    :param standard: Keyword argument tuple.

    :type name: unicode
    :param name: **standard** tuple argument.

    :type seq_keyword: unicode
    :param seq_keyword: **standard** tuple argument.

        * enumeration restriction: ::

            ['seq']

    :type instance: int
    :param instance: **standard** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ip.community_list.standard', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ip.community_list.standard', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ip.community_list.standard', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.ip.community_list.standard', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'standard', 'keyval': 'name, seq_keyword, instance', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'std-community-expr'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, standard=standard)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, standard=standard)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ip_dhcp_relay_information_option_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ip.dhcp.relay.information', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ip.dhcp.relay.information', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ip.dhcp.relay.information', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'option'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ip_extcommunity_list_delete(self, rbridge_id=None, extcommunity_list=None, ext_community_action=None, ext_community_expr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type extcommunity_list: extcommunity_list_num, ext_community_action, ext_community_expr
    :param extcommunity_list: Keyword argument tuple.

    :type extcommunity_list_num: int
    :param extcommunity_list_num: **extcommunity_list** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type ext_community_action: unicode
    :param ext_community_action: **extcommunity_list** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type ext_community_expr: unicode
    :param ext_community_expr: **extcommunity_list** tuple argument:  Ext-community-list

        * pattern restriction: ::

            '(\s*)|(\s*((rt)|(soo)|((([1-9][0-9]{0,8})|([1-3]'
            '[0-9]{9})|(4[0-1][0-9]{8})|(42[0-8][0-9]{7})|(42'
            '9[0-3][0-9]{6})|(4294[0-8][0-9]{5})|(42949[0-5]['
            '0-9]{4})|(429496[0-6][0-9]{3})|(4294967[0-1][0-9'
            ']{2})|(42949672[0-8][0-9])|(429496729[0-5])):((['
            '1-9][0-9]{0,8})|([1-3][0-9]{9})|(4[0-1][0-9]{8})'
            '|(42[0-8][0-9]{7})|(429[0-3][0-9]{6})|(4294[0-8]'
            '[0-9]{5})|(42949[0-5][0-9]{4})|(429496[0-6][0-9]'
            '{3})|(4294967[0-1][0-9]{2})|(42949672[0-8][0-9])'
            '|(429496729[0-5])))|((([0-9]|[1-9][0-9]|1[0-9]{2'
            '}|2[0-4][0-9]|25[0-5])\.){3}([0-9]|[1-9][0-9]|1['
            '0-9]{2}|2[0-4][0-9]|25[0-5]):(([1-9][0-9]{0,8})|'
            '([1-3][0-9]{9})|(4[0-1][0-9]{8})|(42[0-8][0-9]{7'
            '})|(429[0-3][0-9]{6})|(4294[0-8][0-9]{5})|(42949'
            '[0-5][0-9]{4})|(429496[0-6][0-9]{3})|(4294967[0-'
            '1][0-9]{2})|(42949672[0-8][0-9])|(429496729[0-5]'
            ')))))((\s+((rt)|(soo)|((([1-9][0-9]{0,8})|([1-3]'
            '[0-9]{9})|(4[0-1][0-9]{8})|(42[0-8][0-9]{7})|(42'
            '9[0-3][0-9]{6})|(4294[0-8][0-9]{5})|(42949[0-5]['
            '0-9]{4})|(429496[0-6][0-9]{3})|(4294967[0-1][0-9'
            ']{2})|(42949672[0-8][0-9])|(429496729[0-5])):((['
            '1-9][0-9]{0,8})|([1-3][0-9]{9})|(4[0-1][0-9]{8})'
            '|(42[0-8][0-9]{7})|(429[0-3][0-9]{6})|(4294[0-8]'
            '[0-9]{5})|(42949[0-5][0-9]{4})|(429496[0-6][0-9]'
            '{3})|(4294967[0-1][0-9]{2})|(42949672[0-8][0-9])'
            '|(429496729[0-5])))|(((([0-9]|[1-9][0-9]|1[0-9]{'
            '2}|2[0-4][0-9]|25[0-5])\.){3}([0-9]|[1-9][0-9]|1'
            '[0-9]{2}|2[0-4][0-9]|25[0-5])):(([1-9][0-9]{0,8}'
            ')|([1-3][0-9]{9})|(4[0-1][0-9]{8})|(42[0-8][0-9]'
            '{7})|(429[0-3][0-9]{6})|(4294[0-8][0-9]{5})|(429'
            '49[0-5][0-9]{4})|(429496[0-6][0-9]{3})|(4294967['
            '0-1][0-9]{2})|(42949672[0-8][0-9])|(429496729[0-'
            '5])))))*)'

    **Instance Argument(s)**:

    :type ext_community_action: unicode
    :param ext_community_action: Keyword argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type ext_community_expr: unicode
    :param ext_community_expr: Ext-community-list

        * pattern restriction: ::

            '(\s*)|(\s*((rt)|(soo)|((([1-9][0-9]{0,8})|([1-3]'
            '[0-9]{9})|(4[0-1][0-9]{8})|(42[0-8][0-9]{7})|(42'
            '9[0-3][0-9]{6})|(4294[0-8][0-9]{5})|(42949[0-5]['
            '0-9]{4})|(429496[0-6][0-9]{3})|(4294967[0-1][0-9'
            ']{2})|(42949672[0-8][0-9])|(429496729[0-5])):((['
            '1-9][0-9]{0,8})|([1-3][0-9]{9})|(4[0-1][0-9]{8})'
            '|(42[0-8][0-9]{7})|(429[0-3][0-9]{6})|(4294[0-8]'
            '[0-9]{5})|(42949[0-5][0-9]{4})|(429496[0-6][0-9]'
            '{3})|(4294967[0-1][0-9]{2})|(42949672[0-8][0-9])'
            '|(429496729[0-5])))|((([0-9]|[1-9][0-9]|1[0-9]{2'
            '}|2[0-4][0-9]|25[0-5])\.){3}([0-9]|[1-9][0-9]|1['
            '0-9]{2}|2[0-4][0-9]|25[0-5]):(([1-9][0-9]{0,8})|'
            '([1-3][0-9]{9})|(4[0-1][0-9]{8})|(42[0-8][0-9]{7'
            '})|(429[0-3][0-9]{6})|(4294[0-8][0-9]{5})|(42949'
            '[0-5][0-9]{4})|(429496[0-6][0-9]{3})|(4294967[0-'
            '1][0-9]{2})|(42949672[0-8][0-9])|(429496729[0-5]'
            ')))))((\s+((rt)|(soo)|((([1-9][0-9]{0,8})|([1-3]'
            '[0-9]{9})|(4[0-1][0-9]{8})|(42[0-8][0-9]{7})|(42'
            '9[0-3][0-9]{6})|(4294[0-8][0-9]{5})|(42949[0-5]['
            '0-9]{4})|(429496[0-6][0-9]{3})|(4294967[0-1][0-9'
            ']{2})|(42949672[0-8][0-9])|(429496729[0-5])):((['
            '1-9][0-9]{0,8})|([1-3][0-9]{9})|(4[0-1][0-9]{8})'
            '|(42[0-8][0-9]{7})|(429[0-3][0-9]{6})|(4294[0-8]'
            '[0-9]{5})|(42949[0-5][0-9]{4})|(429496[0-6][0-9]'
            '{3})|(4294967[0-1][0-9]{2})|(42949672[0-8][0-9])'
            '|(429496729[0-5])))|(((([0-9]|[1-9][0-9]|1[0-9]{'
            '2}|2[0-4][0-9]|25[0-5])\.){3}([0-9]|[1-9][0-9]|1'
            '[0-9]{2}|2[0-4][0-9]|25[0-5])):(([1-9][0-9]{0,8}'
            ')|([1-3][0-9]{9})|(4[0-1][0-9]{8})|(42[0-8][0-9]'
            '{7})|(429[0-3][0-9]{6})|(4294[0-8][0-9]{5})|(429'
            '49[0-5][0-9]{4})|(429496[0-6][0-9]{3})|(4294967['
            '0-1][0-9]{2})|(42949672[0-8][0-9])|(429496729[0-'
            '5])))))*)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ip.extcommunity_list', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ip.extcommunity_list', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ip.extcommunity_list', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'extcommunity_list', 'keyval': 'extcommunity_list_num', 'extra_keyval': 'extcommunity_list_num, ext_community_action, ext_community_expr'}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v6_0_2c.rbridge_id.ip.extcommunity_list": {"ext_community_action": "ext_community_action", "ext_community_expr": "ext_community_expr", "extcommunity_list_num": "extcommunity_list_num"}, "pybind.nos.v7_1_0.rbridge_id.ip.extcommunity_list": {}, "pybind.nos.v7_0_1b.rbridge_id.ip.extcommunity_list": {"ext_community_action": "ext_community_action", "ext_community_expr": "ext_community_expr", "extcommunity_list_num": "extcommunity_list_num"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, extcommunity_list=extcommunity_list, ext_community_action=ext_community_action, ext_community_expr=ext_community_expr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, extcommunity_list=extcommunity_list, ext_community_action=ext_community_action, ext_community_expr=ext_community_expr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ip_extcommunity_list_ext_community_action_delete(self, rbridge_id=None, extcommunity_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type extcommunity_list: extcommunity_list_num
    :param extcommunity_list: Keyword argument tuple.

    :type extcommunity_list_num: int
    :param extcommunity_list_num: **extcommunity_list** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ip.extcommunity_list', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ip.extcommunity_list', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ip.extcommunity_list', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'extcommunity_list', 'keyval': 'extcommunity_list_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ext-community-action'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, extcommunity_list=extcommunity_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, extcommunity_list=extcommunity_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ip_extcommunity_list_ext_community_expr_delete(self, rbridge_id=None, extcommunity_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type extcommunity_list: extcommunity_list_num
    :param extcommunity_list: Keyword argument tuple.

    :type extcommunity_list_num: int
    :param extcommunity_list_num: **extcommunity_list** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ip.extcommunity_list', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ip.extcommunity_list', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ip.extcommunity_list', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'extcommunity_list', 'keyval': 'extcommunity_list_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ext-community-expr'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, extcommunity_list=extcommunity_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, extcommunity_list=extcommunity_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ip_extcommunity_list_ext_community_regex_delete(self, rbridge_id=None, extcommunity_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type extcommunity_list: extcommunity_list_num
    :param extcommunity_list: Keyword argument tuple.

    :type extcommunity_list_num: int
    :param extcommunity_list_num: **extcommunity_list** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_1_0.rbridge_id.ip.extcommunity_list', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'extcommunity_list', 'keyval': 'extcommunity_list_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ext-community-regex'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, extcommunity_list=extcommunity_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, extcommunity_list=extcommunity_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ip_import_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ip.import_', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ip.import_', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ip.import_', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ip_import_routes_delete(self, rbridge_id=None, routes=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type routes: src_vrf, route_map
    :param routes: Keyword argument tuple.

    :type src_vrf: unicode
    :param src_vrf: **routes** tuple argument:  ASCII string;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type route_map: unicode
    :param route_map: **routes** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ip.import_.routes', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ip.import_.routes', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ip.import_.routes', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'routes', 'keyval': 'src_vrf, route_map', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, routes=routes)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, routes=routes)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ip_load_sharing_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ip.rtm_config', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ip.rtm_config', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ip.rtm_config', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'load-sharing'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ip_prefix_list_delete(self, rbridge_id=None, prefix_list=None, action_ipp=None, prefix_ipp=None, ge_ipp=None, le_ipp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type prefix_list: name, seq_keyword, instance, action_ipp, prefix_ipp, ge_ipp, le_ipp
    :param prefix_list: Keyword argument tuple.

    :type name: unicode
    :param name: **prefix_list** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type seq_keyword: unicode
    :param seq_keyword: **prefix_list** tuple argument.

        * enumeration restriction: ::

            ['seq']

    :type instance: int
    :param instance: **prefix_list** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type action_ipp: unicode
    :param action_ipp: **prefix_list** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type prefix_ipp: unicode
    :param prefix_ipp: **prefix_list** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type ge_ipp: long
    :param ge_ipp: **prefix_list** tuple argument:  Minimum IP prefix length.

        * range restriction: ::

            ['0..4294967295']

    :type le_ipp: long
    :param le_ipp: **prefix_list** tuple argument:  Maximum IP prefix length.

        * range restriction: ::

            ['0..4294967295']

    **Instance Argument(s)**:

    :type action_ipp: unicode
    :param action_ipp: Keyword argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type prefix_ipp: unicode
    :param prefix_ipp: Keyword argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type ge_ipp: long
    :param ge_ipp: Minimum IP prefix length.

        * range restriction: ::

            ['0..4294967295']

    :type le_ipp: long
    :param le_ipp: Maximum IP prefix length.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ip.prefix_list', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ip.prefix_list', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ip.prefix_list', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_list', 'keyval': 'name, seq_keyword, instance', 'extra_keyval': 'name, seq_keyword, instance, action_ipp, prefix_ipp, ge_ipp, le_ipp'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, prefix_list=prefix_list, action_ipp=action_ipp, prefix_ipp=prefix_ipp, ge_ipp=ge_ipp, le_ipp=le_ipp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, prefix_list=prefix_list, action_ipp=action_ipp, prefix_ipp=prefix_ipp, ge_ipp=ge_ipp, le_ipp=le_ipp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ip_prefix_list_action_ipp_delete(self, rbridge_id=None, prefix_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type prefix_list: name, seq_keyword, instance
    :param prefix_list: Keyword argument tuple.

    :type name: unicode
    :param name: **prefix_list** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type seq_keyword: unicode
    :param seq_keyword: **prefix_list** tuple argument.

        * enumeration restriction: ::

            ['seq']

    :type instance: int
    :param instance: **prefix_list** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ip.prefix_list', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ip.prefix_list', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ip.prefix_list', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_list', 'keyval': 'name, seq_keyword, instance', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'action-ipp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, prefix_list=prefix_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, prefix_list=prefix_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ip_prefix_list_ge_delete(self, rbridge_id=None, prefix_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type prefix_list: name, seq_keyword, instance
    :param prefix_list: Keyword argument tuple.

    :type name: unicode
    :param name: **prefix_list** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type seq_keyword: unicode
    :param seq_keyword: **prefix_list** tuple argument.

        * enumeration restriction: ::

            ['seq']

    :type instance: int
    :param instance: **prefix_list** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ip.prefix_list', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ip.prefix_list', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ip.prefix_list', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_list', 'keyval': 'name, seq_keyword, instance', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ge'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, prefix_list=prefix_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, prefix_list=prefix_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ip_prefix_list_le_delete(self, rbridge_id=None, prefix_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type prefix_list: name, seq_keyword, instance
    :param prefix_list: Keyword argument tuple.

    :type name: unicode
    :param name: **prefix_list** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type seq_keyword: unicode
    :param seq_keyword: **prefix_list** tuple argument.

        * enumeration restriction: ::

            ['seq']

    :type instance: int
    :param instance: **prefix_list** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ip.prefix_list', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ip.prefix_list', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ip.prefix_list', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_list', 'keyval': 'name, seq_keyword, instance', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'le'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, prefix_list=prefix_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, prefix_list=prefix_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ip_prefix_list_prefix_ipp_delete(self, rbridge_id=None, prefix_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type prefix_list: name, seq_keyword, instance
    :param prefix_list: Keyword argument tuple.

    :type name: unicode
    :param name: **prefix_list** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type seq_keyword: unicode
    :param seq_keyword: **prefix_list** tuple argument.

        * enumeration restriction: ::

            ['seq']

    :type instance: int
    :param instance: **prefix_list** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ip.prefix_list', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ip.prefix_list', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ip.prefix_list', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_list', 'keyval': 'name, seq_keyword, instance', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'prefix-ipp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, prefix_list=prefix_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, prefix_list=prefix_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ip_route_static_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ip.rtm_config.route.static', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ip.rtm_config.route.static', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ip.rtm_config.route.static', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ip_route_static_bfd_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ip.rtm_config.route.static.bfd', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ip.rtm_config.route.static.bfd', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ip.rtm_config.route.static.bfd', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ip_route_static_bfd_bfd_static_route_delete(self, rbridge_id=None, bfd_static_route=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type bfd_static_route: bfd_static_route_dest, bfd_static_route_src
    :param bfd_static_route: Keyword argument tuple.

    :type bfd_static_route_dest: unicode
    :param bfd_static_route_dest: **bfd_static_route** tuple argument:  A.B.C.D ;; Destination IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type bfd_static_route_src: unicode
    :param bfd_static_route_src: **bfd_static_route** tuple argument:  A.B.C.D ;; Source IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ip.rtm_config.route.static.bfd.bfd_static_route', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ip.rtm_config.route.static.bfd.bfd_static_route', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ip.rtm_config.route.static.bfd.bfd_static_route', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'bfd_static_route', 'keyval': 'bfd_static_route_dest, bfd_static_route_src', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, bfd_static_route=bfd_static_route)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, bfd_static_route=bfd_static_route)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ip_route_static_bfd_holdover_interval_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ip.rtm_config.route.static.bfd', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ip.rtm_config.route.static.bfd', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ip.rtm_config.route.static.bfd', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'holdover-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ip_route_static_route_nh_delete(self, rbridge_id=None, static_route_nh=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type static_route_nh: static_route_dest, static_route_next_hop
    :param static_route_nh: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_nh** tuple argument:  A.B.C.D/L ;; Destination IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type static_route_next_hop: unicode
    :param static_route_next_hop: **static_route_nh** tuple argument:  A.B.C.D ;; Next hop IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ip.rtm_config.route.static_route_nh', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ip.rtm_config.route.static_route_nh', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ip.rtm_config.route.static_route_nh', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'static_route_nh', 'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, static_route_nh=static_route_nh)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, static_route_nh=static_route_nh)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ip_route_static_route_nh_distance_delete(self, rbridge_id=None, static_route_nh=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type static_route_nh: static_route_dest, static_route_next_hop
    :param static_route_nh: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_nh** tuple argument:  A.B.C.D/L ;; Destination IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type static_route_next_hop: unicode
    :param static_route_next_hop: **static_route_nh** tuple argument:  A.B.C.D ;; Next hop IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ip.rtm_config.route.static_route_nh', u'static_route_nh'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ip.rtm_config.route.static_route_nh', u'static_route_nh'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ip.rtm_config.route.static_route_nh', u'static_route_nh')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ip.rtm_config.route.static_route_nh.route_attributes', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ip.rtm_config.route.static_route_nh.route_attributes', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ip.rtm_config.route.static_route_nh.route_attributes', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'distance'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, static_route_nh=static_route_nh)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, static_route_nh=static_route_nh)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ip_route_static_route_nh_metric_delete(self, rbridge_id=None, static_route_nh=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type static_route_nh: static_route_dest, static_route_next_hop
    :param static_route_nh: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_nh** tuple argument:  A.B.C.D/L ;; Destination IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type static_route_next_hop: unicode
    :param static_route_next_hop: **static_route_nh** tuple argument:  A.B.C.D ;; Next hop IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ip.rtm_config.route.static_route_nh', u'static_route_nh'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ip.rtm_config.route.static_route_nh', u'static_route_nh'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ip.rtm_config.route.static_route_nh', u'static_route_nh')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ip.rtm_config.route.static_route_nh.route_attributes', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ip.rtm_config.route.static_route_nh.route_attributes', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ip.rtm_config.route.static_route_nh.route_attributes', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, static_route_nh=static_route_nh)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, static_route_nh=static_route_nh)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ip_route_static_route_nh_tag_delete(self, rbridge_id=None, static_route_nh=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type static_route_nh: static_route_dest, static_route_next_hop
    :param static_route_nh: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_nh** tuple argument:  A.B.C.D/L ;; Destination IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type static_route_next_hop: unicode
    :param static_route_next_hop: **static_route_nh** tuple argument:  A.B.C.D ;; Next hop IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ip.rtm_config.route.static_route_nh', u'static_route_nh'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ip.rtm_config.route.static_route_nh', u'static_route_nh'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ip.rtm_config.route.static_route_nh', u'static_route_nh')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ip.rtm_config.route.static_route_nh.route_attributes', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ip.rtm_config.route.static_route_nh.route_attributes', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ip.rtm_config.route.static_route_nh.route_attributes', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, static_route_nh=static_route_nh)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, static_route_nh=static_route_nh)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ip_route_static_route_nh_vrf_delete(self, rbridge_id=None, static_route_nh_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type static_route_nh_vrf: static_route_next_vrf_dest, next_hop_vrf, static_route_next_hop
    :param static_route_nh_vrf: Keyword argument tuple.

    :type static_route_next_vrf_dest: unicode
    :param static_route_next_vrf_dest: **static_route_nh_vrf** tuple argument:  A.B.C.D/L ;; Destination IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type next_hop_vrf: unicode
    :param next_hop_vrf: **static_route_nh_vrf** tuple argument:  Next Hop Vrf Name

    :type static_route_next_hop: unicode
    :param static_route_next_hop: **static_route_nh_vrf** tuple argument:  A.B.C.D ;; Next hop IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ip.rtm_config.route.static_route_nh_vrf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ip.rtm_config.route.static_route_nh_vrf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ip.rtm_config.route.static_route_nh_vrf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'static_route_nh_vrf', 'keyval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_next_hop', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, static_route_nh_vrf=static_route_nh_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, static_route_nh_vrf=static_route_nh_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ip_route_static_route_oif_delete(self, rbridge_id=None, static_route_oif=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type static_route_oif: static_route_dest, static_route_oif_type, static_route_oif_name
    :param static_route_oif: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_oif** tuple argument:  A.B.C.D/L ;; Destination IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type static_route_oif_type: unicode
    :param static_route_oif_type: **static_route_oif** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ve',
            'fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'null']

    :type static_route_oif_name: unicode
    :param static_route_oif_name: **static_route_oif** tuple argument.

        * length restriction: ::

            ['1..16']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ip.rtm_config.route.static_route_oif', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ip.rtm_config.route.static_route_oif', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ip.rtm_config.route.static_route_oif', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'static_route_oif', 'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, static_route_oif=static_route_oif)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, static_route_oif=static_route_oif)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ip_route_static_route_oif_distance_delete(self, rbridge_id=None, static_route_oif=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type static_route_oif: static_route_dest, static_route_oif_type, static_route_oif_name
    :param static_route_oif: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_oif** tuple argument:  A.B.C.D/L ;; Destination IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type static_route_oif_type: unicode
    :param static_route_oif_type: **static_route_oif** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ve',
            'fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'null']

    :type static_route_oif_name: unicode
    :param static_route_oif_name: **static_route_oif** tuple argument.

        * length restriction: ::

            ['1..16']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ip.rtm_config.route.static_route_oif', u'static_route_oif'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ip.rtm_config.route.static_route_oif', u'static_route_oif'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ip.rtm_config.route.static_route_oif', u'static_route_oif')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ip.rtm_config.route.static_route_oif.route_attributes', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ip.rtm_config.route.static_route_oif.route_attributes', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ip.rtm_config.route.static_route_oif.route_attributes', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'distance'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, static_route_oif=static_route_oif)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, static_route_oif=static_route_oif)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ip_route_static_route_oif_metric_delete(self, rbridge_id=None, static_route_oif=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type static_route_oif: static_route_dest, static_route_oif_type, static_route_oif_name
    :param static_route_oif: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_oif** tuple argument:  A.B.C.D/L ;; Destination IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type static_route_oif_type: unicode
    :param static_route_oif_type: **static_route_oif** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ve',
            'fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'null']

    :type static_route_oif_name: unicode
    :param static_route_oif_name: **static_route_oif** tuple argument.

        * length restriction: ::

            ['1..16']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ip.rtm_config.route.static_route_oif', u'static_route_oif'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ip.rtm_config.route.static_route_oif', u'static_route_oif'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ip.rtm_config.route.static_route_oif', u'static_route_oif')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ip.rtm_config.route.static_route_oif.route_attributes', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ip.rtm_config.route.static_route_oif.route_attributes', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ip.rtm_config.route.static_route_oif.route_attributes', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, static_route_oif=static_route_oif)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, static_route_oif=static_route_oif)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ip_route_static_route_oif_tag_delete(self, rbridge_id=None, static_route_oif=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type static_route_oif: static_route_dest, static_route_oif_type, static_route_oif_name
    :param static_route_oif: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_oif** tuple argument:  A.B.C.D/L ;; Destination IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type static_route_oif_type: unicode
    :param static_route_oif_type: **static_route_oif** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ve',
            'fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'null']

    :type static_route_oif_name: unicode
    :param static_route_oif_name: **static_route_oif** tuple argument.

        * length restriction: ::

            ['1..16']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ip.rtm_config.route.static_route_oif', u'static_route_oif'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ip.rtm_config.route.static_route_oif', u'static_route_oif'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ip.rtm_config.route.static_route_oif', u'static_route_oif')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ip.rtm_config.route.static_route_oif.route_attributes', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ip.rtm_config.route.static_route_oif.route_attributes', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ip.rtm_config.route.static_route_oif.route_attributes', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, static_route_oif=static_route_oif)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, static_route_oif=static_route_oif)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ip_route_static_route_oif_vrf_delete(self, rbridge_id=None, static_route_oif_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type static_route_oif_vrf: static_route_next_vrf_dest, next_hop_vrf, static_route_oif_type, static_route_oif_name
    :param static_route_oif_vrf: Keyword argument tuple.

    :type static_route_next_vrf_dest: unicode
    :param static_route_next_vrf_dest: **static_route_oif_vrf** tuple argument:  A.B.C.D/L ;; Destination IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type next_hop_vrf: unicode
    :param next_hop_vrf: **static_route_oif_vrf** tuple argument:  Next Hop Vrf Name

    :type static_route_oif_type: unicode
    :param static_route_oif_type: **static_route_oif_vrf** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            've']

    :type static_route_oif_name: unicode
    :param static_route_oif_name: **static_route_oif_vrf** tuple argument.

        * length restriction: ::

            ['1..16']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ip.rtm_config.route.static_route_oif_vrf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ip.rtm_config.route.static_route_oif_vrf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ip.rtm_config.route.static_route_oif_vrf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'static_route_oif_vrf', 'keyval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, static_route_oif_vrf=static_route_oif_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, static_route_oif_vrf=static_route_oif_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ip_router_id_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ip.rtm_config', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ip.rtm_config', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ip.rtm_config', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'router-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ip_rtm_config_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ip.rtm_config', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ip.rtm_config', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ip.rtm_config', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ip_static_ag_ip_config_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.ip.static_ag_ip_config', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ip.static_ag_ip_config', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_anycast_gateway_mac_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.ipv6.static_ag_ipv6_config.anycast_gateway_mac', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.static_ag_ipv6_config.anycast_gateway_mac', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_anycast_gateway_mac_default_mac_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.ipv6.static_ag_ipv6_config.anycast_gateway_mac', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.static_ag_ipv6_config.anycast_gateway_mac', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'default-mac'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_anycast_gateway_mac_ipv6_anycast_gateway_mac_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.ipv6.static_ag_ipv6_config.anycast_gateway_mac', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.static_ag_ipv6_config.anycast_gateway_mac', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ipv6-anycast-gateway-mac'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_import_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.import_', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.import_', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.import_', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_import_routes_delete(self, rbridge_id=None, routes=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type routes: src_vrf, route_map
    :param routes: Keyword argument tuple.

    :type src_vrf: unicode
    :param src_vrf: **routes** tuple argument:  ASCII string;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type route_map: unicode
    :param route_map: **routes** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.import_.routes', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.import_.routes', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.import_.routes', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'routes', 'keyval': 'src_vrf, route_map', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, routes=routes)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, routes=routes)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_ipv6_global_cmds_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.ipv6_global_cmds', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.ipv6_global_cmds', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.ipv6_global_cmds', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_ipv6route_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.ipv6route', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.ipv6route', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.ipv6route', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.ipv6.ipv6route', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_nd_dad_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.ipv6_global_cmds.nd_global.dad', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.ipv6_global_cmds.nd_global.dad', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.ipv6_global_cmds.nd_global.dad', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_nd_dad_time_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.ipv6_global_cmds.nd_global.dad', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.ipv6_global_cmds.nd_global.dad', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.ipv6_global_cmds.nd_global.dad', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_prefix_list_delete(self, rbridge_id=None, prefix_list=None, action_ipp=None, ipv6_prefix_ipp=None, ge_ipp=None, le_ipp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type prefix_list: name, seq_keyword, instance, action_ipp, ipv6_prefix_ipp, ge_ipp, le_ipp
    :param prefix_list: Keyword argument tuple.

    :type name: unicode
    :param name: **prefix_list** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type seq_keyword: unicode
    :param seq_keyword: **prefix_list** tuple argument.

        * enumeration restriction: ::

            ['seq']

    :type instance: int
    :param instance: **prefix_list** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type action_ipp: unicode
    :param action_ipp: **prefix_list** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type ipv6_prefix_ipp: unicode
    :param ipv6_prefix_ipp: **prefix_list** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type ge_ipp: long
    :param ge_ipp: **prefix_list** tuple argument:  Minimum IPv6 prefix length.

        * range restriction: ::

            ['0..4294967295']

    :type le_ipp: long
    :param le_ipp: **prefix_list** tuple argument:  Maximum IPv6 prefix length.

        * range restriction: ::

            ['0..4294967295']

    **Instance Argument(s)**:

    :type action_ipp: unicode
    :param action_ipp: Keyword argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type ipv6_prefix_ipp: unicode
    :param ipv6_prefix_ipp: Keyword argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type ge_ipp: long
    :param ge_ipp: Minimum IPv6 prefix length.

        * range restriction: ::

            ['0..4294967295']

    :type le_ipp: long
    :param le_ipp: Maximum IPv6 prefix length.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.prefix_list', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.prefix_list', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.prefix_list', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_list', 'keyval': 'name, seq_keyword, instance', 'extra_keyval': 'name, seq_keyword, instance, action_ipp, ipv6_prefix_ipp, ge_ipp, le_ipp'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, prefix_list=prefix_list, action_ipp=action_ipp, ipv6_prefix_ipp=ipv6_prefix_ipp, ge_ipp=ge_ipp, le_ipp=le_ipp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, prefix_list=prefix_list, action_ipp=action_ipp, ipv6_prefix_ipp=ipv6_prefix_ipp, ge_ipp=ge_ipp, le_ipp=le_ipp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_prefix_list_action_ipp_delete(self, rbridge_id=None, prefix_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type prefix_list: name, seq_keyword, instance
    :param prefix_list: Keyword argument tuple.

    :type name: unicode
    :param name: **prefix_list** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type seq_keyword: unicode
    :param seq_keyword: **prefix_list** tuple argument.

        * enumeration restriction: ::

            ['seq']

    :type instance: int
    :param instance: **prefix_list** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.prefix_list', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.prefix_list', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.prefix_list', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_list', 'keyval': 'name, seq_keyword, instance', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'action-ipp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, prefix_list=prefix_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, prefix_list=prefix_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_prefix_list_ge_delete(self, rbridge_id=None, prefix_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type prefix_list: name, seq_keyword, instance
    :param prefix_list: Keyword argument tuple.

    :type name: unicode
    :param name: **prefix_list** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type seq_keyword: unicode
    :param seq_keyword: **prefix_list** tuple argument.

        * enumeration restriction: ::

            ['seq']

    :type instance: int
    :param instance: **prefix_list** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.prefix_list', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.prefix_list', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.prefix_list', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_list', 'keyval': 'name, seq_keyword, instance', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ge'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, prefix_list=prefix_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, prefix_list=prefix_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_prefix_list_ipv6_prefix_ipp_delete(self, rbridge_id=None, prefix_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type prefix_list: name, seq_keyword, instance
    :param prefix_list: Keyword argument tuple.

    :type name: unicode
    :param name: **prefix_list** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type seq_keyword: unicode
    :param seq_keyword: **prefix_list** tuple argument.

        * enumeration restriction: ::

            ['seq']

    :type instance: int
    :param instance: **prefix_list** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.prefix_list', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.prefix_list', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.prefix_list', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_list', 'keyval': 'name, seq_keyword, instance', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ipv6-prefix-ipp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, prefix_list=prefix_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, prefix_list=prefix_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_prefix_list_le_delete(self, rbridge_id=None, prefix_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type prefix_list: name, seq_keyword, instance
    :param prefix_list: Keyword argument tuple.

    :type name: unicode
    :param name: **prefix_list** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type seq_keyword: unicode
    :param seq_keyword: **prefix_list** tuple argument.

        * enumeration restriction: ::

            ['seq']

    :type instance: int
    :param instance: **prefix_list** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.prefix_list', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.prefix_list', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.prefix_list', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_list', 'keyval': 'name, seq_keyword, instance', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'le'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, prefix_list=prefix_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, prefix_list=prefix_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_protocol_vrrp_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.proto_vrrpv3', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.proto_vrrpv3', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.proto_vrrpv3', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vrrp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_protocol_vrrp_extended_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.proto_vrrpv3', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.proto_vrrpv3', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.proto_vrrpv3', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vrrp-extended'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_receive_access_group_ip_direction_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.receive.access_group', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.receive.access_group', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.receive.access_group', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ip-direction'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_receive_access_group_ipv6_access_list_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.receive.access_group', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.receive.access_group', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.receive.access_group', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ipv6-access-list'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_route_delete(self, rbridge_id=None, route=None, next_hop=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type route: dest
    :param route: Keyword argument tuple.

    :type dest: unicode
    :param dest: **route** tuple argument:  IPv6Address/prefix.;; Destination IPv6 address-prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    **Instance Argument(s)**:

    :type next_hop: unicode
    :param next_hop: IPv6 address.;; Next hop IPv6 address. Choice keyword argument (Only one choice argument allowed per API invocation).

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.ipv6route.route', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.ipv6route.route', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.ipv6route.route', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.ipv6.ipv6route.route', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'route', 'keyval': 'dest', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v6_0_2c.rbridge_id.ipv6.ipv6route.route': [u'next_hop'], 'pybind.nos.v7_0_1b.rbridge_id.ipv6.ipv6route.route': [u'next_hop'], 'pybind.nos.v7_1_0.rbridge_id.ipv6.ipv6route.route': [u'next_hop'], 'pybind.slxos.v16r_1_00b.rbridge_id.ipv6.ipv6route.route': [u'next_hop']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route=route, next_hop=next_hop)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route=route, next_hop=next_hop)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_route_ipv6_static_route_oif_vrf_delete(self, rbridge_id=None, ipv6_static_route_oif_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ipv6_static_route_oif_vrf: static_route_next_vrf_dest, next_hop_vrf, static_route_oif_type, static_route_oif_name
    :param ipv6_static_route_oif_vrf: Keyword argument tuple.

    :type static_route_next_vrf_dest: unicode
    :param static_route_next_vrf_dest: **ipv6_static_route_oif_vrf** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type next_hop_vrf: unicode
    :param next_hop_vrf: **ipv6_static_route_oif_vrf** tuple argument:  Next Hop Vrf Name

    :type static_route_oif_type: unicode
    :param static_route_oif_type: **ipv6_static_route_oif_vrf** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            've']

    :type static_route_oif_name: unicode
    :param static_route_oif_name: **ipv6_static_route_oif_vrf** tuple argument.

        * length restriction: ::

            ['1..16']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.route.ipv6_static_route_oif_vrf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.route.ipv6_static_route_oif_vrf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.route.ipv6_static_route_oif_vrf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_static_route_oif_vrf', 'keyval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ipv6_static_route_oif_vrf=ipv6_static_route_oif_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ipv6_static_route_oif_vrf=ipv6_static_route_oif_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_route_link_local_static_route_nh_delete(self, rbridge_id=None, link_local_static_route_nh=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type link_local_static_route_nh: link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name
    :param link_local_static_route_nh: Keyword argument tuple.

    :type link_local_static_route_dest: unicode
    :param link_local_static_route_dest: **link_local_static_route_nh** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type link_local_nexthop: unicode
    :param link_local_nexthop: **link_local_static_route_nh** tuple argument:  A:B::C:D ;; Next hop IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type link_local_route_oif_type: unicode
    :param link_local_route_oif_type: **link_local_static_route_nh** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['management',
            've',
            'fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'null']

    :type link_local_route_oif_name: unicode
    :param link_local_route_oif_name: **link_local_static_route_nh** tuple argument.

        * length restriction: ::

            ['1..16']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.route.link_local_static_route_nh', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.route.link_local_static_route_nh', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.route.link_local_static_route_nh', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'link_local_static_route_nh', 'keyval': 'link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, link_local_static_route_nh=link_local_static_route_nh)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, link_local_static_route_nh=link_local_static_route_nh)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_route_link_local_static_route_nh_distance_delete(self, rbridge_id=None, link_local_static_route_nh=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type link_local_static_route_nh: link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name
    :param link_local_static_route_nh: Keyword argument tuple.

    :type link_local_static_route_dest: unicode
    :param link_local_static_route_dest: **link_local_static_route_nh** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type link_local_nexthop: unicode
    :param link_local_nexthop: **link_local_static_route_nh** tuple argument:  A:B::C:D ;; Next hop IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type link_local_route_oif_type: unicode
    :param link_local_route_oif_type: **link_local_static_route_nh** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['management',
            've',
            'fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'null']

    :type link_local_route_oif_name: unicode
    :param link_local_route_oif_name: **link_local_static_route_nh** tuple argument.

        * length restriction: ::

            ['1..16']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.route.link_local_static_route_nh', u'link_local_static_route_nh'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.route.link_local_static_route_nh', u'link_local_static_route_nh'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.route.link_local_static_route_nh', u'link_local_static_route_nh')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.route.link_local_static_route_nh.route_attributes', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.route.link_local_static_route_nh.route_attributes', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.route.link_local_static_route_nh.route_attributes', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'distance'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, link_local_static_route_nh=link_local_static_route_nh)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, link_local_static_route_nh=link_local_static_route_nh)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_route_link_local_static_route_nh_metric_delete(self, rbridge_id=None, link_local_static_route_nh=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type link_local_static_route_nh: link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name
    :param link_local_static_route_nh: Keyword argument tuple.

    :type link_local_static_route_dest: unicode
    :param link_local_static_route_dest: **link_local_static_route_nh** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type link_local_nexthop: unicode
    :param link_local_nexthop: **link_local_static_route_nh** tuple argument:  A:B::C:D ;; Next hop IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type link_local_route_oif_type: unicode
    :param link_local_route_oif_type: **link_local_static_route_nh** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['management',
            've',
            'fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'null']

    :type link_local_route_oif_name: unicode
    :param link_local_route_oif_name: **link_local_static_route_nh** tuple argument.

        * length restriction: ::

            ['1..16']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.route.link_local_static_route_nh', u'link_local_static_route_nh'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.route.link_local_static_route_nh', u'link_local_static_route_nh'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.route.link_local_static_route_nh', u'link_local_static_route_nh')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.route.link_local_static_route_nh.route_attributes', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.route.link_local_static_route_nh.route_attributes', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.route.link_local_static_route_nh.route_attributes', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, link_local_static_route_nh=link_local_static_route_nh)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, link_local_static_route_nh=link_local_static_route_nh)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_route_link_local_static_route_nh_tag_delete(self, rbridge_id=None, link_local_static_route_nh=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type link_local_static_route_nh: link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name
    :param link_local_static_route_nh: Keyword argument tuple.

    :type link_local_static_route_dest: unicode
    :param link_local_static_route_dest: **link_local_static_route_nh** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type link_local_nexthop: unicode
    :param link_local_nexthop: **link_local_static_route_nh** tuple argument:  A:B::C:D ;; Next hop IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type link_local_route_oif_type: unicode
    :param link_local_route_oif_type: **link_local_static_route_nh** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['management',
            've',
            'fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'null']

    :type link_local_route_oif_name: unicode
    :param link_local_route_oif_name: **link_local_static_route_nh** tuple argument.

        * length restriction: ::

            ['1..16']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.route.link_local_static_route_nh', u'link_local_static_route_nh'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.route.link_local_static_route_nh', u'link_local_static_route_nh'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.route.link_local_static_route_nh', u'link_local_static_route_nh')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.route.link_local_static_route_nh.route_attributes', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.route.link_local_static_route_nh.route_attributes', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.route.link_local_static_route_nh.route_attributes', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, link_local_static_route_nh=link_local_static_route_nh)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, link_local_static_route_nh=link_local_static_route_nh)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_route_link_local_static_route_nh_vrf_delete(self, rbridge_id=None, link_local_static_route_nh_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type link_local_static_route_nh_vrf: static_route_next_vrf_dest, next_hop_vrf, link_local_next_hop, link_local_route_oif_type, link_local_route_oif_name
    :param link_local_static_route_nh_vrf: Keyword argument tuple.

    :type static_route_next_vrf_dest: unicode
    :param static_route_next_vrf_dest: **link_local_static_route_nh_vrf** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type next_hop_vrf: unicode
    :param next_hop_vrf: **link_local_static_route_nh_vrf** tuple argument:  WORD 1-63;;Next Hop Vrf Name

    :type link_local_next_hop: unicode
    :param link_local_next_hop: **link_local_static_route_nh_vrf** tuple argument:  A:B::C:D ;; Next hop IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type link_local_route_oif_type: unicode
    :param link_local_route_oif_type: **link_local_static_route_nh_vrf** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['management',
            've',
            'fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'null']

    :type link_local_route_oif_name: unicode
    :param link_local_route_oif_name: **link_local_static_route_nh_vrf** tuple argument.

        * length restriction: ::

            ['1..16']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.route.link_local_static_route_nh_vrf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.route.link_local_static_route_nh_vrf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.route.link_local_static_route_nh_vrf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'link_local_static_route_nh_vrf', 'keyval': 'static_route_next_vrf_dest, next_hop_vrf, link_local_next_hop, link_local_route_oif_type, link_local_route_oif_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, link_local_static_route_nh_vrf=link_local_static_route_nh_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, link_local_static_route_nh_vrf=link_local_static_route_nh_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_route_next_hop_delete(self, rbridge_id=None, route=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type route: dest
    :param route: Keyword argument tuple.

    :type dest: unicode
    :param dest: **route** tuple argument:  IPv6Address/prefix.;; Destination IPv6 address-prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.ipv6route.route', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.ipv6route.route', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.ipv6route.route', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.ipv6.ipv6route.route', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'route', 'keyval': 'dest', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'next-hop'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route=route)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route=route)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_route_static_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.route.static', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.route.static', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.route.static', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_route_static_bfd_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.route.static.bfd', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.route.static.bfd', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.route.static.bfd', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_route_static_bfd_bfd_ipv6_link_local_static_route_delete(self, rbridge_id=None, bfd_ipv6_link_local_static_route=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type bfd_ipv6_link_local_static_route: bfd_ipv6_link_local_dest, bfd_ipv6_link_local_src, bfd_interface_type, bfd_interface_name
    :param bfd_ipv6_link_local_static_route: Keyword argument tuple.

    :type bfd_ipv6_link_local_dest: unicode
    :param bfd_ipv6_link_local_dest: **bfd_ipv6_link_local_static_route** tuple argument:  A:B::C:D ;; Destination IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type bfd_ipv6_link_local_src: unicode
    :param bfd_ipv6_link_local_src: **bfd_ipv6_link_local_static_route** tuple argument:  A:B::C:D ;; Source IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type bfd_interface_type: unicode
    :param bfd_interface_type: **bfd_ipv6_link_local_static_route** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ve',
            'fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'null']

    :type bfd_interface_name: unicode
    :param bfd_interface_name: **bfd_ipv6_link_local_static_route** tuple argument.

        * length restriction: ::

            ['1..16']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.route.static.bfd.bfd_ipv6_link_local_static_route', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.route.static.bfd.bfd_ipv6_link_local_static_route', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.route.static.bfd.bfd_ipv6_link_local_static_route', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'bfd_ipv6_link_local_static_route', 'keyval': 'bfd_ipv6_link_local_dest, bfd_ipv6_link_local_src, bfd_interface_type, bfd_interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, bfd_ipv6_link_local_static_route=bfd_ipv6_link_local_static_route)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, bfd_ipv6_link_local_static_route=bfd_ipv6_link_local_static_route)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_route_static_bfd_bfd_ipv6_static_route_delete(self, rbridge_id=None, bfd_ipv6_static_route=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type bfd_ipv6_static_route: bfd_ipv6_static_route_dest, bfd_ipv6_static_route_src
    :param bfd_ipv6_static_route: Keyword argument tuple.

    :type bfd_ipv6_static_route_dest: unicode
    :param bfd_ipv6_static_route_dest: **bfd_ipv6_static_route** tuple argument:  A:B::C:D ;; Destination IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type bfd_ipv6_static_route_src: unicode
    :param bfd_ipv6_static_route_src: **bfd_ipv6_static_route** tuple argument:  A:B::C:D ;; Source IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.route.static.bfd.bfd_ipv6_static_route', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.route.static.bfd.bfd_ipv6_static_route', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.route.static.bfd.bfd_ipv6_static_route', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'bfd_ipv6_static_route', 'keyval': 'bfd_ipv6_static_route_dest, bfd_ipv6_static_route_src', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, bfd_ipv6_static_route=bfd_ipv6_static_route)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, bfd_ipv6_static_route=bfd_ipv6_static_route)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_route_static_bfd_holdover_interval_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.route.static.bfd', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.route.static.bfd', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.route.static.bfd', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'holdover-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_route_static_route_nh_delete(self, rbridge_id=None, static_route_nh=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type static_route_nh: static_route_dest, static_route_next_hop
    :param static_route_nh: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_nh** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type static_route_next_hop: unicode
    :param static_route_next_hop: **static_route_nh** tuple argument:  A:B::C:D ;; Next hop IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.route.static_route_nh', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.route.static_route_nh', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.route.static_route_nh', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'static_route_nh', 'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, static_route_nh=static_route_nh)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, static_route_nh=static_route_nh)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_route_static_route_nh_distance_delete(self, rbridge_id=None, static_route_nh=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type static_route_nh: static_route_dest, static_route_next_hop
    :param static_route_nh: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_nh** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type static_route_next_hop: unicode
    :param static_route_next_hop: **static_route_nh** tuple argument:  A:B::C:D ;; Next hop IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.route.static_route_nh', u'static_route_nh'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.route.static_route_nh', u'static_route_nh'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.route.static_route_nh', u'static_route_nh')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.route.static_route_nh.route_attributes', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.route.static_route_nh.route_attributes', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.route.static_route_nh.route_attributes', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'distance'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, static_route_nh=static_route_nh)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, static_route_nh=static_route_nh)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_route_static_route_nh_metric_delete(self, rbridge_id=None, static_route_nh=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type static_route_nh: static_route_dest, static_route_next_hop
    :param static_route_nh: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_nh** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type static_route_next_hop: unicode
    :param static_route_next_hop: **static_route_nh** tuple argument:  A:B::C:D ;; Next hop IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.route.static_route_nh', u'static_route_nh'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.route.static_route_nh', u'static_route_nh'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.route.static_route_nh', u'static_route_nh')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.route.static_route_nh.route_attributes', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.route.static_route_nh.route_attributes', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.route.static_route_nh.route_attributes', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, static_route_nh=static_route_nh)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, static_route_nh=static_route_nh)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_route_static_route_nh_tag_delete(self, rbridge_id=None, static_route_nh=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type static_route_nh: static_route_dest, static_route_next_hop
    :param static_route_nh: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_nh** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type static_route_next_hop: unicode
    :param static_route_next_hop: **static_route_nh** tuple argument:  A:B::C:D ;; Next hop IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.route.static_route_nh', u'static_route_nh'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.route.static_route_nh', u'static_route_nh'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.route.static_route_nh', u'static_route_nh')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.route.static_route_nh.route_attributes', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.route.static_route_nh.route_attributes', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.route.static_route_nh.route_attributes', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, static_route_nh=static_route_nh)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, static_route_nh=static_route_nh)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_route_static_route_nh_vrf_delete(self, rbridge_id=None, static_route_nh_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type static_route_nh_vrf: static_route_next_vrf_dest, next_hop_vrf, static_route_next_hop
    :param static_route_nh_vrf: Keyword argument tuple.

    :type static_route_next_vrf_dest: unicode
    :param static_route_next_vrf_dest: **static_route_nh_vrf** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type next_hop_vrf: unicode
    :param next_hop_vrf: **static_route_nh_vrf** tuple argument:  Next Hop Vrf Name

    :type static_route_next_hop: unicode
    :param static_route_next_hop: **static_route_nh_vrf** tuple argument:  A:B::C:D ;; Next hop IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.route.static_route_nh_vrf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.route.static_route_nh_vrf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.route.static_route_nh_vrf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'static_route_nh_vrf', 'keyval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_next_hop', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, static_route_nh_vrf=static_route_nh_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, static_route_nh_vrf=static_route_nh_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_route_static_route_oif_delete(self, rbridge_id=None, static_route_oif=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type static_route_oif: static_route_dest, static_route_oif_type, static_route_oif_name
    :param static_route_oif: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_oif** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type static_route_oif_type: unicode
    :param static_route_oif_type: **static_route_oif** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ve',
            'fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'null']

    :type static_route_oif_name: unicode
    :param static_route_oif_name: **static_route_oif** tuple argument.

        * length restriction: ::

            ['1..16']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.route.static_route_oif', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.route.static_route_oif', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.route.static_route_oif', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'static_route_oif', 'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, static_route_oif=static_route_oif)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, static_route_oif=static_route_oif)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_route_static_route_oif_distance_delete(self, rbridge_id=None, static_route_oif=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type static_route_oif: static_route_dest, static_route_oif_type, static_route_oif_name
    :param static_route_oif: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_oif** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type static_route_oif_type: unicode
    :param static_route_oif_type: **static_route_oif** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ve',
            'fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'null']

    :type static_route_oif_name: unicode
    :param static_route_oif_name: **static_route_oif** tuple argument.

        * length restriction: ::

            ['1..16']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.route.static_route_oif', u'static_route_oif'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.route.static_route_oif', u'static_route_oif'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.route.static_route_oif', u'static_route_oif')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.route.static_route_oif.route_attributes', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.route.static_route_oif.route_attributes', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.route.static_route_oif.route_attributes', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'distance'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, static_route_oif=static_route_oif)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, static_route_oif=static_route_oif)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_route_static_route_oif_metric_delete(self, rbridge_id=None, static_route_oif=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type static_route_oif: static_route_dest, static_route_oif_type, static_route_oif_name
    :param static_route_oif: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_oif** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type static_route_oif_type: unicode
    :param static_route_oif_type: **static_route_oif** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ve',
            'fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'null']

    :type static_route_oif_name: unicode
    :param static_route_oif_name: **static_route_oif** tuple argument.

        * length restriction: ::

            ['1..16']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.route.static_route_oif', u'static_route_oif'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.route.static_route_oif', u'static_route_oif'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.route.static_route_oif', u'static_route_oif')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.route.static_route_oif.route_attributes', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.route.static_route_oif.route_attributes', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.route.static_route_oif.route_attributes', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, static_route_oif=static_route_oif)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, static_route_oif=static_route_oif)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_route_static_route_oif_tag_delete(self, rbridge_id=None, static_route_oif=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type static_route_oif: static_route_dest, static_route_oif_type, static_route_oif_name
    :param static_route_oif: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_oif** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type static_route_oif_type: unicode
    :param static_route_oif_type: **static_route_oif** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ve',
            'fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'null']

    :type static_route_oif_name: unicode
    :param static_route_oif_name: **static_route_oif** tuple argument.

        * length restriction: ::

            ['1..16']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.route.static_route_oif', u'static_route_oif'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.route.static_route_oif', u'static_route_oif'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.route.static_route_oif', u'static_route_oif')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.route.static_route_oif.route_attributes', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.route.static_route_oif.route_attributes', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.route.static_route_oif.route_attributes', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, static_route_oif=static_route_oif)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, static_route_oif=static_route_oif)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ospf', 'keyval': 'vrf', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_area_delete(self, rbridge_id=None, ospf=None, area=None, normal=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    **Instance Argument(s)**:

    :type normal: YANGBool
    :param normal: Keyword argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.area', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.area', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.area', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'area', 'keyval': 'area_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area, normal=normal)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area, normal=normal)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_area_authentication_ah_delete(self, rbridge_id=None, ospf=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.area.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.area.authentication.ipsec_auth_key_config', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.area.authentication.ipsec_auth_key_config', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ah'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_area_authentication_esp_delete(self, rbridge_id=None, ospf=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.area.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.area.authentication.ipsec_auth_key_config', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.area.authentication.ipsec_auth_key_config', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'esp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_area_authentication_esp_auth_delete(self, rbridge_id=None, ospf=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.area.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.area.authentication.ipsec_auth_key_config', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.area.authentication.ipsec_auth_key_config', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'esp-auth'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_area_authentication_esp_key_delete(self, rbridge_id=None, ospf=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.area.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.area.authentication.ipsec_auth_key_config', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.area.authentication.ipsec_auth_key_config', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'esp-key'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_area_authentication_esp_no_encrypt_delete(self, rbridge_id=None, ospf=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.area.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.area.authentication.ipsec_auth_key_config', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.area.authentication.ipsec_auth_key_config', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'esp-no-encrypt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_area_authentication_key_delete(self, rbridge_id=None, ospf=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.area.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.area.authentication.ipsec_auth_key_config', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.area.authentication.ipsec_auth_key_config', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'key'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_area_authentication_no_encrypt_delete(self, rbridge_id=None, ospf=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.area.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.area.authentication.ipsec_auth_key_config', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.area.authentication.ipsec_auth_key_config', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'no-encrypt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_area_authentication_spi_delete(self, rbridge_id=None, ospf=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.area.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.area.authentication.ipsec_auth_key_config', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.area.authentication.ipsec_auth_key_config', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'spi'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_area_normal_delete(self, rbridge_id=None, ospf=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.area', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.area', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.area', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'area', 'keyval': 'area_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'normal'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_area_nssa_default_information_originate_delete(self, rbridge_id=None, ospf=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.area.nssa.area_default_information_originate', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.area.nssa.area_default_information_originate', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.area.nssa.area_default_information_originate', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'area_default_information_originate_metric, area_default_information_originate_metric_type'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_area_nssa_default_information_originate_metric_delete(self, rbridge_id=None, ospf=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.area.nssa.area_default_information_originate', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.area.nssa.area_default_information_originate', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.area.nssa.area_default_information_originate', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_area_nssa_default_information_originate_metric_type_delete(self, rbridge_id=None, ospf=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.area.nssa.area_default_information_originate', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.area.nssa.area_default_information_originate', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.area.nssa.area_default_information_originate', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_area_nssa_metric_delete(self, rbridge_id=None, ospf=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.area.nssa.metric', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.area.nssa.metric', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.area.nssa.metric', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_area_nssa_no_redistribution_delete(self, rbridge_id=None, ospf=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.area.nssa', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.area.nssa', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.area.nssa', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'no-redistribution'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_area_nssa_no_summary_delete(self, rbridge_id=None, ospf=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.area.nssa', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.area.nssa', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.area.nssa', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'no-summary'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_area_nssa_nssa_area_metric_delete(self, rbridge_id=None, ospf=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.area.nssa.metric', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.area.nssa.metric', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.area.nssa.metric', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'nssa-area-metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_area_nssa_translator_always_delete(self, rbridge_id=None, ospf=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.area.nssa', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.area.nssa', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.area.nssa', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'translator-always'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_area_nssa_translator_interval_delete(self, rbridge_id=None, ospf=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.area.nssa', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.area.nssa', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.area.nssa', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'translator-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_area_range_delete(self, rbridge_id=None, ospf=None, area=None, area_range=None, range_effect=None, range_cost=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    **Instance Keyword Argument Tuple**:

    :type area_range: range_address, range_effect, range_cost
    :param area_range: Keyword argument tuple.

    :type range_address: unicode
    :param range_address: **area_range** tuple argument:  A:B::C:D/LEN;; IPv6 address to match

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type range_effect: unicode
    :param range_effect: **area_range** tuple argument:  Advertise/Do not advertise this type-3 summarization

        * enumeration restriction: ::

            ['advertise', 'not-advertise']

    :type range_cost: long
    :param range_cost: **area_range** tuple argument:  Configure area range cost

        * range restriction: ::

            ['0..4294967295']

    **Instance Argument(s)**:

    :type range_effect: unicode
    :param range_effect: Advertise/Do not advertise this type-3 summarization

        * enumeration restriction: ::

            ['advertise', 'not-advertise']

    :type range_cost: long
    :param range_cost: Configure area range cost

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.area.area_range', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.area.area_range', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.area.area_range', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'area_range', 'keyval': 'range_address', 'extra_keyval': 'range_address, range_effect, range_cost'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area, area_range=area_range, range_effect=range_effect, range_cost=range_cost)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area, area_range=area_range, range_effect=range_effect, range_cost=range_cost)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_area_range_cost_delete(self, rbridge_id=None, ospf=None, area=None, area_range=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    **Instance Keyword Argument Tuple**:

    :type area_range: range_address
    :param area_range: Keyword argument tuple.

    :type range_address: unicode
    :param range_address: **area_range** tuple argument:  A:B::C:D/LEN;; IPv6 address to match

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.area.area_range', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.area.area_range', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.area.area_range', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'area_range', 'keyval': 'range_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cost'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area, area_range=area_range)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area, area_range=area_range)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_area_range_range_effect_delete(self, rbridge_id=None, ospf=None, area=None, area_range=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    **Instance Keyword Argument Tuple**:

    :type area_range: range_address
    :param area_range: Keyword argument tuple.

    :type range_address: unicode
    :param range_address: **area_range** tuple argument:  A:B::C:D/LEN;; IPv6 address to match

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.area.area_range', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.area.area_range', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.area.area_range', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'area_range', 'keyval': 'range_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'range-effect'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area, area_range=area_range)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area, area_range=area_range)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_area_stub_no_summary_delete(self, rbridge_id=None, ospf=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.area.stub', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.area.stub', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.area.stub', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'no-summary'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_area_stub_stub_area_metric_delete(self, rbridge_id=None, ospf=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.area.stub', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.area.stub', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.area.stub', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'stub-area-metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_area_virtual_link_delete(self, rbridge_id=None, ospf=None, area=None, virtual_link=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    **Instance Keyword Argument Tuple**:

    :type virtual_link: virtual_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virtual_link_neighbor: unicode
    :param virtual_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.area.virtual_link', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.area.virtual_link', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.area.virtual_link', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'virtual_link', 'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_area_virtual_link_authentication_ah_delete(self, rbridge_id=None, ospf=None, area=None, virtual_link=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virtual_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virtual_link_neighbor: unicode
    :param virtual_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.area.virtual_link.link_properties.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.area.virtual_link.link_properties.authentication.ipsec_auth_key_config', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.area.virtual_link.link_properties.authentication.ipsec_auth_key_config', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ah'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_area_virtual_link_authentication_esp_delete(self, rbridge_id=None, ospf=None, area=None, virtual_link=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virtual_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virtual_link_neighbor: unicode
    :param virtual_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.area.virtual_link.link_properties.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.area.virtual_link.link_properties.authentication.ipsec_auth_key_config', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.area.virtual_link.link_properties.authentication.ipsec_auth_key_config', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'esp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_area_virtual_link_authentication_esp_auth_delete(self, rbridge_id=None, ospf=None, area=None, virtual_link=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virtual_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virtual_link_neighbor: unicode
    :param virtual_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.area.virtual_link.link_properties.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.area.virtual_link.link_properties.authentication.ipsec_auth_key_config', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.area.virtual_link.link_properties.authentication.ipsec_auth_key_config', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'esp-auth'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_area_virtual_link_authentication_esp_key_delete(self, rbridge_id=None, ospf=None, area=None, virtual_link=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virtual_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virtual_link_neighbor: unicode
    :param virtual_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.area.virtual_link.link_properties.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.area.virtual_link.link_properties.authentication.ipsec_auth_key_config', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.area.virtual_link.link_properties.authentication.ipsec_auth_key_config', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'esp-key'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_area_virtual_link_authentication_esp_no_encrypt_delete(self, rbridge_id=None, ospf=None, area=None, virtual_link=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virtual_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virtual_link_neighbor: unicode
    :param virtual_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.area.virtual_link.link_properties.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.area.virtual_link.link_properties.authentication.ipsec_auth_key_config', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.area.virtual_link.link_properties.authentication.ipsec_auth_key_config', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'esp-no-encrypt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_area_virtual_link_authentication_key_delete(self, rbridge_id=None, ospf=None, area=None, virtual_link=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virtual_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virtual_link_neighbor: unicode
    :param virtual_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.area.virtual_link.link_properties.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.area.virtual_link.link_properties.authentication.ipsec_auth_key_config', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.area.virtual_link.link_properties.authentication.ipsec_auth_key_config', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'key'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_area_virtual_link_authentication_no_encrypt_delete(self, rbridge_id=None, ospf=None, area=None, virtual_link=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virtual_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virtual_link_neighbor: unicode
    :param virtual_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.area.virtual_link.link_properties.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.area.virtual_link.link_properties.authentication.ipsec_auth_key_config', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.area.virtual_link.link_properties.authentication.ipsec_auth_key_config', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'no-encrypt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_area_virtual_link_authentication_spi_delete(self, rbridge_id=None, ospf=None, area=None, virtual_link=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virtual_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virtual_link_neighbor: unicode
    :param virtual_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.area.virtual_link.link_properties.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.area.virtual_link.link_properties.authentication.ipsec_auth_key_config', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.area.virtual_link.link_properties.authentication.ipsec_auth_key_config', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'spi'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_area_virtual_link_dead_interval_delete(self, rbridge_id=None, ospf=None, area=None, virtual_link=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virtual_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virtual_link_neighbor: unicode
    :param virtual_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.area.virtual_link.link_properties.link_interval_properties', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.area.virtual_link.link_properties.link_interval_properties', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.area.virtual_link.link_properties.link_interval_properties', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dead-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_area_virtual_link_hello_interval_delete(self, rbridge_id=None, ospf=None, area=None, virtual_link=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virtual_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virtual_link_neighbor: unicode
    :param virtual_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.area.virtual_link.link_properties.link_interval_properties', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.area.virtual_link.link_properties.link_interval_properties', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.area.virtual_link.link_properties.link_interval_properties', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hello-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_area_virtual_link_hello_jitter_delete(self, rbridge_id=None, ospf=None, area=None, virtual_link=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virtual_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virtual_link_neighbor: unicode
    :param virtual_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.area.virtual_link.link_properties.link_interval_properties', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.area.virtual_link.link_properties.link_interval_properties', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.area.virtual_link.link_properties.link_interval_properties', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hello-jitter'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_area_virtual_link_link_interval_properties_delete(self, rbridge_id=None, ospf=None, area=None, virtual_link=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virtual_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virtual_link_neighbor: unicode
    :param virtual_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.area.virtual_link.link_properties.link_interval_properties', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.area.virtual_link.link_properties.link_interval_properties', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.area.virtual_link.link_properties.link_interval_properties', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_area_virtual_link_retransmit_interval_delete(self, rbridge_id=None, ospf=None, area=None, virtual_link=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virtual_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virtual_link_neighbor: unicode
    :param virtual_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.area.virtual_link.link_properties.link_interval_properties', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.area.virtual_link.link_properties.link_interval_properties', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.area.virtual_link.link_properties.link_interval_properties', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'retransmit-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_area_virtual_link_transmit_delay_delete(self, rbridge_id=None, ospf=None, area=None, virtual_link=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virtual_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virtual_link_neighbor: unicode
    :param virtual_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.area.virtual_link.link_properties.link_interval_properties', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.area.virtual_link.link_properties.link_interval_properties', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.area.virtual_link.link_properties.link_interval_properties', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'transmit-delay'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_auto_cost_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.auto_cost', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.auto_cost', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.auto_cost', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_auto_cost_reference_bandwidth_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.auto_cost', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.auto_cost', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.auto_cost', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'reference-bandwidth'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_bfd_bfd_enable_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.bfd', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.bfd', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.bfd', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bfd-enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_bfd_holdover_interval_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.bfd', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.bfd', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.bfd', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'holdover-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_database_overflow_interval_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ospf', 'keyval': 'vrf', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'database-overflow-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_default_information_originate_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.global_default_information_originate', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.global_default_information_originate', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.global_default_information_originate', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'global_default_information_originate_always, global_default_information_originate_metric, global_default_information_originate_metric_type'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_default_information_originate_always_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.global_default_information_originate', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.global_default_information_originate', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.global_default_information_originate', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'always'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_default_information_originate_metric_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.global_default_information_originate', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.global_default_information_originate', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.global_default_information_originate', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_default_information_originate_metric_type_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.global_default_information_originate', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.global_default_information_originate', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.global_default_information_originate', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_default_metric_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ospf', 'keyval': 'vrf', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'default-metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_default_passive_interface_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ospf', 'keyval': 'vrf', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'default-passive-interface'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_distance_delete(self, rbridge_id=None, ospf=None, distance=None, distance_value=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type distance: route_type
    :param distance: Keyword argument tuple.

    :type route_type: unicode
    :param route_type: **distance** tuple argument:  The type of route propagation

        * enumeration restriction: ::

            ['intra-area', 'external', 'inter-area']

    **Instance Argument(s)**:

    :type distance_value: long
    :param distance_value: The distance for a given type of route

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.distance', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.distance', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.distance', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'distance', 'keyval': 'route_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, distance=distance, distance_value=distance_value)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, distance=distance, distance_value=distance_value)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_distance_distance_value_delete(self, rbridge_id=None, ospf=None, distance=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type distance: route_type
    :param distance: Keyword argument tuple.

    :type route_type: unicode
    :param route_type: **distance** tuple argument:  The type of route propagation

        * enumeration restriction: ::

            ['intra-area', 'external', 'inter-area']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.distance', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.distance', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.distance', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'distance', 'keyval': 'route_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'distance-value'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, distance=distance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, distance=distance)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_distribute_list_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.distribute_list', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.distribute_list', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.distribute_list', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_distribute_list_prefix_list_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.distribute_list.prefix_list', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.distribute_list.prefix_list', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.distribute_list.prefix_list', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'distribute_list_prefix_list_name, distribute_list_prefix_list_in'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_distribute_list_prefix_list_distribute_list_prefix_list_name_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.distribute_list.prefix_list', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.distribute_list.prefix_list', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.distribute_list.prefix_list', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'distribute-list-prefix-list-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_distribute_list_prefix_list_in_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.distribute_list.prefix_list', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.distribute_list.prefix_list', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.distribute_list.prefix_list', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'in'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_distribute_list_route_map_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.distribute_list.route_map', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.distribute_list.route_map', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.distribute_list.route_map', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'distribute_list_route_map_name, distribute_list_route_map_in'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_distribute_list_route_map_distribute_list_route_map_name_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.distribute_list.route_map', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.distribute_list.route_map', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.distribute_list.route_map', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'distribute-list-route-map-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_distribute_list_route_map_in_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.distribute_list.route_map', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.distribute_list.route_map', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.distribute_list.route_map', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'in'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_external_lsdb_limit_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ospf', 'keyval': 'vrf', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'external-lsdb-limit'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_graceful_restart_helper_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.graceful_restart.helper', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.graceful_restart.helper', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.graceful_restart.helper', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_graceful_restart_helper_disable_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.graceful_restart.helper', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.graceful_restart.helper', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.graceful_restart.helper', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'disable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_graceful_restart_helper_strict_lsa_checking_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.graceful_restart.helper', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.graceful_restart.helper', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.graceful_restart.helper', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'strict-lsa-checking'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_key_add_remove_interval_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ospf', 'keyval': 'vrf', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'key-add-remove-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_key_rollover_interval_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ospf', 'keyval': 'vrf', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'key-rollover-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_log_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.log', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.log', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.log', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_log_adjacency_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.log.log_adjacency', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.log.log_adjacency', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.log.log_adjacency', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_log_adjacency_dr_only_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.log.log_adjacency', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.log.log_adjacency', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.log.log_adjacency', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dr-only'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_log_all_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.log', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.log', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.log', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'all'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_log_bad_packet_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.log.log_bad_packet', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.log.log_bad_packet', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.log.log_bad_packet', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_log_bad_packet_checksum_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.log.log_bad_packet', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.log.log_bad_packet', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.log.log_bad_packet', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'checksum'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_log_database_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.log', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.log', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.log', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'database'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_log_retransmit_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.log', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.log', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.log', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'retransmit'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_log_status_change_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ospf', 'keyval': 'vrf', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'log-status-change'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_max_metric_router_lsa_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.max_metric.router_lsa', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.max_metric.router_lsa', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.max_metric.router_lsa', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_max_metric_router_lsa_all_lsas_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.max_metric.router_lsa', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.max_metric.router_lsa', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.max_metric.router_lsa', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'all-lsas'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_max_metric_router_lsa_external_lsa_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.max_metric.router_lsa.external_lsa', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.max_metric.router_lsa.external_lsa', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.max_metric.router_lsa.external_lsa', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_max_metric_router_lsa_external_lsa_external_lsa_value_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.max_metric.router_lsa.external_lsa', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.max_metric.router_lsa.external_lsa', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.max_metric.router_lsa.external_lsa', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'external-lsa-value'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_max_metric_router_lsa_include_stub_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.max_metric.router_lsa', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.max_metric.router_lsa', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.max_metric.router_lsa', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'include-stub'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_max_metric_router_lsa_on_startup_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.max_metric.router_lsa.on_startup', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.max_metric.router_lsa.on_startup', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.max_metric.router_lsa.on_startup', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_max_metric_router_lsa_on_startup_on_startup_time_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.max_metric.router_lsa.on_startup', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.max_metric.router_lsa.on_startup', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.max_metric.router_lsa.on_startup', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'on-startup-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_max_metric_router_lsa_on_startup_wait_for_bgp_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.max_metric.router_lsa.on_startup', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.max_metric.router_lsa.on_startup', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.max_metric.router_lsa.on_startup', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'wait-for-bgp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_max_metric_router_lsa_summary_lsa_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.max_metric.router_lsa.summary_lsa', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.max_metric.router_lsa.summary_lsa', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.max_metric.router_lsa.summary_lsa', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_max_metric_router_lsa_summary_lsa_summary_lsa_value_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.max_metric.router_lsa.summary_lsa', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.max_metric.router_lsa.summary_lsa', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.max_metric.router_lsa.summary_lsa', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'summary-lsa-value'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_maximum_paths_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ospf', 'keyval': 'vrf', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'maximum-paths'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_metric_type_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ospf', 'keyval': 'vrf', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_nonstop_routing_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ospf', 'keyval': 'vrf', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'nonstop-routing'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_redistribute_bgp_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.redistribute.redistribute_bgp', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.redistribute.redistribute_bgp', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.redistribute.redistribute_bgp', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_redistribute_bgp_metric_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.redistribute.redistribute_bgp', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.redistribute.redistribute_bgp', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.redistribute.redistribute_bgp', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_redistribute_bgp_metric_type_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.redistribute.redistribute_bgp', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.redistribute.redistribute_bgp', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.redistribute.redistribute_bgp', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_redistribute_bgp_route_map_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.redistribute.redistribute_bgp', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.redistribute.redistribute_bgp', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.redistribute.redistribute_bgp', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_redistribute_connected_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.redistribute.redistribute_connected', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.redistribute.redistribute_connected', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.redistribute.redistribute_connected', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_redistribute_connected_metric_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.redistribute.redistribute_connected', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.redistribute.redistribute_connected', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.redistribute.redistribute_connected', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_redistribute_connected_metric_type_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.redistribute.redistribute_connected', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.redistribute.redistribute_connected', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.redistribute.redistribute_connected', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_redistribute_connected_route_map_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.redistribute.redistribute_connected', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.redistribute.redistribute_connected', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.redistribute.redistribute_connected', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_redistribute_ospf_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.redistribute.redistribute_ospf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.redistribute.redistribute_ospf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.redistribute.redistribute_ospf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_redistribute_ospf_metric_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.redistribute.redistribute_ospf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.redistribute.redistribute_ospf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.redistribute.redistribute_ospf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_redistribute_ospf_metric_type_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.redistribute.redistribute_ospf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.redistribute.redistribute_ospf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.redistribute.redistribute_ospf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_redistribute_ospf_route_map_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.redistribute.redistribute_ospf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.redistribute.redistribute_ospf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.redistribute.redistribute_ospf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_redistribute_static_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.redistribute.redistribute_static', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.redistribute.redistribute_static', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.redistribute.redistribute_static', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_redistribute_static_metric_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.redistribute.redistribute_static', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.redistribute.redistribute_static', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.redistribute.redistribute_static', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_redistribute_static_metric_type_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.redistribute.redistribute_static', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.redistribute.redistribute_static', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.redistribute.redistribute_static', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_redistribute_static_route_map_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.redistribute.redistribute_static', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.redistribute.redistribute_static', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.redistribute.redistribute_static', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_summary_address_delete(self, rbridge_id=None, ospf=None, summary_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type summary_address: summary_address_value
    :param summary_address: Keyword argument tuple.

    :type summary_address_value: unicode
    :param summary_address_value: **summary_address** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.summary_address', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.summary_address', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.summary_address', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'summary_address', 'keyval': 'summary_address_value', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, summary_address=summary_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, summary_address=summary_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_timers_lsa_group_pacing_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.timers', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.timers', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.timers', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lsa-group-pacing'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_timers_spf_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.timers.spf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.timers.spf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.timers.spf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'spf_delay, spf_hold_time'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_timers_spf_spf_delay_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.timers.spf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.timers.spf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.timers.spf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'spf-delay'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_timers_spf_spf_hold_time_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ipv6.router.ospf.timers.spf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ipv6.router.ospf.timers.spf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.router.ospf.timers.spf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'spf-hold-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ipv6_static_ag_ipv6_config_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.ipv6.static_ag_ipv6_config', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ipv6.static_ag_ipv6_config', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_linecard_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.global_lc_holder.linecard', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.global_lc_holder.linecard', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.global_lc_holder.linecard', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_linecard_linecards_delete(self, rbridge_id=None, linecards=None, linecardType=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type linecards: linecardName, linecardType
    :param linecards: Keyword argument tuple.

    :type linecardName: unicode
    :param linecardName: **linecards** tuple argument.

        * pattern restriction: ::

            '([1-9]|[1][0-6])'

    :type linecardType: unicode
    :param linecardType: **linecards** tuple argument.

        * enumeration restriction: ::

            ['LC27X40G',
            'LC48X10G',
            'LC6X100G',
            'LC48X10GT',
            'LC12X40G',
            'LC48X1G']

    **Instance Argument(s)**:

    :type linecardType: unicode
    :param linecardType: Keyword argument.

        * enumeration restriction: ::

            ['LC27X40G',
            'LC48X10G',
            'LC6X100G',
            'LC48X10GT',
            'LC12X40G',
            'LC48X1G']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.global_lc_holder.linecard.linecards', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.global_lc_holder.linecard.linecards', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.global_lc_holder.linecard.linecards', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'linecards', 'keyval': 'linecardName', 'extra_keyval': 'linecardName, linecardType'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, linecards=linecards, linecardType=linecardType)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, linecards=linecards, linecardType=linecardType)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_linecard_linecards_linecardtype_delete(self, rbridge_id=None, linecards=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type linecards: linecardName
    :param linecards: Keyword argument tuple.

    :type linecardName: unicode
    :param linecardName: **linecards** tuple argument.

        * pattern restriction: ::

            '([1-9]|[1][0-6])'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.global_lc_holder.linecard.linecards', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.global_lc_holder.linecard.linecards', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.global_lc_holder.linecard.linecards', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'linecards', 'keyval': 'linecardName', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'linecardType'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, linecards=linecards)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, linecards=linecards)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_logical_chassis_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.logical_chassis', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.logical_chassis', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.logical_chassis', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.logical_chassis', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_logical_chassis_principal_priority_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.logical_chassis', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.logical_chassis', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.logical_chassis', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.logical_chassis', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'principal-priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_maps_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.maps', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.maps', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.maps', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.maps', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_maps_email_email_list_delete(self, rbridge_id=None, email_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type email_list: email
    :param email_list: Keyword argument tuple.

    :type email: unicode
    :param email: **email_list** tuple argument:  <email:string>  e-mail address for MAPS alerts

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.maps.email.email_list', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.maps.email.email_list', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.maps.email.email_list', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.maps.email.email_list', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'email_list', 'keyval': 'email', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, email_list=email_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, email_list=email_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_maps_enable_actions_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.maps.enable', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.maps.enable', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.maps.enable', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.maps.enable', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'actions'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_maps_enable_policy_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.maps.enable', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.maps.enable', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.maps.enable', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.maps.enable', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'policy'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_maps_group_delete(self, rbridge_id=None, logicalgroup=None, elementtype=None, members=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type logicalgroup: logicalgroupname, elementtype, members
    :param logicalgroup: Keyword argument tuple.

    :type logicalgroupname: unicode
    :param logicalgroupname: **logicalgroup** tuple argument:  Configure group name

    :type elementtype: unicode
    :param elementtype: **logicalgroup** tuple argument.

        * enumeration restriction: ::

            ['interface', 'sfp']

    :type members: unicode
    :param members: **logicalgroup** tuple argument:  Configure memberlist

        * length restriction: ::

            ['1..253']

        * pattern restriction: ::

            '(((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?'
            '(([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]['
            '0-9]))((-([1-9]|[1-9][0-9]|[1-9][0-9][0-9]))?)(('
            '(,([1-9]|[1-9][0-9]|[1-9][0-9][0-9])(-([1-9]|[1-'
            '9][0-9]|[1-9][0-9][0-9]))?){1})+|((([1-9]|[1-9]['
            '0-9]|1[0-9][0-9]|2[0-3][0-9])/)?(([0-9]|[1][0-6]'
            '))/([1-9]|[1-9][0-9]|[1-9][0-9][0-9]))(-([1-9]|['
            '1-9][0-9]|[1-9][0-9][0-9])){1}|((([1-9]|[1-9][0-'
            '9]|1[0-9][0-9]|2[0-3][0-9])/)?(([0-9]|[1][0-6]))'
            '/([1-9]|[1-9][0-9]|[1-9][0-9][0-9])(:((([1-4])(-'
            '([1-4]))?)(((,([1-4])(-([1-4]))?){1})+)|([1-4])('
            '-([1-4]))))))*)(,(((([1-9]|[1-9][0-9]|1[0-9][0-9'
            ']|2[0-3][0-9])/)?(([0-9]|[1][0-6]))/([1-9]|[1-9]'
            '[0-9]|[1-9][0-9][0-9]))((-([1-9]|[1-9][0-9]|[1-9'
            '][0-9][0-9]))?)(((,([1-9]|[1-9][0-9]|[1-9][0-9]['
            '0-9])(-([1-9]|[1-9][0-9]|[1-9][0-9][0-9]))?){1})'
            '+|((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)'
            '?(([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9]))(-([1-9]|[1-9][0-9]|[1-9][0-9][0-9])){1}|'
            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:((([1-4])(-([1-4]))?)(((,([1-4])(-([1-4]))'
            '?){1})+)|([1-4])(-([1-4]))))))*))*'

    **Instance Argument(s)**:

    :type elementtype: unicode
    :param elementtype: Keyword argument.

        * enumeration restriction: ::

            ['interface', 'sfp']

    :type members: unicode
    :param members: Configure memberlist

        * length restriction: ::

            ['1..253']

        * pattern restriction: ::

            '(((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?'
            '(([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]['
            '0-9]))((-([1-9]|[1-9][0-9]|[1-9][0-9][0-9]))?)(('
            '(,([1-9]|[1-9][0-9]|[1-9][0-9][0-9])(-([1-9]|[1-'
            '9][0-9]|[1-9][0-9][0-9]))?){1})+|((([1-9]|[1-9]['
            '0-9]|1[0-9][0-9]|2[0-3][0-9])/)?(([0-9]|[1][0-6]'
            '))/([1-9]|[1-9][0-9]|[1-9][0-9][0-9]))(-([1-9]|['
            '1-9][0-9]|[1-9][0-9][0-9])){1}|((([1-9]|[1-9][0-'
            '9]|1[0-9][0-9]|2[0-3][0-9])/)?(([0-9]|[1][0-6]))'
            '/([1-9]|[1-9][0-9]|[1-9][0-9][0-9])(:((([1-4])(-'
            '([1-4]))?)(((,([1-4])(-([1-4]))?){1})+)|([1-4])('
            '-([1-4]))))))*)(,(((([1-9]|[1-9][0-9]|1[0-9][0-9'
            ']|2[0-3][0-9])/)?(([0-9]|[1][0-6]))/([1-9]|[1-9]'
            '[0-9]|[1-9][0-9][0-9]))((-([1-9]|[1-9][0-9]|[1-9'
            '][0-9][0-9]))?)(((,([1-9]|[1-9][0-9]|[1-9][0-9]['
            '0-9])(-([1-9]|[1-9][0-9]|[1-9][0-9][0-9]))?){1})'
            '+|((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)'
            '?(([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9]))(-([1-9]|[1-9][0-9]|[1-9][0-9][0-9])){1}|'
            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:((([1-4])(-([1-4]))?)(((,([1-4])(-([1-4]))'
            '?){1})+)|([1-4])(-([1-4]))))))*))*'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.maps.logicalgroup', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.maps.logicalgroup', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'logicalgroup', 'keyval': 'logicalgroupname', 'extra_keyval': 'logicalgroupname, elementtype, members'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, logicalgroup=logicalgroup, elementtype=elementtype, members=members)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, logicalgroup=logicalgroup, elementtype=elementtype, members=members)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_maps_group_members_delete(self, rbridge_id=None, logicalgroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type logicalgroup: logicalgroupname
    :param logicalgroup: Keyword argument tuple.

    :type logicalgroupname: unicode
    :param logicalgroupname: **logicalgroup** tuple argument:  Configure group name

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.maps.logicalgroup', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.maps.logicalgroup', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'logicalgroup', 'keyval': 'logicalgroupname', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'members'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, logicalgroup=logicalgroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, logicalgroup=logicalgroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_maps_group_type_delete(self, rbridge_id=None, logicalgroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type logicalgroup: logicalgroupname
    :param logicalgroup: Keyword argument tuple.

    :type logicalgroupname: unicode
    :param logicalgroupname: **logicalgroup** tuple argument:  Configure group name

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.maps.logicalgroup', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.maps.logicalgroup', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'logicalgroup', 'keyval': 'logicalgroupname', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, logicalgroup=logicalgroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, logicalgroup=logicalgroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_maps_policy_delete(self, rbridge_id=None, policy=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type policy: policyname
    :param policy: Keyword argument tuple.

    :type policyname: unicode
    :param policyname: **policy** tuple argument:  Configure policy name

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.maps.policy', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.maps.policy', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'policy', 'keyval': 'policyname', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, policy=policy)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, policy=policy)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_maps_policy_rule_delete(self, rbridge_id=None, policy=None, ruleaction=None, policyaction=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type policy: policyname
    :param policy: Keyword argument tuple.

    :type policyname: unicode
    :param policyname: **policy** tuple argument:  Configure policy name

    **Instance Keyword Argument Tuple**:

    :type ruleaction: policyrule, policyaction
    :param ruleaction: Keyword argument tuple.

    :type policyrule: unicode
    :param policyrule: **ruleaction** tuple argument:  rule name

    :type policyaction: unicode
    :param policyaction: **ruleaction** tuple argument:  rule actions

        * enumeration restriction: ::

            ['NONE',
            'SNMP',
            'RASLOG',
            'SW_CRITICAL',
            'SFP_MARGINAL',
            'EMAIL',
            'SW_MARGINAL']

    **Instance Argument(s)**:

    :type policyaction: unicode
    :param policyaction: rule actions

        * enumeration restriction: ::

            ['NONE',
            'SNMP',
            'RASLOG',
            'SW_CRITICAL',
            'SFP_MARGINAL',
            'EMAIL',
            'SW_MARGINAL']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.maps.policy', u'policy'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.maps.policy', u'policy')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.maps.policy.ruleaction', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.maps.policy.ruleaction', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policyname', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policyname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ruleaction', 'keyval': 'policyrule', 'extra_keyval': 'policyrule, policyaction'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, policy=policy, ruleaction=ruleaction, policyaction=policyaction)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, policy=policy, ruleaction=ruleaction, policyaction=policyaction)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_maps_policy_rule_actions_delete(self, rbridge_id=None, policy=None, ruleaction=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type policy: policyname
    :param policy: Keyword argument tuple.

    :type policyname: unicode
    :param policyname: **policy** tuple argument:  Configure policy name

    **Instance Keyword Argument Tuple**:

    :type ruleaction: policyrule
    :param ruleaction: Keyword argument tuple.

    :type policyrule: unicode
    :param policyrule: **ruleaction** tuple argument:  rule name

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.maps.policy', u'policy'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.maps.policy', u'policy')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.maps.policy.ruleaction', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.maps.policy.ruleaction', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policyname', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policyname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ruleaction', 'keyval': 'policyrule', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'actions'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, policy=policy, ruleaction=ruleaction)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, policy=policy, ruleaction=ruleaction)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_maps_relay_delete(self, rbridge_id=None, relay=None, domainname=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type relay: hostip
    :param relay: Keyword argument tuple.

    :type hostip: unicode
    :param hostip: **relay** tuple argument:  <IP:Address> IP address of Relay Host

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Argument(s)**:

    :type domainname: unicode
    :param domainname: Domain name server

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.maps.relay', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.maps.relay', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.maps.relay', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.maps.relay', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'relay', 'keyval': 'hostip', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, relay=relay, domainname=domainname)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, relay=relay, domainname=domainname)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_maps_relay_domainname_delete(self, rbridge_id=None, relay=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type relay: hostip
    :param relay: Keyword argument tuple.

    :type hostip: unicode
    :param hostip: **relay** tuple argument:  <IP:Address> IP address of Relay Host

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.maps.relay', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.maps.relay', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.maps.relay', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.maps.relay', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'relay', 'keyval': 'hostip', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'domainname'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, relay=relay)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, relay=relay)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_maps_rule_delete(self, rbridge_id=None, rule=None, targetgroup=None, monitor=None, timebase=None, op=None, threshold=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type rule: rulename, targetgroup, monitor, timebase, op, threshold
    :param rule: Keyword argument tuple.

    :type rulename: unicode
    :param rulename: **rule** tuple argument:  Configure rule name

    :type targetgroup: unicode
    :param targetgroup: **rule** tuple argument:  target group for rule

    :type monitor: unicode
    :param monitor: **rule** tuple argument.

        * enumeration restriction: ::

            ['MEMORY_USAGE',
            'FLASH_USAGE',
            'HA_SYNC',
            'BAD_PWR',
            'ETH_MGMT_PORT_STATE',
            'BAD_FAN',
            'CPU',
            'SFP_TEMP',
            'SEC_TELNET',
            'TXP',
            'TEMP',
            'RX_SYM_ERR',
            'CRCALN',
            'VOLTAGE',
            'SFP_STATE',
            'WWN_DOWN',
            'FAN_STATE',
            'CURRENT',
            'RX_ABN_FRAME',
            'RXP',
            'FAULTY_BLADE',
            'WWN',
            'BAD_TEMP',
            'PS_STATE',
            'SEC_LV',
            'BLADE_STATE',
            'DOWN_SFM']

    :type timebase: unicode
    :param timebase: **rule** tuple argument.

        * enumeration restriction: ::

            ['none', 'day', 'hour', 'min']

    :type op: unicode
    :param op: **rule** tuple argument.

        * enumeration restriction: ::

            ['gt', 'lt', 'le', 'eq', 'ge']

    :type threshold: unicode
    :param threshold: **rule** tuple argument:  threshold value

    **Instance Argument(s)**:

    :type targetgroup: unicode
    :param targetgroup: target group for rule

    :type monitor: unicode
    :param monitor: Keyword argument.

        * enumeration restriction: ::

            ['MEMORY_USAGE',
            'FLASH_USAGE',
            'HA_SYNC',
            'BAD_PWR',
            'ETH_MGMT_PORT_STATE',
            'BAD_FAN',
            'CPU',
            'SFP_TEMP',
            'SEC_TELNET',
            'TXP',
            'TEMP',
            'RX_SYM_ERR',
            'CRCALN',
            'VOLTAGE',
            'SFP_STATE',
            'WWN_DOWN',
            'FAN_STATE',
            'CURRENT',
            'RX_ABN_FRAME',
            'RXP',
            'FAULTY_BLADE',
            'WWN',
            'BAD_TEMP',
            'PS_STATE',
            'SEC_LV',
            'BLADE_STATE',
            'DOWN_SFM']

    :type timebase: unicode
    :param timebase: Keyword argument.

        * enumeration restriction: ::

            ['none', 'day', 'hour', 'min']

    :type op: unicode
    :param op: Keyword argument.

        * enumeration restriction: ::

            ['gt', 'lt', 'le', 'eq', 'ge']

    :type threshold: unicode
    :param threshold: threshold value

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.maps.rule', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.maps.rule', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'rule', 'keyval': 'rulename', 'extra_keyval': 'rulename, targetgroup, monitor, timebase, op, threshold'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, rule=rule, targetgroup=targetgroup, monitor=monitor, timebase=timebase, op=op, threshold=threshold)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, rule=rule, targetgroup=targetgroup, monitor=monitor, timebase=timebase, op=op, threshold=threshold)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_maps_rule_group_delete(self, rbridge_id=None, rule=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type rule: rulename
    :param rule: Keyword argument tuple.

    :type rulename: unicode
    :param rulename: **rule** tuple argument:  Configure rule name

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.maps.rule', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.maps.rule', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'rule', 'keyval': 'rulename', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'group'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, rule=rule)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_maps_rule_interval_delete(self, rbridge_id=None, rule=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type rule: rulename
    :param rule: Keyword argument tuple.

    :type rulename: unicode
    :param rulename: **rule** tuple argument:  Configure rule name

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.maps.rule', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.maps.rule', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'rule', 'keyval': 'rulename', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, rule=rule)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_maps_rule_monitor_delete(self, rbridge_id=None, rule=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type rule: rulename
    :param rule: Keyword argument tuple.

    :type rulename: unicode
    :param rulename: **rule** tuple argument:  Configure rule name

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.maps.rule', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.maps.rule', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'rule', 'keyval': 'rulename', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'monitor'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, rule=rule)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_maps_rule_op_delete(self, rbridge_id=None, rule=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type rule: rulename
    :param rule: Keyword argument tuple.

    :type rulename: unicode
    :param rulename: **rule** tuple argument:  Configure rule name

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.maps.rule', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.maps.rule', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'rule', 'keyval': 'rulename', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'op'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, rule=rule)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_maps_rule_value_delete(self, rbridge_id=None, rule=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type rule: rulename
    :param rule: Keyword argument tuple.

    :type rulename: unicode
    :param rulename: **rule** tuple argument:  Configure rule name

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.maps.rule', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.maps.rule', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'rule', 'keyval': 'rulename', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'value'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, rule=rule)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_openflow_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.openflow', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.openflow', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.openflow', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_openflow_logical_instance_delete(self, rbridge_id=None, logical_instance=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type logical_instance: instance_id
    :param logical_instance: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **logical_instance** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.openflow.logical_instance', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.openflow.logical_instance', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.openflow.logical_instance', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'logical_instance', 'keyval': 'instance_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, logical_instance=logical_instance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, logical_instance=logical_instance)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_openflow_logical_instance_activate_delete(self, rbridge_id=None, logical_instance=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type logical_instance: instance_id
    :param logical_instance: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **logical_instance** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.openflow.logical_instance', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.openflow.logical_instance', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.openflow.logical_instance', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'logical_instance', 'keyval': 'instance_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'activate'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, logical_instance=logical_instance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, logical_instance=logical_instance)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_openflow_logical_instance_controller_delete(self, rbridge_id=None, logical_instance=None, controller=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type logical_instance: instance_id
    :param logical_instance: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **logical_instance** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type controller: controller_name
    :param controller: Keyword argument tuple.

    :type controller_name: unicode
    :param controller_name: **controller** tuple argument:  OpenFlow controller name

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.openflow.logical_instance', u'logical_instance'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.openflow.logical_instance', u'logical_instance'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.openflow.logical_instance', u'logical_instance')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.openflow.logical_instance.controller', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.openflow.logical_instance.controller', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.openflow.logical_instance.controller', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'instance_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'instance_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'instance_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'controller', 'keyval': 'controller_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, logical_instance=logical_instance, controller=controller)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, logical_instance=logical_instance, controller=controller)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_openflow_logical_instance_default_behavior_delete(self, rbridge_id=None, logical_instance=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type logical_instance: instance_id
    :param logical_instance: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **logical_instance** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.openflow.logical_instance', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.openflow.logical_instance', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.openflow.logical_instance', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'logical_instance', 'keyval': 'instance_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'default-behavior'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, logical_instance=logical_instance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, logical_instance=logical_instance)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_openflow_logical_instance_passive_no_ssl_delete(self, rbridge_id=None, logical_instance=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type logical_instance: instance_id
    :param logical_instance: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **logical_instance** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.openflow.logical_instance', u'logical_instance'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.openflow.logical_instance', u'logical_instance'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.openflow.logical_instance', u'logical_instance')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.openflow.logical_instance.passive.no_ssl', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.openflow.logical_instance.passive.no_ssl', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.openflow.logical_instance.passive.no_ssl', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'instance_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'instance_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'instance_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'passive_controller_flag, passive_controller_ip_address, passive_controller_port'}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v6_0_2c.rbridge_id.openflow.logical_instance.passive.no_ssl": {"passive_controller_flag": "passive_controller_flag", "passive_controller_ip_address": "passive_controller_ip_address", "passive_controller_port": "passive_controller_port"}, "pybind.nos.v7_1_0.rbridge_id.openflow.logical_instance.passive.no_ssl": {}, "pybind.nos.v7_0_1b.rbridge_id.openflow.logical_instance.passive.no_ssl": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, logical_instance=logical_instance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, logical_instance=logical_instance)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_openflow_logical_instance_passive_no_ssl_ip_address_delete(self, rbridge_id=None, logical_instance=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type logical_instance: instance_id
    :param logical_instance: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **logical_instance** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.openflow.logical_instance', u'logical_instance'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.openflow.logical_instance', u'logical_instance'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.openflow.logical_instance', u'logical_instance')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.openflow.logical_instance.passive.no_ssl', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.openflow.logical_instance.passive.no_ssl', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.openflow.logical_instance.passive.no_ssl', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'instance_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'instance_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'instance_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ip-address'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, logical_instance=logical_instance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, logical_instance=logical_instance)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_openflow_logical_instance_passive_no_ssl_passive_controller_flag_delete(self, rbridge_id=None, logical_instance=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type logical_instance: instance_id
    :param logical_instance: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **logical_instance** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.openflow.logical_instance', u'logical_instance'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.openflow.logical_instance', u'logical_instance'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.openflow.logical_instance', u'logical_instance')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.openflow.logical_instance.passive.no_ssl', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.openflow.logical_instance.passive.no_ssl', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.openflow.logical_instance.passive.no_ssl', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'instance_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'instance_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'instance_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'passive-controller-flag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, logical_instance=logical_instance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, logical_instance=logical_instance)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_openflow_logical_instance_passive_no_ssl_port_delete(self, rbridge_id=None, logical_instance=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type logical_instance: instance_id
    :param logical_instance: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **logical_instance** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.openflow.logical_instance', u'logical_instance'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.openflow.logical_instance', u'logical_instance'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.openflow.logical_instance', u'logical_instance')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.openflow.logical_instance.passive.no_ssl', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.openflow.logical_instance.passive.no_ssl', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.openflow.logical_instance.passive.no_ssl', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'instance_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'instance_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'instance_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'port'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, logical_instance=logical_instance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, logical_instance=logical_instance)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_openflow_logical_instance_passive_no_ssl_use_vrf_delete(self, rbridge_id=None, logical_instance=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type logical_instance: instance_id
    :param logical_instance: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **logical_instance** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.openflow.logical_instance', u'logical_instance'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.openflow.logical_instance', u'logical_instance')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.openflow.logical_instance.passive.no_ssl', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.openflow.logical_instance.passive.no_ssl', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'instance_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'instance_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'use-vrf'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, logical_instance=logical_instance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, logical_instance=logical_instance)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_openflow_logical_instance_version_delete(self, rbridge_id=None, logical_instance=None, version=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type logical_instance: instance_id
    :param logical_instance: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **logical_instance** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type version: version_name
    :param version: Keyword argument tuple.

    :type version_name: unicode
    :param version_name: **version** tuple argument.

        * enumeration restriction: ::

            ['ofv130']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.openflow.logical_instance', u'logical_instance'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.openflow.logical_instance', u'logical_instance'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.openflow.logical_instance', u'logical_instance')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.openflow.logical_instance.version', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.openflow.logical_instance.version', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.openflow.logical_instance.version', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'instance_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'instance_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'instance_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'version', 'keyval': 'version_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, logical_instance=logical_instance, version=version)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, logical_instance=logical_instance, version=version)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_protocol_vrrp_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.protocol.hide_vrrp_holder', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.protocol.hide_vrrp_holder', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.protocol.hide_vrrp_holder', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vrrp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_protocol_vrrp_extended_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.protocol.hide_vrrp_holder', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.protocol.hide_vrrp_holder', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.protocol.hide_vrrp_holder', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vrrp-extended'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_qos_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.qos', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.qos', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.qos', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_qos_rcv_queue_limit_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.qos.rcv_queue', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.qos.rcv_queue', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.qos.rcv_queue', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'limit'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_qos_rcv_queue_multicast_mode_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.qos.rcv_queue.multicast', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.qos.rcv_queue.multicast', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.qos.rcv_queue.multicast', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mode'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_qos_tx_queue_limit_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.qos.tx_queue', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.qos.tx_queue', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.qos.tx_queue', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'limit'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_resource_monitor_cpu_action_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_1_0.rbridge_id.resource_monitor.cpu', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'action'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_resource_monitor_cpu_enable_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_1_0.rbridge_id.resource_monitor.cpu', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_resource_monitor_cpu_grace_period_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_1_0.rbridge_id.resource_monitor.cpu', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'grace-period'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_resource_monitor_cpu_logging_rate_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_1_0.rbridge_id.resource_monitor.cpu', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'logging-rate'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_resource_monitor_cpu_sample_rate_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_1_0.rbridge_id.resource_monitor.cpu', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'sample-rate'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_resource_monitor_cpu_thresh_offset_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_1_0.rbridge_id.resource_monitor.cpu', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'thresh-offset'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_resource_monitor_cpu_threshold_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_1_0.rbridge_id.resource_monitor.cpu', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'threshold'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_resource_monitor_memory_action_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_1_0.rbridge_id.resource_monitor.memory', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'action'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_resource_monitor_memory_enable_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_1_0.rbridge_id.resource_monitor.memory', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_resource_monitor_memory_grace_period_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_1_0.rbridge_id.resource_monitor.memory', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'grace-period'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_resource_monitor_memory_logging_rate_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_1_0.rbridge_id.resource_monitor.memory', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'logging-rate'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_resource_monitor_memory_sample_rate_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_1_0.rbridge_id.resource_monitor.memory', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'sample-rate'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_resource_monitor_memory_thresh_offset_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_1_0.rbridge_id.resource_monitor.memory', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'thresh-offset'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_resource_monitor_memory_threshold_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_1_0.rbridge_id.resource_monitor.memory', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'threshold'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_resource_monitor_process_memory_alarm_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_1_0.rbridge_id.resource_monitor.process.memory', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'alarm'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_resource_monitor_process_memory_critical_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_1_0.rbridge_id.resource_monitor.process.memory', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'critical'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_resource_monitor_process_memory_enable_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_1_0.rbridge_id.resource_monitor.process.memory', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_root_access_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.root', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.root', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.root', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'access'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_root_enable_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.root', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.root', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.root', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_route_map_delete(self, rbridge_id=None, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.route_map', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.route_map', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.route_map', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'route_map', 'keyval': 'name, action_rm, instance', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_route_map_continue_delete(self, rbridge_id=None, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.route_map', u'route_map'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.route_map.content.continue_holder', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.route_map.content.continue_holder', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.route_map.content.continue_holder', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'continue'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_route_map_continue_holder_delete(self, rbridge_id=None, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.route_map', u'route_map'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.route_map.content.continue_holder', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.route_map.content.continue_holder', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.route_map.content.continue_holder', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'continue_, continue_val'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_route_map_continue_val_delete(self, rbridge_id=None, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.route_map', u'route_map'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.route_map.content.continue_holder', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.route_map.content.continue_holder', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.route_map.content.continue_holder', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'continue-val'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_route_map_match_as_path_delete(self, rbridge_id=None, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.route_map.content.match.as_path', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.route_map.content.match.as_path', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.route_map.content.match.as_path', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_route_map_match_as_path_as_path_access_list_name_delete(self, rbridge_id=None, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.route_map.content.match.as_path', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.route_map.content.match.as_path', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.route_map.content.match.as_path', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'as-path-access-list-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_route_map_match_community_delete(self, rbridge_id=None, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.route_map', u'route_map'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.route_map.content.match.community', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.route_map.content.match.community', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.route_map.content.match.community', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'community_access_list_name'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_route_map_match_community_community_access_list_name_delete(self, rbridge_id=None, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.route_map', u'route_map'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.route_map.content.match.community', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.route_map.content.match.community', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.route_map.content.match.community', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'community-access-list-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_route_map_match_extcommunity_delete(self, rbridge_id=None, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.route_map.content.match.extcommunity', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.route_map.content.match.extcommunity', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.route_map.content.match.extcommunity', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_route_map_match_extcommunity_extcommunity_num_delete(self, rbridge_id=None, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.route_map.content.match.extcommunity', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.route_map.content.match.extcommunity', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.route_map.content.match.extcommunity', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'extcommunity-num'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_route_map_match_interface_delete(self, rbridge_id=None, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.route_map', u'route_map'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.route_map.content.match.interface', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.route_map.content.match.interface', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.route_map.content.match.interface', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_route_map_match_ip_address_delete(self, rbridge_id=None, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.route_map.content.match.ip.address', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.route_map.content.match.ip.address', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.route_map.content.match.ip.address', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_route_map_match_ip_address_acl_delete(self, rbridge_id=None, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.route_map.content.match.ip.address', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.route_map.content.match.ip.address', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.route_map.content.match.ip.address', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'acl'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_route_map_match_ip_address_prefix_list_delete(self, rbridge_id=None, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.route_map.content.match.ip.address', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.route_map.content.match.ip.address', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.route_map.content.match.ip.address', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'prefix-list'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_route_map_match_ip_next_hop_delete(self, rbridge_id=None, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.route_map', u'route_map'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.route_map.content.match.ip.next_hop', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.route_map.content.match.ip.next_hop', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.route_map.content.match.ip.next_hop', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_route_map_match_ip_next_hop_prefix_list_delete(self, rbridge_id=None, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.route_map', u'route_map'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.route_map.content.match.ip.next_hop', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.route_map.content.match.ip.next_hop', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.route_map.content.match.ip.next_hop', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'prefix-list'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_route_map_match_ip_route_source_delete(self, rbridge_id=None, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.route_map.content.match.ip.route_source', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.route_map.content.match.ip.route_source', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.route_map.content.match.ip.route_source', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_route_map_match_ip_route_source_prefix_list_delete(self, rbridge_id=None, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.route_map.content.match.ip.route_source', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.route_map.content.match.ip.route_source', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.route_map.content.match.ip.route_source', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'prefix-list'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_route_map_match_ipv6_address_delete(self, rbridge_id=None, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.route_map', u'route_map'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.route_map.content.match.ipv6.address', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.route_map.content.match.ipv6.address', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.route_map.content.match.ipv6.address', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_route_map_match_ipv6_address_acl_delete(self, rbridge_id=None, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.route_map', u'route_map'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.route_map.content.match.ipv6.address', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.route_map.content.match.ipv6.address', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.route_map.content.match.ipv6.address', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'acl'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_route_map_match_ipv6_address_prefix_list_delete(self, rbridge_id=None, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.route_map', u'route_map'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.route_map.content.match.ipv6.address', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.route_map.content.match.ipv6.address', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.route_map.content.match.ipv6.address', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'prefix-list'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_route_map_match_ipv6_next_hop_delete(self, rbridge_id=None, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.route_map', u'route_map'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.route_map.content.match.ipv6.next_hop', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.route_map.content.match.ipv6.next_hop', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.route_map.content.match.ipv6.next_hop', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_route_map_match_ipv6_next_hop_prefix_list_delete(self, rbridge_id=None, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.route_map', u'route_map'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.route_map.content.match.ipv6.next_hop', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.route_map.content.match.ipv6.next_hop', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.route_map.content.match.ipv6.next_hop', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'prefix-list'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_route_map_match_ipv6_route_source_delete(self, rbridge_id=None, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.route_map', u'route_map'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.route_map.content.match.ipv6.route_source', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.route_map.content.match.ipv6.route_source', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.route_map.content.match.ipv6.route_source', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_route_map_match_ipv6_route_source_prefix_list_delete(self, rbridge_id=None, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.route_map', u'route_map'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.route_map.content.match.ipv6.route_source', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.route_map.content.match.ipv6.route_source', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.route_map.content.match.ipv6.route_source', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'prefix-list'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_route_map_match_metric_delete(self, rbridge_id=None, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.route_map', u'route_map'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.route_map.content.match.metric', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.route_map.content.match.metric', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.route_map.content.match.metric', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_route_map_match_metric_metric_rmm_delete(self, rbridge_id=None, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.route_map', u'route_map'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.route_map.content.match.metric', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.route_map.content.match.metric', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.route_map.content.match.metric', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric-rmm'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_route_map_match_next_hop_delete(self, rbridge_id=None, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.route_map', u'route_map'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.route_map.content.match.next_hop', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.route_map.content.match.next_hop', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.route_map.content.match.next_hop', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_route_map_match_next_hop_next_hop_filter_val_delete(self, rbridge_id=None, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.route_map', u'route_map'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.route_map.content.match.next_hop', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.route_map.content.match.next_hop', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.route_map.content.match.next_hop', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'next-hop-filter-val'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_route_map_match_protocol_delete(self, rbridge_id=None, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.route_map', u'route_map'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.route_map.content.match.protocol', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.route_map.content.match.protocol', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.route_map.content.match.protocol', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_route_map_match_protocol_bgp_delete(self, rbridge_id=None, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.route_map.content.match.protocol.bgp_protocol_container', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.route_map.content.match.protocol.bgp_protocol_container', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.route_map.content.match.protocol.bgp_protocol_container', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bgp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_route_map_match_protocol_bgp_protocol_container_delete(self, rbridge_id=None, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.route_map.content.match.protocol.bgp_protocol_container', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.route_map.content.match.protocol.bgp_protocol_container', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.route_map.content.match.protocol.bgp_protocol_container', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_route_map_match_protocol_bgp_route_type_delete(self, rbridge_id=None, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.route_map.content.match.protocol.bgp_protocol_container', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.route_map.content.match.protocol.bgp_protocol_container', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.route_map.content.match.protocol.bgp_protocol_container', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bgp-route-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_route_map_match_protocol_protocol_static_container_delete(self, rbridge_id=None, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.route_map', u'route_map'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.route_map.content.match.protocol.protocol_static_container', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.route_map.content.match.protocol.protocol_static_container', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.route_map.content.match.protocol.protocol_static_container', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_route_map_match_protocol_static_delete(self, rbridge_id=None, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.route_map', u'route_map'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.route_map.content.match.protocol.protocol_static_container', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.route_map.content.match.protocol.protocol_static_container', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.route_map.content.match.protocol.protocol_static_container', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'static'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_route_map_match_route_type_delete(self, rbridge_id=None, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.route_map.content.match.route_type', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.route_map.content.match.route_type', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.route_map.content.match.route_type', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_route_map_match_route_type_route_type_rmm_delete(self, rbridge_id=None, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.route_map.content.match.route_type', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.route_map.content.match.route_type', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.route_map.content.match.route_type', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-type-rmm'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_route_map_match_tag_delete(self, rbridge_id=None, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.route_map.content.match.tag', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.route_map.content.match.tag', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.route_map.content.match.tag', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_route_map_match_vrf_delete(self, rbridge_id=None, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.route_map', u'route_map'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.route_map.content.match', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.route_map.content.match', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.route_map.content.match', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vrf'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_route_map_set_as_path_delete(self, rbridge_id=None, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.route_map', u'route_map'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.route_map.content.set_.as_path', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.route_map.content.set_.as_path', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.route_map.content.set_.as_path', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_route_map_set_as_path_prepend_delete(self, rbridge_id=None, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.route_map', u'route_map'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.route_map.content.set_.as_path', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.route_map.content.set_.as_path', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.route_map.content.set_.as_path', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'prepend'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_route_map_set_as_path_tag_delete(self, rbridge_id=None, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.route_map', u'route_map'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.route_map.content.set_.as_path', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.route_map.content.set_.as_path', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.route_map.content.set_.as_path', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_route_map_set_automatic_tag_delete(self, rbridge_id=None, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.route_map', u'route_map'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.route_map.content.set_.automatic_tag', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.route_map.content.set_.automatic_tag', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.route_map.content.set_.automatic_tag', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_route_map_set_automatic_tag_tag_empty_delete(self, rbridge_id=None, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.route_map', u'route_map'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.route_map.content.set_.automatic_tag', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.route_map.content.set_.automatic_tag', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.route_map.content.set_.automatic_tag', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tag-empty'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_route_map_set_comm_list_delete(self, rbridge_id=None, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.route_map', u'route_map'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.route_map.content.set_.comm_list', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.route_map.content.set_.comm_list', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.route_map.content.set_.comm_list', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'comm_list_name, match_comm_delete'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_route_map_set_comm_list_comm_list_name_delete(self, rbridge_id=None, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.route_map', u'route_map'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.route_map.content.set_.comm_list', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.route_map.content.set_.comm_list', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.route_map.content.set_.comm_list', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'comm-list-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_route_map_set_comm_list_delete_delete(self, rbridge_id=None, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.route_map', u'route_map'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.route_map.content.set_.comm_list', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.route_map.content.set_.comm_list', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.route_map.content.set_.comm_list', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'delete'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_route_map_set_community_delete(self, rbridge_id=None, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.route_map', u'route_map'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.route_map.content.set_.community', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.route_map.content.set_.community', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.route_map.content.set_.community', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_route_map_set_community_set_community_expr_delete(self, rbridge_id=None, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.route_map', u'route_map'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.route_map.content.set_.community', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.route_map.content.set_.community', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.route_map.content.set_.community', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'set-community-expr'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_route_map_set_dampening_delete(self, rbridge_id=None, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.route_map.content.set_.dampening', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.route_map.content.set_.dampening', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.route_map.content.set_.dampening', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'half_life, reuse, suppress, max_suppress_time'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_route_map_set_dampening_half_life_delete(self, rbridge_id=None, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.route_map.content.set_.dampening', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.route_map.content.set_.dampening', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.route_map.content.set_.dampening', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'half-life'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_route_map_set_dampening_max_suppress_time_delete(self, rbridge_id=None, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.route_map.content.set_.dampening', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.route_map.content.set_.dampening', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.route_map.content.set_.dampening', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'max-suppress-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_route_map_set_dampening_reuse_delete(self, rbridge_id=None, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.route_map.content.set_.dampening', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.route_map.content.set_.dampening', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.route_map.content.set_.dampening', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'reuse'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_route_map_set_dampening_suppress_delete(self, rbridge_id=None, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.route_map.content.set_.dampening', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.route_map.content.set_.dampening', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.route_map.content.set_.dampening', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'suppress'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_route_map_set_distance_delete(self, rbridge_id=None, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.route_map.content.set_.distance', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.route_map.content.set_.distance', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.route_map.content.set_.distance', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_route_map_set_distance_dist_rms_delete(self, rbridge_id=None, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.route_map.content.set_.distance', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.route_map.content.set_.distance', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.route_map.content.set_.distance', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dist-rms'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_route_map_set_extcommunity_rt_delete(self, rbridge_id=None, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.route_map.content.set_.extcommunity.rt', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.route_map.content.set_.extcommunity.rt', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.route_map.content.set_.extcommunity.rt', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_route_map_set_extcommunity_rt_asn_nn_rt_delete(self, rbridge_id=None, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.route_map.content.set_.extcommunity.rt', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.route_map.content.set_.extcommunity.rt', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.route_map.content.set_.extcommunity.rt', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ASN-NN-rt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_route_map_set_extcommunity_soo_delete(self, rbridge_id=None, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.route_map', u'route_map'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.route_map.content.set_.extcommunity.soo', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.route_map.content.set_.extcommunity.soo', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.route_map.content.set_.extcommunity.soo', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_route_map_set_extcommunity_soo_asn_nn_soo_delete(self, rbridge_id=None, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.route_map', u'route_map'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.route_map.content.set_.extcommunity.soo', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.route_map.content.set_.extcommunity.soo', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.route_map.content.set_.extcommunity.soo', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ASN-NN-soo'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_route_map_set_ip_dscp_delete(self, rbridge_id=None, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.route_map', u'route_map'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.route_map.content.set_.ip.dscp', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.route_map.content.set_.ip.dscp', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.route_map.content.set_.ip.dscp', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_route_map_set_ip_dscp_dscp_rms_delete(self, rbridge_id=None, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.route_map', u'route_map'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.route_map.content.set_.ip.dscp', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.route_map.content.set_.ip.dscp', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.route_map.content.set_.ip.dscp', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dscp-rms'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_route_map_set_ip_global_delete(self, rbridge_id=None, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.route_map.content.set_.ip.global_', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.route_map.content.set_.ip.global_', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.route_map.content.set_.ip.global_', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_route_map_set_ip_global_next_global_hop_delete(self, rbridge_id=None, route_map=None, next_global_hop=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    **Instance Keyword Argument Tuple**:

    :type next_global_hop: next_hop
    :param next_global_hop: Keyword argument tuple.

    :type next_hop: unicode
    :param next_hop: **next_global_hop** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.route_map.content.set_.ip.global_.next_global_hop', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.route_map.content.set_.ip.global_.next_global_hop', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.route_map.content.set_.ip.global_.next_global_hop', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'next_global_hop', 'keyval': 'next_hop', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map, next_global_hop=next_global_hop)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map, next_global_hop=next_global_hop)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_route_map_set_ip_interface_null0_delete(self, rbridge_id=None, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.route_map.content.set_.ip.interface', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.route_map.content.set_.ip.interface', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.route_map.content.set_.ip.interface', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'null0'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_route_map_set_ip_next_hop_delete(self, rbridge_id=None, route_map=None, next_hop=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    **Instance Keyword Argument Tuple**:

    :type next_hop: next_hop
    :param next_hop: Keyword argument tuple.

    :type next_hop: unicode
    :param next_hop: **next_hop** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.route_map', u'route_map'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.route_map.content.set_.ip.next_ip.next_hop', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.route_map.content.set_.ip.next_ip.next_hop', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.route_map.content.set_.ip.next_ip.next_hop', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'next_hop', 'keyval': 'next_hop', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map, next_hop=next_hop)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map, next_hop=next_hop)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_route_map_set_ip_next_hop_peer_address_delete(self, rbridge_id=None, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.route_map', u'route_map'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.route_map.content.set_.ip.next_hop', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.route_map.content.set_.ip.next_hop', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.route_map.content.set_.ip.next_hop', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'peer-address'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_route_map_set_ip_next_ip_delete(self, rbridge_id=None, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.route_map', u'route_map'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.route_map.content.set_.ip.next_ip', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.route_map.content.set_.ip.next_ip', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.route_map.content.set_.ip.next_ip', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_route_map_set_ip_next_vrf_delete(self, rbridge_id=None, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.route_map.content.set_.ip.next_vrf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.route_map.content.set_.ip.next_vrf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.route_map.content.set_.ip.next_vrf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_route_map_set_ip_next_vrf_list_delete(self, rbridge_id=None, route_map=None, next_vrf_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    **Instance Keyword Argument Tuple**:

    :type next_vrf_list: vrf, next_hop
    :param next_vrf_list: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **next_vrf_list** tuple argument:  Next Hop Vrf Name

    :type next_hop: unicode
    :param next_hop: **next_vrf_list** tuple argument:  A.B.C.D;;IP address of next hop

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.route_map.content.set_.ip.next_vrf.next_vrf_list', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.route_map.content.set_.ip.next_vrf.next_vrf_list', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.route_map.content.set_.ip.next_vrf.next_vrf_list', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'next_vrf_list', 'keyval': 'vrf, next_hop', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map, next_vrf_list=next_vrf_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map, next_vrf_list=next_vrf_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_route_map_set_ipv6_global_delete(self, rbridge_id=None, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.route_map', u'route_map'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.route_map.content.set_.ipv6.global_', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.route_map.content.set_.ipv6.global_', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.route_map.content.set_.ipv6.global_', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_route_map_set_ipv6_global_next_global_hop_delete(self, rbridge_id=None, route_map=None, next_global_hop=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    **Instance Keyword Argument Tuple**:

    :type next_global_hop: next_hop
    :param next_global_hop: Keyword argument tuple.

    :type next_hop: unicode
    :param next_hop: **next_global_hop** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.route_map.content.set_.ipv6.global_.next_global_hop', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.route_map.content.set_.ipv6.global_.next_global_hop', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.route_map.content.set_.ipv6.global_.next_global_hop', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'next_global_hop', 'keyval': 'next_hop', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map, next_global_hop=next_global_hop)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map, next_global_hop=next_global_hop)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_route_map_set_ipv6_interface_null0_delete(self, rbridge_id=None, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.route_map', u'route_map'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.route_map.content.set_.ipv6.interface', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.route_map.content.set_.ipv6.interface', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.route_map.content.set_.ipv6.interface', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'null0'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_route_map_set_ipv6_next_hop_delete(self, rbridge_id=None, route_map=None, next_hop=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    **Instance Keyword Argument Tuple**:

    :type next_hop: next_hop
    :param next_hop: Keyword argument tuple.

    :type next_hop: unicode
    :param next_hop: **next_hop** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.route_map.content.set_.ipv6.next_ip.next_hop', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.route_map.content.set_.ipv6.next_ip.next_hop', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.route_map.content.set_.ipv6.next_ip.next_hop', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'next_hop', 'keyval': 'next_hop', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map, next_hop=next_hop)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map, next_hop=next_hop)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_route_map_set_ipv6_next_ip_delete(self, rbridge_id=None, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.route_map', u'route_map'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.route_map.content.set_.ipv6.next_ip', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.route_map.content.set_.ipv6.next_ip', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.route_map.content.set_.ipv6.next_ip', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_route_map_set_ipv6_next_vrf_delete(self, rbridge_id=None, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.route_map', u'route_map'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.route_map.content.set_.ipv6.next_vrf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.route_map.content.set_.ipv6.next_vrf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.route_map.content.set_.ipv6.next_vrf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_route_map_set_ipv6_next_vrf_list_delete(self, rbridge_id=None, route_map=None, next_vrf_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    **Instance Keyword Argument Tuple**:

    :type next_vrf_list: vrf, next_hop
    :param next_vrf_list: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **next_vrf_list** tuple argument:  WORD 1-63;;Next Hop Vrf Name

    :type next_hop: unicode
    :param next_hop: **next_vrf_list** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.route_map', u'route_map'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.route_map.content.set_.ipv6.next_vrf.next_vrf_list', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.route_map.content.set_.ipv6.next_vrf.next_vrf_list', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.route_map.content.set_.ipv6.next_vrf.next_vrf_list', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'next_vrf_list', 'keyval': 'vrf, next_hop', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map, next_vrf_list=next_vrf_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map, next_vrf_list=next_vrf_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_route_map_set_local_preference_delete(self, rbridge_id=None, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.route_map.content.set_.local_preference', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.route_map.content.set_.local_preference', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.route_map.content.set_.local_preference', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_route_map_set_local_preference_local_preference_value_delete(self, rbridge_id=None, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.route_map.content.set_.local_preference', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.route_map.content.set_.local_preference', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.route_map.content.set_.local_preference', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'local-preference-value'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_route_map_set_metric_delete(self, rbridge_id=None, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.route_map.content.set_.metric', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.route_map.content.set_.metric', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.route_map.content.set_.metric', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'delta_rms, metric_rms'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_route_map_set_metric_delta_rms_delete(self, rbridge_id=None, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.route_map.content.set_.metric', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.route_map.content.set_.metric', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.route_map.content.set_.metric', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'delta-rms'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_route_map_set_metric_metric_rms_delete(self, rbridge_id=None, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.route_map.content.set_.metric', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.route_map.content.set_.metric', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.route_map.content.set_.metric', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric-rms'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_route_map_set_metric_type_delete(self, rbridge_id=None, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.route_map.content.set_.metric_type', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.route_map.content.set_.metric_type', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.route_map.content.set_.metric_type', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_route_map_set_metric_type_external_delete(self, rbridge_id=None, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.route_map.content.set_.metric_type', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.route_map.content.set_.metric_type', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.route_map.content.set_.metric_type', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'external'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_route_map_set_metric_type_internal_delete(self, rbridge_id=None, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.route_map.content.set_.metric_type', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.route_map.content.set_.metric_type', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.route_map.content.set_.metric_type', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'internal'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_route_map_set_metric_type_type_1_delete(self, rbridge_id=None, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.route_map.content.set_.metric_type', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.route_map.content.set_.metric_type', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.route_map.content.set_.metric_type', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'type-1'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_route_map_set_metric_type_type_2_delete(self, rbridge_id=None, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.route_map.content.set_.metric_type', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.route_map.content.set_.metric_type', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.route_map.content.set_.metric_type', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'type-2'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_route_map_set_origin_delete(self, rbridge_id=None, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.route_map', u'route_map'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.route_map.content.set_.origin', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.route_map.content.set_.origin', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.route_map.content.set_.origin', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_route_map_set_origin_igp_delete(self, rbridge_id=None, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.route_map', u'route_map'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.route_map.content.set_.origin', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.route_map.content.set_.origin', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.route_map.content.set_.origin', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'igp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_route_map_set_origin_incomplete_delete(self, rbridge_id=None, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.route_map', u'route_map'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.route_map.content.set_.origin', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.route_map.content.set_.origin', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.route_map.content.set_.origin', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'incomplete'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_route_map_set_route_type_delete(self, rbridge_id=None, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.route_map', u'route_map'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.route_map.content.set_.route_type', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.route_map.content.set_.route_type', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.route_map.content.set_.route_type', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_route_map_set_route_type_route_type_rms_delete(self, rbridge_id=None, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.route_map', u'route_map'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.route_map.content.set_.route_type', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.route_map.content.set_.route_type', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.route_map.content.set_.route_type', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-type-rms'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_route_map_set_tag_delete(self, rbridge_id=None, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.route_map', u'route_map'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.route_map.content.set_.tag', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.route_map.content.set_.tag', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.route_map.content.set_.tag', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_route_map_set_tag_tag_rms_delete(self, rbridge_id=None, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.route_map', u'route_map'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.route_map.content.set_.tag', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.route_map.content.set_.tag', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.route_map.content.set_.tag', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tag-rms'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_route_map_set_weight_delete(self, rbridge_id=None, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.route_map.content.set_.weight', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.route_map.content.set_.weight', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.route_map.content.set_.weight', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_route_map_set_weight_weight_value_delete(self, rbridge_id=None, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.route_map.content.set_.weight', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.route_map.content.set_.weight', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.route_map.content.set_.weight', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'weight-value'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_af_common_cmds_holder_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_af_ipv4_uc_and_vrf_cmds_call_point_holder_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_aggregate_address_delete(self, rbridge_id=None, aggregate_address=None, advertise_map=None, as_set=None, attribute_map=None, summary_only=None, suppress_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type aggregate_address: aggregate_ip_prefix
    :param aggregate_address: Keyword argument tuple.

    :type aggregate_ip_prefix: unicode
    :param aggregate_ip_prefix: **aggregate_address** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    **Instance Argument(s)**:

    :type advertise_map: unicode
    :param advertise_map: Route map to control attribute advertisement

        * length restriction: ::

            ['1..63']

    :type as_set: YANGBool
    :param as_set: Generate AS set path information

    :type attribute_map: unicode
    :param attribute_map: Route map for parameter control

        * length restriction: ::

            ['1..63']

    :type summary_only: YANGBool
    :param summary_only: Filter more specific routes from updates

    :type suppress_map: unicode
    :param suppress_map: Conditionally filter more specific routes from updates

        * length restriction: ::

            ['1..63']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.aggregate_address', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.aggregate_address', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.aggregate_address', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'aggregate_address', 'keyval': 'aggregate_ip_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, aggregate_address=aggregate_address, advertise_map=advertise_map, as_set=as_set, attribute_map=attribute_map, summary_only=summary_only, suppress_map=suppress_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, aggregate_address=aggregate_address, advertise_map=advertise_map, as_set=as_set, attribute_map=attribute_map, summary_only=summary_only, suppress_map=suppress_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_aggregate_address_advertise_map_delete(self, rbridge_id=None, aggregate_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type aggregate_address: aggregate_ip_prefix
    :param aggregate_address: Keyword argument tuple.

    :type aggregate_ip_prefix: unicode
    :param aggregate_ip_prefix: **aggregate_address** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.aggregate_address', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.aggregate_address', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.aggregate_address', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'aggregate_address', 'keyval': 'aggregate_ip_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'advertise-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, aggregate_address=aggregate_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, aggregate_address=aggregate_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_aggregate_address_as_set_delete(self, rbridge_id=None, aggregate_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type aggregate_address: aggregate_ip_prefix
    :param aggregate_address: Keyword argument tuple.

    :type aggregate_ip_prefix: unicode
    :param aggregate_ip_prefix: **aggregate_address** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.aggregate_address', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.aggregate_address', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.aggregate_address', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'aggregate_address', 'keyval': 'aggregate_ip_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'as-set'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, aggregate_address=aggregate_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, aggregate_address=aggregate_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_aggregate_address_attribute_map_delete(self, rbridge_id=None, aggregate_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type aggregate_address: aggregate_ip_prefix
    :param aggregate_address: Keyword argument tuple.

    :type aggregate_ip_prefix: unicode
    :param aggregate_ip_prefix: **aggregate_address** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.aggregate_address', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.aggregate_address', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.aggregate_address', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'aggregate_address', 'keyval': 'aggregate_ip_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'attribute-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, aggregate_address=aggregate_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, aggregate_address=aggregate_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_aggregate_address_summary_only_delete(self, rbridge_id=None, aggregate_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type aggregate_address: aggregate_ip_prefix
    :param aggregate_address: Keyword argument tuple.

    :type aggregate_ip_prefix: unicode
    :param aggregate_ip_prefix: **aggregate_address** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.aggregate_address', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.aggregate_address', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.aggregate_address', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'aggregate_address', 'keyval': 'aggregate_ip_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'summary-only'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, aggregate_address=aggregate_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, aggregate_address=aggregate_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_aggregate_address_suppress_map_delete(self, rbridge_id=None, aggregate_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type aggregate_address: aggregate_ip_prefix
    :param aggregate_address: Keyword argument tuple.

    :type aggregate_ip_prefix: unicode
    :param aggregate_ip_prefix: **aggregate_address** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.aggregate_address', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.aggregate_address', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.aggregate_address', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'aggregate_address', 'keyval': 'aggregate_ip_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'suppress-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, aggregate_address=aggregate_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, aggregate_address=aggregate_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_always_propagate_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'always-propagate'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_bgp_redistribute_internal_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bgp-redistribute-internal'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_client_to_client_reflection_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'client-to-client-reflection'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_dampening_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening': [u'dampening_flag', u'values', u'dampening_route_map'], 'pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening': [u'dampening_flag', u'values', u'dampening_route_map']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_dampening_dampening_flag_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dampening-flag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_dampening_route_map_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_dampening_values_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening.values', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening.values', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening.values', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening.values': [u'half_time'], 'pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening.values': [u'half_time'], 'pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening.values': [u'half_time']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_default_information_originate_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'default-information-originate'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_default_metric_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'default-metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_default_vrf_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_default_vrf_selected_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'default-vrf-selected'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_graceful_restart_graceful_restart_status_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.graceful_restart', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.graceful_restart', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.graceful_restart', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'graceful-restart-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_graceful_restart_purge_time_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.graceful_restart', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.graceful_restart', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.graceful_restart', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'purge-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_graceful_restart_restart_time_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.graceful_restart', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.graceful_restart', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.graceful_restart', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'restart-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_graceful_restart_stale_routes_time_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.graceful_restart', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.graceful_restart', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.graceful_restart', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'stale-routes-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_maximum_paths_ebgp_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.maximum_paths', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.maximum_paths', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.maximum_paths', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ebgp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_maximum_paths_ibgp_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.maximum_paths', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.maximum_paths', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.maximum_paths', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ibgp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_maximum_paths_load_sharing_value_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.maximum_paths', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.maximum_paths', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.maximum_paths', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'load-sharing-value'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_maximum_paths_use_load_sharing_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.maximum_paths', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.maximum_paths', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.maximum_paths', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'use-load-sharing'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_multipath_ebgp_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.multipath', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.multipath', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.multipath', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ebgp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_multipath_ibgp_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.multipath', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.multipath', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.multipath', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ibgp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_multipath_multi_as_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.multipath', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.multipath', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.multipath', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'multi-as'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_activate_delete(self, rbridge_id=None, af_ipv4_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv4_neighbor_address', 'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'activate'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_additional_paths_advertise_all_delete(self, rbridge_id=None, af_ipv4_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.additional_paths.advertise', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.additional_paths.advertise', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'all'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_additional_paths_advertise_best_delete(self, rbridge_id=None, af_ipv4_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.additional_paths.advertise', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.additional_paths.advertise', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'best'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_allowas_in_delete(self, rbridge_id=None, af_ipv4_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv4_neighbor_address', 'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'allowas-in'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_capability_additional_paths_add_path_both_delete(self, rbridge_id=None, af_ipv4_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.af_neighbor_capability.additional_paths', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.af_neighbor_capability.additional_paths', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'add-path-both'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_capability_additional_paths_receive_delete(self, rbridge_id=None, af_ipv4_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.af_neighbor_capability.additional_paths', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.af_neighbor_capability.additional_paths', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'receive'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_capability_additional_paths_send_delete(self, rbridge_id=None, af_ipv4_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.af_neighbor_capability.additional_paths', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.af_neighbor_capability.additional_paths', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'send'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_capability_orf_prefixlist_prefixlist_status_delete(self, rbridge_id=None, af_ipv4_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.af_neighbor_capability.orf.prefixlist', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.af_neighbor_capability.orf.prefixlist', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.af_neighbor_capability.orf.prefixlist', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'prefixlist-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_capability_orf_prefixlist_receive_delete(self, rbridge_id=None, af_ipv4_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.af_neighbor_capability.orf.prefixlist', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.af_neighbor_capability.orf.prefixlist', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.af_neighbor_capability.orf.prefixlist', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'receive'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_capability_orf_prefixlist_send_delete(self, rbridge_id=None, af_ipv4_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.af_neighbor_capability.orf.prefixlist', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.af_neighbor_capability.orf.prefixlist', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.af_neighbor_capability.orf.prefixlist', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'send'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_default_originate_default_originate_status_delete(self, rbridge_id=None, af_ipv4_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.default_originate', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.default_originate', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.default_originate', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'default-originate-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_default_originate_route_map_delete(self, rbridge_id=None, af_ipv4_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.default_originate', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.default_originate', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.default_originate', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_enable_peer_as_check_delete(self, rbridge_id=None, af_ipv4_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv4_neighbor_address', 'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable-peer-as-check'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_holder_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_maximum_prefix_max_prefix_limit_delete(self, rbridge_id=None, af_ipv4_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.maximum_prefix', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.maximum_prefix', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.maximum_prefix', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'max-prefix-limit'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_maximum_prefix_teardown_delete(self, rbridge_id=None, af_ipv4_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.maximum_prefix.threshold_holder', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.maximum_prefix.threshold_holder', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.maximum_prefix.threshold_holder', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'teardown'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_maximum_prefix_threshold_delete(self, rbridge_id=None, af_ipv4_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.maximum_prefix.threshold_holder', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.maximum_prefix.threshold_holder', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.maximum_prefix.threshold_holder', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'threshold'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_maximum_prefix_threshold_holder_delete(self, rbridge_id=None, af_ipv4_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.maximum_prefix.threshold_holder', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.maximum_prefix.threshold_holder', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.maximum_prefix.threshold_holder', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'threshold, teardown'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_prefix_list_in_delete(self, rbridge_id=None, af_ipv4_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.prefix_list.direction_in', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.prefix_list.direction_in', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.prefix_list.direction_in', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'in'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_prefix_list_ip_access_number_delete(self, rbridge_id=None, af_ipv4_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.prefix_list.direction_in', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ip-access-number'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_prefix_list_ip_access_number_direction_out_delete(self, rbridge_id=None, af_ipv4_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.prefix_list.direction_out', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ip-access-number'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_prefix_list_out_delete(self, rbridge_id=None, af_ipv4_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.prefix_list.direction_out', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.prefix_list.direction_out', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.prefix_list.direction_out', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'out'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_prefix_list_prefix_list_direction_in_prefix_name_delete(self, rbridge_id=None, af_ipv4_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.prefix_list.direction_in', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.prefix_list.direction_in', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'prefix-list-direction-in-prefix-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_prefix_list_prefix_list_direction_out_prefix_name_delete(self, rbridge_id=None, af_ipv4_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.prefix_list.direction_out', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.prefix_list.direction_out', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'prefix-list-direction-out-prefix-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_route_map_in_neighbor_route_map_name_direction_in_delete(self, rbridge_id=None, af_ipv4_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.neighbor_route_map.neighbor_route_map_direction_in', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.neighbor_route_map.neighbor_route_map_direction_in', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.neighbor_route_map.neighbor_route_map_direction_in', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'neighbor-route-map-name-direction-in'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_route_map_out_neighbor_route_map_name_direction_out_delete(self, rbridge_id=None, af_ipv4_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.neighbor_route_map.neighbor_route_map_direction_out', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.neighbor_route_map.neighbor_route_map_direction_out', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.neighbor_route_map.neighbor_route_map_direction_out', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'neighbor-route-map-name-direction-out'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_route_reflector_client_delete(self, rbridge_id=None, af_ipv4_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv4_neighbor_address', 'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-reflector-client'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_send_community_both_delete(self, rbridge_id=None, af_ipv4_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.send_community', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.send_community', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.send_community', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'both'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_send_community_extended_delete(self, rbridge_id=None, af_ipv4_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.send_community', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.send_community', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.send_community', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'extended'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_send_community_send_community_status_delete(self, rbridge_id=None, af_ipv4_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.send_community', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.send_community', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.send_community', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'send-community-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_send_community_standard_delete(self, rbridge_id=None, af_ipv4_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.send_community', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.send_community', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.send_community', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'standard'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_unsuppress_map_map_name_delete(self, rbridge_id=None, af_ipv4_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.unsuppress_map', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.unsuppress_map', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.unsuppress_map', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'map-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_weight_delete(self, rbridge_id=None, af_ipv4_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv4_neighbor_address', 'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'weight'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_activate_delete(self, rbridge_id=None, af_ipv4_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv4_neighbor_peergroup', 'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'activate'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_additional_paths_advertise_all_delete(self, rbridge_id=None, af_ipv4_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.additional_paths.advertise', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.additional_paths.advertise', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'all'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_additional_paths_advertise_best_delete(self, rbridge_id=None, af_ipv4_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.additional_paths.advertise', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.additional_paths.advertise', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'best'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_allowas_in_delete(self, rbridge_id=None, af_ipv4_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv4_neighbor_peergroup', 'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'allowas-in'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_capability_additional_paths_add_path_both_delete(self, rbridge_id=None, af_ipv4_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.af_neighbor_capability.additional_paths', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.af_neighbor_capability.additional_paths', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'add-path-both'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_capability_additional_paths_receive_delete(self, rbridge_id=None, af_ipv4_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.af_neighbor_capability.additional_paths', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.af_neighbor_capability.additional_paths', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'receive'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_capability_additional_paths_send_delete(self, rbridge_id=None, af_ipv4_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.af_neighbor_capability.additional_paths', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.af_neighbor_capability.additional_paths', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'send'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_capability_orf_prefixlist_prefixlist_status_delete(self, rbridge_id=None, af_ipv4_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.af_neighbor_capability.orf.prefixlist', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.af_neighbor_capability.orf.prefixlist', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.af_neighbor_capability.orf.prefixlist', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'prefixlist-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_capability_orf_prefixlist_receive_delete(self, rbridge_id=None, af_ipv4_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.af_neighbor_capability.orf.prefixlist', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.af_neighbor_capability.orf.prefixlist', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.af_neighbor_capability.orf.prefixlist', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'receive'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_capability_orf_prefixlist_send_delete(self, rbridge_id=None, af_ipv4_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.af_neighbor_capability.orf.prefixlist', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.af_neighbor_capability.orf.prefixlist', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.af_neighbor_capability.orf.prefixlist', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'send'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_default_originate_default_originate_status_delete(self, rbridge_id=None, af_ipv4_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.default_originate', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.default_originate', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.default_originate', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'default-originate-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_default_originate_route_map_delete(self, rbridge_id=None, af_ipv4_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.default_originate', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.default_originate', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.default_originate', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_enable_peer_as_check_delete(self, rbridge_id=None, af_ipv4_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv4_neighbor_peergroup', 'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable-peer-as-check'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_holder_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_maximum_prefix_max_prefix_limit_delete(self, rbridge_id=None, af_ipv4_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.maximum_prefix', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.maximum_prefix', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.maximum_prefix', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'max-prefix-limit'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_maximum_prefix_teardown_delete(self, rbridge_id=None, af_ipv4_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.maximum_prefix.threshold_holder', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.maximum_prefix.threshold_holder', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.maximum_prefix.threshold_holder', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'teardown'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_maximum_prefix_threshold_delete(self, rbridge_id=None, af_ipv4_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.maximum_prefix.threshold_holder', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.maximum_prefix.threshold_holder', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.maximum_prefix.threshold_holder', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'threshold'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_maximum_prefix_threshold_holder_delete(self, rbridge_id=None, af_ipv4_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.maximum_prefix.threshold_holder', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.maximum_prefix.threshold_holder', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.maximum_prefix.threshold_holder', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'threshold, teardown'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_prefix_list_in_delete(self, rbridge_id=None, af_ipv4_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.prefix_list.direction_in', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.prefix_list.direction_in', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.prefix_list.direction_in', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'in'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_prefix_list_ip_access_number_delete(self, rbridge_id=None, af_ipv4_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.prefix_list.direction_in', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ip-access-number'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_prefix_list_ip_access_number_direction_out_delete(self, rbridge_id=None, af_ipv4_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.prefix_list.direction_out', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ip-access-number'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_prefix_list_out_delete(self, rbridge_id=None, af_ipv4_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.prefix_list.direction_out', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.prefix_list.direction_out', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.prefix_list.direction_out', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'out'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_prefix_list_prefix_list_direction_in_prefix_name_delete(self, rbridge_id=None, af_ipv4_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.prefix_list.direction_in', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.prefix_list.direction_in', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'prefix-list-direction-in-prefix-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_prefix_list_prefix_list_direction_out_prefix_name_delete(self, rbridge_id=None, af_ipv4_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.prefix_list.direction_out', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.prefix_list.direction_out', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'prefix-list-direction-out-prefix-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_route_map_in_neighbor_route_map_name_direction_in_delete(self, rbridge_id=None, af_ipv4_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.neighbor_route_map.neighbor_route_map_direction_in', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.neighbor_route_map.neighbor_route_map_direction_in', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.neighbor_route_map.neighbor_route_map_direction_in', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'neighbor-route-map-name-direction-in'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_route_map_out_neighbor_route_map_name_direction_out_delete(self, rbridge_id=None, af_ipv4_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.neighbor_route_map.neighbor_route_map_direction_out', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.neighbor_route_map.neighbor_route_map_direction_out', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.neighbor_route_map.neighbor_route_map_direction_out', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'neighbor-route-map-name-direction-out'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_route_reflector_client_delete(self, rbridge_id=None, af_ipv4_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv4_neighbor_peergroup', 'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-reflector-client'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_send_community_both_delete(self, rbridge_id=None, af_ipv4_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.send_community', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.send_community', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.send_community', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'both'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_send_community_extended_delete(self, rbridge_id=None, af_ipv4_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.send_community', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.send_community', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.send_community', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'extended'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_send_community_send_community_status_delete(self, rbridge_id=None, af_ipv4_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.send_community', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.send_community', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.send_community', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'send-community-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_send_community_standard_delete(self, rbridge_id=None, af_ipv4_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.send_community', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.send_community', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.send_community', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'standard'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_unsuppress_map_map_name_delete(self, rbridge_id=None, af_ipv4_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.unsuppress_map', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.unsuppress_map', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.unsuppress_map', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'map-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_weight_delete(self, rbridge_id=None, af_ipv4_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv4_neighbor_peergroup', 'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'weight'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_network_delete(self, rbridge_id=None, network=None, network_weight=None, backdoor=None, network_route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type network: network_ipv4_address
    :param network: Keyword argument tuple.

    :type network_ipv4_address: unicode
    :param network_ipv4_address: **network** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    **Instance Argument(s)**:

    :type network_weight: long
    :param network_weight: Set BGP weight for network

        * range restriction: ::

            ['0..4294967295']

    :type backdoor: YANGBool
    :param backdoor: Specify a BGP backdoor route

    :type network_route_map: unicode
    :param network_route_map: Route-map to modify the attributes

        * length restriction: ::

            ['1..63']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.network', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.network', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.network', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'network', 'keyval': 'network_ipv4_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, network=network, network_weight=network_weight, backdoor=backdoor, network_route_map=network_route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, network=network, network_weight=network_weight, backdoor=backdoor, network_route_map=network_route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_network_backdoor_delete(self, rbridge_id=None, network=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type network: network_ipv4_address
    :param network: Keyword argument tuple.

    :type network_ipv4_address: unicode
    :param network_ipv4_address: **network** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.network', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.network', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.network', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'network', 'keyval': 'network_ipv4_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'backdoor'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, network=network)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, network=network)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_network_route_map_delete(self, rbridge_id=None, network=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type network: network_ipv4_address
    :param network: Keyword argument tuple.

    :type network_ipv4_address: unicode
    :param network_ipv4_address: **network** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.network', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.network', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.network', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'network', 'keyval': 'network_ipv4_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, network=network)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, network=network)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_network_weight_delete(self, rbridge_id=None, network=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type network: network_ipv4_address
    :param network: Keyword argument tuple.

    :type network_ipv4_address: unicode
    :param network_ipv4_address: **network** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.network', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.network', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.network', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'network', 'keyval': 'network_ipv4_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'weight'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, network=network)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, network=network)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_next_hop_enable_default_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'next-hop-enable-default'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_next_hop_recursion_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'next-hop-recursion'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_redistribute_bgp_metric_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_redistribute_bgp_redistribute_bgp_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redistribute-bgp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_redistribute_bgp_route_map_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_redistribute_connected_metric_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_redistribute_connected_redistribute_connected_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redistribute-connected'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_redistribute_connected_route_map_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_redistribute_ospf_match_external1_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'external1'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_redistribute_ospf_match_external2_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'external2'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_redistribute_ospf_match_internal_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'internal'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_redistribute_ospf_metric_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_redistribute_ospf_redistribute_ospf_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redistribute-ospf'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_redistribute_ospf_route_map_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_redistribute_static_metric_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_redistribute_static_redistribute_static_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redistribute-static'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_redistribute_static_route_map_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_rib_route_limit_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rib-route-limit'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_static_network_delete(self, rbridge_id=None, static_network=None, static_network_distance=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type static_network: static_network_address
    :param static_network: Keyword argument tuple.

    :type static_network_address: unicode
    :param static_network_address: **static_network** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    **Instance Argument(s)**:

    :type static_network_distance: long
    :param static_network_distance: Define an administrative distance for this local network

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.static_network', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.static_network', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.static_network', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'static_network', 'keyval': 'static_network_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, static_network=static_network, static_network_distance=static_network_distance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, static_network=static_network, static_network_distance=static_network_distance)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_static_network_distance_delete(self, rbridge_id=None, static_network=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type static_network: static_network_address
    :param static_network: Keyword argument tuple.

    :type static_network_address: unicode
    :param static_network_address: **static_network** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.static_network', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.static_network', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.static_network', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'static_network', 'keyval': 'static_network_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'distance'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, static_network=static_network)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, static_network=static_network)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_table_map_route_map_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.table_map', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.table_map', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.table_map', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_update_time_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'update-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_delete(self, rbridge_id=None, af_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_vrf', 'keyval': 'af_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_aggregate_address_delete(self, rbridge_id=None, af_vrf=None, aggregate_address=None, advertise_map=None, as_set=None, attribute_map=None, summary_only=None, suppress_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type aggregate_address: aggregate_ip_prefix
    :param aggregate_address: Keyword argument tuple.

    :type aggregate_ip_prefix: unicode
    :param aggregate_ip_prefix: **aggregate_address** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    **Instance Argument(s)**:

    :type advertise_map: unicode
    :param advertise_map: Route map to control attribute advertisement

        * length restriction: ::

            ['1..63']

    :type as_set: YANGBool
    :param as_set: Generate AS set path information

    :type attribute_map: unicode
    :param attribute_map: Route map for parameter control

        * length restriction: ::

            ['1..63']

    :type summary_only: YANGBool
    :param summary_only: Filter more specific routes from updates

    :type suppress_map: unicode
    :param suppress_map: Conditionally filter more specific routes from updates

        * length restriction: ::

            ['1..63']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.aggregate_address', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.aggregate_address', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.aggregate_address', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'aggregate_address', 'keyval': 'aggregate_ip_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, aggregate_address=aggregate_address, advertise_map=advertise_map, as_set=as_set, attribute_map=attribute_map, summary_only=summary_only, suppress_map=suppress_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, aggregate_address=aggregate_address, advertise_map=advertise_map, as_set=as_set, attribute_map=attribute_map, summary_only=summary_only, suppress_map=suppress_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_aggregate_address_advertise_map_delete(self, rbridge_id=None, af_vrf=None, aggregate_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type aggregate_address: aggregate_ip_prefix
    :param aggregate_address: Keyword argument tuple.

    :type aggregate_ip_prefix: unicode
    :param aggregate_ip_prefix: **aggregate_address** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.aggregate_address', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.aggregate_address', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.aggregate_address', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'aggregate_address', 'keyval': 'aggregate_ip_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'advertise-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, aggregate_address=aggregate_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, aggregate_address=aggregate_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_aggregate_address_as_set_delete(self, rbridge_id=None, af_vrf=None, aggregate_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type aggregate_address: aggregate_ip_prefix
    :param aggregate_address: Keyword argument tuple.

    :type aggregate_ip_prefix: unicode
    :param aggregate_ip_prefix: **aggregate_address** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.aggregate_address', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.aggregate_address', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.aggregate_address', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'aggregate_address', 'keyval': 'aggregate_ip_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'as-set'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, aggregate_address=aggregate_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, aggregate_address=aggregate_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_aggregate_address_attribute_map_delete(self, rbridge_id=None, af_vrf=None, aggregate_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type aggregate_address: aggregate_ip_prefix
    :param aggregate_address: Keyword argument tuple.

    :type aggregate_ip_prefix: unicode
    :param aggregate_ip_prefix: **aggregate_address** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.aggregate_address', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.aggregate_address', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.aggregate_address', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'aggregate_address', 'keyval': 'aggregate_ip_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'attribute-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, aggregate_address=aggregate_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, aggregate_address=aggregate_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_aggregate_address_summary_only_delete(self, rbridge_id=None, af_vrf=None, aggregate_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type aggregate_address: aggregate_ip_prefix
    :param aggregate_address: Keyword argument tuple.

    :type aggregate_ip_prefix: unicode
    :param aggregate_ip_prefix: **aggregate_address** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.aggregate_address', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.aggregate_address', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.aggregate_address', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'aggregate_address', 'keyval': 'aggregate_ip_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'summary-only'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, aggregate_address=aggregate_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, aggregate_address=aggregate_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_aggregate_address_suppress_map_delete(self, rbridge_id=None, af_vrf=None, aggregate_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type aggregate_address: aggregate_ip_prefix
    :param aggregate_address: Keyword argument tuple.

    :type aggregate_ip_prefix: unicode
    :param aggregate_ip_prefix: **aggregate_address** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.aggregate_address', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.aggregate_address', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.aggregate_address', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'aggregate_address', 'keyval': 'aggregate_ip_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'suppress-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, aggregate_address=aggregate_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, aggregate_address=aggregate_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_always_propagate_delete(self, rbridge_id=None, af_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_vrf', 'keyval': 'af_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'always-propagate'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_bgp_redistribute_internal_delete(self, rbridge_id=None, af_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bgp-redistribute-internal'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_client_to_client_reflection_delete(self, rbridge_id=None, af_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_vrf', 'keyval': 'af_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'client-to-client-reflection'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_dampening_delete(self, rbridge_id=None, af_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening': [u'dampening_flag', u'values', u'dampening_route_map'], 'pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening': [u'dampening_flag', u'values', u'dampening_route_map']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_dampening_dampening_flag_delete(self, rbridge_id=None, af_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dampening-flag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_dampening_route_map_delete(self, rbridge_id=None, af_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_dampening_values_delete(self, rbridge_id=None, af_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening.values', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening.values', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening.values', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening.values': [u'half_time'], 'pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening.values': [u'half_time'], 'pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening.values': [u'half_time']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_default_information_originate_delete(self, rbridge_id=None, af_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_vrf', 'keyval': 'af_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'default-information-originate'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_default_metric_delete(self, rbridge_id=None, af_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_vrf', 'keyval': 'af_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'default-metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_graceful_restart_delete(self, rbridge_id=None, af_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_vrf', 'keyval': 'af_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'graceful-restart'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_listen_range_delete(self, rbridge_id=None, af_vrf=None, listen_range=None, limit=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type listen_range: listen_range_prefix, peer_group, limit
    :param listen_range: Keyword argument tuple.

    :type listen_range_prefix: unicode
    :param listen_range_prefix: **listen_range** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type peer_group: unicode
    :param peer_group: **listen_range** tuple argument:  Peer group name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type limit: long
    :param limit: **listen_range** tuple argument:  Limit the neighbor

        * range restriction: ::

            ['0..4294967295']

    **Instance Argument(s)**:

    :type limit: long
    :param limit: Limit the neighbor

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.listen_range', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'listen_range', 'keyval': 'listen_range_prefix, peer_group', 'extra_keyval': 'listen_range_prefix, peer_group, limit'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, listen_range=listen_range, limit=limit)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, listen_range=listen_range, limit=limit)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_listen_range_limit_delete(self, rbridge_id=None, af_vrf=None, listen_range=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type listen_range: listen_range_prefix, peer_group
    :param listen_range: Keyword argument tuple.

    :type listen_range_prefix: unicode
    :param listen_range_prefix: **listen_range** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type peer_group: unicode
    :param peer_group: **listen_range** tuple argument:  Peer group name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.listen_range', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'listen_range', 'keyval': 'listen_range_prefix, peer_group', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'limit'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, listen_range=listen_range)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, listen_range=listen_range)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_local_as_delete(self, rbridge_id=None, af_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_vrf', 'keyval': 'af_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'local-as'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_maxas_limit_in_num_as_in_path_delete(self, rbridge_id=None, af_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maxas_limit.in_', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maxas_limit.in_', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maxas_limit.in_', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'num-as-in-path'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_maximum_paths_ebgp_delete(self, rbridge_id=None, af_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maximum_paths', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maximum_paths', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maximum_paths', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ebgp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_maximum_paths_ibgp_delete(self, rbridge_id=None, af_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maximum_paths', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maximum_paths', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maximum_paths', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ibgp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_maximum_paths_load_sharing_value_delete(self, rbridge_id=None, af_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maximum_paths', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maximum_paths', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maximum_paths', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'load-sharing-value'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_maximum_paths_use_load_sharing_delete(self, rbridge_id=None, af_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maximum_paths', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maximum_paths', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maximum_paths', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'use-load-sharing'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_multipath_ebgp_delete(self, rbridge_id=None, af_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.multipath', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.multipath', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.multipath', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ebgp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_multipath_ibgp_delete(self, rbridge_id=None, af_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.multipath', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.multipath', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.multipath', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ibgp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_multipath_multi_as_delete(self, rbridge_id=None, af_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.multipath', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.multipath', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.multipath', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'multi-as'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_delete(self, rbridge_id=None, af_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_activate_delete(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv4_neighbor_addr', 'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'activate'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_additional_paths_advertise_all_delete(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths.advertise', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths.advertise', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'all'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_additional_paths_advertise_best_delete(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths.advertise', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths.advertise', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'best'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_advertisement_interval_delete(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.advertisement_interval', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.advertisement_interval', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.advertisement_interval', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'value'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_advertisement_interval_value_delete(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.advertisement_interval', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.advertisement_interval', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.advertisement_interval', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'value'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_allowas_in_delete(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv4_neighbor_addr', 'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'allowas-in'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_as_override_delete(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv4_neighbor_addr', 'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'as-override'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_bfd_bfd_enable_delete(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bfd-enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_bfd_holdover_interval_delete(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'holdover-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_bfd_interval_delete(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd.interval', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd.interval', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd.interval', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_bfd_interval_min_rx_delete(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd.interval', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd.interval', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd.interval', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'min-rx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_bfd_interval_min_tx_delete(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd.interval', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd.interval', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd.interval', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'min-tx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_bfd_interval_multiplier_delete(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd.interval', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd.interval', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd.interval', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'multiplier'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_capability_additional_paths_add_path_both_delete(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.additional_paths', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.additional_paths', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'add-path-both'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_capability_additional_paths_receive_delete(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.additional_paths', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.additional_paths', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'receive'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_capability_additional_paths_send_delete(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.additional_paths', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.additional_paths', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'send'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_capability_as4_disable_delete(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.as4', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.as4', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.as4', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'disable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_capability_as4_enable_delete(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.as4', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.as4', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.as4', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_capability_orf_prefixlist_prefixlist_status_delete(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.orf.prefixlist', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.orf.prefixlist', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.orf.prefixlist', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'prefixlist-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_capability_orf_prefixlist_receive_delete(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.orf.prefixlist', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.orf.prefixlist', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.orf.prefixlist', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'receive'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_capability_orf_prefixlist_send_delete(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.orf.prefixlist', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.orf.prefixlist', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.orf.prefixlist', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'send'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_default_originate_default_originate_status_delete(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.default_originate', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.default_originate', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.default_originate', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'default-originate-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_default_originate_route_map_delete(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.default_originate', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.default_originate', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.default_originate', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_description_delete(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv4_neighbor_addr', 'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'description'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_ebgp_btsh_delete(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv4_neighbor_addr', 'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ebgp-btsh'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_ebgp_multihop_delete(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.ebgp_multihop', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.ebgp_multihop', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.ebgp_multihop': [u'ebgp_multihop_flag', u'ebgp_multihop_count'], 'pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.ebgp_multihop': [u'ebgp_multihop_flag', u'ebgp_multihop_count']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_ebgp_multihop_ebgp_multihop_count_delete(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.ebgp_multihop', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.ebgp_multihop', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.ebgp_multihop', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ebgp-multihop-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_ebgp_multihop_ebgp_multihop_flag_delete(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.ebgp_multihop', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.ebgp_multihop', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.ebgp_multihop', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ebgp-multihop-flag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_enable_peer_as_check_delete(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv4_neighbor_addr', 'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable-peer-as-check'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_enforce_first_as_disable_delete(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.enforce_first_as', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.enforce_first_as', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.enforce_first_as', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'disable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_enforce_first_as_enable_delete(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.enforce_first_as', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.enforce_first_as', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.enforce_first_as', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_local_as_delete(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.local_as', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.local_as', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.local_as', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'local_as_value, no_prepend'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_local_as_local_as_value_delete(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.local_as', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.local_as', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.local_as', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'local-as-value'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_local_as_no_prepend_delete(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.local_as', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.local_as', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.local_as', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'no-prepend'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_maxas_limit_in_disable_delete(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maxas_limit.in_', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maxas_limit.in_', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maxas_limit.in_', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'disable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_maxas_limit_in_num_as_in_as_path_delete(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maxas_limit.in_', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maxas_limit.in_', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maxas_limit.in_', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'num-as-in-as-path'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_maximum_prefix_max_prefix_limit_delete(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'max-prefix-limit'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_maximum_prefix_teardown_delete(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix.threshold_holder', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix.threshold_holder', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix.threshold_holder', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'teardown'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_maximum_prefix_threshold_delete(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix.threshold_holder', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix.threshold_holder', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix.threshold_holder', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'threshold'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_maximum_prefix_threshold_holder_delete(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix.threshold_holder', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix.threshold_holder', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix.threshold_holder', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'threshold, teardown'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_next_hop_self_always_delete(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.next_hop_self', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.next_hop_self', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.next_hop_self', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'always'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_next_hop_self_next_hop_self_status_delete(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.next_hop_self', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.next_hop_self', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.next_hop_self', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'next-hop-self-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_password_delete(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv4_neighbor_addr', 'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'password'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_peer_group_delete(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv4_neighbor_addr', 'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'peer-group'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_prefix_list_in_delete(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list.direction_in', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list.direction_in', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list.direction_in', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'in'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_prefix_list_ip_access_number_delete(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list.direction_in', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ip-access-number'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_prefix_list_ip_access_number_direction_out_delete(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list.direction_out', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ip-access-number'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_prefix_list_out_delete(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list.direction_out', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list.direction_out', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list.direction_out', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'out'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_prefix_list_prefix_list_direction_in_prefix_name_delete(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list.direction_in', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list.direction_in', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'prefix-list-direction-in-prefix-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_prefix_list_prefix_list_direction_out_prefix_name_delete(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list.direction_out', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list.direction_out', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'prefix-list-direction-out-prefix-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_remote_as_delete(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv4_neighbor_addr', 'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'remote-as'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_remove_private_as_delete(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv4_neighbor_addr', 'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'remove-private-as'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_route_map_in_neighbor_route_map_name_direction_in_delete(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map.neighbor_route_map_direction_in', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map.neighbor_route_map_direction_in', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map.neighbor_route_map_direction_in', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'neighbor-route-map-name-direction-in'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_route_map_out_neighbor_route_map_name_direction_out_delete(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map.neighbor_route_map_direction_out', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map.neighbor_route_map_direction_out', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map.neighbor_route_map_direction_out', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'neighbor-route-map-name-direction-out'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_route_reflector_client_delete(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv4_neighbor_addr', 'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-reflector-client'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_send_community_both_delete(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.send_community', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.send_community', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.send_community', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'both'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_send_community_extended_delete(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.send_community', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.send_community', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.send_community', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'extended'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_send_community_send_community_status_delete(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.send_community', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.send_community', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.send_community', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'send-community-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_send_community_standard_delete(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.send_community', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.send_community', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.send_community', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'standard'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_shutdown_generate_rib_out_delete(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.shutdown', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.shutdown', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.shutdown', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'generate-rib-out'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_shutdown_shutdown_status_delete(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.shutdown', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.shutdown', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.shutdown', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'shutdown-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_soft_reconfiguration_inbound_delete(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.soft_reconfiguration', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.soft_reconfiguration', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.soft_reconfiguration', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'inbound'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_static_network_edge_delete(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv4_neighbor_addr', 'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'static-network-edge'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_timers_hold_time_delete(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.timers', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.timers', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.timers', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hold-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_timers_keep_alive_delete(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.timers', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.timers', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.timers', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'keep-alive'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_unsuppress_map_map_name_delete(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.unsuppress_map', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.unsuppress_map', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.unsuppress_map', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'map-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_update_source_ethernet_delete(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source.ethernet_interface', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source.ethernet_interface', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source.ethernet_interface', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ethernet'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_update_source_ethernet_interface_delete(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source.ethernet_interface', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source.ethernet_interface', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source.ethernet_interface', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'interface_type, ethernet'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source.ethernet_interface': [u'interface_type'], 'pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source.ethernet_interface': [u'interface_type'], 'pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source.ethernet_interface': [u'interface_type']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_update_source_interface_type_delete(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source.ethernet_interface', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source.ethernet_interface', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source.ethernet_interface', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'interface-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_update_source_loopback_delete(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'loopback'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_update_source_port_channel_delete(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'port-channel'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_update_source_sip_ipv4_address_delete(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'sip-ipv4-address'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_update_source_ve_interface_delete(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 've-interface'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_weight_delete(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv4_neighbor_addr', 'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'weight'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_vrf_neighbor_address_holder_delete(self, rbridge_id=None, af_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_network_delete(self, rbridge_id=None, af_vrf=None, network=None, network_weight=None, backdoor=None, network_route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type network: network_ipv4_address
    :param network: Keyword argument tuple.

    :type network_ipv4_address: unicode
    :param network_ipv4_address: **network** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    **Instance Argument(s)**:

    :type network_weight: long
    :param network_weight: Set BGP weight for network

        * range restriction: ::

            ['0..4294967295']

    :type backdoor: YANGBool
    :param backdoor: Specify a BGP backdoor route

    :type network_route_map: unicode
    :param network_route_map: Route-map to modify the attributes

        * length restriction: ::

            ['1..63']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.network', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.network', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.network', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'network', 'keyval': 'network_ipv4_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, network=network, network_weight=network_weight, backdoor=backdoor, network_route_map=network_route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, network=network, network_weight=network_weight, backdoor=backdoor, network_route_map=network_route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_network_backdoor_delete(self, rbridge_id=None, af_vrf=None, network=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type network: network_ipv4_address
    :param network: Keyword argument tuple.

    :type network_ipv4_address: unicode
    :param network_ipv4_address: **network** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.network', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.network', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.network', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'network', 'keyval': 'network_ipv4_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'backdoor'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, network=network)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, network=network)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_network_route_map_delete(self, rbridge_id=None, af_vrf=None, network=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type network: network_ipv4_address
    :param network: Keyword argument tuple.

    :type network_ipv4_address: unicode
    :param network_ipv4_address: **network** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.network', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.network', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.network', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'network', 'keyval': 'network_ipv4_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, network=network)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, network=network)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_network_weight_delete(self, rbridge_id=None, af_vrf=None, network=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type network: network_ipv4_address
    :param network: Keyword argument tuple.

    :type network_ipv4_address: unicode
    :param network_ipv4_address: **network** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.network', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.network', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.network', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'network', 'keyval': 'network_ipv4_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'weight'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, network=network)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, network=network)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_next_hop_enable_default_delete(self, rbridge_id=None, af_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_vrf', 'keyval': 'af_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'next-hop-enable-default'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_next_hop_recursion_delete(self, rbridge_id=None, af_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_vrf', 'keyval': 'af_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'next-hop-recursion'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_redistribute_bgp_metric_delete(self, rbridge_id=None, af_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_redistribute_bgp_redistribute_bgp_delete(self, rbridge_id=None, af_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redistribute-bgp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_redistribute_bgp_route_map_delete(self, rbridge_id=None, af_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_redistribute_connected_metric_delete(self, rbridge_id=None, af_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_redistribute_connected_redistribute_connected_delete(self, rbridge_id=None, af_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redistribute-connected'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_redistribute_connected_route_map_delete(self, rbridge_id=None, af_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_redistribute_ospf_match_external1_delete(self, rbridge_id=None, af_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'external1'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_redistribute_ospf_match_external2_delete(self, rbridge_id=None, af_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'external2'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_redistribute_ospf_match_internal_delete(self, rbridge_id=None, af_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'internal'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_redistribute_ospf_metric_delete(self, rbridge_id=None, af_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_redistribute_ospf_redistribute_ospf_delete(self, rbridge_id=None, af_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redistribute-ospf'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_redistribute_ospf_route_map_delete(self, rbridge_id=None, af_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_redistribute_static_metric_delete(self, rbridge_id=None, af_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_redistribute_static_redistribute_static_delete(self, rbridge_id=None, af_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redistribute-static'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_redistribute_static_route_map_delete(self, rbridge_id=None, af_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_rib_route_limit_delete(self, rbridge_id=None, af_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_vrf', 'keyval': 'af_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rib-route-limit'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_static_network_delete(self, rbridge_id=None, af_vrf=None, static_network=None, static_network_distance=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type static_network: static_network_address
    :param static_network: Keyword argument tuple.

    :type static_network_address: unicode
    :param static_network_address: **static_network** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    **Instance Argument(s)**:

    :type static_network_distance: long
    :param static_network_distance: Define an administrative distance for this local network

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.static_network', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.static_network', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.static_network', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'static_network', 'keyval': 'static_network_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, static_network=static_network, static_network_distance=static_network_distance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, static_network=static_network, static_network_distance=static_network_distance)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_static_network_distance_delete(self, rbridge_id=None, af_vrf=None, static_network=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type static_network: static_network_address
    :param static_network: Keyword argument tuple.

    :type static_network_address: unicode
    :param static_network_address: **static_network** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.static_network', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.static_network', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.static_network', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'static_network', 'keyval': 'static_network_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'distance'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, static_network=static_network)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, static_network=static_network)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_table_map_route_map_delete(self, rbridge_id=None, af_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.table_map', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.table_map', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.table_map', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_update_time_delete(self, rbridge_id=None, af_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_vrf', 'keyval': 'af_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'update-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_af_common_cmds_holder_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_af_ipv6_uc_and_vrf_cmds_call_point_holder_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_aggregate_address_delete(self, rbridge_id=None, aggregate_ipv6_address=None, advertise_map=None, as_set=None, attribute_map=None, summary_only=None, suppress_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type aggregate_ipv6_address: aggregate_ip_prefix
    :param aggregate_ipv6_address: Keyword argument tuple.

    :type aggregate_ip_prefix: unicode
    :param aggregate_ip_prefix: **aggregate_ipv6_address** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    **Instance Argument(s)**:

    :type advertise_map: unicode
    :param advertise_map: Route map to control attribute advertisement

        * length restriction: ::

            ['1..63']

    :type as_set: YANGBool
    :param as_set: Generate AS set path information

    :type attribute_map: unicode
    :param attribute_map: Route map for parameter control

        * length restriction: ::

            ['1..63']

    :type summary_only: YANGBool
    :param summary_only: Filter more specific routes from updates

    :type suppress_map: unicode
    :param suppress_map: Conditionally filter more specific routes from updates

        * length restriction: ::

            ['1..63']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.aggregate_ipv6_address', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.aggregate_ipv6_address', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.aggregate_ipv6_address', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'aggregate_ipv6_address', 'keyval': 'aggregate_ip_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, aggregate_ipv6_address=aggregate_ipv6_address, advertise_map=advertise_map, as_set=as_set, attribute_map=attribute_map, summary_only=summary_only, suppress_map=suppress_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, aggregate_ipv6_address=aggregate_ipv6_address, advertise_map=advertise_map, as_set=as_set, attribute_map=attribute_map, summary_only=summary_only, suppress_map=suppress_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_aggregate_address_advertise_map_delete(self, rbridge_id=None, aggregate_ipv6_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type aggregate_ipv6_address: aggregate_ip_prefix
    :param aggregate_ipv6_address: Keyword argument tuple.

    :type aggregate_ip_prefix: unicode
    :param aggregate_ip_prefix: **aggregate_ipv6_address** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.aggregate_ipv6_address', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.aggregate_ipv6_address', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.aggregate_ipv6_address', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'aggregate_ipv6_address', 'keyval': 'aggregate_ip_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'advertise-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, aggregate_ipv6_address=aggregate_ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, aggregate_ipv6_address=aggregate_ipv6_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_aggregate_address_as_set_delete(self, rbridge_id=None, aggregate_ipv6_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type aggregate_ipv6_address: aggregate_ip_prefix
    :param aggregate_ipv6_address: Keyword argument tuple.

    :type aggregate_ip_prefix: unicode
    :param aggregate_ip_prefix: **aggregate_ipv6_address** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.aggregate_ipv6_address', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.aggregate_ipv6_address', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.aggregate_ipv6_address', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'aggregate_ipv6_address', 'keyval': 'aggregate_ip_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'as-set'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, aggregate_ipv6_address=aggregate_ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, aggregate_ipv6_address=aggregate_ipv6_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_aggregate_address_attribute_map_delete(self, rbridge_id=None, aggregate_ipv6_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type aggregate_ipv6_address: aggregate_ip_prefix
    :param aggregate_ipv6_address: Keyword argument tuple.

    :type aggregate_ip_prefix: unicode
    :param aggregate_ip_prefix: **aggregate_ipv6_address** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.aggregate_ipv6_address', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.aggregate_ipv6_address', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.aggregate_ipv6_address', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'aggregate_ipv6_address', 'keyval': 'aggregate_ip_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'attribute-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, aggregate_ipv6_address=aggregate_ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, aggregate_ipv6_address=aggregate_ipv6_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_aggregate_address_summary_only_delete(self, rbridge_id=None, aggregate_ipv6_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type aggregate_ipv6_address: aggregate_ip_prefix
    :param aggregate_ipv6_address: Keyword argument tuple.

    :type aggregate_ip_prefix: unicode
    :param aggregate_ip_prefix: **aggregate_ipv6_address** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.aggregate_ipv6_address', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.aggregate_ipv6_address', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.aggregate_ipv6_address', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'aggregate_ipv6_address', 'keyval': 'aggregate_ip_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'summary-only'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, aggregate_ipv6_address=aggregate_ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, aggregate_ipv6_address=aggregate_ipv6_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_aggregate_address_suppress_map_delete(self, rbridge_id=None, aggregate_ipv6_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type aggregate_ipv6_address: aggregate_ip_prefix
    :param aggregate_ipv6_address: Keyword argument tuple.

    :type aggregate_ip_prefix: unicode
    :param aggregate_ip_prefix: **aggregate_ipv6_address** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.aggregate_ipv6_address', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.aggregate_ipv6_address', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.aggregate_ipv6_address', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'aggregate_ipv6_address', 'keyval': 'aggregate_ip_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'suppress-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, aggregate_ipv6_address=aggregate_ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, aggregate_ipv6_address=aggregate_ipv6_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_always_propagate_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'always-propagate'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_bgp_redistribute_internal_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bgp-redistribute-internal'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_client_to_client_reflection_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'client-to-client-reflection'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_dampening_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening': [u'dampening_flag', u'values', u'dampening_route_map'], 'pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening': [u'dampening_flag', u'values', u'dampening_route_map']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_dampening_dampening_flag_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dampening-flag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_dampening_route_map_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_dampening_values_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening.values', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening.values', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening.values', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening.values': [u'half_time'], 'pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening.values': [u'half_time'], 'pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening.values': [u'half_time']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_default_information_originate_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'default-information-originate'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_default_metric_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'default-metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_default_vrf_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_default_vrf_selected_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'default-vrf-selected'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_graceful_restart_graceful_restart_status_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.graceful_restart', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.graceful_restart', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.graceful_restart', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'graceful-restart-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_graceful_restart_purge_time_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.graceful_restart', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.graceful_restart', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.graceful_restart', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'purge-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_graceful_restart_restart_time_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.graceful_restart', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.graceful_restart', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.graceful_restart', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'restart-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_graceful_restart_stale_routes_time_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.graceful_restart', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.graceful_restart', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.graceful_restart', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'stale-routes-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_maximum_paths_ebgp_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.maximum_paths', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.maximum_paths', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.maximum_paths', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ebgp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_maximum_paths_ibgp_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.maximum_paths', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.maximum_paths', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.maximum_paths', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ibgp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_maximum_paths_load_sharing_value_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.maximum_paths', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.maximum_paths', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.maximum_paths', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'load-sharing-value'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_maximum_paths_use_load_sharing_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.maximum_paths', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.maximum_paths', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.maximum_paths', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'use-load-sharing'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_multipath_ebgp_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.multipath', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.multipath', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.multipath', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ebgp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_multipath_ibgp_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.multipath', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.multipath', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.multipath', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ibgp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_multipath_multi_as_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.multipath', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.multipath', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.multipath', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'multi-as'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_activate_delete(self, rbridge_id=None, af_ipv6_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_neighbor_address', 'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'activate'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_additional_paths_advertise_all_delete(self, rbridge_id=None, af_ipv6_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.additional_paths.advertise', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.additional_paths.advertise', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'all'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_additional_paths_advertise_best_delete(self, rbridge_id=None, af_ipv6_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.additional_paths.advertise', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.additional_paths.advertise', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'best'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_allowas_in_delete(self, rbridge_id=None, af_ipv6_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_neighbor_address', 'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'allowas-in'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_capability_additional_paths_add_path_both_delete(self, rbridge_id=None, af_ipv6_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.af_neighbor_capability.additional_paths', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.af_neighbor_capability.additional_paths', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'add-path-both'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_capability_additional_paths_receive_delete(self, rbridge_id=None, af_ipv6_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.af_neighbor_capability.additional_paths', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.af_neighbor_capability.additional_paths', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'receive'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_capability_additional_paths_send_delete(self, rbridge_id=None, af_ipv6_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.af_neighbor_capability.additional_paths', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.af_neighbor_capability.additional_paths', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'send'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_capability_orf_prefixlist_prefixlist_status_delete(self, rbridge_id=None, af_ipv6_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.af_neighbor_capability.orf.prefixlist', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.af_neighbor_capability.orf.prefixlist', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.af_neighbor_capability.orf.prefixlist', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'prefixlist-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_capability_orf_prefixlist_receive_delete(self, rbridge_id=None, af_ipv6_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.af_neighbor_capability.orf.prefixlist', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.af_neighbor_capability.orf.prefixlist', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.af_neighbor_capability.orf.prefixlist', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'receive'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_capability_orf_prefixlist_send_delete(self, rbridge_id=None, af_ipv6_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.af_neighbor_capability.orf.prefixlist', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.af_neighbor_capability.orf.prefixlist', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.af_neighbor_capability.orf.prefixlist', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'send'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_default_originate_default_originate_status_delete(self, rbridge_id=None, af_ipv6_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.default_originate', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.default_originate', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.default_originate', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'default-originate-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_default_originate_route_map_delete(self, rbridge_id=None, af_ipv6_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.default_originate', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.default_originate', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.default_originate', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_enable_peer_as_check_delete(self, rbridge_id=None, af_ipv6_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_neighbor_address', 'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable-peer-as-check'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_holder_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_maximum_prefix_max_prefix_limit_delete(self, rbridge_id=None, af_ipv6_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.maximum_prefix', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.maximum_prefix', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.maximum_prefix', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'max-prefix-limit'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_maximum_prefix_teardown_delete(self, rbridge_id=None, af_ipv6_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.maximum_prefix.threshold_holder', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.maximum_prefix.threshold_holder', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.maximum_prefix.threshold_holder', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'teardown'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_maximum_prefix_threshold_delete(self, rbridge_id=None, af_ipv6_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.maximum_prefix.threshold_holder', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.maximum_prefix.threshold_holder', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.maximum_prefix.threshold_holder', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'threshold'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_maximum_prefix_threshold_holder_delete(self, rbridge_id=None, af_ipv6_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.maximum_prefix.threshold_holder', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.maximum_prefix.threshold_holder', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.maximum_prefix.threshold_holder', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'threshold, teardown'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_prefix_list_in_delete(self, rbridge_id=None, af_ipv6_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.prefix_list.direction_in', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.prefix_list.direction_in', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.prefix_list.direction_in', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'in'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_prefix_list_ip_access_number_delete(self, rbridge_id=None, af_ipv6_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.prefix_list.direction_in', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ip-access-number'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_prefix_list_ip_access_number_direction_out_delete(self, rbridge_id=None, af_ipv6_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.prefix_list.direction_out', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ip-access-number'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_prefix_list_out_delete(self, rbridge_id=None, af_ipv6_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.prefix_list.direction_out', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.prefix_list.direction_out', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.prefix_list.direction_out', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'out'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_prefix_list_prefix_list_direction_in_prefix_name_delete(self, rbridge_id=None, af_ipv6_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.prefix_list.direction_in', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.prefix_list.direction_in', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'prefix-list-direction-in-prefix-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_prefix_list_prefix_list_direction_out_prefix_name_delete(self, rbridge_id=None, af_ipv6_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.prefix_list.direction_out', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.prefix_list.direction_out', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'prefix-list-direction-out-prefix-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_route_map_in_neighbor_route_map_name_direction_in_delete(self, rbridge_id=None, af_ipv6_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.neighbor_route_map.neighbor_route_map_direction_in', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.neighbor_route_map.neighbor_route_map_direction_in', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.neighbor_route_map.neighbor_route_map_direction_in', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'neighbor-route-map-name-direction-in'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_route_map_out_neighbor_route_map_name_direction_out_delete(self, rbridge_id=None, af_ipv6_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.neighbor_route_map.neighbor_route_map_direction_out', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.neighbor_route_map.neighbor_route_map_direction_out', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.neighbor_route_map.neighbor_route_map_direction_out', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'neighbor-route-map-name-direction-out'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_route_reflector_client_delete(self, rbridge_id=None, af_ipv6_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_neighbor_address', 'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-reflector-client'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_send_community_both_delete(self, rbridge_id=None, af_ipv6_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.send_community', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.send_community', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.send_community', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'both'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_send_community_extended_delete(self, rbridge_id=None, af_ipv6_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.send_community', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.send_community', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.send_community', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'extended'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_send_community_send_community_status_delete(self, rbridge_id=None, af_ipv6_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.send_community', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.send_community', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.send_community', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'send-community-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_send_community_standard_delete(self, rbridge_id=None, af_ipv6_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.send_community', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.send_community', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.send_community', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'standard'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_unsuppress_map_map_name_delete(self, rbridge_id=None, af_ipv6_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.unsuppress_map', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.unsuppress_map', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.unsuppress_map', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'map-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_weight_delete(self, rbridge_id=None, af_ipv6_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_neighbor_address', 'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'weight'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_activate_delete(self, rbridge_id=None, af_ipv6_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_neighbor_peergroup', 'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'activate'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_additional_paths_advertise_all_delete(self, rbridge_id=None, af_ipv6_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.additional_paths.advertise', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.additional_paths.advertise', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'all'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_additional_paths_advertise_best_delete(self, rbridge_id=None, af_ipv6_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.additional_paths.advertise', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.additional_paths.advertise', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'best'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_allowas_in_delete(self, rbridge_id=None, af_ipv6_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_neighbor_peergroup', 'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'allowas-in'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_capability_additional_paths_add_path_both_delete(self, rbridge_id=None, af_ipv6_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.af_neighbor_capability.additional_paths', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.af_neighbor_capability.additional_paths', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'add-path-both'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_capability_additional_paths_receive_delete(self, rbridge_id=None, af_ipv6_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.af_neighbor_capability.additional_paths', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.af_neighbor_capability.additional_paths', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'receive'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_capability_additional_paths_send_delete(self, rbridge_id=None, af_ipv6_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.af_neighbor_capability.additional_paths', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.af_neighbor_capability.additional_paths', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'send'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_capability_orf_prefixlist_prefixlist_status_delete(self, rbridge_id=None, af_ipv6_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.af_neighbor_capability.orf.prefixlist', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.af_neighbor_capability.orf.prefixlist', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.af_neighbor_capability.orf.prefixlist', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'prefixlist-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_capability_orf_prefixlist_receive_delete(self, rbridge_id=None, af_ipv6_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.af_neighbor_capability.orf.prefixlist', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.af_neighbor_capability.orf.prefixlist', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.af_neighbor_capability.orf.prefixlist', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'receive'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_capability_orf_prefixlist_send_delete(self, rbridge_id=None, af_ipv6_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.af_neighbor_capability.orf.prefixlist', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.af_neighbor_capability.orf.prefixlist', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.af_neighbor_capability.orf.prefixlist', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'send'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_default_originate_default_originate_status_delete(self, rbridge_id=None, af_ipv6_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.default_originate', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.default_originate', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.default_originate', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'default-originate-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_default_originate_route_map_delete(self, rbridge_id=None, af_ipv6_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.default_originate', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.default_originate', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.default_originate', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_enable_peer_as_check_delete(self, rbridge_id=None, af_ipv6_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_neighbor_peergroup', 'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable-peer-as-check'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_holder_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_maximum_prefix_max_prefix_limit_delete(self, rbridge_id=None, af_ipv6_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.maximum_prefix', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.maximum_prefix', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.maximum_prefix', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'max-prefix-limit'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_maximum_prefix_teardown_delete(self, rbridge_id=None, af_ipv6_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.maximum_prefix.threshold_holder', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.maximum_prefix.threshold_holder', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.maximum_prefix.threshold_holder', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'teardown'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_maximum_prefix_threshold_delete(self, rbridge_id=None, af_ipv6_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.maximum_prefix.threshold_holder', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.maximum_prefix.threshold_holder', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.maximum_prefix.threshold_holder', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'threshold'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_maximum_prefix_threshold_holder_delete(self, rbridge_id=None, af_ipv6_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.maximum_prefix.threshold_holder', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.maximum_prefix.threshold_holder', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.maximum_prefix.threshold_holder', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'threshold, teardown'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_prefix_list_in_delete(self, rbridge_id=None, af_ipv6_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.prefix_list.direction_in', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.prefix_list.direction_in', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.prefix_list.direction_in', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'in'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_prefix_list_ip_access_number_delete(self, rbridge_id=None, af_ipv6_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.prefix_list.direction_in', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ip-access-number'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_prefix_list_ip_access_number_direction_out_delete(self, rbridge_id=None, af_ipv6_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.prefix_list.direction_out', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ip-access-number'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_prefix_list_out_delete(self, rbridge_id=None, af_ipv6_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.prefix_list.direction_out', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.prefix_list.direction_out', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.prefix_list.direction_out', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'out'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_prefix_list_prefix_list_direction_in_prefix_name_delete(self, rbridge_id=None, af_ipv6_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.prefix_list.direction_in', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.prefix_list.direction_in', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'prefix-list-direction-in-prefix-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_prefix_list_prefix_list_direction_out_prefix_name_delete(self, rbridge_id=None, af_ipv6_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.prefix_list.direction_out', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.prefix_list.direction_out', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'prefix-list-direction-out-prefix-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_route_map_in_neighbor_route_map_name_direction_in_delete(self, rbridge_id=None, af_ipv6_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.neighbor_route_map.neighbor_route_map_direction_in', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.neighbor_route_map.neighbor_route_map_direction_in', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.neighbor_route_map.neighbor_route_map_direction_in', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'neighbor-route-map-name-direction-in'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_route_map_out_neighbor_route_map_name_direction_out_delete(self, rbridge_id=None, af_ipv6_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.neighbor_route_map.neighbor_route_map_direction_out', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.neighbor_route_map.neighbor_route_map_direction_out', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.neighbor_route_map.neighbor_route_map_direction_out', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'neighbor-route-map-name-direction-out'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_route_reflector_client_delete(self, rbridge_id=None, af_ipv6_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_neighbor_peergroup', 'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-reflector-client'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_send_community_both_delete(self, rbridge_id=None, af_ipv6_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.send_community', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.send_community', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.send_community', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'both'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_send_community_extended_delete(self, rbridge_id=None, af_ipv6_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.send_community', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.send_community', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.send_community', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'extended'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_send_community_send_community_status_delete(self, rbridge_id=None, af_ipv6_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.send_community', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.send_community', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.send_community', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'send-community-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_send_community_standard_delete(self, rbridge_id=None, af_ipv6_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.send_community', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.send_community', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.send_community', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'standard'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_unsuppress_map_map_name_delete(self, rbridge_id=None, af_ipv6_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.unsuppress_map', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.unsuppress_map', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.unsuppress_map', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'map-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_weight_delete(self, rbridge_id=None, af_ipv6_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_neighbor_peergroup', 'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'weight'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_network_delete(self, rbridge_id=None, network=None, network_weight=None, backdoor=None, network_route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type network: network_ipv6_address
    :param network: Keyword argument tuple.

    :type network_ipv6_address: unicode
    :param network_ipv6_address: **network** tuple argument:  A:B::C:D/M IPV6 address in dotted decimal/Mask

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    **Instance Argument(s)**:

    :type network_weight: long
    :param network_weight: Set BGP weight for network

        * range restriction: ::

            ['0..4294967295']

    :type backdoor: YANGBool
    :param backdoor: Specify a BGP backdoor route

    :type network_route_map: unicode
    :param network_route_map: Route-map to modify the attributes

        * length restriction: ::

            ['1..63']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.network', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.network', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.network', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'network', 'keyval': 'network_ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, network=network, network_weight=network_weight, backdoor=backdoor, network_route_map=network_route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, network=network, network_weight=network_weight, backdoor=backdoor, network_route_map=network_route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_network_backdoor_delete(self, rbridge_id=None, network=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type network: network_ipv6_address
    :param network: Keyword argument tuple.

    :type network_ipv6_address: unicode
    :param network_ipv6_address: **network** tuple argument:  A:B::C:D/M IPV6 address in dotted decimal/Mask

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.network', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.network', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.network', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'network', 'keyval': 'network_ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'backdoor'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, network=network)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, network=network)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_network_route_map_delete(self, rbridge_id=None, network=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type network: network_ipv6_address
    :param network: Keyword argument tuple.

    :type network_ipv6_address: unicode
    :param network_ipv6_address: **network** tuple argument:  A:B::C:D/M IPV6 address in dotted decimal/Mask

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.network', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.network', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.network', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'network', 'keyval': 'network_ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, network=network)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, network=network)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_network_weight_delete(self, rbridge_id=None, network=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type network: network_ipv6_address
    :param network: Keyword argument tuple.

    :type network_ipv6_address: unicode
    :param network_ipv6_address: **network** tuple argument:  A:B::C:D/M IPV6 address in dotted decimal/Mask

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.network', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.network', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.network', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'network', 'keyval': 'network_ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'weight'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, network=network)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, network=network)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_next_hop_enable_default_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'next-hop-enable-default'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_next_hop_recursion_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'next-hop-recursion'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_redistribute_bgp_metric_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_redistribute_bgp_redistribute_bgp_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redistribute-bgp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_redistribute_bgp_route_map_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_redistribute_connected_metric_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_redistribute_connected_redistribute_connected_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redistribute-connected'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_redistribute_connected_route_map_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_redistribute_ospf_match_external1_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'external1'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_redistribute_ospf_match_external2_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'external2'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_redistribute_ospf_match_internal_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'internal'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_redistribute_ospf_metric_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_redistribute_ospf_redistribute_ospf_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redistribute-ospf'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_redistribute_ospf_route_map_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_redistribute_static_metric_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_redistribute_static_redistribute_static_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redistribute-static'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_redistribute_static_route_map_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_rib_route_limit_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rib-route-limit'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_table_map_route_map_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.table_map', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.table_map', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.table_map', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_update_time_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'update-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_delete(self, rbridge_id=None, af_ipv6_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_vrf', 'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_aggregate_address_delete(self, rbridge_id=None, af_ipv6_vrf=None, aggregate_ipv6_address=None, advertise_map=None, as_set=None, attribute_map=None, summary_only=None, suppress_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type aggregate_ipv6_address: aggregate_ip_prefix
    :param aggregate_ipv6_address: Keyword argument tuple.

    :type aggregate_ip_prefix: unicode
    :param aggregate_ip_prefix: **aggregate_ipv6_address** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    **Instance Argument(s)**:

    :type advertise_map: unicode
    :param advertise_map: Route map to control attribute advertisement

        * length restriction: ::

            ['1..63']

    :type as_set: YANGBool
    :param as_set: Generate AS set path information

    :type attribute_map: unicode
    :param attribute_map: Route map for parameter control

        * length restriction: ::

            ['1..63']

    :type summary_only: YANGBool
    :param summary_only: Filter more specific routes from updates

    :type suppress_map: unicode
    :param suppress_map: Conditionally filter more specific routes from updates

        * length restriction: ::

            ['1..63']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.aggregate_ipv6_address', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.aggregate_ipv6_address', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.aggregate_ipv6_address', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'aggregate_ipv6_address', 'keyval': 'aggregate_ip_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, aggregate_ipv6_address=aggregate_ipv6_address, advertise_map=advertise_map, as_set=as_set, attribute_map=attribute_map, summary_only=summary_only, suppress_map=suppress_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, aggregate_ipv6_address=aggregate_ipv6_address, advertise_map=advertise_map, as_set=as_set, attribute_map=attribute_map, summary_only=summary_only, suppress_map=suppress_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_aggregate_address_advertise_map_delete(self, rbridge_id=None, af_ipv6_vrf=None, aggregate_ipv6_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type aggregate_ipv6_address: aggregate_ip_prefix
    :param aggregate_ipv6_address: Keyword argument tuple.

    :type aggregate_ip_prefix: unicode
    :param aggregate_ip_prefix: **aggregate_ipv6_address** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.aggregate_ipv6_address', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.aggregate_ipv6_address', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.aggregate_ipv6_address', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'aggregate_ipv6_address', 'keyval': 'aggregate_ip_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'advertise-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, aggregate_ipv6_address=aggregate_ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, aggregate_ipv6_address=aggregate_ipv6_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_aggregate_address_as_set_delete(self, rbridge_id=None, af_ipv6_vrf=None, aggregate_ipv6_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type aggregate_ipv6_address: aggregate_ip_prefix
    :param aggregate_ipv6_address: Keyword argument tuple.

    :type aggregate_ip_prefix: unicode
    :param aggregate_ip_prefix: **aggregate_ipv6_address** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.aggregate_ipv6_address', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.aggregate_ipv6_address', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.aggregate_ipv6_address', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'aggregate_ipv6_address', 'keyval': 'aggregate_ip_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'as-set'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, aggregate_ipv6_address=aggregate_ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, aggregate_ipv6_address=aggregate_ipv6_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_aggregate_address_attribute_map_delete(self, rbridge_id=None, af_ipv6_vrf=None, aggregate_ipv6_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type aggregate_ipv6_address: aggregate_ip_prefix
    :param aggregate_ipv6_address: Keyword argument tuple.

    :type aggregate_ip_prefix: unicode
    :param aggregate_ip_prefix: **aggregate_ipv6_address** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.aggregate_ipv6_address', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.aggregate_ipv6_address', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.aggregate_ipv6_address', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'aggregate_ipv6_address', 'keyval': 'aggregate_ip_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'attribute-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, aggregate_ipv6_address=aggregate_ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, aggregate_ipv6_address=aggregate_ipv6_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_aggregate_address_summary_only_delete(self, rbridge_id=None, af_ipv6_vrf=None, aggregate_ipv6_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type aggregate_ipv6_address: aggregate_ip_prefix
    :param aggregate_ipv6_address: Keyword argument tuple.

    :type aggregate_ip_prefix: unicode
    :param aggregate_ip_prefix: **aggregate_ipv6_address** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.aggregate_ipv6_address', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.aggregate_ipv6_address', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.aggregate_ipv6_address', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'aggregate_ipv6_address', 'keyval': 'aggregate_ip_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'summary-only'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, aggregate_ipv6_address=aggregate_ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, aggregate_ipv6_address=aggregate_ipv6_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_aggregate_address_suppress_map_delete(self, rbridge_id=None, af_ipv6_vrf=None, aggregate_ipv6_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type aggregate_ipv6_address: aggregate_ip_prefix
    :param aggregate_ipv6_address: Keyword argument tuple.

    :type aggregate_ip_prefix: unicode
    :param aggregate_ip_prefix: **aggregate_ipv6_address** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.aggregate_ipv6_address', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.aggregate_ipv6_address', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.aggregate_ipv6_address', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'aggregate_ipv6_address', 'keyval': 'aggregate_ip_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'suppress-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, aggregate_ipv6_address=aggregate_ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, aggregate_ipv6_address=aggregate_ipv6_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_always_propagate_delete(self, rbridge_id=None, af_ipv6_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_vrf', 'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'always-propagate'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_bgp_redistribute_internal_delete(self, rbridge_id=None, af_ipv6_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bgp-redistribute-internal'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_client_to_client_reflection_delete(self, rbridge_id=None, af_ipv6_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_vrf', 'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'client-to-client-reflection'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_dampening_delete(self, rbridge_id=None, af_ipv6_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening': [u'dampening_flag', u'values', u'dampening_route_map'], 'pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening': [u'dampening_flag', u'values', u'dampening_route_map']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_dampening_dampening_flag_delete(self, rbridge_id=None, af_ipv6_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dampening-flag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_dampening_route_map_delete(self, rbridge_id=None, af_ipv6_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_dampening_values_delete(self, rbridge_id=None, af_ipv6_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening.values', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening.values', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening.values', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening.values': [u'half_time'], 'pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening.values': [u'half_time'], 'pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening.values': [u'half_time']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_default_information_originate_delete(self, rbridge_id=None, af_ipv6_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_vrf', 'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'default-information-originate'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_default_metric_delete(self, rbridge_id=None, af_ipv6_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_vrf', 'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'default-metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_graceful_restart_delete(self, rbridge_id=None, af_ipv6_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_vrf', 'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'graceful-restart'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_maximum_paths_ebgp_delete(self, rbridge_id=None, af_ipv6_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.maximum_paths', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.maximum_paths', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.maximum_paths', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ebgp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_maximum_paths_ibgp_delete(self, rbridge_id=None, af_ipv6_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.maximum_paths', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.maximum_paths', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.maximum_paths', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ibgp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_maximum_paths_load_sharing_value_delete(self, rbridge_id=None, af_ipv6_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.maximum_paths', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.maximum_paths', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.maximum_paths', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'load-sharing-value'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_maximum_paths_use_load_sharing_delete(self, rbridge_id=None, af_ipv6_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.maximum_paths', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.maximum_paths', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.maximum_paths', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'use-load-sharing'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_multipath_ebgp_delete(self, rbridge_id=None, af_ipv6_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.multipath', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.multipath', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.multipath', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ebgp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_multipath_ibgp_delete(self, rbridge_id=None, af_ipv6_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.multipath', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.multipath', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.multipath', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ibgp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_multipath_multi_as_delete(self, rbridge_id=None, af_ipv6_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.multipath', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.multipath', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.multipath', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'multi-as'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_delete(self, rbridge_id=None, af_ipv6_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_activate_delete(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_neighbor_addr', 'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'activate'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_additional_paths_advertise_all_delete(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths.advertise', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths.advertise', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'all'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_additional_paths_advertise_best_delete(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths.advertise', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths.advertise', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'best'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_advertisement_interval_delete(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.advertisement_interval', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.advertisement_interval', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.advertisement_interval', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'value'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_advertisement_interval_value_delete(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.advertisement_interval', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.advertisement_interval', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.advertisement_interval', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'value'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_allowas_in_delete(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_neighbor_addr', 'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'allowas-in'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_as_override_delete(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_neighbor_addr', 'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'as-override'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_bfd_bfd_enable_delete(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bfd-enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_bfd_holdover_interval_delete(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'holdover-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_bfd_interval_delete(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd.interval', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd.interval', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd.interval', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_bfd_interval_min_rx_delete(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd.interval', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd.interval', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd.interval', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'min-rx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_bfd_interval_min_tx_delete(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd.interval', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd.interval', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd.interval', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'min-tx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_bfd_interval_multiplier_delete(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd.interval', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd.interval', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd.interval', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'multiplier'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_capability_additional_paths_add_path_both_delete(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.additional_paths', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.additional_paths', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'add-path-both'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_capability_additional_paths_receive_delete(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.additional_paths', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.additional_paths', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'receive'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_capability_additional_paths_send_delete(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.additional_paths', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.additional_paths', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'send'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_capability_as4_disable_delete(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.as4', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.as4', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.as4', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'disable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_capability_as4_enable_delete(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.as4', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.as4', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.as4', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_capability_orf_prefixlist_prefixlist_status_delete(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.orf.prefixlist', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.orf.prefixlist', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.orf.prefixlist', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'prefixlist-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_capability_orf_prefixlist_receive_delete(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.orf.prefixlist', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.orf.prefixlist', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.orf.prefixlist', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'receive'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_capability_orf_prefixlist_send_delete(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.orf.prefixlist', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.orf.prefixlist', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.orf.prefixlist', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'send'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_default_originate_default_originate_status_delete(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.default_originate', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.default_originate', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.default_originate', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'default-originate-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_default_originate_route_map_delete(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.default_originate', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.default_originate', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.default_originate', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_description_delete(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_neighbor_addr', 'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'description'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_ebgp_btsh_delete(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_neighbor_addr', 'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ebgp-btsh'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_ebgp_multihop_delete(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.ebgp_multihop', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.ebgp_multihop', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.ebgp_multihop': [u'ebgp_multihop_flag', u'ebgp_multihop_count'], 'pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.ebgp_multihop': [u'ebgp_multihop_flag', u'ebgp_multihop_count']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_ebgp_multihop_ebgp_multihop_count_delete(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.ebgp_multihop', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.ebgp_multihop', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.ebgp_multihop', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ebgp-multihop-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_ebgp_multihop_ebgp_multihop_flag_delete(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.ebgp_multihop', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.ebgp_multihop', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.ebgp_multihop', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ebgp-multihop-flag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_enable_peer_as_check_delete(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_neighbor_addr', 'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable-peer-as-check'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_enforce_first_as_disable_delete(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.enforce_first_as', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.enforce_first_as', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.enforce_first_as', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'disable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_enforce_first_as_enable_delete(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.enforce_first_as', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.enforce_first_as', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.enforce_first_as', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_local_as_delete(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.local_as', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.local_as', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.local_as', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'local_as_value, no_prepend'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_local_as_local_as_value_delete(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.local_as', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.local_as', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.local_as', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'local-as-value'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_local_as_no_prepend_delete(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.local_as', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.local_as', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.local_as', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'no-prepend'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_maxas_limit_in_disable_delete(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maxas_limit.in_', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maxas_limit.in_', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maxas_limit.in_', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'disable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_maxas_limit_in_num_as_in_as_path_delete(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maxas_limit.in_', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maxas_limit.in_', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maxas_limit.in_', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'num-as-in-as-path'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_maximum_prefix_max_prefix_limit_delete(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'max-prefix-limit'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_maximum_prefix_teardown_delete(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix.threshold_holder', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix.threshold_holder', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix.threshold_holder', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'teardown'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_maximum_prefix_threshold_delete(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix.threshold_holder', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix.threshold_holder', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix.threshold_holder', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'threshold'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_maximum_prefix_threshold_holder_delete(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix.threshold_holder', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix.threshold_holder', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix.threshold_holder', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'threshold, teardown'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_next_hop_self_always_delete(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.next_hop_self', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.next_hop_self', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.next_hop_self', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'always'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_next_hop_self_next_hop_self_status_delete(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.next_hop_self', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.next_hop_self', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.next_hop_self', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'next-hop-self-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_password_delete(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_neighbor_addr', 'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'password'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_peer_group_delete(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_neighbor_addr', 'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'peer-group'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_prefix_list_in_delete(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list.direction_in', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list.direction_in', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list.direction_in', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'in'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_prefix_list_ip_access_number_delete(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list.direction_in', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ip-access-number'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_prefix_list_ip_access_number_direction_out_delete(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list.direction_out', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ip-access-number'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_prefix_list_out_delete(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list.direction_out', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list.direction_out', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list.direction_out', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'out'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_prefix_list_prefix_list_direction_in_prefix_name_delete(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list.direction_in', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list.direction_in', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'prefix-list-direction-in-prefix-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_prefix_list_prefix_list_direction_out_prefix_name_delete(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list.direction_out', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list.direction_out', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'prefix-list-direction-out-prefix-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_remote_as_delete(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_neighbor_addr', 'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'remote-as'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_remove_private_as_delete(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_neighbor_addr', 'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'remove-private-as'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_route_map_in_neighbor_route_map_name_direction_in_delete(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map.neighbor_route_map_direction_in', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map.neighbor_route_map_direction_in', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map.neighbor_route_map_direction_in', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'neighbor-route-map-name-direction-in'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_route_map_out_neighbor_route_map_name_direction_out_delete(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map.neighbor_route_map_direction_out', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map.neighbor_route_map_direction_out', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map.neighbor_route_map_direction_out', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'neighbor-route-map-name-direction-out'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_route_reflector_client_delete(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_neighbor_addr', 'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-reflector-client'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_send_community_both_delete(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.send_community', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.send_community', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.send_community', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'both'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_send_community_extended_delete(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.send_community', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.send_community', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.send_community', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'extended'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_send_community_send_community_status_delete(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.send_community', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.send_community', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.send_community', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'send-community-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_send_community_standard_delete(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.send_community', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.send_community', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.send_community', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'standard'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_shutdown_generate_rib_out_delete(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.shutdown', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.shutdown', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.shutdown', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'generate-rib-out'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_shutdown_shutdown_status_delete(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.shutdown', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.shutdown', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.shutdown', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'shutdown-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_soft_reconfiguration_inbound_delete(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.soft_reconfiguration', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.soft_reconfiguration', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.soft_reconfiguration', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'inbound'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_static_network_edge_delete(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_neighbor_addr', 'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'static-network-edge'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_timers_hold_time_delete(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.timers', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.timers', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.timers', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hold-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_timers_keep_alive_delete(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.timers', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.timers', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.timers', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'keep-alive'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_unsuppress_map_map_name_delete(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.unsuppress_map', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.unsuppress_map', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.unsuppress_map', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'map-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_update_source_ethernet_delete(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source.ethernet_interface', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source.ethernet_interface', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source.ethernet_interface', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ethernet'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_update_source_ethernet_interface_delete(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source.ethernet_interface', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source.ethernet_interface', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source.ethernet_interface', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'interface_type, ethernet'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source.ethernet_interface': [u'interface_type'], 'pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source.ethernet_interface': [u'interface_type'], 'pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source.ethernet_interface': [u'interface_type']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_update_source_interface_type_delete(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source.ethernet_interface', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source.ethernet_interface', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source.ethernet_interface', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'interface-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_update_source_loopback_delete(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'loopback'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_update_source_port_channel_delete(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'port-channel'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_update_source_sip_ipv6_address_delete(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'sip-ipv6-address'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_update_source_ve_interface_delete(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 've-interface'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_weight_delete(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_neighbor_addr', 'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'weight'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_vrf_neighbor_address_holder_delete(self, rbridge_id=None, af_ipv6_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_network_delete(self, rbridge_id=None, af_ipv6_vrf=None, network=None, network_weight=None, backdoor=None, network_route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type network: network_ipv6_address
    :param network: Keyword argument tuple.

    :type network_ipv6_address: unicode
    :param network_ipv6_address: **network** tuple argument:  A:B::C:D/M IPV6 address in dotted decimal/Mask

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    **Instance Argument(s)**:

    :type network_weight: long
    :param network_weight: Set BGP weight for network

        * range restriction: ::

            ['0..4294967295']

    :type backdoor: YANGBool
    :param backdoor: Specify a BGP backdoor route

    :type network_route_map: unicode
    :param network_route_map: Route-map to modify the attributes

        * length restriction: ::

            ['1..63']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.network', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.network', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.network', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'network', 'keyval': 'network_ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, network=network, network_weight=network_weight, backdoor=backdoor, network_route_map=network_route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, network=network, network_weight=network_weight, backdoor=backdoor, network_route_map=network_route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_network_backdoor_delete(self, rbridge_id=None, af_ipv6_vrf=None, network=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type network: network_ipv6_address
    :param network: Keyword argument tuple.

    :type network_ipv6_address: unicode
    :param network_ipv6_address: **network** tuple argument:  A:B::C:D/M IPV6 address in dotted decimal/Mask

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.network', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.network', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.network', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'network', 'keyval': 'network_ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'backdoor'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, network=network)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, network=network)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_network_route_map_delete(self, rbridge_id=None, af_ipv6_vrf=None, network=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type network: network_ipv6_address
    :param network: Keyword argument tuple.

    :type network_ipv6_address: unicode
    :param network_ipv6_address: **network** tuple argument:  A:B::C:D/M IPV6 address in dotted decimal/Mask

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.network', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.network', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.network', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'network', 'keyval': 'network_ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, network=network)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, network=network)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_network_weight_delete(self, rbridge_id=None, af_ipv6_vrf=None, network=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type network: network_ipv6_address
    :param network: Keyword argument tuple.

    :type network_ipv6_address: unicode
    :param network_ipv6_address: **network** tuple argument:  A:B::C:D/M IPV6 address in dotted decimal/Mask

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.network', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.network', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.network', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'network', 'keyval': 'network_ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'weight'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, network=network)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, network=network)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_next_hop_enable_default_delete(self, rbridge_id=None, af_ipv6_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_vrf', 'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'next-hop-enable-default'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_next_hop_recursion_delete(self, rbridge_id=None, af_ipv6_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_vrf', 'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'next-hop-recursion'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_redistribute_bgp_metric_delete(self, rbridge_id=None, af_ipv6_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_redistribute_bgp_redistribute_bgp_delete(self, rbridge_id=None, af_ipv6_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redistribute-bgp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_redistribute_bgp_route_map_delete(self, rbridge_id=None, af_ipv6_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_redistribute_connected_metric_delete(self, rbridge_id=None, af_ipv6_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_redistribute_connected_redistribute_connected_delete(self, rbridge_id=None, af_ipv6_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redistribute-connected'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_redistribute_connected_route_map_delete(self, rbridge_id=None, af_ipv6_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_redistribute_ospf_match_external1_delete(self, rbridge_id=None, af_ipv6_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'external1'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_redistribute_ospf_match_external2_delete(self, rbridge_id=None, af_ipv6_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'external2'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_redistribute_ospf_match_internal_delete(self, rbridge_id=None, af_ipv6_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'internal'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_redistribute_ospf_metric_delete(self, rbridge_id=None, af_ipv6_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_redistribute_ospf_redistribute_ospf_delete(self, rbridge_id=None, af_ipv6_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redistribute-ospf'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_redistribute_ospf_route_map_delete(self, rbridge_id=None, af_ipv6_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_redistribute_static_metric_delete(self, rbridge_id=None, af_ipv6_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_redistribute_static_redistribute_static_delete(self, rbridge_id=None, af_ipv6_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redistribute-static'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_redistribute_static_route_map_delete(self, rbridge_id=None, af_ipv6_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_rib_route_limit_delete(self, rbridge_id=None, af_ipv6_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_vrf', 'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rib-route-limit'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_table_map_route_map_delete(self, rbridge_id=None, af_ipv6_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.table_map', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.table_map', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.table_map', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_update_time_delete(self, rbridge_id=None, af_ipv6_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_vrf', 'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'update-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_evpn_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.l2vpn.evpn', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_evpn_client_to_client_reflection_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.l2vpn.evpn', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'client-to-client-reflection'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_evpn_graceful_restart_graceful_restart_status_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.graceful_restart', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.graceful_restart', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'graceful-restart-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_evpn_graceful_restart_purge_time_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.graceful_restart', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.graceful_restart', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'purge-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_evpn_graceful_restart_restart_time_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.graceful_restart', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.graceful_restart', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'restart-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_evpn_graceful_restart_stale_routes_time_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.graceful_restart', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.graceful_restart', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'stale-routes-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_evpn_neighbor_evpn_neighbor_ipv4_activate_delete(self, rbridge_id=None, evpn_neighbor_ipv4=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type evpn_neighbor_ipv4: evpn_neighbor_ipv4_address
    :param evpn_neighbor_ipv4: Keyword argument tuple.

    :type evpn_neighbor_ipv4_address: unicode
    :param evpn_neighbor_ipv4_address: **evpn_neighbor_ipv4** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'evpn_neighbor_ipv4', 'keyval': 'evpn_neighbor_ipv4_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'activate'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_neighbor_ipv4=evpn_neighbor_ipv4)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_neighbor_ipv4=evpn_neighbor_ipv4)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_evpn_neighbor_evpn_neighbor_ipv4_allowas_in_delete(self, rbridge_id=None, evpn_neighbor_ipv4=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type evpn_neighbor_ipv4: evpn_neighbor_ipv4_address
    :param evpn_neighbor_ipv4: Keyword argument tuple.

    :type evpn_neighbor_ipv4_address: unicode
    :param evpn_neighbor_ipv4_address: **evpn_neighbor_ipv4** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'evpn_neighbor_ipv4', 'keyval': 'evpn_neighbor_ipv4_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'allowas-in'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_neighbor_ipv4=evpn_neighbor_ipv4)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_neighbor_ipv4=evpn_neighbor_ipv4)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_evpn_neighbor_evpn_neighbor_ipv4_enable_peer_as_check_delete(self, rbridge_id=None, evpn_neighbor_ipv4=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type evpn_neighbor_ipv4: evpn_neighbor_ipv4_address
    :param evpn_neighbor_ipv4: Keyword argument tuple.

    :type evpn_neighbor_ipv4_address: unicode
    :param evpn_neighbor_ipv4_address: **evpn_neighbor_ipv4** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'evpn_neighbor_ipv4', 'keyval': 'evpn_neighbor_ipv4_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable-peer-as-check'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_neighbor_ipv4=evpn_neighbor_ipv4)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_neighbor_ipv4=evpn_neighbor_ipv4)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_evpn_neighbor_evpn_neighbor_ipv4_maximum_prefix_delete(self, rbridge_id=None, evpn_neighbor_ipv4=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type evpn_neighbor_ipv4: evpn_neighbor_ipv4_address
    :param evpn_neighbor_ipv4: Keyword argument tuple.

    :type evpn_neighbor_ipv4_address: unicode
    :param evpn_neighbor_ipv4_address: **evpn_neighbor_ipv4** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'evpn_neighbor_ipv4', 'keyval': 'evpn_neighbor_ipv4_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'maximum-prefix'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_neighbor_ipv4=evpn_neighbor_ipv4)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_neighbor_ipv4=evpn_neighbor_ipv4)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_evpn_neighbor_evpn_neighbor_ipv4_next_hop_unchanged_delete(self, rbridge_id=None, evpn_neighbor_ipv4=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type evpn_neighbor_ipv4: evpn_neighbor_ipv4_address
    :param evpn_neighbor_ipv4: Keyword argument tuple.

    :type evpn_neighbor_ipv4_address: unicode
    :param evpn_neighbor_ipv4_address: **evpn_neighbor_ipv4** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'evpn_neighbor_ipv4', 'keyval': 'evpn_neighbor_ipv4_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'next-hop-unchanged'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_neighbor_ipv4=evpn_neighbor_ipv4)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_neighbor_ipv4=evpn_neighbor_ipv4)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_evpn_neighbor_evpn_neighbor_ipv4_route_map_in_route_map_name_direction_in_delete(self, rbridge_id=None, evpn_neighbor_ipv4=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type evpn_neighbor_ipv4: evpn_neighbor_ipv4_address
    :param evpn_neighbor_ipv4: Keyword argument tuple.

    :type evpn_neighbor_ipv4_address: unicode
    :param evpn_neighbor_ipv4_address: **evpn_neighbor_ipv4** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', u'evpn_neighbor_ipv4'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', u'evpn_neighbor_ipv4')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.route_map.direction_in', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.route_map.direction_in', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_ipv4_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_ipv4_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map-name-direction-in'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_neighbor_ipv4=evpn_neighbor_ipv4)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_neighbor_ipv4=evpn_neighbor_ipv4)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_evpn_neighbor_evpn_neighbor_ipv4_route_map_out_route_map_name_direction_out_delete(self, rbridge_id=None, evpn_neighbor_ipv4=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type evpn_neighbor_ipv4: evpn_neighbor_ipv4_address
    :param evpn_neighbor_ipv4: Keyword argument tuple.

    :type evpn_neighbor_ipv4_address: unicode
    :param evpn_neighbor_ipv4_address: **evpn_neighbor_ipv4** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', u'evpn_neighbor_ipv4'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', u'evpn_neighbor_ipv4')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.route_map.direction_out', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.route_map.direction_out', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_ipv4_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_ipv4_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map-name-direction-out'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_neighbor_ipv4=evpn_neighbor_ipv4)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_neighbor_ipv4=evpn_neighbor_ipv4)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_evpn_neighbor_evpn_neighbor_ipv4_route_reflector_client_delete(self, rbridge_id=None, evpn_neighbor_ipv4=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type evpn_neighbor_ipv4: evpn_neighbor_ipv4_address
    :param evpn_neighbor_ipv4: Keyword argument tuple.

    :type evpn_neighbor_ipv4_address: unicode
    :param evpn_neighbor_ipv4_address: **evpn_neighbor_ipv4** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'evpn_neighbor_ipv4', 'keyval': 'evpn_neighbor_ipv4_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-reflector-client'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_neighbor_ipv4=evpn_neighbor_ipv4)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_neighbor_ipv4=evpn_neighbor_ipv4)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_evpn_neighbor_evpn_neighbor_ipv4_send_community_both_delete(self, rbridge_id=None, evpn_neighbor_ipv4=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type evpn_neighbor_ipv4: evpn_neighbor_ipv4_address
    :param evpn_neighbor_ipv4: Keyword argument tuple.

    :type evpn_neighbor_ipv4_address: unicode
    :param evpn_neighbor_ipv4_address: **evpn_neighbor_ipv4** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', u'evpn_neighbor_ipv4'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', u'evpn_neighbor_ipv4')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.send_community', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.send_community', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_ipv4_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_ipv4_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'both'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_neighbor_ipv4=evpn_neighbor_ipv4)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_neighbor_ipv4=evpn_neighbor_ipv4)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_evpn_neighbor_evpn_neighbor_ipv4_send_community_extended_delete(self, rbridge_id=None, evpn_neighbor_ipv4=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type evpn_neighbor_ipv4: evpn_neighbor_ipv4_address
    :param evpn_neighbor_ipv4: Keyword argument tuple.

    :type evpn_neighbor_ipv4_address: unicode
    :param evpn_neighbor_ipv4_address: **evpn_neighbor_ipv4** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', u'evpn_neighbor_ipv4'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', u'evpn_neighbor_ipv4')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.send_community', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.send_community', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_ipv4_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_ipv4_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'extended'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_neighbor_ipv4=evpn_neighbor_ipv4)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_neighbor_ipv4=evpn_neighbor_ipv4)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_evpn_neighbor_evpn_neighbor_ipv4_send_community_send_community_status_delete(self, rbridge_id=None, evpn_neighbor_ipv4=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type evpn_neighbor_ipv4: evpn_neighbor_ipv4_address
    :param evpn_neighbor_ipv4: Keyword argument tuple.

    :type evpn_neighbor_ipv4_address: unicode
    :param evpn_neighbor_ipv4_address: **evpn_neighbor_ipv4** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', u'evpn_neighbor_ipv4'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', u'evpn_neighbor_ipv4')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.send_community', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.send_community', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_ipv4_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_ipv4_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'send-community-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_neighbor_ipv4=evpn_neighbor_ipv4)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_neighbor_ipv4=evpn_neighbor_ipv4)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_evpn_neighbor_evpn_neighbor_ipv4_send_community_standard_delete(self, rbridge_id=None, evpn_neighbor_ipv4=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type evpn_neighbor_ipv4: evpn_neighbor_ipv4_address
    :param evpn_neighbor_ipv4: Keyword argument tuple.

    :type evpn_neighbor_ipv4_address: unicode
    :param evpn_neighbor_ipv4_address: **evpn_neighbor_ipv4** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', u'evpn_neighbor_ipv4'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', u'evpn_neighbor_ipv4')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.send_community', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.send_community', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_ipv4_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_ipv4_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'standard'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_neighbor_ipv4=evpn_neighbor_ipv4)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_neighbor_ipv4=evpn_neighbor_ipv4)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_evpn_neighbor_evpn_neighbor_ipv6_activate_delete(self, rbridge_id=None, evpn_neighbor_ipv6=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type evpn_neighbor_ipv6: evpn_neighbor_ipv6_address
    :param evpn_neighbor_ipv6: Keyword argument tuple.

    :type evpn_neighbor_ipv6_address: unicode
    :param evpn_neighbor_ipv6_address: **evpn_neighbor_ipv6** tuple argument:  A:B::C:D;;Neighbor Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'evpn_neighbor_ipv6', 'keyval': 'evpn_neighbor_ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'activate'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_neighbor_ipv6=evpn_neighbor_ipv6)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_neighbor_ipv6=evpn_neighbor_ipv6)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_evpn_neighbor_evpn_neighbor_ipv6_allowas_in_delete(self, rbridge_id=None, evpn_neighbor_ipv6=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type evpn_neighbor_ipv6: evpn_neighbor_ipv6_address
    :param evpn_neighbor_ipv6: Keyword argument tuple.

    :type evpn_neighbor_ipv6_address: unicode
    :param evpn_neighbor_ipv6_address: **evpn_neighbor_ipv6** tuple argument:  A:B::C:D;;Neighbor Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'evpn_neighbor_ipv6', 'keyval': 'evpn_neighbor_ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'allowas-in'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_neighbor_ipv6=evpn_neighbor_ipv6)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_neighbor_ipv6=evpn_neighbor_ipv6)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_evpn_neighbor_evpn_neighbor_ipv6_enable_peer_as_check_delete(self, rbridge_id=None, evpn_neighbor_ipv6=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type evpn_neighbor_ipv6: evpn_neighbor_ipv6_address
    :param evpn_neighbor_ipv6: Keyword argument tuple.

    :type evpn_neighbor_ipv6_address: unicode
    :param evpn_neighbor_ipv6_address: **evpn_neighbor_ipv6** tuple argument:  A:B::C:D;;Neighbor Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'evpn_neighbor_ipv6', 'keyval': 'evpn_neighbor_ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable-peer-as-check'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_neighbor_ipv6=evpn_neighbor_ipv6)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_neighbor_ipv6=evpn_neighbor_ipv6)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_evpn_neighbor_evpn_neighbor_ipv6_maximum_prefix_delete(self, rbridge_id=None, evpn_neighbor_ipv6=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type evpn_neighbor_ipv6: evpn_neighbor_ipv6_address
    :param evpn_neighbor_ipv6: Keyword argument tuple.

    :type evpn_neighbor_ipv6_address: unicode
    :param evpn_neighbor_ipv6_address: **evpn_neighbor_ipv6** tuple argument:  A:B::C:D;;Neighbor Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'evpn_neighbor_ipv6', 'keyval': 'evpn_neighbor_ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'maximum-prefix'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_neighbor_ipv6=evpn_neighbor_ipv6)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_neighbor_ipv6=evpn_neighbor_ipv6)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_evpn_neighbor_evpn_neighbor_ipv6_next_hop_unchanged_delete(self, rbridge_id=None, evpn_neighbor_ipv6=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type evpn_neighbor_ipv6: evpn_neighbor_ipv6_address
    :param evpn_neighbor_ipv6: Keyword argument tuple.

    :type evpn_neighbor_ipv6_address: unicode
    :param evpn_neighbor_ipv6_address: **evpn_neighbor_ipv6** tuple argument:  A:B::C:D;;Neighbor Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'evpn_neighbor_ipv6', 'keyval': 'evpn_neighbor_ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'next-hop-unchanged'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_neighbor_ipv6=evpn_neighbor_ipv6)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_neighbor_ipv6=evpn_neighbor_ipv6)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_evpn_neighbor_evpn_neighbor_ipv6_route_map_in_route_map_name_direction_in_delete(self, rbridge_id=None, evpn_neighbor_ipv6=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type evpn_neighbor_ipv6: evpn_neighbor_ipv6_address
    :param evpn_neighbor_ipv6: Keyword argument tuple.

    :type evpn_neighbor_ipv6_address: unicode
    :param evpn_neighbor_ipv6_address: **evpn_neighbor_ipv6** tuple argument:  A:B::C:D;;Neighbor Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', u'evpn_neighbor_ipv6'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', u'evpn_neighbor_ipv6')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.route_map.direction_in', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.route_map.direction_in', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map-name-direction-in'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_neighbor_ipv6=evpn_neighbor_ipv6)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_neighbor_ipv6=evpn_neighbor_ipv6)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_evpn_neighbor_evpn_neighbor_ipv6_route_map_out_route_map_name_direction_out_delete(self, rbridge_id=None, evpn_neighbor_ipv6=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type evpn_neighbor_ipv6: evpn_neighbor_ipv6_address
    :param evpn_neighbor_ipv6: Keyword argument tuple.

    :type evpn_neighbor_ipv6_address: unicode
    :param evpn_neighbor_ipv6_address: **evpn_neighbor_ipv6** tuple argument:  A:B::C:D;;Neighbor Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', u'evpn_neighbor_ipv6'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', u'evpn_neighbor_ipv6')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.route_map.direction_out', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.route_map.direction_out', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map-name-direction-out'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_neighbor_ipv6=evpn_neighbor_ipv6)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_neighbor_ipv6=evpn_neighbor_ipv6)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_evpn_neighbor_evpn_neighbor_ipv6_route_reflector_client_delete(self, rbridge_id=None, evpn_neighbor_ipv6=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type evpn_neighbor_ipv6: evpn_neighbor_ipv6_address
    :param evpn_neighbor_ipv6: Keyword argument tuple.

    :type evpn_neighbor_ipv6_address: unicode
    :param evpn_neighbor_ipv6_address: **evpn_neighbor_ipv6** tuple argument:  A:B::C:D;;Neighbor Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'evpn_neighbor_ipv6', 'keyval': 'evpn_neighbor_ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-reflector-client'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_neighbor_ipv6=evpn_neighbor_ipv6)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_neighbor_ipv6=evpn_neighbor_ipv6)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_evpn_neighbor_evpn_neighbor_ipv6_send_community_both_delete(self, rbridge_id=None, evpn_neighbor_ipv6=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type evpn_neighbor_ipv6: evpn_neighbor_ipv6_address
    :param evpn_neighbor_ipv6: Keyword argument tuple.

    :type evpn_neighbor_ipv6_address: unicode
    :param evpn_neighbor_ipv6_address: **evpn_neighbor_ipv6** tuple argument:  A:B::C:D;;Neighbor Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', u'evpn_neighbor_ipv6'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', u'evpn_neighbor_ipv6')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.send_community', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.send_community', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'both'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_neighbor_ipv6=evpn_neighbor_ipv6)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_neighbor_ipv6=evpn_neighbor_ipv6)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_evpn_neighbor_evpn_neighbor_ipv6_send_community_extended_delete(self, rbridge_id=None, evpn_neighbor_ipv6=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type evpn_neighbor_ipv6: evpn_neighbor_ipv6_address
    :param evpn_neighbor_ipv6: Keyword argument tuple.

    :type evpn_neighbor_ipv6_address: unicode
    :param evpn_neighbor_ipv6_address: **evpn_neighbor_ipv6** tuple argument:  A:B::C:D;;Neighbor Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', u'evpn_neighbor_ipv6'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', u'evpn_neighbor_ipv6')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.send_community', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.send_community', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'extended'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_neighbor_ipv6=evpn_neighbor_ipv6)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_neighbor_ipv6=evpn_neighbor_ipv6)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_evpn_neighbor_evpn_neighbor_ipv6_send_community_send_community_status_delete(self, rbridge_id=None, evpn_neighbor_ipv6=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type evpn_neighbor_ipv6: evpn_neighbor_ipv6_address
    :param evpn_neighbor_ipv6: Keyword argument tuple.

    :type evpn_neighbor_ipv6_address: unicode
    :param evpn_neighbor_ipv6_address: **evpn_neighbor_ipv6** tuple argument:  A:B::C:D;;Neighbor Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', u'evpn_neighbor_ipv6'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', u'evpn_neighbor_ipv6')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.send_community', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.send_community', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'send-community-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_neighbor_ipv6=evpn_neighbor_ipv6)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_neighbor_ipv6=evpn_neighbor_ipv6)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_evpn_neighbor_evpn_neighbor_ipv6_send_community_standard_delete(self, rbridge_id=None, evpn_neighbor_ipv6=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type evpn_neighbor_ipv6: evpn_neighbor_ipv6_address
    :param evpn_neighbor_ipv6: Keyword argument tuple.

    :type evpn_neighbor_ipv6_address: unicode
    :param evpn_neighbor_ipv6_address: **evpn_neighbor_ipv6** tuple argument:  A:B::C:D;;Neighbor Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', u'evpn_neighbor_ipv6'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', u'evpn_neighbor_ipv6')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.send_community', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.send_community', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'standard'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_neighbor_ipv6=evpn_neighbor_ipv6)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_neighbor_ipv6=evpn_neighbor_ipv6)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_evpn_neighbor_evpn_peer_group_activate_delete(self, rbridge_id=None, evpn_peer_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type evpn_peer_group: evpn_neighbor_peergroup_name
    :param evpn_peer_group: Keyword argument tuple.

    :type evpn_neighbor_peergroup_name: unicode
    :param evpn_neighbor_peergroup_name: **evpn_peer_group** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'evpn_peer_group', 'keyval': 'evpn_neighbor_peergroup_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'activate'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_peer_group=evpn_peer_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_peer_group=evpn_peer_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_evpn_neighbor_evpn_peer_group_allowas_in_delete(self, rbridge_id=None, evpn_peer_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type evpn_peer_group: evpn_neighbor_peergroup_name
    :param evpn_peer_group: Keyword argument tuple.

    :type evpn_neighbor_peergroup_name: unicode
    :param evpn_neighbor_peergroup_name: **evpn_peer_group** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'evpn_peer_group', 'keyval': 'evpn_neighbor_peergroup_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'allowas-in'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_peer_group=evpn_peer_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_peer_group=evpn_peer_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_evpn_neighbor_evpn_peer_group_enable_peer_as_check_delete(self, rbridge_id=None, evpn_peer_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type evpn_peer_group: evpn_neighbor_peergroup_name
    :param evpn_peer_group: Keyword argument tuple.

    :type evpn_neighbor_peergroup_name: unicode
    :param evpn_neighbor_peergroup_name: **evpn_peer_group** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'evpn_peer_group', 'keyval': 'evpn_neighbor_peergroup_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable-peer-as-check'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_peer_group=evpn_peer_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_peer_group=evpn_peer_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_evpn_neighbor_evpn_peer_group_maximum_prefix_delete(self, rbridge_id=None, evpn_peer_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type evpn_peer_group: evpn_neighbor_peergroup_name
    :param evpn_peer_group: Keyword argument tuple.

    :type evpn_neighbor_peergroup_name: unicode
    :param evpn_neighbor_peergroup_name: **evpn_peer_group** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'evpn_peer_group', 'keyval': 'evpn_neighbor_peergroup_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'maximum-prefix'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_peer_group=evpn_peer_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_peer_group=evpn_peer_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_evpn_neighbor_evpn_peer_group_next_hop_unchanged_delete(self, rbridge_id=None, evpn_peer_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type evpn_peer_group: evpn_neighbor_peergroup_name
    :param evpn_peer_group: Keyword argument tuple.

    :type evpn_neighbor_peergroup_name: unicode
    :param evpn_neighbor_peergroup_name: **evpn_peer_group** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'evpn_peer_group', 'keyval': 'evpn_neighbor_peergroup_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'next-hop-unchanged'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_peer_group=evpn_peer_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_peer_group=evpn_peer_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_evpn_neighbor_evpn_peer_group_route_map_in_route_map_name_direction_in_delete(self, rbridge_id=None, evpn_peer_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type evpn_peer_group: evpn_neighbor_peergroup_name
    :param evpn_peer_group: Keyword argument tuple.

    :type evpn_neighbor_peergroup_name: unicode
    :param evpn_neighbor_peergroup_name: **evpn_peer_group** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', u'evpn_peer_group'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', u'evpn_peer_group')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.route_map.direction_in', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.route_map.direction_in', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map-name-direction-in'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_peer_group=evpn_peer_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_peer_group=evpn_peer_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_evpn_neighbor_evpn_peer_group_route_map_out_route_map_name_direction_out_delete(self, rbridge_id=None, evpn_peer_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type evpn_peer_group: evpn_neighbor_peergroup_name
    :param evpn_peer_group: Keyword argument tuple.

    :type evpn_neighbor_peergroup_name: unicode
    :param evpn_neighbor_peergroup_name: **evpn_peer_group** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', u'evpn_peer_group'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', u'evpn_peer_group')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.route_map.direction_out', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.route_map.direction_out', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map-name-direction-out'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_peer_group=evpn_peer_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_peer_group=evpn_peer_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_evpn_neighbor_evpn_peer_group_route_reflector_client_delete(self, rbridge_id=None, evpn_peer_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type evpn_peer_group: evpn_neighbor_peergroup_name
    :param evpn_peer_group: Keyword argument tuple.

    :type evpn_neighbor_peergroup_name: unicode
    :param evpn_neighbor_peergroup_name: **evpn_peer_group** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'evpn_peer_group', 'keyval': 'evpn_neighbor_peergroup_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-reflector-client'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_peer_group=evpn_peer_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_peer_group=evpn_peer_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_evpn_neighbor_evpn_peer_group_send_community_both_delete(self, rbridge_id=None, evpn_peer_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type evpn_peer_group: evpn_neighbor_peergroup_name
    :param evpn_peer_group: Keyword argument tuple.

    :type evpn_neighbor_peergroup_name: unicode
    :param evpn_neighbor_peergroup_name: **evpn_peer_group** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', u'evpn_peer_group'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', u'evpn_peer_group')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.send_community', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.send_community', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'both'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_peer_group=evpn_peer_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_peer_group=evpn_peer_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_evpn_neighbor_evpn_peer_group_send_community_extended_delete(self, rbridge_id=None, evpn_peer_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type evpn_peer_group: evpn_neighbor_peergroup_name
    :param evpn_peer_group: Keyword argument tuple.

    :type evpn_neighbor_peergroup_name: unicode
    :param evpn_neighbor_peergroup_name: **evpn_peer_group** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', u'evpn_peer_group'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', u'evpn_peer_group')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.send_community', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.send_community', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'extended'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_peer_group=evpn_peer_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_peer_group=evpn_peer_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_evpn_neighbor_evpn_peer_group_send_community_send_community_status_delete(self, rbridge_id=None, evpn_peer_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type evpn_peer_group: evpn_neighbor_peergroup_name
    :param evpn_peer_group: Keyword argument tuple.

    :type evpn_neighbor_peergroup_name: unicode
    :param evpn_neighbor_peergroup_name: **evpn_peer_group** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', u'evpn_peer_group'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', u'evpn_peer_group')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.send_community', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.send_community', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'send-community-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_peer_group=evpn_peer_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_peer_group=evpn_peer_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_evpn_neighbor_evpn_peer_group_send_community_standard_delete(self, rbridge_id=None, evpn_peer_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type evpn_peer_group: evpn_neighbor_peergroup_name
    :param evpn_peer_group: Keyword argument tuple.

    :type evpn_neighbor_peergroup_name: unicode
    :param evpn_neighbor_peergroup_name: **evpn_peer_group** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', u'evpn_peer_group'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', u'evpn_peer_group')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.send_community', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.send_community', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'standard'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_peer_group=evpn_peer_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_peer_group=evpn_peer_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_evpn_retain_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.retain', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.retain', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_evpn_retain_route_target_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.retain.route_target', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.retain.route_target', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_evpn_retain_route_target_all_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.retain.route_target', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.retain.route_target', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'all'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_evpn_vtep_discovery_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.address_family.l2vpn.evpn', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vtep-discovery'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_always_compare_med_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'always-compare-med'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_as_path_ignore_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'as-path-ignore'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_auto_shutdown_new_neighbors_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'auto-shutdown-new-neighbors'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_bfd_holdover_interval_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.bfd', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.bfd', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.bfd', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'holdover-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_bfd_interval_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.bfd.interval', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.bfd.interval', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.bfd.interval', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_bfd_interval_min_rx_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.bfd.interval', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.bfd.interval', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.bfd.interval', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'min-rx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_bfd_interval_min_tx_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.bfd.interval', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.bfd.interval', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.bfd.interval', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'min-tx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_bfd_interval_multiplier_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.bfd.interval', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.bfd.interval', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.bfd.interval', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'multiplier'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_capability_as4_enable_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.capability', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.capability', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.capability', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'as4-enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_cluster_id_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.cluster_id', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.cluster_id', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.cluster_id', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.cluster_id': [u'cluster_id_value', u'cluster_id_ipv4_address'], 'pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.cluster_id': [u'cluster_id_value', u'cluster_id_ipv4_address'], 'pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.cluster_id': [u'cluster_id_value', u'cluster_id_ipv4_address']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_cluster_id_id_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.cluster_id', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.cluster_id', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.cluster_id', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_cluster_id_ipv4_address_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.cluster_id', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.cluster_id', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.cluster_id', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ipv4-address'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_compare_med_empty_aspath_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'compare-med-empty-aspath'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_compare_routerid_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'compare-routerid'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_confederation_identifier_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.confederation', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.confederation', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.confederation', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'identifier'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_default_local_preference_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'default-local-preference'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_enforce_first_as_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enforce-first-as'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_fast_external_fallover_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'fast-external-fallover'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_install_igp_cost_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'install-igp-cost'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_listen_limit_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'listen-limit'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_listen_range_delete(self, rbridge_id=None, listen_range=None, limit=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type listen_range: listen_range_prefix, peer_group, limit
    :param listen_range: Keyword argument tuple.

    :type listen_range_prefix: unicode
    :param listen_range_prefix: **listen_range** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type peer_group: unicode
    :param peer_group: **listen_range** tuple argument:  Peer group name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type limit: long
    :param limit: **listen_range** tuple argument:  Limit the neighbor

        * range restriction: ::

            ['0..4294967295']

    **Instance Argument(s)**:

    :type limit: long
    :param limit: Limit the neighbor

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.listen_range', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'listen_range', 'keyval': 'listen_range_prefix, peer_group', 'extra_keyval': 'listen_range_prefix, peer_group, limit'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, listen_range=listen_range, limit=limit)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, listen_range=listen_range, limit=limit)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_listen_range_limit_delete(self, rbridge_id=None, listen_range=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type listen_range: listen_range_prefix, peer_group
    :param listen_range: Keyword argument tuple.

    :type listen_range_prefix: unicode
    :param listen_range_prefix: **listen_range** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type peer_group: unicode
    :param peer_group: **listen_range** tuple argument:  Peer group name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.listen_range', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'listen_range', 'keyval': 'listen_range_prefix, peer_group', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'limit'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, listen_range=listen_range)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, listen_range=listen_range)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_local_as_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'local-as'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_log_dampening_debug_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'log-dampening-debug'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_maxas_limit_in_num_as_in_path_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.maxas_limit.in_', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.maxas_limit.in_', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.maxas_limit.in_', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'num-as-in-path'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_med_missing_as_worst_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'med-missing-as-worst'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_addr_advertisement_interval_delete(self, rbridge_id=None, neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.advertisement_interval', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.advertisement_interval', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.advertisement_interval', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'value'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_addr_advertisement_interval_value_delete(self, rbridge_id=None, neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.advertisement_interval', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.advertisement_interval', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.advertisement_interval', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'value'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_addr_as_override_delete(self, rbridge_id=None, neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'neighbor_addr', 'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'as-override'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_addr_bfd_bfd_enable_delete(self, rbridge_id=None, neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.bfd', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.bfd', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.bfd', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bfd-enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_addr_bfd_holdover_interval_delete(self, rbridge_id=None, neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.bfd', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.bfd', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.bfd', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'holdover-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_addr_bfd_interval_delete(self, rbridge_id=None, neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.bfd.interval', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.bfd.interval', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.bfd.interval', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_addr_bfd_interval_min_rx_delete(self, rbridge_id=None, neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.bfd.interval', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.bfd.interval', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.bfd.interval', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'min-rx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_addr_bfd_interval_min_tx_delete(self, rbridge_id=None, neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.bfd.interval', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.bfd.interval', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.bfd.interval', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'min-tx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_addr_bfd_interval_multiplier_delete(self, rbridge_id=None, neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.bfd.interval', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.bfd.interval', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.bfd.interval', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'multiplier'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_addr_capability_as4_disable_delete(self, rbridge_id=None, neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.af_neighbor_capability.as4', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.af_neighbor_capability.as4', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.af_neighbor_capability.as4', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'disable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_addr_capability_as4_enable_delete(self, rbridge_id=None, neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.af_neighbor_capability.as4', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.af_neighbor_capability.as4', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.af_neighbor_capability.as4', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_addr_description_delete(self, rbridge_id=None, neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'neighbor_addr', 'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'description'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_addr_ebgp_btsh_delete(self, rbridge_id=None, neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'neighbor_addr', 'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ebgp-btsh'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_addr_ebgp_multihop_delete(self, rbridge_id=None, neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.ebgp_multihop', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.ebgp_multihop', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.ebgp_multihop': [u'ebgp_multihop_flag', u'ebgp_multihop_count'], 'pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.ebgp_multihop': [u'ebgp_multihop_flag', u'ebgp_multihop_count']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_addr_ebgp_multihop_ebgp_multihop_count_delete(self, rbridge_id=None, neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.ebgp_multihop', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.ebgp_multihop', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.ebgp_multihop', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ebgp-multihop-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_addr_ebgp_multihop_ebgp_multihop_flag_delete(self, rbridge_id=None, neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.ebgp_multihop', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.ebgp_multihop', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.ebgp_multihop', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ebgp-multihop-flag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_addr_enforce_first_as_disable_delete(self, rbridge_id=None, neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.enforce_first_as', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.enforce_first_as', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.enforce_first_as', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'disable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_addr_enforce_first_as_enable_delete(self, rbridge_id=None, neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.enforce_first_as', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.enforce_first_as', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.enforce_first_as', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_addr_local_as_delete(self, rbridge_id=None, neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.local_as', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.local_as', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.local_as', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'local_as_value, no_prepend'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_addr_local_as_local_as_value_delete(self, rbridge_id=None, neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.local_as', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.local_as', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.local_as', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'local-as-value'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_addr_local_as_no_prepend_delete(self, rbridge_id=None, neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.local_as', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.local_as', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.local_as', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'no-prepend'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_addr_maxas_limit_in_disable_delete(self, rbridge_id=None, neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.maxas_limit.in_', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.maxas_limit.in_', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.maxas_limit.in_', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'disable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_addr_maxas_limit_in_num_as_in_as_path_delete(self, rbridge_id=None, neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.maxas_limit.in_', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.maxas_limit.in_', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.maxas_limit.in_', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'num-as-in-as-path'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_addr_next_hop_self_always_delete(self, rbridge_id=None, neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.next_hop_self', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.next_hop_self', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.next_hop_self', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'always'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_addr_next_hop_self_next_hop_self_status_delete(self, rbridge_id=None, neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.next_hop_self', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.next_hop_self', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.next_hop_self', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'next-hop-self-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_addr_password_delete(self, rbridge_id=None, neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'neighbor_addr', 'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'password'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_addr_peer_group_delete(self, rbridge_id=None, neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'neighbor_addr', 'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'peer-group'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_addr_remote_as_delete(self, rbridge_id=None, neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'neighbor_addr', 'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'remote-as'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_addr_remove_private_as_delete(self, rbridge_id=None, neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'neighbor_addr', 'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'remove-private-as'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_addr_shutdown_generate_rib_out_delete(self, rbridge_id=None, neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.shutdown', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.shutdown', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.shutdown', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'generate-rib-out'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_addr_shutdown_shutdown_status_delete(self, rbridge_id=None, neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.shutdown', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.shutdown', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.shutdown', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'shutdown-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_addr_soft_reconfiguration_inbound_delete(self, rbridge_id=None, neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.soft_reconfiguration', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.soft_reconfiguration', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.soft_reconfiguration', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'inbound'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_addr_static_network_edge_delete(self, rbridge_id=None, neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'neighbor_addr', 'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'static-network-edge'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_addr_timers_hold_time_delete(self, rbridge_id=None, neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.timers', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.timers', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.timers', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hold-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_addr_timers_keep_alive_delete(self, rbridge_id=None, neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.timers', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.timers', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.timers', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'keep-alive'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_addr_update_source_ethernet_delete(self, rbridge_id=None, neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source.ethernet_interface', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source.ethernet_interface', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source.ethernet_interface', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ethernet'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_addr_update_source_ethernet_interface_delete(self, rbridge_id=None, neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source.ethernet_interface', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source.ethernet_interface', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source.ethernet_interface', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'interface_type, ethernet'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source.ethernet_interface': [u'interface_type'], 'pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source.ethernet_interface': [u'interface_type'], 'pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source.ethernet_interface': [u'interface_type']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_addr_update_source_interface_type_delete(self, rbridge_id=None, neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source.ethernet_interface', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source.ethernet_interface', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source.ethernet_interface', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'interface-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_addr_update_source_loopback_delete(self, rbridge_id=None, neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'loopback'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_addr_update_source_port_channel_delete(self, rbridge_id=None, neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'port-channel'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_addr_update_source_sip_ipv4_address_delete(self, rbridge_id=None, neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'sip-ipv4-address'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_addr_update_source_ve_interface_delete(self, rbridge_id=None, neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 've-interface'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_ipv6_addr_advertisement_interval_delete(self, rbridge_id=None, neighbor_ipv6_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.advertisement_interval', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.advertisement_interval', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.advertisement_interval', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'value'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_ipv6_addr_advertisement_interval_value_delete(self, rbridge_id=None, neighbor_ipv6_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.advertisement_interval', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.advertisement_interval', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.advertisement_interval', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'value'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_ipv6_addr_as_override_delete(self, rbridge_id=None, neighbor_ipv6_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'neighbor_ipv6_addr', 'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'as-override'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_ipv6_addr_bfd_bfd_enable_delete(self, rbridge_id=None, neighbor_ipv6_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.bfd', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.bfd', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.bfd', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bfd-enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_ipv6_addr_bfd_holdover_interval_delete(self, rbridge_id=None, neighbor_ipv6_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.bfd', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.bfd', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.bfd', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'holdover-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_ipv6_addr_bfd_interval_delete(self, rbridge_id=None, neighbor_ipv6_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.bfd.interval', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.bfd.interval', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.bfd.interval', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_ipv6_addr_bfd_interval_min_rx_delete(self, rbridge_id=None, neighbor_ipv6_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.bfd.interval', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.bfd.interval', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.bfd.interval', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'min-rx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_ipv6_addr_bfd_interval_min_tx_delete(self, rbridge_id=None, neighbor_ipv6_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.bfd.interval', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.bfd.interval', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.bfd.interval', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'min-tx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_ipv6_addr_bfd_interval_multiplier_delete(self, rbridge_id=None, neighbor_ipv6_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.bfd.interval', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.bfd.interval', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.bfd.interval', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'multiplier'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_ipv6_addr_capability_as4_disable_delete(self, rbridge_id=None, neighbor_ipv6_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.af_neighbor_capability.as4', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.af_neighbor_capability.as4', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.af_neighbor_capability.as4', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'disable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_ipv6_addr_capability_as4_enable_delete(self, rbridge_id=None, neighbor_ipv6_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.af_neighbor_capability.as4', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.af_neighbor_capability.as4', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.af_neighbor_capability.as4', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_ipv6_addr_description_delete(self, rbridge_id=None, neighbor_ipv6_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'neighbor_ipv6_addr', 'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'description'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_ipv6_addr_ebgp_btsh_delete(self, rbridge_id=None, neighbor_ipv6_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'neighbor_ipv6_addr', 'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ebgp-btsh'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_ipv6_addr_ebgp_multihop_delete(self, rbridge_id=None, neighbor_ipv6_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.ebgp_multihop', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.ebgp_multihop', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.ebgp_multihop': [u'ebgp_multihop_flag', u'ebgp_multihop_count'], 'pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.ebgp_multihop': [u'ebgp_multihop_flag', u'ebgp_multihop_count']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_ipv6_addr_ebgp_multihop_ebgp_multihop_count_delete(self, rbridge_id=None, neighbor_ipv6_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.ebgp_multihop', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.ebgp_multihop', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.ebgp_multihop', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ebgp-multihop-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_ipv6_addr_ebgp_multihop_ebgp_multihop_flag_delete(self, rbridge_id=None, neighbor_ipv6_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.ebgp_multihop', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.ebgp_multihop', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.ebgp_multihop', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ebgp-multihop-flag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_ipv6_addr_enforce_first_as_disable_delete(self, rbridge_id=None, neighbor_ipv6_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.enforce_first_as', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.enforce_first_as', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.enforce_first_as', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'disable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_ipv6_addr_enforce_first_as_enable_delete(self, rbridge_id=None, neighbor_ipv6_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.enforce_first_as', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.enforce_first_as', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.enforce_first_as', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_ipv6_addr_local_as_delete(self, rbridge_id=None, neighbor_ipv6_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.local_as', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.local_as', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.local_as', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'local_as_value, no_prepend'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_ipv6_addr_local_as_local_as_value_delete(self, rbridge_id=None, neighbor_ipv6_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.local_as', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.local_as', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.local_as', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'local-as-value'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_ipv6_addr_local_as_no_prepend_delete(self, rbridge_id=None, neighbor_ipv6_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.local_as', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.local_as', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.local_as', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'no-prepend'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_ipv6_addr_maxas_limit_in_disable_delete(self, rbridge_id=None, neighbor_ipv6_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.maxas_limit.in_', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.maxas_limit.in_', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.maxas_limit.in_', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'disable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_ipv6_addr_maxas_limit_in_num_as_in_as_path_delete(self, rbridge_id=None, neighbor_ipv6_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.maxas_limit.in_', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.maxas_limit.in_', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.maxas_limit.in_', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'num-as-in-as-path'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_ipv6_addr_next_hop_self_always_delete(self, rbridge_id=None, neighbor_ipv6_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.next_hop_self', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.next_hop_self', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.next_hop_self', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'always'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_ipv6_addr_next_hop_self_next_hop_self_status_delete(self, rbridge_id=None, neighbor_ipv6_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.next_hop_self', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.next_hop_self', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.next_hop_self', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'next-hop-self-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_ipv6_addr_password_delete(self, rbridge_id=None, neighbor_ipv6_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'neighbor_ipv6_addr', 'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'password'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_ipv6_addr_peer_group_delete(self, rbridge_id=None, neighbor_ipv6_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'neighbor_ipv6_addr', 'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'peer-group'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_ipv6_addr_remote_as_delete(self, rbridge_id=None, neighbor_ipv6_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'neighbor_ipv6_addr', 'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'remote-as'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_ipv6_addr_remove_private_as_delete(self, rbridge_id=None, neighbor_ipv6_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'neighbor_ipv6_addr', 'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'remove-private-as'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_ipv6_addr_shutdown_generate_rib_out_delete(self, rbridge_id=None, neighbor_ipv6_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.shutdown', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.shutdown', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.shutdown', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'generate-rib-out'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_ipv6_addr_shutdown_shutdown_status_delete(self, rbridge_id=None, neighbor_ipv6_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.shutdown', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.shutdown', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.shutdown', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'shutdown-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_ipv6_addr_soft_reconfiguration_inbound_delete(self, rbridge_id=None, neighbor_ipv6_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.soft_reconfiguration', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.soft_reconfiguration', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.soft_reconfiguration', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'inbound'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_ipv6_addr_static_network_edge_delete(self, rbridge_id=None, neighbor_ipv6_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'neighbor_ipv6_addr', 'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'static-network-edge'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_ipv6_addr_timers_hold_time_delete(self, rbridge_id=None, neighbor_ipv6_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.timers', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.timers', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.timers', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hold-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_ipv6_addr_timers_keep_alive_delete(self, rbridge_id=None, neighbor_ipv6_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.timers', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.timers', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.timers', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'keep-alive'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_ipv6_addr_update_source_ethernet_delete(self, rbridge_id=None, neighbor_ipv6_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source.ethernet_interface', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source.ethernet_interface', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source.ethernet_interface', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ethernet'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_ipv6_addr_update_source_ethernet_interface_delete(self, rbridge_id=None, neighbor_ipv6_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source.ethernet_interface', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source.ethernet_interface', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source.ethernet_interface', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'interface_type, ethernet'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source.ethernet_interface': [u'interface_type'], 'pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source.ethernet_interface': [u'interface_type'], 'pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source.ethernet_interface': [u'interface_type']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_ipv6_addr_update_source_interface_type_delete(self, rbridge_id=None, neighbor_ipv6_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source.ethernet_interface', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source.ethernet_interface', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source.ethernet_interface', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'interface-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_ipv6_addr_update_source_loopback_delete(self, rbridge_id=None, neighbor_ipv6_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'loopback'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_ipv6_addr_update_source_port_channel_delete(self, rbridge_id=None, neighbor_ipv6_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'port-channel'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_ipv6_addr_update_source_sip_ipv6_address_delete(self, rbridge_id=None, neighbor_ipv6_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'sip-ipv6-address'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_ipv6_addr_update_source_ve_interface_delete(self, rbridge_id=None, neighbor_ipv6_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 've-interface'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_advertisement_interval_delete(self, rbridge_id=None, neighbor_peer_grp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.advertisement_interval', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.advertisement_interval', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.advertisement_interval', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'value'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_advertisement_interval_value_delete(self, rbridge_id=None, neighbor_peer_grp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.advertisement_interval', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.advertisement_interval', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.advertisement_interval', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'value'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_alternate_as_delete(self, rbridge_id=None, neighbor_peer_grp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.alternate_as', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_alternate_as_add_delete(self, rbridge_id=None, neighbor_peer_grp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.alternate_as', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'add'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_alternate_as_remove_delete(self, rbridge_id=None, neighbor_peer_grp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.alternate_as', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'remove'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_as_override_delete(self, rbridge_id=None, neighbor_peer_grp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'neighbor_peer_grp', 'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'as-override'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_bfd_bfd_enable_delete(self, rbridge_id=None, neighbor_peer_grp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.bfd', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.bfd', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.bfd', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bfd-enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_bfd_holdover_interval_delete(self, rbridge_id=None, neighbor_peer_grp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.bfd', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.bfd', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.bfd', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'holdover-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_bfd_interval_delete(self, rbridge_id=None, neighbor_peer_grp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.bfd.interval', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.bfd.interval', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.bfd.interval', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_bfd_interval_min_rx_delete(self, rbridge_id=None, neighbor_peer_grp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.bfd.interval', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.bfd.interval', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.bfd.interval', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'min-rx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_bfd_interval_min_tx_delete(self, rbridge_id=None, neighbor_peer_grp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.bfd.interval', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.bfd.interval', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.bfd.interval', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'min-tx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_bfd_interval_multiplier_delete(self, rbridge_id=None, neighbor_peer_grp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.bfd.interval', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.bfd.interval', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.bfd.interval', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'multiplier'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_capability_as4_disable_delete(self, rbridge_id=None, neighbor_peer_grp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.af_neighbor_capability.as4', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.af_neighbor_capability.as4', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.af_neighbor_capability.as4', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'disable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_capability_as4_enable_delete(self, rbridge_id=None, neighbor_peer_grp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.af_neighbor_capability.as4', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.af_neighbor_capability.as4', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.af_neighbor_capability.as4', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_description_delete(self, rbridge_id=None, neighbor_peer_grp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'neighbor_peer_grp', 'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'description'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_ebgp_btsh_delete(self, rbridge_id=None, neighbor_peer_grp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'neighbor_peer_grp', 'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ebgp-btsh'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_ebgp_multihop_delete(self, rbridge_id=None, neighbor_peer_grp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.ebgp_multihop', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.ebgp_multihop', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.ebgp_multihop': [u'ebgp_multihop_flag', u'ebgp_multihop_count'], 'pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.ebgp_multihop': [u'ebgp_multihop_flag', u'ebgp_multihop_count']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_ebgp_multihop_ebgp_multihop_count_delete(self, rbridge_id=None, neighbor_peer_grp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.ebgp_multihop', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.ebgp_multihop', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.ebgp_multihop', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ebgp-multihop-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_ebgp_multihop_ebgp_multihop_flag_delete(self, rbridge_id=None, neighbor_peer_grp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.ebgp_multihop', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.ebgp_multihop', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.ebgp_multihop', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ebgp-multihop-flag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_enforce_first_as_disable_delete(self, rbridge_id=None, neighbor_peer_grp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.enforce_first_as', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.enforce_first_as', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.enforce_first_as', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'disable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_enforce_first_as_enable_delete(self, rbridge_id=None, neighbor_peer_grp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.enforce_first_as', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.enforce_first_as', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.enforce_first_as', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_local_as_delete(self, rbridge_id=None, neighbor_peer_grp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.local_as', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.local_as', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.local_as', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'local_as_value, no_prepend'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_local_as_local_as_value_delete(self, rbridge_id=None, neighbor_peer_grp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.local_as', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.local_as', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.local_as', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'local-as-value'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_local_as_no_prepend_delete(self, rbridge_id=None, neighbor_peer_grp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.local_as', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.local_as', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.local_as', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'no-prepend'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_maxas_limit_in_disable_delete(self, rbridge_id=None, neighbor_peer_grp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.maxas_limit.in_', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.maxas_limit.in_', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.maxas_limit.in_', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'disable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_maxas_limit_in_num_as_in_as_path_delete(self, rbridge_id=None, neighbor_peer_grp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.maxas_limit.in_', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.maxas_limit.in_', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.maxas_limit.in_', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'num-as-in-as-path'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_next_hop_self_always_delete(self, rbridge_id=None, neighbor_peer_grp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.next_hop_self', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.next_hop_self', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.next_hop_self', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'always'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_next_hop_self_next_hop_self_status_delete(self, rbridge_id=None, neighbor_peer_grp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.next_hop_self', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.next_hop_self', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.next_hop_self', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'next-hop-self-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_password_delete(self, rbridge_id=None, neighbor_peer_grp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'neighbor_peer_grp', 'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'password'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_peer_group_delete(self, rbridge_id=None, neighbor_peer_grp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'neighbor_peer_grp', 'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'peer-group'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_remote_as_delete(self, rbridge_id=None, neighbor_peer_grp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'neighbor_peer_grp', 'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'remote-as'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_remove_private_as_delete(self, rbridge_id=None, neighbor_peer_grp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'neighbor_peer_grp', 'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'remove-private-as'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_shutdown_generate_rib_out_delete(self, rbridge_id=None, neighbor_peer_grp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.shutdown', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.shutdown', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.shutdown', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'generate-rib-out'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_shutdown_shutdown_status_delete(self, rbridge_id=None, neighbor_peer_grp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.shutdown', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.shutdown', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.shutdown', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'shutdown-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_soft_reconfiguration_inbound_delete(self, rbridge_id=None, neighbor_peer_grp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.soft_reconfiguration', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.soft_reconfiguration', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.soft_reconfiguration', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'inbound'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_static_network_edge_delete(self, rbridge_id=None, neighbor_peer_grp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'neighbor_peer_grp', 'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'static-network-edge'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_timers_hold_time_delete(self, rbridge_id=None, neighbor_peer_grp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.timers', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.timers', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.timers', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hold-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_timers_keep_alive_delete(self, rbridge_id=None, neighbor_peer_grp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.timers', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.timers', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.timers', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'keep-alive'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_update_source_ethernet_delete(self, rbridge_id=None, neighbor_peer_grp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source.ethernet_interface', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source.ethernet_interface', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source.ethernet_interface', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ethernet'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_update_source_ethernet_interface_delete(self, rbridge_id=None, neighbor_peer_grp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source.ethernet_interface', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source.ethernet_interface', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source.ethernet_interface', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'interface_type, ethernet'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source.ethernet_interface': [u'interface_type'], 'pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source.ethernet_interface': [u'interface_type'], 'pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source.ethernet_interface': [u'interface_type']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_update_source_interface_type_delete(self, rbridge_id=None, neighbor_peer_grp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source.ethernet_interface', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source.ethernet_interface', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source.ethernet_interface', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'interface-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_update_source_loopback_delete(self, rbridge_id=None, neighbor_peer_grp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'loopback'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_update_source_port_channel_delete(self, rbridge_id=None, neighbor_peer_grp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'port-channel'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_update_source_sip_ipv4_address_delete(self, rbridge_id=None, neighbor_peer_grp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'sip-ipv4-address'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_update_source_ve_interface_delete(self, rbridge_id=None, neighbor_peer_grp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 've-interface'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_router_bgp_attributes_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes": {"fast_external_fallover": "fast_external_fallover", "compare_med_empty_aspath": "compare_med_empty_aspath", "default_local_preference": "default_local_preference", "med_missing_as_worst": "med_missing_as_worst", "enforce_first_as": "enforce_first_as", "always_compare_med": "always_compare_med", "local_as": "local_as", "log_dampening_debug": "log_dampening_debug", "install_igp_cost": "install_igp_cost", "compare_routerid": "compare_routerid", "as_path_ignore": "as_path_ignore"}, "pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes": {}, "pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_timers_hold_time_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.timers', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.timers', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.timers', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hold-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_bgp_timers_keep_alive_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.router_bgp.router_bgp_attributes.timers', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.router_bgp.router_bgp_attributes.timers', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.router_bgp.router_bgp_attributes.timers', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'keep-alive'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_hide_pim_holder_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.hide_pim_holder', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.hide_pim_holder', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.hide_pim_holder', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ospf', 'keyval': 'vrf', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_area_delete(self, rbridge_id=None, ospf=None, area=None, normal=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    **Instance Keyword Argument Tuple**:

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    **Instance Argument(s)**:

    :type normal: YANGBool
    :param normal: Keyword argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.area', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.area', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.area', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'area', 'keyval': 'area_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area, normal=normal)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area, normal=normal)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_area_normal_delete(self, rbridge_id=None, ospf=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    **Instance Keyword Argument Tuple**:

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.area', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.area', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.area', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'area', 'keyval': 'area_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'normal'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_area_nssa_delete(self, rbridge_id=None, ospf=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.area.nssa', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.area.nssa', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.area.nssa', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v7_1_0.rbridge_id.router.ospf.area.nssa": {}, "pybind.nos.v6_0_2c.rbridge_id.router.ospf.area.nssa": {"default_information_originate": "default_information_originate"}, "pybind.nos.v7_0_1b.rbridge_id.router.ospf.area.nssa": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_area_nssa_default_information_metric_metric_delete(self, rbridge_id=None, ospf=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.area', u'area')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.ospf.area.nssa.default_information_metric', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.area.nssa.default_information_metric', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_area_nssa_default_information_metric_metric_type_delete(self, rbridge_id=None, ospf=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.area', u'area')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.ospf.area.nssa.default_information_metric', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.area.nssa.default_information_metric', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_area_nssa_default_information_originate_delete(self, rbridge_id=None, ospf=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.area.nssa', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.area.nssa', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.area.nssa', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'default-information-originate'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_area_nssa_metric_delete(self, rbridge_id=None, ospf=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.area.nssa.metric', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.area.nssa.metric', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.area.nssa.metric', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'nssa_value, nssa_no_summary'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_area_nssa_no_redistribution_delete(self, rbridge_id=None, ospf=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.area', u'area')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.ospf.area.nssa', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.area.nssa', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'no-redistribution'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_area_nssa_no_summary_delete(self, rbridge_id=None, ospf=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.area.nssa.metric', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.area.nssa.metric', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.area.nssa.metric', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'no-summary'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_area_nssa_nssa_value_delete(self, rbridge_id=None, ospf=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.area.nssa.metric', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.area.nssa.metric', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.area.nssa.metric', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'nssa-value'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_area_nssa_translator_always_delete(self, rbridge_id=None, ospf=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.area', u'area')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.ospf.area.nssa', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.area.nssa', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'translator-always'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_area_nssa_translator_interval_delete(self, rbridge_id=None, ospf=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.area', u'area')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.ospf.area.nssa', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.area.nssa', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'translator-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_area_prefix_list_in_delete(self, rbridge_id=None, ospf=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.area', u'area')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.ospf.area.prefix_list.direction_in', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.area.prefix_list.direction_in', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'in'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_area_prefix_list_out_delete(self, rbridge_id=None, ospf=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.area', u'area')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.ospf.area.prefix_list.direction_out', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.area.prefix_list.direction_out', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'out'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_area_prefix_list_prefix_list_delete(self, rbridge_id=None, ospf=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.area', u'area')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.ospf.area.prefix_list.direction_in', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.area.prefix_list.direction_in', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'prefix-list'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_area_prefix_list_prefix_list_direction_out_delete(self, rbridge_id=None, ospf=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.area', u'area')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.ospf.area.prefix_list.direction_out', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.area.prefix_list.direction_out', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'prefix-list'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_area_range_delete(self, rbridge_id=None, ospf=None, area=None, range=None, range_effect=None, range_cost=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    **Instance Keyword Argument Tuple**:

    :type range: range_address, range_mask, range_effect, range_cost
    :param range: Keyword argument tuple.

    :type range_address: unicode
    :param range_address: **range** tuple argument:  A.B.C.D   IP address to match

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type range_mask: unicode
    :param range_mask: **range** tuple argument:  A.B.C.D   IP mask for address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type range_effect: unicode
    :param range_effect: **range** tuple argument:  Advertise/Do not advertise this type-3 summarization

        * enumeration restriction: ::

            ['advertise', 'not-advertise']

    :type range_cost: long
    :param range_cost: **range** tuple argument:  Configure area range cost

        * range restriction: ::

            ['0..4294967295']

    **Instance Argument(s)**:

    :type range_effect: unicode
    :param range_effect: Advertise/Do not advertise this type-3 summarization

        * enumeration restriction: ::

            ['advertise', 'not-advertise']

    :type range_cost: long
    :param range_cost: Configure area range cost

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.area.range', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.area.range', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.area.range', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'range', 'keyval': 'range_address, range_mask', 'extra_keyval': 'range_address, range_mask, range_effect, range_cost'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area, range=range, range_effect=range_effect, range_cost=range_cost)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area, range=range, range_effect=range_effect, range_cost=range_cost)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_area_range_cost_delete(self, rbridge_id=None, ospf=None, area=None, range=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    **Instance Keyword Argument Tuple**:

    :type range: range_address, range_mask
    :param range: Keyword argument tuple.

    :type range_address: unicode
    :param range_address: **range** tuple argument:  A.B.C.D   IP address to match

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type range_mask: unicode
    :param range_mask: **range** tuple argument:  A.B.C.D   IP mask for address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.area.range', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.area.range', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.area.range', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'range', 'keyval': 'range_address, range_mask', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cost'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area, range=range)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area, range=range)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_area_range_range_effect_delete(self, rbridge_id=None, ospf=None, area=None, range=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    **Instance Keyword Argument Tuple**:

    :type range: range_address, range_mask
    :param range: Keyword argument tuple.

    :type range_address: unicode
    :param range_address: **range** tuple argument:  A.B.C.D   IP address to match

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type range_mask: unicode
    :param range_mask: **range** tuple argument:  A.B.C.D   IP mask for address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.area.range', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.area.range', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.area.range', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'range', 'keyval': 'range_address, range_mask', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'range-effect'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area, range=range)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area, range=range)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_area_stub_delete(self, rbridge_id=None, ospf=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.area.stub', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.area.stub', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.area.stub', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_area_stub_metric_delete(self, rbridge_id=None, ospf=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.area.stub.metric', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.area.stub.metric', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.area.stub.metric', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'stub_value, no_summary'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_area_stub_no_summary_delete(self, rbridge_id=None, ospf=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.area.stub.metric', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.area.stub.metric', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.area.stub.metric', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'no-summary'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_area_stub_stub_value_delete(self, rbridge_id=None, ospf=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.area.stub.metric', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.area.stub.metric', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.area.stub.metric', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'stub-value'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_area_virtual_link_delete(self, rbridge_id=None, ospf=None, area=None, virtual_link=None, dead_interval=None, hello_interval=None, retransmit_interval=None, transmit_delay=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    **Instance Keyword Argument Tuple**:

    :type virtual_link: virt_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virt_link_neighbor: unicode
    :param virt_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Argument(s)**:

    :type dead_interval: long
    :param dead_interval: Interval after which a neighbor is declared dead

        * range restriction: ::

            ['0..4294967295']

    :type hello_interval: long
    :param hello_interval: Time between HELLO packets

        * range restriction: ::

            ['0..4294967295']

    :type retransmit_interval: long
    :param retransmit_interval: Time between retransmitting lost link state   advertisements

        * range restriction: ::

            ['0..4294967295']

    :type transmit_delay: long
    :param transmit_delay: Link state transmit delay

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.area.virtual_link', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.area.virtual_link', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.area.virtual_link', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'virtual_link', 'keyval': 'virt_link_neighbor', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link, dead_interval=dead_interval, hello_interval=hello_interval, retransmit_interval=retransmit_interval, transmit_delay=transmit_delay)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link, dead_interval=dead_interval, hello_interval=hello_interval, retransmit_interval=retransmit_interval, transmit_delay=transmit_delay)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_area_virtual_link_authentication_key_delete(self, rbridge_id=None, ospf=None, area=None, virtual_link=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virt_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virt_link_neighbor: unicode
    :param virt_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.area.virtual_link.authentication_key', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.area.virtual_link.authentication_key', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.area.virtual_link.authentication_key', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_area_virtual_link_authentication_key_auth_key_delete(self, rbridge_id=None, ospf=None, area=None, virtual_link=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virt_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virt_link_neighbor: unicode
    :param virt_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.area.virtual_link.authentication_key.auth_key_table', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.area.virtual_link.authentication_key.auth_key_table', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.area.virtual_link.authentication_key.auth_key_table', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'auth-key'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_area_virtual_link_authentication_key_auth_key_table_delete(self, rbridge_id=None, ospf=None, area=None, virtual_link=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virt_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virt_link_neighbor: unicode
    :param virt_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.area.virtual_link.authentication_key.auth_key_table', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.area.virtual_link.authentication_key.auth_key_table', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.area.virtual_link.authentication_key.auth_key_table', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'encrypttype, auth_key'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_area_virtual_link_authentication_key_encrypttype_delete(self, rbridge_id=None, ospf=None, area=None, virtual_link=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virt_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virt_link_neighbor: unicode
    :param virt_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.area.virtual_link.authentication_key.auth_key_table', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.area.virtual_link.authentication_key.auth_key_table', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.area.virtual_link.authentication_key.auth_key_table', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'encrypttype'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_area_virtual_link_authentication_key_no_encrypt_auth_key_delete(self, rbridge_id=None, ospf=None, area=None, virtual_link=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virt_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virt_link_neighbor: unicode
    :param virt_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.area.virtual_link.authentication_key.no_encrypt_auth_key_table', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.area.virtual_link.authentication_key.no_encrypt_auth_key_table', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.area.virtual_link.authentication_key.no_encrypt_auth_key_table', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'no-encrypt-auth-key'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_area_virtual_link_authentication_key_no_encrypt_auth_key_table_delete(self, rbridge_id=None, ospf=None, area=None, virtual_link=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virt_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virt_link_neighbor: unicode
    :param virt_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.area.virtual_link.authentication_key.no_encrypt_auth_key_table', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.area.virtual_link.authentication_key.no_encrypt_auth_key_table', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.area.virtual_link.authentication_key.no_encrypt_auth_key_table', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_area_virtual_link_dead_interval_delete(self, rbridge_id=None, ospf=None, area=None, virtual_link=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    **Instance Keyword Argument Tuple**:

    :type virtual_link: virt_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virt_link_neighbor: unicode
    :param virt_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.area.virtual_link', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.area.virtual_link', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.area.virtual_link', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'virtual_link', 'keyval': 'virt_link_neighbor', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dead-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_area_virtual_link_hello_interval_delete(self, rbridge_id=None, ospf=None, area=None, virtual_link=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    **Instance Keyword Argument Tuple**:

    :type virtual_link: virt_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virt_link_neighbor: unicode
    :param virt_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.area.virtual_link', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.area.virtual_link', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.area.virtual_link', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'virtual_link', 'keyval': 'virt_link_neighbor', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hello-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_area_virtual_link_md5_authentication_key_delete(self, rbridge_id=None, ospf=None, area=None, virtual_link=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virt_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virt_link_neighbor: unicode
    :param virt_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.area.virtual_link.md5_authentication.no_encrypt_key_table', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.area.virtual_link.md5_authentication.no_encrypt_key_table', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.area.virtual_link.md5_authentication.no_encrypt_key_table', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'key'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_area_virtual_link_md5_authentication_key_activation_wait_time_delete(self, rbridge_id=None, ospf=None, area=None, virtual_link=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virt_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virt_link_neighbor: unicode
    :param virt_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.area.virtual_link.md5_authentication', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.area.virtual_link.md5_authentication', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.area.virtual_link.md5_authentication', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'key-activation-wait-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_area_virtual_link_md5_authentication_key_id_delete(self, rbridge_id=None, ospf=None, area=None, virtual_link=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virt_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virt_link_neighbor: unicode
    :param virt_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.area.virtual_link.md5_authentication.no_encrypt_key_table', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.area.virtual_link.md5_authentication.no_encrypt_key_table', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.area.virtual_link.md5_authentication.no_encrypt_key_table', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'key-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_area_virtual_link_md5_authentication_key_id_key_delete(self, rbridge_id=None, ospf=None, area=None, virtual_link=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virt_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virt_link_neighbor: unicode
    :param virt_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.area.virtual_link.md5_authentication.key_table', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.area.virtual_link.md5_authentication.key_table', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.area.virtual_link.md5_authentication.key_table', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'key'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_area_virtual_link_md5_authentication_key_id_key_id_delete(self, rbridge_id=None, ospf=None, area=None, virtual_link=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virt_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virt_link_neighbor: unicode
    :param virt_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.area.virtual_link.md5_authentication.key_table', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.area.virtual_link.md5_authentication.key_table', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.area.virtual_link.md5_authentication.key_table', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'key-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_area_virtual_link_md5_authentication_key_id_md5_authentication_key_delete(self, rbridge_id=None, ospf=None, area=None, virtual_link=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virt_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virt_link_neighbor: unicode
    :param virt_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.area.virtual_link.md5_authentication.key_table', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.area.virtual_link.md5_authentication.key_table', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.area.virtual_link.md5_authentication.key_table', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'md5-authentication-key'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_area_virtual_link_retransmit_interval_delete(self, rbridge_id=None, ospf=None, area=None, virtual_link=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    **Instance Keyword Argument Tuple**:

    :type virtual_link: virt_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virt_link_neighbor: unicode
    :param virt_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.area.virtual_link', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.area.virtual_link', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.area.virtual_link', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'virtual_link', 'keyval': 'virt_link_neighbor', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'retransmit-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_area_virtual_link_transmit_delay_delete(self, rbridge_id=None, ospf=None, area=None, virtual_link=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    **Instance Keyword Argument Tuple**:

    :type virtual_link: virt_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virt_link_neighbor: unicode
    :param virt_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.area.virtual_link', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.area.virtual_link', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.area.virtual_link', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'virtual_link', 'keyval': 'virt_link_neighbor', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'transmit-delay'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_auto_cost_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.auto_cost', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.auto_cost', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.auto_cost', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_auto_cost_reference_bandwidth_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.auto_cost.reference_bandwidth', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.auto_cost.reference_bandwidth', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.auto_cost.reference_bandwidth', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_auto_cost_reference_bandwidth_ref_bandwidth_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.auto_cost.reference_bandwidth', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.auto_cost.reference_bandwidth', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.auto_cost.reference_bandwidth', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ref-bandwidth'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_auto_cost_reference_bandwidth_use_active_ports_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.auto_cost.reference_bandwidth', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.auto_cost.reference_bandwidth', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.auto_cost.reference_bandwidth', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'use-active-ports'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_bfd_bfd_enable_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.global_bfd', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.global_bfd', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.global_bfd', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bfd-enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_bfd_holdover_interval_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.global_bfd', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.global_bfd', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.global_bfd', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'holdover-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_database_overflow_interval_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ospf', 'keyval': 'vrf', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'database-overflow-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_default_information_originate_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.default_information_originate', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.default_information_originate', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.default_information_originate', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'always, def_orig_metric, def_orig_metric_type, def_orig_route_map'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_default_information_originate_always_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.default_information_originate', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.default_information_originate', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.default_information_originate', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'always'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_default_information_originate_metric_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.default_information_originate', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.default_information_originate', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.default_information_originate', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_default_information_originate_metric_type_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.default_information_originate', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.default_information_originate', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.default_information_originate', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_default_information_originate_route_map_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.default_information_originate', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.default_information_originate', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.default_information_originate', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_default_metric_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ospf', 'keyval': 'vrf', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'default-metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_default_passive_interface_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ospf', 'keyval': 'vrf', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'default-passive-interface'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_deny_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.deny', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.deny', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.deny', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_deny_redistribute_delete(self, rbridge_id=None, ospf=None, redistribute=None, address=None, mask=None, set_metric_val=None, match_metric_val=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    **Instance Keyword Argument Tuple**:

    :type redistribute: redist_value, route_option, address, mask, set_metric_val, match_metric_val
    :param redistribute: Keyword argument tuple.

    :type redist_value: long
    :param redist_value: **redistribute** tuple argument:  Number

        * range restriction: ::

            ['0..4294967295']

    :type route_option: unicode
    :param route_option: **redistribute** tuple argument:  OSPF route option

        * enumeration restriction: ::

            ['connected', 'all', 'static']

    :type address: unicode
    :param address: **redistribute** tuple argument:  IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type mask: unicode
    :param mask: **redistribute** tuple argument:  Subnet Mask

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type set_metric_val: long
    :param set_metric_val: **redistribute** tuple argument:  Metric value

        * range restriction: ::

            ['0..4294967295']

    :type match_metric_val: long
    :param match_metric_val: **redistribute** tuple argument:  Metric value

        * range restriction: ::

            ['0..4294967295']

    **Instance Argument(s)**:

    :type address: unicode
    :param address: IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type mask: unicode
    :param mask: Subnet Mask

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type set_metric_val: long
    :param set_metric_val: Metric value

        * range restriction: ::

            ['0..4294967295']

    :type match_metric_val: long
    :param match_metric_val: Metric value

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.deny.redistribute', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.deny.redistribute', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.deny.redistribute', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'redistribute', 'keyval': 'redist_value, route_option', 'extra_keyval': 'redist_value, route_option, address, mask, set_metric_val, match_metric_val'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, redistribute=redistribute, address=address, mask=mask, set_metric_val=set_metric_val, match_metric_val=match_metric_val)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, redistribute=redistribute, address=address, mask=mask, set_metric_val=set_metric_val, match_metric_val=match_metric_val)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_deny_redistribute_address_delete(self, rbridge_id=None, ospf=None, redistribute=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    **Instance Keyword Argument Tuple**:

    :type redistribute: redist_value, route_option
    :param redistribute: Keyword argument tuple.

    :type redist_value: long
    :param redist_value: **redistribute** tuple argument:  Number

        * range restriction: ::

            ['0..4294967295']

    :type route_option: unicode
    :param route_option: **redistribute** tuple argument:  OSPF route option

        * enumeration restriction: ::

            ['connected', 'all', 'static']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.deny.redistribute', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.deny.redistribute', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.deny.redistribute', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'redistribute', 'keyval': 'redist_value, route_option', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'address'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, redistribute=redistribute)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, redistribute=redistribute)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_deny_redistribute_mask_delete(self, rbridge_id=None, ospf=None, redistribute=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    **Instance Keyword Argument Tuple**:

    :type redistribute: redist_value, route_option
    :param redistribute: Keyword argument tuple.

    :type redist_value: long
    :param redist_value: **redistribute** tuple argument:  Number

        * range restriction: ::

            ['0..4294967295']

    :type route_option: unicode
    :param route_option: **redistribute** tuple argument:  OSPF route option

        * enumeration restriction: ::

            ['connected', 'all', 'static']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.deny.redistribute', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.deny.redistribute', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.deny.redistribute', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'redistribute', 'keyval': 'redist_value, route_option', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mask'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, redistribute=redistribute)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, redistribute=redistribute)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_deny_redistribute_match_metric_delete(self, rbridge_id=None, ospf=None, redistribute=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    **Instance Keyword Argument Tuple**:

    :type redistribute: redist_value, route_option
    :param redistribute: Keyword argument tuple.

    :type redist_value: long
    :param redist_value: **redistribute** tuple argument:  Number

        * range restriction: ::

            ['0..4294967295']

    :type route_option: unicode
    :param route_option: **redistribute** tuple argument:  OSPF route option

        * enumeration restriction: ::

            ['connected', 'all', 'static']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.deny.redistribute', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.deny.redistribute', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.deny.redistribute', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'redistribute', 'keyval': 'redist_value, route_option', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'match-metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, redistribute=redistribute)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, redistribute=redistribute)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_deny_redistribute_set_metric_delete(self, rbridge_id=None, ospf=None, redistribute=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    **Instance Keyword Argument Tuple**:

    :type redistribute: redist_value, route_option
    :param redistribute: Keyword argument tuple.

    :type redist_value: long
    :param redist_value: **redistribute** tuple argument:  Number

        * range restriction: ::

            ['0..4294967295']

    :type route_option: unicode
    :param route_option: **redistribute** tuple argument:  OSPF route option

        * enumeration restriction: ::

            ['connected', 'all', 'static']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.deny.redistribute', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.deny.redistribute', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.deny.redistribute', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'redistribute', 'keyval': 'redist_value, route_option', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'set-metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, redistribute=redistribute)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, redistribute=redistribute)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_distance_delete(self, rbridge_id=None, ospf=None, distance=None, dist_value=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    **Instance Keyword Argument Tuple**:

    :type distance: route_type
    :param distance: Keyword argument tuple.

    :type route_type: unicode
    :param route_type: **distance** tuple argument:  The type of route propogation

        * enumeration restriction: ::

            ['intra-area', 'external', 'inter-area']

    **Instance Argument(s)**:

    :type dist_value: long
    :param dist_value: The distance for a given type of route

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.distance', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.distance', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.distance', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'distance', 'keyval': 'route_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, distance=distance, dist_value=dist_value)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, distance=distance, dist_value=dist_value)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_distance_dist_value_delete(self, rbridge_id=None, ospf=None, distance=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    **Instance Keyword Argument Tuple**:

    :type distance: route_type
    :param distance: Keyword argument tuple.

    :type route_type: unicode
    :param route_type: **distance** tuple argument:  The type of route propogation

        * enumeration restriction: ::

            ['intra-area', 'external', 'inter-area']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.distance', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.distance', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.distance', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'distance', 'keyval': 'route_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dist-value'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, distance=distance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, distance=distance)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_distribute_list_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.distribute_list', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.distribute_list', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.distribute_list', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_distribute_list_route_map_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.distribute_list.route_map', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.distribute_list.route_map', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.distribute_list.route_map', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'route_map, in_'}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v7_0_1b.rbridge_id.router.ospf.distribute_list.route_map": {"route_map": "route_map"}, "pybind.nos.v6_0_2c.rbridge_id.router.ospf.distribute_list.route_map": {"route_map": "route_map", "in_": "in_"}, "pybind.nos.v7_1_0.rbridge_id.router.ospf.distribute_list.route_map": {"route_map": "route_map"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_distribute_list_route_map_in_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.distribute_list.route_map', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.distribute_list.route_map', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.distribute_list.route_map', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v7_0_1b.rbridge_id.router.ospf.distribute_list.route_map": {}, "pybind.nos.v6_0_2c.rbridge_id.router.ospf.distribute_list.route_map": {"in_": "in_"}, "pybind.nos.v7_1_0.rbridge_id.router.ospf.distribute_list.route_map": {}}
    rest_leaf_name = 'in'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_distribute_list_route_map_route_map_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.distribute_list.route_map', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.distribute_list.route_map', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.distribute_list.route_map', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_external_lsdb_limit_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ospf', 'keyval': 'vrf', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'external-lsdb-limit'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_graceful_restart_graceful_restart_enable_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.graceful_restart', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.graceful_restart', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.graceful_restart', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'graceful-restart-enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_graceful_restart_helper_disable_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.graceful_restart', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.graceful_restart', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.graceful_restart', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'helper-disable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_graceful_restart_helper_strict_lsa_checking_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.ospf.graceful_restart', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.graceful_restart', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'helper-strict-lsa-checking'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_graceful_restart_restart_time_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.graceful_restart', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.graceful_restart', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.graceful_restart', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'restart-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_log_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.log', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.log', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.log', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_log_adjacency_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.log.adjacency', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.log.adjacency', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.log.adjacency', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_log_adjacency_dr_only_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.log.adjacency', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.log.adjacency', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.log.adjacency', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dr-only'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_log_all_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.log', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.log', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.log', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'all'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_log_bad_packet_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.log.bad_packet', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.log.bad_packet', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.log.bad_packet', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_log_bad_packet_checksum_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.log.bad_packet', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.log.bad_packet', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.log.bad_packet', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'checksum'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_log_database_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.log', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.log', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.log', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'database'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_log_retransmit_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.log', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.log', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.log', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'retransmit'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_max_metric_router_lsa_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.max_metric.router_lsa', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.max_metric.router_lsa', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.max_metric.router_lsa', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_max_metric_router_lsa_all_lsas_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.max_metric.router_lsa', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.max_metric.router_lsa', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.max_metric.router_lsa', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'all-lsas'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_max_metric_router_lsa_all_vrfs_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.max_metric.router_lsa', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.max_metric.router_lsa', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.max_metric.router_lsa', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'all-vrfs'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_max_metric_router_lsa_external_lsa_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.max_metric.router_lsa.external_lsa', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.max_metric.router_lsa.external_lsa', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.max_metric.router_lsa.external_lsa', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_max_metric_router_lsa_external_lsa_external_lsa_val_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.max_metric.router_lsa.external_lsa', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.max_metric.router_lsa.external_lsa', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.max_metric.router_lsa.external_lsa', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'external-lsa-val'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_max_metric_router_lsa_link_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.max_metric.router_lsa.link', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.max_metric.router_lsa.link', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.max_metric.router_lsa.link', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_max_metric_router_lsa_link_all_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.max_metric.router_lsa.link', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.max_metric.router_lsa.link', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.max_metric.router_lsa.link', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'all'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_max_metric_router_lsa_link_ptp_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.max_metric.router_lsa.link', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.max_metric.router_lsa.link', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.max_metric.router_lsa.link', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ptp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_max_metric_router_lsa_link_stub_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.max_metric.router_lsa.link', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.max_metric.router_lsa.link', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.max_metric.router_lsa.link', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'stub'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_max_metric_router_lsa_link_transit_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.max_metric.router_lsa.link', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.max_metric.router_lsa.link', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.max_metric.router_lsa.link', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'transit'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_max_metric_router_lsa_on_startup_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.max_metric.router_lsa.on_startup', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.max_metric.router_lsa.on_startup', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.max_metric.router_lsa.on_startup', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_max_metric_router_lsa_on_startup_all_lsas_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.max_metric.router_lsa.on_startup', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.max_metric.router_lsa.on_startup', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.max_metric.router_lsa.on_startup', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'all-lsas'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_max_metric_router_lsa_on_startup_external_lsa_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.max_metric.router_lsa.on_startup.external_lsa_onstartup', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.max_metric.router_lsa.on_startup.external_lsa_onstartup', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.max_metric.router_lsa.on_startup.external_lsa_onstartup', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_max_metric_router_lsa_on_startup_external_lsa_external_lsa_val_onstartup_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.max_metric.router_lsa.on_startup.external_lsa_onstartup', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.max_metric.router_lsa.on_startup.external_lsa_onstartup', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.max_metric.router_lsa.on_startup.external_lsa_onstartup', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'external-lsa-val-onstartup'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_max_metric_router_lsa_on_startup_link_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.max_metric.router_lsa.on_startup.link_onstartup', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.max_metric.router_lsa.on_startup.link_onstartup', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.max_metric.router_lsa.on_startup.link_onstartup', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_max_metric_router_lsa_on_startup_link_all_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.max_metric.router_lsa.on_startup.link_onstartup', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.max_metric.router_lsa.on_startup.link_onstartup', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.max_metric.router_lsa.on_startup.link_onstartup', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'all'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_max_metric_router_lsa_on_startup_link_ptp_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.max_metric.router_lsa.on_startup.link_onstartup', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.max_metric.router_lsa.on_startup.link_onstartup', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.max_metric.router_lsa.on_startup.link_onstartup', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ptp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_max_metric_router_lsa_on_startup_link_stub_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.max_metric.router_lsa.on_startup.link_onstartup', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.max_metric.router_lsa.on_startup.link_onstartup', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.max_metric.router_lsa.on_startup.link_onstartup', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'stub'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_max_metric_router_lsa_on_startup_link_transit_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.max_metric.router_lsa.on_startup.link_onstartup', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.max_metric.router_lsa.on_startup.link_onstartup', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.max_metric.router_lsa.on_startup.link_onstartup', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'transit'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_max_metric_router_lsa_on_startup_summary_lsa_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.max_metric.router_lsa.on_startup.summary_lsa_onstartup', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.max_metric.router_lsa.on_startup.summary_lsa_onstartup', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.max_metric.router_lsa.on_startup.summary_lsa_onstartup', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_max_metric_router_lsa_on_startup_summary_lsa_summary_lsa_val_onstartup_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.max_metric.router_lsa.on_startup.summary_lsa_onstartup', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.max_metric.router_lsa.on_startup.summary_lsa_onstartup', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.max_metric.router_lsa.on_startup.summary_lsa_onstartup', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'summary-lsa-val-onstartup'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_max_metric_router_lsa_on_startup_time_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.max_metric.router_lsa.on_startup', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.max_metric.router_lsa.on_startup', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.max_metric.router_lsa.on_startup', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_max_metric_router_lsa_on_startup_wait_for_bgp_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.max_metric.router_lsa.on_startup', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.max_metric.router_lsa.on_startup', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.max_metric.router_lsa.on_startup', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'wait-for-bgp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_max_metric_router_lsa_summary_lsa_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.max_metric.router_lsa.summary_lsa', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.max_metric.router_lsa.summary_lsa', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.max_metric.router_lsa.summary_lsa', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_max_metric_router_lsa_summary_lsa_summary_lsa_val_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.max_metric.router_lsa.summary_lsa', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.max_metric.router_lsa.summary_lsa', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.max_metric.router_lsa.summary_lsa', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'summary-lsa-val'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_maximum_paths_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ospf', 'keyval': 'vrf', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'maximum-paths'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_metric_type_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ospf', 'keyval': 'vrf', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_neighbor_delete(self, rbridge_id=None, ospf=None, neighbor=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    **Instance Keyword Argument Tuple**:

    :type neighbor: neighbor_addr
    :param neighbor: Keyword argument tuple.

    :type neighbor_addr: unicode
    :param neighbor_addr: **neighbor** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.neighbor', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.neighbor', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.neighbor', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'neighbor', 'keyval': 'neighbor_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, neighbor=neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, neighbor=neighbor)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_nonstop_routing_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ospf', 'keyval': 'vrf', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'nonstop-routing'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_permit_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.permit', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.permit', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.permit', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_permit_redistribute_delete(self, rbridge_id=None, ospf=None, redistribute=None, address=None, mask=None, set_metric_val=None, match_metric_val=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    **Instance Keyword Argument Tuple**:

    :type redistribute: redist_value, route_option, address, mask, set_metric_val, match_metric_val
    :param redistribute: Keyword argument tuple.

    :type redist_value: long
    :param redist_value: **redistribute** tuple argument:  Number

        * range restriction: ::

            ['0..4294967295']

    :type route_option: unicode
    :param route_option: **redistribute** tuple argument:  OSPF route option

        * enumeration restriction: ::

            ['connected', 'all', 'static']

    :type address: unicode
    :param address: **redistribute** tuple argument:  IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type mask: unicode
    :param mask: **redistribute** tuple argument:  Subnet Mask

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type set_metric_val: long
    :param set_metric_val: **redistribute** tuple argument:  Metric value

        * range restriction: ::

            ['0..4294967295']

    :type match_metric_val: long
    :param match_metric_val: **redistribute** tuple argument:  Metric value

        * range restriction: ::

            ['0..4294967295']

    **Instance Argument(s)**:

    :type address: unicode
    :param address: IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type mask: unicode
    :param mask: Subnet Mask

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type set_metric_val: long
    :param set_metric_val: Metric value

        * range restriction: ::

            ['0..4294967295']

    :type match_metric_val: long
    :param match_metric_val: Metric value

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.permit.redistribute', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.permit.redistribute', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.permit.redistribute', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'redistribute', 'keyval': 'redist_value, route_option', 'extra_keyval': 'redist_value, route_option, address, mask, set_metric_val, match_metric_val'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, redistribute=redistribute, address=address, mask=mask, set_metric_val=set_metric_val, match_metric_val=match_metric_val)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, redistribute=redistribute, address=address, mask=mask, set_metric_val=set_metric_val, match_metric_val=match_metric_val)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_permit_redistribute_address_delete(self, rbridge_id=None, ospf=None, redistribute=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    **Instance Keyword Argument Tuple**:

    :type redistribute: redist_value, route_option
    :param redistribute: Keyword argument tuple.

    :type redist_value: long
    :param redist_value: **redistribute** tuple argument:  Number

        * range restriction: ::

            ['0..4294967295']

    :type route_option: unicode
    :param route_option: **redistribute** tuple argument:  OSPF route option

        * enumeration restriction: ::

            ['connected', 'all', 'static']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.permit.redistribute', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.permit.redistribute', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.permit.redistribute', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'redistribute', 'keyval': 'redist_value, route_option', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'address'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, redistribute=redistribute)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, redistribute=redistribute)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_permit_redistribute_mask_delete(self, rbridge_id=None, ospf=None, redistribute=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    **Instance Keyword Argument Tuple**:

    :type redistribute: redist_value, route_option
    :param redistribute: Keyword argument tuple.

    :type redist_value: long
    :param redist_value: **redistribute** tuple argument:  Number

        * range restriction: ::

            ['0..4294967295']

    :type route_option: unicode
    :param route_option: **redistribute** tuple argument:  OSPF route option

        * enumeration restriction: ::

            ['connected', 'all', 'static']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.permit.redistribute', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.permit.redistribute', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.permit.redistribute', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'redistribute', 'keyval': 'redist_value, route_option', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mask'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, redistribute=redistribute)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, redistribute=redistribute)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_permit_redistribute_match_metric_delete(self, rbridge_id=None, ospf=None, redistribute=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    **Instance Keyword Argument Tuple**:

    :type redistribute: redist_value, route_option
    :param redistribute: Keyword argument tuple.

    :type redist_value: long
    :param redist_value: **redistribute** tuple argument:  Number

        * range restriction: ::

            ['0..4294967295']

    :type route_option: unicode
    :param route_option: **redistribute** tuple argument:  OSPF route option

        * enumeration restriction: ::

            ['connected', 'all', 'static']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.permit.redistribute', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.permit.redistribute', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.permit.redistribute', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'redistribute', 'keyval': 'redist_value, route_option', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'match-metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, redistribute=redistribute)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, redistribute=redistribute)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_permit_redistribute_set_metric_delete(self, rbridge_id=None, ospf=None, redistribute=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    **Instance Keyword Argument Tuple**:

    :type redistribute: redist_value, route_option
    :param redistribute: Keyword argument tuple.

    :type redist_value: long
    :param redist_value: **redistribute** tuple argument:  Number

        * range restriction: ::

            ['0..4294967295']

    :type route_option: unicode
    :param route_option: **redistribute** tuple argument:  OSPF route option

        * enumeration restriction: ::

            ['connected', 'all', 'static']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.permit.redistribute', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.permit.redistribute', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.permit.redistribute', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'redistribute', 'keyval': 'redist_value, route_option', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'set-metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, redistribute=redistribute)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, redistribute=redistribute)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_redistribute_bgp_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.redistribute.bgp', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.redistribute.bgp', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.redistribute.bgp', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_redistribute_bgp_route_map_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.redistribute.bgp', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.redistribute.bgp', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.redistribute.bgp', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_redistribute_connected_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.redistribute.connected', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.redistribute.connected', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.redistribute.connected', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_redistribute_connected_route_map_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.redistribute.connected', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.redistribute.connected', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.redistribute.connected', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_redistribute_ospf_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.redistribute.redistribute_ospf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.redistribute.redistribute_ospf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.redistribute.redistribute_ospf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_redistribute_ospf_route_map_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.redistribute.redistribute_ospf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.redistribute.redistribute_ospf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.redistribute.redistribute_ospf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_redistribute_static_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.redistribute.static', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.redistribute.static', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.redistribute.static', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_redistribute_static_route_map_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.redistribute.static', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.redistribute.static', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.redistribute.static', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_rfc1583_compatibility_rfc1583_compatibility_flag_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.rfc1583_compatibility', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.rfc1583_compatibility', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.rfc1583_compatibility', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rfc1583-compatibility-flag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_summary_address_delete(self, rbridge_id=None, ospf=None, summary_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    **Instance Keyword Argument Tuple**:

    :type summary_address: sum_address, sum_address_mask
    :param summary_address: Keyword argument tuple.

    :type sum_address: unicode
    :param sum_address: **summary_address** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type sum_address_mask: unicode
    :param sum_address_mask: **summary_address** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.summary_address', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.summary_address', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.summary_address', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'summary_address', 'keyval': 'sum_address, sum_address_mask', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, summary_address=summary_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, summary_address=summary_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_timers_lsa_group_pacing_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.timers', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.timers', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.timers', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lsa-group-pacing'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_timers_throttle_spf_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.timers.throttle.spf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.timers.throttle.spf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.timers.throttle.spf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'init_delay, hold_time, max_hold_time'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_timers_throttle_spf_hold_time_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.timers.throttle.spf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.timers.throttle.spf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.timers.throttle.spf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hold-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_timers_throttle_spf_init_delay_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.timers.throttle.spf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.timers.throttle.spf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.timers.throttle.spf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'init-delay'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_timers_throttle_spf_max_hold_time_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf.timers.throttle.spf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf.timers.throttle.spf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf.timers.throttle.spf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'max-hold-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_ospf_vrf_lite_capability_delete(self, rbridge_id=None, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.ospf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.ospf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.ospf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ospf', 'keyval': 'vrf', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vrf-lite-capability'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_pim_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.hide_pim_holder.pim', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.hide_pim_holder.pim', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.hide_pim_holder.pim', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v6_0_2c.rbridge_id.router.hide_pim_holder.pim": {"nbr_timeout": "nbr_timeout", "max_mcache": "max_mcache", "hello_interval": "hello_interval", "message_interval": "message_interval", "spt_threshold": "spt_threshold", "inactivity_timer": "inactivity_timer"}, "pybind.nos.v7_0_1b.rbridge_id.router.hide_pim_holder.pim": {}, "pybind.nos.v7_1_0.rbridge_id.router.hide_pim_holder.pim": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_pim_bsr_candidate_interface_delete(self, rbridge_id=None, bsr_cand_interface=None, hash_mask_length=None, bsr_cand_priority=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type bsr_cand_interface: bsr_cand_intf_type, bsr_cand_intf_id, hash_mask_length, bsr_cand_priority
    :param bsr_cand_interface: Keyword argument tuple.

    :type bsr_cand_intf_type: unicode
    :param bsr_cand_intf_type: **bsr_cand_interface** tuple argument.

        * enumeration restriction: ::

            ['port-channel',
            've',
            'fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet']

    :type bsr_cand_intf_id: unicode
    :param bsr_cand_intf_id: **bsr_cand_interface** tuple argument:  String;;Interface ID

    :type hash_mask_length: int
    :param hash_mask_length: **bsr_cand_interface** tuple argument:  BSR hash mask

        * range restriction: ::

            ['0..65535']

    :type bsr_cand_priority: long
    :param bsr_cand_priority: **bsr_cand_interface** tuple argument:  BSR priority

        * range restriction: ::

            ['0..4294967295']

    **Instance Argument(s)**:

    :type hash_mask_length: int
    :param hash_mask_length: BSR hash mask

        * range restriction: ::

            ['0..65535']

    :type bsr_cand_priority: long
    :param bsr_cand_priority: BSR priority

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.hide_pim_holder.pim.bsr_candidate.bsr_cand_interface', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.hide_pim_holder.pim.bsr_candidate.bsr_cand_interface', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.hide_pim_holder.pim.bsr_candidate.bsr_cand_interface', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'bsr_cand_interface', 'keyval': 'bsr_cand_intf_type, bsr_cand_intf_id', 'extra_keyval': 'bsr_cand_intf_type, bsr_cand_intf_id, hash_mask_length, bsr_cand_priority'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, bsr_cand_interface=bsr_cand_interface, hash_mask_length=hash_mask_length, bsr_cand_priority=bsr_cand_priority)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, bsr_cand_interface=bsr_cand_interface, hash_mask_length=hash_mask_length, bsr_cand_priority=bsr_cand_priority)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_pim_bsr_candidate_interface_mask_delete(self, rbridge_id=None, bsr_cand_interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type bsr_cand_interface: bsr_cand_intf_type, bsr_cand_intf_id
    :param bsr_cand_interface: Keyword argument tuple.

    :type bsr_cand_intf_type: unicode
    :param bsr_cand_intf_type: **bsr_cand_interface** tuple argument.

        * enumeration restriction: ::

            ['port-channel',
            've',
            'fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet']

    :type bsr_cand_intf_id: unicode
    :param bsr_cand_intf_id: **bsr_cand_interface** tuple argument:  String;;Interface ID

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.hide_pim_holder.pim.bsr_candidate.bsr_cand_interface', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.hide_pim_holder.pim.bsr_candidate.bsr_cand_interface', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.hide_pim_holder.pim.bsr_candidate.bsr_cand_interface', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'bsr_cand_interface', 'keyval': 'bsr_cand_intf_type, bsr_cand_intf_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mask'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, bsr_cand_interface=bsr_cand_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, bsr_cand_interface=bsr_cand_interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_pim_bsr_candidate_interface_priority_delete(self, rbridge_id=None, bsr_cand_interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type bsr_cand_interface: bsr_cand_intf_type, bsr_cand_intf_id
    :param bsr_cand_interface: Keyword argument tuple.

    :type bsr_cand_intf_type: unicode
    :param bsr_cand_intf_type: **bsr_cand_interface** tuple argument.

        * enumeration restriction: ::

            ['port-channel',
            've',
            'fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet']

    :type bsr_cand_intf_id: unicode
    :param bsr_cand_intf_id: **bsr_cand_interface** tuple argument:  String;;Interface ID

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.hide_pim_holder.pim.bsr_candidate.bsr_cand_interface', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.hide_pim_holder.pim.bsr_candidate.bsr_cand_interface', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.hide_pim_holder.pim.bsr_candidate.bsr_cand_interface', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'bsr_cand_interface', 'keyval': 'bsr_cand_intf_type, bsr_cand_intf_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, bsr_cand_interface=bsr_cand_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, bsr_cand_interface=bsr_cand_interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_pim_bsr_msg_interval_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.hide_pim_holder.pim', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.hide_pim_holder.pim', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bsr-msg-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_pim_hello_interval_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.hide_pim_holder.pim', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.hide_pim_holder.pim', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.hide_pim_holder.pim', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hello-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_pim_inactivity_timer_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.hide_pim_holder.pim', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.hide_pim_holder.pim', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.hide_pim_holder.pim', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'inactivity-timer'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_pim_max_mcache_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.hide_pim_holder.pim', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.hide_pim_holder.pim', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.hide_pim_holder.pim', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'max-mcache'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_pim_message_interval_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.hide_pim_holder.pim', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.hide_pim_holder.pim', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.hide_pim_holder.pim', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'message-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_pim_nbr_timeout_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.hide_pim_holder.pim', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.hide_pim_holder.pim', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.hide_pim_holder.pim', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'nbr-timeout'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_pim_reset_tracking_bit_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.hide_pim_holder.pim', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.hide_pim_holder.pim', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'reset-tracking-bit'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_pim_rp_address_delete(self, rbridge_id=None, rp_address=None, prefix_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type rp_address: rp_ip_addr, prefix_list
    :param rp_address: Keyword argument tuple.

    :type rp_ip_addr: unicode
    :param rp_ip_addr: **rp_address** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type prefix_list: unicode
    :param prefix_list: **rp_address** tuple argument:  Prefix list

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    **Instance Argument(s)**:

    :type prefix_list: unicode
    :param prefix_list: Prefix list

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.hide_pim_holder.pim.rp_address', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.hide_pim_holder.pim.rp_address', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.hide_pim_holder.pim.rp_address', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'rp_address', 'keyval': 'rp_ip_addr', 'extra_keyval': 'rp_ip_addr, prefix_list'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, rp_address=rp_address, prefix_list=prefix_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, rp_address=rp_address, prefix_list=prefix_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_pim_rp_address_prefix_list_delete(self, rbridge_id=None, rp_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type rp_address: rp_ip_addr
    :param rp_address: Keyword argument tuple.

    :type rp_ip_addr: unicode
    :param rp_ip_addr: **rp_address** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.hide_pim_holder.pim.rp_address', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.hide_pim_holder.pim.rp_address', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.hide_pim_holder.pim.rp_address', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'rp_address', 'keyval': 'rp_ip_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'prefix-list'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, rp_address=rp_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, rp_address=rp_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_pim_rp_adv_interval_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.hide_pim_holder.pim', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.hide_pim_holder.pim', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rp-adv-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_pim_rp_candidate_group_range_delete(self, rbridge_id=None, rp_cand_grp_prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type rp_cand_grp_prefix: rp_cand_grp_prefix_ip, rp_cand_grp_prefix_length
    :param rp_cand_grp_prefix: Keyword argument tuple.

    :type rp_cand_grp_prefix_ip: unicode
    :param rp_cand_grp_prefix_ip: **rp_cand_grp_prefix** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type rp_cand_grp_prefix_length: int
    :param rp_cand_grp_prefix_length: **rp_cand_grp_prefix** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.hide_pim_holder.pim.rp_candidate.rp_cand_grp_prefix', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.hide_pim_holder.pim.rp_candidate.rp_cand_grp_prefix', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'rp_cand_grp_prefix', 'keyval': 'rp_cand_grp_prefix_ip, rp_cand_grp_prefix_length', 'extra_keyval': 'rp_cand_grp_prefix_ip, rp_cand_grp_prefix_length'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, rp_cand_grp_prefix=rp_cand_grp_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, rp_cand_grp_prefix=rp_cand_grp_prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_pim_rp_candidate_interface_delete(self, rbridge_id=None, rp_cand_interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type rp_cand_interface: rp_cand_intf_type, rp_cand_intf_id
    :param rp_cand_interface: Keyword argument tuple.

    :type rp_cand_intf_type: unicode
    :param rp_cand_intf_type: **rp_cand_interface** tuple argument.

        * enumeration restriction: ::

            ['port-channel',
            've',
            'fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet']

    :type rp_cand_intf_id: unicode
    :param rp_cand_intf_id: **rp_cand_interface** tuple argument:  Interface ID

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.hide_pim_holder.pim.rp_candidate.rp_cand_interface', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.hide_pim_holder.pim.rp_candidate.rp_cand_interface', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.hide_pim_holder.pim.rp_candidate.rp_cand_interface', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'rp_cand_interface', 'keyval': 'rp_cand_intf_type, rp_cand_intf_id', 'extra_keyval': 'rp_cand_intf_type, rp_cand_intf_id, rp_cand_priority'}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v7_0_1b.rbridge_id.router.hide_pim_holder.pim.rp_candidate.rp_cand_interface": {}, "pybind.nos.v6_0_2c.rbridge_id.router.hide_pim_holder.pim.rp_candidate.rp_cand_interface": {"rp_cand_intf_id": "rp_cand_intf_id", "rp_cand_intf_type": "rp_cand_intf_type"}, "pybind.nos.v7_1_0.rbridge_id.router.hide_pim_holder.pim.rp_candidate.rp_cand_interface": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, rp_cand_interface=rp_cand_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, rp_cand_interface=rp_cand_interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_pim_rp_candidate_interface_priority_delete(self, rbridge_id=None, rp_cand_interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type rp_cand_interface: rp_cand_intf_type, rp_cand_intf_id
    :param rp_cand_interface: Keyword argument tuple.

    :type rp_cand_intf_type: unicode
    :param rp_cand_intf_type: **rp_cand_interface** tuple argument.

        * enumeration restriction: ::

            ['port-channel',
            've',
            'fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet']

    :type rp_cand_intf_id: unicode
    :param rp_cand_intf_id: **rp_cand_interface** tuple argument:  Interface ID

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.router.hide_pim_holder.pim.rp_candidate.rp_cand_interface', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.hide_pim_holder.pim.rp_candidate.rp_cand_interface', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'rp_cand_interface', 'keyval': 'rp_cand_intf_type, rp_cand_intf_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, rp_cand_interface=rp_cand_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, rp_cand_interface=rp_cand_interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_pim_rp_candidate_rp_cand_grp_prefix_delete(self, rbridge_id=None, rp_cand_grp_prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type rp_cand_grp_prefix: rp_cand_grp_prefix_action, rp_cand_grp_prefix_ip, rp_cand_grp_prefix_length
    :param rp_cand_grp_prefix: Keyword argument tuple.

    :type rp_cand_grp_prefix_action: unicode
    :param rp_cand_grp_prefix_action: **rp_cand_grp_prefix** tuple argument.

        * enumeration restriction: ::

            ['add', 'delete']

    :type rp_cand_grp_prefix_ip: unicode
    :param rp_cand_grp_prefix_ip: **rp_cand_grp_prefix** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type rp_cand_grp_prefix_length: int
    :param rp_cand_grp_prefix_length: **rp_cand_grp_prefix** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.hide_pim_holder.pim.rp_candidate.rp_cand_grp_prefix', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'rp_cand_grp_prefix', 'keyval': 'rp_cand_grp_prefix_action, rp_cand_grp_prefix_ip, rp_cand_grp_prefix_length', 'extra_keyval': 'rp_cand_grp_prefix_action, rp_cand_grp_prefix_ip, rp_cand_grp_prefix_length'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, rp_cand_grp_prefix=rp_cand_grp_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, rp_cand_grp_prefix=rp_cand_grp_prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_router_pim_spt_threshold_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.router.hide_pim_holder.pim', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.router.hide_pim_holder.pim', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.router.hide_pim_holder.pim', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'spt-threshold'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_secpolicy_active_policy_policies_delete(self, rbridge_id=None, policies=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type policies: policy
    :param policies: Keyword argument tuple.

    :type policy: unicode
    :param policy: **policies** tuple argument.

        * pattern restriction: ::

            'SCC_POLICY'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.secpolicy.active_policy.policies', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.secpolicy.active_policy.policies', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.secpolicy.active_policy.policies', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'policies', 'keyval': 'policy', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, policies=policies)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, policies=policies)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_secpolicy_active_policy_policies_member_entry_delete(self, rbridge_id=None, policies=None, member_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type policies: policy
    :param policies: Keyword argument tuple.

    :type policy: unicode
    :param policy: **policies** tuple argument.

        * pattern restriction: ::

            'SCC_POLICY'

    **Instance Keyword Argument Tuple**:

    :type member_entry: member
    :param member_entry: Keyword argument tuple.

    :type member: unicode
    :param member: **member_entry** tuple argument:  WWN of the switch

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.secpolicy.active_policy.policies', u'policies'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.secpolicy.active_policy.policies', u'policies'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.secpolicy.active_policy.policies', u'policies')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.secpolicy.active_policy.policies.member_entry', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.secpolicy.active_policy.policies.member_entry', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.secpolicy.active_policy.policies.member_entry', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'member_entry', 'keyval': 'member', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, policies=policies, member_entry=member_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, policies=policies, member_entry=member_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_secpolicy_defined_policy_policies_delete(self, rbridge_id=None, policies=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type policies: policy
    :param policies: Keyword argument tuple.

    :type policy: unicode
    :param policy: **policies** tuple argument.

        * pattern restriction: ::

            'SCC_POLICY'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.secpolicy.defined_policy.policies', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.secpolicy.defined_policy.policies', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.secpolicy.defined_policy.policies', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'policies', 'keyval': 'policy', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, policies=policies)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, policies=policies)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_secpolicy_defined_policy_policies_member_entry_delete(self, rbridge_id=None, policies=None, member_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type policies: policy
    :param policies: Keyword argument tuple.

    :type policy: unicode
    :param policy: **policies** tuple argument.

        * pattern restriction: ::

            'SCC_POLICY'

    **Instance Keyword Argument Tuple**:

    :type member_entry: member
    :param member_entry: Keyword argument tuple.

    :type member: unicode
    :param member: **member_entry** tuple argument:  WWN of the switch

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.secpolicy.defined_policy.policies', u'policies'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.secpolicy.defined_policy.policies', u'policies'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.secpolicy.defined_policy.policies', u'policies')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.secpolicy.defined_policy.policies.member_entry', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.secpolicy.defined_policy.policies.member_entry', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.secpolicy.defined_policy.policies.member_entry', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'member_entry', 'keyval': 'member', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, policies=policies, member_entry=member_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, policies=policies, member_entry=member_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_snmp_server_engineid_local_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.snmp_server.engineID', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.snmp_server.engineID', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.snmp_server.engineID', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'local'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_snmp_server_offline_if_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.snmp_server.offline_if', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.snmp_server.offline_if', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.snmp_server.offline_if', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_snmp_server_offline_if_enable_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.snmp_server.offline_if', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.snmp_server.offline_if', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.snmp_server.offline_if', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_snmp_server_three_tuple_if_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.snmp_server.three_tuple_if', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.snmp_server.three_tuple_if', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.snmp_server.three_tuple_if', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_snmp_server_three_tuple_if_enable_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.snmp_server.three_tuple_if', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.snmp_server.three_tuple_if', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.snmp_server.three_tuple_if', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_snmp_server_user_delete(self, rbridge_id=None, user=None, groupname=None, auth=None, auth_password=None, priv=None, priv_password=None, encrypted=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type user: username, groupname, auth, auth_password, priv, priv_password, encrypted
    :param user: Keyword argument tuple.

    :type username: unicode
    :param username: **user** tuple argument.

        * length restriction: ::

            ['1 .. 25']

    :type groupname: unicode
    :param groupname: **user** tuple argument.

    :type auth: unicode
    :param auth: **user** tuple argument:  Authorization protocol for username(Default=noauth)

        * enumeration restriction: ::

            ['sha', 'noauth', 'md5']

    :type auth_password: unicode
    :param auth_password: **user** tuple argument:  Authorization password associated withusername

    :type priv: unicode
    :param priv: **user** tuple argument:  Privacy protocol for username (Default=nopriv)

        * enumeration restriction: ::

            ['AES128', 'DES', 'nopriv']

    :type priv_password: unicode
    :param priv_password: **user** tuple argument:  Privacy password associated with username

    :type encrypted: YANGBool
    :param encrypted: **user** tuple argument:  This flag is used to enter the auth/privpasswords as encrypted.(Default=disable)

    **Instance Argument(s)**:

    :type groupname: unicode
    :param groupname: Keyword argument.

    :type auth: unicode
    :param auth: Authorization protocol for username(Default=noauth)

        * enumeration restriction: ::

            ['sha', 'noauth', 'md5']

    :type auth_password: unicode
    :param auth_password: Authorization password associated withusername

    :type priv: unicode
    :param priv: Privacy protocol for username (Default=nopriv)

        * enumeration restriction: ::

            ['AES128', 'DES', 'nopriv']

    :type priv_password: unicode
    :param priv_password: Privacy password associated with username

    :type encrypted: YANGBool
    :param encrypted: This flag is used to enter the auth/privpasswords as encrypted.(Default=disable)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.snmp_server.user', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.snmp_server.user', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.snmp_server.user', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'user', 'keyval': 'username', 'extra_keyval': 'username, groupname, auth, auth_password, priv, priv_password, encrypted'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, user=user, groupname=groupname, auth=auth, auth_password=auth_password, priv=priv, priv_password=priv_password, encrypted=encrypted)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, user=user, groupname=groupname, auth=auth, auth_password=auth_password, priv=priv, priv_password=priv_password, encrypted=encrypted)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_snmp_server_user_auth_delete(self, rbridge_id=None, user=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type user: username
    :param user: Keyword argument tuple.

    :type username: unicode
    :param username: **user** tuple argument.

        * length restriction: ::

            ['1 .. 25']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.snmp_server.user', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.snmp_server.user', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.snmp_server.user', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'user', 'keyval': 'username', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'auth'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, user=user)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, user=user)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_snmp_server_user_auth_password_delete(self, rbridge_id=None, user=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type user: username
    :param user: Keyword argument tuple.

    :type username: unicode
    :param username: **user** tuple argument.

        * length restriction: ::

            ['1 .. 25']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.snmp_server.user', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.snmp_server.user', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.snmp_server.user', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'user', 'keyval': 'username', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'auth-password'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, user=user)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, user=user)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_snmp_server_user_encrypted_delete(self, rbridge_id=None, user=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type user: username
    :param user: Keyword argument tuple.

    :type username: unicode
    :param username: **user** tuple argument.

        * length restriction: ::

            ['1 .. 25']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.snmp_server.user', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.snmp_server.user', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.snmp_server.user', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'user', 'keyval': 'username', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'encrypted'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, user=user)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, user=user)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_snmp_server_user_groupname_delete(self, rbridge_id=None, user=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type user: username
    :param user: Keyword argument tuple.

    :type username: unicode
    :param username: **user** tuple argument.

        * length restriction: ::

            ['1 .. 25']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.snmp_server.user', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.snmp_server.user', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.snmp_server.user', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'user', 'keyval': 'username', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'groupname'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, user=user)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, user=user)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_snmp_server_user_priv_delete(self, rbridge_id=None, user=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type user: username
    :param user: Keyword argument tuple.

    :type username: unicode
    :param username: **user** tuple argument.

        * length restriction: ::

            ['1 .. 25']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.snmp_server.user', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.snmp_server.user', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.snmp_server.user', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'user', 'keyval': 'username', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priv'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, user=user)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, user=user)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_snmp_server_user_priv_password_delete(self, rbridge_id=None, user=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type user: username
    :param user: Keyword argument tuple.

    :type username: unicode
    :param username: **user** tuple argument.

        * length restriction: ::

            ['1 .. 25']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.snmp_server.user', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.snmp_server.user', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.snmp_server.user', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'user', 'keyval': 'username', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priv-password'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, user=user)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, user=user)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_snmp_server_v3host_delete(self, rbridge_id=None, v3host=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type v3host: hostip, username
    :param v3host: Keyword argument tuple.

    :type hostip: unicode
    :param hostip: **v3host** tuple argument:  ipv4/ipv6/dns address of the notification recipientassociated with username. Notificationswill be sent to this host

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type username: unicode
    :param username: **v3host** tuple argument:  Username associated with notification type.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.snmp_server.v3host', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.snmp_server.v3host', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.snmp_server.v3host', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'v3host', 'keyval': 'hostip, username', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v7_0_1b.rbridge_id.snmp_server.v3host": {}, "pybind.nos.v7_1_0.rbridge_id.snmp_server.v3host": {}, "pybind.nos.v6_0_2c.rbridge_id.snmp_server.v3host": {"username": "username", "severity_level": "severity_level", "udp_port": "udp_port", "use_vrf": "use_vrf", "notifytype": "notifytype", "hostip": "hostip", "engineid": "engineid"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, v3host=v3host)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, v3host=v3host)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_snmp_server_v3host_engineid_delete(self, rbridge_id=None, v3host=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type v3host: hostip, username
    :param v3host: Keyword argument tuple.

    :type hostip: unicode
    :param hostip: **v3host** tuple argument:  ipv4/ipv6/dns address of the notification recipientassociated with username. Notificationswill be sent to this host

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type username: unicode
    :param username: **v3host** tuple argument:  Username associated with notification type.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.snmp_server.v3host', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.snmp_server.v3host', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.snmp_server.v3host', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'v3host', 'keyval': 'hostip, username', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'engineid'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, v3host=v3host)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, v3host=v3host)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_snmp_server_v3host_notifytype_delete(self, rbridge_id=None, v3host=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type v3host: hostip, username
    :param v3host: Keyword argument tuple.

    :type hostip: unicode
    :param hostip: **v3host** tuple argument:  ipv4/ipv6/dns address of the notification recipientassociated with username. Notificationswill be sent to this host

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type username: unicode
    :param username: **v3host** tuple argument:  Username associated with notification type.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.snmp_server.v3host', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.snmp_server.v3host', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.snmp_server.v3host', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'v3host', 'keyval': 'hostip, username', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'notifytype'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, v3host=v3host)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, v3host=v3host)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_snmp_server_v3host_severity_level_delete(self, rbridge_id=None, v3host=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type v3host: hostip, username
    :param v3host: Keyword argument tuple.

    :type hostip: unicode
    :param hostip: **v3host** tuple argument:  ipv4/ipv6/dns address of the notification recipientassociated with username. Notificationswill be sent to this host

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type username: unicode
    :param username: **v3host** tuple argument:  Username associated with notification type.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.snmp_server.v3host', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.snmp_server.v3host', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.snmp_server.v3host', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'v3host', 'keyval': 'hostip, username', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'severity-level'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, v3host=v3host)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, v3host=v3host)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_snmp_server_v3host_udp_port_delete(self, rbridge_id=None, v3host=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type v3host: hostip, username
    :param v3host: Keyword argument tuple.

    :type hostip: unicode
    :param hostip: **v3host** tuple argument:  ipv4/ipv6/dns address of the notification recipientassociated with username. Notificationswill be sent to this host

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type username: unicode
    :param username: **v3host** tuple argument:  Username associated with notification type.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.snmp_server.v3host', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.snmp_server.v3host', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.snmp_server.v3host', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'v3host', 'keyval': 'hostip, username', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'udp-port'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, v3host=v3host)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, v3host=v3host)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_snmp_server_v3host_use_vrf_delete(self, rbridge_id=None, v3host=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type v3host: hostip, username
    :param v3host: Keyword argument tuple.

    :type hostip: unicode
    :param hostip: **v3host** tuple argument:  ipv4/ipv6/dns address of the notification recipientassociated with username. Notificationswill be sent to this host

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type username: unicode
    :param username: **v3host** tuple argument:  Username associated with notification type.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.snmp_server.v3host', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'v3host', 'keyval': 'hostip, username', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'use-vrf'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, v3host=v3host)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, v3host=v3host)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_spanning_tree_ieee_bpdu_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.spanning_tree.ieee_bpdu', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.spanning_tree.ieee_bpdu', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.spanning_tree.ieee_bpdu', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_spanning_tree_ieee_bpdu_limit_vlan_flood_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.spanning_tree.ieee_bpdu', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.spanning_tree.ieee_bpdu', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.spanning_tree.ieee_bpdu', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'limit-vlan-flood'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ssh_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ssh', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ssh', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ssh', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ssh_client_cipher_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ssh.client', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ssh.client', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ssh.client', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cipher'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ssh_client_key_exchange_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ssh.client', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ssh.client', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ssh.client', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'key-exchange'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ssh_client_mac_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ssh.client', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ssh.client', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ssh.client', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mac'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ssh_server_cipher_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ssh.server', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ssh.server', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ssh.server', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cipher'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ssh_server_key_dsa_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ssh.server.key', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ssh.server.key', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ssh.server.key', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dsa'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ssh_server_key_ecdsa_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ssh.server.key', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ssh.server.key', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ssh.server.key', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ecdsa'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ssh_server_key_exchange_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ssh.server', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ssh.server', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ssh.server', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'key-exchange'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ssh_server_key_rsa_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ssh.server.key', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ssh.server.key', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ssh.server.key', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rsa'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ssh_server_mac_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ssh.server', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ssh.server', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ssh.server', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mac'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ssh_server_max_sessions_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_1_0.rbridge_id.ssh.server', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'max-sessions'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ssh_server_rekey_interval_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ssh.server', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ssh.server', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ssh.server', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rekey-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ssh_server_shutdown_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ssh.server', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ssh.server', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ssh.server', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'shutdown'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ssh_server_ssh_vrf_cont_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ssh.server.ssh_vrf_cont', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ssh.server.ssh_vrf_cont', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ssh.server.ssh_vrf_cont', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ssh_server_standby_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ssh.server.standby', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ssh.server.standby', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ssh.server.standby', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ssh_server_standby_enable_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ssh.server.standby', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ssh.server.standby', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ssh.server.standby', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ssh_server_use_vrf_delete(self, rbridge_id=None, use_vrf=None, ssh_vrf_shutdown=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type use_vrf: use_vrf_name, ssh_vrf_shutdown
    :param use_vrf: Keyword argument tuple.

    :type use_vrf_name: unicode
    :param use_vrf_name: **use_vrf** tuple argument.

        * length restriction: ::

            ['0 .. max']

    :type ssh_vrf_shutdown: YANGBool
    :param ssh_vrf_shutdown: **use_vrf** tuple argument:  Shutdown SSH server on given vrf

    **Instance Argument(s)**:

    :type ssh_vrf_shutdown: YANGBool
    :param ssh_vrf_shutdown: Shutdown SSH server on given vrf

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ssh.server.ssh_vrf_cont.use_vrf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ssh.server.ssh_vrf_cont.use_vrf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ssh.server.ssh_vrf_cont.use_vrf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'use_vrf', 'keyval': 'use_vrf_name', 'extra_keyval': 'use_vrf_name, ssh_vrf_shutdown'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, use_vrf=use_vrf, ssh_vrf_shutdown=ssh_vrf_shutdown)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, use_vrf=use_vrf, ssh_vrf_shutdown=ssh_vrf_shutdown)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_ssh_server_use_vrf_shutdown_delete(self, rbridge_id=None, use_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type use_vrf: use_vrf_name
    :param use_vrf: Keyword argument tuple.

    :type use_vrf_name: unicode
    :param use_vrf_name: **use_vrf** tuple argument.

        * length restriction: ::

            ['0 .. max']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.ssh.server.ssh_vrf_cont.use_vrf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.ssh.server.ssh_vrf_cont.use_vrf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.ssh.server.ssh_vrf_cont.use_vrf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'use_vrf', 'keyval': 'use_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'shutdown'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, use_vrf=use_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, use_vrf=use_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_swbd_number_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'rbridge_id', 'keyval': 'rbridge_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'swbd-number'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_switch_attributes_chassis_name_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.switch_attributes', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.switch_attributes', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.switch_attributes', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'chassis-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_switch_attributes_host_name_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.switch_attributes', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.switch_attributes', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.switch_attributes', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'host-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_system_max_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.system_max', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.system_max', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.system_max', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_system_max_arp_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.system_max', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.system_max', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.system_max', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'arp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_system_mode_maintenance_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.system_mode', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.system_mode', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'maintenance'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_system_monitor_cid_card_alert_action_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.system_monitor.cid_card.alert', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.system_monitor.cid_card.alert', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.system_monitor.cid_card.alert', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.system_monitor.cid_card.alert', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'action'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_system_monitor_cid_card_alert_state_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.system_monitor.cid_card.alert', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.system_monitor.cid_card.alert', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.system_monitor.cid_card.alert', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.system_monitor.cid_card.alert', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'state'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_system_monitor_cid_card_threshold_down_threshold_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.system_monitor.cid_card.threshold', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.system_monitor.cid_card.threshold', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.system_monitor.cid_card.threshold', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.system_monitor.cid_card.threshold', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'down-threshold'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_system_monitor_cid_card_threshold_marginal_threshold_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.system_monitor.cid_card.threshold', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.system_monitor.cid_card.threshold', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.system_monitor.cid_card.threshold', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.system_monitor.cid_card.threshold', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'marginal-threshold'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_system_monitor_compact_flash_threshold_down_threshold_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.system_monitor.compact_flash.threshold', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.system_monitor.compact_flash.threshold', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.system_monitor.compact_flash.threshold', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.system_monitor.compact_flash.threshold', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'down-threshold'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_system_monitor_compact_flash_threshold_marginal_threshold_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.system_monitor.compact_flash.threshold', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.system_monitor.compact_flash.threshold', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.system_monitor.compact_flash.threshold', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.system_monitor.compact_flash.threshold', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'marginal-threshold'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_system_monitor_fan_alert_action_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.system_monitor.fan.alert', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.system_monitor.fan.alert', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.system_monitor.fan.alert', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.system_monitor.fan.alert', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'action'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_system_monitor_fan_alert_state_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.system_monitor.fan.alert', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.system_monitor.fan.alert', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.system_monitor.fan.alert', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.system_monitor.fan.alert', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'state'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_system_monitor_fan_threshold_down_threshold_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.system_monitor.fan.threshold', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.system_monitor.fan.threshold', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.system_monitor.fan.threshold', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.system_monitor.fan.threshold', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'down-threshold'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_system_monitor_fan_threshold_marginal_threshold_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.system_monitor.fan.threshold', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.system_monitor.fan.threshold', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.system_monitor.fan.threshold', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.system_monitor.fan.threshold', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'marginal-threshold'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_system_monitor_linecard_alert_action_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.system_monitor.LineCard.alert', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.system_monitor.LineCard.alert', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.system_monitor.LineCard.alert', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.system_monitor.LineCard.alert', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'action'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_system_monitor_linecard_alert_state_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.system_monitor.LineCard.alert', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.system_monitor.LineCard.alert', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.system_monitor.LineCard.alert', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.system_monitor.LineCard.alert', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'state'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_system_monitor_linecard_threshold_down_threshold_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.system_monitor.LineCard.threshold', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.system_monitor.LineCard.threshold', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.system_monitor.LineCard.threshold', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.system_monitor.LineCard.threshold', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'down-threshold'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_system_monitor_linecard_threshold_marginal_threshold_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.system_monitor.LineCard.threshold', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.system_monitor.LineCard.threshold', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.system_monitor.LineCard.threshold', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.system_monitor.LineCard.threshold', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'marginal-threshold'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_system_monitor_mm_threshold_down_threshold_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.system_monitor.MM.threshold', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.system_monitor.MM.threshold', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.system_monitor.MM.threshold', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.system_monitor.MM.threshold', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'down-threshold'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_system_monitor_mm_threshold_marginal_threshold_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.system_monitor.MM.threshold', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.system_monitor.MM.threshold', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.system_monitor.MM.threshold', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.system_monitor.MM.threshold', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'marginal-threshold'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_system_monitor_power_alert_action_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.system_monitor.power.alert', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.system_monitor.power.alert', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.system_monitor.power.alert', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.system_monitor.power.alert', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'action'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_system_monitor_power_alert_state_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.system_monitor.power.alert', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.system_monitor.power.alert', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.system_monitor.power.alert', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.system_monitor.power.alert', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'state'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_system_monitor_power_threshold_down_threshold_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.system_monitor.power.threshold', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.system_monitor.power.threshold', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.system_monitor.power.threshold', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.system_monitor.power.threshold', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'down-threshold'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_system_monitor_power_threshold_marginal_threshold_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.system_monitor.power.threshold', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.system_monitor.power.threshold', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.system_monitor.power.threshold', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.system_monitor.power.threshold', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'marginal-threshold'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_system_monitor_sfm_threshold_down_threshold_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.system_monitor.SFM.threshold', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.system_monitor.SFM.threshold', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.system_monitor.SFM.threshold', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.system_monitor.SFM.threshold', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'down-threshold'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_system_monitor_sfm_threshold_marginal_threshold_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.system_monitor.SFM.threshold', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.system_monitor.SFM.threshold', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.system_monitor.SFM.threshold', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.system_monitor.SFM.threshold', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'marginal-threshold'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_system_monitor_sfp_alert_action_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.system_monitor.sfp.alert', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.system_monitor.sfp.alert', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.system_monitor.sfp.alert', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'action'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_system_monitor_sfp_alert_state_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.system_monitor.sfp.alert', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.system_monitor.sfp.alert', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.system_monitor.sfp.alert', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'state'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_system_monitor_temp_threshold_down_threshold_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.system_monitor.temp.threshold', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.system_monitor.temp.threshold', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.system_monitor.temp.threshold', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.system_monitor.temp.threshold', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'down-threshold'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_system_monitor_temp_threshold_marginal_threshold_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.system_monitor.temp.threshold', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.system_monitor.temp.threshold', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.system_monitor.temp.threshold', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.system_monitor.temp.threshold', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'marginal-threshold'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_telnet_server_shutdown_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.telnet.server', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.telnet.server', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.telnet.server', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'shutdown'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_telnet_server_standby_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.telnet.server.standby', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.telnet.server.standby', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.telnet.server.standby', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_telnet_server_standby_enable_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.telnet.server.standby', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.telnet.server.standby', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.telnet.server.standby', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_telnet_server_telnet_vrf_cont_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.telnet.server.telnet_vrf_cont', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.telnet.server.telnet_vrf_cont', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.telnet.server.telnet_vrf_cont', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_telnet_server_use_vrf_delete(self, rbridge_id=None, use_vrf=None, telnet_vrf_shutdown=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type use_vrf: use_vrf_name, telnet_vrf_shutdown
    :param use_vrf: Keyword argument tuple.

    :type use_vrf_name: unicode
    :param use_vrf_name: **use_vrf** tuple argument.

        * length restriction: ::

            ['0 .. max']

    :type telnet_vrf_shutdown: YANGBool
    :param telnet_vrf_shutdown: **use_vrf** tuple argument:  Shutdown telnet server on given vrf

    **Instance Argument(s)**:

    :type telnet_vrf_shutdown: YANGBool
    :param telnet_vrf_shutdown: Shutdown telnet server on given vrf

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.telnet.server.telnet_vrf_cont.use_vrf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.telnet.server.telnet_vrf_cont.use_vrf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.telnet.server.telnet_vrf_cont.use_vrf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'use_vrf', 'keyval': 'use_vrf_name', 'extra_keyval': 'use_vrf_name, telnet_vrf_shutdown'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, use_vrf=use_vrf, telnet_vrf_shutdown=telnet_vrf_shutdown)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, use_vrf=use_vrf, telnet_vrf_shutdown=telnet_vrf_shutdown)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_telnet_server_use_vrf_shutdown_delete(self, rbridge_id=None, use_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type use_vrf: use_vrf_name
    :param use_vrf: Keyword argument tuple.

    :type use_vrf_name: unicode
    :param use_vrf_name: **use_vrf** tuple argument.

        * length restriction: ::

            ['0 .. max']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.telnet.server.telnet_vrf_cont.use_vrf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.telnet.server.telnet_vrf_cont.use_vrf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.telnet.server.telnet_vrf_cont.use_vrf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'use_vrf', 'keyval': 'use_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'shutdown'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, use_vrf=use_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, use_vrf=use_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_threshold_monitor_buffer_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.slxos.v16r_1_00b.rbridge_id.threshold_monitor.Buffer', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'poll, retry, limit, actions'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_threshold_monitor_buffer_actions_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.slxos.v16r_1_00b.rbridge_id.threshold_monitor.Buffer', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'actions'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_threshold_monitor_buffer_limit_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.slxos.v16r_1_00b.rbridge_id.threshold_monitor.Buffer', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'limit'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_threshold_monitor_buffer_poll_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.slxos.v16r_1_00b.rbridge_id.threshold_monitor.Buffer', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'poll'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_threshold_monitor_buffer_retry_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.slxos.v16r_1_00b.rbridge_id.threshold_monitor.Buffer', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'retry'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_threshold_monitor_cpu_actions_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.threshold_monitor.Cpu', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.threshold_monitor.Cpu', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.threshold_monitor.Cpu', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.threshold_monitor.Cpu', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'actions'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_threshold_monitor_cpu_limit_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.threshold_monitor.Cpu', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.threshold_monitor.Cpu', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.threshold_monitor.Cpu', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.threshold_monitor.Cpu', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'limit'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_threshold_monitor_cpu_poll_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.threshold_monitor.Cpu', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.threshold_monitor.Cpu', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.threshold_monitor.Cpu', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.threshold_monitor.Cpu', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'poll'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_threshold_monitor_cpu_retry_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.threshold_monitor.Cpu', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.threshold_monitor.Cpu', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.threshold_monitor.Cpu', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.threshold_monitor.Cpu', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'retry'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_threshold_monitor_interface_apply_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.threshold_monitor.interface', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.threshold_monitor.interface', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.threshold_monitor.interface', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.threshold_monitor.interface', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'apply'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_threshold_monitor_interface_pause_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.threshold_monitor.interface', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.threshold_monitor.interface', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.threshold_monitor.interface', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.threshold_monitor.interface', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'pause'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_threshold_monitor_interface_policy_area_alert_above_highthresh_action_delete(self, rbridge_id=None, policy=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type policy: policy_name
    :param policy: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **policy** tuple argument.

    :type area: type, area_value
    :param area: Keyword argument tuple.

    :type type: unicode
    :param type: **area** tuple argument:  Interface types that can be configured independent of speed

        * enumeration restriction: ::

            ['Ethernet']

    :type area_value: unicode
    :param area_value: **area** tuple argument.

        * enumeration restriction: ::

            ['MissingTerminationCharacter',
            'CRCAlignErrors',
            'IFG',
            'SymbolErrors']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.threshold_monitor.interface.policy', u'policy'), ('pybind.nos.v6_0_2c.rbridge_id.threshold_monitor.interface.policy.area', u'area'), ('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id'), ('pybind.slxos.v16r_1_00b.rbridge_id.threshold_monitor.interface.policy', u'policy'), ('pybind.slxos.v16r_1_00b.rbridge_id.threshold_monitor.interface.policy.area', u'area'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.threshold_monitor.interface.policy', u'policy'), ('pybind.nos.v7_1_0.rbridge_id.threshold_monitor.interface.policy.area', u'area'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.threshold_monitor.interface.policy', u'policy'), ('pybind.nos.v7_0_1b.rbridge_id.threshold_monitor.interface.policy.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.threshold_monitor.interface.policy.area.alert.above', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.threshold_monitor.interface.policy.area.alert.above', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.threshold_monitor.interface.policy.area.alert.above', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.threshold_monitor.interface.policy.area.alert.above', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'highthresh-action'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, policy=policy, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_threshold_monitor_interface_policy_area_alert_above_lowthresh_action_delete(self, rbridge_id=None, policy=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type policy: policy_name
    :param policy: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **policy** tuple argument.

    :type area: type, area_value
    :param area: Keyword argument tuple.

    :type type: unicode
    :param type: **area** tuple argument:  Interface types that can be configured independent of speed

        * enumeration restriction: ::

            ['Ethernet']

    :type area_value: unicode
    :param area_value: **area** tuple argument.

        * enumeration restriction: ::

            ['MissingTerminationCharacter',
            'CRCAlignErrors',
            'IFG',
            'SymbolErrors']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.threshold_monitor.interface.policy', u'policy'), ('pybind.nos.v6_0_2c.rbridge_id.threshold_monitor.interface.policy.area', u'area'), ('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id'), ('pybind.slxos.v16r_1_00b.rbridge_id.threshold_monitor.interface.policy', u'policy'), ('pybind.slxos.v16r_1_00b.rbridge_id.threshold_monitor.interface.policy.area', u'area'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.threshold_monitor.interface.policy', u'policy'), ('pybind.nos.v7_1_0.rbridge_id.threshold_monitor.interface.policy.area', u'area'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.threshold_monitor.interface.policy', u'policy'), ('pybind.nos.v7_0_1b.rbridge_id.threshold_monitor.interface.policy.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.threshold_monitor.interface.policy.area.alert.above', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.threshold_monitor.interface.policy.area.alert.above', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.threshold_monitor.interface.policy.area.alert.above', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.threshold_monitor.interface.policy.area.alert.above', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lowthresh-action'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, policy=policy, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_threshold_monitor_interface_policy_area_alert_below_highthresh_action_delete(self, rbridge_id=None, policy=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type policy: policy_name
    :param policy: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **policy** tuple argument.

    :type area: type, area_value
    :param area: Keyword argument tuple.

    :type type: unicode
    :param type: **area** tuple argument:  Interface types that can be configured independent of speed

        * enumeration restriction: ::

            ['Ethernet']

    :type area_value: unicode
    :param area_value: **area** tuple argument.

        * enumeration restriction: ::

            ['MissingTerminationCharacter',
            'CRCAlignErrors',
            'IFG',
            'SymbolErrors']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.threshold_monitor.interface.policy', u'policy'), ('pybind.nos.v7_0_1b.rbridge_id.threshold_monitor.interface.policy.area', u'area'), ('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id'), ('pybind.slxos.v16r_1_00b.rbridge_id.threshold_monitor.interface.policy', u'policy'), ('pybind.slxos.v16r_1_00b.rbridge_id.threshold_monitor.interface.policy.area', u'area'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.threshold_monitor.interface.policy', u'policy'), ('pybind.nos.v6_0_2c.rbridge_id.threshold_monitor.interface.policy.area', u'area'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.threshold_monitor.interface.policy', u'policy'), ('pybind.nos.v7_1_0.rbridge_id.threshold_monitor.interface.policy.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.threshold_monitor.interface.policy.area.alert.below', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.threshold_monitor.interface.policy.area.alert.below', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.threshold_monitor.interface.policy.area.alert.below', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.threshold_monitor.interface.policy.area.alert.below', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'highthresh-action'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, policy=policy, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_threshold_monitor_interface_policy_area_alert_below_lowthresh_action_delete(self, rbridge_id=None, policy=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type policy: policy_name
    :param policy: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **policy** tuple argument.

    :type area: type, area_value
    :param area: Keyword argument tuple.

    :type type: unicode
    :param type: **area** tuple argument:  Interface types that can be configured independent of speed

        * enumeration restriction: ::

            ['Ethernet']

    :type area_value: unicode
    :param area_value: **area** tuple argument.

        * enumeration restriction: ::

            ['MissingTerminationCharacter',
            'CRCAlignErrors',
            'IFG',
            'SymbolErrors']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.threshold_monitor.interface.policy', u'policy'), ('pybind.nos.v7_0_1b.rbridge_id.threshold_monitor.interface.policy.area', u'area'), ('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id'), ('pybind.slxos.v16r_1_00b.rbridge_id.threshold_monitor.interface.policy', u'policy'), ('pybind.slxos.v16r_1_00b.rbridge_id.threshold_monitor.interface.policy.area', u'area'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.threshold_monitor.interface.policy', u'policy'), ('pybind.nos.v6_0_2c.rbridge_id.threshold_monitor.interface.policy.area', u'area'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.threshold_monitor.interface.policy', u'policy'), ('pybind.nos.v7_1_0.rbridge_id.threshold_monitor.interface.policy.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.threshold_monitor.interface.policy.area.alert.below', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.threshold_monitor.interface.policy.area.alert.below', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.threshold_monitor.interface.policy.area.alert.below', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.threshold_monitor.interface.policy.area.alert.below', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lowthresh-action'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, policy=policy, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_threshold_monitor_interface_policy_area_threshold_buffer_delete(self, rbridge_id=None, policy=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type policy: policy_name
    :param policy: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **policy** tuple argument.

    :type area: type, area_value
    :param area: Keyword argument tuple.

    :type type: unicode
    :param type: **area** tuple argument:  Interface types that can be configured independent of speed

        * enumeration restriction: ::

            ['Ethernet']

    :type area_value: unicode
    :param area_value: **area** tuple argument.

        * enumeration restriction: ::

            ['MissingTerminationCharacter',
            'CRCAlignErrors',
            'IFG',
            'SymbolErrors']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.threshold_monitor.interface.policy', u'policy'), ('pybind.nos.v6_0_2c.rbridge_id.threshold_monitor.interface.policy.area', u'area'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.threshold_monitor.interface.policy', u'policy'), ('pybind.nos.v7_0_1b.rbridge_id.threshold_monitor.interface.policy.area', u'area'), ('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id'), ('pybind.slxos.v16r_1_00b.rbridge_id.threshold_monitor.interface.policy', u'policy'), ('pybind.slxos.v16r_1_00b.rbridge_id.threshold_monitor.interface.policy.area', u'area'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.threshold_monitor.interface.policy', u'policy'), ('pybind.nos.v7_1_0.rbridge_id.threshold_monitor.interface.policy.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.threshold_monitor.interface.policy.area.threshold', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.threshold_monitor.interface.policy.area.threshold', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.threshold_monitor.interface.policy.area.threshold', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.threshold_monitor.interface.policy.area.threshold', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'buffer'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, policy=policy, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_threshold_monitor_interface_policy_area_threshold_high_threshold_delete(self, rbridge_id=None, policy=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type policy: policy_name
    :param policy: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **policy** tuple argument.

    :type area: type, area_value
    :param area: Keyword argument tuple.

    :type type: unicode
    :param type: **area** tuple argument:  Interface types that can be configured independent of speed

        * enumeration restriction: ::

            ['Ethernet']

    :type area_value: unicode
    :param area_value: **area** tuple argument.

        * enumeration restriction: ::

            ['MissingTerminationCharacter',
            'CRCAlignErrors',
            'IFG',
            'SymbolErrors']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.threshold_monitor.interface.policy', u'policy'), ('pybind.nos.v6_0_2c.rbridge_id.threshold_monitor.interface.policy.area', u'area'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.threshold_monitor.interface.policy', u'policy'), ('pybind.nos.v7_0_1b.rbridge_id.threshold_monitor.interface.policy.area', u'area'), ('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id'), ('pybind.slxos.v16r_1_00b.rbridge_id.threshold_monitor.interface.policy', u'policy'), ('pybind.slxos.v16r_1_00b.rbridge_id.threshold_monitor.interface.policy.area', u'area'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.threshold_monitor.interface.policy', u'policy'), ('pybind.nos.v7_1_0.rbridge_id.threshold_monitor.interface.policy.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.threshold_monitor.interface.policy.area.threshold', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.threshold_monitor.interface.policy.area.threshold', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.threshold_monitor.interface.policy.area.threshold', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.threshold_monitor.interface.policy.area.threshold', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'high-threshold'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, policy=policy, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_threshold_monitor_interface_policy_area_threshold_low_threshold_delete(self, rbridge_id=None, policy=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type policy: policy_name
    :param policy: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **policy** tuple argument.

    :type area: type, area_value
    :param area: Keyword argument tuple.

    :type type: unicode
    :param type: **area** tuple argument:  Interface types that can be configured independent of speed

        * enumeration restriction: ::

            ['Ethernet']

    :type area_value: unicode
    :param area_value: **area** tuple argument.

        * enumeration restriction: ::

            ['MissingTerminationCharacter',
            'CRCAlignErrors',
            'IFG',
            'SymbolErrors']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.threshold_monitor.interface.policy', u'policy'), ('pybind.nos.v6_0_2c.rbridge_id.threshold_monitor.interface.policy.area', u'area'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.threshold_monitor.interface.policy', u'policy'), ('pybind.nos.v7_0_1b.rbridge_id.threshold_monitor.interface.policy.area', u'area'), ('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id'), ('pybind.slxos.v16r_1_00b.rbridge_id.threshold_monitor.interface.policy', u'policy'), ('pybind.slxos.v16r_1_00b.rbridge_id.threshold_monitor.interface.policy.area', u'area'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.threshold_monitor.interface.policy', u'policy'), ('pybind.nos.v7_1_0.rbridge_id.threshold_monitor.interface.policy.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.threshold_monitor.interface.policy.area.threshold', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.threshold_monitor.interface.policy.area.threshold', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.threshold_monitor.interface.policy.area.threshold', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.threshold_monitor.interface.policy.area.threshold', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'low-threshold'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, policy=policy, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_threshold_monitor_interface_policy_area_threshold_timebase_delete(self, rbridge_id=None, policy=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type policy: policy_name
    :param policy: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **policy** tuple argument.

    :type area: type, area_value
    :param area: Keyword argument tuple.

    :type type: unicode
    :param type: **area** tuple argument:  Interface types that can be configured independent of speed

        * enumeration restriction: ::

            ['Ethernet']

    :type area_value: unicode
    :param area_value: **area** tuple argument.

        * enumeration restriction: ::

            ['MissingTerminationCharacter',
            'CRCAlignErrors',
            'IFG',
            'SymbolErrors']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.threshold_monitor.interface.policy', u'policy'), ('pybind.nos.v6_0_2c.rbridge_id.threshold_monitor.interface.policy.area', u'area'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.threshold_monitor.interface.policy', u'policy'), ('pybind.nos.v7_0_1b.rbridge_id.threshold_monitor.interface.policy.area', u'area'), ('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id'), ('pybind.slxos.v16r_1_00b.rbridge_id.threshold_monitor.interface.policy', u'policy'), ('pybind.slxos.v16r_1_00b.rbridge_id.threshold_monitor.interface.policy.area', u'area'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.threshold_monitor.interface.policy', u'policy'), ('pybind.nos.v7_1_0.rbridge_id.threshold_monitor.interface.policy.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.threshold_monitor.interface.policy.area.threshold', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.threshold_monitor.interface.policy.area.threshold', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.threshold_monitor.interface.policy.area.threshold', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.threshold_monitor.interface.policy.area.threshold', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'timebase'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, policy=policy, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_threshold_monitor_memory_actions_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.threshold_monitor.Memory', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.threshold_monitor.Memory', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.threshold_monitor.Memory', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.threshold_monitor.Memory', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'actions'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_threshold_monitor_memory_high_limit_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.threshold_monitor.Memory', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.threshold_monitor.Memory', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.threshold_monitor.Memory', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.threshold_monitor.Memory', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'high-limit'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_threshold_monitor_memory_limit_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.threshold_monitor.Memory', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.threshold_monitor.Memory', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.threshold_monitor.Memory', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.threshold_monitor.Memory', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'limit'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_threshold_monitor_memory_low_limit_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.threshold_monitor.Memory', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.threshold_monitor.Memory', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.threshold_monitor.Memory', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.threshold_monitor.Memory', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'low-limit'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_threshold_monitor_memory_poll_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.threshold_monitor.Memory', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.threshold_monitor.Memory', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.threshold_monitor.Memory', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.threshold_monitor.Memory', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'poll'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_threshold_monitor_memory_retry_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.threshold_monitor.Memory', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.threshold_monitor.Memory', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.threshold_monitor.Memory', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.threshold_monitor.Memory', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'retry'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_threshold_monitor_security_apply_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.threshold_monitor.security', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.threshold_monitor.security', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.threshold_monitor.security', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.threshold_monitor.security', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'apply'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_threshold_monitor_security_pause_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.threshold_monitor.security', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.threshold_monitor.security', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.threshold_monitor.security', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.threshold_monitor.security', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'pause'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_threshold_monitor_security_policy_area_alert_above_highthresh_action_delete(self, rbridge_id=None, policy=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type policy: sec_policy_name
    :param policy: Keyword argument tuple.

    :type sec_policy_name: unicode
    :param sec_policy_name: **policy** tuple argument.

    :type area: sec_area_value
    :param area: Keyword argument tuple.

    :type sec_area_value: unicode
    :param sec_area_value: **area** tuple argument:  Security Areas

        * enumeration restriction: ::

            ['telnet-violation', 'login-violation']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.threshold_monitor.security.policy', u'policy'), ('pybind.nos.v7_1_0.rbridge_id.threshold_monitor.security.policy.area', u'area'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.threshold_monitor.security.policy', u'policy'), ('pybind.nos.v7_0_1b.rbridge_id.threshold_monitor.security.policy.area', u'area'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.threshold_monitor.security.policy', u'policy'), ('pybind.nos.v6_0_2c.rbridge_id.threshold_monitor.security.policy.area', u'area'), ('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id'), ('pybind.slxos.v16r_1_00b.rbridge_id.threshold_monitor.security.policy', u'policy'), ('pybind.slxos.v16r_1_00b.rbridge_id.threshold_monitor.security.policy.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.threshold_monitor.security.policy.area.alert.above', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.threshold_monitor.security.policy.area.alert.above', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.threshold_monitor.security.policy.area.alert.above', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.threshold_monitor.security.policy.area.alert.above', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'highthresh-action'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, policy=policy, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_threshold_monitor_security_policy_area_alert_below_highthresh_action_delete(self, rbridge_id=None, policy=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type policy: sec_policy_name
    :param policy: Keyword argument tuple.

    :type sec_policy_name: unicode
    :param sec_policy_name: **policy** tuple argument.

    :type area: sec_area_value
    :param area: Keyword argument tuple.

    :type sec_area_value: unicode
    :param sec_area_value: **area** tuple argument:  Security Areas

        * enumeration restriction: ::

            ['telnet-violation', 'login-violation']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id'), ('pybind.slxos.v16r_1_00b.rbridge_id.threshold_monitor.security.policy', u'policy'), ('pybind.slxos.v16r_1_00b.rbridge_id.threshold_monitor.security.policy.area', u'area'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.threshold_monitor.security.policy', u'policy'), ('pybind.nos.v6_0_2c.rbridge_id.threshold_monitor.security.policy.area', u'area'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.threshold_monitor.security.policy', u'policy'), ('pybind.nos.v7_0_1b.rbridge_id.threshold_monitor.security.policy.area', u'area'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.threshold_monitor.security.policy', u'policy'), ('pybind.nos.v7_1_0.rbridge_id.threshold_monitor.security.policy.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.threshold_monitor.security.policy.area.alert.below', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.threshold_monitor.security.policy.area.alert.below', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.threshold_monitor.security.policy.area.alert.below', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.threshold_monitor.security.policy.area.alert.below', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'highthresh-action'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, policy=policy, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_threshold_monitor_security_policy_area_alert_below_lowthresh_action_delete(self, rbridge_id=None, policy=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type policy: sec_policy_name
    :param policy: Keyword argument tuple.

    :type sec_policy_name: unicode
    :param sec_policy_name: **policy** tuple argument.

    :type area: sec_area_value
    :param area: Keyword argument tuple.

    :type sec_area_value: unicode
    :param sec_area_value: **area** tuple argument:  Security Areas

        * enumeration restriction: ::

            ['telnet-violation', 'login-violation']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id'), ('pybind.slxos.v16r_1_00b.rbridge_id.threshold_monitor.security.policy', u'policy'), ('pybind.slxos.v16r_1_00b.rbridge_id.threshold_monitor.security.policy.area', u'area'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.threshold_monitor.security.policy', u'policy'), ('pybind.nos.v6_0_2c.rbridge_id.threshold_monitor.security.policy.area', u'area'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.threshold_monitor.security.policy', u'policy'), ('pybind.nos.v7_0_1b.rbridge_id.threshold_monitor.security.policy.area', u'area'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.threshold_monitor.security.policy', u'policy'), ('pybind.nos.v7_1_0.rbridge_id.threshold_monitor.security.policy.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.threshold_monitor.security.policy.area.alert.below', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.threshold_monitor.security.policy.area.alert.below', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.threshold_monitor.security.policy.area.alert.below', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.threshold_monitor.security.policy.area.alert.below', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lowthresh-action'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, policy=policy, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_threshold_monitor_security_policy_area_threshold_buffer_delete(self, rbridge_id=None, policy=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type policy: sec_policy_name
    :param policy: Keyword argument tuple.

    :type sec_policy_name: unicode
    :param sec_policy_name: **policy** tuple argument.

    :type area: sec_area_value
    :param area: Keyword argument tuple.

    :type sec_area_value: unicode
    :param sec_area_value: **area** tuple argument:  Security Areas

        * enumeration restriction: ::

            ['telnet-violation', 'login-violation']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.threshold_monitor.security.policy', u'policy'), ('pybind.nos.v7_0_1b.rbridge_id.threshold_monitor.security.policy.area', u'area'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.threshold_monitor.security.policy', u'policy'), ('pybind.nos.v7_1_0.rbridge_id.threshold_monitor.security.policy.area', u'area'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.threshold_monitor.security.policy', u'policy'), ('pybind.nos.v6_0_2c.rbridge_id.threshold_monitor.security.policy.area', u'area'), ('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id'), ('pybind.slxos.v16r_1_00b.rbridge_id.threshold_monitor.security.policy', u'policy'), ('pybind.slxos.v16r_1_00b.rbridge_id.threshold_monitor.security.policy.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.threshold_monitor.security.policy.area.threshold', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.threshold_monitor.security.policy.area.threshold', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.threshold_monitor.security.policy.area.threshold', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.threshold_monitor.security.policy.area.threshold', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'buffer'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, policy=policy, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_threshold_monitor_security_policy_area_threshold_high_threshold_delete(self, rbridge_id=None, policy=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type policy: sec_policy_name
    :param policy: Keyword argument tuple.

    :type sec_policy_name: unicode
    :param sec_policy_name: **policy** tuple argument.

    :type area: sec_area_value
    :param area: Keyword argument tuple.

    :type sec_area_value: unicode
    :param sec_area_value: **area** tuple argument:  Security Areas

        * enumeration restriction: ::

            ['telnet-violation', 'login-violation']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.threshold_monitor.security.policy', u'policy'), ('pybind.nos.v7_0_1b.rbridge_id.threshold_monitor.security.policy.area', u'area'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.threshold_monitor.security.policy', u'policy'), ('pybind.nos.v7_1_0.rbridge_id.threshold_monitor.security.policy.area', u'area'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.threshold_monitor.security.policy', u'policy'), ('pybind.nos.v6_0_2c.rbridge_id.threshold_monitor.security.policy.area', u'area'), ('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id'), ('pybind.slxos.v16r_1_00b.rbridge_id.threshold_monitor.security.policy', u'policy'), ('pybind.slxos.v16r_1_00b.rbridge_id.threshold_monitor.security.policy.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.threshold_monitor.security.policy.area.threshold', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.threshold_monitor.security.policy.area.threshold', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.threshold_monitor.security.policy.area.threshold', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.threshold_monitor.security.policy.area.threshold', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'high-threshold'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, policy=policy, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_threshold_monitor_security_policy_area_threshold_low_threshold_delete(self, rbridge_id=None, policy=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type policy: sec_policy_name
    :param policy: Keyword argument tuple.

    :type sec_policy_name: unicode
    :param sec_policy_name: **policy** tuple argument.

    :type area: sec_area_value
    :param area: Keyword argument tuple.

    :type sec_area_value: unicode
    :param sec_area_value: **area** tuple argument:  Security Areas

        * enumeration restriction: ::

            ['telnet-violation', 'login-violation']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.threshold_monitor.security.policy', u'policy'), ('pybind.nos.v7_0_1b.rbridge_id.threshold_monitor.security.policy.area', u'area'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.threshold_monitor.security.policy', u'policy'), ('pybind.nos.v7_1_0.rbridge_id.threshold_monitor.security.policy.area', u'area'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.threshold_monitor.security.policy', u'policy'), ('pybind.nos.v6_0_2c.rbridge_id.threshold_monitor.security.policy.area', u'area'), ('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id'), ('pybind.slxos.v16r_1_00b.rbridge_id.threshold_monitor.security.policy', u'policy'), ('pybind.slxos.v16r_1_00b.rbridge_id.threshold_monitor.security.policy.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.threshold_monitor.security.policy.area.threshold', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.threshold_monitor.security.policy.area.threshold', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.threshold_monitor.security.policy.area.threshold', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.threshold_monitor.security.policy.area.threshold', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'low-threshold'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, policy=policy, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_threshold_monitor_security_policy_area_timebase_delete(self, rbridge_id=None, policy=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type policy: sec_policy_name
    :param policy: Keyword argument tuple.

    :type sec_policy_name: unicode
    :param sec_policy_name: **policy** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type area: sec_area_value
    :param area: Keyword argument tuple.

    :type sec_area_value: unicode
    :param sec_area_value: **area** tuple argument:  Security Areas

        * enumeration restriction: ::

            ['telnet-violation', 'login-violation']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.threshold_monitor.security.policy', u'policy'), ('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id'), ('pybind.slxos.v16r_1_00b.rbridge_id.threshold_monitor.security.policy', u'policy'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.threshold_monitor.security.policy', u'policy'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.threshold_monitor.security.policy', u'policy')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.threshold_monitor.security.policy.area', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.threshold_monitor.security.policy.area', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.threshold_monitor.security.policy.area', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.threshold_monitor.security.policy.area', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}]
    bindings_keyval = {'kwargs_key_name': u'area', 'keyval': 'sec_area_value', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'timebase'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, policy=policy, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_threshold_monitor_sfp_apply_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.threshold_monitor.sfp', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.threshold_monitor.sfp', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.threshold_monitor.sfp', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.threshold_monitor.sfp', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'apply'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_threshold_monitor_sfp_pause_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.threshold_monitor.sfp', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.threshold_monitor.sfp', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.threshold_monitor.sfp', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.threshold_monitor.sfp', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'pause'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_threshold_monitor_sfp_policy_area_alert_above_highthresh_action_delete(self, rbridge_id=None, policy=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type policy: policy_name
    :param policy: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **policy** tuple argument.

    :type area: type, area_value
    :param area: Keyword argument tuple.

    :type type: unicode
    :param type: **area** tuple argument:  SFP types that can be configured

        * enumeration restriction: ::

            ['10GLR',
            '1GLR',
            '100GSR',
            '10GUSR',
            '1GSR',
            '10GSR',
            'QSFP']

    :type area_value: unicode
    :param area_value: **area** tuple argument.

        * enumeration restriction: ::

            ['Current',
            'RXP',
            'TXP',
            'Voltage',
            'Temperature']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.threshold_monitor.sfp.policy', u'policy'), ('pybind.nos.v7_0_1b.rbridge_id.threshold_monitor.sfp.policy.area', u'area'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.threshold_monitor.sfp.policy', u'policy'), ('pybind.nos.v7_1_0.rbridge_id.threshold_monitor.sfp.policy.area', u'area'), ('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id'), ('pybind.slxos.v16r_1_00b.rbridge_id.threshold_monitor.sfp.policy', u'policy'), ('pybind.slxos.v16r_1_00b.rbridge_id.threshold_monitor.sfp.policy.area', u'area'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.threshold_monitor.sfp.policy', u'policy'), ('pybind.nos.v6_0_2c.rbridge_id.threshold_monitor.sfp.policy.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.threshold_monitor.sfp.policy.area.alert.above', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.threshold_monitor.sfp.policy.area.alert.above', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.threshold_monitor.sfp.policy.area.alert.above', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.threshold_monitor.sfp.policy.area.alert.above', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'highthresh-action'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, policy=policy, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_threshold_monitor_sfp_policy_area_alert_below_highthresh_action_delete(self, rbridge_id=None, policy=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type policy: policy_name
    :param policy: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **policy** tuple argument.

    :type area: type, area_value
    :param area: Keyword argument tuple.

    :type type: unicode
    :param type: **area** tuple argument:  SFP types that can be configured

        * enumeration restriction: ::

            ['10GLR',
            '1GLR',
            '100GSR',
            '10GUSR',
            '1GSR',
            '10GSR',
            'QSFP']

    :type area_value: unicode
    :param area_value: **area** tuple argument.

        * enumeration restriction: ::

            ['Current',
            'RXP',
            'TXP',
            'Voltage',
            'Temperature']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.threshold_monitor.sfp.policy', u'policy'), ('pybind.nos.v7_0_1b.rbridge_id.threshold_monitor.sfp.policy.area', u'area'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.threshold_monitor.sfp.policy', u'policy'), ('pybind.nos.v7_1_0.rbridge_id.threshold_monitor.sfp.policy.area', u'area'), ('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id'), ('pybind.slxos.v16r_1_00b.rbridge_id.threshold_monitor.sfp.policy', u'policy'), ('pybind.slxos.v16r_1_00b.rbridge_id.threshold_monitor.sfp.policy.area', u'area'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.threshold_monitor.sfp.policy', u'policy'), ('pybind.nos.v6_0_2c.rbridge_id.threshold_monitor.sfp.policy.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.threshold_monitor.sfp.policy.area.alert.below', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.threshold_monitor.sfp.policy.area.alert.below', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.threshold_monitor.sfp.policy.area.alert.below', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.threshold_monitor.sfp.policy.area.alert.below', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'highthresh-action'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, policy=policy, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_threshold_monitor_sfp_policy_area_alert_below_lowthresh_action_delete(self, rbridge_id=None, policy=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type policy: policy_name
    :param policy: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **policy** tuple argument.

    :type area: type, area_value
    :param area: Keyword argument tuple.

    :type type: unicode
    :param type: **area** tuple argument:  SFP types that can be configured

        * enumeration restriction: ::

            ['10GLR',
            '1GLR',
            '100GSR',
            '10GUSR',
            '1GSR',
            '10GSR',
            'QSFP']

    :type area_value: unicode
    :param area_value: **area** tuple argument.

        * enumeration restriction: ::

            ['Current',
            'RXP',
            'TXP',
            'Voltage',
            'Temperature']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.threshold_monitor.sfp.policy', u'policy'), ('pybind.nos.v7_0_1b.rbridge_id.threshold_monitor.sfp.policy.area', u'area'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.threshold_monitor.sfp.policy', u'policy'), ('pybind.nos.v7_1_0.rbridge_id.threshold_monitor.sfp.policy.area', u'area'), ('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id'), ('pybind.slxos.v16r_1_00b.rbridge_id.threshold_monitor.sfp.policy', u'policy'), ('pybind.slxos.v16r_1_00b.rbridge_id.threshold_monitor.sfp.policy.area', u'area'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.threshold_monitor.sfp.policy', u'policy'), ('pybind.nos.v6_0_2c.rbridge_id.threshold_monitor.sfp.policy.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.threshold_monitor.sfp.policy.area.alert.below', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.threshold_monitor.sfp.policy.area.alert.below', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.threshold_monitor.sfp.policy.area.alert.below', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.threshold_monitor.sfp.policy.area.alert.below', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lowthresh-action'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, policy=policy, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_threshold_monitor_sfp_policy_area_threshold_buffer_delete(self, rbridge_id=None, policy=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type policy: policy_name
    :param policy: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **policy** tuple argument.

    :type area: type, area_value
    :param area: Keyword argument tuple.

    :type type: unicode
    :param type: **area** tuple argument:  SFP types that can be configured

        * enumeration restriction: ::

            ['10GLR',
            '1GLR',
            '100GSR',
            '10GUSR',
            '1GSR',
            '10GSR',
            'QSFP']

    :type area_value: unicode
    :param area_value: **area** tuple argument.

        * enumeration restriction: ::

            ['Current',
            'RXP',
            'TXP',
            'Voltage',
            'Temperature']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id'), ('pybind.slxos.v16r_1_00b.rbridge_id.threshold_monitor.sfp.policy', u'policy'), ('pybind.slxos.v16r_1_00b.rbridge_id.threshold_monitor.sfp.policy.area', u'area'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.threshold_monitor.sfp.policy', u'policy'), ('pybind.nos.v6_0_2c.rbridge_id.threshold_monitor.sfp.policy.area', u'area'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.threshold_monitor.sfp.policy', u'policy'), ('pybind.nos.v7_1_0.rbridge_id.threshold_monitor.sfp.policy.area', u'area'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.threshold_monitor.sfp.policy', u'policy'), ('pybind.nos.v7_0_1b.rbridge_id.threshold_monitor.sfp.policy.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.threshold_monitor.sfp.policy.area.threshold', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.threshold_monitor.sfp.policy.area.threshold', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.threshold_monitor.sfp.policy.area.threshold', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.threshold_monitor.sfp.policy.area.threshold', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'buffer'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, policy=policy, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_threshold_monitor_sfp_policy_area_threshold_high_threshold_delete(self, rbridge_id=None, policy=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type policy: policy_name
    :param policy: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **policy** tuple argument.

    :type area: type, area_value
    :param area: Keyword argument tuple.

    :type type: unicode
    :param type: **area** tuple argument:  SFP types that can be configured

        * enumeration restriction: ::

            ['10GLR',
            '1GLR',
            '100GSR',
            '10GUSR',
            '1GSR',
            '10GSR',
            'QSFP']

    :type area_value: unicode
    :param area_value: **area** tuple argument.

        * enumeration restriction: ::

            ['Current',
            'RXP',
            'TXP',
            'Voltage',
            'Temperature']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id'), ('pybind.slxos.v16r_1_00b.rbridge_id.threshold_monitor.sfp.policy', u'policy'), ('pybind.slxos.v16r_1_00b.rbridge_id.threshold_monitor.sfp.policy.area', u'area'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.threshold_monitor.sfp.policy', u'policy'), ('pybind.nos.v6_0_2c.rbridge_id.threshold_monitor.sfp.policy.area', u'area'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.threshold_monitor.sfp.policy', u'policy'), ('pybind.nos.v7_1_0.rbridge_id.threshold_monitor.sfp.policy.area', u'area'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.threshold_monitor.sfp.policy', u'policy'), ('pybind.nos.v7_0_1b.rbridge_id.threshold_monitor.sfp.policy.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.threshold_monitor.sfp.policy.area.threshold', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.threshold_monitor.sfp.policy.area.threshold', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.threshold_monitor.sfp.policy.area.threshold', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.threshold_monitor.sfp.policy.area.threshold', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'high-threshold'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, policy=policy, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_threshold_monitor_sfp_policy_area_threshold_low_threshold_delete(self, rbridge_id=None, policy=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type policy: policy_name
    :param policy: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **policy** tuple argument.

    :type area: type, area_value
    :param area: Keyword argument tuple.

    :type type: unicode
    :param type: **area** tuple argument:  SFP types that can be configured

        * enumeration restriction: ::

            ['10GLR',
            '1GLR',
            '100GSR',
            '10GUSR',
            '1GSR',
            '10GSR',
            'QSFP']

    :type area_value: unicode
    :param area_value: **area** tuple argument.

        * enumeration restriction: ::

            ['Current',
            'RXP',
            'TXP',
            'Voltage',
            'Temperature']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id'), ('pybind.slxos.v16r_1_00b.rbridge_id.threshold_monitor.sfp.policy', u'policy'), ('pybind.slxos.v16r_1_00b.rbridge_id.threshold_monitor.sfp.policy.area', u'area'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.threshold_monitor.sfp.policy', u'policy'), ('pybind.nos.v6_0_2c.rbridge_id.threshold_monitor.sfp.policy.area', u'area'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.threshold_monitor.sfp.policy', u'policy'), ('pybind.nos.v7_1_0.rbridge_id.threshold_monitor.sfp.policy.area', u'area'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.threshold_monitor.sfp.policy', u'policy'), ('pybind.nos.v7_0_1b.rbridge_id.threshold_monitor.sfp.policy.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.threshold_monitor.sfp.policy.area.threshold', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.threshold_monitor.sfp.policy.area.threshold', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.threshold_monitor.sfp.policy.area.threshold', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.threshold_monitor.sfp.policy.area.threshold', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'low-threshold'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, policy=policy, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_vcs_auto_shut_lag_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.slxos.v16r_1_00b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.vcs.auto_shut', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.vcs.auto_shut', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.vcs.auto_shut', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rbridge_id.vcs.auto_shut', 'pybind.slxos.v16r_1_00b.brocade_rbridge', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_vrf_delete(self, rbridge_id=None, vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.vrf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.vrf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.vrf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrf', 'keyval': 'vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v7_0_1b.rbridge_id.vrf": {}, "pybind.nos.v6_0_2c.rbridge_id.vrf": {"vrf_name": "vrf_name", "route_distiniguisher": "route_distiniguisher"}, "pybind.nos.v7_1_0.rbridge_id.vrf": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_vrf_address_family_delete(self, rbridge_id=None, vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.vrf.address_family', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.vrf.address_family', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.vrf.address_family', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv4_unicast_delete(self, rbridge_id=None, vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.vrf', u'vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.vrf.address_family.ip.unicast', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.vrf.address_family.ip.unicast', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.vrf.address_family.ip.unicast', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv4_unicast_arp_delete(self, rbridge_id=None, vrf=None, arp_entry=None, mac_address_value=None, interfacename=None, GigabitEthernet=None, TenGigabitEthernet=None, FortyGigabitEthernet=None, HundredGigabitEthernet=None, Ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type arp_entry: arp_ip_address, mac_address_value, interfacename, GigabitEthernet, TenGigabitEthernet, FortyGigabitEthernet, HundredGigabitEthernet, Ve
    :param arp_entry: Keyword argument tuple.

    :type arp_ip_address: unicode
    :param arp_ip_address: **arp_entry** tuple argument:  A.B.C.D;; IP address of the ARP entry

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type mac_address_value: unicode
    :param mac_address_value: **arp_entry** tuple argument.

    :type interfacename: unicode
    :param interfacename: **arp_entry** tuple argument.

        * enumeration restriction: ::

            ['interface']

    :type GigabitEthernet: unicode
    :param GigabitEthernet: **arp_entry** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type TenGigabitEthernet: unicode
    :param TenGigabitEthernet: **arp_entry** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type FortyGigabitEthernet: unicode
    :param FortyGigabitEthernet: **arp_entry** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type HundredGigabitEthernet: unicode
    :param HundredGigabitEthernet: **arp_entry** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type Ve: long
    :param Ve: **arp_entry** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Argument(s)**:

    :type mac_address_value: unicode
    :param mac_address_value: Keyword argument.

    :type interfacename: unicode
    :param interfacename: Keyword argument.

        * enumeration restriction: ::

            ['interface']

    :type GigabitEthernet: unicode
    :param GigabitEthernet: Choice keyword argument (Only one choice argument allowed per API invocation).

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type TenGigabitEthernet: unicode
    :param TenGigabitEthernet: Choice keyword argument (Only one choice argument allowed per API invocation).

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type FortyGigabitEthernet: unicode
    :param FortyGigabitEthernet: Choice keyword argument (Only one choice argument allowed per API invocation).

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type HundredGigabitEthernet: unicode
    :param HundredGigabitEthernet: Choice keyword argument (Only one choice argument allowed per API invocation).

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type Ve: long
    :param Ve: Choice keyword argument (Only one choice argument allowed per API invocation).

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.vrf', u'vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.vrf.address_family.ip.unicast.arp_entry', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.vrf.address_family.ip.unicast.arp_entry', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.vrf.address_family.ip.unicast.arp_entry', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'arp_entry', 'keyval': 'arp_ip_address', 'extra_keyval': 'arp_ip_address, mac_address_value, interfacename, GigabitEthernet, TenGigabitEthernet, FortyGigabitEthernet, HundredGigabitEthernet, Ve'}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v6_0_2c.rbridge_id.vrf.address_family.ip.unicast.arp_entry": {"mac_address_value": "mac_address_value", "interfacename": "interfacename", "FortyGigabitEthernet": "FortyGigabitEthernet", "GigabitEthernet": "GigabitEthernet", "TenGigabitEthernet": "TenGigabitEthernet", "arp_ip_address": "arp_ip_address", "HundredGigabitEthernet": "HundredGigabitEthernet", "Ve": "Ve"}, "pybind.nos.v7_0_1b.rbridge_id.vrf.address_family.ip.unicast.arp_entry": {}, "pybind.nos.v7_1_0.rbridge_id.vrf.address_family.ip.unicast.arp_entry": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v6_0_2c.rbridge_id.vrf.address_family.ip.unicast.arp_entry': [u'FortyGigabitEthernet', u'GigabitEthernet', u'TenGigabitEthernet', u'HundredGigabitEthernet', u'Ve'], 'pybind.nos.v7_0_1b.rbridge_id.vrf.address_family.ip.unicast.arp_entry': [u'Port_channel', u'Ve', u'FortyGigabitEthernet', u'GigabitEthernet', u'TenGigabitEthernet', u'HundredGigabitEthernet'], 'pybind.nos.v7_1_0.rbridge_id.vrf.address_family.ip.unicast.arp_entry': [u'Port_channel', u'Ve', u'FortyGigabitEthernet', u'GigabitEthernet', u'TenGigabitEthernet', u'HundredGigabitEthernet']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf, arp_entry=arp_entry, mac_address_value=mac_address_value, interfacename=interfacename, GigabitEthernet=GigabitEthernet, TenGigabitEthernet=TenGigabitEthernet, FortyGigabitEthernet=FortyGigabitEthernet, HundredGigabitEthernet=HundredGigabitEthernet, Ve=Ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf, arp_entry=arp_entry, mac_address_value=mac_address_value, interfacename=interfacename, GigabitEthernet=GigabitEthernet, TenGigabitEthernet=TenGigabitEthernet, FortyGigabitEthernet=FortyGigabitEthernet, HundredGigabitEthernet=HundredGigabitEthernet, Ve=Ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv4_unicast_arp_fortygigabitethernet_delete(self, rbridge_id=None, vrf=None, arp_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type arp_entry: arp_ip_address
    :param arp_entry: Keyword argument tuple.

    :type arp_ip_address: unicode
    :param arp_ip_address: **arp_entry** tuple argument:  A.B.C.D;; IP address of the ARP entry

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.vrf', u'vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.vrf.address_family.ip.unicast.arp_entry', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.vrf.address_family.ip.unicast.arp_entry', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.vrf.address_family.ip.unicast.arp_entry', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'arp_entry', 'keyval': 'arp_ip_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'FortyGigabitEthernet'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf, arp_entry=arp_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf, arp_entry=arp_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv4_unicast_arp_gigabitethernet_delete(self, rbridge_id=None, vrf=None, arp_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type arp_entry: arp_ip_address
    :param arp_entry: Keyword argument tuple.

    :type arp_ip_address: unicode
    :param arp_ip_address: **arp_entry** tuple argument:  A.B.C.D;; IP address of the ARP entry

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.vrf', u'vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.vrf.address_family.ip.unicast.arp_entry', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.vrf.address_family.ip.unicast.arp_entry', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.vrf.address_family.ip.unicast.arp_entry', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'arp_entry', 'keyval': 'arp_ip_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'GigabitEthernet'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf, arp_entry=arp_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf, arp_entry=arp_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv4_unicast_arp_hundredgigabitethernet_delete(self, rbridge_id=None, vrf=None, arp_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type arp_entry: arp_ip_address
    :param arp_entry: Keyword argument tuple.

    :type arp_ip_address: unicode
    :param arp_ip_address: **arp_entry** tuple argument:  A.B.C.D;; IP address of the ARP entry

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.vrf', u'vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.vrf.address_family.ip.unicast.arp_entry', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.vrf.address_family.ip.unicast.arp_entry', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.vrf.address_family.ip.unicast.arp_entry', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'arp_entry', 'keyval': 'arp_ip_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'HundredGigabitEthernet'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf, arp_entry=arp_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf, arp_entry=arp_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv4_unicast_arp_interfacename_delete(self, rbridge_id=None, vrf=None, arp_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type arp_entry: arp_ip_address
    :param arp_entry: Keyword argument tuple.

    :type arp_ip_address: unicode
    :param arp_ip_address: **arp_entry** tuple argument:  A.B.C.D;; IP address of the ARP entry

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.vrf', u'vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.vrf.address_family.ip.unicast.arp_entry', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.vrf.address_family.ip.unicast.arp_entry', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.vrf.address_family.ip.unicast.arp_entry', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'arp_entry', 'keyval': 'arp_ip_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'interfacename'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf, arp_entry=arp_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf, arp_entry=arp_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv4_unicast_arp_mac_address_value_delete(self, rbridge_id=None, vrf=None, arp_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type arp_entry: arp_ip_address
    :param arp_entry: Keyword argument tuple.

    :type arp_ip_address: unicode
    :param arp_ip_address: **arp_entry** tuple argument:  A.B.C.D;; IP address of the ARP entry

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.vrf', u'vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.vrf.address_family.ip.unicast.arp_entry', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.vrf.address_family.ip.unicast.arp_entry', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.vrf.address_family.ip.unicast.arp_entry', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'arp_entry', 'keyval': 'arp_ip_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mac-address-value'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf, arp_entry=arp_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf, arp_entry=arp_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv4_unicast_arp_port_channel_delete(self, rbridge_id=None, vrf=None, arp_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type arp_entry: arp_ip_address
    :param arp_entry: Keyword argument tuple.

    :type arp_ip_address: unicode
    :param arp_ip_address: **arp_entry** tuple argument:  A.B.C.D;; IP address of the ARP entry

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.vrf.address_family.ip.unicast.arp_entry', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.vrf.address_family.ip.unicast.arp_entry', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'arp_entry', 'keyval': 'arp_ip_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'Port-channel'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf, arp_entry=arp_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf, arp_entry=arp_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv4_unicast_arp_tengigabitethernet_delete(self, rbridge_id=None, vrf=None, arp_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type arp_entry: arp_ip_address
    :param arp_entry: Keyword argument tuple.

    :type arp_ip_address: unicode
    :param arp_ip_address: **arp_entry** tuple argument:  A.B.C.D;; IP address of the ARP entry

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.vrf', u'vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.vrf.address_family.ip.unicast.arp_entry', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.vrf.address_family.ip.unicast.arp_entry', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.vrf.address_family.ip.unicast.arp_entry', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'arp_entry', 'keyval': 'arp_ip_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'TenGigabitEthernet'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf, arp_entry=arp_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf, arp_entry=arp_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv4_unicast_arp_ve_delete(self, rbridge_id=None, vrf=None, arp_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type arp_entry: arp_ip_address
    :param arp_entry: Keyword argument tuple.

    :type arp_ip_address: unicode
    :param arp_ip_address: **arp_entry** tuple argument:  A.B.C.D;; IP address of the ARP entry

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.vrf', u'vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.vrf.address_family.ip.unicast.arp_entry', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.vrf.address_family.ip.unicast.arp_entry', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.vrf.address_family.ip.unicast.arp_entry', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'arp_entry', 'keyval': 'arp_ip_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'Ve'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf, arp_entry=arp_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf, arp_entry=arp_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv4_unicast_export_delete(self, rbridge_id=None, vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v7_1_0.rbridge_id.vrf.address_family.ip.unicast.export', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'map_export, evpn_export'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv4_unicast_export_evpn_delete(self, rbridge_id=None, vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v7_1_0.rbridge_id.vrf.address_family.ip.unicast.export', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'evpn'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv4_unicast_export_map_delete(self, rbridge_id=None, vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v7_1_0.rbridge_id.vrf.address_family.ip.unicast.export', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv4_unicast_import_delete(self, rbridge_id=None, vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v7_1_0.rbridge_id.vrf.address_family.ip.unicast.import_', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'map_import, evpn_import'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv4_unicast_import_evpn_delete(self, rbridge_id=None, vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v7_1_0.rbridge_id.vrf.address_family.ip.unicast.import_', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'evpn'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv4_unicast_import_map_delete(self, rbridge_id=None, vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v7_1_0.rbridge_id.vrf.address_family.ip.unicast.import_', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv4_unicast_ip_delete(self, rbridge_id=None, vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.vrf', u'vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.vrf.address_family.ip.unicast.ip', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.vrf.address_family.ip.unicast.ip', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.vrf.address_family.ip.unicast.ip', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv4_unicast_ip_import_delete(self, rbridge_id=None, vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.vrf', u'vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.vrf.address_family.ip.unicast.ip.import_', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.vrf.address_family.ip.unicast.ip.import_', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.vrf.address_family.ip.unicast.ip.import_', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv4_unicast_ip_import_routes_delete(self, rbridge_id=None, vrf=None, routes=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type routes: src_vrf, route_map
    :param routes: Keyword argument tuple.

    :type src_vrf: unicode
    :param src_vrf: **routes** tuple argument:  ASCII string;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type route_map: unicode
    :param route_map: **routes** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.vrf.address_family.ip.unicast.ip.import_.routes', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.vrf.address_family.ip.unicast.ip.import_.routes', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.vrf.address_family.ip.unicast.ip.import_.routes', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'routes', 'keyval': 'src_vrf, route_map', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf, routes=routes)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf, routes=routes)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv4_unicast_ip_route_static_delete(self, rbridge_id=None, vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.vrf', u'vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.vrf.address_family.ip.unicast.ip.route.static', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.vrf.address_family.ip.unicast.ip.route.static', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.vrf.address_family.ip.unicast.ip.route.static', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv4_unicast_ip_route_static_bfd_delete(self, rbridge_id=None, vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.vrf', u'vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.vrf.address_family.ip.unicast.ip.route.static.bfd', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.vrf.address_family.ip.unicast.ip.route.static.bfd', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.vrf.address_family.ip.unicast.ip.route.static.bfd', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv4_unicast_ip_route_static_bfd_bfd_static_route_delete(self, rbridge_id=None, vrf=None, bfd_static_route=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type bfd_static_route: bfd_static_route_dest, bfd_static_route_src
    :param bfd_static_route: Keyword argument tuple.

    :type bfd_static_route_dest: unicode
    :param bfd_static_route_dest: **bfd_static_route** tuple argument:  A.B.C.D ;; Destination IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type bfd_static_route_src: unicode
    :param bfd_static_route_src: **bfd_static_route** tuple argument:  A.B.C.D ;; Source IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.vrf.address_family.ip.unicast.ip.route.static.bfd.bfd_static_route', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.vrf.address_family.ip.unicast.ip.route.static.bfd.bfd_static_route', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.vrf.address_family.ip.unicast.ip.route.static.bfd.bfd_static_route', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'bfd_static_route', 'keyval': 'bfd_static_route_dest, bfd_static_route_src', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf, bfd_static_route=bfd_static_route)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf, bfd_static_route=bfd_static_route)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv4_unicast_ip_route_static_route_nh_delete(self, rbridge_id=None, vrf=None, static_route_nh=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type static_route_nh: static_route_dest, static_route_next_hop
    :param static_route_nh: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_nh** tuple argument:  A.B.C.D/L ;; Destination IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type static_route_next_hop: unicode
    :param static_route_next_hop: **static_route_nh** tuple argument:  A.B.C.D ;; Next hop IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.vrf.address_family.ip.unicast.ip.route.static_route_nh', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.vrf.address_family.ip.unicast.ip.route.static_route_nh', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.vrf.address_family.ip.unicast.ip.route.static_route_nh', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'static_route_nh', 'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf, static_route_nh=static_route_nh)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf, static_route_nh=static_route_nh)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv4_unicast_ip_route_static_route_nh_distance_delete(self, rbridge_id=None, vrf=None, static_route_nh=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type static_route_nh: static_route_dest, static_route_next_hop
    :param static_route_nh: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_nh** tuple argument:  A.B.C.D/L ;; Destination IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type static_route_next_hop: unicode
    :param static_route_next_hop: **static_route_nh** tuple argument:  A.B.C.D ;; Next hop IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_1_0.rbridge_id.vrf.address_family.ip.unicast.ip.route.static_route_nh', u'static_route_nh'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.vrf', u'vrf'), ('pybind.nos.v6_0_2c.rbridge_id.vrf.address_family.ip.unicast.ip.route.static_route_nh', u'static_route_nh'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_0_1b.rbridge_id.vrf.address_family.ip.unicast.ip.route.static_route_nh', u'static_route_nh')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.vrf.address_family.ip.unicast.ip.route.static_route_nh.route_attributes', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.vrf.address_family.ip.unicast.ip.route.static_route_nh.route_attributes', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.vrf.address_family.ip.unicast.ip.route.static_route_nh.route_attributes', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'distance'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf, static_route_nh=static_route_nh)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf, static_route_nh=static_route_nh)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv4_unicast_ip_route_static_route_nh_metric_delete(self, rbridge_id=None, vrf=None, static_route_nh=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type static_route_nh: static_route_dest, static_route_next_hop
    :param static_route_nh: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_nh** tuple argument:  A.B.C.D/L ;; Destination IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type static_route_next_hop: unicode
    :param static_route_next_hop: **static_route_nh** tuple argument:  A.B.C.D ;; Next hop IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_1_0.rbridge_id.vrf.address_family.ip.unicast.ip.route.static_route_nh', u'static_route_nh'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.vrf', u'vrf'), ('pybind.nos.v6_0_2c.rbridge_id.vrf.address_family.ip.unicast.ip.route.static_route_nh', u'static_route_nh'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_0_1b.rbridge_id.vrf.address_family.ip.unicast.ip.route.static_route_nh', u'static_route_nh')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.vrf.address_family.ip.unicast.ip.route.static_route_nh.route_attributes', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.vrf.address_family.ip.unicast.ip.route.static_route_nh.route_attributes', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.vrf.address_family.ip.unicast.ip.route.static_route_nh.route_attributes', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf, static_route_nh=static_route_nh)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf, static_route_nh=static_route_nh)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv4_unicast_ip_route_static_route_nh_tag_delete(self, rbridge_id=None, vrf=None, static_route_nh=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type static_route_nh: static_route_dest, static_route_next_hop
    :param static_route_nh: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_nh** tuple argument:  A.B.C.D/L ;; Destination IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type static_route_next_hop: unicode
    :param static_route_next_hop: **static_route_nh** tuple argument:  A.B.C.D ;; Next hop IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_1_0.rbridge_id.vrf.address_family.ip.unicast.ip.route.static_route_nh', u'static_route_nh'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.vrf', u'vrf'), ('pybind.nos.v6_0_2c.rbridge_id.vrf.address_family.ip.unicast.ip.route.static_route_nh', u'static_route_nh'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_0_1b.rbridge_id.vrf.address_family.ip.unicast.ip.route.static_route_nh', u'static_route_nh')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.vrf.address_family.ip.unicast.ip.route.static_route_nh.route_attributes', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.vrf.address_family.ip.unicast.ip.route.static_route_nh.route_attributes', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.vrf.address_family.ip.unicast.ip.route.static_route_nh.route_attributes', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf, static_route_nh=static_route_nh)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf, static_route_nh=static_route_nh)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv4_unicast_ip_route_static_route_nh_vrf_delete(self, rbridge_id=None, vrf=None, static_route_nh_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type static_route_nh_vrf: static_route_next_vrf_dest, next_hop_vrf, static_route_next_hop
    :param static_route_nh_vrf: Keyword argument tuple.

    :type static_route_next_vrf_dest: unicode
    :param static_route_next_vrf_dest: **static_route_nh_vrf** tuple argument:  A.B.C.D/L ;; Destination IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type next_hop_vrf: unicode
    :param next_hop_vrf: **static_route_nh_vrf** tuple argument:  Next Hop Vrf Name

    :type static_route_next_hop: unicode
    :param static_route_next_hop: **static_route_nh_vrf** tuple argument:  A.B.C.D ;; Next hop IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.vrf', u'vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.vrf.address_family.ip.unicast.ip.route.static_route_nh_vrf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.vrf.address_family.ip.unicast.ip.route.static_route_nh_vrf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.vrf.address_family.ip.unicast.ip.route.static_route_nh_vrf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'static_route_nh_vrf', 'keyval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_next_hop', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf, static_route_nh_vrf=static_route_nh_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf, static_route_nh_vrf=static_route_nh_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv4_unicast_ip_route_static_route_oif_delete(self, rbridge_id=None, vrf=None, static_route_oif=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type static_route_oif: static_route_dest, static_route_oif_type, static_route_oif_name
    :param static_route_oif: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_oif** tuple argument:  A.B.C.D/L ;; Destination IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type static_route_oif_type: unicode
    :param static_route_oif_type: **static_route_oif** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ve',
            'fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'null']

    :type static_route_oif_name: unicode
    :param static_route_oif_name: **static_route_oif** tuple argument.

        * length restriction: ::

            ['1..16']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.vrf.address_family.ip.unicast.ip.route.static_route_oif', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.vrf.address_family.ip.unicast.ip.route.static_route_oif', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.vrf.address_family.ip.unicast.ip.route.static_route_oif', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'static_route_oif', 'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf, static_route_oif=static_route_oif)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf, static_route_oif=static_route_oif)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv4_unicast_ip_route_static_route_oif_distance_delete(self, rbridge_id=None, vrf=None, static_route_oif=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type static_route_oif: static_route_dest, static_route_oif_type, static_route_oif_name
    :param static_route_oif: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_oif** tuple argument:  A.B.C.D/L ;; Destination IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type static_route_oif_type: unicode
    :param static_route_oif_type: **static_route_oif** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ve',
            'fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'null']

    :type static_route_oif_name: unicode
    :param static_route_oif_name: **static_route_oif** tuple argument.

        * length restriction: ::

            ['1..16']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_1_0.rbridge_id.vrf.address_family.ip.unicast.ip.route.static_route_oif', u'static_route_oif'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_0_1b.rbridge_id.vrf.address_family.ip.unicast.ip.route.static_route_oif', u'static_route_oif'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.vrf', u'vrf'), ('pybind.nos.v6_0_2c.rbridge_id.vrf.address_family.ip.unicast.ip.route.static_route_oif', u'static_route_oif')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.vrf.address_family.ip.unicast.ip.route.static_route_oif.route_attributes', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.vrf.address_family.ip.unicast.ip.route.static_route_oif.route_attributes', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.vrf.address_family.ip.unicast.ip.route.static_route_oif.route_attributes', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'distance'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf, static_route_oif=static_route_oif)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf, static_route_oif=static_route_oif)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv4_unicast_ip_route_static_route_oif_metric_delete(self, rbridge_id=None, vrf=None, static_route_oif=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type static_route_oif: static_route_dest, static_route_oif_type, static_route_oif_name
    :param static_route_oif: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_oif** tuple argument:  A.B.C.D/L ;; Destination IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type static_route_oif_type: unicode
    :param static_route_oif_type: **static_route_oif** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ve',
            'fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'null']

    :type static_route_oif_name: unicode
    :param static_route_oif_name: **static_route_oif** tuple argument.

        * length restriction: ::

            ['1..16']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_1_0.rbridge_id.vrf.address_family.ip.unicast.ip.route.static_route_oif', u'static_route_oif'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_0_1b.rbridge_id.vrf.address_family.ip.unicast.ip.route.static_route_oif', u'static_route_oif'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.vrf', u'vrf'), ('pybind.nos.v6_0_2c.rbridge_id.vrf.address_family.ip.unicast.ip.route.static_route_oif', u'static_route_oif')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.vrf.address_family.ip.unicast.ip.route.static_route_oif.route_attributes', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.vrf.address_family.ip.unicast.ip.route.static_route_oif.route_attributes', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.vrf.address_family.ip.unicast.ip.route.static_route_oif.route_attributes', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf, static_route_oif=static_route_oif)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf, static_route_oif=static_route_oif)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv4_unicast_ip_route_static_route_oif_tag_delete(self, rbridge_id=None, vrf=None, static_route_oif=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type static_route_oif: static_route_dest, static_route_oif_type, static_route_oif_name
    :param static_route_oif: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_oif** tuple argument:  A.B.C.D/L ;; Destination IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type static_route_oif_type: unicode
    :param static_route_oif_type: **static_route_oif** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ve',
            'fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'null']

    :type static_route_oif_name: unicode
    :param static_route_oif_name: **static_route_oif** tuple argument.

        * length restriction: ::

            ['1..16']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_1_0.rbridge_id.vrf.address_family.ip.unicast.ip.route.static_route_oif', u'static_route_oif'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_0_1b.rbridge_id.vrf.address_family.ip.unicast.ip.route.static_route_oif', u'static_route_oif'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.vrf', u'vrf'), ('pybind.nos.v6_0_2c.rbridge_id.vrf.address_family.ip.unicast.ip.route.static_route_oif', u'static_route_oif')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.vrf.address_family.ip.unicast.ip.route.static_route_oif.route_attributes', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.vrf.address_family.ip.unicast.ip.route.static_route_oif.route_attributes', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.vrf.address_family.ip.unicast.ip.route.static_route_oif.route_attributes', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf, static_route_oif=static_route_oif)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf, static_route_oif=static_route_oif)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv4_unicast_ip_route_static_route_oif_vrf_delete(self, rbridge_id=None, vrf=None, static_route_oif_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type static_route_oif_vrf: static_route_next_vrf_dest, next_hop_vrf, static_route_oif_type, static_route_oif_name
    :param static_route_oif_vrf: Keyword argument tuple.

    :type static_route_next_vrf_dest: unicode
    :param static_route_next_vrf_dest: **static_route_oif_vrf** tuple argument:  A.B.C.D/L ;; Destination IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type next_hop_vrf: unicode
    :param next_hop_vrf: **static_route_oif_vrf** tuple argument:  Next Hop Vrf Name

    :type static_route_oif_type: unicode
    :param static_route_oif_type: **static_route_oif_vrf** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            've']

    :type static_route_oif_name: unicode
    :param static_route_oif_name: **static_route_oif_vrf** tuple argument.

        * length restriction: ::

            ['1..16']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.vrf', u'vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.vrf.address_family.ip.unicast.ip.route.static_route_oif_vrf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.vrf.address_family.ip.unicast.ip.route.static_route_oif_vrf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.vrf.address_family.ip.unicast.ip.route.static_route_oif_vrf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'static_route_oif_vrf', 'keyval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf, static_route_oif_vrf=static_route_oif_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf, static_route_oif_vrf=static_route_oif_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv4_unicast_max_route_delete(self, rbridge_id=None, vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.vrf', u'vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.vrf.address_family.ip.unicast', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.vrf.address_family.ip.unicast', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.vrf.address_family.ip.unicast', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'max-route'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv4_unicast_route_target_evpn_delete(self, rbridge_id=None, vrf=None, route_target=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type route_target: action, target_community
    :param route_target: Keyword argument tuple.

    :type action: unicode
    :param action: **route_target** tuple argument.

        * enumeration restriction: ::

            ['import', 'export', 'both']

    :type target_community: unicode
    :param target_community: **route_target** tuple argument:  ASN:nn;; Target VPN Extended Community

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.vrf.address_family.ip.unicast.route_target', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.vrf.address_family.ip.unicast.route_target', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'route_target', 'keyval': 'action, target_community', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'evpn'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf, route_target=route_target)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf, route_target=route_target)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv6_unicast_delete(self, rbridge_id=None, vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.vrf.address_family.ipv6.unicast', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.vrf.address_family.ipv6.unicast', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.vrf.address_family.ipv6.unicast', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv6_unicast_export_delete(self, rbridge_id=None, vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v7_1_0.rbridge_id.vrf.address_family.ipv6.unicast.export', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'map_export, evpn_export'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv6_unicast_export_evpn_delete(self, rbridge_id=None, vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v7_1_0.rbridge_id.vrf.address_family.ipv6.unicast.export', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'evpn'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv6_unicast_export_map_delete(self, rbridge_id=None, vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v7_1_0.rbridge_id.vrf.address_family.ipv6.unicast.export', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv6_unicast_import_delete(self, rbridge_id=None, vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v7_1_0.rbridge_id.vrf.address_family.ipv6.unicast.import_', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'map_import, evpn_import'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv6_unicast_import_evpn_delete(self, rbridge_id=None, vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v7_1_0.rbridge_id.vrf.address_family.ipv6.unicast.import_', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'evpn'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv6_unicast_import_map_delete(self, rbridge_id=None, vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v7_1_0.rbridge_id.vrf.address_family.ipv6.unicast.import_', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv6_unicast_ipv6_delete(self, rbridge_id=None, vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.vrf.address_family.ipv6.unicast.ipv6', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.vrf.address_family.ipv6.unicast.ipv6', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.vrf.address_family.ipv6.unicast.ipv6', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv6_unicast_ipv6_import_delete(self, rbridge_id=None, vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.import_', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.import_', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.import_', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv6_unicast_ipv6_import_routes_delete(self, rbridge_id=None, vrf=None, routes=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type routes: src_vrf, route_map
    :param routes: Keyword argument tuple.

    :type src_vrf: unicode
    :param src_vrf: **routes** tuple argument:  ASCII string;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type route_map: unicode
    :param route_map: **routes** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.vrf', u'vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.import_.routes', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.import_.routes', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.import_.routes', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'routes', 'keyval': 'src_vrf, route_map', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf, routes=routes)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf, routes=routes)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv6_unicast_ipv6_route_ipv6_static_route_oif_vrf_delete(self, rbridge_id=None, vrf=None, ipv6_static_route_oif_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type ipv6_static_route_oif_vrf: static_route_next_vrf_dest, next_hop_vrf, static_route_oif_type, static_route_oif_name
    :param ipv6_static_route_oif_vrf: Keyword argument tuple.

    :type static_route_next_vrf_dest: unicode
    :param static_route_next_vrf_dest: **ipv6_static_route_oif_vrf** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type next_hop_vrf: unicode
    :param next_hop_vrf: **ipv6_static_route_oif_vrf** tuple argument:  Next Hop Vrf Name

    :type static_route_oif_type: unicode
    :param static_route_oif_type: **ipv6_static_route_oif_vrf** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            've']

    :type static_route_oif_name: unicode
    :param static_route_oif_name: **ipv6_static_route_oif_vrf** tuple argument.

        * length restriction: ::

            ['1..16']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.vrf', u'vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.ipv6_static_route_oif_vrf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.ipv6_static_route_oif_vrf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.ipv6_static_route_oif_vrf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_static_route_oif_vrf', 'keyval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf, ipv6_static_route_oif_vrf=ipv6_static_route_oif_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf, ipv6_static_route_oif_vrf=ipv6_static_route_oif_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv6_unicast_ipv6_route_link_local_static_route_nh_delete(self, rbridge_id=None, vrf=None, link_local_static_route_nh=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type link_local_static_route_nh: link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name
    :param link_local_static_route_nh: Keyword argument tuple.

    :type link_local_static_route_dest: unicode
    :param link_local_static_route_dest: **link_local_static_route_nh** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type link_local_nexthop: unicode
    :param link_local_nexthop: **link_local_static_route_nh** tuple argument:  A:B::C:D ;; Next hop IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type link_local_route_oif_type: unicode
    :param link_local_route_oif_type: **link_local_static_route_nh** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['management',
            've',
            'fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'null']

    :type link_local_route_oif_name: unicode
    :param link_local_route_oif_name: **link_local_static_route_nh** tuple argument.

        * length restriction: ::

            ['1..16']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.vrf', u'vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.link_local_static_route_nh', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.link_local_static_route_nh', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.link_local_static_route_nh', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'link_local_static_route_nh', 'keyval': 'link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf, link_local_static_route_nh=link_local_static_route_nh)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf, link_local_static_route_nh=link_local_static_route_nh)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv6_unicast_ipv6_route_link_local_static_route_nh_distance_delete(self, rbridge_id=None, vrf=None, link_local_static_route_nh=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type link_local_static_route_nh: link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name
    :param link_local_static_route_nh: Keyword argument tuple.

    :type link_local_static_route_dest: unicode
    :param link_local_static_route_dest: **link_local_static_route_nh** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type link_local_nexthop: unicode
    :param link_local_nexthop: **link_local_static_route_nh** tuple argument:  A:B::C:D ;; Next hop IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type link_local_route_oif_type: unicode
    :param link_local_route_oif_type: **link_local_static_route_nh** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['management',
            've',
            'fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'null']

    :type link_local_route_oif_name: unicode
    :param link_local_route_oif_name: **link_local_static_route_nh** tuple argument.

        * length restriction: ::

            ['1..16']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_0_1b.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.link_local_static_route_nh', u'link_local_static_route_nh'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_1_0.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.link_local_static_route_nh', u'link_local_static_route_nh'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.vrf', u'vrf'), ('pybind.nos.v6_0_2c.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.link_local_static_route_nh', u'link_local_static_route_nh')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.link_local_static_route_nh.route_attributes', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.link_local_static_route_nh.route_attributes', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.link_local_static_route_nh.route_attributes', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'distance'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf, link_local_static_route_nh=link_local_static_route_nh)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf, link_local_static_route_nh=link_local_static_route_nh)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv6_unicast_ipv6_route_link_local_static_route_nh_metric_delete(self, rbridge_id=None, vrf=None, link_local_static_route_nh=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type link_local_static_route_nh: link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name
    :param link_local_static_route_nh: Keyword argument tuple.

    :type link_local_static_route_dest: unicode
    :param link_local_static_route_dest: **link_local_static_route_nh** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type link_local_nexthop: unicode
    :param link_local_nexthop: **link_local_static_route_nh** tuple argument:  A:B::C:D ;; Next hop IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type link_local_route_oif_type: unicode
    :param link_local_route_oif_type: **link_local_static_route_nh** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['management',
            've',
            'fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'null']

    :type link_local_route_oif_name: unicode
    :param link_local_route_oif_name: **link_local_static_route_nh** tuple argument.

        * length restriction: ::

            ['1..16']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_0_1b.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.link_local_static_route_nh', u'link_local_static_route_nh'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_1_0.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.link_local_static_route_nh', u'link_local_static_route_nh'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.vrf', u'vrf'), ('pybind.nos.v6_0_2c.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.link_local_static_route_nh', u'link_local_static_route_nh')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.link_local_static_route_nh.route_attributes', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.link_local_static_route_nh.route_attributes', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.link_local_static_route_nh.route_attributes', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf, link_local_static_route_nh=link_local_static_route_nh)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf, link_local_static_route_nh=link_local_static_route_nh)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv6_unicast_ipv6_route_link_local_static_route_nh_tag_delete(self, rbridge_id=None, vrf=None, link_local_static_route_nh=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type link_local_static_route_nh: link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name
    :param link_local_static_route_nh: Keyword argument tuple.

    :type link_local_static_route_dest: unicode
    :param link_local_static_route_dest: **link_local_static_route_nh** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type link_local_nexthop: unicode
    :param link_local_nexthop: **link_local_static_route_nh** tuple argument:  A:B::C:D ;; Next hop IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type link_local_route_oif_type: unicode
    :param link_local_route_oif_type: **link_local_static_route_nh** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['management',
            've',
            'fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'null']

    :type link_local_route_oif_name: unicode
    :param link_local_route_oif_name: **link_local_static_route_nh** tuple argument.

        * length restriction: ::

            ['1..16']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_0_1b.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.link_local_static_route_nh', u'link_local_static_route_nh'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_1_0.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.link_local_static_route_nh', u'link_local_static_route_nh'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.vrf', u'vrf'), ('pybind.nos.v6_0_2c.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.link_local_static_route_nh', u'link_local_static_route_nh')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.link_local_static_route_nh.route_attributes', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.link_local_static_route_nh.route_attributes', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.link_local_static_route_nh.route_attributes', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf, link_local_static_route_nh=link_local_static_route_nh)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf, link_local_static_route_nh=link_local_static_route_nh)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv6_unicast_ipv6_route_link_local_static_route_nh_vrf_delete(self, rbridge_id=None, vrf=None, link_local_static_route_nh_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type link_local_static_route_nh_vrf: static_route_next_vrf_dest, next_hop_vrf, link_local_next_hop, link_local_route_oif_type, link_local_route_oif_name
    :param link_local_static_route_nh_vrf: Keyword argument tuple.

    :type static_route_next_vrf_dest: unicode
    :param static_route_next_vrf_dest: **link_local_static_route_nh_vrf** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type next_hop_vrf: unicode
    :param next_hop_vrf: **link_local_static_route_nh_vrf** tuple argument:  WORD 1-63;;Next Hop Vrf Name

    :type link_local_next_hop: unicode
    :param link_local_next_hop: **link_local_static_route_nh_vrf** tuple argument:  A:B::C:D ;; Next hop IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type link_local_route_oif_type: unicode
    :param link_local_route_oif_type: **link_local_static_route_nh_vrf** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['management',
            've',
            'fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'null']

    :type link_local_route_oif_name: unicode
    :param link_local_route_oif_name: **link_local_static_route_nh_vrf** tuple argument.

        * length restriction: ::

            ['1..16']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.link_local_static_route_nh_vrf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.link_local_static_route_nh_vrf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.link_local_static_route_nh_vrf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'link_local_static_route_nh_vrf', 'keyval': 'static_route_next_vrf_dest, next_hop_vrf, link_local_next_hop, link_local_route_oif_type, link_local_route_oif_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf, link_local_static_route_nh_vrf=link_local_static_route_nh_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf, link_local_static_route_nh_vrf=link_local_static_route_nh_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv6_unicast_ipv6_route_static_delete(self, rbridge_id=None, vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.vrf', u'vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv6_unicast_ipv6_route_static_bfd_delete(self, rbridge_id=None, vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.vrf', u'vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv6_unicast_ipv6_route_static_bfd_bfd_ipv6_link_local_static_route_delete(self, rbridge_id=None, vrf=None, bfd_ipv6_link_local_static_route=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type bfd_ipv6_link_local_static_route: bfd_ipv6_link_local_dest, bfd_ipv6_link_local_src, bfd_interface_type, bfd_interface_name
    :param bfd_ipv6_link_local_static_route: Keyword argument tuple.

    :type bfd_ipv6_link_local_dest: unicode
    :param bfd_ipv6_link_local_dest: **bfd_ipv6_link_local_static_route** tuple argument:  A:B::C:D ;; Destination IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type bfd_ipv6_link_local_src: unicode
    :param bfd_ipv6_link_local_src: **bfd_ipv6_link_local_static_route** tuple argument:  A:B::C:D ;; Source IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type bfd_interface_type: unicode
    :param bfd_interface_type: **bfd_ipv6_link_local_static_route** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ve',
            'fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'null']

    :type bfd_interface_name: unicode
    :param bfd_interface_name: **bfd_ipv6_link_local_static_route** tuple argument.

        * length restriction: ::

            ['1..16']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd.bfd_ipv6_link_local_static_route', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd.bfd_ipv6_link_local_static_route', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd.bfd_ipv6_link_local_static_route', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'bfd_ipv6_link_local_static_route', 'keyval': 'bfd_ipv6_link_local_dest, bfd_ipv6_link_local_src, bfd_interface_type, bfd_interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf, bfd_ipv6_link_local_static_route=bfd_ipv6_link_local_static_route)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf, bfd_ipv6_link_local_static_route=bfd_ipv6_link_local_static_route)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv6_unicast_ipv6_route_static_bfd_bfd_ipv6_static_route_delete(self, rbridge_id=None, vrf=None, bfd_ipv6_static_route=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type bfd_ipv6_static_route: bfd_ipv6_static_route_dest, bfd_ipv6_static_route_src
    :param bfd_ipv6_static_route: Keyword argument tuple.

    :type bfd_ipv6_static_route_dest: unicode
    :param bfd_ipv6_static_route_dest: **bfd_ipv6_static_route** tuple argument:  A:B::C:D ;; Destination IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type bfd_ipv6_static_route_src: unicode
    :param bfd_ipv6_static_route_src: **bfd_ipv6_static_route** tuple argument:  A:B::C:D ;; Source IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd.bfd_ipv6_static_route', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd.bfd_ipv6_static_route', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd.bfd_ipv6_static_route', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'bfd_ipv6_static_route', 'keyval': 'bfd_ipv6_static_route_dest, bfd_ipv6_static_route_src', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf, bfd_ipv6_static_route=bfd_ipv6_static_route)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf, bfd_ipv6_static_route=bfd_ipv6_static_route)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv6_unicast_ipv6_route_static_route_nh_delete(self, rbridge_id=None, vrf=None, static_route_nh=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type static_route_nh: static_route_dest, static_route_next_hop
    :param static_route_nh: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_nh** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type static_route_next_hop: unicode
    :param static_route_next_hop: **static_route_nh** tuple argument:  A:B::C:D ;; Next hop IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static_route_nh', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static_route_nh', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static_route_nh', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'static_route_nh', 'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf, static_route_nh=static_route_nh)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf, static_route_nh=static_route_nh)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv6_unicast_ipv6_route_static_route_nh_distance_delete(self, rbridge_id=None, vrf=None, static_route_nh=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type static_route_nh: static_route_dest, static_route_next_hop
    :param static_route_nh: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_nh** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type static_route_next_hop: unicode
    :param static_route_next_hop: **static_route_nh** tuple argument:  A:B::C:D ;; Next hop IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_0_1b.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static_route_nh', u'static_route_nh'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_1_0.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static_route_nh', u'static_route_nh'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.vrf', u'vrf'), ('pybind.nos.v6_0_2c.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static_route_nh', u'static_route_nh')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static_route_nh.route_attributes', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static_route_nh.route_attributes', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static_route_nh.route_attributes', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'distance'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf, static_route_nh=static_route_nh)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf, static_route_nh=static_route_nh)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv6_unicast_ipv6_route_static_route_nh_metric_delete(self, rbridge_id=None, vrf=None, static_route_nh=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type static_route_nh: static_route_dest, static_route_next_hop
    :param static_route_nh: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_nh** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type static_route_next_hop: unicode
    :param static_route_next_hop: **static_route_nh** tuple argument:  A:B::C:D ;; Next hop IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_0_1b.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static_route_nh', u'static_route_nh'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_1_0.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static_route_nh', u'static_route_nh'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.vrf', u'vrf'), ('pybind.nos.v6_0_2c.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static_route_nh', u'static_route_nh')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static_route_nh.route_attributes', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static_route_nh.route_attributes', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static_route_nh.route_attributes', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf, static_route_nh=static_route_nh)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf, static_route_nh=static_route_nh)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv6_unicast_ipv6_route_static_route_nh_tag_delete(self, rbridge_id=None, vrf=None, static_route_nh=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type static_route_nh: static_route_dest, static_route_next_hop
    :param static_route_nh: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_nh** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type static_route_next_hop: unicode
    :param static_route_next_hop: **static_route_nh** tuple argument:  A:B::C:D ;; Next hop IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_0_1b.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static_route_nh', u'static_route_nh'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_1_0.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static_route_nh', u'static_route_nh'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.vrf', u'vrf'), ('pybind.nos.v6_0_2c.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static_route_nh', u'static_route_nh')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static_route_nh.route_attributes', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static_route_nh.route_attributes', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static_route_nh.route_attributes', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf, static_route_nh=static_route_nh)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf, static_route_nh=static_route_nh)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv6_unicast_ipv6_route_static_route_nh_vrf_delete(self, rbridge_id=None, vrf=None, static_route_nh_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type static_route_nh_vrf: static_route_next_vrf_dest, next_hop_vrf, static_route_next_hop
    :param static_route_nh_vrf: Keyword argument tuple.

    :type static_route_next_vrf_dest: unicode
    :param static_route_next_vrf_dest: **static_route_nh_vrf** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type next_hop_vrf: unicode
    :param next_hop_vrf: **static_route_nh_vrf** tuple argument:  Next Hop Vrf Name

    :type static_route_next_hop: unicode
    :param static_route_next_hop: **static_route_nh_vrf** tuple argument:  A:B::C:D ;; Next hop IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static_route_nh_vrf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static_route_nh_vrf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static_route_nh_vrf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'static_route_nh_vrf', 'keyval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_next_hop', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf, static_route_nh_vrf=static_route_nh_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf, static_route_nh_vrf=static_route_nh_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv6_unicast_ipv6_route_static_route_oif_delete(self, rbridge_id=None, vrf=None, static_route_oif=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type static_route_oif: static_route_dest, static_route_oif_type, static_route_oif_name
    :param static_route_oif: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_oif** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type static_route_oif_type: unicode
    :param static_route_oif_type: **static_route_oif** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ve',
            'fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'null']

    :type static_route_oif_name: unicode
    :param static_route_oif_name: **static_route_oif** tuple argument.

        * length restriction: ::

            ['1..16']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.vrf', u'vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static_route_oif', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static_route_oif', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static_route_oif', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'static_route_oif', 'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf, static_route_oif=static_route_oif)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf, static_route_oif=static_route_oif)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv6_unicast_ipv6_route_static_route_oif_distance_delete(self, rbridge_id=None, vrf=None, static_route_oif=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type static_route_oif: static_route_dest, static_route_oif_type, static_route_oif_name
    :param static_route_oif: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_oif** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type static_route_oif_type: unicode
    :param static_route_oif_type: **static_route_oif** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ve',
            'fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'null']

    :type static_route_oif_name: unicode
    :param static_route_oif_name: **static_route_oif** tuple argument.

        * length restriction: ::

            ['1..16']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_1_0.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static_route_oif', u'static_route_oif'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_0_1b.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static_route_oif', u'static_route_oif'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.vrf', u'vrf'), ('pybind.nos.v6_0_2c.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static_route_oif', u'static_route_oif')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static_route_oif.route_attributes', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static_route_oif.route_attributes', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static_route_oif.route_attributes', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'distance'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf, static_route_oif=static_route_oif)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf, static_route_oif=static_route_oif)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv6_unicast_ipv6_route_static_route_oif_metric_delete(self, rbridge_id=None, vrf=None, static_route_oif=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type static_route_oif: static_route_dest, static_route_oif_type, static_route_oif_name
    :param static_route_oif: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_oif** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type static_route_oif_type: unicode
    :param static_route_oif_type: **static_route_oif** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ve',
            'fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'null']

    :type static_route_oif_name: unicode
    :param static_route_oif_name: **static_route_oif** tuple argument.

        * length restriction: ::

            ['1..16']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_1_0.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static_route_oif', u'static_route_oif'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_0_1b.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static_route_oif', u'static_route_oif'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.vrf', u'vrf'), ('pybind.nos.v6_0_2c.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static_route_oif', u'static_route_oif')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static_route_oif.route_attributes', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static_route_oif.route_attributes', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static_route_oif.route_attributes', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf, static_route_oif=static_route_oif)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf, static_route_oif=static_route_oif)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv6_unicast_ipv6_route_static_route_oif_tag_delete(self, rbridge_id=None, vrf=None, static_route_oif=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type static_route_oif: static_route_dest, static_route_oif_type, static_route_oif_name
    :param static_route_oif: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_oif** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type static_route_oif_type: unicode
    :param static_route_oif_type: **static_route_oif** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ve',
            'fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'null']

    :type static_route_oif_name: unicode
    :param static_route_oif_name: **static_route_oif** tuple argument.

        * length restriction: ::

            ['1..16']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_1_0.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static_route_oif', u'static_route_oif'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_0_1b.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static_route_oif', u'static_route_oif'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.vrf', u'vrf'), ('pybind.nos.v6_0_2c.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static_route_oif', u'static_route_oif')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static_route_oif.route_attributes', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static_route_oif.route_attributes', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static_route_oif.route_attributes', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf, static_route_oif=static_route_oif)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf, static_route_oif=static_route_oif)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv6_unicast_max_route_delete(self, rbridge_id=None, vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.vrf.address_family.ipv6.unicast', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.vrf.address_family.ipv6.unicast', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.vrf.address_family.ipv6.unicast', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'max-route'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv6_unicast_route_target_evpn_delete(self, rbridge_id=None, vrf=None, route_target=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type route_target: action, target_community
    :param route_target: Keyword argument tuple.

    :type action: unicode
    :param action: **route_target** tuple argument.

        * enumeration restriction: ::

            ['import', 'export', 'both']

    :type target_community: unicode
    :param target_community: **route_target** tuple argument:  ASN:nn;; Target VPN Extended Community

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.vrf.address_family.ipv6.unicast.route_target', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.vrf.address_family.ipv6.unicast.route_target', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'route_target', 'keyval': 'action, target_community', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'evpn'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf, route_target=route_target)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf, route_target=route_target)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_vrf_ip_delete(self, rbridge_id=None, vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.vrf', u'vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.vrf.ip', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.vrf.ip', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.vrf.ip', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_vrf_ip_router_id_delete(self, rbridge_id=None, vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.vrf', u'vrf'), ('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.vrf.ip', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.vrf.ip', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.vrf.ip', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'router-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_vrf_rd_delete(self, rbridge_id=None, vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.vrf', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.vrf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.vrf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrf', 'keyval': 'vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rd'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_vrf_route_target_delete(self, rbridge_id=None, vrf=None, route_target=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type route_target: action, target_community
    :param route_target: Keyword argument tuple.

    :type action: unicode
    :param action: **route_target** tuple argument.

        * enumeration restriction: ::

            ['import', 'export', 'both']

    :type target_community: unicode
    :param target_community: **route_target** tuple argument:  ASN:nn;; Target VPN Extended Community

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2c.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.vrf.route_target', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.vrf.route_target', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.vrf.route_target', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'route_target', 'keyval': 'action, target_community', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf, route_target=route_target)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf, route_target=route_target)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_vrf_vni_delete(self, rbridge_id=None, vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_0_1b.rbridge_id.vrf', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.vrf', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrf', 'keyval': 'vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vni'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_vrrp_acceptmode_disable_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.vrrp_rbridge_global', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.vrrp_rbridge_global', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.vrrp_rbridge_global', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vrrp-acceptmode-disable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rbridge_id_vrrp_early_startup_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_1_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_0_1b.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2c.rbridge_id.vrrp', 'pybind.nos.v6_0_2c.brocade_rbridge', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rbridge_id.vrrp', 'pybind.nos.v7_0_1b.brocade_rbridge', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rbridge_id.vrrp', 'pybind.nos.v7_1_0.brocade_rbridge', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'early-startup'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def reserved_vlan_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.reserved_vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.reserved_vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.reserved_vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'reserved_vlan_start, reserved_vlan_end'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def reserved_vlan_reserved_vlan_end_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.reserved_vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.reserved_vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.reserved_vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'reserved-vlan-end'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def reserved_vlan_reserved_vlan_start_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.reserved_vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.reserved_vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.reserved_vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'reserved-vlan-start'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rmon_alarm_delete(self, alarm_entry=None, snmp_oid=None, alarm_interval=None, alarm_sample=None, alarm_rising_threshold=None, alarm_rising_event_index=None, alarm_falling_threshold=None, alarm_falling_event_index=None, alarm_owner=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type alarm_entry: alarm_index, snmp_oid, alarm_interval, alarm_sample, alarm_rising_threshold, alarm_rising_event_index, alarm_falling_threshold, alarm_falling_event_index, alarm_owner
    :param alarm_entry: Keyword argument tuple.

    :type alarm_index: long
    :param alarm_index: **alarm_entry** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type snmp_oid: unicode
    :param snmp_oid: **alarm_entry** tuple argument.

        * length restriction: ::

            ['min .. 35']

    :type alarm_interval: long
    :param alarm_interval: **alarm_entry** tuple argument:  Alarm sample interval

        * range restriction: ::

            ['0..4294967295']

    :type alarm_sample: unicode
    :param alarm_sample: **alarm_entry** tuple argument.

        * enumeration restriction: ::

            ['absolute', 'delta']

    :type alarm_rising_threshold: long
    :param alarm_rising_threshold: **alarm_entry** tuple argument:  Alarm rising threshold

        * range restriction: ::

            ['0..4294967295']

    :type alarm_rising_event_index: long
    :param alarm_rising_event_index: **alarm_entry** tuple argument:  Event for rising alarm

        * range restriction: ::

            ['-2147483648..2147483647']

    :type alarm_falling_threshold: long
    :param alarm_falling_threshold: **alarm_entry** tuple argument:  Alarm falling threshold

        * range restriction: ::

            ['0..4294967295']

    :type alarm_falling_event_index: long
    :param alarm_falling_event_index: **alarm_entry** tuple argument:  Event for falling alarm

        * range restriction: ::

            ['-2147483648..2147483647']

    :type alarm_owner: unicode
    :param alarm_owner: **alarm_entry** tuple argument:  Owner identity

        * length restriction: ::

            ['1 .. 15']

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,14})'

    **Instance Argument(s)**:

    :type snmp_oid: unicode
    :param snmp_oid: Keyword argument.

        * length restriction: ::

            ['min .. 35']

    :type alarm_interval: long
    :param alarm_interval: Alarm sample interval

        * range restriction: ::

            ['0..4294967295']

    :type alarm_sample: unicode
    :param alarm_sample: Keyword argument.

        * enumeration restriction: ::

            ['absolute', 'delta']

    :type alarm_rising_threshold: long
    :param alarm_rising_threshold: Alarm rising threshold

        * range restriction: ::

            ['0..4294967295']

    :type alarm_rising_event_index: long
    :param alarm_rising_event_index: Event for rising alarm

        * range restriction: ::

            ['-2147483648..2147483647']

    :type alarm_falling_threshold: long
    :param alarm_falling_threshold: Alarm falling threshold

        * range restriction: ::

            ['0..4294967295']

    :type alarm_falling_event_index: long
    :param alarm_falling_event_index: Event for falling alarm

        * range restriction: ::

            ['-2147483648..2147483647']

    :type alarm_owner: unicode
    :param alarm_owner: Owner identity

        * length restriction: ::

            ['1 .. 15']

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,14})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.rmon.alarm_entry', 'pybind.nos.v6_0_2c.brocade_rmon', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rmon.alarm_entry', 'pybind.nos.v7_0_1b.brocade_rmon', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rmon.alarm_entry', 'pybind.nos.v7_1_0.brocade_rmon', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rmon.alarm_entry', 'pybind.slxos.v16r_1_00b.brocade_rmon', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'alarm_entry', 'keyval': 'alarm_index', 'extra_keyval': 'alarm_index, snmp_oid, alarm_interval, alarm_sample, alarm_rising_threshold, alarm_rising_event_index, alarm_falling_threshold, alarm_falling_event_index, alarm_owner'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, alarm_entry=alarm_entry, snmp_oid=snmp_oid, alarm_interval=alarm_interval, alarm_sample=alarm_sample, alarm_rising_threshold=alarm_rising_threshold, alarm_rising_event_index=alarm_rising_event_index, alarm_falling_threshold=alarm_falling_threshold, alarm_falling_event_index=alarm_falling_event_index, alarm_owner=alarm_owner)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, alarm_entry=alarm_entry, snmp_oid=snmp_oid, alarm_interval=alarm_interval, alarm_sample=alarm_sample, alarm_rising_threshold=alarm_rising_threshold, alarm_rising_event_index=alarm_rising_event_index, alarm_falling_threshold=alarm_falling_threshold, alarm_falling_event_index=alarm_falling_event_index, alarm_owner=alarm_owner)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rmon_alarm_event_delete(self, alarm_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type alarm_entry: alarm_index
    :param alarm_entry: Keyword argument tuple.

    :type alarm_index: long
    :param alarm_index: **alarm_entry** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.rmon.alarm_entry', 'pybind.nos.v6_0_2c.brocade_rmon', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rmon.alarm_entry', 'pybind.nos.v7_0_1b.brocade_rmon', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rmon.alarm_entry', 'pybind.nos.v7_1_0.brocade_rmon', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rmon.alarm_entry', 'pybind.slxos.v16r_1_00b.brocade_rmon', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'alarm_entry', 'keyval': 'alarm_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'event'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, alarm_entry=alarm_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, alarm_entry=alarm_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rmon_alarm_falling_threshold_delete(self, alarm_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type alarm_entry: alarm_index
    :param alarm_entry: Keyword argument tuple.

    :type alarm_index: long
    :param alarm_index: **alarm_entry** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.rmon.alarm_entry', 'pybind.nos.v6_0_2c.brocade_rmon', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rmon.alarm_entry', 'pybind.nos.v7_0_1b.brocade_rmon', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rmon.alarm_entry', 'pybind.nos.v7_1_0.brocade_rmon', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rmon.alarm_entry', 'pybind.slxos.v16r_1_00b.brocade_rmon', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'alarm_entry', 'keyval': 'alarm_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'falling-threshold'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, alarm_entry=alarm_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, alarm_entry=alarm_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rmon_alarm_interval_delete(self, alarm_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type alarm_entry: alarm_index
    :param alarm_entry: Keyword argument tuple.

    :type alarm_index: long
    :param alarm_index: **alarm_entry** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.rmon.alarm_entry', 'pybind.nos.v6_0_2c.brocade_rmon', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rmon.alarm_entry', 'pybind.nos.v7_0_1b.brocade_rmon', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rmon.alarm_entry', 'pybind.nos.v7_1_0.brocade_rmon', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rmon.alarm_entry', 'pybind.slxos.v16r_1_00b.brocade_rmon', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'alarm_entry', 'keyval': 'alarm_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, alarm_entry=alarm_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, alarm_entry=alarm_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rmon_alarm_owner_delete(self, alarm_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type alarm_entry: alarm_index
    :param alarm_entry: Keyword argument tuple.

    :type alarm_index: long
    :param alarm_index: **alarm_entry** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.rmon.alarm_entry', 'pybind.nos.v6_0_2c.brocade_rmon', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rmon.alarm_entry', 'pybind.nos.v7_0_1b.brocade_rmon', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rmon.alarm_entry', 'pybind.nos.v7_1_0.brocade_rmon', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rmon.alarm_entry', 'pybind.slxos.v16r_1_00b.brocade_rmon', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'alarm_entry', 'keyval': 'alarm_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'owner'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, alarm_entry=alarm_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, alarm_entry=alarm_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rmon_alarm_rising_threshold_delete(self, alarm_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type alarm_entry: alarm_index
    :param alarm_entry: Keyword argument tuple.

    :type alarm_index: long
    :param alarm_index: **alarm_entry** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.rmon.alarm_entry', 'pybind.nos.v6_0_2c.brocade_rmon', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rmon.alarm_entry', 'pybind.nos.v7_0_1b.brocade_rmon', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rmon.alarm_entry', 'pybind.nos.v7_1_0.brocade_rmon', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rmon.alarm_entry', 'pybind.slxos.v16r_1_00b.brocade_rmon', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'alarm_entry', 'keyval': 'alarm_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rising-threshold'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, alarm_entry=alarm_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, alarm_entry=alarm_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rmon_alarm_snmp_oid_delete(self, alarm_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type alarm_entry: alarm_index
    :param alarm_entry: Keyword argument tuple.

    :type alarm_index: long
    :param alarm_index: **alarm_entry** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.rmon.alarm_entry', 'pybind.nos.v6_0_2c.brocade_rmon', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rmon.alarm_entry', 'pybind.nos.v7_0_1b.brocade_rmon', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rmon.alarm_entry', 'pybind.nos.v7_1_0.brocade_rmon', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rmon.alarm_entry', 'pybind.slxos.v16r_1_00b.brocade_rmon', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'alarm_entry', 'keyval': 'alarm_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'snmp-oid'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, alarm_entry=alarm_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, alarm_entry=alarm_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rmon_alarm_type_delete(self, alarm_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type alarm_entry: alarm_index
    :param alarm_entry: Keyword argument tuple.

    :type alarm_index: long
    :param alarm_index: **alarm_entry** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.rmon.alarm_entry', 'pybind.nos.v6_0_2c.brocade_rmon', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rmon.alarm_entry', 'pybind.nos.v7_0_1b.brocade_rmon', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rmon.alarm_entry', 'pybind.nos.v7_1_0.brocade_rmon', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rmon.alarm_entry', 'pybind.slxos.v16r_1_00b.brocade_rmon', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'alarm_entry', 'keyval': 'alarm_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, alarm_entry=alarm_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, alarm_entry=alarm_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rmon_event_delete(self, event_entry=None, event_description=None, log=None, event_community=None, event_owner=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type event_entry: event_index, event_description, log, event_community, event_owner
    :param event_entry: Keyword argument tuple.

    :type event_index: long
    :param event_index: **event_entry** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type event_description: unicode
    :param event_description: **event_entry** tuple argument:  Event description

        * length restriction: ::

            ['min .. 127']

    :type log: YANGBool
    :param log: **event_entry** tuple argument:  Log the event

    :type event_community: unicode
    :param event_community: **event_entry** tuple argument:  Send trap for the event

        * length restriction: ::

            ['1 .. 127']

    :type event_owner: unicode
    :param event_owner: **event_entry** tuple argument:  Owner identity

        * length restriction: ::

            ['1 .. 15']

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,14})'

    **Instance Argument(s)**:

    :type event_description: unicode
    :param event_description: Event description

        * length restriction: ::

            ['min .. 127']

    :type log: YANGBool
    :param log: Log the event

    :type event_community: unicode
    :param event_community: Send trap for the event

        * length restriction: ::

            ['1 .. 127']

    :type event_owner: unicode
    :param event_owner: Owner identity

        * length restriction: ::

            ['1 .. 15']

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,14})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.rmon.event_entry', 'pybind.nos.v6_0_2c.brocade_rmon', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rmon.event_entry', 'pybind.nos.v7_0_1b.brocade_rmon', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rmon.event_entry', 'pybind.nos.v7_1_0.brocade_rmon', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rmon.event_entry', 'pybind.slxos.v16r_1_00b.brocade_rmon', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'event_entry', 'keyval': 'event_index', 'extra_keyval': 'event_index, event_description, log, event_community, event_owner'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, event_entry=event_entry, event_description=event_description, log=log, event_community=event_community, event_owner=event_owner)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, event_entry=event_entry, event_description=event_description, log=log, event_community=event_community, event_owner=event_owner)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rmon_event_description_delete(self, event_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type event_entry: event_index
    :param event_entry: Keyword argument tuple.

    :type event_index: long
    :param event_index: **event_entry** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.rmon.event_entry', 'pybind.nos.v6_0_2c.brocade_rmon', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rmon.event_entry', 'pybind.nos.v7_0_1b.brocade_rmon', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rmon.event_entry', 'pybind.nos.v7_1_0.brocade_rmon', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rmon.event_entry', 'pybind.slxos.v16r_1_00b.brocade_rmon', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'event_entry', 'keyval': 'event_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'description'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, event_entry=event_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, event_entry=event_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rmon_event_log_delete(self, event_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type event_entry: event_index
    :param event_entry: Keyword argument tuple.

    :type event_index: long
    :param event_index: **event_entry** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.rmon.event_entry', 'pybind.nos.v6_0_2c.brocade_rmon', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rmon.event_entry', 'pybind.nos.v7_0_1b.brocade_rmon', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rmon.event_entry', 'pybind.nos.v7_1_0.brocade_rmon', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rmon.event_entry', 'pybind.slxos.v16r_1_00b.brocade_rmon', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'event_entry', 'keyval': 'event_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'log'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, event_entry=event_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, event_entry=event_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rmon_event_owner_delete(self, event_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type event_entry: event_index
    :param event_entry: Keyword argument tuple.

    :type event_index: long
    :param event_index: **event_entry** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.rmon.event_entry', 'pybind.nos.v6_0_2c.brocade_rmon', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rmon.event_entry', 'pybind.nos.v7_0_1b.brocade_rmon', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rmon.event_entry', 'pybind.nos.v7_1_0.brocade_rmon', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rmon.event_entry', 'pybind.slxos.v16r_1_00b.brocade_rmon', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'event_entry', 'keyval': 'event_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'owner'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, event_entry=event_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, event_entry=event_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rmon_event_trap_delete(self, event_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type event_entry: event_index
    :param event_entry: Keyword argument tuple.

    :type event_index: long
    :param event_index: **event_entry** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.rmon.event_entry', 'pybind.nos.v6_0_2c.brocade_rmon', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rmon.event_entry', 'pybind.nos.v7_0_1b.brocade_rmon', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rmon.event_entry', 'pybind.nos.v7_1_0.brocade_rmon', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rmon.event_entry', 'pybind.slxos.v16r_1_00b.brocade_rmon', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'event_entry', 'keyval': 'event_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'trap'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, event_entry=event_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, event_entry=event_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def role_name_delete(self, name=None, desc=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type name: name, desc
    :param name: Keyword argument tuple.

    :type name: unicode
    :param name: **name** tuple argument.

        * length restriction: ::

            ['4 .. 32']

    :type desc: unicode
    :param desc: **name** tuple argument:  Description of the role (default='')

        * length restriction: ::

            ['0 .. 64']

    **Instance Argument(s)**:

    :type desc: unicode
    :param desc: Description of the role (default='')

        * length restriction: ::

            ['0 .. 64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.role.name', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.role.name', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.role.name', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.role.name', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'name', 'keyval': 'name', 'extra_keyval': 'name, desc'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, name=name, desc=desc)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, name=name, desc=desc)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def role_name_desc_delete(self, name=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type name: name
    :param name: Keyword argument tuple.

    :type name: unicode
    :param name: **name** tuple argument.

        * length restriction: ::

            ['4 .. 32']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.role.name', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.role.name', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.role.name', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.role.name', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'name', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'desc'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, name=name)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, name=name)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def root_access_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.root_sa.root', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.root_sa.root', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.root_sa.root', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.root_sa.root', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'access'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def root_enable_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.root_sa.root', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.root_sa.root', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.root_sa.root', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.root_sa.root', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def root_sa_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.root_sa', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.root_sa', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.root_sa', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.root_sa', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def route_map_delete(self, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map', 'pybind.nos.v6_0_2c.brocade_ip_policy', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map', 'pybind.nos.v7_0_1b.brocade_ip_policy', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map', 'pybind.nos.v7_1_0.brocade_ip_policy', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.route_map', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'route_map', 'keyval': 'name, action_rm, instance', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def route_map_continue_delete(self, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v16r_1_00b.routing_system.route_map', u'route_map'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map.content.continue_holder', 'pybind.nos.v6_0_2c.brocade_ip_policy', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map.content.continue_holder', 'pybind.nos.v7_0_1b.brocade_ip_policy', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map.content.continue_holder', 'pybind.nos.v7_1_0.brocade_ip_policy', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.route_map.content.continue_holder', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'continue'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def route_map_continue_holder_delete(self, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v16r_1_00b.routing_system.route_map', u'route_map'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map.content.continue_holder', 'pybind.nos.v6_0_2c.brocade_ip_policy', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map.content.continue_holder', 'pybind.nos.v7_0_1b.brocade_ip_policy', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map.content.continue_holder', 'pybind.nos.v7_1_0.brocade_ip_policy', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.route_map.content.continue_holder', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'continue_, continue_val'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def route_map_continue_val_delete(self, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v16r_1_00b.routing_system.route_map', u'route_map'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map.content.continue_holder', 'pybind.nos.v6_0_2c.brocade_ip_policy', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map.content.continue_holder', 'pybind.nos.v7_0_1b.brocade_ip_policy', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map.content.continue_holder', 'pybind.nos.v7_1_0.brocade_ip_policy', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.route_map.content.continue_holder', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'continue-val'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def route_map_match_as_path_delete(self, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v16r_1_00b.routing_system.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map.content.match.as_path', 'pybind.nos.v6_0_2c.brocade_ip_policy', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map.content.match.as_path', 'pybind.nos.v7_0_1b.brocade_ip_policy', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map.content.match.as_path', 'pybind.nos.v7_1_0.brocade_ip_policy', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.route_map.content.match.as_path', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def route_map_match_as_path_as_path_access_list_name_delete(self, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v16r_1_00b.routing_system.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map.content.match.as_path', 'pybind.nos.v6_0_2c.brocade_ip_policy', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map.content.match.as_path', 'pybind.nos.v7_0_1b.brocade_ip_policy', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map.content.match.as_path', 'pybind.nos.v7_1_0.brocade_ip_policy', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.route_map.content.match.as_path', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'as-path-access-list-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def route_map_match_community_delete(self, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.route_map', u'route_map'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v6_0_2c.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map.content.match.community', 'pybind.nos.v6_0_2c.brocade_ip_policy', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map.content.match.community', 'pybind.nos.v7_0_1b.brocade_ip_policy', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map.content.match.community', 'pybind.nos.v7_1_0.brocade_ip_policy', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.route_map.content.match.community', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'community_access_list_name'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def route_map_match_community_community_access_list_name_delete(self, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.route_map', u'route_map'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v6_0_2c.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map.content.match.community', 'pybind.nos.v6_0_2c.brocade_ip_policy', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map.content.match.community', 'pybind.nos.v7_0_1b.brocade_ip_policy', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map.content.match.community', 'pybind.nos.v7_1_0.brocade_ip_policy', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.route_map.content.match.community', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'community-access-list-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def route_map_match_extcommunity_delete(self, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v16r_1_00b.routing_system.route_map', u'route_map'), ('pybind.nos.v6_0_2c.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map.content.match.extcommunity', 'pybind.nos.v6_0_2c.brocade_ip_policy', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map.content.match.extcommunity', 'pybind.nos.v7_0_1b.brocade_ip_policy', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map.content.match.extcommunity', 'pybind.nos.v7_1_0.brocade_ip_policy', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.route_map.content.match.extcommunity', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v16r_1_00b.routing_system.route_map.content.match.extcommunity": {}, "pybind.nos.v7_0_1b.hide_routemap_holder.route_map.content.match.extcommunity": {"extcommunity_num": "extcommunity_num"}, "pybind.nos.v6_0_2c.hide_routemap_holder.route_map.content.match.extcommunity": {"extcommunity_num": "extcommunity_num"}, "pybind.nos.v7_1_0.hide_routemap_holder.route_map.content.match.extcommunity": {"extcommunity_num": "extcommunity_num"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def route_map_match_extcommunity_extcommunity_name_delete(self, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.route_map', u'route_map')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.route_map.content.match.extcommunity', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'extcommunity-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def route_map_match_extcommunity_extcommunity_num_delete(self, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v6_0_2c.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map.content.match.extcommunity', 'pybind.nos.v6_0_2c.brocade_ip_policy', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map.content.match.extcommunity', 'pybind.nos.v7_0_1b.brocade_ip_policy', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map.content.match.extcommunity', 'pybind.nos.v7_1_0.brocade_ip_policy', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'extcommunity-num'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def route_map_match_interface_delete(self, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v6_0_2c.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v16r_1_00b.routing_system.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map.content.match.interface', 'pybind.nos.v6_0_2c.brocade_ip_policy', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map.content.match.interface', 'pybind.nos.v7_0_1b.brocade_ip_policy', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map.content.match.interface', 'pybind.nos.v7_1_0.brocade_ip_policy', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.route_map.content.match.interface', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def route_map_match_ip_address_delete(self, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v6_0_2c.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v16r_1_00b.routing_system.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map.content.match.ip.address', 'pybind.nos.v6_0_2c.brocade_ip_policy', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map.content.match.ip.address', 'pybind.nos.v7_0_1b.brocade_ip_policy', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map.content.match.ip.address', 'pybind.nos.v7_1_0.brocade_ip_policy', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.route_map.content.match.ip.address', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def route_map_match_ip_address_acl_delete(self, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v6_0_2c.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v16r_1_00b.routing_system.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map.content.match.ip.address', 'pybind.nos.v6_0_2c.brocade_ip_policy', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map.content.match.ip.address', 'pybind.nos.v7_0_1b.brocade_ip_policy', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map.content.match.ip.address', 'pybind.nos.v7_1_0.brocade_ip_policy', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.route_map.content.match.ip.address', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'acl'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def route_map_match_ip_address_prefix_list_delete(self, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v6_0_2c.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v16r_1_00b.routing_system.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map.content.match.ip.address', 'pybind.nos.v6_0_2c.brocade_ip_policy', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map.content.match.ip.address', 'pybind.nos.v7_0_1b.brocade_ip_policy', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map.content.match.ip.address', 'pybind.nos.v7_1_0.brocade_ip_policy', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.route_map.content.match.ip.address', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'prefix-list'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def route_map_match_ip_next_hop_delete(self, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.route_map', u'route_map'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v6_0_2c.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map.content.match.ip.next_hop', 'pybind.nos.v6_0_2c.brocade_ip_policy', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map.content.match.ip.next_hop', 'pybind.nos.v7_0_1b.brocade_ip_policy', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map.content.match.ip.next_hop', 'pybind.nos.v7_1_0.brocade_ip_policy', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.route_map.content.match.ip.next_hop', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def route_map_match_ip_next_hop_prefix_list_delete(self, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.route_map', u'route_map'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v6_0_2c.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map.content.match.ip.next_hop', 'pybind.nos.v6_0_2c.brocade_ip_policy', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map.content.match.ip.next_hop', 'pybind.nos.v7_0_1b.brocade_ip_policy', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map.content.match.ip.next_hop', 'pybind.nos.v7_1_0.brocade_ip_policy', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.route_map.content.match.ip.next_hop', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'prefix-list'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def route_map_match_ip_route_source_delete(self, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v6_0_2c.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v16r_1_00b.routing_system.route_map', u'route_map'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map.content.match.ip.route_source', 'pybind.nos.v6_0_2c.brocade_ip_policy', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map.content.match.ip.route_source', 'pybind.nos.v7_0_1b.brocade_ip_policy', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map.content.match.ip.route_source', 'pybind.nos.v7_1_0.brocade_ip_policy', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.route_map.content.match.ip.route_source', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def route_map_match_ip_route_source_prefix_list_delete(self, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v6_0_2c.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v16r_1_00b.routing_system.route_map', u'route_map'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map.content.match.ip.route_source', 'pybind.nos.v6_0_2c.brocade_ip_policy', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map.content.match.ip.route_source', 'pybind.nos.v7_0_1b.brocade_ip_policy', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map.content.match.ip.route_source', 'pybind.nos.v7_1_0.brocade_ip_policy', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.route_map.content.match.ip.route_source', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'prefix-list'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def route_map_match_ipv6_address_delete(self, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v16r_1_00b.routing_system.route_map', u'route_map'), ('pybind.nos.v6_0_2c.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map.content.match.ipv6.address', 'pybind.nos.v6_0_2c.brocade_ip_policy', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map.content.match.ipv6.address', 'pybind.nos.v7_0_1b.brocade_ip_policy', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map.content.match.ipv6.address', 'pybind.nos.v7_1_0.brocade_ip_policy', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.route_map.content.match.ipv6.address', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def route_map_match_ipv6_address_acl_delete(self, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v16r_1_00b.routing_system.route_map', u'route_map'), ('pybind.nos.v6_0_2c.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map.content.match.ipv6.address', 'pybind.nos.v6_0_2c.brocade_ip_policy', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map.content.match.ipv6.address', 'pybind.nos.v7_0_1b.brocade_ip_policy', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map.content.match.ipv6.address', 'pybind.nos.v7_1_0.brocade_ip_policy', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.route_map.content.match.ipv6.address', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'acl'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def route_map_match_ipv6_address_prefix_list_delete(self, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v16r_1_00b.routing_system.route_map', u'route_map'), ('pybind.nos.v6_0_2c.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map.content.match.ipv6.address', 'pybind.nos.v6_0_2c.brocade_ip_policy', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map.content.match.ipv6.address', 'pybind.nos.v7_0_1b.brocade_ip_policy', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map.content.match.ipv6.address', 'pybind.nos.v7_1_0.brocade_ip_policy', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.route_map.content.match.ipv6.address', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'prefix-list'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def route_map_match_ipv6_next_hop_delete(self, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v6_0_2c.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v16r_1_00b.routing_system.route_map', u'route_map'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map.content.match.ipv6.next_hop', 'pybind.nos.v6_0_2c.brocade_ip_policy', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map.content.match.ipv6.next_hop', 'pybind.nos.v7_0_1b.brocade_ip_policy', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map.content.match.ipv6.next_hop', 'pybind.nos.v7_1_0.brocade_ip_policy', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.route_map.content.match.ipv6.next_hop', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def route_map_match_ipv6_next_hop_prefix_list_delete(self, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v6_0_2c.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v16r_1_00b.routing_system.route_map', u'route_map'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map.content.match.ipv6.next_hop', 'pybind.nos.v6_0_2c.brocade_ip_policy', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map.content.match.ipv6.next_hop', 'pybind.nos.v7_0_1b.brocade_ip_policy', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map.content.match.ipv6.next_hop', 'pybind.nos.v7_1_0.brocade_ip_policy', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.route_map.content.match.ipv6.next_hop', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'prefix-list'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def route_map_match_ipv6_route_source_delete(self, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.route_map', u'route_map'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v6_0_2c.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map.content.match.ipv6.route_source', 'pybind.nos.v6_0_2c.brocade_ip_policy', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map.content.match.ipv6.route_source', 'pybind.nos.v7_0_1b.brocade_ip_policy', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map.content.match.ipv6.route_source', 'pybind.nos.v7_1_0.brocade_ip_policy', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.route_map.content.match.ipv6.route_source', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def route_map_match_ipv6_route_source_prefix_list_delete(self, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.route_map', u'route_map'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v6_0_2c.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map.content.match.ipv6.route_source', 'pybind.nos.v6_0_2c.brocade_ip_policy', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map.content.match.ipv6.route_source', 'pybind.nos.v7_0_1b.brocade_ip_policy', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map.content.match.ipv6.route_source', 'pybind.nos.v7_1_0.brocade_ip_policy', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.route_map.content.match.ipv6.route_source', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'prefix-list'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def route_map_match_metric_delete(self, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v16r_1_00b.routing_system.route_map', u'route_map'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map.content.match.metric', 'pybind.nos.v6_0_2c.brocade_ip_policy', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map.content.match.metric', 'pybind.nos.v7_0_1b.brocade_ip_policy', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map.content.match.metric', 'pybind.nos.v7_1_0.brocade_ip_policy', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.route_map.content.match.metric', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def route_map_match_metric_metric_rmm_delete(self, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v16r_1_00b.routing_system.route_map', u'route_map'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map.content.match.metric', 'pybind.nos.v6_0_2c.brocade_ip_policy', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map.content.match.metric', 'pybind.nos.v7_0_1b.brocade_ip_policy', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map.content.match.metric', 'pybind.nos.v7_1_0.brocade_ip_policy', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.route_map.content.match.metric', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric-rmm'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def route_map_match_next_hop_delete(self, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.route_map', u'route_map'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v6_0_2c.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map.content.match.next_hop', 'pybind.nos.v6_0_2c.brocade_ip_policy', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map.content.match.next_hop', 'pybind.nos.v7_0_1b.brocade_ip_policy', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map.content.match.next_hop', 'pybind.nos.v7_1_0.brocade_ip_policy', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.route_map.content.match.next_hop', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def route_map_match_next_hop_next_hop_filter_val_delete(self, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.route_map', u'route_map'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v6_0_2c.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map.content.match.next_hop', 'pybind.nos.v6_0_2c.brocade_ip_policy', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map.content.match.next_hop', 'pybind.nos.v7_0_1b.brocade_ip_policy', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map.content.match.next_hop', 'pybind.nos.v7_1_0.brocade_ip_policy', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.route_map.content.match.next_hop', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'next-hop-filter-val'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def route_map_match_protocol_delete(self, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v6_0_2c.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v16r_1_00b.routing_system.route_map', u'route_map'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map.content.match.protocol', 'pybind.nos.v6_0_2c.brocade_ip_policy', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map.content.match.protocol', 'pybind.nos.v7_0_1b.brocade_ip_policy', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map.content.match.protocol', 'pybind.nos.v7_1_0.brocade_ip_policy', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.route_map.content.match.protocol', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def route_map_match_protocol_bgp_delete(self, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v16r_1_00b.routing_system.route_map', u'route_map'), ('pybind.nos.v6_0_2c.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map.content.match.protocol.bgp_protocol_container', 'pybind.nos.v6_0_2c.brocade_ip_policy', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map.content.match.protocol.bgp_protocol_container', 'pybind.nos.v7_0_1b.brocade_ip_policy', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map.content.match.protocol.bgp_protocol_container', 'pybind.nos.v7_1_0.brocade_ip_policy', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.route_map.content.match.protocol.bgp_protocol_container', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bgp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def route_map_match_protocol_bgp_protocol_container_delete(self, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v16r_1_00b.routing_system.route_map', u'route_map'), ('pybind.nos.v6_0_2c.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map.content.match.protocol.bgp_protocol_container', 'pybind.nos.v6_0_2c.brocade_ip_policy', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map.content.match.protocol.bgp_protocol_container', 'pybind.nos.v7_0_1b.brocade_ip_policy', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map.content.match.protocol.bgp_protocol_container', 'pybind.nos.v7_1_0.brocade_ip_policy', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.route_map.content.match.protocol.bgp_protocol_container', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def route_map_match_protocol_bgp_route_type_delete(self, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v16r_1_00b.routing_system.route_map', u'route_map'), ('pybind.nos.v6_0_2c.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map.content.match.protocol.bgp_protocol_container', 'pybind.nos.v6_0_2c.brocade_ip_policy', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map.content.match.protocol.bgp_protocol_container', 'pybind.nos.v7_0_1b.brocade_ip_policy', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map.content.match.protocol.bgp_protocol_container', 'pybind.nos.v7_1_0.brocade_ip_policy', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.route_map.content.match.protocol.bgp_protocol_container', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bgp-route-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def route_map_match_protocol_protocol_static_container_delete(self, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v16r_1_00b.routing_system.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map.content.match.protocol.protocol_static_container', 'pybind.nos.v6_0_2c.brocade_ip_policy', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map.content.match.protocol.protocol_static_container', 'pybind.nos.v7_0_1b.brocade_ip_policy', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map.content.match.protocol.protocol_static_container', 'pybind.nos.v7_1_0.brocade_ip_policy', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.route_map.content.match.protocol.protocol_static_container', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def route_map_match_protocol_static_delete(self, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v16r_1_00b.routing_system.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map.content.match.protocol.protocol_static_container', 'pybind.nos.v6_0_2c.brocade_ip_policy', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map.content.match.protocol.protocol_static_container', 'pybind.nos.v7_0_1b.brocade_ip_policy', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map.content.match.protocol.protocol_static_container', 'pybind.nos.v7_1_0.brocade_ip_policy', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.route_map.content.match.protocol.protocol_static_container', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'static'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def route_map_match_route_type_delete(self, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v16r_1_00b.routing_system.route_map', u'route_map'), ('pybind.nos.v6_0_2c.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map.content.match.route_type', 'pybind.nos.v6_0_2c.brocade_ip_policy', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map.content.match.route_type', 'pybind.nos.v7_0_1b.brocade_ip_policy', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map.content.match.route_type', 'pybind.nos.v7_1_0.brocade_ip_policy', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.route_map.content.match.route_type', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def route_map_match_route_type_route_type_rmm_delete(self, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v16r_1_00b.routing_system.route_map', u'route_map'), ('pybind.nos.v6_0_2c.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map.content.match.route_type', 'pybind.nos.v6_0_2c.brocade_ip_policy', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map.content.match.route_type', 'pybind.nos.v7_0_1b.brocade_ip_policy', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map.content.match.route_type', 'pybind.nos.v7_1_0.brocade_ip_policy', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.route_map.content.match.route_type', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-type-rmm'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def route_map_match_tag_delete(self, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v6_0_2c.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v16r_1_00b.routing_system.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map.content.match.tag', 'pybind.nos.v6_0_2c.brocade_ip_policy', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map.content.match.tag', 'pybind.nos.v7_0_1b.brocade_ip_policy', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map.content.match.tag', 'pybind.nos.v7_1_0.brocade_ip_policy', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.route_map.content.match.tag', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def route_map_match_vrf_delete(self, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v16r_1_00b.routing_system.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map.content.match', 'pybind.nos.v6_0_2c.brocade_ip_policy', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map.content.match', 'pybind.nos.v7_0_1b.brocade_ip_policy', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map.content.match', 'pybind.nos.v7_1_0.brocade_ip_policy', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.route_map.content.match', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vrf'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def route_map_set_as_path_delete(self, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v16r_1_00b.routing_system.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map.content.set_.as_path', 'pybind.nos.v6_0_2c.brocade_ip_policy', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map.content.set_.as_path', 'pybind.nos.v7_0_1b.brocade_ip_policy', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map.content.set_.as_path', 'pybind.nos.v7_1_0.brocade_ip_policy', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.route_map.content.set_.as_path', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def route_map_set_as_path_prepend_delete(self, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v16r_1_00b.routing_system.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map.content.set_.as_path', 'pybind.nos.v6_0_2c.brocade_ip_policy', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map.content.set_.as_path', 'pybind.nos.v7_0_1b.brocade_ip_policy', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map.content.set_.as_path', 'pybind.nos.v7_1_0.brocade_ip_policy', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.route_map.content.set_.as_path', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'prepend'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def route_map_set_as_path_tag_delete(self, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v16r_1_00b.routing_system.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map.content.set_.as_path', 'pybind.nos.v6_0_2c.brocade_ip_policy', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map.content.set_.as_path', 'pybind.nos.v7_0_1b.brocade_ip_policy', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map.content.set_.as_path', 'pybind.nos.v7_1_0.brocade_ip_policy', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.route_map.content.set_.as_path', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def route_map_set_automatic_tag_delete(self, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v6_0_2c.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v16r_1_00b.routing_system.route_map', u'route_map'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map.content.set_.automatic_tag', 'pybind.nos.v6_0_2c.brocade_ip_policy', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map.content.set_.automatic_tag', 'pybind.nos.v7_0_1b.brocade_ip_policy', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map.content.set_.automatic_tag', 'pybind.nos.v7_1_0.brocade_ip_policy', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.route_map.content.set_.automatic_tag', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def route_map_set_automatic_tag_tag_empty_delete(self, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v6_0_2c.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v16r_1_00b.routing_system.route_map', u'route_map'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map.content.set_.automatic_tag', 'pybind.nos.v6_0_2c.brocade_ip_policy', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map.content.set_.automatic_tag', 'pybind.nos.v7_0_1b.brocade_ip_policy', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map.content.set_.automatic_tag', 'pybind.nos.v7_1_0.brocade_ip_policy', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.route_map.content.set_.automatic_tag', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tag-empty'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def route_map_set_comm_list_delete(self, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.route_map', u'route_map'), ('pybind.nos.v6_0_2c.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map.content.set_.comm_list', 'pybind.nos.v6_0_2c.brocade_ip_policy', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map.content.set_.comm_list', 'pybind.nos.v7_0_1b.brocade_ip_policy', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map.content.set_.comm_list', 'pybind.nos.v7_1_0.brocade_ip_policy', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.route_map.content.set_.comm_list', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'comm_list_name, match_comm_delete'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def route_map_set_comm_list_comm_list_name_delete(self, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.route_map', u'route_map'), ('pybind.nos.v6_0_2c.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map.content.set_.comm_list', 'pybind.nos.v6_0_2c.brocade_ip_policy', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map.content.set_.comm_list', 'pybind.nos.v7_0_1b.brocade_ip_policy', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map.content.set_.comm_list', 'pybind.nos.v7_1_0.brocade_ip_policy', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.route_map.content.set_.comm_list', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'comm-list-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def route_map_set_comm_list_delete_delete(self, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.route_map', u'route_map'), ('pybind.nos.v6_0_2c.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map.content.set_.comm_list', 'pybind.nos.v6_0_2c.brocade_ip_policy', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map.content.set_.comm_list', 'pybind.nos.v7_0_1b.brocade_ip_policy', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map.content.set_.comm_list', 'pybind.nos.v7_1_0.brocade_ip_policy', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.route_map.content.set_.comm_list', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'delete'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def route_map_set_community_delete(self, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.route_map', u'route_map'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v6_0_2c.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map.content.set_.community', 'pybind.nos.v6_0_2c.brocade_ip_policy', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map.content.set_.community', 'pybind.nos.v7_0_1b.brocade_ip_policy', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map.content.set_.community', 'pybind.nos.v7_1_0.brocade_ip_policy', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.route_map.content.set_.community', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def route_map_set_community_set_community_expr_delete(self, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.route_map', u'route_map'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v6_0_2c.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map.content.set_.community', 'pybind.nos.v6_0_2c.brocade_ip_policy', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map.content.set_.community', 'pybind.nos.v7_0_1b.brocade_ip_policy', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map.content.set_.community', 'pybind.nos.v7_1_0.brocade_ip_policy', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.route_map.content.set_.community', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'set-community-expr'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def route_map_set_dampening_delete(self, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v6_0_2c.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v16r_1_00b.routing_system.route_map', u'route_map'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map.content.set_.dampening', 'pybind.nos.v6_0_2c.brocade_ip_policy', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map.content.set_.dampening', 'pybind.nos.v7_0_1b.brocade_ip_policy', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map.content.set_.dampening', 'pybind.nos.v7_1_0.brocade_ip_policy', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.route_map.content.set_.dampening', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'half_life, reuse, suppress, max_suppress_time'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def route_map_set_dampening_half_life_delete(self, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v6_0_2c.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v16r_1_00b.routing_system.route_map', u'route_map'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map.content.set_.dampening', 'pybind.nos.v6_0_2c.brocade_ip_policy', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map.content.set_.dampening', 'pybind.nos.v7_0_1b.brocade_ip_policy', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map.content.set_.dampening', 'pybind.nos.v7_1_0.brocade_ip_policy', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.route_map.content.set_.dampening', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'half-life'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def route_map_set_dampening_max_suppress_time_delete(self, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v6_0_2c.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v16r_1_00b.routing_system.route_map', u'route_map'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map.content.set_.dampening', 'pybind.nos.v6_0_2c.brocade_ip_policy', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map.content.set_.dampening', 'pybind.nos.v7_0_1b.brocade_ip_policy', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map.content.set_.dampening', 'pybind.nos.v7_1_0.brocade_ip_policy', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.route_map.content.set_.dampening', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'max-suppress-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def route_map_set_dampening_reuse_delete(self, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v6_0_2c.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v16r_1_00b.routing_system.route_map', u'route_map'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map.content.set_.dampening', 'pybind.nos.v6_0_2c.brocade_ip_policy', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map.content.set_.dampening', 'pybind.nos.v7_0_1b.brocade_ip_policy', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map.content.set_.dampening', 'pybind.nos.v7_1_0.brocade_ip_policy', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.route_map.content.set_.dampening', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'reuse'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def route_map_set_dampening_suppress_delete(self, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v6_0_2c.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v16r_1_00b.routing_system.route_map', u'route_map'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map.content.set_.dampening', 'pybind.nos.v6_0_2c.brocade_ip_policy', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map.content.set_.dampening', 'pybind.nos.v7_0_1b.brocade_ip_policy', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map.content.set_.dampening', 'pybind.nos.v7_1_0.brocade_ip_policy', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.route_map.content.set_.dampening', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'suppress'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def route_map_set_distance_delete(self, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.route_map', u'route_map'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v6_0_2c.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map.content.set_.distance', 'pybind.nos.v6_0_2c.brocade_ip_policy', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map.content.set_.distance', 'pybind.nos.v7_0_1b.brocade_ip_policy', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map.content.set_.distance', 'pybind.nos.v7_1_0.brocade_ip_policy', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.route_map.content.set_.distance', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def route_map_set_distance_dist_rms_delete(self, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.route_map', u'route_map'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v6_0_2c.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map.content.set_.distance', 'pybind.nos.v6_0_2c.brocade_ip_policy', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map.content.set_.distance', 'pybind.nos.v7_0_1b.brocade_ip_policy', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map.content.set_.distance', 'pybind.nos.v7_1_0.brocade_ip_policy', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.route_map.content.set_.distance', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dist-rms'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def route_map_set_extcommunity_rt_delete(self, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v16r_1_00b.routing_system.route_map', u'route_map'), ('pybind.nos.v6_0_2c.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map.content.set_.extcommunity.rt', 'pybind.nos.v6_0_2c.brocade_ip_policy', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map.content.set_.extcommunity.rt', 'pybind.nos.v7_0_1b.brocade_ip_policy', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map.content.set_.extcommunity.rt', 'pybind.nos.v7_1_0.brocade_ip_policy', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.route_map.content.set_.extcommunity.rt', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def route_map_set_extcommunity_rt_asn_nn_rt_delete(self, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v16r_1_00b.routing_system.route_map', u'route_map'), ('pybind.nos.v6_0_2c.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map.content.set_.extcommunity.rt', 'pybind.nos.v6_0_2c.brocade_ip_policy', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map.content.set_.extcommunity.rt', 'pybind.nos.v7_0_1b.brocade_ip_policy', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map.content.set_.extcommunity.rt', 'pybind.nos.v7_1_0.brocade_ip_policy', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.route_map.content.set_.extcommunity.rt', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ASN-NN-rt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def route_map_set_extcommunity_soo_delete(self, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v16r_1_00b.routing_system.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map.content.set_.extcommunity.soo', 'pybind.nos.v6_0_2c.brocade_ip_policy', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map.content.set_.extcommunity.soo', 'pybind.nos.v7_0_1b.brocade_ip_policy', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map.content.set_.extcommunity.soo', 'pybind.nos.v7_1_0.brocade_ip_policy', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.route_map.content.set_.extcommunity.soo', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def route_map_set_extcommunity_soo_asn_nn_soo_delete(self, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v16r_1_00b.routing_system.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map.content.set_.extcommunity.soo', 'pybind.nos.v6_0_2c.brocade_ip_policy', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map.content.set_.extcommunity.soo', 'pybind.nos.v7_0_1b.brocade_ip_policy', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map.content.set_.extcommunity.soo', 'pybind.nos.v7_1_0.brocade_ip_policy', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.route_map.content.set_.extcommunity.soo', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ASN-NN-soo'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def route_map_set_ip_dscp_delete(self, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.route_map', u'route_map'), ('pybind.nos.v6_0_2c.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map.content.set_.ip.dscp', 'pybind.nos.v6_0_2c.brocade_ip_policy', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map.content.set_.ip.dscp', 'pybind.nos.v7_0_1b.brocade_ip_policy', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map.content.set_.ip.dscp', 'pybind.nos.v7_1_0.brocade_ip_policy', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.route_map.content.set_.ip.dscp', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def route_map_set_ip_dscp_dscp_rms_delete(self, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.route_map', u'route_map'), ('pybind.nos.v6_0_2c.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map.content.set_.ip.dscp', 'pybind.nos.v6_0_2c.brocade_ip_policy', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map.content.set_.ip.dscp', 'pybind.nos.v7_0_1b.brocade_ip_policy', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map.content.set_.ip.dscp', 'pybind.nos.v7_1_0.brocade_ip_policy', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.route_map.content.set_.ip.dscp', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dscp-rms'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def route_map_set_ip_global_delete(self, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.route_map', u'route_map'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v6_0_2c.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map.content.set_.ip.global_', 'pybind.nos.v6_0_2c.brocade_ip_policy', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map.content.set_.ip.global_', 'pybind.nos.v7_0_1b.brocade_ip_policy', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map.content.set_.ip.global_', 'pybind.nos.v7_1_0.brocade_ip_policy', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.route_map.content.set_.ip.global_', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def route_map_set_ip_global_next_global_hop_delete(self, route_map=None, next_global_hop=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    **Instance Keyword Argument Tuple**:

    :type next_global_hop: next_hop
    :param next_global_hop: Keyword argument tuple.

    :type next_hop: unicode
    :param next_hop: **next_global_hop** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v6_0_2c.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v16r_1_00b.routing_system.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map.content.set_.ip.global_.next_global_hop', 'pybind.nos.v6_0_2c.brocade_ip_policy', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map.content.set_.ip.global_.next_global_hop', 'pybind.nos.v7_0_1b.brocade_ip_policy', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map.content.set_.ip.global_.next_global_hop', 'pybind.nos.v7_1_0.brocade_ip_policy', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.route_map.content.set_.ip.global_.next_global_hop', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'next_global_hop', 'keyval': 'next_hop', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map, next_global_hop=next_global_hop)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map, next_global_hop=next_global_hop)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def route_map_set_ip_interface_null0_delete(self, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v6_0_2c.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v16r_1_00b.routing_system.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map.content.set_.ip.interface', 'pybind.nos.v6_0_2c.brocade_ip_policy', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map.content.set_.ip.interface', 'pybind.nos.v7_0_1b.brocade_ip_policy', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map.content.set_.ip.interface', 'pybind.nos.v7_1_0.brocade_ip_policy', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.route_map.content.set_.ip.interface', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'null0'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def route_map_set_ip_next_hop_delete(self, route_map=None, next_hop=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    **Instance Keyword Argument Tuple**:

    :type next_hop: next_hop
    :param next_hop: Keyword argument tuple.

    :type next_hop: unicode
    :param next_hop: **next_hop** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map.content.set_.ip.next_ip.next_hop', 'pybind.nos.v6_0_2c.brocade_ip_policy', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map.content.set_.ip.next_ip.next_hop', 'pybind.nos.v7_0_1b.brocade_ip_policy', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map.content.set_.ip.next_ip.next_hop', 'pybind.nos.v7_1_0.brocade_ip_policy', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'next_hop', 'keyval': 'next_hop', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map, next_hop=next_hop)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map, next_hop=next_hop)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def route_map_set_ip_next_hop_next_hop_list_delete(self, route_map=None, next_hop_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    **Instance Keyword Argument Tuple**:

    :type next_hop_list: next_hop_addr
    :param next_hop_list: Keyword argument tuple.

    :type next_hop_addr: unicode
    :param next_hop_addr: **next_hop_list** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.route_map', u'route_map')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.route_map.content.set_.ip.next_hop.next_hop_list', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'next_hop_list', 'keyval': 'next_hop_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map, next_hop_list=next_hop_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map, next_hop_list=next_hop_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def route_map_set_ip_next_hop_peer_address_delete(self, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v16r_1_00b.routing_system.route_map', u'route_map'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map.content.set_.ip.next_hop', 'pybind.nos.v6_0_2c.brocade_ip_policy', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map.content.set_.ip.next_hop', 'pybind.nos.v7_0_1b.brocade_ip_policy', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map.content.set_.ip.next_hop', 'pybind.nos.v7_1_0.brocade_ip_policy', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.route_map.content.set_.ip.next_hop', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'peer-address'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def route_map_set_ip_next_ip_delete(self, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v6_0_2c.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map.content.set_.ip.next_ip', 'pybind.nos.v6_0_2c.brocade_ip_policy', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map.content.set_.ip.next_ip', 'pybind.nos.v7_0_1b.brocade_ip_policy', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map.content.set_.ip.next_ip', 'pybind.nos.v7_1_0.brocade_ip_policy', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def route_map_set_ip_next_vrf_delete(self, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v6_0_2c.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v16r_1_00b.routing_system.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map.content.set_.ip.next_vrf', 'pybind.nos.v6_0_2c.brocade_ip_policy', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map.content.set_.ip.next_vrf', 'pybind.nos.v7_0_1b.brocade_ip_policy', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map.content.set_.ip.next_vrf', 'pybind.nos.v7_1_0.brocade_ip_policy', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.route_map.content.set_.ip.next_vrf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def route_map_set_ip_next_vrf_list_delete(self, route_map=None, next_vrf_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    **Instance Keyword Argument Tuple**:

    :type next_vrf_list: vrf, next_hop
    :param next_vrf_list: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **next_vrf_list** tuple argument:  Next Hop Vrf Name

    :type next_hop: unicode
    :param next_hop: **next_vrf_list** tuple argument:  A.B.C.D;;IP address of next hop

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.route_map', u'route_map'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v6_0_2c.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map.content.set_.ip.next_vrf.next_vrf_list', 'pybind.nos.v6_0_2c.brocade_ip_policy', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map.content.set_.ip.next_vrf.next_vrf_list', 'pybind.nos.v7_0_1b.brocade_ip_policy', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map.content.set_.ip.next_vrf.next_vrf_list', 'pybind.nos.v7_1_0.brocade_ip_policy', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.route_map.content.set_.ip.next_vrf.next_vrf_list', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'next_vrf_list', 'keyval': 'vrf, next_hop', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map, next_vrf_list=next_vrf_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map, next_vrf_list=next_vrf_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def route_map_set_ipv6_global_delete(self, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.route_map', u'route_map'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v6_0_2c.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map.content.set_.ipv6.global_', 'pybind.nos.v6_0_2c.brocade_ip_policy', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map.content.set_.ipv6.global_', 'pybind.nos.v7_0_1b.brocade_ip_policy', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map.content.set_.ipv6.global_', 'pybind.nos.v7_1_0.brocade_ip_policy', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.route_map.content.set_.ipv6.global_', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def route_map_set_ipv6_global_next_global_hop_delete(self, route_map=None, next_global_hop=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    **Instance Keyword Argument Tuple**:

    :type next_global_hop: next_hop
    :param next_global_hop: Keyword argument tuple.

    :type next_hop: unicode
    :param next_hop: **next_global_hop** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v16r_1_00b.routing_system.route_map', u'route_map'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v6_0_2c.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map.content.set_.ipv6.global_.next_global_hop', 'pybind.nos.v6_0_2c.brocade_ip_policy', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map.content.set_.ipv6.global_.next_global_hop', 'pybind.nos.v7_0_1b.brocade_ip_policy', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map.content.set_.ipv6.global_.next_global_hop', 'pybind.nos.v7_1_0.brocade_ip_policy', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.route_map.content.set_.ipv6.global_.next_global_hop', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'next_global_hop', 'keyval': 'next_hop', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map, next_global_hop=next_global_hop)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map, next_global_hop=next_global_hop)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def route_map_set_ipv6_interface_null0_delete(self, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v16r_1_00b.routing_system.route_map', u'route_map'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map.content.set_.ipv6.interface', 'pybind.nos.v6_0_2c.brocade_ip_policy', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map.content.set_.ipv6.interface', 'pybind.nos.v7_0_1b.brocade_ip_policy', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map.content.set_.ipv6.interface', 'pybind.nos.v7_1_0.brocade_ip_policy', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.route_map.content.set_.ipv6.interface', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'null0'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def route_map_set_ipv6_next_hop_delete(self, route_map=None, next_hop=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    **Instance Keyword Argument Tuple**:

    :type next_hop: next_hop
    :param next_hop: Keyword argument tuple.

    :type next_hop: unicode
    :param next_hop: **next_hop** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v16r_1_00b.routing_system.route_map', u'route_map'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map.content.set_.ipv6.next_ip.next_hop', 'pybind.nos.v6_0_2c.brocade_ip_policy', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map.content.set_.ipv6.next_ip.next_hop', 'pybind.nos.v7_0_1b.brocade_ip_policy', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map.content.set_.ipv6.next_ip.next_hop', 'pybind.nos.v7_1_0.brocade_ip_policy', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.route_map.content.set_.ipv6.next_ip.next_hop', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'next_hop', 'keyval': 'next_hop', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map, next_hop=next_hop)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map, next_hop=next_hop)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def route_map_set_ipv6_next_ip_delete(self, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v16r_1_00b.routing_system.route_map', u'route_map'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map.content.set_.ipv6.next_ip', 'pybind.nos.v6_0_2c.brocade_ip_policy', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map.content.set_.ipv6.next_ip', 'pybind.nos.v7_0_1b.brocade_ip_policy', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map.content.set_.ipv6.next_ip', 'pybind.nos.v7_1_0.brocade_ip_policy', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.route_map.content.set_.ipv6.next_ip', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def route_map_set_ipv6_next_vrf_delete(self, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v6_0_2c.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v16r_1_00b.routing_system.route_map', u'route_map'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map.content.set_.ipv6.next_vrf', 'pybind.nos.v6_0_2c.brocade_ip_policy', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map.content.set_.ipv6.next_vrf', 'pybind.nos.v7_0_1b.brocade_ip_policy', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map.content.set_.ipv6.next_vrf', 'pybind.nos.v7_1_0.brocade_ip_policy', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.route_map.content.set_.ipv6.next_vrf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def route_map_set_ipv6_next_vrf_list_delete(self, route_map=None, next_vrf_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    **Instance Keyword Argument Tuple**:

    :type next_vrf_list: vrf, next_hop
    :param next_vrf_list: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **next_vrf_list** tuple argument:  WORD 1-63;;Next Hop Vrf Name

    :type next_hop: unicode
    :param next_hop: **next_vrf_list** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v16r_1_00b.routing_system.route_map', u'route_map'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v6_0_2c.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map.content.set_.ipv6.next_vrf.next_vrf_list', 'pybind.nos.v6_0_2c.brocade_ip_policy', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map.content.set_.ipv6.next_vrf.next_vrf_list', 'pybind.nos.v7_0_1b.brocade_ip_policy', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map.content.set_.ipv6.next_vrf.next_vrf_list', 'pybind.nos.v7_1_0.brocade_ip_policy', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.route_map.content.set_.ipv6.next_vrf.next_vrf_list', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'next_vrf_list', 'keyval': 'vrf, next_hop', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map, next_vrf_list=next_vrf_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map, next_vrf_list=next_vrf_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def route_map_set_local_preference_delete(self, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v6_0_2c.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v16r_1_00b.routing_system.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map.content.set_.local_preference', 'pybind.nos.v6_0_2c.brocade_ip_policy', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map.content.set_.local_preference', 'pybind.nos.v7_0_1b.brocade_ip_policy', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map.content.set_.local_preference', 'pybind.nos.v7_1_0.brocade_ip_policy', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.route_map.content.set_.local_preference', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def route_map_set_local_preference_local_preference_value_delete(self, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v6_0_2c.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v16r_1_00b.routing_system.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map.content.set_.local_preference', 'pybind.nos.v6_0_2c.brocade_ip_policy', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map.content.set_.local_preference', 'pybind.nos.v7_0_1b.brocade_ip_policy', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map.content.set_.local_preference', 'pybind.nos.v7_1_0.brocade_ip_policy', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.route_map.content.set_.local_preference', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'local-preference-value'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def route_map_set_metric_delete(self, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.route_map', u'route_map'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v6_0_2c.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map.content.set_.metric', 'pybind.nos.v6_0_2c.brocade_ip_policy', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map.content.set_.metric', 'pybind.nos.v7_0_1b.brocade_ip_policy', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map.content.set_.metric', 'pybind.nos.v7_1_0.brocade_ip_policy', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.route_map.content.set_.metric', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'delta_rms, metric_rms'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def route_map_set_metric_delta_rms_delete(self, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.route_map', u'route_map'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v6_0_2c.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map.content.set_.metric', 'pybind.nos.v6_0_2c.brocade_ip_policy', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map.content.set_.metric', 'pybind.nos.v7_0_1b.brocade_ip_policy', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map.content.set_.metric', 'pybind.nos.v7_1_0.brocade_ip_policy', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.route_map.content.set_.metric', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'delta-rms'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def route_map_set_metric_metric_rms_delete(self, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.route_map', u'route_map'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v6_0_2c.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map.content.set_.metric', 'pybind.nos.v6_0_2c.brocade_ip_policy', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map.content.set_.metric', 'pybind.nos.v7_0_1b.brocade_ip_policy', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map.content.set_.metric', 'pybind.nos.v7_1_0.brocade_ip_policy', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.route_map.content.set_.metric', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric-rms'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def route_map_set_metric_type_delete(self, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v16r_1_00b.routing_system.route_map', u'route_map'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map.content.set_.metric_type', 'pybind.nos.v6_0_2c.brocade_ip_policy', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map.content.set_.metric_type', 'pybind.nos.v7_0_1b.brocade_ip_policy', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map.content.set_.metric_type', 'pybind.nos.v7_1_0.brocade_ip_policy', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.route_map.content.set_.metric_type', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def route_map_set_metric_type_external_delete(self, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v16r_1_00b.routing_system.route_map', u'route_map'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map.content.set_.metric_type', 'pybind.nos.v6_0_2c.brocade_ip_policy', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map.content.set_.metric_type', 'pybind.nos.v7_0_1b.brocade_ip_policy', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map.content.set_.metric_type', 'pybind.nos.v7_1_0.brocade_ip_policy', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.route_map.content.set_.metric_type', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'external'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def route_map_set_metric_type_internal_delete(self, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v16r_1_00b.routing_system.route_map', u'route_map'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map.content.set_.metric_type', 'pybind.nos.v6_0_2c.brocade_ip_policy', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map.content.set_.metric_type', 'pybind.nos.v7_0_1b.brocade_ip_policy', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map.content.set_.metric_type', 'pybind.nos.v7_1_0.brocade_ip_policy', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.route_map.content.set_.metric_type', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'internal'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def route_map_set_metric_type_type_1_delete(self, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v16r_1_00b.routing_system.route_map', u'route_map'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map.content.set_.metric_type', 'pybind.nos.v6_0_2c.brocade_ip_policy', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map.content.set_.metric_type', 'pybind.nos.v7_0_1b.brocade_ip_policy', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map.content.set_.metric_type', 'pybind.nos.v7_1_0.brocade_ip_policy', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.route_map.content.set_.metric_type', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'type-1'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def route_map_set_metric_type_type_2_delete(self, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v16r_1_00b.routing_system.route_map', u'route_map'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map.content.set_.metric_type', 'pybind.nos.v6_0_2c.brocade_ip_policy', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map.content.set_.metric_type', 'pybind.nos.v7_0_1b.brocade_ip_policy', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map.content.set_.metric_type', 'pybind.nos.v7_1_0.brocade_ip_policy', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.route_map.content.set_.metric_type', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'type-2'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def route_map_set_origin_delete(self, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v6_0_2c.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v16r_1_00b.routing_system.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map.content.set_.origin', 'pybind.nos.v6_0_2c.brocade_ip_policy', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map.content.set_.origin', 'pybind.nos.v7_0_1b.brocade_ip_policy', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map.content.set_.origin', 'pybind.nos.v7_1_0.brocade_ip_policy', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.route_map.content.set_.origin', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def route_map_set_origin_igp_delete(self, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v6_0_2c.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v16r_1_00b.routing_system.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map.content.set_.origin', 'pybind.nos.v6_0_2c.brocade_ip_policy', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map.content.set_.origin', 'pybind.nos.v7_0_1b.brocade_ip_policy', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map.content.set_.origin', 'pybind.nos.v7_1_0.brocade_ip_policy', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.route_map.content.set_.origin', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'igp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def route_map_set_origin_incomplete_delete(self, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v6_0_2c.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v16r_1_00b.routing_system.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map.content.set_.origin', 'pybind.nos.v6_0_2c.brocade_ip_policy', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map.content.set_.origin', 'pybind.nos.v7_0_1b.brocade_ip_policy', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map.content.set_.origin', 'pybind.nos.v7_1_0.brocade_ip_policy', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.route_map.content.set_.origin', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'incomplete'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def route_map_set_route_type_delete(self, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.route_map', u'route_map'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v6_0_2c.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map.content.set_.route_type', 'pybind.nos.v6_0_2c.brocade_ip_policy', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map.content.set_.route_type', 'pybind.nos.v7_0_1b.brocade_ip_policy', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map.content.set_.route_type', 'pybind.nos.v7_1_0.brocade_ip_policy', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.route_map.content.set_.route_type', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def route_map_set_route_type_route_type_rms_delete(self, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.route_map', u'route_map'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v6_0_2c.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map.content.set_.route_type', 'pybind.nos.v6_0_2c.brocade_ip_policy', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map.content.set_.route_type', 'pybind.nos.v7_0_1b.brocade_ip_policy', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map.content.set_.route_type', 'pybind.nos.v7_1_0.brocade_ip_policy', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.route_map.content.set_.route_type', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-type-rms'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def route_map_set_tag_delete(self, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v16r_1_00b.routing_system.route_map', u'route_map'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v6_0_2c.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map.content.set_.tag', 'pybind.nos.v6_0_2c.brocade_ip_policy', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map.content.set_.tag', 'pybind.nos.v7_0_1b.brocade_ip_policy', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map.content.set_.tag', 'pybind.nos.v7_1_0.brocade_ip_policy', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.route_map.content.set_.tag', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def route_map_set_tag_tag_rms_delete(self, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v16r_1_00b.routing_system.route_map', u'route_map'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v6_0_2c.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map.content.set_.tag', 'pybind.nos.v6_0_2c.brocade_ip_policy', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map.content.set_.tag', 'pybind.nos.v7_0_1b.brocade_ip_policy', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map.content.set_.tag', 'pybind.nos.v7_1_0.brocade_ip_policy', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.route_map.content.set_.tag', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tag-rms'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def route_map_set_weight_delete(self, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.route_map', u'route_map'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v6_0_2c.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map.content.set_.weight', 'pybind.nos.v6_0_2c.brocade_ip_policy', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map.content.set_.weight', 'pybind.nos.v7_0_1b.brocade_ip_policy', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map.content.set_.weight', 'pybind.nos.v7_1_0.brocade_ip_policy', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.route_map.content.set_.weight', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def route_map_set_weight_weight_value_delete(self, route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.route_map', u'route_map'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v6_0_2c.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2c.hide_routemap_holder.route_map.content.set_.weight', 'pybind.nos.v6_0_2c.brocade_ip_policy', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_routemap_holder.route_map.content.set_.weight', 'pybind.nos.v7_0_1b.brocade_ip_policy', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_routemap_holder.route_map.content.set_.weight', 'pybind.nos.v7_1_0.brocade_ip_policy', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.routing_system.route_map.content.set_.weight', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'weight-value'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_evpn_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.evpn', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_evpn_af_evpn_neighbor_address_holder_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.evpn.af_evpn_neighbor_address_holder', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_evpn_neighbor_activate_delete(self, af_evpn_neighbor=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type af_evpn_neighbor: af_evpn_neighbor_address
    :param af_evpn_neighbor: Keyword argument tuple.

    :type af_evpn_neighbor_address: unicode
    :param af_evpn_neighbor_address: **af_evpn_neighbor** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.evpn.af_evpn_neighbor_address_holder.af_evpn_neighbor', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'af_evpn_neighbor', 'keyval': 'af_evpn_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'activate'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_evpn_neighbor=af_evpn_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_evpn_neighbor=af_evpn_neighbor)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_af_common_cmds_holder_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_af_ipv4_uc_and_vrf_cmds_call_point_holder_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_aggregate_address_delete(self, aggregate_address=None, advertise_map=None, as_set=None, attribute_map=None, summary_only=None, suppress_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type aggregate_address: aggregate_ip_prefix
    :param aggregate_address: Keyword argument tuple.

    :type aggregate_ip_prefix: unicode
    :param aggregate_ip_prefix: **aggregate_address** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    **Instance Argument(s)**:

    :type advertise_map: unicode
    :param advertise_map: Route map to control attribute advertisement

        * length restriction: ::

            ['1..63']

    :type as_set: YANGBool
    :param as_set: Generate AS set path information

    :type attribute_map: unicode
    :param attribute_map: Route map for parameter control

        * length restriction: ::

            ['1..63']

    :type summary_only: YANGBool
    :param summary_only: Filter more specific routes from updates

    :type suppress_map: unicode
    :param suppress_map: Conditionally filter more specific routes from updates

        * length restriction: ::

            ['1..63']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.aggregate_address', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'aggregate_address', 'keyval': 'aggregate_ip_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, aggregate_address=aggregate_address, advertise_map=advertise_map, as_set=as_set, attribute_map=attribute_map, summary_only=summary_only, suppress_map=suppress_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, aggregate_address=aggregate_address, advertise_map=advertise_map, as_set=as_set, attribute_map=attribute_map, summary_only=summary_only, suppress_map=suppress_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_aggregate_address_advertise_map_delete(self, aggregate_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type aggregate_address: aggregate_ip_prefix
    :param aggregate_address: Keyword argument tuple.

    :type aggregate_ip_prefix: unicode
    :param aggregate_ip_prefix: **aggregate_address** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.aggregate_address', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'aggregate_address', 'keyval': 'aggregate_ip_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'advertise-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, aggregate_address=aggregate_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, aggregate_address=aggregate_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_aggregate_address_as_set_delete(self, aggregate_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type aggregate_address: aggregate_ip_prefix
    :param aggregate_address: Keyword argument tuple.

    :type aggregate_ip_prefix: unicode
    :param aggregate_ip_prefix: **aggregate_address** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.aggregate_address', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'aggregate_address', 'keyval': 'aggregate_ip_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'as-set'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, aggregate_address=aggregate_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, aggregate_address=aggregate_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_aggregate_address_attribute_map_delete(self, aggregate_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type aggregate_address: aggregate_ip_prefix
    :param aggregate_address: Keyword argument tuple.

    :type aggregate_ip_prefix: unicode
    :param aggregate_ip_prefix: **aggregate_address** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.aggregate_address', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'aggregate_address', 'keyval': 'aggregate_ip_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'attribute-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, aggregate_address=aggregate_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, aggregate_address=aggregate_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_aggregate_address_summary_only_delete(self, aggregate_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type aggregate_address: aggregate_ip_prefix
    :param aggregate_address: Keyword argument tuple.

    :type aggregate_ip_prefix: unicode
    :param aggregate_ip_prefix: **aggregate_address** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.aggregate_address', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'aggregate_address', 'keyval': 'aggregate_ip_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'summary-only'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, aggregate_address=aggregate_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, aggregate_address=aggregate_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_aggregate_address_suppress_map_delete(self, aggregate_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type aggregate_address: aggregate_ip_prefix
    :param aggregate_address: Keyword argument tuple.

    :type aggregate_ip_prefix: unicode
    :param aggregate_ip_prefix: **aggregate_address** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.aggregate_address', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'aggregate_address', 'keyval': 'aggregate_ip_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'suppress-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, aggregate_address=aggregate_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, aggregate_address=aggregate_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_always_propagate_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'always-propagate'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_bgp_redistribute_internal_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bgp-redistribute-internal'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_client_to_client_reflection_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'client-to-client-reflection'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_dampening_dampening_flag_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dampening-flag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_dampening_route_map_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_dampening_values_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening.values', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening.values': [u'half_time']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_default_information_originate_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'default-information-originate'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_default_metric_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'default-metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_default_vrf_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_default_vrf_selected_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'default-vrf-selected'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_graceful_restart_graceful_restart_status_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.graceful_restart', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'graceful-restart-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_graceful_restart_purge_time_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.graceful_restart', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'purge-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_graceful_restart_restart_time_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.graceful_restart', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'restart-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_graceful_restart_stale_routes_time_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.graceful_restart', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'stale-routes-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_maximum_paths_ebgp_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.maximum_paths', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ebgp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_maximum_paths_ibgp_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.maximum_paths', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ibgp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_maximum_paths_load_sharing_value_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.maximum_paths', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'load-sharing-value'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_maximum_paths_use_load_sharing_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.maximum_paths', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'use-load-sharing'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_multipath_ebgp_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.multipath', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ebgp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_multipath_ibgp_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.multipath', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ibgp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_multipath_multi_as_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.multipath', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'multi-as'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_activate_delete(self, af_ipv4_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'af_ipv4_neighbor_address', 'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'activate'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_allowas_in_delete(self, af_ipv4_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'af_ipv4_neighbor_address', 'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'allowas-in'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_capability_orf_prefixlist_prefixlist_status_delete(self, af_ipv4_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.af_neighbor_capability.orf.prefixlist', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'prefixlist-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_capability_orf_prefixlist_receive_delete(self, af_ipv4_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.af_neighbor_capability.orf.prefixlist', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'receive'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_capability_orf_prefixlist_send_delete(self, af_ipv4_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.af_neighbor_capability.orf.prefixlist', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'send'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_default_originate_default_originate_status_delete(self, af_ipv4_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.default_originate', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'default-originate-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_default_originate_route_map_delete(self, af_ipv4_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.default_originate', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_holder_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_maximum_prefix_max_prefix_limit_delete(self, af_ipv4_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.maximum_prefix', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'max-prefix-limit'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_maximum_prefix_teardown_delete(self, af_ipv4_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.maximum_prefix.threshold_holder', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'teardown'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_maximum_prefix_threshold_delete(self, af_ipv4_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.maximum_prefix.threshold_holder', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'threshold'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_maximum_prefix_threshold_holder_delete(self, af_ipv4_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.maximum_prefix.threshold_holder', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'threshold, teardown'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_prefix_list_in_delete(self, af_ipv4_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.prefix_list.direction_in', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'in'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_prefix_list_ip_access_number_delete(self, af_ipv4_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.prefix_list.direction_in', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ip-access-number'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_prefix_list_ip_access_number_direction_out_delete(self, af_ipv4_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.prefix_list.direction_out', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ip-access-number'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_prefix_list_out_delete(self, af_ipv4_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.prefix_list.direction_out', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'out'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_route_map_in_neighbor_route_map_name_direction_in_delete(self, af_ipv4_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.neighbor_route_map.neighbor_route_map_direction_in', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'neighbor-route-map-name-direction-in'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_route_map_out_neighbor_route_map_name_direction_out_delete(self, af_ipv4_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.neighbor_route_map.neighbor_route_map_direction_out', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'neighbor-route-map-name-direction-out'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_route_reflector_client_delete(self, af_ipv4_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'af_ipv4_neighbor_address', 'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-reflector-client'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_send_community_both_delete(self, af_ipv4_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.send_community', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'both'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_send_community_extended_delete(self, af_ipv4_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.send_community', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'extended'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_send_community_send_community_status_delete(self, af_ipv4_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.send_community', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'send-community-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_send_community_standard_delete(self, af_ipv4_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.send_community', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'standard'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_unsuppress_map_map_name_delete(self, af_ipv4_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.unsuppress_map', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'map-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_weight_delete(self, af_ipv4_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'af_ipv4_neighbor_address', 'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'weight'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_activate_delete(self, af_ipv4_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'af_ipv4_neighbor_peergroup', 'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'activate'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_allowas_in_delete(self, af_ipv4_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'af_ipv4_neighbor_peergroup', 'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'allowas-in'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_capability_orf_prefixlist_prefixlist_status_delete(self, af_ipv4_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.af_neighbor_capability.orf.prefixlist', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'prefixlist-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_capability_orf_prefixlist_receive_delete(self, af_ipv4_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.af_neighbor_capability.orf.prefixlist', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'receive'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_capability_orf_prefixlist_send_delete(self, af_ipv4_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.af_neighbor_capability.orf.prefixlist', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'send'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_default_originate_default_originate_status_delete(self, af_ipv4_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.default_originate', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'default-originate-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_default_originate_route_map_delete(self, af_ipv4_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.default_originate', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_holder_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_maximum_prefix_max_prefix_limit_delete(self, af_ipv4_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.maximum_prefix', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'max-prefix-limit'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_maximum_prefix_teardown_delete(self, af_ipv4_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.maximum_prefix.threshold_holder', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'teardown'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_maximum_prefix_threshold_delete(self, af_ipv4_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.maximum_prefix.threshold_holder', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'threshold'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_maximum_prefix_threshold_holder_delete(self, af_ipv4_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.maximum_prefix.threshold_holder', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'threshold, teardown'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_prefix_list_in_delete(self, af_ipv4_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.prefix_list.direction_in', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'in'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_prefix_list_ip_access_number_delete(self, af_ipv4_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.prefix_list.direction_in', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ip-access-number'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_prefix_list_ip_access_number_direction_out_delete(self, af_ipv4_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.prefix_list.direction_out', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ip-access-number'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_prefix_list_out_delete(self, af_ipv4_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.prefix_list.direction_out', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'out'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_route_map_in_neighbor_route_map_name_direction_in_delete(self, af_ipv4_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.neighbor_route_map.neighbor_route_map_direction_in', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'neighbor-route-map-name-direction-in'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_route_map_out_neighbor_route_map_name_direction_out_delete(self, af_ipv4_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.neighbor_route_map.neighbor_route_map_direction_out', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'neighbor-route-map-name-direction-out'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_route_reflector_client_delete(self, af_ipv4_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'af_ipv4_neighbor_peergroup', 'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-reflector-client'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_send_community_both_delete(self, af_ipv4_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.send_community', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'both'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_send_community_extended_delete(self, af_ipv4_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.send_community', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'extended'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_send_community_send_community_status_delete(self, af_ipv4_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.send_community', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'send-community-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_send_community_standard_delete(self, af_ipv4_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.send_community', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'standard'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_unsuppress_map_map_name_delete(self, af_ipv4_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.unsuppress_map', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'map-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_weight_delete(self, af_ipv4_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'af_ipv4_neighbor_peergroup', 'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'weight'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_network_delete(self, network=None, network_weight=None, backdoor=None, network_route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type network: network_ipv4_address
    :param network: Keyword argument tuple.

    :type network_ipv4_address: unicode
    :param network_ipv4_address: **network** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    **Instance Argument(s)**:

    :type network_weight: long
    :param network_weight: Set BGP weight for network

        * range restriction: ::

            ['0..4294967295']

    :type backdoor: YANGBool
    :param backdoor: Specify a BGP backdoor route

    :type network_route_map: unicode
    :param network_route_map: Route-map to modify the attributes

        * length restriction: ::

            ['1..63']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.network', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'network', 'keyval': 'network_ipv4_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, network=network, network_weight=network_weight, backdoor=backdoor, network_route_map=network_route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, network=network, network_weight=network_weight, backdoor=backdoor, network_route_map=network_route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_network_backdoor_delete(self, network=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type network: network_ipv4_address
    :param network: Keyword argument tuple.

    :type network_ipv4_address: unicode
    :param network_ipv4_address: **network** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.network', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'network', 'keyval': 'network_ipv4_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'backdoor'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, network=network)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, network=network)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_network_route_map_delete(self, network=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type network: network_ipv4_address
    :param network: Keyword argument tuple.

    :type network_ipv4_address: unicode
    :param network_ipv4_address: **network** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.network', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'network', 'keyval': 'network_ipv4_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, network=network)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, network=network)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_network_weight_delete(self, network=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type network: network_ipv4_address
    :param network: Keyword argument tuple.

    :type network_ipv4_address: unicode
    :param network_ipv4_address: **network** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.network', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'network', 'keyval': 'network_ipv4_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'weight'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, network=network)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, network=network)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_next_hop_enable_default_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'next-hop-enable-default'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_next_hop_mpls_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.next_hop_mpls', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.next_hop_mpls': [u'compare_lsp_metric', u'follow_igp']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_next_hop_mpls_compare_lsp_metric_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.next_hop_mpls', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'compare-lsp-metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_next_hop_mpls_follow_igp_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.next_hop_mpls', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'follow-igp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_next_hop_recursion_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'next-hop-recursion'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_redistribute_bgp_metric_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_redistribute_bgp_redistribute_bgp_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redistribute-bgp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_redistribute_bgp_route_map_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_redistribute_connected_metric_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_redistribute_connected_redistribute_connected_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redistribute-connected'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_redistribute_connected_route_map_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_redistribute_isis_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.redistribute_isis', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.redistribute_isis': [u'level_2', u'level_1', u'level_1_2']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_redistribute_isis_level_1_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.redistribute_isis', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'level-1'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_redistribute_isis_level_1_2_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.redistribute_isis', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'level-1-2'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_redistribute_isis_level_2_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.redistribute_isis', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'level-2'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_redistribute_isis_metric_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.redistribute_isis', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_redistribute_isis_route_map_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.redistribute_isis', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_redistribute_ospf_match_external1_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'external1'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_redistribute_ospf_match_external2_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'external2'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_redistribute_ospf_match_internal_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'internal'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_redistribute_ospf_metric_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_redistribute_ospf_redistribute_ospf_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redistribute-ospf'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_redistribute_ospf_route_map_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_redistribute_static_metric_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_redistribute_static_redistribute_static_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redistribute-static'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_redistribute_static_route_map_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_rib_route_limit_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rib-route-limit'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_static_network_delete(self, static_network=None, static_network_distance=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type static_network: static_network_address
    :param static_network: Keyword argument tuple.

    :type static_network_address: unicode
    :param static_network_address: **static_network** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    **Instance Argument(s)**:

    :type static_network_distance: long
    :param static_network_distance: Define an administrative distance for this local network

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.static_network', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'static_network', 'keyval': 'static_network_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, static_network=static_network, static_network_distance=static_network_distance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, static_network=static_network, static_network_distance=static_network_distance)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_static_network_distance_delete(self, static_network=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type static_network: static_network_address
    :param static_network: Keyword argument tuple.

    :type static_network_address: unicode
    :param static_network_address: **static_network** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.static_network', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'static_network', 'keyval': 'static_network_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'distance'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, static_network=static_network)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, static_network=static_network)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_table_map_route_map_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.table_map', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_update_time_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'update-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_delete(self, af_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'af_vrf', 'keyval': 'af_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_aggregate_address_delete(self, af_vrf=None, aggregate_address=None, advertise_map=None, as_set=None, attribute_map=None, summary_only=None, suppress_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type aggregate_address: aggregate_ip_prefix
    :param aggregate_address: Keyword argument tuple.

    :type aggregate_ip_prefix: unicode
    :param aggregate_ip_prefix: **aggregate_address** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    **Instance Argument(s)**:

    :type advertise_map: unicode
    :param advertise_map: Route map to control attribute advertisement

        * length restriction: ::

            ['1..63']

    :type as_set: YANGBool
    :param as_set: Generate AS set path information

    :type attribute_map: unicode
    :param attribute_map: Route map for parameter control

        * length restriction: ::

            ['1..63']

    :type summary_only: YANGBool
    :param summary_only: Filter more specific routes from updates

    :type suppress_map: unicode
    :param suppress_map: Conditionally filter more specific routes from updates

        * length restriction: ::

            ['1..63']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.aggregate_address', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'aggregate_address', 'keyval': 'aggregate_ip_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, aggregate_address=aggregate_address, advertise_map=advertise_map, as_set=as_set, attribute_map=attribute_map, summary_only=summary_only, suppress_map=suppress_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, aggregate_address=aggregate_address, advertise_map=advertise_map, as_set=as_set, attribute_map=attribute_map, summary_only=summary_only, suppress_map=suppress_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_aggregate_address_advertise_map_delete(self, af_vrf=None, aggregate_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type aggregate_address: aggregate_ip_prefix
    :param aggregate_address: Keyword argument tuple.

    :type aggregate_ip_prefix: unicode
    :param aggregate_ip_prefix: **aggregate_address** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.aggregate_address', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'aggregate_address', 'keyval': 'aggregate_ip_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'advertise-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, aggregate_address=aggregate_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, aggregate_address=aggregate_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_aggregate_address_as_set_delete(self, af_vrf=None, aggregate_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type aggregate_address: aggregate_ip_prefix
    :param aggregate_address: Keyword argument tuple.

    :type aggregate_ip_prefix: unicode
    :param aggregate_ip_prefix: **aggregate_address** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.aggregate_address', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'aggregate_address', 'keyval': 'aggregate_ip_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'as-set'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, aggregate_address=aggregate_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, aggregate_address=aggregate_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_aggregate_address_attribute_map_delete(self, af_vrf=None, aggregate_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type aggregate_address: aggregate_ip_prefix
    :param aggregate_address: Keyword argument tuple.

    :type aggregate_ip_prefix: unicode
    :param aggregate_ip_prefix: **aggregate_address** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.aggregate_address', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'aggregate_address', 'keyval': 'aggregate_ip_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'attribute-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, aggregate_address=aggregate_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, aggregate_address=aggregate_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_aggregate_address_summary_only_delete(self, af_vrf=None, aggregate_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type aggregate_address: aggregate_ip_prefix
    :param aggregate_address: Keyword argument tuple.

    :type aggregate_ip_prefix: unicode
    :param aggregate_ip_prefix: **aggregate_address** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.aggregate_address', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'aggregate_address', 'keyval': 'aggregate_ip_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'summary-only'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, aggregate_address=aggregate_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, aggregate_address=aggregate_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_aggregate_address_suppress_map_delete(self, af_vrf=None, aggregate_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type aggregate_address: aggregate_ip_prefix
    :param aggregate_address: Keyword argument tuple.

    :type aggregate_ip_prefix: unicode
    :param aggregate_ip_prefix: **aggregate_address** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.aggregate_address', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'aggregate_address', 'keyval': 'aggregate_ip_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'suppress-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, aggregate_address=aggregate_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, aggregate_address=aggregate_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_always_propagate_delete(self, af_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'af_vrf', 'keyval': 'af_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'always-propagate'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_bgp_redistribute_internal_delete(self, af_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bgp-redistribute-internal'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_client_to_client_reflection_delete(self, af_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'af_vrf', 'keyval': 'af_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'client-to-client-reflection'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_dampening_dampening_flag_delete(self, af_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dampening-flag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_dampening_route_map_delete(self, af_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_dampening_values_delete(self, af_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening.values', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening.values': [u'half_time']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_default_information_originate_delete(self, af_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'af_vrf', 'keyval': 'af_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'default-information-originate'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_default_metric_delete(self, af_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'af_vrf', 'keyval': 'af_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'default-metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_graceful_restart_delete(self, af_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'af_vrf', 'keyval': 'af_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'graceful-restart'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_local_as_delete(self, af_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'af_vrf', 'keyval': 'af_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'local-as'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_maxas_limit_in_num_as_in_path_delete(self, af_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maxas_limit.in_', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'num-as-in-path'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_maximum_paths_ebgp_delete(self, af_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maximum_paths', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ebgp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_maximum_paths_ibgp_delete(self, af_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maximum_paths', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ibgp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_maximum_paths_load_sharing_value_delete(self, af_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maximum_paths', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'load-sharing-value'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_maximum_paths_use_load_sharing_delete(self, af_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maximum_paths', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'use-load-sharing'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_multipath_ebgp_delete(self, af_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.multipath', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ebgp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_multipath_ibgp_delete(self, af_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.multipath', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ibgp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_multipath_multi_as_delete(self, af_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.multipath', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'multi-as'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_delete(self, af_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_activate_delete(self, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv4_neighbor_addr', 'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'activate'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_advertisement_interval_delete(self, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.advertisement_interval', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'value'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_advertisement_interval_value_delete(self, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.advertisement_interval', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'value'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_allowas_in_delete(self, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv4_neighbor_addr', 'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'allowas-in'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_as_override_delete(self, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv4_neighbor_addr', 'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'as-override'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_bfd_bfd_enable_delete(self, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bfd-enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_bfd_holdover_interval_delete(self, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'holdover-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_bfd_interval_delete(self, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd.interval', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_bfd_interval_min_rx_delete(self, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd.interval', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'min-rx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_bfd_interval_min_tx_delete(self, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd.interval', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'min-tx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_bfd_interval_multiplier_delete(self, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd.interval', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'multiplier'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_capability_as4_disable_delete(self, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.as4', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'disable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_capability_as4_enable_delete(self, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.as4', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_capability_orf_prefixlist_prefixlist_status_delete(self, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.orf.prefixlist', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'prefixlist-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_capability_orf_prefixlist_receive_delete(self, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.orf.prefixlist', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'receive'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_capability_orf_prefixlist_send_delete(self, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.orf.prefixlist', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'send'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_default_originate_default_originate_status_delete(self, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.default_originate', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'default-originate-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_default_originate_route_map_delete(self, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.default_originate', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_description_delete(self, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv4_neighbor_addr', 'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'description'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_ebgp_btsh_delete(self, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv4_neighbor_addr', 'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ebgp-btsh'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_ebgp_multihop_delete(self, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.ebgp_multihop', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.ebgp_multihop': [u'ebgp_multihop_flag', u'ebgp_multihop_count']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_ebgp_multihop_ebgp_multihop_count_delete(self, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.ebgp_multihop', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ebgp-multihop-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_ebgp_multihop_ebgp_multihop_flag_delete(self, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.ebgp_multihop', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ebgp-multihop-flag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_enforce_first_as_disable_delete(self, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.enforce_first_as', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'disable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_enforce_first_as_enable_delete(self, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.enforce_first_as', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_local_as_delete(self, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.local_as', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'local_as_value, no_prepend'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_local_as_local_as_value_delete(self, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.local_as', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'local-as-value'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_local_as_no_prepend_delete(self, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.local_as', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'no-prepend'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_maxas_limit_in_disable_delete(self, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maxas_limit.in_', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'disable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_maxas_limit_in_num_as_in_as_path_delete(self, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maxas_limit.in_', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'num-as-in-as-path'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_maximum_prefix_max_prefix_limit_delete(self, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'max-prefix-limit'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_maximum_prefix_teardown_delete(self, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix.threshold_holder', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'teardown'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_maximum_prefix_threshold_delete(self, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix.threshold_holder', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'threshold'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_maximum_prefix_threshold_holder_delete(self, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix.threshold_holder', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'threshold, teardown'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_next_hop_self_always_delete(self, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.next_hop_self', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'always'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_next_hop_self_next_hop_self_status_delete(self, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.next_hop_self', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'next-hop-self-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_password_delete(self, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv4_neighbor_addr', 'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'password'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_peer_group_delete(self, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv4_neighbor_addr', 'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'peer-group'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_prefix_list_in_delete(self, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list.direction_in', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'in'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_prefix_list_ip_access_number_delete(self, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list.direction_in', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ip-access-number'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_prefix_list_ip_access_number_direction_out_delete(self, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list.direction_out', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ip-access-number'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_prefix_list_out_delete(self, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list.direction_out', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'out'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_remote_as_delete(self, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv4_neighbor_addr', 'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'remote-as'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_remove_private_as_delete(self, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv4_neighbor_addr', 'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'remove-private-as'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_route_map_in_neighbor_route_map_name_direction_in_delete(self, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map.neighbor_route_map_direction_in', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'neighbor-route-map-name-direction-in'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_route_map_out_neighbor_route_map_name_direction_out_delete(self, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map.neighbor_route_map_direction_out', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'neighbor-route-map-name-direction-out'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_route_reflector_client_delete(self, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv4_neighbor_addr', 'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-reflector-client'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_send_community_both_delete(self, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.send_community', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'both'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_send_community_extended_delete(self, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.send_community', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'extended'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_send_community_send_community_status_delete(self, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.send_community', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'send-community-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_send_community_standard_delete(self, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.send_community', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'standard'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_shutdown_generate_rib_out_delete(self, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.shutdown', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'generate-rib-out'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_shutdown_shutdown_status_delete(self, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.shutdown', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'shutdown-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_soft_reconfiguration_inbound_delete(self, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.soft_reconfiguration', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'inbound'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_static_network_edge_delete(self, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv4_neighbor_addr', 'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'static-network-edge'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_timers_hold_time_delete(self, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.timers', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hold-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_timers_keep_alive_delete(self, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.timers', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'keep-alive'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_unsuppress_map_map_name_delete(self, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.unsuppress_map', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'map-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_update_source_ethernet_interface_delete(self, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source.ethernet_interface', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'interface_type, interface_name'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source.ethernet_interface': [u'interface_type']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_update_source_interface_name_delete(self, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source.ethernet_interface', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'interface-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_update_source_interface_type_delete(self, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source.ethernet_interface', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'interface-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_update_source_loopback_delete(self, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'loopback'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_update_source_sip_ipv4_address_delete(self, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'sip-ipv4-address'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_update_source_ve_interface_delete(self, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 've-interface'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_weight_delete(self, af_vrf=None, af_ipv4_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv4_neighbor_addr', 'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'weight'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_vrf_neighbor_address_holder_delete(self, af_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_network_delete(self, af_vrf=None, network=None, network_weight=None, backdoor=None, network_route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type network: network_ipv4_address
    :param network: Keyword argument tuple.

    :type network_ipv4_address: unicode
    :param network_ipv4_address: **network** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    **Instance Argument(s)**:

    :type network_weight: long
    :param network_weight: Set BGP weight for network

        * range restriction: ::

            ['0..4294967295']

    :type backdoor: YANGBool
    :param backdoor: Specify a BGP backdoor route

    :type network_route_map: unicode
    :param network_route_map: Route-map to modify the attributes

        * length restriction: ::

            ['1..63']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.network', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'network', 'keyval': 'network_ipv4_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, network=network, network_weight=network_weight, backdoor=backdoor, network_route_map=network_route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, network=network, network_weight=network_weight, backdoor=backdoor, network_route_map=network_route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_network_backdoor_delete(self, af_vrf=None, network=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type network: network_ipv4_address
    :param network: Keyword argument tuple.

    :type network_ipv4_address: unicode
    :param network_ipv4_address: **network** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.network', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'network', 'keyval': 'network_ipv4_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'backdoor'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, network=network)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, network=network)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_network_route_map_delete(self, af_vrf=None, network=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type network: network_ipv4_address
    :param network: Keyword argument tuple.

    :type network_ipv4_address: unicode
    :param network_ipv4_address: **network** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.network', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'network', 'keyval': 'network_ipv4_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, network=network)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, network=network)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_network_weight_delete(self, af_vrf=None, network=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type network: network_ipv4_address
    :param network: Keyword argument tuple.

    :type network_ipv4_address: unicode
    :param network_ipv4_address: **network** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.network', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'network', 'keyval': 'network_ipv4_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'weight'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, network=network)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, network=network)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_next_hop_enable_default_delete(self, af_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'af_vrf', 'keyval': 'af_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'next-hop-enable-default'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_next_hop_recursion_delete(self, af_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'af_vrf', 'keyval': 'af_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'next-hop-recursion'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_redistribute_bgp_metric_delete(self, af_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_redistribute_bgp_redistribute_bgp_delete(self, af_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redistribute-bgp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_redistribute_bgp_route_map_delete(self, af_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_redistribute_connected_metric_delete(self, af_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_redistribute_connected_redistribute_connected_delete(self, af_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redistribute-connected'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_redistribute_connected_route_map_delete(self, af_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_redistribute_ospf_match_external1_delete(self, af_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'external1'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_redistribute_ospf_match_external2_delete(self, af_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'external2'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_redistribute_ospf_match_internal_delete(self, af_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'internal'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_redistribute_ospf_metric_delete(self, af_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_redistribute_ospf_redistribute_ospf_delete(self, af_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redistribute-ospf'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_redistribute_ospf_route_map_delete(self, af_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_redistribute_static_metric_delete(self, af_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_redistribute_static_redistribute_static_delete(self, af_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redistribute-static'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_redistribute_static_route_map_delete(self, af_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_rib_route_limit_delete(self, af_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'af_vrf', 'keyval': 'af_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rib-route-limit'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_static_network_delete(self, af_vrf=None, static_network=None, static_network_distance=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type static_network: static_network_address
    :param static_network: Keyword argument tuple.

    :type static_network_address: unicode
    :param static_network_address: **static_network** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    **Instance Argument(s)**:

    :type static_network_distance: long
    :param static_network_distance: Define an administrative distance for this local network

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.static_network', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'static_network', 'keyval': 'static_network_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, static_network=static_network, static_network_distance=static_network_distance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, static_network=static_network, static_network_distance=static_network_distance)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_static_network_distance_delete(self, af_vrf=None, static_network=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type static_network: static_network_address
    :param static_network: Keyword argument tuple.

    :type static_network_address: unicode
    :param static_network_address: **static_network** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.static_network', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'static_network', 'keyval': 'static_network_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'distance'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, static_network=static_network)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, static_network=static_network)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_table_map_route_map_delete(self, af_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.table_map', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_update_time_delete(self, af_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'af_vrf', 'keyval': 'af_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'update-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_af_common_cmds_holder_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_af_ipv6_uc_and_vrf_cmds_call_point_holder_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_aggregate_address_delete(self, aggregate_ipv6_address=None, advertise_map=None, as_set=None, attribute_map=None, summary_only=None, suppress_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type aggregate_ipv6_address: aggregate_ip_prefix
    :param aggregate_ipv6_address: Keyword argument tuple.

    :type aggregate_ip_prefix: unicode
    :param aggregate_ip_prefix: **aggregate_ipv6_address** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    **Instance Argument(s)**:

    :type advertise_map: unicode
    :param advertise_map: Route map to control attribute advertisement

        * length restriction: ::

            ['1..63']

    :type as_set: YANGBool
    :param as_set: Generate AS set path information

    :type attribute_map: unicode
    :param attribute_map: Route map for parameter control

        * length restriction: ::

            ['1..63']

    :type summary_only: YANGBool
    :param summary_only: Filter more specific routes from updates

    :type suppress_map: unicode
    :param suppress_map: Conditionally filter more specific routes from updates

        * length restriction: ::

            ['1..63']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.aggregate_ipv6_address', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'aggregate_ipv6_address', 'keyval': 'aggregate_ip_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, aggregate_ipv6_address=aggregate_ipv6_address, advertise_map=advertise_map, as_set=as_set, attribute_map=attribute_map, summary_only=summary_only, suppress_map=suppress_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, aggregate_ipv6_address=aggregate_ipv6_address, advertise_map=advertise_map, as_set=as_set, attribute_map=attribute_map, summary_only=summary_only, suppress_map=suppress_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_aggregate_address_advertise_map_delete(self, aggregate_ipv6_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type aggregate_ipv6_address: aggregate_ip_prefix
    :param aggregate_ipv6_address: Keyword argument tuple.

    :type aggregate_ip_prefix: unicode
    :param aggregate_ip_prefix: **aggregate_ipv6_address** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.aggregate_ipv6_address', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'aggregate_ipv6_address', 'keyval': 'aggregate_ip_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'advertise-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, aggregate_ipv6_address=aggregate_ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, aggregate_ipv6_address=aggregate_ipv6_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_aggregate_address_as_set_delete(self, aggregate_ipv6_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type aggregate_ipv6_address: aggregate_ip_prefix
    :param aggregate_ipv6_address: Keyword argument tuple.

    :type aggregate_ip_prefix: unicode
    :param aggregate_ip_prefix: **aggregate_ipv6_address** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.aggregate_ipv6_address', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'aggregate_ipv6_address', 'keyval': 'aggregate_ip_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'as-set'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, aggregate_ipv6_address=aggregate_ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, aggregate_ipv6_address=aggregate_ipv6_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_aggregate_address_attribute_map_delete(self, aggregate_ipv6_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type aggregate_ipv6_address: aggregate_ip_prefix
    :param aggregate_ipv6_address: Keyword argument tuple.

    :type aggregate_ip_prefix: unicode
    :param aggregate_ip_prefix: **aggregate_ipv6_address** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.aggregate_ipv6_address', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'aggregate_ipv6_address', 'keyval': 'aggregate_ip_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'attribute-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, aggregate_ipv6_address=aggregate_ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, aggregate_ipv6_address=aggregate_ipv6_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_aggregate_address_summary_only_delete(self, aggregate_ipv6_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type aggregate_ipv6_address: aggregate_ip_prefix
    :param aggregate_ipv6_address: Keyword argument tuple.

    :type aggregate_ip_prefix: unicode
    :param aggregate_ip_prefix: **aggregate_ipv6_address** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.aggregate_ipv6_address', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'aggregate_ipv6_address', 'keyval': 'aggregate_ip_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'summary-only'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, aggregate_ipv6_address=aggregate_ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, aggregate_ipv6_address=aggregate_ipv6_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_aggregate_address_suppress_map_delete(self, aggregate_ipv6_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type aggregate_ipv6_address: aggregate_ip_prefix
    :param aggregate_ipv6_address: Keyword argument tuple.

    :type aggregate_ip_prefix: unicode
    :param aggregate_ip_prefix: **aggregate_ipv6_address** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.aggregate_ipv6_address', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'aggregate_ipv6_address', 'keyval': 'aggregate_ip_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'suppress-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, aggregate_ipv6_address=aggregate_ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, aggregate_ipv6_address=aggregate_ipv6_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_always_propagate_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'always-propagate'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_bgp_redistribute_internal_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bgp-redistribute-internal'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_client_to_client_reflection_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'client-to-client-reflection'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_dampening_dampening_flag_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dampening-flag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_dampening_route_map_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_dampening_values_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening.values', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening.values': [u'half_time']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_default_information_originate_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'default-information-originate'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_default_metric_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'default-metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_default_vrf_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_default_vrf_selected_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'default-vrf-selected'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_graceful_restart_graceful_restart_status_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.graceful_restart', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'graceful-restart-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_graceful_restart_purge_time_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.graceful_restart', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'purge-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_graceful_restart_restart_time_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.graceful_restart', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'restart-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_graceful_restart_stale_routes_time_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.graceful_restart', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'stale-routes-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_maximum_paths_ebgp_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.maximum_paths', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ebgp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_maximum_paths_ibgp_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.maximum_paths', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ibgp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_maximum_paths_load_sharing_value_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.maximum_paths', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'load-sharing-value'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_maximum_paths_use_load_sharing_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.maximum_paths', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'use-load-sharing'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_multipath_ebgp_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.multipath', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ebgp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_multipath_ibgp_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.multipath', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ibgp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_multipath_multi_as_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.multipath', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'multi-as'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_activate_delete(self, af_ipv6_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_neighbor_address', 'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'activate'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_allowas_in_delete(self, af_ipv6_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_neighbor_address', 'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'allowas-in'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_capability_orf_prefixlist_prefixlist_status_delete(self, af_ipv6_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.af_neighbor_capability.orf.prefixlist', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'prefixlist-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_capability_orf_prefixlist_receive_delete(self, af_ipv6_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.af_neighbor_capability.orf.prefixlist', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'receive'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_capability_orf_prefixlist_send_delete(self, af_ipv6_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.af_neighbor_capability.orf.prefixlist', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'send'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_default_originate_default_originate_status_delete(self, af_ipv6_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.default_originate', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'default-originate-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_default_originate_route_map_delete(self, af_ipv6_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.default_originate', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_holder_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_maximum_prefix_max_prefix_limit_delete(self, af_ipv6_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.maximum_prefix', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'max-prefix-limit'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_maximum_prefix_teardown_delete(self, af_ipv6_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.maximum_prefix.threshold_holder', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'teardown'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_maximum_prefix_threshold_delete(self, af_ipv6_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.maximum_prefix.threshold_holder', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'threshold'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_maximum_prefix_threshold_holder_delete(self, af_ipv6_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.maximum_prefix.threshold_holder', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'threshold, teardown'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_prefix_list_in_delete(self, af_ipv6_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.prefix_list.direction_in', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'in'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_prefix_list_ip_access_number_delete(self, af_ipv6_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.prefix_list.direction_in', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ip-access-number'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_prefix_list_ip_access_number_direction_out_delete(self, af_ipv6_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.prefix_list.direction_out', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ip-access-number'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_prefix_list_out_delete(self, af_ipv6_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.prefix_list.direction_out', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'out'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_route_map_in_neighbor_route_map_name_direction_in_delete(self, af_ipv6_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.neighbor_route_map.neighbor_route_map_direction_in', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'neighbor-route-map-name-direction-in'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_route_map_out_neighbor_route_map_name_direction_out_delete(self, af_ipv6_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.neighbor_route_map.neighbor_route_map_direction_out', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'neighbor-route-map-name-direction-out'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_route_reflector_client_delete(self, af_ipv6_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_neighbor_address', 'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-reflector-client'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_send_community_both_delete(self, af_ipv6_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.send_community', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'both'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_send_community_extended_delete(self, af_ipv6_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.send_community', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'extended'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_send_community_send_community_status_delete(self, af_ipv6_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.send_community', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'send-community-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_send_community_standard_delete(self, af_ipv6_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.send_community', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'standard'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_unsuppress_map_map_name_delete(self, af_ipv6_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.unsuppress_map', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'map-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_weight_delete(self, af_ipv6_neighbor_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_neighbor_address', 'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'weight'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_activate_delete(self, af_ipv6_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_neighbor_peergroup', 'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'activate'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_allowas_in_delete(self, af_ipv6_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_neighbor_peergroup', 'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'allowas-in'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_capability_orf_prefixlist_prefixlist_status_delete(self, af_ipv6_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.af_neighbor_capability.orf.prefixlist', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'prefixlist-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_capability_orf_prefixlist_receive_delete(self, af_ipv6_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.af_neighbor_capability.orf.prefixlist', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'receive'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_capability_orf_prefixlist_send_delete(self, af_ipv6_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.af_neighbor_capability.orf.prefixlist', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'send'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_default_originate_default_originate_status_delete(self, af_ipv6_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.default_originate', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'default-originate-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_default_originate_route_map_delete(self, af_ipv6_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.default_originate', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_holder_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_maximum_prefix_max_prefix_limit_delete(self, af_ipv6_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.maximum_prefix', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'max-prefix-limit'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_maximum_prefix_teardown_delete(self, af_ipv6_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.maximum_prefix.threshold_holder', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'teardown'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_maximum_prefix_threshold_delete(self, af_ipv6_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.maximum_prefix.threshold_holder', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'threshold'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_maximum_prefix_threshold_holder_delete(self, af_ipv6_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.maximum_prefix.threshold_holder', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'threshold, teardown'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_prefix_list_in_delete(self, af_ipv6_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.prefix_list.direction_in', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'in'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_prefix_list_ip_access_number_delete(self, af_ipv6_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.prefix_list.direction_in', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ip-access-number'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_prefix_list_ip_access_number_direction_out_delete(self, af_ipv6_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.prefix_list.direction_out', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ip-access-number'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_prefix_list_out_delete(self, af_ipv6_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.prefix_list.direction_out', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'out'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_route_map_in_neighbor_route_map_name_direction_in_delete(self, af_ipv6_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.neighbor_route_map.neighbor_route_map_direction_in', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'neighbor-route-map-name-direction-in'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_route_map_out_neighbor_route_map_name_direction_out_delete(self, af_ipv6_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.neighbor_route_map.neighbor_route_map_direction_out', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'neighbor-route-map-name-direction-out'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_route_reflector_client_delete(self, af_ipv6_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_neighbor_peergroup', 'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-reflector-client'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_send_community_both_delete(self, af_ipv6_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.send_community', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'both'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_send_community_extended_delete(self, af_ipv6_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.send_community', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'extended'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_send_community_send_community_status_delete(self, af_ipv6_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.send_community', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'send-community-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_send_community_standard_delete(self, af_ipv6_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.send_community', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'standard'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_unsuppress_map_map_name_delete(self, af_ipv6_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.unsuppress_map', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'map-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_weight_delete(self, af_ipv6_neighbor_peergroup=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_neighbor_peergroup', 'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'weight'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_network_delete(self, network=None, network_weight=None, backdoor=None, network_route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type network: network_ipv6_address
    :param network: Keyword argument tuple.

    :type network_ipv6_address: unicode
    :param network_ipv6_address: **network** tuple argument:  A:B::C:D/M IPV6 address in dotted decimal/Mask

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    **Instance Argument(s)**:

    :type network_weight: long
    :param network_weight: Set BGP weight for network

        * range restriction: ::

            ['0..4294967295']

    :type backdoor: YANGBool
    :param backdoor: Specify a BGP backdoor route

    :type network_route_map: unicode
    :param network_route_map: Route-map to modify the attributes

        * length restriction: ::

            ['1..63']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.network', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'network', 'keyval': 'network_ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, network=network, network_weight=network_weight, backdoor=backdoor, network_route_map=network_route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, network=network, network_weight=network_weight, backdoor=backdoor, network_route_map=network_route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_network_backdoor_delete(self, network=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type network: network_ipv6_address
    :param network: Keyword argument tuple.

    :type network_ipv6_address: unicode
    :param network_ipv6_address: **network** tuple argument:  A:B::C:D/M IPV6 address in dotted decimal/Mask

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.network', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'network', 'keyval': 'network_ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'backdoor'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, network=network)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, network=network)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_network_route_map_delete(self, network=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type network: network_ipv6_address
    :param network: Keyword argument tuple.

    :type network_ipv6_address: unicode
    :param network_ipv6_address: **network** tuple argument:  A:B::C:D/M IPV6 address in dotted decimal/Mask

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.network', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'network', 'keyval': 'network_ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, network=network)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, network=network)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_network_weight_delete(self, network=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type network: network_ipv6_address
    :param network: Keyword argument tuple.

    :type network_ipv6_address: unicode
    :param network_ipv6_address: **network** tuple argument:  A:B::C:D/M IPV6 address in dotted decimal/Mask

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.network', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'network', 'keyval': 'network_ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'weight'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, network=network)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, network=network)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_next_hop_enable_default_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'next-hop-enable-default'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_next_hop_recursion_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'next-hop-recursion'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_redistribute_bgp_metric_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_redistribute_bgp_redistribute_bgp_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redistribute-bgp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_redistribute_bgp_route_map_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_redistribute_connected_metric_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_redistribute_connected_redistribute_connected_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redistribute-connected'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_redistribute_connected_route_map_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_redistribute_isis_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.redistribute_isis', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.redistribute_isis': [u'level_2', u'level_1', u'level_1_2']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_redistribute_isis_level_1_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.redistribute_isis', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'level-1'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_redistribute_isis_level_1_2_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.redistribute_isis', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'level-1-2'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_redistribute_isis_level_2_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.redistribute_isis', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'level-2'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_redistribute_isis_metric_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.redistribute_isis', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_redistribute_isis_route_map_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.redistribute_isis', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_redistribute_ospf_match_external1_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'external1'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_redistribute_ospf_match_external2_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'external2'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_redistribute_ospf_match_internal_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'internal'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_redistribute_ospf_metric_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_redistribute_ospf_redistribute_ospf_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redistribute-ospf'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_redistribute_ospf_route_map_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_redistribute_static_metric_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_redistribute_static_redistribute_static_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redistribute-static'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_redistribute_static_route_map_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_rib_route_limit_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rib-route-limit'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_table_map_route_map_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.table_map', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_update_time_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'update-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_delete(self, af_ipv6_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_vrf', 'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_aggregate_address_delete(self, af_ipv6_vrf=None, aggregate_ipv6_address=None, advertise_map=None, as_set=None, attribute_map=None, summary_only=None, suppress_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type aggregate_ipv6_address: aggregate_ip_prefix
    :param aggregate_ipv6_address: Keyword argument tuple.

    :type aggregate_ip_prefix: unicode
    :param aggregate_ip_prefix: **aggregate_ipv6_address** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    **Instance Argument(s)**:

    :type advertise_map: unicode
    :param advertise_map: Route map to control attribute advertisement

        * length restriction: ::

            ['1..63']

    :type as_set: YANGBool
    :param as_set: Generate AS set path information

    :type attribute_map: unicode
    :param attribute_map: Route map for parameter control

        * length restriction: ::

            ['1..63']

    :type summary_only: YANGBool
    :param summary_only: Filter more specific routes from updates

    :type suppress_map: unicode
    :param suppress_map: Conditionally filter more specific routes from updates

        * length restriction: ::

            ['1..63']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.aggregate_ipv6_address', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'aggregate_ipv6_address', 'keyval': 'aggregate_ip_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, aggregate_ipv6_address=aggregate_ipv6_address, advertise_map=advertise_map, as_set=as_set, attribute_map=attribute_map, summary_only=summary_only, suppress_map=suppress_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, aggregate_ipv6_address=aggregate_ipv6_address, advertise_map=advertise_map, as_set=as_set, attribute_map=attribute_map, summary_only=summary_only, suppress_map=suppress_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_aggregate_address_advertise_map_delete(self, af_ipv6_vrf=None, aggregate_ipv6_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type aggregate_ipv6_address: aggregate_ip_prefix
    :param aggregate_ipv6_address: Keyword argument tuple.

    :type aggregate_ip_prefix: unicode
    :param aggregate_ip_prefix: **aggregate_ipv6_address** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.aggregate_ipv6_address', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'aggregate_ipv6_address', 'keyval': 'aggregate_ip_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'advertise-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, aggregate_ipv6_address=aggregate_ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, aggregate_ipv6_address=aggregate_ipv6_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_aggregate_address_as_set_delete(self, af_ipv6_vrf=None, aggregate_ipv6_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type aggregate_ipv6_address: aggregate_ip_prefix
    :param aggregate_ipv6_address: Keyword argument tuple.

    :type aggregate_ip_prefix: unicode
    :param aggregate_ip_prefix: **aggregate_ipv6_address** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.aggregate_ipv6_address', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'aggregate_ipv6_address', 'keyval': 'aggregate_ip_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'as-set'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, aggregate_ipv6_address=aggregate_ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, aggregate_ipv6_address=aggregate_ipv6_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_aggregate_address_attribute_map_delete(self, af_ipv6_vrf=None, aggregate_ipv6_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type aggregate_ipv6_address: aggregate_ip_prefix
    :param aggregate_ipv6_address: Keyword argument tuple.

    :type aggregate_ip_prefix: unicode
    :param aggregate_ip_prefix: **aggregate_ipv6_address** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.aggregate_ipv6_address', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'aggregate_ipv6_address', 'keyval': 'aggregate_ip_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'attribute-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, aggregate_ipv6_address=aggregate_ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, aggregate_ipv6_address=aggregate_ipv6_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_aggregate_address_summary_only_delete(self, af_ipv6_vrf=None, aggregate_ipv6_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type aggregate_ipv6_address: aggregate_ip_prefix
    :param aggregate_ipv6_address: Keyword argument tuple.

    :type aggregate_ip_prefix: unicode
    :param aggregate_ip_prefix: **aggregate_ipv6_address** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.aggregate_ipv6_address', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'aggregate_ipv6_address', 'keyval': 'aggregate_ip_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'summary-only'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, aggregate_ipv6_address=aggregate_ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, aggregate_ipv6_address=aggregate_ipv6_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_aggregate_address_suppress_map_delete(self, af_ipv6_vrf=None, aggregate_ipv6_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type aggregate_ipv6_address: aggregate_ip_prefix
    :param aggregate_ipv6_address: Keyword argument tuple.

    :type aggregate_ip_prefix: unicode
    :param aggregate_ip_prefix: **aggregate_ipv6_address** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.aggregate_ipv6_address', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'aggregate_ipv6_address', 'keyval': 'aggregate_ip_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'suppress-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, aggregate_ipv6_address=aggregate_ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, aggregate_ipv6_address=aggregate_ipv6_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_always_propagate_delete(self, af_ipv6_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_vrf', 'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'always-propagate'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_bgp_redistribute_internal_delete(self, af_ipv6_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bgp-redistribute-internal'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_client_to_client_reflection_delete(self, af_ipv6_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_vrf', 'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'client-to-client-reflection'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_dampening_dampening_flag_delete(self, af_ipv6_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dampening-flag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_dampening_route_map_delete(self, af_ipv6_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_dampening_values_delete(self, af_ipv6_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening.values', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening.values': [u'half_time']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_default_information_originate_delete(self, af_ipv6_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_vrf', 'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'default-information-originate'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_default_metric_delete(self, af_ipv6_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_vrf', 'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'default-metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_graceful_restart_delete(self, af_ipv6_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_vrf', 'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'graceful-restart'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_maximum_paths_ebgp_delete(self, af_ipv6_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.maximum_paths', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ebgp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_maximum_paths_ibgp_delete(self, af_ipv6_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.maximum_paths', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ibgp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_maximum_paths_load_sharing_value_delete(self, af_ipv6_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.maximum_paths', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'load-sharing-value'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_maximum_paths_use_load_sharing_delete(self, af_ipv6_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.maximum_paths', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'use-load-sharing'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_multipath_ebgp_delete(self, af_ipv6_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.multipath', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ebgp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_multipath_ibgp_delete(self, af_ipv6_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.multipath', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ibgp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_multipath_multi_as_delete(self, af_ipv6_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.multipath', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'multi-as'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_delete(self, af_ipv6_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_activate_delete(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_neighbor_addr', 'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'activate'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_advertisement_interval_delete(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.advertisement_interval', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'value'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_advertisement_interval_value_delete(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.advertisement_interval', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'value'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_allowas_in_delete(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_neighbor_addr', 'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'allowas-in'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_as_override_delete(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_neighbor_addr', 'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'as-override'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_bfd_bfd_enable_delete(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bfd-enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_bfd_holdover_interval_delete(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'holdover-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_bfd_interval_delete(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd.interval', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_bfd_interval_min_rx_delete(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd.interval', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'min-rx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_bfd_interval_min_tx_delete(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd.interval', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'min-tx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_bfd_interval_multiplier_delete(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd.interval', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'multiplier'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_capability_as4_disable_delete(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.as4', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'disable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_capability_as4_enable_delete(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.as4', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_capability_orf_prefixlist_prefixlist_status_delete(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.orf.prefixlist', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'prefixlist-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_capability_orf_prefixlist_receive_delete(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.orf.prefixlist', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'receive'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_capability_orf_prefixlist_send_delete(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.orf.prefixlist', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'send'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_default_originate_default_originate_status_delete(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.default_originate', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'default-originate-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_default_originate_route_map_delete(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.default_originate', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_description_delete(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_neighbor_addr', 'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'description'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_ebgp_btsh_delete(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_neighbor_addr', 'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ebgp-btsh'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_ebgp_multihop_delete(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.ebgp_multihop', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.ebgp_multihop': [u'ebgp_multihop_flag', u'ebgp_multihop_count']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_ebgp_multihop_ebgp_multihop_count_delete(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.ebgp_multihop', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ebgp-multihop-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_ebgp_multihop_ebgp_multihop_flag_delete(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.ebgp_multihop', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ebgp-multihop-flag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_enforce_first_as_disable_delete(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.enforce_first_as', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'disable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_enforce_first_as_enable_delete(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.enforce_first_as', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_local_as_delete(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.local_as', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'local_as_value, no_prepend'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_local_as_local_as_value_delete(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.local_as', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'local-as-value'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_local_as_no_prepend_delete(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.local_as', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'no-prepend'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_maxas_limit_in_disable_delete(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maxas_limit.in_', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'disable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_maxas_limit_in_num_as_in_as_path_delete(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maxas_limit.in_', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'num-as-in-as-path'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_maximum_prefix_max_prefix_limit_delete(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'max-prefix-limit'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_maximum_prefix_teardown_delete(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix.threshold_holder', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'teardown'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_maximum_prefix_threshold_delete(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix.threshold_holder', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'threshold'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_maximum_prefix_threshold_holder_delete(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix.threshold_holder', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'threshold, teardown'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_next_hop_self_always_delete(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.next_hop_self', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'always'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_next_hop_self_next_hop_self_status_delete(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.next_hop_self', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'next-hop-self-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_password_delete(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_neighbor_addr', 'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'password'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_peer_group_delete(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_neighbor_addr', 'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'peer-group'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_prefix_list_in_delete(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list.direction_in', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'in'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_prefix_list_ip_access_number_delete(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list.direction_in', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ip-access-number'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_prefix_list_ip_access_number_direction_out_delete(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list.direction_out', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ip-access-number'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_prefix_list_out_delete(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list.direction_out', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'out'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_remote_as_delete(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_neighbor_addr', 'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'remote-as'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_remove_private_as_delete(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_neighbor_addr', 'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'remove-private-as'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_route_map_in_neighbor_route_map_name_direction_in_delete(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map.neighbor_route_map_direction_in', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'neighbor-route-map-name-direction-in'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_route_map_out_neighbor_route_map_name_direction_out_delete(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map.neighbor_route_map_direction_out', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'neighbor-route-map-name-direction-out'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_route_reflector_client_delete(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_neighbor_addr', 'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-reflector-client'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_send_community_both_delete(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.send_community', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'both'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_send_community_extended_delete(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.send_community', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'extended'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_send_community_send_community_status_delete(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.send_community', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'send-community-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_send_community_standard_delete(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.send_community', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'standard'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_shutdown_generate_rib_out_delete(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.shutdown', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'generate-rib-out'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_shutdown_shutdown_status_delete(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.shutdown', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'shutdown-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_soft_reconfiguration_inbound_delete(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.soft_reconfiguration', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'inbound'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_static_network_edge_delete(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_neighbor_addr', 'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'static-network-edge'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_timers_hold_time_delete(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.timers', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hold-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_timers_keep_alive_delete(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.timers', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'keep-alive'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_unsuppress_map_map_name_delete(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.unsuppress_map', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'map-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_update_source_ethernet_interface_delete(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source.ethernet_interface', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'interface_type, interface_name'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source.ethernet_interface': [u'interface_type']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_update_source_interface_name_delete(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source.ethernet_interface', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'interface-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_update_source_interface_type_delete(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source.ethernet_interface', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'interface-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_update_source_loopback_delete(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'loopback'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_update_source_sip_ipv6_address_delete(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'sip-ipv6-address'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_update_source_ve_interface_delete(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 've-interface'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_weight_delete(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_neighbor_addr', 'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'weight'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_vrf_neighbor_address_holder_delete(self, af_ipv6_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_network_delete(self, af_ipv6_vrf=None, network=None, network_weight=None, backdoor=None, network_route_map=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type network: network_ipv6_address
    :param network: Keyword argument tuple.

    :type network_ipv6_address: unicode
    :param network_ipv6_address: **network** tuple argument:  A:B::C:D/M IPV6 address in dotted decimal/Mask

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    **Instance Argument(s)**:

    :type network_weight: long
    :param network_weight: Set BGP weight for network

        * range restriction: ::

            ['0..4294967295']

    :type backdoor: YANGBool
    :param backdoor: Specify a BGP backdoor route

    :type network_route_map: unicode
    :param network_route_map: Route-map to modify the attributes

        * length restriction: ::

            ['1..63']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.network', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'network', 'keyval': 'network_ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, network=network, network_weight=network_weight, backdoor=backdoor, network_route_map=network_route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, network=network, network_weight=network_weight, backdoor=backdoor, network_route_map=network_route_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_network_backdoor_delete(self, af_ipv6_vrf=None, network=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type network: network_ipv6_address
    :param network: Keyword argument tuple.

    :type network_ipv6_address: unicode
    :param network_ipv6_address: **network** tuple argument:  A:B::C:D/M IPV6 address in dotted decimal/Mask

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.network', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'network', 'keyval': 'network_ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'backdoor'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, network=network)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, network=network)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_network_route_map_delete(self, af_ipv6_vrf=None, network=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type network: network_ipv6_address
    :param network: Keyword argument tuple.

    :type network_ipv6_address: unicode
    :param network_ipv6_address: **network** tuple argument:  A:B::C:D/M IPV6 address in dotted decimal/Mask

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.network', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'network', 'keyval': 'network_ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, network=network)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, network=network)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_network_weight_delete(self, af_ipv6_vrf=None, network=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type network: network_ipv6_address
    :param network: Keyword argument tuple.

    :type network_ipv6_address: unicode
    :param network_ipv6_address: **network** tuple argument:  A:B::C:D/M IPV6 address in dotted decimal/Mask

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.network', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'network', 'keyval': 'network_ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'weight'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, network=network)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, network=network)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_next_hop_enable_default_delete(self, af_ipv6_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_vrf', 'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'next-hop-enable-default'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_next_hop_recursion_delete(self, af_ipv6_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_vrf', 'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'next-hop-recursion'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_redistribute_bgp_metric_delete(self, af_ipv6_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_redistribute_bgp_redistribute_bgp_delete(self, af_ipv6_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redistribute-bgp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_redistribute_bgp_route_map_delete(self, af_ipv6_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_redistribute_connected_metric_delete(self, af_ipv6_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_redistribute_connected_redistribute_connected_delete(self, af_ipv6_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redistribute-connected'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_redistribute_connected_route_map_delete(self, af_ipv6_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_redistribute_ospf_match_external1_delete(self, af_ipv6_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'external1'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_redistribute_ospf_match_external2_delete(self, af_ipv6_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'external2'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_redistribute_ospf_match_internal_delete(self, af_ipv6_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'internal'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_redistribute_ospf_metric_delete(self, af_ipv6_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_redistribute_ospf_redistribute_ospf_delete(self, af_ipv6_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redistribute-ospf'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_redistribute_ospf_route_map_delete(self, af_ipv6_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_redistribute_static_metric_delete(self, af_ipv6_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_redistribute_static_redistribute_static_delete(self, af_ipv6_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redistribute-static'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_redistribute_static_route_map_delete(self, af_ipv6_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_rib_route_limit_delete(self, af_ipv6_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_vrf', 'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rib-route-limit'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_table_map_route_map_delete(self, af_ipv6_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.table_map', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_update_time_delete(self, af_ipv6_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_vrf', 'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'update-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_always_compare_med_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'always-compare-med'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_as_path_ignore_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'as-path-ignore'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_auto_shutdown_new_neighbors_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'auto-shutdown-new-neighbors'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_bfd_holdover_interval_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.bfd', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'holdover-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_bfd_interval_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.bfd.interval', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_bfd_interval_min_rx_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.bfd.interval', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'min-rx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_bfd_interval_min_tx_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.bfd.interval', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'min-tx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_bfd_interval_multiplier_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.bfd.interval', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'multiplier'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_capability_as4_enable_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.capability', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'as4-enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_cluster_id_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.cluster_id', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.cluster_id': [u'cluster_id_value', u'cluster_id_ipv4_address']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_cluster_id_id_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.cluster_id', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_cluster_id_ipv4_address_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.cluster_id', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ipv4-address'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_compare_med_empty_aspath_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'compare-med-empty-aspath'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_compare_routerid_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'compare-routerid'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_confederation_identifier_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.confederation', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'identifier'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_default_local_preference_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'default-local-preference'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_enforce_first_as_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enforce-first-as'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_fast_external_fallover_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'fast-external-fallover'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_install_igp_cost_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'install-igp-cost'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_local_as_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'local-as'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_log_dampening_debug_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'log-dampening-debug'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_maxas_limit_in_num_as_in_path_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.maxas_limit.in_', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'num-as-in-path'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_med_missing_as_worst_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'med-missing-as-worst'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_addr_advertisement_interval_delete(self, neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.advertisement_interval', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'value'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_addr=neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_addr_advertisement_interval_value_delete(self, neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.advertisement_interval', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'value'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_addr=neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_addr_as_override_delete(self, neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'neighbor_addr', 'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'as-override'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_addr=neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_addr_bfd_bfd_enable_delete(self, neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.bfd', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bfd-enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_addr=neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_addr_bfd_holdover_interval_delete(self, neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.bfd', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'holdover-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_addr=neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_addr_bfd_interval_delete(self, neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.bfd.interval', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_addr=neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_addr_bfd_interval_min_rx_delete(self, neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.bfd.interval', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'min-rx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_addr=neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_addr_bfd_interval_min_tx_delete(self, neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.bfd.interval', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'min-tx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_addr=neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_addr_bfd_interval_multiplier_delete(self, neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.bfd.interval', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'multiplier'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_addr=neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_addr_capability_as4_disable_delete(self, neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.af_neighbor_capability.as4', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'disable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_addr=neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_addr_capability_as4_enable_delete(self, neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.af_neighbor_capability.as4', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_addr=neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_addr_description_delete(self, neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'neighbor_addr', 'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'description'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_addr=neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_addr_ebgp_btsh_delete(self, neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'neighbor_addr', 'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ebgp-btsh'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_addr=neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_addr_ebgp_multihop_delete(self, neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.ebgp_multihop', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.ebgp_multihop': [u'ebgp_multihop_flag', u'ebgp_multihop_count']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_addr=neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_addr_ebgp_multihop_ebgp_multihop_count_delete(self, neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.ebgp_multihop', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ebgp-multihop-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_addr=neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_addr_ebgp_multihop_ebgp_multihop_flag_delete(self, neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.ebgp_multihop', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ebgp-multihop-flag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_addr=neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_addr_enforce_first_as_disable_delete(self, neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.enforce_first_as', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'disable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_addr=neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_addr_enforce_first_as_enable_delete(self, neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.enforce_first_as', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_addr=neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_addr_local_as_delete(self, neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.local_as', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'local_as_value, no_prepend'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_addr=neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_addr_local_as_local_as_value_delete(self, neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.local_as', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'local-as-value'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_addr=neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_addr_local_as_no_prepend_delete(self, neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.local_as', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'no-prepend'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_addr=neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_addr_maxas_limit_in_disable_delete(self, neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.maxas_limit.in_', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'disable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_addr=neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_addr_maxas_limit_in_num_as_in_as_path_delete(self, neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.maxas_limit.in_', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'num-as-in-as-path'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_addr=neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_addr_next_hop_self_always_delete(self, neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.next_hop_self', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'always'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_addr=neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_addr_next_hop_self_next_hop_self_status_delete(self, neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.next_hop_self', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'next-hop-self-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_addr=neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_addr_password_delete(self, neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'neighbor_addr', 'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'password'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_addr=neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_addr_peer_group_delete(self, neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'neighbor_addr', 'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'peer-group'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_addr=neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_addr_remote_as_delete(self, neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'neighbor_addr', 'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'remote-as'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_addr=neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_addr_remove_private_as_delete(self, neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'neighbor_addr', 'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'remove-private-as'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_addr=neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_addr_shutdown_generate_rib_out_delete(self, neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.shutdown', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'generate-rib-out'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_addr=neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_addr_shutdown_shutdown_status_delete(self, neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.shutdown', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'shutdown-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_addr=neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_addr_soft_reconfiguration_inbound_delete(self, neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.soft_reconfiguration', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'inbound'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_addr=neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_addr_static_network_edge_delete(self, neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'neighbor_addr', 'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'static-network-edge'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_addr=neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_addr_timers_hold_time_delete(self, neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.timers', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hold-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_addr=neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_addr_timers_keep_alive_delete(self, neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.timers', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'keep-alive'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_addr=neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_addr_update_source_ethernet_interface_delete(self, neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source.ethernet_interface', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'interface_type, interface_name'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source.ethernet_interface': [u'interface_type']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_addr=neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_addr_update_source_interface_name_delete(self, neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source.ethernet_interface', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'interface-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_addr=neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_addr_update_source_interface_type_delete(self, neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source.ethernet_interface', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'interface-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_addr=neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_addr_update_source_loopback_delete(self, neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'loopback'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_addr=neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_addr_update_source_sip_ipv4_address_delete(self, neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'sip-ipv4-address'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_addr=neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_addr_update_source_ve_interface_delete(self, neighbor_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 've-interface'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_addr=neighbor_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_ipv6_addr_advertisement_interval_delete(self, neighbor_ipv6_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.advertisement_interval', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'value'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_ipv6_addr_advertisement_interval_value_delete(self, neighbor_ipv6_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.advertisement_interval', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'value'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_ipv6_addr_as_override_delete(self, neighbor_ipv6_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'neighbor_ipv6_addr', 'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'as-override'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_ipv6_addr_bfd_bfd_enable_delete(self, neighbor_ipv6_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.bfd', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bfd-enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_ipv6_addr_bfd_holdover_interval_delete(self, neighbor_ipv6_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.bfd', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'holdover-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_ipv6_addr_bfd_interval_delete(self, neighbor_ipv6_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.bfd.interval', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_ipv6_addr_bfd_interval_min_rx_delete(self, neighbor_ipv6_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.bfd.interval', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'min-rx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_ipv6_addr_bfd_interval_min_tx_delete(self, neighbor_ipv6_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.bfd.interval', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'min-tx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_ipv6_addr_bfd_interval_multiplier_delete(self, neighbor_ipv6_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.bfd.interval', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'multiplier'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_ipv6_addr_capability_as4_disable_delete(self, neighbor_ipv6_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.af_neighbor_capability.as4', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'disable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_ipv6_addr_capability_as4_enable_delete(self, neighbor_ipv6_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.af_neighbor_capability.as4', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_ipv6_addr_description_delete(self, neighbor_ipv6_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'neighbor_ipv6_addr', 'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'description'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_ipv6_addr_ebgp_btsh_delete(self, neighbor_ipv6_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'neighbor_ipv6_addr', 'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ebgp-btsh'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_ipv6_addr_ebgp_multihop_delete(self, neighbor_ipv6_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.ebgp_multihop', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.ebgp_multihop': [u'ebgp_multihop_flag', u'ebgp_multihop_count']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_ipv6_addr_ebgp_multihop_ebgp_multihop_count_delete(self, neighbor_ipv6_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.ebgp_multihop', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ebgp-multihop-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_ipv6_addr_ebgp_multihop_ebgp_multihop_flag_delete(self, neighbor_ipv6_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.ebgp_multihop', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ebgp-multihop-flag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_ipv6_addr_enforce_first_as_disable_delete(self, neighbor_ipv6_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.enforce_first_as', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'disable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_ipv6_addr_enforce_first_as_enable_delete(self, neighbor_ipv6_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.enforce_first_as', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_ipv6_addr_local_as_delete(self, neighbor_ipv6_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.local_as', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'local_as_value, no_prepend'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_ipv6_addr_local_as_local_as_value_delete(self, neighbor_ipv6_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.local_as', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'local-as-value'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_ipv6_addr_local_as_no_prepend_delete(self, neighbor_ipv6_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.local_as', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'no-prepend'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_ipv6_addr_maxas_limit_in_disable_delete(self, neighbor_ipv6_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.maxas_limit.in_', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'disable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_ipv6_addr_maxas_limit_in_num_as_in_as_path_delete(self, neighbor_ipv6_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.maxas_limit.in_', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'num-as-in-as-path'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_ipv6_addr_next_hop_self_always_delete(self, neighbor_ipv6_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.next_hop_self', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'always'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_ipv6_addr_next_hop_self_next_hop_self_status_delete(self, neighbor_ipv6_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.next_hop_self', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'next-hop-self-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_ipv6_addr_password_delete(self, neighbor_ipv6_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'neighbor_ipv6_addr', 'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'password'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_ipv6_addr_peer_group_delete(self, neighbor_ipv6_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'neighbor_ipv6_addr', 'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'peer-group'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_ipv6_addr_remote_as_delete(self, neighbor_ipv6_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'neighbor_ipv6_addr', 'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'remote-as'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_ipv6_addr_remove_private_as_delete(self, neighbor_ipv6_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'neighbor_ipv6_addr', 'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'remove-private-as'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_ipv6_addr_shutdown_generate_rib_out_delete(self, neighbor_ipv6_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.shutdown', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'generate-rib-out'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_ipv6_addr_shutdown_shutdown_status_delete(self, neighbor_ipv6_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.shutdown', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'shutdown-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_ipv6_addr_soft_reconfiguration_inbound_delete(self, neighbor_ipv6_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.soft_reconfiguration', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'inbound'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_ipv6_addr_static_network_edge_delete(self, neighbor_ipv6_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'neighbor_ipv6_addr', 'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'static-network-edge'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_ipv6_addr_timers_hold_time_delete(self, neighbor_ipv6_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.timers', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hold-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_ipv6_addr_timers_keep_alive_delete(self, neighbor_ipv6_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.timers', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'keep-alive'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_ipv6_addr_update_source_ethernet_interface_delete(self, neighbor_ipv6_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source.ethernet_interface', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'interface_type, interface_name'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source.ethernet_interface': [u'interface_type']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_ipv6_addr_update_source_interface_name_delete(self, neighbor_ipv6_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source.ethernet_interface', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'interface-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_ipv6_addr_update_source_interface_type_delete(self, neighbor_ipv6_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source.ethernet_interface', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'interface-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_ipv6_addr_update_source_loopback_delete(self, neighbor_ipv6_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'loopback'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_ipv6_addr_update_source_sip_ipv6_address_delete(self, neighbor_ipv6_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'sip-ipv6-address'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_ipv6_addr_update_source_ve_interface_delete(self, neighbor_ipv6_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 've-interface'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_peer_grp_advertisement_interval_delete(self, neighbor_peer_grp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.advertisement_interval', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'value'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_peer_grp_advertisement_interval_value_delete(self, neighbor_peer_grp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.advertisement_interval', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'value'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_peer_grp_as_override_delete(self, neighbor_peer_grp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'neighbor_peer_grp', 'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'as-override'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_peer_grp_bfd_bfd_enable_delete(self, neighbor_peer_grp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.bfd', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bfd-enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_peer_grp_bfd_holdover_interval_delete(self, neighbor_peer_grp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.bfd', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'holdover-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_peer_grp_bfd_interval_delete(self, neighbor_peer_grp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.bfd.interval', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_peer_grp_bfd_interval_min_rx_delete(self, neighbor_peer_grp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.bfd.interval', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'min-rx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_peer_grp_bfd_interval_min_tx_delete(self, neighbor_peer_grp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.bfd.interval', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'min-tx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_peer_grp_bfd_interval_multiplier_delete(self, neighbor_peer_grp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.bfd.interval', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'multiplier'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_peer_grp_capability_as4_disable_delete(self, neighbor_peer_grp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.af_neighbor_capability.as4', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'disable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_peer_grp_capability_as4_enable_delete(self, neighbor_peer_grp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.af_neighbor_capability.as4', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_peer_grp_description_delete(self, neighbor_peer_grp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'neighbor_peer_grp', 'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'description'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_peer_grp_ebgp_btsh_delete(self, neighbor_peer_grp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'neighbor_peer_grp', 'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ebgp-btsh'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_peer_grp_ebgp_multihop_delete(self, neighbor_peer_grp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.ebgp_multihop', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.ebgp_multihop': [u'ebgp_multihop_flag', u'ebgp_multihop_count']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_peer_grp_ebgp_multihop_ebgp_multihop_count_delete(self, neighbor_peer_grp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.ebgp_multihop', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ebgp-multihop-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_peer_grp_ebgp_multihop_ebgp_multihop_flag_delete(self, neighbor_peer_grp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.ebgp_multihop', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ebgp-multihop-flag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_peer_grp_enforce_first_as_disable_delete(self, neighbor_peer_grp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.enforce_first_as', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'disable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_peer_grp_enforce_first_as_enable_delete(self, neighbor_peer_grp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.enforce_first_as', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_peer_grp_local_as_delete(self, neighbor_peer_grp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.local_as', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'local_as_value, no_prepend'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_peer_grp_local_as_local_as_value_delete(self, neighbor_peer_grp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.local_as', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'local-as-value'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_peer_grp_local_as_no_prepend_delete(self, neighbor_peer_grp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.local_as', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'no-prepend'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_peer_grp_maxas_limit_in_disable_delete(self, neighbor_peer_grp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.maxas_limit.in_', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'disable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_peer_grp_maxas_limit_in_num_as_in_as_path_delete(self, neighbor_peer_grp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.maxas_limit.in_', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'num-as-in-as-path'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_peer_grp_next_hop_self_always_delete(self, neighbor_peer_grp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.next_hop_self', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'always'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_peer_grp_next_hop_self_next_hop_self_status_delete(self, neighbor_peer_grp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.next_hop_self', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'next-hop-self-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_peer_grp_password_delete(self, neighbor_peer_grp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'neighbor_peer_grp', 'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'password'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_peer_grp_peer_group_delete(self, neighbor_peer_grp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'neighbor_peer_grp', 'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'peer-group'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_peer_grp_remote_as_delete(self, neighbor_peer_grp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'neighbor_peer_grp', 'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'remote-as'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_peer_grp_remove_private_as_delete(self, neighbor_peer_grp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'neighbor_peer_grp', 'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'remove-private-as'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_peer_grp_shutdown_generate_rib_out_delete(self, neighbor_peer_grp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.shutdown', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'generate-rib-out'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_peer_grp_shutdown_shutdown_status_delete(self, neighbor_peer_grp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.shutdown', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'shutdown-status'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_peer_grp_soft_reconfiguration_inbound_delete(self, neighbor_peer_grp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.soft_reconfiguration', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'inbound'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_peer_grp_static_network_edge_delete(self, neighbor_peer_grp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'neighbor_peer_grp', 'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'static-network-edge'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_peer_grp_timers_hold_time_delete(self, neighbor_peer_grp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.timers', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hold-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_peer_grp_timers_keep_alive_delete(self, neighbor_peer_grp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.timers', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'keep-alive'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_peer_grp_update_source_ethernet_interface_delete(self, neighbor_peer_grp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source.ethernet_interface', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'interface_type, interface_name'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source.ethernet_interface': [u'interface_type']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_peer_grp_update_source_interface_name_delete(self, neighbor_peer_grp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source.ethernet_interface', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'interface-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_peer_grp_update_source_interface_type_delete(self, neighbor_peer_grp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source.ethernet_interface', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'interface-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_peer_grp_update_source_loopback_delete(self, neighbor_peer_grp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'loopback'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_peer_grp_update_source_sip_ipv4_address_delete(self, neighbor_peer_grp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'sip-ipv4-address'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_neighbor_neighbor_peer_grp_update_source_ve_interface_delete(self, neighbor_peer_grp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 've-interface'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_router_bgp_attributes_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_timers_hold_time_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.timers', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hold-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_bgp_timers_keep_alive_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.router_bgp.router_bgp_attributes.timers', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'keep-alive'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_fabric_virtual_gateway_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.router.fabric_virtual_gateway', 'pybind.nos.v6_0_2c.brocade_common_def', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.router.fabric_virtual_gateway', 'pybind.nos.v7_0_1b.brocade_common_def', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.router.fabric_virtual_gateway', 'pybind.nos.v7_1_0.brocade_common_def', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.router.fabric_virtual_gateway', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_fabric_virtual_gateway_address_family_ipv4_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.router.fabric_virtual_gateway.address_family.ipv4', 'pybind.nos.v6_0_2c.brocade_common_def', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.router.fabric_virtual_gateway.address_family.ipv4', 'pybind.nos.v7_0_1b.brocade_common_def', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.router.fabric_virtual_gateway.address_family.ipv4', 'pybind.nos.v7_1_0.brocade_common_def', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.router.fabric_virtual_gateway.address_family.ipv4', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_fabric_virtual_gateway_address_family_ipv4_accept_unicast_arp_request_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.router.fabric_virtual_gateway.address_family.ipv4', 'pybind.nos.v6_0_2c.brocade_common_def', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.router.fabric_virtual_gateway.address_family.ipv4', 'pybind.nos.v7_0_1b.brocade_common_def', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.router.fabric_virtual_gateway.address_family.ipv4', 'pybind.nos.v7_1_0.brocade_common_def', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.router.fabric_virtual_gateway.address_family.ipv4', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'accept-unicast-arp-request'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_fabric_virtual_gateway_address_family_ipv4_enable_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.router.fabric_virtual_gateway.address_family.ipv4', 'pybind.nos.v6_0_2c.brocade_common_def', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.router.fabric_virtual_gateway.address_family.ipv4', 'pybind.nos.v7_0_1b.brocade_common_def', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.router.fabric_virtual_gateway.address_family.ipv4', 'pybind.nos.v7_1_0.brocade_common_def', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.router.fabric_virtual_gateway.address_family.ipv4', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_fabric_virtual_gateway_address_family_ipv4_gateway_mac_address_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.router.fabric_virtual_gateway.address_family.ipv4', 'pybind.nos.v6_0_2c.brocade_common_def', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.router.fabric_virtual_gateway.address_family.ipv4', 'pybind.nos.v7_0_1b.brocade_common_def', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.router.fabric_virtual_gateway.address_family.ipv4', 'pybind.nos.v7_1_0.brocade_common_def', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.router.fabric_virtual_gateway.address_family.ipv4', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'gateway-mac-address'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_fabric_virtual_gateway_address_family_ipv4_gratuitous_arp_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.router.fabric_virtual_gateway.address_family.ipv4.gratuitous_arp', 'pybind.nos.v6_0_2c.brocade_common_def', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.router.fabric_virtual_gateway.address_family.ipv4.gratuitous_arp', 'pybind.nos.v7_0_1b.brocade_common_def', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.router.fabric_virtual_gateway.address_family.ipv4.gratuitous_arp', 'pybind.nos.v7_1_0.brocade_common_def', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.router.fabric_virtual_gateway.address_family.ipv4.gratuitous_arp', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_fabric_virtual_gateway_address_family_ipv4_gratuitous_arp_timer_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.router.fabric_virtual_gateway.address_family.ipv4.gratuitous_arp', 'pybind.nos.v6_0_2c.brocade_common_def', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.router.fabric_virtual_gateway.address_family.ipv4.gratuitous_arp', 'pybind.nos.v7_0_1b.brocade_common_def', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.router.fabric_virtual_gateway.address_family.ipv4.gratuitous_arp', 'pybind.nos.v7_1_0.brocade_common_def', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.router.fabric_virtual_gateway.address_family.ipv4.gratuitous_arp', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'timer'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_fabric_virtual_gateway_address_family_ipv6_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.router.fabric_virtual_gateway.address_family.ipv6', 'pybind.nos.v6_0_2c.brocade_common_def', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.router.fabric_virtual_gateway.address_family.ipv6', 'pybind.nos.v7_0_1b.brocade_common_def', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.router.fabric_virtual_gateway.address_family.ipv6', 'pybind.nos.v7_1_0.brocade_common_def', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.router.fabric_virtual_gateway.address_family.ipv6', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_fabric_virtual_gateway_address_family_ipv6_enable_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.router.fabric_virtual_gateway.address_family.ipv6', 'pybind.nos.v6_0_2c.brocade_common_def', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.router.fabric_virtual_gateway.address_family.ipv6', 'pybind.nos.v7_0_1b.brocade_common_def', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.router.fabric_virtual_gateway.address_family.ipv6', 'pybind.nos.v7_1_0.brocade_common_def', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.router.fabric_virtual_gateway.address_family.ipv6', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_fabric_virtual_gateway_address_family_ipv6_gateway_mac_address_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.router.fabric_virtual_gateway.address_family.ipv6', 'pybind.nos.v6_0_2c.brocade_common_def', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.router.fabric_virtual_gateway.address_family.ipv6', 'pybind.nos.v7_0_1b.brocade_common_def', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.router.fabric_virtual_gateway.address_family.ipv6', 'pybind.nos.v7_1_0.brocade_common_def', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.router.fabric_virtual_gateway.address_family.ipv6', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'gateway-mac-address'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_fabric_virtual_gateway_address_family_ipv6_gratuitous_arp_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.router.fabric_virtual_gateway.address_family.ipv6.gratuitous_arp', 'pybind.nos.v6_0_2c.brocade_common_def', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.router.fabric_virtual_gateway.address_family.ipv6.gratuitous_arp', 'pybind.nos.v7_0_1b.brocade_common_def', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.router.fabric_virtual_gateway.address_family.ipv6.gratuitous_arp', 'pybind.nos.v7_1_0.brocade_common_def', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.router.fabric_virtual_gateway.address_family.ipv6.gratuitous_arp', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_fabric_virtual_gateway_address_family_ipv6_gratuitous_arp_timer_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.router.fabric_virtual_gateway.address_family.ipv6.gratuitous_arp', 'pybind.nos.v6_0_2c.brocade_common_def', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.router.fabric_virtual_gateway.address_family.ipv6.gratuitous_arp', 'pybind.nos.v7_0_1b.brocade_common_def', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.router.fabric_virtual_gateway.address_family.ipv6.gratuitous_arp', 'pybind.nos.v7_1_0.brocade_common_def', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.router.fabric_virtual_gateway.address_family.ipv6.gratuitous_arp', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'timer'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_hide_pim_holder_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.hide_pim_holder', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv4_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_af_common_attributes_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_af_ipv4_attributes_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_default_information_originate_default_information_originate_cr_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.default_information_originate', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'default-information-originate-cr'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_default_information_originate_route_map_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.default_information_originate', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_default_link_metric_level_1_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.default_link_metric', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'level-1'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_default_link_metric_level_2_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.default_link_metric', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'level-2'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_default_metric_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'default-metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_distance_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'distance'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_ldp_sync_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.ldp_sync', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_ldp_sync_hold_down_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.ldp_sync', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hold-down'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_maximum_paths_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'maximum-paths'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_metric_style_wide_level_1_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.metric_style.wide', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'level-1'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_metric_style_wide_level_2_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.metric_style.wide', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'level-2'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_redistribute_bgp_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.bgp', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.bgp': [u'bgp_level2', u'bgp_level1', u'bgp_level12']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_redistribute_bgp_level_1_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.bgp', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'level-1'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_redistribute_bgp_level_1_2_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.bgp', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'level-1-2'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_redistribute_bgp_level_2_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.bgp', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'level-2'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_redistribute_bgp_metric_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.bgp', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_redistribute_bgp_metric_type_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.bgp', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_redistribute_bgp_route_map_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.bgp', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_redistribute_connected_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.connected', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.connected': [u'connected_level12', u'connected_level2', u'connected_level1']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_redistribute_connected_level_1_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.connected', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'level-1'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_redistribute_connected_level_1_2_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.connected', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'level-1-2'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_redistribute_connected_level_2_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.connected', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'level-2'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_redistribute_connected_metric_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.connected', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_redistribute_connected_metric_type_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.connected', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_redistribute_connected_route_map_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.connected', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_redistribute_isis_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_redistribute_isis_level_1_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_1', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_redistribute_isis_level_1_into_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_1.into', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_redistribute_isis_level_1_into_level_2_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_1.into.level1_into_level2', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_1.into.level1_into_level2': [u'level1_into_level2_disable', u'prefix_list_level1']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_redistribute_isis_level_1_into_level_2_disable_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_1.into.level1_into_level2', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'disable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_redistribute_isis_level_1_into_level_2_prefix_list_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_1.into.level1_into_level2', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'prefix-list'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_redistribute_isis_level_2_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_2', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_redistribute_isis_level_2_into_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_2.into', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_redistribute_isis_level_2_into_level_1_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_2.into.level2_into_level1', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_redistribute_isis_level_2_into_level_1_prefix_list_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_2.into.level2_into_level1', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'prefix-list'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_redistribute_ospf_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf': [u'ospf_level2', u'ospf_level12', u'ospf_level1']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_redistribute_ospf_level_1_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'level-1'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_redistribute_ospf_level_1_2_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'level-1-2'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_redistribute_ospf_level_2_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'level-2'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_redistribute_ospf_match_external1_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf.match', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'external1'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_redistribute_ospf_match_external2_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf.match', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'external2'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_redistribute_ospf_match_internal_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf.match', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'internal'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_redistribute_ospf_metric_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_redistribute_ospf_metric_type_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_redistribute_ospf_route_map_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_redistribute_static_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.static', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.static': [u'static_level2', u'static_level12', u'static_level1']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_redistribute_static_level_1_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.static', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'level-1'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_redistribute_static_level_1_2_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.static', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'level-1-2'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_redistribute_static_level_2_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.static', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'level-2'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_redistribute_static_metric_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.static', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_redistribute_static_metric_type_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.static', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_redistribute_static_route_map_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.static', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_summary_address_delete(self, summary_address=None, summary_ip_level1=None, summary_ip_level2=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type summary_address: summary_ip, summary_ip_mask, summary_ip_level1, summary_ip_level2
    :param summary_address: Keyword argument tuple.

    :type summary_ip: unicode
    :param summary_ip: **summary_address** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type summary_ip_mask: unicode
    :param summary_ip_mask: **summary_address** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type summary_ip_level1: YANGBool
    :param summary_ip_level1: **summary_address** tuple argument:  For Level-1

    :type summary_ip_level2: YANGBool
    :param summary_ip_level2: **summary_address** tuple argument:  For Level-2

    **Instance Argument(s)**:

    :type summary_ip_level1: YANGBool
    :param summary_ip_level1: For Level-1

    :type summary_ip_level2: YANGBool
    :param summary_ip_level2: For Level-2

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.summary_address', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'summary_address', 'keyval': 'summary_ip, summary_ip_mask', 'extra_keyval': 'summary_ip, summary_ip_mask, summary_ip_level1, summary_ip_level2'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, summary_address=summary_address, summary_ip_level1=summary_ip_level1, summary_ip_level2=summary_ip_level2)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, summary_address=summary_address, summary_ip_level1=summary_ip_level1, summary_ip_level2=summary_ip_level2)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv6_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_af_common_attributes_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_af_ipv6_attributes_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_default_information_originate_default_information_originate_cr_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.default_information_originate', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'default-information-originate-cr'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_default_information_originate_route_map_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.default_information_originate', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_default_link_metric_level_1_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.ipv6_default_link_metric', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'level-1'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_default_link_metric_level_2_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.ipv6_default_link_metric', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'level-2'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_default_metric_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'default-metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_disable_adjacency_check_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'disable-adjacency-check'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_distance_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'distance'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_maximum_paths_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'maximum-paths'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_multi_topology_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.multi_topology', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_multi_topology_transition_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.multi_topology', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'transition'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_partial_spf_interval_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.partial6_spf_interval', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'pspf6_max_hold_time, pspf6_init_delay, pspf6_hold_time'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_partial_spf_interval_pspf_hold_time_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.partial6_spf_interval', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'pspf-hold-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_partial_spf_interval_pspf_init_delay_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.partial6_spf_interval', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'pspf-init-delay'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_partial_spf_interval_pspf_max_hold_time_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.partial6_spf_interval', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'pspf-max-hold-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_redistribute_bgp_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.bgp', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.bgp': [u'bgp_level2', u'bgp_level1', u'bgp_level12']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_redistribute_bgp_level_1_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.bgp', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'level-1'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_redistribute_bgp_level_1_2_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.bgp', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'level-1-2'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_redistribute_bgp_level_2_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.bgp', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'level-2'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_redistribute_bgp_metric_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.bgp', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_redistribute_bgp_metric_type_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.bgp', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_redistribute_bgp_route_map_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.bgp', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_redistribute_connected_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.connected', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.connected': [u'connected_level12', u'connected_level2', u'connected_level1']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_redistribute_connected_level_1_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.connected', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'level-1'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_redistribute_connected_level_1_2_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.connected', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'level-1-2'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_redistribute_connected_level_2_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.connected', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'level-2'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_redistribute_connected_metric_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.connected', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_redistribute_connected_metric_type_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.connected', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_redistribute_connected_route_map_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.connected', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_redistribute_isis_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_redistribute_isis_level_1_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_1', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_redistribute_isis_level_1_into_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_1.into', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_redistribute_isis_level_1_into_level_2_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_1.into.level1_into_level2', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_1.into.level1_into_level2': [u'level1_into_level2_disable', u'prefix_list_level1']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_redistribute_isis_level_1_into_level_2_disable_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_1.into.level1_into_level2', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'disable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_redistribute_isis_level_1_into_level_2_prefix_list_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_1.into.level1_into_level2', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'prefix-list'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_redistribute_isis_level_2_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_2', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_redistribute_isis_level_2_into_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_2.into', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_redistribute_isis_level_2_into_level_1_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_2.into.level2_into_level1', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_redistribute_isis_level_2_into_level_1_prefix_list_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_2.into.level2_into_level1', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'prefix-list'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_redistribute_ospf_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf': [u'ospf_level2', u'ospf_level12', u'ospf_level1']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_redistribute_ospf_level_1_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'level-1'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_redistribute_ospf_level_1_2_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'level-1-2'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_redistribute_ospf_level_2_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'level-2'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_redistribute_ospf_match_external1_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf.match', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'external1'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_redistribute_ospf_match_external2_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf.match', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'external2'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_redistribute_ospf_match_internal_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf.match', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'internal'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_redistribute_ospf_metric_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_redistribute_ospf_metric_type_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_redistribute_ospf_route_map_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_redistribute_static_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.static', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.static': [u'static_level2', u'static_level12', u'static_level1']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_redistribute_static_level_1_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.static', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'level-1'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_redistribute_static_level_1_2_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.static', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'level-1-2'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_redistribute_static_level_2_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.static', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'level-2'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_redistribute_static_metric_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.static', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_redistribute_static_metric_type_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.static', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_redistribute_static_route_map_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.static', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_spf_interval_delete(self, spf6_interval=None, spf6_interval_max_hold_time=None, spf6_interval_initial_delay=None, spf6_interval_hold_time=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type spf6_interval: spf6_interval_level, spf6_interval_max_hold_time, spf6_interval_initial_delay, spf6_interval_hold_time
    :param spf6_interval: Keyword argument tuple.

    :type spf6_interval_level: unicode
    :param spf6_interval_level: **spf6_interval** tuple argument.

        * enumeration restriction: ::

            ['level-2', 'level-1']

    :type spf6_interval_max_hold_time: long
    :param spf6_interval_max_hold_time: **spf6_interval** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type spf6_interval_initial_delay: long
    :param spf6_interval_initial_delay: **spf6_interval** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type spf6_interval_hold_time: long
    :param spf6_interval_hold_time: **spf6_interval** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Argument(s)**:

    :type spf6_interval_max_hold_time: long
    :param spf6_interval_max_hold_time: Keyword argument.

        * range restriction: ::

            ['0..4294967295']

    :type spf6_interval_initial_delay: long
    :param spf6_interval_initial_delay: Keyword argument.

        * range restriction: ::

            ['0..4294967295']

    :type spf6_interval_hold_time: long
    :param spf6_interval_hold_time: Keyword argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.spf6_interval', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'spf6_interval', 'keyval': 'spf6_interval_level', 'extra_keyval': 'spf6_interval_level, spf6_interval_max_hold_time, spf6_interval_initial_delay, spf6_interval_hold_time'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, spf6_interval=spf6_interval, spf6_interval_max_hold_time=spf6_interval_max_hold_time, spf6_interval_initial_delay=spf6_interval_initial_delay, spf6_interval_hold_time=spf6_interval_hold_time)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, spf6_interval=spf6_interval, spf6_interval_max_hold_time=spf6_interval_max_hold_time, spf6_interval_initial_delay=spf6_interval_initial_delay, spf6_interval_hold_time=spf6_interval_hold_time)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_spf_interval_spf6_interval_hold_time_delete(self, spf6_interval=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type spf6_interval: spf6_interval_level
    :param spf6_interval: Keyword argument tuple.

    :type spf6_interval_level: unicode
    :param spf6_interval_level: **spf6_interval** tuple argument.

        * enumeration restriction: ::

            ['level-2', 'level-1']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.spf6_interval', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'spf6_interval', 'keyval': 'spf6_interval_level', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'spf6-interval-hold-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, spf6_interval=spf6_interval)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, spf6_interval=spf6_interval)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_spf_interval_spf6_interval_initial_delay_delete(self, spf6_interval=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type spf6_interval: spf6_interval_level
    :param spf6_interval: Keyword argument tuple.

    :type spf6_interval_level: unicode
    :param spf6_interval_level: **spf6_interval** tuple argument.

        * enumeration restriction: ::

            ['level-2', 'level-1']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.spf6_interval', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'spf6_interval', 'keyval': 'spf6_interval_level', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'spf6-interval-initial-delay'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, spf6_interval=spf6_interval)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, spf6_interval=spf6_interval)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_spf_interval_spf6_interval_max_hold_time_delete(self, spf6_interval=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type spf6_interval: spf6_interval_level
    :param spf6_interval: Keyword argument tuple.

    :type spf6_interval_level: unicode
    :param spf6_interval_level: **spf6_interval** tuple argument.

        * enumeration restriction: ::

            ['level-2', 'level-1']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.spf6_interval', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'spf6_interval', 'keyval': 'spf6_interval_level', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'spf6-interval-max-hold-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, spf6_interval=spf6_interval)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, spf6_interval=spf6_interval)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_summary_prefix_delete(self, summary_prefix=None, summary_prefix_level1=None, summary_prefix_level2=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type summary_prefix: summary_prefix_ipv6
    :param summary_prefix: Keyword argument tuple.

    :type summary_prefix_ipv6: unicode
    :param summary_prefix_ipv6: **summary_prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    **Instance Argument(s)**:

    :type summary_prefix_level1: YANGBool
    :param summary_prefix_level1: For Level-1

    :type summary_prefix_level2: YANGBool
    :param summary_prefix_level2: For Level-2

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.summary_prefix', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'summary_prefix', 'keyval': 'summary_prefix_ipv6', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, summary_prefix=summary_prefix, summary_prefix_level1=summary_prefix_level1, summary_prefix_level2=summary_prefix_level2)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, summary_prefix=summary_prefix, summary_prefix_level1=summary_prefix_level1, summary_prefix_level2=summary_prefix_level2)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_summary_prefix_level_1_delete(self, summary_prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type summary_prefix: summary_prefix_ipv6
    :param summary_prefix: Keyword argument tuple.

    :type summary_prefix_ipv6: unicode
    :param summary_prefix_ipv6: **summary_prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.summary_prefix', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'summary_prefix', 'keyval': 'summary_prefix_ipv6', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'Level-1'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, summary_prefix=summary_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, summary_prefix=summary_prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_summary_prefix_level_2_delete(self, summary_prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type summary_prefix: summary_prefix_ipv6
    :param summary_prefix: Keyword argument tuple.

    :type summary_prefix_ipv6: unicode
    :param summary_prefix_ipv6: **summary_prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.summary_prefix', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'summary_prefix', 'keyval': 'summary_prefix_ipv6', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'Level-2'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, summary_prefix=summary_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, summary_prefix=summary_prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_auth_check_level_1_disable_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check.auth_check_level1', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'disable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_auth_check_level_2_disable_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check.auth_check_level2', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'disable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_auth_key_level_1_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_key', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'level-1'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_auth_key_level_2_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_key', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'level-2'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_auth_mode_md5_level_1_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_mode.md5', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'level-1'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_auth_mode_md5_level_2_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_mode.md5', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'level-2'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_bfd_all_interfaces_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.bfd', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'all-interfaces'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_csnp_interval_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'csnp-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_disable_inc_stct_spf_opt_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'disable-inc-stct-spf-opt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_disable_incremental_spf_opt_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'disable-incremental-spf-opt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_disable_partial_spf_opt_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'disable-partial-spf-opt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_fast_flood_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.fast_flood', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'fast_flood_value'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_fast_flood_fast_flood_value_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.fast_flood', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'fast-flood-value'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_graceful_restart_helper_disable_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.graceful_restart', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'helper-disable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_hello_padding_disable_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello.padding', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'disable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_hello_padding_point_to_point_disable_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello.padding.hello_padding_point_to_point', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'disable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_hostname_disable_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hostname', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'disable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_is_type_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'is-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_log_adjacency_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.log', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'adjacency'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_log_invalid_lsp_packets_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.log', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'invalid-lsp-packets'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_lsp_gen_interval_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lsp-gen-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_lsp_interval_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lsp-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_lsp_refresh_interval_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lsp-refresh-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_max_lsp_lifetime_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'max-lsp-lifetime'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_net_delete(self, net=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type net: net_cmd
    :param net: Keyword argument tuple.

    :type net_cmd: unicode
    :param net_cmd: **net** tuple argument.

        * pattern restriction: ::

            '([0-9a-fA-F]{2}((\.[0-9a-fA-F]{4}){3,9})\.00)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.net', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'net', 'keyval': 'net_cmd', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, net=net)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, net=net)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_nonstop_routing_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'nonstop-routing'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_partial_spf_interval_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.partial_spf_interval', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'pspf_max_hold_time, pspf_init_delay, pspf_hold_time'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_partial_spf_interval_pspf_hold_time_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.partial_spf_interval', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'pspf-hold-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_partial_spf_interval_pspf_init_delay_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.partial_spf_interval', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'pspf-init-delay'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_partial_spf_interval_pspf_max_hold_time_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.partial_spf_interval', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'pspf-max-hold-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_retransmit_interval_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'retransmit-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_reverse_metric_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_reverse_metric_rev_metric_common_attributes_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric.rev_metric_common_attributes', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_reverse_metric_rev_metric_val_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric.rev_metric_common_attributes', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rev-metric-val'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_reverse_metric_reverse_metric_tlv_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric.reverse_metric_tlv', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_reverse_metric_te_def_metric_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric.rev_metric_common_attributes', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'te-def-metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_reverse_metric_tlv_type_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric.reverse_metric_tlv', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tlv-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_reverse_metric_whole_lan_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric.rev_metric_common_attributes', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'whole-lan'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_router_isis_attributes_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_router_isis_cmds_holder_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_set_debug_nsr_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_debug', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'nsr'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_set_overload_bit_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_set_overload_bit_on_startup_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit.on_startup', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit.on_startup': [u'wait_for_bgp', u'on_startup_overloadtime']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_set_overload_bit_on_startup_on_startup_overloadtime_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit.on_startup', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'on-startup-overloadtime'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_set_overload_bit_on_startup_wait_for_bgp_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit.on_startup.wait_for_bgp', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit.on_startup.wait_for_bgp': [u'wait_for_bgp_value']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_set_overload_bit_on_startup_wait_for_bgp_wait_for_bgp_value_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit.on_startup.wait_for_bgp', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'wait-for-bgp-value'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_spf_interval_delete(self, spf_interval=None, spf_interval_max_hold_time=None, spf_interval_initial_delay=None, spf_interval_hold_time=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type spf_interval: spf_interval_level, spf_interval_max_hold_time, spf_interval_initial_delay, spf_interval_hold_time
    :param spf_interval: Keyword argument tuple.

    :type spf_interval_level: unicode
    :param spf_interval_level: **spf_interval** tuple argument.

        * enumeration restriction: ::

            ['level-2', 'level-1']

    :type spf_interval_max_hold_time: long
    :param spf_interval_max_hold_time: **spf_interval** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type spf_interval_initial_delay: long
    :param spf_interval_initial_delay: **spf_interval** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type spf_interval_hold_time: long
    :param spf_interval_hold_time: **spf_interval** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Argument(s)**:

    :type spf_interval_max_hold_time: long
    :param spf_interval_max_hold_time: Keyword argument.

        * range restriction: ::

            ['0..4294967295']

    :type spf_interval_initial_delay: long
    :param spf_interval_initial_delay: Keyword argument.

        * range restriction: ::

            ['0..4294967295']

    :type spf_interval_hold_time: long
    :param spf_interval_hold_time: Keyword argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.spf_interval', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'spf_interval', 'keyval': 'spf_interval_level', 'extra_keyval': 'spf_interval_level, spf_interval_max_hold_time, spf_interval_initial_delay, spf_interval_hold_time'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, spf_interval=spf_interval, spf_interval_max_hold_time=spf_interval_max_hold_time, spf_interval_initial_delay=spf_interval_initial_delay, spf_interval_hold_time=spf_interval_hold_time)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, spf_interval=spf_interval, spf_interval_max_hold_time=spf_interval_max_hold_time, spf_interval_initial_delay=spf_interval_initial_delay, spf_interval_hold_time=spf_interval_hold_time)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_spf_interval_spf_interval_hold_time_delete(self, spf_interval=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type spf_interval: spf_interval_level
    :param spf_interval: Keyword argument tuple.

    :type spf_interval_level: unicode
    :param spf_interval_level: **spf_interval** tuple argument.

        * enumeration restriction: ::

            ['level-2', 'level-1']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.spf_interval', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'spf_interval', 'keyval': 'spf_interval_level', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'spf-interval-hold-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, spf_interval=spf_interval)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, spf_interval=spf_interval)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_spf_interval_spf_interval_initial_delay_delete(self, spf_interval=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type spf_interval: spf_interval_level
    :param spf_interval: Keyword argument tuple.

    :type spf_interval_level: unicode
    :param spf_interval_level: **spf_interval** tuple argument.

        * enumeration restriction: ::

            ['level-2', 'level-1']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.spf_interval', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'spf_interval', 'keyval': 'spf_interval_level', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'spf-interval-initial-delay'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, spf_interval=spf_interval)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, spf_interval=spf_interval)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_isis_spf_interval_spf_interval_max_hold_time_delete(self, spf_interval=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type spf_interval: spf_interval_level
    :param spf_interval: Keyword argument tuple.

    :type spf_interval_level: unicode
    :param spf_interval_level: **spf_interval** tuple argument.

        * enumeration restriction: ::

            ['level-2', 'level-1']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.spf_interval', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'spf_interval', 'keyval': 'spf_interval_level', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'spf-interval-max-hold-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, spf_interval=spf_interval)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, spf_interval=spf_interval)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_autobw_template_delete(self, autobw_template=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type autobw_template: autobw_template_name
    :param autobw_template: Keyword argument tuple.

    :type autobw_template_name: unicode
    :param autobw_template_name: **autobw_template** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.autobw_template', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'autobw_template', 'keyval': 'autobw_template_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, autobw_template=autobw_template)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, autobw_template=autobw_template)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_autobw_template_adjustment_interval_delete(self, autobw_template=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type autobw_template: autobw_template_name
    :param autobw_template: Keyword argument tuple.

    :type autobw_template_name: unicode
    :param autobw_template_name: **autobw_template** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.autobw_template', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'autobw_template', 'keyval': 'autobw_template_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'adjustment-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, autobw_template=autobw_template)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, autobw_template=autobw_template)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_autobw_template_adjustment_threshold_delete(self, autobw_template=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type autobw_template: autobw_template_name
    :param autobw_template: Keyword argument tuple.

    :type autobw_template_name: unicode
    :param autobw_template_name: **autobw_template** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.autobw_template', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'autobw_template', 'keyval': 'autobw_template_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'adjustment-threshold'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, autobw_template=autobw_template)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, autobw_template=autobw_template)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_autobw_template_max_bandwidth_delete(self, autobw_template=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type autobw_template: autobw_template_name
    :param autobw_template: Keyword argument tuple.

    :type autobw_template_name: unicode
    :param autobw_template_name: **autobw_template** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.autobw_template', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'autobw_template', 'keyval': 'autobw_template_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'max-bandwidth'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, autobw_template=autobw_template)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, autobw_template=autobw_template)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_autobw_template_min_bandwidth_delete(self, autobw_template=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type autobw_template: autobw_template_name
    :param autobw_template: Keyword argument tuple.

    :type autobw_template_name: unicode
    :param autobw_template_name: **autobw_template** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.autobw_template', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'autobw_template', 'keyval': 'autobw_template_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'min-bandwidth'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, autobw_template=autobw_template)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, autobw_template=autobw_template)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_autobw_template_mode_delete(self, autobw_template=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type autobw_template: autobw_template_name
    :param autobw_template: Keyword argument tuple.

    :type autobw_template_name: unicode
    :param autobw_template_name: **autobw_template** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.autobw_template', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'autobw_template', 'keyval': 'autobw_template_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mode'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, autobw_template=autobw_template)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, autobw_template=autobw_template)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_autobw_template_overflow_limit_delete(self, autobw_template=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type autobw_template: autobw_template_name
    :param autobw_template: Keyword argument tuple.

    :type autobw_template_name: unicode
    :param autobw_template_name: **autobw_template** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.autobw_template', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'autobw_template', 'keyval': 'autobw_template_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'overflow-limit'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, autobw_template=autobw_template)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, autobw_template=autobw_template)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_autobw_template_sample_recording_delete(self, autobw_template=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type autobw_template: autobw_template_name
    :param autobw_template: Keyword argument tuple.

    :type autobw_template_name: unicode
    :param autobw_template_name: **autobw_template** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.autobw_template', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'autobw_template', 'keyval': 'autobw_template_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'sample-recording'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, autobw_template=autobw_template)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, autobw_template=autobw_template)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_autobw_template_underflow_limit_delete(self, autobw_template=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type autobw_template: autobw_template_name
    :param autobw_template: Keyword argument tuple.

    :type autobw_template_name: unicode
    :param autobw_template_name: **autobw_template** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.autobw_template', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'autobw_template', 'keyval': 'autobw_template_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'underflow-limit'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, autobw_template=autobw_template)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, autobw_template=autobw_template)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_autobw_threshold_table_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.autobw_threshold_table', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_autobw_threshold_table_bandwidth_delete(self, autobw_threshold_table_bandwidth=None, autobw_threshold_table_threshold=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type autobw_threshold_table_bandwidth: bandwidth_value, autobw_threshold_table_threshold
    :param autobw_threshold_table_bandwidth: Keyword argument tuple.

    :type bandwidth_value: long
    :param bandwidth_value: **autobw_threshold_table_bandwidth** tuple argument:  DECIMAL;;Bandwidth upto which threshold will apply

        * range restriction: ::

            ['0..4294967295']

    :type autobw_threshold_table_threshold: long
    :param autobw_threshold_table_threshold: **autobw_threshold_table_bandwidth** tuple argument:  DECIMAL;;Absolute threshold value for the bandwidth

        * range restriction: ::

            ['0..4294967295']

    **Instance Argument(s)**:

    :type autobw_threshold_table_threshold: long
    :param autobw_threshold_table_threshold: DECIMAL;;Absolute threshold value for the bandwidth

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.autobw_threshold_table.autobw_threshold_table_bandwidth', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'autobw_threshold_table_bandwidth', 'keyval': 'bandwidth_value', 'extra_keyval': 'bandwidth_value, autobw_threshold_table_threshold'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, autobw_threshold_table_bandwidth=autobw_threshold_table_bandwidth, autobw_threshold_table_threshold=autobw_threshold_table_threshold)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, autobw_threshold_table_bandwidth=autobw_threshold_table_bandwidth, autobw_threshold_table_threshold=autobw_threshold_table_threshold)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_autobw_threshold_table_bandwidth_threshold_delete(self, autobw_threshold_table_bandwidth=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type autobw_threshold_table_bandwidth: bandwidth_value
    :param autobw_threshold_table_bandwidth: Keyword argument tuple.

    :type bandwidth_value: long
    :param bandwidth_value: **autobw_threshold_table_bandwidth** tuple argument:  DECIMAL;;Bandwidth upto which threshold will apply

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.autobw_threshold_table.autobw_threshold_table_bandwidth', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'autobw_threshold_table_bandwidth', 'keyval': 'bandwidth_value', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'threshold'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, autobw_threshold_table_bandwidth=autobw_threshold_table_bandwidth)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, autobw_threshold_table_bandwidth=autobw_threshold_table_bandwidth)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_autobw_threshold_table_max_bw_threshold_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.autobw_threshold_table.max_bw_threshold', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.autobw_threshold_table.max_bw_threshold': [u'max_bw_threshold_percentage', u'max_bw_threshold_absolute']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_autobw_threshold_table_max_bw_threshold_absolute_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.autobw_threshold_table.max_bw_threshold', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'absolute'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_autobw_threshold_table_max_bw_threshold_percentage_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.autobw_threshold_table.max_bw_threshold', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'percentage'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_bfd_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.bfd', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_bfd_bfd_sub_cmds_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.bfd.bfd_sub_cmds', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_bfd_min_tx_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.bfd.bfd_sub_cmds.bfd_min_tx', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'bfd_min_tx_val, bfd_min_rx, bfd_multiplier'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_bypass_lsp_delete(self, bypass_lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type bypass_lsp: bypass_lsp_name
    :param bypass_lsp: Keyword argument tuple.

    :type bypass_lsp_name: unicode
    :param bypass_lsp_name: **bypass_lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'bypass_lsp', 'keyval': 'bypass_lsp_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bypass_lsp=bypass_lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bypass_lsp=bypass_lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_bypass_lsp_adaptive_delete(self, bypass_lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type bypass_lsp: bypass_lsp_name
    :param bypass_lsp: Keyword argument tuple.

    :type bypass_lsp_name: unicode
    :param bypass_lsp_name: **bypass_lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'bypass_lsp', 'keyval': 'bypass_lsp_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'adaptive'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bypass_lsp=bypass_lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bypass_lsp=bypass_lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_bypass_lsp_commit_delete(self, bypass_lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type bypass_lsp: bypass_lsp_name
    :param bypass_lsp: Keyword argument tuple.

    :type bypass_lsp_name: unicode
    :param bypass_lsp_name: **bypass_lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'bypass_lsp', 'keyval': 'bypass_lsp_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'commit'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bypass_lsp=bypass_lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bypass_lsp=bypass_lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_bypass_lsp_cos_delete(self, bypass_lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type bypass_lsp: bypass_lsp_name
    :param bypass_lsp: Keyword argument tuple.

    :type bypass_lsp_name: unicode
    :param bypass_lsp_name: **bypass_lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'bypass_lsp', 'keyval': 'bypass_lsp_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cos'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bypass_lsp=bypass_lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bypass_lsp=bypass_lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_bypass_lsp_cspf_computation_mode_delete(self, bypass_lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type bypass_lsp: bypass_lsp_name
    :param bypass_lsp: Keyword argument tuple.

    :type bypass_lsp_name: unicode
    :param bypass_lsp_name: **bypass_lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'bypass_lsp', 'keyval': 'bypass_lsp_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cspf-computation-mode'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bypass_lsp=bypass_lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bypass_lsp=bypass_lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_bypass_lsp_enable_delete(self, bypass_lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type bypass_lsp: bypass_lsp_name
    :param bypass_lsp: Keyword argument tuple.

    :type bypass_lsp_name: unicode
    :param bypass_lsp_name: **bypass_lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'bypass_lsp', 'keyval': 'bypass_lsp_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bypass_lsp=bypass_lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bypass_lsp=bypass_lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_bypass_lsp_exclude_interface_delete(self, bypass_lsp=None, exclude_interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bypass_lsp: bypass_lsp_name
    :param bypass_lsp: Keyword argument tuple.

    :type bypass_lsp_name: unicode
    :param bypass_lsp_name: **bypass_lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    **Instance Keyword Argument Tuple**:

    :type exclude_interface: bypass_exclude_interface_type, bypass_exclude_interface_name
    :param exclude_interface: Keyword argument tuple.

    :type bypass_exclude_interface_type: unicode
    :param bypass_exclude_interface_type: **exclude_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 've']

    :type bypass_exclude_interface_name: unicode
    :param bypass_exclude_interface_name: **exclude_interface** tuple argument:  The Interface value.

        * length restriction: ::

            ['1..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6])/([1-9]|[1-9][0-9]|[1-9][0-9]['
            '0-9])(:[1-4])?)|([0-9]([0-9])?([0-9])?([0-9])?))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'bypass_lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp.exclude_interface', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bypass_lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'exclude_interface', 'keyval': 'bypass_exclude_interface_type, bypass_exclude_interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bypass_lsp=bypass_lsp, exclude_interface=exclude_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bypass_lsp=bypass_lsp, exclude_interface=exclude_interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_bypass_lsp_from_delete(self, bypass_lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type bypass_lsp: bypass_lsp_name
    :param bypass_lsp: Keyword argument tuple.

    :type bypass_lsp_name: unicode
    :param bypass_lsp_name: **bypass_lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'bypass_lsp', 'keyval': 'bypass_lsp_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'from'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bypass_lsp=bypass_lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bypass_lsp=bypass_lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_bypass_lsp_hop_limit_delete(self, bypass_lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type bypass_lsp: bypass_lsp_name
    :param bypass_lsp: Keyword argument tuple.

    :type bypass_lsp_name: unicode
    :param bypass_lsp_name: **bypass_lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'bypass_lsp', 'keyval': 'bypass_lsp_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hop-limit'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bypass_lsp=bypass_lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bypass_lsp=bypass_lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_bypass_lsp_primary_path_delete(self, bypass_lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type bypass_lsp: bypass_lsp_name
    :param bypass_lsp: Keyword argument tuple.

    :type bypass_lsp_name: unicode
    :param bypass_lsp_name: **bypass_lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'bypass_lsp', 'keyval': 'bypass_lsp_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'primary-path'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bypass_lsp=bypass_lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bypass_lsp=bypass_lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_bypass_lsp_priority_lsp_hold_priority_delete(self, bypass_lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bypass_lsp: bypass_lsp_name
    :param bypass_lsp: Keyword argument tuple.

    :type bypass_lsp_name: unicode
    :param bypass_lsp_name: **bypass_lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'bypass_lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp.priority', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bypass_lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lsp-hold-priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bypass_lsp=bypass_lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bypass_lsp=bypass_lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_bypass_lsp_priority_lsp_setup_priority_delete(self, bypass_lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bypass_lsp: bypass_lsp_name
    :param bypass_lsp: Keyword argument tuple.

    :type bypass_lsp_name: unicode
    :param bypass_lsp_name: **bypass_lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'bypass_lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp.priority', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bypass_lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lsp-setup-priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bypass_lsp=bypass_lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bypass_lsp=bypass_lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_bypass_lsp_record_delete(self, bypass_lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type bypass_lsp: bypass_lsp_name
    :param bypass_lsp: Keyword argument tuple.

    :type bypass_lsp_name: unicode
    :param bypass_lsp_name: **bypass_lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'bypass_lsp', 'keyval': 'bypass_lsp_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'record'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bypass_lsp=bypass_lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bypass_lsp=bypass_lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_bypass_lsp_reoptimize_timer_delete(self, bypass_lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type bypass_lsp: bypass_lsp_name
    :param bypass_lsp: Keyword argument tuple.

    :type bypass_lsp_name: unicode
    :param bypass_lsp_name: **bypass_lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'bypass_lsp', 'keyval': 'bypass_lsp_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'reoptimize-timer'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bypass_lsp=bypass_lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bypass_lsp=bypass_lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_bypass_lsp_tie_breaking_delete(self, bypass_lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type bypass_lsp: bypass_lsp_name
    :param bypass_lsp: Keyword argument tuple.

    :type bypass_lsp_name: unicode
    :param bypass_lsp_name: **bypass_lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'bypass_lsp', 'keyval': 'bypass_lsp_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tie-breaking'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bypass_lsp=bypass_lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bypass_lsp=bypass_lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_bypass_lsp_to_delete(self, bypass_lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type bypass_lsp: bypass_lsp_name
    :param bypass_lsp: Keyword argument tuple.

    :type bypass_lsp_name: unicode
    :param bypass_lsp_name: **bypass_lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'bypass_lsp', 'keyval': 'bypass_lsp_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'to'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bypass_lsp=bypass_lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bypass_lsp=bypass_lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_bypass_lsp_traffic_engineering_max_burst_delete(self, bypass_lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bypass_lsp: bypass_lsp_name
    :param bypass_lsp: Keyword argument tuple.

    :type bypass_lsp_name: unicode
    :param bypass_lsp_name: **bypass_lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'bypass_lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp.lsp_traffic_engineering', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bypass_lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'max-burst'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bypass_lsp=bypass_lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bypass_lsp=bypass_lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_bypass_lsp_traffic_engineering_max_rate_delete(self, bypass_lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bypass_lsp: bypass_lsp_name
    :param bypass_lsp: Keyword argument tuple.

    :type bypass_lsp_name: unicode
    :param bypass_lsp_name: **bypass_lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'bypass_lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp.lsp_traffic_engineering', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bypass_lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'max-rate'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bypass_lsp=bypass_lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bypass_lsp=bypass_lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_bypass_lsp_traffic_engineering_mean_rate_delete(self, bypass_lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bypass_lsp: bypass_lsp_name
    :param bypass_lsp: Keyword argument tuple.

    :type bypass_lsp_name: unicode
    :param bypass_lsp_name: **bypass_lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'bypass_lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp.lsp_traffic_engineering', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bypass_lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mean-rate'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bypass_lsp=bypass_lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bypass_lsp=bypass_lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_cspf_group_delete(self, cspf_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type cspf_group: cspf_group_name
    :param cspf_group: Keyword argument tuple.

    :type cspf_group_name: unicode
    :param cspf_group_name: **cspf_group** tuple argument:  ASCII string;;Name (up to 128 characters)

        * length restriction: ::

            ['1..128']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.cspf_group', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'cspf_group', 'keyval': 'cspf_group_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cspf_group=cspf_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cspf_group=cspf_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_cspf_group_from_delete(self, cspf_group=None, cspf_group_ip=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cspf_group: cspf_group_name
    :param cspf_group: Keyword argument tuple.

    :type cspf_group_name: unicode
    :param cspf_group_name: **cspf_group** tuple argument:  ASCII string;;Name (up to 128 characters)

        * length restriction: ::

            ['1..128']

    **Instance Keyword Argument Tuple**:

    :type cspf_group_ip: cspf_group_ip_address
    :param cspf_group_ip: Keyword argument tuple.

    :type cspf_group_ip_address: unicode
    :param cspf_group_ip_address: **cspf_group_ip** tuple argument:  A.B.C.D;;ip address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.cspf_group', u'cspf_group')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.cspf_group.cspf_group_ip', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cspf_group_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'cspf_group_ip', 'keyval': 'cspf_group_ip_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cspf_group=cspf_group, cspf_group_ip=cspf_group_ip)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cspf_group=cspf_group, cspf_group_ip=cspf_group_ip)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_cspf_group_link_delete(self, cspf_group=None, cspf_group_link=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cspf_group: cspf_group_name
    :param cspf_group: Keyword argument tuple.

    :type cspf_group_name: unicode
    :param cspf_group_name: **cspf_group** tuple argument:  ASCII string;;Name (up to 128 characters)

        * length restriction: ::

            ['1..128']

    **Instance Keyword Argument Tuple**:

    :type cspf_group_link: cspf_group_link_from, cspf_group_link_to
    :param cspf_group_link: Keyword argument tuple.

    :type cspf_group_link_from: unicode
    :param cspf_group_link_from: **cspf_group_link** tuple argument:  A.B.C.D;;from ip address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type cspf_group_link_to: unicode
    :param cspf_group_link_to: **cspf_group_link** tuple argument:  A.B.C.D;;to ip address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.cspf_group', u'cspf_group')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.cspf_group.cspf_group_link', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cspf_group_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'cspf_group_link', 'keyval': 'cspf_group_link_from, cspf_group_link_to', 'extra_keyval': 'cspf_group_link_from, cspf_group_link_to'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cspf_group=cspf_group, cspf_group_link=cspf_group_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cspf_group=cspf_group, cspf_group_link=cspf_group_link)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_cspf_group_node_delete(self, cspf_group=None, cspf_group_node=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cspf_group: cspf_group_name
    :param cspf_group: Keyword argument tuple.

    :type cspf_group_name: unicode
    :param cspf_group_name: **cspf_group** tuple argument:  ASCII string;;Name (up to 128 characters)

        * length restriction: ::

            ['1..128']

    **Instance Keyword Argument Tuple**:

    :type cspf_group_node: cspf_group_node_ip
    :param cspf_group_node: Keyword argument tuple.

    :type cspf_group_node_ip: unicode
    :param cspf_group_node_ip: **cspf_group_node** tuple argument:  A.B.C.D;;node ip address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.cspf_group', u'cspf_group')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.cspf_group.cspf_group_node', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cspf_group_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'cspf_group_node', 'keyval': 'cspf_group_node_ip', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cspf_group=cspf_group, cspf_group_node=cspf_group_node)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cspf_group=cspf_group, cspf_group_node=cspf_group_node)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_cspf_group_penalty_delete(self, cspf_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cspf_group: cspf_group_name
    :param cspf_group: Keyword argument tuple.

    :type cspf_group_name: unicode
    :param cspf_group_name: **cspf_group** tuple argument:  ASCII string;;Name (up to 128 characters)

        * length restriction: ::

            ['1..128']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.cspf_group', u'cspf_group')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.cspf_group.cspf_group_penalty_n', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cspf_group_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'penalty'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cspf_group=cspf_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cspf_group=cspf_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_cspf_group_subnet_delete(self, cspf_group=None, cspf_group_subnet=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cspf_group: cspf_group_name
    :param cspf_group: Keyword argument tuple.

    :type cspf_group_name: unicode
    :param cspf_group_name: **cspf_group** tuple argument:  ASCII string;;Name (up to 128 characters)

        * length restriction: ::

            ['1..128']

    **Instance Keyword Argument Tuple**:

    :type cspf_group_subnet: cspf_group_subnet_ip
    :param cspf_group_subnet: Keyword argument tuple.

    :type cspf_group_subnet_ip: unicode
    :param cspf_group_subnet_ip: **cspf_group_subnet** tuple argument:  A.B.C.D/M;;Subnet address (with host part zero) in dotted decimal/Mask

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.cspf_group', u'cspf_group')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.cspf_group.cspf_group_subnet', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cspf_group_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'cspf_group_subnet', 'keyval': 'cspf_group_subnet_ip', 'extra_keyval': 'cspf_group_subnet_ip'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cspf_group=cspf_group, cspf_group_subnet=cspf_group_subnet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cspf_group=cspf_group, cspf_group_subnet=cspf_group_subnet)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_dynamic_bypass_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.dynamic_bypass', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_dynamic_bypass_disable_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.dynamic_bypass.mpls_dynamic_bypass_sub_cmds', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'disable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_dynamic_bypass_enable_all_interfaces_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.dynamic_bypass.mpls_dynamic_bypass_sub_cmds', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable-all-interfaces'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_dynamic_bypass_max_bypasses_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.dynamic_bypass.mpls_dynamic_bypass_sub_cmds', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'max-bypasses'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_dynamic_bypass_max_bypasses_per_mp_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.dynamic_bypass.mpls_dynamic_bypass_sub_cmds', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'max-bypasses-per-mp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_dynamic_bypass_mpls_dynamic_bypass_sub_cmds_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.dynamic_bypass.mpls_dynamic_bypass_sub_cmds', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_dynamic_bypass_reoptimize_timer_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.dynamic_bypass.mpls_dynamic_bypass_sub_cmds', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'reoptimize-timer'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_ldp_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.ldp', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_ldp_advertise_fec_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'advertise-fec'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_ldp_eol_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder.ldp_eol', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_ldp_eol_notification_timer_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder.ldp_eol', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'notification-timer'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_ldp_eol_tx_label_silence_timer_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder.ldp_eol', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tx-label-silence-timer'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_ldp_fec_128_for_auto_discovered_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'fec-128-for-auto-discovered'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_ldp_filter_fec_in_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'filter-fec-in'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_ldp_filter_fec_out_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'filter-fec-out'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_ldp_graceful_restart_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder.ldp_gr', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_ldp_graceful_restart_helper_only_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder.ldp_gr', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'helper-only'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_ldp_graceful_restart_max_neighbor_reconnect_time_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder.ldp_gr', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'max-neighbor-reconnect-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_ldp_graceful_restart_max_neighbor_recovery_time_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder.ldp_gr', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'max-neighbor-recovery-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_ldp_graceful_restart_reconnect_time_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder.ldp_gr', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'reconnect-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_ldp_graceful_restart_recovery_time_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder.ldp_gr', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'recovery-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_ldp_hello_interval_link_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hello-interval-link'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_ldp_hello_interval_target_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hello-interval-target'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_ldp_hello_timeout_link_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hello-timeout-link'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_ldp_hello_timeout_target_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hello-timeout-target'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_ldp_ka_int_count_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ka-int-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_ldp_ka_interval_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ka-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_ldp_ka_timeout_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ka-timeout'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_ldp_label_withdrawal_delay_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'label-withdrawal-delay'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_ldp_ldp_holder_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_ldp_ldp_startup_time_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ldp-startup-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_ldp_load_sharing_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'load-sharing'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_ldp_lsr_id_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lsr-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_ldp_rx_label_silence_timer_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rx-label-silence-timer'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_ldp_session_delete(self, ldp_session=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ldp_session: ldp_session_ip
    :param ldp_session: Keyword argument tuple.

    :type ldp_session_ip: unicode
    :param ldp_session_ip: **ldp_session** tuple argument:  Define LDP peer ip address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder.ldp_session', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_session', 'keyval': 'ldp_session_ip', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_ldp_session_filter_fec_out_delete(self, ldp_session=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ldp_session: ldp_session_ip
    :param ldp_session: Keyword argument tuple.

    :type ldp_session_ip: unicode
    :param ldp_session_ip: **ldp_session** tuple argument:  Define LDP peer ip address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder.ldp_session', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_session', 'keyval': 'ldp_session_ip', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'filter-fec-out'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_ldp_session_key_delete(self, ldp_session=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ldp_session: ldp_session_ip
    :param ldp_session: Keyword argument tuple.

    :type ldp_session_ip: unicode
    :param ldp_session_ip: **ldp_session** tuple argument:  Define LDP peer ip address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder.ldp_session', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_session', 'keyval': 'ldp_session_ip', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'key'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_ldp_targeted_peer_delete(self, ldp_targeted_peer=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ldp_targeted_peer: ldp_targeted_peer_ip
    :param ldp_targeted_peer: Keyword argument tuple.

    :type ldp_targeted_peer_ip: unicode
    :param ldp_targeted_peer_ip: **ldp_targeted_peer** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder.ldp_targeted_peer', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_targeted_peer', 'keyval': 'ldp_targeted_peer_ip', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_targeted_peer=ldp_targeted_peer)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_targeted_peer=ldp_targeted_peer)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_ldp_tunnel_metric_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tunnel-metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_lsp_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'lsp', 'keyval': 'lsp_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_lsp_adaptive_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'lsp', 'keyval': 'lsp_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'adaptive'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_lsp_autobw_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_auto_bandwidth', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_lsp_autobw_adjustment_interval_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_auto_bandwidth', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'adjustment-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_lsp_autobw_adjustment_threshold_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_auto_bandwidth', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'adjustment-threshold'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_lsp_autobw_max_bandwidth_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_auto_bandwidth', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'max-bandwidth'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_lsp_autobw_min_bandwidth_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_auto_bandwidth', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'min-bandwidth'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_lsp_autobw_mode_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_auto_bandwidth', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mode'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_lsp_autobw_overflow_limit_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_auto_bandwidth', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'overflow-limit'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_lsp_autobw_sample_recording_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_auto_bandwidth', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'sample-recording'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_lsp_autobw_template_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_auto_bandwidth', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'template'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_lsp_autobw_underflow_limit_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_auto_bandwidth', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'underflow-limit'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_lsp_commit_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'lsp', 'keyval': 'lsp_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'commit'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_lsp_cos_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'lsp', 'keyval': 'lsp_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cos'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_lsp_cspf_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'lsp', 'keyval': 'lsp_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cspf'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_lsp_cspf_computation_mode_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'lsp', 'keyval': 'lsp_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cspf-computation-mode'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_lsp_enable_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'lsp', 'keyval': 'lsp_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_lsp_from_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'lsp', 'keyval': 'lsp_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'from'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_lsp_frr_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_lsp_frr_bandwidth_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr.lsp_frr_bandwidth', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr.lsp_frr_bandwidth': [u'lsp_frr_bandwidth', u'lsp_frr_bandwidth_inherit']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_lsp_frr_bandwidth_inherit_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr.lsp_frr_bandwidth', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'inherit'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_lsp_frr_bandwidth_lsp_frr_bandwidth_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr.lsp_frr_bandwidth', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lsp-frr-bandwidth'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_lsp_frr_facility_backup_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'facility-backup'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_lsp_frr_hop_limit_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hop-limit'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_lsp_frr_link_protection_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'link-protection'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_lsp_frr_priority_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr.lsp_frr_priority', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_lsp_frr_priority_lsp_frr_hold_priority_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr.lsp_frr_priority', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lsp-frr-hold-priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_lsp_frr_priority_lsp_frr_setup_priority_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr.lsp_frr_priority', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lsp-frr-setup-priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_lsp_frr_revertive_global_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr.lsp_frr_revertive', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'global'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_lsp_frr_revertive_holdtime_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr.lsp_frr_revertive', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'holdtime'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_lsp_hop_limit_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'lsp', 'keyval': 'lsp_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hop-limit'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_lsp_ipmtu_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'lsp', 'keyval': 'lsp_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ipmtu'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_lsp_metric_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'lsp', 'keyval': 'lsp_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_lsp_primary_path_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'lsp', 'keyval': 'lsp_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'primary-path'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_lsp_priority_lsp_hold_priority_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp.priority', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lsp-hold-priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_lsp_priority_lsp_setup_priority_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp.priority', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lsp-setup-priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_lsp_record_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'lsp', 'keyval': 'lsp_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'record'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_lsp_reoptimize_timer_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'lsp', 'keyval': 'lsp_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'reoptimize-timer'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_lsp_revert_timer_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'lsp', 'keyval': 'lsp_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'revert-timer'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_lsp_secondary_path_delete(self, lsp=None, secondary_path=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    **Instance Keyword Argument Tuple**:

    :type secondary_path: secpath_name
    :param secondary_path: Keyword argument tuple.

    :type secpath_name: unicode
    :param secpath_name: **secondary_path** tuple argument:  Set secondary explicit path

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'secondary_path', 'keyval': 'secpath_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_lsp_secondary_path_adaptive_delete(self, lsp=None, secondary_path=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    **Instance Keyword Argument Tuple**:

    :type secondary_path: secpath_name
    :param secondary_path: Keyword argument tuple.

    :type secpath_name: unicode
    :param secpath_name: **secondary_path** tuple argument:  Set secondary explicit path

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'secondary_path', 'keyval': 'secpath_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'adaptive'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_lsp_secondary_path_autobw_delete(self, lsp=None, secondary_path=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type secondary_path: secpath_name
    :param secondary_path: Keyword argument tuple.

    :type secpath_name: unicode
    :param secpath_name: **secondary_path** tuple argument:  Set secondary explicit path

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'secondary_path')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path.lsp_secpath_auto_bandwidth', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'secpath_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_lsp_secondary_path_autobw_adjustment_interval_delete(self, lsp=None, secondary_path=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type secondary_path: secpath_name
    :param secondary_path: Keyword argument tuple.

    :type secpath_name: unicode
    :param secpath_name: **secondary_path** tuple argument:  Set secondary explicit path

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'secondary_path')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path.lsp_secpath_auto_bandwidth', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'secpath_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'adjustment-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_lsp_secondary_path_autobw_adjustment_threshold_delete(self, lsp=None, secondary_path=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type secondary_path: secpath_name
    :param secondary_path: Keyword argument tuple.

    :type secpath_name: unicode
    :param secpath_name: **secondary_path** tuple argument:  Set secondary explicit path

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'secondary_path')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path.lsp_secpath_auto_bandwidth', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'secpath_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'adjustment-threshold'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_lsp_secondary_path_autobw_max_bandwidth_delete(self, lsp=None, secondary_path=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type secondary_path: secpath_name
    :param secondary_path: Keyword argument tuple.

    :type secpath_name: unicode
    :param secpath_name: **secondary_path** tuple argument:  Set secondary explicit path

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'secondary_path')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path.lsp_secpath_auto_bandwidth', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'secpath_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'max-bandwidth'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_lsp_secondary_path_autobw_min_bandwidth_delete(self, lsp=None, secondary_path=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type secondary_path: secpath_name
    :param secondary_path: Keyword argument tuple.

    :type secpath_name: unicode
    :param secpath_name: **secondary_path** tuple argument:  Set secondary explicit path

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'secondary_path')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path.lsp_secpath_auto_bandwidth', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'secpath_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'min-bandwidth'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_lsp_secondary_path_autobw_mode_delete(self, lsp=None, secondary_path=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type secondary_path: secpath_name
    :param secondary_path: Keyword argument tuple.

    :type secpath_name: unicode
    :param secpath_name: **secondary_path** tuple argument:  Set secondary explicit path

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'secondary_path')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path.lsp_secpath_auto_bandwidth', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'secpath_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mode'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_lsp_secondary_path_autobw_overflow_limit_delete(self, lsp=None, secondary_path=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type secondary_path: secpath_name
    :param secondary_path: Keyword argument tuple.

    :type secpath_name: unicode
    :param secpath_name: **secondary_path** tuple argument:  Set secondary explicit path

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'secondary_path')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path.lsp_secpath_auto_bandwidth', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'secpath_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'overflow-limit'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_lsp_secondary_path_autobw_sample_recording_delete(self, lsp=None, secondary_path=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type secondary_path: secpath_name
    :param secondary_path: Keyword argument tuple.

    :type secpath_name: unicode
    :param secpath_name: **secondary_path** tuple argument:  Set secondary explicit path

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'secondary_path')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path.lsp_secpath_auto_bandwidth', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'secpath_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'sample-recording'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_lsp_secondary_path_autobw_template_delete(self, lsp=None, secondary_path=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type secondary_path: secpath_name
    :param secondary_path: Keyword argument tuple.

    :type secpath_name: unicode
    :param secpath_name: **secondary_path** tuple argument:  Set secondary explicit path

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'secondary_path')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path.lsp_secpath_auto_bandwidth', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'secpath_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'template'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_lsp_secondary_path_autobw_underflow_limit_delete(self, lsp=None, secondary_path=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type secondary_path: secpath_name
    :param secondary_path: Keyword argument tuple.

    :type secpath_name: unicode
    :param secpath_name: **secondary_path** tuple argument:  Set secondary explicit path

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'secondary_path')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path.lsp_secpath_auto_bandwidth', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'secpath_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'underflow-limit'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_lsp_secondary_path_bfd_delete(self, lsp=None, secondary_path=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    **Instance Keyword Argument Tuple**:

    :type secondary_path: secpath_name
    :param secondary_path: Keyword argument tuple.

    :type secpath_name: unicode
    :param secpath_name: **secondary_path** tuple argument:  Set secondary explicit path

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'secondary_path', 'keyval': 'secpath_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bfd'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_lsp_secondary_path_commit_delete(self, lsp=None, secondary_path=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    **Instance Keyword Argument Tuple**:

    :type secondary_path: secpath_name
    :param secondary_path: Keyword argument tuple.

    :type secpath_name: unicode
    :param secpath_name: **secondary_path** tuple argument:  Set secondary explicit path

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'secondary_path', 'keyval': 'secpath_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'commit'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_lsp_secondary_path_cos_delete(self, lsp=None, secondary_path=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    **Instance Keyword Argument Tuple**:

    :type secondary_path: secpath_name
    :param secondary_path: Keyword argument tuple.

    :type secpath_name: unicode
    :param secpath_name: **secondary_path** tuple argument:  Set secondary explicit path

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'secondary_path', 'keyval': 'secpath_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cos'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_lsp_secondary_path_cspf_delete(self, lsp=None, secondary_path=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    **Instance Keyword Argument Tuple**:

    :type secondary_path: secpath_name
    :param secondary_path: Keyword argument tuple.

    :type secpath_name: unicode
    :param secpath_name: **secondary_path** tuple argument:  Set secondary explicit path

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'secondary_path', 'keyval': 'secpath_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cspf'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_lsp_secondary_path_cspf_computation_mode_delete(self, lsp=None, secondary_path=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    **Instance Keyword Argument Tuple**:

    :type secondary_path: secpath_name
    :param secondary_path: Keyword argument tuple.

    :type secpath_name: unicode
    :param secpath_name: **secondary_path** tuple argument:  Set secondary explicit path

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'secondary_path', 'keyval': 'secpath_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cspf-computation-mode'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_lsp_secondary_path_hop_limit_delete(self, lsp=None, secondary_path=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    **Instance Keyword Argument Tuple**:

    :type secondary_path: secpath_name
    :param secondary_path: Keyword argument tuple.

    :type secpath_name: unicode
    :param secpath_name: **secondary_path** tuple argument:  Set secondary explicit path

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'secondary_path', 'keyval': 'secpath_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hop-limit'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_lsp_secondary_path_ipmtu_delete(self, lsp=None, secondary_path=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    **Instance Keyword Argument Tuple**:

    :type secondary_path: secpath_name
    :param secondary_path: Keyword argument tuple.

    :type secpath_name: unicode
    :param secpath_name: **secondary_path** tuple argument:  Set secondary explicit path

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'secondary_path', 'keyval': 'secpath_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ipmtu'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_lsp_secondary_path_priority_lsp_hold_priority_delete(self, lsp=None, secondary_path=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type secondary_path: secpath_name
    :param secondary_path: Keyword argument tuple.

    :type secpath_name: unicode
    :param secpath_name: **secondary_path** tuple argument:  Set secondary explicit path

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'secondary_path')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path.priority', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'secpath_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lsp-hold-priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_lsp_secondary_path_priority_lsp_setup_priority_delete(self, lsp=None, secondary_path=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type secondary_path: secpath_name
    :param secondary_path: Keyword argument tuple.

    :type secpath_name: unicode
    :param secpath_name: **secondary_path** tuple argument:  Set secondary explicit path

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'secondary_path')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path.priority', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'secpath_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lsp-setup-priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_lsp_secondary_path_record_delete(self, lsp=None, secondary_path=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    **Instance Keyword Argument Tuple**:

    :type secondary_path: secpath_name
    :param secondary_path: Keyword argument tuple.

    :type secpath_name: unicode
    :param secpath_name: **secondary_path** tuple argument:  Set secondary explicit path

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'secondary_path', 'keyval': 'secpath_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'record'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_lsp_secondary_path_reoptimize_timer_delete(self, lsp=None, secondary_path=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    **Instance Keyword Argument Tuple**:

    :type secondary_path: secpath_name
    :param secondary_path: Keyword argument tuple.

    :type secpath_name: unicode
    :param secpath_name: **secondary_path** tuple argument:  Set secondary explicit path

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'secondary_path', 'keyval': 'secpath_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'reoptimize-timer'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_lsp_secondary_path_soft_preemption_delete(self, lsp=None, secondary_path=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    **Instance Keyword Argument Tuple**:

    :type secondary_path: secpath_name
    :param secondary_path: Keyword argument tuple.

    :type secpath_name: unicode
    :param secpath_name: **secondary_path** tuple argument:  Set secondary explicit path

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'secondary_path', 'keyval': 'secpath_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'soft-preemption'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_lsp_secondary_path_standby_delete(self, lsp=None, secondary_path=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    **Instance Keyword Argument Tuple**:

    :type secondary_path: secpath_name
    :param secondary_path: Keyword argument tuple.

    :type secpath_name: unicode
    :param secpath_name: **secondary_path** tuple argument:  Set secondary explicit path

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'secondary_path', 'keyval': 'secpath_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'standby'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_lsp_secondary_path_traffic_engineering_max_burst_delete(self, lsp=None, secondary_path=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type secondary_path: secpath_name
    :param secondary_path: Keyword argument tuple.

    :type secpath_name: unicode
    :param secpath_name: **secondary_path** tuple argument:  Set secondary explicit path

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'secondary_path')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path.lsp_traffic_engineering', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'secpath_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'max-burst'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_lsp_secondary_path_traffic_engineering_max_rate_delete(self, lsp=None, secondary_path=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type secondary_path: secpath_name
    :param secondary_path: Keyword argument tuple.

    :type secpath_name: unicode
    :param secpath_name: **secondary_path** tuple argument:  Set secondary explicit path

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'secondary_path')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path.lsp_traffic_engineering', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'secpath_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'max-rate'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_lsp_secondary_path_traffic_engineering_mean_rate_delete(self, lsp=None, secondary_path=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type secondary_path: secpath_name
    :param secondary_path: Keyword argument tuple.

    :type secpath_name: unicode
    :param secpath_name: **secondary_path** tuple argument:  Set secondary explicit path

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'secondary_path')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path.lsp_traffic_engineering', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'secpath_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mean-rate'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_lsp_select_path_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_select_path', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'lsp_select_path_mode, lsp_select_path_primary, lsp_select_path_secondary_name'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_select_path': [u'lsp_select_path_secondary_name', u'lsp_select_path_primary']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_lsp_select_path_lsp_select_path_mode_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_select_path', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lsp-select-path-mode'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_lsp_select_path_primary_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_select_path', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'primary'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_lsp_select_path_secondary_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_select_path', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'secondary'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_lsp_soft_preemption_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'lsp', 'keyval': 'lsp_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'soft-preemption'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_lsp_tie_breaking_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'lsp', 'keyval': 'lsp_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tie-breaking'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_lsp_to_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'lsp', 'keyval': 'lsp_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'to'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_lsp_traffic_engineering_max_burst_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_traffic_engineering', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'max-burst'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_lsp_traffic_engineering_max_rate_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_traffic_engineering', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'max-rate'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_lsp_traffic_engineering_mean_rate_delete(self, lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_traffic_engineering', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mean-rate'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_lsp_xc_traps_enable_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.lsp_xc_traps', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_mpls_cmds_holder_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_mpls_interface_delete(self, mpls_interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type mpls_interface: interface_type, interface_name
    :param mpls_interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **mpls_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 've']

    :type interface_name: unicode
    :param interface_name: **mpls_interface** tuple argument:  The Interface value.

        * length restriction: ::

            ['1..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6])/([1-9]|[1-9][0-9]|[1-9][0-9]['
            '0-9])(:[1-4])?)|([0-9]([0-9])?([0-9])?([0-9])?))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'mpls_interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_interface=mpls_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_interface=mpls_interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_mpls_interface_dynamic_bypass_delete(self, mpls_interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mpls_interface: interface_type, interface_name
    :param mpls_interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **mpls_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 've']

    :type interface_name: unicode
    :param interface_name: **mpls_interface** tuple argument:  The Interface value.

        * length restriction: ::

            ['1..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6])/([1-9]|[1-9][0-9]|[1-9][0-9]['
            '0-9])(:[1-4])?)|([0-9]([0-9])?([0-9])?([0-9])?))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.interface_dynamic_bypass', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_interface=mpls_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_interface=mpls_interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_mpls_interface_dynamic_bypass_adaptive_delete(self, mpls_interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mpls_interface: interface_type, interface_name
    :param mpls_interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **mpls_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 've']

    :type interface_name: unicode
    :param interface_name: **mpls_interface** tuple argument:  The Interface value.

        * length restriction: ::

            ['1..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6])/([1-9]|[1-9][0-9]|[1-9][0-9]['
            '0-9])(:[1-4])?)|([0-9]([0-9])?([0-9])?([0-9])?))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.interface_dynamic_bypass.mpls_interface_dynamic_bypass_sub_cmds', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'adaptive'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_interface=mpls_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_interface=mpls_interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_mpls_interface_dynamic_bypass_cos_delete(self, mpls_interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mpls_interface: interface_type, interface_name
    :param mpls_interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **mpls_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 've']

    :type interface_name: unicode
    :param interface_name: **mpls_interface** tuple argument:  The Interface value.

        * length restriction: ::

            ['1..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6])/([1-9]|[1-9][0-9]|[1-9][0-9]['
            '0-9])(:[1-4])?)|([0-9]([0-9])?([0-9])?([0-9])?))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.interface_dynamic_bypass.mpls_interface_dynamic_bypass_sub_cmds', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cos'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_interface=mpls_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_interface=mpls_interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_mpls_interface_dynamic_bypass_cspf_computation_mode_delete(self, mpls_interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mpls_interface: interface_type, interface_name
    :param mpls_interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **mpls_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 've']

    :type interface_name: unicode
    :param interface_name: **mpls_interface** tuple argument:  The Interface value.

        * length restriction: ::

            ['1..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6])/([1-9]|[1-9][0-9]|[1-9][0-9]['
            '0-9])(:[1-4])?)|([0-9]([0-9])?([0-9])?([0-9])?))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.interface_dynamic_bypass.mpls_interface_dynamic_bypass_sub_cmds', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cspf-computation-mode'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_interface=mpls_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_interface=mpls_interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_mpls_interface_dynamic_bypass_disable_delete(self, mpls_interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mpls_interface: interface_type, interface_name
    :param mpls_interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **mpls_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 've']

    :type interface_name: unicode
    :param interface_name: **mpls_interface** tuple argument:  The Interface value.

        * length restriction: ::

            ['1..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6])/([1-9]|[1-9][0-9]|[1-9][0-9]['
            '0-9])(:[1-4])?)|([0-9]([0-9])?([0-9])?([0-9])?))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.interface_dynamic_bypass.mpls_interface_dynamic_bypass_sub_cmds', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'disable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_interface=mpls_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_interface=mpls_interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_mpls_interface_dynamic_bypass_from_delete(self, mpls_interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mpls_interface: interface_type, interface_name
    :param mpls_interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **mpls_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 've']

    :type interface_name: unicode
    :param interface_name: **mpls_interface** tuple argument:  The Interface value.

        * length restriction: ::

            ['1..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6])/([1-9]|[1-9][0-9]|[1-9][0-9]['
            '0-9])(:[1-4])?)|([0-9]([0-9])?([0-9])?([0-9])?))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.interface_dynamic_bypass.mpls_interface_dynamic_bypass_sub_cmds', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'from'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_interface=mpls_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_interface=mpls_interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_mpls_interface_dynamic_bypass_hop_limit_delete(self, mpls_interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mpls_interface: interface_type, interface_name
    :param mpls_interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **mpls_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 've']

    :type interface_name: unicode
    :param interface_name: **mpls_interface** tuple argument:  The Interface value.

        * length restriction: ::

            ['1..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6])/([1-9]|[1-9][0-9]|[1-9][0-9]['
            '0-9])(:[1-4])?)|([0-9]([0-9])?([0-9])?([0-9])?))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.interface_dynamic_bypass.mpls_interface_dynamic_bypass_sub_cmds', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hop-limit'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_interface=mpls_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_interface=mpls_interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_mpls_interface_dynamic_bypass_max_bypasses_delete(self, mpls_interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mpls_interface: interface_type, interface_name
    :param mpls_interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **mpls_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 've']

    :type interface_name: unicode
    :param interface_name: **mpls_interface** tuple argument:  The Interface value.

        * length restriction: ::

            ['1..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6])/([1-9]|[1-9][0-9]|[1-9][0-9]['
            '0-9])(:[1-4])?)|([0-9]([0-9])?([0-9])?([0-9])?))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.interface_dynamic_bypass.mpls_interface_dynamic_bypass_sub_cmds', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'max-bypasses'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_interface=mpls_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_interface=mpls_interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_mpls_interface_dynamic_bypass_max_bypasses_per_mp_delete(self, mpls_interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mpls_interface: interface_type, interface_name
    :param mpls_interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **mpls_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 've']

    :type interface_name: unicode
    :param interface_name: **mpls_interface** tuple argument:  The Interface value.

        * length restriction: ::

            ['1..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6])/([1-9]|[1-9][0-9]|[1-9][0-9]['
            '0-9])(:[1-4])?)|([0-9]([0-9])?([0-9])?([0-9])?))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.interface_dynamic_bypass.mpls_interface_dynamic_bypass_sub_cmds', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'max-bypasses-per-mp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_interface=mpls_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_interface=mpls_interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_mpls_interface_dynamic_bypass_mpls_interface_dynamic_bypass_sub_cmds_delete(self, mpls_interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mpls_interface: interface_type, interface_name
    :param mpls_interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **mpls_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 've']

    :type interface_name: unicode
    :param interface_name: **mpls_interface** tuple argument:  The Interface value.

        * length restriction: ::

            ['1..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6])/([1-9]|[1-9][0-9]|[1-9][0-9]['
            '0-9])(:[1-4])?)|([0-9]([0-9])?([0-9])?([0-9])?))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.interface_dynamic_bypass.mpls_interface_dynamic_bypass_sub_cmds', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_interface=mpls_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_interface=mpls_interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_mpls_interface_dynamic_bypass_name_prefix_delete(self, mpls_interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mpls_interface: interface_type, interface_name
    :param mpls_interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **mpls_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 've']

    :type interface_name: unicode
    :param interface_name: **mpls_interface** tuple argument:  The Interface value.

        * length restriction: ::

            ['1..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6])/([1-9]|[1-9][0-9]|[1-9][0-9]['
            '0-9])(:[1-4])?)|([0-9]([0-9])?([0-9])?([0-9])?))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.interface_dynamic_bypass.mpls_interface_dynamic_bypass_sub_cmds', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'name-prefix'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_interface=mpls_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_interface=mpls_interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_mpls_interface_dynamic_bypass_primary_path_delete(self, mpls_interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mpls_interface: interface_type, interface_name
    :param mpls_interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **mpls_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 've']

    :type interface_name: unicode
    :param interface_name: **mpls_interface** tuple argument:  The Interface value.

        * length restriction: ::

            ['1..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6])/([1-9]|[1-9][0-9]|[1-9][0-9]['
            '0-9])(:[1-4])?)|([0-9]([0-9])?([0-9])?([0-9])?))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.interface_dynamic_bypass.mpls_interface_dynamic_bypass_sub_cmds', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'primary-path'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_interface=mpls_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_interface=mpls_interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_mpls_interface_dynamic_bypass_priority_delete(self, mpls_interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mpls_interface: interface_type, interface_name
    :param mpls_interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **mpls_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 've']

    :type interface_name: unicode
    :param interface_name: **mpls_interface** tuple argument:  The Interface value.

        * length restriction: ::

            ['1..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6])/([1-9]|[1-9][0-9]|[1-9][0-9]['
            '0-9])(:[1-4])?)|([0-9]([0-9])?([0-9])?([0-9])?))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.interface_dynamic_bypass.mpls_interface_dynamic_bypass_sub_cmds.priority', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'interface_dynamic_bypass_setup_priority, interface_dynamic_bypass_holding_priority'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_interface=mpls_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_interface=mpls_interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_mpls_interface_dynamic_bypass_priority_interface_dynamic_bypass_holding_priority_delete(self, mpls_interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mpls_interface: interface_type, interface_name
    :param mpls_interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **mpls_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 've']

    :type interface_name: unicode
    :param interface_name: **mpls_interface** tuple argument:  The Interface value.

        * length restriction: ::

            ['1..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6])/([1-9]|[1-9][0-9]|[1-9][0-9]['
            '0-9])(:[1-4])?)|([0-9]([0-9])?([0-9])?([0-9])?))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.interface_dynamic_bypass.mpls_interface_dynamic_bypass_sub_cmds.priority', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'interface-dynamic-bypass-holding-priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_interface=mpls_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_interface=mpls_interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_mpls_interface_dynamic_bypass_priority_interface_dynamic_bypass_setup_priority_delete(self, mpls_interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mpls_interface: interface_type, interface_name
    :param mpls_interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **mpls_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 've']

    :type interface_name: unicode
    :param interface_name: **mpls_interface** tuple argument:  The Interface value.

        * length restriction: ::

            ['1..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6])/([1-9]|[1-9][0-9]|[1-9][0-9]['
            '0-9])(:[1-4])?)|([0-9]([0-9])?([0-9])?([0-9])?))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.interface_dynamic_bypass.mpls_interface_dynamic_bypass_sub_cmds.priority', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'interface-dynamic-bypass-setup-priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_interface=mpls_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_interface=mpls_interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_mpls_interface_dynamic_bypass_record_route_delete(self, mpls_interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mpls_interface: interface_type, interface_name
    :param mpls_interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **mpls_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 've']

    :type interface_name: unicode
    :param interface_name: **mpls_interface** tuple argument:  The Interface value.

        * length restriction: ::

            ['1..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6])/([1-9]|[1-9][0-9]|[1-9][0-9]['
            '0-9])(:[1-4])?)|([0-9]([0-9])?([0-9])?([0-9])?))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.interface_dynamic_bypass.mpls_interface_dynamic_bypass_sub_cmds', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'record-route'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_interface=mpls_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_interface=mpls_interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_mpls_interface_dynamic_bypass_reoptimize_timer_delete(self, mpls_interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mpls_interface: interface_type, interface_name
    :param mpls_interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **mpls_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 've']

    :type interface_name: unicode
    :param interface_name: **mpls_interface** tuple argument:  The Interface value.

        * length restriction: ::

            ['1..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6])/([1-9]|[1-9][0-9]|[1-9][0-9]['
            '0-9])(:[1-4])?)|([0-9]([0-9])?([0-9])?([0-9])?))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.interface_dynamic_bypass.mpls_interface_dynamic_bypass_sub_cmds', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'reoptimize-timer'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_interface=mpls_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_interface=mpls_interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_mpls_interface_dynamic_bypass_tie_breaking_delete(self, mpls_interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mpls_interface: interface_type, interface_name
    :param mpls_interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **mpls_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 've']

    :type interface_name: unicode
    :param interface_name: **mpls_interface** tuple argument:  The Interface value.

        * length restriction: ::

            ['1..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6])/([1-9]|[1-9][0-9]|[1-9][0-9]['
            '0-9])(:[1-4])?)|([0-9]([0-9])?([0-9])?([0-9])?))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.interface_dynamic_bypass.mpls_interface_dynamic_bypass_sub_cmds', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tie-breaking'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_interface=mpls_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_interface=mpls_interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_mpls_interface_dynamic_bypass_traffic_eng_delete(self, mpls_interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mpls_interface: interface_type, interface_name
    :param mpls_interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **mpls_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 've']

    :type interface_name: unicode
    :param interface_name: **mpls_interface** tuple argument:  The Interface value.

        * length restriction: ::

            ['1..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6])/([1-9]|[1-9][0-9]|[1-9][0-9]['
            '0-9])(:[1-4])?)|([0-9]([0-9])?([0-9])?([0-9])?))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.interface_dynamic_bypass.mpls_interface_dynamic_bypass_sub_cmds.traffic_eng', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'interface_dynamic_bypass_traffic_eng_max_burst, interface_dynamic_bypass_traffic_eng_max_rate, interface_dynamic_bypass_traffic_eng_mean_rate'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_interface=mpls_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_interface=mpls_interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_mpls_interface_dynamic_bypass_traffic_eng_max_burst_delete(self, mpls_interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mpls_interface: interface_type, interface_name
    :param mpls_interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **mpls_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 've']

    :type interface_name: unicode
    :param interface_name: **mpls_interface** tuple argument:  The Interface value.

        * length restriction: ::

            ['1..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6])/([1-9]|[1-9][0-9]|[1-9][0-9]['
            '0-9])(:[1-4])?)|([0-9]([0-9])?([0-9])?([0-9])?))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.interface_dynamic_bypass.mpls_interface_dynamic_bypass_sub_cmds.traffic_eng', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'max-burst'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_interface=mpls_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_interface=mpls_interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_mpls_interface_dynamic_bypass_traffic_eng_max_rate_delete(self, mpls_interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mpls_interface: interface_type, interface_name
    :param mpls_interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **mpls_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 've']

    :type interface_name: unicode
    :param interface_name: **mpls_interface** tuple argument:  The Interface value.

        * length restriction: ::

            ['1..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6])/([1-9]|[1-9][0-9]|[1-9][0-9]['
            '0-9])(:[1-4])?)|([0-9]([0-9])?([0-9])?([0-9])?))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.interface_dynamic_bypass.mpls_interface_dynamic_bypass_sub_cmds.traffic_eng', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'max-rate'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_interface=mpls_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_interface=mpls_interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_mpls_interface_dynamic_bypass_traffic_eng_mean_rate_delete(self, mpls_interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mpls_interface: interface_type, interface_name
    :param mpls_interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **mpls_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 've']

    :type interface_name: unicode
    :param interface_name: **mpls_interface** tuple argument:  The Interface value.

        * length restriction: ::

            ['1..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6])/([1-9]|[1-9][0-9]|[1-9][0-9]['
            '0-9])(:[1-4])?)|([0-9]([0-9])?([0-9])?([0-9])?))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.interface_dynamic_bypass.mpls_interface_dynamic_bypass_sub_cmds.traffic_eng', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mean-rate'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_interface=mpls_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_interface=mpls_interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_mpls_interface_ldp_enable_delete(self, mpls_interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type mpls_interface: interface_type, interface_name
    :param mpls_interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **mpls_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 've']

    :type interface_name: unicode
    :param interface_name: **mpls_interface** tuple argument:  The Interface value.

        * length restriction: ::

            ['1..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6])/([1-9]|[1-9][0-9]|[1-9][0-9]['
            '0-9])(:[1-4])?)|([0-9]([0-9])?([0-9])?([0-9])?))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'mpls_interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ldp-enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_interface=mpls_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_interface=mpls_interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_mpls_interface_ldp_params_delete(self, mpls_interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mpls_interface: interface_type, interface_name
    :param mpls_interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **mpls_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 've']

    :type interface_name: unicode
    :param interface_name: **mpls_interface** tuple argument:  The Interface value.

        * length restriction: ::

            ['1..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6])/([1-9]|[1-9][0-9]|[1-9][0-9]['
            '0-9])(:[1-4])?)|([0-9]([0-9])?([0-9])?([0-9])?))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.ldp_params', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_interface=mpls_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_interface=mpls_interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_mpls_interface_ldp_params_hello_interval_delete(self, mpls_interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mpls_interface: interface_type, interface_name
    :param mpls_interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **mpls_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 've']

    :type interface_name: unicode
    :param interface_name: **mpls_interface** tuple argument:  The Interface value.

        * length restriction: ::

            ['1..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6])/([1-9]|[1-9][0-9]|[1-9][0-9]['
            '0-9])(:[1-4])?)|([0-9]([0-9])?([0-9])?([0-9])?))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.ldp_params.ldp_param_cmds', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hello-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_interface=mpls_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_interface=mpls_interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_mpls_interface_ldp_params_hello_timeout_delete(self, mpls_interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mpls_interface: interface_type, interface_name
    :param mpls_interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **mpls_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 've']

    :type interface_name: unicode
    :param interface_name: **mpls_interface** tuple argument:  The Interface value.

        * length restriction: ::

            ['1..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6])/([1-9]|[1-9][0-9]|[1-9][0-9]['
            '0-9])(:[1-4])?)|([0-9]([0-9])?([0-9])?([0-9])?))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.ldp_params.ldp_param_cmds', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hello-timeout'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_interface=mpls_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_interface=mpls_interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_mpls_interface_ldp_params_ldp_param_cmds_delete(self, mpls_interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mpls_interface: interface_type, interface_name
    :param mpls_interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **mpls_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 've']

    :type interface_name: unicode
    :param interface_name: **mpls_interface** tuple argument:  The Interface value.

        * length restriction: ::

            ['1..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6])/([1-9]|[1-9][0-9]|[1-9][0-9]['
            '0-9])(:[1-4])?)|([0-9]([0-9])?([0-9])?([0-9])?))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.ldp_params.ldp_param_cmds', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'hello_interval, hello_timeout'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_interface=mpls_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_interface=mpls_interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_mpls_interface_rsvp_delete(self, mpls_interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mpls_interface: interface_type, interface_name
    :param mpls_interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **mpls_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 've']

    :type interface_name: unicode
    :param interface_name: **mpls_interface** tuple argument:  The Interface value.

        * length restriction: ::

            ['1..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6])/([1-9]|[1-9][0-9]|[1-9][0-9]['
            '0-9])(:[1-4])?)|([0-9]([0-9])?([0-9])?([0-9])?))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_interface=mpls_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_interface=mpls_interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_mpls_interface_rsvp_authentication_delete(self, mpls_interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mpls_interface: interface_type, interface_name
    :param mpls_interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **mpls_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 've']

    :type interface_name: unicode
    :param interface_name: **mpls_interface** tuple argument:  The Interface value.

        * length restriction: ::

            ['1..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6])/([1-9]|[1-9][0-9]|[1-9][0-9]['
            '0-9])(:[1-4])?)|([0-9]([0-9])?([0-9])?([0-9])?))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp.rsvp_authentication', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_interface=mpls_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_interface=mpls_interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_mpls_interface_rsvp_authentication_key_delete(self, mpls_interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mpls_interface: interface_type, interface_name
    :param mpls_interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **mpls_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 've']

    :type interface_name: unicode
    :param interface_name: **mpls_interface** tuple argument:  The Interface value.

        * length restriction: ::

            ['1..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6])/([1-9]|[1-9][0-9]|[1-9][0-9]['
            '0-9])(:[1-4])?)|([0-9]([0-9])?([0-9])?([0-9])?))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp.rsvp_authentication', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'key'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_interface=mpls_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_interface=mpls_interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_mpls_interface_rsvp_hello_delete(self, mpls_interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mpls_interface: interface_type, interface_name
    :param mpls_interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **mpls_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 've']

    :type interface_name: unicode
    :param interface_name: **mpls_interface** tuple argument:  The Interface value.

        * length restriction: ::

            ['1..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6])/([1-9]|[1-9][0-9]|[1-9][0-9]['
            '0-9])(:[1-4])?)|([0-9]([0-9])?([0-9])?([0-9])?))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp.interface_rsvp_hello', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'rsvp_hello_interval, rsvp_hello_tolerance'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_interface=mpls_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_interface=mpls_interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_mpls_interface_rsvp_hello_disable_delete(self, mpls_interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mpls_interface: interface_type, interface_name
    :param mpls_interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **mpls_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 've']

    :type interface_name: unicode
    :param interface_name: **mpls_interface** tuple argument:  The Interface value.

        * length restriction: ::

            ['1..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6])/([1-9]|[1-9][0-9]|[1-9][0-9]['
            '0-9])(:[1-4])?)|([0-9]([0-9])?([0-9])?([0-9])?))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hello-disable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_interface=mpls_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_interface=mpls_interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_mpls_interface_rsvp_hello_interval_delete(self, mpls_interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mpls_interface: interface_type, interface_name
    :param mpls_interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **mpls_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 've']

    :type interface_name: unicode
    :param interface_name: **mpls_interface** tuple argument:  The Interface value.

        * length restriction: ::

            ['1..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6])/([1-9]|[1-9][0-9]|[1-9][0-9]['
            '0-9])(:[1-4])?)|([0-9]([0-9])?([0-9])?([0-9])?))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp.interface_rsvp_hello', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_interface=mpls_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_interface=mpls_interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_mpls_interface_rsvp_hello_tolerance_delete(self, mpls_interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mpls_interface: interface_type, interface_name
    :param mpls_interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **mpls_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 've']

    :type interface_name: unicode
    :param interface_name: **mpls_interface** tuple argument:  The Interface value.

        * length restriction: ::

            ['1..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6])/([1-9]|[1-9][0-9]|[1-9][0-9]['
            '0-9])(:[1-4])?)|([0-9]([0-9])?([0-9])?([0-9])?))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp.interface_rsvp_hello', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tolerance'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_interface=mpls_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_interface=mpls_interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_mpls_interface_rsvp_refresh_reduction_delete(self, mpls_interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mpls_interface: interface_type, interface_name
    :param mpls_interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **mpls_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 've']

    :type interface_name: unicode
    :param interface_name: **mpls_interface** tuple argument:  The Interface value.

        * length restriction: ::

            ['1..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6])/([1-9]|[1-9][0-9]|[1-9][0-9]['
            '0-9])(:[1-4])?)|([0-9]([0-9])?([0-9])?([0-9])?))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp.interface_refresh_reduction', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_interface=mpls_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_interface=mpls_interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_mpls_interface_rsvp_refresh_reduction_all_delete(self, mpls_interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mpls_interface: interface_type, interface_name
    :param mpls_interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **mpls_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 've']

    :type interface_name: unicode
    :param interface_name: **mpls_interface** tuple argument:  The Interface value.

        * length restriction: ::

            ['1..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6])/([1-9]|[1-9][0-9]|[1-9][0-9]['
            '0-9])(:[1-4])?)|([0-9]([0-9])?([0-9])?([0-9])?))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp.interface_refresh_reduction', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'all'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_interface=mpls_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_interface=mpls_interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_mpls_interface_rsvp_refresh_reduction_bundle_message_delete(self, mpls_interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mpls_interface: interface_type, interface_name
    :param mpls_interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **mpls_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 've']

    :type interface_name: unicode
    :param interface_name: **mpls_interface** tuple argument:  The Interface value.

        * length restriction: ::

            ['1..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6])/([1-9]|[1-9][0-9]|[1-9][0-9]['
            '0-9])(:[1-4])?)|([0-9]([0-9])?([0-9])?([0-9])?))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp.interface_refresh_reduction.bundle_message', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_interface=mpls_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_interface=mpls_interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_mpls_interface_rsvp_refresh_reduction_bundle_message_bundle_send_delay_delete(self, mpls_interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mpls_interface: interface_type, interface_name
    :param mpls_interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **mpls_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 've']

    :type interface_name: unicode
    :param interface_name: **mpls_interface** tuple argument:  The Interface value.

        * length restriction: ::

            ['1..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6])/([1-9]|[1-9][0-9]|[1-9][0-9]['
            '0-9])(:[1-4])?)|([0-9]([0-9])?([0-9])?([0-9])?))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp.interface_refresh_reduction.bundle_message', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bundle-send-delay'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_interface=mpls_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_interface=mpls_interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_mpls_interface_rsvp_refresh_reduction_disable_delete(self, mpls_interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mpls_interface: interface_type, interface_name
    :param mpls_interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **mpls_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 've']

    :type interface_name: unicode
    :param interface_name: **mpls_interface** tuple argument:  The Interface value.

        * length restriction: ::

            ['1..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6])/([1-9]|[1-9][0-9]|[1-9][0-9]['
            '0-9])(:[1-4])?)|([0-9]([0-9])?([0-9])?([0-9])?))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp.interface_refresh_reduction', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'disable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_interface=mpls_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_interface=mpls_interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_mpls_interface_rsvp_refresh_reduction_summary_refresh_delete(self, mpls_interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mpls_interface: interface_type, interface_name
    :param mpls_interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **mpls_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 've']

    :type interface_name: unicode
    :param interface_name: **mpls_interface** tuple argument:  The Interface value.

        * length restriction: ::

            ['1..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6])/([1-9]|[1-9][0-9]|[1-9][0-9]['
            '0-9])(:[1-4])?)|([0-9]([0-9])?([0-9])?([0-9])?))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp.interface_refresh_reduction', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'summary-refresh'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_interface=mpls_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_interface=mpls_interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_mpls_interface_rsvp_reliable_messaging_delete(self, mpls_interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mpls_interface: interface_type, interface_name
    :param mpls_interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **mpls_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 've']

    :type interface_name: unicode
    :param interface_name: **mpls_interface** tuple argument:  The Interface value.

        * length restriction: ::

            ['1..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6])/([1-9]|[1-9][0-9]|[1-9][0-9]['
            '0-9])(:[1-4])?)|([0-9]([0-9])?([0-9])?([0-9])?))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp.interface_reliable_messaging', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_interface=mpls_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_interface=mpls_interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_mpls_interface_rsvp_reliable_messaging_disable_delete(self, mpls_interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mpls_interface: interface_type, interface_name
    :param mpls_interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **mpls_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 've']

    :type interface_name: unicode
    :param interface_name: **mpls_interface** tuple argument:  The Interface value.

        * length restriction: ::

            ['1..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6])/([1-9]|[1-9][0-9]|[1-9][0-9]['
            '0-9])(:[1-4])?)|([0-9]([0-9])?([0-9])?([0-9])?))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp.interface_reliable_messaging', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'disable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_interface=mpls_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_interface=mpls_interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_mpls_interface_rsvp_reliable_messaging_rapid_retrans_decay_delete(self, mpls_interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mpls_interface: interface_type, interface_name
    :param mpls_interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **mpls_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 've']

    :type interface_name: unicode
    :param interface_name: **mpls_interface** tuple argument:  The Interface value.

        * length restriction: ::

            ['1..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6])/([1-9]|[1-9][0-9]|[1-9][0-9]['
            '0-9])(:[1-4])?)|([0-9]([0-9])?([0-9])?([0-9])?))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp.interface_reliable_messaging', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rapid-retrans-decay'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_interface=mpls_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_interface=mpls_interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_mpls_interface_rsvp_reliable_messaging_rapid_retrans_interval_delete(self, mpls_interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mpls_interface: interface_type, interface_name
    :param mpls_interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **mpls_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 've']

    :type interface_name: unicode
    :param interface_name: **mpls_interface** tuple argument:  The Interface value.

        * length restriction: ::

            ['1..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6])/([1-9]|[1-9][0-9]|[1-9][0-9]['
            '0-9])(:[1-4])?)|([0-9]([0-9])?([0-9])?([0-9])?))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp.interface_reliable_messaging', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rapid-retrans-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_interface=mpls_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_interface=mpls_interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_mpls_interface_rsvp_reliable_messaging_rapid_retry_limit_delete(self, mpls_interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mpls_interface: interface_type, interface_name
    :param mpls_interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **mpls_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 've']

    :type interface_name: unicode
    :param interface_name: **mpls_interface** tuple argument:  The Interface value.

        * length restriction: ::

            ['1..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6])/([1-9]|[1-9][0-9]|[1-9][0-9]['
            '0-9])(:[1-4])?)|([0-9]([0-9])?([0-9])?([0-9])?))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp.interface_reliable_messaging', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rapid-retry-limit'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_interface=mpls_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_interface=mpls_interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_mpls_interface_rsvp_reservable_bandwidth_delete(self, mpls_interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mpls_interface: interface_type, interface_name
    :param mpls_interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **mpls_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 've']

    :type interface_name: unicode
    :param interface_name: **mpls_interface** tuple argument:  The Interface value.

        * length restriction: ::

            ['1..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6])/([1-9]|[1-9][0-9]|[1-9][0-9]['
            '0-9])(:[1-4])?)|([0-9]([0-9])?([0-9])?([0-9])?))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp.rsvp_reservable_bandwidth', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp.rsvp_reservable_bandwidth': [u'reservable_bandwidth_percentage', u'reservable_bandwidth']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_interface=mpls_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_interface=mpls_interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_mpls_interface_rsvp_reservable_bandwidth_percentage_delete(self, mpls_interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mpls_interface: interface_type, interface_name
    :param mpls_interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **mpls_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 've']

    :type interface_name: unicode
    :param interface_name: **mpls_interface** tuple argument:  The Interface value.

        * length restriction: ::

            ['1..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6])/([1-9]|[1-9][0-9]|[1-9][0-9]['
            '0-9])(:[1-4])?)|([0-9]([0-9])?([0-9])?([0-9])?))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp.rsvp_reservable_bandwidth', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'percentage'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_interface=mpls_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_interface=mpls_interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_mpls_interface_rsvp_reservable_bandwidth_reservable_bandwidth_delete(self, mpls_interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mpls_interface: interface_type, interface_name
    :param mpls_interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **mpls_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 've']

    :type interface_name: unicode
    :param interface_name: **mpls_interface** tuple argument:  The Interface value.

        * length restriction: ::

            ['1..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6])/([1-9]|[1-9][0-9]|[1-9][0-9]['
            '0-9])(:[1-4])?)|([0-9]([0-9])?([0-9])?([0-9])?))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp.rsvp_reservable_bandwidth', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'reservable-bandwidth'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_interface=mpls_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_interface=mpls_interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_mpls_interface_rsvp_te_metric_delete(self, mpls_interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mpls_interface: interface_type, interface_name
    :param mpls_interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **mpls_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 've']

    :type interface_name: unicode
    :param interface_name: **mpls_interface** tuple argument:  The Interface value.

        * length restriction: ::

            ['1..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6])/([1-9]|[1-9][0-9]|[1-9][0-9]['
            '0-9])(:[1-4])?)|([0-9]([0-9])?([0-9])?([0-9])?))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'te-metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_interface=mpls_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_interface=mpls_interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_path_delete(self, path=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type path: path_name
    :param path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **path** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.path', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'path', 'keyval': 'path_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, path=path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, path=path)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_path_hop_delete(self, path=None, path_hop=None, path_hop_type=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type path: path_name
    :param path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **path** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    **Instance Keyword Argument Tuple**:

    :type path_hop: path_hop_ip, path_hop_type
    :param path_hop: Keyword argument tuple.

    :type path_hop_ip: unicode
    :param path_hop_ip: **path_hop** tuple argument:  A.B.C.D;;path hop ip address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type path_hop_type: unicode
    :param path_hop_type: **path_hop** tuple argument:  path hop type

        * enumeration restriction: ::

            ['strict', 'loose']

    **Instance Argument(s)**:

    :type path_hop_type: unicode
    :param path_hop_type: path hop type

        * enumeration restriction: ::

            ['strict', 'loose']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.path', u'path')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.path.path_hop', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'path_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'path_hop', 'keyval': 'path_hop_ip', 'extra_keyval': 'path_hop_ip, path_hop_type'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, path=path, path_hop=path_hop, path_hop_type=path_hop_type)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, path=path, path_hop=path_hop, path_hop_type=path_hop_type)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_path_hop_path_hop_type_delete(self, path=None, path_hop=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type path: path_name
    :param path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **path** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    **Instance Keyword Argument Tuple**:

    :type path_hop: path_hop_ip
    :param path_hop: Keyword argument tuple.

    :type path_hop_ip: unicode
    :param path_hop_ip: **path_hop** tuple argument:  A.B.C.D;;path hop ip address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.path', u'path')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.path.path_hop', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'path_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'path_hop', 'keyval': 'path_hop_ip', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'path-hop-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, path=path, path_hop=path_hop)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, path=path, path_hop=path_hop)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_path_insert_delete(self, path=None, path_insert=None, path_insert_type=None, path_insert_before_hop_ip=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type path: path_name
    :param path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **path** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    **Instance Keyword Argument Tuple**:

    :type path_insert: path_insert_ip
    :param path_insert: Keyword argument tuple.

    :type path_insert_ip: unicode
    :param path_insert_ip: **path_insert** tuple argument:  A.B.C.D;;path hop ip address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Argument(s)**:

    :type path_insert_type: unicode
    :param path_insert_type: path hop type

        * enumeration restriction: ::

            ['strict', 'loose']

    :type path_insert_before_hop_ip: unicode
    :param path_insert_before_hop_ip: add before hop ip address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.path', u'path')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.path.path_insert', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'path_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'path_insert', 'keyval': 'path_insert_ip', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, path=path, path_insert=path_insert, path_insert_type=path_insert_type, path_insert_before_hop_ip=path_insert_before_hop_ip)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, path=path, path_insert=path_insert, path_insert_type=path_insert_type, path_insert_before_hop_ip=path_insert_before_hop_ip)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_path_insert_before_delete(self, path=None, path_insert=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type path: path_name
    :param path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **path** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    **Instance Keyword Argument Tuple**:

    :type path_insert: path_insert_ip
    :param path_insert: Keyword argument tuple.

    :type path_insert_ip: unicode
    :param path_insert_ip: **path_insert** tuple argument:  A.B.C.D;;path hop ip address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.path', u'path')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.path.path_insert', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'path_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'path_insert', 'keyval': 'path_insert_ip', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'before'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, path=path, path_insert=path_insert)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, path=path, path_insert=path_insert)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_path_insert_path_insert_type_delete(self, path=None, path_insert=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type path: path_name
    :param path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **path** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    **Instance Keyword Argument Tuple**:

    :type path_insert: path_insert_ip
    :param path_insert: Keyword argument tuple.

    :type path_insert_ip: unicode
    :param path_insert_ip: **path_insert** tuple argument:  A.B.C.D;;path hop ip address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.path', u'path')]
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.path.path_insert', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'path_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'path_insert', 'keyval': 'path_insert_ip', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'path-insert-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, path=path, path_insert=path_insert)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, path=path, path_insert=path_insert)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_policy_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.policy', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_policy_admin_group_delete(self, policy_admin_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type policy_admin_group: admin_group_name, admin_group_number
    :param policy_admin_group: Keyword argument tuple.

    :type admin_group_name: unicode
    :param admin_group_name: **policy_admin_group** tuple argument.

        * length restriction: ::

            ['1..32']

    :type admin_group_number: long
    :param admin_group_number: **policy_admin_group** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.policy.policy_admin_group', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'policy_admin_group', 'keyval': 'admin_group_name, admin_group_number', 'extra_keyval': 'admin_group_name, admin_group_number'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_admin_group=policy_admin_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_admin_group=policy_admin_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_policy_auto_bandwidth_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.policy.global_auto_bandwidth', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_policy_auto_bandwidth_num_sample_record_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.policy.global_auto_bandwidth', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'num-sample-record'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_policy_auto_bandwidth_sample_interval_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.policy.global_auto_bandwidth', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'sample-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_policy_backup_retry_time_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.policy', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'backup-retry-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_policy_cspf_computation_mode_ignore_overload_bit_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.policy.cspf_computation_mode', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ignore-overload-bit'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_policy_cspf_computation_mode_metric_type_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.policy.cspf_computation_mode', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_policy_cspf_computation_mode_use_bypass_liberal_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.policy.cspf_computation_mode', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'use-bypass-liberal'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_policy_cspf_computation_mode_use_bypass_metric_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.policy.cspf_computation_mode', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'use-bypass-metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_policy_cspf_group_computation_add_penalty_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.policy.cspf_group_computation', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'add-penalty'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_policy_cspf_interface_constraint_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.policy', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cspf-interface-constraint'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_policy_handle_isis_neighbor_down_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.policy', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'handle-isis-neighbor-down'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_policy_handle_ospf_neighbor_down_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.policy', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'handle-ospf-neighbor-down'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_policy_implicit_commit_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.policy.implicit_commit', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.policy.implicit_commit': [u'implicit_commit_all', u'implicit_commit_autobw_adjustment']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_policy_implicit_commit_all_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.policy.implicit_commit', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'all'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_policy_implicit_commit_auto_bandwidth_adjustment_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.policy.implicit_commit', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'auto-bandwidth-adjustment'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_policy_implicit_commit_lsp_reoptimize_timer_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.policy.implicit_commit', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lsp-reoptimize-timer'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_policy_ingress_tunnel_accounting_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.policy', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ingress-tunnel-accounting'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_policy_load_interval_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.policy', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'load-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_policy_qos_ttl_mode_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.policy', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'qos-ttl-mode'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_policy_rapid_retry_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.policy', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rapid-retry'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_policy_retry_limit_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.policy', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'retry-limit'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_policy_retry_time_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.policy', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'retry-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_policy_rsvp_periodic_flooding_time_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.policy', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rsvp-periodic-flooding-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_policy_soft_preemption_cleanup_timer_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.policy.soft_preemption', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cleanup-timer'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_policy_traffic_engineering_isis_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.policy.traffic_engineering', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'isis'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_policy_traffic_engineering_ospf_area_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.policy.traffic_engineering.traffic_eng_ospf.area', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.policy.traffic_engineering.traffic_eng_ospf.area': [u'ospf_area_as_decimal', u'ospf_area_as_ip_address', u'ospf_area_all']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_policy_traffic_engineering_ospf_area_all_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.policy.traffic_engineering.traffic_eng_ospf.area', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'all'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_policy_traffic_engineering_ospf_area_ospf_area_as_decimal_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.policy.traffic_engineering.traffic_eng_ospf.area', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ospf-area-as-decimal'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_policy_traffic_engineering_ospf_area_ospf_area_as_ip_address_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.policy.traffic_engineering.traffic_eng_ospf.area', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ospf-area-as-ip-address'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_policy_transit_session_accounting_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.policy', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'transit-session-accounting'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_rsvp_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.rsvp', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_rsvp_backup_bw_guarantee_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.rsvp', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'backup-bw-guarantee'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_rsvp_hello_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.rsvp.global_rsvp_hello', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'global_rsvp_hello_interval, global_rsvp_hello_tolerance'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_rsvp_hello_acknowledgements_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.rsvp', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hello-acknowledgements'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_rsvp_hello_interval_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.rsvp.global_rsvp_hello', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_rsvp_hello_tolerance_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.rsvp.global_rsvp_hello', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tolerance'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_rsvp_hello_unprioritize_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.rsvp', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hello-unprioritize'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_rsvp_refresh_interval_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.rsvp', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'refresh-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_rsvp_refresh_multiple_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.rsvp', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'refresh-multiple'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_rsvp_refresh_reduction_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.rsvp.g_refresh_reduction', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_rsvp_refresh_reduction_all_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.rsvp.g_refresh_reduction', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'all'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_rsvp_refresh_reduction_bundle_message_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.rsvp.g_refresh_reduction.bundle_message', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_rsvp_refresh_reduction_bundle_message_bundle_send_delay_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.rsvp.g_refresh_reduction.bundle_message', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bundle-send-delay'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_rsvp_refresh_reduction_summary_refresh_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.rsvp.g_refresh_reduction', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'summary-refresh'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_rsvp_reliable_messaging_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.rsvp.g_reliable_messaging', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_rsvp_reliable_messaging_rapid_retrans_decay_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.rsvp.g_reliable_messaging', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rapid-retrans-decay'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_rsvp_reliable_messaging_rapid_retrans_interval_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.rsvp.g_reliable_messaging', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rapid-retrans-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_mpls_rsvp_reliable_messaging_rapid_retry_limit_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.mpls_config.router.mpls.mpls_cmds_holder.rsvp.g_reliable_messaging', 'pybind.slxos.v16r_1_00b.brocade_mpls', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rapid-retry-limit'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ospf', 'keyval': 'vrf', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_area_delete(self, ospf=None, area=None, normal=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    **Instance Keyword Argument Tuple**:

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    **Instance Argument(s)**:

    :type normal: YANGBool
    :param normal: Keyword argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.area', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'area', 'keyval': 'area_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area, normal=normal)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area, normal=normal)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_area_normal_delete(self, ospf=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    **Instance Keyword Argument Tuple**:

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.area', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'area', 'keyval': 'area_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'normal'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_area_nssa_default_information_originate_delete(self, ospf=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v16r_1_00b.routing_system.router.ospf.area', u'area')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.area.nssa', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'default-information-originate'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_area_nssa_metric_delete(self, ospf=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v16r_1_00b.routing_system.router.ospf.area', u'area')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.area.nssa.metric', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'nssa_value, no_summary1'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_area_nssa_no_summary_delete(self, ospf=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v16r_1_00b.routing_system.router.ospf.area', u'area')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.area.nssa.metric', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'no-summary'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_area_nssa_nssa_value_delete(self, ospf=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v16r_1_00b.routing_system.router.ospf.area', u'area')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.area.nssa.metric', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'nssa-value'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_area_prefix_list_in_delete(self, ospf=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v16r_1_00b.routing_system.router.ospf.area', u'area')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.area.prefix_list.direction_in', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'in'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_area_prefix_list_out_delete(self, ospf=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v16r_1_00b.routing_system.router.ospf.area', u'area')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.area.prefix_list.direction_out', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'out'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_area_prefix_list_prefix_list_delete(self, ospf=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v16r_1_00b.routing_system.router.ospf.area', u'area')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.area.prefix_list.direction_in', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'prefix-list'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_area_prefix_list_prefix_list_direction_out_delete(self, ospf=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v16r_1_00b.routing_system.router.ospf.area', u'area')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.area.prefix_list.direction_out', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'prefix-list'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_area_range_delete(self, ospf=None, area=None, range=None, range_effect=None, range_cost=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    **Instance Keyword Argument Tuple**:

    :type range: range_address, range_mask, range_effect, range_cost
    :param range: Keyword argument tuple.

    :type range_address: unicode
    :param range_address: **range** tuple argument:  A.B.C.D   IP address to match

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type range_mask: unicode
    :param range_mask: **range** tuple argument:  A.B.C.D   IP mask for address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type range_effect: unicode
    :param range_effect: **range** tuple argument:  Advertise/Do not advertise this type-3 summarization

        * enumeration restriction: ::

            ['advertise', 'not-advertise']

    :type range_cost: long
    :param range_cost: **range** tuple argument:  Configure area range cost

        * range restriction: ::

            ['0..4294967295']

    **Instance Argument(s)**:

    :type range_effect: unicode
    :param range_effect: Advertise/Do not advertise this type-3 summarization

        * enumeration restriction: ::

            ['advertise', 'not-advertise']

    :type range_cost: long
    :param range_cost: Configure area range cost

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v16r_1_00b.routing_system.router.ospf.area', u'area')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.area.range', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'range', 'keyval': 'range_address, range_mask', 'extra_keyval': 'range_address, range_mask, range_effect, range_cost'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area, range=range, range_effect=range_effect, range_cost=range_cost)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area, range=range, range_effect=range_effect, range_cost=range_cost)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_area_range_cost_delete(self, ospf=None, area=None, range=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    **Instance Keyword Argument Tuple**:

    :type range: range_address, range_mask
    :param range: Keyword argument tuple.

    :type range_address: unicode
    :param range_address: **range** tuple argument:  A.B.C.D   IP address to match

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type range_mask: unicode
    :param range_mask: **range** tuple argument:  A.B.C.D   IP mask for address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v16r_1_00b.routing_system.router.ospf.area', u'area')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.area.range', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'range', 'keyval': 'range_address, range_mask', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cost'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area, range=range)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area, range=range)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_area_range_range_effect_delete(self, ospf=None, area=None, range=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    **Instance Keyword Argument Tuple**:

    :type range: range_address, range_mask
    :param range: Keyword argument tuple.

    :type range_address: unicode
    :param range_address: **range** tuple argument:  A.B.C.D   IP address to match

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type range_mask: unicode
    :param range_mask: **range** tuple argument:  A.B.C.D   IP mask for address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v16r_1_00b.routing_system.router.ospf.area', u'area')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.area.range', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'range', 'keyval': 'range_address, range_mask', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'range-effect'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area, range=range)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area, range=range)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_area_stub_delete(self, ospf=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v16r_1_00b.routing_system.router.ospf.area', u'area')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.area.stub', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_area_stub_metric_delete(self, ospf=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v16r_1_00b.routing_system.router.ospf.area', u'area')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.area.stub.metric', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'stub_value, no_summary'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_area_stub_no_summary_delete(self, ospf=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v16r_1_00b.routing_system.router.ospf.area', u'area')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.area.stub.metric', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'no-summary'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_area_stub_stub_value_delete(self, ospf=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v16r_1_00b.routing_system.router.ospf.area', u'area')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.area.stub.metric', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'stub-value'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_area_virtual_link_delete(self, ospf=None, area=None, virtual_link=None, hello_interval=None, dead_interval=None, retransmit_interval=None, transmit_delay=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    **Instance Keyword Argument Tuple**:

    :type virtual_link: virt_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virt_link_neighbor: unicode
    :param virt_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Argument(s)**:

    :type hello_interval: long
    :param hello_interval: Time between HELLO packets

        * range restriction: ::

            ['0..4294967295']

    :type dead_interval: long
    :param dead_interval: Interval after which a neighbor is declared dead

        * range restriction: ::

            ['0..4294967295']

    :type retransmit_interval: long
    :param retransmit_interval: Time between retransmitting lost link state   advertisements

        * range restriction: ::

            ['0..4294967295']

    :type transmit_delay: long
    :param transmit_delay: Link state transmit delay

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v16r_1_00b.routing_system.router.ospf.area', u'area')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.area.virtual_link', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'virtual_link', 'keyval': 'virt_link_neighbor', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area, virtual_link=virtual_link, hello_interval=hello_interval, dead_interval=dead_interval, retransmit_interval=retransmit_interval, transmit_delay=transmit_delay)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area, virtual_link=virtual_link, hello_interval=hello_interval, dead_interval=dead_interval, retransmit_interval=retransmit_interval, transmit_delay=transmit_delay)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_area_virtual_link_authentication_key_delete(self, ospf=None, area=None, virtual_link=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virt_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virt_link_neighbor: unicode
    :param virt_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v16r_1_00b.routing_system.router.ospf.area', u'area'), ('pybind.slxos.v16r_1_00b.routing_system.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.area.virtual_link.authentication_key', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_area_virtual_link_authentication_key_auth_key_delete(self, ospf=None, area=None, virtual_link=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virt_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virt_link_neighbor: unicode
    :param virt_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v16r_1_00b.routing_system.router.ospf.area', u'area'), ('pybind.slxos.v16r_1_00b.routing_system.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.area.virtual_link.authentication_key.auth_key_table', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'auth-key'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_area_virtual_link_authentication_key_auth_key_table_delete(self, ospf=None, area=None, virtual_link=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virt_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virt_link_neighbor: unicode
    :param virt_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v16r_1_00b.routing_system.router.ospf.area', u'area'), ('pybind.slxos.v16r_1_00b.routing_system.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.area.virtual_link.authentication_key.auth_key_table', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'encrypttype, auth_key'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_area_virtual_link_authentication_key_encrypttype_delete(self, ospf=None, area=None, virtual_link=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virt_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virt_link_neighbor: unicode
    :param virt_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v16r_1_00b.routing_system.router.ospf.area', u'area'), ('pybind.slxos.v16r_1_00b.routing_system.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.area.virtual_link.authentication_key.auth_key_table', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'encrypttype'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_area_virtual_link_authentication_key_no_encrypt_auth_key_delete(self, ospf=None, area=None, virtual_link=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virt_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virt_link_neighbor: unicode
    :param virt_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v16r_1_00b.routing_system.router.ospf.area', u'area'), ('pybind.slxos.v16r_1_00b.routing_system.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.area.virtual_link.authentication_key.no_encrypt_auth_key_table', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'no-encrypt-auth-key'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_area_virtual_link_authentication_key_no_encrypt_auth_key_table_delete(self, ospf=None, area=None, virtual_link=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virt_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virt_link_neighbor: unicode
    :param virt_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v16r_1_00b.routing_system.router.ospf.area', u'area'), ('pybind.slxos.v16r_1_00b.routing_system.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.area.virtual_link.authentication_key.no_encrypt_auth_key_table', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_area_virtual_link_dead_interval_delete(self, ospf=None, area=None, virtual_link=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    **Instance Keyword Argument Tuple**:

    :type virtual_link: virt_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virt_link_neighbor: unicode
    :param virt_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v16r_1_00b.routing_system.router.ospf.area', u'area')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.area.virtual_link', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'virtual_link', 'keyval': 'virt_link_neighbor', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dead-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_area_virtual_link_hello_interval_delete(self, ospf=None, area=None, virtual_link=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    **Instance Keyword Argument Tuple**:

    :type virtual_link: virt_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virt_link_neighbor: unicode
    :param virt_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v16r_1_00b.routing_system.router.ospf.area', u'area')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.area.virtual_link', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'virtual_link', 'keyval': 'virt_link_neighbor', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hello-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_area_virtual_link_md5_authentication_key_activation_wait_time_delete(self, ospf=None, area=None, virtual_link=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virt_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virt_link_neighbor: unicode
    :param virt_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v16r_1_00b.routing_system.router.ospf.area', u'area'), ('pybind.slxos.v16r_1_00b.routing_system.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.area.virtual_link.md5_authentication', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'key-activation-wait-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_area_virtual_link_md5_authentication_key_id_delete(self, ospf=None, area=None, virtual_link=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virt_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virt_link_neighbor: unicode
    :param virt_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v16r_1_00b.routing_system.router.ospf.area', u'area'), ('pybind.slxos.v16r_1_00b.routing_system.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.area.virtual_link.md5_authentication.key_table', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'key_id, key, md5_authentication_key'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_area_virtual_link_md5_authentication_key_id_key_delete(self, ospf=None, area=None, virtual_link=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virt_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virt_link_neighbor: unicode
    :param virt_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v16r_1_00b.routing_system.router.ospf.area', u'area'), ('pybind.slxos.v16r_1_00b.routing_system.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.area.virtual_link.md5_authentication.key_table', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'key'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_area_virtual_link_md5_authentication_key_id_key_id_delete(self, ospf=None, area=None, virtual_link=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virt_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virt_link_neighbor: unicode
    :param virt_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v16r_1_00b.routing_system.router.ospf.area', u'area'), ('pybind.slxos.v16r_1_00b.routing_system.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.area.virtual_link.md5_authentication.key_table', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'key-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_area_virtual_link_md5_authentication_no_encrypt_key_delete(self, ospf=None, area=None, virtual_link=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virt_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virt_link_neighbor: unicode
    :param virt_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v16r_1_00b.routing_system.router.ospf.area', u'area'), ('pybind.slxos.v16r_1_00b.routing_system.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.area.virtual_link.md5_authentication.no_encrypt_key_table', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'no-encrypt-key'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_area_virtual_link_md5_authentication_no_encrypt_key_id_delete(self, ospf=None, area=None, virtual_link=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virt_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virt_link_neighbor: unicode
    :param virt_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v16r_1_00b.routing_system.router.ospf.area', u'area'), ('pybind.slxos.v16r_1_00b.routing_system.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.area.virtual_link.md5_authentication.no_encrypt_key_table', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'no-encrypt-key-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_area_virtual_link_retransmit_interval_delete(self, ospf=None, area=None, virtual_link=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    **Instance Keyword Argument Tuple**:

    :type virtual_link: virt_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virt_link_neighbor: unicode
    :param virt_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v16r_1_00b.routing_system.router.ospf.area', u'area')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.area.virtual_link', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'virtual_link', 'keyval': 'virt_link_neighbor', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'retransmit-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_area_virtual_link_transmit_delay_delete(self, ospf=None, area=None, virtual_link=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    **Instance Keyword Argument Tuple**:

    :type virtual_link: virt_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virt_link_neighbor: unicode
    :param virt_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v16r_1_00b.routing_system.router.ospf.area', u'area')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.area.virtual_link', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'virtual_link', 'keyval': 'virt_link_neighbor', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'transmit-delay'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_auto_cost_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.auto_cost', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_auto_cost_reference_bandwidth_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.auto_cost.reference_bandwidth', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_auto_cost_reference_bandwidth_ref_bandwidth_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.auto_cost.reference_bandwidth', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ref-bandwidth'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_auto_cost_reference_bandwidth_use_active_ports_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.auto_cost.reference_bandwidth', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'use-active-ports'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_bfd_bfd_enable_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.global_bfd', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'bfd-enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_bfd_holdover_interval_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.global_bfd', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'holdover-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_database_overflow_interval_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ospf', 'keyval': 'vrf', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'database-overflow-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_default_information_originate_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.default_information_originate', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'always, def_orig_metric, def_orig_metric_type, def_orig_route_map'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_default_information_originate_always_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.default_information_originate', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'always'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_default_information_originate_metric_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.default_information_originate', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_default_information_originate_metric_type_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.default_information_originate', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_default_information_originate_route_map_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.default_information_originate', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_default_metric_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ospf', 'keyval': 'vrf', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'default-metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_default_passive_interface_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ospf', 'keyval': 'vrf', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'default-passive-interface'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_deny_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.deny', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_deny_redistribute_delete(self, ospf=None, redistribute=None, address=None, mask=None, set_metric_val=None, match_metric_val=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    **Instance Keyword Argument Tuple**:

    :type redistribute: redist_value, route_option, address, mask, set_metric_val, match_metric_val
    :param redistribute: Keyword argument tuple.

    :type redist_value: long
    :param redist_value: **redistribute** tuple argument:  Number

        * range restriction: ::

            ['0..4294967295']

    :type route_option: unicode
    :param route_option: **redistribute** tuple argument:  OSPF route option

        * enumeration restriction: ::

            ['connected', 'all', 'static']

    :type address: unicode
    :param address: **redistribute** tuple argument:  IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type mask: unicode
    :param mask: **redistribute** tuple argument:  Subnet Mask

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type set_metric_val: long
    :param set_metric_val: **redistribute** tuple argument:  Metric value

        * range restriction: ::

            ['0..4294967295']

    :type match_metric_val: long
    :param match_metric_val: **redistribute** tuple argument:  Metric value

        * range restriction: ::

            ['0..4294967295']

    **Instance Argument(s)**:

    :type address: unicode
    :param address: IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type mask: unicode
    :param mask: Subnet Mask

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type set_metric_val: long
    :param set_metric_val: Metric value

        * range restriction: ::

            ['0..4294967295']

    :type match_metric_val: long
    :param match_metric_val: Metric value

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.deny.redistribute', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'redistribute', 'keyval': 'redist_value, route_option', 'extra_keyval': 'redist_value, route_option, address, mask, set_metric_val, match_metric_val'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, redistribute=redistribute, address=address, mask=mask, set_metric_val=set_metric_val, match_metric_val=match_metric_val)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, redistribute=redistribute, address=address, mask=mask, set_metric_val=set_metric_val, match_metric_val=match_metric_val)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_deny_redistribute_address_delete(self, ospf=None, redistribute=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    **Instance Keyword Argument Tuple**:

    :type redistribute: redist_value, route_option
    :param redistribute: Keyword argument tuple.

    :type redist_value: long
    :param redist_value: **redistribute** tuple argument:  Number

        * range restriction: ::

            ['0..4294967295']

    :type route_option: unicode
    :param route_option: **redistribute** tuple argument:  OSPF route option

        * enumeration restriction: ::

            ['connected', 'all', 'static']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.deny.redistribute', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'redistribute', 'keyval': 'redist_value, route_option', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'address'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, redistribute=redistribute)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, redistribute=redistribute)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_deny_redistribute_mask_delete(self, ospf=None, redistribute=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    **Instance Keyword Argument Tuple**:

    :type redistribute: redist_value, route_option
    :param redistribute: Keyword argument tuple.

    :type redist_value: long
    :param redist_value: **redistribute** tuple argument:  Number

        * range restriction: ::

            ['0..4294967295']

    :type route_option: unicode
    :param route_option: **redistribute** tuple argument:  OSPF route option

        * enumeration restriction: ::

            ['connected', 'all', 'static']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.deny.redistribute', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'redistribute', 'keyval': 'redist_value, route_option', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mask'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, redistribute=redistribute)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, redistribute=redistribute)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_deny_redistribute_match_metric_delete(self, ospf=None, redistribute=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    **Instance Keyword Argument Tuple**:

    :type redistribute: redist_value, route_option
    :param redistribute: Keyword argument tuple.

    :type redist_value: long
    :param redist_value: **redistribute** tuple argument:  Number

        * range restriction: ::

            ['0..4294967295']

    :type route_option: unicode
    :param route_option: **redistribute** tuple argument:  OSPF route option

        * enumeration restriction: ::

            ['connected', 'all', 'static']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.deny.redistribute', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'redistribute', 'keyval': 'redist_value, route_option', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'match-metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, redistribute=redistribute)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, redistribute=redistribute)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_deny_redistribute_set_metric_delete(self, ospf=None, redistribute=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    **Instance Keyword Argument Tuple**:

    :type redistribute: redist_value, route_option
    :param redistribute: Keyword argument tuple.

    :type redist_value: long
    :param redist_value: **redistribute** tuple argument:  Number

        * range restriction: ::

            ['0..4294967295']

    :type route_option: unicode
    :param route_option: **redistribute** tuple argument:  OSPF route option

        * enumeration restriction: ::

            ['connected', 'all', 'static']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.deny.redistribute', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'redistribute', 'keyval': 'redist_value, route_option', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'set-metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, redistribute=redistribute)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, redistribute=redistribute)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_distance_delete(self, ospf=None, distance=None, dist_value=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    **Instance Keyword Argument Tuple**:

    :type distance: route_type
    :param distance: Keyword argument tuple.

    :type route_type: unicode
    :param route_type: **distance** tuple argument:  The type of route propogation

        * enumeration restriction: ::

            ['intra-area', 'external', 'inter-area']

    **Instance Argument(s)**:

    :type dist_value: long
    :param dist_value: The distance for a given type of route

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.distance', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'distance', 'keyval': 'route_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, distance=distance, dist_value=dist_value)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, distance=distance, dist_value=dist_value)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_distance_dist_value_delete(self, ospf=None, distance=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    **Instance Keyword Argument Tuple**:

    :type distance: route_type
    :param distance: Keyword argument tuple.

    :type route_type: unicode
    :param route_type: **distance** tuple argument:  The type of route propogation

        * enumeration restriction: ::

            ['intra-area', 'external', 'inter-area']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.distance', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'distance', 'keyval': 'route_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dist-value'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, distance=distance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, distance=distance)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_distribute_list_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.distribute_list', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_distribute_list_route_map_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.distribute_list.route_map', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'route_map, input'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_distribute_list_route_map_in_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.distribute_list.route_map', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'in'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_distribute_list_route_map_route_map_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.distribute_list.route_map', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_external_lsdb_limit_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ospf', 'keyval': 'vrf', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'external-lsdb-limit'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_graceful_restart_graceful_restart_enable_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.graceful_restart', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'graceful-restart-enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_graceful_restart_helper_disable_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.graceful_restart', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'helper-disable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_graceful_restart_restart_time_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.graceful_restart', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'restart-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_ldp_sync_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.ldp_sync', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'ldp_sync_hold_down'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_ldp_sync_hold_down_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.ldp_sync', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hold-down'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_log_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.log', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_log_adjacency_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.log.adjacency', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_log_adjacency_dr_only_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.log.adjacency', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dr-only'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_log_all_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.log', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'all'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_log_bad_packet_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.log.bad_packet', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_log_bad_packet_checksum_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.log.bad_packet', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'checksum'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_log_database_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.log', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'database'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_log_retransmit_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.log', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'retransmit'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_max_metric_router_lsa_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.max_metric.router_lsa', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_max_metric_router_lsa_all_lsas_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.max_metric.router_lsa', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'all-lsas'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_max_metric_router_lsa_all_vrfs_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.max_metric.router_lsa', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'all-vrfs'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_max_metric_router_lsa_external_lsa_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.max_metric.router_lsa.external_lsa', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_max_metric_router_lsa_external_lsa_external_lsa_val_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.max_metric.router_lsa.external_lsa', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'external-lsa-val'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_max_metric_router_lsa_link_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.max_metric.router_lsa.link', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_max_metric_router_lsa_link_all_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.max_metric.router_lsa.link', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'all'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_max_metric_router_lsa_link_ptp_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.max_metric.router_lsa.link', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ptp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_max_metric_router_lsa_link_stub_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.max_metric.router_lsa.link', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'stub'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_max_metric_router_lsa_link_transit_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.max_metric.router_lsa.link', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'transit'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_max_metric_router_lsa_on_startup_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.max_metric.router_lsa.on_startup', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_max_metric_router_lsa_on_startup_all_lsas_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.max_metric.router_lsa.on_startup', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'all-lsas'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_max_metric_router_lsa_on_startup_external_lsa_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.max_metric.router_lsa.on_startup.external_lsa_onstartup', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_max_metric_router_lsa_on_startup_external_lsa_external_lsa_val_onstartup_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.max_metric.router_lsa.on_startup.external_lsa_onstartup', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'external-lsa-val-onstartup'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_max_metric_router_lsa_on_startup_link_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.max_metric.router_lsa.on_startup.link_onstartup', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_max_metric_router_lsa_on_startup_link_all_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.max_metric.router_lsa.on_startup.link_onstartup', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'all'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_max_metric_router_lsa_on_startup_link_ptp_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.max_metric.router_lsa.on_startup.link_onstartup', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ptp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_max_metric_router_lsa_on_startup_link_stub_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.max_metric.router_lsa.on_startup.link_onstartup', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'stub'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_max_metric_router_lsa_on_startup_link_transit_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.max_metric.router_lsa.on_startup.link_onstartup', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'transit'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_max_metric_router_lsa_on_startup_summary_lsa_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.max_metric.router_lsa.on_startup.summary_lsa_onstartup', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_max_metric_router_lsa_on_startup_summary_lsa_summary_lsa_val_onstartup_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.max_metric.router_lsa.on_startup.summary_lsa_onstartup', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'summary-lsa-val-onstartup'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_max_metric_router_lsa_on_startup_time_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.max_metric.router_lsa.on_startup', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_max_metric_router_lsa_on_startup_wait_for_bgp_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.max_metric.router_lsa.on_startup', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'wait-for-bgp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_max_metric_router_lsa_summary_lsa_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.max_metric.router_lsa.summary_lsa', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_max_metric_router_lsa_summary_lsa_summary_lsa_val_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.max_metric.router_lsa.summary_lsa', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'summary-lsa-val'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_maximum_paths_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ospf', 'keyval': 'vrf', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'maximum-paths'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_metric_type_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ospf', 'keyval': 'vrf', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_neighbor_delete(self, ospf=None, neighbor=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    **Instance Keyword Argument Tuple**:

    :type neighbor: neighbor_addr
    :param neighbor: Keyword argument tuple.

    :type neighbor_addr: unicode
    :param neighbor_addr: **neighbor** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.neighbor', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'neighbor', 'keyval': 'neighbor_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, neighbor=neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, neighbor=neighbor)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_nonstop_routing_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ospf', 'keyval': 'vrf', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'nonstop-routing'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_permit_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.permit', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_permit_redistribute_delete(self, ospf=None, redistribute=None, address=None, mask=None, set_metric_val=None, match_metric_val=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    **Instance Keyword Argument Tuple**:

    :type redistribute: redist_value, route_option, address, mask, set_metric_val, match_metric_val
    :param redistribute: Keyword argument tuple.

    :type redist_value: long
    :param redist_value: **redistribute** tuple argument:  Number

        * range restriction: ::

            ['0..4294967295']

    :type route_option: unicode
    :param route_option: **redistribute** tuple argument:  OSPF route option

        * enumeration restriction: ::

            ['connected', 'all', 'static']

    :type address: unicode
    :param address: **redistribute** tuple argument:  IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type mask: unicode
    :param mask: **redistribute** tuple argument:  Subnet Mask

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type set_metric_val: long
    :param set_metric_val: **redistribute** tuple argument:  Metric value

        * range restriction: ::

            ['0..4294967295']

    :type match_metric_val: long
    :param match_metric_val: **redistribute** tuple argument:  Metric value

        * range restriction: ::

            ['0..4294967295']

    **Instance Argument(s)**:

    :type address: unicode
    :param address: IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type mask: unicode
    :param mask: Subnet Mask

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type set_metric_val: long
    :param set_metric_val: Metric value

        * range restriction: ::

            ['0..4294967295']

    :type match_metric_val: long
    :param match_metric_val: Metric value

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.permit.redistribute', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'redistribute', 'keyval': 'redist_value, route_option', 'extra_keyval': 'redist_value, route_option, address, mask, set_metric_val, match_metric_val'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, redistribute=redistribute, address=address, mask=mask, set_metric_val=set_metric_val, match_metric_val=match_metric_val)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, redistribute=redistribute, address=address, mask=mask, set_metric_val=set_metric_val, match_metric_val=match_metric_val)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_permit_redistribute_address_delete(self, ospf=None, redistribute=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    **Instance Keyword Argument Tuple**:

    :type redistribute: redist_value, route_option
    :param redistribute: Keyword argument tuple.

    :type redist_value: long
    :param redist_value: **redistribute** tuple argument:  Number

        * range restriction: ::

            ['0..4294967295']

    :type route_option: unicode
    :param route_option: **redistribute** tuple argument:  OSPF route option

        * enumeration restriction: ::

            ['connected', 'all', 'static']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.permit.redistribute', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'redistribute', 'keyval': 'redist_value, route_option', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'address'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, redistribute=redistribute)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, redistribute=redistribute)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_permit_redistribute_mask_delete(self, ospf=None, redistribute=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    **Instance Keyword Argument Tuple**:

    :type redistribute: redist_value, route_option
    :param redistribute: Keyword argument tuple.

    :type redist_value: long
    :param redist_value: **redistribute** tuple argument:  Number

        * range restriction: ::

            ['0..4294967295']

    :type route_option: unicode
    :param route_option: **redistribute** tuple argument:  OSPF route option

        * enumeration restriction: ::

            ['connected', 'all', 'static']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.permit.redistribute', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'redistribute', 'keyval': 'redist_value, route_option', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mask'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, redistribute=redistribute)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, redistribute=redistribute)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_permit_redistribute_match_metric_delete(self, ospf=None, redistribute=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    **Instance Keyword Argument Tuple**:

    :type redistribute: redist_value, route_option
    :param redistribute: Keyword argument tuple.

    :type redist_value: long
    :param redist_value: **redistribute** tuple argument:  Number

        * range restriction: ::

            ['0..4294967295']

    :type route_option: unicode
    :param route_option: **redistribute** tuple argument:  OSPF route option

        * enumeration restriction: ::

            ['connected', 'all', 'static']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.permit.redistribute', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'redistribute', 'keyval': 'redist_value, route_option', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'match-metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, redistribute=redistribute)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, redistribute=redistribute)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_permit_redistribute_set_metric_delete(self, ospf=None, redistribute=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    **Instance Keyword Argument Tuple**:

    :type redistribute: redist_value, route_option
    :param redistribute: Keyword argument tuple.

    :type redist_value: long
    :param redist_value: **redistribute** tuple argument:  Number

        * range restriction: ::

            ['0..4294967295']

    :type route_option: unicode
    :param route_option: **redistribute** tuple argument:  OSPF route option

        * enumeration restriction: ::

            ['connected', 'all', 'static']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.permit.redistribute', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'redistribute', 'keyval': 'redist_value, route_option', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'set-metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, redistribute=redistribute)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, redistribute=redistribute)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_redistribute_bgp_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.redistribute.bgp', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_redistribute_bgp_route_map_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.redistribute.bgp', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_redistribute_connected_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.redistribute.connected', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_redistribute_connected_route_map_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.redistribute.connected', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_redistribute_isis_level_1_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.redistribute.isis', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'level-1'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_redistribute_isis_level_1_2_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.redistribute.isis', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'level-1-2'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_redistribute_isis_level_2_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.redistribute.isis', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'level-2'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_redistribute_isis_route_map_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.redistribute.isis', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_redistribute_ospf_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.redistribute.redistribute_ospf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_redistribute_ospf_route_map_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.redistribute.redistribute_ospf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_redistribute_static_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.redistribute.static', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_redistribute_static_route_map_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.redistribute.static', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'route-map'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_rfc1583_compatibility_rfc1583_compatibility_flag_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.rfc1583_compatibility', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rfc1583-compatibility-flag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_summary_address_delete(self, ospf=None, summary_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    **Instance Keyword Argument Tuple**:

    :type summary_address: sum_address, sum_address_mask
    :param summary_address: Keyword argument tuple.

    :type sum_address: unicode
    :param sum_address: **summary_address** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type sum_address_mask: unicode
    :param sum_address_mask: **summary_address** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.summary_address', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'summary_address', 'keyval': 'sum_address, sum_address_mask', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, summary_address=summary_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, summary_address=summary_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_timers_lsa_group_pacing_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.timers', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lsa-group-pacing'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_timers_throttle_spf_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.timers.throttle.spf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'init_delay, hold_time, max_hold_time'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_timers_throttle_spf_hold_time_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.timers.throttle.spf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hold-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_timers_throttle_spf_init_delay_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.timers.throttle.spf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'init-delay'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_timers_throttle_spf_max_hold_time_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf.timers.throttle.spf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'max-hold-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_ospf_vrf_lite_capability_delete(self, ospf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.ospf', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ospf', 'keyval': 'vrf', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vrf-lite-capability'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_pim_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.hide_pim_holder.pim', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_pim_anycast_rp_delete(self, anycast_rp=None, anycast_prefix_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type anycast_rp: anycast_ip_addr, anycast_prefix_list
    :param anycast_rp: Keyword argument tuple.

    :type anycast_ip_addr: unicode
    :param anycast_ip_addr: **anycast_rp** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type anycast_prefix_list: unicode
    :param anycast_prefix_list: **anycast_rp** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    **Instance Argument(s)**:

    :type anycast_prefix_list: unicode
    :param anycast_prefix_list: Keyword argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.hide_pim_holder.pim.anycast_rp', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'anycast_rp', 'keyval': 'anycast_ip_addr', 'extra_keyval': 'anycast_ip_addr, anycast_prefix_list'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, anycast_rp=anycast_rp, anycast_prefix_list=anycast_prefix_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, anycast_rp=anycast_rp, anycast_prefix_list=anycast_prefix_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_pim_anycast_rp_anycast_prefix_list_delete(self, anycast_rp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type anycast_rp: anycast_ip_addr
    :param anycast_rp: Keyword argument tuple.

    :type anycast_ip_addr: unicode
    :param anycast_ip_addr: **anycast_rp** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.hide_pim_holder.pim.anycast_rp', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'anycast_rp', 'keyval': 'anycast_ip_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'anycast-prefix-list'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, anycast_rp=anycast_rp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, anycast_rp=anycast_rp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_pim_anycast_rp_ip_delete(self, anycast_rp_ip=None, anycast_peer_ip_addr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type anycast_rp_ip: anycast_rp_ip_addr
    :param anycast_rp_ip: Keyword argument tuple.

    :type anycast_rp_ip_addr: unicode
    :param anycast_rp_ip_addr: **anycast_rp_ip** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Argument(s)**:

    :type anycast_peer_ip_addr: unicode
    :param anycast_peer_ip_addr: Keyword argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.hide_pim_holder.pim.anycast_rp_ip', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'anycast_rp_ip', 'keyval': 'anycast_rp_ip_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, anycast_rp_ip=anycast_rp_ip, anycast_peer_ip_addr=anycast_peer_ip_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, anycast_rp_ip=anycast_rp_ip, anycast_peer_ip_addr=anycast_peer_ip_addr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_pim_anycast_rp_ip_anycast_peer_ip_addr_delete(self, anycast_rp_ip=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type anycast_rp_ip: anycast_rp_ip_addr
    :param anycast_rp_ip: Keyword argument tuple.

    :type anycast_rp_ip_addr: unicode
    :param anycast_rp_ip_addr: **anycast_rp_ip** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.hide_pim_holder.pim.anycast_rp_ip', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'anycast_rp_ip', 'keyval': 'anycast_rp_ip_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'anycast-peer-ip-addr'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, anycast_rp_ip=anycast_rp_ip)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, anycast_rp_ip=anycast_rp_ip)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_pim_bsr_candidate_interface_delete(self, bsr_cand_interface=None, hash_mask_length=None, bsr_cand_priority=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type bsr_cand_interface: bsr_cand_intf_type, bsr_cand_intf_id, hash_mask_length, bsr_cand_priority
    :param bsr_cand_interface: Keyword argument tuple.

    :type bsr_cand_intf_type: unicode
    :param bsr_cand_intf_type: **bsr_cand_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 'port-channel', 've', 'loopback']

    :type bsr_cand_intf_id: unicode
    :param bsr_cand_intf_id: **bsr_cand_interface** tuple argument:  Interface name in slot/port format for ethernet or port-channel/ve/loopback interface number

    :type hash_mask_length: int
    :param hash_mask_length: **bsr_cand_interface** tuple argument:  BSR hash mask

        * range restriction: ::

            ['0..65535']

    :type bsr_cand_priority: long
    :param bsr_cand_priority: **bsr_cand_interface** tuple argument:  BSR priority

        * range restriction: ::

            ['0..4294967295']

    **Instance Argument(s)**:

    :type hash_mask_length: int
    :param hash_mask_length: BSR hash mask

        * range restriction: ::

            ['0..65535']

    :type bsr_cand_priority: long
    :param bsr_cand_priority: BSR priority

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.hide_pim_holder.pim.bsr_candidate.bsr_cand_interface', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'bsr_cand_interface', 'keyval': 'bsr_cand_intf_type, bsr_cand_intf_id', 'extra_keyval': 'bsr_cand_intf_type, bsr_cand_intf_id, hash_mask_length, bsr_cand_priority'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bsr_cand_interface=bsr_cand_interface, hash_mask_length=hash_mask_length, bsr_cand_priority=bsr_cand_priority)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bsr_cand_interface=bsr_cand_interface, hash_mask_length=hash_mask_length, bsr_cand_priority=bsr_cand_priority)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_pim_bsr_candidate_interface_mask_delete(self, bsr_cand_interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type bsr_cand_interface: bsr_cand_intf_type, bsr_cand_intf_id
    :param bsr_cand_interface: Keyword argument tuple.

    :type bsr_cand_intf_type: unicode
    :param bsr_cand_intf_type: **bsr_cand_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 'port-channel', 've', 'loopback']

    :type bsr_cand_intf_id: unicode
    :param bsr_cand_intf_id: **bsr_cand_interface** tuple argument:  Interface name in slot/port format for ethernet or port-channel/ve/loopback interface number

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.hide_pim_holder.pim.bsr_candidate.bsr_cand_interface', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'bsr_cand_interface', 'keyval': 'bsr_cand_intf_type, bsr_cand_intf_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mask'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bsr_cand_interface=bsr_cand_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bsr_cand_interface=bsr_cand_interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_pim_bsr_candidate_interface_priority_delete(self, bsr_cand_interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type bsr_cand_interface: bsr_cand_intf_type, bsr_cand_intf_id
    :param bsr_cand_interface: Keyword argument tuple.

    :type bsr_cand_intf_type: unicode
    :param bsr_cand_intf_type: **bsr_cand_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 'port-channel', 've', 'loopback']

    :type bsr_cand_intf_id: unicode
    :param bsr_cand_intf_id: **bsr_cand_interface** tuple argument:  Interface name in slot/port format for ethernet or port-channel/ve/loopback interface number

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.hide_pim_holder.pim.bsr_candidate.bsr_cand_interface', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'bsr_cand_interface', 'keyval': 'bsr_cand_intf_type, bsr_cand_intf_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bsr_cand_interface=bsr_cand_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bsr_cand_interface=bsr_cand_interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_pim_hello_interval_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.hide_pim_holder.pim', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hello-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_pim_inactivity_timer_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.hide_pim_holder.pim', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'inactivity-timer'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_pim_max_mcache_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.hide_pim_holder.pim', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'max-mcache'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_pim_message_interval_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.hide_pim_holder.pim', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'message-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_pim_nbr_timeout_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.hide_pim_holder.pim', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'nbr-timeout'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_pim_prune_wait_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.hide_pim_holder.pim', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'prune-wait'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_pim_route_precedence_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.hide_pim_holder.pim.route_precedence', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'uc_default, uc_non_default, none'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_pim_route_precedence_none_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.hide_pim_holder.pim.route_precedence', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'none'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_pim_route_precedence_uc_default_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.hide_pim_holder.pim.route_precedence', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'uc-default'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_pim_route_precedence_uc_non_default_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.hide_pim_holder.pim.route_precedence', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'uc-non-default'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_pim_rp_address_delete(self, rp_address=None, rp_addr_prefix_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type rp_address: rp_ip_addr, rp_addr_prefix_list
    :param rp_address: Keyword argument tuple.

    :type rp_ip_addr: unicode
    :param rp_ip_addr: **rp_address** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type rp_addr_prefix_list: unicode
    :param rp_addr_prefix_list: **rp_address** tuple argument:  Prefix list

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    **Instance Argument(s)**:

    :type rp_addr_prefix_list: unicode
    :param rp_addr_prefix_list: Prefix list

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.hide_pim_holder.pim.rp_address', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'rp_address', 'keyval': 'rp_ip_addr', 'extra_keyval': 'rp_ip_addr, rp_addr_prefix_list'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rp_address=rp_address, rp_addr_prefix_list=rp_addr_prefix_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rp_address=rp_address, rp_addr_prefix_list=rp_addr_prefix_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_pim_rp_address_prefix_list_delete(self, rp_address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type rp_address: rp_ip_addr
    :param rp_address: Keyword argument tuple.

    :type rp_ip_addr: unicode
    :param rp_ip_addr: **rp_address** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.hide_pim_holder.pim.rp_address', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'rp_address', 'keyval': 'rp_ip_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'prefix-list'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rp_address=rp_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rp_address=rp_address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_pim_rp_candidate_interface_delete(self, rp_cand_interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type rp_cand_interface: rp_cand_intf_type, rp_cand_intf_id
    :param rp_cand_interface: Keyword argument tuple.

    :type rp_cand_intf_type: unicode
    :param rp_cand_intf_type: **rp_cand_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 'port-channel', 've', 'loopback']

    :type rp_cand_intf_id: unicode
    :param rp_cand_intf_id: **rp_cand_interface** tuple argument:  Interface name in slot/port format for ethernet or port-channel/ve/loopback interface number

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.hide_pim_holder.pim.rp_candidate.rp_cand_interface', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'rp_cand_interface', 'keyval': 'rp_cand_intf_type, rp_cand_intf_id', 'extra_keyval': 'rp_cand_intf_type, rp_cand_intf_id'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rp_cand_interface=rp_cand_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rp_cand_interface=rp_cand_interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_pim_rp_candidate_prefix_delete(self, rp_cand_grp_prefix=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type rp_cand_grp_prefix: rp_cand_prefix_name
    :param rp_cand_grp_prefix: Keyword argument tuple.

    :type rp_cand_prefix_name: unicode
    :param rp_cand_prefix_name: **rp_cand_grp_prefix** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.hide_pim_holder.pim.rp_candidate.rp_cand_grp_prefix', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'rp_cand_grp_prefix', 'keyval': 'rp_cand_prefix_name', 'extra_keyval': 'rp_cand_prefix_name'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rp_cand_grp_prefix=rp_cand_grp_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rp_cand_grp_prefix=rp_cand_grp_prefix)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_pim_rpf_ecmp_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.hide_pim_holder.pim.rpf.ecmp', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_pim_rpf_ecmp_rebalance_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.hide_pim_holder.pim.rpf.ecmp', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rebalance'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_pim_spt_threshold_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.hide_pim_holder.pim', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'spt-threshold'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_pim_ssm_enable_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.hide_pim_holder.pim.ssm_enable', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def router_pim_ssm_enable_range_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system.router.hide_pim_holder.pim.ssm_enable', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'range'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def routing_system_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.routing_system', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rpf_config_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.rpf_config', 'pybind.slxos.v16r_1_00b.brocade_rpf', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rule_delete(self, rule=None, action=None, operation=None, role=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    **Instance Argument(s)**:

    :type action: unicode
    :param action: Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.rule', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rule', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rule', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rule', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'rule', 'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule, action=action, operation=operation, role=role)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule, action=action, operation=operation, role=role)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rule_action_delete(self, rule=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type rule: index
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.rule', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rule', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rule', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rule', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'rule', 'keyval': 'index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'action'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rule_command_delete(self, rule=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rule', 'rule'), ('pybind.nos.v7_0_1b.rule', 'rule'), ('pybind.slxos.v16r_1_00b.rule', 'rule'), ('pybind.nos.v7_1_0.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2c.rule.command', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rule.command', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rule.command', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rule.command', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v16r_1_00b.rule.command': [u'clear_support', u'clear_logging', u'clear_cl', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'protocol_lldp', u'interface_int', u'interface_eth', u'protocol_spanning', u'interface_eth_leaf', u'copy_support', u'copy_cp', u'interface_pc', u'copy_running', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback', u'interface_mgmt', u'interface_fc', u'protocol_pr'], 'pybind.nos.v7_1_0.rule.command': [u'clear_support', u'clear_logging', u'clear_cl', u'show_running', u'show_startupcfg', u'copy_cp', u'show_rb_runcfg', u'show_startupdb', u'show_rb_local_runcfg', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback'], 'pybind.nos.v7_0_1b.rule.command': [u'clear_support', u'clear_logging', u'clear_cl', u'copy_cp', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback'], 'pybind.nos.v6_0_2c.rule.command': [u'clear_support', u'clear_logging', u'clear_cl', u'copy_cp', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rule_command_clear_delete(self, rule=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rule', 'rule'), ('pybind.nos.v7_0_1b.rule', 'rule'), ('pybind.nos.v7_1_0.rule', 'rule'), ('pybind.slxos.v16r_1_00b.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2c.rule.command.clear_logging.clear', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rule.command.clear_logging.clear', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rule.command.clear_logging.clear', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rule.command.clear_logging.clear', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_1_0.rule.command.clear_logging.clear': [u'clear'], 'pybind.nos.v7_0_1b.rule.command.clear_logging.clear': [u'clear'], 'pybind.slxos.v16r_1_00b.rule.command.clear_logging.clear': [u'clear'], 'pybind.nos.v6_0_2c.rule.command.clear_logging.clear': [u'clear']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rule_command_clear_cl_delete(self, rule=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.rule', 'rule'), ('pybind.nos.v7_1_0.rule', 'rule'), ('pybind.nos.v6_0_2c.rule', 'rule'), ('pybind.nos.v7_0_1b.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2c.rule.command.clear_cl', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rule.command.clear_cl', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rule.command.clear_cl', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rule.command.clear_cl', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_0_1b.rule.command.clear_cl': [u'clear_support', u'clear_logging', u'clear_cl', u'copy_cp', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback'], 'pybind.nos.v6_0_2c.rule.command.clear_cl': [u'clear_support', u'clear_logging', u'clear_cl', u'copy_cp', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback'], 'pybind.slxos.v16r_1_00b.rule.command.clear_cl': [u'clear_support', u'clear_logging', u'clear_cl', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'protocol_lldp', u'interface_int', u'interface_eth', u'protocol_spanning', u'interface_eth_leaf', u'copy_support', u'copy_cp', u'interface_pc', u'copy_running', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback', u'interface_mgmt', u'interface_fc', u'protocol_pr'], 'pybind.nos.v7_1_0.rule.command.clear_cl': [u'clear_support', u'clear_logging', u'clear_cl', u'show_running', u'show_startupcfg', u'copy_cp', u'show_rb_runcfg', u'show_startupdb', u'show_rb_local_runcfg', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rule_command_clear_clear_support_delete(self, rule=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rule', 'rule'), ('pybind.nos.v7_0_1b.rule', 'rule'), ('pybind.slxos.v16r_1_00b.rule', 'rule'), ('pybind.nos.v7_1_0.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2c.rule.command.clear_support.clear', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rule.command.clear_support.clear', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rule.command.clear_support.clear', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rule.command.clear_support.clear', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_0_1b.rule.command.clear_support.clear': [u'clear'], 'pybind.nos.v6_0_2c.rule.command.clear_support.clear': [u'clear'], 'pybind.slxos.v16r_1_00b.rule.command.clear_support.clear': [u'clear'], 'pybind.nos.v7_1_0.rule.command.clear_support.clear': [u'clear']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rule_command_clear_logging_delete(self, rule=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rule', 'rule'), ('pybind.nos.v7_1_0.rule', 'rule'), ('pybind.slxos.v16r_1_00b.rule', 'rule'), ('pybind.nos.v6_0_2c.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2c.rule.command.clear_logging', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rule.command.clear_logging', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rule.command.clear_logging', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rule.command.clear_logging', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v6_0_2c.rule.command.clear_logging': [u'clear_support', u'clear_logging', u'clear_cl', u'copy_cp', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback'], 'pybind.nos.v7_1_0.rule.command.clear_logging': [u'clear_support', u'clear_logging', u'clear_cl', u'show_running', u'show_startupcfg', u'copy_cp', u'show_rb_runcfg', u'show_startupdb', u'show_rb_local_runcfg', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback'], 'pybind.nos.v7_0_1b.rule.command.clear_logging': [u'clear_support', u'clear_logging', u'clear_cl', u'copy_cp', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback'], 'pybind.slxos.v16r_1_00b.rule.command.clear_logging': [u'clear_support', u'clear_logging', u'clear_cl', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'protocol_lldp', u'interface_int', u'interface_eth', u'protocol_spanning', u'interface_eth_leaf', u'copy_support', u'copy_cp', u'interface_pc', u'copy_running', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback', u'interface_mgmt', u'interface_fc', u'protocol_pr']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rule_command_clear_support_delete(self, rule=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rule', 'rule'), ('pybind.nos.v7_0_1b.rule', 'rule'), ('pybind.nos.v6_0_2c.rule', 'rule'), ('pybind.slxos.v16r_1_00b.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2c.rule.command.clear_support', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rule.command.clear_support', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rule.command.clear_support', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rule.command.clear_support', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_1_0.rule.command.clear_support': [u'clear_support', u'clear_logging', u'clear_cl', u'show_running', u'show_startupcfg', u'copy_cp', u'show_rb_runcfg', u'show_startupdb', u'show_rb_local_runcfg', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback'], 'pybind.nos.v6_0_2c.rule.command.clear_support': [u'clear_support', u'clear_logging', u'clear_cl', u'copy_cp', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback'], 'pybind.nos.v7_0_1b.rule.command.clear_support': [u'clear_support', u'clear_logging', u'clear_cl', u'copy_cp', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback'], 'pybind.slxos.v16r_1_00b.rule.command.clear_support': [u'clear_support', u'clear_logging', u'clear_cl', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'protocol_lldp', u'interface_int', u'interface_eth', u'protocol_spanning', u'interface_eth_leaf', u'copy_support', u'copy_cp', u'interface_pc', u'copy_running', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback', u'interface_mgmt', u'interface_fc', u'protocol_pr']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rule_command_copy_delete(self, rule=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.rule', 'rule'), ('pybind.nos.v7_0_1b.rule', 'rule'), ('pybind.nos.v6_0_2c.rule', 'rule'), ('pybind.nos.v7_1_0.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2c.rule.command.copy_running.copy', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rule.command.copy_running.copy', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rule.command.copy_running.copy', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rule.command.copy_running.copy', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v16r_1_00b.rule.command.copy_running.copy': [u'copy'], 'pybind.nos.v6_0_2c.rule.command.copy_running.copy': [u'copy'], 'pybind.nos.v7_0_1b.rule.command.copy_running.copy': [u'copy'], 'pybind.nos.v7_1_0.rule.command.copy_running.copy': [u'copy']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rule_command_copy_copy_support_delete(self, rule=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rule', 'rule'), ('pybind.nos.v7_1_0.rule', 'rule'), ('pybind.nos.v7_0_1b.rule', 'rule'), ('pybind.slxos.v16r_1_00b.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2c.rule.command.copy_support.copy', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rule.command.copy_support.copy', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rule.command.copy_support.copy', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rule.command.copy_support.copy', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_0_1b.rule.command.copy_support.copy': [u'copy'], 'pybind.nos.v6_0_2c.rule.command.copy_support.copy': [u'copy'], 'pybind.nos.v7_1_0.rule.command.copy_support.copy': [u'copy'], 'pybind.slxos.v16r_1_00b.rule.command.copy_support.copy': [u'copy']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rule_command_copy_cp_delete(self, rule=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.rule', 'rule'), ('pybind.nos.v6_0_2c.rule', 'rule'), ('pybind.nos.v7_1_0.rule', 'rule'), ('pybind.nos.v7_0_1b.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2c.rule.command.copy_cp', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rule.command.copy_cp', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rule.command.copy_cp', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rule.command.copy_cp', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v6_0_2c.rule.command.copy_cp': [u'clear_support', u'clear_logging', u'clear_cl', u'copy_cp', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback'], 'pybind.nos.v7_0_1b.rule.command.copy_cp': [u'clear_support', u'clear_logging', u'clear_cl', u'copy_cp', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback'], 'pybind.nos.v7_1_0.rule.command.copy_cp': [u'clear_support', u'clear_logging', u'clear_cl', u'show_running', u'show_startupcfg', u'copy_cp', u'show_rb_runcfg', u'show_startupdb', u'show_rb_local_runcfg', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback'], 'pybind.slxos.v16r_1_00b.rule.command.copy_cp': [u'clear_support', u'clear_logging', u'clear_cl', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'protocol_lldp', u'interface_int', u'interface_eth', u'protocol_spanning', u'interface_eth_leaf', u'copy_support', u'copy_cp', u'interface_pc', u'copy_running', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback', u'interface_mgmt', u'interface_fc', u'protocol_pr']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rule_command_copy_running_delete(self, rule=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rule', 'rule'), ('pybind.nos.v7_1_0.rule', 'rule'), ('pybind.nos.v7_0_1b.rule', 'rule'), ('pybind.slxos.v16r_1_00b.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2c.rule.command.copy_running', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rule.command.copy_running', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rule.command.copy_running', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rule.command.copy_running', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_1_0.rule.command.copy_running': [u'clear_support', u'clear_logging', u'clear_cl', u'show_running', u'show_startupcfg', u'copy_cp', u'show_rb_runcfg', u'show_startupdb', u'show_rb_local_runcfg', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback'], 'pybind.slxos.v16r_1_00b.rule.command.copy_running': [u'clear_support', u'clear_logging', u'clear_cl', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'protocol_lldp', u'interface_int', u'interface_eth', u'protocol_spanning', u'interface_eth_leaf', u'copy_support', u'copy_cp', u'interface_pc', u'copy_running', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback', u'interface_mgmt', u'interface_fc', u'protocol_pr'], 'pybind.nos.v6_0_2c.rule.command.copy_running': [u'clear_support', u'clear_logging', u'clear_cl', u'copy_cp', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback'], 'pybind.nos.v7_0_1b.rule.command.copy_running': [u'clear_support', u'clear_logging', u'clear_cl', u'copy_cp', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rule_command_copy_support_delete(self, rule=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rule', 'rule'), ('pybind.nos.v7_0_1b.rule', 'rule'), ('pybind.slxos.v16r_1_00b.rule', 'rule'), ('pybind.nos.v6_0_2c.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2c.rule.command.copy_support', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rule.command.copy_support', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rule.command.copy_support', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rule.command.copy_support', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_0_1b.rule.command.copy_support': [u'clear_support', u'clear_logging', u'clear_cl', u'copy_cp', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback'], 'pybind.nos.v6_0_2c.rule.command.copy_support': [u'clear_support', u'clear_logging', u'clear_cl', u'copy_cp', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback'], 'pybind.slxos.v16r_1_00b.rule.command.copy_support': [u'clear_support', u'clear_logging', u'clear_cl', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'protocol_lldp', u'interface_int', u'interface_eth', u'protocol_spanning', u'interface_eth_leaf', u'copy_support', u'copy_cp', u'interface_pc', u'copy_running', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback', u'interface_mgmt', u'interface_fc', u'protocol_pr'], 'pybind.nos.v7_1_0.rule.command.copy_support': [u'clear_support', u'clear_logging', u'clear_cl', u'show_running', u'show_startupcfg', u'copy_cp', u'show_rb_runcfg', u'show_startupdb', u'show_rb_local_runcfg', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rule_command_enumlist_delete(self, rule=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rule', 'rule'), ('pybind.nos.v7_0_1b.rule', 'rule'), ('pybind.slxos.v16r_1_00b.rule', 'rule'), ('pybind.nos.v7_1_0.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2c.rule.command', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rule.command', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rule.command', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rule.command', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enumList'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rule_command_interface_delete(self, rule=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rule', 'rule'), ('pybind.slxos.v16r_1_00b.rule', 'rule'), ('pybind.nos.v6_0_2c.rule', 'rule'), ('pybind.nos.v7_1_0.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2c.rule.command.interface_fc.interface', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rule.command.interface_fc.interface', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rule.command.interface_fc.interface', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rule.command.interface_eth.interface', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v6_0_2c.rule.command.interface_fc.interface': [u'interface'], 'pybind.slxos.v16r_1_00b.rule.command.interface_eth.interface': [u'interface'], 'pybind.nos.v7_1_0.rule.command.interface_fc.interface': [u'interface'], 'pybind.nos.v7_0_1b.rule.command.interface_fc.interface': [u'interface']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rule_command_interface_eth_delete(self, rule=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.rule', 'rule')]
    bindings_list = [('pybind.slxos.v16r_1_00b.rule.command.interface_eth', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v16r_1_00b.rule.command.interface_eth': [u'clear_support', u'clear_logging', u'clear_cl', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'protocol_lldp', u'interface_int', u'interface_eth', u'protocol_spanning', u'interface_eth_leaf', u'copy_support', u'copy_cp', u'interface_pc', u'copy_running', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback', u'interface_mgmt', u'interface_fc', u'protocol_pr']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rule_command_interface_eth_leaf_delete(self, rule=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.rule', 'rule')]
    bindings_list = [('pybind.slxos.v16r_1_00b.rule.command.interface_eth_leaf', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v16r_1_00b.rule.command.interface_eth_leaf': [u'clear_support', u'clear_logging', u'clear_cl', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'protocol_lldp', u'interface_int', u'interface_eth', u'protocol_spanning', u'interface_eth_leaf', u'copy_support', u'copy_cp', u'interface_pc', u'copy_running', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback', u'interface_mgmt', u'interface_fc', u'protocol_pr']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rule_command_interface_ethernet_delete(self, rule=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.rule', 'rule')]
    bindings_list = [('pybind.slxos.v16r_1_00b.rule.command.interface_eth_leaf.interface', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ethernet'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rule_command_interface_fc_delete(self, rule=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rule', 'rule'), ('pybind.slxos.v16r_1_00b.rule', 'rule'), ('pybind.nos.v6_0_2c.rule', 'rule'), ('pybind.nos.v7_0_1b.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2c.rule.command.interface_fc', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rule.command.interface_fc', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rule.command.interface_fc', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rule.command.interface_fc', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v6_0_2c.rule.command.interface_fc': [u'clear_support', u'clear_logging', u'clear_cl', u'copy_cp', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback'], 'pybind.nos.v7_1_0.rule.command.interface_fc': [u'clear_support', u'clear_logging', u'clear_cl', u'show_running', u'show_startupcfg', u'copy_cp', u'show_rb_runcfg', u'show_startupdb', u'show_rb_local_runcfg', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback'], 'pybind.nos.v7_0_1b.rule.command.interface_fc': [u'clear_support', u'clear_logging', u'clear_cl', u'copy_cp', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback'], 'pybind.slxos.v16r_1_00b.rule.command.interface_fc': [u'clear_support', u'clear_logging', u'clear_cl', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'protocol_lldp', u'interface_int', u'interface_eth', u'protocol_spanning', u'interface_eth_leaf', u'copy_support', u'copy_cp', u'interface_pc', u'copy_running', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback', u'interface_mgmt', u'interface_fc', u'protocol_pr']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rule_command_interface_fc_leaf_delete(self, rule=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rule', 'rule'), ('pybind.nos.v6_0_2c.rule', 'rule'), ('pybind.nos.v7_1_0.rule', 'rule'), ('pybind.slxos.v16r_1_00b.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2c.rule.command.interface_fc_leaf', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rule.command.interface_fc_leaf', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rule.command.interface_fc_leaf', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rule.command.interface_fc_leaf', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v16r_1_00b.rule.command.interface_fc_leaf': [u'clear_support', u'clear_logging', u'clear_cl', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'protocol_lldp', u'interface_int', u'interface_eth', u'protocol_spanning', u'interface_eth_leaf', u'copy_support', u'copy_cp', u'interface_pc', u'copy_running', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback', u'interface_mgmt', u'interface_fc', u'protocol_pr'], 'pybind.nos.v6_0_2c.rule.command.interface_fc_leaf': [u'clear_support', u'clear_logging', u'clear_cl', u'copy_cp', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback'], 'pybind.nos.v7_0_1b.rule.command.interface_fc_leaf': [u'clear_support', u'clear_logging', u'clear_cl', u'copy_cp', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback'], 'pybind.nos.v7_1_0.rule.command.interface_fc_leaf': [u'clear_support', u'clear_logging', u'clear_cl', u'show_running', u'show_startupcfg', u'copy_cp', u'show_rb_runcfg', u'show_startupdb', u'show_rb_local_runcfg', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rule_command_interface_fcoe_delete(self, rule=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rule', 'rule'), ('pybind.nos.v6_0_2c.rule', 'rule'), ('pybind.nos.v7_1_0.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2c.rule.command.interface_fcoe_leaf.interface', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rule.command.interface_fcoe_leaf.interface', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rule.command.interface_fcoe_leaf.interface', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'fcoe'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rule_command_interface_fcoe_leaf_delete(self, rule=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rule', 'rule'), ('pybind.nos.v6_0_2c.rule', 'rule'), ('pybind.nos.v7_0_1b.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2c.rule.command.interface_fcoe_leaf', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rule.command.interface_fcoe_leaf', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rule.command.interface_fcoe_leaf', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_0_1b.rule.command.interface_fcoe_leaf': [u'clear_support', u'clear_logging', u'clear_cl', u'copy_cp', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback'], 'pybind.nos.v6_0_2c.rule.command.interface_fcoe_leaf': [u'clear_support', u'clear_logging', u'clear_cl', u'copy_cp', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback'], 'pybind.nos.v7_1_0.rule.command.interface_fcoe_leaf': [u'clear_support', u'clear_logging', u'clear_cl', u'show_running', u'show_startupcfg', u'copy_cp', u'show_rb_runcfg', u'show_startupdb', u'show_rb_local_runcfg', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rule_command_interface_fe_delete(self, rule=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rule', 'rule'), ('pybind.nos.v7_0_1b.rule', 'rule'), ('pybind.nos.v6_0_2c.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2c.rule.command.interface_fe', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rule.command.interface_fe', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rule.command.interface_fe', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_0_1b.rule.command.interface_fe': [u'clear_support', u'clear_logging', u'clear_cl', u'copy_cp', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback'], 'pybind.nos.v7_1_0.rule.command.interface_fe': [u'clear_support', u'clear_logging', u'clear_cl', u'show_running', u'show_startupcfg', u'copy_cp', u'show_rb_runcfg', u'show_startupdb', u'show_rb_local_runcfg', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback'], 'pybind.nos.v6_0_2c.rule.command.interface_fe': [u'clear_support', u'clear_logging', u'clear_cl', u'copy_cp', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rule_command_interface_fe_leaf_delete(self, rule=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rule', 'rule'), ('pybind.nos.v7_0_1b.rule', 'rule'), ('pybind.nos.v7_1_0.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2c.rule.command.interface_fe_leaf', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rule.command.interface_fe_leaf', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rule.command.interface_fe_leaf', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_1_0.rule.command.interface_fe_leaf': [u'clear_support', u'clear_logging', u'clear_cl', u'show_running', u'show_startupcfg', u'copy_cp', u'show_rb_runcfg', u'show_startupdb', u'show_rb_local_runcfg', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback'], 'pybind.nos.v7_0_1b.rule.command.interface_fe_leaf': [u'clear_support', u'clear_logging', u'clear_cl', u'copy_cp', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback'], 'pybind.nos.v6_0_2c.rule.command.interface_fe_leaf': [u'clear_support', u'clear_logging', u'clear_cl', u'copy_cp', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rule_command_interface_fibrechannel_delete(self, rule=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rule', 'rule'), ('pybind.nos.v6_0_2c.rule', 'rule'), ('pybind.slxos.v16r_1_00b.rule', 'rule'), ('pybind.nos.v7_0_1b.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2c.rule.command.interface_fc_leaf.interface', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rule.command.interface_fc_leaf.interface', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rule.command.interface_fc_leaf.interface', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rule.command.interface_fc_leaf.interface', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'fibrechannel'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rule_command_interface_fortygigabitethernet_delete(self, rule=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rule', 'rule'), ('pybind.nos.v7_0_1b.rule', 'rule'), ('pybind.nos.v7_1_0.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2c.rule.command.interface_fe_leaf.interface', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rule.command.interface_fe_leaf.interface', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rule.command.interface_fe_leaf.interface', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'fortygigabitethernet'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rule_command_interface_ge_delete(self, rule=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rule', 'rule'), ('pybind.nos.v7_1_0.rule', 'rule'), ('pybind.nos.v6_0_2c.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2c.rule.command.interface_ge', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rule.command.interface_ge', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rule.command.interface_ge', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v6_0_2c.rule.command.interface_ge': [u'clear_support', u'clear_logging', u'clear_cl', u'copy_cp', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback'], 'pybind.nos.v7_1_0.rule.command.interface_ge': [u'clear_support', u'clear_logging', u'clear_cl', u'show_running', u'show_startupcfg', u'copy_cp', u'show_rb_runcfg', u'show_startupdb', u'show_rb_local_runcfg', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback'], 'pybind.nos.v7_0_1b.rule.command.interface_ge': [u'clear_support', u'clear_logging', u'clear_cl', u'copy_cp', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rule_command_interface_ge_leaf_delete(self, rule=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rule', 'rule'), ('pybind.nos.v7_0_1b.rule', 'rule'), ('pybind.nos.v7_1_0.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2c.rule.command.interface_ge_leaf', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rule.command.interface_ge_leaf', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rule.command.interface_ge_leaf', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_1_0.rule.command.interface_ge_leaf': [u'clear_support', u'clear_logging', u'clear_cl', u'show_running', u'show_startupcfg', u'copy_cp', u'show_rb_runcfg', u'show_startupdb', u'show_rb_local_runcfg', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback'], 'pybind.nos.v6_0_2c.rule.command.interface_ge_leaf': [u'clear_support', u'clear_logging', u'clear_cl', u'copy_cp', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback'], 'pybind.nos.v7_0_1b.rule.command.interface_ge_leaf': [u'clear_support', u'clear_logging', u'clear_cl', u'copy_cp', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rule_command_interface_gigabitethernet_delete(self, rule=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rule', 'rule'), ('pybind.nos.v7_0_1b.rule', 'rule'), ('pybind.nos.v7_1_0.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2c.rule.command.interface_ge_leaf.interface', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rule.command.interface_ge_leaf.interface', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rule.command.interface_ge_leaf.interface', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'gigabitethernet'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rule_command_interface_he_delete(self, rule=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rule', 'rule'), ('pybind.nos.v7_1_0.rule', 'rule'), ('pybind.nos.v7_0_1b.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2c.rule.command.interface_he', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rule.command.interface_he', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rule.command.interface_he', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_1_0.rule.command.interface_he': [u'clear_support', u'clear_logging', u'clear_cl', u'show_running', u'show_startupcfg', u'copy_cp', u'show_rb_runcfg', u'show_startupdb', u'show_rb_local_runcfg', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback'], 'pybind.nos.v6_0_2c.rule.command.interface_he': [u'clear_support', u'clear_logging', u'clear_cl', u'copy_cp', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback'], 'pybind.nos.v7_0_1b.rule.command.interface_he': [u'clear_support', u'clear_logging', u'clear_cl', u'copy_cp', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rule_command_interface_he_leaf_delete(self, rule=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rule', 'rule'), ('pybind.nos.v7_0_1b.rule', 'rule'), ('pybind.nos.v7_1_0.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2c.rule.command.interface_he_leaf', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rule.command.interface_he_leaf', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rule.command.interface_he_leaf', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_0_1b.rule.command.interface_he_leaf': [u'clear_support', u'clear_logging', u'clear_cl', u'copy_cp', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback'], 'pybind.nos.v6_0_2c.rule.command.interface_he_leaf': [u'clear_support', u'clear_logging', u'clear_cl', u'copy_cp', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback'], 'pybind.nos.v7_1_0.rule.command.interface_he_leaf': [u'clear_support', u'clear_logging', u'clear_cl', u'show_running', u'show_startupcfg', u'copy_cp', u'show_rb_runcfg', u'show_startupdb', u'show_rb_local_runcfg', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rule_command_interface_hundredgigabitethernet_delete(self, rule=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rule', 'rule'), ('pybind.nos.v7_0_1b.rule', 'rule'), ('pybind.nos.v6_0_2c.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2c.rule.command.interface_he_leaf.interface', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rule.command.interface_he_leaf.interface', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rule.command.interface_he_leaf.interface', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hundredgigabitethernet'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rule_command_interface_int_delete(self, rule=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.rule', 'rule'), ('pybind.nos.v6_0_2c.rule', 'rule'), ('pybind.nos.v7_1_0.rule', 'rule'), ('pybind.nos.v7_0_1b.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2c.rule.command.interface_int', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rule.command.interface_int', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rule.command.interface_int', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rule.command.interface_int', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v6_0_2c.rule.command.interface_int': [u'clear_support', u'clear_logging', u'clear_cl', u'copy_cp', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback'], 'pybind.slxos.v16r_1_00b.rule.command.interface_int': [u'clear_support', u'clear_logging', u'clear_cl', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'protocol_lldp', u'interface_int', u'interface_eth', u'protocol_spanning', u'interface_eth_leaf', u'copy_support', u'copy_cp', u'interface_pc', u'copy_running', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback', u'interface_mgmt', u'interface_fc', u'protocol_pr'], 'pybind.nos.v7_1_0.rule.command.interface_int': [u'clear_support', u'clear_logging', u'clear_cl', u'show_running', u'show_startupcfg', u'copy_cp', u'show_rb_runcfg', u'show_startupdb', u'show_rb_local_runcfg', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback'], 'pybind.nos.v7_0_1b.rule.command.interface_int': [u'clear_support', u'clear_logging', u'clear_cl', u'copy_cp', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rule_command_interface_interface_eth_leaf_delete(self, rule=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.rule', 'rule')]
    bindings_list = [('pybind.slxos.v16r_1_00b.rule.command.interface_eth_leaf.interface', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v16r_1_00b.rule.command.interface_eth_leaf.interface': [u'ethernet_leaf']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rule_command_interface_interface_fc_delete(self, rule=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.rule', 'rule')]
    bindings_list = [('pybind.slxos.v16r_1_00b.rule.command.interface_fc.interface', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v16r_1_00b.rule.command.interface_fc.interface': [u'interface']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rule_command_interface_interface_fc_leaf_delete(self, rule=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rule', 'rule'), ('pybind.nos.v6_0_2c.rule', 'rule'), ('pybind.slxos.v16r_1_00b.rule', 'rule'), ('pybind.nos.v7_0_1b.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2c.rule.command.interface_fc_leaf.interface', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rule.command.interface_fc_leaf.interface', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rule.command.interface_fc_leaf.interface', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rule.command.interface_fc_leaf.interface', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v6_0_2c.rule.command.interface_fc_leaf.interface': [u'fibrechannel_leaf'], 'pybind.slxos.v16r_1_00b.rule.command.interface_fc_leaf.interface': [u'fibrechannel_leaf'], 'pybind.nos.v7_1_0.rule.command.interface_fc_leaf.interface': [u'fibrechannel_leaf'], 'pybind.nos.v7_0_1b.rule.command.interface_fc_leaf.interface': [u'fibrechannel_leaf']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rule_command_interface_interface_fcoe_delete(self, rule=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rule', 'rule'), ('pybind.nos.v7_1_0.rule', 'rule'), ('pybind.nos.v6_0_2c.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2c.rule.command.interface_fcoe.interface', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rule.command.interface_fcoe.interface', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rule.command.interface_fcoe.interface', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_1_0.rule.command.interface_fcoe.interface': [u'interface'], 'pybind.nos.v7_0_1b.rule.command.interface_fcoe.interface': [u'interface'], 'pybind.nos.v6_0_2c.rule.command.interface_fcoe.interface': [u'interface']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rule_command_interface_interface_fcoe_leaf_delete(self, rule=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rule', 'rule'), ('pybind.nos.v6_0_2c.rule', 'rule'), ('pybind.nos.v7_1_0.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2c.rule.command.interface_fcoe_leaf.interface', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rule.command.interface_fcoe_leaf.interface', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rule.command.interface_fcoe_leaf.interface', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_1_0.rule.command.interface_fcoe_leaf.interface': [u'fcoe_leaf'], 'pybind.nos.v6_0_2c.rule.command.interface_fcoe_leaf.interface': [u'fcoe_leaf'], 'pybind.nos.v7_0_1b.rule.command.interface_fcoe_leaf.interface': [u'fcoe_leaf']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rule_command_interface_interface_fe_delete(self, rule=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rule', 'rule'), ('pybind.nos.v7_0_1b.rule', 'rule'), ('pybind.nos.v7_1_0.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2c.rule.command.interface_fe.interface', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rule.command.interface_fe.interface', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rule.command.interface_fe.interface', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_1_0.rule.command.interface_fe.interface': [u'interface'], 'pybind.nos.v7_0_1b.rule.command.interface_fe.interface': [u'interface'], 'pybind.nos.v6_0_2c.rule.command.interface_fe.interface': [u'interface']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rule_command_interface_interface_fe_leaf_delete(self, rule=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rule', 'rule'), ('pybind.nos.v7_0_1b.rule', 'rule'), ('pybind.nos.v7_1_0.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2c.rule.command.interface_fe_leaf.interface', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rule.command.interface_fe_leaf.interface', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rule.command.interface_fe_leaf.interface', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_1_0.rule.command.interface_fe_leaf.interface': [u'fortygigabitethernet_leaf'], 'pybind.nos.v6_0_2c.rule.command.interface_fe_leaf.interface': [u'fortygigabitethernet_leaf'], 'pybind.nos.v7_0_1b.rule.command.interface_fe_leaf.interface': [u'fortygigabitethernet_leaf']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rule_command_interface_interface_ge_delete(self, rule=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rule', 'rule'), ('pybind.nos.v6_0_2c.rule', 'rule'), ('pybind.nos.v7_0_1b.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2c.rule.command.interface_ge.interface', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rule.command.interface_ge.interface', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rule.command.interface_ge.interface', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v6_0_2c.rule.command.interface_ge.interface': [u'interface'], 'pybind.nos.v7_1_0.rule.command.interface_ge.interface': [u'interface'], 'pybind.nos.v7_0_1b.rule.command.interface_ge.interface': [u'interface']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rule_command_interface_interface_ge_leaf_delete(self, rule=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rule', 'rule'), ('pybind.nos.v7_0_1b.rule', 'rule'), ('pybind.nos.v7_1_0.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2c.rule.command.interface_ge_leaf.interface', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rule.command.interface_ge_leaf.interface', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rule.command.interface_ge_leaf.interface', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_1_0.rule.command.interface_ge_leaf.interface': [u'gigabitethernet_leaf'], 'pybind.nos.v7_0_1b.rule.command.interface_ge_leaf.interface': [u'gigabitethernet_leaf'], 'pybind.nos.v6_0_2c.rule.command.interface_ge_leaf.interface': [u'gigabitethernet_leaf']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rule_command_interface_interface_he_delete(self, rule=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rule', 'rule'), ('pybind.nos.v7_1_0.rule', 'rule'), ('pybind.nos.v6_0_2c.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2c.rule.command.interface_he.interface', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rule.command.interface_he.interface', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rule.command.interface_he.interface', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v6_0_2c.rule.command.interface_he.interface': [u'interface'], 'pybind.nos.v7_1_0.rule.command.interface_he.interface': [u'interface'], 'pybind.nos.v7_0_1b.rule.command.interface_he.interface': [u'interface']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rule_command_interface_interface_he_leaf_delete(self, rule=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rule', 'rule'), ('pybind.nos.v7_0_1b.rule', 'rule'), ('pybind.nos.v6_0_2c.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2c.rule.command.interface_he_leaf.interface', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rule.command.interface_he_leaf.interface', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rule.command.interface_he_leaf.interface', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v6_0_2c.rule.command.interface_he_leaf.interface': [u'hundredgigabitethernet_leaf'], 'pybind.nos.v7_0_1b.rule.command.interface_he_leaf.interface': [u'hundredgigabitethernet_leaf'], 'pybind.nos.v7_1_0.rule.command.interface_he_leaf.interface': [u'hundredgigabitethernet_leaf']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rule_command_interface_interface_loopback_delete(self, rule=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rule', 'rule'), ('pybind.nos.v6_0_2c.rule', 'rule'), ('pybind.nos.v7_1_0.rule', 'rule'), ('pybind.slxos.v16r_1_00b.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2c.rule.command.interface_loopback.interface', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rule.command.interface_loopback.interface', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rule.command.interface_loopback.interface', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rule.command.interface_loopback.interface', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_0_1b.rule.command.interface_loopback.interface': [u'interface'], 'pybind.nos.v6_0_2c.rule.command.interface_loopback.interface': [u'interface'], 'pybind.nos.v7_1_0.rule.command.interface_loopback.interface': [u'interface'], 'pybind.slxos.v16r_1_00b.rule.command.interface_loopback.interface': [u'interface']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rule_command_interface_interface_loopback_leaf_delete(self, rule=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rule', 'rule'), ('pybind.nos.v7_0_1b.rule', 'rule'), ('pybind.slxos.v16r_1_00b.rule', 'rule'), ('pybind.nos.v6_0_2c.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2c.rule.command.interface_loopback_leaf.interface', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rule.command.interface_loopback_leaf.interface', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rule.command.interface_loopback_leaf.interface', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rule.command.interface_loopback_leaf.interface', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v6_0_2c.rule.command.interface_loopback_leaf.interface': [u'loopback_leaf'], 'pybind.nos.v7_0_1b.rule.command.interface_loopback_leaf.interface': [u'loopback_leaf'], 'pybind.nos.v7_1_0.rule.command.interface_loopback_leaf.interface': [u'loopback_leaf'], 'pybind.slxos.v16r_1_00b.rule.command.interface_loopback_leaf.interface': [u'loopback_leaf']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rule_command_interface_interface_management_leaf_delete(self, rule=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rule', 'rule'), ('pybind.slxos.v16r_1_00b.rule', 'rule'), ('pybind.nos.v7_1_0.rule', 'rule'), ('pybind.nos.v6_0_2c.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2c.rule.command.interface_management_leaf.interface', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rule.command.interface_management_leaf.interface', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rule.command.interface_management_leaf.interface', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rule.command.interface_management_leaf.interface', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v6_0_2c.rule.command.interface_management_leaf.interface': [u'management_leaf'], 'pybind.slxos.v16r_1_00b.rule.command.interface_management_leaf.interface': [u'management_leaf'], 'pybind.nos.v7_1_0.rule.command.interface_management_leaf.interface': [u'management_leaf'], 'pybind.nos.v7_0_1b.rule.command.interface_management_leaf.interface': [u'management_leaf']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rule_command_interface_interface_mgmt_delete(self, rule=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rule', 'rule'), ('pybind.slxos.v16r_1_00b.rule', 'rule'), ('pybind.nos.v7_1_0.rule', 'rule'), ('pybind.nos.v7_0_1b.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2c.rule.command.interface_mgmt.interface', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rule.command.interface_mgmt.interface', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rule.command.interface_mgmt.interface', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rule.command.interface_mgmt.interface', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_1_0.rule.command.interface_mgmt.interface': [u'interface'], 'pybind.slxos.v16r_1_00b.rule.command.interface_mgmt.interface': [u'interface'], 'pybind.nos.v6_0_2c.rule.command.interface_mgmt.interface': [u'interface'], 'pybind.nos.v7_0_1b.rule.command.interface_mgmt.interface': [u'interface']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rule_command_interface_interface_pc_delete(self, rule=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rule', 'rule'), ('pybind.nos.v7_1_0.rule', 'rule'), ('pybind.nos.v6_0_2c.rule', 'rule'), ('pybind.slxos.v16r_1_00b.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2c.rule.command.interface_pc.interface', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rule.command.interface_pc.interface', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rule.command.interface_pc.interface', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rule.command.interface_pc.interface', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_1_0.rule.command.interface_pc.interface': [u'interface'], 'pybind.nos.v7_0_1b.rule.command.interface_pc.interface': [u'interface'], 'pybind.nos.v6_0_2c.rule.command.interface_pc.interface': [u'interface'], 'pybind.slxos.v16r_1_00b.rule.command.interface_pc.interface': [u'interface']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rule_command_interface_interface_pc_leaf_delete(self, rule=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rule', 'rule'), ('pybind.slxos.v16r_1_00b.rule', 'rule'), ('pybind.nos.v7_0_1b.rule', 'rule'), ('pybind.nos.v6_0_2c.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2c.rule.command.interface_pc_leaf.interface', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rule.command.interface_pc_leaf.interface', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rule.command.interface_pc_leaf.interface', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rule.command.interface_pc_leaf.interface', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_1_0.rule.command.interface_pc_leaf.interface': [u'port_channel_leaf'], 'pybind.slxos.v16r_1_00b.rule.command.interface_pc_leaf.interface': [u'port_channel_leaf'], 'pybind.nos.v7_0_1b.rule.command.interface_pc_leaf.interface': [u'port_channel_leaf'], 'pybind.nos.v6_0_2c.rule.command.interface_pc_leaf.interface': [u'port_channel_leaf']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rule_command_interface_interface_te_delete(self, rule=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rule', 'rule'), ('pybind.nos.v7_0_1b.rule', 'rule'), ('pybind.nos.v7_1_0.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2c.rule.command.interface_te.interface', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rule.command.interface_te.interface', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rule.command.interface_te.interface', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v6_0_2c.rule.command.interface_te.interface': [u'interface'], 'pybind.nos.v7_1_0.rule.command.interface_te.interface': [u'interface'], 'pybind.nos.v7_0_1b.rule.command.interface_te.interface': [u'interface']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rule_command_interface_interface_te_leaf_delete(self, rule=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rule', 'rule'), ('pybind.nos.v7_1_0.rule', 'rule'), ('pybind.nos.v7_0_1b.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2c.rule.command.interface_te_leaf.interface', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rule.command.interface_te_leaf.interface', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rule.command.interface_te_leaf.interface', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v6_0_2c.rule.command.interface_te_leaf.interface': [u'tengigabitethernet_leaf'], 'pybind.nos.v7_0_1b.rule.command.interface_te_leaf.interface': [u'tengigabitethernet_leaf'], 'pybind.nos.v7_1_0.rule.command.interface_te_leaf.interface': [u'tengigabitethernet_leaf']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rule_command_interface_interface_ve_delete(self, rule=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rule', 'rule'), ('pybind.slxos.v16r_1_00b.rule', 'rule'), ('pybind.nos.v7_1_0.rule', 'rule'), ('pybind.nos.v7_0_1b.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2c.rule.command.interface_ve.interface', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rule.command.interface_ve.interface', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rule.command.interface_ve.interface', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rule.command.interface_ve.interface', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_1_0.rule.command.interface_ve.interface': [u'interface'], 'pybind.slxos.v16r_1_00b.rule.command.interface_ve.interface': [u'interface'], 'pybind.nos.v6_0_2c.rule.command.interface_ve.interface': [u'interface'], 'pybind.nos.v7_0_1b.rule.command.interface_ve.interface': [u'interface']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rule_command_interface_interface_ve_leaf_delete(self, rule=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.rule', 'rule'), ('pybind.nos.v7_0_1b.rule', 'rule'), ('pybind.nos.v7_1_0.rule', 'rule'), ('pybind.nos.v6_0_2c.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2c.rule.command.interface_ve_leaf.interface', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rule.command.interface_ve_leaf.interface', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rule.command.interface_ve_leaf.interface', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rule.command.interface_ve_leaf.interface', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_1_0.rule.command.interface_ve_leaf.interface': [u've_leaf'], 'pybind.nos.v6_0_2c.rule.command.interface_ve_leaf.interface': [u've_leaf'], 'pybind.nos.v7_0_1b.rule.command.interface_ve_leaf.interface': [u've_leaf'], 'pybind.slxos.v16r_1_00b.rule.command.interface_ve_leaf.interface': [u've_leaf']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rule_command_interface_interface_vlan_delete(self, rule=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.rule', 'rule'), ('pybind.nos.v7_0_1b.rule', 'rule'), ('pybind.nos.v7_1_0.rule', 'rule'), ('pybind.nos.v6_0_2c.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2c.rule.command.interface_vlan.interface', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rule.command.interface_vlan.interface', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rule.command.interface_vlan.interface', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rule.command.interface_vlan.interface', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v6_0_2c.rule.command.interface_vlan.interface': [u'interface'], 'pybind.slxos.v16r_1_00b.rule.command.interface_vlan.interface': [u'interface'], 'pybind.nos.v7_1_0.rule.command.interface_vlan.interface': [u'interface'], 'pybind.nos.v7_0_1b.rule.command.interface_vlan.interface': [u'interface']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rule_command_interface_interface_vlan_leaf_delete(self, rule=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.rule', 'rule'), ('pybind.nos.v7_0_1b.rule', 'rule'), ('pybind.nos.v7_1_0.rule', 'rule'), ('pybind.nos.v6_0_2c.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2c.rule.command.interface_vlan_leaf.interface', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rule.command.interface_vlan_leaf.interface', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rule.command.interface_vlan_leaf.interface', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rule.command.interface_vlan_leaf.interface', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v16r_1_00b.rule.command.interface_vlan_leaf.interface': [u'vlan_leaf'], 'pybind.nos.v7_1_0.rule.command.interface_vlan_leaf.interface': [u'vlan_leaf'], 'pybind.nos.v6_0_2c.rule.command.interface_vlan_leaf.interface': [u'vlan_leaf'], 'pybind.nos.v7_0_1b.rule.command.interface_vlan_leaf.interface': [u'vlan_leaf']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rule_command_interface_loopback_delete(self, rule=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rule', 'rule'), ('pybind.nos.v7_0_1b.rule', 'rule'), ('pybind.slxos.v16r_1_00b.rule', 'rule'), ('pybind.nos.v6_0_2c.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2c.rule.command.interface_loopback_leaf.interface', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rule.command.interface_loopback_leaf.interface', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rule.command.interface_loopback_leaf.interface', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rule.command.interface_loopback_leaf.interface', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'loopback'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rule_command_interface_loopback_leaf_delete(self, rule=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.rule', 'rule'), ('pybind.nos.v6_0_2c.rule', 'rule'), ('pybind.nos.v7_0_1b.rule', 'rule'), ('pybind.nos.v7_1_0.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2c.rule.command.interface_loopback_leaf', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rule.command.interface_loopback_leaf', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rule.command.interface_loopback_leaf', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rule.command.interface_loopback_leaf', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v16r_1_00b.rule.command.interface_loopback_leaf': [u'clear_support', u'clear_logging', u'clear_cl', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'protocol_lldp', u'interface_int', u'interface_eth', u'protocol_spanning', u'interface_eth_leaf', u'copy_support', u'copy_cp', u'interface_pc', u'copy_running', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback', u'interface_mgmt', u'interface_fc', u'protocol_pr'], 'pybind.nos.v7_0_1b.rule.command.interface_loopback_leaf': [u'clear_support', u'clear_logging', u'clear_cl', u'copy_cp', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback'], 'pybind.nos.v6_0_2c.rule.command.interface_loopback_leaf': [u'clear_support', u'clear_logging', u'clear_cl', u'copy_cp', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback'], 'pybind.nos.v7_1_0.rule.command.interface_loopback_leaf': [u'clear_support', u'clear_logging', u'clear_cl', u'show_running', u'show_startupcfg', u'copy_cp', u'show_rb_runcfg', u'show_startupdb', u'show_rb_local_runcfg', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rule_command_interface_management_delete(self, rule=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rule', 'rule'), ('pybind.slxos.v16r_1_00b.rule', 'rule'), ('pybind.nos.v7_1_0.rule', 'rule'), ('pybind.nos.v6_0_2c.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2c.rule.command.interface_management_leaf.interface', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rule.command.interface_management_leaf.interface', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rule.command.interface_management_leaf.interface', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rule.command.interface_management_leaf.interface', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'management'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rule_command_interface_management_leaf_delete(self, rule=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rule', 'rule'), ('pybind.nos.v6_0_2c.rule', 'rule'), ('pybind.slxos.v16r_1_00b.rule', 'rule'), ('pybind.nos.v7_1_0.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2c.rule.command.interface_management_leaf', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rule.command.interface_management_leaf', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rule.command.interface_management_leaf', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rule.command.interface_management_leaf', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v16r_1_00b.rule.command.interface_management_leaf': [u'clear_support', u'clear_logging', u'clear_cl', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'protocol_lldp', u'interface_int', u'interface_eth', u'protocol_spanning', u'interface_eth_leaf', u'copy_support', u'copy_cp', u'interface_pc', u'copy_running', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback', u'interface_mgmt', u'interface_fc', u'protocol_pr'], 'pybind.nos.v6_0_2c.rule.command.interface_management_leaf': [u'clear_support', u'clear_logging', u'clear_cl', u'copy_cp', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback'], 'pybind.nos.v7_1_0.rule.command.interface_management_leaf': [u'clear_support', u'clear_logging', u'clear_cl', u'show_running', u'show_startupcfg', u'copy_cp', u'show_rb_runcfg', u'show_startupdb', u'show_rb_local_runcfg', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback'], 'pybind.nos.v7_0_1b.rule.command.interface_management_leaf': [u'clear_support', u'clear_logging', u'clear_cl', u'copy_cp', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rule_command_interface_mgmt_delete(self, rule=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rule', 'rule'), ('pybind.nos.v7_0_1b.rule', 'rule'), ('pybind.nos.v6_0_2c.rule', 'rule'), ('pybind.slxos.v16r_1_00b.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2c.rule.command.interface_mgmt', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rule.command.interface_mgmt', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rule.command.interface_mgmt', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rule.command.interface_mgmt', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v6_0_2c.rule.command.interface_mgmt': [u'clear_support', u'clear_logging', u'clear_cl', u'copy_cp', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback'], 'pybind.nos.v7_0_1b.rule.command.interface_mgmt': [u'clear_support', u'clear_logging', u'clear_cl', u'copy_cp', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback'], 'pybind.nos.v7_1_0.rule.command.interface_mgmt': [u'clear_support', u'clear_logging', u'clear_cl', u'show_running', u'show_startupcfg', u'copy_cp', u'show_rb_runcfg', u'show_startupdb', u'show_rb_local_runcfg', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback'], 'pybind.slxos.v16r_1_00b.rule.command.interface_mgmt': [u'clear_support', u'clear_logging', u'clear_cl', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'protocol_lldp', u'interface_int', u'interface_eth', u'protocol_spanning', u'interface_eth_leaf', u'copy_support', u'copy_cp', u'interface_pc', u'copy_running', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback', u'interface_mgmt', u'interface_fc', u'protocol_pr']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rule_command_interface_pc_delete(self, rule=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rule', 'rule'), ('pybind.nos.v7_0_1b.rule', 'rule'), ('pybind.slxos.v16r_1_00b.rule', 'rule'), ('pybind.nos.v7_1_0.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2c.rule.command.interface_pc', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rule.command.interface_pc', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rule.command.interface_pc', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rule.command.interface_pc', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_0_1b.rule.command.interface_pc': [u'clear_support', u'clear_logging', u'clear_cl', u'copy_cp', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback'], 'pybind.nos.v6_0_2c.rule.command.interface_pc': [u'clear_support', u'clear_logging', u'clear_cl', u'copy_cp', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback'], 'pybind.slxos.v16r_1_00b.rule.command.interface_pc': [u'clear_support', u'clear_logging', u'clear_cl', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'protocol_lldp', u'interface_int', u'interface_eth', u'protocol_spanning', u'interface_eth_leaf', u'copy_support', u'copy_cp', u'interface_pc', u'copy_running', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback', u'interface_mgmt', u'interface_fc', u'protocol_pr'], 'pybind.nos.v7_1_0.rule.command.interface_pc': [u'clear_support', u'clear_logging', u'clear_cl', u'show_running', u'show_startupcfg', u'copy_cp', u'show_rb_runcfg', u'show_startupdb', u'show_rb_local_runcfg', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rule_command_interface_pc_leaf_delete(self, rule=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.rule', 'rule'), ('pybind.nos.v7_1_0.rule', 'rule'), ('pybind.nos.v7_0_1b.rule', 'rule'), ('pybind.nos.v6_0_2c.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2c.rule.command.interface_pc_leaf', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rule.command.interface_pc_leaf', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rule.command.interface_pc_leaf', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rule.command.interface_pc_leaf', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_1_0.rule.command.interface_pc_leaf': [u'clear_support', u'clear_logging', u'clear_cl', u'show_running', u'show_startupcfg', u'copy_cp', u'show_rb_runcfg', u'show_startupdb', u'show_rb_local_runcfg', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback'], 'pybind.nos.v7_0_1b.rule.command.interface_pc_leaf': [u'clear_support', u'clear_logging', u'clear_cl', u'copy_cp', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback'], 'pybind.slxos.v16r_1_00b.rule.command.interface_pc_leaf': [u'clear_support', u'clear_logging', u'clear_cl', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'protocol_lldp', u'interface_int', u'interface_eth', u'protocol_spanning', u'interface_eth_leaf', u'copy_support', u'copy_cp', u'interface_pc', u'copy_running', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback', u'interface_mgmt', u'interface_fc', u'protocol_pr'], 'pybind.nos.v6_0_2c.rule.command.interface_pc_leaf': [u'clear_support', u'clear_logging', u'clear_cl', u'copy_cp', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rule_command_interface_port_channel_delete(self, rule=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rule', 'rule'), ('pybind.slxos.v16r_1_00b.rule', 'rule'), ('pybind.nos.v7_0_1b.rule', 'rule'), ('pybind.nos.v6_0_2c.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2c.rule.command.interface_pc_leaf.interface', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rule.command.interface_pc_leaf.interface', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rule.command.interface_pc_leaf.interface', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rule.command.interface_pc_leaf.interface', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'port-channel'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rule_command_interface_te_delete(self, rule=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rule', 'rule'), ('pybind.nos.v6_0_2c.rule', 'rule'), ('pybind.nos.v7_1_0.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2c.rule.command.interface_te', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rule.command.interface_te', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rule.command.interface_te', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v6_0_2c.rule.command.interface_te': [u'clear_support', u'clear_logging', u'clear_cl', u'copy_cp', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback'], 'pybind.nos.v7_0_1b.rule.command.interface_te': [u'clear_support', u'clear_logging', u'clear_cl', u'copy_cp', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback'], 'pybind.nos.v7_1_0.rule.command.interface_te': [u'clear_support', u'clear_logging', u'clear_cl', u'show_running', u'show_startupcfg', u'copy_cp', u'show_rb_runcfg', u'show_startupdb', u'show_rb_local_runcfg', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rule_command_interface_te_leaf_delete(self, rule=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rule', 'rule'), ('pybind.nos.v6_0_2c.rule', 'rule'), ('pybind.nos.v7_0_1b.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2c.rule.command.interface_te_leaf', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rule.command.interface_te_leaf', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rule.command.interface_te_leaf', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_0_1b.rule.command.interface_te_leaf': [u'clear_support', u'clear_logging', u'clear_cl', u'copy_cp', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback'], 'pybind.nos.v6_0_2c.rule.command.interface_te_leaf': [u'clear_support', u'clear_logging', u'clear_cl', u'copy_cp', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback'], 'pybind.nos.v7_1_0.rule.command.interface_te_leaf': [u'clear_support', u'clear_logging', u'clear_cl', u'show_running', u'show_startupcfg', u'copy_cp', u'show_rb_runcfg', u'show_startupdb', u'show_rb_local_runcfg', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rule_command_interface_tengigabitethernet_delete(self, rule=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rule', 'rule'), ('pybind.nos.v7_1_0.rule', 'rule'), ('pybind.nos.v7_0_1b.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2c.rule.command.interface_te_leaf.interface', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rule.command.interface_te_leaf.interface', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rule.command.interface_te_leaf.interface', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tengigabitethernet'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rule_command_interface_ve_delete(self, rule=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.rule', 'rule'), ('pybind.nos.v7_0_1b.rule', 'rule'), ('pybind.nos.v7_1_0.rule', 'rule'), ('pybind.nos.v6_0_2c.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2c.rule.command.interface_ve_leaf.interface', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rule.command.interface_ve_leaf.interface', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rule.command.interface_ve_leaf.interface', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rule.command.interface_ve_leaf.interface', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 've'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rule_command_interface_ve_leaf_delete(self, rule=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rule', 'rule'), ('pybind.slxos.v16r_1_00b.rule', 'rule'), ('pybind.nos.v6_0_2c.rule', 'rule'), ('pybind.nos.v7_0_1b.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2c.rule.command.interface_ve_leaf', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rule.command.interface_ve_leaf', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rule.command.interface_ve_leaf', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rule.command.interface_ve_leaf', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_1_0.rule.command.interface_ve_leaf': [u'clear_support', u'clear_logging', u'clear_cl', u'show_running', u'show_startupcfg', u'copy_cp', u'show_rb_runcfg', u'show_startupdb', u'show_rb_local_runcfg', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback'], 'pybind.slxos.v16r_1_00b.rule.command.interface_ve_leaf': [u'clear_support', u'clear_logging', u'clear_cl', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'protocol_lldp', u'interface_int', u'interface_eth', u'protocol_spanning', u'interface_eth_leaf', u'copy_support', u'copy_cp', u'interface_pc', u'copy_running', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback', u'interface_mgmt', u'interface_fc', u'protocol_pr'], 'pybind.nos.v6_0_2c.rule.command.interface_ve_leaf': [u'clear_support', u'clear_logging', u'clear_cl', u'copy_cp', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback'], 'pybind.nos.v7_0_1b.rule.command.interface_ve_leaf': [u'clear_support', u'clear_logging', u'clear_cl', u'copy_cp', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rule_command_interface_vlan_delete(self, rule=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.rule', 'rule'), ('pybind.nos.v7_0_1b.rule', 'rule'), ('pybind.nos.v7_1_0.rule', 'rule'), ('pybind.nos.v6_0_2c.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2c.rule.command.interface_vlan_leaf.interface', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rule.command.interface_vlan_leaf.interface', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rule.command.interface_vlan_leaf.interface', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rule.command.interface_vlan_leaf.interface', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vlan'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rule_command_interface_vlan_leaf_delete(self, rule=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rule', 'rule'), ('pybind.nos.v7_0_1b.rule', 'rule'), ('pybind.slxos.v16r_1_00b.rule', 'rule'), ('pybind.nos.v7_1_0.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2c.rule.command.interface_vlan_leaf', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rule.command.interface_vlan_leaf', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rule.command.interface_vlan_leaf', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rule.command.interface_vlan_leaf', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_0_1b.rule.command.interface_vlan_leaf': [u'clear_support', u'clear_logging', u'clear_cl', u'copy_cp', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback'], 'pybind.nos.v6_0_2c.rule.command.interface_vlan_leaf': [u'clear_support', u'clear_logging', u'clear_cl', u'copy_cp', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback'], 'pybind.nos.v7_1_0.rule.command.interface_vlan_leaf': [u'clear_support', u'clear_logging', u'clear_cl', u'show_running', u'show_startupcfg', u'copy_cp', u'show_rb_runcfg', u'show_startupdb', u'show_rb_local_runcfg', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback'], 'pybind.slxos.v16r_1_00b.rule.command.interface_vlan_leaf': [u'clear_support', u'clear_logging', u'clear_cl', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'protocol_lldp', u'interface_int', u'interface_eth', u'protocol_spanning', u'interface_eth_leaf', u'copy_support', u'copy_cp', u'interface_pc', u'copy_running', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback', u'interface_mgmt', u'interface_fc', u'protocol_pr']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rule_command_protocol_delete(self, rule=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.rule', 'rule'), ('pybind.nos.v7_0_1b.rule', 'rule'), ('pybind.nos.v7_1_0.rule', 'rule'), ('pybind.slxos.v16r_1_00b.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2c.rule.command.protocol_lldp.protocol', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rule.command.protocol_lldp.protocol', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rule.command.protocol_lldp.protocol', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rule.command.protocol_lldp.protocol', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v16r_1_00b.rule.command.protocol_lldp.protocol': [u'protocol'], 'pybind.nos.v6_0_2c.rule.command.protocol_lldp.protocol': [u'protocol'], 'pybind.nos.v7_0_1b.rule.command.protocol_lldp.protocol': [u'protocol'], 'pybind.nos.v7_1_0.rule.command.protocol_lldp.protocol': [u'protocol']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rule_command_protocol_lldp_delete(self, rule=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.rule', 'rule'), ('pybind.nos.v7_0_1b.rule', 'rule'), ('pybind.nos.v6_0_2c.rule', 'rule'), ('pybind.nos.v7_1_0.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2c.rule.command.protocol_lldp', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rule.command.protocol_lldp', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rule.command.protocol_lldp', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rule.command.protocol_lldp', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_1_0.rule.command.protocol_lldp': [u'clear_support', u'clear_logging', u'clear_cl', u'show_running', u'show_startupcfg', u'copy_cp', u'show_rb_runcfg', u'show_startupdb', u'show_rb_local_runcfg', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback'], 'pybind.nos.v6_0_2c.rule.command.protocol_lldp': [u'clear_support', u'clear_logging', u'clear_cl', u'copy_cp', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback'], 'pybind.slxos.v16r_1_00b.rule.command.protocol_lldp': [u'clear_support', u'clear_logging', u'clear_cl', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'protocol_lldp', u'interface_int', u'interface_eth', u'protocol_spanning', u'interface_eth_leaf', u'copy_support', u'copy_cp', u'interface_pc', u'copy_running', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback', u'interface_mgmt', u'interface_fc', u'protocol_pr'], 'pybind.nos.v7_0_1b.rule.command.protocol_lldp': [u'clear_support', u'clear_logging', u'clear_cl', u'copy_cp', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rule_command_protocol_pr_delete(self, rule=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.rule', 'rule'), ('pybind.nos.v7_1_0.rule', 'rule'), ('pybind.nos.v6_0_2c.rule', 'rule'), ('pybind.nos.v7_0_1b.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2c.rule.command.protocol_pr', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rule.command.protocol_pr', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rule.command.protocol_pr', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rule.command.protocol_pr', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_1_0.rule.command.protocol_pr': [u'clear_support', u'clear_logging', u'clear_cl', u'show_running', u'show_startupcfg', u'copy_cp', u'show_rb_runcfg', u'show_startupdb', u'show_rb_local_runcfg', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback'], 'pybind.nos.v6_0_2c.rule.command.protocol_pr': [u'clear_support', u'clear_logging', u'clear_cl', u'copy_cp', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback'], 'pybind.nos.v7_0_1b.rule.command.protocol_pr': [u'clear_support', u'clear_logging', u'clear_cl', u'copy_cp', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback'], 'pybind.slxos.v16r_1_00b.rule.command.protocol_pr': [u'clear_support', u'clear_logging', u'clear_cl', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'protocol_lldp', u'interface_int', u'interface_eth', u'protocol_spanning', u'interface_eth_leaf', u'copy_support', u'copy_cp', u'interface_pc', u'copy_running', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback', u'interface_mgmt', u'interface_fc', u'protocol_pr']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rule_command_protocol_protocol_spanning_delete(self, rule=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.rule', 'rule'), ('pybind.nos.v7_1_0.rule', 'rule'), ('pybind.nos.v7_0_1b.rule', 'rule'), ('pybind.nos.v6_0_2c.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2c.rule.command.protocol_spanning.protocol', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rule.command.protocol_spanning.protocol', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rule.command.protocol_spanning.protocol', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rule.command.protocol_spanning.protocol', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v16r_1_00b.rule.command.protocol_spanning.protocol': [u'protocol'], 'pybind.nos.v7_0_1b.rule.command.protocol_spanning.protocol': [u'protocol'], 'pybind.nos.v7_1_0.rule.command.protocol_spanning.protocol': [u'protocol'], 'pybind.nos.v6_0_2c.rule.command.protocol_spanning.protocol': [u'protocol']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rule_command_protocol_spanning_delete(self, rule=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.rule', 'rule'), ('pybind.nos.v7_1_0.rule', 'rule'), ('pybind.slxos.v16r_1_00b.rule', 'rule'), ('pybind.nos.v6_0_2c.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2c.rule.command.protocol_spanning', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rule.command.protocol_spanning', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rule.command.protocol_spanning', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rule.command.protocol_spanning', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_0_1b.rule.command.protocol_spanning': [u'clear_support', u'clear_logging', u'clear_cl', u'copy_cp', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback'], 'pybind.nos.v7_1_0.rule.command.protocol_spanning': [u'clear_support', u'clear_logging', u'clear_cl', u'show_running', u'show_startupcfg', u'copy_cp', u'show_rb_runcfg', u'show_startupdb', u'show_rb_local_runcfg', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback'], 'pybind.nos.v6_0_2c.rule.command.protocol_spanning': [u'clear_support', u'clear_logging', u'clear_cl', u'copy_cp', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback'], 'pybind.slxos.v16r_1_00b.rule.command.protocol_spanning': [u'clear_support', u'clear_logging', u'clear_cl', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'protocol_lldp', u'interface_int', u'interface_eth', u'protocol_spanning', u'interface_eth_leaf', u'copy_support', u'copy_cp', u'interface_pc', u'copy_running', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback', u'interface_mgmt', u'interface_fc', u'protocol_pr']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rule_command_show_delete(self, rule=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rule', 'rule')]
    bindings_list = [('pybind.nos.v7_1_0.rule.command.show_rb_local_runcfg.show', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_1_0.rule.command.show_rb_local_runcfg.show': [u'show']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rule_command_show_rb_local_runcfg_delete(self, rule=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rule', 'rule')]
    bindings_list = [('pybind.nos.v7_1_0.rule.command.show_rb_local_runcfg', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_1_0.rule.command.show_rb_local_runcfg': [u'clear_support', u'clear_logging', u'clear_cl', u'show_running', u'show_startupcfg', u'copy_cp', u'show_rb_runcfg', u'show_startupdb', u'show_rb_local_runcfg', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rule_command_show_rb_runcfg_delete(self, rule=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rule', 'rule')]
    bindings_list = [('pybind.nos.v7_1_0.rule.command.show_rb_runcfg', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_1_0.rule.command.show_rb_runcfg': [u'clear_support', u'clear_logging', u'clear_cl', u'show_running', u'show_startupcfg', u'copy_cp', u'show_rb_runcfg', u'show_startupdb', u'show_rb_local_runcfg', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rule_command_show_running_delete(self, rule=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rule', 'rule')]
    bindings_list = [('pybind.nos.v7_1_0.rule.command.show_running', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_1_0.rule.command.show_running': [u'clear_support', u'clear_logging', u'clear_cl', u'show_running', u'show_startupcfg', u'copy_cp', u'show_rb_runcfg', u'show_startupdb', u'show_rb_local_runcfg', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rule_command_show_show_rb_runcfg_delete(self, rule=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rule', 'rule')]
    bindings_list = [('pybind.nos.v7_1_0.rule.command.show_rb_runcfg.show', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_1_0.rule.command.show_rb_runcfg.show': [u'show']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rule_command_show_show_running_delete(self, rule=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rule', 'rule')]
    bindings_list = [('pybind.nos.v7_1_0.rule.command.show_running.show', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_1_0.rule.command.show_running.show': [u'show']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rule_command_show_show_startupcfg_delete(self, rule=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rule', 'rule')]
    bindings_list = [('pybind.nos.v7_1_0.rule.command.show_startupcfg.show', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_1_0.rule.command.show_startupcfg.show': [u'show']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rule_command_show_show_startupdb_delete(self, rule=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rule', 'rule')]
    bindings_list = [('pybind.nos.v7_1_0.rule.command.show_startupdb.show', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_1_0.rule.command.show_startupdb.show': [u'show']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rule_command_show_startupcfg_delete(self, rule=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rule', 'rule')]
    bindings_list = [('pybind.nos.v7_1_0.rule.command.show_startupcfg', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_1_0.rule.command.show_startupcfg': [u'clear_support', u'clear_logging', u'clear_cl', u'show_running', u'show_startupcfg', u'copy_cp', u'show_rb_runcfg', u'show_startupdb', u'show_rb_local_runcfg', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rule_command_show_startupdb_delete(self, rule=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.rule', 'rule')]
    bindings_list = [('pybind.nos.v7_1_0.rule.command.show_startupdb', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_1_0.rule.command.show_startupdb': [u'clear_support', u'clear_logging', u'clear_cl', u'show_running', u'show_startupcfg', u'copy_cp', u'show_rb_runcfg', u'show_startupdb', u'show_rb_local_runcfg', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rule_operation_delete(self, rule=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type rule: index
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.rule', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rule', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rule', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rule', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'rule', 'keyval': 'index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'operation'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def rule_role_delete(self, rule=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type rule: index
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.rule', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.rule', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.rule', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.rule', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'rule', 'keyval': 'index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'role'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def secpolicy_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.secpolicy', 'pybind.nos.v6_0_2c.brocade_fc_auth', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.secpolicy', 'pybind.nos.v7_0_1b.brocade_fc_auth', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.secpolicy', 'pybind.nos.v7_1_0.brocade_fc_auth', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.secpolicy', 'pybind.slxos.v16r_1_00b.brocade_fc_auth', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def secpolicy_active_policy_policies_delete(self, policies=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type policies: policy
    :param policies: Keyword argument tuple.

    :type policy: unicode
    :param policy: **policies** tuple argument.

        * pattern restriction: ::

            'SCC_POLICY'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.secpolicy_sa.secpolicy.active_policy.policies', 'pybind.nos.v6_0_2c.brocade_fc_auth', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.secpolicy_sa.secpolicy.active_policy.policies', 'pybind.nos.v7_0_1b.brocade_fc_auth', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.secpolicy_sa.secpolicy.active_policy.policies', 'pybind.nos.v7_1_0.brocade_fc_auth', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.secpolicy_sa.secpolicy.active_policy.policies', 'pybind.slxos.v16r_1_00b.brocade_fc_auth', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'policies', 'keyval': 'policy', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policies=policies)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policies=policies)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def secpolicy_active_policy_policies_member_entry_delete(self, policies=None, member_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policies: policy
    :param policies: Keyword argument tuple.

    :type policy: unicode
    :param policy: **policies** tuple argument.

        * pattern restriction: ::

            'SCC_POLICY'

    **Instance Keyword Argument Tuple**:

    :type member_entry: member
    :param member_entry: Keyword argument tuple.

    :type member: unicode
    :param member: **member_entry** tuple argument:  WWN of the switch

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.secpolicy_sa.secpolicy.active_policy.policies', u'policies'), ('pybind.nos.v6_0_2c.secpolicy_sa.secpolicy.active_policy.policies', u'policies'), ('pybind.slxos.v16r_1_00b.secpolicy_sa.secpolicy.active_policy.policies', u'policies'), ('pybind.nos.v7_0_1b.secpolicy_sa.secpolicy.active_policy.policies', u'policies')]
    bindings_list = [('pybind.nos.v6_0_2c.secpolicy_sa.secpolicy.active_policy.policies.member_entry', 'pybind.nos.v6_0_2c.brocade_fc_auth', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.secpolicy_sa.secpolicy.active_policy.policies.member_entry', 'pybind.nos.v7_0_1b.brocade_fc_auth', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.secpolicy_sa.secpolicy.active_policy.policies.member_entry', 'pybind.nos.v7_1_0.brocade_fc_auth', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.secpolicy_sa.secpolicy.active_policy.policies.member_entry', 'pybind.slxos.v16r_1_00b.brocade_fc_auth', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'policy', 'extra_keyval': ''}, {'keyval': 'policy', 'extra_keyval': ''}, {'keyval': 'policy', 'extra_keyval': ''}, {'keyval': 'policy', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'member_entry', 'keyval': 'member', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policies=policies, member_entry=member_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policies=policies, member_entry=member_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def secpolicy_defined_policy_policies_delete(self, policies=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type policies: policy
    :param policies: Keyword argument tuple.

    :type policy: unicode
    :param policy: **policies** tuple argument.

        * pattern restriction: ::

            'SCC_POLICY'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.secpolicy_sa.secpolicy.defined_policy.policies', 'pybind.nos.v6_0_2c.brocade_fc_auth', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.secpolicy_sa.secpolicy.defined_policy.policies', 'pybind.nos.v7_0_1b.brocade_fc_auth', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.secpolicy_sa.secpolicy.defined_policy.policies', 'pybind.nos.v7_1_0.brocade_fc_auth', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.secpolicy_sa.secpolicy.defined_policy.policies', 'pybind.slxos.v16r_1_00b.brocade_fc_auth', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'policies', 'keyval': 'policy', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policies=policies)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policies=policies)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def secpolicy_defined_policy_policies_member_entry_delete(self, policies=None, member_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policies: policy
    :param policies: Keyword argument tuple.

    :type policy: unicode
    :param policy: **policies** tuple argument.

        * pattern restriction: ::

            'SCC_POLICY'

    **Instance Keyword Argument Tuple**:

    :type member_entry: member
    :param member_entry: Keyword argument tuple.

    :type member: unicode
    :param member: **member_entry** tuple argument:  WWN of the switch

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.secpolicy_sa.secpolicy.defined_policy.policies', u'policies'), ('pybind.slxos.v16r_1_00b.secpolicy_sa.secpolicy.defined_policy.policies', u'policies'), ('pybind.nos.v7_0_1b.secpolicy_sa.secpolicy.defined_policy.policies', u'policies'), ('pybind.nos.v6_0_2c.secpolicy_sa.secpolicy.defined_policy.policies', u'policies')]
    bindings_list = [('pybind.nos.v6_0_2c.secpolicy_sa.secpolicy.defined_policy.policies.member_entry', 'pybind.nos.v6_0_2c.brocade_fc_auth', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.secpolicy_sa.secpolicy.defined_policy.policies.member_entry', 'pybind.nos.v7_0_1b.brocade_fc_auth', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.secpolicy_sa.secpolicy.defined_policy.policies.member_entry', 'pybind.nos.v7_1_0.brocade_fc_auth', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.secpolicy_sa.secpolicy.defined_policy.policies.member_entry', 'pybind.slxos.v16r_1_00b.brocade_fc_auth', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'policy', 'extra_keyval': ''}, {'keyval': 'policy', 'extra_keyval': ''}, {'keyval': 'policy', 'extra_keyval': ''}, {'keyval': 'policy', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'member_entry', 'keyval': 'member', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policies=policies, member_entry=member_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policies=policies, member_entry=member_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def secpolicy_sa_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.secpolicy_sa', 'pybind.nos.v6_0_2c.brocade_fc_auth', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.secpolicy_sa', 'pybind.nos.v7_0_1b.brocade_fc_auth', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.secpolicy_sa', 'pybind.nos.v7_1_0.brocade_fc_auth', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.secpolicy_sa', 'pybind.slxos.v16r_1_00b.brocade_fc_auth', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def service_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.service', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.service', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.service', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.service', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def service_password_encryption_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.service', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.service', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.service', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.service', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'password-encryption'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def sflow_collector_delete(self, collector=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type collector: collector_ip_address, collector_port_number, use_vrf
    :param collector: Keyword argument tuple.

    :type collector_ip_address: unicode
    :param collector_ip_address: **collector** tuple argument:  <ipv4/v6 address>; The IPv4/IPv6 address of the Sflow collector

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type collector_port_number: long
    :param collector_port_number: **collector** tuple argument:  <1-65535> The port number used by the Sflow collector (default = 6343)

        * range restriction: ::

            ['0..4294967295']

    :type use_vrf: unicode
    :param use_vrf: **collector** tuple argument:  Vrf to use for sending data to the collector (default = mgmt-vrf)

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.sflow.collector', 'pybind.nos.v6_0_2c.brocade_sflow', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.sflow.collector', 'pybind.nos.v7_0_1b.brocade_sflow', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.sflow.collector', 'pybind.nos.v7_1_0.brocade_sflow', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.sflow.collector', 'pybind.slxos.v16r_1_00b.brocade_sflow', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'collector', 'keyval': 'collector_ip_address, collector_port_number, use_vrf', 'extra_keyval': 'collector_ip_address, collector_port_number, use_vrf'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, collector=collector)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, collector=collector)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def sflow_collector_vrf_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.sflow', 'pybind.slxos.v16r_1_00b.brocade_sflow', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'collector-vrf'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def sflow_enable_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.sflow', 'pybind.nos.v6_0_2c.brocade_sflow', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.sflow', 'pybind.nos.v7_0_1b.brocade_sflow', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.sflow', 'pybind.nos.v7_1_0.brocade_sflow', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.sflow', 'pybind.slxos.v16r_1_00b.brocade_sflow', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def sflow_null0_sampling_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.sflow', 'pybind.slxos.v16r_1_00b.brocade_sflow', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'null0-sampling'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def sflow_polling_interval_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.sflow', 'pybind.nos.v6_0_2c.brocade_sflow', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.sflow', 'pybind.nos.v7_0_1b.brocade_sflow', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.sflow', 'pybind.nos.v7_1_0.brocade_sflow', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.sflow', 'pybind.slxos.v16r_1_00b.brocade_sflow', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'polling-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def sflow_profile_delete(self, sflow_profile=None, profile_sampling_rate=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type sflow_profile: profile_name, profile_sampling_rate
    :param sflow_profile: Keyword argument tuple.

    :type profile_name: unicode
    :param profile_name: **sflow_profile** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type profile_sampling_rate: long
    :param profile_sampling_rate: **sflow_profile** tuple argument:  Sflow profile sampling-rate

        * range restriction: ::

            ['0..4294967295']

    **Instance Argument(s)**:

    :type profile_sampling_rate: long
    :param profile_sampling_rate: Sflow profile sampling-rate

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.sflow_profile', 'pybind.nos.v6_0_2c.brocade_sflow', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.sflow_profile', 'pybind.nos.v7_0_1b.brocade_sflow', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.sflow_profile', 'pybind.nos.v7_1_0.brocade_sflow', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.sflow_profile', 'pybind.slxos.v16r_1_00b.brocade_sflow', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'sflow_profile', 'keyval': 'profile_name', 'extra_keyval': 'profile_name, profile_sampling_rate'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sflow_profile=sflow_profile, profile_sampling_rate=profile_sampling_rate)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sflow_profile=sflow_profile, profile_sampling_rate=profile_sampling_rate)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def sflow_profile_sampling_rate_delete(self, sflow_profile=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type sflow_profile: profile_name
    :param sflow_profile: Keyword argument tuple.

    :type profile_name: unicode
    :param profile_name: **sflow_profile** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.sflow_profile', 'pybind.nos.v6_0_2c.brocade_sflow', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.sflow_profile', 'pybind.nos.v7_0_1b.brocade_sflow', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.sflow_profile', 'pybind.nos.v7_1_0.brocade_sflow', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.sflow_profile', 'pybind.slxos.v16r_1_00b.brocade_sflow', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'sflow_profile', 'keyval': 'profile_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'sampling-rate'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sflow_profile=sflow_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sflow_profile=sflow_profile)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def sflow_sample_rate_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.sflow', 'pybind.nos.v6_0_2c.brocade_sflow', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.sflow', 'pybind.nos.v7_0_1b.brocade_sflow', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.sflow', 'pybind.nos.v7_1_0.brocade_sflow', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.sflow', 'pybind.slxos.v16r_1_00b.brocade_sflow', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'sample-rate'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def sflow_source_interface_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.sflow.source_interface', 'pybind.slxos.v16r_1_00b.brocade_sflow', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'interface_type, interface_name'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def sflow_source_interface_interface_name_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.sflow.source_interface', 'pybind.slxos.v16r_1_00b.brocade_sflow', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'interface-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def sflow_source_interface_interface_type_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.sflow.source_interface', 'pybind.slxos.v16r_1_00b.brocade_sflow', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'interface-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def sflow_source_ip_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.sflow', 'pybind.nos.v6_0_2c.brocade_sflow', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.sflow', 'pybind.nos.v7_0_1b.brocade_sflow', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.sflow', 'pybind.nos.v7_1_0.brocade_sflow', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'source-ip'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def sfm_state_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.sfm_state', 'pybind.slxos.v16r_1_00b.brocade_sysmgr_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def sfm_state_connectivity_delete(self, connectivity=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type connectivity: connectivity_sfmid
    :param connectivity: Keyword argument tuple.

    :type connectivity_sfmid: long
    :param connectivity_sfmid: **connectivity** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.sfm_state.connectivity', 'pybind.slxos.v16r_1_00b.brocade_sysmgr_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'connectivity', 'keyval': 'connectivity_sfmid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, connectivity=connectivity)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, connectivity=connectivity)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def sfm_state_connectivity_connectivity_count_delete(self, connectivity=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type connectivity: connectivity_sfmid
    :param connectivity: Keyword argument tuple.

    :type connectivity_sfmid: long
    :param connectivity_sfmid: **connectivity** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.sfm_state.connectivity', 'pybind.slxos.v16r_1_00b.brocade_sysmgr_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'connectivity', 'keyval': 'connectivity_sfmid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'connectivity-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, connectivity=connectivity)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, connectivity=connectivity)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def sfm_state_connectivity_connectivity_feid_delete(self, connectivity=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type connectivity: connectivity_sfmid
    :param connectivity: Keyword argument tuple.

    :type connectivity_sfmid: long
    :param connectivity_sfmid: **connectivity** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.sfm_state.connectivity', 'pybind.slxos.v16r_1_00b.brocade_sysmgr_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'connectivity', 'keyval': 'connectivity_sfmid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'connectivity-feid'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, connectivity=connectivity)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, connectivity=connectivity)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def sfm_state_connectivity_connectivity_type_delete(self, connectivity=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type connectivity: connectivity_sfmid
    :param connectivity: Keyword argument tuple.

    :type connectivity_sfmid: long
    :param connectivity_sfmid: **connectivity** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.sfm_state.connectivity', 'pybind.slxos.v16r_1_00b.brocade_sysmgr_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'connectivity', 'keyval': 'connectivity_sfmid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'connectivity-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, connectivity=connectivity)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, connectivity=connectivity)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def sfm_state_links_delete(self, links=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type links: links_sfmid
    :param links: Keyword argument tuple.

    :type links_sfmid: long
    :param links_sfmid: **links** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.sfm_state.links', 'pybind.slxos.v16r_1_00b.brocade_sysmgr_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'links', 'keyval': 'links_sfmid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, links=links)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, links=links)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def sfm_state_links_links_count_delete(self, links=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type links: links_sfmid
    :param links: Keyword argument tuple.

    :type links_sfmid: long
    :param links_sfmid: **links** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.sfm_state.links', 'pybind.slxos.v16r_1_00b.brocade_sysmgr_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'links', 'keyval': 'links_sfmid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'links-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, links=links)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, links=links)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def sfm_state_links_links_feid_delete(self, links=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type links: links_sfmid
    :param links: Keyword argument tuple.

    :type links_sfmid: long
    :param links_sfmid: **links** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.sfm_state.links', 'pybind.slxos.v16r_1_00b.brocade_sysmgr_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'links', 'keyval': 'links_sfmid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'links-feid'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, links=links)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, links=links)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def sfm_state_mcast_delete(self, mcast=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type mcast: mcastid
    :param mcast: Keyword argument tuple.

    :type mcastid: long
    :param mcastid: **mcast** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.sfm_state.mcast', 'pybind.slxos.v16r_1_00b.brocade_sysmgr_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'mcast', 'keyval': 'mcastid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mcast=mcast)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mcast=mcast)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def sfm_state_mcast_mcast_count_delete(self, mcast=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type mcast: mcastid
    :param mcast: Keyword argument tuple.

    :type mcastid: long
    :param mcastid: **mcast** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.sfm_state.mcast', 'pybind.slxos.v16r_1_00b.brocade_sysmgr_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'mcast', 'keyval': 'mcastid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mcast-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mcast=mcast)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mcast=mcast)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def sfm_state_mcast_mcast_feid_delete(self, mcast=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type mcast: mcastid
    :param mcast: Keyword argument tuple.

    :type mcastid: long
    :param mcastid: **mcast** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.sfm_state.mcast', 'pybind.slxos.v16r_1_00b.brocade_sysmgr_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'mcast', 'keyval': 'mcastid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mcast-feid'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mcast=mcast)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mcast=mcast)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def sfm_state_mcast_mcast_sfmcount_delete(self, mcast=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type mcast: mcastid
    :param mcast: Keyword argument tuple.

    :type mcastid: long
    :param mcastid: **mcast** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.sfm_state.mcast', 'pybind.slxos.v16r_1_00b.brocade_sysmgr_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'mcast', 'keyval': 'mcastid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mcast-sfmcount'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mcast=mcast)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mcast=mcast)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def sfm_state_mcast_mcast_sfmid_delete(self, mcast=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type mcast: mcastid
    :param mcast: Keyword argument tuple.

    :type mcastid: long
    :param mcastid: **mcast** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.sfm_state.mcast', 'pybind.slxos.v16r_1_00b.brocade_sysmgr_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'mcast', 'keyval': 'mcastid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mcast-sfmid'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mcast=mcast)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mcast=mcast)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def sfm_state_queue_delete(self, queue=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type queue: queue_sfmid
    :param queue: Keyword argument tuple.

    :type queue_sfmid: long
    :param queue_sfmid: **queue** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.sfm_state.queue', 'pybind.slxos.v16r_1_00b.brocade_sysmgr_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'queue', 'keyval': 'queue_sfmid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, queue=queue)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, queue=queue)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def sfm_state_queue_queue_dch_count_delete(self, queue=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type queue: queue_sfmid
    :param queue: Keyword argument tuple.

    :type queue_sfmid: long
    :param queue_sfmid: **queue** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.sfm_state.queue', 'pybind.slxos.v16r_1_00b.brocade_sysmgr_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'queue', 'keyval': 'queue_sfmid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'queue-dch-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, queue=queue)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, queue=queue)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def sfm_state_queue_queue_dcl_count_delete(self, queue=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type queue: queue_sfmid
    :param queue: Keyword argument tuple.

    :type queue_sfmid: long
    :param queue_sfmid: **queue** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.sfm_state.queue', 'pybind.slxos.v16r_1_00b.brocade_sysmgr_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'queue', 'keyval': 'queue_sfmid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'queue-dcl-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, queue=queue)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, queue=queue)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def sfm_state_queue_queue_dcm_count_delete(self, queue=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type queue: queue_sfmid
    :param queue: Keyword argument tuple.

    :type queue_sfmid: long
    :param queue_sfmid: **queue** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.sfm_state.queue', 'pybind.slxos.v16r_1_00b.brocade_sysmgr_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'queue', 'keyval': 'queue_sfmid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'queue-dcm-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, queue=queue)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, queue=queue)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def sfm_state_queue_queue_feid_delete(self, queue=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type queue: queue_sfmid
    :param queue: Keyword argument tuple.

    :type queue_sfmid: long
    :param queue_sfmid: **queue** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.sfm_state.queue', 'pybind.slxos.v16r_1_00b.brocade_sysmgr_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'queue', 'keyval': 'queue_sfmid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'queue-feid'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, queue=queue)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, queue=queue)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def sfm_state_queue_queue_pipe_delete(self, queue=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type queue: queue_sfmid
    :param queue: Keyword argument tuple.

    :type queue_sfmid: long
    :param queue_sfmid: **queue** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.sfm_state.queue', 'pybind.slxos.v16r_1_00b.brocade_sysmgr_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'queue', 'keyval': 'queue_sfmid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'queue-pipe'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, queue=queue)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, queue=queue)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def sfm_state_serdesmode_delete(self, serdesmode=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type serdesmode: serdesmode_sfmid
    :param serdesmode: Keyword argument tuple.

    :type serdesmode_sfmid: long
    :param serdesmode_sfmid: **serdesmode** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.sfm_state.serdesmode', 'pybind.slxos.v16r_1_00b.brocade_sysmgr_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'serdesmode', 'keyval': 'serdesmode_sfmid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, serdesmode=serdesmode)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, serdesmode=serdesmode)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def sfm_state_serdesmode_serdesmode_delete(self, serdesmode=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type serdesmode: serdesmode_sfmid
    :param serdesmode: Keyword argument tuple.

    :type serdesmode_sfmid: long
    :param serdesmode_sfmid: **serdesmode** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.sfm_state.serdesmode', 'pybind.slxos.v16r_1_00b.brocade_sysmgr_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'serdesmode', 'keyval': 'serdesmode_sfmid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'serdesmode'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, serdesmode=serdesmode)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, serdesmode=serdesmode)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def sfm_state_serdesmode_serdesmode_feid_delete(self, serdesmode=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type serdesmode: serdesmode_sfmid
    :param serdesmode: Keyword argument tuple.

    :type serdesmode_sfmid: long
    :param serdesmode_sfmid: **serdesmode** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.sfm_state.serdesmode', 'pybind.slxos.v16r_1_00b.brocade_sysmgr_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'serdesmode', 'keyval': 'serdesmode_sfmid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'serdesmode-feid'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, serdesmode=serdesmode)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, serdesmode=serdesmode)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def sfm_state_statistics_delete(self, statistics=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type statistics: statistics_sfmid
    :param statistics: Keyword argument tuple.

    :type statistics_sfmid: long
    :param statistics_sfmid: **statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.sfm_state.statistics', 'pybind.slxos.v16r_1_00b.brocade_sysmgr_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'statistics', 'keyval': 'statistics_sfmid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, statistics=statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, statistics=statistics)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def sfm_state_statistics_statistics_dch_fifo_discard_delete(self, statistics=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type statistics: statistics_sfmid
    :param statistics: Keyword argument tuple.

    :type statistics_sfmid: long
    :param statistics_sfmid: **statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.sfm_state.statistics', 'pybind.slxos.v16r_1_00b.brocade_sysmgr_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'statistics', 'keyval': 'statistics_sfmid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'statistics-dch-fifo-discard'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, statistics=statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, statistics=statistics)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def sfm_state_statistics_statistics_dch_max_q_size_delete(self, statistics=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type statistics: statistics_sfmid
    :param statistics: Keyword argument tuple.

    :type statistics_sfmid: long
    :param statistics_sfmid: **statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.sfm_state.statistics', 'pybind.slxos.v16r_1_00b.brocade_sysmgr_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'statistics', 'keyval': 'statistics_sfmid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'statistics-dch-max-q-size'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, statistics=statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, statistics=statistics)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def sfm_state_statistics_statistics_dch_reorder_discard_delete(self, statistics=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type statistics: statistics_sfmid
    :param statistics: Keyword argument tuple.

    :type statistics_sfmid: long
    :param statistics_sfmid: **statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.sfm_state.statistics', 'pybind.slxos.v16r_1_00b.brocade_sysmgr_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'statistics', 'keyval': 'statistics_sfmid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'statistics-dch-reorder-discard'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, statistics=statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, statistics=statistics)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def sfm_state_statistics_statistics_dch_total_in_delete(self, statistics=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type statistics: statistics_sfmid
    :param statistics: Keyword argument tuple.

    :type statistics_sfmid: long
    :param statistics_sfmid: **statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.sfm_state.statistics', 'pybind.slxos.v16r_1_00b.brocade_sysmgr_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'statistics', 'keyval': 'statistics_sfmid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'statistics-dch-total-in'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, statistics=statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, statistics=statistics)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def sfm_state_statistics_statistics_dch_total_out_delete(self, statistics=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type statistics: statistics_sfmid
    :param statistics: Keyword argument tuple.

    :type statistics_sfmid: long
    :param statistics_sfmid: **statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.sfm_state.statistics', 'pybind.slxos.v16r_1_00b.brocade_sysmgr_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'statistics', 'keyval': 'statistics_sfmid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'statistics-dch-total-out'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, statistics=statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, statistics=statistics)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def sfm_state_statistics_statistics_dch_unreach_discard_delete(self, statistics=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type statistics: statistics_sfmid
    :param statistics: Keyword argument tuple.

    :type statistics_sfmid: long
    :param statistics_sfmid: **statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.sfm_state.statistics', 'pybind.slxos.v16r_1_00b.brocade_sysmgr_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'statistics', 'keyval': 'statistics_sfmid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'statistics-dch-unreach-discard'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, statistics=statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, statistics=statistics)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def sfm_state_statistics_statistics_dcl_dropped_delete(self, statistics=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type statistics: statistics_sfmid
    :param statistics: Keyword argument tuple.

    :type statistics_sfmid: long
    :param statistics_sfmid: **statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.sfm_state.statistics', 'pybind.slxos.v16r_1_00b.brocade_sysmgr_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'statistics', 'keyval': 'statistics_sfmid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'statistics-dcl-dropped'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, statistics=statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, statistics=statistics)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def sfm_state_statistics_statistics_dcl_max_delete(self, statistics=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type statistics: statistics_sfmid
    :param statistics: Keyword argument tuple.

    :type statistics_sfmid: long
    :param statistics_sfmid: **statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.sfm_state.statistics', 'pybind.slxos.v16r_1_00b.brocade_sysmgr_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'statistics', 'keyval': 'statistics_sfmid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'statistics-dcl-max'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, statistics=statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, statistics=statistics)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def sfm_state_statistics_statistics_dcl_tot_in_delete(self, statistics=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type statistics: statistics_sfmid
    :param statistics: Keyword argument tuple.

    :type statistics_sfmid: long
    :param statistics_sfmid: **statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.sfm_state.statistics', 'pybind.slxos.v16r_1_00b.brocade_sysmgr_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'statistics', 'keyval': 'statistics_sfmid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'statistics-dcl-tot-in'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, statistics=statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, statistics=statistics)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def sfm_state_statistics_statistics_dcl_tot_out_delete(self, statistics=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type statistics: statistics_sfmid
    :param statistics: Keyword argument tuple.

    :type statistics_sfmid: long
    :param statistics_sfmid: **statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.sfm_state.statistics', 'pybind.slxos.v16r_1_00b.brocade_sysmgr_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'statistics', 'keyval': 'statistics_sfmid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'statistics-dcl-tot-out'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, statistics=statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, statistics=statistics)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def sfm_state_statistics_statistics_dcm_drop_delete(self, statistics=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type statistics: statistics_sfmid
    :param statistics: Keyword argument tuple.

    :type statistics_sfmid: long
    :param statistics_sfmid: **statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.sfm_state.statistics', 'pybind.slxos.v16r_1_00b.brocade_sysmgr_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'statistics', 'keyval': 'statistics_sfmid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'statistics-dcm-drop'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, statistics=statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, statistics=statistics)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def sfm_state_statistics_statistics_dcm_max_delete(self, statistics=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type statistics: statistics_sfmid
    :param statistics: Keyword argument tuple.

    :type statistics_sfmid: long
    :param statistics_sfmid: **statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.sfm_state.statistics', 'pybind.slxos.v16r_1_00b.brocade_sysmgr_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'statistics', 'keyval': 'statistics_sfmid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'statistics-dcm-max'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, statistics=statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, statistics=statistics)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def sfm_state_statistics_statistics_dcm_tot_delete(self, statistics=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type statistics: statistics_sfmid
    :param statistics: Keyword argument tuple.

    :type statistics_sfmid: long
    :param statistics_sfmid: **statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.sfm_state.statistics', 'pybind.slxos.v16r_1_00b.brocade_sysmgr_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'statistics', 'keyval': 'statistics_sfmid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'statistics-dcm-tot'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, statistics=statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, statistics=statistics)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def sfm_state_statistics_statistics_feid_delete(self, statistics=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type statistics: statistics_sfmid
    :param statistics: Keyword argument tuple.

    :type statistics_sfmid: long
    :param statistics_sfmid: **statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.sfm_state.statistics', 'pybind.slxos.v16r_1_00b.brocade_sysmgr_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'statistics', 'keyval': 'statistics_sfmid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'statistics-feid'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, statistics=statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, statistics=statistics)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def sfm_state_statistics_statistics_pipe_delete(self, statistics=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type statistics: statistics_sfmid
    :param statistics: Keyword argument tuple.

    :type statistics_sfmid: long
    :param statistics_sfmid: **statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.sfm_state.statistics', 'pybind.slxos.v16r_1_00b.brocade_sysmgr_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'statistics', 'keyval': 'statistics_sfmid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'statistics-pipe'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, statistics=statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, statistics=statistics)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def sfm_state_thresholds_delete(self, thresholds=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type thresholds: thresholds_sfmid
    :param thresholds: Keyword argument tuple.

    :type thresholds_sfmid: long
    :param thresholds_sfmid: **thresholds** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.sfm_state.thresholds', 'pybind.slxos.v16r_1_00b.brocade_sysmgr_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'thresholds', 'keyval': 'thresholds_sfmid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, thresholds=thresholds)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, thresholds=thresholds)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def sfm_state_thresholds_thresholds_feid_delete(self, thresholds=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type thresholds: thresholds_sfmid
    :param thresholds: Keyword argument tuple.

    :type thresholds_sfmid: long
    :param thresholds_sfmid: **thresholds** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.sfm_state.thresholds', 'pybind.slxos.v16r_1_00b.brocade_sysmgr_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'thresholds', 'keyval': 'thresholds_sfmid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'thresholds-feid'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, thresholds=thresholds)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, thresholds=thresholds)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def sfm_state_thresholds_thresholds_port_delete(self, thresholds=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type thresholds: thresholds_sfmid
    :param thresholds: Keyword argument tuple.

    :type thresholds_sfmid: long
    :param thresholds_sfmid: **thresholds** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.sfm_state.thresholds', 'pybind.slxos.v16r_1_00b.brocade_sysmgr_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'thresholds', 'keyval': 'thresholds_sfmid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'thresholds-port'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, thresholds=thresholds)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, thresholds=thresholds)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def show_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.show', 'pybind.nos.v6_0_2c.brocade_common_def', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.show', 'pybind.nos.v7_0_1b.brocade_common_def', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.show', 'pybind.nos.v7_1_0.brocade_common_def', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.show', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def show_bpswitch_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.show.bpswitch', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def show_client_id_df_info_state_delete(self, show_client_id_df_info_state=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type show_client_id_df_info_state: cluster_id, client_id
    :param show_client_id_df_info_state: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_client_id_df_info_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type client_id: long
    :param client_id: **show_client_id_df_info_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.show_client_id_df_info_state', 'pybind.slxos.v16r_1_00b.brocade_mct_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'show_client_id_df_info_state', 'keyval': 'cluster_id, client_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_client_id_df_info_state=show_client_id_df_info_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_client_id_df_info_state=show_client_id_df_info_state)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def show_client_id_df_info_state_client_state_delete(self, show_client_id_df_info_state=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type show_client_id_df_info_state: cluster_id, client_id
    :param show_client_id_df_info_state: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_client_id_df_info_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type client_id: long
    :param client_id: **show_client_id_df_info_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.show_client_id_df_info_state', 'pybind.slxos.v16r_1_00b.brocade_mct_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'show_client_id_df_info_state', 'keyval': 'cluster_id, client_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'client-state'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_client_id_df_info_state=show_client_id_df_info_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_client_id_df_info_state=show_client_id_df_info_state)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def show_client_id_df_info_state_df_vlans_delete(self, show_client_id_df_info_state=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type show_client_id_df_info_state: cluster_id, client_id
    :param show_client_id_df_info_state: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_client_id_df_info_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type client_id: long
    :param client_id: **show_client_id_df_info_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.show_client_id_df_info_state', 'show_client_id_df_info_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.show_client_id_df_info_state.df_vlans', 'pybind.slxos.v16r_1_00b.brocade_mct_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_id, client_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_client_id_df_info_state=show_client_id_df_info_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_client_id_df_info_state=show_client_id_df_info_state)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def show_client_id_df_info_state_df_vlans_vlan_id_delete(self, show_client_id_df_info_state=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type show_client_id_df_info_state: cluster_id, client_id
    :param show_client_id_df_info_state: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_client_id_df_info_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type client_id: long
    :param client_id: **show_client_id_df_info_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.show_client_id_df_info_state', 'show_client_id_df_info_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.show_client_id_df_info_state.df_vlans', 'pybind.slxos.v16r_1_00b.brocade_mct_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_id, client_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vlan-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_client_id_df_info_state=show_client_id_df_info_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_client_id_df_info_state=show_client_id_df_info_state)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def show_client_id_df_info_state_is_all_vlan_elected_delete(self, show_client_id_df_info_state=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type show_client_id_df_info_state: cluster_id, client_id
    :param show_client_id_df_info_state: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_client_id_df_info_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type client_id: long
    :param client_id: **show_client_id_df_info_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.show_client_id_df_info_state', 'pybind.slxos.v16r_1_00b.brocade_mct_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'show_client_id_df_info_state', 'keyval': 'cluster_id, client_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'is-all-vlan-elected'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_client_id_df_info_state=show_client_id_df_info_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_client_id_df_info_state=show_client_id_df_info_state)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def show_client_id_df_info_state_is_df_election_pending_delete(self, show_client_id_df_info_state=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type show_client_id_df_info_state: cluster_id, client_id
    :param show_client_id_df_info_state: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_client_id_df_info_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type client_id: long
    :param client_id: **show_client_id_df_info_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.show_client_id_df_info_state', 'pybind.slxos.v16r_1_00b.brocade_mct_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'show_client_id_df_info_state', 'keyval': 'cluster_id, client_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'is-df-election-pending'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_client_id_df_info_state=show_client_id_df_info_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_client_id_df_info_state=show_client_id_df_info_state)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def show_client_id_df_info_state_num_df_vlans_delete(self, show_client_id_df_info_state=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type show_client_id_df_info_state: cluster_id, client_id
    :param show_client_id_df_info_state: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_client_id_df_info_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type client_id: long
    :param client_id: **show_client_id_df_info_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.show_client_id_df_info_state', 'pybind.slxos.v16r_1_00b.brocade_mct_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'show_client_id_df_info_state', 'keyval': 'cluster_id, client_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'num-df-vlans'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_client_id_df_info_state=show_client_id_df_info_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_client_id_df_info_state=show_client_id_df_info_state)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def show_crypto_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.show.crypto', 'pybind.nos.v6_0_2c.brocade_common_def', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.show.crypto', 'pybind.nos.v7_0_1b.brocade_common_def', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.show.crypto', 'pybind.nos.v7_1_0.brocade_common_def', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.show.crypto', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def show_defaults_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.show.defaults', 'pybind.nos.v6_0_2c.brocade_common_def', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.show.defaults', 'pybind.nos.v7_0_1b.brocade_common_def', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.show.defaults', 'pybind.nos.v7_1_0.brocade_common_def', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.show.defaults', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def show_diag_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.show.diag', 'pybind.nos.v6_0_2c.brocade_common_def', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.show.diag', 'pybind.nos.v7_0_1b.brocade_common_def', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.show.diag', 'pybind.nos.v7_1_0.brocade_common_def', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.show.diag', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def show_fabric_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.show.fabric', 'pybind.nos.v6_0_2c.brocade_common_def', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.show.fabric', 'pybind.nos.v7_0_1b.brocade_common_def', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.show.fabric', 'pybind.nos.v7_1_0.brocade_common_def', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.show.fabric', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def show_fcsp_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.show.fcsp', 'pybind.nos.v6_0_2c.brocade_common_def', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.show.fcsp', 'pybind.nos.v7_0_1b.brocade_common_def', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.show.fcsp', 'pybind.nos.v7_1_0.brocade_common_def', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.show.fcsp', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def show_http_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.show.http', 'pybind.nos.v6_0_2c.brocade_common_def', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.show.http', 'pybind.nos.v7_0_1b.brocade_common_def', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.show.http', 'pybind.nos.v7_1_0.brocade_common_def', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.show.http', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def show_infra_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.show.infra', 'pybind.nos.v6_0_2c.brocade_common_def', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.show.infra', 'pybind.nos.v7_0_1b.brocade_common_def', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.show.infra', 'pybind.nos.v7_1_0.brocade_common_def', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.show.infra', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def show_ssh_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.show.ssh', 'pybind.nos.v6_0_2c.brocade_common_def', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.show.ssh', 'pybind.nos.v7_0_1b.brocade_common_def', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.show.ssh', 'pybind.nos.v7_1_0.brocade_common_def', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.show.ssh', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def show_telnet_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.show.telnet', 'pybind.nos.v6_0_2c.brocade_common_def', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.show.telnet', 'pybind.nos.v7_0_1b.brocade_common_def', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.show.telnet', 'pybind.nos.v7_1_0.brocade_common_def', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.show.telnet', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def show_vnetwork_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.show.vnetwork', 'pybind.nos.v6_0_2c.brocade_common_def', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.show.vnetwork', 'pybind.nos.v7_0_1b.brocade_common_def', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.show.vnetwork', 'pybind.nos.v7_1_0.brocade_common_def', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.show.vnetwork', 'pybind.slxos.v16r_1_00b.brocade_common_def', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def snmp_server_community_delete(self, community=None, groupname=None, ipv4_acl=None, ipv6_acl=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type community: community, groupname, ipv4_acl, ipv6_acl
    :param community: Keyword argument tuple.

    :type community: unicode
    :param community: **community** tuple argument.

    :type groupname: unicode
    :param groupname: **community** tuple argument:  Groupname associated with community string

    :type ipv4_acl: unicode
    :param ipv4_acl: **community** tuple argument:  standard IPv4 Access list name (or) ID associated with community strings.

        * length restriction: ::

            ['0 .. 63']

    :type ipv6_acl: unicode
    :param ipv6_acl: **community** tuple argument:  standard IPv6 Access list name (or) ID associated with community strings.

        * length restriction: ::

            ['0 .. 63']

    **Instance Argument(s)**:

    :type groupname: unicode
    :param groupname: Groupname associated with community string

    :type ipv4_acl: unicode
    :param ipv4_acl: standard IPv4 Access list name (or) ID associated with community strings.

        * length restriction: ::

            ['0 .. 63']

    :type ipv6_acl: unicode
    :param ipv6_acl: standard IPv6 Access list name (or) ID associated with community strings.

        * length restriction: ::

            ['0 .. 63']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.snmp_server.community', 'pybind.nos.v6_0_2c.brocade_snmp', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.snmp_server.community', 'pybind.nos.v7_0_1b.brocade_snmp', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.snmp_server.community', 'pybind.nos.v7_1_0.brocade_snmp', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.snmp_server.community', 'pybind.slxos.v16r_1_00b.brocade_snmp', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'community', 'keyval': 'community', 'extra_keyval': 'community, groupname'}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v6_0_2c.snmp_server.community": {"ipv4_acl": "ipv4_acl", "groupname": "groupname", "ipv6_acl": "ipv6_acl", "community": "community"}, "pybind.nos.v7_0_1b.snmp_server.community": {"ipv4_acl": "ipv4_acl", "groupname": "groupname", "ipv6_acl": "ipv6_acl", "community": "community"}, "pybind.nos.v7_1_0.snmp_server.community": {"ipv4_acl": "ipv4_acl", "groupname": "groupname", "ipv6_acl": "ipv6_acl", "community": "community"}, "pybind.slxos.v16r_1_00b.snmp_server.community": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, community=community, groupname=groupname, ipv4_acl=ipv4_acl, ipv6_acl=ipv6_acl)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, community=community, groupname=groupname, ipv4_acl=ipv4_acl, ipv6_acl=ipv6_acl)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def snmp_server_community_groupname_delete(self, community=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type community: community
    :param community: Keyword argument tuple.

    :type community: unicode
    :param community: **community** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.snmp_server.community', 'pybind.nos.v6_0_2c.brocade_snmp', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.snmp_server.community', 'pybind.nos.v7_0_1b.brocade_snmp', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.snmp_server.community', 'pybind.nos.v7_1_0.brocade_snmp', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.snmp_server.community', 'pybind.slxos.v16r_1_00b.brocade_snmp', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'community', 'keyval': 'community', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'groupname'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, community=community)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, community=community)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def snmp_server_community_ipv4_acl_delete(self, community=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Instance Keyword Argument Tuple**:

    :type community: community
    :param community: Keyword argument tuple.

    :type community: unicode
    :param community: **community** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.snmp_server.community', 'pybind.nos.v6_0_2c.brocade_snmp', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.snmp_server.community', 'pybind.nos.v7_0_1b.brocade_snmp', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.snmp_server.community', 'pybind.nos.v7_1_0.brocade_snmp', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'community', 'keyval': 'community', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ipv4-acl'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, community=community)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, community=community)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def snmp_server_community_ipv6_acl_delete(self, community=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Instance Keyword Argument Tuple**:

    :type community: community
    :param community: Keyword argument tuple.

    :type community: unicode
    :param community: **community** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.snmp_server.community', 'pybind.nos.v6_0_2c.brocade_snmp', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.snmp_server.community', 'pybind.nos.v7_0_1b.brocade_snmp', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.snmp_server.community', 'pybind.nos.v7_1_0.brocade_snmp', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'community', 'keyval': 'community', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ipv6-acl'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, community=community)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, community=community)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def snmp_server_contact_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.snmp_server.agtconfig', 'pybind.nos.v6_0_2c.brocade_snmp', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.snmp_server.agtconfig', 'pybind.nos.v7_0_1b.brocade_snmp', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.snmp_server.agtconfig', 'pybind.nos.v7_1_0.brocade_snmp', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.snmp_server.agtconfig', 'pybind.slxos.v16r_1_00b.brocade_snmp', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'contact'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def snmp_server_context_delete(self, context=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type context: context_name
    :param context: Keyword argument tuple.

    :type context_name: unicode
    :param context_name: **context** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.snmp_server.context', 'pybind.nos.v6_0_2c.brocade_snmp', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.snmp_server.context', 'pybind.nos.v7_0_1b.brocade_snmp', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.snmp_server.context', 'pybind.nos.v7_1_0.brocade_snmp', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.snmp_server.context', 'pybind.slxos.v16r_1_00b.brocade_snmp', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'context', 'keyval': 'context_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, context=context)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, context=context)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def snmp_server_context_vrf_name_delete(self, context=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type context: context_name
    :param context: Keyword argument tuple.

    :type context_name: unicode
    :param context_name: **context** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.snmp_server.context', 'pybind.nos.v6_0_2c.brocade_snmp', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.snmp_server.context', 'pybind.nos.v7_0_1b.brocade_snmp', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.snmp_server.context', 'pybind.nos.v7_1_0.brocade_snmp', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.snmp_server.context', 'pybind.slxos.v16r_1_00b.brocade_snmp', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'context', 'keyval': 'context_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vrf-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, context=context)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, context=context)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def snmp_server_enable_trap_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.snmp_server.enable.trap', 'pybind.nos.v6_0_2c.brocade_snmp', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.snmp_server.enable.trap', 'pybind.nos.v7_0_1b.brocade_snmp', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.snmp_server.enable.trap', 'pybind.nos.v7_1_0.brocade_snmp', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.snmp_server.enable.trap', 'pybind.slxos.v16r_1_00b.brocade_snmp', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def snmp_server_enable_trap_trap_flag_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.snmp_server.enable.trap', 'pybind.nos.v6_0_2c.brocade_snmp', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.snmp_server.enable.trap', 'pybind.nos.v7_0_1b.brocade_snmp', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.snmp_server.enable.trap', 'pybind.nos.v7_1_0.brocade_snmp', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.snmp_server.enable.trap', 'pybind.slxos.v16r_1_00b.brocade_snmp', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'trap-flag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def snmp_server_engineID_drop_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.snmp_server.engineID_drop', 'pybind.nos.v6_0_2c.brocade_snmp', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.snmp_server.engineID_drop', 'pybind.nos.v7_0_1b.brocade_snmp', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.snmp_server.engineID_drop', 'pybind.nos.v7_1_0.brocade_snmp', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.snmp_server.engineID_drop', 'pybind.slxos.v16r_1_00b.brocade_snmp', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def snmp_server_engineid_local_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.snmp_server.engineID_drop.engineID', 'pybind.nos.v6_0_2c.brocade_snmp', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.snmp_server.engineID_drop.engineID', 'pybind.nos.v7_0_1b.brocade_snmp', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.snmp_server.engineID_drop.engineID', 'pybind.nos.v7_1_0.brocade_snmp', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.snmp_server.engineID_drop.engineID', 'pybind.slxos.v16r_1_00b.brocade_snmp', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'local'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def snmp_server_group_delete(self, group=None, group_auth_mode=None, read=None, write=None, notify=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type group: group_name, group_version, group_auth_mode, read, write, notify
    :param group: Keyword argument tuple.

    :type group_name: unicode
    :param group_name: **group** tuple argument.

        * length restriction: ::

            ['1 .. 32']

    :type group_version: unicode
    :param group_version: **group** tuple argument.

        * enumeration restriction: ::

            ['v2c', 'v1', 'v3']

    :type group_auth_mode: unicode
    :param group_auth_mode: **group** tuple argument.

        * enumeration restriction: ::

            ['noauth', 'auth', 'priv']

    :type read: unicode
    :param read: **group** tuple argument:  read	Specify a read view for the group

        * length restriction: ::

            ['1 .. 32']

    :type write: unicode
    :param write: **group** tuple argument:  write	Specify a write view for the group

        * length restriction: ::

            ['1 .. 32']

    :type notify: unicode
    :param notify: **group** tuple argument:  notify	Specify a notify view for the group

        * length restriction: ::

            ['1 .. 32']

    **Instance Argument(s)**:

    :type group_auth_mode: unicode
    :param group_auth_mode: Keyword argument.

        * enumeration restriction: ::

            ['noauth', 'auth', 'priv']

    :type read: unicode
    :param read: read	Specify a read view for the group

        * length restriction: ::

            ['1 .. 32']

    :type write: unicode
    :param write: write	Specify a write view for the group

        * length restriction: ::

            ['1 .. 32']

    :type notify: unicode
    :param notify: notify	Specify a notify view for the group

        * length restriction: ::

            ['1 .. 32']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.snmp_server.group', 'pybind.nos.v6_0_2c.brocade_snmp', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.snmp_server.group', 'pybind.nos.v7_0_1b.brocade_snmp', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.snmp_server.group', 'pybind.nos.v7_1_0.brocade_snmp', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.snmp_server.group', 'pybind.slxos.v16r_1_00b.brocade_snmp', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'group', 'keyval': 'group_name, group_version', 'extra_keyval': 'group_name, group_version, group_auth_mode, read, write, notify'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, group=group, group_auth_mode=group_auth_mode, read=read, write=write, notify=notify)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, group=group, group_auth_mode=group_auth_mode, read=read, write=write, notify=notify)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def snmp_server_group_group_auth_mode_delete(self, group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type group: group_name, group_version
    :param group: Keyword argument tuple.

    :type group_name: unicode
    :param group_name: **group** tuple argument.

        * length restriction: ::

            ['1 .. 32']

    :type group_version: unicode
    :param group_version: **group** tuple argument.

        * enumeration restriction: ::

            ['v2c', 'v1', 'v3']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.snmp_server.group', 'pybind.nos.v6_0_2c.brocade_snmp', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.snmp_server.group', 'pybind.nos.v7_0_1b.brocade_snmp', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.snmp_server.group', 'pybind.nos.v7_1_0.brocade_snmp', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.snmp_server.group', 'pybind.slxos.v16r_1_00b.brocade_snmp', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'group', 'keyval': 'group_name, group_version', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'group-auth-mode'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, group=group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, group=group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def snmp_server_group_notify_delete(self, group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type group: group_name, group_version
    :param group: Keyword argument tuple.

    :type group_name: unicode
    :param group_name: **group** tuple argument.

        * length restriction: ::

            ['1 .. 32']

    :type group_version: unicode
    :param group_version: **group** tuple argument.

        * enumeration restriction: ::

            ['v2c', 'v1', 'v3']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.snmp_server.group', 'pybind.nos.v6_0_2c.brocade_snmp', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.snmp_server.group', 'pybind.nos.v7_0_1b.brocade_snmp', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.snmp_server.group', 'pybind.nos.v7_1_0.brocade_snmp', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.snmp_server.group', 'pybind.slxos.v16r_1_00b.brocade_snmp', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'group', 'keyval': 'group_name, group_version', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'notify'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, group=group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, group=group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def snmp_server_group_read_delete(self, group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type group: group_name, group_version
    :param group: Keyword argument tuple.

    :type group_name: unicode
    :param group_name: **group** tuple argument.

        * length restriction: ::

            ['1 .. 32']

    :type group_version: unicode
    :param group_version: **group** tuple argument.

        * enumeration restriction: ::

            ['v2c', 'v1', 'v3']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.snmp_server.group', 'pybind.nos.v6_0_2c.brocade_snmp', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.snmp_server.group', 'pybind.nos.v7_0_1b.brocade_snmp', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.snmp_server.group', 'pybind.nos.v7_1_0.brocade_snmp', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.snmp_server.group', 'pybind.slxos.v16r_1_00b.brocade_snmp', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'group', 'keyval': 'group_name, group_version', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'read'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, group=group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, group=group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def snmp_server_group_write_delete(self, group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type group: group_name, group_version
    :param group: Keyword argument tuple.

    :type group_name: unicode
    :param group_name: **group** tuple argument.

        * length restriction: ::

            ['1 .. 32']

    :type group_version: unicode
    :param group_version: **group** tuple argument.

        * enumeration restriction: ::

            ['v2c', 'v1', 'v3']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.snmp_server.group', 'pybind.nos.v6_0_2c.brocade_snmp', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.snmp_server.group', 'pybind.nos.v7_0_1b.brocade_snmp', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.snmp_server.group', 'pybind.nos.v7_1_0.brocade_snmp', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.snmp_server.group', 'pybind.slxos.v16r_1_00b.brocade_snmp', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'group', 'keyval': 'group_name, group_version', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'write'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, group=group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, group=group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def snmp_server_host_delete(self, host=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type host: ip, community
    :param host: Keyword argument tuple.

    :type ip: unicode
    :param ip: **host** tuple argument:  ipv4/ipv6/dns address of the trap recipient associated with community strings.  Traps will be sent to this host

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type community: unicode
    :param community: **host** tuple argument:  Community string associated with traps.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.snmp_server.host', 'pybind.nos.v6_0_2c.brocade_snmp', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.snmp_server.host', 'pybind.nos.v7_0_1b.brocade_snmp', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.snmp_server.host', 'pybind.nos.v7_1_0.brocade_snmp', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.snmp_server.host', 'pybind.slxos.v16r_1_00b.brocade_snmp', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'host', 'keyval': 'ip, community', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, host=host)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, host=host)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def snmp_server_host_severity_level_delete(self, host=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type host: ip, community
    :param host: Keyword argument tuple.

    :type ip: unicode
    :param ip: **host** tuple argument:  ipv4/ipv6/dns address of the trap recipient associated with community strings.  Traps will be sent to this host

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type community: unicode
    :param community: **host** tuple argument:  Community string associated with traps.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.snmp_server.host', 'pybind.nos.v6_0_2c.brocade_snmp', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.snmp_server.host', 'pybind.nos.v7_0_1b.brocade_snmp', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.snmp_server.host', 'pybind.nos.v7_1_0.brocade_snmp', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.snmp_server.host', 'pybind.slxos.v16r_1_00b.brocade_snmp', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'host', 'keyval': 'ip, community', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'severity-level'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, host=host)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, host=host)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def snmp_server_host_source_interface_delete(self, host=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type host: ip, community
    :param host: Keyword argument tuple.

    :type ip: unicode
    :param ip: **host** tuple argument:  ipv4/ipv6/dns address of the trap recipient associated with community strings.  Traps will be sent to this host

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type community: unicode
    :param community: **host** tuple argument:  Community string associated with traps.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.snmp_server.host', u'host'), ('pybind.nos.v6_0_2c.snmp_server.host', u'host'), ('pybind.nos.v7_1_0.snmp_server.host', u'host')]
    bindings_list = [('pybind.nos.v6_0_2c.snmp_server.host.source_interface', 'pybind.nos.v6_0_2c.brocade_snmp', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.snmp_server.host.source_interface', 'pybind.nos.v7_0_1b.brocade_snmp', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.snmp_server.host.source_interface', 'pybind.nos.v7_1_0.brocade_snmp', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ip, community', 'extra_keyval': ''}, {'keyval': 'ip, community', 'extra_keyval': ''}, {'keyval': 'ip, community', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_1_0.snmp_server.host.source_interface': [u've', u'loopback'], 'pybind.nos.v7_0_1b.snmp_server.host.source_interface': [u've', u'loopback'], 'pybind.nos.v6_0_2c.snmp_server.host.source_interface': [u've', u'loopback']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, host=host)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, host=host)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def snmp_server_host_source_interface_loopback_delete(self, host=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type host: ip, community
    :param host: Keyword argument tuple.

    :type ip: unicode
    :param ip: **host** tuple argument:  ipv4/ipv6/dns address of the trap recipient associated with community strings.  Traps will be sent to this host

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type community: unicode
    :param community: **host** tuple argument:  Community string associated with traps.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.snmp_server.host', u'host'), ('pybind.nos.v6_0_2c.snmp_server.host', u'host'), ('pybind.nos.v7_1_0.snmp_server.host', u'host')]
    bindings_list = [('pybind.nos.v6_0_2c.snmp_server.host.source_interface', 'pybind.nos.v6_0_2c.brocade_snmp', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.snmp_server.host.source_interface', 'pybind.nos.v7_0_1b.brocade_snmp', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.snmp_server.host.source_interface', 'pybind.nos.v7_1_0.brocade_snmp', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ip, community', 'extra_keyval': ''}, {'keyval': 'ip, community', 'extra_keyval': ''}, {'keyval': 'ip, community', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'loopback'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, host=host)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, host=host)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def snmp_server_host_source_interface_ve_delete(self, host=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type host: ip, community
    :param host: Keyword argument tuple.

    :type ip: unicode
    :param ip: **host** tuple argument:  ipv4/ipv6/dns address of the trap recipient associated with community strings.  Traps will be sent to this host

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type community: unicode
    :param community: **host** tuple argument:  Community string associated with traps.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.snmp_server.host', u'host'), ('pybind.nos.v6_0_2c.snmp_server.host', u'host'), ('pybind.nos.v7_1_0.snmp_server.host', u'host')]
    bindings_list = [('pybind.nos.v6_0_2c.snmp_server.host.source_interface', 'pybind.nos.v6_0_2c.brocade_snmp', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.snmp_server.host.source_interface', 'pybind.nos.v7_0_1b.brocade_snmp', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.snmp_server.host.source_interface', 'pybind.nos.v7_1_0.brocade_snmp', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ip, community', 'extra_keyval': ''}, {'keyval': 'ip, community', 'extra_keyval': ''}, {'keyval': 'ip, community', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 've'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, host=host)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, host=host)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def snmp_server_host_udp_port_delete(self, host=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type host: ip, community
    :param host: Keyword argument tuple.

    :type ip: unicode
    :param ip: **host** tuple argument:  ipv4/ipv6/dns address of the trap recipient associated with community strings.  Traps will be sent to this host

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type community: unicode
    :param community: **host** tuple argument:  Community string associated with traps.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.snmp_server.host', 'pybind.nos.v6_0_2c.brocade_snmp', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.snmp_server.host', 'pybind.nos.v7_0_1b.brocade_snmp', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.snmp_server.host', 'pybind.nos.v7_1_0.brocade_snmp', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.snmp_server.host', 'pybind.slxos.v16r_1_00b.brocade_snmp', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'host', 'keyval': 'ip, community', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'udp-port'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, host=host)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, host=host)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def snmp_server_host_use_vrf_delete(self, host=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type host: ip, community
    :param host: Keyword argument tuple.

    :type ip: unicode
    :param ip: **host** tuple argument:  ipv4/ipv6/dns address of the trap recipient associated with community strings.  Traps will be sent to this host

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type community: unicode
    :param community: **host** tuple argument:  Community string associated with traps.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.snmp_server.host', 'pybind.nos.v6_0_2c.brocade_snmp', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.snmp_server.host', 'pybind.nos.v7_0_1b.brocade_snmp', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.snmp_server.host', 'pybind.nos.v7_1_0.brocade_snmp', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.snmp_server.host', 'pybind.slxos.v16r_1_00b.brocade_snmp', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'host', 'keyval': 'ip, community', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'use-vrf'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, host=host)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, host=host)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def snmp_server_host_version_delete(self, host=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type host: ip, community
    :param host: Keyword argument tuple.

    :type ip: unicode
    :param ip: **host** tuple argument:  ipv4/ipv6/dns address of the trap recipient associated with community strings.  Traps will be sent to this host

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type community: unicode
    :param community: **host** tuple argument:  Community string associated with traps.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.snmp_server.host', 'pybind.nos.v6_0_2c.brocade_snmp', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.snmp_server.host', 'pybind.nos.v7_0_1b.brocade_snmp', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.snmp_server.host', 'pybind.nos.v7_1_0.brocade_snmp', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.snmp_server.host', 'pybind.slxos.v16r_1_00b.brocade_snmp', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'host', 'keyval': 'ip, community', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'version'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, host=host)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, host=host)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def snmp_server_location_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.snmp_server.agtconfig', 'pybind.nos.v6_0_2c.brocade_snmp', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.snmp_server.agtconfig', 'pybind.nos.v7_0_1b.brocade_snmp', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.snmp_server.agtconfig', 'pybind.nos.v7_1_0.brocade_snmp', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.snmp_server.agtconfig', 'pybind.slxos.v16r_1_00b.brocade_snmp', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'location'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def snmp_server_mib_community_map_delete(self, community_map=None, context=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type community_map: community, context
    :param community_map: Keyword argument tuple.

    :type community: unicode
    :param community: **community_map** tuple argument:  Community string to map with the context name

    :type context: unicode
    :param context: **community_map** tuple argument:  Context Name.

    **Instance Argument(s)**:

    :type context: unicode
    :param context: Context Name.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_0_1b.snmp_server.mib.community_map', 'pybind.nos.v7_0_1b.brocade_snmp', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.snmp_server.mib.community_map', 'pybind.nos.v7_1_0.brocade_snmp', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.snmp_server.mib.community_map', 'pybind.slxos.v16r_1_00b.brocade_snmp', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'community_map', 'keyval': 'community', 'extra_keyval': 'community, context'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, community_map=community_map, context=context)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, community_map=community_map, context=context)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def snmp_server_sys_descr_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.snmp_server.agtconfig', 'pybind.nos.v6_0_2c.brocade_snmp', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.snmp_server.agtconfig', 'pybind.nos.v7_0_1b.brocade_snmp', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.snmp_server.agtconfig', 'pybind.nos.v7_1_0.brocade_snmp', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.snmp_server.agtconfig', 'pybind.slxos.v16r_1_00b.brocade_snmp', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'sys-descr'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def snmp_server_user_delete(self, user=None, groupname=None, auth=None, auth_password=None, priv=None, priv_password=None, encrypted=None, ipv4_acl=None, ipv6_acl=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type user: username, groupname, auth, auth_password, priv, priv_password, encrypted, ipv4_acl, ipv6_acl
    :param user: Keyword argument tuple.

    :type username: unicode
    :param username: **user** tuple argument.

        * length restriction: ::

            ['1 .. 25']

    :type groupname: unicode
    :param groupname: **user** tuple argument.

    :type auth: unicode
    :param auth: **user** tuple argument:  Authorization protocol for username(Default=noauth)

        * enumeration restriction: ::

            ['sha', 'noauth', 'md5']

    :type auth_password: unicode
    :param auth_password: **user** tuple argument:  Authorization password associated withusername

    :type priv: unicode
    :param priv: **user** tuple argument:  Privacy protocol for username (Default=nopriv)

        * enumeration restriction: ::

            ['AES128', 'DES', 'nopriv']

    :type priv_password: unicode
    :param priv_password: **user** tuple argument:  Privacy password associated with username

    :type encrypted: YANGBool
    :param encrypted: **user** tuple argument:  This flag is used to enter the auth/privpasswords as encrypted.(Default=disable)

    :type ipv4_acl: unicode
    :param ipv4_acl: **user** tuple argument:  standard IPv4 Access list name (or) ID associated with SNMP v3 user strings.

        * length restriction: ::

            ['0 .. 63']

    :type ipv6_acl: unicode
    :param ipv6_acl: **user** tuple argument:  standard IPv6 Access list name (or) ID associated with SNMP V3 user strings.

        * length restriction: ::

            ['0 .. 63']

    **Instance Argument(s)**:

    :type groupname: unicode
    :param groupname: Keyword argument.

    :type auth: unicode
    :param auth: Authorization protocol for username(Default=noauth)

        * enumeration restriction: ::

            ['sha', 'noauth', 'md5']

    :type auth_password: unicode
    :param auth_password: Authorization password associated withusername

    :type priv: unicode
    :param priv: Privacy protocol for username (Default=nopriv)

        * enumeration restriction: ::

            ['AES128', 'DES', 'nopriv']

    :type priv_password: unicode
    :param priv_password: Privacy password associated with username

    :type encrypted: YANGBool
    :param encrypted: This flag is used to enter the auth/privpasswords as encrypted.(Default=disable)

    :type ipv4_acl: unicode
    :param ipv4_acl: standard IPv4 Access list name (or) ID associated with SNMP v3 user strings.

        * length restriction: ::

            ['0 .. 63']

    :type ipv6_acl: unicode
    :param ipv6_acl: standard IPv6 Access list name (or) ID associated with SNMP V3 user strings.

        * length restriction: ::

            ['0 .. 63']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.snmp_server.user', 'pybind.nos.v6_0_2c.brocade_snmp', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.snmp_server.user', 'pybind.nos.v7_0_1b.brocade_snmp', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.snmp_server.user', 'pybind.nos.v7_1_0.brocade_snmp', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.snmp_server.user', 'pybind.slxos.v16r_1_00b.brocade_snmp', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'user', 'keyval': 'username', 'extra_keyval': 'username, groupname, auth, auth_password, priv, priv_password, encrypted'}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v7_1_0.snmp_server.user": {"username": "username", "ipv4_acl": "ipv4_acl", "encrypted": "encrypted", "ipv6_acl": "ipv6_acl", "auth": "auth", "priv_password": "priv_password", "groupname": "groupname", "auth_password": "auth_password", "priv": "priv"}, "pybind.slxos.v16r_1_00b.snmp_server.user": {}, "pybind.nos.v7_0_1b.snmp_server.user": {"username": "username", "ipv4_acl": "ipv4_acl", "encrypted": "encrypted", "ipv6_acl": "ipv6_acl", "auth": "auth", "priv_password": "priv_password", "groupname": "groupname", "auth_password": "auth_password", "priv": "priv"}, "pybind.nos.v6_0_2c.snmp_server.user": {"username": "username", "ipv4_acl": "ipv4_acl", "encrypted": "encrypted", "ipv6_acl": "ipv6_acl", "auth": "auth", "priv_password": "priv_password", "groupname": "groupname", "auth_password": "auth_password", "priv": "priv"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, user=user, groupname=groupname, auth=auth, auth_password=auth_password, priv=priv, priv_password=priv_password, encrypted=encrypted, ipv4_acl=ipv4_acl, ipv6_acl=ipv6_acl)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, user=user, groupname=groupname, auth=auth, auth_password=auth_password, priv=priv, priv_password=priv_password, encrypted=encrypted, ipv4_acl=ipv4_acl, ipv6_acl=ipv6_acl)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def snmp_server_user_auth_delete(self, user=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type user: username
    :param user: Keyword argument tuple.

    :type username: unicode
    :param username: **user** tuple argument.

        * length restriction: ::

            ['1 .. 25']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.snmp_server.user', 'pybind.nos.v6_0_2c.brocade_snmp', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.snmp_server.user', 'pybind.nos.v7_0_1b.brocade_snmp', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.snmp_server.user', 'pybind.nos.v7_1_0.brocade_snmp', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.snmp_server.user', 'pybind.slxos.v16r_1_00b.brocade_snmp', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'user', 'keyval': 'username', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'auth'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, user=user)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, user=user)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def snmp_server_user_auth_password_delete(self, user=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type user: username
    :param user: Keyword argument tuple.

    :type username: unicode
    :param username: **user** tuple argument.

        * length restriction: ::

            ['1 .. 25']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.snmp_server.user', 'pybind.nos.v6_0_2c.brocade_snmp', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.snmp_server.user', 'pybind.nos.v7_0_1b.brocade_snmp', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.snmp_server.user', 'pybind.nos.v7_1_0.brocade_snmp', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.snmp_server.user', 'pybind.slxos.v16r_1_00b.brocade_snmp', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'user', 'keyval': 'username', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'auth-password'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, user=user)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, user=user)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def snmp_server_user_encrypted_delete(self, user=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type user: username
    :param user: Keyword argument tuple.

    :type username: unicode
    :param username: **user** tuple argument.

        * length restriction: ::

            ['1 .. 25']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.snmp_server.user', 'pybind.nos.v6_0_2c.brocade_snmp', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.snmp_server.user', 'pybind.nos.v7_0_1b.brocade_snmp', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.snmp_server.user', 'pybind.nos.v7_1_0.brocade_snmp', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.snmp_server.user', 'pybind.slxos.v16r_1_00b.brocade_snmp', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'user', 'keyval': 'username', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'encrypted'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, user=user)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, user=user)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def snmp_server_user_groupname_delete(self, user=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type user: username
    :param user: Keyword argument tuple.

    :type username: unicode
    :param username: **user** tuple argument.

        * length restriction: ::

            ['1 .. 25']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.snmp_server.user', 'pybind.nos.v6_0_2c.brocade_snmp', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.snmp_server.user', 'pybind.nos.v7_0_1b.brocade_snmp', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.snmp_server.user', 'pybind.nos.v7_1_0.brocade_snmp', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.snmp_server.user', 'pybind.slxos.v16r_1_00b.brocade_snmp', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'user', 'keyval': 'username', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'groupname'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, user=user)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, user=user)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def snmp_server_user_ipv4_acl_delete(self, user=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Instance Keyword Argument Tuple**:

    :type user: username
    :param user: Keyword argument tuple.

    :type username: unicode
    :param username: **user** tuple argument.

        * length restriction: ::

            ['1 .. 25']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.snmp_server.user', 'pybind.nos.v6_0_2c.brocade_snmp', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.snmp_server.user', 'pybind.nos.v7_0_1b.brocade_snmp', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.snmp_server.user', 'pybind.nos.v7_1_0.brocade_snmp', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'user', 'keyval': 'username', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ipv4-acl'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, user=user)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, user=user)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def snmp_server_user_ipv6_acl_delete(self, user=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Instance Keyword Argument Tuple**:

    :type user: username
    :param user: Keyword argument tuple.

    :type username: unicode
    :param username: **user** tuple argument.

        * length restriction: ::

            ['1 .. 25']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.snmp_server.user', 'pybind.nos.v6_0_2c.brocade_snmp', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.snmp_server.user', 'pybind.nos.v7_0_1b.brocade_snmp', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.snmp_server.user', 'pybind.nos.v7_1_0.brocade_snmp', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'user', 'keyval': 'username', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ipv6-acl'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, user=user)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, user=user)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def snmp_server_user_priv_delete(self, user=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type user: username
    :param user: Keyword argument tuple.

    :type username: unicode
    :param username: **user** tuple argument.

        * length restriction: ::

            ['1 .. 25']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.snmp_server.user', 'pybind.nos.v6_0_2c.brocade_snmp', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.snmp_server.user', 'pybind.nos.v7_0_1b.brocade_snmp', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.snmp_server.user', 'pybind.nos.v7_1_0.brocade_snmp', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.snmp_server.user', 'pybind.slxos.v16r_1_00b.brocade_snmp', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'user', 'keyval': 'username', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priv'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, user=user)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, user=user)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def snmp_server_user_priv_password_delete(self, user=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type user: username
    :param user: Keyword argument tuple.

    :type username: unicode
    :param username: **user** tuple argument.

        * length restriction: ::

            ['1 .. 25']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.snmp_server.user', 'pybind.nos.v6_0_2c.brocade_snmp', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.snmp_server.user', 'pybind.nos.v7_0_1b.brocade_snmp', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.snmp_server.user', 'pybind.nos.v7_1_0.brocade_snmp', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.snmp_server.user', 'pybind.slxos.v16r_1_00b.brocade_snmp', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'user', 'keyval': 'username', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priv-password'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, user=user)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, user=user)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def snmp_server_v3host_delete(self, v3host=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type v3host: hostip, username
    :param v3host: Keyword argument tuple.

    :type hostip: unicode
    :param hostip: **v3host** tuple argument:  ipv4/ipv6/dns address of the notification recipientassociated with username. Notificationswill be sent to this host

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type username: unicode
    :param username: **v3host** tuple argument:  Username associated with notification type.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.snmp_server.v3host', 'pybind.nos.v6_0_2c.brocade_snmp', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.snmp_server.v3host', 'pybind.nos.v7_0_1b.brocade_snmp', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.snmp_server.v3host', 'pybind.nos.v7_1_0.brocade_snmp', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.snmp_server.v3host', 'pybind.slxos.v16r_1_00b.brocade_snmp', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'v3host', 'keyval': 'hostip, username', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, v3host=v3host)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, v3host=v3host)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def snmp_server_v3host_engineid_delete(self, v3host=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type v3host: hostip, username
    :param v3host: Keyword argument tuple.

    :type hostip: unicode
    :param hostip: **v3host** tuple argument:  ipv4/ipv6/dns address of the notification recipientassociated with username. Notificationswill be sent to this host

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type username: unicode
    :param username: **v3host** tuple argument:  Username associated with notification type.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.snmp_server.v3host', 'pybind.nos.v6_0_2c.brocade_snmp', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.snmp_server.v3host', 'pybind.nos.v7_0_1b.brocade_snmp', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.snmp_server.v3host', 'pybind.nos.v7_1_0.brocade_snmp', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.snmp_server.v3host', 'pybind.slxos.v16r_1_00b.brocade_snmp', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'v3host', 'keyval': 'hostip, username', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'engineid'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, v3host=v3host)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, v3host=v3host)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def snmp_server_v3host_notifytype_delete(self, v3host=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type v3host: hostip, username
    :param v3host: Keyword argument tuple.

    :type hostip: unicode
    :param hostip: **v3host** tuple argument:  ipv4/ipv6/dns address of the notification recipientassociated with username. Notificationswill be sent to this host

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type username: unicode
    :param username: **v3host** tuple argument:  Username associated with notification type.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.snmp_server.v3host', 'pybind.nos.v6_0_2c.brocade_snmp', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.snmp_server.v3host', 'pybind.nos.v7_0_1b.brocade_snmp', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.snmp_server.v3host', 'pybind.nos.v7_1_0.brocade_snmp', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.snmp_server.v3host', 'pybind.slxos.v16r_1_00b.brocade_snmp', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'v3host', 'keyval': 'hostip, username', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'notifytype'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, v3host=v3host)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, v3host=v3host)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def snmp_server_v3host_severity_level_delete(self, v3host=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type v3host: hostip, username
    :param v3host: Keyword argument tuple.

    :type hostip: unicode
    :param hostip: **v3host** tuple argument:  ipv4/ipv6/dns address of the notification recipientassociated with username. Notificationswill be sent to this host

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type username: unicode
    :param username: **v3host** tuple argument:  Username associated with notification type.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.snmp_server.v3host', 'pybind.nos.v6_0_2c.brocade_snmp', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.snmp_server.v3host', 'pybind.nos.v7_0_1b.brocade_snmp', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.snmp_server.v3host', 'pybind.nos.v7_1_0.brocade_snmp', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.snmp_server.v3host', 'pybind.slxos.v16r_1_00b.brocade_snmp', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'v3host', 'keyval': 'hostip, username', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'severity-level'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, v3host=v3host)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, v3host=v3host)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def snmp_server_v3host_source_interface_delete(self, v3host=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type v3host: hostip, username
    :param v3host: Keyword argument tuple.

    :type hostip: unicode
    :param hostip: **v3host** tuple argument:  ipv4/ipv6/dns address of the notification recipientassociated with username. Notificationswill be sent to this host

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type username: unicode
    :param username: **v3host** tuple argument:  Username associated with notification type.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.snmp_server.v3host', u'v3host'), ('pybind.nos.v7_1_0.snmp_server.v3host', u'v3host'), ('pybind.nos.v7_0_1b.snmp_server.v3host', u'v3host')]
    bindings_list = [('pybind.nos.v6_0_2c.snmp_server.v3host.source_interface', 'pybind.nos.v6_0_2c.brocade_snmp', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.snmp_server.v3host.source_interface', 'pybind.nos.v7_0_1b.brocade_snmp', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.snmp_server.v3host.source_interface', 'pybind.nos.v7_1_0.brocade_snmp', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'hostip, username', 'extra_keyval': ''}, {'keyval': 'hostip, username', 'extra_keyval': ''}, {'keyval': 'hostip, username', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v6_0_2c.snmp_server.v3host.source_interface': [u've', u'loopback'], 'pybind.nos.v7_0_1b.snmp_server.v3host.source_interface': [u've', u'loopback'], 'pybind.nos.v7_1_0.snmp_server.v3host.source_interface': [u've', u'loopback']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, v3host=v3host)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, v3host=v3host)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def snmp_server_v3host_source_interface_loopback_delete(self, v3host=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type v3host: hostip, username
    :param v3host: Keyword argument tuple.

    :type hostip: unicode
    :param hostip: **v3host** tuple argument:  ipv4/ipv6/dns address of the notification recipientassociated with username. Notificationswill be sent to this host

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type username: unicode
    :param username: **v3host** tuple argument:  Username associated with notification type.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.snmp_server.v3host', u'v3host'), ('pybind.nos.v7_1_0.snmp_server.v3host', u'v3host'), ('pybind.nos.v7_0_1b.snmp_server.v3host', u'v3host')]
    bindings_list = [('pybind.nos.v6_0_2c.snmp_server.v3host.source_interface', 'pybind.nos.v6_0_2c.brocade_snmp', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.snmp_server.v3host.source_interface', 'pybind.nos.v7_0_1b.brocade_snmp', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.snmp_server.v3host.source_interface', 'pybind.nos.v7_1_0.brocade_snmp', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'hostip, username', 'extra_keyval': ''}, {'keyval': 'hostip, username', 'extra_keyval': ''}, {'keyval': 'hostip, username', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'loopback'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, v3host=v3host)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, v3host=v3host)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def snmp_server_v3host_source_interface_ve_delete(self, v3host=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type v3host: hostip, username
    :param v3host: Keyword argument tuple.

    :type hostip: unicode
    :param hostip: **v3host** tuple argument:  ipv4/ipv6/dns address of the notification recipientassociated with username. Notificationswill be sent to this host

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type username: unicode
    :param username: **v3host** tuple argument:  Username associated with notification type.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.snmp_server.v3host', u'v3host'), ('pybind.nos.v7_1_0.snmp_server.v3host', u'v3host'), ('pybind.nos.v7_0_1b.snmp_server.v3host', u'v3host')]
    bindings_list = [('pybind.nos.v6_0_2c.snmp_server.v3host.source_interface', 'pybind.nos.v6_0_2c.brocade_snmp', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.snmp_server.v3host.source_interface', 'pybind.nos.v7_0_1b.brocade_snmp', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.snmp_server.v3host.source_interface', 'pybind.nos.v7_1_0.brocade_snmp', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'hostip, username', 'extra_keyval': ''}, {'keyval': 'hostip, username', 'extra_keyval': ''}, {'keyval': 'hostip, username', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 've'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, v3host=v3host)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, v3host=v3host)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def snmp_server_v3host_udp_port_delete(self, v3host=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type v3host: hostip, username
    :param v3host: Keyword argument tuple.

    :type hostip: unicode
    :param hostip: **v3host** tuple argument:  ipv4/ipv6/dns address of the notification recipientassociated with username. Notificationswill be sent to this host

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type username: unicode
    :param username: **v3host** tuple argument:  Username associated with notification type.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.snmp_server.v3host', 'pybind.nos.v6_0_2c.brocade_snmp', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.snmp_server.v3host', 'pybind.nos.v7_0_1b.brocade_snmp', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.snmp_server.v3host', 'pybind.nos.v7_1_0.brocade_snmp', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.snmp_server.v3host', 'pybind.slxos.v16r_1_00b.brocade_snmp', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'v3host', 'keyval': 'hostip, username', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'udp-port'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, v3host=v3host)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, v3host=v3host)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def snmp_server_v3host_use_vrf_delete(self, v3host=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type v3host: hostip, username
    :param v3host: Keyword argument tuple.

    :type hostip: unicode
    :param hostip: **v3host** tuple argument:  ipv4/ipv6/dns address of the notification recipientassociated with username. Notificationswill be sent to this host

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type username: unicode
    :param username: **v3host** tuple argument:  Username associated with notification type.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.snmp_server.v3host', 'pybind.nos.v6_0_2c.brocade_snmp', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.snmp_server.v3host', 'pybind.nos.v7_0_1b.brocade_snmp', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.snmp_server.v3host', 'pybind.nos.v7_1_0.brocade_snmp', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.snmp_server.v3host', 'pybind.slxos.v16r_1_00b.brocade_snmp', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'v3host', 'keyval': 'hostip, username', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'use-vrf'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, v3host=v3host)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, v3host=v3host)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def snmp_server_view_delete(self, view=None, mibtree_access=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type view: viewname, mibtree
    :param view: Keyword argument tuple.

    :type viewname: unicode
    :param viewname: **view** tuple argument.

        * length restriction: ::

            ['1 .. 32']

    :type mibtree: unicode
    :param mibtree: **view** tuple argument.

        * length restriction: ::

            ['1 .. 256']

    **Instance Argument(s)**:

    :type mibtree_access: unicode
    :param mibtree_access: Keyword argument.

        * enumeration restriction: ::

            ['included', 'excluded']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.snmp_server.view', 'pybind.nos.v6_0_2c.brocade_snmp', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.snmp_server.view', 'pybind.nos.v7_0_1b.brocade_snmp', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.snmp_server.view', 'pybind.nos.v7_1_0.brocade_snmp', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.snmp_server.view', 'pybind.slxos.v16r_1_00b.brocade_snmp', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'view', 'keyval': 'viewname, mibtree', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, view=view, mibtree_access=mibtree_access)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, view=view, mibtree_access=mibtree_access)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def snmp_server_view_mibtree_access_delete(self, view=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type view: viewname, mibtree
    :param view: Keyword argument tuple.

    :type viewname: unicode
    :param viewname: **view** tuple argument.

        * length restriction: ::

            ['1 .. 32']

    :type mibtree: unicode
    :param mibtree: **view** tuple argument.

        * length restriction: ::

            ['1 .. 256']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.snmp_server.view', 'pybind.nos.v6_0_2c.brocade_snmp', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.snmp_server.view', 'pybind.nos.v7_0_1b.brocade_snmp', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.snmp_server.view', 'pybind.nos.v7_1_0.brocade_snmp', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.snmp_server.view', 'pybind.slxos.v16r_1_00b.brocade_snmp', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'view', 'keyval': 'viewname, mibtree', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mibtree-access'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, view=view)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, view=view)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def spf_log_state_delete(self, spf_log_state=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type spf_log_state: spf_log_version
    :param spf_log_state: Keyword argument tuple.

    :type spf_log_version: unicode
    :param spf_log_version: **spf_log_state** tuple argument.

        * enumeration restriction: ::

            ['isis-ipv6-unicast-safi',
            'isis-ipv4-unicast-safi']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.spf_log_state', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'spf_log_state', 'keyval': 'spf_log_version', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, spf_log_state=spf_log_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, spf_log_state=spf_log_state)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def spf_log_state_spf_log_levels_delete(self, spf_log_state=None, spf_log_levels=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type spf_log_state: spf_log_version
    :param spf_log_state: Keyword argument tuple.

    :type spf_log_version: unicode
    :param spf_log_version: **spf_log_state** tuple argument.

        * enumeration restriction: ::

            ['isis-ipv6-unicast-safi',
            'isis-ipv4-unicast-safi']

    **Instance Keyword Argument Tuple**:

    :type spf_log_levels: level
    :param spf_log_levels: Keyword argument tuple.

    :type level: unicode
    :param level: **spf_log_levels** tuple argument.

        * enumeration restriction: ::

            ['level-2', 'level-1-2', 'level-1']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.spf_log_state', 'spf_log_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.spf_log_state.spf_log_levels', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'spf_log_version', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'spf_log_levels', 'keyval': 'level', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, spf_log_state=spf_log_state, spf_log_levels=spf_log_levels)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, spf_log_state=spf_log_state, spf_log_levels=spf_log_levels)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def spf_log_state_spf_log_levels_log_counts_delete(self, spf_log_state=None, spf_log_levels=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type spf_log_state: spf_log_version
    :param spf_log_state: Keyword argument tuple.

    :type spf_log_version: unicode
    :param spf_log_version: **spf_log_state** tuple argument.

        * enumeration restriction: ::

            ['isis-ipv6-unicast-safi',
            'isis-ipv4-unicast-safi']

    **Instance Keyword Argument Tuple**:

    :type spf_log_levels: level
    :param spf_log_levels: Keyword argument tuple.

    :type level: unicode
    :param level: **spf_log_levels** tuple argument.

        * enumeration restriction: ::

            ['level-2', 'level-1-2', 'level-1']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.spf_log_state', 'spf_log_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.spf_log_state.spf_log_levels', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'spf_log_version', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'spf_log_levels', 'keyval': 'level', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'log-counts'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, spf_log_state=spf_log_state, spf_log_levels=spf_log_levels)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, spf_log_state=spf_log_state, spf_log_levels=spf_log_levels)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def spf_log_state_spf_log_levels_node_count_delete(self, spf_log_state=None, spf_log_levels=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type spf_log_state: spf_log_version
    :param spf_log_state: Keyword argument tuple.

    :type spf_log_version: unicode
    :param spf_log_version: **spf_log_state** tuple argument.

        * enumeration restriction: ::

            ['isis-ipv6-unicast-safi',
            'isis-ipv4-unicast-safi']

    **Instance Keyword Argument Tuple**:

    :type spf_log_levels: level
    :param spf_log_levels: Keyword argument tuple.

    :type level: unicode
    :param level: **spf_log_levels** tuple argument.

        * enumeration restriction: ::

            ['level-2', 'level-1-2', 'level-1']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.spf_log_state', 'spf_log_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.spf_log_state.spf_log_levels', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'spf_log_version', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'spf_log_levels', 'keyval': 'level', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'node-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, spf_log_state=spf_log_state, spf_log_levels=spf_log_levels)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, spf_log_state=spf_log_state, spf_log_levels=spf_log_levels)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def spf_log_state_spf_log_levels_spf_log_events_delete(self, spf_log_state=None, spf_log_levels=None, spf_log_events=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type spf_log_state: spf_log_version
    :param spf_log_state: Keyword argument tuple.

    :type spf_log_version: unicode
    :param spf_log_version: **spf_log_state** tuple argument.

        * enumeration restriction: ::

            ['isis-ipv6-unicast-safi',
            'isis-ipv4-unicast-safi']

    :type spf_log_levels: level
    :param spf_log_levels: Keyword argument tuple.

    :type level: unicode
    :param level: **spf_log_levels** tuple argument.

        * enumeration restriction: ::

            ['level-2', 'level-1-2', 'level-1']

    **Instance Keyword Argument Tuple**:

    :type spf_log_events: spf_log_index
    :param spf_log_events: Keyword argument tuple.

    :type spf_log_index: int
    :param spf_log_index: **spf_log_events** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.spf_log_state', 'spf_log_state'), ('pybind.slxos.v16r_1_00b.spf_log_state.spf_log_levels', u'spf_log_levels')]
    bindings_list = [('pybind.slxos.v16r_1_00b.spf_log_state.spf_log_levels.spf_log_events', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'spf_log_version', 'extra_keyval': ''}, {'keyval': 'level', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'spf_log_events', 'keyval': 'spf_log_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, spf_log_state=spf_log_state, spf_log_levels=spf_log_levels, spf_log_events=spf_log_events)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, spf_log_state=spf_log_state, spf_log_levels=spf_log_levels, spf_log_events=spf_log_events)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def spf_log_state_spf_log_levels_spf_log_events_brief_reason_delete(self, spf_log_state=None, spf_log_levels=None, spf_log_events=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type spf_log_state: spf_log_version
    :param spf_log_state: Keyword argument tuple.

    :type spf_log_version: unicode
    :param spf_log_version: **spf_log_state** tuple argument.

        * enumeration restriction: ::

            ['isis-ipv6-unicast-safi',
            'isis-ipv4-unicast-safi']

    :type spf_log_levels: level
    :param spf_log_levels: Keyword argument tuple.

    :type level: unicode
    :param level: **spf_log_levels** tuple argument.

        * enumeration restriction: ::

            ['level-2', 'level-1-2', 'level-1']

    **Instance Keyword Argument Tuple**:

    :type spf_log_events: spf_log_index
    :param spf_log_events: Keyword argument tuple.

    :type spf_log_index: int
    :param spf_log_index: **spf_log_events** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.spf_log_state', 'spf_log_state'), ('pybind.slxos.v16r_1_00b.spf_log_state.spf_log_levels', u'spf_log_levels')]
    bindings_list = [('pybind.slxos.v16r_1_00b.spf_log_state.spf_log_levels.spf_log_events', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'spf_log_version', 'extra_keyval': ''}, {'keyval': 'level', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'spf_log_events', 'keyval': 'spf_log_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'brief-reason'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, spf_log_state=spf_log_state, spf_log_levels=spf_log_levels, spf_log_events=spf_log_events)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, spf_log_state=spf_log_state, spf_log_levels=spf_log_levels, spf_log_events=spf_log_events)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def spf_log_state_spf_log_levels_spf_log_events_duration_ms_delete(self, spf_log_state=None, spf_log_levels=None, spf_log_events=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type spf_log_state: spf_log_version
    :param spf_log_state: Keyword argument tuple.

    :type spf_log_version: unicode
    :param spf_log_version: **spf_log_state** tuple argument.

        * enumeration restriction: ::

            ['isis-ipv6-unicast-safi',
            'isis-ipv4-unicast-safi']

    :type spf_log_levels: level
    :param spf_log_levels: Keyword argument tuple.

    :type level: unicode
    :param level: **spf_log_levels** tuple argument.

        * enumeration restriction: ::

            ['level-2', 'level-1-2', 'level-1']

    **Instance Keyword Argument Tuple**:

    :type spf_log_events: spf_log_index
    :param spf_log_events: Keyword argument tuple.

    :type spf_log_index: int
    :param spf_log_index: **spf_log_events** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.spf_log_state', 'spf_log_state'), ('pybind.slxos.v16r_1_00b.spf_log_state.spf_log_levels', u'spf_log_levels')]
    bindings_list = [('pybind.slxos.v16r_1_00b.spf_log_state.spf_log_levels.spf_log_events', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'spf_log_version', 'extra_keyval': ''}, {'keyval': 'level', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'spf_log_events', 'keyval': 'spf_log_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'duration-ms'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, spf_log_state=spf_log_state, spf_log_levels=spf_log_levels, spf_log_events=spf_log_events)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, spf_log_state=spf_log_state, spf_log_levels=spf_log_levels, spf_log_events=spf_log_events)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def spf_log_state_spf_log_levels_spf_log_events_event_count_delete(self, spf_log_state=None, spf_log_levels=None, spf_log_events=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type spf_log_state: spf_log_version
    :param spf_log_state: Keyword argument tuple.

    :type spf_log_version: unicode
    :param spf_log_version: **spf_log_state** tuple argument.

        * enumeration restriction: ::

            ['isis-ipv6-unicast-safi',
            'isis-ipv4-unicast-safi']

    :type spf_log_levels: level
    :param spf_log_levels: Keyword argument tuple.

    :type level: unicode
    :param level: **spf_log_levels** tuple argument.

        * enumeration restriction: ::

            ['level-2', 'level-1-2', 'level-1']

    **Instance Keyword Argument Tuple**:

    :type spf_log_events: spf_log_index
    :param spf_log_events: Keyword argument tuple.

    :type spf_log_index: int
    :param spf_log_index: **spf_log_events** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.spf_log_state', 'spf_log_state'), ('pybind.slxos.v16r_1_00b.spf_log_state.spf_log_levels', u'spf_log_levels')]
    bindings_list = [('pybind.slxos.v16r_1_00b.spf_log_state.spf_log_levels.spf_log_events', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'spf_log_version', 'extra_keyval': ''}, {'keyval': 'level', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'spf_log_events', 'keyval': 'spf_log_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'event-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, spf_log_state=spf_log_state, spf_log_levels=spf_log_levels, spf_log_events=spf_log_events)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, spf_log_state=spf_log_state, spf_log_levels=spf_log_levels, spf_log_events=spf_log_events)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def spf_log_state_spf_log_levels_spf_log_events_first_trigger_change_delete(self, spf_log_state=None, spf_log_levels=None, spf_log_events=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type spf_log_state: spf_log_version
    :param spf_log_state: Keyword argument tuple.

    :type spf_log_version: unicode
    :param spf_log_version: **spf_log_state** tuple argument.

        * enumeration restriction: ::

            ['isis-ipv6-unicast-safi',
            'isis-ipv4-unicast-safi']

    :type spf_log_levels: level
    :param spf_log_levels: Keyword argument tuple.

    :type level: unicode
    :param level: **spf_log_levels** tuple argument.

        * enumeration restriction: ::

            ['level-2', 'level-1-2', 'level-1']

    **Instance Keyword Argument Tuple**:

    :type spf_log_events: spf_log_index
    :param spf_log_events: Keyword argument tuple.

    :type spf_log_index: int
    :param spf_log_index: **spf_log_events** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.spf_log_state', 'spf_log_state'), ('pybind.slxos.v16r_1_00b.spf_log_state.spf_log_levels', u'spf_log_levels')]
    bindings_list = [('pybind.slxos.v16r_1_00b.spf_log_state.spf_log_levels.spf_log_events', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'spf_log_version', 'extra_keyval': ''}, {'keyval': 'level', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'spf_log_events', 'keyval': 'spf_log_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'first-trigger-change'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, spf_log_state=spf_log_state, spf_log_levels=spf_log_levels, spf_log_events=spf_log_events)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, spf_log_state=spf_log_state, spf_log_levels=spf_log_levels, spf_log_events=spf_log_events)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def spf_log_state_spf_log_levels_spf_log_events_first_trigger_detail_reason_delete(self, spf_log_state=None, spf_log_levels=None, spf_log_events=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type spf_log_state: spf_log_version
    :param spf_log_state: Keyword argument tuple.

    :type spf_log_version: unicode
    :param spf_log_version: **spf_log_state** tuple argument.

        * enumeration restriction: ::

            ['isis-ipv6-unicast-safi',
            'isis-ipv4-unicast-safi']

    :type spf_log_levels: level
    :param spf_log_levels: Keyword argument tuple.

    :type level: unicode
    :param level: **spf_log_levels** tuple argument.

        * enumeration restriction: ::

            ['level-2', 'level-1-2', 'level-1']

    **Instance Keyword Argument Tuple**:

    :type spf_log_events: spf_log_index
    :param spf_log_events: Keyword argument tuple.

    :type spf_log_index: int
    :param spf_log_index: **spf_log_events** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.spf_log_state', 'spf_log_state'), ('pybind.slxos.v16r_1_00b.spf_log_state.spf_log_levels', u'spf_log_levels')]
    bindings_list = [('pybind.slxos.v16r_1_00b.spf_log_state.spf_log_levels.spf_log_events', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'spf_log_version', 'extra_keyval': ''}, {'keyval': 'level', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'spf_log_events', 'keyval': 'spf_log_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'first-trigger-detail-reason'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, spf_log_state=spf_log_state, spf_log_levels=spf_log_levels, spf_log_events=spf_log_events)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, spf_log_state=spf_log_state, spf_log_levels=spf_log_levels, spf_log_events=spf_log_events)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def spf_log_state_spf_log_levels_spf_log_events_first_trigger_time_stamp_ms_delete(self, spf_log_state=None, spf_log_levels=None, spf_log_events=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type spf_log_state: spf_log_version
    :param spf_log_state: Keyword argument tuple.

    :type spf_log_version: unicode
    :param spf_log_version: **spf_log_state** tuple argument.

        * enumeration restriction: ::

            ['isis-ipv6-unicast-safi',
            'isis-ipv4-unicast-safi']

    :type spf_log_levels: level
    :param spf_log_levels: Keyword argument tuple.

    :type level: unicode
    :param level: **spf_log_levels** tuple argument.

        * enumeration restriction: ::

            ['level-2', 'level-1-2', 'level-1']

    **Instance Keyword Argument Tuple**:

    :type spf_log_events: spf_log_index
    :param spf_log_events: Keyword argument tuple.

    :type spf_log_index: int
    :param spf_log_index: **spf_log_events** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.spf_log_state', 'spf_log_state'), ('pybind.slxos.v16r_1_00b.spf_log_state.spf_log_levels', u'spf_log_levels')]
    bindings_list = [('pybind.slxos.v16r_1_00b.spf_log_state.spf_log_levels.spf_log_events', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'spf_log_version', 'extra_keyval': ''}, {'keyval': 'level', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'spf_log_events', 'keyval': 'spf_log_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'first-trigger-time-stamp-ms'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, spf_log_state=spf_log_state, spf_log_levels=spf_log_levels, spf_log_events=spf_log_events)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, spf_log_state=spf_log_state, spf_log_levels=spf_log_levels, spf_log_events=spf_log_events)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def spf_log_state_spf_log_levels_spf_log_events_ipv4_routes_delete(self, spf_log_state=None, spf_log_levels=None, spf_log_events=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type spf_log_state: spf_log_version
    :param spf_log_state: Keyword argument tuple.

    :type spf_log_version: unicode
    :param spf_log_version: **spf_log_state** tuple argument.

        * enumeration restriction: ::

            ['isis-ipv6-unicast-safi',
            'isis-ipv4-unicast-safi']

    :type spf_log_levels: level
    :param spf_log_levels: Keyword argument tuple.

    :type level: unicode
    :param level: **spf_log_levels** tuple argument.

        * enumeration restriction: ::

            ['level-2', 'level-1-2', 'level-1']

    **Instance Keyword Argument Tuple**:

    :type spf_log_events: spf_log_index
    :param spf_log_events: Keyword argument tuple.

    :type spf_log_index: int
    :param spf_log_index: **spf_log_events** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.spf_log_state', 'spf_log_state'), ('pybind.slxos.v16r_1_00b.spf_log_state.spf_log_levels', u'spf_log_levels')]
    bindings_list = [('pybind.slxos.v16r_1_00b.spf_log_state.spf_log_levels.spf_log_events', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'spf_log_version', 'extra_keyval': ''}, {'keyval': 'level', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'spf_log_events', 'keyval': 'spf_log_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ipv4-routes'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, spf_log_state=spf_log_state, spf_log_levels=spf_log_levels, spf_log_events=spf_log_events)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, spf_log_state=spf_log_state, spf_log_levels=spf_log_levels, spf_log_events=spf_log_events)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def spf_log_state_spf_log_levels_spf_log_events_ipv6_routes_delete(self, spf_log_state=None, spf_log_levels=None, spf_log_events=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type spf_log_state: spf_log_version
    :param spf_log_state: Keyword argument tuple.

    :type spf_log_version: unicode
    :param spf_log_version: **spf_log_state** tuple argument.

        * enumeration restriction: ::

            ['isis-ipv6-unicast-safi',
            'isis-ipv4-unicast-safi']

    :type spf_log_levels: level
    :param spf_log_levels: Keyword argument tuple.

    :type level: unicode
    :param level: **spf_log_levels** tuple argument.

        * enumeration restriction: ::

            ['level-2', 'level-1-2', 'level-1']

    **Instance Keyword Argument Tuple**:

    :type spf_log_events: spf_log_index
    :param spf_log_events: Keyword argument tuple.

    :type spf_log_index: int
    :param spf_log_index: **spf_log_events** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.spf_log_state', 'spf_log_state'), ('pybind.slxos.v16r_1_00b.spf_log_state.spf_log_levels', u'spf_log_levels')]
    bindings_list = [('pybind.slxos.v16r_1_00b.spf_log_state.spf_log_levels.spf_log_events', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'spf_log_version', 'extra_keyval': ''}, {'keyval': 'level', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'spf_log_events', 'keyval': 'spf_log_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ipv6-routes'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, spf_log_state=spf_log_state, spf_log_levels=spf_log_levels, spf_log_events=spf_log_events)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, spf_log_state=spf_log_state, spf_log_levels=spf_log_levels, spf_log_events=spf_log_events)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def spf_log_state_spf_log_levels_spf_log_events_isis_lsp_name_delete(self, spf_log_state=None, spf_log_levels=None, spf_log_events=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type spf_log_state: spf_log_version
    :param spf_log_state: Keyword argument tuple.

    :type spf_log_version: unicode
    :param spf_log_version: **spf_log_state** tuple argument.

        * enumeration restriction: ::

            ['isis-ipv6-unicast-safi',
            'isis-ipv4-unicast-safi']

    :type spf_log_levels: level
    :param spf_log_levels: Keyword argument tuple.

    :type level: unicode
    :param level: **spf_log_levels** tuple argument.

        * enumeration restriction: ::

            ['level-2', 'level-1-2', 'level-1']

    **Instance Keyword Argument Tuple**:

    :type spf_log_events: spf_log_index
    :param spf_log_events: Keyword argument tuple.

    :type spf_log_index: int
    :param spf_log_index: **spf_log_events** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.spf_log_state', 'spf_log_state'), ('pybind.slxos.v16r_1_00b.spf_log_state.spf_log_levels', u'spf_log_levels')]
    bindings_list = [('pybind.slxos.v16r_1_00b.spf_log_state.spf_log_levels.spf_log_events', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'spf_log_version', 'extra_keyval': ''}, {'keyval': 'level', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'spf_log_events', 'keyval': 'spf_log_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'isis-lsp-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, spf_log_state=spf_log_state, spf_log_levels=spf_log_levels, spf_log_events=spf_log_events)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, spf_log_state=spf_log_state, spf_log_levels=spf_log_levels, spf_log_events=spf_log_events)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def spf_log_state_spf_log_levels_spf_log_events_isis_spf_log_reason_delete(self, spf_log_state=None, spf_log_levels=None, spf_log_events=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type spf_log_state: spf_log_version
    :param spf_log_state: Keyword argument tuple.

    :type spf_log_version: unicode
    :param spf_log_version: **spf_log_state** tuple argument.

        * enumeration restriction: ::

            ['isis-ipv6-unicast-safi',
            'isis-ipv4-unicast-safi']

    :type spf_log_levels: level
    :param spf_log_levels: Keyword argument tuple.

    :type level: unicode
    :param level: **spf_log_levels** tuple argument.

        * enumeration restriction: ::

            ['level-2', 'level-1-2', 'level-1']

    **Instance Keyword Argument Tuple**:

    :type spf_log_events: spf_log_index
    :param spf_log_events: Keyword argument tuple.

    :type spf_log_index: int
    :param spf_log_index: **spf_log_events** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.spf_log_state', 'spf_log_state'), ('pybind.slxos.v16r_1_00b.spf_log_state.spf_log_levels', u'spf_log_levels')]
    bindings_list = [('pybind.slxos.v16r_1_00b.spf_log_state.spf_log_levels.spf_log_events', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'spf_log_version', 'extra_keyval': ''}, {'keyval': 'level', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'spf_log_events', 'keyval': 'spf_log_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'isis-spf-log-reason'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, spf_log_state=spf_log_state, spf_log_levels=spf_log_levels, spf_log_events=spf_log_events)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, spf_log_state=spf_log_state, spf_log_levels=spf_log_levels, spf_log_events=spf_log_events)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def spf_log_state_spf_log_levels_spf_log_events_last_trigger_change_delete(self, spf_log_state=None, spf_log_levels=None, spf_log_events=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type spf_log_state: spf_log_version
    :param spf_log_state: Keyword argument tuple.

    :type spf_log_version: unicode
    :param spf_log_version: **spf_log_state** tuple argument.

        * enumeration restriction: ::

            ['isis-ipv6-unicast-safi',
            'isis-ipv4-unicast-safi']

    :type spf_log_levels: level
    :param spf_log_levels: Keyword argument tuple.

    :type level: unicode
    :param level: **spf_log_levels** tuple argument.

        * enumeration restriction: ::

            ['level-2', 'level-1-2', 'level-1']

    **Instance Keyword Argument Tuple**:

    :type spf_log_events: spf_log_index
    :param spf_log_events: Keyword argument tuple.

    :type spf_log_index: int
    :param spf_log_index: **spf_log_events** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.spf_log_state', 'spf_log_state'), ('pybind.slxos.v16r_1_00b.spf_log_state.spf_log_levels', u'spf_log_levels')]
    bindings_list = [('pybind.slxos.v16r_1_00b.spf_log_state.spf_log_levels.spf_log_events', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'spf_log_version', 'extra_keyval': ''}, {'keyval': 'level', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'spf_log_events', 'keyval': 'spf_log_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'last-trigger-change'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, spf_log_state=spf_log_state, spf_log_levels=spf_log_levels, spf_log_events=spf_log_events)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, spf_log_state=spf_log_state, spf_log_levels=spf_log_levels, spf_log_events=spf_log_events)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def spf_log_state_spf_log_levels_spf_log_events_last_trigger_detail_reason_delete(self, spf_log_state=None, spf_log_levels=None, spf_log_events=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type spf_log_state: spf_log_version
    :param spf_log_state: Keyword argument tuple.

    :type spf_log_version: unicode
    :param spf_log_version: **spf_log_state** tuple argument.

        * enumeration restriction: ::

            ['isis-ipv6-unicast-safi',
            'isis-ipv4-unicast-safi']

    :type spf_log_levels: level
    :param spf_log_levels: Keyword argument tuple.

    :type level: unicode
    :param level: **spf_log_levels** tuple argument.

        * enumeration restriction: ::

            ['level-2', 'level-1-2', 'level-1']

    **Instance Keyword Argument Tuple**:

    :type spf_log_events: spf_log_index
    :param spf_log_events: Keyword argument tuple.

    :type spf_log_index: int
    :param spf_log_index: **spf_log_events** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.spf_log_state', 'spf_log_state'), ('pybind.slxos.v16r_1_00b.spf_log_state.spf_log_levels', u'spf_log_levels')]
    bindings_list = [('pybind.slxos.v16r_1_00b.spf_log_state.spf_log_levels.spf_log_events', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'spf_log_version', 'extra_keyval': ''}, {'keyval': 'level', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'spf_log_events', 'keyval': 'spf_log_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'last-trigger-detail-reason'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, spf_log_state=spf_log_state, spf_log_levels=spf_log_levels, spf_log_events=spf_log_events)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, spf_log_state=spf_log_state, spf_log_levels=spf_log_levels, spf_log_events=spf_log_events)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def spf_log_state_spf_log_levels_spf_log_events_last_trigger_time_stamp_ms_delete(self, spf_log_state=None, spf_log_levels=None, spf_log_events=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type spf_log_state: spf_log_version
    :param spf_log_state: Keyword argument tuple.

    :type spf_log_version: unicode
    :param spf_log_version: **spf_log_state** tuple argument.

        * enumeration restriction: ::

            ['isis-ipv6-unicast-safi',
            'isis-ipv4-unicast-safi']

    :type spf_log_levels: level
    :param spf_log_levels: Keyword argument tuple.

    :type level: unicode
    :param level: **spf_log_levels** tuple argument.

        * enumeration restriction: ::

            ['level-2', 'level-1-2', 'level-1']

    **Instance Keyword Argument Tuple**:

    :type spf_log_events: spf_log_index
    :param spf_log_events: Keyword argument tuple.

    :type spf_log_index: int
    :param spf_log_index: **spf_log_events** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.spf_log_state', 'spf_log_state'), ('pybind.slxos.v16r_1_00b.spf_log_state.spf_log_levels', u'spf_log_levels')]
    bindings_list = [('pybind.slxos.v16r_1_00b.spf_log_state.spf_log_levels.spf_log_events', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'spf_log_version', 'extra_keyval': ''}, {'keyval': 'level', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'spf_log_events', 'keyval': 'spf_log_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'last-trigger-time-stamp-ms'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, spf_log_state=spf_log_state, spf_log_levels=spf_log_levels, spf_log_events=spf_log_events)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, spf_log_state=spf_log_state, spf_log_levels=spf_log_levels, spf_log_events=spf_log_events)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def spf_log_state_spf_log_levels_spf_log_events_node_count_delete(self, spf_log_state=None, spf_log_levels=None, spf_log_events=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type spf_log_state: spf_log_version
    :param spf_log_state: Keyword argument tuple.

    :type spf_log_version: unicode
    :param spf_log_version: **spf_log_state** tuple argument.

        * enumeration restriction: ::

            ['isis-ipv6-unicast-safi',
            'isis-ipv4-unicast-safi']

    :type spf_log_levels: level
    :param spf_log_levels: Keyword argument tuple.

    :type level: unicode
    :param level: **spf_log_levels** tuple argument.

        * enumeration restriction: ::

            ['level-2', 'level-1-2', 'level-1']

    **Instance Keyword Argument Tuple**:

    :type spf_log_events: spf_log_index
    :param spf_log_events: Keyword argument tuple.

    :type spf_log_index: int
    :param spf_log_index: **spf_log_events** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.spf_log_state', 'spf_log_state'), ('pybind.slxos.v16r_1_00b.spf_log_state.spf_log_levels', u'spf_log_levels')]
    bindings_list = [('pybind.slxos.v16r_1_00b.spf_log_state.spf_log_levels.spf_log_events', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'spf_log_version', 'extra_keyval': ''}, {'keyval': 'level', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'spf_log_events', 'keyval': 'spf_log_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'node-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, spf_log_state=spf_log_state, spf_log_levels=spf_log_levels, spf_log_events=spf_log_events)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, spf_log_state=spf_log_state, spf_log_levels=spf_log_levels, spf_log_events=spf_log_events)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def spf_log_state_spf_log_levels_spf_log_events_time_stamp_ms_delete(self, spf_log_state=None, spf_log_levels=None, spf_log_events=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type spf_log_state: spf_log_version
    :param spf_log_state: Keyword argument tuple.

    :type spf_log_version: unicode
    :param spf_log_version: **spf_log_state** tuple argument.

        * enumeration restriction: ::

            ['isis-ipv6-unicast-safi',
            'isis-ipv4-unicast-safi']

    :type spf_log_levels: level
    :param spf_log_levels: Keyword argument tuple.

    :type level: unicode
    :param level: **spf_log_levels** tuple argument.

        * enumeration restriction: ::

            ['level-2', 'level-1-2', 'level-1']

    **Instance Keyword Argument Tuple**:

    :type spf_log_events: spf_log_index
    :param spf_log_events: Keyword argument tuple.

    :type spf_log_index: int
    :param spf_log_index: **spf_log_events** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.spf_log_state', 'spf_log_state'), ('pybind.slxos.v16r_1_00b.spf_log_state.spf_log_levels', u'spf_log_levels')]
    bindings_list = [('pybind.slxos.v16r_1_00b.spf_log_state.spf_log_levels.spf_log_events', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'spf_log_version', 'extra_keyval': ''}, {'keyval': 'level', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'spf_log_events', 'keyval': 'spf_log_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'time-stamp-ms'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, spf_log_state=spf_log_state, spf_log_levels=spf_log_levels, spf_log_events=spf_log_events)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, spf_log_state=spf_log_state, spf_log_levels=spf_log_levels, spf_log_events=spf_log_events)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def spf_log_state_spf_log_levels_spf_trigger_count_delete(self, spf_log_state=None, spf_log_levels=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type spf_log_state: spf_log_version
    :param spf_log_state: Keyword argument tuple.

    :type spf_log_version: unicode
    :param spf_log_version: **spf_log_state** tuple argument.

        * enumeration restriction: ::

            ['isis-ipv6-unicast-safi',
            'isis-ipv4-unicast-safi']

    **Instance Keyword Argument Tuple**:

    :type spf_log_levels: level
    :param spf_log_levels: Keyword argument tuple.

    :type level: unicode
    :param level: **spf_log_levels** tuple argument.

        * enumeration restriction: ::

            ['level-2', 'level-1-2', 'level-1']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.spf_log_state', 'spf_log_state')]
    bindings_list = [('pybind.slxos.v16r_1_00b.spf_log_state.spf_log_levels', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'spf_log_version', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'spf_log_levels', 'keyval': 'level', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'spf-trigger-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, spf_log_state=spf_log_state, spf_log_levels=spf_log_levels)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, spf_log_state=spf_log_state, spf_log_levels=spf_log_levels)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ssh_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.ssh_sa.ssh', 'pybind.nos.v6_0_2c.brocade_sec_services', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ssh_sa.ssh', 'pybind.nos.v7_0_1b.brocade_sec_services', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ssh_sa.ssh', 'pybind.nos.v7_1_0.brocade_sec_services', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ssh_sa.ssh', 'pybind.slxos.v16r_1_00b.brocade_sec_services', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ssh_client_cipher_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.ssh_sa.ssh.client', 'pybind.nos.v6_0_2c.brocade_sec_services', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ssh_sa.ssh.client', 'pybind.nos.v7_0_1b.brocade_sec_services', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ssh_sa.ssh.client', 'pybind.nos.v7_1_0.brocade_sec_services', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ssh_sa.ssh.client', 'pybind.slxos.v16r_1_00b.brocade_sec_services', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cipher'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ssh_client_key_exchange_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.ssh_sa.ssh.client', 'pybind.nos.v6_0_2c.brocade_sec_services', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ssh_sa.ssh.client', 'pybind.nos.v7_0_1b.brocade_sec_services', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ssh_sa.ssh.client', 'pybind.nos.v7_1_0.brocade_sec_services', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ssh_sa.ssh.client', 'pybind.slxos.v16r_1_00b.brocade_sec_services', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'key-exchange'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ssh_client_mac_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.ssh_sa.ssh.client', 'pybind.nos.v6_0_2c.brocade_sec_services', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ssh_sa.ssh.client', 'pybind.nos.v7_0_1b.brocade_sec_services', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ssh_sa.ssh.client', 'pybind.nos.v7_1_0.brocade_sec_services', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ssh_sa.ssh.client', 'pybind.slxos.v16r_1_00b.brocade_sec_services', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mac'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ssh_client_source_interface_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.ssh_sa.ssh.client.source_interface', 'pybind.slxos.v16r_1_00b.brocade_sec_services', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ssh_client_source_interface_interface_name_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.ssh_sa.ssh.client.source_interface', 'pybind.slxos.v16r_1_00b.brocade_sec_services', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'interface-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ssh_client_source_interface_interface_type_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.ssh_sa.ssh.client.source_interface', 'pybind.slxos.v16r_1_00b.brocade_sec_services', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'interface-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ssh_sa_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.ssh_sa', 'pybind.nos.v6_0_2c.brocade_sec_services', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ssh_sa', 'pybind.nos.v7_0_1b.brocade_sec_services', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ssh_sa', 'pybind.nos.v7_1_0.brocade_sec_services', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ssh_sa', 'pybind.slxos.v16r_1_00b.brocade_sec_services', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ssh_server_cipher_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.ssh_sa.ssh.server', 'pybind.nos.v6_0_2c.brocade_sec_services', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ssh_sa.ssh.server', 'pybind.nos.v7_0_1b.brocade_sec_services', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ssh_sa.ssh.server', 'pybind.nos.v7_1_0.brocade_sec_services', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ssh_sa.ssh.server', 'pybind.slxos.v16r_1_00b.brocade_sec_services', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cipher'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ssh_server_key_dsa_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.ssh_sa.ssh.server.key', 'pybind.nos.v6_0_2c.brocade_sec_services', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ssh_sa.ssh.server.key', 'pybind.nos.v7_0_1b.brocade_sec_services', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ssh_sa.ssh.server.key', 'pybind.nos.v7_1_0.brocade_sec_services', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ssh_sa.ssh.server.key', 'pybind.slxos.v16r_1_00b.brocade_sec_services', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dsa'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ssh_server_key_ecdsa_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.ssh_sa.ssh.server.key', 'pybind.nos.v6_0_2c.brocade_sec_services', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ssh_sa.ssh.server.key', 'pybind.nos.v7_0_1b.brocade_sec_services', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ssh_sa.ssh.server.key', 'pybind.nos.v7_1_0.brocade_sec_services', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ssh_sa.ssh.server.key', 'pybind.slxos.v16r_1_00b.brocade_sec_services', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ecdsa'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ssh_server_key_exchange_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.ssh_sa.ssh.server', 'pybind.nos.v6_0_2c.brocade_sec_services', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ssh_sa.ssh.server', 'pybind.nos.v7_0_1b.brocade_sec_services', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ssh_sa.ssh.server', 'pybind.nos.v7_1_0.brocade_sec_services', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ssh_sa.ssh.server', 'pybind.slxos.v16r_1_00b.brocade_sec_services', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'key-exchange'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ssh_server_key_rsa_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.ssh_sa.ssh.server.key', 'pybind.nos.v6_0_2c.brocade_sec_services', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ssh_sa.ssh.server.key', 'pybind.nos.v7_0_1b.brocade_sec_services', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ssh_sa.ssh.server.key', 'pybind.nos.v7_1_0.brocade_sec_services', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ssh_sa.ssh.server.key', 'pybind.slxos.v16r_1_00b.brocade_sec_services', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rsa'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ssh_server_mac_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.ssh_sa.ssh.server', 'pybind.nos.v6_0_2c.brocade_sec_services', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ssh_sa.ssh.server', 'pybind.nos.v7_0_1b.brocade_sec_services', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ssh_sa.ssh.server', 'pybind.nos.v7_1_0.brocade_sec_services', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ssh_sa.ssh.server', 'pybind.slxos.v16r_1_00b.brocade_sec_services', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mac'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ssh_server_max_sessions_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_1_0.ssh_sa.ssh.server', 'pybind.nos.v7_1_0.brocade_sec_services', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'max-sessions'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ssh_server_port_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.ssh_sa.ssh.server', 'pybind.slxos.v16r_1_00b.brocade_sec_services', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'port'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ssh_server_rekey_interval_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.ssh_sa.ssh.server', 'pybind.nos.v6_0_2c.brocade_sec_services', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ssh_sa.ssh.server', 'pybind.nos.v7_0_1b.brocade_sec_services', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ssh_sa.ssh.server', 'pybind.nos.v7_1_0.brocade_sec_services', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ssh_sa.ssh.server', 'pybind.slxos.v16r_1_00b.brocade_sec_services', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rekey-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ssh_server_shutdown_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.ssh_sa.ssh.server', 'pybind.nos.v6_0_2c.brocade_sec_services', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ssh_sa.ssh.server', 'pybind.nos.v7_0_1b.brocade_sec_services', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ssh_sa.ssh.server', 'pybind.nos.v7_1_0.brocade_sec_services', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ssh_sa.ssh.server', 'pybind.slxos.v16r_1_00b.brocade_sec_services', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'shutdown'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ssh_server_ssh_vrf_cont_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.ssh_sa.ssh.server.ssh_vrf_cont', 'pybind.nos.v6_0_2c.brocade_sec_services', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ssh_sa.ssh.server.ssh_vrf_cont', 'pybind.nos.v7_0_1b.brocade_sec_services', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ssh_sa.ssh.server.ssh_vrf_cont', 'pybind.nos.v7_1_0.brocade_sec_services', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ssh_sa.ssh.server.ssh_vrf_cont', 'pybind.slxos.v16r_1_00b.brocade_sec_services', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ssh_server_standby_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.ssh_sa.ssh.server.standby', 'pybind.nos.v6_0_2c.brocade_sec_services', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ssh_sa.ssh.server.standby', 'pybind.nos.v7_0_1b.brocade_sec_services', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ssh_sa.ssh.server.standby', 'pybind.nos.v7_1_0.brocade_sec_services', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ssh_sa.ssh.server.standby', 'pybind.slxos.v16r_1_00b.brocade_sec_services', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ssh_server_standby_enable_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.ssh_sa.ssh.server.standby', 'pybind.nos.v6_0_2c.brocade_sec_services', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ssh_sa.ssh.server.standby', 'pybind.nos.v7_0_1b.brocade_sec_services', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ssh_sa.ssh.server.standby', 'pybind.nos.v7_1_0.brocade_sec_services', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ssh_sa.ssh.server.standby', 'pybind.slxos.v16r_1_00b.brocade_sec_services', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ssh_server_use_vrf_delete(self, use_vrf=None, ssh_vrf_shutdown=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type use_vrf: use_vrf_name, ssh_vrf_shutdown
    :param use_vrf: Keyword argument tuple.

    :type use_vrf_name: unicode
    :param use_vrf_name: **use_vrf** tuple argument.

        * length restriction: ::

            ['0 .. max']

    :type ssh_vrf_shutdown: YANGBool
    :param ssh_vrf_shutdown: **use_vrf** tuple argument:  Shutdown SSH server on given vrf

    **Instance Argument(s)**:

    :type ssh_vrf_shutdown: YANGBool
    :param ssh_vrf_shutdown: Shutdown SSH server on given vrf

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.ssh_sa.ssh.server.ssh_vrf_cont.use_vrf', 'pybind.nos.v6_0_2c.brocade_sec_services', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ssh_sa.ssh.server.ssh_vrf_cont.use_vrf', 'pybind.nos.v7_0_1b.brocade_sec_services', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ssh_sa.ssh.server.ssh_vrf_cont.use_vrf', 'pybind.nos.v7_1_0.brocade_sec_services', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ssh_sa.ssh.server.ssh_vrf_cont.use_vrf', 'pybind.slxos.v16r_1_00b.brocade_sec_services', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'use_vrf', 'keyval': 'use_vrf_name', 'extra_keyval': 'use_vrf_name, ssh_vrf_shutdown'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, use_vrf=use_vrf, ssh_vrf_shutdown=ssh_vrf_shutdown)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, use_vrf=use_vrf, ssh_vrf_shutdown=ssh_vrf_shutdown)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def ssh_server_use_vrf_shutdown_delete(self, use_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type use_vrf: use_vrf_name
    :param use_vrf: Keyword argument tuple.

    :type use_vrf_name: unicode
    :param use_vrf_name: **use_vrf** tuple argument.

        * length restriction: ::

            ['0 .. max']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.ssh_sa.ssh.server.ssh_vrf_cont.use_vrf', 'pybind.nos.v6_0_2c.brocade_sec_services', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.ssh_sa.ssh.server.ssh_vrf_cont.use_vrf', 'pybind.nos.v7_0_1b.brocade_sec_services', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.ssh_sa.ssh.server.ssh_vrf_cont.use_vrf', 'pybind.nos.v7_1_0.brocade_sec_services', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.ssh_sa.ssh.server.ssh_vrf_cont.use_vrf', 'pybind.slxos.v16r_1_00b.brocade_sec_services', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'use_vrf', 'keyval': 'use_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'shutdown'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, use_vrf=use_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, use_vrf=use_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def sub_interface_statistics_state_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.sub_interface_statistics_state', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def sub_interface_statistics_state_bridge_domain_statistics_delete(self, bridge_domain_statistics=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type bridge_domain_statistics: bd_id
    :param bridge_domain_statistics: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bridge_domain_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.sub_interface_statistics_state.bridge_domain_statistics', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'bridge_domain_statistics', 'keyval': 'bd_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain_statistics=bridge_domain_statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain_statistics=bridge_domain_statistics)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def sub_interface_statistics_state_bridge_domain_statistics_lif_statistics_delete(self, bridge_domain_statistics=None, lif_statistics=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bridge_domain_statistics: bd_id
    :param bridge_domain_statistics: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bridge_domain_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type lif_statistics: lif_id
    :param lif_statistics: Keyword argument tuple.

    :type lif_id: long
    :param lif_id: **lif_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.sub_interface_statistics_state.bridge_domain_statistics', u'bridge_domain_statistics')]
    bindings_list = [('pybind.slxos.v16r_1_00b.sub_interface_statistics_state.bridge_domain_statistics.lif_statistics', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bd_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'lif_statistics', 'keyval': 'lif_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain_statistics=bridge_domain_statistics, lif_statistics=lif_statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain_statistics=bridge_domain_statistics, lif_statistics=lif_statistics)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def sub_interface_statistics_state_bridge_domain_statistics_lif_statistics_lif_name_delete(self, bridge_domain_statistics=None, lif_statistics=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bridge_domain_statistics: bd_id
    :param bridge_domain_statistics: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bridge_domain_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type lif_statistics: lif_id
    :param lif_statistics: Keyword argument tuple.

    :type lif_id: long
    :param lif_id: **lif_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.sub_interface_statistics_state.bridge_domain_statistics', u'bridge_domain_statistics')]
    bindings_list = [('pybind.slxos.v16r_1_00b.sub_interface_statistics_state.bridge_domain_statistics.lif_statistics', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bd_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'lif_statistics', 'keyval': 'lif_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lif-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain_statistics=bridge_domain_statistics, lif_statistics=lif_statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain_statistics=bridge_domain_statistics, lif_statistics=lif_statistics)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def sub_interface_statistics_state_bridge_domain_statistics_lif_statistics_rx_bytes_delete(self, bridge_domain_statistics=None, lif_statistics=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bridge_domain_statistics: bd_id
    :param bridge_domain_statistics: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bridge_domain_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type lif_statistics: lif_id
    :param lif_statistics: Keyword argument tuple.

    :type lif_id: long
    :param lif_id: **lif_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.sub_interface_statistics_state.bridge_domain_statistics', u'bridge_domain_statistics')]
    bindings_list = [('pybind.slxos.v16r_1_00b.sub_interface_statistics_state.bridge_domain_statistics.lif_statistics', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bd_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'lif_statistics', 'keyval': 'lif_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rx-bytes'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain_statistics=bridge_domain_statistics, lif_statistics=lif_statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain_statistics=bridge_domain_statistics, lif_statistics=lif_statistics)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def sub_interface_statistics_state_bridge_domain_statistics_lif_statistics_rx_packets_delete(self, bridge_domain_statistics=None, lif_statistics=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bridge_domain_statistics: bd_id
    :param bridge_domain_statistics: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bridge_domain_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type lif_statistics: lif_id
    :param lif_statistics: Keyword argument tuple.

    :type lif_id: long
    :param lif_id: **lif_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.sub_interface_statistics_state.bridge_domain_statistics', u'bridge_domain_statistics')]
    bindings_list = [('pybind.slxos.v16r_1_00b.sub_interface_statistics_state.bridge_domain_statistics.lif_statistics', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bd_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'lif_statistics', 'keyval': 'lif_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rx-packets'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain_statistics=bridge_domain_statistics, lif_statistics=lif_statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain_statistics=bridge_domain_statistics, lif_statistics=lif_statistics)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def sub_interface_statistics_state_bridge_domain_statistics_lif_statistics_tx_bytes_delete(self, bridge_domain_statistics=None, lif_statistics=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bridge_domain_statistics: bd_id
    :param bridge_domain_statistics: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bridge_domain_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type lif_statistics: lif_id
    :param lif_statistics: Keyword argument tuple.

    :type lif_id: long
    :param lif_id: **lif_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.sub_interface_statistics_state.bridge_domain_statistics', u'bridge_domain_statistics')]
    bindings_list = [('pybind.slxos.v16r_1_00b.sub_interface_statistics_state.bridge_domain_statistics.lif_statistics', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bd_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'lif_statistics', 'keyval': 'lif_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tx-bytes'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain_statistics=bridge_domain_statistics, lif_statistics=lif_statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain_statistics=bridge_domain_statistics, lif_statistics=lif_statistics)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def sub_interface_statistics_state_bridge_domain_statistics_lif_statistics_tx_packets_delete(self, bridge_domain_statistics=None, lif_statistics=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bridge_domain_statistics: bd_id
    :param bridge_domain_statistics: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bridge_domain_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type lif_statistics: lif_id
    :param lif_statistics: Keyword argument tuple.

    :type lif_id: long
    :param lif_id: **lif_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.sub_interface_statistics_state.bridge_domain_statistics', u'bridge_domain_statistics')]
    bindings_list = [('pybind.slxos.v16r_1_00b.sub_interface_statistics_state.bridge_domain_statistics.lif_statistics', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bd_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'lif_statistics', 'keyval': 'lif_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tx-packets'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain_statistics=bridge_domain_statistics, lif_statistics=lif_statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain_statistics=bridge_domain_statistics, lif_statistics=lif_statistics)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def sub_interface_statistics_state_vlan_statistics_delete(self, vlan_statistics=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type vlan_statistics: vlan_id
    :param vlan_statistics: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **vlan_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.sub_interface_statistics_state.vlan_statistics', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'vlan_statistics', 'keyval': 'vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan_statistics=vlan_statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan_statistics=vlan_statistics)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def sub_interface_statistics_state_vlan_statistics_port_statistics_delete(self, vlan_statistics=None, port_statistics=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan_statistics: vlan_id
    :param vlan_statistics: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **vlan_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type port_statistics: port_id
    :param port_statistics: Keyword argument tuple.

    :type port_id: long
    :param port_id: **port_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.sub_interface_statistics_state.vlan_statistics', u'vlan_statistics')]
    bindings_list = [('pybind.slxos.v16r_1_00b.sub_interface_statistics_state.vlan_statistics.port_statistics', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vlan_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'port_statistics', 'keyval': 'port_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan_statistics=vlan_statistics, port_statistics=port_statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan_statistics=vlan_statistics, port_statistics=port_statistics)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def sub_interface_statistics_state_vlan_statistics_port_statistics_port_name_delete(self, vlan_statistics=None, port_statistics=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan_statistics: vlan_id
    :param vlan_statistics: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **vlan_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type port_statistics: port_id
    :param port_statistics: Keyword argument tuple.

    :type port_id: long
    :param port_id: **port_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.sub_interface_statistics_state.vlan_statistics', u'vlan_statistics')]
    bindings_list = [('pybind.slxos.v16r_1_00b.sub_interface_statistics_state.vlan_statistics.port_statistics', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vlan_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'port_statistics', 'keyval': 'port_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'port-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan_statistics=vlan_statistics, port_statistics=port_statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan_statistics=vlan_statistics, port_statistics=port_statistics)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def sub_interface_statistics_state_vlan_statistics_port_statistics_rx_bytes_delete(self, vlan_statistics=None, port_statistics=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan_statistics: vlan_id
    :param vlan_statistics: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **vlan_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type port_statistics: port_id
    :param port_statistics: Keyword argument tuple.

    :type port_id: long
    :param port_id: **port_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.sub_interface_statistics_state.vlan_statistics', u'vlan_statistics')]
    bindings_list = [('pybind.slxos.v16r_1_00b.sub_interface_statistics_state.vlan_statistics.port_statistics', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vlan_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'port_statistics', 'keyval': 'port_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rx-bytes'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan_statistics=vlan_statistics, port_statistics=port_statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan_statistics=vlan_statistics, port_statistics=port_statistics)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def sub_interface_statistics_state_vlan_statistics_port_statistics_rx_packets_delete(self, vlan_statistics=None, port_statistics=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan_statistics: vlan_id
    :param vlan_statistics: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **vlan_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type port_statistics: port_id
    :param port_statistics: Keyword argument tuple.

    :type port_id: long
    :param port_id: **port_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.sub_interface_statistics_state.vlan_statistics', u'vlan_statistics')]
    bindings_list = [('pybind.slxos.v16r_1_00b.sub_interface_statistics_state.vlan_statistics.port_statistics', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vlan_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'port_statistics', 'keyval': 'port_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rx-packets'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan_statistics=vlan_statistics, port_statistics=port_statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan_statistics=vlan_statistics, port_statistics=port_statistics)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def sub_interface_statistics_state_vlan_statistics_port_statistics_tx_bytes_delete(self, vlan_statistics=None, port_statistics=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan_statistics: vlan_id
    :param vlan_statistics: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **vlan_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type port_statistics: port_id
    :param port_statistics: Keyword argument tuple.

    :type port_id: long
    :param port_id: **port_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.sub_interface_statistics_state.vlan_statistics', u'vlan_statistics')]
    bindings_list = [('pybind.slxos.v16r_1_00b.sub_interface_statistics_state.vlan_statistics.port_statistics', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vlan_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'port_statistics', 'keyval': 'port_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tx-bytes'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan_statistics=vlan_statistics, port_statistics=port_statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan_statistics=vlan_statistics, port_statistics=port_statistics)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def sub_interface_statistics_state_vlan_statistics_port_statistics_tx_packets_delete(self, vlan_statistics=None, port_statistics=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan_statistics: vlan_id
    :param vlan_statistics: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **vlan_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type port_statistics: port_id
    :param port_statistics: Keyword argument tuple.

    :type port_id: long
    :param port_id: **port_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.sub_interface_statistics_state.vlan_statistics', u'vlan_statistics')]
    bindings_list = [('pybind.slxos.v16r_1_00b.sub_interface_statistics_state.vlan_statistics.port_statistics', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vlan_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'port_statistics', 'keyval': 'port_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tx-packets'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan_statistics=vlan_statistics, port_statistics=port_statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan_statistics=vlan_statistics, port_statistics=port_statistics)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def support_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.support', 'pybind.nos.v6_0_2c.brocade_ras', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.support', 'pybind.nos.v7_0_1b.brocade_ras', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.support', 'pybind.nos.v7_1_0.brocade_ras', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.support', 'pybind.slxos.v16r_1_00b.brocade_ras', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def support_autoupload_enable_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.support.autoupload', 'pybind.nos.v6_0_2c.brocade_ras', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.support.autoupload', 'pybind.nos.v7_0_1b.brocade_ras', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.support.autoupload', 'pybind.nos.v7_1_0.brocade_ras', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.support.autoupload', 'pybind.slxos.v16r_1_00b.brocade_ras', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def support_autoupload_param_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.support.autoupload_param', 'pybind.nos.v6_0_2c.brocade_ras', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.support.autoupload_param', 'pybind.nos.v7_0_1b.brocade_ras', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.support.autoupload_param', 'pybind.nos.v7_1_0.brocade_ras', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.support.autoupload_param', 'pybind.slxos.v16r_1_00b.brocade_ras', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'hostip, username, directory, protocol, password'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def support_autoupload_param_directory_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.support.autoupload_param', 'pybind.nos.v6_0_2c.brocade_ras', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.support.autoupload_param', 'pybind.nos.v7_0_1b.brocade_ras', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.support.autoupload_param', 'pybind.nos.v7_1_0.brocade_ras', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.support.autoupload_param', 'pybind.slxos.v16r_1_00b.brocade_ras', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'directory'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def support_autoupload_param_hostip_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.support.autoupload_param', 'pybind.nos.v6_0_2c.brocade_ras', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.support.autoupload_param', 'pybind.nos.v7_0_1b.brocade_ras', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.support.autoupload_param', 'pybind.nos.v7_1_0.brocade_ras', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.support.autoupload_param', 'pybind.slxos.v16r_1_00b.brocade_ras', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hostip'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def support_autoupload_param_password_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.support.autoupload_param', 'pybind.nos.v6_0_2c.brocade_ras', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.support.autoupload_param', 'pybind.nos.v7_0_1b.brocade_ras', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.support.autoupload_param', 'pybind.nos.v7_1_0.brocade_ras', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.support.autoupload_param', 'pybind.slxos.v16r_1_00b.brocade_ras', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'password'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def support_autoupload_param_protocol_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.support.autoupload_param', 'pybind.nos.v6_0_2c.brocade_ras', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.support.autoupload_param', 'pybind.nos.v7_0_1b.brocade_ras', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.support.autoupload_param', 'pybind.nos.v7_1_0.brocade_ras', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.support.autoupload_param', 'pybind.slxos.v16r_1_00b.brocade_ras', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'protocol'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def support_autoupload_param_username_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.support.autoupload_param', 'pybind.nos.v6_0_2c.brocade_ras', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.support.autoupload_param', 'pybind.nos.v7_0_1b.brocade_ras', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.support.autoupload_param', 'pybind.nos.v7_1_0.brocade_ras', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.support.autoupload_param', 'pybind.slxos.v16r_1_00b.brocade_ras', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'username'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def support_ffdc_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.support', 'pybind.nos.v6_0_2c.brocade_ras', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.support', 'pybind.nos.v7_0_1b.brocade_ras', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.support', 'pybind.nos.v7_1_0.brocade_ras', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.support', 'pybind.slxos.v16r_1_00b.brocade_ras', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ffdc'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def support_support_param_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.support.support_param', 'pybind.nos.v6_0_2c.brocade_ras', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.support.support_param', 'pybind.nos.v7_0_1b.brocade_ras', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.support.support_param', 'pybind.nos.v7_1_0.brocade_ras', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.support.support_param', 'pybind.slxos.v16r_1_00b.brocade_ras', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'hostip, username, directory, protocol, password'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def support_support_param_directory_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.support.support_param', 'pybind.nos.v6_0_2c.brocade_ras', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.support.support_param', 'pybind.nos.v7_0_1b.brocade_ras', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.support.support_param', 'pybind.nos.v7_1_0.brocade_ras', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.support.support_param', 'pybind.slxos.v16r_1_00b.brocade_ras', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'directory'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def support_support_param_hostip_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.support.support_param', 'pybind.nos.v6_0_2c.brocade_ras', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.support.support_param', 'pybind.nos.v7_0_1b.brocade_ras', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.support.support_param', 'pybind.nos.v7_1_0.brocade_ras', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.support.support_param', 'pybind.slxos.v16r_1_00b.brocade_ras', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'hostip'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def support_support_param_password_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.support.support_param', 'pybind.nos.v6_0_2c.brocade_ras', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.support.support_param', 'pybind.nos.v7_0_1b.brocade_ras', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.support.support_param', 'pybind.nos.v7_1_0.brocade_ras', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.support.support_param', 'pybind.slxos.v16r_1_00b.brocade_ras', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'password'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def support_support_param_protocol_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.support.support_param', 'pybind.nos.v6_0_2c.brocade_ras', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.support.support_param', 'pybind.nos.v7_0_1b.brocade_ras', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.support.support_param', 'pybind.nos.v7_1_0.brocade_ras', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.support.support_param', 'pybind.slxos.v16r_1_00b.brocade_ras', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'protocol'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def support_support_param_username_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.support.support_param', 'pybind.nos.v6_0_2c.brocade_ras', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.support.support_param', 'pybind.nos.v7_0_1b.brocade_ras', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.support.support_param', 'pybind.nos.v7_1_0.brocade_ras', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.support.support_param', 'pybind.slxos.v16r_1_00b.brocade_ras', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'username'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def switch_attributes_chassis_name_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.system.switch_attributes', 'pybind.slxos.v16r_1_00b.brocade_ras', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'chassis-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def switch_attributes_host_name_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.system.switch_attributes', 'pybind.slxos.v16r_1_00b.brocade_ras', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'host-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def switch_attributes_rbridge_id_chassis_name_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Instance Keyword Argument Tuple**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: unicode
    :param rbridge_id: **rbridge_id** tuple argument.

        * length restriction: ::

            ['1..3']

        * pattern restriction: ::

            '[1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9]'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.system.switch_attributes.rbridge_id', 'pybind.nos.v6_0_2c.brocade_ras', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.system.switch_attributes.rbridge_id', 'pybind.nos.v7_0_1b.brocade_ras', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.system.switch_attributes.rbridge_id', 'pybind.nos.v7_1_0.brocade_ras', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'rbridge_id', 'keyval': 'rbridge_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'chassis-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def switch_attributes_rbridge_id_host_name_delete(self, rbridge_id=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Instance Keyword Argument Tuple**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: unicode
    :param rbridge_id: **rbridge_id** tuple argument.

        * length restriction: ::

            ['1..3']

        * pattern restriction: ::

            '[1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9]'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.system.switch_attributes.rbridge_id', 'pybind.nos.v6_0_2c.brocade_ras', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.system.switch_attributes.rbridge_id', 'pybind.nos.v7_0_1b.brocade_ras', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.system.switch_attributes.rbridge_id', 'pybind.nos.v7_1_0.brocade_ras', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'rbridge_id', 'keyval': 'rbridge_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'host-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def sysmon_fe_access_check_action_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.sysmon.fe_access_check', 'pybind.slxos.v16r_1_00b.brocade_sysmon', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'action'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def sysmon_fe_access_check_disable_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.sysmon.fe_access_check', 'pybind.slxos.v16r_1_00b.brocade_sysmon', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'disable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def sysmon_fe_access_check_poll_interval_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.sysmon.fe_access_check', 'pybind.slxos.v16r_1_00b.brocade_sysmon', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'poll-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def sysmon_fe_access_check_recovery_threshold_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.sysmon.fe_access_check', 'pybind.slxos.v16r_1_00b.brocade_sysmon', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'recovery-threshold'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def sysmon_fe_access_check_threshold_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.sysmon.fe_access_check', 'pybind.slxos.v16r_1_00b.brocade_sysmon', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'threshold'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def sysmon_link_crc_monitoring_action_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.sysmon.link_crc_monitoring', 'pybind.slxos.v16r_1_00b.brocade_sysmon', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'action'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def sysmon_link_crc_monitoring_disable_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.sysmon.link_crc_monitoring', 'pybind.slxos.v16r_1_00b.brocade_sysmon', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'disable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def sysmon_link_crc_monitoring_poll_interval_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.sysmon.link_crc_monitoring', 'pybind.slxos.v16r_1_00b.brocade_sysmon', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'poll-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def sysmon_link_crc_monitoring_threshold_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.sysmon.link_crc_monitoring', 'pybind.slxos.v16r_1_00b.brocade_sysmon', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'threshold'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def sysmon_sfm_walk_auto_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.sysmon.sfm_walk', 'pybind.slxos.v16r_1_00b.brocade_sysmon', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'auto'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def sysmon_sfm_walk_disable_redundancy_check_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.sysmon.sfm_walk', 'pybind.slxos.v16r_1_00b.brocade_sysmon', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'disable-redundancy-check'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def sysmon_sfm_walk_poll_interval_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.sysmon.sfm_walk', 'pybind.slxos.v16r_1_00b.brocade_sysmon', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'poll-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def sysmon_sfm_walk_threshold_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.sysmon.sfm_walk', 'pybind.slxos.v16r_1_00b.brocade_sysmon', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'threshold'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def system_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.system', 'pybind.nos.v6_0_2c.brocade_ras', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.system', 'pybind.nos.v7_0_1b.brocade_ras', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.system', 'pybind.nos.v7_1_0.brocade_ras', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.system', 'pybind.slxos.v16r_1_00b.brocade_ras', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def system_max_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.hide_arp_holder.system_max', 'pybind.nos.v6_0_2c.brocade_arp', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_arp_holder.system_max', 'pybind.nos.v7_0_1b.brocade_arp', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_arp_holder.system_max', 'pybind.nos.v7_1_0.brocade_arp', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def system_max_arp_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.hide_arp_holder.system_max', 'pybind.nos.v6_0_2c.brocade_arp', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.hide_arp_holder.system_max', 'pybind.nos.v7_0_1b.brocade_arp', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.hide_arp_holder.system_max', 'pybind.nos.v7_1_0.brocade_arp', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'arp'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def system_monitor_cid_card_alert_action_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.system_monitor.cid_card.alert', 'pybind.nos.v6_0_2c.brocade_system_monitor', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.system_monitor.cid_card.alert', 'pybind.nos.v7_0_1b.brocade_system_monitor', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.system_monitor.cid_card.alert', 'pybind.nos.v7_1_0.brocade_system_monitor', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.system_monitor.cid_card.alert', 'pybind.slxos.v16r_1_00b.brocade_system_monitor', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'action'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def system_monitor_cid_card_alert_state_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.system_monitor.cid_card.alert', 'pybind.nos.v6_0_2c.brocade_system_monitor', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.system_monitor.cid_card.alert', 'pybind.nos.v7_0_1b.brocade_system_monitor', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.system_monitor.cid_card.alert', 'pybind.nos.v7_1_0.brocade_system_monitor', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.system_monitor.cid_card.alert', 'pybind.slxos.v16r_1_00b.brocade_system_monitor', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'state'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def system_monitor_cid_card_threshold_down_threshold_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.system_monitor.cid_card.threshold', 'pybind.nos.v6_0_2c.brocade_system_monitor', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.system_monitor.cid_card.threshold', 'pybind.nos.v7_0_1b.brocade_system_monitor', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.system_monitor.cid_card.threshold', 'pybind.nos.v7_1_0.brocade_system_monitor', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.system_monitor.cid_card.threshold', 'pybind.slxos.v16r_1_00b.brocade_system_monitor', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'down-threshold'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def system_monitor_cid_card_threshold_marginal_threshold_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.system_monitor.cid_card.threshold', 'pybind.nos.v6_0_2c.brocade_system_monitor', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.system_monitor.cid_card.threshold', 'pybind.nos.v7_0_1b.brocade_system_monitor', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.system_monitor.cid_card.threshold', 'pybind.nos.v7_1_0.brocade_system_monitor', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.system_monitor.cid_card.threshold', 'pybind.slxos.v16r_1_00b.brocade_system_monitor', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'marginal-threshold'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def system_monitor_compact_flash_threshold_down_threshold_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.system_monitor.compact_flash.threshold', 'pybind.nos.v6_0_2c.brocade_system_monitor', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.system_monitor.compact_flash.threshold', 'pybind.nos.v7_0_1b.brocade_system_monitor', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.system_monitor.compact_flash.threshold', 'pybind.nos.v7_1_0.brocade_system_monitor', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.system_monitor.compact_flash.threshold', 'pybind.slxos.v16r_1_00b.brocade_system_monitor', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'down-threshold'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def system_monitor_compact_flash_threshold_marginal_threshold_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.system_monitor.compact_flash.threshold', 'pybind.nos.v6_0_2c.brocade_system_monitor', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.system_monitor.compact_flash.threshold', 'pybind.nos.v7_0_1b.brocade_system_monitor', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.system_monitor.compact_flash.threshold', 'pybind.nos.v7_1_0.brocade_system_monitor', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.system_monitor.compact_flash.threshold', 'pybind.slxos.v16r_1_00b.brocade_system_monitor', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'marginal-threshold'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def system_monitor_fan_alert_action_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.system_monitor.fan.alert', 'pybind.nos.v6_0_2c.brocade_system_monitor', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.system_monitor.fan.alert', 'pybind.nos.v7_0_1b.brocade_system_monitor', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.system_monitor.fan.alert', 'pybind.nos.v7_1_0.brocade_system_monitor', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.system_monitor.fan.alert', 'pybind.slxos.v16r_1_00b.brocade_system_monitor', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'action'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def system_monitor_fan_alert_state_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.system_monitor.fan.alert', 'pybind.nos.v6_0_2c.brocade_system_monitor', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.system_monitor.fan.alert', 'pybind.nos.v7_0_1b.brocade_system_monitor', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.system_monitor.fan.alert', 'pybind.nos.v7_1_0.brocade_system_monitor', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.system_monitor.fan.alert', 'pybind.slxos.v16r_1_00b.brocade_system_monitor', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'state'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def system_monitor_fan_threshold_down_threshold_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.system_monitor.fan.threshold', 'pybind.nos.v6_0_2c.brocade_system_monitor', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.system_monitor.fan.threshold', 'pybind.nos.v7_0_1b.brocade_system_monitor', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.system_monitor.fan.threshold', 'pybind.nos.v7_1_0.brocade_system_monitor', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.system_monitor.fan.threshold', 'pybind.slxos.v16r_1_00b.brocade_system_monitor', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'down-threshold'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def system_monitor_fan_threshold_marginal_threshold_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.system_monitor.fan.threshold', 'pybind.nos.v6_0_2c.brocade_system_monitor', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.system_monitor.fan.threshold', 'pybind.nos.v7_0_1b.brocade_system_monitor', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.system_monitor.fan.threshold', 'pybind.nos.v7_1_0.brocade_system_monitor', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.system_monitor.fan.threshold', 'pybind.slxos.v16r_1_00b.brocade_system_monitor', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'marginal-threshold'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def system_monitor_linecard_alert_action_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.system_monitor.LineCard.alert', 'pybind.nos.v6_0_2c.brocade_system_monitor', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.system_monitor.LineCard.alert', 'pybind.nos.v7_0_1b.brocade_system_monitor', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.system_monitor.LineCard.alert', 'pybind.nos.v7_1_0.brocade_system_monitor', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.system_monitor.LineCard.alert', 'pybind.slxos.v16r_1_00b.brocade_system_monitor', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'action'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def system_monitor_linecard_alert_state_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.system_monitor.LineCard.alert', 'pybind.nos.v6_0_2c.brocade_system_monitor', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.system_monitor.LineCard.alert', 'pybind.nos.v7_0_1b.brocade_system_monitor', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.system_monitor.LineCard.alert', 'pybind.nos.v7_1_0.brocade_system_monitor', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.system_monitor.LineCard.alert', 'pybind.slxos.v16r_1_00b.brocade_system_monitor', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'state'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def system_monitor_linecard_threshold_down_threshold_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.system_monitor.LineCard.threshold', 'pybind.nos.v6_0_2c.brocade_system_monitor', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.system_monitor.LineCard.threshold', 'pybind.nos.v7_0_1b.brocade_system_monitor', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.system_monitor.LineCard.threshold', 'pybind.nos.v7_1_0.brocade_system_monitor', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.system_monitor.LineCard.threshold', 'pybind.slxos.v16r_1_00b.brocade_system_monitor', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'down-threshold'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def system_monitor_linecard_threshold_marginal_threshold_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.system_monitor.LineCard.threshold', 'pybind.nos.v6_0_2c.brocade_system_monitor', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.system_monitor.LineCard.threshold', 'pybind.nos.v7_0_1b.brocade_system_monitor', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.system_monitor.LineCard.threshold', 'pybind.nos.v7_1_0.brocade_system_monitor', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.system_monitor.LineCard.threshold', 'pybind.slxos.v16r_1_00b.brocade_system_monitor', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'marginal-threshold'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def system_monitor_mail_fru_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.system_monitor_mail.fru', 'pybind.nos.v6_0_2c.brocade_system_monitor', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.system_monitor_mail.fru', 'pybind.nos.v7_0_1b.brocade_system_monitor', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.system_monitor_mail.fru', 'pybind.nos.v7_1_0.brocade_system_monitor', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.system_monitor_mail.fru', 'pybind.slxos.v16r_1_00b.brocade_system_monitor', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def system_monitor_mail_fru_email_list_delete(self, email_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type email_list: email
    :param email_list: Keyword argument tuple.

    :type email: unicode
    :param email: **email_list** tuple argument:  <email:string>  e-mail address for FRU alerts

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.system_monitor_mail.fru.email_list', 'pybind.nos.v6_0_2c.brocade_system_monitor', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.system_monitor_mail.fru.email_list', 'pybind.nos.v7_0_1b.brocade_system_monitor', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.system_monitor_mail.fru.email_list', 'pybind.nos.v7_1_0.brocade_system_monitor', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.system_monitor_mail.fru.email_list', 'pybind.slxos.v16r_1_00b.brocade_system_monitor', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'email_list', 'keyval': 'email', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, email_list=email_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, email_list=email_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def system_monitor_mail_fru_enable_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.system_monitor_mail.fru', 'pybind.nos.v6_0_2c.brocade_system_monitor', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.system_monitor_mail.fru', 'pybind.nos.v7_0_1b.brocade_system_monitor', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.system_monitor_mail.fru', 'pybind.nos.v7_1_0.brocade_system_monitor', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.system_monitor_mail.fru', 'pybind.slxos.v16r_1_00b.brocade_system_monitor', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def system_monitor_mail_interface_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.system_monitor_mail.interface', 'pybind.nos.v6_0_2c.brocade_system_monitor', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.system_monitor_mail.interface', 'pybind.nos.v7_0_1b.brocade_system_monitor', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.system_monitor_mail.interface', 'pybind.nos.v7_1_0.brocade_system_monitor', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.system_monitor_mail.interface', 'pybind.slxos.v16r_1_00b.brocade_system_monitor', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def system_monitor_mail_interface_email_list_delete(self, email_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type email_list: email
    :param email_list: Keyword argument tuple.

    :type email: unicode
    :param email: **email_list** tuple argument:  <email:string>  e-mail address for Interface alerts

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.system_monitor_mail.interface.email_list', 'pybind.nos.v6_0_2c.brocade_system_monitor', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.system_monitor_mail.interface.email_list', 'pybind.nos.v7_0_1b.brocade_system_monitor', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.system_monitor_mail.interface.email_list', 'pybind.nos.v7_1_0.brocade_system_monitor', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.system_monitor_mail.interface.email_list', 'pybind.slxos.v16r_1_00b.brocade_system_monitor', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'email_list', 'keyval': 'email', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, email_list=email_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, email_list=email_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def system_monitor_mail_interface_enable_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.system_monitor_mail.interface', 'pybind.nos.v6_0_2c.brocade_system_monitor', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.system_monitor_mail.interface', 'pybind.nos.v7_0_1b.brocade_system_monitor', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.system_monitor_mail.interface', 'pybind.nos.v7_1_0.brocade_system_monitor', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.system_monitor_mail.interface', 'pybind.slxos.v16r_1_00b.brocade_system_monitor', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def system_monitor_mail_relay_delete(self, relay=None, domain_name=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type relay: host_ip
    :param relay: Keyword argument tuple.

    :type host_ip: unicode
    :param host_ip: **relay** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Argument(s)**:

    :type domain_name: unicode
    :param domain_name: Domain name server

        * length restriction: ::

            ['0 .. 64']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.system_monitor_mail.relay', 'pybind.nos.v6_0_2c.brocade_system_monitor', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.system_monitor_mail.relay', 'pybind.nos.v7_0_1b.brocade_system_monitor', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.system_monitor_mail.relay', 'pybind.nos.v7_1_0.brocade_system_monitor', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.system_monitor_mail.relay', 'pybind.slxos.v16r_1_00b.brocade_system_monitor', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'relay', 'keyval': 'host_ip', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, relay=relay, domain_name=domain_name)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, relay=relay, domain_name=domain_name)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def system_monitor_mail_relay_domain_name_delete(self, relay=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type relay: host_ip
    :param relay: Keyword argument tuple.

    :type host_ip: unicode
    :param host_ip: **relay** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.system_monitor_mail.relay', 'pybind.nos.v6_0_2c.brocade_system_monitor', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.system_monitor_mail.relay', 'pybind.nos.v7_0_1b.brocade_system_monitor', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.system_monitor_mail.relay', 'pybind.nos.v7_1_0.brocade_system_monitor', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.system_monitor_mail.relay', 'pybind.slxos.v16r_1_00b.brocade_system_monitor', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'relay', 'keyval': 'host_ip', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'domain-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, relay=relay)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, relay=relay)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def system_monitor_mail_security_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.system_monitor_mail.security', 'pybind.nos.v6_0_2c.brocade_system_monitor', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.system_monitor_mail.security', 'pybind.nos.v7_0_1b.brocade_system_monitor', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.system_monitor_mail.security', 'pybind.nos.v7_1_0.brocade_system_monitor', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.system_monitor_mail.security', 'pybind.slxos.v16r_1_00b.brocade_system_monitor', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def system_monitor_mail_security_email_list_delete(self, email_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type email_list: email
    :param email_list: Keyword argument tuple.

    :type email: unicode
    :param email: **email_list** tuple argument:  <email:string>  e-mail address for Security alerts

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.system_monitor_mail.security.email_list', 'pybind.nos.v6_0_2c.brocade_system_monitor', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.system_monitor_mail.security.email_list', 'pybind.nos.v7_0_1b.brocade_system_monitor', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.system_monitor_mail.security.email_list', 'pybind.nos.v7_1_0.brocade_system_monitor', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.system_monitor_mail.security.email_list', 'pybind.slxos.v16r_1_00b.brocade_system_monitor', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'email_list', 'keyval': 'email', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, email_list=email_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, email_list=email_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def system_monitor_mail_security_enable_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.system_monitor_mail.security', 'pybind.nos.v6_0_2c.brocade_system_monitor', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.system_monitor_mail.security', 'pybind.nos.v7_0_1b.brocade_system_monitor', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.system_monitor_mail.security', 'pybind.nos.v7_1_0.brocade_system_monitor', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.system_monitor_mail.security', 'pybind.slxos.v16r_1_00b.brocade_system_monitor', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def system_monitor_mail_sfp_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.system_monitor_mail.sfp', 'pybind.nos.v6_0_2c.brocade_system_monitor', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.system_monitor_mail.sfp', 'pybind.nos.v7_0_1b.brocade_system_monitor', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.system_monitor_mail.sfp', 'pybind.nos.v7_1_0.brocade_system_monitor', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.system_monitor_mail.sfp', 'pybind.slxos.v16r_1_00b.brocade_system_monitor', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def system_monitor_mail_sfp_email_list_delete(self, email_list=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type email_list: email
    :param email_list: Keyword argument tuple.

    :type email: unicode
    :param email: **email_list** tuple argument:  <email:string>  e-mail address for SFP alerts

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.system_monitor_mail.sfp.email_list', 'pybind.nos.v6_0_2c.brocade_system_monitor', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.system_monitor_mail.sfp.email_list', 'pybind.nos.v7_0_1b.brocade_system_monitor', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.system_monitor_mail.sfp.email_list', 'pybind.nos.v7_1_0.brocade_system_monitor', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.system_monitor_mail.sfp.email_list', 'pybind.slxos.v16r_1_00b.brocade_system_monitor', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'email_list', 'keyval': 'email', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, email_list=email_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, email_list=email_list)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def system_monitor_mail_sfp_enable_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.system_monitor_mail.sfp', 'pybind.nos.v6_0_2c.brocade_system_monitor', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.system_monitor_mail.sfp', 'pybind.nos.v7_0_1b.brocade_system_monitor', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.system_monitor_mail.sfp', 'pybind.nos.v7_1_0.brocade_system_monitor', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.system_monitor_mail.sfp', 'pybind.slxos.v16r_1_00b.brocade_system_monitor', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def system_monitor_mm_threshold_down_threshold_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.system_monitor.MM.threshold', 'pybind.nos.v6_0_2c.brocade_system_monitor', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.system_monitor.MM.threshold', 'pybind.nos.v7_0_1b.brocade_system_monitor', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.system_monitor.MM.threshold', 'pybind.nos.v7_1_0.brocade_system_monitor', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.system_monitor.MM.threshold', 'pybind.slxos.v16r_1_00b.brocade_system_monitor', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'down-threshold'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def system_monitor_mm_threshold_marginal_threshold_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.system_monitor.MM.threshold', 'pybind.nos.v6_0_2c.brocade_system_monitor', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.system_monitor.MM.threshold', 'pybind.nos.v7_0_1b.brocade_system_monitor', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.system_monitor.MM.threshold', 'pybind.nos.v7_1_0.brocade_system_monitor', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.system_monitor.MM.threshold', 'pybind.slxos.v16r_1_00b.brocade_system_monitor', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'marginal-threshold'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def system_monitor_power_alert_action_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.system_monitor.power.alert', 'pybind.nos.v6_0_2c.brocade_system_monitor', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.system_monitor.power.alert', 'pybind.nos.v7_0_1b.brocade_system_monitor', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.system_monitor.power.alert', 'pybind.nos.v7_1_0.brocade_system_monitor', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.system_monitor.power.alert', 'pybind.slxos.v16r_1_00b.brocade_system_monitor', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'action'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def system_monitor_power_alert_state_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.system_monitor.power.alert', 'pybind.nos.v6_0_2c.brocade_system_monitor', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.system_monitor.power.alert', 'pybind.nos.v7_0_1b.brocade_system_monitor', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.system_monitor.power.alert', 'pybind.nos.v7_1_0.brocade_system_monitor', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.system_monitor.power.alert', 'pybind.slxos.v16r_1_00b.brocade_system_monitor', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'state'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def system_monitor_power_threshold_down_threshold_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.system_monitor.power.threshold', 'pybind.nos.v6_0_2c.brocade_system_monitor', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.system_monitor.power.threshold', 'pybind.nos.v7_0_1b.brocade_system_monitor', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.system_monitor.power.threshold', 'pybind.nos.v7_1_0.brocade_system_monitor', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.system_monitor.power.threshold', 'pybind.slxos.v16r_1_00b.brocade_system_monitor', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'down-threshold'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def system_monitor_power_threshold_marginal_threshold_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.system_monitor.power.threshold', 'pybind.nos.v6_0_2c.brocade_system_monitor', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.system_monitor.power.threshold', 'pybind.nos.v7_0_1b.brocade_system_monitor', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.system_monitor.power.threshold', 'pybind.nos.v7_1_0.brocade_system_monitor', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.system_monitor.power.threshold', 'pybind.slxos.v16r_1_00b.brocade_system_monitor', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'marginal-threshold'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def system_monitor_sfm_threshold_down_threshold_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.system_monitor.SFM.threshold', 'pybind.nos.v6_0_2c.brocade_system_monitor', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.system_monitor.SFM.threshold', 'pybind.nos.v7_0_1b.brocade_system_monitor', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.system_monitor.SFM.threshold', 'pybind.nos.v7_1_0.brocade_system_monitor', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.system_monitor.SFM.threshold', 'pybind.slxos.v16r_1_00b.brocade_system_monitor', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'down-threshold'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def system_monitor_sfm_threshold_marginal_threshold_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.system_monitor.SFM.threshold', 'pybind.nos.v6_0_2c.brocade_system_monitor', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.system_monitor.SFM.threshold', 'pybind.nos.v7_0_1b.brocade_system_monitor', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.system_monitor.SFM.threshold', 'pybind.nos.v7_1_0.brocade_system_monitor', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.system_monitor.SFM.threshold', 'pybind.slxos.v16r_1_00b.brocade_system_monitor', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'marginal-threshold'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def system_monitor_sfp_alert_action_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.system_monitor.sfp.alert', 'pybind.nos.v6_0_2c.brocade_system_monitor', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.system_monitor.sfp.alert', 'pybind.nos.v7_0_1b.brocade_system_monitor', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.system_monitor.sfp.alert', 'pybind.nos.v7_1_0.brocade_system_monitor', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'action'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def system_monitor_sfp_alert_state_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.system_monitor.sfp.alert', 'pybind.nos.v6_0_2c.brocade_system_monitor', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.system_monitor.sfp.alert', 'pybind.nos.v7_0_1b.brocade_system_monitor', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.system_monitor.sfp.alert', 'pybind.nos.v7_1_0.brocade_system_monitor', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'state'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def system_monitor_temp_threshold_down_threshold_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.system_monitor.temp.threshold', 'pybind.nos.v6_0_2c.brocade_system_monitor', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.system_monitor.temp.threshold', 'pybind.nos.v7_0_1b.brocade_system_monitor', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.system_monitor.temp.threshold', 'pybind.nos.v7_1_0.brocade_system_monitor', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.system_monitor.temp.threshold', 'pybind.slxos.v16r_1_00b.brocade_system_monitor', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'down-threshold'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def system_monitor_temp_threshold_marginal_threshold_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.system_monitor.temp.threshold', 'pybind.nos.v6_0_2c.brocade_system_monitor', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.system_monitor.temp.threshold', 'pybind.nos.v7_0_1b.brocade_system_monitor', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.system_monitor.temp.threshold', 'pybind.nos.v7_1_0.brocade_system_monitor', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.system_monitor.temp.threshold', 'pybind.slxos.v16r_1_00b.brocade_system_monitor', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'marginal-threshold'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def system_qos_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.system_qos', 'pybind.nos.v6_0_2c.brocade_policer', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.system_qos', 'pybind.nos.v7_0_1b.brocade_policer', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.system_qos', 'pybind.nos.v7_1_0.brocade_policer', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.system_qos', 'pybind.slxos.v16r_1_00b.brocade_qos_mqc', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def system_tunnel_replicator_load_balance_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_0_1b.tunnel_settings.system.tunnel.replicator', 'pybind.nos.v7_0_1b.brocade_tunnels', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.tunnel_settings.system.tunnel.replicator', 'pybind.nos.v7_1_0.brocade_tunnels', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'load-balance'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def system_tunnel_suppress_debounce_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.tunnel_settings.system.tunnel', 'pybind.nos.v6_0_2c.brocade_tunnels', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.tunnel_settings.system.tunnel', 'pybind.nos.v7_0_1b.brocade_tunnels', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.tunnel_settings.system.tunnel', 'pybind.nos.v7_1_0.brocade_tunnels', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'suppress-debounce'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def tacacs_server_host_delete(self, host=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type host: hostname
    :param host: Keyword argument tuple.

    :type hostname: unicode
    :param hostname: **host** tuple argument:  INETADDRESS   Domain name or IP Address of this TACACS+ server

        * length restriction: ::

            ['0..max']

        * pattern restriction: ::

            '\p{IsBasicLatin}{0,255}'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.tacacs_server.host', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.tacacs_server.host', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.tacacs_server.host', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.tacacs_server.host', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'host', 'keyval': 'hostname, use_vrf', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v7_0_1b.tacacs_server.host": {}, "pybind.nos.v7_1_0.tacacs_server.host": {}, "pybind.slxos.v16r_1_00b.tacacs_server.host": {}, "pybind.nos.v6_0_2c.tacacs_server.host": {"encryption_level": "encryption_level", "retries": "retries", "protocol": "protocol", "timeout": "timeout", "hostname": "hostname", "key": "key", "port": "port"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, host=host)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, host=host)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def tacacs_server_host_encryption_level_delete(self, host=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type host: hostname
    :param host: Keyword argument tuple.

    :type hostname: unicode
    :param hostname: **host** tuple argument:  INETADDRESS   Domain name or IP Address of this TACACS+ server

        * length restriction: ::

            ['0..max']

        * pattern restriction: ::

            '\p{IsBasicLatin}{0,255}'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.tacacs_server.host', u'host')]
    bindings_list = [('pybind.nos.v6_0_2c.tacacs_server.host', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.tacacs_server.host', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.tacacs_server.host', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.tacacs_server.host.tacacs_server_options', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'hostname, use_vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'host', 'keyval': 'hostname, use_vrf', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v7_0_1b.tacacs_server.host": {}, "pybind.slxos.v16r_1_00b.tacacs_server.host.tacacs_server_options": {}, "pybind.nos.v7_1_0.tacacs_server.host": {}, "pybind.nos.v6_0_2c.tacacs_server.host": {"encryption_level": "encryption_level", "hostname": "hostname"}}
    rest_leaf_name = 'encryption-level'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, host=host)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, host=host)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def tacacs_server_host_key_delete(self, host=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type host: hostname
    :param host: Keyword argument tuple.

    :type hostname: unicode
    :param hostname: **host** tuple argument:  INETADDRESS   Domain name or IP Address of this TACACS+ server

        * length restriction: ::

            ['0..max']

        * pattern restriction: ::

            '\p{IsBasicLatin}{0,255}'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.tacacs_server.host', u'host')]
    bindings_list = [('pybind.nos.v6_0_2c.tacacs_server.host', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.tacacs_server.host', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.tacacs_server.host', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.tacacs_server.host.tacacs_server_options', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'hostname, use_vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'host', 'keyval': 'hostname, use_vrf', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v7_0_1b.tacacs_server.host": {}, "pybind.slxos.v16r_1_00b.tacacs_server.host.tacacs_server_options": {}, "pybind.nos.v7_1_0.tacacs_server.host": {}, "pybind.nos.v6_0_2c.tacacs_server.host": {"hostname": "hostname", "key": "key"}}
    rest_leaf_name = 'key'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, host=host)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, host=host)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def tacacs_server_host_port_delete(self, host=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type host: hostname
    :param host: Keyword argument tuple.

    :type hostname: unicode
    :param hostname: **host** tuple argument:  INETADDRESS   Domain name or IP Address of this TACACS+ server

        * length restriction: ::

            ['0..max']

        * pattern restriction: ::

            '\p{IsBasicLatin}{0,255}'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.tacacs_server.host', u'host')]
    bindings_list = [('pybind.nos.v6_0_2c.tacacs_server.host', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.tacacs_server.host', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.tacacs_server.host', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.tacacs_server.host.tacacs_server_options', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'hostname, use_vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'host', 'keyval': 'hostname, use_vrf', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v7_0_1b.tacacs_server.host": {}, "pybind.slxos.v16r_1_00b.tacacs_server.host.tacacs_server_options": {}, "pybind.nos.v7_1_0.tacacs_server.host": {}, "pybind.nos.v6_0_2c.tacacs_server.host": {"hostname": "hostname", "port": "port"}}
    rest_leaf_name = 'port'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, host=host)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, host=host)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def tacacs_server_host_protocol_delete(self, host=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type host: hostname
    :param host: Keyword argument tuple.

    :type hostname: unicode
    :param hostname: **host** tuple argument:  INETADDRESS   Domain name or IP Address of this TACACS+ server

        * length restriction: ::

            ['0..max']

        * pattern restriction: ::

            '\p{IsBasicLatin}{0,255}'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.tacacs_server.host', u'host')]
    bindings_list = [('pybind.nos.v6_0_2c.tacacs_server.host', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.tacacs_server.host', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.tacacs_server.host', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.tacacs_server.host.tacacs_server_options', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'hostname, use_vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'host', 'keyval': 'hostname, use_vrf', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v7_0_1b.tacacs_server.host": {}, "pybind.slxos.v16r_1_00b.tacacs_server.host.tacacs_server_options": {}, "pybind.nos.v7_1_0.tacacs_server.host": {}, "pybind.nos.v6_0_2c.tacacs_server.host": {"hostname": "hostname", "protocol": "protocol"}}
    rest_leaf_name = 'protocol'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, host=host)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, host=host)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def tacacs_server_host_retries_delete(self, host=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type host: hostname
    :param host: Keyword argument tuple.

    :type hostname: unicode
    :param hostname: **host** tuple argument:  INETADDRESS   Domain name or IP Address of this TACACS+ server

        * length restriction: ::

            ['0..max']

        * pattern restriction: ::

            '\p{IsBasicLatin}{0,255}'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.tacacs_server.host', u'host')]
    bindings_list = [('pybind.nos.v6_0_2c.tacacs_server.host', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.tacacs_server.host', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.tacacs_server.host', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.tacacs_server.host.tacacs_server_options', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'hostname, use_vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'host', 'keyval': 'hostname, use_vrf', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v7_0_1b.tacacs_server.host": {}, "pybind.slxos.v16r_1_00b.tacacs_server.host.tacacs_server_options": {}, "pybind.nos.v7_1_0.tacacs_server.host": {}, "pybind.nos.v6_0_2c.tacacs_server.host": {"retries": "retries", "hostname": "hostname"}}
    rest_leaf_name = 'retries'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, host=host)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, host=host)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def tacacs_server_host_timeout_delete(self, host=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type host: hostname
    :param host: Keyword argument tuple.

    :type hostname: unicode
    :param hostname: **host** tuple argument:  INETADDRESS   Domain name or IP Address of this TACACS+ server

        * length restriction: ::

            ['0..max']

        * pattern restriction: ::

            '\p{IsBasicLatin}{0,255}'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.tacacs_server.host', u'host')]
    bindings_list = [('pybind.nos.v6_0_2c.tacacs_server.host', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.tacacs_server.host', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.tacacs_server.host', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.tacacs_server.host.tacacs_server_options', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'hostname, use_vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'host', 'keyval': 'hostname, use_vrf', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v7_0_1b.tacacs_server.host": {}, "pybind.slxos.v16r_1_00b.tacacs_server.host.tacacs_server_options": {}, "pybind.nos.v7_1_0.tacacs_server.host": {}, "pybind.nos.v6_0_2c.tacacs_server.host": {"hostname": "hostname", "timeout": "timeout"}}
    rest_leaf_name = 'timeout'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, host=host)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, host=host)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def tacacs_server_source_ip_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.tacacs_server', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.tacacs_server', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.tacacs_server', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.tacacs_server', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'source-ip'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def telnet_client_source_interface_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.telnet_sa.telnet.client.source_interface', 'pybind.slxos.v16r_1_00b.brocade_sec_services', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def telnet_client_source_interface_interface_name_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.telnet_sa.telnet.client.source_interface', 'pybind.slxos.v16r_1_00b.brocade_sec_services', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'interface-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def telnet_client_source_interface_interface_type_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.telnet_sa.telnet.client.source_interface', 'pybind.slxos.v16r_1_00b.brocade_sec_services', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'interface-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def telnet_sa_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.telnet_sa', 'pybind.nos.v6_0_2c.brocade_sec_services', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.telnet_sa', 'pybind.nos.v7_0_1b.brocade_sec_services', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.telnet_sa', 'pybind.nos.v7_1_0.brocade_sec_services', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.telnet_sa', 'pybind.slxos.v16r_1_00b.brocade_sec_services', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def telnet_server_shutdown_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.telnet_sa.telnet.server', 'pybind.nos.v6_0_2c.brocade_sec_services', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.telnet_sa.telnet.server', 'pybind.nos.v7_0_1b.brocade_sec_services', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.telnet_sa.telnet.server', 'pybind.nos.v7_1_0.brocade_sec_services', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.telnet_sa.telnet.server', 'pybind.slxos.v16r_1_00b.brocade_sec_services', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'shutdown'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def telnet_server_standby_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.telnet_sa.telnet.server.standby', 'pybind.nos.v6_0_2c.brocade_sec_services', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.telnet_sa.telnet.server.standby', 'pybind.nos.v7_0_1b.brocade_sec_services', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.telnet_sa.telnet.server.standby', 'pybind.nos.v7_1_0.brocade_sec_services', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.telnet_sa.telnet.server.standby', 'pybind.slxos.v16r_1_00b.brocade_sec_services', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def telnet_server_standby_enable_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.telnet_sa.telnet.server.standby', 'pybind.nos.v6_0_2c.brocade_sec_services', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.telnet_sa.telnet.server.standby', 'pybind.nos.v7_0_1b.brocade_sec_services', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.telnet_sa.telnet.server.standby', 'pybind.nos.v7_1_0.brocade_sec_services', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.telnet_sa.telnet.server.standby', 'pybind.slxos.v16r_1_00b.brocade_sec_services', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def telnet_server_telnet_vrf_cont_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.telnet_sa.telnet.server.telnet_vrf_cont', 'pybind.nos.v6_0_2c.brocade_sec_services', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.telnet_sa.telnet.server.telnet_vrf_cont', 'pybind.nos.v7_0_1b.brocade_sec_services', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.telnet_sa.telnet.server.telnet_vrf_cont', 'pybind.nos.v7_1_0.brocade_sec_services', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.telnet_sa.telnet.server.telnet_vrf_cont', 'pybind.slxos.v16r_1_00b.brocade_sec_services', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def telnet_server_use_vrf_delete(self, use_vrf=None, telnet_vrf_shutdown=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type use_vrf: use_vrf_name, telnet_vrf_shutdown
    :param use_vrf: Keyword argument tuple.

    :type use_vrf_name: unicode
    :param use_vrf_name: **use_vrf** tuple argument.

        * length restriction: ::

            ['0 .. max']

    :type telnet_vrf_shutdown: YANGBool
    :param telnet_vrf_shutdown: **use_vrf** tuple argument:  Shutdown telnet server on given vrf

    **Instance Argument(s)**:

    :type telnet_vrf_shutdown: YANGBool
    :param telnet_vrf_shutdown: Shutdown telnet server on given vrf

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.telnet_sa.telnet.server.telnet_vrf_cont.use_vrf', 'pybind.nos.v6_0_2c.brocade_sec_services', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.telnet_sa.telnet.server.telnet_vrf_cont.use_vrf', 'pybind.nos.v7_0_1b.brocade_sec_services', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.telnet_sa.telnet.server.telnet_vrf_cont.use_vrf', 'pybind.nos.v7_1_0.brocade_sec_services', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.telnet_sa.telnet.server.telnet_vrf_cont.use_vrf', 'pybind.slxos.v16r_1_00b.brocade_sec_services', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'use_vrf', 'keyval': 'use_vrf_name', 'extra_keyval': 'use_vrf_name, telnet_vrf_shutdown'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, use_vrf=use_vrf, telnet_vrf_shutdown=telnet_vrf_shutdown)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, use_vrf=use_vrf, telnet_vrf_shutdown=telnet_vrf_shutdown)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def telnet_server_use_vrf_shutdown_delete(self, use_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type use_vrf: use_vrf_name
    :param use_vrf: Keyword argument tuple.

    :type use_vrf_name: unicode
    :param use_vrf_name: **use_vrf** tuple argument.

        * length restriction: ::

            ['0 .. max']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.telnet_sa.telnet.server.telnet_vrf_cont.use_vrf', 'pybind.nos.v6_0_2c.brocade_sec_services', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.telnet_sa.telnet.server.telnet_vrf_cont.use_vrf', 'pybind.nos.v7_0_1b.brocade_sec_services', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.telnet_sa.telnet.server.telnet_vrf_cont.use_vrf', 'pybind.nos.v7_1_0.brocade_sec_services', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.telnet_sa.telnet.server.telnet_vrf_cont.use_vrf', 'pybind.slxos.v16r_1_00b.brocade_sec_services', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'use_vrf', 'keyval': 'use_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'shutdown'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, use_vrf=use_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, use_vrf=use_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def terminal_cfg_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.terminal_cfg', 'pybind.nos.v6_0_2c.brocade_terminal', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.terminal_cfg', 'pybind.nos.v7_0_1b.brocade_terminal', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.terminal_cfg', 'pybind.nos.v7_1_0.brocade_terminal', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.terminal_cfg', 'pybind.slxos.v16r_1_00b.brocade_terminal', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def threshold_monitor_buffer_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.threshold_monitor_hidden.threshold_monitor.Buffer', 'pybind.slxos.v16r_1_00b.brocade_threshold_monitor', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'poll, retry, limit, actions'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def threshold_monitor_buffer_actions_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.threshold_monitor_hidden.threshold_monitor.Buffer', 'pybind.slxos.v16r_1_00b.brocade_threshold_monitor', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'actions'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def threshold_monitor_buffer_limit_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.threshold_monitor_hidden.threshold_monitor.Buffer', 'pybind.slxos.v16r_1_00b.brocade_threshold_monitor', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'limit'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def threshold_monitor_buffer_poll_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.threshold_monitor_hidden.threshold_monitor.Buffer', 'pybind.slxos.v16r_1_00b.brocade_threshold_monitor', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'poll'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def threshold_monitor_buffer_retry_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.threshold_monitor_hidden.threshold_monitor.Buffer', 'pybind.slxos.v16r_1_00b.brocade_threshold_monitor', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'retry'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def threshold_monitor_cpu_actions_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.threshold_monitor_hidden.threshold_monitor.Cpu', 'pybind.nos.v6_0_2c.brocade_threshold_monitor', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.threshold_monitor_hidden.threshold_monitor.Cpu', 'pybind.nos.v7_0_1b.brocade_threshold_monitor', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.threshold_monitor_hidden.threshold_monitor.Cpu', 'pybind.nos.v7_1_0.brocade_threshold_monitor', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.threshold_monitor_hidden.threshold_monitor.Cpu', 'pybind.slxos.v16r_1_00b.brocade_threshold_monitor', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'actions'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def threshold_monitor_cpu_limit_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.threshold_monitor_hidden.threshold_monitor.Cpu', 'pybind.nos.v6_0_2c.brocade_threshold_monitor', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.threshold_monitor_hidden.threshold_monitor.Cpu', 'pybind.nos.v7_0_1b.brocade_threshold_monitor', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.threshold_monitor_hidden.threshold_monitor.Cpu', 'pybind.nos.v7_1_0.brocade_threshold_monitor', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.threshold_monitor_hidden.threshold_monitor.Cpu', 'pybind.slxos.v16r_1_00b.brocade_threshold_monitor', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'limit'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def threshold_monitor_cpu_poll_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.threshold_monitor_hidden.threshold_monitor.Cpu', 'pybind.nos.v6_0_2c.brocade_threshold_monitor', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.threshold_monitor_hidden.threshold_monitor.Cpu', 'pybind.nos.v7_0_1b.brocade_threshold_monitor', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.threshold_monitor_hidden.threshold_monitor.Cpu', 'pybind.nos.v7_1_0.brocade_threshold_monitor', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.threshold_monitor_hidden.threshold_monitor.Cpu', 'pybind.slxos.v16r_1_00b.brocade_threshold_monitor', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'poll'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def threshold_monitor_cpu_retry_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.threshold_monitor_hidden.threshold_monitor.Cpu', 'pybind.nos.v6_0_2c.brocade_threshold_monitor', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.threshold_monitor_hidden.threshold_monitor.Cpu', 'pybind.nos.v7_0_1b.brocade_threshold_monitor', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.threshold_monitor_hidden.threshold_monitor.Cpu', 'pybind.nos.v7_1_0.brocade_threshold_monitor', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.threshold_monitor_hidden.threshold_monitor.Cpu', 'pybind.slxos.v16r_1_00b.brocade_threshold_monitor', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'retry'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def threshold_monitor_hidden_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.threshold_monitor_hidden', 'pybind.nos.v6_0_2c.brocade_threshold_monitor', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.threshold_monitor_hidden', 'pybind.nos.v7_0_1b.brocade_threshold_monitor', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.threshold_monitor_hidden', 'pybind.nos.v7_1_0.brocade_threshold_monitor', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.threshold_monitor_hidden', 'pybind.slxos.v16r_1_00b.brocade_threshold_monitor', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def threshold_monitor_interface_apply_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.threshold_monitor_hidden.threshold_monitor.interface', 'pybind.nos.v6_0_2c.brocade_threshold_monitor', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.threshold_monitor_hidden.threshold_monitor.interface', 'pybind.nos.v7_0_1b.brocade_threshold_monitor', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.threshold_monitor_hidden.threshold_monitor.interface', 'pybind.nos.v7_1_0.brocade_threshold_monitor', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.threshold_monitor_hidden.threshold_monitor.interface', 'pybind.slxos.v16r_1_00b.brocade_threshold_monitor', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'apply'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def threshold_monitor_interface_pause_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.threshold_monitor_hidden.threshold_monitor.interface', 'pybind.nos.v6_0_2c.brocade_threshold_monitor', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.threshold_monitor_hidden.threshold_monitor.interface', 'pybind.nos.v7_0_1b.brocade_threshold_monitor', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.threshold_monitor_hidden.threshold_monitor.interface', 'pybind.nos.v7_1_0.brocade_threshold_monitor', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.threshold_monitor_hidden.threshold_monitor.interface', 'pybind.slxos.v16r_1_00b.brocade_threshold_monitor', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'pause'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def threshold_monitor_interface_policy_area_alert_above_highthresh_action_delete(self, policy=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy: policy_name
    :param policy: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **policy** tuple argument.

    :type area: type, area_value
    :param area: Keyword argument tuple.

    :type type: unicode
    :param type: **area** tuple argument:  Interface types that can be configured independent of speed

        * enumeration restriction: ::

            ['Ethernet']

    :type area_value: unicode
    :param area_value: **area** tuple argument.

        * enumeration restriction: ::

            ['MissingTerminationCharacter',
            'CRCAlignErrors',
            'IFG',
            'SymbolErrors']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.threshold_monitor_hidden.threshold_monitor.interface.policy', u'policy'), ('pybind.nos.v6_0_2c.threshold_monitor_hidden.threshold_monitor.interface.policy.area', u'area'), ('pybind.nos.v7_1_0.threshold_monitor_hidden.threshold_monitor.interface.policy', u'policy'), ('pybind.nos.v7_1_0.threshold_monitor_hidden.threshold_monitor.interface.policy.area', u'area'), ('pybind.nos.v7_0_1b.threshold_monitor_hidden.threshold_monitor.interface.policy', u'policy'), ('pybind.nos.v7_0_1b.threshold_monitor_hidden.threshold_monitor.interface.policy.area', u'area'), ('pybind.slxos.v16r_1_00b.threshold_monitor_hidden.threshold_monitor.interface.policy', u'policy'), ('pybind.slxos.v16r_1_00b.threshold_monitor_hidden.threshold_monitor.interface.policy.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2c.threshold_monitor_hidden.threshold_monitor.interface.policy.area.alert.above', 'pybind.nos.v6_0_2c.brocade_threshold_monitor', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.threshold_monitor_hidden.threshold_monitor.interface.policy.area.alert.above', 'pybind.nos.v7_0_1b.brocade_threshold_monitor', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.threshold_monitor_hidden.threshold_monitor.interface.policy.area.alert.above', 'pybind.nos.v7_1_0.brocade_threshold_monitor', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.threshold_monitor_hidden.threshold_monitor.interface.policy.area.alert.above', 'pybind.slxos.v16r_1_00b.brocade_threshold_monitor', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'highthresh-action'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy=policy, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def threshold_monitor_interface_policy_area_alert_above_lowthresh_action_delete(self, policy=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy: policy_name
    :param policy: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **policy** tuple argument.

    :type area: type, area_value
    :param area: Keyword argument tuple.

    :type type: unicode
    :param type: **area** tuple argument:  Interface types that can be configured independent of speed

        * enumeration restriction: ::

            ['Ethernet']

    :type area_value: unicode
    :param area_value: **area** tuple argument.

        * enumeration restriction: ::

            ['MissingTerminationCharacter',
            'CRCAlignErrors',
            'IFG',
            'SymbolErrors']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.threshold_monitor_hidden.threshold_monitor.interface.policy', u'policy'), ('pybind.nos.v6_0_2c.threshold_monitor_hidden.threshold_monitor.interface.policy.area', u'area'), ('pybind.nos.v7_1_0.threshold_monitor_hidden.threshold_monitor.interface.policy', u'policy'), ('pybind.nos.v7_1_0.threshold_monitor_hidden.threshold_monitor.interface.policy.area', u'area'), ('pybind.nos.v7_0_1b.threshold_monitor_hidden.threshold_monitor.interface.policy', u'policy'), ('pybind.nos.v7_0_1b.threshold_monitor_hidden.threshold_monitor.interface.policy.area', u'area'), ('pybind.slxos.v16r_1_00b.threshold_monitor_hidden.threshold_monitor.interface.policy', u'policy'), ('pybind.slxos.v16r_1_00b.threshold_monitor_hidden.threshold_monitor.interface.policy.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2c.threshold_monitor_hidden.threshold_monitor.interface.policy.area.alert.above', 'pybind.nos.v6_0_2c.brocade_threshold_monitor', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.threshold_monitor_hidden.threshold_monitor.interface.policy.area.alert.above', 'pybind.nos.v7_0_1b.brocade_threshold_monitor', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.threshold_monitor_hidden.threshold_monitor.interface.policy.area.alert.above', 'pybind.nos.v7_1_0.brocade_threshold_monitor', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.threshold_monitor_hidden.threshold_monitor.interface.policy.area.alert.above', 'pybind.slxos.v16r_1_00b.brocade_threshold_monitor', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lowthresh-action'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy=policy, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def threshold_monitor_interface_policy_area_alert_below_highthresh_action_delete(self, policy=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy: policy_name
    :param policy: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **policy** tuple argument.

    :type area: type, area_value
    :param area: Keyword argument tuple.

    :type type: unicode
    :param type: **area** tuple argument:  Interface types that can be configured independent of speed

        * enumeration restriction: ::

            ['Ethernet']

    :type area_value: unicode
    :param area_value: **area** tuple argument.

        * enumeration restriction: ::

            ['MissingTerminationCharacter',
            'CRCAlignErrors',
            'IFG',
            'SymbolErrors']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.threshold_monitor_hidden.threshold_monitor.interface.policy', u'policy'), ('pybind.nos.v7_0_1b.threshold_monitor_hidden.threshold_monitor.interface.policy.area', u'area'), ('pybind.slxos.v16r_1_00b.threshold_monitor_hidden.threshold_monitor.interface.policy', u'policy'), ('pybind.slxos.v16r_1_00b.threshold_monitor_hidden.threshold_monitor.interface.policy.area', u'area'), ('pybind.nos.v7_1_0.threshold_monitor_hidden.threshold_monitor.interface.policy', u'policy'), ('pybind.nos.v7_1_0.threshold_monitor_hidden.threshold_monitor.interface.policy.area', u'area'), ('pybind.nos.v6_0_2c.threshold_monitor_hidden.threshold_monitor.interface.policy', u'policy'), ('pybind.nos.v6_0_2c.threshold_monitor_hidden.threshold_monitor.interface.policy.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2c.threshold_monitor_hidden.threshold_monitor.interface.policy.area.alert.below', 'pybind.nos.v6_0_2c.brocade_threshold_monitor', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.threshold_monitor_hidden.threshold_monitor.interface.policy.area.alert.below', 'pybind.nos.v7_0_1b.brocade_threshold_monitor', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.threshold_monitor_hidden.threshold_monitor.interface.policy.area.alert.below', 'pybind.nos.v7_1_0.brocade_threshold_monitor', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.threshold_monitor_hidden.threshold_monitor.interface.policy.area.alert.below', 'pybind.slxos.v16r_1_00b.brocade_threshold_monitor', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'highthresh-action'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy=policy, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def threshold_monitor_interface_policy_area_alert_below_lowthresh_action_delete(self, policy=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy: policy_name
    :param policy: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **policy** tuple argument.

    :type area: type, area_value
    :param area: Keyword argument tuple.

    :type type: unicode
    :param type: **area** tuple argument:  Interface types that can be configured independent of speed

        * enumeration restriction: ::

            ['Ethernet']

    :type area_value: unicode
    :param area_value: **area** tuple argument.

        * enumeration restriction: ::

            ['MissingTerminationCharacter',
            'CRCAlignErrors',
            'IFG',
            'SymbolErrors']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.threshold_monitor_hidden.threshold_monitor.interface.policy', u'policy'), ('pybind.nos.v7_0_1b.threshold_monitor_hidden.threshold_monitor.interface.policy.area', u'area'), ('pybind.slxos.v16r_1_00b.threshold_monitor_hidden.threshold_monitor.interface.policy', u'policy'), ('pybind.slxos.v16r_1_00b.threshold_monitor_hidden.threshold_monitor.interface.policy.area', u'area'), ('pybind.nos.v7_1_0.threshold_monitor_hidden.threshold_monitor.interface.policy', u'policy'), ('pybind.nos.v7_1_0.threshold_monitor_hidden.threshold_monitor.interface.policy.area', u'area'), ('pybind.nos.v6_0_2c.threshold_monitor_hidden.threshold_monitor.interface.policy', u'policy'), ('pybind.nos.v6_0_2c.threshold_monitor_hidden.threshold_monitor.interface.policy.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2c.threshold_monitor_hidden.threshold_monitor.interface.policy.area.alert.below', 'pybind.nos.v6_0_2c.brocade_threshold_monitor', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.threshold_monitor_hidden.threshold_monitor.interface.policy.area.alert.below', 'pybind.nos.v7_0_1b.brocade_threshold_monitor', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.threshold_monitor_hidden.threshold_monitor.interface.policy.area.alert.below', 'pybind.nos.v7_1_0.brocade_threshold_monitor', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.threshold_monitor_hidden.threshold_monitor.interface.policy.area.alert.below', 'pybind.slxos.v16r_1_00b.brocade_threshold_monitor', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lowthresh-action'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy=policy, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def threshold_monitor_interface_policy_area_threshold_buffer_delete(self, policy=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy: policy_name
    :param policy: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **policy** tuple argument.

    :type area: type, area_value
    :param area: Keyword argument tuple.

    :type type: unicode
    :param type: **area** tuple argument:  Interface types that can be configured independent of speed

        * enumeration restriction: ::

            ['Ethernet']

    :type area_value: unicode
    :param area_value: **area** tuple argument.

        * enumeration restriction: ::

            ['MissingTerminationCharacter',
            'CRCAlignErrors',
            'IFG',
            'SymbolErrors']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.threshold_monitor_hidden.threshold_monitor.interface.policy', u'policy'), ('pybind.slxos.v16r_1_00b.threshold_monitor_hidden.threshold_monitor.interface.policy.area', u'area'), ('pybind.nos.v6_0_2c.threshold_monitor_hidden.threshold_monitor.interface.policy', u'policy'), ('pybind.nos.v6_0_2c.threshold_monitor_hidden.threshold_monitor.interface.policy.area', u'area'), ('pybind.nos.v7_0_1b.threshold_monitor_hidden.threshold_monitor.interface.policy', u'policy'), ('pybind.nos.v7_0_1b.threshold_monitor_hidden.threshold_monitor.interface.policy.area', u'area'), ('pybind.nos.v7_1_0.threshold_monitor_hidden.threshold_monitor.interface.policy', u'policy'), ('pybind.nos.v7_1_0.threshold_monitor_hidden.threshold_monitor.interface.policy.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2c.threshold_monitor_hidden.threshold_monitor.interface.policy.area.threshold', 'pybind.nos.v6_0_2c.brocade_threshold_monitor', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.threshold_monitor_hidden.threshold_monitor.interface.policy.area.threshold', 'pybind.nos.v7_0_1b.brocade_threshold_monitor', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.threshold_monitor_hidden.threshold_monitor.interface.policy.area.threshold', 'pybind.nos.v7_1_0.brocade_threshold_monitor', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.threshold_monitor_hidden.threshold_monitor.interface.policy.area.threshold', 'pybind.slxos.v16r_1_00b.brocade_threshold_monitor', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'buffer'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy=policy, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def threshold_monitor_interface_policy_area_threshold_high_threshold_delete(self, policy=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy: policy_name
    :param policy: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **policy** tuple argument.

    :type area: type, area_value
    :param area: Keyword argument tuple.

    :type type: unicode
    :param type: **area** tuple argument:  Interface types that can be configured independent of speed

        * enumeration restriction: ::

            ['Ethernet']

    :type area_value: unicode
    :param area_value: **area** tuple argument.

        * enumeration restriction: ::

            ['MissingTerminationCharacter',
            'CRCAlignErrors',
            'IFG',
            'SymbolErrors']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.threshold_monitor_hidden.threshold_monitor.interface.policy', u'policy'), ('pybind.slxos.v16r_1_00b.threshold_monitor_hidden.threshold_monitor.interface.policy.area', u'area'), ('pybind.nos.v6_0_2c.threshold_monitor_hidden.threshold_monitor.interface.policy', u'policy'), ('pybind.nos.v6_0_2c.threshold_monitor_hidden.threshold_monitor.interface.policy.area', u'area'), ('pybind.nos.v7_0_1b.threshold_monitor_hidden.threshold_monitor.interface.policy', u'policy'), ('pybind.nos.v7_0_1b.threshold_monitor_hidden.threshold_monitor.interface.policy.area', u'area'), ('pybind.nos.v7_1_0.threshold_monitor_hidden.threshold_monitor.interface.policy', u'policy'), ('pybind.nos.v7_1_0.threshold_monitor_hidden.threshold_monitor.interface.policy.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2c.threshold_monitor_hidden.threshold_monitor.interface.policy.area.threshold', 'pybind.nos.v6_0_2c.brocade_threshold_monitor', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.threshold_monitor_hidden.threshold_monitor.interface.policy.area.threshold', 'pybind.nos.v7_0_1b.brocade_threshold_monitor', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.threshold_monitor_hidden.threshold_monitor.interface.policy.area.threshold', 'pybind.nos.v7_1_0.brocade_threshold_monitor', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.threshold_monitor_hidden.threshold_monitor.interface.policy.area.threshold', 'pybind.slxos.v16r_1_00b.brocade_threshold_monitor', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'high-threshold'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy=policy, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def threshold_monitor_interface_policy_area_threshold_low_threshold_delete(self, policy=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy: policy_name
    :param policy: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **policy** tuple argument.

    :type area: type, area_value
    :param area: Keyword argument tuple.

    :type type: unicode
    :param type: **area** tuple argument:  Interface types that can be configured independent of speed

        * enumeration restriction: ::

            ['Ethernet']

    :type area_value: unicode
    :param area_value: **area** tuple argument.

        * enumeration restriction: ::

            ['MissingTerminationCharacter',
            'CRCAlignErrors',
            'IFG',
            'SymbolErrors']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.threshold_monitor_hidden.threshold_monitor.interface.policy', u'policy'), ('pybind.slxos.v16r_1_00b.threshold_monitor_hidden.threshold_monitor.interface.policy.area', u'area'), ('pybind.nos.v6_0_2c.threshold_monitor_hidden.threshold_monitor.interface.policy', u'policy'), ('pybind.nos.v6_0_2c.threshold_monitor_hidden.threshold_monitor.interface.policy.area', u'area'), ('pybind.nos.v7_0_1b.threshold_monitor_hidden.threshold_monitor.interface.policy', u'policy'), ('pybind.nos.v7_0_1b.threshold_monitor_hidden.threshold_monitor.interface.policy.area', u'area'), ('pybind.nos.v7_1_0.threshold_monitor_hidden.threshold_monitor.interface.policy', u'policy'), ('pybind.nos.v7_1_0.threshold_monitor_hidden.threshold_monitor.interface.policy.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2c.threshold_monitor_hidden.threshold_monitor.interface.policy.area.threshold', 'pybind.nos.v6_0_2c.brocade_threshold_monitor', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.threshold_monitor_hidden.threshold_monitor.interface.policy.area.threshold', 'pybind.nos.v7_0_1b.brocade_threshold_monitor', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.threshold_monitor_hidden.threshold_monitor.interface.policy.area.threshold', 'pybind.nos.v7_1_0.brocade_threshold_monitor', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.threshold_monitor_hidden.threshold_monitor.interface.policy.area.threshold', 'pybind.slxos.v16r_1_00b.brocade_threshold_monitor', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'low-threshold'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy=policy, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def threshold_monitor_interface_policy_area_threshold_timebase_delete(self, policy=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy: policy_name
    :param policy: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **policy** tuple argument.

    :type area: type, area_value
    :param area: Keyword argument tuple.

    :type type: unicode
    :param type: **area** tuple argument:  Interface types that can be configured independent of speed

        * enumeration restriction: ::

            ['Ethernet']

    :type area_value: unicode
    :param area_value: **area** tuple argument.

        * enumeration restriction: ::

            ['MissingTerminationCharacter',
            'CRCAlignErrors',
            'IFG',
            'SymbolErrors']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.threshold_monitor_hidden.threshold_monitor.interface.policy', u'policy'), ('pybind.slxos.v16r_1_00b.threshold_monitor_hidden.threshold_monitor.interface.policy.area', u'area'), ('pybind.nos.v6_0_2c.threshold_monitor_hidden.threshold_monitor.interface.policy', u'policy'), ('pybind.nos.v6_0_2c.threshold_monitor_hidden.threshold_monitor.interface.policy.area', u'area'), ('pybind.nos.v7_0_1b.threshold_monitor_hidden.threshold_monitor.interface.policy', u'policy'), ('pybind.nos.v7_0_1b.threshold_monitor_hidden.threshold_monitor.interface.policy.area', u'area'), ('pybind.nos.v7_1_0.threshold_monitor_hidden.threshold_monitor.interface.policy', u'policy'), ('pybind.nos.v7_1_0.threshold_monitor_hidden.threshold_monitor.interface.policy.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2c.threshold_monitor_hidden.threshold_monitor.interface.policy.area.threshold', 'pybind.nos.v6_0_2c.brocade_threshold_monitor', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.threshold_monitor_hidden.threshold_monitor.interface.policy.area.threshold', 'pybind.nos.v7_0_1b.brocade_threshold_monitor', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.threshold_monitor_hidden.threshold_monitor.interface.policy.area.threshold', 'pybind.nos.v7_1_0.brocade_threshold_monitor', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.threshold_monitor_hidden.threshold_monitor.interface.policy.area.threshold', 'pybind.slxos.v16r_1_00b.brocade_threshold_monitor', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'timebase'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy=policy, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def threshold_monitor_memory_actions_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.threshold_monitor_hidden.threshold_monitor.Memory', 'pybind.nos.v6_0_2c.brocade_threshold_monitor', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.threshold_monitor_hidden.threshold_monitor.Memory', 'pybind.nos.v7_0_1b.brocade_threshold_monitor', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.threshold_monitor_hidden.threshold_monitor.Memory', 'pybind.nos.v7_1_0.brocade_threshold_monitor', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.threshold_monitor_hidden.threshold_monitor.Memory', 'pybind.slxos.v16r_1_00b.brocade_threshold_monitor', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'actions'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def threshold_monitor_memory_high_limit_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.threshold_monitor_hidden.threshold_monitor.Memory', 'pybind.nos.v6_0_2c.brocade_threshold_monitor', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.threshold_monitor_hidden.threshold_monitor.Memory', 'pybind.nos.v7_0_1b.brocade_threshold_monitor', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.threshold_monitor_hidden.threshold_monitor.Memory', 'pybind.nos.v7_1_0.brocade_threshold_monitor', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.threshold_monitor_hidden.threshold_monitor.Memory', 'pybind.slxos.v16r_1_00b.brocade_threshold_monitor', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'high-limit'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def threshold_monitor_memory_limit_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.threshold_monitor_hidden.threshold_monitor.Memory', 'pybind.nos.v6_0_2c.brocade_threshold_monitor', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.threshold_monitor_hidden.threshold_monitor.Memory', 'pybind.nos.v7_0_1b.brocade_threshold_monitor', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.threshold_monitor_hidden.threshold_monitor.Memory', 'pybind.nos.v7_1_0.brocade_threshold_monitor', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.threshold_monitor_hidden.threshold_monitor.Memory', 'pybind.slxos.v16r_1_00b.brocade_threshold_monitor', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'limit'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def threshold_monitor_memory_low_limit_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.threshold_monitor_hidden.threshold_monitor.Memory', 'pybind.nos.v6_0_2c.brocade_threshold_monitor', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.threshold_monitor_hidden.threshold_monitor.Memory', 'pybind.nos.v7_0_1b.brocade_threshold_monitor', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.threshold_monitor_hidden.threshold_monitor.Memory', 'pybind.nos.v7_1_0.brocade_threshold_monitor', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.threshold_monitor_hidden.threshold_monitor.Memory', 'pybind.slxos.v16r_1_00b.brocade_threshold_monitor', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'low-limit'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def threshold_monitor_memory_poll_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.threshold_monitor_hidden.threshold_monitor.Memory', 'pybind.nos.v6_0_2c.brocade_threshold_monitor', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.threshold_monitor_hidden.threshold_monitor.Memory', 'pybind.nos.v7_0_1b.brocade_threshold_monitor', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.threshold_monitor_hidden.threshold_monitor.Memory', 'pybind.nos.v7_1_0.brocade_threshold_monitor', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.threshold_monitor_hidden.threshold_monitor.Memory', 'pybind.slxos.v16r_1_00b.brocade_threshold_monitor', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'poll'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def threshold_monitor_memory_retry_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.threshold_monitor_hidden.threshold_monitor.Memory', 'pybind.nos.v6_0_2c.brocade_threshold_monitor', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.threshold_monitor_hidden.threshold_monitor.Memory', 'pybind.nos.v7_0_1b.brocade_threshold_monitor', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.threshold_monitor_hidden.threshold_monitor.Memory', 'pybind.nos.v7_1_0.brocade_threshold_monitor', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.threshold_monitor_hidden.threshold_monitor.Memory', 'pybind.slxos.v16r_1_00b.brocade_threshold_monitor', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'retry'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def threshold_monitor_security_apply_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.threshold_monitor_hidden.threshold_monitor.security', 'pybind.nos.v6_0_2c.brocade_threshold_monitor', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.threshold_monitor_hidden.threshold_monitor.security', 'pybind.nos.v7_0_1b.brocade_threshold_monitor', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.threshold_monitor_hidden.threshold_monitor.security', 'pybind.nos.v7_1_0.brocade_threshold_monitor', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.threshold_monitor_hidden.threshold_monitor.security', 'pybind.slxos.v16r_1_00b.brocade_threshold_monitor', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'apply'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def threshold_monitor_security_pause_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.threshold_monitor_hidden.threshold_monitor.security', 'pybind.nos.v6_0_2c.brocade_threshold_monitor', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.threshold_monitor_hidden.threshold_monitor.security', 'pybind.nos.v7_0_1b.brocade_threshold_monitor', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.threshold_monitor_hidden.threshold_monitor.security', 'pybind.nos.v7_1_0.brocade_threshold_monitor', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.threshold_monitor_hidden.threshold_monitor.security', 'pybind.slxos.v16r_1_00b.brocade_threshold_monitor', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'pause'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def threshold_monitor_security_policy_area_alert_above_highthresh_action_delete(self, policy=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy: sec_policy_name
    :param policy: Keyword argument tuple.

    :type sec_policy_name: unicode
    :param sec_policy_name: **policy** tuple argument.

    :type area: sec_area_value
    :param area: Keyword argument tuple.

    :type sec_area_value: unicode
    :param sec_area_value: **area** tuple argument:  Security Areas

        * enumeration restriction: ::

            ['telnet-violation', 'login-violation']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.threshold_monitor_hidden.threshold_monitor.security.policy', u'policy'), ('pybind.nos.v7_1_0.threshold_monitor_hidden.threshold_monitor.security.policy.area', u'area'), ('pybind.slxos.v16r_1_00b.threshold_monitor_hidden.threshold_monitor.security.policy', u'policy'), ('pybind.slxos.v16r_1_00b.threshold_monitor_hidden.threshold_monitor.security.policy.area', u'area'), ('pybind.nos.v6_0_2c.threshold_monitor_hidden.threshold_monitor.security.policy', u'policy'), ('pybind.nos.v6_0_2c.threshold_monitor_hidden.threshold_monitor.security.policy.area', u'area'), ('pybind.nos.v7_0_1b.threshold_monitor_hidden.threshold_monitor.security.policy', u'policy'), ('pybind.nos.v7_0_1b.threshold_monitor_hidden.threshold_monitor.security.policy.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2c.threshold_monitor_hidden.threshold_monitor.security.policy.area.alert.above', 'pybind.nos.v6_0_2c.brocade_threshold_monitor', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.threshold_monitor_hidden.threshold_monitor.security.policy.area.alert.above', 'pybind.nos.v7_0_1b.brocade_threshold_monitor', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.threshold_monitor_hidden.threshold_monitor.security.policy.area.alert.above', 'pybind.nos.v7_1_0.brocade_threshold_monitor', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.threshold_monitor_hidden.threshold_monitor.security.policy.area.alert.above', 'pybind.slxos.v16r_1_00b.brocade_threshold_monitor', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'highthresh-action'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy=policy, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def threshold_monitor_security_policy_area_alert_below_highthresh_action_delete(self, policy=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy: sec_policy_name
    :param policy: Keyword argument tuple.

    :type sec_policy_name: unicode
    :param sec_policy_name: **policy** tuple argument.

    :type area: sec_area_value
    :param area: Keyword argument tuple.

    :type sec_area_value: unicode
    :param sec_area_value: **area** tuple argument:  Security Areas

        * enumeration restriction: ::

            ['telnet-violation', 'login-violation']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.threshold_monitor_hidden.threshold_monitor.security.policy', u'policy'), ('pybind.nos.v7_1_0.threshold_monitor_hidden.threshold_monitor.security.policy.area', u'area'), ('pybind.nos.v7_0_1b.threshold_monitor_hidden.threshold_monitor.security.policy', u'policy'), ('pybind.nos.v7_0_1b.threshold_monitor_hidden.threshold_monitor.security.policy.area', u'area'), ('pybind.nos.v6_0_2c.threshold_monitor_hidden.threshold_monitor.security.policy', u'policy'), ('pybind.nos.v6_0_2c.threshold_monitor_hidden.threshold_monitor.security.policy.area', u'area'), ('pybind.slxos.v16r_1_00b.threshold_monitor_hidden.threshold_monitor.security.policy', u'policy'), ('pybind.slxos.v16r_1_00b.threshold_monitor_hidden.threshold_monitor.security.policy.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2c.threshold_monitor_hidden.threshold_monitor.security.policy.area.alert.below', 'pybind.nos.v6_0_2c.brocade_threshold_monitor', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.threshold_monitor_hidden.threshold_monitor.security.policy.area.alert.below', 'pybind.nos.v7_0_1b.brocade_threshold_monitor', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.threshold_monitor_hidden.threshold_monitor.security.policy.area.alert.below', 'pybind.nos.v7_1_0.brocade_threshold_monitor', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.threshold_monitor_hidden.threshold_monitor.security.policy.area.alert.below', 'pybind.slxos.v16r_1_00b.brocade_threshold_monitor', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'highthresh-action'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy=policy, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def threshold_monitor_security_policy_area_alert_below_lowthresh_action_delete(self, policy=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy: sec_policy_name
    :param policy: Keyword argument tuple.

    :type sec_policy_name: unicode
    :param sec_policy_name: **policy** tuple argument.

    :type area: sec_area_value
    :param area: Keyword argument tuple.

    :type sec_area_value: unicode
    :param sec_area_value: **area** tuple argument:  Security Areas

        * enumeration restriction: ::

            ['telnet-violation', 'login-violation']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.threshold_monitor_hidden.threshold_monitor.security.policy', u'policy'), ('pybind.nos.v7_1_0.threshold_monitor_hidden.threshold_monitor.security.policy.area', u'area'), ('pybind.nos.v7_0_1b.threshold_monitor_hidden.threshold_monitor.security.policy', u'policy'), ('pybind.nos.v7_0_1b.threshold_monitor_hidden.threshold_monitor.security.policy.area', u'area'), ('pybind.nos.v6_0_2c.threshold_monitor_hidden.threshold_monitor.security.policy', u'policy'), ('pybind.nos.v6_0_2c.threshold_monitor_hidden.threshold_monitor.security.policy.area', u'area'), ('pybind.slxos.v16r_1_00b.threshold_monitor_hidden.threshold_monitor.security.policy', u'policy'), ('pybind.slxos.v16r_1_00b.threshold_monitor_hidden.threshold_monitor.security.policy.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2c.threshold_monitor_hidden.threshold_monitor.security.policy.area.alert.below', 'pybind.nos.v6_0_2c.brocade_threshold_monitor', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.threshold_monitor_hidden.threshold_monitor.security.policy.area.alert.below', 'pybind.nos.v7_0_1b.brocade_threshold_monitor', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.threshold_monitor_hidden.threshold_monitor.security.policy.area.alert.below', 'pybind.nos.v7_1_0.brocade_threshold_monitor', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.threshold_monitor_hidden.threshold_monitor.security.policy.area.alert.below', 'pybind.slxos.v16r_1_00b.brocade_threshold_monitor', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lowthresh-action'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy=policy, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def threshold_monitor_security_policy_area_threshold_buffer_delete(self, policy=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy: sec_policy_name
    :param policy: Keyword argument tuple.

    :type sec_policy_name: unicode
    :param sec_policy_name: **policy** tuple argument.

    :type area: sec_area_value
    :param area: Keyword argument tuple.

    :type sec_area_value: unicode
    :param sec_area_value: **area** tuple argument:  Security Areas

        * enumeration restriction: ::

            ['telnet-violation', 'login-violation']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.threshold_monitor_hidden.threshold_monitor.security.policy', u'policy'), ('pybind.slxos.v16r_1_00b.threshold_monitor_hidden.threshold_monitor.security.policy.area', u'area'), ('pybind.nos.v7_1_0.threshold_monitor_hidden.threshold_monitor.security.policy', u'policy'), ('pybind.nos.v7_1_0.threshold_monitor_hidden.threshold_monitor.security.policy.area', u'area'), ('pybind.nos.v7_0_1b.threshold_monitor_hidden.threshold_monitor.security.policy', u'policy'), ('pybind.nos.v7_0_1b.threshold_monitor_hidden.threshold_monitor.security.policy.area', u'area'), ('pybind.nos.v6_0_2c.threshold_monitor_hidden.threshold_monitor.security.policy', u'policy'), ('pybind.nos.v6_0_2c.threshold_monitor_hidden.threshold_monitor.security.policy.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2c.threshold_monitor_hidden.threshold_monitor.security.policy.area.threshold', 'pybind.nos.v6_0_2c.brocade_threshold_monitor', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.threshold_monitor_hidden.threshold_monitor.security.policy.area.threshold', 'pybind.nos.v7_0_1b.brocade_threshold_monitor', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.threshold_monitor_hidden.threshold_monitor.security.policy.area.threshold', 'pybind.nos.v7_1_0.brocade_threshold_monitor', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.threshold_monitor_hidden.threshold_monitor.security.policy.area.threshold', 'pybind.slxos.v16r_1_00b.brocade_threshold_monitor', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'buffer'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy=policy, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def threshold_monitor_security_policy_area_threshold_high_threshold_delete(self, policy=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy: sec_policy_name
    :param policy: Keyword argument tuple.

    :type sec_policy_name: unicode
    :param sec_policy_name: **policy** tuple argument.

    :type area: sec_area_value
    :param area: Keyword argument tuple.

    :type sec_area_value: unicode
    :param sec_area_value: **area** tuple argument:  Security Areas

        * enumeration restriction: ::

            ['telnet-violation', 'login-violation']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.threshold_monitor_hidden.threshold_monitor.security.policy', u'policy'), ('pybind.slxos.v16r_1_00b.threshold_monitor_hidden.threshold_monitor.security.policy.area', u'area'), ('pybind.nos.v7_1_0.threshold_monitor_hidden.threshold_monitor.security.policy', u'policy'), ('pybind.nos.v7_1_0.threshold_monitor_hidden.threshold_monitor.security.policy.area', u'area'), ('pybind.nos.v7_0_1b.threshold_monitor_hidden.threshold_monitor.security.policy', u'policy'), ('pybind.nos.v7_0_1b.threshold_monitor_hidden.threshold_monitor.security.policy.area', u'area'), ('pybind.nos.v6_0_2c.threshold_monitor_hidden.threshold_monitor.security.policy', u'policy'), ('pybind.nos.v6_0_2c.threshold_monitor_hidden.threshold_monitor.security.policy.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2c.threshold_monitor_hidden.threshold_monitor.security.policy.area.threshold', 'pybind.nos.v6_0_2c.brocade_threshold_monitor', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.threshold_monitor_hidden.threshold_monitor.security.policy.area.threshold', 'pybind.nos.v7_0_1b.brocade_threshold_monitor', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.threshold_monitor_hidden.threshold_monitor.security.policy.area.threshold', 'pybind.nos.v7_1_0.brocade_threshold_monitor', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.threshold_monitor_hidden.threshold_monitor.security.policy.area.threshold', 'pybind.slxos.v16r_1_00b.brocade_threshold_monitor', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'high-threshold'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy=policy, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def threshold_monitor_security_policy_area_threshold_low_threshold_delete(self, policy=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy: sec_policy_name
    :param policy: Keyword argument tuple.

    :type sec_policy_name: unicode
    :param sec_policy_name: **policy** tuple argument.

    :type area: sec_area_value
    :param area: Keyword argument tuple.

    :type sec_area_value: unicode
    :param sec_area_value: **area** tuple argument:  Security Areas

        * enumeration restriction: ::

            ['telnet-violation', 'login-violation']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.threshold_monitor_hidden.threshold_monitor.security.policy', u'policy'), ('pybind.slxos.v16r_1_00b.threshold_monitor_hidden.threshold_monitor.security.policy.area', u'area'), ('pybind.nos.v7_1_0.threshold_monitor_hidden.threshold_monitor.security.policy', u'policy'), ('pybind.nos.v7_1_0.threshold_monitor_hidden.threshold_monitor.security.policy.area', u'area'), ('pybind.nos.v7_0_1b.threshold_monitor_hidden.threshold_monitor.security.policy', u'policy'), ('pybind.nos.v7_0_1b.threshold_monitor_hidden.threshold_monitor.security.policy.area', u'area'), ('pybind.nos.v6_0_2c.threshold_monitor_hidden.threshold_monitor.security.policy', u'policy'), ('pybind.nos.v6_0_2c.threshold_monitor_hidden.threshold_monitor.security.policy.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2c.threshold_monitor_hidden.threshold_monitor.security.policy.area.threshold', 'pybind.nos.v6_0_2c.brocade_threshold_monitor', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.threshold_monitor_hidden.threshold_monitor.security.policy.area.threshold', 'pybind.nos.v7_0_1b.brocade_threshold_monitor', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.threshold_monitor_hidden.threshold_monitor.security.policy.area.threshold', 'pybind.nos.v7_1_0.brocade_threshold_monitor', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.threshold_monitor_hidden.threshold_monitor.security.policy.area.threshold', 'pybind.slxos.v16r_1_00b.brocade_threshold_monitor', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'low-threshold'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy=policy, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def threshold_monitor_security_policy_area_timebase_delete(self, policy=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy: sec_policy_name
    :param policy: Keyword argument tuple.

    :type sec_policy_name: unicode
    :param sec_policy_name: **policy** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type area: sec_area_value
    :param area: Keyword argument tuple.

    :type sec_area_value: unicode
    :param sec_area_value: **area** tuple argument:  Security Areas

        * enumeration restriction: ::

            ['telnet-violation', 'login-violation']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.threshold_monitor_hidden.threshold_monitor.security.policy', u'policy'), ('pybind.nos.v6_0_2c.threshold_monitor_hidden.threshold_monitor.security.policy', u'policy'), ('pybind.nos.v7_0_1b.threshold_monitor_hidden.threshold_monitor.security.policy', u'policy'), ('pybind.slxos.v16r_1_00b.threshold_monitor_hidden.threshold_monitor.security.policy', u'policy')]
    bindings_list = [('pybind.nos.v6_0_2c.threshold_monitor_hidden.threshold_monitor.security.policy.area', 'pybind.nos.v6_0_2c.brocade_threshold_monitor', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.threshold_monitor_hidden.threshold_monitor.security.policy.area', 'pybind.nos.v7_0_1b.brocade_threshold_monitor', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.threshold_monitor_hidden.threshold_monitor.security.policy.area', 'pybind.nos.v7_1_0.brocade_threshold_monitor', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.threshold_monitor_hidden.threshold_monitor.security.policy.area', 'pybind.slxos.v16r_1_00b.brocade_threshold_monitor', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}]
    bindings_keyval = {'kwargs_key_name': u'area', 'keyval': 'sec_area_value', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'timebase'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy=policy, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def threshold_monitor_sfp_apply_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.threshold_monitor_hidden.threshold_monitor.sfp', 'pybind.nos.v6_0_2c.brocade_threshold_monitor', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.threshold_monitor_hidden.threshold_monitor.sfp', 'pybind.nos.v7_0_1b.brocade_threshold_monitor', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.threshold_monitor_hidden.threshold_monitor.sfp', 'pybind.nos.v7_1_0.brocade_threshold_monitor', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.threshold_monitor_hidden.threshold_monitor.sfp', 'pybind.slxos.v16r_1_00b.brocade_threshold_monitor', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'apply'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def threshold_monitor_sfp_pause_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.threshold_monitor_hidden.threshold_monitor.sfp', 'pybind.nos.v6_0_2c.brocade_threshold_monitor', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.threshold_monitor_hidden.threshold_monitor.sfp', 'pybind.nos.v7_0_1b.brocade_threshold_monitor', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.threshold_monitor_hidden.threshold_monitor.sfp', 'pybind.nos.v7_1_0.brocade_threshold_monitor', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.threshold_monitor_hidden.threshold_monitor.sfp', 'pybind.slxos.v16r_1_00b.brocade_threshold_monitor', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'pause'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def threshold_monitor_sfp_policy_area_alert_above_highthresh_action_delete(self, policy=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy: policy_name
    :param policy: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **policy** tuple argument.

    :type area: type, area_value
    :param area: Keyword argument tuple.

    :type type: unicode
    :param type: **area** tuple argument:  SFP types that can be configured

        * enumeration restriction: ::

            ['10GLR',
            '1GLR',
            '100GSR',
            '10GUSR',
            '1GSR',
            '10GSR',
            'QSFP']

    :type area_value: unicode
    :param area_value: **area** tuple argument.

        * enumeration restriction: ::

            ['Current',
            'RXP',
            'TXP',
            'Voltage',
            'Temperature']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.threshold_monitor_hidden.threshold_monitor.sfp.policy', u'policy'), ('pybind.nos.v7_1_0.threshold_monitor_hidden.threshold_monitor.sfp.policy.area', u'area'), ('pybind.slxos.v16r_1_00b.threshold_monitor_hidden.threshold_monitor.sfp.policy', u'policy'), ('pybind.slxos.v16r_1_00b.threshold_monitor_hidden.threshold_monitor.sfp.policy.area', u'area'), ('pybind.nos.v7_0_1b.threshold_monitor_hidden.threshold_monitor.sfp.policy', u'policy'), ('pybind.nos.v7_0_1b.threshold_monitor_hidden.threshold_monitor.sfp.policy.area', u'area'), ('pybind.nos.v6_0_2c.threshold_monitor_hidden.threshold_monitor.sfp.policy', u'policy'), ('pybind.nos.v6_0_2c.threshold_monitor_hidden.threshold_monitor.sfp.policy.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2c.threshold_monitor_hidden.threshold_monitor.sfp.policy.area.alert.above', 'pybind.nos.v6_0_2c.brocade_threshold_monitor', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.threshold_monitor_hidden.threshold_monitor.sfp.policy.area.alert.above', 'pybind.nos.v7_0_1b.brocade_threshold_monitor', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.threshold_monitor_hidden.threshold_monitor.sfp.policy.area.alert.above', 'pybind.nos.v7_1_0.brocade_threshold_monitor', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.threshold_monitor_hidden.threshold_monitor.sfp.policy.area.alert.above', 'pybind.slxos.v16r_1_00b.brocade_threshold_monitor', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'highthresh-action'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy=policy, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def threshold_monitor_sfp_policy_area_alert_below_highthresh_action_delete(self, policy=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy: policy_name
    :param policy: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **policy** tuple argument.

    :type area: type, area_value
    :param area: Keyword argument tuple.

    :type type: unicode
    :param type: **area** tuple argument:  SFP types that can be configured

        * enumeration restriction: ::

            ['10GLR',
            '1GLR',
            '100GSR',
            '10GUSR',
            '1GSR',
            '10GSR',
            'QSFP']

    :type area_value: unicode
    :param area_value: **area** tuple argument.

        * enumeration restriction: ::

            ['Current',
            'RXP',
            'TXP',
            'Voltage',
            'Temperature']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.threshold_monitor_hidden.threshold_monitor.sfp.policy', u'policy'), ('pybind.nos.v7_1_0.threshold_monitor_hidden.threshold_monitor.sfp.policy.area', u'area'), ('pybind.nos.v6_0_2c.threshold_monitor_hidden.threshold_monitor.sfp.policy', u'policy'), ('pybind.nos.v6_0_2c.threshold_monitor_hidden.threshold_monitor.sfp.policy.area', u'area'), ('pybind.nos.v7_0_1b.threshold_monitor_hidden.threshold_monitor.sfp.policy', u'policy'), ('pybind.nos.v7_0_1b.threshold_monitor_hidden.threshold_monitor.sfp.policy.area', u'area'), ('pybind.slxos.v16r_1_00b.threshold_monitor_hidden.threshold_monitor.sfp.policy', u'policy'), ('pybind.slxos.v16r_1_00b.threshold_monitor_hidden.threshold_monitor.sfp.policy.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2c.threshold_monitor_hidden.threshold_monitor.sfp.policy.area.alert.below', 'pybind.nos.v6_0_2c.brocade_threshold_monitor', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.threshold_monitor_hidden.threshold_monitor.sfp.policy.area.alert.below', 'pybind.nos.v7_0_1b.brocade_threshold_monitor', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.threshold_monitor_hidden.threshold_monitor.sfp.policy.area.alert.below', 'pybind.nos.v7_1_0.brocade_threshold_monitor', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.threshold_monitor_hidden.threshold_monitor.sfp.policy.area.alert.below', 'pybind.slxos.v16r_1_00b.brocade_threshold_monitor', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'highthresh-action'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy=policy, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def threshold_monitor_sfp_policy_area_alert_below_lowthresh_action_delete(self, policy=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy: policy_name
    :param policy: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **policy** tuple argument.

    :type area: type, area_value
    :param area: Keyword argument tuple.

    :type type: unicode
    :param type: **area** tuple argument:  SFP types that can be configured

        * enumeration restriction: ::

            ['10GLR',
            '1GLR',
            '100GSR',
            '10GUSR',
            '1GSR',
            '10GSR',
            'QSFP']

    :type area_value: unicode
    :param area_value: **area** tuple argument.

        * enumeration restriction: ::

            ['Current',
            'RXP',
            'TXP',
            'Voltage',
            'Temperature']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.threshold_monitor_hidden.threshold_monitor.sfp.policy', u'policy'), ('pybind.nos.v7_1_0.threshold_monitor_hidden.threshold_monitor.sfp.policy.area', u'area'), ('pybind.nos.v6_0_2c.threshold_monitor_hidden.threshold_monitor.sfp.policy', u'policy'), ('pybind.nos.v6_0_2c.threshold_monitor_hidden.threshold_monitor.sfp.policy.area', u'area'), ('pybind.nos.v7_0_1b.threshold_monitor_hidden.threshold_monitor.sfp.policy', u'policy'), ('pybind.nos.v7_0_1b.threshold_monitor_hidden.threshold_monitor.sfp.policy.area', u'area'), ('pybind.slxos.v16r_1_00b.threshold_monitor_hidden.threshold_monitor.sfp.policy', u'policy'), ('pybind.slxos.v16r_1_00b.threshold_monitor_hidden.threshold_monitor.sfp.policy.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2c.threshold_monitor_hidden.threshold_monitor.sfp.policy.area.alert.below', 'pybind.nos.v6_0_2c.brocade_threshold_monitor', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.threshold_monitor_hidden.threshold_monitor.sfp.policy.area.alert.below', 'pybind.nos.v7_0_1b.brocade_threshold_monitor', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.threshold_monitor_hidden.threshold_monitor.sfp.policy.area.alert.below', 'pybind.nos.v7_1_0.brocade_threshold_monitor', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.threshold_monitor_hidden.threshold_monitor.sfp.policy.area.alert.below', 'pybind.slxos.v16r_1_00b.brocade_threshold_monitor', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'lowthresh-action'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy=policy, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def threshold_monitor_sfp_policy_area_threshold_buffer_delete(self, policy=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy: policy_name
    :param policy: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **policy** tuple argument.

    :type area: type, area_value
    :param area: Keyword argument tuple.

    :type type: unicode
    :param type: **area** tuple argument:  SFP types that can be configured

        * enumeration restriction: ::

            ['10GLR',
            '1GLR',
            '100GSR',
            '10GUSR',
            '1GSR',
            '10GSR',
            'QSFP']

    :type area_value: unicode
    :param area_value: **area** tuple argument.

        * enumeration restriction: ::

            ['Current',
            'RXP',
            'TXP',
            'Voltage',
            'Temperature']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.threshold_monitor_hidden.threshold_monitor.sfp.policy', u'policy'), ('pybind.nos.v7_0_1b.threshold_monitor_hidden.threshold_monitor.sfp.policy.area', u'area'), ('pybind.nos.v6_0_2c.threshold_monitor_hidden.threshold_monitor.sfp.policy', u'policy'), ('pybind.nos.v6_0_2c.threshold_monitor_hidden.threshold_monitor.sfp.policy.area', u'area'), ('pybind.slxos.v16r_1_00b.threshold_monitor_hidden.threshold_monitor.sfp.policy', u'policy'), ('pybind.slxos.v16r_1_00b.threshold_monitor_hidden.threshold_monitor.sfp.policy.area', u'area'), ('pybind.nos.v7_1_0.threshold_monitor_hidden.threshold_monitor.sfp.policy', u'policy'), ('pybind.nos.v7_1_0.threshold_monitor_hidden.threshold_monitor.sfp.policy.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2c.threshold_monitor_hidden.threshold_monitor.sfp.policy.area.threshold', 'pybind.nos.v6_0_2c.brocade_threshold_monitor', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.threshold_monitor_hidden.threshold_monitor.sfp.policy.area.threshold', 'pybind.nos.v7_0_1b.brocade_threshold_monitor', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.threshold_monitor_hidden.threshold_monitor.sfp.policy.area.threshold', 'pybind.nos.v7_1_0.brocade_threshold_monitor', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.threshold_monitor_hidden.threshold_monitor.sfp.policy.area.threshold', 'pybind.slxos.v16r_1_00b.brocade_threshold_monitor', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'buffer'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy=policy, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def threshold_monitor_sfp_policy_area_threshold_high_threshold_delete(self, policy=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy: policy_name
    :param policy: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **policy** tuple argument.

    :type area: type, area_value
    :param area: Keyword argument tuple.

    :type type: unicode
    :param type: **area** tuple argument:  SFP types that can be configured

        * enumeration restriction: ::

            ['10GLR',
            '1GLR',
            '100GSR',
            '10GUSR',
            '1GSR',
            '10GSR',
            'QSFP']

    :type area_value: unicode
    :param area_value: **area** tuple argument.

        * enumeration restriction: ::

            ['Current',
            'RXP',
            'TXP',
            'Voltage',
            'Temperature']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.threshold_monitor_hidden.threshold_monitor.sfp.policy', u'policy'), ('pybind.nos.v7_0_1b.threshold_monitor_hidden.threshold_monitor.sfp.policy.area', u'area'), ('pybind.nos.v6_0_2c.threshold_monitor_hidden.threshold_monitor.sfp.policy', u'policy'), ('pybind.nos.v6_0_2c.threshold_monitor_hidden.threshold_monitor.sfp.policy.area', u'area'), ('pybind.slxos.v16r_1_00b.threshold_monitor_hidden.threshold_monitor.sfp.policy', u'policy'), ('pybind.slxos.v16r_1_00b.threshold_monitor_hidden.threshold_monitor.sfp.policy.area', u'area'), ('pybind.nos.v7_1_0.threshold_monitor_hidden.threshold_monitor.sfp.policy', u'policy'), ('pybind.nos.v7_1_0.threshold_monitor_hidden.threshold_monitor.sfp.policy.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2c.threshold_monitor_hidden.threshold_monitor.sfp.policy.area.threshold', 'pybind.nos.v6_0_2c.brocade_threshold_monitor', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.threshold_monitor_hidden.threshold_monitor.sfp.policy.area.threshold', 'pybind.nos.v7_0_1b.brocade_threshold_monitor', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.threshold_monitor_hidden.threshold_monitor.sfp.policy.area.threshold', 'pybind.nos.v7_1_0.brocade_threshold_monitor', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.threshold_monitor_hidden.threshold_monitor.sfp.policy.area.threshold', 'pybind.slxos.v16r_1_00b.brocade_threshold_monitor', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'high-threshold'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy=policy, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def threshold_monitor_sfp_policy_area_threshold_low_threshold_delete(self, policy=None, area=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy: policy_name
    :param policy: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **policy** tuple argument.

    :type area: type, area_value
    :param area: Keyword argument tuple.

    :type type: unicode
    :param type: **area** tuple argument:  SFP types that can be configured

        * enumeration restriction: ::

            ['10GLR',
            '1GLR',
            '100GSR',
            '10GUSR',
            '1GSR',
            '10GSR',
            'QSFP']

    :type area_value: unicode
    :param area_value: **area** tuple argument.

        * enumeration restriction: ::

            ['Current',
            'RXP',
            'TXP',
            'Voltage',
            'Temperature']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.threshold_monitor_hidden.threshold_monitor.sfp.policy', u'policy'), ('pybind.nos.v7_0_1b.threshold_monitor_hidden.threshold_monitor.sfp.policy.area', u'area'), ('pybind.nos.v6_0_2c.threshold_monitor_hidden.threshold_monitor.sfp.policy', u'policy'), ('pybind.nos.v6_0_2c.threshold_monitor_hidden.threshold_monitor.sfp.policy.area', u'area'), ('pybind.slxos.v16r_1_00b.threshold_monitor_hidden.threshold_monitor.sfp.policy', u'policy'), ('pybind.slxos.v16r_1_00b.threshold_monitor_hidden.threshold_monitor.sfp.policy.area', u'area'), ('pybind.nos.v7_1_0.threshold_monitor_hidden.threshold_monitor.sfp.policy', u'policy'), ('pybind.nos.v7_1_0.threshold_monitor_hidden.threshold_monitor.sfp.policy.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2c.threshold_monitor_hidden.threshold_monitor.sfp.policy.area.threshold', 'pybind.nos.v6_0_2c.brocade_threshold_monitor', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.threshold_monitor_hidden.threshold_monitor.sfp.policy.area.threshold', 'pybind.nos.v7_0_1b.brocade_threshold_monitor', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.threshold_monitor_hidden.threshold_monitor.sfp.policy.area.threshold', 'pybind.nos.v7_1_0.brocade_threshold_monitor', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.threshold_monitor_hidden.threshold_monitor.sfp.policy.area.threshold', 'pybind.slxos.v16r_1_00b.brocade_threshold_monitor', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'low-threshold'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy=policy, area=area)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def tm_state_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.tm_state', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def tm_state_non_empty_voq_delete(self, non_empty_voq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type non_empty_voq: slot_port
    :param non_empty_voq: Keyword argument tuple.

    :type slot_port: unicode
    :param slot_port: **non_empty_voq** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.tm_state.non_empty_voq', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'non_empty_voq', 'keyval': 'slot_port', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, non_empty_voq=non_empty_voq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, non_empty_voq=non_empty_voq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def tm_state_non_empty_voq_voq_id_delete(self, non_empty_voq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type non_empty_voq: slot_port
    :param non_empty_voq: Keyword argument tuple.

    :type slot_port: unicode
    :param slot_port: **non_empty_voq** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.tm_state.non_empty_voq', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'non_empty_voq', 'keyval': 'slot_port', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'voq-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, non_empty_voq=non_empty_voq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, non_empty_voq=non_empty_voq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def tm_state_non_empty_voq_voq_size_delete(self, non_empty_voq=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type non_empty_voq: slot_port
    :param non_empty_voq: Keyword argument tuple.

    :type slot_port: unicode
    :param slot_port: **non_empty_voq** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.tm_state.non_empty_voq', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'non_empty_voq', 'keyval': 'slot_port', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'voq-size'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, non_empty_voq=non_empty_voq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, non_empty_voq=non_empty_voq)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def tm_state_tm_max_buff_util_data_delete(self, tm_max_buff_util_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type tm_max_buff_util_data: slot, tower
    :param tm_max_buff_util_data: Keyword argument tuple.

    :type slot: int
    :param slot: **tm_max_buff_util_data** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type tower: int
    :param tower: **tm_max_buff_util_data** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.tm_state.tm_max_buff_util_data', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tm_max_buff_util_data', 'keyval': 'slot, tower', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tm_max_buff_util_data=tm_max_buff_util_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tm_max_buff_util_data=tm_max_buff_util_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def tm_state_tm_max_buff_util_data_max_buff_size_delete(self, tm_max_buff_util_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type tm_max_buff_util_data: slot, tower
    :param tm_max_buff_util_data: Keyword argument tuple.

    :type slot: int
    :param slot: **tm_max_buff_util_data** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type tower: int
    :param tower: **tm_max_buff_util_data** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.tm_state.tm_max_buff_util_data', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tm_max_buff_util_data', 'keyval': 'slot, tower', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'max-buff-size'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tm_max_buff_util_data=tm_max_buff_util_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tm_max_buff_util_data=tm_max_buff_util_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def tm_state_tm_max_buff_util_data_max_buff_util_delete(self, tm_max_buff_util_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type tm_max_buff_util_data: slot, tower
    :param tm_max_buff_util_data: Keyword argument tuple.

    :type slot: int
    :param slot: **tm_max_buff_util_data** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type tower: int
    :param tower: **tm_max_buff_util_data** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.tm_state.tm_max_buff_util_data', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tm_max_buff_util_data', 'keyval': 'slot, tower', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'max-buff-util'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tm_max_buff_util_data=tm_max_buff_util_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tm_max_buff_util_data=tm_max_buff_util_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def tm_state_tm_top_discard_pkt_data_delete(self, tm_top_discard_pkt_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type tm_top_discard_pkt_data: slot, tower, id
    :param tm_top_discard_pkt_data: Keyword argument tuple.

    :type slot: int
    :param slot: **tm_top_discard_pkt_data** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type tower: int
    :param tower: **tm_top_discard_pkt_data** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type id: int
    :param id: **tm_top_discard_pkt_data** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.tm_state.tm_top_discard_pkt_data', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tm_top_discard_pkt_data', 'keyval': 'slot, tower, id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tm_top_discard_pkt_data=tm_top_discard_pkt_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tm_top_discard_pkt_data=tm_top_discard_pkt_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def tm_state_tm_top_discard_pkt_data_dest_port_delete(self, tm_top_discard_pkt_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type tm_top_discard_pkt_data: slot, tower, id
    :param tm_top_discard_pkt_data: Keyword argument tuple.

    :type slot: int
    :param slot: **tm_top_discard_pkt_data** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type tower: int
    :param tower: **tm_top_discard_pkt_data** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type id: int
    :param id: **tm_top_discard_pkt_data** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.tm_state.tm_top_discard_pkt_data', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tm_top_discard_pkt_data', 'keyval': 'slot, tower, id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dest-port'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tm_top_discard_pkt_data=tm_top_discard_pkt_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tm_top_discard_pkt_data=tm_top_discard_pkt_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def tm_state_tm_top_discard_pkt_data_discardpkt_delete(self, tm_top_discard_pkt_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type tm_top_discard_pkt_data: slot, tower, id
    :param tm_top_discard_pkt_data: Keyword argument tuple.

    :type slot: int
    :param slot: **tm_top_discard_pkt_data** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type tower: int
    :param tower: **tm_top_discard_pkt_data** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type id: int
    :param id: **tm_top_discard_pkt_data** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.tm_state.tm_top_discard_pkt_data', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tm_top_discard_pkt_data', 'keyval': 'slot, tower, id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'discardpkt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tm_top_discard_pkt_data=tm_top_discard_pkt_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tm_top_discard_pkt_data=tm_top_discard_pkt_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def tm_state_tm_top_discard_pkt_data_priority_delete(self, tm_top_discard_pkt_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type tm_top_discard_pkt_data: slot, tower, id
    :param tm_top_discard_pkt_data: Keyword argument tuple.

    :type slot: int
    :param slot: **tm_top_discard_pkt_data** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type tower: int
    :param tower: **tm_top_discard_pkt_data** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type id: int
    :param id: **tm_top_discard_pkt_data** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.tm_state.tm_top_discard_pkt_data', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tm_top_discard_pkt_data', 'keyval': 'slot, tower, id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tm_top_discard_pkt_data=tm_top_discard_pkt_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tm_top_discard_pkt_data=tm_top_discard_pkt_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def tm_state_tm_top_discard_pkt_data_queue_delete(self, tm_top_discard_pkt_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type tm_top_discard_pkt_data: slot, tower, id
    :param tm_top_discard_pkt_data: Keyword argument tuple.

    :type slot: int
    :param slot: **tm_top_discard_pkt_data** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type tower: int
    :param tower: **tm_top_discard_pkt_data** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type id: int
    :param id: **tm_top_discard_pkt_data** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.tm_state.tm_top_discard_pkt_data', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tm_top_discard_pkt_data', 'keyval': 'slot, tower, id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'queue'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tm_top_discard_pkt_data=tm_top_discard_pkt_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tm_top_discard_pkt_data=tm_top_discard_pkt_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def tm_state_tm_top_max_queue_depth_data_delete(self, tm_top_max_queue_depth_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type tm_top_max_queue_depth_data: slot, tower, id
    :param tm_top_max_queue_depth_data: Keyword argument tuple.

    :type slot: int
    :param slot: **tm_top_max_queue_depth_data** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type tower: int
    :param tower: **tm_top_max_queue_depth_data** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type id: int
    :param id: **tm_top_max_queue_depth_data** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.tm_state.tm_top_max_queue_depth_data', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tm_top_max_queue_depth_data', 'keyval': 'slot, tower, id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tm_top_max_queue_depth_data=tm_top_max_queue_depth_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tm_top_max_queue_depth_data=tm_top_max_queue_depth_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def tm_state_tm_top_max_queue_depth_data_dest_port_delete(self, tm_top_max_queue_depth_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type tm_top_max_queue_depth_data: slot, tower, id
    :param tm_top_max_queue_depth_data: Keyword argument tuple.

    :type slot: int
    :param slot: **tm_top_max_queue_depth_data** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type tower: int
    :param tower: **tm_top_max_queue_depth_data** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type id: int
    :param id: **tm_top_max_queue_depth_data** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.tm_state.tm_top_max_queue_depth_data', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tm_top_max_queue_depth_data', 'keyval': 'slot, tower, id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dest-port'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tm_top_max_queue_depth_data=tm_top_max_queue_depth_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tm_top_max_queue_depth_data=tm_top_max_queue_depth_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def tm_state_tm_top_max_queue_depth_data_max_queue_depth_delete(self, tm_top_max_queue_depth_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type tm_top_max_queue_depth_data: slot, tower, id
    :param tm_top_max_queue_depth_data: Keyword argument tuple.

    :type slot: int
    :param slot: **tm_top_max_queue_depth_data** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type tower: int
    :param tower: **tm_top_max_queue_depth_data** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type id: int
    :param id: **tm_top_max_queue_depth_data** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.tm_state.tm_top_max_queue_depth_data', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tm_top_max_queue_depth_data', 'keyval': 'slot, tower, id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'max-queue-depth'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tm_top_max_queue_depth_data=tm_top_max_queue_depth_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tm_top_max_queue_depth_data=tm_top_max_queue_depth_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def tm_state_tm_top_max_queue_depth_data_max_utilization_delete(self, tm_top_max_queue_depth_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type tm_top_max_queue_depth_data: slot, tower, id
    :param tm_top_max_queue_depth_data: Keyword argument tuple.

    :type slot: int
    :param slot: **tm_top_max_queue_depth_data** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type tower: int
    :param tower: **tm_top_max_queue_depth_data** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type id: int
    :param id: **tm_top_max_queue_depth_data** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.tm_state.tm_top_max_queue_depth_data', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tm_top_max_queue_depth_data', 'keyval': 'slot, tower, id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'max-utilization'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tm_top_max_queue_depth_data=tm_top_max_queue_depth_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tm_top_max_queue_depth_data=tm_top_max_queue_depth_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def tm_state_tm_top_max_queue_depth_data_min_threshold_delete(self, tm_top_max_queue_depth_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type tm_top_max_queue_depth_data: slot, tower, id
    :param tm_top_max_queue_depth_data: Keyword argument tuple.

    :type slot: int
    :param slot: **tm_top_max_queue_depth_data** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type tower: int
    :param tower: **tm_top_max_queue_depth_data** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type id: int
    :param id: **tm_top_max_queue_depth_data** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.tm_state.tm_top_max_queue_depth_data', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tm_top_max_queue_depth_data', 'keyval': 'slot, tower, id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'min-threshold'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tm_top_max_queue_depth_data=tm_top_max_queue_depth_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tm_top_max_queue_depth_data=tm_top_max_queue_depth_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def tm_state_tm_top_max_queue_depth_data_priority_delete(self, tm_top_max_queue_depth_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type tm_top_max_queue_depth_data: slot, tower, id
    :param tm_top_max_queue_depth_data: Keyword argument tuple.

    :type slot: int
    :param slot: **tm_top_max_queue_depth_data** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type tower: int
    :param tower: **tm_top_max_queue_depth_data** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type id: int
    :param id: **tm_top_max_queue_depth_data** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.tm_state.tm_top_max_queue_depth_data', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tm_top_max_queue_depth_data', 'keyval': 'slot, tower, id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tm_top_max_queue_depth_data=tm_top_max_queue_depth_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tm_top_max_queue_depth_data=tm_top_max_queue_depth_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def tm_state_tm_top_max_queue_depth_data_queue_delete(self, tm_top_max_queue_depth_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type tm_top_max_queue_depth_data: slot, tower, id
    :param tm_top_max_queue_depth_data: Keyword argument tuple.

    :type slot: int
    :param slot: **tm_top_max_queue_depth_data** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type tower: int
    :param tower: **tm_top_max_queue_depth_data** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type id: int
    :param id: **tm_top_max_queue_depth_data** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.tm_state.tm_top_max_queue_depth_data', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tm_top_max_queue_depth_data', 'keyval': 'slot, tower, id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'queue'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tm_top_max_queue_depth_data=tm_top_max_queue_depth_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tm_top_max_queue_depth_data=tm_top_max_queue_depth_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def tm_state_tmcpustatsslot_delete(self, tmcpustatsslot=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type tmcpustatsslot: slot_id, cpugroup_id
    :param tmcpustatsslot: Keyword argument tuple.

    :type slot_id: int
    :param slot_id: **tmcpustatsslot** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type cpugroup_id: int
    :param cpugroup_id: **tmcpustatsslot** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.tm_state.tmcpustatsslot', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tmcpustatsslot', 'keyval': 'slot_id, cpugroup_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tmcpustatsslot=tmcpustatsslot)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tmcpustatsslot=tmcpustatsslot)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def tm_state_tmcpustatsslot_currdepth_delete(self, tmcpustatsslot=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type tmcpustatsslot: slot_id, cpugroup_id
    :param tmcpustatsslot: Keyword argument tuple.

    :type slot_id: int
    :param slot_id: **tmcpustatsslot** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type cpugroup_id: int
    :param cpugroup_id: **tmcpustatsslot** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.tm_state.tmcpustatsslot', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tmcpustatsslot', 'keyval': 'slot_id, cpugroup_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'currdepth'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tmcpustatsslot=tmcpustatsslot)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tmcpustatsslot=tmcpustatsslot)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def tm_state_tmcpustatsslot_discardbytes_delete(self, tmcpustatsslot=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type tmcpustatsslot: slot_id, cpugroup_id
    :param tmcpustatsslot: Keyword argument tuple.

    :type slot_id: int
    :param slot_id: **tmcpustatsslot** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type cpugroup_id: int
    :param cpugroup_id: **tmcpustatsslot** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.tm_state.tmcpustatsslot', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tmcpustatsslot', 'keyval': 'slot_id, cpugroup_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'discardbytes'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tmcpustatsslot=tmcpustatsslot)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tmcpustatsslot=tmcpustatsslot)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def tm_state_tmcpustatsslot_discardpkt_delete(self, tmcpustatsslot=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type tmcpustatsslot: slot_id, cpugroup_id
    :param tmcpustatsslot: Keyword argument tuple.

    :type slot_id: int
    :param slot_id: **tmcpustatsslot** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type cpugroup_id: int
    :param cpugroup_id: **tmcpustatsslot** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.tm_state.tmcpustatsslot', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tmcpustatsslot', 'keyval': 'slot_id, cpugroup_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'discardpkt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tmcpustatsslot=tmcpustatsslot)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tmcpustatsslot=tmcpustatsslot)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def tm_state_tmcpustatsslot_enquepkt_delete(self, tmcpustatsslot=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type tmcpustatsslot: slot_id, cpugroup_id
    :param tmcpustatsslot: Keyword argument tuple.

    :type slot_id: int
    :param slot_id: **tmcpustatsslot** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type cpugroup_id: int
    :param cpugroup_id: **tmcpustatsslot** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.tm_state.tmcpustatsslot', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tmcpustatsslot', 'keyval': 'slot_id, cpugroup_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enquepkt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tmcpustatsslot=tmcpustatsslot)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tmcpustatsslot=tmcpustatsslot)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def tm_state_tmcpustatsslot_enqueubytes_delete(self, tmcpustatsslot=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type tmcpustatsslot: slot_id, cpugroup_id
    :param tmcpustatsslot: Keyword argument tuple.

    :type slot_id: int
    :param slot_id: **tmcpustatsslot** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type cpugroup_id: int
    :param cpugroup_id: **tmcpustatsslot** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.tm_state.tmcpustatsslot', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tmcpustatsslot', 'keyval': 'slot_id, cpugroup_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enqueubytes'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tmcpustatsslot=tmcpustatsslot)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tmcpustatsslot=tmcpustatsslot)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def tm_state_tmcpustatsslot_maxdepth_delete(self, tmcpustatsslot=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type tmcpustatsslot: slot_id, cpugroup_id
    :param tmcpustatsslot: Keyword argument tuple.

    :type slot_id: int
    :param slot_id: **tmcpustatsslot** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type cpugroup_id: int
    :param cpugroup_id: **tmcpustatsslot** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.tm_state.tmcpustatsslot', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tmcpustatsslot', 'keyval': 'slot_id, cpugroup_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'maxdepth'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tmcpustatsslot=tmcpustatsslot)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tmcpustatsslot=tmcpustatsslot)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def tm_state_tmcpustatsslotallgrp_delete(self, tmcpustatsslotallgrp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type tmcpustatsslotallgrp: slot_id
    :param tmcpustatsslotallgrp: Keyword argument tuple.

    :type slot_id: int
    :param slot_id: **tmcpustatsslotallgrp** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.tm_state.tmcpustatsslotallgrp', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tmcpustatsslotallgrp', 'keyval': 'slot_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tmcpustatsslotallgrp=tmcpustatsslotallgrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tmcpustatsslotallgrp=tmcpustatsslotallgrp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def tm_state_tmcpustatsslotallgrp_currdepth_delete(self, tmcpustatsslotallgrp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type tmcpustatsslotallgrp: slot_id
    :param tmcpustatsslotallgrp: Keyword argument tuple.

    :type slot_id: int
    :param slot_id: **tmcpustatsslotallgrp** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.tm_state.tmcpustatsslotallgrp', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tmcpustatsslotallgrp', 'keyval': 'slot_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'currdepth'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tmcpustatsslotallgrp=tmcpustatsslotallgrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tmcpustatsslotallgrp=tmcpustatsslotallgrp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def tm_state_tmcpustatsslotallgrp_discardbytes_delete(self, tmcpustatsslotallgrp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type tmcpustatsslotallgrp: slot_id
    :param tmcpustatsslotallgrp: Keyword argument tuple.

    :type slot_id: int
    :param slot_id: **tmcpustatsslotallgrp** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.tm_state.tmcpustatsslotallgrp', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tmcpustatsslotallgrp', 'keyval': 'slot_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'discardbytes'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tmcpustatsslotallgrp=tmcpustatsslotallgrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tmcpustatsslotallgrp=tmcpustatsslotallgrp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def tm_state_tmcpustatsslotallgrp_discardpkt_delete(self, tmcpustatsslotallgrp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type tmcpustatsslotallgrp: slot_id
    :param tmcpustatsslotallgrp: Keyword argument tuple.

    :type slot_id: int
    :param slot_id: **tmcpustatsslotallgrp** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.tm_state.tmcpustatsslotallgrp', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tmcpustatsslotallgrp', 'keyval': 'slot_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'discardpkt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tmcpustatsslotallgrp=tmcpustatsslotallgrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tmcpustatsslotallgrp=tmcpustatsslotallgrp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def tm_state_tmcpustatsslotallgrp_enquepkt_delete(self, tmcpustatsslotallgrp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type tmcpustatsslotallgrp: slot_id
    :param tmcpustatsslotallgrp: Keyword argument tuple.

    :type slot_id: int
    :param slot_id: **tmcpustatsslotallgrp** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.tm_state.tmcpustatsslotallgrp', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tmcpustatsslotallgrp', 'keyval': 'slot_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enquepkt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tmcpustatsslotallgrp=tmcpustatsslotallgrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tmcpustatsslotallgrp=tmcpustatsslotallgrp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def tm_state_tmcpustatsslotallgrp_enqueubytes_delete(self, tmcpustatsslotallgrp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type tmcpustatsslotallgrp: slot_id
    :param tmcpustatsslotallgrp: Keyword argument tuple.

    :type slot_id: int
    :param slot_id: **tmcpustatsslotallgrp** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.tm_state.tmcpustatsslotallgrp', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tmcpustatsslotallgrp', 'keyval': 'slot_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enqueubytes'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tmcpustatsslotallgrp=tmcpustatsslotallgrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tmcpustatsslotallgrp=tmcpustatsslotallgrp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def tm_state_tmcpustatsslotallgrp_maxdepth_delete(self, tmcpustatsslotallgrp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type tmcpustatsslotallgrp: slot_id
    :param tmcpustatsslotallgrp: Keyword argument tuple.

    :type slot_id: int
    :param slot_id: **tmcpustatsslotallgrp** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.tm_state.tmcpustatsslotallgrp', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tmcpustatsslotallgrp', 'keyval': 'slot_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'maxdepth'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tmcpustatsslotallgrp=tmcpustatsslotallgrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tmcpustatsslotallgrp=tmcpustatsslotallgrp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def tm_state_tmdevicestataggr_delete(self, tmdevicestataggr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type tmdevicestataggr: slot, tower
    :param tmdevicestataggr: Keyword argument tuple.

    :type slot: int
    :param slot: **tmdevicestataggr** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type tower: int
    :param tower: **tmdevicestataggr** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.tm_state.tmdevicestataggr', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tmdevicestataggr', 'keyval': 'slot, tower', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tmdevicestataggr=tmdevicestataggr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tmdevicestataggr=tmdevicestataggr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def tm_state_tmdevicestataggr_cpu_pkt_cnt_aggr_delete(self, tmdevicestataggr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type tmdevicestataggr: slot, tower
    :param tmdevicestataggr: Keyword argument tuple.

    :type slot: int
    :param slot: **tmdevicestataggr** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type tower: int
    :param tower: **tmdevicestataggr** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.tm_state.tmdevicestataggr', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tmdevicestataggr', 'keyval': 'slot, tower', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cpu-pkt-cnt-aggr'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tmdevicestataggr=tmdevicestataggr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tmdevicestataggr=tmdevicestataggr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def tm_state_tmdevicestataggr_deleted_pkt_cnt_aggr_delete(self, tmdevicestataggr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type tmdevicestataggr: slot, tower
    :param tmdevicestataggr: Keyword argument tuple.

    :type slot: int
    :param slot: **tmdevicestataggr** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type tower: int
    :param tower: **tmdevicestataggr** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.tm_state.tmdevicestataggr', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tmdevicestataggr', 'keyval': 'slot, tower', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'deleted-pkt-cnt-aggr'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tmdevicestataggr=tmdevicestataggr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tmdevicestataggr=tmdevicestataggr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def tm_state_tmdevicestataggr_deque_pkt_cnt_aggr_delete(self, tmdevicestataggr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type tmdevicestataggr: slot, tower
    :param tmdevicestataggr: Keyword argument tuple.

    :type slot: int
    :param slot: **tmdevicestataggr** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type tower: int
    :param tower: **tmdevicestataggr** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.tm_state.tmdevicestataggr', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tmdevicestataggr', 'keyval': 'slot, tower', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'deque-pkt-cnt-aggr'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tmdevicestataggr=tmdevicestataggr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tmdevicestataggr=tmdevicestataggr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def tm_state_tmdevicestataggr_ehp_discard_cnt_aggr_delete(self, tmdevicestataggr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type tmdevicestataggr: slot, tower
    :param tmdevicestataggr: Keyword argument tuple.

    :type slot: int
    :param slot: **tmdevicestataggr** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type tower: int
    :param tower: **tmdevicestataggr** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.tm_state.tmdevicestataggr', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tmdevicestataggr', 'keyval': 'slot, tower', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ehp-discard-cnt-aggr'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tmdevicestataggr=tmdevicestataggr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tmdevicestataggr=tmdevicestataggr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def tm_state_tmdevicestataggr_enque_pkt_cnt_aggr_delete(self, tmdevicestataggr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type tmdevicestataggr: slot, tower
    :param tmdevicestataggr: Keyword argument tuple.

    :type slot: int
    :param slot: **tmdevicestataggr** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type tower: int
    :param tower: **tmdevicestataggr** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.tm_state.tmdevicestataggr', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tmdevicestataggr', 'keyval': 'slot, tower', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enque-pkt-cnt-aggr'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tmdevicestataggr=tmdevicestataggr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tmdevicestataggr=tmdevicestataggr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def tm_state_tmdevicestataggr_fqp_pkt_cnt_aggr_delete(self, tmdevicestataggr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type tmdevicestataggr: slot, tower
    :param tmdevicestataggr: Keyword argument tuple.

    :type slot: int
    :param slot: **tmdevicestataggr** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type tower: int
    :param tower: **tmdevicestataggr** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.tm_state.tmdevicestataggr', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tmdevicestataggr', 'keyval': 'slot, tower', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'fqp-pkt-cnt-aggr'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tmdevicestataggr=tmdevicestataggr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tmdevicestataggr=tmdevicestataggr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def tm_state_tmdevicestataggr_ingress_total_pkt_cnt_aggr_delete(self, tmdevicestataggr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type tmdevicestataggr: slot, tower
    :param tmdevicestataggr: Keyword argument tuple.

    :type slot: int
    :param slot: **tmdevicestataggr** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type tower: int
    :param tower: **tmdevicestataggr** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.tm_state.tmdevicestataggr', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tmdevicestataggr', 'keyval': 'slot, tower', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ingress-total-pkt-cnt-aggr'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tmdevicestataggr=tmdevicestataggr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tmdevicestataggr=tmdevicestataggr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def tm_state_tmdevicestataggr_invalid_queue_pkt_aggr_delete(self, tmdevicestataggr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type tmdevicestataggr: slot, tower
    :param tmdevicestataggr: Keyword argument tuple.

    :type slot: int
    :param slot: **tmdevicestataggr** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type tower: int
    :param tower: **tmdevicestataggr** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.tm_state.tmdevicestataggr', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tmdevicestataggr', 'keyval': 'slot, tower', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'invalid-queue-pkt-aggr'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tmdevicestataggr=tmdevicestataggr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tmdevicestataggr=tmdevicestataggr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def tm_state_tmdevicestataggr_mcast_discard_pkt_cnt_aggr_delete(self, tmdevicestataggr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type tmdevicestataggr: slot, tower
    :param tmdevicestataggr: Keyword argument tuple.

    :type slot: int
    :param slot: **tmdevicestataggr** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type tower: int
    :param tower: **tmdevicestataggr** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.tm_state.tmdevicestataggr', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tmdevicestataggr', 'keyval': 'slot, tower', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mcast-discard-pkt-cnt-aggr'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tmdevicestataggr=tmdevicestataggr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tmdevicestataggr=tmdevicestataggr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def tm_state_tmdevicestataggr_mcast_pkt_cnt_aggr_delete(self, tmdevicestataggr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type tmdevicestataggr: slot, tower
    :param tmdevicestataggr: Keyword argument tuple.

    :type slot: int
    :param slot: **tmdevicestataggr** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type tower: int
    :param tower: **tmdevicestataggr** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.tm_state.tmdevicestataggr', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tmdevicestataggr', 'keyval': 'slot, tower', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mcast-pkt-cnt-aggr'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tmdevicestataggr=tmdevicestataggr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tmdevicestataggr=tmdevicestataggr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def tm_state_tmdevicestataggr_total_discard_pkt_cnt_aggr_delete(self, tmdevicestataggr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type tmdevicestataggr: slot, tower
    :param tmdevicestataggr: Keyword argument tuple.

    :type slot: int
    :param slot: **tmdevicestataggr** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type tower: int
    :param tower: **tmdevicestataggr** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.tm_state.tmdevicestataggr', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tmdevicestataggr', 'keyval': 'slot, tower', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'total-discard-pkt-cnt-aggr'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tmdevicestataggr=tmdevicestataggr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tmdevicestataggr=tmdevicestataggr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def tm_state_tmdevicestataggr_uni_discard_pkt_cnt_aggr_delete(self, tmdevicestataggr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type tmdevicestataggr: slot, tower
    :param tmdevicestataggr: Keyword argument tuple.

    :type slot: int
    :param slot: **tmdevicestataggr** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type tower: int
    :param tower: **tmdevicestataggr** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.tm_state.tmdevicestataggr', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tmdevicestataggr', 'keyval': 'slot, tower', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'uni-discard-pkt-cnt-aggr'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tmdevicestataggr=tmdevicestataggr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tmdevicestataggr=tmdevicestataggr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def tm_state_tmdevicestataggr_uni_pkt_cnt_aggr_delete(self, tmdevicestataggr=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type tmdevicestataggr: slot, tower
    :param tmdevicestataggr: Keyword argument tuple.

    :type slot: int
    :param slot: **tmdevicestataggr** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type tower: int
    :param tower: **tmdevicestataggr** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.tm_state.tmdevicestataggr', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tmdevicestataggr', 'keyval': 'slot, tower', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'uni-pkt-cnt-aggr'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tmdevicestataggr=tmdevicestataggr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tmdevicestataggr=tmdevicestataggr)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def tm_state_tmvoqstatistics_delete(self, tmvoqstatistics=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type tmvoqstatistics: ing_slot, ing_tower, egr_voqid
    :param tmvoqstatistics: Keyword argument tuple.

    :type ing_slot: int
    :param ing_slot: **tmvoqstatistics** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type ing_tower: int
    :param ing_tower: **tmvoqstatistics** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type egr_voqid: int
    :param egr_voqid: **tmvoqstatistics** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.tm_state.tmvoqstatistics', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tmvoqstatistics', 'keyval': 'ing_slot, ing_tower, egr_voqid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tmvoqstatistics=tmvoqstatistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tmvoqstatistics=tmvoqstatistics)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def tm_state_tmvoqstatistics_currdepth_delete(self, tmvoqstatistics=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type tmvoqstatistics: ing_slot, ing_tower, egr_voqid
    :param tmvoqstatistics: Keyword argument tuple.

    :type ing_slot: int
    :param ing_slot: **tmvoqstatistics** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type ing_tower: int
    :param ing_tower: **tmvoqstatistics** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type egr_voqid: int
    :param egr_voqid: **tmvoqstatistics** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.tm_state.tmvoqstatistics', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tmvoqstatistics', 'keyval': 'ing_slot, ing_tower, egr_voqid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'currdepth'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tmvoqstatistics=tmvoqstatistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tmvoqstatistics=tmvoqstatistics)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def tm_state_tmvoqstatistics_discardbytes_delete(self, tmvoqstatistics=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type tmvoqstatistics: ing_slot, ing_tower, egr_voqid
    :param tmvoqstatistics: Keyword argument tuple.

    :type ing_slot: int
    :param ing_slot: **tmvoqstatistics** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type ing_tower: int
    :param ing_tower: **tmvoqstatistics** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type egr_voqid: int
    :param egr_voqid: **tmvoqstatistics** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.tm_state.tmvoqstatistics', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tmvoqstatistics', 'keyval': 'ing_slot, ing_tower, egr_voqid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'discardbytes'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tmvoqstatistics=tmvoqstatistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tmvoqstatistics=tmvoqstatistics)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def tm_state_tmvoqstatistics_discardpkt_delete(self, tmvoqstatistics=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type tmvoqstatistics: ing_slot, ing_tower, egr_voqid
    :param tmvoqstatistics: Keyword argument tuple.

    :type ing_slot: int
    :param ing_slot: **tmvoqstatistics** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type ing_tower: int
    :param ing_tower: **tmvoqstatistics** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type egr_voqid: int
    :param egr_voqid: **tmvoqstatistics** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.tm_state.tmvoqstatistics', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tmvoqstatistics', 'keyval': 'ing_slot, ing_tower, egr_voqid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'discardpkt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tmvoqstatistics=tmvoqstatistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tmvoqstatistics=tmvoqstatistics)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def tm_state_tmvoqstatistics_enquepkt_delete(self, tmvoqstatistics=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type tmvoqstatistics: ing_slot, ing_tower, egr_voqid
    :param tmvoqstatistics: Keyword argument tuple.

    :type ing_slot: int
    :param ing_slot: **tmvoqstatistics** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type ing_tower: int
    :param ing_tower: **tmvoqstatistics** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type egr_voqid: int
    :param egr_voqid: **tmvoqstatistics** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.tm_state.tmvoqstatistics', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tmvoqstatistics', 'keyval': 'ing_slot, ing_tower, egr_voqid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enquepkt'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tmvoqstatistics=tmvoqstatistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tmvoqstatistics=tmvoqstatistics)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def tm_state_tmvoqstatistics_enqueubytes_delete(self, tmvoqstatistics=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type tmvoqstatistics: ing_slot, ing_tower, egr_voqid
    :param tmvoqstatistics: Keyword argument tuple.

    :type ing_slot: int
    :param ing_slot: **tmvoqstatistics** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type ing_tower: int
    :param ing_tower: **tmvoqstatistics** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type egr_voqid: int
    :param egr_voqid: **tmvoqstatistics** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.tm_state.tmvoqstatistics', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tmvoqstatistics', 'keyval': 'ing_slot, ing_tower, egr_voqid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enqueubytes'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tmvoqstatistics=tmvoqstatistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tmvoqstatistics=tmvoqstatistics)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def tm_state_tmvoqstatistics_maxdepth_delete(self, tmvoqstatistics=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type tmvoqstatistics: ing_slot, ing_tower, egr_voqid
    :param tmvoqstatistics: Keyword argument tuple.

    :type ing_slot: int
    :param ing_slot: **tmvoqstatistics** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type ing_tower: int
    :param ing_tower: **tmvoqstatistics** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type egr_voqid: int
    :param egr_voqid: **tmvoqstatistics** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.tm_state.tmvoqstatistics', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tmvoqstatistics', 'keyval': 'ing_slot, ing_tower, egr_voqid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'maxdepth'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tmvoqstatistics=tmvoqstatistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tmvoqstatistics=tmvoqstatistics)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def tm_state_tmvoqstatistics_priority_delete(self, tmvoqstatistics=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type tmvoqstatistics: ing_slot, ing_tower, egr_voqid
    :param tmvoqstatistics: Keyword argument tuple.

    :type ing_slot: int
    :param ing_slot: **tmvoqstatistics** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type ing_tower: int
    :param ing_tower: **tmvoqstatistics** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type egr_voqid: int
    :param egr_voqid: **tmvoqstatistics** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.tm_state.tmvoqstatistics', 'pybind.slxos.v16r_1_00b.brocade_sysdiag_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tmvoqstatistics', 'keyval': 'ing_slot, ing_tower, egr_voqid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'priority'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tmvoqstatistics=tmvoqstatistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tmvoqstatistics=tmvoqstatistics)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def topology_group_delete(self, topology_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type topology_group: topology_group_id
    :param topology_group: Keyword argument tuple.

    :type topology_group_id: long
    :param topology_group_id: **topology_group** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.topology_group', 'pybind.slxos.v16r_1_00b.brocade_topology_group', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'topology_group', 'keyval': 'topology_group_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, topology_group=topology_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, topology_group=topology_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def topology_group_master_vlan_delete(self, topology_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type topology_group: topology_group_id
    :param topology_group: Keyword argument tuple.

    :type topology_group_id: long
    :param topology_group_id: **topology_group** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.topology_group', 'pybind.slxos.v16r_1_00b.brocade_topology_group', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'topology_group', 'keyval': 'topology_group_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'master-vlan'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, topology_group=topology_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, topology_group=topology_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def topology_group_member_bridge_domain_delete(self, topology_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type topology_group: topology_group_id
    :param topology_group: Keyword argument tuple.

    :type topology_group_id: long
    :param topology_group_id: **topology_group** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.topology_group', 'topology_group')]
    bindings_list = [('pybind.slxos.v16r_1_00b.topology_group.member_bridge_domain', 'pybind.slxos.v16r_1_00b.brocade_topology_group', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'topology_group_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, topology_group=topology_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, topology_group=topology_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def topology_group_member_bridge_domain_add_delete(self, topology_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type topology_group: topology_group_id
    :param topology_group: Keyword argument tuple.

    :type topology_group_id: long
    :param topology_group_id: **topology_group** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.topology_group', 'topology_group')]
    bindings_list = [('pybind.slxos.v16r_1_00b.topology_group.member_bridge_domain', 'pybind.slxos.v16r_1_00b.brocade_topology_group', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'topology_group_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'add'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, topology_group=topology_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, topology_group=topology_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def topology_group_member_bridge_domain_remove_delete(self, topology_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type topology_group: topology_group_id
    :param topology_group: Keyword argument tuple.

    :type topology_group_id: long
    :param topology_group_id: **topology_group** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.topology_group', 'topology_group')]
    bindings_list = [('pybind.slxos.v16r_1_00b.topology_group.member_bridge_domain', 'pybind.slxos.v16r_1_00b.brocade_topology_group', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'topology_group_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'remove'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, topology_group=topology_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, topology_group=topology_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def topology_group_member_vlan_delete(self, topology_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type topology_group: topology_group_id
    :param topology_group: Keyword argument tuple.

    :type topology_group_id: long
    :param topology_group_id: **topology_group** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.topology_group', 'topology_group')]
    bindings_list = [('pybind.slxos.v16r_1_00b.topology_group.member_vlan', 'pybind.slxos.v16r_1_00b.brocade_topology_group', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'topology_group_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, topology_group=topology_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, topology_group=topology_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def topology_group_member_vlan_add_delete(self, topology_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type topology_group: topology_group_id
    :param topology_group: Keyword argument tuple.

    :type topology_group_id: long
    :param topology_group_id: **topology_group** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.topology_group', 'topology_group')]
    bindings_list = [('pybind.slxos.v16r_1_00b.topology_group.member_vlan', 'pybind.slxos.v16r_1_00b.brocade_topology_group', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'topology_group_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'add'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, topology_group=topology_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, topology_group=topology_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def topology_group_member_vlan_remove_delete(self, topology_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type topology_group: topology_group_id
    :param topology_group: Keyword argument tuple.

    :type topology_group_id: long
    :param topology_group_id: **topology_group** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.topology_group', 'topology_group')]
    bindings_list = [('pybind.slxos.v16r_1_00b.topology_group.member_vlan', 'pybind.slxos.v16r_1_00b.brocade_topology_group', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'topology_group_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'remove'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, topology_group=topology_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, topology_group=topology_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def topology_group_state_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.topology_group_state', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def topology_group_state_topology_group_data_delete(self, topology_group_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type topology_group_data: topology_group_id
    :param topology_group_data: Keyword argument tuple.

    :type topology_group_id: int
    :param topology_group_id: **topology_group_data** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.topology_group_state.topology_group_data', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'topology_group_data', 'keyval': 'topology_group_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, topology_group_data=topology_group_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, topology_group_data=topology_group_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def topology_group_state_topology_group_data_l2_protocol_delete(self, topology_group_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type topology_group_data: topology_group_id
    :param topology_group_data: Keyword argument tuple.

    :type topology_group_id: int
    :param topology_group_id: **topology_group_data** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.topology_group_state.topology_group_data', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'topology_group_data', 'keyval': 'topology_group_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'l2-protocol'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, topology_group_data=topology_group_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, topology_group_data=topology_group_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def topology_group_state_topology_group_data_master_vlan_delete(self, topology_group_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type topology_group_data: topology_group_id
    :param topology_group_data: Keyword argument tuple.

    :type topology_group_id: int
    :param topology_group_id: **topology_group_data** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.topology_group_state.topology_group_data', u'topology_group_data')]
    bindings_list = [('pybind.slxos.v16r_1_00b.topology_group_state.topology_group_data.master_vlan', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'topology_group_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, topology_group_data=topology_group_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, topology_group_data=topology_group_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def topology_group_state_topology_group_data_master_vlan_control_ports_delete(self, topology_group_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type topology_group_data: topology_group_id
    :param topology_group_data: Keyword argument tuple.

    :type topology_group_id: int
    :param topology_group_id: **topology_group_data** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.topology_group_state.topology_group_data', u'topology_group_data')]
    bindings_list = [('pybind.slxos.v16r_1_00b.topology_group_state.topology_group_data.master_vlan', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'topology_group_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'control-ports'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, topology_group_data=topology_group_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, topology_group_data=topology_group_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def topology_group_state_topology_group_data_master_vlan_free_ports_delete(self, topology_group_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type topology_group_data: topology_group_id
    :param topology_group_data: Keyword argument tuple.

    :type topology_group_id: int
    :param topology_group_id: **topology_group_data** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.topology_group_state.topology_group_data', u'topology_group_data')]
    bindings_list = [('pybind.slxos.v16r_1_00b.topology_group_state.topology_group_data.master_vlan', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'topology_group_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'free-ports'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, topology_group_data=topology_group_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, topology_group_data=topology_group_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def topology_group_state_topology_group_data_master_vlan_vlan_id_delete(self, topology_group_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type topology_group_data: topology_group_id
    :param topology_group_data: Keyword argument tuple.

    :type topology_group_id: int
    :param topology_group_id: **topology_group_data** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.topology_group_state.topology_group_data', u'topology_group_data')]
    bindings_list = [('pybind.slxos.v16r_1_00b.topology_group_state.topology_group_data.master_vlan', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'topology_group_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vlan-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, topology_group_data=topology_group_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, topology_group_data=topology_group_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def topology_group_state_topology_group_data_member_bd_delete(self, topology_group_data=None, member_bd=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type topology_group_data: topology_group_id
    :param topology_group_data: Keyword argument tuple.

    :type topology_group_id: int
    :param topology_group_id: **topology_group_data** tuple argument.

        * range restriction: ::

            ['0..65535']

    **Instance Keyword Argument Tuple**:

    :type member_bd: bd_id
    :param member_bd: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **member_bd** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.topology_group_state.topology_group_data', u'topology_group_data')]
    bindings_list = [('pybind.slxos.v16r_1_00b.topology_group_state.topology_group_data.member_bd', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'topology_group_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'member_bd', 'keyval': 'bd_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, topology_group_data=topology_group_data, member_bd=member_bd)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, topology_group_data=topology_group_data, member_bd=member_bd)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def topology_group_state_topology_group_data_member_bd_free_ports_delete(self, topology_group_data=None, member_bd=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type topology_group_data: topology_group_id
    :param topology_group_data: Keyword argument tuple.

    :type topology_group_id: int
    :param topology_group_id: **topology_group_data** tuple argument.

        * range restriction: ::

            ['0..65535']

    **Instance Keyword Argument Tuple**:

    :type member_bd: bd_id
    :param member_bd: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **member_bd** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.topology_group_state.topology_group_data', u'topology_group_data')]
    bindings_list = [('pybind.slxos.v16r_1_00b.topology_group_state.topology_group_data.member_bd', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'topology_group_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'member_bd', 'keyval': 'bd_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'free-ports'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, topology_group_data=topology_group_data, member_bd=member_bd)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, topology_group_data=topology_group_data, member_bd=member_bd)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def topology_group_state_topology_group_data_member_vlan_delete(self, topology_group_data=None, member_vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type topology_group_data: topology_group_id
    :param topology_group_data: Keyword argument tuple.

    :type topology_group_id: int
    :param topology_group_id: **topology_group_data** tuple argument.

        * range restriction: ::

            ['0..65535']

    **Instance Keyword Argument Tuple**:

    :type member_vlan: vlan_id
    :param member_vlan: Keyword argument tuple.

    :type vlan_id: int
    :param vlan_id: **member_vlan** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.topology_group_state.topology_group_data', u'topology_group_data')]
    bindings_list = [('pybind.slxos.v16r_1_00b.topology_group_state.topology_group_data.member_vlan', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'topology_group_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'member_vlan', 'keyval': 'vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, topology_group_data=topology_group_data, member_vlan=member_vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, topology_group_data=topology_group_data, member_vlan=member_vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def topology_group_state_topology_group_data_member_vlan_free_ports_delete(self, topology_group_data=None, member_vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type topology_group_data: topology_group_id
    :param topology_group_data: Keyword argument tuple.

    :type topology_group_id: int
    :param topology_group_id: **topology_group_data** tuple argument.

        * range restriction: ::

            ['0..65535']

    **Instance Keyword Argument Tuple**:

    :type member_vlan: vlan_id
    :param member_vlan: Keyword argument tuple.

    :type vlan_id: int
    :param vlan_id: **member_vlan** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.topology_group_state.topology_group_data', u'topology_group_data')]
    bindings_list = [('pybind.slxos.v16r_1_00b.topology_group_state.topology_group_data.member_vlan', 'pybind.slxos.v16r_1_00b.brocade_nsm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'topology_group_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'member_vlan', 'keyval': 'vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'free-ports'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, topology_group_data=topology_group_data, member_vlan=member_vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, topology_group_data=topology_group_data, member_vlan=member_vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def traffic_class_exp_state_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.traffic_class_exp_state', 'pybind.slxos.v16r_1_00b.brocade_qos_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def traffic_class_exp_state_qos_mpls_delete(self, qos_mpls=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type qos_mpls: map_name
    :param qos_mpls: Keyword argument tuple.

    :type map_name: unicode
    :param map_name: **qos_mpls** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.traffic_class_exp_state.qos_mpls', 'pybind.slxos.v16r_1_00b.brocade_qos_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'qos_mpls', 'keyval': 'map_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, qos_mpls=qos_mpls)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, qos_mpls=qos_mpls)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def traffic_class_exp_state_qos_mpls_enabled_slots_delete(self, qos_mpls=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type qos_mpls: map_name
    :param qos_mpls: Keyword argument tuple.

    :type map_name: unicode
    :param map_name: **qos_mpls** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.traffic_class_exp_state.qos_mpls', 'pybind.slxos.v16r_1_00b.brocade_qos_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'qos_mpls', 'keyval': 'map_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enabled-slots'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, qos_mpls=qos_mpls)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, qos_mpls=qos_mpls)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def traffic_class_exp_state_qos_mpls_map_type_delete(self, qos_mpls=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type qos_mpls: map_name
    :param qos_mpls: Keyword argument tuple.

    :type map_name: unicode
    :param map_name: **qos_mpls** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.traffic_class_exp_state.qos_mpls', 'pybind.slxos.v16r_1_00b.brocade_qos_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'qos_mpls', 'keyval': 'map_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'map-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, qos_mpls=qos_mpls)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, qos_mpls=qos_mpls)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def traffic_state_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.traffic_state', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def traffic_state_l1_csnp_rx_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.traffic_state', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'l1-csnp-rx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def traffic_state_l1_csnp_tx_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.traffic_state', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'l1-csnp-tx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def traffic_state_l1_hello_rx_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.traffic_state', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'l1-hello-rx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def traffic_state_l1_hello_tx_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.traffic_state', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'l1-hello-tx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def traffic_state_l1_lsp_rx_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.traffic_state', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'l1-lsp-rx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def traffic_state_l1_lsp_tx_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.traffic_state', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'l1-lsp-tx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def traffic_state_l1_psnp_rx_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.traffic_state', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'l1-psnp-rx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def traffic_state_l1_psnp_tx_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.traffic_state', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'l1-psnp-tx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def traffic_state_l2_csnp_rx_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.traffic_state', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'l2-csnp-rx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def traffic_state_l2_csnp_tx_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.traffic_state', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'l2-csnp-tx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def traffic_state_l2_hello_rx_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.traffic_state', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'l2-hello-rx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def traffic_state_l2_hello_tx_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.traffic_state', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'l2-hello-tx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def traffic_state_l2_lsp_rx_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.traffic_state', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'l2-lsp-rx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def traffic_state_l2_lsp_tx_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.traffic_state', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'l2-lsp-tx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def traffic_state_l2_psnp_rx_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.traffic_state', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'l2-psnp-rx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def traffic_state_l2_psnp_tx_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.traffic_state', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'l2-psnp-tx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def traffic_state_pp_hello_rx_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.traffic_state', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'pp-hello-rx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def traffic_state_pp_hello_tx_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.traffic_state', 'pybind.slxos.v16r_1_00b.brocade_isis_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'pp-hello-tx'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def tunnel_settings_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.tunnel_settings', 'pybind.nos.v6_0_2c.brocade_tunnels', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.tunnel_settings', 'pybind.nos.v7_0_1b.brocade_tunnels', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.tunnel_settings', 'pybind.nos.v7_1_0.brocade_tunnels', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def urpf_exclude_default_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.rpf_config', 'pybind.slxos.v16r_1_00b.brocade_rpf', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'urpf-exclude-default'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def username_delete(self, username=None, user_password=None, encryption_level=None, role=None, desc=None, enable=None, expire=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type username: name, user_password, encryption_level, role, desc, enable, expire
    :param username: Keyword argument tuple.

    :type name: unicode
    :param name: **username** tuple argument.

        * length restriction: ::

            ['1 .. 40']

    :type user_password: unicode
    :param user_password: **username** tuple argument:  Password of the user

        * length restriction: ::

            ['1..40']

    :type encryption_level: unicode
    :param encryption_level: **username** tuple argument:  Level of encryption of the password(default=0)

        * enumeration restriction: ::

            ['0', '7']

    :type role: unicode
    :param role: **username** tuple argument:  Role of the user

        * length restriction: ::

            ['4 .. 32']

    :type desc: unicode
    :param desc: **username** tuple argument:  Description of the user (default='')

        * length restriction: ::

            ['0 .. 64']

    :type enable: YANGBool
    :param enable: **username** tuple argument:  Represents whether the user account is enabled(default=true)

    :type expire: unicode
    :param expire: **username** tuple argument:  Date until when the password will remain valid after being updated(default=never)

        * length restriction: ::

            ['0 .. 10']

        * pattern restriction: ::

            '((19(0[2-9]|[1-9][0-9])|20([012][0-9]|3[0-7]))-('
            '0[1-9]|1[012])-(0[1-9]|[12][0-9]|3[01]))|never'

    **Instance Argument(s)**:

    :type user_password: unicode
    :param user_password: Password of the user

        * length restriction: ::

            ['1..40']

    :type encryption_level: unicode
    :param encryption_level: Level of encryption of the password(default=0)

        * enumeration restriction: ::

            ['0', '7']

    :type role: unicode
    :param role: Role of the user

        * length restriction: ::

            ['4 .. 32']

    :type desc: unicode
    :param desc: Description of the user (default='')

        * length restriction: ::

            ['0 .. 64']

    :type enable: YANGBool
    :param enable: Represents whether the user account is enabled(default=true)

    :type expire: unicode
    :param expire: Date until when the password will remain valid after being updated(default=never)

        * length restriction: ::

            ['0 .. 10']

        * pattern restriction: ::

            '((19(0[2-9]|[1-9][0-9])|20([012][0-9]|3[0-7]))-('
            '0[1-9]|1[012])-(0[1-9]|[12][0-9]|3[01]))|never'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.username', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.username', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.username', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.username', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'username', 'keyval': 'name', 'extra_keyval': 'name, user_password, encryption_level, role, desc, enable, expire, access_time, end_time'}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v7_1_0.username": {}, "pybind.nos.v6_0_2c.username": {"encryption_level": "encryption_level", "enable": "enable", "name": "name", "user_password": "user_password", "expire": "expire", "role": "role", "desc": "desc"}, "pybind.nos.v7_0_1b.username": {}, "pybind.slxos.v16r_1_00b.username": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, username=username, user_password=user_password, encryption_level=encryption_level, role=role, desc=desc, enable=enable, expire=expire)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, username=username, user_password=user_password, encryption_level=encryption_level, role=role, desc=desc, enable=enable, expire=expire)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def username_access_time_delete(self, username=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type username: name
    :param username: Keyword argument tuple.

    :type name: unicode
    :param name: **username** tuple argument.

        * length restriction: ::

            ['1 .. 40']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_0_1b.username', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.username', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.username', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'username', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'access-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, username=username)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, username=username)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def username_desc_delete(self, username=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type username: name
    :param username: Keyword argument tuple.

    :type name: unicode
    :param name: **username** tuple argument.

        * length restriction: ::

            ['1 .. 40']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.username', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.username', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.username', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.username', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'username', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'desc'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, username=username)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, username=username)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def username_enable_delete(self, username=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type username: name
    :param username: Keyword argument tuple.

    :type name: unicode
    :param name: **username** tuple argument.

        * length restriction: ::

            ['1 .. 40']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.username', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.username', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.username', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.username', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'username', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, username=username)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, username=username)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def username_encryption_level_delete(self, username=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type username: name
    :param username: Keyword argument tuple.

    :type name: unicode
    :param name: **username** tuple argument.

        * length restriction: ::

            ['1 .. 40']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.username', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.username', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.username', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.username', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'username', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'encryption-level'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, username=username)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, username=username)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def username_expire_delete(self, username=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type username: name
    :param username: Keyword argument tuple.

    :type name: unicode
    :param name: **username** tuple argument.

        * length restriction: ::

            ['1 .. 40']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.username', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.username', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.username', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.username', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'username', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'expire'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, username=username)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, username=username)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def username_password_delete(self, username=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type username: name
    :param username: Keyword argument tuple.

    :type name: unicode
    :param name: **username** tuple argument.

        * length restriction: ::

            ['1 .. 40']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.username', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.username', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.username', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.username', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'username', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'password'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, username=username)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, username=username)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def username_role_delete(self, username=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type username: name
    :param username: Keyword argument tuple.

    :type name: unicode
    :param name: **username** tuple argument.

        * length restriction: ::

            ['1 .. 40']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.username', 'pybind.nos.v6_0_2c.brocade_aaa', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.username', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.username', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.username', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'username', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'role'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, username=username)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, username=username)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def username_to_delete(self, username=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type username: name
    :param username: Keyword argument tuple.

    :type name: unicode
    :param name: **username** tuple argument.

        * length restriction: ::

            ['1 .. 40']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_0_1b.username', 'pybind.nos.v7_0_1b.brocade_aaa', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.username', 'pybind.nos.v7_1_0.brocade_aaa', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.username', 'pybind.slxos.v16r_1_00b.brocade_aaa', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'username', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'to'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, username=username)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, username=username)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vc_peer_state_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.vc_peer_state', 'pybind.slxos.v16r_1_00b.brocade_pwm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vc_peer_state_vc_peer_data_delete(self, vc_peer_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type vc_peer_data: vc_id
    :param vc_peer_data: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **vc_peer_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.vc_peer_state.vc_peer_data', 'pybind.slxos.v16r_1_00b.brocade_pwm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'vc_peer_data', 'keyval': 'vc_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vc_peer_data=vc_peer_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vc_peer_data=vc_peer_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vc_peer_state_vc_peer_data_vc_assigned_lsp_delete(self, vc_peer_data=None, vc_assigned_lsp=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vc_peer_data: vc_id
    :param vc_peer_data: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **vc_peer_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vc_assigned_lsp: vc_lsp_name
    :param vc_assigned_lsp: Keyword argument tuple.

    :type vc_lsp_name: unicode
    :param vc_lsp_name: **vc_assigned_lsp** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.vc_peer_state.vc_peer_data', u'vc_peer_data')]
    bindings_list = [('pybind.slxos.v16r_1_00b.vc_peer_state.vc_peer_data.vc_assigned_lsp', 'pybind.slxos.v16r_1_00b.brocade_pwm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vc_assigned_lsp', 'keyval': 'vc_lsp_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vc_peer_data=vc_peer_data, vc_assigned_lsp=vc_assigned_lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vc_peer_data=vc_peer_data, vc_assigned_lsp=vc_assigned_lsp)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vc_peer_state_vc_peer_data_vc_ldp_tnnl_in_use_delete(self, vc_peer_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type vc_peer_data: vc_id
    :param vc_peer_data: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **vc_peer_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.vc_peer_state.vc_peer_data', 'pybind.slxos.v16r_1_00b.brocade_pwm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'vc_peer_data', 'keyval': 'vc_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vc-ldp-tnnl-in-use'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vc_peer_data=vc_peer_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vc_peer_data=vc_peer_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vc_peer_state_vc_peer_data_vc_local_label_delete(self, vc_peer_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type vc_peer_data: vc_id
    :param vc_peer_data: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **vc_peer_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.vc_peer_state.vc_peer_data', 'pybind.slxos.v16r_1_00b.brocade_pwm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'vc_peer_data', 'keyval': 'vc_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vc-local-label'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vc_peer_data=vc_peer_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vc_peer_data=vc_peer_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vc_peer_state_vc_peer_data_vc_local_mtu_delete(self, vc_peer_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type vc_peer_data: vc_id
    :param vc_peer_data: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **vc_peer_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.vc_peer_state.vc_peer_data', 'pybind.slxos.v16r_1_00b.brocade_pwm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'vc_peer_data', 'keyval': 'vc_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vc-local-mtu'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vc_peer_data=vc_peer_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vc_peer_data=vc_peer_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vc_peer_state_vc_peer_data_vc_local_type_delete(self, vc_peer_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type vc_peer_data: vc_id
    :param vc_peer_data: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **vc_peer_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.vc_peer_state.vc_peer_data', 'pybind.slxos.v16r_1_00b.brocade_pwm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'vc_peer_data', 'keyval': 'vc_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vc-local-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vc_peer_data=vc_peer_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vc_peer_data=vc_peer_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vc_peer_state_vc_peer_data_vc_peer_address_delete(self, vc_peer_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type vc_peer_data: vc_id
    :param vc_peer_data: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **vc_peer_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.vc_peer_state.vc_peer_data', 'pybind.slxos.v16r_1_00b.brocade_pwm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'vc_peer_data', 'keyval': 'vc_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vc-peer-address'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vc_peer_data=vc_peer_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vc_peer_data=vc_peer_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vc_peer_state_vc_peer_data_vc_peer_cos_enabled_delete(self, vc_peer_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type vc_peer_data: vc_id
    :param vc_peer_data: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **vc_peer_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.vc_peer_state.vc_peer_data', 'pybind.slxos.v16r_1_00b.brocade_pwm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'vc_peer_data', 'keyval': 'vc_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vc-peer-cos-enabled'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vc_peer_data=vc_peer_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vc_peer_data=vc_peer_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vc_peer_state_vc_peer_data_vc_peer_cos_value_delete(self, vc_peer_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type vc_peer_data: vc_id
    :param vc_peer_data: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **vc_peer_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.vc_peer_state.vc_peer_data', 'pybind.slxos.v16r_1_00b.brocade_pwm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'vc_peer_data', 'keyval': 'vc_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vc-peer-cos-value'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vc_peer_data=vc_peer_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vc_peer_data=vc_peer_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vc_peer_state_vc_peer_data_vc_peer_load_balance_delete(self, vc_peer_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type vc_peer_data: vc_id
    :param vc_peer_data: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **vc_peer_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.vc_peer_state.vc_peer_data', 'pybind.slxos.v16r_1_00b.brocade_pwm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'vc_peer_data', 'keyval': 'vc_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vc-peer-load-balance'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vc_peer_data=vc_peer_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vc_peer_data=vc_peer_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vc_peer_state_vc_peer_data_vc_peer_state_delete(self, vc_peer_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type vc_peer_data: vc_id
    :param vc_peer_data: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **vc_peer_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.vc_peer_state.vc_peer_data', 'pybind.slxos.v16r_1_00b.brocade_pwm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'vc_peer_data', 'keyval': 'vc_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vc-peer-state'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vc_peer_data=vc_peer_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vc_peer_data=vc_peer_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vc_peer_state_vc_peer_data_vc_peer_uptime_delete(self, vc_peer_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type vc_peer_data: vc_id
    :param vc_peer_data: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **vc_peer_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.vc_peer_state.vc_peer_data', 'pybind.slxos.v16r_1_00b.brocade_pwm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'vc_peer_data', 'keyval': 'vc_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vc-peer-uptime'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vc_peer_data=vc_peer_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vc_peer_data=vc_peer_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vc_peer_state_vc_peer_data_vc_proto_tnnl_delete(self, vc_peer_data=None, vc_proto_tnnl=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vc_peer_data: vc_id
    :param vc_peer_data: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **vc_peer_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vc_proto_tnnl: vc_proto_name
    :param vc_proto_tnnl: Keyword argument tuple.

    :type vc_proto_name: unicode
    :param vc_proto_name: **vc_proto_tnnl** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.vc_peer_state.vc_peer_data', u'vc_peer_data')]
    bindings_list = [('pybind.slxos.v16r_1_00b.vc_peer_state.vc_peer_data.vc_proto_tnnl', 'pybind.slxos.v16r_1_00b.brocade_pwm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vc_proto_tnnl', 'keyval': 'vc_proto_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vc_peer_data=vc_peer_data, vc_proto_tnnl=vc_proto_tnnl)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vc_peer_data=vc_peer_data, vc_proto_tnnl=vc_proto_tnnl)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vc_peer_state_vc_peer_data_vc_proto_tnnl_vc_ldp_name_delete(self, vc_peer_data=None, vc_proto_tnnl=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vc_peer_data: vc_id
    :param vc_peer_data: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **vc_peer_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vc_proto_tnnl: vc_proto_name
    :param vc_proto_tnnl: Keyword argument tuple.

    :type vc_proto_name: unicode
    :param vc_proto_name: **vc_proto_tnnl** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.vc_peer_state.vc_peer_data', u'vc_peer_data')]
    bindings_list = [('pybind.slxos.v16r_1_00b.vc_peer_state.vc_peer_data.vc_proto_tnnl', 'pybind.slxos.v16r_1_00b.brocade_pwm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vc_proto_tnnl', 'keyval': 'vc_proto_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vc-ldp-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vc_peer_data=vc_peer_data, vc_proto_tnnl=vc_proto_tnnl)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vc_peer_data=vc_peer_data, vc_proto_tnnl=vc_proto_tnnl)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vc_peer_state_vc_peer_data_vc_proto_tnnl_vc_ldp_tunnel_id_delete(self, vc_peer_data=None, vc_proto_tnnl=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vc_peer_data: vc_id
    :param vc_peer_data: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **vc_peer_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vc_proto_tnnl: vc_proto_name
    :param vc_proto_tnnl: Keyword argument tuple.

    :type vc_proto_name: unicode
    :param vc_proto_name: **vc_proto_tnnl** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.vc_peer_state.vc_peer_data', u'vc_peer_data')]
    bindings_list = [('pybind.slxos.v16r_1_00b.vc_peer_state.vc_peer_data.vc_proto_tnnl', 'pybind.slxos.v16r_1_00b.brocade_pwm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vc_proto_tnnl', 'keyval': 'vc_proto_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vc-ldp-tunnel-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vc_peer_data=vc_peer_data, vc_proto_tnnl=vc_proto_tnnl)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vc_peer_data=vc_peer_data, vc_proto_tnnl=vc_proto_tnnl)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vc_peer_state_vc_peer_data_vc_proto_tnnl_vc_lsp_name_delete(self, vc_peer_data=None, vc_proto_tnnl=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vc_peer_data: vc_id
    :param vc_peer_data: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **vc_peer_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vc_proto_tnnl: vc_proto_name
    :param vc_proto_tnnl: Keyword argument tuple.

    :type vc_proto_name: unicode
    :param vc_proto_name: **vc_proto_tnnl** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.vc_peer_state.vc_peer_data', u'vc_peer_data')]
    bindings_list = [('pybind.slxos.v16r_1_00b.vc_peer_state.vc_peer_data.vc_proto_tnnl', 'pybind.slxos.v16r_1_00b.brocade_pwm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vc_proto_tnnl', 'keyval': 'vc_proto_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vc-lsp-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vc_peer_data=vc_peer_data, vc_proto_tnnl=vc_proto_tnnl)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vc_peer_data=vc_peer_data, vc_proto_tnnl=vc_proto_tnnl)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vc_peer_state_vc_peer_data_vc_proto_tnnl_vc_peer_lsp_cos_enabled_delete(self, vc_peer_data=None, vc_proto_tnnl=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vc_peer_data: vc_id
    :param vc_peer_data: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **vc_peer_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vc_proto_tnnl: vc_proto_name
    :param vc_proto_tnnl: Keyword argument tuple.

    :type vc_proto_name: unicode
    :param vc_proto_name: **vc_proto_tnnl** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.vc_peer_state.vc_peer_data', u'vc_peer_data')]
    bindings_list = [('pybind.slxos.v16r_1_00b.vc_peer_state.vc_peer_data.vc_proto_tnnl', 'pybind.slxos.v16r_1_00b.brocade_pwm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vc_proto_tnnl', 'keyval': 'vc_proto_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vc-peer-lsp-cos-enabled'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vc_peer_data=vc_peer_data, vc_proto_tnnl=vc_proto_tnnl)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vc_peer_data=vc_peer_data, vc_proto_tnnl=vc_proto_tnnl)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vc_peer_state_vc_peer_data_vc_proto_tnnl_vc_peer_lsp_cos_value_delete(self, vc_peer_data=None, vc_proto_tnnl=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vc_peer_data: vc_id
    :param vc_peer_data: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **vc_peer_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vc_proto_tnnl: vc_proto_name
    :param vc_proto_tnnl: Keyword argument tuple.

    :type vc_proto_name: unicode
    :param vc_proto_name: **vc_proto_tnnl** tuple argument.

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.vc_peer_state.vc_peer_data', u'vc_peer_data')]
    bindings_list = [('pybind.slxos.v16r_1_00b.vc_peer_state.vc_peer_data.vc_proto_tnnl', 'pybind.slxos.v16r_1_00b.brocade_pwm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vc_proto_tnnl', 'keyval': 'vc_proto_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vc-peer-lsp-cos-value'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vc_peer_data=vc_peer_data, vc_proto_tnnl=vc_proto_tnnl)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vc_peer_data=vc_peer_data, vc_proto_tnnl=vc_proto_tnnl)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vc_peer_state_vc_peer_data_vc_remote_label_delete(self, vc_peer_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type vc_peer_data: vc_id
    :param vc_peer_data: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **vc_peer_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.vc_peer_state.vc_peer_data', 'pybind.slxos.v16r_1_00b.brocade_pwm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'vc_peer_data', 'keyval': 'vc_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vc-remote-label'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vc_peer_data=vc_peer_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vc_peer_data=vc_peer_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vc_peer_state_vc_peer_data_vc_remote_mtu_delete(self, vc_peer_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type vc_peer_data: vc_id
    :param vc_peer_data: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **vc_peer_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.vc_peer_state.vc_peer_data', 'pybind.slxos.v16r_1_00b.brocade_pwm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'vc_peer_data', 'keyval': 'vc_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vc-remote-mtu'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vc_peer_data=vc_peer_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vc_peer_data=vc_peer_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vc_peer_state_vc_peer_data_vc_remote_type_delete(self, vc_peer_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type vc_peer_data: vc_id
    :param vc_peer_data: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **vc_peer_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.vc_peer_state.vc_peer_data', 'pybind.slxos.v16r_1_00b.brocade_pwm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'vc_peer_data', 'keyval': 'vc_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vc-remote-type'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vc_peer_data=vc_peer_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vc_peer_data=vc_peer_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vcenter_delete(self, vcenter=None, activate=None, interval=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type vcenter: id
    :param vcenter: Keyword argument tuple.

    :type id: unicode
    :param id: **vcenter** tuple argument:  NAME;;vCenter name (Max Size - 32)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    **Instance Argument(s)**:

    :type activate: YANGBool
    :param activate: Activate the vCenter discovery

    :type interval: long
    :param interval: Discovery Timer Interval

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.vcenter', 'pybind.nos.v6_0_2c.brocade_vswitch', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.vcenter', 'pybind.nos.v7_0_1b.brocade_vswitch', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.vcenter', 'pybind.nos.v7_1_0.brocade_vswitch', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.vcenter', 'pybind.slxos.v16r_1_00b.brocade_vswitch', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'vcenter', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vcenter=vcenter, activate=activate, interval=interval)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vcenter=vcenter, activate=activate, interval=interval)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vcenter_activate_delete(self, vcenter=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type vcenter: id
    :param vcenter: Keyword argument tuple.

    :type id: unicode
    :param id: **vcenter** tuple argument:  NAME;;vCenter name (Max Size - 32)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.vcenter', 'pybind.nos.v6_0_2c.brocade_vswitch', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.vcenter', 'pybind.nos.v7_0_1b.brocade_vswitch', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.vcenter', 'pybind.nos.v7_1_0.brocade_vswitch', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.vcenter', 'pybind.slxos.v16r_1_00b.brocade_vswitch', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'vcenter', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'activate'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vcenter=vcenter)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vcenter=vcenter)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vcenter_discovery_delete(self, vcenter=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vcenter: id
    :param vcenter: Keyword argument tuple.

    :type id: unicode
    :param id: **vcenter** tuple argument:  NAME;;vCenter name (Max Size - 32)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.vcenter', 'vcenter'), ('pybind.nos.v7_0_1b.vcenter', 'vcenter'), ('pybind.nos.v6_0_2c.vcenter', 'vcenter'), ('pybind.slxos.v16r_1_00b.vcenter', 'vcenter')]
    bindings_list = [('pybind.nos.v6_0_2c.vcenter.discovery', 'pybind.nos.v6_0_2c.brocade_vswitch', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.vcenter.discovery', 'pybind.nos.v7_0_1b.brocade_vswitch', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.vcenter.discovery', 'pybind.nos.v7_1_0.brocade_vswitch', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.vcenter.discovery', 'pybind.slxos.v16r_1_00b.brocade_vswitch', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vcenter=vcenter)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vcenter=vcenter)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vcenter_discovery_ignore_delete_all_response_delete(self, vcenter=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vcenter: id
    :param vcenter: Keyword argument tuple.

    :type id: unicode
    :param id: **vcenter** tuple argument:  NAME;;vCenter name (Max Size - 32)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.vcenter', 'vcenter'), ('pybind.nos.v7_1_0.vcenter', 'vcenter'), ('pybind.nos.v7_0_1b.vcenter', 'vcenter'), ('pybind.slxos.v16r_1_00b.vcenter', 'vcenter')]
    bindings_list = [('pybind.nos.v6_0_2c.vcenter.discovery.ignore_delete_all_response', 'pybind.nos.v6_0_2c.brocade_vswitch', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.vcenter.discovery.ignore_delete_all_response', 'pybind.nos.v7_0_1b.brocade_vswitch', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.vcenter.discovery.ignore_delete_all_response', 'pybind.nos.v7_1_0.brocade_vswitch', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.vcenter.discovery.ignore_delete_all_response', 'pybind.slxos.v16r_1_00b.brocade_vswitch', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vcenter=vcenter)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vcenter=vcenter)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vcenter_discovery_ignore_delete_all_response_always_delete(self, vcenter=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vcenter: id
    :param vcenter: Keyword argument tuple.

    :type id: unicode
    :param id: **vcenter** tuple argument:  NAME;;vCenter name (Max Size - 32)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.vcenter', 'vcenter'), ('pybind.nos.v7_1_0.vcenter', 'vcenter'), ('pybind.nos.v7_0_1b.vcenter', 'vcenter'), ('pybind.slxos.v16r_1_00b.vcenter', 'vcenter')]
    bindings_list = [('pybind.nos.v6_0_2c.vcenter.discovery.ignore_delete_all_response', 'pybind.nos.v6_0_2c.brocade_vswitch', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.vcenter.discovery.ignore_delete_all_response', 'pybind.nos.v7_0_1b.brocade_vswitch', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.vcenter.discovery.ignore_delete_all_response', 'pybind.nos.v7_1_0.brocade_vswitch', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.vcenter.discovery.ignore_delete_all_response', 'pybind.slxos.v16r_1_00b.brocade_vswitch', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'always'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vcenter=vcenter)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vcenter=vcenter)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vcenter_discovery_ignore_delete_all_response_ignore_value_delete(self, vcenter=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vcenter: id
    :param vcenter: Keyword argument tuple.

    :type id: unicode
    :param id: **vcenter** tuple argument:  NAME;;vCenter name (Max Size - 32)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.vcenter', 'vcenter'), ('pybind.nos.v7_1_0.vcenter', 'vcenter'), ('pybind.nos.v7_0_1b.vcenter', 'vcenter'), ('pybind.slxos.v16r_1_00b.vcenter', 'vcenter')]
    bindings_list = [('pybind.nos.v6_0_2c.vcenter.discovery.ignore_delete_all_response', 'pybind.nos.v6_0_2c.brocade_vswitch', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.vcenter.discovery.ignore_delete_all_response', 'pybind.nos.v7_0_1b.brocade_vswitch', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.vcenter.discovery.ignore_delete_all_response', 'pybind.nos.v7_1_0.brocade_vswitch', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.vcenter.discovery.ignore_delete_all_response', 'pybind.slxos.v16r_1_00b.brocade_vswitch', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ignore-value'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vcenter=vcenter)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vcenter=vcenter)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vcenter_interval_delete(self, vcenter=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type vcenter: id
    :param vcenter: Keyword argument tuple.

    :type id: unicode
    :param id: **vcenter** tuple argument:  NAME;;vCenter name (Max Size - 32)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.vcenter', 'pybind.nos.v6_0_2c.brocade_vswitch', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.vcenter', 'pybind.nos.v7_0_1b.brocade_vswitch', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.vcenter', 'pybind.nos.v7_1_0.brocade_vswitch', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.vcenter', 'pybind.slxos.v16r_1_00b.brocade_vswitch', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'vcenter', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vcenter=vcenter)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vcenter=vcenter)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vcenter_password_delete(self, vcenter=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vcenter: id
    :param vcenter: Keyword argument tuple.

    :type id: unicode
    :param id: **vcenter** tuple argument:  NAME;;vCenter name (Max Size - 32)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.vcenter', 'vcenter'), ('pybind.nos.v7_0_1b.vcenter', 'vcenter'), ('pybind.slxos.v16r_1_00b.vcenter', 'vcenter'), ('pybind.nos.v7_1_0.vcenter', 'vcenter')]
    bindings_list = [('pybind.nos.v6_0_2c.vcenter.credentials', 'pybind.nos.v6_0_2c.brocade_vswitch', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.vcenter.credentials', 'pybind.nos.v7_0_1b.brocade_vswitch', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.vcenter.credentials', 'pybind.nos.v7_1_0.brocade_vswitch', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.vcenter.credentials', 'pybind.slxos.v16r_1_00b.brocade_vswitch', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'password'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vcenter=vcenter)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vcenter=vcenter)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vcenter_url_delete(self, vcenter=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vcenter: id
    :param vcenter: Keyword argument tuple.

    :type id: unicode
    :param id: **vcenter** tuple argument:  NAME;;vCenter name (Max Size - 32)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.vcenter', 'vcenter'), ('pybind.nos.v7_0_1b.vcenter', 'vcenter'), ('pybind.slxos.v16r_1_00b.vcenter', 'vcenter'), ('pybind.nos.v7_1_0.vcenter', 'vcenter')]
    bindings_list = [('pybind.nos.v6_0_2c.vcenter.credentials', 'pybind.nos.v6_0_2c.brocade_vswitch', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.vcenter.credentials', 'pybind.nos.v7_0_1b.brocade_vswitch', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.vcenter.credentials', 'pybind.nos.v7_1_0.brocade_vswitch', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.vcenter.credentials', 'pybind.slxos.v16r_1_00b.brocade_vswitch', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'url'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vcenter=vcenter)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vcenter=vcenter)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vcenter_use_vrf_delete(self, vcenter=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vcenter: id
    :param vcenter: Keyword argument tuple.

    :type id: unicode
    :param id: **vcenter** tuple argument:  NAME;;vCenter name (Max Size - 32)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.vcenter', 'vcenter'), ('pybind.nos.v7_0_1b.vcenter', 'vcenter')]
    bindings_list = [('pybind.nos.v7_0_1b.vcenter.credentials', 'pybind.nos.v7_0_1b.brocade_vswitch', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.vcenter.credentials', 'pybind.nos.v7_1_0.brocade_vswitch', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'use-vrf'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vcenter=vcenter)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vcenter=vcenter)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vcenter_username_delete(self, vcenter=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vcenter: id
    :param vcenter: Keyword argument tuple.

    :type id: unicode
    :param id: **vcenter** tuple argument:  NAME;;vCenter name (Max Size - 32)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.vcenter', 'vcenter'), ('pybind.nos.v7_0_1b.vcenter', 'vcenter'), ('pybind.slxos.v16r_1_00b.vcenter', 'vcenter'), ('pybind.nos.v7_1_0.vcenter', 'vcenter')]
    bindings_list = [('pybind.nos.v6_0_2c.vcenter.credentials', 'pybind.nos.v6_0_2c.brocade_vswitch', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.vcenter.credentials', 'pybind.nos.v7_0_1b.brocade_vswitch', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.vcenter.credentials', 'pybind.nos.v7_1_0.brocade_vswitch', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.vcenter.credentials', 'pybind.slxos.v16r_1_00b.brocade_vswitch', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'username'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vcenter=vcenter)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vcenter=vcenter)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vcs_auto_config_backup_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_1_0.vcs.auto_config_backup', 'pybind.nos.v7_1_0.brocade_vcs', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vcs_auto_config_backup_timer_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.1.0    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_1_0.vcs.auto_config_backup', 'pybind.nos.v7_1_0.brocade_vcs', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'timer'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vcs_virtual_fabric_enable_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.vcs.virtual_fabric', 'pybind.nos.v6_0_2c.brocade_vcs', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.vcs.virtual_fabric', 'pybind.nos.v7_0_1b.brocade_vcs', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.vcs.virtual_fabric', 'pybind.nos.v7_1_0.brocade_vcs', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.vcs.virtual_fabric', 'pybind.slxos.v16r_1_00b.brocade_vcs', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vcs_virtual_ip_address_delete(self, address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type address: address
    :param address: Keyword argument tuple.

    :type address: unicode
    :param address: **address** tuple argument:  Virtual IP address (IPv4 Address/Prefix)

        * pattern restriction: ::

            '((0|(1[0-9]{0,2})|(2(([0-4][0-9]?)|(5[0-5]?)|([6'
            '-9]?)))|([3-9][0-9]?))\.){3}(0|(1[0-9]{0,2})|(2('
            '([0-4][0-9]?)|(5[0-5]?)|([6-9]?)))|([3-9][0-9]?)'
            ')/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.vcs.virtual.ip.address', 'pybind.nos.v6_0_2c.brocade_vcs', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.vcs.virtual.ip.address', 'pybind.nos.v7_0_1b.brocade_vcs', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.vcs.virtual.ip.address', 'pybind.nos.v7_1_0.brocade_vcs', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.vcs.virtual.ip.address', 'pybind.slxos.v16r_1_00b.brocade_vcs', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'address', 'keyval': 'address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, address=address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, address=address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vcs_virtual_ip_address_inband_delete(self, address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type address: address
    :param address: Keyword argument tuple.

    :type address: unicode
    :param address: **address** tuple argument:  Virtual IP address (IPv4 Address/Prefix)

        * pattern restriction: ::

            '((0|(1[0-9]{0,2})|(2(([0-4][0-9]?)|(5[0-5]?)|([6'
            '-9]?)))|([3-9][0-9]?))\.){3}(0|(1[0-9]{0,2})|(2('
            '([0-4][0-9]?)|(5[0-5]?)|([6-9]?)))|([3-9][0-9]?)'
            ')/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.vcs.virtual.ip.address', u'address'), ('pybind.nos.v6_0_2c.vcs.virtual.ip.address', u'address'), ('pybind.nos.v7_0_1b.vcs.virtual.ip.address', u'address'), ('pybind.nos.v7_1_0.vcs.virtual.ip.address', u'address')]
    bindings_list = [('pybind.nos.v6_0_2c.vcs.virtual.ip.address.inband', 'pybind.nos.v6_0_2c.brocade_vcs', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.vcs.virtual.ip.address.inband', 'pybind.nos.v7_0_1b.brocade_vcs', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.vcs.virtual.ip.address.inband', 'pybind.nos.v7_1_0.brocade_vcs', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.vcs.virtual.ip.address.inband', 'pybind.slxos.v16r_1_00b.brocade_vcs', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'address', 'extra_keyval': ''}, {'keyval': 'address', 'extra_keyval': ''}, {'keyval': 'address', 'extra_keyval': ''}, {'keyval': 'address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, address=address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, address=address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vcs_virtual_ip_address_inband_interface_ve_delete(self, address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type address: address
    :param address: Keyword argument tuple.

    :type address: unicode
    :param address: **address** tuple argument:  Virtual IP address (IPv4 Address/Prefix)

        * pattern restriction: ::

            '((0|(1[0-9]{0,2})|(2(([0-4][0-9]?)|(5[0-5]?)|([6'
            '-9]?)))|([3-9][0-9]?))\.){3}(0|(1[0-9]{0,2})|(2('
            '([0-4][0-9]?)|(5[0-5]?)|([6-9]?)))|([3-9][0-9]?)'
            ')/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.vcs.virtual.ip.address', u'address'), ('pybind.slxos.v16r_1_00b.vcs.virtual.ip.address', u'address'), ('pybind.nos.v6_0_2c.vcs.virtual.ip.address', u'address'), ('pybind.nos.v7_0_1b.vcs.virtual.ip.address', u'address')]
    bindings_list = [('pybind.nos.v6_0_2c.vcs.virtual.ip.address.inband.interface', 'pybind.nos.v6_0_2c.brocade_vcs', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.vcs.virtual.ip.address.inband.interface', 'pybind.nos.v7_0_1b.brocade_vcs', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.vcs.virtual.ip.address.inband.interface', 'pybind.nos.v7_1_0.brocade_vcs', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.vcs.virtual.ip.address.inband.interface', 'pybind.slxos.v16r_1_00b.brocade_vcs', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'address', 'extra_keyval': ''}, {'keyval': 'address', 'extra_keyval': ''}, {'keyval': 'address', 'extra_keyval': ''}, {'keyval': 'address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 've'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, address=address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, address=address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vcs_virtual_ipv6_address_delete(self, address=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type address: ipv6address
    :param address: Keyword argument tuple.

    :type ipv6address: unicode
    :param ipv6address: **address** tuple argument:  Virtual IPV6 address (IPv6 Address/Prefix)

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.vcs.virtual.ipv6.address', 'pybind.nos.v6_0_2c.brocade_vcs', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.vcs.virtual.ipv6.address', 'pybind.nos.v7_0_1b.brocade_vcs', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.vcs.virtual.ipv6.address', 'pybind.nos.v7_1_0.brocade_vcs', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.vcs.virtual.ipv6.address', 'pybind.slxos.v16r_1_00b.brocade_vcs', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'address', 'keyval': 'ipv6address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, address=address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, address=address)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vcsmode_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.vcsmode', 'pybind.nos.v6_0_2c.brocade_vcs', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.vcsmode', 'pybind.nos.v7_0_1b.brocade_vcs', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.vcsmode', 'pybind.nos.v7_1_0.brocade_vcs', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.vcsmode', 'pybind.slxos.v16r_1_00b.brocade_vcs', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vcsmode_vcs_cluster_mode_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.vcsmode', 'pybind.nos.v6_0_2c.brocade_vcs', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.vcsmode', 'pybind.nos.v7_0_1b.brocade_vcs', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.vcsmode', 'pybind.nos.v7_1_0.brocade_vcs', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.vcsmode', 'pybind.slxos.v16r_1_00b.brocade_vcs', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vcs-cluster-mode'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vcsmode_vcs_mode_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.vcsmode', 'pybind.nos.v6_0_2c.brocade_vcs', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.vcsmode', 'pybind.nos.v7_0_1b.brocade_vcs', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.vcsmode', 'pybind.nos.v7_1_0.brocade_vcs', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.vcsmode', 'pybind.slxos.v16r_1_00b.brocade_vcs', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vcs-mode'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vlag_commit_mode_disable_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.0.1b, 7.1.0    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_0_1b.vlag_commit_mode', 'pybind.nos.v7_0_1b.brocade_lacp', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.vlag_commit_mode', 'pybind.nos.v7_1_0.brocade_lacp', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'disable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vlan_delete(self, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.interface_vlan.interface.vlan', 'pybind.nos.v6_0_2c.brocade_interface', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.interface_vlan.interface.vlan', 'pybind.nos.v7_0_1b.brocade_interface', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.interface_vlan.interface.vlan', 'pybind.nos.v7_1_0.brocade_interface', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.interface_vlan.vlan', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v6_0_2c.interface_vlan.interface.vlan": {"name": "name", "vlan_name": "vlan_name", "transport_service": "transport_service", "ifindex": "ifindex", "remote_span": "remote_span", "description": "description"}, "pybind.nos.v7_1_0.interface_vlan.interface.vlan": {"name": "name", "vlan_name": "vlan_name", "transport_service": "transport_service", "ifindex": "ifindex", "remote_span": "remote_span", "description": "description"}, "pybind.nos.v7_0_1b.interface_vlan.interface.vlan": {"name": "name", "vlan_name": "vlan_name", "transport_service": "transport_service", "ifindex": "ifindex", "remote_span": "remote_span", "description": "description"}, "pybind.slxos.v16r_1_00b.interface_vlan.vlan": {"ifindex": "ifindex", "remote_span": "remote_span", "name": "name", "vlan_name": "vlan_name", "description": "description"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vlan_classifier_group_delete(self, group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Instance Keyword Argument Tuple**:

    :type group: groupid, oper, rule_name, ruleid
    :param group: Keyword argument tuple.

    :type groupid: long
    :param groupid: **group** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type oper: unicode
    :param oper: **group** tuple argument:  Add/Delete Rule.

        * enumeration restriction: ::

            ['add', 'delete']

    :type rule_name: unicode
    :param rule_name: **group** tuple argument.

        * enumeration restriction: ::

            ['rule']

    :type ruleid: long
    :param ruleid: **group** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.vlan.classifier.group', 'pybind.nos.v6_0_2c.brocade_vlan', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.vlan.classifier.group', 'pybind.nos.v7_0_1b.brocade_vlan', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.vlan.classifier.group', 'pybind.nos.v7_1_0.brocade_vlan', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'group', 'keyval': 'groupid, oper, rule_name, ruleid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, group=group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, group=group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vlan_classifier_rule_delete(self, rule=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Instance Keyword Argument Tuple**:

    :type rule: ruleid
    :param rule: Keyword argument tuple.

    :type ruleid: long
    :param ruleid: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.vlan.classifier.rule', 'pybind.nos.v6_0_2c.brocade_vlan', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.vlan.classifier.rule', 'pybind.nos.v7_0_1b.brocade_vlan', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.vlan.classifier.rule', 'pybind.nos.v7_1_0.brocade_vlan', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'rule', 'keyval': 'ruleid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_0_1b.vlan.classifier.rule': [u'mac', u'proto'], 'pybind.nos.v7_1_0.vlan.classifier.rule': [u'mac', u'proto'], 'pybind.nos.v6_0_2c.vlan.classifier.rule': [u'mac', u'proto']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vlan_classifier_rule_mac_delete(self, rule=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: ruleid
    :param rule: Keyword argument tuple.

    :type ruleid: long
    :param ruleid: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.vlan.classifier.rule', u'rule'), ('pybind.nos.v7_0_1b.vlan.classifier.rule', u'rule'), ('pybind.nos.v7_1_0.vlan.classifier.rule', u'rule')]
    bindings_list = [('pybind.nos.v6_0_2c.vlan.classifier.rule.mac', 'pybind.nos.v6_0_2c.brocade_vlan', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.vlan.classifier.rule.mac', 'pybind.nos.v7_0_1b.brocade_vlan', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.vlan.classifier.rule.mac', 'pybind.nos.v7_1_0.brocade_vlan', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ruleid', 'extra_keyval': ''}, {'keyval': 'ruleid', 'extra_keyval': ''}, {'keyval': 'ruleid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_0_1b.vlan.classifier.rule.mac': [u'address'], 'pybind.nos.v7_1_0.vlan.classifier.rule.mac': [u'address'], 'pybind.nos.v6_0_2c.vlan.classifier.rule.mac': [u'address']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vlan_classifier_rule_mac_address_delete(self, rule=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: ruleid
    :param rule: Keyword argument tuple.

    :type ruleid: long
    :param ruleid: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.vlan.classifier.rule', u'rule'), ('pybind.nos.v7_0_1b.vlan.classifier.rule', u'rule'), ('pybind.nos.v7_1_0.vlan.classifier.rule', u'rule')]
    bindings_list = [('pybind.nos.v6_0_2c.vlan.classifier.rule.mac', 'pybind.nos.v6_0_2c.brocade_vlan', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.vlan.classifier.rule.mac', 'pybind.nos.v7_0_1b.brocade_vlan', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.vlan.classifier.rule.mac', 'pybind.nos.v7_1_0.brocade_vlan', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ruleid', 'extra_keyval': ''}, {'keyval': 'ruleid', 'extra_keyval': ''}, {'keyval': 'ruleid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'address'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vlan_classifier_rule_proto_delete(self, rule=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: ruleid
    :param rule: Keyword argument tuple.

    :type ruleid: long
    :param ruleid: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.vlan.classifier.rule', u'rule'), ('pybind.nos.v7_0_1b.vlan.classifier.rule', u'rule'), ('pybind.nos.v6_0_2c.vlan.classifier.rule', u'rule')]
    bindings_list = [('pybind.nos.v6_0_2c.vlan.classifier.rule.proto', 'pybind.nos.v6_0_2c.brocade_vlan', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.vlan.classifier.rule.proto', 'pybind.nos.v7_0_1b.brocade_vlan', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.vlan.classifier.rule.proto', 'pybind.nos.v7_1_0.brocade_vlan', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ruleid', 'extra_keyval': ''}, {'keyval': 'ruleid', 'extra_keyval': ''}, {'keyval': 'ruleid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'proto_val, encap'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_0_1b.vlan.classifier.rule.proto': [u'proto_val'], 'pybind.nos.v6_0_2c.vlan.classifier.rule.proto': [u'proto_val'], 'pybind.nos.v7_1_0.vlan.classifier.rule.proto': [u'proto_val']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vlan_classifier_rule_proto_encap_delete(self, rule=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: ruleid
    :param rule: Keyword argument tuple.

    :type ruleid: long
    :param ruleid: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.vlan.classifier.rule', u'rule'), ('pybind.nos.v7_0_1b.vlan.classifier.rule', u'rule'), ('pybind.nos.v6_0_2c.vlan.classifier.rule', u'rule')]
    bindings_list = [('pybind.nos.v6_0_2c.vlan.classifier.rule.proto', 'pybind.nos.v6_0_2c.brocade_vlan', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.vlan.classifier.rule.proto', 'pybind.nos.v7_0_1b.brocade_vlan', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.vlan.classifier.rule.proto', 'pybind.nos.v7_1_0.brocade_vlan', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ruleid', 'extra_keyval': ''}, {'keyval': 'ruleid', 'extra_keyval': ''}, {'keyval': 'ruleid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'encap'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vlan_classifier_rule_proto_proto_val_delete(self, rule=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: ruleid
    :param rule: Keyword argument tuple.

    :type ruleid: long
    :param ruleid: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.vlan.classifier.rule', u'rule'), ('pybind.nos.v7_0_1b.vlan.classifier.rule', u'rule'), ('pybind.nos.v6_0_2c.vlan.classifier.rule', u'rule')]
    bindings_list = [('pybind.nos.v6_0_2c.vlan.classifier.rule.proto', 'pybind.nos.v6_0_2c.brocade_vlan', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.vlan.classifier.rule.proto', 'pybind.nos.v7_0_1b.brocade_vlan', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.vlan.classifier.rule.proto', 'pybind.nos.v7_1_0.brocade_vlan', 'pybind.nos.v7_1_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ruleid', 'extra_keyval': ''}, {'keyval': 'ruleid', 'extra_keyval': ''}, {'keyval': 'ruleid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'proto-val'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vlan_description_delete(self, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.interface_vlan.vlan', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'description'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vlan_dot1q_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.vlan.dot1q', 'pybind.nos.v6_0_2c.brocade_vlan', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.vlan.dot1q', 'pybind.nos.v7_0_1b.brocade_vlan', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.vlan.dot1q', 'pybind.nos.v7_1_0.brocade_vlan', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.vlan.dot1q', 'pybind.slxos.v16r_1_00b.brocade_vlan', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vlan_dot1q_tag_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.vlan.dot1q.tag', 'pybind.nos.v6_0_2c.brocade_vlan', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.vlan.dot1q.tag', 'pybind.nos.v7_0_1b.brocade_vlan', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.vlan.dot1q.tag', 'pybind.nos.v7_1_0.brocade_vlan', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.vlan.dot1q.tag', 'pybind.slxos.v16r_1_00b.brocade_vlan', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vlan_dot1q_tag_native_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.vlan.dot1q.tag', 'pybind.nos.v6_0_2c.brocade_vlan', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.vlan.dot1q.tag', 'pybind.nos.v7_0_1b.brocade_vlan', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.vlan.dot1q.tag', 'pybind.nos.v7_1_0.brocade_vlan', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.vlan.dot1q.tag', 'pybind.slxos.v16r_1_00b.brocade_vlan', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'native'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vlan_ifindex_delete(self, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.interface_vlan.vlan', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'ifindex'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vlan_ip_arp_inspection_delete(self, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface_vlan.vlan', u'vlan')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface_vlan.vlan.ip.arp.inspection', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vlan_ip_arp_inspection_filter_delete(self, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface_vlan.vlan', u'vlan')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface_vlan.vlan.ip.arp.inspection.filter', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vlan_ip_arp_inspection_filter_acl_name_delete(self, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface_vlan.vlan', u'vlan')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface_vlan.vlan.ip.arp.inspection.filter', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'acl-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vlan_ip_arp_inspection_logging_acl_match_delete(self, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface_vlan.vlan', u'vlan')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface_vlan.vlan.ip.arp.inspection.logging', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'acl-match'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vlan_ip_arp_inspection_trust_delete(self, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface_vlan.vlan', u'vlan')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface_vlan.vlan.ip.arp.inspection', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'trust'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vlan_ip_igmp_snooping_enable_delete(self, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface_vlan.vlan', u'vlan')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface_vlan.vlan.ip.igmpVlan.snooping', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vlan_ip_igmp_snooping_fast_leave_delete(self, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface_vlan.vlan', u'vlan')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface_vlan.vlan.ip.igmpVlan.snooping', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'fast-leave'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vlan_ip_igmp_snooping_last_member_query_interval_delete(self, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface_vlan.vlan', u'vlan')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface_vlan.vlan.ip.igmpVlan.snooping', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'last-member-query-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vlan_ip_igmp_snooping_mrouter_interface_delete(self, vlan=None, igmps_interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type igmps_interface: igmps_if_type, igmps_value
    :param igmps_interface: Keyword argument tuple.

    :type igmps_if_type: unicode
    :param igmps_if_type: **igmps_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 'port-channel']

    :type igmps_value: unicode
    :param igmps_value: **igmps_interface** tuple argument.

        * length restriction: ::

            ['1..10']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface_vlan.vlan', u'vlan')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface_vlan.vlan.ip.igmpVlan.snooping.igmps_mrouter.igmps_interface', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'igmps_interface', 'keyval': 'igmps_if_type, igmps_value', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan, igmps_interface=igmps_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan, igmps_interface=igmps_interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vlan_ip_igmp_snooping_querier_enable_delete(self, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface_vlan.vlan', u'vlan')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface_vlan.vlan.ip.igmpVlan.snooping.igmps_querier', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vlan_ip_igmp_snooping_query_interval_delete(self, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface_vlan.vlan', u'vlan')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface_vlan.vlan.ip.igmpVlan.snooping', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'query-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vlan_ip_igmp_snooping_query_max_response_time_delete(self, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface_vlan.vlan', u'vlan')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface_vlan.vlan.ip.igmpVlan.snooping', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'query-max-response-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vlan_ip_igmp_snooping_static_group_delete(self, vlan=None, igmps_static_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type igmps_static_group: igmps_mcast_address, igmps_interface, igmps_if_type, igmps_value
    :param igmps_static_group: Keyword argument tuple.

    :type igmps_mcast_address: unicode
    :param igmps_mcast_address: **igmps_static_group** tuple argument:  Multicast Address to be Joined in the format A.B.C.D

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type igmps_interface: unicode
    :param igmps_interface: **igmps_static_group** tuple argument.

        * enumeration restriction: ::

            ['interface']

    :type igmps_if_type: unicode
    :param igmps_if_type: **igmps_static_group** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 'port-channel']

    :type igmps_value: unicode
    :param igmps_value: **igmps_static_group** tuple argument.

        * length restriction: ::

            ['1..10']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface_vlan.vlan', u'vlan')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface_vlan.vlan.ip.igmpVlan.snooping.igmps_static_group', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'igmps_static_group', 'keyval': 'igmps_mcast_address, igmps_interface, igmps_if_type, igmps_value', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan, igmps_static_group=igmps_static_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan, igmps_static_group=igmps_static_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vlan_ip_igmp_snooping_version_delete(self, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface_vlan.vlan', u'vlan')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface_vlan.vlan.ip.igmpVlan.snooping', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'version'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vlan_ip_pim_snooping_enable_delete(self, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface_vlan.vlan', u'vlan')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface_vlan.vlan.ip.igmpPIM.snooping', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vlan_ipv6_mld_snooping_enable_delete(self, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface_vlan.vlan', u'vlan')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface_vlan.vlan.ipv6.mldVlan.snooping', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vlan_ipv6_mld_snooping_fast_leave_delete(self, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface_vlan.vlan', u'vlan')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface_vlan.vlan.ipv6.mldVlan.snooping', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'fast-leave'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vlan_ipv6_mld_snooping_last_member_query_count_delete(self, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface_vlan.vlan', u'vlan')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface_vlan.vlan.ipv6.mldVlan.snooping', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'last-member-query-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vlan_ipv6_mld_snooping_last_member_query_interval_delete(self, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface_vlan.vlan', u'vlan')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface_vlan.vlan.ipv6.mldVlan.snooping', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'last-member-query-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vlan_ipv6_mld_snooping_mrouter_interface_delete(self, vlan=None, interface=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type interface: if_type, value
    :param interface: Keyword argument tuple.

    :type if_type: unicode
    :param if_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['Ethernet', 'Port-channel']

    :type value: unicode
    :param value: **interface** tuple argument.

        * length restriction: ::

            ['1..10']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface_vlan.vlan', u'vlan')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface_vlan.vlan.ipv6.mldVlan.snooping.mrouter.interface', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'if_type, value', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan, interface=interface)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vlan_ipv6_mld_snooping_querier_enable_delete(self, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface_vlan.vlan', u'vlan')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface_vlan.vlan.ipv6.mldVlan.snooping.querier', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vlan_ipv6_mld_snooping_query_interval_delete(self, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface_vlan.vlan', u'vlan')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface_vlan.vlan.ipv6.mldVlan.snooping', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'query-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vlan_ipv6_mld_snooping_query_max_response_time_delete(self, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface_vlan.vlan', u'vlan')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface_vlan.vlan.ipv6.mldVlan.snooping', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'query-max-response-time'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vlan_ipv6_mld_snooping_startup_query_count_delete(self, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface_vlan.vlan', u'vlan')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface_vlan.vlan.ipv6.mldVlan.snooping', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'startup-query-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vlan_ipv6_mld_snooping_startup_query_interval_delete(self, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface_vlan.vlan', u'vlan')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface_vlan.vlan.ipv6.mldVlan.snooping', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'startup-query-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vlan_ipv6_mld_snooping_static_group_delete(self, vlan=None, static_group=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type static_group: mcast_address, interface, if_type, value
    :param static_group: Keyword argument tuple.

    :type mcast_address: unicode
    :param mcast_address: **static_group** tuple argument:  Multicast Address to be Joined in format xxxx:xxxx/ml, xxxx:xxxx::/ml

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type interface: unicode
    :param interface: **static_group** tuple argument.

        * enumeration restriction: ::

            ['interface']

    :type if_type: unicode
    :param if_type: **static_group** tuple argument.

        * enumeration restriction: ::

            ['Ethernet', 'Port-channel']

    :type value: unicode
    :param value: **static_group** tuple argument.

        * length restriction: ::

            ['1..10']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface_vlan.vlan', u'vlan')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface_vlan.vlan.ipv6.mldVlan.snooping.static_group', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'static_group', 'keyval': 'mcast_address, interface, if_type, value', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan, static_group=static_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan, static_group=static_group)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vlan_ipv6_mld_snooping_version_delete(self, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface_vlan.vlan', u'vlan')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface_vlan.vlan.ipv6.mldVlan.snooping', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'version'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vlan_ipv6_pim_snooping_enable_delete(self, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface_vlan.vlan', u'vlan')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface_vlan.vlan.ipv6.mldPIM.snooping', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'enable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vlan_mac_delete(self, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface_vlan.vlan', u'vlan')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface_vlan.vlan.mac', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vlan_mac_access_group_delete(self, vlan=None, access_group=None, traffic_type=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type access_group: mac_access_list, mac_direction, traffic_type
    :param access_group: Keyword argument tuple.

    :type mac_access_list: unicode
    :param mac_access_list: **access_group** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type mac_direction: unicode
    :param mac_direction: **access_group** tuple argument.

        * enumeration restriction: ::

            ['in', 'out']

    :type traffic_type: unicode
    :param traffic_type: **access_group** tuple argument.

        * enumeration restriction: ::

            ['switched', 'routed']

    **Instance Argument(s)**:

    :type traffic_type: unicode
    :param traffic_type: Keyword argument.

        * enumeration restriction: ::

            ['switched', 'routed']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface_vlan.vlan', u'vlan')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface_vlan.vlan.mac.access_group', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'access_group', 'keyval': 'mac_access_list, mac_direction', 'extra_keyval': 'mac_access_list, mac_direction, traffic_type'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan, access_group=access_group, traffic_type=traffic_type)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan, access_group=access_group, traffic_type=traffic_type)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vlan_name_delete(self, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.interface_vlan.vlan', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vlan_router_interface_ve_delete(self, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface_vlan.vlan', u'vlan')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface_vlan.vlan.router_interface', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'Ve'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vlan_rspan_vlan_delete(self, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.interface_vlan.vlan', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rspan-vlan'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vlan_spanning_tree_shutdown_delete(self, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.interface_vlan.vlan', u'vlan')]
    bindings_list = [('pybind.slxos.v16r_1_00b.interface_vlan.vlan.spanning_tree', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'shutdown'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vlan_statistics_delete(self, vlan=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.interface_vlan.vlan', 'pybind.slxos.v16r_1_00b.brocade_interface', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'statistics'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vrf_delete(self, vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.vrf', 'pybind.slxos.v16r_1_00b.brocade_vrf', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'vrf', 'keyval': 'vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vrf_address_family_delete(self, vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.vrf.address_family', 'pybind.slxos.v16r_1_00b.brocade_vrf', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vrf_address_family_ipv4_unicast_delete(self, vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.vrf.address_family.ip.unicast', 'pybind.slxos.v16r_1_00b.brocade_vrf', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vrf_address_family_ipv4_unicast_arp_delete(self, vrf=None, arp_entry=None, mac_address_value=None, interfacename=None, Ethernet=None, Ve=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type arp_entry: arp_ip_address, mac_address_value, interfacename, Ethernet, Ve
    :param arp_entry: Keyword argument tuple.

    :type arp_ip_address: unicode
    :param arp_ip_address: **arp_entry** tuple argument:  A.B.C.D;; IP address of the ARP entry

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type mac_address_value: unicode
    :param mac_address_value: **arp_entry** tuple argument.

    :type interfacename: unicode
    :param interfacename: **arp_entry** tuple argument.

        * enumeration restriction: ::

            ['interface']

    :type Ethernet: unicode
    :param Ethernet: **arp_entry** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type Ve: long
    :param Ve: **arp_entry** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Argument(s)**:

    :type mac_address_value: unicode
    :param mac_address_value: Keyword argument.

    :type interfacename: unicode
    :param interfacename: Keyword argument.

        * enumeration restriction: ::

            ['interface']

    :type Ethernet: unicode
    :param Ethernet: Choice keyword argument (Only one choice argument allowed per API invocation).

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type Ve: long
    :param Ve: Choice keyword argument (Only one choice argument allowed per API invocation).

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.vrf.address_family.ip.unicast.arp_entry', 'pybind.slxos.v16r_1_00b.brocade_vrf', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'arp_entry', 'keyval': 'arp_ip_address', 'extra_keyval': 'arp_ip_address, mac_address_value, interfacename, Ethernet, Ve'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v16r_1_00b.vrf.address_family.ip.unicast.arp_entry': [u'Ethernet', u'Ve']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf, arp_entry=arp_entry, mac_address_value=mac_address_value, interfacename=interfacename, Ethernet=Ethernet, Ve=Ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf, arp_entry=arp_entry, mac_address_value=mac_address_value, interfacename=interfacename, Ethernet=Ethernet, Ve=Ve)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vrf_address_family_ipv4_unicast_arp_ethernet_delete(self, vrf=None, arp_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type arp_entry: arp_ip_address
    :param arp_entry: Keyword argument tuple.

    :type arp_ip_address: unicode
    :param arp_ip_address: **arp_entry** tuple argument:  A.B.C.D;; IP address of the ARP entry

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.vrf.address_family.ip.unicast.arp_entry', 'pybind.slxos.v16r_1_00b.brocade_vrf', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'arp_entry', 'keyval': 'arp_ip_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'Ethernet'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf, arp_entry=arp_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf, arp_entry=arp_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vrf_address_family_ipv4_unicast_arp_interfacename_delete(self, vrf=None, arp_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type arp_entry: arp_ip_address
    :param arp_entry: Keyword argument tuple.

    :type arp_ip_address: unicode
    :param arp_ip_address: **arp_entry** tuple argument:  A.B.C.D;; IP address of the ARP entry

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.vrf.address_family.ip.unicast.arp_entry', 'pybind.slxos.v16r_1_00b.brocade_vrf', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'arp_entry', 'keyval': 'arp_ip_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'interfacename'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf, arp_entry=arp_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf, arp_entry=arp_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vrf_address_family_ipv4_unicast_arp_mac_address_value_delete(self, vrf=None, arp_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type arp_entry: arp_ip_address
    :param arp_entry: Keyword argument tuple.

    :type arp_ip_address: unicode
    :param arp_ip_address: **arp_entry** tuple argument:  A.B.C.D;; IP address of the ARP entry

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.vrf.address_family.ip.unicast.arp_entry', 'pybind.slxos.v16r_1_00b.brocade_vrf', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'arp_entry', 'keyval': 'arp_ip_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mac-address-value'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf, arp_entry=arp_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf, arp_entry=arp_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vrf_address_family_ipv4_unicast_arp_ve_delete(self, vrf=None, arp_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type arp_entry: arp_ip_address
    :param arp_entry: Keyword argument tuple.

    :type arp_ip_address: unicode
    :param arp_ip_address: **arp_entry** tuple argument:  A.B.C.D;; IP address of the ARP entry

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.vrf.address_family.ip.unicast.arp_entry', 'pybind.slxos.v16r_1_00b.brocade_vrf', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'arp_entry', 'keyval': 'arp_ip_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'Ve'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf, arp_entry=arp_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf, arp_entry=arp_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vrf_address_family_ipv4_unicast_ip_delete(self, vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.vrf.address_family.ip.unicast.ip', 'pybind.slxos.v16r_1_00b.brocade_vrf', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vrf_address_family_ipv4_unicast_ip_import_delete(self, vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.vrf.address_family.ip.unicast.ip.import_', 'pybind.slxos.v16r_1_00b.brocade_vrf', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vrf_address_family_ipv4_unicast_ip_import_routes_delete(self, vrf=None, routes=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type routes: src_vrf, route_map
    :param routes: Keyword argument tuple.

    :type src_vrf: unicode
    :param src_vrf: **routes** tuple argument:  ASCII string;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type route_map: unicode
    :param route_map: **routes** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.vrf.address_family.ip.unicast.ip.import_.routes', 'pybind.slxos.v16r_1_00b.brocade_vrf', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'routes', 'keyval': 'src_vrf, route_map', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf, routes=routes)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf, routes=routes)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vrf_address_family_ipv4_unicast_ip_route_static_delete(self, vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.vrf.address_family.ip.unicast.ip.route.static', 'pybind.slxos.v16r_1_00b.brocade_vrf', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vrf_address_family_ipv4_unicast_ip_route_static_bfd_delete(self, vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.vrf.address_family.ip.unicast.ip.route.static.bfd', 'pybind.slxos.v16r_1_00b.brocade_vrf', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vrf_address_family_ipv4_unicast_ip_route_static_bfd_bfd_static_route_delete(self, vrf=None, bfd_static_route=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type bfd_static_route: bfd_static_route_dest, bfd_static_route_src
    :param bfd_static_route: Keyword argument tuple.

    :type bfd_static_route_dest: unicode
    :param bfd_static_route_dest: **bfd_static_route** tuple argument:  A.B.C.D ;; Destination IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type bfd_static_route_src: unicode
    :param bfd_static_route_src: **bfd_static_route** tuple argument:  A.B.C.D ;; Source IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.vrf.address_family.ip.unicast.ip.route.static.bfd.bfd_static_route', 'pybind.slxos.v16r_1_00b.brocade_vrf', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'bfd_static_route', 'keyval': 'bfd_static_route_dest, bfd_static_route_src', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf, bfd_static_route=bfd_static_route)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf, bfd_static_route=bfd_static_route)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vrf_address_family_ipv4_unicast_ip_route_static_bfd_holdover_interval_delete(self, vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.vrf.address_family.ip.unicast.ip.route.static.bfd', 'pybind.slxos.v16r_1_00b.brocade_vrf', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'holdover-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vrf_address_family_ipv4_unicast_ip_route_static_route_nh_delete(self, vrf=None, static_route_nh=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type static_route_nh: static_route_dest, static_route_next_hop
    :param static_route_nh: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_nh** tuple argument:  A.B.C.D/L ;; Destination IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type static_route_next_hop: unicode
    :param static_route_next_hop: **static_route_nh** tuple argument:  A.B.C.D ;; Next hop IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.vrf.address_family.ip.unicast.ip.route.static_route_nh', 'pybind.slxos.v16r_1_00b.brocade_vrf', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'static_route_nh', 'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf, static_route_nh=static_route_nh)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf, static_route_nh=static_route_nh)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vrf_address_family_ipv4_unicast_ip_route_static_route_nh_distance_delete(self, vrf=None, static_route_nh=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type static_route_nh: static_route_dest, static_route_next_hop
    :param static_route_nh: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_nh** tuple argument:  A.B.C.D/L ;; Destination IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type static_route_next_hop: unicode
    :param static_route_next_hop: **static_route_nh** tuple argument:  A.B.C.D ;; Next hop IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.vrf', 'vrf'), ('pybind.slxos.v16r_1_00b.vrf.address_family.ip.unicast.ip.route.static_route_nh', u'static_route_nh')]
    bindings_list = [('pybind.slxos.v16r_1_00b.vrf.address_family.ip.unicast.ip.route.static_route_nh.route_attributes', 'pybind.slxos.v16r_1_00b.brocade_vrf', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'distance'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf, static_route_nh=static_route_nh)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf, static_route_nh=static_route_nh)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vrf_address_family_ipv4_unicast_ip_route_static_route_nh_metric_delete(self, vrf=None, static_route_nh=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type static_route_nh: static_route_dest, static_route_next_hop
    :param static_route_nh: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_nh** tuple argument:  A.B.C.D/L ;; Destination IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type static_route_next_hop: unicode
    :param static_route_next_hop: **static_route_nh** tuple argument:  A.B.C.D ;; Next hop IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.vrf', 'vrf'), ('pybind.slxos.v16r_1_00b.vrf.address_family.ip.unicast.ip.route.static_route_nh', u'static_route_nh')]
    bindings_list = [('pybind.slxos.v16r_1_00b.vrf.address_family.ip.unicast.ip.route.static_route_nh.route_attributes', 'pybind.slxos.v16r_1_00b.brocade_vrf', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf, static_route_nh=static_route_nh)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf, static_route_nh=static_route_nh)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vrf_address_family_ipv4_unicast_ip_route_static_route_nh_tag_delete(self, vrf=None, static_route_nh=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type static_route_nh: static_route_dest, static_route_next_hop
    :param static_route_nh: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_nh** tuple argument:  A.B.C.D/L ;; Destination IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type static_route_next_hop: unicode
    :param static_route_next_hop: **static_route_nh** tuple argument:  A.B.C.D ;; Next hop IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.vrf', 'vrf'), ('pybind.slxos.v16r_1_00b.vrf.address_family.ip.unicast.ip.route.static_route_nh', u'static_route_nh')]
    bindings_list = [('pybind.slxos.v16r_1_00b.vrf.address_family.ip.unicast.ip.route.static_route_nh.route_attributes', 'pybind.slxos.v16r_1_00b.brocade_vrf', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf, static_route_nh=static_route_nh)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf, static_route_nh=static_route_nh)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vrf_address_family_ipv4_unicast_ip_route_static_route_nh_vrf_delete(self, vrf=None, static_route_nh_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type static_route_nh_vrf: static_route_next_vrf_dest, next_hop_vrf, static_route_next_hop
    :param static_route_nh_vrf: Keyword argument tuple.

    :type static_route_next_vrf_dest: unicode
    :param static_route_next_vrf_dest: **static_route_nh_vrf** tuple argument:  A.B.C.D/L ;; Destination IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type next_hop_vrf: unicode
    :param next_hop_vrf: **static_route_nh_vrf** tuple argument:  Next Hop Vrf Name

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type static_route_next_hop: unicode
    :param static_route_next_hop: **static_route_nh_vrf** tuple argument:  A.B.C.D ;; Next hop IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.vrf.address_family.ip.unicast.ip.route.static_route_nh_vrf', 'pybind.slxos.v16r_1_00b.brocade_vrf', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'static_route_nh_vrf', 'keyval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_next_hop', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf, static_route_nh_vrf=static_route_nh_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf, static_route_nh_vrf=static_route_nh_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vrf_address_family_ipv4_unicast_ip_route_static_route_oif_delete(self, vrf=None, static_route_oif=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type static_route_oif: static_route_dest, static_route_oif_type, static_route_oif_name
    :param static_route_oif: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_oif** tuple argument:  A.B.C.D/L ;; Destination IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type static_route_oif_type: unicode
    :param static_route_oif_type: **static_route_oif** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ethernet', 'null', 've']

    :type static_route_oif_name: unicode
    :param static_route_oif_name: **static_route_oif** tuple argument.

        * length restriction: ::

            ['1..16']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.vrf.address_family.ip.unicast.ip.route.static_route_oif', 'pybind.slxos.v16r_1_00b.brocade_vrf', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'static_route_oif', 'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf, static_route_oif=static_route_oif)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf, static_route_oif=static_route_oif)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vrf_address_family_ipv4_unicast_ip_route_static_route_oif_distance_delete(self, vrf=None, static_route_oif=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type static_route_oif: static_route_dest, static_route_oif_type, static_route_oif_name
    :param static_route_oif: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_oif** tuple argument:  A.B.C.D/L ;; Destination IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type static_route_oif_type: unicode
    :param static_route_oif_type: **static_route_oif** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ethernet', 'null', 've']

    :type static_route_oif_name: unicode
    :param static_route_oif_name: **static_route_oif** tuple argument.

        * length restriction: ::

            ['1..16']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.vrf', 'vrf'), ('pybind.slxos.v16r_1_00b.vrf.address_family.ip.unicast.ip.route.static_route_oif', u'static_route_oif')]
    bindings_list = [('pybind.slxos.v16r_1_00b.vrf.address_family.ip.unicast.ip.route.static_route_oif.route_attributes', 'pybind.slxos.v16r_1_00b.brocade_vrf', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'distance'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf, static_route_oif=static_route_oif)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf, static_route_oif=static_route_oif)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vrf_address_family_ipv4_unicast_ip_route_static_route_oif_metric_delete(self, vrf=None, static_route_oif=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type static_route_oif: static_route_dest, static_route_oif_type, static_route_oif_name
    :param static_route_oif: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_oif** tuple argument:  A.B.C.D/L ;; Destination IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type static_route_oif_type: unicode
    :param static_route_oif_type: **static_route_oif** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ethernet', 'null', 've']

    :type static_route_oif_name: unicode
    :param static_route_oif_name: **static_route_oif** tuple argument.

        * length restriction: ::

            ['1..16']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.vrf', 'vrf'), ('pybind.slxos.v16r_1_00b.vrf.address_family.ip.unicast.ip.route.static_route_oif', u'static_route_oif')]
    bindings_list = [('pybind.slxos.v16r_1_00b.vrf.address_family.ip.unicast.ip.route.static_route_oif.route_attributes', 'pybind.slxos.v16r_1_00b.brocade_vrf', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf, static_route_oif=static_route_oif)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf, static_route_oif=static_route_oif)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vrf_address_family_ipv4_unicast_ip_route_static_route_oif_tag_delete(self, vrf=None, static_route_oif=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type static_route_oif: static_route_dest, static_route_oif_type, static_route_oif_name
    :param static_route_oif: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_oif** tuple argument:  A.B.C.D/L ;; Destination IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type static_route_oif_type: unicode
    :param static_route_oif_type: **static_route_oif** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ethernet', 'null', 've']

    :type static_route_oif_name: unicode
    :param static_route_oif_name: **static_route_oif** tuple argument.

        * length restriction: ::

            ['1..16']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.vrf', 'vrf'), ('pybind.slxos.v16r_1_00b.vrf.address_family.ip.unicast.ip.route.static_route_oif', u'static_route_oif')]
    bindings_list = [('pybind.slxos.v16r_1_00b.vrf.address_family.ip.unicast.ip.route.static_route_oif.route_attributes', 'pybind.slxos.v16r_1_00b.brocade_vrf', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf, static_route_oif=static_route_oif)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf, static_route_oif=static_route_oif)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vrf_address_family_ipv4_unicast_ip_route_static_route_oif_vrf_delete(self, vrf=None, static_route_oif_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type static_route_oif_vrf: static_route_next_vrf_dest, next_hop_vrf, static_route_oif_type, static_route_oif_name
    :param static_route_oif_vrf: Keyword argument tuple.

    :type static_route_next_vrf_dest: unicode
    :param static_route_next_vrf_dest: **static_route_oif_vrf** tuple argument:  A.B.C.D/L ;; Destination IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type next_hop_vrf: unicode
    :param next_hop_vrf: **static_route_oif_vrf** tuple argument:  Next Hop Vrf Name

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type static_route_oif_type: unicode
    :param static_route_oif_type: **static_route_oif_vrf** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ethernet', 'null', 've']

    :type static_route_oif_name: unicode
    :param static_route_oif_name: **static_route_oif_vrf** tuple argument.

        * length restriction: ::

            ['1..16']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.vrf.address_family.ip.unicast.ip.route.static_route_oif_vrf', 'pybind.slxos.v16r_1_00b.brocade_vrf', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'static_route_oif_vrf', 'keyval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf, static_route_oif_vrf=static_route_oif_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf, static_route_oif_vrf=static_route_oif_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vrf_address_family_ipv4_unicast_max_route_delete(self, vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.vrf.address_family.ip.unicast', 'pybind.slxos.v16r_1_00b.brocade_vrf', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'max-route'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vrf_address_family_ipv6_unicast_delete(self, vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.vrf.address_family.ipv6.unicast', 'pybind.slxos.v16r_1_00b.brocade_vrf', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vrf_address_family_ipv6_unicast_ipv6_delete(self, vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.vrf.address_family.ipv6.unicast.ipv6', 'pybind.slxos.v16r_1_00b.brocade_vrf', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vrf_address_family_ipv6_unicast_ipv6_import_delete(self, vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.vrf.address_family.ipv6.unicast.ipv6.import_', 'pybind.slxos.v16r_1_00b.brocade_vrf', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vrf_address_family_ipv6_unicast_ipv6_import_routes_delete(self, vrf=None, routes=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type routes: src_vrf, route_map
    :param routes: Keyword argument tuple.

    :type src_vrf: unicode
    :param src_vrf: **routes** tuple argument:  ASCII string;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type route_map: unicode
    :param route_map: **routes** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.vrf.address_family.ipv6.unicast.ipv6.import_.routes', 'pybind.slxos.v16r_1_00b.brocade_vrf', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'routes', 'keyval': 'src_vrf, route_map', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf, routes=routes)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf, routes=routes)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vrf_address_family_ipv6_unicast_ipv6_route_ipv6_static_route_oif_vrf_delete(self, vrf=None, ipv6_static_route_oif_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type ipv6_static_route_oif_vrf: static_route_next_vrf_dest, next_hop_vrf, static_route_oif_type, static_route_oif_name
    :param ipv6_static_route_oif_vrf: Keyword argument tuple.

    :type static_route_next_vrf_dest: unicode
    :param static_route_next_vrf_dest: **ipv6_static_route_oif_vrf** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type next_hop_vrf: unicode
    :param next_hop_vrf: **ipv6_static_route_oif_vrf** tuple argument:  Next Hop Vrf Name

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type static_route_oif_type: unicode
    :param static_route_oif_type: **ipv6_static_route_oif_vrf** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ethernet', 'null', 've']

    :type static_route_oif_name: unicode
    :param static_route_oif_name: **ipv6_static_route_oif_vrf** tuple argument.

        * length restriction: ::

            ['1..16']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.vrf.address_family.ipv6.unicast.ipv6.route.ipv6_static_route_oif_vrf', 'pybind.slxos.v16r_1_00b.brocade_vrf', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_static_route_oif_vrf', 'keyval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf, ipv6_static_route_oif_vrf=ipv6_static_route_oif_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf, ipv6_static_route_oif_vrf=ipv6_static_route_oif_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vrf_address_family_ipv6_unicast_ipv6_route_link_local_static_route_nh_delete(self, vrf=None, link_local_static_route_nh=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type link_local_static_route_nh: link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name
    :param link_local_static_route_nh: Keyword argument tuple.

    :type link_local_static_route_dest: unicode
    :param link_local_static_route_dest: **link_local_static_route_nh** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type link_local_nexthop: unicode
    :param link_local_nexthop: **link_local_static_route_nh** tuple argument:  A:B::C:D ;; Next hop IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type link_local_route_oif_type: unicode
    :param link_local_route_oif_type: **link_local_static_route_nh** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ethernet', 'management', 'null', 've']

    :type link_local_route_oif_name: unicode
    :param link_local_route_oif_name: **link_local_static_route_nh** tuple argument.

        * length restriction: ::

            ['1..16']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.vrf.address_family.ipv6.unicast.ipv6.route.link_local_static_route_nh', 'pybind.slxos.v16r_1_00b.brocade_vrf', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'link_local_static_route_nh', 'keyval': 'link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf, link_local_static_route_nh=link_local_static_route_nh)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf, link_local_static_route_nh=link_local_static_route_nh)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vrf_address_family_ipv6_unicast_ipv6_route_link_local_static_route_nh_distance_delete(self, vrf=None, link_local_static_route_nh=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type link_local_static_route_nh: link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name
    :param link_local_static_route_nh: Keyword argument tuple.

    :type link_local_static_route_dest: unicode
    :param link_local_static_route_dest: **link_local_static_route_nh** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type link_local_nexthop: unicode
    :param link_local_nexthop: **link_local_static_route_nh** tuple argument:  A:B::C:D ;; Next hop IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type link_local_route_oif_type: unicode
    :param link_local_route_oif_type: **link_local_static_route_nh** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ethernet', 'management', 'null', 've']

    :type link_local_route_oif_name: unicode
    :param link_local_route_oif_name: **link_local_static_route_nh** tuple argument.

        * length restriction: ::

            ['1..16']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.vrf', 'vrf'), ('pybind.slxos.v16r_1_00b.vrf.address_family.ipv6.unicast.ipv6.route.link_local_static_route_nh', u'link_local_static_route_nh')]
    bindings_list = [('pybind.slxos.v16r_1_00b.vrf.address_family.ipv6.unicast.ipv6.route.link_local_static_route_nh.route_attributes', 'pybind.slxos.v16r_1_00b.brocade_vrf', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'distance'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf, link_local_static_route_nh=link_local_static_route_nh)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf, link_local_static_route_nh=link_local_static_route_nh)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vrf_address_family_ipv6_unicast_ipv6_route_link_local_static_route_nh_metric_delete(self, vrf=None, link_local_static_route_nh=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type link_local_static_route_nh: link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name
    :param link_local_static_route_nh: Keyword argument tuple.

    :type link_local_static_route_dest: unicode
    :param link_local_static_route_dest: **link_local_static_route_nh** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type link_local_nexthop: unicode
    :param link_local_nexthop: **link_local_static_route_nh** tuple argument:  A:B::C:D ;; Next hop IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type link_local_route_oif_type: unicode
    :param link_local_route_oif_type: **link_local_static_route_nh** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ethernet', 'management', 'null', 've']

    :type link_local_route_oif_name: unicode
    :param link_local_route_oif_name: **link_local_static_route_nh** tuple argument.

        * length restriction: ::

            ['1..16']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.vrf', 'vrf'), ('pybind.slxos.v16r_1_00b.vrf.address_family.ipv6.unicast.ipv6.route.link_local_static_route_nh', u'link_local_static_route_nh')]
    bindings_list = [('pybind.slxos.v16r_1_00b.vrf.address_family.ipv6.unicast.ipv6.route.link_local_static_route_nh.route_attributes', 'pybind.slxos.v16r_1_00b.brocade_vrf', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf, link_local_static_route_nh=link_local_static_route_nh)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf, link_local_static_route_nh=link_local_static_route_nh)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vrf_address_family_ipv6_unicast_ipv6_route_link_local_static_route_nh_tag_delete(self, vrf=None, link_local_static_route_nh=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type link_local_static_route_nh: link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name
    :param link_local_static_route_nh: Keyword argument tuple.

    :type link_local_static_route_dest: unicode
    :param link_local_static_route_dest: **link_local_static_route_nh** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type link_local_nexthop: unicode
    :param link_local_nexthop: **link_local_static_route_nh** tuple argument:  A:B::C:D ;; Next hop IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type link_local_route_oif_type: unicode
    :param link_local_route_oif_type: **link_local_static_route_nh** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ethernet', 'management', 'null', 've']

    :type link_local_route_oif_name: unicode
    :param link_local_route_oif_name: **link_local_static_route_nh** tuple argument.

        * length restriction: ::

            ['1..16']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.vrf', 'vrf'), ('pybind.slxos.v16r_1_00b.vrf.address_family.ipv6.unicast.ipv6.route.link_local_static_route_nh', u'link_local_static_route_nh')]
    bindings_list = [('pybind.slxos.v16r_1_00b.vrf.address_family.ipv6.unicast.ipv6.route.link_local_static_route_nh.route_attributes', 'pybind.slxos.v16r_1_00b.brocade_vrf', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf, link_local_static_route_nh=link_local_static_route_nh)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf, link_local_static_route_nh=link_local_static_route_nh)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vrf_address_family_ipv6_unicast_ipv6_route_link_local_static_route_nh_vrf_delete(self, vrf=None, link_local_static_route_nh_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type link_local_static_route_nh_vrf: static_route_next_vrf_dest, next_hop_vrf, link_local_next_hop, link_local_route_oif_type, link_local_route_oif_name
    :param link_local_static_route_nh_vrf: Keyword argument tuple.

    :type static_route_next_vrf_dest: unicode
    :param static_route_next_vrf_dest: **link_local_static_route_nh_vrf** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type next_hop_vrf: unicode
    :param next_hop_vrf: **link_local_static_route_nh_vrf** tuple argument:  Next Hop Vrf Name

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type link_local_next_hop: unicode
    :param link_local_next_hop: **link_local_static_route_nh_vrf** tuple argument:  A:B::C:D ;; Next hop IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type link_local_route_oif_type: unicode
    :param link_local_route_oif_type: **link_local_static_route_nh_vrf** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ethernet', 'management', 'null', 've']

    :type link_local_route_oif_name: unicode
    :param link_local_route_oif_name: **link_local_static_route_nh_vrf** tuple argument.

        * length restriction: ::

            ['1..16']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.vrf.address_family.ipv6.unicast.ipv6.route.link_local_static_route_nh_vrf', 'pybind.slxos.v16r_1_00b.brocade_vrf', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'link_local_static_route_nh_vrf', 'keyval': 'static_route_next_vrf_dest, next_hop_vrf, link_local_next_hop, link_local_route_oif_type, link_local_route_oif_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf, link_local_static_route_nh_vrf=link_local_static_route_nh_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf, link_local_static_route_nh_vrf=link_local_static_route_nh_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vrf_address_family_ipv6_unicast_ipv6_route_static_delete(self, vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.vrf.address_family.ipv6.unicast.ipv6.route.static', 'pybind.slxos.v16r_1_00b.brocade_vrf', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vrf_address_family_ipv6_unicast_ipv6_route_static_bfd_delete(self, vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd', 'pybind.slxos.v16r_1_00b.brocade_vrf', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vrf_address_family_ipv6_unicast_ipv6_route_static_bfd_bfd_ipv6_link_local_static_route_delete(self, vrf=None, bfd_ipv6_link_local_static_route=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type bfd_ipv6_link_local_static_route: bfd_ipv6_link_local_dest, bfd_ipv6_link_local_src, bfd_interface_type, bfd_interface_name
    :param bfd_ipv6_link_local_static_route: Keyword argument tuple.

    :type bfd_ipv6_link_local_dest: unicode
    :param bfd_ipv6_link_local_dest: **bfd_ipv6_link_local_static_route** tuple argument:  A:B::C:D ;; Destination IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type bfd_ipv6_link_local_src: unicode
    :param bfd_ipv6_link_local_src: **bfd_ipv6_link_local_static_route** tuple argument:  A:B::C:D ;; Source IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type bfd_interface_type: unicode
    :param bfd_interface_type: **bfd_ipv6_link_local_static_route** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ethernet', 'null', 've']

    :type bfd_interface_name: unicode
    :param bfd_interface_name: **bfd_ipv6_link_local_static_route** tuple argument.

        * length restriction: ::

            ['1..16']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd.bfd_ipv6_link_local_static_route', 'pybind.slxos.v16r_1_00b.brocade_vrf', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'bfd_ipv6_link_local_static_route', 'keyval': 'bfd_ipv6_link_local_dest, bfd_ipv6_link_local_src, bfd_interface_type, bfd_interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf, bfd_ipv6_link_local_static_route=bfd_ipv6_link_local_static_route)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf, bfd_ipv6_link_local_static_route=bfd_ipv6_link_local_static_route)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vrf_address_family_ipv6_unicast_ipv6_route_static_bfd_bfd_ipv6_static_route_delete(self, vrf=None, bfd_ipv6_static_route=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type bfd_ipv6_static_route: bfd_ipv6_static_route_dest, bfd_ipv6_static_route_src
    :param bfd_ipv6_static_route: Keyword argument tuple.

    :type bfd_ipv6_static_route_dest: unicode
    :param bfd_ipv6_static_route_dest: **bfd_ipv6_static_route** tuple argument:  A:B::C:D ;; Destination IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type bfd_ipv6_static_route_src: unicode
    :param bfd_ipv6_static_route_src: **bfd_ipv6_static_route** tuple argument:  A:B::C:D ;; Source IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd.bfd_ipv6_static_route', 'pybind.slxos.v16r_1_00b.brocade_vrf', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'bfd_ipv6_static_route', 'keyval': 'bfd_ipv6_static_route_dest, bfd_ipv6_static_route_src', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf, bfd_ipv6_static_route=bfd_ipv6_static_route)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf, bfd_ipv6_static_route=bfd_ipv6_static_route)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vrf_address_family_ipv6_unicast_ipv6_route_static_bfd_holdover_interval_delete(self, vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd', 'pybind.slxos.v16r_1_00b.brocade_vrf', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'holdover-interval'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vrf_address_family_ipv6_unicast_ipv6_route_static_route_nh_delete(self, vrf=None, static_route_nh=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type static_route_nh: static_route_dest, static_route_next_hop
    :param static_route_nh: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_nh** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type static_route_next_hop: unicode
    :param static_route_next_hop: **static_route_nh** tuple argument:  A:B::C:D ;; Next hop IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.vrf.address_family.ipv6.unicast.ipv6.route.static_route_nh', 'pybind.slxos.v16r_1_00b.brocade_vrf', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'static_route_nh', 'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf, static_route_nh=static_route_nh)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf, static_route_nh=static_route_nh)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vrf_address_family_ipv6_unicast_ipv6_route_static_route_nh_distance_delete(self, vrf=None, static_route_nh=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type static_route_nh: static_route_dest, static_route_next_hop
    :param static_route_nh: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_nh** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type static_route_next_hop: unicode
    :param static_route_next_hop: **static_route_nh** tuple argument:  A:B::C:D ;; Next hop IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.vrf', 'vrf'), ('pybind.slxos.v16r_1_00b.vrf.address_family.ipv6.unicast.ipv6.route.static_route_nh', u'static_route_nh')]
    bindings_list = [('pybind.slxos.v16r_1_00b.vrf.address_family.ipv6.unicast.ipv6.route.static_route_nh.route_attributes', 'pybind.slxos.v16r_1_00b.brocade_vrf', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'distance'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf, static_route_nh=static_route_nh)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf, static_route_nh=static_route_nh)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vrf_address_family_ipv6_unicast_ipv6_route_static_route_nh_metric_delete(self, vrf=None, static_route_nh=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type static_route_nh: static_route_dest, static_route_next_hop
    :param static_route_nh: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_nh** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type static_route_next_hop: unicode
    :param static_route_next_hop: **static_route_nh** tuple argument:  A:B::C:D ;; Next hop IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.vrf', 'vrf'), ('pybind.slxos.v16r_1_00b.vrf.address_family.ipv6.unicast.ipv6.route.static_route_nh', u'static_route_nh')]
    bindings_list = [('pybind.slxos.v16r_1_00b.vrf.address_family.ipv6.unicast.ipv6.route.static_route_nh.route_attributes', 'pybind.slxos.v16r_1_00b.brocade_vrf', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf, static_route_nh=static_route_nh)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf, static_route_nh=static_route_nh)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vrf_address_family_ipv6_unicast_ipv6_route_static_route_nh_tag_delete(self, vrf=None, static_route_nh=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type static_route_nh: static_route_dest, static_route_next_hop
    :param static_route_nh: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_nh** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type static_route_next_hop: unicode
    :param static_route_next_hop: **static_route_nh** tuple argument:  A:B::C:D ;; Next hop IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.vrf', 'vrf'), ('pybind.slxos.v16r_1_00b.vrf.address_family.ipv6.unicast.ipv6.route.static_route_nh', u'static_route_nh')]
    bindings_list = [('pybind.slxos.v16r_1_00b.vrf.address_family.ipv6.unicast.ipv6.route.static_route_nh.route_attributes', 'pybind.slxos.v16r_1_00b.brocade_vrf', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf, static_route_nh=static_route_nh)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf, static_route_nh=static_route_nh)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vrf_address_family_ipv6_unicast_ipv6_route_static_route_nh_vrf_delete(self, vrf=None, static_route_nh_vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type static_route_nh_vrf: static_route_next_vrf_dest, next_hop_vrf, static_route_next_hop
    :param static_route_nh_vrf: Keyword argument tuple.

    :type static_route_next_vrf_dest: unicode
    :param static_route_next_vrf_dest: **static_route_nh_vrf** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type next_hop_vrf: unicode
    :param next_hop_vrf: **static_route_nh_vrf** tuple argument:  Next Hop Vrf Name

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type static_route_next_hop: unicode
    :param static_route_next_hop: **static_route_nh_vrf** tuple argument:  A:B::C:D ;; Next hop IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.vrf.address_family.ipv6.unicast.ipv6.route.static_route_nh_vrf', 'pybind.slxos.v16r_1_00b.brocade_vrf', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'static_route_nh_vrf', 'keyval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_next_hop', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf, static_route_nh_vrf=static_route_nh_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf, static_route_nh_vrf=static_route_nh_vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vrf_address_family_ipv6_unicast_ipv6_route_static_route_oif_delete(self, vrf=None, static_route_oif=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type static_route_oif: static_route_dest, static_route_oif_type, static_route_oif_name
    :param static_route_oif: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_oif** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type static_route_oif_type: unicode
    :param static_route_oif_type: **static_route_oif** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ethernet', 'null', 've']

    :type static_route_oif_name: unicode
    :param static_route_oif_name: **static_route_oif** tuple argument.

        * length restriction: ::

            ['1..16']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.vrf.address_family.ipv6.unicast.ipv6.route.static_route_oif', 'pybind.slxos.v16r_1_00b.brocade_vrf', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'static_route_oif', 'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf, static_route_oif=static_route_oif)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf, static_route_oif=static_route_oif)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vrf_address_family_ipv6_unicast_ipv6_route_static_route_oif_distance_delete(self, vrf=None, static_route_oif=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type static_route_oif: static_route_dest, static_route_oif_type, static_route_oif_name
    :param static_route_oif: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_oif** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type static_route_oif_type: unicode
    :param static_route_oif_type: **static_route_oif** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ethernet', 'null', 've']

    :type static_route_oif_name: unicode
    :param static_route_oif_name: **static_route_oif** tuple argument.

        * length restriction: ::

            ['1..16']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.vrf', 'vrf'), ('pybind.slxos.v16r_1_00b.vrf.address_family.ipv6.unicast.ipv6.route.static_route_oif', u'static_route_oif')]
    bindings_list = [('pybind.slxos.v16r_1_00b.vrf.address_family.ipv6.unicast.ipv6.route.static_route_oif.route_attributes', 'pybind.slxos.v16r_1_00b.brocade_vrf', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'distance'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf, static_route_oif=static_route_oif)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf, static_route_oif=static_route_oif)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vrf_address_family_ipv6_unicast_ipv6_route_static_route_oif_metric_delete(self, vrf=None, static_route_oif=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type static_route_oif: static_route_dest, static_route_oif_type, static_route_oif_name
    :param static_route_oif: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_oif** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type static_route_oif_type: unicode
    :param static_route_oif_type: **static_route_oif** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ethernet', 'null', 've']

    :type static_route_oif_name: unicode
    :param static_route_oif_name: **static_route_oif** tuple argument.

        * length restriction: ::

            ['1..16']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.vrf', 'vrf'), ('pybind.slxos.v16r_1_00b.vrf.address_family.ipv6.unicast.ipv6.route.static_route_oif', u'static_route_oif')]
    bindings_list = [('pybind.slxos.v16r_1_00b.vrf.address_family.ipv6.unicast.ipv6.route.static_route_oif.route_attributes', 'pybind.slxos.v16r_1_00b.brocade_vrf', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'metric'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf, static_route_oif=static_route_oif)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf, static_route_oif=static_route_oif)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vrf_address_family_ipv6_unicast_ipv6_route_static_route_oif_tag_delete(self, vrf=None, static_route_oif=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type static_route_oif: static_route_dest, static_route_oif_type, static_route_oif_name
    :param static_route_oif: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_oif** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type static_route_oif_type: unicode
    :param static_route_oif_type: **static_route_oif** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ethernet', 'null', 've']

    :type static_route_oif_name: unicode
    :param static_route_oif_name: **static_route_oif** tuple argument.

        * length restriction: ::

            ['1..16']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.vrf', 'vrf'), ('pybind.slxos.v16r_1_00b.vrf.address_family.ipv6.unicast.ipv6.route.static_route_oif', u'static_route_oif')]
    bindings_list = [('pybind.slxos.v16r_1_00b.vrf.address_family.ipv6.unicast.ipv6.route.static_route_oif.route_attributes', 'pybind.slxos.v16r_1_00b.brocade_vrf', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'tag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf, static_route_oif=static_route_oif)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf, static_route_oif=static_route_oif)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vrf_address_family_ipv6_unicast_max_route_delete(self, vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.vrf.address_family.ipv6.unicast', 'pybind.slxos.v16r_1_00b.brocade_vrf', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'max-route'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vrf_ip_delete(self, vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.vrf.ip', 'pybind.slxos.v16r_1_00b.brocade_vrf', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vrf_ip_router_id_delete(self, vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.vrf.ip', 'pybind.slxos.v16r_1_00b.brocade_vrf', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'router-id'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vrf_rd_delete(self, vrf=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.vrf', 'pybind.slxos.v16r_1_00b.brocade_vrf', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'vrf', 'keyval': 'vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'rd'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vrf_route_target_delete(self, vrf=None, route_target=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type route_target: action, target_community
    :param route_target: Keyword argument tuple.

    :type action: unicode
    :param action: **route_target** tuple argument.

        * enumeration restriction: ::

            ['import', 'export', 'both']

    :type target_community: unicode
    :param target_community: **route_target** tuple argument:  ASN:nn;; Target VPN Extended Community

        * pattern restriction: ::

            '((\s*(((([1-9][0-9]{0,8})|(4[0-1][0-9]{8})|(42[0'
            '-8][0-9]{7})|(429[0-3][0-9]{6})|(4294[0-8][0-9]{'
            '5})|(42949[0-5][0-9]{4})|(429496[0-6][0-9]{3})|('
            '4294967[0-1][0-9]{2})|(42949672[0-8][0-9])|(4294'
            '96729[0-5])):(([1-9][0-9]{0,3})|([1-5][0-9]{4})|'
            '(6[0-4][0-9]{3})|(65[0-4][0-9]{2})|(655[0-2][0-9'
            '])|(6553[0-5])))|(((([1-9]|[1-9][0-9]|1[0-9]{2}|'
            '2[0-4][0-9]|25[0-5])\.)(([0-9]|[1-9][0-9]|1[0-9]'
            '{2}|2[0-4][0-9]|25[0-5])\.){2}([0-9]|[1-9][0-9]|'
            '1[0-9]{2}|2[0-4][0-9]|25[0-5])):(([1-9][0-9]{0,3'
            '})|([1-5][0-9]{4})|(6[0-4][0-9]{3})|(65[0-4][0-9'
            ']{2})|(655[0-2][0-9])|(6553[0-5])))))*)'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.slxos.v16r_1_00b.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v16r_1_00b.vrf.route_target', 'pybind.slxos.v16r_1_00b.brocade_vrf', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'route_target', 'keyval': 'action, target_community', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf, route_target=route_target)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf, route_target=route_target)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vrrp_acceptmode_disable_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.vrrp_rbridge_global', 'pybind.slxos.v16r_1_00b.brocade_vrrpv3', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vrrp-acceptmode-disable'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vxlan_stats_acl_state_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.vxlan_stats_acl_state', 'pybind.slxos.v16r_1_00b.brocade_ssm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vxlan_stats_acl_state_extended_stats_data_delete(self, extended_stats_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type extended_stats_data: acl_name, seq_num
    :param extended_stats_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_stats_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_stats_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.vxlan_stats_acl_state.extended_stats_data', 'pybind.slxos.v16r_1_00b.brocade_ssm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended_stats_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended_stats_data=extended_stats_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended_stats_data=extended_stats_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vxlan_stats_acl_state_extended_stats_data_byte_count_delete(self, extended_stats_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type extended_stats_data: acl_name, seq_num
    :param extended_stats_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_stats_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_stats_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.vxlan_stats_acl_state.extended_stats_data', 'pybind.slxos.v16r_1_00b.brocade_ssm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended_stats_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'byte-count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended_stats_data=extended_stats_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended_stats_data=extended_stats_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vxlan_stats_acl_state_extended_stats_data_count_delete(self, extended_stats_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type extended_stats_data: acl_name, seq_num
    :param extended_stats_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_stats_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_stats_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.vxlan_stats_acl_state.extended_stats_data', 'pybind.slxos.v16r_1_00b.brocade_ssm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended_stats_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'count'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended_stats_data=extended_stats_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended_stats_data=extended_stats_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vxlan_stats_acl_state_extended_stats_data_dst_ip_delete(self, extended_stats_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type extended_stats_data: acl_name, seq_num
    :param extended_stats_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_stats_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_stats_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.vxlan_stats_acl_state.extended_stats_data', 'pybind.slxos.v16r_1_00b.brocade_ssm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended_stats_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dst-ip'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended_stats_data=extended_stats_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended_stats_data=extended_stats_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vxlan_stats_acl_state_extended_stats_data_dst_ip_mask_delete(self, extended_stats_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type extended_stats_data: acl_name, seq_num
    :param extended_stats_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_stats_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_stats_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.vxlan_stats_acl_state.extended_stats_data', 'pybind.slxos.v16r_1_00b.brocade_ssm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended_stats_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dst-ip-mask'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended_stats_data=extended_stats_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended_stats_data=extended_stats_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vxlan_stats_acl_state_extended_stats_data_dst_port_delete(self, extended_stats_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type extended_stats_data: acl_name, seq_num
    :param extended_stats_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_stats_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_stats_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.vxlan_stats_acl_state.extended_stats_data', 'pybind.slxos.v16r_1_00b.brocade_ssm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended_stats_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dst-port'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended_stats_data=extended_stats_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended_stats_data=extended_stats_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vxlan_stats_acl_state_extended_stats_data_dst_vtep_ip_delete(self, extended_stats_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type extended_stats_data: acl_name, seq_num
    :param extended_stats_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_stats_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_stats_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.vxlan_stats_acl_state.extended_stats_data', 'pybind.slxos.v16r_1_00b.brocade_ssm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended_stats_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'dst-vtep-ip'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended_stats_data=extended_stats_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended_stats_data=extended_stats_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vxlan_stats_acl_state_extended_stats_data_mirror_interface_delete(self, extended_stats_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type extended_stats_data: acl_name, seq_num
    :param extended_stats_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_stats_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_stats_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.vxlan_stats_acl_state.extended_stats_data', 'pybind.slxos.v16r_1_00b.brocade_ssm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended_stats_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'mirror-interface'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended_stats_data=extended_stats_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended_stats_data=extended_stats_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vxlan_stats_acl_state_extended_stats_data_native_tag_delete(self, extended_stats_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type extended_stats_data: acl_name, seq_num
    :param extended_stats_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_stats_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_stats_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.vxlan_stats_acl_state.extended_stats_data', 'pybind.slxos.v16r_1_00b.brocade_ssm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended_stats_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'native-tag'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended_stats_data=extended_stats_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended_stats_data=extended_stats_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vxlan_stats_acl_state_extended_stats_data_permit_deny_delete(self, extended_stats_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type extended_stats_data: acl_name, seq_num
    :param extended_stats_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_stats_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_stats_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.vxlan_stats_acl_state.extended_stats_data', 'pybind.slxos.v16r_1_00b.brocade_ssm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended_stats_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'permit-deny'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended_stats_data=extended_stats_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended_stats_data=extended_stats_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vxlan_stats_acl_state_extended_stats_data_redir_interface_delete(self, extended_stats_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type extended_stats_data: acl_name, seq_num
    :param extended_stats_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_stats_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_stats_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.vxlan_stats_acl_state.extended_stats_data', 'pybind.slxos.v16r_1_00b.brocade_ssm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended_stats_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'redir-interface'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended_stats_data=extended_stats_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended_stats_data=extended_stats_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vxlan_stats_acl_state_extended_stats_data_sflow_delete(self, extended_stats_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type extended_stats_data: acl_name, seq_num
    :param extended_stats_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_stats_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_stats_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.vxlan_stats_acl_state.extended_stats_data', 'pybind.slxos.v16r_1_00b.brocade_ssm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended_stats_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'sflow'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended_stats_data=extended_stats_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended_stats_data=extended_stats_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vxlan_stats_acl_state_extended_stats_data_src_ip_delete(self, extended_stats_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type extended_stats_data: acl_name, seq_num
    :param extended_stats_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_stats_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_stats_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.vxlan_stats_acl_state.extended_stats_data', 'pybind.slxos.v16r_1_00b.brocade_ssm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended_stats_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'src-ip'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended_stats_data=extended_stats_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended_stats_data=extended_stats_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vxlan_stats_acl_state_extended_stats_data_src_ip_mask_delete(self, extended_stats_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type extended_stats_data: acl_name, seq_num
    :param extended_stats_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_stats_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_stats_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.vxlan_stats_acl_state.extended_stats_data', 'pybind.slxos.v16r_1_00b.brocade_ssm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended_stats_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'src-ip-mask'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended_stats_data=extended_stats_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended_stats_data=extended_stats_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vxlan_stats_acl_state_extended_stats_data_src_port_delete(self, extended_stats_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type extended_stats_data: acl_name, seq_num
    :param extended_stats_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_stats_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_stats_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.vxlan_stats_acl_state.extended_stats_data', 'pybind.slxos.v16r_1_00b.brocade_ssm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended_stats_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'src-port'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended_stats_data=extended_stats_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended_stats_data=extended_stats_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vxlan_stats_acl_state_extended_stats_data_src_vtep_ip_delete(self, extended_stats_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type extended_stats_data: acl_name, seq_num
    :param extended_stats_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_stats_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_stats_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.vxlan_stats_acl_state.extended_stats_data', 'pybind.slxos.v16r_1_00b.brocade_ssm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended_stats_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'src-vtep-ip'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended_stats_data=extended_stats_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended_stats_data=extended_stats_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vxlan_stats_acl_state_extended_stats_data_vni_delete(self, extended_stats_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type extended_stats_data: acl_name, seq_num
    :param extended_stats_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_stats_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_stats_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.vxlan_stats_acl_state.extended_stats_data', 'pybind.slxos.v16r_1_00b.brocade_ssm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended_stats_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vni'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended_stats_data=extended_stats_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended_stats_data=extended_stats_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def vxlan_stats_acl_state_extended_stats_data_vni_mask_delete(self, extended_stats_data=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type extended_stats_data: acl_name, seq_num
    :param extended_stats_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_stats_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_stats_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.slxos.v16r_1_00b.vxlan_stats_acl_state.extended_stats_data', 'pybind.slxos.v16r_1_00b.brocade_ssm_operational', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended_stats_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'vni-mask'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended_stats_data=extended_stats_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended_stats_data=extended_stats_data)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def zoning_defined_configuration_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.zoning.defined_configuration', 'pybind.nos.v6_0_2c.brocade_zone', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.zoning.defined_configuration', 'pybind.nos.v7_0_1b.brocade_zone', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.zoning.defined_configuration', 'pybind.nos.v7_1_0.brocade_zone', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.zoning.defined_configuration', 'pybind.slxos.v16r_1_00b.brocade_zone', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def zoning_defined_configuration_alias_delete(self, alias=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type alias: alias_name
    :param alias: Keyword argument tuple.

    :type alias_name: unicode
    :param alias_name: **alias** tuple argument:  <WORD>;;Alias-Name

        * length restriction: ::

            ['1..64']

        * pattern restriction: ::

            '[0-9a-zA-Z_]{1,64}'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.zoning.defined_configuration.alias', 'pybind.nos.v6_0_2c.brocade_zone', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.zoning.defined_configuration.alias', 'pybind.nos.v7_0_1b.brocade_zone', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.zoning.defined_configuration.alias', 'pybind.nos.v7_1_0.brocade_zone', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.zoning.defined_configuration.alias', 'pybind.slxos.v16r_1_00b.brocade_zone', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'alias', 'keyval': 'alias_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, alias=alias)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, alias=alias)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def zoning_defined_configuration_alias_member_entry_delete(self, alias=None, member_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type alias: alias_name
    :param alias: Keyword argument tuple.

    :type alias_name: unicode
    :param alias_name: **alias** tuple argument:  <WORD>;;Alias-Name

        * length restriction: ::

            ['1..64']

        * pattern restriction: ::

            '[0-9a-zA-Z_]{1,64}'

    **Instance Keyword Argument Tuple**:

    :type member_entry: alias_entry_name
    :param member_entry: Keyword argument tuple.

    :type alias_entry_name: unicode
    :param alias_entry_name: **member_entry** tuple argument:  <WWN>;;Member-Name - add one or more WWNmembers to an alias, the [no] option removesonly one member at a time.

        * pattern restriction: ::

            '([0-9a-fA-F]{2}(:[0-9a-fA-F]{2}){7})(;[0-9a-fA-F'
            ']{2}(:[0-9a-fA-F]{2}){7})*'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v6_0_2c.zoning.defined_configuration.alias', u'alias'), ('pybind.nos.v7_0_1b.zoning.defined_configuration.alias', u'alias'), ('pybind.nos.v7_1_0.zoning.defined_configuration.alias', u'alias'), ('pybind.slxos.v16r_1_00b.zoning.defined_configuration.alias', u'alias')]
    bindings_list = [('pybind.nos.v6_0_2c.zoning.defined_configuration.alias.member_entry', 'pybind.nos.v6_0_2c.brocade_zone', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.zoning.defined_configuration.alias.member_entry', 'pybind.nos.v7_0_1b.brocade_zone', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.zoning.defined_configuration.alias.member_entry', 'pybind.nos.v7_1_0.brocade_zone', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.zoning.defined_configuration.alias.member_entry', 'pybind.slxos.v16r_1_00b.brocade_zone', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'alias_name', 'extra_keyval': ''}, {'keyval': 'alias_name', 'extra_keyval': ''}, {'keyval': 'alias_name', 'extra_keyval': ''}, {'keyval': 'alias_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'member_entry', 'keyval': 'alias_entry_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, alias=alias, member_entry=member_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, alias=alias, member_entry=member_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def zoning_defined_configuration_cfg_delete(self, cfg=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type cfg: cfg_name
    :param cfg: Keyword argument tuple.

    :type cfg_name: unicode
    :param cfg_name: **cfg** tuple argument:  <WORD>;;CFG-Name

        * length restriction: ::

            ['1..64']

        * pattern restriction: ::

            '[0-9a-zA-Z_]{1,64}'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.zoning.defined_configuration.cfg', 'pybind.nos.v6_0_2c.brocade_zone', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.zoning.defined_configuration.cfg', 'pybind.nos.v7_0_1b.brocade_zone', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.zoning.defined_configuration.cfg', 'pybind.nos.v7_1_0.brocade_zone', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.zoning.defined_configuration.cfg', 'pybind.slxos.v16r_1_00b.brocade_zone', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'cfg', 'keyval': 'cfg_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cfg=cfg)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cfg=cfg)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def zoning_defined_configuration_cfg_member_zone_delete(self, cfg=None, member_zone=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cfg: cfg_name
    :param cfg: Keyword argument tuple.

    :type cfg_name: unicode
    :param cfg_name: **cfg** tuple argument:  <WORD>;;CFG-Name

        * length restriction: ::

            ['1..64']

        * pattern restriction: ::

            '[0-9a-zA-Z_]{1,64}'

    **Instance Keyword Argument Tuple**:

    :type member_zone: zone_name
    :param member_zone: Keyword argument tuple.

    :type zone_name: unicode
    :param zone_name: **member_zone** tuple argument:  <WORD>;;Zone-Name - add one or more zonemembers to a cfg, the [no] option removesonly one member at a time.

        * pattern restriction: ::

            '([0-9a-zA-Z_]{1,64})(;([0-9a-zA-Z_]{1,64}))*'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_1_0.zoning.defined_configuration.cfg', u'cfg'), ('pybind.nos.v7_0_1b.zoning.defined_configuration.cfg', u'cfg'), ('pybind.nos.v6_0_2c.zoning.defined_configuration.cfg', u'cfg'), ('pybind.slxos.v16r_1_00b.zoning.defined_configuration.cfg', u'cfg')]
    bindings_list = [('pybind.nos.v6_0_2c.zoning.defined_configuration.cfg.member_zone', 'pybind.nos.v6_0_2c.brocade_zone', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.zoning.defined_configuration.cfg.member_zone', 'pybind.nos.v7_0_1b.brocade_zone', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.zoning.defined_configuration.cfg.member_zone', 'pybind.nos.v7_1_0.brocade_zone', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.zoning.defined_configuration.cfg.member_zone', 'pybind.slxos.v16r_1_00b.brocade_zone', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cfg_name', 'extra_keyval': ''}, {'keyval': 'cfg_name', 'extra_keyval': ''}, {'keyval': 'cfg_name', 'extra_keyval': ''}, {'keyval': 'cfg_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'member_zone', 'keyval': 'zone_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cfg=cfg, member_zone=member_zone)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cfg=cfg, member_zone=member_zone)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def zoning_defined_configuration_zone_delete(self, zone=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Instance Keyword Argument Tuple**:

    :type zone: zone_name
    :param zone: Keyword argument tuple.

    :type zone_name: unicode
    :param zone_name: **zone** tuple argument:  <WORD>;;Zone-Name

        * length restriction: ::

            ['1..64']

        * pattern restriction: ::

            '[0-9a-zA-Z_]{1,64}'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.zoning.defined_configuration.zone', 'pybind.nos.v6_0_2c.brocade_zone', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.zoning.defined_configuration.zone', 'pybind.nos.v7_0_1b.brocade_zone', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.zoning.defined_configuration.zone', 'pybind.nos.v7_1_0.brocade_zone', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.zoning.defined_configuration.zone', 'pybind.slxos.v16r_1_00b.brocade_zone', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'zone', 'keyval': 'zone_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, zone=zone)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, zone=zone)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def zoning_defined_configuration_zone_member_entry_delete(self, zone=None, member_entry=None, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type zone: zone_name
    :param zone: Keyword argument tuple.

    :type zone_name: unicode
    :param zone_name: **zone** tuple argument:  <WORD>;;Zone-Name

        * length restriction: ::

            ['1..64']

        * pattern restriction: ::

            '[0-9a-zA-Z_]{1,64}'

    **Instance Keyword Argument Tuple**:

    :type member_entry: entry_name
    :param member_entry: Keyword argument tuple.

    :type entry_name: unicode
    :param entry_name: **member_entry** tuple argument:  <WWN> and/or <Alias-Name>;;Member-Name - add one or more WWN and/or Alias-Namemembers to a zone, the [no] option removesonly one member at a time.

        * pattern restriction: ::

            '(([0-9a-zA-Z_]{1,64})|([0-9a-fA-F]{2}(:[0-9a-fA-'
            'F]{2}){7}))(;(([0-9a-zA-Z_]{1,64})|([0-9a-fA-F]{'
            '2}(:[0-9a-fA-F]{2}){7})))*'

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = [('pybind.nos.v7_0_1b.zoning.defined_configuration.zone', u'zone'), ('pybind.slxos.v16r_1_00b.zoning.defined_configuration.zone', u'zone'), ('pybind.nos.v7_1_0.zoning.defined_configuration.zone', u'zone'), ('pybind.nos.v6_0_2c.zoning.defined_configuration.zone', u'zone')]
    bindings_list = [('pybind.nos.v6_0_2c.zoning.defined_configuration.zone.member_entry', 'pybind.nos.v6_0_2c.brocade_zone', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.zoning.defined_configuration.zone.member_entry', 'pybind.nos.v7_0_1b.brocade_zone', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.zoning.defined_configuration.zone.member_entry', 'pybind.nos.v7_1_0.brocade_zone', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.zoning.defined_configuration.zone.member_entry', 'pybind.slxos.v16r_1_00b.brocade_zone', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'zone_name', 'extra_keyval': ''}, {'keyval': 'zone_name', 'extra_keyval': ''}, {'keyval': 'zone_name', 'extra_keyval': ''}, {'keyval': 'zone_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'member_entry', 'keyval': 'entry_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, zone=zone, member_entry=member_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, zone=zone, member_entry=member_entry)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def zoning_enabled_configuration_cfg_action_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.zoning.enabled_configuration', 'pybind.nos.v6_0_2c.brocade_zone', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.zoning.enabled_configuration', 'pybind.nos.v7_0_1b.brocade_zone', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.zoning.enabled_configuration', 'pybind.nos.v7_1_0.brocade_zone', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.zoning.enabled_configuration', 'pybind.slxos.v16r_1_00b.brocade_zone', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cfg-action'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def zoning_enabled_configuration_cfg_name_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.zoning.enabled_configuration', 'pybind.nos.v6_0_2c.brocade_zone', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.zoning.enabled_configuration', 'pybind.nos.v7_0_1b.brocade_zone', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.zoning.enabled_configuration', 'pybind.nos.v7_1_0.brocade_zone', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.zoning.enabled_configuration', 'pybind.slxos.v16r_1_00b.brocade_zone', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'cfg-name'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

def zoning_enabled_configuration_default_zone_access_delete(self, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2c, 7.0.1b, 7.1.0
        * SLXOS: 16r.1.00b    

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'delete'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2c.zoning.enabled_configuration', 'pybind.nos.v6_0_2c.brocade_zone', 'pybind.nos.v6_0_2c'), ('pybind.nos.v7_0_1b.zoning.enabled_configuration', 'pybind.nos.v7_0_1b.brocade_zone', 'pybind.nos.v7_0_1b'), ('pybind.nos.v7_1_0.zoning.enabled_configuration', 'pybind.nos.v7_1_0.brocade_zone', 'pybind.nos.v7_1_0'), ('pybind.slxos.v16r_1_00b.zoning.enabled_configuration', 'pybind.slxos.v16r_1_00b.brocade_zone', 'pybind.slxos.v16r_1_00b')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = 'default-zone-access'
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_worker(operation_type=operation_type, pybind_object=pybind_object, rest_leaf_name=rest_leaf_name, resource_depth=1, timeout=api_timeout)

